! ----------------------------------------------------------------------
      subroutine PreparaContour
      USE General
!
      implicit none
!
      call LeggiSezioni()
      call SetScaleMap()
      if (QualePgm /= JAVPGM) then
          call PlotContour()
          call Sistemino
      else
          call PlotContourJav()
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine LeggiSezioni()
      USE General
      USE Contorno
      USE Molcom
      USE Mappa
      USE MappaCont
      USE Iso_Surfaces
      USE PhaseModule
!
      implicit none
      integer :: sezione, sezioni, ngrid2(2), nLev, iix, iiy, ii, imap
      integer :: ilb, iub, jub, i, k, jlb, ier, ksezione, iniz, ifin
      integer :: nExitCode, Layer3
      real    :: limits(2,2), xvet(1000), yvet(1000), assex, assey,assez
      real    :: stepx, stepy, stepz, ax, ay, zeta
      real,    allocatable :: dmap(:,:)
!
!     imap is the orientation section: 1 XY, 2 YZ, 3 ZX
      assex = xyzlimCont(2,1) - xyzlimCont(1,1)
      assey = xyzlimCont(2,2) - xyzlimCont(1,2)
      assez = xyzlimCont(2,3) - xyzlimCont(1,3)
      nPuntiCont = 0
      nLev = nLevels(1)
      if (Layer == 1) then
          stepx = 1.0 / float(ngridCont(2))
          stepy = 1.0 / float(ngridCont(3))
          stepz = 1.0 / float(ngridCont(1))
          iix = int( 0.5 + assey / stepx )
          iiy = int( 0.5 + assez / stepy )
          ii = int( xyzlimCont(1,2) / stepx )
          ax = float(ii) * stepx
          ii = int( xyzlimCont(1,3) / stepy )
          ay = float(ii) * stepy
          limits(1,1) = xyzlimCont(1,2)
          limits(1,2) = xyzlimCont(2,2)
          limits(2,1) = xyzlimCont(1,3)
          limits(2,2) = xyzlimCont(2,3)
          imap = 2
      elseif (Layer == 2) then
          stepx = 1.0 / float(ngridCont(3))
          stepy = 1.0 / float(ngridCont(1))
          stepz = 1.0 / float(ngridCont(2))
          iix = int(  0.5 + assez / stepx )
          iiy = int(  0.5 + assex / stepy )
          ii = int( xyzlimCont(1,3) / stepx )
          ax = float(ii) * stepx
          ii = int( xyzlimCont(1,1) / stepy )
          ay = float(ii) * stepy
          limits(1,1) = xyzlimCont(1,3)
          limits(1,2) = xyzlimCont(2,3)
          limits(2,1) = xyzlimCont(1,1)
          limits(2,2) = xyzlimCont(2,1)
          imap = 3
      elseif (Layer == 3) then
          stepx = assex / float(ngridCont(1))
          stepy = assey / float(ngridCont(2))
          stepz = 1.0 / float(ngridCont(3))
          iix = int(  0.5 + assex / stepx )
          iiy = int(  0.5 + assey / stepy )
          ii = int( xyzlimCont(1,1) / stepx )
          ax = float(ii) * stepx
          ii = int( xyzlimCont(1,2) / stepy )
          ay = float(ii) * stepy
          limits(1,1) = xyzlimCont(1,1)
          limits(1,2) = xyzlimCont(2,1)
          limits(2,1) = xyzlimCont(1,2)
          limits(2,2) = xyzlimCont(2,2)
          imap = 1
      endif
!
      ngrid2(1) = iix + 1
      ngrid2(2) = iiy + 1
!
      ilb = 1  !            ( 1,dimensione(dmap) )
      iub = ngrid2(1)
      jlb = 1
      jub = ngrid2(2)

      IF (.NOT. ALLOCATED(dmap)) then
          ALLOCATE (dmap(ilb:iub,jlb:jub), stat = ier)
      endif
      do i=1,ngrid2(1)
         xvet(i) = ax
         ax = ax + stepx
      enddo

      do i=1,ngrid2(2)
         yvet(i) = ay
         ay = ay + stepy
      enddo
!
      if (sezione0 <= sezioneN) then
          sezioni = sezioneN - sezione0 + 1
      else
          sezioni = (sezioneN+np(Layer)) - sezione0 + 1
      endif
      ier = 0
      do k=1,sezioni
         sezione = mod(sezione0+k-1,np(Layer))
         ksezione = sezione + 1
         call Load_Section(RhoNew, ngridCont, imap, ksezione,
     *                     limits, ngrid2, dmap)
         iniz = nPuntiCont + 1
         call PrintMess('Computing iso-lines ...')
         call Calculate_Contour2D(dmap,ilb,iub,jlb,jub,xvet,yvet,
     *         SoglieCont,nLev,nPuntiCont,xyz_tria,Max_Points,ier)
         ifin = nPuntiCont
         zeta = stepz * float(sezione)
         xyz_tria(4,iniz:ifin) = xyz_tria(3,iniz:ifin)
         if (Layer == 1) then
             xyz_tria(3,iniz:ifin) = xyz_tria(2,iniz:ifin)
             xyz_tria(2,iniz:ifin) = xyz_tria(1,iniz:ifin)
             xyz_tria(1,iniz:ifin) = zeta
         elseif (Layer == 2) then
             xyz_tria(3,iniz:ifin) = xyz_tria(1,iniz:ifin)
             xyz_tria(1,iniz:ifin) = xyz_tria(2,iniz:ifin)
             xyz_tria(2,iniz:ifin) = zeta
         elseif (Layer == 3) then
             xyz_tria(3,iniz:ifin) = zeta
         endif
         if (ier < 0) then
             Msg = 'Too many points: reduce limits !!!'
             call MsgWinErr('Warning', Msg, WARN_WINDOW, nExitCode)
             exit
         endif
      enddo
!
      IF (ALLOCATED(dmap))
     *    DEALLOCATE (dmap, stat = ier)
!
      call AddCellContour
!
      call TrasformaContour()
!
      if (ifOriented == 0) then
!	ifOriented = 1

      Layer3 = Layer + 3
      ifDrawContour = 0
      call ChePiano (Layer3)
      ifDrawContour = 1
      call RotMap(BTot)             !pg
!
!pieropg      Layer3 = Layer + 3
!pieropg      call ChePiano (Layer3)
!
      call SetScaleMap()

      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AddCellContour
      USE General
      USE Atomi
      USE Contorno
      USE Molcom
!
!                        3       [9]         7
!                       ......................
!                      .|                    .     
!                     . |                   ..     
!                 [8].  |                  . .     
!                   .   |[7]          [12].  .     
!                  .    |                .   .[6]  
!                 .     |    [11]       .    .     
!               6.......................8    .     
!                .      |              .     .     
!                .      |4       [4]   .     .     
!                .      +--------------.------ 2
!                .     /               .     .
!            [3] .    /            [10].    .
!                .   /                 .   .
!                .  / [1]              .  . [5]
!                . /                   . .
!                ./        [2]         ..
!                /......................
!               1                      5
!
!
      implicit none
      integer :: i, j, k, n12, n8, jj1, jj2, jj3
      real    :: CellEdges(2,3)
!
      call BuildBox
!
!  numCell(3,2)
      do i=1,3
         CellEdges (1,i) = numCell(i,2)
         CellEdges (2,i) = CellEdges (1,i) + numCell(i,1)
      enddo
!
      k = nPuntiCont
      xyz_tria(1, k + 1) = 1
      xyz_tria(2, k + 1) = 0
      xyz_tria(3, k + 1) = 0

      xyz_tria(1, k + 2) = 0
      xyz_tria(2, k + 2) = 1
      xyz_tria(3, k + 2) = 0

      xyz_tria(1, k + 3) = 0
      xyz_tria(2, k + 3) = 0
      xyz_tria(3, k + 3) = 1

      xyz_tria(1, k + 4) = 0
      xyz_tria(2, k + 4) = 0
      xyz_tria(3, k + 4) = 0

      xyz_tria(1, k + 5) = 1
      xyz_tria(2, k + 5) = 1
      xyz_tria(3, k + 5) = 0

      xyz_tria(1, k + 6) = 1
      xyz_tria(2, k + 6) = 0
      xyz_tria(3, k + 6) = 1

      xyz_tria(1, k + 7) = 0
      xyz_tria(2, k + 7) = 1
      xyz_tria(3, k + 7) = 1

      xyz_tria(1, k + 8) = 1
      xyz_tria(2, k + 8) = 1
      xyz_tria(3, k + 8) = 1
!
      kSpiCont( 1,1) = k + 1
      kSpiCont( 1,2) = k + 4
      kSpiCont( 2,1) = k + 1
      kSpiCont( 2,2) = k + 5
      kSpiCont( 3,1) = k + 1
      kSpiCont( 3,2) = k + 6
      kSpiCont( 4,1) = k + 2
      kSpiCont( 4,2) = k + 4
      kSpiCont( 5,1) = k + 2
      kSpiCont( 5,2) = k + 5
      kSpiCont( 6,1) = k + 2
      kSpiCont( 6,2) = k + 7
      kSpiCont( 7,1) = k + 3
      kSpiCont( 7,2) = k + 4
      kSpiCont( 8,1) = k + 3
      kSpiCont( 8,2) = k + 6
      kSpiCont( 9,1) = k + 3
      kSpiCont( 9,2) = k + 7
      kSpiCont(10,1) = k + 8
      kSpiCont(10,2) = k + 5
      kSpiCont(11,1) = k + 8
      kSpiCont(11,2) = k + 6
      kSpiCont(12,1) = k + 8
      kSpiCont(12,2) = k + 7
!
      n12 = 12
      n8 = k + 8
      do j=1,3
         jj1 = mod(j, 3) + 1
         jj2 = mod(j+1, 3) + 1
         jj3 = mod(4-j, 3) + 5
         if (xyzlimCont(1,j).lt.0.0) then
             xyz_tria(j,n8+1) = CellEdges(1,j)
             xyz_tria(j,n8+2) = CellEdges(1,j)
             xyz_tria(jj1,n8+1) = 0
             xyz_tria(jj1,n8+2) = 0
             xyz_tria(jj2,n8+1) = 0
             xyz_tria(jj2,n8+2) = 1
             kSpiCont(n12+1,1) = n8 + 1
             kSpiCont(n12+1,2) = k + 4
             kSpiCont(n12+2,1) = n8 + 2
             kSpiCont(n12+2,2) = k + jj2
             n8 = n8 + 2
             n12 = n12 + 2
             xyz_tria(j,n8+1) = CellEdges(1,j)
             xyz_tria(j,n8+2) = CellEdges(1,j)
             xyz_tria(jj1,n8+1) = 1
             xyz_tria(jj1,n8+2) = 1
             xyz_tria(jj2,n8+1) = 0
             xyz_tria(jj2,n8+2) = 1
             kSpiCont(n12+1,1) = n8 + 1
             kSpiCont(n12+1,2) = k + jj1
             kSpiCont(n12+2,1) = n8 + 2
             kSpiCont(n12+2,2) = k + 8 - j
             n8 = n8 + 2
             n12 = n12 + 2
         endif
         if (xyzlimCont(2,j).gt.1.0) then
             xyz_tria(j,n8+1) = CellEdges(2,j)
             xyz_tria(j,n8+2) = CellEdges(2,j)
             xyz_tria(jj1,n8+1) = 0
             xyz_tria(jj1,n8+2) = 0
             xyz_tria(jj2,n8+1) = 0
             xyz_tria(jj2,n8+2) = 1
             kSpiCont(n12+1,1) = n8 + 1
             kSpiCont(n12+1,2) = k + j
             kSpiCont(n12+2,1) = n8 + 2
             kSpiCont(n12+2,2) = k + 2 + jj2 + j
             n8 = n8 + 2
             n12 = n12 + 2
             xyz_tria(j,n8+1) = CellEdges(2,j)
             xyz_tria(j,n8+2) = CellEdges(2,j)
             xyz_tria(jj1,n8+1) = 1
             xyz_tria(jj1,n8+2) = 1
             xyz_tria(jj2,n8+1) = 0
             xyz_tria(jj2,n8+2) = 1
             kSpiCont(n12+1,1) = n8 + 1
             kSpiCont(n12+1,2) = k + jj3
             kSpiCont(n12+2,1) = n8 + 2
             kSpiCont(n12+2,2) = k + 8
             n8 = n8 + 2
             n12 = n12 + 2
         endif
      enddo
      morePoints = n8 - nPuntiCont
      moreLines  = n12 - 12
!
      return
      end
!-----------------------------------------------------------------------
      subroutine TrasformaContour()
      USE Contorno
      USE Molcom
!
      implicit none
      integer :: i, j
      real    :: x1(3), x2(3)
!
      do i=1, nPuntiCont + MorePoints
         do j=1,3
            x1(j) = xyz_tria(j,i)
         enddo
         call MoltMatVec(rm, x1, x2)
         do j=1,3
            xyz_tria(j,i) = x2(j)
         enddo
      end do
!
      return
      end
!-----------------------------------------------------------------------
      subroutine RotMap(B)
      USE Contorno
      USE Molcom
!
      implicit none
      integer :: JAT, i, j
      real    :: q(3), P(3), B(3, 3)
!
      do JAT = 1 , nPuntiCont + morePoints
         q(1) = xyz_tria(1,JAT)
         q(2) = xyz_tria(2,JAT)
         q(3) = xyz_tria(3,JAT)
         do i = 1 , 3
            P(i) = 0
            do j = 1 , 3
               P(i) = P(i) + B(i, j) * q(j)
            enddo
         enddo
         xyz_tria(1,JAT) = P(1)
         xyz_tria(2,JAT) = P(2)
         xyz_tria(3,JAT) = P(3)
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine SetScaleMap()
      USE Contorno
      USE Molcom
!
      implicit none
      integer :: JAT, i, iEnd, morePointsB
      real    :: DeltX, DeltY, Ratio, quanto, D1, D2, Dx, Dy
      real    :: DX1, DY1, DEL
!
      morePointsB = morePoints  !pgMap
      if (ifCell == 0) then     !pgMap
         morePoints = 0         !pgMap
      end if                    !pgMap
      Rmin1 = 99999.
      Rmin2 = 99999.
      RMAX1 = -99999.
      RMAX2 = -99999.
      bard = 0
! ---
! ---    trova il baricentro dei vertici dei triangoli
! ---
      do i = 1 , nPuntiCont + morePoints
         bard(1) = bard(1) + xyz_tria(1,i)
         bard(2) = bard(2) + xyz_tria(2,i)
         bard(3) = bard(3) + xyz_tria(3,i)
      enddo
!
      bard = bard / ( nPuntiCont + morePoints )
! ---
! ---     shift dei vertici dei triangoli: origine sul baricentro
! ---
      do i = 1 , nPuntiCont + morePointsB         !pgMap
          xyz_tria(1,i) = xyz_tria(1,i) - bard(1)
          xyz_tria(2,i) = xyz_tria(2,i) - bard(2)
          xyz_tria(3,i) = xyz_tria(3,i) - bard(3)
      enddo
!
      do JAT = 1 , nPuntiCont + morePoints
         if (xyz_tria(1,JAT) .LT. Rmin1) Rmin1 = xyz_tria(1,JAT)
         if (xyz_tria(1,JAT) .GT. RMAX1) RMAX1 = xyz_tria(1,JAT)
         if (xyz_tria(2,JAT) .LT. Rmin2) Rmin2 = xyz_tria(2,JAT)
         if (xyz_tria(2,JAT) .GT. RMAX2) RMAX2 = xyz_tria(2,JAT)
      enddo
      DeltX = (Rmin1 + RMAX1) / 2
      DeltY = (Rmin2 + RMAX2) / 2
      do JAT = 1 , nPuntiCont + morePointsB        !pgMap
         xyz_tria(1,JAT) = xyz_tria(1,JAT) - DeltX
         xyz_tria(2,JAT) = xyz_tria(2,JAT) - DeltY
      enddo
!
      if (NatMol > 0) then
          call SovrapponiAtomi()
      endif
!
      Rmin1 = 99999.
      Rmin2 = 99999.
      RMAX1 = -99999.
      RMAX2 = -99999.
      iEnd = NatMol
      do JAT = 1 , nPuntiCont + morePoints
         if (xyz_tria(1,JAT) .LT. Rmin1) then
            Rmin1 = xyz_tria(1,JAT)
         end if
         if (xyz_tria(1,JAT) .GT. RMAX1) then
            RMAX1 = xyz_tria(1,JAT)
         end if
         if (xyz_tria(2,JAT) .LT. Rmin2) then
            Rmin2 = xyz_tria(2,JAT)
         end if
         if (xyz_tria(2,JAT) .GT. RMAX2) then
            RMAX2 = xyz_tria(2,JAT)
         end if
      enddo
!
      Lim1 = iVP(1)
      Lim2 = iVP(2)
      Lim3 = iVP(3)
      Lim4 = iVP(4)
      NPX = Lim3 - Lim1
      NPY = Lim4 - Lim2
      Ratio = float(NPX) / float(NPY)
!
      quanto = 20
      D1 = (RMAX1 - Rmin1) / quanto
      Rmin1 = Rmin1 - D1
      RMAX1 = RMAX1 + D1
      D2 = (RMAX2 - Rmin2) / quanto
      Rmin2 = Rmin2 - D2
      RMAX2 = RMAX2 + D2
      Dx = RMAX1 - Rmin1
      Dy = RMAX2 - Rmin2
!
      if (Dx.LE.Dy * Ratio) then
         DX1 = Dy * Ratio
         DEL = (DX1 - Dx) / 2
         Rmin1 = Rmin1 - DEL
         RMAX1 = RMAX1 + DEL
         Dx = DX1
      else
         DY1 = Dx / Ratio
         DEL = (DY1 - Dy) / 2
         Rmin2 = Rmin2 - DEL
         RMAX2 = RMAX2 + DEL
         Dy = DY1
      end if
      Xmin = Rmin1
      Ymin = Rmin2
      YMax = Rmin2 + Dy
      XMax = Rmin1 + Dx
      RMAX1 = XMax
      RMAX2 = YMax
      call Window (Xmin, Ymin, XMax, YMax, Ratio)
      DDX = (XMax - Xmin) / (Lim3 - Lim1)
      DDY = (YMax - Ymin) / (Lim4 - Lim2)
!
      if (ifCell == 0) then              !pgMap
         morePoints = morePointsB        !pgMap
      end if                             !pgMap

      return
      end
!-----------------------------------------------------------------------
      subroutine DrawCellContour()
      USE Atomi
      USE Contorno
      USE Molcom
      USE PhaseModule
!
      implicit none
      integer :: iC1, j, N1, N2, ix1, iy1, ix2, iy2
      real    :: a, b
!
      iC1 = color_CELL
      do j=1,12 + moreLines
         N1  = kSpiCont(j,1)
         N2  = kSpiCont(j,2)
         a = ( xyz_tria(1,N1) + x11disp(1) ) * x11scale(1)
         b = ( xyz_tria(2,N1) + x11disp(2) ) * x11scale(2)
         ix1 = nint(a)
         iy1 = iVP(4) - nint(b)
         a = ( xyz_tria(1,N2) + x11disp(1) ) * x11scale(1)
         b = ( xyz_tria(2,N2) + x11disp(2) ) * x11scale(2)
         ix2 = nint(a)
         iy2 = iVP(4) - nint(b)
         call Linea(ix1, iy1, ix2, iy2, iC1)
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine PolyShape(nPoints, tria, ico)
      USE Molcom
!
      implicit none
      integer :: nPoints, ico, iColor, i, j, ind
      real    :: a, b, tria(3,10), x1(3)
!
      iColor = ico
      RagMed = 0.0
      do j = 1, nPoints
         do i = 1, 3
            x1(i)=tria(i,j)
         enddo
         a = ( x1(1) + x11disp(1) ) * x11scale(1)
         b = ( x1(2) + x11disp(2) ) * x11scale(2)
         ixv(j)=nint(a)
         iyv(j)=iVP(4) - nint(b)
      enddo
!
! Line

      ind = 3
      call graphs(nPoints, ind, ' ', iColor, iColor)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine BuildBox
      USE Contorno
      USE Molcom
!
      implicit none
      integer :: k
!
!             1-5 ---------- 2-6
!              |              |       (1-2-3-4) z(c) + 
!              |       C      |       (5-6-7-8) z(c) - 
!              |              |
!             4-8 ---------- 3-7
!
!
      moreBox = 8
!
      k = nPuntiCont 
      xyz_tria(1,k+1) = centerCont(1) - deltaCont(1) / 2.0
      xyz_tria(1,k+2) = centerCont(1) + deltaCont(1) / 2.0
      xyz_tria(1,k+3) = centerCont(1) + deltaCont(1) / 2.0
      xyz_tria(1,k+4) = centerCont(1) - deltaCont(1) / 2.0
      xyz_tria(1,k+5) = centerCont(1) - deltaCont(1) / 2.0
      xyz_tria(1,k+6) = centerCont(1) + deltaCont(1) / 2.0
      xyz_tria(1,k+7) = centerCont(1) + deltaCont(1) / 2.0
      xyz_tria(1,k+8) = centerCont(1) - deltaCont(1) / 2.0
!
      xyz_tria(2,k+1) = centerCont(2) - deltaCont(2) / 2.0
      xyz_tria(2,k+2) = centerCont(2) - deltaCont(2) / 2.0
      xyz_tria(2,k+3) = centerCont(2) + deltaCont(2) / 2.0
      xyz_tria(2,k+4) = centerCont(2) + deltaCont(2) / 2.0
      xyz_tria(2,k+5) = centerCont(2) - deltaCont(2) / 2.0
      xyz_tria(2,k+6) = centerCont(2) - deltaCont(2) / 2.0
      xyz_tria(2,k+7) = centerCont(2) + deltaCont(2) / 2.0
      xyz_tria(2,k+8) = centerCont(2) + deltaCont(2) / 2.0
!
      xyz_tria(3,k+1) = centerCont(3) + deltaCont(3) / 2.0
      xyz_tria(3,k+2) = centerCont(3) + deltaCont(3) / 2.0
      xyz_tria(3,k+3) = centerCont(3) + deltaCont(3) / 2.0
      xyz_tria(3,k+4) = centerCont(3) + deltaCont(3) / 2.0
      xyz_tria(3,k+5) = centerCont(3) - deltaCont(3) / 2.0
      xyz_tria(3,k+6) = centerCont(3) - deltaCont(3) / 2.0
      xyz_tria(3,k+7) = centerCont(3) - deltaCont(3) / 2.0
      xyz_tria(3,k+8) = centerCont(3) - deltaCont(3) / 2.0
!
      ContBox(1:3,1) = xyz_tria(1:3,k+1)
      ContBox(1:3,2) = xyz_tria(1:3,k+7)
!
!
!             1-5 ---------- 2-6
!              |              |       (1-2-3-4) z(c) + 
!              |       C      |       (5-6-7-8) z(c) - 
!              |              |
!             4-8 ---------- 3-7
      lineBox( 1,1) = k+1
      lineBox( 1,2) = k+2
      lineBox( 2,1) = k+2
      lineBox( 2,2) = k+3
      lineBox( 3,1) = k+3
      lineBox( 3,2) = k+4
      lineBox( 4,1) = k+4
      lineBox( 4,2) = k+1
!
      lineBox( 5,1) = k+5
      lineBox( 5,2) = k+6
      lineBox( 6,1) = k+6
      lineBox( 6,2) = k+7
      lineBox( 7,1) = k+7
      lineBox( 7,2) = k+8
      lineBox( 8,1) = k+8
      lineBox( 8,2) = k+5
!             1-5 ---------- 2-6
!              |              |       (1-2-3-4) z(c) + 
!              |       C      |       (5-6-7-8) z(c) - 
!              |              |
!             4-8 ---------- 3-7
!
      lineBox( 9,1) = k+1
      lineBox( 9,2) = k+5
      lineBox(10,1) = k+2
      lineBox(10,2) = k+6
      lineBox(11,1) = k+3
      lineBox(11,2) = k+7
      lineBox(12,1) = k+4
      lineBox(12,2) = k+8
      nPuntiCont = nPuntiCont + moreBox
!
      return
      end
! -----------------------------------------------------------------
      subroutine SovrapponiAtomi()
      USE General
      USE Molcom
      USE Contorno
!
      implicit none
      integer :: JAT
      real    :: DeltX, DeltY, DeltZ
      DeltX = xyz(1, NatMol + 4) - xyz_tria(1, NpuntiCont + 4)
      DeltY = xyz(2, NatMol + 4) - xyz_tria(2, NpuntiCont + 4)
      DeltZ = xyz(3, NatMol + 4) - xyz_tria(3, NpuntiCont + 4)
!
      do JAT = 1 , NatMol + NatSpi
         xyz(1,JAT) = xyz(1,JAT) - DeltX
         xyz(2,JAT) = xyz(2,JAT) - DeltY
         xyz(3,JAT) = xyz(3,JAT) - DeltZ
      enddo
!
      return
      end
! -----------------------------------------------------------------
      subroutine PlotContour()
      USE General
      USE Molcom
      USE Contorno
      USE PhaseModule
!
      implicit none
      integer :: TipoPlot, nExitCode, i, j, k, kk, ic, ic1, ifSingle
      integer :: ipltSav, nPoints
      real    :: tria(3,10)
!
      if (nPuntiCont.lt.3) then
          Msg = 'Not enough points to contour. Check level values.'
          call MsgWinErr('Warning', Msg, WARN_WINDOW, nExitCode)
      else

          call NewPage()

!!mr
*         call SetScaleMap()     ! commentato gianluca 11 aprile 2020
!!mr
          nPoints = 2
          do i=1, nPuntiCont-moreBox, 2
             do k=0,1
                kk = i + k
                do j=1,3
                   tria(j,k+1) = xyz_tria(j,kk)
                enddo
             enddo
             ic = xyz_tria(4,i)
             ic1 = mod(ic-1, 5) + 1
             if (ifLevel(ic1).eq.1) then
                 ic1 = LevelCol(ic1)
                 call PolyShape(nPoints, tria, ic1)
             endif
          end do
      endif
!
      if (ifModel /= 0) then
          call SelectAtoms()
          do i=1, NatMol + NatSpi
             iOrd(i) = i
          enddo
          call AngToPix
          TipoPlot = mod(ifModel,10)
          ipltSav = iPlotType
          if (TipoPlot == 1) then
              iPlotType = STICKS
          elseif (TipoPlot == 2) then
              iPlotType = SIMPLE
          elseif (TipoPlot == 3) then
              iPlotType = BUBBLES
          elseif (TipoPlot == 4) then
              iPlotType = SHADING
          elseif (TipoPlot == 5) then
              iPlotType = ELLIPSOIDS
          endif
          ifSingle = 0
          call DisegnaAtomi(0,ifSingle)
          iPlotType = ipltSav
          if (ifLabels.ne.0) then
              call DrawLabels()
          endif
      endif
      if (ifGrid == 1) then
          call DrawGrid()
      endif
!
      if (ifCell.eq.1) then
          call DrawCellContour()
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine DrawGrid()
      USE General
      USE Contorno
      USE Molcom
!
      implicit none
      integer :: lati(4), iColoB, j, k, N1, N2, N3, N4, ix, ix1, iy1
      integer :: ix2, iy2
      real    :: x0, y0, x1, y1, x2, y2, x3, y3, dist, emme, xp, yp
      real    :: stepy, a, b, xp1, yp1, x, xn, xn1, yn, yn1
!
      select case(Layer)
         case (1)
            lati(1)=4
            lati(2)=9
            lati(3)=7
            lati(4)=6
         case (2)
            lati(1)=1
            lati(2)=8
            lati(3)=7
            lati(4)=3
         case (3)
            lati(1)=1
            lati(2)=5
            lati(3)=4
            lati(4)=2
      end select
      iColoB = color_WHITE

      do k=0,1
         j=1+2*k
         N1 = kSpiCont(lati(j),1)
         N2 = kSpiCont(lati(j),2)
         N3 = kSpiCont(lati(j+1),1)
         N4 = kSpiCont(lati(j+1),2)
         x0 = xyz_tria(1,N1)
         y0 = xyz_tria(2,N1)
         x1 = xyz_tria(1,N2)
         y1 = xyz_tria(2,N2)
         x2 = xyz_tria(1,N3)
         y2 = xyz_tria(2,N3)
         x3 = xyz_tria(1,N4)
         y3 = xyz_tria(2,N4)

         dist = sqrt( (x1-x0)**2 ) / 10.0
         if (dist > 1.e-6) then
             emme = (y1-y0) / (x1-x0)
             if (x0 < x1) then
                 xp = x0
                 yp = y0
             else
                 xp = x1
                 yp = y1
             endif
             if (x2 < x3) then
                 xp1 = x2
                 yp1 = y2
             else
                 xp1 = x3
                 yp1 = y3
             endif
         else
             stepy = sqrt( (y1-y0)**2 ) / 10.0
             if (y0 < y1) then
                 xp = x0
                 yp = y0
             else
                 xp = x1
                 yp = y1
             endif
             if (y2 < y3) then
                 xp1 = x2
                 yp1 = y2
             else
                 xp1 = x3
                 yp1 = y3
             endif
         endif
         do ix=1,9
            x = ix
            if (dist > 1.e-6) then
                xn = xp + dist * x
                yn = emme * (xn-xp) +yp
            else
                xn = xp
                yn = stepy*x + yp
            endif
            a = ( xn + x11disp(1) ) * x11scale(1)
            b = ( yn + x11disp(2) ) * x11scale(2)
            ix1 = nint(a)
            iy1 = iVP(4) - nint(b)
            if (dist > 1.e-6) then
                xn1 = xp1 + dist * x
                yn1 = emme * (xn1-xp1) + yp1
            else
                xn1 = xp1
                yn1 = stepy*x + yp1 
            endif
            a = ( xn1 + x11disp(1) ) * x11scale(1)
            b = ( yn1 + x11disp(2) ) * x11scale(2)
            ix2 = nint(a)
            iy2 = iVP(4) - nint(b)
            call Linea_dash(ix1, iy1, ix2, iy2, iColoB)
         enddo
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine DrawBox(iColor)
      USE Contorno
      USE Molcom
!
      implicit none
      integer :: iColor, i, i1, i2
      real    :: x1, y1, x2, y2
!
!             1-5 ---------- 2-6
!              |              |       (1-2-3-4) z(c) + 
!              |       C      |       (5-6-7-8) z(c) - 
!              |              |
!             4-8 ---------- 3-7
!
!
      do i=1,12
         i1 = lineBox(i,1) 
         i2 = lineBox(i,2) 
         x1 = xyz_tria(1,i1)
         y1 = xyz_tria(2,i1)
         x2 = xyz_tria(1,i2)
         y2 = xyz_tria(2,i2)
         call Linea0(x1, y1, x2, y2, iColor)
      enddo
!
      return
      end
! -----------------------------------------------------------------
      subroutine SelectAtoms()
      USE General
      USE Atomi
      USE Molcom
      USE Mappa
      USE Contorno
      USE Poliedri
      USE PhaseModule
!
      implicit none
      integer :: i, k, sez0, sezN, js, ieqX, iColor
      real    :: xo(3), xn(3), step, bot0, top, bot, com
      real    :: x1, x2, y1, y2, z1, z2, a
!
!-- show all
!
      do i = 1 , NatMol
         if (RS(i) .gt. -10.) then
             RS(i) = abs(RS(i))
         end if
      enddo
!
      if (ifModel /= 0) then
          if (WhichLimit == 3) then
              do i = nats + 1 , NatMol
                 if (RS(i) .gt. -10.) then
                     RS(i) = -abs(RS(i))
                 endif
              enddo
          endif
      endif
!
!-- Compute limits of the wafer (top-bottom)
!

      step = cell(Layer) / float( np(Layer) )
      step = 1.0 / float( np(Layer) )
      bot0 = xyz_tria(Layer,nPuntiCont + 4)
      bot0 = 0
!
!-- Hide all atoms external to the interval top-bottom
!
      sez0 = sezione0
      sezN = sezioneN
      if (sezione0 == sezioneN) then
          top = step * sez0 + bot0 + step / 2.0
          bot = step * sez0 + bot0 - step / 2.0
      else
          top = step * sezN + bot0 + step / 2.0
          bot = step * sez0 + bot0 - step / 2.0
      endif
      if (bot.lt.top) then
          do i = 1 , NatMol
             if (RS(i) .gt. -10.) then
                 xo(1:3) = xyzs(1:3,iEqui(i))
c                 call xequi(xo,nOpEq(i)/10000,1.0,xn,1)
                 js=nOpEq(i)/1000
                 ieqX=-1
                 call xequiTot(js, xo, xn,ieqX)
c                 if(ieqX.eq.1) cycle
                 if (xn(Layer).gt.1.0) xn(Layer) = xn(Layer) - 1.0
                 if (xn(Layer).lt.0.0) xn(Layer) = xn(Layer) + 1.0
                 if ((xn(Layer) > top).or.
     *               (xn(Layer) < bot)) then
                     RS(i) = -abs(RS(i))
                 endif
             endif
          enddo
      else
          com = bot
          bot = top
          top = com
          do i = 1 , NatMol
             if (RS(i) .gt. -10.) then
                 xo(1:3) = xyzs(1:3,iEqui(i))
c                 call xequi(xo,nOpEq(i)/10000,1.0,xn,1)
                 js=nOpEq(i)/1000
                 ieqX=-1
                 call xequiTot(js, xo, xn,ieqX)
c                 if(ieqX.eq.1) cycle
                 if ((xn(Layer) > top).or.
     *               (xn(Layer) < bot)) then
                     RS(i) = -abs(RS(i))
                 endif
             endif
          enddo
      endif
      if (WhichLimit /= 3) then
!
!-- Hide all atoms outside limits
!
! calcoliamo le coordinate dei vertici della scatola (frazionarie)
! le ortonormalizziamo e applichiamo la rotaztot
! li trattiamo come atomi e - in prima approssimazione li disegnamo
! con una routine a parte e poi passiamo a nascondere gli atomi 
!      
      k = nPuntiCont - moreBox
!             1-5 ---------- 2-6
!              |              |       (1-2-3-4) z(c) + 
!              |       C      |       (5-6-7-8) z(c) - 
!              |              |
!             4-8 ---------- 3-7
          x1 = xyz_tria(1,k+1) 
          x2 = xyz_tria(1,k+7)
          y1 = xyz_tria(2,k+1) 
          y2 = xyz_tria(2,k+7)
          z1 = xyz_tria(3,k+1) 
          z2 = xyz_tria(3,k+7)
!
          x1 = ContBox(1,1)
          y1 = ContBox(2,1)
          z1 = ContBox(3,1)
          x2 = ContBox(1,2)
          y2 = ContBox(2,2)
          z2 = ContBox(3,2)
!
          if (x1 > x2) then
              a  = x1
              x1 = x2
              x2 = a
          endif
          if (y1 > y2) then
              a  = y1
              y1 = y2
              y2 = a
          endif
          if (z1 > z2) then
              a  = z1
              z1 = z2
              z2 = a
          endif
          do i = 1 , NatMol
             if (RS(i) .gt. -10.) then
                 if (xyzTot(1,i) < x1 .or. xyzTot(1,i) > x2 .or.
     *               xyzTot(2,i) < y1 .or. xyzTot(2,i) > y2 .or.
     *               xyzTot(3,i) < z1 .or. xyzTot(3,i) > z2) then
                     RS(i) = -abs(RS(i))
                 end if
             end if
          enddo
      endif
      iColor = color_GREEN
      call DrawBox(iColor)
!
      return
      end
!-----------------------------------------------------------------
      subroutine FineMappa
      USE General
      USE Mappa
      USE MappaCont
      USE Param
      USE MolCom
!
      implicit none
      integer :: ksubr, ier, jpatt, i, nnx, nny, nnz, ngrid(3)
      real    :: sigma3
!
      call AllocaMappaCont(1)
      RhoNew = xmap
!
      nnx=np(1)
      nny=np(2)
      nnz=np(3)
      call maxminSir(nnx,nny,nnz,rhonew)
      massimoMappa = denmax
      massimoMappa = max0(massimoMappa, int(5*sigmaMappa))
      sigmaMappa = stden
      sigma3 = sigmaMappa / 3.0
      do i=1,15
         SoglieCont(i) = sigma3 * i
      enddo
      ngrid     = np
      ngridCont = np
!
      call LeggiSezioni()
      call SetScaleMap()
      call apri_toolbar ('contour')  ! deve essere aggiornata
      call PlotContour()
      call Sistemino
!
      return
      end
!-----------------------------------------------------------------------
      subroutine FindMinMaxCont()
      USE General
      USE Contorno
      USE Molcom
!
      implicit none
      integer :: i
      real    :: DeltX, DeltY
!
      Rmin1 = 99999.
      Rmin2 = 99999.
      RMAX1 = -99999.
      RMAX2 = -99999.
      do i = 1 , nPuntiCont + 8
         if (xyz_tria(1,i) .LT. Rmin1) Rmin1 = xyz_tria(1,i)
         if (xyz_tria(1,i) .GT. RMAX1) RMAX1 = xyz_tria(1,i)
         if (xyz_tria(2,i) .LT. Rmin2) Rmin2 = xyz_tria(2,i)
         if (xyz_tria(2,i) .GT. RMAX2) RMAX2 = xyz_tria(2,i)
      enddo
      DeltX = (Rmin1 + RMAX1) / 2
      DeltY = (Rmin2 + RMAX2) / 2
      do i = 1 , nPuntiCont + morePoints !8
         xyz_tria(1,i) = xyz_tria(1,i) - DeltX
         xyz_tria(2,i) = xyz_tria(2,i) - DeltY
      enddo
      Rmin1 = 99999.
      Rmin2 = 99999.
      RMAX1 = -99999.
      RMAX2 = -99999.
      do i = 1 , nPuntiCont + 8
         if (xyz_tria(1,i) .LT. Rmin1) then
            Rmin1 = xyz_tria(1,i)
         end if
         if (xyz_tria(1,i) .GT. RMAX1) then
            RMAX1 = xyz_tria(1,i)
         end if
         if (xyz_tria(2,i) .LT. Rmin2) then
            Rmin2 = xyz_tria(2,i)
         end if
         if (xyz_tria(2,i) .GT. RMAX2) then
            RMAX2 = xyz_tria(2,i)
         end if
      enddo
!
      return
      end
! -----------------------------------------------------------------
