*---------------------------------------------------------------
      subroutine setfree

      USE General
      USE Riflessi
      USE PhaseModule
      USE Param

      do 10 i=1,nrefl
         free2(i)=-1.0
         jinc1(i)=0.0
         if (wt(i).gt.0.0) jinc1(i)=1.0
 10   continue
      return
      end

*---------------------------------------------------------
      subroutine setfreer(nfp,nftot,ncp)

      USE General
      USE Riflessi
      USE PhaseModule
      USE Param

      if (nftot.gt.1 .and. nfp.eq.nftot) then
         return
      elseif (nftot.eq.1) then
         ipick=mod(ncp,20)+1
      else
         ipick=nfp
      endif

      nexc=0
      ninc=0
      nexcfr=0
      nincfr=0
      do 100 i=1,nrefl
            if (jinc1(i).eq.0) nexc=nexc+1
            if (jinc1(i).eq.1) ninc=ninc+1
            if (nint(rfree1(i)).eq.ipick) then
               if (jinc1(i).eq.0) nexcfr=nexcfr+1
               if (jinc1(i).eq.1) nincfr=nincfr+1
               jinc1(i)=-1
            endif
 100  continue

c     if (kverbo==4) then
      if (knw > 0) then
       write(lo,200)nincfr,ninc,nexcfr,nexc,nincfr+nexcfr,ninc+nexc
      endif
 200  format (
     +  '  Included reflections for Rfree: ',i7,' /  ',i7/
     +  '  Excluded reflections for Rfree: ',i7,' /  ',i7/
     +  '     Total reflections for Rfree: ',i7,' /  ',i7/)


      return
      end

*----------------------------------------------------------------------
      logical function freestat(smax,rfreeOut)

      USE General
      USE Riflessi
      USE PhaseModule
      USE Param

      parameter (maxbin=30)
      dimension rres(maxbin),sfo(0:maxbin),sfc(0:maxbin),
     +          sw(0:maxbin)

      nrbin=50
      call resbin(smax,nrbin,maxbin,rres,kres)

      freefd=0.0
      freefo=0.0
      do 10 i=0,kres
         sw(i)=0.0
         sfo(i)=0.0
         sfc(i)=0.0
 10   continue
      do 100 i=1,nrefl
            if (free2(i).lt.0.0) goto 100
            s=rhov(i)*4.0
            fo=free1(i)
            fc=free2(i)

         call setresstat(s,rres,maxbin,kres,kres1,kres2,w1,w2)
         call addresstat(maxbin,kres1,kres2,w1,w2,sw,1.0)
         call addresstat(maxbin,kres1,kres2,w1,w2,sfo,fo**2)
         call addresstat(maxbin,kres1,kres2,w1,w2,sfc,fc**2)
 100  continue
      do 120 i=0,kres
         sfo(i)=sqrt(sfo(i)/amax1(sw(i),0.01))
         sfc(i)=sqrt(sfc(i)/amax1(sw(i),0.01))
 120  continue
      do 150 i=1,nrefl
            if (free2(i).lt.0.0) goto 150
            s=rhov(i)*4.0
            fo=free1(i)
            fc=free2(i)
         call setresstat(s,rres,maxbin,kres,kres1,kres2,w1,w2)
         forms=resstat(maxbin,sfo,kres1,kres2,w1,w2)
         fcrms=resstat(maxbin,sfc,kres1,kres2,w1,w2)
         fc=fc*forms/amax1(fcrms,0.1)
         freefd=freefd+abs(fo-fc)
         freefo=freefo+fo
 150  continue
      factor=1.0
      if (freefo.gt.0.0) factor=freefd/freefo
c     write(lo,200) factor
 200  format(/,'    Rfree(%) :',f7.4/)

      freestat=(factor.gt.rfree)
c update free r
      rfreeOut = factor

      return
      end
c----------------------------------------------------------
      subroutine resbin(smax,nrangeLoc,maxranges,rres,kres)

      USE General
      USE Riflessi
      USE PhaseModule
      USE Param

      parameter (nhist=1000)
      dimension rres(maxranges),hist(nhist)

      ds=smax/real(nhist-1)
      dsmin=smax/real(maxranges)
      do 10 i=1,nhist
         hist(i)=0
 10   continue

      do 20 i=1,nrefl
            if (free1(i).le.0.0) goto 20
            s1=4.0*rhov(i)
            ires=int(s1/ds)+1
            hist(ires)=hist(ires)+1
 20   continue
      ibin=0
      nbin=0
      sbin=0.0
      do 30 i=1,nhist
         nbin=nbin+hist(i)
         sbin=sbin+ds
         if (nbin.gt.nrangeLoc .and. sbin.gt.dsmin) then
            ibin=ibin+1
            rres(ibin)=1.0/sqrt(i*ds)
            nbin=0
            sbin=0.0
         endif
 30   continue
      kres=ibin
      rres(kres)=1.0/sqrt(smax)

      return
      end

*-----------------------------------------------------------------*
      subroutine setresstat(s,rres,maxranges,kres,kres1,kres2,w1,w2)

      dimension rres(maxranges)

      kres2=iresbin(s,rres,maxranges,kres)
      kres1=kres2-1
      s1=0.0
      if (kres1.gt.0) s1=1.0/rres(kres1)**2
      s2=1.0/rres(kres2)**2
      w1=(s2-s)/(s2-s1)
      w2=(s-s1)/(s2-s1)

      return
      end

*-----------------------------------------------------------------*
      function resstat(maxranges,stat,kres1,kres2,w1,w2)

      dimension stat(0:maxranges)

      resstat=w1*stat(kres1) + w2*stat(kres2)

      return
      end

*-----------------------------------------------------------------*
      integer function iresbin(s,rres,maxranges,kres)
  
      dimension rres(maxranges)

      do 10 i=1,kres-1
         if (s.lt.1.0/rres(i)**2) goto 20
 10   continue
 20   iresbin=i

      return
      end
*-----------------------------------------------------------------*
      subroutine addresstat(maxranges,kres1,kres2,w1,w2,stat,val)

      dimension stat(0:maxranges)

      stat(kres1)=stat(kres1)+w1*val
      stat(kres2)=stat(kres2)+w2*val

      return
      end
*-----------------------------------------------------------------*

C
C
C     This code is distributed under the terms and conditions of the
C     CCP4 licence agreement as `Part 2' (Annex 2) software.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
c
c ----------------------------------------------------------------------
c
      subroutine getfreemask(solmsk,mask,nu,nv,nww)
      USE General
      USE PhaseModule
      USE Param

c Locate good free spheres in protein and solvent
      real solmsk(0:nu-1,0:nv-1,0:nww-1)
      real  mask(0:nu-1,0:nv-1,0:nww-1)
c
      real frprad,frsrad
      parameter (frprad=5.0**2,frsrad=5.0**2)
c
      integer i,m,iu,iv,iw,pu,pv,pw,su,sv,sw,lmod
c
      external lmod
c
c set up the mask on -0.5..0.5
c     kverbo = 4

      do 100 iw=0,nww-1
      do 100 iv=0,nv-1
      do 100 iu=0,nu-1
       ia=int(solmsk(iu,iv,iw))
       ia=int(ia/100)
c       if (solmsk(iu,iv,iw)/100.ge.1) then
	if (ia ==1) then
        mask(iu,iv,iw)=0.5
       else
        mask(iu,iv,iw)=-0.5
       endif
 100  continue
c
c now mark with approx. dist from the solvent boundary
      call zflush
      call DoSingleIteration()
      call markdist(mask,nu,nv,nww)
      call zflush
      call DoSingleIteration()
c
c find most distant points
      pu=0
      pv=0
      pw=0
      su=0
      sv=0
      sw=0
      do 200 iw=0,nww-1
      do 200 iv=0,nv-1
      do 200 iu=0,nu-1
       if (mask(iu,iv,iw).gt.mask(pu,pv,pw)) then
        pu=iu
        pv=iv
        pw=iw
       endif
       if (mask(iu,iv,iw).lt.mask(su,sv,sw)) then
        su=iu
        sv=iv
        sw=iw
       endif
 200  continue
c
      call zflush
      call DoSingleIteration()
      if (frpx.lt.-0.9e6) then
       call frac2orth
     +   (real(pu)/nu,real(pv)/nv,real(pw)/nww,frpx,frpy,frpz)
c      if (kverbo==4) then
       if (knw  > 0 ) then
        write (lo,210)'protein',frpx,frpy,frpz,mask(pu,pv,pw)
       endif
      endif
      if (frsx.lt.-0.9e6) then
       call frac2orth
     +   (real(su)/nu,real(sv)/nv,real(sw)/nww,frsx,frsy,frsz)
c      if (kverbo==4) then
       if (knw  > 0 ) then
        write (lo,210)'solvent',frsx,frsy,frsz,mask(su,sv,sw)
       endif
      endif
 210  format (/
     +  ' REAL/FREE ',a7,' sphere at ',3f8.3,' remoteness ',f8.3)
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine markdist(mask,nu,nv,nww)
      USE General
c markdist - mark up the mask, marking each point with the (approximate)
c  distance to the nearest mask boundary. Max error ~ 15% (cubic)
c  Distances are in approximate grid points.
      real mask(0:nu-1,0:nv-1,0:nww-1)
c
*     common/ortocom/q(4,4),qt(4,4),cstar(6),
*    *     rcm11,rcm12,rcm13,rcm22,rcm23,rcm33,
*    *     rlm11,rlm12,rlm13,rlm22,rlm23,rlm33

      real olddif,newdif,maxht,minht,uphill,dnhill,dist,distm,cut
      real u,v,w,distab(-1:1,-1:1,-1:1)
      integer iu,iv,iw,ju,jv,jw,ku,kv,kw,lmod
c
      external lmod
c
c make table of orthogonal pixel distances to nearby pixels
      distm=1.0e12
      distab(0,0,0)=1.0e12
      do 100 jw=-1,1
      w=real(jw)/nww
      do 100 jv=-1,1
      v=real(jv)/nv
      do 100 ju=-1,1
      u=real(ju)/nu
       if (ju.ne.0.or.jv.ne.0.or.jw.ne.0)
     +  distab(ju,jv,jw)=sqrt(rlm11*u**2+rlm22*v**2+rlm33*w**2+
     +                        rlm12*u*v +rlm13*u*w +rlm23*v*w )
       distm=min(distm,distab(ju,jv,jw))
 100  continue
c
c and mark up - iterative refinement
      cut=0.0
      newdif=0.0
 150   olddif=newdif+0.001
       maxht=0.0
       minht=0.0
c loop to increase stuff inside mask
       do 200 iw=0,nww-1
       do 200 iv=0,nv-1
       do 200 iu=0,nu-1
c only treat points inside mask (to speed things up)
        if (abs(mask(iu,iv,iw)).gt.cut) then
         uphill= 1.0e12
         dnhill=-1.0e12
         do 180 jw=-1,1
         kw=lmod(iw+jw,nww)
         do 180 jv=-1,1
         kv=lmod(iv+jv,nv)
         do 180 ju=-1,1
         ku=lmod(iu+ju,nu)
          dist=distab(ju,jv,jw)
c mark with highest/lowest neighbour+distance
          uphill=min(uphill,mask(ku,kv,kw)+dist)
          dnhill=max(dnhill,mask(ku,kv,kw)-dist)
 180     continue
         if (mask(iu,iv,iw).gt.0.0) then
          mask(iu,iv,iw)=uphill
         else
          mask(iu,iv,iw)=dnhill
         endif
        endif
        maxht=max(maxht,mask(iu,iv,iw))
        minht=min(minht,mask(iu,iv,iw))
 200   continue
c we can increase the cutoff to speed things up
       cut=cut+distm
       newdif=maxht-minht
      if (newdif.gt.olddif) goto 150
      return
      end
c
c ----------------------------------------------------------------------
c
      logical function setfreemask(solmsk,nu,nv,nww)
      USE General
      USE Symmetry
      USE PhaseModule
      USE Param

      real solmsk(0:nu-1,0:nv-1,0:nww-1)

*     common/ortocom/q(4,4),qt(4,4),cstar(6),
*    *     rcm11,rcm12,rcm13,rcm22,rcm23,rcm33,
*    *     rlm11,rlm12,rlm13,rlm22,rlm23,rlm33

c
      real frprad,frsrad
      parameter (frprad=5.0**2,frsrad=5.0**2)
c
      integer m,iu,iv,iw,lmod
      real u1,v1,w1,du,dv,dw,fpu,fpv,fpw,fsu,fsv,fsw,r2
      real s,p,sf,pf,rfracp,uvw(3)
c
      external rfracp,lmod
c
c make spheres

      
      call orth2frac(frpx,frpy,frpz,fpu,fpv,fpw)
      call orth2frac(frsx,frsy,frsz,fsu,fsv,fsw)
      s=0.1
      p=0.1
      sf=0.1
      pf=0.1
      do 300 iw=0,nww-1
      do 300 iv=0,nv-1
      do 300 iu=0,nu-1
       dw=rfracp(real(iw)/nww-fpw)
       dv=rfracp(real(iv)/nv-fpv)
       du=rfracp(real(iu)/nu-fpu)
       r2=rlm11*du**2+rlm22*dv**2+rlm33*dw**2+
     +    rlm12*du*dv+rlm13*du*dw+rlm23*dv*dw
       if (r2.lt.frpr**2) then
        p=p+1.0
        ia=int(solmsk(iu,iv,iw))/100
c        if (int(solmsk(iu,iv,iw)/100).eq.1) then
	if (ia == 1) then
c        solmsk(iu,iv,iw)=10
         solmsk(iu,iv,iw)=10*100
         pf=pf+1.0
        endif
       endif
       dw=rfracp(real(iw)/nww-fsw)
       dv=rfracp(real(iv)/nv-fsv)
       du=rfracp(real(iu)/nu-fsu)
       r2=rlm11*du**2+rlm22*dv**2+rlm33*dw**2+
     +    rlm12*du*dv+rlm13*du*dw+rlm23*dv*dw
       if (r2.lt.frsr**2) then
        s=s+1.0
        ia=int(solmsk(iu,iv,iw))/100
c        if (int(solmsk(iu,iv,iw)/100).eq.0) then
	if (ia == 0) then
c        solmsk(iu,iv,iw)=-10
         solmsk(iu,iv,iw)=-10*100
         sf=sf+1.0
        endif
       endif
 300  continue
c
c symmetry expand
      do 310 iw=0,nww-1
      do 310 iv=0,nv-1
      do 310 iu=0,nu-1
       if (abs(solmsk(iu,iv,iw)).eq.10) then
        do 305 m=2,nsym
           u11=real(iu)/nu
           v11=real(iv)/nv
           w11=real(iw)/nww
           call oper(m,uvw,u11,v11,w11)
           u1=uvw(1)
           v1=uvw(2)
           w1=uvw(3)

         solmsk(lmod(nint(nu*u1),nu),
     +          lmod(nint(nv*v1),nv),
     +          lmod(nint(nww*w1),nww))=solmsk(iu,iv,iw)
 305    continue
       endif
 310  continue
c
      sf=sf/s
      pf=pf/p
c     if (kverbo==4) then
      if (knw > 0) then
       write (6,350)sf,pf
      endif
 350  format(/' REAL/FREE-R MASKS:'/
     +  '  ',f5.2,' of free solvent sphere lies in solvent'/
     +  '  ',f5.2,' of free protein sphere lies in protein'/)
c
c Check for mask changing beyond free spheres
c
      setfreemask=(pf.gt.0.75.and.sf.gt.0.75)
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine resetfreemask(solmsk,nu,nv,nww)
      real solmsk(*)
      integer i

c     nu=np(1)
c     nv=np(2)
c     nww=np(3)

      do 100 i=1,nu*nv*nww
       ia=int(solmsk(i))/100
c       if (int(solmsk(i)/100).eq.-10) then
	if (ia == -10) then
c       solmsk(i)=0
        solmsk(i)=50.
c       else if (int(solmsk(i)/100).eq.10 ) then
	else if (ia == 10) then
c       solmsk(i)=1
        solmsk(i)=100.
       endif
 100  continue
      return
      end
c
c ----------------------------------------------------------------------
c
      logical function freerstat(rhomap,rhomod,solmsk,reseffe,realfree)

      USE General
      USE Mappa
c     USE PhaseModule
      USE Param

      real rhomap(*),rhomod(*),reseffe,realfree
      real solmsk(*)
      integer i
      real r1,r2,r3,r4,r5,r6,c1,c2,c3,c4,r12,r22,r32,r42
      logical setfreemask,dum
      real flagstd,flaghm
      external setfreemask,flagstd,flaghm
c
c     kverbo = 4
c set flags:
      nu=np(1)
      nv=np(2)
      nww=np(3)

      r1 = 0.0
      r2 = 0.0
      r3 = 0.0
      r4 = 0.0
      r5 = 0.0
      r6 = 0.0
      solc=1-v_p

      if (setfreemask(solmsk,nu,nv,nww)) goto 150
c     if (kverbo==4) then
      if (knw > 0) then
       write (6,90)
      endif
 90   format(' WARNING: Solvent mask has changed significantly.',/,
     +  ' Recalculating free spheres. Real-free-resid may jump')

      call zflush
      call DoSingleIteration()
      call resetfreemask(solmsk,nu,nv,nww)
      call zflush
      call DoSingleIteration()
      
      realfree=1.0e6
      frpx=-1.0e6
      frsx=-1.0e6
      call getfreemask(solmsk,rhomod,nu,nv,nww)
      call zflush
      call DoSingleIteration()
      if (setfreemask(solmsk,nu,nv,nww)) goto 150
c failed to get a new freemask
      realr(icycl)=0.0
      realfree=0.0
      realfreeR2=0.0
      realfreeR4=0.0
      freerstat=.False.
       
c     if (kverbo==4) then
      if (knw > 0) then
        write(6,*)' FREESTAT - not enough solv/prot for REALFREE'
      endif
      return
c
c make map
 150  continue
c
c
      r1=flagstd(rhomap,solmsk,0,nu,nv,nww)
     
      call zflush
      call DoSingleIteration()
      if (frsr.gt.0.0) r2=flagstd(rhomap,solmsk,-10,nu,nv,nww)
      if (ihism > 0) then
        r3=flaghm(rhomap,solmsk,1,reseffe,nu,nv,nww)
        r3=r3*volume
      else
        r3=flagstd(rhomap,solmsk,1,nu,nv,nww)
      endif
      if (ihism > 0) then
        if (frpr.gt.0.0) r4=flaghm(rhomap,solmsk,10,reseffe,nu,nv,nww)
        r4=r4*volume
      else
        r4=flagstd(rhomap,solmsk,10,nu,nv,nww)
      endif
      call zflush
      call DoSingleIteration()
      r5=solc*r1+(1.0-solc)*r3
      r6=solc*r2+(1.0-solc)*r4
      call resetfreemask(solmsk,nu,nv,nww)
      call zflush
      call DoSingleIteration()
c     if (kverbo==4) then
      if (knw > 0) then
         write (6,991)r1/volume,r2/volume,
     *                r3/volume,r4/volume,
     *                r5/volume,r6/volume
      endif
 991  format(
     +  /'*************************************************'
     +  /'* Solvent Resid : ',f6.3,' FreeSol Resid : ',f6.3,' *'
     +  /'* Protein Resid : ',f6.3,' FreePrt Resid : ',f6.3,' *'
     +  /'* Combine Resid : ',f6.3,' FreeCmb Resid : ',f6.3,' *'
     +  /'*************************************************'/)
      r2=r2/volume
      r4=r4/volume
      r6=r6/volume
      realr(icycl)=r6
c
c set termination condition
      freerstat=(r6.gt.realfree)
c update real free r
      realfree=r6
      realfreeR2=r2
      realfreeR4=r4

      return
      end
c
c ----------------------------------------------------------------------
c
      real function flagstd(map,mask,flag,nu,nv,nww)
c
      real map(nu,nv,nww)
      real mask(nu,nv,nww)
      integer flag
c
      real s,sr,sr2
      integer iu,iv,iw,i
c
      s=0.0
      sr=0.0
      sr2=0.0
      do 100 iw=1,nww
      do 100 iv=1,nv
      do 100 iu=1,nu
       i=int(mask(iu,iv,iw))/100
c      i=int(mask(iu,iv,iw)/100) 
       if (i.eq.flag) then
        s=s+1.0
        sr=sr+map(iu,iv,iw)
        sr2=sr2+map(iu,iv,iw)**2
       endif
 100  continue
c
      flagstd=sqrt(sr2*s-sr**2)/s
c
      return
      end
c
c ----------------------------------------------------------------------
c
      real function flaghm(map,solmsk,flag,hmres,nu,nv,nww)
c HISTMAP - perform histogram mapping
c
      USE General
      USE PhaseModule
      USE Param
      real map(nu,nv,nww),hmres
      real solmsk(nu,nv,nww)
      integer flag

      real hresl,hrmin,hrmax,hrave,hdata
      common/maphistograms/ hresl(50),hrmin(50),hrmax(50),hrave(50),
     +                   vrstd(50),hdata(200,50),kresl,nhist

      save /maphistograms/
c
      real hobs(200),hcal(200),hmod(200),cobs(200),ccal(200),rtran(200)
      integer i,j,k,nr,nrh,nrm,jres,ih,ihm
      real hmres1,sr,sr2,srh,srm,srh2,srm2,dj,r,dhr,dr,robs,rcal,rh,dh
      real rhomaxF,rhominF,hrhomaxF,hrhominF,hrav,hrst,hmav,hmst
c
      hmres1=hmres
      nr=0
      nrh=0
      nrm=0
      sr=0.0
      srh=0.0
      srm=0.0
      sr2=0.0
      srh2=0.0
      srm2=0.0
      rhomaxF=-1000.0
      rhominF=1000.0
      do 100 i=1,nhist
      hobs(i)=0.0
      hmod(i)=0.0
 100  continue
c pick the best resolution ranges for the Fcalc histograms
      do 150 jres=1,kresl
      if (hresl(jres).lt.hmres1) goto 160
 150  continue
 160  if (jres.eq.1) then
      jres=2
      dj=0.0
      else if (jres.eq.kresl+1) then
      jres=kresl
      dj=1.0
      else
      dj=(hmres1-hresl(jres-1))/(hresl(jres)-hresl(jres-1))
      endif
c make interpolated histogram from two calculated histograms
      do 320 i=1,nhist
      rcal=(i-0.5)*(hrmax(jres)-hrmin(jres))/(nhist-1)+hrmin(jres)
      hcal(i)=(1.0-dj)*hdata(i,jres-1)+dj*hdata(i,jres)
      nrh=nrh+hcal(i)
      srh=srh+hcal(i)*rcal
      srh2=srh2+hcal(i)*rcal**2
 320  continue
c now calc the scale of the Fcalc histogram
      hrav=srh/nrh
      hrst=sqrt(srh2*nrh-srh**2)/nrh
      hrhomaxF=hrmax(jres)
cc *aveprt/hrav
      hrhominF=hrmin(jres)
cc *aveprt/hrav
      dhr=(hrhomaxF-hrhominF)/(nhist-1)
c compile histogram stats for observed data
      do 200 k=1,nww
      do 200 j=1,nv
      do 200 i=1,nu
      ia=int(solmsk(i,j,k))/100
c      if (int(solmsk(i,j,k)/100).ne.flag) goto 200
      if (ia.ne.flag) goto 200
      nr=nr+1
      xx=map(i,j,k)/volume
      sr=sr+xx
      sr2=sr2+xx**2
      rhomaxF=max(rhomaxF,xx)
      rhominF=min(rhominF,xx)
 200  continue
      dr=(rhomaxF-rhominF)/(nhist-1)
      do 300 k=1,nww
      do 300 j=1,nv
      do 300 i=1,nu
      ia=int(solmsk(i,j,k))/100
c      if (int(solmsk(i,j,k)/100).ne.flag) goto 300
      if (ia.ne.flag) goto 300
      xx=map(i,j,k)/volume
      ih=int((xx-rhominF)/dr)+1
      hobs(ih)=hobs(ih)+1.0
 300  continue
c put on a scale of fractions of the unit cell
      do 360 i=1,nhist
      hobs(i)=hobs(i)/nr
      hcal(i)=hcal(i)/nrh
 360  continue
c generate cumulative density distributions
      cobs(1)=0.0
      ccal(1)=0.0
      cobs(nhist)=1.0
      ccal(nhist)=1.0
      do 400 i=2,nhist-1
      cobs(i)=cobs(i-1)+hobs(i-1)
      ccal(i)=ccal(i-1)+hcal(i-1)
 400  continue
c generate the density transformation list
      do 500 i=1,nhist
      robs=(i-1)*dr+rhominF
      do 480 j=2,nhist-1
      if (ccal(j).ge.cobs(i)) goto 490
 480  continue
 490  rcal=(j-2+(cobs(i)-ccal(j-1))/max(ccal(j)-ccal(j-1),1.0e-6))
     +  *dhr+hrhominF
      rtran(i)=rcal
 500  continue
c now do shift calculations
      do 600 k=1,nww
      do 600 j=1,nv
      do 600 i=1,nu
      ia=int(solmsk(i,j,k))/100
c      if (int(solmsk(i,j,k)/100).ne.flag) goto 600
      if (ia.ne.flag) goto 600
      xx=map(i,j,k)/volume
      robs=xx
      rh=(robs-rhominF)/dr+1.0
      ih=int(rh)
      dh=rh-ih
      ih=max(min(ih,nhist-1),1)
      rcal=rtran(ih)+dh*(rtran(ih+1)-rtran(ih))
      nrm=nrm+1
      srm=srm+(rcal-xx)
      srm2=srm2+(rcal-xx)**2
 600  continue
      hmav=srm/nrm
      hmst=sqrt(srm2*nrm-srm**2)/nrm
c
      flaghm=hmst
      return
      end
c
c ----------------------------------------------------------------------
c
      real function rfracp(r)
c fractional part range -0.5..0.5
      real r
c
      rfracp=r-real(nint(r))
      return
      end

