#define JAV_VERSION VERSION 

// la successiva setta per Jav l'uso di Cairo per il rendering delle font
// commentandola Jav utilizza solo Pango
#ifdef USE_CAIRO_RENDERING
#define JAV_USE_CAIRO_RENDERING 1
#endif

typedef struct {
                 int type;
                 int model;
                 int object;
                 float zm;
               } PickResult;

#define MAXLENSTR 10

typedef struct {
                 int   z1, z2;
                 float distmin, distmax;
                 int typeb;
                 int kleg;
               } _BondTable;

typedef struct {
                 float tolmin, tolmax; //legame se dmin+tolmin < d < dmax+tolmax
                 float angle;          //legame se l'angolo < angle
               } _BondSetting;


#define MAX_SYMLEVEL 3

typedef enum {NO_MOVE = -1, ROT, ZOOM, TRASL, SELECT_CENTRE, SELECT_DEST, 
              GEOM = 10, ON_SELECT = 20, MOL_SELECT, MOVE_LEGEND,
              RECT_SELECT, ZOOM_MODE} 
         MOTION_TYPE;
//                   =  -1      --> Normal mode / no motion
//                   =  0       --> Rotation
//                   =  1       --> Translation
//                   =  2       --> mouse drag
//                   =  3       --> Select Centre of plot
//                   =  4       --> Select Residue  (right click)
//                   =  11      --> Select 1 atoms  (sphere centre)
//                   =  12      --> Select 2 atoms  (distance)
//                   =  13      --> Select 3 atoms  (angle)
//                   =  14      --> Select 4 atoms  (torsion angle)
//                   =  20      --> Atom Selection mode on
//                   =  21      --> Molecule Selection mode on
//                   =  22      --> Move Legend
//                   =  23      --> Rectangular selection

#ifndef __CALLBACK_H
enum _filetypes {typeCIF = 1, typePDB, typeSHELX, typeFRA, typeXYZ,
// ex                 13        7 (5)     6 (1)     3 (9)   4 (11)
                 typeZMT, typeMOL, typeMOL2, typeMOP, typePOV,
// ex               14    16 (15)    17         15       12
                 typeMOPCRT};
#endif
namespace GLextmr {
     GtkWidget *gen_strutt(GtkWidget *dlg, int ifScroll, GtkWidget *box=NULL);
     GtkWidget *add_label(const char *string, GtkWidget *parent);
     void init_string(std::stringstream &os, const char *title, int flag=1);
     void on_clip(gpointer item, gpointer data);
     void on_reset(gpointer item, gpointer data);
     void on_Screenshot(gpointer item, gpointer data);
     void do_Screenshot(GtkWidget *window, std::string fn);
     void SetClip(bool active, bool redraw=true);
     void on_ResetScale(gpointer item, gpointer data);
     void on_ResetView(gpointer item, gpointer data);
     void on_ViewPlanea(gpointer item, gpointer data);
     void on_ViewPlaneb(gpointer item, gpointer data);
     void on_ViewPlanec(gpointer item, gpointer data);
     void on_ViewPlaneastar(gpointer item, gpointer data);
     void on_ViewPlanebstar(gpointer item, gpointer data);
     void on_ViewPlanecstar(gpointer item, gpointer data);     
     void on_ViewPlaneLSQ(gpointer item, gpointer data);
     void on_ViewPlaneSelected(gpointer item, gpointer data);
     void on_ZoomIn(gpointer item, gpointer data);
     void on_ZoomOut(gpointer item, gpointer data);
     void on_Xplus(gpointer item, gpointer data);
     void on_Xminus(gpointer item, gpointer data);
     void on_Yplus(gpointer item, gpointer data);
     void on_Yminus(gpointer item, gpointer data);
     void on_Zplus(gpointer item, gpointer data);
     void on_Zminus(gpointer item, gpointer data);
     void on_step(gpointer item, gpointer data);
     void CellOnOff(gpointer item, gpointer data);
     void PolyOnOff(gpointer item, gpointer data);
     void on_PolyhedraProperties(gpointer item, gpointer data);
     void ShowMB(gpointer item, gpointer data);
     void LabelsOnOff(gpointer item, gpointer data);
     void LabelsOff(gpointer item, gpointer data);
     void CalcoliGeometrici(gpointer item, gpointer data);
     void AdvancedSettings(gpointer item, gpointer data);
     void TbOnOff(gpointer item, gpointer data);
     void on_label_type(gpointer item, gpointer current, gpointer data);
     void on_label_name(gpointer item, gpointer data);
     void on_label_species(gpointer item, gpointer data);
     void on_label_number(gpointer item, gpointer data);
     void on_size_medium(gpointer item, gpointer data);
     void on_size_large(gpointer item, gpointer data);
     void on_size_xlarge(gpointer item, gpointer data);
     void LabelsHOnOff(gpointer item, gpointer data);
     void LabelsHeavy(gpointer item, gpointer data);
     void LabelsSelected(gpointer item, gpointer data);
     void add_result(GtkWidget *window, int p[][2], float result_op, int toclick);
     void SelectAtom(GtkWidget *widget, int x, int y, gpointer data);
     void build_popup(int whichType, GtkWidget *window);
     int  selectForPopup(int x, int y, gpointer data);
     int  selectObject(int x, int y, gpointer data, bool sel_flag = true, bool only_atoms = false);
     void selectObjects(int x, int y, gpointer data, double wp, double hp);
     gboolean SelectAtoms(GtkWidget *widget, int x, int y, gpointer data);
     void ColorTable(gpointer item, gpointer data);
     void show_dialog(GtkWidget *window, GtkWidget *father);
     void SelectResidue(int x, int y, gpointer data);
     void on_select_mode(gpointer item, gpointer data);
     void on_rect_select_mode(gpointer item, gpointer data);
     void on_mol_select_mode(gpointer item, gpointer data);
     void on_zoom_mode(gpointer item, gpointer data);
     void on_manipulation_mode(gpointer item, gpointer data);
     void PointerMode(gpointer item, gpointer data);
     void on_select(gpointer item, gpointer data);
     void on_unselect(gpointer item, gpointer data);
     void on_invselect(gpointer item, gpointer data);
     void on_change_spec(gpointer item, gpointer data);
     void on_rename(gpointer item, gpointer data);
     void on_select_by_spec(gpointer item, gpointer data);
     void on_delete_by_spec(gpointer item, gpointer data);
     void on_delete_bonds(gpointer item, gpointer data);
     void on_delete_dup(gpointer item, gpointer data);
     void on_delete_residue(gpointer item, gpointer data);
     void on_delete_sidechain(gpointer item, gpointer data);
     void on_delete_aromatic(gpointer item, gpointer data);
     void on_show_all(gpointer item, gpointer data);
     void on_hide_selected(gpointer item, gpointer data);
     void on_hide_unselected(gpointer item, gpointer data);
     void on_hide_hydrogens(gpointer item, gpointer data);
     void update_items_modify(bool status, bool updateList = true);
     void endModify(int whichModel, bool exitSelect = false);
     void on_ClearExtra(gpointer,  gpointer data);
     int *pickObjects(int x, int y, gpointer data, bool only_atoms=false,
                      double wp = 5, double hp = 5, bool ifMultiple=false);
     void set_motion_type(int t, int flag);
//     GtkWidget *CreateToolbar(GtkWidget *father, int orientation,
//                           mr_action_entry tb_entries[], int n_tb_entries);
     GtkWidget *create_info (GtkWidget *window, GList *listModels);
     void StructureInfo(gpointer item, gpointer data);
     void ListConn(gpointer item, gpointer data);
     void ListAng(gpointer item, gpointer data);
     void ListTors(gpointer item, gpointer data);
     void ListAtoms(gpointer item, gpointer data);
     void ViewIntensitiesHistogram(gpointer item, gpointer data);
     void ListContacts(gpointer item, gpointer data);
     void InfoAtoms(gpointer window, GLWindow *gl, int action);
     void StructureEdit(gpointer item, gpointer data);
     void PropsEdit(gpointer, gpointer data);
     void OnAngsEdit(gpointer, gpointer data);
     void OnTorsEdit(gpointer, gpointer data);
     void UpdateInfoAtoms();
     void on_Sphere(gpointer item, gpointer data);
     void update_center();
     void RipassaModelli();
     void do_move_atoms();
     void updateModify(int active);
     float *get_coeff(int action);
     float *get_coeffF(int action);
     void doPopup(int whichType, int whichObject=0);
     void set_values_for_advanced();
     void block_handlers_for_advanced();
     void unblock_handlers_for_advanced();
     void move_center(float posi[], int whichModel, int whichAtom,
                      bool ifDrawCenter);
     void move_center(vet3 posi, int whichModel, int whichAtom,
                      bool ifDrawCenter);
     void on_togglecell(gpointer item, gpointer data);
     void on_togglelabels(gpointer item, gpointer data);
     void on_togglesymm(gpointer item, gpointer data);
     void on_Open(GtkWidget *window, const char *filter, int tipo, int op);
     void on_delete(gpointer item, gpointer data);
     void on_addbond(gpointer item, gpointer data);
     void on_changespecies(gpointer item, gpointer data);
     void on_rename(gpointer item, gpointer data);
     void on_undo(gpointer item, gpointer data);
     void on_redo(gpointer item, gpointer data);
     void on_assemble(gpointer item, gpointer data);
     void on_buildbonds(gpointer item, gpointer data);
     void on_bondsetting(gpointer item, gpointer data);
     void on_renumber(gpointer item, gpointer data);
     void on_sortbyspec(gpointer item, gpointer data);
     void on_complete(gpointer item, gpointer data);
     void on_regularize(gpointer item, gpointer data);
     void on_enant(gpointer item, gpointer data);
     void on_transform(gpointer item, gpointer data);
     void on_hydro(gpointer item, gpointer data);
     void on_norm_hydro(gpointer item, gpointer data);
     void on_export(gpointer item, gpointer data);
     void on_add_frag_fromfile(gpointer item, gpointer data);
     void on_add_frag_fromsmiles(gpointer item, gpointer data);
     void on_add_frag_fromcod(gpointer item, gpointer data);
     void on_add_tetra(gpointer item, gpointer data);
     void on_add_octa(gpointer item, gpointer data);
     void on_add_cube(gpointer item, gpointer data);
     void on_add_trigp(gpointer item, gpointer data);
     void on_add_antip(gpointer item, gpointer data);
     void on_add_prismt(gpointer item, gpointer data);
     void on_add_icos(gpointer item, gpointer data);     
     void on_add_squarep(gpointer item, gpointer data);
     void on_add_isolated(gpointer item, gpointer data);
     void on_dup_all(gpointer item, gpointer data);
     void on_dup_sel(gpointer item, gpointer data);
     void on_expand_sel(gpointer item, gpointer data);
     void on_import_tetra(gpointer item, gpointer data);
     void on_import_octa(gpointer item, gpointer data);
     void on_import_squarep(gpointer item, gpointer data);
     void on_import_cube(gpointer item, gpointer data);
     void on_import_trigp(gpointer item, gpointer data);
     void on_import_antip(gpointer item, gpointer data);
     void on_import_prismt(gpointer item, gpointer data);
     void on_import_icos(gpointer item, gpointer data);     
     void on_import_isolated(gpointer item, gpointer data);
     void on_import_smiles(gpointer item, gpointer data);
     void on_import_cod(gpointer, gpointer data);     
     void on_overlay(gpointer item, gpointer data);
     void on_overlay_info(gpointer item, gpointer data);
     void on_move_atoms(gpointer item, gpointer data);
     void PackOnOff(gpointer item, gpointer data);
     void GrowOnOff(gpointer item, gpointer data);
     void HydBondsOnOff(gpointer item, gpointer data);
     void ShortContOnOff(gpointer item, gpointer data);
     void DelHangContOnOff(gpointer item, gpointer data);
     void on_EditHbonds(gpointer item, gpointer data);
     void IncPack(gpointer item, gpointer data);
     void DecPack(gpointer item, gpointer data);
     void about_render(gpointer item, gpointer data);
     void aggiornaMenuSym();
     void set_values_for_polyhedra(GtkWidget *father, GLWindow *gl);
     void autov(double a[3][3], double eigen[3], double t[3][3], int *icod);
     void set_values_for_model(int i, GtkWidget *father, GtkWidget *window);
     int GetInfo(int code, int whichModel);
     void SetActive(int which);
     void rewrite_models(GtkWidget *father, GtkWidget *window);
     void update_model(GtkWidget *father, GtkWidget *window);
     void   aggiornaProperties(int which=0);
     void update_menu_deletemodel();
     void DrawText(int width, PangoFontDescription *font_desc,
              PangoAlignment alignment, float color[], vet3 xy,
              const char *testo, PangoRectangle *r2, bool ifbg=false);
     PangoRectangle *get_text_rect(PangoFontDescription *fdesc,
              const char *testo);
     void open_pango();
     void close_pango();
#ifndef JAV_USE_CAIRO_RENDERING
     void gl_pango_ft2_render_layout (PangoLayout *layout);
#else
     void gl_pango_render_layout (PangoLayout *layout, cairo_surface_t *surface,
                             float *color=NULL);
#endif
     GtkWidget *add_model_selector(GtkWidget *dlg);
     void on_Quit(gpointer, gpointer data);
     void on_import(gpointer, gpointer data);
     void on_newcentre(gpointer, gpointer data);
     void on_CenterOnMap(gpointer item, gpointer data);
     float U_or_B(float B, GtkWidget *dlg);
     void freeSurface(int which);
     void SettaSurface(int which, int ifView);
     void  add_surface_line(GtkWidget *table, GtkWidget *father, int i, int row);
     void set_values_for_surface(int i, GtkWidget *father, GtkWidget *window, int abi);
     void GetMapColor(float colore[], int index);
     void RicalcolaSurface(int which, GtkWidget *dlg);
     int  GetActiveModel();
     void SetActiveModel (int which);
     void SetLightSystem(float colore[], float alpha, int blend=0);
     int IsMapVisible(int which);
     gboolean close_offscreen (GtkWidget *w, GdkEvent *, gpointer );
     void render3DArrow(vet3 p1, vet3 p2, double raggio, int subdivisions);
     void disegnaSfera(double r, int divs, bool textureCoords = false);
     void disegnaCilindro(double radius, double halfLength, int slices);
     void disegnaCono(double radius, double Length, int slices);
     void on_clickselect(gpointer item, gpointer data);
     void on_add_atom(gpointer item, gpointer data);
     bool FromCoordToWin(GLdouble objx, GLdouble objy, GLdouble objz,
              const GLdouble modelMatrix[16],
              const GLdouble projMatrix[16],
              const GLint viewport[4],
              GLdouble *winx, GLdouble *winy, GLdouble *winz);
     bool FromWinToCoord1(GLdouble winx, GLdouble winy, GLdouble winz,
                const GLdouble modelMatrix[16],
                const GLdouble projMatrix[16],
                const GLint viewport[4],
                GLdouble *objx, GLdouble *objy, GLdouble *objz);
     bool FromWinToCoord(GLdouble winx, GLdouble winy, GLdouble winz,
                const GLdouble modelMatrix[16],
                const GLdouble projMatrix[16],
                const GLint viewport[4],
                GLdouble *objx, GLdouble *objy, GLdouble *objz);
     void pickMatrix(double x, double y, double deltax, double deltay,
                  GLint viewport[4]);
     vet3 DrawDistLines(int n, vet3 points[]);
     vet3 DrawDistAngles(int n, vet3 p[], double ang);
     vet3 DrawDistDihedral(int n, vet3 p[]);
     GtkWidget *AAFrame(GtkWidget *father);
     void GoToAtom(gpointer item, gpointer data);
     void on_centroids(gpointer item, gpointer data);
     void NormalizzaCentroids(GLWindow *gl);
     void DrawCentroids(GLWindow *gl);
     void on_exportScene(gpointer item, gpointer data);
     void on_importSTL(gpointer, gpointer data);
     bool DrawTrigs();
     void on_optimize(gpointer item, gpointer data);
     void view_mopac_out(gpointer , gpointer data);
     void on_dftd(gpointer , gpointer data);
     void on_pdp(gpointer , gpointer data);
     void on_pdf(gpointer , gpointer data);
     void on_bondvs(gpointer , gpointer data);     
}
// =======================================
void call_jav(gpointer item, gpointer data);
void aggiorna_smooth(int val);
void aggiorna_rendering(int val);
void aggiorna_dimensioni(GtkWidget *mainwin);
void aggiorna_bg(int val);
void set_defbg(int val);
void aggiorna_cfg(std::string &fn);
void PassaMappa(char *name, int *nmaps, int *which, int np[],
                int *nrefl, float *resm, int *ifd,
                float *denmin = NULL, float *denmax = NULL,
                float *avden = NULL, float *stden = NULL,
                float ***map=NULL, int ***color=NULL);

void DisegnaSelezione(int whichModel, int code, int n[]);

extern "C" void csetmodel_(int *which);
extern "C" float getb_(float B[3][3]);
extern "C" void getstructureinfo_(structure_info_type *StructInfo, int *ifCalc,
                 int *wm);
