! ---------------------------------------------------------------------
      subroutine GetBonds(iAction)
      USE General
      USE Atomi
      USE Molcom
!
      lsq = 1
      VMod  = evec(1,lsq)**2 + evec(2,lsq)**2
      V1Mod = sqrt(VMod + evec(3,lsq)**2)
      VMod  = sqrt(VMod) / V1Mod
      if ( VMod .gt.  1.0 ) VMod = 1.0
      if ( VMod .lt. -1.0 ) VMod =-1.0
      Ang   = asin(VMod) * rtod
      Ang   = SIGN(Ang, evec(3,lsq))
      RK(1) = Ang
      RK(2) = 4
      RK(3) = 1
      VV(1, 1) = evec(2,lsq)
      VV(1, 2) = -evec(1,lsq)
      VV(1, 3) = 0
      rMaxLu = 2.05
      iColDef = 4
      Radius = .22
      do 10 i = 1 , NatMol + NatSpi
         iOrd(i) = i
         if (iCol(i) .eq. 0) iCol(i) = iColDef
         if (abs(RS(i)) .lt. 0.00001) RS(i) = Radius
   10 continue
!
      if (iAction .eq.2) return
!
! ----  costruisci la tabella dei legami
!
      NumLeg = iconn(1)
      j = 0
      do i = 1 , NumLeg
         i1 = ( i - 1 ) * 3 + 2
         i2 = i1 + 1
         i3 = i1 + 2
c--mercedes 2mag2006         if (iconn(i3).eq.-1) cycle
         if (iconn(i3).eq.0) iconn(i3)=1
         n1 = iconn(i1)
         n2 = iconn(i2)
         if (n1 <= 0 .or. n2 <= 0) cycle
         if (n1 > NatMol .or. n2 > NatMol) cycle
         if (nz(n1).ne.0.and.nz(n2).gt.0) then
             j = j + 1
             LE(1, j) = iconn(i1)
             LE(2, j) = iconn(i2)
             LE(3, j) = iconn(i3)
         endif
         if (j .eq. nMaxLeg - nlp) exit
      enddo
   50 NumLeg = j
!
      do 60 i = nMaxLeg - nlp + 1, nMaxLeg
         NumLeg = NumLeg + 1
         LE(1, NumLeg) = LE(1, i)
         LE(2, NumLeg) = LE(2, i)
         LE(3, NumLeg) = LE(3, i)
   60 continue
      nnn = nMaxLeg - nlp + 1
!      ik = LE(1, nnn)
!      jk = LE(2, nnn)
!
      do 70 i = 1, NumLeg
         LE1(1, i) = LE(1, i)
         LE1(2, i) = LE(2, i)
         LE1(3, i) = LE(3, i)
   70 continue
      nLegInd = NumLeg
!
      return
      end
! ---------------------------------------------------------------------
      subroutine BuildBonds(iAction)
      USE General
      USE Atomi, only : nzTot
      USE Molcom
!
      common/symcon/natsym,idoppiodi,iopsym(1000),ipolim
     1,asmin(3),asmax(3),incella(10000),idoppiodit
!
      real distBackBone(2)
      integer tipoLegame
!
      distBackBone(1) = 4.0
      distBackBone(2) = 7.5
      if (ifSkeleton == 0) then   ! gianluca 11/03/2009
          tipoLegame = 1
      else
          tipoLegame = 4
      endif
!
! ---
      if (iAction.eq.99) goto 15
! ---
      lsq = 1
      VMod  = evec(1,lsq)**2 + evec(2,lsq)**2
      V1Mod = sqrt(VMod + evec(3,lsq)**2)
      VMod  = sqrt(VMod) / V1Mod
      if ( VMod .gt.  1.0 ) VMod = 1.0
      if ( VMod .lt. -1.0 ) VMod =-1.0
      Ang   = asin(VMod) * rtod
      Ang   = SIGN(Ang, evec(3,lsq))
      RK(1) = Ang
      RK(2) = 4
      RK(3) = 1
      VV(1, 1) = evec(2,lsq)
      VV(1, 2) = -evec(1,lsq)
      VV(1, 3) = 0
   15 rMaxLu = 2.05
      iColDef = 4
      Radius = .22
      do 10 i = 1 , NatMol + NatSpi
         iOrd(i) = i
         if (iCol(i) .eq. 0) iCol(i) = iColDef
         if (abs(RS(i)) .lt. 0.00001) RS(i) = Radius
   10 continue
!
! ----  costruisci la tabella dei legami
!
c      if(idoppiodi.ne.-999)then
      nntt = 0
      do 444 i=1, NatMol-1
         nntt = nntt + i
  444 continue
      NumLeg = 0
      if (iAction.ne.3 .and. iAction.ne.2) then
         call scrper('Building bond table',0,0)
      end if
      nnpp = 0
      do 40 i = 1 , NatMol - 1
         if (nzTot(i).eq.0.or.nzTot(i) == PiccoFour) then
            nnpp = nnpp + NatMol - i - 1
            go to 35
         end if
         iP1 = i + 1
         do 30 j = iP1 , NatMol
            nnpp = nnpp + 1
            if (nzTot(j).eq.0.or.nzTot(j) == PiccoFour) go to 30
            DIS = 0
            do 20 K = 1 , 3
               DR = xyz(K,i) - xyz(K,j)
               DIS = DIS + DR * DR
   20       continue
            DIS = SQRT(DIS)
            iz1 = nzTot(i)
            iz2 = nzTot(j)
            iOk = 0
            if (ifSkeleton == 0) then   ! gianluca 11/03/2009
                if (DIS.ge.(BondTable(1,iz1,iz2)-0.01).and.
     *              DIS.le.(BondTable(2,iz1,iz2)+0.01)) then
                    iOk = 1
                endif
            else
                if (DIS < distBackBone(iz1) .and. dis > 3.0) then
                    iOk = 1
                endif
            endif
            if (iOk == 1) then
*           if (DIS.ge.(BondTable(1,iz1,iz2)-0.01).and.
*    *          DIS.le.(BondTable(2,iz1,iz2)+0.01)) then
                NumLeg = NumLeg + 1
                LE(1, NumLeg) = i
                LE(2, NumLeg) = j
                LE(3, NumLeg) = tipoLegame
            endif
            if (NumLeg .EQ. nMaxLeg - nlp) return
   30    continue
   35    if (iAction.ne.3 .and. iAction.ne.2) then
            call scrper('                   ',nnpp,nntt)
         end if
   40 continue
c      endif
!
      do 60 i = nMaxLeg - nlp + 1, nMaxLeg
         NumLeg = NumLeg + 1
               if (numleg.eq.1772) then
                   iiiiii = 1
               endif
         LE(1, NumLeg) = LE(1, i)
         LE(2, NumLeg) = LE(2, i)
         LE(3, NumLeg) = LE(3, i)
   60 continue
!
      if (iAction .eq. 1) then
         do 70 i = 1, NumLeg
            LE1(1, i) = LE(1, i)
            LE1(2, i) = LE(2, i)
            LE1(3, i) = LE(3, i)
   70    continue
         nLegInd = NumLeg
      end if
!
      if (iAction.ne.3 .and. iAction.ne.2) then
          call ClearMessage
          call scrper(' ',0,-1)
      end if
!
      return
      end
!----------------------------------------------------------------
      subroutine LsPlane(NATV, iAct)
      USE Molcom
!
!--main routine for l.s. plane calculation
!
!---- set normal equations matrix for the best plane
!
      call fillmatr(NATV, iAct)
!
      if (NATV.eq.0) then
          return
      end if
!
!--search for the eigenvalues and eigenvectors
!
      call autov(ainer,eval,evec,icod)
!
      do 50 i=1 , 2
         do 30 j= i+1 , 3
            if (eval(i) .gt. eval(j)) then
               Dum = eval(i)
               eval(i) = eval(j)
               eval(j) = Dum
               do 10 k=1 , 3
                  Dum = evec(k,i)
                  evec(k,i) = evec(k,j)
                  evec(k,j) = Dum
   10          continue
            endif
   30    continue
   50 continue
!
      return
      end
! ---------------------------------------------------------------
      subroutine fillmatr(NATV,iActiv)
      USE General
      USE Atomi
      USE Molcom
      USE TestModel
      USE Dialogo, only : ModelToCompare
!
      dimension xd(3)
!
      do 130 i = 1 , 3
         DrawBard(i) = 0.0
         do 100 j=1,3
            ainer(i,j) = 0.0
  100    continue
  130 continue
! ---
! ---    trova il baricentro deli atomi visibili
! ---
      NATV = 0
      if (iActiv .eq.1) then
         do 150 i = 1 , NatMol
            if (RS(i).gt.0) then
               NATV = NATV + 1
               DrawBard(1) = DrawBard(1) + xyz(1,i)
               DrawBard(2) = DrawBard(2) + xyz(2,i)
               DrawBard(3) = DrawBard(3) + xyz(3,i)
            end if
  150    continue
      else
         do 160 i = 1 , NatMol
            if (RS(i).gt.0) then
               NATV = NATV + 1
               DrawBard(1) = DrawBard(1) + xyzs(1,i)
               DrawBard(2) = DrawBard(2) + xyzs(2,i)
               DrawBard(3) = DrawBard(3) + xyzs(3,i)
            end if
  160    continue
      end if
!
      if (NATV.eq.0) then
          return
      end if
      DrawBard(1) = DrawBard(1) / NATV
      DrawBard(2) = DrawBard(2) / NATV
      DrawBard(3) = DrawBard(3) / NATV
! ---
! ---     shift degli atomi per avere l'origine sul baricentro
! ---
      if (iActiv .eq.1) then
c      write(lo,*)' Molp2002.O..',DrawBard
         do i = 1 , NatMol + NatSpi
c          write(lo,*)' a)',xyz(1,i),xyz(2,i),xyz(3,i)
             xyz(1,i) = xyz(1,i) - DrawBard(1)
             xyz(2,i) = xyz(2,i) - DrawBard(2)
             xyz(3,i) = xyz(3,i) - DrawBard(3)
c          write(lo,*)' b)',xyz(1,i),xyz(2,i),xyz(3,i)
         enddo
*        if (ifViewModel == 1) then
         if (ModelToCompare == 2) then
             do i = 1 , nCoordpub
                 xyzPub(1,i) = xyzPub(1,i) - DrawBard(1)
                 xyzPub(2,i) = xyzPub(2,i) - DrawBard(2)
                 xyzPub(3,i) = xyzPub(3,i) - DrawBard(3)
             enddo
         endif
      else

         write(lo,*)' Molp2002.F..',DrawBard
         do i = 1 , NatMol
             xyzs(1,i) = xyzs(1,i) - DrawBard(1)
             xyzs(2,i) = xyzs(2,i) - DrawBard(2)
             xyzs(3,i) = xyzs(3,i) - DrawBard(3)
         enddo
*        if (ifViewModel == 1) then
         if (ModelToCompare == 2) then
             do i = 1 , nCoordpub
                 xyzPub(1,i) = xyzPub(1,i) - DrawBard(1)
                 xyzPub(2,i) = xyzPub(2,i) - DrawBard(2)
                 xyzPub(3,i) = xyzPub(3,i) - DrawBard(3)
             enddo
         endif
      endif
      do 500 i=1,NatMol
          if (RS(i).gt.0) then
             if (iActiv .eq.1) then
                xd(1) = xyz(1,i)
                xd(2) = xyz(2,i)
                xd(3) = xyz(3,i)
              else
                xd(1) = xyzs(1,i)
                xd(2) = xyzs(2,i)
                xd(3) = xyzs(3,i)
              end if
              do 400 k=1,3
                  do 300 l=1,3
                      ainer(k,l) =ainer(k,l)+xd(k)*xd(l)
  300             continue
  400         continue
          end if
  500 continue
!
      return
      end
! ------------------------------------------------------------------
      subroutine CreaLab(i,j,lnz,Label)
      USE General
      USE Atomi
      USE Molcom
!
!-- i     position in array
!-- j     digits in Label string
!-- lnz   atomic species pointer
!-- Label Label string
!
!
      character*(*) Label
      character*17  Buffer
!
      fy = FntPixHeight
      kser = i
!
      Buffer = ' '
      if (lnz.ne.0) then
          vetSpec(lnz) = vetSpec(lnz) + 1
          kser = vetSpec(lnz)
          if (lnz /= PiccoFour) then
*             if (mod(kprog,10) .lt. 3) then
*                 write(Buffer(1:2),'(a2)') nalf(lnz)
*             else
!!                Buffer(1:2) = Species(lnz)  ! gianluca 19/11/2009
                  Buffer = Species(lnz)
*             end if
          else
              Buffer(1:2) = '  '
          end if
      else
          Buffer(1:2)='Q '
          vetSpec(PiccoFour) = vetSpec(PiccoFour) + 1
          kser = vetSpec(PiccoFour)
      endif
      call ucase(Buffer(1:1))
!!    if (Buffer(2:2).eq.' ') then  ! gianluca 19/11/2009
!!       k=2
!!    else
!!       k=3
!!    endif
      k = Lung(Buffer) + 1
!
      if (j.gt.0) then
         iii = serial(j)
         write(Buffer(k:k+4),'(i5)') iii
      elseif (j.eq.0) then
         iMax = NatMol + 1
         write(Buffer(k:k+4),'(i5)') kser
         serial(i) = kser
      else
         write(Buffer(k:k+4),'(i5)') kser
         serial(i) = kser
      end if
      call NoBlanks(Buffer,lstri)
      Label=Buffer(1:lstri)
!
! - si potrebbe migliorare
!
      fx = LenInPix(Label,2)
      ipixLab(1,i) = ipix(1,i) - fx / 2.0
      ipixLab(2,i) = ipix(2,i) + fy  / 4.0
!
      return
      end
! -----------------------------------------------------------------
      subroutine InvRm
      USE General
      USE Molcom
!
      double precision det
!
      det = 0
      i = 1
      l = i + 1
      l1 = l + 1
      do j=1, 3
         k = 1
         if (k .eq. j) then
            k = k + 1
         end if
         k1 = k + 1
         if (k1 .eq. j) then
            k1 = k1 + 1
         end if
         s = (-1.)**(i+j)
         sdet = s*rm(i,j)*(rm(l,k) * rm(l1,k1)-rm(l,k1)*rm(l1,k))
         det = det + sdet
      enddo
!
      do i=1, 3
         l=1
         if (l .eq. i) then
            l = l + 1
         end if
         l1 = l + 1
         if (l1 .eq. i) then
            l1 = l1 + 1
         end if
         do j=1, 3
            k = 1
            if (k .eq. j) then
               k = k + 1
            end if
            k1 = k + 1
            if (k1 .eq. j) then
               k1 = k1 + 1
            end if
            s = (-1.) ** (i + j)
            rmi(j,i) = (rm(l,k) * rm(l1,k1) - rm(l,k1) * rm(l1,k)) / det
            rmi(j,i) = s * rmi(j,i)
         enddo
      enddo
!
  100 format (3f15.8)
      return
      end
! -----------------------------------------------------------------
      subroutine InvRmi
      USE General
      USE Molcom
!
      double precision det
!
      det = 0
      i = 1
      l = i + 1
      l1 = l + 1
      do j=1, 3
         k = 1
         if (k .eq. j) then
            k = k + 1
         end if
         k1 = k + 1
         if (k1 .eq. j) then
            k1 = k1 + 1
         end if
         s = (-1.)**(i+j)
         sdet = s*rmi(i,j)*(rmi(l,k) * rmi(l1,k1)-rmi(l,k1)*rmi(l1,k))
         det = det + sdet
      enddo
!
      do i=1, 3
       l=1
       if (l .eq. i) then
          l = l + 1
       end if
       l1 = l + 1
       if (l1 .eq. i) then
          l1 = l1 + 1
       end if
       do j=1, 3
         k = 1
         if (k .eq. j) then
            k = k + 1
         end if
         k1 = k + 1
         if (k1 .eq. j) then
            k1 = k1 + 1
         end if
         s = (-1.) ** (i + j)
         rm(j,i) = (rmi(l,k) * rmi(l1,k1) - rmi(l,k1) * rmi(l1,k)) / det
         rm(j,i) = s * rm(j,i)
       enddo
      enddo
!
  100 format (3f15.8)
      return
      end
! -----------------------------------------------------------------
      subroutine MakeLab(iniz,ifin)
      USE General
      USE Atomi
      USE Molcom
!
      vetSpec(:) = 0
      do i = iniz, ifin
          knz = nz(i) / nzConst
          lnz = iabs(knz)
          call CreaLab(i,-1,lnz,Labb)
          aLab(i) = Labb
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine ModLab(ii,lnz,Prefisso)
      USE General
      USE Atomi
      USE Molcom
      USE LsqModule
!
      character *(*) Prefisso
      character *6 fmt
      character *17 Buffer
!
      iDupl = 0
      NewSerial = 0
      i = ii
      if (lnz.gt.0) then      ! ancient "Relabel"
!
!-- counts the number of characters of the atomic specie (la)
!
          Buffer = '      '
          Labb = Lab(i)
          if (ifChanged(i).eq.0) then
              ifChanged(i) = 4
          else if (ifChanged(i).le.10) then
              ifChanged(i) = ifChanged(i) + 40
          else
              ifChanged(i) = 100
          endif
          vetSpec(lnz) = vetSpec(lnz) + 1
          NewSerial = vetSpec(lnz)
          serial(i) = NewSerial
          write(Buffer,'(a2,i7)') nalf(lnz), NewSerial
          call NoBlanks(Buffer,lstri)
          Labb = Buffer(1:16)
          call ucase(Labb(1:1))
          if (lstri.gt.16) Labb(1:1) = 'X'
          Lab(i) = Labb
      else
          lp = Lung(Prefisso)
          do j=1,nptr
             Buffer = '         '
             k = kptr(j)
             Labb = Lab(k)
             jfeq = iEqui(k)
             if (ifChanged(jfeq).eq.0) then
                ifChanged(jfeq) = 5
             else if (ifChanged(jfeq).le.10) then
                 ifChanged(jfeq) = ifChanged(jfeq) + 50
             else
                 ifChanged(jfeq) = 100
             endif
             if (lp.le.0) then
                 write(Buffer,'(a2,i7)') nalf(nzTot(k)),i
                 call NoBlanks(Buffer,lstri)
                 Labb = Buffer(1:16)
                 call ucase(Labb(1:1))
             else
                 if (i.le.9) then
                     lp1 = 7
                     fmt = '(a,i1)'
                 else if (i.le.99) then
                     lp1 = 6
                     fmt = '(a,i2)'
                 else if (i.le.999) then
                     lp1 = 5
                     fmt = '(a,i3)'
                 else if (i.le.9999) then
                     lp1 = 4
                     fmt = '(a,i4)'
                 endif
                 lp = min0(lp, lp1)
                 write(Buffer,fmt) Prefisso(1:lp),i
                 call NoBlanks(Buffer,lstri)
                 Labb = Buffer(1:16)
             endif
             if (lstri.gt.16) Labb(1:1) = 'X'
             iDup = ifLabelDupl(Labb)
!prova             if (iDup == 0) then
                 Lab(k) = Labb
                 serial(k) = i
                 i = i + 1
!prova             else
!prova                 if (iDup /= k) then
!prova                     iDupl = iDup
!prova                 endif
!prova             endif
          enddo
      endif
      iDupl = 0
      do j=1,nptr
         jj = kptr(j)
         Labb = Lab(jj)
         do k = 1 , NatMol
            if (Lab(k) == Labb .and. jj /= k) then
                iDupl = k
                exit
            endif
         enddo
         if (iDupl /= 0) then
             exit
         endif
      enddo
      
!
      if (iDupl /= 0) then
!          ifOK = 0
          Inte = 'W A R N I N G'
          Msg = 'There is at least one couple of atoms '//
     *          'with the same name (i.e. '//Lab(iDupl)//')'
          iExCode = 0
          call MsgWinErr(Inte,Msg,WARN_WINDOW,iExCode)
      endif
!
      return
      end
!-----------------------------------------------------------------------
      integer function ifLabelDupl(Labb)
      USE Molcom
!
      implicit none
      integer :: i
      character*(*) Labb
!
!-- checks for label duplications
!
      ifLabelDupl = 0
      do i = 1 , NatMol
         if (Lab(i) == Labb) then
             ifLabelDupl = i
             exit
         endif
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine toMolPlo3(leggi)
      USE General
      USE Symmetry, only : nsymTrue
      USE Atomi
      USE Molcom
      USE PhaseModule
!
      implicit none
      integer :: leggi, ifLi5, ifLi6, i, j, k, jj, kk, interp, iAction
      integer :: ier, knz, lnz, kCol, ifIso, natsOnly, n1gl, n2gl, n3gl
      real    :: a, P, SumColor, SumLab, w1, w2, w3
      real    :: x1(3), rrv(3), el(3,3), tell(3,3)
!
      nMaxLeg = 9800
      p1 = 2.0 * PI * PI
      ProbF = 0.5
      ifLi5 = 0
!
      do i=1,MaxAtomsInGr
         xyLab(1,i) = 0.0
         xyLab(2,i) = 0.0
         Lab(i) = ' '
         iEqui(i)=0
      enddo
      jSingleColor(:) = 0
      SumColor = 0.0
      if (leggi.ge.1) then
          ifLi5 = InfoOK(5)
          if (ifLi5 > 0) then
              if (leggi == 1)then
                  ifLi6 = InfoOK(6)
                  if (ifLi6 > 0) then
                      call LoadReflInfo
                      if (ifReduced.eq.1) then
                          nreflDim = nrefltot * nsymTrue
                      else
                          nreflDim = nrefltot
                      endif
                      erre = rflsq / 100.0
                      errem = rflsq / 100.0
                  endif
              endif
              call GetModel
*gl*          do i=1,nats
*gl*             a = bSav(i)
*gl*             bSav(i) = bfac(i)
*gl*             bfac(i) = a
*gl*          enddo
          else
              call PutGetXyzs(2, interp)
*gl*          do i = 1 , nats
*gl*             bSav(i) = bfac(i)
*gl*             bfac(i) = bfac(i) - 100000.0
*gl*          enddo
          endif
      endif
!
      call MolecolaInCella(ifLi5, ier)
!
      P = ProbF
      if (ProbF.le. 0.975) then
         FProb = (((((23.326*P)-55.693)*P+51.552)*P-22.75)*P+
     *           6.447)*P+0.296
      else
         FProb = -136.496 + 141.072 * ProbF
      end if
!
      if (ifSkeleton == 1 .and. nSkel > 0) then
          do i=1,nSkel
             j = nats + i
             xyzs(1:3,j) = xyztot(1:3,i) 
             xyzs(4,j) = 100.0
             xyzs(5,j) = 1.0 
             nz(j) = nzConst
             bfac(j) = 3
*gl*         bSav(j) = bfac(j)
*gl*         bfac(j) = bfac(j) - 10000.0
          enddo
          k = iconn(1) * 3 + 1
          iconn(1) = iconn(1) + nSkelLeg
          do i=1, nSkelLeg
             n1gl = LE1(1,i)
             n2gl = LE1(2,i)
             n3gl = LE1(3,i)
             iconn(k+1) = n1gl + nats
             iconn(k+2) = n2gl + nats
             iconn(k+3) = n3gl
             k = k + 3
          enddo
          nats = nats + nSkel
          nSkel = 0
      endif 
!
      natsOnly = nats - nSkel
      ifIso = 0
      do 50 i = 1, nats
          ifChangedB(i) = 0
          NatMol = i
          knz=nz(i)/nzConst
          nzTot(i) = iabs(knz)
          x1(1:3)=xyzs(1:3,i)
!                                  label  xyz legame  palla  colore
!     read(ic,'(a3,1x,5f10.0,i4)') Lab(i), x, MLu(i), RS(i), iCol(i)
          call MoltMatVec(rm, x1, rrv)
          xyz(1:3,i) = rrv(1:3)
          lnz=iabs(knz)
          if(lnz.lt.0.or.lnz.gt.18) lnz=1
          Lab(i)=aLab(i)
          iOrd(i) = i
          if (SumColor > 1.0) then
              if ((lnz == 0) .or. (lnz == PiccoFour)) then
                  lnz = 1
              endif
              kCol = jSingleColor(i)
          else
              if ((lnz == 0) .or. (lnz == PiccoFour)) then
                  lnz = 1
                  kCol = color_GHOST
              else
                  kCol = no(lnz) + N_OBJS
              endif
          endif
          if (i <= natsOnly) then
              iCol(i) = kCol
          else
              if (iCol(i) == 0) then
                  iCol(i) = color_LIGHTBLUE
              endif
          endif
          jSingleColor(i) = iCol(i)
          SinglePlotType(i) = iPlotType
!
          Rs(i) = radii(lnz,1) / 3.0
          rMLu(i) = 2 * radii(lnz,1)
          if(iEqui(i).eq.0) iEqui(i) = i
          if(nOpEq(i).eq.0) nOpEq(i) = 1555
          if (leggi.eq.1) then
*gl*      if (bfac(i).lt.-50000.0) then
          if (bij(1,i) > 0.0) then
*gl*          bSav(i) = bfac(i)
              do jj=1,3
                 do kk=jj, 3
                    el(jj,kk) = Ell(jj,kk,i) / p1
                    if(jj.ne.kk) el(jj,kk) = el(jj,kk)/2.
                 enddo
              enddo
              el(2,1) = el(1,2)
              el(3,1) = el(1,3)
              el(3,2) = el(2,3)
              call NorEll(i, el, w1, w2, w3, tell, ifIso)
              semax(1,i) = w1
              semax(2,i) = w2
              semax(3,i) = w3
              do jj=1,3
                 do kk=1, 3
                    cd(jj,kk,i) = tell(jj,kk)
                    Ell(jj,kk,i) = el(jj,kk) / FProb
                 enddo
              enddo
          else
              call CreaEll(i)
          endif
      end if
   50 continue
!
      if (ifIso.eq.1) then
          do i = 1, nats
             if (ifChangedB(i).ne.0) then
                 ifChangedB(i) = 0
                 iAction = 3
                 Labb = aLab(i)
                 lnz = iabs(nz(i)) / nzConst
                 do k=1,5
                    VetChanges(k) = xyzs(k,i)
                 enddo
                 VetChanges(6) = bfac(i)
                 call ModModel(i,iAction,Labb,lnz,VetChanges)
                 bij(:,i) = 0.0
             endif
          enddo
          iAction = 100
          call ModModel(i,iAction,Labb,lnz,VetChanges)
      endif
!
      SumLab = sum( xyLab(1:2,1:nats) )
      if (SumLab > 1.0) then
          ifMovedLab = 1
          NatSpi = 0
          call DefineLabelPos(1)
      else
          ifMovedLab = 0
      endif
      call AggiuSpig

!
      NATind = NatMol
!
!!prova      call AggiornaJav
!
      return
      end
!-----------------------------------------------------------------------
      subroutine MolecolaInCella(ifLi5, ier)
      USE General
      USE Atomi
      USE Molcom
!
      implicit none
      integer :: ifLi5, ier, modificato, i, ii, ise, lnz, iAction
      real    :: amin, amax
      common /minma/ amin(3), amax(3)
!
      modificato = 0
      if (ifSkeletonOn == 0) then
          bard(1:3) = 0.
          do i=1, nats
             ifChanged(i) = 0
             ifChangedB(i) = 0
             do ii=1, 3
                bard(ii) = bard(ii) + xyzs(ii, i)
             enddo
          enddo
          do ii=1, 3
             bard(ii) = bard(ii) / nats
             amin(ii) = 99.
             amax(ii) = -99.
   36        if (abs(bard(ii)) .gt. 1.5) then
                 ise = sign(1.0, bard(ii) - 1.)
                 do i=1, nats
                    xyzs(ii, i) = xyzs(ii, i) - 1. * ise
                    modificato = 1
                 enddo
                 bard(ii) = bard(ii) - 1. * ise
                 goto 36
             else
                 if (bard(ii) .lt. -0.5) then
                     do i=1, nats
                        xyzs(ii, i) = xyzs(ii, i) + 1.0
                        modificato = 1
                     enddo
                     bard(ii) = bard(ii) + 1.0
                 endif
                 do i=1, nats
                    if (xyzs(ii, i) < amin(ii)) amin(ii) = xyzs(ii, i)
                    if (xyzs(ii, i) > amax(ii)) amax(ii) = xyzs(ii, i)
                 enddo
             endif
          enddo
      endif
!
!-- update list 5 ( modified because of baric. )
!
      if (modificato.eq.1.and.ifLi5.gt.0) then
          do i=1,nats
             lnz = iabs(nz(i)) / nzConst
             if (lnz.gt.0) then
                 kblock(i) = 0
                 VetChanges(1:5) = xyzs(1:5,i)
                 if (bfac(i).gt.-5000.0) then
                     VetChanges(6) = bfac(i)
                 else
                     VetChanges(6) = bfac(i) + 100000.0
                 endif
                 Labb = aLab(i)
                 iAction = 6
                 call ModModel(i,iAction,Labb,lnz,VetChanges)
             endif
          enddo
          iAction = 100
          call ModModel(i,iAction,Labb,lnz,VetChanges)
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine CreaEll(i)
      USE General
      USE Atomi
      USE Molcom
!
*gl*  bfac(i) = bSav(i)
*gl*  bSav(i) = -bSav(i)

      bf = bfac(i) / (8*PI*PI)
      if (bf.gt.0.0000001) then
          Ell_val = 1.0 / bf
      else
          Rs2 = Rs(i) * Rs(i)
          Ell_val = 1.0 / Rs2
          bf = Rs2
      endif
      rad_bf = sqrt(bf)
      do j=1, 3
         do k=1, 3
            Ell(j,k,i) = 0.
            cd(j,k,i) = 0.
            if (j.eq.k) then
                Ell(j,j,i) = Ell_val
                cd(j,j,i) = 1.
            end if
         enddo
      enddo
      semax(1,i) = rad_bf
      semax(2,i) = rad_bf
      semax(3,i) = rad_bf
!
      return
      end
!-----------------------------------------------------------------------
      subroutine EllRest
      USE General
      USE Atomi
      USE Molcom
!
      dimension el(3,3), be(3,3), trm(3,3), ba(3,3)
!
      p1 = 2.0 * PI * PI
      do i=1, NatMol
         if ( bSav(i) .lt. 0.) then
            do jj=1, 3
                do kk=1, 3
                   el(jj,kk) = 0.
               enddo
            enddo
         else
            do jj=1, 3
               do kk=1, 3
                  el(jj,kk) = Ell(jj,kk,i) * FProb
               enddo
            enddo
            call InvMat(el, be, iCod)
            call Trasp (rmi, trm)
            call MoltMatMat(be, trm, ba)
            call MoltMatMat(rmi, ba, el)
            do jj=1,3
               do kk=jj, 3
                   el(jj,kk) = el(jj,kk) * p1
                   if(jj.ne.kk) el(jj,kk) = el(jj,kk)*2.
               enddo
            enddo
            el(2,1) = el(1,2)
            el(3,1) = el(1,3)
            el(3,2) = el(2,3)
         end if
         do jj=1, 3
            do kk=1, 3
               Ell(jj,kk,i) = el(jj,kk)
            enddo
         enddo
      enddo
! ---
      return
      end
!-----------------------------------------------------------------------
      subroutine NorEll(na, el, w1, w2, w3, t3, ifIso)
      USE General
      USE Atomi
      USE Molcom
      USE PhaseModule
      USE LsqModule
!
      dimension el(3,3), be(3,3), trm(3,3), t3(3,3), eigen(3), ba(3,3)
!
! ---
      call Trasp (rm, trm)
      call MoltMatMat(el, trm, ba)
      call MoltMatMat(rm, ba, be)
      call InvMat(be, el, iCod)
! ---
      if (iCod.eq.0) then
          call InconsistentAniso(na, el, w1, w2, w3, t3)
          ifIso = 1
          return
      end if
      do 20 i=1, 3
         do 15 j=1, 3
            t3(i,j) = 0.
            be(i,j) = el(i,j)
   15    continue
   20 continue
      call Autov(be, eigen, t3, iCod)
      do 9950 i=1, 2
         do 9940 j=i+1, 3
            ps = t3(1,i)*t3(1,j)+t3(2,i)*t3(2,j)+t3(3,i)*t3(3,j)
            if (abs(ps).gt.0.000001) then
               icod = 0
            end if
 9940    continue
 9950 continue
      do 9960 i=1, 3
         if (eigen(i) .le. 0) then
            icod = 0
         end if
 9960 continue
      if (iCod.eq.0) then
          call InconsistentAniso(na, el, w1, w2, w3, t3)
          ifIso = 1
          return
      endif
      w1 = 1./sqrt(abs(eigen(1)))
      w2 = 1./sqrt(abs(eigen(2)))
      w3 = 1./sqrt(abs(eigen(3)))
!
      if (w1 > 2.0 .or. w2 > 2.0 .or. w3 > 2.0) then
          call InconsistentAniso(na, el, w1, w2, w3, t3)
          ifIso = 1
          return
      endif
!
      do 50 j=1, 3
         q = 0.
         do 30 i=1, 3
            q = q + t3(i,j) * t3(i,j)
   30    continue
         do 40 i=1, 3
            if (abs(t3(i,j)) .gt. 1.e-15) then
                t3(i,j) = sqrt(t3(i,j)*t3(i,j)/q)*t3(i,j)/abs(t3(i,j))
            end if
   40    continue
   50 continue
! ---
      return
      end
!-----------------------------------------------------------------------
      subroutine InconsistentAniso(i, el, w1, w2, w3, t3)
      USE General
      USE Atomi
      USE Molcom
!
      implicit none
      integer :: i, j, k, iExCode
      real    :: el(3,3), t3(3,3), bf, w1, w2, w3
!
      Inte = 'W A R N I N G ...'
      Msg='Problems with anisotropic thermal parameters of atom '
     *           //aLab(i)//': set to isotropic.'
      call OneBlankOnly(Msg)
      iExCode = 0
      call MsgWinErr(Inte, Msg, WARN_WINDOW, iExCode)
      IsoAniso(i) = 2
      ifChangedB(i) = 1
!
      bf = bfac(i) / (8*PI*PI)
      do j=1, 3
         do k=1, 3
            el(j,k) = 0.
            t3(j,k) = 0.
            if (j == k) then
               el(j,j) = 1./bf
               t3(j,j) = 1.
            end if
         enddo
      enddo
      w1 = sqrt(bf)
      w2 = w1
      w3 = w1
!
      return
      end
!-----------------------------------------------------------------------
      subroutine InvMat(rm, rmi, iCod)
!
      USE General
      real rm(3,3),rmi(3,3)
      double precision det
!
      det = 0
      i = 1
      l = i + 1
      l1 = l + 1
      do 10 j=1, 3
         k = 1
         if (k .eq. j) then
            k = k + 1
         end if
         k1 = k + 1
         if (k1 .eq. j) then
            k1 = k1 + 1
         end if
         s = (-1.)**(i+j)
         sdet = s*rm(i,j)*(rm(l,k) * rm(l1,k1)-rm(l,k1)*rm(l1,k))
         det = det + sdet
   10 continue
c       write(lo,'(a,e15.4)')'det=',det
c      if (abs(det) .lt.0.0000001) then
      if (abs(det) .lt.1.0e-15) then
         iCod = 0
         return
      end if
!
      do 30 i=1, 3
         l=1
         if (l .eq. i) then
            l = l + 1
         end if
         l1 = l + 1
         if (l1 .eq. i) then
            l1 = l1 + 1
         end if
         do 20 j=1, 3
            k = 1
            if (k .eq. j) then
               k = k + 1
            end if
            k1 = k + 1
            if (k1 .eq. j) then
               k1 = k1 + 1
            end if
            s = (-1.) ** (i + j)
            rmi(j,i) = (rm(l,k) * rm(l1,k1) - rm(l,k1) * rm(l1,k)) / det
            rmi(j,i) = s * rmi(j,i)
   20    continue
   30 continue
      iCod = 1
!
  100 format (3f15.8)
      return
      end
! -----------------------------------------------------------------
      subroutine RotEll(el)
      USE Molcom
!
      dimension el(3,3), tr(3,3), Pro(3,3)
! ---
      call Trasp(BTot, tr)
      call MoltMatMat(BTot, el, Pro)
      call MoltMatMat(Pro, tr, el)
! ---
      return
      end
! -----------------------------------------------------------------
      subroutine RotCil(Cil,Rot)
      USE Molcom
!
      dimension Cil(3,3), tr(3,3), Pro(3,3), Rot(3,3)
! ---
      call Trasp(Rot, tr)
      call MoltMatMat(Rot, Cil, Pro)
      call MoltMatMat(Pro, tr, Cil)
! ---
      return
      end
! -----------------------------------------------------------------
      subroutine EllEqui(el, nOp1)
      USE Symmetry
      USE Molcom
!
      dimension el(3,3),b(3,3), tr(3,3), Pro(3,3)
! ---
c      nOp = nOp1 / 10000
      nOp = nOp1 / 1000
      do i=1,3
         do j=1,3
            b(i,j) = kmat(nOP, i,j)
         enddo
      enddo
      call MoltMatMat(b,rmi,pro)
      call MoltMatMat(rm,pro,b)
      call Trasp(b, tr)
      call MoltMatMat(b, el, Pro)
      call MoltMatMat(Pro, tr, el)
! ---
      return
      end
! -----------------------------------------------------------------
      subroutine CDEqui(rj, nOp1)
      USE Symmetry
      USE Molcom
!
      dimension rj(3),b(3,3), tr(3), pro(3,3)
! ---
c      nOp = nOp1 / 10000
      nOp = nOp1 / 1000
      do 20 i=1,3
         do 10 j=1,3
            b(i,j) = kmat(nOp, i,j)
   10    continue
   20 continue
      call MoltMatMat(b,rmi,pro)
      call MoltMatMat(rm,pro,b)

      call MoltMatVec(b, rj, tr)

      do 30 j=1,3
         rj(j) = tr(j)
   30 continue
! ---
      return
      end
! -----------------------------------------------------------------
      subroutine CalInt (nn1, nn2, FatK1, FatK2)
      USE General
      USE Atomi
      USE Molcom
!
      dimension el(3,3), s(3), e(3)
! ---
      n1 = iEqui(nn1)
      n2 = iEqui(nn2)
      lnz = iabs(nz(n1)) / nzConst
      if (no(lnz).ne.1) then
         do 10 i = 1, 3
            du1 = xyz(i,nn1) / FatK1
            du2 = xyz(i,nn2) / FatK2
            s(i) = -du1 + du2
            do 5 j = 1, 3
               el(i, j) = Ell(i, j, n1)
    5       continue
   10    continue
c         if (nOpEq(nn1)/10000 .ne. 1) then
         if (nOpEq(nn1)/1000 .ne. 1) then
            call EllEqui(el, nOpEq(nn1))
         end if
         call RotEll(el)
         call NormVett(s, el, e)
         p3 = (xyz(1, nn1) + e(1)) / FatK1
         p4 = (xyz(2, nn1) + e(2)) / FatK1
      end if

      lnz = iabs(nz(n2)) / nzConst
      if (no(lnz).ne.1) then
         do 20 i = 1, 3
            du1 = xyz(i,nn1) / FatK1
            du2 = xyz(i,nn2) / FatK2
            s(i) = -du2 + du1
            do 15 j = 1, 3
               el(i, j) = Ell(i, j, n2)
   15       continue
   20    continue
c         if (nOpEq(nn2)/10000 .ne. 1) then
         if (nOpEq(nn2)/1000 .ne. 1) then
            call EllEqui(el, nOpEq(nn2))
         end if
         call RotEll(el)
         call NormVett(s, el, e)
         p1 = (xyz(1, nn2) + e(1)) / FatK2
         p2 = (xyz(2, nn2) + e(2)) / FatK2
      end if
! ---
      return
      end
! -----------------------------------------------------------------
      subroutine InitMolplo
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Plotter
      USE PhaseModule
      USE LsqModule
!
      common /minma/ amin(3), amax(3)
! ---
      character str2*90, str*256
!
      DrawBard(:) = 0
      DrawDeltX   = 0
      DrawDeltY   = 0
!
!-- contour defaults
!
      Max_Points  = xyz_triadim - 28
      ifOriented = 0
      ifDrawContour = 0
      nLevels(1)  = 15     
      nLevels(2)  = 5     
      ifLevel     = 0
      ifLevel(3)  = 1
      SoglieCont  = 0.0
      do i=1,5
         if(jBackGround.eq.0) then
            LevelCol(i) = 16 - i + NToAdd
         else
            LevelCol(i) = 3 + i + NToAdd
         endif
      enddo 
      sezione0    = 0
      sezioneN    = 0
      abcmin = 9999
      do i=1,3
         xyzlimCont(1,i) = xyzfou(i,1) / xyzfou(i,4)
         xyzlimCont(2,i) = xyzfou(i,2) / xyzfou(i,4)
         deltaCont(i)  = xyzlimCont(2,i) - xyzlimCont(1,i)
         centerCont(i) = xyzlimCont(1,i) + deltaCont(i) / 2.0
         numCell(i,1) = 1
         numCell(i,2) = 0
         abcl = cell(i) * deltaCont(i)
         if (abcl < abcmin) then
             abcmin = abcl
             Layer  = i
         endif
      enddo
      ifModel = 0
      ifAlreadyProduced = 0
      ifGrid = 0
      Shapes(1) = 3
      Shapes(2) = 4
      Shapes(3) = 7
      Shapes(4) = 10
      Shapes(5) = 4
      Shapes(6) = 7
      moreLines = 0
      WhichRes = 1
      WhichLimit = 1
!
      ifDashed = 0
!
      if (ifRemo == 0) then
          if (allocated(ifLabelsVis)) then
              ifLabelsVis(:) = 1
              SinglePlotType(:) = iPlotType
          endif
      endif
!
      ifFour = 0
      Labb = 'Pk'
      read(Labb,'(a2)') nalf(PiccoFour)
      lspec = -1
      nAided = 0
      call Orto(cell)
      call CopyMat
!
!-- Drawing Options
!
      ifCont = 0
      ifCell = 0
      ifScale = 1
      ifGhost = 1
      ifDrRes = 0
      ifDrHydr = 1
      ifDrHBond = 1
      ifChangedXYZ = 0
!
      if (no(1).eq.1) then
          ifHydro = 1
      else
          ifHydro = 0
      endif
      if (jscreen.ge.1) then
         NumSpec = nk
         do i=1,nk
            ixv(i) = nw(i)
         end do
         do i=1,nk
            iyv(i) = no(i)
         end do
         str=' '
         str2=' '
         call ucase(Species(1)(1:1))
         str = nomeat(1)
         str2 = Species(1)
         j=13
         j2 = 3
         do i=2,nk
            call ucase(Species(i)(1:1))
            str(j:j+12) = '@' // nomeat(i)
            j=j+13
            str2(j2:j2+5) = '@' // Species(i) 
            j2=j2+5
         enddo
         call PassaSpecie(str,0,nk)
         call PassaSpecie(str2,1,nk)
!
         jscreen = 2
      endif
!
      if (ifRemo == 0) then
          if (allocated(iOrd)) then
              do i=1, MaxAtomsInGr
                 iOrd(i) = i
              enddo
          endif
      endif
!
!-- Cube connectivity (in Fourier)
!
      legaCubo( 1,1:2) = (/ 1, 4 /)  ;  legaCubo( 2,1:2) = (/ 1, 5 /)
      legaCubo( 3,1:2) = (/ 1, 6 /)  ;  legaCubo( 4,1:2) = (/ 2, 4 /)
      legaCubo( 5,1:2) = (/ 2, 5 /)  ;  legaCubo( 6,1:2) = (/ 2, 7 /)
      legaCubo( 7,1:2) = (/ 3, 4 /)  ;  legaCubo( 8,1:2) = (/ 3, 6 /)
      legaCubo( 9,1:2) = (/ 3, 7 /)  ;  legaCubo(10,1:2) = (/ 8, 5 /)
      legaCubo(11,1:2) = (/ 8, 6 /)  ;  legaCubo(12,1:2) = (/ 8, 7 /)
!
      return
      end
c ---------------------------------------------------------------------
      subroutine Orto(cella)
      USE General ! , only: pi
      USE Molcom
!
      implicit none
      integer :: i
      real    :: cella(6), alf, bet, gam
!
*     common /pippo/ asta(3),alf,bet,gam,sas,sbs,sgs,alfs,bets,gams,v
!
      alf = cella(4)
      bet = cella(5)
      gam = cella(6)
!
      do i=1, 3
         DeADef(i) = 3.0/cella(i)
         if ( DeADef(i) .gt. 0.5 ) DeADef(i) = 0.5
         DeA(i) = DeADef(i)
         nCell(i) = 1
      enddo
!
*     call toMolPlo1(a,b,c,alf,bet,gam)
      alf=pi/180*alf
      bet=pi/180*bet
      gam=pi/180*gam
! ---------
! ---------  sgs =  coseno di gamma star
! ---------
      sas=(cos(bet)*cos(gam)-cos(alf))/(sin(bet)*sin(gam))
      sbs=(cos(alf)*cos(gam)-cos(bet))/(sin(alf)*sin(gam))
      sgs=(cos(alf)*cos(bet)-cos(gam))/(sin(alf)*sin(bet))
! ---------
! ---------  gams =  gamma star
! ---------

      if ( sas .gt.  1.0 ) sas = 1.0
      if ( sas .lt. -1.0 ) sas =-1.0
      alfs=acos(sas)
      if ( sbs .gt.  1.0 ) sbs = 1.0
      if ( sbs .lt. -1.0 ) sbs =-1.0
      bets=acos(sbs)
      if ( sgs .gt.  1.0 ) sgs = 1.0
      if ( sgs .lt. -1.0 ) sgs =-1.0
      gams=acos(sgs)
      volume = cella(1) * cella(2) * cella(3)
      volume = volume*sqrt(sin(alf)**2+sin(bet)**2+sin(gam)**2-2+
     *         2*cos(alf)*cos(bet)*cos(gam))
      asta(1) = cella(2) * cella(3) * sin(alf) / volume
      asta(2) = cella(1) * cella(3) * sin(bet) / volume
      asta(3) = cella(1) * cella(2) * sin(gam) / volume
!
      rmi(1,1) = 1.0 / cella(1)
      rmi(2,1) = 0.0
      rmi(3,1) = 0.0
      rmi(1,2) = -cos(gam) / (cella(1)*sin(gam))
      rmi(2,2) = 1.0 / (cella(2)*sin(gam))
      rmi(3,2) = 0.0
      rmi(1,3) = asta(1) * cos(bets)
      rmi(2,3) = asta(2) * cos(alfs)
      rmi(3,3) = asta(3)
!
      call InvRmi
!
      return
      end
!----------------------------------------------------------------
      subroutine CopyMat
      USE General
      USE Symmetry
      USE Molcom
!
      character *7 reticoli

      reticoli = 'pabcifr'
      nt1 = reticoli(latt:latt)
      if (icent == 1) then
          nSymMol = nsym * 2
      else
          nSymMol = nsym
      endif
!
      return
      end
! -------------------------------------------------------------------
      subroutine Leggi15_5(lista)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE PhaseModule
!
      if (lista == 15) then
          call PutGetXyzs(2, interp)
          leggi = 0
      else
          leggi = 1
      endif
      call toMolPlo3(leggi)
!
      call LsPlane(NATV, 1)
!
      IfLeg = iconn(1)
!
      if (IfLeg .eq.-1) then
          call BuildBonds(1)
          call LEtoIconn
      else
          call GetBonds(1)
      end if
!
      if (kscreen.eq.0) return
!
      return

      call EnableSingleIteration(0)
      call Disegna(ifScale)
      call EnableSingleIteration(1)
!
      return
      end
! ---------------------------------------------------------------------
      subroutine DefineLabelPos(jump)
      USE General
      USE Molcom
!
      character *8 LabN
!
      fy = FntPixHeight
!
      if (jump == 0) then
          ifPlotting = 1
          call NewLabel
          ifPlotting = 0
      endif
!
      do i=1,NatMol
         ipixLab(1,i) = nint( xyLab(1,i) * kscrx )
         ipixLab(2,i) = nint( (1.0 - xyLab(2,i)) * kscry )
      enddo
      ifMovedLab = 1
      do i=1,NatMol
         L = Lung(Lab(i))
         if(L>8) L=8  ! pezza
         if (L .GT. 0) then
             LabN = Lab(i)(1:L)
             It(i) = LabN(1:L)//char(0)
!mr180106             ListeAtomiV(i) = i
             fx = LenInPix(Lab(i),2)
         else
             ipixLab(1,i) = ipix(1,i)
             ipixLab(2,i) = ipix(2,i)
         end if
      enddo
      It(NatMol+1) = char(0)
!
      if (jump == 0) then
          ifsca = 0
          call Disegna(ifsca)
      endif
!
      return
      end
! ---------------------------------------------------------------------
      subroutine AggiuSpig
      USE General
      USE Atomi
      USE Molcom
!
      dimension x1(3), lega(12,2), sh(3), rrv(3)
      dimension xv(5,2500)
!
      lega(  1, 1) = 1
      lega(  1, 2) = 4
      lega(  2, 1) = 1
      lega(  2, 2) = 5
      lega(  3, 1) = 1
      lega(  3, 2) = 6
      lega(  4, 1) = 2
      lega(  4, 2) = 4
      lega(  5, 1) = 2
      lega(  5, 2) = 5
      lega(  6, 1) = 2
      lega(  6, 2) = 7
      lega(  7, 1) = 3
      lega(  7, 2) = 4
      lega(  8, 1) = 3
      lega(  8, 2) = 6
      lega(  9, 1) = 3
      lega(  9, 2) = 7
      lega( 10, 1) = 8
      lega( 10, 2) = 5
      lega( 11, 1) = 8
      lega( 11, 2) = 6
      lega( 12, 1) = 8
      lega( 12, 2) = 7

      xv(1, 1) = 1
      xv(2, 1) = 0
      xv(3, 1) = 0
      xv(1, 2) = 0
      xv(2, 2) = 1
      xv(3, 2) = 0
      xv(1, 3) = 0
      xv(2, 3) = 0
      xv(3, 3) = 1
      xv(1, 4) = 0
      xv(2, 4) = 0
      xv(3, 4) = 0
      xv(1, 5) = 1
      xv(2, 5) = 1
      xv(3, 5) = 0
      xv(1, 6) = 1
      xv(2, 6) = 0
      xv(3, 6) = 1
      xv(1, 7) = 0
      xv(2, 7) = 1
      xv(3, 7) = 1
      xv(1, 8) = 1
      xv(2, 8) = 1
      xv(3, 8) = 1
c      write(lo,*)'aggiuspig NatMol ',natmol
      do i = NatMol + 1, NatMol + 8
         iOrd(i) = i
         Lab(i) = ' '
         iCol(i) = color_CELL
         RS(i) = 0.01
         nzTot(i) = 0
         do j = 1, 3
            x1(j) = xv(j, i - NatMol)
         enddo
         call MoltMatVec(rm,x1,rrv)
         xyz(1,i) = rrv(1)
         xyz(2,i) = rrv(2)
         xyz(3,i) = rrv(3)
c	write(lo,*)'do 200,i,xyz(1:3,i) ',i,xyz(1:3,i)
      enddo
      NatSpi = 9
      nlp = 0
      do i = 1, 12
         j = lega(i,1) + NatMol
         k = lega(i,2) + NatMol
         x01 = xyz(1,j)
         y1 = xyz(2,j)
         z1 = xyz(3,j)
         x2 = xyz(1,k)
         y2 = xyz(2,k)
         z2 = xyz(3,k)
         dist = sqrt( (x01-x2)**2 + (y1-y2)**2 + (z1-z2)**2 )
         r0 = 2.5 / dist
         r1 = r0
         iu = j
  250    xm = x01 + (x2 - x01) * r1
         ym = y1 + (y2 - y1) * r1
         zm = z1 + (z2 - z1) * r1
         xyz(1, NatMol + NatSpi) = xm
         xyz(2, NatMol + NatSpi) = ym
         xyz(3, NatMol + NatSpi) = zm
c	write(lo,*)'do 250,i,xyz(1:3,natmol+natspi) '
c	1,natmol+natspi,xyz(1:3,natmol+natspi)
         do j = 1, 3
            x1(j) = xyz(j,NatMol+NatSpi)
         enddo
         call MoltMatVec(rmi,x1,rrv)
         xv(1, NatSpi) = rrv(1)
         xv(2, NatSpi) = rrv(2)
         xv(3, NatSpi) = rrv(3)
         iOrd(NatMol + NatSpi) = NatMol + NatSpi
         Lab(NatMol + NatSpi) = ' '
         iCol(NatMol + NatSpi) = color_CELL
         RS(NatMol + NatSpi) = 0.01
         nzTot(NatMol + NatSpi) = 0
         LE(1, nMaxLeg - nlp) = iu
         LE(2, nMaxLeg - nlp) = NatMol + NatSpi
         LE(3, nMaxLeg - nlp) = 0
         iu = NatMol + NatSpi
         nlp = nlp + 1
         r1 = r1 + r0
         NatSpi = NatSpi + 1
         if (NatMol + NatSpi .gt. MaxAtomsInGr) exit
         if (r1 .lt. 1.) then
             goto 250
         else
             LE(1, nMaxLeg - nlp) = iu
             LE(2, nMaxLeg - nlp) = k
             LE(3, nMaxLeg - nlp) = 0 
c	write(lo,*)'nmaxleg,nlp,le(1:3,nmaxleg-nlp) ',
c     1 nmaxleg,nlp,le(1:3,nmaxleg-nlp)
             nlp = nlp + 1
         end if
      enddo
      LE(1, nMaxLeg - nlp) = 0
      LE(2, nMaxLeg - nlp) = 0
      LE(3, nMaxLeg - nlp) = 0
      NatSpi = NatSpi - 1
      if (ifCont /= 0) then
!
          NuVe = NatSpi
          nlp1 = nlp
          dtr = atan(1.)
          do nax = 1, 3
             sh(1) = 0
             sh(2) = 0
             sh(3) = 0
             if (nCell(nax).gt.1) then
                sh(nax) = 1
                ifi = 1
                if (nCell(nax).eq.3) ifi = -1
                do j=ifi, 1, 2
                   do i=NatMol+1, NatMol+NuVe
                      NatSpi = NatSpi + 1
                      xv(1, NatSpi) = xv(1, i - NatMol) + j * sh(1)
                      xv(2, NatSpi) = xv(2, i - NatMol) + j * sh(2)
                      xv(3, NatSpi) = xv(3, i - NatMol) + j * sh(3)
                      x1(1:3) = xv(1:3, NatSpi)
                      call MoltMatVec(rm,x1,rrv)
                      xyz(1, NatMol + NatSpi) = rrv(1)
                      xyz(2, NatMol + NatSpi) = rrv(2)
                      xyz(3, NatMol + NatSpi) = rrv(3)
                      iOrd(NatMol + NatSpi) = NatMol + NatSpi
                      Lab(NatMol + NatSpi) = ' '
                      iCol(NatMol + NatSpi) = color_CELL
                      RS(NatMol + NatSpi) = 0.01
                      nzTot(NatMol + NatSpi) = 0
                   enddo
                   do nl=nlp,nlp+nlp1
                      LE(1, nMaxLeg - nl) = LE(1,nMaxLeg-nl+nlp1)+NuVe
                      LE(2, nMaxLeg - nl) = LE(2,nMaxLeg-nl+nlp1)+NuVe
                      LE(3, nMaxLeg - nl) = 0
                   enddo
                   nlp = nlp + nlp1
                enddo
                NuVe = NatSpi
                nlp1 = nlp
             end if
          enddo
          LE(1, nMaxLeg - nlp) = 0
          LE(2, nMaxLeg - nlp) = 0
          LE(3, nMaxLeg - nlp) = 0
      endif
      j = NatMol + NatSpi
      do i=1,9
         xyz(:,j+i) = coordCubo(:,i)
      enddo
      xyzCubo(:) = 10000
!
      return
      end
! ---------------------------------------------------------------------
      subroutine NormVett(S, EL, E)
      USE Molcom
!
      dimension S(3), EL(3, 3), E(3), RI(3)
!
      RL = SQRT(S(1) * S(1) + S(2) * S(2) + S(3) * S(3))
      if (RL .lt. 0.0001) then
          RL = .0001
      endif
      do K = 1 , 3
         RI(K) = S(K) / RL
      enddo
      d = 0
      do j = 1 , 3
         DD = 0
         do K = 1 , 3
            DD = DD + RI(K) * EL(K, j)
         enddo
         d = d + DD * RI(j)
      enddo
      if (d .lt. 0.000001)  d = .000001
      Q = SQRT(1 / ABS(d))
      do i = 1 , 3
         E(i) = Q * RI(i)
      enddo
!
      return
      end
! ---------------------------------------------------------------------
      subroutine LEtoIconn
      USE Atomi
      USE Molcom
!
      NL = NumLeg - nlp
      iconn(1) = NL
      k = 1
      do  i=1,NL
          do  j=1,3
          k = k + 1
          iconn(k) = LE(j,i)
          enddo
      enddo
      return
      end
! ---------------------------------------------------------------------
