*----------------------------------------------------------------
      subroutine esamin(khl,mkang,iphiv,iphic,mmm,numbx,
     * wt1,wtexa,errm,errmw,nrefas,shi)
      USE PhaseModule

      dimension khl(3,mmm),iphiv(mmm),iphic(mmm),
     *          wt1(mmm),wtexa(mmm),mkang(mmm)
      dimension shi(4)
!
      nuset = 0
      ifmin = 1 + ifReduced * 10
      numby = numbx - 1
      call examin(nuset,mkang,khl,iphiv,iphic,mmm,numby,wtexa,ifmin)
      nrefas = isumal
      shi(:) = shiftexam(1:4)
      errm = erore
      errmw = erorepes
!
      return
      end

!-----------------------------------------------------------------------
      subroutine examin(nuset,mkang,khl,iphiv,iphic,mmm,numbx,wtexa,
     *                  ifmin_input)
      USE General
      USE Symmetry
      USE TestStuff
      USE PhaseModule
c
c-- nuset= trial ( or set ) number
c-- khl   = h-k-l array
c-- iphiv = published phases array
c-- iphic = computed phases array
c-- mmm   = number of reflections
c-- numbx = number of reflections to exclude at beginning of array
c-- wtexa = weights array
c-- shiftexam = Shifts su h,k,l and enantiomorph
c           phaseN =  sign(enantiomorph) * phaseO - 360 * ( H S )

C COMPARE CALCULATED PHASES WITH PUBLISHED VALUES (IN DEGREES), TAKING
C INTO
C ACCOUNT ANY POSSIBLE SHIFT OF ORIGIN. NOX, NOY AND NOZ ARE THE NUMBER
C OF
C POSSIBLE ORIGIN POSITIONS IN EACH DIRECTION. THESE NUMBERS MUST BE
C POWERS
C OF 2 AND NOX*NOY*NOZ MUST BE .LE. 1024. FOR DIRECTIONS ALONG WHICH THE
C ORIGIN IS COMPLETELY FREE IT IS SUGGESTED ONE SHOULD USE ABOUT 10
C TIMES
C AS MANY POINTS AS THE LENGTH OF THE CORRESPONDING CELL PARAMETER.
C EG. FOR P2(1)2(1)2(1)                  USE 2   2   2
C         P2(1) WITH B=11.0 ANGSTROM         2 128   2
C WE ACKNOWLEDGE HERE THE USE OF A FFT ROUTINE WRITTEN BY DR.A.LIFCHITZ
C FROM LABORATOIRE DE MINERALOGIE-CRISTALLOGRAPHIE, UNIVERSITE DE PARIS
C FRANCE.
C
C
C RMSE = ROOT MEAN SQUARE ERROR IN DEGREES
C ERM  = MEAN ERROR IN DEGREES
      DIMENSION mkang(mmm),khl(3,mmm),iphiv(mmm),iphic(mmm),wtexa(mmm)
      integer steps(3)
*     common /exam/ FT
*     COMPLEX FT(2097152)
      integer, parameter :: FTSIZE = 2097152  !128*128*128
!
      ifmin = ifmin_input
      erore    = 0.0
      erorepes = 0.0
!      ifExamin = 0            !pgMAD6
      if (ifExamin.eq.0.or.knw.eq.0.or.ifTime.eq.1) then
          return
      endif
      if (nsym.eq.1.and.icent.eq.0.and.ifReduced.eq.0) then
!pgMAD4
!!!!!     if (ifPatt.eq.0.and.kmad.eq.0) return    ! commentare per 
!                                                    testare il P 1
!pgMAD4
      endif
!
      if (ifFloatOrigin > 0) then
          if (ifReduced.eq.1) then
              if (ifmin < 9) then
                  return
              else
                  ifmin = ifmin - 10
                  nOrigRoxi = 1
                  NOX = 128  !256
                  NOY = 128  !256
                  NOZ = 128  !256
                  tabo(1,1:3) = 128  !256
                  if3den = 0
              endif
          else
              if (ifmin > 9) then
                  ifmin = ifmin - 10
              endif
              NOX = nint( xyzmax(1) )
              NOY = nint( xyzmax(2) )
              NOZ = nint( xyzmax(3) )
          endif
          if (if3den.eq.1) then
              if (vpol(1) == 0 .and. xyzmax(1) > 4) then
                  NOX = 128
                  steps(1) = 42
              else
                  steps(1) = 1
              endif
              if (vpol(2) == 0 .and. xyzmax(2) > 4) then
                  NOY = 128
                  steps(2) = 42
              else
                  steps(2) = 1
              endif
              if (vpol(3) == 0 .and. xyzmax(3) > 4) then
                  NOZ = 128
                  steps(3) = 42
              else
                  steps(3) = 1
              endif
              if (ifRhombAx == 0 .and. latt == 7) then
                  steps(3) = 1
              endif
          else
              steps(1:3) = 1
          endif
!
          if (.not.allocated(FT)) allocate(FT(FTSIZE))

          CALL FERROR(FT,NOX,NOY,NOZ,steps,mkang,khl,iphiv,iphic,mmm,
     *                numbx,wtexa,nuset,ifmin)
      else
          if (allocated(FT)) deallocate(FT)
          call Esamina(mkang,khl,iphiv,iphic,mmm,numbx,wtexa,nuset,
     *                 ifmin)
      endif
*     if (kverbo > 0) then
*         write(6,'(a,e25.15)') 'EXAMIN SUM(WT)',sum(wtexa(1:mmm))
*     endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Esamina(mkang,khl,ipub,iphic,mmm,numbx,wtexa,nuset,
     *                   ifmin)
      USE General
      USE Symmetry
      USE PhaseModule
c
      integer mkang(mmm), khl(3,mmm), ipub(mmm), iphic(mmm)
      real wtexa(mmm)
      real s(6)
      character *80 Buffer2
!
      Buffer1 = ' '
      Buffer2 = ' '

      ifin = 2
      setmin = 0

!!!!  do i=1, 2
      do i=1, ifin
         if (i == 1) then
             sm = +1
         else
             sm = -1
         endif
         ermAbs = 9999
         erpAbs = 9999
         erm2 = 9999
         ermpes2 = 9999
         RMSEAbs = 9999
         RMSEwAbs = 9999
         frac1Abs    = 9999
         errm_csAbs  = 9999
         errmw_csAbs = 9999
         errm_ncsAbs  = 9999
         errmw_ncsAbs = 9999

         ifin_Orig = nOrigRoxi

!!!!     do k=1, nOrigRoxi
         do k=1, ifin_Orig
            dxm = tabo(k, 1)
            dym = tabo(k, 2)
            dzm = tabo(k, 3)

            isumal = 0
            sumalfa = 0.0
            erm = 0.0
            ermpes = 0.0
            RMSE  = 0.0
            RMSEw = 0.0
            errm_ncs = 0.0
            errmw_ncs= 0.0
            sumw_ncs = 0
            nrefncs  = 0
            errm_cs  = 0.0
            errmw_cs = 0.0
            sumw_cs  = 0
            nrefcs   = 0
            nrefncs  = 0
            do ll=numbx+1, mmm
               if (wtexa(ll) > 0.0) then
                   isumal = isumal + 1
                   sumalfa = sumalfa + wtexa(ll)
                   phih = iphic(ll)
                   delta = (khl(1,ll) * dxm
     *                    + khl(2,ll) * dym
     *                    + khl(3,ll) * dzm) 
                   del1= 360.0 * delta + ipub(ll) -sm * iphic(ll)
!                  del1 = 360.0 * (jh * dxm + jk * dym + jl * dzm)
!    *                  + ipub(ll) - sm * ifaz
                   del2 = abs( amod(del1, 360.0) )
                   if (del2 > 180.0) del2 = 360.0 - del2
                   erm = erm + del2
                   ermpes = ermpes + del2 * wtexa(ll)
                   RMSE  = RMSE  + del2 ** 2
                   RMSEw = RMSEw + del2 * del2 * wtexa(ll)
                   if (mkang(ll) == 1) then
                       errm_ncs  = errm_ncs + del2
                       errmw_ncs = errmw_ncs + del2 * wtexa(ll)
                       nrefncs   = nrefncs + 1
                       sumw_ncs  = sumw_ncs + wtexa(ll)
                   else
                       errm_cs   = errm_cs + del2
                       errmw_cs  = errmw_cs + del2 * wtexa(ll)
                       nrefcs    = nrefcs + 1
                       if (del2 == 0.0) nrefcs = nrefcs + 1
                       sumw_cs   = sumw_cs + wtexa(ll)
                   endif
!     write(6,1000) ll,khl(1:3,ll),iphic(ll),ipub(ll),dxm,dym,dzm,delta,
!    *              del1,del2,erm,ermpes
!1000 format(i4,1h),5i4,3f6.3,2f12.3,f8.3,2f15.3)
               endif
            enddo
            if (isumal > 0) then
                erm = erm/isumal
                ermpes = ermpes/sumalfa
                RMSE  = SQRT(RMSE  / isumal)
                RMSEw = sqrt(RMSEw / sumalfa)
            else
               return
            endif
            if (erm < ermAbs) then
                ermAbs = erm
                dxmAbs = dxm
                dymAbs = dym
                dzmAbs = dzm
                erpAbs = ermpes
                RMSEAbs = RMSE
                RMSEwAbs = RMSEw
                if (nrefcs.gt.0) then
                    frac1Abs    = nrefcs / float(nrefcs)
                    errm_csAbs  = errm_cs / float(nrefcs)
                    errmw_csAbs = errmw_cs / sumw_cs
                endif
                if (nrefncs.gt.0) then
                    errm_ncsAbs  = errm_ncs / float(nrefncs)
                    errmw_ncsAbs = errmw_ncs / sumw_ncs
                endif
            endif
         enddo
         if (i == 1) then
             nrefncs1  = nrefncs
             nrefcs1   = nrefcs
             errm1_cs  = 0.0
             errmw1_cs = 0.0
             frac1     = 0.0
             errm1_ncs = 0.0
             errmw1_ncs= 0.0
             if (nrefcs.gt.0) then
                 frac1    = frac1Abs
                 errm1_cs = errm_csAbs
                 errmw1_cs= errmw_csAbs
             endif
             if (nrefncs.gt.0) then
                 errm1_ncs  = errm_ncsAbs
                 errmw1_ncs = errmw_ncsAbs
             endif
             erm1 = ermAbs
             ermpes1 = erpAbs
             s(1) = dxmAbs
             s(2) = dymAbs
             s(3) = dzmAbs
             RMSE1 = RMSEAbs
             RMSEw1 = RMSEwAbs
             if (QualePgm == SIRPGM) then
                 if (kmad == 0) then
                     write(Buffer1(1:40),"(i5,') ',3f5.2,2f8.2,'  ')") 
     *                     nuset, s(1:3), erm1, ermpes1
                 else
                     write(Buffer1(1:46),"(i5,') ',3f5.2,2f11.5,'  ')")
     *                     nuset, s(1:3), erm1, ermpes1
                 endif
             else
                 kuno = 1
                 write(Buffer1(1:70),"(i7,')',3f5.2,4f10.2,i6)") 
     *                kuno, s(1:3), erm1, ermpes1, RMSE1, RMSEw1, isumal
             endif
             write(Buffer2(1:31),"(i6,')',2f9.2,'      ')") nuset,
     *                   erm1, ermpes1
             if (ifErrMin == 1) then
                 if (erm1 < erm1min .and. isumal > nstr/2) then
                     setmin = nuset
                     erm1min = erm1
                 endif
             endif
         else

             nrefncs2=nrefncs
             nrefcs2=nrefcs
             frac2=0.0
             errm2_cs=0.0
             errmw2_cs=0.0
             errm2_ncs=0.0
             errmw2_ncs=0.0
             if (nrefcs.gt.0) then
                 frac2    = frac1Abs
                 errm2_cs = errm_csAbs
                 errmw2_cs= errmw_csAbs
             endif
             if (nrefncs.gt.0) then
                 errm2_ncs  = errm_ncsAbs
                 errmw2_ncs = errmw_ncsAbs
             endif
             erm2 = ermAbs
             ermpes2 = erpAbs
             RMSE2 = RMSEAbs
             RMSEw2 = RMSEwAbs
             s(4) = dxmAbs
             s(5) = dymAbs
             s(6) = dzmAbs
             if (QualePgm == SIRPGM) then
                 if (kmad == 0) then
                     write(Buffer1(41:),'(3f5.2,2f8.2,i6)')
     *                          s(4:6),erm2, ermpes2, isumal
                 else
                     write(Buffer1(47:),'(3f5.2,2f11.5,i6)')
     *                          s(4:6),erm2, ermpes2, isumal
                 endif
             else
                 kuno = -1
                 write(Buffer1(71:),"(i7,')',3f5.2,4f10.2,i6)") 
     *                kuno, s(4:6), erm2, ermpes2, RMSE2, RMSEw2, isumal
             endif
             if (ifErrMin == 1) then
                 if (erm2 < erm1min .and. isumal > nstr/2) then
                     setmin = -nuset
                     erm1min = erm2
                 endif
             endif
         endif
         write(Buffer2(32:),'(2f9.2,i6,f9.2,i6)')
     *                   erm2,ermpes2,isumal,erm1min,nint(setmin)
      enddo
      if (QualePgm == SIRPGM) then
          if (ifmin /= 0) then
              write(lo,'(a)') Buffer1(1:Lung(Buffer1))
              call toflush()
          end if
      else
           L = Lung(Buffer1(1:70))
           write(lo,'(a)') Buffer1(1:L)
           L = Lung(Buffer1(71:140))
           write(lo,'(a)') Buffer1(71:71+L-1)
           if (erm1 > erm2) then
               write(lo,2000) nrefcs2,errm2_cs,errmw2_cs,frac2,
     *                        nrefncs2,errm2_ncs,errmw2_ncs
           else
               write(lo,2000) nrefcs1,errm1_cs,errmw1_cs,frac1,
     *                        nrefncs1,errm1_ncs,errmw1_ncs
           endif
      end if
      if (erm1 > erm2) then
          erore = erm2
          erorepes = ermpes2
         do i=1,3
            shiftexam(i) = s(i+3)
            shiftexam(i+4) = s(i)
         end do
         shiftexam(4) = -1.0
      else
          erore = erm1
          erorepes = ermpes1
         do i=1,3
            shiftexam(i) = s(i)
            shiftexam(i+4) = s(i+3)
         end do
         shiftexam(4) = 1.0
      end if
!
      return
 2000 format(6x,'c.s reflection  :',i6,1x,2f10.2,f7.4,/,
     *       6x,'n.c.s reflection:',i6,1x,2f10.2,/)
      end
!-----------------------------------------------------------------------
      SUBROUTINE FERROR(FT,NOX,NOY,NOZ,steps,mkang,khl,ipub,iphic,mmm,
     *                  numbx,wtexa,nuset,ifmin)
      USE General
      USE Symmetry
      USE PhaseModule
c
      dimension mkang(mmm),khl(3,mmm),ipub(mmm),iphic(mmm),wtexa(mmm)
      dimension s(6),dxyzi(3),dxyz(3)
      integer steps(3)
      COMPLEX FT(NOX,NOY,NOZ)
      character *80 Buffer2
!
!     ZERO=0.000001
      ZERO = 0.04
      Buffer1 = ' '
      Buffer2 = ' '
      LC1=6
            
      IFIN = 2
!!!!  do I=1,2
      do I=1,IFIN
         dxyz(1:3) = 0.0
         DXM = 0.0
         DYM = 0.0
         DZM = 0.0
c
         DXM1 = 0.0
         DYM1 = 0.0
         DZM1 = 0.0
         ermpes2 = 9999
         errm_ncs  = 0.0
         errmw_ncs = 0.0
         sumw_ncs  = 0
         nrefncs   = 0
         errm_cs   = 0.0
         errmw_cs  = 0.0
         sumw_cs   = 0
         nrefcs    = 0
         nrefcsf   = 0
         RMAX      = 0.
c
         RMAX=-9999.
         do LX=1,NOX
            do LY=1,NOY
               do LZ=1,NOZ
                  FT(LX,LY,LZ) = (0.,0.)
               enddo
            enddo
         enddo
!
         sommaref = 0
         do IK=1,mmm
            LL=IK
            if (ll.le.numbx) cycle
            if (WTexa(LL) > 0.0) then
                sommaref = sommaref + 1
                SM=+1
                if (I .EQ.2) SM=-1
                IFAZ=IPHIC(LL)
                FFF=(IPUB(LL)-SM*IFAZ)*DTOR
                AA=COS(FFF)
                BB=-SIN(FFF)
                jh = khl(1,ll)
                jk = khl(2,ll)
                jl = khl(3,ll)
                LX=MOD(JH,NOX)+1
                if (LX.LE.0)LX=LX+NOX
                LY=MOD(JK,NOY)+1
                if (LY.LE.0)LY=LY+NOY
                LZ=MOD(JL,NOZ)+1
                if (LZ.LE.0)LZ=LZ+NOZ
                FT(LX,LY,LZ)=FT(LX,LY,LZ)+CMPLX(AA,BB)
            endif
         enddo
         CALL ABC(NOX,NOY,NOZ,-1)
!
         if (ifRhombAx == nOrigRoxi) then
             do LX=1,NOX
                LY=LX
                LZ=LX
                R = REAL(FT(LX,LY,LZ))
                if (R.gt.RMAX) then
                    RMAX = R
                    dxyz(1:3) = ( float(LX)-1.0 ) / FLOAT(NOX)
                endif
             enddo
         else
             do LX=1,NOX, steps(1)
                do LY=1,NOY, steps(2)
                   do LZ=1,NOZ, steps(3)
                      dxyzi(1) = ( float(LX)-1.0 ) / FLOAT(NOX)
                      dxyzi(2) = ( float(LY)-1.0 ) / FLOAT(NOY)
                      dxyzi(3) = ( float(LZ)-1.0 ) / FLOAT(NOZ)
                      do k=1,nOrigRoxi
                         kVai = 1
                         do j=1,3
                            if (vpol(j) == 0) then
                                difxyz = abs( dxyzi(j) - tabo(k,j) )
                                if (difxyz.gt.ZERO) then
                                    kVai = 0
                                endif
                            endif
                         enddo
                         if (kVai == 1) then
                             R = REAL(FT(LX,LY,LZ))
                             if (R.gt.RMAX) then
                                 RMAX = R
                                 dxyz = dxyzi
                             endif
                         endif
                      enddo
                   enddo
                enddo
             enddo
         endif
!
         if (if3den.eq.1) then
             do k=1,3
                if (vpol(k) == 0) then
                    if (dxyz(k).gt.0.1) then
                        if (dxyz(k).lt.0.2) then
                            dxyz(k) = 1.0 / 6.0
                        elseif (dxyz(k).lt.0.4) then
                            dxyz(k) = 1.0 / 3.0
                        elseif (dxyz(k).lt.0.6) then
                            dxyz(k) = 1.0 / 2.0
                        elseif (dxyz(k).lt.0.8) then
                            dxyz(k) = 2.0 / 3.0
                        else
                            dxyz(k) = 5.0 / 6.0
                        endif
                    endif
                endif
             enddo
         endif
         DXM = dxyz(1)
         DYM = dxyz(2)
         DZM = dxyz(3)
!
         RMSE=0.
         RMSEw=0.0
         ERM=0.
         ermpes=0.0
         sumalfa=0.0
         ISUMAL=0
         do J=1,mmm
            LL=J
            if (ll <= numbx) cycle
            if (WTexa(LL) > 0.0) then
                ISUMAL=ISUMAL+1
                sumalfa=sumalfa+wtexa(ll)
                jh = khl(1,ll)
                jk = khl(2,ll)
                jl = khl(3,ll)
                IFAZ=IPHIC(LL)
                DELta=(JH*DXM+JK*DYM+JL*DZM)+IPUB(LL)
                DEL1=360.*DELta+IPUB(LL)-SM*IFAZ
                DEL=abs(amod(DEL1,360.))
                if (DEL > 180.0) DEL=360.-DEL
                ERM=ERM+DEL
                ermpes=ermpes+del*wtexa(ll)
                RMSE=RMSE+DEL**2
                RMSEw=RMSEw+del*del*wtexa(ll)
                if (mkang(ll).eq.1) then
                  errm_ncs=errm_ncs+DEL
                  errmw_ncs=errmw_ncs+del*wtexa(ll)
                  nrefncs=nrefncs+1
                  sumw_ncs=sumw_ncs+wtexa(ll)
                else
                  errm_cs=errm_cs+DEL
                  errmw_cs=errmw_cs+del*wtexa(ll)
                  nrefcs=nrefcs+1
                  if (del.eq.0.0)nrefcsf=nrefcsf+1
                  sumw_cs=sumw_cs+wtexa(ll)
                endif
            endif
         enddo
         if (isumal == 0) then
*         write(0,*) ' isumal = 0',' nuset =',nuset,' ifmin =',ifmin
             isumal=1
             sumalfa=1.0
         endif
         ERM=ERM/ISUMAL
         ermpes=ermpes/sumalfa
         RMSE=SQRT(RMSE/ISUMAL)
         RMSEw=sqrt(RMSEw/sumalfa)
         if (I.EQ.1) then
             nrefncs1=nrefncs
             nrefcs1=nrefcs
             errm1_cs=0.0
             errmw1_cs=0.0
             frac1=0.0
             errm1_ncs=0.0
             errmw1_ncs=0.0
             if (nrefcs.gt.0) then
                 frac1=nrefcsf/float(nrefcs)
                 errm1_cs=errm_cs/float(nrefcs)
                 errmw1_cs=errmw_cs/sumw_cs
             endif
             if (nrefncs.gt.0) then
                 errm1_ncs=errm_ncs/float(nrefncs)
                 errmw1_ncs=errmw_ncs/sumw_ncs
             endif

             ERM1=ERM
             ermpes1=ermpes
             RMSE1=RMSE
             RMSEw1=RMSEw
             s(1)=dxm
             s(2)=dym
             s(3)=dzm
             if (QualePgm == SIRPGM) then
                 if (kmad == 0) then
                     write(Buffer1(1:40),"(i5,') ',3f5.2,2f8.2,'  ')") 
     *                     nuset,dxm,dym,dzm,erm1,ermpes1
!                    write(6,"('HAND +',3f5.2,2f8.2,'  ')") 
!    *                           dxm,dym,dzm,erm1,ermpes1
                 else
                     write(Buffer1(1:46),"(i5,') ',3f5.2,2f11.5,'  ')")
     *                     nuset,dxm,dym,dzm,erm1,ermpes1
                 endif
             else
                 kuno = 1
                 write(Buffer1(1:70),"(i7,')',3f5.2,4f10.2,i6)")
     *                kuno, s(1:3), erm1, ermpes1, RMSE1, RMSEw1, isumal
             endif
             write(Buffer2(1:31),"(i6,')',2f9.2,'      ')") nuset,
     *                   erm1,ermpes1
             if (ifErrmin == 1) then
                 if (erm1.lt.erm1min.and.isumal.gt.nstr/2) then
                     setmin = nuset
                     erm1min = erm1
                 endif
             endif
         endif
         if (I.EQ.2) then
             nrefncs2=nrefncs
             nrefcs2=nrefcs
             frac2=0.0
             errm2_cs=0.0
             errmw2_cs=0.0
             errm2_ncs=0.0
             errmw2_ncs=0.0
             if (nrefcs.gt.0) then
                 frac2=nrefcsf/float(nrefcs)
                 errm2_cs=errm_cs/float(nrefcs)
                 errmw2_cs=errmw_cs/sumw_cs
             endif
             if (nrefncs.gt.0) then
                 errm2_ncs=errm_ncs/float(nrefncs)
                 errmw2_ncs=errmw_ncs/sumw_ncs
             endif
             ERM2=ERM
             ermpes2=ermpes
             RMSE2=RMSE
             RMSEw2=RMSEw
             s(4)=dxm
             s(5)=dym
             s(6)=dzm
             if (QualePgm == SIRPGM) then
                 if (kmad == 0) then
                     write(Buffer1(41:),'(3f5.2,2f8.2,i6)')
     *                          dxm,dym,dzm,erm2,ermpes2,isumal
!                    write(6,"('HAND -',3f5.2,2f8.2,'  ')") 
!    *                           dxm,dym,dzm,erm2,ermpes2
                 else
                     write(Buffer1(47:),'(3f5.2,2f11.5,i6)')
     *                          dxm,dym,dzm,erm2,ermpes2,isumal
                 endif
             else
                 kuno = -1
                 write(Buffer1(71:),"(i7,')',3f5.2,4f10.2,i6)")
     *                kuno, s(4:6), erm2, ermpes2, RMSE2, RMSEw2, isumal
             endif
             if (ifErrmin == 1) then
                 if (erm2.lt.erm1min.and.isumal.gt.nstr/2) then
                     setmin = -nuset
                     erm1min = erm2
                 endif
             endif
             write(Buffer2(32:),'(2f9.2,i6,f9.2,i6)')
     *                   erm2,ermpes2,isumal,erm1min,nint(setmin)
         endif
         if (erm1.lt.erm2) then
             erore = erm1
             erorepes = ermpes1
         else
             erore = erm2
             erorepes = ermpes2
         end if
      enddo
      if (QualePgm == SIRPGM) then
          if (ifmin /= 0) then
              write(lo,'(a)') Buffer1(1:Lung(Buffer1))
              call toflush()
          end if
      else
           L = Lung(Buffer1(1:70))
           write(lo,'(a)') Buffer1(1:L)
           L = Lung(Buffer1(71:140))
           write(lo,'(a)') Buffer1(71:71+L-1)
           if (erm1 > erm2) then
               write(lo,2000) nrefcs2,errm2_cs,errmw2_cs,frac2,
     *                        nrefncs2,errm2_ncs,errmw2_ncs
           else
               write(lo,2000) nrefcs1,errm1_cs,errmw1_cs,frac1,
     *                        nrefncs1,errm1_ncs,errmw1_ncs
           endif
      end if
      if (erm1.le.erm2) then
         do i=1,3
            shiftexam(i)=s(i)
            shiftexam(i+4)=s(i+3)
         end do
         shiftexam(4)=1.0
      else
         do i=1,3
            shiftexam(i)=s(i+3)
            shiftexam(i+4)=s(i)
         end do
         shiftexam(4)=-1.0
      end if
      call toflush()
!
      RETURN
 2000 format(10x,'c.s reflection:',i6,1x,2f10.2,f7.4,/,
     *       10x,'n.c.s reflection:',i6,1x,2f10.2,/)
      END
!-----------------------------------------------------------------------
      SUBROUTINE ABC(K,L,M,ISIGN)
      USE TestStuff
      COMPLEX             FX,FY,V,W,F
      DIMENSION IM(3),IN(3),ICA(3)
!
      PI = 4.0 * ATAN(1.0)
      IM(1) = K
      IM(2) = L
      IM(3) = M
      DO J=1,3
         IA=1
         IB=0
         do
            IC=IM(J)-IA
            IF (IC < 0) then
                PRINT 100,K,L,M,ISIGN
                return
            endif
            IF (IC > 0) then
                IA=IA+IA
                IB=IB+1
            else
                exit
            endif
         enddo
         IM(J)=IB
      enddo
      IF (ISIGN*ISIGN <= 0) then
          PRINT 100,K,L,M,ISIGN
          return
      endif
      CALL REV(FT,K,L,M)
      IN(1)=1
      IN(2)=2
      IN(3)=3
      DO ID=1,2
         IA=IN(1)
         IB=IN(2)
         IF (IM(IB) < IM(IA)) then
             IN(1)=IB
             IN(2)=IA
         endif
         IB=IN(2)
         IC=IN(3)
         IF (IM(IC) < IM(IB)) then
             IN(2)=IC
             IN(3)=IB
         endif
      enddo
      II=1
      II2=2
      ICC=ISIGN
      KL=K*L
      KLM=KL*M
      IK=K
      IK2=K+K
      IKL=KL
      IKL2=KL+KL
      DO J=1,3
         ICA(J)=0
         IF (IM(J) > 0) then
             ICA(J)=1
         endif
      enddo
      IA=0
      DO J=1,3
         IB=IN(J)
         IMIN=IM(IB)-IA
         IF (IMIN > 0) then
             DO IG=1,IMIN
                F=(0.0,1.0)
                F=F*(PI/ICC)
                W=CEXP(F)
                IF (ICA(1) > 0) then
                    V=(1.0,0.0)
                    DO IA=1,II
                       DO IB=IA,K,II2
                          DO IC=IB,KL,K
                             DO ID=IC,KLM,KL
                                IE=ID+II
                                FX=FT(ID)
                                FY=FT(IE)*V
                                FT(ID)=FX+FY
                                FT(IE)=FX-FY
                             enddo
                          enddo
                       enddo
                       V=V*W
                    enddo
                endif
                IF (ICA(2) > 0) then
                    V=(1.0,0.0)
                    DO IA=K,IK,K
                       DO IB=1,K
                          IF=IA+IB-K
                          DO IC=IF,KL,IK2
                             DO ID=IC,KLM,KL
                                IE=ID+IK
                                FX=FT(ID)
                                FY=FT(IE)*V
                                FT(ID)=FX+FY
                                FT(IE)=FX-FY
                             enddo
                          enddo
                       enddo
                       V=V*W
                    enddo
                endif
                IF (ICA(3) > 0) then
                    V=(1.0,0.0)
                    DO IA=KL,IKL,KL
                       DO IB=1,K
                          IF=IA+IB-KL
                          DO IC=IF,IA,K
                             DO ID=IC,KLM,IKL2
                                IE=ID+IKL
                                FX=FT(ID)
                                FY=FT(IE)*V
                                FT(ID)=FX+FY
                                FT(IE)=FX-FY
                             enddo
                          enddo
                       enddo
                       V=V*W
                    enddo
                endif
                II=II+II
                II2=II2+II2
                IK=IK+IK
                IK2=IK2+IK2
                IKL=IKL+IKL
                IKL2=IKL2+IKL2
                ICC=ICC+ICC
             enddo
         endif
         IB=IN(J)
         IA=IM(IB)
         ICA(IB)=0
      enddo
      IF (ISIGN > 0) then
          C=1.0/KLM
          DO IA=1,KLM
             FT(IA)=FT(IA)*C
          enddo
      endif
!
      RETURN
  100 FORMAT(' * ERREUR ABC * ',4I11)
      END
!-----------------------------------------------------------------------
      SUBROUTINE REV(FT,K,L,M)
      COMPLEX FT(K,L,M),F
!
      DO MA=1,M
         MM=MIR(MA-1,M)+1
         IF (MM < MA) cycle
         IF (MM > MA) then
             DO LA=1,L
                LL=MIR(LA-1,L)+1
                DO KA=1,K
                   KK=MIR(KA-1,K)+1
                   F=FT(KA,LA,MA)
                   FT(KA,LA,MA)=FT(KK,LL,MM)
                   FT(KK,LL,MM)=F
                enddo
             enddo
             cycle
         endif
         DO LA=1,L
            LL=MIR(LA-1,L)+1
            IF (LL < LA) cycle
            IF (LL > LA) then
                DO KA=1,K
                   KK=MIR(KA-1,K)+1
                   F=FT(KA,LA,MA)
                   FT(KA,LA,MA)=FT(KK,LL,MM)
                   FT(KK,LL,MM)=F
                enddo
                cycle
            endif
            DO KA=1,K
               KK=MIR(KA-1,K)+1
               IF (KK > KA) then
                   F = FT(KA, LA, MA)
                   FT(KA, LA, MA) = FT(KK, LL, MM)
                   FT(KK, LL, MM) = F
               endif
            enddo
         enddo
      enddo
!
      RETURN
      END
!-----------------------------------------------------------------------
      FUNCTION MIR(I,K)
      KA  = K
      IA  = I
      MIR = 0
      do
         IF ( ((KA - 1) * IA) <= 0 ) exit
         KA  = KA / 2
         IB  = IA / 2
         MIR = MIR + KA * (IA - IB - IB)
         IA  = IB
      enddo
!
      RETURN
      END
!-----------------------------------------------------------------------
      subroutine pherrdisNew(tirang,dij,khl,mkang,nrif,ic,
     *                       ia,ib,c,nrang1,rmax1,ipher)
! --- (tirang,wt,khl,numbMax,izero,
!                       ipub,iphaz,tmpwt,10,0.0,ipher) 
      USE General
      USE PhaseModule
!
      dimension khl(3,nrif),mkang(nrif)
      dimension ia(nrif),ib(nrif),c(nrif),dij(nrif)
      dimension his(201),cumde(201),range(201),
     * disa1(201),disb1(201),disa2(201),disb2(201),
     * cumerr1(201),cumerr2(201),cumerp1(201),cumerp2(201),
     * csegni(201),cumse(201),cmed(201),ccmed(201)
      character tirang*11
      integer his, cumde, ierv(3)

      real,    allocatable :: dijs(:)
      integer, allocatable :: jorde(:), jorde1(:)
c--
      if (ipher < 0 .or. ifExamin == 0) return    ! 27/7/2010 dedi - per uscire dalla subroutine
      if (ifTime == 1) return
!
      if (ipher.eq.0) then
          lll = -444
          ifmin = 10
          call examin(lll,mkang,khl,ia,ib,nrif,ic,c,ifmin)
      endif
      if (knw.eq.0) return
      if (nrif.le.0) then
         write(lo,*) ' nrif = 0'
        return
      endif
c--
      ierv(:) = 0
      IF (.NOT. ALLOCATED(dijs))
     *    ALLOCATE (dijs(1:nreflDim),  stat = ierv(1))
      IF (.NOT. ALLOCATED(jorde))
     *    ALLOCATE (jorde(1:nreflDim), stat = ierv(2))
      IF (.NOT. ALLOCATED(jorde1))
     *    ALLOCATE (jorde1(1:nreflDim),stat = ierv(3))
      ierr = sum(iabs(ierv(:)))
      if (ierr.ne.0) then
          write(lo,*) 'PherrDisNew Allocation error'
          call cstop(' ')
      endif
      do i=1,nrif
         jorde(i) = i
      enddo
      nrang = 10
      if (nrang1.gt.0)   nrang = nrang1
      if (nrang1.gt.200) nrang = 200
      itot=0
      sumsegni=0.0
      sumdif1=0.0
      sumdisb1=0.0
      sumdif2=0.0
      sumdisb2=0.0
      sumc=0.0
      do i=1,201
         range(i)=0.0
         his(i)=0
         cumde(i)=0
         cumse(i)=0.0
         csegni(i)=0.0
         cmed(i)=0.0
         disa1(i)=0.0
         disb1(i)=0.0
         cumerr1(i)=0.0
         cumerp1(i)=0.0
         disa2(i)=0.0
         cumerr2(i)=0.0
         cumerp2(i)=0.0
         disb2(i)=0.0
         ccmed(i)=0.0
      enddo
      rmin=99999.
      rabs=99999.
      rmax=-99999.
      ii=0
      do i=1,nrif
         if (i.le.ic) cycle
         kk=jorde(i)
         if (kk.eq.0.or.kk.gt.nrif) write(lo,*)kk
         if (c(kk).le.0.0) cycle
         ii=ii+1
         dijs(ii)=dij(kk)
         jorde1(ii)=kk
         if (abs(dij(kk)).lt.rabs) rabs=abs(dij(kk))
         if (dij(kk).lt.rmin) rmin=dij(kk)
         if (dij(kk).gt.rmax) rmax=dij(kk)
      enddo
      numsort=ii
      if (rmax.eq.rmin) then
          write(lo,*) ' rmax = rmin '
          return
      endif
      call sortall3(1,dijs,1,numsort,jorde1)
      if (rmin.lt.0.0) then
          rmax=amax1(rmax,abs(rmin))
          rmin=-1.0*rmax
      endif
      rmaxg=rmax
      rming=rmin
      if (rmax1.gt.0.0) then
          rmax=rmax1
          if (rmin.lt.0.0) rmin=-1.0*rmax
      endif

c--
      dev=rmax-rmin
      iaa=nint(dev)
      rang=float(nrang)
      if (iaa.gt.0) then
          dev=float(iaa)/rang
      else
          dev=dev/rang
      end if
      if (rmin.ge.0.0) then
          range(1)=float(int(10.*rmin))/10.
          range(1)=rming                     ! gianluca 9/giugno/2017
          do i=2,nrang
             range(i)=range(i-1)+dev
          enddo
      else
          range(1)=float(nint(10.*rmin))/10.
          nrangi=nint(rang/2.0)
          nrang=2*nrangi
          dev=rmax-rabs
          dev=dev/float(nrangi)
          do i=2,nrangi-1
             range(i)=range(i-1)+dev
          enddo
          range(nrangi)=-rabs
          range(nrangi+1)=rabs
          do i=nrangi+2,nrang
             range(i)=range(i-1)+dev
          enddo
      endif
c     range(1)=rmin
      range(1)=rming
      nrang=nrang+1
      range(nrang)=rmax
      range(nrang+1)=rmaxg
!cris
      if (knw == 2) then
          range(1) = 0.0
          do i=2,nrang1 + 1
              range(i) = range(i-1) + 0.1
          end do
      end if
c--
c--
      n=2
      do i=1,numsort
         k=jorde1(i)
         jh = khl(1,k)
         jk = khl(2,k)
         jl = khl(3,k)
         shiftp=jh*shiftexam(1)+jk*shiftexam(2)+jl*shiftexam(3)
         shiftp=360.* shiftp + ia(k)
         dif1=shiftp - ib(k)
         dif2=shiftp + ib(k)
         dif1=abs(amod(dif1,360.))
         if (dif1.gt.180.)dif1=360.-dif1
         dif2=abs(amod(dif2,360.))
         if (dif2.gt.180.)dif2=360.-dif2

   17    if (dijs(i).le.range(n)) then
             his(n)=his(n)+1
         else
             n=n+1
             if (n.gt.nrang) n=nrang+1
             goto 17
         endif
         disa1(n)=disa1(n)+dif1
         disa2(n)=disa2(n)+dif2
         disb1(n)=disb1(n)+dif1*c(k)
         disb2(n)=disb2(n)+dif2*c(k)
         cmed(n)=cmed(n)+c(k)
      enddo
*-----cumulative
      cumerp1(nrang+1)=disb1(nrang+1)
      cumerp2(nrang+1)=disb2(nrang+1)
      ccmed(nrang+1)=cmed(nrang+1)
      do i=1,nrang
         cumerp1(nrang+1-i)=cumerp1(nrang+2-i)+disb1(nrang+1-i)
         cumerp2(nrang+1-i)=cumerp2(nrang+2-i)+disb2(nrang+1-i)
         ccmed(nrang+1-i)=ccmed(nrang+2-i)+cmed(nrang+1-i)
      enddo
*-----
      do i=1,nrang+1
         if (his(i).gt.0) then
             itot=itot+his(i)
             sumdif1=sumdif1+disa1(i)
             sumdif2=sumdif2+disa2(i)
             sumdisb1=sumdisb1+disb1(i)
             sumdisb2=sumdisb2+disb2(i)
             sumc=sumc+cmed(i)
             sumsegni=sumsegni+csegni(i)
             disa1(i)=disa1(i)/float(his(i))
             disa2(i)=disa2(i)/float(his(i))
             disb1(i)=disb1(i)/cmed(i)
             disb2(i)=disb2(i)/cmed(i)
             csegni(i)=csegni(i)/float(his(i))
             csegni(i)=100.*csegni(i)
         else
             disa1(i)=0.0
             disa2(i)=0.0
             disb1(i)=0.0
             disb2(i)=0.0
             csegni(i)=0.0
             cmed(i)=0.0
         endif
      enddo
      if (itot.le.0) then
          write(lo,*) ' itot = 0'
          return
      endif
      tot=float(itot)
      segnim=100.*sumsegni/tot
      dif1m=sumdif1/tot
      dif2m=sumdif2/tot
      disb1m=sumdisb1/sumc
      disb2m=sumdisb2/sumc
c-----cumulative 
      cumde(nrang+1)  =his(nrang+1)
      cumse(nrang+1)  =float(his(nrang+1))*csegni(nrang+1)
      cumerr1(nrang+1)=float(his(nrang+1))*disa1(nrang+1)
      cumerr2(nrang+1)=float(his(nrang+1))*disa2(nrang+1)
      do i=1,nrang
         cumde(nrang+1-i)  =cumde(nrang+2-i)+his(nrang+1-i)
         cumse(nrang+1-i)  =cumse(nrang+2-i)+csegni(nrang+1-i)*
     *                      float(his(nrang+1-i))
         cumerr1(nrang+1-i)=cumerr1(nrang+2-i)+disa1(nrang+1-i)*
     *                      float(his(nrang+1-i))
         cumerr2(nrang+1-i)=cumerr2(nrang+2-i)+disa2(nrang+1-i)*
     *                      float(his(nrang+1-i))
      enddo

      if (knw.eq.1) write(lo,200) tirang
      if (knw.eq.0) write(lo,250) tirang
      if (knw.eq.2) write(lo,250) tirang
      do i=2,nrang+1
         if (his(i).eq.0) cycle
         if (knw > 0)then
             if (shiftexam(4).gt.0.) then
                 write(lo,100) range(i-1),range(i),his(i),
     *                 disa1(i),disb1(i),cumde(i),
     *                 cumerr1(i)/float(cumde(i)),cumerp1(i)/ccmed(i)
             else
                 write(lo,100) range(i-1),range(i),his(i),
     *                 disa2(i),disb2(i),cumde(i),
     *                 cumerr2(i)/float(cumde(i)),cumerp2(i)/ccmed(i)
             endif
         else
             write(lo,150) range(i-1),range(i),his(i),cumde(i)
         endif
      enddo

      write(lo,"(24x,42('.'))")
      if (knw.gt.0) then
          if (shiftexam(4).gt.0.) then 
              write(lo,300)itot,dif1m,disb1m
         else
              write(lo,300)itot,dif2m,disb2m
          endif
      else
          write(lo,300)itot
      end if
  100 format(f10.4,'  - ',f10.4,i8,2f7.2,'  |',i8,2f7.2)
  150 format(f10.4,'  - ',f10.4,i8,'  |',i8)
  200 format(/,11x,a11,6x,' HIS',
     *      '  <err> <w-err>',' | ',
     *      '    CUM',
     *      '  <err> <w-err>')
  250 format(11x,a11,6x,'HIS',3x,'CUM')
  300 format(34x,i8,2f7.2,/)
c
      ipher = 0
      DEALLOCATE (dijs, jorde, jorde1, stat = ierr)
      if (ierr.ne.0) then
          write(*,*) 'PherrDisNew DeAllocation Error'
          call cstop(' ')
      endif
c
      return
      end
c------------------------------------------------------------------
      subroutine weightsdis(tirang,dij,khl,nrif,ic,
     *                      ia,ib,c,nrang1,rmax11,ipher)
! --- (tirang,wt,khl,numbMax,izero,
!                       ipub,iphaz,tmpwt,10,0.0,ipher)
      USE General
      USE PhaseModule
!
      dimension khl(3,nrif)
      dimension ia(nrif),ib(nrif),c(nrif),dij(nrif)
      dimension his(201),cumde(201),range(201),
     * disa1(201),disb1(201),disa2(201),disb2(201),
     * cumerr1(201),cumerr2(201),cumerp1(201),cumerp2(201),
     * csegni(201),cumse(201),cmed(201),ccmed(201)
      character tirang*11
      integer his,cumde,ierv(2)

      real, allocatable    :: dijs(:)
      integer, allocatable :: iorde1(:)

c--
      if (ipher.eq.0) return   ! ipher = 1 esegue la statistica
      if (knw.eq.0) return
      if (nrif.le.0) then
         write(lo,*) ' nrif = 0'
        return
      endif
c--
      ierv(:) = 0
      IF (.NOT. ALLOCATED(dijs))
     *    ALLOCATE (dijs(1:nreflDim),  stat = ierv(1))
      IF (.NOT. ALLOCATED(iorde1))
     *    ALLOCATE (iorde1(1:nreflDim),stat = ierv(2))
      ierr = sum(iabs(ierv(:)))
      if (ierr.ne.0) then
          write(lo,*) 'WeightsDis Allocation error'
          call cstop(' ')
      endif

      nrang=10
      rmax1=rmax11
      if (nrang1.gt.0) nrang=nrang1
      if (nrang1.gt.200) nrang = 200
      itot=0
      sumsegni=0.0
      sumdif1=0.0
      sumdisb1=0.0
      sumdif2=0.0
      sumdisb2=0.0
      sumc=0.0
      do i=1,201
         range(i)=0.0
         his(i)=0
         cumde(i)=0
         cumse(i)=0.0
         csegni(i)=0.0
         cmed(i)=0.0
         disa1(i)=0.0
         disb1(i)=0.0
         cumerr1(i)=0.0
         cumerp1(i)=0.0
         disa2(i)=0.0
         cumerr2(i)=0.0
         cumerp2(i)=0.0
         disb2(i)=0.0
         ccmed(i)=0.0
      enddo
      rmin=99999.
      rabs=99999.
      rmax=-99999.
      ii=0
      do 5 i=1,nrif
       if (i.le.ic) goto 5
       kk=i
       if (kk.eq.0.or.kk.gt.nrif) write(6,*)kk
!      if (c(kk).le.0.0.or.dij(kk).eq.0.0) goto 5
       ii=ii+1
       dijs(ii)=dij(kk)
       iorde1(ii)=kk
       if (abs(dij(kk)).lt.rabs) rabs=abs(dij(kk))
       if (dij(kk).lt.rmin) rmin=dij(kk)
       if (dij(kk).gt.rmax) rmax=dij(kk)
    5 continue
      numsort=ii
      if (rmax.eq.rmin) return 
      if (numsort.eq.0) return 
      call sortall3(1,dijs,1,numsort,iorde1)
      nsogrmax=nint(0.99*numsort)
      rmax1=dijs(nsogrmax)
      if (rmin.lt.0.0) then
          rmax=amax1(rmax,abs(rmin))
          rmin=-1.0*rmax
      endif
      rmaxg=rmax
      rming=rmin
      if (rmax1.gt.0.0) then
        rmax=rmax1
        if (rmin.lt.0.0)rmin=-1.0*rmax
      endif

c--
      dev=rmax-rmin
      iaa=nint(dev)
      rang=float(nrang)
      if (iaa.gt.0) then
          dev=float(iaa)/rang
      else
          dev=dev/rang
      end if
      if (rmin.ge.0.0) then
         range(1)=float(int(10.*rmin))/10.
         do 12 i=2,nrang
            range(i)=range(i-1)+dev
  12     continue
      else
         range(1)=float(nint(10.*rmin))/10.
         nrangi=nint(rang/2.0)
         nrang=2*nrangi
         dev=rmax-rabs
         dev=dev/float(nrangi)
         do 13 i=2,nrangi-1
            range(i)=range(i-1)+dev
  13     continue
         range(nrangi)=-rabs
         range(nrangi+1)=rabs
         do 14 i=nrangi+2,nrang
            range(i)=range(i-1)+dev
  14     continue
      endif
      range(1)=rming
      range(nrang)=rmaxg
c--
      n=2
      do 15 i=1,numsort
        k=iorde1(i)
        jh = khl(1,k)
        jk = khl(2,k)
        jl = khl(3,k)
        shift=jh*shiftexam(1)+jk*shiftexam(2)+jl*shiftexam(3)
        shift=360.* shift + ia(k)
        dif1=shift - shiftexam(4)*ib(k)
        dif2=shift + ib(k)
        dif1=abs(amod(dif1,360.))
        if (dif1.gt.180.)dif1=360.-dif1
        dif2=abs(amod(dif2,360.))
        if (dif2.gt.180.)dif2=360.-dif2

   17   if (dijs(i).le.range(n)) then
            his(n)=his(n)+1
        else
            n=n+1
            if (n.gt.nrang) n=nrang+1
            goto 17
        endif
       disa1(n)=disa1(n)+dif1
       disa2(n)=disa2(n)+dif2
       disb1(n)=disb1(n)+dif1*c(k)
       disb2(n)=disb2(n)+dif2*c(k)
       cmed(n)=cmed(n)+c(k)
   15 continue

      do i=1,nrang-1
        args=0.5*(range(i) + range(i+1))
        args=min(args,1.0)
        csegni(i)=rtod*acos(args)
        args=sum(range(i:nrang))
        args=args/float(nrang-i+1)
        args=min(args,1.0)
        cumse(i)  = rtod*acos(args)
      enddo

*-----cumulative
      cumerp1(nrang)=disb1(nrang)
      cumerp2(nrang)=disb2(nrang)
      ccmed(nrang)=cmed(nrang)
      do i=1,nrang-1
        cumerp1(nrang-i)=cumerp1(nrang+1-i)+disb1(nrang-i)
        cumerp2(nrang-i)=cumerp2(nrang+1-i)+disb2(nrang-i)
        ccmed(nrang-i)=ccmed(nrang+1-i)+cmed(nrang-i)
      enddo
*-----
      do 20 i=1,nrang
         if (his(i).gt.0) then
            itot=itot+his(i)
            sumdif1=sumdif1+disa1(i)
            sumdif2=sumdif2+disa2(i)
            sumdisb1=sumdisb1+disb1(i)
            sumdisb2=sumdisb2+disb2(i)
            sumc=sumc+cmed(i)
            sumsegni=sumsegni+csegni(i)
            disa1(i)=disa1(i)/float(his(i))
            disa2(i)=disa2(i)/float(his(i))
            disb1(i)=disb1(i)/cmed(i)
            disb2(i)=disb2(i)/cmed(i)
         else
            disa1(i)=0.0
            disa2(i)=0.0
            disb1(i)=0.0
            disb2(i)=0.0
            cmed(i)=0.0
         endif
   20 continue
      if (itot.le.0) return
      tot=float(itot)
      dif1m=sumdif1/tot
      dif2m=sumdif2/tot
      disb1m=sumdisb1/sumc
      disb2m=sumdisb2/sumc
c-----cumulative 
      cumde(nrang)  =his(nrang)
      cumerr1(nrang)=float(his(nrang))*disa1(nrang)
      cumerr2(nrang)=float(his(nrang))*disa2(nrang)
      do 25 i=1,nrang-1
        cumde(nrang-i)  =cumde(nrang+1-i)+his(nrang-i)
        cumerr1(nrang-i)=cumerr1(nrang+1-i)+disa1(nrang-i)*
     *                   float(his(nrang-i))
        cumerr2(nrang-i)=cumerr2(nrang+1-i)+disa2(nrang-i)*
     *                   float(his(nrang-i))
   25 continue

      if (knw.eq.1) write(lo,210)tirang
      if (knw.eq.0) write(lo,250)tirang
      do 30 i=2,nrang+1
      if (his(i).eq.0) go to 30
      if (knw.gt.0 )then
       csegni1=csegni(i-1)
       cumse1=cumse(i-1)
        write(lo,110) range(i-1),range(i),his(i),csegni1,
     *                disa1(i),disb1(i),
     *                cumde(i),cumse1,
     *                cumerr1(i)/float(cumde(i)),cumerp1(i)/ccmed(i)
      else
      write(lo,150) range(i-1),range(i),his(i),cumde(i)
      endif
   30 continue
      write(lo,"(24x,42('.'))")
      if (knw.gt.0) then
       write(lo,310)itot,cumse(1),dif1m,disb1m
      else
       write(lo,300)itot
      end if
  100 format(f10.4,'  - ',f10.4,i7,5f7.2,' |',i7,5f7.2)
  110 format(f10.4,'  - ',f10.4,i7,3f7.2,' |',i7,3f7.2)
  150 format(f10.4,'  - ',f10.4,i7,' |',i7)

  210 format(11x,a11,6x,'HIS',1x,'<err>c',
     *      '  <err> <w-err>','|',
     *      '   CUM',2x,'<err>c',
     *      '  <err> <w-err>')

  250 format(11x,a11,6x,'HIS',3x,'CUM')
  300 format(24x,i7,5f7.2,/)
  310 format(24x,i7,3f7.2,/)
c
      ipher = 0
      DEALLOCATE (dijs, iorde1, stat = ierr)
      if (ierr.ne.0) then
          write(*,*) 'WeightsDis DeAllocation Error'
          call cstop(' ')
      endif
!
      return
      end
!------------------------------------------------------------------
      subroutine to_coord_sir(kdstampa, numb)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE PhaseModule
      USE TestModel
      USE Dialogo, only: ModelToCompare
      USE Molcom, only: ifViewModel, rm
*     USE CorrMod, only: inLSQ_Bias ! dedi
      USE Groups, only: nResidStored
!
      integer :: stessiResidui, residuoPub, residuoNow, perc1, perc2
      common/cat/tipo
      common/rosanna/itot
      common /maximo/ dmean,origv(3),npeak,maxpeaks,ntop,nghost,sirpeak
      character*5 sirpeak
      dimension vet(40),ivet(40)
      character tipo*2,line*80,dire*80
      character a
      character patom*256
      character*4 lSpecies(18)
      real xn(3), xo(3), xeq(3), s(3), xyzMin(3)
      character segnochar
      logical Esiste
      character (len=4) :: a4
!
      stessiResidui = 0
      vett_test(:) = 0
      if (knw <= 0 .or. ifNoMatch == 1) then ! dedi
          return
      endif
      if (ifTime == 1) then
          return
      endif
*     if (inLSQ_Bias == 1) then ! dedi
*         if (kdstampa >= 0) then
*             kdstampa = 0
*         endif
*     endif

      if (.not.allocated(coordSir)) then
          call AllocaTestModel(1)
          if (ModelToCompare /= 0) then
              call Save_Restore_Modello_Publ(2)
          endif
      endif
      do i=1, nk
         lSpecies(i) = Species(i)
         call lcase(lSpecies(i))
      enddo
      i = 1
      do ij=1, 3
         do ji=1, 3
            gdist(i  ) = xgg(ij, ji)
            gdist(i+9) = xgr(ij, ji)
            i = i + 1
         enddo
      enddo
!
c     if (kstampa.ne.99991) return
      if (iprin.gt.0) then
        kstampa=1
      else
        kstampa=kdstampa
      endif
      nsym_Save = nsym
      nats_Save = nats
      if (nats > MaxAtoms) then
          nats = MaxAtoms
      endif
      nc = nats
      k = size(coordSir(1,:))
      if (nats > k) then
*         deallocate(coordSir, stat=ier)
*         allocate(coordSir(1:4, 1:nats), stat=ier)
          call AllocaTestModel(2)
          MaxAtoms = nats
          call AllocaTestModel(1)
       endif
!
      if (ModelToCompare == 0) then
          if (FraFilePath(1:1) /= ' ') then
              inquire (file=FraFilePath,  exist = Esiste)
              if (Esiste) then
                  call CheckModelToLoad(ier)
                  if (.not. allocated(kblock)) then
                     call AllocaAtomi(1) 
                  endif
              endif
          else
              call spy(patom)
          
! per file nello stesso direttorio
!modhh
              inquire (file=patom,  exist = Esiste)
              if (.not. Esiste) then
                  k=index(fname(1),'.bin')
                  patom = fname(1)(1:k)//'fra'
                  FraFilePath = ' '
              endif
!modhh
! per file nello stesso direttorio

!
! --- legge il file .fra
!
*             write(lo,*) 'TO_COORD, file is',patom
              open(unit=kform,file=patom,status='old',err=8000)
!
              call AllocaTestModel(1)
              natspub=0
              do
                 read(kform,'(a)',end=2) line
                 call shift(line,ls)
                 iasc = ichar(line(1:1))
                 if (iasc .eq. 26) then
                     exit
                 end if
                 a = line(1:1)
                 if (a == '!' .or. a == '>') then
                     cycle
                 end if
                 natspub=natspub+1
                 natcoo=natspub
                 call cutst(line,lenp,dire,lend)
                 call lcase(dire)
                 nzPub(natcoo) = 0
                 lend = 2
                 do i=1, nk
                    if (lSpecies(i)(1:lend) == dire(1:lend)) then
                        nzPub(natcoo) = i
                        exit
                    endif
                 enddo
                 lend = 4
                 aLabPub(natcoo) = dire(1:lend)
                 iopt=0
                 call getnum(line,vet,ivet,iv,iopt)
                 do i=1,3
                    coordPub(i,natcoo)=vet(i)
                 enddo
                 cycle
              enddo
    2         close(kform)
              nCoordPub = natcoo
              ModelToCompare = 1
          endif
      else
          natcoo = nCoordPub
      endif
      if (ModelToCompare == 0) then
          return
      endif
!
! --- calcolo gli shift
!
      shiftexam(1:7) = 0.0
      shiftexam(4)   = 1.0
      izero = 0
      ifmin = kdstampa  ! 1   !kstampa
      if (kdstampa > 0) then
          ifmin = 1
      else
          ifmin = 0
      endif
      if (kverbo == 0) then
          ifmin = 0
      endif
      if (kdstampa /= 99 ) then
          nbru = 4321
          call examin(nbru,mkang,khl,ipub,iphaz,numb,izero,wt,ifmin)
      endif
!
! --- ngost = numero di ghost tra i picchi SIR
!
      ngost=0
      do j=1,nats
         if (iabs(nz(j)).lt.nzConst) then
             izpki=iabs(nz(j))
         else
             izpki=iabs(nz(j))/nzConst
         endif
         if (izpki.eq.0.or.izpki.gt.nk) ngost=ngost+1
      enddo
      if (ngost.eq.nats) then
          do i=1,nats
             nz(i)=nzConst
          enddo
          ngost=0
      endif
!
! --- applica lo shift alle coordinate SIR
!
!*!   write(6,*) 'TO_COORD',shiftexam
      do j=1,nats
!*!      write(6,'(i5,1h),5f10.4)') j, xyzs(1:5,j)
         if (CaOnly) then
             do i=1,3
                coordSir(i,j) = xyzs(i,j) - shiftexam(i)
             enddo
         else
             do i=1,3
                if (shiftexam(4).gt.0.0) then
                    coordSir(i,j) = xyzs(i,j) - shiftexam(i)
                else
                    coordSir(i,j) = - ( xyzs(i,j) + shiftexam(i))
                endif
             enddo
!*!          write(6,'(i5,1h),6f10.3)') j, xyzs(1:3,j),coordSir(1:3,j)
         endif
         coordSir(4,j) = xyzs(4,j)
      enddo
!
      npunt(:)  = 0
      kblock(:) = 0
!
! --- calcola le distanze minime
!
      if (CaOnly) then
          natc = 0
          do i=1, nats
             k = index(aLab(i),'_')
             if (k > 0) then
                 a4 = aLab(i)(1:k-1)
                 call ucase(a4)
                 if (nResidStored > 0) then
                     if (a4 /= 'CA  ') then
                         xyzs(4,i) = -xyzs(4,i)
                     else
                         natc = natc + 1
                     endif
                 else
                     if (a4 /= 'P   ') then
                         xyzs(4,i) = -xyzs(4,i)
                     else
                         natc = natc + 1
                     endif
                 endif
             endif
          enddo
      endif
      aatoms = 0.0
      dmedia = 0.0
      distRms(:) = 0
      do i=1, nCoordPub
         if (mod(i,10) == 0) then
            call DoSingleIteration()
         endif
         if (CaOnly .and. tipoPub(i) < 300) then
             jpunt = 0
             cycle
         endif
         residuoPub = mod(tipoPub(i), 300)
         xo(1:3) = coordPub(1:3,i)
         if (lproj > 0) xo(lproj) = 0.0
         distm=9999
         jpunt = 0
         distmA=9999
         jpuntA = 0
         do j=1,nats
            if (xyzs(4,j) < 0.0) cycle
            residuoNow = nomeResiduo(j)
            if (npunt(j).eq.0) then
                xn(1:3) = coordSir(1:3,j)
                if (lproj > 0) xn(lproj) = 0.0
!
                do k=1, nsymTot
                   kt = -1
                   call xequiTot(k, xn, xeq, kt)
                   call xdist(xo, xeq, d, s)
                   if (d < distmA) then
                       distmA = d
                       jpuntA = j
                   endif
                   if (d < distm .and. d < distCoord) then
                       distm = d
                       jpunt = j
                       xyzMin(1:3) = xeq(1:3)
                   endif
                enddo
!
            endif
         enddo
         distRms(i) = distmA
         if (jpunt.ne.0) then
             npunt(jpunt) = i
             distv(jpunt) = distm
             call PosizioneAssoluta(xyzMin, xo)
             coordSir(1:3,jpunt) = xyzMin(1:3)
             aatoms = aatoms + 1
             dmedia = dmedia + distm
             residuoNow = nomeResiduo(jpunt)
             if (CaOnly) then
                 if (residuoPub == residuoNow) then
                     stessiResidui = stessiResidui + 1
                 endif
             endif
         else
             if(jpuntA>0) distv(jpuntA) = distmA
         endif
         if (jpuntA.ne.0) then
             xyzs4(jpuntA) = distmA  ! per uso statistico fuori to_coor
         endif
      enddo
      rmsd = sqrt(dot_product(distRms(:nCoordPub),distRms(:nCoordPub))
     */nCoordPub)

      if (aatoms.gt.0) then
          adistmean = dmedia / aatoms
          naatoms = nint(aatoms)
      else
          adistmean = 0.0
          naatoms = 0
      endif
      if (CaOnly) then
          perc1 = nint( 100.0*float(naatoms)/float(nCaPub) )
          perc2 = nint( 100.0*float(stessiResidui)/float(nCaPub) )
      else
          perc1 = nint( 100.0*float(naatoms)/float(nCoordPub) )
      endif
      if (kdstampa >= 0) then
          if (shiftexam(4) > 0.0) then
              segnochar = '+'
          else
              segnochar = '-'
          endif
          if (rmsd > 99) then
              rmsd = 99.999
          endif
          if (CaOnly) then
*???*         segnochar = '+'
              perc1 = nint( 100.0*float(naatoms)/float(nCaPub) )
              perc2 = nint( 100.0*float(stessiResidui)/float(nCaPub) )
              if (nResidStored > 0) then
                  write(lo,110) nCaPub, natc, naatoms,
     *                  perc1, stessiResidui, perc2,
     *                  erm1, isumal, distCoord, adistmean, rmsd
              else
                  write(lo,120) nCaPub, nNucleiTarget,
     *                  natc,  nNucleiModel, naatoms,
     *                  perc1, stessiResidui, perc2,
     *                  shiftexam(1:3), segnochar,
     *                  erm1, isumal, distCoord, adistmean, rmsd
              endif
          else
              perc1 = nint( 100.0*float(naatoms)/float(nCoordPub) )
              write(lo,100) nats, nCoordPub, naatoms, perc1, 
     *              shiftexam(1:3), segnochar, erore, isumal, distCoord,
     *              adistmean, rmsd
          endif
      endif
      if (CaOnly) then
          vett_test(1) = nCaPub
          vett_test(2) = natc
          vett_test(6) = stessiResidui
          vett_test(7) = perc1
          vett_test(8) = perc2
      else
          vett_test(1) = nCoordPub
          vett_test(2) = nats
          vett_test(7) = perc1
      endif
      vett_test(3) = naatoms
      vett_test(4) = adistmean
      vett_test(5) = rmsd
  100 format('SIR coordinates    ',i6,/,
     *       'Target coordinates ',i6,/,
     *       'Matches found      ',i6,i6,'%',5x,
     *       'Shift applied      ',3f6.3,'  Sign is ',a1,/,
     *       'Mean Phase Error   ',f7.3,' using ',i8,' reflections',/,
     *       'Distance limit:    ',f6.3,/,
     *       '<Dist> among found ',f6.3,/,
     *       'RMSD               ',f6.3)
  110 format('C-Alpha in target  ',i6,/,
     *       'C-Alpha in model   ',i6,/,
     *       'Matches found      ',i6,i6,'%',5x,
     *       ' (Identical ',i6,i6,'%)'/,
*    *       'Shift applied      ',3f6.3,'  Sign is ',a1,/,
     *       'Mean Phase Error   ',f7.3,' using ',i8,' reflections',/,
     *       'Distance limit:    ',f6.3,/,
     *       '<Dist> among found ',f6.3,/,
     *       'RMSD               ',f6.3)
  120 format('P atoms in target  ',i6,'   Nucleotides in target  ',i6,/,
     *       'P atoms in model   ',i6,'   Nucleotides in model   ',i6,/,
     *       'Matches found      ',i6,i6,'%',5x,
     *       ' (Identical ',i6,i6,'%)'/,
     *       'Shift applied      ',3f6.3,'  Sign is ',a1,/,
     *       'Mean Phase Error   ',f7.3,' using ',i8,' reflections',/,
     *       'Distance limit:    ',f6.3,/,
     *       '<Dist> among found ',f6.3,/,
     *       'RMSD               ',f6.3)
      if (kdstampa > 0) then
         if (naatoms > 0) then
             if (kdstampa /= 2) then
                 write(lo,200)
             else
                 if (ifProcAB /= 0) then
                     write(lo,210)
                 endif
             endif
         endif
         do j=1,nats
            if (npunt(j).ne.0) then
                l = npunt(j)
                if (kdstampa /= 2) then
                    write(Buffer1,300) 
     *             aLab(j),nint(coordSir(4,j)),(coordSir(k,j),k=1,3),
     *             distv(j),
     &             (coordPub(k,l),k=1,3),aLabPub(l)
                    write(lo,'(a)') Buffer1(1:Lung(Buffer1))
                else
                   if (ifProcAB /= 0 .and. nz(j) > 0) then
                       write(lo,310)
     *                 j,(coordSir(k,j),k=1,4),aLabPub(l),l,
     &                 (coordPub(k,l),k=1,3),distv(j)
                   endif
                endif
            endif
         enddo
      endif
  200 format('----------- SIR coordinates  -----------   ',
     *       ' Distance  ---- Target coordinates ----')
  300 format(a16,i4,3f7.3,f10.5,2x,3f7.3,3x,a16)
  210 format('  -------- SIR peaks  ------------             ',
     *       '--------- publ. coord. ---------    distance')
  310 format(i6,2x,3f6.3,f10.0,3x,a16,i6,2x,3f6.3,f10.5)
!
!modhh
c     avdist=0.0
c     nh=0
c     do j=1,nats
c       if (npunt(j).ne.0) then
c           l = npunt(j)
c           if(aLabPub(l)=='h') then
c              avdist=avdist+distv(j)
c              nh=nh+1
c           endif
c       endif
c     enddo
c     if(nh>0) then
c       avdist=avdist/float(nh)
c     else
c       avdist=9999.
c     endif
c     write(6,'(a,i8,f10.3)') 'HYDROGEN',nh,avdist
c     write(0,'(a,i8,f10.3)') 'HYDROGEN',nh,avdist
!modhh
!
      nsym = nsym_Save
      nats = nats_Save
!
      do i=1, nCoordPub
         xo(1:3) = coordPub(1:3,i)
         call MoltMatVec(rm, xo, xn)
         xyzPub(1:3,i) = xn(1:3)
      enddo
      do i=1,nats
         if (npunt(i).ne.0) then
            kblock(i) = 1
         endif
      enddo
!
      if (CaOnly) then
          do i=1, nats
             xyzs(4,i) = abs(xyzs(4,i))
          enddo
      endif
!
      call toflush()
      return
!
 8000 continue
      nsym = nsym_Save
      nats = nats_Save
      kpatom = Lung(patom)
      write(6,*) ' ERROR in file: ',patom(1:kpatom)
      write(6,*) 'Match between SIR model and fragment is not possible!'

      return
      end
c----------------------------------------------------------
      subroutine spy(patom)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE PhaseModule
!
      character name*80, patom*256
      character*3 esten
!
      esten = 'fra'
      name = ''
!
! --- definisce il nome ed il path del file .fra
!
      kpath = Lung(FraFilePath)
      ifName = 0
      if (kpath < 1) then
          if (ifW95 == 0) then
              if (ksize > 3) then
                  FraFilePath = '/server/public/proteins/frag/'
              else
                  FraFilePath = '/server/public/strutture/frag/'
              endif
              if (ifVLD == 1) then
                  FraFilePath = ReflFilePath
              endif
          else
              FraFilePath = ReflFilePath
          endif
          kpath = Lung(FraFilePath)
          if (ifName <= 0) then
              k = index(fname(1), '.bin')
              ipu1 = index(fname(1), char(47), .TRUE.)
              ipu2 = index(fname(1), char(92), .TRUE.)
              if (ipu1 > 0) then
                 name = fname(1)(ipu1+1:k) // 'fra'
              elseif (ipu2 > 0) then
                 name = fname(1)(ipu2+1:k) // 'fra'
              else
                 name = fname(1)(1:k) // 'fra'
              end if
              if (kmad /= 0) then
                 Lnnb = len_trim(ReflFilePath)
                 if (Lnnb > 0) then
                    patom = ReflFilePath(1:Lnnb) // name
                 else
                    patom = name
                 end if
              else
                 patom = FraFilePath(1:kpath) // name
                 FraFilePath = patom
              end if
              if (neutro /= 0) then
                  patom = name
              endif
          else
              patom = FraFilePath
          endif
      else
          patom = FraFilePath
*         ifName = index(FraFilePath, '.fra', .TRUE.)
      endif
      ipu1 = index(patom, '.fra', .TRUE.)
      if (ipu1 > 0) then
          ipu1 = ipu1 + 1
          patom(ipu1:) = esten
      else
          patom = patom(1:len_trim(patom)) // name
      endif
!
      return
      end
!---------------------------------------------------------------------
