!-----------------------------------------------------------------------
!     List of subroutines (S) & functions (F) in this file
!-----------------------------------------------------------------------
!
!-- Routines related to graphic
!
! S    InitGraphics(iz)         !mrmrmr obsoleta
! S    PassaParametro(iquale,str)
! S    OpenWindow(str, iz)
! S    StartGtkMainLoop(iflag,ier)
! S    EnableSingleIteration(iflag)
! S    DoSingleIteration()
! S    SetWindowTitle (string)
! S    AllocaColori()            i!mrmrmr Obsolete, to be deleted
! S    PrintMess(Message)
! S    ClearMessage
! S    PassaSpecie(str,iflag,nk)
! S    NewPage
! S    SetColor(iColor)
! S    Punto (ix1, iy1, iColor)
! S    Linea (ix, iy, ix2, iy2, iColor)
! S    Linea_dash (ix, iy, ix2, iy2, iColor)
! S    Linea0(x, y, x2, y2, iColor)
! S    LineaSpessa(ix1, iy1, ix2, iy2, iColor, iRaggio)
! S    LineaSpessa2(ix1, iy1, ix2, iy2, iColor, iRaggio)
! S    LineaSfumata(ix1, iy1, ix2, iy2, iColor, iRaggio)
! S    Rettangolo (ix1, iy1, ix2, iy2, ic1, ic2)
! S    Poligono (numVert, iColore, iFill)
! S    RettangoloSpeciale (iColore, iQuale, Label)
! S    Star(X11,Y11)
! S    Croce (ix1, iy1, iSize, iColor, itypecross)
! S    Cerchio (ix1, iy1, Radius, iColor, IfFill, iFillColor)
! S    Cerchio_dash (ix, iy, ir, iColor)
! S    Ellisse_dash (ix, iy, AsseX, AsseY, Start, Len, iColor)
! S    Arco_dash (ix, iy, ir, iniz, ifin, iColor)
! S    MettiPixmap(string, ix, iy)
! S    Palla(ix, iy, iq, iraggio, ic1, ixlux, iylux)
! S    Togo(ifHB, iRaggio, iC1, iC2)
! S    XBox (jx1, jy1, jx2, jy2, inSet, ifFrame)
! S    AllocaGBuffer(iflag)
! S    DrawLabel (ix1, iy1, string, iColor)  draw horizontal string
! S    DrawLabelV(ix1, iy1, string, iColor)  draw vertical string
! F    LenInPix(str,size)                     Lenght of a string in pixels
! F    LenInPix2(str,nChars,size)             Lenght of a string in pixels
! S    text_mode(flag)
!
!-- Files related routines
!
! S    LeggiXENHeader                         get info from XEN header
! S    CheckRecordLength
! F    jopen(ncsu,name,istat,iform,ier)       Open sequential file
! F    kopen(ncsu,name,nlenBin,itype,ier)     Open direct access file
! S    cRemoveFile(FileName)                  Remove file
! S    cRemoveDir(DirName)                    Remove directory
! S    RemoveFile                             Remove file in Msg
!
!-- Sort routines
!
! S    sortz(lind,numb,iblk,jump)   (moved in sirprot)
! S    sortz_dyn(vettore,idim,lind,numb,iblk,jump)
! S    sort3 (alf, iorde, numb)               decreasing order (max 4000 items)
! S    sort3_big(alf, iorde, tmp, numb)       decreasing order (no limit)
! S    sortall(isort,x,numb)
! S    sort_index(isort, x, iorde, numb)      sort only index
! S    sortall2(x,ix,icam,n1,nnn,iord)
! S    sortall3(isort,x,numbx,numb,iorde)
! S    sort3_int(ialf, iorde, numb)
! S    sort3_int8(ialf, numb)                 sort on integer*8 array
! S    sortco (st1,list2,n)
! S    sortf(xyzs,nrighe,natomi,n)
!
!-- Time & date routines
!
! S    CPUTime(string)
! S    CPUTime0(string)
! S    sirtime(string,lstring)
! S    sirdate(string,lstring)
! S    elapsed_time(Action, elTime, routine, buffer)
! S    elapsed_time_tot(Action, elTime, routine, buffer)
!
!-- String related routines
!
! S    ucase(line)                       Convert a string in upper case
! S    lcase(line)                       Convert a string in lower case
! S    filtra(string)                    Eliminates ^M in a string
! S    getnum(linei,vet,ivet,iv,iopt)    Get numerical values from a string
! S    shift(string,lenp)                Left shift of a string
! S    cutst(string,lens,dire,lend)      Cut a string with respect to the first blank
!                                        Leftmost string in dire, remainder in string
! S    CentraStr(icode,nchar,line,str)   Center a string
! S    ltrim(tmp)
! S    CutStr(tmp, iz)                   Cut a string with respect to the first blank
! F    Valore(String)                    Numrical value of a string
! F    isADigit(String)                  =1 if the character corresponds to a digit
! F    Lung(String)                      Number of chars in a string
! S    CheckBlanks(fileh, ifin)          Checks for blanks in file name
! S    CheckSpaceGroupSymbol(nSpaceG, ier)  Standardize and check Space Group Symbol
! S    StandardSPG(String,ier)           Make Space Group Symbol standard
! S    OneBlankOnly(String)              Only one blank allowed between items
! S    NoBlanks(String,ls)               Delete all blanks in String (ex xcmprp)
! S    FillBlanks(stringa,iAction,carattere) modify chars in stringa
!
!-- Numeric routines
! S    autov(a,eigen,t,icod)             
! F    ScattFact(k, rho)                 Scattering factor for k-th species at rho value
! S    besse(xx,vec)
! F    bes(x)                            Bessel function
! F    dbes(x)                           Real*8 Bessel function
! F    besinv(y)                         Inverse of a Bessel function
! F    bessel_I0(X)                      Zero order Bessel function
! S    i0(x,ri0)                         Zero order modified Bessel function
! S    cc_vet(x,y,npunti,corre)          Correlation between vectors x & y
! S    Correla_Mappe(nx,ny,nz,x1,x2,cor) Correlation between vectors x1 & x2
! F    atanh(x)                          Inverse of a hyp. tangent function
! F    sim(x)                            Calculate Sim & Srinivasan non-centric figure of merit as
!                                        I1(X)/I0(X), where I1 and I0 are the modified 1st and zero order bessel functions.
! F    siminv(y)                         inverse SIM function (slow but accurate version)
! F    acentx(x)                         given the figure of merit for a acentric reflection, return X as
!                                        defined by Hendrickson and Lattman (Acta Cryst B26, 136-143, 1970).
! F    centx(x)                          given the figure of merit of a centric reflection, return X as defined
!                                        by Hendrickson and Lattman (Acta Cryst B26, 136-143, 1970).
!
!-- Array manipulation routines
! S    MoltMatVec(a, b, c)               matrix * vector
! S    MoltVecMat(a, b, c)               vector * matrix
! S    MoltMatMat(a, b, c)               matrix * matrix
! S    inv3(a, det, v)                   integer a(3,3) matrix inversion, results in v(3,3)
! S    inv3r(a, det, v)                  real a(3,3) matrix inversion, results in v(3,3)
! S    Trasp(a, b)                       compute b, the transpose of a
! S xmtmm(a, b, c, l, m, n)
! S xmtmt(a, b, c, l, m, n)
! S xmttm(a, b, c, l, m, n)
! S xmttt(a, b, c, l, m, n)
! S xmtmr(a, b, c, l, m, n)
!
!-- Misc routines
! S    unpak3Sir(index,kod1,kod2,ifaz)
! S    unpack (index,ih,kk,il)
! F    cdist
! F    DeltaFase(phi1, phi2)             Phase difference
!-----------------------------------------------------------------------
!     GRAPHIC PRIMITIVES
!-----------------------------------------------------------------------
      subroutine InitGraphics(iz)     
      USE Molcom
! ---
      iz = 0
      ind = -1
      icolor=1
      call graphs(iz,ind,' ',icolor,icolor)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine PassaParametro(iquale,str)
      USE Molcom
! ---
      character*(*) str
!
      ind = iquale * 1000
      iz = 0
      icolor = 0
      call graphs(iz,ind,str,icolor,icolor)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine OpenWindow(str, iz)
      USE Molcom
! ---
      character*(*) str
!
      iz = 0
      ind = 1
      icolor = ifHidden
      call graphs(iz,ind,str,icolor,icolor)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine StartGtkMainLoop(iflag, ier)
      USE Molcom
! ---
      iz = 0
      ind = 999
      icol0 = 0
      call graphs(iz, ind, ' ', iflag, icol0)
      ier = iz
!
      return
      end
!-----------------------------------------------------------------------
      subroutine EnableSingleIteration(iflag)
      USE Molcom
!
      ind = 85
      iot = 0
      call graphs(iflag, ind,' ', iot, iot)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine DoSingleIteration()
      USE Molcom
!
      if (kscreen.eq.0) then
         return
      end if
      ind = 86
      iot = 0
      iz = 0
      call graphs(iz, ind,' ', iot, iot)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine AllocaColori()
      USE Molcom
!
      ind = 83
      iot = 0
      iz = 0
      call graphs(iz, ind,' ', iot, iot)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine PassaSpecie(str,iflag,nk)
      USE Molcom
!
      character*(*) str

      iColor = nk
      ind = 18
      call graphs(iz, ind, str, iColor, iflag)

!
      return
      end
!-----------------------------------------------------------------------
      subroutine Rettangolo (ix1, iy1, ix2, iy2, ic1, ic2)
      USE Molcom
! ---
      dummyString = ' '
      if (ix1.le.ix2) then
         ixv(1) = ix1
         ixv(2) = ix2
      else
         ixv(1) = ix2
         ixv(2) = ix1
      endif
      if (iy1.le.iy2) then
         iyv(1) = iy1
         iyv(2) = iy2
      else
         iyv(1) = iy2
         iyv(2) = iy1
      endif
      kx = ixv(2) - ixv(1)
      ky = iyv(2) - iyv(1)
      if (ic2 >= 0 .and. kx*ky == 0) then
          iic2 = -1
      else
          iic2 = ic2
      endif
      ind = 17
      iz = 0
      call graphs(iz,ind,dummyString,ic1,iic2)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine SetWindowTitle (string)
      USE Molcom
! ---
      character*(*) string
!
      ind = 81
      iz = 0
      idum = 0
      idum = 0
      call graphs(iz,ind,string,idum, idum)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine Poligono (numVert, iColore, iFill)
      USE Molcom
! ---
      if (iFill.eq.0) then
          ind = 14
      else if (iFill.eq.1) then
         ind = 15
      else if (iFill.eq.-1) then
         ind = 16
      end if
      call graphs(numVert,ind,' ',iColore,iColore)
      return
      end
! ----------------------------------------------------------------------
      subroutine RettangoloSpeciale (iColore, iQuale, Labb)
      USE Molcom
! ---
!     Disegna un rettangolo color iColore con hint = Labb
!     N.B. Va utilizzata all'interno di Histograms
!
      character*(*) Labb
!
      ind = 50
      call graphs(iQuale,ind,Labb,iColore,iColore)
      return
      end
! ----------------------------------------------------------------------
      subroutine ClearMessage
!
      call PrintMess(' ')
!
      return
      end
!-----------------------------------------------------------------------
      subroutine PrintMess(Message)
      USE Molcom
!
      character *(*) Message
!
      if (kscreen.eq.0) return
!
      ind = 4
      call BarraDiStato(iz,ind,ix,iy,Message)
!
      return
      end
! -----------------------------------------------------------------
      subroutine NewPage
      USE Molcom
! ---
      dummyString = '  '
      dummyString(2:2) = char(0)
      ind = 7
      iz = 1      !@ 2
      iColor = jBackGround

      call graphs(iz,ind,dummyString,iColor,iColor)
!
      return
      end
! -----------------------------------------------------------------
      subroutine Linea (ix, iy, ix2, iy2, iColor)
      USE Molcom
!
      dummyString = ' '
      ixv(1)=ix
      ixv(2)=ix2
      iyv(1)=iy
      iyv(2)=iy2
      ind = 3
      call graphs(iz, ind, dummyString, iColor, iColor)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Linea_dash (ix, iy, ix2, iy2, iColor)
      USE Molcom
!
      dummyString = ' '
      ixv(1)=ix
      ixv(2)=ix2
      iyv(1)=iy
      iyv(2)=iy2
      ind = 5
      call graphs(iz, ind, dummyString, iColor, iColor)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Cerchio_dash (ix, iy, ir, iColor)
      USE Molcom
!
      dummyString = ' '
      ixv(1)=ix - ir
      iyv(1)=iy - ir
      iz = 2*ir
      ind = 12
      call graphs(iz, ind, dummyString, iColor, iColor)
      call zflush
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Ellisse_dash (ix, iy, AsseX, AsseY, Start, Len, iColor)
      USE Molcom
!
      integer AsseX, AsseY, Start, Len
!
      dummyString = ' '
      ixv(1) = ix - AsseX
      iyv(1) = iy - AsseY
      ixv(2) = AsseX * 2
      iyv(2) = AsseY * 2
      ixv(3) = Start
      iyv(3) = Len
      ind = 22
      call graphs(iz, ind, dummyString, iColor, iColor)
      call zflush
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Arco_dash (ix, iy, ir, iniz, ifin, iColor)
      USE Molcom
!
      dummyString = ' '
      ixv(1)=ix - ir
      iyv(1)=iy - ir
      ixv(2)= iniz
      iyv(2)= ifin
      iz = 2*ir
      ind = 13
      call graphs(iz, ind, dummyString, iColor, iColor)
      call zflush
!
      return
      end
!-----------------------------------------------------------------------
      subroutine text_mode(flag)
      USE Molcom
      USE General, only: ifW95
!
      integer flag
!
      dummyString = ' '
!mr   if (flag == 1) then
      if (flag == 1 .and . ifW95 /= 1) then       !ifort 19
          write(0, '(" Thanks for using ", a)') 
     *               ProgName(1:Lung(ProgName))
          write(0, *) 'Bye'
      endif
      if (jscreen.ne.0) then
          ind = 0
          icolor = 1
          jscreen = 0
          call graphs(iz,ind,dummyString,flag,icolor)
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine SetColor(iColor)
      USE Molcom
!
      icoloresettato = iColor
      ind = 8
      ix=0
      iy=0
      call graphs(iz,ind," ",iColor,iColor)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine MettiPixmap(string, ix, iy)
      USE Molcom
!
      character*(*) string
!
      ixv(1)=ix
      iyv(1)=iy
      ind = 19
      iz = 0
      idum = 0
      call graphs(iz,ind,string,idum,idum)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Palla(ix, iy, iq, iraggio, ic1, ixlux, iylux)
      USE Molcom
!
      ixv(1) = ix 
      iyv(1) = iy
      ixv(2) = iraggio
      iyv(2) = iq  
      ixv(3) = ixlux
      iyv(3) = iylux
      ind = 31
      iz = 0
      call graphs(iz,ind,char(0),ic1,ic1)
!
      return
      end
! -----------------------------------------------------------------
      subroutine Togo(ifHB, iRaggio, iC1, iC2)
!
      USE Molcom
!
      if (ifHB == 0) then
          iz = iRaggio * 2
          ind = 32
          call graphs(iz,ind,' ',iC1, iC2)

      else
          iColor = color_CELL
          iz = -iRaggio
          ind = 32
          call graphs(iz,ind,' ',iColor, iColor)
      endif
!
      return
      end
! -----------------------------------------------------------------
      subroutine Linea0(x, y, x2, y2, iColor)
!
      USE Molcom
!
      ix  = nint( (  x + x11disp(1) ) * x11scale(1) )
      iy  = nint( (  y + x11disp(2) ) * x11scale(2) )
      ix2 = nint( ( x2 + x11disp(1) ) * x11scale(1) )
      iy2 = nint( ( y2 + x11disp(2) ) * x11scale(2) )
      iy  = iVP(4) - iy
      iy2 = iVP(4) - iy2
      call Linea (ix, iy, ix2, iy2, iColor)
!
      return
      end
! -----------------------------------------------------------------
      subroutine Linea0_dash(x, y, x2, y2, iColor)
!
      USE Molcom
!
      ix  = nint( (  x + x11disp(1) ) * x11scale(1) )
      iy  = nint( (  y + x11disp(2) ) * x11scale(2) )
      ix2 = nint( ( x2 + x11disp(1) ) * x11scale(1) )
      iy2 = nint( ( y2 + x11disp(2) ) * x11scale(2) )
      iy  = iVP(4) - iy
      iy2 = iVP(4) - iy2
      call Linea_dash (ix, iy, ix2, iy2, iColor)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine XBox (jx1, jy1, jx2, jy2, inSet, ifFrame)
      USE Molcom
!
      if (jx1.gt.jx2) then
         ix1 = jx2
         ix2 = jx1
      else
         ix1 = jx1
         ix2 = jx2
      end if
      if (jy1.gt.jy2) then
         iy1 = jy2
         iy2 = jy1
      else
         iy1 = jy1
         iy2 = jy2
      end if
      ic1 = color_BRIGHTWHITE
      ic3 = color_GRAY
      if (inSet .gt. 0) then
         ic1 = color_GRAY
         ic3 = color_BRIGHTWHITE
      end if
!mr150606      ic2 = color_WHITE
      ic2 = color_BRIGHTWHITE           !mr150606
      if (ifFrame .ne. 0) then
         ic2 = jBackGround
      end if
      call Rettangolo (ix1, iy1, ix2, iy2, ic1, ic2)
      call Linea (ix1 + 1, iy2, ix2, iy2, ic3)
      call Linea (ix2, iy2, ix2, iy1 + 1, ic3)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine AllocaGBuffer(iflag)
      USE Molcom
!
      ic1 = 1
      iz = iflag
      ind = 30
      call graphs(iz,ind,' ',ic1, ic1)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Cerchio (ix1, iy1, Radius, iColor, IfFill, iFillColor)
      USE Molcom
!
      integer Radius
!
!     X , Y  :  Center Coordinates
!     Radius :  Circle Radius
!     iColor  :  Line Color
!     IfFill = 0 don't fill    = -1  Fill
!     iFillColor : Filling Color
!
      dummyString = ' '
      ixv(1) = ix1 - Radius
      iyv(1) = iy1 - Radius
      iz = 2 * Radius
      if (IfFill .ne. 0) then
         ind = 11
         call graphs(iz,ind,dummyString,iColor,iFillcolor)
      else
         ind = 10
         call graphs(iz,ind,dummyString,iColor,iColor)
      end if
!
      return
      end
! -----------------------------------------------------------------
      subroutine Punto (ix1, iy1, iColor)
      USE Molcom
!
!     X , Y  :  Point Coordinates
!     iColor  :  Point Color
!
      dummyString = ' '
      ixv(1) = ix1 
      iyv(1) = iy1
      iz = 1
      ind = 2
      call graphs(iz,ind,dummyString,iColor,icolor)
!
      return
      end
! -----------------------------------------------------------------
      subroutine DrawLabel (ix1, iy1, string, iColor, size)
      USE Molcom
!
      character*(*) string
      integer size
!
!     ix1 , iy1 :  Label Coordinates
!     iColor    :  Label Color
!     string    :  Label text
!
      ixv(1) = ix1 
      iyv(1) = iy1
      iz = size
      ind = 90
      call graphs(iz,ind,string,iColor,iColor)
!
      return
      end
! -----------------------------------------------------------------
      subroutine DrawLabelV(ix1, iy1, string, iColor, size)
      USE Molcom
!
!-- Draw a vertical string
      character*(*) string
      integer size
!
!     ix1 , iy1 :  Label Coordinates
!     iColor    :  Label Color
!     string    :  Label text
!
      ixv(1) = ix1 
      ixv(2) = 0 
      iyv(1) = iy1
      iz = size
      ind = 29
      call graphs(iz,ind,string,iColor,iColor)
!
      return
      end
! -----------------------------------------------------------------
      subroutine Star(X11,Y11)
      USE Molcom
!
      integer X11,Y11
!
      ind = 40
      iCC = icoWire
      ixv(1) = X11
      iyv(1) = Y11
      call graphs(iz,ind,' ',iCC,iCC)
!
      return
      end
! -----------------------------------------------------------------
      subroutine Croce (ix1, iy1, iSize, iColor, itypecross)
      USE Molcom
!
!     X , Y  :  Center Coordinates
!     iSize : Cross Size
!     iColor  :  Line Color
!     itypecross : =0 -> croce normale, =1 -> croce ruotata
!
      dummyString = ' '
      ixv(1) = ix1 
      iyv(1) = iy1
      iz = iSize
      if (itypecross == 0) then
          ind = 33 
          call graphs(iz,ind,dummyString,iColor,iColor)
      else
          ind = 34 
          call graphs(iz,ind,dummyString,iColor,iColor)
      endif
!
      return
      end
! -----------------------------------------------------------------
      subroutine LineaSpessa(ix1, iy1, ix2, iy2, iColor, iRaggio)
      USE Molcom
!
      ixv(1) = ix1
      ixv(2) = ix2
      iyv(1) = iy1
      iyv(2) = iy2
      iz = 1
      iPen = iRaggio * 2
      ind = 4
      call graphs(iz,ind,' ',iColor,iPen)
      call Cerchio (ix1, iy1, iRaggio, iColor, 1, iColor)
      call Cerchio (ix2, iy2, iRaggio, iColor, 1, iColor)
!
      return
      end
! -----------------------------------------------------------------
      subroutine LineaSpessa2(ix1, iy1, ix2, iy2, iColor, iRaggio)
      USE Molcom
!
      ixv(1) = ix1
      ixv(2) = ix2
      iyv(1) = iy1
      iyv(2) = iy2
      iz = 0
      iPen = iRaggio * 2
      ind = 4
      call graphs(iz,ind,' ',iColor,iPen)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine LineaSfumata(ix1, iy1, ix2, iy2, iColor, iRaggio)
      USE Molcom
!
      ixv(1) = ix1
      ixv(2) = ix2
      iyv(1) = iy1
      iyv(2) = iy2
      iPen = iRaggio * 2
      ind = 6
      call graphs(iPen,ind,' ',iColor,iColor)
!
      return
      end

! ----------------------------------------------------------------------
      real function CheckTic(maxx, Quale)
      USE Grafici
      real, intent(in)    :: maxx
      integer, intent(in) :: Quale
      real                :: Tic
      integer             :: i, xArea
      character(len=10)   :: numero
!
      write(numero,'(i10)') nint(maxx)
      call shift(numero,i)
      i = LenInPix2(numero,i, 2)
      i = i * maxx
      xArea = nint( (xHisto(2,Quale) - xHisto(1,Quale)) * float(kLarg))
      if (i > xArea) then
          Tic = 0.0
      else
          Tic = 1.0
      endif
      CheckTic = Tic
!
      return
      end
! ----------------------------------------------------------------------
      subroutine gr_frame(kLarg, kAlt, xminGR, xmaxGR, yminGR, ymaxGR,
     *                    ic1GR, ic2GR)
      USE Molcom
!
      ix1 = nint(kLarg * xminGR)
      ix2 = nint(kLarg * xmaxGR)
      iy1 = kAlt - nint(kAlt * yminGR)
      iy2 = kAlt - nint(kAlt * ymaxGR)
!     
      call Rettangolo (ix1, iy1, ix2, iy2, ic1GR, ic2GR)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine  gr_Poligono(xvet, yvet, iz, iColor, jFill)
      USE Molcom
!
      integer  xvet(iz), yvet(iz)
!
      ixv(1:iz) = xvet(1:iz)
      iyv(1:iz) = yvet(1:iz)
      call  Poligono(iz, iColor, jFill)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine MarkUpGR(stringa, lstr)
      USE General
      USE CaratteriSpeciali
!
!-- This routine manages the following MarkUps  
!          <span lang="A">A</span>              Angstrom symbol
!          <span lang="Greek">stringa</span>    Greek characters
!
!-- The following are managed directly by GTK
!          <b>text</b>          Bold 
!          <big>text</big>      Makes font relatively larger
!          <sub>text</sub>      Subscript 
!          <sup>text</sup>      Superscript 
!          <small>text</small>  Makes font relatively smaller
!          <tt>text</tt>        Monospace font 
!          <u>text</u>          Underline 
 
      character*(*) stringa
!
      cardDiret = ' '
      cardImage = stringa
      call lcase(cardImage)
      k1 = index(cardImage,'<span lang="a">')
      k2 = index(cardImage,'<span lang="greek">')
      if (k1 > 0) then
          do while (k1 > 0)
             call SpecialChar(SpecCode(59), Inte, InteL)
             cardDiret(1:k1-1) = stringa(1:k1-1)
             cardDiret(k1:k1+InteL-1) = Inte(1:InteL)
             cardDiret(k1+InteL:) = stringa(k1+23:)
             stringa = cardDiret
             cardImage = stringa
             call lcase(cardImage)
             k1 = index(cardImage,'<span lang=a>')
          enddo
      endif
      if (k2 > 0) then
          do while (k2 > 0)
             kn = index(cardImage,'</span>') - 1
             k3 = k2 + 19
             cardDiret(1:k2-1) = stringa(1:k2-1)
             do k = k3, kn
                kk = ichar(stringa(k:k))
                kk = kk - 64
                call SpecialChar(SpecCode(kk), Inte, InteL)
                cardDiret(k2:k2+InteL-1) = Inte(1:InteL)
                k2 = k2+InteL
             enddo
             cardDiret(k2:) = stringa(kn+8:)
             stringa = cardDiret
             cardImage = stringa
             call lcase(cardImage)
             k2 = index(cardImage,'<span lang="greek">')
          enddo
      endif
      lstr = Lung(stringa)
!
      return
      end
!-----------------------------------------------------------------------
!     SORT ROUTINES
!-----------------------------------------------------------------------
      subroutine sortz_dyn(vettore,idim,lind,numb,iblk,jump)
!
!--sort the data in vettore
!
!  vettore      array to sort
!  idim         dimension of vettore
!  lind         addres in vettore
!  numb         number of block of data to be sorted
!  iblk         block lenght of the data (i.e. number of items per block)
!  jump  < 0    sort in decreasing order
!  jump  > 0    sort in increasing order
!  iabs(jump)-1 = relative addres of the key of sort
!
      dimension vettore(idim)
!
      if (numb.le.1) then
          return
      endif
      jsig=1
      if (jump.lt.0) then
          jump = iabs(jump)
          jsig = -1
      endif
      jump = jump - 1
      ja = 2
      kVai = 1
      do while (kVai.eq.1)
         jb = numb / ja
         if (jb.le.0) then 
             jb = 1
         endif
         jc = numb - jb
 2040    continue
         jd = 0
         m  = lind
         do i=1,jc
            mk = m + jb * iblk
            if ((vettore(m+jump)-vettore(mk+jump))*jsig.gt.0) then
                mm = m
                mmk = mk
                do je=1,iblk
                   f          = vettore(mm)
                   vettore(mm)  = vettore(mmk)
                   vettore(mmk) = f
                   mm  = mm + 1
                   mmk = mmk + 1
                enddo
                jd = 1
            endif
            m = m + iblk
         enddo
         if (jd.gt.0) then
             go to 2040
         endif
         if (jb.gt.1) then
             ja = ja * 2
         else
             kVai = 0
         endif
      enddo
c
      return
      end
c ------------------------------------------------------------------
      subroutine sortco (st1,list2,n)
      dimension st1(n),list2(n)
      int = 2
10    int = int*2
      if(int.lt.n)goto 10
      int = min0(n,(3*int)/4 - 1)
20    int = int/2
      ifin = n - int
      do 120  ii = 1,ifin
         i = ii
         j = i + int
         if(st1(i).gt.st1(j)) then
            r = st1(j)
            m = list2(j)
60          st1(j) = st1(i)
            list2(j) = list2(i)
            j = i
            i = i - int
            if(i.gt.0) then
               if(st1(i).gt.r) then
                  go to 60
               end if
            end if
            st1(j) = r
            list2(j) = m
         end if
120   continue
      if(int.gt.1) go to 20
      return
      end
!-----------------------------------------------------------------------
      subroutine sort3 (alf,iorde,   numb)
!
!--sort in decreasing order the array iorde respect to the alf array
!
      dimension alf(*),iorde(*)
      dimension wt(4000)
!psie      
!psie      dimension wt(12000)
      integer iorde
c--
      do 1010 i=1,numb
      wt(i)=alf(i)
1010  continue
      int = 2
1000  int = 2*int
      if(int .lt. numb) go to 1000
      int = min0(numb,(3*int)/4-1)
1020  int = int/2
      ifin = numb - int
      do 1120 ii=1,ifin
      i=ii
      j=i+int
      if(wt(i)-wt(j)) 1040,1120,1120
1040  a=wt(j)
      m=iorde(j)
1060  wt(j)=wt(i)
      iorde(j)=iorde(i)
      j=i
      i=i-int
      if(i) 1100,1100,1080
1080  if(wt(i)-a) 1060,1100,1100
1100  wt(j)=a
      iorde(j)=m
1120  continue
      if(int .gt. 1) go to 1020
      return
      end
!-----------------------------------------------------------------------
      subroutine sort3_big(alf, iorde, wt, numb)
!
!--sort in decreasing order the array iorde respect to the alf array
!
      implicit none
      integer :: numb, i, ii, j, m, int, ifin
      integer :: iorde(numb)
      real    :: a, alf(numb), wt(numb)
c--
      do 1010 i=1,numb
      wt(i)=alf(i)
1010  continue
      int = 2
1000  int = 2*int
      if(int .lt. numb) go to 1000
      int = min0(numb,(3*int)/4-1)
1020  int = int/2
      ifin = numb - int
      do 1120 ii=1,ifin
      i=ii
      j=i+int
      if(wt(i)-wt(j)) 1040,1120,1120
1040  a=wt(j)
      m=iorde(j)
1060  wt(j)=wt(i)
      iorde(j)=iorde(i)
      j=i
      i=i-int
      if(i) 1100,1100,1080
1080  if(wt(i)-a) 1060,1100,1100
1100  wt(j)=a
      iorde(j)=m
1120  continue
      if(int .gt. 1) go to 1020
!
      return
      end
!-----------------------------------------------------------------------
      subroutine sort3_c(alf, iorde, numb)
!
!--sort in increasing order the array iorde respect to the alf array
!
      dimension alf(*),iorde(*)
      dimension wt(4000)
!psie      
!psie      dimension wt(12000)
      
      integer iorde
c--
      do 1010 i=1,numb
      wt(i)=alf(i)
1010  continue
      int = 2
1000  int = 2*int
      if(int .lt. numb) go to 1000
      int = min0(numb,(3*int)/4-1)
1020  int = int/2
      ifin = numb - int
      do 1120 ii=1,ifin
      i=ii
      j=i+int
      if(wt(j)-wt(i)) 1040,1120,1120
1040  a=wt(j)
      m=iorde(j)
1060  wt(j)=wt(i)
      iorde(j)=iorde(i)
      j=i
      i=i-int
      if(i) 1100,1100,1080
1080  if(wt(i)-a) 1060,1100,1100
1100  wt(j)=a
      iorde(j)=m
1120  continue
      if(int .gt. 1) go to 1020
      return
      end
!-----------------------------------------------------
      subroutine sortall(isort,x,numb)
      dimension x(numb)

c--- isort=-1 ===> descrescente
c--- isort= 1 ===> crescente

      if (numb.eq.1) return
      m=2
  10  continue
      in=numb/m
      if (in) 20,20,30
  20  continue
      in=1
  30  continue
      ifin=numb-in
  40  continue
      mark=0
      do 60 i=1,ifin
      k=i+in
      if (isort.lt.0) then
         if (x(i)-x(k)) 50,60,60
      else
         if (x(k)-x(i)) 50,60,60
      endif
  50  continue
      dd=x(i)
      x(i)=x(k)
      x(k)=dd
      mark=1
  60  continue
      if (mark) 65,65,40
  65  continue
      if (in-1) 80,80,70
  70  continue
      m=m*2
      go to 10
  80  continue
      return
      end
!-----------------------------------------------------------------------
      subroutine sort_index(isort, y, iorde, numb)
      real    :: x(numb), y(numb) ! era y(4000)
      integer :: iorde(numb)
c--
      do i=1,numb
         x(i)=y(i)
      enddo

c--- isort=-1 ===> descrescente
c--- isort= 1 ===> crescente

      if (numb.eq.1) return
      m=2
  10  continue
      in=numb/m
      if (in) 20,20,30
  20  continue
      in=1
  30  continue
      ifin=numb-in
  40  continue
      mark=0
      do 60 i=1,ifin
      k=i+in
      if (isort.lt.0) then
         if (x(i)-x(k)) 50,60,60
      else
         if (x(k)-x(i)) 50,60,60
      endif
  50  continue
      dd=x(i)
      x(i)=x(k)
      x(k)=dd
      id=iorde(i)
      iorde(i)=iorde(k)
      iorde(k)=id
      mark=1
  60  continue
      if (mark) 65,65,40
  65  continue
      if (in-1) 80,80,70
  70  continue
      m=m*2
      go to 10
  80  continue
      return
      end
!-----------------------------------------------------------------------
      subroutine sort3_int(ialf, iorde, numb)
c
      integer ialf(numb), iorde(numb), a
c--
      int = 2
1000  int = 2*int
      if(int .lt. numb) go to 1000
      int = min0(numb,(3*int)/4-1)
1020  int = int/2
      ifin = numb - int
      do 1120 ii=1,ifin
      i=ii
      j=i+int
      if(ialf(i)-ialf(j)) 1040,1120,1120
1040  a=ialf(j)
      m=iorde(j)
1060  ialf(j)=ialf(i)
      iorde(j)=iorde(i)
      j=i
      i=i-int
      if(i) 1100,1100,1080
1080  if(ialf(i)-a) 1060,1100,1100
1100  ialf(j)=a
      iorde(j)=m
1120  continue
      if(int .gt. 1) go to 1020
      return
      end
!-----------------------------------------------------------------------
      subroutine sort3_int8(ialf, numb)
!
      implicit none
      integer   :: numb, int, ifin, i, ii, j
      integer*8 :: ialf(numb), a
!
      int = 2
1000  int = 2*int
      if(int .lt. numb) go to 1000
      int = min0(numb,(3*int)/4-1)
1020  int = int/2
      ifin = numb - int
      do 1120 ii=1,ifin
      i=ii
      j=i+int
      if(ialf(i)-ialf(j)) 1040,1120,1120
1040  a=ialf(j)
1060  ialf(j)=ialf(i)
      j=i
      i=i-int
      if(i) 1100,1100,1080
1080  if(ialf(i)-a) 1060,1100,1100
1100  ialf(j)=a
1120  continue
      if(int .gt. 1) go to 1020
!
      return
      end
!-----------------------------------------------------------------------
      subroutine sortall3(isort,x,numbx,numb,iorde)
      dimension x(numb),iorde(numb)

c--- isort=-1 ===> decrescente
c--- isort= 1 ===> crescente

      if(numb.eq.1) return
      m=2
  10  continue
      in=numb/m
      if(in) 20,20,30
  20  continue
      in=1
  30  continue
      ifin=numb-in
  40  continue
      mark=0
      do 60 i=1,ifin
      if (i.lt.numbx) goto 60
      k=i+in
      if (isort.lt.0) then
         if(x(i)-x(k)) 50,60,60
      else
         if(x(k)-x(i)) 50,60,60
      endif
  50  continue
      dd=x(i)
      x(i)=x(k)
      x(k)=dd
      id=iorde(i)
      iorde(i)=iorde(k)
      iorde(k)=id
      mark=1
  60  continue
      if(mark) 65,65,40
  65  continue
      if(in-1) 80,80,70
  70  continue
      m=m*2
      go to 10
  80  continue
      return
      end
!-----------------------------------------------------------------------
      subroutine sortall2(x,ix,icam,n1,nnn,iord)
      dimension x(ix,nnn),t(10)
c--- iord= 1 ===> decrescente
c--- iord=-1 ===> crescente
      int=2
 1000 int=int+int
      if(int.lt.n1)go to 1000
      int=min0(n1,(3*int)/4-1)
 1020 int=int/2
      ifin=n1-int
      do 1200 ii=1,ifin
      i=ii
      j=i+int
      if (iord.eq.1) then
        if (x(icam,i).gt.x(icam,j))go to 1200
      elseif (iord.eq.-1) then
        if (x(icam,i).lt.x(icam,j))go to 1200
      end if
      do 1060 k=1,ix
      t(k)=x(k,j)
 1060 continue
 1080 do 1100 k=1,ix
      x(k,j)=x(k,i)
 1100 continue
      j=i
      i=i-int
      if(i)1140,1140,1120
 1120 if (iord.eq.1) then
         if (x(icam,i).lt.t(icam))go to 1080
      elseif (iord.eq.-1) then
         if (x(icam,i).gt.t(icam))go to 1080
      endif
 1140 do 1160 k=1,ix
      x(k,j)=t(k)
 1160 continue
 1200 continue
      if(int.ne.1)go to 1020

      return
      end
!-----------------------------------------------------------------------
      subroutine sortf(xyzs, righe, natomi, n)
!
!--   sort peaks in order of peak height or in order of plotting
!
      implicit none
      integer :: righe, natomi, n, int, ifin, ii, i, j
      real    :: xyzs(righe,natomi)
      real    :: t(righe)
!
      if (natomi <= 1) return
!
      int = 2
      do
         int = int + int
         if (int >= natomi) exit
      enddo
!
      int = min0(natomi, (3*int)/4-1)
!
      do
         int = int / 2
         ifin = natomi - int
         do ii=1, ifin
            i = ii
            j = i + int
            if (xyzs(n,i) >= xyzs(n,j)) cycle
            t(1:righe) = xyzs(1:righe,j)
 1080       xyzs(1:righe,j) = xyzs(1:righe,i)
            j = i
            i = i - int
            if (i > 0) then
                if (xyzs(n,i) < t(n)) go to 1080
            endif
            xyzs(1:righe,j) = t(1:righe)
         enddo
         if (int == 1) exit
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine unpak3Sir(index,kod1,kod2,ifaz)
!
      isave=iabs(index)/32
      ifaz=iabs(index)-isave*32 -1
      kod1=isave/8192
      kod2=isave-8192*kod1-4096
      kod1=kod1-4096
!
      return
      end
!-----------------------------------------------------------------------
      real function cdist(g, d, distsq)
!
!-- distance between two atoms (cryst. coords) 
!
      implicit none
      real      ::  g(9), d(3), distsq
!
      distsq = g(1) * d(1) * d(1)
     1       + g(5) * d(2) * d(2)
     2       + g(9) * d(3) * d(3)
     3       + g(2) * d(1) * d(2) * 2.0
     4       + g(3) * d(1) * d(3) * 2.0
     5       + g(6) * d(2) * d(3) * 2.0
      cdist = sqrt(distsq)
!
      return
      end
!-----------------------------------------------------------------------
      integer function DeltaFase(phi1, phi2)
      implicit none
      integer :: phi1, phi2, ip
!

      ip = iabs(phi1 - phi2)
      DeltaFase = min0 (ip, 360 - ip)
!
      return
      end
!-----------------------------------------------------------------------
!     MATH ROUTINES
!-----------------------------------------------------------------------
      subroutine autov(a, eigen, t, icod)
      implicit double precision (a-h,o-z)
      real t(3,3),a(3,3),aik(3),eigen(3),aaa
!
      itmax = 50
      n = 3
      nm1 = n - 1
      eps1 = .1e-10
      eps2 = eps1
      eps3 = .1e-9
      sigma1 = 0
      offdsq = 0
      t(1:3, 1:3) = 0.0
      do i=1, n
         sigma1 = sigma1 + a(i,i)**2
         t(i,i) = 1.0
         ip1 = i + 1
         if (i >= n) exit
         do j=ip1, n
            offdsq = offdsq + a(i,j)**2
         enddo
      enddo
      s = 2.0 * offdsq + sigma1
!
!-- inizio iter. jacobi
!
      do iter=1, itmax
         do i=1, nm1
            ip1 = i + 1
            do j=ip1, n
               q = abs( a(i,i) - a(j,j) )
               if (q > eps1) then
                   if (abs(a(i,j)) <= eps2) then
                       a(i,j) = 0.0
                       cycle
                   endif
                   p = 2.0 * a(i,j) * q / ( a(i,i) - a(j,j) )
                   spq = sqrt( p * p + q * q)
                   csa = sqrt( (1.0 + q / spq) / 2.0 )
                   sna = p / ( 2.0 * csa * spq )
               else
                   csa = 1.0 / sqrt(2.d0)
                   sna = csa
               endif
!
               do k=1, n
                  holdki = t(k,i)
                  t(k,i) = holdki * csa + t(k,j) * sna
                  t(k,j) = holdki * sna - t(k,j) * csa
               enddo
!
               do k=i, n
                  if (k <= j) then
                      aik(k) = a(i,k)
                      a(i,k) = csa * aik(k) + sna * a(k,j)
                      if (k == j) then
                          a(j,k) = sna * aik(k) - csa * a(j,k)
                      endif
                  else
                      holdik = a(i,k)
                      a(i,k) = csa * holdik + sna * a(j,k)
                      a(j,k) = sna * holdik - csa * a(j,k)
                  endif
               enddo
!
               aik(j) = sna * aik(i) - csa * aik(j)
!
               do k=1, j
                  if (k <= i) then
                     holdki = a(k,i)
                     a(k,i) = csa * holdki + sna * a(k,j)
                     a(k,j) = sna * holdki - csa * a(k,j)
                  else
                     a(k,j) = sna * aik(k) - csa * a(k,j)
                  endif
               enddo
               a(i,j) = 0.0
            enddo
         enddo
!
         sigma2 = 0.0
         do i=1, n
            eigen(i) = a(i,i)
            sigma2 = sigma2 + eigen(i)**2
         enddo
         if (abs(sigma2) <= 1.e-07) then
            icod = 0
            return
         endif
         if (abs(sigma2) > 1.e-07) then
            aaa = 1.0 - sigma1 / sigma2
            if (aaa >= eps3) then
                sigma1 = sigma2
                cycle
            endif
         endif
         icod = 1
         return
      enddo
      icod = 0
!
      return
      end
!-----------------------------------------------------------------------
      function ScattFact(k, rho)
!
      USE General
!
      sf = cl(k)
      do i=1,4
         sf = sf + al(i,k) * exp( -bs(i,k) * rho )
      enddo
      ScattFact = sf
      if (ifMottFormula(k) > 0) then
          Zeta = no(k)
          ScattFact = 0.023934 * (Zeta - ScattFact) / rho
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine besse(xx,vec)
!--bessel function
!
      x=abs(xx)
      vec=amin1((x+0.4807)*x/((x+0.8636)*x+1.3943),1.0)
      if (xx.lt.0.0) vec=-vec
      return
      end
!-----------------------------------------------------------------------
      subroutine pack (index,ih,kk,il)
      ih = index/262144
      is = index - 262144*ih
      kk = is/512-256
      il = is-512*(kk+256)-256
      return
      end
!-----------------------------------------------------------------------
      function bes(x)
      is=1
      if(x.lt.0.0) is=-1
      x1=abs(x)
      if(x1.lt.0.000001)  go to 200
      if(x1.le.2.9) go to 180
      if(x1.le.7.5) go to 160
      if(x1.le.20.) go to 140
      if(x1.le.39.) go to 120
      if(x1.le.45.) go to 100
      if(x1.le.55.) go to  80
      if(x1.le.65.) go to  60
      if(x1.le.80.) go to  40
      if(x1.le.99.) go to  20
      bes=1.*is
      return
   20 bes=0.0000631*x1+.988652
      bes=abs(bes)*is
      return
   40 bes=0.0000933*x1+.9862355
      bes=abs(bes)*is
      return
   60 bes=0.00014*x1+.9832
      bes=abs(bes)*is
      return
   80 bes=0.00021*x1+.97935
      bes=abs(bes)*is
      return
  100 bes=0.0000666*x1+.9858026
      bes=abs(bes)*is
      return
  120 bes=0.9459 +0.00187*x1-0.00002*x1*x1
      bes=abs(bes)*is
      return
  140 bes=0.82227+0.02189*x1-0.00114*x1*x1+0.00002*x1*x1*x1
      bes=abs(bes)*is
      return
  160 bes=0.444+0.19096*x1-0.02697*x1*x1+0.00135*x1*x1*x1
      bes=abs(bes)*is
      return
  180 bes=-0.00718+0.5668*x1-0.12287*x1*x1 +0.008*x1*x1*x1
      bes=abs(bes)*is
      return
  200 bes=0.
      return
      end
! ----------------------------------------------------------------------
      function besinv(y)
      if (abs(y).lt.0.000001)  go to  200
      if (y.le.0.6989)  go to 180
      if (y.le.0.8666) go to 160
      if (y.le.0.9259)  go to 140
      if (y.le.0.9553)  go to 120
      if (y.le.0.9635)  go to 100
      if (y.le.0.9884) go to 90
      if (y.le.0.9888) go to 80
      if (y.le.0.9909) go to 70
      if (y.le.0.9923) go to 60
      if (y.le.0.9937) go to 50
      if (y.le.0.9949) go to 40
      besinv=100.
      return
   40 besinv=15833.333*y-15653.583
      return
   50 besinv=10714.285*y-10566.785
      return
   60 besinv=7142.8571*y-7022.8571
      return
   70 besinv=4761.9047*y-4663.5713
      return
   80 besinv=15000*y-14787
      return
   90 besinv=49773.46954-102737.23532*y+53033.83171*y*y
      return
  100 besinv=77576.4096-162332.52722*y+84935.62155*y*y
      return
  120 besinv=3117.15834-6767.58257*y+3681.64105*y*y
      return
  140 besinv=486.69735-1127.7574*y+658.80603*y*y
      return
  160 besinv=-82.06253+344.25645*y-478.71058*y*y+226.35886*y*y*y
      return
  180 besinv=-0.00252+2.1065*y-1.12674*y*y+3.09414*y*y*y
      return
  200 besinv=0
      return
      end
!-----------------------------------------------------------------------
      function dbes(x)
      real *8 dx1, dx2, dy1, dy2, dm, dp
      is=1
      if(x.lt.0.0) is=-1
      x1=abs(x)
      if(x1.lt.0.000001)  go to 200
      if(x1.le.2.9) go to 180
      if(x1.le.7.5) go to 160
      if(x1.le.20.) go to 140
      if(x1.le.39.) go to 120
      if(x1.le.45.) go to 100
      if(x1.le.55.) go to  80
      if(x1.le.65.) go to  60
      if(x1.le.80.) go to  40
      if(x1.le.99.) go to  20
!!!!!!!!!!!!      bes=1.*is
      dx1 = 99.0
      dx2 = 700.
      dy1 = 0.994937625172
      dy2 = 0.999285771579
      dm = (dy2-dy1) / (dx2-dx1)
      dp = dy1 - dx1 *dm
      dbes = dm * x1 + dp
      dbes = dbes * is
      return
   20 dbes=0.0000631*x1+.988652
      dbes=abs(dbes)*is
      return
   40 dbes=0.0000933*x1+.9862355
      dbes=abs(dbes)*is
      return
   60 dbes=0.00014*x1+.9832
      dbes=abs(dbes)*is
      return
   80 dbes=0.00021*x1+.97935
      dbes=abs(dbes)*is
      return
  100 dbes=0.0000666*x1+.9858026
      dbes=abs(dbes)*is
      return
  120 dbes=0.9459 +0.00187*x1-0.00002*x1*x1
      dbes=abs(dbes)*is
      return
  140 dbes=0.82227+0.02189*x1-0.00114*x1*x1+0.00002*x1*x1*x1
      dbes=abs(dbes)*is
      return
  160 dbes=0.444+0.19096*x1-0.02697*x1*x1+0.00135*x1*x1*x1
      dbes=abs(dbes)*is
      return
  180 dbes=-0.00718+0.5668*x1-0.12287*x1*x1 +0.008*x1*x1*x1
      dbes=abs(dbes)*is
      return
  200 dbes=0.
      return
      end
! ----------------------------------------------------------------------
      function dbesinv(y)
      real *8 dx1, dx2, dy1, dy2, dm, dp
      
      if (abs(y).lt.0.000001)  go to  200
      if (y.le.0.6989)  go to 180
      if (y.le.0.8666) go to 160
      if (y.le.0.9259)  go to 140
      if (y.le.0.9553)  go to 120
      if (y.le.0.9635)  go to 100
      if (y.le.0.9884) go to 90
      if (y.le.0.9888) go to 80
      if (y.le.0.9909) go to 70
      if (y.le.0.9923) go to 60
      if (y.le.0.9937) go to 50
      if (y.le.0.9949) go to 40
!!!!!!!!!!!!      besinv=100.
      dx1 = 99.0
      dx2 = 700.
      dy1 = 0.994937625172
      dy2 = 0.999285771579
      dm =  (dx2-dx1) / (dy2-dy1)
      dp = dx1 - dy1 * dm
      dbesinv = y * dm + dp
      return
   40 dbesinv=15833.333*y-15653.583
      return
   50 dbesinv=10714.285*y-10566.785
      return
   60 dbesinv=7142.8571*y-7022.8571
      return
   70 dbesinv=4761.9047*y-4663.5713
      return
   80 dbesinv=15000*y-14787
      return
   90 dbesinv=49773.46954-102737.23532*y+53033.83171*y*y
      return
  100 dbesinv=77576.4096-162332.52722*y+84935.62155*y*y
      return
  120 dbesinv=3117.15834-6767.58257*y+3681.64105*y*y
      return
  140 dbesinv=486.69735-1127.7574*y+658.80603*y*y
      return
  160 dbesinv=-82.06253+344.25645*y-478.71058*y*y+226.35886*y*y*y
      return
  180 dbesinv=-0.00252+2.1065*y-1.12674*y*y+3.09414*y*y*y
      return
  200 dbesinv=0
      return
      end
!-----------------------------------------------------------------------
      real function bessel_I0(X)
!
!-- zero order bessel function
!
      REAL*8 Y,P1,P2,P3,P4,P5,P6,P7,
     *    Q1,Q2,Q3,Q4,Q5,Q6,Q7,Q8,Q9
      DATA P1,P2,P3,P4,P5,P6,P7/1.0D0,3.5156229D0,3.0899424D0,1.2067492D
     *0,
     *    0.2659732D0,0.360768D-1,0.45813D-2/
      DATA Q1,Q2,Q3,Q4,Q5,Q6,Q7,Q8,Q9/0.39894228D0,0.1328592D-1,
     *    0.225319D-2,-0.157565D-2,0.916281D-2,-0.2057706D-1,
     *    0.2635537D-1,-0.1647633D-1,0.392377D-2/
      IF (ABS(X).LT.3.75) THEN
        Y=(X/3.75)**2
        bessel_I0=P1+Y*(P2+Y*(P3+Y*(P4+Y*(P5+Y*(P6+Y*P7)))))
      ELSE
        AX=ABS(X)
        Y=AX/3.75
        bessel_I0=Q1+Y**(-1)*Q2+Y**(-2)*Q3+
     *  Y**(-3)*Q4+Y**(-4)*Q5+Y**(-5)*Q6+Y**(-6)*Q7+
     *  Y**(-7)*Q8+Y**(-8)*Q9
      ENDIF
!
      RETURN
      END
!-----------------------------------------------------------------------
      subroutine i0(x,ri0)
c ---
c ---        compute the modified bessel function i of order zero
c---
      ri0=abs(x)
      if(ri0-3.75)1,1,2
    1 z=x*x*7.111111e-2
      ri0=((((( 4.5813e-3*z+3.60768e-2)*z+2.659732e-1)*z+1.206749e0)*z
     1+3.089942e0)*z+3.515623e0)*z+1.
      return
    2 z=3.75/ri0
      ri0= exp(ri0)/sqrt(ri0)*((((((((3.92377e-3*z-1.647633e-2)*z
     1+2.635537e-2)*z-2.057706e-2)*z+9.16281e-3)*z-1.57565e-3)*z
     2+2.25319e-3)*z+1.328592e-2)*z+3.989423e-1)
      return
      end
!-----------------------------------------------------------------------
      subroutine cc_vet(x,y,npunti,corre)

C --  Correlazione tra due vettori x, y
      dimension x(npunti), y(npunti)
c
      vmedt=0.0
      vmedc=0.0
      vmedtc=0.0
      vmed2t=0.0
      vmed2c=0.0
      do ix=1,npunti
         xx1 = x(ix)
         xx2 = y(ix)
         vmedt=vmedt + xx1
         vmedc=vmedc + xx2
         vmedtc=vmedtc + xx1 * xx2
         vmed2t=vmed2t + xx1 * xx1
         vmed2c=vmed2c + xx2 * xx2
      enddo
      vmedt=vmedt/float(npunti)
      vmedc=vmedc/float(npunti)
      vmedtc=vmedtc/float(npunti)
      vmed2t=vmed2t/float(npunti)
      vmed2c=vmed2c/float(npunti)

      rnum=vmedtc - (vmedt*vmedc)
      rden=sqrt(vmed2t-vmedt**2) * sqrt(vmed2c-vmedc**2)
      corre=rnum/rden
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Correla_Mappe(nx,ny,nz,x1,x2,cor)
      USE General

! -- Attenzione le mappe da confrontare devono avere origine coincidente

      real x1(0:nx-1,0:ny-1,0:nz-1)
      real x2(0:nx-1,0:ny-1,0:nz-1)
c
      correl = -99.9
c
      nnx=nx-1
      nny=ny-1
      nnz=nz-1

      npunti=0
      vmedt=0.0
      vmedc=0.0
      vmedtc=0.0
      vmed2t=0.0
      vmed2c=0.0

      do iz=0,nnz
         do iy=0,nny
            do ix=0,nnx
               npunti=npunti+1
               xx1=x1(ix,iy,iz)
               xx2=x2(ix,iy,iz)
               vmedt=vmedt + xx1
               vmedc=vmedc + xx2
               vmedtc=vmedtc + xx1 * xx2
               vmed2t=vmed2t + xx1 * xx1
               vmed2c=vmed2c + xx2 * xx2
          enddo
        enddo
      enddo

      vmedt=vmedt/float(npunti)
      vmedc=vmedc/float(npunti)
      vmedtc=vmedtc/float(npunti)
      vmed2t=vmed2t/float(npunti)
      vmed2c=vmed2c/float(npunti)
c--occhio
c       write(6,'(a,3f15.1)') 'Media',vmed2t,vmed2c,vmedtc
c--occhio
      rnum=vmedtc - (vmedt*vmedc)
      arg1 = vmed2t - vmedt ** 2
      arg2 = vmed2c - vmedc ** 2
      rden=sqrt(arg1) * sqrt(arg2)
      correl=rnum/rden
c       if (correl.lt.0.0) then
c           correl = 0.0
c       endif
      close(jgrap)
!
      return
      end
!-----------------------------------------------------------------------
      function atanhILM(x)
!
!-- funcion tangente hiperbolica inversa
!
      real x

      if (x .gt. 0.99999) then
         atanhILM=54.0
      elseif(x.lt.-0.99999) then
         atanhILM=-54.0
      else
         atanhILM=alog((1+x)/(1-x))*0.5
      endif

      return
      end
!-----------------------------------------------------------------------
      real function sim(x)
c Calculate Sim & Srinivasan non-centric figure of merit as
c I1(X)/I0(X), where I1 and I0 are the modified 1st and zero
c order bessel functions.
c References: Sim, G. A. (1960) Acta Cryst. 13, 511-512;
c             Srinivasan, R. (1966) Acta Cryst. 20, 143-144;
c             Abramowitz & Stegun, Handbook of Mathematical Functions, 378.
c This routine was obtained from W. Kabsch.
      real x,t
c
      if (abs(x).gt.0.0001) then
        t=abs(x)/3.75
        if (t.gt.1.0) then
          t=1.0/t
          sim=((((((((0.01787654-t*0.00420059)*t+ (-0.02895312))*t+
     +        0.02282967)*t+ (-0.01031555))*t+0.00163801)*t+
     +        (-0.00362018))*t+ (-0.03988024))*t+0.39894228)*
     +        sign(1.0,x)/ ((((((((-0.01647633+t*0.00392377)*t+
     +        0.02635537)*t+ (-0.02057706))*t+0.00916281)*t+
     +        (-0.00157565))*t+0.00225319)*t+0.01328592)*t+0.39894228)
        else
          t=t*t
          sim=((((((t*0.00032411+0.00301532)*t+0.02658733)*t+
     +        0.15084934)*t+0.51498869)*t+0.87890594)*t+0.5)*x/
     +        ((((((t*0.0045813+0.0360768)*t+0.2659732)*t+
     +        1.2067492)*t+3.0899424)*t+3.5156229)*t+1.0)
        endif
      else
        sim=0.0
      endif
      return
      end
!-----------------------------------------------------------------------
      real function siminv(fom)
c SIMINV - inverse SIM function
c slow but accurate version
      real fom,x,x1,x2,sim
      integer i
      external sim
      x1=0.0
      x2=1.0
      do 100 i=1,8
       if (sim(x2).gt.fom) goto 110
       x1=x2
       x2=2.0*x2
 100  continue
      siminv=x2
      return
 110  do 200 i=1,12
       x=(x1+x2)/2
       if (sim(x).gt.fom) then
        x2=x
       else
        x1=x
       endif
 200  continue
      siminv=x
      return
      end

!---------------------------------------------------------------------
      function acentx(fom)
c given the figure of merit for a acentric reflection, return X as
c defined by Hendrickson and Lattman (Acta Cryst B26, 136-143, 1970).
c The returned value for X wil always be 0 <= X <= 998.04
c Illegal values of FOM, less than 0.0 or larger than 1.0, will return
c 0.0 and 998.04 respectively. It is the responsibility of the calling
c routine to detect these invalid FOM values.

      implicit none

      real fom, acentx

      real xlow, xhgh, xtry, fomlow, fomhgh, fomtry, sim


c X=infinite for FOM=1.0, so limit to 0.9995 (FOM=0.9995 has X=998.04)
      if(fom .ge. 0.9995)then
        acentx = 998.04
        return
      else if(fom .le. 0.0)then
        acentx = 0.0
      endif
c Set initial brackets, eg. 0<FOM<1.0 and corresponding X values
      fomlow = 0.0
      xlow   = 0.0
      fomhgh = 1.0
      xhgh   = 999.99

  100 continue
        xtry   = (xlow + xhgh)/2.0
        fomtry = sim(xtry)
c update the boundaries
        if(fomtry .lt. fom)then
          fomlow = fomtry
          xlow   = xtry
        else
          fomhgh = fomtry
          xhgh   = xtry
        endif
      if(abs(fomtry - fom) .gt. 0.000001) goto 100

c get final estimate by linear interpolation
      acentx = xlow + (xhgh-xlow)*(fom-fomlow)/(fomhgh-fomlow)

      end

!---------------------------------------------------------------------
      function centx(fom)
c given the figure of merit of a centric reflection, return X as defined
c by Hendrickson and Lattman (Acta Cryst B26, 136-143, 1970). The
c returned value for X wil always be 0 <= X <= 6.06
c Illegal values of FOM, less than 0.0 or larger than 1.0, will return
c 0.0 and 998.04 respectively. It is the responsibility of the calling
c routine to detect these invalid FOM values.

      implicit none

      real    fom, centx

      real    xlow, xhgh, xtry, fomlow, fomhgh, fomtry
c X=infinite for FOM=1.0, so limit to 0.99999 (FOM=0.99999 has X=6.06)
      if(fom .ge. 0.99999)then
        centx = 6.06
        return
      else if(fom .le. 0.0)then
        centx = 0.0
      endif

c Set initial brackets, eg. 0<FOM<1.0 and corresponding X values
      fomlow = 0.0
      xlow   = 0.0
      fomhgh = 1.0
      xhgh   = 6.06

  100 continue
        xtry   = (xlow + xhgh)/2.0
        fomtry = tanh(xtry)
c update the boundaries
        if(fomtry .lt. fom)then
          fomlow = fomtry
          xlow   = xtry
        else
          fomhgh = fomtry
          xhgh   = xtry
        endif
      if(abs(fomtry - fom) .gt. 0.000001) goto 100

c get final estimate by linear interpolation
      centx = xlow + (xhgh-xlow)*(fom-fomlow)/(fomhgh-fomlow)

      end
!-----------------------------------------------------------------------
!     TIME ROUTINES
!-----------------------------------------------------------------------
code for XTimeIN
      subroutine XTimeIN(n,testoc)
c--initiate the timing of a given operation
c  n the number that identifies this operation (1-10)
c
      USE General
      character*40 testo
      character*(*) testoc
      common /xtimes/ q(10),qp(10),qsum(10),testo(10)
c
      if (n.gt.10)  call cstop('XTimeIN')
      call cpu_time(t1)
      q(n)=t1
      qsum(n)=0
      testo(n)=testoc
      return
      end
!-------------------------------------------------------------
code for XTimeOUT
      subroutine XTimeOUT(n)
c--calculate the timing of a given operation
c  n the number that identifies this operation (1-10)
c
      USE General
      USE LsqModule
      character*40 testo
      common /xtimes/ q(10),qp(10),qsum(10),testo(10)
c
      if (n.gt.10)  call cstop('XTimeOUT')
      call cpu_time(t1)
      T=t1-q(n)
      nSecsTot = int(T)
      tmil=T-nSecsTot
c	nmil=int(tmil*1000)
      iss = mod(nSecsTot,3600)
      ih = ( nSecsTot - iss ) / 3600
      is =  mod(iss,60)
      im  = ( iss - is ) / 60
      fismil=is+tmil	
      if (iverb >= 0) write(lo,1000) testo(n),ih,im,fismil
1000  format(1x,60('*'),/,1x,a,/,
     2      ' CPU time:',i4,':',i2,':',f6.3,/,1x,60('*'))
      return
      end
!-------------------------------------------------------------
code for XTimeINParz
      subroutine XTimeINParz(n)
c--initiate the current timing of a given operation
c  n the number that identifies this operation (1-10)
c
      USE General
      character*40 testo
      common /xtimes/ q(10),qp(10),qsum(10),testo(10)
c
      if (n.gt.10)  call cstop('XTimeINParz')
      call cpu_time(t1)
      qp(n)=t1
      return
      end
!-------------------------------------------------------------
code for XTimeParz
      subroutine XTimeParz(n,j)
c--calculate the current timing of a given operation
c  n the number that identifies this operation (1-10)
c  j 1 stampa
c    0 non stampa
c
      USE General
      USE LsqModule
      character*40 testo
      common /xtimes/ q(10),qp(10),qsum(10),testo(10)
c
      if (n.gt.10)  call cstop('XTimeParz')
      call cpu_time(t1)
      T=t1-qp(n)
      qsum(n)=qsum(n)+T
      if (j.eq.1) then
          nSecsTot = int(qsum(n))
          tmil=qsum(n)-nSecsTot
c	nmil=int(tmil*1000)
          iss = mod(nSecsTot,3600)
          ih = ( nSecsTot - iss ) / 3600
          is =  mod(iss,60)
          im  = ( iss - is ) / 60
          fismil=is+tmil
          if (iverb >= 0) write(lo,1000) testo(n),ih,im,fismil
      endif
1000  format(1x,60('*'),/,1x,a,/,
     2      ' CPU time:',i4,':',i2,':',f6.3,/,1x,60('*'))
      return
      end
!-------------------------------------------------------------
      subroutine CPUTime(string, Stampa)
      USE General
      USE PhaseModule, only : ifVLD, kWstop

      implicit none
      integer :: Stampa, Lung, L, iss, ih, im, is
      integer :: nSecsTot, nnSecsTot, nnMinsTot
      real    :: T
      character (len=*) :: string
!
! Print CPU time used since last called
!
!
      T=t1vet(jcpuP)

      call cpu_time(t1)
!
      T = t1-T
!      if (jcpuP.eq.1) then
          SecsTot = T
!      endif
      nnSecsTot = nint(SecsTot)
      nnMinsTot = nint(SecsTot / 60)
      nSecsTot = int(SecsTot)
      iss = mod(nSecsTot,3600)
      ih = ( nSecsTot - iss ) / 3600
      is =  mod(iss,60)
      im  = ( iss - is ) / 60
      Ore = ih
      Minuti = im
      Secondi = float(is) + amod(SecsTot, 1.0)
      if (Stampa == 1) then
          L = Lung(line_VLD)
          if (ksize <=3) then
               write(lo,15,err=5) string(1:Lung(string)), ih, im,
     *                            Secondi, nnSecsTot
               if (kWstop == 2 .and. ifDebug == 1) then
                   write(lo,'(a,i10)') line_VLD(1:L),nnSecsTot
               endif
          else
               write(lo,16,err=5) string(1:Lung(string)), ih, im,
     *                            Secondi, nnMinsTot
               if (kWstop == 2 .and. ifDebug == 1) then
                   write(lo,'(a,i10)') line_VLD(1:L),nnMinsTot
               endif
          endif
      else
              if (ksize <=3 ) then
                  write(Inte,25) ih, im, Secondi, nnSecsTot
              else
                  write(Inte,30) ih, im, Secondi, nnMinsTot
              endif
      endif
      call toflush()
!
    5 jcpuP = jcpuP - 1
      if (jcpuP.lt.0) then
          call cstop('CPUTIME error')
          write(0,*) 'CPUTime, jcpuP',jcpuP,string(1:lung(string))
      endif
*     write(0,*) 'CPUTime, jcpuP',jcpuP,string(1:lung(string))
!
      return
   10 format(/,a,' CPU Time   ',i6,'h',i3,'m',f6.2,'s')
   15 format(/,a,' CPU Time   ',i6,'h',i3,'m',f6.2,'s',i10,
     *' SecTot')
   16 format(/,a,' CPU Time   ',i6,'h',i3,'m',f6.2,'s',i10,
     *' MinTot')
   20 format('CPU Time',i4,'h',i3,'m',f6.2,'s')
   25 format('CPU Time',i4,'h',i3,'m',f6.2,'s',i10,' SecTot')
   30 format('CPU Time',i4,'h',i3,'m',f6.2,'s',i10,' MinTot')
      end
!-------------------------------------------------------------
      subroutine CPUTime_old(string, Stampa)
      USE General
      USE PhaseModule, only : ifVLD
      
      character*(*) string
      integer Stampa
!
! Print CPU time used since last called
!
!
      T=t1vet(jcpuP)

      call cpu_time(t1)
!
      T = t1-T
!      if (jcpuP.eq.1) then
          SecsTot = T
!      endif
      nnSecsTot = nint(SecsTot)
      nnMinsTot = nint(SecsTot / 60)
      nSecsTot = int(SecsTot)
      iss = mod(nSecsTot,3600)
      ih = ( nSecsTot - iss ) / 3600
      is =  mod(iss,60)
      im  = ( iss - is ) / 60
      Ore = ih
      Minuti = im
      Secondi = float(is) + amod(SecsTot, 1.0)
      L = lung(line_VLD) + 1
      if (Stampa == 1) then
*         if (knw == 0) then
*            write(lo,10,err=5) string(1:Lung(string)), ih, im, Secondi
*         else
             if (ksize <=3 ) then
                  write(lo,15,err=5) string(1:Lung(string)), ih, im,
     *                          Secondi, nnSecsTot
                  write(lo,'(a,i10)') line_VLD(1:L),nnSecsTot
             else
                write(lo,16,err=5) string(1:Lung(string)), ih, im,
     *                          Secondi, nnMinsTot
                  write(lo,'(a,i10)') line_VLD(1:L),nnMinsTot
             endif
*         endif
      else
*         if (knw == 0) then
*             write(Inte,20) ih, im, Secondi
*         else
              if (ksize <=3 ) then
                  write(Inte,25) ih, im, Secondi, nnSecsTot
              else
                  write(Inte,30) ih, im, Secondi, nnMinsTot
              endif
*         endif
      endif
      call toflush()
!
    5 jcpuP = jcpuP - 1
      if (jcpuP.lt.0) then
          call cstop('CPUTIME')
      endif
*     write(0,*) 'CPUTime, jcpuP',jcpuP,string(1:lung(string))
!
      return
   10 format(/,a,' CPU Time   ',i6,'h',i3,'m',f6.2,'s')
   15 format(/,a,' CPU Time   ',i6,'h',i3,'m',f6.2,'s',i10,
     *' SecTot')
   16 format(/,a,' CPU Time   ',i6,'h',i3,'m',f6.2,'s',i10,
     *' MinTot')
   20 format('CPU Time',i4,'h',i3,'m',f6.2,'s')
   25 format('CPU Time',i4,'h',i3,'m',f6.2,'s',i10,' SecTot')
   30 format('CPU Time',i4,'h',i3,'m',f6.2,'s',i10,' MinTot')
      end
!-------------------------------------------------------------
      subroutine CPUTime0(string)
      USE General
      character*(*) string
!
! Initialize CPU time routine
!
!
      
      call cpu_time(t1)
      jcpuP = jcpuP + 1
*     write(6,*) 'CPUTime0, jcpuP',jcpuP,string(1:lung(string))
      if (jcpuP.gt.10) then
          call cstop('CPUTIME0')
      endif
      t1vet(jcpuP) = t1
!pgMAD 2507
!      nSecs = nint(t1)
      nSecs = int(t1)
      iss = mod(nSecs,3600)
      ih = ( nSecs - iss ) / 3600
      is =  mod(iss,60)
      im  = ( iss - is ) / 60
      Secondi = float(is) + amod(t1, 1.0)
*     write(lo,10) string(1:Lung(string)), ih, im, Secondi
   10 format(/,a,' CPU Time0  ',i6,'h',i3,'m',f6.2,'s')
!pgMAD 2507
!
      return
      end
c-------------------------------------------------------------
      SUBROUTINE CPUTIMEtot(string)
      USE General
      character*200 string
      REAL  :: TX
!
! Print CPU time used since last called
!
      T=T1
      call cpu_time(TX)
      T1=TX
      IF(T1.LT.0.)GOTO 2
      T=T1-T
      k=len_trim(string)
      WRITE(lo,1)string(1:k),T
   1  FORMAT(/,' Routine: ',a,F10.1,' seconds CPU time')
      ttot=ttot+t
 2    RETURN
      END
c-------------------------------------------------------------
      subroutine sirtime(string,lstring)
      character *(*) string
!
!-- if a TIME function is not available
!-- tranform this subroutine in a dummy one
!-- leaving only the following lines
!--
!--              character *(*) string
!--              lstring=0
!--              return
!--              end
!
      character time*26
!
      call SirTm(time)
      string( 1:3)='At '
      string( 4:11)=time(12:19)
      string(12:12)=' '
      lstring=12
!
      return
      end
!-----------------------------------------------------------------------
      subroutine sirdate(string,lstring)
      character *(*) string
!
!-- if a DATE function is not available
!-- tranform this subroutine in a dummy one
!-- leaving only the following lines
!--
!--              character *(*) string
!--              lstring=0
!--              return
!--              end
!
      character stringa_data*26
!
      string=' '
      call SirTm(stringa_data)
      string( 1:11)=stringa_data( 1:11)
      string(12:16)=stringa_data(20:24)
      call shift(string,k)
      string(k+2:k+3)='at'
      string(k+5:k+12)=stringa_data(12:19)
      lstring=k+12
!
      return
      end
!-----------------------------------------------------------------------
      subroutine elapsed_time(Action, elTime, routine, buffer)
!
      implicit none
      integer :: Action, t1, t2, clock_rate, clock_max, L, Lung
      integer :: t1_tot, t2_tot, lenp, ier
      real    :: elTime, tmp
      character (len=3) :: unita
      character (len=*) :: routine, buffer
      common /el_time/ t1_tot, t2_tot, t1, t2
!
      if (Action == 1) then
          call system_clock (t1, clock_rate, clock_max)
          elTime = 0
      else
          call system_clock (t2, clock_rate, clock_max)
          tmp = real (t2 - t1) / real (clock_rate)
          buffer = 'Elapsed time in ' // routine
          L = Lung(buffer)
          if (tmp > 360) then
              tmp = tmp / 3600
              unita = ' h.'
          else if (tmp > 60) then
              tmp = tmp / 60
              unita = ' m.'
          else
              unita = ' s.'
          endif
          elTime = tmp
          write(buffer(L+1:),10) elTime, unita
          lenp = 0
          ier = 0
          call onebl(buffer,lenp,ier)
      endif
!
      return
   10 format(': ',f15.1,a3)
      end
!-----------------------------------------------------------------------
      subroutine elapsed_time_tot(Action, elTime, routine, buffer)
!
      implicit none
      integer :: Action, t1, t2, clock_rate, clock_max
      integer :: t1_tot, t2_tot, lenp, ier
      real    :: elTime, tmp
      character (len=3) :: unita
      character (len=*) :: routine, buffer
      common /el_time/ t1_tot, t2_tot, t1, t2
!
      if (Action == 1) then
          call system_clock (t1_tot, clock_rate, clock_max)
          elTime = 0
      else
          call system_clock (t2_tot, clock_rate, clock_max)
          tmp = real (t2_tot - t1_tot) / real (clock_rate)
          if (tmp > 360) then
              tmp = tmp / 3600
              unita = ' h.'
          else if (tmp > 60) then
              tmp = tmp / 60
              unita = ' m.'
          else
              unita = ' s.'
          endif
          elTime = tmp
          write(buffer,10) elTime, unita
          lenp = 0
          ier = 0
          call onebl(buffer,lenp,ier)
      endif
!
      return
   10 format('Elapsed time: ',f18.1,a3)
      end
!-----------------------------------------------------------------------
!     FILES RELATED ROUTINES
!-----------------------------------------------------------------------
      subroutine LeggiXENHeader(kform, cardImage, ncards, nComments)
!
      implicit none
      integer :: kform, ncards, nComments
      real    :: Valore
      character (len=*) :: cardImage
!
      rewind(kform)
      read(kform,'(a)') cardImage      ! header
      read(kform,'(a)') cardImage      ! number of cards per species
      ncards = nint(Valore(cardImage))
      nComments = 2
      do
         read(kform,'(a)') cardImage      ! comments
         if (cardImage(1:1) /= '#') then
             exit
         else
             nComments = nComments + 1
         endif
      enddo
      rewind(kform)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine CheckRecordLength
      USE General
      dimension ivet(512)
!
      ivet(:) = 0
      inquire(IOLENGTH = nlenBin) ivet
      return
!
      end
!-----------------------------------------------------------------------
      function jopen(ncsu, name, istat, iform, ier)
!--connect a unit to an external file
!  file properties:
!  sequential
!  formatted
!  ncsu = number identifies the unit
!  name = file name
!  istat = 0 means status unknown
!        = 1 means status scratch
!        = 2 means status old
!        = 3 means status unknown and append mode
!  iform = 1 means formatted
!        = 2 means unformatted
!  ier  = integer variable to receive a status indicator
!--
      character *(*) name
      character form(2)*11
!
      form(1) = 'formatted  '
      form(2) = 'unformatted'
!
      jopen = 0
      jump = istat
      select case (jump)

         case (0)        !   status = 'unknown'
             open(unit=ncsu, file=name, iostat=ier, err=9000,
     1       status='unknown', form=form(iform))

         case (1)        !   status = 'scratch'
             open(unit=ncsu, iostat=ier, err=9000,
     1       status='scratch', form=form(iform))

         case (2)        !   status = 'old'
             open(unit=ncsu, file=name, iostat=ier, err=9000,
     1       status='old', form=form(iform))

         case (3)        !   status = 'append'
             open(unit=ncsu, file=name, iostat=ier, err=9000,
     1       status='unknown', position='append', form=form(iform))

      end select
!
      if (ncsu /= 6.and.istat/=3) then
          if (ncsu /= 5) rewind ncsu
      endif
!
      return
!
 9000 jopen = -1
!
      return
      end
!-----------------------------------------------------------------------
      function kopen(ncsu, name, nlenBin, itype, ier)
!--connect a unit to an external file
!  file properties:
!  direct
!  unformatted
!  ncsu    = number identifies the unit
!  name    = file name
!  nlenBin = length in bytes for the records
!  itype   = 0 means status unknown
!          = 1 means status scratch
!          = 2 means status old
!  ier     = integer variable to receive a status indicator
!--
      character *(*) name
!
      kopen = 0
      jump  = itype
      select case (jump)

         case (0)        !   status = 'unknown'
            open(unit=ncsu,file=name,iostat=ier,err=9000,
     *      status='unknown',access='direct',
     2      form='unformatted',recl=nlenBin)

         case (1)        !   status = 'scratch'
            open(unit=ncsu,iostat=ier,err=9000,
     *      status='scratch',access='direct',
     2      form='unformatted',recl=nlenBin)

         case (2)        !   status = 'old'
            open(unit=ncsu,file=name,iostat=ier,err=9000,
     *      status='old',access='direct',
     2      form='unformatted',recl=nlenBin)

      end select
!
      return
!
 9000 kopen = -1
      return
      end
!-----------------------------------------------------------------------
      subroutine cRemoveFile(fsrc)
!
      implicit none
      integer Lung
      character*(*) fsrc
!
      call c_removefile(fsrc(1:Lung(fsrc))//char(0))
!
      return
      end
!-----------------------------------------------------------------------
      subroutine cRemoveDir(fsrc)
!
      implicit none
      integer Lung
      character*(*) fsrc
!
      call c_removedir(fsrc(1:Lung(fsrc))//char(0))
!
      return
      end
!-----------------------------------------------------------------------
      subroutine RemoveFile
      USE General
!
      implicit none
      integer :: Lung, l
      logical :: Esiste
!
      l = lung(Msg)
      inquire (file=Msg(1:l), exist = Esiste)
      if (Esiste) then
          call cRemoveFile(Msg)
          if (knw > 0) write(lo,10) Msg(1:l)
      endif
!
      return
   10 format(5x,'Removed ',a)
      end
!-----------------------------------------------------------------------
!     STRING MANIPULATION ROUTINES
!-----------------------------------------------------------------------
      subroutine ucase(line)
      character*(*) line
!
      k = len(line)
      do i=1,k
         j = ichar( line(i:i) )
         if (j > 96 .and. j < 123) then
             line(i:i) = char( j - 32 ) 
         endif
      enddo
c
      return
      end
!----------------------------------------------------------------------
      subroutine lcase(line)
      character*(*) line
!
      k = len(line)
      do i=1,k
         j = ichar( line(i:i) )
         if (j > 64 .and. j < 91) then
             line(i:i) = char( j + 32 ) 
         endif
      enddo
!
      return
      end
!----------------------------------------------------------------------
      subroutine filtra(string)
      character*(*) string
!
      k = index(string,char(13))
      do while (k > 0)
         string(k:k) = ' '
         k = index(string,char(13))
      enddo
!
      return
      end
!----------------------------------------------------------------------
      subroutine getnum(linei,vet,ivet,iv,iopt)
      dimension vet(40),ivet(40)
      character linei*(*), resto*780, cifre*80
      character Numdigit*13
      common /cifre/ Numdigit
      character blank
      real adig, espon, somma, dieci
!
!-- CTRL-M filter
!
      blank = ' '
      dieci = 10.0
      call filtra(linei)
      call shift(linei,lenp)
!        
      iv=0
      do i=1,40
         vet(i)=0.0
      enddo
      k=len(linei)
      resto = blank
      do i=1,k
         resto(i:i)=linei(i:i)
      enddo
    5 somma=0.0
      isum=0
      call cutst(resto,ncharl,cifre,nchard)
      if (nchard.le.0) return
      segno=1.0
      isegno=1
      iniz=1
      if (cifre(1:1).eq.Numdigit(12:12)) then
          segno=-1.0
          isegno=-1
          iniz=2
      endif
      ipoi=index(cifre(1:nchard),Numdigit(11:11))
      if (ipoi.eq.0) ipoi=nchard+1
      dec=ipoi-1-iniz
      idec=ipoi-1-iniz
      do i=iniz,nchard
         idig=index(Numdigit,cifre(i:i))
         if (idig.ge.1.and.idig.le.11)  then
             if (idig.le.10)  then
                 adig=float(idig-1)
                 espon=dieci**dec
*                somma=somma+float(idig-1)*10.0**dec
                 somma=somma+adig*espon
                 if (idec.ge.0) isum=isum*10+(idig-1)
                 dec=dec-1.0
                 idec=idec-1.0
             endif
         else
             iopt=-1
             return
         endif
      enddo
      iv=iv+1
      vet(iv)=somma*segno
      ivet(iv)=isum*isegno
      if (ncharl.le.0) then
          iopt=1
          return
      endif
      if (iv.eq.iopt) return
      go to 5
      end
!-----------------------------------------------------------------------
      subroutine getnumRic(linei,vet,ivet,iv,iopt)
      dimension vet(40),ivet(40)
      character linei*(*), resto*780, cifre*80
      character Numdigit*13
      common /cifre/ Numdigit
      character blank
      real adig, espon, somma, dieci
!
!-- CTRL-M filter
!
      blank = ' '
      dieci = 10.0
      call filtra(linei)
      call shift(linei,lenp)
!        
      iv=0
      do i=1,40
         vet(i)=0.0
      enddo
      k=len(linei)
      resto = blank
      do i=1,k
         resto(i:i)=linei(i:i)
      enddo
    5 somma=0.0
      isum=0
      call cutst(resto,ncharl,cifre,nchard)
      if (nchard.le.0) return
      a = ValoreRic(cifre)
      iv=iv+1
      vet(iv)=a
      ivet(iv)=nint(a)
      if (ncharl.le.0) then
          iopt=1
          return
      endif
      if (iv.eq.iopt) return
      go to 5
      end
!-----------------------------------------------------------------------
      subroutine shift(string,lenp)
*     USE General
      character string*(*)
!
      k=len(string)
!
!-- TAB filter
!
      do i=1,k
         j = ichar(string(i:i))
c--	 if (j.eq.9) then
!mr         if (j.lt.32.or.j.ge.127) then
         if (j.lt.32) then
             string(i:i)=' '
         endif
      enddo
      ifin=1
      do 10 i=1,k
      if (string(i:i).ne.' ') then
          iniz=i
          go to 20
      endif
   10 continue
      lenp=-1
      return
   20 do 30 i=k,1,-1
         if (string(i:i).ne.' ') then
             ifin=i
             go to 40
         endif
   30 continue
   40 continue
      lenp=ifin-iniz+1
      if (iniz.eq.1) then
          return
      endif
      do i=1,lenp
         j=iniz+i-1
         string(i:i)=string(j:j)
      enddo
      if (lenp.eq.k) return
      do i=lenp+1,k
         string(i:i)=' '
      enddo
c
      return
      end
!-----------------------------------------------------------------------
      subroutine cutst(string,lens,dire,lend)
      USE General
      character string*(*),dire*(*)
!
      k=len(dire)
      do i=1,k
         dire(i:i)=blank
      enddo
      k=len(string)
      do 10 i=1,k
      if (string(i:i).eq.blank) then
          iniz1=i
          go to 20
      endif
   10 continue
   20 continue
      lend=min0(iniz1-1,80)
      do i=1,lend
         dire(i:i)=string(i:i)
         string(i:i)=blank
      enddo
      call shift(string,lens)
c
      return
      end
!-----------------------------------------------------------------------
      function LenInPix(str, Size)
      USE Molcom
!
      character *(*) str
      integer Size
!
      ixv(1) = Size
      ind = 70
      iz = Lung(str)
      call graphs(iz, ind, str, 0, 0)
      LenInPix = ixv(1)
!
      return
      end
!-----------------------------------------------------------------------
      function LenInPix2(str,nChars, Size)
      USE Molcom
!
      character *(*) str
      integer Size
      character *128 tmp
!    
      ixv(1) = Size
      if (nChars.ne.0) then
         tmp = str(1:nChars)
      else
         tmp = str
      end if
!
      ind = 70
      iz = Lung(tmp)
      call graphs(iz, ind, tmp, 0, 0)
      LenInPix2 = ixv(1)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine CentraStr(icode,nchar,linea,stringa)
      USE General
!
      implicit none
      integer :: icode, nchar, lstringa, k, Lung
      character *(*) linea,stringa
!
      lstringa = Lung(stringa)
      if (lstringa > nchar) lstringa = nchar   ! riccardo 16/02/2011
      k = 1 + ( nchar - lstringa ) / 2
      linea = ' '
      linea(k:k+lstringa-1) = stringa
      if (icode == 1) write(lo,80) linea(1:nchar)
   80 format(2x,'*',a,'*')
!
      return
      end
!-----------------------------------------------------------------------
      subroutine ltrim(tmp)
      character *(*)tmp
      character *400 tmp2
!
      iz = 1
   10 if (tmp(iz:iz) .eq. ' ') then
         iz = iz + 1
         if (iz.lt.len(tmp)) goto 10
      end if
!
      tmp2 = tmp(iz:)
      tmp = tmp2
      return
      end
!------------------------------------------------------------------------
      real function ValoreCIF(string)
      implicit none
      real :: Valore
      character (len=*) :: string
!
      if (index(string,'e') > 0 .or. index(string,'E') > 0) then
          read(string,*) ValoreCIF
      else
          ValoreCIF = Valore(string)
      endif
!
      return
      end
!------------------------------------------------------------------------
      function Valore(string)
      character *(*) string, char *1
!
      call shift(string,L)
      if (string(1:1).eq.'-') then
          string(1:1) = ' '
          call shift(string,L)
          segno = -1.0
      elseif (string(1:1).eq.'+') then
          string(1:1) = ' '
          call shift(string,L)
          segno =  1.0
      else
          segno =  1.0
      endif
      L = Lung(string)
      i = 1
      Valore = 0.0
      if (L.eq.0) then
          return
      endif
   10 if (string(i:i) .eq. ' ') then
         if (i .eq. L) then
            return
         end if
         i = i + 1
         goto 10
      end if
      k = ichar('0')
      idec = 0
      exp = 1
      do 100 j=i, L
         char = string(j:j)
         if(char .eq. '.') then
            idec = 1
            goto 100
         end if
         v = ichar(string(j:j)) - k
         if (idec .ne. 0) then
            exp = exp / 10.
            Valore = Valore + v * exp
         else
            Valore = Valore * 10. + v
         end if
  100 continue
      Valore = Valore * segno
      return
      end
!-----------------------------------------------------------------------
      function ValoreRic(CardImageX)
!
!-- read a number from a string
!-- the numeric value is put in 'ValoreRic'
!
      implicit none
      integer             :: nc, nt, Lung, i, j
      real                :: ValoreRic, t, s, r, q, p
      character (len=*)   :: CardImageX
      character (len=13)  :: Numdigit
!
      common /cifre/ Numdigit
!      
!-- set up the initial constants
!
      nc = 1
      nt = Lung(CardImageX)
      j  = nc
      t  = 0.0
      s  = 1.0
      r  = 10.0
      q  = 1.0
      p  = 1.0
!
!--check the first character to be read
!
      if (CardImageX(nc:nc) == Numdigit(13:13)) goto 1050 
      if (CardImageX(nc:nc) == Numdigit(12:12)) then 
          s = -1.
          go to 1050
      endif
      if (CardImageX(nc:nc).eq.Numdigit(11:11)) goto 1040 
      goto 1100
!
!--check if this is  the first '.' found
!
1030  continue
      if (p <= 0.5) then  
          ValoreRic = t * s
          return
      endif
!
!--reset for reading after the '.'
!
1040  continue
      r = 1.0
      q = 0.1
      p = 0.1
1050  continue
      nc = nc + 1
!
!--check if this is end of card
!
      if (nc-nt-1 < 0) then  
!
!--check if this is the end of the number - ' '
!
         if (CardImageX(nc:nc) /= ' ') goto 1090 
      endif 
      ValoreRic  = t * s
      return
1090  continue
      if (CardImageX(nc:nc).eq.Numdigit(11:11)) goto 1030 
!
!--find the numeric equivalent of the character and add in
!
1100  continue
      do i=1, 10
         if (CardImageX(nc:nc) == Numdigit(i:i)) then 
             t = t * r + float(i-1) * q
             q = q * p
             go to 1050
         endif
      enddo
!
1130  continue
      ValoreRic = t * s
!
      return
      end
!-----------------------------------------------------------------------
      function isADigit(carattere)
      character *1 carattere
!
      character Numdigit*13
      common /cifre/ Numdigit
!
!
      if (index(Numdigit(1:10), carattere) > 0) then
          isADigit = 1
      else
          isADigit = 0
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine CutStr(tmp, iz)
      USE General
!
      character *(*)tmp
!
   10 if (tmp(iz:iz).ne.' '.and.tmp(iz:iz).ne.slash) then
         if (iz.gt.1) then
            iz = iz - 1
            goto 10
         end if
      end if
!
      iz = iz - 1
      return
      end
! ----------------------------------------------------------------------
      function Lung (Stringa)
!
      character  Stringa *(*)

      K = len (Stringa)
      do I = K, 1, -1
           num = ichar(Stringa(I:I))
!          if (Stringa(I:I) .NE. ' ') then
          if (num.ne.32.and.num.ne.0) then
             Lung = I
             return
          end if
      enddo
      Lung = 0
!
      return
      end
!---------------------------------------------------------------------
      subroutine CheckBlanks(fileh, ifin)
!
!-- check for blanks in the file name
!-- checks also if a rotation matrix has been given
!
      USE General
!
      character*(*) fileh
      dimension vet(40), ivet(40), MatOrV(9)
!
      inMatOrV = 9
      ifMatOr = 0
      ifin = Lung(cardDiret)
      k = ifin
      do while (k > 1)
         k = k -1
         if (cardDiret(k:k) == blank) then
             iopt = 0
             call getnum(cardDiret(k+1:ifin), vet, ivet, iv, iopt)
             if (iopt < 0) then
                 ifMatOr = 0
                 exit
             else
             MatOrV(inMatOrV) = ivet(1)
             inMatOrV = inMatOrV - 1
             cardDiret(k+1:ifin) = blank
             ifin = Lung(cardDiret)
             k = ifin
             endif
         endif
      enddo
      fileh = cardDiret(1:ifin)
      if (inMatOrV == 0) then
          ifMatOr = 1
          inMatOrV = 9
          do i=3,1,-1
             do j=3,1,-1
                MatOr(i,j) = MatOrV(inMatOrV)
                inMatOrV = inMatOrV - 1
             enddo
          enddo
      endif
!
      return
      end
!----------------------------------------------------------------------
      subroutine CheckSpaceGroupSymbol(DummySpaceGr, ier)
      USE General
      USE Symmetry
!
      integer :: k, DummySpaceGr(16)
      dimension ivet(40), vet(40)
      character symbol*16, newsymbol*13, line*13, newline*13
!
      nSpaceGroup = 0
      nSpaceGroupPatt = 0
!
!-- Convert Space Group Symbol in lower case character string
!
      write(symbol,'(16a1)') DummySpaceGr(1:16)
      call lcase(symbol)
      k = index(symbol,':')
      if (k > 0) then
          symbol(k:) = ' '
      endif
      if (symbol(1:1) == 'h') then
          symbol(1:1) = 'r'
      endif
      L = Lung(symbol)
      if (symbol(L:L) == 'h') then
          symbol(L:L) = ' '
      endif
!
!-- Check if Space Group Code has been supplied
!
      iopt = 0
      call getnum(symbol,vet,ivet,iv,iopt)
      if (iopt /= -1 .and. iv == 1) then
          Code = ivet(1)
          if ((Code > 0) .and. (Code < 231)) then
              istat = 2
              iform = 1
              jop = jopen(kform, iasun, istat, iform, ier)
              read(kform,'(a13)') line
              if (line(1:3) == 'p 1') then
                  nLinesLaue = 0
              else
                  nLinesLaue = 26
              endif
              rewind kform
              if (nLinesLaue > 0) then
                  do i=1, nLinesLaue
                     read(kform,'(a13)') line
                  enddo
              endif
              do
                 read(kform,'(a13,i2,i5)') line, kp, kf
                 if (Code == kf) then
                     symbol = line
                     nSpaceGroup = kf
                     nSpaceGroupPatt = kp
                     exit
                 endif
              enddo
              close(kform)
              read(symbol,'(16a1)') DummySpaceGr(1:16)
              return
          endif
      endif

!
!-- First check on Space Group Symbol conversion from
!-- International Table (1983) into the notation used in
!-- International Table (1974).
!                   controllo spostato in subr. symm, speriamo bene
!gian if (symbol(5:6).eq.'-3') then
!gian     symbol = symbol(1:4) // '3' // symbol(7:16) // ' '
!gian endif
!
      istat = 2
      iform = 1
      jop = jopen(kform, iasun, istat, iform, ier)
      read(kform,'(a13)') line
      if (line(1:3) == 'p 1') then
          nLinesLaue = 0
      else
          nLinesLaue = 26
      endif
      rewind kform
      if (nLinesLaue > 0) then
          do i=1, nLinesLaue
             read(kform,'(a13)') line
          enddo
      endif
!
!-- Check Space Group Symbol as it is
!
      iOK = 0
      do
         read(kform,'(a13,i2,i5)') line, kp, kf
         if (line(1:4) == '$$$$') then
             exit
         endif
         if (line == symbol(1:13)) then
             iOK = 1
             nSpaceGroup = kf
             nSpaceGroupPatt = kp
             exit
         endif
      enddo
      if (iOK == 0) then
          newsymbol(1:13) = symbol(1:13)
!
!-- Strip out parenthesis (if any)
!
          k1 = index(newsymbol, '(')
          if (k1 > 0) then
              k2 = k1
              do while (k1 > 0 .or. k2 > 0)
                 if (k1 > 0) newsymbol(k1:k1) = ' '
                 if (k2 > 0) newsymbol(k2:k2) = ' '
                 k1 = index(newsymbol, '(')
                 k2 = index(newsymbol, ')')
              enddo
          endif
!
          call NoBlanks(newsymbol, ls)
!
!-- Second check on Space Group Symbol conversion
!-- verificare quello che si voleva fate
!
*         if (newsymbol(3:4).eq.'-3') then
*             newsymbol = newsymbol(1:4) // '3' // newsymbol(7:13) //' '
*             ls = ls - 1
*         endif
!
!-- Check Space Group Symbol ( blanks stripped )
!
          rewind kform
          if (nLinesLaue > 0) then
              do i=1, nLinesLaue
                 read(kform,'(a13)') line
              enddo
          endif
          do
             read(kform,'(a13,i2,i5)') line, kp, kf
             if (line(1:4) == '$$$$') then
                 exit
             endif
             newline = line
             call NoBlanks(newline, ls)
             if (newline == newsymbol(1:13)) then
                 iOK = 1
                 nSpaceGroup = kf
                 nSpaceGroupPatt = kp
                 exit
             endif
          enddo
          if (iOK == 1) then
              symbol = line
          endif
      endif
      ier = 0
      lenp = 16
      call onebl(symbol,lenp,ier)
!
      close(kform)
      read(symbol,'(16a1)') DummySpaceGr(1:16)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine onebl(string,lenstr,ier)
      USE General
      character string*(*), poss*22
      dimension in(7)
c
      ier=0
      poss='pabcifrmabcnd-123456/ '
      blank=poss(22:22)
      k=len(string)
      if (lenstr.eq.0) then
          lunghezza = k
      else
          lunghezza = 16
      endif
c
c-- check the number of blanks between items in space
c-- group symbol ( max one blank allowed )
c
      Buffer1 = ' '
      ic=0
      j=1
      do i=1,k
         if (string(i:i).ne.blank) then
             Buffer1(j:j)=string(i:i)
             j=j+1
             if (j.gt.lunghezza) exit
             ic=0
         else
             if (ic.eq.0) then
                 ic=ic+1
                 Buffer1(j:j)=string(i:i)
                 j=j+1
                 if (j.gt.lunghezza) exit
             endif
         endif
      enddo
      do i=1,lunghezza
         string(i:i)=Buffer1(i:i)
      enddo
      if (lenstr.eq.0) then
          lenstr = Lung(string)
          return
      endif
c
c-- now check the correctness of the space group symbol
c
c     poss='pabcifrmabcnd-123456/ '
c                  123456789012345
c-- ifoll = possible following character
c         = 0   initial state ( actual char = blank )
c         = 1   only numbers < 7 ( not 5 )
c         = 2   only numbers < actual number or / or blank
c         = 3   only letters
c         = 4   only blank
      if (string(2:2).ne.blank) go to 800
      n=0
      k=0
      iz=0
      nbr=0
      do i=1,7
         in(i)=0
         if (string(1:1).eq.poss(i:i)) nbr=i
      enddo
      if(nbr.eq.0) go to 800
      do 100 i=2,lenstr
      if(string(i:i).ne.blank) go to 101
      minus=1
      num=0
      ifoll=0
      k=k+1
      go to 100
 101  m=0
      do j=1,14
         if (string(i:i).eq.poss(j+7:j+7)) m=j
      enddo
      if(m.eq.0.or.k.gt.3) go to 800
c     poss='pabcifrmabcnd-123456/ '
c                  123456789012345
      if (m.ge.1.and.m.le.6.and.ifoll.eq.3) then
          ifoll=4
      elseif (m.ge.1.and.m.le.6.and.ifoll.eq.0) then
          ifoll=4
      elseif (m.eq.7.and.ifoll.eq.0) then
          ifoll=1
          minus=-1
          num=num+1
      elseif (m.ge.8.and.m.le.13.and.ifoll.le.1) then
          ifoll=2
          iold=m-7
          if (iold.eq.5) go to 800
          num=num+1
          if (num.gt.2) go to 800
      elseif (m.ge.8.and.m.le.13.and.ifoll.eq.2) then
          inew=m-7
          if (inew.ge.iold) go to 800
          num=num+1
          if (num.gt.2) go to 800
          ifoll=2
      elseif (m.eq.14.and.ifoll.eq.2) then
          ifoll=3
      else
          go to 800
      endif
 100  continue
      if (minus.lt.0.and.num.eq.1) go to 800
c
c-- space group symbol ok
c
      return
c
c-- error
c
  800 continue
      ier=-1
      return
      end
!-----------------------------------------------------------------------
      subroutine StandardSPG(String, ier)
      USE General
      USE Symmetry
      USE Molcom
!
!-- Make Space Group Symbol standard 
!
      character*(*) String
      character a, b, poss*22
!
              ier = 0
              read(String,'(16a1)') nSpaceG
              call CheckSpaceGroupSymbol(nSpaceG, ier)
              write(String,'(16a1)') nSpaceG
              return
!
      ier = 0
      poss = 'pabcifrmabcnd-123456/ '
!
!-- Strip parenthesis
!
      k = Lung(String)
      Buffer1 = ' '
      j = 0
      do i=1, k
         a = String(i:i)
         if (a /= '(' .and. a /= ')') then
             j = j + 1
             Buffer1(j:j) = a
         endif
      enddo
      String = ' '
      String(1:j) = Buffer1(1:j)
!
!-- Insert blanks in Space Group Symbol
!
      Buffer1 = ' '
      k = Lung(String)
      Buffer1(1:1) = String(1:1)
      Buffer1(2:2) = blank
      j = 2
      do i=2, k
         ifBlank = 1
         a = String(i:i)
         b = String(i+1:i+1)
         j = j + 1
         Buffer1(j:j) = a
         if (a /= blank) then
             if (a == '/' .or. a == '-' .or. b == '/') then
                 ifBlank = 0
             elseif (a == '2') then
                 if (b == '1') then 
                     ifBlank = 0
                 endif
             elseif (a == '3') then
                 if (b == '1' .or. b == '2') then 
                     ifBlank = 0
                 endif
             elseif (a == '4') then
                 if (b == '1' .or. b == '2' .or. b == '3') then 
                     ifBlank = 0
                 endif
             elseif (a == '6') then
                 if (b == '1' .or. b == '2' .or. b == '3' .and.
     *               b == '4' .or. b == '5') then 
                     ifBlank = 0
                 endif
             endif
             if (ifBlank == 1) then
                 j = j + 1
                 Buffer1(j:j) = blank
             endif
         else
             j = j + 1
             Buffer1(j:j) = blank
         endif
      enddo
      String = ' '
      ls = j
      String(1:ls) = Buffer1(1:ls)
!
!-- Check that only one blank is between two symmetry operators
!
      call OneBlankOnly(String)
!
!-- Now check the correctness of the space group symbol
!
!     poss='pabcifrmabcnd-123456/ '
!                  123456789012345
!-- ifoll = possible following character
!         = 0   initial state ( actual char = blank )
!         = 1   only numbers < 7 ( not 5 )
!         = 2   only numbers < actual number or / or blank
!         = 3   only letters
!         = 4   only blank
!
      n   = 0
      k   = 0
      iz  = 0
      nbr = 0
      do i=1, 7
         if (string(1:1).eq.poss(i:i)) then
             nbr = i
         endif
      enddo
      if (nbr == 0) then
          ier = -1
      else
          do i=2, 16
             if (String(i:i) == blank) then
                 minus = 1
                 num = 0
                 ifoll = 0
                 k = k + 1
             else
                 m = 0
                 do j=1,14
                    if (String(i:i) == poss(j+7:j+7)) then
                        m = j
                    endif
                 enddo
                 if (m == 0 .or. k > 3) then
                     ier = -1
                     exit
                 else
                     if (m.ge.1.and.m.le.6.and.ifoll.eq.3) then
                         ifoll = 4
                     elseif (m.ge.1.and.m.le.6.and.ifoll.eq.0) then
                         ifoll= 4
                     elseif (m.eq.7.and.ifoll.eq.0) then
                         ifoll = 1
                         minus = -1
                         num = num + 1
                     elseif (m.ge.8.and.m.le.13.and.ifoll.le.1) then
                         ifoll = 2
                         iold = m - 7
                         if (iold.eq.5) then
                             ier = -1
                             exit
                         endif
                         num = num + 1
                         if (num.gt.2) then
                             ier = -1
                             exit
                         endif
                     elseif (m.ge.8.and.m.le.13.and.ifoll.eq.2) then
                         inew = m - 7
                         if (inew.ge.iold) then
                             ier = -1
                             exit
                         endif
                         num = num + 1
                         if (num.gt.2) then
                             ier = -1
                             exit
                         endif
                         ifoll = 2
                     elseif (m.eq.14.and.ifoll.eq.2) then
                         ifoll = 3
                     else
                         ier = -1
                         exit
                     endif
                 endif
             endif
          enddo
      endif
      if (minus < 0 .and. num == 1 .or. ier == -1) then
          ier = -1
      else
!
!-- Space group symbol ok
!
          read(String,'(16a1)') nSpaceG
!??!      call ti1983(nSpaceG) ci potrebbero essere problemi col -3
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine OneBlankOnly(String)
      USE General
!
!-- Check that only one blank is between two symmetry operators
!
      character*(*) String
!
      ls = Lung(String)
      k = 9999
      do while (k > 0)
         k = index(String(1:ls), '  ')
         if (k > 0) then
             Buffer1 = ' '
             Buffer1(1:k) = String(1:k)
             Buffer1(k+1:) = String(k+2:)
             String = ' '
             ls = ls - 1
             String(1:ls) = Buffer1(1:ls)
         endif
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine NoBlanks(String,ls) ! substitute xcmprp
      USE General
!
!-- Delete all blanks in String
!
      character*(*) String
      call shift(string,ls)
      ls = Lung(String)
      k = 9999
      do while (k > 0)
         k = index(String(1:ls), ' ')
         if (k > 0) then
             Buffer1 = ' '
             Buffer1(1:k-1) = String(1:k-1)
             Buffer1(k:) = String(k+1:)
             String = ' '
             ls = ls - 1
             String(1:ls) = Buffer1(1:ls)
         endif
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine FillBlanks(stringa,iAction,carattere)
!
!-- iAction = 0  all blanks but the rightmost are substitued by "carattere"
!-- iAction = 1  all blanks are substitued by "carattere"
!-- iAction = 2  all the rightmost "carattere" are filled with blanks
!
      USE General
!
      character*(*) stringa
      character carattere
!
      if (iAction == 0) then
          L = Lung(stringa)
      elseif (iAction == 1) then
          L = len(stringa)
      elseif (iAction == 2) then
          L = Lung(stringa)
      endif
      if (iAction /= 2) then
          do i=1, L
             if (stringa(i:i) == ' ') then
                 stringa(i:i) = carattere
             endif
          enddo
      else
          do i=L,1,-1
             if (stringa(i:i) == carattere) then
                 stringa(i:i) = ' '
             else
                 exit
             endif
          enddo
      endif
!
      return
      end
!------------------------------------------------------------------
      subroutine MoltMatVec(a, b, c)
      dimension a(3, 3), b(3), c(3)
!
! ---  matrix * vector
!
      do i=1, 3
         c(i) = 0
         do j=1, 3
            c(i) = c(i) + a(i,j) * b(j)
         enddo
      enddo
!
      return
      end
! ------------------------------------------------------------------
      subroutine MoltVecMat(a, b, c)
      dimension a(3, 3), b(3), c(3)
!
! --- vector * matrix
!
      do j=1, 3
         c(j) = 0
         do i=1, 3
            c(j) = c(j) + b(i) * a(i,j)
         enddo
      enddo
!
      return
      end
! --------------------------------------------------------------------
      subroutine MoltMatMat(b, du, w)
      dimension b(3,3), du(3,3), w(3,3)
!
! ---  matrix * matrix
!
      do i = 1 , 3
         do j = 1 , 3
            dum = 0
            do K = 1 , 3
               dum = dum + b(i, K) * du(K, j)
            enddo
            w(i, j) = dum
         enddo
      enddo
!
      return
      end
! --------------------------------------------------------------------
      subroutine inv3(a,det,v)
c
c---- calcola l'inversa della matrice a e la
c---- memorizza in v.
c---- a deve essere una matrice  3*3 non-singolare
c---- alfa e' la matrice aggiunta
c
      integer a(3,3),v(3,3),det,alfa(3,3)
c
c
      alfa(1,1)=a(2,2)*a(3,3)-a(2,3)*a(3,2)
      alfa(1,2)=-1*(a(2,1)*a(3,3)-a(2,3)*a(3,1))
      alfa(1,3)=a(2,1)*a(3,2)-a(2,2)*a(3,1)
      alfa(2,1)=-1*(a(1,2)*a(3,3)-a(1,3)*a(3,2))
      alfa(2,2)=a(1,1)*a(3,3)-a(1,3)*a(3,1)
      alfa(2,3)=-1*(a(1,1)*a(3,2)-a(1,2)*a(3,1))
      alfa(3,1)=a(1,2)*a(2,3)-a(1,3)*a(2,2)
      alfa(3,2)=-1*(a(1,1)*a(2,3)-a(1,3)*a(2,1))
      alfa(3,3)=a(1,1)*a(2,2)-a(1,2)*a(2,1)
      det=a(1,1)*alfa(1,1)+a(1,2)*alfa(1,2)+a(1,3)*alfa(1,3)
      if (det.ne.0) goto 200
      do i=1,3
          write(6,6) (a(i,j),j=1,3)
      enddo
      do i=1,3
         write(6,6) (alfa(i,j),j=1,3)
      enddo
   6  format(5x,3i8)
 200  do i=1,3
         do j=1,3
            v(i,j)=alfa(j,i)/det
         enddo
      enddo
      return
      end
! --------------------------------------------------------------------
      subroutine inv3r(a,det,v)
c
c---- calcola l'inversa della matrice a e la
c---- memorizza in v.
c---- a deve essere una matrice  3*3 non-singolare
c---- alfa e' la matrice aggiunta
c
      real a(3,3),v(3,3),alfa(3,3)
c
c
      alfa(1,1)=a(2,2)*a(3,3)-a(2,3)*a(3,2)
      alfa(1,2)=-1*(a(2,1)*a(3,3)-a(2,3)*a(3,1))
      alfa(1,3)=a(2,1)*a(3,2)-a(2,2)*a(3,1)
      alfa(2,1)=-1*(a(1,2)*a(3,3)-a(1,3)*a(3,2))
      alfa(2,2)=a(1,1)*a(3,3)-a(1,3)*a(3,1)
      alfa(2,3)=-1*(a(1,1)*a(3,2)-a(1,2)*a(3,1))
      alfa(3,1)=a(1,2)*a(2,3)-a(1,3)*a(2,2)
      alfa(3,2)=-1*(a(1,1)*a(2,3)-a(1,3)*a(2,1))
      alfa(3,3)=a(1,1)*a(2,2)-a(1,2)*a(2,1)
      det=a(1,1)*alfa(1,1)+a(1,2)*alfa(1,2)+a(1,3)*alfa(1,3)
      if (det.ne.0) goto 200
      do i=1,3
          write(6,6) (a(i,j),j=1,3)
      enddo
      do i=1,3
         write(6,6) (alfa(i,j),j=1,3)
      enddo
   6  format(5x,3f8.3)
 200  do i=1,3
         do j=1,3
            v(i,j)=alfa(j,i)/det
         enddo
      enddo
      return
      end
!-----------------------------------------------------------------------
      subroutine Trasp(a, b)
!
!-- calcola la trasposta della matrice a e la memorizza in b
!
      dimension a(3,3), b(3,3)
      do 20 i=1, 3
         do 10 j=1, 3
            b(i,j) = a(j,i)
   10    continue
   20 continue
      return
      end
!-----------------------------------------------------------------------
code for xmtmm
      subroutine xmtmm(a,b,c,l,m,n)
c--general matrix manipulation routines
c  a(l,m).b(m,n)=c(l,n)
      common /xmate/ m1d,m2d,n1d,n2d
      dimension a(*),b(*),c(*)
      m1d=l
      m2d=1
      n1d=1
      n2d=m
      call xmtmr(a,b,c,l,m,n)
      return
      end
c
code for xmtmt
      subroutine xmtmt(a,b,c,l,m,n)
c--a(l,m).b(n,m)'=c(l,n)
      common /xmate/ m1d,m2d,n1d,n2d
      dimension a(9),b(9),c(9)
      m1d=l
      m2d=1
      n1d=n
      n2d=1
      call xmtmr(a,b,c,l,m,n)
      return
      end
c
code for xmttm
      subroutine xmttm(a,b,c,l,m,n)
c--a(m,l)'.b(m,n)=c(l,n)
      common /xmate/ m1d,m2d,n1d,n2d
      dimension a(9),b(9),c(9)
      m1d=1
      m2d=m
      n1d=1
      n2d=m
      call xmtmr(a,b,c,l,m,n)
      return
      end
c
code for xmttt
      subroutine xmttt(a,b,c,l,m,n)
c--a(m,l)'.b(n,m)'=c(l,n)
      common /xmate/ m1d,m2d,n1d,n2d
      dimension a(9),b(9),c(9)
      m1d=1
      m2d=m
      n1d=n
      n2d=1
      call xmtmr(a,b,c,l,m,n)
      return
      end
c
code for xmtmr
      subroutine xmtmr(a,b,c,l,m,n)
c--main matrix multiplication routine
      common /xmate/ m1d,m2d,n1d,n2d
      dimension a(*),b(*),c(*)
      l1=1
      n2=1
      do 1030 j=1,n
      m2=1
      do 1020 i=1,l
      c(l1)=0.
      m1=m2
      n1=n2
      do 1010 k=1,m
      c(l1)=c(l1)+a(m1)*b(n1)
      m1=m1+m1d
      n1=n1+n1d
1010  continue
      l1=l1+1
      m2=m2+m2d
1020  continue
      n2=n2+n2d
1030  continue
      return
      end
!-----------------------------------------------------------------------
      subroutine randu1(ix,iy,yfl)
c ---
c ---computes uniformly distributed random real numbers between 0 and 1.
c ---
      iy=ix*65539
      if(iy)5,6,6
    5 iy=(iy+2147483647)+1
    6 yfl=iy
      yfl=yfl*.4656613e-9
      return
      end
!-----------------------------------------------------------------------
      subroutine hlconv1(mkang, peso, fase, aHLcoef, bHLcoef,
     *                                      cHLcoef, dHLcoef)
      USE General, only: dtor
!
      if (peso < 0.001) then
          peso    = 0.0
          aHLcoef = 0.0
          bHLcoef = 0.0
      else
          ffase = fase * dtor
          if (mkang == 1) then
             xx = acentx(peso)
          else
             xx = centx(peso)
          endif
          aHLcoef = xx * cos(ffase)
          bHLcoef = xx * sin(ffase)
          cHLcoef = xx * cos(2.*ffase)
          dHLcoef = xx * sin(2.*ffase)
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine geneq(lty,ih,kk,il,idelt,jcode,isnn,istd,rho,ireje)
      USE General
      USE Symmetry
!
      common /gianlucaProva/ maxi
      dimension kl1(24),kl2(24),kl3(24),i1(3),i1s(3),i2(3),ise(24)
!
      isnn = 1
      rho1 = rhof(pp,ih,kk,il)
      rho  = rho1 * rho1
      if (rho.lt.th) then
          ireje = 0
          i1(1) = ih
          i1(2) = kk
          i1(3) = il
          call SinThVal(i1, ro)
          jcode = 13
          ido   = 1
          maxi  = 1
          ise(maxi) = 1
          if (nsym.eq.1.and.icent.eq.0) then
!
!-- P 1 case
!
              ifl = 0
              do i=1,3
                 if (i1(i).ne.0.and.ifl.eq.0) then
                     if (i1(i).lt.0) then
                         ifl = 1
                         isnn = -1
                         ise(maxi)=isnn
                         i1(1) = -i1(1)
                         i1(2) = -i1(2)
                         i1(3) = -i1(3)
                     else
                         ifl = 1
                     endif
                 endif
              enddo
          endif
          do j=1,nsym
             kl1(j)=2400
             kl2(j)=2400
             do i=1,3
                i2(i)=0
                kl1(j) = kl1(j) - i1(i) * int(tsmat(i,j)*24+0.01)
                kl2(j) = kl2(j) - i1(i) * int(tsmat(i,j)*12+0.01)
             enddo
             kl1(j) = mod(kl1(j),24)
             do i=1,3
                do k=1,2
                   m=iabs(ismat(k,i,j))
                   if (m.gt.0) then
                       i2(m)=i2(m)+i1(i)*isign(1,ismat(k,i,j))
                   endif
                enddo
             enddo
             isnn = 1
             ifl = 0
             do i=1,3
                if (i2(i).ne.0.and.ifl.eq.0) then
                    if (i2(i).lt.0) then
                        ifl = 1
                        isnn = -1
                        i2(1) = -i2(1)
                        i2(2) = -i2(2)
                        i2(3) = -i2(3)
                    else
                        ifl = 1
                    endif
                endif
             enddo
             if (icent.eq.1.or.ido.ne.1) goto 230
             jcode=1
             do i=1,3
                if (i1(i)+i2(i).ne.0) go to 230
             enddo
             jcode=mod(kl2(j),12)+1
             if (jcode.le.1) jcode=jcode+12
             ido=0
!!230        ind=262144 * i2(1) + 512 * i2(2) + i2(3)
!!           kl3(j)=131328 + iabs(ind)
  230        ind = (i2(1) + 512) * ifat512a +
     *             (i2(2) + 512) * ifat512b + 
     *             (i2(3) + 512)
             kl3(j) = ind 
!!!          write(99,'(i2,1h),6i4,i15,a)') j,i1,i2,ind,'  Gen2002'
             if (lty.eq.1) then
                 rhomax=amax1(rhomax,rho1)
                 if (ihmx(1).lt.iabs(i2(1))) ihmx(1)=iabs(i2(1))
                 if (ihmx(2).lt.iabs(i2(2))) ihmx(2)=iabs(i2(2))
                 if (ihmx(3).lt.iabs(i2(3))) ihmx(3)=iabs(i2(3))
             endif
             if (j.ne.1) then
                 jm1=j-1
                 do i=1,jm1
                    if (kl3(i).eq.kl3(j)) kl3(j)=0
                 enddo
                 if (kl3(j).gt.kl3(maxi)) then
                     maxi = j
                     ise(maxi) = isnn
                 endif
             endif
          enddo
          isnn=ise(maxi)
          call unpack2002(kl3(maxi),ih,kk,il)
!!!    write(99,'(i4,i15,3i4,a)') maxi,kl3(maxi),ih,ik,il,'  Gen2002'
          idelt=kl1(maxi)*15
          istd=0
          jcodes = jcode
          if (icent.eq.0) then
              ido=1
              i1s(1)=ih
              i1s(2)=kk
              i1s(3)=il
              do j=1,nsym
                 kl1(j)=24000
                 do i=1,3
                    i2(i)=0
                    kl1(j)=kl1(j)+i1s(i) * nint(tsmat(i,j)*12)
                 enddo
                 do i=1,3
                    do k=1,2
                       m=iabs(ismat(k,i,j))
                       if (m.gt.0) then
                           i2(m)=i2(m)+i1s(i)*isign(1,ismat(k,i,j))
                       endif
                    enddo
                 enddo
                 if (ido.eq.1) then
                     jcode=1
                     ifl = 0
                     do i=1,3
                        if (i1s(i)+i2(i).ne.0) ifl = 1
                     enddo
                     if (ifl.eq.0) then
                         jcode1 = mod ( kl1(j) , 24 )
                         jcode2 = mod ( ( jcode1 + 12 ), 24 )
                         jcode = min0 ( jcode1 , jcode2 )
                         jcode = jcode + 1
                         if (jcode.le.1) jcode=jcode+12
                         ido=0
                     endif
                 endif
              enddo
          endif
      else
          ireje = 1
      endif
      if (lty.ne.1) then
          if (i1(1).eq.ih.and.i1(2).eq.kk.and.i1(3).eq.il) istd=1
      endif
!
      return
      end
!------------------------------------------------------------
      function rhof(p,jh,jk,jl)
      dimension p(6)
      integer hkl(3)
c
!     hkl(1) = jh
!     hkl(2) = jk
!     hkl(3) = jl
!     call CalcolaRho(hkl, rho)
!     rhof = sqrt(rho)
      rho2=p(1)*float(jh*jh)+p(2)*float(jk*jk)
     1 +p(3)*float(jl*jl)+p(4)*float(jh*jk)
     2 +p(5)*float(jh*jl)+p(6)*float(jk*jl)
      rhof=sqrt(rho2)

      return
      end
!--------------------------------------------------------------------
      subroutine SinThVal(hh, rho)
      USE SinTh
!
!-- rho = ( sin(theta)/lamba ) ** 2
!
      implicit none
      integer :: hh(3)
      real    :: rho, q
!
      q = hh(1) * hh(1) * astar * astar
     1  + hh(2) * hh(2) * bstar * bstar
     2  + hh(3) * hh(3) * cstar * cstar
     3  + 2.0 * hh(2) * hh(3) * bstar * cstar * cosas
     4  + 2.0 * hh(3) * hh(1) * cstar * astar * cosbs
     5  + 2.0 * hh(1) * hh(2) * astar * bstar * coscs
      rho = 0.25 * q
!
      return
      end
!---------------------------------------------------------------------
