#include <utils.h>
#include <sir_application.h>
#include "glext.h"
#include "maps.h"
#include "callbacks2d.h"

using namespace std;
namespace GLextmr
{
    extern GtkWidget *GLWINDOW;
    extern Mappa *MapInfo;
}

namespace main_app
{
    extern Application JavApp;
}

using namespace GLextmr;	

string getFilePng(GLWindow *gl)
{
    string nome_mappa = str_cut(MapInfo[gl->activeMap].name, ".");
    nome_mappa.append(".png"); 
    string filname(g_build_filename(getPWD(), nome_mappa.c_str(), NULL));
    return filname;
}    

GdkColor *get_colorgdk(int new_color)
{
   return main_app::JavApp.getgdkCol(new_color);
}

float *getfColor(int icol)
{
    if(icol < 16)
       return(ToColor3f(get_colorgdk(icol+NUM_COLORS+16)));
    else
       return(ToColor3f(get_colorgdk(icol)));
}

void openContourDlg(gpointer item, gpointer data)
{
     int quale = GPOINTER_TO_INT(data);
     switch(quale)
     {
     case 1:
          doopenContourDlg1();
	  break;
     case 2:
          doopenContourDlg2();
	  break;
     case 3:
          doopenContourDlg3();
	  break;
     }
}

void ScreenShotContour(gpointer item, gpointer data)
{
using namespace gtkext;
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   string fn = "";
   string extensions;
   vector<string> types, exts;
   int ke = fill_formats(types, exts, extensions);
   if(ke == -1)
      return;
   
   bool ifT = false;
   bool showT = false;
   fn =  dlg_select_file(window, fn, eSELECT_TO_WRITE, extensions.c_str(), showT, &ifT);
   if(str_white(fn.c_str()))
       return;
   
   ke = find_extension_in_list(fn, exts);
   if(ke == -1)
      return;
   string filname = getFilePng(gl);
   mr_CopyFile(filname.c_str(), fn.c_str());
}

void openModelCont(gpointer item, gpointer data)
{
}

void ChangeSection(gpointer item, gpointer data)
{
using namespace GLextmr;
    int quanto = 5;
    if(item)
       quanto = GPOINTER_TO_INT(data) - 1;
    ChangeSectionContour(quanto, GLWINDOW);
}

void on_toggle_cell(gpointer item, gpointer data)
{
     SetCell(obj_get_active(item));
}

void on_toggle_grid(gpointer item, gpointer data)
{
     SetGrid(obj_get_active(item));
}

void end_tbcontour(gpointer item, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GtkWidget *ht = get_widget(window, "ctoolbar");
   gtk_widget_hide(ht);
   ht = get_widget(window, "toolbar");
   gtk_widget_show(ht);
   ht = get_widget(window, "vtoolbar");
   gtk_widget_set_sensitive(ht, TRUE);
   ht = get_widget(window, "menubar");
   gtk_widget_set_sensitive(ht, TRUE);
   obj_set_active(get_object(window, "Contour"), FALSE);
}

static GtkWidget *about_contdlg = NULL;
void AboutContour (gpointer, gpointer data)
{
    gtkext::AboutItem it;
    GtkWidget *main_window;

    memset(&it, 0, sizeof(gtkext::AboutItem));
    main_window = ( GtkWidget *) data;
    if (about_contdlg == NULL)
    {
       it.title            = DuplicaStringa("About Contour Routine");
       it.image            = DuplicaStringa("contourb.png");
       //it.text1            = DuplicaStringa("<span  size=\"medium\">"
       //                              "This part of the code is\n"
       //                              "based on routines written by\n</span>"
       //                              "<span foreground=\"blue\" size=\"x-large\">"
       //                              "Javier Gonzalez-Platas</span>");
       it.browser          = g_strdup_printf("%s", main_app::JavApp.InternetBrowser().c_str());
       about_contdlg       = create_about_dialog(main_window, &it);
     }

    gtk_widget_show_all (about_contdlg);
    gdk_window_raise (gtk_widget_get_window(about_contdlg));
}


void on_contour2D(gpointer item, gpointer data)
{
using namespace GLextmr;
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   gboolean active = obj_get_active(item);
   if(gl->nMaps > 0)
   {
      gl->if2Dcontour = (active != 0);
      if(gl->if2Dcontour)
      {
         GtkWidget *ht = get_widget(window, "toolbar");
         gtk_widget_hide(ht);
         ht = get_widget(window, "ctoolbar");
         gtk_widget_show(ht);
         ht = get_widget(window, "vtoolbar");
         gtk_widget_set_sensitive(ht, FALSE);
         ht = get_widget(window, "menubar");
         gtk_widget_set_sensitive(ht, FALSE);
         initcontourJav(&gl->Width, &gl->Height);
      }
      return;
   }
   int hnd = get_int(item, "hnd");
    g_signal_handler_block(G_OBJECT(item), hnd);
    obj_set_active(item, FALSE);
    g_signal_handler_unblock(G_OBJECT(item), hnd);

   gl->if2Dcontour = 0;
}

extern "C" void settacontour_(int *flag)
{
using namespace GLextmr;

     if(!GLWINDOW)
        return;
     GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
     gl->if2Dcontour = (*flag != 0);
}

