#include "cont_dlg1.h"
#ifdef _WIN32
float round(float x)
{
   return x >= 0.0f ? floorf(x + 0.5f) : ceilf(x - 0.5f);
}
#endif

static void ok_dlg(GtkWidget *button, gpointer data)
{
    ContDlg1 *cont = (ContDlg1 *) data;
    cont->CloseDlg(button, GINT_TO_POINTER(1));
}

static void apply_dlg(GtkWidget *button, gpointer data)
{
    ContDlg1 *cont = (ContDlg1 *) data;
    cont->CloseDlg(button, GINT_TO_POINTER(2));
}

static void close_dlg(GtkWidget *button, gpointer data)
{
    ContDlg1 *cont = (ContDlg1 *) data;
    cont->CloseDlg(button, GINT_TO_POINTER(0));
}

GtkWidget *color_row(int iColor, GCallback cb, gpointer data)
{
   float *colore = getfColor(iColor);
   GtkWidget *button = mycolor_button(colore, "", cb, data);
   gtk_widget_set_size_request(button, 18, 18);
   gtk_widget_show_all(button);
   mycolor_button_set_color(button, colore);
   g_object_set_data(G_OBJECT(button), "colore", GINT_TO_POINTER(iColor));
   return button;
}

void set_color_row(GtkWidget *wid, int iColor)
{
   float *colore = getfColor(iColor);
   mycolor_button_set_color(wid, colore);
   g_object_set_data(G_OBJECT(wid), "colore", GINT_TO_POINTER(iColor));
}

void selected_level_color(GtkWidget *button, GdkEvent *, gpointer but)
{
   int num = get_int(button, "quale");

   set_color_row((GtkWidget *)but, num);
   gtk_widget_destroy(gtk_widget_get_toplevel(button));
   gtk_main_quit();
}

void show_colors(GtkWidget *button, GdkEvent *, gpointer data)
{
  int i, posx, posy;
  GtkWidget *box, *frame, *popwin;
  char nume[4];
  GtkWidget *father = gtk_widget_get_toplevel(button);

  popwin = gtk_window_new(GTK_WINDOW_POPUP);
  g_object_set_data(G_OBJECT(father), "popwin", popwin);

  frame = gtk_frame_new(NULL);
  gtk_container_add(GTK_CONTAINER(popwin), frame);
  gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_ETCHED_OUT);
  box = table_new(4, 4, TRUE);
  gtk_container_add(GTK_CONTAINER(frame), box);
  gtk_container_set_border_width(GTK_CONTAINER(box), 10);

  for(i=0; i<16; i++)
  {
       int iColor = i + NUM_COLORS + N_OBJS;
       frame = color_row(iColor, G_CALLBACK(selected_level_color),  button);
       table_attach(box, frame, i%4, i%4+1, i/4, i/4+1);
       ScriviStringa(nume, sizeof(nume), "%d", i);
       g_object_set_data(G_OBJECT(popwin), nume, frame);
       g_object_set_data(G_OBJECT(frame), "quale", GINT_TO_POINTER(iColor));
  }
  gtk_window_get_position(GTK_WINDOW(gtk_widget_get_toplevel(button)), &posx, &posy);
  GtkAllocation allocation;
  gtk_widget_get_allocation(button, &allocation);
  posx += allocation.x;
  posy += allocation.y;
  gtk_window_move(GTK_WINDOW(popwin), posx, posy);
  gtk_widget_show_all(popwin);
//  gdk_window_set_cursor(gtk_widget_get_window(popwin), pick_cursor);

  gtk_main();
}

GtkWidget *create_combo_colors(GtkWidget *parentbox,
                          int default_selected)
{
  GtkWidget *frame = color_row(default_selected, G_CALLBACK(show_colors), NULL);
#ifdef IN_GTK3
  GtkWidget *align = gtk_frame_new (NULL);
  gtk_frame_set_shadow_type (GTK_FRAME (align), GTK_SHADOW_NONE);
  gtk_widget_set_hexpand(frame, FALSE);
  gtk_widget_set_vexpand(frame, FALSE);
  g_object_set(G_OBJECT(frame), "halign", GTK_ALIGN_CENTER, NULL);
  g_object_set(G_OBJECT(frame), "valign", GTK_ALIGN_CENTER, NULL);
#else
  GtkWidget *align = gtk_alignment_new (0.5f, 0.5f, 0.f, 0.f);
#endif
  gtk_widget_show(align);
  gtk_box_pack_start (GTK_BOX (parentbox), align, FALSE, FALSE, 8);
  gtk_widget_show(frame);
  gtk_container_add(GTK_CONTAINER(align), frame);
  set_tip (frame, "Click to change level color");
  return frame;
}

void ContDlg1::SettaContour(myContour *cont1)
{
     Contour = cont1;
}

void ContDlg1::ChangeColorsCombo (GtkToggleButton *button, gpointer data)
{
   GtkWidget *wid;
   int i, j;

   i = gtk_toggle_button_get_active(button);
   for(j=0;j<5;j++)
   {
       if(i)
          lcolor[j] = 4 + j + N_OBJS+NUM_COLORS;
       else
          lcolor[j] = 15 - j + N_OBJS+NUM_COLORS;
       std::stringstream num;
       num << "col" << i;
       wid = get_widget(GTK_WIDGET(dlg), num.str().c_str());
       set_color_row(wid, lcolor[j]);
  }
}

void ContDlg1::CloseDlg (GtkWidget *button, gpointer data)
{
   GtkAdjustment *adj;
   int ifOk;
   int i;

   ifOk = GPOINTER_TO_INT(data);
   if(ifOk)
   {
      for (i=0; i<5; i++)
      {
           std::stringstream num;
           num << "cb" << i;
           GtkWidget *wid = get_widget(GTK_WIDGET(dlg), num.str().c_str());
           lvis[i] = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(wid));
           num.str("");
           num << "sc" << i;
           wid = get_widget(GTK_WIDGET(dlg), num.str().c_str());
           adj = gtk_range_get_adjustment ((GtkRange *)wid);
           lval[i] = (int) gtk_adjustment_get_value(adj);
           num.str("");
           num << "col" << i;
           wid = get_widget(GTK_WIDGET(dlg), num.str().c_str());
           lcolor[i] = get_int(wid, "colore");
      }
#if 0
      GtkWidget *wid = lookup_widget(GTK_WIDGET(button), "bg");
      i = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(wid));
      if(i != dialogo->jBackGround)
      {
         dialogo->jBackGround = i;
         change_bg("togbg", dialogo->jBackGround, 1);
      }
#endif
      int ifChanged = 0;
      for(int i=0; i<5; i++)
      {
         if (Contour->ifLevel[i] != lvis[i])
	 {
             ifChanged = ifChanged + 1;
             Contour->ifLevel[i]  = lvis[i];
	 }
         int k = 3 * (i + 1);
         if (lval[i] != round(Contour->Soglie[k-1]))
	 {
             float soglia3 = (float) lval[i] / 3.0f;
             Contour->Soglie[k-3]   = soglia3;
             Contour->Soglie[k-2]   = soglia3 * 2.0f;
             Contour->Soglie[k-1]   = soglia3 * 3.0f;
             ifChanged = ifChanged + 10;
	 }
         if (Contour->LevelCol[i] != lcolor[i])
	 {
             Contour->LevelCol[i]  = lcolor[i];
             ifChanged = ifChanged + 1;
	 }
      }
      putinfocontour_(Contour);
      if(ifChanged >= 10)
             preparacontour_();
      else if(ifChanged >= 1)
             plotcontourjav_();
   }
   if(ifOk <= 1)
      gtk_widget_hide(dlg);
}

ContDlg1::ContDlg1 ():
	Contour(nullptr),
	dlg(nullptr)
{
    GtkWidget *wid1=nullptr, *wid2, *wid;
	
    dlg = gtk_dialog_new();
    gtk_window_set_title(GTK_WINDOW(dlg), "Set contour levels");
    GtkWidget *vbox = (gtk_dialog_get_content_area(GTK_DIALOG(dlg)));
    gtk_container_set_border_width(GTK_CONTAINER(vbox), 10);

    GtkWidget *table = table_new(5, 3, FALSE);
    gtk_widget_show(table);
    table_set_row_spacings(table, 0);
    table_set_col_spacings(table, 0);
    gtk_box_pack_start(GTK_BOX(vbox), table, TRUE, TRUE, 4);

    for(int j=0; j<3; j++)
    {
        for(int i=0; i<5; i++)
        {
            wid = gtk_frame_new(NULL);
            table_attach(table, wid, j, j+1, i, i+1, TRUE);
            gtk_widget_show(wid);
	    std:: stringstream num;
            switch (j)
            {
            case 0:
               num << " " << i+1 << " ";
               wid1 = LABEL_NEW(num.str().c_str(), LABELCOLOR);
               gtk_widget_show(wid1);
               break;
            case 1:
               num << "cb" << i;
               wid1 = gtk_check_button_new();
               g_object_set_data(G_OBJECT(dlg), num.str().c_str(), wid1);
               gtk_widget_show(wid1);
               break;
            case 2:
               wid1 = hbox_new(FALSE, 0);
               gtk_widget_show(wid1);
               wid2 = hscale_new(GTK_ADJUSTMENT(adj_new (
                       10, 10, 200, 0, 10)));
               gtk_scale_set_digits(GTK_SCALE(wid2), 0);
	       num.str("");
               num << "sc" << i;
               g_object_set_data(G_OBJECT(dlg), num.str().c_str(), wid2);
               gtk_box_pack_start (GTK_BOX (wid1), wid2, TRUE,TRUE, 0);
               gtk_widget_set_size_request(wid2, 120, -1);
               gtk_widget_show(wid2);
               lcolor[i] = i+4+N_OBJS+NUM_COLORS;
               wid2 = create_combo_colors (wid1, lcolor[i]);
	       num.str("");
               num << "col" << i;
               g_object_set_data(G_OBJECT(dlg), num.str().c_str(), wid2);
               gtk_widget_show(wid2);
               break;
            }
	    if(wid1)
               gtk_container_add(GTK_CONTAINER(wid), wid1);
        }
    }

    wid1 = hbox_new(TRUE, 2);
    gtk_container_set_border_width(GTK_CONTAINER(wid1), 8);
    gtk_box_pack_start(GTK_BOX(vbox), wid1, FALSE, TRUE, 4);
    gtk_widget_show(wid1);
#if 0    

    wid2 = LABEL_BOLD("Background setting", LABELCOLOR, 1.2f);
    gtk_box_pack_start(GTK_BOX(wid1), wid2, FALSE, TRUE, 0);
    gtk_widget_show(wid2);

    icon2 = create_image("bbackgoff.png");
    wid2 = mr_toggle_button_new_with_pixmap(icon2, dialogo->jBackGround);
    gtk_box_pack_start (GTK_BOX (wid1), wid2, FALSE, FALSE, 0);
    g_object_set_data(G_OBJECT(dlg), "bg", wid2);
    (void) g_signal_connect (G_OBJECT (wid2), "clicked",
                      G_CALLBACK(change_colors_combo), NULL);
    gtk_widget_show(wid2);
#endif
    wid1 = OK_button();
    gtk_dialog_add_action_widget(GTK_DIALOG (dlg), wid1, 1);
    (void) g_signal_connect (G_OBJECT (wid1), "clicked",
                      G_CALLBACK(ok_dlg), (gpointer) this);

    wid1 = APPLY_button();
    gtk_dialog_add_action_widget(GTK_DIALOG (dlg), wid1, 2);
    (void) g_signal_connect (G_OBJECT (wid1), "clicked",
                      G_CALLBACK(apply_dlg), (gpointer) this);
    wid1 = CANCEL_button();
    gtk_dialog_add_action_widget(GTK_DIALOG (dlg), wid1, 3);
    gtk_button_box_set_layout(GTK_BUTTON_BOX(
      gtk_widget_get_parent(wid1)), GTK_BUTTONBOX_SPREAD);

    (void) g_signal_connect (G_OBJECT (wid1), "clicked",
                      G_CALLBACK(close_dlg), (gpointer) this);
    (void) g_signal_connect_swapped(G_OBJECT(dlg), "delete_event",
         G_CALLBACK(gtk_button_clicked), G_OBJECT(wid1));
   (void) g_signal_connect (G_OBJECT (dlg), "delete_event",
                      G_CALLBACK(true_cb), NULL);
}

void ContDlg1::ShowDlg(GtkWidget *parent)
{	
      int grid[3];
      //wid = lookup_widget(dlg, "bg");
      //gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(wid), dialogo->jBackGround);
      getinfocontour_(grid, Contour);
      float smin = 0;
      float smax = (float)Contour->massimoMappa;
      if(!dlg)
	 new ContDlg1();

      for(int i=0; i<5; i++)
      {
          lval[i] = (int) Contour->Soglie[3*i+2];
          if(Contour->LevelCol[i] > (N_OBJS + NUM_COLORS))
             lcolor[i] = Contour->LevelCol[i];
          else
             lcolor[i] = i+4+N_OBJS+NUM_COLORS;
          lvis[i] = Contour->ifLevel[i];
	  std::stringstream num;
	  num << "sc" << i;
          GtkWidget *wid = get_widget(GTK_WIDGET(dlg), num.str().c_str());
          GObject *adj = adj_new((float)lval[i], smin, smax, 0, 10);
          gtk_range_set_adjustment ((GtkRange *)wid, (GtkAdjustment*) adj);
	  num.str("");
	  num << "cb" << i;
          wid = get_widget(GTK_WIDGET(dlg), num.str().c_str());
          gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(wid), lvis[i]);
	  num.str("");
	  num << "col" << i;
          wid = get_widget(GTK_WIDGET(dlg), num.str().c_str());
          set_color_row(wid, lcolor[i]);
      }
      gtk_window_set_transient_for(GTK_WINDOW(dlg), GTK_WINDOW(parent));
      gtk_widget_show(dlg);
}

