#include "cont_dlg2.h"
#include <cerrno>

using namespace std;

extern "C" void finish_limitsjav_();

static void on_cb_show(GtkToggleButton *button, GtkWidget *to_show)
{
   gboolean st;

   st = gtk_toggle_button_get_active(button);
   obj_set_visible(to_show, st);
}

static void ok_dlg(GtkWidget *, gpointer data)
{
    ContDlg2 *cont = (ContDlg2 *) data;
    cont->CloseDlg(GINT_TO_POINTER(1));
}

static void close_dlg(GtkWidget *, gpointer data)
{
    ContDlg2 *cont = (ContDlg2 *) data;
    cont->CloseDlg(GINT_TO_POINTER(0));
}

ContDlg2::ContDlg2() :
	Contour(nullptr),
	dlg(nullptr)
{
    GSList *group = NULL;

    dlg = gtk_dialog_new();
    gtk_window_set_title(GTK_WINDOW(dlg), "Set limits");
    GtkWidget *vbox = (gtk_dialog_get_content_area(GTK_DIALOG(dlg)));
    gtk_container_set_border_width(GTK_CONTAINER(vbox), 10);
    
    GtkWidget *wid1 = FRAME_NEW("Limits", LABELCOLOR);
    gtk_widget_show(wid1);
    gtk_box_pack_start(GTK_BOX (vbox), wid1, TRUE, TRUE, 0);
    gtk_container_set_border_width(GTK_CONTAINER(wid1), 2);

    GtkWidget *wid = vbox_new(FALSE, 0);
    gtk_widget_show(wid);
    gtk_container_add(GTK_CONTAINER (wid1), wid);

    GtkWidget *wid2 = LABEL_BOLD("Select part of the map", LABELCOLOR, 1.2f);
    gtk_widget_show(wid2);
    set_alignment(wid2, 0., 0.5);
    gtk_box_pack_start (GTK_BOX (wid), wid2, FALSE, FALSE, 0);

    GtkWidget *frame = FRAME_NEW("Box", LABELCOLOR);

    GtkWidget *frame1 = FRAME_NEW("Cells", LABELCOLOR);

    GtkWidget *radio = RADIO_BUTTON_WITH_LABEL (group, "Asymmetric unit", LABELCOLOR);
    group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
    g_object_set_data(G_OBJECT(dlg), "radio1", radio);
    gtk_widget_show(radio);
    gtk_box_pack_start (GTK_BOX (wid), radio, FALSE, FALSE, 0);

    radio = RADIO_BUTTON_WITH_LABEL (group, "Complete unit cell", LABELCOLOR);
    group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
    g_object_set_data(G_OBJECT(dlg), "radio2", radio);
    gtk_widget_show(radio);
    gtk_box_pack_start (GTK_BOX (wid), radio, FALSE, FALSE, 0);
    (void) g_signal_connect (G_OBJECT (radio), "toggled",
                       G_CALLBACK(on_cb_show),frame1);

    //radio = RADIO_BUTTON_WITH_LABEL (group, "Box around model", LABELCOLOR);
    //group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
    //g_object_set_data(G_OBJECT(dlg), "radio3", radio);
    //gtk_widget_show(radio);
    //gtk_box_pack_start (GTK_BOX (wid), radio, FALSE, FALSE, 0);

    radio = RADIO_BUTTON_WITH_LABEL (group, "User defined box", LABELCOLOR);
    group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
    g_object_set_data(G_OBJECT(dlg), "radio4", radio);
    gtk_widget_show(radio);
    gtk_box_pack_start (GTK_BOX (wid), radio, FALSE, FALSE, 0);
    (void) g_signal_connect (G_OBJECT (radio), "toggled",
                       (GCallback)on_cb_show,frame);

    gtk_box_pack_start (GTK_BOX (wid), frame, FALSE, FALSE, 0);
    g_object_set_data(G_OBJECT(dlg), "user_box", frame);
    gtk_container_set_border_width(GTK_CONTAINER(wid), 2);
    UserBox(frame);

    gtk_box_pack_start (GTK_BOX (wid), frame1, FALSE, FALSE, 0);
    g_object_set_data(G_OBJECT(dlg), "complete_cell", frame1);
    gtk_container_set_border_width(GTK_CONTAINER(wid), 2);
    CompleteCell(frame1);

    wid1 = myimage_button("   _OK", "ok.png");
    gtk_dialog_add_action_widget(GTK_DIALOG (dlg), wid1, 1);
    (void) g_signal_connect (G_OBJECT (wid1), "clicked",
                      G_CALLBACK(ok_dlg), (gpointer) this);

    wid1 = myimage_button("  _Cancel", "cancel.png");
    gtk_dialog_add_action_widget(GTK_DIALOG (dlg), wid1, 2);
    (void) g_signal_connect (G_OBJECT (wid1), "clicked",
                      G_CALLBACK(close_dlg), (gpointer) this);
    (void) g_signal_connect_swapped(G_OBJECT(dlg), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(wid1));
  (void) g_signal_connect (G_OBJECT (dlg), "delete_event",
                      G_CALLBACK(true_cb), NULL);
    gtk_button_box_set_layout(GTK_BUTTON_BOX(
      gtk_widget_get_parent(wid1)), GTK_BUTTONBOX_SPREAD);
}

void ContDlg2::SettaContour(myContour *cont1)
{
     Contour = cont1;
}

void ContDlg2::ShowDlg(GtkWidget *father)
{
      for(int j=0; j<3; j++)
      {
           c_center[j] = Contour->centerCont[j];
           c_delta[j] = Contour->deltaCont[j];
	   stringstream num;
	   num << "c" << j;
           GtkWidget *wid = get_widget(dlg, num.str().c_str());
           gtk_entry_set_text(GTK_ENTRY(wid),g_strdup_printf("%5.2f",c_center[j]));
	   num.str("");
	   num << "d" << j;
           wid = get_widget(dlg, num.str().c_str());
           gtk_entry_set_text(GTK_ENTRY(wid),g_strdup_printf("%5.2f",c_delta[j]));
	   num.str("");
	   num << "nc" << j;
           wid = get_widget(dlg, num.str().c_str());
           spin_button_set_value(wid, (float)Contour->numCell[0][j]);
	   num.str("");
	   num << "sc" << j;
           wid = get_widget(dlg, num.str().c_str());
           spin_button_set_value(wid, (float)Contour->numCell[1][j]);
      }
      stringstream num;
      num << "radio" << Contour->WhichLimit;
      GtkWidget *wid = get_widget(dlg, num.str().c_str());
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(wid), TRUE);
      RadioSelected = Contour->WhichLimit;

      gtk_window_set_transient_for(GTK_WINDOW(dlg), GTK_WINDOW(father));
      gtk_widget_show(dlg);
}

void ContDlg2::UserBox(GtkWidget *frame)
{
    GtkWidget *table = table_new(6, 3, FALSE);
    table_set_row_spacings(table, 4);
    table_set_col_spacings(table, 4);
    gtk_widget_show(table);
    gtk_container_add (GTK_CONTAINER (frame), table);
    gtk_container_set_border_width(GTK_CONTAINER(table), 2);

    GtkWidget *wid2 = LABEL_BOLD("Dimensions of the box (Ang.)", LABELCOLOR, 1.2f);
    gtk_widget_show(wid2);
    set_alignment(wid2, 0., 0.5);
    table_attach(table, wid2, 0, 3, 0, 1, TRUE);

    wid2 = LABEL_NEW("Lx", LABELCOLOR);
    gtk_widget_show(wid2);
    set_alignment(wid2, 0.5, 0.5);
    table_attach(table, wid2, 0, 1, 1, 2, TRUE);

    wid2 = LABEL_NEW("Ly", LABELCOLOR);
    gtk_widget_show(wid2);
    set_alignment(wid2, 0.5, 0.5);
    table_attach(table, wid2, 1, 2, 1, 2, TRUE);

    wid2 = LABEL_NEW("Lz", LABELCOLOR);
    gtk_widget_show(wid2);
    set_alignment(wid2, 0.5, 0.5);
    table_attach(table, wid2, 2, 3, 1, 2, TRUE);

    wid2 = LABEL_BOLD("Type center coordinates of the box", LABELCOLOR, 1.2f);
    gtk_widget_show(wid2);
    set_alignment(wid2, 0., 0.5);
    table_attach(table, wid2, 0, 3, 3, 4, TRUE);

#if 0    
    wid2 = LABEL_BOLD("or select atom as center", LABELCOLOR, 1.2f);
    gtk_widget_show(wid2);
    set_alignment(wid2, 0., 0.5);
    table_attach(table, wid2, 0, 2, 5, 6, TRUE);

    wid2 = xpm_button("mouse.png");
    gtk_widget_show(wid2);
    table_attach(table, wid2, 2, 3, 5, 6);
    (void) g_signal_connect(G_OBJECT(wid2), "clicked", 
          G_CALLBACK(scegli_atomo), dlg);
#endif
    for(int j=0; j<3; j++)
    {
        GtkWidget *wid1 = gtk_entry_new();
        set_width_chars (GTK_ENTRY(wid1), 10);
        gtk_widget_show(wid1);
        table_attach(table, wid1, j, j+1, 2, 3, TRUE);
	stringstream num;
        num  << "d" << j;
        g_object_set_data(G_OBJECT(dlg), num.str().c_str(), wid1);
        wid1 = gtk_entry_new();
        set_width_chars (GTK_ENTRY(wid1), 10);
        gtk_widget_show(wid1);
        table_attach(table, wid1, j, j+1, 4, 5, TRUE);
	num.str("");
	num << "c" << j;
        g_object_set_data(G_OBJECT(dlg), num.str().c_str(), wid1);
    }
}

void ContDlg2::CompleteCell(GtkWidget *frame)
{
    GtkWidget *table = table_new(6, 3, FALSE);
    table_set_row_spacings(table, 4);
    table_set_col_spacings(table, 4);
    gtk_widget_show(table);
    gtk_container_add (GTK_CONTAINER (frame), table);
    gtk_container_set_border_width(GTK_CONTAINER(table), 2);

    GtkWidget *wid2 = LABEL_BOLD("Number of cells:", LABELCOLOR, 1.2f);
    gtk_widget_show(wid2);
    set_alignment(wid2, 0., 0.5);
    table_attach(table, wid2, 0, 3, 0, 1, TRUE);


    wid2 = LABEL_NEW("along x", LABELCOLOR);
    gtk_widget_show(wid2);
    set_alignment(wid2, 0.5, 0.5);
    table_attach(table, wid2, 0, 1, 1, 2, TRUE);

    wid2 = LABEL_NEW("along y", LABELCOLOR);
    gtk_widget_show(wid2);
    set_alignment(wid2, 0.5, 0.5);
    table_attach(table, wid2, 1, 2, 1, 2, TRUE);

    wid2 = LABEL_NEW("along z", LABELCOLOR);
    gtk_widget_show(wid2);
    set_alignment(wid2, 0.5, 0.5);
    table_attach(table, wid2, 2, 3, 1, 2, TRUE);

    wid2 = LABEL_NEW("along x", LABELCOLOR);
    gtk_widget_show(wid2);
    set_alignment(wid2, 0.5, 0.5);
    table_attach(table, wid2, 0, 1, 4, 5, TRUE);

    wid2 = LABEL_NEW("along y", LABELCOLOR);
    gtk_widget_show(wid2);
    set_alignment(wid2, 0.5, 0.5);
    table_attach(table, wid2, 1, 2, 4, 5, TRUE);

    wid2 = LABEL_NEW("along z", LABELCOLOR);
    gtk_widget_show(wid2);
    set_alignment(wid2, 0.5, 0.5);
    table_attach(table, wid2, 2, 3, 4, 5, TRUE);

    wid2 = LABEL_BOLD("Starting point", LABELCOLOR,1.2f);
    gtk_widget_show(wid2);
    set_alignment(wid2, 0., 0.5);
    table_attach(table, wid2, 0, 3, 3, 4, TRUE);

    for(int j=0; j<3; j++)
    {
        GtkWidget *wid1 = spin_button_new(GTK_ADJUSTMENT(
                 adj_new (1.f, 1.f,3.f,1.f,1.f)),1,0);
        set_width_chars (GTK_ENTRY(wid1), 8);
        gtk_widget_show(wid1);
        table_attach(table, wid1, j, j+1, 2, 3, TRUE);
	stringstream num;
	num << "nc" << j;
        g_object_set_data(G_OBJECT(dlg), num.str().c_str(), wid1);
        wid1 = spin_button_new(GTK_ADJUSTMENT(
                 adj_new (0.f, -2.f,2.f,1.f,1.f)),1,0);
        set_width_chars (GTK_ENTRY(wid1), 8);
        gtk_widget_show(wid1);
        table_attach(table, wid1, j, j+1, 5, 6, TRUE);
	num.str("");
	num << "sc" << j;
        g_object_set_data(G_OBJECT(dlg), num.str().c_str(), wid1);
    }
}
void ContDlg2::CloseDlg(gpointer data)
{
   int iAction=0;
   float newval;

   int ifOk = GPOINTER_TO_INT(data);
   int ier = 0;
   if(!ifOk)
   {
      gtk_widget_hide(dlg);
      return;
   }
   for(int i=1; i<=4; i++)
   {
       if(i == 3)
	  continue;
       stringstream num;
       num << "radio" << i;
       GtkWidget *wid = get_widget(dlg, num.str().c_str());
       if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(wid)))
       {
            iAction = i;
            break;
       }
   }
   ifOk = 0;
   switch(iAction)
   {
   case 4:
      for (int j=0; j<3; j++)
      {
           stringstream num;
	   num << "c" << j;
           GtkWidget *wid = get_widget(dlg, num.str().c_str());
	   string Num(gtk_editable_get_chars(GTK_EDITABLE(wid), 0, -1));
           errno = 0;
           newval = (float) atof(Num.c_str());
           if (newval != c_center[j]) 
           {
               c_center[j] = newval;
               ifOk = 1;
           }
           if(errno)
              ier = -1;

	   num.str("");
	   num << "d" << j;
           wid = get_widget(dlg, num.str().c_str());
           Num.assign(gtk_editable_get_chars(GTK_EDITABLE(wid), 0, -1));
           errno = 0;
           newval = (float) atof(Num.c_str());
           if (newval != c_delta[j]) 
           {
               c_delta[j] = newval;
               ifOk = 1;
           }
           if(errno)
              ier = -1;
      }
      break;

   case 2:
      for (int j=0; j<3; j++)
      {
           stringstream num;
	   num << "nc" << j;
           GtkWidget *wid = get_widget(dlg, num.str().c_str());
           int i = spin_button_get_value_as_int(wid);
           if(i != Contour->numCell[0][j])
           {
              Contour->numCell[0][j] = i;
              ifOk = 1;
           }
	   num.str("");
	   num << "sc" << j;
           wid = get_widget(dlg, num.str().c_str());
           i = spin_button_get_value_as_int(wid);
           if(i != Contour->numCell[1][j])
           {
              Contour->numCell[1][j] = i;
              ifOk = 1;
           }
      }
      break;
   default:
//       ifOk = 1;
      break;
   }
   if(!ier)
   {
      if(iAction != RadioSelected)
         ifOk = 1;
      gtk_widget_hide(dlg);
      if(ifOk)
      {
         for (int i=0; i<3; i++)
         {
            Contour->centerCont[i] = c_center[i];
            Contour->deltaCont[i] = c_delta[i];
         }
         Contour->WhichLimit = iAction;
	 putinfocontour_(Contour);
         finish_limitsjav_();
         AggiornaStatusBar();
      }
   }
}

