#include "cont_dlg3.h"
using namespace std;

static void ok_dlg(GtkWidget *, gpointer data)
{
    ContDlg3 *cont = (ContDlg3 *) data;
    cont->CloseDlg(GINT_TO_POINTER(1));
}

static void close_dlg(GtkWidget *, gpointer data)
{
    ContDlg3 *cont = (ContDlg3 *) data;
    cont->CloseDlg(GINT_TO_POINTER(0));
}

static void AttivaEntries(GtkToggleButton *button, gpointer data)
{
    GtkWidget *entry=nullptr;
    int iattiva = GPOINTER_TO_INT(data);
    GtkWidget *dlg1 = gtk_widget_get_toplevel(GTK_WIDGET(button));

    if(gtk_toggle_button_get_active(button))
    {
       entry = get_widget(dlg1, "more1");
       gtk_widget_set_sensitive(entry, iattiva);
       entry = get_widget(dlg1, "more2");
       gtk_widget_set_sensitive(entry, iattiva);
       entry = get_widget(dlg1, "one");
       gtk_widget_set_sensitive(entry, !iattiva);
    }
    AggiornaStatusBar();
}
	
ContDlg3::ContDlg3() :
	Contour(nullptr),
	dlg(nullptr)
{
    GSList *group = NULL;

    dlg = gtk_dialog_new();
    gtk_window_set_title(GTK_WINDOW(dlg), "Select Section(s)");
    GtkWidget *vbox = (gtk_dialog_get_content_area(GTK_DIALOG(dlg)));
    gtk_container_set_border_width(GTK_CONTAINER(vbox), 10);
    
    GtkWidget *frame = gtk_frame_new(NULL);
    gtk_widget_show(frame);
    gtk_box_pack_start(GTK_BOX (vbox), frame, TRUE, TRUE, 10);

    GtkWidget *wid = vbox_new(FALSE, 0);
    gtk_widget_show(wid);
#ifdef IN_GTK3
    gtk_container_add(GTK_CONTAINER(frame), wid);
    gtk_widget_set_vexpand(wid, TRUE);
    gtk_widget_set_hexpand(wid, TRUE);
    g_object_set(G_OBJECT(wid), "valign", GTK_ALIGN_CENTER, NULL);
#else
    GtkWidget *wid4 = gtk_alignment_new(0.5, 0.5, 1, 1);
    gtk_widget_show(wid4);
    gtk_container_add(GTK_CONTAINER(frame), wid4);
    gtk_container_set_border_width(GTK_CONTAINER(wid4), 10);
    gtk_container_add(GTK_CONTAINER(wid4), wid);
#endif

    GtkWidget *radio = RADIO_BUTTON_WITH_LABEL (group, "Only one section", LABELCOLOR);
    group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
    g_object_set_data(G_OBJECT(dlg), "radio1", radio);
    gtk_widget_show(radio);
    gtk_box_pack_start (GTK_BOX (wid), radio, FALSE, FALSE, 0);
    (void) g_signal_connect (G_OBJECT (radio), "toggled",
                       (GCallback)AttivaEntries, GINT_TO_POINTER(0));

    GtkWidget *wid1 = hbox_new(FALSE, 0);
    gtk_widget_show(wid1);
    gtk_box_pack_start (GTK_BOX (wid), wid1, FALSE, FALSE, 0);
    g_object_set_data(G_OBJECT(dlg), "one", wid1);

    GtkWidget *wid2 = spin_button_new_with_range(1.f,100.f,1.f);
    gtk_box_pack_end (GTK_BOX (wid1), wid2, FALSE, FALSE, 0);
    gtk_widget_show(wid2);
    g_object_set_data(G_OBJECT(dlg), "section", wid2);

    wid  = LABEL_NEW("Section #", LABELCOLOR);
    gtk_box_pack_end (GTK_BOX (wid1), wid, FALSE, FALSE, 10);
    gtk_widget_show(wid);
    
    frame = gtk_frame_new(NULL);
    gtk_widget_show(frame);
    gtk_box_pack_start(GTK_BOX (vbox), frame, TRUE, TRUE, 10);

    wid = vbox_new(FALSE, 0);
    gtk_widget_show(wid);

#ifdef IN_GTK3
    gtk_container_add(GTK_CONTAINER(frame), wid);
    gtk_widget_set_vexpand(wid, TRUE);
    gtk_widget_set_hexpand(wid, TRUE);
    g_object_set(G_OBJECT(wid), "valign", GTK_ALIGN_CENTER, NULL);
#else
    wid1 = gtk_alignment_new(0.5, 0.5, 1, 1);
    gtk_widget_show(wid1);
    gtk_container_add(GTK_CONTAINER(frame), wid1);
    gtk_container_set_border_width(GTK_CONTAINER(wid1), 10);
    gtk_container_add(GTK_CONTAINER(wid1), wid);
#endif

    radio = RADIO_BUTTON_WITH_LABEL (group, "More than one", LABELCOLOR);
    group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
    g_object_set_data(G_OBJECT(dlg), "radio2", radio);
    gtk_widget_show(radio);
    gtk_box_pack_start (GTK_BOX (wid), radio, FALSE, FALSE, 0);
    (void) g_signal_connect (G_OBJECT (radio), "toggled",
                       (GCallback)AttivaEntries, GINT_TO_POINTER(1));

    wid1 = hbox_new(FALSE, 0);
    gtk_widget_show(wid1);
    gtk_box_pack_start (GTK_BOX (wid), wid1, FALSE, FALSE, 0);
    g_object_set_data(G_OBJECT(dlg), "more1", wid1);

    wid2 = spin_button_new_with_range(1.f,100.f,1.f);
    gtk_box_pack_end (GTK_BOX (wid1), wid2, FALSE, FALSE, 0);
    gtk_widget_show(wid2);
    g_object_set_data(G_OBJECT(dlg), "section0", wid2);

    GtkWidget *wid3  = LABEL_NEW("Starting Section", LABELCOLOR);
    gtk_box_pack_end (GTK_BOX (wid1), wid3, FALSE, FALSE, 10);
    gtk_widget_show(wid3);
    
    wid1 = hbox_new(FALSE, 0);
    gtk_widget_show(wid1);
    gtk_box_pack_start (GTK_BOX (wid), wid1, FALSE, FALSE, 0);
    g_object_set_data(G_OBJECT(dlg), "more2", wid1);

    wid2 = spin_button_new_with_range(1.f,100.f,1.f);
    gtk_box_pack_end (GTK_BOX (wid1), wid2, FALSE, FALSE, 0);
    gtk_widget_show(wid2);
    g_object_set_data(G_OBJECT(dlg), "sectionN", wid2);

    wid3  = LABEL_NEW("Ending Section", LABELCOLOR);
    gtk_box_pack_end (GTK_BOX (wid1), wid3, FALSE, FALSE, 10);
    gtk_widget_show(wid3);
    
    wid1 = myimage_button("   _OK", "ok.png");
    gtk_dialog_add_action_widget(GTK_DIALOG (dlg), wid1, 1);
    (void) g_signal_connect (G_OBJECT (wid1), "clicked",
                      G_CALLBACK(ok_dlg), (gpointer) this);

    wid1 = myimage_button("  _Cancel", "cancel.png");
    gtk_dialog_add_action_widget(GTK_DIALOG (dlg), wid1, 2);
    (void) g_signal_connect (G_OBJECT (wid1), "clicked",
                      G_CALLBACK(close_dlg), (gpointer) this);
    (void) g_signal_connect_swapped(G_OBJECT(dlg), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(wid1));
  (void) g_signal_connect (G_OBJECT (dlg), "delete_event",
                      G_CALLBACK(true_cb), NULL);
    gtk_button_box_set_layout(GTK_BUTTON_BOX(
      gtk_widget_get_parent(wid1)), GTK_BUTTONBOX_SPREAD);
    wid = get_widget(dlg, "radio2");
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(wid), TRUE);

}

void ContDlg3::SettaContour(myContour *cont1)
{
     Contour = cont1;
}

void ContDlg3::SettaGrid(int gr[])
{
     for(int i=0; i<3;i++)
	 ngrid[i] = gr[i];
}

void ContDlg3::ShowDlg(GtkWidget *father)
{
      GtkWidget *wid = get_widget(dlg, "section");
      spin_button_set_range(wid, 1.f, (float)ngrid[Contour->Layer-1]);
      spin_button_set_value(wid, (float)Contour->sezione0 + 1.f);
      wid = get_widget(dlg, "section0");
      spin_button_set_range(wid, 1.f, (float)ngrid[Contour->Layer-1]);
      spin_button_set_value(wid, (float)Contour->sezione0 + 1.f);
      wid = get_widget(dlg, "sectionN");
      spin_button_set_range(wid, 1.f, (float)ngrid[Contour->Layer-1]);
      spin_button_set_value(wid, (float)Contour->sezioneN + 1.f);
      gtk_window_set_transient_for(GTK_WINDOW(dlg), GTK_WINDOW(father));
      gtk_widget_show(dlg);
}

void ContDlg3::CloseDlg(gpointer data)
{
   int ifOk = GPOINTER_TO_INT(data);
   if(ifOk)
   {
      GtkWidget *wid = get_widget(dlg, "radio1");
      if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(wid)))  // One section
      {
         wid = get_widget(dlg, "section");
         Contour->sezione0 = spin_button_get_value_as_int(wid) - 1;
         Contour->sezioneN = Contour->sezione0;
      }
      else                                                      // More than
      {
         wid = get_widget(dlg, "section0");
         Contour->sezione0 = spin_button_get_value_as_int(wid) - 1;
         wid = get_widget(dlg, "sectionN");
         Contour->sezioneN = spin_button_get_value_as_int(wid) - 1;
      }
      putinfocontour_(Contour);
      leggisezioni_();
      plotcontourjav_();
   }
   AggiornaStatusBar();
   gtk_widget_hide(dlg);
}

