#ifndef DRAW_CONTOUR2D_H
#define DRAW_CONTOUR2D_H

#include "utils.h"
#include "glext.h"

#define N_OBJS 16

namespace GLextmr {
    extern GtkWidget *GLWINDOW;
}
using namespace GLextmr;

typedef struct {
                 unsigned long ulDimensionX;
                 unsigned long ulDimensionY;
                 int            n_channels;
                 int            rowstride;
                 GLenum         format;
                 guchar         *pcData;
               } MyTex ;
typedef struct {
                 int ifLevel[5];
                 float Soglie[15];
                 int LevelCol[5];
                 int Layer;
                 int sezione0;
                 int sezioneN;
                 float centerCont[3];
                 float deltaCont[3];
                 float xyzlimCont[3][2]; 
                 int ifModel;
                 int massimoMappa;
                 int ifGrid;
                 int WhichLimit;
		 int numCell[2][3];
               } myContour;
		 
float *getfColor(int icol);
void AggiornaStatusBar();
extern "C" void leggisezioni_();
extern "C" void preparacontour_();
extern "C" void plotcontourjav_();
extern "C" void initcontourjav_(int *w, int *h);
extern "C" void getinfocontour_(int vet[], myContour *cont);
extern "C" void putinfocontour_(myContour *cont);
extern "C" void viewforjav_(int *action);
extern "C" void setcelldraw_(int *action);
extern "C" void setgriddraw_(int *action);

   class DrawContour2D {
   public:
	
    DrawContour2D();
    void DrawTexture();
    void StartContour();
    void DrawLine(int x[], int y[], float Color[], int Type, int Lw);
    void DrawLabel(int x, int y, char *c, float *col, int Lw);
    void EndContour();
    void NewPage();
    void ChangeSection(int quanto, GtkWidget *window);
    void ReDraw();
    void Messaggio(bool ifMess);
    myContour *getContour() {return Contour;}
    int *getGrid() {return ngrid;}

private:
    GLuint m_Texture;
    cairo_surface_t *m_image;
    cairo_t *m_cr;
    myContour *Contour;
    GLWindow *m_gl;
    int ngrid[3];
    int m_width;
    int m_height;
    void LoadTextureFile(const char *szFilename, MyTex *pTexture);
    void LoadDrawTexture(const char *textfile);
};
#endif
