      MODULE PhaseModule
          real               :: aperc(90),rperc(90)
          integer            :: npercm, nrefB
          integer            :: numbrun = 0
          real               :: errem = 0.0
          real               :: biso, oscale
          integer            :: maxcyc, jrest, nSetsFineDSR
          integer            :: ifVLD = 0
          integer            :: kWstop = 0
          integer            :: ifExamin = 1
          integer            :: ifTime = 0
          integer            :: ifReduced = 0
          real               :: erre = 0
          real, dimension(7) :: shiftexam
          real               :: erore
          integer            :: isumal
      END MODULE PhaseModule
!-----------------------------------------------------------------------
      MODULE DataModule
          integer :: ifPlotSpots = 0
          integer :: noSpaceGroup = 0
          integer :: ifContSuppl
          real    :: bfacPDB, wave
      END MODULE DataModule
!-----------------------------------------------------------------------
      MODULE MadModule
      common /erreMAD/ numR, NumRefR(5), rfacR(5)
      END MODULE MadModule
!-----------------------------------------------------------------------
      subroutine RotazTot()
!
      return
      end
!-----------------------------------------------------------------------
      subroutine VecchiaExamin()
!
      return
      end
!-----------------------------------------------------------------------
      subroutine PolyShapeJav(nPoints, tria, ico)
      USE Molcom
!
      implicit none
      integer :: nPoints, ico, iColor, i, j, ind
      real    :: a, b, tria(3,10), x1(3)
!
      iColor = ico
      RagMed = 0.0
      do j = 1, nPoints
         do i = 1, 3
            x1(i)=tria(i,j)
         enddo
         a = ( x1(1) + x11disp(1) ) * x11scale(1)
         b = ( x1(2) + x11disp(2) ) * x11scale(2)
         ixv(j)=nint(a)
         iyv(j)=iVP(4) - nint(b)
      enddo
!
! Line
      call DrawLinec2D(ixv, iyv, iColor, 1, 1)
!
      return
      end
! ----------------------------------------------------------------------
      
      subroutine PlotContourJav()
!
      USE General
      USE Molcom
      USE Contorno
!!      USE PhaseModule
!
      implicit none
      integer :: nExitCode, i, j, k, kk, ic, ic1
      integer :: nPoints
      real    :: tria(3,10)
!
      if (nPuntiCont.lt.3) then
          Msg = 'Not enough points to contour. Check level values.'
          call MsgWinErr('Warning', Msg, WARN_WINDOW, nExitCode)
      else

          call StartContour2D()
!!mr
          call FindMinMax    ! GL

*         call SetScaleMap()      ! commentato gianluca 11 aprile 2020
          nPoints = 2
          do i=1, nPuntiCont-moreBox, 2
             do k=0,1
                kk = i + k
                do j=1,3
                   tria(j,k+1) = xyz_tria(j,kk)
                enddo
             enddo
             ic = xyz_tria(4,i)
             ic1 = mod(ic-1, 5) + 1
             if (ifLevel(ic1).eq.1) then
                 ic1 = LevelCol(ic1)
                 call PolyShapeJav(nPoints, tria, ic1)
             endif
          end do

          !!ifGrid = 1

          if (ifGrid == 1) then
              call DrawGridJav()
          endif
!


          !!ifCell = 1


          if (ifCell.eq.1) then
              call DrawCellContourJav()
          endif

          call Sistemino

          call StopContour2D()
      endif
          
      
              
      return
      end
!-----------------------------------------------------------------------
      subroutine InitContourJav(iw, ih)
      USE General
      USE Symmetry
      USE Atomi
      USE PhaseModule
      USE Molcom
!
      implicit none
      integer              :: iAction
      integer, intent(in)  :: iw, ih
      integer              :: ier
!
      call Orto(cell(1:6))
***   call CheckSpaceGroupSymbol(nSpaceG, ier)
***   call CreaSymmetryInfo(ier)
      ViewDist = 9.e33
      nMaxLeg = 9800
      NatMol = 0
      jscreen = 1
      iAction = 1
      iVP(1) = 1
      iVP(2) = 1
      iVP(3) = iw
      iVP(4) = ih
      call AllocaContorno(1)
      MaxAtomsInGr = 10
      MaxAtoms = 100
      call AllocaAtomi(-9)
      NatMol = 0
      call AggiuSpig
      call InitMolplo
      ifDrawContour = 1
      ifDrawContour2D = 1
      ifSkeleton = 0
      nats = 1
      BTot(:,:) = 0; BTot(1,1) = 1; BTot(2,2) = 1; BTot(3,3) = 1
      call FineMappa
!
      call PreparaContour
!
      return
      end
!-----------------------------------------------------------------------
      subroutine toMolplo3(k)
!
      integer k
!
      return
      end
!-----------------------------------------------------------------------
      subroutine GetBonds(k)
!
      integer k
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Disegna(k)
!
      integer k
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Orto(cella)
      USE General ! , only: pi
      USE Molcom
!
      implicit none
      integer :: i
      real    :: cella(6), alf, bet, gam
!
*     common /pippo/ asta(3),alf,bet,gam,sas,sbs,sgs,alfs,bets,gams,v
!
      alf = cella(4)
      bet = cella(5)
      gam = cella(6)
!
      do i=1, 3
         DeADef(i) = 3.0/cella(i)
         if ( DeADef(i) .gt. 0.5 ) DeADef(i) = 0.5
         DeA(i) = DeADef(i)
         nCell(i) = 1
      enddo
!
*     call toMolPlo1(a,b,c,alf,bet,gam)
      alf=pi/180*alf
      bet=pi/180*bet
      gam=pi/180*gam
! ---------
! ---------  sgs =  coseno di gamma star
! ---------
      sas=(cos(bet)*cos(gam)-cos(alf))/(sin(bet)*sin(gam))
      sbs=(cos(alf)*cos(gam)-cos(bet))/(sin(alf)*sin(gam))
      sgs=(cos(alf)*cos(bet)-cos(gam))/(sin(alf)*sin(bet))
! ---------
! ---------  gams =  gamma star
! ---------

      if ( sas .gt.  1.0 ) sas = 1.0
      if ( sas .lt. -1.0 ) sas =-1.0
      alfs=acos(sas)
      if ( sbs .gt.  1.0 ) sbs = 1.0
      if ( sbs .lt. -1.0 ) sbs =-1.0
      bets=acos(sbs)
      if ( sgs .gt.  1.0 ) sgs = 1.0
      if ( sgs .lt. -1.0 ) sgs =-1.0
      gams=acos(sgs)
      volume = cella(1) * cella(2) * cella(3)
      volume = volume*sqrt(sin(alf)**2+sin(bet)**2+sin(gam)**2-2+
     *         2*cos(alf)*cos(bet)*cos(gam))
      asta(1) = cella(2) * cella(3) * sin(alf) / volume
      asta(2) = cella(1) * cella(3) * sin(bet) / volume
      asta(3) = cella(1) * cella(2) * sin(gam) / volume
!
      rmi(1,1) = 1.0 / cella(1)
      rmi(2,1) = 0.0
      rmi(3,1) = 0.0
      rmi(1,2) = -cos(gam) / (cella(1)*sin(gam))
      rmi(2,2) = 1.0 / (cella(2)*sin(gam))
      rmi(3,2) = 0.0
      rmi(1,3) = asta(1) * cos(bets)
      rmi(2,3) = asta(2) * cos(alfs)
      rmi(3,3) = asta(3)
!
      call InvRmi
!
      return
      end
!----------------------------------------------------------------
      subroutine examin(nuset,mkang,khl,iphiv,iphic,mmm,numbx,wtexa,
     *                  ifmin_input)
      DIMENSION mkang(mmm),khl(3,mmm),iphiv(mmm),iphic(mmm),wtexa(mmm)
      end
!----------------------------------------------------------------
      subroutine MolPlo(iPlt, ifSingle)
      end 
!----------------------------------------------------------------
      subroutine ManageJavHydro(natsOld)
      end
!----------------------------------------------------------------
      subroutine to_coord_sir(kdstampa,numb)
      end subroutine to_coord_sir
!----------------------------------------------------------------
      subroutine outShelx(ifref)
      integer, intent(in) :: ifref
      end subroutine outShelx
!----------------------------------------------------------------
!      subroutine Open_GLWindow()
!      end subroutine Open_GLWindow
!----------------------------------------------------------------
!      subroutine Close_GLWindow()
!      end subroutine Close_GLWindow
!----------------------------------------------------------------
!      subroutine GetStructureInfo(info, icalc)
!      end subroutine GetStructureInfo
!----------------------------------------------------------------
      subroutine importa(filnam, dirnam, iAction, ier)
      end subroutine importa
!----------------------------------------------------------------
      subroutine Sistemino
      USE Molcom
      USE PhaseModule
!
      implicit none
      integer :: ipx(2,4), i, j, ix, iy
      real    :: xs(3,4), raa, am, f, FatK, a, b, dxp, dyp
      character (len=1) :: Lb(3)
!
      Lb(1)='a'
      Lb(2)='b'
      Lb(3)='c'
      do i=1,4
         do j=1,3
            xs(j,i) = xyz(j,NatMol + i)
         enddo
      enddo
      raa = 1./x11scale(1)
      do i=1,4
         am = 0.
         if (i.lt.4) then
            do j=1,3
               am = am + (xs(j,i)-xs(j,4))**2
            enddo
            am = sqrt(am)
            do j=1,3
             if ( abs(am).gt.0.0001) then
               xs(j,i) = 30. * raa * (xs(j,i)-xs(j,4)) / am + xs(j,4)
             end if
            enddo
         end if
         f = xs(3,i)
         FatK = -f / ViewDist + 1
         a = ( xs(1,i)/FatK + x11disp(1) ) * x11scale(1)
         b = ( xs(2,i)/FatK + x11disp(2) ) * x11scale(2)
         ipx(1,i)=nint(a)
         ipx(2,i)=iVP(4) - nint(b)
      enddo
      dxp = ipx(1,4)
      dyp = ipx(2,4)
      do 65 i=1,4
         ipx(1,i) = ipx(1,i) - dxp + 40
         ipx(2,i) = ipx(2,i) - dyp + iVP(4) - 40
 65   enddo

      do i=1,3
         ix = ipx(1,i) - 30
         iy = ipx(2,i) + 30
*        call Linea(ix,iy,ipx(1,4),ipx(2,4),icoWire)
         ixv(1) = ix
         ixv(2) = ipx(1,4) - 30
         iyv(1) = iy
         iyv(2) = ipx(2,4) + 30
         call DrawLinec2D(ixv, iyv, icoWire, 1, 1)
         !!write(0,1) 'Sistemino', ix, iy, ipx(1,4), ipx(2,4), icoWire
         call DrawLabelJav(ix + 3, iy - 3, Lb(i)//char(0), icoWire, 2)
      enddo
!
      return
    1 format(a,2x,5i4)
      end
!----------------------------------------------------------------
      subroutine DrawCellContourJav()
      USE Atomi
      USE Contorno
      USE Molcom
      USE PhaseModule
!
      implicit none
      integer :: iC1, j, N1, N2, ix1, iy1, ix2, iy2
      real    :: a, b
!
      iC1 = color_CELL
      do j=1,12 + moreLines
         N1  = kSpiCont(j,1)
         N2  = kSpiCont(j,2)
         a = ( xyz_tria(1,N1) + x11disp(1) ) * x11scale(1)
         b = ( xyz_tria(2,N1) + x11disp(2) ) * x11scale(2)
         ix1 = nint(a)
         iy1 = iVP(4) - nint(b)
         a = ( xyz_tria(1,N2) + x11disp(1) ) * x11scale(1)
         b = ( xyz_tria(2,N2) + x11disp(2) ) * x11scale(2)
         ix2 = nint(a)
         iy2 = iVP(4) - nint(b)
*        call Linea(ix1, iy1, ix2, iy2, iC1)
         ixv(1) = ix1
         ixv(2) = ix2
         iyv(1) = iy1
         iyv(2) = iy2
         call DrawLinec2D(ixv, iyv, iC1, 1, 1)
         !!write(0,1) 'cell', ix1, iy1, ix2, iy2,iC1
      enddo
!
      return
    1 format(a,2x,5i4)
      end
!----------------------------------------------------------------
      subroutine DrawGridJav()
      USE General
      USE Contorno
      USE Molcom
!
      implicit none
      integer :: lati(4), iColoB, j, k, N1, N2, N3, N4, ix, ix1, iy1
      integer :: ix2, iy2
      real    :: x0, y0, x1, y1, x2, y2, x3, y3, dist, emme, xp, yp
      real    :: stepy, a, b, xp1, yp1, x, xn, xn1, yn, yn1
!
      select case(Layer)
         case (1)
            lati(1)=4
            lati(2)=9
            lati(3)=7
            lati(4)=6
         case (2)
            lati(1)=1
            lati(2)=8
            lati(3)=7
            lati(4)=3
         case (3)
            lati(1)=1
            lati(2)=5
            lati(3)=4
            lati(4)=2
      end select
      iColoB = color_WHITE

      do k=0,1
         j=1+2*k
         N1 = kSpiCont(lati(j),1)
         N2 = kSpiCont(lati(j),2)
         N3 = kSpiCont(lati(j+1),1)
         N4 = kSpiCont(lati(j+1),2)
         x0 = xyz_tria(1,N1)
         y0 = xyz_tria(2,N1)
         x1 = xyz_tria(1,N2)
         y1 = xyz_tria(2,N2)
         x2 = xyz_tria(1,N3)
         y2 = xyz_tria(2,N3)
         x3 = xyz_tria(1,N4)
         y3 = xyz_tria(2,N4)

         dist = sqrt( (x1-x0)**2 ) / 10.0
         if (dist > 1.e-6) then
             emme = (y1-y0) / (x1-x0)
             if (x0 < x1) then
                 xp = x0
                 yp = y0
             else
                 xp = x1
                 yp = y1
             endif
             if (x2 < x3) then
                 xp1 = x2
                 yp1 = y2
             else
                 xp1 = x3
                 yp1 = y3
             endif
         else
             stepy = sqrt( (y1-y0)**2 ) / 10.0
             if (y0 < y1) then
                 xp = x0
                 yp = y0
             else
                 xp = x1
                 yp = y1
             endif
             if (y2 < y3) then
                 xp1 = x2
                 yp1 = y2
             else
                 xp1 = x3
                 yp1 = y3
             endif
         endif
         do ix=1,9
            x = ix
            if (dist > 1.e-6) then
                xn = xp + dist * x
                yn = emme * (xn-xp) +yp
            else
                xn = xp
                yn = stepy*x + yp
            endif
            a = ( xn + x11disp(1) ) * x11scale(1)
            b = ( yn + x11disp(2) ) * x11scale(2)
            ix1 = nint(a)
            iy1 = iVP(4) - nint(b)
            if (dist > 1.e-6) then
                xn1 = xp1 + dist * x
                yn1 = emme * (xn1-xp1) + yp1
            else
                xn1 = xp1
                yn1 = stepy*x + yp1 
            endif
            a = ( xn1 + x11disp(1) ) * x11scale(1)
            b = ( yn1 + x11disp(2) ) * x11scale(2)
            ix2 = nint(a)
            iy2 = iVP(4) - nint(b)
*           call Linea_dash(ix1, iy1, ix2, iy2, iColoB)
            ixv(1) = ix1
            ixv(2) = ix2
            iyv(1) = iy1
            iyv(2) = iy2
            call DrawLinec2D(ixv, iyv, iColoB, 2, 1)
         enddo
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine finish_limitsJav()
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Mappa
      USE MappaCont
      USE Iso_Surfaces
      USE PhaseModule
!
!-- WhichLimit = 1 Asymmetric unit
!              = 2 Complete unit cell
!              = 3 Box around model (not used)
!              = 4 User defined box
!
      implicit none
      integer :: i
      real    :: delta, deltaFract
!
      if (WhichLimit == 1) then
          do i=1,3
             xyzlimCont(1,i) = xyzfou(i,1) / xyzfou(i,4)
             xyzlimCont(2,i) = xyzfou(i,2) / xyzfou(i,4)
             deltaCont(i)  = xyzlimCont(2,i) - xyzlimCont(1,i)
             centerCont(i) = xyzlimCont(1,i) + deltaCont(i) / 2.0
          enddo
      elseif (WhichLimit == 2) then
          do i=1,3
             delta = 0.5 /cell(i)
             xyzlimCont(1,i) = numCell(i,2)
             xyzlimCont(2,i) = xyzlimCont(1,i) + numCell(i,1)
             deltaCont(i)  = xyzlimCont(2,i) - xyzlimCont(1,i)
             centerCont(i) = xyzlimCont(1,i) + deltaCont(i) / 2.0
          enddo
      elseif (WhichLimit == 4) then
          do i=1,3
             deltaFract = 0.5 * deltaCont(i) / cell(i) 
             xyzlimCont(1,i) = centerCont(i) - deltaFract
             xyzlimCont(2,i) = centerCont(i) + deltaFract
             deltaCont(i)  = xyzlimCont(2,i) - xyzlimCont(1,i)
          enddo
      elseif (WhichLimit == 0) then
          write(0,*) 'Non dovevo essere qui(WhicLimit = 0)'
      endif
!
      RhoNew=xmap
      call PreparaContour
!
      return
      end
! -----------------------------------------------------------------
      subroutine FindMinMax
      USE Molcom
      USE Atomi, only : nzTot
!
      implicit none
      integer :: iEnd, JAT
      real    :: FatK
!
      if (ifDrawContour == 1) then
          call FindMinMaxCont()
          if (NatMol > 0) then
              call SovrapponiAtomi()
          endif
          return
      endif
      Rmin1 = 99999.
      Rmin2 = 99999.
      RMAX1 = -99999.
      RMAX2 = -99999.
      iEnd = NatMol
      if (NatMol == 0) iEnd = NatSpi
      do JAT = 1 , iEnd
         if (RS(JAT) .ge. 0.0) then
            if (nzTot(JAT).ne.0 .or. ifGhost.eq.1) then
                if (xyz(1,JAT) .LT. Rmin1) Rmin1 = xyz(1,JAT)
                if (xyz(1,JAT) .GT. RMAX1) RMAX1 = xyz(1,JAT)
                if (xyz(2,JAT) .LT. Rmin2) Rmin2 = xyz(2,JAT)
                if (xyz(2,JAT) .GT. RMAX2) RMAX2 = xyz(2,JAT)
             end if
         endif
      enddo
      DrawDeltX = (Rmin1 + RMAX1) / 2
      DrawDeltY = (Rmin2 + RMAX2) / 2
      do JAT = 1 , NatMol + NatSpi + 9
         xyz(1,JAT) = xyz(1,JAT) - DrawDeltX
         xyz(2,JAT) = xyz(2,JAT) - DrawDeltY
      enddo
      Rmin1 = 99999.
      Rmin2 = 99999.
      RMAX1 = -99999.
      RMAX2 = -99999.
      iEnd = NatMol
      if (ifCell.eq.1) iEnd = NatMol + NatSpi
      if (NatMol == 0) iEnd = NatSpi
      do JAT = 1 , iEnd
         FatK = -xyz(3,JAT)/ViewDist + 1
         if (RS(JAT) .ge. 0.0) then
            if (nzTot(JAT).ne.0 .or. ifGhost.eq.1) then
               if ((xyz(1,JAT)-RS(JAT))/FatK .LT. Rmin1) then
                  Rmin1 = (xyz(1,JAT)-RS(JAT)) / FatK
               end if
               if ((xyz(1,JAT)+RS(JAT))/FatK .GT. RMAX1) then
                  RMAX1 = (xyz(1,JAT)+RS(JAT)) / FatK
               end if
               if ((xyz(2,JAT)-RS(JAT))/FatK .LT. Rmin2) then
                  Rmin2 = (xyz(2,JAT)-RS(JAT)) / FatK
               end if
               if ((xyz(2,JAT)+RS(JAT))/FatK .GT. RMAX2) then
                  RMAX2 = (xyz(2,JAT)+RS(JAT)) / FatK
               end if
            end if
         end if
      enddo
!
      return
      end
! -----------------------------------------------------------------
       subroutine AngToPix
       end subroutine AngToPix
!----------------------------------------------------------------
       subroutine DrawLabels
       end subroutine DrawLabels
!-----------------------------------------------------------------------
       subroutine DisegnaAtomi(ifNewPage, ifSingle)
       implicit none
       integer :: ifNewPage, ifSingle
       end subroutine DisegnaAtomi
!-----------------------------------------------------------------------
       subroutine apri_toolbar (stringa)
*      USE Molcom
*      implicit none
*      integer :: ix, iy
       character (len=*) stringa
*      ix =  iVP(3) - iVp(1) + 1
*      iy =  iVP(4) - iVp(2) + 1
*      call InitContourJav(ix, iy)
       end subroutine apri_toolbar
!-----------------------------------------------------------------------
      subroutine ChePiano(iSce)
      USE Molcom
!
      implicit none
      integer :: iSce, iScelta, i, j, k, iok, NATV
      real    :: B(3, 3), VecX, VecY, VecZ
!
      iScelta = iSce
!
      k = NatMol + iScelta - 3
      j = NatMol + 4
      VecX = xyz(1, k) - xyz(1, j)
      VecY = xyz(2, k) - xyz(2, j)
      VecZ = xyz(3, k) - xyz(3, j)
!
      if (iScelta .lt. 8) then
          call PlaneFound(VecX, VecY, VecZ)
          if (ifDrawContour .ne. 1) then         !pg2
             call FindOr(B, iSce)
          end if                               !pg
      end if
!
      return
      end
! -----------------------------------------------------------------
      subroutine PlaneFound (VecX, VecY, VecZ)
      USE General
      USE Molcom
!
      implicit none
      integer :: nRot, nRTot
      real    :: VecX, VecY, VecZ, VMod, V1Mod, s, Ang
      nRot = 1
      nRTot = 1
      VMod = VecX ** 2 + VecY ** 2
      V1Mod = SQRT(VMod + VecZ ** 2)
      VMod = SQRT(VMod)
      s = VMod / V1Mod
      if (s .lt. .999) then
          Ang = ATAN(s / SQRT(1 - s * s))
          Ang = Ang * rtod
      else
          Ang = 90
      end if
      if (VecZ .lt. 0) then
         Ang = 180 - Ang
      end if
      RK(1) = Ang
      RK(2) = 4
      RK(3) = 1
      VV(1, 1) = VecY
      VV(1, 2) = -VecX
      VV(1, 3) = 0
      if (abs(VecX).lt.0.00001 .AND. abs(VecY).lt.0.00001) then
          VV(1, 3) = 1
      end if
!
      return
      end
! -----------------------------------------------------------------
      subroutine FindOr(B, iSce)
      USE General
      USE Molcom
      USE Atomi
!
      implicit none
      integer :: iSce, i, j, ns, NuR
      real    :: B(3, 3), BOpt(3, 3), xl, Angolo
      real    :: sca
!
      do j = 1 , 3
         do i = 1 , 3
            B(i, j) = 0
            BOpt(i, j) = 0
         enddo
         B(j, j) = 1
         BOpt(j, j) = 1
      enddo
!
      call CombRot(B)
      call RotTot(B)
!
      call RotAtoms(B, 1)
      
      call FindMinMax()
      call SetScale(4)
!
      if (iSce.eq.4) then
         ns = 2
      elseif (iSce.eq.5) then
         ns = 3
      elseif (iSce.eq. 6) then
         ns = 1
      end if
      p1 = xyz(1, NatMol + ns) 
     *   - xyz(1, NatMol + 4)
      p2 = xyz(2, NatMol + ns) 
     *   - xyz(2, NatMol + 4)
      xl = sqrt( p1 * p1 + p2 * p2 )
      if (xl > 1.e-20)  then
         Angolo = (xyz(1, NatMol + ns) 
     *          - xyz(1, NatMol + 4)) / xl
      else
         Angolo = 1.e-20
      end if
      if (Angolo .gt. 1.-1.e-20) Angolo = 1.-1.e-20
      if (Angolo .lt.-1.+1.e-20) Angolo =-1.+1.e-20
      RK(1) = acos(Angolo) * rtod
      if (xyz(2, NatMol + ns) -
     *    xyz(2, NatMol + 4).gt.0) then
          RK(1) = -abs(RK(1))
      end if
      RK(2) = 3
      call CombRot(BOpt)
      call RotTot(BOpt)
      call RotAtoms(BOpt, 1)
      call FindMinMax()
!
      call SetScale(1)
!
      return
      end
! -----------------------------------------------------------------
      subroutine CombRot(B)
      USE General
      USE Molcom
!

      dimension du(3, 3), vu(10), W(3, 3), B(3,3)
!
      if (nint(RK(2)) .EQ. 0) then
          return
      end if
      do 20 ISS = 1 , 3
         do 10 kSSI = 1 , 3
            du(ISS, kSSI) = 0
   10    continue
   20 continue
      aT = dtor * RK(1)
      dSinT = SIN(aT)
      dCosT = COS(aT)
      if (nint(RK(2)) .EQ. 1) then
         du(1, 1) = 1
         du(2, 2) = dCosT
         du(3, 3) = dCosT
         du(2, 3) = -dSinT
         du(3, 2) = dSinT
      end if
      if (nint(RK(2)) .EQ. 2) then
         du(1, 1) = dCosT
         du(1, 3) = dSinT
         du(2, 2) = 1
         du(3, 1) = -dSinT
         du(3, 3) = dCosT
      end if
      if (nint(RK(2)) .EQ. 3) then
         du(1, 1) = dCosT
         du(1, 2) = -dSinT
         du(2, 1) = dSinT
         du(2, 2) = dCosT
         du(3, 3) = 1
      end if
      if (nint(RK(2)) .EQ. 4) then
         NRTO = RK(3)
         PAR = VV(NRTO, 1) ** 2 + VV(NRTO, 2) ** 2
         PAR = PAR + VV(NRTO, 3) ** 2
         DDN = SQRT(PAR)
!
         if (abs(DDN) < 0.001) DDN = 0.001  ! gianluca 06/10/2010
!
         do 30 i = 1 , 3
            vu(i) = VV(NRTO, i) / DDN
   30    continue
         vu(4) = -vu(2)
         vu(5) = vu(1)
         ANG = RK(1)
         RO = dtor * ANG
         CoRo = COS(RO)
         SiRo = SIN(RO)
         UCoRo = 1 - CoRo
         do 50 i = 1 , 3
            do 40 j = i , 3
               du(i, j) = vu(i) * vu(j) * UCoRo
               if (i.EQ.j) then
                  du(i, j) = du(i, j) + CoRo
               else
                  du(j, i) = du(i, j) + vu(i + j) * SiRo
                  du(i, j) = du(i, j) - vu(i + j) * SiRo
               end if
   40       continue
   50    continue
      end if

      call MoltMatMat(du, B, W)

      do 70 i = 1 , 3
         do 60 j = 1 , 3
            B(i, j) = W(i, j)
   60    continue
   70 continue
!
      end
! ----------------------------------------------------------------------
      subroutine RotTot(B)
      USE Molcom
!
      dimension B(3,3), W(3,3)
!
      call MoltMatMat(B, BTot, W)
      do 170 i = 1 , 3
         do 160 j = 1 , 3
            BTot(i, j) = W(i, j)
  160    continue
  170 continue
!
      return
      end
! ----------------------------------------------------------------------
      subroutine SetScale(Azione)
      USE Molcom
!
      integer Azione
!
      Lim1 = iVP(1)
      Lim2 = iVP(2)
      Lim3 = iVP(3)
      Lim4 = iVP(4)
      NPX = Lim3 - Lim1
      NPY = Lim4 - Lim2
      Ratio = float(NPX) / float(NPY)
!
      if (Azione .eq. 0)  goto 2690
      if (Azione .eq. 5) then   !perugia1312
         quanto = 4
      else
         quanto = 20
      end if
      if (Azione .ne. 2)  then
         D1 = (RMAX1 - Rmin1) / quanto
         Rmin1 = Rmin1 - D1
         RMAX1 = RMAX1 + D1
         D2 = (RMAX2 - Rmin2) / quanto
         Rmin2 = Rmin2 - D2
         RMAX2 = RMAX2 + D2
      end if
      Dx = RMAX1 - Rmin1
      Dy = RMAX2 - Rmin2
!
      if (Dx.LE.Dy * Ratio) then
         DX1 = Dy * Ratio
         DEL = (DX1 - Dx) / 2
         Rmin1 = Rmin1 - DEL
         RMAX1 = RMAX1 + DEL
         Dx = DX1
      else
         DY1 = Dx / Ratio
         DEL = (DY1 - Dy) / 2
         Rmin2 = Rmin2 - DEL
         RMAX2 = RMAX2 + DEL
         Dy = DY1
      end if
      if (Azione .EQ. 4) return
      Xmin = Rmin1
      Ymin = Rmin2
      YMax = Rmin2 + Dy
      XMax = Rmin1 + Dx
      RMAX1 = XMax
      RMAX2 = YMax
2690  call Window (Xmin, Ymin, XMax, YMax, Ratio)
      DDX = (XMax - Xmin) / (Lim3 - Lim1)
      DDY = (YMax - Ymin) / (Lim4 - Lim2)
!
      return
      end
! -----------------------------------------------------------------
      subroutine Window(Amin1, Amin2, AMax1, AMax2, Ratio)
      USE Molcom
!
      if (ABS(Amin1 - AMax1) .lt. 1.) then
         Half = (AMax1 + Amin1)/2
         Amin1 = Half - 0.5
         AMax1 = Half + 0.5
         De1 = 0.5*(AMax1 - Amin1)/Ratio
         Half2 = (Amin2+AMax2)/2.
         Amin2 = Half2 - De1
         AMax2 = Half2 + De1
      end if
      if (ABS(Amin2 - AMax2) .lt. 1.) then
         Half = (AMax2 + Amin2)/2
         Amin2 = Half - 0.5
         AMax2 = Half + 0.5
         De2 = Ratio * (Amax2 - Amin2)/2.
         Half1 = (Amin1 + AMax1)/2
         Amin1 = Half1 - De2
         AMax1 = Half1 + De2
      end if
      XXmin = Amin1
      XXMax = AMax1
      YYmin = Amin2
      YYMax = AMax2
      dx=XXMax-XXMin
      dy=YYMax-YYMin
!
          x11scale(1)=(iVP(3) - iVP(1))/dx
          x11scale(2)=(iVP(4) - iVP(2))/dy
          x11disp(1)=-XXMin
          x11disp(2)=-YYMin
!
      return
      end
! -----------------------------------------------------------------
      subroutine RotAtoms(B, iAction)
      USE Molcom
      USE Contorno
!
      dimension q(3), P(3), B(3, 3)
!
      integer O1,O2
!
      do 30 JAT = 1 , NatMol + NatSpi + 9
         q(1) = xyz(1,JAT)
         q(2) = xyz(2,JAT)
         q(3) = xyz(3,JAT)
         do 20 i = 1 , 3
            P(i) = 0
            do 10 j = 1 , 3
               P(i) = P(i) + B(i, j) * q(j)
   10       continue
   20    continue
         if (iAction.eq.1) then       ! normal rotation
            xyz(1,JAT) = P(1)
            xyz(2,JAT) = P(2)
            xyz(3,JAT) = P(3)
         end if
         if (RS(JAT) .LT. 0.0) go to 30
         if (iAction.eq.2) then       ! rotation from Find_Best_Orient.
            if (JAT.le.NatMol .OR. ifCell.gt.0) then
               if (P(1)-RS(JAT) .LT. Rmin1)  Rmin1 = P(1)-RS(JAT)
               if (P(1)+RS(JAT) .GT. RMAX1)  RMAX1 = P(1)+RS(JAT)
               if (P(2)-RS(JAT) .LT. Rmin2)  Rmin2 = P(2)-RS(JAT)
               if (P(2)+RS(JAT) .GT. RMAX2)  RMAX2 = P(2)+RS(JAT)
            end if
         end if
   30 continue
!
      if (iAction .eq. 1) then
         do 50 i = 1 , (NatMol + NatSpi) - 1
            if (RS(i) .LT. 0.0) go to 50
            do 40 K = i + 1 , NatMol + NatSpi
               if (RS(K) .LT. 0.0) go to 40
               O1 = iOrd(i)
               O2 = iOrd(K)
               O3 = xyz(3,O1)
               O4 = xyz(3,O2)
               if (O3.GT.O4) then
                  iOrd(i) = O2
                  iOrd(K) = O1
               end if
   40       continue
   50    continue
      end if
!
      if (ifDrawContour == 1) then
          do JAT = 1 , nPuntiCont + morePoints
             q(1) = xyz_tria(1,JAT)
             q(2) = xyz_tria(2,JAT)
             q(3) = xyz_tria(3,JAT)
             do i = 1 , 3
                P(i) = 0
                do j = 1 , 3
                   P(i) = P(i) + B(i, j) * q(j)
                enddo
             enddo
             xyz_tria(1,JAT) = P(1)
             xyz_tria(2,JAT) = P(2)
             xyz_tria(3,JAT) = P(3)
          enddo
      endif
!
      if (ifCubo == 9) then
          do JAT = 1 , 9
             q(:) = coordCubo(:,JAT)
             do i = 1 , 3
                P(i) = 0
                do j = 1 , 3
                   P(i) = P(i) + B(i, j) * q(j)
                enddo
             enddo
             if (iAction.eq.1) then       ! normal rotation
                coordCubo(:,JAT) = P(:)
             end if
          enddo
          xyzCubo(:) = coordCubo(:,9)
      endif
!
      return
      end
! -----------------------------------------------------------------
! ----------------------------------------------------------------------
      subroutine cmult2002(i1,eps,mult)
      USE General
      USE Symmetry
!
!-- compute epsilon and multiplicity by generating equivalent
!-- reflections
!-- epsylon = number of times same reflection appears in list
!-- multiplicity = number different reflections in list
!
      dimension i1(3),i2(3)
!
!pgMAD
      nsymPG = nsym
      if (kmad.ne.0.and.icent.gt.0) then
         nsymPG = nsym / 2
      end if
!pgMAD
      eps=1.0
      mult=1
!-- in triclinic space groups eps = 1.0 and mult = 1
      if (nsym.ne.1) then
          k1 = i1(1) * ifat512a + i1(2) * ifat512b + i1(3)
          ik1 = - k1
          do j=2,nsym
             i2 = 0
             do l=1,3
                do k=1,2
                   m=iabs(ismat(k,l,j))
                   if (m.gt.0) then
                       i2(m) = i2(m) + i1(l) * isign( 1,ismat(k,l,j) )
                   endif
                enddo
             enddo
             k2 = i2(1) * ifat512a + i2(2) * ifat512b + i2(3)
             if (k2.eq.k1) then
                 eps = eps + 1.0
             endif
             if (icent.ne.0.and.k2.eq.ik1) then
                 eps = eps + 1.0
             endif
             if (k2.eq.k1.or.k2.eq.ik1) then
                 mult = mult + 1
             endif
          enddo
      endif
      mult =nsymPG / mult           !pgMAD
!
      return
      end
! ---------------------------------------------------------------------
      subroutine AggiuSpig
      USE General
      USE Atomi
      USE Molcom
!
      implicit none
      integer :: lega(12,2), i, j, k, nlp1, iu, NuVe
      integer :: ifi, nl, nax
      real    :: x1(3), sh(3), rrv(3), xv(5,2500), dist
      real    :: x01, y1, z1, x2, y2, z2, r0, r1, xm, ym, zm
!
      lega(  1, 1) = 1
      lega(  1, 2) = 4
      lega(  2, 1) = 1
      lega(  2, 2) = 5
      lega(  3, 1) = 1
      lega(  3, 2) = 6
      lega(  4, 1) = 2
      lega(  4, 2) = 4
      lega(  5, 1) = 2
      lega(  5, 2) = 5
      lega(  6, 1) = 2
      lega(  6, 2) = 7
      lega(  7, 1) = 3
      lega(  7, 2) = 4
      lega(  8, 1) = 3
      lega(  8, 2) = 6
      lega(  9, 1) = 3
      lega(  9, 2) = 7
      lega( 10, 1) = 8
      lega( 10, 2) = 5
      lega( 11, 1) = 8
      lega( 11, 2) = 6
      lega( 12, 1) = 8
      lega( 12, 2) = 7

      xv(1, 1) = 1
      xv(2, 1) = 0
      xv(3, 1) = 0
      xv(1, 2) = 0
      xv(2, 2) = 1
      xv(3, 2) = 0
      xv(1, 3) = 0
      xv(2, 3) = 0
      xv(3, 3) = 1
      xv(1, 4) = 0
      xv(2, 4) = 0
      xv(3, 4) = 0
      xv(1, 5) = 1
      xv(2, 5) = 1
      xv(3, 5) = 0
      xv(1, 6) = 1
      xv(2, 6) = 0
      xv(3, 6) = 1
      xv(1, 7) = 0
      xv(2, 7) = 1
      xv(3, 7) = 1
      xv(1, 8) = 1
      xv(2, 8) = 1
      xv(3, 8) = 1
c      write(lo,*)'aggiuspig NatMol ',natmol
      do i = NatMol + 1, NatMol + 8
         iOrd(i) = i
         Lab(i) = ' '
         iCol(i) = color_CELL
         RS(i) = 0.01
         nzTot(i) = 0
         do j = 1, 3
            x1(j) = xv(j, i - NatMol)
         enddo
         call MoltMatVec(rm,x1,rrv)
         xyz(1,i) = rrv(1)
         xyz(2,i) = rrv(2)
         xyz(3,i) = rrv(3)
c	write(lo,*)'do 200,i,xyz(1:3,i) ',i,xyz(1:3,i)
      enddo
      NatSpi = 9
      nlp = 0
      do i = 1, 12
         j = lega(i,1) + NatMol
         k = lega(i,2) + NatMol
         x01 = xyz(1,j)
         y1 = xyz(2,j)
         z1 = xyz(3,j)
         x2 = xyz(1,k)
         y2 = xyz(2,k)
         z2 = xyz(3,k)
         dist = sqrt( (x01-x2)**2 + (y1-y2)**2 + (z1-z2)**2 )
         r0 = 2.5 / dist
         r1 = r0
         iu = j
  250    xm = x01 + (x2 - x01) * r1
         ym = y1 + (y2 - y1) * r1
         zm = z1 + (z2 - z1) * r1
         xyz(1, NatMol + NatSpi) = xm
         xyz(2, NatMol + NatSpi) = ym
         xyz(3, NatMol + NatSpi) = zm
c	write(lo,*)'do 250,i,xyz(1:3,natmol+natspi) '
c	1,natmol+natspi,xyz(1:3,natmol+natspi)
         do j = 1, 3
            x1(j) = xyz(j,NatMol+NatSpi)
         enddo
         call MoltMatVec(rmi,x1,rrv)
         xv(1, NatSpi) = rrv(1)
         xv(2, NatSpi) = rrv(2)
         xv(3, NatSpi) = rrv(3)
         iOrd(NatMol + NatSpi) = NatMol + NatSpi
         Lab(NatMol + NatSpi) = ' '
         iCol(NatMol + NatSpi) = color_CELL
         RS(NatMol + NatSpi) = 0.01
         nzTot(NatMol + NatSpi) = 0
         LE(1, nMaxLeg - nlp) = iu
         LE(2, nMaxLeg - nlp) = NatMol + NatSpi
         LE(3, nMaxLeg - nlp) = 0
         iu = NatMol + NatSpi
         nlp = nlp + 1
         r1 = r1 + r0
         NatSpi = NatSpi + 1
         if (NatMol + NatSpi .gt. MaxAtomsInGr) exit
         if (r1 .lt. 1.) then
             goto 250
         else
             LE(1, nMaxLeg - nlp) = iu
             LE(2, nMaxLeg - nlp) = k
             LE(3, nMaxLeg - nlp) = 0 
c	write(lo,*)'nmaxleg,nlp,le(1:3,nmaxleg-nlp) ',
c     1 nmaxleg,nlp,le(1:3,nmaxleg-nlp)
             nlp = nlp + 1
         end if
      enddo
      LE(1, nMaxLeg - nlp) = 0
      LE(2, nMaxLeg - nlp) = 0
      LE(3, nMaxLeg - nlp) = 0
      NatSpi = NatSpi - 1
      if (ifCont /= 0) then
!
          NuVe = NatSpi
          nlp1 = nlp
          dtr = atan(1.)
          do nax = 1, 3
             sh(1) = 0
             sh(2) = 0
             sh(3) = 0
             if (nCell(nax).gt.1) then
                sh(nax) = 1
                ifi = 1
                if (nCell(nax).eq.3) ifi = -1
                do j=ifi, 1, 2
                   do i=NatMol+1, NatMol+NuVe
                      NatSpi = NatSpi + 1
                      xv(1, NatSpi) = xv(1, i - NatMol) + j * sh(1)
                      xv(2, NatSpi) = xv(2, i - NatMol) + j * sh(2)
                      xv(3, NatSpi) = xv(3, i - NatMol) + j * sh(3)
                      x1(1:3) = xv(1:3, NatSpi)
                      call MoltMatVec(rm,x1,rrv)
                      xyz(1, NatMol + NatSpi) = rrv(1)
                      xyz(2, NatMol + NatSpi) = rrv(2)
                      xyz(3, NatMol + NatSpi) = rrv(3)
                      iOrd(NatMol + NatSpi) = NatMol + NatSpi
                      Lab(NatMol + NatSpi) = ' '
                      iCol(NatMol + NatSpi) = color_CELL
                      RS(NatMol + NatSpi) = 0.01
                      nzTot(NatMol + NatSpi) = 0
                   enddo
                   do nl=nlp,nlp+nlp1
                      LE(1, nMaxLeg - nl) = LE(1,nMaxLeg-nl+nlp1)+NuVe
                      LE(2, nMaxLeg - nl) = LE(2,nMaxLeg-nl+nlp1)+NuVe
                      LE(3, nMaxLeg - nl) = 0
                   enddo
                   nlp = nlp + nlp1
                enddo
                NuVe = NatSpi
                nlp1 = nlp
             end if
          enddo
          LE(1, nMaxLeg - nlp) = 0
          LE(2, nMaxLeg - nlp) = 0
          LE(3, nMaxLeg - nlp) = 0
      endif
      j = NatMol + NatSpi
      do i=1,9
         xyz(:,j+i) = coordCubo(:,i)
      enddo
      xyzCubo(:) = 10000
!
      return
      end
!-----------------------------------------------------------------------
      subroutine InitMolplo
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE PhaseModule
!
      implicit none
      integer :: i
      real    :: abcl, abcmin
      character str2*90, str*256
!
      DrawBard(:) = 0
      DrawDeltX   = 0
      DrawDeltY   = 0
!
!-- contour defaults
!
      Max_Points  = xyz_triadim - 28
      ifGhost = 1
      ifOriented = 0
      ifDrawContour = 0
      nLevels(1)  = 15     
      nLevels(2)  = 5     
      ifLevel     = 0
      ifLevel(3)  = 1
!!mr      ifLevel     = 1
      SoglieCont  = 0.0
      do i=1,5
!!mr         if(jBackGround.eq.0) then
!!mr            LevelCol(i) = 16 - i + NToAdd
!!mr         else
            LevelCol(i) = 3 + i + NToAdd
!!mr         endif
      enddo 
      sezione0    = 0
      sezioneN    = 0
      abcmin = 9999
      do i=1,3
         xyzlimCont(1,i) = xyzfou(i,1) / xyzfou(i,4)
         xyzlimCont(2,i) = xyzfou(i,2) / xyzfou(i,4)
         deltaCont(i)  = xyzlimCont(2,i) - xyzlimCont(1,i)
         centerCont(i) = xyzlimCont(1,i) + deltaCont(i) / 2.0
         numCell(i,1) = 1
         numCell(i,2) = 0
         abcl = cell(i) * deltaCont(i)
         if (abcl < abcmin) then
             abcmin = abcl
             Layer  = i
         endif
      enddo
      ifModel = 0
      ifAlreadyProduced = 1
      ifGrid = 0
      Shapes(1) = 3
      Shapes(2) = 4
      Shapes(3) = 7
      Shapes(4) = 10
      Shapes(5) = 4
      Shapes(6) = 7
      moreLines = 0
      WhichRes = 1
      WhichLimit = 1
!
      ifFour = 0
      call Orto(cell)
!
!-- Drawing Options
!
      ifCont = 0
      ifCell = 0
      ifGrid = 0
      ifScale = 1
      ifGhost = 1
      ifDrRes = 0
      ifDrHydr = 1
      ifDrHBond = 1
      ifChangedXYZ = 0
!
      return
      end
c ---------------------------------------------------------------------
      subroutine GetInfoContour(grid, info)
      USE Molcom
      USE Mappa, only: np
      implicit none
      type InfoContour
                 integer      :: ifLevel(5)
                 real         :: Soglie(15)
                 integer      :: LevelCol(5)
                 integer      :: Layer
                 integer      :: sezione0
                 integer      :: sezioneN
                 real         :: centerCont(3)
                 real         :: deltaCont(3)
                 real         :: xyzlimCont(2, 3)
                 integer      :: ifModel
                 integer      :: massimoMappa
                 integer      :: ifGrid
                 integer      :: WhichLimit
                 integer      :: numCell(3, 2)
      end type InfoContour
!      
      type (InfoContour)  :: info
      integer             :: grid(3)
!
      grid = np
      info%ifLevel= ifLevel
      info%Soglie= SoglieCont
      info%LevelCol= LevelCol
      info%Layer= Layer
      info%sezione0= sezione0
      info%sezioneN= sezioneN
      info%centerCont= centerCont
      info%deltaCont= deltaCont
      info%xyzlimCont= xyzlimCont
      info%ifModel= ifModel
      info%massimoMappa= massimoMappa
      info%ifGrid= ifGrid
      info%WhichLimit= WhichLimit
      info%numCell= numCell
!
      return
      end subroutine GetInfoContour
c ---------------------------------------------------------------------
      subroutine PutInfoContour(info)
      USE Molcom
      implicit none
      type InfoContour
                 integer      :: ifLevel(5)
                 real         :: Soglie(15)
                 integer      :: LevelCol(5)
                 integer      :: Layer
                 integer      :: sezione0
                 integer      :: sezioneN
                 real         :: centerCont(3)
                 real         :: deltaCont(3)
                 real         :: xyzlimCont(2, 3)
                 integer      :: ifModel
                 integer      :: massimoMappa
                 integer      :: ifGrid
                 integer      :: WhichLimit
                 integer      :: numCell(3, 2)
      end type InfoContour
!      
      type (InfoContour)  :: info
!
      ifLevel = info%ifLevel
      SoglieCont = info%Soglie
      LevelCol = info%LevelCol
      Layer = info%Layer
      sezione0 = info%sezione0
      sezioneN = info%sezioneN
      centerCont = info%centerCont
      deltaCont = info%deltaCont
      xyzlimCont = info%xyzlimCont
      ifModel = info%ifModel
      massimoMappa = info%massimoMappa
      ifGrid = info%ifGrid
      WhichLimit = info%WhichLimit
      numCell = info%numCell
!
      return
      end subroutine PutInfoContour
c ---------------------------------------------------------------------
      subroutine ViewForJav(iaction)
!
      Use Molcom
      implicit none
      integer     :: iaction, iScelta      
!
      ifScale = 0
      select case (iAction)
      
             case (15)                            ! Zoom In
                   call Translate(6,10.)

             case (16)                            ! Zoom Out
                   call Translate(5,10.)

             case (17)                            ! Reset View
                   call SetScaleMap()
      
             case (21,22,23)             ! View Plane
                   iScelta = iAction - 17

                   call ChePiano (iScelta)
                   call FindMinMax
                   Layer = iAction - 20
                   sezione0 = 0
                   sezioneN = 0
                   call LeggiSezioni()
!
                   call SetScaleMap()
                   ifOriented = 0
      end select

      call PlotContourJav()
!
      return
      end
! ----------------------------------------------------------------------
      subroutine Translate (iAction, Perc)
      USE Molcom
      implicit none
      integer    :: iAction
      real       :: Perc, D1, D2
!
      Rmin1 = Xmin
      Rmin2 = Ymin
      RMax1 = XMax
      RMax2 = YMax
      D1 = (RMAX1 - Rmin1) * Perc / 100.
      D2 = (RMAX2 - Rmin2) * Perc / 100.
      if (iAction.EQ.1) then
         Rmin1 = Rmin1 + D1
         RMax1 = RMax1 + D1
      else if (iAction.EQ.2) then
         Rmin1 = Rmin1 - D1
         RMax1 = RMax1 - D1
      else if (iAction.EQ.3) then
         Rmin2 = Rmin2 + D2
         RMax2 = RMax2 + D2
      else if (iAction.EQ.4) then
         Rmin2 = Rmin2 - D2
         RMax2 = RMax2 - D2
      else if (iAction.EQ.5) then
         Rmin1 = Rmin1 - D1
         RMax1 = RMax1 + D1
         Rmin2 = Rmin2 - D2
         RMax2 = RMax2 + D2
      else if (iAction.EQ.6) then
         Rmin1 = Rmin1 + D1
         RMax1 = RMax1 - D1
         Rmin2 = Rmin2 + D2
         RMax2 = RMax2 - D2
      end if
      Xmin = Rmin1
      Ymin = Rmin2
      XMax = RMax1
      YMax = RMax2
      call SetScale(0)
      return
      end
! -----------------------------------------------------------------      
      subroutine SetCellDraw (iact)
      USE Molcom
      implicit none
      integer  :: iact
!      
      ifCell = iact
!      
      return
      end
! -----------------------------------------------------------------      
      subroutine SetGridDraw (iact)
      USE Molcom
      implicit none
      integer  :: iact
!      
      ifGrid = iact
!      
      return
      end
! -----------------------------------------------------------------      
