MODULE javinterface
   implicit none

!!mr   integer, parameter :: PRESENTNZ = 1
   integer, parameter :: PRESENTNZ = -1

   CONTAINS

      subroutine fromModelToAtom(atom)
      USE MolCom, only: rm
      USE RemoModule
      USE atom_basic
      USE Atomi, only: aLab,nzConst
      USE sinterface, only: bij_atom
      USE General, only: celem
!
      implicit none
      integer nats, i, j, k
      type(atom_type), dimension(:)           :: atom
!

      nats = size(atom)
      do i=1, nats
         j = InfoOnModels(WhichModel)%iEqui(i)
         atom(i)%xc(1:3) = model(WhichModel)%atoms(1:3,i,1)
!        atom(i)%xc(1:3) = model(WhichModel)%ortho(1:3,i,1)
         atom(i)%biso    = model(WhichModel)%th_fact(j,1)
         atom(i)%bij(1:6)= bij_atom(model(WhichModel)%bij(1:6,i,1))
         atom(i)%och     = 1
         atom(i)%inte    = model(WhichModel)%atoms(4,i,1)
         atom(i)%ocry    = model(WhichModel)%atoms(5,i,1)
!corr         atom(i)%nz      = model(WhichModel)%specie(j,1) * nzConst
         call atom(i)%set_specie(model(WhichModel)%specie(j,1),celem)
         atom(i)%lab     = model(WhichModel)%Label(j)
!mr       aLab(i)         = model(1)%Label(i)
         atom(i)%rcod(:) = 0
      enddo
!
      return
      end subroutine fromModelToAtom
!-----------------------------------------------------------------------
!
      subroutine fromAtomToModel(atom)
      USE MolCom, only: rm
      USE RemoModule
      USE atom_basic
      USE Atomi, only: aLab,nzConst
!
      implicit none
      integer nats, i, k
      real                                    :: x1(3), x2(3)
      type(atom_type), dimension(:)           :: atom
!

      nats = size(atom)
      do i=1, nats
         model(WhichModel)%atoms(1:3,i,1) = atom(i)%xc(1:3) 
         model(WhichModel)%atoms(5,i,1) = atom(i)%ocry 
!!mr     if(model(WhichModel)%Label(i)(1:1) == ' ') then
            model(WhichModel)%Label(i) = atom(i)%lab 
!!mr     endif
      enddo
!
      do i=1, nats
         x1(1:3) = model(WhichModel)%atoms(1:3,i,1)
!        model(WhichModel)%saved(1:3,i,1)= x1(1:3)   ! oviedo
         call MoltMatVec(rm, x1, x2)
         model(WhichModel)%ortho(1:3,i,1)= x2(1:3)
      enddo
!
      return
      end subroutine fromAtomToModel

!-----------------------------------------------------------------------
!corr
!corr   integer function operator_code(kop,tra) result(opcode)
!corr!
!corr!  Genara codice per memorizzare la rotazione e la traslazione
!corr!
!corr   integer, intent(in)               :: kop
!corr   integer, dimension(3), intent(in) :: tra
!corr!
!corr   opcode = kop*1000+(5+tra(1))*100+(5+tra(2))*10+(5+tra(3))
!corr!
!corr   end function operator_code
!corr
!-----------------------------------------------------------------------
      subroutine real_jav_passa_modello(atom,legm,elem,spg,numAu,nlegs_au,km, nm, flag_resize)
      USE General, only: slash, filePDB, cardImage
      USE RemoModule
      USE connect_mod
      USE Atomi, only:nzConst
      USE atom_type_util
      USE spginfom
      USE elements
      implicit none
      type(atom_type), dimension(:), allocatable, intent(in)    :: atom
      type(bond_type), dimension(:), allocatable, intent(in)    :: legm
      type(element_type), dimension(:), allocatable, intent(in) :: elem
      type(spaceg_type), intent(in)                             :: spg
      integer                                                   :: natom, ierr
      integer                                                   :: numlegs        
      integer                                                   :: nelem
      integer                                                   :: icent
      integer                                                   :: km,nm
      integer                                                   :: i, L1, L2, Lung
      integer                                                   :: numAu, nlegs_au
      logical                                                   :: symatoms
      integer                                                   :: flag_resize
      integer, dimension(:), allocatable                        :: het
      type(atom_type), dimension(1)                             :: at0
      type(bond_type), dimension(1)                             :: b0
!
      WhichModel = km
      numbModels = nm    !!max(nm, km)
      natom = numatoms(atom)
      numlegs = numbonds(legm)
      nelem = numelem(elem)
      if (spg%symcent == 1) then
          icent = 1
      else
          icent = 0
      endif
!
      L1 = index(filePDB, slash, .TRUE.)
      if (L1 > 0) then
          L1 = L1 + 1
      else
          L1 = 1
      endif
      L2 = Lung(filePDB)
      cardImage = filePDB(1:L2) // char(0)

      L1 = Model(WhichModel)%PDB
      if (numAu /= 0) then
          allocate(het(1:numAu))
          if(allocated(Model(whichModel)%HETA)) then
             if(size(Model(whichModel)%HETA) >= numAu) then
                het(:) = Model(whichModel)%HETA(1:numAu, 1)
             else
                het(:) = 1
             endif
          else
             het(:) = 1
          endif
      endif
      if (natom == 0) then
          call PassaModello( at0, b0, natom, numau, numlegs, nlegs_au, elem, nelem, icent, km, nm, flag_resize)
      else
          if (numlegs == 0) then
             call PassaModello(atom,b0,natom,numau,numlegs,nlegs_au, elem, nelem, icent, km, nm, flag_resize)
          else
             call PassaModello(atom,legm,natom,numau,numlegs,nlegs_au, elem, nelem, icent, km, nm, flag_resize)
          endif
      endif
!
      end subroutine real_jav_passa_modello
!----------------------------------------------------------------------

      subroutine NonUsatajav_get_bij(i, cbij)
      USE RemoModule
!
      implicit none
      integer            :: i, j, k
      real               :: cbij(6)
!
      j = InfoOnModels(WhichModel)%iEqui(i)
      do k=1, 6
         cbij(k) = model(WhichModel)%bij(k, j, 1)
      end do
!
      end subroutine NonUsatajav_get_bij
!-----------------------------------------------------------------------
      subroutine NonUsataSetActiveModel(Which)
      USE RemoModule, only: WhichModel
      implicit none
      integer  :: Which
!
      WhichModel = Which
!!      call GetModelInfo(Which)
!
      end subroutine NonUsataSetActiveModel
!-----------------------------------------------------------------------

END MODULE javinterface
 
      subroutine NonUsataCSetModel(Which)
      USE javinterface
      implicit none
      integer  :: Which
!
!!      call SetActiveModel(Which)
!
      end subroutine NonUsataCSetModel
!-----------------------------------------------------------------------

      function NonUsataGetActiveModel() result (Which)
      USE RemoModule, only: WhichModel
      implicit none
      integer  :: Which
!
      Which = WhichModel
!
      end function NonUsataGetActiveModel
!-----------------------------------------------------------------------
