#define ENTRY_SIZE 65
#define EMPTY_LIST_HEIGHT       (15)

#include "mrconfig.h"
#ifdef _WIN32
#include <windows.h>
#endif
#include "aliasx.h"
#include "toolbar.h"
#include "callbacks.h"
#include <gtkmrcomune.h>
#include "menubar.h"
#include <fcntl.h>
#include <locale>
#include <sstream>
int iconified;

namespace main_app {
       extern Application TheApp;
                   }
extern "C" _CContour *Contour;
extern "C" void cflush_(void);
extern "C" void hidemesg_(void);
void change_bg(const char *name, int i1, int i2);
void reset_jav_var();
gboolean statoinimb[6][150];
gboolean auto_newproj = FALSE;

void abilitatb(GtkWidget *widget, int state);
void abilitamb(GtkWidget *mwin, int stato);
void salva_stato_tb(GtkWidget *widget, gboolean stato_sav[]);
void salva_stato_mb(GtkWidget *widget, gboolean stato_sav[]);
void quit_program (GtkWidget *widget, gpointer data);
void compare_w(GtkWindow *winmain, const char *filnam, const char *filter, int flags, const char *title);
void c_newbestmodel(GtkButton *button, gpointer data);
void splash(const char *splash_file);
float *get_fcolor(int new_color);

gboolean statoinitb[6][51];
const gchar *toolbarname[5]        = {"toolbar_main",
                                      "toolbar",
                                      "toolbar",
                                      "toolbar",
                                      "toolbar"};
GdkPoint *points;

//  -----------------------------------------
extern bool ifSannel;
extern PangoFontDescription *fontdescN, *fontdescP, *fontdescU;
extern int jscreen;
extern int mainloop;
extern gboolean single_it;
extern gboolean ifHidden;
extern int Ascent,Descent, larSaveP, larSaveN, altSaveP, altSaveN;
//  -----------------------------------------
GdkColor BgColor;
/*-------------------------------------------------------------*/
/*          Local (private) variables                          */
/*-------------------------------------------------------------*/
static GtkWidget *mainwin; 
static GtkWidget *drawingarea;
static GtkWidget *statusbar;
static gboolean ifParam = FALSE;
//static int NMESSAGES=12;
//static bool AreaMessaggi = false;
std::vector <GtkWidget *> vett_dlg;

/*-------------------------------------------------------------*/
/*          Global internal variables                          */
/*-------------------------------------------------------------*/

gboolean ifQuery = FALSE;
gboolean can_drag = TRUE;
gpointer initial_pix;
gboolean show_toolbar = TRUE;
int Livcur = 0;
os_and_gc *outBuf;
extern GtkWidget *viewer_window;

int curSmiley = 1;
//extern gboolean viewerOpened;
gboolean viewerOpened = FALSE;
GtkWidget *finestre[6];
int win_stack = 0;
int curSmileySav = 1;
GdkCursor *cross_cursor, *default_cursor, *help_cursor, *pick_cursor,
          *drag1_cursor, *drag2_cursor, *wait_cursor, *move_cursor,
          *zoom_cursor;
GtkWidget *pixsmiley = NULL;
GdkPixbufAnimation *smil_buf[NUM_SMILEY];

extern stringa     *It;
extern _Dialogo *dialogo;
extern "C" _SWareRC *SWareRC;
extern "C" Tasti *tasti;
extern "C" RecentPr *RP;
extern "C" WindoMess *winmess;
extern "C" _args *args;

/* internally used functions */

void init_toggles2();
GtkWidget* create_mainwin  (int wi, int he);
static gboolean on_configure_event (GtkWidget *widget, GdkEventConfigure *event,
                                 gpointer user_data);
void createHtml(int ifBody, int ifPng, const char *inp_suff, const char *out_suff);
void PrimeCose (GtkWidget *main_window);
gboolean destroy (GtkWidget *widget, GdkEvent *event, gpointer data);
GtkWidget *CreateSideFrame(GtkWidget *main_window, int ori);
void do_configure(GtkWidget *widget, int w, int h);

typedef struct {
                  gpointer  reg;
                  char      *lab;
               } _InfoReg;

/********************************************************************************/
/*                L i s t s    U t i l i t i e s                                */
/********************************************************************************/

#ifdef USE_ACTIONS
gpointer get_action (const char *name)
{
    GtkActionGroup *ag = (GtkActionGroup *) get_object(finestre[0],
      "action_group");
    if(ag)
       return gtk_action_group_get_action(ag, name);
    return NULL;
}

void salva_stato_tb(GtkWidget *widget, gboolean stato_sav[])
{
    GList     *children;
    GtkWidget *child, *hbox;
    int       numChildren,i;

    children = gtk_container_get_children(GTK_CONTAINER(get_widget(widget, "tb")));
    numChildren = g_list_length(children);

    for(i=0; i<numChildren;i++)
    {
        child = GTK_WIDGET(g_list_nth_data(children, i));
        if(gtk_widget_get_sensitive(child))
           stato_sav[i] = TRUE;
        else
           stato_sav[i] = FALSE;
    }
    hbox = gtk_widget_get_parent(widget); //get_widget(widget, "hbox");
    if(gtk_widget_get_sensitive(hbox))
       stato_sav[50] = TRUE;
    else
       stato_sav[50] = FALSE;
    if(children)
       g_list_free(children);
}

void abilitatb(GtkWidget *widget, int state)
{
    GList     *children;
    GtkWidget *child, *hbox;
    int       numChildren,i;
    bool      to_show = true;
    gpointer  act;

    if(ifToolbar && show_toolbar && strstr(toolbarname[Livcur], "main")) 
    {
       to_show = main_app::TheApp.standalone;
#ifndef _WIN32
       i = isatty(STDIN_FILENO);
       if(!i)
          to_show = FALSE;
#endif
        gpointer bterm = get_object(finestre[0], "terminal");
        if(!to_show)
           obj_hide(bterm); 
     }
       children = gtk_container_get_children(GTK_CONTAINER(get_widget(widget, "tb")));
       numChildren = g_list_length(children);
       hbox = get_widget(widget, "hbox");
       switch(state)
       {
       case -1:
          gtk_widget_set_sensitive(hbox, statoinitb[0][50]);
          break;
       case -2:
          gtk_widget_set_sensitive(hbox, statoinitb[win_stack][50]);
          break;
       default:
          gtk_widget_set_sensitive(hbox, state);
          break;
       }
       for(i=0; i<numChildren;i++)
       {
           child = GTK_WIDGET(g_list_nth_data(children, i));
           const char *nome = gtk_widget_get_name(child);
           if((act = get_action(nome)) == NULL)
               continue;
           switch(state)
           {
              case -1:
                 gtk_action_set_sensitive(GTK_ACTION(act), statoinitb[0][i]);
                 break;
              case -2:
                 gtk_action_set_sensitive(GTK_ACTION(act), statoinitb[win_stack][i]);
                 break;
              case 1:
                 if(strstr(nome, "Load") || strstr(nome, "New") ||
                    strstr(nome, "Old") ||
                    strstr(nome, "Save") || strstr(nome, "Restore") )
                    gtk_action_set_sensitive(GTK_ACTION(act), FALSE);
                 else if(!strcmp(nome, "View") && (dialogo->ifMadEnv == 2))
                    gtk_action_set_sensitive(GTK_ACTION(act), TRUE);
                 else
                 gtk_action_set_sensitive(GTK_ACTION(act), statoinitb[0][i]);
                 break;
              default:
                 if(strstr(nome, "Move Labels") && state)
                    gtk_action_set_sensitive(GTK_ACTION(act), dialogo->ifLabels);
                 else
                    gtk_action_set_sensitive(GTK_ACTION(act), state);
                 break;
           }
       }
    if(children)
       g_list_free(children);
}

void salva_stato_mb(GtkWidget *widget, gboolean stato_sav[])
{
    GList     *children, *nipoti;
    GtkWidget *child, *widgetf, *nipote;
    int       numChildren, numnipoti,i, j, k;
    gpointer  act;

    children = gtk_container_get_children(GTK_CONTAINER(widget));
    numChildren = g_list_length(children);
    k = 0;
    for(i=0; i<numChildren - 1;i++)
    {
        child = GTK_WIDGET(g_list_nth_data(children, i));
        const char *nome = gtk_widget_get_name(child);
        if((act = get_action(nome)) == NULL)
            continue;
        if(gtk_action_get_sensitive(GTK_ACTION(act)))
           stato_sav[k++] = TRUE;
        else
           stato_sav[k++] = FALSE;
	widgetf = gtk_menu_item_get_submenu(GTK_MENU_ITEM(child));
        nipoti = gtk_container_get_children(GTK_CONTAINER(widgetf));
        numnipoti = g_list_length(nipoti);
        if(numnipoti > 0)
           for(j=0; j<numnipoti;j++)
           {
               nipote = GTK_WIDGET(g_list_nth_data(nipoti, j));
               const char *nome = gtk_widget_get_name(nipote);
               if((act = get_action(nome)) == NULL)
                   continue;
               if(gtk_action_get_sensitive(GTK_ACTION(act)))
                  stato_sav[k++] = TRUE;
               else
                  stato_sav[k++] = FALSE;
           }
    }
    if(children)
       g_list_free(children);
}

void abilita_item(GtkWidget *child, int stato, int *indice)
{
  int k;
  gpointer act;
  const char *nome = gtk_widget_get_name(child);
  if((act = get_action(nome)) == NULL)
      return;

  k = *indice;
   
  switch(stato)
  {
  case -1:
       gtk_action_set_sensitive(GTK_ACTION(act), statoinimb[0][k]);
       break;
  case -2:
       gtk_action_set_sensitive(GTK_ACTION(act), statoinimb[win_stack][k]);
       break;
  case -3:
       gtk_action_set_sensitive(GTK_ACTION(act), statoinimb[5][k]);
       break;
  case 0:
       gtk_action_set_sensitive(GTK_ACTION(act), stato);
       break;
  default:
       stato = stato - 1;
       if(strstr(nome, "Enant") && stato)
             stato =  1-dialogo->ifCentro;
       if(strstr(nome, "Move in P") && stato)
             stato =  dialogo->ifGS_P1;
       gtk_action_set_sensitive(GTK_ACTION(act), stato);
       break;
  }
  k++;
  *indice = k;
}

void abilitamb(GtkWidget *mwin, int stato)
{
    GList     *children, *nipoti;
    GtkWidget *child, *widget, *widgetf, *nipote;
    int       numChildren, numnipoti, i, j, k, statovero, nAtomi;
    gpointer act;

    if(ifMenubar)
    {
       widget = lookup_widget(mwin, menubarname);
       children = gtk_container_get_children(GTK_CONTAINER(widget));
       numChildren = g_list_length(children);
       k = 0;

       statovero = stato;
       for(i=0; i<numChildren - 1;i++)
       {
           stato = statovero;
           child = GTK_WIDGET(g_list_nth_data(children, i));
           const char *nome = gtk_widget_get_name(child);
           if((act = get_action(nome)) == NULL)
               continue;
           if(stato == 1)
           {
              if(strstr(nome, "Solve") && (dialogo->ifMadEnv != 2))
                 stato = 2;
              else if(strstr(nome, "View") 
                      && (dialogo->ifMadEnv == 2))
                 stato = 2;
              else
                 stato = -1;
           }
           abilita_item(child, stato, &k);
           if(statovero == 0)
              continue;
           widgetf = gtk_menu_item_get_submenu(GTK_MENU_ITEM(child));
           nipoti = gtk_container_get_children(GTK_CONTAINER(widgetf));
           numnipoti = g_list_length(nipoti);
           if(numnipoti > 0)
           {
              for(j=0; j<numnipoti;j++)
              {
                  nipote = GTK_WIDGET(g_list_nth_data(nipoti, j));
                  const char *nome1 = gtk_widget_get_name(nipote);
                  if((act = get_action(nome1)) == NULL)
                      continue;
                  if((strstr(nome1, "Save") || strstr(nome1, "Export")) &&
                        (statovero > 0) && (dialogo->ifMadEnv != 2))
                     abilita_item(nipote, 2, &k);
//                else if((strstr(nome1, "Save") || strstr(nome1, "Export")) && 
//                      (dialogo->ifMadEnv == 2))
//                   abilita_item(nipote, 2, &k);
                else if(strstr(nome1, "Jav") && (statovero > 0) && 
                      (dialogo->ifMadEnv == 2))
                   abilita_item(nipote, 2, &k);
                 else if(strstr(nome, "View") && (dialogo->ifMadEnv == 2))
                   abilita_item(nipote, statovero, &k);
                  else if((strstr(nome1, "BackBone")) && !dialogo->ifPDBcoded)
                     abilita_item(nipote, 0, &k);
                  else if(strstr(nome1, "Select among") ||
                          strstr(nome1, "Simulated Annealing"))
                     abilita_item(nipote, statovero, &k);
                  else if((dialogo->ifMadEnv == 2) && (statovero == 1) &&
                         strstr(nome, "File"))
                  {
                     if(strstr(nome1, "View output") || strstr(nome1, "Exit") ||
                        strstr(nome1, "HardCopy") || strstr(nome1, "Summary"))
                        abilita_item(nipote, 2, &k);
                      else
                        abilita_item(nipote, 1, &k);
                  }
                  else
                     abilita_item(nipote, stato, &k);
              }
           }
       }
       if(numChildren > 0)
          g_list_free(children);
       nAtomi = valore_di_nats_();
       if(nAtomi > MaxAtLSQ)
       {
          if((act = get_action("Refine")) != NULL)
              gtk_action_set_sensitive(GTK_ACTION(act), FALSE);
       }
       act = get_action("Help");
       gtk_action_set_sensitive(GTK_ACTION(act), TRUE);
    }
    init_toggles2();
}
#else
void salva_stato_tb(GtkWidget *widget, gboolean stato_sav[])
{
    GList     *children;
    GtkWidget *child, *hbox;
    int       numChildren,i;

    children = gtk_container_get_children(GTK_CONTAINER(get_widget(widget, "tb")));
    numChildren = g_list_length(children);

    for(i=0; i<numChildren;i++)
    {
        child = GTK_WIDGET(g_list_nth_data(children, i));
        if(gtk_widget_get_sensitive(child))
           stato_sav[i] = TRUE;
        else
           stato_sav[i] = FALSE;
    }
    hbox = gtk_widget_get_parent(widget); //get_widget(widget, "hbox");
    if(gtk_widget_get_sensitive(hbox))
       stato_sav[50] = TRUE;
    else
       stato_sav[50] = FALSE;
    if(numChildren > 0)
       g_list_free(children);
}

void abilitatb(GtkWidget *widget, int state)
{
    GList     *children;
    GtkWidget *child, *hbox;
    int       numChildren,i;
    bool      to_show = true;

    if(ifToolbar && show_toolbar && strstr(toolbarname[Livcur], "main")) 
    {
       to_show = main_app::TheApp.standalone;
#ifndef _WIN32
       i = isatty(STDIN_FILENO);
       if(!i)
          to_show = FALSE;
#endif
        gpointer bterm = get_object(finestre[0], "terminal");
        if(!to_show)
           obj_hide(bterm); 
     }
       children = gtk_container_get_children(GTK_CONTAINER(get_widget(widget, "tb")));
       numChildren = g_list_length(children);
       hbox = get_widget(widget, "hbox");
       switch(state)
       {
       case -1:
          gtk_widget_set_sensitive(hbox, statoinitb[0][50]);
          break;
       case -2:
          gtk_widget_set_sensitive(hbox, statoinitb[win_stack][50]);
          break;
       default:
          gtk_widget_set_sensitive(hbox, state);
          break;
       }
       for(i=0; i<numChildren;i++)
       {
           child = GTK_WIDGET(g_list_nth_data(children, i));
           char *nm = g_strdup(gtk_widget_get_name(child));
           switch(state)
           {
              case -1:
                 gtk_widget_set_sensitive(child, statoinitb[0][i]);
                 break;
              case -2:
                 gtk_widget_set_sensitive(child, statoinitb[win_stack][i]);
                 break;
              case 1:
                 if(strstr(nm, "Load") || strstr(nm, "New") ||
                    strstr(nm, "Old") ||
                    strstr(nm, "Save") || strstr(nm, "Restore") )
                    gtk_widget_set_sensitive(child, FALSE);
                 else if(!strcmp(nm, "View") && (dialogo->ifMadEnv == 2))
                    gtk_widget_set_sensitive(child, TRUE);
                 else
                    gtk_widget_set_sensitive(child, statoinitb[0][i]);
                 break;
              default:
                 if(strstr(nm, "Move Labels") && state)
                    gtk_widget_set_sensitive(child, dialogo->ifLabels);
                 else
                    gtk_widget_set_sensitive(child, state);
                 break;
           }
           g_free(nm);
       }
       if(numChildren > 0)
          g_list_free(children);
}

void salva_stato_mb(GtkWidget *widget, gboolean stato_sav[])
{
    GList     *children, *nipoti;
    GtkWidget *child, *widgetf, *nipote;
    int       numChildren, numnipoti,i, j, k;

    children = gtk_container_get_children(GTK_CONTAINER(widget));
    numChildren = g_list_length(children);
    k = 0;
    for(i=0; i<numChildren - 1;i++)
    {
        child = GTK_WIDGET(g_list_nth_data(children, i));
        if(gtk_widget_get_sensitive(child))
           stato_sav[k++] = TRUE;
        else
           stato_sav[k++] = FALSE;
	widgetf = gtk_menu_item_get_submenu(GTK_MENU_ITEM(child));
        nipoti = gtk_container_get_children(GTK_CONTAINER(widgetf));
        numnipoti = g_list_length(nipoti);
        if(numnipoti > 0)
        {
           for(j=0; j<numnipoti;j++)
           {
               nipote = GTK_WIDGET(g_list_nth_data(nipoti, j));
               if(gtk_widget_get_sensitive(nipote))
                  stato_sav[k++] = TRUE;
               else
                  stato_sav[k++] = FALSE;
           }
           g_list_free(nipoti);
        }
    }
    if(numChildren > 0)
       g_list_free(children);
}

void abilita_item(GtkWidget *child, int stato, int *indice)
{
  int k;

  k = *indice;
   
  switch(stato)
  {
  case -1:
       gtk_widget_set_sensitive(child, statoinimb[0][k]);
       break;
  case -2:
       gtk_widget_set_sensitive(child, statoinimb[win_stack][k]);
       break;
  case -3:
       gtk_widget_set_sensitive(child, statoinimb[5][k]);
       break;
  case 0:
       gtk_widget_set_sensitive(child, stato);
       break;
  default:
       stato = stato - 1;
       if(strstr(gtk_widget_get_name(child), "Enant") && stato)
             stato =  1-dialogo->ifCentro;
       if(strstr(gtk_widget_get_name(child), "Move in P") && stato)
             stato =  dialogo->ifGS_P1;
       gtk_widget_set_sensitive(child, stato);
       break;
  }
  k++;
  *indice = k;
}

void abilitamb(GtkWidget *mwin, int stato)
{
    GList     *children, *nipoti;
    GtkWidget *child, *widget, *widgetf, *nipote;
    int       numChildren, numnipoti, i, j, k, statovero, nAtomi;

    if(ifMenubar)
    {
       widget = lookup_widget(mwin, menubarname);
       children = gtk_container_get_children(GTK_CONTAINER(widget));
       numChildren = g_list_length(children);
       k = 0;

       statovero = stato;
       for(i=0; i<numChildren - 1;i++)
       {
           stato = statovero;
           child = GTK_WIDGET(g_list_nth_data(children, i));
           const char *nm = gtk_widget_get_name(child);
           if(stato == 1)
           {
              if(strstr(nm, "Solve") && (dialogo->ifMadEnv != 2))
                 stato = 2;
              else if(strstr(nm, "View") && (dialogo->ifMadEnv == 2))
                 stato = 2;
              else
                 stato = -1;
           }
           abilita_item(child, stato, &k);
           widgetf = gtk_menu_item_get_submenu(GTK_MENU_ITEM(child));
           nipoti = gtk_container_get_children(GTK_CONTAINER(widgetf));
           numnipoti = g_list_length(nipoti);
           if(numnipoti > 0)
           {
              for(j=0; j<numnipoti;j++)
              {
                  nipote = GTK_WIDGET(g_list_nth_data(nipoti, j));
                  const char *nm1 = gtk_widget_get_name(nipote);
                  if((strstr(nm1, "Save") ||
                      strstr(nm1, "Export")) && (statovero == 2) )   //> 0))
                     abilita_item(nipote, 2, &k);
                   else if(strstr(nm1, "Jav") && 
                   (statovero > 0) && (dialogo->ifMadEnv == 2))
                     abilita_item(nipote, 2, &k);
                   else if(strstr(nm, "View") && (dialogo->ifMadEnv == 2))
                     abilita_item(nipote, statovero, &k);
                  else if((strstr(nm1, "BackBone")) && !dialogo->ifPDBcoded)
                     abilita_item(nipote, 0, &k);
                  else if(strstr(nm1, "Select among") ||
                          strstr(nm1, "Simulated Annealing"))
                     abilita_item(nipote, statovero, &k);
                  else if((dialogo->ifMadEnv == 2) && (statovero == 1) &&
                           strstr(nm, "File"))
                  {
                     if(strstr(nm1, "View output") || strstr(nm1, "HardCopy") ||
                        strstr(nm1, "Summary") || strstr(nm1, "Exit"))
                        abilita_item(nipote, 2, &k);
                      else
                        abilita_item(nipote, 1, &k);
                  }
                  else
                     abilita_item(nipote, stato, &k);
              }
           }
           if(nipoti)
             g_list_free(nipoti);
       }
       nAtomi = valore_di_nats_();
       if(nAtomi > MaxAtLSQ)
       {
          child = get_widget(widget, "Refine");
          gtk_widget_set_sensitive(child, FALSE);
       }
       child = GTK_WIDGET(g_list_nth_data(children, numChildren-1));
       gtk_widget_set_sensitive(child, TRUE);
       if(children)
          g_list_free(children);
    }
    init_toggles2();
}
#endif
void populate_list1(GtkTreeView *list, stringa values[], int numval, int ifClear)
{
    GtkListStore *list_store;
    GtkTreeIter iter;
    int i;

    list_store = GTK_LIST_STORE(gtk_tree_view_get_model(list));
    if(ifClear)
       gtk_list_store_clear(GTK_LIST_STORE(list_store));
    for(i=0; i<numval; i++)
    {
        if(values[i] && strlen(values[i]))
        {
           gtk_list_store_append (list_store, &iter);
           gtk_list_store_set (list_store, &iter, 0, values[i],-1);
        }
    }
}

gchar *color_and_font_markup(const char *string, const gchar *color)
{
    gchar *labelstring;
    size_t sz = 80+strlen(string);

    labelstring = g_new0(char, sz);
    if(color)
       ScriviStringa(labelstring, sz, "<span foreground=\"%s\" font_family=\"%s\">"
           "%s </span>", color, MONOSPACE_FONT, string);
    else
       ScriviStringa(labelstring, sz, "%s", string);
    return labelstring;
}

void set_cell_color(GtkWidget *list, int nrow, int ncol, const char *colore)
{
    GtkListStore *list_store;
    GtkTreeIter iter;
    GtkTreePath *path;
    gchar *newlin, *line = g_new0(char, 80), *text;
    char num[6];
    PangoAttrList *attrs;
    gboolean result;
    size_t sz;

    list_store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(list)));
    ScriviStringa(num, sizeof(num), "%d", nrow);
    path = gtk_tree_path_new_from_string(num);
    if(gtk_tree_model_get_iter (GTK_TREE_MODEL(list_store), &iter, path))
        gtk_tree_model_get (GTK_TREE_MODEL(list_store), &iter, ncol, &line, -1);
    result = pango_parse_markup (line, -1, 0, &attrs, &text, NULL, NULL);
    if(result)
    {
       sz = strlen(text)+80;
       newlin = g_new0(char, sz);
    }
    else
    {
       sz = strlen(line) + 80;
       newlin = g_new0(char, sz);
       text = DuplicaStringa(line);
    }

    ScriviStringa(newlin, sz, "%s", color_and_font_markup(text, colore));
    gtk_list_store_set (list_store, &iter, ncol, newlin, -1);
}

void get_drawing_area_size(int *w, int *h)
{
  GtkAllocation allocation;
  gtk_widget_get_allocation(drawingarea, &allocation);
  *w = allocation.width;
  *h = allocation.height;
}

void set_font(char c)
{
    switch(c)
    {
    case 'P':
        fontdescP = pango_font_description_from_string (main_app::TheApp.FontP().c_str());
        get_metrics(fontdescP, &larSaveP, &altSaveP);
        break;
    case 'N':
        fontdescN = pango_font_description_from_string (main_app::TheApp.FontN().c_str());
        get_metrics(fontdescN, &larSaveN, &altSaveN);
        break;
    case 'U':
        fontdescU = pango_font_description_from_string (main_app::TheApp.FontU().c_str());
        break;
    }

}

int getStructName(char *file1, char *file2)
{
  if (strstr(file1, ".sir") == 0)
  {
      CopiaStringa(file2, MaxLenFilename, str_cut(file1, "."));
      return 0;
  }
  FILE *fp = fOpen(file1, "r");
  char *line = g_new0(char, MAX_LEN+1);
  if(!fp)
  {
     if(jscreen)
        MessageDialog(finestre[0], GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
                   "Error in open file: ", file1);
     else
        cMsgWinErr(g_strdup_printf( "Error in open file: %s", file1), -ERR_WINDOW);
     return -1;
  }
  
  while(fgets(line, MAX_LEN, fp) != NULL)
  {
     char inizio[6];
     char *tok[2];

     CopiaStringan(inizio, sizeof(inizio), g_strstrip(line), 5);
     inizio[5] = '\0';
     if(g_ascii_strcasecmp(inizio, "%stru") == 0)
     {
        (void) get_str_tokens(filtranl(line).c_str(), " ",2, tok);
        CopiaStringa(file2, MaxLenFilename, tok[1]);
        for(int kk=0; kk<2; kk++)
            if(tok[kk] != NULL)
               g_free(tok[kk]);
        break;
     }
  }
  fclose(fp);
  g_free(line);
  return 0;
}

int cStartMainLoop(int Flag)
{
   GtkWidget *tb, *mainwin, *hbox1;

   mainwin = finestre[0];
   fine_lavoro();

   if(Flag)
      return 0;

   if(ifToolbar && show_toolbar && Livcur != 0 && !Contour->ifDrawContour2D)
   {
      tb = lookup_widget(mainwin, toolbarname[Livcur]);
      hbox1 = get_widget(tb, "hbox");
      gtk_widget_hide(hbox1);
      Livcur--;
      tb = lookup_widget(mainwin, "toolbar_main");
      hbox1 = get_widget(tb, "hbox");
      gtk_widget_set_sensitive(hbox1, TRUE);
      gtk_widget_show(hbox1);
   }

   if(ifToolbar)
      tb = lookup_widget(mainwin, "toolbar_main");
   if(dialogo->QualeAbilita)
   {
       if(ifMenubar)
          abilitamb(mainwin, dialogo->QualeAbilita);
       if(ifToolbar)
          abilitatb(tb, dialogo->QualeAbilita);
       can_drag = MRmax(dialogo->QualeAbilita - 1, 0);

   }
   else
   {
       if(ifMenubar)
          abilitamb(mainwin, -1);
       if(ifToolbar)
          abilitatb(tb, -1);
       can_drag = FALSE;
   }
   return 1;
}

int MainLoop(_drawarea *DrawingArea, int flag)
{
      //if(auto_newproj)
      //   open_newproj_dlg(mainwin, "new");
         
      if(cStartMainLoop(flag))
      {
         mainloop = 1;
//301110
         if(ifSannel)
         {
            c_globalopt(NULL, NULL);
            ifSannel = false;
         }
      if(auto_newproj)
      {
         //gtk_widget_show(get_widget(mainwin, "menubar"));
         //gtk_widget_show(get_widget(get_widget(mainwin, "toolbar_main"), "hbox"));
         open_newproj_dlg(mainwin, "new");
      }
//end 301110
         gtk_main ();
         mainloop = 0;
      }
      return main_app::TheApp.AppError;
}

void CloseWindow(int *js, int ml, _drawarea *da, int col)
{
      if(*js)
      {
         *js = 0;
         if(col)
            quit_program(NULL, GINT_TO_POINTER(0));
         else
         {
            gtk_widget_destroy(mainwin);
            while(gtk_events_pending())
               (void) gtk_main_iteration();
            if(ml)
               gtk_main_quit();
         }
      }

}

GtkWidget* open_window (int w, int h, const char *title, _drawarea *DrawingArea)
{
using namespace Lista;
  GdkRectangle rect;

  mainwin = create_mainwin(main_app::TheApp.Kscrx, main_app::TheApp.Kscry);
  drawingarea = lookup_widget(mainwin, drawingareaname);
  finestre[0] = mainwin;
  MyList::SetParent(mainwin);
  DrawingArea->widget = drawingarea;
  DrawingArea->wPrevious = 0;
  DrawingArea->hPrevious = 0;
  DrawingArea->backGround = dialogo->jBackGround;
  DrawingArea->primavolta = TRUE;
  DrawingArea->kscrx = main_app::TheApp.Kscrx;
  DrawingArea->kscry = main_app::TheApp.Kscry;
  g_object_set_data(G_OBJECT(drawingarea), "struct", DrawingArea);

  if(!main_app::TheApp.IfMaximized)
     gtk_window_move (GTK_WINDOW (mainwin), main_app::TheApp.XStart,
                       main_app::TheApp.YStart);
  else
     gtk_window_maximize(GTK_WINDOW (mainwin));
  gtk_widget_show (mainwin);

  if(ifHidden)
     gtk_widget_hide(mainwin);

  GdkColor *bgcolor = getBgColor(mainwin);
  memcpy(&BgColor, bgcolor, sizeof(GdkColor));
  g_free(bgcolor);

  gdk_window_set_icon_name (gtk_widget_get_window(mainwin), MR_PACKAGE);
  set_icon(mainwin, program_ico);
  PrimeCose(mainwin);
#ifdef JAV1
  SetMainMenu(get_widget(mainwin, "menubar"), true);
#endif

  GdkWindow *da_window = gtk_widget_get_window(drawingarea);
  DrawingArea->outWindow = da_window;
  DrawingArea->outPix = get_object(drawingarea, "offscreen");
  DrawingArea->context = get_object(drawingarea, "context");
  gpointer context = DrawingArea->context;

  rect.x = 0;
  rect.y = 0;
  get_drawing_area_size(&(rect.width), &(rect.height));
  g_object_set_data(G_OBJECT(drawingarea), "context", context);

         cross_cursor = create_my_cursor(CROSS_CURSOR);
//         default_cursor  = gdk_cursor_new(GDK_TOP_LEFT_ARROW);
         default_cursor  = NULL;
         help_cursor     = gdk_cursor_new_for_display(
               gdk_display_get_default(),GDK_QUESTION_ARROW);
//         wait_cursor     = create_my_cursor(WAIT_CURSOR);
         wait_cursor     = gdk_cursor_new_for_display(
               gdk_display_get_default(),GDK_WATCH);
         drag1_cursor = create_my_cursor(DRAG1_CURSOR);
         drag2_cursor = create_my_cursor(DRAG2_CURSOR);
         pick_cursor = create_my_cursor(PICK_CURSOR);
         move_cursor = create_my_cursor(MOVE_CURSOR);
         zoom_cursor = create_my_cursor(ZOOM_CURSOR);
         gdk_window_set_cursor(da_window,default_cursor);
         g_object_set_data(G_OBJECT(drawingarea), "def_cursor",
             default_cursor);
      
      if(ifParam)
      {
         if(ifMenubar)
            abilitamb(mainwin, 0);
         if(ifToolbar && show_toolbar)
            abilitatb(get_widget(mainwin, "toolbar_main"), 0);
         can_drag = FALSE;
         fortran_al_lavoro();
      }
      //PROVA else
      {
         if(ifToolbar && show_toolbar)
         {
            GtkWidget *tb = lookup_widget(mainwin, "toolbar_main");
            GtkWidget *hb = get_widget(tb, "hbox");
            gtk_widget_show(hb);
         }
//#ifndef MAC_INTEGRATION
         if(ifMenubar  && show_toolbar)
         {
            GtkWidget *mb = lookup_widget(mainwin, "menubar");
            gtk_widget_show(mb);
         }
//#endif
      }
      while(gtk_events_pending())
         (void) gtk_main_iteration();
      int flag = main_app::TheApp.AutoUpdate();
      if(flag)
      {
         int n;
         int result = main_app::TheApp.LastUpdate(finestre[0], true, &n);
         if(result > 0)
         {
            UpdateCheck(finestre[0], result, &flag, 
               g_strdup_printf("%d.%2.2d", n/100, n%100));
            main_app::TheApp.UpdateAutoU(flag);
         }
         else if(result < 0)         //No connection
         {
            flag = 0;
            main_app::TheApp.UpdateAutoU(flag);
         }
         statusbar   = lookup_widget(finestre[0], statusbarname);
         AddWelcomeMessage(statusbar, msgdefault);
      }
  return mainwin;
}

void PrimoParametro(char *string)
{
      auto_newproj = FALSE;
      ifParam = TRUE;
//mr 270615      if(strstr(string, "newproj") == 0)
      if(strcmp(string, "newproj") != 0)
      {
          CopiaStringa(main_app::TheApp.filesir, MaxLenFilename, string);
          if(!strstr(main_app::TheApp.filesir, ".sir") &&
             (!strstr(main_app::TheApp.filesir, ".ins")) )
             AppendiStringa(main_app::TheApp.filesir, MaxLenFilename, ".sir");
	  std::string file1, fil(main_app::TheApp.filesir);
// mr 030420
             if(!g_path_is_absolute(fil.c_str()))
             {
                file1.assign(g_get_current_dir());
                file1.append(G_DIR_SEPARATOR_S);
                file1.append(fil);
                CopiaStringa(main_app::TheApp.filesir, MaxLenFilename, file1.c_str());
                CopiaStringa(string, MaxLenFilename, file1.c_str());
             }
// end
        
// mr 301205
          if (g_path_get_dirname(main_app::TheApp.filesir))
              ScriviStringa(SWareRC->WorkingDirectory, MaxLenFilename, g_path_get_dirname(main_app::TheApp.filesir));
          else
              CopiaStringa(SWareRC->WorkingDirectory, MaxLenFilename, getPWD());
          dir_set_current(SWareRC->WorkingDirectory);
          
          int ier = getStructName(main_app::TheApp.filesir, main_app::TheApp.filebin);
          if(ier)
             quit_program(NULL, GINT_TO_POINTER(-1));
          AppendiStringa(main_app::TheApp.filebin, MaxLenFilename, ".bin");
// mr 301205 end
          fortran_al_lavoro();
      }
      else
          auto_newproj = TRUE;
}

void SecondoParametro(char *string)
{
    CopiaStringa(main_app::TheApp.fileout, MaxLenFilename, string);
}

extern "C" void cpunto_e_basta_(int *X, int *Y)
{
  if(!jscreen)
      return;
  gpointer outPix = getCurrentPix();
  gpointer context = getCurrentContext();
  draw_point( outPix, context, *X, *Y );
}

gboolean on_viewer_configure_event     (GtkWidget       *widget,
                                        GdkEventConfigure *event,
                                        gpointer         user_data)
{
    gpointer pixmap;
    gpointer context;
    os_and_gc *rt;
//    static int wP=0, hP=0;

    int wP = get_int(widget, "wP");
    int hP = get_int(widget, "hP");
    GtkAllocation allocation;
    gtk_widget_get_allocation(widget, &allocation);
    int w = (int)allocation.width;
    int h = (int)allocation.height;

    if (get_object(widget, "context") != NULL)
        context = get_object(widget, "context");
    else
        context = NULL;

    if (get_object(widget, "offscreen") != NULL)
        pixmap = get_object(widget, "offscreen");
    else
        pixmap = NULL;

    if(context && (wP == w) && (hP == h))
       return TRUE;
    wP = w;
    hP = h;
    destroy_os_and_gc(pixmap, context);
    rt = get_os_and_gc(widget);
    pixmap = rt->os;
    context = rt->gc;
    g_free(rt);
    g_object_set_data(G_OBJECT(widget), "context", context);
    g_object_set_data( G_OBJECT(widget), "offscreen", pixmap);
    g_object_set_data( G_OBJECT(widget), "wP", GINT_TO_POINTER(wP));
    g_object_set_data( G_OBJECT(widget), "hP", GINT_TO_POINTER(hP));
    mr_send_viewer_pixmap(widget);

//  Clear window 

    setta_foreground(dialogo->jBackGround, context);
    draw_rectangle (pixmap, context, TRUE, 0, 0, w, h);

    return TRUE;
}

#ifndef GTK_TOOLTIP
static void print_label(GtkWidget *statusb, const char *riga)
{
    gtk_statusbar_pop(GTK_STATUSBAR(statusb), 1);
    (void) gtk_statusbar_push(GTK_STATUSBAR(statusb), 1, toUTF8(riga));
}
#endif

static gboolean on_mouse_move  (GtkWidget       *widget,
                                GdkEventMotion  *event,
                                gpointer        data)
{
  int x = (int)event->x;
  int y = (int)event->y;
  int i;
  GdkWindow *ww = gtk_widget_get_window(widget);
  int nreg = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(ww), "nreg"));

  for(i=0; i<nreg; i++)
  {
      char nome[20];
      ScriviStringa(nome, sizeof(nome), "reg%d", i);
      _InfoReg *info = (_InfoReg *) g_object_get_data(G_OBJECT(ww), nome);
      if(info->reg == NULL)
         return TRUE;
      if(point_in_region(info->reg, x, y))
      {
#ifndef GTK_TOOLTIP
         print_label(get_widget(widget, "statusbar"), info->lab);
#else
         gtk_widget_set_tooltip_text(widget, info->lab);
#endif
         return FALSE;
      }
  }

#ifndef GTK_TOOLTIP
    print_label(get_widget(widget, "statusbar"), " ");
#else
    gtk_widget_set_has_tooltip(widget, FALSE);
#endif

   return TRUE;
}

GtkWidget *create_viewer(DlgItem *tx)
{
  GtkWidget *window;
  GtkWidget *box1;
  GtkWidget *button;
  GtkWidget *viewer;
  bool scrollbar = false;
  bool connect_move = false;
  int w, h;
 
  window = gtk_dialog_new ();
  GdkRectangle rect;
#if (GTK_MAJOR_VERSION > 2) && (GTK_MINOR_VERSION >= 22)
         GdkMonitor *mon = gdk_display_get_primary_monitor(gdk_display_get_default());
         if(mon == NULL)
            mon = gdk_display_get_monitor_at_point(gdk_display_get_default(), 0, 0);
         if(mon != NULL)
            gdk_monitor_get_geometry(mon, &rect);
         else
         {
            rect.width = 800;
            rect.height = 600;
         }
#else
         GdkScreen *sc = gdk_screen_get_default();
         gdk_screen_get_monitor_geometry(sc, 0, &rect);
#endif

  int ww = rect.width;

  int maxwidth = ww * 2 / 3;
  if (tx->width > maxwidth)
      scrollbar = true;
  
  gtk_window_set_position (GTK_WINDOW(window), GTK_WIN_POS_MOUSE);
  (void) g_signal_connect (G_OBJECT (window), "destroy",
                      G_CALLBACK(destroy), NULL);
  gtk_window_set_title (GTK_WINDOW (window), tx->title);
  gtk_container_set_border_width (GTK_CONTAINER (window), 0);
  gtk_window_set_resizable(GTK_WINDOW(window), FALSE);
     
  if(tx->height < 0)
  {
     if (scrollbar)
        w = maxwidth;
     else
        w = tx->width;
     h = MRmin((int) (0.65 * (double) w), 400);
     tx->height = h;
     connect_move = true;
     if (scrollbar)
         gtk_widget_set_size_request(window, w, -1);
  }
  else
  {
     h = tx->height;
     w = tx->width;
     scrollbar = false;
  }

  box1 = gtk_dialog_get_content_area(GTK_DIALOG(window));
  
  // Create the Drawable widget 
  viewer = gtk_drawing_area_new ();
  gtk_widget_set_size_request(viewer, tx->width, h);

  if(scrollbar)
  {
     GtkWidget *scrollwin = gtk_scrolled_window_new(NULL, NULL);
     gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrollwin), 
        GTK_POLICY_AUTOMATIC, GTK_POLICY_NEVER);
     gtk_container_set_border_width (GTK_CONTAINER (scrollwin), 0);

     gtk_box_pack_start (GTK_BOX (box1), scrollwin, TRUE, TRUE, 0);
     gtk_widget_show (scrollwin);
     add_to_scrollwin(scrollwin, viewer);
  }
  else
     gtk_box_pack_start (GTK_BOX (box1), viewer, TRUE, TRUE, 0);

  g_object_set_data(G_OBJECT(window), "viewer", viewer);
  g_object_set_data(G_OBJECT(viewer), "offscreen", NULL);
  g_object_set_data( G_OBJECT(viewer), "wP", GINT_TO_POINTER(0));
  g_object_set_data( G_OBJECT(viewer), "hP", GINT_TO_POINTER(0));
  if(connect_move)
  {
     gtk_widget_set_events(viewer, GDK_POINTER_MOTION_MASK );
     g_signal_connect (G_OBJECT (viewer), "motion_notify_event",
                      G_CALLBACK (on_mouse_move), NULL);
  }

  (void) g_signal_connect (G_OBJECT (viewer), "configure_event",
                      G_CALLBACK (on_viewer_configure_event),
                      NULL);
  (void) g_signal_connect (G_OBJECT (viewer), DRAW_EVENT,
                      G_CALLBACK (ManageExpose),
                      NULL);

  gtk_widget_show (viewer);

#ifndef GTK_TOOLTIP
  if(connect_move)
  {
     GtkWidget *statusb = gtk_statusbar_new ();
     g_object_set_data (G_OBJECT (viewer), "statusbar", statusb);
     gtk_widget_show (statusb);
     set_widget_font(GTK_STATUSBAR(statusb)->label, main_app::TheApp.FontU().c_str());
     gtk_box_pack_start (GTK_BOX (box1), statusb, TRUE, TRUE, 2);
  }
#endif

  if(tx->nButtons >= 1)
  {
     button = myimage_button(tx->label1, tx->image1);
     (void) g_signal_connect (G_OBJECT (button), "clicked",
                         tx->cb_func1,tx->cb_data1);
     gtk_dialog_add_action_widget(GTK_DIALOG(window), button, 1);
     gtk_widget_show (button);
  }

  if(tx->nButtons >= 2)
  {
     button = myimage_button(tx->label2, tx->image2);
     (void) g_signal_connect (G_OBJECT (button), "clicked",
                         tx->cb_func2,tx->cb_data2);
     gtk_dialog_add_action_widget(GTK_DIALOG(window), button, 2);
     gtk_widget_show (button);
  }

  if(tx->nButtons >= 3)
  {
     button = myimage_button(tx->label3, tx->image3);
     (void) g_signal_connect (G_OBJECT (button), "clicked",
                         tx->cb_func3,tx->cb_data3);
     gtk_dialog_add_action_widget(GTK_DIALOG(window), button, 3);
     gtk_widget_show (button);
  }
  if(tx->nButtons >= 1)
  {
     if(button)
     {
        (void) g_signal_connect_swapped(G_OBJECT(window), "delete_event",
           G_CALLBACK(gtk_button_clicked), G_OBJECT(button)); 
        gtk_button_box_set_layout(GTK_BUTTON_BOX(
           gtk_widget_get_parent(button)), GTK_BUTTONBOX_SPREAD);
     }
  }
  else
  {
//     gtk_widget_hide(hbox);
     (void) g_signal_connect_swapped(G_OBJECT(window), "delete_event",
           G_CALLBACK(gtk_widget_hide), G_OBJECT(window)); 
  }
  (void) g_signal_connect (G_OBJECT (window), "delete_event",
                      G_CALLBACK(true_cb), NULL);

  viewer_window = window;
  return window;
}

void close_viewer  (GtkButton  *button, gpointer data)
{
  mr_restore_pixmap();
  viewerOpened = FALSE;
  dialogo->viewerOpened = FALSE;
  gtk_widget_hide (gtk_widget_get_toplevel(GTK_WIDGET(button)));
}

int find_in_vett(GtkWidget *dlg)
{
  if(vett_dlg.empty())
     return -1;
  int found = -1;
  for(int i=0; i<(int) vett_dlg.size(); i++)
  {
      GtkWidget *my_dlg = vett_dlg.at(i);
      if(my_dlg == dlg)
      {
         found = i;
         break;
      }
  }
  return found;
}

void push_in_vett(GtkWidget *dlg)
{
  int found = find_in_vett(dlg);
  if(found == -1)
     vett_dlg.push_back(dlg);
}

void pop_from_vett(GtkWidget *dlg)
{
  int found = find_in_vett(dlg);
  if(found != -1)
     vett_dlg.erase(vett_dlg.begin()+found);
}

void close_sir_viewers()
{
  if(vett_dlg.empty())
     return;
  for(int i=0; i<(int) vett_dlg.size(); i++)
  {
      GtkWidget *my_dlg = vett_dlg.at(i);
      if(my_dlg && GTK_IS_WIDGET(my_dlg))
         gtk_widget_destroy (GTK_WIDGET(my_dlg));
  }
  vett_dlg.clear();
}

void force_close_viewers()
{
  reset_jav_var();
  close_sir_viewers();
}

void delete_viewer  (GtkButton  *button, gpointer data)
{
  mr_restore_pixmap();
  viewerOpened = FALSE;
  dialogo->viewerOpened = FALSE;
  viewer_window = NULL;
  pop_from_vett(gtk_widget_get_toplevel(GTK_WIDGET(button)));
  gtk_widget_destroy (gtk_widget_get_toplevel(GTK_WIDGET(button)));
}

extern "C" int c_visualizzatore_(int *action, int *x , int *y , char *string)

{
  DlgItem gr;
  int Act;
  static GtkWidget *my_dlg;
  GtkWidget *viewer_win;
 
  if(!jscreen)
     return 0;
  Act = *action;
  gr.title = DuplicaStringa(string);
  gr.width  = *x;
  gr.height = *y;

  if(single_it)
     while(gtk_events_pending())
         (void) gtk_main_iteration();
  switch(Act)
  {

  case 1:   /* ex 144 Open graphic viewer (destroy on close) */

       if(!viewerOpened)
//       if(!viewer_window)
       {
          gr.nButtons         = 0;
          gr.cb_func1         = G_CALLBACK(delete_viewer);
          gr.cb_data1         = GINT_TO_POINTER(0);
          gr.label1           = DuplicaStringa("   _OK");
          gr.image1           = DuplicaStringa("ok.png");
          my_dlg              = create_viewer(&gr);
          *y                  = gr.height;
          push_in_vett(my_dlg);
          g_free(gr.label1);
          g_free(gr.image1);
       }
       //if(!ifHidden)
       if((!ifHidden) && (!iconified))
       {
          gtk_window_set_transient_for(GTK_WINDOW(my_dlg), GTK_WINDOW(finestre[0]));
          gtk_widget_show(my_dlg);
          gdk_window_raise (gtk_widget_get_window(my_dlg));
       }
       break;

  case 11:   /* Open graphic viewer hidden */

       if(!viewerOpened)
       {
          gr.nButtons         = 0;
          gr.cb_func1         = G_CALLBACK(delete_viewer);
          gr.cb_data1         = GINT_TO_POINTER(0);
          gr.label1           = DuplicaStringa("   _OK");
          gr.image1           = DuplicaStringa("ok.png");
          my_dlg              = create_viewer(&gr);
          push_in_vett(my_dlg);
          g_free(gr.label1);
          g_free(gr.image1);
       }
       if(!ifHidden)
       {
          gtk_window_set_transient_for(GTK_WINDOW(my_dlg), GTK_WINDOW(finestre[0]));
          gtk_widget_show(my_dlg);
          gdk_window_raise (gtk_widget_get_window(my_dlg));
          gtk_widget_hide(my_dlg);
       }
       break;

  case 2:   /* ex 145  Open graphic viewer (hide on close) */

       if(!viewerOpened)
//       if(!viewer_window)
       {
          gr.nButtons         = 1;
          gr.cb_func1         = G_CALLBACK(close_viewer);
          gr.cb_data1         = GINT_TO_POINTER(0);
          gr.label1           = DuplicaStringa("   _OK");
          gr.image1           = DuplicaStringa("ok.png");
          my_dlg              = create_viewer(&gr);
          g_free(gr.label1);
          g_free(gr.image1);
       }
       else
       {
          MessageDialog(finestre[0], GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
                        "Programming Error: You cannot open two viewers");
          gdk_beep();
          return -1;
       }
       //if(!ifHidden)
       if((!ifHidden) && (!iconified))
       {
          gtk_window_set_transient_for(GTK_WINDOW(my_dlg), GTK_WINDOW(finestre[0]));
          gtk_widget_show(my_dlg);
          gdk_window_raise (gtk_widget_get_window(my_dlg));
       }
       break;

  case 3:         /* ex 146  Restore main window */
//     viewerOpened = FALSE;            gianluca 29/11/2010 - allineamento expo
//     dialogo->viewerOpened = FALSE;   gianluca 29/11/2010 - allineamento expo
// non me ne frega niemte di expo, ma sir non funziona
       viewerOpened = FALSE;            //rosi 19/12/2010 
       mr_restore_pixmap();
       break;

  case 33:         /* Restore main window */
       {
       GtkWidget *vw = get_widget(my_dlg, "viewer");
       if(vw)
       {
          char *tmp =  str_cut(main_app::TheApp.filebin, ".");
          std::string pngfile(tmp);
          g_free(tmp);
          if(*x ==0)
             pngfile.append( "_Wilson.png");   // *x == 0  -> nome_struttura_Wilson.png 
          if(*x >0)
          {
             tmp = g_strdup_printf("_Wilson%d.png", *x);
             pngfile.append(tmp);   // *x > 0   -> nome_struttura_Wilson*x.png 
             g_free(tmp);
          }
          if(*x <0)
          {
             tmp = g_strdup_printf("_Spot%d.png", *x);
             pngfile.append(tmp);   // *x > 0   -> nome_struttura_Spot*x.png 
             g_free(tmp);
          }
          save_pixbuf_from_window(vw, pngfile.c_str());
       }
       viewerOpened = FALSE;
       dialogo->viewerOpened = FALSE;
       mr_restore_pixmap();
       if(iconified)
          gtk_window_iconify(GTK_WINDOW(finestre[0]));
       }
       break;

  case 4:         /* ex 147  Restore viewer window */

       if(my_dlg)
       {
          viewerOpened = TRUE;
          dialogo->viewerOpened = TRUE;
          viewer_win = get_widget(my_dlg, "viewer");
          mr_send_viewer_pixmap(viewer_win);
       }
       else
       {
          if(viewerOpened)
          {
          MessageDialog(finestre[0], GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
                        "Programming Error: Attempt to restore closed viewer");
          gdk_beep();
          return -1;
          }
       }
       break;

  case 5:         /* ex 148  Close graphic viewer  */
       
       pop_from_vett(my_dlg);
       if(GTK_IS_WIDGET(my_dlg))
           gtk_widget_destroy (my_dlg);
       else if(GTK_IS_WIDGET(get_widget(finestre[0], "showimage")))
       {
           gtk_widget_destroy (get_widget(finestre[0], "showimage"));
           g_object_set_data(G_OBJECT(finestre[0]), "showimage", NULL);
       }
       my_dlg = NULL;
       viewer_window = NULL;
       viewerOpened = FALSE;
       dialogo->viewerOpened = FALSE;
       break;

  case -100:      /* Dump graphic viewer into file 'string' */
       if(my_dlg)
       {
          GtkWidget *vw = get_widget(my_dlg, "viewer");
          if(vw)
             save_pixbuf_from_window(vw, string);
          gtk_widget_destroy (my_dlg);
          my_dlg = NULL;
          viewer_window = NULL;
          viewerOpened = FALSE;
          dialogo->viewerOpened = FALSE;
          GtkWidget *w1 = show_image(string, "FOMs Statistics", finestre[0]);
          g_object_set_data(G_OBJECT(finestre[0]), "showimage", w1);
       }
       break;
  }
  g_free(gr.title);
  return 0;
}

//extern "C" void mrwinnew_(int xv1[], int yv1[], int xv2[], int yv2[], int xv3[], int yv3[],
extern "C" void drawsticks_(int xv1[], int yv1[], int xv2[], int yv2[], int xv3[], int yv3[],
              int col1[], int col2[], int *z, int *ifclear)
{

      int np, new_color, old_color;
      if(!jscreen)
          return;
      gpointer outPix = getCurrentPix();
      gpointer context = getCurrentContext();

      if(*ifclear)
      {
         setta_foreground(main_app::TheApp.Background, context);
         int w, h;
         get_drawing_area_size(&w, &h);
         draw_rectangle (outPix, context, TRUE, 0,0,w,h);
      }
      old_color = 0;
      for (np=0;np<*z;np++)
      {
         new_color = col1[np];
         if ( new_color != old_color ) 
         {
              old_color = new_color;
              setta_foreground(new_color, context);       
         }
         draw_line( outPix, context, xv1[np], yv1[np], xv2[np], yv2[np]);

         new_color = col2[np];
         if ( new_color != old_color ) 
         {
              old_color = new_color;
              setta_foreground(new_color, context);
         }
         draw_line( outPix, context, xv2[np], yv2[np], xv3[np], yv3[np]);
      }
}

extern "C" void drawsegments_(int *nsegs, int *iColor, int kpix[], int kpiy[],
                              int *ifDashed, int *ifClear)
{
// Disegna segmenti non connessi
   int nsegments;
   if(!jscreen)
      return;
   gpointer outPix = getCurrentPix();
   gpointer context = getCurrentContext();

   if(*ifClear)
   {
      int w, h;
      get_drawing_area_size(&w, &h);
      setta_foreground(main_app::TheApp.Background, context);
      draw_rectangle (outPix, context, TRUE, 0,0, w, h);
   }

   nsegments = *nsegs;
   GdkSegment *segs = g_new0(GdkSegment, nsegments);
   int n = 0;
   for (int ns=0; ns<nsegments*2;ns+=2)
   {
         segs[n].x1 = kpix[ns];
         segs[n].y1 = kpiy[ns];
         segs[n].x2 = kpix[ns+1];
         segs[n].y2 = kpiy[ns+1];
         n++;
   }

   setta_foreground(*iColor, context);
   if(*ifDashed)
      set_dash_style(context);
   draw_segments( outPix, context, segs, nsegments);
   if(*ifDashed)
      reset_style(context);
   g_free(segs);
}

extern "C" void c_fortran_al_lavoro_(int *flag)
{
   if(!jscreen)
      return;
   if(*flag)
   {
      GtkWidget *tb = lookup_widget(finestre[0], toolbarname[Livcur]);
      GtkWidget *hbox = get_widget(tb, "hbox");
      gtk_widget_set_sensitive(hbox, FALSE);
      abilitamb(finestre[0], 0);
   }
   fortran_al_lavoro();
}

extern "C" void c_fine_lavoro_(int *flag)
{
   if(!jscreen)
      return;
   if(*flag)
   {
      GtkWidget *tb = lookup_widget(finestre[0], toolbarname[Livcur]);
      GtkWidget *hbox = get_widget(tb, "hbox");
      gtk_widget_set_sensitive(hbox, TRUE);
      abilitamb(finestre[0], dialogo->QualeAbilita);
      if(strstr(toolbarname[Livcur],"main"))
         abilitatb(tb, dialogo->QualeAbilita);
      can_drag = MRmax(dialogo->QualeAbilita - 1, 0);
   }
   fine_lavoro();
}

/***************************************************************************/

gchar *color_markup(const char *string, const gchar *color) 
{
    gchar *labelstring;
    size_t sz = 80+strlen(string);

    labelstring = g_new0(char, sz);
    if(color)
       ScriviStringa(labelstring, sz, "<span foreground=\"%s\">"
           "%s </span>", color, string);
    else
       ScriviStringa(labelstring, sz, "%s", string);
    return labelstring;
}

gchar *create_markup_color(char *string, gchar *color, PangoFontDescription *fd) 
{
    if(color)
    {
       std::string labelstring;
       labelstring = g_strdup_printf("<span foreground=\"%s\" font_desc=\"%s\">"
           "%s </span>", color,
            pango_font_description_to_string(fd), string);
       return g_strdup(labelstring.c_str());
    }
    else
       return g_strdup(string);
}

GtkWidget *ENTRY_NEW()
{
    GtkWidget *label;

    label = gtk_entry_new();
    //widget_modify_font(label, fontdescU);
    return label;
}

GtkWidget *LABEL_WITH_ENTRY(const char *string, const gchar *colore)
{
    GtkWidget *label, *entry, *box;

    box = hbox_new(FALSE, 0);
    label = LABEL_NEW(string, colore);
    set_alignment (label, 0.0, 0.5);
    gtk_box_pack_start(GTK_BOX(box), label,FALSE, FALSE, 2);
    entry = gtk_entry_new();
    widget_modify_font(entry, fontdescU);
    gtk_widget_set_size_request(entry, ENTRY_SIZE, 20);
    gtk_box_pack_start(GTK_BOX(box), entry, FALSE, FALSE, 2);
    gtk_label_set_mnemonic_widget(GTK_LABEL(label), entry);
    g_object_set_data(G_OBJECT(box), "label", label);
    g_object_set_data(G_OBJECT(box), "entry", entry);

    return box;
}
                     
void quit_program (GtkWidget *widget, gpointer data)
{
    (void) Cancella("tmp.tmp");
    if(GPOINTER_TO_INT(data))
       g_print("Program killed by user\n");
    exit(GPOINTER_TO_INT(data));
}

void  set_dialog_response(GtkWidget *widget, gpointer response)
{
  int risposta = GPOINTER_TO_INT(response);
  gtk_dialog_response(GTK_DIALOG(gtk_widget_get_toplevel(widget)), risposta);
}

int save_restore_pm(int type)
{
  GtkWidget *dialog, *box1, *box2, *label1, *label2, *button;
  int answer;

  dialog = gtk_dialog_new();
  gtk_container_set_border_width (GTK_CONTAINER (dialog), 7);
  gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_MOUSE);

  box1 = gtk_dialog_get_content_area(GTK_DIALOG(dialog));

  box2 = hbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(box1), box2, TRUE, TRUE, 4);
  if(type == 1)
     button = xpm_button("savebin.png");
  else
     button = xpm_button("restorebin.png");
  gtk_box_pack_start(GTK_BOX(box2), button, FALSE, FALSE, 4);
  (void) g_signal_connect(G_OBJECT(button), "clicked",
           G_CALLBACK (set_dialog_response), GINT_TO_POINTER(1));
  gtk_widget_grab_focus (button);
  label1 = gtk_label_new("");
  gtk_box_pack_start(GTK_BOX(box2), label1, TRUE, TRUE, 4);

  box2 = hbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(box1), box2, TRUE, TRUE, 4);
  if(type == 1)
     button = xpm_button("savemdl.png");
  else
     button = xpm_button("restoremdl.png");
  gtk_box_pack_start(GTK_BOX(box2), button, FALSE, FALSE, 4);
  (void) g_signal_connect(G_OBJECT(button), "clicked",
           G_CALLBACK (set_dialog_response), GINT_TO_POINTER(2));
  label2 = gtk_label_new("");
  gtk_box_pack_start(GTK_BOX(box2), label2, TRUE, TRUE, 4);

  button = myimage_button("  _Cancel", "cancel.png");
  gtk_dialog_add_action_widget(GTK_DIALOG(dialog), button, 3);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(
      gtk_widget_get_parent(button)), GTK_BUTTONBOX_SPREAD);


  if(type == 1)                   // Save
  {
     gtk_window_set_title (GTK_WINDOW (dialog), "Save");
     gtk_label_set_text(GTK_LABEL(label1), "Save project file");
     gtk_label_set_text(GTK_LABEL(label2), "Save model");
  }
  else
  {
     gtk_window_set_title (GTK_WINDOW (dialog), "Restore");
     gtk_label_set_text(GTK_LABEL(label1), "Restore project file");
     gtk_label_set_text(GTK_LABEL(label2), "Restore model");
  }

   gtk_widget_show_all(dialog);
   setSmiley(finestre[0], "smil5.gif");
   answer = gtk_dialog_run(GTK_DIALOG(dialog));
   gtk_widget_destroy(dialog);
   if(answer == GTK_RESPONSE_DELETE_EVENT)
      answer = 3;
   resetSmiley(finestre[0]);
   return answer;
}

GtkWidget *window_tip (gchar  *string, int lriga)
{
    GtkWidget *frame, *label;
    char *text;
    size_t sz = strlen(string) + 20;

    text = g_new0(char, sz);
    formatta_msg(text, sz, string, lriga);
    frame = gtk_frame_new (NULL);
    gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_ETCHED_OUT);
    label = gtk_label_new (text);
    set_alignment (label, 0.5, 0.5);
    set_margins (label, 4, 4, 4, 4);
    gtk_container_add (GTK_CONTAINER (frame), label);
    gtk_container_set_border_width (GTK_CONTAINER (frame), 0);
    gtk_widget_show (label);
    gtk_widget_show (frame);
    return frame;
}

void stringatovector(char *str, char *strvec[], int nElem, int lung)
{
   int i;
   size_t sz = lung+1;

   for(i=0; i<nElem; i++)
   {
       strvec[i] = g_new0(char, sz);
       AppendiStringan(strvec[i], sz, str+lung*i, lung);
   }
}

/***************************************************************/
void set_color_row(GtkWidget *wid, int iColor)
{
   float *colore = get_fcolor(iColor);
   mycolor_button_set_color(wid, colore);
   g_object_set_data(G_OBJECT(wid), "colore", GINT_TO_POINTER(iColor));
}

GtkWidget *color_row(int iColor, GCallback cb, gpointer data)
{
   float *colore = get_fcolor(iColor);
   GtkWidget *button = mycolor_button(colore, "", cb, data);
   gtk_widget_set_size_request(button, 18, 18);
   gtk_widget_show_all(button);
   mycolor_button_set_color(button, colore);
   g_object_set_data(G_OBJECT(button), "colore", GINT_TO_POINTER(iColor));
   return button;
}

void selected_level_color(GtkWidget *button, GdkEvent *, gpointer but)
{
   int num = get_int(button, "quale");
   
   set_color_row((GtkWidget *)but, num);
   gtk_widget_destroy(gtk_widget_get_toplevel(button));
   gtk_main_quit();
}

void show_colors(GtkWidget *button, GdkEvent *, gpointer data)
{
  int i, posx, posy;
  GtkWidget *box, *frame, *popwin;
  char nume[4];
  GtkWidget *father = gtk_widget_get_toplevel(button);

  popwin = gtk_window_new(GTK_WINDOW_POPUP);
  g_object_set_data(G_OBJECT(father), "popwin", popwin);

  frame = gtk_frame_new(NULL);
  gtk_container_add(GTK_CONTAINER(popwin), frame);
  gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_ETCHED_OUT);
  box = table_new(4, 4, TRUE);
  gtk_container_add(GTK_CONTAINER(frame), box);
  gtk_container_set_border_width(GTK_CONTAINER(box), 10);
   
  for(i=0; i<16; i++)
  {
       int iColor = i + NUM_COLORS + N_OBJS;
       frame = color_row(iColor, G_CALLBACK(selected_level_color),  button);
       table_attach(box, frame, i%4, i%4+1, i/4, i/4+1);
       ScriviStringa(nume, sizeof(nume), "%d", i);
       g_object_set_data(G_OBJECT(popwin), nume, frame);
       g_object_set_data(G_OBJECT(frame), "quale", GINT_TO_POINTER(iColor));
  }
  gtk_window_get_position(GTK_WINDOW(gtk_widget_get_toplevel(button)), &posx, &posy);
  GtkAllocation allocation;
  gtk_widget_get_allocation(button, &allocation);
  posx += allocation.x;
  posy += allocation.y;
  gtk_window_move(GTK_WINDOW(popwin), posx, posy);
  gtk_widget_show_all(popwin);
  gdk_window_set_cursor(gtk_widget_get_window(popwin), pick_cursor);

  gtk_main();
}

GtkWidget *create_combo_colors(GtkWidget *parentbox, 
                          int default_selected)
{
  GtkWidget *frame = color_row(default_selected, G_CALLBACK(show_colors), NULL);
#ifdef IN_GTK3
  GtkWidget *align = gtk_frame_new (NULL);
  gtk_frame_set_shadow_type (GTK_FRAME (align), GTK_SHADOW_NONE);
  gtk_widget_set_hexpand(frame, FALSE);
  gtk_widget_set_vexpand(frame, FALSE);
  g_object_set(G_OBJECT(frame), "halign", GTK_ALIGN_CENTER, NULL);
  g_object_set(G_OBJECT(frame), "valign", GTK_ALIGN_CENTER, NULL);
#else
  GtkWidget *align = gtk_alignment_new (0.5f, 0.5f, 0.f, 0.f);
#endif
  gtk_widget_show(align);
  gtk_box_pack_start (GTK_BOX (parentbox), align, FALSE, FALSE, 8);
  gtk_widget_show(frame);
  gtk_container_add(GTK_CONTAINER(align), frame);
  set_tip (frame, "Click to change level color");
  return frame;
}

int getpos(char *str, char *vec[], int n_el)
{
   int i;
   
   for(i=0; i<n_el;i++)
     if(strcmp(str, vec[i]) == 0)
        return (i+1);
   return 0;
}

void check_numeric (GtkEditable *editable, const gchar *text,
                          gint length, gint *position, gpointer data)
{
   int i, j, hnd;
   gchar *result = g_new (gchar, length);

   j = 0;
   for (i=0; i<length; i++)
     if(isdigit(text[i]))
        result[j++] = text[i];

   hnd = get_int(GTK_WIDGET(editable), "hnd");
   g_signal_handler_block (G_OBJECT (editable), hnd);
   gtk_editable_insert_text (editable, result, j, position);
   g_signal_handler_unblock (G_OBJECT (editable), hnd);

   g_signal_stop_emission_by_name(G_OBJECT (editable), "insert_text");

   g_free (result);
 }


double Fr(double r, int type)
{
   int i;

   if(type == 0)
      return sqrt(r);
   for(i=0; i<type-1; i++)
       r *= r;
   return r;
}

GdkColor *get_colorgdk(int new_color)
{
   return main_app::TheApp.getgdkCol(new_color);
}

void palla_sfumata_java(int x, int y, int raggio, int iFC, int plux, 
                        gpointer context, gpointer outPix,
                         GdkColor Colori[], int fromSettings)
{
      GdkColor *col;
      if(fromSettings)
         col = &(Colori[iFC]);
      else
         col = get_colorgdk(iFC);
      palla_sfumata(context, outPix, x, y, raggio, col);
      if(!fromSettings)
         g_free(col);
      return;
}

extern "C" void csfumapallejava_(int *X11, int *Y11, int *irp, int *iFC)
{
      int plux, xo, yo, raggio;
      gboolean disegna;
      if(!jscreen)
          return;
      gpointer outPix = getCurrentPix();
      gpointer context = getCurrentContext();

      raggio = *irp;
      plux = (int) ((double) raggio/2.0);
      xo = *X11 - raggio;
      yo = *Y11 - raggio;
      disegna = TRUE;
      if((xo > main_app::TheApp.Kscrx) || (yo > main_app::TheApp.Kscry) || (xo < -2*raggio) || (yo < -2*raggio))
         disegna = FALSE;
      if(disegna)
         palla_sfumata_java(*X11, *Y11, raggio, *iFC, plux,
                            context, outPix, NULL);
}

extern "C" void csfumapalle_(int *X11, int *Y11, int *irp, int *iFC)
{
      if(!jscreen)
          return;
      csfumapallejava_(X11, Y11, irp, iFC);
}

void finestra_modale_aperta2(GtkWidget *widget)
{
    GtkWidget *tb;

    if(win_stack < 0)
    {
       gdk_beep();
       (void) printf("win_stack error\n");
       quit_program(NULL, GINT_TO_POINTER(-1));
    }
    win_stack++;
    finestre[win_stack] = widget;
    if(ifMenubar)
    {
       GtkWidget *mb = lookup_widget(finestre[0], "menubar");
       salva_stato_mb(mb, statoinimb[win_stack]);
       abilitamb(finestre[0], 0);
    }
    if(ifToolbar && show_toolbar)
    {
       tb = lookup_widget(finestre[0], toolbarname[Livcur]);
       salva_stato_tb(tb, statoinitb[win_stack]);
       abilitatb(tb, 0);
    }
    if(curSmiley != 5)
       curSmileySav = curSmiley;
    curSmiley = 5;
    set_smiley(curSmiley);
//    gtk_window_set_transient_for(finestre[win_stack],
//             finestre[win_stack-1]);
}

void finestra_modale_chiusa2(void)
{
    GtkWidget *tb;//, *hbox;     27.11

    if(ifMenubar)
       abilitamb(finestre[0], -2);
    if(ifToolbar && show_toolbar)
    {
       tb = lookup_widget(finestre[0], toolbarname[Livcur]);
       abilitatb(tb, -2);
    }
    win_stack--;
    if(win_stack == 0)
       curSmiley = curSmileySav;
    else if(win_stack > 0)
       curSmiley = 5;
    else
       curSmiley = 4;
    set_smiley(curSmiley);
}

gboolean finestra_modale_up(GtkWidget *wid, GdkEvent *ev, gpointer data)
{
    if(finestre[win_stack])
       gdk_window_raise(gtk_widget_get_window(finestre[win_stack]));
    return TRUE;
}


void fortran_al_lavoro(void)
{
   if(!jscreen)
      return;
   if(ifStatusbar)
      set_smiley(3);
//080206   curSmiley = 1;
   if(curSmiley != 5)
      curSmileySav = curSmiley;
   curSmiley = 3;

   single_it = TRUE;
}

void fine_lavoro(void)
{
   if(!jscreen)
      return;
           //080206
   if(curSmileySav != 3)
     curSmiley = curSmileySav;
   else
     curSmiley = 1;
   set_smiley(curSmiley);
   single_it = FALSE;
}

void set_smiley (int come)
{
   if(ifStatusbar)
   {
      if(gdk_pixbuf_animation_is_static_image(smil_buf[come]))
         gtk_image_set_from_pixbuf(GTK_IMAGE(pixsmiley), 
               gdk_pixbuf_animation_get_static_image(smil_buf[come]));
      else
         gtk_image_set_from_animation(GTK_IMAGE(pixsmiley), smil_buf[come]);
   }
   if(come == 5)
      enable_tip(get_widget(finestre[0], "ebox"), TRUE);
   else
      enable_tip(get_widget(finestre[0], "ebox"), FALSE);
}

void clear_status_bar(void)
{
     if(ifStatusbar)
     {
        print_mess(" ");
        if(win_stack == 0)
        {
           curSmiley = 1;
           curSmileySav = 1;
           set_smiley(curSmiley);
        }
     }
}

static gboolean on_state_event (GtkWidget *widget,
                    GdkEventWindowState *event, gpointer data)
{
//  main_app::TheApp.IfMaximized = 0;
//#ifdef _WIN32
  if (event->changed_mask & (GDK_WINDOW_STATE_MAXIMIZED |
                             GDK_WINDOW_STATE_FULLSCREEN))
    {
      gboolean maximized;

      maximized = event->new_window_state & (GDK_WINDOW_STATE_MAXIMIZED |
                                             GDK_WINDOW_STATE_FULLSCREEN);
      main_app::TheApp.IfMaximized = (maximized > 0);
    }
//#endif
    return FALSE;
}

void cExitSir(GtkWidget *button, gpointer data)
{
    dialogo->ifIsOver = 1;
    exit_confirm(button, "Exit");
}

#if 0
extern "C" int is_new_viewer_opened_()
{
  if(!jscreen)
      return 0;
  GtkWidget *wid = get_widget(finestre[0], "area_messaggi");
  return gtk_widget_get_visible(wid);
}

int altezza_viewer()
{
    GtkAllocation allocation;
    gtk_widget_get_allocation(get_widget(finestre[0], "DAbox"), &allocation);
    int htot = (int) allocation.height;
    gtk_widget_get_allocation(get_widget(finestre[0], drawingareaname), &allocation);
    int hDA = (int) allocation.height;
    int h = htot - hDA - 6;
    return h;
}

extern "C" void new_viewer_size_(int *x, int *y)
{
  if(!jscreen)
      return;
  GtkAllocation allocation;
  GtkWidget *viewer = get_widget(finestre[0], "area_grafica2");
//     while(gtk_events_pending())
//         (void) gtk_main_iteration();
  gtk_widget_get_allocation(viewer, &allocation);
  *x = (int) allocation.width;
  *y = altezza_viewer(); //(int) allocation.height;
//  g_print("size %d %d\n", *x, *y);
}

void do_configure(GtkWidget *widget, int w, int h)
{
    gpointer pixmap;
    _Viewer *view = (_Viewer *) get_object(widget, "view");
    gpointer context;
    os_and_gc *rt;

    if (get_object(widget, "context") != NULL)
        context = get_object(widget, "context");
    else
        context = NULL;

    if (get_object(widget, "offscreen") != NULL)
        pixmap = get_object(widget, "offscreen");
    else
        pixmap = NULL;

    destroy_os_and_gc(pixmap, context);
    rt = get_os_and_gc(widget);
    pixmap = rt->os;
    context = rt->gc;
    g_object_set_data(G_OBJECT(widget), "context", context);
    g_object_set_data( G_OBJECT(widget), "offscreen", pixmap);
    setta_foreground(dialogo->jBackGround, context);
    draw_rectangle (pixmap, context, TRUE, 0, 0, w, h);
    if(view != NULL)
    {
       view->pix = pixmap;
       if(view->ifResize)
       {
//          g_print("do_configure %d  %d\n", w, h);
          mr_send_viewer_pixmap(widget);
          view->cbResize(&w, &h);
          mr_restore_pixmap();       // aggiunta il 26/03/2013
       }
    }
}

gboolean onView_configure_event     (GtkWidget       *widget,
                                       GdkEventConfigure *event,
                                       gpointer        data)
{
    GtkAllocation alloc;
    gtk_widget_get_allocation(widget, &alloc);
    int w = (int)alloc.width;
    int h = altezza_viewer();
//mr 190414 aggiunto anche controllo su hP 
    int wP = get_int(widget, "wP");
    int hP = get_int(widget, "hP");
    if((wP == w) && (hP == h))
       return TRUE;
    do_configure(widget, w, h);
    g_object_set_data( G_OBJECT(widget), "wP", GINT_TO_POINTER(w));
    g_object_set_data( G_OBJECT(widget), "hP", GINT_TO_POINTER(h));
    g_signal_stop_emission_by_name(G_OBJECT(widget), "configure_event");
    return TRUE;
}

GtkWidget *CreateSideFrame(GtkWidget *main_window, int ori)
{
  GtkWidget *frame;

  if(ori == 'v')
     frame = hpaned_new();
  else
     frame = vpaned_new();
  gtk_widget_show (frame);
  g_object_set_data (G_OBJECT (main_window), "area_messaggi", frame);
  g_object_set_data (G_OBJECT (main_window), "paned2", frame);

  GtkWidget *frame2 = gtk_frame_new(NULL);
  gtk_paned_pack1((GtkPaned *)frame, frame2, TRUE, TRUE);
  gtk_widget_show (frame2);
  g_object_set_data (G_OBJECT (main_window), "area_testo", frame2);
  GtkWidget *vbox = vbox_new(FALSE, 0);
  gtk_widget_show (vbox);
  gtk_container_set_border_width(GTK_CONTAINER(vbox), 8);
  gtk_container_add(GTK_CONTAINER(frame2), vbox);
  for(int i=0; i<NMESSAGES; i++)
  {
      std::stringstream nome;
      nome << "messaggi" << i+1;
      GtkWidget *label = LABEL_NEW(" ", NULL);
      gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE, 0);
      gtk_widget_show (label);
      g_object_set_data (G_OBJECT (main_window), nome.str().c_str(), label);
      set_alignment(label, 0., 0.);
      gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);
#ifndef NOELLIPSIZE
      gtk_label_set_ellipsize(GTK_LABEL(label), PANGO_ELLIPSIZE_END);
#else
      gtk_label_set_line_wrap(GTK_LABEL(label), TRUE);
#endif
  }

  // Create the Drawable widget 
  GtkWidget *viewer = gtk_drawing_area_new ();
  gtk_paned_pack2((GtkPaned *)frame, viewer, TRUE, TRUE);
  g_object_set_data(G_OBJECT(main_window), "area_grafica2", viewer);
  g_object_set_data(G_OBJECT(viewer), "offscreen", NULL);
  int hnd = g_signal_connect (G_OBJECT (viewer), "configure_event",
                      G_CALLBACK (onView_configure_event), NULL);
  g_object_set_data(G_OBJECT(viewer), "hnd", GINT_TO_POINTER(hnd));
  g_object_set_data(G_OBJECT(viewer), "wP", GINT_TO_POINTER(0));

  hnd = g_signal_connect (G_OBJECT (viewer), DRAW_EVENT,
                      G_CALLBACK (ManageExpose),
                      NULL);
  g_object_set_data(G_OBJECT(viewer), "hnd_expose", GINT_TO_POINTER(hnd));

  gtk_widget_show (viewer);

  return frame;
}
#endif

void c_gui(GtkWidget *button, gpointer data)
{
    dialogo->ifMadEnv = 0;
    GtkWidget *hb = get_widget(finestre[0], "close_box");
    gtk_widget_hide(hb);
    hb = get_widget(finestre[0], "hboxsotto");
    gtk_widget_show(hb);
    hb = get_widget(finestre[0], menubarname);
    gtk_widget_show(hb);
    hb = get_widget(get_widget(finestre[0], "toolbar_main"), "hbox");
    gtk_widget_show(hb);
    show_toolbar = TRUE;
    gdk_window_invalidate_rect(gtk_widget_get_window(finestre[0]),
     NULL, FALSE);
}

//  NEW 1606 

void  update_menu_recprj(GtkWidget *mainwin, int flag)
{
  int k;
  gchar *item_string, sk[10];
  gpointer item;

  for(k=0; k<RP->nRecentProjects; k++)             /* progetti recenti */
  {
      ScriviStringa(sk, sizeof(sk), "recent%d", k+1);
      if((item = get_object(mainwin, sk)) != NULL)
      {
         item_string = DuplicaStringa(RP->RecentProj[k]);
         obj_set_label(item,toUTF8(item_string));
         obj_show(item);
         g_free(item_string);
      }
  }
}

#ifdef USE_ACTIONS

void finish_ui_manager(GtkUIManager *merge, mr_action_entry entries[],
          guint n_entries, const char *base, GtkWidget *window)
{
    std::string nome(base);
    GtkWidget *tb = gtk_ui_manager_get_widget (merge, base);
    PangoFontDescription *newfdesc = get_font(1.1);
    for(guint i=0; i<n_entries; i++)
    {
        int hnd;
        mr_action_entry entry = entries[i];
        bool ifShow = true;
        if(str_white(entry.name))
           continue;
        nome.assign(base);
        nome.append(entry.name);
        if(entry.type < 0)
        {
            ifShow = false;
            entry.type = -entry.type;
        }
        GtkWidget *toolitem = gtk_ui_manager_get_widget (merge, nome.c_str());
        if(toolitem == NULL)
           continue;
        GtkWidget *button = NULL;
        gpointer data;
        if(entry.cb)
        {
           if(entry.num == -2)
              data = (gpointer) window;
           else if(entry.num == -1)
              data = (gpointer) entry.name;
           else
              data = GINT_TO_POINTER(entry.num);
        }
        if(entry.type > 100)
           entry.type -= 100;

        switch(entry.type)
        {
        default:
             break;
        case 5:
             {
                float v[6];
                char *tmpst = g_strdup(entry.icon);
                get_float_tokens(tmpst,  ",", 5,  v);
                button = spin_button_new_with_range(
                                      v[2], v[3], v[4]);
                spin_button_set_value(button, v[1]);
                if(v[0] > 0) 
                    gtk_widget_set_size_request(button, 80, 24);
                spin_button_set_numeric (button, TRUE);
                if(entry.cb)
                {
                   hnd = g_signal_connect ((gpointer) button, "value-changed",
                     entry.cb , data);
                   g_object_set_data (G_OBJECT (button), "hnd",
                           GINT_TO_POINTER(hnd));
                }
             }
             break;
        case 6:
             {
                GtkWidget *vbox = vbox_new(FALSE, 0);
                button = create_range(window, vbox,
                   special_car_greek('s'), 1, entry.name);
                gtk_widget_show_all(vbox);
                int hnd = g_signal_connect ((gpointer) button,
                   "value-changed", G_CALLBACK(entry.cb), data);
                g_object_set_data (G_OBJECT (button), "hnd",
                   GINT_TO_POINTER(hnd));
                gtk_widget_set_sensitive(vbox, FALSE);
             }
             break;

        case 7:
        case 8:
             button = myimage_button(entry.string, entry.icon);
             gtk_button_set_relief (GTK_BUTTON(button), GTK_RELIEF_NONE);
             gtk_widget_set_can_focus (button, FALSE);
             if(entry.cb)
                g_signal_connect ((gpointer) button, "clicked",
                     entry.cb , data);
             break;
          
        case 12:
             button = LABEL_BOLD(entry.string, MyBLUE, 1.1f);
             break;
        case 13:
             button = gtk_entry_new();
             break;
        case 47:
             if(toolitem)
             {
                char *icons[3];
                char *tmpst = g_strdup(entry.icon);
                get_str_tokens(tmpst,  ",", 2,  icons);
                button = gtk_event_box_new();
                GtkWidget *tbpix1 = create_image(icons[0]);
                GtkWidget *tbpix2 = create_image(icons[1]);
                g_object_ref(G_OBJECT(tbpix1));
                g_object_ref(G_OBJECT(tbpix2));
                gtk_widget_show(tbpix1);
                gtk_widget_show(tbpix2);
                g_object_set_data(G_OBJECT(button), "icon1", tbpix1);
                g_object_set_data(G_OBJECT(button), "icon2", tbpix2);
                gtk_container_set_border_width(GTK_CONTAINER(button), 0);
                gtk_container_add(GTK_CONTAINER(button), tbpix1);
                if(entry.cb)
                {
                   (void) g_signal_connect (G_OBJECT (button), 
                   "button_release_event", entry.cb, GINT_TO_POINTER(0));
                   (void) g_signal_connect (G_OBJECT (button), 
                   "button_press_event", entry.cb, GINT_TO_POINTER(1));
                    gtk_widget_set_events(button, GDK_BUTTON_RELEASE_MASK | 
                      GDK_BUTTON_PRESS_MASK);
                }
             }
             break;

        case 50:
             button = create_image(entry.icon);
             break;

        case 52:
             button = label_boxed(" ");
             widget_modify_font(get_widget(button, "label"), newfdesc);
             break;

        case 80:
             gtk_tool_item_set_expand(GTK_TOOL_ITEM(toolitem), TRUE);
             break;

       }
       if(button != NULL)
       {
          gtk_widget_show_all(button);
          gtk_widget_set_visible(toolitem, ifShow);
          if(entry.type == 52)
          {
             g_object_set_data (G_OBJECT (window), entry.name,
                   gtk_bin_get_child(GTK_BIN(button)));
             g_object_set_data (G_OBJECT (tb), entry.name,
                   gtk_bin_get_child(GTK_BIN(button)));
          }
          else
          {
             g_object_set_data (G_OBJECT (window), entry.name, button);
             g_object_set_data (G_OBJECT (tb), entry.name, button);
          }
          if(entry.type == 6)
             gtk_container_add(GTK_CONTAINER(toolitem),
               gtk_widget_get_parent(button));
          else
             gtk_container_add(GTK_CONTAINER(toolitem), button);
       }
    }
    pango_font_description_free(newfdesc);
}

#endif

GtkWidget* create_mainwin (int WINDWID, int WINDHEI)
{
  GtkWidget *main_window;
  GtkWidget *vbox;
  GtkWidget *ebox;
  GtkWidget *menubar;
  GtkWidget *frame2;
  GtkWidget *drawingarea;
  GtkWidget *statusb;
  GtkWidget *pixsmiley;
  GtkWidget *hboxsotto;
  GtkWidget *progressbar;
  GtkWidget *toolbar;
  GtkWidget *hbox;
  int       i, ori = 'v';

  main_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  finestre[0] = main_window;
  g_object_set_data (G_OBJECT (main_window), windowname, main_window);
  gtk_window_set_title (GTK_WINDOW (main_window), MR_PACKAGE);
  gtk_window_set_default_size(GTK_WINDOW (main_window), WINDWID, WINDHEI);

#ifndef GTK_TOOLTIP
  GtkTooltips *tooltips = gtk_tooltips_new ();
  GtkTooltips *smile_tooltips = gtk_tooltips_new ();
  set_win_main(main_window);
  g_object_set_data(G_OBJECT(main_window), "tt", tooltips);
  g_object_set_data(G_OBJECT(main_window), "smilett", smile_tooltips);
#endif

  vbox = vbox_new (FALSE, 0);
  g_object_set_data (G_OBJECT (main_window), "vbox", vbox);
  gtk_container_add (GTK_CONTAINER (main_window), vbox);
  gtk_widget_show (vbox);

  GtkWidget *frame = gtk_frame_new(NULL);
  gtk_box_pack_start (GTK_BOX (vbox), frame, FALSE, TRUE, 0);
  gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_ETCHED_IN);

#ifdef USE_ACTIONS
  GtkActionGroup *group = CreateActionGroup(main_window,
                      n_menu_items, (mr_action_entry *) menuitems, "MenuBar");
#else
  menubar = CreateMenubar(main_window, (mr_action_entry *) menuitems, n_menu_items);
  PangoFontDescription *newfdesc = get_font(1.1);
#endif
  if(ifToolbar)
  {
      for (i=0; i< (int) (sizeof(toolbaritems)/sizeof(gpointer)); i++)
      {
#ifdef USE_ACTIONS
         CreateActionGroup(main_window, n_entries[i],
                   (mr_action_entry *)toolbaritems[i], Nomi[i]);
#else
         toolbar = CreateToolbar(main_window, 0, 
                   (mr_action_entry *)toolbaritems[i], n_entries[i]);
         g_object_set_data (G_OBJECT (main_window), Nomi[i], toolbar);
         g_object_set_data(G_OBJECT(toolbar), "tb", toolbar);
         if(strstr(Nomi[i], "run2"))
            widget_modify_font(get_widget(toolbar, "entryRun2"), newfdesc);
         else if(strstr(Nomi[i], "run"))
            widget_modify_font(get_widget(toolbar, "entry"), newfdesc);
#endif
      }        
  }
#ifdef USE_ACTIONS
     GtkUIManager *merge = gtk_ui_manager_new ();
     gtk_ui_manager_insert_action_group (merge, group, -1);
     gtk_window_add_accel_group (GTK_WINDOW (main_window),
                                  gtk_ui_manager_get_accel_group (merge));
     g_object_set_data_full (G_OBJECT (main_window), "ui-manager", merge,
                              g_object_unref);
     menubar = CreateMenubar(main_window, menu_info, merge, group);
     set_tooltips_on_menu(main_window, n_menu_items,
            (mr_action_entry *) menuitems);

     if(ifToolbar)
     {
         for (i=0; i< (int) (sizeof(toolbaritems)/sizeof(gpointer)); i++)
         {
              toolbar = CreateToolbar(main_window, tbui_info[i], merge, group,
                        Nomi[i]);
              g_object_set_data (G_OBJECT (main_window), Nomi[i], toolbar);\
              g_object_set_data(G_OBJECT(toolbar), "tb", toolbar);
              std::string nome = "/";
              nome.append(Nomi[i]);
              nome.append("/");
              finish_ui_manager(merge, (mr_action_entry *)toolbaritems[i],
                n_entries[i], nome.c_str(), main_window);
              g_object_set_data (G_OBJECT (main_window), Nomi[i], toolbar);
         }
     }
#else 
     pango_font_description_free(newfdesc);
#endif

  if(ifMenubar)
  {
      update_menu_recprj(main_window, 1);
  
      int nRecProj = RP->nRecentProjects;
      for(int k=0; k<MAXPROJ; k++)
      {
          gpointer item;
          gchar sk[10];
          ScriviStringa(sk, sizeof(sk), "recent%d", k+1);
          if((item = get_object(main_window, sk)) != NULL)
              (void) g_signal_connect( G_OBJECT(item), "activate",
                     cb_for_recproj, (gpointer) "recprj");
      }
      for(int k=nRecProj; k<MAXPROJ; k++)
      {
          gpointer item;
          gchar sk[10];
          ScriviStringa(sk, sizeof(sk), "recent%d", k+1);
          if((item = get_object(main_window, sk)) != NULL)
              obj_hide(item);
      }
      salva_stato_mb(menubar, statoinimb[0]);
      g_object_set_data(G_OBJECT(menubar), windowname, main_window);
//#ifndef MAC_INTEGRATION
      gtk_widget_show(frame);
      gtk_container_add (GTK_CONTAINER (frame), menubar);
//#endif
      g_object_set_data (G_OBJECT (main_window), menubarname, menubar);
  }

  GtkWidget *frame1 = gtk_frame_new(NULL);
  gtk_box_pack_start (GTK_BOX (vbox), frame1, FALSE, TRUE, 0);
  gtk_widget_show(frame1);
  gtk_frame_set_shadow_type(GTK_FRAME(frame1), GTK_SHADOW_ETCHED_IN);
  GtkWidget *vbox1 = vbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER(frame1), vbox1);
  gtk_widget_show(vbox1);

  if(ifToolbar)
  {
      for (i=0; i< (int) (sizeof(toolbaritems)/sizeof(gpointer)); i++)
      {
         hbox = hbox_new (FALSE, 0);
         gtk_box_pack_start (GTK_BOX (vbox1), hbox, FALSE, FALSE, 0);
         g_object_set_data (G_OBJECT (main_window), "hbox", hbox);
         toolbar = get_widget(main_window, Nomi[i]);
         g_object_set_data(G_OBJECT(toolbar), "hbox", hbox);
         gtk_box_pack_start (GTK_BOX (hbox), toolbar, TRUE, TRUE, 0);
         if(i == 0)
         {
            salva_stato_tb(toolbar, statoinitb[0]);
            (void) g_signal_connect_after(G_OBJECT(hbox), "show", 
                G_CALLBACK(cb_for_set_tog), NULL);
         }
//         GdkColor color  = White;
//         widget_modify_bg(toolbar, GTK_STATE_NORMAL, &color);
         gtk_widget_show (toolbar);
      }
  }

  frame = hbox_new(FALSE, 0);
  g_object_set_data (G_OBJECT (main_window), "box_scr",frame);
  gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 0);
  gtk_widget_show (frame);

  if(ori == 'v')
     frame2 = vpaned_new();
  else
     frame2 = hpaned_new();
  g_object_set_data (G_OBJECT (main_window), "DAbox",frame2);
  gtk_box_pack_end (GTK_BOX (frame), frame2, TRUE, TRUE, 0);
  gtk_widget_show (frame2);

  drawingarea = gtk_drawing_area_new ();
  g_object_set_data (G_OBJECT (main_window), drawingareaname, 
              drawingarea);
  gtk_paned_pack1((GtkPaned *)frame2, drawingarea, TRUE, FALSE);
  g_object_set_data(G_OBJECT(drawingarea), "offscreen", NULL);
  gtk_widget_set_size_request(drawingarea, 200, 200); //WINDWID-3, WINDHEI-88);
  gtk_widget_show (drawingarea);

  GtkWidget *sideframe = CreateSideFrame(main_window, ori);
  gtk_paned_pack2((GtkPaned *)frame2, sideframe, TRUE, TRUE);
//  gtk_paned_pack2((GtkPaned *)frame2, sideframe, TRUE, FALSE);

  if(ifStatusbar)
  {
     GtkWidget *frame = gtk_frame_new(NULL);
     gtk_box_pack_start (GTK_BOX (vbox), frame, FALSE, FALSE, 0);
     gtk_widget_show(frame);
     gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_ETCHED_IN);

     hboxsotto = hbox_new (FALSE, 0);
     gtk_container_set_border_width ( GTK_CONTAINER (hboxsotto) , 0 );
     g_object_set_data (G_OBJECT (main_window), "hboxsotto", hboxsotto);
     gtk_widget_show (hboxsotto);
     gtk_container_add (GTK_CONTAINER (frame), hboxsotto);

     frame = gtk_frame_new(NULL);
     gtk_box_pack_start (GTK_BOX (hboxsotto), frame, FALSE, FALSE, 0);
     gtk_widget_show(frame);
     ebox = gtk_event_box_new();
     g_object_set_data (G_OBJECT (main_window), "ebox", ebox);
     gtk_container_add (GTK_CONTAINER (frame), ebox);
     gtk_widget_show (ebox);
     set_smil_tip (ebox, "Click to raise the obscured window");

     pixsmiley = gtk_image_new();
     if(pixsmiley)
     {
        g_object_set_data (G_OBJECT (main_window), smileyareaname, 
          pixsmiley);
        g_object_ref(G_OBJECT(pixsmiley));
//     gtk_widget_set_size_request(pixsmiley, 18, 18);
        gtk_widget_set_size_request(pixsmiley, 40, 20);
        set_alignment (pixsmiley, 0.5, 0.5);
        gtk_container_add(GTK_CONTAINER(ebox), pixsmiley);
        gtk_widget_show (pixsmiley);
     }

     statusb = gtk_statusbar_new ();
     g_object_set_data (G_OBJECT (main_window), statusbarname, statusb);
     gtk_widget_show (statusb);
     set_widget_font(gtk_statusbar_get_message_area(GTK_STATUSBAR(statusb)), main_app::TheApp.FontU().c_str());
     gtk_box_pack_start (GTK_BOX (hboxsotto), statusb, TRUE, TRUE, 2);

     progressbar = gtk_progress_bar_new ();
     g_object_set_data (G_OBJECT (main_window), progressbarname, 
           progressbar);
     gtk_widget_set_size_request(progressbar, WINDWID/4, 18);
//     GtkStyle  *newstyle = gtk_style_copy(gtk_widget_get_default_style());
//     newstyle->bg[GTK_STATE_PRELIGHT] = *LIGHTBLUE;
//     gtk_widget_ensure_style(progressbar);
//     gtk_widget_set_style(progressbar, newstyle);
//     g_object_set(G_OBJECT(progressbar), "bar-style",
//         GINT_TO_POINTER(GTK_PROGRESS_DISCRETE), NULL);
//     g_object_set(G_OBJECT(progressbar), "discrete-blocks",
//         GINT_TO_POINTER(20), NULL);
//     gtk_box_pack_start (GTK_BOX (hboxsotto), progressbar, TRUE,TRUE, 2);
     gtk_box_pack_start (GTK_BOX (hboxsotto), progressbar, FALSE,FALSE, 2);
     (void) g_signal_connect (G_OBJECT (ebox), "button_press_event",
                      G_CALLBACK (finestra_modale_up), NULL);
     gtk_widget_set_events(ebox, GDK_BUTTON_PRESS_MASK );
  }
//NEW
  hbox = hbutton_box_new();
  gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 4);
//  gtk_button_box_set_layout (GTK_BUTTON_BOX(hbox), GTK_BUTTONBOX_END);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(hbox), GTK_BUTTONBOX_SPREAD);
  gtk_box_set_spacing (GTK_BOX(hbox), 10);
  g_object_set_data( G_OBJECT(main_window), "close_box", hbox);

//EXTRA NEW
  GtkWidget *button = myimage_button ("B_est Model", "jav.png");
  g_object_set_data( G_OBJECT(main_window), "jav_button", button);
  gtk_container_add(GTK_CONTAINER(hbox), button);
  (void) g_signal_connect (G_OBJECT (button), "clicked",
              G_CALLBACK (c_newbestmodel), NULL);
  gtk_widget_show(button);
  set_tip(button, "View Best Model in Jav");

  button = myimage_button ("O_utput File", "output.png");
  g_object_set_data( G_OBJECT(main_window), "output_button", button);
  gtk_container_add(GTK_CONTAINER(hbox), button);
  (void) g_signal_connect (G_OBJECT (button), "clicked",
              G_CALLBACK (c_browserv2), GINT_TO_POINTER(5));
  set_tip(button, "View Output file");
  gtk_widget_show(button);

  button = myimage_button ("S_ummary", "summary.png");
  g_object_set_data( G_OBJECT(main_window), "summary_button", button);
  gtk_container_add(GTK_CONTAINER(hbox), button);
  (void) g_signal_connect (G_OBJECT (button), "clicked",
              G_CALLBACK (c_browserv2), GINT_TO_POINTER(1));
  set_tip(button, "View Summary");
  gtk_widget_show(button);

  button = myimage_button ("G_UI", "model_settings.png");
  g_object_set_data( G_OBJECT(main_window), "gui_button", button);
  gtk_container_add(GTK_CONTAINER(hbox), button);
  (void) g_signal_connect (G_OBJECT (button), "clicked",
              G_CALLBACK (c_gui), NULL);
  set_tip(button, "Start Graphical User Interface");
  gtk_widget_show(button);

//  GtkWidget *button = myimage_button ("C_lose", "close.png");
  button = QUIT_button();
  g_object_set_data( G_OBJECT(main_window), "close_button", button);
  gtk_container_add(GTK_CONTAINER(hbox), button);
  (void) g_signal_connect (G_OBJECT (button), "clicked",
              G_CALLBACK (cExitSir), NULL);
  char *tmp =  g_strdup_printf("Exit %s",MR_PACKAGE);
  set_tip(button, tmp);
  gtk_widget_show(button);
  g_free(tmp);

  (void) g_signal_connect (G_OBJECT (drawingarea), "configure_event",
                      G_CALLBACK (on_configure_event), NULL);

  (void) g_signal_connect (G_OBJECT (drawingarea), DRAW_EVENT,
                      G_CALLBACK (ManageExpose),
                      NULL);
  (void) g_signal_connect (G_OBJECT (main_window), "key_press_event",
                      G_CALLBACK (cb_for_key_press), NULL);
  gtk_widget_set_events(main_window, GDK_KEY_PRESS_MASK);
  (void) g_signal_connect (G_OBJECT (drawingarea), "button_press_event",
                      G_CALLBACK (cb_for_mouse_press), NULL);
  (void) g_signal_connect (G_OBJECT (drawingarea), "button_release_event",
                      G_CALLBACK (cb_for_mouse_release), NULL);
  (void) g_signal_connect (G_OBJECT (drawingarea), "motion_notify_event",
                      G_CALLBACK (cb_for_mouse_move), NULL);
  (void) g_signal_connect (G_OBJECT (drawingarea), "scroll-event",
                      G_CALLBACK (cb_for_mouse_scroll), NULL);

  gtk_widget_set_events(drawingarea, GDK_BUTTON_PRESS_MASK | 
            GDK_SCROLL_MASK | GDK_STRUCTURE_MASK |
            GDK_BUTTON_MOTION_MASK | GDK_BUTTON_RELEASE_MASK);

  (void) g_signal_connect(main_window, "window_state_event",
                          G_CALLBACK (on_state_event),
                               NULL);

  (void) g_signal_connect (G_OBJECT (main_window), "delete_event",
                      cb_for_delete, (gpointer) "forced");

  return main_window;
}

void PrimeCose (GtkWidget *main_window)
{
  GtkWidget *drawingarea;
  int i;

  drawingarea = lookup_widget(main_window, drawingareaname);
  if(ifStatusbar)
  {
     statusbar   = lookup_widget(main_window, statusbarname);
     AddWelcomeMessage(statusbar, msgdefault);
#if 0
     Re_data *re_data = g_new0(Re_data, 1);
     re_data->statusbar = statusbar;
     re_data->msg = msgdefault;
#ifdef NOADD_SECS
     g_timeout_add(7200000, RefreshWelcomeMessage, (gpointer) re_data);
#else
     g_timeout_add_seconds (7200, RefreshWelcomeMessage, (gpointer) re_data);
#endif
#endif
     pixsmiley   = lookup_widget(main_window, smileyareaname);
  }
  initial_pix = create_initial_pix(initial_pixmap);
  if(!main_app::TheApp.Background)
  {
     GdkColor color  = Black;
     set_widget_color(drawingarea, &color);
  }
  else
  {
     GdkColor color  = White;
     set_widget_color(drawingarea, &color);
  }
//  gdk_window_clear (gtk_widget_get_window(drawingarea));
  GtkAllocation allocation;
  gtk_widget_get_allocation(main_window, &allocation);
  int w = (int) allocation.width;
  int h = (int) allocation.height;
  GtkWidget *paned1 = get_widget (main_window, "DAbox");
  gtk_paned_set_position(GTK_PANED(paned1), h);
  GtkWidget *paned2 = get_widget (main_window, "paned2");
  gtk_paned_set_position(GTK_PANED(paned2), w/2);

  if(ifStatusbar)
  {
     for (i=0; i<NUM_SMILEY; i++)
     {
          gchar *nome = g_strdup_printf("smil%d.gif",i);
          smil_buf[i] = mr_load_animation(nome);
          g_free(nome);
     }
     set_smiley(1);
  }
}
//end NEW 1606

void draw_cross(int ixx, int iyy, int col)
{
     gpointer outPix = getCurrentPix();
     gpointer context = getCurrentContext();
     setta_foreground(col, context);
     draw_line(outPix, context, ixx-6, iyy, ixx+6, iyy);
     draw_line(outPix, context, ixx, iyy-6, ixx, iyy+6);
     cflush_();
}

#if 0
void draw_initial_pixmap()
{
   GdkColor colorBlue = {0, 2570, 41634, 61937};
   if(initial_pix != NULL)
   {
      int w, h;
      hidemesg_();
      get_drawing_area_size(&w, &h);
      gpointer outPix = getCurrentPix();
      gpointer context = getCurrentContext();

      setta_foreground(1, context);
      draw_rectangle (outPix, context, TRUE, 0,0, w, h);
      int w1, h1, x2, y2, w2;
      disegna_pixnew(outPix, context, initial_pix, w/2, h/2, &x2, &y2);
      PangoFontDescription *fontnew  = DefaultFont();
      guint sz = pango_font_description_get_size (fontnew);
      pango_font_description_set_size (fontnew, 3*sz);
      pango_font_description_set_weight (fontnew, PANGO_WEIGHT_HEAVY);
      pango_font_description_set_style (fontnew, PANGO_STYLE_OBLIQUE);
      const char *str;
      if(strstr(MR_VERSION, "beta"))
         str = g_strdup_printf("%d.%dbeta", MY_MAJOR_VERSION(MR_VERSION),
                        MY_MINOR_VERSION(MR_VERSION));
      else
         str = g_strdup_printf("%d.%d", MY_MAJOR_VERSION(MR_VERSION),
                        MY_MINOR_VERSION(MR_VERSION));
      get_metrics(fontnew, &w1, &h1);
      draw_string(outPix, fontnew, context,  x2-(int)strlen(str)*w1, y2-h1, str, &colorBlue, NULL);
      gpointer flag_pix = create_initial_pix("bandiera.png");
      if(flag_pix != NULL)
      {
         drawable_get_size(initial_pix, &w2, &h1);
         drawable_get_size(flag_pix, &w1, &h1);
         disegna_pixnew(outPix, context, flag_pix,
              x2-w2+w1/2, y2-h1/2, &x2, &y2,1);
      }
      cflush_();
      setta_foreground(dialogo->jBackGround, context);
   }
}
#endif

#ifndef USE_CAIRO
void draw_initial_pixmap()
{
   GdkColor colorBlue = {0, 2570, 41634, 61937};
   if(initial_pix != NULL)
   {
      int w, h;
      hidemesg_();
      get_drawing_area_size(&w, &h);
      gpointer outPix = getCurrentPix();
      gpointer context = getCurrentContext();

      setta_foreground(1, context);
      draw_rectangle (outPix, context, TRUE, 0,0, w, h);
      int w1, h1, x2, y2, w2;
      disegna_pixnew(outPix, context, initial_pix, w/2, h/2, &x2, &y2);
      PangoFontDescription *fontnew  = DefaultFont();
      guint sz = pango_font_description_get_size (fontnew);
      pango_font_description_set_size (fontnew, 3*sz);
      pango_font_description_set_weight (fontnew, PANGO_WEIGHT_HEAVY);
      pango_font_description_set_style (fontnew, PANGO_STYLE_OBLIQUE);
      char *str;
      if(strstr(MR_VERSION, "beta"))
         str = g_strdup_printf("%d.%2.2d beta", MY_MAJOR_VERSION(MR_VERSION),
                        MY_MINOR_VERSION(MR_VERSION));
      else
         str = g_strdup_printf("%d.%2.2d", MY_MAJOR_VERSION(MR_VERSION),
                        MY_MINOR_VERSION(MR_VERSION));
      get_metrics(fontnew, &w1, &h1);
      draw_string(outPix, fontnew, context,  x2-(int)strlen(str)*w1, y2-h1, str, &colorBlue, NULL);
#if 0
      gpointer flag_pix = create_initial_pix("bandiera.png");
      if(flag_pix != NULL)
      {
         drawable_get_size(initial_pix, &w2, &h1);
         drawable_get_size(flag_pix, &w1, &h1);
         disegna_pixnew(outPix, context, flag_pix,
              x2-w2+w1/2, y2-h1/2, &x2, &y2,1);
      }
#endif
      cflush_();
      g_free(str);
      setta_foreground(dialogo->jBackGround, context);
   }
}
#else
void disegna_sfondo(gpointer context, int w, int h)
{
    cairo_pattern_t *pat;
//    float color0[] = {1, 1, 1};
//    float color1[] = {0.215686275f, 0.011764706f, 0.035294118f};
//    float color2[] = {1, 0, 0};
    float color1[] = {0.04f, 0.015f,0.24f};
    float color2[] =  {0.45f, 0.62f,0.81f};
    int raggio = MRmax(h, w);
    int x=w/2, y=h/2;
//    double r0 = MRmax(1.0, (double)raggio/15.);
    cairo_t *cr = (cairo_t *) context;
    cairo_set_line_width (cr, 1.0);

    pat = cairo_pattern_create_linear (0, 0, 0, h);  //vert 
//    pat = cairo_pattern_create_linear (0, 0, w, h); //diag
//    pat = cairo_pattern_create_radial (x, y, r0, x+r0, y-r0, (double) raggio);//radial
    cairo_pattern_add_color_stop_rgba (pat, 0.05, color1[0], color1[1], color1[2], 1);
    cairo_pattern_add_color_stop_rgba (pat, 0.95, color2[0], color2[1], color2[2], 1);
//    cairo_pattern_add_color_stop_rgba (pat, 0.0, color0[0], color0[1], color0[2], 1);  //add white
    cairo_set_source (cr, pat);
    cairo_arc (cr, x, y, raggio, 0, 2 * M_PI);
    cairo_fill (cr);
    cairo_pattern_destroy (pat);
      cflush_();
}


void draw_initial_pixmap()
{
   GdkColor colorWhite = {0, 65535, 65535, 65535};
   //gpointer pix2014 = create_initial_pix("sir2014ini.png");
   
   int w, h;
   hidemesg_();
   get_drawing_area_size(&w, &h);
   gpointer outPix = getCurrentPix();
   gpointer context = getCurrentContext();

   disegna_sfondo(context, w, h);
   if(initial_pix != NULL)
   {
      int w1, h1, x2, y2;
      disegna_pixnew(outPix, context, initial_pix, w/2, h/2, &x2, &y2);
      PangoFontDescription *fontnew  = DefaultFont();
      guint sz = pango_font_description_get_size (fontnew);
      pango_font_description_set_size (fontnew, 3*sz);
      pango_font_description_set_weight (fontnew, PANGO_WEIGHT_HEAVY);
      pango_font_description_set_style (fontnew, PANGO_STYLE_OBLIQUE);
      char *str;// = "1.0";
      if(strstr(MR_VERSION, "beta"))
         str = g_strdup_printf("%d.%2.2d beta", MY_MAJOR_VERSION(MR_VERSION),
                        MY_MINOR_VERSION(MR_VERSION));
      else
         str = g_strdup_printf("%d.%2.2d", MY_MAJOR_VERSION(MR_VERSION),
                        MY_MINOR_VERSION(MR_VERSION));
      get_metrics(fontnew, &w1, &h1);
      w1 = (int)(1.2*w1);
      draw_string(outPix, fontnew, context,  x2-(int)strlen(str)*w1, y2-h1, str, &colorWhite, NULL);
      cflush_();
      g_free(str);
      setta_foreground(dialogo->jBackGround, context);
      pango_font_description_free(fontnew);
   }
}
#endif
extern "C" void drawinitialpixmap_()
{
    if(jscreen)
       draw_initial_pixmap();
}

static gboolean on_configure_event (GtkWidget *widget, GdkEventConfigure *event,
                                        gpointer user_data)
{
    int w,h,i,ier;

    gpointer pixmap;
    _drawarea *da = (_drawarea *)(get_object(widget, "struct"));
    gpointer context;
    os_and_gc *rt;

    GtkAllocation allocation;
    gtk_widget_get_allocation(widget, &allocation);
    w = (int)allocation.width;
    h = (int)allocation.height;
    if( (MRabs(w - da->wPrevious)<= 5) && (MRabs(h - da->hPrevious) <= 5) && (!da->primavolta ))
    {
        g_signal_stop_emission_by_name(G_OBJECT(widget), "configure_event");
        return TRUE;
    }

    if (get_object(widget, "context") != NULL)
        context = get_object(widget, "context");
    else
        context = NULL;

    if (get_object(widget, "offscreen") != NULL)
        pixmap = get_object(widget, "offscreen");
    else
        pixmap = NULL;

    destroy_os_and_gc(pixmap, context);
    rt = get_os_and_gc(widget);
    pixmap = rt->os;
    context = rt->gc;
    g_free(rt);
    g_object_set_data(G_OBJECT(widget), "context", context);
    g_object_set_data( G_OBJECT(widget), "offscreen", pixmap);
    mr_send_pixmap(widget);
    da->outPix = pixmap;
    da->context = context;
    da->wPrevious = w;
    da->hPrevious = h;

//  Clear window 

    if(context)
    {
    setta_foreground(da->backGround, context);
    draw_rectangle (pixmap, context, TRUE, 0, 0, w, h);

    if(dialogo->ifMadEnv == 0)
    {
       setta_foreground(dialogo->jBackGround, context);
       draw_rectangle (pixmap, context, TRUE, 0, 0, w, h);
    }
    else
    {
       setta_foreground(1, context);
       draw_rectangle (pixmap, context, TRUE, 0, 0, w, h);
    }

    i = 1;
    ier = kridisegna_(&w, &h, &i);
    if(ier && context)
    {
        draw_initial_pixmap();
        da->primavolta = FALSE;
    }
    }

     GtkWidget *mwin = lookup_widget(widget, windowname);
     gtk_widget_get_allocation(mwin, &allocation);
     int wmain = (int)allocation.width;
     int hmain = (int)allocation.height;
     main_app::TheApp.UpdateDime(wmain, hmain);

#ifdef IN_GTK3
     if (gtk_widget_get_visible(get_widget(finestre[0], "area_messaggi")))
     {
         gtk_widget_get_allocation(get_widget(mwin, "DAbox"), &allocation);
         int he = (int) allocation.height - h;
         gtk_widget_get_allocation(get_widget(mwin, "area_grafica2"), &allocation);
         int wi = (int)allocation.width;
         do_configure(get_widget(finestre[0], "area_grafica2"), wi, he);
//       g_print("do_configure %d  %d\n", wi, he);
     }
#endif
     return TRUE;
}

void mr_send_pixmap(GtkWidget *win)
{
    GdkWindow *outWindow = gtk_widget_get_window(win);
    gpointer outPix = get_object(win,"offscreen");
    gpointer context = get_object(win,"context");
    g_object_set_data(G_OBJECT(finestre[0]), "currentPixmap", outPix);
    g_object_set_data(G_OBJECT(finestre[0]), "currentWindow", outWindow);
    g_object_set_data(G_OBJECT(finestre[0]), "currentContext", context);
    set_clip(win, getCurrentContext());
}

char *ref_line(char *str)
{
    char *newstr;
    int lstr, i, k, notblank = 0;

    lstr = (int)strlen(str)-1;
    if(lstr)
    {
       newstr = g_new0(gchar, lstr+1);
       k = 1;
       for(i=0; i<lstr; i++)
       {
           if(str[i] == ' ')
           {
              if(notblank)
              {
                 k = 1;
                 notblank = 0;
              }
              newstr[i] = (k % 10) + '0';
              k++;
           }
           else
           {
              newstr[i] = (k % 10) + '0';
              k++;
              notblank = 1;
           }
       }
       return g_strchomp(newstr);
    }
    else
      return NULL;
}

gboolean chiudi_dlg(gpointer data )
{
     gtk_widget_destroy((GtkWidget*) data);
     return FALSE;
}

gboolean hide_dlg(gpointer data )
{
     gtk_widget_hide((GtkWidget*) data);
     return FALSE;
}

void reset_handler (GtkWidget *hwnd, GdkEvent *ev, gpointer data)
{
  data = NULL;
}

void close_dlg  (GtkButton  *button, gpointer data)
{
    int num;
    gboolean ifmodale, ifdestroy, ifloop;

    ifdestroy = FALSE;
    ifloop = FALSE;
    num = GPOINTER_TO_INT(data);
    if(num >= 20)
    {
       num -= 20;
       ifloop = TRUE;
    }
    if(num >= 10)
    {
       num -= 10;
       ifdestroy = TRUE;
    }
    ifmodale = num % 2;
    num /= 2;
    if(ifmodale)
      finestra_modale_chiusa2();
//  if(num > 0)
//     avvisa_fortran(num);
    if(ifdestroy)
       gtk_widget_destroy (gtk_widget_get_toplevel(GTK_WIDGET(button)));
    else
       gtk_widget_hide (gtk_widget_get_toplevel(GTK_WIDGET(button)));
   if(ifloop)
      gtk_main_quit();
}

int is_comment(char c)
{
    if(c == '!' || c == '>')
       return 1;
    return 0;
}

int load_file(char *filename, GtkTextBuffer *text, 
                          int nlines, char **tags, int ntags)
{
   FILE *infile;
   GtkTextIter iter;
   int i;
   GtkTextTagTable *tag_table;

   infile = fOpen(filename, "r");
  
   if (infile) 
   {
       char buffer[1024], *str;

       gtk_text_buffer_get_iter_at_offset (text, &iter, 0);
       if(nlines)
       {
          if((str = fgets(buffer, 1024, infile)) != NULL)
          {
             while(is_comment(str[0]))
                   str = fgets(buffer, 1024, infile);
               
             gtk_text_buffer_insert_with_tags_by_name(text,
                                   &iter,
                                   ref_line(str), 
                                   (int) strlen(ref_line(str)),
                                   "reference_line",
                                   NULL);
             gtk_text_buffer_insert(text,
                                   &iter,
                                   "\n", 
                                   1);
             tag_table = gtk_text_buffer_get_tag_table(text);
             for(i=0; i<ntags; i++)
                   gtk_text_tag_table_add(tag_table,
                      gtk_text_tag_new(tags[i]));
          }
          (void) fclose (infile);
          infile = fOpen(filename, "r");
       }
       i = 0;
       while((str = fgets(buffer, 1024, infile)) != NULL)
       {
            gtk_text_buffer_insert(text,
                                   &iter,
                                   g_strchomp(str), 
                                   (int) strlen(g_strchomp(str)));
            gtk_text_buffer_insert(text,
                                   &iter,
                                   "\n", 
                                   1);
            i++;
            if((nlines) && (i == nlines))
                break;
       }
       (void) fclose (infile);
       return 0;
    }
    return -1;
}

int load_file_into_window(char *filnam, GtkWidget *text, 
                          char *fore, char *back, int nlines)
{
    GtkTextBuffer *text_buffer;
    int ntags, ier;
    char *tags[4];

    text_buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (text));
    ntags = 0;

    if(fore)
    {
       tags[ntags] = DuplicaStringa ("fore_color");
       gtk_text_buffer_create_tag (text_buffer, tags[ntags],
			      "foreground", fore, NULL);  
       ntags++;
    }
    if(back)
    {
       tags[ntags] = DuplicaStringa ("back_color");
       gtk_text_buffer_create_tag (text_buffer, tags[ntags],
			      "background", back, NULL);  
       ntags++;
    }
    ClearText(text);
    ier = load_file(filnam, text_buffer, nlines, tags, ntags);
    return ier;
}

GtkWidget *scrolled_text_new (GtkWidget *box1)
{
  GtkWidget *scrollwin;
  GtkWidget *text;
  GtkTextBuffer *tb;

  scrollwin = gtk_scrolled_window_new( NULL, NULL);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrollwin),
                                  GTK_POLICY_AUTOMATIC, 
                                  GTK_POLICY_AUTOMATIC);
  gtk_widget_show (scrollwin);
  gtk_container_add (GTK_CONTAINER (box1), scrollwin);
#ifdef IN_GTK3
  gtk_widget_set_vexpand(scrollwin, TRUE);
 #endif

  tb = gtk_text_buffer_new(NULL);
  gtk_text_buffer_create_tag (tb, "word_wrap",
			      "wrap_mode", GTK_WRAP_WORD, NULL);
  gtk_text_buffer_create_tag (tb, "font_p",
			      "font-desc", fontdescP, NULL);
  gtk_text_buffer_create_tag (tb, "font_n",
			      "font-desc", fontdescN, NULL);
  gtk_text_buffer_create_tag (tb, "font_u",
			      "font-desc", fontdescU, NULL);
  gtk_text_buffer_create_tag (tb, "blue_foreground",
			      "foreground", "blue", NULL);
  gtk_text_buffer_create_tag (tb, "gray_foreground",
//			      "foreground", "darkgray", NULL);
			      "foreground", "#606060", NULL);
  gtk_text_buffer_create_tag (tb, "yellow_foreground",
			      "foreground", "yellow", NULL);
  gtk_text_buffer_create_tag (tb, "wide_margins",
			      "left_margin", 10, "right_margin", 10,
			      NULL);
  gtk_text_buffer_create_tag (tb, "gray_bg",
			      "background", "lightgray", NULL);
  gtk_text_buffer_create_tag (tb, "superscript",
			      "rise", 15 * PANGO_SCALE,
			      "size", 12 * PANGO_SCALE,
			      "font-desc", fontdescP,
			      NULL);

  text = gtk_text_view_new_with_buffer(tb);
  gtk_container_add(GTK_CONTAINER(scrollwin), text);
  gtk_text_view_set_cursor_visible (GTK_TEXT_VIEW(text), FALSE);

  return text;
}


GtkWidget* create_dialog (GtkWidget *mwin, DlgItem *it)
{
  GtkWidget *dialog;
  GtkWidget *vbox;
  GtkWidget *box1;
  GtkWidget *box2;
  GtkWidget *pixmap;
  GtkWidget *button1;
  GtkWidget *label;

  dialog = gtk_dialog_new ();
  if(mwin != NULL)
      g_object_set_data (G_OBJECT (dialog), windowname, mwin);
  g_object_set_data (G_OBJECT (dialog), it->title, dialog);
  gtk_container_set_border_width (GTK_CONTAINER (dialog), 7);
  gtk_window_set_title (GTK_WINDOW (dialog), it->title);
  gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_CENTER);

  vbox = gtk_dialog_get_content_area(GTK_DIALOG(dialog));

  box1 = vbox_new (FALSE, 4);

  box2 = hbox_new (FALSE, 4);

  if(it->format == 1)
  {
      gtk_container_add (GTK_CONTAINER (vbox), box1);
      gtk_box_pack_start (GTK_BOX (box1), box2, TRUE, TRUE, 0);
  }
  else
  {
      gtk_container_add (GTK_CONTAINER (vbox), box2);
      gtk_box_pack_end (GTK_BOX (box2), box1, TRUE, TRUE, 0);
  }
 
  if(it->image != NULL)
  {
     pixmap = create_image (it->image);
     gtk_box_pack_start (GTK_BOX (box2), pixmap, TRUE, FALSE, 0);
  }

  if(it->text != NULL)
  {
     label = gtk_label_new (NULL);
     gtk_label_set_markup(GTK_LABEL(label), it->text);
     gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_CENTER);

     if(it->format == 1)
        gtk_box_pack_start (GTK_BOX (box2), label, FALSE, FALSE, 0);
     else
        gtk_box_pack_start (GTK_BOX (box1), label, TRUE, TRUE, 0);
  }
  widget_modify_font(label, fontdescU);

  if(it->nButtons >=1)
  {

     button1 = myimage_button(it->label1, it->image1);
     g_object_set_data(G_OBJECT (dialog), "button1",button1);
     gtk_dialog_add_action_widget(GTK_DIALOG(dialog), button1, 1);
     (void) g_signal_connect_after (G_OBJECT(button1), "clicked", 
                      it->cb_func1,it->cb_data1);
     if(it->focus == 1)
        gtk_widget_grab_focus (button1);
  }
  if(it->nButtons >=2)
  {

     button1 = myimage_button(it->label2, it->image2);
     g_object_set_data(G_OBJECT (dialog), "button2",button1);
     gtk_dialog_add_action_widget(GTK_DIALOG(dialog), button1, 2);
     (void) g_signal_connect_after (G_OBJECT(button1), "clicked", 
                      it->cb_func2,it->cb_data2);
     if(it->focus == 2)
        gtk_widget_grab_focus (button1);
  }
  if(it->nButtons >=3)
  {

     button1 = myimage_button(it->label3, it->image3);
     g_object_set_data(G_OBJECT (dialog), "button3",button1);
     gtk_dialog_add_action_widget(GTK_DIALOG(dialog), button1, 3);
     (void) g_signal_connect_after (G_OBJECT(button1), "clicked", 
                      it->cb_func3,it->cb_data3);
     if(it->focus == 2)
        gtk_widget_grab_focus (button1);
  }
  if(button1)
  {
     (void) g_signal_connect_swapped(G_OBJECT(dialog), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button1)); 
     gtk_button_box_set_layout(GTK_BUTTON_BOX(
      gtk_widget_get_parent(button1)), GTK_BUTTONBOX_SPREAD);

  }
  else
     (void) g_signal_connect_swapped(G_OBJECT(dialog), "delete_event",
           G_CALLBACK(gtk_widget_hide), G_OBJECT(dialog)); 

  (void) g_signal_connect (G_OBJECT (dialog), "delete_event",
                      G_CALLBACK(true_cb), NULL);

  if(mwin != NULL)
     gtk_window_set_transient_for(GTK_WINDOW(dialog), GTK_WINDOW(mwin));
  return dialog;
}

static int scelta = -1;
static int ifBW = 0, ifStereo = 0;

void click_button(GtkButton *button, gpointer data)
{
    GtkWidget *rb;
    int i;
    char num[3];
    
    ifBW = 0;
    if(!data)
       scelta = -1;
    else
    {
       for(i=1;i<=3;i++)
       {
          ScriviStringa(num, sizeof(num), "%d", i);
          rb = lookup_widget(GTK_WIDGET(button), num);
          if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(rb)))
             scelta = i;
       }
// GIANLUCA
       i = 5;
       ScriviStringa(num, sizeof(num), "%d", i);
       rb = lookup_widget(GTK_WIDGET(button), num);
       ifBW = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(rb));
       i = 7;
       ScriviStringa(num, sizeof(num), "%d", i);
       rb = lookup_widget(GTK_WIDGET(button), num);
       ifStereo = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(rb));
// GIANLUCA
    }
    close_dlg(button, GINT_TO_POINTER(11));
    gtk_main_quit();
}

GtkWidget *create_pof_dlg(void)
{
    GtkWidget *dialog, *button, *vbox, *frame;
    GSList *group = NULL;
    GtkWidget *separator, *hbox;
    GSList *group1 = NULL;

    dialog = gtk_dialog_new();
    gtk_container_set_border_width (GTK_CONTAINER (dialog), 5);
//    gtk_widget_set_size_request (dialog, 250, 150);

    frame = gtk_frame_new(NULL);
    gtk_box_pack_start(GTK_BOX(gtk_dialog_get_content_area(GTK_DIALOG(dialog))), frame,
                        FALSE, FALSE, 0);

    vbox = vbox_new(FALSE, 0);
    gtk_container_add(GTK_CONTAINER(frame), vbox);

    button = RADIO_BUTTON_WITH_LABEL(group, "Preview only", LABELCOLOR);
    g_object_set_data (G_OBJECT (dialog), "1", button);
    group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (button));
    gtk_box_pack_start (GTK_BOX (vbox), button, FALSE, FALSE, 0);
    button = RADIO_BUTTON_WITH_LABEL (group, "File only", LABELCOLOR);
    g_object_set_data (G_OBJECT (dialog), "2", button);
    group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (button));
    gtk_box_pack_start (GTK_BOX (vbox), button, FALSE, FALSE, 0);
    button = RADIO_BUTTON_WITH_LABEL (group, "Both preview & file", LABELCOLOR);
    g_object_set_data (G_OBJECT (dialog), "3", button);
    gtk_box_pack_start (GTK_BOX (vbox), button, FALSE, FALSE, 0);
  
// GIANLUCA
    separator = hseparator_new(  );
    gtk_box_pack_start (GTK_BOX (vbox), separator, FALSE, FALSE, 0);
    hbox = hbox_new (FALSE, 0);
    gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, FALSE, 0);

    button = RADIO_BUTTON_WITH_LABEL (group1, "Color",LABELCOLOR);
    g_object_set_data (G_OBJECT (dialog), "4", button);
    group1 = gtk_radio_button_get_group (GTK_RADIO_BUTTON (button));
    gtk_box_pack_start (GTK_BOX (hbox), button, TRUE, TRUE, 0);

    button = RADIO_BUTTON_WITH_LABEL (group1, "B / W", LABELCOLOR);
    g_object_set_data (G_OBJECT (dialog), "5", button);
    gtk_box_pack_start (GTK_BOX (hbox), button, TRUE, TRUE, 0);
// GIANLUCA
    separator = hseparator_new(  );
    gtk_box_pack_start (GTK_BOX (vbox), separator, FALSE, FALSE, 0);
    hbox = hbox_new (FALSE, 0);
    gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, FALSE, 0);

    group1 = NULL;
    button = RADIO_BUTTON_WITH_LABEL (group1, "Normal",LABELCOLOR);
    g_object_set_data (G_OBJECT (dialog), "6", button);
    group1 = gtk_radio_button_get_group (GTK_RADIO_BUTTON (button));
    gtk_box_pack_start (GTK_BOX (hbox), button, TRUE, TRUE, 0);

    button = RADIO_BUTTON_WITH_LABEL (group1, "Stereo", LABELCOLOR);
    g_object_set_data (G_OBJECT (dialog), "7", button);
    gtk_box_pack_start (GTK_BOX (hbox), button, TRUE, TRUE, 0);

    button = myimage_button("   _OK", "ok.png");
    gtk_dialog_add_action_widget(GTK_DIALOG (dialog), button, 1);
    (void) g_signal_connect (G_OBJECT (button), "clicked",
                      G_CALLBACK(click_button), GINT_TO_POINTER(1));

    button = myimage_button("  _Cancel", "cancel.png");
    gtk_dialog_add_action_widget(GTK_DIALOG (dialog), button, 2);
    (void) g_signal_connect (G_OBJECT (button), "clicked",
                      G_CALLBACK(click_button), NULL);
    (void) g_signal_connect_swapped (G_OBJECT (dialog), "delete-event",
                      G_CALLBACK(gtk_button_clicked), G_OBJECT(button));
    (void) g_signal_connect (G_OBJECT (dialog), "delete_event",
                      G_CALLBACK(true_cb), NULL);
    gtk_button_box_set_layout(GTK_BUTTON_BOX(
      gtk_widget_get_parent(button)), GTK_BUTTONBOX_SPREAD);

    return dialog;
    }

int preview_or_file(int espo)
{
    GtkWidget *pof_dlg;
    GtkWidget *button;

    scelta = 0;
    pof_dlg = create_pof_dlg();
    if(espo == 1)
       gtk_window_set_title (GTK_WINDOW (pof_dlg), "PostScript export");
    else
       gtk_window_set_title (GTK_WINDOW (pof_dlg), "HPGL export");
    gtk_widget_show_all(pof_dlg);
    button = lookup_widget(pof_dlg, "1");
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), TRUE);
    finestra_modale_aperta2(pof_dlg);
    gtk_main();
    if (scelta>0)
        scelta = scelta*10+ifBW*2+ifStereo;
    return scelta;
}

static gboolean cb_sele(GtkTreeSelection *selection, GtkTreeModel *model,
                        GtkTreePath *path, gboolean path_currently_selected,
                        int sel[])
{
    GtkWidget *list = GTK_WIDGET(gtk_tree_selection_get_tree_view(selection));
    int row = atoi(gtk_tree_path_to_string(path));

    if(path_currently_selected)
    {
       if(sel[row] < 0)
          set_cell_color(list, row, 0, "red");
       else if(sel[row] == 0)
          set_cell_color(list, row, 0, "blue");
    }
    else
       if(sel[row] < 0)
          set_cell_color(list, row, 0, "#ffcccc");
       else if(sel[row] == 0)
          set_cell_color(list, row, 0, "#ccccff");
    return TRUE;
}

GtkWidget *create_cselection(GtkWidget *parent, GtkWidget *parentbox,
                            const char *title, const char *id, int vsel[])
{  
  GtkWidget *scrolledwindow1, *dirsel, *label;
  GtkListStore *store;
  GtkCellRenderer *renderer;
  GtkTreeViewColumn *column;

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1),
                                   GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_widget_show (scrolledwindow1);
  if(parentbox)
  {
     if (GTK_IS_BOX(G_OBJECT(parentbox)))
         gtk_box_pack_start (GTK_BOX (parentbox), scrolledwindow1, TRUE, TRUE, 0);
     else if (GTK_IS_CONTAINER(G_OBJECT(parentbox)))
         gtk_container_add(GTK_CONTAINER(parentbox), scrolledwindow1);
  }
  store = gtk_list_store_new (1, G_TYPE_STRING);
  dirsel = gtk_tree_view_new_with_model(GTK_TREE_MODEL (store));
  g_object_set_data (G_OBJECT (parent), id, dirsel);
  gtk_widget_show (dirsel);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), dirsel);
  renderer = gtk_cell_renderer_text_new ();
  g_object_set (GTK_CELL_RENDERER (renderer),
                "font-desc", fontdescN, NULL);
  column = gtk_tree_view_column_new_with_attributes (title,
						     renderer,
						     "markup",
						     0,
						     NULL);
  gtk_tree_selection_set_select_function (gtk_tree_view_get_selection(GTK_TREE_VIEW(dirsel)),
                                         (GtkTreeSelectionFunc) cb_sele,
                                          vsel, NULL);
  gtk_tree_view_append_column (GTK_TREE_VIEW(dirsel), column); 
  gtk_tree_view_column_set_clickable(column, FALSE);
  if(title)
  {
     label = gtk_label_new (title);
     gtk_widget_show (label);
     widget_modify_font(label, fontdescU);
     gtk_tree_view_column_set_widget(column, label);
     g_object_set_data(G_OBJECT(dirsel), "titolo", label);
  }
  else
     gtk_tree_view_set_headers_visible(GTK_TREE_VIEW(dirsel), FALSE);
  return dirsel;
}
GtkWidget *create_selection(GtkWidget *parent, GtkWidget *parentbox,
                            const char *title, const char *id)
{  
  GtkWidget *scrolledwindow1, *dirsel, *label;
  GtkListStore *store;
  GtkCellRenderer *renderer;
  GtkTreeViewColumn *column;

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1),
                                   GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_container_set_border_width (GTK_CONTAINER (scrolledwindow1), 6);
  gtk_widget_show (scrolledwindow1);

  if(parentbox)
  {
     if (GTK_IS_BOX(G_OBJECT(parentbox)))
         gtk_box_pack_start (GTK_BOX (parentbox), scrolledwindow1, TRUE, TRUE, 0);
     else if (GTK_IS_CONTAINER(G_OBJECT(parentbox)))
         gtk_container_add(GTK_CONTAINER(parentbox), scrolledwindow1);
  }

  store = gtk_list_store_new (1, G_TYPE_STRING);
  dirsel = gtk_tree_view_new_with_model(GTK_TREE_MODEL (store));
  g_object_set_data (G_OBJECT (parent), id, dirsel);
  g_object_set_data (G_OBJECT (dirsel), "scrollwin", scrolledwindow1);
  gtk_widget_show (dirsel);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), dirsel);
  renderer = gtk_cell_renderer_text_new ();
  g_object_set (GTK_CELL_RENDERER (renderer),
             "font-desc", fontdescU, NULL);
  column = gtk_tree_view_column_new_with_attributes (title,
					     renderer,
					     "text",
					     0,
					     NULL);
  gtk_tree_view_append_column (GTK_TREE_VIEW(dirsel), column); 
  gtk_tree_view_column_set_clickable(column, FALSE);
  if(title)
  {
     label = gtk_label_new (title);
     gtk_widget_show (label);
     widget_modify_font(label, fontdescU);
     gtk_tree_view_column_set_widget(column, label);
     g_object_set_data(G_OBJECT(dirsel), "titolo", label);
  }
  else
     gtk_tree_view_set_headers_visible(GTK_TREE_VIEW(dirsel), FALSE);
  return dirsel;
}

GtkWidget *list_store_new(int ncol, char *titles[], int sizes[])
{
  GtkWidget *dirsel;
  GtkListStore *store;
  GtkCellRenderer *renderer;
  GtkTreeViewColumn *column;
  GType *types = g_new0(GType, ncol);
  int i;

  dirsel = gtk_tree_view_new();
  g_object_set_data(G_OBJECT(dirsel), "formato", GINT_TO_POINTER(ncol));
  for(i=0; i<ncol; i++)
      types[i] = G_TYPE_STRING;

  store = gtk_list_store_newv(ncol, types);
  for(i=0; i<ncol; i++)
  {
        renderer = gtk_cell_renderer_text_new ();
        g_object_set (GTK_CELL_RENDERER (renderer),
                "font-desc", fontdescU, "xpad", sizes[i]/4,
                "xalign", 1., NULL);
        column = gtk_tree_view_column_new_with_attributes (titles[i],
            renderer, "text", i, NULL);
        gtk_tree_view_column_set_sizing (column,GTK_TREE_VIEW_COLUMN_FIXED);
        gtk_tree_view_column_set_fixed_width(column, sizes[i]);
        gtk_tree_view_column_set_clickable(column, FALSE);
        gtk_tree_view_append_column (GTK_TREE_VIEW(dirsel), column); 
  }
  gtk_tree_view_set_model(GTK_TREE_VIEW(dirsel), GTK_TREE_MODEL (store));
  return dirsel;
}

GtkWidget *mostra_lista(const char *wtitle, const char *title, char *vec[], int n_el,
                         int seltype, GCallback cb2)
{
  GtkWidget *window, *list, *vbox, *button;
  int lung;

  window = gtk_dialog_new();
  gtk_window_set_title (GTK_WINDOW(window), wtitle);
  gtk_window_set_position (GTK_WINDOW(window), GTK_WIN_POS_MOUSE);
  lung = n_el * 30 + 100;
  if(lung > 350) 
     lung = 350;
  gtk_window_set_default_size(GTK_WINDOW(window), 100, lung);

  vbox = gtk_dialog_get_content_area(GTK_DIALOG(window));
  list = createSelection (window, vbox, title, title, 0, "blue");
  gtk_widget_set_name (list, title);
  if(seltype == 0)
     set_selection_mode(list, GTK_SELECTION_SINGLE);
  else
     set_selection_mode(list, GTK_SELECTION_MULTIPLE);
  populate_list(GTK_TREE_VIEW(list), vec, n_el, 1);
  gtk_widget_show (list);

  button = myimage_button("   _OK", "ok.png");
  gtk_widget_set_name(button, "ok");
  gtk_dialog_add_action_widget(GTK_DIALOG(window), button, 1);
  gtk_widget_show (button);
  (void) g_signal_connect (G_OBJECT(button), "clicked", cb2, DuplicaStringa(title));

  button = myimage_button("  _Cancel", "cancel.png");
  gtk_widget_set_name(button, "cancel");
  gtk_dialog_add_action_widget(GTK_DIALOG(window), button, 2);
  gtk_widget_show (button);
  (void) g_signal_connect (G_OBJECT(button), "clicked", cb2, DuplicaStringa(title));
   gtk_button_box_set_layout(GTK_BUTTON_BOX(
      gtk_widget_get_parent(button)), GTK_BUTTONBOX_SPREAD);
  
  (void) g_signal_connect_swapped(G_OBJECT(window), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button)); 
  (void) g_signal_connect (G_OBJECT (window), "delete_event",
                      G_CALLBACK(true_cb), NULL);

  gtk_widget_show(window);
  finestra_modale_aperta2(window);
  return list;
}

void show_selected (GtkWidget *list, int sel[])
{
  int n, item;

   unselect_all (GTK_TREE_VIEW(list));
   n =  n_children(list);
   for(item = 0; item < n ; item++)
   {
       if(sel[item] < 0)
          set_cell_color(list, item, 0, "red");
       else if(sel[item] > 0)
          select_row (list, item);
       else
          set_cell_color(list, item, 0, "blue");
   }
}

GtkWidget *create_peeklist(int sel_mode, char *string, int vsel[])
{
  GtkWidget *window, *list, *button, *label;

  window = gtk_dialog_new();
  gtk_window_set_position (GTK_WINDOW (window), GTK_WIN_POS_NONE);
  gtk_window_set_default_size(GTK_WINDOW(window), 300, 250);
  gtk_container_set_border_width(GTK_CONTAINER(window), 6);

  if(string && (strlen(string) > 1))
  {
     label = label_boxed(string);
     GtkWidget *truelabel = gtk_bin_get_child(GTK_BIN(label));
     set_alignment (truelabel, 0.5, 0.5);
     gtk_widget_show(label);
     gtk_box_pack_start(GTK_BOX(gtk_dialog_get_content_area(GTK_DIALOG(window))), label, FALSE, FALSE,
                         0);
  }
  list = create_cselection(window, gtk_dialog_get_content_area(GTK_DIALOG(window)), NULL, "scelte", vsel);
  if(sel_mode)
     set_selection_mode(list, GTK_SELECTION_MULTIPLE);
  else
     set_selection_mode(list, GTK_SELECTION_SINGLE);

  button = myimage_button("   _OK", "ok.png");
  gtk_dialog_add_action_widget(GTK_DIALOG(window), button, 1);
  g_object_set_data(G_OBJECT (window), "ok", button);

  button = myimage_button("  _All", "all.png");
  gtk_dialog_add_action_widget(GTK_DIALOG(window), button, 2);
  g_object_set_data(G_OBJECT (window), "all", button);

  button = myimage_button("  _Cancel", "cancel.png");
  gtk_dialog_add_action_widget(GTK_DIALOG(window), button, 3);
  g_object_set_data(G_OBJECT (window), "cancel", button);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(
      gtk_widget_get_parent(button)), GTK_BUTTONBOX_SPREAD);

  gtk_window_set_transient_for(GTK_WINDOW(window), GTK_WINDOW(finestre[0]));
  return window;
}

extern "C" void c_peek_list_(char *Inte, int *NumCan, int *MultiSel, int sel[],
                  int *iExitC, int *nats, char *Msg, int *flags)
{
  if(!jscreen)
      return;
   int nc = *NumCan;
   GtkWidget *list, *dialog;
   enum {IdOK=1, IdAll=2, IdCancel=4};

   fine_lavoro();
   dialog = create_peeklist(*MultiSel, Msg, sel);
   gtk_window_set_title (GTK_WINDOW (dialog), Inte);
   list = lookup_widget(dialog, "scelte");
   populate_list1(GTK_TREE_VIEW(list), It, nc, 1);

   show_selected(list, sel);
   //gtk_window_set_transient_for(GTK_WINDOW(dialog), GTK_WINDOW(finestre[0]));
   gtk_widget_show_all(dialog);
   if((*flags & IdOK) == 0)
       gtk_widget_hide(get_widget(dialog, "ok"));
   if((*flags & IdAll) == 0)
       gtk_widget_hide(get_widget(dialog, "all"));
   if((*flags & IdCancel) == 0)
   {
       int hnd = get_int(dialog, "hnd");
       gtk_widget_hide(get_widget(dialog, "cancel"));
       g_signal_handler_block(G_OBJECT(dialog), hnd);
   }
   finestra_modale_aperta2(dialog);
   int result = -1;
   while((result < 1) || (result > 3))
   {
        result = gtk_dialog_run(GTK_DIALOG(dialog));
        if(result == GTK_RESPONSE_DELETE_EVENT)
           result = 3;
   }
   get_selected_rownums(list, sel);
   gtk_widget_destroy(dialog);
   finestra_modale_chiusa2();

   *iExitC = result;
}

GtkWidget *toolbar_button_with_label(const gchar  *xpm_filename, const gchar *label)
{
    GtkWidget *button;

    button = myimage_button (label, xpm_filename);

    gtk_button_set_relief (GTK_BUTTON(button), GTK_RELIEF_NONE);
    gtk_widget_set_can_focus (button, FALSE);
    gtk_widget_show(button);
    return button;
}

extern "C" void  c_update_menu_recprj_(void)
{
  if(ifMenubar && jscreen)
     update_menu_recprj(mainwin, 0);
}
  
float copy_a_(void)
{
    int w, h;
    get_drawing_area_size(&w, &h);
    gpointer outPix = getCurrentPix();
    os_and_gc *outBuf = get_os_and_gc(drawingarea);
    draw_drawable(outBuf->gc, outBuf->gc, outPix, 0, 0, 0, 0, w, h);
    g_free(outBuf);
    return 0;
}

float copy_b_(void)
{
    gpointer outPix = getCurrentPix();
    gpointer context = getCurrentContext();
    int w, h;
    get_drawing_area_size(&w, &h);
    if(outBuf)
    {
       draw_drawable(outPix, context, outBuf->os, 0, 0, 0, 0, w, h);
       cflush_();
       destroy_os_and_gc(outBuf->os, outBuf->gc);
       outBuf = NULL;
    }
    return 0;
}

#ifndef GDK_WINDOWING_QUARTZ
void splash(const char*splash_file)
{
#ifndef IN_GTK3
    GtkWidget *splashwin, *pixmap;
    GdkPixmap *gdk_pixmap;
    GdkBitmap *mask;

    if(!strlen(splash_xpm) || !jscreen)
       return;
    if(ifHidden)
       return;
    splashwin = gtk_window_new (GTK_WINDOW_POPUP);
    gtk_window_move (GTK_WINDOW(splashwin), 200, 200);

    (void) g_signal_connect_swapped (G_OBJECT (splashwin), 
       "button_press_event",
        G_CALLBACK (gtk_widget_destroy), G_OBJECT(splashwin));
     gtk_widget_set_events(splashwin, GDK_BUTTON_PRESS_MASK );

    gdk_pixmap = mr_load_pixmap_withmask (splashwin, splash_file, 
                    &mask);
    if(gdk_pixmap == NULL)
       return;
    pixmap = create_image (splash_file);
    gtk_widget_show(pixmap);
    gtk_container_add (GTK_CONTAINER (splashwin), pixmap);

   if(mask)
      gtk_widget_shape_combine_mask (splashwin, mask, 0, 0);
    gtk_widget_show_all (splashwin);

    while (gtk_events_pending ())
      gtk_main_iteration ();
#else
    GtkWidget *splashwin, *pixmap;

    if(!strlen(splash_file) || !jscreen)
       return;
    if(ifHidden)
       return;
    splashwin = gtk_window_new (GTK_WINDOW_POPUP);
    gtk_window_move (GTK_WINDOW(splashwin), 200, 200);

    (void) g_signal_connect_swapped (G_OBJECT (splashwin),
       "button_press_event",
        G_CALLBACK (gtk_widget_destroy), G_OBJECT(splashwin));
     gtk_widget_set_events(splashwin, GDK_BUTTON_PRESS_MASK );

    cairo_surface_t *image = (cairo_surface_t *)
        mr_load_pixmap(splashwin, splash_file);
    if(image == NULL)
       return;
    pixmap = create_image (splash_file);
    gtk_widget_show(pixmap);
    gtk_container_add (GTK_CONTAINER (splashwin), pixmap);
    cairo_region_t *region = gdk_cairo_region_create_from_surface(image);

   if(region)
      gtk_widget_shape_combine_region (splashwin, region);
    gtk_widget_show_all (splashwin);

    while (gtk_events_pending ())
      gtk_main_iteration ();
#endif
}
#endif

extern "C" void c_splash_()
{
  if(!jscreen)
      return;
   splash(splash_xpm);
}
void on_cb_show(GtkToggleButton *button, GtkWidget *to_show)
{
   gboolean st;

   st = gtk_toggle_button_get_active(button);
   if(st)
      gtk_widget_show(to_show);
   else
      gtk_widget_hide(to_show);
}

void on_cb_hide(GtkToggleButton *button, GtkWidget *to_hide)
{
   gboolean st;

   st = gtk_toggle_button_get_active(button);
   if(st)
      gtk_widget_hide(to_hide);
   else
      gtk_widget_show(to_hide);
}

static void fill_model(GtkTreeStore *model, TreeItem tl[])
{
  GtkTreeIter iter;
  TreeItem *operations = tl;
  int i;

  i = 0;
  /* add data to the tree store */
  while (operations->label)
  {
      TreeItem *selmodes = operations->children;

      i++;
      gtk_tree_store_append (model, &iter, NULL);
      gtk_tree_store_set (model, &iter, 0, operations->label, -1);

      /* add children */
      while (selmodes->label)
      {
             GtkTreeIter child_iter;
             gtk_tree_store_append (model, &child_iter, &iter);
             gtk_tree_store_set (model, &child_iter, 0, selmodes->label, -1);
             selmodes++;
      }
      operations++;
  }
}

static GtkTreeModel *create_model (TreeItem tl[])
{
  GtkTreeStore *model;
  // create tree store 
  model = gtk_tree_store_new (1, G_TYPE_STRING);

  fill_model(model, tl);

  return GTK_TREE_MODEL (model);
}

static void add_columns (GtkTreeView *treeview)
{
  GtkCellRenderer *renderer;

  /* column for holiday names */
  renderer = gtk_cell_renderer_text_new ();
//  g_object_set (renderer, "xalign", 0.0, NULL);
  g_object_set (renderer,
                "xalign", 0.0, 
                "font-desc", fontdescU,
                NULL);

  gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (treeview),
							    -1, " ",
							    renderer, "text",
							    0,
							    NULL);
  gtk_tree_view_set_headers_visible(GTK_TREE_VIEW(treeview), FALSE);
}

void collapse_other(GtkTreeView *treeview, GtkTreeIter *arg1, GtkTreePath *arg2,
                     gpointer data)
{
      int hnd = get_int(GTK_WIDGET(treeview), "hnd");
          
      gtk_tree_view_collapse_all(treeview);
      g_signal_handler_block(treeview, hnd);
      gtk_tree_view_expand_row (treeview, arg2, 0);
      g_signal_handler_unblock(treeview, hnd);
}

GtkWidget *do_tree_store (GtkWidget *window, TreeItem tops[], GCallback cb, 
      GtkWidget *cb_data)
{
      GtkWidget *treeview;
      GtkTreeModel *model;
      GtkWidget *scrolled_win;
      int hnd;

      gtk_container_set_border_width (GTK_CONTAINER(window), 5);
  
      scrolled_win = gtk_scrolled_window_new (NULL, NULL);
      gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_win),
				         GTK_POLICY_NEVER,GTK_POLICY_AUTOMATIC);
      gtk_container_add (GTK_CONTAINER(window), scrolled_win);
      gtk_widget_show (scrolled_win);
  
      /* create model */
      model = create_model (tops);

      /* create tree view */
      treeview = gtk_tree_view_new_with_model (model);
      g_object_set_data(G_OBJECT(cb_data), "blocchi", treeview);
      g_object_unref (model);
      //gtk_tree_view_set_rules_hint (GTK_TREE_VIEW (treeview), FALSE);
      gtk_tree_selection_set_mode (gtk_tree_view_get_selection (GTK_TREE_VIEW (treeview)),
				   GTK_SELECTION_SINGLE);
      g_signal_connect(G_OBJECT(gtk_tree_view_get_selection (GTK_TREE_VIEW (treeview))),
        "changed", cb, cb_data);

      add_columns (GTK_TREE_VIEW (treeview));

      gtk_container_add (GTK_CONTAINER (scrolled_win), treeview);

      g_signal_connect (treeview, "realize",
         			G_CALLBACK (gtk_tree_view_collapse_all), NULL);
      hnd = g_signal_connect (treeview, "row-expanded",
         			G_CALLBACK (collapse_other), NULL);
      g_object_set_data(G_OBJECT(treeview), "hnd", GINT_TO_POINTER(hnd));
      gtk_widget_show_all(scrolled_win);
      return treeview;
}

extern "C" int viewfile_(char *title, char *file, int *tipo)
{
  struct stat buf;
  int e, flags = 0;
  int ctipo = *tipo;
  char *filter = g_new0(char, 6);
  CopiaStringa(filter, 6, "*.");
  AppendiStringa(filter, 6, str_cut(file, "."));
  if(strstr(filter, ".tmp"))
     CopiaStringa(filter, 6, "*.txt");

  if(!jscreen)
     return 0;
  if(single_it)
     while(gtk_events_pending())
         (void) gtk_main_iteration();
  e = stat("tmp.tmp", &buf);
  if(e)
     return 0;

  if(ctipo == 1)
  {
     createHtml(1, 1, ".log", ".htm");
     return 0;
  }
//121006 CONTROLLARE per readonly
  flags = gtkext::IFREADONLY;
  if(ctipo != 5)
     flags += gtkext::IFSAVEAS;
  if(ctipo == -1)
     compare_w (GTK_WINDOW(finestre[0]), file, filter, flags, title);
  else
     gtkext::text_window (GTK_WINDOW(finestre[0]), file, filter, flags, title);

  return 0;
}

static void change_dir(GtkButton *button, GtkWidget *widget)
{
   char *nome = g_new0(char, MaxLenFilename);

   ScriviStringa (nome, MaxLenFilename, "%s", gtk_editable_get_chars(GTK_EDITABLE(widget), 0, -1));
   if((strlen(nome) > 0) && (g_path_get_dirname(nome) != 0))
      (void) dir_set_current(g_path_get_dirname(nome));
}

GtkWidget *entry_for_fileselection(const char *label_string, const char *pix, 
          GCallback cb, gpointer data, int ifPreview, int ifBrowse, 
          const gchar *col, const char mod)
{

  GtkWidget *vbox, *hbox, *label, *entry, *button, *image;
  GtkRequisition req;
  int wid;

  if(mod == 'v')
     vbox = vbox_new(FALSE, 0);
  else
     vbox = hbox_new(FALSE, 0);
  gtk_widget_show (vbox);

  hbox = hbox_new(FALSE, 0);
  gtk_widget_show(hbox);
  gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, TRUE, 0);
  g_object_set_data(G_OBJECT (vbox), "box1", hbox);

  if(pix)
  {
     image = create_image(pix);
     g_object_ref(G_OBJECT(image));
     gtk_widget_show (image);
     gtk_box_pack_start(GTK_BOX(hbox), image, FALSE, FALSE, 0);
     gtk_box_set_spacing(GTK_BOX(hbox), 20);
  }

  if(label_string && strlen(label_string))
  {
     label = LABEL_BOLD(label_string, col, 1.05f);
     g_object_set_data(G_OBJECT (vbox), "label", label);
     gtk_widget_show (label);
     gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
     set_alignment (label, 0, 0.5);
  }
  else
     label = NULL;

  hbox = hbox_new(FALSE, 0);
  gtk_widget_show(hbox);
  g_object_set_data(G_OBJECT (vbox), "box2", hbox);
  if(mod == 'v')
     gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, TRUE, 0);
  else
     gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 0);

  entry = gtk_entry_new ();
  g_object_set_data(G_OBJECT (vbox), "entry", entry);
  gtk_widget_show (entry);
  gtk_box_pack_start(GTK_BOX(hbox), entry, TRUE, TRUE, 0);
  widget_modify_font(entry, fontdescU);
  widget_size_request(entry, &req);
  wid = req.width;
  if (label)
     gtk_label_set_mnemonic_widget(GTK_LABEL(label), entry);

  if(ifPreview)
  {
     if(MRabs(ifPreview) == 1)
        button = xpm_button("preview22.png");
     else
        button = xpm_button("edit.png");
     if(ifPreview > 0)
     {
     gtk_widget_show(button);
     gtk_box_pack_end (GTK_BOX (hbox), button, FALSE, FALSE, 0);
     }
     gtk_container_set_border_width (GTK_CONTAINER (button), 4);
     g_object_set_data(G_OBJECT (vbox), "preview", button);
     set_tip (button, "Click to preview");
     g_object_set_data(G_OBJECT (button), "entry", entry);
     widget_size_request(button, &req);
     gtk_widget_set_size_request(entry, wid, req.height-8);
  }

  gtk_editable_set_editable(GTK_EDITABLE(entry), TRUE);
  if(ifBrowse)
  {
//     button = gtk_button_new_with_label ("...");   //  gianluca 12 10 2004

     button = xpm_button("browse.png");
     gtk_widget_show (button);
     g_object_set_data(G_OBJECT (vbox), "browse", button);
     g_object_set_data(G_OBJECT (button), "entry", entry);
     g_object_set_data(G_OBJECT (button), "father", vbox);
     g_signal_connect(G_OBJECT (button), "clicked",
                         G_CALLBACK(change_dir), entry);
     g_signal_connect(G_OBJECT (button), "clicked",
                         G_CALLBACK(cb), data);
     gtk_box_pack_end (GTK_BOX (hbox), button, FALSE, FALSE, 0);
     gtk_container_set_border_width (GTK_CONTAINER (button), 4);
     set_tip (button, "Click to browse");
     gtk_editable_set_editable(GTK_EDITABLE(entry), FALSE);
     widget_size_request(button, &req);
     gtk_widget_set_size_request(entry, wid, req.height-8);
  }

  return vbox;
}

GtkWidget *label_boxed_medium (const gchar  *string)
{
    GtkWidget *frame, *label;

    frame = gtk_frame_new (NULL);
    gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_ETCHED_OUT);
    label = LABEL_BOLD_WITH_FONT (string, MSGCOLOR, 1.2f, fontdescU);
    set_alignment(label, 0.5, 0.5);
    gtk_label_set_justify (GTK_LABEL (label), GTK_JUSTIFY_CENTER);
    set_margins (label, 2, 2, 4, 4);
    set_label_color(label, MSGCOLOR);
    gtk_container_add (GTK_CONTAINER (frame), label);
    g_object_set_data(G_OBJECT(frame), "label", label);
    gtk_widget_show (label);
    gtk_widget_show (frame);
    return frame;
}

GtkWidget *label_boxed_big (const gchar  *string)
{
    GtkWidget *frame, *label;

    frame = gtk_frame_new (NULL);
    gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_ETCHED_OUT);
    label = LABEL_BOLD_WITH_FONT (string, MSGCOLOR, 1.2f, fontdescP);
    set_alignment (label, 0.5, 0.5);
    gtk_label_set_justify (GTK_LABEL (label), GTK_JUSTIFY_CENTER);
    set_margins (label, 2, 2, 4, 4);
    set_label_color(label, MSGCOLOR);
    gtk_container_add (GTK_CONTAINER (frame), label);
    g_object_set_data(G_OBJECT(frame), "label", label);
    gtk_widget_show (label);
    gtk_widget_show (frame);
    return frame;
}

void label_boxed_set_text (GtkWidget *frame, const gchar *string)
{
    GtkWidget *label;

    label = gtk_bin_get_child(GTK_BIN(frame));
    gtk_label_set_text(GTK_LABEL(label), toUTF8(string));
}

void cDrawLabels()
{
       drawlabels_();
       cflush_();
}

extern "C" void cambiabg_(int *col)
{
     dialogo->jBackGround = *col;
     dialogo->icoWire = 1 - dialogo->jBackGround;
     if (jscreen)
         change_bg("togbg", dialogo->jBackGround, 1);
}

GtkWidget *browser_dlg = NULL;
void system_browser(GtkWidget *item, gpointer data)
{
      char *string0;
      DlgItem it;

      string0 = g_new0(char, MaxLenFilename);
      ScriviStringa(string0, MaxLenFilename, "Starting Internet Browser on:\n %s%c%s.htm",
                main_app::TheApp.PkgDataDir().c_str(), G_DIR_SEPARATOR, MR_PACKAGE);

      if (browser_dlg == NULL)
      {
         it.format           = 1;
         it.title            = g_strdup_printf("Browser Info");
         it.nButtons         = 1;
         it.focus            = 1;
         it.image            = g_strdup_printf("helponline.png");
         it.text             = g_strdup_printf("%s", string0);
         it.label1           = g_strdup_printf("   _OK");
         it.image1           = g_strdup_printf("ok.png");
         it.cb_func1         = G_CALLBACK(close_dlg);
         it.cb_data1         = GINT_TO_POINTER(0);
         browser_dlg = create_dialog(finestre[0], &it);
      }
      gtk_widget_show_all (browser_dlg);
      gdk_window_raise (gtk_widget_get_window(browser_dlg));
      (void) g_timeout_add(12000, hide_dlg, browser_dlg);

      std::string urlname = main_app::TheApp.PkgDataDir() + G_DIR_SEPARATOR +  MR_PACKAGE + ".htm";
      URLOpen(urlname, main_app::TheApp.InternetBrowser(), finestre[0]);
}

void system_browser2(GtkWidget *item, gpointer data)
{
      char *string0;
      DlgItem it;

      std::string urlname =
           "http://www.ba.ic.cnr.it/softwareic/sir/";

      string0 = g_new0(char, MaxLenFilename);
      ScriviStringa(string0, MaxLenFilename, "Starting Internet Browser on:\n %s", urlname.c_str());
      //ScriviStringa(string0, MaxLenFilename, "Starting Internet Browser on:\n %s%c%s.htm",
      //          main_app::TheApp.PkgDataDir().c_str(), G_DIR_SEPARATOR, MR_PACKAGE);

      if (browser_dlg == NULL)
      {
         it.format           = 1;
         it.title            = g_strdup_printf("Browser Info");
         it.nButtons         = 1;
         it.focus            = 1;
         it.image            = g_strdup_printf("helponline.png");
         it.text             = g_strdup_printf("%s", string0);
         it.label1           = g_strdup_printf("   _OK");
         it.image1           = g_strdup_printf("ok.png");
         it.cb_func1         = G_CALLBACK(close_dlg);
         it.cb_data1         = GINT_TO_POINTER(0);
         browser_dlg = create_dialog(finestre[0], &it);
      }
      gtk_widget_show_all (browser_dlg);
      gdk_window_raise (gtk_widget_get_window(browser_dlg));
      (void) g_timeout_add(12000, hide_dlg, browser_dlg);

//      std::string urlname = main_app::TheApp.PkgDataDir() + G_DIR_SEPARATOR +  MR_PACKAGE + ".htm";
      URLOpen(urlname, main_app::TheApp.InternetBrowser(), finestre[0]);
}

void pdf_open(GtkWidget *item, gpointer data)
{
      std::string pdfname = "http://www.ba.ic.cnr.it/softwareic/sir/wp-content/uploads/sites/3/kalins-pdf/Sir2020.pdf";
      OpenPdf(pdfname, finestre[0]);
}

void open_htm(const char *filnam, const char *subdir)
{
      std::string urlname = "http://www.ba.ic.cnr.it/softwareic/sir/";
#if 0
      std::string urlname = main_app::TheApp.PkgDataDir() + G_DIR_SEPARATOR;
      if(!str_white(subdir))
      {
         urlname.append(subdir);
         urlname.append(G_DIR_SEPARATOR_S);
      }
      else
      {
         urlname.append("files");
         urlname.append(G_DIR_SEPARATOR_S);
      }
#endif
#ifndef MACOSX
      urlname.append(filnam);
#else
      std::string temp = filnam;
      size_t i = temp.find("#");
      if(i == std::string::npos)
         urlname.append(filnam);
      else
         urlname.append(temp.substr(0,i));
#endif
      URLOpen(urlname, main_app::TheApp.InternetBrowser(), finestre[0]);
}

void set_drag_cursor()
{
      GtkWidget *drawingarea = lookup_widget(mainwin, drawingareaname);
      gdk_window_set_cursor(gtk_widget_get_window(drawingarea), move_cursor);
}

void set_normal_cursor()
{
      GtkWidget *drawingarea = lookup_widget(mainwin, drawingareaname);
      gdk_window_set_cursor(gtk_widget_get_window(drawingarea),default_cursor);
}

void mr_restore_pixmap(void)
{
    GtkWidget *drawingarea;

    drawingarea = lookup_widget(finestre[0], drawingareaname);
    GdkWindow *outWindow = gtk_widget_get_window(drawingarea);
    gpointer outPix = get_object(drawingarea, "offscreen");
    gpointer context = get_object(drawingarea, "context");
    g_object_set_data(G_OBJECT(finestre[0]), "currentPixmap", outPix);
    g_object_set_data(G_OBJECT(finestre[0]), "currentWindow", outWindow);
    g_object_set_data(G_OBJECT(finestre[0]), "currentContext", context);
    set_clip(drawingarea, getCurrentContext());
}

void mr_send_viewer_pixmap(GtkWidget *win)
{
      GdkWindow *outWindow = gtk_widget_get_window(win);
      gpointer outPix = get_object(win,"offscreen");
      gpointer context = get_object(win,"context");
      g_object_set_data(G_OBJECT(finestre[0]), "currentPixmap", outPix);
      g_object_set_data(G_OBJECT(finestre[0]), "currentWindow", outWindow);
      g_object_set_data(G_OBJECT(finestre[0]), "currentContext", context);
      viewerOpened = TRUE;
      dialogo->viewerOpened = TRUE;
      set_clip(win, getCurrentContext());
}

#if 0
gboolean onViewer_configure_event     (GtkWidget       *widget,
                                       GdkEventConfigure *event,
                                       gpointer        data)
//                                       _Viewer          *view)
{
    _Viewer *view = (_Viewer *) data;
    gpointer pixmap;
    gpointer context;
    os_and_gc *rt;
    GtkAllocation allocation;
    gtk_widget_get_allocation(widget, &allocation);
    int x = (int)allocation.width;
    int y = (int)allocation.height;
//    static int wP=0;
    int wP = get_int(widget, "wP");
    if(wP == x)
       return TRUE;
    wP = x;

    if (get_object(widget, "context") != NULL)
        context = get_object(widget, "context");
    else
        context = NULL;
    if (get_object(widget, "offscreen") != NULL)
        pixmap = get_object(widget, "offscreen");
    else
        pixmap = NULL;

    destroy_os_and_gc(pixmap, context);
    rt = get_os_and_gc(widget);
    pixmap = rt->os;
    context = rt->gc;
    g_object_set_data(G_OBJECT(widget), "context", context);
    g_object_set_data( G_OBJECT(widget), "offscreen", pixmap);
    g_object_set_data( G_OBJECT(widget), "wP", GINT_TO_POINTER(wP));

    GdkColor colorWhite = White;
    set_foreground(context, &colorWhite);
    draw_rectangle (pixmap, context, TRUE, 0, 0,
                         (int)allocation.width,
                         (int)allocation.height);
    mr_send_viewer_pixmap(widget);

    if(view != NULL)
    {
       view->pix = pixmap;
       if(view->ifResize)
          view->cbResize(&x, &y);
    }
    return TRUE;
}

GtkWidget *CreateViewer(_Viewer *view)
{
  GtkWidget *window;
  GtkWidget *frame;
  GtkWidget *box1;
  GtkWidget *hbox;
  GtkWidget *button;
  GtkWidget *viewer;
 
//  window = gtk_dialog_new ();
  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  
  gtk_window_set_position (GTK_WINDOW(window), GTK_WIN_POS_MOUSE);
  (void) g_signal_connect (G_OBJECT (window), "destroy",
                      G_CALLBACK(destroy), NULL);
  gtk_window_set_title (GTK_WINDOW (window), view->title);
  gtk_container_set_border_width (GTK_CONTAINER (window), 0);
  gtk_window_set_resizable(GTK_WINDOW(window), view->ifResize);
//  box1 = GTK_DIALOG(window)->vbox;
  box1 = vbox_new(FALSE, 2);
  gtk_container_add(GTK_CONTAINER(window), box1);
  gtk_widget_show(box1);
  gtk_container_set_border_width(GTK_CONTAINER(box1), 6);
  
  if(view->ifResize)
  {
     frame = gtk_frame_new(NULL);
     gtk_widget_show (frame);
     gtk_box_pack_start (GTK_BOX (box1), frame, FALSE, FALSE, 0);

     hbox = hbox_new(FALSE, 0);
     gtk_widget_show (hbox);
     gtk_container_add (GTK_CONTAINER (frame), hbox);
  }

  /* Create the Drawable widget */
  viewer = gtk_drawing_area_new ();
  gtk_widget_set_size_request(viewer, view->width, view->height);
  gtk_box_pack_start (GTK_BOX (box1), viewer, TRUE, TRUE, 0);
  g_object_set_data(G_OBJECT(window), "viewer", viewer);
  g_object_set_data(G_OBJECT(viewer), "offscreen", NULL);
  g_object_set_data( G_OBJECT(viewer), "wP", GINT_TO_POINTER(0));
  view->widget = viewer;
  view->pix = NULL;
  (void) g_signal_connect (G_OBJECT (viewer), "configure_event",
                      G_CALLBACK (onViewer_configure_event),
                      (gpointer) view);
  (void) g_signal_connect (G_OBJECT (viewer), DRAW_EVENT,
                      G_CALLBACK (ManageExpose),
                      NULL);

  gtk_widget_show (viewer);

//  gtk_dialog_set_has_separator(GTK_DIALOG(window), FALSE);

  if(view->ifResize)
  {
     button = toolbar_button("zoom_in.png");
     gtk_widget_show (button);
     gtk_box_pack_start (GTK_BOX (hbox), button, FALSE, FALSE, 10);
     (void) g_signal_connect (G_OBJECT (button), "clicked",
                         G_CALLBACK(on_zoomin), view);
     set_tip (button, "Zoom In(+)");

     button = toolbar_button("zoom_out.png");
     gtk_widget_show (button);
     gtk_box_pack_start (GTK_BOX (hbox), button, FALSE, FALSE, 10);
     (void) g_signal_connect (G_OBJECT (button), "clicked",
                         G_CALLBACK(on_zoomout), view);
     set_tip (button, "Zoom Out(-)");

     button = toolbar_button("zoom_normal.png");
     gtk_widget_show (button);
     gtk_box_pack_start (GTK_BOX (hbox), button, FALSE, FALSE, 10);
     (void) g_signal_connect (G_OBJECT (button), "clicked",
                         G_CALLBACK(on_zoomnormal), view);
     set_tip (button, "Zoom Fit(Reset View)");

     button = toolbar_button("cancel.png");
     gtk_widget_show (button);
     gtk_box_pack_start (GTK_BOX (hbox), button, FALSE, FALSE, 10);
     (void) g_signal_connect (G_OBJECT (button), "clicked",
                         G_CALLBACK(on_close), view);
     set_tip (button, "Close Viewer");

     (void) g_signal_connect_swapped(G_OBJECT(window), "delete_event",
           G_CALLBACK(gtk_button_clicked), G_OBJECT(button)); 
  }
  else
     (void) g_signal_connect_swapped(G_OBJECT(window), "delete_event",
           G_CALLBACK(on_close), view);
  (void) g_signal_connect (G_OBJECT (window), "delete_event",
                      G_CALLBACK(true_cb), NULL);

  return window;
}

int nuovovisualizzatore1(int *action, int *x , int *y , int *ifRes, char *istring,
                         void (*cbResize)(int  *p1, int  *p2),
                         void (*cbZoom)(int  *p1))
{
  int Act = *action;
  _Viewer *view = g_new0(_Viewer, 1);

  if(!jscreen)
     return 0;

  if(single_it)
     while(gtk_events_pending())
         (void) gtk_main_iteration();

  GtkWidget *viewer_win = get_widget(finestre[0], "area_grafica2");
  switch(Act)
  {
  case 1:              // Open Viewer
  case 2:              // Open Viewer (compatibilita' con vecchio)
       if(!dialogo->viewerOpened)
       {
          view->title    = DuplicaStringa(istring);
          view->width    = -1;    //*x;
          view->height   = -1;    //*y;
          view->widget   = NULL;
          view->pix      = NULL;
          view->ifResize = *ifRes;
          view->cbResize = cbResize;
          view->cbZoom   = cbZoom;
          view->widget = viewer_win;
          if(view->ifResize)
          {
              int hnd = get_int(viewer_win, "hnd");
              if(hnd)
                 g_signal_handler_disconnect(G_OBJECT(viewer_win), hnd);
              hnd = g_signal_connect(G_OBJECT(viewer_win),  "configure_event",
                         G_CALLBACK (onView_configure_event), (gpointer) view);
              g_object_set_data(G_OBJECT(viewer_win), "hnd", GINT_TO_POINTER(hnd));
              g_object_set_data(G_OBJECT(viewer_win), "view", (gpointer) view);
          }
//          gtk_widget_set_size_request(viewer_win, *x, *y);
//          while(gtk_events_pending())
//            (void) gtk_main_iteration();
       }
  case 4:             // Restore Viewer
       mr_send_viewer_pixmap(viewer_win);
       break;

  case 3:              // Restore Main Window
       mr_restore_pixmap();
       break;
  case 5:              // Close Viewer
       mr_restore_pixmap();
       dialogo->viewerOpened = FALSE;
       break;
  }
  return 0;
}

int nuovovisualizzatore2(int *action, int *x , int *y , int *ifRes, char *istring,
                         void (*cbResize)(int  *p1, int  *p2),
                         void (*cbZoom)(int  *p1))
{
  static _Viewer view;
  int Act;
  static GtkWidget *my_dlg;
  GtkWidget *viewer_win;
  const char *string = DuplicaStringa(istring);

  Act = *action;

  if(!jscreen)
     return 0;
  if(single_it)
     while(gtk_events_pending())
         (void) gtk_main_iteration();
  switch(Act)
  {

  case 1:              // Open Viewer
  case 2:              // Open Viewer (compatibilita' con vecchio)

       if(!dialogo->viewerOpened)
       {
          view.title    = DuplicaStringa(string);
          view.width    = *x;
          view.height   = *y;
          view.widget   = NULL;
          view.pix      = NULL;
          view.ifResize = *ifRes;
          view.cbResize = cbResize;
          view.cbZoom   = cbZoom;
          my_dlg        = CreateViewer(&view);
          gtk_widget_show(my_dlg);
          //gdk_window_raise (my_dlg->window);
       }
       break;

  case 3:              // Restore Main Window

       mr_restore_pixmap();
       break;

  case 4:             // Restore Viewer

       if(my_dlg)
       {
          viewer_win = get_widget(my_dlg, "viewer");
          mr_send_viewer_pixmap(viewer_win);
       }
       else
       {
          MessageDialog("Programming Error", 0, 0, finestre[0], GTK_MESSAGE_ERROR,
                    GTK_BUTTONS_CLOSE, "Attempt to restore closed viewer");
          return -1;
       }
       break;

  case 5:              // Close Viewer
       
       if(GTK_IS_WIDGET(my_dlg))
           gtk_widget_destroy (my_dlg);
       my_dlg = NULL;
       viewer_window = NULL;
       dialogo->viewerOpened = FALSE;
       break;

  }
  return 0;
}

extern "C" 
{
int nuovovisualizzatore_(int *action, int *x , int *y , int *ifRes, char *istring,
                         void (*cbResize)(int  *p1, int  *p2),
                         void (*cbZoom)(int  *p1))
{
  if(!jscreen)
      return 0;
  GtkWidget *wid = get_widget(finestre[0], "area_messaggi");
  if(gtk_widget_get_visible(wid))
     return nuovovisualizzatore1(action, x , y , ifRes, istring,
                         cbResize, cbZoom);
  else
     return nuovovisualizzatore2(action, x , y , ifRes, istring,
                         cbResize, cbZoom);
}
#endif
     
extern "C" 
{
void abilita_runtb_(int statob[])
{
   gpointer button;

   if(jscreen == 0)
      return;
   button = get_object(finestre[0], "Viewer");
   obj_set_visible(button, (statob[0] >= 0));
   obj_set_sensitive(button, (statob[0]==1));
   button = get_object(finestre[0], "Skip");
   obj_set_visible(button, (statob[1] >= 0));
   obj_set_sensitive(button, (statob[1]==1));
   button = get_object(finestre[0], "SkiporStop");
   obj_set_visible(button, (statob[2] >= 0));
   obj_set_sensitive(button, (statob[2]==1));
   button = get_object(finestre[0], "jav");
   obj_set_visible(button, (statob[3] >= 0));
   obj_set_sensitive(button, (statob[3]==1));
}

void settoggleval_(const char *string, int *flag)
{
   int val;
   if(!jscreen)
      return;

   gpointer wid = get_object(finestre[0], string);
   if (wid == NULL)
       return;
   val = obj_get_active(wid);
   if(val != *flag)
      obj_set_active(wid, *flag);
}

}             //end extern "C"
void ResetConfiguration(GtkWidget *item, gpointer data)
{
   main_app::TheApp.CreaConfig();
   exit(0);
}

void open_about_sir(gpointer item, gpointer data)
{
    GtkWidget *main_window;

    main_window = finestre[0];
    main_app::TheApp.OpenAbout(main_window);
}

void open_khelp_sir (gpointer item, gpointer data)
{
   std::string fhelp = g_build_filename(main_app::TheApp.PkgDataDir().c_str(),
                                        main_app::TheApp.PkName(),
                                        NULL);
   fhelp.append(".kbd");
   open_khelp(finestre[0], fhelp);
}

int initGraphics()
{
   int result = main_app::TheApp.InitGraphics();
   if(result)
   {
      int flag = main_app::TheApp.AutoUpdate();
      if(flag)
      {
         int n;
         int res = main_app::TheApp.LastUpdate(finestre[0], true, &n, false);
         if(res > 0)
            g_print("It's time to update to %d.%2.2d version. Please download"
                    " it from http://wwwba.ic.cnr.it/\n",n/100, n%100);
      }
   }
   else
   {
   fontdescN = pango_font_description_from_string (main_app::TheApp.FontN().c_str());
   fontdescP = pango_font_description_from_string (main_app::TheApp.FontP().c_str());
   fontdescU = pango_font_description_from_string (main_app::TheApp.FontU().c_str());
   }
   return result;
}

float *get_fcolor(int new_color)
{
   return main_app::TheApp.getfCol(new_color);
}

const GdkColor blend_color(int col, float coef, speCol Colori[])
{
     guint16 r1, g1, b1;
     float Col[4];

     memcpy(Col, Colori[col], 4*sizeof(float));
     float flim = 0.9f;
     int red   = (int)(Col[0]*65535);
     int green = (int)(Col[1]*65535);
     int blue  = (int)(Col[2]*65535);

     r1 =  (guint16) MRblend(red,   65535, coef, flim);
     g1 =  (guint16) MRblend(green, 65535, coef, flim);
     b1 =  (guint16) MRblend(blue,  65535, coef, flim);

     const GdkColor c1 = {0, r1, g1, b1};
     return c1;
}

extern "C" void poligonosfumato_(int *numVert, int *iColore, int *nsh,
                                int *nshmax, int ixv[], int iyv[])
{
      if(!jscreen)
          return;
      gpointer outPix = getCurrentPix();
      gpointer context   = getCurrentContext();
      int nvert = *numVert;

      float coef = ((*nsh)-1)/(float) (*nshmax);
      GdkColor c1;
      c1 = blend_color(*iColore, coef, main_app::TheApp.app_color);
      set_foreground(context, &c1);
      GdkPoint *points = g_new0(GdkPoint, nvert);
      for (int np=0;np<nvert;np++)
      {
         points[np].x = ixv[np];
         points[np].y = iyv[np];
      }
      draw_polygon( outPix, context, TRUE, points, nvert );
      draw_polygon( outPix, context, FALSE, points, nvert );
      g_free(points);
}

void CheckForUpdates(GtkWidget *item, gpointer data)
{
      int n;
      int result = main_app::TheApp.LastUpdate(finestre[0], false, &n);
      int flag = main_app::TheApp.AutoUpdate();
      if(result > 0)
         UpdateCheck(finestre[0], result, &flag, 
               g_strdup_printf("%d.%2.2d", n/100, n%100));
      else
         UpdateCheck(finestre[0], result, &flag, MR_VERSION);
      main_app::TheApp.UpdateAutoU(flag);
}

#if 0
#ifdef _WIN32
#if WINVER >= 0x0602
#include <Processthreadsapi.h>
#endif
extern "C" void lanciash_(char *shell_script)
{
   if(jscreen)
   {
      PROCESS_INFORMATION procInfo = {0};
      STARTUPINFO startupInfo = {0};
      SECURITY_ATTRIBUTES saAttr = {0};
      HANDLE hStdIn  = GetStdHandle(STD_INPUT_HANDLE);
      HANDLE hStdOut = GetStdHandle(STD_OUTPUT_HANDLE);
      HANDLE hStdErr = GetStdHandle(STD_ERROR_HANDLE);
      std::string commandline;

      dir_set_current(g_path_get_dirname(shell_script));
      ChangeMode(shell_script, tXt);
      saAttr.nLength = sizeof(saAttr);
      saAttr.bInheritHandle = TRUE;
      saAttr.lpSecurityDescriptor = NULL;

      startupInfo.cb = sizeof(startupInfo);
      startupInfo.dwFlags = STARTF_USESTDHANDLES |  STARTF_USESHOWWINDOW;
      startupInfo.hStdInput = hStdIn;
      startupInfo.hStdOutput = hStdOut;
      startupInfo.hStdError = hStdErr;
      startupInfo.wShowWindow = SW_HIDE;
      commandline.assign ("cmd.exe /c \"");
      commandline.append(g_path_get_basename(shell_script));
      commandline.append("\"");

      wchar_t cmd[256];
      size_t l;
      mbstowcs_s(&l,cmd, commandline.c_str(),256);
      LPWSTR p = cmd;

      BOOL rc = CreateProcess(NULL, p, NULL, &saAttr, FALSE, 0, NULL, NULL,
          &startupInfo, &procInfo);
      if(!rc)
      {
         MessageDialog(finestre[0], GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
            g_strdup_printf( "CreateProcess failed (%d).\n", GetLastError()));
         return;
      }
      WaitForSingleObject( procInfo.hProcess, INFINITE );
      CloseHandle( procInfo.hProcess );
      CloseHandle( procInfo.hThread );
      return;
   }
 
   GError *error=NULL;
   dir_set_current(g_path_get_dirname(shell_script));
   ChangeMode(shell_script, tXt);
   std::string commandline;
   commandline.assign(g_path_get_basename(shell_script));
   g_spawn_command_line_sync(commandline.c_str(), NULL, NULL, NULL, &error);
   if(error)
      g_warning ("Error spawning file: %s", error->message);
}
#else
extern "C" void lanciash_(char *shell_script)
{
      GError *error=NULL;
      dir_set_current(g_path_get_dirname(shell_script));
      ChangeMode(shell_script, tXt);
      std::string commandline;
#ifdef _WIN32
      commandline.assign(g_path_get_basename(shell_script));
#else
      commandline.assign("./");
      commandline.append(g_path_get_basename(shell_script));
#endif
      g_spawn_command_line_sync(commandline.c_str(), NULL, NULL, NULL, &error);
      if(error)
         g_warning ("Error spawning file: %s", error->message);
}
#endif

extern "C" void lanciash_nowait_(char *shell_script)
{
      GError *error=NULL;
      dir_set_current(g_path_get_dirname(shell_script));
      ChangeMode(shell_script, tXt);
      std::string commandline;
#ifdef _WIN32
      commandline.assign(g_path_get_basename(shell_script));
#else
      commandline.assign("./");
      commandline.append(g_path_get_basename(shell_script));
#endif

//180514      g_spawn_command_line_async(shell_script, &error);
      g_spawn_command_line_async(commandline.c_str(), &error);
      if(error)
         g_warning ("Error spawning file: %s", error->message);
}

extern "C" void makeexec_(char *shell_script)
{
      ChangeMode(shell_script, tXt);
}
#endif

extern "C" void closeviewers_()
{
  close_sir_viewers();
}

static int action = 3;
static int vsele[MaxAtLSQ];

void end_list(GtkButton *button, gpointer data)
{
   GtkWidget *lista = get_widget(gtk_widget_get_toplevel(GTK_WIDGET(button)),
                             "scelte");

   get_selected_rownums(lista, vsele);

   action = GPOINTER_TO_INT(data);
   close_dlg(button, GINT_TO_POINTER(11));
   gtk_main_quit();
}

namespace GLextmr {
    void SelezionaAtomi(int whichModel, GList *atoms_to_sel);
    void set_children_status(gpointer item, gboolean active, GtkWidget *mw);
                  };
static void selected_peek(GtkTreeSelection  *sele, gpointer data)
{
using namespace GLextmr;
     GtkTreeView *tree_view;

     tree_view = gtk_tree_selection_get_tree_view(sele);
     GList *rowsel = NULL, *atoms_to_sel=NULL;
     rowsel = get_selections(GTK_WIDGET(tree_view));
     if(rowsel)
     {
        int num_sel = g_list_length(rowsel);
        for(int i=0; i<num_sel; i++)
        {
             GtkTreePath *path = (GtkTreePath *) g_list_nth_data (rowsel, i);
             gpointer riga =
                 get_selection_from_pathC(tree_view, path, 0);
             atoms_to_sel = g_list_append(atoms_to_sel, riga);
        }
        g_list_foreach (rowsel, (GFunc)gtk_tree_path_free, NULL);
        g_list_free (rowsel);
     }
     SelezionaAtomi(0, atoms_to_sel);
     g_list_free (atoms_to_sel);
}

GtkWidget *create_newpeeklist (int sel_mode, char *string, int natsOld)
{
  GtkWidget *label, *button;

  GtkWidget *window = gtk_dialog_new();
  gtk_container_set_border_width(GTK_CONTAINER(window), 6);

  int lar, alt;
  PangoFontDescription *fontlist = get_fontN(MONOSPACE_FONT);
  get_metrics(fontlist, &lar, &alt);
  GtkWidget *parentbox = gtk_dialog_get_content_area(GTK_DIALOG(window));
  if(string && (strlen(string) > 1))
  {
     label = label_boxed(string);
     set_alignment (gtk_bin_get_child(GTK_BIN(label)), 0.5, 0.5);
     gtk_widget_show(label);
     gtk_box_pack_start(GTK_BOX(parentbox), label, FALSE, FALSE, 0);
  }

  const char *titles[] = { "Number", "Label", "Intensity",
                           "Minimum distance", "From"};
  GType types[] = { G_TYPE_INT, G_TYPE_STRING, G_TYPE_INT,
                    G_TYPE_FLOAT,  G_TYPE_STRING};
  int  sizes[] = { -1, 0, 0, 0, 0};
  int precs[] = { 0, 0, 0, 3, 0};

  int ncol = (int)(sizeof(sizes)/sizeof(sizes[0]));
  GtkWidget *list =
  new_selection(window, parentbox, "scelte", ncol, titles, sizes, types, precs);
  widget_modify_font(list, fontlist);
  g_object_set_data(G_OBJECT(list), "alt", GINT_TO_POINTER(alt));
  for(int i=0; i<ncol; i++)
  {
      GtkTreeViewColumn *column = gtk_tree_view_get_column(GTK_TREE_VIEW(list), i);
      label = gtk_tree_view_column_get_widget(column);
      if(label)
         widget_modify_font(label, fontlist);
  }
  GtkTreeSelection *selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(list));
  if(sel_mode)
     set_selection_mode(list, GTK_SELECTION_MULTIPLE);
  else
     set_selection_mode(list, GTK_SELECTION_SINGLE);

  int hnd = g_signal_connect (G_OBJECT (selection), "changed",
                      G_CALLBACK (selected_peek), NULL);
  g_object_set_data(G_OBJECT(selection), "hnd", GINT_TO_POINTER(hnd));
  g_object_set_data(G_OBJECT(list), "hnd", GINT_TO_POINTER(hnd));

  button = OK_button();
  gtk_dialog_add_action_widget (GTK_DIALOG (window), button, 1);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
         GTK_BUTTONBOX_SPREAD);
  (void) g_signal_connect(G_OBJECT(button), "clicked",
          G_CALLBACK(end_list), GINT_TO_POINTER(1));

  button = myimage_button("   _All", "all.png");
  gtk_dialog_add_action_widget (GTK_DIALOG (window), button, 2);
  (void) g_signal_connect(G_OBJECT(button), "clicked",
          G_CALLBACK(end_list), GINT_TO_POINTER(2));

  button =  CANCEL_button();
  gtk_dialog_add_action_widget (GTK_DIALOG (window), button, 3);
  (void) g_signal_connect(G_OBJECT(button), "clicked",
          G_CALLBACK(end_list), GINT_TO_POINTER(3));

  (void) g_signal_connect_swapped(G_OBJECT(window), "delete_event",
          G_CALLBACK(gtk_button_clicked), G_OBJECT(button));
  (void) g_signal_connect (G_OBJECT (window), "delete_event",
                      G_CALLBACK(true_cb), NULL);

  gtk_window_set_transient_for(GTK_WINDOW(window), GTK_WINDOW(finestre[0]));
  return window;
}

void FillList1(GtkTreeView *list, int nc, int natsOld, atom_type *atm, 
               float mindistv[], int kminv[])
{
  GtkTreeIter iter;
  int alt = get_int(GTK_WIDGET(list), "alt");
  GtkListStore *list_store = GTK_LIST_STORE(gtk_tree_view_get_model(list));
  GtkTreeSelection *selection = gtk_tree_view_get_selection(list);
  int hnd = get_int(GTK_WIDGET(list), "hnd");
  if(hnd)
     g_signal_handler_block(G_OBJECT(selection), hnd);
  gtk_list_store_clear(GTK_LIST_STORE(list_store));
  gtk_widget_set_size_request(get_widget(GTK_WIDGET(list), "scrollwin"), -1, MRmin(2*(nc+1)*alt, 10*alt));
  for(int i=0; i<nc; i++)
  {
      int iat = natsOld + i;
//corr      int kat = kminv[i];
      int kat = kminv[i]-1;
//      char *label1 = g_strdup(atm[iat].lab);
//      char *label2 = g_strdup(atm[kat].lab);
      char *label1 = g_new0(char, 17);
      char *label2 = g_new0(char, 17);
      CopiaStringan(label1, 17, atm[iat].lab, 16);
      CopiaStringan(label2, 17, atm[kat].lab, 16);

      gtk_list_store_append (list_store, &iter);
      gtk_list_store_set (list_store, &iter,
              0, iat,
              1, g_strstrip(label1), 
              2, (int) atm[iat].inte,
              3, mindistv[i], 
              4, g_strstrip(label2), -1);
  }
  if(hnd)
     g_signal_handler_unblock(G_OBJECT(selection), hnd);
}

void open_newpeeklist(char *Inte, int NumCan, int *MultiSel, int sel[],
                  int *iExitC, int natsOld, char *Msg, 
                  atom_type *atm, float mindistv[], int kminv[])
{
   int i;
   GtkWidget *list, *dialog;

   action = 3;
   for(i=0; i<NumCan; i++)
       vsele[i] = sel[i];

   dialog = create_newpeeklist(*MultiSel, Msg, natsOld);
   gtk_window_set_title (GTK_WINDOW (dialog), Inte);
   list = lookup_widget(dialog, "scelte");
   FillList1(GTK_TREE_VIEW(list), NumCan, natsOld, atm, mindistv, kminv);

   gtk_widget_show_all(dialog);
   finestra_modale_aperta2(dialog);
   can_drag = FALSE;
   gtk_main();
   can_drag = TRUE;
   *iExitC = action;
   for(i=0; i<NumCan; i++)
       sel[i] = vsele[i];
}

extern "C" void c_newpeeklist_(char *Inte, int *NumCan, int *MultiSel, int sel[],
                  int *iExitC, int *natsOld, char *Msg, 
                  atom_type *atml, float mindistv[], int kminv[])
{
   fine_lavoro();
   int Nats = *natsOld + (*NumCan);
   atom_type *atm = g_new0(atom_type, Nats);
   memcpy(atm, atml, Nats*sizeof(atom_type));
   open_newpeeklist (Inte, *NumCan, MultiSel, sel, iExitC, 
                     *natsOld, Msg, atm, mindistv, kminv);
   g_free(atm);
}

extern "C" void minimizza_(int *flag)
{
   iconified = !(*flag);
   if(*flag)
   {
      gtk_window_deiconify(GTK_WINDOW(finestre[0]));
       MessageDialog("Info", 10, 0, finestre[0], GTK_MESSAGE_INFO, GTK_BUTTONS_CLOSE, "ok");
      //gtk_widget_show(finestre[0]);
   }
   else
      gtk_window_iconify(GTK_WINDOW(finestre[0]));
      //gtk_widget_hide(finestre[0]);
      //g_print("iconified = %s\n", iconified?"yes":"no");
}

