MODULE javinterface
   implicit none

   integer, parameter :: PRESENTNZ = 1   !! -1

   CONTAINS

!-----------------------------------------------------------------------
      subroutine fromModelToAtom(atom)
      USE RemoModule
      USE atom_basic
      USE sinterface, only: bij_atom
      USE General, only: celem
      USE variables, only: atm
!
      implicit none
      type(atom_type), dimension(:) :: atom
      integer nats, i, j, k, ii
!
      nats = size(atom) !! natsInModel(WhichModel) !!size(atom)
      ii = 0
      do k=1, 1 ! MonomerInModel(WhichModel)
         do i=1, nats
            ii = ii + 1
            j = InfoOnModels(WhichModel)%iEqui(i)
            atom(ii)%xc(1:3) = model(WhichModel)%atoms(1:3,i,k)
            atom(ii)%biso    = model(WhichModel)%th_fact(j,k)
            atom(ii)%bij(1:6)= bij_atom(model(WhichModel)%bij(1:6,i,k))
            atom(ii)%och     = 1
            atom(ii)%inte    = model(WhichModel)%atoms(4,i,k)
            atom(ii)%ocry    = model(WhichModel)%atoms(5,i,k)
!corr            atom(ii)%nz      = model(WhichModel)%specie(j,k) ! * nzConst  gianluca 01/11/2012
            call atom(ii)%set_specie(model(WhichModel)%specie(j,k),celem)
            atom(ii)%lab     = model(WhichModel)%Label(j)
            atom(ii)%rcod(:) = 0
         enddo
      enddo
!
      if (numatoms(atm) == nats) then
          atom%chain = atm%chain
      endif
!
      return
      end subroutine fromModelToAtom

!-----------------------------------------------------------------------
      subroutine real_jav_passa_modello(atom,legm,elem,spg,numAu,nlegs_au,km, nm, flag_resize)
      USE General, only: slash, cardImage, ifLigand, PDBfile, FichierOut
      USE Dialogo, only:iPlotType
      USE connect_mod
      USE Atomi, only:nzConst
      USE atom_type_util
      USE Molcom, only:  BTot
      USE RemoModule    !!, only: WhichModel
      USE elements
      USE spginfom
!
      type(atom_type), dimension(:), allocatable, intent(in)    :: atom
      type(bond_type), dimension(:), allocatable, intent(in)    :: legm
      type(element_type), dimension(:), allocatable, intent(in) :: elem
      type(spaceg_type), intent(in)                             :: spg
      integer                                                   :: natom
      integer                                                   :: numlegs        
      integer                                                   :: nelem        
      integer                                                   :: icent        
      integer                                                   :: km, nm
      integer                                                   :: numAu
      integer                                                   :: nlegs_au
      integer                                                   :: jPlotType
      real                                                      :: B(3, 3)
      integer                                                   :: L1, L2, Lung
      integer                                                   :: flag_resize
      type(atom_type), dimension(1)                             :: at0
      type(bond_type), dimension(1)                             :: b0
!     
      natom = numatoms(atom)
      numlegs = numbonds(legm)
      nelem = numelem(elem)
      if (spg%symcent == 1) then
          icent = 1
      else
          icent = 0
      endif

      if (ifLigand /= 0) then
          if (km == 1) then        ! ligand
              L1 = index(PDBfile, slash, .TRUE.)
              if (L1 > 0) then
                  L1 = L1 + 1
              else
                  L1 = 1
              endif
              L2 = Lung(PDBfile)
!!mr              cardImage = PDBfile(L1:L2) // char(0)
              cardImage = PDBfile(1:L2) // char(0)
              L1 = 0                ! ifPDB
          else
              L1 = index(FichierOut, slash, .TRUE.)
              if (L1 > 0) then
                  L1 = L1 + 1
              else
                  L1 = 1
              endif
              L2 = Lung(FichierOut)
!!mr              cardImage = FichierOut(L1:L2) // char(0)
              cardImage = FichierOut(1:L2) // char(0)
              L1 = 1                ! ifPDB
          endif

      else
              cardImage = char(0)
              if (.not.allocated(Model)) then
!!!!corrado - crash if numbModels is == 0 - chiedere a Gianluca
                  if (numbModels == 0) numbModels = 1
!!!!corrado
                  call AllocaModelRemo(0)
                  WhichModel = 1
                  natsInModel(WhichModel) = natom
                  call AllocaModelRemo(1)
                  Model(WhichModel)%PDB = 0
              endif
              L1 = Model(WhichModel)%PDB
      endif

      jPlotType = 5            !! Stick and balls
      select case(iPlotType)
        case (1)
              jPlotType = 1
        case (2)
              jPlotType = 4
        case (3)
              jPlotType = 2
        case (4)
        case (5)
        case (6)
              jPlotType = 5
        case (7)
              jPlotType = 7
        case (8)
              jPlotType = 6
      end select
      call Set_Style(jPlotType, km)
      B(:,:) = BTot(:,:)
      if(flag_resize == 1) then
         call Set_UseDefaultB(B)
      endif
!
      if (ifLigand == 0) then
          if (natom == 0) then
              call PassaModelloJav(at0, b0,natom,numAu, numlegs, nlegs_au, &
                        elem, nelem, icent, &
                        nm, km, L1, cardImage,  flag_resize, Model(whichModel)%HETA)
          else
              if (numlegs == 0) then
                  call PassaModelloJav(atom, b0,natom,numAu, numlegs, nlegs_au, &
                        elem, nelem, icent, &
                        nm, km, L1, cardImage,  flag_resize, Model(whichModel)%HETA)
              else
                  call PassaModelloJav(atom,legm,natom,numAu, numlegs, nlegs_au, &
                        elem, nelem, icent, &
                        nm, km, L1, cardImage,  flag_resize, Model(whichModel)%HETA)
              endif
          endif
      else
          if (natom == 0) then
              call PassaModelloJav(at0, b0,  natom, numau, numlegs, nlegs_Au, &
                        elem, nelem, icent, &
                        nm, km, L1, cardImage,  flag_resize, Model(whichModel)%HETA)
          else
              if (numlegs == 0) then
                 call PassaModelloJav(atom, b0,  natom, numAu, numlegs, nlegs_au, &
                        elem, nelem, icent, &
                        nm, km, L1, cardImage,  flag_resize, Model(whichModel)%HETA)
              else
                  call PassaModelloJav(atom,legm,natom,numAu, numlegs, nlegs_au, &
                        elem, nelem, icent, &
                        nm, km, L1, cardImage,  flag_resize, Model(whichModel)%HETA)
              endif
          endif
      endif
!
      end subroutine real_jav_passa_modello
!----------------------------------------------------------------------

      subroutine NonUsatajav_get_bij(i, cbij)
      USE RemoModule
!
      implicit none
      integer            :: i, j, k
      real               :: cbij(6)
!
      j = InfoOnModels(WhichModel)%iEqui(i)
      do k=1, 6
         cbij(k) = model(WhichModel)%bij(k, j, 1)
      end do
!
      end subroutine NonUsatajav_get_bij
!-----------------------------------------------------------------------
      subroutine NonUsataSetActiveModel(Which)
      USE RemoModule, only: WhichModel
      implicit none
      integer  :: Which
!
      WhichModel = Which
!
      end subroutine NonUsataSetActiveModel
!-----------------------------------------------------------------------

END MODULE javinterface

