!-----------------------------------------------------------------------
      MODULE RfacMatrixModule
           integer :: nRfacMatrix, nRfacMatrixBl, nRfacSav, nolsqSav
           real    :: fomBestSav
           real    :: erreBestSav
           real    :: TrBestfomSav
           real    :: TrerreBestSav
           real, allocatable    :: RfacMatrix(:,:,:) ! (8,500,30) 
           real, allocatable    :: RfacMatrixSav(:,:,:) 
      END MODULE RfacMatrixModule
!-----------------------------------------------------------------------
      MODULE RelaxMod
           integer :: ksizeSav, nreflSav, nreflDimSav, numbInvSav
           integer :: numbLSQSav, natmSav, lattSav, jsysSav
           integer :: ifExpandedSav, nrefltotSav
           real    :: tlsav(12), fsSav(216)
           real    :: ValCritici(5,2)
           real    :: EpsCritici = 0.05
           logical :: LoadedPhases = .false.
           integer, allocatable :: FasiRelax(:)
           real,    allocatable :: PesiRelax(:)
           real    :: Rap_Picchi(3)
           real    :: BestFomChe   !pg201213
           real    :: Best_Tra(3)
      END MODULE RelaxMod

!-----------------------------------------------------------------------
      MODULE Align
         PARAMETER(ndimAlign=6000)
         integer :: ifAli = 0
         integer :: NumberAminoAcids = 23
         integer :: numbInRes(23)
         integer :: numbRes
         integer :: nseq1, nseq2, nseq2True, nAllinea
         integer :: nseqTotTarget, nseqTotModel
         integer :: imut(23,23)
         integer :: j2i(ndimAlign), j2i_loc(ndimAlign)
         integer :: jumpRes = 0
         integer :: numeroCA = 99999
         integer :: nMutations = 0
         integer :: testProc = 0
         integer :: nCateneTarget, CateneTarget(100)
         integer :: nCateneModel, CateneModel(100)
         integer :: L_id, L_ali
         real    :: gap_open, gap_extn
         real    :: SeqId
         logical :: paused = .false.
         character (len=1) :: AminoCode1(23)
         character (len=3) :: AminoCode3(23)
         character (len=256) :: CCP4map
         character (len=256) :: AliFile
         integer, allocatable :: seq1(:), seq2(:), seqR(:,:)
         integer, allocatable :: TableM(:,:)
         integer, allocatable :: idir(:,:)
         integer, allocatable :: jpV(:,:)
         integer, allocatable :: jpH(:,:)
         integer, allocatable :: idirH(:,:)
         integer, allocatable :: idirV(:,:)
         integer, allocatable :: vettCA(:)
         integer, allocatable :: countCoot(:)
         integer, allocatable :: toMutate(:), newResid(:), from(:)
         integer, allocatable :: CAtoMutate(:)
         integer, allocatable :: BufferAll(:)
         real, allocatable :: score(:,:)
         real, allocatable :: val(:,:)
         real, allocatable :: preV(:,:)
         real, allocatable :: preH(:,:)
         real, allocatable :: preD(:,:)
         character(len=1) , allocatable :: sequenceA(:)
         character(len=1) , allocatable :: sequenceB(:)
         character(len=1) , allocatable :: sequenceM(:)
         character (len=1), allocatable :: vettCatena(:)
         character (len=1), allocatable :: CSecondary(:)
      END MODULE Align
! ---------------------------------------------------------------------
      MODULE AutoLabelMod
             integer   :: idrogeno, ossigeno, ispecie, nSpecies
             integer   :: SpeciesVet(18), vAnions(40), nAnions(18)
             integer   :: nCyclesAuto
             real      :: dmin, dmax, distVal(2,0:18), distAnions(40)
             real      :: cdista(18), ldista(18), ctolle(18), ltolle(18)
      END MODULE AutoLabelMod
! ----------------------------------------------------------------------
      MODULE FastPlot
          integer :: ix1(10000),iy1(10000),  ix2(10000),  iy2(10000)
          integer :: ix3(10000),iy3(10000),nCol1(10000),nCol2(10000)
          integer :: nFastPlot = 10000
      END MODULE FastPlot
! ----------------------------------------------------------------------
      MODULE Tutto
           integer, allocatable :: iwork11(:)
           integer, allocatable :: iphaz11(:)
           real, allocatable    :: wt11(:)
           real                 :: prevFinalFom
           real                 :: sommfF = 0.0
           real                 :: sommfF2 = 0.0
           real                 :: p_fFom = 0.0
           integer              :: nRelax = 0
           
           real                 :: sommfFOM = 0.0
           real                 :: sommfFOM2 = 0.0
           real                 :: sog_fFom = 0.0
           integer              :: nMigliora = 0
      END MODULE Tutto
! ----------------------------------------------------------------------
      MODULE VLDmod
          integer :: firstTime, nCycleVLD
          integer :: nTrialsVLD, nIterVLD, ifVLDdirect, cicloBestVLD
          real    :: erreBestVLD, abs_erreBestVLD, fomBestVLD
          real    :: correBestVLD
          integer :: kverbo_pg
          integer :: ifRaffiRelax  ! Dedi per envelope
          integer :: ifIbrida !  per DEDM ibrida
          real    :: Tau
          real    :: Omega
          integer :: ifScriviCicloVLD
          integer :: ifTuttiCarboni, n_EDM, n_cicli, ifContrLab
          integer :: nPrCy, n_cb, n_Maxrun, n_abi_model
          integer :: nPreviousTrials = 0
          integer :: numbrunTot = 0
          integer :: ifOrigPerm = 0
          integer :: ntang
          integer :: ifRiscala
          real    :: sog_sigmaA, Sog_PrCy, sog_ref
          real    :: SC_alfa_np1
          real , allocatable :: FasiPesiFcVLD(:,:)
          real , allocatable :: rvetVLD(:)
          real   :: sigmaAmed

          logical :: ifPrimaEDMg = .false.
          logical :: ifPrimoVld = .true., entra = .true.
          real    :: ffomV=0., ffomH=0., finalfomIter=0.
          real    :: varg1=0., varg2=0., varg3=0., varg4=1., varg5=1.
          integer :: ivarg1=0, ivarg2=0, ivarg3=0, ivarg4=1, ivarg5=1
          integer :: ivarg6=0, ivarg7=0
          
          integer :: ripetibilita=1     !rst

      END MODULE VLDmod
! ----------------------------------------------------------------------
      MODULE VLDmod_1
      real, allocatable :: SigmaN(:)
      real, allocatable :: es(:)
      integer :: ksigma_pg
      END MODULE VLDmod_1      
!-----------------------------------------------------------------------
      MODULE VLDmod_2
      real, allocatable :: Ep(:)
      real, allocatable :: Eq(:)
      real, allocatable :: Eqp(:)
      real, allocatable :: Eqp_ist(:)

      real, allocatable :: Eq_s(:)

      real, allocatable :: Epp(:)
      real, allocatable :: EqVero(:)
      real, allocatable :: ArgGq(:)
      real, allocatable :: sgq(:)
      real, allocatable :: wq(:)
      real, allocatable :: WT_save(:)
      real, allocatable :: WT_save_m(:)
      real, allocatable :: wq1_1(:)
      real, allocatable :: wq1_2(:)
      real, allocatable :: wq1_3(:)
      real, allocatable :: wq1_a(:)
      real, allocatable :: wq1_b(:)
      real, allocatable :: wq1_c(:)
      real, allocatable :: wq2(:)
      real, allocatable :: wq3(:)
      real, allocatable :: wq4(:)
      real, allocatable :: wq2_a(:)
      real, allocatable :: wq2_b(:)
      real, allocatable :: wq2_c(:)
      real, allocatable :: wq2_d(:)
      real, allocatable :: wq2_e(:)
      real, allocatable :: EossEcal(:)
      real, allocatable :: dijs(:)
      real, allocatable :: xmapSav_VLD(:,:,:)
      real, allocatable :: work22(:)
      real, allocatable :: work1_res(:)
      real, allocatable :: WT_save_res(:)
      real, allocatable :: WT_work3(:)
      real, allocatable :: WT_work4(:)
      integer, allocatable :: PHIp(:)
      integer, allocatable :: PHIp_diff(:)
      integer, allocatable :: PHIq(:)
      integer, allocatable :: PHIq_s(:)
      integer, allocatable :: PHIqp(:)
      integer, allocatable :: PHIqVero(:)
      integer, allocatable :: ichange_sym(:)
      integer, allocatable :: jorde(:)
      integer, allocatable :: iphaz_res(:)
      integer, allocatable :: WT_work5(:)
!20diccharacter*2, allocatable :: caso(:)
!20diccharacter*2, allocatable :: caso_ac(:)
      END MODULE VLDmod_2
!-----------------------------------------------------------------------
      MODULE VLDmod_3
      real :: amed_Dl
      real :: amed_Dl_orig
      real :: fattore
      real :: rfac_init
      real :: rfac_10EDM
      real :: amedia_n_edm
      real :: sigmaA_init
      real :: rfac_init_edm
      real :: sigmaA_init_BestVLD
      real :: rfac_init_edm_BestVLD
      real :: rfac_edm_min
      real :: rfac_edm
      real :: Rat_VLD
      real :: t0_edm
      real :: t1_edm
      real :: t0_dlsq
      real :: t1_dlsq
      real :: t0_raffi
      real :: t1_raffi
      real :: time_tot_edm
      real :: time_tot_dlsq
      real :: time_tot_raffi
      real :: time_tot_postdsr
      real :: perc_cammino_control
      real :: perc_cammino_rat
      real :: pesmod_med
      real :: sigmaA_1
      real :: FinalFom2
      real :: stopFinalFom2
      real :: tperc
      real :: amed_Dl_orig_init
      integer :: nPROTdir
      integer :: numero_cicli
      integer :: num_tot_edm
      integer :: numero_edm
      integer :: numero_edm_finale  !formula20
      integer :: num_rfac_edm_min
      integer :: num_model_edm_min
      integer :: num_tot_raffi
      integer :: num_tot_dlsq
      integer :: ifTiDeviFermare
      integer :: n_edm_save
      integer :: naatoms_max
      integer :: numero_cicli_max
      integer :: numbrun_max
      integer :: nSeedDLSQ
      integer :: nSeedRelax 
      integer :: ncon1tot
      integer :: ncon2tot
      integer :: ncon3tot
      integer :: ncon4tot
      integer :: ncon5tot
      integer :: ncon6tot
      integer :: ncon1tot_ncs
      integer :: ncon2tot_ncs
      integer :: ncon3tot_ncs
      integer :: ncon4tot_ncs
      integer :: ncon5tot_ncs
      integer :: ncon6tot_ncs
      integer :: ncon7tot_ncs
      integer :: ncon8tot_ncs
      integer :: kSavMDM
      integer :: ifForm20
!pg27012014
      character (len=80) :: line_EDM
      END MODULE VLDmod_3
! ----------------------------------------------------------------------
      MODULE Direttive
          integer :: icomq(200,2)
          integer :: maxcom = 200
          integer :: ipcom
          integer :: ipdir
          integer :: icomat
          integer :: ivet(40)
          real    :: vet(40)
          common /comdir/ icomq, maxcom, ipcom, ipdir, icomat
      END MODULE Direttive
! ----------------------------------------------------------------------
!     MODULE SAmodule
!         real    :: cellaFrag(6)
!         real    :: traslaVetSA(3)
!     END MODULE SAmodule
! ----------------------------------------------------------------------
      MODULE DataModule
          integer :: ifPlotSpots = 0
          integer :: noSpaceGroup = 0
          integer :: ifContSuppl
          integer :: nrec, lproh, lprok, lprol
          integer :: vsym(24), ibrav(6,13), klatt, ksym
          real    :: bfacPDB, wave
          integer :: ifWeight
          integer :: Moltiplica(18)
          real    :: WeightSuppl, WeightInp
      END MODULE DataModule
! ----------------------------------------------------------------------
      MODULE Laue
!     common/LaueGr/ 
          integer :: LaMat(24,3,3)
          integer :: nlinea(9)
          integer :: matini(5)
          integer :: matfin(5)
          integer :: numequiv(6,24)
          real    :: rint(6)
*gl*      real    :: perce(6)
          real    :: fomed(6)
          integer :: nindep(6)
          integer :: nLaMat(6)
          real    :: rintw(12)
          real    :: rintequi(6,24)
          real    :: diff(6,24)
          real    :: fome(6,24)
          real    :: ProbL(6)
          integer :: nordmat(5,96)
          integer :: nrefsing(6)
          real    :: percssf
          real    :: percmin
          real    :: epsmed(9,5,27)
!     common/dummy/
          real    :: tab(13,8,6)
          real    :: tfo,tsfo
          real    :: tfosfo
          integer :: lh,lk,ll
          real    :: fo
          real    :: sfo
          real    :: weigg
          integer :: msys
          integer :: numcond(13)
          integer :: ncont(13)
          integer :: nocond(13)
          integer :: isolu(30)
          real    :: tabnew(13,8)  
          integer :: lsolu(30)
          real    :: foclass(13)
          integer :: ipow
          real    :: rhosog
          integer :: nrefus
          real    :: tabfomax(13,8,2)
          integer :: numcond0(13)
          real    :: wclass(13)
          integer :: nEsure(13,8)
          real , allocatable :: valEsure(:,:,:)
          real    :: Esure(13,8)
!     common/dumm4/
          character (len=3) :: lasymb(8)
          character (len=16) :: exsymb(200)
          integer :: itabsy(9,8,200)
          character (len=12) :: lauecl(14)
!     common/dumm5/
          integer :: nclassLa
          integer :: nume
          integer :: nume2
          real    :: fmersg(2000)
          integer :: nindexx(2000)
          integer :: nindla(2000)
          integer :: nindlacl(2000)
!     common/dummx/
          character (len=8)  :: stab(13)
          character (len=12) :: nsolu(30)
          character (len=18) :: scond(13,8)
          character (len=18) :: scond2(13,8)
          character (len=18) :: symope(50)
          character (len=18) :: riga
!      common/lauelinea/
          character (len=16) :: linea(30)
!
          integer :: msysgeom
!
          character (len=80) :: spgtxt
      END MODULE Laue
! ----------------------------------------------------------------------
      MODULE Migliore
             integer              :: nBest = 0
             integer              :: maxBest, doBest
             real                 :: scaled, vettFoSig(2,48)
             integer, allocatable :: indBest(:), numBest(:)
             real, allocatable    :: matFoSig(:,:,:)
      END MODULE Migliore
! ----------------------------------------------------------------------
      MODULE HydroStuff
!
             integer              :: MaxAtomsH
             integer, allocatable :: ibridc(:)
             integer, allocatable :: lconlun(:,:)
             integer, allocatable :: nhyold(:)
             real, allocatable    :: chdist(:)
             integer, allocatable :: idisorder(:)
             integer, allocatable :: ibtab(:,:)
             real,    allocatable :: hibtab(:,:)
             integer              :: jdisor
!--genhy
             common/xhidro/nameHy,nserialH,distch,ionly,iup
!
      TYPE infohydro_type
              integer            :: nlegati
              integer            :: ibcal
              integer            :: nHybcal
              integer            :: nHydcal
              integer            :: nHybut
              integer            :: nHydut
              character (len=17) :: lab
      END TYPE infohydro_type
      TYPE(infohydro_type), allocatable   :: HydroInfo(:)
!
      END MODULE HydroStuff
! ----------------------------------------------------------------------
      MODULE PolyStuff
             integer, allocatable :: ixx1(:)
             integer, allocatable :: iyy1(:)
             integer, allocatable :: ixx2(:)
             integer, allocatable :: iyy2(:)
             integer, allocatable :: ixx3(:)
             integer, allocatable :: iyy3(:)
             integer, allocatable :: nCol1(:)
             integer, allocatable :: nCol2(:)
      END MODULE PolyStuff
! ----------------------------------------------------------------------
      MODULE ShellSIGMAA
             real,     allocatable   :: midpts(:)
             integer,  allocatable   :: RES_TAG(:)
             integer                 :: Nbin
             real                    :: sigma_media
             real                    :: sigmaAshell2(100),
     +                                  sigmaAshell2_l(100),
     +                                  EomShell(100,6),EcmShell(100,6),
     +                                  ddocm(100), acoeff, bcoeff 
             real,     allocatable   :: Eo2Ec2Mean(:)                   !pgVLD
             real,     allocatable   :: argBess(:)                      !ligand
      END MODULE ShellSIGMAA
! ----------------------------------------------------------------------
      MODULE LsqStuff
!
!-- Caos Least Squares ( /lsqc/, /lsqg/ )
!
             integer              :: CodeEquiv
             integer              :: CodeWeight
             integer              :: CodeGroup
             integer              :: NumBlockTot = 1
             integer              :: NumOggettiMax
             integer              :: NumGroup = 0
             integer              :: NumRota = 0
             integer              :: nPar15 = 11
             integer              :: nParMax = 15
             integer              :: ifGroupRefined(100)
             integer, allocatable :: iEquiv(:,:,:)
             integer, allocatable :: nab(:) 
             integer, allocatable :: nParBl(:,:)
             integer, allocatable :: Jaffina(:)
             integer, allocatable :: ckEquiv(:)
             integer, allocatable :: nAddrDer(:,:)
             real, allocatable    :: shiftMnqd(:,:)
!
             integer, allocatable :: ckFix(:)
             integer, allocatable :: kFix(:,:)
!
      END MODULE LsqStuff
! ----------------------------------------------------------------------
      MODULE LsqStuff12
!
!-- Caos Least Squares directive  ( list 12)
!
             integer              :: NumCond12 = -1
             integer              :: NumBlock12 = 0
             integer              :: NumRestr12 = -1
             integer              :: NumRestr12_Special = -1
             integer              :: NGroup12 = -1
             integer              :: NRotam12 = -1
             integer              :: NumDirOver(5)
             integer              :: codeparam(19)
             integer, allocatable :: idir12(:)
             character(len=80) , allocatable :: stringa12Tot(:)
!             
             integer              :: NumCond12_Sav 
             integer, allocatable :: idir12_Sav(:)
             character(len=80) , allocatable :: stringa12Tot_Sav(:)
!                 
!-- Available directives for refinement condition
             integer              :: NumDiret12 = 21
             character(len=4), dimension(21) :: Diret12=(/
     1                                              'diag',     ! 1
     2                                              'full',     ! 2
     3                                              'bloc',     ! 3
     4                                              'plus',     ! 4
     5                                              'fix ',     ! 5
     6                                              'fact',     ! 6
     7                                              'equi',     ! 7
     8                                              'ride',     ! 8
     9                                              'end ',     ! 9
     *                                              'fixe',     ! 10 
     1                                              'dist',     ! 11
     2                                              'angl',     ! 12
     3                                              'tors',     ! 13
     4                                              'plan',     ! 14
     5                                              'sum ',     ! 15
     6                                              'cont',     ! 16
     7                                              'limi',     ! 17
     8                                              'grou',     ! 18
     9                                              'rota',     ! 19
     8                                              'site',     ! 20
     9                                              'diso'/)    ! 21
!
!--Codes for parameters used in the directives for refinement condition 
             integer              :: NumParam12 = 32
             character(len=4), dimension(32) :: Param12=(/
     1        'x   ', 'y   ', 'z   ', 'b[is', '11  ', '12  ', '13  ',
     2        '22  ', '23  ', '33  ', 'occ ', 'occ1', 'occ2', 'occ3',
     3        'occ4', 'tau ', 'thet', 'phi ', 'psi ', 'alph', 'alp1',
     4        'alp2', 'alp3', 'alp4', 'xs  ', 'ij  ', 'ii  ', 'scal',
     5        'bove', 'exti', 'pola', 'twin'/)
!
      END MODULE LsqStuff12
! ----------------------------------------------------------------------
      MODULE LsqStuff12_byUser
!
!-- Caos Least Squares directive  ( list 12) byUser
!
             integer              :: NumCond12_byUser = -1
             integer, allocatable :: idir12_byUser(:)
             character(len=80) , allocatable   :: stringa12_byUser(:)
!
      END MODULE LsqStuff12_byUser
! ----------------------------------------------------------------------
      MODULE LsqStuff12_RT
!
!-- Least Squares directive  (RunTime)
!
             integer              :: NumCond12_C
             integer, allocatable :: idir12_C(:)
             integer, allocatable :: icodeequiv12(:)
             character(len=80) , allocatable :: stringa12(:)
             character(len=80) , allocatable :: stringa12Tot_C(:)
             integer, allocatable :: codeparam12(:,:)
             integer, allocatable :: codeatom12(:,:)
             real, allocatable    :: valuetarget12(:)
             real, allocatable    :: valuesigma12(:)
             real, allocatable    :: valuesig12(:,:)
             integer, allocatable :: nvres12(:)
!
      END MODULE LsqStuff12_RT
! ----------------------------------------------------------------------
      MODULE LsqStuff22
!
!-- Caos Least Squares directive  ( list 22)
!   BlAddr(NumBlockTot)
!
             integer, allocatable :: BlAddr(:)
!                 
      END MODULE LsqStuff22
! ----------------------------------------------------------------------
      MODULE LsqStuff22Abs
!
!-- Caos Least Squares directive  ( list 22abs)
!      NumBlockTot = numero di blocchi
!      NParTot (ex n22a) = numero di parametri da affinare
!      DimMatMax (ex n22y) = numero massimo (matrice triangolare)
!      NParBlMax (ex n22x) = numero massimo di parametri per blocco
!      NumDerParz= ex jq  numero di derivate parz. per parametro
!--alloca vettori: ParAddr(NumBlockTot,NParBlMax,2)
!                  EquaNorm(DimMatMax,NumBlockTot)
!                  VettNorm(NParBlMax,NumBlockTot)
!                  BuffNorm(NParBlMax,NumBlockTot)
!                  DeriPerz(1:NumBlockTot,1:NParBlMax,1:NumDerParz)
!                  DeriTot(1:NumBlockTot,1:NParBlMax)
!
             integer              :: NumDerParz
             integer              :: DimMatMax
             integer              :: NParTot
             integer              :: NParBlMax
!
             integer, allocatable :: ParAddr(:,:,:)
             real*8, allocatable  :: EquaNorm(:,:)
             real*8, allocatable  :: VettNorm(:,:)
             real*8, allocatable  :: BuffNorm(:,:)
             real, allocatable    :: DeriPerz(:,:,:)
             real, allocatable    :: DeriTot(:,:)
!                 
      END MODULE LsqStuff22Abs
! ----------------------------------------------------------------------
      MODULE LsqRestraint
!
!-- Direttive dei Restraint
!
             integer              :: NumRestraint = -1
             integer, allocatable :: idirRestraint(:)
             character(len=80) , allocatable :: stringaRestraint(:)
!                 
!-- Available directives for refinement condition
             integer              :: NumDiretRestraint = 10
             character(len=4), dimension(10) :: DiretRestraint=(/
     1                                              'dist',     ! 1 --> 11
     2                                              'angl',     ! 2 --> 12
     3                                              'tors',     ! 3 --> 13
     4                                              'plan',     ! 4 --> 14
     5                                              'sum ',     ! 5 --> 15
     6                                              'cont',     ! 6 --> 16
     7                                              'limi',     ! 7 --> 17
     8                                              'site',     ! 8 --> 20
     9                                              'diso',     ! 9 --> 21
     *                                              'end '/)    !10 --> 21
!
      END MODULE LsqRestraint
! ----------------------------------------------------------------------
      MODULE LsqGroupsStuff
      
             integer              :: NumRigheGroup
             character(len=80) , allocatable :: RigheGroup(:)
             integer              :: MaxAtomsGroup
             integer, allocatable :: NumAtomsGroup(:)
             integer, allocatable :: JcodeFrag(:)
             integer, allocatable :: IsoAnisoGroup(:)
             integer, allocatable :: TypeGroup(:)
             integer, allocatable :: NserialGroup(:)
             real, allocatable    :: XGroup(:,:)
             real, allocatable    :: BisoGroup(:)
             real, allocatable    :: BijGroup(:,:)
             real, allocatable    :: OccGroup(:)
             real, allocatable    :: ThetaGroup(:)
             real, allocatable    :: PhiGroup(:)
             real, allocatable    :: PsiGroup(:)
             real, allocatable    :: SXGroup(:,:)
             real, allocatable    :: SBisoGroup(:)
             real, allocatable    :: SBijGroup(:,:)
             real, allocatable    :: SOccGroup(:)
             real, allocatable    :: SThetaGroup(:)
             real, allocatable    :: SPhiGroup(:)
             real, allocatable    :: SPsiGroup(:)
             real, allocatable    :: shiftMnqdGroup(:,:)
             integer, allocatable :: JflagGroup(:)
             integer, allocatable :: NameGroup(:,:)
             real, allocatable    :: ThetaDer(:,:,:)
             real, allocatable    :: PhiDer(:,:,:)
             real, allocatable    :: PsiDer(:,:,:)
             real, allocatable    :: GGroup(:,:,:)
             real, allocatable    :: XOrtoGroup(:,:,:)
             real, allocatable    :: XCrystGroup(:,:,:)
             integer, allocatable :: NordGroup(:)
             integer, allocatable :: NordAtomsGroup(:,:)
             character(len=16) , allocatable :: aLabPrintGroup(:,:)
             character(len=16) , allocatable :: aLabGroup(:)
             character(len=20) , allocatable :: NameLongGroup(:)
      END MODULE LsqGroupsStuff
! ----------------------------------------------------------------------
      MODULE HistoStuff
             real,    allocatable :: vetmatchin(:)  ! vettore appoggio
             real,    allocatable :: hisobco4(:,:)  ! E osservati
!
             real,    allocatable :: hisobco(:,:)   ! curva teorica
             real,    allocatable :: hiscaco(:,:)   ! curva teorica
      END MODULE HistoStuff
! ----------------------------------------------------------------------
      MODULE InvarStuff
      USE IsrCom
             integer, allocatable :: itab(:)
             integer, allocatable :: itabH(:)
             integer, allocatable :: itabK(:)
             integer, allocatable :: itabL(:)
             integer, allocatable :: itabO(:)
!
             integer, allocatable :: isig(:,:)
             integer, allocatable :: inq(:,:)
             real,    allocatable :: gq(:)
             real,    allocatable :: gv(:)
      END MODULE InvarStuff
! ----------------------------------------------------------------------
      MODULE RenorArrays
             real,     allocatable   :: RES(:)
             real,     allocatable   :: res_sort(:)
             real,     allocatable   :: Eobs(:)
             integer,  allocatable   :: RES_TAG(:)
             integer,  allocatable   :: IX_sort(:)
             integer,  allocatable   :: IX_aux(:)
             real,     allocatable   :: Eo2Shell(:)
             real,     allocatable   :: scEo2Shell(:)
             real,     allocatable   :: shellTAB(:,:)
      END MODULE RenorArrays
! ----------------------------------------------------------------------
      MODULE MADStuff
             real, allocatable :: eMadP(:,:)
             real, allocatable :: eMadM(:,:)
             integer, allocatable :: idvet(:)
             integer, allocatable :: idvet1(:)
             integer, allocatable :: idvetP(:)
             integer, allocatable :: iordm(:,:)
             integer, allocatable :: iinr(:)
             real, allocatable :: eme(:)
             real, allocatable :: evero(:)
             real, allocatable :: fvero(:)
             real, allocatable :: emesus(:,:)
      END MODULE MADStuff
! ----------------------------------------------------------------------
      MODULE SnipMod
             real, allocatable :: xmapOld(:,:,:)
             real, allocatable :: xmapNew(:,:,:)
      END MODULE SnipMod
! ----------------------------------------------------------------------
      MODULE MappaPatterson
             real, allocatable :: Patt(:,:,:)
             real, allocatable :: PattOrig(:,:,:)
             real, allocatable :: SMF(:,:,:)
             real, allocatable :: SMFtrue(:,:,:)
             real, allocatable :: xmapShi(:,:,:)
             real, allocatable :: xmapSav(:,:,:)
             real, allocatable :: xmapmod2(:,:,:)
             integer :: ifModPat = 0
             integer :: ifNewPat = 0
             integer :: iesCmap = 0
             integer :: iesSnip = 0
             integer :: iswitch_3D = 0
             integer :: numCmap = 0
      END MODULE MappaPatterson
! ----------------------------------------------------------------------
      MODULE MappaCorrezione
             real, allocatable :: xmap2(:,:,:)
             real, allocatable :: xmap2sav(:,:,:)
      END MODULE MappaCorrezione
! ----------------------------------------------------------------------
      MODULE MapShi
             real, allocatable :: RhoMap(:,:,:)
             real, allocatable :: RhoMapShi(:,:,:)
             real, allocatable :: RhoMapComb(:,:,:)
             real, allocatable :: RhoMapApp(:,:,:)
      END MODULE MapShi
! ----------------------------------------------------------------------
      MODULE CorrMod
!
             real,    allocatable :: work_bf(:)
             real,    allocatable :: fcoefRB(:)

             real,    allocatable :: wtRB(:,:)
             integer, allocatable :: iphRB(:,:)
!
             real, allocatable        :: distr(:)
             real, allocatable        :: fourr(:)
             real, allocatable        :: fourrr(:,:)  !NEW
             real, allocatable        :: info_fne(:,:)
!
             real, allocatable           :: xyz_model(:,:)
             real, allocatable           :: bfac_model(:)
             integer, allocatable        :: nz_model(:)
!ndstep = 2000
             real, dimension(2,2000)   :: mapcor
*            real, dimension(2,10000)   :: mapcor
             real, dimension(2,10000)   :: mapcorRoc
!
             integer   :: NatUsed, lcyc, nic, lcyc_best
             integer   :: nmapcor, npksig, nats_best
             integer   :: nmaplim1, nmaplim2, nmap_best
             integer   :: nmaplim2Roc, inLSQ_Bias
!
             real      :: erore_best, erorepes_best, cc_best
             real      :: Rf_best, Rf_best_cyc, RSoglia_Bias
             real      :: dminneg, sigma1_indaga, sigma1
             real      :: raylim, raylim0, raylim1, raylim2
             real      :: deltx, delty, deltz
             real      :: ca, cb, cg
             real      :: dx, dy, dz
!
      END MODULE CorrMod
! ----------------------------------------------------------------------
      MODULE C_EDM
!
             real, allocatable :: xpat(:,:,:)
!
             real, allocatable :: EobsEp(:)
             real, allocatable :: xPrec(:)
             real, allocatable :: fcoefSav(:)
             real, allocatable :: fcPrec(:)
             real, allocatable :: wtNew(:)
             real, allocatable :: wtHis(:)
             real, allocatable :: wtSav(:)
             real, allocatable :: wtSSav(:)
!
             integer, allocatable :: puntatore(:)
             integer, allocatable :: mkangSav(:)
!
             real      :: denmaxPatt
!
      END MODULE C_EDM
! ----------------------------------------------------------------------
      MODULE RuotaRiflessi
          real,     allocatable :: ModuliSel(:,:)
          real,     allocatable :: Fph(:,:)
          real,     allocatable :: Fsh(:,:,:)
          real,     allocatable :: FshFix(:,:,:)
          real,     allocatable :: solv_corr(:,:)
c          real,     allocatable :: sumff (:)
c          real,     allocatable :: sumffMod(:,:)
          real,     allocatable :: fccomp(:)!fc compattati
          real,     allocatable :: focomp(:)!fo compattati
          real,     allocatable :: epsvcomp(:)
          real,     allocatable :: rhovcomp(:) 
          real,     allocatable :: sigmavcomp(:) 
          integer                  nreflSelRot
          integer                  nreflSelTra
          integer                  nreflSelRemo
      END MODULE RuotaRiflessi
! ----------------------------------------------------------------------
      MODULE TraslaSolution
          type TraSolution
             real TraVal(3)
             real TraFom
             real TraCorr
             real MolMPE
             integer ipunt
             integer trial
             real RotVal(3)
             real RotFom
             real LocFom
             integer accepted
             real TFom(5)
          end type TraSolution
          integer TraNum
          integer nTraSol
          integer ifAdjust
          type(TraSolution),   allocatable :: Trasol(:)
          type(TraSolution),   allocatable :: TraAll(:)
          integer,  allocatable:: iwork4(:)
          real,     allocatable :: work4(:)
          real,     allocatable:: workRenor1(:), workRenor2(:)
      END MODULE TraslaSolution
! ----------------------------------------------------------------------
      MODULE RenorArrays_MR
             real,     allocatable   :: RES(:)
             real,     allocatable   :: res_sort(:)
             real,     allocatable   :: Eobs(:)
             real,     allocatable   :: Eo2Shell(:)
             real,     allocatable   :: scEo2Shell(:)
             integer,  allocatable   :: RES_TAG(:)
             integer,  allocatable   :: IX_sort(:)
             integer,  allocatable   :: IX_aux(:)
             real, allocatable       :: shellTAB(:,:)
      END MODULE RenorArrays_MR
!------------------------------------------------------------------------------
      MODULE riflessi_c
         integer :: nRifDimC
         real    :: distmaxPdb
         real :: dimcell
         integer :: ifatxC
         integer :: ifat1C
         integer :: ifat2C
         integer :: ihmx_c(3)
         integer,    allocatable :: khlc (:,:)
         integer,    allocatable :: superind (:)
         real,       allocatable :: fcvetc (:)
         real,       allocatable :: fcvets (:)
         real,       allocatable :: ecvetc (:)
         real,       allocatable :: rhovc (:)
         integer,    allocatable :: khlv(:,:,:)
         real,       allocatable :: khlv_eq(:,:,:,:)
         integer,    allocatable :: k_mem(:)
         integer,    allocatable :: k_mem1(:)
         integer,    allocatable :: iworki(:,:)
      END MODULE riflessi_c
! ----------------------------------------------------------------------
      MODULE riflessi_mio
c         integer,    allocatable :: superind_m (:)
c         real,       allocatable :: ecvetc_m (:)
         integer,    allocatable :: khlv_m(:,:,:)
         real,       allocatable :: khlv_eq_m(:,:,:,:)
         integer,    allocatable :: k_mem_m(:)
         integer,    allocatable :: k_mem1_m(:)
c         integer,    allocatable :: khlc_m (:,:)
         real,     allocatable :: solv_corr_m(:,:)

      END MODULE riflessi_mio
! ----------------------------------------------------------------------
      MODULE Riflessi_App
             integer, allocatable  :: iphapp(:)
             real, allocatable     :: pesapp(:)
             real, allocatable     :: eveapp(:)      ! fo**2
      END MODULE Riflessi_App
! ----------------------------------------------------------------------
      MODULE CanalMod
           real, allocatable       :: djjs(:)
           integer, allocatable    :: jjorde(:)
           integer, allocatable    :: jjorde1(:)
      END MODULE CanalMod
! ----------------------------------------------------------------------
      MODULE PherrMod
           real, allocatable       :: dijs(:)
           integer, allocatable    :: jorde(:)
           integer, allocatable    :: jorde1(:)
      END MODULE PherrMod
! ----------------------------------------------------------------------
      MODULE Finale
!
         real, allocatable :: ResMol (:,:,:)
         real, allocatable :: TrialCor (:,:)
         real, allocatable :: TrialDrop (:)
!
      END MODULE Finale
! ----------------------------------------------------------------------
      MODULE ModModel
!
         integer :: nca
         real, allocatable : : distMatrix(:,:)
         real, allocatable : : distMatrixModel(:,:)
         real, allocatable : : distMatrixPatt(:,:)
         real, allocatable : : MatrixModel(:,:)
         real, allocatable : : Shell(:,:,:)
         integer, allocatable : : ShellCont(:)
!
      END MODULE ModModel
! ----------------------------------------------------------------------
      MODULE MadModule
!
      character(len=256)                :: MTZfile_Mad
      character(len=30), dimension(100) :: Lab_Ch_Mad
      character(len= 1), dimension(100) :: tipo_colonne_Mad
      integer ::  nMTZlab_Mad
      integer ::  Sostituisci(2,8)
      integer ::  ifSelenio
      common /cmad/ nWave,kAnom(8),fPrimoSecondo(8,5,2),normm(5), 
     *              nAn(8), nkAnom(8), nAnom,
     *              bWilsonM(5),scaleWilsonM(5),
     *              nWaveAct,
     *              nwl(5),numbWL,
     *              eMadMax,
     *              NumFiltri,nFiltro(10),SogFiltro(10),
     *              iks,ikess,SogEss,ifEsuSigma,ikepers,ifCreate,
     *              ifNative,ifClick
c     nWave = numero di lunghezze d'onda in input
c     kAnom = specie atomica dei diffusori (formato a2)
c     nAn = numero di atomi per ogni diffusore
c     nkAnom = puntatore (in nw, no ...) dei diffusori anomali
c     nAnom = numero di speci anomale
c     fPrimoSecondo(j,i,1) = f' dell'iesima lunghezza d'onda j-esimo scatterer
c     fPrimoSecondo(j,i,2) = f" dell'iesima lunghezza d'onda j-esimo scatterer
c     normm(i) = 1 se si vuol normalizzare rispetto alla i-esima l.d.o.
c               se si utilizza piu' di una lunghezza d'onda,
c               l'E finale e' dato dalla media dei singoli E
c     bWilsonM(i)     = B di Wilson per l'i-esima l.d.o.
c     scaleWilsonM(i) = scala di Wilson per l'i-esima l.d.o.
c     nWaveAct = n. della lunghezza d'onda attualmente normalizzata
c     nwl(i) = n. seq. di una lunghezza d'onda da usare
c     numbWL = numero totale di l. d'onda da utilizzare
c     iks   = indice della colonna di emesus contenente i sigma(E0a)
c     ikess =   "      "     "          "        "   E0a/sigma(E0a)
c     SogEss= soglia di E0a/sigma(E0a) per i riflessi strong (nstr)
c     ifEsuSigma = 0  riflessi ordinati per E0a
c                = 1     "        "     per E0a/sigma
c     ifNative = 0/1 assenza/presenza dei dati della nativa sul file hkl
c     ifClick  = 0/1 assenza/presenza della stringa "Click on graphics.."

      common /atm/ f0jna(270,5),f0ja(270,8,5),fpj(270,8,5),fsj(270,8,5),
     *             f0(8),fp(8,5),fss(8,5),fpQ(8,5),fsQ(8,5)
!      real *8 f0jna, f0ja ,fpj , fsj, f0, fp, fss, fpQ, fsQ
      double precision f0jna, f0ja ,fpj , fsj,     fp, fss, fpQ, fsQ
!     common /evvero/ evero(100000), fvero(100000)
      common /erreMAD/ numR, NumRefR(5), rfacR(5)
      common /DSR/ Dan(5),DanAbs(5),nRefDev(5),kpc,
     *             Soglia_su_d,Soglia_su_d_lowres           !pgMAD040105

      common /WLCORR/ dval(20), nrfd(10,20), correl(10,20), ninterv
      common /WLCORR_D/ dval_d(20),nrfd_d(15,20),corre_d(15,20),
     *                  ninterv_d
      common /RANGO/ Rank(31),iCombC(31),Peso3,Peso4,PercCorr,cut_d(31),
     *               n_WL_Comb,isRank(31)
      common /reject/ nRej1,nRej2,nRej3,nReflInput,nRejj(10)
      common /anomalous/ kfpfs(8),fpfs(2,8), nWilsonPlots
!gl!  common /patter/ jjpatt, cutoffPatt   ! spostata in General
!
!pgMAD0512
      common /RESsuRAT/ ResRat(502,3),npis
!090205
!     character *200 MadMsg
!     common /MadMes/ nMadMsg, MadMsg(200)
!090205
!
!-- MAD-Sirprot
!
      integer ::  MAD_WL_vet(4)
      integer ::  MAD_WL_number
      integer ::  MAD_set(2)
      integer ::  MAD_lsq
      integer ::  MAD_posi
!
      END MODULE MadModule
! ----------------------------------------------------------------------
      MODULE PhaseModule
!corr      USE progtype, only: model_type
      USE model_util, only: model_type
!
      integer :: jumpVLD = 0
      integer :: ifCombMap = 0
      integer :: mpe_zero = 0
      integer :: jEnan = 0
      integer :: ifTre = 0
      integer :: ifTraslas = 0
      integer :: kverboCow = 0
      integer :: ricicloVLD = 0
      integer :: nsetVLD
      integer :: ifErrMin = 1
      integer :: ifSigmaA = 0
      integer :: ifFomNew = 0
      integer :: ifFomNewReq(2)
! -- direttive di invar gestite anche in phase
      integer ifGmin, ifGminReq, ifCochReq, ifNoQuaReq
      common/PhaseToInv/ ifGmin, ifGminReq, ifCochReq, ifNoQuaReq
!
      integer :: ifPert_tg, ifCycTang, trial_pert
      integer  :: numset,npic, iyrandSav
      common /ureqph/ jtabl,jproc,nneg,nngq,lasts,ipesi,nfisso,ifP1
      real     :: RSoglia = 25.0
      real     :: rfacSog
*     common /xdata99/iorde(4000),alfest(4000),alfvar(4000),
*    2        alpha(4000),irefin(4000),limref(2,4001),wtPseudo(4000)
      common /xdata99/            alfest(4000),alfvar(4000),
     2        alphaVet(4000),irefin(4000),limref(2,4001),wtPseudo(4000),
     3        alpha_str(4000),alpha_str_rif(4000),alpha_str_sav(4000)
!psie      
!psie      common /xdata99/            alfest(12000),alfvar(12000),
!psie     2    alphaVet(12000),irefin(12000),limref(2,12001),wtPseudo(12000),
!psie     3    alpha_str(12000),alpha_str_rif(12000),alpha_str_sav(12000)
      
      common /xdataph/ ntrip, ntrn, nquar, LenIPH, nstartTang, 
     *                 nutri, jpq, nn(8)
      common /BackToTangent/ BackWT(8000),BackPh(8000),BackEmod(4000,2),
     *       numbB,numbInv,numbLSQ,nEmod, numbLSQFinal, numbLSQReset
      common /FastC/ kfast,iesfast,ifPost,kWriMap,iWriMap,kSolMap
      common /appo/ pmax,
     *           ifLib,rapdenini,ifnoesa,ies_Esalta,exposigma,ifOUT,
     *           ifnoEE,ifnoEEReq,ifNstr,axiec,if97
      integer  :: ifnoesa = 0
      integer  :: ies_Esalta = 0
      integer nBlockEDM, nMacro, nMacroTot, nMicro
      integer  :: noSnip = 1
      integer indiceBlocchi, indiceMacro, indiceMicro, nMacroAppl,
     *        cicloEDM, MetaMicro, ifHafr
      integer nBlockEDM_UnRel, nMacroTot_UnRel, nBlockEDM_Relax,
     *        nMacroTot_Relax
      common /dsrC/ nBlockEDM, nMacro, nMacroTot, nMicro,
     *        indiceBlocchi, indiceMacro, indiceMicro, nMacroAppl,
     *        cicloEDM, MetaMicro, ifHafr, nBlockEDM_UnRel,
     *        nMacroTot_UnRel, nBlockEDM_Relax, nMacroTot_Relax
! -- dedi  per  selezione su alfaprimo
      integer  :: ncountConver
      integer icodeli(4000)
      real alfaprimo(4000)
!psie
!psie    icodeli(12000)
!psie alfaprimo(12000)
! -- dedi  per  selezione picco traslazione in Relax
      common /util3/ hSol,hFom,coef_hFom
! -- dedi
      integer iordeTang(4000)
      integer trialVett
      common /solvec/ IYsolve, itria, itriaPatt, numbTrials, 
     *                trialVett(500), ntria
      integer :: ifTrial = 0
      integer :: IterADD = 0
      integer :: kPost = 0
      integer :: kWstop = 0
      integer :: kWstop2 = 0
      integer :: kWstop3 = 0
      integer :: iverbo
      real    :: errev(101)
      integer :: kloop=0, kproc=0, kffom=0
      real    :: MPEvet(5)
      common /errori/ erm1,ermpes1,erm2,ermpes2,
     * error1(502,2),error2(502,2),shif(502,3),isumal,sumalfa
      common /erroriminimi/ shiftexam(7), setmin, erm1min, erm1sav,
     *        bestmin, kbestr, erore, erorepes, errstp(36), errtp(12),
!pg05052014
     *        erore_best_MNQ
      common /MultiRun/ numbrun,jCountRun,MaxRun,MaxRunTot,nTotTrials,
     *        MaxRun_MDM
      integer :: MaxRun_MDM
      integer :: numbSet = 0
      integer :: numbrunOld = 0
      type(model_type), allocatable, dimension(:) :: BestModels
      integer :: nBestModelsMax = 0
      integer :: nBestModels    = 0
      integer :: vBestModels(2,20)
      integer :: jrecyc = 0
      integer :: krecy  = 0
      integer :: nemap  = 0
      integer :: lsx, jrest, maxcyc
      real    :: erre  = 0.0
      real    :: erreo = 0.0
      real    :: biso, oscale, errem, fobmin, tsigma
      common /SmallOrMacro/ isma,ismah,jsaved
      common /sdir/ npic0,nats0,ihalf,dm0,dm,dm_fou,npc,nproj ! dedi
      common/dedimiss/numbmis,ResSog_Ph,LowRes
      common/iterac/  percMap, percMap_n, invflag, iesnegmap,
     *                 esalta, esaltaPatt
cdedi real    :: esalta  = 1.0   ! da scommentare per inizializzare la variabile (vedi DUMP in pesi extrap)
      real    :: esaltaPatt  = 1.0
      integer :: ifPatWei = 0
      common /preb/ ipreb,ifLsqh,iwei,iheavy,NumeroAtomico,NumeroZolfo,
     *            NumPes,NumPes1,NumPes2,pip
      common /vagria/ aperc(90),rperc(90),npercm, nrefB
      common /CicliInv/ iDelta
      common / rettaLSQ / aaterm, bbterm, sigmaven
      integer  :: ifNewPsi0, NewPsi0Req
!
!-- FOMs
!
      integer, allocatable :: nent1(:)
      integer, allocatable :: nent2(:)
      integer  :: ifOldFoms, iesFom
      real     :: sigm, crel, coms, alcom, psicom
      common /stampac/ cfom(502), ipos(502), figMer(11), stampa(14)
      integer iyrandEquiv
      equivalence (iyrandEquiv, figMer(11))
      integer psicode
      common /psi0/ npsi,num0,alfest0(4000),alfvar0(4000),psicode(4000),
     1 lim0n(4001),iph0n(150000),mkang0(1000),evet0(1000)
      common /oldxdata/ negt1(4000),negt2(4000),iqu1(750),
     * iqu2(750),iqu3(750),psivet(4000)
      common /oldparam/ ckae, ckae0, ssig
      integer     :: jjpunt, SetsStored, jumpp, jmpsie, nsec
      common /ureq1/ jjpunt(4001), SetsStored, jumpp, jmpsie, nsec
      integer  :: npuntEquiv
      equivalence (npuntEquiv, jjpunt(4001))
      common/fom4/attl2,attl3,nqen,nen,ns1,ns2,nphas,nfom0,nfoml,coeco
       common /fomcom/ ntrSv, aminco,cfomx,
     1 MaxToStore,absfom,resid,al2,al2m1,almed,nundet,error,errpes,
     2 fomps0,foms1,fomrt(502,10),f1mx,f1mn,f2mx,f2mn,f21mx,f21mn,
     3 f22mx,f22mn,f23mx,f23mn,f3mx,f3mn,f4mx,f4mn,f5mx,f5mn,f6mx,f6mn,
     4 f7mx,f7mn,f8mx,f8mn,f9mx,f9mn,f10mx,f10mn,f11mx,f11mn,f12mx,
     5 f12mn,f13mx,f13mn,f14mx,f14mn,f15mx,f15mn,f16mx,f16mn,f17mx,
     6 f17mn,f18mx,f18mn,ff1mx,ff1mn,ff3mx,ff3mn,ff4mx,ff4mn,ff5mx,
     7 ff5mn
      common /NewFoms/ fomrtN(500,6), fomBuff(6), ifCombinedFom,
     * averlar, aversma, avewe, avewenum, aveweden, averat, avemaxM,
     * stdrlar, stdrsma, stdwe, stdwenum, stdweden, stdrat, stdmaxM,
     * dphi
      common/numiter/ Iterazione, nIterazioni, itera, iterasog, 
     *                IterADD, nIterADD, nIteraTot, Itera_Imp,
     *                sogFinalFom, stopFinalFom, ffomReq, FFomStopPGM,
     *                ffom, fom(11), sumpx, SogliaCorre, waveare
      real    :: FFomStopPGM = 0.0
      integer :: ffomReq
      integer :: WhichBlock
      common /BlockComm/ nBlocksPh, jBlocksPh(2,30), nTotBlocksPh, 
     *        jBlock, nSetStored, nVolteFour, nFour, WhichBlock, nBias
      integer :: nPattpks = 1
      integer :: nPattpksReq = -99
      integer :: nBlocksPhReq = -99
      common /errevetcomm/FOMs(2,5), FOM_Mad(6), errevet(100),FinalFom0,
     *        nerrevet, coefFom, CCEoEc(2),fomold(5),EarlyFom,FinalFom,
     *        errevetMAD(100),Final_info(5), fig_CC(10), diffCC,
     *        figuracce(2,15),sogFFomRif,FFomRif,stopFFom,numrat_first,
     *        eFOM_MDM, sum_term(2), fom_NewRat
      real    :: coeFFom = 1.0
      real    :: FinalFom_DSR = 0.0
      real    :: FinalFom_1 = 0.0
      real    :: FinalFom_2 = 0.0
      real    :: numrat_first = 0.0
      real    :: eFOM_MDM, sum_term

      common /Libcomm/CC_Shelx,Fom_Trip,Fom_TripM,Fom_Trip_sca
      common /RATcomm/ BestRatVet(8)
      integer :: WhichFom, TrerreBestMDM
      common /BestValues/ fomBest,fomBestE,erreBest,erreWorse,
     *                    jRfac,kRfac,nRfac,NumbMaxRfac,FomsMin,
     *                    kFomsMin,                     vmin,vmax,
     *                    TrerreBest,TrBestFom, WhichFom,
     *                    VXmin(3),VXMax(3),VYmin,VYMax,
     *                    TrerreBestMDM
      common /figmerC/ RfacMato,RfacMind,RfacMave,RfacMaso,facMaso,
     *                facMato,facMind,facMave,facMasc,itotsir,facMasold,
     *                ratmxnosol

      integer ResBiasReq, ksizeReq, ksize_vero, ksize_orig ! dedi
      common /VariFlags/ ifExamin, nolsq, ifRescale, ifCorr, ifCorrReq,
     *           ifTime, ifExpanded,ifPDB, ifPostDSR, ifMason, nMason,
     *              ifCutE, ifPert, ifPatt, ifTang, ifInvar, nowei
     *              ,ifVLD, ifVLDdir, ifMDM,ifEndDSR
      integer :: ifEndDSR = 0
      integer :: ifMDM = 0
      integer :: AbortLSQ = 0
      integer :: ifHelix = 0
      common /SelAlfaC/ ifSelAlfa, nstrelimi, ntripelimP, ntripelimN, 
     *                 nquadelimi, npsi0elimi, elimalfa
      common /r_free/ nincfr, ninc, nexcfr, nexc
      common /envDyn/ ifEnve,RenveStart,RenveDyn,RenveStep,EnvePronta,
     *                numresVal
      common /matchH/ifirstHM,nsip,nwiz,nwizl,
     *               ifirstHMT,nsipT,nwizT,nwizlT,
     *               xoss_Theo(500),xoss_Obs(500),xcalc(500),xhist(500),
     *               ai(500),bi(500)
!
      common /ChemCom/ ifChemFra,jChem,natomChem,
     *                 caChem,cbChem,cgChem,deltChem
!
!-- RELAX
!
      integer relaxReq
!gl   common /reducec/ ifReduced,nsymTrue,icentTrue,natmTrue,nstrSav,
!gl nsymTrue,icentTrue spostati in MODULE Symmetr
      common /reducec/ ifReduced,                   natmTrue,nstrSav,
     *                 nstrP1,kpolTrue, ifRelax, ntrRelax, relaxReq,
     *                 noDSR
      common/piu_trasla/ ntraslas,delta_tra(2,3),delta_sol(3)
!
!-- Gestione dei set di fasi in uscita da DSR
!
      integer :: ifStoredPhases = 0
      integer :: nSetsMaxFineDSR = 0
      integer :: nSetsFineDSR    = 0
      integer :: iposFineDSR
      common /FineDSR/ nSetsMaxFineDSR, nSetsFineDSR, 
     *                 FomsFineDSR(10), iposFineDSR(10),
     *                 OldTRialsForDLSQ(10,11)
!
!-- Picco Patterson imposto dall'utente
!
      common /ForcedPeak/ ifPivot, coord_temp(3)

!
!-- Procedura affinamento ridotta x MAD/SAD       !pgMAD2907
!
      common /ProcRid/ ifRidotta
!
      common /MappaFF/FFfom0,FFfom
!
      common /SMF/ nOrigRoxiRoc, nsymTotRoc, taboRoc(32,3)
!
!-- Procedura per l'utilizzo dei riflessi estrapolati in tangente
!
      integer  :: nstrMod
!
*gl*  common /cBarra/ nbarra, npercB, perc0B, percB, iipercB, jpercB
      integer  :: nbarra, npercB, iipercB, jpercB 
      integer  :: jpercBarra, npercBarra
      real     :: perc0B, percB
!
!-- Gestione dei file da exportare automaticamente
!
      integer  :: natsExportLimit = 0
      integer  :: ifExportShelx = -1
      character (len=3) :: ExportExtension
!
      integer :: ifProcAB = 0
!
      END MODULE PhaseModule
! ----------------------------------------------------------------------
      MODULE PhaseInterface
      interface
         subroutine MiglioriErre(iAction, trial, trialv, erreV, str)
         USE General, only: MyStringa
            integer   :: iAction
            type(MyStringa), optional  :: str(*)
            integer, optional :: trial
            integer, optional :: trialv(*)
            real, optional    :: erreV(*)
         end subroutine MiglioriErre
      end interface
      END MODULE PhaseInterface
! ----------------------------------------------------------------------
      MODULE Seminvariants
!
*     common /choi/ mm,iimax,jmax,nsj,jtable(8,16),invet(48)
*     common /pro/  jvarma(3,3),kx(3),idoub,kkk,sump(2),icros,
*    * jhkl(3),e,scr2(2),ns,sr2(2),  hklt(3,3),nsemc,nsemg
*     common /Seminvariants/ nSemi, kSemi(8000)
*     common /inv/  invma(96,3,3),idivv(48)
*     common/multi/ntrials,ntrialsatt,npeaktrial(500)
      integer  ::  mm, iimax, jmax, nsj, jtable(8,16), invet(48)
      integer  :: jvarma(3,3), kx(3), idoub, kkk,icros
      integer  :: jhkl(3), ns, nsemc, nsemg
      integer  :: h3(3), hk(3)          ! NEW
      integer  :: nss1 = 0              ! NEW
      integer, allocatable :: ss1vet(:) ! NEW
      real     :: sump(2), e, scr2(2), sr2(2), hklt(3,3)
      integer  :: nSemi, kSemi(8000)
      integer  :: invma(96,3,3), idivv(48)
!
      END MODULE Seminvariants
! ----------------------------------------------------------------------
      MODULE PseudoStuff
!
             real,    allocatable :: epseud(:)
             real,    allocatable :: esuper(:)
             real,    allocatable :: enew(:)
             real,    allocatable :: patom(:)
             real,    allocatable :: qatom(:)
             real,    allocatable :: pnew(:)
             real,    allocatable :: qnew(:)
             real,    allocatable :: emed(:)
             real,    allocatable :: qn(:,:,:)
             integer, allocatable :: kpseud(:)
             integer, allocatable :: ksuper(:)
             integer, allocatable :: ipseud(:)
             integer, allocatable :: iskip(:)
             integer, allocatable :: keq(:)
             integer, allocatable :: numps(:)
             integer, allocatable :: jqn(:)
             integer, allocatable :: mpseud(:,:)
             integer, allocatable :: hkleMat(:,:)
      END MODULE PseudoStuff
! ----------------------------------------------------------------------
      MODULE Pattern
!
      common/directGTK/nspec_lab,ispecie_lab(2),
     *npeaks_lab(2),ncoord_lab(2),valori_lab(4),
     *num_polpo1,natomo_p1(100),ncoord_p1(100),dist_p1(100),
     *tol_dis_p1(100),tol_ang_p1(100),
     *num_polpo2,natomo1_p2(100),natomo2_p2(100),nspec_p2(100),
     *ncoord_p2(100),dist_p2(100),tol_dis_p2(100),tol_ang_p2(100),
     *kmethod
     *,num_spec_draw, nspecie_draw(100), ncoord_pdraw(100),
     * dist_draw(100), tol_dis_draw(100), tol_ang_draw(100)
!
      END MODULE Pattern
! ----------------------------------------------------------------------
      MODULE MappaPrint
             real, allocatable :: xmap_prt(:,:,:)
      END MODULE MappaPrint

! ----------------------------------------------------------------------
      MODULE ArpWarp
             integer   :: tab2(10)
             integer   :: nats_added_to_pdb = 0
             integer   :: nats_pesanti_in_pdb = 0
             integer   :: perc_CA = 0
             integer   :: perc_IR = 0
             integer   :: WasAmb = 0
             integer   :: statoMR = 0
             integer   :: ifAmbModel = 0
             integer   :: FasiPerRefmac = -1
             integer   :: cicloAW, lendirAW
             integer   :: ifHeavyPDB = 0
             integer   :: nRefmacCycles = 10
             integer   :: TotRefmacCycles = 0
             integer   :: ncontAMB = 0
             integer   :: nAMB
             integer   :: nAMBReq
             integer   :: residuesAW
             integer   :: ifFailAW = 0
             integer   :: ifSkip = 0
             integer   :: ifSoloMR = 0
             integer   :: ifnoImp = 0
             real      :: tab3(6)
             real      :: RfacSynergy, RfreSynergy
             real      :: erre_added_to_pdb, erref_added_to_pdb
             real      :: erreHA, errefHA, eroreHA
             real      :: erreCAB, erreCAB1
             real      :: erreCABprev = 9999
             real      :: erreHAprev = 9999
             real      :: erreEprev = 9999
             real      :: coverage = 9999
             real      :: coverageSog = 80
             real      :: coverageOld = 0
c            real      :: RfacAW, RfreAW, RfacAWi, RfreAWi
             real      :: RfacAW = 0.999
             real      :: RfreAW = 0.999
             real      :: RfacAWi = 0.999
             real      :: RfreAWi = 0.999
             real      :: SogliaRfree = 0.3
             logical   :: UseSynergy = .false.
             logical   :: anisoRef = .false.
             logical   :: DoPhosphate = .false.
             logical   :: pdbinMR = .false.
             logical   :: AddPdb = .false.
             logical   :: HydroRefmac = .true.
             logical   :: MutateOn = .false.
             logical   :: UpdateMTZ = .false.
             logical   :: isJelly = .false.
             integer   :: JellyReq = -99
             integer   :: lAmb
             character (len= 9) :: AmbName
             character (len=50)  :: erreAW
             character (len=256) :: direttorioAW = ' '
             character (len=256) :: MTZfileAW
             integer, allocatable :: PH_refmac(:)
             real,    allocatable :: FC_refmac(:)
             real,    allocatable :: WT_refmac(:)
!
      END MODULE ArpWarp
! ----------------------------------------------------------------------
*     MODULE FasiEDM
*
*          real    :: BestEdmFom
*          real   , allocatable :: Pesi_EDM(:)
*          integer, allocatable :: Fasi_EDM(:)
*
*     END MODULE FasiEDM
! ----------------------------------------------------------------------
      MODULE PhMod

           logical :: aggiungiHA = .true.
           integer :: NfNhNe(3)
           real    :: absVet(8), tabImpr(16), erreTest , tabPrev(16)
           real    :: BestEdmFom
           integer :: ZHeavyPDB
           integer :: nAu, nkPh, minimoCAB
           integer, allocatable :: Pderiv_v(:)
           real,    allocatable :: Rderiv_1(:)
           integer, allocatable :: Ptota(:), Pub_target(:)
           real,    allocatable :: Ftarget(:)
           real,    allocatable :: Wtota(:), Rtarget(:)
           integer, allocatable :: Pfinal(:)
           real   , allocatable :: Wfinal(:)
           real   , allocatable :: work_PHA(:)
           real   , allocatable :: Rderiv_0(:)
           real   , allocatable :: Pesi_MR(:)
           integer, allocatable :: Fasi_MR(:)
           real   , allocatable :: Fcvet_MR(:)
           real   , allocatable :: Pesi_Sav(:)
           integer, allocatable :: Fasi_Sav(:)
           real   , allocatable :: MappaSomma(:,:,:)
           integer, allocatable :: RifPh(:)
           real   , allocatable :: RifWt(:)
           real, allocatable    :: FasiPrecedenti(:)
           real, allocatable    :: PesiPrecedenti(:)
           real, allocatable    :: xyzHeavy(:,:)
           real, allocatable    :: IntModel(:)
           integer              :: ancella
           integer              :: ancellaMax
           integer              :: BigCycles
           integer              :: nBigCycles =   1
           integer              :: nMicro_PHA, nMicro_PHA2
           integer              :: nDer
           integer              :: nVR = 1
           integer              :: npMix(3)
           integer              :: Box_PHA
           real                 :: VettRisultati(50)
           real                 :: tabOrigin(320,3)
           real                 :: RatioModelTarget = 1.0
           real                 :: fasePhantom
           real                 :: RfreePrec
           integer              :: nOrigPHA
           logical              :: mista
           logical              :: ModificaNp = .true.
           logical              :: AddRis = .true.
           logical              :: AssiFixed = .true. ! .true.
           logical              :: calcFC = .false. ! .true.
           logical              :: HeavyAtoms = .true.
           logical              :: instead = .false.
           character (len=4)    :: SHeavyPDB
           character (len=16), allocatable :: aLabHeavy(:)
      ENDMODULE PhMod
! ----------------------------------------------------------------------
      MODULE AlignDNA
!
      integer :: numeroNucleotidi
      integer :: numeroCatene, Catene(20,7)
      integer :: totResidModel
      integer :: nlimiti, limiti(3,20)
      integer :: nlimitiC, limitiChain(3,20)
      integer :: cateneTarget(20)
      integer :: offset(20,2)
      integer :: hole(20), uguali(20)
      integer :: summaryVet(20), summaryMat(20,6,2)
      integer :: summaryCat(20,6)
      integer :: summaryBefore(20,6), summaryAfter(20)
      integer :: summaryIniz(20,6)
      integer :: Fosforo
      integer :: fCoot, fuseCoot(200), funit, fser
      logical :: fused, fuseOpened, Udeleted, AddHetam
      integer :: nNewSeq, NewSeqMat(20,6)
      integer, allocatable :: preso(:)
      integer, allocatable :: Sequence_chk(:)
      integer, allocatable :: Sequence_check(:,:)
      integer, allocatable :: nuclei(:,:), localSequence(:,:)
      integer, allocatable :: SeqMod(:,:)
      real, allocatable    :: tabDist(:,:)

!
      END MODULE AlignDNA
! ----------------------------------------------------------------------
      MODULE PatternRef
      integer :: kcount_status
      ENDMODULE PatternRef
! ----------------------------------------------------------------------
      subroutine AllocaRfacMatrix(iAction)
      USE RfacMatrixModule
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
      implicit none
      integer :: iAction, ierv(2), ierr
!
      ierv(:) = 0
!
      ierr = 0
      if (iAction == 1) then
          if (allocated(RfacMatrix)) then
              deallocate (RfacMatrix, RfacMatrixSav, stat = ierr)
          endif
          allocate (RfacMatrix(8, nRfacMatrix, nRfacMatrixBl)   ,
     *              stat = ierv(1))
          allocate (RfacMatrixSav(8, nRfacMatrix, nRfacMatrixBl),
     *              stat = ierv(2))
!
          ierr = sum(ierv)
          if (ierr /= 0) then
              write(6,*) 'RfacMatrix Allocation Error'
              call cstop(' ')
          endif

      else
          if (allocated(RfacMatrix)) then
              deallocate (RfacMatrix, RfacMatrixSav, stat = ierr)
          endif
          if (ierr /= 0) then
              write(6,*) 'RfacMatrix DeAllocation Error'
              call cstop(' ')
          endif
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaMappaSnip(iAction)
      USE SnipMod
      USE Mappa, only : np
!
      dimension ierv(2)
!
      ierv(:) = 0
!
      ierr = 0
      if (iAction == 1) then

          IF (.NOT. ALLOCATED(xmapOld))
     *    ALLOCATE (xmapOld(0:np(1)-1,0:np(2)-1,0:np(3)-1),
     *                                                  stat = ierv(1))

          IF (.NOT. ALLOCATED(xmapNew))
     *    ALLOCATE (xmapNew(0:np(1)-1,0:np(2)-1,0:np(3)-1),
     *                                                  stat = ierv(2))
          ierr = sum(ierv)
          if (ierr.ne.0) then
              write(*,*) 'MapSnip Allocation Error'
              call cstop(' ')
          endif
          xmapOld = 0.0
          xmapNew = 0.0

      else
          IF (ALLOCATED(xmapOld))
     *        DEALLOCATE (xmapOld, xmapNew, stat = ierr)
          if (ierr.ne.0) then
              write(*,*) 'MapSnip DeAllocation Error'
              call cstop(' ')
          endif
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaMappaPatterson(iAction)
      USE MappaPatterson
      USE Mappa, only : np
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
      dimension ierv(9)
!
      ierv(:) = 0
!
      ierr = 0
      if (iAction == 1) then
          IF (.NOT. ALLOCATED(Patt))
     *    ALLOCATE (Patt(0:np(1)-1,0:np(2)-1,0:np(3)-1), stat = ierv(1))

          IF (.NOT. ALLOCATED(PattOrig))
     *    ALLOCATE (PattOrig(0:np(1)-1,0:np(2)-1,0:np(3)-1),
     *                                                   stat = ierv(2))

          IF (.NOT. ALLOCATED(SMF))
     *    ALLOCATE (SMF(0:np(1)-1,0:np(2)-1,0:np(3)-1), stat = ierv(3))

          IF (.NOT. ALLOCATED(SMFtrue))
     *    ALLOCATE (SMFtrue(0:np(1)-1,0:np(2)-1,0:np(3)-1),
     *                                           stat = ierv(4))

          IF (.NOT. ALLOCATED(xmapShi))
     *    ALLOCATE (xmapShi(0:np(1)-1,0:np(2)-1,0:np(3)-1),
     *                                                  stat = ierv(5))

          IF (.NOT. ALLOCATED(xmapSav))
     *    ALLOCATE (xmapSav(0:np(1)-1,0:np(2)-1,0:np(3)-1),
     *                                                  stat = ierv(6))

          IF (.NOT. ALLOCATED(xmapmod2))
     *    ALLOCATE (xmapmod2(0:np(1)-1,0:np(2)-1,0:np(3)-1),
     *                                                  stat = ierv(7))
!
          ierr = sum(ierv)
          if (ierr.ne.0) then
              write(*,*) 'MapPatterson Allocation Error'
              call cstop(' ')
          endif
          SMF = 0.0
          SMFtrue = 0.0
          xmapShi = 0.0
          xmapSav = 0.0
          xmapmod2 = 0.0

      else
          IF (ALLOCATED(Patt))
     *        DEALLOCATE (Patt,PattOrig,SMF,SMFtrue,xmapShi,xmapSav,
     *                     xmapmod2, stat = ierr)
          if (ierr.ne.0) then
              write(*,*) 'MapPatterson DeAllocation Error'
              call cstop(' ')
          endif
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaMappaPrint(iAction)
      USE MappaPrint
      USE Mappa, only : np
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
!
      ierr = 0
      if (iAction == 1) then
         IF (.NOT. ALLOCATED(xmap_prt))
     *   ALLOCATE (xmap_prt(0:np(1)-1,0:np(2)-1,0:np(3)-1), stat = ierr)
!
          if (ierr.ne.0) then
              write(*,*) 'MapPrint Allocation Error'
              call cstop(' ')
          endif
          xmap_prt = 0.0
      else
          IF (ALLOCATED(xmap_prt))
     *        DEALLOCATE (xmap_prt,  stat = ierr)
          if (ierr.ne.0) then
              write(*,*) 'MapPrint DeAllocation Error'
              call cstop(' ')
          endif
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaMappaCorrezione(iAction)
      USE MappaCorrezione
      USE Mappa, only : np
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
      dimension ierv(5)
!
      do i=1,5
         ierv(i) = 0
      enddo
!
      ierr = 0
      if (iAction == 1) then

          IF (.NOT. ALLOCATED(xmap2))
     *    ALLOCATE (xmap2(0:np(1)-1,0:np(2)-1,0:np(3)-1),
     *                                                   stat = ierv(1))

          IF (.NOT. ALLOCATED(xmap2sav))
     *    ALLOCATE (xmap2sav(0:np(1)-1,0:np(2)-1,0:np(3)-1),
     *                                                   stat = ierv(2))

          ierr = sum(ierv)
          if (ierr.ne.0) then
              write(*,*) 'MappaCorrezione Allocation Error'
              call cstop(' ')
          endif
          xmap2    = 0.0
          xmap2sav = 0.0
      else
          IF (ALLOCATED(xmap2))
     *        DEALLOCATE (xmap2,xmap2sav,stat = ierr)
          if (ierr.ne.0) then
              write(*,*) 'MappaCorrezione DeAllocation Error'
              call cstop(' ')
          endif
      endif
!
      return
      end
!------------------------------------------------------------------------------
      subroutine AllocaMapShi(iAction)
      USE MapShi
      USE Mappa, only : np
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
      ierr = 0
      if (iAction == 1) then
          IF (.NOT. ALLOCATED(RhoMap))
     *    ALLOCATE (RhoMap(0:np(1)-1,0:np(2)-1,0:np(3)-1), stat=ier1)
!
          IF (.NOT. ALLOCATED(RhoMapShi))
     *    ALLOCATE (RhoMapShi(0:np(1)-1,0:np(2)-1,0:np(3)-1), stat=ier2)
!
          IF (.NOT. ALLOCATED(RhoMapComb))
     *    ALLOCATE (RhoMapComb(0:np(1)-1,0:np(2)-1,0:np(3)-1),stat=ier3)
!
          IF (.NOT. ALLOCATED(RhoMapApp))
     *    ALLOCATE (RhoMapApp(0:np(1)-1,0:np(2)-1,0:np(3)-1), stat=ier4)
!
          ierr = ier1+ier2+ier3+ier4
          if (ierr.ne.0) then
              write(*,*) 'MapShi Allocation Error'
              call cstop(' ')
          endif
          RhoMap = 0.0
          RhoMapShi = 0.0
          RhoMapComb = 0.0
          RhoMapApp = 0.0
      else
          IF (ALLOCATED(RhoMap))
     *        DEALLOCATE (RhoMap, RhoMapShi, RhoMapComb, RhoMapApp,
     *                                                stat = ierr)
          if (ierr.ne.0) then
              write(*,*) 'MapShi DeAllocation Error'
              call cstop(' ')
          endif
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaCorrMod(iAction)
      USE General, only : nrefl
      USE Atomi, only : MaxAtoms
      USE Mappa, only : np
      USE CorrMod
!
!-- Allocate / Deallocate arrays  ( iAction = 1,3 / 2 )
!
      dimension ierv(9)
!
      ierv(:) = 0
!
      ierr = 0
      if (iAction == 1) then  ! IndagaMappa

          ndim_map = np(1)*np(2)*np(3)
          IF (.NOT. ALLOCATED(distr))
     *        ALLOCATE (distr(1:ndim_map),      stat = ierv(1))

          IF (.NOT. ALLOCATED(fourr))
     *        ALLOCATE (fourr(1:ndim_map),      stat = ierv(2))

          IF (.NOT. ALLOCATED(fourrr))
     *        ALLOCATE (fourrr(1:ndim_map,1:2),  stat = ierv(3))

          ierr = sum(ierv)
          if (ierr.ne.0) then
              write(*,*) 'CorrMod Allocation Error'
              call cstop(' ')
          endif

          distr(:) = 0.0
          fourr(:) = 0.0
          fourrr(:,:) = 0.0

      elseif (iAction == 3) then  ! Proc_Bias

          IF (.NOT. ALLOCATED(work_bf))
     *        ALLOCATE (work_bf(1:MaxAtoms),  stat = ierv(4))
          IF (.NOT. ALLOCATED(wtRB))
     *        ALLOCATE (wtRB(1:2,1:nrefl),    stat = ierv(5))
          IF (.NOT. ALLOCATED(iphRB))
     *        ALLOCATE (iphRB(1:2,1:nrefl),   stat = ierv(6))
          IF (.NOT. ALLOCATED(fcoefRB))
     *        ALLOCATE (fcoefRB(1:nrefl),     stat = ierv(7))

          ierr = sum(ierv)
          if (ierr.ne.0) then
              write(*,*) 'CorrMod Allocation Error'
              call cstop(' ')
          endif

          work_bf(:) = 0.0
          wtRB(:,:) = 0.0
          iphRB(:,:) = 0.0
          fcoefRB(:) = 0.0

      else

          IF (ALLOCATED(distr))
     *        DEALLOCATE (distr,fourr,fourrr, stat = ierr)
          IF (ALLOCATED(work_bf))
     *        DEALLOCATE (work_bf,wtRB,iphRB,fcoefRB, stat = ierr)
          if (ierr.ne.0) then
              write(*,*) 'CorrMod DeAllocation Error'
              call cstop(' ')
          endif
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaC_EDM(iAction)
      USE General, only : nrefl,nreflDim
      USE Mappa, only : np
      USE C_EDM

!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
      dimension ierv(15)
!
      ierv(:) = 0
!
      ierr = 0
      if (iAction == 1) then

          IF (.NOT. ALLOCATED(mkangSav))
     *        ALLOCATE (mkangSav(1:nreflDim),  stat = ierv(1))
          IF (.NOT. ALLOCATED(puntatore))
     *        ALLOCATE (puntatore(1:nreflDim),  stat = ierv(2))
          IF (.NOT. ALLOCATED(EobsEp))
     *        ALLOCATE (EobsEp(1:nreflDim),  stat = ierv(3))
          IF (.NOT. ALLOCATED(xPrec))
     *        ALLOCATE (xPrec(1:nreflDim),  stat = ierv(4))
          IF (.NOT. ALLOCATED(fcPrec))
     *        ALLOCATE (fcPrec(1:nreflDim),  stat = ierv(5))
          IF (.NOT. ALLOCATED(fcoefSav))
     *        ALLOCATE (fcoefSav(1:nreflDim),  stat = ierv(6))
          IF (.NOT. ALLOCATED(wtNew))
     *        ALLOCATE (wtNew(1:nreflDim),  stat = ierv(7))
          IF (.NOT. ALLOCATED(wtHis))
     *        ALLOCATE (wtHis(1:nreflDim),  stat = ierv(8))
          IF (.NOT. ALLOCATED(wtSav))
     *        ALLOCATE (wtSav(1:nreflDim),  stat = ierv(9))
          IF (.NOT. ALLOCATED(wtSSav))
     *        ALLOCATE (wtSSav(1:nreflDim),  stat = ierv(10))

          IF (.NOT. ALLOCATED(xpat))
     *    ALLOCATE (xpat(0:np(1)-1,0:np(2)-1,0:np(3)-1),stat = ierv(11))

          ierr = sum(ierv)
          if (ierr.ne.0) then
              write(*,*) 'C_EDM Allocation Error'
              call cstop(' ')
          endif

          EobsEp(:) = 0.0
          xPrec(:) = 0.0
          fcPrec(:) = 0.0
          fcoefSav(:) = 0.0
          wtNew(:) = 0.0
          wtHis(:) = 0.0
          wtSav(:) = 0.0
          wtSSav(:) = 0.0
          mkangSav(:) = 0
          puntatore(:) = 0

          xpat(:,:,:) = 0
          denmaxPatt = 0.0
       
      else
          IF (ALLOCATED(EobsEp))
     *        DEALLOCATE (EobsEp, xPrec, fcPrec, fcoefSav,
     *                    wtNew, wtHis, wtSav, wtSSav,
     *                    mkangSav, puntatore, xpat, stat = ierr)
          if (ierr.ne.0) then
              write(*,*) 'C_EDM DeAllocation Error'
              call cstop(' ')
          endif
      endif
!
      return
      end
! ----------------------------------------------------------------------
*      subroutine AllocaRiflessiSIGMAA(iAction)
*      USE General
*      USE RiflessiSIGMAA
*      USE ShellSIGMAA
*!
*!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
*!
*      dimension ierv(20)
*!
*      ierv(:) = 0
*      ierr = 0
*!
*      if (iAction == 1) then
*          IF (.NOT. ALLOCATED(wto))
*     *     ALLOCATE (wto(1:nreflDim)   ,stat = ierv(1))
*          IF (.NOT. ALLOCATED(iphio))
*     *     ALLOCATE (iphio(1:nreflDim)   ,stat = ierv(2))
*          IF (.NOT. ALLOCATED(foper))
*     *     ALLOCATE (foper(1:nreflDim)   ,stat = ierv(3))
*          IF (.NOT. ALLOCATED(iphoper))
*     *     ALLOCATE (iphoper(1:nreflDim)   ,stat = ierv(4))
*          IF (.NOT. ALLOCATED(fper))
*     *     ALLOCATE (fper(1:nreflDim)   ,stat = ierv(5))
*          IF (.NOT. ALLOCATED(iphper))
*     *     ALLOCATE (iphper(1:nreflDim)   ,stat = ierv(6))
*          IF (.NOT. ALLOCATED(wt_in))
*     *     ALLOCATE (wt_in(1:nreflDim)   ,stat = ierv(7))
*          IF (.NOT. ALLOCATED(iphaz_in))
*     *     ALLOCATE (iphaz_in(1:nreflDim)   ,stat = ierv(8))
*!
*          ierr = sum(iabs( ierv(:) ))
*          if (ierr.ne.0) then
*              write(lo,*) 'RiflessiSIGMAA Allocation error'
*              call cstop(' ')
*          endif
*          wto(:)      = 0
*          iphio(:)    = 0
*          wt_in(:)    = 0
*          iphaz_in(:) = 0
*      else
*          IF (ALLOCATED(wto))
*     *        DEALLOCATE (wto, iphio, foper, iphoper,
*     *        fper, iphper, wt_in, iphaz_in, stat = ierr)
*          if (ierr.ne.0) then
*              write(*,*) 'RiflessiSIGMAA DeAllocation Error'
*              call cstop(' ')
*          endif
*          IF (ALLOCATED(midpts)) deallocate(midpts, RES_TAG, stat=ierr)
*      endif
*!
*      return
*      end
! ----------------------------------------------------------------------
      subroutine AllocaLsqStuff(iAction)
      USE Atomi
      USE LsqStuff
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
!
      integer :: YYY
      dimension ierv(100)
!             real, allocatable    :: shiftMnqd(:)

      ierv(:) = 0
      ierr    = 0
      if (iAction == 1) then
          YYY = 1
          if (.not.Allocated(kFix))
     *       Allocate(kfix(1:nParMax,1:NumOggettiMax), stat = ierv(YYY))
          YYY = YYY + 1
          if (.not.Allocated(iEquiv))
     *  Allocate(iEquiv(1:nParMax,1:3,1:NumOggettiMax),stat = ierv(YYY))
          YYY = YYY + 1
          if (.not.Allocated(nab))
     *        Allocate(nab(1:NumOggettiMax+1),         stat = ierv(YYY))
          YYY = YYY + 1
          if (.not.Allocated(nParBl))
     *      Allocate(nParBl(1:nParMax,1:NumOggettiMax),stat = ierv(YYY))
          YYY = YYY + 1
          if (.not.Allocated(Jaffina))
     *        Allocate(Jaffina(1:NumOggettiMax),       stat = ierv(YYY))
          YYY = YYY + 1
          if (.not.Allocated(ckFix))
     *        Allocate(ckFix(1:NumOggettiMax),         stat = ierv(YYY))
          YYY = YYY + 1
          if (.not.Allocated(ckEquiv))
     *        Allocate(ckEquiv(1:NumOggettiMax),       stat = ierv(YYY))
          YYY = YYY + 1
          if (.not.Allocated(nAddrDer))
     *  Allocate(nAddrDer(1:nParMax,1:NumOggettiMax),  stat = ierv(YYY))
          YYY = YYY + 1
          if (.not.Allocated(shiftMnqd))
     *        Allocate(shiftMnqd(1:nParMax,1:MaxAtoms),stat = ierv(YYY))
!     
          ierr = sum(ierv(1:YYY))
          if (ierr.ne.0) then
              write(*,*) 'LsqStuff Allocation Error'
              call cstop(' ')
          endif
          kFix(:,:)=0
          iEquiv(:,:,:)=0
          nab(:)=0
          nParBl(:,:)=0
          Jaffina(:)=0
          ckFix(:)=0
          ckEquiv(:)=0
          nAddrDer(:,:)=0 
          shiftMnqd(:,:)=0.0
      else
          IF (Allocated(kfix))
     *        Deallocate ( kFix, iEquiv, nab, nParBl, 
     *           Jaffina,ckFix, ckEquiv,nAddrDer,
     *           shiftMnqd, stat = ierr)
          if (ierr.ne.0) then
              write(*,*) 'LsqStuff DeAllocation Error'
              call cstop(' ')
          endif

      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaLsqStuff12(iAction)
      USE LsqStuff
      USE LsqStuff12
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
!
      integer :: YYY
      dimension ierv(10)
!
      ierv(:) = 0
      ierr    = 0
      if (iAction == 1) then
          YYY = 1
          if (.not.Allocated(idir12))
     *        Allocate(idir12(1:NumCond12),          stat = ierv(YYY))
          YYY = YYY + 1
          if (.not.Allocated(stringa12Tot))
     *        Allocate(stringa12Tot(1:NumCond12),    stat = ierv(YYY))
!
          ierr = sum(ierv(1:YYY))
          if (ierr.ne.0) then
              write(*,*) 'LsqStuff12 Allocation Error'
              call cstop(' ')
          endif
          idir12(:)=0
          stringa12Tot(:)=' '
      else
          IF (Allocated(idir12))
     *        Deallocate ( idir12,stringa12Tot, stat = ierr)

          if (ierr.ne.0) then
              write(*,*) 'LsqStuff12 DeAllocation Error'
              call cstop(' ')
          endif

      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaLsqStuff12_Sav(iAction)
      USE LsqStuff
      USE LsqStuff12
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
!
      integer :: YYY
      dimension ierv(10)
!
      ierv(:) = 0
      ierr    = 0
      if (iAction == 1) then
          YYY = 1
          if (.not.Allocated(idir12_Sav))
     *        Allocate(idir12_Sav(1:NumCond12_Sav),   stat = ierv(YYY))
          YYY = YYY + 1
          if (.not.Allocated(stringa12Tot_Sav))
     *        Allocate(stringa12Tot_Sav(1:NumCond12_Sav),stat=ierv(YYY))
! 
          ierr = sum(ierv(1:YYY))
          if (ierr.ne.0) then
              write(*,*) 'LsqStuff12_Sav Allocation Error'
              call cstop(' ')
          endif
          idir12_Sav(:)=0
          stringa12Tot_Sav(:)=' '
      else
          IF (Allocated(idir12_Sav))
     *        Deallocate ( idir12_Sav,stringa12Tot_Sav,    stat = ierr)

          if (ierr.ne.0) then
              write(*,*) 'LsqStuff12_Sav DeAllocation Error'
              call cstop(' ')
          endif

      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaLsqStuff12_byUser(iAction)
      USE LsqStuff
      USE LsqStuff12_byUser
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
      integer :: YYY
      dimension ierv(10)
!
      ierv(:) = 0
      ierr    = 0
      if (iAction == 1) then
          YYY = 1
          if (.not.Allocated(idir12_byUser))
     *        Allocate(idir12_byUser(1:NumCond12_byUser),
     *                stat = ierv(YYY))
          YYY = YYY + 1
          if (.not.Allocated(stringa12_byUser))
     *        Allocate(stringa12_byUser(1:NumCond12_byUser), 
     *                stat = ierv(YYY))
!
          ierr = sum(ierv(1:YYY))
          if (ierr.ne.0) then
              write(*,*) 'LsqStuff12_byUser Allocation Error'
              call cstop(' ')
          endif
          stringa12_byUser(:)=' '
      else
          IF (Allocated(stringa12_byUser))
     *        Deallocate (idir12_byUser, stringa12_byUser, stat = ierr)
     
          if (ierr.ne.0) then
              write(*,*) 'LsqStuff12_byUser DeAllocation Error'
              call cstop(' ')
          endif

      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaLsqStuff12_RT(iAction)
      USE LsqStuff
      USE LsqStuff12
      USE LsqStuff12_RT
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
!
      integer :: YYY
      dimension ierv(100)
!
      ierv(:) = 0
      ierr    = 0
      if (iAction == 1) then
          YYY = 1
          if (.not.Allocated(idir12_C))
     *        Allocate(idir12_C(1:NumCond12_C),       stat = ierv(YYY))
          YYY = YYY + 1
          if (.not.Allocated(stringa12Tot_C))
     *        Allocate(stringa12Tot_C(1:NumCond12_C),  stat = ierv(YYY))
          YYY = YYY + 1
          if (.not.Allocated(icodeequiv12))
     *        Allocate(icodeequiv12(1:NumCond12_C), stat = ierv(YYY))
          YYY = YYY + 1
          if (.not.Allocated(stringa12))
     *        Allocate(stringa12(1:NumCond12_C),    stat = ierv(YYY))
          YYY = YYY + 1
          if (.not.Allocated(codeparam12))
     *        Allocate(codeparam12(1:nParMax,1:NumCond12_C),
     *                stat = ierv(YYY))
          YYY = YYY + 1
          if (.not.Allocated(codeatom12))
     *        Allocate(codeatom12(1:4,1:NumCond12_C),stat = ierv(YYY))
          YYY = YYY + 1
          if (.not.Allocated(valuetarget12))
     *        Allocate(valuetarget12(1:NumCond12_C), stat = ierv(YYY))
          YYY = YYY + 1
          if (.not.Allocated(valuesigma12))
     *        Allocate(valuesigma12(1:NumCond12_C),   stat = ierv(YYY))
          YYY = YYY + 1
          if (.not.Allocated(valuesig12))
     *        Allocate(valuesig12(1:3,1:NumCond12_C),stat = ierv(YYY))
          YYY = YYY + 1
          if (.not.Allocated(nvres12))
     *        Allocate(nvres12(1:NumCond12_C),       stat = ierv(YYY))
!
         ierr = sum(ierv(1:YYY))
          if (ierr.ne.0) then
              write(*,*) 'LsqStuff12_RT Allocation Error'
              call cstop(' ')
          endif
          idir12_C(:)=0
          stringa12Tot_C(:)=' '
          icodeequiv12(:)=0
          stringa12(:)=' '
          codeparam12(:,:)=0
          codeatom12(:,:)=0
          valuetarget12(:)=0.0
          valuesigma12(:)=0.0
          valuesig12(:,:)=0.0
          nvres12(:)=0
      else
          IF (Allocated(idir12_C))
     *        Deallocate ( idir12_C,stringa12Tot_C,
     *           codeparam12,icodeequiv12,stringa12,
     *           valuetarget12,valuesigma12,nvres12,
     *           valuesig12,codeatom12, stat = ierr)
          if (ierr.ne.0) then
              write(*,*) 'LsqStuff12_RT DeAllocation Error'
              call cstop(' ')
          endif

      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaLsqStuff22(iAction)
      USE LsqStuff
      USE LsqStuff22
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
!
      integer :: YYY
      dimension ierv(100)
!
      ierv(:) = 0
      ierr    = 0
      if (iAction == 1) then
          YYY = 1
          if (.not.Allocated(BlAddr))
     *        Allocate(BlAddr(1:NumBlockTot), stat = ierv(YYY))
          ierr = sum(ierv(1:YYY))
          if (ierr.ne.0) then
              write(*,*) 'LsqStuff22 Allocation Error'
              call cstop(' ')
          endif
          BlAddr(:)=0
      else
          IF (Allocated(BlAddr))
     *        Deallocate ( BlAddr, stat = ierr)
          if (ierr.ne.0) then
              write(*,*) 'LsqStuff22 DeAllocation Error'
              call cstop(' ')
          endif

      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaLsqStuff22Abs(iAction)
      USE LsqStuff
      USE LsqStuff22Abs
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
!      NumBlockTot (ex n22)  = numero di blocchi
!      NParTot = numero di parametri da affinare
!      DimMatMax = numero massimo (matrice triangolare)
!      NParBlMax = numero massimo di parametri per blocco
!      NumDerParz= ex jq  numero di derivate parz. per parametro
!--alloca vettori(2 vuol dire: 1 pos per atomo, 2 pos per parametro): 
!                  ParAddr(NumBlockTot,NParBlMax,2)
!                  EquaNorm(DimMatMax,NumBlockTot)
!                  VettNorm(NParBlMax,NumBlockTot)
!                  BuffNorm(NParBlMax,NumBlockTot)
!                  DeriPerz(NumBlockTot,NParBlMax,NumDerParz)
!                  DeriTot(NumBlockTot,NParBlMax)
!
      integer :: YYY
      dimension ierv(100)
!
      ierv(:) = 0
      ierr    = 0
      if (iAction == 1) then
          YYY = 1
          if (.not.Allocated(ParAddr))
     *     Allocate(ParAddr(1:NumBlockTot,1:NParBlMax,1:2),
     *                stat = ierv(YYY))
          YYY = YYY + 1
          if(.not.Allocated(EquaNorm))
     *       Allocate(EquaNorm(1:DimMatMax,1:NumBlockTot),
     *                stat = ierv(YYY))
          YYY = YYY + 1
          if(.not.Allocated(VettNorm))
     *       Allocate(VettNorm(1:NParBlMax,1:NumBlockTot),
     *                stat = ierv(YYY))
          YYY = YYY + 1
          if(.not.Allocated(DeriPerz))
     *     Allocate(DeriPerz(1:NumBlockTot,1:NParBlMax,1:NumDerParz),
     *             stat = ierv(YYY))
          YYY = YYY + 1
          if(.not.Allocated(DeriTot))
     *     Allocate(DeriTot(1:NumBlockTot,1:NParBlMax),stat = ierv(YYY))
          YYY = YYY+1
          if (.not.Allocated(BuffNorm))
     *        Allocate(BuffNorm(1:NParBlMax,1:NumBlockTot),
     *                stat = ierv(YYY))
          ierr = sum(ierv(1:YYY))
          if (ierr.ne.0) then
              write(*,*) 'LsqStuff22 Allocation Error'
              call cstop(' ')
          endif
          ParAddr(:,:,:)=0
          EquaNorm(:,:)=0
          VettNorm(:,:)=0
          DeriPerz(:,:,:)=0
          DeriTot(:,:)=0
          BuffNorm(:,:)=0
      else
          IF (Allocated(ParAddr))
     *        Deallocate ( ParAddr,EquaNorm,DeriPerz,DeriTot
     *                    ,VettNorm,BuffNorm, stat = ierr)
          if (ierr.ne.0) then
              write(*,*) 'LsqStuff22 DeAllocation Error'
              call cstop(' ')
          endif

      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaLsqRestraint(iAction)
      USE LsqStuff
      USE LsqRestraint
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
!
      integer :: YYY
      dimension ierv(10)
!
      ierv(:) = 0
      ierr    = 0
      if (iAction == 1) then
          YYY = 1
          if (.not.Allocated(idirRestraint))
     *        Allocate(idirRestraint(1:NumRestraint),  stat = ierv(YYY))
          YYY = YYY + 1
          if (.not.Allocated(stringaRestraint))
     *       Allocate(stringaRestraint(1:NumRestraint),stat = ierv(YYY))
!
         ierr = sum(ierv(1:YYY))
          if (ierr.ne.0) then
              write(*,*) 'LsqRestraint Allocation Error'
              call cstop(' ')
          endif
          idirRestraint(:)=0
          stringaRestraint(:)=' '
      else
          IF (Allocated(idirRestraint))
     *        Deallocate ( idirRestraint,stringaRestraint, stat = ierr)

          if (ierr.ne.0) then
              write(*,*) 'LsqRestraint DeAllocation Error'
              call cstop(' ')
          endif

      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaLsqGroups(iAction)
      USE Atomi
      USE LsqStuff
      USE LsqGroupsStuff
!
      integer           :: YYY
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
      dimension ierv(100)
!
      if (iAction == 1 .and. Allocated(NumAtomsGroup)) then
          return
      endif
      ierv(:) = 0
      ierr = 0
      
!
      if (iAction <= 1) then
          YYY = 1
          if (.not.Allocated(NumAtomsGroup))
     *        Allocate(NumAtomsGroup(1:NumGroup), stat = ierv(YYY))  ! 1
          YYY = YYY + 1
          if (.not.Allocated(JcodeFrag))
     *        Allocate(JcodeFrag(1:NumGroup),     stat = ierv(YYY))  ! 2
          YYY = YYY + 1
          if (.not.Allocated(IsoAnisoGroup))
     *        Allocate(IsoAnisoGroup(1:NumGroup), stat = ierv(YYY))  ! 3
          YYY = YYY + 1
          if (.not.Allocated(TypeGroup))
     *        Allocate(TypeGroup(1:NumGroup),     stat = ierv(YYY))  ! 4
          YYY = YYY + 1
          if (.not.Allocated(NserialGroup))
     *        Allocate(NserialGroup(1:NumGroup),  stat = ierv(YYY))  ! 5
          YYY = YYY + 1
          if (.not.Allocated(XGroup))
     *        Allocate(XGroup(1:3,1:NumGroup),    stat = ierv(YYY))  ! 6
               YYY = YYY + 1
          if (.not.Allocated(BisoGroup))
     *        Allocate(BisoGroup(1:NumGroup),     stat = ierv(YYY))  ! 7
          YYY = YYY + 1
          if (.not.Allocated(BijGroup))
     *        Allocate(BijGroup(1:6,1:NumGroup),   stat = ierv(YYY)) ! 8
          YYY = YYY + 1
          if (.not.Allocated(OccGroup))
     *        Allocate(OccGroup(1:NumGroup),       stat = ierv(YYY)) ! 9
          YYY = YYY + 1
          if (.not.Allocated(ThetaGroup))
     *        Allocate(ThetaGroup(1:NumGroup),     stat = ierv(YYY)) ! 10
          YYY = YYY + 1
          if (.not.Allocated(PhiGroup))
     *        Allocate(PhiGroup(1:NumGroup),       stat = ierv(YYY)) ! 11
          YYY = YYY + 1
          if (.not.Allocated(PsiGroup))
     *        Allocate(PsiGroup(1:NumGroup),       stat = ierv(YYY)) ! 12
          YYY = YYY + 1
          if (.not.Allocated(SXGroup))
     *        Allocate(SXGroup(1:3,1:NumGroup),    stat = ierv(YYY)) ! 13
          YYY = YYY + 1
          if (.not.Allocated(SBisoGroup))
     *        Allocate(SBisoGroup(1:NumGroup),     stat = ierv(YYY)) ! 14
          YYY = YYY + 1
          if (.not.Allocated(SBijGroup))
     *        Allocate(SBijGroup(1:6,1:NumGroup),  stat = ierv(YYY)) ! 15
          YYY = YYY + 1
          if (.not.Allocated(SOccGroup))
     *        Allocate(SOccGroup(1:NumGroup),      stat = ierv(YYY)) ! 16
          YYY = YYY + 1
          if (.not.Allocated(SThetaGroup))
     *        Allocate(SThetaGroup(1:NumGroup),    stat = ierv(YYY)) ! 17
          YYY = YYY + 1
          if (.not.Allocated(SPhiGroup))
     *        Allocate(SPhiGroup(1:NumGroup),      stat = ierv(YYY)) ! 18
          YYY = YYY + 1
          if (.not.Allocated(SPsiGroup))
     *        Allocate(SPsiGroup(1:NumGroup),      stat = ierv(YYY)) ! 19
          YYY = YYY + 1
          if (.not.Allocated(shiftMnqdGroup))
     *  Allocate(shiftMnqdGroup(1:nParMax,1:NumGroup),stat = ierv(YYY)) ! 20
          YYY = YYY + 1
          if (.not.Allocated(JflagGroup))
     *        Allocate(JflagGroup(1:NumGroup),     stat = ierv(YYY)) ! 21
          YYY = YYY + 1
          if (.not.Allocated(NameGroup))
     *        Allocate(NameGroup(1:4,1:NumGroup),  stat = ierv(YYY)) ! 22
          YYY = YYY + 1
          if (.not.Allocated(ThetaDer))
     *        Allocate(ThetaDer(1:3,1:3,1:NumGroup),stat = ierv(YYY))! 23
          YYY = YYY + 1
          if (.not.Allocated(PhiDer))
     *        Allocate(PhiDer(1:3,1:3,1:NumGroup), stat = ierv(YYY)) ! 24
          YYY = YYY + 1
          if (.not.Allocated(PsiDer))
     *        Allocate(PsiDer(1:3,1:3,1:NumGroup), stat = ierv(YYY)) ! 25
          YYY = YYY + 1
          if (.not.Allocated(GGroup))
     *        Allocate(GGroup(1:3,1:3,1:NumGroup), stat = ierv(YYY)) ! 26
          YYY = YYY + 1
          if (.not.Allocated(XOrtoGroup))
     *        Allocate(XOrtoGroup(1:3,1:MaxAtomsGroup,1:NumGroup),
     *                                             stat = ierv(YYY)) ! 27
          YYY = YYY + 1
          if (.not.Allocated(NordGroup))
     *        Allocate(NordGroup(1:NumGroup),      stat = ierv(YYY)) ! 28
          YYY = YYY + 1
          if (.not.Allocated(aLabPrintGroup))
     *    Allocate(aLabPrintGroup(1:MaxAtomsGroup,1:NumGroup), 
     *                                             stat = ierv(YYY)) ! 29
          YYY = YYY + 1
          if (.not.Allocated(aLabGroup))
     *        Allocate(aLabGroup(1:NumGroup),      stat = ierv(YYY)) ! 30

          YYY = YYY + 1
          if (.not.Allocated(RigheGroup))
     *        Allocate(RigheGroup(1:NumRigheGroup), stat = ierv(YYY)) ! 31

          YYY = YYY + 1
          if (.not.Allocated(NordAtomsGroup))
     *    Allocate(NordAtomsGroup(1:MaxAtomsGroup,1:NumGroup),
     *                                             stat = ierv(YYY)) ! 32

          if (.not.Allocated(XCrystGroup))
     *        Allocate(XCrystGroup(1:3,1:MaxAtomsGroup,1:NumGroup),
     *                                             stat = ierv(YYY)) ! 33

          if (.not.Allocated(NameLongGroup))
     *        Allocate(NameLongGroup(1:NumGroup),  stat = ierv(YYY)) ! 34

!     
          ierr = sum(ierv(1:YYY))
          if (ierr.ne.0) then
              write(*,*) 'Group(s) Allocation Error'
              call cstop(' ')
          endif
!          
          shiftMnqdGroup(:,:) = 0.0
          NumAtomsGroup(:)  = 0
          JcodeFrag(:)  = 0
          IsoAnisoGroup(:)  = 0
          TypeGroup(:)  = 0
          NserialGroup(:)  = 0
          XGroup(:,:)  = 0.0
          BisoGroup(:)  = 0.0
          BijGroup(:,:)  = 0.0
          OccGroup(:)  = 0.0
          ThetaGroup(:)  = 0.0
          PhiGroup(:)  = 0.0
          PsiGroup(:)  = 0.0
          SXGroup(:,:)  = 0.0
          SBisoGroup(:)  = 0.0
          SBijGroup(:,:)  = 0.0
          SOccGroup(:)  = 0.0
          SThetaGroup(:)  = 0.0
          SPhiGroup(:)  = 0.0
          SPsiGroup(:)  = 0.0
          JflagGroup(:) = 0
          ThetaDer(:,:,:) = 0.0
          PhiDer(:,:,:) = 0.0
          PsiDer(:,:,:) = 0.0
          GGroup(:,:,:) = 0.0
          XOrtoGroup(:,:,:) = 0.0
          XCrystGroup(:,:,:) = 0.0
          NordGroup(:) = 0
          aLabPrintGroup(:,:) = ' '
          aLabGroup(:) = ' '
          RigheGroup(:)=' '
          NordAtomsGroup(:,:) = 0
          NameLongGroup(:)=' '
      else
!          NumGroup = 0
!          MaxAtomsGroup = 0
!          NumOggettiMax = MaxAtoms + NumOverall
          IF (Allocated(NumAtomsGroup)) then
              Deallocate (NumAtomsGroup,JcodeFrag,        stat=ierv( 1))
              Deallocate (IsoAnisoGroup,TypeGroup,        stat=ierv( 2))
              Deallocate (NserialGroup,XGroup,BisoGroup,  stat=ierv( 3))
              Deallocate (BijGroup,OccGroup,ThetaGroup,   stat=ierv( 4))
              Deallocate (PhiGroup,PsiGroup,SXGroup,      stat=ierv( 5))
              Deallocate (SBisoGroup,SBijGroup,SOccGroup, stat=ierv( 6))
            Deallocate (SThetaGroup, SPhiGroup,SPsiGroup, stat=ierv( 7))
              Deallocate (JflagGroup,NameGroup,ThetaDer,  stat=ierv( 8))
              Deallocate (PhiDer, PsiDer, GGroup,         stat=ierv( 9))
              Deallocate (XOrtoGroup, shiftMnqdGroup,     stat=ierv(10))
              Deallocate (aLabPrintGroup,aLabGroup,       stat=ierv(11))
              Deallocate (RigheGroup,NordAtomsGroup,      stat=ierv(12))
              Deallocate (XCrystGroup,NameLongGroup,      stat=ierv(13))
              Deallocate (NordGroup,                      stat=ierv(14))
          endif
          ierr = sum(ierv(:))
          if (ierr.ne.0) then
              write(*,*) 'Group(s) DeAllocation Error'
              call cstop(' ')
          endif

      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaHydroStuff(iAction)
      USE HydroStuff
      integer           :: YYY
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
!
      dimension ierv(100)
!
      ierv(:) = 0
      ierr = 0
     
!
      if (iAction == 1) then
!
          YYY = 0
          YYY = YYY + 1
          if(.not.Allocated(ibridc))
     *        Allocate(ibridc(1:MaxAtomsH),     stat = ierv(YYY))
          YYY = YYY + 1
          if(.not.Allocated(nhyold))
     *        Allocate(nhyold(1:MaxAtomsH),     stat = ierv(YYY))
          YYY = YYY + 1
          if(.not.Allocated(chdist))
     *        Allocate(chdist(1:MaxAtomsH),     stat = ierv(YYY))
          YYY = YYY + 1
          if(.not.Allocated(idisorder))
     *        Allocate(idisorder(1:MaxAtomsH),  stat = ierv(YYY))
          YYY = YYY + 1
          if(.not.Allocated(ibtab))
     *        Allocate(ibtab(1:MaxAtomsH,1:10), stat = ierv(YYY))
          YYY = YYY + 1
          if(.not.Allocated(hibtab))
     *        Allocate(hibtab(1:MaxAtomsH,1:10),stat = ierv(YYY))
          YYY = YYY + 1
          if(.not.Allocated(lconlun))
     *        Allocate(lconlun(1:12,1:MaxAtomsH),stat = ierv(YYY))
          YYY = YYY + 1
          if(.not.Allocated(HydroInfo))
     *        Allocate(HydroInfo(1:MaxAtomsH),stat = ierv(YYY))
          ierr = sum(ierv(1:YYY))
          if (ierr.ne.0) then
              write(*,*) 'HydroStuff Allocation Error'
              call cstop(' ')
          endif
      else
          IF (Allocated(ibridc))
     *        Deallocate (ibridc, nhyold, chdist, idisorder,
     *        ibtab, hibtab, lconlun, HydroInfo, stat = ierr)
          if (ierr.ne.0) then
              write(*,*) 'HydroStuff DeAllocation Error'
              call cstop(' ')
          endif
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaHistoStuff(iAction)
      USE General
      USE HistoStuff
      USE PhaseModule
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
      dimension ierv(4)

      if (kmad /= 0) return

      ierr = 0
      ierv(:) = 0
      if (iAction == 1) then
              IF (.NOT. ALLOCATED(vetmatchin))
     *     ALLOCATE (vetmatchin(1:nreflDim),   stat = ierv(1))
              IF (.NOT. ALLOCATED(hisobco4))
     *     ALLOCATE (hisobco4(1:4, 1:nreflDim), stat = ierv(4))
          if (numbGen > 0) then
              IF (.NOT. ALLOCATED(hisobco))
     *     ALLOCATE (hisobco(1:2, 1:nreflDim), stat = ierv(2))
              IF (.NOT. ALLOCATED(hiscaco))
     *     ALLOCATE (hiscaco(1:2, 1:nreflDim), stat = ierv(3))
          endif
          ierr = sum(ierv)
          if (ierr.ne.0) then
              write(lo,*) 'HistoStuff Allocation error '
              call cstop(' ')
          endif
          vetmatchin(:) = 0
          hisobco4(:,:) = 0
          if (numbGen > 0) then
              hisobco(:,:) = 0
              hiscaco(:,:) = 0
          endif
      else
          IF (ALLOCATED(vetmatchin))
     *        DEALLOCATE (vetmatchin,hisobco4, stat = ierr)
          IF (ALLOCATED(hisobco))
     *        DEALLOCATE (hisobco, hiscaco, stat = ierr)
          if (ierr.ne.0) then
              write(*,*) 'HistoStuff DeAllocation Error'
              call cstop(' ')
          endif
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaMAD(iAction)
      USE General
      USE MADStuff
      USE MadModule
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
      dimension ierv(20)
!
      do i=1,20
         ierv(i) = 0
      enddo
      ierr = 0
!
      if (iAction == 1) then
      nrefp = nrefl / 2
      IF (.NOT. ALLOCATED(eMadP))
     *   ALLOCATE (eMadP(1:nrefp,1:nWave),stat = ierv(1))
      IF (.NOT. ALLOCATED(eMadM))
     *   ALLOCATE (eMadM(1:nrefp,1:nWave),stat = ierv(2))
      IF (.NOT. ALLOCATED(idvet))
     *   ALLOCATE (idvet(1:nrefl),stat = ierv(2))
      IF (.NOT. ALLOCATED(idvet1)) 
     *   ALLOCATE (idvet1(1:nrefp),stat = ierv(3))
      IF (.NOT. ALLOCATED(iordm)) 
     *   ALLOCATE (iordm(1:nrefl,1:nWave),stat = ierv(4))
      IF (.NOT. ALLOCATED(iinr)) 
     *   ALLOCATE (iinr(1:nrefl),stat = ierv(5))
      IF (.NOT. ALLOCATED(eme)) 
     *   ALLOCATE (eme(1:nrefl),stat = ierv(6))
      IF (.NOT. ALLOCATED(idvetP)) 
     *   ALLOCATE (idvetP(1:nrefl),stat = ierv(7))
      IF (.NOT. ALLOCATED(evero)) 
     *   ALLOCATE (evero(1:nrefl),stat = ierv(8))
      IF (.NOT. ALLOCATED(fvero)) 
     *   ALLOCATE (fvero(1:nrefl),stat = ierv(9))
      IF (.NOT. ALLOCATED(emesus)) 
     *     ALLOCATE (emesus(1:nrefl,1:20) ,stat = ierv(10))


          ierr = 0
          do i=1,10
             ierr = ierr + iabs( ierv(i) )
          enddo
          if (ierr.ne.0) then
              write(lo,*) 'MAD Allocation error'
              call cstop(' ')
          endif
          eMadP   = 0
          eMadM   = 0
          idvet  = 0
          idvet1 = 0
          iordm  = 0
          iinr   = 0
          eme    = 0
          idvetP = 0
          evero  = 0
          fvero  = 0
          emesus = 0
      else
          IF (ALLOCATED(eMadP))
     *       DEALLOCATE (eMadP,eMadM,iordm,idvet,idvet1,iinr,eme,
     *                   fvero,emesus, stat = ierr)
          if (ierr.ne.0) then
              write(*,*) 'MAD DeAllocation Error'
              call cstop(' ')
          endif
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaIsr(iAction)
      USE General
      USE IsrCom
!
      ierr = 0
      if (iAction == 1) then
          IF (.NOT. ALLOCATED(isr))
     *        ALLOCATE (isr(1:ifatx),    stat = ierr)
          if (ierr.ne.0) then
              write(lo,*) 'Isr Allocation error '
              call cstop(' ')
          endif
      else
          ierr = 0
          IF (ALLOCATED(isr))
     *        DEALLOCATE (isr, stat = ierr)
          if (ierr.ne.0) then
              write(*,*) 'Isr DeAllocation Error'
              call cstop(' ')
          endif
      endif
!
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaInvarStuff(iAction)
      USE General
      USE InvarStuff
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
      dimension ierv(10)
!
      call AllocaIsr(iAction)
!
      ierv(:) = 0
      ierr = 0
      if (iAction == 1) then
          IF (.NOT. ALLOCATED(itab))
     *        ALLOCATE (itab(1:itabmx),  stat = ierv(1))
          IF (.NOT. ALLOCATED(itabH))
     *        ALLOCATE (itabH(1:itabmx), stat = ierv(2))
          IF (.NOT. ALLOCATED(itabK))
     *        ALLOCATE (itabK(1:itabmx), stat = ierv(3))
          IF (.NOT. ALLOCATED(itabL))
     *        ALLOCATE (itabL(1:itabmx), stat = ierv(4))
          IF (.NOT. ALLOCATED(itabO))
     *        ALLOCATE (itabO(1:itabmx), stat = ierv(5))
!
          IF (.NOT. ALLOCATED(isig))
     *        ALLOCATE (isig(1:3,1:numbMaxTrip), stat = ierv(7))
          IF (.NOT. ALLOCATED(inq))
     *        ALLOCATE (inq(1:7,1:numbMaxNQ),    stat = ierv(8))
          IF (.NOT. ALLOCATED(gq))
     *        ALLOCATE (gq(1:numbMaxTrip),       stat = ierv(9))
          IF (.NOT. ALLOCATED(gv))
     *        ALLOCATE (gv(1:numbMaxTrip),       stat = ierv(10))
          ierr = 0
          do i=1,10
             ierr = ierr + iabs( ierv(i) )
          enddo
          if (ierr.ne.0) then
              write(lo,*) 'InvarStuff Allocation error '
              write(lo,*) 'Errors ',ierv
              call cstop(' ')
          endif
          itab  = 0
          itabH = 0
          itabK = 0
          itabL = 0
          itabO = 0
          gq    = 0.0
          gv    = 0.0
      else
          ierr = 0
          if (allocated(isr))   deallocate(isr,   stat = ierv( 1))
          if (allocated(itab))  deallocate(itab,  stat = ierv( 2))
          if (allocated(itabH)) deallocate(itabH, stat = ierv( 3))
          if (allocated(itabK)) deallocate(itabK, stat = ierv( 4))
          if (allocated(itabL)) deallocate(itabL, stat = ierv( 5))
          if (allocated(itabO)) deallocate(itabO, stat = ierv( 6))
          if (allocated(isig))  deallocate(isig,  stat = ierv( 7))
          if (allocated(inq))   deallocate(inq,   stat = ierv( 8))
          if (allocated(gq))    deallocate(gq,    stat = ierv( 9))
          if (allocated(gv))    deallocate(gv,    stat = ierv(10))
          do i=1,10
             ierr = ierr + iabs( ierv(i) )
          enddo
          if (ierr.ne.0) then
              write(*,*) 'InvarStuff DeAllocation Error'
              call cstop(' ')
          endif
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaRenorArrays(iAction)

      USE General
      USE RenorArrays
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
      dimension ierv(10)
!
      do i=1,10
         ierv(i) = 0
      enddo
      ierr = 0
!
      if (iAction == 1) then
          IF (.NOT. ALLOCATED(RES))
     *     ALLOCATE (RES(1:nreflDim)       ,stat = ierv( 1))
          IF (.NOT. ALLOCATED(RES_TAG))
     *     ALLOCATE (RES_TAG(1:nreflDim)   ,stat = ierv( 2))
          IF (.NOT. ALLOCATED(Eobs))
     *     ALLOCATE (Eobs(1:nreflDim)      ,stat = ierv( 3))
          IF (.NOT. ALLOCATED(res_sort))
     *     ALLOCATE (res_sort(1:nreflDim)  ,stat = ierv( 4))
          IF (.NOT. ALLOCATED(IX_sort))
     *     ALLOCATE (IX_sort(1:nreflDim)   ,stat = ierv( 5))
          IF (.NOT. ALLOCATED(IX_aux))
     *     ALLOCATE (IX_aux(1:nreflDim)    ,stat = ierv( 6))
          IF (.NOT. ALLOCATED(Eo2Shell))
     *     ALLOCATE (Eo2Shell(1:NShell)    ,stat = ierv( 7))
          IF (.NOT. ALLOCATED(scEo2Shell))
     *     ALLOCATE (scEo2Shell(1:NShell)  ,stat = ierv( 8))
          IF (.NOT. ALLOCATED(shellTAB))
     *     ALLOCATE (shellTAB(1:NShell,1:2),stat = ierv( 9))
          ierr = 0
          do i=1,10
             ierr = ierr + iabs( ierv(i) )
          enddo
          if (ierr.ne.0) then
              write(lo,*) 'Arrays Allocation error'
              call cstop(' ')
          endif
                                                                                                                     
          RES        = 0
          res_sort   = 0
          RES_TAG    = 0
          IX_sort    = 0
          IX_aux     = 0
          Eobs       = 0
          Eo2Shell   = 0
          scEo2Shell = 1.0
          shellTAB(:,:) = 0.0
      else
          IF (ALLOCATED(RES))
     *        DEALLOCATE (RES, res_sort, RES_TAG, IX_sort, IX_aux, Eobs,
     *              Eo2Shell, scEo2Shell, shellTAB, stat = ierr)
          if (ierr.ne.0) then
              write(*,*) 'Arrays DeAllocation Error'
              call cstop(' ')
          endif
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaPhaseStuff(iAction)
      USE General
      USE PhaseStuff
      USE PhaseModule
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
      dimension ierv(2)
!
      ierv(:) = 0
      ierr = 0
      if (iAction == 1) then
          IF (.NOT. ALLOCATED(iph)) 
     *         ALLOCATE (iph(1:LenIPH),  stat = ierv(1))
          ierr = ierv(1)
          if (ierr.ne.0) then
              write(lo,*) 'PhaseStuff Allocation error '
              call cstop(' ')
          endif
          iph = 0
      else
          IF (ALLOCATED(iph))
     *        DEALLOCATE (iph, stat = ierr)
          if (ierr.ne.0) then
              write(*,*) 'PhaseStuff DeAllocation Error'
              call cstop(' ')
          endif
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine AllocaPseudoStuff(iAction)
      USE PseudoStuff
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
      if (iAction == 1) then
          allocate(epseud(74), esuper(74), enew(74), patom(74),
     *             qatom(74), pnew(74), qnew(74), emed(74), qn(12,3,74),
     *             kpseud(74), ksuper(74), ipseud(74), iskip(74),
     *             keq(74), numps(74), jqn(74), mpseud(12,74), 
     *             hkleMat(48,3), stat=ierr)
          if (ierr.ne.0) then
              write(*,*) 'PseudoStuff Allocation Error'
              call cstop(' ')
          endif
          mpseud(1:12, 1) = (/ 1, 1, 1,  1, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12, 2) = (/ 1, 0, 0,  2, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12, 3) = (/ 0, 1, 0,  2, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12, 4) = (/ 0, 0, 1,  2, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12, 5) = (/ 1, 1, 1,  2, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12, 6) = (/ 1, 1, 0,  2, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12, 7) = (/ 1, 0, 1,  2, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12, 8) = (/ 0, 1, 1,  2, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12, 9) = (/ 1, 0, 0,  3, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,10) = (/ 0, 1, 0,  3, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,11) = (/ 0, 0, 1,  3, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,12) = (/ 1, 1, 0,  3, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,13) = (/ 1, 0, 1,  3, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,14) = (/ 0, 1, 1,  3, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,15) = (/ 1, 1, 1,  3, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,16) = (/ 1, 1, 2,  3, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,17) = (/ 1, 2, 1,  3, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,18) = (/ 2, 1, 1,  3, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,19) = (/ 1, 2, 0,  3, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,20) = (/ 1, 0, 2,  3, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,21) = (/ 0, 1, 2,  3, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,22) = (/ 0, 0, 1,  4, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,23) = (/ 0, 1, 0,  4, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,24) = (/ 1, 0, 0,  4, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,25) = (/ 1, 1, 0,  4, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,26) = (/ 1, 0, 1,  4, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,27) = (/ 0, 1, 1,  4, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,28) = (/ 1, 1, 1,  4, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,29) = (/ 2, 2, 1,  4, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,30) = (/ 2, 1, 2,  4, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,31) = (/ 1, 2, 2,  4, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,32) = (/ 2, 1, 1,  4, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,33) = (/ 1, 2, 1,  4, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,34) = (/ 1, 1, 2,  4, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,35) = (/ 1, 2, 0,  4, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,36) = (/ 1, 0, 2,  4, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,37) = (/ 0, 1, 2,  4, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,38) = (/ 2, 1, 0,  4, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,39) = (/ 2, 0, 1,  4, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,40) = (/ 0, 2, 1,  4, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,41) = (/ 3, 3, 1,  4, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,42) = (/ 3, 1, 3,  4, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,43) = (/ 1, 3, 3,  4, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,44) = (/ 1, 2, 3,  4, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,45) = (/ 1, 3, 2,  4, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,46) = (/ 3, 1, 2,  4, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,47) = (/ 1, 3, 0,  4, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,48) = (/ 1, 0, 3,  4, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,49) = (/ 0, 1, 3,  4, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,50) = (/ 0, 3, 2,  6, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,51) = (/ 0, 2, 3,  6, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,52) = (/ 2, 3, 0,  6, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,53) = (/ 3, 2, 0,  6, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,54) = (/ 3, 0, 2,  6, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,55) = (/ 2, 0, 3,  6, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,56) = (/ 2, 2, 3,  6, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,57) = (/ 3, 2, 3,  6, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,58) = (/ 3, 3, 2,  6, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,59) = (/ 0, 4, 3, 12, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,60) = (/ 4, 0, 3, 12, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,61) = (/ 4, 3, 0, 12, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,62) = (/ 0, 3, 4, 12, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,63) = (/ 3, 4, 0, 12, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,64) = (/ 3, 0, 4, 12, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,65) = (/ 1, 0, 0,  2, 0, 1, 0, 2, 1, 1, 1, 1 /)
          mpseud(1:12,66) = (/ 1, 0, 0,  2, 0, 0, 1, 2, 1, 1, 1, 1 /)
          mpseud(1:12,67) = (/ 0, 1, 0,  2, 0, 0, 1, 2, 1, 1, 1, 1 /)
          mpseud(1:12,68) = (/ 1, 0, 0,  2, 0, 1, 1, 2, 1, 1, 1, 1 /)
          mpseud(1:12,69) = (/ 0, 1, 0,  2, 1, 0, 1, 2, 1, 1, 1, 1 /)
          mpseud(1:12,70) = (/ 0, 0, 1,  2, 1, 1, 0, 2, 1, 1, 1, 1 /)
          mpseud(1:12,71) = (/ 1, 1, 0,  2, 1, 0, 1, 2, 1, 1, 1, 1 /)
          mpseud(1:12,72) = (/ 1, 0, 0,  2, 0, 1, 0, 2, 0, 0, 1, 2 /)
          mpseud(1:12,73) = (/ 1, 1, 1,  1, 1, 1, 1, 1, 1, 1, 1, 1 /)
          mpseud(1:12,74) = (/ 1, 1, 1,  1, 1, 1, 1, 1, 1, 1, 1, 1 /)
          numps( 1:64)  = 1
          numps(65:71)  = 2
          numps(   72)  = 3
          numps(73:74)  = 0
          patom(:)  = 0.0
          qatom(:)  = 0.0
          kpseud(:) = 0
          ipseud(:) = 0
          ksuper(:) = 0
          iskip (:) = 0
          jqn   (:) = 0
          epseud(:) = 0.0
          esuper(:) = 0.0
          enew  (:) = 0.0
          emed  (:) = 0.0
          pnew  (:) = 0.0
          qnew  (:) = 0.0
          qn(:,:,:) = 0.0
      else
          ierr = 0
          if (Allocated(mpseud)) then
              deallocate(epseud, esuper, enew, patom, qatom, pnew, qnew,
     *                   emed, qn, kpseud, ksuper, ipseud, iskip, keq,
     *                   numps, jqn, mpseud, hkleMat, stat=ierr)
          endif
          if (ierr.ne.0) then
              write(*,*) 'PseudoStuff Deallocation Error'
              call cstop(' ')
          endif
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine AllocaFinale(iAction)

      USE General
!     USE RenorArrays_MR
      USE riflessi_c
      USE Riflessi
      USE Finale
      USE RemoModule
!
!-- Allocate / Deallocate arrays  ( iAction = 1(-1) / 2 )
!
      dimension ierv(20)
!
      ierv(:) = 0
      ierr = 0
!
      if (iAction == 1) then
          if (nSolToExplore == 1) then
              nSTE = 2
          else
              nSTE = nSolToExplore
          endif
          IF (.NOT. ALLOCATED(ResMol))
     *       ALLOCATE (ResMol(1:nSTE,1:nMolMR,1:7),
     *                                                stat = ierv(1))
          IF (.NOT. ALLOCATED(TrialCor))
     *       ALLOCATE (TrialCor(1:nSTE,1:2), stat = ierv(2))
          IF (.NOT. ALLOCATED(TrialDrop))
     *       ALLOCATE (TrialDrop(1:nSolToExploreRot),  stat = ierv(3))
          do i=1,20
             ierr = ierr + iabs( ierv(i) )
          enddo
          if (ierr.ne.0) then
              write(lo,*) 'Finale Allocation error'
              call cstop(' ')
          endif

          ResMol(:,:,:) = 0
          TrialCor(:,:) = 0
          TrialDrop(:)   = 0
      else
          IF (ALLOCATED(ResMol))
     *        DEALLOCATE (ResMol, TrialCor, TrialDrop,stat = ierr)
          if (ierr.ne.0) then
              write(*,*) 'Finale DeAllocation Error'
              call cstop(' ')
          endif
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine AllocaModModel(iAction)
      USE ModModel
      USE General
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
      dimension ierv(20)
!
      ierv(:) = 0
      ierr = 0
!
      if (iAction == 1) then
          IF (.NOT. ALLOCATED(distMatrix))
     *       ALLOCATE (distMatrix(1:nca,1:nca), stat = ierv(1))
          IF (.NOT. ALLOCATED(distMatrixModel))
     *       ALLOCATE (distMatrixModel(1:nca,1:nca), stat = ierv(2))
          IF (.NOT. ALLOCATED(distMatrixPatt))
     *       ALLOCATE (distMatrixPatt(1:nca,1:nca), stat = ierv(3))
          IF (.NOT. ALLOCATED(MatrixModel))
     *       ALLOCATE (MatrixModel(1:nca-1,1:4), stat = ierv(4))
          IF (.NOT. ALLOCATED(Shell))
     *       ALLOCATE (Shell(1:nca-1,1:10*nreflDim,1:3), stat = ierv(5))
          IF (.NOT. ALLOCATED(ShellCont))
     *       ALLOCATE (ShellCont(1:nca-1), stat = ierv(6))
          do i=1,20
             ierr = ierr + iabs( ierv(i) )
          enddo
          if (ierr.ne.0) then
              write(lo,*) 'ModModel Allocation error'
              call cstop(' ')
          endif
          distMatrix(:,:) = 0
          distMatrixModel(:,:) = 0
          distMatrixPatt(:,:) = 0
          MatrixModel(:,:) = 0
          Shell(:,:,:) = 0
          ShellCont(:) = 0
      else
          IF (ALLOCATED(distMatrix))
     *        DEALLOCATE (distMatrix, distMatrixModel, 
     *                     distMatrixPatt, MatrixModel, Shell,ShellCont,
     *                      stat = ierr)
          if (ierr.ne.0) then
              write(*,*) 'ModModel DeAllocation Error'
              call cstop(' ')
          endif
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine AllocaFinalSolution(iAction)

      USE General
      USE RemoModule
      USE Solutions
!
!-- Allocate / Deallocate arrays  ( iAction = 1(-1) / 2 )
!
      dimension ierv(20)
!
      ierv(:) = 0
      ierr = 0
!
      if (iAction == 1) then
          if (.not. Allocated(finsolcan)) then
              Allocate (finsolcan(1:nFinalSolution), stat=ierv(1))
              k = maxval(MonomerInModel(1:numbModels))
              do i=1,nFinalSolution
                 allocate (finsolcan(i)%RotVal(3,numbModels,k), 
     *                                           stat=ierv(2))
                 allocate (finsolcan(i)%TraVal(3,numbModels,k),
     *                                           stat=ierv(3))
                 allocate (finsolcan(i)%flag(numbModels,k),
     *                                           stat=ierv(4))
              enddo
              if (numbModels > 1) then
                 Allocate (finsolcanSav(1:nFinalSolution), stat=ierv(1))
                 k = maxval(MonomerInModel(1:numbModels))
                 do i=1,nFinalSolution
                    allocate (finsolcanSav(i)%RotVal(3,numbModels,k), 
     *                                              stat=ierv(2))
                    allocate (finsolcanSav(i)%TraVal(3,numbModels,k),
     *                                              stat=ierv(3))
                    allocate (finsolcanSav(i)%flag(numbModels,k),
     *                                              stat=ierv(4))
                 enddo
              endif
          endif
          IF (.NOT. ALLOCATED(iwork5))
     *    ALLOCATE (iwork5(1:nFinalSolution), stat = ierv(5))
          IF (.NOT. ALLOCATED(work5))
     *    ALLOCATE (work5(1:nFinalSolution), stat = ierv(6))
          do i=1,20
             ierr = ierr + iabs( ierv(i) )
          enddo
          if (ierr.ne.0) then
              write(lo,*) 'FinalSolution Allocation error'
              call cstop(' ')
          endif
          do i=1,nFinalSolution
             finsolcan(i)%RotVal(:,:,:) = 0.0
             finsolcan(i)%TraVal(:,:,:) = 0.0
             finsolcan(i)%flag(:,:)     = 0
          enddo
      else
          if (Allocated(finsolcan)) then
              do i=1,nFinalSolution
                 deallocate(finsolcan(i)%RotVal)
                 deallocate(finsolcan(i)%TraVal)
                 deallocate(finsolcan(i)%flag)
              enddo
              deallocate (finsolcan, stat = ierr)
              deallocate (work5, iwork5, stat = ierr)
          endif
          if (Allocated(finsolcanSav)) then
              do i=1,nFinalSolution
                 deallocate(finsolcanSav(i)%RotVal)
                 deallocate(finsolcanSav(i)%TraVal)
                 deallocate(finsolcanSav(i)%flag)
              enddo
              deallocate (finsolcanSav, stat = ierr)
          endif
          if (ierr.ne.0) then
             write(*,*) 'FinalSolution DeAllocation Error'
             call cstop(' ')
          endif
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaRenorArrays_MR(iAction)

      USE General
      USE RenorArrays_MR
      USE riflessi_c
      USE Riflessi
      USE RuotaRiflessi
!
!-- Allocate / Deallocate arrays  ( iAction = 1(-1) / 2 )
!
      dimension ierv(20)
!
      do i=1,10
         ierv(i) = 0
      enddo
      ierr = 0
!
      if (iAction == 1) then
          nnn = nRifDimC
      elseif (iAction == 3) then
          nnn = nreflSelTra
      elseif (iAction == -1) then
          nnn = nreflDim
      endif
      if (iAction /= 2) then
          IF (.NOT. ALLOCATED(RES))
     *     ALLOCATE (RES(1:nnn)       ,stat = ierv( 1))
          IF (.NOT. ALLOCATED(RES_TAG))
     *     ALLOCATE (RES_TAG(1:nnn)   ,stat = ierv( 2))
          IF (.NOT. ALLOCATED(Eobs))
     *     ALLOCATE (Eobs(1:nnn)      ,stat = ierv( 3))
          IF (.NOT. ALLOCATED(res_sort))
     *     ALLOCATE (res_sort(1:nnn)  ,stat = ierv( 4))
          IF (.NOT. ALLOCATED(IX_sort))
     *     ALLOCATE (IX_sort(1:nnn)   ,stat = ierv( 5))
          IF (.NOT. ALLOCATED(IX_aux))
     *     ALLOCATE (IX_aux(1:nnn)    ,stat = ierv( 6))
          IF (.NOT. ALLOCATED(shellTAB))
     *     ALLOCATE (shellTAB(1:NShell,1:2)   ,stat = ierv( 7))
          IF (.NOT. ALLOCATED(Eo2Shell))
     *     ALLOCATE (Eo2Shell(1:NShell)    ,stat = ierv( 8))
          IF (.NOT. ALLOCATED(scEo2Shell))
     *     ALLOCATE (scEo2Shell(1:NShell)  ,stat = ierv( 9))
          do i=1,10
             ierr = ierr + iabs( ierv(i) )
          enddo
          if (ierr.ne.0) then
              write(lo,*) 'Arrays Allocation error'
              call cstop(' ')
          endif

          RES        = 0
          res_sort   = 0
          RES_TAG    = 0
          IX_sort    = 0
          IX_aux     = 0
          Eobs       = 0
          Eo2Shell   = 0
          scEo2Shell = 1.0
      else
          IF (ALLOCATED(RES))
     *        DEALLOCATE (RES, res_sort, RES_TAG, IX_sort, IX_aux, Eobs,
     *                    shellTAB, Eo2Shell, scEo2Shell, stat = ierr)
          if (ierr.ne.0) then
              write(*,*) 'Arrays DeAllocation Error'
              call cstop(' ')
          endif
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaRuotaRiflessi(iAction)
      USE General
      USE Symmetry
      USE RuotaRiflessi
      USE RemoModule
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
      dimension ierv(10)
!
      ierv(:) = 0
      ierr = 0
!
      nsymcent=nsym*(icent+1)
      if (iAction == 1) then
          IF (.NOT. ALLOCATED(ModuliSel))
     *        ALLOCATE (ModuliSel(1:2,1:nreflMR), stat = ierv(1))
          IF (.NOT. ALLOCATED(Fsh))
     *        ALLOCATE (Fsh(1:nsymcent,1:2,1:nreflMR),stat = ierv(2))
          IF (.NOT. ALLOCATED(FshFix))
     *        ALLOCATE (FshFix(1:nsymcent,1:2,1:nreflMR),stat = ierv(3))
          IF (.NOT. ALLOCATED(solv_corr))
     *        ALLOCATE (solv_corr(1:2,1:nreflMR),      stat = ierv(4))
c          IF (.NOT. ALLOCATED(sumff))
c     *        ALLOCATE (sumff(1:nreflMR), stat = ierv(5))
c          IF (.NOT. ALLOCATED(sumffMod))
c     *        ALLOCATE (sumffMod(1:nreflMR,1:10), stat = ierv(6))
          IF (.NOT. ALLOCATED(fccomp))
     *        ALLOCATE (fccomp(1:nreflMR), stat = ierv(7))
          IF (.NOT. ALLOCATED(focomp))
     *        ALLOCATE (focomp(1:nreflMR), stat = ierv(8))
          IF (.NOT. ALLOCATED(epsvcomp))
     *        ALLOCATE (epsvcomp(1:nreflMR), stat = ierv(9))
          IF (.NOT. ALLOCATED(rhovcomp))
     *        ALLOCATE (rhovcomp(1:nreflMR), stat = ierv(10))
          IF (.NOT. ALLOCATED(sigmavcomp))
     *        ALLOCATE (sigmavcomp(1:nreflMR), stat = ierv(10))
          ierr = 0
          do i=1,10
             ierr = ierr + iabs( ierv(i) )
          enddo
          if (ierr.ne.0) then
              write(lo,*) 'RuotaRiflessi Allocation error'
              call cstop(' ')
          endif
          ModuliSel(:,:) = 0
          Fsh(:,:,:)     = 0
          FshFix(:,:,:)  = 0
c          sumff(:)       = 0
c          sumffMod(:,:)    = 0
          solv_corr(:,:) = 0
          fccomp(:)      = 0
          focomp(:)      = 0
          epsvcomp(:)    = 0
          rhovcomp(:)    = 0 
          sigmavcomp(:)    = 0 

      else
          IF (ALLOCATED(ModuliSel))
     *        DEALLOCATE (ModuliSel, Fsh, FshFix, solv_corr, fccomp,
     *        epsvcomp,rhovcomp,focomp,sigmavcomp, stat = ierr)
          if (ierr.ne.0) then
              write(*,*) 'RuotaRiflessi DeAllocation Error'
              call cstop(' ')
          endif
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaTraslaSolution(iAction)
      USE General
      USE Symmetry
      USE TraslaSolution
      USE RemoModule
      USE RuotaRiflessi, only : nreflSelTra
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
      dimension ierv(6)
!
      ierv(:) = 0
      ierr = 0
!
*     write(6,*) '*************************************************'
*     write(6,*) '       subroutine AllocaTraslaSolution           '
*     write(6,*) '  iAction, nGridMR, nTraSol                      '
*     write(6,*) iAction, nGridMR(1:3),nGridMR(1)*nGridMR(2)*nGridMR(3)
*     write(6,*) '*************************************************'
      if (iAction == 1) then
          if (ifPositioned==0) then
            if (nsym==1.and.icent==0) then
              nTraSol=nSolToExploreRot
            else
              nTraSol_0 = nGridMR(1) * nGridMR(2) * nGridMR(3)
              nTraSol=nSolToExploreRot * 5
              nTraSol = max0(nTraSol_0,nTraSol)
            endif
          else
            nTraSol=1.0
          endif
          IF (.NOT. ALLOCATED(TraSol))
     *        ALLOCATE (TraSol(1:nTraSol), stat = ierv(1))
          IF (.NOT. ALLOCATED(TraAll))
     *        ALLOCATE (TraAll(1:nTraSol), stat = ierv(2))
          IF (.NOT. ALLOCATED(work4))
     *        ALLOCATE (work4(1:nTraSol), stat = ierv(3))
          IF (.NOT. ALLOCATED(iwork4))
     *        ALLOCATE (iwork4(1:nTraSol), stat = ierv(4))
          IF (.NOT. ALLOCATED(workRenor1))
     *        ALLOCATE (workRenor1(1:nreflSelTra), stat = ierv(5))
          IF (.NOT. ALLOCATED(workRenor2))
     *        ALLOCATE (workRenor2(1:nreflSelTra), stat = ierv(6))
          ierr = 0
          do i=1,6
             ierr = ierr + iabs( ierv(i) )
          enddo
          if (ierr.ne.0) then
              write(lo,*) 'AllocaTraslaSolution Allocation error'
              call cstop(' ')
          endif

          do i=1,nTraSol
             TraAll(i)%TraVal(:) = 0
             TraAll(i)%TraFom = -10000
             TraAll(i)%TraCorr = 0
             TraAll(i)%MolMPE = 0
             TraAll(i)%ipunt = 0
             TraAll(i)%trial = 0
             TraAll(i)%RotVal(:) = 0
             TraAll(i)%RotFom = -10000
             TraAll(i)%LocFom = -10000
             TraAll(i)%accepted = 0
             TraAll(i)%TFom(:) = 0

             TraSol(i)%TraVal(:) = 0
             TraSol(i)%TraFom = -10000
             TraSol(i)%TraCorr = 0
             TraSol(i)%MolMPE = 0
             TraSol(i)%ipunt = 0
             TraSol(i)%trial = 0
             TraSol(i)%RotVal(:) = 0
             TraSol(i)%RotFom = -10000
             TraSol(i)%LocFom = -10000
             TraSol(i)%accepted = 0
             TraSol(i)%TFom(:) = 0

             work4(i)     = 0
             iwork4(i)     = 0
          enddo

          workRenor1(:)     = 0
          workRenor2(:)     = 0

      else
          IF (ALLOCATED(TraAll))
     *        DEALLOCATE (TraAll, work4, iwork4, stat = ierv(1))
          IF (ALLOCATED(TraSol))
     *        DEALLOCATE (TraSol, workRenor1,workRenor2, stat = ierv(2))
          ierr = ierv(1) + ierv(2)
          if (ierr.ne.0) then
              write(*,*) 'AllocaTraslaSolution DeAllocation Error'
              call cstop(' ')
          endif
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaRiflessi_c(iAction)
      USE General
      USE Symmetry
      USE riflessi_c
      USE RemoModule
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
      implicit none
      integer :: iAction, ierv(20), ierr, i, nsymcentSav
!
      ierv(:) = 0
      ierr = 0
      nsymcentSav = nsymSav * (icentSav + 1)
!
      if (iAction == 1) then
          ihmx_c(1:3) = ihmx(1:3)
          ifat1C = ( 2 * ihmx(3) + 1 ) * ( 2 * ihmx(2) + 1 )
          ifat2C = ( 2 * ihmx(3) + 1 )
          ifatxC = ihmx(1) * ifat1C + ihmx(2) * ifat2C + ihmx(3)

          IF (.NOT. ALLOCATED(khlc)) 
     *        ALLOCATE (khlc(1:3,1:nRifDimC)         , stat = ierv( 1))
          IF (.NOT. ALLOCATED(superind)) 
     *        ALLOCATE (superind(1:ifatxC)           , stat = ierv( 2))
          IF (.NOT. ALLOCATED(fcvetc)) 
     *        ALLOCATE (fcvetc(1:nRifDimC)           , stat = ierv( 3))
          IF (.NOT. ALLOCATED(fcvets))
     *        ALLOCATE (fcvets(1:nRifDimC)           , stat = ierv( 4))
          IF (.NOT. ALLOCATED(k_mem1))
     *        ALLOCATE (k_mem1(1:nreflDim)           , stat = ierv( 5))
          if (ifRemo > 0) then
              IF (.NOT. ALLOCATED(khlv))
     *            ALLOCATE (khlv(1:3,1:2,1:nreflDim) , stat = ierv( 6))
              IF (.NOT. ALLOCATED(k_mem))
     *            ALLOCATE (k_mem(1:nreflDim)        , stat = ierv( 7))
              IF (.NOT. ALLOCATED(khlv_eq))
     *            ALLOCATE (khlv_eq(1:4,1:nsymcentSav,1:3,1:nreflDim) 
     *                                               , stat = ierv( 8))
              IF (.NOT. ALLOCATED(ecvetc))
     *            ALLOCATE (ecvetc(1:nRifDimC)       , stat = ierv( 9))
              IF (.NOT. ALLOCATED(rhovc))
     *            ALLOCATE (rhovc(1:nRifDimC)        , stat = ierv(10))
          endif
!
          ierr = 0
          do i=1,20
             ierr = ierr + iabs( ierv(i) ) 
          enddo
          if (ierr.ne.0) then
              write(lo,*) 'Riflessi_c Allocation error'
              call cstop(' ')
          endif
          superind    = 0
          fcvetc  = 0
          fcvets  = 0
          if (ifRemo > 0) then 
              ecvetc   = 0
              rhovc    = 0
          endif

      else

          IF (ALLOCATED(superind))
     *        DEALLOCATE (khlc, superind, fcvetc, fcvets, k_mem1,
     *                    stat = ierv(1))
          IF (ALLOCATED(khlv))
     *        DEALLOCATE ( khlv, k_mem, khlv_eq, ecvetc, rhovc,
     *                    stat = ierv(2))
          IF (ALLOCATED(iworki))
     *        DEALLOCATE (iworki, stat = ierv(2))
!
          ierr = 0
          do i=1,20
             ierr = ierr + iabs( ierv(i) ) 
          enddo
          if (ierr.ne.0) then
              write(*,*) 'Riflessi_c DeAllocation Error'
              call cstop(' ')
          endif
      endif
!
      return
      end
! -------------------------------------------------------------------
      subroutine AllocaRiflessi_mio(iAction)
      USE General
      USE Symmetry
      USE riflessi_mio
      USE riflessi_c!, only: nRifDimC
      USE RemoModule
      USE RuotaRiflessi

!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
      dimension ierv(8)
!
      ierv(:) = 0
      ierr = 0
      nsymcent=nsym*(icent+1)
!
      if (iAction == 1) then
c          ifat1C = ( 2 * ihmx(3) + 1 ) * ( 2 * ihmx(2) + 1 )
c          ifat2C = ( 2 * ihmx(3) + 1 )
c          ifatxC = ihmx(1) * ifat1C + ihmx(2) * ifat2C + ihmx(3)

c          IF (.NOT. ALLOCATED(superind_m)) 
c     *        ALLOCATE (superind_m(1:ifatxC),            stat = ierv(1))
          IF (.NOT. ALLOCATED(khlv_m))
     *        ALLOCATE (khlv_m(1:3,1:2,1:nreflDim),      stat = ierv(2))
          IF (.NOT. ALLOCATED(k_mem_m))
     *        ALLOCATE (k_mem_m(1:nreflDim),         stat = ierv(3))
          IF (.NOT. ALLOCATED(khlv_eq_m))
     *        ALLOCATE (khlv_eq_m(1:4,1:nsymcent,1:3,1:nreflDim),
     *                                                   stat = ierv(4))
c          IF (.NOT. ALLOCATED(ecvetc_m))
c     *        ALLOCATE (ecvetc_m(1:nRifDimC),            stat = ierv(5))
          IF (.NOT. ALLOCATED(k_mem1_m))
     *        ALLOCATE (k_mem1_m(1:nreflDim),        stat = ierv(6))

          IF (.NOT. ALLOCATED(solv_corr_m))
     *        ALLOCATE (solv_corr_m(1:2,1:nreflMR),      stat = ierv(7))
c           IF (.NOT. ALLOCATED(khlc_m)) 
c     *     ALLOCATE (khlc_m(1:3,1:nRifDimC) ,stat = ierv( 8))


          ierr = 0
          do i=1,8
             ierr = ierr + iabs( ierv(i) ) 
          enddo
          if (ierr.ne.0) then
              write(lo,*) 'Riflessi_c Allocation error'
              call cstop(' ')
          endif
c          superind_m = superind
c          ecvetc_m   = ecvetc
          khlv_m     = khlv
          khlv_eq_m  = khlv_eq
          k_mem1_m   = k_mem1
          k_mem_m    = k_mem
c          khlc_m     = khlc
          solv_corr_m = solv_corr
      else

          if(ALLOCATED(khlv_m))then!superind_m)) then

c             superind  = superind_m
c             ecvetc    = ecvetc_m
             khlv      = khlv_m
             khlv_eq   = khlv_eq_m
             k_mem1    = k_mem1_m
             k_mem     = k_mem_m
             solv_corr = solv_corr_m
c             khlc      = khlc_m
             DEALLOCATE (khlv_m, !superind_m, ecvetc_m, khlc_m,
     *              k_mem_m, k_mem1_m, khlv_eq_m, solv_corr_m,
     *              stat = ierr)
          endif
          if (ierr.ne.0) then
              write(*,*) 'Riflessi_mio DeAllocation Error'
              call cstop(' ')
          endif

      endif
!
      return
      end
! -------------------------------------------------------------------

      subroutine AllocaSolutions(iAction)
      USE Solutions
      USE RemoModule
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
      ierv = 0
      ierr = 0
c
      if (iAction == 1) then
          IF (.NOT. ALLOCATED(solcan))
     *    ALLOCATE (solcan(1:nMaxSolutions), stat = ierv)
          IF (.NOT. ALLOCATED(iwork3))
     *    ALLOCATE (iwork3(1:nMaxSolutions), stat = ierv)
          IF (.NOT. ALLOCATED(work3))
     *    ALLOCATE (work3(1:nMaxSolutions), stat = ierv)
!
          if (ierv.ne.0) then
              write(*,*) 'Solutions Allocation Error'
              call cstop(' ')
          endif


          do i=1,nMaxSolutions
             solcan(i)%RotVal(:) = 0
             solcan(i)%TraVal(:) = 0
             solcan(i)%RotFom = -10000
             solcan(i)%TraFom = -10000
             solcan(i)%MolMPE = 0
             solcan(i)%ipunt = 0
             solcan(i)%trial = 0
             solcan(i)%accepted = 0
             solcan(i)%RFom(:) = 0
          enddo

      else 
          IF (ALLOCATED(solcan))
     *        DEALLOCATE (solcan, work3, iwork3, stat = ierr)
          if (ierr.ne.0) then
              write(*,*) 'Solutions DeAllocation Error'
              call cstop(' ')
          endif
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaRiflessi_App(iAction)
      USE General
      USE Riflessi_App
!
      implicit none
      integer :: iAction, ierv(10), ier
!
      ierv(:) = 0
      if (iAction == 1) then
          if (.not.allocated(iphapp)) then
              allocate(iphapp(nreflDim)             , stat=ierv( 1))
              allocate(pesapp(nreflDim)             , stat=ierv( 2))
              allocate(eveapp(nreflDim)             , stat=ierv( 3))
          endif
!
          ier = sum(iabs(ierv(:)))
          if (ier /= 0) then
              write(*,*) 'Riflessi_App Allocation Error'
              call cstop(' ')
           endif
!
           iphapp(:)      = 0
           pesapp(:)      = 0
           eveapp(:)      = 0
!
      else
           if (allocated(iphapp)) then
               deallocate(iphapp            , stat=ierv( 1))
               deallocate(pesapp            , stat=ierv( 2))
               deallocate(eveapp            , stat=ierv( 3))
           endif

           ier = sum(iabs(ierv(:)))
           if (ier /= 0) then
               write(*,*) 'Riflessi_App DeAllocation Error'
               call cstop(' ')
           endif
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaRiflessi_Canal(iAction)
      USE General
      USE CowMod
      USE PherrMod
!
      implicit none
      integer :: iAction, ierv(10), ier
!
      ierv(:) = 0
      if (iAction == 1) then
          if (.not.allocated(distrPesi)) then
              allocate(distrPesi(nreflDim)         , stat=ierv( 1))
              allocate(resvet(nreflDim)            , stat=ierv( 2))
          endif
!
          ier = sum(iabs(ierv(:)))
          if (ier /= 0) then
              write(*,*) 'Riflessi_Canal Allocation Error'
              call cstop(' ')
           endif
!
           distrPesi(:)   = 0.0
           resvet(:) = 0.0
!
      else
           if (allocated(distrPesi)) then
               deallocate(distrPesi, resvet,         stat=ierv( 1))
           endif

           ier = sum(iabs(ierv(:)))
           if (ier /= 0) then
               write(*,*) 'Riflessi_Canal DeAllocation Error'
               call cstop(' ')
           endif
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaCanalMod(iAction)
      USE General
      USE Riflessi, only: mult
      USE CanalMod
!
      implicit none
      integer :: numb, iAction, ierv(10), ier
!
      if (iAction == 1) then  !!! Phase con  Relax
          numb = sum(mult(1:nreflTot)) 
      elseif (iAction == 3) then  !!! REMO no Relax
          numb = nreflTot
      endif
      ierv(:) = 0
      if (iAction == 1 .or. iAction == 3) then
          if (.not.allocated(djjs)) then
              allocate(djjs(numb)             , stat=ierv( 1))
              allocate(jjorde(numb)            , stat=ierv( 2))
              allocate(jjorde1(numb)           , stat=ierv( 3))
          endif
!
          ier = sum(iabs(ierv(:)))
          if (ier /= 0) then
              write(*,*) 'CanalMod Allocation Error'
              call cstop(' ')
           endif
!
           djjs(:)      = 0
           jjorde(:)      = 0
           jjorde1(:)      = 0
!
      else
           if (allocated(djjs)) then
               deallocate(djjs            , stat=ierv( 1))
               deallocate(jjorde           , stat=ierv( 2))
               deallocate(jjorde1          , stat=ierv( 3))
           endif

           ier = sum(iabs(ierv(:)))
           if (ier /= 0) then
               write(*,*) 'CanalMod DeAllocation Error'
               call cstop(' ')
           endif
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaPherrMod(iAction)
      USE General
      USE Riflessi, only: mult
      USE PherrMod
!
      implicit none
      integer :: numb, iAction, ierv(10), ier
!
      if (iAction == 1) then  !!! Phase con  Relax
          numb = sum(mult(1:nreflTot))
      elseif (iAction == 3) then  !!! REMO no Relax
          numb = nreflTot
      endif
      ierv(:) = 0
      if (iAction == 1 .or. iAction == 3) then
          if (.not.allocated(dijs)) then
              allocate(dijs(numb)             , stat=ierv( 1))
              allocate(jorde(numb)            , stat=ierv( 2))
              allocate(jorde1(numb)           , stat=ierv( 3))
          endif
!
          ier = sum(iabs(ierv(:)))
          if (ier /= 0) then
              write(*,*) 'PherrMod Allocation Error'
              call cstop(' ')
           endif
!
           dijs(:)      = 0
           jorde(:)      = 0
           jorde1(:)      = 0
!
      else
           if (allocated(dijs)) then
               deallocate(dijs            , stat=ierv( 1))
               deallocate(jorde           , stat=ierv( 2))
               deallocate(jorde1          , stat=ierv( 3))
           endif

           ier = sum(iabs(ierv(:)))
           if (ier /= 0) then
               write(*,*) 'PherrMod DeAllocation Error'
               call cstop(' ')
           endif
      endif
!
      return
      end
! ----------------------------------------------------------------------
