enum {DISTA, ANGLE, TORSION_ANGLE, PLANE, SUM, LIMIT, SITE, DISORDER, DEL, ALL};
/********************************************************/
/*                    R E S T R A I N T S               */
/********************************************************/

#include "mrconfig.h"
#include <gtkmrcomune.h>
#include "aliasx.h"

namespace main_app {
       extern Application TheApp;
                   }

static const char *typeres[] = {"DST", "ANG", "TOR", "PLA", "SUM", "LIM", "SIT", "DIS"};
#define NTYPERES (sizeof(typeres)/sizeof(typeres[0]))        /* tipi di restraints */
static int num_restr[NTYPERES] = {0, 0, 0, 0, 0, 0, 0, 0};       /* contatore */
static _StyleType FrameStyle = {true, 1, NULL, GTK_SHADOW_ETCHED_IN, 6, 6, 6, 6};
static _StyleType FrameStyle2 = {true, 1, NULL, GTK_SHADOW_ETCHED_IN, 4, 1, 1, 1};

extern char *Specie[NUMSPECIES];
extern int   nSpec;
extern int *nzTot, *iSite;
static int nSites;
static int *indSites;
static char **Sites;
extern GtkWidget *finestre[6];

extern "C" _LSQinfo *clsqgtk;
extern _Dialogo *dialogo;
extern "C" void clickforsite_(int *action);
int size_sel = sizeof(dialogo->kptrc)/sizeof(dialogo->kptrc[0]);
 
static GtkWidget *restraints_dlg = NULL;
static GtkWidget *mainwin;
static int vspace = 4;
static char **Atomi;          //[MaxAtLSQ];
static int *selezione;        //[MaxAtLSQ];
static int gAction = -1;
static int gSelMode = -1;
static gboolean deleteActive = FALSE;
static int nats;
static int numSelected;
static int rowSelected = -1;
static int nfl;

static const char *parametri[] = {"  X   ","  Y   ","  Z   ","B[iso]",
                              "  11  ", "  12  ","  13  ","  22  ",
                              "  23  ","  33  ", " Occ. ", " Occ1 ",
                              " Occ2 ", " Occ3 ", " Occ4 "};

#define NUMPAR  sizeof(parametri)/sizeof(parametri[0])
static int numpar, param[NUMPAR];

static TreeItem all[] =
{
  {"Select by List", NULL},
  {"Select by Species", NULL},
  {"Select by Mouse Click", NULL},
  {"Select by Polygon", NULL},
  {"All", NULL},
  {NULL}
};

static TreeItem mouse[] =
{
  {"Select by Mouse Click", NULL},
  {NULL}
};

static TreeItem mouse_pol[] =
{
  {"Select by Mouse Click", NULL},
  {"Select by Polygon", NULL},
  {NULL}
};

static TreeItem mouse_list[] =
{
  {"Select by List", NULL},
  {"Select by Mouse Click", NULL},
  {NULL}
};
static TreeItem which_del[] =
{
   {"All Distance restraints", NULL},
   {"All Angle restraints", NULL},
   {"All Torsion Angle restraints", NULL},
   {"All Plane restraints", NULL},
   {"All Sum restraints", NULL},
   {"All Limit restraints", NULL},
   {"All Site restraints", NULL},
   {"All Disorder restraints", NULL},
   {"Selected by List", NULL},
   {"All restraints", NULL},
   {NULL}
};

static TreeItem restrnames[] = {  {"Set up distance restraints", mouse},
                                  {"Set up angle restraints", mouse},
                                  {"Set up torsion angle restraints", mouse},
                                  {"Set up plane restraints", mouse_pol},
                                  {"Set up sum restraints", all},
                                  {"Set up limit restraints", all},
                                  {"Set up site restraints", mouse_list},
                                  {"Set up disorder restraints", mouse},
                                  {"Delete restraints", which_del},
                                  {NULL}
                                };

static const char *gFormato[] = {"%d Distance restraints\n",
                                 "%d Angle restraints\n",
                                 "%d Torsion Angle restraints\n",
                                 "%d Planar restraints\n",
                                 "%d Sum restraints\n",
                                 "%d Limit restraints\n",
                                 "%d Site restraints\n",
                                 "%d Disorder restraints\n"};

static GtkWidget *old_exp = NULL;

/*           NumItems --> numero di rami del tree principale               */
/*                            add distance restraints                      */
/*                            add angle restraints                         */
/*                            add plane restraints                         */
/*                            add sum restraints                           */
/*                            add limit restraints                         */
/*                            delete restraints                            */
/*           numfigli --> indica il numero di foglie per ciascuno dei rami */
/*                            Select by List         ----------            */
/*                            Select by Species               |            */
/*                            Select by Mouse Click           |  add restr */
/*                            Select by Polygon               |            */
/*                            All                    ----------            */
/*                            Distance restraints    ----------            */
/*                            Angle restraints                |            */
/*                            Planar Restraints               |            */
/*                            Sum restraints                  |  del restr */
/*                            Limit restraints                |            */
/*                            Sum restraints                  |            */
/*                            Disorder restraints             |            */
/*                            By List                         |            */
/*                            All                    ----------            */

#define  NumItems  sizeof(restrnames)/sizeof(restrnames[0])   //6                    
int   numfigli[NumItems] = {1, 1, 1, 2, 5,  5, 2, 5, 7};

static float distance, esd, angle, sigmax, sigmab, sigmabij;

/*************************************************************************/

int c_finish_restraints(gpointer data, int nfl)
{
   int exitC;
   int ier=0;
   int num_res_items;
   
   num_res_items = nfl;
   exitC = GPOINTER_TO_INT(data);
   finish_restraints_(&exitC, &num_res_items);
   return ier;
}

void append_line(GtkWidget *list, gchar *line)
{
    GtkListStore *list_store;
    GtkTreeIter iter;
                                                                                                        
    list_store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(list)));
    gtk_list_store_append (list_store, &iter);
    gtk_list_store_set (list_store, &iter, 0, line,-1);
}

void conta_restraints (GtkWidget *list, GtkWidget *label)
{
   int i, j, npar, jp, icode, natom;
//   char label_text[200];
   std::string line;

/* conta i vari tipi di restraints */

   clear_list(list);
   for (i = 0; i < (int) (NTYPERES); i++)
      num_restr[i] = 0;

   jp = -1;

   for (i = 0; i < clsqgtk->nresGTK; i++)
   {
      jp++;
      icode = (int) clsqgtk->vresGTK[jp] - 1;
      natom = (int) clsqgtk->vresGTK[jp+1];
      num_restr[icode]++;
      switch(icode)
      {
      case DISTA:
           line = g_strdup_printf("%s %7.5f %6.4f           ",
                  typeres[icode], clsqgtk->vresGTK[jp+2], 
                  clsqgtk->vresGTK[jp+3]);
           break;
      case ANGLE: 
           line = g_strdup_printf("%s %7.5f %6.2f           ",
                  typeres[icode], clsqgtk->vresGTK[jp+2], 
                  clsqgtk->vresGTK[jp+3]);
           break;
      case TORSION_ANGLE: 
           line = g_strdup_printf("%s %7.5f %6.2f           ",
                  typeres[icode], clsqgtk->vresGTK[jp+2], 
                  clsqgtk->vresGTK[jp+3]);
           break;
      case PLANE:
           line = g_strdup_printf("%s %7.5f                  ",
                  typeres[icode], clsqgtk->vresGTK[jp+2]);
           break;
      case SUM:
           npar = (int) clsqgtk->vresGTK[jp+3];
           line = g_strdup_printf("%s %7.5f                  ",
                  typeres[icode], clsqgtk->vresGTK[jp+2]);
           for(j=0; j<npar; j++)
               line.append(parametri[(int) clsqgtk->vresGTK[jp+4+j]-1]);
           jp += npar;
           break;
      case LIMIT:
           line = g_strdup_printf("%s %7.5f %7.5f %7.5f  ",
                  typeres[icode], clsqgtk->vresGTK[jp+2],
                  clsqgtk->vresGTK[jp+3],clsqgtk->vresGTK[jp+4]);
           jp++;
           break;
      case SITE:
           line = g_strdup_printf("%s ", typeres[icode]);
           break;
      case DISORDER:
           line = g_strdup_printf("%s ", typeres[icode]);
           break;
      default:
           (void) MessageDialog(restraints_dlg, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
                    "Programming Error");
           break;
      }
      if(natom == 0)
         line.append("All Atoms");
      else if(icode == DISORDER)
      {
         for(j=0; j<2*natom; j++)
             line.append(Atomi[(int) clsqgtk->vresGTK[jp+2+j]-1]);
      }
      else
      {
         for(j=0; j<natom; j++)
             line.append(Atomi[(int) clsqgtk->vresGTK[jp+4+j]-1]);
      }
      append_line(list, (char *) line.c_str());
      if(icode == DISORDER)
         jp = jp + 2*natom + 1;
      else
         jp = jp + natom + 3;
   }
   nfl = jp + 1;

   if(label)
   {
      std::string label_text;
      label_text.assign(g_strdup_printf(gFormato[0], num_restr[0]));
      for(int l=1; l<(int)NTYPERES; l++)
          label_text.append(g_strdup_printf(gFormato[l], num_restr[l]));
/*
      ScriviStringa(label_text, sizeof(label_text), gFormato, num_restr[0], num_restr[1],
                 num_restr[2], num_restr[3], num_restr[4], num_restr[5]);
      gtk_label_set_text(GTK_LABEL(label),label_text);
*/
      gtk_label_set_text(GTK_LABEL(label),label_text.c_str());
   }
}

void manage_ok_restr (int from)
{
   GtkWidget *frame, *spin1, *spin2, *label1, *label2;

/* from = 0 --> scelta by mouse click
   from = 1 --> scelta by polygon 
   from = 2 --> scelta by list
   from = 3 --> all                    */

   int i, ier;

   ier = 0;
   for(i=0;i <size_sel; i++)
     selezione[i] = 0;
   i = 0;
   while(dialogo->kptrc[i] != 0)
   {
       selezione[i] = dialogo->kptrc[i];
       i++;
   }
   numSelected = i;
   if(from == 3)
      numSelected = 0;
   switch(gAction)
   {
   case DISTA:
        if((i < 2) || ((i % 2) != 0))
        {
           (void) MessageDialog(restraints_dlg, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
                    "You should select couples of atoms!");
           ier = 1;
        }
        break;
          
   case ANGLE:
        if((i < 3) || ((i % 3) != 0))
        {
           (void) MessageDialog(restraints_dlg, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
                    "You should select triples of atoms!");
           ier = 1;
        }
        break;

   case TORSION_ANGLE:
        if((i < 4) || ((i % 4) != 0))
        {
           (void) MessageDialog(restraints_dlg, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
                    "You should select 4-ples of atoms!");
           ier = 1;
        }
        break;

   case PLANE:
        if(i < 3) 
        {
           (void) MessageDialog(restraints_dlg, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
                    "You should select at least three atoms!");
           ier = 1;
        }
// da mettere in funzione quando Riccardo si adegua
//      if(numSelected == nats)
//         numSelected = 0;
        break;

   case SUM:
        if(i < 2) 
        {
           (void) MessageDialog(restraints_dlg, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
                    "You should select at least two atoms!");
           ier = 1;
        }
        break;

   case LIMIT:
        break;
   case SITE:
        for(int k=0; k<numSelected; k++)
        {
           if(iSite[selezione[k]-1] == 0)
           {
               (void) MessageDialog(restraints_dlg, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
                    "Atoms %s is not a site", Atomi[selezione[k]-1]);
               ier = 1;
           }
        }
        {
            int act = 0;
            clickforsite_(&act);
            (void) ridisegna_();
        }
        break;
   case DISORDER:
        if(numSelected == 1)
        {
           (void) MessageDialog(restraints_dlg, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
                    "You should select at least a couple of atoms.");
           ier = 1;
        }
        else if((numSelected % 2) == 1)            //dispari
           (void) MessageDialog(restraints_dlg, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
                    "Odd number of atoms.\nLast selected atom will be ignored.");
        break;
   }

   gtk_widget_set_sensitive(restraints_dlg, TRUE);
   gdk_window_raise(gtk_widget_get_window(restraints_dlg));

   if(!ier)
   {
       frame = get_widget(restraints_dlg, "frame_val");
       gtk_widget_set_sensitive(frame, TRUE);
       frame = get_widget(restraints_dlg, "accept_val");
       if((gAction == SUM) && (numpar == 0))
           gtk_widget_set_sensitive(frame, FALSE);
       frame = get_widget(restraints_dlg, "frame_par");
       gtk_widget_set_sensitive(frame, FALSE);
       gtk_widget_show(frame);
       if(gAction == SUM)
          gtk_widget_set_sensitive(frame, TRUE);
       frame = get_widget(restraints_dlg, "all");
       gtk_widget_show(frame);
       if(gAction == LIMIT)
          gtk_widget_hide(frame);
       frame = get_widget(restraints_dlg, "limit");
       gtk_widget_hide(frame);
       if(gAction == LIMIT)
          gtk_widget_show(frame);
       frame = get_widget(restraints_dlg, "frame_act");
       gtk_widget_set_sensitive(frame, FALSE);
       frame = get_widget(restraints_dlg, "ok_button");
       gtk_widget_set_sensitive(frame, FALSE);
       spin1 = get_widget(restraints_dlg, "distance");
       gtk_widget_set_sensitive(spin1, FALSE);
       label1 = get_widget(restraints_dlg, "ldistance");
       gtk_widget_set_sensitive(label1, FALSE);
       spin2 = get_widget(restraints_dlg, "angle");
       gtk_widget_set_sensitive(spin2, FALSE);
       label2 = get_widget(restraints_dlg, "langle");
       gtk_widget_set_sensitive(label2, FALSE);
       if(gAction == DISTA)
       {
           gtk_widget_set_sensitive(spin1, TRUE);
           gtk_widget_set_sensitive(label1, TRUE);
       }
       else if((gAction == ANGLE) || (gAction == TORSION_ANGLE) )
       {
           gtk_widget_set_sensitive(spin2, TRUE);
           gtk_widget_set_sensitive(label2, TRUE);
           if(gAction == ANGLE)
           {
              spin_button_set_range(spin2, 90., 180.);
              spin_button_set_value(spin2, 120.);
           }
           else if(gAction == TORSION_ANGLE)
           {
              spin_button_set_range(spin2, -180., 180.);
              spin_button_set_value(spin2, 180.);
           }
       }
       else if((gAction == SITE) || (gAction == DISORDER))
       {
            spin2 = get_widget(restraints_dlg, "esd");
            gtk_widget_set_sensitive(spin2, FALSE);
            label2 = get_widget(restraints_dlg, "lesd");
            gtk_widget_set_sensitive(label2, FALSE);
       }
   }
   else
       if(old_exp)
          gtk_tree_view_collapse_all ((GtkTreeView *) old_exp); 
}

void accept_val(GtkButton *button, gpointer data)
{
   int ok, i, ier;
   GtkWidget *frame, *label;
   GtkWidget *spin;

   ok = GPOINTER_TO_INT(data);
   ier = 0;
   if(ok)
   {
      spin = get_widget(restraints_dlg, "esd");
      esd = (float) spin_button_get_value(spin);
      switch(gAction)
      {
      case DISTA:
          spin = get_widget(restraints_dlg, "esd");
          esd = (float) spin_button_get_value(spin);
          spin = get_widget(restraints_dlg, "distance");
          distance = (float)spin_button_get_value(spin);
          for(i=0; i<numSelected; i+=2)
          {
              clsqgtk->vresGTK[nfl]   = (float) (gAction + 1);
              clsqgtk->vresGTK[nfl+1] = 2.0f;
              clsqgtk->vresGTK[nfl+2] = esd;
              clsqgtk->vresGTK[nfl+3] = distance;
              clsqgtk->vresGTK[nfl+4] = (float)selezione[i];
              clsqgtk->vresGTK[nfl+5] = (float)selezione[i+1];
              clsqgtk->nresGTK++;
              nfl += 6;
          }
          break;

      case ANGLE:
          spin = get_widget(restraints_dlg, "esd");
          esd = (float)spin_button_get_value(spin);
          spin = get_widget(restraints_dlg, "angle");
          angle = (float)spin_button_get_value(spin);
          for(i=0; i<numSelected; i+=3)
          {
              clsqgtk->vresGTK[nfl]   = (float) (gAction + 1);
              clsqgtk->vresGTK[nfl+1] = 3.0f;
              clsqgtk->vresGTK[nfl+2] = esd;
              clsqgtk->vresGTK[nfl+3] = angle;
              clsqgtk->vresGTK[nfl+4] = (float)selezione[i];
              clsqgtk->vresGTK[nfl+5] = (float)selezione[i+1];
              clsqgtk->vresGTK[nfl+6] = (float)selezione[i+2];
              clsqgtk->nresGTK++;
              nfl += 7;
          }
          break;

      case TORSION_ANGLE:
          spin = get_widget(restraints_dlg, "esd");
          esd = (float)spin_button_get_value(spin);
          spin = get_widget(restraints_dlg, "angle");
          angle = (float)spin_button_get_value(spin);
          for(i=0; i<numSelected; i+=4)
          {
              clsqgtk->vresGTK[nfl]   = (float) (gAction + 1);
              clsqgtk->vresGTK[nfl+1] = 4.0f;
              clsqgtk->vresGTK[nfl+2] = esd;
              clsqgtk->vresGTK[nfl+3] = angle;
              clsqgtk->vresGTK[nfl+4] = (float)selezione[i];
              clsqgtk->vresGTK[nfl+5] = (float)selezione[i+1];
              clsqgtk->vresGTK[nfl+6] = (float)selezione[i+2];
              clsqgtk->vresGTK[nfl+7] = (float)selezione[i+3];
              clsqgtk->nresGTK++;
              nfl += 8;
          }
          break;

      case PLANE:
          spin = get_widget(restraints_dlg, "esd");
          esd = (float)spin_button_get_value(spin);
          clsqgtk->vresGTK[nfl]   = (float) (gAction + 1);
          clsqgtk->vresGTK[nfl+1] = (float) numSelected;
          clsqgtk->vresGTK[nfl+2] = esd;
          clsqgtk->vresGTK[nfl+3] = 0.0f;
          nfl += 4;
          for(i=0; i<numSelected; i++)
          {
              clsqgtk->vresGTK[nfl] = (float)selezione[i];
              nfl++;
          }
          clsqgtk->nresGTK++;
          break;

      case SUM:
          spin = get_widget(restraints_dlg, "esd");
          esd = (float)spin_button_get_value(spin);
          if(numpar > 0)
          {
              clsqgtk->vresGTK[nfl]   = (float) (gAction + 1);
              clsqgtk->vresGTK[nfl+1] = (float) numSelected;
              clsqgtk->vresGTK[nfl+2] = esd;
              clsqgtk->vresGTK[nfl+3] = (float)numpar; 
              for(i=0; i<numpar; i++)
                  clsqgtk->vresGTK[nfl+4+i] = (float)param[i]; 
              nfl += 4+numpar;
              for(i=0; i<numSelected; i++)
              {
                  clsqgtk->vresGTK[nfl] = (float)selezione[i];
                  nfl++;
              }
              clsqgtk->nresGTK++;
          }
          else 
             ier = 1;
          break;
      case LIMIT:
          spin = get_widget(restraints_dlg, "sigmax");
          sigmax = (float)spin_button_get_value(spin);
          spin = get_widget(restraints_dlg, "sigmab");
          sigmab = (float)spin_button_get_value(spin);
          spin = get_widget(restraints_dlg, "sigmabij");
          sigmabij = (float)spin_button_get_value(spin);
          clsqgtk->vresGTK[nfl]   = (float) (gAction + 1);
          clsqgtk->vresGTK[nfl+1] = (float) numSelected;
          clsqgtk->vresGTK[nfl+2] = sigmax;
          clsqgtk->vresGTK[nfl+3] = sigmab;
          clsqgtk->vresGTK[nfl+4] = sigmabij;
          nfl += 5;
          for(i=0; i<numSelected; i++)
          {
              clsqgtk->vresGTK[nfl] = (float)selezione[i];
              nfl++;
          }
          clsqgtk->nresGTK++;
          break;
      case SITE:
          for(i=0; i<numSelected; i++)
          {
              clsqgtk->vresGTK[nfl]   = (float) (gAction + 1);
              clsqgtk->vresGTK[nfl+1] = (float) 1;
              nfl += 4;
              clsqgtk->vresGTK[nfl] = (float)selezione[i];
              nfl++;
              clsqgtk->nresGTK++;
          }
          break;
      case DISORDER:
          clsqgtk->vresGTK[nfl]   = (float) (gAction + 1);
          clsqgtk->vresGTK[nfl+1] = (float) (numSelected/2);
          nfl += 2;
          for(i=0; i<numSelected; i++)
          {
              clsqgtk->vresGTK[nfl] = (float)selezione[i];
              nfl++;
          }
          clsqgtk->nresGTK++;
          break;
      }
      if(!ier)
      {
         drwrstr_();
         frame = get_widget(restraints_dlg,"listaRestr");
         label = get_widget(restraints_dlg,"info");
         conta_restraints (frame, label);
         if(old_exp)
            gtk_tree_view_collapse_all ((GtkTreeView *) old_exp);
         frame = get_widget(restraints_dlg, "frame_val");
         gtk_widget_set_sensitive(frame, FALSE);
         frame = get_widget(restraints_dlg, "frame_act");
         gtk_widget_set_sensitive(frame, TRUE);
         frame = get_widget(restraints_dlg, "ok_button");
         gtk_widget_set_sensitive(frame, TRUE);
      }
   }
}
   
static void ok_lista(GtkButton *button, gpointer data)
{
    int i, selbis[NUMSPECIES];
    const gchar *nome;
    char *string = (char *) data;
    GtkWidget *lista = get_widget(gtk_widget_get_toplevel(GTK_WIDGET(button)),
                             string);

    nome = gtk_widget_get_name(GTK_WIDGET(button));
    if(strstr(nome, "ok") == NULL)
    {
       close_dlg(button, GINT_TO_POINTER(11));
       gtk_widget_set_sensitive(restraints_dlg, TRUE);
       if(old_exp)
          gtk_tree_view_collapse_all ((GtkTreeView *) old_exp); 
       return;
    }
    for(i=0; i<size_sel; i++)                    //MaxAtLSQ;i++) 090107
       selezione[i] = 0;
    if(strstr(string, "Species") != 0)
    {
       int ind;

       for(i=0; i<NUMSPECIES;i++)
           selbis[i] = 0;
       get_selected_rownums(lista, selbis);
       for(ind=0; ind<NUMSPECIES; ind++)
       {
           if(selbis[ind] == 1)
           {
              for(i=0; i<nats; i++)
                  if(nzTot[i] == (ind+1))
                     selezione[i] = 1;
           }
       }
    }
    else if(strstr(string, "Atoms") != 0)
       get_selected_rownums(lista, selezione);
    else                                          // Sites
    {
       int *selsit = g_new0(int, nSites);
       get_selected_rownums(lista, selsit);
       for(int ind=0; ind<nSites; ind++)
       {
           if(selsit[ind] == 1)
              selezione[indSites[ind]] = 1;
       }
       g_free(selsit);
    }

    numSelected = 0;
    for(i=0;i <size_sel; i++)
    {
       if(selezione[i])
          dialogo->kptrc[numSelected++] = i+1;
    }
    for(i=numSelected; i<nats; i++)
        dialogo->kptrc[i] = 0;              //numSelected++] = 0;
    close_dlg(button, GINT_TO_POINTER(11));
    gtk_widget_set_sensitive(restraints_dlg, TRUE);
    if(old_exp)
       gtk_tree_view_collapse_all ((GtkTreeView *) old_exp); 
    manage_ok_restr(2);
}


void cancella_riga(int nriga)
{
   int i, j, ksrc, kdst, tipo, natom, copia, trovati, ninc;
   GtkWidget *list;
   GtkWidget *label;

//   if(old_exp)
//      gtk_tree_view_collapse_all ((GtkTreeView *) old_exp); 
   list = get_widget(restraints_dlg, "listaRestr");

   if(nriga != -(ALL+1))
   {
      ksrc = 0;
      kdst = 0;
      natom = 0;
   
      trovati = 0;
      for(i=0; i<clsqgtk->nresGTK; i++)
      {
          copia = 0;
          tipo  = (int)clsqgtk->vresGTK[ksrc] - 1;
          natom = (int)clsqgtk->vresGTK[ksrc+1];
          if(tipo == SUM)   
             ninc = 4 + natom + (int)clsqgtk->vresGTK[ksrc+3];
          else if (tipo == LIMIT)
             ninc = 5 + natom;
          else if (tipo == DISORDER)
             ninc = 2 + natom*2;
          else 
             ninc = 4 + natom;
          if(nriga >= 0)
          {
             if(i == nriga)
                trovati++;
             else
                copia = 1;
          }
          else
          { 
             if(tipo == (-nriga - 1))
                trovati++;
             else
                copia = 1;
          }
          if (copia == 1)
          {
             for(j=0; j<ninc; j++)
                clsqgtk->vresGTK[kdst+j] = clsqgtk->vresGTK[ksrc+j];    
             kdst += ninc;
          }
          ksrc += ninc;
       }
       clsqgtk->nresGTK -= trovati;
   }
   else
      clsqgtk->nresGTK = 0;

   drwrstr_();
   label = get_widget(restraints_dlg,  "info");
   conta_restraints(list, label);
}

static void select_from_tree(GtkTreeSelection *selec, GtkWidget *dlg)
{
    GtkTreeModel *model;
    GtkTreeIter iter;
    GtkTreePath *path;
    GtkTreeView *treeview;
    char *linea;

    treeview = gtk_tree_selection_get_tree_view(selec);
    old_exp = GTK_WIDGET(treeview);
    if(gtk_tree_selection_get_selected (selec, &model, &iter))
    {
       linea = DuplicaStringa(get_selected_row_path(GTK_WIDGET(treeview)));
       path = gtk_tree_path_new_from_string(linea);
       if(gtk_tree_view_expand_row (treeview, path, 0)) //ramo principale
          return;
       else
       {
          int nodi[3], i;

          get_int_tokens(linea, ":", 2, nodi);
          gAction = nodi[0];
          if(gAction >= SITE)
          {
             if(nSites == 0)    // compensa la riga nascosta
                gAction++;
          }
          gSelMode = nodi[1];
          deleteActive = FALSE;
          switch(gAction)
          {
          case DISTA:
          case ANGLE:
          case TORSION_ANGLE:
          case PLANE:
               mostra_tbg1lsq(mainwin, gSelMode+2, 2);
               break;
          case SUM:
          case LIMIT:
               gtk_widget_set_sensitive(dlg, FALSE);
               for (i=0; i<size_sel; i++)
                   selezione[i] = 0;
               switch(gSelMode)
               {
               case 0:                  // List 
                  mostra_lista("Select Atoms", "Atoms", Atomi, nats, 1,
                         G_CALLBACK(ok_lista));
                  break;
       
               case 1:                  // Species 
                  mostra_lista("Select Species", "Species", Specie, nSpec, 1,
                           G_CALLBACK(ok_lista));
                  break;

                case 4:                 // All 
                   for (i=0; i<nats; i++)
                        dialogo->kptrc[i] = i+1;
                   manage_ok_restr(3);
                   break;

                default:               // Mouse click or Polygon 
                   mostra_tbg1lsq(mainwin, gSelMode, 2);
                   break;
                }
                break;
          case SITE:
               gtk_widget_set_sensitive(dlg, FALSE);
               for (i=0; i<size_sel; i++)
                   selezione[i] = 0;
               switch(gSelMode)
               {
               case 0:                  // List 
                  mostra_lista("Select Sites", "Sites", Sites, nSites, 1,
                         G_CALLBACK(ok_lista));
                  break;
               default:               // Mouse click
                  {
                  int act = 1;
                  clickforsite_(&act);
                  (void) ridisegna_();
                  mostra_tbg1lsq(mainwin, gSelMode, 2);
                  }
                  break;
               }
               break;
          case DISORDER:
               gtk_widget_set_sensitive(dlg, FALSE);
               for (i=0; i<size_sel; i++)
                   selezione[i] = 0;
               mostra_tbg1lsq(mainwin, gSelMode, 2);
               break;
          case DEL:                       /* Delete */
               if(gSelMode >= SITE)
               {
                  if(nSites == 0)
                     gSelMode++;
               }
               switch(gSelMode)
               {
               case DISTA:                 /* Distance restraints */

               case ANGLE:                 /* Angle restraints */

               case TORSION_ANGLE:         /* Torsion Angle restraints */

               case PLANE:                 /* Plane restraints */

               case SUM:                   /* Sum restraints */

               case LIMIT:                 /* Limit restraints */

               case SITE:                  /* Site restraints */

               case DISORDER:              /* Disorder restraints */

               case ALL:                   /* Delete all */
                    cancella_riga(-(gSelMode+1));
                    break;

               case ALL-1:                    /* Delete by list */
                    deleteActive = TRUE;    
                    break;
               }
               break;
          }

       }
    }
}

void end_restraints(GtkButton *button, gpointer data)
{
   if(old_exp)
      gtk_tree_view_collapse_all ((GtkTreeView *) old_exp); 
   close_dlg(button, GINT_TO_POINTER(1));
   g_free(selezione);
   for(int i=0; i<nats; i++)
       g_free(Atomi[i]);
   g_free(Atomi);
   for(int i=0; i<nSites; i++)
       g_free(Sites[i]);
   g_free(Sites);
   g_free(indSites);

   (void) c_finish_restraints(data, nfl);
}

void del_restraints(GtkButton *button, GtkWidget *list)
{
    if(rowSelected != -1)
        cancella_riga(rowSelected);             
    gtk_widget_set_sensitive(GTK_WIDGET(button), FALSE);
}

static void sel_restr(GtkTreeSelection *selec, gpointer data)
{
    GtkTreeModel *model;
    GtkTreeIter iter;
    GtkTreeView *treeview;
    gboolean is_selection;
    GtkWidget *button;

    treeview = gtk_tree_selection_get_tree_view(selec);
    is_selection = gtk_tree_selection_get_selected (selec, &model, &iter);
    button = lookup_widget(GTK_WIDGET(treeview), "delete");

    if(is_selection)
    {
       rowSelected = row_selected(selec);
       if(!deleteActive)
       {
          unselect_row(GTK_WIDGET(treeview), rowSelected);
          is_selection = FALSE;
       }
    }
    else
       rowSelected = -1;
    gtk_widget_set_sensitive(button, is_selection);

}

void select_param (GtkToggleButton *button, gpointer data)
{
    int i;
    char num[5];
    GtkWidget *accept_button;

    numpar = 0;
    for(i=0; i<(int) (NUMPAR); i++)
    {
        ScriviStringa(num, sizeof(num), "%d", i);
        button = GTK_TOGGLE_BUTTON(get_widget(restraints_dlg, num));
        if(gtk_toggle_button_get_active(button))
           param[numpar++] = i+1;
    }
    accept_button = get_widget(restraints_dlg, "accept_val");
    if(numpar > 0)
       gtk_widget_set_sensitive(accept_button, TRUE);
    else
       gtk_widget_set_sensitive(accept_button, FALSE);
}

#ifdef GTK_TREE_MODEL_FILTER
static gboolean visible_func (GtkTreeModel *model,
              GtkTreeIter  *iter,
              gpointer      data)
{
  // Visible if first column is not Site or nSites > 0
  gchar *str;
  gboolean visible = FALSE;

  gtk_tree_model_get (model, iter, 0, &str, -1);
  if ((nSites > 0) || 
      ((strcmp (str, restrnames[SITE].label) != 0) &&
       (strcmp (str, which_del[SITE].label)  != 0) ))
    visible = TRUE;
  g_free (str);

  return visible;
}
#endif

void help_restr(GtkButton *button, gpointer data)
{
    open_htm("refine"); //Refine.html#restraints");
}

GtkWidget* create_restraints (void)
{
  GtkWidget *restraints_window;
  GtkWidget *vbox;
  GtkWidget *align;
  GtkWidget *vbox2;
  GtkWidget *hbox;
  GtkWidget *hbox1;
  GtkWidget *label;
  GtkWidget *frame;
  GtkWidget *list;
  GtkWidget *button;
  GtkWidget *ok_button;
  GtkWidget *help_button;
  GtkWidget *cancel_button;
  GtkWidget *accept_button;
  GtkWidget *checkbutton;
  GtkWidget *table;
  GtkSizeGroup *group;
//  char label_text[200];
  char num[5];
  int  i, j, k;
  int nrows = 3, ncols = 4;

  restraints_window = gtk_dialog_new ();
  g_object_set_data (G_OBJECT (restraints_window), 
                       "restraints_window", restraints_window);
  gtk_window_set_title (GTK_WINDOW (restraints_window), 
                        "Manage restraints");
  gtk_window_set_default_size (GTK_WINDOW (restraints_window), 300, 450);

  vbox = gtk_dialog_get_content_area(GTK_DIALOG(restraints_window));

  hbox = hbox_new (FALSE, 0);
  gtk_widget_show (hbox);
  gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, FALSE, 0);

  frame = NEW_FRAME("Select Action", &FrameStyle);
  g_object_set_data (G_OBJECT (restraints_window), "frame_act",frame);
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (hbox), frame, TRUE, TRUE, 0);

  GtkWidget *tv = do_tree_store(get_widget(frame, "align"), restrnames, G_CALLBACK(select_from_tree), restraints_window);
  g_object_set_data (G_OBJECT (restraints_window), "lista_restr",tv);

  frame = NEW_FRAME ("Set values", &FrameStyle);
  g_object_set_data (G_OBJECT (restraints_window), "frame_val", frame);
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (hbox), frame, TRUE, TRUE, 0);

  vbox2 = vbox_new(FALSE, 0);
  gtk_widget_show(vbox2);
  gtk_container_add(GTK_CONTAINER(get_widget(frame, "align")), vbox2);

  table = table_new (3, 1, TRUE);
  g_object_set_data (G_OBJECT (restraints_window), "all", table);
  gtk_widget_show (table);
  gtk_box_pack_start(GTK_BOX(vbox2), table, TRUE, TRUE, 0);
  gtk_container_set_border_width(GTK_CONTAINER(table), 5);
  table_set_row_spacings(table, 5);
  group = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);

  label = SPIN_WITH_LABEL("Distance", LABELCOLOR, 0.9, 3.0, 1.25, 0.05, 2);
  table_attach_exp (table, label, 0, 1, 0, 1);
  g_object_set_data (G_OBJECT (restraints_window), "ldistance",
                 get_widget(label, "label"));
  g_object_set_data (G_OBJECT (restraints_window), "distance",
                 get_widget(label, "spin"));
  gtk_widget_show_all (label);
  gtk_size_group_add_widget(group, get_widget(label, "label"));

  label = SPIN_WITH_LABEL("Angle", LABELCOLOR, 90., 180., 120., 0.1, 2);
  table_attach_exp (table, label, 0, 1, 1, 2);
  g_object_set_data (G_OBJECT (restraints_window), "langle",
                 get_widget(label, "label"));
  g_object_set_data (G_OBJECT (restraints_window), "angle",
                 get_widget(label, "spin"));
  gtk_widget_show_all (label);
  gtk_size_group_add_widget(group, get_widget(label, "label"));

  label = SPIN_WITH_LABEL("ESD", LABELCOLOR, 0.00001, 0.001, 0.001, 0.00001, 5);
  table_attach_exp (table, label, 0, 1, 2, 3);
  g_object_set_data (G_OBJECT (restraints_window), "lesd",
                 get_widget(label, "label"));
  g_object_set_data (G_OBJECT (restraints_window), "esd",
                 get_widget(label, "spin"));
  gtk_widget_show_all (label);
  gtk_size_group_add_widget(group, get_widget(label, "label"));

  table = table_new (3, 1, TRUE);
  g_object_set_data (G_OBJECT (restraints_window), "limit", table);
  gtk_box_pack_start(GTK_BOX(vbox2), table, TRUE, TRUE, 0);
  gtk_container_set_border_width(GTK_CONTAINER(table), 5);
  table_set_row_spacings(table, 5);
  group = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);

  label = SPIN_WITH_LABEL("ESD(x)", LABELCOLOR, 0.0001, 0.01, 0.001, 0.0001, 5);
  table_attach_exp (table, label, 0, 1, 0, 1);
  g_object_set_data (G_OBJECT (restraints_window), "sigx",
                 get_widget(label, "label"));
  g_object_set_data (G_OBJECT (restraints_window), "sigmax",
                 get_widget(label, "spin"));
  gtk_widget_show_all (label);
  gtk_size_group_add_widget(group, get_widget(label, "label"));

  label = SPIN_WITH_LABEL("ESD(B)", LABELCOLOR, 0.01, 1., 0.1, 0.01, 5);
  table_attach_exp (table, label, 0, 1, 1, 2);
  g_object_set_data (G_OBJECT (restraints_window), "sigb",
                 get_widget(label, "label"));
  g_object_set_data (G_OBJECT (restraints_window), "sigmab",
                 get_widget(label, "spin"));
  gtk_widget_show_all (label);
  gtk_size_group_add_widget(group, get_widget(label, "label"));

  label = SPIN_WITH_LABEL("ESD(bij)", LABELCOLOR, 0.0001, 0.01, 0.001, 0.0001, 5);
  table_attach_exp (table, label, 0, 1, 2, 3);
  g_object_set_data (G_OBJECT (restraints_window), "sigbij",
                 get_widget(label, "label"));
  g_object_set_data (G_OBJECT (restraints_window), "sigmabij",
                 get_widget(label, "spin"));
  gtk_widget_show_all (label);
  gtk_size_group_add_widget(group, get_widget(label, "label"));

  label = NEW_FRAME("Parameters", &FrameStyle2);
  g_object_set_data(G_OBJECT (restraints_window), "frame_par",label);
  gtk_widget_show(label);
  gtk_box_pack_start(GTK_BOX(vbox2), label, TRUE, TRUE, 0);

  table = table_new (nrows, ncols, TRUE);
  gtk_widget_show (table);
  gtk_container_add(GTK_CONTAINER(get_widget(label, "align")), table);
  gtk_container_set_border_width(GTK_CONTAINER(table), 2);
  table_set_row_spacings(table, 2);
  table_set_col_spacings(table, 2);

  for(i=0; i<(int) (NUMPAR);i++)
  {
     j = i % ncols;
     k = i / ncols;
/*
     if(i <= 3)
     {
        j = i % 3;
        k = i / 3;
     }
     else if(i == 10)
     {
        j = 2;
        k = 1;
     }
     else
     {
        j = (i-1) % 3;
        k = (i-1) / 3 + 1;
     }
*/
     checkbutton = CHECK_BUTTON_WITH_LABEL (parametri[i], LABELCOLOR);
     ScriviStringa(num, sizeof(num), "%d", i);
     g_object_set_data(G_OBJECT (restraints_window), num, checkbutton);
     gtk_widget_show (checkbutton);
     table_attach_exp (table, checkbutton, j, j+1, k, k+1);
     (void) g_signal_connect(G_OBJECT(checkbutton), "toggled",
                        G_CALLBACK(select_param), NULL);
  }

#ifdef IN_GTK3
  label = new_alignment(GTK_ALIGN_START, GTK_ALIGN_START, 0, 0);
#else
  label = gtk_alignment_new(0.5f, 0.5f, 0.0f, 0.0f);
#endif
  gtk_widget_show(label);
  gtk_box_pack_start(GTK_BOX(vbox2), label, TRUE, TRUE, 0);

  accept_button = myimage_button ("_Accept", "apply.png");
  g_object_set_data (G_OBJECT (restraints_window), "accept_val",
                 accept_button);
  gtk_container_add(GTK_CONTAINER(label), accept_button);
  (void) g_signal_connect(G_OBJECT(accept_button), "clicked",
                     G_CALLBACK(accept_val), GINT_TO_POINTER(1));
  gtk_widget_show (accept_button);

  frame = NEW_FRAME("List of restraints", &FrameStyle);
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 0);

  hbox1 = hbox_new(FALSE, vspace);
  gtk_widget_show(hbox1);
  gtk_container_add(GTK_CONTAINER(get_widget(frame, "align")), hbox1);

  list = createSelection(restraints_window, hbox1,NULL,"listaRestr", 10, "blue");
  set_widget_fontN(list);

  gtk_tree_selection_set_mode (gtk_tree_view_get_selection (GTK_TREE_VIEW (list)),
				   GTK_SELECTION_SINGLE);
  g_signal_connect(G_OBJECT(gtk_tree_view_get_selection (GTK_TREE_VIEW (list))),
        "changed", G_CALLBACK(sel_restr), NULL);

  vbox2 = vbox_new(FALSE, 0);
  gtk_widget_show(vbox2);
  gtk_box_pack_end(GTK_BOX(hbox1), vbox2, FALSE, FALSE, 0);


#ifdef IN_GTK3
  label = new_alignment(GTK_ALIGN_START, GTK_ALIGN_START, 0, 0);
#else
  label = gtk_alignment_new(0.5f, 0.5f, 0.0f, 0.0f);
#endif
  gtk_widget_show(label);
  gtk_box_pack_start(GTK_BOX(vbox2), label, FALSE, FALSE, 0);

  button = myimage_button ("_Delete", "deleteeq.png");
  g_object_set_data(G_OBJECT(restraints_window), "delete", button);
  gtk_widget_set_sensitive(button, FALSE);
  gtk_container_add(GTK_CONTAINER(label), button);
  (void) g_signal_connect(G_OBJECT(button), "clicked", 
         G_CALLBACK(del_restraints), list);                  
  
  frame = NEW_FRAME("Defined restraints", &FrameStyle);
  gtk_widget_show (frame);
  gtk_box_pack_end (GTK_BOX (vbox2), frame, FALSE, FALSE, 0);
  align = get_widget(frame, "align");
  
  std::string label_text;
  label_text.assign(g_strdup_printf(gFormato[0], num_restr[0]));
  for(int l=1; l< (int)NTYPERES; l++)
      label_text.append(g_strdup_printf(gFormato[l], num_restr[l]));
/*
  ScriviStringa(label_text, sizeof(label_text), gFormato, num_restr[0], num_restr[1],
                 num_restr[2], num_restr[3], num_restr[4], num_restr[5]);
  label = LABEL_NEW(label_text, NULL);
*/
  label = LABEL_NEW(label_text.c_str(), NULL);
  g_object_set_data (G_OBJECT (restraints_window), "info", label);
  gtk_container_add(GTK_CONTAINER(align), label);
  gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);
  gtk_widget_show(label);

  help_button = HELP_button();
  gtk_widget_show (help_button);
  gtk_dialog_add_action_widget (GTK_DIALOG (restraints_window), help_button, 1);
  (void) g_signal_connect (G_OBJECT(help_button), "clicked",
  G_CALLBACK(help_restr), NULL);

  ok_button = OK_button();
  g_object_set_data (G_OBJECT (restraints_window), "ok_button",
                            ok_button);
  (void) g_signal_connect(G_OBJECT(ok_button), "clicked", 
         G_CALLBACK(end_restraints), GINT_TO_POINTER(1));
  gtk_dialog_add_action_widget (GTK_DIALOG (restraints_window), ok_button, 2);
  gtk_widget_show (ok_button);

  cancel_button = CANCEL_button();
  g_object_set_data (G_OBJECT (restraints_window), "cancel_button",
                            cancel_button);
  gtk_dialog_add_action_widget (GTK_DIALOG (restraints_window), cancel_button, 2);
  (void) g_signal_connect(G_OBJECT(cancel_button), "clicked", 
         G_CALLBACK(end_restraints), GINT_TO_POINTER(0));
  gtk_widget_show (cancel_button);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(ok_button)),
        GTK_BUTTONBOX_SPREAD);

  (void) g_signal_connect_swapped(G_OBJECT(restraints_window), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(cancel_button)); 
  (void) g_signal_connect (G_OBJECT (restraints_window), "delete_event",
                      G_CALLBACK(true_cb), NULL);

  return restraints_window;
}

void restraints (GtkWidget *widget, gpointer data)
{
   GtkWidget *frame, *label;
   int ier = 0;
   init_restraints_(&ier);
   if(ier)
      return;

   mainwin = finestre[0]; 

   if(restraints_dlg == NULL)
       restraints_dlg = create_restraints();
   g_object_set_data(G_OBJECT(mainwin), "win_dlg", restraints_dlg);

/* inizializzazioni */


   nats = clsqgtk->natsGTK;
   Atomi = g_new0(char *, nats);
   stringatovector(clsqgtk->AtomsGTK, Atomi, nats, 8);
   selezione = g_new0(int, size_sel);

   nSites = 0;
   for(int kk=0; kk<nats; kk++)
   {
       if(iSite[kk] != 0)
          nSites++;
   }
   Sites = g_new0(char *, nSites);
   indSites = g_new0(int, nSites);
   int jj=0;
   for(int kk=0; kk<nats; kk++)
   {
       if(iSite[kk] != 0)
       {
          indSites[jj] = kk;
          Sites[jj++] = DuplicaStringa(Atomi[kk]);
       }
   }

   GtkWidget *tv = get_widget(restraints_dlg, "lista_restr");
#ifdef GTK_TREE_MODEL_FILTER
   GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(tv));

   GtkTreeModel *model1 = gtk_tree_model_filter_new(model, NULL);
   gtk_tree_model_filter_set_visible_func ((GtkTreeModelFilter *)model1, visible_func, NULL, NULL);
   gtk_tree_view_set_model (GTK_TREE_VIEW(tv), NULL);
   gtk_tree_view_set_model (GTK_TREE_VIEW(tv), model1);
#endif
   frame = get_widget(restraints_dlg, "frame_act");
   gtk_widget_set_sensitive(frame, TRUE);

   frame = get_widget(restraints_dlg, "listaRestr");
   set_widget_font(frame, (char *)main_app::TheApp.FontN().c_str());
   label = get_widget(restraints_dlg, "info");
   conta_restraints (frame, label);

   frame = get_widget(restraints_dlg, "frame_val");
   gtk_widget_set_sensitive(frame, FALSE);

   gtk_widget_show (restraints_dlg);
   finestra_modale_aperta2(restraints_dlg);
}


/********************************************************/
/*              R E F I N E _ D L S Q                   */
/********************************************************/

GtkWidget *dlsq_dlg = NULL;
float df;
int nci;

int c_finish_dlsq(gpointer data, float val1, int val2)
{
   int exitC;
   int ier=0;
   
   exitC = GPOINTER_TO_INT(data);
   finish_dlsq_(&exitC, &val1, &val2);
   return ier;
}

void end_dlsq(GtkButton *button, gpointer data)
{
   GtkWidget *spin;

   if(GPOINTER_TO_INT(data))
   {
      spin = get_widget(dlsq_dlg, "dampi");
      df = (float)spin_button_get_value(spin);
      spin = get_widget(dlsq_dlg, "ncycles");
      nci = spin_button_get_value_as_int(spin);
   }
   g_free(selezione);
   for(int i=0; i<nats; i++)
       g_free(Atomi[i]);
   g_free(Atomi);
   close_dlg(button, GINT_TO_POINTER(1));
   (void) c_finish_dlsq(data, df, nci);
}

void help_dlsq(GtkButton *button, gpointer data)
{
    open_htm("refine"); //Refine.html#dlsq");
}

GtkWidget *create_dlsq(void)
{
  GtkWidget *window, *vbox, *hbox1, *ok_button, *cancel_button;
  GtkWidget *frame, *list, *dampi, *ncycles, *label1, *label2, *help_button;

  window = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (window), "DLSQ");
  gtk_container_set_border_width(GTK_CONTAINER(window), 10);
  gtk_window_set_default_size (GTK_WINDOW (window), 450, 350);

  vbox = gtk_dialog_get_content_area(GTK_DIALOG(window));

  frame = NEW_FRAME("List of restraints", &FrameStyle);
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 0);
  gtk_container_set_border_width(GTK_CONTAINER(frame), 10);

  list = createSelection(window, get_widget(frame, "align"),NULL,"listaRestr", 0, "blue");
  set_selection_mode(list, GTK_SELECTION_NONE);

  frame = gtk_frame_new (NULL);
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, FALSE, 0);
  gtk_container_set_border_width(GTK_CONTAINER(frame), 10);


  label1 = SPIN_WITH_LABEL("Damping Factor", LABELCOLOR, 0.1f, 1.0f, 1.0f, 0.1f, 1);
  label2 = SPIN_WITH_LABEL("# of Cycles", LABELCOLOR, 0, 100, 3, 1, 0);
  dampi = get_widget(label1, "spin");
  ncycles = get_widget(label2, "spin");
  g_object_set_data (G_OBJECT (window), "dampi", dampi);
  g_object_set_data (G_OBJECT (window), "ncycles", ncycles);

  hbox1 = hbox_new(FALSE, 0);
  gtk_container_add (GTK_CONTAINER (frame), hbox1);
  gtk_container_set_border_width(GTK_CONTAINER(hbox1), 10);

  gtk_box_pack_start(GTK_BOX (hbox1), label1, TRUE, TRUE, 2);
  gtk_box_pack_start(GTK_BOX (hbox1), label2, TRUE, TRUE, 4);

  help_button = HELP_button();
  gtk_widget_show (help_button);
  gtk_dialog_add_action_widget (GTK_DIALOG (window), help_button,1);
  (void) g_signal_connect (G_OBJECT(help_button), "clicked",
  G_CALLBACK(help_dlsq), NULL);

  ok_button = myimage_button("", "go.png");
  g_object_set_data (G_OBJECT (window), "ok_button",
                            ok_button);
  (void) g_signal_connect(G_OBJECT(ok_button), "clicked", 
         G_CALLBACK(end_dlsq), GINT_TO_POINTER(1));
  gtk_dialog_add_action_widget (GTK_DIALOG (window), ok_button,2);
  gtk_widget_show (ok_button);

  cancel_button = CANCEL_button();
  g_object_set_data (G_OBJECT (window), "cancel_button",
                            cancel_button);
  gtk_dialog_add_action_widget (GTK_DIALOG (window), cancel_button,3);
  (void) g_signal_connect(G_OBJECT(cancel_button), "clicked", 
         G_CALLBACK(end_dlsq), GINT_TO_POINTER(0));
  gtk_widget_show (cancel_button);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(ok_button)),
     GTK_BUTTONBOX_SPREAD);

  (void) g_signal_connect_swapped(G_OBJECT(window), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(cancel_button)); 
  (void) g_signal_connect (G_OBJECT (window), "delete_event",
                      G_CALLBACK(true_cb), NULL);

  return window;
}
void open_dlsq (GtkWidget *widget, gpointer data)
{
   GtkWidget *frame;
//   int i, n;
   int ier = 0;
   init_restraints_(&ier);
   if(ier)
      return;

   if(dlsq_dlg == NULL)
       dlsq_dlg = create_dlsq();

/* inizializzazioni */

   nats = clsqgtk->natsGTK;
   Atomi = g_new0(char *, nats);
   selezione = g_new0(int, size_sel);
   stringatovector(clsqgtk->AtomsGTK, Atomi, nats, 8);

   frame = get_widget(dlsq_dlg,"listaRestr");
   set_widget_font(frame, (char *)main_app::TheApp.FontN().c_str());
   conta_restraints (frame, NULL);

   gtk_widget_show_all (dlsq_dlg);
   finestra_modale_aperta2(dlsq_dlg);
}
