   MODULE RefinecomRef
   USE progtype, only: refine_condition_type, refine_info_type
!
   type(refine_condition_type) :: rfcond   
   type(refine_info_type)      :: rinfo
!
   END MODULE RefinecomRef

   MODULE rietv

   implicit none

   contains

   subroutine Count0(rcond)
   use progtype, only: refine_condition_type
   implicit none
   type(refine_condition_type), intent(in) :: rcond
   end subroutine Count0

!------------------------------------------------------------------------------------

   subroutine init_rietveld(kaction,initfo,scalefo,rcond)
   USE progtype, only: refine_condition_type
   USE reflection_type_util
   USE proginterface
   USE nr
   USE variables, only: cryst,dataset
   USE General, only: neutro,wavel,knw,celem
   USE Atomi, only: nzConst
   USE Molcom, only: jscreen
   USE datasetmod
   USE counts
   USE Testmodel, only: coordPub, nzPub, aLabPub, nCoordPub
   USE atom_type_util
   USE messagemod
   integer, intent(in)                              :: kaction
   logical, intent(in)                              :: initfo
   logical, intent(in)                              :: scalefo
   type(refine_condition_type), intent(inout)       :: rcond
   type(reflection_type), dimension(:), allocatable :: ref
   type(dataset_type)                               :: datas
   type(atom_type), dimension(:), allocatable       :: atmpub
   integer :: i
!
!  Set reflections for crystal phase
   call fillref(ref)
   ref%tthd(1) = thvalue(0.5/sqrt(ref%slaq),wavel)
   call sort_reflections(ref,ORD_BY_2THETA)
   call cryst(1)%set_reflections(ref)
!
!  Set dataset for single crystal      
   datas%datatype = SCRYS_DATA
   datas%radtype = neutro
   call datas%set_wave(1,[wavel])
   call push_back_dataset(dataset,datas)
   dataset(1)%tmin = minval(ref(:)%tthd(1))
   dataset(1)%tmax = maxval(ref(:)%tthd(1))
!
   if (knw > 0) then
       call xyz_to_atom(atmpub,coordPub(:3,:nCoordPub),nz=nzPub*nzConst,lab=aLabPub,elem=celem)
       call cryst(1)%set_as_known(atmpub,dataset(1)%radtype)
   endif
!
   if (jscreen > 0) then
       call StartStopMsg(1)
       call init_messages()
   endif
!
   end subroutine init_rietveld

   end module rietv

   module conteggi
   implicit none
   integer, parameter :: npunti = 0
   end module conteggi
