#ifndef GUI_ENV
#include <cutils.h>
#else
#include <utils.h>
#endif
#include <int_main.h>
#include <gtkmrcomune.h>
#include <gtkdefs.h>
#include "sir.h"
#include "forcomm1.h"
#include <forcomm2.h>
#include <forlink.h>
#include "forlink1.h"
#include "forlink2.h"

static const char *desc_about = "A program for automatic solution and refinement \nof crystal structures.\n\n"
"By M.C. Burla, R. Caliandro, B. Carrozzini, \nG.L. Cascarano, "
"C. Cuocci, C. Giacovazzo,\nM.Mallamo, A. Mazzone, G.Polidori,\nD.Siliqi.";
static const char  *about_pixmap  = "sir2020about.png";

void SettaGruppoDefault(const char *nome);

namespace main_app {
Application TheApp = Application(MR_PACKAGE, MR_VERSION, PK, prg_files_dir,
                 EX_DIR, 1, desc_about, about_pixmap);

#ifdef __cplusplus
extern "C" {
#endif
int Main (int argc, char **argv)
{
     int k = 0;
     int i, result = TheApp.Initialize(argc, argv); 

     if(!result)
        return -1;

     TheApp.standalone = true;
     dialogo->NOCFG = 0;         //22/07/2016
     args->argc = argc;
     for(i=0; i<argc; i++)
     {
         if(strcmp(argv[i], "--version") == 0)
         {
            TheApp.InfoAbout();
            return 0;
         }
         else if(strcmp(argv[i], "--sub") == 0)
         {
            args->argc--;
            TheApp.standalone = false;
         }
//22/07/2016
         else if(strcmp(argv[i], "--nocfg") == 0)
         {
            args->argc--;
            TheApp.nocfg = true;
            dialogo->NOCFG = 1;
         }
//END 22/07/2016
         else
         {
            CopiaStringa(args->arg[k], MaxLenFilename, argv[i]);
            k++;
         }
     }

     ScriviStringa(SWareRC->SWRC, MaxLenFilename, "%s", TheApp.ConfFile().c_str());
     ScriviStringa(SWareRC->HOMEdir, MaxLenFilename, "%s", TheApp.ConfDir().c_str());
     ScriviStringa(SWareRC->WorkingDirectory, MaxLenFilename, "%s", TheApp.WorkingDirectory().c_str());

     RP->nRecentProjects   = TheApp.nRecentProjects;
     for(i=0; i<5;i++)
         CopiaStringa(RP->RecentProj[i], MaxLenFilename, TheApp.RecentProj[i]);
     dialogo->ifGTK        = 1;
     dialogo->ifLabels     = TheApp.IfLabels;
     dialogo->iPlotType    = TheApp.PlotType;
     dialogo->ifBestVisual = TheApp.Bestv;
     dialogo->color_GHOST        = GHOST;
     dialogo->color_CELL         = CELLC;
     dialogo->jBackGround        = TheApp.Background;

     ScriviStringa(dialogo->ProgName, MaxLenFilename, "%s", TheApp.PackageName());
     dialogo->lProgName = (int) strlen(dialogo->ProgName);
     ScriviStringa(dialogo->PkgName, MaxLenFilename, "%s", PACKAGE_STRING);
     dialogo->lPkgName = (int) strlen(dialogo->PkgName);
     SettaGruppoDefault(TheApp.GroupsFile().c_str());
     sir2006main_();

    return 0;
}

#ifdef __cplusplus
          }
#endif
}

std::string main_dir()
{
    std::string dir = main_app::TheApp.MainDir();
    return dir;
}
