!-----------------------------------------------------------------------
!
!-- Versione 30.09.11   (senza store)
!
!-----------------------------------------------------------------------
!-- 28/03/07 -- build dimensionato a 1000 atomi, da usare con modul2006_1000.f
! jdimbuild=1000  !dimension dei vettori in clust
!-- NEW VERSION: 1001 atomi non considera gli angoli
!
!-----------------------------------------------------------------------
      MODULE BuildModuleSmall
          integer :: DimStored = 0
          real, allocatable :: stored(:)
      END MODULE BuildModuleSmall
!-----------------------------------------------------------------------
      subroutine DeallocaBuildModuleSmall
      USE BuildModuleSmall
!
      if (allocated(stored)) then
          deallocate(stored)
      endif
      DimStored = 0
!
      return
      end
!-----------------------------------------------------------------------
!
!
!code for build
      subroutine build(kaction, jComplete)
!
!-------------------------------------------------------------------------
!-- significato dei vettori usati
!
! subrotine clust
!  nord_coppia(1:nats20),  
!  
!  nord_picco1_coppia(1:nats20), 1o.picco nella coppia  
!  
!  nord_picco2_coppia(1:nats20), 2o.picco nella coppia
!  
!  nopsym_picco2_coppia(1:nats20), no. del op.di sim del 2o.picco
!
!  kodice_dist(1:nats20),         2 distanza accettata,1 tra dmax e dmin, 0 fuori, -1 incompatibile
!  
!  dist_coppia(1:nats20),          distanza
!  
!  distxyz_coppia(1:nats20,1:3),   componenti della distanza
!  
!  atomo_in_coppie(1:nats20,1:nn), (no. picco,no.coppie dove partecipa seguito dai nord in nord_coppia
!                                   nord>0 legame accettato, nord<0 coppia incompatibile
!  atomo_in_angoli(1:nats20,1:nn),  (nord picco,no.angoli dove partecipa seguito dai nord in norang)
!                                  
!  legami_atomo(1:nats20,1:nn),     (nord picco,no.legame(coppie accettate)dove partecipa seguito dai nord in nord_coppia)
!
!  norang(1:4,nang),                (picco1-picco2-picco3-somma intensita,no. angolo)
!
!  angolo(nang),                    valore dell'angolo in gradi
!
!  numfr(1:MaxAtomsBuild),          numero di atomi in ogni frammento
!  
!  idfrag(1:MaxAtomsBuild),     
!  
!  jdfrag(1:MaxAtomsBuild),     
!  
!  ianel(1:MaxAtomsBuild),      
!  
!  isol(1:MaxAtomsBuild),       
!  
!  movefr(1:MaxAtomsBuild),     
!  
!  mfra(1:MaxAtomsBuild),       
!  
!  jfisspk(1:MaxAtomsBuild),    
!  
!  jfissfr(1:MaxAtomsBuild),    
!  
!  jfrag(1:MaxAtomsBuild),       
!  
!  kvet(1:3,1:MaxAtomsBuild),  
!  
!  icogr(1:MaxAtomsBuild),      
!  
!  icopf(1:MaxAtomsBuild),      
!  
!  baric(1:3,1:MaxAtomsBuild),  
!  
!  xyzbu(1:8,1:MaxAtomsBuild),  
!  
!  rxyzs(1:5,1:MaxAtomsBuild),  
!  
!  groupatomi(1:9*nk),  
!  
!  LongConnect(1:nats20,1:nn),
!  
!  kluster(1:nats),               
!  
!  intens_legati(1:nats),         
!  
!  incomp_atomi(1:nats,1:nn),     
!-------------------------------------------------------------------------
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE BuildStuff
      USE PhaseModule
      USE BuildModule
      USE BuildStuff
!   
!--main subroutine for peaks management
!
!-- jComplete = 0  calcolate connectivity ab initio (iconn(1)=0)
!-- jComplete = 1  complete a partial connectivity  (iconn(1)=-iconn(1))
!-- jComplete = 2  recompute connectivity           (iconn(1)=-iconn(1))
!-- if(jComplete.eq.1) e nAtmBlocc=0 : 
!-- aggiunge le nuove copie alla vecchia conn.
!-- conserva le copie con iconn(n+2) = 1,2,3,-1 (tutte)
!-- if(jComplete.eq.1) e nAtmBlocc=nats : viene da Move chiama build_per_Move 
!-- if(jComplete.eq.2) :
!-- aggiunge le nuove copie alle vecchie date dall utente
!-- conserva le copie con iconn(n+2) =   2,3,-1
!-- iconn(n+2) =  1 copia generata da programma
!-- iconn(n+2) =  2 copia definita dall'utente
!-- iconn(n+2) =  3 copia (legame H) definita dall'utente
!-- iconn(n+2) = -1 copia cancellata dall'utente
!
!-- izpk(i)= (10000*numero d'ordine del elem.)+nfrag  : picco accettato
!-- izpk(i)= (10000*numero d'ordine del elem.)+ 0     : picco isolato
!-- izpk(i)=-(10000*numero d'ordine del elem.)+ nfrag : picco incompatible o
!--                                                     communque non accettato
!-- izpk(i)= -999999 : picco negleted
!
!-- kblock(i)=0 picco libero da muoversi (nuovo)
!-- kblock(i)=1  picco fisso (vecchio)
!--
!-- kaction		azione		   stampa
!      1	      npk,icl,scl	dst,ang,plt,con  (istat2=3)
!      2	      npk,icl,scl	      - 	 (istat2=0)
!      3	      npk,icl,scl	    plt,con	 (istat2=1)
!      4              rpk,icl,scl       dst,ang,plt,con  (istat2=3)
!      5              rpk,icl,scl             -          (istat2=0)
!
!      tipo di azione
!      npk: sub. namepk
!      rpk: sub. readpk
!      icl: sub. intcl
!      scl: sub. storcl
!
!      tipo di stampa
!      dst: tabella distanze
!      ang: tabella angoli
!      plt: plot
!      con: tabella connettivita
!
!
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common /pimpo/nAtmBlocc,focc,jumpcl,l15con,ihce,n3n
     1,vett(3,4),zatom(10),legacon(1000)
      dimension istmp(5)
      common /timetempo/ timeT(10)
      dimension x(3),y(3),d(3)
!
!       write(lo,*) ' inizia build nats,nsymtot,kaction '
!     1 ,nats,nsymtot,kaction
!
!-------------------------------------------------------------------------
!pgMAD10
      if (kmad == 2) then
          izpk(1:nats) = nzConst
          return
      endif
!
      if (kmad /= 0 .or. jscreen == 0) then
          do i=1,nats
             if (nz(i).eq.0) then
                 izpk(i) = 0
             else
                 izpki   = iabs( nz(i) ) / nzConst
                 izpk(i) = (nk - izpki + 1) * nzConst
             endif
          enddo
          return
      end if
!pgMAD10
!-------------------------------------------------------------------------
      if (lproj > 0) then
          do i=1, nats
             k = nz(i) / nzConst
             if (k > 0) then
                 k = nk - k + 1
             endif
             izpk(i) = k * nzConst
          enddo
          return
      endif
!-------------------------------------------------------------------------
!-- se iconn(1).ne.0 si assicura che la conn sia sortizzata 
!-- (iconn(n)<iconn(n+1), iconn(n)<=iconn(n+md))
      if(iconn(1).eq.-9999.or.jComplete.eq.2) iconn(1)=0
      ncop=iabs(iconn(1))
      ncops=0
      if(ncop.gt.0)then
      ncops=3*ncop+1
        do i=2,ncops,3
           i1=iconn(i)
           i2=iconn(i+1)
           if(i1.gt.i2)then
             iconn(i)=i2
             iconn(i+1)=i1
           endif
        enddo
!       write(lo,*)'1 BUILD(input) ncopie ',ncop,ncops
!       write(lo,8888)' BUILD(input) iconn ',(iconn(i),i=1,ncops)
        jump = 0
        call sortya(iconn,2,ncop,3,jump)
      endif
!-------------------------------------------------------------------------
!       write(lo,*) ' build nats,iconn(1),kact,jcomplete ',nats,iconn(1)
!     1,kaction ,jcomplete
      MaxAtomsBuild = MaxAtoms
      MaxAtomsBuild = sum(nw(1:nk)) / totop * 2.2
      MaxAtomsBuild = nats * 2.5
      MaxBond3=MaxBonds*3
      num_legami_max=12
!
*     num_legami_max=20   ! Gianluca 12/11/2011
!
      if (neutro > 1) num_legami_max=20
 !     nats600=1+600*nats
      nats20=2*nsymtot*nats
      if(nats20.lt.40*nats)nats20=40*nats
      jdimbuild=1000   !dimension dei vettori di clust
!      jdimbuild=2   ! per provare clust1001
      ifTraccia = 0
      nprojj=1
!
      call AllocaBuildStuff(1)
      kvet(:,:) = 0
!-------------------------------------------------------------------------
!--copia le coord. su xyzbu
      if (neutro == 1) then
          do i=1,nats
             xyzbu(1:5,i) = xyzNeutrons(1:5,i)
             xyzbu(4,i) = int(xyzbu(4,i))
          enddo
      else
          x0=1.
          do i=1,nats
             xyzbu(1:5,i) = xyzs(1:5,i)
             if(xyzbu(4,i).le.0)then
             if(i.gt.1)x0=xyzbu(4,i-1) 
             xyzbu(4,i)=x0
             endif
          enddo
      endif
!-- controllo per i set con intensita  troppo piatte e basse
      if(xyzbu(4,nats).le.10)then
         do i=1,nats
           xyzbu(4,i)=xyzbu(4,i)*50
         enddo
      endif
      do i=1,MaxBond3
        iconnori(i)=iconn(i)
      enddo
      if(iconn(1).eq.-9999)iconnori(1)=0
!-------------------------------------------------------------------------
!-- nAtmBlocc :n. di atomi bloccati
      nAtmBlocc=0
      do  i=1,nats
        izpk(i)=0
	  if (kblock(i).ne.0) then
	     nAtmBlocc=nAtmBlocc+1
	  endif
      enddo
!-------------------------------------------------------------------------
!-- se viene da Move chiama  build_per_Move
      if(jComplete.eq.1.and.nAtmBlocc.eq.nats)then
           call build_per_Move(kaction)
           call aggcon2(2)
           ncopie=iconn(1)
           ncop=3*ncopie+1
!                write(lo,*)' dopo build_per_Move ncopie ',ncopie
!                write(lo,8888)' conn ',(iconn(j),j=1,ncop)
           call AllocaBuildStuff(2)
	     return
      endif
!-------------------------------------------------------------------------
!-- se viene da ReGroup/Complete the connectivity:fissa gli atomi connessi
      if(jComplete.eq.1)then
           ncop=iabs(iconn(1))
           if(ncop.gt.0)then
                ncops=3*ncop+1
                do i=2,ncops,3
                    i1=iconn(i)
                    i2=iconn(i+1)
                    kblock(i1)=1
                    kblock(i2)=1
!                    write(lo,*)' kblock(i)=1 i1 i2 ',i1,i2
                enddo
!-- conta gli atomi bloccati
                nAtmBlocc=0
                do  i=1,nats
                    if (kblock(i).ne.0) nAtmBlocc=nAtmBlocc+1
                enddo
           endif
      else if(jComplete.eq.2.and.nAtmBlocc.lt.nats)then
           kblock(1:nats)=0
           nAtmBlocc=0
      endif
!-------------------------------------------------------------------------
      if (kaction.le.3) then
           angi(1)=55.
           angi(2)=80.
           angi(3)=55.
           angs(1)=180.
           angs(2)=145.
           angs(3)=180.
      else
           angi(1)=55.
           angi(2)=80.
           angi(3)=55.
           angs(1)=180.
           angs(2)=160.
           if (erre < 0.15 .and. erre > 0.0) then  ! 05mag09
              angs(2)=180.
           endif
           angs(3)=180.
      endif
!-------------------------------------------------------------------------
      kkverbo=0
      if(kkverbo.eq.1)then
           if(kaction.lt.4) kaction=1
           if(kaction.gt.4) kaction=4
      endif
      istmp(1)=3
      istmp(2)=0
      istmp(3)=1
      istmp(4)=3
      istmp(5)=0
      jstmp=istmp(kaction)
      if (nats.eq.0)then
           if (jstmp.gt.1)
     1     write(lo,*)' No peaks to be interpretated Maincl can not run'
           return  
      endif
!
!-------------------------------------------------------------------------
      if (kkverbo.eq.1) then
!      write(lo,*) ' INIZIA BUILD kaction,jComplete,nats,nAtmBlocc,iconn(1) '
!     1,kaction,jComplete,nats,nAtmBlocc,iconn(1)
           write(lo,*)'BUILD input i,xyzbu,kblock,nz,izpk '
           do i=1,nats
             write(lo,'(i5,3f8.3,2f12.2,2i7,i10)')
     1        i,(xyzbu(j,i),j=1,5),kblock(i),nz(i),izpk(i)
           enddo
           ncop=iabs(iconn(1))
           ncops=3*iabs(iconn(1))+1
           if(ncop.gt.0)write(lo,'(a,i6,/,50(3(3i6),/))')
     1      ' BUILD(input) iconn ',(iconn(i),i=1,ncops)  
      endif
!-------------------------------------------------------------------------
!       write(lo,*) ' 2 build nats,iconn(1),krecy,nAtmBlocc,jcomplete ',
!     1  nats,iconn(1),krecy,nAtmBlocc,jcomplete 
      if (nAtmBlocc.eq.0.or.krecy.gt.0.or.iconn(1).eq.-9999.
     1   .or.jcomplete.eq.0) then
	     do  i=1,MaxBonds
              iconn(i)=0
           enddo
      endif
!-------------------------------------------------------------------------
!    
      call clupar(kaction,jaction,ctrloxy)
!--interpreta
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      if(nats.le.jdimbuild) then  !interpreta considerando gli angoli
           call clust(kaction)
      else                   !interpreta senza considerare gli angoli
           call clust1001(kaction)
!            write(lo,*)'izpk dopo clust1001 ',izpk(1:nats)
      endif
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!             
      call cluend(kaction,ctrloxy)
!      write(lo,*)'izpk dopo cluend ',izpk(1:nats)
      if(jaction.ne.-1)kaction=jaction
      if(jComplete.eq.1)call aggcon2(jComplete)
!-------------------------------------------------------------------------
!-- copia su xyzs
      do j=1,nats
         do k=1,3
            xyzs(k,j)=xyzbu(k,j)
         enddo
      enddo
!-------------------------------------------------------------------------
      if (kkverbo.eq.1) then
          write(lo,*)'BUILD output nats ',nats
          write(lo,*)'BUILD output i,xyzs,kblock,nz,izpk '
          do i=1,nats
             write(lo,'(i5,3f8.3,2f12.2,2i7,i10)') 
     1        i,(xyzs(j,i),j=1,5),kblock(i),nz(i),izpk(i)
             if(i.eq.76) nz(i)=nz(i+1)
          enddo
          ncopie=iconn(1)
          ncop=3*ncopie+1
          write(lo,*)' BUILD(out) ncopie ',ncopie
          write(lo,'(a,i6,/,50(3(3i6),/))')
     1     ' BUILD(out) conn ',(iconn(i),i=1,ncop)
      endif
!
!-------------------------------------------------------------------------
!-- stampa  la connettivita con distance
      isstp=0
      if(isstp.eq.1)then
          write(lo,*)'BUILD output i,xyzs,kblock,nz,izpk '
          do i=1,nats
             write(lo,'(i5,3f8.3,2f12.2,2i7,i10)') 
     1        i,(xyzs(j,i),j=1,5),kblock(i),nz(i),izpk(i)
             if(i.eq.76) nz(i)=nz(i+1)
          enddo
       write(lo,'(a,i7)')' BUILD output connettivita con dist. ncopie= '
     1                ,iconn(1)
         ncops=3*iconn(1)+1
         do i=2,ncops,3
            i1=iconn(i)
            i2=iconn(i+1)
            cc=cpxyzs(i1,x) 
            cc=cpxyzs(i2,y) 
            do j=1,3
               d(j)=x(j)-y(j)
            enddo
            dist0=cdist(gdist,d,dist2)
            write(lo,'(2i5,f6.2)')i1,i2,dist0
         enddo
      endif
!-------------------------------------------------------------------------
*gl*  call AllocaBuildStuff(2)
!       write(lo,*) ' fine build nats,nztot(1:nats) ',nats
!       write(lo,'(10i6)')nztot(1:nats)
      return
      end
!
!code for cpxyzbu
      function cpxyzbu(n,xcoo)
      USE Atomi
      USE BuildModule
      USE BuildStuff
!
      dimension xcoo(3)
      do i=1,3
         xcoo(i)=xyzbu(i,n) 
      enddo
      cpxyzbu=1
      return
      end
!
!code for nztoz
      function nztoz(nxn,nzn)
      USE Atomi
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
!
      nztoz=1
      inz=iabs(nzn)
      if(inz.ge.nzConst)inz=iabs(nzn)/nzConst
      if(inz.eq.0)inz=1  !!!
      nztoz=inz
      return
      end
!
!code for build_per_Move
      subroutine build_per_Move(kaction)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE BuildStuff
!
      USE LsqModule
      USE BuildModule
!
      dimension kprfix(1000),d(3),x(3),y(3),ifermo(1000)
!
!      write(lo,*)' build_per_Move iconn(1)',iconn(1)
!      write(lo,*)' nptr kptr ',nptr,(kptr(ii),ii=1,nptr)
      i=1
      do  ij=1,3
      do  ji=1,3
         gdist(i)=xgg(ij,ji)
         gdist(i+9)=xgr(ij,ji)
         i=i+1
      enddo
      enddo

      ncopie=iabs(iconn(1))
      md5c=3
      ncop=md5c*ncopie+1
!
  400 format(i5,5f10.3,3i7)
!      write(lo,8888)' build_per_Move(input) iconn ',(iconn(i),i=1,ncop)
8888  format(a,i6,/,50(3(3i6),/))
!       write(lo,*) 'build_per_Move nats  ncop'
!     1  ,nats,ncop
!      write(lo,*)' nptr kptr ',nptr,(kptr(ii),ii=1,nptr)
      j=2
      ncopien=0
      do i=2,ncop,md5c
         if(iconn(i+2).ne.0)then
            ncopien=ncopien+1
            jconn(j)=iconn(i)
            jconn(j+1)=iconn(i+1)
            jconn(j+2)=iconn(i+2)
            j=j+md5c
         endif
      enddo
      jconn(1)=ncopien
      ncopn=3*ncopien+1
!      write(lo,8888)' build_per_Move(input) jconn ',(jconn(i),i=1,ncopn)
      ncopien0=ncopien
      ncopn0=ncopn
      ncopn=ncopn+1
      do  inx=2,nptr
         npk=kptr(inx)
         mg1=nztoz(npk,nz(npk))
         if (mg1 <= 0 .or. mg1 > 18) cycle       ! gianluca 18/04/2011
         cc=cpxyzs(npk,x)
!      write(lo,*)' x ', x
         do  npk2=1,nats
            mg2=nztoz(npk2,nz(npk2))
            if (mg2 <= 0 .or. mg2 > 18) cycle    ! gianluca 18/04/2011
            cc=cpxyzs(npk2,y)
!           write(lo,*)' y ', y
            do n=1,3
               d(n)=x(n)-y(n)
            enddo
            dist0=cdist(gdist,d,dist2)
            dmxh=BondTable(2,mg1,mg2)
            dmnh=BondTable(1,mg1,mg2)
!      write(lo,*)'  npk,npk2,dmxh,dmnh,dist0 ', npk,npk2,dmxh,dmnh,dist0
           if(dist0.ge.dmnh.and.dist0.le.dmxh)then    
              i1=min0(npk,npk2)
              i2=npk+npk2-i1
              inew=0
              do kk=2,ncopn0,md5c
                 j1=jconn(kk)
                 j2=jconn(kk+1)
!                if(j1.eq.i1.and.j2.eq.i2.and.
!     1           jconn(kk+2).gt.0)inew=1
                 if(j1.eq.i1.and.j2.eq.i2)then
!                    write(lo,'(a,4i4,i6)')'i1,i2,j1,j2,jconn(kk+2)'
!     1              ,i1,i2,j1,j2,jconn(kk+2)
                    inew=1
!                   if(jconn(kk+2).le.0)then
!                   jconn(kk+2)=iabs(jconn(kk+2))
!                   write(lo,'(a,4i4)')'jconn(kk:kk+2)'
!     1             ,jconn(kk:kk+2)
!                   endif       
                    exit     
                 endif  
              enddo
              if(inew.eq.0)then
                 jconn(ncopn  )=i1
                 jconn(ncopn+1)=i2
                 jconn(ncopn+2)=1
                 ncopn=ncopn+3
                 ncopien=ncopien+1
!                 write(lo,*)' ncopien, jconn '
!     1            ,ncopien,(jconn(ii),ii=ncopn,ncopn+2)
              endif
           endif
         enddo
      enddo
!      write(lo,*)' ncopien  ',ncopien
!      write(lo,8888)'build_per_Move(input) jconn ',(jconn(i),i=1,ncopn)
!--salva su iconn
!      if(ncopien.gt.ncopien0)ncopien=ncopien-1
      iconn(1)=ncopien
      do i=2,ncopn
        iconn(i)=jconn(i)
      enddo
!      write(lo,8888)' build_per_Move iconn ',(iconn(i),i=1,ncop)
      return
      end
!
!code for clupar
      subroutine clupar(kaction,jaction,ctrloxy)
      USE General
      USE Symmetry
      USE Atomi
      USE BuildStuff
!
      USE BuildModule
      USE BuildStuff
!
!-- interface subroutine for peaks management
!
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
!
      common /pimpo/nAtmBlocc,focc,jumpcl,l15con,ihce,n3n
     1,vett(3,4),zatom(10),legacon(1000)
      dimension istmp(5)
!
!-- sir sir sir
      istmp(1)=3
      istmp(2)=0
      istmp(3)=1
      istmp(4)=3
      istmp(5)=0
      jstmp=istmp(kaction)
      istat2=jstmp
      jumpcl=0
      dmax=0.0
      ncwu=lo
      ift1=1000
      ift2=10
      focc=1.0/(pts*nsym*(icent+1))
!      write(ncwu,*)'clupar pts,nsym,focc,icent,ncentr'
!     1 ,pts,nsym,focc,icent,ncentr 
!      write(ncwu,*)'clupar g',g 
      vett=0
      do i=1,ncentr
         do j=1,3
           j1=(i-1)*3+j
           vett(j,i)=centrt(latt,j1)
         enddo
      enddo
!      write(ncwu,*)'clupar vett',vett 
      zneutro=1
!--15.7.97
      if(neutro.eq.0.and.kaction.gt.3)zneutro=0
!      write(ncwu,*)'neutro, kaction,zneutro' 
!     1,neutro, kaction,zneutro 
      ihce=0
      ctrloxy=0
      do  i=1,nk
      zatom(i)=no(i)
      if(no(i).eq.8)ctrloxy=1
      enddo
      if (neutro.ne.0) then
          do i=1,nk
             if (neutro.eq.1) then
                 zatom(i)=abs(cl(i))
             else
                 zatom(i)=zeff(i)
             endif
          enddo   
      zneutro=0
      endif
!--
      if(zatom(1).lt.1.5
     1 .and.neutro.eq.0.and.kaction.le.3)ihce=0
!      write(ncwu,*)'2 neutro, kaction,zneutro,ihce,zatom(1)'
!     1,neutro, kaction,zneutro,ihce,zatom(1)
          if (kaction.gt.3.and.zatom(1).le.1.5) then
              ihh = 0
              do i =1,nats
                 if (iabs(nz(i)/nzConst).eq.1) then
                     ihh = 1
                 endif
              enddo
	      ihce = ihh
          endif
      nn3=0
      izmin=999999
      do   i= 1,nk
      if(zatom(i).gt.8)nn3=nn3+1
      izz=int(zatom(i))
        if(zatom(i).gt.zneutro.and.izz.lt.izmin)then
           izmin=izz
           niz=i
           jtype=nalf(i)
        endif
!      write(ncwu,42) i,nalf(i),nw(i),zatom(i),radii(i,1)
      enddo
   42 format(i5,1h),1x,a2,3f10.3)
!      write(ncwu,*)'clupar,l2,l3,nflb',l2,l3,nflb
      if(kaction.gt.3)then
         iz=ihce
         do i=1,nats
           if(nz(i).ne.0.and.iz.eq.0) then
             iz=iabs(nz(i))/nzConst
           endif
         enddo
      else
         iz=1+ihce
      endif
      nghost=0
      do i=1,nats
         if(kaction.gt.3)then
           if(nz(i).eq.0)then
             izpk(i)=-999999
              nghost=nghost+1
           else if(nz(i).ne.0)then
              iz=iabs(nz(i))/nzConst
              izp = nk - iz + 1
              izpk(i)=izp
           endif
         else
           izp = nk - iz + 1
           izpk(i)=izp
         endif
      if(xyzbu(5,i).le.0)xyzbu(5,i)=1
      if(xyzbu(4,i).le.0)xyzbu(4,i)=iz*100.
      enddo   
!------------------------------------------------------------------
!      write(ncwu,*)'3 neutro, kaction,zneutro,ihce,iz'
!     1,neutro, kaction,zneutro,ihce,iz
!-- crea AngTable
      do i=1,nk
         angn=dtor*angi(1)
         angx=dtor*angs(1)
         iz=no(i)
         if(iz.lt.9)then
             angn=dtor*angi(2)
             angx=dtor*angs(2)
         endif
      enddo
!------------------------------------------------------------------
      jaction=-1
      if (nghost.eq.nats.and.kaction.gt.3)then
          do i=1,nats
             izpk(i)=nzConst
          enddo
          jaction=kaction
          kaction=2
      endif
1     format(i4,1h),1x,a2,20f10.4)
11     format(a2,2x,7f12.5)
!--is it possible to run clust?
!      write(ncwu,*)'clupar nats,jumpcl',nnats,jumpcl
      if (nats.le.2) then
	  jumpcl=1
	  if (kaction.le.3) then
	      do i=1,nats
              izpk(i)=niz*nzConst
            enddo  
  	    else
	      do i=1,nats
               izpki=nz(i)
               izpk(i) = ( nk - iabs(izpki/nzConst) + 1 ) * nzConst 
            enddo  
	  endif
      endif
!      write(ncwu,*)'clupar 2 nats,jumpcl',nnats,jumpcl
!      write(ncwu,*)' ihce,n3n,izpk clupar ',ihce,n3n,(izpk(i),i=1,nats)
!        write(ncwu,*) 'clupar nflb,nflbld,nnfl ',nflb,nflbld,nnfl
      return
      end
!
!code for cluend
      subroutine cluend(kaction,ctrloxy)
      USE Atomi
      USE Molcom
      USE BuildModule
      USE BuildStuff
!
!
!-- final interface subroutine for peaks management
!
      common /pimpo/nAtmBlocc,focc,jumpcl,l15con,ihce,n3n
     1,vett(3,4),zatom(10),legacon(1000)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common /minma/ amin(3), amax(3)
      dimension xbar(3)
!
!      write(ncwu,*) 'cluend kblock  ',(kblock(i),i=1,nats)
!      write(ncwu,*)' izpk nz cluend ',(izpk(i),nz(i),i=1,nats)
!      l15a=l15fin
      nats25=0
      nats26=0
      md5c=3
!   
!-- control nleg for the O atoms.
      if(kaction.gt.3.and.ctrloxy.eq.1)then
         call oxi_two_leg
!         write(ncwu,*)'dopo oxi_two_leg'
1        format(i4,1h),1x,a2,27f10.4)
!         write(ncwu,*)' izpk cluend ',(izpk(i),i=1,nats)
!         write(ncwu,*)' nz cluend ',(nz(i),i=1,nats)
         call contoxy
!         write(ncwu,*)'dopo contoxy'
!         write(ncwu,*)' nz cluend ',(nz(i),i=1,nats)
      endif
1111  format(6(3i4))
!      write(ncwu,*)'cluend conn ncopie old',iconn(1) 
!      write(ncwu,1111)(iconn(j),j=2,ibx)
      ncop=iconn(1)
      jump = 0
      call sortya(iconn,2,ncop,3,jump)
      if(jumpcl.eq.1)return
!   50 format(3i10,2f10.3)
!--
!      do i =1,nats
!      write(ncwu,*)'2  cluendnew x ',(xyzbu(ii,i),ii=1,4)
!      enddo
!      write(ncwu,*)'cluend iconn finale' 
!      write(ncwu,*)' ncopie',iconn(1) 
!      write(ncwu,"(3i5)")(iconn(j),j=2,ibx-1)
!      write(ncwu,*)'  cluend nz fin',(nz(i),i=1,n15)
!      write(ncwu,*) 'FINE CLUEND'
      return
      end
!
!code for oxi_two_leg
      subroutine oxi_two_leg   
      USE General
      USE Atomi
!
      USE BuildModule
      USE BuildStuff
!-- controlla i leg. degli O. Se ne ha piu' di 2 cambia la specie in izpk
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common /pimpo/nAtmBlocc,focc,jumpcl,l15con,ihce,n3n
     1,vett(3,4),zatom(10),legacon(1000)
!
      ncop=jconn(1)
      if(ncop.le.0) return
!
      nzbor=0
      nzcar=0
      nznit=0
      nzoss=0
      nzflu=0   !aggiunto 06lug11
!      write(ncwu,*)' otwoleg 1 i, nz ,izpk'
!      write(ncwu,*)(ii,nz(ii),izpk(ii),ii=1,nats)
      do i=1,nk
         if(no(i).eq.5)nzbor=i
         if(no(i).eq.6)nzcar=i
         if(no(i).eq.7)nznit=i
         if(no(i).eq.8)nzoss=i
         if(no(i).eq.9)nzflu=i
      enddo
!      write(ncwu,*)' otwoleg  no ',no
!      write(ncwu,*)' otwoleg  nzbor,nzcar,nznit,nzoss ',
!     1  nzbor,nzcar,nznit,nzoss 
      if(nzoss.eq.0) return
      if(nzcar.eq.0)nzcar=nznit
      if(nzcar.eq.0)nzcar=nzbor
      if(nzcar.eq.0)nzcar=nzflu
!      write(ncwu,*)' otwoleg  nzbor,nzcar,nznit,nzoss,ncop ',
!     1  nzbor,nzcar,nznit,nzoss,ncop 
      do i=1,nats
         if(iabs(nz(i)/nzConst).ne.nzoss)cycle
         nleg= LongConnect(i,1)
         if (nleg.gt.2.and.izpk(i).gt.0) then
            if (nzcar.eq.0) then
               if (istat2.gt.2) write(lo,2)i
               cycle
            endif 
            iz=nk-nzcar+1
!              write(lo,*)'izpk(i).gt.0'
!              if(izpk(i).gt.100000.or.ifra.gt.10000)then
!              izz=izpk(i)/100000
!              write(lo,*)'i,izpk(i),izz, izpk(i).gt.100000',i,izz
!              write(lo,*)'i,nz(i),ifra',i,nz(i),ifra
!              endif
            ifra=izpk(i)-izpk(i)/10000*10000
            if(ifra.ge.10000)ifra=9999
            izpk(i)=iz*10000+ifra  !cambia la specie in izpk
!          write(lo,*)'i,izpk(i),nz(i)',i,izpk(i),nz(i)
         endif
      enddo
2     format(' Warning!! Atom #',i3,
     1' is bonded to more than two atoms: cannot be an oxigen. ')
!      write(ncwu,*)' otwoleg 2 nz ,izpk',(nz(ii),izpk(ii),ii=1,nats)
      return
      end
!
!code for contoxy
      subroutine contoxy
      USE General
      USE Atomi
      USE BuildStuff
!
      USE BuildModule
!
!-- control nleg for the O atoms.
!
      common /pimpo/nAtmBlocc,focc,jumpcl,l15con,ihce,n3n
     1,vett(3,4),zatom(10),legacon(1000)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension d(3)
!
      nzbor=0
      nzcar=0
      nznit=0
      nzoss=0
      do i=1,nk
        if(no(i).eq.5)nzbor=i
        if(no(i).eq.6)nzcar=i
        if(no(i).eq.7)nznit=i
        if(no(i).eq.8)then
           nzoss=i
           asscont= nw(i)*focc
        endif
      enddo
      cont15=0.
      do i=1,nats
         if(izpk(i).gt.0.and.iabs(nz(i)).eq.nzoss)
     1   cont15=cont15+xyzbu(5,i)
!        write(ncwu,*)'contoxy i,cont15',i,cont15
      enddo
11    format(i4,1h),1x,a2,27f10.4)
      if(cont15.le.0.or.asscont.le.cont15)return
      jj=2
      ncop=jconn(1)
      nfin=ncop*3+2
1111  format(6(3i4))
1     format(10i5)
      do i=1,nats
         if(izpk(i).le.0.or.iabs(nz(i)).ne.nzcar)cycle
         newcont=cont15+xyzbu(5,i)
         if(newcont.le.asscont)then
           leg= LongConnect(i,1)
           if(leg.gt.1)cycle
!-- atomo isolato 
              i1=i
           if(leg.eq.0.and.nz(i).gt.0)then
!              i1=i
!      write(ncwu,*)'contoxy conect i1,izpk(i1) ',i1,izpk(i1)
              do i2=1,nats
                if(i2.ne.i1)then
                  d(1)=xyzbu(1,i1)-xyzbu(1,i2)
                  d(2)=xyzbu(2,i1)-xyzbu(2,i2)
                  d(3)=xyzbu(3,i1)-xyzbu(3,i2)
                  distt=gdist(1)*d(1)*d(1)
     1                 +gdist(5)*d(2)*d(2)
     2                 +gdist(9)*d(3)*d(3)
     3                 +gdist(2)*d(1)*d(2)*2.0
     4                 +gdist(3)*d(1)*d(3)*2.0
     5                 +gdist(6)*d(2)*d(3)*2.0
                  distt=sqrt(distt)
!      write(ncwu,*)'contoxy conect i1,i2,distt ',i1,i2,distt
                  if(distt.le.1.3.and.distt.gt.1.0)then
                     ifra=izpk(i2)-(izpk(i2)/10000)*10000
                     izpk(i1)=iabs(izpk(i1))+ifra
                     LongConnect(i1,1)=1 
                     LongConnect(i1,3)=i2 
                     LongConnect(i1,4)=nint(distt*1000) 
                     nleg2=LongConnect(i2,1)
                     LongConnect(i2,1)=LongConnect(i2,1)+1 
                     LongConnect(i2,2*nleg2+3)=i2 
                     LongConnect(i2,2*nleg2+4)=nint(distt*1000) 
                     nfin=3*jconn(1)+2
                     jconn(1)=jconn(1)+1                    
                     if(i1.lt.i2)then
                        jconn(nfin)=i1
                        jconn(nfin+1)=i2
                        jconn(nfin+2)=0 
                     else
                        jconn(nfin)=i2
                        jconn(nfin+1)=i1
                        jconn(nfin+2)=0 
                     endif
                    !go to 300 
                    cont15=newcont   !300
                    if(izpk(i).gt.0)then
                      ifra=izpk(i)-(izpk(i)/10000)*10000
                      if(ifra.ge.10000)ifra=9999
                      izpk(i)=nzoss*10000+ifra   !lo rende O in izpk
                      nz(i)=nzoss*10000+ifra     !e in nz
                    endif
                    exit
                  endif
                endif
              enddo
              cycle
!-- atomo con un solo legame
           else if(leg.eq.1)then
             i2=LongConnect(i1,3) 
             d(1)=xyzbu(1,i1)-xyzbu(1,i2)
             d(2)=xyzbu(2,i1)-xyzbu(2,i2)
             d(3)=xyzbu(3,i1)-xyzbu(3,i2)
             distt=gdist(1)*d(1)*d(1)
     1            +gdist(5)*d(2)*d(2)
     2            +gdist(9)*d(3)*d(3)
     3            +gdist(2)*d(1)*d(2)*2.0
     4            +gdist(3)*d(1)*d(3)*2.0
     5            +gdist(6)*d(2)*d(3)*2.0
             distt=sqrt(distt)
!            write(ncwu,*)'contoxy i,distt ' ,i,distt
             if(distt.gt.1.3)cycle
             cont15=newcont  !300
             if(izpk(i).gt.0)then
                ifra=izpk(i)-(izpk(i)/10000)*10000
                izpk(i)=nzoss*10000+ifra
                if(ifra.ge.10000)ifra=9999
                nz(i)=nzoss*10000+ifra
             endif
           endif
         endif
      enddo
      return
      end

!
!code for aggcon2
      subroutine aggcon2(jComplete)
      USE Atomi
      USE BuildModule
      USE BuildStuff
!
      common /pimpo/nAtmBlocc,focc,jumpcl,l15con,ihce,n3n
     1,vett(3,4),zatom(10),legacon(1000)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
!--
!-- aggiorna la nuova connettivita'  rispetto alla gia'  esistente
!-- if(jComplete.eq.1) :
!-- ripristina le copie con iconn(n+2)=1,2,3,-1
!-- if(jComplete.eq.2) :
!-- ripristina le copie con iconn(n+2)=2,3,-1
!-- iconn(n+2)=1 copia generata da programma
!-- iconn(n+2)=2 copia definita dall'utente
!-- iconn(n+2)=3 copia (legame H) definita dall'utente
!-- iconn(n+2)=-1 copia cancellata dall'utente
      md=3
      ncopieori=iabs(iconnori(1))
      if(ncopieori.eq.0)return
      llo=ncopieori*md+1
      ncopienew=iconn(1)
      lln=ncopienew*md+1
!      write(ncwu,*)'ncopien,ncopieo',ncopien,ncopieo
      do  i=2,llo,md
      i1=iconnori(i)
      i2=iconnori(i+1)
      i3=iconnori(i+2)
      if(iconnori(i+2).eq.-1.or.iconnori(i+2).ge.1)then
      if(iconnori(i+2).eq.1.and.jComplete.eq.2)cycle
!      write(ncwu,*)'i,iconn '
!     1 ,iconn(i),iconn(i+1),iconn(i+2)
      ifind=0
          do  j=2,lln,md
             if(i1.eq.iconn(j).and.
     1          i2.eq.iconn(j+1))then
!          write(ncwu,*)' trovato!'
             iconn(j+2)=i3
             ifind=1
             endif
          enddo
        if(ifind.eq.0)then
        iconn(lln+1)=i1
        iconn(lln+2)=i2
        iconn(lln+3)=i3
        iconn(1)=iconn(1)+1
        lln=lln+md
        endif
      endif
      enddo
      return
      end
!--------------------------------------------------------------
!
!code for clust
      subroutine clust(kaction)
      USE General
      USE Symmetry
      USE Atomi
      USE BuildStuff
      USE BuildModule
      USE BuildModuleSmall
!
!--cluster searching routine
!
      character ib*1,str2*2
      character*6 wgrup
      character*15 line,any,ibb,dd(9),inpco,iwr
!  
      common /pimpo/nAtmBlocc,focc,jumpcl,l15con,ihce,n3n
     1,vett(3,4),zatom(10),legacon(1000)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension yy(3),sss(3),d(3),x(3),z(3),ivvet(2),d3(3)
      dimension zz(3,200),dimi(18),dax(18),includ(18)
*gl*  real, allocatable :: stored(:)
!
!
      data ibb/'               '/
      data inpco/'* '/
      data any/'    any        '/
      data wgrup/' group'/
      data  ib/' '/
!
      kkverbo=0
      e10=1.0e-10
!--set the input parameters
!      write(ncwu,*)'CLUST kaction,nAtmBlocc ',kaction,nAtmBlocc
!      write(ncwu,*) 'CLUST izpk  ',(izpk(i),i=1,nats)
!      write(ncwu,*) 'CLUST kblock  ',(kblock(i),i=1,nats)
      ninc=0
      incomp(:,:)=0
      natspecc=0
      idfrag(:)=0
      jdfrag(:)=0
      numfr(:)=0
      if (kaction.le.3) then
	      call namepk
	else
	      call readpk
	endif
!
      call intugu(kaction)
      jfragVal=1
!-- print limits for interatomic bonds
      if (istat2.gt.1) then
          if (neutro.eq.0) then
              write(ncwu,155)
          else
              write(ncwu,156)
          endif
!--29.7.97
          nnn=nk-ihce
          if (kaction.gt.3) nnn = ngrup
          do i=1,nnn
            jjj=1+(i-1)*md
            if (groupatomi(jjj).le.0.00) cycle
            ija=nint(groupatomi(jjj+7))
            ij2=nint(groupatomi(jjj+2))
            ijj=nint(groupatomi(jjj+6))
            write(str2,'(a2)') nalf(ijj)
            call ucase(str2(1:1))
            if (istat2.gt.1)then 
              if (neutro == 0) then             
               write(ncwu,180) str2,groupatomi(jjj+1),groupatomi(jjj+4),
     1           groupatomi(jjj+5), angi(ija),angs(ija) ,ij2
              else             
               write(ncwu,182) str2,groupatomi(jjj+1),groupatomi(jjj+4),
     1          groupatomi(jjj+5), angi(ija),angs(ija),groupatomi(jjj+2)
              endif             
            endif
          enddo
  155 format(/,1x,'Assumed atomic parameters and limits for',
     *           ' interatomic bonds and angles',/,
     *       16x,'   (interspecies and intraspecies)'   ,//,
     1       23x,'distances',12x,'angles',7x,
     1        '  atomic  ',/,
     1           1x,'type',3x,'radius',4x,'minimum   maximum',4x,
     1      'minimum  maximum',4x,'number',/)
  156 format(/,1x,'Assumed atomic parameters and limits for',
     *           ' interatomic bonds and angles',/,
     *       16x,'   (interspecies and intraspecies)'   ,//,
     1       23x,'distances',12x,'angles',7x,
     1        ' effective ',/,
     1           1x,'type',3x,'radius',4x,'minimum   maximum',4x,
     1      'minimum  maximum',4x,'lenght',/)
  180 format(2x,a2,f9.3,1x,2f10.2,1x,2f10.2,i10,8x,a2)
  182 format(2x,a2,f9.3,1x,2f10.2,1x,2f10.2,f10.3,8x,a2)
      endif
!------------------------------------------------------------------------
!------------------------------------------------------------------------
1     continue
!------------------------------------------------------------------------
!------------------------------------------------------------------------
!--set the addresses
!       write(ncwu,*)'ngrup',ngrup
!       write(ncwu)'icogr ',(icogr(i),i=1,ngrup)
!
      mddis=7
      noautoc=0
      nautoleg=0
!--calculate the distances
!      write(ncwu,*)'2 nsym,ncentr,icent ',nsym,ncentr,icent
      dddmin=dmin
      ddmax=dmax
      if (dmax.lt.5.76) dmax=5.76
      dddmax=dmax
      dmxx=sqrt(dmax)
!      write(ncwu,*)' dmax,dmin',dmax,dmin
      ndummy=0
!
!      write(lo,'(a)')'ndummy,npk,npk2,idst0,nop2,dist0,yy'
!      write(lo,'(a,3i9)')'nats,nsymtot,nats20',nats,nsymtot,nats20
      nop2=11
      do npk2=1,nats            !150
         ndummy_npk2=ndummy
         nnsym=nsymTot
         if(kblock(npk2).eq.1)nnsym=1
         nequ = 0
         zz(:,:) = 0.0   
         mg2=icogr(npk2)
!      write(ncwu,'(/,a,3i6)')' nnsym,npk2,ndummy ',nnsym,npk2,ndummy
!--25nov04
         if(mg2.eq.0)mg2=1 
         cc=cpxyzbu(npk2,x) 
         do k=1,nnsym         !1050
            ieqX=0
!      write(ncwu,*)' nnsym,npk2,k ',nnsym,npk2,k
            call  xequiTot(k, x, yy,ieqX)
!      write(ncwu,'(a,3i5,3f8.3,i5)')
!     1 ' nnsym,npk2,k,yy,nequ ',nnsym,npk2,k,yy,nequ
            if(nequ.eq.0)then
                  nequ=1
                  do ikk=1,3
                    zz(ikk,1)=yy(ikk)
                  enddo
            else
                 do  kequi=1,nequ     !1051
                    do ikk=1,3
                       d3(ikk)=yy(ikk)-zz(ikk,kequi)  
                    enddo
                    call reddst(d3,sss)
                    dist0=cdist(gdist,d3,dist2)
                    if(dist0.lt.0.2)exit
                 enddo                !1051
                 if(dist0.lt.0.2)cycle
                 nequ=nequ+1 
                 zz(1:3,nequ)=yy(1:3)
            endif
!       write(ncwu,*)'kequi,(zz(ikk,kequi),ikk=1,3)'
!       do kequi=1,nequ
!         write(ncwu,*)kequi,(zz(ikk,kequi),ikk=1,3)
!       enddo
!            write(ncwu,*)'npk2,kt,coef,k,yy',
!     1    npk2,kt,coef,k,yy
!
            do npk=1,nats    !160
               mg1=icogr(npk)
!--25nov04
	         if(mg1.eq.0)mg1=1
               cc=cpxyzbu(npk,z) 
               sss(1:3)=0
               d(1:3)=z(1:3)-yy(1:3)
               if(kblock(npk2).ne.1)call reddst(d,sss)
               istras=cistras(sss)
!         write(ncwu,*)'NPK,z',npk,z
               nop2 = k*1000 + istras 
               dist0=cdist(gdist,d,dist2)
!      write(ncwu,'(a,2i4,i12,i8,3f6.2,2i4)')
!     1'npk,npk2,nop2,istras,sss,k,kt'
!     1,npk,npk2,nop2,istras,sss,k,kt
!      write(ncwu,*)' npk,npk2,nop2,dist0,dimxx,nAtmBlocc',
!     1 npk,npk2,nop2,dist0,dmxx,nAtmBlocc
!      write(ncwu,*)' npk,npk2,mg1,mg2 ',npk,npk2,mg1,mg2
                dmxh =dmnmx(mg1,mg2,2)
                dmnh =dmnmx(mg1,mg2,1)
                icon=0
                if(nAtmBlocc.gt.0) then
                   icon=konect0(npk,npk2,kcon)
                endif
!
!-- set idst0=0/1/2/-1 lontano/tra dmin e dmax/legato/incomp.
!
                if(icon.eq.2)then
!-- istoricamente legato (idst0=2)
                   idst0=2
                else if(dist0.gt.dmxx)then
!-- lontano (idst0=0)
                   idst0=0
                   cycle   !go to 160
                else if(dist0.le.dmxx)then
                   dimin=sqrt(dmin)
                   dimin=dimin-dimin/10
                   dimnh=dmnh-dmnh/10
                   dimnh2=dimnh+icon*0.5
                   if(dist0.le.dimnh2.or.dist0.le.dimin)then
!--incompatibile (idst0=-1)
                      idst0=-1
                      if(dist0.gt.0.5.and.npk.eq.npk2)then
!-- atomo no autoconsistente (troppo vicino a se stesso) 
!-- controllo "noautoc", eliminato per invecchiarlo a build98
                         noautoc=noautoc+1
!        write(lo,*)'npk,noautoc,dist0',npk,noautoc,dist0
                      endif
                      if(dist0.gt.0.2)then
                         idst0=-1
!                         if(npk.le.npk2)then
!                            ninc=ninc+1
!                            incomp(1,ninc)=npk
!                            incomp(2,ninc)=npk2
!                  write(ncwu,*)'incompatibili',npk,npk2,dist0
!                         endif
!23mag11                  if(ifi.eq.1.and.k.eq.1.and.kt.eq.1)go to 160
!        write(lo,*)'npk,npk2,dist0',npk,npk2,dist0
!-- atomo in posizione speciale (su un op. di sim.)
                      else if(dist0.lt.0.2)then
                          if(npk.eq.npk2)then
                             if(k.eq.1)cycle
                             natspecc=natspecc+1
                             cycle
                           endif
                      endif
                   else         !--tra dmin e dmax (idst0=1)
                      idst0=1
!--legato (idst0=2)
                      dif1=dist0-(dmnh-icon*0.5)
                      dif2=dist0-(dmxh+icon*0.5)
!--12nov02
                      fmeno=0.001
                      if(kaction.gt.3)fmeno=fmeno*20 
                      if(dif1.gt.-fmeno.and.dif2.lt.fmeno)idst0=2
!      write(ncwu,*)' npk,npk2,nop2,dist0,dif1,dif2,fmeno,idst0,kaction',
!     1 npk,npk2,nop2,dist0,dif1,dif2,fmeno,idst0,kaction
!--fine 12nov02
                      if(npk2.eq.npk)then
!-- atomo autoconsistente (a distanza di legame da se stesso) 
                         natspecc=natspecc+1
                       endif
                       do  nnn=1,3
                          if(abs(d(nnn)).lt.e10)d(nnn)=sign(e10,d(nnn))
                       enddo
                       if(idst0.ne.2.and.icon.eq.0)cycle
                   endif
                endif
170                continue
!      write(ncwu,'(a,4i5,f8.2,i5)')'ndummy npk,npk2,idst0,dist0,nop2 ',
!     1 ndummy,npk,npk2,idst0,dist0,nop2
!
                   if(ndummy-ndummy_npk2.gt.num_legami_max)exit !ammette massimo num_legami_max
                   ndummy=ndummy+1
                   nord_coppia(ndummy)=ndummy 
                   nord_picco1_coppia(ndummy)= npk   !storeb(m  )=npk
                   nord_picco2_coppia(ndummy)= npk2  !storeb(m+1)=npk2
                   kodice_dist(ndummy)= idst0        !storeb(m+2)=idst0
                   dist_coppia(ndummy)=dist0         !storeb (m+3)=dist0
                   distxyz_coppia(ndummy,1:3)=d(1:3) !storeb (m+4:m+6)=d(1:3)
                   nopsym_picco2_coppia(ndummy)=nop2 !storeb(m+7)=nop2
!             write(lo,'(5i6,4f8.3)')ndummy,npk,npk2,idst0,nop2,dist0,yy
            enddo  
         enddo   
      enddo   
!      write(ncwu,*)'n. copie incompatibili',ninc
!copia su stored per il sort
!      ndimstored=nats*160   !si considerano massimo 20 legami/atomi,(disorder,etc)
      nn=ndummy
      if(nn.lt.nats)nn=nats
      ndimstored=nn*8+1   !17ott11
!      write(lo,'(a,4I10)')'nats,ndummy,ndimstored,DimStored ',
!     1  nats,ndummy,ndimstored,DimStored
      if (ndimstored > DimStored) then
          call DeallocaBuildModuleSmall
          allocate (stored(1:ndimstored), stat = ierr)
          DimStored = ndimstored
      endif
      stored(:)=0.  !vettore transitorio per il sort)
      atomo_in_coppie(:,:)=0     ! contiene(nord del atomo,no.coppie dove partecipa seguito dalle coppie)
      ldummy=1
      mddum=8 
      m=ldummy
      ntottt=ndummy
      do icopy=1,ndummy
         stored(m  )=nord_picco1_coppia(icopy)
         stored(m+1)=nord_picco2_coppia(icopy)
         stored(m+2)=kodice_dist(icopy)
         stored(m+3)=dist_coppia(icopy)
         stored(m+4)=distxyz_coppia(icopy,1 )
         stored(m+5)=distxyz_coppia(icopy,2 )
         stored(m+6)=distxyz_coppia(icopy,3 )
         stored(m+7)=nopsym_picco2_coppia(icopy)
         m=m+mddum
       enddo
      if (ntottt.eq.0)then
!        write(ncwu,*)'ntottt=',ntottt
        do i=1,nats
          izpk(i)=izpk(i)*nzConst
        enddo
!        write(ncwu,*)'izpk',(izpk(i),i=1,nats)
        return
      endif
      jump = 1
      call sortz_dyn(stored,ndimstored,1,ndummy,mddum,jump)
!
      ncoppia=1
      mx3=ldummy+(ndummy)*mddum
      mx2=ldummy
      mx1=ldummy
      npkk=nint(stored(mx1))
      nn6=0
      do while  (mx2.le.mx3)
!152   continue
         nn6=nn6+1
         if(nint(stored(mx2)).ne.npkk)then
         nn6=nn6-1
               if(nn6.gt.0)then
               if(nn6.gt.20)nn6=20
               atomo_in_coppie(npkk,1)=nn6    !storeb(mdis+1)=nn6
               jump = 2
               call sortz_dyn(stored,ndimstored,mx1,nn6,mddum,jump)
               do ik=1,nn6
                   atomo_in_coppie(npkk,ik+1)      =ncoppia
                   nord_picco1_coppia(ncoppia)  =stored(mx1  )
                   nord_picco2_coppia(ncoppia)  =stored(mx1+1)
                   kodice_dist(ncoppia)         =stored(mx1+2)
                   if(kodice_dist(ncoppia).eq.-1)then
                            ninc=ninc+1
                            atomo_in_coppie(npkk,ik+1)      =-ncoppia
                            incomp(1,ninc)=nord_picco1_coppia(ncoppia)
                            incomp(2,ninc)=nord_picco2_coppia(ncoppia)
                            incomp(3,ninc)=ncoppia
                   endif          
                   dist_coppia(ncoppia)         =stored(mx1+3)
                   distxyz_coppia(ncoppia,1)    =stored(mx1+4)
                   distxyz_coppia(ncoppia,2)    =stored(mx1+5)
                   distxyz_coppia(ncoppia,3)    =stored(mx1+6)
                   nopsym_picco2_coppia(ncoppia)=stored(mx1+7)
                   nord_coppia(ncoppia)=ncoppia 
                   ncoppia=ncoppia+1
                   stored(mx1:mx1+7)=0.
                   mx1=mx1+mddum
               enddo
               mx1=mx2
               npkk=nint(stored(mx1))
               mx2=mx2-mddum
               nn6=0
               endif
         endif
         mx2=mx2+mddum
      enddo
      ncoppie_iniz=ncoppia-1
      iprinta=0
      if(iprinta.eq.1)then
         write(lo,'(a,a,a)')'nord_coppia ',
     1   'nord_picco1_coppia,nord_picco2_coppia ',
     1   ' kodice_dist,dist_coppia,nopsym_picco2_coppia'
         do ik=1,ncoppie_iniz
           write(lo,'(i5,2i4,i3,f8.5,i6)')nord_coppia(ik),
     1     nord_picco1_coppia(ik),nord_picco2_coppia(ik),
     1     kodice_dist(ik),dist_coppia(ik),nopsym_picco2_coppia(ik)
         enddo
         write(lo,'(a)')'nord atomo_in_coppie '
         do ik=1,nats
           write(lo,'(i5,i6,12i5)')ik,(atomo_in_coppie(ik,1:12))
         enddo
      endif
!
*gl*  deallocate (stored, stat = ierr)
!
      dmi=sqrt(dmin)
      dma=sqrt(dmax)
      dmax=ddmax
      dmin=dddmin
!--create the addresses-connectivity table
!--stampa le tabelle
      if (istat2.gt.2) then
         includ(1:18)=0
         do i=1,nats
           ii=icogr(i)
           includ(ii)=includ(ii)+1
         enddo
         write(ncwu,185)
         write(ncwu,185)
         write(ncwu,*)' Tentative of peak labelling in terms of atomic',
     1   ' species'
		 write(ncwu,4106)
		 write(ncwu,4107)
!
         ng=ngrup
         if(ng.gt.4)ng=4
         do j=1,ngrup
            ji=nk-j+1
            ma1=ive3i(j)
            ma2=ive3s(j)
            if(kaction.gt.3)then
               ma1=j
               ma2=j
            endif
            mm1=nint(groupatomi(1+(ma1-1)*md+6))
            mm2=nint(groupatomi(1+(ma2-1)*md+6))
            write(line(1:15),4101)(nalf(m),ib,m=mm2,mm1)
            do i=1,13,3
               call ucase(line(i:i))
            enddo
            iang=ive(j)
            inam=nalf(mm2)
            write(str2,'(a2)') inam
            call ucase(str2(1:1))
            if(ive(j).eq.3)then
               line=any
            endif
            dd(1:9)=ibb
!           write(ncwu,*)'ngrup,i,dimi(i),dax(i)',ngrup
            do i=1,ngrup
               if(i.lt.j)cycle
               dimi(i)=dmnmx(i,j,1)
               dax(i)=dmnmx(i,j,2)
!               write(ncwu,*)i,dimi(i),dax(i)
               write(dd(i)(1:15),4203)dimi(i),dax(i)
            enddo   
            write(ncwu,5103)j,includ(j),line,str2,angi(iang),angs(iang)
            line=ibb
         enddo   
!--tabella ' range of bond distances used to build fragments'
         ng1=1
         ng2=ng
!         write(ncwu,*)'istat2,ng1,ng2', istat2,ng1,ng2
         write(ncwu,5105)
         ik=0
         do while (ik==0)
5000        write(ncwu,4108)(wgrup,j,j=ng1,ng2)
            ik=1
            do j=ng1,ng2
               dd(1:8)=ibb
               do i=ng1,ng2
                  if(i.lt.j)cycle
                  dimi(i)=dmnmx(i,j,1)
                  dax(i)=dmnmx(i,j,2)
!                 write(ncwu,*)'i,dimi(i),dax(i)',i,dimi(i),dax(i)
                  write(dd(i)(1:15),4203)dimi(i),dax(i)
               enddo    
               write(ncwu,5104)j,(dd(ij),ij=ng1,ng2)
            enddo
            if(ng2.lt.ngrup)then
               write(ncwu,4108)(wgrup,j,j=ng2+1,ngrup)
               do j=ng1,ngrup
                 dd(1:8)=ibb
                 do i=ng2+1,ngrup
                    dimi(i)=dmnmx(i,j,1)
                    dax(i)=dmnmx(i,j,2)
                    write(dd(i)(1:15),4203)dimi(i),dax(i)
                 enddo   
                 write(ncwu,5104)j,(dd(ij),ij=ng2+1,ngrup)
               enddo
               if(ngrup.gt.8)then
                  ng1=ng1+1
                  ng2=ngrup
                  ik=0
               endif
            endif
         enddo   
      endif
      if (istat2.gt.1) write(ncwu,4102)
4101  format(5(a2,a1))
4102  format(1x,78('-'))
4104  format(//,
     *'  group',3x,'   peaks',3x,'   possible    ',3x,' species',3x,
     *'  range of ',4x,
     *'range of bond distances used to build fragments')
4105  format(' number',3x,'included',2x,'chemical species',3x,
     3  'assigned',3x,'bond angles',4(6x,a6,i2,1x))
4107  format(' number',3x,'included',2x,'chemical species',3x,
     3  'assigned',3x,'bond angles')
4106  format(/,
     *'  group',3x,'   peaks',3x,'   possible    ',3x,' species',3x,
     *'  range of ')
4108  format(3x,'group',4x,8(a6,i2,7x))
5103  format(1x,i4,4x,3x,i6,4x,a15,3x,2x,a2,3x,4x,f4.0,' - ',f4.0)
5104  format(2x,i4,2x,8a15)
5105  format(/,' range of bond distances used to build fragments')
4203  format(2x,'(',f5.2,'-',f5.2,')')
 185  format(1h )
!
      ddmax=dmax
      dmax=dddmax
      dma=sqrt(dmax)
!     write(ncwu,*)'ntottt=',ntottt
      if (ntottt.eq.0)then
         do i=1,nats
            izpk(i)=izpk(i)*nzConst
         enddo
!        write(ncwu,*)'izpk',(izpk(i),i=1,nats)
         return
      endif
      nnnx=100   !limite per stampare tabelle distanze
      if (istat2.gt.1.and.nats.lt.nnnx)then
!        write(ncwu,*) ' nflb,nflbld,nnfl,lll ',nflb,nflbld,nnfl,lll
           write(ncwu,2) dma
2          format(2x,'interpeak distances up to ',f5.2,/)
           call sttab(lll)
      endif
      dmax=ddmax
!--fine stampa le tabelle
      legami_atomo(:,:)=0   
      do jjj=1,ngrup
         jj=jjj
         call andis(jj,kaction)
      enddo
      icodpr=0
      if(istat2.eq.0)icodpr=-1
!-----------------------------------------------------
!--- deve chiamare calang?
      ntotang=0
      do jan=1,nats
          if(ntotang.lt.legami_atomo(jan,1))ntotang=legami_atomo(jan,1)
      enddo
!---
!         write(ncwu,*)'ntotang', ntotang
      if (istat2.gt.2) then
          if (ntotang.gt.0) then
              write(ncwu,4004)
4004          format(1h )
              write(ncwu,
     1        '(44h  accepted distances in this interpretation ,/)')
              call sttab(lll)
          else
              write(ncwu,
     1        '(46h no accepted distances in this interpretation ,/)')
              introk=0
              nfrag=0
              go to 9000
          endif
      endif
      if (istat2.gt.1) write(ncwu,4004)
!
      nang=0
      if (ntotang.le.1) then
          if (istat2.gt.1)write(ncwu,311)
311       format(/,1x,' no bond angles in this interpretation',/)
      else
          call calang(nang)
          if (istat2.gt.1) then
              write(ncwu,4102)
              write(ncwu,4004)
          endif
      endif
      if (istat2.gt.1) write(ncwu,4004)
!-- interpreta il cluster creando una connettivita' effettiva via
!-- 1) l'eliminazione dei non buoni (subr. intclu) 
!-- 2) l'applicazione degli op.di simm. (subr. chgxyz)
      introk=0
      call intclu(ninc,nang,kaction)
      if (istat2.gt.1) write(ncwu,4004)
!--
9000  introk=introk+nfrag
!      write(ncwu,*)'introk,nfrag',introk,nfrag
!      write(lo, *) 'izpk ',izpk(1:nats)
      jj=0
      do i=1,nats
         jj=jj+1
         if (izpk(jj).eq.-999999) then
             is=kluster(i)
             jfr=jordfr(is)
             if(kluster(i).gt.0.and.jfr.gt.0)then
                kluster(i)=-kluster(i)
                if(numfr(jfr).gt.0)numfr(jfr)=numfr(jfr)-1
             endif
         endif
      enddo
!      write(ncwu,*)'introk ',introk
      if (introk.eq.0.) then
	   do j=1,nats
!           write(ncwu,*)' 1 9045 j,izpk', j,izpk(j)
            if (izpk(j).ge.0)then
               iiz=izpk(j)
               izpk(j)=-1*(iiz*10000+1)
            endif
!         write(ncwu,*)' 2 9045 j,izpk', j,izpk(j)
         enddo
	   return
      endif
!--trasferisce su izpk la informazione di kluster
      do  i=1,nats    
         m=kluster(i)
         if (izpk(i).eq.-999999)cycle   
         jfragVal=jordfr(m)
         iiz=iabs(izpk(i))
         if(iiz.ge.10000)iiz=iiz/10000  
         izpk(i)=iiz*10000+jfragVal
         if(m.gt.30000.or. m.eq.0)cycle  
         izpk(i)=-izpk(i)
      enddo

!      write(ncwu,*)'trasferisce su izpk la informazione di kluster'
!      write(ncwu,'(a)')'kluster '
!      write(ncwu,'(10i7)')(kluster(jjj),jjj=1,nats)
!      write(ncwu,'(a)')'izpk '
!      write(ncwu,'(10i7)')(izpk(jjj),jjj=1,nats)
!
!--  richiamo a chgxyz
      do i=1,MaxAtomsBuild 
         jdfrag(i)=0
      enddo
      do i=1,nats 
         jdfrag(i)=kluster(i)
      enddo
      if(nAtmBlocc.lt.nats)call chgxyz(kaction)
!      write(ncwu,*)' dopo chgx nfrag,numfr  '
!     1 ,nfrag,( numfr(ii),ii=1,nfrag)
!      do  i=1,nats
!       write(lo,'(i,3f8.4,2i6)') i,(xyzbu(j,i),j=1,3),kblock(i),nz(i)
!      enddo
!  401 format('dopo 2 chgxyz i,xyzbu(,),kblock,nz ',i5,5f10.3,2i4)
!
!--------------------------------------------------------------------
!-- stampa nell'.out i fragmenti e la connettivita'
!      write(ncwu,*)'nprojj,icodpr,ntottt',nprojj,icodpr,ntottt
      if(nprojj.ne.0.or.icodpr.ne.-1.or.ntottt.ne.0.and.
     1   nats.lt.100)then
         call bonder(nAtmBlocc)
         ndimstored=nats26*5+1   !30ott11
         if (ndimstored > DimStored) then
             call DeallocaBuildModuleSmall
             allocate (stored(1:ndimstored), stat = ierr)
             DimStored = ndimstored
         endif
         stored(:)=0.
         if(nats.lt.100)call cluprz(stored,ndimstored,icodpr,nn15)
         call stclu(stored,ndimstored,icodpr,nn15)
*gl*     deallocate (stored, stat = ierr)
      endif
      if (istat2.gt.1) then
        write(ncwu,4004)
        write(ncwu,4102)
      endif
!--------------------------------------------------------------------
!-- salva la connettivita su iconn
!      write(ncwu,*)'clust jconn,',(jconn(j),j=1,jconn(1)*3+1)
      nfin=jconn(1)
      if(nfin.gt.0)then
      nf=3*nfin+1
      iconn(1:nf)=jconn(1:nf)
!      write(ncwu,*)' clust conn ncopie',iconn(1) 
!      write(ncwu,'(4(3i5,5x))')(iconn(j),j=2,nf)
      endif
!      write(ncwu,*)'clust finale izpk'
!      write(ncwu,602)(izpk(i),i=1,nats)
602   format(1x,10i7)
      return
      end
!
!code for intugu
      subroutine intugu(kaction)
      USE Atomi
      USE BuildStuff
!
      USE BuildModule
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty

      kvet(1:3,1:nats)=0
      factn=100.0/xyzbu(4,1)
!          write(ncwu,*)'intugu kaction,nats,factn ',kaction,nats,factn
      if(kaction.lt.3)then
         k=1
         nngg=ngrup
         do ii=1,nngg
            i=nngg-ii+1
            inf=ive15i(i)
            isup=ive15s(i)
            ia=1
            if(isup.gt.inf)ia=(isup-inf)
            jdelta1=(xyzbu(4,inf)-xyzbu(4,isup))/ia
!            write(ncwu,'(a,5i6)')'intugu ngrup,i,inf,isup,jdelta1',
!     1      ngrup,i,inf,isup,jdelta1
            jfactr=0
            icf1=0
            icf2=0
            kvet(2,k)=isup
            ik=0
            do while (ik==0)
               ik=1
10             continue
               int0=ifix(xyzbu(4,isup)*factn)
               int1=ifix(xyzbu(4,isup))
               isup0=isup
!              write(ncwu,'(a,5i6)')'intugu int0,int1,isup,inf,isup0 '
!     1         ,int0,int1,isup,inf,isup0
               do j=-isup,-inf
                  jj=-j
                  if(xyzbu(4,jj).le.int1.or.jj.eq.isup)then
                     kvet(1,k)=jj
                     kvet(3,k)=int0
                     intnew(jj)=int0
                     int1=xyzbu(4,jj)
!          write(ncwu,*)'j,jj,int1 ',j,jj,int1
                  else
                     isup=jj
                     k=k+1
!--25nov04                  if(k.ge.MaxAtoms)stop 2345
                     if(k.ge.MaxAtomsBuild)k=MaxAtomsBuild
                     kvet(2,k)=isup
                     ik=0    !go to 10
                     exit
                  endif
               enddo
            enddo
         enddo
      else
         do k=1,nats
            kk=nats-k+1
            intnew(k)=nint(xyzbu(4,k)*factn)
            kvet(1,kk)=k
            kvet(2,kk)=k
            kvet(3,kk)=intnew(k)
         enddo
         k=nats
      endif
      nkgru=k
!      write(ncwu,*)'intugu nkgru,nats',nkgru,nats
!      write(ncwu,*)'intnew'
!      write(ncwu,'(8i10)')(intnew(i),i=1,nats)
!      write(ncwu,*)'xyzbu(4,i)'
!      write(ncwu,'(8f9.1)')(xyzbu(4,i),i=1,nats)
!      write(ncwu,*)'intugu k,kvet,intnew,xyzbu(4,'
!      do k=1,nats
!      write(ncwu,'(i4,4i10,f7.1)')k,
!     1  kvet(1,k),kvet(2,k),kvet(3,k),
!     1 intnew(k),xyzbu(4,k)
!      enddo
!      write(ncwu,*)'fine intugu nkgru',nkgru
      return
      end
!
!code for namepk
      subroutine namepk
      USE General
      USE Atomi
      USE BuildStuff
!
      USE PhaseModule
      USE BuildModule
!
!--gives  name to the peaks
      common /pimpo/nAtmBlocc,focc,jumpcl,l15con,ihce,n3n
     1,vett(3,4),zatom(10),legacon(1000)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension pic(18),npic15(18),rapic(18),rapBuild(18)
!
!      write(ncwu,*)'inizia namepk nats,ihce',nats,ihce

!---   5/6/1995
      epsmin = 0.35
      epsmax = 0.41
!---
!
!      write(ncwu,*)'namepk n3dum',n3dum
      ngh=0
      ngl=0
      nok=0
      ngrup=1
      dmn(:)=0
      dmx(:)=0
      ive(:)=0
      pic(:)=0
      npic15(:)=0
      rapic(:)=0
      rapBuild(:)=0
      icopk(:)=0
      ive3i(:)=0
      ive3s(:)=0
      ive15i(:)=0
      ive15s(:)=0
      icogr(1:nats)=0
      icopf(1:nats)=0
      dmnmx(:,:,:)=0.
!--
      n3n=nk-ihce
      md=9
      m=1-md
!      write(ncwu,*)'namepk nk,n3n,ihce,neutro',nk,n3n,ihce,neutro
!      write(ncwu,*)'namepk n3',n3
!      write(ncwu,*)'namepk no',(no(i),i=1,nk)
!      write(ncwu,*)'namepk nw',(nw(i),i=1,nk)
!      write(ncwu,*)'namepk radii ',(radii(i,1),i=1,nk)
!      write(ncwu,*)'namepk nalf ',(nalf(i),i=1,nk)
!      write(ncwu,*)'namepk zatom ',(zatom(i),i=1,nk)
      dmi=100.
      dma=0.
      nn6=0
      ihceh=ihce+1
      a=0.
      do i=nk,ihceh,-1
         m=m+md
!--definisce il n. di gruppi pesanti (ngh)
         if(zatom(i).ge.11.and.neutro.eq.0)ngh=ngh+1
         groupatomi(m  )=nw(i)*focc
         groupatomi(m+1)=radii(i,1)
         dmi=amin1(dmi,radii(i,1))
         dma=amax1(dma,radii(i,1))
         groupatomi(m+2)=zatom(i)
         groupatomi(m+3)=0
         groupatomi(m+4)=0
         groupatomi(m+5)=0
         groupatomi(m+6)=i
         groupatomi(m+7)=2
         if(zatom(i).gt.18)groupatomi(m+7)=1
         a=a+groupatomi(m)
         nn6=nn6+1
!      write(ncwu,*) 'namepk i,a,groupatomi(m),nn6',i,a,groupatomi(m),nn6
*gl*  if (ifReduced.eq.1) cycle
         if(nint(a).lt.nats)cycle
         if(nint(a).ge.nats.and.i.eq.ihceh)cycle
         n3n=nn6
         groupatomi(m)=nats-a+groupatomi(m)
         exit
      enddo
!--definisce il n. di gruppi leggeri (ngl)
      ngl=n3n-ngh
!      write(ncwu,*)'n3n,n3,ngl,ngh',n3n,n3,ngl,ngh
!      write(ncwu,*)'n3,groupatomi(m+2) '
!     1,n3,(groupatomi(m+2),m=l3dum,l3dum+n3*md,md)
      dmin=2*dmi-epsmin
      if (dmax.lt.0.5) dmax=2*dma+epsmax
      dmin=dmin*dmin
      dmax=dmax*dmax
!      write(ncwu,*)'namepk dmin,dmax',dmin,dmax 
      m=1-md
      do i=1,n3n
         m=m+md
         groupatomi(m+3)=0
!        write(ncwu,*)'i,ngh,n3n,n3,st(m+2)',i,ngh,n3n,n3,groupatomi(m+2)
         if(i.le.ngh)then
          if(i.lt.n3n)groupatomi(m+3)=groupatomi(m+2)/groupatomi(m+2+md)
          if(i.ge.n3n)groupatomi(m+3)=groupatomi(m+2)
         endif
         groupatomi(m+4)=dmi+groupatomi(m+1)-epsmin
         if(groupatomi(m+4).lt.0.8)groupatomi(m+4)=.8
         groupatomi(m+5)=dma+groupatomi(m+1)+epsmax
         if(groupatomi(m+5).lt.groupatomi(m+4))
     1      groupatomi(m+5)=groupatomi(m+4)
!        write(lo,*)'i,zatom(i),n3',i,zatom(i),n3
         dmn(i)=groupatomi(m+4)
         dmx(i)=groupatomi(m+5)
!        write(ncwu,*) 'l3dum  ',i,(groupatomi(nn6),nn6=mm,mm+7),igroupatomi(mm+8)
!        write(ncwu,*) 'l3dum  ',i,(groupatomi(nn6),nn6=m,m+md-1)
!        write(ncwu,*)'namepk i dmn(i),dmx(i)',i,dmn(i),dmx(i) 
      enddo
!     
!
! 
      ive3i(1)=1
      ive3s(1)=n3n
      ive15i(1)=1
      ive15s(1)=nats
      ive(1)=2
      if(ngh.gt.0)then
        a=0.
        mlm=1-md
        do i=1,ngh
          mlm=mlm+md
          pic(i)=a+groupatomi(mlm)
          a=pic(i)
          ifin=i
          call pic15(focc,a,npp)
          npic15(i)=npp
!          write(ncwu,*)' i,a,npic15,npp,groupatomi(mlm+3),nats  '
!     1     ,i,a,npic15(i),npp,groupatomi(mlm+3),nats
          if(groupatomi(mlm+3).lt.1.35)cycle
          if(npic15(i).ge.nats)then
            npic15(i)=nats
            npp=nats-1
          endif
          rapic(i)=xyzbu(4,npp)/xyzbu(4,npp+1)
          rapBuild(i)=groupatomi(mlm+3)*.222+1.167
!         write(ncwu,*)' i,rapic,rapBuild ',i,rapic(i),rapBuild(i)
          if(rapic(i).lt.rapBuild(i))cycle
          ifin=0
          nok=1
          ive3s(ngrup)=i
!           write(ncwu,*)' ngrup,i,groupatomi(l3dum+(i-1)*md+6) ',
!     1     ngrup,i,groupatomi(l3dum+(i-1)*md+6)
          ive15s(ngrup)=npic15(i)
          if (ive15s(ngrup).lt.ive15i(ngrup)) then
            if (istat2.gt.1) write(ncwu,*)
     *        ' Possible error in the unit cell content'
            ive15s(ngrup)=ive15i(ngrup)
          endif
          ij=ive3i(ngrup)
          ive(ngrup)=1
!         write(ncwu,*)'163,ngrup,ive(ngrup),ive3i(ngrup),ive15i(ngrup),',
!     1   'ive3s(ngrup),ive15s(ngrup)',
!     2   ngrup,ive(ngrup),ive3i(ngrup),ive15i(ngrup),
!     3   ive3s(ngrup),ive15s(ngrup)
!         write(ncwu,*)'nats ',nats
          if(ive15s(ngrup).ge.nats)then
           ive15s(ngrup)=nats
           if(ive15s(ngrup).lt.ive15i(ngrup))ive15i(ngrup)=ive15s(ngrup)
           if(ngh.lt.ngrup)ngh=ngrup
           if(n3n.lt.ngrup)n3n=ngrup
           exit
          endif
          ngrup=ngrup+1
          ive3i(ngrup)=i+1
          ive15i(ngrup)=npic15(i)+1
        enddo
101     continue
!--
!        write(ncwu,*)'172,ifin,ngrup,ive(ngrup),ive3i(ngrup)'
!     1  ,',ive15i(ngrup),',
!     1  'ive3s(ngrup),ive15s(ngrup)',
!     2  ifin,ngrup,ive(ngrup),ive3i(ngrup),ive15i(ngrup),
!     3  ive3s(ngrup),ive15s(ngrup)
200     continue
        if(ifin.ne.0)then
!-- procedura nok=0
!         write(ncwu,*)'!-- procedura nok=0'
!         write(ncwu,*)'190,ngrup,ive(ngrup),ive3i(ngrup),ive15i(ngrup),',
!     1   'ive3s(ngrup),ive15s(ngrup)',
!     2   ngrup,ive(ngrup),ive3i(ngrup),ive15i(ngrup),
!     3   ive3s(ngrup),ive15s(ngrup)
          inf=ive3i(ngrup)
          infg=inf
          mlm=4+(inf-2)*md
          a=0.
          do i=inf,ngh
            mlm=mlm+md
            if(a.ge.groupatomi(mlm))cycle
            if(npic15(i).le.1)cycle
            a=groupatomi(mlm)
            ml=mlm
            infg=i
          enddo
          inf=ive15i(ngrup)
          isup=npic15(infg)
          ive(ngrup)=3
          ive3s(ngrup)=ngh
          ive15s(ngrup)=npic15(ngh)
          mm=npic15(infg)+1
          if(mm.gt.nats)mm=nats
          fff=xyzbu(4,mm)*rapBuild(infg)
          m15=ive15i(ngrup)-1
          iout=0
          do i=inf,isup
            m15=m15+1
            ij=i-1
            if(xyzbu(4,m15).le.fff)then ! go to 450
               iout=1
            endif   
          enddo
!      write(ncwu,*)'220,ngrup,ive(ngrup),ive3i(ngrup),ive15i(ngrup),',
!     1'ive3s(ngrup),ive15s(ngrup)',
!     2ngrup,ive(ngrup),ive3i(ngrup),ive15i(ngrup),
!     3ive3s(ngrup),ive15s(ngrup)
!--peaks like heavy
          if(iout.eq.1)then
450       continue
            if(ij.ge.inf)then  !if(ij.lt.inf)go to 470
              ive3s(ngrup)=infg
              ii=ive3i(ngrup)
              ive15s(ngrup)=ij
              ive(ngrup)=1
!--peak like ambigui
              ngrup=ngrup+1
            endif
470         ive(ngrup)=3
            ive15i(ngrup)=ij+1
            ive15s(ngrup)=npic15(ngh)
            if(ngh.eq.n3n)ive15s(ngrup)=nats
            ive3i(ngrup)=1
            if(ngrup.gt.1)ive3i(ngrup)=ive3i(ngrup-1)
            ive3s(ngrup)=ngh
            if(n3n.gt.ngh)ive3s(ngrup)=ngh+1
            ii=ive3i(ngrup)
!           write(ncwu,*)'248,ngrup,ive(ngrup),ive3i(ngrup),ive15i(ngrup),',
!     1     'ive3s(ngrup),ive15s(ngrup)',
!     2      ngrup,ive(ngrup),ive3i(ngrup),ive15i(ngrup),
!     3     ive3s(ngrup),ive15s(ngrup)
!500         if(n3n.eq.ngh.or.ive15s(ngrup).eq.nats)go to 590
500         if(n3n.ne.ngh.and.ive15s(ngrup).ne.nats)then
!-- carboni
              ngrup=ngrup+1
              ive3i(ngrup)=ngh+1
              ive3s(ngrup)=n3n
              ive15i(ngrup)=ive15s(ngrup-1)+1
              ive15s(ngrup)=nats
              ive(ngrup)=2
              ii=ive3i(ngrup)
            endif
!      write(ncwu,*)'260,ngrup,ive(ngrup),ive3i(ngrup),ive15i(ngrup),',
!     1'ive3s(ngrup),ive15s(ngrup)',
!     2ngrup,ive(ngrup),ive3i(ngrup),ive15i(ngrup),
!     3ive3s(ngrup),ive15s(ngrup)

          else if(iout.eq.0)then
           if(ive15s(ngrup).lt.ive15i(ngrup))ive15s(ngrup)=ive15i(ngrup)
            if(n3n.eq.ngh.and.ive15s(ngrup).lt.nats)ive15s(ngrup)=nats
            ive3s(ngrup)=n3n
            if(ive15s(ngrup).lt.nats)then  !go to 500
!-- carboni
              ngrup=ngrup+1
              ive3i(ngrup)=ngh+1
              ive3s(ngrup)=n3n
              ive15i(ngrup)=ive15s(ngrup-1)+1
              ive15s(ngrup)=nats
              ive(ngrup)=2
              ii=ive3i(ngrup)
            endif
          endif   !if(iout.eq.1)
        else if(ifin.eq.0)then
          if(n3n.ne.ngh.or.ive15s(ngrup).ne.nats)then
            ive3s(ngrup)=n3n
            ive15s(ngrup)=nats
            ive(ngrup)=2
            ii=ive3i(ngrup)
          endif
        endif
      endif
!--set distances
590     continue
!      write(ncwu,*)'269,ngrup,ive(ngrup),ive3i(ngrup),ive15i(ngrup),',
!     1'ive3s(ngrup),ive15s(ngrup)',
!     2ngrup,ive(ngrup),ive3i(ngrup),ive15i(ngrup),
!     3ive3s(ngrup),ive15s(ngrup)
      do i=1,ngrup
      inf=ive15i(i)
      isup=ive15s(i)
      inf2=ive3i(i)
      isup2=ive3s(i)
        do j=inf,isup
        if (izpk(j).ne.-999999) izpk(j)=ive3s(i)
        icogr(j)=i
!       write(ncwu,*)'i,inf2,isup2,icogr(j),j',i,inf2,isup2,icogr(j),j
      enddo
      enddo
      npeahi=1
      do i=1,ngrup
      if(ive(i).eq.1)npeahi=ive15s(i)
      enddo
      ive15s(ngrup)=nats
      do i=1,ngrup
      inf=ive3i(i)
      isup=ive3s(i)
      dmn(i)=1000.
      dmx(i)=0.
cv      mlm=l3dum+(inf-1)*md+1
      mlm=1+(inf-2)*md+1
        do  j=inf,isup
        mlm=mlm+md
        if(groupatomi(mlm).le.dmn(i))dmn(i)=groupatomi(mlm)
        if(groupatomi(mlm).lt.dmx(i))cycle
        dmx(i)=groupatomi(mlm)
        enddo
      enddo
600   continue
!-- definisce il vett icopf (codice picco forte): =1, z>18 ;=0 z<18
      do i=1,nats
      icopf(i)=kpiccoforte(i,1)
      enddo
!       write(ncwu,*)'namepk,icopf ',(icopf(i),i=1,nats)
      do  i=1,ngrup
        do  j=1,ngrup
        dmnmx(i,j,1)=dmn(i)+dmn(j)-epsmin
        if(dmnmx(i,j,1).lt.0.8) dmnmx(i,j,1)=0.8
        dmnmx(i,j,2)=dmx(i)+dmx(j)+epsmax
        if(dmnmx(i,j,2).lt.dmnmx(i,j,1)) dmnmx(i,j,2)=dmnmx(i,j,1)
        enddo
!      write(ncwu,'(2i3,8f6.2)')i,j,(dmnmx(i,jj,1),jj=1,ngrup)
!      write(ncwu,'(2i3,8f6.2)')i,j,(dmnmx(i,jj,2),jj=1,ngrup)
      enddo
!--redefinisce ive solo per neutro=1
!  ive(i)=1 al meno un elemento del gruppo ha z maggiore di 18
!  ive(i)=2 sono tutti non metallici
      if (neutro.gt.0) then
         do j=1,ngrup
            inf =ive3i(j)
            isup =ive3s(j)
            do i=inf,isup
               if(zatom(i).gt.18)ive(j)=1
            enddo
         enddo
      endif
      kprint=0
      if(kprint.eq.1)then
         m=1
         do j=1,n3n
            write(ncwu,'(i3,8f8.3,2x,a2)')j,(groupatomi(nn6),nn6=m,m+8)
            m=m+md
         enddo
!         write(ncwu,*)'namepk,nats,nk,ngrup,ngh ',nnats,nk,ngrup,ngh
!         write(ncwu,*)'namepk,icogr ',(icogr(i),i=1,nats)
!         write(ncwu,*)'namepk,ive   ',(ive(i),i=1,n3n)
!         write(ncwu,*)'namepk,ive3i ',(ive3i(i),i=1,ngrup)
!         write(ncwu,*)'namepk,ive3s ',(ive3s(i),i=1,ngrup)
!         write(ncwu,*)'namepk,ive15i ',(ive15i(i),i=1,ngrup)
!         write(ncwu,*)'namepk,ive15s ',(ive15s(i),i=1,ngrup)
!         write(ncwu,*)'namepk izpk  ',(izpk(i),i=1,nats)
      endif
      return
      end
!
!code for readpk
      subroutine readpk
      USE General
      USE Deprecato
      USE Atomi
      USE BuildStuff
!
      USE PhaseModule
      USE BuildModule
!
!--gives  name to the peaks
      common /pimpo/nAtmBlocc,focc,jumpcl,l15con,ihce,n3n
     1,vett(3,4),zatom(10),legacon(1000)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension pic(18),npic15(18),rapic(18),rapBuild(18)
!
!      write(ncwu,*)'inizia readpk'
!      write(ncwu,*)'n3n,zatom,ihce',
!     1 n3n,zatom,ihce
!      write(ncwu,*)'i,radii(i,1),no(i),zatom(i)'
!      do i =1,nk
!      write(ncwu,*)
!     1i,radii(i,1),no(i),zatom(i)
!      enddo
      epsmin = 0.35
      epsmax = 0.41
      if(erre.lt.0.15.and.erre.gt.0.0) epsmin = 0.54
!
      ngh=0
      ngl=0
      nok=1
      ngrup=1
      npeahi=0
      do 40 i=1,18
      dmn(i)=100
      dmx(i)=0
      ive(i)=0
      pic(i)=0
      npic15(i)=0
      rapic(i)=0
      rapBuild(i)=0
      icopk(i)=0
      ive3i(i)=0
      ive3s(i)=0
      ive15i(i)=0
40    ive15s(i)=0
      do 41 i=1,nats
      icopf(i)=0
41    icogr(i)=0
      do 42 i=1,18
      do 42 j=1,18
      dmnmx(i,j,1)=0.
42    dmnmx(i,j,2)=0.
!--
1     format(5x,2i3,1x,a2,2x,a2,i5)
      md=9
      m=1
      n3n=nk-ihce
      n3=n3n
      dma=0.
      dmi=100.
      acum=0.
      iii=0
!      ihceh=ihce+1
      ihceh=1
      do  50 i=nk,ihceh,-1
!--group number:iii, no. d'ordine in funzione di z crescente:i
      groupatomi(m)=0.
      j0=0
      do 55 j=1,nats
      nzj=iabs(nz(j))
      if(nzj.ge.10000)nzj=nzj/10000
      if(nzj.ne.i)cycle
            if(j0.eq.0) then
            iii=iii+1
	    j0=j
!            if(erre.lt.0.15.and.erre.gt.0.0)npeahi=j 
!            if(zatom(i).gt.18)npeahi=j
            endif
      groupatomi(m)=groupatomi(m)+xyzbu(5,j)
      icogr(j)=iii
!-- definisce il vett icopf (codice picco forte): =1, z>18 ;=0 z<18
      icopf(j)=kpiccoforte(j,4)
      if(icopf(j).eq.1)npeahi=npeahi+1
      acum=acum+groupatomi(m)
55    continue 
!      write(ncwu,*)'readpk,icogr ',(icogr(iik),iik=1,nats)
      if(j0.eq.0)cycle
      if(no(i).ge.11.and.neutro.eq.0)ngh=ngh+1
      if(radii(i,1).ge.dma)dma=radii(i,1)
      if(radii(i,1).le.dmi)dmi=radii(i,1)
      groupatomi(m+1)=radii(i,1)
      if (neutro == 0) then
          groupatomi(m+2)=no(i)
      elseif (neutro == 1) then
          groupatomi(m+2)=cl(i)
      else
          groupatomi(m+2)=zeff(i)
      endif
      groupatomi(m+3:m+5)=0
      groupatomi(m+6)=i
      groupatomi(m+7)=2
      itemp(1)=nalf(i)
      groupatomi(m+8)=temp(1)
!      write(ncwu,*)' ii,i,j0 ,ive15i(i)',ii,i,j0,ive15i(i)
      ive(iii)=2
!--2nov04      if(erre.lt.0.15.and.erre.gt.0.0)ive(iii)=1 
      if(zatom(i).gt.18)ive(iii)=1
      if(zatom(i).gt.18)groupatomi(m+7)=1
      ngrup=iii
!--29.7.97      if(i.lt.n3n)ive3i(i+1)=i+1
!      write(ncwu,*)' ii,i,j0 ,ive3s(i),ive(i)',ii,i,j0,ive3s(i),ive(i)
!       write(ncwu,'(a,i5,10f6.3)')
!     1'm,groupatomi(m:m+8)',m,groupatomi(m:m+8)
49    m=m+md 
50    continue  
      ngl=n3n-ngh
      dmin=2*dmi-epsmin
      dmax=2*dma+epsmax
      dmin=dmin*dmin
      dmax=dmax*dmax
!      write(ncwu,*)' nk,nats,ngrup,ngh ',nk,nnats,ngrup,ngh
      if(ngrup.eq.0)then
      write(ncwu,*)' Given peaks cannot be recognized '
      ngrup=1
      endif
!--controlla se icogr( ) eq.0
      do j=1,nats
      if(icogr(j).eq.0)icogr(j)=ngrup
      enddo
!--fine "controlla"
      do  i=1,ngrup
      mim=1+(i-1)*md+4
      groupatomi(mim)=1000.
      groupatomi(mim+1)=0.
      ik=groupatomi(mim+2)
        do  j=1,ngrup
        mjm=1+(j-1)*md+6
        jk=groupatomi(mjm)
        dmnmx(i,j,1)=BondTable(1,ik,jk)
        dmnmx(i,j,2)=BondTable(2,ik,jk)
        if(groupatomi(mim).ge.dmnmx(i,j,1))groupatomi(mim)=dmnmx(i,j,1)
        if(groupatomi(mim+1).le.dmnmx(i,j,2))
     1  groupatomi(mim+1)=dmnmx(i,j,2)
!        write(lo,*)'i,j,ik,jk,dmnmx(i,j,1-2)',i,j,ik,jk,dmnmx(i,j,1),
!     1 dmnmx(i,j,2)
        enddo
      enddo
!------------------------------------------------------------------------
!      write(ncwu,*)'readpk,icogr ',(icogr(i),i=1,nats)
!      write(ncwu,*)'readpk,ive   ',(ive(i),i=1,n3n)
!      write(ncwu,*)'readpk,ive3i   ',(ive3i(i),i=1,n3n)
!      write(ncwu,*)'readpk,ive3s   ',(ive3s(i),i=1,n3n)
!      write(ncwu,*)'readpk,ive15i   ',(ive15i(i),i=1,n3n)
!      write(ncwu,*)'readpk,ive15s   ',(ive15s(i),i=1,n3n)
      return
      end
!
!code for kpiccoforte
      function kpiccoforte(n,kaction)
      USE General
      USE Atomi
      USE BuildModule
!
      kpiccoforte=0
      if(kaction.le.3)then
!      if(npeahi.gt.n)kpiccoforte=1   !06dic11
      if(npeahi.ge.n)kpiccoforte=1
      else
      ik=nztoz(n,nz(n))
      if(no(ik).ge.18)kpiccoforte=1
      endif
      return
      end
!
!code for andis
      subroutine andis(n,kaction)
      USE Atomi
      USE BuildStuff
!
      USE BuildModule
!
!--analyze distances
      common /pimpo/nAtmBlocc,focc,jumpcl,l15con,ihce,n3n
     1,vett(3,4),zatom(10),legacon(1000)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
     
!
      limi15=ive15i(n)
      lims15=ive15s(n)
!      write(ncwu,*)'limi15,lims15',limi15,lims15
      if(kaction.gt.3)then
         limi15=1
         lims15=nats
      endif
      do  j=limi15,lims15
         mg1=icogr(j)
         if(mg1.ne.n)cycle    !go to 211
         ni=atomo_in_coppie(j,1)   !nint(storeb(mdis+1))
         if(ni.le.0)cycle
         numb=0
!--22.9.98 Aggiunta terza parola che conterra una funzione delle intensita 
!--        degli at.a lui legati, che viene calcolata in calang
!         storeb(m1con+2)=0  !funzione della int. dei legati  !intens_legati
         do  i=1,ni
            ncopia2=atomo_in_coppie(j,i+1) 
            if(ncopia2.le.0)cycle 
            nord2=nord_picco2_coppia(ncopia2)    !nint(storeb(mdis))
            mg2=icogr(nord2)
            if(ihce.eq.1.and.mg2.eq.ngrup.and.mg1.eq.ngrup)cycle  
 !           write(ncwu,*)'j,nord2,kblock(nord2),ni,',
 !    1      'i,ncopia2,nord2'
 !    1      ,j,nord2,kblock(nord2),ni,i,ncopia2,nord2
!-- per ogni atomo mette :address in ldis del nord2 (mdis+2)
!--                      :niente
!--                      :address in lang degli angoli nord2-nord1-x
            if(numb.ge.num_legami_max)then
               atomo_in_coppie(j,i+1)=-iabs(atomo_in_coppie(j,i+1))
               cycle
            endif
            numb=numb+1
            legami_atomo(j,numb+1)=ncopia2    !storeb(mcon)=mdis
          enddo      
      legami_atomo(j,1)=numb    !storeb(m1con+1)=numb
!      write(ncwu,'(a,i6,12i4)')'andis ',j,legami_atomo(j,1:numb+1)
      enddo
      return
      end
!
!code for konect0
      function konect0(i,j,kcon)
      USE Atomi
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c read the old connectivity looking for the bond between i and j peaks.
      md5c=3
      konect0=0
      kcon=0
      i1=min0(i,j)
      i2=i+j-i1
      k=iconn(1)
      k=1+(k-1)*md5c
      do 100 l=2,k,md5c
      if(iconn(l).eq.i1.and.iconn(l+1).eq.i2)then
      konect0=iconn(l+2)
!--15.7.97      kcon=1
      kcon=iconn(l+2)
!      write(ncwu,*)' konect0,i1,12,kcon  ', i1,i2,kcon
      endif
100   continue
      return
      end
!
!code for idstall
      subroutine idstall(npmin,npmax,npk,npk2,
     1 nop2,distmin,yyy,ss,jfissfk,kccod)
      USE General, only : gdist
      USE Symmetry
      USE Atomi
      USE BuildStuff
!
      USE BuildModule
!
!-- applica gli op. di sim. a npk2 e trova l'equivalente piu'
!-- vicino ad un altro picco (npk) appartenente a un fragmento
!
      dimension jfissfk(*)
      common /pimpo/nAtmBlocc,focc,jumpcl,l15con,ihce,n3n
     1,vett(3,4),zatom(10),legacon(1000)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension ivvet(2)
      dimension x(3),y(3),yy(3),z(3),yyy(3),ss(3),sss(3),d(3)
!--    nnpmin <0       : kcontrol=0 ; npmin=-nnpmin
!-- 0< nnpmin <=nats   : kcontrol=1 ; npmin=nnpmin
!--    nnpmin >nats    : kcontrol=2 ; npmin=nnpmin-nats
!--    nnpmin = npmax  : kcontrol=3 ; npmin=nnpmin
!--    distmin <0  :esce apena trova un atomo a dist. di legame in kcontrol=2
!--kcontrol=0 :loop sui baricentro dei frag.fissi 
!--kcontrol=1 :loop su tutti i picchi compressi tra nnpmin e npmax
!--kcontrol=2 :loop sui picchi compressi tra (nnpmin-nats) e npmax appartenenti 
!--            fragmenti con piu' di 4 picchi (piu' di 2 per piccole strutt.)
!--kcontrol=3 :controlla la autoconsistenza del nnpmin picco.
!
!      write(ncwu,*)' idstall npmin,npmax,nats',npmin,npmax,nats
!      write(ncwu,*)' idstall jfissfk',(jfissfk(i),i=1,nats) 
      nop2=1555
      nsym1=1
      e10=1.0e-10
      idst=0
!      write(ncwu,*)' idstall kccod,npmin,npmax',kccod,npmin,npmax
      distmin=10000000
      ivvet(1)= 1
      ivvet(2)=-1
      ifin=icent+1
      x(1:3)=0.
      y(1:3)=0.
      yy(1:3)=0.
      yyy(1:3)=0.
      z(1:3)=0.
      sss(1:3)=0.
      ss(1:3)=0.
      d(1:3)=0.
!
      iscel=0
      icodinsieme=0
      if(npmin.eq.9999.and.npmax.eq.9999)then
         npmin=1
         npmax=1
         icodinsieme=1
      endif
      if(npmax.gt.nats)iscel=nats
!
      cc=cprxyzs(npk2,x) 
      npk=0
      do k=1,nsymTot         !1050
         ieqX=0
         call  xequiTot(k, x, yy,ieqX)
!
         do inp=npmin,npmax
            jfiss=inp-iscel
!      write(ncwu,*)'idstall inp,npk2,jfiss,jfisspk(jfiss),kccod'
!     1 ,inp,npk2,jfiss,jfisspk(jfiss),kccod
            iin=0
            if(inp.ne.npk2.and.jfissfk(jfiss).eq.kccod
     1          .and.icodinsieme.eq.0)iin=1
            if(iin.eq.1.or.icodinsieme.eq.1)then
                do  n=1,3
                   if(icodinsieme.eq.0)then
                      z(n)=rxyzs(n,inp)
                   else if(icodinsieme.eq.1)then
                      z(n)=barx(n)
!       write(ncwu,*)'npk ,z',inp,z
                   endif
                   sss(n)=0
                   d(n)=z(n)-yy(n)
                enddo
!       write(ncwu,*)' idstall npk2 equiv= yy',yy
!       write(ncwu,*)'npk ,z',inp,z
!       write(ncwu,*)'inp,k,d',inp,k,d
                call reddst(d,sss)
                dist0=cdist(gdist,d,distt)
                if(dist0.lt.distmin) then
                   distmin=dist0
                   npk=inp
                   istras=cistras(sss)
                   nop2 = k*1000 + istras 
                   do  nyy=1,3
                      ss(nyy)=sss(nyy)
                      yyy(nyy)=yy(nyy)+sss(nyy)
                   enddo
!      write(ncwu,*)
!     1 'idstall inp,ivvet(ifi),istras,npk2,k,kt,ii,dist0,yyy,ss',
!     1inp,ivvet(ifi),istras,npk2,k,kt,ii,dist0,yyy,ss
                endif
            endif
         enddo
      enddo
      return
      end
!
!code for idst1at_to_atsfrag
      subroutine idst1at_to_atsfrag(numerofrag,npk,npk2,
     1 nop2,distmin,yyy,ss)
      USE General
      USE Symmetry
      USE Atomi
      USE BuildStuff
!
      USE BuildModule
      USE Molcom
      USE PhaseModule
!
c
!-- applica gli op. di sim. a npk2 e trova l'equivalente piu'
!-- vicino ad un altro picco (npk) appartenente al fragmento
!-- richiesto
      common /pimpo/nAtmBlocc,focc,jumpcl,l15con,ihce,n3n
     1,vett(3,4),zatom(10),legacon(1000)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension ivvet(2)
      dimension x(3),y(3),yy(3),z(3),yyy(3),ss(3),sss(3),d(3)
!
!--    nnpmin <0       : kcontrol=0 ; npmin=-nnpmin
!-- 0< nnpmin <=nats   : kcontrol=1 ; npmin=nnpmin
!--    nnpmin >nats    : kcontrol=2 ; npmin=nnpmin-nats
!--    nnpmin = npmax  : kcontrol=3 ; npmin=nnpmin
!--    distmin <0  :esce apena trova un atomo a dist. di legame in kcontrol=2
!--kcontrol=0 :loop sui baricentro dei frag.fissi 
!--kcontrol=1 :loop su tutti i picchi compressi tra nnpmin e npmax
!--kcontrol=2 :loop sui picchi compressi tra (nnpmin-nats) e npmax appartenenti 
!--            fragmenti con piu' di 4 picchi (piu' di 2 per piccole strutt.)
!--kcontrol=3 :controlla la autoconsistenza del nnpmin picco.
c
!      write(ncwu,*)' idstall npmin,npmax,nats',npmin,npmax,nats
!      write(ncwu,*)' idstall jfisspk',(jfisspk(i),i=1,nats) 
      nop2=1555
      nsym1=1
      e10=1.0e-10
      idst=0
!      write(ncwu,*)' idstall kccod,npmin,npmax',kccod,npmin,npmax
      distmin=10000000
      ivvet(1)= 1
      ivvet(2)=-1
      ifin=icent+1
      x(1:3)=0.
      y(1:3)=0.
      yy(1:3)=0.
      yyy(1:3)=0.
      z(1:3)=0.
      sss(1:3)=0.
      ss(1:3)=0.
      d(1:3)=0.
!
!      write(lo,*)' idst1at_ ncentr,ifin,icent,nsym1,nsym ',
!     1ncentr,ifin,icent,nsym1,nsym
      cc=cprxyzs(npk2,x) 
      npk=0
      do k=1,nsymTot         !1050
         ieqX=0
         call  xequiTot(k, x, yy,ieqX)
!
         do inp=1,nats
            inpfr=jdfrag(inp)
!      write(lo,*)' idst1at_ inp,inpfr,jordfr(inpfr) ',
!     1inp,inpfr,jordfr(inpfr)
            jfraginp=jordfr(inpfr)
!      write(ncwu,*)'idstall inp,npk2,jfiss,jfisspk(jfiss),kccod'
!     1 ,inp,npk2,jfiss,jfisspk(jfiss),kccod
!      if(inp.ne.npk2.and.jfisspk(inp).eq.1)then
            if(inp.ne.npk2.and.jfraginp.eq.numerofrag)then
               do  n=1,3
                  z(n)=rxyzs(n,inp)
                  sss(n)=0
                  d(n)=z(n)-yy(n)
               enddo
!       write(ncwu,*)' idstall npk2 equiv= yy',yy
!       write(ncwu,*)'npk ,z',inp,z
!       write(ncwu,*)'inp,k,d',inp,k,d
               call reddst(d,sss)
               dist0=cdist(gdist,d,distt)
               mg0 =nzTot(inp)
               mg1 =nzTot(npk2)
               if(mg0.gt.0.and.mg1.gt.0)then
                  dmxh =BondTable(2,mg0,mg1)
                  dmnh =BondTable(1,mg0,mg1)
!      write(lo,*)'dst0,dmxh,dmnh ',dst0,dmxh,dmnh
                  if(dist0.ge.dmnh.and.dist0.le.dmxh)then !legati
                     distmin=dist0
                     npk=inp
                     istras=cistras(sss)
                     nop2 = k*1000 + istras 
!      write(ncwu,*)'idstall inp,ivvet(ifi),istras,npk2,k,kt,ii,dist0,yy,sss',
!     1inp,ivvet(ifi),istras,npk2,k,kt,ii,dist0,yy,sss
!       write(ncwu,*)'idst1at_ npk,npk2,nop2,dist0 ',npk,npk2,nop2,dist0
                     do  nyy=1,3
                       ss(nyy)=sss(nyy)
                       yyy(nyy)=yy(nyy)+sss(nyy)
                     enddo
                     return
!      write(ncwu,*)
!     1 'idst1at.. inp,nop2,istras,npk2,k,kt,ii,dist0,yyy,ss',
!     1inp,nop2,istras,npk2,k,kt,ii,dist0,yyy,ss
                  endif
               endif
            endif
         enddo
      enddo   
      return
      end
!
!code for cpxyzs
      function cpxyzs(n,xcoo)
      USE Atomi
      dimension xcoo(3)
      do i=1,3
      xcoo(i)=xyzs(i,n) 
      enddo
      cpxyzs=1
      return
      end
!
!code for cprxyzs
      function cprxyzs(n,xcoo)
      USE Atomi
      USE BuildModule
      USE BuildStuff
!
      dimension xcoo(3)
      do i=1,3
      xcoo(i)=rxyzs(i,n) 
      enddo
      cprxyzs=1
      return
      end
!
!code for reddst
      subroutine reddst(d,sss)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension d(3),sss(3),d0(3)
      do n=1,3
      d0(n)=d(n)
      sss(n)=0.
      enddo
      do n=1,3
         do while (abs(d(n)).gt.0.5)
           sgn=sign(1.0,d(n))
           sss(n)=sgn+sss(n)
           d(n)=d(n)-sgn
         enddo
      enddo
      return
      end
!
!code for cistras
      function cistras(sss)
      dimension sss(3),iss(3)
      cistras=0
      iss(:)=nint(sss(:))+5
      cistras=iss(1)*100+iss(2)*10+iss(3)
      return
      end
!
!code for norop
      subroutine norop(m,nop,itx,ity,itz)
      USE BuildModule
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
!
!- decompatta il contenuto di m=nop*1000+istras
! istras
!      write(ncwu,*)'norop m ',m
      nop=m/1000
      istras=m-nop*1000
      itx=istras/100
      icj=istras-itx*100
      ity=icj/10
      itz=icj-ity*10
      itx=itx-5
      ity=ity-5
      itz=itz-5
      return
      end
!
!code for sttab
      subroutine sttab(l)
      USE Atomi
!
      USE BuildModule
      USE BuildStuff
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension iprnt(30),prnt(30)
      equivalence(prnt,iprnt)
c
      ncolmx=4
      nn6=0   !leggerÃƒ  da atomo_in_coppie  mdis
      if(l.lt.0)nn6=1   !leggerÃƒ  da ?? mcon
      do  j=1,nats
         jprnt= j      !nint(storeb(m))
         ni=atomo_in_coppie(j,1)     !nint(storeb(m+1))
!        write(ncwu,*)'nn6,l,j,m,maddr,jprnt,ni',nn6,l,j,m,maddr,jprnt,ni
         if(ni.eq.0)cycle
         n=1
         nline=0
	   ncol=0
         do i=1,ni
            ncoppia=iabs(atomo_in_coppie(j,i+1))
            if(ncoppia.eq.0) cycle  !nint(storeb(m0)).eq.0)go to 199 
            nopp=nopsym_picco2_coppia(ncoppia)    !nint(storeb(m0+6))
            nord=nord_picco2_coppia(ncoppia)      !nint(storeb(m0))
            ncol=ncol+1
            iprnt(n  )=nord
            iprnt(n+1)=nopp
            prnt(n+2)=dist_coppia(ncoppia)           !storeb(m0+2)
            if(i.ne.ni.and.ncol.ne.ncolmx)then
              n=n+3
              cycle
            endif
            if(nline.eq.0)then
               if (istat2.gt.1) write(ncwu,2)jprnt,
     1           (iprnt(k),iprnt(k+1),prnt(k+2),k=1,n,3)
            else
               if (istat2.gt.1) write(ncwu,1)
     1           (iprnt(k),iprnt(k+1),prnt(k+2),k=1,n,3)
            endif
            nline=nline+1
            ncol=0
            n=1
            enddo
        jprnt=0
        do i=1,30,3
           iprnt(i+1)=0
           iprnt(i+2)=0
           prnt(i)=0.
        enddo
      enddo
2     format(i4,')',4(i5,'(',i6,')',f6.2))
1     format(5x,4(i5,'(',i6,')',f6.2))  
      return
      end
!
!code for pic15
      subroutine pic15(focc,a,nb)
      USE Atomi
      USE BuildModule
      USE BuildStuff
!
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      som=a
      erro=.5*focc
      do 100 i=1,nats
      som=som- xyzbu(5,i)
      nb=i
!      write(ncwu,*)'pic15,a,focc,erro,i,som,nb ',a,focc,erro,i,som,nb
      if(som.gt.erro.or.som.gt.0)go to 100 
      if(abs(som).le.erro)return
!--error
!         write(ncwu,1)erro,som,nats,nb
!   1     format(1x,' possible error in the cell content',
!        1   2f10.4,2i5)
      return
100   continue
      return
      end
!
!code for ang
      subroutine ang(a,b,c)
      Use General, only : gdist
!
      USE BuildModule
      USE BuildStuff
!--
      dimension a(3),b(3)
      c=0.0
      idm = 3
      do i=1,idm
         j=(i-1)*idm
         do l=1,idm
            c=c+gdist(j+l)*a(i)*b(l)
         enddo   
      enddo   
      return
      end
!
!code for calang
      subroutine calang(nang)
      USE General
      USE Atomi
!
      USE BuildModule
      USE buildStuff
!
      common /timetempo/ timeT(10)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension d1(3),d2(3),ist(5,5),gt(5),nord(3),nnum(2)
      dimension nchick(3),chicang(2,3),legati(100)
!
!
!      write(ncwu,*)'intnew',(intnew(i),i=1,nats)
      kkverbo=0
      npicen=0
      mini0=2**30   
      nang=1
      j3000=nats
      k3000=1000 
      maxangl=k3000
      nkook(1:2,1:j3000)=0
      lpicen(1:8,1:j3000)=0
      maxnkook(1:k3000)=0
      kooktab(1:2,1:k3000,1:j3000)=0
      norang(:,:)=0
      nnum(1:2)=1
      do j=1,nats
!!mr          intsom(1:2,j)=intnew(j)
          intsom(1,j)=intnew(j)
          intsom(2,j)=intnew(j)
!         write(ncwu,*)'intsom 1 e 2,j',(intsom(ii,j),ii=1,2)
      enddo
      if (istat2.gt.1) write(lo,5)
      ja=0
      mangl=1    !=lang
!
      do i=1,nats
         if(nang.ge.10000) exit
         if (atomo_in_coppie(i,1).le.1) cycle   !era mdis adesso nleg
         nchick(1:3)=0
         legati(1:100)=0
         nanell=0
         nleg=atomo_in_coppie(i,1)           !nint(storeb(mdis+1))
         nord1=i                         !nint(storeb(mdis))
         nord(1)=nord1
!               
         do j=2,nleg+1   !=1,nleg
             ncop1=iabs(atomo_in_coppie(i,j))  !mdis2=mdis0+(j-1)*mddis
             if(kodice_dist(ncop1).ne.0.or.
     1                  kodice_dist(ncop1).ne.1)then
                idsta1=kodice_dist(ncop1)
                nord2=nord_picco2_coppia(ncop1)   !nint(storeb(mdis2))
                if (idsta1.ne.0.and.idsta1.ne.1) then
                    intens_legati(nord1)=
     1                          intens_legati(nord1)+intnew(nord2) 
                    intsom(1,nord1)=intsom(1,nord1)+intnew(nord2)
                    intsom(2,nord1)=intsom(2,nord1)+intnew(nord2)
                endif
!                write(ncwu,*)'nord2,j(1-nleg),idsta2',nord2,j,idsta2
                nord(2)=nord2
                if(idsta1.eq.2.and.dist_coppia(ncop1).lt.1.7)then
                   nanell=nanell+1
                   legati(nanell)=nord2
!        write(ncwu,*)'nanell,legati ',nanell,(legati(ijk),ijk=1,nanell)
                endif
                atomo_in_angoli(nord1,j)=nang      !storeb(mcon2+2)=mangl
                     do k=1,3
                        d1(k)=distxyz_coppia(ncop1,k)   !storeb(m+j1)
                     enddo    
                     do k=2,nleg+1     !=1,nleg
                         if(k.eq.j)cycle
                         if(nang.ge.10000)cycle
                         ncop2=iabs(atomo_in_coppie(i,k))  !mdis2=mdis0+(k-1)*mddis
                         idsta2=kodice_dist(ncop2)
                         if (idsta2.ne.0.and.idsta2.ne.1) then !accetta legati e incompat.
                             nord3=nord_picco2_coppia(ncop2)   !nint(storeb(mdis3))
                             nord(3)=nord3
!          write(ncwu,*)'nord3,k(1-nleg),idsta3',nord3,k,idsta3
                             do  k1=1,3
                               d2(k1)=distxyz_coppia(ncop2,k1)    !storeb(m+j1)
                             enddo
                             call ang(d1,d2,angle)
                             deno=dist_coppia(ncop1)*dist_coppia(ncop2)
                             if(deno.le.1.0e-35)deno=1.0e-5
                             angle=angle/deno
                             if(angle.gt.1.and.angle.le.1.1)angle=1.0
                             if(angle.lt.-1.and.angle.ge.-1.1)angle=-1.0
                             angle=acos(angle)*rtod
!                      write(ncwu,*)' d1,d2,angle,deno ',d1,d2,angle,deno
                             iangle=int(angle)
                             if (nord3.ge.nord2) then 
!--controlla i chicken-wire                         
!         write(ncwu,*)'nord1,nord2,nord3,angle,in2,nang,idsta2,idsta3',
!     1   nord1,nord2,nord3,angle,in2,nang,idsta2,idsta3
                               if (idsta1.eq.2.and.idsta2.eq.2) then
       if(angle.gt.50.and.angle.lt.70)nchick(1)=nchick(1)+1
       if(angle.gt.110.and.angle.lt.130)nchick(2)=nchick(2)+1
       if(angle.gt.160.and.angle.lt.190)nchick(3)=nchick(3)+1
!       write(ncwu,*)'nchick(1),nchick(2),nchick(3)',
!     1nchick(1),nchick(2),nchick(3)
                               endif                           
!--                                    
                               in2=cntang(nord1,nord2,nord3,angle) !2=ok, -1=ko
!         write(ncwu,*)'nord1,nord2,nord3,angle,in2,nang,idsta2,idsta3',
!     1   nord1,nord2,nord3,angle,in2,nang,idsta2,idsta3
                               jn3=iabs(in2)
                               nnoo=nnum(jn3) 
                               nnum(jn3)=nnoo+1
                               do ll=1,3
                                 norang(ll,nang)=nord(ll)
                                 nnn=nord(ll)
                               norang(4,nang)=norang(4,nang)+intnew(nnn)
                               enddo
                               angolo(nang)=angle                  
!         write(ncwu,'(a,4i6,f8.2)')'nang,norang(1:3,nang),angolo(nang)',
!     1        nang,norang(1:3,nang),angolo(nang)
                               do ll=1,3
                                 nnn=nord(ll)
                                 l=nkook(jn3,nnn)+1
                                 if (l.le.maxangl)then
                     intsom(jn3,nnn)=intsom(jn3,nnn)+norang(4,nang)
                     if(intsom(jn3,nnn).ge.mini0)intsom(jn3,nnn)=mini0-1
                                   nkook(jn3,nnn)=l
                                   kooktab(jn3,l,nnn)=nang
                                 endif
                               enddo                  
                               nang=nang+1
                             endif                  
!
                             if (idsta1.eq.2.and.idsta2.eq.2) then
!--print                              
                                if (nord3.ge.nord2) then 
                                  ja=ja+1
                                  ist(1,ja)=nord2
                                  ist(2,ja)=nopsym_picco2_coppia(ncop1) !nop2*iccentr2
                                  ist(3,ja)=nord1
                                  ist(4,ja)=nord3
                                  ist(5,ja)=nopsym_picco2_coppia(ncop2) !nop3*iccentr3
                                  gt(ja)=angle
                                  if (ja.eq.2) then
                                    if (istat2.gt.1)
     *       write(ncwu,2)((ist(jg,jji),jg=1,5),gt(jji),jji=1,2)
                                    ja=0
                                  endif
                                endif
                             endif  
                         endif
                     enddo                                    
             endif                                                  
         enddo                                    
!--controlla se e' un centro di anello (6 angoli di 60, 6 di 120, 3 di 180)
!       write(ncwu,*)'nord1 ,nleg,nanell,nang60,nang120,nang180',nord1,
!     1  nleg,nanell,nchick(1),nchick(2),nchick(3)
         if(nanell.gt.30)nanell=30           
         if (nanell.ge.5) then
            if (nchick(1).ge.4.and.nchick(2).ge.4
     1         .and.nchick(3).ge.2)then
               npicen=npicen+1
               lpicen(1,npicen)=nord1
               lpicen(2,npicen)=nanell
               do j2=1,nanell
                  lpicen(j2+2,npicen)=legati(j2)
               enddo
            endif
         endif
!               
      enddo
!--print
      if (ja.gt.0.and.istat2.gt.1)
     1 write(ncwu,1)((ist(jg,ji),jg=1,5),gt(ji),ji=1,ja)
!
      if (kkverbo.eq.1) then
          if (npicen.gt.0) then
             do i=1,npicen
               nanell=lpicen(2,i)
               write(ncwu,'(a,i5,a,i3,a,6i4,/,20i4)')
     1          ' picco ',lpicen(1,i),
     1          ' nleg ',lpicen(2,i),' centro anello: '
     1          ,(lpicen(ii6,i),ii6=3,nanell+2)
             enddo
          endif
          write(ncwu,*)'stampa tabella intsom kooktab jn3=1 ko jn3=2 ok'
          do i=1,2
            write(ncwu,*) ' jn3=',i
            write(ncwu,*) ' picco) , intsom , no.ang , angoli ' 
            mini0=2**30
            do j=1,nats
               nkk=nkook(i,j)
               if(intsom(i,j).ge.mini0)intsom(i,j)=mini0-1
               write(ncwu,'(i5,")",i10,i5,10i6,/,95(21x,10i6,/))')
     1         j,intsom(i,j),nkk,(kooktab(i,ii,j),ii=1,nkk)
            enddo
          enddo
          write(ncwu,*)'calang fine nang=',nang
      endif
1     format(1x,('(',i4,'(',i6,')',
     1' - ',i4,' - ',i4,'(',i6,'))',f6.1,5x))
2     format(1x,2('(',i4,'(',i6,')',
     1' - ',i4,' - ',i4,'(',i6,'))',f6.1,5x))
5     format(/,1x,' bond angles in this interpretation',/)
      return
      end
!
!code for intclu
      subroutine intclu(ninc,nang,kaction)
      USE General
      USE Symmetry
      USE Atomi
      USE BuildStuff
!
      USE BuildModule
!
      common /pimpo/nAtmBlocc,focc,jumpcl,l15con,ihce,n3n
     1,vett(3,4),zatom(10),legacon(1000)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common /timetempo/ timeT(10)
      dimension nord(20),disnord(20)
      dimension d(3),sss(3),yy(3),x(3),z(3),ivvet(2)
!
!-- elimina i picchi da eliminare (kluster(n)<0 ) e accetta i buoni (kluster(n)>0 ) 
!
      kkverbo=0
!      if(ncyclevld.eq.34)kkverbo=1
!      write(ncwu,*)'intclu nats',nats 
      do i=1,nats
         maxnkook(i)=nkook(1,i)
         if(nkook(2,i).gt.nkook(1,i))maxnkook(i)=nkook(2,i)
         if(maxnkook(i).eq.0)maxnkook(i)=1
      enddo
      kluster(1:nats)=10000
      mini0=2**30
!--elimina i ghost (izpk(i)=-999999)
      do i=1,nats
         j = i
         if(izpk(i).eq.-999999)then
                 call elimpic(j)  
                 if(kkverbo.ge.1)
     1           write(ncwu,'(" Eliminato ghost",i5)')i
         endif
      enddo
!--elimina gli incompatibili con se stessi e con i pesanti
      if(ninc.gt.0)then
!         write(ncwu,*)'ninc=',ninc
          do i=1,ninc
              num1=incomp(1,i)
              num=incomp(2,i)
!             write(ncwu,*)'num1,num,npeahi ',num1,num,npeahi
!--elimina gli noautoconsistenti(solo quelli con occ=1.)
              if(incomp(1,i).eq.incomp(2,i))then
                 if(xyzbu(5,num).ge.1.0
     1              .and.izpk(num1).ne.-999999)then
                     call elimpic(num)
                     if(kkverbo.ge.1)
     1             write(ncwu,'(" Eliminato noautoconsistente",i5)')num          
                 endif
                 if(kkverbo.ge.1.and.incomp(1,i).le.incomp(2,i))
     1           write(ncwu,'(i5," incomnpatibile con",i5)')
     1           incomp(1,i),incomp(2,i)
              else
!--elimina gli incompatibili con i pesanti
                 numm=0
                 if(num1.le.npeahi.and.num.gt.npeahi)numm=num 
                 if(num.le.npeahi.and.num1.gt.npeahi)numm=num1 
                 if(numm.gt.0)then
                    izpk(numm)=-999999
                    call elimpic(numm)
                    if(kkverbo.ge.1)
     1              write(ncwu,'(" Eliminato near pesante",i5)')numm          
                 endif
              endif
          enddo
      endif
!
      if(nang.gt.0)then
!--elimina quegli con solo angoli ko (nkook(2,i)=0)
         do i=1,nats
            npea=icopf(i)
            if(npea.eq.0.and.
     1      nkook(1,i).gt.0.and.nkook(2,i).eq.0)then
               num=i
               call elimpic(num)
               if(kkverbo.ge.1)
     1         write(ncwu,*)' Eliminato picco con',
     1         ' solo angoli ko ',num          
            endif
         enddo
!--elimina i centri di anello in the chicken wire.
         if(npicen.gt.0)then
            nanellx=6
100         continue
            do ii=-npicen,-1
               i=iabs(ii)
!              write(ncwu,*)' i,lpicen ',i,(lpicen(iii,i),iii=1,8) 
               num=lpicen(1,i)
               if(num.gt.0.and.lpicen(2,i).ge.nanellx)then
                  nanell=lpicen(2,i)
!                 write(ncwu,*)' num nanell ',num,nanell 
                  do k=3,nanell+2
                     kpic=lpicen(k,i)
!                    write(ncwu,*)' kpic ',kpic 
                     do jj=-npicen,-1
                        j=iabs(jj)
!                       write(ncwu,*)' j,lpicen ',j,(lpicen(iii,j),iii=1,8) 
                        if(kpic.eq.lpicen(1,j))lpicen(1,j)=-lpicen(1,j)
                     enddo  
                  enddo  
                  call elimpic(num)
                  if (kkverbo.ge.1) then
              write(ncwu,'(" Eliminato centro-anello",i5,i3," legami")')
     *               num,nanell
                  endif
               endif
            enddo
         endif
200   continue
!--stampa   
         if(kkverbo.ge.1)then
         write(ncwu,*)'stampa tabella intnew intsom(ok) kooktab(ko)',
     1   ' (angoli non buoni)' 
         write(ncwu,*) 
     1   'picco) , intnew '
     1    , ',  intsom(ok) , intsom(ko) , no.ang(ko) , angoli(ko) ' 
         do kj=1,nats
            nkk=maxnkook(kj)
            write(ncwu,'(i5,")",3i10,i5,6i5,/,95(46x,6i5,/))')
     1      kj,intnew(kj),intsom(2,kj),intsom(1,kj),nkook(1,kj)
     1      ,(kooktab(1,ii,kj),ii=1,nkk)
         enddo
         endif
!--fine stampa
!-- sceglie il picco da eliminare
         if(nang.gt.0)then
            ninc0=1
1000        continue
            if(kkverbo.ge.1)then
              write(ncwu,*)'dopo 1000 kluster,nats',nats 
              write(ncwu,'(10i6)')(kluster(i),i=1,nats) 
            endif
            do i =1,nkgru
               nnor(1:1000)=0
               num=0
               k=0
               if(ninc.gt.0.and.ninc0.lt.ninc)then  
                  nnor(1)=incomp(1,ninc0)
                  nnor(2)=incomp(2,ninc0)
                  k=2
                  ninc0=ninc0+1
                  if(kluster(nnor(1)).lt.0.or.
     1             kluster(nnor(2)).lt.0)go to 1000
               else
                  if(kaction.gt.3)then
                     inf=1
                     isup=nats
                  else
                     inf=kvet(1,i)
                     isup=kvet(2,i)
                  endif
!                 write(ncwu,*)'nkgru,i,inf,isup ',nkgru,i,inf,isup 
                  do j=inf,isup
                     istmcl=kluster(j)
                     npea=icopf(j)
!                    write(ncwu,*) 'j,nkook(1,j),kblock(j),icopf(j),istmcl ', 
!     1              j,nkook(1,j),kblock(j),icopf(j),istmcl 
                     if(nkook(1,j).ne.0.and.kblock(j).eq.0.and.npea.eq.0
     1               .and.istmcl.gt.0)then
                         k=k+1
                         nnor(k)=j
                     endif
                  enddo
!                 write(ncwu,*) 'k,nnor',k,(nnor(ijj),ijj=1,k) 
               endif
               if(k.gt.0)then
                  if(kkverbo.ge.1)
     1            write(ncwu,*) 'k,nnor',k,(nnor(j),j=1,k) 
                  num=nnor(1)
                  if(k.gt.1)then
                    mini=mini0
                    nmini=0
                    do j=1,k
                       nn6=nnor(j)
                       istmcl=kluster(nn6)
!                      write(ncwu,*)'j,mini,nn6,intsom(2,nn6)',
!     1                j,mini,nn6,intsom(2,nn6)
                       if(mini.ge.intsom(2,nn6).and.istmcl.gt.0)then
                          mini=intsom(2,nn6) 
                          nmini=nn6
                       endif
                    enddo
                    if(nmini.eq.0)go to 1000
                    num=nmini
                  endif
                  if(kkverbo.ge.1)then
                    write(ncwu,*) 'num prima scelta ',num
                    write(ncwu,*) 'nkook(1-2,num)'
     1               ,nkook(1,num),nkook(2,num)
                    write(ncwu,*) 'maxnkook(num)',maxnkook(num)
                  endif
!--se forma un unico angolo ko, sceglie tra i tre picco che lo formano
                  if(nkook(1,num).eq.1)then
                     nkk=maxnkook(num)
                     do j=1,nkk
                       nangx=kooktab(1,j,num)
                       if(nangx.gt.0)then
                          num0=num
                          lll=1
                          do ll=1,3
                             if(norang(ll,nangx).ne.num)then
                                nord(lll)=norang(ll,nangx)
                                lll=lll+1
                             endif 
                          enddo
                          ipic1=nord(1)
                          ipic2=nord(2)
                          istmcl1=kluster(ipic1)
                          istmcl2=kluster(ipic2)
                          if (istmcl1.lt.0.and.istmcl2.lt.0)then
                             num=num0
                          else if (istmcl1.lt.0.and.istmcl2.gt.0)then
                             num=ipic2
                          else if (istmcl2.lt.0.and.istmcl1.gt.0)then
                             num=ipic1
                          else
                             if(nkook(1,ipic1).eq.1.
     1                       and.nkook(1,ipic2).eq.1)then
                               do ll=1,3
                                   nordd=norang(ll,nangx)
                                   if(intsom(2,num0).gt.intsom(2,nordd))
     1                             num0=nordd
                               enddo
                               num=num0
                             else
                               if (nkook(1,ipic1).eq.nkook(1,ipic2))then
                                 num0=ipic2
                                 if (intsom(2,ipic1).lt.intsom(2,ipic2))
     1                           num0=ipic1
                               else
                                 num0=ipic2
                                 if (nkook(1,ipic1).gt.nkook(1,ipic2))
     1                           num0=ipic1
                               endif
                             endif
                          endif
                       endif
                     enddo
                  endif
!-- elimina tutti gli angoli ko a cui apartiene num
!-- aggiorna kooktab e intsom
                  if(num.gt.0)then
                    if(kkverbo.ge.1)write(ncwu,*) ' Elimina picco',num
                    numnew=-num
                    call elimpic(numnew)
                    if(kkverbo.ge.1)then
                       write(ncwu,*)'dopo elimpic kluster',nats 
                       write(ncwu,'(10i6)')(kluster(iih),iih=1,nats) 
                    endif
!
!--stampa  
                    if(kkverbo.ge.1)then
                    write(ncwu,*)'stampa tabella intsom(ok) kooktab(ko)'
     1              ,' picco) , intnew ,  intsom(ok) ,',
     1              ' intsom(ko) , no.ang(ko) , angoli(ko)' 
                  do kj=1,nats
                  nkk=maxnkook(kj)
                  write(ncwu,'(i5,")",i7,2i9,i5,10i5,/,95(36x,10i5,/))')
     1            kj,intnew(kj),intsom(2,kj),intsom(1,kj),nkook(1,kj)
     1            ,(kooktab(1,ii,kj),ii=1,nkk)
                  enddo
                    endif
!                    
                    go to 1000
                  endif
               endif
            enddo
         endif
      endif
2000  continue
!-- controlla se qualcuno degli eliminati ha tutti gli angoli ok con gli
!-- accettati, se e' cosi lo riprende.
!      write(ncwu,*)'klusterprima',(kluster(i),i=1,nats)
      ireacc=1
      if(ireacc.eq.1.and.nang.gt.0)then
         do i=1,nats      
            if(kluster(i).eq.-20000.or.
     1         kluster(i).eq.-10000)then
!-- controlla se forma qualche angolo ko con i picchi gia accettati.
               num=i
               n500=maxnkook(num)
               if (n500.gt.0)then
                  do j=1,n500    !400
                     nnoo=0
                     if (kooktab(1,j,num).eq.0)cycle   !go to 400
                     nangg=iabs(kooktab(1,j,num))
!      write(ncwu,*)'num,nangg,norang',num,nangg,(norang(ll,nang),ll=1,3)
!                     nnoo=0
                     do ll=1,3
                        norr=norang(ll,nangg)
                        if (kluster(norr).gt.0)nnoo=nnoo+1
                     enddo
                     if (nnoo.eq.2)exit    !go to 300
                  enddo    !400
                  if(nnoo.eq.2)cycle     
               endif
               if(kkverbo.eq.1)write(ncwu,*)
     1         're-accettato num,kluster(num)',num,kluster(num)
                kluster(num)=10000   !storeb(mclus)=10000
            endif
         enddo   !300   
      endif
!--stampa  
      if(kkverbo.ge.1)then
         write(ncwu,*)'stampa tabella FInale intsom(ok) kooktab(ko) ',
     1   'picco) , intnew (angoli ko)'
     1   , ',  intsom(ok) , intsom(ko) , no.ang(ko) , angoli(ko) '
         do kj=1,nats
            nkk=maxnkook(kj)
            write(ncwu,'(i5,")",i7,2i9,i5,10i5,/,95(36x,10i5,/))')
     1      kj,intnew(kj),intsom(2,kj),intsom(1,kj),nkook(1,kj)
     1      ,(kooktab(1,ii,kj),ii=1,nkk)
         enddo
         write(ncwu,*)'kluster,nats',nats 
         write(ncwu,'(10i6)')(kluster(i),i=1,nats) 
      endif
!
!--controlla gli incompatibili
      if(ninc.lt.0)then
         if(kkverbo.ge.1)then
            write(ncwu,*)'kluster,nats',nats 
            write(ncwu,'(10i6)')(kluster(i),i=1,nats) 
         endif
         do i=1,ninc
            nleg1=0
            nleg2=0
            np1=incomp(1,i)
            np2=incomp(2,i)
            if(np1.ne.np2)then
               if(kluster(np1).gt.0.and.kluster(np2).gt.0)then
                  nleg1=legami_atomo(np1,1)
                  nleg2=legami_atomo(np2,1)
                  npx=np1
                  if(nleg1.gt.nleg2)npx=np2
                  kluster(npx)=-kluster(npx)
                  if(kkverbo.ge.1)then
                     write(ncwu,'(i5," incompatibile con",i5,
     1                  " Eliminato picco ",i4)')
     1                   incomp(1,i),incomp(2,i),npx
                  endif
               endif 
            endif 
         enddo
      endif
!--determina i fragmenti , crea la connettivita (storcl)
      call storcl() 
      return
      end
!
!code for storcl
      subroutine storcl()
      USE General
      USE Symmetry
      USE Atomi
      USE BuildStuff
      USE BuildModule
!
!-- crea la tabella conettivita lunga (Longconnect(1:nats,12))
      common /pimpo/nAtmBlocc,focc,jumpcl,l15con,ihce,n3n
     1,vett(3,4),zatom(10),legacon(1000)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common /timetempo/ timeT(10)
      dimension nord(100),disnord(100),kod_atomo(2000)
      dimension d(3),sss(3),yy(3),x(3),z(3),ivvet(2)
!
!-- riconosce i fragmenti e crea la connettivita in jconn tipo iconn e in
!-- LongConnect(nats,2+2*num_legami_max)
      kkverbo=0    !
!      if(ncyclevld.eq.72)kkverbo=1
      if(kkverbo.eq.1)then
      write(lo,*)'storcl kkverbo= ',kkverbo
      write(lo,'(a,/,8(10i6))')'inizio storcl: kluster  nats=',nats
      write(lo,'(10i7)')kluster(1:nats)
      write(lo,'(a,/,8(10i6))')'legami_atomo(1:nats,1) '
      write(lo,'(10i6)') legami_atomo(1:nats,1)
      write(lo,'(a,/,8(10i6))')'atomo_in_coppie(1:nats,1) '
      write(lo,'(10i6)') atomo_in_coppie(1:nats,1)
      endif
      mjconn=2
      ncopie=0
      numlx=2*num_legami_max+2
      LongConnect(:,:)=0
      kfrag=0
      kod_atomo(1:nats)=0   !conterra' 0/2/3 atomo da analizzare/sottoanalisi/fatto.
!
2100  continue
      ik=0
      do while (ik.eq.0)
         kfrag=kfrag+1
         ik=1
         ikk=1
!-- se c'e' un at. con kblock=1 parte da lui
         do nord1=1,nats
            if(kblock(nord1).eq.0) cycle
            nleg= legami_atomo(nord1,1)
            if(kluster(nord1).ne.10000
     1         .or.kod_atomo(nord1).ne.0) cycle
            if (nleg > 48) nleg = 48
            kluster(nord1)=30000+kfrag
            if(nleg.gt.0)then
               kod_atomo(nord1)=2  
               ikk=0
               exit
!                      go to 2200
            else if(nleg.eq.0)then
               kod_atomo(nord1)=3
               kluster(nord1)=-iabs(kluster(nord1))
               kfrag=kfrag+1
               cycle
!                      go to 2100
            endif
         enddo
!        write(lo,'(a,4(10i6))')'dopo kblock=1 ikk,ik ',ikk,ik
!        write(lo,'(a,4(10i6))')'dopo kblock=1 kluster ',kluster(1:nats)
!        write(lo,'(a,4(10i6))')'dopokblock kod_atomo ',kod_atomo(1:nats)
!
         if(ikk.ne.0)then    !nessun  blockato, prende il primo con legami libero
           do nord1=1,nats
              if(kblock(nord1).eq.1) cycle
              if(kluster(nord1).ne.10000.or.
     1            kod_atomo(nord1).ne.0) cycle
              nleg= legami_atomo(nord1,1)
!        write(lo,'(a,4(10i6))')'nord1,nleg ',nord1,nleg
              if(nleg.gt.0)then
                 kod_atomo(nord1)=2
                 kluster(nord1)=30000+kfrag
                 ikk=0
!                go to 2200
                 exit
              else
                 kod_atomo(nord1)=3
                 kluster(nord1)=-(30000+kfrag)
                 kfrag=kfrag+1
              endif
           enddo
!        write(lo,'(a,4(10i6))')'dopo kblock=0 ikk,ik ',ikk,ik
!        write(lo,'(a,4(10i6))')'dopo kblock=0 kluster ',kluster(1:nats)
!        write(lo,'(a,4(10i6))')'dopokblock kod_atomo ',kod_atomo(1:nats)
!          go to 2300
         endif
2200  continue
         do while (ikk.eq.0)
!        write(lo,'(a,4(10i6))')'2200 kluster ',kluster(1:nats)
!        write(lo,'(a,4(10i6))')'2200 kod_atomo ',kod_atomo(1:nats)
           ikk=1
           ichg=0
           do nord1=1,nats
             nn1=1
             if(kod_atomo(nord1).ne.2) cycle
!ha trovato il primo quindi sviluppa il fragmento
             kod_atomo(nord1)=3
             ichg=ichg+1
             kkfrag=jordfr(kluster(nord1))  
             nleg= legami_atomo(nord1,1)
             if(kkverbo.eq.1)
     1       write(lo,'(a,i5,4(10i6))')'nord1,legami_atomo(nord1,1:10) '
     1        ,nord1,legami_atomo(nord1,1:10)
             if(kkverbo.eq.1)
     1    write(lo,'(a,i5,4(10i6))')'nord1,atomo_in_coppie(nord1,1:10) '
     1        ,nord1,atomo_in_coppie(nord1,1:10)
             !if(nleg.gt.0)then
             z(1:3)=xyzbu(1:3,nord1)
             disnord(1:100)=0
             nord(1:100)=0
             nord(nn1)=nord1*100
             do j=1,nleg
                 ncopia2=legami_atomo(nord1,j+1) 
                 if(kkverbo.eq.1)
     1           write(lo,'(a,4(10i6))')'ncopia2,nord1 ',ncopia2,nord1
                 if(ncopia2.le.0)cycle 
                 nord2=nord_picco2_coppia(ncopia2)    !nint(storeb(mdis))
                 if(kkverbo.eq.1)write(lo,'(a,4(10i6))')
     1           'ncopia2,nord2,kod_atomo(nord2)'
     1           ,ncopia2,nord2,kod_atomo(nord2)
	           if(nord2.gt.0)then
                    if(kluster(nord2).gt.0)then
                       iss=1
                       dist=dist_coppia(ncopia2)
                       if(kod_atomo(nord2).eq.0)then
                          kod_atomo(nord2)=2
                          ikk=0
                          kluster(nord2)=30000+kkfrag
!                          write(lo,'(a,/,4(10i6))')'nord2 kluster ',
!     1                    nord2,kluster(1:nats)
!                          write(lo,'(a,/,4(10i6))')'nord2 kod_atomo ',
!     1                    nord2,kod_atomo(1:nats)
!-- muove nord2                                    
                          if(kblock(nord2).eq.0)then
                             cc=cpxyzbu(nord2,x) 
                             do k=1,nsymTot        !1050
                                ieqX=0
                                call  xequiTot(k, x, yy,ieqX)
                                do  n=1,3
                                   d(n)=0.
                                   sss(n)=0.
                                   d(n)=z(n)-yy(n)
                                enddo
                                call reddst(d,sss)
                                dist0=cdist(gdist,d,dist2)
!--qui cambia x  deve cambiare bij
                                iss=-1             
                                if(abs(dist0-dist).lt.0.01)then
                                   iss=1
                                   do kk=1,3
                                      yy(kk)=yy(kk)+sss(kk)
                                   enddo
                                   call chcoo(nord2,yy,-k)
                                   exit  !go  to 2222
                                endif
                             enddo
                             if(nz(nord2).le.0)then   !12set11
                                kod_atomo(nord2)=2
                                kluster(nord2)=-iabs(kluster(nord2))
                             endif
2222  continue                 
                          endif  
!                                                    
                       else if(kod_atomo(nord2).gt.0)then
                           if(kkverbo.eq.1)write(ncwu,*)
     1                     'gia accettato:nord2,kod_atomo(nord2),nord1'
     1                      ,nord2,kod_atomo(nord2),nord1
                            cc=cpxyzbu(nord2,x) 
                            do  n=1,3
                              d(n)=0.
                              sss(n)=0.
                              d(n)=z(n)-x(n)
                            enddo
                            dist0=cdist(gdist,d,dist2)
                            iss=1
                            if(abs(dist0-dist).gt.0.01)iss=-1
                            if(kkverbo.eq.1)then
                              write(ncwu,*)'nord1,z',nord1,z
                              write(ncwu,*)'nord2,x',nord2,x
                              write(ncwu,*)
     1                   'dist0,dist,kluster(nord2),kluster(nord1),iss',
     1                    dist0,dist,kluster(nord2),kluster(nord1),iss
                            endif  
                       endif  
!                      write(ncwu,*)' nord1,nn1,iss ' ,nord1,nn1,iss
                       if(iss.gt.0)then
!-------------------------------------------------------------------------                       
!-- appartengono allo stesso fragmento?
                          iaa=0
                          if(iaa.eq.1)then
                          kfra2=jordfr(kluster(nord2))
                          if(kkfrag.ne.kfra2)then
                             if(kod_atomo(nord2).eq.3)kod_atomo(nord2)=2
                             do ich=1,nats
                                  kfrich=jordfr(kluster(ich))
                                  if(kfrich.eq.kfra2)then
                                     isg=isign(1,kluster(ich))
                                     kl=iabs(kluster(ich)/10000)
                                     kluster(ich)=isg*(kl*10000+kkfrag)
                                     if(kod_atomo(ich).eq.3)
     1                                  kod_atomo(ich)=2
                                     if(kkverbo.eq.1)write(ncwu,*)
     1                              'cambia frag.,nord2,oldfrag,newfrag'
     1                               ,ich,kfra2,kkfrag,kluster(ich)
                                  endif
                               enddo
                          endif                                    
                          endif                                    
!-------------------------------------------------------------------------                       
!--
                          kop=0
                          do k=1,nn1
                             if(nord2.eq.(nord(k)/100))kop=kop+1
                          enddo
                          if(nz(nord2).gt.0)then   !12set11
                             nn1=nn1+1
                             nord(nn1)=nord2*100+kop
                             disnord(nn1)=dist
                          endif  
                       endif  
                    endif   !if(kluster(nord2).gt.0)
		         endif    !if(nord2.gt.0)  
             enddo   !1,nleg
             if(nn1.gt.num_legami_max+1)nn1=num_legami_max+1
             LongConnect(nord1,1)= nn1-1   !nleg
             LongConnect(nord1,2)= kfrag
             if(kkverbo.ge.1)
     1                  write(ncwu,*)' nord1,nleg,kfrag '
     1                 ,nord1,nn1-1,kfrag 
!                     mcon2=mcon2+3
             if(nn1.gt.1)then    !e' legato
                jj=3
                do  j=2,nn1
                   iok=0
                   if(j.gt.2)then
                        do j2=2,j-1
                           if(nord(j2)/100.eq.nord(j)/100)iok=1
                        enddo
                   endif
                   if(jj.ge.numlx-1)exit   ! 14nov11
                   LongConnect(nord1,jj)= nord(j)
                   LongConnect(nord1,jj+1)=nint(disnord(j)*1000)
                   if(kkverbo.ge.1)write(ncwu,*)'picchi legati: ',
     1                LongConnect(nord1,jj),disnord(j)
                   jj=jj+2
                   nordj=nord(j)/100
                   if(nord1.le.nordj)then    !crea jconn=iconn
                      if(iok.eq.0)then
                        jconn(mjconn  )=nord1   !storeb(m15con)=(nord1)
                        jconn(mjconn+1)=nordj   !storeb(m15con+1)=(nordj)
                        jconn(mjconn+2)=1       !storeb(m15con+2)=1
                        kcon=0
                        if(nAtmBlocc.gt.0)kon=konect0(nord1,nord2,kcon)
                        jconn(mjconn+2)=kcon
 !                      write(lo,*)'mjconn,jconn(mjconn:mjconn+2) ',
 !    1                  mjconn,jconn(mjconn:mjconn+2)
                        mjconn=mjconn+3
                        ncopie=ncopie+1
                      endif  
                   endif  
                enddo
             else  ! nn1.eq.1 quindi nord1 ÃƒÂ¨ isolato
                kluster(nord1)=-iabs(kluster(nord1))
                kod_atomo(nord1)=3
             endif  !fine if(nn1.gt.1)
             if(ikk.eq.0)exit
           enddo     !nord1=1,nats
         enddo     !do while ikk=0
!--controlla se kfrag e' un fragmento vuoto.
         ia=0
         do j=1,nats
            ilocal=iabs(kluster(j))
            ibbb=mod(ilocal,30000)
            if(ibbb.eq.kfrag)ia=ia+1
         enddo
         if(ia.eq.0)kfrag=kfrag-1
         do j=1,nats
            if(kod_atomo(j).eq.0.and.kluster(j).gt.0)ik=0
         enddo
      enddo !do while  ik=0       
2300  continue
      jconn(1)=ncopie      !storeb(l15con)=ncopie
      if(kkverbo.ge.1)then
      nncopp=1+3*ncopie
      write(ncwu,*)'storcl connettivita (jconn), ncopie',jconn(1)
      write(ncwu,'(3(3i6,4x))')
     1 (jconn(ll),ll=2,nncopp)
      endif
!
!--picchi isolati
!      write(ncwu,*)'intcl lclus ,ldum prima degli isolati'
!      write(ncwu,'(10i6)')(istoreb(i),i=lclus,lclus+nats-1) 
!      write(ncwu,'(10i6)')(istoreb(i),i=ldum,ldum+nats-1) 
!      write(ncwu,*)'picchi isolati'
!             write(ncwu,*)'npeahi,ngl,n3n',npeahi,ngl,n3n
!      write(lo,'(a,4(10i6))')'picchi isolati kluster ',kluster(1:nats)
      do i=1,nats
         npea=icopf(i)
         if(iabs(kluster(i)).ge.10000
     1   .and.kod_atomo(i).eq.0)then
           kfrag=kfrag+1
           iss=isign(1,kluster(i))
!               write(ncwu,*)'i,istoreb(lclus+i-1),kfrag,iss'
!     1         ,i,istoreb(lclus+i-1),kfrag,iss
           if(npea.eq.0.and.kblock(i).ne.1)then
              nleg=LongConnect(nord1,1)
!              write(ncwu,*)'i,nleg,kluster(i)',i,nleg,kluster(i)
              if(nleg.eq.0)iss=-1    !isolato
              if(ngl.lt.n3n)iss=-1
           endif
           kluster(i)=iss*iabs(kluster(i))
           if(iabs(kluster(i)).eq.10000)kluster(i)=iss*(30000+kfrag)
           LongConnect(i,1)=0
           kod_atomo(i)=3
           if(iss.eq.1)LongConnect(i,2)=kfrag
         endif
      enddo         
!
      nfrag=kfrag
  400     format(i5,5f10.3,3i7)
 !         write(lo,*)'storcl i,xyzbu,kblock,nz,izpk '
      do i=1,nats
 !       write(lo,400) i,(xyzbu(j,i),j=1,5),kblock(i),nz(i),izpk(i)
         ia=kluster(i)
         if(ia.gt.0)then
            ibbb=mod(ia,30000)
            if(ibbb.gt.0)numfr(ibbb)=numfr(ibbb)+1
         endif
      enddo
      if(kkverbo.ge.1)then
         write(ncwu,*)' alla  fine di storcl' 
         write(ncwu,*)'numfr,nfrag',nfrag 
         write(ncwu,'(10i6)')(numfr(i),i=1,nfrag) 
         write(ncwu,*)'storcl kluster,nats',nats 
         write(ncwu,'(10i6)')(kluster(i),i=1,nats)
         write(ncwu,'(a)')'LongConnect'
         do i=1,nats
            write(ncwu,'(3i5,2x,26i6)')
     1       i,LongConnect(i,1:2),LongConnect(i,3:26)
         enddo 
         write(ncwu,*)'fine storcl' 
      endif
!      write(ncwu,*)'fine storcl' 
      return
      end
!
!code for elimpic
      subroutine elimpic(numb)
      USE Atomi
      USE BuildModule
      USE BuildStuff
!
      common /pimpo/nAtmBlocc,focc,jumpcl,l15con,ihce,n3n
     1,vett(3,4),zatom(10),legacon(1000)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
!
!      write(ncwu,*)' elimpic numb=',numb
      ivalmclus=-10000
      if (numb.lt.0)then
          numb=-numb
          ivalmclus=-20000
      endif
!      write(ncwu,*)'picco da eliminare  ',numb
      kluster(numb)=ivalmclus 
      nelim=0
      n500=maxnkook(numb)
      if (n500.gt.0)then
         do j=1,n500
            if (kooktab(1,j,numb).gt.0)then
               nelim=nelim+1
               kelimang=kooktab(1,j,numb)
!           write(ncwu,*)' elimina kelimang;',kelimang
!           write(ncwu,*)' nkook(1,numb)',nkook(1,numb)
!           write(ncwu,*)' maxnkook(numb)',maxnkook(numb)
!--elimina da kooktab
               do ij=1,2
                  do ik=1,nats
                  m500=maxnkook(ik)
!           write(ncwu,*)' ij,ik,nkook(ij,ik) ',ij,ik,nkook(ij,ik)
                    if (m500.gt.0)then
                       do ii=1,m500
                        if (kooktab(ij,ii,ik).eq.kelimang)then
                          nkook(ij,ik)=nkook(ij,ik)-1
                          kooktab(ij,ii,ik)=-kelimang
                          intsom(ij,ik)=intsom(ij,ik)-norang(4,kelimang)
!      write(ncwu,*)'eliminato kelimang da picco ik,posizione ii',ik,ii
                        endif
                       enddo
!           write(ncwu,*)' nkook(ij,ik) dopo',nkook(ij,ik)
                    endif
                  enddo 
               enddo 
            endif
         enddo
      endif
!      write(ncwu,*)'fine elimpic'
      return
      end
!
!code for jordfr
      function jordfr(m)
      jordfr=0
      if(m.eq.-999999)return
      if(m.gt.0.and.m.lt.10000)return
      mm=iabs(m)
      jordfr=mm-(mm/10000)*10000
      return
      end
!
!code for jchgordfr
      function jchgordfr(kdfrag,lfrnew)
      jchgordfr=kdfrag
      if(kdfrag.eq.-999999.or.kdfrag.eq.0)return
      js1=isign(1,kdfrag)
      jchgordfr=js1*((iabs(kdfrag/10000)*10000)+lfrnew)
      return
      end
!
!code for jcod
      function jcod(m)
      jcod=m/10000
      return
      end
!
!code for cntang
      function cntang(nord1,nord2,nord3,angle)
      USE BuildStuff
      USE BuildModule
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
!--      cntang=2  angle ok
!--      cntang=-1 angle non buono
      cntang=2
      ii=icogr(nord1)
      i=ive(ii)
      if(i.lt.1.or.i.gt.3)then
         write(ncwu,*)'stop in build cntang',i,nord1,nord2,nord3
         call cstop( 'Programming error in CNTANG' )
      endif
!      write(ncwu,*)'nord1,icogr(nord1)=ii,ive(ii)=i,angi(i),angs(i)',
!     1nord1,icogr(nord1),ive(ii),angi(i),angs(i)
      if(angle.ge.angi(i).and.angle.le.angs(i))return
      cntang=-1
      return
      end
!
!code for stclu
      subroutine stclu(stored,ndim,icodpr,nn15)
      USE General                 !!!
      USE Atomi
      USE BuildStuff
      USE BuildModule
!
      character*1 ibb,iapi,iop
      character*5 line(13),ib,iring(13),ia
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension iop(13,80)
      dimension nord(13,80)
      dimension stored(ndim)
      data ib/'     '/ ,ia/'   * '/
      ibb=' '
      iapi='*'
      istam=1
      jpic=0
      jisol=0
!      write(ncwu,*)'stclu inizia '
      if (istat2.gt.0) write(ncwu,770)
      do k=1,nfrag
!        write(ncwu,*)'stclu,k,numfr(k),nfrag',k,numfr(k),nfrag
         ifin=numfr(k)
         if (ifin.le.0) cycle
!      write(ncwu,*)'stclu frag con numfr(nfrag)=0: ',k,numfr(k),nfrag
         if (ifin.eq.1) then   !atomi isolati
            do jj=1,nats
                 nleg=LongConnect(jj,1) 
                 kfrag=LongConnect(jj,2) 
                    if(kluster(jj).gt.0.and.kfrag.eq.k)then 
                      jisol=jisol+1
                      isol(jisol)=jj
                      cycle
                    endif
            enddo
         else
            if(ifin.le.4)then
               jpic=jpic+1
               jfrag(jpic)=k
               cycle
            endif
            if(icodpr.ne.-1)then
                icodpr=k
                if(nats.lt.100)call cluprz(stored,ndim,icodpr,nn15)
            endif
25          continue
            if (istat2.gt.0) write(ncwu,1) k,numfr(k)
            nnm=0
            jring=0
            iring(:)=ib
            nord(:,:)=0
            jj=0
            kch=k
            jprint=0
            do  kk=1,nats   !1100
               if(jj.lt.13) then  !go to 1300
                 if(kluster(kk).le.0) cycle
                 nleg=LongConnect(kk,1) 
                 kfrag=LongConnect(kk,2) 
                 if(kfrag.ne.k)cycle
                 nn1=1
                 jj=jj+1
                 nord(jj,nn1)=kk
1102             continue
                 nleg1=nleg+1
                 nnm=max(nnm,nleg1)
                 nn=3
                 do jk=1,nleg
                   nn1=nn1+1
                   nord(jj,nn1)=LongConnect(kk,nn)
                   iop(jj,nn1)=' '    !ibb
                   if(nn1.gt.2)then
                      do ik=1,nn1-1
                        mm=nord(jj,ik)
                        if(ik.gt.1)mm=mm/100
                        if(nord(jj,nn1)/100.eq.mm)iop(jj,nn1)="'"  !iapi
                      enddo    
                   endif                    
                   nn=nn+2
                 enddo
 1201            if(jj.lt.13) cycle    !go to 1100
 1300      continue
               endif
               if (istat2.gt.0)write(ncwu,600)(nord(i,1),i=1,jj)
               nline=0
               do i=2,nnm
                  do j=1,13
                     line(j)=ib
                     nn=nord(j,i)/100
                     if(nord(j,i).ne.0.and.istat2.gt.0)
!     *                  write(line(j),550)nord(j,i),iop(j,i)
     *                  write(line(j),550)nn,iop(j,i)
                  enddo
                  nline=nline+1
                  if (istat2.gt.0) then
                      if (nline.eq.1) then
                          write(ncwu,700)(line(j),j=1,13)
                      else
                          write(ncwu,750)(line(j),j=1,13)
                      endif
                  endif
               enddo
               if(jring.eq.1.and.istat2.gt.0)
     1             write(ncwu,710)(iring(j),j=1,13)
               nnm=0
               jj=0
               jring=0
               iring(:)=ib
               nord(:,:)=0
            enddo   !1100
            if (jj.ne.0) then
            if (istat2.gt.0)write(ncwu,600)(nord(i,1),i=1,jj)
            nline=0
              do i=2,nnm
                do j=1,13
                   line(j)=ib
                   nn=nord(j,i)/100
                   if(nord(j,i).ne.0.and.istat2.gt.0)
!     *             write(line(j),550)nord(j,i),iop(j,i)
     *                  write(line(j),550)nn,iop(j,i)
                enddo
                nline=nline+1
                if (istat2.gt.0) then
                  if (nline.eq.1) then
                      write(ncwu,700)(line(j),j=1,13)
                  else
                      write(ncwu,750)(line(j),j=1,13)
                  endif
                endif
              enddo     
              if(jring.eq.1.and.istat2.gt.0)
     1                 write(ncwu,710)(iring(j),j=1,13)
            endif
 3000                continue
         endif
      enddo   
      if(jpic.ne.0)then   !go to 6000
!        write(ncwu,*)'jpic,jfrag(jpic)',jpic,(jfrag(j),j=1,jpic)
         if (istat2.gt.0) write(ncwu,2)
         do i=1,13
            iring(i)=ibb
            do ii=1,20
              nord(i,ii)=0
            enddo
         enddo
         jj=0
         nnm=0
         do j=1,jpic   !5000
            k=jfrag(j)
            ifin=numfr(k)
            nfind=0
            do jnj=1,nats   !5500
               nleg=LongConnect(jnj,1) 
               kfrag=LongConnect(jnj,2) 
               if(kfrag.ne.k)cycle
               if(ifin.eq.nfind)exit 
               if(jj.lt.13)then    !go to 5300
                   nn1=1
                   jj=jj+1
                   nfind=nfind+1
                   nord(jj,nn1)=jnj
                   write(iring(jj),550)k
                   nleg1=nleg+1
                   nnm=max(nnm,nleg1)
                   nn=3
                   do jk=1,nleg
                      nn1=nn1+1
                      nord(jj,nn1)=LongConnect(jnj,nn)
                      nn3=nord(jj,nn1)/100
                      iop(jj,nn1)=' '   !ibb
                   if(nn1.gt.2)then
                      do ik=1,nn1-1
                        mm=nord(jj,ik)
                        if(ik.gt.1)mm=mm/100
                        if(nord(jj,nn1)/100.eq.mm)iop(jj,nn1)="'"  !iapi
                      enddo    
                   endif                    
                      nn=nn+2
                   enddo
!                  write(ncwu,*)'jj,nord(jj,)',jj,(nord(jji,1),jji=1,nn1)
                   if(jj.lt.13)cycle
               endif
5300           continue
               if (istat2.gt.0)write(ncwu,600)(nord(i,1),i=1,jj)
               nline=0
               do i=2,nnm
                  do ii=1,13
                     line(ii)=ib
                     nn=nord(ii,i)/100
                     if(nord(ii,i).ne.0.and.istat2.gt.0)
!     *               write(line(ii),550)nord(ii,i),iop(ii,i)
     *               write(line(ii),550)nn,iop(ii,i)
                  enddo
                  nline=nline+1
                  if (istat2.gt.0) then
                     if (nline.eq.1) then
                        write(ncwu,700)(line(ii),ii=1,13)
                     else
                        write(ncwu,750)(line(ii),ii=1,13)
                     endif
                  endif
               enddo
               if(istat2.gt.0)write(ncwu,711)(iring(ii),ii=1,13)
               nnm=0
               jj=0
               jring=0
               do i1=1,13
                  iring(i1)=ib
                  do j1=1,20
                     nord(i1,j1)=0
                  enddo
               enddo
            enddo   !5500
5005        continue
         enddo  !5000
         if (jj.ne.0)then
         if (istat2.gt.0)write(ncwu,600)(nord(i,1),i=1,jj)
             nline=0
             do i=2,nnm
                do ii=1,13
                   line(ii)=ib
                   nn=nord(ii,i)/100
                   if(nord(ii,i).ne.0.and.istat2.gt.0)
!     *            write(line(ii),550)nord(ii,i),iop(ii,i)
     *             write(line(ii),550)nn,iop(ii,i)
                enddo
                nline=nline+1
                if (istat2.gt.0) then
                     if (nline.eq.1) then
                         write(ncwu,700)(line(ii),ii=1,13)
                     else
                         write(ncwu,750)(line(ii),ii=1,13)
                     endif
                endif
             enddo
             if(istat2.gt.0)write(ncwu,711)(iring(ii),ii=1,13)
         endif                 
      endif                 
6000  continue
      if (istat2.gt.0.and.jisol.gt.0) then
         if (jisol.eq.1) then
                           write(ncwu,3)isol(1)
                         else
                           write(ncwu,4)(isol(i),i=1,jisol)
                         endif
                      endif
    1 format(/,1h , 76('-'),/,
     *1x,'fragment number ',i3,' ,',i5,' peaks included')
    2 format(/,1h , 76('-'),/,
     *1x,' fragments with less than five peaks')
    3 format(/,1h , 76('-'),/,
     *1x,' peak number ',i5,' is isolated')
    4 format(/,1h , 76('-'),/,
     *1x,'The following peaks are isolated : ',8i5,/,5(36x,8i5,/))
  550 format(i4,a1)
  600 format(//,1x,'     peak',13(i4,1x))
  700 format(1x,'linked to',13a5)
  710 format(1x,' ring    ',13a5)
  711 format(1x,' fragment',13a5)
  750 format(10x,13a5)
  770 format(1h )
!      write(ncwu,*)'stclu fine '
      return
      end
!
!code for cluprz
      subroutine cluprz(stored,ndim,icodpr,nats025)
      USE General
      USE Atomi
      USE BuildModule
      USE BuildStuff
!
!--interface between cluster and projection routine
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
!
      common/workc/ggg(9),ggr(9),x1(6),x2(6),x3(6),x4(6),x5(6),x6(6),
     1          eval(3),eve(3,3),ever(3,3),
     2          ainer(3,3),vv(3),vr(3),
     3          caa(3,3),xb(3),varxb(3,3),
     4          gg(3,3),gr(3,3),varian(4),l28,m28,md28,n28,
     5          l25,m25,md25,n25,icomc(59)
      dimension gg1(18)
      dimension stored(ndim)
!--
      if(icodpr.eq.-1) return
      if(nats.le.3.or.nats.gt.100) return
      istat3=istat2
      istat2=0
      nats025=0
      nats25=0
!
      do n=1,nats26
         j=xyzs26(5,n)
         if(icodpr.ne.0.and.j.ne.icodpr)cycle
         if(n.le.nats)nats025=nats025+1
         nats25=nats25+1
         xyzs25(1:5,nats25)=xyzs26(1:5,n)
      enddo
      if(nats25.eq.0)return
      if(lproj.eq.0) then
         call xpqmMNQD(ier)
      else
         ever=xortr
      endif
      if(icodpr.ne.0) nprojj=1
      call sprzsm(stored,ndim,nprojj,icodpr,nats025)
4000  continue
      istat2=istat3
      return
      end
!
!code for sprzsm
      subroutine sprzsm(stored,ndim,iplo,icodpr,n025)
      USE General
      USE BuildModule
      USE BuildStuff
      USE Atomi
!--plot the atoms on the lpt device
!  iplo = 1  on least squares plane
!       = 2  on least and on most squares plane
!  icodpr = -1 non fa la proiezione
!            0 proietta tutti gli atomi e controlla
!              scala
!            n proietta l'n-esimo frammento
!
      dimension  xmax_merc(3), xmin_merc(3),ind(3)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/workc/ggg(9),ggr(9),x1(6),x2(6),x3(6),x4(6),x5(6),x6(6),
     1          eval(3),eve(3,3),ever(3,3),
     2          ainer(3,3),vv(3),vr(3),
     3          caa(3,3),xb(3),varxb(3,3),
     4          gg(3,3),gr(3,3),varian(4),l28,m28,md28,n28
     5          ,l25,m25,md25,n25,icomc(59)
!      dimension line(78)
      character*80 line
!	character*2 ibchar
!	data ibchar/' '/
!
      dimension stored(ndim)
!      read(ibchar,'(a1)')ib
!--
      xmax_merc(1:3)=-100000.    
      xmin_merc(1:3)= 100000.
      if(lproj.eq.0) then
         ind(1)=3
         ind(2)=2
         ind(3)=1
      else
         ind(1)=1
         ind(2)=2
         ind(3)=3
      endif
!      write(ncwu,'(a)')'k,xyzs25(1:3,k)'
      do k=1,nats25
         do i=1,3
            x2(i)=xyzs25(i,k)
         enddo   
         do i=1,3
            x3(i)=0.0
            l=ind(i)
            do j=1,3
              x3(i)=x3(i)+x2(j)*ever(l,j)
            enddo  
            xmax_merc(i)=amax1(xmax_merc(i),x3(i))
            xmin_merc(i)=amin1(xmin_merc(i),x3(i))
         enddo
            xyzs25(1:3,k)=x3(1:3)
!            write(lo,'(i5,3f8.3,i10)')k,xyzs25(1:3,k)
      enddo   
      iex=0
!--number of lines per inch on lineprinter
      aln=6
      nnn=0
      orizmx=78.0
      if(lproj.eq.0) then
        n1 = 2
        n2 = 1
        if (orizmx/(xmax_merc(n2)-xmin_merc(n2)).lt.2.0/0.254)then  !go to 1190
           n1 = 1
           n2 = 2
        endif
1190    amax = amax1(xmax_merc(n2)-xmin_merc(n2), 
     *               xmax_merc(n2+1)-xmin_merc(n2+1))
      else if(lproj.eq.3) then
        n1 = 2
        n2 = 1
        if (orizmx/(xmax_merc(n2)-xmin_merc(n2)).lt.2.0/0.254)then  !go to 1191
          n1 = 1
          n2 = 2
        endif  
1191    amax = amax1(xmax_merc(n2)-xmin_merc(n2), 
     *               xmax_merc(n1)-xmin_merc(n1))
      else if(lproj.eq.1) then
        n1 = 2
        n2 = 3
        if (orizmx/(xmax_merc(n2)-xmin_merc(n2)).lt.2.0/0.254)then  !go to 1192
           n1 = 3
           n2 = 2
        endif   
1192    amax = amax1(xmax_merc(n2)-xmin_merc(n2), 
     *               xmax_merc(n1)-xmin_merc(n1))
      else if(lproj.eq.2) then
        n1 = 1
        n2 = 3
        if (orizmx/(xmax_merc(n2)-xmin_merc(n2)).lt.2.0/0.254)then  !go to 1193
           n1 = 3
           n2 = 1
        endif
1193    amax = amax1(xmax_merc(n2)-xmin_merc(n2), 
     *               xmax_merc(n1)-xmin_merc(n1))
      endif
!--calculate scale factor to fill page or give 2.5 cms/a
      scale = amin1(orizmx/amax, 2.5/0.254)
      scl = 0.254 * scale
!      if(icodpr.gt.0) goto 1200
      if(icodpr.le.0.and.scl.gt.2.0) icodpr=-1
!--sort peaks in order of plotting
 1200 jump=-n1    !-(n1+2)
      ndimension=nats25*5  
      stored=0.
      m=1
      do icopy=1,nats25
         stored(m:m+4)=xyzs25(1:5,icopy)
         m=m+5
      enddo
      call sortz_dyn(stored,ndim,1,nats25,5,jump)
      m=1
!      write(lo,'(a,i2,3f8.3)')'icopy,xyzs25(1:5,icopy),n1,scale,scl,aln'
!     1,n1,scale,scl,aln
!      write(lo,'(a,i2,3f8.3)')'icopy,xyzs25(1:5,icopy)'
      do icopy=1,nats25
         xyzs25(1:5,icopy)=stored(m:m+4)
!         write(lo,'(i5,5f10.3)')icopy,xyzs25(1:5,icopy)
         m=m+5
      enddo
      stored(:)=0.
! print
!      call sortz(l25,n25,md25,jump)
!--output heading and plot peaks
      nnn=nnn+1
      if (icodpr.le.0) then
         write(ncwu,1214)
      else
         write(ncwu,1215) icodpr
      endif
 1214 format(//,1h ,21(1h-),' overall plot of the structure  ',
     125(1h-))
 1215 format(//,1h ,21(1h-),'  partial plot for fragment ',i3,
     1 1x,25(1h-))
      if (iex.eq.0) then
         write(ncwu,1035) scl
      else
         write(ncwu,1036) scl
      endif
 1035 format(1h ,12(1h-),' projection on l.s.q. plane ---- scale :'
     *,f6.2,' cms/a  ',12(1h-))
 1036 format(1h ,12(1h-),'projection on m.s.q. plane ---- scale :'
     *,f6.2,' cms/a  ',12(1h-))
      do j=1,3
         write(ncwu,1380)
      enddo
 1380 format(2h  )
      ix=0
      offset = 0.5 * (orizmx - (xmax_merc(n2) 
     *                       - xmin_merc(n2)) * scale) + 1.5
      norizmx=nint(orizmx)
!      line(:)=ib
!      nord=nfld
!      do j=nord,nord+norizmx-1
!      line(j-nord+1)=ib
!      stored(j)=0
!      stored(j+norizmx)=0
!      enddo
!
      line=' '
      nord=1
      ndat=0
      do i=1,nats25
         x2(1:3)=xyzs25(1:3,i)
         ixrel = 0.1 * aln * scale * (xmax_merc(n1)-x2(n1)) 
     *                                 - float(ix) + 0.5
!         write(lo,'(a,3i5,2f10.3)')'i,ixrel,n1,xmax_merc(n1),x2(n1)',
!     1   i,ixrel,n1,xmax_merc(n1),x2(n1) 
         if(ixrel.gt.0)then
            if(ndat.gt.80)ndat=80
            call stline(stored,ndim,ndat,n025,line)
            line=' '
            stored=0
            ndat=0
         endif
         ndat=ndat+1
         nn=2*ndat-1
         ix2=scale*(x2(n2)-xmin_merc(n2))+offset
         if(ix2.gt.norizmx)ix2=norizmx
         if(ix2.le.0)ix2=1
         stored(nn)=ix2       !posizione nella linea
         stored(nn+1)=xyzs25(4,i) !n.ordine
!        write(ncwu,'(a,2f10.2)')' nord,stored(nord),stored(nord+1)',
!     1 nn,stored(nn),stored(nn+1)
         ix=ix+ixrel
      enddo
      if(ndat.gt.80)ndat=80
      call stline(stored,ndim,ndat,n025,line)
      line=' '
      stored=0.
      return
      end
!
!code for stline
      subroutine stline(stored,ndim,ndati,nats025,line)
      USE General
      USE BuildModule
      USE BuildStuff
      USE Atomi
!      character *2 blank,star,minus
!      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension itab(78,4), stored(ndim)
      character *80 line,follow
!
!-- sort the peaks in decreasing horizontal order
      jump=-1
      call sortz_dyn(stored,ndim,1,ndati,2,jump)
      jlast=78
      mlf=-1
      do i=1,ndati
         mlf=mlf+2
         itab(i,1)=nint(stored(mlf  ))
         itab(i,2)=nint(stored(mlf+1))
         itab(i,3)=jlast
         k1=itab(i,2)
         ncifre=1
         if (k1.le.nats) then
           if (k1.ge.10) ncifre=2
           if (k1.ge.100) ncifre=3
         endif
         itab(i,4)=ncifre
!         write(lo,'(a,i5,4i10)')' i,itab(i,1:4) ', i,itab(i,1:4)
         if (itab(i,1).gt.jlast) itab(i,1)=jlast
         jlast=itab(i,1)-ncifre
         if (jlast.ge.0) cycle
         if (itab(i,3).ge.itab(i,1)+ncifre-1) then
           itab(i,1)=itab(i,1)+ncifre-1
           jlast=itab(i,1)-ncifre
           if(jlast.lt.0)jlast=0
           ndati=i-1
           exit   !go to 199
         endif
         if(i.gt.1)then
            i0=i
            do ll=1,i0-1
               iexit=0
               l=i0-ll
               if ((itab(l,1)-itab(l,3)).ge.jlast) cycle
               iexit=1
               itab(l,1)=itab(l,1)-jlast
               l0=l
               do k=l0+1,i
                  itab(k,1)=itab(k,1)-jlast
                  itab(k,3)=itab(k,3)-jlast
               enddo   
               jlast=itab(i0,1)
!      write(lo,'(a,i5,4i10)')' i,iexit,itab(i,1:4) ',i,iexit,itab(i,1:4)
               exit
            enddo
            if(iexit.eq.1) exit
         endif
         itab(i,1)=0
      enddo
      do i=1,ndati
         j=itab(i,1)
         k=itab(i,2)
         ncifre=itab(i,4)
         if (j.le.0) cycle
         follow=''
         if (k.gt.nats) then
                  if (j.le.78)follow(1:1)='*'
                  kini=1
                  kfin=1
         else
                  write(follow,'(i3)')k
                  kini=3-ncifre+1
                  kfin=3
         endif
         line(j:j+kfin-kini)=follow(kini:kfin)
      enddo
       write(lo,'(a)')line
      return
      end
!
!code for bonder
      subroutine bonder(nAtmBlocc)
      USE General
      USE Atomi
      USE BuildStuff
      USE BuildModule
!
!-- calcola la posizione delle stelline che rappresentano il legame.
!
      integer :: size26
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension d(3),d2(3)
!
       size26 = size(xyzs26(1,:))
       nn=2+2*num_legami_max
!        write(lo,'(a,i5)')' i,longconnect(i,1:nn) nn=',nn
!      do i=1,nats
!        write(lo,'(3i5,2x,24i5)')i,longconnect(i,1:nn)
!      enddo
      numb=3
      nats26=nats+1
      if (nats.gt.100) numb=2
      if (nats.gt.300) numb=1
!        write(lo,'(a)')'bonder i,xyzs26 '
      do i=1,nats
        xyzs26(1:3,i)=xyzbu(1:3,i)
        xyzs26(4,i)=i
        xyzs26(5,i)=LongConnect(i,2)  !nfrag
!        write(lo,'(i5,5f10.3)')i,xyzs26(1:5,i)
      enddo
      do kkk=1,nfrag
         do k=1,nats
            if(nz(k).le.0)cycle  ! 12set11
            if(LongConnect(k,1).eq.0.or.LongConnect(k,2).ne.kkk) cycle
            nord1=k
            nleg=LongConnect(nord1,1)
            if(nleg.le.0)cycle  ! 14nov11
            nfr=LongConnect(nord1,2)
            nl=2*nleg+2
            do j=3,nl,2    ! 1750
               nord2=LongConnect(k,j)/100
               if(nord2.eq.0)cycle
               if(nord2*100.ne.LongConnect(k,j))cycle
               if(nz(nord2).le.0)cycle  !12set11
               if(nord2.lt.nord1)cycle
               do  i=1,3
                 d2(i)=xyzs26(i,nord1)-xyzs26(i,nord2)
                 d(i)=d2(i)/numb
               enddo
!--Mette le estelle
               if (numb.lt.3) cycle
             dist0 = cdist(gdist, d2, dist2)
!      write(lo,'(a,3i5,f8.3)')'bonder nats,nord1,nord2,dist0 '
!     1,nats,nord1,nord2,dist0
               ll=nord1
               do ii=1,numb-1
                  do i=1,3
                    xyzs26(i,nats26)=xyzs26(i,ll)-d(i)
                  enddo
                  xyzs26(4,nats26)=nats26
                  xyzs26(5,nats26)=kkk
                  ll=nats26
                  nats26=nats26+1
                  if (nats26 > size26) then
                      nats26=nats26-1
                      exit
                  endif
               enddo
            enddo   
         enddo  
      enddo   
      nats26=nats26-1
!      write(lo,'(a,2i5,5f10.3)')'bonder nats,nats26 ',nats,nats26
!      do i=1,nats26
!        write(lo,'(i5,5f10.3)')i,xyzs26(1:5,i)
!      enddo
      return
      end
!
!code for chcoo
      subroutine chcoo(nord2,yyy,nopp)
      USE Atomi
      USE BuildModule
      USE BuildStuff
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension yyy(3)
      do   ll=1,3
      xyzbu(ll,nord2)=yyy(ll)
      enddo
      if (IsoAniso(nord2).eq.1)then   !! gianluca 25/06/2004
          call chbij(nord2,nopp)
      endif
!      write(ncwu,*)'fine chcoo'
      return
      end
!
!code for chcoor
      subroutine chcoor(nord2,yyy,nopp)
      USE Atomi
      USE BuildModule
      USE BuildStuff
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension yyy(3)
!      write(ncwu,*)' chcoor nord2, old ,new '
!     1 ,nord2,(rxyzs(ll,nord2),ll=1,3),yyy
      do   ll=1,3
      rxyzs(ll,nord2)=yyy(ll)
      enddo
!      if(bij(1,nord2).eq.1)then
!      call chbij(nord2,nopp)
!      endif
!      write(ncwu,*)'fine chcoor'
      return
      end
!
!code for chbij
      subroutine chbij(jnord2,nopp2)
      USE General
      USE Symmetry
      USE Atomi
      USE BuildModule
      USE BuildStuff
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension yyy(3), yy(3),xmmat(9)
!-- nopp2<0 -nop
!-- nopp2>0 da decompattare
!      write(ncwu,*)'chbij nopp ',nopp
      if (nopp2.lt.0)then
          nop = -nopp2
      else
          call norop(nopp2,nop,itx,ity,itz)
      endif
!      write(ncwu,*)'chbij nop ',nop
      if (nop.gt.0.and.nop.le.nsymTot)then
          ii=0
          do i=1,3
             do j=1,3
                ii = ii + 1               !! gianluca 25/06/2004
                xmmat(ii) = kmat(nop,i,j) !! gianluca 25/06/2004
             enddo
          enddo
          call xbijx(xmmat,bij(1,jnord2),bij(1,jnord2))
      endif
!
      return
      end
!
!code for chgxyz
      subroutine chgxyz(kaction)
      USE General
      USE Symmetry
      USE Atomi
      USE BuildStuff
      USE BuildModule
!
!-- change peaks coordinates to obtain the best plot
!
      common /pimpo/nAtmBlocc,focc,jumpcl,l15con,ihce,n3n
     1,vett(3,4),zatom(10),legacon(1000)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
!
      dimension y(3),sss(3),yy(3),ssx(3),yyx(3),iy(3)
      dimension yvi(3),sssvi(3),baric0(3),iprt(2,3),prt(3)
!dim1500
!
!      write(ncwu,*)'inizia chgx jdfrag'
!      write(ncwu,11)(jdfrag(i),i=1,nats)
11    format(10i8)
!
      kkverbo=0
!      if(ncyclevld.eq.34)kkverbo=1
      do i=1,nats
         do j=1,5
            rxyzs(j,i)=xyzbu(j,i)  
         enddo  
      enddo  
      mfra(1:MaxAtomsBuild)=0
      dsave=dmax
!      dmax=10000.0
!
!--determina il numero di picchi del fragmento minimo
      min4=6
      min3=2
      if(nats.le.8)then
         do i =1,nats
            if(numfr(i).gt.min3)min3=numfr(i)
         enddo
         if(min4.gt.min3)min4=min3
      endif
!--determina il numero massimo di fragmenti
      lfragmx=0
      do  i=1,nats
         jfra=jdfrag(i)
         lfrag=jordfr(jfra)
         if(lfrag.gt.lfragmx)lfragmx=lfrag
      enddo
!
      lfragmx0=lfragmx
      do  i=1,nats
         jfra=jdfrag(i)
         lfrag=jordfr(jfra)
         if(lfrag.eq.0)then
            lfragmx=lfragmx+1
            lfrag=lfragmx
            jdfrag(i)=-(10000+lfrag)
         endif
         if(lfrag.ne.0)mfra(lfrag)=mfra(lfrag)+1
      enddo
      lfrag=lfragmx
      if(kkverbo.eq.1)then
         write(ncwu,*)'lfrag,lfragmx',lfrag,lfragmx
         write(ncwu,*)'jdfrag'
         write(ncwu,11)(jdfrag(i),i=1,nats)
         write(ncwu,*)'mfra'
         write(ncwu,11)(mfra(i),i=1,lfragmx)
      endif
!
!-- Parte 2 : move fragments
      igiri=0
1000  continue
!-- initialize work array
      iby=0   !numero di frammenti fissati
      jpes=0
      jfissfr(1:MaxAtomsBuild)=0
      jfisspk(1:MaxAtomsBuild)=0
      movefr(1:MaxAtomsBuild)=0
      baric(1:3,1:MaxAtomsBuild)=0.0
!--  calculate baric
      icodkblock=0
      jmx=0
      lfragmx0=lfragmx
      mmfra=0
      do i=1,nats
         jfra=jdfrag(i)
         lfrag=jordfr(jfra)
!        write(ncwu,*)'i,lfrag,lfra',i,lfrag,lfra
!-- se c'e' un atomo con kblock 1 il suo fragmento viene tenuto fisso
         if(kblock(i).eq.1)then
            if(movefr(lfrag).eq.0)then
               movefr(lfrag)=1
               iby=iby+1
               jfissfr(iby)=lfrag
               if(mfra(lfrag).gt.mmfra)then
                  jmx=lfrag
                  mmfra=mfra(lfrag)
               endif
               icodkblock=jmx
!              write(ncwu,*)' fissato (per kblock) frag. n.',lfrag
!              write(ncwu,*)'iby,jfissfr',iby,jfissfr(iby)
               do j=1,nats
                  jfra=jdfrag(j)
                  jm=jordfr(jfra)
                  if(jm.eq.lfrag)jfisspk(j)=1
               enddo
            endif
         endif
!--
         do  j=1,3
            baric(j,lfrag)=baric(j,lfrag)+rxyzs(j,i)
         enddo
      enddo
!-- store i baric
      do j=1,lfragmx
         if(mfra(j).le.0)cycle
         kk4=nats+j
         do  i=1,3
           rxyzs(i,kk4)=baric(i,j)/float(mfra(j))
         enddo
         if(kkverbo.eq.1)then
           write(ncwu,'(a,i4,3f8.3,2i6)')
     1     'baric: j,rxyzs(i,kk4),mfra(j),movefr(j) ',j,
     1     (rxyzs(i,kk4),i=1,3),mfra(j),movefr(j)
         endif
      enddo
!-- se non ci sono atomi blockati: se c'e' un atomo pesante il suo fragmento viene tenuto fisso
!-- altrimenti  fissa il fragmento piu' grande
      if(iby.eq.0)then
!-- atomo pesante 
        jpes=0   
        if(kaction.gt.3)then
          jzpes=0   
          do i=1,nats
            if(nz(i).gt.0)then
              ii=nz(i)/nzConst
              if(ii.gt.0)then
                if(no(ii).gt.20.and.no(ii).gt.jzpes)then
                  jpes=i
                  jzpes=no(ii)
!                write(ncwu,*)'jpes,jdfrag(jpes),nz(jpes),ii,no(ii)',
!     1          jpes,jdfrag(jpes),nz(jpes),ii,no(ii)
                endif
              endif
            endif
          enddo
        else
          if(npeahi.ge.1)jpes=1
        endif
        if(jpes.gt.0)then
          jfraa=jdfrag(jpes)
          if(jordfr(jfraa).gt.0)jmx=jordfr(jfraa)
          nframx=mfra(jmx)
!      write(ncwu,*)'jpes,jdfrag(jpes),nz(jpes)',
!     1   jpes,jdfrag(jpes),nz(jpes)
        else
!-- fragmento piu' grande
          nframx=0
          jmx=1
          do  j=1,lfragmx
             if(mfra(j).lt.nframx)cycle
             nframx=mfra(j)
             jmx=j
          enddo
!         write(ncwu,*)'fragmento piu grande no. ',jmx
        endif
        kk=nats+jmx
!        write(ncwu,'(a,i4,3f8.3)')
!     1   'primo fragmento fissato ',jmx,(rxyzs(i,kk),i=1,3)
!
      endif       !if(iby.eq.0)
!--fissa
!      write(ncwu,*)' fissato frag. n.,mfra(jmx)',jmx,mfra(jmx)
      movefr(jmx)=1
      iby=1
      jfissfr(iby)=jmx
      do j=1,nats
        jfra=jdfrag(j)
        jm=jordfr(jfra)
        if(jm.eq.jmx)jfisspk(j)=1
      enddo
!--salva il baricentro del primo fisso
      do j=1,3
        baric0(j)=baric(j,jmx)/mfra(jmx)
!        if(kinsieme.eq.1)barisav(j)=rxyzs(j,jmx+nats)
        barisav(j)=rxyzs(j,jmx+nats)
      enddo
      mfra0=mfra(jmx)
!      write(ncwu,*)' baric(j,jmx)',(baric(j,jmx),j=1,3)
!      write(ncwu,*)' jmx,mfra(jmx),baric0 ',jmx,mfra(jmx),baric0
!      write(ncwu,*)' mfra(jmx)',mfra(jmx)
!      write(ncwu,*)' kinsieme,barisav ',kinsieme,barisav
!--
1700  continue
      nfissfr=iby
!      write(ncwu,*)'jfissfr(j)',(jfissfr(j),j=1,lfragmx)
!      write(ncwu,*)'No. di baricentri:',lfragmx
      if(kkverbo.eq.1)then
         write(ncwu,*)' Parte 2 lfragmx,nats ',lfragmx,nats
         write(ncwu,*)'jfissfr(j)'
         write(ncwu,11)(jfissfr(j),j=1,lfragmx)
         write(ncwu,*)'movefr(j)'
         write(ncwu,11)(movefr(j),j=1,lfragmx)
         write(ncwu,*)'jfisspk(j)'
         write(ncwu,11)(jfisspk(j),j=1,nats)
         write(ncwu,*)'jdfrag'
         write(ncwu,11)(jdfrag(i),i=1,nats)
         write(ncwu,*)'mfra'
         write(ncwu,11)(mfra(i),i=1,lfragmx)
         do j2=1,nats
           write(ncwu,'(i5,5f8.3)')j2,rxyzs(1:3,j2)
         enddo
      endif
!
      if (lfragmx.gt.1)then   
2602    continue
        muove=1
        do while  (muove==1)
!-- cerca il frag. piu vicino al primo fisso
          muove=0
          dist=1000000.
          npmin=nats+jmx
          npmax=nats+jmx
          kccod1=1
!      write(ncwu,*)'chgxyz npmin,npmax,jmx,nats',npmin,npmax,jmx,nats
!      write(ncwu,*)'jmx,rxyzs(1:3,jmx+nats),baric0 ',
!     1 jmx,(rxyzs(ki,jmx+nats),ki=1,3),baric0 
!      write(ncwu,*)'jmx,baric(1:3,jmx) ',
!     1 jmx,(baric(ki,jmx),ki=1,3)
          do j2=1,lfragmx
            nord1=0
            y=0
            sss=0
            if(mfra(j2).le.1)cycle
            if(movefr(j2).eq.1)cycle
            nord2=nats+j2
!         write(ncwu,*)'chgx npmin,npmax,nord1-2',npmin,npmax,nord1,nord2
            call idstall(npmin,npmax,nord1,nord2
     1         ,nop2,dstmn,y,sss,movefr,kccod1)
!            write(ncwu,*)'chgxyz npmin,nord1,nord2,nop2,dstmn'
!     1      ,npmin,nord1,nord2,nop2,dstmn
            if(dstmn.lt.dist)then
              muove=1
              dist=dstmn
              j1vi=j2
              nordvi=nord2
              nopvi=nop2
              do jjj=1,3
                yvi(jjj)=y(jjj)
                sssvi(jjj)=sss(jjj)  
              enddo
!      write(ncwu,'(a,5i6,4f10.4)')
!     1'chgxyz jmx,j2,npmin,nord2,nop2,dstmn,y'
!     1 ,jmx,j2,npmin,nord2,nop2 ,dstmn,y
            endif
          enddo
!-- fine cerca il frag. piu vicino
!
!-- muove il frag. piu vicino
          if(muove.eq.1.and.nordvi.gt.0)then
!             write(ncwu,'(a,i4,6f8.3)')
!     1       'prima di muovo il frag piu vicino j1vi, rxyzs(1:3,j1vi) '
!     1       ,j1vi,rxyzs(1:3,j1vi+nats)
!             write(ncwu,'(a,i4,6f8.3)')
!     1       'muovo il frag piu vicino j1vi,yvi ',j1vi,yvi,sssvi
              j1=j1vi
              nord2=nordvi
              nop2=nopvi
              do ij1=1,3
                 y(ij1)=yvi(ij1)
                 sss(ij1)=sssvi(ij1)
              enddo
!
              do kkx=1,3
                 rxyzs(kkx,nord2)=y(kkx)
              enddo
              call norop(nop2,nop,itx,ity,itz)
!              write(ncwu,*)'norop nop2,nop,itx,ity,itz '  ,
!     1          nop2,nop,itx,ity,itz
!--move gli atomi del frag.
            do jj=1,nats
!      write(ncwu,*)' P2 muove  ',jj,(rxyzs(ixx,jj),ixx=1,3)
              jf=jdfrag(jj)
              jkk2=jordfr(jf)
              if (jkk2.eq.j1) then
                cc=cprxyzs(jj,y) 
                call xequiTot(nop,y, yy,iexit)
                do i=1,3
                   yy(i)=yy(i)+sss(i)
                enddo
                if(kkverbo.eq.1) then
                write(ncwu,'(a,i5,6f7.3)')  ' P2  1 coord picco ,sssvi',
     1           jj,y,sssvi
                write(ncwu,'(a,i5,3f7.3,i5)')' P2  2 coord picco,nop   '
     1           ,jj,yy,nop
                endif
!--qui cambia x  deve cambiare bij
                call chcoor(jj,yy,-nop)
!--aggiorna baric
!         write(ncwu,'(a,i5,3f7.3)')
!     1  ' aggiorna baric prima mfra0 ',mfra0,(baric(jij,jmx),jij=1,3)
                do jjj=1,3
                  baric(jjj,jmx)=baric(jjj,jmx)+yy(jjj)
                enddo
                mfra0=mfra0+1
!         write(ncwu,'(a,i5,3f7.3)')
!     1  ' aggiorna baric dopo mfra0 ',mfra0,(baric(jij,jmx),jij=1,3)
              endif
            enddo
!--ricalcola  baric
!            write(ncwu,'(a,i5,3f7.3)')
!     1      ' prima aggiorna jmx,baric0 ',jmx,baric0
            do jjj=1,3
              rxyzs(jjj,nats+jmx)=baric(jjj,jmx)/mfra0
              baric0(jjj)=baric(jjj,jmx)/mfra0
            enddo
            kk4=nats+jmx
!      write(ncwu,*)'ricalcola baric mfra0,kk4,rxyzs(i,kk4),baric0'
!     1       ,mfra0,kk4,(rxyzs(i,kk4),i=1,3),baric0
!-- aggiunge il frag. a quelli fissi
2603       iby=iby+1
           jfissfr(iby)=j1
           movefr(j1)=1
!       write(ncwu,*)'iby,jfissfr(1:iby)',iby,(jfissfr(ii),ii=1,iby)
           do i=1,lfragmx
              if(movefr(i).eq.1)then
                do j=1,nats
                  jkk2=jordfr(jdfrag(j))
                  if(jkk2.eq.i)jfisspk(j)=1
!                 if(jkk2.eq.i) write(ncwu,*)
!     1           'picco fisso,frag',j,jkk2,jfisspk(j),movefr(i)
                enddo
              endif
           enddo
        endif
        enddo !while
      endif    !lfragmx.gt.1 
!
!-- Parte 3 : analize unlinked peaks
!
2700  continue
      if (lfragmx.eq.1) go to 3700
      if(kkverbo.eq.1)then
      write(ncwu,*)' Parte 3 lfragmx,nats ',lfragmx,nats
      write(ncwu,*)'jfissfr(j)'
      write(ncwu,11)(jfissfr(j),j=1,lfragmx)
      write(ncwu,*)'movefr(j)'
      write(ncwu,11)(movefr(j),j=1,lfragmx)
      write(ncwu,*)'jfisspk(j)'
      write(ncwu,11)(jfisspk(j),j=1,nats)
      write(ncwu,*)'jdfrag'
      write(ncwu,11)(jdfrag(i),i=1,nats)
      write(ncwu,*)'mfra'
      write(ncwu,11)(mfra(i),i=1,lfragmx)
      endif
!
!-- find out unlinked peaks in order to move them
!-- at minimun distance from other peaks
!
      do i=1,nats
!--fix(ini)
         if(kblock(i) .eq.1) cycle  !go to 3400
         if(jfisspk(i).eq.1) cycle  !go to 3400
!--fix(fin)
!      write(ncwu,*)'*******PICCO ISOLATO****** ',i
!      write(ncwu,*)'i,jdfrag(i),jfisspk(i)',i,jdfrag(i),jfisspk(i)

3100     continue
!-- modify x,y,z according to another peak
         barx(1:3)=barisav(1:3)
         dist=1000000.
         nnn15=9999
         nn15=9999
         nord2=i
         npk=1
         kccod1=1
         call idstall(nnn15,nn15,npk,nord2,
     1     nop2,distmin,y,ssx,jfisspk,kccod1)
!         write(ncwu,*)'3100 npk,nord2,nop2,y,distmin',
!     1    npk,nord2,nop2,y,distmin
         if(npk.gt.0)then
            if(kkverbo.eq.1)write(ncwu,*)
     1      'P3 1 coord picco ',nord2,(rxyzs(ixx,nord2),ixx=1,3)
!             write(ncwu,*)'3100 npk,nord2,nop2,y,distmin',
!             1 npk,nord2,nop2,y,distmin
!--qui cambia x
            call  chcoor(nord2,y,nop2)
            jfisspk(nord2)=1
            if(kkverbo.eq.1)write(ncwu,*)
     1      'P3 2 coord picco ',nord2,(rxyzs(ixx,nord2),ixx=1,3)
         endif
      enddo
!--Parte 4 
!-- controlla la posizione relativa dei fragmenti.
      if(kkverbo.eq.1)write(ncwu,*)' Parte 4 '
      noparte4=0
      if(noparte4.eq.0)then
         m=0
         yy(1:3)=0.0
!--
         do i=1,nats
             yy(1:3)=yy(1:3)+rxyzs(1:3,i)
             m=m+1
         enddo
!        write(ncwu,*)'m,yy',m,yy
         yy(1:3)=yy(1:3)/m
!        write(ncwu,*)'baric=yy',yy
!--
         do ii=1,3
             iy(ii)=0.
             if(abs(yy(ii)).ge.1.8)then
                 iy(ii)=nint(yy(ii)) 
!            write(ncwu,*)' ii,yy(ii),iy(ii) ',ii,yy(ii),iy(ii)
                 do ij=1,nats
                   rxyzs(ii,ij)=rxyzs(ii,ij)-iy(ii)
                 enddo
             endif
         enddo
      endif
3700  continue
!--aggiorna )LongConnect(jj,2)= numero del frag.
          if(kkverbo.eq.1)write(ncwu,'(a)')'LongConnect'
      do jj=1,nats
          jjd=jdfrag(jj)
!          if(jjd.ne.0)LongConnect(jj,2)= jordfr(jjd)
          if(jjd.ne.0)LongConnect(jj,2)= jordfr(jjd)
          if(kkverbo.eq.1)
     1       write(ncwu,'(3i5,2x,26i6)')
     1       jj,LongConnect(jj,1:2),LongConnect(jj,3:26)
      enddo
!--ricopia su xyzbu 
!      write(ncwu,*)'fine chgxyz i,xyzbu(ii,i)'
      do i=1,nats
          xyzbu(1:5,i)=rxyzs(1:5,i)
!      write(ncwu,*)'i,xyzbu(ii,i)',i,
!     1(xyzbu(ii,i),ii=1,3)
      enddo
      dmax=dsave
!      write(ncwu,'(a)')'chgxyz fine'
      return
      end
!
!code for chgxyz1001
      subroutine chgxyz1001(kaction)
      USE General
      USE Symmetry
      USE Atomi
      USE BuildStuff
      USE BuildModule
!
!-- change peaks coordinates to obtain the best plot
!
      common /pimpo/nAtmBlocc,focc,jumpcl,l15con,ihce,n3n
     1,vett(3,4),zatom(10),legacon(1000)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
!
      dimension y(3),sss(3),yy(3),ssx(3),yyx(3),iy(3),yyy(3),ss(3)
      dimension yvi(3),sssvi(3),baric0(3)
!
!      write(ncwu,*)'inizia chgx jdfrag'
!      write(ncwu,11)(jdfrag(i),i=1,nats)
11    format(10i8)
!
      kkverbo=0
      rxyzs(:,:)=0.
      do i=1,nats
         do j=1,5
            rxyzs(j,i)=xyzbu(j,i)  
         enddo  
!      write(ncwu,*)'i,rxyzs(ii,i)',i,
!     1(rxyzs(ii,i),ii=1,3)
      enddo  
      do i=1,MaxAtomsBuild
         mfra(i)=0
      enddo  
      dsave=dmax
!--determina il numero massimo di fragmenti
      lfragmx=0
      do  i=1,nats
         jfra=jdfrag(i)
         lfrag=jordfr(jfra)   
!        write(ncwu,*)'i,jdfrag(i),lfrag ',i,jdfrag(i),lfrag
         if(lfrag.gt.lfragmx)lfragmx=lfrag
      enddo
!
!      write(ncwu,*)'lfragmx',lfragmx
      lfragmx0=lfragmx
      do  i=1,nats
         jfra=jdfrag(i)
         lfrag=jordfr(jfra)
         if(lfrag.eq.0)then
            lfragmx=lfragmx+1
            lfrag=lfragmx
            jdfrag(i)=-(10000+lfrag)
         endif
         if(lfrag.ne.0)mfra(lfrag)=mfra(lfrag)+1
      enddo
      lfrag=lfragmx
      if(kkverbo.eq.1)then
      write(ncwu,*)'lfrag,lfragmx',lfrag,lfragmx
      write(ncwu,*)'jdfrag'
      write(ncwu,11)(jdfrag(i),i=1,nats)
      write(ncwu,*)'mfra'
      write(ncwu,11)(mfra(i),i=1,lfragmx)
      endif
      if(lfragmx.eq.1)return
!
!-- Parte 2 : move fragments
      igiri=0
1000  continue
!-- initialize work array
      iby=0
      jpes=0
      do  i=1,MaxAtomsBuild
         jfissfr(i)=0
         jfisspk(i)=0
         movefr(i)=0
      enddo
!--  
      icodkblock=0
      jmx=0
      lfragmx0=lfragmx
      mmfra=0
      do 10 i=1,nats
         jfra=jdfrag(i)
         lfrag=jordfr(jfra)
!      write(ncwu,*)'i,lfrag,lfra',i,lfrag,lfra
!-- se c'e' un atomo con kblock 1 il suo fragmento viene tenuto fisso
         if(kblock(i).eq.1)then
            if(movefr(lfrag).eq.0)then
              movefr(lfrag)=1
              iby=iby+1
              jfissfr(iby)=lfrag
              if(mfra(lfrag).gt.mmfra)then
                   jmx=lfrag
                   mmfra=mfra(lfrag)
              endif
              icodkblock=jmx
!      write(ncwu,*)' fissato (per kblock) frag. n.',lfrag
!            write(ncwu,*)'iby,jfissfr',iby,jfissfr(iby)
              do j=1,nats
                  jfra=jdfrag(j)
                  jm=jordfr(jfra)
                  if(jm.eq.lfrag)jfisspk(j)=1
              enddo
            endif
         endif
10    continue 
!-- altrimenti  fissa il fragmento piu' grande
         if(iby.eq.0)then
!-- fragmento piu' grande
           nframx=0
           jmx=1
           do  j=1,lfragmx
             if(mfra(j).gt.nframx)then
               nframx=mfra(j)
               jmx=j
             endif
           enddo
!         write(ncwu,*)'fragmento piu grande no. ',jmx
         endif
!--fissa
!      write(ncwu,*)' fissato frag. n.,mfra(jmx)',jmx,mfra(jmx)
         movefr(jmx)=1
         iby=1
         jfissfr(iby)=jmx
         do j=1,nats
           jfra=jdfrag(j)
           jm=jordfr(jfra)
           if(jm.eq.jmx)jfisspk(j)=1
         enddo
         mfra0=mfra(jmx)
!      write(ncwu,*)' baric(j,jmx)',(baric(j,jmx),j=1,3)
!      write(ncwu,*)' mfra(jmx),baric0 ',mfra(jmx),baric0
!      write(ncwu,*)' mfra(jmx)',mfra(jmx)
!      write(ncwu,*)' kinsieme,barisav ',kinsieme,barisav
!--
1700  continue
      nfissfr=iby
!      write(ncwu,*)'jfissfr(j)',(jfissfr(j),j=1,lfragmx)
      if (lfragmx.eq.1) go to 2700
!
      if(kkverbo.eq.1)then
      write(ncwu,*)' Parte 2 lfragmx',lfragmx
      write(ncwu,*)'jfissfr(j)'
      write(ncwu,11)(jfissfr(j),j=1,lfragmx)
      write(ncwu,*)'movefr(j)'
      write(ncwu,11)(movefr(j),j=1,lfragmx)
      write(ncwu,*)'jfisspk(j)'
      write(ncwu,11)(jfisspk(j),j=1,nats)
      write(ncwu,*)'jdfrag'
      write(ncwu,11)(jdfrag(i),i=1,nats)
      write(ncwu,*)'mfra'
      write(ncwu,11)(mfra(i),i=1,lfragmx)
      endif
!
2602  continue
!-- cerca l'equiv. di un atomo legato ad un atomo del frag. fisso
      muove=0
      do jfr=1,lfragmx  !sui frag. fissi
      if(movefr(jfr).ne.1)cycle
      nnn=jfr
        do j2=1,nats
        jf=jdfrag(j2)
        jjj=jordfr(jf)
        if(jjj.le.0)cycle
        if(movefr(jjj).ne.0)cycle !=0 non fisso,1 fisso ,-1 fisso ma vuoto
        yyy=0.
        ss=0.
        npk=0
        nord2=j2
        call idst1at_to_atsfrag(nnn,npk,nord2,
     1  nop2,distmin,yyy,ss)
            if(npk.gt.0)then
*           write(ncwu,*)'chgxyz nnn,npk,nord2,nop2,distmin'
*    1       ,nnn,npk,nord2,nop2,distmin
            muove=1
            jfrfis=nnn
            dist=distmin
            j1vi=jjj
            nordvi=nord2
            nopvi=nop2
              do jjj=1,3
              yvi(jjj)=yyy(jjj)
              sssvi(jjj)=ss(jjj)
              enddo
            exit
            endif
        enddo
!-- fine cerca l'atomo piu vicino al frag. fisso
!
!-- muove il frag. dell'atomo piu vicino
          if(muove.eq.1.and.nordvi.gt.0)then
!          write(ncwu,*)'muovo il frag j1vi,nopvi ',j1vi,nopvi
          j1=j1vi
          nord2=nordvi
          nop2=nopvi
          npk2=max0(npk,nord2)
          npk1=nord2+npk-npk2
            do ij1=1,3
            y(ij1)=yvi(ij1)
            sss(ij1)=sssvi(ij1)
            enddo
!--cambia nord2
          rxyzs(1:3,nord2)=y(1:3)
          if(jdfrag(nord2).gt.0)jdfrag(nord2)=jdfrag(nord2)-j1+jfrfis
          numcon=jconn(1)
          nindr=2+3*numcon
          jconn(nindr)=npk1
          jconn(nindr+1)=npk2
          jconn(nindr+2)=1
          jconn(1)=numcon+1
          call norop(nop2,nop,itx,ity,itz)
!      write(ncwu,*)'norop nop2,iccentr,itx,ity,itz,nord,nop,jkk1 '  ,
!     1nop2,iccentr,itx,ity,itz,nord,nop,jkk1
!--move gli atomi del frag.
           do jj=1,nats
!           write(ncwu,*)' P2 muove  ',jj,(rxyzs(ixx,jj),ixx=1,3)
           jf=jdfrag(jj)
           jkk2=jordfr(jf)
            if (jkk2.eq.j1.and.jj.ne.nord2) then
                cc=cprxyzs(jj,y) 
                call xequiTot(nop,y, yy,iexit)
                do i=1,3
                   yy(i)=yy(i)+sss(i)
                enddo
                if(kkverbo.eq.1) then
                 write(ncwu,'(a,2i5,3f7.3)')'P2 1 coord picco ',jf,jj,y
                 write(ncwu,'(a,2i5,3f7.3)')'P2 2 coord picco ',jf,jj,yy
                endif
!--qui cambia x  deve cambiare bij
                call chcoor(jj,yy,-nop)
!-- aggiunge l'atomo al frag. fisso
                if(jdfrag(jj).gt.0)jdfrag(jj)=jdfrag(jj)-j1+jfrfis
            endif
           enddo
          movefr(j1)=-1
          go to 2602
          endif
      enddo   !sui frag. fissi


2700  continue
!--ricopia su xyzbu 
!      write(ncwu,*)'fine chgxyz i,xyzbu(ii,i)'
      do i=1,nats
      do j=1,5
      xyzbu(j,i)=rxyzs(j,i)
      enddo
!      write(ncwu,*)'i,xyzbu(ii,i)',i,
!     1(xyzbu(ii,i),ii=1,3)
      enddo
      dmax=dsave
!      write(ncwu,*)'chgxyz fine'
      return
      end
!
!----------------------------------------------------------------------
!
!        Build per 1001 e piu' atomi
!
!----------------------------------------------------------------------
!
!code for clust1001
      subroutine clust1001(kaction)
      USE General
      USE Symmetry
      USE Atomi
      USE BuildStuff
      USE BuildModule
!
!-- for more than 1000 peak, change peaks coordinates to obtain the best plot
!
      character ib*1,str2*2
      character*6 wgrup
      character*15 line,any,ibb,dd(9),inpco,iwr
c  
      common /pimpo/nAtmBlocc,focc,jumpcl,l15con,ihce,n3n
     1,vett(3,4),zatom(10),legacon(1000)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      dimension y(3),z(3),yy(3),ssx(3),yyx(3),iy(3),dstleg2(100)
      dimension yvi(3),sssvi(3),baric0(3),iprt(2,3),prt(3),d1(3),d2(3)
      dimension dimi(18),dax(18),includ(18),dleg2(100,3),leg2(100)
!
      data ibb/'               '/
      data inpco/'* '/
      data any/'    any        '/
      data wgrup/' group'/
      data  ib/' '/
!
!      write(lo,'(a,10i5)')'Inizia clust1001 nzconst ',nzconst


      
      

!
      kkverbo=0
      e10=1.0e-10
!--set the input parameters
!
!      write(ncwu,*)'CLUST kaction,nfl istat2 ',kaction,nflb,istat2
!      write(ncwu,*) 'CLUST izpk  ',(izpk(i),i=1,nats)
!      write(ncwu,*) 'CLUST kblock  ',(kblock(i),i=1,nats)
      ninc=0
      natspecc=0
      do j=1,nats
      idfrag(j)=0
      jdfrag(j)=0
      numfr(j)=0
      nzTot(j) = nz(j) / nzConst
      enddo
      if (kaction.le.3) then
          call namepk
      else
          call readpk
      endif
!
      jfragVal=1
!-- print limits for interatomic bonds
      if (istat2.gt.1) then
          if (neutro.eq.0) then
              write(ncwu,155)
          else
              write(ncwu,156)
      endif
!--29.7.97
      nnn=nk-ihce
      if (kaction.gt.3) nnn = ngrup
      do 165 i=1,nnn
         jjj=1+(i-1)*md
         if (groupatomi(jjj).le.0.00) cycle
         ija=nint(groupatomi(jjj+7))
         ij2=nint(groupatomi(jjj+2))
         ijj=nint(groupatomi(jjj+6))
         write(str2,'(a2)') nalf(ijj)
         call ucase(str2(1:1))
!        write(ncwu,180) str2,storeb(jjj-3),storeb(jjj),storeb(jjj+1),
!      1   angi(ijj),angs(ijj) ,storeb(m3+13),iwr
         if (istat2.gt.1)then 
             if (neutro == 0) then             
              write(ncwu,180) str2,groupatomi(jjj+1),groupatomi(jjj+4),
     1           groupatomi(jjj+5) ,ij2
             else             
              write(ncwu,182) str2,groupatomi(jjj+1),groupatomi(jjj+4),
     1          groupatomi(jjj+5),groupatomi(jjj+2)
             endif             
         endif
  165 continue
  155 format(/,1x,'Assumed atomic parameters and limits for',
     *           ' interatomic bonds ',/,
     *       16x,'   (interspecies and intraspecies)'   ,//,
     1       23x,'distances',7x,
     1        '  atomic  ',/,
     1           1x,'type',3x,'radius',4x,'minimum   maximum',4x,
     1      '  number',/)
  156 format(/,1x,'Assumed atomic parameters and limits for',
     *           ' interatomic bonds',/,
     *       16x,'   (interspecies and intraspecies)'   ,//,
     1       23x,'distances',7x,
     1        ' effective ',/,
     1           1x,'type',3x,'radius',4x,'minimum   maximum',4x,
     1      '  lenght',/)
  180 format(2x,a2,f9.3,1x,2f10.2,1x,i10,8x,a2)
  182 format(2x,a2,f9.3,1x,2f10.2,1x,f10.3,8x,a2)
      endif
 185  format(1h )

!--stampa le tabelle
      if (istat2.gt.2) then
      includ(1:18)=0
      do i=1,nats
      ii=icogr(i)
      includ(ii)=includ(ii)+1
      enddo
      write(ncwu,185)
      write(ncwu,185)
      write(ncwu,*)
     *  ' Tentative of peak labelling in terms of atomic species'
      write(ncwu,4106)
      write(ncwu,4107)
!
      ng=ngrup
      if(ng.gt.4)ng=4
      do 4000 j=1,ngrup
      ji=nk-j+1
      ma1=ive3i(j)
      ma2=ive3s(j)
      if(kaction.gt.3)then
      ma1=j
      ma2=j
      endif
      mm1=nint(groupatomi(1+(ma1-1)*md+6))
      mm2=nint(groupatomi(1+(ma2-1)*md+6))
      write(line(1:15),4101)(nalf(m),ib,m=mm2,mm1)
      do i=1,13,3
        call ucase(line(i:i))
      enddo
      iang=ive(j)
      inam=nalf(mm2)
      write(str2,'(a2)') inam
      call ucase(str2(1:1))
         if(ive(j).eq.3)then
         line=any
         endif
      do 5150 i=1,9
5150  dd(i)=ibb
!      write(ncwu,*)'ngrup,i,dimi(i),dax(i)',ngrup
      do 5200 i=1,ngrup
      if(i.lt.j)go to 5200
      dimi(i)=dmnmx(i,j,1)
      dax(i)=dmnmx(i,j,2)
!      write(ncwu,*)i,dimi(i),dax(i)
      write(dd(i)(1:15),4203)dimi(i),dax(i)
5200  continue
                             write(ncwu,5103)j,includ(j),line,
     *                                      str2
      line=ibb
4000  continue
!--tabella ' range of bond distances used to build fragments'
      ng1=1
      ng2=ng
!      write(ncwu,*)'istat2,ng1,ng2', istat2,ng1,ng2
      write(ncwu,5105)
5000  write(ncwu,4108)(wgrup,j,j=ng1,ng2)
      do 4300 j=ng1,ng2
      do 5160 k=1,8
5160  dd(k)=ibb
      do 4400 i=ng1,ng2
      if(i.lt.j)go to 4400
      dimi(i)=dmnmx(i,j,1)
      dax(i)=dmnmx(i,j,2)
!      write(ncwu,*)'i,dimi(i),dax(i)',i,dimi(i),dax(i)
      write(dd(i)(1:15),4203)dimi(i),dax(i)
4400  continue
      write(ncwu,5104)j,(dd(ij),ij=ng1,ng2)
4300  continue
           if(ng2.lt.ngrup)then
           write(ncwu,4108)(wgrup,j,j=ng2+1,ngrup)
           do 4301 j=ng1,ngrup
           do 5161 k=1,8
5161       dd(k)=ibb
           do 4401 i=ng2+1,ngrup
           dimi(i)=dmnmx(i,j,1)
           dax(i)=dmnmx(i,j,2)
           write(dd(i)(1:15),4203)dimi(i),dax(i)
4401       continue
           write(ncwu,5104)j,(dd(ij),ij=ng2+1,ngrup)
4301       continue
             if(ngrup.gt.8)then
             ng1=ng1+1
             ng2=ngrup
             go to 5000
             endif
           endif
      endif
      if (istat2.gt.1) write(ncwu,4102)
4101  format(5(a2,a1))
4102  format(1x,78('-'))
4104  format(//,
     *'  group',3x,'   peaks',3x,'   possible    ',3x,' species',3x,
     *'  range of ',4x,
     *'range of bond distances used to build fragments')
4105  format(' number',3x,'included',2x,'chemical species',3x,
     3  'assigned',4(6x,a6,i2,1x))
4107  format(' number',3x,'included',2x,'chemical species',3x,
     3  'assigned')
4106  format(/,
     *'  group',3x,'   peaks',3x,'   possible    ',3x,' species')
4108  format(3x,'group',4x,8(a6,i2,7x))
5103  format(1x,i4,4x,3x,i6,4x,a15,3x,2x,a2,3x,4x,f4.0,' - ',f4.0)
5104  format(2x,i4,2x,8a15)
5105  format(/,' range of bond distances used to build fragments')
 4203 format(2x,'(',f5.2,'-',f5.2,')')








      nfrag=0
      idfrag(:)=0  !temporaneo (stato 0,1,2)
      jdfrag(:)=0  !n. del framm. a cui appartiene l'atomo
      mfra(:)=0    !n. di atomi nel framm. 
      jconn(:)=0
      ncop3=2
!
      i2=0
      nn=0
      if (istat2.gt.1)
     1write(lo,*)' Connectivity with distances '
10    continue
      do while (i2 < nats)
           do i=1,nats
             if(idfrag(i).eq.0)then
             nfrag=nfrag+1
             idfrag(i)=1
             jdfrag(i)=10000+nfrag
!      write(lo,'(a,10i5)')'10 i,mfra ',i,mfra(i)
             exit
             endif
           enddo
!      write(lo,'(a,10i5)')'idfrag '
!      write(lo,'(10i5)')idfrag(1:nats)
100   continue
      i1=1
        do while (i1 > 0)
        i1=0
        i2=0
          do j=1,nats
          if(idfrag(j).eq.2)i2=i2+1
            if(idfrag(j).eq.1)then
            i1=j
!                if(izpk(j).gt.0.and.izpk(k).le.nzConst)
!     1          izpk(k)=izpk(k)*nzConst+jdfrag(k)
               if(izpk(j).gt.0.and.izpk(j).le.nzConst)then
               jdd=mod(jdfrag(j),10000)
               izpk(j)=izpk(j)*nzConst+jdd
               endif
            mm=1
            dleg2(:,:)=0.
            d2(:)=0.
            exit
            endif
          enddo
!
          if(i1.gt.0)then
            do k=1,nats
              if(idfrag(k).lt.2)then
                if(distleg(i1,k,dis,d2).eq.1)then
                if (mm >= 100) then
                    write(6,*) 'Atomo ',i,' Superati 100 legami'
                    exit
                endif
                npk2=max0(i1,k)
                npk1=i1+k-npk2
                jconn(1)=jconn(1)+1
                if (ncop3+3 > size(jconn)) then
                    igianluca = size(jconn)
                    return
                endif
                jconn(ncop3)=npk1
                jconn(ncop3+1)=npk2
                jconn(ncop3+2)=1
                jdfrag(k)=10000+nfrag
!-- storizza per calc. gli angoli 
                leg2(mm)=k
                dleg2(mm,1:3)=d2(1:3)
                dstleg2(mm)=dis
                mm=mm+1
!-- stampa
                if(istat2.gt.1)then
                nn=nn+1
                iprt(1,nn)=npk1
                iprt(2,nn)=npk2
                prt(nn)=dis
                   if(nn.eq.3)then
      write(lo,'(3(5x,2i5,f8.3))')(iprt(1:2,nnn),prt(nnn),nnn=1,3)
                   nn=0
                   endif
                endif
!      write(lo,'(2i5,f8.3)')jconn(ncop3:ncop3+1),dis
!                if(izpk(j).gt.0.and.izpk(k).le.nzConst)
!     1          izpk(k)=izpk(k)*nzConst+jdfrag(k)
                  if(izpk(j).gt.0.and.izpk(j).le.nzConst)then
                  jdd=mod(jdfrag(j),10000)
                  izpk(j)=izpk(j)*nzConst+jdd
                  endif
!      write(lo,'(a,10i5)')'100 i,mfra ',i,mfra(i)
!      write(lo,'(a,a,4i5,f8.3,2i7)')'ncop3, jconn(ncop3:ncop3+2),dis'
!     1,'izpk(i1),izpk(k) '
!     1,ncop3, jconn(ncop3:ncop3+2),dis,izpk(i1),izpk(k)
                ncop3=ncop3+3
                idfrag(k)=1
                endif
              endif
            enddo
          idfrag(i1)=2 
          mfra(nfrag)=mfra(nfrag)+1
!--classifica l'atomo in funzione dei suoi angoli (n.leg*10+n.ang.ko)





          noncalcolaangoli=0
              if(noncalcolaangoli.ne.0)then
                if(mm.gt.2)then
                 mm=mm-1
                 nko1=0
                 nko2=0
                 nko3=0
                  do im1=1,mm-1
                  d1(1:3)=dleg2(im1,1:3)
                    do im2=im1+1,mm
                    d2(1:3)=dleg2(im2,1:3)
                    call ang(d1,d2,angle)
                    deno=dstleg2(im1)*dstleg2(im2)
                    if(deno.le.1.0e-35)deno=1.0e-5
                    angle=angle/deno
                    if(angle.gt.1.and.angle.le.1.1)angle=1.0
                    if(angle.lt.-1.and.angle.ge.-1.1)angle=-1.0
                    angle=acos(angle)*rtod
                    write(lo,*)i1,leg2(im1),leg2(im2),angle
                    if(angle.gt.130..or.angle.lt.100.)nko1=nko1+1
                    if(angle.gt.150..or.angle.lt.80.) nko2=nko2+1
                    if(angle.gt.170..or.angle.lt.60.) nko3=nko3+1
                    enddo
                  enddo
                endif
                kscore=mm*1000000+nko3*10000+nko2*100+nko1
                write(lo,*)' n.atom score-angle ',i1,kscore
              endif






          endif
        enddo
      enddo
                if(istat2.gt.1)then
                if(nn.gt.0)then
      write(lo,'(3(5x,2i5,f8.3))')(iprt(1:2,nnn),prt(nnn),nnn=1,nn)
                endif
                endif
      ncop=jconn(1)
      jump = 0
      call sortya(jconn,2,ncop,3,jump)
!      write(lo,'(a,10i5)')'clst1001 fine jdfrag '
!      write(lo,'(10i5)')jdfrag(1:nats)
!!
!-- copia su iconn
      nn=1+3*jconn(1)
      iconn(1:nn)=jconn(1:nn)
      call chgxyz1001(kaction)
!--
      ia=0
!-- calcola il baricentro dei frammenti
      if(ia.ne.0)then
      baric=0.
      do  i=1,nats
      lfrag=jdfrag(i)
!      write(ncwu,*)'lfrag,baric(1:3,lfrag),i,xyzs(1:3,i)'
!     1,lfrag,baric(1:3,lfrag),i,xyzs(1:3,i)
        do  j=1,3
        baric(j,lfrag)=baric(j,lfrag)+xyzs(j,i)
        enddo
      enddo
      lfragmx=0
      do  lfrag=1,nfrag
      lfragmx=max0(lfragmx,mfra(lfrag)) !il fram. piu' grande
        do  j=1,3
        baric(j,lfrag)=baric(j,lfrag)/mfra(lfrag)
        enddo
      enddo
      if(kkverbo.eq.1)then
      write(ncwu,*)'nfrag,lfragmx',nfrag,lfragmx
      write(ncwu,*)'jdfrag'
      write(ncwu,'(10i5)')(jdfrag(i),i=1,nats)
      write(ncwu,*)'mfra'
      write(ncwu,'(10i5)')(mfra(i),i=1,lfragmx)
      do  lfrag=1,nfrag
      write(ncwu,*)'lfrag,baric(1:3,lfrag)',lfrag,baric(1:3,lfrag)
      enddo
      endif
      endif
      return
      end
!
!code for distleg
      function distleg(npk1,npk2,dst0,d2)
!
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE BuildStuff
      USE PhaseModule
      USE BuildModule
!
      dimension d2(3)
!
      distleg=0    !non legati
      do n=1,3
      d2(n)=xyzbu(n,npk1)-xyzbu(n,npk2)
      enddo
      dist=gdist(1)*d2(1)*d2(1)
     1    +gdist(5)*d2(2)*d2(2)
     2    +gdist(9)*d2(3)*d2(3)
     3    +gdist(2)*d2(1)*d2(2)*2.0
     4    +gdist(3)*d2(1)*d2(3)*2.0
     5    +gdist(6)*d2(2)*d2(3)*2.0
      dst0=sqrt(dist)
      mg0 =nzTot(npk1)
      mg1 =nzTot(npk2)
      if(mg0.gt.0.and.mg1.gt.0)then
      dmxh =BondTable(2,mg0,mg1)
      dmnh =BondTable(1,mg0,mg1)
      if(dst0.ge.dmnh.and.dst0.le.dmxh)distleg=1 !legati
      endif
      return
      end
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!                     AVVISOLATI
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!code for avvisolati
      subroutine avvisolati(kaction,iStamp,ncycle)
      USE General
*     USE Liste
      USE Atomi
      USE BuildStuff
      USE BuildModule
!
!-- avvicina gli isolati al primo atomo che trova a dist .le. distnew  
!
      common /idist/vett(3,4),focc,ihce
      dimension zatom(10),inp(9),istmp(5)
      dimension yyy(3),sss(3),x(3),y(3),z(3)
      dimension yy(3),ssx(3,200),yyx(3,200),d(3,200)
     1,dst(200),npp(200),deltadst(200),d1(3),d2(3)
!
      dimension inok(5000),tabangsav(8,5000)
!
      if (nats < 2) return
!
      icn   = 0  ! gianluca
      call InitAvvisolati
!
!-- setta i parametri
!
      deltaini = 0.05
      deltap2  = 1.0 * ncycle * deltaini
      deltapm  = 2.0 * ncycle * deltaini
      angolomn = 70
      angolomx = 180
!
      if (iStamp.eq.1) then
          write(lo,*)' '
          write(lo,"(/,1h ,78('-'),/,1h ,78('-'))") 
          write(lo,*)' '
          write(lo,*)' Avvicina gli isolati'
          write(lo,*)' '
          write(lo,*)' Parte 0: Condizioni Iniziali'
          write(lo,*)' ============================'
          write(lo,'(a,i5,f6.3)')
     1  ' Per allungare le bonddist:ncycle,deltaini',ncycle,deltaini
          write(lo,'(a,f6.3)')' Per avvicinare i frag:deltap2',deltap2
          write(lo,'(a,f6.3)')
     1  ' Due frag.avvicinati sono legati se delta<deltapm=',deltapm
          write(lo,'(2a,2f7.2)')' Range di angoli accettati ',
     1  'angolomn,angolomx ',angolomn,angolomx
          write(lo,*)' '
      endif
!--
      if (iStamp == 1) then
          write(lo,*)' nord   x       y       z    nfrag '
          do jj=1, nats
             nnfrag = iabs( mod(izpk(jj), nzConst) )
             write(lo,'(i5,3f8.4,i5)') jj, xyzbu(3:5,jj), nnfrag
          enddo
          write(lo,*)' '
      endif
*     write(6,'(i5)') nats
*     do jj=1, nats
*        nnfrag = iabs( mod(izpk(jj), nzConst) )
*        k = nz(jj) / nzConst
*        k = k * 100 + nnfrag
*        write(6,'(6f15.8,i5)') xyzs(1:5,jj), bfac(jj), k
*     enddo
      nconn = iconn30(1)
      nn  =3 * nconn + 1
*     write(6,'(i5)') nn
*     write(6,'(10i5)') iconn(1:nn)
      numcop0=nconn
      if (iStamp == 1) then
          write(lo,'(a,i10)')
     1  ' Connettivita. No. di legami:',iconn30(1)
          write(lo,'(3(3i4,4x))') iconn30(2:nn)
      endif
!
!-- reset and salve dmax e dmin
!
      ddmin = dmin
      ddmax = dmax
      dmin  = 0.8
!-- crea la tab.coord. con distanze per i legami giaÃƒâ€š  esistenti
      nconn = iconn30(1)
      nnn   = 3 * nconn + 1
      iconn(1:nnn) = iconn30(1:nnn)
      nn=3*iconn(1)
      jtab=1
      if (nn > 0) then
          j=1
          do i=2, nn, 3
             nord1 = iconn(i)
             nord2 = iconn(i+1)
             mg1 = icogr(nord1)
             mg2 = icogr(nord2)
             x(1:3) = xyz30(1:3, nord1)
             y(1:3) = xyz30(1:3, nord2)
             z(1:3) = x(1:3) - y(1:3)
             dmxhh = ( dmnmx(mg1,mg2,2) + dmnmx(mg1,mg2,1) ) / 2
             dist0 = cdist(gdist, z, dist2)
             tabdst(1,j) = nord1
             tabdst(2,j) = nord2
             tabdst(3,j) = dstteo(nord1, nord2)
             tabdst(4,j) = dist0
             tabdst(5,j) = dmnmx(mg1, mg2, 2)
             tabdst(6,j) = 0.
             j=j+1
          enddo 
       endif

!XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

!-- stampa la tab. conn con dst.
      nn = iconn(1)
      if (iStamp == 1) then
          write(lo,*)' '
          write(lo,*)' Tabella connettivita con distanze '
          write(lo,*)' nord1 nord2 distteo  dist distmax codeleg'
!
          do j=1,nn
             write(lo,'(2x,2f6.0,3f7.3,i5)') tabdst(1:5,j),
     *       nint(tabdst(6,j))
          enddo 
      endif
!-- crea la tab. angoli con dst.
      numang=0
      do k=1, nconn-1
         nord11 = tabdst(1,k)
         nord12 = tabdst(2,k)
         code1  = tabdst(6,k)
         dd1    = tabdst(4,k)
         do i=k+1, nconn
            nord21 = tabdst(1,i)
            nord22 = tabdst(2,i)
            code2  = tabdst(6,i)
            dd2    = tabdst(4,i)
            nr1 = 0
            if (nord11.eq.nord21)then
                nr1 = nord11
                nr2 = nord12
                nr3 = nord22
            elseif (nord11.eq.nord22)then
                nr1 = nord11
                nr2 = nord12
                nr3 = nord21
            elseif (nord12.eq.nord21)then
                nr1 = nord12
                nr2 = nord11
                nr3 = nord22
            elseif (nord12.eq.nord22)then
                nr1 = nord12
                nr2 = nord11
                nr3 = nord21
            endif
            if (nr1.gt.0) then
                do j=1,3
                   d1(j) = xyz30(j, nr2) - xyz30(j, nr1)
                   d2(j) = xyz30(j, nr3) - xyz30(j, nr1)
                enddo
                call ang(d1, d2, angle)
                deno = dd1 * dd2
                if (deno.le.1.0e-35) deno=1.0e-5
                angle = angle / deno
                if (angle.gt.1.and.angle.le.1.1) angle=1.0
                if (angle.lt.-1.and.angle.ge.-1.1) angle=-1.0
                angle = acos(angle) * rtod
                numang = numang + 1
                tabang(1,numang) = nr2
                tabang(2,numang) = dd1
                tabang(3,numang) = nr1
                tabang(4,numang) = dd2
                tabang(5,numang) = nr3
                tabang(6,numang) = angle
                tabang(7,numang) = code1
                tabang(8,numang) = code2
            endif
         enddo
      enddo
      numang0 = numang
!-- stampa la tab. angoli con dst.
      if (iStamp == 1) then
          write(lo,*)' '
          write(lo,*)' Tabella angoli con distanze ,N.angoli= ',numang
          write(lo,*)
     1  ' nord1  dist1-2 nord2 dist2-3 nord3   angle codleg1 codleg2'
          do m=1,numang
             write(lo,'(2(i5,4x,f6.2),i5,3x,f7.2,2i6)')
     1       nint(tabang(1,m)),tabang(2,m),
     1       nint(tabang(3,m)),tabang(4,m),
     1       nint(tabang(5,m)),tabang(6,m),
     1       nint(tabang(7,m)),
     1       nint(tabang(8,m))
          enddo
!----
          write(lo,*)' '
          write(lo,"(/,1h ,78('-'),/,1h ,78('-'))") 
          write(lo,*)' '
!
!-- Parte 1: muove gli isolati a dist. di pseudo legame dai frag. 
!
          write(lo,*)' '
          write(lo,*)
     1   'Parte 1: muove gli isolati a dist. di pseudo legame dai frag.'
          write(lo,*)
     1   '============================================================='
      endif
      isofisso = 0
!
!-- controlla che ci sia almeno un frammento con piu' di 1 atomo
!-- se non c'e' sceglie il primo atomo come 'bonded atomo'
!
      ibonded = 0
      do jj=1, nats
         if (numfr(jj) > 1) ibonded = ibonded + 1
      enddo
!
      if (ibonded < nats) then
    1     continue
!
          dmax=dmax*(1+deltapm)
          do ncy=1,ncycle
             deltap=ncy*deltaini
!-- loop sugli isolati
             do i=1, nats
                nfriso=jordfr(serial30(i))
                if (numfr(nfriso).gt.1) cycle
                nordiso = i
                mclusiso = i
                ngiso=icogr(nordiso)
!-- find the closest bonded atom
                distmin=10000.
                nordbondmin=0
                do j1=1, nats
                   nordbond=j1
                   mclusbond=1+nordbond-1
                   if (serial30(mclusbond).le.0) cycle
                   nfrbond=jordfr(serial30(mclusbond))
                   ngbond=icogr(nordbond)
                   if (isofisso.eq.0) then
                       if (numfr(nfrbond).le.1) cycle
                   elseif (isofisso.eq.1) then
                       if (numfr(nfrbond).ne.1.or.j1.eq.i) cycle
                   endif
                   distnew =(1+deltap)*dmnmx(ngbond,ngiso,2)
                   ntot=0
                   idista = idstExpo(nordbond,nordiso,npp,ntot,dst,d,
     *                           yyx,ssx,icn)
                   if (ntot.ne.0)then    
                       do jj=1,ntot
                          if (sqrt(dst(jj)).le.distnew.and.
     *                        sqrt(dst(jj)).lt.distmin) then
                              yy(1:3) = yyx(1:3,jj)
                              if (iStamp == 1) then
                                  write(lo,*)'Prova bond ',
     *                                          nordbond,nordiso
                              endif
                              nev =  nevediang(l15con,nordbond,
     *                                         nordiso,yy,ncy)
                              if (nev > 0)exit
                              distmin=sqrt(dst(jj))
                              distnewsav=distnew
                              nfrbondmin=nfrbond
                              nordbondmin=nordbond
                              nop=npp(jj)
                              do jjj=1,3
                                 yyy(jjj)=yyx(jjj,jj)
                                 sss(jjj)=ssx(jjj,jj)
                              enddo
                          endif
                       enddo
                   endif
                enddo
!-- ha trovato un vicino
                if (nordbondmin.gt.0) then
                    numfr(nfrbondmin)=numfr(nfrbondmin)+1
                    numfr(nfriso)=0
                    if (serial30(mclusiso).ge.0)
     1                  serial30(mclusiso) =
     *                   (serial30(mclusiso)/nzConst)*nzConst+nfrbondmin
                    if (serial30(mclusiso).lt.0)
     1                  serial30(mclusiso)=
     *                   (serial30(mclusiso)/nzConst)*nzConst-nfrbondmin
                    izpk(nordiso)=(izpk(nordiso)/100)*100+nfrbondmin
!-- qui cambia x di nordiso  
                    call  chcooExpo(nordiso, yyy)
!-- aggiunge alla connect.
                    nconn=iconn30(1)
                    nn=1+3*nconn+1
                    iconn30(nn)=min0(nordbondmin,nordiso)
                    iconn30(nn+1)=max0(nordbondmin,nordiso)   
                    iconn30(nn+2)=1
                    iconn30(1)=iconn30(1)+1
!-- crea la tab. conn con dst.
                    tabdst(1,nconn+1)=iconn30(nn)
                    tabdst(2,nconn+1)=iconn30(nn+1)
                    tabdst(3,nconn+1)=dstteo(nordbondmin,nordiso)
                    tabdst(4,nconn+1)=distmin
                    tabdst(5,nconn+1)=distnewsav
                    tabdst(6,nconn+1)=ncy
                    if (iStamp == 1) then
                        write(lo,'(a,2x,2f6.0,3f7.3,2(2x,3f6.3))')
     1                  ' trovato bond ',tabdst(1:5,nconn+1)
                    endif
                endif
             enddo
          enddo
!-- se ci sono ancora isol. controlla se sono a pseudo dist tra di se
          if (isofisso.eq.0) then
              ibonded=0
              do jj=1, nats
                 jjj=jordfr(serial30(jj))
                 if (numfr(jjj) == 1) ibonded = ibonded + 1
              enddo
              if (ibonded.gt.1) then
                  isofisso=1
                  if (iStamp == 1) then
                      write(lo,*)' controlla gli isolati tra di se ' 
                  endif
                  go to 1
              endif
          endif
!
!-- salva xyzs e iconn
!
          if (iStamp == 1) then
              write(lo,*)' '
              write(lo,*)' Salvati dopo aver allungato le bond dist.'
          endif
          nconn=iconn30(1)
          numcop1=nconn
          nnn=3*nconn+1
          iconn(1:nnn)=iconn30(1:nnn)
!
          if (iStamp == 1) then
              write(lo,*)' nord   x       y       z    nfrag '
          endif
          do jj=1, nats
             nnfrag=jordfr(serial30(jj))
             if (iStamp.eq.1)  then
                 write(lo,'(i5,3f8.4,i5)') jj, xyz30(1:3,jj), nnfrag
             endif
             xyzs(1,jj)=xyz30(1, jj)
             xyzs(2,jj)=xyz30(2, jj)
             xyzs(3,jj)=xyz30(3, jj)
          enddo
          nconn=iconn30(1)
          nn=1+3*nconn
          if (iStamp == 1) then
              write(lo,'(a,i10)')
     1      ' Connettivita. No. di legami:',nconn
              write(lo,'(3(3i4,4x))')iconn30(2:nn)
!-- stampa la tab. conn con dst.
              write(lo,*)' '
              write(lo,*)' Tabella connettivita con distanze '
              write(lo,*)' nord1 nord2 distteo  dist distmax codleg'
              nn=iconn(1)
              do j=1,nn
                 write(lo,'(2x,2f6.0,3f7.3,i5)')
     *                 tabdst(1:5,j), nint(tabdst(6,j))
              enddo 
          endif     ! fine if su iStamp
      endif
!-- stampa la tab. angoli con dst.
      if (iStamp == 1) then
          write(lo,*)' '
          write(lo,*)' Tabella angoli con distanze '
          write(lo,*)
     1  ' nord1 dist1-2 nord2 dist2-3 nord3 angle codleg1 codleg2'
          do m=1,numang-1  
             write(lo,'(2(i4,4x,f6.2),i4,3x,f7.2,2i6)')
     1       nint(tabang(1,m)),tabang(2,m),
     1       nint(tabang(3,m)),tabang(4,m),
     1       nint(tabang(5,m)),tabang(6,m),
     1       nint(tabang(7,m)),
     1       nint(tabang(8,m))
          enddo
!
!-- Parte 2: avvicina i fragmenti
!
          write(lo,*)' '
          write(lo,*)' Parte 2: Avvicina i fragmenti'
          write(lo,*)' ============================='
      endif
!      
      call avvfrag(l15con,deltap2,deltapm,ncycle,iStamp)
!
!-- salva su iconn e xyzs
3000  continue
      nconn=iconn30(1)
      numcop2=nconn
      nnn=3*nconn+1
      iconn(1:nnn)=iconn30(1:nnn)
      if (iStamp == 1) write(lo,*)'  Condizioni finali'
!
      mclus = 1
      m15bu = 1
      do jj=1, nats
         nnfrag= jordfr(serial30(jj))
         if (iStamp == 1) write(lo,'(i5,3f8.4,i5)')
*    1       jj, xyz30(1:3,jj), nnfrag
     1       jj, xyzbu(3:5,jj), nnfrag
         xyzs(1,jj)=xyzbu(3, jj)
         xyzs(2,jj)=xyzbu(4, jj)
         xyzs(3,jj)=xyzbu(5, jj)
      enddo
      nconn=iconn30(1)
      nn=1+3*nconn
      if (iStamp == 1) then
          write(lo,'(a,i10)')
     1  ' Connettivita. No. di legami:',nconn
          write(lo,'(3(3i4,4x))')iconn30(2:nn)
!
!-- stampa la tab. conn con dst.
          write(lo,*)'  '
          write(lo,*)' Tabella connettivita con distanze '
          write(lo,*)' nord1 nord2 distteo  dist distmax codleg'
          nn=iconn(1)
          do j=1,nn
             write(lo,'(2x,2f6.0,3f7.3,i5)')tabdst(1:5,j),
     1       nint(tabdst(6,j))
          enddo 
!-- stampa la tab. angoli con dst.
          write(lo,*)' '
          write(lo,*)' Tabella angoli con distanze '
          write(lo,*)
     1  ' nord1  dist1-2 nord2 dist2-3 nord3   angle codleg1 codleg2 '
!
          do ij=1,numang
             inok(ij)=0
          enddo
          do m=1,numang
             iang1 = nint(tabang(1,m))
             iang2 = nint(tabang(3,m))
             iang3 = nint(tabang(5,m))
             do j=1,nn
                idiss1 = nint(tabdst(1,j))
                idiss2 = nint(tabdst(2,j))
!
               if (iang1 == idiss1 .and. iang2 == idiss2) then
                   inok(m) = inok(m) + 1
               endif
               if (iang1 == idiss2 .and. iang2 == idiss1) then
                   inok(m) = inok(m) + 1
               endif
               if (iang2 == idiss1 .and. iang3 == idiss2) then
                   inok(m) = inok(m) + 1
               endif
               if (iang2 == idiss2 .and. iang3 == idiss1) then
                   inok(m) = inok(m) + 1
               endif
!
             enddo
          enddo
!
          do i=1,numang
             do ii=1,8
                tabangsav(ii,i)=tabang(ii,i)
             enddo
          enddo
!
          nokk= 0
          do i=1,numang
             if (inok(i).eq.2) then
                 nokk=nokk+1
                 do ii=1,8
                    tabang(ii,nokk)=tabangsav(ii,i)
                 enddo
             endif
          enddo
          numang = nokk
!
          do m=1,numang
             write(lo,'(2(i5,4x,f6.2),i5,3x,f7.2,2i6)')
     1       nint(tabang(1,m)),tabang(2,m),
     1       nint(tabang(3,m)),tabang(4,m),
     1       nint(tabang(5,m)),tabang(6,m),
     1       nint(tabang(7,m)),
     1       nint(tabang(8,m))
          enddo
!
          write(lo,*)' '
          write(lo,"(/,1h ,78('-'),/,1h ,78('-'))") 
          write(lo,*)' '
      endif     ! fine if su iStamp
!
!-- reset and salve dmax
      dmax=ddmax
      dmin=ddmin
!
      call AllocaBuildStuff(2)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine InitAvvisolati
      USE General
      USE Symmetry
      USE Atomi
      USE BuildStuff
      USE BuildModule
      USE PhaseModule, only: erre
!
      common /contropezza/ exlst3dum(160)
      dimension pic(18),npic15(18),rapic(18),rap(18),inp(18),zatom(10)
      dimension katom(2,10)
!
      integer, allocatable :: nfragm(:)
      integer, allocatable :: nfram(:)
!
      allocate (nfragm(1:MaxAtoms), stat = ierr)
      allocate (nfram(1:MaxAtoms), stat = ierr)
!
      if (MaxAtoms > MaxAtomsBuild) then
          call AllocaBuildStuff(2)
      endif
      if (.not.Allocated(xyzbu)) then
          MaxAtomsBuild = MaxAtoms
          call AllocaBuildStuff(1)
      endif
      do i=1, MaxAtoms
         xyzbu(1:8,i) = 0.0
         numfr(i)  = 0
         kblock(i)=0
      enddo
!
      if (dmaxi.gt.0.5) then
          dmax=dmaxi
      else
          dmax=0.0
      endif
!
      nameh=1
      i=1
      do ij=1,3
         do ji=1,3
            gdist(i)=xgg(ij,ji)
            gdist(i+9)=xgr(ij,ji)
            i=i+1
         enddo
      enddo
!      call xlat(vett)
      focc=1.0/(pts*nsym*(icent+1))   !-- CONTROPEZZA 16/01/2007
      zneutro=1
!--15.7.97
      if (neutro == 0) zneutro = 0
      ihce=0
      do i=1,nk
         zatom(i) = no(i)
         if (no(i).eq.8) ctrloxy = 1
         katom(1,i) = nalf(i)
         katom(2,i) = no(i)
      enddo
!-- FINE CONTROPEZZA 16/01/2007
      if (neutro.ne.0) then
          do i=1,nk
             if (neutro.eq.1) then
                 zatom(i)=abs(cl(i))
             else
                 zatom(i)=zeff(i)
             endif
          enddo
          zneutro = 0
      endif
!      
      if (zatom(1) <= 1.5 .and. neutro == 0) then
          ihh = 1
          do i =1,nats
             if (iabs(nz(i)/nzConst) == 1) then
                 ihh = 0
             endif
          enddo
          ihce = ihh
      endif
      nn3=0
      izmin=9999
      do i= 1,nk
         if (zatom(i) > 8) nn3 = nn3 + 1
         izz = int(zatom(i))
         if (zatom(i).gt.zneutro.and.izz.lt.izmin) then
             izmin=izz
             niz=i
             jtype=nalf(i)
         endif
      enddo
!
!-- crea xyzbu(8,nats)
!
      nghost = 0
      do i=1,nats
         if (nz(i) == 0) then
             izpk(i) = -99999
             nghost = nghost + 1
         else
             iz = iabs( nz(i) ) / nzConst
             izp = nk - iz + 1
             izpk(i) = izp
         endif
         if (xyzs(5,i) <= 0) xyzs(5,i) = 1
         if (xyzs(4,i) <= 0) then
             xyzs(4,i) = iz * 100.
             jpkint = 0
         endif
         ijk = iabs( nz(i) ) / nzConst
         nni = 0
         if (ijk /= 0) nni = no(ijk)
!
!-- xyzbu(1,i)   = num. atomico
!-- xyzbu(2,i)   = i
!-- xyzbu(3:5,i) = x,y,z
!-- xyzbu(6,i)   = b(iso)
!-- xyzbu(7,i)   = occ.
!-- xyzbu(8,i)   = intensita
!
         xyzbu(1,i)   = nni
         xyzbu(2,i)   = i
         xyzbu(3:5,i) = xyzs(1:3,i)
         xyzbu(6,i)   = bfac(i)
         xyzbu(7,i)   = xyzs(5,i)
         xyzbu(8,i)   = xyzs(4,i)
         xyz30(1:5,i) = xyzs(1:5,i)
      enddo
!
      do i=1,nk
         do j=1,nk
            if (nalf(i) == katom(1,j)) then
                zatom(i) = float(katom(2,j))
                exit
            endif
         enddo
      enddo
!
!-- ex aggiornaistore
!
      iconn30(:) = iconn(:)
      nconn = iconn(1)
      do i=1, nats
         nfragm(i)=0
         nfram(i)=0
      enddo
      nfragmm=0
      do j=1,nconn
         i1 = iconn((j-1)*3+2)
         i2 = iconn((j-1)*3+3)
         if (nfram(i1) == 0 .and. nfram(i2) == 0) then
             nfram(i1) = 1
             nfram(i2) = 1
             nfragmm = nfragmm + 1
             nfragm(i1) = nfragmm
             nfragm(i2) = nfragmm
         endif
!
*        kcod = 1
*        do while (kcod == 1)
  200    continue
            do k=1, nats
               if (nfram(k) == 1) then
                   kcod = 0
                   do kk=1, nconn
                      ii1 = iconn((kk-1)*3+2)
                      ii2 = iconn((kk-1)*3+3)
                      if (ii1 == k .and. nfram(ii2) == 0) then
                          nfram(ii2)  = 1
                          nfragm(ii2) = nfragmm
                          kcod = 1
                      endif
                      if (ii2 == k .and. nfram(ii1) == 0) then
                          nfram(ii1)  = 1
                          nfragm(ii1) = nfragmm
                          kcod = 1
                      endif
                   enddo
                   nfram(k) = 2
*                  if (kcod == 1) exit
                   if (kcod == 1) go to 200
               endif
*           enddo
         enddo
      enddo
      do i=1, nats
         if (nfragm(i) == 0) then
             nfragmm   = nfragmm+1
             nfragm(i) = nfragmm
         endif
      enddo
      nfrag = nfragmm
      do i=1, nfrag
         numfr(i) = 0
         do j=1, nats
            if (nfragm(j) == i) then
                numfr(i) = numfr(i) + 1
                if (iabs(izpk(j)) < nzConst) then
                    is=1
                    if (izpk(j) < 0) is = -1
                    izpk(j) = is * (iabs(izpk(j))*nzConst+i)
                elseif (iabs(izpk(j)) >= nzConst) then
                    izpk(i) = (izpk(i)/nzConst) * nzConst + nfragm(i)
                endif
            endif
         enddo
      enddo
      do i=1,nats
         serial30(i) = 3 * nzConst + nfragm(i)
      enddo
!
      deallocate (nfragm, nfram, stat = ierr)
!
!-- ex readpk
!
      epsmin = 0.35
      epsmax = 0.41
      if (erre < 0.15 .and. erre > 0.0) epsmin = 0.54
!
      angi(1)=55.
      angs(1)=180.
!
      angi(2)=85.
      angs(2)=180.
!
      angi(3)=55.
      angs(3)=180.
      ngh=0
      ngl=0
      nok=1
      ngrup=1
      do i=1,9
         inp(i)    = 0
         dmn(i)    = 100
         dmx(i)    = 0
         ive(i)    = 0
         pic(i)    = 0
         npic15(i) = 0
         rapic(i)  = 0
         rap(i)    = 0
         icopk(i)  = 0
         icoel(i)  = 0
         ive3i(i)  = 0
         ive3s(i)  = 0
         ive15i(i) = 0
         ive15s(i) = 0
      enddo
      icogr(:) = 0
      do i=1,9
         do j=1,9
            dmnmx(i,j,1) = 0.
            dmnmx(i,j,2) = 0.
         enddo
      enddo
!--
      n3n=nk-ihce
      l3dum=1
      md=9
      m=l3dum
      dma=0.
      dmi=100.
      ive15i(1)=1
      iii=0
      acum=0.
      ihceh=ihce+1
      nn6=0
      a=0.
      do ii= -nk,-ihceh
         i = iabs(ii)
         ij = nk-i+1
         exlst3dum(m) = 0.
         if (acum.le.0.) ive3i(1) = i
         j0=0
         do j=1,nats
            nzj = iabs(nz(j))
            if (nzj >= nzConst) nzj = nzj / nzConst
            if (nzj /= i) cycle
            if (j0 == 0) then
                j0 = j
                iii = iii + 1
                ive3i(iii) = i
                icoel(i) = 10**(i-1) + icoel(i)
            endif
            exlst3dum(m) = exlst3dum(m) + xyzbu(7,j)
            icogr(j) = iii
            ive15s(iii) = j
            acum = acum + exlst3dum(m)
         enddo
         if (j0.eq.0) cycle
         if (no(i).ge.11.and.neutro.eq.0) ngh = ngh + 1
         if (radii(i,1).ge.dma) dma = radii(i,1)
         if (radii(i,1).le.dmi) dmi = radii(i,1)
         exlst3dum(m+1) = radii(i,1)
         if (neutro == 0) then
             exlst3dum(m+2) = no(i)
         elseif (neutro == 1) then
             exlst3dum(m+2) = cl(i)
         else
             exlst3dum(m+2) = zeff(i)
         endif
         exlst3dum(m+3) = 0
         exlst3dum(m+4) = 0
         exlst3dum(m+5) = 0
         exlst3dum(m+6) = i
         exlst3dum(m+7) = 2
         if (erre < 0.15 .and. erre > 0.0) then
             exlst3dum(m+7)=1 
         endif
         ive15i(iii) = j0
         ive(iii) = 2
         if (erre < 0.15 .and. erre > 0.0) then
             ive(iii)=1 
         endif
         if (zatom(i) > 18)  ive(iii) = 1
         if (zatom(i) == 8)  ive(iii) = 3
         if (zatom(i) == 3)  ive(iii) = 1
         if (zatom(i) == 4)  ive(iii) = 1
         if (zatom(i) == 11) ive(iii) = 1
         if (zatom(i) == 12) ive(iii) = 1
         if (zatom(iii) > 18) exlst3dum(m+7) = 1
         ive3s(iii) = i
         m=m+md 
      enddo
      ngrup=iii
      if (ngrup.eq.0) then
          write(lo,*)' Given peaks cannot be recognized '
          stop 1114
      endif
!--controlla se icogr( ) eq.0
      do j=1,nats
         if (icogr(j) == 0) icogr(j) = 1
      enddo
!--fine "controlla"
      l=l3dum
      dmin=2*dmi-epsmin
      dmax=2*dma+epsmax
      dmin=dmin*dmin
      dmax=dmax*dmax
      do i=1,n3n
         m=l3dum+(i-1)*md
         if (exlst3dum(m).lt.0.00001) cycle
         exlst3dum(m+4)=dmi+exlst3dum(m+1)-epsmin
         if (exlst3dum(m+4).lt.0.8) then
             exlst3dum(m+4)=.8
         endif
         exlst3dum(m+5)=dma+exlst3dum(m+1)+epsmax
         if (exlst3dum(m+5).lt.exlst3dum(m+4)) then
             exlst3dum(m+5)=exlst3dum(m+4)
         endif
         dmn(i)=exlst3dum(m+1)
         dmx(i)=exlst3dum(m+1)
      enddo
!
!-- da namepk
!
      do i=1, ngrup
         inf=ive3i(i)
         mlm=l3dum+(i-1)*md+1
         if (exlst3dum(mlm-1).le.0.) cycle
         isup=ive3s(i)
         dmn(i)=1000.
         dmx(i)=0.
         do j=inf,isup
            if (exlst3dum(mlm) <= dmn(i)) then
                dmn(i)=exlst3dum(mlm)
            endif
            if (exlst3dum(mlm) >= dmx(i)) then
                dmx(i)=exlst3dum(mlm)
            endif
            mlm=mlm+md
         enddo
      enddo
      if (neutro == 0) then
          delta1=0.20
          delta2=0.20
      else
          delta1=0.20
          delta2=0.20
      endif
      do i=1,ngrup
         do j=1,ngrup
            dmnmx(i,j,1)=dmn(i)+dmn(j)-delta1*dmn(i)-delta1*dmn(j)
            if (dmnmx(i,j,1).lt.0.8) then
                dmnmx(i,j,1)=0.8
            endif
            dmnmx(i,j,2)=dmn(i)+dmn(j)+delta2*dmn(i)+delta2*dmn(j)
            if (dmnmx(i,j,2).lt.dmnmx(i,j,1)) then
                dmnmx(i,j,2)=dmnmx(i,j,1)
            endif
         enddo
      enddo
!
      return
      end
!-----------------------------------------------------------------------
!code for nevediang
      function nevediang(l15con,norbon,noriso,yy,nncod)
      USE General
      USE Atomi
      USE BuildStuff
      USE BuildModule
!
!-- avvicina gli isolati al primo atomo che trova a dist .le. distnew
!
      dimension d1(3),d2(3),yy(3)
c
      nevediang = 0
      nn = iconn30(1)
      nor1 = norbon
      nor2 = noriso
      m   = numang+1
      mm1 = nor1
      do i=1,nn
         if (tabdst(1,i) == nor1 .or. tabdst(2,i) == nor1) then
             i2=tabdst(1,i)+tabdst(2,i)-nor1
             it1=0
             if (i.gt.numcop0.and.i.le.numcop1) it1 = 1
             if (i.gt.numcop1.and.i.le.numcop2) it1 = 2
             mm2=i2
             mm3=nor2
             do j=1,3
                d1(j)=xyzbu(j+2,mm2)-xyzbu(j+2,mm1)
                d2(j)=yy(j)-xyzbu(j+2,mm1)
             enddo
             dist2 = gdist(1) * d2(1) * d2(1)
     1             + gdist(5) * d2(2) * d2(2)
     2             + gdist(9) * d2(3) * d2(3)
     3             + gdist(2) * d2(1) * d2(2) * 2.0
     4             + gdist(3) * d2(1) * d2(3) * 2.0
     5             + gdist(6) * d2(2) * d2(3) * 2.0
             dist1 = gdist(1) * d1(1) * d1(1)
     1             + gdist(5) * d1(2) * d1(2)
     2             + gdist(9) * d1(3) * d1(3)
     3             + gdist(2) * d1(1) * d1(2) * 2.0
     4             + gdist(3) * d1(1) * d1(3) * 2.0
     5             + gdist(6) * d1(2) * d1(3) * 2.0
             call ang(d1, d2, angle)
             deno = sqrt(dist1) * sqrt(dist2)
             if (deno.le.1.0e-35) deno = 1.0e-5
             angle = angle / deno
             if (angle.gt.1 .and. angle.le.1.1) angle=1.0
             if (angle.lt.-1 .and. angle.ge.-1.1) angle=-1.0
             angle = acos(angle) * rtod
             iok = 1
             if (angle.ge.angolomn .and. angle.le.angolomx) iok=0
             nevediang = nevediang + iok
             if (iok == 0) then
!-- controlla se e gia storizzato
                 nostore=0
                 do im=1,m-1
                    if (tabang(3,im) == norbon) then
                        if (tabang(1,im) == i2.and.
     1                      tabang(5,im) == noriso.or.
     1                      tabang(1,im) == noriso.and.
     1                      tabang(5,im) == i2) then
                            nostore=1
                            exit
                        endif
                    endif
                 enddo
                 if (nostore == 0) then
                     tabang(1,m) = i2
                     tabang(2,m) = sqrt(dist1)
                     tabang(3,m) = norbon
                     tabang(4,m) = sqrt(dist2)
                     tabang(5,m) = noriso
                     tabang(6,m) = angle
                     tabang(7,m) = tabdst(6,i)
                     tabang(8,m) = nncod
                     m=m+1
                 endif
             endif
         endif
      enddo
      if (nevediang.eq.0) numang = m - 1
!
      return
      end
!-----------------------------------------------------------------------
!code for dstteo
      function dstteo(nor1,nor2)
!
      USE Atomi
      USE BuildStuff
      USE BuildModule
!
!-- crea la tab. distanze teoriche tra gli atomi
      mg1 = icogr(nor1)
      mg2 = icogr(nor2)
      dstteo = ( dmnmx(mg1,mg2,2) + dmnmx(mg1,mg2,1) ) / 2.0
!
      return
      end
!-----------------------------------------------------------------------
!code for movfrappcon
      subroutine movfrappcon(nfri,nord1mos,numcop,iStamp)
!
      USE General
      USE Atomi
      USE BuildStuff
      USE BuildModule
!
!-- avvicina gli altri atomi di in frag. a uno giaÃƒâ€š  mosso (nord1mos)

      dimension yyy(3),sss(3),x(3),y(3),z(3)
      dimension yy(3),ssx(3,200),yyx(3,200),d(3,200),dst(200),npp(200)
!
      icn  = 0  ! gianluca
      kmos = 0
      if (nfri.lt.0) kmos=1
      nfri = iabs(nfri)
      do jj=1, nats
         mosso2(jj)=0
         nfrjj=mod(serial30(jj), nzConst)
         if (kmos.eq.1) nfrjj = kpsfra(jj)
         if (nfrjj.eq.nfri) mosso2(jj) = 1
         if (jj.eq.nord1mos) mosso2(jj) = 2
      enddo
 1000 continue
      nn=numcop
      do ii=1, nn
         nord1 = nint(tabdst(1,ii))
         nord2 = nint(tabdst(2,ii))
         m = mosso2(nord1) + mosso2(nord2)
         if (m.ne.3) cycle
         if (mosso2(nord1).eq.2) nordfix=nord1       
         if (mosso2(nord2).eq.2) nordfix=nord2       
         nordmov=nord1+nord2-nordfix
         dist=tabdst(4,ii)
         ntot=0
         idista=idstExpo(nordfix,nordmov,npp,ntot,dst,d,yyx,ssx,icn)
         do jj=1,ntot
            if (abs(sqrt(dst(jj))-dist).gt.0.01) cycle
            mosso2(nordmov)=2
            mosso(nordmov)=1
            yyy(1:3)=yyx(1:3,jj)
            call  chcooExpo(nordmov, yyy)
            if (iStamp == 1)
     1          write(lo,'(a,2i5,3f6.3)')
     1               'mosso per nordfix:nordmov,yyy',nordfix,nordmov,yyy
            go to 1000 
         enddo
      enddo
!
      return
      end
!-----------------------------------------------------------------------
!code for avvfrag
      subroutine avvfrag(l15con,deltap2,deltapm,ncyc,iStamp)

      USE General
      USE Atomi
      USE BuildStuff
      USE BuildModule
!
!-- avvicina i fragmenti  
!
      dimension ifissati(2500)
      dimension yyy(3),sss(3),x(3),y(3),z(3)
      dimension yy(3),ssx(3,200),yyx(3,200),d(3,200)
     1,dst(200),npp(200),deltadst(200)
     1,dst2(200),npp2(200)
      dimension ssx2(3,200),yyx2(3,200),d2(3,200),yyxx(3)
!
      icn  = 0  ! gianluca
      numcop0=iconn30(1)
!-- prende il frag. con maggior no. di atomi
      icn=0
      icn2=0
      ifissati(1:2500)=0
!-- trova il frag. con maggior no. di atomi
      nfissa=1
      maxnu=-100000
      do i=1,nfrag
         nf=numfr(i)
         if (nf.gt.maxnu) then
             maxnu=nf
             isav=i
         endif
      enddo
      ifissati(isav)=1
1000  continue
      newleg=0
      mosso(1:2500)=0
      mosso2(1:2500)=0
!-- fissa il frag. "da fissare" 
      do i=1, nats
         nfr=jordfr(serial30(i))
         if (nfr.eq.isav) mosso(i) = 1
      enddo
!-- controlla se deve ancora proseguire 
 150  continue
      do i=1, nats
         if (mosso(i).eq.0) go to 99
      enddo
      go to 200
!-- prosegue
  99  continue
      distmin=99999.
      numang0=numang
      do i=1, nats
!-- do sui mobili  
         nfriso=jordfr(serial30(i))
         if (numfr(nfriso).eq.1) cycle
         if (mosso(i).eq.1) cycle
         mgi=icogr(i)
!-- do sui fissi, calcola le dist. ai fissi e conserva la minima 
!-- e il no. di frag.          
!-- anche il nord di j delfrag.2 per creare il legame in conn. (se esiste)
          do j=1, nats
             nfrisj=jordfr(serial30(j))
             if (numfr(nfrisj).eq.1) cycle
             if (mosso(j).eq.0) cycle
             mgj=icogr(j)
             ntot=0
             iii=i
             idista=idstExpo(j,iii,npp,ntot,dst,d,yyx,ssx,icn)
             if (ntot.gt.0) then
                 numang=numang0
                 do jj=1,ntot
                    distnew =(1+deltap2)*dmnmx(mgi,mgj,2)
!-- controlla le dist.
                    if (sqrt(dst(jj)).le.distnew.and.
     *                  sqrt(dst(jj)).lt.distmin)then
                        if (iStamp.eq.1) then
                            write(lo,*)'prova legame fisso-movile',j,i
!-- controlla gli angoli: avvicinato -fisso -legati al fisso
                            write(lo,*)
     1'controlla gli angoli: avvicinato -fisso -legati al fisso '
                        endif
                        yy(1:3)=yyx(1:3,jj)
                        if (nevediang(l15con,j,i,yy,ncyc).gt.0) exit  
!-- controlla gli angoli: fisso-avvicinato-legati al avvicinato, 
!-- (avvicina il fisso al mosso)
                        jjj=j
                        jdista =
     *                  idstExpo(i,jjj,npp2,ntot2,dst2,d2,yyx2,ssx2,icn)
                        if (ntot2.gt.0) then
                            do ii=1, ntot2
                               if (abs(dst2(ii)-dst(jj)).lt.0.001) then
                                   yyxx(1:3)=yyx2(1:3,ii)
                                   exit
                               endif
                            enddo
! 
                            if (iStamp.eq.1) write(lo,*)
     1'controlla gli angoli: fisso-avvicinato-legati al avvicinato' 
                            nev =  nevediang(l15con,i,j,yyxx,ncyc)
                            if (nev > 0) cycle
                            numang0 = numang
                        endif
                        distmin = sqrt(dst(jj))
                        distnewsav = distnew
                        nopp = npp(jj)
                        yyy(1:3) = yyx(1:3,jj)
                        sss(1:3) = ssx(1:3,jj)
                        nfri   = jordfr(serial30(i))
                        nfrfis = jordfr(serial30(j))
                        nord1mos = i
                        nordfis = j
                    endif
                 enddo
             endif
          enddo
      enddo
!
!-- muove il frag. seguendo la conn. e lo fissa
!   
      if (distmin.lt.99999.0) then
!
          mosso(nord1mos)=1
!
!-- muove il frag. seguendo la conn.
!
          call  chcooExpo(nord1mos,yyy)
          numcop=iconn(1)
          if (numfr(nfri).gt.1) then
              call movfrappcon(nfri,nord1mos,numcop,iStamp)
          endif
!
!-- la dist. nord1mos-nordfis e' di legame?
!
          mg1 = icogr(nord1mos)
          mg2 = icogr(nordfis)
!
          distmx = (1+deltapm) * dmnmx(mg1, mg2, 2)
!
          newleg=1
!-- aggiunge alla connect. e cambia il no. di frag. in mclus
          nconn = iconn30(1)
          nn = 1 + 3 * nconn + 1
          iconn30(nn)   = min0(nord1mos,nordfis)
          iconn30(nn+1) = max0(nord1mos,nordfis)   
          iconn30(nn+2) = 1
          iconn30(1)    = iconn30(1) + 1
          if (iStamp.eq.1)
     *     write(lo,*)'new legame conn :',(iconn30(knn),knn=nn,nn+2)
!-- aggiunge alla connect. con dist.
          nconn=nconn+1
          tabdst(1,nconn) = min0(nord1mos,nordfis)
          tabdst(2,nconn) = max0(nord1mos,nordfis)
          tabdst(3,nconn) = dstteo(nord1mos,nordfis)
          tabdst(4,nconn) = distmin
          tabdst(5,nconn) = distnewsav
          tabdst(6,nconn) = ncyc
          if (iStamp.eq.1)
     *     write(lo,'(2x,2f6.0,3f7.3,2(2x,3f6.3))')tabdst(1:5,nconn)
!-- modifica mclus e izpk
          do jjj=1, nats
             nfrjjj=jordfr(serial30(jjj))      
             if (nfrjjj.eq.nfri) then
                 serial30(jjj)=
     *                   nzConst * (serial30(jjj)/nzConst) + nfrfis
                 numfr(nfrfis) = numfr(nfrfis) + 1
                 izpk(jjj) = nzConst * (izpk(jjj)/nzConst) + nfrfis
             endif
          enddo
          go to 150
      elseif (distmin.ge.99999.0.and.newleg.eq.0) then
          isav0=isav
          maxnu=-100000
          minnu=numfr(isav0)
          isav=0
          do i=1,nfrag
             nf=numfr(i)
             if (nf.le.1.or.nf.lt.maxnu.or.ifissati(i).eq.1) cycle
             maxnu=nf
             isav=i
          enddo
          if (isav.le.0) go to 200
          ifissati(isav)=1
          go to 1000
      endif
 200  continue
!
      return
      end 
!-----------------------------------------------------------------------
!code for idstExpo
      function idstExpo(npk,npk2,nop,ntot,dist,dd,yyy,ss,icon)
      USE General, only : gdist
      USE Symmetry
      USE Atomi
*     USE Liste
      USE BuildStuff
      USE BuildModule
!--check if two peaks are closer than dmax (idstExpo=1, ntot=1)
!--check if two peaks are farther than dmax (idstExpo=0, ntot=0)
!--check if two peaks are closer than dm angstroms (idstExpo=0 , ntot=1)
      common /idist/vett(3,4),focc,ihce
      dimension dist(200),nop(200),yx(3,200),d2(3)
      dimension dd(3,200),d(3),yyy(3,200),ddd(3),ss(3,200)
      dimension x(3),y(3),yy(3),z(3),iss(3),sss(3)
!--
!-- per annullare il controllo su kblock (necesario per genhy)
      kkblo = 0
      if (npk2 < 0) then
          npk2 = -npk2
          kkblo = 1
      endif
!-- fine controllo su kblock
      ift1=500*49*10
      ift2=49*10
      ift3=10
      e10=1.0e-10
      idstExpo=0
      istras=0
      dm=dmin
      ntot=0
      do j=1,3
         if (npk.lt.0) z(j) = dist(j)
      enddo
      do j=1,3
         d(j)   = 0.
         d2(j)  = 0.
         ddd(j) = 0.
         y(j)   = 0.
         yy(j)  = 0.
         iss(j) = 0
         sss(j) = 0.
         do n=1,200
            nop(n)   = 0
            dist(n)  = 0.
            dd(j,n)  = 0.
            yyy(j,n) = 0.
            yx(j,n)  = 0.
            ss(j,n)  = 0.
         enddo
      enddo
      if (npk.gt.0 .and. npk2.gt.0) then
          z(1:3) = xyzbu(3:5, npk)
          x(1:3) = xyzbu(3:5, npk2)
      endif
      mm0=0
      i0=1
!
      nn2  = nsym
      ic1x = icent + 1
      nn2p = ncentr
      if ((kblock(npk2).eq.1 .and. kblock(npk).eq.1) .or. 
     1    (kblock(npk2).eq.1 .and. kkblo.eq.0)) then
          nn2  = 1
          ic1x = 1
          nn2p = 1
      endif
      do i=1, nn2
         y(1) = x(1)*kmat(i,1,1) + x(2)*kmat(i,1,2) + x(3)*kmat(i,1,3)
         y(2) = x(1)*kmat(i,2,1) + x(2)*kmat(i,2,2) + x(3)*kmat(i,2,3)
         y(3) = x(1)*kmat(i,3,1) + x(2)*kmat(i,3,2) + x(3)*kmat(i,3,3)
         y(1) = y(1)+tmat(i,1)
         y(2) = y(2)+tmat(i,2)
         y(3) = y(3)+tmat(i,3)
         seg=1.0
         do ii=1,ic1x
            do jj=1,3
               y(jj)=seg*y(jj)
            enddo
            seg=-seg
            do 1060 kkk=1,nn2p
               do nnn=1,3
                  yy(nnn)=y(nnn)+vett(nnn,kkk)
               enddo
               mm0=mm0+1
               do n=1,3
                  yx(n,mm0)=yy(n)
               enddo
               mm=mm0-1
               if (mm /= 0) then
                   do n=1,mm
                      do jj=1,3
                         d2(jj)=yy(jj)-yx(jj,n)
 2011                    if (abs(d2(jj)).le.0.5) cycle
                         d2(jj)=d2(jj)-sign(1.0,d2(jj))
                         go to 2011
                      enddo
                      distt = gdist(1) * d2(1) * d2(1)
     1                      + gdist(5) * d2(2) * d2(2)
     2                      + gdist(9) * d2(3) * d2(3)
     3                      + gdist(2) * d2(1) * d2(2) * 2.0
     4                      + gdist(3) * d2(1) * d2(3) * 2.0
     5                      + gdist(6) * d2(2) * d2(3) * 2.0
                      if (distt.lt.0.6) then
                          mm0=mm0-1
                          go to 1060
                      endif
                   enddo
               endif
!
               do n=1,3
                  sss(n)=0
                  iss(n)=0
                  d(n)=z(n)-yy(n)
                  if ((kblock(npk2).eq.1.and.kblock(npk).eq.1) .or. 
     1                (kblock(npk2).eq.1.and.kkblo.eq.0)) cycle
 1011             if (abs(d(n)).le.0.5) cycle
                  sss(n)=sign(1.0,d(n))+sss(n)
                  d(n)=d(n)-sign(1.0,d(n))
                  ddd(n)=d(n)
                  iss(n)=int(-sign(1.0,d(n))+2 )
                  go to 1011
               enddo
               distt = gdist(1) * d(1) * d(1)
     1               + gdist(5) * d(2) * d(2)
     2               + gdist(9) * d(3) * d(3)
     3               + gdist(2) * d(1) * d(2) * 2.0
     4               + gdist(3) * d(1) * d(3) * 2.0
     5               + gdist(6) * d(2) * d(3) * 2.0
               if (distt.lt.0.001 .and. npk.eq.npk2) go to 1060
               dist0=sqrt(distt)
               istras=iss(1)*100+iss(2)*10+iss(3)
               if (distt.le.dm-icon*0.5) go to 1025
               idstExpo=0
               if (distt.gt.dmax+icon*0.5) go to 1060
1025           continue
               ntot = ntot + 1
               do nnn=1,3
                  if (abs(d(nnn)).lt.e10) d(nnn) = sign(e10, d(nnn))
                  dd(nnn,ntot) = d(nnn)
               enddo
               dist(ntot) = distt
               ici = 1
               if (ii.eq.2) ici = -1
               nop(ntot) = ici*(istras*ift1 + npk2*ift2 + i*ift3 + kkk)
               do nyy=1,3
                  ss(nyy, ntot)  = sss(nyy)
                  yyy(nyy, ntot) = yy(nyy) + sss(nyy)
                  aa = yyy(nyy, ntot)
               enddo
               if (distt.le.dm-icon*0.5) return
               idstExpo = 1
1060        continue
         enddo
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine chcooExpo(nord2,yyy)
*     USE Liste
      USE BuildStuff
!
      real :: yyy(3)
      do  ll=1, 3
          xyzbu(ll+2,nord2) = yyy(ll)
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      real function xshuttleDaEliminare(valore)
      integer   valore, input
      real output
      equivalence (input, output)
!
      input = valore
      xshuttleDaEliminare = output
!
      return
      end
!-----------------------------------------------------------------------
      subroutine sorty(lind,numb,mincc,jump)
!--sorting routine using array storeb --->like integer
!--lind :first address in the list
!--numb :number of elements in the list
!--minc :number of words per element
!--jump :function of the relative address(jaddress) of the variable
!  to be sort   (0.ge.jaddress.le.minc)
!  jump>=0 increasing sorting ( jaddress=jump )
!  jump<0 decreasing sorting ( jaddress=iabs(jump)-1 )
!
!--array to be used : istoreb
      USE BuildModule
      USE BuildStuff
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
!
      if(numb.eq.1)return
      jsign=1
      if(jump.lt.0)then 
        jump=iabs(jump)-1
        jsign=-1
      endif 
      ja=2
 2010 continue
      jb=numb/ja
      if(jb.le.0)jb=1  
      jc=numb-jb
 2040 continue
      jd=0
      m =lind
      do i=1,jc
      mk =m +jb*mincc
      iloca=nint(storeb(m+jump))        
      ilocb=nint(storeb(mk+jump))       
      if(iloca.le.ilocb*jsign)goto 2060 
      mm=m
      mmk=mk
      do je=1,mincc
      a=storeb(mm)
      storeb(mm)=storeb(mmk)
      storeb(mmk)=a
      mm=mm+1
      mmk=mmk+1
      enddo
      jd=1
 2060 continue
      m =m +mincc
      enddo
      if(jd.gt.0) goto 2040 
      if(jb.gt.1) then 
        ja=ja*2
        go to 2010
      endif
      return
      end
