!-----------------------------------------------------------------------
      subroutine ViewMaps(map1, np)
      USE General
!
      implicit none
      integer            :: np(3), kk, jop, jopen, istat, iform, ier
      integer            :: Lung, iy, iz
      real               :: map1(1:np(1), 1:np(2), 1:np(3))
!
      kk = Lung(StructureName)
      cardDiret = StructureName(1:kk) // '_tmp.dmp'
!
      istat = 0
      iform = 2
      jop = jopen(jrel, cardDiret, istat, iform, ier)
!
      write(jrel) cell(1:6), SpaceGroup, np(1:3)
      do iz =1, np(3)
         do iy =1, np(2)
            write(jrel) map1(1:np(1), iy, iz)
         enddo
      enddo
      close(jrel)
!
      card(1) = '-a -w' // char(0)
      card(2) = cardDiret(1:Lung(cardDiret)) // char(0)
      call startJav(card, 2)
!
      return
      end
!-----------------------------------------------------------------------
!    PDB routines
!-----------------------------------------------------------------------
code for checknum
      subroutine checknum(jav,ifnum)
c--controllo che il carattere sia un numero
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xchar/id,ie,ib,ic,ia,ih,numb(10),iplus, inus,ipoint
c
      ifnum=1
      do j=1,10
         if (numb(j).eq.jav) then
             ifnum=0
             return
          endif
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      integer function kQualeResiduo(name)
      USE Groups
!
!-- returns the position of name in array AminoName3
!-- i.e. if name = ASN, then returns 3
!-- if name is not allowed returns the lenght of AminoName3
!-- corresponding to DUM
!
      character (len=*)  :: name
      character (len=3)  :: buff
!
      buff = '   '
      k = Lung(name)
      buff(1:k) = name(1:k)
      call ucase(buff)
      n = size(AminoName3)
      kQualeResiduo = n
      do i=1, n
         if (buff == AminoName3(i)) then
             kQualeResiduo = i
             exit
         endif
      enddo
!
      return
      end
!------------------------------------------------------------------
      integer function kQualeTipoAtomo(name)
      USE Groups
!
!-- returns the position of name in array TipoAtomo
!-- i.e. if name = CA, then returns 2
!-- if name is not allowed returns the lenght of TipoAtomo
!-- corresponding to DUM
!
      character (len=*)  :: name
      character (len=3)  :: buff
!
      buff = '   '
      k = Lung(name)
      buff(1:k) = name(1:k)
      call ucase(buff)
      n = size(TipoAtomo)
      kQualeTipoAtomo = n
      do i=1, n
         if (buff == TipoAtomo(i)) then
             kQualeTipoAtomo = i
             exit
         endif
      enddo
!
      return
      end
!------------------------------------------------------------------
      character*3 function QualeResiduo(k)
      USE Groups
!
!-- returns the name corresponding to AminoName3(k)
!-- i.e. if k = 3, then returns ASN
!-- if k is not allowed returns DUM
!
      n = size(AminoName3)
      if (k < n .or. k > n) then
          QualeResiduo = AminoName3(n)
      else
          QualeResiduo = AminoName3(k)
      endif
!
      kQualeTipoAtomo = k
!
      return
      end
!------------------------------------------------------------------
      character*3 function QualeTipoAtomo(k)
      USE Groups
!
!-- returns the name corresponding to TipoAtomo(k)
!-- i.e. if k = 2, then returns CA
!-- if k is not allowed returns DUM
!
      n = size(TipoAtomo)
      if (k < n .or. k > n) then
          QualeTipoAtomo = TipoAtomo(n)
      else
          QualeTipoAtomo = TipoAtomo(k)
      endif
!
      return
      end
!------------------------------------------------------------------
      subroutine outPDB(nunit, numbPDB, ifFast, ifREM, filtra)
      USE General
      USE Symmetry
      USE Solutions
      USE RemoModule
      USE Atomi, only : nzConst
!
!-- nunit   = logical unit (file must be already opened)
!-- numbPDB > 0 number of atoms to export
!--         < 0 all atoms in binary file are exported
!-- ifFast  = 0  atoms coordinates are fetched from binary file
!--         = 1  atoms coordinates are fetched from xyzs (Atomi module)
!-- ifREM   = 0  no REMs are added to the file
!--         > 0  REMs are added to the file (MAD info)
!
      implicit none
      integer :: nunit, numbPDB, ifFast, ifREM, ihydr, Lung, i, j, l, k
      integer :: nzeta, nch, ii, nCatena, nresid, n, iser, ich, kk
      integer :: NSYMP, NSYMTZ, NSPGR, MAXSYM, uij(6), plusCatena
      integer :: filtra
      parameter (MAXSYM = 192)
      real    :: origx(3,3), rmpdb(3,3), rmipdb(3,3), txxx, angoli(3)
      real    :: xtemp(5), RSYM(4,4,MAXSYM)
      character (len= 1) :: Catena, LTYPE, insertCode, oldCatena, alt
      character (len= 2) :: a2
      character (len= 4) :: a4a, a4b, a4c
      character (len= 6) :: a6
      character (len=10) :: SPGRNAM, PGNAM
!
      ihydr = 0
!
!-- HEADER
!
      Inte = Titolo
      call shift(Inte, l)
      write(Buffer1,1111) Inte
      Buffer1(62:) = ' '
      write(nunit,'(a)') Buffer1(1:Lung(Buffer1))
!
!-- REMARKS
!
      if (ifREM > 0) then
          do i=1, ifREM
             write(nunit,'(a)') card(i)(1:Lung(card(i)))
          enddo
      endif
!
!-- CRYST1
!
      call SpaceGroupCCP4(NSPGR,SPGRNAM,PGNAM,NSYMP,NSYMTZ,RSYM,LTYPE)
      Inte = SPGRNAM
      nzeta = totop
      write(nunit,1130) cell(1:6), Inte(1:11), nzeta
!
!-- ORIGX
!
      do i=1,3
         do j=1,3
            origx(i,j)=0.0
            if (i.eq.j) origx(i,j)=1.0
         enddo
         txxx=0.0
         write(nunit,1135)i,(origx(i,j),j=1,3),txxx
      enddo
!
      do i=1,3
         angoli(i) = cell(i+3) * dtor
      enddo
!
!-- metrica diretta
!
      rmpdb(1,1) =  cell(1)                          ! a
      rmpdb(1,2) =  0
      rmpdb(1,3) =  0
      rmpdb(2,1) =  cell(2) * cos(angoli(3))         !  b*cos(gam)
      rmpdb(2,2) =  cell(2) * sin(angoli(3))         !  b*sin(gam)
      rmpdb(2,3) =  0
      rmpdb(3,1) =  cell(3) * cos(angoli(2))         !  c*cos(bet)
      rmpdb(3,2) = -cell(3) * sin(angoli(2))
     1                     * cos(asta(4))          ! -c*sin(bet)*cos(alfs)
      rmpdb(3,3) =  1.0 / asta(3)                    !  1./cstar
!
!-- metrica inversa
!
      rmipdb(1,1) =  1.0 / cell(1)                    !  1./a
      rmipdb(1,2) =  0
      rmipdb(1,3) =  0
      rmipdb(2,1) = -cos(angoli(3)) /
     1               (cell(1) * sin(angoli(3)))       !  -cos(gam)/(a*sin(gam))
      rmipdb(2,2) =  1.0 / (cell(2) * sin(angoli(3))) !  1./(b*sin(gam))
      rmipdb(2,3) =  0
      rmipdb(3,1) =  asta(1) * cos(asta(5))           !  astar*cos(bets)
      rmipdb(3,2) =  asta(2) * cos(asta(4))           !  bstar*cos(alfs)
      rmipdb(3,3) =  asta(3)                          !  cstar
!
!-- SCALE
!
      do i=1, 3
         write(nunit,1136)i,(rmipdb(j,i),j=1,3), txxx
      enddo
!
!-- ATOM / HETATM
!
      nresid = 666
      nch = 64
      iser = 0
      nCatena = 0
      oldCatena = '*'
      plusCatena = 0
      do ii=1, size(model)
         if (.not.allocated(model(ii)%atoms)) cycle
         do j=1, MonomerInModel(ii)
            if (ifRemo == 1) then
                if (finsolcan(WhichSolution)%flag(ii,j) < 0) cycle
            endif
            nch = nch + 1
            do i=1, natsInModel(ii)
               if (filtra == 1) then
                   if (model(ii)%HETA(i,j)  < 0) then
                       cycle
                   endif
               endif
               kk = model(ii)%specie(i,j) / nzConst
               if (kk == 0) cycle
               kk = iabs(kk)
               a2 = Species(kk)(1:2)
               call ucase(a2)
               if (a2(2:2) == ' ') then
                   a2(2:2) = a2(1:1)
                   a2(1:1) = ' '
               endif
               nresid = mod(model(ii)%specie(i,j), nzConst)
               xtemp(:) = 0.0
               do l=1,3
                  do n=1,3
                     xtemp(l)=xtemp(l)+rmpdb(n,l)*model(ii)%atoms(n,i,j)
                  enddo
               enddo
               xtemp(4) = model(ii)%atoms(5,i,j)
               xtemp(5) = model(ii)%th_fact(i,j)
               iser = iser + 1
               Catena = model(ii)%Catena(i,j)
               if (Catena /= ' ') then
                   if (Catena /= oldCatena) then
                       plusCatena = plusCatena + 1
                       oldCatena = Catena
                   endif
                   ich = ichar(Catena)
                   ich = ich + nCatena
                   Catena = char(ich)
               endif
**             model(ii)%tipoAtomo(i,j)(4:4) = model(ii)%Alternate(i,j)
               alt = model(ii)%Alternate(i,j)
               a4a = model(ii)%tipoAtomo(i,j)
               a4b = model(ii)%tipoResiduo(i,j)
               call ucase(a4a)
               call ucase(a4b)
               if (a4a == '    ') then
                   a4a = a2
               endif
               if (a4b == '    ') then
                   a4b = 'HET'
                   a6  = 'HETATM'
               else
                   a6  = 'ATOM  '
               endif
!
! -- se DNA allora va conservata la D iniziale nel tipoResiduo 
! -- da commentare per mantenere la D
!
*              if (ifDNA > 0) then
*                  k = index(a4b, 'D')
*                  if (k > 0) then
*                      a4b(k:K) = a4b(k+1:k+1)
*                      a4b(k+1:k+1) = ' '
*                  endif
*             endif
              if (model(ii)%HETA(i,j) >= 0) then
                  if (model(ii)%HETA(i,j) == 1) then
                      a6  = 'HETATM'
                  else
                      a6  = 'ATOM  '
                  endif
              endif
               if (Catena == ' ') then
                   Catena = 'A'
               endif
               n = model(ii)%numResiduo(i,j)
               if (n == 0 .and. ifProtein == 0) then
                   n = i
               endif
               insertCode = model(ii)%Insertion(i,j)
               call ucase(insertCode)
*              write(nunit,10) a6, iser, a4a, alt, a4b, Catena,
               if (model(ii)%HETA(i,j) == 1) then
                   a4c = a4a(1:4)
               else
                   if (a4a(4:4) == ' ') then
                       a4c = ' ' // a4a(1:3)
                   else
                       a4c = a4a(1:4)
                   endif
               endif
               write(nunit,10) a6, iser, a4c, alt, a4b, Catena,
     *                         n, insertCode, xtemp(:), a2
!
!-- ANISOU
!
               if (model(ii)%bij(1,i,j) > 0.0) then
                   uij(1) = model(ii)%bij(1,i,j) * 10000.0 * BijToUij_11
                   uij(4) = model(ii)%bij(2,i,j) * 10000.0 * BijToUij_12
                   uij(5) = model(ii)%bij(3,i,j) * 10000.0 * BijToUij_13
                   uij(2) = model(ii)%bij(4,i,j) * 10000.0 * BijToUij_22
                   uij(6) = model(ii)%bij(5,i,j) * 10000.0 * BijToUij_23
                   uij(3) = model(ii)%bij(6,i,j) * 10000.0 * BijToUij_33
                   a6 = 'ANISOU'
                   write(nunit,20) a6, iser, a4c, alt, a4b, Catena, n,
     *                             uij(:),a2
               endif
            enddo
            nCatena = nCatena + plusCatena
            oldCatena = '*'
         enddo
      enddo
      write(nunit,1155)
!
      return
*  10 format(a,i5,2x,2a4,a1,i4,a1,3x,3f8.3,2f6.2,10x,a2)
   10 format(a6,i5,' ',a4,a1,a4,a1,i4,a1,3x,3f8.3,2f6.2,10x,a2)
** 10 format(a6,i5,'  ',a3,a1,a4,a1,i4,a1,3x,3f8.3,2f6.2,10x,a2)
   20 format(a6,i5,' ',a4,a1,a4,a1,i4,2x,6i7,6x,a2)
 1110 format('HEADER',4x,18a4)
 1111 format('HEADER',4x,a)
 1130 format('CRYST1',3f9.3,3f7.2,1x,a,i4)
 1135 format('ORIGX',i1,4x,3f10.6,f15.5)
 1136 format('SCALE',i1,4x,3f10.6,f15.5)
 1155 format('END')
!
      return
      end
!-----------------------------------------------------------------------
      subroutine SincronizzaSpecieRemo()
      USE General
      USE Atomi
      USE Molcom
      USE RemoModule
      USE Properties
!
      implicit none
      integer :: i, j, nkk, nkOLd, nkNew, puntatore(18)
      integer :: iabsnz, kk, lnz, ritorna, zero
!
!-- Species contiene le specie atomiche dal file esterno
!-- vSpecie contiene le specie atomiche in AtmProperties
!
      zero = 0
      ritorna = 1
      nkOld = AtmProperties(zero)%nSpecies
      nkNew = nk
      nkk = max0(nkOld, nkNew)
      do i=1, nkk
         call lcase(Species(i))
         call lcase(vSpecie(i))
      enddo
!
!-- check if sync is necessary
!
      do i=1, nkOld
         if (vSpecie(i) /= ' ') then
             ritorna = 0
             exit
         endif
      enddo
!
      if (ritorna == 1) then
          return
      endif
!
      ritorna = 1
      do i=1, nkNew
         if (Species(i) == ' ') exit
         do j=1, nkOld
            if (vSpecie(j) /= Species(i)) then
                ritorna = 0
                exit
             endif
         enddo
      enddo
!
      if (ritorna == 1) then
          return
      endif
!
      do i=1, nkk
         do j=1, nkk
            if (Species(i) == vSpecie(j)) then
                puntatore(i) = j
                exit
            endif
         enddo
      enddo
*     do i=1, nkk
*        do j=1, nkk
*           if (vSpecie(i) == Species(j)) then
*               puntatore(i) = j
*               exit
*           endif
*        enddo
*     enddo
      do i=1, natsInModel(WhichModel)
         iabsnz = iabs(model(WhichModel)%specie(i,1))
         if (iabsnz > 0) then
             kk = mod(model(WhichModel)%specie(i,1), nzConst)
             lnz = iabsnz / nzConst
             if (lnz <= 0) then
                 j=0
             endif
             lnz = puntatore(lnz)
             model(WhichModel)%specie(i,1) = lnz * nzConst + kk
         endif
      enddo
!
      Species(1:18) = vSpecie(1:18)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine SincronizzaSpecie()
      USE General
      USE Atomi
      USE Molcom
      USE RemoModule
!
      integer puntatore(18), dividi1, dividi2
!
      if (QualePgm == SIRPROTPGM .and. ifPDBt==0) then
          vSpecie(:) = ' '
          vSpecie(1:nk) = Species(1:nk)
          nkSav = nk
          nalfSav(1:5) = nalf(1:5)
          nk = nkd
          nalf(1:5) = nalfd(1:5)
         
      endif
      do i=1, nk
         write(Species(i),'(a4)') nalf(i)
         call lcase(Species(i))
         call lcase(vSpecie(i))
      enddo
      do i=1, nk
         do j=1, nk
            if (vSpecie(i) == Species(j)) then
                puntatore(i) = j
                exit
            endif
         enddo
      enddo
      !
      if (QualePgm == SIRPROTPGM .and. ifPDBt==0) then
        ! nel caso che la specie nel frammento della substruttura (p.es da Shelx/Solve) sia scritto con formato errato)
        if (count(puntatore(1:nk) > 0) == 0) then
             puntatore(1) = 1 ! prendiamo la prima specie nell'elenco delle specie "heavy" (MAD/MIR)
        endif
      endif
      !
      dividi1 = nzConst
      dividi2 = nzConst
      
      do i=1, nats
         if (QualePgm == SIRPROTPGM .and. ifPDBt == 0) then
             if (iabs(model(WhichModel)%specie(i,1)) > nzConst-1) then
                 dividi1 = nzConst
                 dividi2 = 1
             else
                 dividi1 = 1
                 dividi2 = 1
             endif
         endif
         lnz = iabs(model(WhichModel)%specie(i,1)) / dividi1
         lnz = puntatore(lnz) * dividi2
         model(WhichModel)%specie(i,1) = lnz
      enddo
!
      if (QualePgm == SIRPROTPGM .and. ifPDBt==0) then
          nk = nkSav
          nalf(1:5) = nalfSav(1:5)
      endif
!
      return
      end
!-----------------------------------------------------------------------
!    CLUSTER routines
!-----------------------------------------------------------------------
      subroutine test03 (xpoints, ypoints, mm, rho, nClust, nc, iv, ipr)
!
!! TEST03 tests JOINER.
!

      integer i
      integer m
      integer n
      integer nc
      integer, allocatable, dimension ( : ) :: p
      integer, allocatable, dimension ( : ) :: pp
      real *8 rho
      real xpoints(mm), ypoints(mm)
      integer nClust(mm)                                 !pgMAD1512
      real *8, allocatable, dimension ( :, : ) :: x
      real, allocatable, dimension ( :, : ) :: BariC
      
!      real BariC(10, 2)
      logical scambia
    
!      write ( 6, '(a)' ) ' '
!      write ( 6, '(a)' ) 'TEST03'
!      write ( 6, '(a)' ) '  JOINER uses a simple clustering algorithm.'

      m = 0
      do i=1,mm
         if (xpoints(i) > 0) then
            m = i
         end if
      end do
      
      if (m == 0) then
         return
      end if
   
      if (ipr > 0) then
          write ( 6, '(a)' ) ' '
          write ( 6, '(a,i6)' ) 'Number of data items is M  = ', m
          write ( 6, '(a,i6)' ) 'Dimension of the data items is N = 2'
          write ( 6, '(a)' ) ' '
      endif

      allocate ( p(1:m) )
      allocate ( pp(1:m) )
      allocate ( x(1:m,2) )

      do i=1, m
         x(i, 1) = xpoints(i)
         x(i, 2) = ypoints(i)
      end do
    
!        rho = 4.0
!        rho = 1.0
    
      if (ipr > 0) then
          write ( 6, '(a)' ) ' '
          write ( 6, '(a,g14.6)' ) 'Using a cluster parameter of RHO = '
     *                            , rho
      endif
        n = 2 
        call joiner ( m, n, x, rho, p, nc )
    
      if (ipr > 0) then
          write ( 6, '(a,i6)' ) '  Number of clusters created was ', nc
      endif
     
        ifZ = 0
        do i = 1, m
!           write ( 6, '(2x,i6,2f10.3,i6)' ) i, x(i, 1), x(i,2), p(i)
           if (p(i) == 0) then
              ifZ = 1
           end if
        end do
        if (ifZ == 1) then
           nc = nc + 1
           do i = 1, m
              if (p(i) == 0) then
                 p(i) = nc
              end if
           end do
        end if

        allocate ( BariC(1:nc,2) )

        if (nc > 1) then
           do j=1, nc
              BariC(j, 1) = 0.0
              BariC(j, 2) = 0.0
              npp = 0
              do i = 1, m
                 if (p(i) == j) then
                    BariC(j, 1) = BariC(j, 1) + x(i, 1)
                    BariC(j, 2) = BariC(j, 2) + x(i, 2)
                    npp = npp + 1
                 end if
              end do
              BariC(j, 1) = BariC(j, 1) / npp
              BariC(j, 2) = BariC(j, 2) / npp
              nClust(j) = j
           end do
           do i=1, nc-1
              do j=i+1, nc
                 if (scambia(BariC(i, 1), BariC(j, 1), iv)) then
                    Tmp = BariC(j, 1)
                    BariC(j, 1) = BariC(i, 1)
                    BariC(i, 1) = Tmp
                    mp = nClust(j)
                    nClust(j) = nClust(i)
                    nClust(i) = mp
                 end if
              end do
           end do
           
           pp(:) = p(:)
           
           NewC = 0
           do i=1, nc
              NewC = NewC + 1
              do j = 1, m
                 if (pp(j) == nClust(i)) then
                    p(j) = NewC
                 end if
              end do
           end do
        end if

!        write ( 6, '(a)' ) '  clusters modificati:'
!        do i = 1, m
!           write ( 6, '(2x,i6,2f10.3,i6)' ) i, x(i, 1), x(i,2), p(i)
!        end do
        
        nClust(:) = 0
        nClust(1:m) = p(1:m)
                
!        j1 = 1
!        j2 = 2
!        rows = 40
!        columns = 100
    
!        call cluster_d_show ( m, n, x, j1, j2, p, rows, columns )


      deallocate ( p )
      deallocate ( pp )
      deallocate ( x )
      deallocate ( BariC )

      return
      end
!-----------------------------------------------------------------------
      logical function scambia(xi, xj, iv)
      
      scambia = .false.
      if (iv > 0) then
         if (xi < xj) then
            scambia = .true.
         end if
      else
         if (xi > xj) then
            scambia = .true.
         end if
      end if
      return
      end
!-----------------------------------------------------------------------
      subroutine joiner ( m, n, x, rho, p, nc )

!*******************************************************************************
!
!! JOINER uses a very simple cluster assignment algorithm.
!
!  Discussion:
!
!    JOINER implements an ad hoc construction of clusters without any
!    special optimal chararacteristics.
!
!  Algorithm:
!
!    1: NC = 0
!
!    2: If all X's have been assigned, return.
!
!    3: NC = NC + 1
!
!    4: Find an element X(I) which has not been assigned to a cluster,
!       and whose distance to all other unassigned elements is maximum.
!       This element becomes the first element of a new cluster,
!       whose centroid is initially equal to X(I).
!
!    5: Any unassigned elements which are closer to the centroid of the
!       NC-th cluster than to any other, and for which this distance
!       is less than RHO, are now assigned to cluster NC.  Each element
!       added to the cluster requires the recalculation of the centroid.
!
!    6: Go to 2.
!
!  Modified:
!
!    24 April 2002
!
!  Reference:
!
!    Helmuth Spaeth,
!    Cluster Analysis Algorithms
!    for Data Reduction and Classification of Objects,
!    Ellis Horwood, 1980, page 46-48,
!    QA278 S6813.
!
!  Parameters:
!
!    Input, integer M, the number of rows of X.
!
!    Input, integer N, the number of columns of X.
!
!    Input, real ( kind = 8 ) X(M,N), the data to be clustered.
!
!    Input, real ( kind = 8 ) RHO, a clustering tolerance.  To join a cluster,
!    a new point has to be within RHO of the representative.
!    RHO should not be negative.
!
!    Output, integer NC, the number of clusters created.
!
!    Output, integer P(M), the cluster assignments.
!
      implicit none

      integer m
      integer n
    
      double precision  f
      double precision  h
      integer i
      integer j
      integer nc
      integer p(m)
      integer q(m)
      integer r
      double precision  rho
      double precision  s(m,n)
      integer u
      double precision  x(m,n)

      nc = 0
      
      if ( m <= 0 ) then
        return
      end if
      
      p(1:m) = 0
      
      if ( rho < 0.0D+00 ) then
        write ( 6, '(a)' ) ' '
        write ( 6, '(a)' ) 'JOINER - Fatal error!'
        write ( 6, '(a)' ) '  RHO must be nonnegative.'
        call cstop(' ')
      end if
      
      do

        r = 0
        u = 0
        h = 0.0D+00
!      
!      Determine H, the largest distance between two unassigned points.
!  
        do i = 1, m-1
          if ( p(i) == 0 ) then
            u = i
            do j = i+1, m
              if ( p(j) == 0 ) then
                f = sum ( ( x(i,1:n) - x(j,1:n) )**2 )
                if ( h < f ) then
                  h = f
                  r = i
                end if
              end if
            end do
          end if
        end do
!       
!  If we didn't find any pair of points to consider, then there
!  are either 1 or 0 points left.  Take care of the case of 1 point
!  left, and then exit.
!
        if ( r == 0 ) then
          if ( u /= 0 ) then
            nc = nc + 1
            p(u) = nc
          end if
          exit
        end if
!
!  The cluster begins with a single point, R.
!
        nc = nc + 1
        p(r) = nc
        q(nc) = 1
        s(nc,1:n) = x(r,1:n)
      
        do
   
          h = huge ( h )
!
!  Search for an unassigned point, and record its distance
!  to the centroid of cluster NC.
!
          do i = 1, m
            if ( p(i) == 0 ) then
              f = sum ( ( s(nc,1:n) - x(i,1:n) )**2 )
              if ( f < h ) then
                h = f
                r = i
              end if
            end if
          end do
!
!  If no unassigned points are near enough to the centroid, exit
!  the loop.
!
          if ( rho < sqrt ( h ) ) then
            exit
          end if
!
!  Otherwise, assign point R to cluster NC, adjust the centroid,
!  and go back to search for more points to add.
!
          p(r) = nc
          q(nc) = q(nc) + 1

          s(nc,1:n) = ( real(q(nc)-1) * s(nc,1:n) + x(r,1:n) ) 
     *               / real(q(nc))
        end do

      end do

      return
      end
!-----------------------------------------------------------------------
!    CELL CONTENT routines
!-----------------------------------------------------------------------
      subroutine ManageWeight(value, iAction, Moltiplica)
      USE General
      USE Symmetry
      USE MadModule
!
!-- iAction = 1   Get unit cell content from weight value
!-- iAction = 2   Get unit cell content from the number of residues
!
      character(len=2)  :: c2
      character(len=4)  :: c4
      integer           :: Moltiplica(18)
!
      value = value * totop * ZValue
      if (iAction == 1) then
          residui = value / 108.7
      else
          residui = value
      endif
      numeroResidui = nint(residui)
!
      if (nk > 0) then
          Moltiplica(1:nk) = 0
!
!-- gli HETAM non devono essere moltiplicati per il numero di molecole
!             (ZValue = nMol, vale solo per le catene)
!
!         nw(1:nk) = nw(1:nk) * totop * ZValue
          nw(1:nk) = nw(1:nk) * totop          ! dedi 22/06/09 
      endif 
      nw(nk+1:) = 0
      kk = 0
      if (QualePgm == SIRPGM) then
! - h
          c2 = 'h   ' ; indice = jAddResid(kk, c2)
          nw(indice) = nw(indice) + nint( 8.00 * residui )
          read(c2,'(a4)') nalf(indice)
      endif
! - c
      c2 = 'c   ' ; indice = jAddResid(kk, c2)
      nw(indice) = nw(indice) + nint( 5.00 * residui )
      read(c2,'(a4)') nalf(indice)
! - n
      c2 = 'n   ' ; indice = jAddResid(kk, c2)
      nw(indice) = nw(indice) + nint( 1.35 * residui )
      read(c2,'(a4)') nalf(indice)
! - o
      c2 = 'o   ' ; indice = jAddResid(kk, c2)
      nw(indice) = nw(indice) + nint( 1.50 * residui )
      read(c2,'(a4)') nalf(indice)
! - s
      ifSelenio = 0
      if (kmad == 1 .and. QualePgm == SIRPGM) then
          do i=1, nAnom
             write(c4,'(a4)') kAnom(i)
             call lcase(c4)
             if (c4(1:2) == 'se') then
                 ifSelenio = 1
             endif
          enddo
      endif
      if (ifSelenio == 0) then
          c2 = 's   ' ; indice = jAddResid(kk, c2)
          kZolfi = nint( 0.05 * residui )
          if (kmad == 1) then
              if (kZolfi > nw(indice)) then
                  nw(indice) = kZolfi
              endif
          else
              nw(indice) = nw(indice) + nint( 0.05 * residui )
          endif
          read(c2,'(a4)') nalf(indice)
      endif
!
      Moltiplica(nk+1:nk+kk) = 0
      nk = nk + kk
!
      do i=1, nk
         write(Species(i),'(a4)') nalf(i)
      enddo
!
      return
      end
!----------------------------------------------------------------------
      function jAddResid(kk, c2)
      USE General
!
      character(len=2)  :: c2
!
      if (nk == 0) then
          kk = kk + 1
          jAddResid = kk
      else
          read(c2,'(a4)') kc2
          iOK = 1
          do i=1, nk
             if (kc2 == nalf(i)) then
                 iOK = 0
                 jAddResid = i
                 exit
             endif
          enddo
          if (iOK == 1) then
              kk = kk + 1
              jAddResid = nk + kk
          endif
      endif
!
      return
      end
!----------------------------------------------------------------------
      subroutine GetSequence(lix3, Moltiplica, ier)
      USE General
      USE Symmetry
      USE Molcom
      USE Groups
      USE elements
!
      implicit none
      integer :: i, iH, jH, inizNk, itype, iform, jop, ierr, jopen
      integer :: ifRSeq, L, nExC, ier, Lung, lix3, nHetGr
      integer :: nalfAmino(18), nwAmino(18), mer(26), idrogeno
      integer :: Moltiplica(18), prev, Formato, nwTemp(18)
      real    :: totw
      character (len=2) :: a2
      character (len=4) :: Hydr, dire, Am2(4)
!
      i = no(1)
      nwTemp(1:18) = nw(1:18)
      nw(:) = 0
      mer(:) = 0
      call InitResidues()
!
!-- 1 residuo contiene mediamente
!          8.00 idrogeni 
!          5.00 carboni
!          1.50 ossigeni
!          1.35 azoto
!          0.05 zolfo
!--  peso molecolare medio del residuo circa 110 D (Dalton)
!                              
      Am2(1) = 'c   '
      Am2(2) = 'n   '
      Am2(3) = 'o   '
      Am2(4) = 's   '
      nwAmino(:) = 0
      if (nk > 0) then
          nalfAmino(1:nk) = nalf(1:nk)
          nwAmino(1:nk) = nw(1:nk)
      endif
!
      Hydr = 'h   '
      read(Hydr,'(a4)') iH
      jH = 0
      if (nk > 0) then
          do i=1, nk
             if (nalf(i) == iH) then
                 jH = i
                 exit
             endif
          enddo
          inizNk = nk + 1
      else
          inizNk = 1
      endif
      if (jH == 0) then
          nk = nk + 1
          jH = nk
          nalfAmino(jH) = iH
      endif    
!
!-- open Sequence file
!
      nResid = 0
      nAcid  = 0
      totw = 0.0
      cardImage = SeqFile
      itype = 2
      iform = 1
      jop = jopen(jrel, SeqFile, itype, iform, ierr)
      if (jop == 0) then
          nChains = 0
          ResInChains(:) = 0
          Sequence(:) = 0
          prev = 0
          ifRSeq = -1
          do
             read(jrel,'(a)',end = 10) buffer_ctrl_M
             call filtra(buffer_ctrl_M)
             cardImage = buffer_ctrl_M
             call shift(cardImage, L)
             if (L < 0) then    ! blank line
                 cycle
             endif
             call ucase(cardImage)
             if (cardImage(1:1) == '>') then
                 if (nChains > 0) then
                     ResInChains(nChains) = nResid - prev
                 endif
                 prev = nResid
                 nChains = nChains + 1
                 ifRSeq = 0
             elseif (ifRSeq == -1) then
                 Msg = 'Cannot read the sequence file.' // char(10) //
     *                 ' Maybe not in FASTA format'
                 call MsgWinErr('Sequence Error', Msg, ERR_WINDOW, nExC)
                 ier = -1
                 return
             else
                 if (ifRSeq == 0) then
                     call AnalizeSequence(ifRSeq)
                 endif
                 tChains(nChains) = ifRSeq
**               write(lo,35) nChains, cardImage(1:L)
                 if (ifRSeq == 1) then
                     call ScanRSequence(Am2, nalfAmino, nwAmino, ier)
                 else
                     call ScanNSequence(mer, ier)
                 endif
             endif
             if (ier < 0) exit
          enddo
   10     if (nChains == 0) then
              nChains = 1
          endif
          close(jrel)
!
          ResInChains(nChains) = nResid - prev
          if (ZValue > 1) then
              call DuplicaSequenza
          endif
!
          numeroResidui = sum(ResInChains(1:nChains))
          if (ier < 0) then
              Msg = 'Garbage in sequence file:'//char(10)//
     *           SeqFile(1:Lung(SeqFile))
              call MsgWinErr('Sequence Error', Msg, ERR_WINDOW, nExC)
              ier = -1
              return
          endif
      else
          Msg = 'Open error on sequence file:'//char(10)//
     *          SeqFile(1:Lung(SeqFile))
                 call MsgWinErr('Sequence Error', Msg, ERR_WINDOW, nExC)
          ier = -1
          return
      endif
!
      if (ier < 0) then
          Msg = 'Incongruences in Sequence directive:'//char(10)//
     *           cardImage(1:Lung(cardImage))
                 call MsgWinErr('Sequence Error', Msg, ERR_WINDOW, nExC)
      else
!
!-- caso di sequenza senza zolfo
!
          if (nwAmino(nk) == 0) then
              nk = nk - 1
          endif
!         nwAmino(jH) = (nResid - nAcid) * 8
!         nwAmino(:) = nwAmino(:) * totop * ZValue
!         nalf(1:nk) = nalfAmino(1:nk)
!         nw(1:nk) = nwAmino(1:nk)
!         Moltiplica(1:nk) = 0
!         lix3 = 1
!-- Nmol > 1 vale solo per catene della sequenza e non per HETATM -  19/12/2007 dedi
!  (Nmol = n.tot catene nella asym.unit: n. catene/molecola * n. molecole in asym.unit)
          nwAmino(jH) = (nResid - nAcid) * 8 / ZValue
          do i = 1,nk
             nwAmino(i) = nwAmino(i) - nw(i)
             nwAmino(i) = nwAmino(i) * totop * ZValue
             nw(i) = nw(i) * totop + nwAmino(i)
             nalf(i) = nalfAmino(i)
             write(dire,'(a4)') nalf(i)
             no(i) =  z_from_specie(dire)
             Moltiplica(i) = 0
          enddo
          lix3 = 1
      endif
!
      nChainsInput = nChains
!
* *   ifDNA = 0
* *   if (nResidStored > 0) then
* *       ifDNA = 0
* *   elseif (nAcid > 0) then
* *       ifDNA = 1
* *   endif
      ifDNA = 1
      do i=1, nChains
         if (tChains(i) == 1) then
             ifDNA = 0
             exit
         endif
      enddo
!
!-- print sequence
!
      call WriteSequence(Buffer1)
!
      if (ier < 0) return
!
      if (nAcid > 0) then
          nHetGr = 0
          do i=1, 26
             if (mer(i) > 0) then
                 nHetGr = nHetGr + 1
                 write(SmallIt(nHetGr),20) '  ' // char(i+64), mer(i)
             endif
          enddo
!
          call ScanHetGroups(nHetGr, 2, ier)
*         nw(:) = nw(:) * ZValue
          Moltiplica(1:nk) = 0
          lix3 = 1
      endif
      idrogeno = -1
      do i=1, nk
         write(a2,'(a2)') nalf(i)
         call lcase(a2)
         if (a2 == 'h ') then
             idrogeno = i
         endif
      enddo
!
      call CalcolaNumeroMonomeri(idrogeno)
      nw(1:18) = nw(1:18) + nwTemp(1:18) * totop
!
      call AllocaAtomi(2)
      call AllocaBonds(99)
      call AllocaModelRemo(2)
!
      return
   20 format(a,2x,i3)
      end
!----------------------------------------------------------------------
      subroutine CalcolaNumeroMonomeri(idrogeno)
      USE General
      USE Symmetry
      USE Param
      USE Groups
      USE Properties
      USE RemoModule
      USE Groups
!
      implicit none
      integer :: i, j, jj, k, nRes, v, s, idrogeno, vs(2,20)
      real    :: atomVol, n_at, diffe, diffeMin, sogliaVol
      character (len=4) :: dire
!
      tab21(:) = 0
      if (ifDNA == 0) then
          sogliaVol = 25
      else
          sogliaVol = 23
      endif
      i = 1
      if (i == 0) return
      if (knw > 0) write(6,*) 'CALCOLA ', nk, nw(1:nk)
*     write(lo,10)
      diffeMin = 100
      do NumeroMonomeri=1, 20
         n_at = 0.0
         v_m  = 0.0
         do i = 1,nk
*           if (no(i) /= 1) then
            if (i /= idrogeno) then
                v_m = v_m + 14.0 * float(nw(i)) * NumeroMonomeri ! 14=2*nz(azoto)
                n_at = n_at + nw(i) * NumeroMonomeri
            endif
         enddo
*        write(6,*) 'CALCOLA ', volume, costanteMatthews
!--- Matthews' number
         v_m = volume / v_m
!--- Percent of Protein
         v_p = costanteMatthews / v_m
         v_s = 1.0 - v_p
         atomVol = volume / n_at
         vs(1,NumeroMonomeri) = nint(v_p*100)
         vs(2,NumeroMonomeri) = nint(v_s*100)
         if (atomVol < sogliaVol .and. NumeroMonomeri > 1) then
*            write(lo,20) NumeroMonomeri, v_m, 
*    *                    nint(v_p*100), nint(v_s*100), atomVol
             exit
         else
             jj = NumeroMonomeri
             diffe = abs(43-atomVol)
             if (diffe < diffeMin) then
                 diffeMin = diffe
                 j = NumeroMonomeri
                 v = nint(v_p*100)
                 s = nint(v_s*100)
             endif
*            write(lo,20) NumeroMonomeri, v_m, 
*    *                    nint(v_p*100), nint(v_s*100), atomVol
         endif
      enddo

!
      NumeroMonomeri = j
      if (jj > NumeroMonomeri) then
          NumeroMonomeri = NumeroMonomeri + 1
      endif
*     write(lo,30) NumeroMonomeri,
*    *             vs(1,NumeroMonomeri), vs(2,NumeroMonomeri)
      tab21(1) = NumeroMonomeri
!
      if (NumeroMonomeri > 1) then
*     if (NumeroMonomeri > 1000) then
          nat   = nat   * NumeroMonomeri
          nw(:) = nw(:) * NumeroMonomeri
          do k=1, NumeroMonomeri-1
             ResInChains(nChains*k+1: nChains*(k+1)) = 
     *          ResInChains(1:nChains)
          enddo
          nRes = sum(ResInChains(1:nChains))
          nChains = nChains * NumeroMonomeri
*         nChainsInput = nChains
          nResidStored = nResidStored * NumeroMonomeri
          do k=1, NumeroMonomeri-1
             Sequence(nRes*k+1: nRes*(k+1)) = Sequence(1:nRes)
          enddo
*         AtmProperties(WhichProps)%nat = nat
*         AtmProperties(WhichProps)%natsInCell(1:18) = nw(1:18)
*         MonomerInModel(:) = NumeroMonomeri !da verificare se monomer in input
          tChains(1:NumeroMonomeri) = tChains(1)
      endif
!
      NumeroMonomeriExp = NumeroMonomeri
      
      return
   10 format(/,'Monomer(s) Matthews coef. Protein  Solvent '
     *         'Volume per atom')
   20 format(i5,3x,f14.2,2(i8,'%'), f14.2,f8.2)
   30 format(/,i2,'   monomer(s) expected  Protein volume =',i3,
     *            '%  Solvent volume =',i3,'%',/)
   40 format(/,i2,'/',i1,' monomer(s) expected  Protein volume =',i3,
     *            '%  Solvent volume =',i3,'%')
      end
!---------------------------------------------------------------------
      subroutine DuplicaSequenza
      USE General
      USE Groups
!
      implicit none
      integer :: nChainsToAdd, nc, RiC, RiCT, i, j, k
!
      nChainsToAdd = ZValue - 1
      RiCT = sum(ResInChains(1:nChains))
      nc = nChains
      do i=1, nChainsToAdd
         RiC = 0
         do j=1, nChains
            nc = nc + 1
            ResInChains(nc) = ResInChains(j)
            tChains(nc) = tChains(j)
            do k=1, ResInChains(j)
               RiC = RiC + 1
               RiCT = RiCT + 1
               Sequence(RiCT) = Sequence(RiC)
            enddo
         enddo
      enddo
!
      nChains = nChains * ZValue
      nResid = sum(ResInChains(1:nChains))
      nAcid  = 0
      do i=1, nChains
         if (tChains(i) == 2) then
             nAcid = nAcid + ResInChains(i)
         endif
      enddo
!
      return
      end
!----------------------------------------------------------------------
*      subroutine N_GetSequence(lix3, Moltiplica, ier)
*      USE General
*      USE Symmetry
*      USE Groups
*      USE Molcom
*!
*      integer nalfAmino(18), mer(26)
*      integer Moltiplica(18), prev
*      character*4 Hydr
*!
*      call InitResidues()
*!
*      Hydr = 'h   '
*      read(Hydr,'(a4)') iH
*      jH = 0
*      if (nk > 0) then
*          do i=1, nk
*             if (nalf(i) == iH) then
*                 jH = i
*                 exit
*             endif
*          enddo
*          inizNk = nk + 1
*      else
*          inizNk = 1
*      endif
*      if (jH == 0) then
*          nk = nk + 1
*          jH = nk
*          nalf(jH) = iH
*      endif    
*!
*!-- open Sequence file
*!
*      nHetGr = 0
*      nResid = 0
*      nAcid  = 0
*      totw = 0.0
*      cardImage = SeqFile(2)
*      itype = 2
*      iform = 1
*      jop = jopen(jrel, SeqFile(2), itype, iform, ierr)
*      if (jop == 0) then
*          nChains = 0
*          ResInChains(:) = 0
*          Sequence(:) = 0
*          prev = 0
*          do
*             read(jrel,'(a)',end = 10) buffer_ctrl_M
*             call filtra(buffer_ctrl_M)
*             cardImage = buffer_ctrl_M
*             call shift(cardImage, L)
*             call ucase(cardImage)
*             if (cardImage(1:1) == '>') then
*                 if (nChains > 0) then
*                     ResInChains(nChains) = nResid - prev
*                 endif
*                 prev = nResid
*                 nChains = nChains + 1
*             else
*                 call ScanNSequence(mer)
*             endif
*          enddo
*   10     if (nChains == 0) then
*              nChains = 1
*          endif
*          ResInChains(nChains) = nResid - prev
*          close(jrel)
*      else
*          Msg = 'Open error on sequence file:'//char(10)//
*     *          SeqFile(2)(1:Lung(SeqFile))
*                 call MsgWinErr('Sequence Error', Msg, ERR_WINDOW, nExC)
*          ier = -1
*          return
*      endif
*!
*      if (ier < 0) then
*          Msg = 'Incongruences in Sequence directive:'//char(10)//
*     *           cardImage(1:Lung(cardImage))
*                 call MsgWinErr('Sequence Error', Msg, ERR_WINDOW, nExC)
*      else
*!
*!-- store sequence
*!
*          call frm07()     
*!
*!-- print sequence
*!
*          call WriteSequence(2, Buffer1, lo, lo, 1)
*          nw(:) = nw(:) * totop
*          nHetGr = 0
*          do i=1, 26
*             if (mer(i) > 0) then
*                 nHetGr = nHetGr + 1
*                 write(SmallIt(nHetGr),20) '  ' // char(i+64), mer(i)
*             endif
*          enddo
*!
*          call ScanHetGroups(nHetGr, 2, ier)
*          nw(:) = nw(:) * ZValue
*          Moltiplica(1:nk) = 0
*          lix3 = 1
*      endif
*!
*      return
*   20 format(a,2x,i3)
*      end
!----------------------------------------------------------------------
      subroutine AnalizeSequence(ifRSeq)
!
      USE General
      USE Groups
!
!-- ifRSeq = 1  if the sequence contains residues
!--          2  if the sequence contains nucleic acids
!
      character(len= 1)  :: Amino1
      character(len=11)  :: Acids
!
      ifRSeq = 2
      Acids = 'ACEGPRTUXYZ'
      call shift(cardImage, nchars)
      if (cardImage(1:1) == ' ') return
      call ucase(cardImage)
      L = Lung(Acids)
!
      do i=1, nchars 
         Amino1 = cardImage(i:i)
         if (Amino1 == ' ') cycle
         iFound = 0
         do j=1, L
            if (Amino1 == Acids(j:j)) then
                iFound = 1
                exit
            endif
         enddo
         if (iFound == 0) then
             ifRSeq = 1
             return
         endif
      enddo
!
      return
      end
!----------------------------------------------------------------------
      subroutine ScanRSequence(Am2, nalfAmino, nwAmino, ier)
      USE General
      USE Groups
      character(len=1)  :: Amino1
      character(len=4)  :: Am2(4)
      dimension nalfAmino(18), nwAmino(18)
!
      call shift(cardImage, nchars)
      if (cardImage(1:1) == ' ') return
      call ucase(cardImage)
      do i=1, nchars 
         Amino1 = cardImage(i:i)
         if (Amino1 == ' ') cycle
         if (Amino1 == '*') cycle
         if (Amino1 == '-') cycle
         if (Amino1 == 'X') Amino1 = 'A'
         k = ichar(Amino1)
         k = k - 64
         nResid = nResid + 1
         ich = ichar(Amino1)
         if (ich < 65 .or. ich > 90) then
             ier = -1
             return
         endif
         Sequence(nResid) = ich
         call AddToContent(k, Am2, nalfAmino, nwAmino)
      enddo
!
      return
      end
!----------------------------------------------------------------------
      subroutine ScanNSequence(mer, ier)
      USE General
      USE Molcom
      USE Groups
      character(len=1)  :: Amino1
      integer mer(26)
!
      call shift(cardImage, nchars)
      if (cardImage(1:1) == ' ') return
      call ucase(cardImage)
      do i=1, nchars
         Amino1 = cardImage(i:i)
         if (Amino1 == ' ') cycle
!!!      if (Amino1 == 'X') cycle   Commentato Gianluca 21/07/20 x 5i4s
         if (Amino1 == '-') cycle
         nResid = nResid + 1
         nAcid  = nAcid  + 1
         Sequence(nResid) = ichar(Amino1)
         k = ichar(Amino1)
         if (k < 65 .or. k > 90) then
             ier = -1
             return
         endif
         k = k - 64
! Gianluca 27/07/20
! non considera la X per il calcolo del contenuto e del volume
         if (k /= 24) then
             mer(k) = mer(k) + 1
         endif
      enddo
!
      return
      end
!----------------------------------------------------------------------
      subroutine AddToContent(k, Am2, nalfAmino, nwAmino)
      USE General
      USE Groups
      character(len=4)    ::  Am2(4)
      dimension nalfAmino(18), nwAmino(18)
!
      do i=1, 4 
         read(Am2(i),'(a4)') nf
         if (nk == 0) then
             nk = 1
             iOK = nk
         else
             iOK = 0
             do j=1, nk
                if (nf == nalfAmino(j)) then
                    iOK = j
                    exit
                endif
             enddo
             if (iOK == 0) then
                 nk = nk + 1
                 iOK = nk
             endif
         endif
         nalfAmino(iOK) = nf
         nwAmino(iOK) = nwAmino(iOK) + AminoContent(k,i)    
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine GetHetGroups(nHetGr, ier)
      USE General
      USE Molcom
!
      implicit none
      integer  :: nHetGr, ier, cifra, lenp, lend, Lung, L
!
      nHetGr = 0
      call shift(cardDiret,lenp)
      if (lenp <= 0) then
          ier = -1
          return
      endif
      do
         call cutst(cardDiret,lenp,direttiva,lend)
         if (lend == 0) then
             exit
         endif
         cifra = ichar(cardDiret(1:1))
         if (cifra >= 48 .and. cifra <= 57) then
             nHetGr = nHetGr + 1
             SmallIt(nHetGr)  = ' '
             if (lend == 3) then
                 SmallIt(nHetGr)(1:3)  = direttiva(1:lend)
             elseif (lend == 2) then
                 SmallIt(nHetGr)(2:3)  = direttiva(1:lend)
             elseif (lend == 1) then
                 SmallIt(nHetGr)(3:3)  = direttiva(1:lend)
             endif
             call cutst(cardDiret,lenp,direttiva,lend)
             SmallIt(nHetGr)(5:) = direttiva(1:lend)
         else
             nHetGr = nHetGr + 1
             SmallIt(nHetGr)  = ' '
             if (lend == 3) then
                 SmallIt(nHetGr)(1:3)  = direttiva(1:lend)
             elseif (lend == 2) then
                 SmallIt(nHetGr)(2:3)  = direttiva(1:lend)
             elseif (lend == 1) then
                 SmallIt(nHetGr)(3:3)  = direttiva(1:lend)
             endif
         endif
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine ScanHetGroups(nHetGr, Quale, ier)
      USE General
      USE Symmetry
      USE Molcom
!
!-- Quale = 1   Scan for Het Groups
!-- Quale = 2   Scan for nucleic acids (??)
!
      integer Moltiplica(18), nalfSav(18), nwSav(18), Quale
!
      nwSav(1:18)   = nw(1:18)
      nalfSav(1:18) = nalf(1:18)
      nkSav = nk
      if (Quale == 1) then
          write(lo,20) nHetGr
      else
*         write(lo,25)
      endif
      itype = 2
      iform = 1
      jop = jopen(kform, hetero, itype, iform, ierr)
      if (jop < 0) then
          Msg = 'Open error, files is ' // hetero 
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          ier = -1
          return
      endif
      do i=1, nHetGr
         nGr = 1
         rewind kform
         iFound = 0
         do 
            read(kform,'(a)',end=10) Buffer1
            if (Buffer1(1:3) == SmallIt(i)(1:3)) then
                iFound = 1
                exit
            endif
         enddo
   10    if (iFound == 0) then
             Msg = 'Nucleic acid ' // SmallIt(i)(1:3) // ' unknown.' 
     *             // char(10) // 'Check sequence file'
             call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
             ier = -1
             exit
         else
             Inte = ' '
             Inte(1:3) = Buffer1(1:3)
             SmallIt(i)(1:3) = ' '
             call shift(SmallIt(i),L)
             if (L > 0) then
                 nGr = nint(Valore(SmallIt(i)))
             endif
             Buffer1(1:3) = ' '
             call shift(Buffer1,L)
             write(lo,30) Inte(1:3), nGr*ZValue, Buffer1(1:L)
             ifMolt = 0
             call lcase(Buffer1)
             call getcon(Buffer1, direttiva, Moltiplica, ifMolt, nnk) 
             nw(1:nnk) = nw(1:nnk) * nGr * totop * ZValue
*            write(6,'(2hp ,10(a4,2x))') nalfSav(1:nk)
*            write(6,'(2hp ,10(i4,2x))') nwSav(1:nk)
*            write(6,'(2h  ,10(a4,2x))') nalf(1:nnk)
*            write(6,'(2h  ,10(i4,2x))') nw(1:nnk)
             if (nnk < 0) then
                 ier = -1
                 exit
             endif
             do k=1, nnk
                iFound = 0
                do j=1, nkSav
                   if (nalfSav(j) == nalf(k)) then
                       nwSav(j) = nwSav(j) + nw(k)
                       iFound = j
                       exit
                   endif
                enddo
                if (iFound == 0) then
                    nk = nk + 1
                    nalfSav(nk) = nalf(k)
                    nwSav(nk) = nw(k)
                endif
             enddo
*            write(6,'(2hd ,10(a4,2x))') nalfSav(1:nk)
*            write(6,'(2hd ,10(i4,2x))') nwSav(1:nk)
             nkSav = nk
         endif
      enddo
!
      write(lo,*)
      close(kform)
      nw(1:18)   = nwSav(1:18)
      nalf(1:18) = nalfSav(1:18)
!
      return
   20 format(' Added ',i2,' Het Group(s) to the unit cell content',/)
   25 format(
     * ' Added the content of the nucleic acids to the unit cell',/)
   30 format(3x,a,i10,' * (',a,')') 
      end
!-----------------------------------------------------------------------
      subroutine WriteSequence(Buffer)
      USE General
      USE Groups
!
      implicit none
      integer :: nC, tC, nR, nR1, nR2, nLines, i, j, k, kk, k1 , Lung
      character (len=*) :: Buffer
!
!-- check if a sequence is available
!

      if (nChains == 0) then
          return
      endif
!
      write(lo,20) SeqFile(1:Lung(SeqFile))
      if (nChains == 1) then
          write(lo,30) 
      else
          write(lo,31) nChains
      endif
!
      nR1 = 0
      nR2 = 0
      k = 0
      do nC =1, nChains
         tC = tChains(nC)
         if (nChains > 1) then
             if (tC == 1) then
                 write(lo,60) nC
             else
                 write(lo,65) nC
             endif
         endif
         nR = ResInChains(nC)
         if (tC == 1) then
             nR1 = nR1 + nR
         else
             nR2 = nR2 + nR
         endif
         kk = 50
         nLines = nR / kk
         do i=1, nLines
            Buffer = ' '
            do j=1, kk
               k = k + 1
               Buffer(j:j) = char(Sequence(k))
            enddo
            write(lo,35) (Buffer(k1:k1+9), k1=1,41,10)
         enddo
         kk = nR - nLines * kk
         if (kk > 0) then
             Buffer = ' '
             do j=1, kk
                k = k + 1
                Buffer(j:j) = char(Sequence(k))
             enddo
             write(lo,35) (Buffer(k1:k1+9), k1=1,41,10)
         endif
      enddo
      nResidStored = nR1
!
      if (nR1 > 0 .and. nR2 > 0) then
          write(Inte,40) nR1, nR2
      else
          if (nR1 > 0) then
              write(Inte,45) nR1
          else
              write(Inte,46) nR2
          endif
      endif
      call OneBlankOnly(Inte)
      write(lo,'(/,a,/)') Inte(1:Lung(Inte))
!
      return
!
   20 format(/,' Sequence from file ',a,/)
   30 format(  
     *' Content of the target asymmetric unit according to ',
     *'the sequence:',/)
   31 format(  
     *' Content of the target asymmetric unit according to ',
     *'the sequence (',i2,' chains):',/)
   35 format('   ',5(a10,' '))
*  36 format(5(a10,' '))
   40 format(' Stored ',i5,' residues and ',i5,' nucleotides.')
   45 format(' Stored ',i5,' residues ')
   46 format(' Stored ',i5,' Nucleotides.')
   60 format(' - Chain #',i2,' (Residues)')
   65 format(' - Chain #',i2,' (Nucleotides)')
      end
!-----------------------------------------------------------------------
      subroutine WriteExpSequence(Buffer)
      USE General
      USE Groups
      USE RemoModule
!
      implicit none
      integer :: nC, nR, nLines, i, j, k, kk, k1 , L, Lung, nRes
      integer :: istat, iform, jop, jopen, ier
      character (len=*) :: Buffer
!
!-- check if a sequence is available
!

      if (nChains == 0) then
          return
      endif
!
!-- restart from input sequence
!
      if (NumeroMonomeriExp > 1) then
          nat   = nat   / NumeroMonomeriExp
          nw(:) = nw(:) / NumeroMonomeriExp
      endif
!
      tab21(2) = NumeroMonomeri
      if (NumeroMonomeri > 1) then
          nat   = nat   * NumeroMonomeri
          nw(:) = nw(:) * NumeroMonomeri
          nChains = nChains * NumeroMonomeri
          nChainsInput = nChains
          do k=1, NumeroMonomeri-1
             ResInChains(nChains*k+1: nChains*(k+1)) =
     *          ResInChains(1:nChains)
          enddo
          nRes = sum(ResInChains(1:nChains))
          nResidStored = nResidStored * NumeroMonomeri
          do k=1, NumeroMonomeri-1
             Sequence(nRes*k+1: nRes*(k+1)) = Sequence(1:nRes)
          enddo
          tChains(1:NumeroMonomeri) = tChains(1)
      endif
!
      SeqFile = nome(1:lnome) // '_Expected.seq'
*     write(lo,20) SeqFile(1:Lung(SeqFile))
      istat = 0
      iform = 1
      jop = jopen(jhost, SeqFile, istat, iform, ier)
!
      Inte = nome(1:lnome)
      call ucase(Inte)
      L = Lung(Inte)
      k = 0
      do nC =1, nChains
         write(jhost,30) Inte(1:L), char(64+nC)
*        write(jhost,'(a)') ' '
         nR = ResInChains(nC)
         kk = 80
         nLines = nR / kk
         do i=1, nLines
            Buffer = ' '
            do j=1, kk
               k = k + 1
               Buffer(j:j) = char(Sequence(k))
            enddo
            write(jhost,35) Buffer(1:80)
         enddo
         kk = nR - nLines * kk
         if (kk > 0) then
             Buffer = ' '
             do j=1, kk
                k = k + 1
                Buffer(j:j) = char(Sequence(k))
             enddo
             write(jhost,35) Buffer(1:kk)
         endif
      enddo
      close(jhost)
!
      return
!
   20 format(/,' Written Sequence file ',a,/)
   30 format('>',a,':',a1,'|PDBID|CHAIN|SEQUENCE')
   35 format(a)
      end
!-----------------------------------------------------------------------
      subroutine WritePirSequence(Buffer, print_unit, unit, stampaInfo)
      USE General
      USE Groups
!
!-- print_unit = print logical unit
!-- unit       = logical unit to write the sequence
!
      implicit none
      integer :: print_unit, unit, stampaInfo
      integer :: istat, iform, jop, jopen, ier, nR1, nR2, iOK
      integer :: tC, nC1, nC2, nLines, i, j, k, kk, k1 , k2, n, Lung
      integer :: nDiversi, nDiversiMax, nInChain
      real    :: percDiversi
      character (len=*) :: Buffer
!
!-- check if a sequence is available
!
      if (nChainsInput == 0) then
          return
      endif
!
!-- check if at least a resid sequence is available
!
      nValidChains = 0
      do nC1=1, nChainsInput
         tC = tChains(nC1)
         if (tC == 1) then
             nValidChains = nValidChains + 1
         else
             ResInChains(nC1) = -ResInChains(nC1)
         endif
      enddo
      if (nValidChains == 0 .and. nAcid == 0) then
          return
      endif
!
!-- check for empty chains
!
      nValidChains = 0
      do nC1=1, nChainsInput
         nR1 = ResInChains(nC1)
         if (nR1 <= 0) then
             cycle
         endif
         nValidChains = nValidChains + 1
      enddo
      if (nValidChains == 0) then
          if (nAcid == 0) then
              return
          else
              ResInChains(:) = iabs(ResInChains(:))
          endif
      endif
!
!-- check for equal chains
!
      nInChain = 0
      nDiversiMax = -9999
      iOK = 1
      Uguali: do nC1=1, nChainsInput-1
         nR1 = ResInChains(nC1)
         if (nR1 <= 0) then
             cycle
         endif
         do nC2=nC1+1, nChainsInput
            nR2 = ResInChains(nC2)
            if (nR2 <= 0) then
                cycle
            endif
            if (nR1 /= nR2) then
                cycle
            endif
            if (nInChain == 0) then
                nInChain = nR2
            endif
            k1 = sum(abs(ResInChains(1:nC1-1)))
            k2 = sum(abs(ResInChains(1:nC2-1)))
            nDiversi = 0
            do k=1, nR2
               if (Sequence(k1+k) /= Sequence(k2+k)) then
*                  exit Uguali
                   nDiversi = nDiversi + 1
                   if (nDiversi > nDiversiMax) then
                       nDiversiMax = nDiversi
                   endif
               endif
            enddo
            iOK = iOK + 1
            exit
         enddo
      enddo Uguali
!
      if (nDiversiMax > 0) then
          percDiversi = float(nDiversiMax) / float(nInChain)
      else
          percDiversi = 0.0
      endif
      if (iOK == nValidChains .and. percDiversi < 0.05) then
          nMonomer = nValidChains
          iOK = 0
          do nC1=1, nChainsInput
             nR1 = ResInChains(nC1)
             if (nR1 <= 0) then
                 cycle
             else
                 if (iOK == 0) then
                     iOK = 1
                 else
                     ResInChains(nC1) = -ResInChains(nC1)
                 endif
             endif
          enddo
      endif
!
      k = index(SeqFile,'.',.TRUE.)
      Buffer = SeqFile(1:k) // 'pir'
      istat = 0
      iform = 1
      jop = jopen(unit, Buffer, istat, iform, ier)
      if (stampaInfo == 1) then
          if (knw /= 0) then
              write(print_unit,10) Buffer(1:Lung(Buffer))
              write(print_unit,28)
          endif
      endif
      write(unit,26)
      Buffer = ' '
      write(unit,'(a)') Buffer(1:55)
      if (stampaInfo == 1) then
          if (knw /= 0) then
              write(print_unit,'(5x,a)') Buffer(1:55)
          endif
      endif
!
*         write(6,*) 'nChains',nChains
*         write(6,*) 'ResInChains', ResInChains(1:nChains)
*         nResid=sum(ResInChains(1:nChains))
*         write(6,*) 'nResid', nResid
*         write(6,*) 'Sequence',Sequence(1:nResid)
          k = 0
          j = 0
      Buffer = ' '
      do nC1 =1, nChainsInput
         nR1 = ResInChains(nC1)
         if (nR1 <= 0) then
             k = k + iabs(nR1)
             cycle
         endif
         do n=1, nR1
            k = k + 1
            j = j + 1
            if (j > 50) then
                write(unit,36) (Buffer(k1:k1+9), k1=1,41,10)
                if (stampaInfo == 1) then
                    if (knw /= 0) then
                      write(print_unit,38) (Buffer(k1:k1+9), k1=1,41,10)
                    endif
                endif
                j = 1
                Buffer = ' '
            endif
            Buffer(j:j) = char(Sequence(k))
         enddo
      enddo
      j = j + 1
      if (j > 50) then
          write(unit,36) (Buffer(k1:k1+9), k1=1,41,10)
          if (stampaInfo == 1) then
              if (knw /= 0) then
                  write(print_unit,38) (Buffer(k1:k1+9), k1=1,41,10)
              endif
          endif
          j = 1
          Buffer = ' '
      endif
      Buffer(j:j) = '*'
      write(unit,36) (Buffer(k1:k1+9), k1=1,41,10)
      if (stampaInfo == 1) then
          if (knw /= 0) then
              write(print_unit,38) (Buffer(k1:k1+9), k1=1,41,10)
              write(print_unit,'(a)') ' '
          endif
      endif
!
      close(unit)
      ResInChains(1:nChainsInput) = iabs(ResInChains(1:nChainsInput))
!
      return
!
   10 format(/,' Sequence exported in file ',a,':'/)
   26 format('>---------+----------+----------+----------+----------+')
   28 format(5x,
     *       '>---------+----------+----------+----------+----------+')
   35 format('   ',5(a10,' '))
   36 format(5(a10,' '))
   38 format(5x,5(a10,' '))
      end
!-----------------------------------------------------------------------
      subroutine ContaGruppi()
      USE General
      USE Groups
!
      implicit none
!
      character Am1, Amino4*4, line*80
      integer   :: j, n_atoms, i3(3)
      real      :: w
!
      MaxAtomsInGroups = 15
      return
!
      MaxAtomsInGroups = -99
      nResid = 0
      read(kform,'(a)') line        ! Rigid Groups file 03 February 2005
      read(kform,'(a)') line        ! Z-matrix
      do
         read(kform,'(a,2x,i3,1x,a1,f8.3)',end=10)
     *                   Amino4, n_atoms, Am1, w
         nResid = nResid + 1
         if (n_atoms > MaxAtomsInGroups) then
             MaxAtomsInGroups = n_atoms
         endif
         do j=1, n_atoms
            read(kform,'(a)') line  ! atoms info
         enddo
         read(kform,'(a)') line     ! Long Residue name
      enddo
   10 rewind kform
!
      return
      end
! ----------------------------------------------------------------------
      subroutine InitResidues()
      USE General
      USE Groups
!
      implicit none
!
      integer itest, itype, iform, jop, jopen, ierr
      if (ifGroupsAllocated == 1) return
!
!-- open Sir.gru file to get the groups info
!
      itest=0
      itype = 2
      iform = 1
      jop = jopen(kform, grufle, itype, iform, ierr)
!
      call ContaGruppi()
!
      allocate (ResidCoords(nResid, 3, MaxAtomsInGroups), stat = ierr)
      allocate (ResidConn(nResid, 2 ,2*MaxAtomsInGroups), stat = ierr)
c     allocate (ResidTable1(nResid, 4),                   stat = ierr)
      allocate (ResidTable1(nResid, 5),                   stat = ierr)
      allocate (ResidTable2(nResid, 7, MaxAtomsInGroups), stat = ierr)
      allocate (ResidAtoms(nResid, 2, MaxAtomsInGroups),  stat = ierr)
      allocate (AminoName(nResid),                        stat = ierr)
      allocate (AminoNameLong(nResid),                    stat = ierr)
      allocate (AminoContent(25, 4),                      stat = ierr)
      allocate (nitro(4000),                              stat = ierr)
!psie      
!psie      allocate (nitro(4000),                              stat = ierr)
!
      ifGroupsAllocated = 1
      ResidCoords(:, :, :) = 0
      ResidConn(:, : ,:) = 0
!
!!!   call FillResiduesTables()  ! non dovrebbe piu servire (rotameri)
      close(kform)
      call LeggiGroups()
!
!-- Chemical content of residues
!                                   C  N  O  S
      AminoContent( 1, 1:4) = (/  3, 1, 1, 0 /) ! A !
      AminoContent( 2, 1:4) = (/  0, 0, 0, 0 /) ! B !
      AminoContent( 3, 1:4) = (/  3, 1, 1, 1 /) ! C !
      AminoContent( 4, 1:4) = (/  4, 1, 3, 0 /) ! D !
      AminoContent( 5, 1:4) = (/  5, 1, 3, 0 /) ! E !
      AminoContent( 6, 1:4) = (/  9, 1, 1, 0 /) ! F !
      AminoContent( 7, 1:4) = (/  2, 1, 1, 0 /) ! G !
      AminoContent( 8, 1:4) = (/  6, 3, 1, 0 /) ! H !
      AminoContent( 9, 1:4) = (/  6, 1, 1, 0 /) ! I !
      AminoContent(10, 1:4) = (/  0, 0, 0, 0 /) ! J !
      AminoContent(11, 1:4) = (/  6, 2, 1, 0 /) ! K !
      AminoContent(12, 1:4) = (/  6, 1, 1, 0 /) ! L !
      AminoContent(13, 1:4) = (/  5, 1, 1, 1 /) ! M !
      AminoContent(14, 1:4) = (/  4, 2, 1, 0 /) ! N !
      AminoContent(15, 1:4) = (/  0, 0, 0, 0 /) ! O !
      AminoContent(16, 1:4) = (/  5, 1, 1, 0 /) ! P !
      AminoContent(17, 1:4) = (/  5, 2, 2, 0 /) ! Q !
      AminoContent(18, 1:4) = (/  6, 4, 1, 0 /) ! R !
      AminoContent(19, 1:4) = (/  3, 1, 2, 0 /) ! S !
      AminoContent(20, 1:4) = (/  4, 1, 2, 0 /) ! T !
      AminoContent(21, 1:4) = (/  0, 0, 0, 0 /) ! U !
      AminoContent(22, 1:4) = (/  5, 1, 1, 0 /) ! V !
      AminoContent(23, 1:4) = (/ 11, 2, 2, 0 /) ! W !
      AminoContent(24, 1:4) = (/  0, 0, 0, 0 /) ! X !
      AminoContent(25, 1:4) = (/  9, 1, 2, 0 /) ! Y !
!
      return
      end
!----------------------------------------------------------------
      subroutine FillResiduesTables()
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Groups
      USE PhaseModule
!
      implicit none
      character Am1, Am3*3, Amino4*4, line*80
      integer   :: i, j, itype, iform, jop, n_atoms, i3(3), nR
      integer   :: itest, i1
      real      :: w, x3(3)
!
      itest = 0
!
      read(kform,'(a)') line  ! Rigid Groups file 03 February 2005
      read(kform,'(a)') line  ! Z-matrix
      do nR=1, nResid
         read(kform,'(a,2x,i3,1x,a1,f8.3)') Amino4,n_atoms, Am1, w
         AminoName(nR) = Amino4(1:4)
         ResidTable1(nR,1) = n_atoms
         ResidTable1(nR,2) = ichar(Am1)
         do j=1, n_atoms
            read(kform,20) Am3, Am1, x3(1:3), i3(1:3)
            ResidAtoms(nR,1,j) = Am3
            ResidAtoms(nR,2,j) = Am1
            ResidTable2(nR,1:3,j) = x3(1:3)
            ResidTable2(nR,4:6,j) = i3(1:3)
            ResidTable2(nR,7,j) = ichar(Am1)
            if (Am3(1:2) == 'CA') then
                ResidTable1(nR,3) = j
            endif
         enddo
         read(kform,'(a)') AminoNameLong(nR)  ! Long Residue name
      enddo
   20 format(7x,a,7x,a,7x,3f10.3,3i5)
!
      if (itest.eq.1) then
          do i=1, nResid
             i1  = ResidTable1(i,1)
             Am1 = char(ResidTable1(i,2))
             write(lo,30) AminoName(i), i1, Am1, ResidTable1(i,3)
             do j=1, i1
                x3(1:3) = ResidTable2(i,1:3,j)
                i3(1:3) = nint(ResidTable2(i,4:6,j))
                i1 = nint( ResidTable2(i,7,j) )
                Am3 = ResidAtoms(i,1,j)
                Am1 = ResidAtoms(i,2,j)(1:1)
                write(lo,40) j, Am3,Am1, x3(1:3), i3(1:3), char(i1)
             enddo
          enddo
      endif
!
   30 format(a3,i6,' ',a1, '  Ca position ',i2)
   40 format(i5, 2x, a3, 8x,a1, 6x, 3f10.3,3i5,2x,a1)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine ContaRotamers()
      USE General
      USE Groups
!
      character Rdiret(2)*4, Rinput*4,line*80
      data Rdiret/'resi','atom'/
!
      MaxAtomsInGroups = -99
      nResid = 0
      do
         read(kform,'(a)',end=10)   line
         read(line,'(a)')   Rinput         
         if(Rinput.eq.Rdiret(1)) then
            nResid = nResid + 1
         else if(Rinput.eq.Rdiret(2))then
            read(line,'(4x,i4)')   n_atoms         
            if (n_atoms > MaxAtomsInGroups) then
                MaxAtomsInGroups = n_atoms
            endif
         endif   
      enddo
   10 rewind kform
!
      return
      end
!-----------------------------------------------------------------------
!--main routine per generare le possibili configurazioni del residuo
!-----------------------------------------------------------------------
      subroutine FullRotamers(typo,RotamerINP,n_atoms,nFig,
     *   RotamerOUT,RFig,ier)
!--main routine per gestire le n-configurazioni dei residui
!  deve eseere stata chiamata precedentemente
!      call InitRotamers()
!
!  typo       : codice del residuo (input)
!  RotamerINP : coordinate cristallografiche del residuo 
!               nella sequenza attesa (input)
!  n_atoms    : no. atomi del residuo
!  nFig       : No. di configurazioni possibili (output)
!  RtamerOUT  : coordiante cristallografiche del residuo 
!              per No configurazioni possibili (output)
!  RFig       : figura di merito per ogni configurazione (output)
!  ier        : > 0 errore (output)
!
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Groups
      USE PhaseModule
      USE Plotter
      USE ZMatrix
!
      implicit none
      integer :: i, j, jj, jj1, itest, ier, nordZ, NincrAng, nrot, nchi
      integer :: l, n, lFig, mFig, nFig, j1, j2, j3, j4, j5, lx, ly, ja
      integer :: ncard, lenFig, NFdim, NFstep, nR, ierr, loo, n_atoms
      integer :: jord
      real    :: AngIncr, AngMeno, RBuffFig
      real    :: RotamerINP(3,MaxAtomsInGroups)
      real    :: BuffOUT(3,MaxAtomsInGroups)
      real    :: RotamerOUT(50,3,MaxAtomsInGroups)
      real    :: RFig(50)
      character typo, Am1, Am3*3, Am*3
      real    :: ResMatOutC(3,MaxAtomsInGroups)
      real    :: xx1(3),xx2(3)
!
      real, allocatable   :: ResidFig(:)
!
      itest = 0
      ier=0
!--passo metriche nelle matrici in PLOTTER da GENERAL
      gdd=xgg
      grr=xgr     
      vd=volume
      vr=1.0/volume
!
      nR=0
c--find the residuo richiesto
      do ja=1,nResid
          Am1 = char(ResidTable1(ja,2))
          if(typo.eq.Am1) then
            nR=ja
            exit
         endif
      enddo   
      if(nR.eq.0) then
      write(lo,9010) typo
9010      format( /,' Required Resid not found for ',a1,/)
          ier = 1
          return
      endif           
!      
      n_atoms = ResidTable1(nR,1)    
c--
      NFdim=50
      NFstep=1+3*n_atoms
      lenFig=NFdim*NFstep
      if (.not. allocated(ResidFig)) 
     *     allocate (ResidFig(lenFig),   stat = ierr)
      if (ierr.ne.0) then 
          write(lo,*) 'ResidFig Allocation error'
          call cstop(' ')
      endif
      lFig=1
      nFig=1
      jord=-1
      ResidFig(:)=0.0
!        
c--recupero e ortogonalizzo coordinate input
c--1 e' l'origine
c  2 e' l'asse x
c  3 fornisce il piano dove calcolare l'asse y
      loo=1
      lx =2
      ly =3
c--salvo coordinate dell'origine
      x_orig(1:3)=RotamerINP(1:3,loo)
!--calcolo matrici di trasformazione      
      call OrtoGru(n_atoms,RotamerINP,ResMatOutC,loo,lx,ly,
     *     MaxAtomsInGroups)
      ncard =  n_atoms
      nchi    = ResidTable1(nR,4)
      nrot    = ResidTable1(nR,5)
!--recupero coordinate z-matrix      
      do jj=1,ncard
         iloc(jj)=jj
         xloc(1:3,jj)=ResidTable2(nR,1:3,jj) 
         nloc(1:3,jj)=ResidTable2(nR,4:6,jj) 
      enddo
      nzm=n_atoms
      nordZ=5
      AngMeno=5.0 
      AngIncr=1.0
      NincrAng=11 
      do i = 1,nrot
!--inserisco valori inziali della configurazione corrente    
         do jj=1,nchi
            jj1=jj+5
            xloc(3,jj1)= ResidRotamers(nR,i,jj)-AngMeno
         enddo
         call zmatr_new(ier)
         call CrystGru(1,BuffOUT)
!         
         select case (nchi)
            case (5)
               do j1=1,NincrAng
                  do j2=1,NincrAng
                     do j3=1,NincrAng
                        do j4=1,NincrAng
                           do j5=1,NincrAng
                           call SingleRotamers(n_atoms,BuffOUT,RBuffFig)
                           mFig=lFig+(nFig-1)*NFstep
                           if(RBuffFig.gt.ResidFig(mFig))then
                                 ResidFig(mFig)=RBuffFig
                                 l=mFig+1
                                 do n=1,n_atoms
                                    do nn1=1,3
                                       ResidFig(l)=BuffOUT(nn1,n)
                                       l=l+1
                                    enddo
                                 enddo
                                 nFig=nFig+1
                                 if(nFig.gt.NFdim) then
                                    nFig=NFdim
                  call sortz_dyn(ResidFig,lenFig,lFig,NFdim,NFstep,jord)
                                 endif
                              endif      
                              xloc(3,10)=xloc(3,10)+AngIncr
                              call zmatr_follow(10,ier)
                              call CrystGru(10,BuffOUT)
                           enddo
                           xloc(3,10)= ResidRotamers(nR,i,5)-AngMeno
                           xloc(3,9) = xloc(3,9)+AngIncr
                           call zmatr_follow(9,ier)
                           call CrystGru(9,BuffOUT)
                        enddo       
                        xloc(3,9)= ResidRotamers(nR,i,4)-AngMeno
                        xloc(3,8)=xloc(3,8)+AngIncr
                        call zmatr_follow(8,ier)
                        call CrystGru(8,BuffOUT)
                     enddo   
                     xloc(3,8)= ResidRotamers(nR,i,3)-AngMeno
                     xloc(3,7)=xloc(3,7)+AngIncr
                     call zmatr_follow(7,ier)
                     call CrystGru(7,BuffOUT)
                  enddo       
                  xloc(3,7)= ResidRotamers(nR,i,2)-AngMeno
                  xloc(3,6)=xloc(3,6)+AngIncr
                  call zmatr_follow(6,ier)
                  call CrystGru(6,BuffOUT)
               enddo   
            case (4)
                do j1=1,NincrAng
                  do j2=1,NincrAng
                     do j3=1,NincrAng
                        do j4=1,NincrAng
                           call SingleRotamers(n_atoms,BuffOUT,RBuffFig)
                           mFig=lFig+(nFig-1)*NFstep
                           if(RBuffFig.gt.ResidFig(mFig))then
                              ResidFig(mFig)=RBuffFig
                              l=mFig+1
                              do n=1,n_atoms
                                 do nn1=1,3
                                    ResidFig(l)=BuffOUT(nn1,n)
                                    l=l+1
                                 enddo
                              enddo
                              nFig=nFig+1
                              if(nFig.gt.NFdim) then
                                 nFig=NFdim
                  call sortz_dyn(ResidFig,lenFig,lFig,NFdim,NFstep,jord)
                              endif
                           endif      
                           xloc(3,9) = xloc(3,9)+AngIncr
                           call zmatr_follow(9,ier)
                           call CrystGru(9,BuffOUT)
                        enddo       
                        xloc(3,9)= ResidRotamers(nR,i,4)-AngMeno
                        xloc(3,8)=xloc(3,8)+AngIncr
                        call zmatr_follow(8,ier)
                        call CrystGru(8,BuffOUT)
                     enddo   
                     xloc(3,8)= ResidRotamers(nR,i,3)-AngMeno
                     xloc(3,7)=xloc(3,7)+AngIncr
                     call zmatr_follow(7,ier)
                     call CrystGru(7,BuffOUT)
                  enddo       
                  xloc(3,7)= ResidRotamers(nR,i,2)-AngMeno
                  xloc(3,6)=xloc(3,6)+AngIncr
                  call zmatr_follow(6,ier)
                  call CrystGru(6,BuffOUT)
               enddo   
            case (3)
                do j1=1,NincrAng
                  do j2=1,NincrAng
                     do j3=1,NincrAng
                        call SingleRotamers(n_atoms,BuffOUT,RBuffFig)
                        mFig=lFig+(nFig-1)*NFstep
                        if(RBuffFig.gt.ResidFig(mFig))then
                           ResidFig(mFig)=RBuffFig
                           l=mFig+1
                           do n=1,n_atoms
                              do nn1=1,3
                                 ResidFig(l)=BuffOUT(nn1,n)
                                 l=l+1
                              enddo
                           enddo
                           nFig=nFig+1
                           if(nFig.gt.NFdim) then
                              nFig=NFdim
                  call sortz_dyn(ResidFig,lenFig,lFig,NFdim,NFstep,jord)
                           endif
                        endif      
                        xloc(3,8)=xloc(3,8)+AngIncr
                        call zmatr_follow(8,ier)
                        call CrystGru(8,BuffOUT)
                     enddo   
                     xloc(3,8)= ResidRotamers(nR,i,3)-AngMeno
                     xloc(3,7)=xloc(3,7)+AngIncr
                     call zmatr_follow(7,ier)
                     call CrystGru(7,BuffOUT)
                  enddo       
                  xloc(3,7)= ResidRotamers(nR,i,2)-AngMeno
                  xloc(3,6)=xloc(3,6)+AngIncr
                  call zmatr_follow(6,ier)
               enddo   
            case (2)
                do j1=1,NincrAng
                  do j2=1,NincrAng
                     call SingleRotamers(n_atoms,BuffOUT,RBuffFig)
                     mFig=lFig+(nFig-1)*NFstep
                     if(RBuffFig.gt.ResidFig(mFig))then
                        ResidFig(mFig)=RBuffFig
                        l=mFig+1
                        do n=1,n_atoms
                           do nn1=1,3
                              ResidFig(l)=BuffOUT(nn1,n)
                              l=l+1
                           enddo
                        enddo
                        nFig=nFig+1
                        if(nFig.gt.NFdim) then
                           nFig=NFdim
                  call sortz_dyn(ResidFig,lenFig,lFig,NFdim,NFstep,jord)
                        endif
                     endif      
                     xloc(3,7)=xloc(3,7)+AngIncr
                     call zmatr_follow(7,ier)
                     call CrystGru(7,BuffOUT)
                  enddo       
                  xloc(3,7)= ResidRotamers(nR,i,2)-AngMeno
                  xloc(3,6)=xloc(3,6)+AngIncr
                  call zmatr_follow(6,ier)
               enddo   
            case (1)
                do j1=1,NincrAng
                  call SingleRotamers(n_atoms,BuffOUT,RBuffFig)
                  mFig=lFig+(nFig-1)*NFstep
                  if(RBuffFig.gt.ResidFig(mFig))then
                     ResidFig(mFig)=RBuffFig
                     l=mFig+1
                     do n=1,n_atoms
                        do nn1=1,3
                           ResidFig(l)=BuffOUT(nn1,n)
                           l=l+1
                        enddo
                     enddo
                     nFig=nFig+1
                     if(nFig.gt.NFdim) then
                        nFig=NFdim
                  call sortz_dyn(ResidFig,lenFig,lFig,NFdim,NFstep,jord)
                     endif
                  endif      
                  xloc(3,6)=xloc(3,6)+AngIncr
                  call zmatr_follow(6,ier)
                  call CrystGru(6,BuffOUT)
               enddo   
         end select   
      enddo
!                        
      if(nFig.le.NFdim) then
         call sortz_dyn(ResidFig,lenFig,lFig,NFig,NFstep,jord)
      endif
!                  
      RotamerOUT(:,:,:)=0.0 
      mFig=lFig       
      do j=1,nFig
         RFig(j)=ResidFig(mFig)
         l=mFig+1
         do n=1,n_atoms
            do nn1=1,3
               RotamerOUT(j,nn1,n)=  ResidFig(l) 
               l=l+1
            enddo
         enddo
         mFig=mFig+NFstep        
      enddo
!      
      deallocate(ResidFig, stat =ierr)
!
      return
      end
!
!-------------------------------------------------------------
      subroutine SingleRotamers(n_atoms,BuffOUT,RBuffFig)
!--calcolo della densità elettronica per gli atomi del residuo
!  n_atoms  : no. atomi del residuo
!  BuffOUT(3,MaxAtomsInGroups) : coordinate atomi residuo
!  RBuffFig : figura di merito       
      implicit none
      integer :: n_atoms
      real    :: BuffOUT(3,*), RBuffFig
!      
      return
      end
!      
c--------------------------------------------------------------
code for CrystGru
      subroutine CrystGru(nordZ,BuffOUT)
c--calcola coordinate locali dai valori espressi nella z-matrix
c
      USE General
      USE Groups
      USE ZMatrix
!
      real    :: BuffOUT(3,MaxAtomsInGroups)   
      real    :: xx1(3),xx2(3)   
c
c--riporto le coordinate in cella
      do ja=nordZ,nzm
          xx1(1:3)=xortolocal(1:3,ja)
          call moltv(t_cryst,xx1,xx2)
          BuffOUT(1:3,ja)=xx2(1:3)+x_orig(1:3)
      enddo
      return
      end      
!-----------------------------------------------------------------------
      subroutine HTML_header(unit,task,string)
      USE Html
      integer unit
      character task*(*)
      character string*(*)
!
      if (task(1:1) /= ' ') then
          k = Lung(task)
          write(unit,10) task(1:k)
      endif
      k = Lung(string)
      write(unit,20) string(1:k)
      k1 = Lung(HTMLdate)
      k2 = Lung(HTMLname)
      write(unit,30) HTMLdate(1:k1), HTMLname(1:k2)
      write(unit,50) 
!
      return
!
   10 format('<a name="',a,'"></a>')
   20 format('<p align="center"><font size="6" style="font-family: ',
     *       'times new roman,times,serif;" color="#FF0000"><b>',a,
     *       '</b></font></p>')
   30 format('<table border="0" cellpadding="0" cellspacing="0" ',
     *       'style="border-collapse: collapse" bordercolor="#111111" ',
     *       'width="100%" id="AutoNumber1"> <tr> ',/,
     *       '<td width="50%" align="center"><font size="4" ',
     *       'style="font-family: times new roman,times,serif;',
     *       '" color="#FF0000"><b>',a,'</b></font></td>',
     *       '<td width="50%" align="center"><font size="4" ',
     *       'style="font-family: times new roman,times,serif;',
     *       '" color="#FF0000"><b>',a,'</b></font></td></tr></table>')
   50 format(' <hr color="#000080" size="1">',
     *       '<font size="2" style="font-family: ',
     *       'courier new,courier,monospace;">')
!
      end
!---------------------------------------------------------------------
      subroutine HTML_end(unit)
      USE Html
      integer unit
!
      write(unit,10)
      k1 = Lung(HTMLend)
      k2 = Lung(HTMLcpu)
      write(unit,30) HTMLend(1:k1), HTMLcpu(1:k2)
      call HTML_top(unit)
!
      return
!
   10 format(' <hr color="#000080" size="1">')
   30 format('<table border="0" cellpadding="0" cellspacing="0" ',
     *       'style="border-collapse: collapse" bordercolor="#111111" ',
     *       'width="100%" id="AutoNumber1"> <tr> ',/,
     *       '<td width="50%" align="center"><font size="4" ',
     *       'style="font-family: times new roman,times,serif;',
     *       '" color="#FF0000"><b>',a,'</b></font></td>',
     *       '<td width="50%" align="center"><font size="4" ',
     *       'style="font-family: times new roman,times,serif;',
     *       '" color="#FF0000"><b>',a,'</b></font></td></tr></table>')
!
      end
!---------------------------------------------------------------------
      subroutine HTML_top(unit)
      integer unit
!
      write(unit,10)
!
      return
!
   10 format('<div align="right">',
     *       '<align="right"><font size="4" style="font-family: ',
     *       'times new roman,times,serif;" color="#0000FF"><b>',
     *       '<a href="#home">Top</a></b></font></align>',
     *       '</div><div align="left">')
!
      end
!---------------------------------------------------------------------
      subroutine hlconv(peso,ifase,aHLcoef,bHLcoef,cHLcoef,dHLcoef)
      USE General
      USE Riflessi
C
C--- Hendrickson Lattman: need to know phase change.
C  A = G * COS(  Phi)
C  B = G * SIN(  Phi)
C  C = G * COS(2*Phi)
C  D = G * SIN(2*Phi)
C

      dimension peso(nreflTot),ifase(nreflTot)
      dimension aHLcoef(nreflTot),bHLcoef(nreflTot)
      dimension cHLcoef(nreflTot),dHLcoef(nreflTot)
      real ha,hb,hc,hd

      aHLcoef(:) = 0.0
      bHLcoef(:) = 0.0
      cHLcoef(:) = 0.0
      dHLcoef(:) = 0.0
      ha = 0.0
      hb = 0.0
      hc = 0.0
      hd = 0.0

      do i=1,nreflTot
         fase = ifase(i)
          call hlconv1(mkang(i), peso(i), fase, ha, hb, hc, hd)
          aHLcoef(i) = ha
          bHLcoef(i) = hb
         cHLcoef(i) = hc
         dHLcoef(i) = hd
      enddo
!
      return
      end
!---------------------------------------------------------------------
      subroutine CalcScale

      USE General
      USE Symmetry
      USE Riflessi
      USE Molcom
      USE Param
      USE PhaseModule
!
c      calc. sc & bt for fovet_mod
c in: if sc > 0.0 no scaling is performed
c     if sc < 0.0 sc is applied but no b-factor
c
      real res(50),std(50),rres(50),sres(50),rstd(50)
      real ncal(50),f2cal(50),nobs(50),f2obs(50)
      integer ndatares
c
      integer i,j,nr,nbin,nrstep,numres
      real srmin,srmax,varprt,varsol,rhoave,rhovar,s
      real x,y1,y2,w,sw,sx,sx2,sdy,sdyx
c
      external numres
c data from ins
      data ndatares/19/
      data res/999.00,10.00, 8.00, 7.00, 6.00, 5.00, 4.50, 4.00, 3.60,
     +     3.30, 3.00, 2.80, 2.60, 2.40, 2.20, 2.00, 1.80, 1.60, 1.50,
     +     31*0.0/
      data std/ 0.000,0.076,0.107,0.121,0.143,0.200,0.248,0.316,0.375,
     +    0.427,0.476,0.512,0.552,0.599,0.654,0.718,0.783,0.850,0.890,
     +     31*0.0/


c     scale=sc
c     scale=0.0
      rmax=0.5/sqrt(rhomax)

      avesol=0.32
      aveprt=0.43

      nrstep=25
      rres(1)=0.0
      rstd(1)=0.0
      nbin=0
      nr=0
      do 100 i=2,ndatares
        srmin=1.0/res(i-1)**2
        srmax=1.0/res(i)**2
        do 50 j=1,nrefl
          s=4.*rhov(j)
          if (s.ge.srmin.and.s.lt.srmax
     +     .and.fovet(i).ge.0.0) nr=nr+1
 50     continue
        if (nr.gt.nrstep) then
          nr=0
          nbin=nbin+1
          rres(nbin)=res(i)
          rstd(nbin)=std(i)
        endif
 100  continue
c
c calculate estimated variances with resolution for this structure
c ================================================================
      solc=1.0-v_p
      call calcsobs(1,nbin,rres,sres,nobs,f2obs)
      if (kscreen > 0 ) then
         call zflush
         call DoSingleIteration()
      endif

      do 110 i=1,nbin
c pick up variance of protein region (res.dep.) and solvent (almost flat)
      varprt=rstd(i)**2
      varsol=varprt/10.0
c now calc overall mean and variance
      rhoave=aveprt*(1.0-solc)+avesol*solc
      rhovar=(varprt+(aveprt-rhoave)**2)*(1.0-solc) +
     +       (varsol+(avesol-rhoave)**2)*solc
c store expected data sizes
      ncal(i)=numres(rres(i))
      call DoSingleIteration()
      f2cal(i)=rhovar*volume**2/(2.0*nsym*pts)
 110  continue
c now do differences for individual ranges
      do 120 i=nbin,2,-1
      ncal(i)=ncal(i)-ncal(i-1)
      f2cal(i)=f2cal(i)-f2cal(i-1)
 120  continue
c
c now produce obs data stats for each resolution range
c ====================================================
      call calcsobs(1,nbin,rres,sres,nobs,f2obs)

      if (kscreen > 0 ) then
         call zflush
         call DoSingleIteration()
      endif
      
      if (scaleDM.gt.0.0) goto 350

      if (rmax.gt.res(5)) goto 9010
c
c calculate scale and B-factor to produce best fit between obs and calc
c =====================================================================
      sw=0.0
      sx=0.0
      sx2=0.0
      sdy=0.0
      sdyx=0.0
      do 300 i=1,nbin
        cali = ncal(i)
        obsi = nobs(i)
        if (nint(cali)==0.or.nint(obsi)==0) goto 300
        x = sres(i) / obsi
        ryy11 = f2cal(i) / cali
        ryy22=  f2obs(i) / obsi
**      y1=log(ry1)
**      y2=log(ry2)
        yy11 = alog(ryy11)
        yy22 = alog(ryy22)
c Empirical weighting scheme:
c uniform weight gives too little influence to high res data.
c (but there are more ranges at high res)
c weighting with number of reflections give too much influence to high res data.
c (but taking into account the SD's might put it right)
        w=1.0
        sw=sw+w
        sx=sx+w*x
        sx2=sx2+w*x**2
        sdy=sdy+w*(yy22-yy11)
        sdyx=sdyx+w*(yy22-yy11)*x
 300  continue
      if (scaleDM.eq.0.0) BtDM=(sw*sdyx-sx*sdy)/(sx**2-sw*sx2)*2.0
      ScaleDM=exp((sx2*sdy-sx*sdyx)/(sx**2-sw*sx2))
      if (BtDM < 0.0 ) then
         BtDM = bt
         ScaleDM = sc
      endif

c
c rescale the input data to match the calc distributions
c ======================================================
c     ScaleDM = 0.84
c     BtDM = 26.657

 350  do 400 i=1,nrefl
        s=4.*rhov(i)
        scn=sqrt(ScaleDM)*exp(BtDM*s/4.0)
        fovet_mod(i) =scn*fovet(i)
c       sigfo(i)=sqrt(ScaleDM)*sigfo(i)
 400  continue
c
c produce stats for rescaled obs data
c ===================================
      call calcsobs(2,nbin,rres,sres,nobs,f2obs)
      if (kscreen > 0 ) then
         call zflush
         call DoSingleIteration()
      endif
      
c
c output data
c ===========
      if (QualePgm == SIRPROTPGM) then
          write (lo,500)ScaleDM,BtDM
      endif
 500  format (/,
     +'   Sc & bt for S.F (used in EDM):',/,
     +'   Estimated S.F. scale factor  = ',f8.3,/
     +'   Estimated temperature factor = ',f8.3,/)

      if (knw > 0 .and. kverbo > 0) then
      write (lo,510)
 510  format (
     +'  res   1/resol^2  number    %present      expect.   obs.   ',/,
     +' (lim)(4sin2th/l2)(reflns) (completeness)    (mean F^2)     ')
      do 520 i=1,nbin
      write (lo,530)rres(i),sres(i)/nobs(i),
     +  nobs(i),100.0*nobs(i)/ncal(i),f2cal(i)/ncal(i),f2obs(i)/nobs(i)
 520  continue
 530  format(1x,f5.2,2x,f6.3,4x,f7.0,6x,f6.1,2x,2f9.0)
      write (lo,'(a)')'   '
      endif
c
      return
 9010 write(lo,*)'Calc. Sc & Bt - insufficent resolution:'
c     stop
      call cstop(' ')
      end
c ----------------------------------------------------------------------
c
      subroutine calcsobs(jflag,nbin,rres,sres,nobs,f2obs)

      USE General
      USE Symmetry
      USE Riflessi

      real rres(*),sres(*),nobs(*),f2obs(*)

c
      integer i,j,ir,nbin
      real s,eps,fo
c
      do 140 i=1,nbin
      sres(i)=0.0
      nobs(i)=0.0
      f2obs(i)=0.0
 140  continue
      do 200 j=1,nrefl
       s=4.*rhov(j)
       eps=epsv(j)*pts
       if (jflag==1) then
         fo=fovet(j)
       else
         fo=fovet_mod(j)
       endif
c check for absent rfls
c      if (j < 2) write(6,*)fo
       if (fo > 0.0) then
        do 150 ir=1,nbin-1
         if (s.lt.1.0/rres(ir)**2) goto 160
 150    continue
 160    nobs(ir)=nobs(ir)+1.0
        f2obs(ir)=f2obs(ir)+fo**2/eps
        sres(ir)=sres(ir)+s
       endif
 200  continue
      return
      end
!-----------------------------------------------------------------------
      integer function numres(reso)
      USE General
      USE Symmetry
      USE Riflessi
      USE IsrCom
      USE WrReIn
!
      integer vsym(24),ibrav(6,13)
      integer  hmin,hmax,kmin,kmax,lmin,lmax
      data ibrav/4*1,3,1,0,3*1,0,-1,1,0,6*1,0,3*1,5*2,3,4*0,1,11*0,1,
     ,5*0,2,5*0,1,5*0,1,11*0,2,0/
      real reso
!
      if (QualePgm == SIRPGM) then
          call AllocaIsr(2)
          if (Added == 0) then
              ifat1 = (2 * ihmx(3) + 1) * (2 * ihmx(2) + 1)
              ifat2 = (2 * ihmx(3) + 1)
              ifatx = ihmx(1) * ifat1 + ihmx(2) * ifat2 + ihmx(3)
          else
              ifat1 = (2 * ihmxAdd(3) + 1) * (2 * ihmxAdd(2) + 1)
              ifat2 = (2 * ihmxAdd(3) + 1)
              ifatx = ihmxAdd(1)*ifat1 + ihmxAdd(2)*ifat2 + ihmxAdd(3)
          endif
          call AllocaIsr(1)
      else
          ifat1 = (2 * ihmx(3) + 1) * (2 * ihmx(2) + 1)
          ifat2 = (2 * ihmx(3) + 1)
          ifatx = ihmx(1) * ifat1 + ihmx(2) * ifat2 + ihmx(3)
      endif
      isr(1:ifatx)=0
!
      ksym=0
      do i=2,nsym
         ifl=0
         do j=1,3
            if (abs(tsmat(j,i)).gt.0.00001) ifl=1
         enddo
         if (ifl /= 0) then
             ksym=ksym+1
             vsym(ksym)=i
         endif
      enddo
      klatt=latt-1
      lty=0


      call indmm(hmin,hmax,kmin,kmax,lmin,lmax)

      n=0
      slim=(0.25/reso**2)

      do ih= hmin,hmax
         do ik= kmin,kmax
            do il= lmin,lmax

               if (ih.eq.0.and.ik.eq.0.and.il.eq.0) cycle
c
c    TRIGONALE : va' considerata la condizione aggiuntiva /h/>/k/
c                nel caso (+-+)
c
               if (jsys.eq.5.and.ik.lt.0.and.iabs(ih).lt.iabs(ik)) cycle
c
c    CUBICO :  va' considerata la condizione aggiuntiva h<=k<=l
c
               if(jsys.eq.6.and.(ik.lt.ih.and.ik.gt.il)) cycle

               ih1=ih
               ik1=ik
               il1=il
         
               inbl=ih1*ifat1+ ik1*ifat2 + il1
               inbl=iabs(inbl)
               if (inbl.gt.ifatx) cycle
               if (isr(inbl) > 0) cycle

               call extin(jex,ih1,ik1,il1,ibrav,klatt,ksym,vsym)
               if (jex==1) cycle

               call geneq(0,ih1,ik1,il1,idelt,jcode,isgnn,id1,s,ireje)
               if (s.gt.slim) cycle

               if (QualePgm == SIRPROTPGM .or. ifRemo == 1) then   !ab initio come SIR
                   inbl=ih1*ifat1+ ik1*ifat2 + il1
                   inbl=iabs(inbl)
                   if (inbl.gt.ifatx) cycle
                   if (isr(inbl) > 0) cycle
               endif
 

               if (iabs(ih1) > ihmx(1)
     *         .or.iabs(ik1) > ihmx(2)
     *         .or.iabs(il1) > ihmx(3)) cycle
               

               isr(inbl) = 1

               n=n+1

            enddo
         enddo
      enddo
!
      numres = n
!
      if (QualePgm == SIRPGM) then
          call AllocaIsr(2)
      endif
!
      return
      end
c-----------------------------------------------------------------------
c     Routine generale per la distribuzione dei valori di un vettore
c           (sostituisce pherrdis)
c-----------------------------------------------------------------------
c     tirang='weight'
c     call ParamDistribution(tirang,2,pesi,khl,nrefl,1,ipub,iphi2,
c    *    shi,pesi,segni,20,1.0)

c     tirang='weight'
c     call ParamDistribution(tirang,2,pesi,khl,nrefl,1,ipub,iphi2,
c    *    shi,pesi,segni,-20,0.5)

c      tirang='|E|'
c       call ParamDistribution(tirang,1,evet,khl,nrefl,1,ipub,
c    *       iphaz,shi,pesi,segni,20,0.0)

c      tirang='|E|'
c       call ParamDistribution(tirang,1,evet,khl,nrefl,1,ipub,
c    *       iphaz,shi,pesi,segni,-30,0.0)

! jdisTipo = 1 generale ;  = 2 distribuzine dei pesi
! segni : work1 = 0 in ingresso  (fase attesa in uscita?) 
! nrang1 > 0 => classica distribuzione in intervalli (range uguali)
! nrang1 < 0 => distribuzione con n° di rifessi uguale per intervallo  
! rmax11 = valore massimo della distribuzione (se 0 max del vettore)

c      tirang='F/S'
c       call ParamDistribution(tirang,1,work2,khl,nrefl,1,ipub,
c    *       iphaz,shi,pesi,work1,20,0.0)
! work1 = (Fo / sigma) / 100
! work2 = vettore risoluzione

c--------------------------------------------------------------
      subroutine ParamDistribution(tirang,jdisTipo,dij,khl,nrif,
     *                            ic,ia,ib,shi,c,
     *                            segni,nrang1,rmax11)

      USE General

      dimension ia(nrif),ib(nrif),khl(3,nrif),c(nrif),
     *          segni(nrif)

      dimension cumde(201),range(201),disa1(201),disb1(201),cmed(201),
     * disa2(201),disb2(201),dij(nrif),shi(4),his(201),
     * csegni(201),cumerr1(200),cumerr2(201),
     * cumerp1(201),cumerp2(201),cumse(201),ccmed(201)

      character tirang*80
      integer his,cumde
**      real, allocatable :: dijs(:),iorde1(:)
      real, allocatable :: dijs(:)
      integer, allocatable :: iorde1(:)

      if (nrif.le.0) return
      if (knw == 0) return

      ALLOCATE (dijs(nrif),iorde1(nrif), stat = ierr)

c     nrang=10
c     rmax1=rmax11
c     if (nrang1 > 0) then
c        nrang=nrang1
c     elseif (nrang1 < 0) then
c        nrang=nrif/abs(nrang1)
c        nRifbin=abs(nrang1)
c     endif

      nrang=10
      ntot=count(c(ic:nrif) > 0.0)
      if (nrang1 > 0) then
       nrang=nrang1
      elseif (nrang1 < 0) then
c      nrang=Ntot/abs(nrang1)
c      nRifbin=abs(nrang1)
       nRifbin=Ntot/abs(nrang1)
       nrang=abs(nrang1)
       if (nrang*nRifbin < ntot) nrang=nrang+1
      endif

      if (knw > 0) write(lo,'(5x,"Origin: ",4f6.2)') shi(1:4)
      itot=0
      sumsegni=0.0
      sumdif1=0.0
      sumdisb1=0.0
      sumdif2=0.0
      sumdisb2=0.0
      sumc=0.0

      range(:)=0.0
      his(:)=0
      cumde(:)=0
      cumse(:)=0.0
      csegni(:)=0.0
      cmed(:)=0.0
      disa1(:)=0.0
      disb1(:)=0.0
      cumerr1(:)=0.0
      cumerp1(:)=0.0
      disa2(:)=0.0
      cumerr2(:)=0.0
      cumerp2(:)=0.0
      disb2(:)=0.0
      ccmed(:)=0.0

      rmin=99999.
      rabs=99999.
      rmax=-99999.
      ii=0
      do 5 i=ic,nrif
       if (jdisTipo > 0.and.c(i) .lt.0.00000001) goto 5
       if (dij(i).eq.0.0) goto 5
       ii=ii+1
       dijs(ii)=dij(i)
       iorde1(ii)=i
       if (abs(dij(i)).lt.rabs) rabs=abs(dij(i))
       if (dij(i).lt.rmin) rmin=dij(i)
       if (dij(i).gt.rmax) rmax=dij(i)
    5 continue
      numsort=ii
      if (rmax.eq.rmin) return 
      if (numsort.eq.0) return 
      call sortall3(1,dijs,1,numsort,iorde1)


c     if (nrang1 >=0) then
        nsogrmax=nint(0.99*numsort)
        rmax1=dijs(nsogrmax)
        if (rmin.lt.0.0) then
          rmax=amax1(rmax,abs(rmin))
          rmin=-1.0*rmax
        endif
        rmaxg=rmax
        rming=rmin
        if (rmax1.gt.0.0) then
          rmax=rmax1
          if (rmin.lt.0.0)rmin=-1.0*rmax
        endif

c--
        dev=rmax-rmin
        iaa=nint(dev)
        rang=float(nrang)
        if (iaa.gt.0) then
          dev=float(iaa)/rang
        else
          dev=dev/rang
        end if
        if (rmin.ge.0.0) then
         range(1)=float(int(10.*rmin))/10.
         do 12 i=2,nrang
            range(i)=range(i-1)+dev
  12     continue
        else
         range(1)=float(nint(10.*rmin))/10.
         nrangi=nint(rang/2.0)
         nrang=2*nrangi
         dev=rmax-rabs
         dev=dev/float(nrangi)
         do 13 i=2,nrangi-1
            range(i)=range(i-1)+dev
  13     continue
         range(nrangi)=-rabs
         range(nrangi+1)=rabs
         do 14 i=nrangi+2,nrang
            range(i)=range(i-1)+dev
  14     continue
        endif
c       range(1)=rmin
        range(1)=rming
        nrang=nrang+1
        range(nrang)=rmax
        range(nrang+1)=rmaxg
c     endif
c--
      if (nrang1 < 0) then
        n=2
      else
        n=2
      endif

      ii=0

      do 15 i=1,numsort
        ii=ii+1
        k=iorde1(i)
        if (jdisTipo > 0) then
          jh=khl(1,k)
          jk=khl(2,k)
          jl=khl(3,k)
          shift=jh*shi(1)+jk*shi(2)+jl*shi(3)
          shift=360.* shift + ia(k)
          dif1=shift - ib(k)
          dif2=shift + ib(k)
          dif1=abs(amod(dif1,360.))
          if (dif1.gt.180.)dif1=360.-dif1
          dif2=abs(amod(dif2,360.))
          if (dif2.gt.180.)dif2=360.-dif2
        else
          dif1=0.0
          dif2=0.0
        endif

        if (nrang1 < 0) then
          if (ii==nRifbin) then
           his(n)=his(n)+1
           range(n)=dijs(i)
           n=n+1
           ii=0
          else
           his(n)=his(n)+1
           disa1(n)=disa1(n)+dif1
           disa2(n)=disa2(n)+dif2
           disb1(n)=disb1(n)+dif1*c(k)
           disb2(n)=disb2(n)+dif2*c(k)
           cmed(n)=cmed(n)+c(k)
           csegni(n)=csegni(n)+segni(k)
          endif
        else
   17     if (dijs(i).le.range(n)) then
            his(n)=his(n)+1
          else
            n=n+1
            if (n.gt.nrang) n=nrang+1
            goto 17
          endif
          disa1(n)=disa1(n)+dif1
          disa2(n)=disa2(n)+dif2
          disb1(n)=disb1(n)+dif1*c(k)
          disb2(n)=disb2(n)+dif2*c(k)
          cmed(n)=cmed(n)+c(k)
          csegni(n)=csegni(n)+segni(k)
        endif
   15 continue
     
      if (nrang1 < 0) then
        nrang=n-1
        range(nrang+1)=rmaxg
      endif
*-----cumulative


      cumerp1(nrang+1)=disb1(nrang+1)
      cumerp2(nrang+1)=disb2(nrang+1)
      ccmed(nrang+1)=cmed(nrang+1)
      do i=1,nrang
      cumerp1(nrang+1-i)=cumerp1(nrang+2-i)+disb1(nrang+1-i)
      cumerp2(nrang+1-i)=cumerp2(nrang+2-i)+disb2(nrang+1-i)
      ccmed(nrang+1-i)=ccmed(nrang+2-i)+cmed(nrang+1-i)
      enddo
*-----
      do 20 i=1,nrang+1
         if (his(i).gt.0) then
            itot=itot+his(i)
            sumdif1=sumdif1+disa1(i)
            sumdif2=sumdif2+disa2(i)
            sumdisb1=sumdisb1+disb1(i)
            sumdisb2=sumdisb2+disb2(i)
            sumc=sumc+cmed(i)
            sumsegni=sumsegni+csegni(i)
            disa1(i)=disa1(i)/float(his(i))
            disa2(i)=disa2(i)/float(his(i))
            disb1(i)=disb1(i)/cmed(i)
            disb2(i)=disb2(i)/cmed(i)
            csegni(i)=csegni(i)/float(his(i))
            csegni(i)=100.*csegni(i)
         else
            disa1(i)=0.0
            disa2(i)=0.0
            disb1(i)=0.0
            disb2(i)=0.0
            csegni(i)=0.0
            cmed(i)=0.0
         endif
   20 continue
      if (itot.le.0) return
      tot=float(itot)
      segnim=100.*sumsegni/tot
      dif1m=sumdif1/tot
      dif2m=sumdif2/tot
      disb1m=sumdisb1/sumc
      disb2m=sumdisb2/sumc
c-----cumulative 
      cumde(nrang+1)  =his(nrang+1)
      cumse(nrang+1)  =float(his(nrang+1))*csegni(nrang+1)
      cumerr1(nrang+1)=float(his(nrang+1))*disa1(nrang+1)
      cumerr2(nrang+1)=float(his(nrang+1))*disa2(nrang+1)
      do 25 i=1,nrang
      cumde(nrang+1-i)  =cumde(nrang+2-i)+his(nrang+1-i)
      cumse(nrang+1-i)  =cumse(nrang+2-i)+csegni(nrang+1-i)*
     *                   float(his(nrang+1-i))
      cumerr1(nrang+1-i)=cumerr1(nrang+2-i)+disa1(nrang+1-i)*
     *                   float(his(nrang+1-i))
      cumerr2(nrang+1-i)=cumerr2(nrang+2-i)+disa2(nrang+1-i)*
     *                   float(his(nrang+1-i))
   25 continue

      if (jdisTipo==2 )then
        do i=1,nrang-1
          args=0.5*(range(i) + range(i+1))
          args=min(args,1.0)
          csegni(i)=rtod*acos(args)
          args=sum(range(i:nrang))
          args=args/float(nrang-i+1)
          args=min(args,1.0)
          cumse(i)  = rtod*acos(args)
        enddo
      endif

      select case (jdisTipo)
      case (0)
        write(lo,250)tirang
      case (1)
        write(lo,200)tirang
      case (2)
        write(lo,210)tirang
      end select

      do 30 i=2,nrang+1
      if (his(i).eq.0) go to 30
      select case (jdisTipo)
      case (0)
         write(lo,150) range(i-1),range(i),his(i),cumde(i)
      case (1)
         write(lo,100) range(i-1),range(i),his(i),csegni(i),
     *                 disa1(i),disb1(i),disa2(i),disb2(i),
     *                 cumde(i),cumse(i)/float(cumde(i)),
     *                 cumerr1(i)/float(cumde(i)),cumerp1(i)/ccmed(i),
     *                 cumerr2(i)/float(cumde(i)),cumerp2(i)/ccmed(i)
      case (2)
       csegni1=csegni(i-1)
       cumse1=cumse(i-1)
        write(lo,100) range(i-1),range(i),his(i),csegni1,
     *                disa1(i),disb1(i),disa2(i),disb2(i),
     *                cumde(i),cumse1,
     *                cumerr1(i)/float(cumde(i)),cumerp1(i)/ccmed(i),
     +                cumerr2(i)/float(cumde(i)),cumerp2(i)/ccmed(i)
      end select
   30 continue
      if (jdisTipo > 0) then
        write(lo,'(24x,42(1h.))')
        write(lo,300)itot,segnim,dif1m,disb1m,dif2m,disb2m
      else
c       write(lo,300)itot
      end if
  100 format(f10.4,'  - ',f10.4,i7,5f7.2,' |',i7,5f7.2)
c 110 format(f10.4,'  - ',f10.4,i7,3f7.2,' |',i7,3f7.2)
  150 format(f10.4,'  - ',f10.4,i7,' |',i7)
  200 format(11x,a11,6x,'HIS',2x,'%INV',
     *      '  <er1> <w-er1>',' <er2> <w-er2>',' |',
     *      '   CUM',3x,'%INV',
     *      '  <er1> <w-er1>',' <er2> <w-er2>')
  210 format(11x,a11,6x,'HIS',1x,'<err>c',
     *      '  <er1> <w-er1>',' <er2> <w-er2>','|',
     *      '   CUM',2x,'<err>c',
     *      '  <er1> <w-er1>',' <er2> <w-er2>')
  250 format(11x,a11,6x,'HIS',3x,'CUM')
  300 format(24x,i7,5f7.2,/)

      DEALLOCATE (dijs,iorde1, stat = ierr)

      return
      end

*-----------------------------------------------------------------------
      subroutine GetStatRfac(tirang,dij,fc,fo,Nend,Ninit,
     *           peso,nrang1,rmax1)

      USE General
      character tirang*80


      integer his(102),cumde(102)

      integer, allocatable :: iorde(:)
      real, allocatable :: segni(:),dijs(:),c1(:)

      real shi(4),range(101),disa1(101),dij(Nend),
     *  peso(Nend),cumerr(101),fo(Nend),fc(Nend),
     *  sumfo(101),sumdiff(101),rfac1(101),rfac2(101),
     *            sumdiffs(101),rfac1s(101),rfac2s(101),
     *  sumfc(101),sumfofc(101),sumfosq(101),sumfcsq(101),
     *  sumfc2(101),sumfofc2(101),sumfosq2(101),sumfcsq2(101),
     *  dsegni(101),csegni(101),sumfo2(101),sumdiff2(101),
     *  sumdiff2s(101),cumdew(101),disa1w(101),cumerrw(101),
     *  cmed(101),corrFoFc(101),corrFoFc2(101)
c--
     


      allocate(iorde(Nend),segni(Nend),dijs(Nend),c1(Nend), stat=ierr)

      nrang=10
c     if (nrang1.gt.0) nrang=nrang1

      ntot=count(peso(Ninit:Nend) > 0.0)
      if (nrang1 > 0) then
       nrang=nrang1
      elseif (nrang1 < 0) then
c      nrang=Ntot/abs(nrang1)
c      nRifbin=abs(nrang1)
       nRifbin=Ntot/abs(nrang1)
       nrang=abs(nrang1)
       if (nrang*nRifbin < ntot) nrang=nrang+1
c      if (nrang > 100) then
c        nrang = 100
c        nRifbin=Ntot/nrang
c        if (nrang*nRifbin < ntot) nrang=nrang+1
c      endif
      endif

      rmin=999999.
      rmax=-999999.
      itot=0
      sumerr=0.0

      ii = 0
      sumFobs = 0.0
      sumFcal = 0.0
      do 5 i=Ninit,Nend
       if (peso(i).le.0.0) goto 5
       sumFobs = sumfobs + abs(fo(i))
       sumFcal = sumfcal + abs(fc(i))
       ii=ii +1
       iorde(ii)=i
       dijs(ii)=dij(i)
       if (dij(i).lt.rmin) rmin=dij(i)
       if (dij(i).gt.rmax) rmax=dij(i)
    5 continue

      scFoFc=sumFcal/sumFobs
c     scFoFc=1.0 ! uffa
c     write(lo,*)'   Scale(Fo,Fc)=',scFoFc

      nTotalSort=ii
      call sortall3(1,dijs,1,nTotalSort,iorde)

      rmaxg=rmax
      if (rmax1.gt.0.0) rmax=rmax1
      if (rmax.eq.0.0.and.rmin.eq.0.0) goto 1000
      dev=rmax-rmin
      iaa=nint(dev)
      rang=float(nrang)
      if (iaa.gt.0) then
         dev=float(iaa)/rang
      else
         dev=dev/rang
      endif
      range(1)=float(int(10.*rmin))/10.

      do i=2,nrang
         range(i)=range(i-1)+dev
      enddo
 
      range(1)=rmin
      range(nrang)=rmaxg

      his(:)=0
      cumde(:)=0.0
      sumfo(:)=0.0
      sumfosq(:)=0.0
      sumfosq2(:)=0.0
      sumfc(:)=0.0
      sumfc2(:)=0.0
      sumfcsq(:)=0.0
      sumfcsq2(:)=0.0
      sumfofc(:)=0.0
      sumfofc2(:)=0.0
      sumdiff(:)=0.0
      sumdiffs(:)=0.0
      sumfo2(:)=0.0
      sumdiff2(:)=0.0
      sumdiff2s(:)=0.0
      rfac1(:)=0.0
      rfac1s(:)=0.0
      rfac2(:)=0.0
      rfac2s(:)=0.0
      corrFoFc(:)=0.0
      corrFoFc2(:)=0.0
c
      nu = 0
      n = 2
      sumerr = 0.0
      sumw = 0.0

      sumdiffTot=0.0
      sumdiffsTot=0.0
      sumfoTot = 0.0
      sumfosqTot = 0.0
      sumfcTot = 0.0
      sumfcsqTot = 0.0
      sumfofcTot = 0.0

      ii = 0

      do 15 i=1,nTotalSort
        k=iorde(i)
        if (k.lt.Ninit) goto 15
        if (peso(k).le.0.0) go to 15
        ii=ii+1
!
        if (nrang1 < 0) then
          if (ii==nRifbin) then
           his(n)=his(n)+1
           range(n)=dijs(i)
           n=n+1
           ii=0
          else
           his(n)=his(n)+1
           sumdiff(n)=sumdiff(n)+abs(fo(k)-fc(k)/scFoFc)
           sumdiffs(n)=sumdiffs(n)+(fo(k)-fc(k)/scFoFc)
           !
           sumdiffTot=sumdiffTot+abs(fo(k)-fc(k)/scFoFc)
           sumdiffsTot=sumdiffsTot+(fo(k)-fc(k)/scFoFc)
           !
           sumfo(n)=sumfo(n)+fo(k)
           sumfosq(n)=sumfosq(n)+fo(k)**2
           sumfc(n)=sumfc(n)+fc(k)
           sumfcsq(n)=sumfcsq(n)+fc(k)**2
           sumfofc(n)=sumfofc(n)+abs(fo(k)*fc(k))
           !
           sumfoTot=sumfoTot + fo(k)
           sumfosqTot=sumfosqTot + fo(k)**2
           sumfcTot=sumfcTot + fc(k)
           sumfcsqTot=sumfcsqTot + fc(k)**2
           sumfofcTot=sumfofcTot + fo(k)*fc(k)
          endif
        else
   17    if (dijs(i).le.range(n)) then
           nu=nu+1
           his(n)=nu
           sumdiff(n)=sumdiff(n)+abs(fo(k)-fc(k)/scFoFc)
           sumdiffs(n)=sumdiffs(n)+(fo(k)-fc(k)/scFoFc)
           !
           sumdiffTot=sumdiffTot+abs(fo(k)-fc(k)/scFoFc)
           sumdiffsTot=sumdiffsTot+(fo(k)-fc(k)/scFoFc)
           !
           sumfo(n)=sumfo(n)+fo(k)
           sumfosq(n)=sumfosq(n)+fo(k)**2
           sumfc(n)=sumfc(n)+fc(k)
           sumfcsq(n)=sumfcsq(n)+fc(k)**2
           sumfofc(n)=sumfofc(n)+abs(fo(k)*fc(k))
           !
           sumfoTot=sumfoTot + fo(k)
           sumfosqTot=sumfosqTot + fo(k)**2
           sumfcTot=sumfcTot + fc(k)
           sumfcsqTot=sumfcsqTot + fc(k)**2
           sumfofcTot=sumfofcTot + fo(k)*fc(k)
           !
         else
           nu=1
   23      n=n+1
           if(n.gt.nrang)n=nrang
           if (dijs(i).le.range(n)) then
             his(n)=nu
             sumfofc(n)=sumfofc(n)+abs(fo(k)*fc(k))
             sumdiff(n)=sumdiff(n)+abs(fo(k)-fc(k)/scFoFc)
             sumdiffs(n)=sumdiffs(n)+(fo(k)-fc(k)/scFoFc)
             !
             sumdiffTot=sumdiffTot+abs(fo(k)-fc(k)/scFoFc)
             sumdiffsTot=sumdiffsTot+(fo(k)-fc(k)/scFoFc)
             !
             sumfo(n)=sumfo(n)+fo(k)
             sumfosq(n)=sumfosq(n)+fo(k)**2
             sumfc(n)=sumfc(n)+fc(k)
             sumfcsq(n)=sumfcsq(n)+fc(k)**2
             sumfofc(n)=sumfofc(n)+abs(fo(k)*fc(k))
             !
             sumfoTot=sumfoTot + fo(k)
             sumfosqTot=sumfosqTot + fo(k)**2
             sumfcTot=sumfcTot + fc(k)
             sumfcsqTot=sumfcsqTot + fc(k)**2
             sumfofcTot=sumfofcTot + fo(k)*fc(k)
             !
           else
             goto 23
           endif
         endif
        endif
   15 continue

      if (nrang1 < 0) then
c       nrang=n-1
        range(nrang+1)=rmaxg
      endif

      do 20 i=2,nrang
         itot=itot+his(i)
         if (his(i) > 0.and.sumfo(i).gt.0.0) then
            rfac1(i)=sumdiff(i)/sumfo(i)
            rfac1s(i)=sumdiffs(i)/sumfo(i)
            aa = sumfo(i)/float(his(i))
            bb = sumfosq(i)/float(his(i))
            cc = sumfc(i)/float(his(i))
            dd = sumfcsq(i)/float(his(i))
            ee = sumfofc(i)/float(his(i))
            rnum = ee - (aa*cc)
            aa1 = bb - aa**2
            bb1 = dd - cc**2
            if (aa1 > 0.0 .and. bb1 > 0.0) then
              rden = sqrt(aa1) * sqrt(bb1)
              corrFoFc(i)=rnum/rden
              if (abs(corrFoFc(i)) > 1.0) corrFoFc(i)=0.0
            else
              corrFoFc(i)=0.0
            endif
         else
            rfac1(i)=0.0
            rfac1s(i)=0.0
            corrFoFc(i)=0.0
         endif
   20 continue

      if (itot.le.0) goto 1000

      cumde(nrang)   =his(nrang)
      sumdiff2(nrang) =sumdiff(nrang)
      sumdiff2s(nrang)=sumdiffs(nrang)
      !
      sumfo2(nrang)   = sumfo(nrang)
      sumfosq2(nrang) = sumfosq(nrang)
      sumfc2(nrang)   = sumfc(nrang)
      sumfcsq2(nrang) = sumfcsq(nrang)
      sumfofc2(nrang) = sumfofc(nrang)
      !
      rfac2(nrang) = rfac1(nrang)
      rfac2s(nrang) = rfac1s(nrang)
      corrFoFc2(nrang) = corrFoFc(nrang)

      do 30 i=2,nrang-1
      cumde(nrang+1-i)=cumde(nrang+2-i)+his(nrang+1-i)
      sumdiff2(nrang+1-i)=sumdiff2(nrang+2-i)+sumdiff(nrang+1-i)
      sumdiff2s(nrang+1-i)=sumdiff2s(nrang+2-i)+sumdiffs(nrang+1-i)
      !
      sumfo2(nrang+1-i)=sumfo2(nrang+2-i)+sumfo(nrang+1-i)
      sumfosq2(nrang+1-i)=sumfosq2(nrang+2-i)+sumfosq(nrang+1-i)
      sumfc2(nrang+1-i)=sumfc2(nrang+2-i)+sumfc(nrang+1-i)
      sumfcsq2(nrang+1-i)=sumfcsq2(nrang+2-i)+sumfcsq(nrang+1-i)
      sumfofc2(nrang+1-i)=sumfofc2(nrang+2-i)+sumfofc(nrang+1-i)
      !
      if (sumfo2(nrang+1-i).gt.0.0) then
        rfac2(nrang+1-i)=sumdiff2(nrang+1-i)/sumfo2(nrang+1-i)
        rfac2s(nrang+1-i)=sumdiff2s(nrang+1-i)/sumfo2(nrang+1-i)
        aa = sumfo2(nrang+1-i)/float(cumde(nrang+1-i))
        bb = sumfosq2(nrang+1-i)/float(cumde(nrang+1-i))
        cc = sumfc2(nrang+1-i)/float(cumde(nrang+1-i))
        dd = sumfcsq2(nrang+1-i)/float(cumde(nrang+1-i))
        ee = sumfofc2(nrang+1-i)/float(cumde(nrang+1-i))
        rnum = ee - (aa*cc)
        aa1 = bb - aa**2
        bb1 = dd - cc**2
c       print*,rnum,ee,aa,cc
        if (aa1 > 0.0 .and. bb1 > 0.0) then
         rden = sqrt(aa1) * sqrt(bb1)
         corrFoFc2(nrang+1-i)=rnum/rden
         if (abs(corrFoFc2(nrang+1-i)) > 1.0) corrFoFc(nrang+1-i)=0.0
        else
         corrFoFc2(nrang+1-i)=0.0
        endif
      endif
   30 continue

      aa = sumfoTot/float(itot)
      bb = sumfosqTot/float(itot)
      cc = sumfcTot/float(itot)
      dd = sumfcsqTot/float(itot)
      ee = sumfofcTot/float(itot)
      rnum = ee - (aa*cc)
      aa1 = bb - aa**2
      bb1 = dd - cc**2
      if (aa1 > 0.0 .and. bb1 > 0.0) then
       rden = sqrt(aa1) * sqrt(bb1)
       corrFoFcTot = rnum/rden
      else
       corrFoFcTot = 0.0
      endif
      rfac1Tot=sumdiffTot/sumfoTot
      rfac2Tot=sumdiffsTot/sumfoTot

      write(lo,200)tirang
      do 50 i=2,nrang
      if (his(i).eq.0) go to 50
      write(lo,100) range(i-1),range(i),his(i),rfac1(i),rfac1s(i),
     *         corrFoFc(i),cumde(i),rfac2(i),rfac2s(i),corrFoFc2(i)
   50 continue

      write(lo,'(24x,42(1h.))')
      write(lo,300)itot,rfac1Tot,rfac2Tot,corrFoFcTot

      write(lo,'(//)')
  100 format(f10.4,4h   -  ,f10.4,i6,1x,3f7.2,1x,1h|,1x,i6,1x,3f7.2)
  200 format(11x,a11,5x,'HIS',3x,'R(O,C)',1x,'Rs(O,C)','  CC','  |',
     *      4x,'CUM',3x,'R(O,C)',2x,'Rs(O,C)',' CC')
  300 format(24x,i7,3f7.2,/)


 1000 continue

      deallocate(iorde,segni,dijs,c1, stat=ierr)

      return
      end
!-------------------------------------------------------------------------------------
!    Creare una MASK usando un set di atomi
!    radSphere negativo nel caso che le coordinate. sono ortonormali 
!    xyzAtoms(4,:) si puoi mettere la densita' da inserire per ogni atomo nella MASK
!------------------------------------------------------------------------------------
      subroutine Atoms2Mask(radSphere,natSphere,neqvAtoms,xyzAtoms,mask)
      USE General
      USE Symmetry
      USE Mappa, only: np

      real mask(1:np(1),1:np(2),1:np(3))
      real xyzAtoms(5,natSphere)
      dimension x1(3),x2(3)

      call prepeqv

      write(lo,*) ' write MASK from atoms:'
      write(lo,*) ' Nr Atoms:',natSphere
      write(lo,*) ' sphere radius for atoms in mask:',abs(radsphere)

      do i = 1, natSphere
        x1(1:3) = xyzAtoms(1:3,i)
        x2(1:3) = x1(1:3)
        if (radSphere < 0) then
           x = x1(1)
           y = x1(2)
           z = x1(3)
           call orth2frac(x,y,z,u,v,w)
           x2(1) = u
           x2(2) = v
           x2(3) = w
        endif
        denvalue  = xyzAtoms(4,i)
        call WriteSphere2Map(neqvAtoms,denvalue,abs(radsphere),x2,mask)
c       write(6,*) 'Punti pos in Mask', count (mask > 0.0),denvalue
c       write(6,*) 'Punti negin Mask', count (mask < 0.0),denvalue

      enddo
      write(6,*)'End mask'

      return
      end
!-------------------------------------------------------------
      subroutine WriteSphere2Map(neqvAtoms,denvalue,radius,x0,xSphere)
      USE General
      USE Symmetry
      USE Mappa, only: np

      dimension xSphere(1:np(1),1:np(2),1:np(3))

      dimension b(3)
      integer kx(3),ka(3),kxmi(3,50),kxma(3,50)
      dimension x0(3),xn(3),xini(3),xfin(3),x1(3),x2(3)


      nnx = np(1)
      nny = np(2)
      nnz = np(3)
      npunti=nnx*nny*nnz
      npuA=0

      do 5 i=1,3
        b(i)=cell(i)/float(np(i))
 5    continue

       ka(1)=nint(radius/b(1))
       ka(2)=nint(radius/b(2))
       ka(3)=nint(radius/b(3))
       npuT=0
       npuD=0
       
       do 60 k=1,neqvAtoms
          call oper(k,xn,x0(1),x0(2),x0(3))
          nbox=1
          do 65 j=1,3
            if (xn(j).lt.0.0) xn(j)=xn(j)-int(xn(j))+1.0
            if (xn(j).gt.1.0) xn(j)=xn(j)-int(xn(j))
            kx(j)=nint(xn(j)*np(j)) + 1
            kxmi(j,nbox)=kx(j)-ka(j)
            kxma(j,nbox)=kx(j)+ka(j)
 65       continue

        do 70 irep=1,3
        nbox1=nbox
        do 72 ib=1,nbox1
          do 73 j=1,3
            if (kxmi(j,ib).lt.1) then
               nbox=nbox+1
               kxmi(j,nbox)=np(j)+kxmi(j,ib)+1
               kxma(j,nbox)=np(j)
               do 74 jj=1,3
                 if (jj.eq.j) goto 74
                 kxmi(jj,nbox)=kxmi(jj,ib)
                 kxma(jj,nbox)=kxma(jj,ib)
 74            continue
               kxmi(j,ib)=1
            endif
            if (kxma(j,ib).gt.np(j)) then
               nbox=nbox+1
               kxmi(j,nbox)=1
               kxma(j,nbox)=kxma(j,ib)-np(j)
               do 75 jj=1,3
                 if (jj.eq.j) goto 75
                 kxmi(jj,nbox)=kxmi(jj,ib)
                 kxma(jj,nbox)=kxma(jj,ib)
 75            continue
               kxma(j,ib)=np(j)
          endif
 73     continue
 72     continue
 70     continue

        do 76 nn=1,nbox

          do 80 ix=kxmi(1,nn),kxma(1,nn)
           do 80 iy=kxmi(2,nn),kxma(2,nn)
              do 80 iz=kxmi(3,nn),kxma(3,nn)
                 xfin(1)=float(ix)
                 xfin(2)=float(iy)
                 xfin(3)=float(iz)
                 xini(1)=float(kx(1))
                 xini(2)=float(kx(2))
                 xini(3)=float(kx(3))
                 dis=dista2(xini,xfin,b,np)
                 if (dis.le.radius) then
                   npuA=npuA+1
                   xSphere(ix,iy,iz)= denvalue
                 endif
 80           continue
 76     continue
 60     continue

      return
      end
*--------------------------------------------
      subroutine CheckInMask(inMask,x1,xMask)

      USE Mappa, only: np

      dimension xMask(1:np(1),1:np(2),1:np(3))
      dimension x1(3), i1(3), i2(3), b(3)


      do i = 1, 3
        if (x1(i).lt.0.0) x1(i)=x1(i)-int(x1(i))+1.0
        if (x1(i).ge.1.0) x1(i)=x1(i)-int(x1(i))
        
        i1(i) = x1(i) * np(i)
        i1(i) = min(np(i),i1(i))
        i1(i) = max(1,i1(i))
      enddo
 
      inMask = xMask(i1(1),i1(2),i1(3))

      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine frac2orth(u,v,w,x,y,z)
      USE General
      real u,v,w,x,y,z
      x=qd(1,1)*u+qd(1,2)*v+qd(1,3)*w+qd(1,4)
      y=qd(2,1)*u+qd(2,2)*v+qd(2,3)*w+qd(2,4)
      z=qd(3,1)*u+qd(3,2)*v+qd(3,3)*w+qd(3,4)
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine orth2frac(x,y,z,u,v,w)
      USE General
      real u,v,w,x,y,z

      u=qt(1,1)*x+qt(1,2)*y+qt(1,3)*z+qt(1,4)
      v=qt(2,1)*x+qt(2,2)*y+qt(2,3)*z+qt(2,4)
      w=qt(3,1)*x+qt(3,2)*y+qt(3,3)*z+qt(3,4)
      return
      end
c
c ----------------------------------------------------------------------
c
*---------------------------------------
      function dista2(xini,xfin,b,np)

      USE General

      dimension delta(3),xini(3),xfin(3),b(3),np(3)


      a1=cell(4)*dtor
      a2=cell(5)*dtor
      a3=cell(6)*dtor

      a1=cos(a1)
      a2=cos(a2)
      a3=cos(a3)

      sumd2=0.0

      a12=0.0
      a13=0.0
      a23=0.0

      do 10 i=1,3
        de1= abs(xfin(i)-xini(i))
        de= min(abs(de1-np(i)),de1)
        delta(i)= de*b(i)
        sumd2=sumd2+delta(i)**2
 10   continue

      a12=2.0*delta(1)*delta(2)*a3
      a13=2.0*delta(1)*delta(3)*a2
      a23=2.0*delta(2)*delta(3)*a1

      d2 = sumd2+a12+a13+a23
      dista2=sqrt(d2)

      return
      end
!-----------------------------------------------------------------------
      subroutine Atoms2Mask_new(jGauss,radius,natGauss,xyzAtoms,map)
      USE General
      USE Symmetry
      USE Mappa, only: np

      real map(0:np(1)-1,0:np(2)-1,0:np(3)-1)
      real xyzAtoms(5,natGauss)
!
!
      integer sidepp
      dimension xs1(3),xs(3)

      write(lo,*) ' write MASK from atoms (new):'
      write(lo,*) ' Nr Atoms:',natGauss
      write(lo,*) ' sphere radius for atoms in mask:',abs(radius)
!
!--vario linearmente alcuni parametri
!
      dumpfact=0.0
      anormfact=2.0
      coefden = 1.2

      caChem=cos(cell(4)*dtor)
      cbChem=cos(cell(5)*dtor)
      cgChem=cos(cell(6)*dtor)

      deltx=np(1)/cell(1)
      delty=np(2)/cell(2)
      deltz=np(3)/cell(3)
      deltChem=(deltx+delty+deltz)/3.0
!     write(6,*) deltx,delty,deltz,deltChem

!
!--calcolo della costante di normalizzazione
!  (l'intensita' massima del picco inserito e' pari ad anorm)
!
      id = 1  ! solo mappa positiva
      call maxminSP(id,np(1),np(2),np(3),denmin,denmax,
     *                   avden,stden,map)
      anorm = avden + anormfact * stden
!
      anormS = anorm
      anormax = anorm * no(nk) ! Z della specie piu pesante (nel caso mio ??)
      rappo = denmax / anormax
      coefden = rappo * coefden
      anorm = anorm * coefden

      if (jGauss == 2) anorm = 1.0     ! il caso mappa "differenza" con la gaussiana
      if (jGauss == 1) map(:,:,:)=0.0  ! il caso che intorno ad un atomo/picco inserisco una gaussiana
c     if (jGauss == 0) map(:,:,:)=0.0  ! il caso che intorno ad un atomo/picco inserisco una "sfera"
     
!
!--faccio prima pulizia intorno agli atomi da modificare 
!
      nnn = 0
      do i=1,natGauss
        xs1(1)=side(xyzAtoms(1,i))
        xs1(2)=side(xyzAtoms(2,i))
        xs1(3)=side(xyzAtoms(3,i))
        if (abs(radius) > 0.0) then
          alim = abs(radius)          
        else
          alim=xyzAtoms(5,i)
        endif
        if (radius < 0) then
           x = xs1(1)
           y = xs1(2)
           z = xs1(3)
           call orth2frac(x,y,z,u,v,w)
           xs1(1) = u
           xs1(2) = v
           xs1(3) = w
        endif
        alim=alim*1.2*deltChem  ! raggio
        ndrop=ceiling(alim)
!       write (6,*) 'ALIM, NDROP', i, alim, ndrop
!
!--considero tutte le posizioni equivalenti di questo atomo
!
!       write(6,*) ncentr,nsym
        do kk1=1,ncentr
        do kk2=1,icent+1
        coef=1.0
        if(kk2==2) coef=-1.0
        do kk3=1,nsym
          call xequi(xs1,kk3,coef,xs,kk1)
          xs(1)=side(xs(1))
          xs(2)=side(xs(2))
          xs(3)=side(xs(3))
          io1=sidepp(nint(xs(1)*np(1)),np(1))
          io2=sidepp(nint(xs(2)*np(2)),np(2))
          io3=sidepp(nint(xs(3)*np(3)),np(3))
!
!--definisco un intorno di ogni atomo e pulisco l'area
!
          do ix = -ndrop, ndrop
            do iy = -ndrop, ndrop
              do iz = -ndrop, ndrop
                ray=ix**2+iy**2+iz**2+
     &              2.*ix*iy*cgChem + 2.*ix*iz*cbChem + 2.*iy*iz*caChem
                ray=sqrt(ray)
                if(ray<alim) then
                  ix1=sidepp(io1+ix,np(1))
                  ix2=sidepp(io2+iy,np(2))
                  ix3=sidepp(io3+iz,np(3))
                  xx=map(ix1,ix2,ix3)
                  map(ix1,ix2,ix3)=xx*dumpfact
                  nnn = nnn + 1
!                write(77,'(a,4i7,5f10.2)') 'map',nnn,ix1,ix2,ix3,
!    &                     ray,alim,xx,
!    &                           map(ix1,ix2,ix3),dumpfact
                endif
              enddo
            enddo
          enddo
!
        enddo
        enddo
        enddo
      enddo

!
!--modifico la mappa in modo da inserire una gaussiana intorno ad ogni
!  atomo posizionato; le code si possono sovrapporre
!
      nnn = 0
      summap = 0
      do i=1,natGauss
        xs1(1)=side(xyzAtoms(1,i))
        xs1(2)=side(xyzAtoms(2,i))
        xs1(3)=side(xyzAtoms(3,i))
        if (abs(radius) > 0.0) then
         alim = abs(radius)
        else
         alim=xyzAtoms(5,i)
        endif
        if (radius < 0) then
           x = xs1(1)
           y = xs1(2)
           z = xs1(3)
           call orth2frac(x,y,z,u,v,w)
           xs1(1) = u
           xs1(2) = v
           xs1(3) = w
        endif
        alim=alim*1.2*deltChem  ! raggio
        sigma=alim/3.0
        ndrop=ceiling(alim)
        zdump = 1.0   ! xyzSk(4,i) / xyzSk(4,1)
c       write (6,*) 'ALIM, NDROP, ZDUMP', i, alim, ndrop, zdump

!
!--inserisco la differenziazione in base al tipo di atomo inserito
!
        denvalue  = xyzAtoms(4,i)
        anorm1 = anorm * xyzAtoms(4,i) * zdump ! Instensita per ogni picco
c       write(6,'(a,i6.2f8.2,i8,2f10.2)') 'atom',i,xyzAtoms(5,i),
c    *       alim,ndrop,xyzAtoms(4,i),anorm1
!
!--considero tutte le posizioni equivalenti di questo atomo
!
        do kk1=1,ncentr
        do kk2=1,icent+1
        coef=1.0
        if(kk2==2) coef=-1.0
        do kk3=1,nsym
          call xequi(xs1,kk3,coef,xs,kk1)
          xs(1)=side(xs(1))
          xs(2)=side(xs(2))
          xs(3)=side(xs(3))
          io1=sidepp(nint(xs(1)*np(1)),np(1))
          io2=sidepp(nint(xs(2)*np(2)),np(2))
          io3=sidepp(nint(xs(3)*np(3)),np(3))
!
!--definisco un intorno di ogni atomo e creo la Gaussiana
!
          do ix = -ndrop, ndrop
            do iy = -ndrop, ndrop
              do iz = -ndrop, ndrop
                ray=ix**2+iy**2+iz**2+
     &              2.*ix*iy*cgChem + 2.*ix*iz*cbChem + 2.*iy*iz*caChem
                ray=sqrt(ray)
                if(ray<alim) then
                  ix1=sidepp(io1+ix,np(1))
                  ix2=sidepp(io2+iy,np(2))
                  ix3=sidepp(io3+iz,np(3))
                  xx=map(ix1,ix2,ix3)
                  term=ray/sigma
                  factt=anorm1*exp(-0.5*term*term)
                  select case (jGauss)
                  case (0)
                     map(ix1,ix2,ix3) = denvalue
                  case (1)
                     map(ix1,ix2,ix3) = xx+factt
                  case (2)
                     map(ix1,ix2,ix3) = xx-factt
                  end select
                  nnn = nnn + 1
                  summap = summap + map(ix1,ix2,ix3)
!                write(88,'(a,4i7,5f10.2)') 'map',nnn,ix1,ix2,ix3,
!    &                      ray,alim,xx,
!    &                      map(ix1,ix2,ix3),factt
                endif
              enddo
            enddo
          enddo
!
        enddo
        enddo
        enddo
      enddo
      avemap = summap / nnn
!
      return
      end
*----------------------------------------------------------------------------*
      subroutine maxminSP(id,nx,ny,nz,denmin,denmax,avden,stden,x)
      USE General
      real x(1:nx,1:ny,1:nz)

!     id = 0 tutta la mappa
!     id = 1 la parte positiva della mappa

      avden = 0.0
      stden = 0.0
      denmin = 1.0e25
      denmax = -1.0e25
      npunt = 0

      if (id ==0) then
         do  iz = 1, nz
          do  iy = 1, ny
           do  ix = 1, nx
              xx=x(ix,iy,iz)
              denmax=amax1(denmax,xx)
              denmin=amin1(denmin,xx)
              avden=avden + xx
              stden=stden + xx * xx
              npunt=npunt+1
           enddo
          enddo
         enddo
      else
         do  iz = 1, nz
          do  iy = 1, ny
           do  ix = 1, nx
              xx=x(ix,iy,iz)
              if (xx > 0.0) then
                denmax=amax1(denmax,xx)
                denmin=amin1(denmin,xx)
                avden=avden + xx
                stden=stden + xx * xx
                npunt=npunt+1
              endif
           enddo
          enddo
         enddo
      endif

      avden=avden/float(npunt)
      stden=stden/float(npunt)
      stden=stden - avden*avden
      if (stden.gt.0.0) then
          stden=sqrt(stden)
      else
          stden=0.0
      endif

      return
      end
!-----------------------------------------------------------------------
      subroutine Atoms2Map_Gauss(badd,radius,natGauss,xyzAtoms,
     *                          bfacAtoms,nzAtoms,map)
      USE General
      USE Symmetry
      USE Mappa, only: np
      USE Atomi, only: nzConst

      real map(0:np(1)-1,0:np(2)-1,0:np(3)-1)
      real xyzAtoms(5,natGauss),bfacAtoms(natGauss)
      integer nzAtoms(natGauss)
!
!
      integer sidepp
      dimension anorm2(4),vet(4)
      dimension GAUSS(4501)
      dimension xs1(3),xs(3)

      write(lo,*) ' write MAP from atoms'
      write(lo,*) ' Nr Atoms:',natGauss

!
!--determino la costante per passare da Angstrom a punti griglia:
!
      deltx=np(1)/cell(1)
      delty=np(2)/cell(2)
      deltz=np(3)/cell(3)
      caChem=cos(cell(4)*dtor)
      cbChem=cos(cell(5)*dtor)
      cgChem=cos(cell(6)*dtor)
      FourPiSq=TwoPi*TwoPi
      rmax=2.5
      rmax = abs(radius)
c
c--tabulazione dei valori della funzione esponenziale
c
      map(:,:,:) = 0.0
      GAUSS(:) = 0.0
      do i = 1,4500
        GAUSS(i) = exp(-0.002*i+0.002)
      enddo

      do i=1,natGauss
        xs1(1)=side(xyzAtoms(1,i))
        xs1(2)=side(xyzAtoms(2,i))
        xs1(3)=side(xyzAtoms(3,i))
        bterm=bfacAtoms(i)+badd
!                  centr* occupanza
c       anorm=100.*pts*xyzAtoms(5,i)+10*badd
        anorm=pts*xyzAtoms(5,i)+10*badd
        kz=nzAtoms(i)/nzConst
        anorm1 =  anorm * cl(kz)/(bterm)**1.5
        ngaus=4
        do ii=1,ngaus
           vet(ii)=bterm+bs(ii,kz)
           anorm2(ii) =  anorm * al(ii,kz)/ (vet(ii))**1.5
        enddo
c
c--determino il raggio di integrazione
c
        alim=rmax*(sqrt(bterm+25)/TwoPi)
        DmaxSq=alim*alim

!
c--aggiungo la simmetria
!
        do kk1 = 1, ncentr
           do kk2 = 1, icent+1
              coef = 1.0
              if (kk2 == 2) coef = -1.0
              do kk3 = 1,nsym
                call xequi(xs1,kk3,coef,xs,kk1)
                xs(1)=side(xs(1))
                xs(2)=side(xs(2))
                xs(3)=side(xs(3))
                iszu=int(xs(3)*np(3)+alim*deltz)
                iszl=int(xs(3)*np(3)-alim*deltz)
                isyu=int(xs(2)*np(2)+alim*delty)
                isyl=int(xs(2)*np(2)-alim*delty)
                isxu=int(xs(1)*np(1)+alim*deltx)
                isxl=int(xs(1)*np(1)-alim*deltx)
!
!--definisco un intorno di ogni atomo e creo la Gaussiana
!
                do iz = iszl, iszu
                 do iy = isyl, isyu
                  do ix = isxl, isxu
                    a1=ix/deltx-xs(1)*cell(1)
                    a2=iy/delty-xs(2)*cell(2)
                    a3=iz/deltz-xs(3)*cell(3)
                    ray=a1**2 + a2**2 + a3**2 + 2.*a1*a2*cgChem +
     &                       2.*a1*a3*cbChem + 2.*a2*a3*caChem
                    if (ray < DmaxSq) then
                      ix1=sidepp(ix,np(1))
                      ix2=sidepp(iy,np(2))
                      ix3=sidepp(iz,np(3))
                      term = ray*500.0*(FourPiSq/bterm) + 1.0
                      term = MIN1(term,4001.1)
                      iterm = nint(term)
                      factt  = anorm1*GAUSS(iterm)
                      do ii=1,ngaus
                        term = ray*500.0*(FourPiSq/vet(ii)) + 1.0
                        term = MIN1(term,4001.1)
                        iterm = nint(term)
                        factt  = factt + anorm2(ii)*GAUSS(iterm)
                      enddo
                      map(ix1,ix2,ix3) = map(ix1,ix2,ix3)+factt
                    endif
                  enddo
                 enddo
                enddo
!
              enddo
           enddo
        enddo
!
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine SaveLists123
      USE General
      USE Symmetry
      USE RemoModule
!
      character*16 spg1
      integer kshif(3) 
!
!-- Save cell parameters
!
      if (InfoOK(1) > 0) then
          cellSav(:) = cell(1:6)
          errcellSav(:) = errcell(:)
      endif
!
!-- Save List 2 content
!
      if (InfoOK(2) > 0) then
          write(SpaceSav,'(16a1)') nSpaceG
          nsymSav = nsym
          icentSav = icent
          ismatSav(:,:,:) = ismat(:,:,:)
          ncentrSav = ncentr
          totopSav = totop
          aaaSav(:) = aaa(:)
!-----------
          kshif(:) = 0
          ishif    = 0
          ier      = 0
          spg1     = 'p 1             ' 
!
          read(spg1,'(16a1)') nSpaceG
          call CreaSymmetryInfo(ier)
!
          nsymTrue = nsymSav
!
          jspini = -1 ! croc
          call xspinb
      endif
!
!-- Save List 3 content
!
      if (InfoOK(3) > 0) then
          nalfSav(:) = nalf(:)
          nwSav(:)   = nw(:)
          waveSav    = wavel
          nkSav      = nk
          anatSav = anat
          clSav(:) = cl(:)
          alSav(:,:) = al(:,:)
          bsSav(:,:) = bs(:,:)
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine RestoreLists123(Lista)
      USE General
      USE Symmetry
      USE RemoModule
!
      dimension celltemp(13), kshif(3)
      logical :: noWrite
      common/util2/noWrite
!
      ifLista1 = InfoOK(1)
      ifLista2 = InfoOK(2)
      ifLista3 = InfoOK(3)
      if (Lista == 1 .and. ifLista1 > 0) then
!
!-- Restore List 1 content
!
          celltemp(1:6)  = cellSav(1:6)
          celltemp(7:13) = errcellSav(:)
          call CreaCellInfo(celltemp) !!mr(1:6))
!
      elseif (Lista == 2 .and. ifLista2 > 0) then
!
!-- Restore List 2 content
!
          read(SpaceSav,'(16a1)') nSpaceG
          ier = 0
          call CreaSymmetryInfo(ier)
          if (nsym.eq.1.and.icent.eq.0) then
              ifReduced = 0
          endif
          nsymTrue = nsym
          ncentr = ncentrSav
          jspini = -1
          call xspinb
          totop = (icent + 1) * nsym * pts
canna
!         if (noWrite) then
!             call WriteSymmInfo(lo)
!          endif
!          noWrite=.true.
c          call WriteSymmInfo(lo)
canna
!
      elseif (Lista == 3 .and. ifLista3 > 0) then
!
!-- Restore List 3 content
!
          nalf(:) = nalfSav(:)
          nw(:)   = nwSav(:)
          wave    = waveSav
          nk      = nkSav
          do j=1, nkSav
             write(Species(j),'(a4)') nalf(j)
          enddo
          call CreaAtmPropInfo(WhichProps, ier)
          call GetFromAtmStruct
          npq = 0
          anat = anatSav
!
      endif
!
      return
      end
!-----------------------------------------------------------------------
code for xbijx
      subroutine xbijx(xmatr,bin,bout)
c--calculate the product of a matrix for the Bij
c  bin  vector containig the current Bij
c  bout vector containing the changed Bij
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      dimension xmatr(*),bin(*),bout(*),temp(9),temp1(9)
      temp(1)=bin(1)
      temp(2)=bin(2)
      temp(3)=bin(3)
      temp(4)=bin(2)
      temp(5)=bin(4)
      temp(6)=bin(5)
      temp(7)=bin(3)
      temp(8)=bin(5)
      temp(9)=bin(6)
      call xmttm(xmatr,temp,temp1,3,3,3)
      call xmtmm(temp1,xmatr,temp,3,3,3)
      bout(1)=temp(1)
      bout(2)=temp(2)
      bout(3)=temp(3)
      bout(4)=temp(5)
      bout(5)=temp(6)
      bout(6)=temp(9)
      return
      end
!-----------------------------------------------------------------------
      subroutine sftryyycNew(iref,mode,numb,scalan,ifBreak,iCoeff)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Molcom
      USE MadModule
      USE PhaseModule
      USE SuperFast
!
!----
!     structure factor calculation
!----
!
      implicit none
      integer :: i1(3), iref, mode, numb, ifBreak, ifBreakFun, iCoeff
      integer :: i, j, ji, ij, jj, k, l, kz, iphap
      real    :: scalan, scale, fkz, arg, effe, tfocc, tfocp
      real    :: contc, conts, act, bct, arg2, args, fc, faze, ac, bc
      real    :: fo, foTest, sumfor, sumfo, sumfc, absdf, sumdf, df
      real    :: sumdf2, sig, den, sumfff, spts, c1, c2, rfac, tt, rho
      real    :: ScattFact, gSimValue, bes
!
      call StartSuperFast
!
      work1(1:numb) = 0.0
      fcoef(1:numb) = 0.0
!
      if (mode.eq.1.or.krecy.eq.1) oscale=1.0
!
      scale=1.0/oscale
      sumfo=0.0
      sumfor=0.0
      sumfc=0.0
      sumdf=0.0
!
      do ji=1,numb
         i = vettoreSigma(ji)
         if (i == 0) cycle
         i1(1:3) = khl(1:3,i)
!
!-- compute H*R and H*T
!
         do j=1,nsym
            tt=1000.0
            do l=1,3
               tt=tt+float(i1(l))*tmat(j,l)
               hkle(l,j)=0
!
               do k=1,3
                  hkle(l,j)=hkle(l,j)+i1(k)*kmat(j,k,l)
               enddo
!
            enddo
            hkle(4,j)=tt
         enddo
         fo=fovet(i)
         rho=rhov(i)
         act=0.0
         bct=0.0
         do ij=1,nk
            ff(ij) = ScattVett(ij,i) ! ScattFact(ij, rho)
         enddo
!
!-- manage BREAK button
!
         if (mode.gt.1.and.ifBreak.eq.0) then
             ifBreak = ifBreakFun()
             if (ifBreak == 1) then
                return
             endif
         endif
         do jj=1,nats
            if (nz(jj).ne.0) then
                kz=iabs(nz(jj))
                fkz=ff(kz)
                arg=-bfac(jj)*rho
                effe=pts*fkz*exp(arg)
                tfocc=effe*xyzs(5,jj)
                tfocp=tfocc*twopi*float(icent+1)
                call sfacyyy(jj,contc,conts,tfocp,iref)
                contc=contc*tfocc
                conts=conts*tfocc
                act=act+contc
                bct=bct+conts
            endif
         enddo
         args=act*act+bct*bct
         if (neutro == 2) then
             arg2= sqrt(args)
             if (arg2.gt.0.000001) then
                 fc=arg2
                 faze=rtod*atan2(bct,act)+360.0
                 ac=act/fc
                 bc=bct/fc
             else
                 fc=0.0
                 faze=0.0
                 ac=0.0
                 bc=0.0
             endif
         else
             if (args.gt.0.000001) then
                 fc=sqrt(args)
                 faze=rtod*atan2(bct,act)+360.0
                 ac=act/fc
                 bc=bct/fc
             else
                 fc=0.0
                 faze=0.0
                 ac=0.0
                 bc=0.0
             endif
         endif
         work1(i)=fc
         fcvet(i) = fc

         foTest=fo
         sumfor=sumfor+fo
         fo=fo*scale
         df=fo-fc
         sumfo=sumfo+fo
         sumfc=sumfc+fc
         absdf=abs(df)
         sumdf=sumdf+absdf
!
!-- compute stuff for fourier
!
         iphap=mod(int(faze+0.5),360)
         if (iphap.eq.0) iphap=360
         iphaz(i)=iphap
      enddo
!
!--  compute r-factor
!
      scalan=sumfc/sumfor

      oscale=1.0/scalan
      sumdf=0.0
      sumfo=0.0

      do ji=1,numb
         i = vettoreSigma(ji)
         if (i == 0) cycle
         absdf=abs(work1(i)-scalan*fovet(i))
         sumdf=sumdf+absdf
         sumfo=sumfo+scalan*fovet(i)
      enddo
      erre=sumdf/sumfo
      rfac=100.0*erre
!
!
!-- compute fourier coefficients and weights
!--         iCoeff = 1  Observed
!--                = 2  2*Fo - Fc
!--                = 3  Difference
!

      if (iCoeff.gt.0) then
          if (iCoeff.eq.1) then
              c1 = 1.0
              c2 = 0.0
          elseif (iCoeff.eq.2) then
              c1 = 2.0
              c2 = 1.0
          elseif (iCoeff.eq.3) then
              c1 = 1.0
              c2 = 1.0
          endif
          do ji=1,numb
             i = vettoreSigma(ji)
             if (i == 0) cycle
             fo       = fovet(i) * scalan
             fc       = work1(i)
             fcoef(i) = c1 * fo  - c2 * fc
          enddo
      elseif (iCoeff.eq.-1) then
          do i=1,numb
             fcoef(i) = evet(i)
          enddo
      endif

      spts = sqrt(pts)

      wt(1:numb)=0.0
      do ji=1,numb
         i = vettoreSigma(ji)
         if (i == 0) cycle
         rho = rhov(i)
         sumfff = 0.0
         do ij=1,nk
            ff(ij) = ScattVett(ij,i) ! ScattFact(ij, rho)
            sumfff=sumfff+nw(ij)*(ff(ij)**2)
         enddo
!
!--     Sim = D1 ( gSim )
!--    gSim =  2 * E(obs) * E(Calc)
!-- E(Calc) =  F(calc) / den
!--     den =  eps * pts * coef * sig
!--     sig =  sqrt( sigma ** 2 ) )
!
         sig = sqrt( exp(-2.0*bt*rho) * sumfff )
         den = epsv(i) * sig
         gSimValue = (0.5* evet(i) * work1(i)) / ( 0.33 * den*pts)
         work1(i) = work1(i) / (den*spts)  ! ecal ! piero 24/09/2009
         work2(i) = gSimValue
         wt(i)=bes(gSimValue)
      enddo
!
      call DoSingleIteration()
!
      return
      end
!-----------------------------------------------------------------------
      subroutine sftryyyc(iref,mode,numb,scalan,ifBreak,iCoeff)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Molcom
      USE MadModule
      USE PhaseModule
!
      dimension ScalanR(5),SumdfR(5),SumfoRP(5),SumfcR(5),SumforR(5)  !pgMAD230306
   
c----
c     structure factor calculation
c----
      integer i1(3)
      character jstep
c

      work1(1:numb) = 0.0
      fcoef(1:numb) = 0.0
!pgMAD230306
*     j = 0
      do i=1,nats
*        if (nz(i) == 0) cycle
*        j = j + 1
***      write(6,2) i, nz(i),xyzs(1:3,i),xyzs(5,i),bfac(i)
      enddo
    2 format(i5,')',i4,3f10.3,f8.3,f10.3)
*     do ji=1,numb
*        i = vettoreSigma(ji)
*        if (i == 0) cycle
*        i1(1)=khl(1,i)
*        i1(2)=khl(2,i)
*        i1(3)=khl(3,i)
*        write(6,*) i, i1, fovet(i),rhov(i)
*     enddo
*     stop
      if (kmad /= 0) then
          numR       = 5
          NumRefR(1) = numb
          NumRefR(2) = 0.75 * numb
          NumRefR(3) = 0.50 * numb
          NumRefR(4) = 0.30 * numb
          NumRefR(5) = 0.20 * numb
      endif
!pgMAD230306

      if (mode.eq.1.or.krecy.eq.1) oscale=1.0
      uno=1
      jlig=1
      if (no(1).eq.1.and.neutro.eq.0) jlig=2
      jstep='A'
c
      jstop=0
      scale=1.0/oscale
      sumfo=0.0
      sumfor=0.0
      sumfc=0.0
      sumdf=0.0
      sumdf2=0.0
      bison=0.0
      bisod=0.0

!pgMAD230306
      if (kmad /= 0) then
          do i=1,numR
             sumfoRP(i)=0.0
             sumforR(i)=0.0
             sumfcR(i)=0.0
             sumdfR(i)=0.0
          end do
      endif
!pgMAD230306

      do 500 ji=1,numb
         i = vettoreSigma(ji)
         if (i == 0) cycle
         i1(1)=khl(1,i)
         i1(2)=khl(2,i)
         i1(3)=khl(3,i)
c
c-- compute H*R and H*T
c
         do j=1,nsym
            tt=1000.0
            do l=1,3
               tt=tt+float(i1(l))*tmat(j,l)
               hkle(l,j)=0
c
               do k=1,3
                  hkle(l,j)=hkle(l,j)+i1(k)*kmat(j,k,l)
               enddo
c
            enddo
            hkle(4,j)=tt
         enddo
         fo=fovet(i)
         rho=rhov(i)
         act=0.0
         bct=0.0
         do ij=1,nk
            ff(ij) = ScattFact(ij, rho)
         enddo
!
!-- manage BREAK button
!
         if (mode.gt.1.and.ifBreak.eq.0) then
             ifBreak = ifBreakFun()
             if (ifBreak == 1) then
                return
             endif
         endif
         do 400 jj=1,nats
            if (nz(jj).ne.0) then
                kz=iabs(nz(jj))
                fkz=ff(kz)
                arg=-bfac(jj)*rho
                effe=pts*fkz*exp(arg)
                tfocc=effe*xyzs(5,jj)
                tfocp=tfocc*twopi*float(icent+1)
                call sfacyyy(jj,contc,conts,tfocp,iref)
                contc=contc*tfocc
                conts=conts*tfocc
                act=act+contc
                bct=bct+conts
            endif
  400    continue
         args=act*act+bct*bct
         if (neutro == 2) then
             arg2= sqrt(args)
             if (arg2.gt.0.000001) then
                 fc=arg2
                 faze=rtod*atan2(bct,act)+360.0
                 ac=act/fc
                 bc=bct/fc
             else
                 fc=0.0
                 faze=0.0
                 ac=0.0
                 bc=0.0
             endif
         else
             if (args.gt.0.000001) then
                 fc=sqrt(args)
                 faze=rtod*atan2(bct,act)+360.0
                 ac=act/fc
                 bc=bct/fc
             else
                 fc=0.0
                 faze=0.0
                 ac=0.0
                 bc=0.0
             endif
         endif
         work1(i)=fc
         fcvet(i) = fc

!pgMAD230306
         if (kmad /= 0) then
             do ii=1,numR
                if (i.le.NumRefR(ii)) then
                   sumforR(ii)=sumforR(ii)+fo
                   sumfcR(ii)=sumfcR(ii)+fc
                end if
             end do
         endif
!pgMAD230306
         foTest=fo
         sumfor=sumfor+fo
         fo=fo*scale
         df=fo-fc
         sumfo=sumfo+fo
         sumfc=sumfc+fc
         absdf=abs(df)
         sumdf=sumdf+absdf
         sumdf2=sumdf2+absdf*absdf
!pgMAD230306

         if (kmad /= 0) then
             do ii=1,numR
                if (i.le.NumRefR(ii)) then
                   sumdfR(ii)=sumdfR(ii)+absdf
                   sumfoRP(ii)=sumfoRP(ii)+fo
                end if
             end do
         endif
!pgMAD230306

c
c-- compute stuff for fourier
c
         iphap=mod(int(faze+0.5),360)
         if (iphap.eq.0) iphap=360
         iphaz(i)=iphap
***      write(6,321) i, khl(:,i),fo,fc,iphap
  321    format(4i5,2f10.4,i6)
  500 continue
!
!--  compute r-factor
!
      scalan=sumfc/sumfor

!pgMAD230306
      if (kmad /= 0) then
          do i=1,numR
             scalanR(i) = sumfcR(i)/sumforR(i)
          end do
      endif
!pgMAD230306

      ksca=0
      if (jrest.eq.0) then
          if (krecy.eq.0) ksca=1
!         if (krecy.le.4) ksca=1
      else
          if (krecy.eq.1) ksca=1
      endif
      ksca=1
      if (ksca.eq.1) then
          oscale=1.0/scalan
          sumdf=0.0
          sumdf2=0.0
          sumfo=0.0

!pgMAD230306
          if (kmad /= 0) then
              do ii=1,numR
                 sumdfR(ii)=0.0
                 sumfoRP(ii)=0.0
              end do
          endif
!pgMAD230306

          do 510 ji=1,numb
             i = vettoreSigma(ji)
             if (i == 0) cycle
             absdf=abs(work1(i)-scalan*fovet(i))
             sumdf=sumdf+absdf
             sumdf2=sumdf2+absdf*absdf
             sumfo=sumfo+scalan*fovet(i)

!pgMAD230306
             if (kmad /= 0) then
                 do ii=1,numR
                    if (i.le.NumRefR(ii)) then
                       absdf=abs(work1(i)-scalanR(ii)*fovet(i))
                       sumdfR(ii)=sumdfR(ii)+absdf
                       sumfoRP(ii)=sumfoRP(ii)+scalanR(ii)*fovet(i)
                    end if
                 end do
             endif
!pgMAD230306

  510     continue
      endif
      erre=sumdf/sumfo
      rfac=100.0*erre

!pgMAD230306
      if (kmad /= 0) then
          do ii=1,numR
             erreR=sumdfR(ii)/sumfoRP(ii)
             rfacR(ii)=100.0*erreR
          end do
      endif
!pgMAD230306

c
c
c-- compute fourier coefficients and weights
c--         iCoeff = 1  Observed
c--                = 2  2*Fo - Fc
c--                = 3  Difference
c

      if (iCoeff.gt.0) then
          if (iCoeff.eq.1) then
              c1 = 1.0
              c2 = 0.0
          elseif (iCoeff.eq.2) then
              c1 = 2.0
              c2 = 1.0
          elseif (iCoeff.eq.3) then
              c1 = 1.0
              c2 = 1.0
          endif
          do ji=1,numb
             i = vettoreSigma(ji)
             if (i == 0) cycle
             fo       = fovet(i) * scalan
             fc       = work1(i)
             fcoef(i) = c1 * fo  - c2 * fc
          enddo
      elseif (iCoeff.eq.-1) then
          do i=1,numb
             fcoef(i) = evet(i)
          enddo
      endif

      spts = sqrt(pts)

      wt(1:numb)=0.0
      do 3500 ji=1,numb
         i = vettoreSigma(ji)
         if (i == 0) cycle
         rho = rhov(i)
         eps = epsv(i)
         sumfff = 0.0
         do ij=1,nk
            ff(ij) = ScattFact(ij, rho)
**          ff(ij)=cl(ij)
**          do 3420 jj=1,4
**             ff(ij)=ff(ij)+al(jj,ij)*exp(-bs(jj,ij)*rho)
**420       continue
            sumfff=sumfff+nw(ij)*(ff(ij)**2)
         enddo
c
c--     Sim = D1 ( gSim )
c--    gSim =  2 * E(obs) * E(Calc)
c-- E(Calc) =  F(calc) / den
c--     den =  eps * pts * coef * sig
c--     sig =  sqrt( sigma ** 2 ) )
c
         coef = 1.0
         sig = sqrt( exp(-2.0*bt*rho) * sumfff )
         den = coef * eps       * sig
!!!!     sig = sqrt( exp(-2.0*bt*rho) * sumfff * eps )  ! ??? piero 24/09/2009
!!!!     den = coef * sig                               ! ??? piero 24/09/2009
*        write(6,*) i,khl(1:3,i),den,coef,eps,sig,rho
c     if(resm.lt.ResSogLow) then
c        gSimValue = (0.5 * evet(i) * work1(i) ) / ( 0.33 * den)
c     else
         gSimValue = (0.5* evet(i) * work1(i)) / ( 0.33 * den*pts)
c     endif
!        work1(i) = work1(i) / (den*pts)  ! ecal
         work1(i) = work1(i) / (den*spts)  ! ecal ! piero 24/09/2009
         work2(i) = gSimValue
         wt(i)=bes(gSimValue)
 3500 continue
!
      call DoSingleIteration()
!
      return
      end
!-----------------------------------------------------------------------
      subroutine sfacyyy(jj, contc, conts, tfocp, iref)
      USE General
      USE Symmetry
      USE Atomi
      USE PhaseModule
!
!--   structure factor calculation
!
      implicit none
      integer :: jj, iref, j, iarg, k
      real    :: contc, conts, tfocp, arg, att, btt, hkltf
!
      att = 0.0
      btt = 0.0
      do j=1, nsym
         arg = amod( hkle(1,j) * xyzs(1,jj)
     *             + hkle(2,j) * xyzs(2,jj)
     *             + hkle(3,j) * xyzs(3,jj)
     *             + hkle(4,j), 1.0 )
         iarg = int(360.0 * arg + 0.5) + 1
         if (iarg == 361) iarg = 1
*        if (iarg < 0 .or. iarg > 360) then
*            iii = 0
*        endif
         att = att + cost(iarg)
         btt = btt + sint(iarg)
         if (iref >= 2) then
             do k=1, 3
                hkltf = hkle(k,j) * tfocp
                apdSir(k,jj) = apdSir(k,jj) - hkltf * sint(iarg)
                if (icent == 0) then
                    bpdSir(k,jj) = bpdSir(k,jj) + hkltf * cost(iarg)
                endif
             enddo
         endif
      enddo
*     if (icent == 0) then
*         contc = att
*         conts = btt
*     else
*         contc = 2.0 * att
*         conts = 0.0
*     endif
      contc = UnoPiuIcent  * att
      conts = UnoMenoIcent * btt
!
      return
      end
!-----------------------------------------------------------------------
      function ifBreakFun()
      USE General
      USE Molcom
!
      if (kscreen.eq.0) then
          ifBreakFun = 0
          return
      endif
      ifBreakFun = ifBrekke
!     if (ifBreakFun == 1) then
!         write(0,*) 'Fortran break'
!     endif
*gl*  ifBrekke = 0
!
      return
      end
!-----------------------------------------------------------------------
      subroutine CheckModelToLoad(ier)
!
!-- check if a model has to be loaded
!
      USE General
      USE TestModel
      USE RemoModule
      USE Atomi
!
      implicit none
      integer kpath, import, Lung, kQualeFormato, iAction
      integer ier, iex, ifLH
      real distDef
!
      WhichModel = 1
      numbModels = 1
      call AllocaAtomi(1)
      BondsInModel(:) = MaxBonds
      call AllocaBonds(1)
!
      kpath = Lung(FraFilePath)
      if (kpath > 1) then
          import = kQualeFormato(FraFilePath)
          if (import.eq.1) then
              iAction = 22
          elseif (import.eq.2) then
              iAction = 23
          elseif (import.eq.4) then
              iAction = 24
          else
              iAction = 20
          endif
          distDef = distCoord
          ifLH = ifLoadHydrogen
          call Carica(FraFilePath, ' ',iAction, ier, distDef, ifLH)
      endif
      if (ier < 0) then
          write(Msg,'("Cannot load ",a," file")') FraFilePath(1:kpath)
          call MsgWinErr('Open file error', Msg, ERR_WINDOW, iex)
          return
      endif
!
      call AllocaBonds(99)
      call AllocaAtomi(2)
      call AllocaModelRemo(2)
      InfoOK( 5) = 0
      InfoOK(15) = 0
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Carica(filnam, dirnam, iAction, ier, cdist, cifHyd)
      USE General
      USE Riflessi
      USE Dialogo, only: ModelToCompare
      USE Atomi
      USE TestModel
      USE RemoModule
      USE Molcom
      USE Groups
!
      implicit none
!
      common/ylimi/nfl,lfl,nlx,idumy(4)
!      
      integer :: nfl, lfl, nlx, idumy
      integer ier, iAction, iAct, cifHyd
      integer ierr, jopen, itype, iform, ios, iex, Lung, L
      integer i, interp, key(10), iactn, khead, iser, kspecb
      integer mode, ifBreak, iCoeff, iref, ksubr, idiv, ifRefl
      integer lista, lsn, lixx, ljxx, lkxx, llxx
      integer ifAll, ifHOH, ifHET, ifBack, inMemoryOnly, nc
      integer jscreenSav, kact, j, k, oldNucl, li05, ii
      real nwTmp(18)
      real xo(11), xn(11), sumE, sumWt, occ, scalan, cdist
      character*(*) filnam, dirnam
      character*256 inpFile
      character*4 str, tipoA, a4
!
!     iAction = 20 --> sir fragment
!             = 21 --> caos fragment
!             = 22 --> shelx file
!             = 23 --> PDB file
!             = 24 --> CIF file
!             = 25 --> z-matrix fragment
!             = 26 --> z-matrix fragment (ACD)
!             = 27 --> z-matrix fragment (DASH)
!
      nNucleiTarget = 0
      oldNucl = -999
      distCoord = cdist
      ModelToCompare = 0
      L = Lung(dirnam)
      if (L > 0) then
          inpFile = dirnam(1:L) // filnam(1:Lung(filnam))
      else
          inpFile = filnam(1:Lung(filnam))
      endif
      L = Lung(inpFile)
      itype = 2
      iform = 1
      ierr =  jopen(jhost, inpFile, itype, iform, ios)
      if (ierr < 0) then
          write(Msg,'("Cannot load ",a," file")') inpFile(1:L)
          call MsgWinErr('Open file error', Msg, ERR_WINDOW, iex)
          ier = -1
          return
      endif

      if (nats > 0) then
          li05 = 1
          interp = 1
          call PutGetXyzs(1, interp)
          call SaveRestoreXyzs(1)
      else
          li05 = 0
      endif
!
      nalfSav(:) = nalf(:)
      nkSav      = nk
!
      call AllocaTestModel(1)
!
      inMemoryOnly = 1
      select case (iAction)
          case (20)
              call getplt(1, inMemoryOnly, ier)
          case (22)
              ifRefl = 0
              call ManageShelxSir(ifRefl, inMemoryOnly, nwTmp, ier)
              BondsInModel(WhichModel) = 0
              call GetModel
              nz(:) = nz(:) / nzConst
          case (23)
              if (cifHyd == 0) then
                  ifHOH = 0
              else
                  ifHOH = 1
              endif
              ifAll = 0
              ifHET = 1
              ifBack = 0
              call ManagePDBSir(ifAll, ifHOH, ifHET, ifBack,
     *                       inMemoryOnly, ier)
              BondsInModel(WhichModel) = 0
              call GetModel
              nz(:) = nz(:) / nzConst
              do i=1, nats
                 a4 = Species(nz(i))
                 ii = 0
                 do j=1, 18
                    if (vSpecie(j)(1:1) == ' ') exit
                    if (a4 == vSpecie(j)) then
                        ii = j
                        exit
                    endif
                 enddo
                 if (ii /= 0) then
                     nz(i) = ii
                 endif
              enddo
          case (24)
              vSpecie(1:18) = Species(1:18)
              ifRefl = 0
              call LeggiCIF(ifRefl, inMemoryOnly, ier)
              BondsInModel(WhichModel) = 0
              call GetModel
              nz(:) = nz(:) / nzConst
      end select
!
      call GetFromAtmStruct
      nk = nkSav     !       PEZZA Gianluca 11/07/2013
!
      do i=1, nk
         call lcase(Species(i))
      enddo
      if (ier < 0) then
          write(Msg,10) inpFile(1:L),char(10)
          call MsgWinErr('Read error', Msg, ERR_WINDOW, iex)
      else
!
!-- reject hydrogen and compress the arrays
!
          if (cifHyd == 0) then
              j = 0
              do i=1, nats
                 itype = nz(i)
                 str = Species(itype)
                 if (str(1:2) == 'h ') cycle
                 j = j + 1
                 nz(j) = nz(i)
                 xyzs(1:5,j) = xyzs(1:5,i)
                 aLab(j) = aLab(i)
                 bfac(j) = bfac(i)
              enddo
              nats = j
          endif
!
          nCoordPub = nats
          j = nzConst
          nz(1:nCoordPub) = nz(1:nCoordPub) * nzConst
          kblock(:) = 1
          iconn(:) = 0
          jscreenSav = jscreen
          jscreen    = 1
          kact = 5
          call build(kact, 2)
          nz(1:nCoordPub) = nz(1:nCoordPub) / nzConst
          kblock(:) = 0
          nLegPub = iconn(1)
          j = 1
          k = 0
          do i=1, nLegPub
             itype = nz(iconn(j+1))
             str = Species(itype)
             if (str(1:2) == 'h ') then
                 if (str == Species( nz(iconn(j+2)) )) cycle
             else
                 k = k + 1
                 LEPub(1,k) = iconn(j+1)
                 LEPub(2,k) = iconn(j+2)
             endif
             j = j + 3
          enddo
          nLegPub = k
          jscreen    = jscreenSav
          ModelToCompare = 1
          call AllocaTestStuff(1)
          iactn = 1
          khead = 0
          call xspinb
          nc = 0
          nCaPub = 0
          do i=1, nCoordPub
             xo(1:3) = xyzs(1:3,i)
             itype = nz(i)
             str = Species(itype)
             if (str(1:2) == 'h ' .and. cifHyd == 0) cycle
             iser = i
             iex = kspecb(newvet,xo,xn,key,itype,iser,khead,iactn)
             occ = 1.0/float(key(10))
             xyzs(5,i) = occ
             nc = nc + 1
             aLabPub(nc) = aLab(i)
*            write(6,*) nc, aLabPub(nc)
             nzPub(nc) = nz(i)
             coordPub(1:3, nc) = xyzs(1:3, i)
             coordPub(4, nc) = bfac(i)
             coordPub(5, nc) = occ
             call MoltMatVec(rm, xo, xn)
             xyzPub(1:3, nc) = xn(1:3)
             k = index(aLabPub(nc),'_')
             if (k > 0) then
                 tipoA = aLabPub(nc)(1:k-1)
                 call ucase(tipoA)
                 if (nResidStored > 0) then
                     if (tipoA == 'CA  ') then
                         nCaPub = nCaPub + 1
                         tipoPub(nc) = 3
                     elseif (tipoA == 'C   ' .or.
     *                       tipoA == 'N   ' .or.
     *                       tipoA == 'CB  ') then
                         tipoPub(nc) = 2
                     else
                         tipoPub(nc) = 1
                     endif
                 else
*                    write(6,*) tipoA
                     if (tipoA(1:2) == 'P/') then
                         tipoA(2:4) = '   '
                     endif
                     if (tipoA == 'P   ') then
                         if (model(WhichModel)%alternate(i,1) == ' '
     *                  .or. model(WhichModel)%alternate(i,1) == 'A')
     *                   then
                             nCaPub = nCaPub + 1
                         endif
                         tipoPub(nc) = 3
                     elseif (tipoA == 'C   ' .or.
     *                       tipoA == 'N   ' .or.
     *                       tipoA == 'CB  ') then
                         tipoPub(nc) = 2
                     else
                         tipoPub(nc) = 1
                     endif
                     if (model(WhichModel)%numResiduo(i,1)
     *                   /= oldNucl) then
                         oldNucl = model(WhichModel)%numResiduo(i,1)
                         if (model(WhichModel)%heta(i,1) == 0) then
                             nNucleiTarget = nNucleiTarget + 1
                         endif
                     else
                         if (model(WhichModel)%heta(i,1) == 1 .and.
     *                       tipoA == "O5'") then
                                 nNucleiTarget = nNucleiTarget + 1
                         endif
                     endif
                 endif
             else
                 tipoPub(nc) = 1
             endif
             tipoPub(nc) = tipoPub(nc) * 100 + nomeResiduo(nc)
          enddo
          nCoordPub = nc
!
!-- save model on disk
!
          iAct = 1   ! save
          call Save_Restore_Modello_Publ(iAct)
!
          if (knw == 0 .and. ModelToCompare > 0 .and. nrefl > 0) then
              if (.not. allocated(khl)) then
                  call AllocaRiflessi(1)
              endif
              sumE = sum(evet(1:nrefl))
              if (sumE < 0.001) then
                  if (QualePgm == SIRPGM) then
                      ksubr = 4
                      call LeggiRiflessi(ier, ksubr)
                  else
                      call LeggiRiflessiSP
                  endif
              endif
              sumWt = sum(wt(1:nrefl))
              tmpwt(1:nrefl) = wt(1:nrefl)
              iphazo(1:nrefl) = iphaz(1:nrefl)
*gl*          call ScriviFrammento
              if (sumWt < 0.01 .or. knw == 0) then
                  if (iabs(nz(1)) > 100) then
                      idiv = nzConst
                  else
                      idiv = 1
                  endif
                  nzSav(:) = nz(:)
                  nz(:) = nz(:) / idiv
                  iref = 0
                  iCoeff = 2
                  ifBreak = 0
                  mode = 0
                  call sftryyyc(iref,mode,nrefl,scalan,ifBreak,iCoeff)
                  nz(:) = nzSav(:)
              endif
              if (knw == 0) then
                  call CaricaFasiNote(iphazo, iphaz)
                  ipub(1:nrefl) = iphaz(1:nrefl)
              endif
              if (.not. sumWt < 0.01) then
                  wt(1:nrefl) = tmpwt(1:nrefl)
                  iphaz(1:nrefl) = iphazo(1:nrefl)
              endif
          endif
      endif
!
!-- restore Sir results
!
      if (li05 > 0) then
          call SaveRestoreXyzs(2)
          lista = 15
          if (allocated(selezione)) SinglePlotType(:) = selezione(:)
          call Leggi15_5(lista)
      endif

!
      return
   10 format('Cannot load ',a,'.',a,'Problems reading the file.')
      end
!-----------------------------------------------------------------------
      SUBROUTINE fit(x,y,ndata,sig,mwt,a,b,siga,sigb,chi2,q)
      INTEGER mwt,ndata
      REAL a,b,chi2,q,siga,sigb,sig(ndata),x(ndata),y(ndata)
CU    USES gammq
      INTEGER i
      REAL sigdat,ss,st2,sx,sxoss,sy,t,wt,gammq
      sx=0.
      sy=0.
      st2=0.
      b=0.
      if(mwt.ne.0) then
        ss=0.
        do 11 i=1,ndata
          wt=1./(sig(i)**2)
          ss=ss+wt
          sx=sx+x(i)*wt
          sy=sy+y(i)*wt
11      continue
      else
        do 12 i=1,ndata
          sx=sx+x(i)
          sy=sy+y(i)
12      continue
        ss=float(ndata)
      endif
      sxoss=sx/ss
      if(mwt.ne.0) then
        do 13 i=1,ndata
          t=(x(i)-sxoss)/sig(i)
          st2=st2+t*t
          b=b+t*y(i)/sig(i)
13      continue
      else
        do 14 i=1,ndata
          t=x(i)-sxoss
          st2=st2+t*t
          b=b+t*y(i)
14      continue
      endif
      b=b/st2
      a=(sy-sx*b)/ss
      siga=sqrt((1.+sx*sx/(ss*st2))/ss)
      sigb=sqrt(1./st2)
      chi2=0.
      q=1.
      if(mwt.eq.0) then
        do 15 i=1,ndata
          chi2=chi2+(y(i)-a-b*x(i))**2
15      continue
        sigdat=sqrt(chi2/(ndata-2))
        siga=siga*sigdat
        sigb=sigb*sigdat
      else
        do 16 i=1,ndata
          chi2=chi2+((y(i)-a-b*x(i))/sig(i))**2
16      continue
        if(ndata.gt.2) q=gammq(0.5*(ndata-2),0.5*chi2)
      endif
      return
      END
c--------------------------------------------------------
      FUNCTION gammq(a,x)
      REAL a,gammq,x
CU    USES gcf,gser
      REAL gammcf,gamser,gln
      if(x.lt.0..or.a.le.0.)call cpause ('bad arguments in gammq')
      if(x.lt.a+1.)then
        call gser(gamser,a,x,gln)
        gammq=1.-gamser
      else
        call gcf(gammcf,a,x,gln)
        gammq=gammcf
      endif
      return
      END
c---------------------------
      SUBROUTINE gser(gamser,a,x,gln)
      INTEGER ITMAX
      REAL a,gamser,gln,x,EPS
      PARAMETER (ITMAX=100,EPS=3.e-7)
CU    USES gammln
      INTEGER n
      REAL ap,del,sum,gammln
      gln=gammln(a)
      if(x.le.0.)then
        if(x.lt.0.)call cpause ('x < 0 in gser')
        gamser=0.
        return
      endif
      ap=a
      sum=1./a
      del=sum
      do 11 n=1,ITMAX
        ap=ap+1.
        del=del*x/ap
        sum=sum+del
        if(abs(del).lt.abs(sum)*EPS)goto 1
11    continue
      call cpause ('a too large, ITMAX too small in gser')
1     gamser=sum*exp(-x+a*alog(x)-gln)
      return
      END
c------------------------------------
      SUBROUTINE gcf(gammcf,a,x,gln)
      INTEGER ITMAX
      REAL a,gammcf,gln,x,EPS,FPMIN
      PARAMETER (ITMAX=100,EPS=3.e-7,FPMIN=1.e-30)
CU    USES gammln
      INTEGER i
      REAL an,b,c,d,del,h,gammln
      gln=gammln(a)
      b=x+1.-a
      c=1./FPMIN
      d=1./b
      h=d
      do 11 i=1,ITMAX
        an=-i*(i-a)
        b=b+2.
        d=an*d+b
        if(abs(d).lt.FPMIN)d=FPMIN
        c=b+an/c
        if(abs(c).lt.FPMIN)c=FPMIN
        d=1./d
        del=d*c
        h=h*del
        if(abs(del-1.).lt.EPS)goto 1
11    continue
      call cpause ('a too large, ITMAX too small in gcf')
1     gammcf=exp(-x+a*alog(x)-gln)*h
      return
      END
c-----------------------------------------
      FUNCTION gammln(xx)
      REAL gammln,xx
      INTEGER j
      DOUBLE PRECISION ser,stp,tmp,x,y,cof(6)
      SAVE cof,stp
      DATA cof,stp/76.18009172947146d0,-86.50532032941677d0,
     *24.01409824083091d0,-1.231739572450155d0,.1208650973866179d-2,
     *-.5395239384953d-5,2.5066282746310005d0/
      x=xx
      y=x
      tmp=x+5.5d0
      tmp=(x+0.5d0)*dlog(tmp)-tmp
      ser=1.000000000190015d0
      do 11 j=1,6
        y=y+1.d0
        ser=ser+cof(j)/y
11    continue
      gammln=tmp+dlog(stp*ser/x)
      return
      END
c---------------------------------------------------------------------
      subroutine varlinear(x,x1,x2,y,y1,y2)
c
c--faccio variare linearmente la variabile y tra y1 e y2 
c  in funzione della variabile c  x nei limiti  x1 e x2
c
      if(abs(x-x1)<0.001) then
        delta=0.0
      else
        delta=(y2-y1)/(x2-x1)
      endif
      y=delta*(x-x1)+y1
      if(y1==y2) then
        y=y1
      elseif(y1<y2) then
        if(y<y1) then
          y=y1
        elseif(y>y2) then
          y=y2
        endif
      elseif(y1>y2) then
        if(y>y1) then
          y=y1
        elseif(y<y2) then
          y=y2
        endif
      endif
c
      return
      end
c---------------------------------------------------------------------
      subroutine varexponential(x,x1,x2,y,y1,y2,pow)
c
c--faccio variare in maniera esponenziale la variabile y tra y1 e y2 
c  in funzione della variabile  x nei limiti  x1 e x2
c
c     pow=3.0  ! costante dell'esponenziale
      if(abs(x2-x1)<0.001) then
        rhox=0.0
      else
        rhox=(x-x1)/(x2-x1)
      endif
      rhoy=1.0-exp(-pow*rhox)
      y=rhoy*(y2-y1)+y1
      if(y1==y2) then
        y=y1
      elseif(y1<y2) then
        if(y<y1) then
          y=y1
        elseif(y>y2) then
          y=y2
        endif
      elseif(y1>y2) then
        if(y>y1) then
          y=y1
        elseif(y<y2) then
          y=y2
        endif
      endif
c
      return
      end

c
code for egnvl
      subroutine egnvl(v,evlr)
c-- eigenvalues calculation
      dimension v(3,3),evlr(3),vin(3,3),d(3,3)
      real*8 evli(3),evlr8(3)
      real*8 p,q,r
c--
      vin(:,:)=v(:,:)
      d(:,:)=0.0
      ndim=3
      m=3
      call matin(vin,ndim,d,m,det)
      q=0.
      p=-dble((v(1,1)+v(2,2)+v(3,3)))
      do i=1,3
         call seq(i,j,k)
         q=q+dble(v(j,j)*v(k,k)-v(j,k)*v(k,j))
      enddo
      r=-dble(det)
      call solv3(p,q,r,evlr8,evli,im)
      evlr(:)=evlr8(:)
      return
      end
c
code for egnvc
      subroutine egnvc(v,evl,a,b,c)
c-- eigenvectors calculation
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension v(3,3),vn(3,3),evl(3),vl1(3),vl2(3)
     *,vp(3),a(3),b(3),c(3)
c--
      im_c=0
      do k=1,3
         do i=1,3
            do j=1,3
               if(i == j) then
                  vn(i,i)=v(i,i)-evl(k)
               else
                  vn(i,j)=v(i,j)
               endif
            enddo
         enddo
         if(istat2.gt.2) then
            write(ncwu,1001) evl
 1001       format('evl(1:3)=',3f15.4)
            write(ncwu,1000) ((vn(j,i),j=1,3),i=1,3)
 1000       format('vn(3,3) =',3f15.4,/,2(9x,3f15.4,/))
         endif
         avn1=abs(vn(1,1))
         avn2=abs(vn(2,2))
         avn3=abs(vn(3,3))
         vnmin=amin1(avn1,avn2,avn3)
         do i=1,3
            if(abs(vn(i,i)).eq.vnmin) im=i
         enddo
         if(im.eq.im_c) then
            im=im+1
            if(im.gt.3) im=mod(im,3)
         endif
         im_c=im
         call seq(im,jm,km)
         do i=1,3
            vl1(i)=vn(jm,i)
            vl2(i)=vn(km,i)
         enddo
         call provct(vl1,vl2,vp)
         if(istat2.gt.2) then
            write(ncwu,*)'im,jm,km :',im,jm,km
            write(ncwu,'(a,3f15.4)')'vl1:',vl1
            write(ncwu,'(a,3f15.4)')'vl2:',vl2
            write(ncwu,'(a,3f15.4)')'vp :',vp
            write(ncwu,'(a)')'----'
         endif
         if(vp(3).lt.0.0) then
            do i=1,3
               vp(i)=-vp(i)
            enddo
         endif
         if(k.eq.1) then
            a(:)=vp(:)
         else if(k.eq.2) then
            b(:)=vp(:)
         else
            c(:)=vp(:)
         endif
      enddo
      return
      end

c
code for solv3
      subroutine solv3(p,q,r,evlr,evli,im)
c--x**3+p*x**2+q*x+r
c--evlr: vettore contenente la parte reale delle soluzioni
c--evli: vettore contenente la parte immaginaria delle soluzioni
c--im=0: la parte immaginaria e nulla
c--im=1: e' presente la parte immaginaria
      USE General, only: pi
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension angle(3)
      real*8 evlr(3),evli(3),y(3),x(3)
      real*8 p,q,r,r1,r2,d,cost1,cost2,a,b,ca,cb,cs,ct
c--
      zero=0.00001
      do i=1,3
      evli(i)=0.
      evlr(i)=0.
      enddo
      im=0
      r1=(3.*q-p*p)/3.
      r2=(2.*(p*p*p)-9.*p*q+27.*r)/27.
      d=(r2*r2)/4.+(r1*r1*r1)/27.
c      write(ncwu,*)'solv3a) r1,r2,d,im',r1,r2,d,im
      if(d) 50,40,30
   30 continue
c-- 1 radice reale 2 radici complesse coniugate
      d=dsqrt(d)
      cost1=-r2/2.+d
      cost2=-r2/2.-d
      if(cost1) 1,2,2
    1 cost1=dabs(cost1)
      a=cost1**0.333333
      a=-a
      go to 3
    2 a=cost1**0.333333
    3 if(cost2) 4,6,6
    4 cost2=abs(cost2)
      b=cost2**0.333333
      b=-b
      go to 7
    6 b=cost2**0.333333
    7 continue
      evlr(1)=a+b-p/3.
      evlr(2)=-(a+b)/2.-p/3.
      evlr(3)=-(a+b)/2.-p/3.
      if(dabs(evlr(1)).le.zero) evlr(1)=0.
      if(dabs(evlr(2)).le.zero) evlr(2)=0.
      if(dabs(evlr(3)).le.zero) evlr(3)=0.
      evli(1)=0.
      evli(2)=(a-b)/2.*1.732050808
      evli(3)=(a-b)/2.*1.732050808
      im=1
      if(evlr(1).lt.0) im=4
      return
   40 continue
c-- 3 radici reali di cui 2 coincidenti
      if(r2.gt.0) go to 401
      ca=(-r2/2.)**0.333333
      cb=(-r2/2.)**0.333333
      go to 402
  401 ca=(r2/2.)**0.333333
      cb=(r2/2.)**0.333333
      ca=-ca
      cb=-cb
  402 continue
      x(1)=ca+cb
      x(2)=-(ca+cb)/2.
      x(3)=-(ca+cb)/2.
      y(1)=x(1)-p/3.
      y(2)=x(2)-p/3.
      y(3)=x(3)-p/3.
      go to 100
   50 continue
c-- 3 radici reali e distinte
      cs=(-r2/2.)/dsqrt((-(r1*r1*r1))/27.)
      cs2=sngl(cs)
      if (cs2.gt.1)    cs2=1.0
      if (cs2.lt.-1.)  cs2=-1.
      teta=acos(cs2)
      angle(1)=teta/3.
      angle(2)=(teta/3.)+(2.*pi)/3.
      angle(3)=(teta/3.)+(4.*pi)/3.
      ct=2.*dsqrt(-r1/3.)
      do 55 i=1,3
      x(i)=ct*cos(angle(i))
      y(i)=x(i)-p/3.
   55 continue
  100 continue
c-- eigenvalues sorting
      evlr(1)=dmin1(y(1),y(2),y(3))
      evlr(3)=dmax1(y(1),y(2),y(3))
      evlr(2)=y(1)+y(2)+y(3)-evlr(1)-evlr(3)
      if(dabs(evlr(1)).le.zero) evlr(1)=0.
      if(dabs(evlr(2)).le.zero) evlr(2)=0.
      if(dabs(evlr(3)).le.zero) evlr(3)=0.
      if(evlr(1).lt.0) im=4
      return
      end
c
code for provct
      subroutine provct(vl1,vl2,vp)
c--vector product
      dimension vl1(3),vl2(3),vp(3)
c--
      do i=1,3
      call seq(i,j,k)
      vp(i)=vl1(j)*vl2(k)-vl1(k)*vl2(j)
      enddo
      vmod=vp(1)*vp(1)+vp(2)*vp(2)+vp(3)*vp(3)
      vmod=sqrt(vmod)
      do i=1,3
      vp(i)=vp(i)/vmod
      enddo
      return
      end
code for four_point
      subroutine four_point(dummy, righe, nats, ifSort)
!--calcola valore di rho per punti definiti in dummy(i,j), j=1, nats
!-- in input: 
!       nreflDim      num riflessi da usare via USE General
!       khl(3,kj), fcoef(kj), iphaz(kj)  (indici, coef, fase) via USE Riflessi
!       dummy(1,j) = x
!       dummy(2,j) = y
!       dummy(3,j) = z
!       dummy(5,j) = occ
!       ifSort = 1/0  sort/no sort of dummy with respect to rho
!-- in output:
!       dummy(4,j) = rho
!       rho(xyz) = 1/Vc [ F(000) 
!                + 2 SUM(h+)SUM(k)SUM(l) |F|cos[2pi(hx+ky+lz)-alpha] ]
!
      USE General
      USE Deprecato
      USE Symmetry
      USE Riflessi
!
      common/ylimi/nfl,lfl,nlx,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      integer :: righe
      dimension fxx(3),fxx2p(3),ikln(60),ill(3)
      dimension dummy(righe,nats)
c      
      dummy(4,:) = 0.0
      ifat1=(2*ihmx(3)+1)*(2*ihmx(2)+1)
      ifat2=(2*ihmx(3)+1)
      NRFourTot=0
      fmilles=1.0/360.0
!=====================================================
!--loop over the reflections
!=====================================================
      do kj=1,nreflDim
         xphase=iphaz(kj)*fmilles
!====================================================
!--loop based on  the symmetry positions
!====================================================
         do j=1,nsym
             do m=1,3
                ill(m)=0.
                do n=1,3
                   ill(m)=ill(m)+khl(n,kj)*kmat(j,n,m)
                enddo
             enddo
             indr=ill(1)*ifat1+ill(2)*ifat2+ill(3)
             if (j.ne.1) then
!--elimina i doppioni
               imen1=j-1
               do i1=1,imen1
                  if (iabs(indr).eq.iabs(ikln(i1))) indr=0
               enddo
             endif
             ikln(j)=indr
             if(indr.eq.0) cycle
             NRFourTot=NRFourTot+1
!--calculate the h.t terms
             fht=0.
             do m=1,3
                fht=fht+khl(m,kj)*tmat(j,m)
             enddo  
             xalph=xphase-fht         !  alpha-(h.t)
!==========================================                             
!--loop based on the peaks                                 
!==========================================                             
            do jy = 1 , nats
               if (dummy(5,jy).ge.0.0) then
                   a=0.0
                   do m=1,3
                      a=a+dummy(m,jy)*ill(m) 
                   enddo
                   ArgTot=(a-xalph)*twopi         !  2pi[(hx+ky+lz)-alpha]
                   dummy(4,jy)=dummy(4,jy)+fcoef(kj)*cos(ArgTot)
               endif
!--end of peaks              
            enddo   
!--end of symmetry               
         enddo 
!--end of reflections  
      enddo  
!==========================================                             
!--final calculation       
!==========================================  
      f000 = 0.0                           
      rho0 = 0.0
      if (neutro == 2) then
          ih = 1
          ik = 0
          il = 0
          cm = cell(1)
          if (cell(2) < cm) then
              ih = 0
              ik = 1
              il = 0
              cm = cell(2)
          endif
          if (cell(3) < cm) then
              ih = 0
              ik = 0
              il = 1
          endif
          rho0 = rhof(pp,ih,ik,il)
          rho0  = rho0 * rho0
*         rho0  = 0
      endif
      do j = 1,nk
*        if (neutro ==2) then
*            ff0 = zeff(j)
*        else
             ff0 = ScattFact(j, rho0)
             temp(j) = ff0
*        endif
         f000 = f000 + float(nw(j)) * ff0  !no. atomi in cella*numero atomico
      enddo
!      write(ncwu,1020) f000,volume
!1020  format('F(000) =',f10.2,/,'Volume =',f10.2)      
!      write(lo,1010)nreflDim,NRFourTot
!1010  format('Indipendent reflections:'i8,/,'Total reflections:'i8)      
      do jy = 1 , nats
         if (dummy(5,jy).ge.0.0) then
             dummy(4,jy) = 2.0 * dummy(4,jy) + f000
             dummy(4,jy) = dummy(4,jy) / volume
             if (dummy(4,jy) < 0.0) then
                 dummy(4,jy) = 0.001
             endif
         endif
      enddo
!
      if (ifSort == 1) then
          call sortf(dummy, righe, nats, 4)
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine WriteMapXYZ(GiaFatta, ifDifference)
      USE General
      USE Symmetry
      USE Riflessi
      USE Mappa
!
      implicit none
      integer    :: jop, jopen, itype, iform, ier2, i, ix, iy, iz, jpatt
      integer    :: GiaFatta, ifDifference
      real       :: scala
!

      itype = 0
      iform = 1
      jop = jopen(jrel,cardDiret,itype,iform,ier2)
      write(jrel,'(6f9.3)') cell(1:6)
      write(Inte,'(16a1)') (nSpaceG(i),i=1,16)
      call ucase(Inte)
      write(jrel,'(a)') Inte(1:16)
!
      if (GiaFatta == 0) then
          if (ifDifference == 1) then
              scala = sum(fcvet(1:nrefl)) / sum(fovet(1:nrefl))
              fcoef(1:nrefl) = scala * fovet(1:nrefl) - fcvet(1:nrefl)
          else
              fcoef(1:nrefl) = fovet(1:nrefl)
          endif
          jpatt = 0
          call MakeMap(fcoef, iphaz, nrefl, jpatt, xmap, FORTH, BACK)
      endif
!
      do iz =0, np(3)-1
         do iy =0, np(2)-1
            do ix =0, np(1)-1
               write(jrel,'(3i6,g15.5)') ix, iy, iz, xmap(ix,iy,iz)
            enddo
         enddo
      enddo
      close (jrel)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine ManagePDBSir(ifAll, ifHOH, ifHET, ifBack, inMemoryOnly,
     *                        ier)
c**Protein Data Bank program format**
!
!--        ifAll = 1  all informations in PDB file are stored in binary file
!                = 0  only atoms coordinates are stored
!--        ifHOH = 0  HOH atoms are skipped
!                = 1  HOH atoms are imported
!--        ifHET = 0  HETATM  hetero atoms are skipped
!                = 1  HETATM  hetero atoms are imported
!--       ifBack = 0  all residues atoms selected
!                = 1  only backbone atoms (i.e. N, Ca, C, O, CB)
!-- inMemoryOnly = 1  coordinates will be not written in binary file
!                = 0  coordinates will be stored in binary file
!
!
      USE General
      USE Symmetry
      USE RemoModule
      USE Atomi
      USE Groups
      USE Molcom
      USE PhaseModule
      USE elements
!
      implicit none
      integer           :: ifAll, ifHOH, ifHET, ifBack, inMemoryOnly
      integer           :: ier, numResiduo, ResiduoNegativo, nSpec, WM
      integer           :: nSecondary, i, ii, jd, jdOld, numeroResiduo
      integer           :: j, k, natsSav
      integer           :: itipo, n1, n2, i1, i2
      real              :: aniso(6), celltemp(13), xwave(2), x1(3),x2(3)
      character (len=4) :: tipoAtm, tipoResiduo, dire
      character (len=1) :: OldCat
      character (len=1) :: Alternate, Catena, Secondary
      character (len=4) :: SpeciesTmp(18)
!
      SpeciesTmp(:) = Species(:)
      xwave(1:2) = (/0.71069,1.54178/)
!
      if (InfoOK(3).eq.0) then
          nk = 0
      endif
      ifPDBcoded=1
      if (inMemoryOnly == 0 .and. ifRemo == 0 .and. 
     *    QualePgm == SIRPGM) then
          if (knw > 0) write(lo,10)
      endif
      nResTot = 0
      nChains = 1
      cChains(1) = 65
      ResiduoNegativo = 0
      nats   = 0
      call LeggiPDBinMem(ifAll, ifHOH, ifHET, ifBack, ifCutResidui,
     *                   celltemp, nats, nSpec, nSecondary, ier)
      if (ifAll == 1) then
          do i=7,13
            celltemp(i)=0.0
          enddo
c--update il puntatore per la cella
          call CreaCellInfo(celltemp)
          if (inMemoryOnly == 0 .and. ifRemo == 0) then
              if (knw > 0) write(lo,2032)
          endif
      endif
      if (InfoOK(2).eq.0) then
          call CreaSymmetryInfo(ier)
      endif
      if (nMolMR > 1) then
          do i=1,nSpec
             nSpecie(i)=nSpecie(i) * nMolMR
          enddo
      endif
      if (inMemoryOnly == 0 .and. QualePgm == SIRPGM) then
          if (ifRemo == 0) then
              if (knw > 0) then
                  write(lo,2010) nats
                  if (nAcid > 0 .and. nResidStored == 0) then
                     write(lo,2111) nResTot
                  else
                     write(lo,2011) nResTot
                  endif
                  write(lo,2012) nChains, char(cChains(1:nChains))
              endif
              if (nMolMR > 1) then
                  if (knw > 0) write(lo,2112) nMolMR
              endif
          endif
      endif
*     write(6,*) 'RESIDUI',nResTot
      nk = nSpec
      Species(1:18) = vSpecie(1:18)
      do i=1, nk
         nw(i) = nSpecie(i) * totop
      enddo
      if (InfoOK(3) == 0) then
          k = WhichProps
          call CreaAtmPropInfo(k, ier)
          vSpecie(1:18) = Species(1:18)
          if (inMemoryOnly == 0) then
              SpeciesTmp(1:18) = Species(1:18)
              k = WhichProps
              WhichProps = 0
              call GetFromAtmStruct
*             WhichProps = k
*             call GetFromAtmStruct
              vSpecie(1:18) = Species(1:18)
              Species(1:18) = SpeciesTmp(1:18)
          else
              call GetFromAtmStruct
              SpeciesTmp(1:18) = Species(1:18)
              Species(1:18) = vSpecie(1:18)
              vSpecie(1:18) = SpeciesTmp(1:18)
          endif
      else
          vSpecie(:) = SpeciesTmp(1:18)
      endif
!
      if (inMemoryOnly == 0) then
*         call GetFromAtmStruct
          if (ifRemo == 0 .and. QualePgm == SIRPGM) then
              if (knw > 0) write(lo,2013)
          endif
          do i=1, nk
             dire = vSpecie(i)
             call lcase(dire)
             call ucase(dire(1:1))
             if (ifRemo == 0 .and. QualePgm == SIRPGM) then
                 if (nw(i) > 0) then
                     if (knw > 0) write(lo,2014) dire, nw(i)
                 endif
             endif
          enddo
!
!-- allocate Atomi module and fill arrays from jgrap
!
          natsSav = nats
          call AllocaAtomi(2)
          nats = natsSav
      endif
      natsMR = nats / nMolMR
      if (ifRemo == 0) then
          if (inMemoryOnly == 0) then
              WhichModel = 1
              numbModels = 1
              call AllocaAtomi(-1)
              natsInModel(WhichModel) = MaxAtoms
              MonomerInModel(WhichModel) = 1
          else
              natsInModel(WhichModel) = natsMR
          endif
          call AllocaModelRemo(1)
      else
          natsMR = nats
          natsInModel(WhichModel) = natsMR
          call AllocaModelRemo(1)
      endif
!
      if (allocated(xyzs)) then
          if (natsMR > size(xyzs(5,:)) ) then
              call AllocaAtomi(2)
              MaxAtoms = natsMR
              call AllocaAtomi(-9)
              nats = natsMR
          endif
      endif
!
      rewind jgrap
!
          WM = WhichModel
          jdOld = -9999
          numeroResiduo = 0
          do i=1, natsMR
             read(jgrap) 
     *            model(WM)%ortho(1:3,i,1),
     *            model(WM)%atoms(4:5,i,1),
     *            model(WM)%specie(i,1),
     *            model(WM)%th_fact(i,1),
     *            model(WM)%tipoAtomo(i,1),
     *            model(WM)%Alternate(i,1),
     *            model(WM)%tipoResiduo(i,1),
     *            model(WM)%catena(i,1),
     *            model(WM)%numResiduo(i,1),
     *            model(WM)%Insertion(i,1),
     *            model(WM)%Label(i),
     *            aniso(1:6),
     *            model(WM)%HETA(i,1),
     *            model(WM)%AtSpecies(i,1)
                  model(WM)%bij(1,i,1) = aniso(1) * 0.0001*UijToBij_11
                  model(WM)%bij(4,i,1) = aniso(2) * 0.0001*UijToBij_22
                  model(WM)%bij(6,i,1) = aniso(3) * 0.0001*UijToBij_33
                  model(WM)%bij(2,i,1) = aniso(4) * 0.0001*UijToBij_12
                  model(WM)%bij(3,i,1) = aniso(5) * 0.0001*UijToBij_13
                  model(WM)%bij(5,i,1) = aniso(6) * 0.0001*UijToBij_23


             if (aniso(1) > 0.1) then
                 model(WM)%IsoAniso(i,1) = 1
             else
                 model(WM)%IsoAniso(i,1) = 2
             endif
!
             jd = model(WM)%numResiduo(i,1)
             if (ResiduoNegativo == 1) then
                 if (jdOld /= jd) then
                     jdOld = jd
                     numeroResiduo = numeroResiduo + 1
                 endif
             else
                     numeroResiduo = jd
             endif
             ii = model(WM)%specie(i,1)! / nzConst
             numeroResiduo = iabs(numeroResiduo)
             model(WM)%specie(i,1) = ii * nzConst + numeroResiduo
             do ii= 1,nSpec
                model(WM)%al(1:4,ii)     = al(1:4,ii)
                model(WM)%bs(1:4,ii)     = bs(1:4,ii)
                model(WM)%cl(ii)         = cl(ii)
                model(WM)%raggio(ii,1:2) = radii(ii,1:2)
                model(WM)%no(ii)         = no(ii)
                model(WM)%nw(ii)         = nw(ii)
                model(WM)%nalf(ii)       = nalf(ii)
             enddo
             model(WM)%nk = nk  
          enddo
          natsInModel(WhichModel) = nats
!gl!      endif
!
!mr
*     model(WhichModel)%Secondary(1:nats,1) = ' '
      model(WhichModel)%Secondary(:,1) = ' '
      if (nSecondary > 0) then
          do j=1, nSecondary
             read(jgrap) itipo, n1, i1, n2, i2
             if (iprin > 0)
     *       write(lo,*) char(itipo), char(i1), n1, char(i2), n2
             Secondary = char(itipo)
             if (char(i1) == ' ') then
                 oldCat = 'A'
             else
                 oldCat = char(i1)
             endif
             if (char(i2) == ' ') then
                 Catena = 'A'
             else
                 Catena = char(i2)
             endif
             do i=1, nats
                if (model(WhichModel)%catena(i,1) /= Catena) cycle
                if (model(WhichModel)%numResiduo(i,1) >= n1 .and.
     *              model(WhichModel)%numResiduo(i,1) <= n2) then
                    model(WhichModel)%Secondary(i,1) = Secondary
                endif
             enddo
          enddo
      endif
      if (ifProtein > 0) then
          model(WhichModel)%PDB = 1
      endif
! end mr
      close(jgrap)
!
      do i=1, nats
         x1(1:3) = model(WhichModel)%ortho(1:3,i,1)
         call MoltMatVec(rmi, x1, x2)
         model(WhichModel)%atoms(1:3,i,1) = x2(1:3)
         model(WhichModel)%saved(1:3,i,1) = x2(1:3)
         if (model(WhichModel)%tipoResiduo(i,1) == '    ') then
             model(WhichModel)%Secondary(i,1) = 'W'
         endif
      enddo
!
      model(WhichModel)%BTot(:,:) = 0
      do i=1, 3
         model(WhichModel)%BTot(i,i) = 1
      enddo
!
      if (inMemoryOnly == 0) then
          if (QualePgm == SIRPGM) then
              call SincronizzaSpecieRemo()
          else
              call SincronizzaSpecie()
          endif
      else
          call AssegnaSpecie()
      endif
!
      BondsInModel(WhichModel) = 0    ! gianluca 15/10/2010
!                                     se fragm in %phase non ha connett.
      if (QualePgm == SIRPGM) then
          model(WhichModel)%trial = numbrun
          model(WhichModel)%erre  = errem
          do i=1, nats
             j = model(WhichModel)%specie(i,1)  / nzConst
             if (j > 0) then
                 model(WhichModel)%atoms(4,i,1) = no(j)
             else
                 dire = model(WhichModel)%AtSpecies(i,1)
                 model(WhichModel)%atoms(4,i,1) =  z_from_specie(dire)
             endif
          enddo
      else
          call GetModel
      endif
!
!
      return
   10 format(/,' Importing a PDB file:')
 2010 format(/,' - ',i6,' atom(s) stored')
 2011 format(  ' - ',i6,' residues')
 2111 format(  ' - ',i6,' nucleotides')
 2012 format(  ' - ',i6,' chain(s): ',10(a,2x))
 2112 format(  ' - ',i6,' monomers considered')
 2013 format(' -  Atoms in unit cell:')
 2014 format(6x,a4,i9)
 2032 format(/,' - Stored cell parameters')
      end
!-----------------------------------------------------------------------
      subroutine AssegnaSpecieAlModello(SpeciesSav, Species)
      USE RemoModule
      USE Atomi, only : nzConst
!
      implicit none
      character (len=4) :: SpeciesSav(18), Species(18)
      character (len=72) :: SpecieAtomiche
      integer :: i, j, k, WM, lnz, resto
!
!-- verifica se ci sono, tra le specie lette (Species), delle specie in più
!-- rispetto a quelle gia' presenti (SpeciesSav)
!
      WM = WhichModel
      j = -3
      do i=1, 18
         j = j + 4
         k = j + 3
         SpecieAtomiche(j:k) = SpeciesSav(i)
         Species(i) = SpeciesSav(i)
         call ucase(Species(i))
      enddo
      do j=1, MonomerInModel(WM)
         do i=1, natsInModel(WM)
            k = index(SpecieAtomiche, model(WM)%AtSpecies(i,j)) + 3
            lnz = k / 4
            resto = mod(model(WM)%specie(i,j), nzConst)
            model(WM)%specie(i,j) = lnz * nzConst + resto
         enddo
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine AssegnaSpecie()
      USE General
      USE Properties
!
      implicit none
      integer :: i, zero, nkOld
      logical :: Add
!
      zero = 0
      nkOld = AtmProperties(zero)%nSpecies
      Add = .true.
      do i=1, nkOld
         if (vSpecie(i) == 'h   ') then
             Add = .false.
             exit
         endif
      enddo
      if (Add) then
          do i=nkOld, 1, -1
             vSpecie(i+1) = vSpecie(i)
          enddo
          vSpecie(1) = 'h   '
          nkOld = nkOld  + 1
          AtmProperties(zero)%nSpecies = nkOld
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine ManageShelxSir(ifRefl, inMemoryOnly, nwTmp, ier)
c--read file
c**shelx program format**
c
      USE General
      USE Symmetry
      USE Atomi
      USE PhaseModule
      USE RemoModule
!
      implicit none
      integer :: i, j, k, ier
      integer :: itipo, iform, jop, jopen, ierr, nzS, nbonds
      integer :: nsymTemp, lattTemp, icentTemp, inMemoryOnly
      integer :: ifRefl, n, Lung, found, kcentr(7)
      real    :: nwTmp(18)
      real    :: wave, celltemp(13), x1(3), x2(3)
      real    :: uij(6), b(6)
      character (len=4) :: SpeciesTmp(18)
!
      nwTmp(:) = 0.0
      SpeciesTmp(:) = Species(:)
      ifRefl = 0
      nats = 0
!!!   neutro = 0
      if (inMemoryOnly == 0) then
          write(lo,10)
      endif
      call LeggiShelxinMem(ifRefl, celltemp, nsymTemp, lattTemp,
     *                           icentTemp, nats, wave, ier)
*     numbModels = numbModels + 1
*     WhichModel = WhichModel + 1
*     natsInModel(WhichModel) = nats
*     MonomerInModel(WhichModel) = 1
*     call AllocaModelRemo(1)
!
      if (InfoOK(1) == 0) then
          call CreaCellInfo(celltemp)
      endif
!
      if (InfoOK(3) == 0) then
          wavel = wave
          SpeciesTmp(1:18) = Species(1:18)
          k = WhichProps
          call CreaAtmPropInfo(k, ier)
          vSpecie(1:18) = Species(1:18)
          if (inMemoryOnly == 0) then
              call GetFromAtmStruct
          endif
          vSpecie(1:18) = Species(1:18)
          Species(1:18) = SpeciesTmp(1:18)
          if (SpeciesSav(1) /= '    ') then
              vSpecie(1:18) = SpeciesSav(1:18)
          endif
      else
          vSpecie(:) = SpeciesTmp(:)
      endif
!
!??!  call SoloCaratteriAlpha(Species, 18)
!
      if (inMemoryOnly == 0) then
          WhichModel = 1
          numbModels = 1
          call AllocaAtomi(-1)
          natsInModel(WhichModel) = MaxAtoms ! nats * 1.5
          MonomerInModel(WhichModel) = 1
          call AllocaModelRemo(1)
      else
          call AllocaModelRemo(1)
      endif

!
      rewind jgrap
      do i=1, nats
         read(jgrap) nzS,
     *               model(WhichModel)%Label(i),
     *               model(WhichModel)%atoms(1:3,i,1),
     *               model(WhichModel)%atoms(5,i,1),
     *               model(WhichModel)%th_fact(i,1),
     *               uij(1:6)

         model(WhichModel)%atoms(4,i,1) = 100
         model(WhichModel)%specie(i,1) = nzS * nzConst
         b(1) = UijToBij_11 * uij(1)
         b(4) = UijToBij_22 * uij(2)
         b(6) = UijToBij_33 * uij(3)
         b(5) = UijToBij_23 * uij(4)
         b(3) = UijToBij_13 * uij(5)
         b(2) = UijToBij_12 * uij(6)
         model(WhichModel)%bij(1:6,i,1) = b(1:6)
         if (uij(1) > 0.0) then
             model(WhichModel)%th_fact(i,1) = b(1) * BijToBiso(1) +
     *                                        b(2) * BijToBiso(2) +
     *                                        b(3) * BijToBiso(3) +
     *                                        b(4) * BijToBiso(4) +
     *                                        b(5) * BijToBiso(5) +
     *                                        b(6) * BijToBiso(6)
         endif
      enddo
      natsInModel(WhichModel) = nats
!
      close(jgrap)
      close(jhost)
!
      model(WhichModel)%BTot(:,:) = 0
      model(WhichModel)%BTot(1,1) = 1
      model(WhichModel)%BTot(2,2) = 1
      model(WhichModel)%BTot(3,3) = 1
!
      call SincronizzaSpecieRemo()
      call AssegnaSerial
!
      do i=1, nats
         j = model(WhichModel)%specie(i,1)  / nzConst
         model(WhichModel)%atoms(4,i,1) = no(j)
      enddo
      if (sum(nw(1:nk)) == 0) then
          do i=1, nats
             j = model(WhichModel)%specie(i,1)  / nzConst
             nwTmp(j) = nwTmp(j) + model(WhichModel)%atoms(5,i,1)
          enddo
      endif
!
      if (inMemoryOnly == 0) then
!--           p   a   b   c   f   i   r
!-- latt   =  1   2   3   4   5   6   7   (multan)
          nsym =  nsymTemp
          icent = icentTemp
          do i=2,6
             kcentr(i) = 2
          enddo
          kcentr(1) = 1
          kcentr(6) = 4
          kcentr(7) = 3
          latt = lattTemp
          ncentr = kcentr(latt)
          nsym =  nsymTemp
          icent = icentTemp
          pts = ncentr
      endif
!
      return
!
9200  continue
   10 format(/,'Importing a Shelx file:')
      end
!-----------------------------------------------------------------------
      subroutine AssegnaSerial
      USE General , only : vetSpec
      USE Atomi , only : nzConst
      USE RemoModule
!
      implicit none
      integer :: i, lnz
!
      vetSpec(:) = 0
      do i=1, natsInModel(WhichModel)
         lnz = iabs( model(WhichModel)%specie(i,1) / nzConst )
         if (lnz > 0) then
             vetSpec(lnz) = vetSpec(lnz) + 1
             model(WhichModel)%serial(i) = vetSpec(lnz)
         endif
      enddo
!
      return
      end
!-----------------------------------------------------------------------
!corr      subroutine GetSecondary(i, c)
!corr      USE RemoModule
!corr      USE Atomi
!corr!
!corr      implicit none
!corr      integer       :: i
!corr      character (len=1)   :: c
!corr!
!corr      c = model(WhichModel)%Secondary(i, 1)
!corr!
!corr      return
!corr      end
!-----------------------------------------------------------------------
      subroutine PutGetDerivInfo(iAction)
      USE General
      USE Properties
!
!-- Manage derivates scattering factors
!
      implicit none
      integer :: iAction, i, j, ier, puntatore(18), WP, ipos, WPs
!
      WPs = WhichProps
      WP = 2
      if (iAction ==1 ) then
          nk = nkd
          do i=1, nkd
             write(Species(i),'(a4)') nalfd(i)
             nalf(i) = nalfd(i)
             nw(i) = nwd(i)
             do j=1,5
                AtmProperties(WP)%ffirst(i,j) = ffirst(i,j)
                AtmProperties(WP)%fsecon(i,j) = fsecon(i,j)
             enddo
          enddo
          AtmProperties(WP)%nkd = nkd
          AtmProperties(WP)%nwd(1:nkd) = nwd(1:nkd)
          AtmProperties(WP)%nalfd(1:nkd) = nalfd(1:nkd)
          ier = 0
          call LeggiXEN(WP, puntatore, ier)
      else
          nkd = AtmProperties(WP)%nkd
          nwd(1:nkd) = AtmProperties(WP)%nwd(1:nkd)
          natd = 0
          do i=1, nkd
             ipos = i
             nod(ipos)    = AtmProperties(WP)%z(i)
             nalfd(ipos)  = AtmProperties(WP)%nalfd(i)
             nanomv(ipos) = AtmProperties(WP)%nanomv(i)
             nod(ipos)    = AtmProperties(WP)%z(i)
             if (nod(ipos).gt.1) natd=natd+nwd(ipos)
             cld(ipos)    = AtmProperties(WP)%c(i)
             do j=1,4
                ald(j,ipos) = AtmProperties(WP)%a(j,i)
                bsd(j,ipos) = AtmProperties(WP)%b(j,i)
             enddo
             do j=1,5
                ffirst(ipos,j) = AtmProperties(WP)%ffirst(ipos,j)
                fsecon(ipos,j) = AtmProperties(WP)%fsecon(ipos,j)
             enddo
          enddo
      endif
      WhichProps = WPs
      call GetFromAtmStruct
!
      return
      end
!-----------------------------------------------------------------------
