! ----------------------------------------------------------------------
! file export2006.f   date: 13 October 2010
! ----------------------------------------------------------------------
      subroutine outCif(iAction)
      USE General
      USE Riflessi
      USE Molcom, only : iPlotType
!
      character*256 line
!
      ier = 0
      call scrper(' Output cif file                             ',0,0)
      call ClessidraOnOff(1)
      call cifwrtNEW(line,ier)
!
      if (iAction.eq.2 .and. InfoOK(6) > 0) then
          if (nrefl > 0) then
              jrelSav = jrel
              jrel = jhost
              jcod = -1
              call Dump_Reflections(jcod,jrel)
!
!-- PhD small
!
*             do i=1, nrefl
*                write(88,88) 
*    *           khl(1:3,i), fovet(i), fcvet(i), iphaz(i), wt(i)
*             enddo
*  88         format(3i4,2f10.3,i4,f8.4)
!
              jrel = jrelSav
          endif
      endif
!
      kplot = iPlotType
      ifSingle = 0
      call MolPlo(kplot, ifSingle)
      call ClessidraOnOff(2)
      call scrper('                                               ',0,0)
!
      return
      end
!-----------------------------------------------------------------------
!      
!code for cifwrtNEW
      subroutine cifwrtNEW(nomeFile,ier)
!
!-- this subroutine writes various experimental values to a file in
!-- such a form as to be consistant with submission to acta. cryst..
!-- such a file is commonly referred to as a cif file.
!
      USE General
      USE Symmetry
      USE LsqModule
      USE LsqStuff
      USE LsqStuff12
      USE LsqStuff22Abs
      USE Limits
      USE Atomi
      USE BuildStuff
      USE BuildModule
      USE CIF
      USE RiflessiNew
      USE HydroStuff
      USE RiflessiNew
      USE Molcom
      
!
      character*60 idfle,stfle
      common /cdisu/ idfle,stfle
      character*60  jscr,iscr,kscr,lscr,iasun1,iform,imsg,jasun,
     2 kkscr,llscr,psfle1
      common/xscru/ jscr,iscr,kscr,lscr,iasun1,iform,imsg,jasun,
     2 kkscr,llscr,psfle1
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xchar/id,ie,ib,icc,ia,ih,numb(10),iplus, inus,ipoint
      common /worka/ a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common /workb/ ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     .             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
!
      character*80 nomeFile, linea
      character*64 follow
      character*48 datatape
      character*32 key
      character*16 space
      character*12 ccls(7)
      character*8 ifull(3)
      character*4 label,ibchar,ixyzch(3),itrasch(24)
      character*2 iwa(2)
      character*1 num6,obnum(0:9), chtmp, apice, zero,ch(3)
      character*40 jname      
!
      dimension linea1(40)
      dimension is(2,3),ts(3)
      dimension ixyz(3),itras(24)
      dimension inam3(20),nnn3(20),fmur(20),atwn(20),na(20)
      dimension fno(20),izno(20)
      dimension rvalue(11),hl(12)
      dimension indmx(3),indmn(3)
      dimension indixc(2,3),sinthl2(2)
      dimension vet(64),vett(200)
      dimension ivet(64)
      equivalence (vet,ivet)
!      
      data jname/' '/
      data  ibchar/'    '/
      data  ixyzch/'x   ','y   ','z   '/
      data itrasch/'    ','0000','0000','1/8 ',
     2             '1/6 ','0000','1/4 ','0000',
     3             '1/3 ','3/8 ','0000','0000',
     4             '1/2 ','0000','0000','5/8 ',
     5             '2/3 ','0000','3/4 ','0000',
     6             '5/6 ','7/8 ','0000','0000'/
      data num6/'6'/
!
      data obnum /'0','1','2','3','4','5','6','7','8','9'/
      data iwa /'Mo','Cu'/,ifull/'Diagonal','Full','Block'/
!
      read(ibchar,'(a2)')iblank
      do i=1,3
         read(ixyzch(i),'(a4)') ixyz(i)
      enddo
      do i=1,24
         read(itrasch(i),'(a4)') itras(i)
      enddo
!--
      MaxAtomsBuild = MaxAtoms
      MaxAtomsH=MaxAtoms
      MaxBond3=MaxBonds*3
      call AllocaBuildStuff(1)
      call AllocaHydroStuff(1)
!
      apice=char(39)
!
      sizecry(1)=0.25
      sizecry(1)=0.35
      sizecry(1)=0.40
      noce=25
!      
      twopis=2.0*pi*pi
!
!-- confronta content e lista atomi
      call Check_Content_Atoms(ighost)
!
!------------------------------------------------------------------
      NParTot = 0      ! n22a   = 0
      nres = 0         ! n22d   = 0
!          nrif   = 0
!      rflsq  = 0
!      rwflsq = 0
!      slsq   = 0
!      shiftesd(1) = 0
!      shiftesd(2) = 0
!--check if a list 12 e 13 exist    
      LsqCF=2
      iStampa=0
      jgraf=0
      call MnqdGetAllInfo(jgraf,ierres,iStampa,0)
!
!--bisogna checkare se necessario...------------------------------
!--number of partial derivatives per parameter (1,2 or 4)
      NumDerParz=2
!--definisco dimensioni e alloco vettori per Eq. Normali      
      call MappaEqNor(ierM)
!----------------------------------------------------
!--uso ncpu nelle routine successive
      ncpu_Sav= ncpu
      ncpu=jhost
!
!--open card keyword library
      itype=2
      jform=1
      jop=jopen(nccf,ciffle,itype,jform,ierr)
      if (jop.lt.0) then
          write(Msg,270) ierr,ciffle(1:Lung(ciffle))
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          ier=-2
      endif
!
!--start loop on cif.dat
!
      do
         read(nccf,'(a)') buffer_ctrl_M
         call filtra(buffer_ctrl_M)
         read(buffer_ctrl_M,'(a32,a48)') key,datatape
         if (key(1:6).eq.'######') exit
         call shift(key,lenp)
!	 write(ncwu,'(a32,i5)') key(1:lenp),lenp
         do kkk=1,nkey
            call shift(keyw(kkk),lenw)
!	    write(ncwu,'(a32,i5)') keyw(kkk)(1:lenw),lenw
            if (lenp.eq.lenw) then
                if (key(1:lenp).eq.keyw(kkk)(1:lenw)) then

                    select case (kkk)

                    case ( 1)
!
!--_publ_section_title
!
                       write(ncpu,'(a32)') keyw(kkk)
                       write(ititle,'(15a4)')(itle(i),i=1,15)
                       call shift(ititle,lenp)
                       write(ncpu,'(2h; ,a)') ititle(1:lenp)
                       read(nccf,'(a)') buffer_ctrl_M
                       call filtra(buffer_ctrl_M)
                       read(buffer_ctrl_M,'(a32,a48)') key,datatape

                    case ( 2)
!
!--_chemical_formula_analytical
!--RS 15.07.11
!-- confronta content e lista atomi
!
!                        fno=0.
!                        nzeta=nsymTot
!                        nzetac=nzeta
!                        iwar=0
!                        k1050 = 1
!                        i1050: do while (k1050 == 1)
!                          k1050 = 0
!                          do j=1,nk
!                            n = nw(j)/nzetac
!                            if (n*nzetac.ne.nw(j)) then
!                               iwar=iwar+1
!                               if (iwar.eq.2) then
!                                  write(ncwu,*)
!     1             ' Warning! Possible error in the chemical formula...'
!                                  exit i1050
!                               endif
!                               nzetac=nzetac/2
!                               k1050 = 1
!                               exit
!                            endif
!                          enddo
!                        enddo i1050
!                        ntt = 0
!                        fmu = 0.0
!                        f000 = 0.0
!                        atwt = 0.0
!                        natm=0
!                        linea=' '
!                        ilin=1
!                        call ChemicalFormulaNEW(linea,ier)
!                        call shift(linea,lenp)
!                        call addpx1(linea,lenp)
!--write chemical_formula_sum
!                        write(ncpu,'(a32,5x,a)') key1(1),linea(1:lenp)
                        linea=' '
                        if (ifPDBcoded == 0) then
                            nfragassimunit=1
                            NatMol0=NatMol
                            NumLeg0=NumLeg
                            call FormulaMoietyNEW(maxnopfr,
     *                           nfragassimunit,linea,weight_moiety)
                            NatMol=NatMol0
                            NumLeg=NumLeg0
                            if(ier.ne.0) return
                         endif

                        lenp=0
                        call shift(linea,lenp)
                        call addpx1(linea,lenp)
!--write chemical_formula_moiety
                        write(ncpu,'(a32,5x,a)') key1(2),linea(1:lenp)
!--write chemical_formula_structural
                        write(ncpu,'(a32,16x,1h?)') key1(3)
!
!--write_chemical_formula_weight
!
!                        nzetac=nzeta
                        fmu = 0.0
                        f000 = 0.0
                        atwt = 0.0
                        ntt = 0
                        do j = 1,nk
                          jnat = no(j)              ! numero atomico
                          atw =  AtomWeight(j)      ! peso atomico
                          fmur(j) = fmuro(j)        ! mu/rho
                          f000 = f000 + jnat*nw(j)  !no. atomi in cella*numero atomico
                          atwn(j) = atw*nw(j)       !peso atomico*no. atomi in cella
!
!---peso in atomi della cella ( m * z )
!
                          atwt = atwt +atwn(j)      ! peso atomico totale in cella
                          ntt = ntt + nw(j)         ! numero atomi totale in cella
                        enddo
                        fweight=atwt
!                        fweight=atwt/nzetac
!mercedes 18mag11                        write(ncpu,'(a32,f15.2)') key1(4),fweight
                        if (ifPDBcoded == 0) then
                            write(ncpu,'(a32,f15.2)') 
     *                                   key1(4),weight_moiety
                        else
                            write(ncpu,'(a32,f15.2)') key1(4),fweight
                        endif
                        key =  blank 
                        datatape =  blank
! 
                    case ( 3)
!
!--_cell_length_a  _b  _c  _volume
!
                        devcell=0
                        do i=1,6
                          devcell=devcell+abs(errcell(i)*10000)  
                        enddo
                        idev=1
                        if(devcell.lt.0.001)idev=0
                        ndev=1
                        nfix=0
                        if (idev.eq.0) then
                           do i=1,6
                             write(ncpu,'(a32,f15.3)')key2(i),cell(i)
                           enddo
                           write(ncpu,'(a32,f14.2)')key2(7),volume
                        else
                           lenp=0
                           ndec=3
                           ndec1=3
                           do i=1,6
                             linea1(1:40)=ib
                             call snum(cell(i),errcell(i),ndec,ndec1,
     *                                   0,21,linea1,ndev,nfix)
                             jfin=lenp+40
                             if(jfin.ge.80)jfin=80
                             jjj=1
                             do jj=lenp+1,jfin
                               write(linea(jj:jj),'(a1)') linea1(jjj)
                               jjj=jjj+1
                             enddo
                             call shift(linea,lenp)
                             write(ncpu,'(a32,40a1)') key2(i),
     *                                (linea1(n),n=1,40)
                           enddo
c                           if(errcell(7).gt.0.0) then
                              ndec=2
                              ndec1=2
                              linea1(1:40)=ib
                              call snum(volume,errcell(7),ndec,ndec1,
     *                                   0,21,linea1,ndev,nfix)
                              write(ncpu,'(a32,40a1)') key2(7),
     *                                  (linea1(n),n=1,40)
c                           endif
                        endif
!
                        if (ifPDBcoded == 0) then
                            nzeta=nsymTot*nfragassimunit/maxnopfr
                        else
                            nzeta=nsymTot
                        endif
                        write(ncpu,'(a32,i12)') key2(8),nzeta      !_cell_formula_units_Z 
                        i=whichwave
                        if (neutro == 0) then
                            if (i.eq.1.or.i.eq.2) then
                                write(ncpu,'(a32,5x,a)') key2(9), 
     *                                apice//iwa(i)//'K\a'//apice      !_cell_measurement_radiation
                            endif
                        elseif (neutro == 1) then
                                write(ncpu,'(a32,5x,a)') key2(9), 
     *                                apice//'neutron'//apice      !_cell_measurement_radiation
                        elseif (neutro == 2) then
                                write(ncpu,'(a32,5x,a)') key2(9), 
     *                                apice//'electron'//apice      !_cell_measurement_radiation
                        endif
                        write(ncpu,'(a32,f15.5)') key2(10),wavel   !_cell_measurement_wavelength
!                       write(ncpu,'(a32,5x,a)') key2(9),'?' 
!                       write(ncpu,'(a32,5x,a)') key2(10),'?'
                        write(ncpu,'(a32,i15)'  ) key2(11),noce    !_cell_measurement_reflns_used
                        write(ncpu,'(a32,f15.2)') key2(12),ceth(1) !_cell_measurement_theta_min 
                        write(ncpu,'(a32,f15.2)') key2(13),ceth(2) !_cell_measurement_theta_max 
                        key =  blank 
                        datatape =  blank 

                    case ( 4)
!--_symmetry_cell_setting
!
!!                        write(ncpu,'(a,i3)') 'jsys',jsys
!!                        do ii=1,7
!!      write(ncpu,'(a,i3,12f5.2)')'ii,centrt(ii,1:12)',ii,centrt(ii,1:12)
!!                        enddo
                        write(space,'(16a1)') nSpaceG
                        call ucase(space(1:1))
!gl!                    linea=texc(isys)
                        linea=texc(jsys)
                        call shift(linea,lenp)
                        linea(lenp+1:lenp+1)=apice
                        follow=apice//linea
                        call shift(follow,lenp)
                        write(ncpu,'(a32,5x,a)') key3(1),follow(1:lenp)
                        linea=apice//space
                        call shift(linea,lenp)
                        linea(lenp+1:lenp+1)=apice
                        write(ncpu,'(a32,5x,a)') key3(2),linea(1:lenp+1)
                        n102=ipuac(nSpaceG,vett,n,ngspat)
                        if (n102.gt.0) then
                            write(ncpu,'(a32,i12)') key3(3),n102
                        else
                            write(ncpu,'(a32,5x,a)') key3(3),'?'
                        end if
!
!--print the symmetry positions given
!
                        write(ncpu,'(a)') 'loop_'
                        write(ncpu,'(a32)') key3(4)
                        write(ncpu,'(a32)') key3(5)

                        key =  blank 
                        datatape =  blank 

                        do i=1, nsymTot
                           k = Lung(SymmStrings(i))
                           linea = 
     *                     char(39) // SymmStrings(i)(1:k) // char(39)
                           write(ncpu,'(i5,3x,a,a,a)') i, linea(1:k+2)
                        enddo

                    case ( 5)
!
!--_exptl_crystal_size_max
!
                        do j=1,3
                           write(ncpu,'(a32,f15.2)') key22(j),sizecry(j)
                        enddo
                        key =  blank 
                        datatape =  blank 

                    case ( 6)
!
!--_exptl_crystal_density_diffrn
!
                        dcal = atwt/(volume*0.602)
!
!---calcolo mu (cm-1)
!
                        if (ntt.gt.0) then
                            do j=1,nk
                               fmu = fmu + (atwn(j)/atwt)*fmur(j)
                            enddo
                        endif
                        fmu = fmu * dcal * 0.1
                        write(ncpu,'(a32,f15.3)') key4(1),dcal
                        n=f000
                        write(ncpu,'(a32,i15)') key4(2),n
                        write(ncpu,'(a32,f15.3)') key4(3),fmu
                        key =  blank 
                        datatape =  blank 

                    case ( 7)
!-----------------------------------------------------------------------
!--_exptl_absorpt_correction_T_min
!
                        do j=1,2
                           write(ncpu,'(a32,f15.4)') key44(j),tmnx(j)
                        enddo
!-----------------------------------------------------------------------
                        key =  blank 
                        datatape =  blank
!                         
                    case ( 8)
!
!--_diffrn_radiation_wavelength
!
                        i=whichwave
                        write(ncpu,'(a32,f15.5)') key5(1), wavel
                        if (neutro == 0) then
                            if (i.eq.1.or.i.eq.2) then
                                write(ncpu,'(a32,5x,a)') key5(2), 
     *                                apice//iwa(i)//'K\a'//apice
                            else
                                write(ncpu,'(a32,5x,a)') key5(2), ' ?'
                            endif
                        elseif (neutro == 1) then
                            write(ncpu,'(a32,5x,a)') key5(2), 
     *                            apice//'neutron'//apice
                        elseif (neutro == 2) then
                            write(ncpu,'(a32,5x,a)') key5(2), 
     *                            apice//'electron'//apice
                        endif
!--	 write(ncpu,'(a32,5x,a)') key5(3), ' ?'
!--	 write(ncpu,'(a32,5x,a)') key5(4), ' ?'
                        key =  blank 
                        datatape =  blank 
                    case ( 9)
!------------------------------------------------------------------------
!--_diffrn_standards_number    
! 
!      write(ncpu,'(a32,i15)' ) key55(1),nstand
!      write(ncpu,'(a32,i15)' ) key55(2),ncountCIF
                        write(ncpu,'(a32,10x,a)') key55(1), ' ?'
                        write(ncpu,'(a32,10x,a)') key55(2), ' ?'
                        write(ncpu,'(a32,10x,a)') key55(3), ' ?'
                        write(ncpu,'(a32,10x,a)') key55(4), ' ?'
                        write(ncpu,'(a)') 'loop_'
                        do j=1,3
                           write(ncpu,'(a32)') key55(4+j)
                        enddo
!                       do j=1,nstand
!                       write(ncpu,'(5x,3i5)' ) (istand(n,j),n=1,3)
!                       enddo
!                       write(ncpu,'(a32,i15)' ) key55(8),ntotale
                        write(ncpu,'(5x,a)' ) ' ?   ?   ? '
                        write(ncpu,'(a32,10x,a)') key55(8) ,'  ? '
                        write(ncpu,'(a32,10x,a)') key55(9) ,'  ? '
                        write(ncpu,'(a32,10x,a)') key55(10),'  ? '
!                       write(ncpu,'(a32,f15.3)') key55(9), averr
!                       write(ncpu,'(a32,f15.3)') key55(10), uneti
!----------------------------------------------------------------------------
                        key =  blank 
                        datatape =  blank 
!
                    case (10)
!
!--_diffrn_reflns_reduction_process
!
                        if (InfoOK(6) > 0) then
                            write(ncpu,'(a32,5x,a)') key6(1), ' ?'
                            if (DataMinLim%Th2.gt.0.0) then
                                a= DataMinLim%Th2/2.0
                                write(ncpu,'(a32,f15.2)') key6(2), a
                                a= DataMaxLim%Th2/2.0
                                write(ncpu,'(a32,f15.2)') key6(3), a
                                write(ncpu,'(a,7x,f15.2)')
     *                                '_diffrn_reflns_theta_full',a
                            else
                                write(ncpu,'(a32,5x,a)') key6(2), ' ?'
                                write(ncpu,'(a32,5x,a)') key6(3), ' ?'
                            endif
!
!-- PEZZA GIANLUCA 25/05/2010
!
                                do j=1,3
                                   indixc(2,j)=DataMaxLim%HKL(j)
                                   indixc(1,j)=DataMinLim%HKL(j)
                                enddo
                                sinthl2(1)=DataMinLim%Rho
                                sinthl2(2)=DataMaxLim%Rho
                            endif
!
                            icompl=0
!--	call xnur(icompl,indixc,sinthl2,jnumb,ireftotx)
!--	a=float(n6)/jnumb
!--	write(ncpu,'(a,f15.3)')'_diffrn_measured_fraction_theta_max '
!--	1 ,a
!--	write(ncpu,'(a,f15.3)')'_diffrn_measured_fraction_theta_full'
!--	1 ,a
                            write(ncpu,'(a)')
     *                      '_diffrn_measured_fraction_theta_max      ?'
                            write(ncpu,'(a)')
     *                      '_diffrn_measured_fraction_theta_full     ?'
                            i=4
                            do j=1,3
                               write(ncpu,'(a32,i15)') key6(i), 
     *                               indixc(2,j)
                               write(ncpu,'(a32,i15)') key6(i+1),
     *                                indixc(1,j)
                               i=i+2
                            enddo
                            write(ncpu,'(a)') 'loop_'
                            i=10
                            do j=1,6
                               write(ncpu,'(a32)') key6(i)
                               i=i+1
                            enddo
                        if (neutro == 2) then
                            keyx(2) = 
     * 'P.Doyle & P.Turner Acta Cryst. (1968).A24,390-397'
                        endif
                        do j = 1,nk
                           label = Species(j)
                           call lcase(label)
                           call ucase(label(1:1))
                           n = nw(j)
                           follow = keyx(2)
                           call shift(follow,lenp)
                           follow(lenp+1:lenp+1) = apice
                            write(ncpu,2610) label,n,nomeat(j),
     *                           fprimo(j),fsecondo(j),
     *                           follow(1:lenp+1)
                        enddo
 2610 format(1x,"'",a4,"'",i5,1x,"'",a12,"'",2f8.4," ' ",a) 
                        key =  blank 
                        datatape =  blank 

                    case (11)
!
!--_reflns_number_total
!
                        if (InfoOK(6) > 0) then
                            write(ncpu,'(a32,i15)') key7(1), nrefltot
                            nrif1=nonoss 
                            nrif2=nescl   
                            nrif=nrefltot-nrif1-nrif2
                            write(ncpu,'(a32,i15)') key7(2), nrif
                            obf=abs(cutoff)
                            if (obf.gt.0.0) then
!--                         if(ifo2.eq.1) then
                                follow=apice//' F >'//obnum(int(obf))//
     *                          '.'//obnum(int(10.0*(obf-int(obf))))//
     *                          ' \s(F) '//apice
!--	                    else
!--	                    follow=apice//' F^2 >'//obnum(int(obf))//'.'
!--	1	          //obnum(int(10.0*(obf-int(obf))))//' \s(F^2) '//apice
!--                       endif
                                call shift(follow,lenp)
                                write(ncpu,'(a32,5x,a)') key7(3),
     *                                follow(1:lenp)
                            else
                                write(ncpu,'(a32,5x,a)') key7(3), 
     *                                apice//'none'//apice
                            endif
!
!--obtain the indices min and max observed
!
                            sintmn= 9999
                            sintmx=-9999
                            do i=1,3
                               indmn(i)= 9999
                               indmx(i)=-9999
                            enddo
!
!--start of the reflection fetching loop
!
                                do i=1, nrefl
                                   ivet(1:3) = refl%hkl(1:3,i)
                                   do k=1,3
                                      if (indmn(k).gt.ivet(k)) then
                                          indmn(k)=ivet(k)
                                      endif
                                      if (indmx(k).lt.ivet(k)) then
                                          indmx(k)=ivet(k)
                                      endif
                                   enddo
                                   a = refl%rho(i)
                                   sintmn=amin1(sintmn,a)
                                   sintmx=amax1(sintmx,a)
                                enddo
!
!--end of the reflection loop
!
                            i=4
                            do j=1,3
                               write(ncpu,'(a32,i15)') key7(i  ),
     *                               indmx(j)
                               write(ncpu,'(a32,i15)') key7(i+1),
     *                               indmn(j)
                               i=i+2
                            enddo
                            resol=1.0/(2.0*sqrt(sintmx))
                            write(ncpu,'(a32,f15.3)') key7(10), resol
                            resol=1.0/(2.0*sqrt(sintmn))
                            write(ncpu,'(a32,f15.3)') key7(11), resol
                            follow='F'
                            call shift(follow,lenp)
                            write(ncpu,'(a32,5x,a)') key7(12),
     *                            follow(1:lenp)
                        endif
                        key =  blank 
                        datatape =  blank 

                    case (12)

!
!--_refine_ls_matrix_type
!
                        if (InfoOK(6) > 0) then
                            if (NumCond12 > 0) then
                                i = idir12(1)
                                linea=ifull(i)
                                call shift(linea,lenp)
                                linea(lenp+1:lenp+1)=apice
                                follow=apice//linea
                                call shift(follow,lenp)
                                write(ncpu,'(a32,5x,a)') key8(1),
     *                                follow(1:lenp)
                                follow=' ? '
                                do j=1,NumCond12
                                    i = idir12(j)
                                    if (i.eq.8) then
                                       follow=keyx(1)
                                       linea=follow
                                       call shift(linea,lenp)
                                       linea(lenp+1:lenp+1)=apice
                                       follow=apice//linea
                                   endif
                                enddo
                                call shift(follow,lenp)
                                write(ncpu,'(a32,5x,a)') key8(2),
     *                                follow(1:lenp)
                                follow=keyx(4)
                                if (nWeight.eq.5) follow=keyx(3)
                                linea=follow
                                call shift(linea,lenp)
                                linea(lenp+1:lenp+1)=apice
                                follow=apice//linea
                                call shift(follow,lenp)
                                write(ncpu,'(a32,5x,a)') key8(3),
     *                                    follow(1:lenp)
!-------------------------------------------------------------------------
!--routine da correggere!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!     
                                if(nWeight.ge.1.and. nWeight.le.18) then
                                   call wrtpesiNEW(follow)
                                   call shift(follow,lenp)
                                   write(ncpu,'(a32)') key8(4)
                                   write(ncpu,'(1h;,5x,a,/,1h;)') 
     *                                follow(1:lenp)
                                endif
                                nrif1=nonoss 
                                nrif2=nescl   
                                nrif=nrefltot-nrif1-nrif2
                            endif
                            write(ncpu,'(a32,i15)') key8(5), nrif
                            write(ncpu,'(a32,i15)') key8(6), NParTot
                            write(ncpu,'(a32,i15)') key8(7), nres
                            write(ncpu,'(a32,i15)') key8(8), NumGroup
                            rvalue(1)= rflsq/100.0
                            rvalue(2)= rflsq/100.0
                            rvalue(3)= rwflsq/100.0
                            rvalue(4)= rwflsq/100.0
                            rvalue(5)= slsq
                            rvalue(6)= slsq
                            rvalue(7)= shiftesd(1)
                            rvalue(8)= shiftesd(2)
                            rvalue(9)=rhodiff(1)
                            rvalue(10)=rhodiff(2) 
                            rvalue(11)=rhodiff(3)  
!                            rvalue(9)= 0.0
!                           rvalue(10)=0.0
!                           rvalue(11)=0.0
                            j=9
                            do i=1,11
                               if (abs(rvalue(i)).gt.0.0) then
                                   write(ncpu,'(a32,f15.3)') key8(j),
     *                                   rvalue(i)
                               else
                                   write(ncpu,'(a32,5x,a)') key8(j),' ?'
                               endif
                               j=j+1
                            enddo
                        endif
!
!-- lista degli atomi
!
                        jcod=1
                        call CaosPubl5NEW(jcod,ier)


                        if (ifPDBcoded == 0)then
                            write(ncpu,'(a)') '  ',
     1    '# GEOMETRY ###############################################'
 !    
!-- open file for geometric calculations results
                           ier = 0
                           itype=1
                           ifform=1
                           jop = jopen(nctu,jname,itype,ifform,ier)
                           if (jop >= 0) then
                               jcif=1
                               icod=0
                               call SupMatGeomNEW
                               close(nctu)
                           endif
                        endif
c--vecchia chiamata--------------------------------------------------     
c                        idev=1
c                        jcod=1
c                        jhost1=0
c                        jscre=0
c                        call CaosGeomNEW(jscre,jhost1,ier,jcod)
c                        jcod=2
c                        call CaosGeomNEW(jscre,jhost1,ier,jcod)
!                       jcod=3
!                    	call CaosGeomNEW(jscre,jhost1,ier,jcod)
!----------------------------------------------------------------------
                        key =  blank 
                        datatape =  blank 

                    case ( 13)
!
!--_computing_structure_solution
!
                        write(ncpu,'(a32)') keyw(kkk)
                        if (QualePGM.eq.1) then
                            key = 'SIR2014 (Burla et al., 2015)'
                        else if (QualePGM.eq.2) then
                            key = 'SIR2014 (Burla et al., 2015)'
                        else if (QualePGM.eq.3) then
                            key = 'EXPO2004 (Altomare et al., 2004)'
                        endif
!
                        call shift(key,lenp)
                        write(ncpu,'(2h; ,a,/,2h; )') key(1:lenp)
                        do i=1,3
                          write(ncpu,'(a32)') key13(i)
                          write(ncpu,'(2h; ,a,/,2h; )') key(1:lenp)
                        enddo  
                        key =  blank 
                        datatape =  blank 

                    end select

!
!--end of first if
!
                endif
            endif
         enddo
         llenp = min0(lenp, 32)
         linea=key(1:llenp)//datatape
         call shift(linea,lenp)
         if(lenp.le.0) lenp=1
         write(ncpu,'(a)') linea(1:lenp)
      enddo
!
      close(nccf,status='keep')
!      
      call AllocaBuildStuff(2)
      call AllocaHydroStuff(2)
!      
      ncpu = ncpu_Sav
      return
!
  270 format(' Open error, code =',i5,' file is ',a)
  271 format(' List of atoms not present')
 1062 format(' Warning! Cell content differents from the list',
     1       ' of atoms for ',a4)
 2150 format(20a4)
 
!
!--error message
!
9000  continue
!
      return
      end
!-----------------------------------------------------------------------
!      
!code for Check_Content_Atoms
      subroutine Check_Content_Atoms(ighost)
!-- confronta content e lista atomi
!
      USE General
      USE Symmetry
      USE Atomi
!
      integer :: ifCellContentDifferent
      dimension fno(18),izno(18)
!
      return
!
      ifCellContentDifferent=0
      ighost=0     !(ighost=1 ci sono i ghost quindi non ancora lsq!!) 
      fno=0.
      nzeta=nsymTot
      nzetac=nzeta
      iwar=0
      k1050 = 1
      i1050: do while (k1050 == 1)
                k1050 = 0
                do j=1,nk
                   n = nw(j)/nzetac
                   if (n*nzetac.ne.nw(j)) then
                      iwar=iwar+1
                      if (iwar.eq.2) then
!--va controllato il 'controllo'...................RS 15.07.11                      
!                         write(lo,*)
!     1             ' Warning! Possible error in the chemical formula...'
                         exit i1050
                      endif
                      nzetac=nzetac/2
                      k1050 = 1
                      exit
                   endif
                enddo
             enddo i1050
      do i=1,nats
         li=nztot(i)
         if(li.eq.0) then  ! (ignora i ghost)
            ighost=1
            cycle                      
         endif  
         fno(li)=fno(li)+xyzs(5,i)
      enddo
      nchMsg = 1
      cardImage = ' '
      do i = 1,nk
         fn =float( nw(i))/nzeta
         if (abs(fno(i)-fn).gt.0.0001) then
             fnoT = fno(i) * nsymTot
             write(cardImage(nchMsg:),10) species(i), nw(i),
     *                                     nint(fnoT), char(10)
             ifCellContentDifferent = 1
             nchMsg = Lung(cardImage) + 1
         endif
      enddo
      if (ifCellContentDifferent == 1) then
          Buffer1 = 
     *    'Declared cell content is different from the list of atoms' //
     *    char(10) // ' ' // char(10) //  'Species  Declared   Actual'
     *    // char(10) // cardImage(1:Lung(cardImage)) //
     *    char(10) // ' ' // char(10) //  
     *    'Do you want to update the unit cell content?'
*         call MsgWinErr('Warning', Msg, WARN_WINDOW, nExitCode)
          call MsgWinErr(' ', Buffer1, QUEST_WINDOW_YES_NO, nExitCode)
      else
          nExitCode = 0
      endif
!
      if (nExitCode == 1) then   ! modifica il cell content
          izno(:) = 0
          izno(1:nk) = nint(fno(1:nk) * nsymTot)
          call UpdateCellContent(izno)
          do i=1, nk
             if (izno(i) /= nw(i)) then
                 exit
             endif
             ifCellContentDifferent = 0
          enddo
      endif
!
      return
   10 format(3x,a,5x,i10,5x,i10,a)
      end
!      
!code for wrtpesiNEW
      subroutine wrtpesiNEW(nome)
!
!--this subroutine writes weighting schemes
!
      USE LsqModule
!
      common /xunit/ ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xchar/id,ie,ib,icc,ia,ih,numb(10),iplus, inus,ipoint
!
      dimension nvalue(10),izer(9)
      character*(*) nome
      character*10 value(10)
      character*80 follow
      character*1 obnum(0:9), chtmp
      character *77 Pesi(18),pesic
      character*1 blank,point,Pchar
      character*4 izerch(9)
!
      data izerch/'P(1)','P(2)','P(3)','P(4)',
     2            'P(5)','P(6)','P(7)','P(8)','P(9)'/
c--
      data blank/' '/,point/'.'/,Pchar/'P'/
      data obnum /'0','1','2','3','4','5','6','7','8','9'/
!
      do i=1,9
         read(izerch(i),'(a4)') izer(i)
      enddo
!
      Pesi(1) = 'w=F/P(1);if_F<=P(1);w=P(1)/F;if_F>P(1)'
      Pesi(2) = 'w=1/(P(1)+P(2)*F+P(3)*F^2^)'
      Pesi(3) = 'w=(Sin\q/\l)^P(1)^'
      Pesi(4) = 'w=(\l/Sin\q)^P(1)^'
      Pesi(5) = 'w=1/\s^2^(F)'
      Pesi(6) = 'w=1.0'
      Pesi(7) = 'w=1/(1.+((F-P(2))/P(1))^2^)'
      Pesi(8) = 'w=1.0;if_F<=P(1);w=P(1)/F;if_F>P(1)'
      Pesi(9) = 'w=\s(F)'
      Pesi(10)= 'w=1.0/\s(F)'
      Pesi(11)= 'w=(Sin\q/\l)^P(4)^/(P(1)+P(2)*F+P(3)*F^2^)'
      Pesi(12)= 'w=1/(P(1)*\s(F))^2^+P(2)*F+P(3)*F^2^)'
      Pesi(13)= 'w=1/(P(1)+P(2)*F+P(3)*F^2^+P(4)*(Sin\q/\l))'
      Pesi(14)= 'w=1/(P(1)+P(2)*F+P(3)*F^2^)'
      Pesi(15)= 'w=1/(P(1)+P(2)*(Sin\q/\l)+P(3)*(Sin\q/\l)^2^)'
      Pesi(16)= 'w=1/(SUM(aj*Tj(F))j=1,n'
      Pesi(17)= 'w=(Sin\q/\l)^P(3)^/(P(1)*\s(F))^2^+P(2)*F^2^)'
      Pesi(18)= 'w=1/((P(1)+P(2)*F+P(3)*F^2^+P(4)*(Sin\q/\l)'//
     1          '^P(5)^)*\s(F))^2^)'
!--		12345678901234567890123456789012345678901234567890
!
      pesic=Pesi(nWeight)
      nome=pesic
      j=index(pesic,Pchar)
!--	write(ncwu,'(i4,3h $ ,a)')j,pesic
      if (j.gt.0) then
          do i=1,nPar
             follow=' '
             write(follow,'(f10.4)')WPar(i) 
             call shift(follow,lenp)
             iflag=0
             do j=1,lenp
                j1=lenp-j+1
                if (iflag.eq.0) then
                    if (follow(j1:j1).eq.obnum(0)) then
                        follow(j1:j1)=blank
                    else
                        iflag=1
                    endif
                endif
             enddo
             call shift(follow,lenp)
             value(i)=follow
             nvalue(i)=lenp
          enddo
          do i=1,10
             j=index(pesic,Pchar)
!--	     write(ncwu,'(i4,3h $ ,a)')j,pesic
             if (j.gt.0) then
                 follow=pesic(j:j+3)
                 read(follow,'(a4)')ipp
!--	write(ncwu,'(1x,a,2h$ ,a4)')follow(1:4),ipp
                 do n=1,9
                    ival=n
                    if (ipp.eq.izer(n)) exit
                 enddo
!--	write(ncwu,'(i10)')ival
                 pesic(j:j+3)='    '
                 call skpblk(pesic,lenp)
                 do l=1,j-1
                    follow(l:l)=pesic(l:l)
                 enddo
                 l1=j
!--	write(ncwu,*)'ival,nvalue(ival)',ival,nvalue(ival)
                 do l=1,nvalue(ival)
                    follow(l1:l1)=value(ival)(l:l)
                    l1=l1+1
                 enddo
                 do l=j,lenp
                    follow(l1:l1)=pesic(l:l)
                    l1=l1+1
                 enddo
                 pesic=follow
!--	write(ncwu,'(1x,a,a)')'pesic: ',pesic
             else
                 exit
             endif
          enddo
!
          nome=pesic
      endif
!--	write(ncwu,'(1x,a)')nome
!
      return
      end
!-----------------------------------------------------------------------
!code for addpx
      subroutine addpx(string,lenp)
!
!--strip away blank character(s) and add apice
!
      common /xunit/ ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      character string*(*)
      character*1 blank,apice
      character*80 string1
!
      blank = ' '
      apice = char(39)
      call skpblk(string,lenp)
      j=1
      string1=' '
      string1(1:1)=apice
      j=j+1
      do i=1,lenp
         string1(j:j)=string(i:i)
         j=j+1
      enddo
      string=string1
      call shift(string,lenp)
      string(lenp+1:lenp+1)=apice
      lenp=lenp+1
!
      return
      end
!-----------------------------------------------------------------------
!code for addpx1
      subroutine addpx1(string,lenp)
!
!--add apice
!
      common /xunit/ ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      character string*(*)
      character*1 blank,apice
      character*80 string1
!
      blank = ' '
      apice = char(39)
      j=1
      string1=' '
      string1(1:1)=apice
      j=j+1
      do i=1,lenp
         string1(j:j)=string(i:i)
         j=j+1
      enddo
      string=string1
      call shift(string,lenp)
      string(lenp+1:lenp+1)=apice
      lenp=lenp+1
!
      return
      end
!-----------------------------------------------------------------------
!code for skpblk
      subroutine skpblk(string,lenp)
!
!--strip away blank character(s)
!
      common /xunit/ ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      character string*(*)
      character*1 blank
      character*60 string1
!
      blank = ' '
      k=len(string)
!
!-- TAB filter
!
      do i=1,k
         j = ichar(string(i:i))
         if (j.eq.9) string(i:i)=blank
      enddo
      ifin=1
      do i=1,k
         if (string(i:i).ne.blank) then
             iniz=i
             go to 20
         endif
      enddo
      string=' '
      return
   20 do i=k,1,-1
         if (string(i:i).ne.blank) then
             ifin=i
             go to 40
         endif
      enddo
   40 continue
      lenp=ifin-iniz+1
      if (iniz.gt.1) then
          do i=1,lenp
             j=iniz+i-1
             string(i:i)=string(j:j)
          enddo
      endif
      j=1
      string1=' '
      do i=1,lenp
         if (string(i:i).ne.blank) then
             string1(j:j)=string(i:i)
             j=j+1
         endif
      enddo
      string=string1
!
      return
      end
!-----------------------------------------------------------------------
c
code for Dump_Reflections
      subroutine Dump_Reflections(in,ncpu)
c--dump list 6 , reflections
c
c in = -1 CIF
c    =	0 format caos 
c    =  1  format shel-x
c    =  2  xplor
c
      USE General
      USE RiflessiNew
      USE Symmetry
      USE Riflessi
      USE Molcom
!
      character (len=3) :: iccc
!
      call AllocaRiflessi(1)
!
      ksubr=13                ! -->    observed and unobserved
      call LeggiRiflessi(ier,ksubr)
!
      if(in.eq.-1) then
         write(ncpu,800)
  800    format(' ',/,
     *       '# Intensity data ##################################',/)
         write(ncpu,1000)
1000     format(' ',/,
     *       'loop_',/,
     1       '_refln_index_h',/,
     2       '_refln_index_k',/,
     3       '_refln_index_l')
c--      if(ifo2.eq.1) then
         write(ncpu,1001)
1001     format(      '_refln_F_meas ',/,
     5       '_refln_F_sigma',/,
     6       '_refln_F_calc',/,
     7       '_refln_phase_calc',/,
     8       '_refln_observed_status',/)
c         else 
c         write(ncpu,1002)
c1002     format(      '_refln_F_squared_meas ',/,
c     5	       '_refln_F_squared_sigma',/,
c     6	       '_refln_F_squared_calc',/,
c     7	       '_refln_phase_calc',/,
c     8	       '_refln_observed_status',/)
c         endif
c
      endif
      innn=0
c--fetch the next reflection
      do ij=1, NreflKsubr
         if(in.eq.-1) then
            if (CodeRefl(ij) == 0) then
                iccc = ' o '
            else
                iccc = ' < '
            endif
            write(ncpu,1030)  khl(1:3,ij),fovet(ij),sigmav(ij),
     2        fcvet(ij),iphaz(ij),iccc      
 1030       format(3i4,3f15.4,i10,5x,a)
         endif
c--output tipo CAOS
         if(in.eq.0) then
            write(ncpu,1035) khl(1:3,ij),fovet(ij),sigmav(ij),
     2           fcvet(ij),iphaz(ij)
 1035       format(3i4,3f10.4,i10)
         endif
c--output tipo Shel-X
         if(in.eq.1) then
            write(ncpu,1040)khl(1:3,ij),fovet(ij),sigmav(ij)
     1                 ,innn
1040        format(3i4,2f8.2,i4)
         endif
c--output tipo XPLOR
         if(in.eq.2) then
            write(ncpu,1050)khl(1:3,ij),fovet(ij),sigmav(ij)
1050        format(' INDE ',3i5,' FOBS=',f10.2,' SIGMA=',f10.2)
         endif
      enddo
c--terminate the list
      i=ifat512
      j=1
      c=-1.0
      iccc = ' < '
      if(in.eq.-1) then
         write(ncpu,1030)  i,i,i,c,c,c,j,iccc 
c--output tipo CAOS
      else if(in.eq.0) then
         write(ncpu,1035) i,i,i,c,c,c,j
c--output tipo Shel-X
      else if(in.eq.1) then
         i=0
         c=0.0
         write(ncpu,1040)i,i,i,c,c
c--output tipo XPLOR
      else if(in.eq.2) then
         i=0
         c=0.0
         write(ncpu,1050)i,i,i,c,c
      endif
      return
      end
c
!-----------------------------------------------------------------------
      subroutine CaosPubl5NEW(jcod,ier)
!--set variables for printing list 5p
!  jcod  1  list 5 for cif file
!       -1  table list 5 (default)
!
!  iub	-1  u equiv e u(i,j)
!        0  beta equiv e beta(i,j) (non fa trasformazioni)
!        1  b equiv e b(i,j)
!
!  ieqcode  -1  u equivalente
!            0  niente
!            1  b equivalente
!
!  ibucode  -1  u(i,j)
!            0  niente
!            1  b(i,j)
!
      USE General
      USE Atomi
      USE Geometry
!
      real, allocatable :: BijSav(:,:),BijDevSav(:,:)
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
!--
      common/xpubx/ nsta,nxf ,nxd  ,nuf  ,nud ,noo  ,
     1 nlw,jump,nif,nid,ibj,nd,idumm(22)
!--
!--define variable caos
      kcont = 0
      istat2=0
      if(jcod.eq.1)then 
!--default cif file
         jcif=1
         iubx=-1
         nxf=12
         nif=8
         nuf=11
      else
!-- set default values
         jcif=0
         iubx=0
         nxf=12
         nif=12
         nuf=11
      end if
!--end default
      iword=0
      nfix=0
      nsta=1
      nxd=4
      nud=4
      nid=3
      ibj=0
      noo=0
      nd=1
      ieqcode=1
      ibucode=0
      ibar=130
      jump=0
!--alloca 
      IF (.NOT. ALLOCATED(BijSav))
     *    ALLOCATE (BijSav(1:6,1:Nats),stat = ierr)
      if (ierr.ne.0) then
          write(lo,*) 'BijSav Allocation error'
          stop 
      endif
      IF (.NOT. ALLOCATED(BijDevSav))
     *    ALLOCATE (BijDevSav(1:6,1:Nats),stat = ierr)
      if (ierr.ne.0) then
          write(lo,*) 'BijDevSav Allocation error'
          stop 
      endif
!
      nlw =nsta+4+nxf*3+nif+4
      if(nlw.gt.ibar)  then  
         write(ncwu,9240) nlw,ibar
9240     format(/,i5,' is more than',i5,' characters for line')
         return
      endif
      i=nlw
      nlw =nsta+4+nuf*6+4
      if(nlw.gt.ibar)  then  
         write(ncwu,9240) nlw,ibar
         return
      endif
      nlw =max0(nlw ,i)
!--direttiva u
      if(iubx.lt.0)then       
         nlw =nsta+4+nxf*3+nif+4
         if(jcif.eq.1)nlw=nlw+11
         ieqcode=-1
         ibucode=0
         call mdf5NEW(BijSav,BijDevSav,ieqcode,ibucode,ibb)
         icod=0
         call spr5pNEW(BijSav,BijDevSav,icod)
         if(ibb.ne.0) then
            nlw =nsta+4+nuf*6+4
            ieqcode=0
            ibucode=-1
            call mdf5NEW(BijSav,BijDevSav,ieqcode,ibucode,ibb)
            icod=1
            call spr5pNEW(BijSav,BijDevSav,icod)
         endif
      else if(iubx.gt.0)then       
!--direttiva b
         ieqcode=1
         ibucode=0
         call  mdf5NEW(BijSav,BijDevSav,ieqcode,ibucode,ibb)
         icod=0
         call spr5pNEW(BijSav,BijDevSav,icod)
         if(ibb.ne.0) then 
            ieqcode=0
            ibucode=1
            call mdf5NEW(BijSav,BijDevSav,ieqcode,ibucode,ibb)
            icod=1
            call spr5pNEW(BijSav,BijDevSav,icod)
         endif
!--calcola eventualmente fatt. term. modificati
      else if(iubx.eq.0)then       
         if(ieqcode.ne.0.or.ibucode.ne.0) then  
            call mdf5NEW(BijSav,BijDevSav,ieqcode,ibucode,ibb)
            icod=0
            call spr5pNEW(BijSav,BijDevSav,icod)
            icod=1
            call spr5pNEW(BijSav,BijDevSav,icod)
         else if(ieqcode.eq.0.and.ibucode.eq.0) then
            icod=0
            call spr5pNEW(BijSav,BijDevSav,icod)
         endif
      endif
      iabort=0
!      
      DEALLOCATE(BijSav, stat =ierr)
      DEALLOCATE(BijDevSav, stat =ierr)
!
      return
      end
!
!code for mdf5NEW
      subroutine mdf5NEW(BijSav,BijDevSav,ieqcode,ibucode,ibb)
!--modifica fattori termici
!
!  ieqcode  =  -1  u (equiv)
!           0  niente
!           1  b (equiv)
!  ibucode  =  -1  u(i,j)
!           0  niente
!           1  B(i,j)
!  ibb  =   0  all are isotropic
!           1  there are anisotropic atom(s)
! 
!  IsoAniso(:)  ! =1 if Aniso, =2 if Iso
!
      USE General
      USE Atomi
      USE Geometry
!
      real  BijSav(6,Nats),BijDevSav(6,Nats),celltemp(6)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      common/xpubx/ nsta,nxf ,nxd  ,nuf  ,nud ,noo  ,
     1 nlw,jump,nif,nid,ibj,nd,idumm(22)
!--
      ibb=0
      do k=1,nats
         if(ibucode.ne.0) then 
            if(IsoAniso(k).eq.1) then 
               ibb=1
               if(ibucode.lt.0) then  
!--trasforma i b(i,j) in u(i,j)
                  BijSav(1,k) =  Bij(1,k)*BijToUij_11    
                  BijSav(2,k) =  Bij(2,k)*BijToUij_12    
                  BijSav(3,k) =  Bij(3,k)*BijToUij_13    
                  BijSav(4,k) =  Bij(4,k)*BijToUij_22    
                  BijSav(5,k) =  Bij(5,k)*BijToUij_23    
                  BijSav(6,k) =  Bij(6,k)*BijToUij_33    
!--
                  BijDevSav(1,k) =  Bij_Dev(1,k)*BijToUij_11  
                  BijDevSav(2,k) =  Bij_Dev(2,k)*BijToUij_12   
                  BijDevSav(3,k) =  Bij_Dev(3,k)*BijToUij_13   
                  BijDevSav(4,k) =  Bij_Dev(4,k)*BijToUij_22   
                  BijDevSav(5,k) =  Bij_Dev(5,k)*BijToUij_23    
                  BijDevSav(6,k) =  Bij_Dev(6,k)*BijToUij_33   
               else if(ibucode.gt.0) then
!--trasforma i b(i,j) in B(i,j)
                  BijSav(1,k) =  Bij(1,k)*4*twopis*BijToUij_11    
                  BijSav(2,k) =  Bij(2,k)*4*twopis*BijToUij_12    
                  BijSav(3,k) =  Bij(3,k)*4*twopis*BijToUij_13    
                  BijSav(4,k) =  Bij(4,k)*4*twopis*BijToUij_22    
                  BijSav(5,k) =  Bij(5,k)*4*twopis*BijToUij_23    
                  BijSav(6,k) =  Bij(6,k)*4*twopis*BijToUij_33    
!--
                  BijDevSav(1,k) =  Bij_Dev(1,k)*4*twopis*BijToUij_11   
                  BijDevSav(2,k) =  Bij_Dev(2,k)*4*twopis*BijToUij_12   
                  BijDevSav(3,k) =  Bij_Dev(3,k)*4*twopis*BijToUij_13  
                  BijDevSav(4,k) =  Bij_Dev(4,k)*4*twopis*BijToUij_22  
                  BijDevSav(5,k) =  Bij_Dev(5,k)*4*twopis*BijToUij_23  
                  BijDevSav(6,k) =  Bij_Dev(6,k)*4*twopis*BijToUij_33  
               endif
            endif
            cycle  
         endif
         if(ieqcode.lt.0) then   
!--trasforma in u equiv
            if(IsoAniso(k).eq.2) then 
!--biso in Ueq
               bSav(k)=Bfac(k)*BisoToUiso
               Bfac15(k)=Bfac_dev(k)*BisoToUiso
            else                        
!--b(i,j) in Ueq
               ibb=1
               bSav(k)=  BisoToUiso *(Bij(1,k)* BijToBiso(1)
     1                               +Bij(2,k)* BijToBiso(2)
     2                               +Bij(3,k)* BijToBiso(3)
     3                               +Bij(4,k)* BijToBiso(4)
     4                               +Bij(5,k)* BijToBiso(5)
     5                               +Bij(6,k)* BijToBiso(6))
               BijSav(1:6,k)=0.0
               jFlagAtom(k)=-1
!--
               dev2=  (Bij_dev(1,k)* BijToBiso(1))**2
     1               +(Bij_dev(2,k)* BijToBiso(2))**2
     2               +(Bij_dev(3,k)* BijToBiso(3))**2
     3               +(Bij_dev(4,k)* BijToBiso(4))**2
     4               +(Bij_dev(5,k)* BijToBiso(5))**2
     5               +(Bij_dev(6,k)* BijToBiso(6))**2
               Bfac15(k)=BisoToUiso*sqrt(dev2)        
            endif
            cycle   
         else if(ieqcode.gt.0) then  
            if(IsoAniso(k).eq.1) then 
!--b(i,j) in Beq
               ibb=1
               bSav(k)= Bij(1,k)* BijToBiso(1)
     1                 +Bij(2,k)* BijToBiso(2)
     2                 +Bij(3,k)* BijToBiso(3)
     3                 +Bij(4,k)* BijToBiso(4)
     4                 +Bij(5,k)* BijToBiso(5)
     5                 +Bij(6,k)* BijToBiso(6)
               BijSav(1:6,k)=0.0
               jFlagAtom(k)=-1
!--
               dev2=  (Bij_dev(1,k)* BijToBiso(1))**2
     1               +(Bij_dev(2,k)* BijToBiso(2))**2
     2               +(Bij_dev(3,k)* BijToBiso(3))**2
     3               +(Bij_dev(4,k)* BijToBiso(4))**2
     4               +(Bij_dev(5,k)* BijToBiso(5))**2
     5               +(Bij_dev(6,k)* BijToBiso(6))**2
               Bfac15(k)= sqrt(dev2)

               BijSav(1:6,k) =  Bij(1:6,k)             
!--
               BijDevSav(1:6,k) =  Bij_Dev(1:6,k)    
            else                       
!--biso in Beq
               bSav(k)  = Bfac(k)
               Bfac15(k)= Bfac_dev(k)
            endif
            cycle   
         endif
      enddo
      return
      end
!
!code for spr5pNEW
      subroutine spr5pNEW(BijSav,BijDevSav,icod)
!--print atoms
!  icod  0  stampo x y z b(iso)
!        1  stampo b(i,j)
!
      USE General
      USE Atomi
      USE Symmetry
      USE Geometry
!
      real  BijSav(6,Nats),BijDevSav(6,Nats)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      common/xpubx/ nsta,nxf ,nxd  ,nuf  ,nud ,noo  ,
     1 nlw,jump,nif,nid,ibj,nd,idumm(22)
c--
      character*40 string
      dimension xo(11),xn(11),key(10)
c--
      character*4 label
      character*6 jflag,ifmt
      character*1 chtmp
      character*40 ifmt1,ifmt2,ifmt3,buffer,buffer2
      character*131 llinea
      dimension linea(131),lineb(131)
c--
      write(ifmt,'(i3)')nlw
      ifmt1='(1x,'//ifmt(1:3)//'a1)'
      ifmt2='(1x,'//ifmt(1:3)//'a1,a,a4,i3)'
      ifmt3='(1x,'//ifmt(1:3)//'a1)'
c--loop per calcolo lunghezza massima attuale della label
      lenx=-1
      do k=1,nats
         call shift(aLab(k),len)
         if(len.gt.lenx) lenx=len
      enddo
      lenx=lenx+2
!
      if(icod.eq.0) then
c--loop to print x y z b(iso)
      fmulti=pts*(icent+1)*nsym
         if (jcif.eq.0) then
             write(ncwu,1030)
1030         format(1h ,78(1h-))
             write(ncwu,1031)
1031         format(/,' Table   . Atomic coordinates and isotropic ',
     1            'thermal parameters with',/,
     2            '           their e.s.d.',1h','s in parentheses',//,
     3            '           B(eq)=(4/3)*sum(ij)[a(i)a(j)b(ij)]')
	       write(ncwu,1041)
1041	       format(1h )
         else
!--calcola il site_multiplicity
             do i=1,nats
                xo(1)=xyzs(1,i )
                xo(2)=xyzs(2,i )
                xo(3)=xyzs(3,i )
                iser=i
	        khead=1
                k=kspecb(newvet,xo,xn,key,itype,iser,khead,iactn)
                xyz30(1,i)=10000.0/float(key(10))
!     	        write(ncwu,*)'i,key(10),xyz30(1,i)',i,key(10),xyz30(1,i)
             enddo
!--fine calcolo 
	       write(ncpu,1050)
1050         format(1h ,/,
     1             'loop_',/,
     2             '_atom_site_label  ',/,
     3             '_atom_site_fract_x',/,
     4             '_atom_site_fract_y',/,
     5             '_atom_site_fract_z',/,
     6             '_atom_site_occupancy',/,
     7             '_atom_site_U_iso_or_equiv',/,
     8             '_atom_site_thermal_displace_type',/,
     9             '_atom_site_type_symbol',/,
     *             '_atom_site_symmetry_multiplicity',/)
         endif
!--
         ibj=0
         do k=1,nats
            nzz=nzTot(k)
            llinea(:)=' '
            buffer(:)=' '
            buffer=aLab(k)
*           chtmp=buffer(1:1)
*           call ucase(chtmp)
*           buffer(1:1)=chtmp
            call shift(buffer,len)
            llinea=buffer
            call shift(llinea,len)
            j=nsta+lenx
            nxfc=11
*gl*        j=10    gianluca 12/02/2011 troppo poco per le label nelle prot.
c            jj=12
            do l=1,3
               e=xyzs(l,k )
               f=xyzs_dev(l,k )
               nxd1=nxd
               call xnumst(e,f,nxd1,string,len)
               call AllineaNumb(blank,string,len,3)
               llinea(j:j+len)=string(1:len)
               call shift(llinea,len2)
               j=j+nxfc
            enddo
            j = j + 2
            len2=len2+2
            jmulti=nint(xyzs(5,k)*fmulti)
            if(jcif.eq.1) then     !occ
	         e=xyzs(5,k)
               kkkx=nint(xyzs(5,k)*10000.0)
	         if(kkkx.eq.nint(xyz30(1,k))) e=1.00
	         f=0.0
               nn=3 
               call xnumst(e,f,nn,string,len)
               llinea(j:j+len)=string(1:len)
               call shift(llinea,len2)
               j=j+11
            end if  
            if(isoAniso(k).eq.2) then 
               jflag=' uiso '
            else
               jflag=' uani '
            endif
            e=bSav(k)
            f=bfac15(k)
            nid1=nid
            call xnumst(e,f,nid1,string,len)
            call AllineaNumb(blank,string,len,3)
            llinea(j:j+len)=string(1:len)
            call shift(llinea,len2)
!            j=j+nif
            call shift(Species(nzz),len3)
            if(jcif.eq.1)then
              label = Species(nzz)
              call lcase(label)
              call ucase(label(1:1))
              write(ncpu,'(3a,i3)')llinea(1:len2),jflag,
     *                 label,jmulti
            else
              write(ncwu,'(a)')llinea(1:len2)
              if(jump.eq.1) write(ncpu,1041)
            endif
         enddo
	else
         ibj=1
	endif
!
!--loop to print b(ij)
      if(ibj.gt.0) then  
         if(jcif.eq.0) then
            write(ncwu,6031)
6031        format(/,' Table   . Anisotropic thermal',
     1          ' parameters for non-hydrogen atoms with',/,
     5          '           their e.s.d.',1h','s in parentheses')
            write(ncwu,1041)
         else
            write(ncpu,1051)
1051        format(1h ,/,
     1            'loop_',/,
     2            '_atom_site_aniso_label  ',/,
     3            '_atom_site_aniso_U_11   ',/,
     4            '_atom_site_aniso_U_12   ',/,
     5            '_atom_site_aniso_U_13   ',/,
     6            '_atom_site_aniso_U_22   ',/,
     7            '_atom_site_aniso_U_23   ',/,
     8            '_atom_site_aniso_U_33   ',/)
c     9           '_atom_site_type_symbol  ',/)
         endif
         do k=1,nats
            if(isoAniso(k).eq.1) then 
               llinea(:)=' '
               buffer=aLab(k)
               chtmp=buffer(1:1)
               call ucase(chtmp)
               buffer(1:1)=chtmp
               call shift(buffer,len)
               llinea(1:len)=buffer(1:len)
               call shift(llinea,len)
c               jj=12
               j=10
               j = lenx    !  gianluca 20/01/2012
               nufc=11
               do l=1,6
                  e=BijSav(l,k)
                  f=BijDevSav(l,k)
                  nud1=nud
                  call xnumst(e,f,nud1,string,len)
                  call AllineaNumb(blank,string,len,3)
c                  call snum(e,f,nud,nud1,noo,jj,linea,nd,nfix)
c                   buffer(:)=' '
c                   write(buffer,'(16a1)')linea(1:16)
c                   call shift(buffer,len)
                  llinea(j:j+len)=string(1:len)
                  call shift(llinea,len2)
                  j=j+nufc
               enddo
               call shift(llinea,len2)
               if(jcif.eq.1) then
                  write(ncpu,'(a)') llinea(1:len2)
               else
                  write(ncwu,'(a)') llinea(1:len2)
                  if(jump.eq.1) write(ncpu,1041)
               endif
            endif
         enddo
      endif
      write(ncwu,1030)
      return
      end
!      
!-----------------------------------------------------------------------
c
code for xnumst
      subroutine xnumst(a,b,ndec,string,lstring)
c--compone a charatcter string with number(st.dev.)
c  a	   number
c  b	   standard deviations
c  ndec    number of decimal if b=<0.0
c  string  character output
c  lstring number of characters
c
      character(*) string
      character*45 buf
      common/xchar/id,ie,ib,ic,ia,ih,numb(10),iplus, inus,ipoint
      dimension ivet(40)
c
      do i=1,40
         ivet(i)=ib
      enddo
      n2=0
      n1=4
      n1a=ndec
      j=20
      n3=1
      nfix=0
      call snum(a,b,n1,n1a,n2,j,ivet,n3,nfix)
      buf=' '
      write(buf,'(40a1)')ivet
      string=buf
      call shift(string,lstring)
      return
      end
c
code for snum
      subroutine snum(a,b,n1,n1a,n2,j,ivet,n3,nfix)
c
c  a        coordinate to insert
c  b        e.s.d. to insert
c  n1       number of decimal
c  n1a	    number of decimal if b=0.0
c  n2	    0  with point
c            1  no point
c  j        last address in ivet
c  ivet     vector for printing
c  n3       number of digit in the standart deviation
c  nfix     1  number of decimal is fixed
c           0  number of decimal depends on st. dev.
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xchar/id,ie,ib,ic,ia,ih,numb(10),iplus, inus,ipoint
      dimension ivet(*)
c--
c      write(ncwu,*)'snum a,b,n1,n1a,n2,j,n3,nfix',
c     1 a,b,n1,n1a,n2,j,n3,nfix
      j1x=j
      n1x=n1
      if(b.eq.0.0) then
       n1x=n1a
       j1x=j1x-abs(n1-n1a)
      endif
1001  continue
      j1=j1x
      if(n2) 1010,1010,1000
1000  continue
      call si(a,n1x,idec)
      call salf(j1,idec,ivet)
      j2=j1
      go to 1015
1010  continue
      call sid(a,n1x,ixa,idec)
c      write(ncwu,*)'sid a,n1x,ix,idec', a,nx1,ix,idec
      j2=j1-n1x+1
      call salf(j1,idec,ivet)
      call set0(j2,j1,ivet)
      j2=j2-1
      ivet(j2)=ipoint
      j2x=j2
      j2=j2-1
      call salf (j2,ixa,ivet)
1015  continue
      if(a.lt.0.) ivet(j2)= inus
      if(b.eq.0)return
      call sid(b,n1x,ix,idec)
c      write(ncwu,*)'sid b,n1x,ix,idec', b,nx1,ix,idec
      if(ix.le.0) goto 1035
      if(nfix.ne.1) goto 1018
      idec=idec+ix*10**n1x
      goto 1070
1018  idec=ix
c--      x=abs(a)
c--      ix=kint(x)
      ix=ixa
      j2=j2x-1
      call salf(j2,ix,ivet)
      if(a.lt.0.) ivet(j2)= inus
      j1=j2x
      goto 1075
1035  continue
      if(nfix.eq.1) goto 1070
      if(idec.lt.10**n1x) goto 1045
      idec=idec/10**n1x
      j1=j2x
      goto 1075
1045  continue
      idecc=idec/10**(n3-1)
      if(idecc)1040,1040,1050
1040  continue
      n1x=n1x+1
      j1x=j1x+1
      go to 1001
1050  continue
      idecc=idec/10**n3
      if(idecc)1070,1070,1060
1060  continue
      n1x=n1x-1
      j1x=j1x-1
      go to 1001
1070  continue
      j1=j1x+1
1075  continue
      do 1005 k=j1,j1+n1+2
1005  ivet(k)=ib
      call sned(j1,idec,ivet)
      return
      end
!
!-----------------------------------------------------------------------
c
code for sned
      subroutine sned(j,iarg,ivet)
c--transform integer number to alphanumeric characters
c
c  the number will be enclosed by brackets
c  j      first address in ivet
c  iarg   integer number
c  ivet   vector for printing
c
      common/xchar/id,ie,ib,ic,ia,ih,numb(10),iplus, inus,ipoint
      dimension ivet(*)
c--
      if(iarg.ne.0) then
       ivet(j)=id
       j=j+1
       call snedx(j,iarg,ivet)
       ivet(j)=ie
       j=j+1
      endif
      return
      end
c
code for snedx
      subroutine snedx(j,iarg,ivet)
c--transform integer number to alphanumeric characters
c
c  the number will be enclosed by brackets
c  j      first address in ivet
c  iarg   integer number
c  ivet   vector for printing
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xchar/id,ie,ib,ic,ia,ih,numb(10),iplus, inus,ipoint
      dimension ivet(*)
c--
      if(iarg.ne.0) then
      ix=iarg
      m=0
      nmx=5
      do 1200 i=1,nmx
      i1=nmx-i
      i2=ix/(10**i1) 
      if(i2.gt.0)goto 1100! 1000,1000,1100
c1000  continue
      if(m.le.0) goto 1200 !1200,1200,1110 
      goto 1110
1100  continue
      m=1
1110  continue
      n=i2+1
      ivet(j)=numb(n) 
      j=j+1
      ix=ix-i2*(10**i1)
1200  continue
      endif
      return
      end
!
!-----------------------------------------------------------------------
!code for stuij
      subroutine stuij(lenx,ivet)
!--insert 'b(i,j)'
!
      USE Geometry
!
      common/xchar/id,ie,ib,icc,ia,ih,numb(10),iplus, inus,ipoint
      common/xpubx/ nsta,nxf ,nxd  ,nuf  ,nud ,noo  ,
     1 nlw,jump,nif,nid,ibj,nd,idumm(22)
c--
      dimension ivet(*)
      character*1 ikchar
      data ikchar/'b'/
c
      read(ikchar,'(a1)')ik
c--
      j=nsta+lenx-4-nud+1
      do i=1,6
        j=j+nuf
        ivet(j  )=ik
        ivet(j+1)=id
        ivet(j+4)=ie
      enddo
      j=nsta+lenx-4-nud+1
      do i=1,3
        j=j+nuf
        n=i+1
        ivet(j+2)=numb(2)
        ivet(j+3)=numb(n)
      enddo
      j=j+nuf
      ivet(j+2)=numb(3)
      ivet(j+3)=numb(3)
      j=j+nuf
      ivet(j+2)=numb(3)
      ivet(j+3)=numb(4)
      j=j+nuf
      ivet(j+2)=numb(4)
      ivet(j+3)=numb(4)
      return
      end
!-----------------------------------------------------------------------
code for stxyz
      subroutine stxyz(lenx,ivet)
!--insert 'x/a  y/b  z/c  b(iso)'
!
      USE Geometry
!      
      common/xpubx/ nsta,nxf ,nxd  ,nuf  ,nud ,noo  ,
     1 nlw,jump,nif,nid,ibj,nd,idumm(22)
c--
      dimension ivet(*)
      character*1 ikchar(8)
      dimension ik(8)
c      data ik/1hx,1hy,1hz,1hB,1h(,1he,1hq,1h)/
      data ikchar/'x','y','z','B','(','e','q',')'/
c
      do i=1,8
      read(ikchar(i),'(a1)')ik(i)
      enddo
c
      j=nsta+lenx+8-nxd+1
      ivet(j+1)=ik(1)
      j=j+nxf
      ivet(j+1)=ik(2)
      j=j+nxf
      ivet(j+1)=ik(3)
      j=j+nif+nxd-nid-3
      ivet(j+1)=ik(4)
      ivet(j+2)=ik(5)
      ivet(j+3)=ik(6)
      ivet(j+4)=ik(7)
      ivet(j+5)=ik(8)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine outShelx(ifReflOut)
!
!-- shelx output
!
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE PhaseModule
      USE LsqModule
      USE RemoModule
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension x2(5), kpunt(18), npunt(18)
      dimension abc(3),ang(3),latsx(7)
      character fmt*4,line*6,linl*180
      integer WM                          !!mr
!
!-- latt   =  1   2   3   4   5   6   7   (multan)
!--           p   a   b   c   f   i   r
!-- latt   =  1   5   6   7   4   2   3   (shelx)
!
      latsx(1:7) = (/ 1, 5, 6, 7, 2, 4, 3 /)
      istat2 = 0
!
!-- shelx output - header
!
      call sirdate(direttiva, L)
      k = index(fname(1),'.bin') - 1
      write(jhost,90) ProgName(1:lProgName), direttiva(1:L), 
     *                fname(1)(1:k)
!
      write(jhost,100) Titolo(1:72)
      do i=1,3
         abc(i) = cell(i)
         ang(i) = cell(i+3)
      enddo
      ilat=latsx(latt)
      if (icent.eq.0) then
          ilat=-ilat
          nop2=nsym
      else
          nop2=nsym*2
      endif
      nop2 = nop2 * pts
      write(jhost,120) wavel, cell(1:6), nop2, errcell(1:6)
      write(jhost,130) ilat
!
!-- procedura che scrive la parte relativa alla simmetria 
!-- del file di input a shelx
!
      if (nsym.gt.1) then
          call KmatToChar(nsym)
          do k=2,nsym
             NewSymmVet(k)(1:4) = 'SYMM'
             write(jhost,'(a)') NewSymmVet(k)
          enddo
      endif
!
*gl*  nalfsx(:) = 0
      kpunt (:) = 0
      npunt (:) = 0
!
!-- find out carbon position
!
      ish = 0
      do i=1,nk
         if (no(i).eq.6) then
             ish = ish + 1
             kpunt(i) = ish
             npunt(ish) = i
*gl*         nalfsx(ish) = nalf(i)
             vSpecie(ish) = Species(i)
             nSpecie(ish) = nw(i)
         endif
      enddo
!
!-- find out hydrogen position
!
      do i=1,nk
         if (no(i).eq.1) then
             ish = ish + 1
             kpunt(i) = ish
             npunt(ish) = i
*gl*         nalfsx(ish) = nalf(i)
             vSpecie(ish) = Species(i)
             nSpecie(ish) = nw(i)
         endif
      enddo
      do i=1,nk
         if (kpunt(i).eq.0) then
             ish = ish + 1
             kpunt(i) = ish
             npunt(ish) = i
*gl*         nalfsx(ish) = nalf(i)
             vSpecie(ish) = Species(i)
             nSpecie(ish) = nw(i)
         endif
      enddo
      if (neutro == 0) then
          write(linl,210) vSpecie(1:nk)
          call OneBlankOnly(linl)
          call ucase(linl)
          write(jhost,'(a)') linl(1:Lung(linl))
      else
          zero = 0
          if (neutro == 1) then
              write(jhost,203)
          else
              write(jhost,204)
          endif
          write(jhost,201)
          write(jhost,202)
          do i=1,nk
             j = npunt(i) 
             linl = ' '
             write(linl,205) Species(j), (al(ii,j),bs(ii,j),ii=1,3)
             call ucase(linl)
             write(jhost,'(a)') linl(1:Lung(linl))
             write(jhost,206) al(4,j), bs(4,j), cl(j), zero, zero,
     *                        fmuro(j), radii(j,1), AtomWeight(j)
          enddo
      endif
      write(linl,220) nint(nSpecie(1:nk))
      call OneBlankOnly(linl)
      write(jhost,'(a)') linl(1:Lung(linl))
      write(jhost,240)
!
!-----------------------------------------------------------   
!                        (1)(2)(3)(4)(5)(6)       
!  la sequenza in sir  : 11 12 13 22 23 33
!  la sequenza in shelx: 11 22 33 23 13 12
!  quindi: u(1) = BijToUij_11*b(1)
!          u(6) = BijToUij_12*b(2)
!          u(5) = BijToUij_13*b(3)
!          u(2) = BijToUij_22*b(4)
!          u(4) = BijToUij_23*b(5)
!          u(3) = BijToUij_33*b(6)
!--trasforma i b(i,j) in u(i,j)
!-----------------------------------------------------------   
      if (InfoOK(5) == 1) then
          WM = WhichModel
          MO = 1
          do i=1, nats
             aLab(i)   = model(WM)%Label(i)
             xyzs(1,i) = model(WM)%atoms(1,i,MO)
             xyzs(2,i) = model(WM)%atoms(2,i,MO)
             xyzs(3,i) = model(WM)%atoms(3,i,MO)
             xyzs(5,i) = model(WM)%atoms(5,i,MO)
             nz(i)     = model(WM)%specie(i,MO)
             if (model(WM)%bij(1,i,MO) > 0.000001) then
                 if (nats.le.500) then
                     IsoAniso(i) = 1
                 endif
                 Ell(1,1,i) = model(WM)%bij(1,i,MO)*BijToUij_11 
                 Ell(1,2,i) = model(WM)%bij(2,i,MO)*BijToUij_12 
                 Ell(2,1,i) = model(WM)%bij(2,i,MO)*BijToUij_12 
                 Ell(1,3,i) = model(WM)%bij(3,i,MO)*BijToUij_13 
                 Ell(3,1,i) = model(WM)%bij(3,i,MO)*BijToUij_13 
                 Ell(2,2,i) = model(WM)%bij(4,i,MO)*BijToUij_22 
                 Ell(2,3,i) = model(WM)%bij(5,i,MO)*BijToUij_23 
                 Ell(3,2,i) = model(WM)%bij(5,i,MO)*BijToUij_23 
                 Ell(3,3,i) = model(WM)%bij(6,i,MO)*BijToUij_33 
             else
                 if (nats.le.500) then
                     IsoAniso(i) = 2
                 endif
                 bfac(i) = model(WM)%th_fact(i,MO)
             endif
*gl*         m5 = m5 + md5
          enddo
      else
          if (nats.le.500) then
              do i=1,nats
                 IsoAniso(i) = 2
              enddo
          end if
      end if
!
      denom=8.0*pi*pi
      do i=1,nats
         izpki=iabs(nz(i))/nzConst
         if (izpki.ne.0) then
             izpk2=kpunt(izpki)
             uiso=bfac(i)/denom
             x2(1:3)=xyzs(1:3,i)
             x2(4)=xyzs(5,i)+10.0
             line = ' '
             L = Lung(aLab(i))
             if (L .gt. 6) then
                 L = 6
             end if
             line = aLab(i)
             call ucase(line)
             if (nats.le.500) then
                 if (IsoAniso(i).eq.1) then
                     write(jhost,291) line(1:4),izpk2,(x2(j),j=1,4),
     *               Ell(1,1,i),Ell(2,2,i),Ell(3,3,i),
     *               Ell(2,3,i),Ell(1,3,i),Ell(1,2,i)
                 else
                     write(jhost,290) line(1:4),izpk2,(x2(j),j=1,4),uiso
                 endif
             else
                 write(jhost,290) line(1:4),izpk2,(x2(j),j=1,4),uiso
             endif
         endif
      enddo
      if (ifo2.eq.1) then
          iHKLF = 3
      else
          iHKLF = 4
      endif
      write(jhost,300) iHKLF
      uiso=bt/denom
      do i=1,nats
         izpki=iabs(nz(i))/nzConst
         if (izpki.eq.0) then
             izpki=1
             x2(1:3)=xyzs(1:3,i)
             line(1:2)='Q '
             line(3:4)='  '
             x2(4)=xyzs(5,i)+10.0
             in=2
             if (i.gt.99) in=3
             write(fmt,280) in
             write(line(5-in:4),fmt) i
             do j=1,4
                if (line(j:j).eq.' ') line(j:j)='0'
             enddo
             if (IsoAniso(i).eq.1) then
                 write(jhost,291) line,izpki,(x2(j),j=1,4),
     *                 Ell(1,1,i),Ell(2,2,i),Ell(3,3,i),
     *                 Ell(2,3,i),Ell(1,3,i),Ell(1,2,i)
             else
                 write(jhost,290) line,izpki,(x2(j),j=1,4),uiso
             endif
         endif
      enddo
!
!--dump list 6
!--check if a list 6 exists
!
      lj = InfoOK(6)
      if (lj > 0 .and. ifReflOut == 1) then
          in= 1
          call Dump_Reflections(in,jhost)    !!!   su G95 va in loop  !!!
      endif
!
      return
!
   90 format('REM  ',/,
     *       'REM  Shelx file produced by ',a,' on ',a,/,
     *       'REM  Structure name: ',a,/,
     *       'REM  ')
  100 format('TITL    ',a)
  120 format('CELL  ',f8.5,2x,6f9.4,/,
     *       'ZERR  ',i8,2x,6f9.4)
  130 format('LATT ',2i2)
  201 format("REM  SFAC Species a(1) b(1) a(2) b(2) a(3) b(3) =")
  202 format("REM  a(4) b(4) c f' f'' mu cov_radius weight")
  203 format("REM  ------ Neutron scattering factors ------")
  204 format("REM  ------ Electron scattering factors ------")
  205 format("SFAC ",a4,6f10.5," =")
  206 format(9x,3f10.5,5f8.3)
  210 format('SFAC  ',18(' ',a4))
  220 format('UNIT  ',18i8)
  240 format('L.S.      5',/,
     *       'WGHT    0.1',/,
     *       'FMAP      2',/,
     *       'PLAN     25',/,
     *       'FVAR    1.0')
  270 format(a2)
  280 format(2h(i,i1,1h))
  290 format(a4,i5,5f10.5)
  291 format(a4,i5,6f10.5,' ='/5x,4f10.5)
  300 format('           ',/,
     *       'HKLF      ',i1,/,
     *       'END        ')
!
      end
!-----------------------------------------------------------------------
      subroutine KmatToChar(nsym2)
      USE Symmetry
      USE Atomi
!
      character xyzshe(3)
      character trasla*3 , space*16

!
      xyzshe(1) = 'X'
      xyzshe(2) = 'Y'
      xyzshe(3) = 'Z'
      do k=1,nsym2
         NewSymmVet(k)=' '
         ip=6
         do j=1,3
            iplus=0
            if (tmat(k,j).gt.0.001) then
                call TmatToChar(k,j,trasla)
                NewSymmVet(k)(ip:ip+2) = trasla
                ip=ip+3
                iplus=1
            endif
            do i=1,3
               ii=kmat(k,j,i)
               if (ii.ne.0) then
                   if (ii.lt.0) then
                       NewSymmVet(k)(ip:ip)='-'
                       ip=ip+1
                   else
                       if (iplus.eq.1) then
                           NewSymmVet(k)(ip:ip)='+'
                           ip=ip+1
                       endif
                   endif
                   write(NewSymmVet(k)(ip:ip),'(a1)') xyzshe(i)
                   ip=ip+1
                   iplus=1
               endif
            enddo
            if (j.lt.3) then
                write(NewSymmVet(k)(ip:ip),'(a1)') ','
                ip=ip+1
                iplus=0
            endif
         enddo
         ip=1
         iplus=0
      enddo
!
!-- Centring
!
      k = nsym2
      write(space,'(16a1)') nSpaceG
      call ucase(space(1:1))
      NewSymmVet(k+1)= '    0,0,0'
      if (space(1:1).eq.'A') then
          NewSymmVet(k+2) = '    0,1/2,1/2'
      elseif (space(1:1).eq.'B') then
          NewSymmVet(k+2) = '    1/2,0,1/2'
      elseif (space(1:1).eq.'C') then
          NewSymmVet(k+2) = '    1/2,1/2,0'
      elseif (space(1:1).eq.'I') then
          NewSymmVet(k+2) = '    1/2,1/2,1/2'
      elseif (space(1:1).eq.'F') then
          NewSymmVet(k+2) = '    0,1/2,1/2'
          NewSymmVet(k+3) = '    1/2,0,1/2'
          NewSymmVet(k+4) = '    1/2,1/2,0'
      elseif (space(1:1).eq.'R') then
          NewSymmVet(k+2) = '    2/3,1/3,1/3'
          NewSymmVet(k+3) = '    1/3,2/3,2/3'
      endif
!
      return
      end
!------------------------------------------------------------------
      subroutine TmatToChar(k,j,trasla)
      USE Symmetry
      character*(*) trasla
!
      n = nint(tmat(k,j) * 100)
      if (n.eq.50) then
          trasla = '1/2'
      elseif (n.eq.33) then
          trasla = '1/3'
      elseif (n.eq.67) then
          trasla = '2/3'
      elseif (n.eq.25) then
          trasla = '1/4'
      elseif (n.eq.75) then
          trasla = '3/4'
      elseif (n.eq.17) then
          trasla = '1/6'
      elseif (n.eq.83) then
          trasla = '5/6'
      else
          trasla = '   '
      endif
!
      return
      end
!---------------------------------------------------------------------
      subroutine outcry(kcompl)
!
!-- crystals output
!
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE PhaseModule
      USE LsqModule
      USE RemoModule
!
      implicit none
      integer :: nnats, kcompl, WM, MO, i, Lung, itp, L, k, somma
      real    :: denom, rfac, u, OvScale
      character (len=4) :: specie
!
      WM = WhichModel
      MO = 1
      kcompl = 0
      denom = 8.0 *pi * pi
!
!-- crystals output - header
!
      call sirdate(direttiva, L)
      k = index(fname(1),'.bin') - 1
      write(jhost,10) ProgName(1:lProgName), direttiva(1:L), 
     *                fname(1)(1:k)
!
!-- crystals output  -  list 5
!
      if (nats > 0) then
          nnats = 0
          somma = 0
          do i=1, nats
             itp = iabs(nz(i) / nzConst)
             if (itp.ne.0) then
                 nnats = nnats + 1
                 somma = somma + serial(i)
             endif
          enddo
          if (somma == 0) then
              call AssegnaSerial
              serial(1:nats) = model(WhichModel)%serial(1:nats)
          endif
          if (sc < 0.0) then
              OvScale = 1.0
          else
              OvScale = sqrt(sc)
          endif
          write(jhost,20)  1.0 / OvScale, nnats

          do i=1, nnats
             itp = iabs(nz(i) / nzConst)
             if (itp /= 0) then
                 specie = Species(itp)
                 call lcase(specie)
                 call ucase(specie(1:1))
                 u = bfac(i) / denom
                 write(jhost,30) specie, serial(i), xyzs(1:3,i), u
             endif
          enddo
      endif
      write(jhost,40)
!
      return
!
   10 format('#   ',/,
     *       '# Crystals file produced by ',a,' on ',a,/,
     *       '# Structure name: ',a,/,
     *       '#   ')
   20 format('#list 5 ',/,
     1       'overall scale = ', f10.5,/,
     2       'read natom = 'i6)
   30 format('atom ',a4,2x,i5,'     x = ',3f10.4, f10.6)
   40 format('end ')
!
      end
!---------------------------------------------------------------------
      subroutine outmold
!
!-- prepare input file for MOLDRAW
!
      USE General
      USE Symmetry
      USE Atomi
      USE PhaseModule
!
      implicit none
      integer :: ivet(9), jtmpVet, ntmpVet, ier, icveti, kfrag, iz
      integer :: i, ii, j, k, l, n, iss, jump
      character line*5,space*16
      real, allocatable :: tmpVet(:)
!
      jtmpVet = 1
      ntmpVet = 6
      n = nats * ntmpVet
      allocate(tmpVet(n), stat=ier)
      write(jhost,1040) Titolo(1:68), cell(1:6)
      do i=1,nats
         icveti=nz(i)
         if (nz(i).lt.0) then
             kfrag=10000+i
             icveti=0
         else
             kfrag=mod(icveti,nzConst)*1000+i
         endif
         iz=icveti/nzConst
         tmpVet(jtmpVet)=iz
         tmpVet(jtmpVet+1)=i
         tmpVet(jtmpVet+2)=xyzs(1,i)
         tmpVet(jtmpVet+3)=xyzs(2,i)
         tmpVet(jtmpVet+4)=xyzs(3,i)
         tmpVet(jtmpVet+5)=kfrag
         jtmpVet=jtmpVet+ntmpVet
      enddo
      jtmpVet=1
      jump=6
      call sortz_dyn(tmpVet, n, 1, nats, ntmpVet, jump)
      do i=1,nats
         do n=1,5
            line(n:n)=' '
         enddo
         icveti=tmpVet(jtmpVet)
         if (icveti.ne.0) then
             write(line(1:2),'(a2)') nalf(icveti)
             call ucase(line)
         else
             line(1:1)='H'
         endif
         write(line(3:5),'(i3)') int(tmpVet(jtmpVet+1))
         call NoBlanks(line,k)
         write(jhost,1120) i,line,(tmpVet(jtmpVet+j),j=2,4)
         jtmpVet=jtmpVet+ntmpVet
      enddo
      write(space,'(16a1)') nSpaceG
      call ucase(space)
      call NoBlanks(space,k)
      write(jhost,1110) space
      iss=-1
      do ii=1,icent+1
         iss=-iss
         do k=1,nsym
            l=0
            do i=1,3
               do j=1,3
                  l=l+1
                  ivet(l)=kmat(k,i,j)*iss
               enddo
            enddo
            write(jhost,1190) (tmat(k,i),i=1,3),ivet
         enddo
      enddo
      write(jhost,1200)
!
      deallocate(tmpVet, stat=ier)
!
      return
!
 1040 format('TITLE',/,a,/,'CELL',/,6f10.3,/,'COSYMB')
 1120 format(i4,2x,a5,3f10.3)
 1110 format('   0  0         0         0         0',/,
     *       'GROUP',/,a16,/,'SYMNUM')
 1190 format(3f10.5,3(3i4,4x))
 1200 format('  -1.       -1.       -1.        0   0   0       0   0   0
     *       0   0   0 ')
!
      end
!---------------------------------------------------------------------
      subroutine outsha
!
!-- prepare input file for SCHAKAL
!
      USE General
      USE Symmetry
      USE Atomi
      USE PhaseModule
      USE PhaseModule
!
      character line*5
!
!gl!  write(jhost,1040) (itle(i),i=1,17),(cell(i),i=1,6)
      write(jhost,1040) Titolo(1:68),(cell(i),i=1,6)
      do i=1,nats
         icveti=nz(i)
         if (icveti.ne.0) then
         if (nz(i).le.0) icveti=0
         iz=icveti/nzConst
         do n=1,5
            line(n:n)=' '
         enddo
         if (icveti.gt.0) then
             write(line(1:2),'(a2)') nalf(iz)
         else
             write(line(1:2),"('H ')")
         endif
         call ucase(line)
         write(line(3:5),'(i3)') i
         call NoBlanks(line,k)
         write(jhost,1120) line,(xyzs(j,i),j=1,3)
         endif
      enddo
      write(jhost,'(a3)') 'END'
!
      return
!
 1040 format('TITLE',3x,a,/,'CELL',3x,6f10.3)
 1120 format('ATOM',3x,a5,3f10.3)
!
      end
!---------------------------------------------------------------------
      subroutine outxyz
!
!-- prepare input file for XYZ
!
      USE General
      USE Symmetry
      USE Atomi
      USE PhaseModule
!
      dimension ivet(12),vet(12),amat(3,3),xyz(3),r(3)
      character line*5
      equivalence (vet(1),ivet(1))
!
      write(jhost,100) nats, Titolo
      alfa=cell(4)*dtor
      beta=cell(5)*dtor
      gamm=cell(6)*dtor
      a1=cos(alfa)
      a2=cos(beta)
      a3=cos(gamm)
      b1=sin(alfa)
      b2=sin(beta)
      b3=sin(gamm)
      amat(1,1) =  cell(1) * b2
      amat(1,2) = -cell(2) * b1 * a3
      amat(1,3) =  0.0
      amat(2,1) =  0.0
      amat(2,2) =  cell(2) * b1 * b3
      amat(2,3) =  0.0
      amat(3,1) =  cell(1) * a2
      amat(3,2) =  cell(2) * a1
      amat(3,3) =  cell(3)
      do i=1,nats
         do j=1,3
            r(j)=xyzs(j,i)
         enddo
         call MoltMatVec(amat,r,xyz)
         icveti=iabs(nz(i))/nzConst
         if (icveti.eq.0) then
             line(1:2)='q '
         else
             write(line(1:2),'(a2)') nalf(icveti)
         endif
         call ucase(line(1:2))
         write(jhost,300) line(1:2),(xyz(k),k=1,3)
      enddo
!
      return
!
  100 format(i5,/,a)
  300 format(a2,3x,3f15.7)
!
      end
!---------------------------------------------------------------------
      subroutine outmsc
!
!-- prepare input file for m.s.c. environment
!
      USE General
      USE Atomi
      USE PhaseModule
      USE Dialogo
!
      write(jhost,75) ProgName(1:lProgName), nats,numset
      do i=1,nats
         kheig=nint(xyzs(4,i))
         izpki=izpk(i)
         if (izpki.gt.0) then
             write(jhost,78) nalf(izpki), i, xyzs(1:3,i), kheig
         endif
      enddo
!
      return
!
   75 format(' ',a,' Release 1.0',i5,'  peaks for set no. ',i5)
   78 format(a2,i5,3f10.5,i7)
!
      end
!---------------------------------------------------------------------
      subroutine outenr
!
!-- prepare input file for enraf-nonius environment
!
      USE General
      USE Atomi
      USE PhaseModule
      USE Dialogo
!
      dimension xo(11),xn(11),key(10)
!
      write(jhost,75) ProgName(1:lProgName), nats,numset
      denom=8.0*pi*pi
      do i=1,nats
         xo(1:3)=xyzs(1:3,i)
         iser=i
         itype=nalf(izpk(i))
         if (itype.eq.0) cycle
         k=kspecb(newvet,xo,xn,key,itype,iser,khead,iactn)
         occ=1.0/float(key(10))
         kheig=nint(xyzs(4,i))
         izpki=izpk(i)
         uiso=bfac(i)/denom
         if (izpki.gt.0) then
             write(jhost,85) nalf(izpki),i,occ,uiso,
     *             (xyzs(j,i),j=1,3),kheig,(key(j),j=1,9)
         endif
      enddo
!
      return
!
   75 format(' ',a,' Release 1.0',i5,'  peaks for set no. ',i5)
   85 format(1h ,a2,i3,5f8.5,i7,9i3)
!
      end
!---------------------------------------------------------------------
      subroutine PovRay
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE PhaseModule
!
      common /movediamo3/ nplt, iplt(9800), nlegami(9800)
!
      call PovRayEnv(zlocation)
!
      call InitPov(zlocation)
      kCol0 = 4      !    color_BLUE   da sistemare prima o poi
      kCol0 = 4 + 128   ! mr
!
!-- Disegna gli atomi
!
      ifAtoms = 1
      if ((ifDrawContour == 1) .and. (ifModel ==0)) then
          ifAtoms = 0
      endif
      if (ifAtoms == 1) then
          write(jhost,10)
          do i=1, NatMol
!
!-- bisogna prevedere tutte le condizioni in cui gli atomi
!-- non vengono disegnati (cancellati/nascosti, ghost, hydro, etc.)
!
             iOK = 1
             if (RS(i).lt.0) then
                 iOK = 0
             endif
             if (nzTot(i) == 0 .and. ifGhost == 0) then
                 iOK = 0
             endif
             if (nzTot(i) == 1 .and.ifHydro == 1
     *           .and.ifDrHydr == 0) then
                 iOK = 0
             endif

             if (iOK.eq.1) then
                 kCol1 = iCol(i)
                 jPlotType = SinglePlotType(i)
                 if (nzTot(i) == 1 .and.ifHydro == 1) then
                     if (jPlotType == ELLIPSOIDS) then
                         jPlotType = SHADING
                     endif
                 endif
                 call DisePallePov(jPlotType,i, kCol1)
                 iplt(i) = 1
             else
                 iplt(i) = -1
             endif
          enddo
!
!-- Disegna i legami
!
          if (iPlotType /= VAN_DER_WAALS) then
              kCol0 = 4
              kCol0 = 4 + 256 !mr
              do i=1,NumLeg
                 if (LE(3, i).gt.0) then
                     N1 = LE(1,i)
                     N2 = LE(2,i)
                     iPlotType1 = SinglePlotType(N1)
                     if (nzTot(N1) == 1 .and.ifHydro == 1) then
                         if (iPlotType1 == ELLIPSOIDS) then
                             iPlotType1 = SHADING
                         endif
                     endif
                     iPlotType2 = SinglePlotType(N2)
                     if (nzTot(N2) == 1 .and.ifHydro == 1) then
                         if (iPlotType2 == ELLIPSOIDS) then
                             iPlotType2 = SHADING
                         endif
                     endif
                     if (iplt(N1).gt.0.and.iplt(N2).gt.0) then
                         call DisLegPov(i,N1,N2,kCol0,kCol1,kCol2,
     *                                  iPlotType1,iPlotType2)
                     endif
                 endif
              enddo
          endif
      endif
!
!-- Disegna la cella
!
      if (ifCell.ne.0) then
          call DisegnaCellaPov()
      endif
      if (ifDrawContour == 1) then
          call PlotContourPov()
      endif
      write(jhost,20)
!
      return
   10 format('#declare molecule = union {')
   20 format('}',/,
     *'object {',/,
     *'         molecule ',/,
     *'              translate <0.0, 0.0, 0.0> ',/,
     *'              rotate    <0.0, 0.0, 0.0> ',/,
     *'              scale     <0.0, 0.0, 0.0> ',/,
     *'       }')

      end
! -----------------------------------------------------------------
      subroutine PovRayEnv(zlocation)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom      
      USE Contorno
      USE PhaseModule
!
      common /movediamo3/ nplt, iplt(9800), nlegami(9800)
      dimension xyzP(3)
!
      xminSav = xmin
      yminSav = ymin
      xmaxSav = xmax
      ymaxSav = ymax

!
      do i = 1, NatMol + NatSpi
         xyzPov(1:3,i) = xyz(1:3,i)
      enddo
      if (ifCell.eq.0) then
          nspi = 0
      else
          nspi = NatSpi
      endif
      baricExpo(1:3) = 0.0
      denom = 0
      if (ifDrawContour == 1) then
          do i = 1, nPuntiCont + nspi
             baricExpo(1:3) = baricExpo(1:3) + xyz_tria(1:3,i)
          enddo
          denom = nPuntiCont + nspi
      else
          do i = 1, NatMol + nspi
             if (RS(i) .gt. 0) then
                 do j=1,3
                    baricExpo(j) = baricExpo(j) + xyzPov(j,i)
                    denom = denom + 1
                 enddo
             endif
          enddo
      endif
      do j=1,3
         baricExpo(j) = baricExpo(j) / denom
      enddo
!
      xmin = 9.e33
      xMax = -9.e33
      ymin = 9.e33
      yMax = -9.e33
      zmin = 9.e33
      zMax = -9.e33
      if (ifDrawContour == 1) then
          do i = 1, nPuntiCont + nspi
             do j=1,3
                xyzP(j) = xyz_tria(j,i) - baricExpo(j)
             enddo
             if (xmin.gt.xyzP(1)) xmin = xyzP(1)
             if (xMax.lt.xyzP(1)) xMax = xyzP(1)
             if (ymin.gt.xyzP(2)) ymin = xyzP(2)
             if (yMax.lt.xyzP(2)) yMax = xyzP(2)
             if (zmin.gt.xyzP(3)) zmin = xyzP(3)
             if (zMax.lt.xyzP(3)) zMax = xyzP(3)
          enddo
      else
          do i = 1, NatMol + NatSpi
             do j=1,3
                xyzPov(j,i) = xyzPov(j,i) - baricExpo(j)
             enddo
             iOK = 1
             if (RS(i) .lt. 0) then
                 iOK = 0
             elseif (i.gt.NatMol.and.ifCell.eq.0) then
                 iOK = 0
             endif
             if (iOK.eq.1) then
                if (xmin.gt.xyzPov(1,i)) xmin = xyzPov(1,i)
                if (xMax.lt.xyzPov(1,i)) xMax = xyzPov(1,i)
                if (ymin.gt.xyzPov(2,i)) ymin = xyzPov(2,i)
                if (yMax.lt.xyzPov(2,i)) yMax = xyzPov(2,i)
                if (zmin.gt.xyzPov(3,i)) zmin = xyzPov(3,i)
                if (zMax.lt.xyzPov(3,i)) zMax = xyzPov(3,i)
             end if
          enddo
      endif
      dx = xMax - xmin
      dy = yMax - ymin
      zlocation = amin1(dx/2.0, dy/2.0)
      locationZ = nint(zlocation)
      if (zlocation < 0.5) then
          zlocation = 5
      endif
      if (dx.gt.dy) then
          if (dx > 0.001) then
              scalapov = 4.5 / dx
          else
              scalapov = 1.0
          endif
            else
          if (dy > 0.001) then
              scalapov = 4.5 / dy
          else
              scalapov = 1.0
          endif
      endif
!
      scalapov = scalapov * 0.20
!
      xmin = 9.e33
      xMax = -9.e33
      ymin = 9.e33
      yMax = -9.e33
      do i = 1, NatMol + NatSpi
         do j=1,3
            xyzPov(j,i) = xyzPov(j,i) * scalapov
         enddo
         if (RS(i) .gt. 0) then
            if (xmin.gt.xyzPov(1,i)) xmin = xyzPov(1,i)
            if (xMax.lt.xyzPov(1,i)) xMax = xyzPov(1,i)
            if (ymin.gt.xyzPov(2,i)) ymin = xyzPov(2,i)
            if (yMax.lt.xyzPov(2,i)) yMax = xyzPov(2,i)
         end if
      enddo
      zmin = zmin -0.01
      zMax = zMax + 0.01
!
      opi2 = 8. * PI * PI
      if (nRadType.gt.1 .or. iPlotType.eq.ELLIPSOIDS) then
         radmed = 0.
         nr = 0
         do k=1, NatMol
            i=iEqui(k)
            if (RS(i) .gt. 0.0 .and. nzTot(i) .ne. 0) then
               if (nRadType .eq. 2) then
                  raa = xyzs(4, i)
               else
                  bfaci = abs(bfac(iEqui(i)))
                  if (bfaci.lt.0.01) then
                      bfaci = 0.01
                  endif
                  raa = sqrt(bfaci / opi2)
               end if
               radmed = radmed + raa
               nr = nr + 1
            end if
         enddo
         radmed = (radmed / nr)
      endif
!
!-- calcolo della distanza media di legame
!
      kxyz = 2
      call AveBondDist(distmed, amed, kxyz)
!
      a = scalapov *  0.2433333 ! raggio del carbonio
      if (amed.gt.0.0) then
          distmed = distmed / amed
          raggio  = distmed / 6.0
      else
          raggio = a / 3.0
      endif
      RaggioRod = raggio
      Wire = a / 7.0 ! 0.02
      if (iPlotType.eq.STICKS) then
          RaggioCyl = Wire
          RaggioSph = RaggioCyl
      elseif (iPlotType.eq.RODS) then
          RaggioCyl = RaggioRod
          RaggioSph = RaggioCyl
      elseif (iPlotType.eq.SIMPLE) then
          RaggioCyl = RaggioRod / 2
          RaggioSph = RaggioCyl * 2
      elseif (iPlotType.eq.VAN_DER_WAALS) then
          RaggioSph = 1.7 * scalapov ! raggio (Van derWaals) del carbonio
      else          
          RaggioCyl = a / 3.0
      endif
!
      xmin = xminSav
      ymin = yminSav
      xmax = xmaxSav
      ymax = ymaxSav

      return
      end
!----------------------------------------------------------------------
      subroutine DisLegPov(ileg, N1, N2, kCol0, kCol1, kCol2,
     *                     iPlt1,iPlt2)
      USE General
      USE Molcom
!
      dimension rgb1(3), rgb2(3)
      dimension x1(3), x2(3), x3(3)
!
      x1(1:3) = xyzPov(1:3,N1)
      x2(1:3) = xyzPov(1:3,N2)
      ifSolid = 1
      if (LE(3,ileg) == 3) then   ! legame idrogeno
          if (ifDrHBond ==1) then
              ifSolid = -1
              call DrawHBondPov(N1, N2)
          endif
          return
      else
          jPlotType1 = SinglePlotType(N1)
          jPlotType2 = SinglePlotType(N2)
          if ((jPlotType1 <= SIMPLE) .or. (jPlotType2 <= SIMPLE)) then
               ifSolid = 0
          endif
      endif
      if (ifSolid == 0) then
          kCol1 = iCol(N1)
          kCol2 = iCol(N2)
          call getRGB(kCol1, rgb1)
          call getRGB(kCol2, rgb2)
          do i=1,3
             x3(i) =  ( x2(i) + x1(i) ) / 2.0
          enddo
          call Cilindro(ifSolid, N1, N2, x1, x3, 0)
          call Cilindro(ifSolid, N2, N1, x2, x3, 0)
      else
          iC = color_BONDS
          call getRGB(iC, rgb1)
          if (iPlt1 /= ELLIPSOIDS .and. iPlt2 /= ELLIPSOIDS) then 
              call Cilindro(ifSolid, N1, N2, x1, x2, 0)
          else
              do i=1,3
                 x3(i) =  ( x2(i) + x1(i) ) / 2.0
              enddo
              if (iPlt1 == ELLIPSOIDS) then 
                  call Cilindro(ifSolid, N1, N2, x1, x3, 1)
              else
                  call Cilindro(ifSolid, N1, N2, x1, x3, 0)
              endif
              if (iPlt2 == ELLIPSOIDS) then 
                  call Cilindro(ifSolid, N2, N1, x2, x3, 1)
              else
                  call Cilindro(ifSolid, N2, N1, x2, x3, 0)
              endif
          endif
      endif
!
      return
      end
! -----------------------------------------------------------------
      subroutine DrawHBondPov(N1, N2)
      USE General
      USE Molcom
!
      dimension dxyz(3), xstart(3), x1(3), x2(3), rgbv(3)
      character*17 bond
!
      write(bond,'(a8,1h-,a8)') LAB(N1), LAB(N2)
      call NoBlanks(bond,nchar)
      write(jhost,10) bond(1:nchar)
!
      call getRGB(color_CELL, rgbv)
!
      tratto = Wire * 5
!
      xstart(1:3) = xyzPov(1:3,N1)
      dxyz(1:3) = xyzPov(1:3,N2) - xyzPov(1:3,N1)
      d = sum(dxyz*dxyz)
      d = sqrt(d)
      if (d > 0) then
          ntratti = d / tratto
          dxyz = dxyz / float(ntratti)
          x1(1:3) = xyzPov(1:3,N1) + 0.5*dxyz(1:3)
          do i=1, ntratti/2
             x2(1:3) = x1(1:3) + dxyz(1:3)
             write(jhost,30) x1, x2,  Wire/2, rgbv
             x1(1:3) = x1(1:3) + 2*dxyz(1:3)
          enddo
      endif
   10 format('// Hydrogen bond ',a)
   30 format(
     *'cylinder{ <',2(f12.6,1h,),f12.6,'>,                      ',/,
     *'          <',2(f12.6,1h,),f12.6,'>,',f12.6,'             ',/,
     *50h       texture { pigment {                          ,/,
     *7x,'color rgb <',2(f12.6,1h,),f12.6,'>  }',/,
     *'finish { Surface } } } ')

!
      return
      end
! -----------------------------------------------------------------
      subroutine DisePallePov(jPlotType, N1, iColor)
      USE General
      USE Molcom
!
      dimension x1(3)
!
      x1(1:3) = xyzPov(1:3,n1)
      call Sfera(jPlotType, N1, x1, iColor)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine InitPov(zlocation)
      USE General
      USE Molcom
!
      common /movediamo3/ nplt, iplt(9800), nlegami(9800)
      dimension rgb1(3)
      character*12 ortho
      character*80 str
!
      call sirdate(str,icod)
!gl!  write(Titolo,'(20a4)') itle
      call shift(Titolo, nchar)
      write(jhost,5) str(1:icod),ProgName(1:lProgName),Titolo(1:nchar)
      write(jhost,6) 
!
!-- inizializzazione iplt = ( -1, 0, 1) = (proibito/da disegnare/gia' disegnato)
!--       iplt(i) = -1 (proibito)
!--       iplt(i) =  0 (da disegnare)
!--       iplt(i) =  1 (gia' disegnato)
!
      iplt(1:NatMol) = 0
!
!-- colori dei Triangoli (poliedri)
!
      do i=1,20
         j = i
         call getRGB(j, rgb1)
         if (j.le.9) then
             write(jhost,7) j,rgb1
         else if(j.le.99) then
             write(jhost,70) j,rgb1
         else
             write(jhost,700) j,rgb1
         endif
      enddo

!
!-- colori degli atomi
!
      do i=1, nk
         j = no(i) + N_OBJS
         call getRGB(j, rgb1)
         if (j.le.9) then
             write(jhost,7) j,rgb1
         else if(j.le.99) then
             write(jhost,70) j,rgb1
         else
             write(jhost,700) j,rgb1
         endif
      enddo
!
!-- colore della cella
!
      call getRGB(color_CELL, rgb1)
      write(jhost,8) rgb1
!
!-- colore dei legami
!
      iC = color_BONDS
      call getRGB(iC, rgb1)
      write(jhost,9) rgb1
!
!-- colore degli spicchi
!
      rgb1(:) = 0.9
      write(jhost,15) rgb1
!
!-- colore nero
!
      rgb1(:) = 0.0
      write(jhost,16) rgb1
!
!-- definizione delle caratteristiche della superficie
!
      if (iPlotType /= VAN_DER_WAALS) then
          write(jhost,11) 
      else
          write(jhost,12) 
      endif
!
      write(jhost,30) RaggioSph, RaggioCyl, Wire 
      write(jhost,*)
      if (jBackGround.eq.0) then
          write(jhost,10)
          ambient =' ambient 0.8'
      else
          write(jhost,20)
          ambient =' ambient 0.1'
      endif
      if (ifPersp.eq.0) then
          ortho = 'orthographic'
      else
          ortho = '            '
      endif
!	    ortho = 'perspective'
      write(jhost,40) ortho, zlocation
      if (iPlotType == RODS) then
          write(jhost,55)
      elseif (iPlotType == VAN_DER_WAALS) then
          write(jhost,56)
      else
          write(jhost,55)
      endif
!
    5 format('//',/,
     *       '// On ',a,/,
     *       '// PovRay input file produced by ',a,' for:',/,
     *       '// ',a,/,'//')
    6 format(
     *30h#include "colors.inc"         ,/,
     *30h#include "stones.inc"         )
    7 format('#declare Color_00',i1,'      = rgb < ',
     *       2(f7.4,2h, ),f7.4,' >;')
   70 format('#declare Color_0',i2,'      = rgb < ',
     *       2(f7.4,2h, ),f7.4,' >;')
  700 format('#declare Color_',i3,'      = rgb < ',
     *       2(f7.4,2h, ),f7.4,' >;')
    8 format('#declare Color_Wire    = rgb < ',
     *       2(f7.4,2h, ),f7.4,' >;')
    9 format('#declare Color_Bond    = rgb < ',
     *       2(f7.4,2h, ),f7.4,' >;')
   15 format('#declare Color_Slice   = rgb < ',
     *       2(f7.4,2h, ),f7.4,' >;')
   16 format('#declare Color_Black   = rgb < ',
     *       2(f7.4,2h, ),f7.4,' >;')
   11 format('#declare Surface =                               ',/,
     *       ' finish {                                ',/,
     *       '         ambient < 0.5 0.5 0.5 1 1 >    ',/,
     *       '         phong 1 phong_size 10          ',/,
     *       '        }                                '
     *)
   12 format('#declare Surface =                               ',/,
     *       ' finish {                                ',/,
     *       '         ambient < 0.5 0.5 0.5 1 1 >    ',/,
     *       '         phong 0.5 phong_size 80          ',/,
     *       '        }                                '
     *)
   10 format('background { color Black }')
   20 format('background { color White }')
!
   30 format(
     *'#declare RadiusSph  = ',f10.3,'; // Radius of the Sphere',/,
     *'#declare RadiusCyl  = ',f10.3,'; // Radius of the Cylinder',/,
     *'#declare Wire       = ',f10.3,'; // Wire thickness')
!
   40 format(
     *   'camera { ',a12,'         ',/,
     *   '   location <0, 0,',f6.2,'>    ',/,
     *   '   look_at  <0, 0, 0>    ',/,
     *   '   up y                   ',/,
     *   '   right -4/3*x     // un valore negativo -> mano destra',/,
     *   '        }                      ')
!
   50 format(
     *   'light_source {                ',/,
     *   '              < 6, 6, 6>     ',/,
     *   '              color White     ',/,
     *   '             }                ')
!
   55 format(
     *   'light_source {                ',/,
     *   '              <6, 6, 6>      ',/,
     *   '              color White     ',/,
     *   '             }                ')
   56 format(
     *   'light_source {                ',/,
     *   '              <6, 6, 6>      ',/,
     *   '              color White     ',/,
     *   '             }                ')
!
   60 format(
     *'plane { z, 30 ',/,
     *'       texture {     ',/,
     *'                T_Stone7      ',/,
     *'                pigment {     ',/,
     *'                         octaves 3  ',/,
     *'                         rotate 90*z',/,
     *'                        }    ',/,
     *'                finish { reflection 0.10 }',/,
     *'                }',/,
     *'      }'
     *)
!
      return
      end

! -----------------------------------------------------------------
      subroutine Cilindro(ifSolid, NN1, NN2, x1, x2, ifDifference)
      USE General
      USE Atomi
      USE Molcom
!
      dimension BTPov(3,3),eigVal(3),semiassi(3)
      dimension x1(3), x2(3), xx(3), scala(3)
      character*3 a3
      character*17 bond, RaggioPov
!
      distanza = sum( x1*x1 + x2*x2 )
      if (distanza > 0.001) then
          write(bond,'(a8,1h-,a8)') LAB(NN1), LAB(NN2)
          call NoBlanks(bond,nchar)
          if (ifSolid == 0) then   ! STICKS & SIMPLE
              k = iCol(NN1) ! + 1
              write(a3,'(i3)') k
              if (k.le.9) then
                  a3(1:2) = '00'
              else if (k.le.99) then
                  a3(1:1) = '0'
              endif
              if (iPlotType == RODS) then 
                  write(jhost,30) bond(1:nchar), x1, x2, a3
              else
                  write(jhost,10) bond(1:nchar), x1, x2, a3
              endif
          else
              if (ifHydro == 1 .and. 
     *               (nzTot(NN1) == 1 .or. nzTot(NN2) == 1)) then
                  RaggioPov = 'Wire'
              else              
                  RaggioPov = 'RadiusCyl'
              endif
              if (ifDifference == 0) then
                  write(jhost,20) bond(1:nchar), x1, x2, RaggioPov
              else
                  xx(1:3) = xyzPov(1:3,NN1)
                  N1 = iEqui(NN1)
                  call RotEllPov(N1, eigVal, BTPov)
                  semin = 9999
                  do i=1,3
                     if (semin.gt.eigVal(i)) then
                         semin =  eigVal(i)
                     endif
                  enddo
                  do i=1,3
                     semiassi(i) = eigVal(i) * scalapov
                     scala(i) = 1.0 * eigVal(i) / semin
                  enddo
                  semin = semin * scalapov
                  write(jhost,40) bond(1:nchar), x1, x2, RaggioPov,
     *                            semin, (scala(j),j=1,3), 
     *                            ((BTPov(i,j),i=1,3),j=1,3),
     *                            (xx(i),i=1,3)
              endif
          endif
      endif
!
   10 format('// Bond ',a,/,
     *'cylinder{ <',2(f12.6,1h,),f12.6,'>,               ',/,
     *'          <',2(f12.6,1h,),f12.6,'>, Wire          ',/,
     *7x,'texture { pigment { color Color_',a3,' } ',
     *'finish { Surface } } } ')
   20 format('// Bond ',a,/,
     *'cylinder{ <',2(f12.6,1h,),f12.6,'>,               ',/,
     *'          <',2(f12.6,1h,),f12.6,'>, ',a            ,/,
     *7x,'texture { pigment { color Color_Bond  } ',
     *'finish { Surface } } } ')
   30 format('// Bond ',a,/,
     *'cylinder{ <',2(f12.6,1h,),f12.6,'>,               ',/,
     *'          <',2(f12.6,1h,),f12.6,'>, RadiusCyl     ',/,
     *7x,'texture { pigment { color Color_',a3,' } ',
     *'finish { Surface } } } ')
   40 format('// Bond ',a,/,
     *'difference{                                      ' ,/,  
     *'  cylinder{ <',2(f12.6,1h,),f12.6,'>,             ',/,
     *'            <',2(f12.6,1h,),f12.6,'>, ',a          ,/,
     *'    texture { pigment { color Color_Bond  }       ',/,
     *'    finish { Surface } } }'                        ,/,
     *'  sphere{ <0, 0, 0 >,',f6.3                        ,/,  
     *'    scale <',2(f12.6,1h,),f12.6,'>                ',/,
     *'    matrix <',3(f12.6,1h,)                         ,/,
     *'           '  ,3(f12.6,1h,)                        ,/,
     *'           '  ,3(f12.6,1h,)                        ,/,
     *'           '  ,2(f12.6,1h,),f12.6,'>              ',/,
     *'    texture { pigment {                           ',/,
     *'              color Color_Bond               }   ',/,
     *'              finish { ambient < 0.5 0.5 0.5 1 1 >',/,
     *'              phong 1 phong_size 10 }}            ',/,
     *'  }                                               ',/
     *'}                                                 ',/
     *)
!
      return
      end
! -----------------------------------------------------------------
      subroutine CilindroCont(x1, x2, iColor)
      USE General
      USE Molcom
!
      dimension x1(3), x2(3)
      character*3 a3
!
      k = iColor + 1
      write(a3,'(i3)') k
      if (k.le.9) then
          a3(1:2) = '00'
      else if (k.le.99) then
          a3(1:1) = '0'
      endif
      write(jhost,10) x1, x2, Wire/3.0, a3
   10 format(
     *'cylinder{ <',2(f12.6,1h,),f12.6,'>,                      ',/,
     *'          <',2(f12.6,1h,),f12.6,'>,',f12.6,'             ',/,
     *7x,'texture { pigment { color Color_',a3,' } ',
     *'finish { Surface } } } ')
!
      return
      end
! -----------------------------------------------------------------
      subroutine CilindroCella(x1, x2, rgbv)
      USE General
      USE Molcom
!
      dimension x1(3), x2(3), rgbv(3)
!
      write(jhost,10) x1, x2, rgbv
   10 format('// Cell ',/,
     *50hcylinder{                                            ,/,
     *7x,'<',2(f12.6,1h,),f12.6,'>,',/,
     *7x,'<',2(f12.6,1h,),f12.6,'>, Wire ',/,
     *50h       texture { pigment {                          ,/,
     *7x,'color rgb <',2(f12.6,1h,),f12.6,'>  }',/,
     *' finish { ambient < 0.5 0.5 0.5 1 1 > ',
     *' phong 1 phong_size 10}}',/,
     *50h      }                                               )
!
      return
      end
! -----------------------------------------------------------------
      subroutine Sfera(jPlotType, N1, xx, iColor)
      USE General
      USE Molcom
!
      dimension xx(3),rgbv(3)
      character*3 a3
!
      k = iCol(N1) !  + 1
      write(a3,'(i3)') k
      if (k.le.9) then
          a3(1:2) = '00'
      else if (k.le.99) then
          a3(1:1) = '0'
      endif
      Raggio = CalcolaRaggio(N1)
      if (jPlotType == STICKS) then
          write(jhost,10) LAB(N1), (xx(j),j=1,3), Wire, a3
      elseif (jPlotType == RODS) then
          write(jhost,100) LAB(N1), (xx(j),j=1,3), a3
      elseif (jPlotType == SIMPLE) then
          write(jhost,10) LAB(N1), (xx(j),j=1,3), Wire * 3.0, a3
      elseif (jPlotType == STICKS_N_BALLS) then
          write(jhost,10) LAB(N1), (xx(j),j=1,3), Raggio, a3
      elseif (jPlotType == BUBBLES) then
          call getRGB(kBolla, rgbv)
          write(jhost,25) LAB(N1), (xx(j),j=1,3), Raggio, rgbv, ambient
      elseif (jPlotType == SHADING) then
          write(jhost,10) LAB(N1), (xx(j),j=1,3), Raggio, a3
      elseif (iPlotType.eq.VAN_DER_WAALS) then
          write(jhost,10) LAB(N1), (xx(j),j=1,3), Raggio, a3
      elseif (jPlotType == ELLIPSOIDS) then
          call EllissePov(N1,xx, a3,iColor)
      endif
   10 format('// Atom ',a8,/,
     *'sphere{ <',2(f12.6,1h,),f12.6,'>, ',f6.3,     /,
     *7x,'texture { pigment { color Color_',a3,' } ',
     *'finish { Surface } } } ')
!
   20 format('// Atom ',a8,/,
     *'sphere { ',/,
     *7x,'<',2(f12.6,1h,),f12.6,'>,',f6.3,/,
     *'texture {',/,
!     *7x,'    pigment { rgbf <',2(f12.6,1h,),f12.6,'> }',/,
     *'pigment { rgbf <0.98, 1.0, 0.99, 0.85> }',/,
     *'finish {',/,a,/,
     *'   diffuse 0.1',/,
     *'   reflection .10',/,
     *'   specular 1',/,
     *'   roughness .001',/,
     *'#if (version<3.1)',/,
     *' ior 1.5',/,
     *'#end',/,
     *'}}}'
     *)
   25 format('// Atom ',a8,/,
     *'sphere { ',/,
     *7x,'<',2(f12.6,1h,),f12.6,'>,',f6.3,/,
     *'texture {',/,
     *'pigment { rgbf <',2(f12.6,1h,),f12.6,', 0.65> }',/,
!    *'pigment { rgbf <0.98, 1.0, 0.99, 0.85> }',/,
     *'finish {',/,a,/,
     *'   diffuse 0.1',/,
     *'   reflection .10',/,
     *'   specular 1',/,
     *'   roughness .001',/,
     *'#if (version<3.1)',/,
     *' ior 1.5',/,
     *'#end',/,
     *'}}}'
     *)
   30 format(
     *'sphere{ <',2(f12.6,1h,),f12.6,'>, RadiusSph             ',/,
     *'       texture {                                        ',/,
     *'          pigment { color rgb <',2(f7.4,1h,),f7.4,'>  } ',/,
     *'             finish { ambient < 0.5 0.5 0.5 1 1 >       ',/,
     *'                      phong 1 phong_size 10 }           ',/,
     *'               }                                        ',/,
     *'      }                                         ')
   40 format('// Atom ',a8,/,
     *'sphere{ <',2(f12.6,1h,),f12.6,'>, ',f6.3,     /,
     *7x,'texture { pigment { color Color_',a3,' }  } } ')
  100 format('// Atom ',a8,/,
     *'sphere{ <',2(f12.6,1h,),f12.6,'>, RadiusSph             ',/,
     *7x,'texture { pigment { color Color_',a3,' } ',
     *'finish { Surface } } } ')
!
      return
      end
!----------------------------------------------------------------------
      subroutine SferaCella(xx, rgbv)
      USE General
      USE Molcom
!
      dimension xx(3),rgbv(3)
!
      write(jhost,10) (xx(j),j=1,3), rgbv
   10 format('// Cell ',/,
     *'sphere{                                         ',/,
     *'       <',2(f12.6,1h,),f12.6,'>, Wire           ',/,
     *'       texture { pigment {                      ',/,
     *'       color rgb <',2(f12.6,1h,),f12.6,'>  }    ',/,
     *'       finish { ambient < 0.5 0.5 0.5 1 1 >     ',/,
     *'       phong 1 phong_size 10 }}                 ',/,
     *'      }                                         ')
!
      return
      end
! -----------------------------------------------------------------
      subroutine EllissePov(NN1, xx, a3,iColor)
      USE General
      USE Atomi
      USE Molcom
!
      dimension xx(3),rgbv(3),scala(3), autovettori(3)!,zero(3)
      character*3 a3
      dimension BTPov(3,3),eigVal(3),semiassi(3),isePov(3),uno(3)   !pollo
      dimension scala1(3), scala2(3) ,scala3(3)
!
      zero = 0.0
      scala1(:) = 1.0
      scala2(:) = 1.0
      scala3(:) = 1.0
      N1 = iEqui(NN1)
!pollo
      if (n1 /= nn1) then
         ehh = 1
      end if
!      call RotEllPov(N1, eigVal, BTPov)   !pollo
      call RotEllPov(NN1, eigVal, BTPov)   !pollo
      uno(:) = 1.2
      semin = 9999
      do i=1,3
         if (semin.gt.eigVal(i)) then
             semin =  eigVal(i)
         endif

      enddo
      do i=1,3
         semiassi(i) = eigVal(i) * scalapov * 1.3
         scala(i) = 1.0 * eigVal(i) / semin
      enddo
      semin = semin * scalapov * 1.3
      d = semin / 15.0
      scala1(:) = scala(:)
      scala2(:) = scala(:)
      scala3(:) = scala(:)
      scala1(1) = 1
      scala2(2) = 1
      scala3(3) = 1

      call ScegliSpicchio(N1, BTPov, isePov)

      semiassi(1:3) = semiassi(1:3) * isePov(1:3)
!
      if (QualeEllisse == 1) then
          write(jhost,111) LAB(N1), semin, (scala(j),j=1,3), a3,
     *                     -d, zero,zero, d, zero,zero,semin,scala1,
     *                      zero,-d,zero,  zero,d,zero,semin,scala2,
     *                     -zero,zero,-d, zero,zero,d,semin,scala3
          write(jhost,1117) semiassi, 
     *                     ((BTPov(i,j),i=1,3),j=1,3),(xx(i),i=1,3)
      elseif (QualeEllisse == 2) then
          write(jhost,113) LAB(N1), semin, (scala(j),j=1,3), a3,
     *                     -d, zero,zero, d, zero,zero,semin,scala1,
     *                      zero,-d,zero,  zero,d,zero,semin,scala2,
     *                     -zero,zero,-d, zero,zero,d,semin,scala3
          write(jhost,1131) ((BTPov(i,j),i=1,3),j=1,3),(xx(i),i=1,3)
      else
          write(jhost,112) LAB(N1), semin, (scala(j),j=1,3), 
     *                     ((BTPov(i,j),i=1,3),j=1,3),(xx(i),i=1,3), a3
      endif
!
  113 format('// Atom ',a8,/,
     *'union{  ',/,
     *'  sphere{ <0, 0, 0 >,',f12.6                       ,/,  
     *'    scale <',2(f12.6,1h,),f12.6,'>               ',/,
     *'    texture { pigment {                          ',/,
     *'              color Color_',a3,'              }   ',/,
     *'              finish { ambient < 0.5 0.5 0.5 1 1 >',/,
     *'              phong 1 phong_size 10 }}            ',/,
     *'  }                                               ',/
     *'  cylinder{ <',2(f12.6,1h,),f12.6,'>,               ',/,
     *'            <',2(f12.6,1h,),f12.6,'>,',f12.6         ,/,
     *'      scale <',2(f12.6,1h,),f12.6,'>               ',/,
     *'         texture { pigment {Color_Black}}}       ',/,
     *'  cylinder{ <',2(f12.6,1h,),f12.6,'>,               ',/,
     *'            <',2(f12.6,1h,),f12.6,'>,',f12.6         ,/,
     *'      scale <',2(f12.6,1h,),f12.6,'>               ',/,
     *'           texture { pigment {Color_Black}}}       ',/,
     *'  cylinder{ <',2(f12.6,1h,),f12.6,'>,               ',/,
     *'            <',2(f12.6,1h,),f12.6,'>,',f12.6         ,/,
     *'      scale <',2(f12.6,1h,),f12.6,'>               ')    !    ,/,
 1131 format('           texture { pigment {Color_Black}}}',/,
     *'matrix <',3(f12.6,1h,)                             ,/,
     *'        ',3(f12.6,1h,)                             ,/,
     *'        ',3(f12.6,1h,)                             ,/,
     *'        ',2(f12.6,1h,),f12.6,'>                   ',/,
     *'}                                               ',/
     *)

  111 format('// Atom ',a8,/,'union{  ',/,'  difference{ ' ,/,
     *'    union{  ',/,
     *'      sphere{ <0, 0, 0 >,',f12.6                       ,/,  
     *'           scale <',2(f12.6,1h,),f12.6,'>               ',/,
     *'           texture { pigment { color Color_',a3,'}      ',/,
     *'                     finish { ambient < 0.5 0.5 0.5 1 1 >',/,
     *'                     phong 1 phong_size 10 }}            ',/,
     *'      }                                               ',/
     *'      cylinder{ <',2(f12.6,1h,),f12.6,'>,             ',/,
     *'            <',2(f12.6,1h,),f12.6,'>,',f12.6       ,/,
     *'        scale <',2(f12.6,1h,),f12.6,'>              ',/,
     *'         texture { pigment {Color_Black}}}        ',/,
     *'      cylinder{ <',2(f12.6,1h,),f12.6,'>,             ',/,
     *'            <',2(f12.6,1h,),f12.6,'>,',f12.6       ,/,
     *'        scale <',2(f12.6,1h,),f12.6,'>              ',/,
     *'           texture { pigment {Color_Black}}}      ',/,
     *'      cylinder{ <',2(f12.6,1h,),f12.6,'>,             ',/,
     *'            <',2(f12.6,1h,),f12.6,'>,',f12.6       ,/,
     *'        scale <',2(f12.6,1h,),f12.6,'>              ',/,
     *'           texture { pigment {Color_Black}}}      ',/,'    } ')
 1117 format(
     *'    box{ <0, 0, 0 >,                                ',/,  
     *'         <',2(f12.6,1h,),f12.6,'>                   ',/,
     *'        texture { pigment {color Color_Slice }    ',/,
     *'                 finish { ambient < 0.4 0.4 0.4 1 1 > }}  ',/,
     *'    }                                               ',/,
     *'  }                                               ',/,
     *'matrix <',3(f12.6,1h,)                        ,/,
     *'        '    ,3(f12.6,1h,)                      ,/,
     *'        '    ,3(f12.6,1h,)                      ,/,
     *'        '    ,2(f12.6,1h,),f12.6,'>            ',/,
     *'}                                                 ',/
     *)
  112 format('// Atom ',a8,/,
     *'  sphere{ <0, 0, 0 >,',f12.6                       ,/,  
     *'     scale <',2(f12.6,1h,),f12.6,'>               ',/,
     *'     matrix <',3(f12.6,1h,)                        ,/,
     *'           '  ,3(f12.6,1h,)                          ,/,
     *'           '  ,3(f12.6,1h,)                          ,/,
     *'           '  ,2(f12.6,1h,),f12.6,'>                ',/,
     *'     texture { pigment {                          ',/,
     *'              color Color_',a3,'              }   ',/,
     *'              finish { ambient < 0.5 0.5 0.5 1 1 >',/,
     *'              phong 1 phong_size 10 }}            ',/,
     *'  }                                               ',/
     *)

!
      return
      end
c----------------------------------------------------------------
      subroutine RotEllPov(NN1, eigVal, W)

      USE General
      USE Atomi
      USE Molcom
!
      dimension W(3,3)
      dimension BPov(3,3), BPovTot(3,3), BPovInv(3,3)
      dimension B1Inv(3,3), B2Inv(3,3)
      dimension el(3,3), eigVal(3), t3(3,3)
      dimension elb(3,3)
      dimension tr(3,3), Pro(3,3)

      nMin = 1

      N1 = iEqui(NN1)

      do i = 1, 3
         do j = 1, 3
            el(i, j) = Ell(i, j, N1)
         end do
      end do
      if (N1 == NN1) then
         VecX = CD(1,nMin,N1)
         VecY = CD(2,nMin,N1)
         VecZ = CD(3,nMin,N1)
      else
!         if (nOpEq(NN1)/1000 .ne. 1) then
            call EllEqui(el, nOpEq(NN1))
            elb(1:3, 1:3) = el(1:3, 1:3)
            call Autov(elb, eigVal, t3, iCod)
            VecX = t3(1,1)
            VecY = t3(2,1)
            VecZ = t3(3,1)
!         end if
      end if
!trova il vettore normale al piano  x _ semiasse n. 1
!      c(1) = a(2)*b(3) - a(3)*b(2)
!      c(2) = a(3)*b(1) - a(1)*b(3)
!      c(3) = a(1)*b(2) - a(2)*b(1)

      nRot = 1
      nRTot = 1
      VMod = VecZ ** 2 + VecY ** 2
      V1Mod = SQRT(VMod + VecX ** 2)
      VMod = SQRT(VMod)
      s = VMod / V1Mod
      if (s .lt. .999) then
          Ang = ATAN(s / SQRT(1 - s * s))
          Ang = Ang * rtod
      else
          Ang = 90
      end if
      if (VecX .lt. 0) then
         Ang = 180 - Ang
      end if
      RK(1) = Ang
      RK(2) = 4
      RK(3) = 1

      vx = 0
      vy = VecZ
      vz = -VecY

      VV(1, 1) = vx
      VV(1, 2) = vy
      VV(1, 3) = vz
      if (abs(vy).lt.0.00001 .AND. abs(vz).lt.0.00001) then
          VV(1, 1) = 1
      end if

!      if (nOpEq(n1)/1000 .ne. 1) then
!         call EllEqui(el, nOpEq(n1))
!      end if

      do i=1,3
         do j=1,3
            BPovTot(i,j) = 0.
            if (i == j) then
               BPovTot(i,j) = 1.
            end if
         end do
      end do

      call CombRot (BPovTot)
      call InvMat(BPovTot,B1Inv , iCod)

! ---
      call Trasp(BPovTot, tr)
      call MoltMatMat(BPovTot, el, Pro)
      call MoltMatMat(Pro, tr, el)
! ---
      do i = 1, 3
         do j = 1, 3
            elb(i, j) = el(i, j)
         end do
      end do
      call Autov(elb, eigVal, t3, iCod)

      if (N1 /= NN1) then
       	vaffa = 1
      end if

!      if (lab(N1)(1:2) == 'C8') then
!         do i=1,3
!            do j=1,3
!               w(i,j) = BPov(i,j)
!            end do
!         end do
!         return
!      end if

      VecX = t3(1,2)
      VecY = t3(2,2)
      VecZ = t3(3,2)
      nRot = 1 !2
      nRTot = 1 !2

      if (abs(VecY) > 0.0001) then
         Ang1 = 4.*atan(1.)-ATAN(VecZ/VecY)
         Ang1 = Ang1 * rtod
      else
          Ang1 = 90
      end if

!      if (VecX .lt. 0) then
!         Ang = 180 - Ang
!      end if

      RK(1) = Ang1
      RK(2) = 1
      RK(3) = 1
 

      do i=1,3
         do j=1,3
            BPov(i,j) = 0.
            if (i == j) then
               BPov(i,j) = 1.
            end if
         end do
      end do

      call CombRot (BPov)
      call InvMat(BPov,B2Inv , iCod)
! ---
      call Trasp(BPov, tr)
      call MoltMatMat(BPov, el, Pro)
      call MoltMatMat(Pro, tr, el)
! ---

      do i = 1, 3
         do j = 1, 3
            elb(i, j) = el(i, j)
         end do
      end do
      call Autov(elb, eigVal, t3, iCod)

      do i=1,3
         eigVal(i) = 1./sqrt(eigVal(i))  ! valori dei 3 semiassi
      end do

      if (N1 /= NN1) then
       	vaffa = 1
      end if

!      call CombRot (BPovTot)
!      call InvMat(BPovTot,BPovInv , iCod)

      call MoltMatMat(B1Inv, B2Inv, BPovInv)

!      return
 
      call MoltMatMat(BTot, BPovInv, W)

      return
      end

!----------------------------------------------------------------
      subroutine ScegliSpicchio(N1,BTPov,isePov)

      USE Atomi
!
      USE Molcom
!
      dimension e(3)
      dimension rj(3), f(3)
      dimension isPov(3),isePov(3)

      dimension BTPov(3,3)
      dimension cdir(3,3), ddir(3,3)

      data  cdir /1., 0., 0., 0., 1., 0., 0., 0., 1./

      dMax = -9999
      do i1 = -1, 1, 2
         isPov(1) = i1
         do i2 = -1, 1, 2
            isPov(2) = i2
            do i3= -1, 1, 2
               isPov(3) = i3
               do k1=1, 3
                  rj(1:3) = cdir(1:3,k1) * isPov(k1)
        

! servira' mai?
!         if (nOpEq(N1)/1000 .ne. 1) then
!            call CDEqui(rj, nOpEq(N1))
!         end if

                  call MoltMatVec(BTPov, rj, f)
                  ddir(1:3,k1) = f(1:3)
               end do
               do i=1,3
                  e(i) = ddir(i,1) + ddir(i,2) + ddir(i,3)
               end do
               if (e(3) > dMax) then
                  isePov(1:3) = isPov(1:3)
                  dMax = e(3)
               end if
            end do
         end do
      end do

      return
      end
!-----------------------------------------------------------------------
      function CalcolaRaggio(IJ)
      USE General
      USE Atomi
      USE Molcom
!
      if (iPlotType.eq.VAN_DER_WAALS) then
          iz1 = nzTot(IJ)
          if (iz1 > 0) then
              CalcolaRaggio = radii(iz1,2)
          else
              CalcolaRaggio = radii(1,2) / 2
          endif
      elseif (nRadType .eq. 1) then
          CalcolaRaggio = RS(IJ)
      elseif (nRadType .eq. 2) then
          if (IJ.le.NatMol) then
              IJJ = iEqui(IJ)
              CalcolaRaggio =  abs(RS(1)) * (xyzs(4, IJJ) / radmed)
          else
              CalcolaRaggio = RS(IJ)
          endif
      elseif (nRadType .eq. 3) then
          if (IJ.le.NatMol) then
              IJJ = iEqui(IJ)
              bfacij = abs(bfac(IJJ))
              if (bfacij.lt.0.01) bfacij = 0.01
              CalcolaRaggio =  sqrt(bfacIJ / opi2)
          else
              CalcolaRaggio = RS(IJ)
          endif
      end if
!
      CalcolaRaggio = CalcolaRaggio * scalapov
      if (iPlotType.eq.BUBBLES) then
          CalcolaRaggio = 1.5 * CalcolaRaggio
      endif

! 
      return
      end
!----------------------------------------------------------------------
      subroutine DisegnaCellaPov()
      USE Atomi
      USE Molcom
!
      dimension rgb1(3), kSpi(12,2), x1(3), x2(3)
!
      last = NatMol
      kSpi( 1,1) = last + 1
      kSpi( 1,2) = last + 4
      kSpi( 2,1) = last + 1
      kSpi( 2,2) = last + 5
      kSpi( 3,1) = last + 1
      kSpi( 3,2) = last + 6
      kSpi( 4,1) = last + 2
      kSpi( 4,2) = last + 4
      kSpi( 5,1) = last + 2
      kSpi( 5,2) = last + 5
      kSpi( 6,1) = last + 2
      kSpi( 6,2) = last + 7
      kSpi( 7,1) = last + 3
      kSpi( 7,2) = last + 4
      kSpi( 8,1) = last + 3
      kSpi( 8,2) = last + 6
      kSpi( 9,1) = last + 3
      kSpi( 9,2) = last + 7
      kSpi(10,1) = last + 8
      kSpi(10,2) = last + 5
      kSpi(11,1) = last + 8
      kSpi(11,2) = last + 6
      kSpi(12,1) = last + 8
      kSpi(12,2) = last + 7
!
      RaggioCyl = Wire
      RaggioSphSav = RaggioSph
      RaggioSph = Wire
      call getRGB(color_CELL, rgb1)
!
      do j=1,12
         j1 = kSpi(j,1)
         j2 = kSpi(j,2)
         x1(1:3) = xyzPov(1:3,j1)
         x2(1:3) = xyzPov(1:3,j2)
         call CilindroCella(x1, x2, rgb1)
      enddo
      do i=1,8
         j = last + i
          x1(1:3) = xyzPov(1:3,j)
          call SferaCella(x1, rgb1)
      enddo
      RaggioSph = RaggioSphSav
!
      return
      end
!----------------------------------------------------------------------
      subroutine PlotContourPov()
      USE General
      USE Molcom
      USE Contorno
      USE PhaseModule
!
      real tria(3,10)
      integer Code
!
      do jlev = nLevels(2), 1, -1
         lev = 5 - jlev + 1
         if (ifLevel(lev).gt.0) then
             ic = LevelCol(lev)
             ii = 1
             do while( ii <= nPuntiLev(jlev) )
                i = ii + indrLev(jlev)
                Code = nint(xyz_tria(4,i))
                if (Code.le.0.or.Code.ge.7) then
                    iiii = 6
                    exit
                endif
                nPoints = Shapes(Code)
                do k=0,nPoints-1
                   kk = i + k
                   do j=1,3
                      tria(j,k+1) = xyz_tria(j,kk)
                   enddo
                enddo
                call PolyShapePov(Code, nPoints, tria, ic)
                ii = ii + nPoints
             end do
         endif
      end do
!
      return
      end
!-----------------------------------------------------------------------
      subroutine PolyShapePov(Code, nPoints, tria, ico)
      USE Molcom
!
      dimension tria(3,10), x(3,10), x1(3), x2(3), x3(3), x4(3)
      integer Code
!
      iColor = ico
      do j = 1, nPoints
         do i = 1, 3
            tria(i,j) = tria(i,j) * scalapov
         enddo
      enddo
!
      select case(Code)

! Line

         case (0)         
            x1(1:3) = tria(1:3,1)
            x2(1:3) = tria(1:3,2)
            call CilindroCont(x1, x2, iColor)

! Triangle or Trapezoide

         case (1,2)         
            x1(1:3) = tria(1:3,1)
            x2(1:3) = tria(1:3,2)
            x3(1:3) = tria(1:3,3)
            call CilindroCont(x1, x2, iColor)
            call CilindroCont(x2, x3, iColor)
            call CilindroCont(x3, x1, iColor)

! Triangle + Trapezoide

         case (3)           
            x1(1:3) = tria(1:3,1)
            x2(1:3) = tria(1:3,2)
            x3(1:3) = tria(1:3,3)
            call CilindroCont(x1, x2, iColor)
            call CilindroCont(x2, x3, iColor)
            call CilindroCont(x3, x1, iColor)
!
            x1(1:3) = tria(1:3,4)
            x2(1:3) = tria(1:3,5)
            x3(1:3) = tria(1:3,6)
            x4(1:3) = tria(1:3,7)
            call CilindroCont(x1, x2, iColor)
            call CilindroCont(x2, x3, iColor)
            call CilindroCont(x3, x4, iColor)
            call CilindroCont(x4, x1, iColor)

! Triangle + Triangle + Trapezoide

         case (4)           
            x1(1:3) = tria(1:3,1)
            x2(1:3) = tria(1:3,2)
            x3(1:3) = tria(1:3,3)
            call CilindroCont(x1, x2, iColor)
            call CilindroCont(x2, x3, iColor)
            call CilindroCont(x3, x1, iColor)
!
            x1(1:3) = tria(1:3,4)
            x2(1:3) = tria(1:3,5)
            x3(1:3) = tria(1:3,6)
            call CilindroCont(x1, x2, iColor)
            call CilindroCont(x2, x3, iColor)
            call CilindroCont(x3, x1, iColor)
!
            x1(1:3) = tria(1:3,7)
            x2(1:3) = tria(1:3,8)
            x3(1:3) = tria(1:3,9)
            x4(1:3) = tria(1:3,10)
            call CilindroCont(x1, x2, iColor)
            call CilindroCont(x2, x3, iColor)
            call CilindroCont(x3, x4, iColor)
            call CilindroCont(x4, x1, iColor)

! Triangle + Line

         case (5)           
            x1(1:3) = tria(1:3,1)
            x2(1:3) = tria(1:3,2)
            x3(1:3) = tria(1:3,3)
            call CilindroCont(x1, x2, iColor)
            call CilindroCont(x2, x3, iColor)
            call CilindroCont(x3, x1, iColor)
!
            x1(1:3) = tria(1:3,4)
            x2(1:3) = tria(1:3,5)
            call CilindroCont(x1, x2, iColor)

! Triangle + Triangle + Line

         case (6)           
            x1(1:3) = tria(1:3,1)
            x2(1:3) = tria(1:3,2)
            x3(1:3) = tria(1:3,3)
            call CilindroCont(x1, x2, iColor)
            call CilindroCont(x2, x3, iColor)
            call CilindroCont(x3, x1, iColor)
!
            x1(1:3) = tria(1:3,4)
            x2(1:3) = tria(1:3,5)
            x3(1:3) = tria(1:3,6)
            call CilindroCont(x1, x2, iColor)
            call CilindroCont(x2, x3, iColor)
            call CilindroCont(x3, x1, iColor)
!
            x1(1:3) = tria(1:3,7)
            x2(1:3) = tria(1:3,8)
      end select
!
      return
      end
!-----------------------------------------------------------------------
      subroutine DefineFileNames(nomefile)
      USE General
!
      character*(*) nomefile
      character*80 nameFile
!
      lend  = Lung(nomefile)
      iOk = index(nomefile,'.')
      if (iOK /= 0) then
          do k=lend,1,-1 
             if (nomefile(k:k) == '.') then 
                 j = k - 1
                 exit
             endif
          enddo
      else
          j = lend
      endif
      nameFile = nomefile(1:j)
      lend = j
      fname( 1) = nameFile(1:lend)//ext(1)
      fname( 2) = nameFile(1:lend)//ext(2)
      fname( 3) = nameFile(1:lend)//ext(3)
      fname( 4) = nameFile(1:lend)//ext(4)
      fname( 5) = nameFile(1:lend)//ext(5)
      fname( 6) = nameFile(1:lend)//ext(5)
      fname( 9) = nameFile(1:lend)//ext(9)
      fname(14) = nameFile(1:lend)//ext(14)
      fname(15) = nameFile(1:lend)//ext(15)
!
      return
      end
c
code for outzmatNEW
      subroutine outzmatNEW(ier)
c--output coordinate z-matrix  (NEW version)
c
      USE General
      USE Atomi
      USE Molcom
      USE Plotter
      USE ZMatrix
      USE HydroStuff
      USE BuildStuff
      USE BuildModule      
!
      character*80 filename, filename2
      character*4 estensione
!      
      integer*4    ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty 
c
      dimension xmatr(3,3),x1(3),xr(3),ori(3,3),oria(3,3)
c---------------------------------
      itest=0
      ier=0
      estensione = '.fhz'
      nco=iconn(1)
!--controllo se la connettivita' non e' presente      
      if (nco.lt.0) then    
          ier=1  
          return
      endif
!--alloco hydrostuff & buildstuff
      MaxAtomsH=MaxAtoms
      call AllocaHydroStuff(1)
      MaxBond3=MaxBonds*3
      MaxAtomsBuild = MaxAtoms 
      call AllocaBuildStuff(1)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!--da iconn  crea  in izpk=nzpk la separazion in moieties 
!--izpk(n)=no(i)*nzconst+n.del moiety di n 
      jconn(:) = iconn(:)      
      call CreaIzpkNumfrNEW
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!-------------------------------------------------------------------------
!--start analysis      
!-------------------------------------------------------------------------
!--vettore work25(i) contiene il numero del frammento per il i-esimo atomo         
      do i=1,nats
         nn=mod(izpk(i),nzConst)
         work25(i)=nn
      enddo
      if(itest.eq.1) then
         write(ncwu,*)' No. di frammenti =',nfrag
         write(ncwu,*)' set flag (nats)',nats
         do i=1,nats
            write(ncwu,61) i,aLab(i),work25(i)
   61       format(i5,') ',a8, f10.0)
         enddo
      endif
!-------------------------------------------------------------------------
!--inizio loop sui frammenti
!-------------------------------------------------------------------------
!  uso il vettore numfr(1:MaxAtomsBuild) 
!  contiene il numero di atomi per ciascun frammento
1000  continue
!--copio connettivita'
      n=iconn(1)*3+1
      iconn30(1:n)=iconn(1:n)
!--trovo il frammento piu' grande rimasto da analizzare      
      ly=-1
      do m=1,nfrag
         if(numfr(m).gt.ly) then
            ly=numfr(m)              ! numero massimo di atomi in un frammento
            ny=m                     ! n. del frammento piu' grande
            numfr(m)=-numfr(m)       ! rendo negativo il numero 
         endif
      enddo
      if(ly.eq.-1) then
         call AllocaHydroStuff(2)
         call AllocaBuildStuff(2)
         return
      endif
!-------------------------------------------------------------------------
!--definisco il file di output  per questo frammento   
!-------------------------------------------------------------------------
      close(jhost)
      nomel = index(fname(1),'.bin')-1
      filename = fname(1)(1:nomel)
      if(nfrag.gt.1) then
         fn=ny
         call nomev2New(filename,fn,filename2)
         call shift(filename2,nome2)
         filename = filename2(1:nome2) // estensione
      else
         filename = fname(1)(1:nomel) // estensione
      endif
      itype = 0
      iform = 1
      jop = jopen(jhost,filename,itype,iform,ier)
      if (jop.lt.0) then
 9000     write(lo,9010) ier,filename(1:Lung(filename))
          return
 9010     format(' *** error ***  open error, code =',i5,' file is ',a)
      endif
!-------------------------------------------------------------------------
!--esiste ancora un frammento da analizzare            
!--creo lista temporanea del frammento 
!-------------------------------------------------------------------------
      n=0
      do j=1,nats
         my=work25(j)
         if(my.eq.ny) then
            n=n+1
            aLab26(n)=aLab(j)
            work26(n)=work25(j)
            xyzs26(1:5,n) = xyzs(1:5,j)           
            xyzs26_dev(1:3,n) = xyzs_dev(1:3,j)
            Adr26to5(n)=j        
         endif
      enddo
      nats26=n
!--frammento selezionato
      if(itest.eq.1) then
         write(ncwu,*)' frammento (ny)',ny
         write(ncwu,*)' set flag (nats26)',nats26
         do j=1,nats26
            write(ncwu,61) j,aLab26(j),work26(j)
         enddo
      endif
!--fine stampa del frammento piu' grande
!--set connettivita' del frammento selezionato
      nco30=iconn30(1)
      j=2
      do i=1,nco30
         iconn30(j) = -iconn30(j)
         iconn30(j+1) = -iconn30(j+1)
         j=j+3
      enddo
      do ja=1,nats26
	   mm=Adr26to5(ja)  
         j=2
         do i=1,nco30
            if(iconn30(j).lt.0) then
	         if(iabs(iconn30(j)).eq.mm) iconn30(j)=ja
	      endif
            if(iconn30(j+1).lt.0) then
	         if(iabs(iconn30(j+1)).eq.mm) iconn30(j+1)=ja
	      endif
            j=j+3
         enddo
      enddo   
!  ncoa, jconn() connettivita' del frammento
	ncoa=0
      n=2
      j=2
	do i=1,nco30
         if(iconn30(j).gt.0) then
            jconn(n:n+2)=iconn30(j:j+2)
            n=n+3
	      ncoa=ncoa+1
	    endif
	    j=j+3
	enddo
	jconn(1)=ncoa
c--stampa del frammento
	if(itest.eq.1) then
         write(ncwu,*)' coordinate del frammento (nats26)',nats26
         call printnats26
         call PrintConn(jconn,aLab26)
	endif
!--fine stampa di test
!--ordina gli atomi secondo la sequenza piu' lunga
!  uso il vettore lconlun(1:12,1:MaxAtomsH) --> conserva no. ordine atomi legati
!  uso il vettore ibtab(1:MaxAtomsH,1:10)   --> conserva in due posizioni in no. di legami
      do i=1,nats26
         lconlun(1:12,i)=0
         ibtab(i,1:2)=0
      enddo
      j=2
      do i=1,ncoa
         do k=1,2
            lj=jconn(j+k-1) 
            lk=jconn(j+k) 
            if(k.eq.2)lk=jconn(j+k-2) 
            ibtab(lj,1)=ibtab(lj,1)+1
	      m=ibtab(lj,1)
	      lconlun(m,lj)=lk
	   enddo
	   j=j+3
	enddo 
	do n=1,nats26
	   ibtab(n,2)=ibtab(n,1)      !  copio il numero di legami
	enddo  
!--stampa connettivita' estesa per atomo del frammento
	if(itest.eq.1) then
         write(ncwu,*)' connettivita del frammento (nats26)',nats26
	   do n=1,nats26
	      l=ibtab(n,1)
	      call shift(aLab26(n),nn)
	      write(lo,62)aLab26(n)(1:nn),l,(lconlun(j,n),j=1,l)
   62       format(a8,' (',i5,')',10i5)
	   enddo
	endif
!--fine stampa di test
!--costruisco il frammento
!  uso il vettore kvet(1:3,1:MaxAtomsBuild)
      ncleg=0
	nfirst=0
	nsecond=0
1300  continue
!--cerco il punto di parrtenza (l'atomo con piu' legami)
      nlegx=9999
      do i=1,nats26
         m=ibtab(i,2)
	   if(m.gt.0) then
	      if(m.lt.nlegx) then
	         nlegx=m
	         nfirst=i
	      endif
	   endif
      enddo
	if(nlegx.eq.9999) goto 2000
1310  continue
	if(itest.eq.1)write(ncwu,*)'1) nfirst,nsecond',nfirst,nsecond
      call nextatomNEW(nfirst,nsecond)
	if(itest.eq.1) then
	   write(ncwu,*)'2) nfirst,nsecond',nfirst,nsecond
         do n=1,nats26
            l=ibtab(n,1)
	      call shift(aLab26(n),nn)
	      write(lo,62)aLab26(n)(1:nn),l,(lconlun(j,n),j=1,l)
	  enddo
	endif
	if(nsecond.eq.0) goto 1300 
	ncleg=ncleg+1
	kvet(1,ncleg)=nfirst
	kvet(2,ncleg)=nsecond
	kvet(3,ncleg)=1
	nfirst=nsecond
	nsecond=0
	goto 1310	       
!-------------------------------------------------------------------------
!--fine frammento
!-------------------------------------------------------------------------
2000  continue
      nlegx=ncleg
	if(itest.eq.1) then
	   write(ncwu,'(a,i5)')' No. legami',nlegx
	   do i=1,nlegx
            write(ncwu,'(i5,1h),2i5)')i,kvet(1:2,i)
	   enddo
      endif
!-------------------------------------------------------------------------
!--costruisco z-matrix
!-------------------------------------------------------------------------
      do i=1,500
	  iloc(i)=0
	  do n=1,3
	     nloc(n,i)=0
	     xloc(n,i)=0.0
	  enddo
	enddo
	iloc(1)=kvet(1,1)
	iloc(2)=kvet(2,1)
	kvet(3,1)=-1
	nloc(1,2)=iloc(1)
!--xloc(1,2)=distanza iloc(2)-iloc(1)
	iloc(3)=kvet(2,2)
	nloc(1,3)=iloc(2)
!--xloc(1,3)=distanza iloc(3)-iloc(2)
      nloc(2,3)=iloc(1)
!--xloc(2,3)=angolo iloc(3)-iloc(2)-iloc(1)
!--controllo che iloc(3) non sia gia' stato definito
      iqual=0
	do i=1,2
	   if(iloc(3).eq.iloc(i)) iqual=1
	enddo
	if(iqual.eq.1) then 
	  iloc(3)=kvet(1,2)
	  nloc(1,3)=iloc(1)
!--xloc(1,3)=distanza iloc(3)-iloc(2)
        nloc(2,3)=iloc(2)
!--xloc(2,3)=angolo iloc(3)-iloc(2)-iloc(1)
      endif
	kvet(3,2)=-1
      iloc(4)=kvet(2,3)
	kvet(3,3)=-1
	nloc(1,4)=iloc(3)
!--xloc(1,4)=distanza iloc(4)-iloc(3)
      nloc(2,4)=iloc(2)
!--xloc(2,4)=angolo iloc(4)-iloc(3)-iloc(2)
      nloc(3,4)=iloc(1)
!--xloc(3,4)=torsione iloc(4)-iloc(3)-iloc(2)-iloc(1)
      natx=4
	nloop=0
2005  continue
      newat=0
      do ja=1,nlegx
         if(kvet(3,ja).gt.0) then
            nn=kvet(1,ja)
	      do k=natx,1,-1
	         if(iloc(k).eq.nn) then
	            knx=k
	            goto 2010
	         endif
	      enddo
            nn=kvet(2,ja)
	      do k=natx,1,-1
	         if(iloc(k).eq.nn) then
	            knx=k
		          goto 2007
	         endif
	      enddo
	      goto 2020
2007        continue
            nn1=kvet(1,ja)
	      goto 2011
2010        continue
            nn1=kvet(2,ja)
2011        continue
            kvet(3,ja)=-1
	      do k=natx,1,-1
	         if(iloc(k).eq.nn1) goto 2020
	      enddo
	      natx=natx+1
	      iloc(natx)=nn1
	      nloc(1,natx)=iloc(knx)
!--xloc(1,natx)=distanza iloc(natx)-iloc(knx)
            if(knx.eq.1) then
               nloc(2,natx)=iloc(2)
               nloc(3,natx)=iloc(3)
	      else
               nloc(2,natx)=nloc(1,knx)
!--devo controllare che nloc(1,knx) sia # 1
               if(nloc(1,knx).eq.iloc(1)) then
                  do jc=1,natx-1
                     if(nloc(1,jc).eq.nloc(1,natx)) then
                        nloc(2,natx)=iloc(jc)
                        do jb=1,natx-1
                           if(nloc(1,jb).eq.nloc(2,natx)) then
                              nloc(3,natx)=iloc(jb)
                              goto 2020
                           endif 
                        enddo 
                     endif
                  enddo
               else
                  nloc(3,natx)=nloc(2,knx)
               endif
            endif
!--xloc(2,natx)=angolo iloc(natx)-iloc(knx)-nloc(2,natx)
!--xloc(3,natx)=torsione iloc(natx)-iloc(knx)-nloc(1,knx)-nloc(2,knx)
2020        continue
         endif
         if(kvet(3,ja).gt.0) newat=newat+1
      enddo
!	write(ncwu,*)'natx,newat',natx,newat
      if (natx.lt.nats26) then
          nloop=nloop+1
          if (nloop.lt.10) goto 2005
!          write(ncwu,'(a,i5,a,i5,a)')'Only ',natx,' atom(s) of',n25,
!     2     ' are defined'
      endif
!--ortogonalizzo frammento
!      write(lo,*) ' xortr(i,j)'
!      write(lo,'(1x,3f10.4)') ((xortr(i,j),j=1,3),i=1,3)
      do n = 1, nats26
         x1(1:3) = xyzs26(1:3,n)
         call MoltMatVec(xortr,x1,xr)
         xyzs26(1:3,n) = xr(1:3) 
      enddo
!-------------------------------------------------------------------------
!--calcolo distanze, angoli e angoli di torsione
!-------------------------------------------------------------------------
!	write(ncwu,*)'Z-matrix'
!     ispefra(i) =  specie dell'atomo
!     atfra(i)   =  nome dell'atomo
      do i=1,natx
         call zmatcalcNEW(iloc(i),nloc(1,i),nloc(2,i),nloc(3,i),
     2     ispefra(i),atfra(i),xloc(1,i),xloc(2,i),xloc(3,i))
!	   write(ncwu,'(i5,1h),i5,2x,a,2x,a4,4x,3f10.3,3i5)') i,iloc(i),
!     *     atfra(i),ispefra(i),(xloc(n,i),n=1,3),(nloc(n,i),n=1,3)
      enddo
!g	write(namefra,'(5a4)') (itle(i),i=1,5)			 
      write(jhost,'(a,i5)') cardImage(1:4),natx
!      write(ncwu ,'(a,i5)') cardImage(1:4),natx
      do i=1,natx
         j2=jfndfra(natx,nloc(1,i))
         j3=jfndfra(natx,nloc(2,i))
         j4=jfndfra(natx,nloc(3,i))
!         write(ncwu, '(i5,2x,a,2x,a4,4x,3f10.3,3i5)') i,atfra(i),
!     2     ispefra(i),(xloc(n,i),n=1,3),j2,j3,j4
         write(jhost,'(i5,2x,a,2x,a4,4x,3f10.3,3i5)') i,atfra(i),
     2     ispefra(i),(xloc(n,i),n=1,3),j2,j3,j4     
      enddo
      k = Lung(cardImage)
      write(jhost,'(a)')cardImage(5:k)
!      write(ncwu ,'(a)')cardImage(5:k)
!--vedo se ci sono altri frammenti da analizzare
      goto 1000
!-------------------------------------------------------------------------
      end
c
code for jfndfra
      function jfndfra(natx,n)
      USE ZMatrix
c
      jfndfra=0
      if (n.gt.0) then
          do i=1,natx
             if (n.eq.iloc(i)) then
                 jfndfra=i
                 return
             endif
          enddo
      endif
!
      return
      end
c
code for zmatcalcNEW
      subroutine zmatcalcNEW(k1,k2,k3,k4,ispe,fra,xd,xa,xt)
c--calcolo dati per z-mat
c
      USE General
      USE Atomi
!
      character*16 fra
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
	dimension x1(3),x2(3),x3(3),x4(3)                                
c
      ll=Adr26to5(k1)
      ksp=nzTot(ll)
      ispe=nalf(ksp)
      fra=aLab26(k1)
      if(k2.gt.0) then
         x1(1:3)=xyzs26(1:3,k1)
         x2(1:3)=xyzs26(1:3,k2)
         call lngto(x1,x2,xd) 
	   if(k3.gt.0) then
            x3(1:3)=xyzs26(1:3,k3)
		    call angto(x1,x2,x3,xa)
		    if(k4.gt.0) then
               x4(1:3)=xyzs26(1:3,k4)
               call torto(x1,x2,x3,x4,xt)
		    endif 
	   endif
	endif
      return
	end
c
code for torto
      subroutine torto(x1,x2,x3,x4,xt)
c--calcola angolo di torsione
c
      USE General
	dimension x1(3),x2(3),x3(3),x4(3),VV(6,3)
!
!--- Calcola i vettori V1, V2 e V3
!
      do j=1,3
	VV(1,j)=x2(j)-x1(j)
	VV(2,j)=x3(j)-x2(j)
	VV(3,j)=x4(j)-x3(j)
	enddo 
!
!--- Calcola gli angoli V1^V2 e V2^V3
!
      rModuA = sqrt(VV(1,1)**2+VV(1,2)**2+VV(1,3)**2)
      rModuB = sqrt(VV(2,1)**2+VV(2,2)**2+VV(2,3)**2)
      rModuS = VV(1,1)*VV(2,1)+VV(1,2)*VV(2,2)+VV(1,3)*VV(2,3)
      CosAng = rModuS/(rModuA*rModuB)
      if (CosAng .gt. 0.999999) CosAng = 0.999999
      if (CosAng .lt.-0.999999) CosAng =-0.999999
      AngG = acos(CosAng)
      SinG = sin(AngG)
!
      rModuC = sqrt(VV(3,1)**2+VV(3,2)**2+VV(3,3)**2)
      rModuS = VV(2,1)*VV(3,1)+VV(2,2)*VV(3,2)+VV(2,3)*VV(3,3)
      CosAng = rModuS/(rModuB*rModuC)
      if (CosAng .gt. 0.999999) CosAng = 0.999999
      if (CosAng .lt.-0.999999) CosAng =-0.999999
      AngA = acos(CosAng)
      SinA = sin(AngA)
!
!--- Calcola le componenti dei prodotti vettoriali V1 x V2, V2 x V3
!   ( V4 e V5 ) e  V4 x V5  ( V6 )
!
      do i = 2, 3
         VV(2+i,1) = VV(i-1,2)*VV(i,3) - VV(i-1,3)*VV(i,2)
         VV(2+i,2) =-VV(i-1,1)*VV(i,3) + VV(i-1,3)*VV(i,1)
         VV(2+i,3) = VV(i-1,1)*VV(i,2) - VV(i-1,2)*VV(i,1)
      enddo
      VV(6,1) = VV(4,2)*VV(5,3) - VV(4,3)*VV(5,2)
      VV(6,2) =-VV(4,1)*VV(5,3) + VV(4,3)*VV(5,1)
      VV(6,3) = VV(4,1)*VV(5,2) - VV(4,2)*VV(5,1)
!
      V = VV(1,1)*VV(5,1)+VV(1,2)*VV(5,2)+VV(1,3)*VV(5,3)
      SinAng =  V / (rModuA*rModuB*rModuC*SinA*SinG)
      pm =sign(1.,SinAng)
!
!--- Calcola il prodotto scalare V4 . V5
!
      rModuS = VV(4,1)*VV(5,1)+VV(4,2)*VV(5,2)+VV(4,3)*VV(5,3)
!
      CosAng = rModuS / (rModuA*rModuB*rModuB*rModuC*SinA*SinG)
      if (CosAng .gt. 0.999999) CosAng = 0.999999
      if (CosAng .lt.-0.999999) CosAng =-0.999999
      xt = pm * acos(CosAng) * RtoD
      return
      end
c
code for angto
      subroutine angto(x1,x2,x3,ang)
c--calcolo distanze 0--1 ,  1--2
c
      USE General
      USE Deprecato
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension x1(3),x2(3),x3(3)
c
      temp(1)=x1(1)-x2(1)
      temp(2)=x1(2)-x2(2)
      temp(3)=x1(3)-x2(3)
      temp(4)=x3(1)-x2(1)
      temp(5)=x3(2)-x2(2)
      temp(6)=x3(3)-x2(3)
      dis1 =0.0
      dis2 =0.0
      dis12=0.0
      do i=1,3
      dis1 =dis1 +temp(i  )*temp(i  )
      dis2 =dis2 +temp(i+3)*temp(i+3)
      dis12=dis12+temp(i  )*temp(i+3)
      enddo
      dis1=sqrt(dis1)
      dis2=sqrt(dis2)
      ang =dis12/(dis1*dis2)
      if (ang.gt. 1.) ang= 1.0
      if (ang.lt.-1.) ang=-1.0
      ang = acos(ang)* rtod
      return
      end
c
code for nextatomNEW
      subroutine nextatomNEW(nfirst,nsecond)
c--trova il prossimo atomo legato
c
      USE General
      USE Atomi
      USE Molcom
      USE Plotter
      USE ZMatrix
      USE HydroStuff
      USE BuildStuff
      USE BuildModule      
!
      m=ibtab(nfirst,2)
c--nfirst ha atomi legati
      if(m.gt.0) then
         m1=ibtab(nfirst,1)
         do n=1,m1
            if(lconlun(n,nfirst).gt.0)then
               nsecond=lconlun(n,nfirst)
               lconlun(n,nfirst)=-lconlun(n,nfirst)
               ibtab(nfirst,2)=ibtab(nfirst,2)-1
               m2=ibtab(nsecond,1)
               do nn=1,m2
	            if(lconlun(nn,nsecond).eq.nfirst) then 
                     lconlun(nn,nsecond)=-lconlun(nn,nsecond)
	               ibtab(nsecond,2)=ibtab(nsecond,2)-1
                  endif
	         enddo
	         return
	      endif
	   enddo
	else
c--nfirst non ha atomi legati
c--controllaimo se gli atomi gia assegnati hanno ancora atomi legati
         do l=1,nfirst       ! controllare se il loop va fino a nats26.....
	      m=ibtab(l,2)
	      if(m.gt.0) then
               m1=ibtab(l,1)
               do n=1,m1
	            if(lconlun(n,l).gt.0) then
	               nfirstx=l
	               nsecond=lconlun(n,l)
	               lconlun(n,l)=-lconlun(n,l)
                     ibtab(l,2)=ibtab(l,2)-1
                     m2=ibtab(nsecond,1)
                     do nn=1,m2
	                  if(lconlun(nn,nsecond).eq.nfirstx) then 
                           lconlun(nn,nsecond)=-lconlun(nn,nsecond)
	                     ibtab(nsecond,2)=ibtab(nsecond,2)-1
                        endif
	               enddo
	               nfirst=nfirstx
	               return
	            endif
	         enddo
	      endif
	   enddo
	endif
	nsecond=0
	return
	end
!----------------------------------------------------------------------
      subroutine outfullprof()
      USE General
!
      write(jhost,*)'Ciao Ivan'
      return
      end
!-----------------------------------------------------------------------
!      
!code for SupMaterialwrtNEW     !da export2006
      subroutine SupMaterialwrtNEW(ier)
!
!-- this subroutine writes a file like the supplementary material of Platon
!
      USE General
      USE Symmetry
      USE LsqModule
      USE LsqStuff
      USE LsqStuff12
      USE LsqStuff22Abs
      USE Limits
      USE Atomi
      USE BuildStuff
      USE BuildModule
      USE HydroStuff
      USE CIF
      USE Geometry
      USE RiflessiNew
      USE Molcom
!
      character*60 idfle,stfle
      common /cdisu/ idfle,stfle
      character*60  jscr,iscr,kscr,lscr,iasun1,iform,imsg,jasun,
     2 kkscr,llscr,psfle1
      common/xscru/ jscr,iscr,kscr,lscr,iasun1,iform,imsg,jasun,
     2 kkscr,llscr,psfle1
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xchar/id,ie,ib,icc,ia,ih,numb(10),iplus, inus,ipoint
      common /worka/a,b,c,d,e,f,xg,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz    
      common/xpubx/ ncolx,nlin,nspac,nskip,lst ,lstx,
     1  lw1, lin(18),ile,im,iv,il1,im1,iv1,fudge,iword,idumm
      common/workc/dx(4),icomc(196)
!
      character*80 filename
      character*4 label
      character*64 follow
      character*64 follow2
      character*48 datatape
      character*32 key
      character*80 linea
      dimension linea1(40)
      dimension inam3(20),nnn3(20),fmur(20),atwn(20),rvalue(11)
      dimension na(20),fno(20)
      dimension hl(12)
      dimension indmx(3),indmn(3)
      dimension indixc(2,3),sinthl2(2)
      dimension vet(64)
      dimension ivet(64)
      equivalence (vet,ivet)
      character*1 obnum(0:9), chtmp, apice, zero,ch(3)
      character*2 iwa(2)
      character*8 ifull(3)
      character *77 Pesi(18)
      character*1 num6
      character*16 space
      character*40 jname,jname2
!
      dimension is(2,3),ts(3)
      dimension nnch(2)
      dimension ixyz(3),itras(24),iNomeAt(20)
      character*4 ibchar,ixyzch(3),itrasch(24),iww
      data nnch/1,2/
      data  ibchar/'    '/
      data  ixyzch/'x   ','y   ','z   '/
      data itrasch/'    ','0000','0000','1/8 ',
     2             '1/6 ','0000','1/4 ','0000',
     3             '1/3 ','3/8 ','0000','0000',
     4             '1/2 ','0000','0000','5/8 ',
     5             '2/3 ','0000','3/4 ','0000',
     6             '5/6 ','7/8 ','0000','0000'/
      data zero/'0'/,ch/'c','h',' '/
      data num6/'6'/
!
      data obnum /'0','1','2','3','4','5','6','7','8','9'/
      data iwa /'Mo','Cu'/,ifull/'Diagonal','Full','Block'/
      data jname/' '/,jname2/' '/
!
      call scrper(' Supplementary Material',0,0)
      ier = 0
      MaxAtomsBuild = MaxAtoms
      MaxAtomsH=MaxAtoms
      MaxBond3=MaxBonds*3
      call AllocaBuildStuff(1)
      call AllocaHydroStuff(1)
!
      read(ibchar,'(a2)')iblank
      do i=1,3
         read(ixyzch(i),'(a4)') ixyz(i)
      enddo
      do i=1,24
         read(itrasch(i),'(a4)') itras(i)
      enddo
!
      twopis=2.0*pi*pi
!
      call Check_Content_Atoms(ighost)
      nzeta=nsymTot
      nzetac=nzeta
!
!--_publ_section_title
!
      write(ititle,'(15a4)')(itle(i),i=1,15)
      call shift(ititle,lenp)
      write(lo,'(a,15x,a)') 'Structure Name',ititle(1:lenp)
!
!--_chemical_formula
!--commentate la routine (deve essere aggiornata!) RS 15.07.11
!      call ChemicalFormulaNEW(linea,ier)
!      call shift(linea,lenp)
!      follow2='Formula'
!      write(lo,'(a32,a)') follow2,linea(1:lenp)
!
!--_chemical_formula_moiety
!
      linea=' '
      NatMol0=NatMol
      NumLeg0=NumLeg
      nfragassimunit=1
      call FormulaMoietyNEW(maxnopfr,nfragassimunit,
     1 linea,weight_moiety)
      NatMol=NatMol0
      NumLeg=NumLeg0
      if(ier.ne.0) return
      lenp=0
      call shift(linea,lenp)
      follow2='Formula Moiety'
      write(lo,'(a32,a)') follow2,linea(1:lenp)
!      call AllocaBuildStuff(2)
!
!--_chemical_formula_weight
!
      fmu = 0.0
      f000 = 0.0
      atwt = 0.0
      ntt = 0
      do j = 1,nk
         jnat = no(j)              ! numero atomico
         atw =  AtomWeight(j)             ! peso atomico
         fmur(j) = fmuro(j)        ! mu/rho
         f000 = f000 + jnat*nw(j)  !no. atomi in cella*numero atomico
         atwn(j) = atw*nw(j)       !peso atomico*no. atomi in cella
!
!---peso in atomi della cella ( m * z )
!
        atwt = atwt +atwn(j)      ! peso atomico totale in cella
        ntt = ntt + nw(j)         ! numero atomi totale in cella
      enddo
      fweight=atwt
c      fweight=atwt/nzetac
      follow2='Formula Weight'
!mercedes 18mag11      write(lo,'(a28,f11.2)') follow2,fweight
      write(lo,'(a28,f11.2)') follow2,weight_moiety
!
!--_cell
!
      devcell=0
      do i=1,6
         devcell=devcell+abs(errcell(i))  
      enddo
      idev=1
      if(devcell.le.0)idev=0
      ndev=1
      nfix=0
      if (idev.eq.0) then
          write(lo,'(a,6f8.3)')'Cell ',cell(1:6)
          write(lo,'(a,10x,f8.3)') 'Vol [Angstrom**3 ]    ',volume
      else
          lenp=0
          do i=1,6
             linea1(1:40)=ib
               if (i.le.3) then
                   ndec=3
                   ndec1=3
               else
                   ndec=2
                   ndec1=2
               endif
             call snum(cell(i),errcell(i),ndec,ndec1,
     *                                   0,10,linea1,ndev,nfix)
             jfin=lenp+40
             if(jfin.ge.80)jfin=80
             jjj=1
             do jj=lenp+1,jfin
                 write(linea(jj:jj),'(a1)') linea1(jjj)
                 jjj=jjj+1
             enddo
             call shift(linea,lenp)
          enddo
          write(lo,'(a,a)')'Cell ',linea  
          linea1(1:40)=ib
          ndec=2
          ndec1=2
          call snum(volume,errcell(7),ndec,ndec1,
     *                                   0,10,linea1,ndev,nfix)
          write(lo,'(a,10x,40a1)') 'Vol [Angstrom**3 ]    ',
     *                                  (linea1(n),n=1,40)
      endif
      nzeta=nsymTot*nfragassimunit/maxnopfr
      follow2='Formula Z'
      write(lo,'(a30,i6)') follow2,nzeta
!
!--_symmetry_cell_setting
!
      write(space,'(16a1)') nSpaceG
      call ucase(space(1:1))
      linea=texc(jsys)
      call shift(linea,lenp)
      follow2='Crystal System '
      write(lo,'(a32,a)')follow2,linea(1:lenp)
      linea=space
      call shift(linea,lenp)
      follow2='Space Group '
      write(lo,'(a32,a)') follow2,linea(1:lenp)
!      
!--print symmetry_equiv_pos
      follow2='Symmetry equivalent positions'
      write(lo,'(a)')follow2    
      do i=1, nsymTot
         k = Lung(SymmStrings(i))
         write(lo,'(25x,i5,1h),1x,a)') i, SymmStrings(i)(1:k)
      enddo
!
!--_exptl_crystal_density_diffrn
!
      dcal = atwt/(volume*0.602)
!
!---calcolo mu (cm-1)
!
      if (ntt.gt.0) then
         do j=1,nk
             fmu = fmu + (atwn(j)/atwt)*fmur(j)
         enddo
      endif
      fmu = fmu * dcal * 0.1
      follow2='D(calc) [g/cm**3]'
      write(lo,'(a32,f6.3)') follow2,dcal
      n=f000
      follow2='F(000)'
      write(lo,'(a32,i5)') follow2,n
      follow2='MU [mm**-1]'
      write(lo,'(a32,f6.3)')follow2,fmu

!
!--_diffrn_radiation_wavelength
!
      i=whichwave
      follow2='Radiation [Angstrom]'
      if (i.eq.1.or.i.eq.2) then
            iww=iwa(i)//'Ka'
            write(lo,'(a32,a)') follow2,iww
      else 
           write(lo,'(a32,f8.5)')follow2, wavel
      endif
!
!--controllo se sono presenti i riflessi
!     
      if(InfoOK(6) > 0) then 
*gl*  if(nrefl > 0) then 
!--_reflns_number_total
         nrif1=nonoss 
         nrif2=nescl   
         nrif=nrefl
         obf=abs(cutoff)
         if (obf.gt.0.0) then
             follow2='Observed Data '
             write(lo,'(a32,a,f4.1,a)')follow2 ,'F > ',obf,' *sigma(F)'
         endif
!
!--obtain the indices min and max observed
!
         sintmn= 9999
         sintmx=-9999
         do i=1,3
            indmn(i)= 9999
            indmx(i)=-9999
         enddo
!
         do i=1, nrefl
            ivet(1:3) = refl%hkl(1:3,i)
            do k=1,3
               if (indmn(k).gt.ivet(k)) then
                   indmn(k)=ivet(k)
               endif
               if (indmx(k).lt.ivet(k)) then
                   indmx(k)=ivet(k)
               endif
            enddo
            a = refl%rho(i)
            sintmn=amin1(sintmn,a)
            sintmx=amax1(sintmx,a)
         enddo
!
!--end of the reflection loop
!
         follow2='H K L Min/Max '
         write(lo,'(a32,3(2i4,2x))')follow2,(indmn(j),indmx(j),j=1,3)
         resol=1.0/(2.0*sqrt(sintmx))
         resol1=1.0/(2.0*sqrt(sintmn))
         follow2='Resolution range'
         write(lo,'(a32,f6.3,f7.3)')follow2, resol,resol1
!
         if(nWeight.ge.1.and. nWeight.le.18) then
            call wrtpesiNEW(follow)
            call shift(follow,lenp)
            follow2='Weighting Scheme '
            write(lo,'(a32,a)') follow2,follow(1:lenp)
         endif
!
         if(ighost.eq.0)then   !per gianluca 07lug10 mercedes (no ghost)
!
!------------------------------------------------------------------
            iStampa=0
            LsqCF=2
            jgraf=0
            call MnqdGetAllInfo(jgraf,ierres,iStampa,0)
!--definisco dimensioni e alloco vettori per Eq. Normali      
            call CalcolaNumParam(ier)
!----------------------------------------------------
            nrif1=nonoss  
            nrif2=nescl  
            nrif=nreflObs
            follow2= 'N.ref for Refinement '
            write(lo,'(a32,2i5)') follow2,nrif
            follow2= 'N. of parameters '
            if(NParTot.gt.0)write(lo,'(a32,2i5)') follow2, NParTot
            follow2= 'N. of restraint(s) '
            if(nres.gt.0)write(lo,'(a32,2i5)') follow2,nres
            follow2= 'N. of contraint(s) '
            if(NumGroup.gt.0)write(lo,'(a32,2i5)') follow2,NumGroup
            rvalue(1)= rflsq/100.0
            rvalue(2)= rflsq/100.0
            rvalue(3)= rwflsq/100.0
            rvalue(4)= rwflsq/100.0
            rvalue(5)= slsq     
            rvalue(6)= slsq
            rvalue(7)= shiftesd(1)
            rvalue(8)= shiftesd(2)
            rvalue(9)=rhodiff(1)
            rvalue(10)=rhodiff(2) 
            rvalue(11)=rhodiff(3)  
            rvalue(9)= 0.0
            rvalue(10)=0.0
            rvalue(11)=0.0
            follow2='R, wR2, S '
            write(lo,'(a32,f7.4,2f8.4)')
     1            follow2,rvalue(1),rvalue(3),rvalue(5)
            follow2='Max-Mean shift/error '
            write(lo,'(a32,3f5.2)') follow2,rvalue(7),rvalue(8)
            follow2='Max-Min Density [e/Ang**3] '
            write(lo,'(a32,2f5.2)')follow2,rvalue(9),rvalue(10)
         endif
      endif
!-----------------------------------------------------------------------
!  scrive tabella delle coordinate
!-----------------------------------------------------------------------      
      jcod=-1       ! per scrivere la tabella
      ncwua=ncwu
      ncwu=lo
      call CaosPubl5NEW(jcod,ier)
      ncwu=ncwua
      ier = 0
      itype=1
      ifform=1
!-- open file for geometric calculations results
      itype = 1
      iformm = 1
      if (jopen(nctu,jname,itype,ifform,ier) >= 0) then  
          jcif=0
          call SupMatGeomNEW
          close(nctu)
      endif
!      
      call AllocaBuildStuff(2)
      call AllocaHydroStuff(2)
!
 9000 continue
  270 format(' Open error, code =',i5,' file is ',a)
  271 format(' List of atoms not present')
 2150 format(20a4)
 2610 format(1x,"'",a4,"'",i5,1x,"'",3a4,"'",2f8.4," ' ",a)
!
      return
      end
!-----------------------------------------------------------------------
!
!code for ChemicalFormulaNEW
      subroutine ChemicalFormulaNEW(linea,ier)
      USE General
      USE Symmetry
      USE Atomi
!
      character*64 follow , follow2
      character*80 linea
      character*1 chtmp, ch(3)
      dimension iNomeAt(20),nnch(2)
      data ch/'c','h',' '/, nnch/1,2/
!
      ier=0
      nzeta=nsymTot
      nzetac=nzeta
      iwar=0
      k1050 = 1
      i1050: do while (k1050 == 1)
                k1050 = 0
                do j=1,nk
                   n = nw(j)/nzetac
                   if (n*nzetac.ne.nw(j)) then
                      iwar=iwar+1
                      if (iwar.eq.2) then
                         write(lo,*)
     1             ' Warning! Possible error in the chemical formula...'
                         exit i1050
                      endif
                      nzetac=nzetac/2
                      k1050 = 1
                      exit
                   endif
                enddo
             enddo i1050
      ini=1
      icarb=0
      ihydr=0
      if(no(1).eq.1)ihydr=1
      do jj = 1,nk
         if(no(jj).eq.6)icarb=jj
      enddo
      if(icarb.eq.0)ihydr=0
      if(icarb.gt.0) then
         chtmp='C'
         iNomeAt(1)=ichar(chtmp)
         iNomeAt(2)=icarb
         ini=3
         if(ihydr.gt.0) then
            chtmp='H'
            iNomeAt(3)=ichar(chtmp)
            iNomeAt(4)=1
            ini=5
         endif
      endif
      j=ini
      do jj = ihydr+1,nk
         if(jj.eq.icarb) cycle
         follow=' '
         follow=Species(jj)
         chtmp=follow(1:1)
         nspec1=ichar(chtmp)
         chtmp=follow(2:2)
         nspec2=ichar(chtmp)
         iNomeAt(j)=nspec1*256+nspec2
         iNomeAt(j+1)=jj
         j=j+2
      enddo
      jump=0
      nkk=nk-ini/2
      call sortya(iNomeAt,ini,nkk,2,jump)
      natm=0
      linea=' '
      ilin=1
      do jj = 1,2*nk,2
         j=iNomeAt(jj+1)
         follow=' '
         n = nw(j)/nzetac
         follow=' '
         follow2=Species(j)
         chtmp=follow2(1:1)
         call ucase(chtmp)
         follow2(1:1)=chtmp
         if (n.gt.1) then
               write(follow,'(a4,i4)')follow2,n
         else
               write(follow,'(a4)')follow2
         endif
         call skpblk(follow,len)
         call shift(follow,len)
         linea(ilin:ilin+len)=follow(1:len)
         ilin=ilin+1+len
      enddo
      call shift(linea,lenp)
      return
      end
!-----------------------------------------------------------------------
!
!code for FormulaMoietyNEW
      subroutine FormulaMoietyNEW(maxnopfr,nfragassimunit,
     1 linea,weight_moiety)
      USE General
      USE Atomi   
      USE HydroStuff
      USE Molcom
      USE Symmetry
      USE BuildStuff
      USE BuildModule
      USE Geometry
!!
      common /BuildAtomi/ storeatomi(20000)
      dimension kformufrag(100,20),iNomeAt(60),nnch(2),nopfr(192)
      character*80 linea,follow,follow2
      character*1 chtmp,ch(3)
      data nnch/1,2/
      data ch/'c','h',' '/
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!--da jconn  crea  in izpk=nzpk la separazion in moieties 
!--izpk(n)=no(i)*nzconst+n.del moiety di n
!
      nfragassimunit=1
!--completa i frammenti applicando gli op.di sim.
      ifmenubuild=2
      call NewAppSym(ifmenubuild)  !ifmenubuild=NatMol (n.totale di atomi)
!      
!-- NewAppSym fornisce: 
!-- ifmenubuild=NatMol (n.totale di atomi)
!-- xyz(1:3,1:natMol) coord. fraz. degli atomi
!-- LE(1:3,1:NumLeg) la connettivita'
!
      natsav=nats      !-- salva nats 
      nats=ifmenubuild  !definisce il nuovo nats
!      
!--copia le coord. su xyzbu
      do i=1,nats
         kblock(i)=1
         xyzbu(1:3,i)=xyz(1:3,i)
         ii=iEqui(i)
         xyzbu(3:4,ii)=xyzs(3:4,i)
      enddo
!-- copia la connettivita su jconn
!RS perche' veniva copiata da LE() invece che da iconn()????????????????
!MERC  usare LE !!
      jconn(1)=NumLeg
      i=2
      do j=1,NumLeg
             jconn(i:i+2)=LE(1:3,j)
!            write(lo,*)'i,jconn(i:i+2)',i,jconn(i:i+2)
             i=i+3
      enddo
!
!MERC jconn(:) = iconn(:)
      call CreaIzpkNumfrNEW
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!-- analizza il contenuto di ogni frag.
      kformufrag(:,:)=0
      ifr=0
      maxnopfr=0
      do ikk=1,nfrag
         ifr=ifr+1
         numat=0
         kformufrag(ifr,1:20)=0 
         iiz=0
         nopfr=0
         do in=1,nats        
            izpkin=iabs(izpk(in))
            ifrag=mod(izpkin,nzConst)
            if(ifrag.eq.ifr)then
               iiz=izpkin/nzConst
               if(iiz.eq.0) cycle 
               kformufrag(ifr,iiz)=kformufrag(ifr,iiz)+1
               kformufrag(ifr,20)=1  !n. di frag.uguali
               nn=nopEq(in)/1000    !conta il no.di op. presenti nel frammento.
               if(nn.le.192)nopfr(nn)=1
            endif
         enddo
         nopfrt=0
         nopfrt=sum(nopfr)
         maxnopfr=max0(maxnopfr,nopfrt)
!         write(lo,'(a,i3,20i4)')'ifr,kformufrag(ifr,1:20)',
!     1     ifr,kformufrag(ifr,1:20)
!-- e' uguale a un frag. anteriore?
         if(ifr.gt.1)then
            do jj=1,ifr-1
            igual=0
               do ii=1,19
                  if(kformufrag(ifr,ii).ne.kformufrag(jj,ii))then
                    igual=1
                    exit
                  endif    
               enddo    
               if(igual.eq.0)then
                 kformufrag(jj,20)=kformufrag(jj,20)+1
                 kformufrag(ifr,1:20)=0
                 exit
               endif    
            enddo
         endif    
      enddo
!-- conta i fragmenti diversi
      iifr=0
      do jj=1,nfrag
           if(kformufrag(jj,20).ne.0)iifr=iifr+1
!      write(lo,*)'jj,kformufrag(jj,20),iifr',jj,kformufrag(jj,20),iifr 
      enddo
!-- c' e' lo stesso numero di ogni frammento diverso?
      nfau=kformufrag(1,20)
      if(nfau.gt.1)then
               kk=0
               do jj=2,nfrag
                  if(kformufrag(jj,20).eq.0)cycle
                  if(kformufrag(jj,20).ne.nfau)then
                     kk=1
                     exit
                  endif    
               enddo   
               if(kk.eq.0)then
               nfragassimunit=kformufrag(1,20)
                  do jj=1,nfrag
                     if(kformufrag(jj,20).eq.0)cycle
                     kformufrag(jj,20)=1
                  enddo   
               endif    
      endif    
!-- scrive la formula bruta di ogni frag.
      lenp=0
      linea=' '
      jfr=0
      weight_moiety=0.
      do ifr=1,nfrag    
         nn=kformufrag(ifr,20)
         if(nn.eq.0)cycle
         jfr=jfr+1
         iapriparentesi=0
         if(nn.gt.1)then
            lenp=lenp+1
            linea(lenp:lenp)='('
         iapriparentesi=1
         endif
         iNomeAt(:)=0
!
!--_chemical_formula 
         ini=1
         icarb=0
         ihydr=0
         if(no(1).eq.1.and.kformufrag(ifr,1).gt.0)ihydr=1
         do jj = 1,nk
            if(no(jj).eq.6.and.kformufrag(ifr,jj).gt.0.and.ihydr.eq.1)
     1      icarb=jj
         enddo
         if(icarb.eq.0)ihydr=0
         if(icarb.gt.0) then
            chtmp='C'
            iNomeAt(1)=ichar(chtmp)
            iNomeAt(2)=icarb
            iNomeAt(3)=kformufrag(ifr,icarb)
            weight_moiety=weight_moiety+
     *                   AtomWeight(icarb)*kformufrag(ifr,icarb)
!      write(lo,'(a,f10.3)') 'F. Moiety weight ',weight_moiety
            ini=4
            if(ihydr.gt.0) then
               chtmp='H'
               iNomeAt(4)=ichar(chtmp)
               iNomeAt(5)=1
               iNomeAt(6)=kformufrag(ifr,1)
            weight_moiety=weight_moiety+AtomWeight(1)*kformufrag(ifr,1)
!      write(lo,'(a,f10.3)') 'F. Moiety weight ',weight_moiety
               ini=7
            endif
         endif
         j=ini
         do jj = ihydr+1,19   !no.d'ordine degli elementi in no(i)
            if(jj.eq.icarb) cycle
            if(kformufrag(ifr,jj).eq.0)cycle
            follow=' '
            follow=Species(jj)
            chtmp=follow(1:1)
            nspec1=ichar(chtmp)
            chtmp=follow(2:2)
            nspec2=ichar(chtmp)
            iNomeAt(j)=nspec1*256+nspec2
            iNomeAt(j+1)=jj
            iNomeAt(j+2)=kformufrag(ifr,jj)
           weight_moiety=weight_moiety+AtomWeight(jj)*kformufrag(ifr,jj)
!      write(lo,'(a,f10.3)') 'F. Moiety weight ',weight_moiety
            j=j+3
         enddo
         jump=0
         nkk=nk-ini/3
         call sortya(iNomeAt,ini,nkk,3,jump)
         lenp=lenp+1
         do jj = 1,3*nk,3
             j=iNomeAt(jj+1)
             if(j.eq.0)cycle
             follow=' '
             n=iNomeAt(jj+2)
             follow2=Species(j)
             chtmp=follow2(1:1)
             call ucase(chtmp)
             follow2(1:1)=chtmp
             if (n.gt.1) then
                write(follow,'(a4,i4)')follow2,n
             else if (n.eq.1) then
                write(follow,'(a4)')follow2
             else if (n.eq.0) then
                write(follow,'(a4,i4)')follow2,n
             endif
             call skpblk(follow,len)
             call shift(follow,len)
             linea(lenp:lenp+len)=follow(1:len)
             lenp=lenp+1+len
         enddo
         call shift(linea,lenp)
         if(iapriparentesi.eq.1)then
            lenp=lenp+1
            linea(lenp:lenp+1)=')'
            if(nn.gt.1)then
               weight_moiety=weight_moiety*nn
               lenp=lenp+1
               write(follow2,'(i4)')nn
               call shift(follow2,len)
               linea(lenp:lenp+len)=follow2
            endif
         endif  
         call shift(linea,lenp)
         lenp=lenp+1
!        if(ifr.lt.nfrag)linea(lenp:lenp)=','
         if(jfr.lt.iifr)linea(lenp:lenp)=','        !mercedes 07mar11
         lenp=lenp+1
      enddo
             
!             follow2='Formula Moiety '
!             write(lo,'(a32,a)') follow2,linea(1:lenp)
!      write(lo,'(a,f10.3)') 'Formula Moiety weight ',weight_moiety
      nats=natsav

      return
      end

!---------------------------------------------------------------------------------------
!      
!code for salf
      subroutine salf(j,iarg,ivet)
!--trasform integer number to alphanumeric characters
!  j  last address in ivet
!  iarg  integer  number
!  ivet  vector for printing
!
      common/xchar/id,ie,ib,ic,ia,ih,numb(10),iplus, inus,ipoint
      dimension ivet(*)
!
      iar=iabs(iarg)
 1000 continue
      iar1=iar
      iar=iar/10
      i=iar1-iar*10+1
      ivet(j)=numb(i)
      j=j-1
      if(iar)  1010,1010,1000
 1010 continue
      if(iarg)  1020,1030,1030
 1020 continue
      ivet(j)= inus
      j=j-1
 1030 continue
      return
      end
!
!code for set0
      subroutine set0(j1,j2,ivet)
!--insert '0'
!
      common/xchar/id,ie,ib,ic,ia,ih,numb(10),iplus, inus,ipoint
      dimension ivet(*)
!
      if(j2-j1) 1010,1005,1005
1005  continue
      do j=j1,j2
      ivet(j)=numb(1)
      enddo
1010  continue
      return
      end
!
!code for sid
      subroutine sid(a,n,ix,id)
!--form the integer and the decimal parts
!
!  a  floating point number
!  n  number of decimal figures
! set on return:
! ix  integer part
! id  decimal part
!
      x=abs(a)
      ix=int(x)
      xd=x-float(ix)
      ipot=10**n
      x1=xd*ipot
      if(a.lt.0.0) x1=-x1
      id1=nint(x1)
      id=iabs(id1)
      if(id.lt.ipot)return
      id=0
      ix=ix+1
      return
      end
!
!code for si
      subroutine si(a,n,id)
!--multiply a floating point number for (10**n)
!  and pick up the integer part
!
      x1=a*(10**n)
      id1=nint(x1)
      id=iabs(id1)
      return
      end
!-----------------------------------------------------------------------
