!-------------------------------------------------------------------
!-- file Mnqd2008.f                  date: 28th January 2011
!-----------------------------------------------------------------------
!-- sir code for Mnqd                    Release 39.10
!----------------------------------------------------------------------
      MODULE xfourx
          integer :: itipo, iprint, numero, iw, ilento, imedium, ivelo
          integer :: isogl, ihomx, ihvmx, ihsmx, isearc, nPToFind
          integer :: interpo, iref, icMappa, javFourier, KindFourier
          integer :: nPeaksF, levelFourier, nPeaksToFind, NordCubo
          real    :: rvol, scale, f000, scr, javGrid
          real    :: xyzCuboCryst(3)
          integer :: Map_Grid(3), limitiJav(2,3)
      END MODULE xfourx
!----------------------------------------------------------------------
!
      subroutine Mnqdmain(idi,ier,iref)
!--main routine for lsq
!--viene chiamata: dal loop di direttive (SIR: #lsq)
!                  dalla grafica (utilizzando i riflessi)
!                  dalla grafica (solo restraints)
!  ier = error code
!  idi = -1 normal input directives (CAOS)   (NOT MORE USED)
!         0 normal input directives (SIR)    (NOT MORE USED)
!	    1 no input directives
!	    2 call from grafica (direttive definite via grafica)
!	    3 call from any routine
!  iref = 0 normal run (use the reflections)
!	    1 no reflections
!
!  LsqCF  (in Module LsqModule) = 1 Calcolo fattori
!                               = 2 Affinamento
!
      USE General
      USE Atomi     
      USE LsqModule
!
      call RoutineHeader('Least-Squares')
!
      jgraf=0
      Num_Riflessi=0
      jCode_Peso=0
      call StartMNQD(jgraf,iref,Num_Riflessi, jCode_Peso)
!            
      call DirMnqd(ier,idi,iref,xyzs4)
      write(lo,3830)
3830  format(/,1h ,78('+'),//)
      return
      end
c----------------------------------------------------------------------
      subroutine RunMndq(ier,jlsq1,jcyc,fdum,istampa,Num_Riflessi,
     * Berr_vector,jCode_Peso)
c--s.f. calculation and least-squares calc.
c--questa e' la routine chiamata da altre routine all'interno del programma
c
c  ier	   = codice di errore in output
c  jlsq1   = 1	calcolo fattori
c	       2	minimi quadrati
c  jcyc    = no di cicli
c  fdum    = fattore di smorzamento
c  istampa = livello di stampa
c	     -1 stampe escluse
c	      0 stampa l'essenziale
c	      1 stampa lista 5 dopo ogni ciclo
c	      2 stampa shift, s.d. e rapporto adogni ciclo
c	      3 stampa lista 22
c
      USE General
      USE LsqModule
c--
      dimension Berr_vector(*)
!      
      iverb=istampa
      LsqCF=jlsq1
      nCycles=jcyc
      Dampi=fdum
      idi=3
      iref=0
      jgraf=0
      call StartMNQD(jgraf,iref,Num_Riflessi, jCode_Peso)
!      
      call DirMnqd(ier,idi,iref,Berr_vector)
      return
      end
c
c----------------------------------------------------------------------
      subroutine DirMnqd(ier,idi,iref,Berr_vector)
c--main routine di l.s.q. e c.f.     
c--prepare lists for s.f. calculation and least-squares calc.
c  idi = -1 normal input directives (CAOS)  (NOT MORE USED)
c         0 normal input directives (SIR)   (NOT MORE USED)
c	    1 no input directives
c	    2 call from lsqfin (direttive definite via grafica)
c	    3 call from any routine
c  iref = 0 normal run (use the reflections)
c	    1 no reflections
c
      USE General
      USE Limits
      USE Atomi
      USE Symmetry
      USE Riflessi
      USE PhaseModule
      USE LsqModule
      USE Molcom
      USE LsqGroupsStuff
      USE LsqStuff
      USE LsqStuff12
      USE LsqStuff22
      USE LsqStuff22Abs
c
      real xMatTwin(3,3)
      dimension Berr_vector(*)
      common/minmaxB/ ifAutoBtAn, value_Bmin, value_Bmax
!      
      character line*80,dire*80,diret*80
c--
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz                  
!                    
      character*6 icodeFOch(2)
      data icodeFOch/' Fo   ',' Fo**2'/
c
c------------------------------------------ 
!
      if (knw == 1) then
          if (nsym > 1 .or. (nsym == 1 .and. icent == 1)) then
              ifExamin = 1
          endif
      endif
      if ((nsym == 1.and.icent == 0) .or. nSpaceGroup == 144) then !dedi
          ifExamin = 0                           ! per P1 e P31
      endif
!
      call XTimeIN(1,'Total Time')
      iprintNEW=0
      jdump_calc=0
      istampa=0
c--define variable caos--------------------
      ier=0
      istat2=0
      iverb=-1
      if(idi.ne.3) iverb=0
!-- prepara le informazioni per LSQ
      BLimit=99999.0
! 
!-- Dampi=1.0   !--'damp'------------------------------------------  

c--set default values
      k=0
c--default : refine
c  LsqCF=2
c  code    jb =  0
c          jh = -1
c          je =  0  if neutro.ne.0 then je=-1
c--calcolo fattori
c  LsqCF=1
c  code    jb = -1
c          jh =  0   (calcola scala)
c          je =  0  if neutro.ne.0 then je=-1
c-----------------
      jb=0
      jh=-1
      je=0   !--'usa sempre la disper. anom.'----------------------  
      if(idi.eq.-1) LsqCF=2    ! input directives (CAOS)(refine default)((NOT MORE USED)
      if(neutro.ne.0) je=-1
      jCodeTwin=0
      jCodeFlack=0
      jFlackON=0
      iautoLsq=1
      jg=-1          !--'prin'----jg=0----------------------------------
      sumWDiff=99999.0
      nCycleTot=20    ! ex ji=20
      nCycleCurr=1    !-ex jl=0  ---'numb'------------------------------ 
      x=1.0
      if(idi.eq.1) then    ! no input directives (solo CF !)
         jb=-1
         iverb=-1
         iautoLsq=0
      end if
      if(idi.ge.2) then    ! call from lsqfin or from any routine
         if(LsqCF.eq.1) then    ! CF
            jb=-1
            jh=0
         else if(LsqCF.eq.2) then  ! least squares refinement
            jb=0
            jh=-1
         endif
         iautoLsq=0
         nCycleTot=nCycles
         if(nCycleTot.eq.0) then
            nCycleTot=20
            iautoLsq=1
         endif
      endif
      NoRefl=0     !--'nore'-- = 1 ----------------------------------     
c--check the 'iref' flag  (affinamento con riflessi=0, senza=1)
      if(iref.eq.1) then
         NoRefl=1
         jh=-1
         jb=0
         iautoLsq=0
         if(nCycleTot.eq.20) nCycleTot=3
         Dampi=0.1
      endif
!--'test'-per avere stampe dettagliate affinamento----------         
!      istat2=3
!      iverb=3
!--'test'---------------------------------------------------         
!	jg=0
      NoTest=0     ! =1 test
c--controllo se affinamento mediante riflessi osservati
      if(NoRefl.eq.0) then
         if(nreflObs.le.0) then
            write(Msg,6101) nreflObs
 6101       format(' Wrong refl number in LSQ modulus:   ',i4)
            call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
            ier=-1
            return
         endif
c--fine controllo affinamento mediante riflessi osservati
      endif
!------------------------------------------------------------------      
!--check if the scale is to be refined
      if(idi.ne.3) then
         if(FcScale.lt.0.0) then
            jh = 0        ! set to 0 if the scale factor is to be refined
            jb = -1
            if(sc>0.0) then
               scf=sqrt(sc)
            else
               scf=1.0
            endif
c--test            FcScale = scf
         endif
      endif
      FcScale=abs(FcScale) 
c      
c--check compatibility of some code 
      if(OverallNumBlock(4).ne.0)jCodeFlack=1
      if(jCodeFlack.ne.0) then
          if(icent.ne.0) then
            write(Msg,6102)  
 6102       format(' Refinement of polarity factor not allowed',
     2               ' for c.s. structure')
            call MsgWinErr('WARNING!', Msg, ERR_WINDOW, nExitCode)
            OverallNumBlock(4)=0
            jCodeFlack=0
          endif
      endif
      if(OverallNumBlock(5).ne.0)jCodeTwin=1
c--check compatibility of some code
      if(jCodeTwin.ne.0.and.jCodeFlack.ne.0)then
         write(Msg,6103)
 6103    format(' Refinement of polarity factor and Twinning',
     2          ' is not allowed')
         call MsgWinErr('WARNING!', Msg, ERR_WINDOW, nExitCode)
         jCodeFlack=0
      endif
      NumTwin=1
      if(jCodeTwin.ne.0) NumTwin=2
      if(jCodeFlack.ne.0) NumTwin=2
      if(jCodeFlack.ne.0) then
         xMatTwin(:,:)=0.0
         do j=1,3
            xMatTwin(j,j)=-1
         enddo 
      endif
!------------------------------------------------------
!--inizio sezione solo Calcolo fattori
!------------------------------------------------------   
      if(iverb.ge.0) then
        if(NoRefl.eq.0) then
          if(jb.eq.-1) then
              write(ncwu,9039)icodeFOch(icodeFO)
9039	        format(' Structure factor calculation on ',a6)
          endif
        endif
      endif
      if(jb.eq.-1) then   
         call MnqdCF(iprintNEW,NumTwin,scalec1,xMatTwin)
         jh=-1
         if(LsqCF == 1)  goto 3820    ! era stato richiesto solo CF
      endif
!-----------------------------------------------------      
!--fine solo Calcolo fattori
!------------------------------------------------------      
!-----------------------------------------------------
!--inizio sezione affinamento Minimi Quadrati
!------------------------------------------------------ 
!--salvo il no. atomico  
      do i=1,Nats
         nzt=nzTot(i)
         noAtom(i)=no(nzt)  !no.atomico dell'i-esimo atomo
      enddo
c--set n. partial derivatives per parameter NumDerParz=NumDerParz*2 if twinning
c  has to be refined
c--number of partial derivatives per parameter (1,2 or 4)
      NumDerParz=(2-icent)*(je+2)
      if(jCodeTwin+jCodeFlack.ne.0) NumDerParz=NumDerParz*2
!
!--creo mappa in memoria per l'equazioni normali (ex jfr22)
!  qui e' solo per informazioni: non e' la creazione per 
!  il calcolo effettivo dei minimi quadrati
!      
!      call PrintRefi(lo)
!--save restraint orig
      nresSav = nres
      vresSav = vres
      NumCond12_Sav =NumCond12
      idir12_Sav = idir12
      stringa12Tot_Sav = stringa12Tot
!     
      call CreaMnqd(jbb,ier,iStampa)
      if(iStampa.gt.1) call PrintMappaEqNor    ! stampa ex list 22
!--definisco dimensioni e alloco vettori per Eq. Normali      
      call MappaEqNor(ierM)
!	
!--controllo se devono essere affinati dei gruppi
      if(CodeGroup.gt.0) then
c--calcolo matrici di orientazione e le loro derivate        	   
         m=nats+1
         do i=1,NumGroup
            if(Jaffina(m).ne.0) then
               call calcderangMNQD(i)
            endif
            m=m+1
         enddo
c	   call PrintGroup(lo)
      endif
c      call PrintAtoms
c--check if observations are enough
      if(NoRefl.eq.0) then
         if(jb == 0) then
            if(nreflDim+nres-NParTot.lt.0) then
               write(Msg,9010) nreflDim, nres, NParTot
 9010          format('Number of rflcts',i4,' plus ',i3,' restraint(s)',
     2                ' less than the number of parameters',i4)
               call MsgWinErr('ERROR!', Msg, ERR_WINDOW, nExitCode)
               ier=-1
               return
            endif
         endif
      else
         jb=0
         jh=-1
         if(nres.eq.0) then
            write(ncwu,1041)
1041	      format(' Error : no restraints are present')
            goto 9000
         endif
      endif
c           
c--stampa condizioni del calcolo
      if(iverb.ge.0)  then  
        if(NoRefl.eq.0) then
          call PrintWeight(lo)
        else
          write(ncwu,1026)
1026      format(' Restraint(s) least squares refinement',5x,
     2           '(Vers. 3102)')
        endif
        if(LsqCF == 2) then
          call PrintRefi_RT(lo)
          call PrintCondizioni
          if(jCodeTwin.eq.1) then
            write(ncwu,9033)
9033        format('Refinement Twinning crystal')
            do i=1,3
               write(ncwu,'(5x,3f5.0)')xMatTwin(i,1:3)
            enddo
            write(ncwu,'(1h )')
          endif
          if(iautoLsq.eq.0) write(ncwu,9035) nCycleTot
9035	    format(' Cycle(s) requested  ',i3)
          if(iautoLsq.eq.1) write(ncwu,9037) nCycleTot
9037	format(' Cycle(s) requested ',i3,' or up to convergence')
          if(Dampi.ne.1.0) write(ncwu,'(9h Damping ,f8.3)') Dampi
          if(nres.gt.0) call PrintRestraint(1)
        end if
        write(ncwu,9301) nats
9301    format(' Number of atom(s)  ',i5)
        if(NumGroup.gt.0) write(ncwu,9302)NumGroup  
9302    format(' Number of group(s) ',i5)
      endif
      if(iprintNEW.eq.1)  call XTimeIN(2,'C.F.')
c      endif
3800  continue
c-------------------------------------------------------------
c  start loop di cicli di affinamento
c-------------------------------------------------------------
3805  continue
c-------------------------------------------------------------
      if(iprintNEW.eq.1) call XTimeIN(2,'C.F.+derivatves')
      call XTimeIN(6,'S.F.L.S. calculation time')
      Message=''
      write(Message,9002) rflsq,rwflsq,slsq
 9002 format('Cycle #',3x,'  R(F)% ( wR(F**2)% ) =',
     *        f6.2,' (',f6.2,')',' S =',f6.2)
      write(Message(8:10),'(i3)') nCycleCurr
      call shift(Message,lmsg)
      diret= Message(1:lmsg)
      cardImage = Message(1:lmsg)//'  Structure Factor Calculation'
      call scrper(cardImage,0,0)
!---------------------------------------------------        
      if(iverb.ge.0) then
        if(NoRefl.eq.0) then
            write(ncwu,9091) icodeFOch(icodeFO),nCycleCurr
9091        format(/,' Structure factor least squares calculation on ',
     2      a6,'cycle',i5,' starts')
        endif
      endif
!---------------------------------------------------        
      call MnqdLSQ(jkmn,iprintNEW,NumTwin,xMatTwin)
!      if (knw > 0) then      
!          call testLSQ(nCycleCurr, 1, 0, nreflX)
!         call examin(88,mkang,khl,ipub,iphaz,nreflX,0,wt,1)
!      endif
!--------------------------------------------------
      if(iprintNEW.eq.1) call XTimeOUT(2)
      if(jkmn.lt.0) goto 3820
!--
      if(iprintNEW.eq.1) call XTimeIN(2,'Matrix inversion and solve')
!
      write(diret(8:10),'(i3)') nCycleCurr
      call shift(diret,lmsg)
      cardImage = diret(1:lmsg)//'  Normal Matrix Inversion'
      call scrper(cardImage,0,0)
!
!      iverb=2
      Msg = ' '
!--------------------------------------------------	
      call Mnqd_solve(Berr_vector,ierS)
!--------------------------------------------------	
!	iverb=0
      if(iprintNEW.eq.1) call XTimeOUT(2)
      if(iverb.ge.0) then
        if(NoRefl.eq.0) then
            call XTimeOUT(6)
            write(ncwu,9090) nCycleCurr
9090        format(' Structure factor least squares calculation',
     2             i5,' ends')
        endif
      endif
      nCycleCurr=nCycleCurr+1
      nCycleTot=nCycleTot-1
!--------------------------------------------------	
!  controllo i valori del B(iso) 
!--------------------------------------------------	
!      if (ifAutoBtAn == 1) then
!          call B_check(iprintNEW, Berr_vector)
!      endif
!
!--controllo se devo fare altri cicli 
      if(nCycleTot.gt.0.and.ierS.eq.0) goto 3805  
!-------------------------------------------------
!--ultimo CF dopo lsq con tutti i dati
!-------------------------------------------------
      rflsq_Sav=rflsq
      rwflsq_Sav=rwflsq

!--ksubr= 11 carico tutti i  riflessi 
      ksubr=11
      ier=0
      call LeggiRiflessi(ier,ksubr)
      nreflX=NreflKsubr
!      
      if(iverb.ge.0) then        ! e' richiesta la stampa
        if(NoRefl.eq.0) then   ! affinamento con i riflessi
              write(lo,'(1h )')
              write(ncwu,9039)icodeFOch(icodeFO)
        endif
      endif
      call MnqdCF(iprintNEW,NumTwin,scalec1,xMatTwin)   ! calcolo Fc tutti i riflessi
!--aggiorno fc, fasi e w per tutti i riflessi      
      call AggiornaFasiPesiNew(ksubr,wt,iphaz,fcvet)
      rflsq=rflsq_Sav
      rwflsq=rwflsq_Sav
!--ricreo limiti      
      call CalcolaLimitData(1)
      DataMinLim =  TempMinLim 
      DataMaxLim =  TempMaxLim
      call CalcolaLimitData(3)
      AgreMinLim =  TempMinLim 
      AgreMaxLim =  TempMaxLim
      call CalcolaLimitData(2)
      UserMinLim =  TempMinLim 
      UserMaxLim =  TempMaxLim
!--------------------------------------------------      
      if(iverb.ge.0) then
c--stampo R% per chop=4 , attuale e 0
         wdft4=0.0
         rw4=0.0 
         sumDF4=0.0
         sumF4=0.0
         num4=0
!         
         wdft3=0.0
         rw3=0.0 
         sumDF3=0.0
         sumF3=0.0
         num3=0
!         
         wdft0=0.0
         rw0=0.0 
         sumDF0=0.0
         sumF0=0.0
         num0=0
!         
         iCut=nint(cutoff)
         xchop=float(iCut)
         write(line,'(i5)')iCut
         call shift(line,lCut)
         line=' Fo>'//line(1:lCut)//'*sig(fo)'
         call shift(line,lCut)
         do i=1,nreflTot
            xsigmav=sigmav(i)
            w=wt(i)
            a=w*fovet(i)
            df=abs(fovet(i) - FcScale *fcvet(i))
            wdf=w*df
!--all the reflections            
            num0=num0+1
            sumF0=sumF0+fovet(i)
            sumDF0= sumDF0 + df
            wdft0=wdft0+wdf*wdf
            rw0=rw0+a*a 
c      write(lo,'(i8,3i5,3f10.2)')i,khl(1,i),khl(2,i),
c     *	khl(3,i),fovet(i),xsigmav,fcvet(i)           
            if(fovet(i).ge.4.0*xsigmav) then
            if(CodeRefl(i).ge.0) then
               num4=num4+1
               sumF4=sumF4+fovet(i)
               sumDF4= sumDF4 + df
               wdft4=wdft4+wdf*wdf
               rw4=rw4+a*a 
            endif
            endif
            if(CodeRefl(i).eq.0) then
c            if(fovet(i).ge.xchop*xsigmav) then
               num3=num3+1
               sumF3=sumF3+fovet(i)
               sumDF3= sumDF3 + df
               wdft3=wdft3+wdf*wdf
               rw3=rw3+a*a 
            endif
         enddo
!         
         rflsq0=100.0*sumDF0/sumF0
         rwflsq0=100.0*sqrt(wdft0/rw0)
         slsq0=sqrt(wdft0/(num0+nres-NParTot))
!         
         rflsq3=100.0*sumDF3/sumF3
         rwflsq3=100.0*sqrt(wdft3/rw3)
         slsq3=sqrt(wdft3/(num3+nres-NParTot))
!         
         rflsq4=100.0*sumDF4/sumF4
         rwflsq4=100.0*sqrt(wdft4/rw4)
         slsq4=sqrt(wdft4/(num4+nres-NParTot))
!         
         write(ncwu,9338) rflsq0,rwflsq0 
9338     format(' R(F)%  ( wR(F**2)% )..',f7.3,' (',f7.2,') and ')
         write(ncwu,9339)slsq0,num0 
9339     format(' Goodnes of fit........',f7.3,
     *          ' for',i6,' all Fo' )
         write(ncwu,9334) rflsq3,rwflsq3
9334     format(' R(F)%  ( wR(F**2)% )..',f7.3,' (',f7.2,') and ')
         write(ncwu,9337)slsq3,num3,line(1:lCut) 
9337     format(' Goodnes of fit........',f7.3,
     *          ' for',i6,1x,a )
         write(ncwu,9335) rflsq4,rwflsq4 
9335     format(' R(F)%  ( wR(F**2)% )..',f7.3,' (',f7.2,') and ')
         write(ncwu,9336)slsq4,num4 
9336     format(' Goodnes of fit........',f7.3,
     *          ' for',i6,' Fo>4*sig(fo)' )
!     
         rflsq=rflsq3
         rwflsq=rwflsq3
!     
!--Restraint(s) summary
         if(nres.gt.0) call PrintRestraint(2)
      endif
!     
      errem = rflsq 
      erre  = rflsq / 100.0
!      
!--write bad reflections
      if(NoRefl.eq.0) then
         if(iverb.ge.0) then
            if(nbad.gt.0) then
              write(ncwu,9097)
9097	        format(/,' Bad reflections having (Fo-Fc) > 3*sigma(Fo)',/,
     2           '  H   K   L      Fo        Fc       (Fo-Fc)    S(Fo)')
               mbuffo=1
               mdbuffo=7
               do i=1,nbad
                  buffo(mbuffo+5)=buffo(mbuffo+3)-buffo(mbuffo+4)
                  write(ncwu,9096)(buffo(mbuffo+n-1),n=1,7)
9096	            format(3f4.0,4f10.2)
                  mbuffo=mbuffo+mdbuffo
               enddo
               if(nbadx.gt.20) write(ncwu,9098)nbadx
9098	                         format(' and so on (',i6,')....')
            endif
         endif
      endif
!
!--------------------------------------------------
!  fine calcoli fattori o lsq      
!--------------------------------------------------
3820  continue
!--------------------------------------------------
!--ripristino restraint e direttive default if refine
!--------------------------------------------------
      if(LsqCF.eq.2) then      
         nres = nresSav
         vres = vresSav
         NumCond12 =NumCond12_Sav
         idir12 = idir12_Sav
         stringa12Tot = stringa12Tot_Sav
      endif
!
!--controllo se sono presenti atomi di idrogeno e aggiorno i B(iso)
!  se dati da RX o elettroni
      if(neutro.ne.1)  then
            jFlagAtom(1:nats)=0
            do jy=1,nats
               ksp=nzTot(jy)
               if(no(ksp).eq.1)jFlagAtom(jy)=1  
            enddo 
!-----------Loop sulla connettivita'  
            m=2
            do in=1,iconn(1)
               inn =iconn(m  )
               innn=iconn(m+1)
               if(jFlagAtom(inn).eq.1)then
                  bfac(inn )= 1.3 * bfac(innn)      
               else if(jFlagAtom(innn).eq.1)then
                  bfac(innn)= 1.3 * bfac(inn)      
               endif
               m=m+3
            enddo
      endif
!---------------------------------------------------      
!--stampo lista 5 finale
      if(iverb.ge.0) then
        if(NoRefl.eq.0) then
          if(LsqCF.eq.2) then
             call PrintAtoms
!--check if a list 13 exist
!gl!
             lj = InfoOK(13)
!gl!
             if(lj.gt.0) then
                call PrintGroup(lo)
             endif
         endif
        endif
      endif      
!--stampa test se struttura nota      
!      if (knw > 0) then
!            call testLSQ(nCycleCurr-1, 2, 1, nreflX)
!           call examin(99,mkang,khl,ipub,iphaz,nreflX,0,wt,1)
!           call to_coord_sir(1,nreflX)
!      endif
      call XTimeOUT(1)
      return
c--error
9000  continue
      write(Msg,'(22h Error in directive : ,a)') diret(1:ldiret)
      call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
9100  continue
      ier=-1
      return
      end
c
code for MnqdCF                                                          
      subroutine MnqdCF(iprintNEW,NumTwin,scalec1,xMatTwin)
c--structure factor calculation                                         
c--icodeFO =  1 Fo
c             2 Fo**2  
c--useage of control variables:
c  ja  set to 1 for iso atoms only, else n2	 (not used)
c  jb  set to -1 for no refinement, else 0                              
c  jc  set to -1 for only calculate cos, else 0                         
c  jd  set to -1 for centro, else 0                                     
c  je  set to -1 for no anomalous dispersion, else 0                    
c  jf  current value of jb,set for each atom if jb=0                    
c  jg  set to -1 for no print, else the number  of lines before page    
c  jh  set to -1 if the scale factor is not to be refined, else 0       
c  nCycleTot  (ex ji)  cycle number                                                     
c  nCycleCurr (ex jl)  current cycle number                                             
c  jm  set to -1 for clear the initial fc, else 0                       
c  jn  dummy location for non-refined parameters                        
c  jo  address complete partial derivatives                             
c  jp  last address complete partial derivatives
c n22z  number of partial derivatives per reflection (0,1,2 or 4)        
c  jr  address normal equations matrix                                  
c  js  work variable                                                    
c  jt  work variables used during accumulation of partial derivatives   
c  ju                                                                   
c  jv                                                                   
c  jw                                                                   
c  jx  loop variable for equivalent positions                           
c  jy  loop variable for atoms                                          
c  jz  address of the shifts
c--useage of general variables                                          
c  tc   coefficient  for the iso-temperature factors                    
c  sst  sin(theta)/lambda squared                                       
c  st   sin(theta)/lambda                                               
c  focc form factor multiplied by the occupation number                 
c  t    temperature factor                                              
c  tfocc t*focc                                                         
c  ap   a part for each symmetry position for each atom                 
c  bp   b part for each symmetry position  for each atom                
c  at   total a part for each atom                                      
c  btt	total b part for each atom
c  ac   total real a part for the reflection                            
c  bc   total real b part for the reflection                            
c  aci  total imaginary a part for the reflection                       
c  bci  total imaginary b part for the reflection                       
c  act  total a part for the reflection                                 
c  bct  total b part for the reflection                                 
c  apd  partial derivatives for each atom with respect to a             
c  bpd  partial derivatives for each atom with respect to b             
c  fo   scaled fo                                                       
c  fc   fc on absolute scale                                            
c  p    phase angles in radians                                         
c  w    square root of the weight for this reflection                   
c  df   difference between fo and fc                                    
c  wdf  weighted difference between fo and fc                           
c  fot  sum of fo                                                       
c  fct  sum of fc                                                       
c  dft  sum of abs(df)
c  wdf  minimization function - sum weighted difference squared         
c  rw   hamilton weigthed r value                                       
c  r    normal weighted value                                           
c  x    (1./-1.) factor which multiplies the current fc                 
c  z    damping factor to be applied to positional parameter
c  y    (=z for standard refinement) to be applied to thermal parameter
c--
      USE General
      USE Symmetry
      USE Riflessi
      USE Molcom
      USE Atomi
      USE PhaseModule
      USE LsqModule
c--
      real xMatTwin(3,3)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz                  
c
      dimension att(2),btt(2),ac(2),bc(2),aci(2),bci(2),act(2),bct(2)
      dimension fcext(2),Fkhleq(10 ,98,2),fxx(3),fxx1(3)
c
      data xvalmin/0.000001/                                     
c--      
      scale =1.0/FcScale
      scalec1=FcScale
      if(iverb.ge.0) then
        if(NoRefl.eq.0) then
              write(lo,9139) FcScale
9139          format(' Scale (Fc).......',f10.5)
        endif
      endif
900   continue
c--definisco alcune variabili
      indch=cutoff+0.005
c--set variables for Twinning
      xflack=FcTwin
      if(xflack.le.0.0) xflack=0.0
      if(xflack.ge.1.0) xflack=1.0
      FcTwin=xflack
      unomenoxflack=1.0-xflack
c--set up the extiction variable
      ext0=0.0
      ext1=1.0
      ext2=1.0
      ext3=1.0
      delta=0.0
c--check if the extinction parameter should be used
      if(FcExtin.gt.0) then
         ext0=FcExtin
         pol1=1.
         pol2=1.0
         theta1=Theta2*dtor
         del=wavel*wavel/(volume*volume)
         if(neutro.ne.2) then
c--we are using x-rays
            del=del*wavel*0.0794
c--set up the polarization constants
            pol1=cos(theta1)
            pol1=pol1*pol1
c	      write(ncwu,*) 'del,pol1',del,pol1
         endif
      endif
c===================================================                            
c--azzera variabili e vettori per totali (+H) + (RH)
c===================================================                            
      fot=0.0
      fct=0.0
      dft=0.0
      wdft=0.0
      sumWDiff = 0.0
      rw=0.0
c--azzera unteriori variabili     
      wrob=0.0
      sumdif=0.0
      nchg=0
      n4z=0
!=====================================================
!--start the loop over the reflections
!=====================================================
      nperc=100
      iperc0=nreflX/nperc
      iperc=iperc0
      jperc=0
c--pick up the next reflection                                          
      do kj=1,nreflX
         if (kj.eq.iperc) then
           jperc=jperc+1
           iperc=iperc+iperc0
           call scrper(' ',jperc,nperc)
         endif
c--azzera per H & RH
         ac(:)=0.                    
         bc(:)=0.                    
         aci(:)=0.0                
         bci(:)=0.0                
         act(:)=0.0                
         bct(:)=0.0
         fcext(:)=0.0
!====================================================
!--store the information for the symmetry positions
!====================================================
         do j=1,nsym
            do jtw=1,NumTwin
               do m=1,3
                  fxx(m)=0.
                  do n=1,3
                     fxx(m)=fxx(m)+khl(n,kj)*kmat(j,n,m)
                  enddo
               enddo  
c--check se Twinning e' presente
               if(jtw.eq.2) then
c**moltiplicazione di una matrice 3x3 ed un vettore a 3 (da plot2006.f)
                  call vrgv(fxx,xMatTwin,fxx1)
                  fxx(1:3)=fxx1(1:3)
               endif
               Fkhleq(1 ,j,jtw)=fxx(1)*twopi
               Fkhleq(2 ,j,jtw)=fxx(2)*twopi
               Fkhleq(3 ,j,jtw)=fxx(3)*twopi   
c--calculate the h.t terms
               Fkhleq(4 ,j,jtw)=0.
               do m=1,3
               Fkhleq(4 ,j,jtw)=Fkhleq(4 ,j,jtw)+khl(m,kj)*tmat(j,m)
c               Fkhleq(4 ,j,jtw)=Fkhleq(4 ,j,jtw)+fxx(m)*tmat(j,m)
               enddo  
c--end to calculate the h.t terms
               Fkhleq(4 ,j,jtw)=Fkhleq(4 ,j,jtw)*twopi
c--aniso contributions
               Fkhleq(5 ,j,jtw)=fxx(1)*fxx(1)
               Fkhleq(6 ,j,jtw)=fxx(1)*fxx(2)
               Fkhleq(7 ,j,jtw)=fxx(1)*fxx(3)
               Fkhleq(8 ,j,jtw)=fxx(2)*fxx(2)
               Fkhleq(9 ,j,jtw)=fxx(2)*fxx(3)
               Fkhleq(10,j,jtw)=fxx(3)*fxx(3)
            enddo         
         enddo
!====================================================
c--pick up fo, sigma(f) & sin(theta)/lambda squared
!====================================================
         fo=fovet(kj)           !  FATTORE OSSERVATO  FO
         sigmaf=sigmav(kj)      !  SIGMA(FO)
         sst=rhov(kj)
         st=sqrt(sst)
         tc=-sst
c--calculate the forms factors
         call scattMnqd(sst)
c--calculate the ratio of the imaginary to real form factors
!--multiply real form factor for (lattice code) and (centrosymmetry)
         do ij=1,nk
            fsecondoMnqd(ij)=fsecondo(ij) / ff(ij)
            ff(ij) = ff(ij) * CentXNlatt
         enddo
!==========================================                             
!--start of the loop based on the atoms                                 
!==========================================                             
         do jy = 1 , nats
!--azzera per H, RH
            att(:)=0.
            btt(:)=0.
!==========================================                             
!--pick up the form factors for this atom
!==========================================
            ksp=nzTot(jy)
            focc=ff(ksp)*xyzs(5,jy)                                 
c--check if mixed atoms
            if (iSite(jy) > 0) then
               imix=iSite(jy)
               do jj=1, imix
c--pick up the form factors for mixed atoms
                  ksp1 = int(SiteInfo(jj,jy)) / 10    ! specie
                  occ  = amod(SiteInfo(jj,jy),10.0)   ! occupazione
                  focc=focc+ff(ksp1)*occ
               enddo
            endif
c--end for mixed atoms
c--check the temperature type for this atom
            if(isoaniso(jy).eq.2) then     ! atomo isotropo
               tfocc = focc * exp(bfac(jy)*tc)
            endif
c====================================================================
c--loop cycling over the different cristalliti (twin or Flack code)
c====================================================================
            do  jtw=1,NumTwin
c====================================================================
c--loop cycling over the different equivalent positions for this atom
c====================================================================
               do jx=1,nsym 
                  a=Fkhleq(4,jx,jtw)
                  do n=1,3
                     a=a+xyzs(n,jy)*Fkhleq(n,jx,jtw)
                  enddo
c--check the temperature factor type
                  if(isoaniso(jy).eq.1) then     ! atomo anisotropo
                     txtot=0.0
                     do n=1,6
                        txtot=txtot+Bij(n,jy)*Fkhleq(n+4,jx,jtw)
                     enddo
                     t=exp(-txtot)
                     tfocc=t*focc                    
                  endif
c==========================================                             
c--calculate the sin/cos terms
c==========================================                             
c--calculate the a contribution 
                  c=cos(a)
                  ap=c*tfocc                                   
                  att(jtw)=att(jtw)+ap                        
                  bp=0.0
                  if(icent.eq.0) then                       
c--calculate the b contribution                                         
                     s =sin(a)                                          
                     bp=s*tfocc                              
                     btt(jtw)=btt(jtw)+bp
                  endif
c==========================================                             
c--end of loop on equivalent position ends                                     
c==========================================                             
               enddo                                    
c=========================================================
c--end of cycling over the different equivalent positions 
c  if twining is preesent  HR=H.MatTwin
c=========================================================
            enddo
c=========================================================
c--ROUTINE finali per questo atomo     
c=========================================================
c--accumulate the totals for this atom 
c--relativo ad H e RH
            do jtw=1,NumTwin
               ac(jtw)=ac(jtw)+att(jtw)                                       
               bc(jtw)=bc(jtw)+btt(jtw)
               if(je.eq.0)then 
c--calculate the immaginary parts                                       
c--relativo ad H
                 aci(jtw)=aci(jtw)-btt(jtw)*fsecondoMnqd(ksp)
                 bci(jtw)=bci(jtw)+att(jtw)*fsecondoMnqd(ksp)
               endif
            enddo
c================================================
c--end of atom cycling loop
c================================================
         enddo
c================================================
c--final calculation for the current reflections
c================================================
         if(icent.eq.1) then    ! centrosym
            bc(:)=0.0
            aci(:)=0.0
         endif
c--operazioni su H & RH
         do jtw=1,NumTwin
            act(jtw)=ac(jtw)+aci(jtw)
            bct(jtw)=bc(jtw)+bci(jtw)
            if(abs(act(jtw))-xvalmin.le.0.0) act(jtw)=xvalmin
            if(abs(bct(jtw))-xvalmin.le.0.0) bct(jtw)=xvalmin
            fcext(jtw)=sqrt(act(jtw)*act(jtw)+bct(jtw)*bct(jtw)) 
         enddo
c--calcolo valori per (H)+(RH)
         fcToT=unomenoxflack*fcext(1)+xflack*fcext(2)
         acToT=unomenoxflack*act(1)+xflack*act(2)
         bcToT=unomenoxflack*bct(1)+xflack*bct(2)
         pToT=atan2(bcToT,acToT)
         pToT=pToT*rtod
         if(pToT.lt.0)pToT=pToT+360.0
c================================================
c--check if we should include extinction
c================================================
         if(FcExtin.gt.0) then
c--calcolo il 2theta
           a=amin1(1.0,wavel*st)
           a=asin(a)*2.0
c--set the mean path length = 1.0
           pathmean=1.0
c--compute delta for neutrons
           delta=del*pathmean/sin(a)
c	     write(ncwu,*)'a,delta',a,delta
           if(neutro.ne.2) then
c--we are using x-rays
              a=cos(a)
              a=a*a
c--calcolo delta che tiene conto del fattore di polarizzazione
              delta=delta*(pol1+pol2*a*a)/(pol1+pol2*a)
c	write(ncwu,*)'delta,pol1,pol2,a',delta,pol1,pol2,a
           endif
c--compute the modified /fc/
           fc=fcTot
           ext1=1.0+2.0*ext0*fc*fc*delta
           fcToT=fc*(ext1**(-0.25))
           ext2=1.0+ext0*fc*fc*delta
           ext3=ext2/(ext1**(1.25))
c	     write(ncwu,*)'ext0,ext1,ext2,ext3,fc,fcTot,fo',
c     1	   ext0,ext1,ext2,ext3,fc,fcTot,fo
         endif
c================================================
c--calculate the square-root of the weight ( = w )
c================================================
         fcexs=fcTot*FcScale 
         if(icodeFo.eq.1) then
              xfo=fo
              xfcexs=fcexs
              xsigmaf=sigmaf
         else
              xfo=fovet2(kj)
              xfcexs=fcexs*fcexs
              xsigmaf=sigmav2(kj)
         endif
         call CalcWeight(xfo,xfcexs,xsigmaf,st,w,n4z)
         if(icodeFo.eq.2) then
             if(nWeight.eq.6) w=w*0.01
         endif
         wt(kj)=w
         wrob=wrob+w*abs(xfo-xfcexs)
c--store Fc and phase
         fcvet(kj)=fcToT
         iphaz(kj)=pToT
c================================================================
c--add in the computed values for /Fc/ etc. to the overall totals
c================================================================
         a=w*fo
         fcToTs=fcToT*FcScale
         df=fo-fcToTs
         df1=abs(df)        
         wdf=w*df
         fot=fot+fo
         fct=fct+fcToT
         dft=dft+df1
c         write(lo,*) kj,fo,fcToTs,df1,fot,dft
c--check if refinenment on Fo or (Fo)**2      
         if(icodeFO.eq.2) then
           a=fovet2(kj)
           df=a-fcToTs*fcToTs
           wdf=w*df
           a=w*a
         endif  
         sumWDiff=sumWDiff+wdf*wdf  
         wdft=wdft+wdf*wdf
         rw=rw+a*a 
c================================================================
c--check if a print of the reflections is needed
c================================================================
         if(jg.ge.0) then
            if(jg.eq.0) then
               write(ncwu,8060)
8060     format(1h1,3x,1hh,3x,1hk,3x,1hl,4x,4h/fo/,4x,4h/fc/,6h phase,
     2          3x,' d/f/ (w)*d/f/',2x,7hsinth/l,/)
             jg=57
            endif
c	      jg=jg-1
            uj=fo*scale
            vj=wdf*scale
            wj=df*scale
            ihh=khl(1,kj)
            ikk=khl(2,kj)
            ill=khl(3,kj)
            write(ncwu,8080)ihh,ikk,ill,uj,fcTot,pTot,wj,vj,st
8080	      format(1x,3i4,2f8.1,f6.1,2f7.1,f12.5)
         endif
!===================================================
!--fine loop over the reflections
!===================================================
      enddo
!==========================================
!--write the r values
!==========================================
      rflsq =100.0*dft/fot
      rwflsq=100.0*sqrt(wdft/rw)
      if(jh.eq.0) then      
!--calcolo alternativo  
         scalec1=fot/fct
         if(iverb.ge.0) then
            write(ncwu,9304)scalec1
9304        format(  ' New Scale (Fc)...',f10.5)
         endif
         FcScale=scalec1 
         sumDF1=0.0
         wdft=0.0
         rw=0.0
         do i=1,nreflX
            df=fovet(i) - scalec1 *fcvet(i)
            w=wt(i)
            wdf=w*df
            a=w*fovet(i)
            sumDF1= sumDF1 + abs(df)
            wdft=wdft+wdf*wdf
            rw=rw+a*a 
         enddo
         rflsq=100.0*sumDF1/fot
         rwflsq=100.0*sqrt(wdft/rw)
      endif
      if(iverb.ge.0) then
         if(LsqCF == 1) then
             write(ncwu,9310)  indch 
9310         format(' Threshold=n*s(Fo)',i6)
             write(ncwu,9320) nreflX
9320         format(' No. reflections ', i7)
             write(ncwu,9315) rflsq 
9315         format('  R(F)% .........',f7.3)
             write(ncwu,9316)rwflsq 
9316         format(' wR(F**2)% ......',f7.3)
             write(ncwu,9056)wdft
9056         format(' Minimization function = ',f20.4)
         endif
      endif
c==========================================
c--end of writing--------------------------
c==========================================
!      if (jscreen > 0 .and. InfoOK(15) > 0) then
!          iAngolo = 0
!          ifSca = 0
!          call Disegna(ifSca)
!      endif
!
      errem = rflsq 
      erre  = rflsq / 100.0
c      
c--terminate the output of list 6
c      if(NoRefl.eq.0) then
c--rewrite the preamble block
c         call UpdateReflInfo
c      endif
      return
      end
c
code for MnqdLSQ                                                          
      subroutine MnqdLSQ(jkmn,iprintNEW,NumTwin,xMatTwin)
c--least squares calculation 
!  jkmn = -1  Error
!  jkmn = 0   ciclo ok
!  jkmn = 1   ultimo ciclo                                        
c--icodeFO =  1 Fo
c             2 Fo**2  
c--useage of control variables (see MnqdCF routine)
c--
      USE General
      USE Symmetry
      USE Riflessi
      USE Molcom
      USE Atomi
      USE PhaseModule
      USE LsqModule
      USE LsqStuff
      USE LsqStuff22
      USE LsqStuff22Abs
!      
      real xMatTwin(3,3)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z  
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz                  
c
      dimension ap(5),bp(5),tfocc(5),focc(5)
      dimension att(2),btt(2),ac(2),bc(2),aci(2),bci(2),act(2),bct(2)
      dimension fcext(2),Fkhleq(10 ,98,2),fxx(3),fxx1(3)
      character*8 modiat(5)
c
      dimension xyzapd(2,3),xyzbpd(2,3)
      dimension apd(2,19),bpd(2,19)
      dimension nb(19),wfw(19),iadr(19)
c
      data xvalmin/0.000001/                                     
c--      
      jkmn=0
      sumWDiff_Prev=sumWDiff
!      wdfto=d
      Message = ' '
      mdbuffo=7
      lbuffo=1
      mbuffo=lbuffo-mdbuffo
      buffo(:)=0.0
      nbad=0
      nbadx=0
      FoScale =1.0/FcScale
      FcScale2=FcScale*FcScale
      if(iverb.ge.0) then
        if(NoRefl.eq.0) then
              write(ncwu,9139) FcScale
9139          format(' Scale (Fc)......',f10.5)	 
        endif
      endif
900   continue
c--definisco alcune variabili
      indch=cutoff+0.005
      ifat=2**15
      jd=-icent
      pi2=pi/2.0
      jc=0
      if(jd.lt.0) then
       if(jb.lt.0) then
          jc=-1
       endif
      endif
      nmodi=0
      modiat(:)=' '
      dd=1.0/twopi
c===========================================
c--set variables for Twinning
      xflack=0.0
      if(jCodeFlack.ne.0)xflack=FcPola
      if(jCodeTwin.ne.0) xflack=FcTwin
      if(xflack.le.0.0) xflack=0.0
      if(xflack.ge.1.0) xflack=1.0
      unomenoxflack=1.0-xflack
      unomenox2flack=1.0-2.0*xflack
c--set up the extiction variable
      ext0=0.0
      ext1=1.0
      ext2=1.0
      ext3=1.0
      delta=0.0
c--check if the extinction parameter should be used
      if(FcExtin.gt.0) then
         ext0=FcExtin
         pol1=1.
         pol2=1.0
         theta1=Theta2*dtor
         del=wavel*wavel/(volume*volume)
         if(neutro.ne.2) then
c--we are using x-rays
            del=del*wavel*0.0794
c--set up the polarization constants
            pol1=cos(theta1)
            pol1=pol1*pol1
c	      write(ncwu,*) 'del,pol1',del,pol1
         endif
      endif
c===========================================
!      NumBlockTot (ex n22)  = numero di blocchi (usato anche nBlocks)
!      NParTot (ex n22a) = numero di parametri da affinare
!      DimMatMax (ex n22y) = numero massimo (matrice triangolare)
!      NParBlMax (ex n22x) = numero massimo di parametri per blocco
!      NumDerParz= ex jq  numero di derivate parz. per parametro
!-- vettori(2 vuol dire: 1 pos per atomo, 2 pos per parametro): 
!                  ParAddr(NumBlockTot,NParBlMax,2)
!                  EquaNorm(DimMatMax,NumBlockTot)   
!                  VettNorm(NParBlMax,NumBlockTot)   
!                  DeriPerz(1:NumBlockTot,1:NParBlMax,1:NumDerParz)
!                  DeriTot(1:NumBlockTot,1:NParBlMax)
c--clear the matrix areas to zero
          EquaNorm(:,:)=0      
          VettNorm(:,:)=0      
c===========================================
c--set up constants for partial derivative accumulation                 
         if(jd.lt.0) then
c--centro     without anomalous dispersion 
           in1=1                   
c--centro     with    anomalous dispersion                              
           if(je.eq.0) in1=2
         else
c--non-centro without anomalous dispersion                              
           in1=3
c--non-centro with    anomalous dispersion                              
           if(je.eq.0) in1=4
         endif
c===========================================
c--check if the refinement without reflectione is required
      if(NoRefl.eq.1) then
        if(nres.gt.0) call xrestrMNQD
        goto 9080    
      endif
c===================================================                            
c--azzera variabili e vettori per totali (+H) + (RH)
c===================================================                            
      fot=0.0
      fct=0.0
      dft=0.0
      wdft=0.0
      sumWDiff = 0.0
      rw=0.0
c--azzera unteriori variabili     
      if(nCycleCurr.eq.1) wrob=0.0
      sumdif=0.0
      nchg=0
      n4z=0
!
      if(iprintNEW.eq.1) call XTimeIN(3,'Accumul')
      if(iprintNEW.eq.1) call XTimeIN(4,'Derivatives')
      if(iprintNEW.eq.1) call XTimeIN(5,'Loop interno')
!
!=====================================================
!--start the loop over the reflections
!=====================================================
      nperc=100
      iperc0=nreflX/nperc
      iperc=iperc0
      jperc=0
c--pick up the next reflection                                          
      do kj=1,nreflX
         if (kj.eq.iperc) then
           jperc=jperc+1
           iperc=iperc+iperc0
           call scrper(' ',jperc,nperc)
         endif
c--azzera per H & RH
         ac(:)=0.                    
         bc(:)=0.                    
         aci(:)=0.0                
         bci(:)=0.0                
         act(:)=0.0                
         bct(:)=0.0
         fcext(:)=0.0
!====================================================
!--store the information for the symmetry positions
!====================================================
         do j=1,nsym
            do jtw=1,NumTwin
               do m=1,3
                  fxx(m)=0.
                  do n=1,3
                     fxx(m)=fxx(m)+khl(n,kj)*kmat(j,n,m)
                  enddo
               enddo  
c--check se Twinning e' presente
               if(jtw.eq.2) then
c**moltiplicazione di una matrice 3x3 ed un vettore a 3 (da plot2006.f)
                  call vrgv(fxx,xMatTwin,fxx1)
                  fxx(1:3)=fxx1(1:3)
               endif
               Fkhleq(1 ,j,jtw)=fxx(1)*twopi
               Fkhleq(2 ,j,jtw)=fxx(2)*twopi
               Fkhleq(3 ,j,jtw)=fxx(3)*twopi   
c--calculate the h.t terms
               Fkhleq(4 ,j,jtw)=0.
               do m=1,3
               Fkhleq(4 ,j,jtw)=Fkhleq(4 ,j,jtw)+khl(m,kj)*tmat(j,m)
c               Fkhleq(4 ,j,jtw)=Fkhleq(4 ,j,jtw)+fxx(m)*tmat(j,m)
               enddo  
c--end to calculate the h.t terms
               Fkhleq(4 ,j,jtw)=Fkhleq(4 ,j,jtw)*twopi
c--aniso contributions
               Fkhleq(5 ,j,jtw)=fxx(1)*fxx(1)
               Fkhleq(6 ,j,jtw)=fxx(1)*fxx(2)
               Fkhleq(7 ,j,jtw)=fxx(1)*fxx(3)
               Fkhleq(8 ,j,jtw)=fxx(2)*fxx(2)
               Fkhleq(9 ,j,jtw)=fxx(2)*fxx(3)
               Fkhleq(10,j,jtw)=fxx(3)*fxx(3)
            enddo         
         enddo
!====================================================
c--pick up fo, sigma(f) & sin(theta)/lambda squared
!====================================================
         fo=fovet(kj)           !  FATTORE OSSERVATO  FO
         sigmaf=sigmav(kj)      !  SIGMA(FO)
         sst=rhov(kj)
         st=sqrt(sst)
         tc=-sst
c--calculate the forms factors
         call scattMnqd(sst)
c--calculate the ratio of the imaginary to real form factors
!--multiply real form factor for (lattice code) and (centrosymmetry)
         do ij=1,nk
            fsecondoMnqd(ij)=fsecondo(ij) / ff(ij)
            ff(ij) = ff(ij) * CentXNlatt
         enddo
!--clear the partial derivative areas to zero
         DeriPerz(:,:,:)=0
         DeriTot(:,:)=0
!==========================================                             
!--start of the loop based on the atoms                                 
!==========================================                             
         do jy = 1 , nats
!--azzera componenti per occupanze > 1
            focc(:)=0.0
            tfocc(:)=0.0
            ap(:)=0.0
            bp(:)=0.0         
!--azzera------------------------------ 
            att(:)=0.
            btt(:)=0.
!--            
            nb(:)=0
            iadr(:)=0
            wfw(:)=0.0
c--clear partial derivative stacks                                      
c--relativo ad H, RH
            apd(:,:)=0.0
            bpd(:,:)=0.0
            jf=Jaffina(jy)       ! if jf > 0 , atomo da affinare
c--set codes *** Gruppo ****
            igrcode= nGrCode(jy)
            nacode = nGrAtCode(jy)
!--loop sui parametri atomici            
            do i=1,nPar15
               nb(i)   = nParBl(i,jy)
!--DeriPerz(1:NumBlockTot,1:NParBlMax,1:NumDerParz)
               iadr(i) = nAddrDer(i,jy) 
               wfw(i)  = iEquiv(i,1,jy)/1000.0
            enddo
!==========================================                             
!--pick up the form factors for this atom
!==========================================
            ksp=nzTot(jy)
            focc(1)=ff(ksp)*xyzs(5,jy)
            icT=1                                 
c--check if mixed atoms
            if (iSite(jy) > 0) then
               imix=iSite(jy)
               do jj=1, imix
c--pick up the form factors for mixed atoms
                  ksp1 = int(SiteInfo(jj,jy)) / 10    ! specie
                  occ  = amod(SiteInfo(jj,jy),10.0)   ! occupazione
                  focc(jj+1)=ff(ksp1)*occ
                  icT=icT+1
               enddo
            endif
c--end for mixed atoms
c--check the temperature type for this atom
            if(isoaniso(jy).eq.2) then     ! atomo isotropo
               do i=1,icT
                  tfocc(i) = focc(i) * exp(bfac(jy)*tc)
               enddo
            endif
c====================================================================
c--loop cycling over the different cristalliti (twin or Flack code)
c====================================================================
            do  jtw=1,NumTwin
c====================================================================
c--loop cycling over the different equivalent positions for this atom
c====================================================================
               do jx=1,nsym 
                  a=Fkhleq(4,jx,jtw)
                  do n=1,3
                     a=a+xyzs(n,jy)*Fkhleq(n,jx,jtw)
                  enddo
c--check the temperature factor type
                  if(isoaniso(jy).eq.1) then     ! atomo anisotropo
                     txtot=0.0
                     do n=1,6
                        txtot=txtot+Bij(n,jy)*Fkhleq(n+4,jx,jtw)
                     enddo
                     t=exp(-txtot)
                     do i=1,icT
                        tfocc(i)=t*focc(i)  
                     enddo                  
                  endif
c==========================================                             
c--calculate the sin/cos terms
c==========================================                             
c--calculate the a contribution 
                  c=cos(a)
                  do i=1,icT
                     ap(i)=c*tfocc(i)
                  enddo 
                  apToT=0
                  do i=1,icT
                     apToT=apToT+ap(i)
                  enddo 
                  att(jtw)=att(jtw)+apTot                        
c--calculate the b contribution                                         
                  s =sin(a) 
                  do i=1,icT
                     bp(i)=s*tfocc(i)
                  enddo 
                  bpToT=0
                  do i=1,icT
                     bpToT=bpToT+bp(i)
                  enddo 
                  btt(jtw)=btt(jtw)+bpToT
c=========================================================
c--check if any refinement is being done
c=========================================================
                  if(jf.gt.0)then  
                     if(iprintNEW.eq.1)call XTimeINParz(4)
c--calculate the partial derivatives for a,a w.r.t.x,y,z
                     do k=1,3
                        if(nParBl(k,jy).ne.0.or.igrcode.gt.0) then 
                           xyzapd(jtw,k)=-Fkhleq(k,jx,jtw)*bpToT
                           apd(jtw,k)   =apd(jtw,k) + xyzapd(jtw,k)
c--check if the structure is non centro
                           if(icent.eq.0)then
                              xyzbpd(jtw,k)=Fkhleq(k,jx,jtw)*apToT
                              bpd(jtw,k)   =bpd(jtw,k) +xyzbpd(jtw,k)
                           endif
                        endif
                     enddo
c--check the temperature factor type
                     if(isoaniso(jy).eq.2) then     ! atomo isotropo 
c--calculate the partial derivatives for a,b w.r.t.b(iso)
                        k=4
                        if(nParBl(k,jy).ne.0)then
                           tcap= tc*apToT
                           apd(jtw,k) =apd(jtw,k) +tcap
                           if(icent.eq.0) then
                              tcbp=tc*bpToT 
                              bpd(jtw,k) =bpd(jtw,k) +tcbp
                           endif
                        endif
                     else
c--calculate the partial derivatives  for a,b w.r.t.the aniso-terms     
                        do k=5,10
                           if(nParBl(k,jy).ne.0) then
                              Fkhleqap=Fkhleq(k,jx,jtw)*apToT
                              apd(jtw,k) =apd(jtw,k) -Fkhleqap
                              if(icent.eq.0) then 
                                 Fkhleqbp=Fkhleq(k,jx,jtw)*bpToT
                                 bpd(jtw,k) =bpd(jtw,k) -Fkhleqbp
                              endif  
                           endif
                        enddo
                     endif
c--check if the occupation of mixed atoms is to refine
                     if(iSite(jy) > 0) then
                        imix=iSite(jy)
                        do jj=1, imix
c--pick up the form factors for mixed atoms
                           ksp1 = int(SiteInfo(jj,jy)) / 10    ! specie
                           occ  = amod(SiteInfo(jj,jy),10.0)   ! occupazione
                           k=11+jj
                           if(nParBl(k,jy).ne.0)then  
                              apd(jtw,k) =apd(jtw,k) + ap(jj+1)/occ
!                              apd(jtw,k) =apd(jtw,k) +(ap/focc)*ff(ksp1)
                              if(icent.eq.0) 
     *	                      bpd(jtw,k) =bpd(jtw,k) + bp(jj+1)/occ
!     *	                      bpd(jtw,k) =bpd(jtw,k) +(bp/focc)*ff(ksp1)
                           endif
                        enddo
                     endif
c--check if the occupation number is to refine
                     k=11
                     if(nParBl(k,jy).ne.0) then 
                        apd(jtw,k) =apd(jtw,k) +ap(1)/xyzs(5,jy)
                        if(icent.eq.0) 
     *                  bpd(jtw,k) =bpd(jtw,k) +bp(1)/xyzs(5,jy)
                      endif
c--check if atoms fa parte di un *** Gruppo ***
                     if(igrcode.gt.0) then
                        ideriv=1
                        call calc55MNQD(kj,jy,jtw,ideriv,igrcode,nacode,
     *                        apd,bpd,xyzapd,xyzbpd)          
c--fine calcolo derivate per atomo di *** Gruppo ***
                     endif
c=========================================================
c--fine routine se affinamento
c=========================================================
                     if(iprintNEW.eq.1) call XTimeParz(4,0)
                  endif
c==========================================                             
c--end of loop on equivalent position ends                                     
c==========================================                             
               enddo                                    
c=========================================================
c--end of cycling over the different equivalent positions 
c  if twining is preesent  HR=H.MatTwin
c=========================================================
            enddo
c=========================================================
c--ROUTINE finali per questo atomo     
c=========================================================
c--accumulate the totals for this atom 
c--relativo ad H e RH
            do jtw=1,NumTwin
               ac(jtw)=ac(jtw)+att(jtw)                                       
               bc(jtw)=bc(jtw)+btt(jtw)
               if(je.eq.0)then 
c--calculate the immaginary parts                                       
c--relativo ad H
                 aci(jtw)=aci(jtw)-btt(jtw)*fsecondoMnqd(ksp)
                 bci(jtw)=bci(jtw)+att(jtw)*fsecondoMnqd(ksp)
               endif
            enddo
c============================================================
c--check if any refinement is being done                                
c============================================================
            if(jf.gt.0) then
               if(iprintNEW.eq.1)call XTimeINParz(4)
               if(CodeWeight.ne.0) then
c--multiply  the derivatives with the appropriate weights
                  do jtw=1,NumTwin
                     do k=1,nPar15
                        if(nParBl(k,jy).ne.0)then
                           apd(jtw,k) = apd(jtw,k) *wfw(k)	      
                           bpd(jtw,k) = bpd(jtw,k) *wfw(k)	      
                        endif
                     enddo
                  enddo
               endif
c----------------------------------------------------------------
c--start of the loops for adding the partial derivatives of the
c  coefficent of fc into the tempory stacks
c  DeriPerz(1:NumBlockTot,1:NParBlMax,1:NumDerParz)
c----------------------------------------------------------------
c--unity,centro and no anomalous dispersion
               select case(in1)
                  case (1)       
                     do jtw=1,NumTwin
                        jtwX=jtw-1
                        do k=1,nPar15
                           j=nParBl(k,jy)
                           if(j.ne.0) then
                              jw=nAddrDer(k,jy)
                              DeriPerz(j,jw,1+jtwX)=
     *                            DeriPerz(j,jw,1+jtwX)+apd(jtw,k)
                           endif
                        enddo
                     enddo
c--unity,centro and anomalous dispersion                                
                  case (2)                                        
                     do jtw=1,NumTwin
                        jtwX=0
                        if(jtw.eq.2) jtwX=2
                        do k=1,nPar15
                           j=nParBl(k,jy)
                           if(j.ne.0) then
                              jw=nAddrDer(k,jy)
                              DeriPerz(j,jw,1+jtwX)=
     *                            DeriPerz(j,jw,1+jtwX)+apd(jtw,k)
                              DeriPerz(j,jw,2+jtwX)=
     *                            DeriPerz(j,jw,2+jtwX)+apd(jtw,k)
     *                                          *fsecondoMnqd(ksp)   
                           endif
                        enddo                                              
                     enddo                                              
c--unity, non-centro and no anomalous dispersion                        
                  case (3)                                              
                     do jtw=1,NumTwin
                        jtwX=0
                        if(jtw.eq.2) jtwX=2
                        do k=1,nPar15
                           j=nParBl(k,jy)
                           if(j.ne.0) then
                              jw=nAddrDer(k,jy) 
                              DeriPerz(j,jw,1+jtwX)=
     *                            DeriPerz(j,jw,1+jtwX)+apd(jtw,k)
                              DeriPerz(j,jw,2+jtwX)=
     *                            DeriPerz(j,jw,2+jtwX)+bpd(jtw,k)
                           endif
                        enddo                                              
                     enddo                                              
c--unity,non-centro and anomalous dispersion
                  case (4) 
                     do jtw=1,NumTwin
                        jtwX=0
                        if(jtw.eq.2) jtwX=4
                        do k=1,nPar15
                           j=nParBl(k,jy)
                           if(j.ne.0) then
                              jw=nAddrDer(k,jy) 
                              DeriPerz(j,jw,1+jtwX)=
     *                            DeriPerz(j,jw,1+jtwX)+apd(jtw,k)
                              DeriPerz(j,jw,2+jtwX)=
     *                            DeriPerz(j,jw,2+jtwX)+bpd(jtw,k)
                              DeriPerz(j,jw,3+jtwX)=
     *                            DeriPerz(j,jw,3+jtwX)-bpd(jtw,k)
     *                                         *fsecondoMnqd(ksp)       
                              DeriPerz(j,jw,4+jtwX)=
     *                            DeriPerz(j,jw,4+jtwX)+apd(jtw,k)
     *                                         *fsecondoMnqd(ksp) 
                           endif
                        enddo              
                     enddo                                              
               end select
c================================================
c--end of refinement routine
c================================================
               if(iprintNEW.eq.1) call XTimeParz(4,0)
            endif
c================================================
c--end of atom cycling loop
c================================================
         enddo
c================================================
c--final calculation for the current reflections
c================================================
         if(icent.eq.1) then    ! centrosym
            bc(:)=0.0
            aci(:)=0.0
         endif
c--operazioni su H & RH
         do jtw=1,NumTwin
            act(jtw)=ac(jtw)+aci(jtw)
            bct(jtw)=bc(jtw)+bci(jtw)
            if(abs(act(jtw))-xvalmin.le.0.0) act(jtw)=xvalmin
            if(abs(bct(jtw))-xvalmin.le.0.0) bct(jtw)=xvalmin
            fcext(jtw)=sqrt(act(jtw)*act(jtw)+bct(jtw)*bct(jtw)) 
         enddo
c--calcolo valori per (H)+(RH)
         fcToT=unomenoxflack*fcext(1)+xflack*fcext(2)
         acToT=unomenoxflack*act(1)+xflack*act(2)
         bcToT=unomenoxflack*bct(1)+xflack*bct(2)
         pToT=atan2(bcToT,acToT)
         pToT=pToT*rtod
         if(pToT.lt.0)pToT=pToT+360.0
c================================================
c--check if we should include extinction
c================================================
         if(FcExtin.gt.0) then
c--calcolo il 2theta
            a=amin1(1.0,wavel*st)
            a=asin(a)*2.0
c--set the mean path length = 1.0
            pathmean=1.0
c--compute delta for neutrons
            delta=del*pathmean/sin(a)
c	      write(ncwu,*)'a,delta',a,delta
            if(neutro.ne.2) then
c--we are using x-rays
               a=cos(a)
               a=a*a
c--calcolo delta che tiene conto del fattore di polarizzazione
               delta=delta*(pol1+pol2*a*a)/(pol1+pol2*a)
c	write(ncwu,*)'delta,pol1,pol2,a',delta,pol1,pol2,a
            endif
c--compute the modified /fc/
            fc=fcTot
            ext1=1.0+2.0*ext0*fc*fc*delta
            fcToT=fc*(ext1**(-0.25))
            ext2=1.0+ext0*fc*fc*delta
            ext3=ext2/(ext1**(1.25))
c	      write(ncwu,*)'ext0,ext1,ext2,ext3,fc,fcTot,fo',
c     1	    ext0,ext1,ext2,ext3,fc,fcTot,fo
         endif
c================================================
c--calculate the square-root of the weight ( = w )
c================================================
         if(nCycleCurr.eq.1) then        ! provvisorio controllo deve = 1               
            fcexs=fcTot*FcScale 
            if(icodeFo.eq.1) then
               xfo=fo
               xfcexs=fcexs
               xsigmaf=sigmaf
            else
               xfo=fovet2(kj)
c              xfo=fo*fo
               xfcexs=fcexs*fcexs
               xsigmaf=sigmav2(kj)
            endif
            call CalcWeight(xfo,xfcexs,xsigmaf,st,w,n4z)
            if(icodeFo.eq.2) then
               if(nWeight.eq.6) w=w*0.01
            endif
            wt(kj)=w
            wrob=wrob+w*abs(xfo-xfcexs)
         endif
         w=wt(kj)
c--store Fc and phase
         fcvet(kj)=fcToT
         iphaz(kj)=pToT
c================================================================
c--add in the computed values for /Fc/ etc. to the overall totals
c================================================================
         a=w*fo
         fcToTs=fcToT*FcScale
         df=fo-fcToTs
         df1=abs(df)        
         wdf=w*df
         fot=fot+fo
         fct=fct+fcToT
         dft=dft+df1
c--check if refinenment on Fo or (Fo)**2      
         if(icodeFO.eq.2) then
            a=fovet2(kj)
            df=a-fcToTs*fcToTs
            wdf=w*df
            a=w*a
         endif  
         sumWDiff=sumWDiff+wdf*wdf  
         wdft=wdft+wdf*wdf
         rw=rw+a*a 
c------------------------------------------------
c--memorizza riflessi 'brutti'....
      if(df1.gt.3.0*sigmaf) then
        nbadx=nbadx+1
        if(nbad.ge.20) then
          jump=-6
          call sortza(buffo,lbuffo,nbad,mdbuffo,jump)
          if(df1.gt.buffo(mbuffo+jump)) then
            buffo(mbuffo  )=khl(1,kj)
            buffo(mbuffo+1)=khl(2,kj)
            buffo(mbuffo+2)=khl(3,kj)
            buffo(mbuffo+3)=fo
            buffo(mbuffo+4)=fcToTs 
            buffo(mbuffo+5)=df1
            buffo(mbuffo+6)=sigmaf
          endif
        else
          nbad=nbad+1
          mbuffo=mbuffo+mdbuffo
          buffo(mbuffo	)=khl(1,kj)
          buffo(mbuffo+1)=khl(2,kj)
          buffo(mbuffo+2)=khl(3,kj)
          buffo(mbuffo+3)=fo
          buffo(mbuffo+4)=fcToTs
          buffo(mbuffo+5)=df1
          buffo(mbuffo+6)=sigmaf
        endif
      endif
c================================================================
c--check if a print of the reflections is needed
c================================================================
         if(jg.ge.0) then
            if(jg.eq.0) then
               write(ncwu,8060)
8060     format(1h1,3x,1hh,3x,1hk,3x,1hl,4x,4h/fo/,4x,4h/fc/,6h phase,
     2          3x,' d/f/ (w)*d/f/',2x,7hsinth/l,/)
               jg=57
            endif
c	      jg=jg-1
            uj=fo*FoScale
            vj=wdf*FoScale
            wj=df*FoScale
            ihh=khl(1,kj)
            ikk=khl(2,kj)
            ill=khl(3,kj)
            write(ncwu,8080)ihh,ikk,ill,uj,fcTot,pTot,wj,vj,st
8080	      format(1x,3i4,2f8.1,f6.1,2f7.1,f12.5)
         endif
c================================================================
c--finish off this reflections - compute the overall totals
c--set up the coefficients for the overall parameters
c================================================================
        do n=1,NumOverall
           m=nats+NumGroup+n  
           j = nParBl(1,m)  
           jw = nAddrDer(1,m)
           if(j.ne.0) then
           select case(n)
             case (1)       
               DeriPerz(j,jw,1)= w*fcToT/ext3
             case (2)       
               DeriPerz(j,jw,1)= w*tc*fcToTs/ext3
             case (3)       
               DeriPerz(j,jw,1)= -0.5*w*FcScale*fc*fc*fc*delta/ext2
             case (4,5) 
               if(icodeFO.eq.1) then      
               DeriPerz(j,jw,1)= w*FcScale*(fcext(2)-fcext(1))/ext3
               else
               DeriPerz(j,jw,1)= w*FcScale2*(fcext(2)**2-fcext(1)**2)/
     *          (ext3*2.0*fcToTs)
               endif
           end select
           endif
       enddo
c==============================================================
c--calculate the cos and sin terms for the partial derivatives
c==============================================================
         if(iprintNEW.eq.1)call XTimeINParz(4)
         acphi=FcScale*w*acToT/fcToT 
         bcphi=FcScale*w*bcToT/fcToT
!c
!c--RH----------------------------
!        if (jCodeFlack.eq.1.or.jCodeTwin.eq.1) then
!c--        if(iover22(4).gt.0.or.iover22(5).gt.0) then
!           a1=1.0
!           a2=1.0
!c--check if refienment on Fo or (Fo)**2      
!           if(icodeFO.eq.2)then
!             a1=scalec*2.0*fcext
!             a2=scalec*2.0*fcextn
!           endif             
!	     acphi=acphi*unomenoxflack*a1
!	     bcphi=bcphi*unomenoxflack*a1
!	     acnphi=xflack*scalec*w*actn*a2/fcn
!	     bcnphi=xflack*scalec*w*bctn*a2/fcn
!        endif
c                                                                       
c--routines to transfer partial derivatives from temporary to
c  permanent store
c  jo  address complete partial derivatives                             
c  jp  last address complete partial derivatives
c  length of 'vector':jp-jo+1 = NParTot                                                                      
c----------------------------------------------------------------
c--start of the loops for adding the partial derivatives of the
c  coefficent of fc from the tempory stacks to permanent area
c  DeriPerz(1:NumBlockTot,1:NParBlMax,1:NumDerParz)
c  DeriTot(1:NumBlockTot,1:NParBlMax)
c----------------------------------------------------------------
c--centro without anomalous dispersion                                  
!         js=jo
         select case(in1)
           case (1) 
             do j=1,NumBlockTot
                do jw=1,BlAddr(j)
                   m=ParAddr(j,jw,1)
                   if(m.le.nats+NumGroup) then  ! controllo se non overall param
                   DeriTot(j,jw)=0.0
                   do k=1,NumTwin
                      DeriTot(j,jw)=DeriTot(j,jw)+DeriPerz(j,jw,k)*acphi
                   enddo
                   else          ! e' un overall parameter                  
                      DeriTot(j,jw)=DeriTot(j,jw)+DeriPerz(j,jw,1)
                   endif
                enddo
             enddo      
c--non-centro without anomalous dispersion or centro with anomalous     
c  dispersion                                                         
           case (2,3)  
             do j=1,NumBlockTot 
                do jw=1,BlAddr(j)
                   m=ParAddr(j,jw,1)
                   if(m.le.nats+NumGroup) then  ! controllo se non overall param
                   DeriTot(j,jw)=0.0
                   k1=0
                   do k=1,NumTwin
                    DeriTot(j,jw)=DeriTot(j,jw)+
     *              DeriPerz(j,jw,1+k1)*acphi+DeriPerz(j,jw,2+k1)*bcphi
                    k1=2
                   enddo
                   else          ! e' un overall parameter                  
                      DeriTot(j,jw)=DeriTot(j,jw)+DeriPerz(j,jw,1)
                   endif
                enddo
             enddo      
c--non-centro with anomalous dispersion                                 
           case (4)  
             do j=1,NumBlockTot 
                do jw=1,BlAddr(j)
                   m=ParAddr(j,jw,1)
                   if(m.le.nats+NumGroup) then  ! controllo se non overall param
                   DeriTot(j,jw)=0.0
                   k1=0
                   do k=1,NumTwin
                    DeriTot(j,jw)=DeriTot(j,jw)+
     *              (DeriPerz(j,jw,1+k1)+DeriPerz(j,jw,3+k1))*acphi+
     *              (DeriPerz(j,jw,2+k1)+DeriPerz(j,jw,4+k1))*bcphi
                    k1=4
                   enddo
                   else          ! e' un overall parameter                  
                      DeriTot(j,jw)=DeriTot(j,jw)+DeriPerz(j,jw,1)
                   endif
                enddo
             enddo      
         end select
c---------------------------------------
c--modify the partial derivatives
      a=1.0
c--check if refinenment on Fo or (Fo)**2      
      if(icodeFO.eq.2)  a=2.0*fcToTs    
      if(icodeFO.eq.2)  a=2.0*fcToTs    
c--check if we should include extinction
      if(OverallNumBlock(3).gt.0) a=a*ext3  
      do j=1,NumBlockTot 
         do jw=1,BlAddr(j)
            DeriTot(j,jw)=DeriTot(j,jw) * a
         enddo
      enddo      
c===================================================
c--accumulation of the l.s. normal equations
c===================================================
      if(iprintNEW.eq.1)call XTimeINParz(3)
c--      
      call MnqdAccum(wdf)
c--      
      if(iprintNEW.eq.1) then
         j=0
         if(kj.eq.nreflX) j=1
         call XTimeParz(3,j)
         if(kj.eq.nreflX)call XTimeParz(5,1)
      endif
c===================================================
c--fine loop over the reflections
c===================================================
      enddo
c---------------------------------------------------      
      if(nCycleCurr.eq.1) then                 ! 1o CICLO
         wrob=wrob/nreflX  
      endif
c==========================================
c--write the r values
c==========================================
      rflsq =100.0*dft/fot
      rwflsq=100.0*sqrt(wdft/rw)
      slsq=sqrt(sumWDiff/(nreflX+nres-NParTot))
      xrapX =float(nreflX + nres)/float(NParTot)
      if(iverb.ge.0) then
         write(ncwu,9302) NParTot 
9302     format(' Number of refined parameters ',i6)
         if(jCodeFlack.ne.0)then
            write(ncwu,9303) FcPola ,Overall_dev(4)
9303        format(' Absolute-structure parameter (Flack parameter)=',
     2                f7.3,'  e.s.u.=',f7.3)
         endif
         if(jCodeTwin.ne.0)then
            write(ncwu,9305) FcTwin,Overall_dev(5)
9305        format(' Twinning fractional contribution=',
     2                f7.3,'  e.s.u.=',f7.3)
         endif
         write(ncwu,9310)  indch 
9310     format(' Threshold=n*s(Fo)',i6)
         write(ncwu,9320) nreflX
9320     format(' No. reflections ', i7)
         write(ncwu,9321) xrapX
9321     format(' No(refl)/param..', f7.2)
         write(ncwu,9315) rflsq 
9315     format('  R(F)% .........',f7.3)
         write(ncwu,9316)rwflsq 
9316     format(' wR(F**2)% ......',f7.3)
         write(ncwu,9317)slsq 
9317     format(  ' Goodnes of fit..',f7.3)
         write(ncwu,9056)sumWDiff
9056     format(' Minimization function = ',f20.4)
      end if
c==========================================
c--end of writing--------------------------
c==========================================
c--calculate the requested restraint(s)
c==========================================
      if(nres.gt.0) call xrestrMNQD
c==========================================
!      if (jscreen > 0 .and. InfoOK(15) > 0) then
!          iAngolo = 0
!          ifSca = 0
!          call Disegna(ifSca)
!      endif
!
      errem = rflsq 
      erres  = rflsq / 100.0
!            
      if(nCycleCurr.gt.1) then               ! cicli successivi
         swdft=sumWDiff_Prev+(sumWDiff_Prev/2)
         if(sumWDiff.gt.swdft) then 
            write(Msg,9057)  
9057        format('Minimization function diverges')
            call OpenWarning(Msg)
            jkmn=-1            
            return
         endif
      endif    
!      
c--indirizzo di provenienza se affinamento senza riflessi
9080  continue
c--terminate the output of list 6
      if(NoRefl.eq.0) then
c--rewrite the preamble block
         nvsfc=NParTot
         call UpdateReflInfo
      endif
c====================================================      
c--check if the refinement converged
c====================================================
      if(iautoLsq.eq.1) then
         if(nCycleCurr.gt.1) then
            swdft=abs(sumWDiff_Prev-sumWDiff)/sumWDiff_Prev
            if(swdft.lt.0.01) nCycleTot=1
         end if
      end if
      return
      end
!
!-----------------------------------------------------------------------
      subroutine MnqdGetAllInfo(jgraf,ierres,iStampa,NoRestore)
!--da menu 'LSQ INFO' -->file spec2006.f (subroutine BrowserV2(kBro))
!              Inte = 'Refinement conditions and atoms info'
!              call sw12(lo,1)
!              call UpdateCommonAndList5(ier)
!              call GetAllInfo(erres,1)
!              call StampaRefCond(erres)
!              call StampaAtCond
!              call StampaGruppi
!------------------------------------------------------------------------
!  jgraf = 0 no grafica
!          1 passa per la grafica
!  LsqCF  (in Module LsqModule) = 1 Calcolo fattori
!                               = 2 Affinamento
!--stampa della mappa delle direttive run time per l'affinamento
!     subroutine PrEqui --> file lsqfin.f
!--(list 22) (subroutine prt22)
!      
      USE General
      USE Atomi
      USE LsqStuff
      USE LsqStuff12
      USE LsqStuff12_RT
      USE LsqStuff12_byUser
      USE LsqGroupsStuff
      USE LsqModule
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
!
      character It1(17)*12
! ---
      It1( 1) = '  x'
      It1( 2) = '  y'
      It1( 3) = '  z'
      It1( 4) = '  B[iso]'
      It1( 5) = '  11'
      It1( 6) = '  12'
      It1( 7) = '  13'
      It1( 8) = '  22'
      It1( 9) = '  23'
      It1(10) = '  33'
      It1(11) = '  occ'
      It1(12) = '  occ1'
      It1(13) = '  occ2'
      It1(14) = '  occ3'
      It1(15) = '  occ4'
      It1(16) = '  scale'
      It1(17) = '  bm'
!
      ierres=0
!      
!--dopo aver trovato la soluzione con i MD, nessuna routine setta InfoOK(5)=1
      InfoOK(5) = 1           ! lo faccio qui ! RS 10.5.2010
!--controllo se esistono gruppi      
      if(NumGroup.gt.0) then
         InfoOK(13)=1
         nPar15=14
      else   
c--azzero codici relativi a gruppi in lista 5      
         nPar15=11
         do i=1,nats
            nGrCode(i)=0
            nGrAtCode(i)=0
         enddo 
      endif     
!--check if there are mixed atom sites da affinare (solo se non ci sono gruppi)
      if(NumGroup.le.0) then
         do i=1,nats
            if(iSite(i).gt.0) then
               nPar15=15     ! oltre agli 11 param si considerano max 4 occupanze nel site
               exit
            endif
         enddo
      endif
!
      if(LsqCF.eq.1.and.jgraf.eq.0) return      
!      
!-- checks if LIST 12 e' nei vettori SIR
!
      if(InfoOK(62).le.0) then
            call DefaultRefi(2,ier)
            if(ier.lt.0) then
               write(lo,*)' Error(a) list 62 from sub MnqdGetAllInfo!'
               return
            endif
            NumCond12_byUser=0
      endif
!        
!--controllo se sono presenti direttive 'group'
      nconstr=0
      if(NGroup12.gt.0) then
         do i=1,NumCond12
            idrb=idir12(i)
            if(idrb.eq.18) then
               nconstr=nconstr+1
               read(stringa12Tot(i),'(80a1)')(iconstr(j,nconstr),j=1,80)
            endif
         enddo
!         do i=1,nconstr
!            write(lo,'(80a1)')(iconstr(j,i),j=1,80)
!         enddo
      endif
!       
!------------------------------------------------     
      if (iStampa.eq.1) call WriteCellInfo
      if (iStampa.eq.1) call WriteSymmInfo(lo)
      if (iStampa.eq.1) call WriteContInfo(npq,ier)
      if (iStampa.eq.1) call PrintWeight(lo)
      if (iStampa.eq.1) call PrintAtoms
      if (iStampa.eq.1.and.NumGroup.gt.0) call PrintGroup(lo)
      if (iStampa.eq.1) call PrintRefi(lo)
      if (iStampa.eq.1) call PrintLimit(lo)
!
      NumOggettiMax=nats+NumGroup+NumOverall
!      
      call AllocaLsqStuff(2)
      call AllocaLsqStuff(1)
!
      if(NumCond12_byUser.gt.0) then
!--crea the code vector ckFix(i) from FIXED direttive
         iAction=2
         call FixedByUser(iAction, It1,ier)
      else
!  kFix(:,:)  = 0 nessuna definizione by user
!             = 1 param. fisso by user
!
         do in=1,NumOggettiMax
            ckFix(in)=0
            do i=1,nPar15
               kFix(i,in)=0        ! default parametri  non fissati 
            enddo
            kFix(11,in)=1          ! default parametro Occ fissato 
         enddo
      endif 
!--creo mappa in memoria per l'equazioni normali (ex jfr22)
!  qui e' solo per informazioni: non e' la creazione per 
!  il calcolo effettivo dei minimi quadrati
!      
!      call PrintRefi(lo)
!--save restraint orig
      nresSav = nres
      vresSav = vres
      NumCond12_Sav =NumCond12
      idir12_Sav = idir12
      stringa12Tot_Sav = stringa12Tot
c!     
      call CreaMnqd(jbb,ier,iStampa)
!      call PrintRefi_RT(lo)
!--restore restraint orig
      if(NoRestore.eq.0) then
         nres = nresSav
         vres = vresSav
         NumCond12 =NumCond12_Sav
         idir12 = idir12_Sav
         stringa12Tot = stringa12Tot_Sav
      endif
!       
!      call PrintRestraint(0)
      if(ier.ne.0) then
         ierres=1
         return
      endif
      if (iStampa.gt.0) then
          if(nres.gt.0) call PrintRestraint(0)
          call PrEqui()
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine PrintCondizioni
!--stampa in chiaro delle condizioni di affinamento degli atomi e gruppi
!      
      USE General
      USE Atomi
      USE LsqStuff
      USE PhaseModule
      USE LsqModule
      USE LsqGroupsStuff
!
      dimension fw(15)
      character  IA(2)*11
      character  LabCurrent*16, blank6*6,isoA(2)*6
      character  It1(15)*6, It2(14)*6, It3(14)*6, atm(15)*6
      data It1 /'    X ','    Y ','    Z ','B[iso]',
     2          '    11','    12','    13','    22',
     3          '    23','    33','   Occ','  Occ1',
     4          '  Occ2','  Occ3','  Occ4'/
      data It2 /'    X ','    Y ','    Z ','B[iso]',
     2          '    11','    12','    13','    22',
     3          '    23','    33','   Occ',' Theta',
     4          '   Phi','   Psi'/
      data It3 /'    x ','    y ','    z ','B[iso]',
     2          '    11','    12','    13','    22',
     3          '    23','    33','   Occ','   xyz',
     4          '   xyz','   xyz'/
!
      IA(1) = 'Anisotropic'
      IA(2) = 'Isotropic'
      isoA(1) = 'b(ij)'
      isoA(2) = 'B[iso]'
      blank6= '      '
!    
      write(lo,'(1x,120(1h-))')
      write(lo,301)
      write(lo,320)
      write(lo,'(1x,5a6)')' Scale',' BOver',' Extin',' Polar','  Twin'
         do j=1,5
            m=OverallNumBlock(j)
            if(m.eq.0) then
               atm(j)='   Fix'
            else
               atm(j)='   Ref'
            endif
         enddo
         write(lo,'(5a6)')   (atm(j),j=1,5)
!      
      write(lo,320)
!      
      do i=1, NumOggettiMax - NumOverall
         if(i.le.nats) then
            k = IsoAniso(i)
            LabCurrent=aLab(i)
         else
            k = IsoAnisoGroup(i-nats)
            LabCurrent=aLabGroup(i-nats)
         endif
         jco=0
         do j=1,nPar15
            m=iEquiv(j,2,i)
            if(m.gt.0) then 
               jco=1
               exit
            endif
         enddo
         if(jco.eq.0) then
            nParx=4
            if (k.eq.1) nParx=10
            numx=0
            do j=1,nParx
               if(nParBl(j,i).gt.0) numx=numx+1
            enddo   
            if(k.eq.1.and.numx.ne.9)jco=1
            if(k.eq.2.and.numx.ne.4)jco=1
         endif    
         call shift(IA(k),kk)
         if(jco.eq.0) then 
            write(lo,300) i,LabCurrent,
     *               'Standard conditions : x,y,z,',isoA(k),IA(k)(1:kk)
!        
         else
            write(lo,302) i,LabCurrent,IA(k)(1:kk)
            if(NumGroup.gt.0) then
               if(i.le.nats) then
                  write(lo,250) (It3(j),j=1,nPar15)
               else
                  write(lo,250) (It2(j),j=1,nPar15)
               endif
            else
               write(lo,250) (It1(j),j=1,nPar15)
            endif
            do j=1,nPar15
               m=iEquiv(j,2,i)
               if(m.gt.0) then
                  if(m.le.nats) then
                     atm(j)=aLab(m)(1:6)
                  else
                     atm(j)=aLabGroup(m-nats)(1:6)
                  endif
                  call shift(atm(j),ll)
                  if(ll.lt.6) then
                     lll=6-ll
                     atm(j)=blank6(1:lll)//atm(j)
                  endif
               else
                  atm(j)=' '
                  ll=6
               endif
            enddo
            write(lo,310)   (atm(j),j=1,nPar15)
!         
            do j=1,nPar15
               m=iEquiv(j,3,i)
               if(m.gt.0) then
                  if(NumGroup.gt.0) then
                     atm(j)=It2(m)
                  else
                     atm(j)=It1(m)
                  endif
               else
                  atm(j)=' '
               endif
            enddo
            write(lo,315)   (atm(j),j=1,nPar15)
!         
            do j=1,nPar15
               fw(j)=float(iEquiv(j,1,i))/1000.0
            enddo
            write(lo,305)    (fw(j),j=1,nPar15)
!         
            do j=1,nPar15
               m=nParBl(j,i)
               if(m.eq.0) then
                  atm(j)='   Fix'
               else
                  atm(j)='   Ref'
               endif
            enddo
            write(lo,330)   (atm(j),j=1,nPar15)
         endif
         write(lo,320)
      enddo      
      write(lo,'(1x,120(1h-),/)')
!
  250 format(/,11x,15a6)
  300 format(i5,') ',a8,1x,2a,2x,'(',a,')') 
  301 format(' Print the Refinement Conditions ',/)       
  302 format(i5,') ',a8,1x,'(',a,')') 
  305 format('Weight     ',15f6.2)
  310 format('Atom  Equiv',15a6)
  315 format('Param Equiv',15a6)
  320 format(' ')
  330 format('Parameters ',15a6)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine PrEqui
!--stampa della mappa delle direttive run time per l'affinamento
!      
      USE General
      USE Atomi
      USE LsqStuff
      USE PhaseModule
      USE LsqModule
      USE LsqGroupsStuff
!
      character  IA(3)*1
      character  LabCurrent*16
      character  It1(15)*6
      data It1 /'    X ','    Y ','    Z ','B[iso]',
     2          '    11','    12','    13','    22',
     3          '    23','    33','   Occ','  Occ1',
     4          '  Occ2','  Occ3','  Occ4'/
!
      IA(1) = 'A'
      IA(2) = 'I'
      write(lo,'(a,/,i5)')' Scale', OverallNumBlock(1)
      write(lo,'(a,/,i5)')' BOver', OverallNumBlock(2)
      write(lo,'(a,/,i5)')' Extin', OverallNumBlock(3)
      write(lo,'(a,/,i5)')' Polar', OverallNumBlock(4)
      write(lo,'(a,/,i5)')' Twin ', OverallNumBlock(5)
      do i=1, NumOggettiMax - NumOverall
         if(i.le.nats) then
            k = IsoAniso(i)
            LabCurrent=aLab(i)
         else
            k = IsoAnisoGroup(i-nats)
            LabCurrent=aLabGroup(i-nats)
         endif
         write(lo,250) (It1(j),j=1,nPar15)
         write(lo,300) LabCurrent,IA(k),  (iEquiv(j,1,i),j=1,nPar15)
         write(lo,310)                    (iEquiv(j,2,i),j=1,nPar15)
         write(lo,315)                    (iEquiv(j,3,i),j=1,nPar15)
         write(lo,330)                    (kFix(j,i),j=1,nPar15)
         write(lo,340)                    (nParBl(j,i),j=1,nPar15)
         write(lo,320)
      enddo      
      do i=1,nats
         if (ckEquiv(i).gt.0) then
             do j=1,nPar15
                if (iEquiv(j,2,i).ne.0) then
                    wei = float(iEquiv(j,1,i)) / 1000.0
                    k2  = iEquiv(j,2,i)
                    k3  = iEquiv(j,3,i)
                    if(k2.le.nats) then
                       LabCurrent=aLab(k2)
                    else
                       LabCurrent=aLabGroup(k2-nats)
                    endif
                    write(lo,510) LabCurrent,It1(k3),aLab(i),It1(j),wei
                endif
             enddo
         endif
      enddo
!
  250 format(9x,15a6)
  300 format(a8,a1,15i6)
  310 format('iEquiv(A)',15i6)
  315 format('iEquiv(P)',15i6)
  320 format(' ')
  330 format('kFix     ',15i6)
  340 format('nParBl   ',15i6)
  510 format(' Equivalence : ',a8,a7,' = ',a8,a7,' * ',f8.3)
!
      return
      end
!-----------------------------------------------------------------------
!
!code for CreaRestraintFromDiret
      subroutine CreaRestraintFromDiret(ier)
!--creo vettori restraint dalle direttive di affinamento
!                                                                       
      USE General
      USE Atomi
      USE LsqModule
      USE LsqStuff
      USE LsqStuff12
      USE LsqRestraint
!
      common/xcardch/CardImageX,idch(6)
      character CardImageX*80,idch*1
!
      dimension vet(40),ivet(40)
      character*80  line, line1,  dire
      character*16 vetch
      dimension valuesig(3)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
!--
      ier=0
!      
c--set current next free location for restraints directives
      nres=0     ! no. di restraints
      nrc=1      ! ind. nel vettore vres(:)
      nrc_previous=nrc
      vres(:)=0.0    
c
c--loop restraint directive
      do jbb=1,NumRestraint
         jFlagAtom(1:nats) = 0
         ist = idirRestraint(jbb)
         if(ist.eq.10) exit   ! 'end' directive              
         line=stringaRestraint(jbb)
         call lcase(line)
         call cutst(line,lenp,dire,lend)
!                                                          
!--esecuzione delle direttive di restraint
!
        select case (ist)
!
!----------------------------------------------------------------------
!--'dist' & 'angle' & 'torsion' directives
!----------------------------------------------------------------------
          case (1,2,3)
               if(lenp.le.0) goto 9000   ! error! non contiene niente altro
               line1=line(1:lenp)   ! salvo stringa
               n25=ist+1
               nres=nres+1
               vres(nrc)= ist                 ! restraint code
               vres(nrc+1)= n25                  ! no. di atomi
!            
               iopt=2
               call getnum(line,vet,ivet,iv,iopt)
               line=line1
               if(iv.eq.0) goto 9000   ! error! non contiene numeri
               valuetarget=vet(1)
               call cutst(line,lenp,dire,lend)  ! elimino 1o numero
               if(iv.ne.2) then
                  valuesigma= 0.001
                  if(j1.gt.2)valuesigma= 0.01
               else
                  valuesigma= vet(2)
                  call cutst(line,lenp,dire,lend)  ! elimino 2o numero
               endif   
               vres(nrc+2)= valuesigma    ! sigma
               vres(nrc+3)= valuetarget   ! target
!--look for atoms                               
               n=nrc+4
               do i=1,n25 
                  call cutst(line,lenp,dire,lend)
                  vetch=dire(1:lend)
                  call LookforAtom(vetch,nord)
                  if(nord.le.0) goto 9000  ! no. ord. atomo oppure =0 (atomo non trovato) 
                  vres(n)=nord
                  n=n+1
                  if(lenp.le.0.and.i.ne.n25) goto 9000  ! error!
               enddo     
               nrc=n
!----------------------------------------------------------------------
!--'planar' directive
!----------------------------------------------------------------------
          case (4)
               if(lenp.le.0) goto 9000   ! error! non contiene niente altro
               line1=line(1:lenp)   ! salvo stringa
               nres=nres+1
               nrc_previous=nrc
               vres(nrc)= ist                 ! restraint code
!            
               valuetarget=0.0
               iopt=1
               call getnum(line,vet,ivet,iv,iopt)
               line=line1
               if(iv.eq.0) then  ! error! non contiene sigma
                  valuesigma=0.0001
               else
                  valuesigma=vet(1)
                  call cutst(line,lenp,dire,lend)  ! elimino il numero
               endif
               vres(nrc+2)= valuesigma    ! sigma
               vres(nrc+3)= valuetarget   ! target
!--look for atoms    
               n=nrc+4
               n25=0                           
               iok=0 
               do while (iok == 0)   
                  call cutst(line,lenp,dire,lend)
                  vetch=dire(1:lend)
                  call LookforAtom(vetch,nord)
                  if(nord.le.0) goto 9000   ! error! atomo  non trovato
                  n25=n25+1
                  vres(n)=nord
                  n=n+1
                  if(lenp.le.0) iok=1
               enddo     
               if(n25.eq.0) goto 9000
               vres(nrc+1)= n25                  ! no. di atomi
               nrc=n
!----------------------------------------------------------------------
!--'sum' directive
!----------------------------------------------------------------------
          case (5)
               if(lenp.le.0) goto 9000   ! error! non contiene niente altro
               jFlagAtom(1:nats)=0
               jcont=0     ! code per record continue: indica cosa sta leggendo
               line1=line(1:lenp)   ! salvo stringa
               nres=nres+1
               nrc_previous=nrc
               vres(nrc)= ist                 ! restraint code
!
               iopt=1
               call getnum(line,vet,ivet,iv,iopt)
               line=line1
               if(iv.eq.0) then  !  non contiene sigma
                  valuesigma=0.0001
               else
                  valuesigma=vet(1)
                  call cutst(line,lenp,dire,lend)  ! elimino il numero
               endif
               vres(nrc+2)= valuesigma        ! sigma
!               
               n25=0
               call cutst(line,lenp,dire,lend)  
               vetch=dire(1:lend)
               n=KompareString(vetch,Param12,NumParam12,0)  ! check parameter                                        
!--look for atoms    
               if(n.le.0) then            ! non e' un parametro
                  call LookforAtom(vetch,nord)
                  if(nord.eq.0) goto 9000  ! error!
                  jFlagAtom(nord)=1 
                  n25=n25+1 
                  if(lenp.gt.0) then
!--look for more atoms                               
                     iok=0
                     ok1=0 
                     do while (iok == 0)   
                        call cutst(line,lenp,dire,lend)
                        vetch=dire(1:lend)
                        call LookforAtom(vetch,nord)
                        if(nord.eq.0)then     ! =0 (atomo non trovato) 
                           iok=2 
                           iok1=1
                        else 
                           jFlagAtom(nord)=1  
                           n25=n25+1 
                        endif   
                        if(lenp.le.0) iok=1
                     enddo     
                  endif
                  
                  if(iok1.eq.0)then      !  non ci sono parametri espliciti
                      jcont=1 ! fine record leggendo atomi
                      codeparam(1:10)=1   ! tutti i parametri (x e b) sono selezionati
                  else                   
!--look for parameters                      
                     n=KompareString(vetch,Param12,NumParam12,0)  ! check parameter  
                     if(iok.eq.1) then   ! un solo parametro indicato
                        call par22MNQD(0,n)
                     else                                      
                        call jpargMNQD(0,n,line,ier) 
                     endif
                  endif
               else                             ! e' un parametro la prima label
                  n25=nats                      
                  jFlagAtom(1:nats)=1           !  si riferisce a tutti gli atomi 
                  if(lenp.le.0) then
                     call par22MNQD(0,n)
                  else        
                     call jpargMNQD(0,n,line,ier) 
                  endif
               endif
!--salva i codici dei parametri
               n=nrc+4
               m=0
               do j=1,nPar15  
                  if(Codeparam(j).ne.0) then
                     vres(n)=j
                     n=n+1
                     m=m+1
                   endif
               enddo
               vres(nrc+3)= m                     ! no. parametri
!--salva i no. d'ordeine degli atomi selezionati               
               vres(nrc+1)= n25   
               do i=1,nats
                  if(jFlagAtom(i).gt.0) then  
                     vres(n)=i
                     n=n+1
                  endif
               enddo
               nrc=n
!----------------------------------------------------------------------
!--'continue' directive
!----------------------------------------------------------------------
          case (16)
               if(nres.eq.0) goto 9000
               if(nrc_previous.eq.0) goto 9000
               istc = vres(nrc_previous)
	         n25_previous=vres(nrc_previous+1)
!--continuazione direttiva 'planar','sum','limit' (code 4,5,6)
               if(istc.lt.4.or.istc.gt.6) goto 9000
!--si dovrebbe controllare che continue segue
!--subito una direttiva possibile
!--la scheda 'continue' contiene solo atomi
!--find the atoms
               CardImageX=line
               ix=0
               jFlagAtom(1:nats)=0
               call FindAtomMnqd(ix,ier)
               if(ier.ne.0) goto 9000
               n=nrc
               n25=0
               do i=1,nats
                  if(jFlagAtom(i).gt.0) then  
                     vres(n)=i
                     n=n+1
                     n25=n25+1
                  endif
               enddo
               vres(nrc_previous+1)= n25 + n25_previous  ! no. di atomi
               nrc=n
!----------------------------------------------------------------------
!--'limit' directive
!----------------------------------------------------------------------
          case (7)
               if(lenp.le.0) goto 9000   ! error! non contiene niente altro
               line1=line(1:lenp)   ! salvo stringa
               nres=nres+1
               nrc_previous=nrc
               vres(nrc)= ist-1                 ! restraint code (6)
c--insert default value for sigma
               valuesig(1)=0.001
               valuesig(2)=0.1
               valuesig(3)=0.0001
               iopt=3
               call getnum(line,vet,ivet,iv,iopt)
               line=line1
               if(iv.ge.1) then  
                  valuesig(1)=vet(1)
                  call cutst(line,lenp,dire,lend)  ! elimino il numero
               endif
               if(iv.ge.2) then 
                  valuesig(2)=vet(2)
                  call cutst(line,lenp,dire,lend)  ! elimino il numero
               endif   
               if(iv.eq.3) then 
                  valuesig(3)=vet(3)
                  call cutst(line,lenp,dire,lend)  ! elimino il numero
               endif
               vres(nrc+2)= valuesig(1)    ! sigma x
               vres(nrc+3)= valuesig(2)    ! sigma b(iso)
               vres(nrc+4)= valuesig(3)    ! sigma bij
               n=nrc+5
c--find the atoms
               call shift(line,lenp)
               if(lenp.le.0) then
                  vres(nrc+1)= nats                  ! tutti gli atomi
                  do i=1,nats
                     vres(n)=i
                     n=n+1
                  enddo
               else
                  CardImageX=line
                  ix=0
                  jFlagAtom(1:nats)=0
                  call FindAtomMnqd(ix,ier)
                  if(ier.ne.0) goto 9000
                  n25=0
                  do i=1,nats
                     if(jFlagAtom(i).gt.0) then  
                        vres(n)=i
                        n=n+1
                        n25=n25+1
                     endif
                  enddo
                  vres(nrc+1)= n25        ! no. di atomi
               endif
               nrc=n
!----------------------------------------------------------------------
c--'site' directive
!----------------------------------------------------------------------
          case (8)
               if(lenp.le.0) goto 9000   ! error! non contiene niente altro
               nres=nres+1
               vres(nrc)= ist-1                  ! restraint code
               vres(nrc+2)= 0.0                  ! per analogia sigma
               vres(nrc+3)= 0.0                  ! per analogia target
c--find the atoms
               CardImageX=line
               ix=0
               jFlagAtom(1:nats)=0
               call FindAtomMnqd(ix,ier)
               if(ier.ne.0) goto 9000
               n25=0
               n=nrc+4
               do i=1,nats
                  if(jFlagAtom(i).gt.0) then
                     vres(n)=i
                     n=n+1
                     n25=n25+1
                  endif
               enddo
               vres(nrc+1)= n25                    ! no. di atomi
               nrc=n
!----------------------------------------------------------------------
!--'disorder' directive
!----------------------------------------------------------------------
          case (9)
               if(lenp.le.0) goto 9000   ! error! non contiene niente altro
               line1=line(1:lenp)   ! salvo stringa
               nres=nres+1
               vres(nrc)= ist-1     ! restraint code
               iopt=1
               call getnum(line,vet,ivet,iv,iopt)
               line=line1
               if(iv.eq.1) then  
                  n25=vet(1)
                  call cutst(line,lenp,dire,lend)  ! elimino il numero
               else
                  goto 9000   ! error!
               endif
               vres(nrc+1)= n25        ! no. di atomi
               n=nrc+2
c--find the atoms
               CardImageX=line
               ix=0
               jFlagAtom(1:nats)=0
               call FindAtomMnqd(ix,ier)
               if(ier.ne.0) goto 9000
               n26=0
               do i=1,nats
                  if(jFlagAtom(i).gt.0) then
                     vres(n)=i
                     n=n+1
                     n26=n26+1
                  endif
               enddo
               if(n25.ne.n26) goto 9000
               nrc=n
!            
!----------------------------------------------------------------------
        end select
c
      enddo
c--end of loop on  directives
!      call PrintRestraint(0)      
      return
c      
c--error conditions      
9000  continue
      ier=1
      return
      end
!
!code for AnalysisDirMNQD
      subroutine AnalysisDirMNQD(ier)
!--crea 1a phase lista 12 run time nei vettori SIR 
!--ho gia' definito la dimensione nPar15 che mi serve per l'allocate dei vettori (ex lista 22) 
!  
!  directive codes: 1 diag
!                   2 full
!                   3 block
!                   4 plus
!                   5 fix
!                   6 factor   (ex weight)
!                   7 equiv
!                   8 ride
!                   9 end
!		           10 fixed -> 5
!		           11 dist
!		           12 angle
!		           13 torsion
!		           14 planar
!		           15 sum
!		           16 continue
!		           17 limit
!		           18 group
!                  19 rotamer
!                  20 site
!                  21 disorder
!  argument type  : 1 no specification
!                   2 a1 un a2 p1 p2 . .
!                   ( a1 p1 p2 p3 . . . . )
!                   ( a1  a2  p1 p2 p3 ...)
!                   3 a1 un a2
!                   ( a1  )
!                   ( a1 a2 ...)
!                   4 p1 p2 p3 . . . . .
!                   5 a1 p1 a2 p2
!                   ( a1 until a2  p1 a3 until a4 p2 )
!                   ( a1 a2 ... p1  a11 a12 ... p2 )
!                   6 a1 p1  w
!                   ( a1 until a2  p1 w  )
!                   ( a1 a2 ... p1 w )
!		    ( a1 a2 d s )
!		    ( a1 a2 a3 cosd s )
!
      USE General
      USE Symmetry
      USE Atomi
      USE Groups
      USE LsqGroupsStuff
      USE LsqStuff
      USE LsqStuff12
      USE LsqStuff12_byUser
      USE LsqStuff12_RT
      USE LsqRestraint
      USE LsqModule
!
      common/xcardch/CardImageX,idch(6)
      character CardImageX*80,idch*1
!
      character*80  line, line1, line2, line3, dire
!--
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
!--
      dimension iato(100)
      dimension vet(40),ivet(40)
      character*16 vetch
!
      character*80 bufferch
      character*5 isumch,plusch,ifxhch
      character*7 bisoch, equich, factch
      character*4 occch(5)
      character groupch*7
!
      data groupch/'group  '/   
      data isumch /'sum  '/
      data plusch /'plus '/
      data ifxhch /'fix  '/
      data equich /'equiv  '/
      data factch /'factor '/
      data occch  /'occ ','occ1','occ2','occ3','occ4'/
      data bisoch /' b[iso]'/
c                   1234567
!
      ier=0
      NGroup12=-1
      NRotam12=-1
      NumRestr12_Special = -1
!------------------------------------------------------------------------------
!--inserisco restraint, fixed by user, group ,nelle direttive
!------------------------------------------------------------------------------
      NumRestraint=0
      if(nres.gt.0.or.NumCond12_byUser.gt.0.or.NumGroup.gt.0) then
         if(nres.gt.0) call RestraintToDiret(ier)
         call x62start(ncard,ier)
         do i=1,NumCond12-1
             write(ncpu,'(a80)') stringa12Tot(i) 
             ncard=ncard+1
         enddo 
         if(NumRestraint.gt.0) then  
            do i=1,NumRestraint-1
               write(ncpu,'(a80)') stringaRestraint(i)
               ncard=ncard+1
            enddo
         endif
!--scrive le direttive FIXED by User 
         if(NumCond12_byUser.gt.0) then      
            do m=1,NumCond12_byUser
               write(ncpu,'(a80)') stringa12_byUser(m)
               ncard=ncard+1
            enddo
         endif
         if(NumGroup.gt.0) then
            do i=1,NumGroup
               if(ifGroupRefined(i).ne.0) then
                  call shift(aLabGroup(i),len)
                  bufferch=groupch//aLabGroup(i)(1:len)
                  write(ncpu,'(a80)') bufferch
                  ncard=ncard+1
               endif
            enddo
         endif
         call x62end(ncard)
      endif
!       
!------------------------------------------------------------------------------
!--controllo direttiva gruppi  e special restraint
!------------------------------------------------------------------------------
      do jx = 1,NumCond12
         idrb=idir12(jx) 
!--non considero rotameri               
         if(idrb.eq.18) NGroup12=1
         if(idrb.eq.20) NumRestr12_Special = 1
         if(idrb.eq.21) NumRestr12_Special = 2
      enddo
!------------------------------------------------------------------------------
!  controlli vari
!------------------------------------------------------------------------------
      nPar15=11
!--controllo se ci sono gruppi
!  in questo caso si fa  l'affinamento di un *** Gruppo ***      
!--(in questo caso non ci pssono essere site con piu' specie) 
      if(NGroup12.gt.0) then
      if(NumGroup.le.0) then 
            NGroup12=0
      else 
            nPar15=14      ! gli 11 parametri standard piu' 3 angoli di rotazione
      endif
      endif
!--check if there are mixed atom sites da affinare (solo se non ci sono gruppi)
c      if(NGroup12.eq.0.and.NumRestr12_Special.eq.1) then
      if(NGroup12.le.0) then
         do i=1,nats
            if(iSite(i).gt.0) then
               nPar15=15     ! oltre agli 11 param si considerano max 4 occupanze nel site
               exit
            endif
         enddo
      endif
!------------------------------------------------------------------------------
!--Creo copia delle direttive di affinamento
!--se presenti, espando restraint speciali  'site' e 'disorder'
!  in questo caso devo calcolare quante direttive saranno create
!------------------------------------------------------------------------------
      if(NumRestr12_Special.le.0) then
         NumCond12_C=NumCond12
      else
         NumCond12_C=0
      do jx = 1,NumCond12
            idrb=idir12(jx)
! 'site' directive---------------------------------------------------------
            if(idrb.eq.20) then
!--trovo quanti anomi sono indicati
         line=stringa12Tot(jx)
         call cutst(line,lenp,dire,lend)
               natoms=0
               if(lenp.le.0) goto 9004   ! error! non contiene niente altro
c--case something else (atomi)
               iok=0
               do while (iok == 0)   
                  call cutst(line,lenp,dire,lend)
                  vetch=dire(1:lend)
                  call LookforAtom(vetch,nord)
                  if(nord.eq.0)then     ! =0 atomo (gruppo,specie,etc) non trovato
                     iok1=1
                  else  
                     natoms=natoms+1
                  endif   
                  if(lenp.le.0) iok=1
               enddo     
!--calcolo numero di nuove direttive
!  fix label b[iso]
!  plus label occ occ1 ...
!  sum label occ occ1 ...
               NumCond12_C = NumCond12_C + natoms * 3
            endif
!------------------------------------------------------------------------------            
! 'disorder' directive---------------------------------------------------------
            if(idrb.eq.21) then      
!--trovo il numero di anomi             
               line=stringa12Tot(jx)
               call cutst(line,lenp,dire,lend)
               if(lenp.le.0) goto 9004   ! error! non contiene niente altro
               iopt=1
               call getnum(line,vet,ivet,iv,iopt)
               if(iv.ne.1) goto 9006     ! error! 
               natoms=vet(1)
!--calcolo numero di nuove direttive
!  plus ato1 occ 
!  plus ato2 occ 
!  ....              
!  fix  ato1 b[iso]
!  fix  ato2 b[iso]
!  ...               
!  equiv ato1 occ ato2 occ
!  factor ato2 occ -1.0
!  ...
               NumCond12_C = NumCond12_C + 6 * natoms    
            endif
!------------------------------------------------------------------------------            
         enddo
         NumCond12_C = NumCond12_C + NumCond12
      endif
!------------------------------------------------------------------------------
!--alloco vettori per direttive_Copia
!------------------------------------------------------------------------------
      call AllocaLsqStuff12_RT(2)
      call AllocaLsqStuff12_RT(1)
!------------------------------------------------------------------------------
!--start loop sulle direttive e creazione delle direttive RunTime
!------------------------------------------------------------------------------
      jy=0     
      do jx = 1,NumCond12
         jy=jy+1
         idir12_C(jy)=idir12(jx)
         stringa12Tot_C(jy)=stringa12Tot(jx)
         idrb=idir12(jx) 
         line=stringa12Tot(jx)
         call lcase(line)
         call cutst(line,lenp,dire,lend)
c--put 'fixed' = 'fix'
c         if(idrb.eq.10) idir12_C(jy )= 5
c--'end' directive         
         if(idrb.eq.9) exit 
!
!--loop on the directives
         select case(idrb)        
!--'diag' & 'full' directives
            case (1,2)       
               if(jx.ne.1) go to 9026
!--'site' directive
            case (20)
!--format: nessun atomo dato  (si elaborano tutti gli atomi con multiple site occupation)
!          label1  label2 ... (si elaborano solo gli atomi indicati)
c--case something else (atomi)
               iok=0
               do while (iok == 0)   
                  call cutst(line,lenp,dire,lend)
                  vetch=dire(1:lend)
                  call LookforAtom(vetch,j1)
                  if(j1.eq.0)then     ! =0 atomo (gruppo,specie,etc) non trovato
                     iok=1 
                  else  
c--variabili relative all'atomo  
                     icont=iSite(j1)
                     call shift(aLab(j1),len1)
c--insert the 'fix ' directive            
                     CardImageX=ifxhch//aLab(j1)(1:len1)//' '//bisoch 
                     call shift(CardImageX,lenX)
                     jy=jy+1
                     idir12_C(jy)=5
                     stringa12Tot_C(jy)=CardImageX(1:lenX)
c--insert the 'plus ' directive
                     CardImageX=plusch//aLab(j1)(1:len1)//' '//occch(1)
                     do i=1,icont
                        call shift(CardImageX,lenX)
                        CardImageX=CardImageX(1:lenX)//' '//occch(i+1)
                     enddo
                     call shift(CardImageX,lenX)
                     jy=jy+1
                     idir12_C(jy)=4
                     stringa12Tot_C(jy)=CardImageX(1:lenX)
c--insert the 'sum ' directive  (restraint)
                     CardImageX(1:5)=isumch(1:5)
                     jy=jy+1
                     idir12_C(jy)=15
                     stringa12Tot_C(jy)=CardImageX(1:lenX)
                  endif   
                  if(lenp.le.0) iok=1
               enddo
!--'disorder' directive
            case (21)
               line1=line(1:lenp)   ! salvo stringa
               iopt=1
               call getnum(line,vet,ivet,iv,iopt)
               line=line1
               if(iv.eq.1) then  
                  natoms=vet(1)
                  call cutst(line,lenp,dire,lend)  ! elimino il numero
               endif
c--case something else (atomi)
               natoms2=natoms*2
               do j=1,natoms2 
                  if(lenp.le.0) goto 9006  
                  call cutst(line,lenp,dire,lend)
                  vetch=dire(1:lend)
                  call LookforAtom(vetch,j1)
                  if(j1.eq.0) goto 9006
c--variabili relative all'atomo  
                  iato(j)=j1
               enddo
               do j1=1,natoms
                  call shift(aLab(j1),len1)
                  call shift(aLab(j1+natoms),len2)
c--insert the 'fix ' directive            
                  CardImageX=ifxhch//aLab(j1)(1:len1)//' '//bisoch 
                  call shift(CardImageX,lenX)
                  jy=jy+1
                  idir12_C(jy)=5
                  stringa12Tot_C(jy)=CardImageX(1:lenX)
!                  
                  CardImageX=ifxhch//aLab(j1+natoms)(1:len2)//
     *                      ' '//bisoch 
                  call shift(CardImageX,lenX)
                  jy=jy+1
                  idir12_C(jy)=5
                  stringa12Tot_C(jy)=CardImageX(1:lenX)
c--insert the 'plus ' directive
                  CardImageX=plusch//aLab(j1)(1:len1)//' '//occch(1)
                  call shift(CardImageX,lenX)
                  jy=jy+1
                  idir12_C(jy)=4
                  stringa12Tot_C(jy)=CardImageX(1:lenX)
!                  
                  CardImageX=plusch//aLab(j1+natoms)(1:len2)//
     *                      ' '//occch(1)
                  call shift(CardImageX,lenX)
                  jy=jy+1
                  idir12_C(jy)=4
                  stringa12Tot_C(jy)=CardImageX(1:lenX)
c--insert the 'equiv ' directive  
                  CardImageX=equich//aLab(j1)(1:len1)//' '//occch(1)
                  call shift(CardImageX,lenX)
                  CardImageX=CardImageX(1:lenX)//' '//
     *                       aLab(j1+natoms)(1:len2)//' '//occch(1)  
                  call shift(CardImageX,lenX)
                  jy=jy+1
                  idir12_C(jy)=15
                  stringa12Tot_C(jy)=CardImageX(1:lenX)
c--insert the 'factor ' directive 
                  CardImageX=factch//aLab(j1+natoms)(1:len2)//' '
     *                       //occch(1)//' -1.0' 
                  call shift(CardImageX,lenX)
                  jy=jy+1
                  idir12_C(jy)=6
                  stringa12Tot_C(jy)=CardImageX(1:lenX)
               enddo
            case default
               if(jx.eq.1) go to 9024
         end select
      enddo
      NumCond12_C = jy
!======================================================================
!--start loop sulle direttive RunTime
!======================================================================
      NumDirOver(:)=0
      do jx = 1,NumCond12_C
         idrb=idir12_C(jx)
         line=stringa12Tot_C(jx)
         call lcase(line)
         call cutst(line,lenp,dire,lend)
         codeparam12(:,jx)=0
         codeatom12(:,jx)=0
         stringa12(jx)=' '
!
!--second loop of select case
         select case(idrb)
!         
!--'diag', 'full', 'block', 'plus', 'fixed' directives
            case(1:5,10)
               natoms=0
               if(lenp.le.0) then   ! non contiene niente altro
!--case directive and nothing else
                  stringa12(jx)=' '              
                  codeparam12(1:10,jx)=1
                  if(NGroup12.eq.1) then
                     codeparam12(12:nPar15,jx)=1
                  endif
               else                 ! contiene altre informazioni
!--case something else (atomi, gruppi o parametri)
                  line1=line(1:lenp)
                  line2=' '
                  iok=0
                  iok1=0 
!--look for atoms                               
                  do while (iok == 0)   
                     call cutst(line,lenp,dire,lend)
                     vetch=dire(1:lend)
                     call LookforAtom(vetch,nord)
                     if(nord.eq.0)call LookforGroup(vetch,nord) 
                     if(nord.eq.0)then     ! =0 atomo (gruppo,specie,etc) non trovato
                        iok=2 
                        iok1=1
                     else  
                        natoms=natoms+1
                        call shift(line2,le)
                        line2=line2(1:le)//' '//dire(1:lend)
                     endif   
                     if(lenp.le.0) iok=1
                  enddo     
                  if(natoms.eq.0) then
                     stringa12(jx)=' '
                     n=KompareString(vetch,Param12,NumParam12,0)  ! check parameter                                        
                     call par22MNQD(jx,n)
                     if(iok.eq.2) then
                        call jpargMNQD(jx,0,line,ier) 
                     endif
                  else
                     stringa12(jx)=line2
                     if(iok1.eq.0)then      !  non ci sono parametri espliciti
                        codeparam12(1:10,jx)=1
                        if(NGroup12.eq.1) then
                           codeparam12(12:nPar15,jx)=1
                        endif
                     else                  !--look for parameters  
                         n=KompareString(vetch,Param12,NumParam12,0)  ! check parameter  
                         if(iok.eq.1) then
                            call par22MNQD(jx,n)
                         else                                      
                            call jpargMNQD(jx,n,line,ier) 
                         endif
                     endif
                  endif                 
               endif
!               
!--'group' directive
            case(18)
               natoms=0
               if(lenp.le.0) then   ! non contiene niente altro
!--case directive and nothing else
                  stringa12(jx)=' '              
                  codeparam12(1:10,jx)=1
                  codeparam12(12:nPar15,jx)=1
               else                 ! contiene altre informazioni
!--case something else (gruppi o parametri)
                  line1=line(1:lenp)
                  line2=' '
                  iok=0
                  iok1=0 
!--look for gruppi                               
                  do while (iok == 0)   
                     call cutst(line,lenp,dire,lend)
                     vetch=dire(1:lend)
                     call LookforGroup(vetch,nord) 
                     if(nord.eq.0)then     ! =0 atomo (gruppo,specie,etc) non trovato
                        iok=2 
                        iok1=1
                     else  
                        natoms=natoms+1
                        call shift(line2,le)
                        line2=line2(1:le)//' '//dire(1:lend)
                     endif   
                     if(lenp.le.0) iok=1
                  enddo     
                  if(natoms.eq.0) then
                     stringa12(jx)=' '
                     n=KompareString(vetch,Param12,NumParam12,0)  ! check parameter                                        
                     call par22MNQD(jx,n)
                     if(iok.eq.2) then
                        call jpargMNQD(jx,0,line,ier) 
                     endif
                  else
                     stringa12(jx)=line2
                     if(iok1.eq.0)then      !  non ci sono parametri espliciti
                        codeparam12(1:10,jx)=1
                        codeparam12(12:nPar15,jx)=1
                     else                  !--look for parameters  
                         n=KompareString(vetch,Param12,NumParam12,0)  ! check parameter  
                         if(iok.eq.1) then
                            call par22MNQD(jx,n)
                         else                                      
                            call jpargMNQD(jx,n,line,ier) 
                         endif
                     endif
                  endif                 
               endif
!               
!--'factor' directive              
            case(6)
               if(lenp.le.0) go to 9006   ! error! non contiene niente altro
               call cutst(line,lenp,dire,lend)
               vetch=dire(1:lend)
               call LookforAtom(vetch,nord)
               if(nord.le.0) goto 9006
               codeparam12(1,jx)=nord   
               call cutst(line,lenp,dire,lend)
               vetch=dire(1:lend)
               n=KompareString(vetch,Param12,NumParam12,0)  ! check parameter                                        
               codeparam12(2,jx)=n  
               iopt=0
               call getnum(line,vet,ivet,iv,iopt)
               if (iopt.eq.-1) go to 9006
               if (iv.ne.1) go to 9006
               codeparam12(3,jx)=int(vet(1)*1000.0)  
!               
!--'equiv' directive              
            case(7)
               if(lenp.le.0) go to 9006   ! error! non contiene niente altro
               call cutst(line,lenp,dire,lend)  ! 1a stringa
               vetch=dire(1:lend)
               call LookforAtom(vetch,nord)   ! check atom
               if(nord.le.0) goto 9006
               codeatom12(1,jx)=nord 
               call cutst(line,lenp,dire,lend)  ! 2a stringa
               vetch=dire(1:lend)
               call LookforAtom(vetch,nord)   ! check atom
               if(nord.le.0) then    !  non e' un atomo  (tipo 1 o 2)
                  n=KompareString(vetch,Param12,NumParam12,0)  ! check parameter                                        
                  if(n.le.0) goto 9006
                  codeparam12(1,jx)=n
                  call cutst(line,lenp,dire,lend)  ! 3a stringa
                  vetch=dire(1:lend)
                  call LookforAtom(vetch,nord) ! check atom
                  if(nord.gt.0) then   ! e' un atomo
!--equiv di tipo 1)  EQUIV  atom1  param1  atom2  param2                  
                     codeatom12(2,jx)=nord 
                     call cutst(line,lenp,dire,lend)  ! 4a stringa
                     vetch=dire(1:lend)
                     n=KompareString(vetch,Param12,NumParam12,0)  ! check parameter                                        
                     if(n.le.0) goto 9006
                     codeparam12(2,jx)=n
                     icodeequiv12(jx)=1
                  else            ! non e' un atomo
!--equiv di tipo 2)   EQUIV  atom  param1  param2                    
                     n=KompareString(vetch,Param12,NumParam12,0)  ! check parameter                                        
                     if(n.le.0) goto 9006
                     codeparam12(2,jx)=n
                     icodeequiv12(jx)=2
                   endif  
               else    ! e' un atomo   (tipo 3 o 4)
                  codeatom12(2,jx)=nord 
                  if(lenp.le.0) then   ! non ci sono strighe sucessive 
!--equiv di tipo 3)   EQUIV  atom1 atom2                    
                     icodeequiv12(jx)=3
                  else  ! letture parametri successivi
                     call jpargMNQD(jx,0,line,ier) 
!--equiv di tipo 4)   EQUIV  atom1 atom2  param1  param2...paramN                
                     icodeequiv12(jx)=4
                  endif
               endif  
!               
!--'ride' directive              
            case(8)
               if(lenp.le.0) go to 9006   ! error! non contiene niente altro
               stringa12(jx)=line(1:lenp)
!               
!--direttive dei restraint  
!--'dist', 'angle' & 'torsion' directives
            case(11,12,13)
               if(lenp.le.0) goto 9006   ! error! non contiene niente altro
               j1=idrb-9
               iopt=2
               call getnum(line,vet,ivet,iv,iopt)
               if(iv.eq.0) goto 9006   ! error! non contiene nimeri
               valuetarget12(jx)=vet(1)
               call cutst(line,lenp,dire,lend)  ! elimino 1o numero
               if(iv.ne.2) then
                  valuesigma12(jx)= 0.001
                  if(j1.gt.1)valuesigma12(jx)= 0.01
               else
                  valuesigma12(jx)= vet(2)
                  call cutst(line,lenp,dire,lend)  ! elimino 2o numero
               endif   
               do i=1,j1  
                  call cutst(line,lenp,dire,lend)
                  vetch=dire(1:lend)
                  call LookforAtom(vetch,nord)
                  if(nord.le.0) goto 9006  ! no. ord. atomo oppure =0 (atomo non trovato) 
                  codeatom12(i,jx)=nord
                  if(lenp.le.0.and.i.ne.j1) goto 9006  ! error!
               enddo     
!               
!--'planar' directives
            case(14)
               if(lenp.le.0) goto 9006   ! error! non contiene niente altro
               line1=line(1:lenp)   ! salvo stringa
               iopt=1
               call getnum(line,vet,ivet,iv,iopt)
               line=line1
               if(iv.eq.0) then  ! error! non contiene sigma
                  valuesigma12(jx)=0.0001
               else
                  valuesigma12(jx)=vet(1)
                  call cutst(line,lenp,dire,lend)  ! elimino il numero
               endif
               stringa12(jx)=line             
!               
!--'sum' directives
            case(15)
               if(lenp.le.0) goto 9006   ! error! non contiene niente altro
               jcont=0     ! code per record continue: indica cosa sta leggendo
               line1=line(1:lenp)   ! salvo stringa
               iopt=1
               call getnum(line,vet,ivet,iv,iopt)
               line=line1
               if(iv.eq.0) then  !  non contiene sigma
                  valuesigma12(jx)=0.0001
               else
                  valuesigma12(jx)=vet(1)
                  call cutst(line,lenp,dire,lend)  ! elimino il numero
               endif
               call cutst(line,lenp,dire,lend)  
               vetch=dire(1:lend)
               n=KompareString(vetch,Param12,NumParam12,0)  ! check parameter                                        
               if(n.le.0) then            ! non e' un parametro
                  call LookforAtom(vetch,nord)
                  if(nord.eq.0) goto 9006  ! error!
                  line2=dire(1:lend)
                  if(lenp.gt.0) then
                     iok=0
                     ok1=0 
!--look for atoms                               
                     do while (iok == 0)   
                        call cutst(line,lenp,dire,lend)
                        vetch=dire(1:lend)
                        call LookforAtom(vetch,nord)
                        if(nord.eq.0)then     ! =0 (atomo non trovato) 
                           iok=2 
                           iok1=1
                        else   
                           call shift(line2,le)
                           line2=line2(1:le)//' '//dire(1:lend)
                        endif   
                        if(lenp.le.0) iok=1
                     enddo     
                  endif
                  stringa12(jx)=line2             
                  if(iok1.eq.0)then      !  non ci sono parametri espliciti
                     jcont=1 ! fine record leggendo atomi
                     codeparam12(1:10,jx)=1
                     if(NGroup12.eq.1) then
                        codeparam12(12:nPar15,jx)=1
                     endif
                  else                  !--look for parameters  
                     n=KompareString(vetch,Param12,NumParam12,0)  ! check parameter  
                     if(iok.eq.1) then
                        call par22MNQD(jx,n)
                     else                                      
                        call jpargMNQD(jx,n,line,ier) 
                     endif
                  endif
               else
                  stringa12(jx)=' '              
                  call jpargMNQD(jx,n,line,ier) 
               endif
!               
!--'continue' directives
            case(16)
               idrb1=idir12(jx-1) 
               if(idrb1.eq.14) then    ! planar restraint
                  call shift(stringa12(jx-1),l1)
                  line=stringa12(jx-1)(1:l1)           
                  line1=line(1:lenp)   ! salvo stringa
                  n=78-l1
                  m=min(n,lenp)
                  stringa12(jx-1)=line(1:l1)//' '//line1(1:m)
               else if(idrb1.eq.15) then    ! sum restraint
                  if(jcont.eq.0) then
                     call jpargMNQD(jx,0,line,ier) 
                  else
                     codeparam12(1:10,jx)=0      !  azzero vettore codici param
                     call cutst(line,lenp,dire,lend)  
                     vetch=dire(1:lend)
                     n=KompareString(vetch,Param12,NumParam12,0)  ! check parameter                                        
                     if(n.le.0) then            ! non e' un parametro
                        call LookforAtom(vetch,nord)
                        if(nord.eq.0) goto 9006  ! error!
                        line2=dire(1:lend)
                        if(lenp.gt.0) then
                           iok=0
                           ok1=0 
!--look for atoms                               
                           do while (iok == 0)   
                              call cutst(line,lenp,dire,lend)
                              vetch=dire(1:lend)
                              call LookforAtom(vetch,nord)
                              if(nord.eq.0)then     !  =0 (atomo non trovato) 
                                 iok=2 
                                 iok1=1
                              else   
                                 call shift(line2,le)
                                 line2=line2(1:le)//' '//dire(1:lend)
                              endif   
                              if(lenp.le.0) iok=1
                           enddo     
                        endif
                        call shift(stringa12(jx-1),l1)
                        line3=stringa12(jx-1)(1:l1)
                        call shift(line2,l2)           
                        n=79-l1
                        m=min(n,l2)
                   stringa12(jx-1)=line3(1:l1)//' '//line2(1:m)
                        if(iok1.eq.0)then      !  non ci sono parametri espliciti
                           codeparam12(1:10,jx)=1
                           if(NGroup12.eq.1) then
                              codeparam12(12:nPar15,jx)=1
                           endif
                        else                  !--look for parameters  
                           n=KompareString(vetch,Param12,NumParam12,0)  ! check parameter  
                           if(iok.eq.1) then
                              call par22MNQD(jx,n)
                           else                                      
                              call jpargMNQD(jx,n,line,ier) 
                           endif
                        endif
                     else
                        call jpargMNQD(jx,n,line,ier) 
                     endif
                  endif 
               else if(idrb1.eq.17) then    ! limit restraint
                  call shift(stringa12(jx-1),l1)
                  line=stringa12(jx-1)(1:l1)           
                  line1=line(1:lenp)   ! salvo stringa
                  n=79-l1
                  m=min(n,lenp)
                  stringa12(jx-1)=line(1:l1)//' '//line1(1:m)
               endif
!               
!--'limit' directives
            case(17)
               if(lenp.le.0) goto 9006   ! error! non contiene niente altro
               line1=line(1:lenp)   ! salvo stringa
!--insert default value for sigma
               valuesig12(1,jx)=0.001
               valuesig12(2,jx)=0.1
               valuesig12(3,jx)=0.0001
               iopt=3
               call getnum(line,vet,ivet,iv,iopt)
               line=line1
               if(iv.ge.1) then  
                  valuesig12(1,jx)=vet(1)
                  call cutst(line,lenp,dire,lend)  ! elimino il numero
               endif
               if(iv.ge.2) then 
                  valuesig12(2,jx)=vet(2)
                  call cutst(line,lenp,dire,lend)  ! elimino il numero
               endif   
               if(iv.eq.3) then 
                  valuesig12(3,jx)=vet(3)
                  call cutst(line,lenp,dire,lend)  ! elimino il numero
               endif
               stringa12(jx)=line             
!               
!--'site' directives    
!--format: nessun atomo dato  (si elaborano tutti gli atomi con multiple site occupation)
!          label1  label2 ... (si elaborano solo gli atomi indicati)
            case(20)
               stringa12(jx)=line(1:lenp)
!               
!--disorder directives
!  format: No_atomi  at1 at2 ... atn  at1_a  at2_a ... atn_a
            case(21)
               line1=line(1:lenp)   ! salvo stringa
               iopt=1
               call getnum(line,vet,ivet,iv,iopt)
               line=line1
               if(iv.eq.1) then  
                  valuesig12(1,jx)=vet(1)
                  call cutst(line,lenp,dire,lend)  ! elimino il numero
               endif
               stringa12(jx)=line             
!               
         end select
!         
!--common branch solo se idrb=1,2,3,4 
         if(idrb.le.4) then      
            do i=1,NumOverall
               if(NumDirOver(i).ne.0) then
                  if(i.le.2) then
                     if(idra.ne.3) goto 9028
                  endif
               endif
            enddo
         endif
      enddo
      return
!
!--error messages
9004  continue
      write(Msg,9005) jx
      ier=-1
      call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
9005  format(2x,'card (j12x)',i2,2x,'error: no argument')
      return
9006  continue
      write(Msg,9007) jx
      ier=-1
      call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
9007  format(2x,'card (j12x)',i2,2x,'error: wrong argument')
      return
9018  continue
      write(Msg,9019) jx
      ier=-1
      call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
9019  format(2x,'card ',i2,2x,'error: paramemter ?')
      return
9024  continue
      write(Msg,9025) jx
      ier=-1
      call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
9025  format(2x,'card ',i2,2x,'error: ',
     1 'the first directive must be /a/ type')
      return
9026  continue
      write(Msg,9027) jx
      ier=-1
      call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
9027  format(2x,'card,',i2,2x,'error: there are incompatible'
     1 ,' directives')
      return
9028  continue
      write(Msg,9029) jx,vetch
      ier=-1
      call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
9029  format(2x,'card ',i2,' error: ',a4,' unknown parameter')
      return  
      end
!-----------------------------------------------------------------------
!  routine di ricerca e di flag
!-----------------------------------------------------------------------
!
!code for LookforAtom
      subroutine LookforAtom(vetch1,nord)
!--controlla se e' un nome di un atomo
!
      USE General
      USE Atomi
!
      character*16 iname, vetch1, vetch2      
      character*4 iunt(3)
      data iunt/'firs','last','unti'/
!
      nord=0
      call shift(vetch1,lenp1)                
      call lcase(vetch1)
!--controlla se first,last,until
      in=KompareString(vetch1,iunt,3,0)
      if(in.gt.0) then
         if(in.eq.1) nord=1
         if(in.eq.2) nord=nats
         if(in.eq.3) nord=-1
         return
      else
!--controlliamo se name1 e' una specie in lista 3
!      write(ncwu,'(a,a4)') 'controllo specie atomica ',name1(1)
         do i=1,nk
            vetch2=species(i)
            call shift(vetch2,lenp3)
            call lcase(vetch2)
            if(vetch1(1:lenp1).eq.vetch2(1:lenp3)) then
!--e' stata indicata la specie atomica
               nord=-2 
               return
            endif
         enddo
      endif
!--name1 e' un atomo
      do i=1,nats
           iname=aLab(i)
           call lcase(iname)
           call shift(iname,lnam)
           if (iname(1:lnam).ne.vetch1(1:lenp1))cycle
           nord=i
           exit
      enddo
      return
      end
!
!code for LookforGroup
      subroutine LookforGroup(vetch1,nord)
!--controlla se e' un nome di un atomo
!
      USE General
      USE LsqStuff
      USE LsqGroupsStuff
!
      character*16 iname, vetch1, vetch2      
      character*4 iunt(3)
      data iunt/'firs','last','unti'/
!
      nord=0
      if(NumGroup.le.0) return
      call shift(vetch1,lenp1)                
      call lcase(vetch1)
!--controlla se first,last,until
      in=KompareString(vetch1,iunt,3,0)
      if(in.gt.0) then
         nord=-1 
         return
      endif
!--name1 e' un atomo
      do i=1,NumGroup
           iname=aLabGroup(i)
           call lcase(iname)
           call shift(iname,lnam)
           if (iname(1:lnam).ne.vetch1(1:lenp1))cycle
           nord=i
           exit
      enddo
      return
      end
!                                                                       
!code for jpargMNQD                                                          
      subroutine jpargMNQD(jx,np,line,ier)
!--store into list 12 the parameters included in the
!  input paramater: 
!  jx   no. della direttiva  risultato su codeparam12(i,jx)  
!     = 0  risultato sul vettore codeparam(i)                                       
!  np = 0  nessun parametro letto prima   
!       n  first parameter read                                            
!  line  vector character holding the parameter name 
!  output parameter:
!  ier  = 0  OK (letto tutto il record)
!         1  stringa non e' un parametro
!            (line in output contiene la stringa non parametro e il resto)                           
!
      USE General
      USE Atomi
      USE LsqStuff12
!
      character*(*) line
      character*80 dire
      character*16 vetch, vetch1
!--
      ier=0
!--analisi del record
      j1=1      
      if(np.gt.0) then 
         call par22MNQD(jx,np)
         j1=2
      endif
      call shift(line,lenp)
      if(lenp.le.0) return
      do nn=j1,NumParam12
         call cutst(line,lenp,dire,lend)
         vetch=dire(1:lend)
         n=KompareString(vetch,Param12,NumParam12,0)
         if(n.le.0) then
            line=dire(1:lend)//line(1:lenp)   
            ier=1
            return
         endif      
         call par22MNQD(jx,n)
         if(lenp.le.0) return
      enddo
      return
      end
!
!code for par22MNQD
      subroutine par22MNQD(jx,np)
!--insert code
!  input paramater: 
!  jx   no. della direttiva  risultato su codeparam12(i,jx)  
!     = 0  risultato sul vettore codeparam(i)                                       
!
      USE General
      USE Atomi
      USE LsqStuff12
      USE LsqStuff12_RT
!
      if(NGroup12.eq.1) then
         if(np.ge.17.and.np.le.24) np=np-5   
      endif
      select case (np) 
         case (1:19)
            if(jx.le.0) then
               codeparam(np)=1
            else
               codeparam12(np,jx)=1
            endif
         case (25)    
            if(jx.le.0) then
               do i=1,3
                  codeparam(i)=1
               enddo
            else
               do i=1,3
                  codeparam12(i,jx)=1
               enddo
            endif
         case (26)
            if(jx.le.0) then
               do i=5,10
                  codeparam(i)=1
               enddo
            else
               do i=5,10
                  codeparam12(i,jx)=1
               enddo
            endif
         case (27)
            if(jx.le.0) then
               codeparam(5)=1
               codeparam(8)=1
               codeparam(10)=1
            else
               codeparam12(5,jx)=1
               codeparam12(8,jx)=1
               codeparam12(10,jx)=1
            endif
         case (28:32)
            if(jx.gt.0) then
               i=np-27
               NumDirOver(i)=jx
            endif
      end select
      return      
      end
!
!code for CreaMnqd
      subroutine CreaMnqd(jbb,ier,iprint)
!--carico vettori SIR per mappatura equaz. normali MNQD  (list 22)
!                                                                       
      USE General
      USE Atomi
      USE LsqModule
      USE LsqStuff
      USE LsqStuff12
      USE LsqStuff12_RT
      USE LsqGroupsStuff
!
      common/xcardch/CardImageX,idch(6)
      character CardImageX*80,idch*1
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xcard/nch,image(80),nc,nd,ni,nnt,na(3),ncd,idoc(20)
      common/xchar/id,ie,ib,icc,ia,ih,numb(10),iplus, inus,ipoint
!--
      ier=0
!      
!--pre analisi direttive refinement (ex lista 12)
      call AnalysisDirMNQD(ier)
!      call PrintRefi_RT(lo)
!      
      CodeGroup=NGroup12
!
      do i=1,NumOverall
         OverallNumBlock(i)=0
      enddo
      CodeEquiv = 0
      CodeWeight= 0
!
!--clear vettori  
!  nab(:) = no. del blocco di eq. normali
!         = 0  atomo fisso
!  Jaffina(:) = 0  atomo fissato            
!             = 1 o > 1 atomo da affinare
!  ckEquiv(:) = 0 non ci sono param equiv
!             = 1 ci sono param equiv
!  nParBl(:,:) = no. del blocco di eq. normali
!              = 0 parametro fisso  
!  iEquiv(:,1,:) = 1000  peso da applicare allo shift
!  iEquiv(:,2,:) = no. d'ordine dell'atomo equiv
!  iEquiv(:,3,:) = no. d'ordine del param dell'atomo equiv
!                                                   
      do in=1,NumOggettiMax
        nab(in)=0
        Jaffina(in)=0        ! default atomo fissati tutti i param 
        ckEquiv(in)=0
        do i=1,nPar15
             nParBl(i,in)=0      ! default parametro fissato (non da affinare)
             iEquiv(i,1,in)=1000
             do m=2,3
                iEquiv(i,m,in)=0
             enddo
        enddo
      enddo
!--check if H(s) are present
      IfirstHy=0
      do i1=1,nats
         kz=nzTot(i1)
         if(no(kz).eq.1)then
            IfirstHy=i1
            exit                      
         endif
      enddo
!--set current next free location for restraints directives
      nres=0     ! no. di restraints
      nrc=1      ! ind. nel vettore vres(:)
      nrc_previous=nrc
      vres(:)=0.0    
!
!--loop on list 12 
      n22=0         ! numero di blocchi   
      ista=0
      do jbb=1,NumCond12_C
        jFlagAtom(1:nats) = 0
        if(NumGroup.gt.0) jFlagGroup(1:NumGroup) = 0
        ist = idir12_C(jbb)
        if(ist.eq.9) exit   ! 'end' directive              
        if(ist.le.3) ista=ist                                         
        CardImageX=stringa12(jbb)
        call lcase(CardImageX)
        image(:)=ib                                                   
        read(CardImageX,'(80a1)') image                     
        nc=1                                                  
!
        select case (ist)
!
!--'diag'
          case (1)
            LsqType=1
            iy=1
            iaa=0
            ix=0
            call InsertCodeMnqd(jbb,iaa,iy,ix,jfier)
            if(jfier.ne.0.and.NumGroup.gt.0) then
              nca=nc
              call InsertCodeGroupMnqd(jbb,iaa,iy,ix,jfier,IfirstHy)
            endif  
            if(jfier.ne.0) goto 9010  
            n22=iaa
!                                                                       
!--'full'                                                               
          case (2)
            LsqType=2
            iy=0                                                              
            iaa=1
            n22=1                                                             
            ix=0
            call InsertCodeMnqd(jbb,iaa,iy,ix,jfier)
            if(jfier.ne.0.and.NumGroup.gt.0) then
              nca=nc
              call InsertCodeGroupMnqd(jbb,iaa,iy,ix,jfier,IfirstHy)
            endif  
            if(jfier.ne.0) goto 9010  
!                                                                       
!--'block'                                                              
          case (3)
            LsqType=3
            iaa=n22+1
            iy=0                                                              
            ix=0
            call InsertCodeMnqd(jbb,iaa,iy,ix,jfier)
            if(jfier.ne.0.and.NumGroup.gt.0) then
              nca=nc
              call InsertCodeGroupMnqd(jbb,iaa,iy,ix,jfier,IfirstHy)
            endif  
            if(jfier.ne.0) goto 9010  
            n22=iaa
!                                                                       
!--'plus'                                                               
          case (4)
            iy=0                                                              
            iaa=n22
            if(ista.eq.1) iy=1                                                
            ix=0
            call InsertCodeMnqd(jbb,iaa,iy,ix,jfier)
            if(jfier.ne.0.and.NumGroup.gt.0) then
              nca=nc
              call InsertCodeGroupMnqd(jbb,iaa,iy,ix,jfier,IfirstHy)
            endif  
            if(jfier.ne.0) goto 9010  
            n22=iaa
!
!--'group'
          case (18)
            iy=0
            iaa=n22
            if(ista.eq.1) iy=1                                                
            ix=0
            call InsertCodeGroupMnqd(jbb,iaa,iy,ix,jfier,IfirstHy)
            if(jfier.ne.0) goto 9010  
            n22=iaa
!
!--'rotamer'
!          case (19)
!-----------not more used          
!
!--'fix'                                                                
          case (5,10)
            iaa=0
            iy=0                                                     
            ix=0
            call InsertCodeMnqd(jbb,iaa,iy,ix,jfier)
            if(jfier.ne.0.and.NumGroup.gt.0) then
              nca=nc
              call InsertCodeGroupMnqd(jbb,iaa,iy,ix,jfier,IfirstHy)
            endif  
            if(jfier.ne.0) goto 9010  
!
!--'factor'
          case (6)
            n=codeparam12(1,jbb)  
            i=codeparam12(2,jbb) 
            iEquiv(i,1,n)=codeparam12(3,jbb)       
            CodeWeight=1
!
!--'equiv'
          case (7)
            iaa=n22
            if(ista.eq.1) iaa=0
            CodeEquiv=1
            select case (icodeequiv12(jbb))
!--3st kind of equiv directive	(atom1	atom2)
                case (3,4)
                  nn =codeatom12(1,jbb)  
                  iani1=0
                  if(IsoAniso(nn).eq.1) iani1=1
                  nnn=codeatom12(2,jbb) 
                  iani2=0
                  if(IsoAniso(nnn).eq.1) iani2=1
                  do i=1,3
                     if(icodeequiv12(jbb).eq.4) then   
!--4th kind of equiv directive	(atom1	atom2  p1)
                       if(Codeparam12(i,jbb).ne.0) then
                         call InsertEquivMnqd(iaa,nn,nnn,i,i,ier)
                       endif
                     else
!--3th kind of equiv directive	(atom1	atom2 )
                         call InsertEquivMnqd(iaa,nn,nnn,i,i,ier)
                     endif
                  enddo 
                  if(iani1+iani2.ne.1) then 
                     nn4=1      !  caso due atomi isotropi
                     j=4
                     if(iani1+iani2.eq.2) then  ! caso due atomi anisotropi
                        nn4=6
                        j=5
                     endif
                     do i=1,nn4
                        if(icodeequiv12(jbb).eq.4) then   
!--4th kind of equiv directive	(atom1	atom2  p1)
                           if(Codeparam12(j,jbb).ne.0) then
                              call InsertEquivMnqd(iaa,nn,nnn,j,j,ier)
                           endif
                        else
!--3th kind of equiv directive	(atom1	atom2 )
                           call InsertEquivMnqd(iaa,nn,nnn,j,j,ier)
                        endif  
                        j=j+1
                     enddo
                  endif      
!--2nd kind of 'equiv'	(atom p1 p2)
                case (2)
                  n  =codeatom12(1,jbb)  
                  i  =Codeparam12(1,jbb)                        
                  j  =Codeparam12(2,jbb)
                  call InsertEquivMnqd(iaa,n,n,i,j,ier)
!--1th kind of 'equiv' (atom1 p1 atom2 p2)
                case (1)
                  nn =codeatom12(1,jbb)  
                  nnn=codeatom12(2,jbb) 
                  i  =Codeparam12(1,jbb)                        
                  j  =Codeparam12(2,jbb)                        
                  call InsertEquivMnqd(iaa,nn,nnn,i,j,ier)
                end select
!
!--'ride'
          case (8)
            if (iconn(1).le.0) then
               write(lo,'(a)')' ERROR! no connectivity!'
               goto 9000
            endif
!--possible directives------------------------            
! 'ride  b h',
! 'ride  c h',
! 'ride  n h',
! 'ride  o h'
!---------------------------------------------            
            iaa=n22
            if(ista.eq.1) iaa=0
            CodeEquiv=1
            jFlagAtom(1:nats)=0
            ix=1
            call FindAtomMnqd(ix,ier)   ! c,n,o,b
            if(ier.ne.0) goto 9000
            jFlagAtom1(1:nats) = jFlagAtom(1:nats)
            jFlagAtom(1:nats)=0
            ix=1
            call FindAtomMnqd(ix,ier)   ! h
            if(ier.ne.0) goto 9000            
!------- ---Loop sulla connettivita'   
            m=2
            do n=1,iconn(1)
               if(iconn(m+2).ne.-1) then
                  nn =iconn(m  )
                  nnn=iconn(m+1)
                  if(jFlagAtom1(nn).eq.1)then        ! c,n,o,b 
                     if(jFlagAtom(nnn).eq.1) then   ! h
                        do i=1,3
                           call InsertEquivMnqdH(iaa,nn,nnn,i,i,ier)
                        enddo
                     endif
                  else if(jFlagAtom1(nnn).eq.1)then   ! c,n,o,b 
                     if(jFlagAtom(nn).eq.1) then     ! h
                        do i=1,3
                           call InsertEquivMnqdH(iaa,nnn,nn,i,i,ier)
                        enddo
                     endif
                  endif
               endif
               m=m+3
            enddo
!
!--'dist' & 'angle' & 'torsion' directives
          case (11,12,13)
            nres=nres+1
            vres(nrc)= ist-10                 ! restraint code
            vres(nrc+2)= valuesigma12(jbb)    ! sigma
            vres(nrc+3)= valuetarget12(jbb)   ! target
            Nvres12(nres)=jbb
            n25=2
            if(ist.eq.12) n25=3
            if(ist.eq.13) n25=4
            vres(nrc+1)= n25                  ! no. di atomi
            n=nrc+4
            do j25=1,n25
               vres(n)=codeatom12(j25,jbb)
               n=n+1
            enddo
            nrc=n
!
!--'planar' directive
          case (14)
            nres=nres+1
            nrc_previous=nrc
            vres(nrc)= ist-10                 ! restraint code
            vres(nrc+2)= valuesigma12(jbb)    ! sigma
            vres(nrc+3)= valuetarget12(jbb)   ! target
            Nvres12(nres)=jbb
!--find the atoms
            ix=0
            jFlagAtom(1:nats)=0
            call FindAtomMnqd(ix,ier)
            if(ier.ne.0) goto 9000
            n=nrc+4
            n25=0
            do i=1,nats
                  if(jFlagAtom(i).gt.0) then  
                     vres(n)=i
                     n=n+1
                     n25=n25+1
                  endif
            enddo
            vres(nrc+1)= n25                  ! no. di atomi
            nrc=n
!
!--'sum' directive
          case (15)
            nres=nres+1
            nrc_previous=nrc
            vres(nrc)= ist-10                 ! restraint code
            vres(nrc+2)= valuesigma12(jbb)    ! sigma
            Nvres12(nres)=jbb
            n=nrc+4
            m=0
            do j=1,nPar15  
               if(Codeparam12(j,jbb).ne.0) then
                  vres(n)=j
                  n=n+1
                  m=m+1
               endif
            enddo
            vres(nrc+3)= m 
            call shift(CardImageX,le)                     ! no. parametri
            if(le.le.0) then
               vres(nrc+1)= nats                  ! tutti gli atomi
               do i=1,nats
                  vres(n)=i
                  n=n+1
               enddo
            else
!--find the atoms
               ix=0
               jFlagAtom(1:nats)=0
               call FindAtomMnqd(ix,ier)
               if(ier.ne.0) goto 9000
               n25=0
               do i=1,nats
                  if(jFlagAtom(i).gt.0) then  
                     vres(n)=i
                     n=n+1
                     n25=n25+1
                  endif
               enddo
               vres(nrc+1)= n25                  ! no. di atomi
            endif     
            nrc=n
!
!--'continue' directive
!          case (16)
!--non viene elaborata in questo contesto
!
!--'limit' directive
          case (17)
            nres=nres+1
            nrc_previous=nrc
            vres(nrc)= ist-11                 ! restraint code (6)
            vres(nrc+2)= valuesig12(1,jbb)    ! sigma x
            vres(nrc+3)= valuesig12(2,jbb)    ! sigma b(iso)
            vres(nrc+4)= valuesig12(3,jbb)    ! sigma bij
            Nvres12(nres)=jbb
            n=nrc+5
!--find the atoms
            if(stringa12(jbb).eq.' ') then
               vres(nrc+1)= nats                  ! tutti gli atomi
               do i=1,nats
                  vres(n)=i
                  n=n+1
               enddo
            else
               ix=0
               jFlagAtom(1:nats)=0
               call FindAtomMnqd(ix,ier)
               if(ier.ne.0) goto 9000
               n25=0
               do i=1,nats
                  if(jFlagAtom(i).gt.0) then  
                     vres(n)=i
                     n=n+1
                     n25=n25+1
                  endif
               enddo
               vres(nrc+1)= n25        ! no. di atomi
            endif
            nrc=n
!
!--'site' directive
          case (20)
            nres=nres+1
            vres(nrc)= ist-13                 ! restraint code
            vres(nrc+2)= 0.0                  ! per analogia sigma
            vres(nrc+3)= 0.0                  ! per analogia target
            Nvres12(nres)=jbb
!--find the atoms
            ix=0
            jFlagAtom(1:nats)=0
            call FindAtomMnqd(ix,ier)
            if(ier.ne.0) goto 9000
            n25=0
            k=nrc+4
            do i=1,nats
               if(jFlagAtom(i).gt.0) then
                  vres(k)=i
                  k=k+1
                  n25=n25+1
               endif
            enddo
            vres(nrc+1)= n25                    ! no. di atomi
            nrc=k
!
!--'disorder' directive
!          case (21)
c            nres=nres+1
c            vres(nrc)= ist-13                 ! restraint code
c            Nvres12(nres)=jbb
c            vres(nrc+1)= valuesig12(1,jbb)        ! no. di atomi
c            n=nrc+2
c--find the atoms
c            ix=0
c            jFlagAtom(1:nats)=0
c            call FindAtomMnqd(ix,ier)
c            if(ier.ne.0) goto 9000
c            n25=0
c            do i=1,nats
c               if(jFlagAtom(i).gt.0) then
c                  vres(n)=i
c                  n=n+1
c                  n25=n25+1
c               endif
c            enddo
c            if(n25.ne.valuesig12(1,jbb)) goto 9000
c            nrc=n
!            
        end select
!
!--common branch
2001    continue
        do i=1,NumOverall
           if(NumDirOver(i).eq.jbb) OverallNumBlock(i)=n22
        enddo
      enddo
!--end of loop on n12 directives
      if(ista.eq.0) goto 9060
!
      if(ista.eq.1) n22=n22+1
      if(OverallNumBlock(1).eq.0) OverallNumBlock(1)=n22
      if(OverallNumBlock(2).eq.0) then
         if(ista.eq.1) OverallNumBlock(2)=n22
      endif
      if(OverallNumBlock(2).ne.0) then
         if(OverallNumBlock(1).ne.OverallNumBlock(2)) goto 9020
      endif
      NumBlockTot   = n22         !       no. di blocchi
      nBlocks       = n22         !       usata anche questa variabile
! Scale, B(overall), Extinction, Polarity, Twinning        
!      do n=1,NumOverall
!         OverallNumBlock(n)=iover22(n)
!      enddo
      do n=1,NumOverall
         m=nats+NumGroup+n  
         nParBl(1,m)=OverallNumBlock(n)
      enddo
      return
!      
!--error conditions      
9000  continue
      ier=1
      go to 9100
9010  continue
      ier=jfier
      go to 9100
9020  continue
      ier=3
      goto 9100
9050  continue
      ier=4
      goto 9100
9060  continue
      ier=5
9100  continue
      return
      end
c                                                                       
code for InsertEquivMnqd
      subroutine InsertEquivMnqd(ia,nn,nnn,i,j,ier)
c--insert equivalence code
c  ex function j22cm
c  ia    =n    number of block
c         0    direttiva diag (richiede che i parametri siano 
c              esplicitamente indicati da affinare , almeno uno)
c  nn     No. ord. atom1
c  nnn    No. ord. atom2
c  i      No. param1
c  j      No. param2
c  ier = 0   end OK
c
      USE General
      USE LsqStuff
!      
      ier=0
c--check the number block of the paramaters
      im22a=nParBl(i,nn)
      im22z=nParBl(j,nnn)
      if((im22z+im22a).le.0) then  
          if(ia.eq.0) goto 9050
          nParBl(i,nn) =ia
          nParBl(j,nnn)=ia 
      else
          if(im22z.eq.0) nParBl(j,nnn)=nParBl(i,nn)
          if(im22a.eq.0) nParBl(i,nn) =nParBl(j,nnn)
          im22a=nParBl(i,nn)
          im22z=nParBl(j,nnn)
          if(im22z.ne.im22a)goto 9050
      endif
c--check equivalenced parameters 
      if(iEquiv(i,2,nn).gt.0) then 
         if(iEquiv(j,2,nnn).gt.0) then
            nnn2= iEquiv(j,2,nnn)
            j2  = iEquiv(j,3,nnn)
            iEquiv(j2,2,nnn2)=iEquiv(i,2,nn)
            iEquiv(j2,3,nnn2)=iEquiv(i,3,nn)
         endif
         iEquiv(j,2,nnn)=iEquiv(i,2,nn)
         iEquiv(j,3,nnn)=iEquiv(i,3,nn)
         return
      endif
      if(iEquiv(j,2,nnn).gt.0) then 
         iEquiv(i,2,nn)=iEquiv(j,2,nnn)
         iEquiv(i,3,nn)=iEquiv(j,3,nnn)
         return
      endif
      iEquiv(j,2,nnn)=nn
      iEquiv(j,3,nnn)=i
      return
c--error exit
9050  continue
      ier=-1
      return
      end
c                                                                       
code for InsertEquivMnqdH
      subroutine InsertEquivMnqdH(ia,nn,nnn,i,j,ier)
c--insert equivalence code da RIDE directive
c  ex function j22cm
c  ia    =n    number of block
c         0    direttiva diag (richiede che i parametri siano 
c              esplicitamente indicati da affinare , almeno uno)
c  nn     No. ord. atom1  B,C,N,O
c  nnn    No. ord. atom2  H
c  i      No. param1
c  j      No. param2
c  ier = 0   end OK
c
      USE General
      USE LsqStuff
!      
      ier=0
c--check the number block of the paramaters
      im22a=nParBl(i,nn)
      if(im22a.eq.0) then
         nParBl(j,nnn)=0
         return
      endif
      nParBl(j,nnn)=nParBl(i,nn)
c--check equivalenced parameters 
      if(iEquiv(i,2,nn).gt.0) then       ! e' in equiv con un altro atomo
         iEquiv(j,2,nnn)=iEquiv(i,2,nn)
         iEquiv(j,3,nnn)=iEquiv(i,3,nn)
         return
      endif
      iEquiv(j,2,nnn)=nn
      iEquiv(j,3,nnn)=i
      return
c--error exit
9050  continue
      ier=-1
      return
      end
c
code for InsertCodeMnqd                                                          
      subroutine InsertCodeMnqd(jbb,ia,iy,ix,ier)
c--insert the requested code
c  ex function jfn22
c  iy  incremento del blocco i eq.norm (=1 or 0)
c  ia  numero del blocco (0 , 1, n22 previous)
c  ix  code per analisi della direttiva che definisce gli atomi (=0)
c  ier = 0   end OK
c
      USE Atomi
      USE LsqStuff
      USE LsqStuff12
      USE LsqStuff12_RT
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xcardch/CardImageX,idch(6)
      character CardImageX*80,idch*1
c
      ier=0
      if(CardImageX.eq.' ') then  
         jFlagAtom(1:nats) = 1
      else
        call FindAtomMnqd(ix,ier)
        if(ier.ne.0) return
      endif
      do n=1,nats                                                    
        if(jFlagAtom(n).eq.1) then    
          ia=ia+iy  
          nab(n)=ia             
          do k=1,3                                                     
            if(codeparam12(k,jbb).eq.1) nParBl(k,n)=ia 
          enddo
          if (IsoAniso(n).eq.2) then
             if(codeparam12(4,jbb).eq.1)nParBl(4,n)=ia   
          else
             do k=1,6
               if(codeparam12(4+k,jbb).eq.1) nParBl(4+k,n)=ia 
             enddo
          endif
!--occupanza
          imix=iSite(n)+1 
          do k=1,imix
             if(codeparam12(10+k,jbb).eq.1) nParBl(10+k,n)=ia 
          enddo
!--controllo  i parametri dell'atomo se fissati        
          m=0
          do k=1,nPar15
             if(kFix(k,n).eq.1)then 
                 nParBl(k,n)=0         ! 0 = parametro da fissare
             endif
          enddo
        endif                                                        
      enddo                                                          
      return                                                            
      end                                                               
c
code for FindAtomMnqd
      subroutine FindAtomMnqd(iall,ier)
c--find the specified atom(s) in list 5
c  ex  function jfnd5(iall,il50)
c
c  ier    = 0 all right
c	      1 atom(s) not found
c	      2 specie(s) not found
c  iall   = 0 all the card has to be analized
c         = 1 return after the first current definition
c--variabili interne routine
c  jy     = 0 all the atoms
c         = 1 only part of the atom(s)
c  jx     = -1 'until' is found
c         =  0 name of atom
c         =  n no. d'ordine della specie data
c
      USE General
      USE Atomi
      USE LsqStuff
      USE LsqStuff12
!
      common/xcardch/CardImageX,idch(6)
      character CardImageX*80,idch*1
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20)
c
      dimension name1(40),name2(40)
      character*16 vetch1,vetch2
      character*80 line,dire

      character*4 iunt(3)
      data iunt/'firs','last','unti'/
c--
      call shift(CardImageX,lenp)
      ier=0
      ifirst=0
      jy=0
      if(lenp.le.0) goto 2000  ! seleziono tutti gli atomi
900   continue
      jx=0
      jy=1
      line = CardImageX     !  salvo record
      call cutst(CardImageX,lenp,dire,lend)
c--controlla se first,last,until
      vetch1=dire(1:lend)
      in=KompareString(vetch1,iunt,3,0)
      if(in.gt.0) then 
          if(in.eq.3) goto 9000
          if(in.eq.1) iord1=1 
          if(in.eq.2) iord1=nats
          vetch1=aLab(iord1)
          call lcase(vetch1)
      else
c--controlliamo se name1 e' una specie in lista 3
c      write(ncwu,'(a,a4)') 'controllo specie atomica ',name1(1)
          do i=1,nk
             vetch2=species(i)
             call shift(vetch2,lenp3)
             call lcase(vetch2)
             if(vetch1(1:lend).eq.vetch2(1:lenp3)) then
c--e' stata indicata la specie atomica
                jx=i
                goto 2000
             endif
          enddo
c      write(ncwu,*)'non riconosco specie'
      endif
c--name1 e' un atomo
c--controllo se e' presenta qualcos'altro nel record
      vetch2=' '
      if(lenp.le.0) goto 2000
      line = CardImageX   ! salvo stringa attuale
      call cutst(CardImageX,lenp,dire,lend)
      vetch2=dire(1:lend)
      in=KompareString(vetch2,iunt,3,0)
c      write(ncwu,'(a,a4,1h%,a,1h%,i5)')' name2 ',name2(1),vetch2,in
      if(in.le.0) goto 1300  
      if(in.ne.3) goto 1300
      if(lenp.le.0) then
         iord1=nats
      else
         call cutst(CardImageX,lenp,dire,lend)
         vetch2=dire(1:lend)
c        if(jrca(name2,n,vetch2).eq.0) then  
         in=KompareString(vetch2,iunt,3,0)
         if(in.le.0) goto 1100   ! name1 until name2
         if(in.eq.3) goto 9000
         if(in.eq.1) iord1=1      
         if(in.eq.2) iord1=nats
c      else
c         iord1=nats
      endif
      vetch2=aLab(iord1)   
      call lcase(vetch2)
1100  continue
      jx=-1
      goto 2000
c1200  continue
c      if(ifirst.eq.0) goto 2000
c      return
1300  continue
      CardImageX=line   ! ripristino stringa salvata
      call shift(CardImageX,lenp)
c      nc=nca
      vetch2=' '
2000  continue
      ifirst=1
      call SetFlagAtom(vetch1,vetch2,jy,jx,j)
      if(j.ne.0) then
c         nc=ncx
         ier=j
         return
      endif
      if(iall.eq.1) return
      if(jy.eq.0) return
      if(lenp.le.0) return
      goto 900
c--error
9000  continue
      ier=1
      return
      end
c
code for SetFlagAtom
      subroutine SetFlagAtom(vetch1,vetch2,jy,jx,ier)
c--set flag in list 5
c  ex function jset5(vetch1,vetch2,jy,jx,il50)
c
c  ier    = 0 all right
c	      1 atom(s) not found
c	      2 specie(s) not found
c  jy	    = 0 all the atoms
c         = 1 only part of the atom(s)
c  jx     = -1 'until' is found
c         =  0 name of atom
c	    =  n numero della specie is given
c
      USE General
      USE Atomi
      USE LsqStuff
      USE LsqStuff12
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      character*16 vetch1,vetch2,iname
c
      call xshift(vetch1,nch1)
      call xshift(vetch2,nch2)
c      write(ncwu,'(a,1h$,a,1h$,2i5)')vetch1,vetch2,nch1,nch2
      ier=0
      ispetrov=0
      do i=1,nats
         ii=i
         if (jy.gt.0) then                 ! jy = 1 only part of the atom(s)
             if (jx.gt.0) then             ! jx >  0 the specie is given
                 ksp=nzTot(i)
                 if(ksp.eq.jx)then
                     ispetrov=1
                     jFlagAtom(i)=1
                 endif
                 cycle
             endif
             iname=aLab(i)
             call lcase(iname)
             call xshift(iname,lnam)
c      write(ncwu,'(a,1h$,a,1h$,a,1h$)')
c     1 '$$$',iname(1:lnam),vetch1(1:nch1)
             if (iname(1:lnam).ne.vetch1(1:nch1))cycle
             if (jx.lt.0) then            ! jx = -1 'until' is found
                jFlagAtom(ii)=1
                i1=ii+1
                do k=i1,nats
                   jFlagAtom(k)=1
                   iname=aLab(k)
                   call lcase(iname)
                   call xshift(iname,lnam)
                   if(iname(1:lnam).eq.vetch2(1:nch2)) return
                enddo
             else                         ! jx = 0 name of atom
                jFlagAtom(i)=1
                return
             endif
         else                             ! jy = 0 all the atoms
             jFlagAtom(i)=1
         endif
      enddo
      if(jx.gt.0) then
          if(ispetrov.eq.0) ier=2
          return
      endif
      if(jy.ne.0) ier=1
      return
      end
c
code for CalcolaNumParam
      subroutine CalcolaNumParam(ier)
!--calcola il numero di parametri da affinare
!  NParTot number of parameters to refine
!
      USE General
      USE Atomi
      USE LsqStuff
      USE LsqStuff22Abs
!
      ier=0
!-----------------------------------------------------------
!--calcolo il numero di parametri per blocco      
!-----------------------------------------------------------
      NParTot=0
      do n=1,nats
        do i=1,nPar15
           j=nParBl(i,n)       ! no del blocco a cui appartiene il parametro
           if(j.gt.0) then
c--controllo se il parametro e' equiv o fa parte di gruppo
              if(iEquiv(i,2,n).eq.0) then   !  parametro da affinare
c--incremento numero parametri 
                 NParTot=NParTot+1
              endif
           endif
        enddo
      enddo
!----------------------------------------------------------------------      
c--check if some groups are to be refined   *** Gruppo ***
      if(CodeGroup.eq.1) then
         do n=1,NumGroup
            m=nats+n
            do i=1,nPar15
               j=nParBl(i,m)    ! no del blocco a cui appartiene il parametro
               if(j.gt.0) then
c--controllo se il parametro e' equiv  (per analogia atomo)
                  if(iEquiv(i,2,m).eq.0) then  !  parametro da affinare
c--incremento numero parametri 
                     NParTot=NParTot+1
                  endif
               endif
            enddo
         enddo
      endif
!----------------------------------------------------------------------      
c--check overall parameters
      do n=1,NumOverall
         m=nats+NumGroup+n 
         j=nParBl(1,m) 
c--incremento numero parametri del blocco
         if(j.gt.0) then 
            NParTot=NParTot+1
         endif
      enddo
!-----------------------------------------------------------
!--fine calcolo del numero di parametri per blocco      
!-----------------------------------------------------------
      return
      end
c
code for MappaEqNor
      subroutine MappaEqNor(ier)
c--form absolute list 22  (ex jab22)
!  calcolato precedentemente: 
!  NumBlockTot (ex n22)  = numero di blocchi
!  NParTot number of parameters to refine
!
      USE General
      USE Atomi
      USE LsqStuff
      USE LsqStuff22
      USE LsqStuff22Abs
      USE LsqModule
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      dimension indbx(19)
      dimension iline(100),nam(4),inome(4)
      dimension iscal(20)
      character*40 iiscal
      data iiscal/'scale   ob(iso) extinctipolaritytwinning'/
c                  1234567890123456789012345678901234567890
      read(iiscal,'(20a2)')iscal
c--
      ier=0
!-------------------------------     
!--alloca vettore BlAddr(NumBlockTot) 
!-------------------------------     
      call AllocaLsqStuff22(2)
      call AllocaLsqStuff22(1)
! azzero numero parametri blocco  BlAddr(NumBlockTot)      
!  e' azzerato dopo aver allocato    BlAddr(:)=0   
!-----------------------------------------------------------
!--calcolo il numero di parametri per blocco      
!-----------------------------------------------------------
      do n=1,nats
        do i=1,nPar15
           j=nParBl(i,n)       ! no del blocco a cui appartiene il parametro
           if(j.gt.0) then
c--controllo se il parametro e' equiv o fa parte di gruppo
              if(iEquiv(i,2,n).eq.0) then   !  parametro da affinare
c--incremento numero parametri del blocco
                 BlAddr(j)=BlAddr(j)+1
              endif
           endif
        enddo
      enddo
!----------------------------------------------------------------------      
c--check if some groups are to be refined   *** Gruppo ***
      if(CodeGroup.eq.1) then
         do n=1,NumGroup
            m=nats+n
            do i=1,nPar15
               j=nParBl(i,m)    ! no del blocco a cui appartiene il parametro
               if(j.gt.0) then
c--controllo se il parametro e' equiv o fa parte di gruppo (per analogia atomo)
                  if(iEquiv(i,2,m).eq.0) then  !  parametro da affinare
c--incremento numero parametri del blocco
                     BlAddr(j)=BlAddr(j)+1
                  endif
               endif
            enddo
         enddo
      endif
!----------------------------------------------------------------------      
c--check overall parameters
      do n=1,NumOverall
         m=nats+NumGroup+n 
         j=nParBl(1,m) 
c--incremento numero parametri del blocco
         if(j.gt.0) then 
            BlAddr(j)=BlAddr(j)+1
         endif
      enddo
!-----------------------------------------------------------
!--fine calcolo del numero di parametri per blocco      
!-----------------------------------------------------------
      NParTot=0        ! numero totale di param da affinare
      NParBlMax=0      ! dimensione massima no. param dei blocchi
      DimMatMax=0      ! dimensione massima della matrice triangolare 
!                 ! delle eq. nor.+vettore termini noti
      do j=1,NumBlockTot
c--ritrovo numero di parametri del blocco
         n=BlAddr(j)
         if(n.gt.0) then
c--calcolo numero totale di parametri da affinare
            NParTot=NParTot+n
            NParBlMax=max0(n,NParBlMax)
            m=n*(n+1)/2
!--eliminato:   BlAddr(2,j)=m      ! non lo conservo piu'
            DimMatMax=max0(m,DimMatMax)
         endif
      enddo
!      n22a=NParTot   ! per compatibilita'
!---------------------------------     
!--alloca vettori: ParAddr(NumBlockTot,NParBlMax,2)
!                  EquaNorm(DimMatMax,NumBlockTot)   
!                  VettNorm(NParBlMax,NumBlockTot)   
!                  DeriPerz(1:NumBlockTot,1:NParBlMax,1:NumDerParz)
!                  DeriTot(1:NumBlockTot,1:NParBlMax)
!      NumBlockTot (n22)  = numero di blocchi
!      NParTot = numero di parametri da affinare
!      DimMatMax = numero massimo (matrice triangolare + vettore)
!      NParBlMax = numero massimo di parametri per blocco
!      NumDerParz= ex jq  numero di derivate parz. per parametro
!                    viene definito dalla routine che chiama questa
      call AllocaLsqStuff22Abs(2)
      call AllocaLsqStuff22Abs(1)
!----------------------------------------------------------------------
      nAddrDer(:,:)=0   ! azzero indirizzi derivate nel blocco (nPar15,NumOggettiMax)
      ParAddr(:,:,:)=0
!----------------------------------------------------------------------      
!--calculate again the number of the parameter for each block
!  e salvo gli indirizzi necessari nei vettori allocati
!----------------------------------------------------------------------      
      BlAddr(:)=0   ! azzero numero parametri blocco  (4,NumBlockTot)
      do n=1,nats
        ii=0
        ieqx=0
        do i=1,nPar15
           j=nParBl(i,n)       ! no del blocco a cui appartiene il parametro
           if(j.gt.0) then
c--controllo se il parametro e' equiv o fa parte di gruppo
              if(iEquiv(i,2,n).ne.0) then
                 ieqx=1
              else
c--parametro da affinare
                 ii=ii+1
c--incremento numero parametri del blocco
                 BlAddr(j)=BlAddr(j)+1
                 jj=BlAddr(j)
!--indirizzo nel blocco per ciascun atomo, parametro	           
                 nAddrDer(i,n)=jj   
! n.ord atomo per ciascun blocco, posizione all'interno blocco
                 ParAddr(j,jj,1)=n
! n.ord parametro per ciascun blocco, posizione all'interno blocco
                 ParAddr(j,jj,2)=i
              endif
           endif
        enddo
        ckEquiv(n) = ieqx	    ! 1 se almeno un parametro in equivalence
        if((ii.eq.0).and.(ieqx.eq.1)) ii=1    ! non ci sono parametri indipendenti, ma e' equiva...
        Jaffina(n)=ii             ! se = 0, l'atomo e' fisso e non vanno calc deriv
      enddo
!----------------------------------------------------------------------      
c--check if some groups are to be refined
      if(CodeGroup.eq.1) then
         do n=1,NumGroup
            m=nats+n
            ii=0
            ieqx=0
            do i=1,nPar15
               j=nParBl(i,m)    ! no del blocco a cui appartiene il parametro
               if(j.gt.0) then
c--controllo se il parametro e' equiv o fa parte di gruppo (per analogia atomo)
                  if(iEquiv(i,2,m).ne.0) then
                     ieqx=1
                  else
c--parametro da affinare
                     ii=ii+1
c--incremento numero parametri del blocco
                     BlAddr(j)=BlAddr(j)+1
                     jj=BlAddr(j)
                     nAddrDer(i,m)=jj
                     ParAddr(j,jj,1)=m
                     ParAddr(j,jj,2)=i
                  endif
               endif
            enddo
            ckEquiv(m)=ieqx
            if((ii.eq.0).and.(ieqx.eq.1)) ii=1
            Jaffina(m)=ii       ! se = 0, gruppo e' fisso e non vanno calc deriv
         enddo
      endif
!----------------------------------------------------------------------      
c--check overall parameters
      do n=1,NumOverall
         m=nats+NumGroup+n 
         j=nParBl(1,m) 
c--incremento numero parametri del blocco
         if(j.gt.0) then 
            BlAddr(j)=BlAddr(j)+1
            jj=BlAddr(j)
            nAddrDer(1,m)=jj
            ParAddr(j,jj,1)=m
            ParAddr(j,jj,2)=0
         endif
      enddo
!-------------------------------------------------------------------
      do m=1,NumOggettiMax
         if(ckEquiv(m).ne.0) then
            do i=1,nPar15
               j=nParBl(i,m)       ! no del blocco a cui appartiene il parametro
               if(j.gt.0) then     ! il parametro va affinato
c--controllo se il parametro e' equiv 
                  if(iEquiv(i,2,m).ne.0) then
                     n=iEquiv(i,2,m)   ! no. d'ord atomo
                     nn=iEquiv(i,3,m)  ! no. d'ord parametro	               
                     j1=nParBl(nn,n)! deve essere uguale a j, controllare o settare
                     nParBl(i,m)=j1
                     jj=nAddrDer(nn,n)
                     nAddrDer(i,m)=jj
                  endif
               endif
            enddo
         endif   
      enddo
c
c--print for testing
      if(iverb.gt.2) call MnqdPrtder
      return
      end
!
!code for ReadGroup                  *** Gruppo ***
      subroutine ReadGroup(jhost1,nrighe,ier)
!--Legge group (rigid-body)e riempie i vettori SIR (ex 55)
!--esempio file creato dalla routine       
!  subroutine f_RigidBody(nrighe, righe)
!
! ----- File per CaosGroup -----
!benz 1 6
! N2 C8 C13 C23 C18 C16
!benz 2 6
! C20 C21 C38 C39 C29 C22
!benz 3 6
! C2 C33 C35 C34 C32 C9
!
!end
! -----       EOF          -----
!                                                                         
      USE General
      USE Atomi
      USE Groups
      USE Molcom
      USE ZMatrix
      USE LsqModule
      USE LsqStuff
      USE LsqStuff12
      USE LsqGroupsStuff
!
      common/xcardch/CardImageX,idch(6)
      character CardImageX*80,idch*1
!      
      dimension ResIn(3,15),ResOut(3,15)  ! andrebbero dimensionati MaxAtomsGroup
      dimension ResOutTest(1:3,15)
!      
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      character vetch*16
      character*80 line, dire
      dimension ori(3,3),oria(3,3),x1(3),xr(3)
      dimension vet(40),ivet(40)
!
      dimension bijdu(6)
!      
      ier=0
      itest=0
!      itest=2
!
      if(nrighe.eq.0) then
         NumGroup=0
         NumRigheGroup=0
         call AllocaLsqGroups(2)
         InfoOK(13)=0
      else if(nrighe.gt.0) then
         call InitResidues()
         MaxAtomsGroup=MaxAtomsInGroups
!         
!        AminoName(nR) = Amino4(1:4)
!        ResidTable1(nR,1) = n_atoms
!--1a lettura dei gruppi dati dall'utente da file di input
!         
         rewind jhost1
         NumGroup=0
         NumRigheGroup=0
         do
            read(jhost1,'(a)') line
!           write(lo, '(a)') line(1:Lung(line))   
            call ucase(line)
            call shift(line,len)
            if(len.le.0) cycle
            NumRigheGroup=NumRigheGroup+1   !  conto i record
            if (line(1:3) == 'END') exit
            call lcase(line)
            call cutst(line,lenp,dire,lend)
            call ucase(dire)
            ngru=KompareString(dire,AminoName,nResid,0)
            if(ngru.gt.0) NumGroup=NumGroup+1   ! conto i gruppi
         enddo
c--alloca aree gruppi utente      
         call AllocaLsqGroups(2)
         call AllocaLsqGroups(1)
!      
!--2a lettura dei gruppi dati dall'utente da file di input
!     
         rewind jhost1
         nr=0
         jy=0 
         do
            read(jhost1,'(a)') line
!           write(lo, '(a)') line(1:Lung(line))
            call ucase(line)
            call shift(line,len)
            if(len.le.0) cycle
            nr=nr+1
            RigheGroup(nr)=line 
            if (line(1:3) == 'END') exit
!           call lcase(line)
            call cutst(line,lenp,dire,lend)
            ngru=KompareString(dire,AminoName,nResid,0)
            if(ngru.gt.0) then
               jy=jy+1 
               n_atoms=ResidTable1(ngru,1)
               NumAtomsGroup(jy)=n_atoms
               JcodeFrag(jy) = 0
               JflagGroup(jy)= 0
               NordGroup(jy) = jy    ! forse non serve piu'
               read(AminoName(ngru),'(a4)')TypeGroup(jy)
               NameLongGroup(jy)=AminoNameLong(ngru)
!--recupero coordinate z-matrix 
!              ncard= n_atoms    
               do jj=1,n_atoms
                  iloc(jj)=jj
                  xloc(1:3,jj)=ResidTable2(ngru,1:3,jj) 
                  nloc(1:3,jj)=ResidTable2(ngru,4:6,jj) 
!                 ResidTable2(nR,7,j) = ichar(Am1)
               enddo
!--dopo il nome del residuo leggo il numero d'ordine e il numero di atomi 
!  che deve essere uguale a n_atoms 
               iopt=0
               call getnum(line,vet,ivet,iv,iopt)
               if(iopt.eq.-1) go to 9006
               if(iv.ne.2) go to 9006
               if(ivet(2).ne.n_atoms) goto 9006
               call nomev2New(AminoName(ngru),vet(1),vetch)
               aLabGroup(jy) = vetch
               read(aLabGroup(jy),'(4a4)') NameGroup(1:4,jy)
               NserialGroup(jy)  = ivet(1)
!--leggo il record con i nome degli atomi                 
               read(jhost1,'(a)') line
               call shift(line,len)
!              write(lo, '(a)') line(1:Lung(line))
               nr=nr+1
               RigheGroup(nr)=line(1:len) 
!--look for atoms 
               natoms=0
               iok=0                              
               do while (iok == 0)   
                  call cutst(line,lenp,dire,lend)
                  vetch=dire(1:lend)
                  call LookforAtom(vetch,nord)
                  if(nord.gt.0)then     ! =0 atomo (gruppo,specie,etc) non trovato
                     natoms=natoms+1
                     NordAtomsGroup(natoms,jy)=nord    ! storizzo n.ord atomo
                     XCrystGroup(1:3,natoms,jy)=xyzs(1:3,nord)
                  endif   
                  if(lenp.le.0) iok=1
               enddo     
               if(natoms.ne.n_atoms) goto 9006
!--ho le coordinate cristallografiche del modello     
!--stampa di test
               if(itest.eq.1) then
                  write(ncwu,*)' coordinate originali'
                  do ja=1,n_atoms
                     nord=NordAtomsGroup(ja,jy)
                     call shift(aLab(nord),len)
                     write(ncwu,'(a,2x,10f10.5)') aLab(nord)(1:len),
     *                                      XCrystGroup(1:3,ja,jy)
                  enddo
               endif
!--recupero e ortogonalizzo coordinate input
!--1 e' l'origine
!  2 e' l'asse x
!  3 fornisce il piano dove calcolare l'asse y
               loo=1
               lx =2
               ly =3
!--salvo coordinate dell'origine
               x_orig(1:3)=XCrystGroup(1:3,loo,jy)
               do ja=1,n_atoms
                  ResIn(1:3,ja)=XCrystGroup(1:3,ja,jy)
               enddo               
               call OrtoGru(n_atoms,ResIn,ResOut,loo,lx,ly,15)     ! CONTROLLARE
               if(itest.ge.1) then
                  write(ncwu,*)' coordinate orto nel nuovo riferimento'
                  do ja=1,n_atoms
                     nord=NordAtomsGroup(ja,jy)
                     call shift(aLab(nord),len)
                     write(ncwu,'(a,2x,10f10.5)') aLab(nord)(1:len),
     *                                      ResOut(1:3,ja)
                  enddo
               endif
!--------------------------------------------------------------------            
!--inizio trasformazione delle coordinate atomiche da orto a cryst
               if(itest.eq.2) then
                  write(ncwu,*)' matrice: t_cryst(3,3)'
                  do i=1,3
                     write(ncwu,'(3f10.4)')(t_cryst(i,j),j=1,3)
                  enddo
                  do ja=1,n_atoms
                     x1(1:3)=ResOut(1:3,ja)
                     call orcor(x1(1),x1(2),x1(3),t_cryst,xr(1),
     *                         xr(2),xr(3))
                     ResOutTest(1:3,ja)=xr(1:3)+x_orig(1:3)
                  enddo
                  write(ncwu,*)' coordinate ripristinate originali'
                  do ja=1,n_atoms
                     nord=NordAtomsGroup(ja,jy)
                     call shift(aLab(nord),len)
                     write(ncwu,'(a,2x,10f10.5)') aLab(nord)(1:len),
     *                                      ResOutTest(1:3,ja)
                  enddo
               endif
!--fine test della trasformazione di base
!--------------------------------------------------------------------            
!--definisco le informazioni per la z-matrix routine
               nzm=n_atoms
               call zmatr_new(ier)
               if(itest.ge.1) then
                  write(ncwu,*)' coordinate orto da Z-matrix ordinate'
                  do ja=1,n_atoms
                     nord=NordAtomsGroup(ja,jy)
                     call shift(aLab(nord),len)
                     write(ncwu,'(a,2x,10f10.5)') aLab(nord)(1:len),
     *                                      xortolocal(1:3,ja)
                  enddo
               endif  
               do ja=1,n_atoms
                  XOrtoGroup(1:3,ja,jy)=xortolocal(1:3,ja)
               enddo
!--------------------------------------------------------------------            
!--inizio trasformazione delle coordinate atomiche da orto a cryst
               do ja=1,n_atoms
                  x1(1:3)=XOrtoGroup(1:3,ja,jy)
                  call orcor(x1(1),x1(2),x1(3),t_cryst,xr(1),
     *                       xr(2),xr(3))
                  ResOutTest(1:3,ja)=xr(1:3)+x_orig(1:3)
               enddo
               if(itest.ge.1) then
                  write(ncwu,*)' matrice: t_cryst(3,3)'
                  do i=1,3
                     write(ncwu,'(3f10.4)')(t_cryst(i,j),j=1,3)
                  enddo
                  write(ncwu,*)' coordinate ripristinate originali'
                  do ja=1,n_atoms
                     nord=NordAtomsGroup(ja,jy)
                     call shift(aLab(nord),len)
                     write(ncwu,'(a,2x,10f10.5)') aLab(nord)(1:len),
     *                                      ResOutTest(1:3,ja)
                  enddo
               endif
!--fine  della trasformazione di base 
!  da riportare nelle coordinate cristallografiche in cella xyzs
               do ja=1,n_atoms
                  nord=NordAtomsGroup(ja,jy)
                  xyzs(1:3,nord)=ResOutTest(1:3,ja)
               enddo
!--------------------------------------------------            
!--inserisco coordinate del gruppo e set flag degli atomi del gruppo
!--------------------------------------------------
               XGroup(1:3,jy)=x_orig(1:3) 
               BisoGroup(jy)=0
               BijGroup(1:6,jy)=0.0
               i1=0
               i2=0
               do ja=1,n_atoms
                  nord=NordAtomsGroup(ja,jy)
                  nGrCode(nord)=jy
                  nGrAtCode(nord)=ja
                  if(IsoAniso(nord).eq.2)then
                     i2=2
                     IsoAnisoGroup(jy)=2
                     BisoGroup(jy)=BisoGroup(jy)+bfac(nord)
                  else
                     i1=1
                     IsoAnisoGroup(jy)=1
                     BijGroup(1:6,jy)=BijGroup(1:6,jy)+ bij(1:6,nord)
                  endif
               enddo
               if(i1.ne.0.and.i2.ne.0)then
!  messaggio.....
               endif                  
               if(IsoAnisoGroup(jy).eq.2) then
                  BisoGroup(jy)=BisoGroup(jy)/n_atoms
               else
                  BijGroup(1:6,jy)=BijGroup(1:6,jy)/n_atoms
               endif
               OccGroup(jy)=1.0          
               SXGroup(1:3,jy) = 0.0
               SBisoGroup(jy)  = 0.0
               SBijGroup(1:6,jy) = 0.0
               SOccGroup(jy)   = 0.0
               SThetaGroup(jy) = 0.0
               SPhiGroup(jy)   = 0.0
               SPsiGroup(jy)   = 0.0
!--------------------------------------------------
!--orient [B] = Trasf x (orthogonal)-1 = [UB]*[U]-1
!--------------------------------------------------
               call prodm(rm,t_cryst,ori)
!--calcolo angoli euleriani
               isex=1.0
               if(ori(3,3).lt.0.0) isex=-1.0
               xa=abs(ori(3,3))
               iarc=0
               if(xa.lt.0.0) xa=0.0
               if(xa.ge.1.0) then
                  xa=1.0
                  iarc=1
               endif
               ori(3,3)=isex*xa
               theta=acos(ori(3,3))
               sintheta=sqrt(1-ori(3,3)*ori(3,3))
               if(iarc.eq.0) then
                  sinphi=ori(3,1)/sintheta
                  cosphi=-ori(3,2)/sintheta
                  phi=asin(sinphi)
                  ichange=0
                  if(sinphi.gt.0.0.and.cosphi.lt.0.0) ichange=1
                  if(sinphi.lt.0.0.and.cosphi.lt.0.0) ichange=1
                  if(ichange.eq.1) then
                     phi=pi-phi
                  else if(sinphi.lt.0.0.and.cosphi.gt.0.0) then
                     phi=twopi+phi
                  endif
                  sinpsi=ori(1,3)/sintheta
                  cospsi=ori(2,3)/sintheta
                  psi=asin(sinpsi)
                  ichange=0
                  if(sinpsi.gt.0.0.and.cospsi.lt.0.0) ichange=1
                  if(sinpsi.lt.0.0.and.cospsi.lt.0.0) ichange=1
                  if(ichange.eq.1) then
                     psi=pi-psi
                  else if(sinpsi.lt.0.0.and.cospsi.gt.0.0) then
                     psi=twopi+psi
                  endif
               else
!--vanno controllati i valori in casi particolari
               endif
               ThetaGroup(jy)= theta*rtd
               PhiGroup(jy)  = phi*rtd
               PsiGroup(jy)  = psi*rtd
            else
!--not group in the data base (FRAG)         
            endif
!--set zero matrici         
            ThetaDer(1:3,1:3,jy) = 0.0
            PhiDer(1:3,1:3,jy)  = 0.0
            PsiDer(1:3,1:3,jy)  = 0.0
            GGroup(1:3,1:3,jy)  = 0.0
!--end of loop of input record            
         enddo 
!------------------------------------------------
         InfoOK(13)=1
         if(itest.ge.1) call PrintGroup(lo)
      endif
      return
9006  continue
      write(Msg,9007) jy
      ier=-1
      call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
9007  format(2x,'Group',i3,2x,'error: wrong argument')
      return
      end
c
code for OrtoGru
      subroutine OrtoGru(ncard,ResMatIn,ResMatOut,loo,lx,ly,NRdim)
c-- ortogonalization
c  t_ortho(3,3) matrice di trasformazione da spazio cristalino a 
c               spazio di riferimento ortonormale monometrico del       modello 
c  t_cryst(3,3) matrice di trasformazione da spazio di riferimento
c              ortonormale monometrico del modello a spazio cristallino
c
      USE General
      USE Plotter
      USE ZMatrix
!
      dimension ResMatIn(3,NRdim),ResMatOut(3,NRdim)
c--
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/workb/hhh(3),ux(3),uy(3),uz(3),ncom,nstep,icomb(12)
      dimension ox(3),oy(3),tmt(3,3),tb(3,3),d(3,3)
      dimension x1(3),xr(3),x0(3)
c--
      itest=0
      vr=1.0/volume
      pis4=4*twopis
c inizio shift coordinate atomiche
      x0(1:3)=ResMatIn(1:3,loo)
      do ja=1,ncard
         ResMatOut(1:3,ja)=ResMatIn(1:3,ja)-x0(1:3)
      enddo
c inizio setting asse x ed asse y
      ox(1:3)=ResMatOut(1:3,lx)
      oy(1:3)=ResMatOut(1:3,ly)
      call newfr(vr,xgg,xgr,ox,oy,tm)
      do i=1,3
        do j=1,3
          tinv(i,j)=tm(i,j)
          d(i,j)=0.0
        enddo
      enddo
      call trasp(tm,t_cryst)
      ndim=3
      m=0
      call matin(tinv,ndim,d,m,det)
      call trasp(tinv,t_ortho)
c inizio trasformazione delle coordinate atomiche 
      do ja=1,ncard
        x1(1:3)=ResMatOut(1:3,ja)
        call orcor(x1(1),x1(2),x1(3),t_ortho,xr(1),xr(2),xr(3))
c che vengono ricopiate sulla vecchia 
        ResMatOut(1:3,ja)=xr(1:3)
      enddo
      return
      end
c
code for newfr
      subroutine newfr(vr,gd,grr,ox,oy,tm)
c--genera il nuovo sistema di riferimento
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension gd(3,3),grr(3,3),ox(3),oy(3),e1(3),e2(3),e3(3),
     *tm(3,3),wr(3),e2r(3),w(3)
c--
      call normer(ox,gd,e1)
      call prodv(vr,gd,grr,ox,oy,wr,w)
      call normer(w,gd,e3)
      call prodv(vr,gd,grr,e3,e1,e2r,e2)
      do 5 j=1,3
      tm(1,j)=e1(j)
      tm(2,j)=e2(j)
      tm(3,j)=e3(j)
    5 continue
      return
      end
c
code for PrintGroup                    *** Gruppo ***
      subroutine PrintGroup(ncwu)
c--print  groups run time  (ex 55)
c
      USE General
      USE Atomi
      USE LsqModule
      USE LsqStuff
      USE LsqGroupsStuff
!
      character*16 vetch
      character*80 lineaz
c--
      itest=0
!      itest=1
      write(ncwu,1010) NumGroup
1010  format(/,' Group(s) :',i4)
      do kk=1,NumGroup
         write(ncwu,1000) TypeGroup(kk),NserialGroup(kk),
     2   XGroup(1:3,kk),BisoGroup(kk),OccGroup(kk),NameGroup(1:4,kk)
1000     format(/,1x,a4,i4,3f10.5,2f10.3,2x,4a4)
         if(IsoAnisoGroup(kk).eq.1) then
            write(ncwu,1001) TypeGroup(kk),BijGroup(1:6,kk)
1001        format(1x,a4,4x,6f10.5)
         endif
         write(ncwu,1004) TypeGroup(kk),ThetaGroup(kk),PhiGroup(kk),
     *   PsiGroup(kk)
1004     format(1x,a4,4x,3f10.5)
         ncard=NumAtomsGroup(kk)
         if(itest.ne.0) then
c--stampo ulteriori dettagli del gruppo
            write(ncwu,*)' Matrice derivata per theta'
            write(ncwu,'(3f10.4)')((ThetaDer(i,j,kk),j=1,3),i=1,3) 
            write(ncwu,*)' Matrice derivata per phi'
            write(ncwu,'(3f10.4)')((PhiDer  (i,j,kk),j=1,3),i=1,3) 
            write(ncwu,*)' Matrice derivata per psi'
            write(ncwu,'(3f10.4)')((PsiDer  (i,j,kk),j=1,3),i=1,3)  
            write(ncwu,*)' Matrice orientazione G'
            write(ncwu,'(3f10.4)')((GGroup  (i,j,kk),j=1,3),i=1,3)   
c--coordinate ortogonali
           write(ncwu,*)' Coordinate ortogonali gruppo'
           do ja=1,ncard
              write(ncwu,'(3f10.4)')XOrtoGroup(1:3,ja,kk)
           enddo
         endif
c--find in list 5 gli atomi del gruppo
         write(ncwu,'(a,i5)')' N. of atoms:',ncard
         n=0
         aLabPrintGroup(1:MaxAtomsGroup,kk) = ' '
         do i=1,ncard
            nord=NordAtomsGroup(i,kk)
            aLabPrintGroup(i,kk) = aLab(nord)
         enddo  
         m=1
         lineaz=' '
         do i=1,ncard
            call shift(aLabPrintGroup(i,kk),l)
            if(60-m.lt.l) then
                 write(ncwu,'(1x,a)')lineaz(1:m)
                 lineaz=' '
                 m=1
            endif
            lineaz(m:m+l-1)=aLabPrintGroup(i,kk)(1:l)
            m=m+l+1
         enddo
         write(ncwu,'(1x,a)')lineaz(1:m)
c--fine gruppo       
      enddo
      write(ncwu,'(1h )')
      return
      end
!
!code for InsertCodeGroupMnqd                                                          
      subroutine InsertCodeGroupMnqd(jbb,ia,iy,ix,ier,IfirstHy)
!--insert the requested code per gruppo            *** Gruppo ***
!  jbb no. d'ordine scheda in list 12
!  iy  incremento del blocco ci eq.norm (=1 or 0)
!  ia  numero del blocco (0 , 1, n22 previous)
!  ix  code per analisi della direttiva che definisce gli atomi (=0)
!  ier = 0   end OK
!
      USE General
      USE Atomi
      USE LsqModule
      USE LsqStuff
      USE LsqStuff12
      USE LsqStuff12_RT
      USE LsqGroupsStuff
!
      common/xcardch/CardImageX,idch(6)
      character CardImageX*80,idch*1
!
      integer icodeH(4),iHG
      character vetch*16
!
      ier=0
      if(CardImageX.eq.' ') then  
         jFlagGroup(1:NumGroup) = 1
      else
         call FindGroupMnqd(ix,ier)
         if(ier.ne.0) return
      endif
      m=nats
      do n=1,NumGroup 
         m=m+1                                                    
         if(jFlagGroup(n).eq.1) then    
            ia=ia+iy  
            nab(m)=ia             
!--abilito parametri posizionali
            do k=1,3                                           
               if(codeparam12(k,jbb).eq.1) nParBl(k,m)=ia 
            enddo
!--abilito parametri termici
            if (IsoAnisoGroup(n).eq.2) then
               if(codeparam12(4,jbb).eq.1) nParBl(4,m)=ia   
            else
              do k=1,6
                 if(codeparam12(4+k,jbb).eq.1) nParBl(4+k,m)=ia 
              enddo
            endif
!--non abilito occupanza
!           if(codeparam12(11,jbb).eq.1) nParBl(11,m)=ia 
!--abilito gli angoli
            do k=1,3                                     
               if(codeparam12(11+k,jbb).eq.1) nParBl(11+k,m)=ia 
            enddo
!----------------------------------------------------------------------------
            do k=1,nPar15
               if(kFix(k,m).eq.1)then 
                 nParBl(k,m)=0               ! 0 = parametro da fissare
               endif
            enddo
!------------------------------------------------------------------------------
!            
            n_atoms=NumAtomsGroup(n)
            do ja=1,n_atoms
               nord=NordAtomsGroup(ja,n)
               nGrCode(nord)=n
               nGrAtCode(nord)=ja
            enddo
!--aggiornamento atomi appartenenti al *** Gruppo ***   
            do i=1,nats
               igrcode=nGrCode(i)
               nacode =nGrAtCode(i)
               if(igrcode.eq.n) then
c--atomo trovato: devo dire che l'atomo e' da affinare nel blocco del gruppo
!--usando le stesse condizioni dei parametri per il gruppo
                  Jaffina(i)=1
                  nab(i)= ia
                  ckEquiv(i)= 1
!--check if H rides this atom
                  iHG=0                         
                  if(IfirstHy.gt.0) then   !  check if H are present
                     icodeH(:)=0
                     do i1=IfirstHy,nats     
                        do k=1,3
                           if(iequiv(k,2,i1).eq.i) then
                              iHG=iHG+1
                              icodeH(iHG)=i1 
                              exit                      
                           endif
                        enddo
                     enddo
                  endif
!--end of checking                  
                  nnn=0
                  do k=1,3    
                     if(codeparam12(k,jbb).eq.1) then
                         nParBl(k,i)=ia 
                         if(iequiv(k,2,i).gt.0) then
                            nnn=iequiv(k,2,i)
                            jjj=iequiv(k,3,i)
                            iequiv(jjj,2,nnn)=nats+n
                            iequiv(jjj,3,nnn)=k
                         endif
                         iequiv(k,2,i)=nats+n
                         iequiv(k,3,i)=k
                         if(iHG.gt.0)then
                            do l=1,iHG
                               i1=icodeH(l)
                               nParBl(k,i1)=ia 
                               iequiv(k,2,i1)=iequiv(k,2,i)
                               iequiv(k,3,i1)=iequiv(k,3,i)
                            enddo                              
                         endif 
                     endif
                  enddo
                  if (IsoAniso(i).eq.2) then
                     if(codeparam12(4,jbb).eq.1)then 
                         nParBl(4,i)=ia   
                         if(iequiv(4,2,i).gt.0) then
                            nnn=iequiv(4,2,i)
                            jjj=iequiv(4,3,i)
                            iequiv(jjj,2,nnn)=nats+n
                            iequiv(jjj,3,nnn)=4
                         endif
                         iequiv(4,2,i)=nats+n
                         iequiv(4,3,i)=4
                     endif
                  else
                     do k=1,6
                        if(codeparam12(4+k,jbb).eq.1) then
                            nParBl(4+k,i)=ia 
                         if(iequiv(4+k,2,i).gt.0) then
                            nnn=iequiv(4+k,2,i)
                            jjj=iequiv(4+k,3,i)
                            iequiv(jjj,2,nnn)=nats+n
                            iequiv(jjj,3,nnn)=4+k
                         endif
                            iequiv(4+k,2,i)=nats+n
                            iequiv(4+k,3,i)=4+k
                        endif
                     enddo
                  endif
!--non abilito l'occupazione
!                 if(codeparam12(11,jbb).eq.1) nParBl(11,i)=ia 
!--abilito gli angoli
                  do k=1,3
                     if(codeparam12(11+k,jbb).eq.1) then 
                        nParBl(11+k,i)=ia 
                        iequiv(11+k,2,i)=nats+n
                        iequiv(11+k,3,i)=11+k
                        if(nnn.ne.0) then
                           nParBl(11+k,nnn)=ia 
                           iequiv(11+k,2,nnn)=nats+n
                           iequiv(11+k,3,nnn)=11+k
                        endif
                         if(iHG.gt.0)then
                            do l=1,iHG
                               i1=icodeH(l)
                               nParBl(11+k,i1)=ia 
                               iequiv(11+k,2,i1)=iequiv(11+k,2,i)
                               iequiv(11+k,3,i1)=iequiv(11+k,3,i)
                            enddo                              
                         endif 
                     endif
                  enddo
!----------------------------------------------------------------------------
                  do k=1,nPar15
                     if(kFix(k,i).eq.1)then 
                        nParBl(k,i)=0        ! 0 = parametro da tenere fisso
                        if(iHG.gt.0)then
                            do l=1,iHG
                               i1=icodeH(l)
                               nParBl(k,i1)=0 
                            enddo                              
                         endif 
                     endif
                  enddo
!------------------------------------------------------------------------------
               endif
            enddo
c--fine aggiornamento
         endif                                                        
      enddo                                                          
      return                                                            
      end                                                               
c
code for FindGroupMnqd
      subroutine FindGroupMnqd(iall,ier)
c--find the specified atom(s) in list 55
c  ex  function jfnd5(iall,il50)
c
c  ier    = 0 all right
c	      1 atom(s) not found
c	      2 specie(s) not found
c  iall   = 0 all the card has to be analized
c         = 1 return after the first current definition
c--variabili interne routine
c  jy     = 0 all the atoms
c         = 1 only same part of the atom(s)
c  jx     = -1 'until' is found
c         =  0 name of atom
c         =  n no. d'ordine della specie data
c
      USE General
      USE Atomi
      USE LsqStuff
      USE LsqStuff12
      USE LsqGroupsStuff
!
      common/xcardch/CardImageX,idch(6)
      character CardImageX*80,idch*1
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20)
!
      dimension name1(40),name2(40)
      character*16 vetch1,vetch2
      character*80 line,dire
!      
      character*4 iunt(3)
      data iunt/'firs','last','unti'/
c--
      call shift(CardImageX,lenp)
      ier=0
      ifirst=0
      jy=0
      if(lenp.le.0) goto 2000  ! seleziono tutti i gruppi
900   continue
      jx=0
      jy=1
      line = CardImageX     !  salvo record
      call cutst(CardImageX,lenp,dire,lend)
c--controlla se first,last,until
      vetch1=dire(1:lend)
      in=KompareString(vetch1,iunt,3,0)
      if(in.gt.0) then 
          if(in.eq.3) goto 9000
          if(in.eq.1) iord1=1 
          if(in.eq.2) iord1=NumGroup
          vetch1=aLabGroup(iord1)
          call lcase(vetch1)
      endif
c--name1 e' un gruppo
c--controllo se e' presenta qualcos'altro nel record
      vetch2=' '
      if(lenp.le.0) goto 2000
      line = CardImageX   ! salvo stringa attuale
      call cutst(CardImageX,lenp,dire,lend)
      vetch2=dire(1:lend)
      in=KompareString(vetch2,iunt,3,0)
c      write(ncwu,'(a,a4,1h%,a,1h%,i5)')' name2 ',name2(1),vetch2,in
      if(in.le.0) goto 1300  
      if(in.ne.3) goto 1300
      if(lenp.le.0) then
         iord1=NumGroup
      else
         call cutst(CardImageX,lenp,dire,lend)
         vetch2=dire(1:lend)
c        if(jrca(name2,n,vetch2).eq.0) then  
         in=KompareString(vetch2,iunt,3,0)
         if(in.le.0) goto 1100   ! name1 until name2
         if(in.eq.3) goto 9000
         if(in.eq.1) iord1=1      
         if(in.eq.2) iord1=NumGroup
c      else
c         iord1=nats
      endif
      vetch2=aLab(iord1)   
      call lcase(vetch2)
1100  continue
      jx=-1
      goto 2000
1300  continue
      CardImageX=line   ! ripristino stringa salvata
      call shift(CardImageX,lenp)
c      nc=nca
      vetch2=' '
2000  continue
      ifirst=1
      call SetFlagGroup(vetch1,vetch2,jy,jx,j)
      if(j.ne.0) then
c         nc=ncx
         ier=j
         return
      endif
      if(iall.eq.1) return
      if(jy.eq.0) return
      if(lenp.le.0) return
      goto 900
c--error
9000  continue
      ier=1
      return
      end
c
code for SetFlagGroup
      subroutine SetFlagGroup(vetch1,vetch2,jy,jx,ier)
c--set flag in list 55
c  ex function jset55(vetch1,vetch2,jy,jx,il50)
c
c  ier    = 0 all right
c	      1 group(s) not found
c  jy	    = 0 all the group(s)
c         = 1 only same part of the group(s)
c  jx     = -1 'until' is found
c         =  0 name of atom
c
      USE General
      USE Atomi
      USE LsqStuff
      USE LsqStuff12
      USE LsqGroupsStuff
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      character*16 vetch1,vetch2,iname
c
      call xshift(vetch1,nch1)
      call xshift(vetch2,nch2)
c      write(ncwu,'(a,1h$,a,1h$,2i5)')vetch1,vetch2,nch1,nch2
      ier=0
      ispetrov=0
      do i=1,NumGroup
         ii=i
         if (jy.gt.0) then                 ! jy = 1 only same part of the atom(s)
             iname=aLabGroup(i)
             call lcase(iname)
             call xshift(iname,lnam)
c      write(ncwu,'(a,1h$,a,1h$,a,1h$)')
c     1 '$$$',iname(1:lnam),vetch1(1:nch1)
             if (iname(1:lnam).ne.vetch1(1:nch1))cycle
             if (jx.lt.0) then            ! jx = -1 'until' is found
                jFlagGroup(ii)=1
                i1=ii+1
                do k=i1,NumGroup
                   jFlagGroup(k)=1
                   iname=aLabGroup(k)
                   call xshift(iname,lnam)
                   if(iname(1:lnam).eq.vetch2(1:nch2)) return
                enddo
             else                         ! jx = 0 name of atom
                jFlagGroup(i)=1
                return
             endif
         else                             ! jy = 0 all the atoms
             jFlagGroup(i)=1
         endif
      enddo
      if(jx.gt.0) then
          if(ispetrov.eq.0) ier=2
          return
      endif
      if(jy.ne.0) ier=1
      return
      end
c
code for PrintMappaEqNor
      subroutine PrintMappaEqNor
c--full printing Mappa Equazioni Normali (list 12)
c--(ex prt22)
      USE General
      USE Atomi
      USE LsqModule
      USE LsqStuff
      USE LsqStuff12
      USE LsqGroupsStuff
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
!
      dimension ipar(15),iname(4)
      character LabCurrent(15)*16, ParCurrent(15)*4
      character*4 iparch(15),ialfch
      data iparch/'x   ','y   ','z   ','b(is','(11)','(12)','(13)',
     2     '(22)','(23)','(33)','occ','occ1','occ2','occ3','occ4'/
      data ialfch/'tau '/
c--
      write(ncwu,1050) nats,NumGroup
1050  format(/,' number of atom(s)    :',i6,/,
     1         ' number of group(s)   :',i6,/,
     1         ' format : parameters',/,
     2         '          no. of block',/,
     3         '          weight',/,
     4         '          atom equivalent',/,
     5         '          parameter equivalent',/)
      write(ncwu,1200)
1200  format(5x,'Scale',4x,'Ob[iso]',4x,'Extinc',
     1 2x,'Polarity',2x,'Twinning',/)
      write(ncwu,1210) FcScale,FcBiso,FcExtin,FcPola,FcTwin
1210  format(1x,2f10.5,3f10.3)
!      write(ncwu,1210) Overall_dev
      write(ncwu,1220) OverallNumBlock
1220  format(i8,10i10)
      write(ncwu,1060)
1060  format(/,1x,5h name,2x,5h type,1x,7h serial,4x,2h x,
     1 8x,2h y,8x,2h z,
     2 6x,6hb(iso),4x,6h b(11),4x,6h b(12),
     3 /,23x,6h b(13), 4x,6h b(22),
     3 4x,6h b(23),4x,6h b(33),5x,4h occ)
c--controllo se ci sono gruppi da affinare     
      if(CodeGroup.gt.0) then
         write(ncwu,1061)
1061     format(23x,' theta',4x,'  phi ',4x,'  psi ')
      endif
      write(ncwu,'(1x)')
!--loop sugli atomi      
      do i=1,nats
c--1a raw
        LabCurrent=' '
        ParCurrent=' '
        j = nzTot(i)
        write(ncwu,1110)aLab(i), nalf(j),                  ! prima stampa
     1     serial(i),xyzs(1:3,i), bfac(i),bij(1:2,i)
1110    format(1x,a8,1x,a4,i6,11f10.5)
        write(ncwu,1075) nParBl(1:6,i)                     ! seconda stampa
1075    format(20x,11i10)
        write(ncwu,1130) float(iEquiv(1:6,1,i)) / 1000.0   ! terza stampa
1130    format(20x,11f10.2)
        do n=1,6
           k2  = iEquiv(n,2,i)
           if(k2.gt.0) then 
           if(k2.le.nats) then
               LabCurrent(n)=aLab(k2)
           else
               LabCurrent(n)=aLabGroup(k2-nats)
           endif
           endif
        enddo   
        write(ncwu,1151)LabCurrent(1:6)                    ! quarta stampa
1151    format(24x,11(2x,a8))
        do n=1,6
           k2  = iEquiv(n,3,i)
           if(k2.le.0) then
               ParCurrent(n)=' '
           else
               ParCurrent(n)=iparch(k2)
           endif
        enddo   
        write(ncwu,1190)ParCurrent(1:6)                    ! quinta stampa
1190    format(22x,11(4x,a4,2x))
c--2a raw
        write(ncwu,1110)aLab(i), nalf(j),                  ! prima stampa
     1     serial(i),bij(3:6,i),xyzs(5,i)
        write(ncwu,1075) nParBl(7:11,i)                    ! seconda stampa
         write(ncwu,1130) float(iEquiv(7:11,1,i)) / 1000.0 ! terza stampa
        do n=7,11
           k2  = iEquiv(n,2,i)
           if(k2.gt.0) then 
           if(k2.le.nats) then
               LabCurrent(n)=aLab(k2)
           else
               LabCurrent(n)=aLabGroup(k2-nats)
           endif
           endif
        enddo   
        write(ncwu,1151)LabCurrent(7:11)                    ! quarta stampa
        do n=7,11
           k2  = iEquiv(n,3,i)
           if(k2.le.0) then
               ParCurrent(n)=' '
           else
               ParCurrent(n)=iparch(k2)
           endif
        enddo   
        write(ncwu,1190)ParCurrent(7:11)                    ! quinta stampa
c--check if there are mixed atoms
        if (iSite(i) > 0) then
c--3a raw and ....        
            imix=iSite(i)
            do jj=1, imix
c--pick up the form factors for mixed atoms
               ksp1 = int(SiteInfo(jj,i)) / 10             ! specie
               occ  = amod(SiteInfo(jj,i),10.0)            ! occupazione
               write(ncwu,1185)  nalf(ksp1),occ             ! prima stampa 
1185           format(10x,a4,f16.5)
               write(ncwu,1075) nParBl(11+jj,i)             ! seconda stampa
               write(ncwu,1130) float(iEquiv(11+jj,1,i)) / 1000.0 ! terza stampa
               k2  = iEquiv(11+jj,2,i)
               write(ncwu,1151)aLab(k2)                     ! quarta stampa
               k2  = iEquiv(n,3,i)
               write(ncwu,1190)iparch(k2)                   ! quinta stampa
            enddo
        endif
c--fine stampa atomi
      enddo
c
c--stampa gruppi
      if(CodeGroup.ne.0) then
        do i=1,NumGroup
           j=nats+i
c--1a raw
           write(ncwu,1110)aLabGroup(i),TypeGroup(i),         ! prima stampa
     1     NserialGroup(i),XGroup(1:3,i), BisoGroup(i),BijGroup(1:2,i)
           write(ncwu,1075) nParBl(1:6,j)                     ! seconda stampa
           write(ncwu,1130) float(iEquiv(1:6,1,j)) / 1000.0   ! terza stampa
           do n=1,6
              k2  = iEquiv(n,2,j)
              if(k2.gt.0) then 
              if(k2.le.nats) then
                 LabCurrent(n)=aLab(k2)
              else
                 LabCurrent(n)=aLabGroup(k2-nats)
              endif
              endif
           enddo   
           write(ncwu,1151)LabCurrent(1:6)                    ! quarta stampa
           do n=1,6
              k2  = iEquiv(n,3,j)
              if(k2.le.0) then
                 ParCurrent(n)=' '
              else
                 ParCurrent(n)=iparch(k2)
              endif
           enddo   
           write(ncwu,1190)ParCurrent(1:6)                    ! quinta stampa
c--2a raw
           write(ncwu,1110)aLabGroup(i),TypeGroup(i),         ! prima stampa
     1     NserialGroup(i),BijGroup(3:6,i),OccGroup(i)
           write(ncwu,1075) nParBl(7:11,j)                    ! seconda stampa
           write(ncwu,1130) float(iEquiv(7:11,1,j)) / 1000.0 ! terza stampa
           do n=7,11
              k2  = iEquiv(n,2,j)
              if(k2.gt.0) then 
              if(k2.le.nats) then
                 LabCurrent(n)=aLab(k2)
              else
                 LabCurrent(n)=aLabGroup(k2-nats)
              endif
              endif
           enddo   
           write(ncwu,1151)LabCurrent(7:11)                    ! quarta stampa
           do n=7,11
              k2  = iEquiv(n,3,j)
              if(k2.le.0) then
                 ParCurrent(n)=' '
              else
                 ParCurrent(n)=iparch(k2)
              endif
           enddo   
           write(ncwu,1190)ParCurrent(7:11)                    ! quinta stampa
!--3a raw   (angoli euleriani)
           write(ncwu,1110)aLabGroup(i),TypeGroup(i),         ! prima stampa
     1     NserialGroup(i),ThetaGroup(i),PhiGroup(i),PsiGroup(i)
           write(ncwu,1075) nParBl(12:14,j)                    ! seconda stampa
           write(ncwu,1130) float(iEquiv(12:14,1,j)) / 1000.0  ! terza stampa
           LabCurrent(1:15)=' '
           write(ncwu,1151)LabCurrent(1:3)                     ! quarta stampa
           write(ncwu,1190)LabCurrent(1:3)                     ! quinta stampa
c--fine stampa gruppi
         enddo
      endif
      return
      end
c
c---------------------------------------------
code for calcderangMNQD                     *** Gruppo ***
      subroutine calcderangMNQD(i)
c--calcola derivate della matrice di rotazione	del gruppo
c
      USE General
      USE LsqModule
      USE LsqStuff
      USE LsqStuff12
      USE LsqGroupsStuff
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty  
      dimension xx1(3), xxx(3,3)                          
c
      thetas=ThetaGroup(i)*dtr
      phis  =PhiGroup(i)  *dtr
      psis  =PsiGroup(i)  *dtr
c--derivata per theta
      ThetaDer(1,1,i)= sin(thetas)*sin(phis)*sin(psis)
      ThetaDer(1,2,i)=-sin(thetas)*cos(phis)*sin(psis)
      ThetaDer(1,3,i)= cos(thetas)*sin(psis)
      ThetaDer(2,1,i)= sin(thetas)*sin(phis)*cos(psis)
      ThetaDer(2,2,i)=-sin(thetas)*cos(phis)*cos(psis)
      ThetaDer(2,3,i)= cos(thetas)*cos(psis)
      ThetaDer(3,1,i)= cos(thetas)*sin(phis)
      ThetaDer(3,2,i)=-cos(thetas)*cos(phis)
      ThetaDer(3,3,i)=-sin(thetas)
c--derivata per phi
      PhiDer(1,1,i)=-cos(psis)*sin(phis)
     1			    -cos(thetas)*cos(phis)*sin(psis)
      PhiDer(1,2,i)= cos(phis)*cos(psis)
     1			    -cos(thetas)*sin(phis)*sin(psis)
      PhiDer(1,3,i)= 0.0
      PhiDer(2,1,i)= sin(psis)*sin(phis)
     1			    -cos(thetas)*cos(phis)*cos(psis)
      PhiDer(2,2,i)=-sin(psis)*cos(phis)
     1			    -cos(thetas)*sin(phis)*cos(psis)
      PhiDer(2,3,i)= 0.0
      PhiDer(3,1,i)= sin(thetas)*cos(phis)
c      PhiDer(3,2,i)=-sin(thetas)*sin(phis)
      PhiDer(3,2,i)=sin(thetas)*sin(phis)
      PhiDer(3,3,i)= 0.0
c--derivata per psi
      PsiDer(1,1,i)=-sin(psis)*cos(phis)
     1			    -cos(thetas)*sin(phis)*cos(psis)
      PsiDer(1,2,i)=-sin(phis)*sin(psis)
     1			    +cos(thetas)*cos(phis)*cos(psis)
      PsiDer(1,3,i)= sin(thetas)*cos(psis)
      PsiDer(2,1,i)=-cos(psis)*cos(phis)
     1			    +cos(thetas)*sin(phis)*sin(psis)
      PsiDer(2,2,i)=-cos(psis)*sin(phis)
     1			    -cos(thetas)*cos(phis)*sin(psis)
      PsiDer(2,3,i)=-sin(thetas)*sin(psis)
      PsiDer(3,1,i)= 0.0
      PsiDer(3,2,i)= 0.0
      PsiDer(3,3,i)= 0.0
c--calcola matrice di orientazione
      call calcorien(thetas,phis,psis,xxx) 
      GGroup(1:3,1:3,i)=xxx(1:3,1:3)
      return
      end
c
code for calcorien
      subroutine calcorien(theta,phi,psi,ori)
c--calcola la matrice di rotazione	dei gruppi
c
      USE General
!
      dimension ori(3,3)
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty       
c
      ori(1,1)=cos(psi)*cos(phi)-cos(theta)*sin(phi)*sin(psi)
      ori(1,2)=cos(psi)*sin(phi)+cos(theta)*cos(phi)*sin(psi)
      ori(1,3)=sin(theta)*sin(psi)
      ori(2,1)=-sin(psi)*cos(phi)-cos(theta)*sin(phi)*cos(psi)
      ori(2,2)=-sin(psi)*sin(phi)+cos(theta)*cos(phi)*cos(psi)
      ori(2,3)=cos(psi)*sin(theta)
      ori(3,1)=sin(theta)*sin(phi)
      ori(3,2)=-sin(theta)*cos(phi)
      ori(3,3)=cos(theta)
      return
      end
!-----------------------------------------------------------------------
c
code for calc55MNQD                               *** Gruppo ***
      subroutine calc55MNQD(kj,kb,jtw,ideriv,igrcode,nacode,apd,bpd,
     * xyzapd,xyzbpd)
c--calcolo coordinate e derivate relative al gruppo
!  kj no. del riflesso (usato per stampe di test)
!  kb no. dell'atomo corrente
c  ideriv = 0 non calcolo derivate
c           1 calcolo derivate
c
      USE General
      USE Symmetry
      USE Molcom
      USE Atomi
      USE LsqGroupsStuff
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,           
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz                  
c
      dimension xyzapd(2,3),xyzbpd(2,3),xx4(3)
      dimension apd(2,19),bpd(2,19)
      dimension xmatang(3,3),xorto(3)
      dimension xx1(3),xx3(3),xx2(3),xmatangR(3,3),xmatr(3,3) 
      character*16 vetch
c                                                                             
c      itest=0
c      if(ideriv.eq.0)kj=1
c      if(kj.eq.1) itest=1
c      if(itest.eq.1) then
c         call shift(aLab(kb),lna)
c         write(ncwu,'(i5,2h) ,a)')kb,aLab(kb)(1:lna)
c         write(ncwu,*)'igrcode,nacode:',igrcode,nacode
c      endif
c--recupera coordinate locali ortogonali
      xorto(1:3)=XOrtoGroup(1:3,nacode,igrcode)
c      if(itest.eq.1) then
c         write(ncwu,*) ' Coordinate ortogonali gruppo'
c         write(ncwu,'(3f10.4)')xorto
c      endif 
c      itest=1
c--controllo se devo calcolare le derivate per gli angoli theta phi psi
      if(ideriv.eq.1) then
c--recupera matrice derivata rispetto theta
         do i=1,3
            do j=1,3
               xmatang(i,j)=ThetaDer(i,j,igrcode)
            enddo
         enddo
c         if(kj.eq.1) then
c      write(ncwu,'(a,2i5,/,3(3f10.3,/))')' th',igrcode,nacode,xmatang
c         endif
c         if(kj.eq.1) write(ncwu,'(a,2x,3f10.5)')' xorto',xorto
              call moltv(xmatang,xorto,xx3)
c         if(kj.eq.1) write(ncwu,'(a,2x,3f10.5)')' xx3  ',xx3
              call moltv(rmi,xx3,xx2)
c         if(kj.eq.1) write(ncwu,'(a,2x,3f10.5)')' xx2  ',xx2
c      if(kj.eq.1) write(ncwu,'(a,2x,3f10.5)')' xyzapd',
c     * (xyzapd(jtw,i),i=1,3)
              xx4(1:3)=xyzapd(jtw,1:3)
              call ospr(xx2,xx4,sumd)
c        if(kj.eq.1) write(ncwu,'(a,2x,3f10.5)')'sumd ',sumd,apd(jtw,12)
              apd(jtw,12)=apd(jtw,12)+sumd
              if(icent.eq.0)then         
c        if(kj.eq.1) write(ncwu,'(a,2x,3f10.5)')'xyzbpd',
c     *  (xyzbpd(jtw,i),i=1,3)
                 xx4(1:3)=xyzbpd(jtw,1:3)
                 call ospr(xx2,xx4,sumd)
c        if(kj.eq.1) write(ncwu,'(a,2x,3f10.5)')'sumd ',sumd,bpd(jtw,12)
                 bpd(jtw,12)=bpd(jtw,12)+sumd
              endif
c--recupera matrice derivata rispetto phi
         do i=1,3
            do j=1,3
               xmatang(i,j)=PhiDer(i,j,igrcode)
            enddo
         enddo
c         if(kj.eq.1) then
c	   write(ncwu,'(a,2i5,/,3(3f10.3,/))')' ph',igrcode,nacode,xmatang
c         endif
c       if(kj.eq.1) write(ncwu,'(a,2x,3f10.5)')' xorto',xorto
              call moltv(xmatang,xorto,xx3)
c       if(kj.eq.1) write(ncwu,'(a,2x,3f10.5)')' xx3  ',xx3
              call moltv(rmi,xx3,xx2)
c       if(kj.eq.1) write(ncwu,'(a,2x,3f10.5)')' xx2  ',xx2
c       if(kj.eq.1) write(ncwu,'(a,2x,3f10.5)')' xyzapd',
c     * (xyzapd(jtw,i),i=1,3)
              xx4(1:3)=xyzapd(jtw,1:3)
              call ospr(xx2,xx4,sumd)
c       if(kj.eq.1) write(ncwu,'(a,2x,3f10.5)')' sumd ',sumd,apd(jtw,13)
              apd(jtw,13)=apd(jtw,13)+sumd
              if(icent.eq.0) then
c        if(kj.eq.1) write(ncwu,'(a,2x,3f10.5)')' xyzbpd',
c     *  (xyzbpd(jtw,i),i=1,3)
                 xx4(1:3)=xyzbpd(jtw,1:3)
                 call ospr(xx2,xx4,sumd)
c       if(kj.eq.1) write(ncwu,'(a,2x,3f10.5)')'sumd ',sumd,bpd(jtw,13)
                 bpd(jtw,13)=bpd(jtw,13)+sumd
              endif
c--recupera matrice derivata rispetto psi
         do i=1,3
            do j=1,3
               xmatang(i,j)=PsiDer(i,j,igrcode)
            enddo
         enddo
c         if(kj.eq.1) then
c  	   write(ncwu,'(a,2i5,/,3(3f10.3,/))')' ps',igrcode,nacode,xmatang
c         endif
c       if(kj.eq.1) write(ncwu,'(a,2x,3f10.5)')' xorto',xorto
              call moltv(xmatang,xorto,xx3)
c       if(kj.eq.1) write(ncwu,'(a,2x,3f10.5)')' xx3  ',xx3
              call moltv(rmi,xx3,xx2)
c       if(kj.eq.1) write(ncwu,'(a,2x,3f10.5)')' xx2  ',xx2
c       if(kj.eq.1) write(ncwu,'(a,2x,3f10.5)')' xyzapd',
c     *  (xyzapd(jtw,i),i=1,3)
              xx4(1:3)=xyzapd(jtw,1:3)
              call ospr(xx2,xx4,sumd)
c       if(kj.eq.1) write(ncwu,'(a,2x,3f10.5)')' sumd ',sumd,apd(jtw,14)
              apd(jtw,14)=apd(jtw,14)+sumd
              if(icent.eq.0) then
c        if(kj.eq.1) write(ncwu,'(a,2x,3f10.5)')' xyzbpd',
c     *   (xyzbpd(jtw,i),i=1,3)
                 xx4(1:3)=xyzbpd(jtw,1:3)
                 call ospr(xx2,xx4,sumd)
c       if(kj.eq.1) write(ncwu,'(a,2x,3f10.5)')' sumd ',sumd,bpd(jtw,14)
                 bpd(jtw,14)=bpd(jtw,14)+sumd
              endif
c--fine calcolo derivate per atomo di gruppo
      else
c--devo moltiplicare per G !!!!!!!!!!!!!!!!!!!!!!!  
c  la matrice G su store e' conservata trasposta!!            
         do j=1,3
            do i=1,3
               xmatangR(i,j)=GGroup(i,j,igrcode)
            enddo
         enddo
c--applico la matrice rotazione per i calcoli successivi
c       if(kj.eq.1) then
c	  write(ncwu,'(a,2i5,/,3(3f10.3,/))')' rmi',igrcode,nacode,rmi
c       endif
c       if(kj.eq.1) then
c	 write(ncwu,'(a,2i5,/,3(3f10.3,/))')' xmatangR',igrcode,nacode,xmatangR
c       endif
              call prodm(rmi,xmatangR,xmatang)
c       if(kj.eq.1) then
c	  write(ncwu,'(a,2i5,/,3(3f10.3,/))')' G ',igrcode,nacode,xmatang
c       endif
         call moltv(xmatang,xorto,xx3)
c         if(itest.eq.1) then
c            write(ncwu,*) ' Coordinate cristal. nel gruppo'
c            write(ncwu,'(3f10.4)')xx3
c         endif 
c--aggiorno coordinate posizionali dell'atomo                   
c         if(itest.eq.1) then
c            write(ncwu,*) ' Coordinate cristal. nella cella (prima)'
c            write(ncwu,'(3f10.4)')xyzs(1:3,kb)
c         endif 
         xyzs(1:3,kb)=xx3(1:3)+XGroup(1:3,igrcode)
c         if(itest.eq.1) then
c            write(ncwu,*) ' Coordinate cristal. nella cella (dopo)'
c            write(ncwu,'(3f10.4)')xyzs(1:3,kb)
c         endif 
      endif
      return
      end
c
code for MnqdPrtder
      subroutine MnqdPrtder
c--print for testing of derivatives
c
      USE General
      USE Atomi
      USE LsqModule
      USE LsqStuff
      USE LsqStuff22
      USE LsqStuff22Abs
      USE LsqGroupsStuff
!
      character*16 namch,nam,namch1,nam1
      character*8 iiscal(5)
      data iiscal/'scale','ob(iso)','extincti','polarity',
     *            'twinning'/
c--
      write(lo,2176) NumDerParz
2176  format(//,' absolute address of the derivative',//,
     1 ' parameter',15x,'block',10x,'address',6x,'(step=',i2,')',/)
      namch=' '
      do n=1,NumOverall
         m=nats+NumGroup+n  
         if(OverallNumBlock(n).ne.0)
     1	 write(lo,2178)iiscal(n),namch,OverallNumBlock(n),
     2	                 nAddrDer(1,m)
      enddo
      do n=1,nats+NumGroup
         if(Jaffina(n).gt.0) then
!           imix=iSite(n)  !  non so se serve
            do i=1,nPar15        
               j=nParBl(i,n)   ! no del blocco a cui appartiene il parametro
               if(j.gt.0) then
                  call MnqdLab(n,i,namch,nam)
                  write(lo,2178) namch,nam,j,nAddrDer(i,n)
2178	            format(1x,a8,2x,a8,i10,i15,e15.5)
               endif
            enddo
         endif
      enddo
c--loo sul blocco
      write(lo,'(/,a,i3)')' Numero di blocchi:',NumBlockTot
      do j=1,NumBlockTot
         do jw=1,BlAddr(j)
! n.ord atomo per ciascun blocco, posizione all'interno blocco
               n=ParAddr(j,jw,1)
! n.ord parametro per ciascun blocco, posizione all'interno blocco
               i=ParAddr(j,jw,2)
               call MnqdLab(n,i,namch,nam)
               write(lo,2180) j,jw,namch,nam
2180           format(2i10,5x,a8,2x,a8)
         enddo 
         write(lo,'(1h )')
         do m=1,NumOggettiMax
            if(ckEquiv(m).ne.0) then
               do i=1,nPar15
                  j1=nParBl(i,m)       ! no del blocco a cui appartiene il parametro
                  if(j1.eq.j) then     ! il parametro appartiene al blocco corrente
c--controllo se il parametro e' equiv 
                     if(iEquiv(i,2,m).ne.0) then
                        call MnqdLab(m,i,namch,nam)
                        n=iEquiv(i,2,m)   ! no. d'ord atomo
                        nn=iEquiv(i,3,m)  ! no. d'ord parametro
                        call MnqdLab(n,nn,namch1,nam1)
                        write(lo,2182) namch,nam,namch1,nam1
2182                    format(1x,a8,2x,a8,2x,'=',2x,a8,2x,a8)
                     endif
                  endif
               enddo
            endif   
         enddo
      enddo                 
      return
      end
c
code for MnqdLab
      subroutine MnqdLab(n,nn,namch,nam)
c--find the correct label
c
      USE General
      USE Atomi
      USE LsqModule
      USE LsqStuff
      USE LsqStuff22
      USE LsqStuff22Abs
      USE LsqGroupsStuff
!
      character*16 namch,nam
      character*8 iiscal(5)
      data iiscal/'scale','ob(iso)','extincti','polarity',
     *            'twinning'/
c--
      icoName=0
      if(n.le.nats) then
         if(nGrCode(n).gt.0) icoName=1
         namch=aLab(n)
      else if(n.le.(nats+NumGroup))then
         icoName=1
         n1=n-nats
         namch=aLabGroup(n1)
      else if(n.gt.(nats+NumGroup))then
         n1=n-(nats+NumGroup)
         namch=iiscal(n1)
         nam=' '
      endif      
      if(nn.gt.0) call MnqdPar(nn,nam,icoName)
      return
      end
c
code for MnqdPar                                                            
      subroutine MnqdPar(npar,namcur,icod)
c--set the name of the parameter
c  icod=0 atomo
c	  1 gruppo
c       2 rotamero
!
      character*(*) namcur
      character*8 namch(24)
      data namch/'x','y','z','b(iso)','b(11)','b(12)','b(13)','b(22)', !8
     *           'b(23)','b(33)','occ','occ1','occ2','occ3','occ4',    !15
     *           'theta','phi','psi','alpha','alpha1','alpha2',        !21
     *           'alpha3','alpha4','tau'/                              !24
c--
      select case (npar)
        case (1:11)
          namcur=namch(npar)
        case (12)
          if(icod.eq.0) then
             namcur=namch(12)
          else if(icod.eq.1) then
             namcur=namch(16)
          else if(icod.eq.2) then
             namcur=namch(24)
          endif
        case (13)
          if(icod.eq.0) then
             namcur=namch(13)
          else if(icod.eq.1) then
             namcur=namch(17)
          endif
        case (14)
          if(icod.eq.0) then
             namcur=namch(14)
          else if(icod.eq.1) then
             namcur=namch(18)
          endif
        case (15)
          if(icod.eq.0) then
             namcur=namch(15)
          else if(icod.eq.1) then
             namcur=namch(19)
          endif
        case (16:19)
             namcur=namch(npar+4)
      end select
      return
      end                                                               
c
code for MnqdAccum                                                          
      subroutine MnqdAccum(wdf)  
c--accumulation of the least squares normal equations
c                                                                       
      USE LsqStuff
      USE LsqStuff22
      USE LsqStuff22Abs
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      real*8 da
c
      da=dble(wdf)
      do j=1,NumBlockTot 
         jf=BlAddr(j)
         ju=1
         do jw=1,jf
            do jv=jw,jf
              EquaNorm(ju,j)=EquaNorm(ju,j)+DeriTot(j,jw)*DeriTot(j,jv)
              ju=ju+1
            enddo
            VettNorm(jw,j)=VettNorm(jw,j)+DeriTot(j,jw)*da
         enddo
      enddo      
      call XTimeINParz(5)
      call XTimeParz(5,0)
      return
      end 
c------------------------------------------------------------- 
c   
code for Mnqd_solve   
      subroutine Mnqd_solve(Berr_vector,ierS)
c--solution of normal equations
c  inn = dummy argument
c
      USE General
      USE Atomi
      USE Molcom
      USE LsqModule
      USE LsqStuff22Abs
      USE LsqGroupsStuff
      USE LsqStuff
      USE LsqStuff22
!      
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
!--
      character*16 name1Mnqd(2),name2Mnqd(2)      
c--                                                                     
      dimension xyzapd(2,3),xyzbpd(2,3),xmatang(3,3),xorto(3)
      dimension xx1(3),xx3(3),xx2(3),xmatangR(3,3)
      dimension apd(2,19),bpd(2,19)
      dimension nb(19),wfw(19),iadr(19)
c
      dimension Berr_vector(*)
c
      dimension ori(3,3)
      dimension bc(19)
      character*8 singat(5)
      character*8 modiat(5)
      character*2 jjhh
      character(len=30)  :: alfabeto
      data alfabeto/'abcdefghijklmnopqrstuvwxyz'/
      data jjhh/'h '/
c
      read(jjhh,'(a2)')jhh
c--
      ierS=0
      nsin=0                                            
      if(nCycleCurr.eq.1) BLimit=9999.0
      if(iverb.gt.1) then
        write(ncwu,900)
 900    format(/,' Form the new coordinate list',5x,
     2  'version	1a',5x,'created	01/03/2010')
        write(ncwu,2005)
2005    format(80(1h-),/,2x,'blk',5x,'num.par',2x,'num.par.b',1x,
     2  'name',7x,'par',6x,'shift.cal.',4x,'e.s.d.',4x,'ratio',/,
     3  80(1h-),/)
      endif
      if(nreflX+nres.gt.NParTot)then
        e=sumWDiff/(nreflX+nres-NParTot)
      else
        e=0.0
      endif
      if(NoRefl.ne.0) e=1.
      SumWMnqd = e
c      write(ncwu,*) 'e,d,n6d,NParTot',e,d,n6d,NParTot
c---chek if the dummy overall temperature factor has been refined
      if(OverallNumBlock(2).gt.0) then
         kd=OverallNumBlock(2)
         bt_star=VettNorm(2,kd)/EquaNorm(3,kd)
      endif
!------------------------------------------------------------      
!--stampa di controllo
!------------------------------------------------------------
      if(istat2.gt.1) then
         if(nCycleCurr.eq.1) then
            jop = jopen(jgrap,'dati_c_MNQD.inp',0,1,ier)
            if (jop < 0) then
                ierS = -1
                return
             endif
         endif
         do kd=1,NumBlockTot
            jf=BlAddr(kd)
            lmatx=jf*(jf+1)/2
            write(jgrap,2021)nCycleCurr, kd,jf,lmatx
2021        format(' Cycle no. ',i5,
     2        ' ; block no.',i3,' ; matrix order =',
     1        i4,' ; triangular matrix dimension =',i10,/)
            write(jgrap,'(a)') 'upper triangular matrix'
            ju=1
            do jw=1,jf
               m=ParAddr(kd,jw,1)
               k=ParAddr(kd,jw,2)
               call MnqdNparam(m,k,name1Mnqd)
               do jv=jw,jf
                  m=ParAddr(kd,jv,1)
                  k=ParAddr(kd,jv,2)
                  call MnqdNparam(m,k,name2Mnqd)
                  write(jgrap,2023)EquaNorm(ju,kd),name1Mnqd(1)(1:8),
     *            name1Mnqd(2)(1:8),name2Mnqd(1)(1:8),name2Mnqd(2)(1:8)
2023              format(e15.4,2x,a,2x,a,' <--> ',a,2x,a)
                  ju=ju+1
               enddo
               write(jgrap,'(a,i10)') 'fine riga',jw
            enddo  
            write(jgrap,'(a)') 'column vector'
            do jw=1,jf
               m=ParAddr(kd,jw,1)
               k=ParAddr(kd,jw,2)
               call MnqdNparam(m,k,name1Mnqd)
               write(jgrap,2023)VettNorm(jw,kd),name1Mnqd(1)(1:8),
     *         name1Mnqd(2)(1:8)
            enddo
         enddo     
      endif
!------------------------------------------------------------   
!--fine stampa di controllo   
!------------------------------------------------------------      
!--begin the inversion - a block at a time
!------------------------------------------------------------   
      SumRapQua=0.0
      SumRapAbs=0.0
      RapAbsMin=9999.0
      RapAbsMax=-9999.0
      npi=1   
      do kd=1,NumBlockTot
         jf=BlAddr(kd)
c--invert the current block                                             
         if(NoRefl.eq.0) then
             call CholMnqd(kd,jf,EquaNorm(1,kd),BuffNorm(1,kd),ier)
             if(ier.ne.0) goto 3010
             call xsolvMnqd(jf,EquaNorm(1,kd),VettNorm(1,kd),
     *                      BuffNorm(1,kd))
c            
             if(istat2.gt.1) then
                write(jgrap,'(a)') 'results vector'
                do jw=1,jf
                   m=ParAddr(kd,jw,1)
                   k=ParAddr(kd,jw,2)
                   call MnqdNparam(m,k,name1Mnqd)
                   write(jgrap,2023)BuffNorm(jw,kd),name1Mnqd(1)(1:8),
     *                  name1Mnqd(2)(1:8)
                enddo
             endif  
         else
c--no reflections
             iii=jf-1
             iv=1
             do jw=1,jf
                if(EquaNorm(iv,kd).gt.0.00001) then
                   BuffNorm(jw,kd)=VettNorm(jw,kd)/EquaNorm(iv,kd)
                   EquaNorm(iv,kd)=1.0/EquaNorm(iv,kd)
                else
                   BuffNorm(jw,kd)=0.0
                endif
                iv=iv+iii+1
                iii=iii-1
             enddo
         endif
         iii=jf
         iv=1
         do jw=1,jf
            m=ParAddr(kd,jw,1)
            k=ParAddr(kd,jw,2)
            call MnqdNparam(m,k,name1Mnqd)
            shiftM=BuffNorm(jw,kd)            ! shifts
            aa=EquaNorm(iv,kd)
            SdMndq=sqrt(aa*SumWMnqd)          ! standard deviations
            if(NoTest.eq.1) then
               write(ncwu,2026) name1Mnqd(1)(1:8),name1Mnqd(2)(1:8),
     *         shiftM,SdMndq
2026           format(1x,a,1x,a,2f10.5)
            endif
            RapMnqd=0.0
            if(SdMndq.gt.0.0000001) RapMnqd=shiftM/SdMndq
            if(iverb.gt.1) then
               write(ncwu,2091) kd,npi,jw,name1Mnqd(1)(1:8),
     *         name1Mnqd(2)(1:8),shiftM,SdMndq,RapMnqd
2091           format(1x,i3,6x,i4,6x,i4,5x,a,2x,a,3f11.5)
            endif
            SumRapQua=SumRapQua+RapMnqd*RapMnqd
            RapAbs=abs(RapMnqd)
            SumRapAbs=SumRapAbs+RapAbs
            RapAbsMin=amin1(RapAbsMin,RapAbs)
            RapAbsMax=amax1(RapAbsMax,RapAbs)
            npi=npi+1
            iv=iv+iii
            iii=iii-1
         enddo  
c--end inversion of blocks
      enddo
      if(istat2.gt.1) then
        close(jgrap)
        istat2=0
      endif
!_refine_ls_shift/su_max                  
!_refine_ls_shift/su_mean                 
!--   xff=float(n6d)/float(NParTot)
      SumRapAbs=SumRapAbs/NParTot
      shiftesd(1)=RapAbsMax
      shiftesd(2)=SumRapAbs
      slsq=sqrt(SumWMnqd)
      if(NoRefl.eq.0) then
        if(iverb.ge.0) then
           write(ncwu,3005) RapAbsMin,RapAbsMax,SumRapAbs
3005       format(/,' Minimum (shift/e.s.d.) =',f7.2,/,
     2              ' Maximum (shift/e.s.d.) =',f7.2,/,
     3              ' Mean    (shift/e.s.d.) =',f7.2)
        write(ncwu,3006) SumRapQua
3006       format(' Sum of the squares of the (shift/e.s.d.) =',f10.2)
        endif
      endif
c      
c--move the results into the proper positions
      Overall_dev(:)  =0.0
      Overall_shift(:)=0.0
      shiftMnqd(:,:)=0.0
      xyzs_dev(:,:)  = 0.0
      bfac_dev(:)    = 0.0 
      bij_dev(:,:) = 0.0 
      occ_dev(:)= 0.0 
      occX_dev(:,:)= 0.0 
      do kd=1,NumBlockTot
         jf=BlAddr(kd)
         iii=jf
         iv=1
         do jw=1,jf
            shiftM=BuffNorm(jw,kd)         ! shifts
            aa=EquaNorm(iv,kd)
            SdMndq=sqrt(aa*SumWMnqd)       ! standard deviations
            m=ParAddr(kd,jw,1)
            k=ParAddr(kd,jw,2)
            if(m.gt.nats) then 
               if(m.gt.nats+NumGroup) then
                  m5o=m-(nats+NumGroup)   ! overall parameter
                  Overall_dev(m5o)  =SdMndq
                  Overall_shift(m5o)=shiftM
               else
                  m55=m-nats              ! group
                  shiftMnqdGroup(k,m55)=shiftM
                  if(k.le.3) then 
                     SXGroup(k,m55)     = SdMndq
                  else if(k.eq.4) then
                     SBisoGroup(m55)    = SdMndq 
                  else if(k.le.10) then
                     SBijGroup(k-4,m55) = SdMndq 
                  else if(k.eq.11) then
                     SOccGroup(m55)     = SdMndq 
                  else if(k.eq.12) then
                     SThetaGroup(m55)   = SdMndq * rtd
                  else if(k.eq.13) then
                     SPhiGroup(m55)     = SdMndq * rtd 
                  else if(k.eq.14) then
                     SPsiGroup(m55)     = SdMndq * rtd 
                  endif 
               endif      
            else  
               m5=m                        ! atom
               shiftMnqd(k,m5)=shiftM
               if(k.le.3) then 
                  xyzs_dev(k,m5)  = SdMndq
               else if(k.eq.4) then
                  bfac_dev(m5)    = SdMndq 
               else if(k.le.10) then
                  bij_dev(k-4,m5) = SdMndq 
               else if(k.eq.11) then
                  occ_dev(m5)= SdMndq 
               else if(k.le.15) then
                  occX_dev(k-11,m5)= SdMndq 
               endif       
            endif
            iv=iv+iii
            iii=iii-1
         enddo
      enddo       
c
c--check if equivalenced parameters are present
! CodeEquiv, CodeWeight, CodeGroup 
      if(CodeEquiv.ne.0.or.CodeGroup.ne.0) then
!-------------------------------------------------------------------
      do n=1,nats
         if(ckEquiv(n).ne.0) then  ! l'atomo ha qualche parametro in equiv
            do i=1,nPar15
               j=nParBl(i,n)       ! no del blocco a cui appartiene il parametro
               if(j.gt.0) then     ! il parametro va affinato
c--controllo se il parametro e' equiv 
                  if(iEquiv(i,2,n).ne.0) then
                     m=iEquiv(i,2,n)   ! no. d'ord atomo
                     k=iEquiv(i,3,n)  ! no. d'ord parametro	
                     if(m.gt.nats) then
                        m55=m-nats              ! group
                        shiftMnqd(i,n)=shiftMnqdGroup(k,m55)
                        if(k.le.3) then 
                           xyzs_dev(i,n)   = 0.0
                         if(noAtom(n).gt.1)xyzs_dev(i,n)= SXGroup(k,m55)
                        else if(k.eq.4) then
                           bfac_dev(n)    = 0.0   
                          if(noAtom(n).gt.1)bfac_dev(n)= SBisoGroup(m55)
                        else if(k.le.10) then
                           bij_dev(i-4,n) = 0.0 
                           if(noAtom(n).gt.1)
     *                               bij_dev(i-4,n)=SBijGroup(k-4,m55) 
                        else if(k.eq.11) then
                           occ_dev(n)= 0.0 
                           if(noAtom(n).gt.1)occ_dev(n)= SOccGroup(m55) 
                        endif 
                     else  
                        m5=m                        ! atom
                        shiftMnqd(i,n)=shiftMnqd(k,m5)
                        if(k.le.3) then 
                           xyzs_dev(i,n)  = 0.0
                          if(noAtom(n).gt.1)xyzs_dev(i,n)=xyzs_dev(k,m5)
                        else if(k.eq.4) then
                           bfac_dev(n)    = 0.0  
                           if(noAtom(n).gt.1)bfac_dev(n)= bfac_dev(m5)  
                        else if(k.le.10) then
                           bij_dev(i-4,n) =  0.0
                           if(noAtom(n).gt.1)
     *                               bij_dev(i-4,n)= bij_dev(k-4,m5) 
                        else if(k.eq.11) then
                           occ_dev(n)= 0.0 
                           if(noAtom(n).gt.1)occ_dev(n)= occ_dev(m5) 
                        else if(k.le.15) then
                           occX_dev(i-11,n)= 0.0
                           if(noAtom(n).gt.1)
     *                               occX_dev(i-11,n)= occX_dev(k-11,m5)
                        endif       
                     endif
                  endif
               endif
            enddo
         endif   
      enddo
      endif
c      call PrintAtoms
c-------------------------------------------------------------
c--apply and print the results
c-------------------------------------------------------------
c  apply to overall parameters
c--set up the constants involving the dummy temperature correction
      b=0.0
      if(OverallNumBlock(2).gt.0) b = Overall_shift(2)-bt_star
      Overall_shift(:)=Overall_shift(:) * Dampi 
      if(OverallNumBlock(1).gt.0)FcScale = FcScale + Overall_shift(1)
      if(OverallNumBlock(2).gt.0)FcBiso  = FcBiso  + Overall_shift(2)
      if(OverallNumBlock(3).gt.0)FcExtin = FcExtin + Overall_shift(3)
      if(OverallNumBlock(4).gt.0)FcPola  = FcPola  + Overall_shift(4)
      if(OverallNumBlock(5).gt.0) then
         FcTwin  = FcTwin  + Overall_shift(5)
         if(FcTwin.ge.1.0) FcTwin = 1.0
         if(FcTwin.le.0.0) FcTwin = 0.0
      endif   
c--check if polarity parameter was refined
      aflack=1.0
      if (jCodeFlack.eq.1) then
          if (FcPola.gt.0.5) aflack=-1.0
      endif
c--check if twinning parameter was refined
      atwin=1.0
      if (jCodeTwin.eq.1) then
          if (FcTwin.gt.0.5) atwin=-1.0
      endif
      afltw=aflack*atwin
      if(iverb.gt.0) then
         write(ncwu,3032)
3032     format(/,5x,10h Format : ,5x,14hnew coordinate,/,
     1    20x,13happlied shift,/,
     2    20x,17hcalculated e.s.d.,/)
c--print the results for the overall parameters
          write(ncwu,1020) NumOverall
 1020     format(i3,22h  Overall parameter(s),/)
          write(ncwu,1030)
 1030     format(3x,' Scale',4x,' OB(iso)',
     1           1x,' Extinction',1x,'Polarity',2x,'Twinning',/)
          write(ncwu,1040)FcScale, FcBiso, FcExtin, FcPola, FcTwin
 1040     format(1x,10f10.5)
          write(ncwu,1040)Overall_shift
          write(ncwu,1040)Overall_dev
          if(OverallNumBlock(2).gt.0) write(ncwu,1045)b
1045      format(/,' Correction to isotropic temperature factor =',
     2       f9.5,/)
          write(ncwu,1060)
1060      format(/,1x,5h name,2x,5h type,1x,7h serial,4x,2h x,
     1        8x,2h y,8x,2h z,
     2        6x,6hb(iso),4x,6h b(11),4x,6h b(12),
     3        /,23x,6h b(13), 4x,6h b(22),
     3        4x,6h b(23),4x,6h b(33),5x,4h occ)
          if(CodeGroup.gt.0) then
             write(ncwu,1061)
1061         format(23x,' theta',4x,'  phi ',4x,'  psi ')
             write(ncwu,1063)
1063         format(23x,' alpha',4x,' alph1',4x,' alph2',4x,' alph3',
     *        4x,' alph4')
          endif
          write(ncwu,'(1x)')
      endif
c      
c--apply results to atoms  
      do ka=1,nats
         if(Jaffina(ka).gt.0) then     ! se = 0, l'atomo e' fisso       
            bc(:)=0.0
            if(OverallNumBlock(2).gt.0) then
               if(IsoAniso(ka).eq.2) then
                  bc(4)=b
               else
                  do i=1,6
                     bc(i+4)=b*BisoToBij(i)
                  enddo
               endif
            endif   
            call saplyMnqd(ka,bc,afltw,iera)
            if(iera.ne.0) ierS=-1
         endif
      enddo  
c      call PrintAtoms
c      
c--controllo se gruppi sono presenti
      if(CodeGroup.gt.0) then
         iniz=1
         do ka=1,NumGroup
            if(Jaffina(ka+nats).gt.0) then     ! se = 0, l'atomo e' fisso       
               bc(:)=0.0
               if(OverallNumBlock(2).gt.0) then
c--set up the constants involving the dummy temperature correction
                  if(IsoAnisoGroup(ka).eq.2) then
                     bc(4)=b
                  else
                     do i=1,6
                        bc(i+4)=b*BisoToBij(i)
                     enddo
                  endif
               endif
               call saplygrMnqd(ka,bc,afltw,ierS)
c--controllo fattore termico      
               if(IsoAnisoGroup(ka).eq.1) then
                  BisoGroup(ka)=0.0
                  do i=1,6
                     BisoGroup(ka)  = BisoGroup(ka) + 
     *                                BijGroup(i,ka)*BijToBiso(i)
                  enddo
               endif
c--fine aggiornamento dati del *** Gruppo ***
c--calcola le varie matrici relative al gruppo e agli eventuali rotameri
               call calcderangMnqd(ka)
c--aggiorno atomi del gruppo
               do jy=1,nats
                  igrcode= nGrCode(jy)
                  if(igrcode.eq.ka) then
                     nacode = nGrAtCode(jy)
                     ideriv=0
                     call calc55MNQD(kj,jy,jtw,ideriv,igrcode,nacode,
     *                                apd,bpd,xyzapd,xyzbpd)          
                  endif
               enddo
c--fine sggiornamento atomi appartenti a gruppi
            endif
         enddo
c--fine elaborazione gruppi
      endif
c      
c--chek if priniting is requested      
      if (iverb.gt.0) then
        do ka=1,nats
             ksp=nzTot(ka)
c--1a raw
             write(ncwu,3036)aLab(ka),nalf(ksp),serial(ka),
     2            (xyzs(l,ka),l=1,3),bfac(ka),(Bij(l,ka),l=1,2)
3036  format(1x,a8,1x,a4,i6,11f10.5)
             write(ncwu,3037) (shiftMnqd(l,ka),l=1,6)
             write(ncwu,3037) 
     *        (xyzs_dev(l,ka),l=1,3),bfac_dev(ka),(Bij_dev(l,ka),l=1,2)
3037  format(20x,11f10.5)
c--2a raw
             write(ncwu,3036)aLab(ka),nalf(ksp),serial(ka),
     2             (Bij(l,ka),l=3,6),xyzs(5,ka)
             write(ncwu,3037) (shiftMnqd(l,ka),l=7,11)
             write(ncwu,3037) (Bij_dev(l,ka),l=3,6),Occ_dev(ka)
c--controllo mixed species
             imix = iSite(ka)
             if(imix.gt.0) then
                do m=1,imix
                   ksp1 = int(SiteInfo(m,ka)) / 10    ! specie
                   occ  = amod(SiteInfo(m,ka),10.0)   ! occupazione
                   write(ncwu,3039) nalf(ksp1), occ, 
     *                          shiftMnqd(11+m,ka),OccX_dev(m,ka)
3039   format(10x,a4,f16.5,/,14x,f16.5,/,14x,f16.5)
                 enddo
             endif
c--linea bianca                       
             write(ncwu,3038)
3038         format(' ')
        enddo
c       
c--controllo se gruppi sono presenti
        if(CodeGroup.gt.0) then
           do kk=1,NumGroup
c--1a raw
             write(ncwu,3036) aLabGroup(kk),TypeGroup(kk),
     2            NserialGroup(kk),XGroup(1:3,kk),BisoGroup(kk),
     3            BijGroup(1:2,kk)
             write(ncwu,3037) (shiftMnqdGroup(l,kk),l=1,6)
             write(ncwu,3037) 
     *            SXGroup(1:3,kk),SBisoGroup(kk),SBijGroup(l:2,kk)
c--2a raw
             write(ncwu,3036) aLabGroup(kk),TypeGroup(kk),
     2             NserialGroup(kk),BijGroup(3:6,kk),OccGroup(kk)
             write(ncwu,3037) (shiftMnqdGroup(l,kk),l=7,11)
             write(ncwu,3037) SBijGroup(3:6,kk),SOccGroup(kk)
c--3a raw
             write(ncwu,3036) aLabGroup(kk),TypeGroup(kk),
     2             NserialGroup(kk),
     3             ThetaGroup(kk),PhiGroup(kk),PsiGroup(kk)
             write(ncwu,3037) (shiftMnqdGroup(l,kk),l=12,14)
             write(ncwu,3037) SThetaGroup(kk),SPhiGroup(kk),
     2             SPsiGroup(kk)
c--linea bianca                       
             write(ncwu,3038)            
          enddo
        endif 
c--fine printing        
      endif
c
c--modified the unreasonable anisotropic temperature factor
      n=0
      nmodi=0
      do i=1,5
         modiat(i)=' '
      enddo
      if(iverb.lt.-3)n=1
c---------------------------------------------------------
c  jflag = 0 nessuna modifica
c          1 problemi sulle coordinate x,y,z (resettate al ciclo precedente)
c          2 problemi sul B(iso) (valore .le. 0.0)
c          3 problemi sui b(i,j)
c---------------------------------------------------------      
      do ka=1,nats
         if(jFlagAtom(ka).ne.0) then
            if (bfac(ka) > 999) then   !  PEZZA gianluca 19/08/2013
                bfac(ka) = 999.99
            endif
            ksp=nzTot(ka)
            jflag=jFlagAtom(ka)
            if(n.eq.0.and.iverb.ge.0) write(ncwu,3120)
 3120	      format(/,' Warning! the following atoms are modified:')
            n=n+1
            nmodi=nmodi+1
            if(nmodi.le.5)then
               write(modiat(nmodi),'(a8)') aLab(ka)
            endif
            if(iverb.ge.0)
     1	      write(ncwu,3136)alfabeto(jflag:jflag),aLab(ka)(1:8),
     2	      nalf(ksp),serial(ka),(xyzs(l,ka),l=1,3),bfac(ka),
     3        (Bij(l,ka),l=1,6),xyzs(5,ka)
3136	        format(1x,a,') ',a8,1x,a4,i6,11f9.5)
         endif
      enddo
c--stampa messaggio b modificati
      if (nmodi.gt.0) then
          if(iverb.ge.0) write(ncwu,3567)
          if(nmodi.gt.5) then
             nmodi=5
c	       write(ncwu,3564)nmodi,(modiat(j),j=1,5)
             write(Msg,3564)nmodi,(modiat(j),j=1,5)
          else
c	       write(ncwu,3566)nmodi,(modiat(j),j=1,nmodi)
             write(Msg,3566)nmodi,(modiat(j),j=1,nmodi)
          endif
          if(ifResBias < 1) then
             call OpenWarning(Msg)
          endif
      end if
 3564 format('At least',i3,
     *       ' atoms have inconsistent Thermal Factor: ',5a)
 3566 format(i3,' atoms have inconsistent Thermal Factor: ',5a)
 3567 format(' Legend: a) shifts grether than 1.0A',/,
     2       '         b) B(iso) less or equal zero',/,
     3       '         c) wrong thermal ellipsoid',/)       
c--fine stampa
c--calculate the b(iso)
!      m5=l5
      do ka=1,nats
         if(IsoAniso(ka).eq.1) then
            bfac(ka)=0.0
            do j=1,6
               bfac(ka)=bfac(ka)+Bij(j,ka)*BijToBiso(j)
            enddo
         endif
      enddo
!      nsin=0
      if(nCycleCurr.eq.1.or.nCycleTot.eq.1) then
c--calculate the <b>
         sumb_min=9999.
         sumb_max=-9999.
         sumb=0.0
         do ka=1,nats
            if(bfac(ka).le.sumb_min) sumb_min=bfac(ka)
            if(bfac(ka).ge.sumb_max) sumb_max=bfac(ka)
            sumb=sumb+bfac(ka)
         enddo
         sumb=sumb/nats
         BLimit=sumb*5
         if(NoRefl.eq.0) then
            if(iverb.ge.0) then
               write(ncwu,3452) sumb_min,sumb_max,sumb
3452	         format(' Min  value of B(equiv) =',f10.3,/,
     2            ' Max  value of B(equiv) =',f10.3,/,
     3            ' Mean value of B(equiv) =',f10.3)
            endif
         endif
      endif
c--check the b(iso) or b(equiv) for the last lsq cycle
      singat(:)=' '
      nsin=0
      if(nCycleTot.eq.1) then
         do ka=1,nats
            if(bfac(ka).ge.BLimit) then
               nsin=nsin+1
               if(nsin.le.5) then
                  write(singat(nsin),'(a8)') aLab(ka)(1:8)
               endif
            endif
         enddo
         if(nsin.gt.0) then
            if(nsin.gt.5) nsin=5
c		       write(ncwu,3562)nsin,BLimit,(singat(j),j=1,nsin)
               write(Msg,3562)nsin,BLimit,(singat(j),j=1,nsin)
         endif
         if(ifResBias < 1 .and. Msg(1:3) /= '   ') then   ! gianluca 21/04/10
            call OpenWarning(Msg)
         endif
         ifWarning = 1
c--end of check b values for the last lsq cycle
      end if
 3560 format('At least',i3,' atoms have B(eq) > ',f6.1,' : ',5a)
 3562 format(i3,' atoms have B(eq) > ',f6.1,' : ',5a)
      if(ierS.lt.0)return
      jFlagAtom(:)=0
      return
3010  continue
      ierS=-1
      return
      end
c
code for MnqdNparam
      subroutine MnqdNparam(m,k,ibuffer)
c--put the current paramater
c
      USE Atomi
      USE LsqStuff
      USE LsqGroupsStuff
!
      character*(*) ibuffer(*)
      character*16  iiscal(5)
      data iiscal/'scale','ob(iso)','extinction','polarity','twinning'/
c--
      ibuffer(1:2)=' '
      if(m.gt.nats) then 
         if(m.gt.nats+NumGroup) then
            m1=m-(nats+NumGroup)   ! overall parameter
            ibuffer(1)=iiscal(m1)
            return
         else
            m1=m-nats             ! group
            ibuffer(1)=aLabGroup(m1)
            call MnqdPar(k,ibuffer(2),1)
            return
         endif
      else   
         ibuffer(1)=aLab(m)
         call MnqdPar(k,ibuffer(2),0)
      endif
      return
      end   
!-------------------------------------------------------------
!  Routine di inversione della matrice triangolare superiore
!-------------------------------------------------------------
c                                                                       
code for CholMnqd                                                          
      subroutine CholMnqd(kd,n,str11,vet11,ier)
c--inversion of a symmetric upper triangular matrix by the cholesky
c  method                                                               
c--the matrix is held in the array store
!  kd     num. del blocco                              
!  n      order of rhe matrix 
!  str11  matrice triangolare superiore (dimensione = n*(n+1)/2 )
!  vet11  vettore di appoggio (dimensione n) 
!                                         
c  ibase  address of the first element della matrice                                 
c  ires   address of work space of length n                             
c--                                                                     
!
      real*8 dpv,asing,bsing,csing,dsing,epv,one
      common/xchox/ n1,ls,lt,lu,lv,lw1,add,dummy
     2 ,dpv,asing,bsing,csing
c
      real*8 str11(*),vet11(*)
c
      data dsing/0.2d1/
      data one/0.1d1/  
!                            
      ibase=1
      ires=1                           
c--assign the singularity check limits                                  
      csing=dsing**(-35)
      bsing=dsqrt(csing)                                                
c--decompose the matrix in to l.l'                                      
      lu=ires      ! vettore di appoggio                         
      n1=n-1       ! dimensione  - 1                         
      k=ibase      ! matrice triangolare                  
      dpv=str11(k)
      asing=bsing                                                       
c--check the first element of the first row                             
      if(n1) 1300,2000,1000                                             
 1000 continue                                                          
      if(dpv-bsing) 1010,1010,1020                                      
 1010 continue                                                          
      call xsingMnqd(kd,0,n,ibase,str11,vet11)
c--setto il valore minimo e vado avanti
      go to 2015                                                        
 1020 continue                                                          
      dpv=dsqrt(dpv)                                                    
      str11(k)=dpv
      vet11(lu)=1.0/str11(k)    
      k=k+1                                                             
      do i=1,n1                                                    
         str11(k)=str11(k)*vet11(lu)
         k=k+1                                                             
      enddo                                                         
c--continue with the rest of the matrix                                 
 1040 continue                                                          
      lu=lu+1                                                           
      do i=1,n1                                                    
         dpv=str11(k)
         asing=dpv*csing
         l=ibase+i
         do j=1,i
            dpv=dpv-str11(l)*str11(l)
            l=l+n-j
         enddo
         if(dpv-bsing) 1070,1070,1060
 1060    continue
         if(dpv-asing) 1070,1070,1080
 1070    continue
         ioi=i
         call xsingMnqd(kd,ioi,n,ibase,str11,vet11)
c--setto il valore minimo e vado avanti
         go to 2015
 1080    continue
         dpv=dsqrt(dpv)
         epv=one/dpv
         str11(k)=dpv
         vet11(lu)=1.0/str11(k)
         k=k+1
         if(i-n1) 1090,1120,1090
 1090    continue
         lw1=i+1
         do j=lw1,n1
            dpv=str11(k)
            ls=ibase+i
            lt=ibase+j
            do m=1,i
               dpv=dpv-str11(ls)*str11(lt)
               ls=ls+n-m
               lt=lt+n-m
            enddo
            str11(k)=dpv*epv
            k=k+1
         enddo
 1120    continue
         lu=lu+1
      enddo   
c--inversion of the triangular matrix l
      lv=k
      k=k-1
      lu=lu-1
      str11(k)=vet11(lu)
      k=k-1
      lu=lu-1
      do i=1,n1
         lw1=lv
         do j=1,i
            add=0.0
            lw1=lw1-j
            lt=k
            ls=lw1
            do l=j,i
               add=add-str11(lt)*str11(ls)
               lt=lt-1
               ls=ls-l
            enddo
            str11(k)=add*vet11(lu)
            k=k-1
         enddo
         str11(k)=vet11(lu)
         k=k-1
         lu=lu-1
      enddo
c--form the inverse matrix from the two inverted triangles
      k=ibase
      ls=ibase-1
      do i=1,n
         lt=ls
         do j=i,n
            add=0.0
            do m=j,n
               lv=m+lt
               lw1=m+ls
               add=add+str11(lv)*str11(lw1)
            enddo
            str11(k)=add
            k=k+1
            lt=lt+n-j
         enddo
         ls=ls+n-i
      enddo
 1300 continue
      ier=0
      return
c--only one element
 2000 continue
      if(dpv-asing) 2010,2010,2020
 2010 continue
      call xsingMnqd(kd,0,n,ibase,str11,vet11)
c--setto il valore minimo e vado avanti
2015  continue
      ier=-1
      return
 2020 continue
      str11(k)=1.0/str11(k)
      go to 1300
      end
c
code for xsolvMnqd
      subroutine xsolvMnqd(n,str11,ter11,vet11)
c--solve the normal equations
!  n      order of rhe matrix 
!  str11  matrice triangolare superiore inversa(dimensione = n*(n+1)/2 )
!  ter11  vettore (dimensione n)
!  vet11  vettore di appoggio (dimensione n) 
!                                         
c  ibase first location of the matrix
c  ivect first location of the vector
c  ires  first location of the results
c--
!
      real*8 dpv,asing,bsing,csing
      common/xchox/ n1,ls,lt,lu,lv,lw1,add,dummy
     2 ,dpv,asing,bsing,csing
c
      real*8 str11(*),ter11(*),vet11(*)
c
      ibase=1
      ivect=1
      ires=1    
c
c--work out the answers
 1300 continue
      k=ires
      do i=1,n
         ls=ibase+i-1
         vet11(k)=0.0
         lt=ivect
         do j=1,n
            vet11(k)=vet11(k)+ter11(lt)*str11(ls)
            if(j-i) 1310,1330,1330
 1310       continue
            ls=ls+n-j
            go to 1340
 1330       continue
            ls=ls+1
 1340       continue
            lt=lt+1
         enddo
         k=k+1
      enddo
      return
      end
c
code for xsingMnqd
      subroutine xsingMnqd(kd,noc,n,ibase,str11,vet11)
c--singularity error
c
      USE General
      USE LsqStuff22Abs
!
      character*(16) ibuffer(2)
c
      real*8 dpv,asing,bsing,csing
      common/xchox/ n1,ls,lt,lu,lv,lw1,add,dummy
     2 ,dpv,asing,bsing,csing
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      real*8 str11(*),vet11(*)
!      
      ls=noc+1
      m=ParAddr(kd,ls,1)
      k=ParAddr(kd,ls,2)
      call MnqdNparam(m,k,ibuffer)
      if (ifResBias < 1) then
          write(Msg,1000)ls,(ibuffer(j)(1:8),j=1,2)
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
      endif
 1000 format(' Singularity - relative parameter',i5,' --> ',a,1x,a)
      ier = -1
c
      ls=ibase+noc
      do 1030 lt=1,n
      str11(ls)=0.0
      if(noc-lt) 1020,1010,1010
 1010 continue
      ls=ls+n-lt
      go to 1030
 1020 continue
      ls=ls+1
 1030 continue
      vet11(lu)=0.0
      return
      end
!-------------------------------------------------------------
!  Fine delle Routine di inversione della matrice 
!-------------------------------------------------------------
c
code for saplyMnqd
      subroutine saplyMnqd(ka,bc,afltw,ierS)
c--apply the calculate shifts agli atomi
c--
      USE General
      USE Atomi
      USE LsqStuff
      USE LsqModule
c
      dimension buf1(nPar15),buf2(nPar15),buf3(nPar15)
      dimension bc(nPar15),xc(3),OccRef(5)
      dimension bijMat(3,3)
      character*16 ivect1,ivect2
c--
      MixRef=0
      imixed = iSite(ka)
      ierS=0
      dm=1.0
      np=nPar15
      if(CodeGroup.gt.0)np=11   ! vuol dire che ci sono gruppi!!!!!!!!!!!!!!!!!
!--update the shifts
      do jx=1,np
         j=nParBl(jx,ka)     ! no del blocco a cui appartiene il parametro
         if(j.gt.0) then
c--calculate the shift for this parameter   
            shiftMnqd(jx,ka) = shiftMnqd(jx,ka) + bc(jx)   
c--check if parameter with a weight different from 1
            if(iEquiv(jx,1,ka).ne.1000) then
               f=iEquiv(jx,1,ka)/1000.0
               shiftMnqd(jx,ka) = shiftMnqd(jx,ka)*f
            endif       
         endif
      enddo
c--apply the shifts
      xc(:)=0.0
      buf1(:)=0.0
      buf2(:)=0.0
      buf3(:)=0.0
      do i=1,np
         j=nParBl(i,ka)     ! no del blocco a cui appartiene il parametro
         if(j.gt.0) then
            if(i.le.3)then
               shiftMnqd(i,ka)=shiftMnqd(i,ka)*Dampi*afltw
               xc(i)=shiftMnqd(i,ka)
            endif
            if (i.gt.3.and.i.le.10)shiftMnqd(i,ka)=shiftMnqd(i,ka)*Dampi
            if (i.gt.10.and.imixed.gt.1) then
                shiftMnqd(i,ka)=shiftMnqd(i,ka)*0.1    ! riduco shift per occupanze
            endif
            if ((i.eq.5).or.(i.eq.8).or.(i.eq.10)) then
                 icountb=0
1000             continue
                 tem=Bij(i-4,ka) + shiftMnqd(i,ka)
                 if (tem.lt.0.0) then
                     shiftMnqd(i,ka)=shiftMnqd(i,ka)*0.5
                     icountb=icountb+1
                     if(icountb.gt.5) goto 1010
                     goto  1000
                 endif
            endif
1010        continue
            buf1(i)=shiftMnqd(i,ka)
            if(i.le.3) then 
               buf2(i)=xyzs(i,ka)
               xyzs(i,ka)  = xyzs(i,ka)+shiftMnqd(i,ka)
            else if(i.eq.4) then
               buf2(i)=bfac(ka)
               bfac(ka)    = bfac(ka)+shiftMnqd(i,ka) 
               if(bfac(ka).le.0.001) then
                  shiftMnqd(i,ka)=0.5*shiftMnqd(i,ka)
                  bfac(ka) = buf2(i) +shiftMnqd(i,ka)
               endif
            else if(i.le.10) then
               buf2(i)= Bij(i-4,ka)
               Bij(i-4,ka) = Bij(i-4,ka)+shiftMnqd(i,ka) 
            else if(i.eq.11) then
               buf2(i)=xyzs(5,ka)
               xyzs(5,ka)  = xyzs(5,ka)+shiftMnqd(i,ka) 
               buf3(i)=xyzs(5,ka)
            else if(i.ge.12) then
               MixRef=1
               ksp = int(SiteInfo(i-11,ka)) / 10
               occs = amod(SiteInfo(i-11,ka),10.0)
               buf2(i)=occs
               occs= occs+shiftMnqd(i,ka)
               buf3(i)=occs
            endif    
         endif
      enddo         
!
c--controllo se ho un restraints sum sulle occupazioni
c  da predisporre
      if(imixed.gt.0.and.MixRef.eq.1) then
c--check occ before cycle occ=xyzs(5,ka) 
          occtB=0.0
          occtF=0.0
          do i=1,imixed+1
            occtB=occtB+buf2(i+10)
            occtF=occtF+buf3(i+10)
          enddo
c--check occ after cycle if it is out of range
          ModMix=0
          jx=11
          do i=1,imixed+1
             j=nParBl(jx,ka)     ! no del blocco a cui appartiene il parametro
             if(j.gt.0) then
                a=buf3(jx)
                if(a.lt.0.0)then
                   a=0.0
                   ModMix=1
                endif
                if(a.gt.occtB) then
                   a=occtB
                   ModMix=1
                endif
                OccRef(i)=a- buf2(jx)
             endif  
             jx=jx+1 
          enddo   
          if(ModMix.eq.0) then
             jx=11
             do i=1,imixed+1
                j=nParBl(jx,ka)     ! no del blocco a cui appartiene il parametro
                if(j.gt.0) then 
                   if(jx.eq.11) then
                      xyzs(5,ka)=buf2(jx)
                      xyzs(5,ka)  = xyzs(5,ka)+shiftMnqd(jx,ka) 
                   else 
                      ksp = int(SiteInfo(jx-11,ka)) / 10
                      occs=buf2(jx)
                      occs= occs+shiftMnqd(jx,ka)
                      SiteInfo(jx-11,ka) = ksp*10 + occs             
                   endif  
                endif    
                jx=jx+1
             enddo 
          else 
             occ_rapp_min=9999.0  
             occ_max_shift=0.0
             jcode_max=0
             jx=11
             do i=1,imixed+1
                j=nParBl(jx,ka)     ! no del blocco a cui appartiene il parametro
                if(j.gt.0) then
!--start check-----------------------------------------------------             
                if(buf3(jx).lt.0.0)then
                   occ_rapp=buf2(jx)/abs(buf1(jx))
                   if(occ_rapp_min.gt.occ_rapp) occ_rapp_min=occ_rapp
                   jcode_max=i 
                endif
                if(buf3(jx).gt.1.0)then
                   occ_rapp=(occtB-buf2(jx))/abs(buf1(jx))
                   if(occ_rapp_min.gt.occ_rapp) occ_rapp_min=occ_rapp
                   jcode_max=i 
                endif
!--end check-------------------------------------------------------             
                endif  
                jx=jx+1 
             enddo   
             if(jcode_max.gt.0) then
                jcode_max=0
                jx=11
                do i=1,imixed+1
                   j=nParBl(jx,ka)     ! no del blocco a cui appartiene il parametro
                   if(j.gt.0) then 
                      shiftMnqd(jx,ka)=buf1(jx)*occ_rapp_min
                      if(jx.eq.11) then
                         xyzs(5,ka)=buf2(jx)
                         xyzs(5,ka)  = xyzs(5,ka)+shiftMnqd(jx,ka) 
                         if(xyzs(5,ka).gt.occtB) then
                            xyzs(5,ka)=occtB
                         endif
                         if(xyzs(5,ka).le.0.01) then
                            xyzs(5,ka)=0.00
                            jcode_max=i
                         endif
                      else 
                         ksp = int(SiteInfo(jx-11,ka)) / 10
                         occs=buf2(jx)
                         occs= occs+shiftMnqd(jx,ka)
                         if(occs.gt.occtB) then
                            occs=occtB
                         endif
                         if(occs.le.0.01) then
                            occs=0.00
                            jcode_max=i
                         endif
                         SiteInfo(jx-11,ka) = ksp*10 + occs             
                      endif  
                   endif    
                   jx=jx+1
                enddo 
c--write warning message
                if(jcode_max.gt.0) then
                   jcode_max=jcode_max-1
                   ivect1=aLab(ka)
                   if(jcode_max.eq.0) then
                      ksp=nzTot(ka)
                   else
                      ksp = int(SiteInfo(jcode_max,ka)) / 10
                   endif   
                   ivect2=Species(ksp)
                   call xshift(ivect2,lnam2)
                   call xshift(ivect1,lnam1)
                   write(Msg,1020)ivect1(1:lnam1),ivect2(1:lnam2)
1020               format('Warning! Site ',a,' , check species ',a)                
                   call OpenWarning(Msg)
                   ierS=-1 
                endif
             endif      
          endif
      endif       
c--check if the positional shifts are reasonable
      jFlagAtom(ka)=0
      do n=1,3
        if(abs(xc(n)).gt.0.5)then
          xc(n)=xc(n)-sign(1.0,xc(n))
        endif
      enddo
      dist=xgg(1,1)*xc(1)*xc(1)
     1	  +xgg(2,2)*xc(2)*xc(2)
     2	  +xgg(3,3)*xc(3)*xc(3)
     3	  +xgg(1,2)*xc(1)*xc(2)*2.0
     4	  +xgg(1,3)*xc(1)*xc(3)*2.0
     5	  +xgg(2,3)*xc(2)*xc(3)*2.0
      if(dist.gt.dm) then
c	write(lo,*) 'problemi nelle coordinate'
         jFlagAtom(ka)=1
         do i=1,3
            xyzs(i,ka)  = buf2(i)
         enddo
      endif
c--check if there are unreasonable values for t.p.
      if(IsoAniso(ka).eq.2) then
         if(bfac(ka).le.0.0) then
!	      write(lo,*) 'problemi nel B(iso)'
            jFlagAtom(ka)=2
            bfac(ka)  = buf2(4)
         endif
      else
c--check the bii terms
         if(Bij(1,ka).le.0.0) jFlagAtom(ka)=3
         if(Bij(4,ka).le.0.0) jFlagAtom(ka)=3
         if(Bij(6,ka).le.0.0) jFlagAtom(ka)=3
         if(jFlagAtom(ka).ne.3) then
c--check the volume of ellipsoid
c--check the det of ellipsoid
!
            bijMat(1,1)=Bij(1,ka)
            bijMat(1,2)=0.5*Bij(2,ka)
            bijMat(1,3)=0.5*Bij(3,ka)
            bijMat(2,1)=bijMat(1,2)
            bijMat(2,2)=Bij(4,ka)
            bijMat(2,3)=0.5*Bij(5,ka)
            bijMat(3,1)=bijMat(1,3)
            bijMat(3,2)=bijMat(2,3)
            bijMat(3,3)=Bij(6,ka)
!
           call dt3(bijMat,det)
           if(det.le.0.0) then 
              jFlagAtom(ka)=3
           else
              s1=bijMat(2,2)*bijMat(3,3)-bijMat(2,3)*bijMat(3,2)
              s2=bijMat(1,1)*bijMat(3,3)-bijMat(1,3)*bijMat(3,1)
              s3=bijMat(1,1)*bijMat(2,2)-bijMat(1,2)*bijMat(2,1)
              stot=s1+s2+s3
              if(stot.le.0.0) jFlagAtom(ka)=3
           endif
         endif
         if(jFlagAtom(ka).eq.3) then
            do i=1,6
               Bij(i,ka) = buf2(4+i)
            enddo
         endif 
c--end of check
      endif
      return                                                            
      end                                                               
c
code for saplygrMnqd                            *** Gruppo ***
      subroutine saplygrMnqd(ka,bc,afltw,ierS)
c--apply the calculate shifts ai gruppi
c--
      USE General
      USE Atomi
      USE LsqStuff
      USE LsqModule
      USE LsqGroupsStuff
c
      dimension buf1(nPar15),buf2(nPar15),buf3(nPar15)
      dimension bc(nPar15),xc(3)
      dimension bijMat(3,3)
      character*16 ivect1,ivect2
!      
      ierS=0
      dm=1.0
      np=nPar15
!--update the shifts
      m=nats+ka
      do jx=1,np
         j=nParBl(jx,m)     ! no del blocco a cui appartiene il parametro
         if(j.gt.0) then
c--calculate the shift for this parameter   
            shiftMnqdGroup(jx,ka) = shiftMnqdGroup(jx,ka) + bc(jx)   
c--check if parameter with a weight different from 1 
            if(iEquiv(jx,1,m).ne.1000) then
               f=iEquiv(jx,1,m)/1000.0
               shiftMnqdGroup(jx,ka) = shiftMnqdGroup(jx,ka)*f
            endif       
         endif
      enddo
c--apply the shifts
      xc(:)=0.0
      buf1(:)=0.0
      buf2(:)=0.0
      buf3(:)=0.0
      do i=1,np
         j=nParBl(i,m)     ! no del blocco a cui appartiene il parametro
         if(j.gt.0) then
            if(i.le.3)then
               shiftMnqdGroup(i,ka)=shiftMnqdGroup(i,ka)*Dampi*afltw
               xc(i)=shiftMnqdGroup(i,ka)
            endif
            if (i.gt.3.and.i.le.10)
     *           shiftMnqdGroup(i,ka)=shiftMnqdGroup(i,ka)*Dampi
            if (i.eq.11)
     *           shiftMnqdGroup(i,ka)=shiftMnqdGroup(i,ka)*0.1    ! riduco shift per occupanze
            if ((i.eq.5).or.(i.eq.8).or.(i.eq.10)) then
                 icountb=0
1000             continue
                 tem=BijGroup(i-4,ka) + shiftMnqdGroup(i,ka)
                 if (tem.lt.0.0) then
                     shiftMnqdGroup(i,ka)=shiftMnqdGroup(i,ka)*0.5
                     icountb=icountb+1
                     if(icountb.gt.5) goto 1010
                     goto  1000
                 endif
            endif
1010        continue      
            if(i.ge.12) then
                 shiftMnqdGroup(i,ka)=shiftMnqdGroup(i,ka)*rtd
            endif
            buf1(i)=shiftMnqdGroup(i,ka)
            if(i.le.3) then 
               buf2(i)=XGroup(i,ka)
               XGroup(i,ka)  = XGroup(i,ka)+shiftMnqdGroup(i,ka)
            else if(i.eq.4) then
               buf2(i)=BisoGroup(ka)
               BisoGroup(ka) = BisoGroup(ka)+shiftMnqdGroup(i,ka) 
            else if(i.le.10) then
               buf2(i)= BijGroup(i-4,ka)
               BijGroup(i-4,ka) = BijGroup(i-4,ka)+shiftMnqdGroup(i,ka) 
            else if(i.eq.11) then
               buf2(i)=OccGroup(ka)
               OccGroup(ka)  = OccGroup(ka)+shiftMnqdGroup(i,ka) 
            else if(i.eq.12) then
               buf2(i)=ThetaGroup(ka)
               ThetaGroup(ka)  = ThetaGroup(ka)+shiftMnqdGroup(i,ka) 
            else if(i.eq.13) then
               buf2(i)=PhiGroup(ka)
               PhiGroup(ka)  = PhiGroup(ka)+shiftMnqdGroup(i,ka) 
            else if(i.eq.14) then
               buf2(i)=PsiGroup(ka)
               PsiGroup(ka)  = PsiGroup(ka)+shiftMnqdGroup(i,ka) 
            endif    
         endif
      enddo
c--check if the positional shifts are reasonable
      jFlagGroup(ka)=0
      do n=1,3
         if(abs(xc(n)).gt.0.5)then
            xc(n)=xc(n)-sign(1.0,xc(n))
         endif
      enddo
      dist=xgg(1,1)*xc(1)*xc(1)
     1	  +xgg(2,2)*xc(2)*xc(2)
     2	  +xgg(3,3)*xc(3)*xc(3)
     3	  +xgg(1,2)*xc(1)*xc(2)*2.0
     4	  +xgg(1,3)*xc(1)*xc(3)*2.0
     5	  +xgg(2,3)*xc(2)*xc(3)*2.0
      if(dist.gt.dm) then
         jFlagGroup(ka)=1
         do i=1,3
            XGroup(i,ka)= buf2(i)
         enddo
      endif
c--check if there are unreasonable values for t.p.
      if(IsoAnisoGroup(ka).eq.2) then
         if(BisoGroup(ka).le.0.0) then
            jFlagGroup(ka)=2
            BisoGroup(ka)=buf2(4)
         endif
      else
c--check the bii terms
         if(BijGroup(1,ka).le.0.0) jFlagGroup(ka)=3
         if(BijGroup(4,ka).le.0.0) jFlagGroup(ka)=3
         if(BijGroup(6,ka).le.0.0) jFlagGroup(ka)=3
         if(jFlagGroup(ka).ne.3) then
!
            bijMat(1,1)=BijGroup(1,ka)
            bijMat(1,2)=0.5*BijGroup(2,ka)
            bijMat(1,3)=0.5*BijGroup(3,ka)
            bijMat(2,1)=bijMat(1,2)
            bijMat(2,2)=BijGroup(4,ka)
            bijMat(2,3)=0.5*BijGroup(5,ka)
            bijMat(3,1)=bijMat(1,3)
            bijMat(3,2)=bijMat(2,3)
            bijMat(3,3)=BijGroup(6,ka)
!
           call dt3(bijMat,det)
           if(det.le.0.0) then 
              jFlagGroup(ka)=3
           else
              s1=bijMat(2,2)*bijMat(3,3)-bijMat(2,3)*bijMat(3,2)
              s2=bijMat(1,1)*bijMat(3,3)-bijMat(1,3)*bijMat(3,1)
              s3=bijMat(1,1)*bijMat(2,2)-bijMat(1,2)*bijMat(2,1)
              stot=s1+s2+s3
              if(stot.le.0.0) jFlagGroup(ka)=3
           endif
         endif
         if(jFlagGroup(ka).eq.3) then
            do i=1,6
               BijGroup(i,ka) = buf2(4+i)
            enddo
         endif 
c--end of check
      endif
      return                                                            
      end   
!                                                                  
!----------------------------------------------------------
!  routine di stampa
!----------------------------------------------------------
c
code for PrintAtoms
      subroutine PrintAtoms
c--print a list in  (type 5)   (ex sw05)
c
      USE General
      USE Atomi
      USE Molcom
      USE Dialogo, only: ifPDBcoded
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      character*60 tit05
      dimension naX(18),noX(18)
c--
c---------------------------------
c  ipr  = 0 print b(ij)
c         1 print b(equiv)
c  icod = 0 no standard deviations
c	    1 standard deviations
      ipr=0
      icod=1
      do i=1,nk
         noX(i)=0
         naX(i)=0
      enddo
c--check if multiple site are present      
      nsiteT=0
      do i=1,nats
         if(iSite(i).gt.0)then
            nsiteT=1
            exit
         endif
      enddo
      if(ifPDBcoded.eq.1) then
          tit05='Atomic parameters (file PDB)'
      else
          tit05='Atomic parameters'
      endif
      write(lo,'(/,1x,a,/)')tit05
c--print the overall parameters
      if(icod.eq.0) then
      write(lo,1030) FcScale,FcBiso,FcExtin,FcPola,FcTwin
1030  format(' Scale      :',f10.5,/,
     2       ' Ob[iso]    :',f10.5,/,
     3       ' Extinction :',f10.5,/,
     4       ' Polarity   :',f10.5,/,
     5       ' Twinning   :',f10.5)
      else
      write(lo,1031) FcScale,Overall_dev(1),FcBiso,Overall_dev(2),
     *FcExtin,Overall_dev(3),FcPola,Overall_dev(4),FcTwin,Overall_dev(5)
1031  format(' Scale      :',2f10.5,/,
     2       ' Ob[iso]    :',2f10.5,/,
     3       ' Extinction :',2f10.5,/,
     4       ' Polarity   :',2f10.5,/,
     5       ' Twinning   :',2f10.5)
      endif
c------------------------------------------------------
      write(lo,1050) nats
1050  format(/, ' Number of atom(s) :',i6/)
      if (ipr.eq.0) then
          if(nsiteT.eq.0) write(lo,1060)
          if(nsiteT.eq.1) write(lo,1062)          
      else
          write(lo,1061)
      end if
!      
 1060 format(' Name',3x,' Type',2x,'Serial',3x,' x',8x,
     1 ' y',8x,' z',4x,'B(iso)/(eq)',3x,' Occ.'/,18x,
     2 3x,' b(11)',4x,' b(12)',4x,' b(13)',4x,' b(22)',
     3 4x,' b(23)',4x,' b(33)',/)
 1062 format(' Name',3x,' Type',2x,'Serial',3x,' x',8x,
     1 ' y',8x,' z',4x,'B(iso)/(eq)',3x,' Occ.'/,18x,
     2 3x,' b(11)',4x,' b(12)',4x,' b(13)',4x,' b(22)',
     3 4x,' b(23)',4x,' b(33)',/,23x,'Occ(n)',40x,4x,'Occ(T)'/)
 1061    format(' Name',3x,' Type',2x,'Serial',3x,' x',8x,
     1 ' y',8x,' z',4x,'B(iso)/(eq)',3x,' Occ',/)
!     
      do i=1,nats
         lnz = nzTot(i)
         do l=1,nk
            if(naX(l).eq.0) then   !goto 1067
               naX(l)=lnz
               noX(l)=noX(l)+1
               exit
            endif
            if(lnz.eq.naX(l)) then   !goto 1068
               noX(l)=noX(l)+1
               exit
            endif
         enddo
!         L = Lung(aLab(i))
         write(lo,1110) aLab(i)(1:8), nalf(lnz),serial(i),
     1        xyzs(1:3,i),bfac(i),xyzs(5,i)
1110     format(1x,a ,1x,a4,i5,3f10.5,2f10.3)
         if(icod.gt.0) then
            write(lo,1075) xyzs_dev(1:3,i),bfac_dev(i),Occ_dev(i)
1075        format(19x,3f10.5,2f10.3)
         endif
         if(ipr.eq.0) then
            write(lo,1111) bij(1:6,i)
1111        format(19x,6f10.5)
            if(icod.gt.0) then
               write(lo,1111) bij_dev(1:6,i)
            endif
         endif
c--print mixed atomic species
         if(iSite(i).gt.0)then
            imix = iSite(i)
            occtot=xyzs(5,i)
            do j=1,imix
               ksp1 = int(SiteInfo(j,i)) / 10    ! specie   
               occ  = amod(SiteInfo(j,i),10.0)   ! occupazione  
               occtot=occtot+occ
               if(j.eq.imix) then
                  write(lo,1081) nalf(ksp1),occ,occtot
1081              format(10x,a4,5x,f10.3,40x,f10.3)
               else
                  write(lo,1080) nalf(ksp1),occ
1080              format(10x,a4,5x,f10.3)
               endif
               if(icod.ne.0)write(lo,1082) OccX_dev(j,i)
1082           format(19x,f10.3)
            enddo
         endif
      enddo
      write(lo,1092)
1092  format(/,' statistics:')
      do l=1,20
         if(naX(l).eq.0) exit
         lnz = naX(l)
         write(lo,1097) l,nalf(lnz),noX(l)
1097     format(1x,i3,') species ',a4,' - no. of atom(s) ',i5)
      enddo
c--connectivity
      write(lo,"(' ')")
      call PrintConn(iconn,aLab)
      return
      end
!
!code for PrintConn
      subroutine PrintConn(iconn,aLab)
!--stampa connettivita'
!
      USE General
!            
      dimension iconn(*)
      character*(*) aLab(*)
      character*25 Aline(3)
      character*1 kcod1,kcod2
      character*2 iasch
      data iasch/'*!'/ 
!
      if(iconn(1).gt.0) then
         nco=iconn(1)
         write(lo,1240)nco
1240     format(/, ' connectivity table - bond list ',/
     1            ,' number of bonds:',i4,/)
         nlin=nco/3 
         nrest=nco - nlin*3
         if(nrest.gt.0) nlin = nlin + 1
         j = 2
         nbo=1
         do l=1,nlin
            Aline(1:3)=' '
            do kl=1,3
               if(nbo.gt.nco) exit
               lj=iabs(iconn(j))
               kj=iabs(iconn(j+1))
               nj=iconn(j+2)
               if(nj.lt.0) then 
                  Aline(kl)=blank//'  !      -   !      '
               else
                  kcod1=' '
                  if(iconn(j).lt.0)kcod1=iasch(1:1) 
                  kcod2=' '
                  if(iconn(j+1).lt.0)kcod2=iasch(1:1) 
                  Aline(kl)=blank//kcod1//aLab(lj)(1:8)// '- '
                  Aline(kl)=Aline(kl)(1:12)//kcod2//aLab(kj)(1:8)
               endif
               nbo=nbo+1
               j=j+3
            enddo
            write(lo,'(3a)') Aline(1:3)   
         enddo   
      endif
      return
      end
!-----------------------------------------------------------
!  Routine per Restraints in MNQD
!-----------------------------------------------------------
c
code for PrintRestraint
      subroutine PrintRestraint(jcod)
c--routine di stampa dei restraint
c  jcod = -1/0 lista Restraint(s) (come output dalla grafica)
c          1 Sommario Restraint(s) prima di MNQD
c          2 Sommario Restraint(s) dopo di MNQD
c
c             nres         = number of restraints
c             vres         = array containing restraints
c
c   restraint code         = 1 DISTANCE
c                            2 ANGLE
c                            3 TORSION
c                            4 PLANE
c                            5 SUM
c                            6 LIMIT
c                            7 SITE
c                            8 DISORDER
c
c   vres(jp)               = restraint code
c   vres(jp+1)             = number of atoms involved
c   vres(jp+2)             = sigma
c                            sigma(x)             if LIMIT
c   vres(jp+3)             = distance             if DISTANCE
c                            angle                if ANGLE
c                            angle                if TORSION
c                            zero                 if PLANE
c                            number of parameters if SUM
c                            sigma(B)             if LIMIT
c
c   vres(jp+4)             = sigma(bij)           if LIMIT
c   vres(jp+4....)         = parameters codes     if SUM
c   vres(jp+4....)         = atoms codes          if DIST, ANGLE, PLANE
c   vres(jp+4....)         = atoms codes          if SITE
c   vres(jp+4+params....)  = atoms codes          if SUM
c   vres(jp+5....)         = atoms codes          if LIMIT
c      
      USE General
      USE Atomi
      USE Molcom
      USE LsqModule
      USE LsqStuff12
      USE LsqStuff12_RT
!
      dimension CoefPlane(4),CoefPlane_dev(4)
      character allAt*9 , string(2)*6
      character *100 line
      character  It1(15)*6
      data It1 /'    X ','    Y ','    Z ','B[iso]',
     2          '    11','    12','    13','    22',
     3          '    23','    33','   Occ','  Occ1',
     4          '  Occ2','  Occ3','  Occ4'/
      data allAt/'All Atoms'/,string/'before','after '/
!
      if(nres.le.0) return
      if(jcod.le.0) then 
         write(lo,5)nres
      else if(jcod.gt.0) then
         write(lo,9038)  string(jcod)
      endif   
!      
      jpn = 0
      iflag1=0
      iflag6=0
      do kk =1,7
         jp = 0
         iflag = 0
         do i = 1 , nres
            if(jcod.gt.0) jbb = Nvres12(i)
            jp = jp + 1
            icode = nint(vres(jp))
            natom = nint(vres(jp+1))
            incr=3
            if (icode.eq.5) then
                nparams = nint( vres(jp+3) )
            else
                nparams = 0
            endif
            if (icode.eq.6) incr=4
            if (icode.eq.kk) then
                sigma = vres(jp+2)
                dista = vres(jp+3)
                select case (icode)
                    case (1)                 ! distances
                        if(jcod.le.0) then
                           if (iflag.eq.0) then
                               write(lo,10)
                               iflag =1
                           endif
                           jjfin = jp + 4 + natom - 1
                           write(lo,100) sigma,dista,
     *                     (aLab(nint(vres(jj))),jj=jp+4,jjfin)
                        else if(jcod.gt.0) then
                           if (iflag1.eq.0) then
                               write(lo,9039)
                               iflag1 =1
                           endif
                           call DistRestr(jp,dist,df)
                           call shift(stringa12Tot_C(jbb),len)
                           if(len.gt.34) then
                               write(lo,3940) dist,dista,df,sigma,
     2			                   stringa12Tot_C(jbb)(1:31)//'...'
                           else
                               write(lo,3940) dist,dista,df,sigma,
     2			                   stringa12Tot_C(jbb)(1:34)
                           endif
                        endif
                    case (2)                 ! angle
                        if(jcod.le.0) then
                           if (iflag.eq.0) then
                               write(lo,20)
                               iflag =1
                           endif
                           jjfin = jp + 4 + natom - 1
                           write(lo,100) sigma,dista,
     *                     (aLab(nint(vres(jj))),jj=jp+4,jjfin)
                        else if(jcod.gt.0) then
                           if (iflag1.eq.0) then
                               write(lo,9039)
                               iflag1 =1
                           endif
                           call AngleRestr(jp,ang,df)
                           call shift(stringa12Tot_C(jbb),len)
                           if(len.gt.34) then
                               write(lo,3940) ang,dista,df,sigma,
     2			                   stringa12Tot_C(jbb)(1:31)//'...'
                           else
                               write(lo,3940) ang,dista,df,sigma,
     2			                   stringa12Tot_C(jbb)(1:34)
                           endif
                        endif
                    case (3)                 ! torsion angle
                        if(jcod.le.0) then
                           if (iflag.eq.0) then
                               write(lo,25)
                               iflag =1
                           endif
                           jjfin = jp + 4 + natom - 1
                           write(lo,100) sigma,dista,
     *                     (aLab(nint(vres(jj))),jj=jp+4,jjfin)
                        else if(jcod.gt.0) then
                           if (iflag1.eq.0) then
                               write(lo,9039)
                               iflag1 =1
                           endif
                           call TorsRestr(jp,ang,df)
                           call shift(stringa12Tot_C(jbb),len)
                           if(len.gt.34) then
                               write(lo,3940) ang,dista,df,sigma,
     2			                   stringa12Tot_C(jbb)(1:31)//'...'
                           else
                               write(lo,3940) ang,dista,df,sigma,
     2			                   stringa12Tot_C(jbb)(1:34)
                           endif
                        endif
                    case (4)                 ! plane
                        if(jcod.le.0) then
                           if (iflag.eq.0) then
                               write(lo,30)
                               iflag =1
                           endif
                           jjfin = jp + 4 + natom - 1
                           if (natom.ne.nats) then
                               write(lo,200) sigma,
     *                          (aLab(nint(vres(jj))),jj=jp+4,jjfin)
                           else
                               write(lo,400) sigma,allAt
                           endif
                        else if(jcod.gt.0) then
                           if (iflag1.eq.0) then
                               write(lo,9039)
                               iflag1 =1
                           endif
                           call PlaneRestr(jp,CoefPlane)
                           do n=1,nats25
                              dfp=xyzs25(4,n)
                              df=dista-dfp
                              write(lo,3535) dfp,dista,df,sigma,
     2			               aLab25(n)
                           enddo
                        endif
                    case (5)                 ! sum
                        if(jcod.le.0) then
                           if (iflag.eq.0) then
                               write(lo,40)
                               iflag =1
                           endif
                           line = ' '
                           jpp=jp+4
                           jjfin = jpp + nparams + natom - 1
                           write(line,600) (It1(nint(vres(jj))),
     *                                    jj=jpp,jpp+nparams-1)
                           lline = 0
                           call onebl(line,lline,ier)
                           jpp = jpp + nparams
                           if (natom.eq.nats) then
                               write(lo,360) sigma,line(1:12),allAt
                           else
                               if (lline.le.12) then
                                   write(lo,300) sigma,line(1:12),
     *                              (aLab(nint(vres(jj))),jj=jpp,jjfin)
                               else
                                   write(lo,350) sigma,line(1:lline),
     *                               (aLab(nint(vres(jj))),jj=jpp,jjfin)
                               endif
                           endif
                        else if(jcod.gt.0) then
                           if (iflag1.eq.0) then
                               write(lo,9039)
                               iflag1 =1
                           endif
                           call SumRestr(jp,sum)
                           call shift(stringa12Tot_C(jbb),len)
                           df=0
                           if(len.gt.34) then
                               write(lo,3542) sum,sum,df,sigma,
     2			                   stringa12Tot_C(jbb)(1:31)//'...'
                           else
                               write(lo,3542) sum,sum,df,sigma,
     2			                   stringa12Tot_C(jbb)(1:34)
                           endif
                        endif
                    case (6)         ! limit
                        sigma1 = vres(jp+4)
                        if(jcod.le.0) then
                           if (iflag.eq.0) then
                               write(lo,50)
                               iflag =1
                           endif
                           jjfin = jp + 5 + natom - 1
                           if (natom.ne.nats) then
                               jpp = jp + 5
                               write(lo,550) sigma,dista,sigma1,
     *                            (aLab(nint(vres(jj))),jj=jpp,jjfin)
                           else
                               write(lo,500) sigma,dista,sigma1,allAt
                           endif
                        else if(jcod.gt.0) then
                           if (iflag6.eq.0) then
                               write(lo,9040)
                               iflag6 =1
                           endif
                           call shift(stringa12Tot_C(jbb),len)
                           if(len.gt.34) then
                               write(lo,3555) sigma,dista,sigma1,
     2			                   stringa12Tot_C(jbb)(1:31)//'...'
                           else
                               write(lo,3555) sigma,dista,sigma1,
     2			                   stringa12Tot_C(jbb)(1:34)
                           endif
                        endif
                    case (7)         ! site
                        if(jcod.le.0) then
                           if (iflag.eq.0) then
                               write(lo,60)
                               iflag =1
                           endif
                           jjfin = jp + 4 + natom - 1
                           jpp = jp + 4
                           write(lo,560) 
     *                            (aLab(nint(vres(jj))),jj=jpp,jjfin)
                        endif
                end select
            endif
            jp = jp + nparams + natom + incr
         enddo
      enddo
      write(lo,*)
!
   10 format(/,' on Distance  ESD    Distance   Atoms')
   20 format(/,' on Angle     ESD    Angle      Atoms')
   25 format(/,' on Tors.Ang. ESD    Angle      Atoms')
   30 format(/,' on Plane     ESD               Atoms')
   40 format(/,' on Sum       ESD    Parameters Atoms')
   50 format(/,' on Limit  ESD(x) ESD(B) ESD(bij) Atoms')
   60 format(/,' on Site      Atoms')
  100 format(10x,f9.5,f8.3,5x ,5a8,100(/,32x,5a8))
  200 format(10x,f9.5, 8x ,5x ,5a8,100(/,32x,5a8))
  300 format(10x,f9.5,1x,a12, 5a8,100(/,32x,5a8))
  350 format(10x,f9.5,1x,a,       100(/,32x,5a8))
  360 format(10x,f9.5,1x,2a)
  400 format(10x,f9.5, 8x ,5x ,a)
  500 format(10x,3f7.4        ,a)
  550 format(10x,3f7.4,     100(/,32x,5a8))
  560 format(14x,8(2x,a6))
  600 format(15(2x,a6))
!
    5 format(/,' List of',i4,' restraint(s)')
3535	format(4f10.4,2x,'planar restraint for atom ',a)
3542	format(3f10.4,e10.2,2x,a)
3555	format(3f10.4,12x,a)
3940	format(4f10.4,2x,a)
9038	format(/' Summary of restraint(s) ',a,' refinement')
9039  format(2x,'Observed',4x,'Target',5x,'Error',5x,'Sigma',
     2       2x,'Restraint')
9040  format(3x,'Sigma(x)',2x,'Sigma(B)',1x,'Sigma(bij)',10x,
     2          'Restraint')
      return
      end
!      
!---------------------------------------------------------
c
code for DistRestr
      subroutine DistRestr(jp,dist,df)
c--calcola distanza restraint
c  jp indirizzo del restraints 
c  dist distanza calcolata
c  df differenza con il target
c
c   vres(jp)               = restraint code
c   vres(jp+1)             = number of atoms involved
c   vres(jp+2)             = sigma
c   vres(jp+3)             = distance             if DISTANCE
c   vres(jp+4....)         = atoms codes          if DIST, ANGLE, PLANE
c      
      USE General
      USE Deprecato
      USE Atomi
      USE Molcom
      USE LsqModule
!
      dista = vres(jp+3)
      jj=jp+4
      m51=vres(jj)
      m52=vres(jj+1)
      n=1
      call xcd2pdMNQD(n,m51,m52)
      dist2=0.0
      do n=1,3
         dist2=dist2+temp(n)*temp(n+3)
      enddo
      dist2=0.5*dist2
      dist=sqrt(dist2)
      df=dista-dist
      return
      end
!      
!---------------------------------------------------------
c
code for AngleRestr
      subroutine AngleRestr(jp,ang,df)
c--calculate angle restraint
c  jp indirizzo del restraints 
c  ang angle in degrees (output)
c  df differenza con il target
!
c  angle in m52 :  m51--m52--m53
c		atom2--atom1--atom3
c  atom1 is the pivot atom
c
c  o  l12*l12	 (l12 = distance atom1-atom2)
c  p  l23*l23
c  q  l31*l31
c  r  l12*l12+l31*l31-l23*l23
c  s  l12
c  t  l23
c  u  l31
c  v  the anglein radians
c
c--after calculation
c  o  d(l12)/dp
c  p  d(l31)/dp
c  q  d(l23)/dp
c
      USE General
      USE Deprecato
      USE Atomi
      USE Molcom
      USE LsqModule
!      
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
c
      anga = vres(jp+3)
      jj=jp+4
      m51=vres(jj)
      m52=vres(jj+1)
      m53=vres(jj+2)
!      
      e=1.0
c--calculate the constants for l12
      n=1
      call xcd2pdMNQD(n,m52,m51)
c--calculate the distance
      o=0.0
      do n=1,3
         o=o+temp(n)*temp(n+3)
      enddo
      o=0.5*o
c--calculate the constants for l23
      n=7
      call xcd2pdMNQD(n,m51,m53)
c--calculate the distance
      p=0.0
      do n=7,9
         p=p+temp(n)*temp(n+3)
      enddo
      p=0.5*p
c--calculate the constants for l31
      n=13
      call xcd2pdMNQD(n,m53,m52)
c--calculate the distance
      q=0.0
      do n=13,15
         q=q+temp(n)*temp(n+3)
      enddo
      q=0.5*q
      r=o+q-p
c--calculate the bond lenghts
      s=sqrt(o+0.000001)
      t=sqrt(p+0.000001)
      u=sqrt(q+0.000001)
c--calculate the angle
      v=r/(2.0*s*u)
      if(abs(v).gt.1.0) v=sign(1.0,v)
      v=acos(v)
!      
      ang=v*rtod
      df=anga-ang
      return
      end
c
code for TorsRestr
      subroutine TorsRestr(jp,ang,df)
c--calculate valore of torsion angle
c  ang   = angolo di torsione 
c  sigma2=1/(sigma^2)
c  torsion angle :  m51--m52--m53--m54
c		          atom1--atom2--atom3--atom4
c
      USE General
      USE Deprecato
      USE Atomi
      USE Molcom
      USE LsqModule
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--                                                                     
      dimension xderiv(3,4)
c--
      anga  = vres(jp+3)
      jj=jp+4
      m51=vres(jj)
      m52=vres(jj+1)
      m53=vres(jj+2)
      m54=vres(jj+3)
      do n=1,3
         temp(n   ) = xyzs(n,m51)           
         temp(n+ 6) = xyzs(n,m52)
         temp(n+12) = xyzs(n,m53)
         temp(n+18) = xyzs(n,m54)
      enddo
      ideriv=0
      call torshn_with_derivativesMNQD(temp(1),temp(7),temp(13),
     2	       temp(19),ang,ideriv,xderiv)
c     
      ang=ang*rtod
      df=anga-ang
      return
      end
c
code for PlaneRestr
      subroutine PlaneRestr(jp,CoefPlane)
c--calculate distanze dal piano for planar restraints
c                                       
      USE General
      USE Atomi
      USE LsqModule
      USE LsqStuff22Abs
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
!      
      common/workc/ggwc(9),grwc(9),x1(6),x2(6),x3(6),x4(6),x5(6),
     1     x6(6),eval(3),eve(3,3),ever(3,3),
     2     ainer(3,3),vv(3),vr(3),
     3     caa(3,3),xb(3),varxb(3,3),
     4     ggbis(3,3),grbis(3,3),varian(4),l28,m28,md28,n28,lsqdummy(63)
!     
       dimension CoefPlane(4),CoefPlane_dev(4)
       character*8 aLabPqm
c--
      nats25 = nint(vres(jp+1))
      jj=jp+4
      do n=1,nats25
         m5=nint(vres(jj))
         Adr25to5(n)=m5
         aLab25(n)=aLab(m5)
         xyzs25(1:5,n) = xyzs(1:5,m5)           
         xyzs25_dev(1:3,n) = xyzs_dev(1:3,m5)
         jj=jj+1           
      enddo
!     call printnats25      
      call xpqmMNQD(ier)
      ind = 1
      aLabPqm='pqm1'
      vr(1) = ever(ind,1)
      vr(2) = ever(ind,2)
      vr(3) = ever(ind,3)
      call ospr(vr,xb,dd)
      CoefPlane(1:3)=ever(ind,1:3)
      CoefPlane(4)=dd
!      write(lo,'(a,2x,4f10.5)')aLabPqm(1:4),CoefPlane(1:4)
c---- calculate distances from the best plane
      do n=1,nats25
        x1(1:3)=xyzs25(1:3,n)
        call ospr (vr,x1,dfp)
        xyzs25(4,n)=dfp
!    	   call shift(aLab25(n),nn)
!        write(lo,'(a,2x,f10.4)')aLab25(n)(1:nn),dfp
      enddo     
      return
      end
c
code for SumRestr
      subroutine SumRestr(jp,sum)
c--calculate restraints of the sum of parameters
c                                       
      USE General
      USE Atomi
      USE LsqModule
      USE LsqStuff22Abs
!
      nats25 = nint(vres(jp+1))
      kpar   = nint(vres(jp+3))
      jj=jp+4
      jja=jj+kpar
      sum=0.0
      do n=1,nats25
         ka=nint(vres(jja))
         jj1=jj
         do m=1,kpar
            i=nint(vres(jj1))
            if(i.le.3) then 
               sum=sum+xyzs(i,ka)
            else if(i.eq.4) then
               sum=sum+bfac(ka)
            else if(i.le.10) then
               sum=sum+Bij(i-4,ka)
            else if(i.eq.11) then
               sum=sum+xyzs(5,ka)
            else if(i.le.15) then
               occs = amod(SiteInfo(i-11,ka),10.0)
               sum=sum+occs
            endif    
            jj1=jj1+1
         enddo  
         jja=jja+1           
      enddo
      return
      end
!
!--------------------------------------------------------------
c
code for xrestrMNQD
      subroutine xrestrMNQD
c--main routine to calculate derivatives for restraints
c
      USE General
      USE Atomi
      USE LsqModule
      USE LsqStuff22Abs
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
c==========================================
c--start the loop over the restraint(s)
c==========================================
      jp = 0
      do jy=1,nres
c
c--clear the partial derivative areas to zero
         DeriTot(:,:)=0
         jp = jp + 1
         icode = nint(vres(jp))
         natom = nint(vres(jp+1))
         incr=3
         if (icode.eq.5) then
             nparams = nint( vres(jp+3) )
         else
             nparams = 0
         endif
         if (icode.eq.6) incr=4
! 
         select case (icode)
c
c--dist restraint
            case (1)                 ! distances
               call DistRestrDer(jp,wdf)
c
c--angle restraint
            case (2)                 ! angle
               call AngleRestrDer(jp,wdf)
c
c--torsion restraint
            case (3)                 ! torsion angle
               call TorsRestrDer(jp,wdf)
c
c--planar restraint
            case (4)                 ! plane
               call PlaneRestrDer(jp)      ! chiama MnqdAccum
c
c--sum restraint
            case (5)                 ! sum
               call SumRestrDer(jp,wdf)
c
c--limit restraint
            case (6)                 ! limit
               call LimitRestrDer(jp,wdf)
c
c--site restraint
            case (7)                 ! site
!--non fa niente qui......               
         end select 
         if(icode.ne.4) call MnqdAccum(wdf)   ! accum normal equations  
         jp = jp + nparams + natom + incr
      enddo
!	call prtmtxMNQD
c--end of loop over the restraint(s)
      return
      end
c
code for DistRestrDer
      subroutine DistRestrDer(jp,wdf)
c--calculate derivatives for distance restraints
c                                       
      USE General
      USE Deprecato
      USE Atomi
      USE LsqModule
!
      dimension apd(19)
c--
      sigma = vres(jp+2)
      dista = vres(jp+3)
      jj=jp+4
      m51=vres(jj)
      m52=vres(jj+1)
      call DistRestr(jp,dist,df)
!      
      sigma2=1.0/(sigma*sigma)
      w=1.0
      if(NoRefl.eq.0) then
c	   w  =	slsq*slsq*sigma2
c	   w  =	0.001*	slsq*sigma2
         w  =   sqrt(slsq*sigma2)
      endif
c--compute the derivatives, apart from the multiplier
c--calculate the p.d. multiplier
      wdf=df*w
      rdist=0.5*w/dist
      if(NoTest.eq.1) then
         write(lo,3501)dist,dista,df
3501	   format(/,' dist: calc, defin, diff =',3f10.3)
         write(lo,3502)w,wdf,rdist
3502	   format(  ' sqrt(w) wdf rdist=',3f10.4)
         write(lo,3503)slsq,sigma2
3503	   format(  ' slsq  sigma2=',f7.3,e12.4)
      endif
c--calculate derivatives for the first atom
      n=1
      apd(:)=0.0
      call xadxyzMNQD(n,rdist,apd)
      if(NoTest.eq.1) then
         write(lo,3504)' g(i,j):',((xgg(i,j),j=1,3),i=1,3)
3504	   format(a,3f15.5,/,8x,3f15.5,/,8x,3f15.5)
         write(lo,3505)'diff:',temp(1:3)
3505	   format(a,3f15.5)
         write(lou,3505)'apd :',apd(1:3)
      endif
c--insert the derivative for atom1
      call xadpdMNQD(m51,apd)
c--calculate derivatives for atom2
      rdist=-rdist
      n=1
      apd(:)=0.0
      call xadxyzMNQD(n,rdist,apd)
c--insert the derivative for atom2
      call xadpdMNQD(m52,apd)
      return
      end
c
code for AngleRestrDer
      subroutine AngleRestrDer(jp,wdf)
c--calculate derivatives for angle restraints
c                                       
      USE General
      USE Atomi
      USE LsqModule
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
!--
      sigma = vres(jp+2)
      anga  = vres(jp+3)
      call AngleRestr(jp,ang,df)
!	
      sigma2= sigma*dtor
      sigma2=1.0/(sigma2*sigma2)
      w=1.0
      if(NoRefl.eq.0) then
c	   w  =	slsq*slsq*sigma2
c	   w  =	0.001*	slsq*sigma2
         w  =   sqrt(slsq*sigma2)
      endif
      if(NoTest.eq.1) then
         write(lo,3502)w
         write(lo,3503)slsq,sigma2
      endif
!      
      call xcapdMNQD(jp,w,ang)
      anga  = anga * dtor
      df=anga-ang
      wdf=df*w
      if(NoTest.eq.1) then
         write(lo,3501)ang,anga,df
         write(lo,3502)w,wdf
      endif
!
3501  format(/,' dist: calc, defin, diff =',3f10.3)
3502  format(  ' sqrt(w) wdf rdist=',3f10.4)
3503  format(  ' slsq  sigma2=',f7.3,e12.4)
      return
      end
c
code for TorsRestrDer
      subroutine TorsRestrDer(jp,wdf)
c--calculate derivatives for torsion restraints
c  anga  = angolo di torsione (radianti)
c  sigma2=1/(sigma^2)
c  torsion angle :  m51--m52--m53--m54
c		          atom1--atom2--atom3--atom4
c
      USE General
      USE Deprecato
      USE Atomi
      USE LsqModule
!
      dimension xderiv(3,4),madres(4) 
      dimension apd(19)
c--
      sigma = vres(jp+2)*dtor
      anga  = vres(jp+3)*dtor
c
      sigma2=1.0/(sigma*sigma)
      w=1.0
      if(NoRefl.eq.0) then
c	   w  =	slsq*slsq*sigma2
c	   w  =	0.001*	slsq*sigma2
         w  =   sqrt(slsq*sigma2)
      endif
      jj=jp+4
      m51=vres(jj)
      m52=vres(jj+1)
      m53=vres(jj+2)
      m54=vres(jj+3)
      temp(:)=0.0
      do n=1,3
         temp(n   ) = xyzs(n,m51)           
         temp(n+ 6) = xyzs(n,m52)
         temp(n+12) = xyzs(n,m53)
         temp(n+18) = xyzs(n,m54)
      enddo
      ideriv=1
      call torshn_with_derivativesMNQD(temp(1),temp(7),temp(13),
     2	       temp(19),ang,ideriv,xderiv)
      df=anga-ang
      wdf=df*w
c
      if(NoTest.eq.1) then
         write(lo,3502)w,wdf,df*rtod 
3502	 format(  ' sqrt(w) wdf df=',3f12.4)
         write(lo,3503)slsq,sigma2
3503	 format(  ' slsq  sigma2=',f7.3,e12.4)
      endif
c
      madres(1)=m51
      madres(2)=m52
      madres(3)=m53
      madres(4)=m54
      nn=3
      nn1=1
      do ia=1,4
         do n=1,3
            temp(n+nn)=xderiv(n,ia)
         enddo
         apd(:)=0.0
         call xadxyzMNQD(nn1,w,apd)
c--insert the derivative for n-esimo atom
         call xadpdMNQD(madres(ia),apd)
         nn1=nn1+6
         nn=nn+6
      enddo
      if(NoTest.eq.1) then
         write(lo,3501)ang*rtod,anga*rtod,df*rtod
3501	   format(/,' torsion: calc, defin, diff =',3f10.3)
         write(lo,3502)w,wdf
      endif
      return
      end
c
code for PlaneRestrDer
      subroutine PlaneRestrDer(jp)
c--calculate distanze dal piano for planar restraints
c                                       
      USE General
      USE Atomi
      USE LsqModule
      USE LsqStuff22Abs
!
      common/workc/ggg(9),ggr(9),x1(6),x2(6),x3(6),x4(6),x5(6),x6(6),
     2		eval(3),eve(3,3),ever(3,3),ainer(3,3),vv(3),vr(3),
     3		caa(3,3),xb(3),varxb(3,3),gg1(3,3),gr1(3,3),varian(4),
     4		l28,m28,md28,n28,lsqdummy(63)
!     
       dimension CoefPlane(4),CoefPlane_dev(4)
       character*8 aLabPqm
c
      dimension apd(19)
!      
      call PlaneRestr(jp,CoefPlane)  
      sigma = vres(jp+2)
      dista = vres(jp+3)
      sigma2=1.0/(sigma *sigma )
      w=1.0
      if(NoRefl.eq.0) then
c	   w  =	slsq*slsq*sigma2
c	   w  =	0.001*slsq*sigma2
         w  =   sqrt(slsq*sigma2)
      endif
!  
      do n=1,nats25
         DeriTot(:,:)=0
         apd(:)=0.0
         m5=Adr25to5(n)
         dfp=xyzs25(4,n)
         df=dista-dfp
         wdf=df*w
!	write(lo,*)'mnqd:',n,dista,dfp,df,sigma2,w,wdf,slsq
c--calculate the derivatives
         do j=1,3
            apd(j)=CoefPlane(j)*w
         enddo
!	write(lo,*)'apd:',apd(1:3)
c--insert the derivative for the current atom
         call xadpdMNQD(m5,apd)
         call  MnqdAccum(wdf)
      enddo
      return
      end
c
code for SumRestrDer
      subroutine SumRestrDer(jp,wdf)
c--calculate derivatives for restraints of the sum of parameters
c                                       
      USE General
      USE Atomi
      USE LsqModule
      USE LsqStuff22Abs
!
      dimension apd(19)
c--
      call SumRestr(jp,sum)
      nats25 = nint(vres(jp+1))
      kpar   = nint(vres(jp+3))
      sigma  = vres(jp+2)
      jj=jp+4
      jja=jj+kpar
      sigma2=1.0/(sigma *sigma )
      w=1.0
      if(NoRefl.eq.0) then
         w  =   sqrt(slsq*sigma2)
c--	   w=sqrt(sigma2)
      endif
      wdf=0.0
      do n=1,nats25
         ka=nint(vres(jja))
         jj1=jj
         apd(:)=0.0
         do m=1,kpar
            i=nint(vres(jj1))
            apd(i)=w
            jj1=jj1+1
         enddo  
         call AllParDer(ka,apd)
         jja=jja+1           
      enddo
      return
      end
c
code for LimitRestrDer
      subroutine LimitRestrDer(jp,wdf)
c--insert resistence to excessive shifts (restraints)
c
      USE General
      USE Atomi
      USE LsqModule
      USE LsqStuff
      USE LsqStuff22Abs
!
      dimension apd(19)
!
      natom = nint(vres(jp+1))
      sigma1 = 1.0/(vres(jp+2)*vres(jp+2))
      sigma2 = 1.0/(vres(jp+3)*vres(jp+3))
      sigma3 = 1.0/(vres(jp+4)*vres(jp+4))
      if(NoRefl.eq.0) then
         sigma1  =   sqrt(slsq*sigma1)
         sigma2  =   sqrt(slsq*sigma2)
         sigma3  =   sqrt(slsq*sigma3)
c--	   sigma1=sqrt(sigma2)
      endif
      jj=jp+5
      do n=1,natom
         apd(:)=0.0
         ka=nint(vres(jj))
         do i=1,nPar15
            if(i.le.3) then 
               apd(i)=sigma1
            else if(i.eq.4) then
               apd(i)=sigma2
            else if(i.le.10) then
               apd(i)=sigma3
            else if(i.eq.11) then
               apd(i)=sigma2
            else if(i.le.15) then
               apd(i)=sigma2
            endif    
         enddo  
         call AllParDer(ka,apd)
         jj =jj +1           
      enddo
      return
      end
!--------------------------------------------------
c
code for xcd2pdMNQD
      subroutine xcd2pdMNQD(n,m1par,m2par)
c--calculate the partial derivatives for the distance squared
c
      USE General
      USE Deprecato
      USE Atomi
      USE Molcom
      USE LsqModule
!
      n1=n
      n2=n-1
      do j=1,3
      temp(n1)=xyzs(j,m1par)-xyzs(j,m2par)
      n1=n1+1
      enddo
      do i=1,3
         temp(n1)=0.0
         do j=1,3
            temp(n1)=temp(n1 )+xgg(i,j)*temp(n2+j)*2.0
         enddo
         n1=n1+1
      enddo   
      return
      end
c
code for xadxyzMNQD
      subroutine xadxyzMNQD(n,rdist,apd)
c--calculate the derivatives for x, y and z
c
      USE General
      USE Deprecato
!
      dimension apd(19)
c--
      n1=n
      do j=1,3
         apd(j)=temp(n1+3)*rdist
         n1=n1+1
      enddo
      return
      end
c
code for xadpdMNQD
      subroutine xadpdMNQD(jy,apd)
c--insert the derivative for x,y,x of the atom
c
      USE General
      USE Atomi
      USE Molcom
!     
      USE LsqModule
      USE LsqStuff
      USE LsqStuff22
      USE LsqStuff22Abs
!
      dimension apd(19)
c--
      do k=1,3
         j=nParBl(k,jy)
         if(j.ne.0) then
            jw= nAddrDer(k,jy)
            w = iEquiv(k,1,jy)/1000.0
            DeriTot(j,jw)=DeriTot(j,jw)+apd(k)*w
         endif
      enddo
      return
      end
c
code for AllParDer
      subroutine AllParDer(jy,apd)
c--insert the derivative for all parameter of the atom
c
      USE General
      USE Atomi
      USE Molcom
!     
      USE LsqModule
      USE LsqStuff
      USE LsqStuff22
      USE LsqStuff22Abs
!
      dimension apd(19)
c--
      do k=1,nPar15
         j=nParBl(k,jy)
         if(j.ne.0) then
            jw= nAddrDer(k,jy)
            w = iEquiv(k,1,jy)/1000.0
            DeriTot(j,jw)=DeriTot(j,jw)+apd(k)*w
         endif
      enddo
      return
      end
!---------------------------------------------------------
c
code for xcapdMNQD
      subroutine xcapdMNQD(jp,www,ang)
c--calculate angle partial derivative
c  ang  angle in radians (output)
c  angle in m52 :  m51--m52--m53
c		atom2--atom1--atom3
c  atom1 is the pivot atom
c
c  o  l12*l12	 (l12 = distance atom1-atom2)
c  p  l23*l23
c  q  l31*l31
c  r  l12*l12+l31*l31-l23*l23
c  s  l12
c  t  l23
c  u  l31
c  v  the anglein radians
c
c--after calculation
c  o  d(l12)/dp
c  p  d(l31)/dp
c  q  d(l23)/dp
c
      USE General
      USE Atomi
      USE Molcom
      USE LsqModule
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
c
      dimension apd(19)
c
      jj=jp+4
      m51=vres(jj)
      m52=vres(jj+1)
      m53=vres(jj+2)
      ang=v
!      
      w=1.0/(2.0*o*q*sin(v))
c--calculate the partial derivatives for the bond lengths
      p=(r-q-q)*s*w
      o=(r-o-o)*u*w
      q=2.0*s*t*u*w
      d=0.5*e
c--calculate the derivative based on l31
      e=www*d*p/u
c--atom 3
      n=13
      apd(:)=0.0
      call xadxyzMNQD(n,e,apd)
      if(NoTest.eq.1) then
         write(ncwu,3505) 'rdist :',e
3505	   format(a,3f15.5)
         write(ncwu,3505) 'apd   :',apd(1:3)
      endif
c--insert the derivative for atom3
      call xadpdMNQD(m53,apd)
c--atom 1
      e=-e
      n=13
      apd(:)=0.0
      call xadxyzMNQD(n,e,apd)
c--insert the derivative for atom1
      call xadpdMNQD(m52,apd)
c--calculate the derivative based on l23
      e=www*d*q/t
c--atom 2
      n=7
      apd(:)=0.0
      call xadxyzMNQD(n,e,apd)
      if(NoTest.eq.1) then
         write(ncwu,3505) 'rdist :',e
         write(ncwu,3505) 'apd   :',apd(1:3)
      endif
c--insert the derivative for atom2
      call xadpdMNQD(m51,apd)
c--atom 3
      e=-e
      n=7
      apd(:)=0.0
      call xadxyzMNQD(n,e,apd)
c--insert the derivative for atom3
      call xadpdMNQD(m53,apd)
c--calculate the derivative based on l12
      e=www*d*o/s
c--atom 1
      n=1
      apd(:)=0.0
      call xadxyzMNQD(n,e,apd)
      if(NoTest.eq.1) then
         write(ncwu,3505) 'rdist :',e
         write(ncwu,3505) 'apd   :',apd(1:3)
      endif
c--insert the derivative for atom1
      call xadpdMNQD(m52,apd)
c--atom 2
      e=-e
      n=1
      apd(:)=0.0
      call xadxyzMNQD(n,e,apd)
c--insert the derivative for atom2
      call xadpdMNQD(m51,apd)
      return
      end
c
code for torshn_with_derivativesMNQD
      subroutine torshn_with_derivativesMNQD
     *               (x1,x2,x3,x4,tau,ideriv,xderiv)
c -----------------------------------------------
c              IA1        IA2        IA3      IA4
c               I3 - 1 -> I2  - 2 -> I1 - 3 -> I
      USE General
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension x1(3),x2(3),x3(3),x4(3),xtem(3)
      dimension dn1(3),dn2(3),wwr(3),dn1r(3),dn2r(3),dww(3)
      dimension dd1r(3),dd2r(3),dd3r(3)
      dimension uu(3),vv(3),ww(3),xtmat(3,3),ytmat(3,3)
      dimension xderiv(3,4),drdx(3)
      dimension dadp(3,3,4),dbdp(3,3,4),dwdp(3,3,4),dwmag(3,4)
      dimension dd1(3),dd2(3),dd3(3)
      dimension rm(3,3),rmi(3,3) 
      data small/0.0001/
c
c-------------------------------------------- 
c           
      do i=1,3
        do j=1,3
          xtmat(j,i)=0.0
          if(i.eq.j) xtmat(j,i)=1.0
        enddo
      enddo
c
      call vcmp (x1,x2,uu)
      call vcmp (x4,x3,vv)
      call vcmp (x3,x2,ww)
c	write(ncwu,'(a)')'x1,x2,x3,x4,uu,vv,ww'
c	write(ncwu,'(3f10.4)')x1,x2,x3,x4,uu,vv,ww
      call vpr(xgg9,uu,ww,dn1)
      call vpr(xgg9,vv,ww,dn2)
      call mv(xgr9,dn1,dn1r)
      call mv(xgr9,dn2,dn2r)
      call mv(xgg9,ww,dww)
      call ospr(ww,dww,wmag1)
      wmag=sqrt(wmag1)
      wmag=amax1(small, wmag )
c	write(ncwu,'(a)')'wmag ,dn1,dn2,dn1r,dn2r'
c	write(ncwu,'(f10.4)') wmag 
c 	write(ncwu,'(3f10.4)')dn1,dn2,dn1r,dn2r
C---- (A.CROSS.B).DOT.W = |A|*|B|*|W|*SIN(ANGLE)
      do j=1,3
        ytmat(1,j)=dn1r(j)
        ytmat(2,j)=dn2r(j)
        ytmat(3,j)=ww(j)
      enddo
      call dt3(ytmat,xdet)
      xs=xdet*volume
C---- (A.DOT.B)*|W| = |A|*|B|*|W|*COS(ANGLE)
      call ospr(dn1r,dn2,ee1)
      xc=ee1*wmag
c	write(ncwu,'(a)') 'ee1,xs,xc'
c	write(ncwu,'(3f10.5)') ee1,xs,xc
      if(xs.ne.0.0.or.xc.ne.0.0) then
        tau=atan2(xs,xc) 
      else
        tau=0.0
      endif
      if(tau.gt. pi) tau=tau-twopi
      if(tau.lt.-pi) tau=tau+twopi
c	write(ncwu,*) 'tau=',tau*rtod
c--
      if(ideriv.eq.0) return
c--
c--calcolo delle derivate
      dirden=amax1(small,(xs**2+xc**2))           
C----Compute partial derivatives of a, b and w w.r.t. parameters
      do ix=1,3
        do jx=1,3
          drdx(jx)=xtmat(jx,ix)
        enddo
c	write(ncwu,'(a,i5)')'drdx',ix
c	write(ncwu,'(3f10.4)') drdx
        call vpr(xgg9,drdx,ww,dd1r)
        call vpr(xgg9,uu,drdx,dd2r)
        call vpr(xgg9,vv,drdx,dd3r)
        call mv(xgr9,dd1r,dd1 )
        call mv(xgr9,dd2r,dd2 )
        call mv(xgr9,dd3r,dd3 )
c	write(ncwu,'(a)')'dd1 dd2 dd3,dd1r dd2r dd3r'
c	write(ncwu,'(3f10.4)') dd1,dd2,dd3
c	write(ncwu,'(3f10.4)') dd1r,dd2r,dd3r
        do jx=1,3
          dadp(jx,ix,1) =  dd1(jx)
          dadp(jx,ix,2) = -dd1(jx) - dd2(jx)
          dadp(jx,ix,3) =  dd2(jx)
c
          dbdp(jx,ix,2) = -dd3(jx)
          dbdp(jx,ix,3) =  dd3(jx) - dd1(jx)
          dbdp(jx,ix,4) =  dd1(jx)
c
          dwdp(jx,ix,2) =  -drdx(jx)
          dwdp(jx,ix,3) =  drdx(jx)
        enddo
c	write(ncwu,'(a)')'dadp,dbdp,dwdp'
c     write(ncwu,'(4(3f10.4,/),/)')((dadp(jx,ix,lx),jx=1,3),lx=1,4)
c     write(ncwu,'(4(3f10.4,/),/)')((dbdp(jx,ix,lx),jx=1,3),lx=1,4)
c     write(ncwu,'(4(3f10.4,/),/)')((dwdp(jx,ix,lx),jx=1,3),lx=1,4)
        dwmag(ix,3) = (dww(1)*drdx(1)+dww(2)*drdx(2)
     2 	  +dww(3)*drdx(3))/wmag
        dwmag(ix,2) = -dwmag(ix,3)
c	write(ncwu,'(a)') 'dwmag'
c	write(ncwu,'(3f10.4)') (dwmag(ix,jx),jx=1,3)
      enddo
c----compute derivatives from partials by the chain rule
      do ix=1,3
        do ia=1,4
          dsdp = 0.0
          dtdp = 0.0
          if(ia.ne.4) then
c
c....contribution of partials of dn1
            do jx=1,3
              ytmat(1,jx) = dadp(jx,ix,ia)
              ytmat(2,jx) = dn2r(jx)
              ytmat(3,jx) = ww(jx)
            enddo
c	write(ncwu,'(a,i5)') '1-ytmat',ia
c	write(ncwu,'(3f10.4)') ((ytmat(i,j),j=1,3),i=1,3)
            call dt3(ytmat,xdet)
            dsdp=xdet*volume
            adotb = (dadp(1,ix,ia)*dn2(1)+dadp(2,ix,ia)*dn2(2)+
     2                                    dadp(3,ix,ia)*dn2(3))
            dtdp = adotb*wmag
c	write(ncwu,'(a)')'dsdp,adotb,dtdp'
c     write(ncwu,'(3f10.4)')dsdp,adotb,dtdp 
            if(ia.eq.1) goto 95
          endif
c
c....contribution of partials of dn2
          do  jx=1,3  
            ytmat(1,jx) = dn1r(jx)
            ytmat(2,jx) = dbdp(jx,ix,ia)
            ytmat(3,jx) = ww(jx)
          enddo
c	write(ncwu,'(a,i5)') '2-ytmat',ia
c	write(ncwu,'(3f10.4)') ((ytmat(i,j),j=1,3),i=1,3)
          call dt3(ytmat,xdet)
          dsdp1=xdet*volume
          dsdp = dsdp + dsdp1
          adotb = (dbdp(1,ix,ia)*dn1(1)+dbdp(2,ix,ia)*dn1(2)+
     2                                  dbdp(3,ix,ia)*dn1(3))
          dtdp = dtdp + adotb*wmag
c	write(ncwu,'(a)')'dsdp,adotb,dtdp'
c     write(ncwu,'(3f10.4)')dsdp,adotb,dtdp 
          if(ia.ne.4) then
c
c....contribution of partials of ww
            do  jx=1,3  
              ytmat(1,jx) = dn1r(jx)
              ytmat(2,jx) = dn2r(jx)
              ytmat(3,jx) = dwdp(jx,ix,ia) 
            enddo
c	write(ncwu,'(a,i5)') '3-ytmat',ia
c	write(ncwu,'(3f10.4)') ((ytmat(i,j),j=1,3),i=1,3)
            call dt3(ytmat,xdet)
            dsdp1=xdet*volume
            dsdp = dsdp + dsdp1
            dtdp = dtdp + (xc/wmag)*dwmag(ix,ia)
c	write(ncwu,'(a)')'dsdp,adotb,dtdp'
c     write(ncwu,'(3f10.4)')dsdp,adotb,dtdp 
          endif
C
C....complete derivative
   95     continue  
          xderiv(ix,ia) = (xc*dsdp-xs*dtdp)/dirden
        enddo
      enddo
c	write(ncwu,'(a)')'xderiv'
c	write(ncwu,'(3f10.4)')((xderiv(ix,ia),ix=1,3),ia=1,4)
      return
      end
!==============================================================
!  routine per lista 12 (vettori SIR)      
!==============================================================
c
code for check_speciesMnqd
      subroutine check_speciesMnqd(irigx,ihy3,ihy2)
c--set codici per le specie atomiche b c n o
c--ihy3 0/1 se la lista 3 no/si contiene H
c--ihy2 0/1 se la lista 5 no/si contiene H
c
      USE General
      USE Atomi
!
      dimension irigx(4)
c--
      character*4 irignc(4) 
      data irignc /'b','c','n','o'/
c	
c--read the atomic species
      irigx(:)=0
      ihy2=0
      ihy3=0
      if(neutro.eq.1) return
      do i=1,nk
         call lcase(Species(i))
         if(no(i).eq.1) ihy3=1
         do j=1,4
            if(Species(i).eq.irignc(j)) irigx(j)=i
         enddo
      enddo
c--controllo se le specie stomiche sono presenti in lista 5
      do j=1,4
         icode=0
         if(irigx(j).gt.0) then
            do i=1,nats
               ksp=nzTot(i)
               if(ksp.eq.irigx(j))then
                  icode=1
                  exit
               endif
            enddo
            if(icode.eq.0)irigx(j)=0 
         endif
      enddo  
c--check if H atoms are present in list 5
      do i=1,nats
         ksp=nzTot(i)
         if (ksp > 0) then
             if (no(ksp).eq.1) ihy2=1
         endif
      enddo
c--end of analysis
      return
      end
!------------------------------------------------------------------
!--new version of routines for list 68
!------------------------------------------------------------------
c
code for CalcolaLimitData
      subroutine CalcolaLimitData(iLim)
!------------------------------------------------
!--creazione dei limiti reflessi (totali) data
!  iLim = 1  tutti i dati
!         2  osservati per MNQD (criterio pesaggio)
!         3  osservati ed esclusi per Agreement
!------------------------------------------------
!
      USE General
      USE Atomi
      USE Riflessi
      USE RiflessiNew
      USE Limits
      USE LsqModule
!
      dimension ihx(3)
!            
      TempMinLim =  ModLimit(10000, 10000.0,10000.0,10000.0,
     *                  10000.0,10000.0,10000.0,10000.0,10000.0,10000.0,
     *                  10000.0,10000.0)
      TempMaxLim =  ModLimit(-10000,-10000.0,-10000.0,
     *                  -10000.0,-10000.0,-10000.0,-10000.0,-10000.0,
     *                  -10000.0,-10000.0,-10000.0,-10000.0)
!     
      if(iLim.eq.1) then
         HLimitMin(1:3)= 10000 
         HLimitMax(1:3)= -10000
      endif   
!
      do i=1,nreflTot
!--trova i minimi e i massimi 
         ihx(1:3)= refl%hkl(1:3, i)
         if(iLim.eq.1) call inmxeqMNQD(ihx)
         obsCode = refl%observed(i)
         if (obsCode /= 0 .and. iLim == 2) cycle
         if (obsCode == 1 .and. iLim == 3) cycle
         fo = refl%fo(i)                                       ! Fo
         fo2 = refl%fosq(i) 
         rh = refl%rho(i)                                      ! Fo**2
!--calculate resolution 
         ss=sqrt(rh)
!   ld = 2d.sin{th}      
!   d  = ld / 2.sin(th)
         re=0.5/ss
!         
!--2theta
         b=0.0
         if(wavel.gt.0.2.and.wavel.lt.2.5) then
            a=ss*wavel
            b=2.0*asin(a)*rtd
         endif
         fc=0.0
         fofc=0.0   
         r=0.0                         
         p=0.0
         p2=0.0
         if(rflsq.gt.0.0.and.rflsq.lt.100.) then
            fc = refl%fc(i)*abs(FcScale)  
            fofc=fo/fc    
            r=abs(fo-fc)/fo                         
            fc2 = refl%fc(i)*abs(FcScale)  * refl%fc(i)*abs(FcScale)   
            p=(fo+2.0*fc)/3.0
            p2=(fo2+2.0*fc2)/3.0
         endif
         do j=1,3
            TempMinLim%HKL(j) = min0(TempMinLim%HKL(j),ihx(j))
            TempMaxLim%HKL(j) = max0(TempMaxLim%HKL(j),ihx(j))
         enddo
c
         TempMinLim%Fo =amin1(TempMinLim%Fo,fo)
         TempMaxLim%Fo =amax1(TempMaxLim%Fo,fo)
         TempMinLim%Fo2 =amin1(TempMinLim%Fo2,fo2)
         TempMaxLim%Fo2 =amax1(TempMaxLim%Fo2,fo2)
c         
         TempMinLim%Resol =amin1(TempMinLim%Resol,re)
         TempMaxLim%Resol =amax1(TempMaxLim%Resol,re)
c
         TempMinLim%Rho =amin1(TempMinLim%Rho,rh)
         TempMaxLim%Rho =amax1(TempMaxLim%Rho,rh)
         TempMinLim%Rhoroot =amin1(TempMinLim%Rhoroot,ss)
         TempMaxLim%Rhoroot =amax1(TempMaxLim%Rhoroot,ss)
!--2theta
         TempMinLim%Th2 =amin1(TempMinLim%Th2,b)
         TempMaxLim%Th2 =amax1(TempMaxLim%Th2,b)
!         
         TempMinLim%Fc =amin1(TempMinLim%Fc,fc)
         TempMaxLim%Fc =amax1(TempMaxLim%Fc,fc)
         TempMinLim%FoFc =amin1(TempMinLim%FoFc,fofc)
         TempMaxLim%FoFc =amax1(TempMaxLim%FoFc,fofc)
         TempMinLim%R =amin1(TempMinLim%R,r)
         TempMaxLim%R =amax1(TempMaxLim%R,r)
         TempMinLim%P =amin1(TempMinLim%P,p)
         TempMaxLim%P =amax1(TempMaxLim%P,p)
         TempMinLim%P2 =amin1(TempMinLim%P2,p2)
         TempMaxLim%P2 =amax1(TempMaxLim%P2,p2)
!
      enddo     
!
      TempMinLim%Fo=TempMinLim%Fo-0.001*TempMinLim%Fo 
      TempMaxLim%Fo=TempMaxLim%Fo+0.001*TempMaxLim%Fo 
      TempMinLim%Rho=TempMinLim%Rho-0.001*TempMinLim%Rho
      TempMaxLim%Rho=TempMaxLim%Rho+0.001*TempMaxLim%Rho
      TempMinLim%Fc=TempMinLim%Fc-0.001*TempMinLim%Fc
      TempMaxLim%Fc=TempMaxLim%Fc+0001*TempMaxLim%Fc
      TempMinLim%FoFc=TempMinLim%FoFc-0.001*TempMinLim%FoFc 
      TempMaxLim%FoFc=TempMaxLim%FoFc+0.001*TempMaxLim%FoFc 
      TempMinLim%R=TempMinLim%R-0.001*TempMinLim%R 
      TempMaxLim%R=TempMaxLim%R+0.001*TempMaxLim%R 
      TempMinLim%Th2=TempMinLim%Th2-0.001*TempMinLim%Th2
      TempMaxLim%Th2=TempMaxLim%Th2+0.001*TempMaxLim%Th2
      TempMinLim%Resol=TempMinLim%Resol-0.001*TempMinLim%Resol
      TempMaxLim%Resol=TempMaxLim%Resol+0.001*TempMaxLim%Resol
      TempMinLim%P=TempMinLim%P-0.001*TempMinLim%P
      TempMaxLim%P=TempMaxLim%P+0.001*TempMaxLim%P
      TempMinLim%P2=TempMinLim%P2-0.001*TempMinLim%P2
      TempMaxLim%P2=TempMaxLim%P2+0.001*TempMaxLim%P2
      TempMinLim%Fo2=TempMinLim%Fo2-0.001*TempMinLim%Fo2
      TempMaxLim%Fo2=TempMaxLim%Fo2+0.001*TempMaxLim%Fo2
      TempMinLim%Rhoroot=TempMinLim%Rhoroot-0.001*TempMinLim%Rhoroot
      TempMaxLim%Rhoroot=TempMaxLim%Rhoroot+0.001*TempMaxLim%Rhoroot
!
      return
      end
!---------------------------------------------------------------------
      subroutine inmxeqMNQD(ihx)
!--trova gli indici massimi e minimi (assoluti)
!      
      USE General
      USE Symmetry
      USE Riflessi
      USE Limits
! 
      dimension ihx(3)
      do n=1,nsym
         do j=1,3
            ihxS = 0
            do i=1,3 
               ihxS = ihxS+ ihx(i) * kmat(n,i,j)
            enddo
            ihxS = iabs(ihxS)
            HLimitMax(j) = max0(HLimitMax(j),ihxS)
            HLimitMin(j) = min0(HLimitMin(j),ihxS)
         enddo
      enddo         
      return
      end
c
code for PutGetLimit
      subroutine PutGetLimit(iAction)
!--scrive e legge su jdir i limiti dei riflessi
!  (nuovo meccanismo)
!
      USE General
      USE Limits
!      
      if (iAction == 1) then
!      
         write(jdir)infoOK(68),HLimitMin(1:3),HLimitMax(1:3),NumOmit,
     *               VetClassiParita(1:TotClassiParita),
     *               CodeLimit(1:NumLimit)     
!    
         if(infoOK(68).eq.1) then 
            write(jdir)AgreMinLim%HKL(1:3), 
     *               AgreMaxLim%HKL(1:3),
     *               AgreMinLim%Fo,
     *               AgreMaxLim%Fo,
     *               AgreMinLim%Fo2,
     *               AgreMaxLim%Fo2,        
     *               AgreMinLim%Resol,
     *               AgreMaxLim%Resol,
     *               AgreMinLim%Rho,
     *               AgreMaxLim%Rho,
     *               AgreMinLim%Rhoroot,
     *               AgreMaxLim%Rhoroot,
     *               AgreMinLim%Th2,
     *               AgreMaxLim%Th2,
     *               AgreMinLim%Fc,
     *               AgreMaxLim%Fc,
     *               AgreMinLim%FoFc,
     *               AgreMaxLim%FoFc,
     *               AgreMinLim%R,
     *               AgreMaxLim%R,
     *               AgreMinLim%P,
     *               AgreMaxLim%P,
     *               AgreMinLim%P2,
     *               AgreMaxLim%P2
!
            write(jdir)UserMinLim%HKL(1:3), 
     *               UserMaxLim%HKL(1:3),
     *               UserMinLim%Fo,
     *               UserMaxLim%Fo,
     *               UserMinLim%Fo2,
     *               UserMaxLim%Fo2,        
     *               UserMinLim%Resol,
     *               UserMaxLim%Resol,
     *               UserMinLim%Rho,
     *               UserMaxLim%Rho,
     *               UserMinLim%Rhoroot,
     *               UserMaxLim%Rhoroot,
     *               UserMinLim%Th2,
     *               UserMaxLim%Th2,
     *               UserMinLim%Fc,
     *               UserMaxLim%Fc,
     *               UserMinLim%FoFc,
     *               UserMaxLim%FoFc,
     *               UserMinLim%R,
     *               UserMaxLim%R,
     *               UserMinLim%P,
     *               UserMaxLim%P,
     *               UserMinLim%P2,
     *               UserMaxLim%P2
!
            write(jdir)DataMinLim%HKL(1:3), 
     *               DataMaxLim%HKL(1:3),
     *               DataMinLim%Fo,
     *               DataMaxLim%Fo,
     *               DataMinLim%Fo2,
     *               DataMaxLim%Fo2,        
     *               DataMinLim%Resol,
     *               DataMaxLim%Resol,
     *               DataMinLim%Rho,
     *               DataMaxLim%Rho,
     *               DataMinLim%Rhoroot,
     *               DataMaxLim%Rhoroot,
     *               DataMinLim%Th2,
     *               DataMaxLim%Th2,
     *               DataMinLim%Fc,
     *               DataMaxLim%Fc,
     *               DataMinLim%FoFc,
     *               DataMaxLim%FoFc,
     *               DataMinLim%R,
     *               DataMaxLim%R,
     *               DataMinLim%P,
     *               DataMaxLim%P,
     *               DataMinLim%P2,
     *               DataMaxLim%P2
!     
            if(NumOmit.gt.0) then 
               do n=1,NumOmit
                  write(jdir) VetOmit(:,n)
               enddo
            endif 
         endif
!
      else
         read(jdir) infoOK68,HLimitMin(1:3),HLimitMax(1:3),NumOmit,
     *               VetClassiParita(1:TotClassiParita),
     *               CodeLimit(1:NumLimit)
!     
         if(infoOK68.eq.1) then
            read(jdir) AgreMinLim%HKL(1:3), 
     *               AgreMaxLim%HKL(1:3),
     *               AgreMinLim%Fo,
     *               AgreMaxLim%Fo,
     *               AgreMinLim%Fo2,
     *               AgreMaxLim%Fo2,        
     *               AgreMinLim%Resol,
     *               AgreMaxLim%Resol,
     *               AgreMinLim%Rho,
     *               AgreMaxLim%Rho,
     *               AgreMinLim%Rhoroot,
     *               AgreMaxLim%Rhoroot,
     *               AgreMinLim%Th2,
     *               AgreMaxLim%Th2,
     *               AgreMinLim%Fc,
     *               AgreMaxLim%Fc,
     *               AgreMinLim%FoFc,
     *               AgreMaxLim%FoFc,
     *               AgreMinLim%R,
     *               AgreMaxLim%R,
     *               AgreMinLim%P,
     *               AgreMaxLim%P,
     *               AgreMinLim%P2,
     *               AgreMaxLim%P2
!
            read(jdir) UserMinLim%HKL(1:3), 
     *               UserMaxLim%HKL(1:3),
     *               UserMinLim%Fo,
     *               UserMaxLim%Fo,
     *               UserMinLim%Fo2,
     *               UserMaxLim%Fo2,        
     *               UserMinLim%Resol,
     *               UserMaxLim%Resol,
     *               UserMinLim%Rho,
     *               UserMaxLim%Rho,
     *               UserMinLim%Rhoroot,
     *               UserMaxLim%Rhoroot,
     *               UserMinLim%Th2,
     *               UserMaxLim%Th2,
     *               UserMinLim%Fc,
     *               UserMaxLim%Fc,
     *               UserMinLim%FoFc,
     *               UserMaxLim%FoFc,
     *               UserMinLim%R,
     *               UserMaxLim%R,
     *               UserMinLim%P,
     *               UserMaxLim%P,
     *               UserMinLim%P2,
     *               UserMaxLim%P2
!
            read(jdir) DataMinLim%HKL(1:3), 
     *               DataMaxLim%HKL(1:3),
     *               DataMinLim%Fo,
     *               DataMaxLim%Fo,
     *               DataMinLim%Fo2,
     *               DataMaxLim%Fo2,        
     *               DataMinLim%Resol,
     *               DataMaxLim%Resol,
     *               DataMinLim%Rho,
     *               DataMaxLim%Rho,
     *               DataMinLim%Rhoroot,
     *               DataMaxLim%Rhoroot,
     *               DataMinLim%Th2,
     *               DataMaxLim%Th2,
     *               DataMinLim%Fc,
     *               DataMaxLim%Fc,
     *               DataMinLim%FoFc,
     *               DataMaxLim%FoFc,
     *               DataMinLim%R,
     *               DataMaxLim%R,
     *               DataMinLim%P,
     *               DataMaxLim%P,
     *               DataMinLim%P2,
     *               DataMaxLim%P2
!     
            if(NumOmit.gt.0) then 
               do n=1,NumOmit
                  read(jdir) VetOmit(:,n)
               enddo
            endif 
            infoOK(68)=1
         endif
!
      endif
!      
      return
      end
c
code for PrintLimit                                                           
      subroutine PrintLimit(ncwux)
c--print limit of reflections
c  DA CONTROLLARE!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!                           
c  code = -1 / 0 / 1
c  se -1 condizione da non applicare
c      0 condizione internal
c      1 condizione external
c                                        
      USE General
      USE Limits
!
      character*21 jb1(14)
      character*8 extch(3)
      character*4 iclassch(33)
!--      
      data iclassch/'ggg ','ggu ','gug ','guu ','ugg ','ugu ',
     1'uug ','uuu ','h00 ','0k0 ','hk0 ','00l ','h0l ','0kl ',
     1'hkl ','g00 ','u00 ','0g0 ','0u0 ','gk0 ','uk0 ',
     1'hg0 ','hu0 ','00g ','00u ','g0l ','u0l ','h0g ','h0u ',
     1'0gl ','0ul ','0kg ','0ku '/
c--
!-- nella finestra di Sir
!   1   [Sin(Theta)/Lambda]^2
!   2   2 Theta
!   3   Resol.
!   4   Fo
!   5   Fc
!   6   Fo/Fc
!   7   (Fo-Fc)/Fo
!   8   h
!   9   k
!  10   l
!  aggiunti
!   :: P             ! 11 (fo+2*fc)/3
!   :: P2            ! 12 (fo2+2*fc2)/3
!   :: Fo2           ! 13 fo2
!   :: Rhoroot       ! 14 (sin(th)/lamda)
      data extch/'not used','internal','external'/
      data jb1/
     5	         '[Sin(Theta)/Lambda]^2',
     9	         '        2Theta       ',
     *	         '      Resolution     ',
     4	         '          Fo         ',
     6	         '          Fc         ',
     7	         '         Fo/Fc       ',
     8	         '     Abs(Fo-Fc)/Fo   ',
     1           '           h         ',
     2	         '           k         ',
     3	         '           l         ',
     4	         '      (Fo+2*Fc)/3    ',
     4	         '    (Fo^2+2*Fc^2)/3  ',
     4	         '          Fo^2       ',
     5	         '   Sin(Theta)/Lambda '/
c--
      if(infoOK(68).eq.0) then
         write(ncwux,1000)
1001     format(/,' Warning!: Limit values not calculated!')
         return
      endif
      Write(ncwux,930)
930   Format(/,' Limit values of the data',/)      
      write(ncwux,920)  HLimitMax
920   format(' Max of equivalent indicies : ',3i4)
      write(ncwux,1000)
1000  format(' General conditions :')
      write(ncwux,1100)              
1100  format(  33x,' observed',19x,' user defined',11x,'code',/,
     2 18x,2(10x,5h min.,10x,5h max.) )
      icode=CodeLimit(1)+2
      write(ncwux,1210) jb1(1),DataMinLim%Rho,DataMaxLim%Rho,
     *              AgreMinLim%Rho,AgreMaxLim%Rho,extch(icode)
      icode=CodeLimit(2)+2
      write(ncwux,1220) jb1(2),DataMinLim%Th2,DataMaxLim%Th2,
     *              AgreMinLim%Th2,AgreMaxLim%Th2,extch(icode)
1220   format(1x,a21,4(f12.2,3x),2x,a)
      icode=CodeLimit(3)+2
      write(ncwux,1220) jb1(3),DataMinLim%Resol,DataMaxLim%Resol,
     *              AgreMinLim%Resol,AgreMaxLim%Resol,extch(icode)
      icode=CodeLimit(4)+2
      write(ncwux,1210) jb1(4),DataMinLim%Fo,DataMaxLim%Fo,
     *              AgreMinLim%Fo,AgreMaxLim%Fo,extch(icode)
      icode=CodeLimit(5)+2
      write(ncwux,1210) jb1(5),DataMinLim%Fc,DataMaxLim%Fc,
     *              AgreMinLim%Fc,AgreMaxLim%Fc,extch(icode)
      icode=CodeLimit(6)+2
      write(ncwux,1210) jb1(6),DataMinLim%FoFc,DataMaxLim%FoFc,
     *              AgreMinLim%FoFc,AgreMaxLim%FoFc,extch(icode)
      icode=CodeLimit(7)+2
      write(ncwux,1210) jb1(7),DataMinLim%R,DataMaxLim%R,
     *              AgreMinLim%R,AgreMaxLim%R,extch(icode)
1210  format(1x,a21,4f15.5,2x,a)
      do j=1,3  
         icode=CodeLimit(7+j)+2
         write(ncwux,1211) jb1(7+j),DataMinLim%HKL(j),DataMaxLim%HKL(j),
     *              AgreMinLim%HKL(j),AgreMaxLim%HKL(j),extch(icode)
1211     format(1x,a21,4(i11,4x),2x,a)
      enddo
      icode=CodeLimit(11)+2
      write(ncwux,1210) jb1(11),DataMinLim%P,DataMaxLim%P,
     *              AgreMinLim%P,AgreMaxLim%P,extch(icode)
      icode=CodeLimit(12)+2
      write(ncwux,1210) jb1(12),DataMinLim%P2,DataMaxLim%P2,
     *              AgreMinLim%P2,AgreMaxLim%P2,extch(icode)
      icode=CodeLimit(13)+2
      write(ncwux,1210) jb1(13),DataMinLim%Fo2,DataMaxLim%Fo2,
     *              AgreMinLim%Fo2,AgreMaxLim%Fo2,extch(icode)
      icode=CodeLimit(14)+2
      write(ncwux,1210) jb1(14),DataMinLim%Rhoroot,DataMaxLim%Rhoroot,
     *              AgreMinLim%Rhoroot,AgreMaxLim%Rhoroot,extch(icode)
!
      do i=1,TotClassiParita
         if(VetClassiParita(i).eq.1) then
            write(ncwux,3110) iclassch(i)
3110        format(' Omit the reflection class: ',a4)
         endif
      enddo
      if(NumOmit.gt.0) then
         do i=1,NumOmit
            write(ncwux,3120) (VetOmit(j,i),j=1,3)
3120        format(' Omit the reflection : ',3i5)
         enddo
      endif
!
      write(ncwux,"(' ')")
      return
      end
!             
!------------------------------------------------------------------
!--new version of routines for list 62  (ex 12)
!------------------------------------------------------------------
c
code for PutGetRefi
      subroutine PutGetRefi(iAction)
!--scrive e legge su jdir condizioni per l'affinamento
!  (nuovo meccanismo)
!
      USE General
      USE LsqModule
      USE LsqStuff12
      USE LsqStuff12_RT
      USE LsqStuff12_byUser
      USE LsqRestraint
!      
      if (iAction == 1) then
! 
         if (nres.gt.0) then
            call RestraintToDiret(ier)
         else   
            NumRestraint=0
         endif      
!      
         write(jdir) NumCond12,NumBlock12,NumRestr12,
     *               NumCond12_byUser,NumRestraint
!--scrivo condizioni per G.S.     
         if(infoOK(62).eq.1) then
            do i=1,NumCond12
               write(jdir) idir12(i)
            enddo
            do i=1,NumCond12
               write(jdir) stringa12Tot(i) 
            enddo
         endif
!--scrivo condizioni definite dall'utente         
         if(NumCond12_byUser.gt.0) then
            do i=1,NumCond12_byUser
               write(jdir) idir12_byUser(i)
            enddo
            do i=1,NumCond12_byUser
               write(jdir) stringa12_byUser(i) 
            enddo
         endif
!--scrivo restraint
         if(NumRestraint.gt.0) then
            do i=1,NumRestraint
               write(jdir) idirRestraint(i)
            enddo
            do i=1,NumRestraint
               write(jdir) stringaRestraint(i) 
            enddo
         endif
!         
      else
!      
         read(jdir) NumCond12,NumBlock12,NumRestr12,
     *               NumCond12_byUser,NumRestraint
!
         infoOK(62)=0
!--leggo condizioni per G.S.            
         if(NumCond12.gt.0) then
            call AllocaLsqStuff12(2)
            call AllocaLsqStuff12(1)
            do i=1,NumCond12
               read(jdir) idir12(i)
            enddo
            do i=1,NumCond12
               read(jdir) stringa12Tot(i) 
            enddo
!           call PrintRefi(lo)
            infoOK(62)=1
            NumCond12_Sav=NumCond12   
            call AllocaLsqStuff12_Sav(2)
            call AllocaLsqStuff12_Sav(1)
         endif
!--leggo condizioni definite dall'utente
         if(NumCond12_byUser.gt.0) then
            call AllocaLsqStuff12_byUser(2)
            call AllocaLsqStuff12_byUser(1)
            do i=1,NumCond12_byUser
               read(jdir) idir12_byUser(i)
            enddo
            do i=1,NumCond12_byUser
               read(jdir) stringa12_byUser(i) 
            enddo
!            call PrintRefi_RT(lo)
         endif
!--leggo restraint
         if(NumRestraint.gt.0) then
            call AllocaLsqRestraint(2)
            call AllocaLsqRestraint(1)
            do i=1,NumRestraint
               read(jdir) idirRestraint(i)
            enddo
            do i=1,NumRestraint
               read(jdir) stringaRestraint(i) 
            enddo
            call CreaRestraintFromDiret(ier)
!           call PrintRestraint(-1)
         endif
!
         if(infoOK(62).eq.0) then
!--creo default condizioni affinamento         
            call DefaultRefi(2,ier)
            if(ier.lt.0) then
               write(lo,*)' Error(a) list 62 from sub PutGetRefi!'
               return
            endif
            infoOK(62)=1
         endif
!         
      endif        
!  
      return
      end
c
code for PrintRefi                                                           
      subroutine PrintRefi(ncwux)
c--print condizioni affinamento (ex sw12)
c  directive codes: 1 diag
c                   2 full
c                   3 block
c                   4 plus
c                   5 fix
c                   6 weight  --> factor
c                   7 equiv
c                   8 ride
c                   9 end
c		           10 fixed -> 5
c		           11 dist
c		           12 angle
c		           13 torsion
c		           14 planar
c		           15 sum
c		           16 continue
c		           17 limit
c		           18 group
c                  19 rotamer
!                  20 site
!                  21 disorder
c                                                                       
      USE General
      USE LsqStuff12
!      
      if(NumCond12.le.0) then
         write(ncwu,1000)
1000     format(/,' Warning!: ',
     *            'No Conditions for the refinement provided!')
         return
      endif
!--      
      write(ncwux,1010) NumCond12
1010  format(' Conditions for the refinement',i5)
      if(NumBlock12.lt.0) then
         write(ncwux,1012)
1012     format(' No. of block(s) equal no. of atom(s) plus one')
      else
         write(ncwux,1011) NumBlock12
1011     format(' No. of block(s)',14x,i5)
      end if
      write(ncwux,1014) NumRestr12
1014  format(' No. di restraint(s)',10x,i5)
      do k=1,NumCond12
         call shift(stringa12Tot(k),l1)
         write(ncwux,'(i4,2a)')k,') ',stringa12Tot(k)(1:l1)
      enddo
      write(ncwux,"(' ')")
      return
      end
c
code for PrintRefi_RT                                                           
      subroutine PrintRefi_RT(ncwux)
c--print condizioni affinamento RunTime
c                                                                       
      USE General
      USE LsqStuff12
      USE LsqStuff12_RT
!      
      if(NumCond12_C.le.0) then
         write(ncwu,1000)
1000     format(/,' Warning!: ',
     *            'No Run Time Conditions for the refinement provided!')
         return
      endif
!--      
      write(ncwux,1010) NumCond12_C
1010  format(' Run Time Conditions for the refinement',i5)
      if(NumBlock12.lt.0) then
         write(ncwux,1012)
1012     format(' No. of block(s) equal no. of atom(s) plus one')
      else
         write(ncwux,1011) NumBlock12
1011     format(' No. of block(s)',14x,i5)
      end if
      write(ncwux,1014) NumRestr12
1014  format(' No. di restraint(s)',10x,i5)
      do k=1,NumCond12_C
         call shift(stringa12Tot_C(k),l1)
         write(ncwux,'(i4,2a)')k,') ',stringa12Tot_C(k)(1:l1)
      enddo
      write(ncwux,"(' ')")
      return
      end
!
!code for DefaultRefi
      subroutine DefaultRefi(in1,ier)
!--form default list 62
!--in=1/2  diag/full
!--check if multiple site are present      
!--check for bidimensional data
!
      USE General
      USE Symmetry
      USE Atomi
      USE LsqStuff
      USE LsqStuff12
      USE LsqModule
!     
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension xo(11),xn(11),key(10)
!--
      character*4 dirch
      dimension kyp(3)
      dimension irigx(4)
!      
      character*80 bufferch
      character*1 ixyzch(3)
      character*4 isumch,iendch,ifullc(2),ifixch
      character*9 irigch(4) 
      character*12 ifxhch 
      character*20 buffer
c      
      data ixyzch /'x','y','z'/  
      data isumch /'sum '/
      data iendch /'end '/
      data ifixch /'fix '/
      data ifxhch /'fix h b[iso]'/
c                   123456789012
      data ifullc /'diag','full'/
      data irigch /'ride  b h',
     1             'ride  c h',
     2             'ride  n h',
     3             'ride  o h'/
!      
      ier=0
      in=in1
      if(in1.eq.3) in=2
!-------------apro file scratch 
      call x62start(jbb,ier)
      if(ier.eq.-1) return
c--in=1/2  full/diag
c--check the atomic species
      call check_speciesMnqd(irigx,ihy3,ihy2)
c--check if multiple site are present      
      nPar15=11
      do i=1,nats
         if(iSite(i).gt.0) then
            nPar15=15
            exit
         endif
      enddo
      jbb=jbb+1
      bufferch=ifullc(in)
      write(ncpu,'(a80)') bufferch
c--controllo atomi in posizioni speciali	
      call xspinb
      do i=1,nats
         ksp=nzTot(i) 
         if (ksp == 0) ksp = 1   ! ci potrebbero essere dei ghost
         itype=nalf(ksp)
         xo(:)=0.0
         xn(:)=0.0
         xo(1:3)=xyzs(1:3,i)
         xo(4)=xyzs(5,i)
         if(IsoAniso(i).eq.1) then
            xo(5:10)=bij(1:6,i)
         else
            xo(5)=bfac(i)
         endif
         iser=i
         khead=0
         iactn=3
c        khead=1
c        iactn=2
         ks=kspecb(newvet,xo,xn,key,itype,iser,khead,iactn)
c        write(ncwu,2047)i,key
         if (key(10).ge.1) then
             call site(key,1,ks)
c	       m22a=l22a
             ic12=0
             call readkeyNEW(i,ic12,key,jbb,ier)   
         endif
         xyzs(1:3,i)=xn(1:3)
         if(IsoAniso(i).eq.1) then
            bij(1:6,i)=xn(5:10)
         endif
         if(iSite(i).eq.0) then
            if(xyzs(5,i).ge.0.98) xyzs(5,i)=xn(11)
         endif
      enddo
!--fine loop sugli atomi      
2046  format(1x,a4,5f10.4,/,6f10.4)
2047  format(1x,i5,' jset12(key) ',10i6)
!
!--control the floating origen
      if(kpol.ge.1)then
         kyp(3)=mod(kpol,10)
         kyp(2)=mod(kpol,100)/10
         kyp(1)=kpol/100
c	   write(ncwu,*)' kpol,ky1,ky2,ky3 ',kpol,kyp
c--insert the 'sum ' directives  (restraint)
         do n=1,3
            if(kyp(n).ne.0) then
               jbb=jbb+1
               bufferch=isumch//' 0.00001  '//ixyzch(n) 
               write(ncpu,'(a80)') bufferch
            endif
         enddo
      endif
c--check bidimensional data
      if(lproj.gt.0) then
         jbb=jbb+1
         bufferch=ifixch//ixyzch(lproj)
         write(ncpu,'(a80)') bufferch
      endif
c--insert the 'ride' directives
      if(ihy2.ne.0) then  
         do j=1,4
            if(irigx(j).ne.0) then
               jbb=jbb+1
               bufferch=irigch(j)
               write(ncpu,'(a80)') bufferch
            endif
         enddo
         jbb=jbb+1
         bufferch=ifxhch
         write(ncpu,'(a80)') bufferch
      endif
      nsched=jbb
      call x62end(jbb)
!      
      NumCond12_Sav=NumCond12   
      call AllocaLsqStuff12_Sav(2)
      call AllocaLsqStuff12_Sav(1)
!      
      InfoOK(62)=1 
      return
      end
c
code for readkeyNEW 
      subroutine readkeyNEW(jy,ic12,key,jbb,ier)
c--
c  jy     no. d'ordine dell'atomo
c  ic12 = 0 non controllo ex lista 22
c         1 controllo se parametro va affinato
c  key    vettore contenente restraint sui parametri
c  jbb    no. d'ordine della direttiva lista 12
c
      USE General
      USE Symmetry
      USE Atomi
      USE LsqStuff
      USE LsqStuff12
      USE LsqModule
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      dimension ixy(4),ixz(4),iyz(4)
      dimension ixyz(3),iorder(6),iparx(6)
      dimension jweig(3),key(10)
      
      character*80 bufferch
      character*60 buffer, buffera
      character*5 kFixch,iequich,iweigch 
      character*3 ixych,iyzch,ixzch,ibijch(6)
      character*2 ixyzch(3)
      data kFixch /'fix  '/
      data iequich/'equi '/
      data iweigch/'fact '/
      data ixyzch /' x',' y',' z'/,ixyz/1,1,1/
      data ixych  /'x y'/  ,ixy /1,0,0,2/
      data iyzch  /'y z'/  ,iyz /2,0,0,3/
      data ixzch  /'x z'/  ,ixz /1,0,0,3/
      data ibijch /' 11',' 22',' 33',' 23',' 13',' 12'/
c--
c--
c--analysis on positional parameters
c--   jfix=1 no cond. jfix=2 fix x    jfix=4 fix y    jfix=6  fix z
c--   jfix=5 fix x y  jfix=7 fix x z  jfix=9 fix y z  jfix=10 fix x y z
c--
c--   jequiv=1 no cond.    jequiv=5  equiv x y  
c--   jequiv=7 equiv x z   jequiv=9  equiv y z  
c--   jequiv=10 equiv x y and equiv x z
c
      ier=0
      jfix=1
      jequiv=1
c--controllo condizioni
      do i=1,3
         if(ic12.eq.1)then
            if(nParBl(i,jy).eq.0) cycle
         endif
         jweig(i)=1
         if(key(i).eq.0)then
               jfix=jfix+2*i-1
         else
               if(key(i).lt.0)jweig(i)=-1
               kei=key(i)*jweig(i)
               if(kei.gt.10)then
                  jweig(i)=jweig(i)*(kei/10)
                  kei=kei-iabs(jweig(i)*10)
               endif
               if(kei.ne.i)jequiv=jequiv+2*kei+2*i-2
         endif
      enddo
      if(jequiv.eq.11)jequiv=10
      if(jfix.eq.1)go to 3002
c-------------------------------------------------------------------      
c--fix
      jbb=jbb+1
      call  instr12NEW(kFixch,jy,bufferch)
c------------1	   2	3   4	 5    6    7	8    9	  10----------
      go to(3002,1200,3002,1100,1200,1300,1200,3002,1100,1200),jfix
1100  continue
      buffer=ixyzch(2)
      if(jfix.eq.9)then
         call shift(buffer,l2)
         buffer=buffer(1:l2)//ixyzch(3)
      endif 
      goto 3000
1200  continue
      buffer=ixyzch(1)
      if(jfix.eq.5.or.jfix.eq.10)then
         call shift(buffer,l2)
         buffer=buffer(1:l2)//ixyzch(2)
      endif
      if(jfix.eq.7.or.jfix.eq.10)then
         call shift(buffer,l2)
         buffer=buffer(1:l2)//ixyzch(3)
      endif
      go to 3000
1300  continue
      buffer=ixyzch(3)
3000  continue
       call shift(bufferch,l)
       call shift(buffer,l2)
       bufferch=bufferch(1:l)//' '//buffer(1:l2)
       write(ncpu,'(a80)') bufferch
c------------------------------------------------------------      
c--equiv
3002  continue
      jequiv=jequiv-4
      inser=0
      if(jequiv.le.0)go to 4200
c------------1	  2    3    4	 5    6-------------
      go to(3100,4200,3300,4200,3500,3100),jequiv
c--jequiv = 1 o 6      
3100  continue   ! controllo  if(ic12.eq.1)
      inser=1
      jbb=jbb+1
      call  instr12NEW(iequich,jy,bufferch)
      buffer=ixych
!--devo aggiornare le stringa......      
3112  continue      
      if(jequiv.eq.1)go to 4000   ! aggiorno stringhe
      if(inser.eq.0) goto 3113    ! ???????
      call shift(bufferch,l)
      call shift(buffer,l2)
      bufferch=bufferch(1:l)//' '//buffer(1:l2)
      write(ncpu,'(a80)') bufferch
3113  continue  ! controllo  if(ic12.eq.1)   !--qui viene anche se inser=0
      jbb=jbb+1
      call  instr12NEW(iequich,jy,bufferch)
      buffer=ixzch
      go to 4000       ! aggiorno stringhe
c--jequiv = 3      
3300  continue   ! controllo  if(ic12.eq.1)
      inser=1
      jbb=jbb+1
      call  instr12NEW(iequich,jy,bufferch)
      buffer=ixzch
      go to 4000        ! aggiorno stringhe
c--jequiv = 5      
3500  continue      ! controllo  if(ic12.eq.1)
      inser=1
      jbb=jbb+1
      call  instr12NEW(iequich,jy,bufferch)
      buffer=iyzch
4000  continue          ! aggiorno stringhe
      if(inser.eq.1) then     ! perche solo se inser=1 ??????????
         call shift(bufferch,l)
         call shift(buffer,l2)
         bufferch=bufferch(1:l)//' '//buffer(1:l2)
         write(ncpu,'(a80)') bufferch
      endif
4011  continue
      if(inser.eq.1) then
c--and joined weight
         do j=1,3
            if(jweig(j).eq.1)cycle
            jbb=jbb+1
            call instr12NEW(iweigch,jy,bufferch)
            buffer=ixyzch(j)
            write(buffera,'(i8)')jweig(j)
            call shift(buffer,l)
            call shift(buffera,l1)
            buffer=buffer(1:l)//' '//buffera(1:l1)
            call shift(bufferch,l)
            call shift(buffer,l2)
            bufferch=bufferch(1:l)//' '//buffer(1:l2)
            write(ncpu,'(a80)') bufferch
        enddo
      endif
c
c--analysis on anisotropic parameters
4200  continue
      if(IsoAniso(jy).eq.2) return
c--change the code for 23 13 12 if they are equivalenced 
      inc=0
      do j=7,9
         keyc=iabs(key(j))
         if(keyc.eq.7)  inc=inc+1
      enddo
      if(inc.eq.3) then
         isig=isign(1,key(9))
         do j=7,9
            isig1=isign(1,key(j))
            key(j)=9*isig*isig1
         enddo
      endif
c--change the order of code
c  b(11)
c      iorder(1)=nParBl(5,jy)
c      iparx(1)=iEquiv(5,3,jy)
c  b(12)
c      iorder(6)=nParBl(6,jy)
c      iparx(6)=iEquiv(6,3,jy)
c  b(13)
c      iorder(5)=nParBl(7,jy)
c      iparx(5)=iEquiv(7,3,jy)
c  b(22)
c      iorder(2)=nParBl(8,jy)
c      iparx(2)=iEquiv(8,3,jy)
c  b(23)
c      iorder(4)=nParBl(9,jy)
c      iparx(4)=iEquiv(9,3,jy)
c  b(33)
c      iorder(3)=nParBl(10,jy)
c      iparx(3)=iEquiv(10,3,jy)
c--fix
      iorder(:)=1
      kinst=0
c      nn=5
      do j=1,6
c        if(iorder(j).gt.0) then
          if(key(j+3).eq.0)then
             iorder(j)=0
             jbb=jbb+1
             call instr12NEW(kFixch,jy,bufferch)
             kinst=1
             buffer=ibijch(j)
             call shift(bufferch,l)
             call shift(buffer,l2)
             bufferch=bufferch(1:l)//' '//buffer(1:l2)
             write(ncpu,'(a80)') bufferch
          endif
c        endif
c        nn=nn+1
      enddo
c--equiv
      kinst=0
      kweigh=0
      do j=4,9
         if(iorder(j-3).gt.0) then
            keyc=iabs(key(j))
            if(keyc.ne.j)then
               jj=keyc
               if(jj.ge.10.or.key(j).lt.0) kweigh=1
               if(jj.ge.10) then
                  jjj=jj/10
                  jj=jj-jjj*10
               end if
               if(jj.ne.j) then
c	            if(iparx(jj-3).eq.0.and.iparx(j-3).eq.0) then
                     jbb=jbb+1
                     call instr12NEW(iequich,jy,bufferch)
                     kinst=1
                     buffer= ibijch(jj-3)//' '//ibijch(j -3)
                     call shift(bufferch,l)
                     call shift(buffer,l2)
                     bufferch=bufferch(1:l)//' '//buffer(1:l2)
                     write(ncpu,'(a80)') bufferch
c	            endif
               endif
            endif
         endif
      enddo
c--	
      if(kinst.eq.0) return
c--weight --> factor
      if(kweigh.eq.0)return
      do j=4,9
         if(iorder(j-3).gt.0) then
            keyc=iabs(key(j))
            if(keyc.ne.j)then
               jj=keyc
               kweigh=1
               if(key(j).lt.0) kweigh=-1
               if(jj.gt.10) then
                  kweigh=kweigh*(keyc/10)
                  jjj=jj/10
                  jj=jj-jjj*10
               end if
               if(kweigh.ne.1) then
                  jbb=jbb+1
                  call instr12NEW(iweigch,jy,bufferch)
                  buffer=ibijch(j -3)
                  write(buffera,'(i5)')kweigh
                  call shift(buffer,l)
                  call shift(buffera,l1)
                  buffer=buffer(1:l)//' '//buffera(1:l1)
                  call shift(bufferch,l)
                  call shift(buffer,l2)
                  bufferch=bufferch(1:l)//' '//buffer(1:l2)
                  write(ncpu,'(a80)') bufferch
               end if
            endif
         endif
      enddo
5200  continue
      return
9000  continue
      ier=-1
      return
      end
c
code for instr12NEW
      subroutine instr12NEW(instr,jy,bufferch)
c  instr direttiva da inserire
c  jy    no. d'ordine dell'atomo
c  bufferch record output
c
      USE General
      USE Atomi
!
      character*80 bufferch
      character*5 instr
c--
      call shift(aLab(jy),l)
      bufferch=instr//aLab(jy)(1:l)
      return
      end
!-----------------------------------------------------------------------
!  routine di creazione della lista 62 run tie      
!-----------------------------------------------------------------------
!
!code for x62_fra
      subroutine x62_fra(line_dir)
!--crea una lista 62 da una routine run time
!  deve essere stata gia' creata la lista 13 (gruppi)
!  line_dir : striga contenente i gruppo da affinare
! per esempio (da finestra 'terminal'):
!  #read 13
!  frag 1 7 12
!  frag 2 13  18
!  frag 3 19  24
!  frag 4 28  33
!  frag 5 34  39
!  frag 6 40  45
!  end
!  #end
!
!  nel caso si voglia affinare solo il gruppo frag2,
!  la stringa line_dir = 'frag2'  
!  (notare che la label 'frag2' indica esattamte il frammento No. 2)
!
      USE General
!
      character*(*) line_dir
!      
      call x62start(ncard,ier)  ! inizializzo la lista 62
!      
      call x62all(ncard, 'full' ,0.0,0.0,line_dir , ' ', ier)
      call x62all(ncard, 'group',0.0,0.0,line_dir , ' ', ier)
!
      call x62end(ncard)
!
      return
      end
!-----------------------------------------------------------------------
!
!code for x62start
      subroutine x62start(ncard,ier)
!--inizializzo la lista 62
!
      USE General
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
!
      itype = 1
      iform = 1
      jop = jopen(ncpu,' ',itype,iform,ier)
      if (jop < 0) then
             write(lo,*)' error in open scratch file '
             ier=-1
             return
      endif
      ncard=0
      return
      end
c
code for x62all
      subroutine x62all(ncard,line_Dir_inp,a,b,line_Ato,line_Par,ier)
c--inserisco informazioni per lista 62
c--sequenza di chiamate per la creazione della lista:
c     call x62start(ncard,ier)  ! apro file temporaneo
c     call x62all(...)  ! deve avere una delle direttive DIAG/FULL/BLOCK
c--loop di chiamate alle subroutine
c     call x62all(...)
c     ....
c--termina il loop con la chiamata  
c     call x62end(ncard)
c----------------------------------------------------------
c  line_Dir : stringa contenente direttiva
c  line_Ato : stringa contenente nomi atomi  (o stringa vuota)
c  line_Par : stringa contenente i parametri ( x y z b[iso] b11..occ ) (o stringa vuota)
c  a,b  valori del target e della s.d. per restraint
c  directive codes: (line_Dir)
c                   1 diag
c                   2 full
c                   3 block
c                   4 plus
c                   5 fix
c                   6 weight  --> factor  (Not enabled)
c                   7 equiv               (Not enabled)
c                   8 ride                (Not enabled)
c                   9 end
c		         10 fixed -> 5
c		         11 dist                  
c		         12 angle              
c		         13 torsion             
c		         14 planar             
c		         15 sum                   (Not enabled)
c		         16 continue              (Not enabled)
c		         17 limit                 (Not enabled)
c		         18 group
c  argument type  : (line_Ato + line_Par)
c                   1 no specification
c                   2 a1 un a2 p1 p2 . .
c                   ( a1 p1 p2 p3 . . . . )
c                   ( a1  a2  p1 p2 p3 ...)
c                   3 a1 un a2
c                   ( a1  )
c                   ( a1 a2 ...)
c                   4 p1 p2 p3 . . . . .
c                   5 a1 p1 a2 p2                          (Not enabled)
c                   ( a1 until a2  p1 a3 until a4 p2 )     (Not enabled)
c                   ( a1 a2 ... p1  a11 a12 ... p2 )       (Not enabled)
c                   6 a1 p1  w                             (Not enabled)
c                   ( a1 until a2  p1 w  )                 (Not enabled)
c                   ( a1 a2 ... p1 w )                     (Not enabled)
c		            ( a1 a2 d s )                          (Not enabled)
c		            ( a1 a2 a3 cosd s )                    (Not enabled)
c
c--
      USE General
      USE LsqStuff12
!
      character*(*) line_Dir_inp,line_Ato,line_Par
c      
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      common/xcardch/CardImageX,idch(6)
      character CardImageX*80,idch*1
c
      character*20 line1
      character*4 dirch
      character*80 line_Dir
!
      line_Dir = line_Dir_inp
!
      ier=0
      call shift(line_Dir,n_Dir)
      if(n_Dir.eq.-1) then
         write(Msg,9005) ncard
         ier=-1
         call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
9005     format(' (List 12) card ',i2,2x,'error: no argument')
         return
      endif 
      call lcase(line_Dir)
c--check the directive
      ncard = ncard + 1
      n=min0(n_Dir,4)
      dirch=line_Dir(1:n)       
      idrb=KompareString(dirch,Diret12,NumDiret12,0)
      if(idrb.le.0) then
         write(Msg,9004) ncard,vetch
         ier=-1
         call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
9004     format(' (List 62) card ',i2,
     *   ' error: Directive ',a,' not valid!')
         return
      endif
!      
      select case (idrb)
c
c--'dist' or 'angle' or 'tors' or 'plan'  directive(s)
        case (11,12,13,14)
          if(idrb.eq.14) a=0.0
          if (b.eq.0.0) then
            b=0.001
            if(idrb.eq.12) b=0.01
            if(idrb.eq.13) b=0.01
          endif
          line1=' '
          if (idrb.eq.14) then
              write(line1,'(2f8.3)') b
          else
              write(line1,'(2f8.3)') a,b
          endif
          CardImageX = line_Dir(1:n_Dir)//' '//line1
          line_Dir = CardImageX 
          call shift(line_Dir,n_Dir)
      end select 
!       
      call shift(line_Ato,n_Ato)
      call shift(line_Par,n_Par)
!      
      CardImageX=line_Dir(1:n_Dir)//' '//line_Ato(1:n_Ato)//' '//
     *           line_Par(1:n_Par)
      write(ncpu,'(a80)') CardImageX
!
      return
      end
!
!code for x62end
      subroutine x62end(ncard)
!--fine  (idrb=9)
!
      USE General
      USE LsqStuff12
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      character*80 bufferch
      character*4 line, dirch
      data line /'end '/
c--
         ncard=ncard+1
         bufferch=' '
         bufferch(1:4)=line
         write(ncpu,'(a80)') bufferch
         rewind ncpu
         NumCond12=ncard
         call AllocaLsqStuff12(2)
         call AllocaLsqStuff12(1)
         NumRestr12=0
         NumBlock12=0
         NGroup12=0
         do i=1,NumCond12
            read(ncpu,'(a80)') stringa12Tot(i)
            dirch=stringa12Tot(i)(1:4)       
            idrb=KompareString(dirch,Diret12,NumDiret12,0)
            idir12(i)=idrb
            if(idrb.eq.1)NumBlock12=-1 
            if(idrb.eq.2)NumBlock12=1
c            if(idrb.eq.3)NumBlock12=NumBlock12+1
            if(idrb.ge.11.and.idrb.le.17) then
               if(idrb.ne.16) NumRestr12=NumRestr12+1
            endif
            if(idrb.eq.18) NGroup12=1
            if(idrb.ge.20.and.idrb.le.21) NumRestr12=NumRestr12+1
         enddo
         close (ncpu)
         InfoOK(62)=1
         return
         end
!
!code for x62end_byUser
      subroutine x62end_byUser(ncard)
!--fine  (idrb=9)
!
      USE General
      USE LsqStuff12
      USE LsqStuff12_byUser
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      character*80 bufferch
      character*4 line, dirch
      data line /'end '/
c--
         ncard=ncard+1
         bufferch=' '
         bufferch(1:4)=line
         write(ncpu,'(a80)') bufferch
         rewind ncpu
         NumCond12_byUser=ncard
         call AllocaLsqStuff12_byUser(2)
         call AllocaLsqStuff12_byUser(1)
         do i=1,NumCond12_byUser
            read(ncpu,'(a80)') stringa12_byUser(i)
            dirch=stringa12_byUser(i)(1:4)       
            idrb=KompareString(dirch,Diret12,NumDiret12,0)
            idir12_byUser(i)=idrb
         enddo
         close (ncpu)
         return
         end
!
!code for x62end_Restraint
      subroutine x62end_Restraint(ncard)
!--fine  (idrb=10)
!
      USE General
      USE LsqStuff12
      USE LsqRestraint
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      character*80 bufferch
      character*4 line, dirch
      data line /'end '/
c--
         ncard=ncard+1
         bufferch=' '
         bufferch(1:4)=line
         write(ncpu,'(a80)') bufferch
         rewind ncpu
         NumRestraint=ncard
         call AllocaLsqRestraint(2)
         call AllocaLsqRestraint(1)
         do i=1,NumRestraint
            read(ncpu,'(a80)') stringaRestraint(i)
            dirch=stringaRestraint(i)(1:4)       
            idrb=KompareString(dirch,DiretRestraint,NumDiretRestraint,0)
            idirRestraint(i)=idrb
            if(idrb.eq.8.or.idrb.eq.9) NumRestr12=NumRestr12+1
         enddo
         close (ncpu)
         return
         end
!
!-----------------------------------------------------------------------------         
c
code for PutGetGroup
      subroutine PutGetGroup(iAction)
!--scrive e legge su jdir Gruppi
!  (nuovo meccanismo)
!
      USE General
      USE LsqStuff
      USE LsqGroupsStuff
!      
      character*80 line
!      
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
!      
      if (iAction == 1) then
!      
         write(jdir) NumRigheGroup, NumGroup
         write(jdir) ifGroupRefined(1:100)
         if(NumRigheGroup.gt.0) then
            do i=1,NumRigheGroup
               write(jdir) RigheGroup(i)
            enddo
         endif
!         
      else
!      
         read(jdir) NumRigheGroup, NumGroup
         read(jdir) ifGroupRefined(1:100)
!--alloca vettori
         if(NumRigheGroup.gt.0) then
            call x62start(ncard,ier)
            do i=1,NumRigheGroup
               read(jdir) line
               write(ncpu,'(a80)')line
            enddo
            call ReadGroup(ncpu,NumRigheGroup,ier)
            close (ncpu)
         endif
!         
      endif        
!
      return
      end
!         
!----------------------------------------------------------------------
!  subroutine da lsqfin
!----------------------------------------------------------------------
      subroutine lsq()
!--call all'mnqd dalla grafica
!      
      USE General
      USE Riflessi
!---
      lixx = InfoOK(6)
      if (lixx.le.0 .or. nrefl == 0) then
          write(Msg,140)
  140     format('Cannot refine. No reflections supplied')
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          return
      endif
! ---
      ier = 0
      call UpdateCommonAndList5(ier)
      if (ier < 0) return
      if (.not.allocated(evet)) then
          iAction = 1
          call AllocaRiflessi(iAction)
      endif
      call mnqd()        !  nuovo MNQD
      return
      end    
!----------------------------------------------------------------------
      subroutine Mnqd()
!--chiamata dalla finestra grafica
!      
      USE General
      USE Atomi
!
      jgraf=1
      iref=0
      Num_Riflessi=0
      jCode_Peso=0
      call StartMNQD(jgraf,iref, Num_Riflessi, jCode_Peso)
      call zflush
      call open_lsq()
!--test commentando chiamata a 'open_lsq()'
!      iCode=1
! 	 call finish_MNQD(iCode,ier)
!--
      return
      end
!
!--------------------------------------------------------
!      Routines to set up and apply refinement conditions
!--------------------------------------------------------
c
code for ContaObsNew 
      subroutine ContaObsNew 
!--conta i riflessi a differenti chop
!
      USE General
      USE LsqModule
      USE Riflessi
      USE RiflessiNew
!
!-- sum for different values of cutoff (0,1,2,3,4,5,6,7,8,9)
      nObservation(1:10) = 0
      do i=1,nreflTot
         if (refl%sigma(i).lt.0.001) then
             jjjc = 10
         else
             jjjc=refl%fo(i)/refl%sigma(i) + 1
             if (jjjc.gt.10) jjjc = 10
         endif
         do jjj=1,jjjc
            nObservation(jjj) = nObservation(jjj) + 1
         enddo
      enddo
      return
      end
! 
!code for StartMNQD     
      subroutine StartMNQD(jgraf,iref, Num_Riflessi, jCode_Peso)
!--predispone il calcolo MNQD  (ex  lsq() in lsqfin.f)   
!  jgraf = 0 NON PASSA PER LA GRAFICA
!        = 1 CHIAMA LA GRAFICA 
!  iref  = 0 use the reflections
!	     1 no reflections
!  jCode_Peso = 0 non viene richiesto un criterio di pesaggio da programma
!               n criterio di pesaggio richiesto da programma
!  Num_Riflessi = 0 riflessi usati sono nreflObs (riflessi osservati)
!                 n si usano il numero minore tra nreflObs e Num_Riflessi
!
!  LsqCF  (in Module LsqModule) = 1 Calcolo fattori
!                               = 2 Affinamento
!     
      USE General
      USE Atomi
      USE Symmetry
      USE Riflessi
      USE Limits
      USE Molcom
      USE LsqStuff
      USE PhaseModule
      USE LsqModule
      USE LsqStuff12
      USE LsqStuff12_byUser
      USE LsqStuff22Abs
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/minmaxB/ ifAutoBtAn, value_Bmin, value_Bmax
! ---
      character*8 LabN
      character It1(17)*12
! ---
      It1( 1) = '  x'
      It1( 2) = '  y'
      It1( 3) = '  z'
      It1( 4) = '  B[iso]'
      It1( 5) = '  11'
      It1( 6) = '  12'
      It1( 7) = '  13'
      It1( 8) = '  22'
      It1( 9) = '  23'
      It1(10) = '  33'
      It1(11) = '  occ'
      It1(12) = '  occ1'
      It1(13) = '  occ2'
      It1(14) = '  occ3'
      It1(15) = '  occ4'
      It1(16) = '  scale'
      It1(17) = '  bm'
!
!--ndim=15
! ---
      iStampa=0

      ifAutoBtAn =  0
      value_Bmin = 0.25 * bt
      value_Bmax = 3.00 * bt
! ---
      lsqTest = 0    ! se lsqTest = 0 non produce stampe di controllo
!      lsqTest = 1    ! se lsqTest = 1 produce stampe di controllo
! ---
      ier = 0
!-------------------------------------------------------------
!--check if list 68 (limiti) non esiste
!-------------------------------------------------------------
      if(InfoOK(68).eq.0) then      
         CodeLimit(:) = -1
         VetClassiParita(:)=-1 
         NumOmit=0 
         call CalcolaLimitData(1)
         DataMinLim =  TempMinLim 
         DataMaxLim =  TempMaxLim
         call CalcolaLimitData(3)
         AgreMinLim =  TempMinLim 
         AgreMaxLim =  TempMaxLim
         infoOK(68)=1
       endif
!----------------------------------------------------
c--riempie vettori dinamici khl per MNQD
!----------------------------------------------------
      call AllocaTestStuff(1)
c--ksubr= 11 carico tutti i  riflessi
      ksubr=11
      ier=0
      call LeggiRiflessi(ier,ksubr)
      call ContaObsNew
      iCutoff=int(cutoff)
!--ottiene il calcolo di     nreflObs
      call ChopRiflessiNew(iCutoff)
!      
c--ksubr= 10 carico solo gli osservati (escludo non osservati ed esclusi da agreement)
      ksubr=10
      ier=0
      call LeggiRiflessi(ier,ksubr)
c--fine allocate vector per riflessi (in questo caso   NreflKsubr=nreflObs
      if(Num_Riflessi.gt.0) then
            nreflX=min0(Num_Riflessi, NreflKsubr)
      else
            if(numbGen > 0) then
               nreflX = nreflDim
            else
               nreflX=NreflKsubr
            endif
      endif
      call CalcolaLimitData(2)
      UserMinLim =  TempMinLim 
      UserMaxLim =  TempMaxLim
      wt(:)=1.0 
      Dluz(:)=1.0
      wvar(:)=1.0
      pesMod(:)=0.0
      do i=1,nreflX
            work1(i) =fovet(i) 
      enddo
!----------------------------------------------------------------
!--setto i default nei vettori SIR per i criteri di pesaggio
!----------------------------------------------------------------
      call sc04MNQD
!----------------------------------------------------------      
!--check if list 4 non esiste
      if(InfoOK(4).ne.1) then      
!      if(nWeight.lt.0.or.nWeight.gt.18) then
!--default criterio di pesaggio is 6
         nWeight=6
         IcodeFo4 = 1
         nPar=nParDef(nWeight)
         l=nPar+1
         if (nWeight.eq.16) l=l+1
         do j=1,l
            WPar(j)=WParDef(nWeight,j) 
         enddo
      else  
!--inserisco i valori attuali nei default
         l=nPar+1
         if (nWeight.eq.16) l=l+1
         do j=1,l
            WParDef(nWeight,j) = WPar(j)
         enddo
      endif
!----------------------------------------
      nWeightSav=nWeight
      if(jCode_Peso.ne.0) nWeight=jCode_Peso
      if(nWeightSav.ne.nWeight)then
!--inserisco i valori default del pesaggio richiesto
         nPar = nParDef(nWeight)
         l=nPar+1
         if (nWeight.eq.16) l=l+1
         do j=1,l
            WPar(j) = WParDef(nWeight,j) 
         enddo
      endif
      InfoOK(4) = 1      
!    
c  icodeFo4 = 1 (default) are on scale of Fo
c             2 are on scale of Fo**2
!  potrebbe essere settato al valore dato nel file .sir   
!  nel preambolo di lista 6: ifo2 ( 1 = fo; 2 = fo**2) 
!      
      FSQ_LSQ = IcodeFo4      !( 1 = fo; 2 = fo**2)          
      IWFo2=IcodeFo4
      icodeFO = FSQ_LSQ       !   se 2 -> affinamento su Fo^2
      if (lsqTest == 1) call PrintWeight(lo)
!
!----------------------------------------------------------------
! ---fine definizione pesi
!----------------------------------------------------------------
      call MnqdGetAllInfo(jgraf,ierres,iStampa,0)
!
      if(iStampa.ge.1.and.LsqCF.eq.2) call PrintMappaEqNor    ! stampa ex list 22
      Dampi=1.0
!----------------------------------------------------------------
!  RETURN se non viene usata la grafica
!----------------------------------------------------------------
      if(jgraf.eq.0) return 
!----------------------------------------------------------------
!--test del calcolo dei numero di parametri da affinare
!----------------------------------------------------------------
      if (lsqTest == 1) then
          call CalcolaNumParam(ier)
          write(ncwu,9302)NParTot
9302      format(' Number of refined parameters ',i6)
      endif             
!----------------------------------------------------------------
!-- prepara le informazioni per LSQ via interfaccia grafica
!----------------------------------------------------------------
!--NumCond12    n. di istruzioni fornite
!  idir12(1)   codice della prima istruzione
!              1  diag
!              2  full
!
      LsqType = idir12(1) 
      Dampi = 1.0
      nBlocks=NumBlockTot        ! sono la stessa cosa
      nBlocksGTK=nBlocks
!          
      iObs = nObservation(iCutoff+1)
      ObsT = nObservation(1)
      Observ = float(iObs) / ObsT
      iObserv = nint(Observ*100)
      nParameters = 0         ! calcolato dal C
      ObsByParam = 0          ! calcolato dal C
      kDampi = nint( Dampi * 1000.0 ) 
      kRatio = nint( ObsByParam * 1000 )
c     OverallNumBlock(1)=iover22(1)   !       Scale
c     OverallNumBlock(2)=iover22(2)   !       B(overall)
c     OverallNumBlock(3)=iover22(3)   !       Extinction
c     OverallNumBlock(4)=iover22(4)   !       Polarity
c     OverallNumBlock(5)=iover22(5)   !       Twinning
      LSQinit(1) = LsqType       !   1/2/3     diag/full/C.F.
      LSQinit(2) = nBlocks       !   number of blocks
      LSQinit(3) = kDampi        !   damping factor
      LSQinit(4) = iCutoff       !   reflections cutoff
      LSQinit(5) = nWeight       !   weighting scheme  
      LSQinit(6) = iObs          !   numb. of observations
      LSQinit(7) = iObserv       !   perc. of observations
      LSQinit(8) = nParameters   !   numb. of parameters
      LSQinit(9) = kRatio        !   ratio Obs / Param.
      LSQinit(10)= nPar15        !   e' il numero di parametri per atomo (11, 14 o 15)
      LSQinit(11)= 3             !   number of cycles
      LSQinit(12)= nPar          !   number of weight parameters
      LSQinit(13)= 0             !   value of weight parameters
      LSQinit(14)= 0             !   reset conditions
      LSQinit(15)= OverallNumBlock(1)  !  block for scale
*     FSQ_LSQ = 1                ! portato a 1 sempre - gianluca 21/05/2008
      LSQinit(16)= FSQ_LSQ       !  ....
c     LSQinit(16)= OverallNumBlock(2)  !  block for B(overall)
c     LSQinit(17)= OverallNumBlock(3)  !  block for Extinction
c     LSQinit(18)= OverallNumBlock(4)  !  block for Polarity
c     LSQinit(19)= OverallNumBlock(5)  !  block for Twinning
c     LSQinit(20)= n22d          !  number of restraints
      kInitStateSav(:) = LSQinit(:)
      nObsGTK = nObservation
!
!--la function NGruppiDef in spec2006.f chiama 
!  la function NGruppiDefMNQD(jump) in maqd2008.f
!--passa all'interfaccia grafica i gruppi
      nGruppiDefined =  NGruppiDef(NatMol)   ! function ! 
!
      do i=1,18
         nParDefGTK(i) = nParDef(i)
         j=nParDef(i)+1
         if(i.eq.16) j=j+1
         do j=1,j
            WParDefGTK(i,j) = WParDef(i,j)
         enddo
      enddo
!
      l=nPar+1
      if (nWeight.eq.16) l=l+1
      do j=1,l
         WParGTK(j) = WPar(j)
      enddo
!               
      do i=1, nats
         L = Lung(Lab(i))
         LabN = Lab(i)
!!         It(i) = LabN(1:Lung(LabN))//'@'
         It(i) = LabN(1:Lung(LabN))//char(0)
!mr180106        ListeAtomiV(i) = i
         IsoAnisoGTK(i) = IsoAniso(i) 
!         
!--passo alla grafica le informazioni sugli atomi (parametri) fissi
         do j=1,nPar15
            kFixGTK(j,i) = kFix(j,i)
         enddo     
      enddo
!
      if (lsqTest.eq.1) then
          write(lo,*) 
     *       '--------------------------------------------------------',
     *       '      Subr. lsq: valori dati in pasto alla grafica      ',
     *       '--------------------------------------------------------'
          write(lo,*)'wpar$GTK',LSQinit(12),
     *             (WParGTK(i),i=1,LSQinit(12)+1)
          write(lo,10) LSQinit(1)   , LSQinit(2) , LSQinit(4) ,
     *              LSQinit(5)
!
          call PrEqui()
      endif
   10 format(
     *  'Variabili in ingresso alla interfaccia LSQ:',/
     *  '    LsqType       =',i8,/,
     *  '    nBlocks       =',i8,/,
     *  '    CutOff        =',i8,/,
     *  '    nWeight       =',i8,/)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine finish_MNQD(iCode,ier)
      USE General
      USE Limits
      USE Atomi
      USE Molcom
      USE LsqStuff
      USE LsqGroupsStuff
      USE PhaseModule
      USE LsqModule
      USE LsqStuff12
      USE LsqStuff12_byUser
!
      integer iCode  
!
!               iCode = 0 --> OK
!               iCode = 1 --> Go
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
!
      character It1(17)*12
      character*5 isan(2)
c
      isan(1) = 'Aniso'
      isan(2) = 'Iso  '
! ---
      It1( 1) = '  x'
      It1( 2) = '  y'
      It1( 3) = '  z'
      It1( 4) = '  B[iso]'
      It1( 5) = '  11'
      It1( 6) = '  12'
      It1( 7) = '  13'
      It1( 8) = '  22'
      It1( 9) = '  23'
      It1(10) = '  33'
      It1(11) = '  occ'
      It1(12) = '  occ1'
      It1(13) = '  occ2'
      It1(14) = '  occ3'
      It1(15) = '  occ4'
      It1(16) = '  scale'
      It1(17) = '  bm'
!
      ier=0
      iex2=0
      iex3=0
      ifWr4 = 0
      iW12  = 0
      ifGiaDef  = 0
!------------------------------------ 1 -- 2 -- 3      
      LsqType   = LSQinit(1)     !   diag/full/S.F.   (BLOCK e' stato eliminato)
      nBlocks   = LSQinit(2)     !   number of blocks  
      kDampi    = LSQinit(3)     !   damping factor
      iCutOff   = LSQinit(4)     !   reflections cutoff
      nWeight   = LSQinit(5)     !   weighting scheme
      nCycles   = LSQinit(11)    !   numb. of lsq cycles
      nPar      = LSQinit(12)    !   num. of parameters
      ifDefault = LSQinit(14)    !   reset conditions
      OverallNumBlock(1)= LSQinit(15)!  block for scale
      FSQ_LSQ   = LSQinit(16)    !   .....
c     OverallNumBlock(2)=LSQinit(16)  !       B(overall)
c     OverallNumBlock(3)=LSQinit(17)  !       Extinction
c     OverallNumBlock(4)=LSQinit(18)  !       Polarity
c     OverallNumBlock(5)=LSQinit(19)  !       Twinning
c      
      Dampi = float(kDampi) / 1000.0
      jActB = kInitStateSav(1)
      jAct  = LSQinit(1)
      if(iCutOff.lt.0) iCutOff=0
      if(iCutOff.gt.8) iCutOff=8
!---print di controllo      
      if (lsqTest.eq.1) then
          write(lo,10) LsqType   , nBlocks , iCutOff , nWeight ,
     *                 ifDefault , nCycles , jActB ,
     *                 nPar      , Dampi , OverallNumBlock

          write(lo,*)
     *       '--------------------------------------------------------',
     *       '        Subr. finishlsq: risultati grezzi dalla grafica ',
     *       '--------------------------------------------------------'
!
          write(ncwu,*)'nWeight,nPar',nWeight,nPar
          write(ncwu,*)'WparGTK',(WParGTK(i),i=1,nPar+1)
          write(ncwu,'(1h )')
          do i=1,nats
             write(lo,11) i,Lab(i),isan(IsoAnisoGTK(i))
             write(lo,13) (kFixGTK(k,i),k=1,nPar15)
          enddo
      endif
!--fine stampa di controllo
!----------------------------------------------------------------    
!--controllo che ho cambiato cutoff da usare
!----------------------------------------------------------------    
      if(kInitStateSav(4).ne.LSQinit(4)) then !  cutoff
!--new cutoff reflections         
c--ksubr= 11 carico tutti i  riflessi
         ksubr=11
         ier=0
         call LeggiRiflessi(ier,ksubr)
         call ChopRiflessiNew(iCutoff)
c--ksubr= 10 carico solo gli osservati
         ksubr=10
         ier=0
         call LeggiRiflessi(ier,ksubr)
         nreflX=nreflObs
         call CalcolaLimitData(2)
         UserMinLim =  TempMinLim 
         UserMaxLim =  TempMaxLim
      endif
!----------------------------------------------------------------    
!--controllo che ho cambiato tipo di riflessi da usare: fo or fo**2
!----------------------------------------------------------------    
      if(kInitStateSav(16).ne.LSQinit(16)) then !  fo or fo**2
         IcodeFo4=LSQinit(16)
         IWFo2=IcodeFo4
         call sc04MNQD
!--inserisco i valori default per il criterio usato
         nPar = nParDef(nWeight)
         l=nPar+1
         if (nWeight.eq.16) l=l+1
         do j=1,l
            WPar(j) = WParDef(nWeight,j) 
         enddo
      else
!--update weithing parameters  
         j=nPar+1
         if(nWeight.eq.16) j=j+1  
         do i=1,j
            WPar(i) = WParGTK(i)
         enddo
      endif
      nObservation = nObsGTK
!-------------------------------------------------------------------   
!--controllo se ho cambiato iso/aniso  (DEVO CONTROLLARE IL GRUPPO)
!-------------------------------------------------------------------    
      xminval=1.0e-20
      ichgTot=0
      do i=1,nats
         ichanged=0
         ksp = nzTot(i) 
         if (no(ksp).eq.1) IsoAnisoGTK(i) = 2
         if(IsoAniso(i).ne.IsoAnisoGTK(i)) ichanged=1
         IsoAniso(i) = IsoAnisoGTK(i)
         if(ichanged.eq.1) then
            ichgTot=1
            if (IsoAnisoGTK(i).eq.1) then
                if (Bij(1,i).le.0.0) then
                    do j=1,6
                       Bij(j,i)=bfac(i)*BisoToBij(j)
                       if(abs(Bij(j,i)).lt.xminval)Bij(j,i)=0.0
                    enddo
                endif
            else if (IsoAnisoGTK(i).eq.2) then
                if (Bij(1,i).gt.0.0) then
                    bfac(i)=0.0
                    do j=1,6
                       bfac(i)=bfac(i)+Bij(j,i)*BijToBiso(j)
                    enddo
                    Bij(1:6,i)=0.0
                end if
            endif
         endif
      enddo
!--controllo se ci sono gruppi definiti e se e' stato cambiato ISO/ANISO atomi
      if(NumGroup.gt.0.and.ichgTot.ne.0) then   
         do jy=1,NumGroup
            n_atoms=NumAtomsGroup(jy)
            ichanged=0
            do ja=1,n_atoms
               i=NordAtomsGroup(ja,jy)
               if(IsoAniso(i).ne.IsoAnisoGroup(jy)) 
     *                                      ichanged=ichanged+1
            enddo   
            if(ichanged.ne.0) then
               if(ichanged.eq.n_atoms) then
                  IsoAnisoGroup(jy)=IsoAniso(i)  
               else
                  write(Msg,6102)  
 6102             format(' Mixed iso/aniso thermal factors not allowed')
                  call MsgWinErr('WARNING!', Msg, ERR_WINDOW, nExitCode)
                  ier=1
                  return
               endif
            endif  
         enddo
      endif           
!               
!----------------------------------------------------------------    
!--controllo se il pulsante RESET e' attivo
!---------------------------------------------------------------- 
c      if(ifDefault.eq.1) then
c         NumCond12_byUser=0
c         ckFix(:)=0
c         kFix(:,:)=0
c         do m=1,nats
c            kFix(11,m)=1        ! default parametro Occ fissato 
c         enddo
c      else
!----------------------------------------------------------------    
!--controllo se ho cambiato FIX/unFIX
!---------------------------------------------------------------- 
         do i=1,nats
!--controllo no di parametri iso/aniso 
!  occupanze e angoli(se gruppo)non sono considerati        
            nParx=4
            if (IsoAniso(i).eq.1) nParx=10
!--setto binary code         
            IDP = 0
            IDMC = 2**nParx - 1  
            if (IsoAniso(i).eq.1) IDMC = IDMC - 2**3 ! ecludo l'indicazione del b[iso]
            IDM = 0
!--binary code IDM : 1111 (se iso) 1111110111 (se aniso)         
c---------------------------------------------------         
c           write(ncwu,'(1x,1h$,B32,1h$)') idm  
c           idm = idm - 2**2  ! (tolgo il 3^ parametro)
c           write(ncwu,'(1x,1h$,B32,1h$)') idm
c           do k=1,nPar15
c                   k1=k-1
c                   IDP = IDP + 2**k1
c                   write(ncwu,'(1x,1h$,B32,1h$)') idp
c           enddo
c           stop
c---------------------------------------------------
            do k=1,nParx
               ichanged=0
               if(IsoAniso(i).eq.2.or.j.ne.4) then    ! salto b[iso] se atomo e' aniso
                  if(kFix(k,i).ne.kFixGTK(k,i)) ichanged=1
                  if(ichanged.eq.1) then
                     if(kFixGTK(k,i).eq.1) then
!--qui devo salvare l'informazione tipo "FIXED aLab(i) It1(k)"  
!  controllando se tutti i parametri dell'atomo sono fissati 
                        k1=k-1
                        IDP = IDP + 2**k1
                     else
!--qui devo eliminare l'informazione tipo "FIXED aLab(i) It1(k)" 
!  presente precedentemente nel vettore ckFix(i)
                        k1=k-1
                        IDM = IDM + 2**k1
                     endif
                  endif 
               endif
            enddo
!--elaboro risultato
            if(IDP.ne.0) then
!--devo aggiungere una operazione FIX dell'utente 
!  se IDP = IDMC , atomo fissato
               ckFix(i)=ckFix(i) + IDP
            endif
            if(IDM.ne.0) then
!--devo eliminare una operazione FIX precedente dell'utente
               if(ckFix(i).ge.IDM) then
                  ckFix(i)=ckFix(i) - IDM
               endif
            endif                           
         enddo
         do i=1, nats
!--passo  le informazioni sugli atomi (parametri) fissi dalla grafica
            do j=1,nPar15
               kFix(j,i) = kFixGTK(j,i)
            enddo     
         enddo
!--creo le direttive FIXED by user
         iAction=1
         call FixedByUser(iAction, It1,ier)
c      endif 
!---------------------------------------------------------
!--chiamo la routine di creazionione in Default 
!---------------------------------------------------------
      call DefaultRefi(LsqType,ier)
!      call PrintRefi(lo)
!      
!---------------------------------------------------------
      if (LsqType.eq.3) then	  ! SFC
          nCycles = 0
          LsqCF=1
      else
          LsqCF=2
          if (nCycles.eq.0) nCycles= 3
          fdump=Dampi
          if (nCycles.gt.11) then
              nCycles= 11
          endif
      endif
!----------------------------------------------------
!--save restraint orig
!----------------------------------------------------
      nresSav = nres
      vresSav = vres
      NumCond12_Sav =NumCond12
      idir12_Sav = idir12
      stringa12Tot_Sav = stringa12Tot
!     
      iprint=0
      call CreaMnqd(jbb,ier,iprint)
!      call PrintRefi_RT(lo)
!----------------------------------------------------
!--restore restraint orig
!----------------------------------------------------
      nres = nresSav
      vres = vresSav
      NumCond12 =NumCond12_Sav
      idir12 = idir12_Sav
      stringa12Tot = stringa12Tot_Sav
!       
!      call PrintRestraint(0)
!      call PrintRefi_RT(lo)
!--print di test !!!!!!!!!!!!!!!
      if (lsqTest.eq.1) then
          write(lo,*)
     *       '--------------------------------------------------------',
     *       '        Subr. finishlsq: risultati dalla grafica        ',
     *       '--------------------------------------------------------'
          call PrEqui()
      endif
!      call PrintCondizioni
!----------------------------------------------------      
!--chiamata alla routine dell'affinamento: botton GO
!----------------------------------------------------      
      if(iCode.eq.1)then
!         
         call RoutineHeader('Least-Squares')
!            
         iref=0
         idi=2
         call DirMnqd(ier,idi,iref,xyzs4)
         write(lo,3830)
3830     format(/,1h ,78('+'),//)
         if (ier.ge.0) then
c            rfac = errem / 100.0
             write(Msg,9002) rflsq,rwflsq,slsq
*            write(Msg,"(' R(F)% = ',f6.2)") rflsq
             call scrper(Msg,0,-1)
         endif
      endif
!----------------------------------------------------
      errem = rflsq / 100.0
      interp = 1                ! gianluca 21/04/10
      call PutGetXyzs(1, interp)        ! gianluca 21/04/10
*gl*
      call PutModel
*gl*
*gl*  BTot(1,1) = 101           ! gianluca 21/04/10
      iPlt = iplotType
      ifSingle = 1
      call MolPlo(iPlt, ifSingle)
!
!mr
      call AggiornaJav
!end mr
!
      ifFromLSQ = 1
      call ThFacTooBig(ifFromLSQ)
!
      return
   10 format(/,'--------------------------------------------',/,
     *'Variabili in uscita dalla interfaccia LSQ:',/
     *'    LsqType       =',i8,/,
     *'    nBlocks       =',i8,/,
     *'    CutOff        =',i8,/,
     *'    nWeight       =',i8,/,
     *'    Reset Condit. =',i8,/,
     *'    nCycles       =',i8,/,
     *'    LsqType prec. =',i8,/,
     *'    nPar          =',i8,/,
     *'    Dampi         =',f8.3,/,
     *'    OverallNumBlock(1)=',i8,/,
     *'    OverallNumBlock(2)=',i8,/,
     *'    OverallNumBlock(3)=',i8,/,
     *'    OverallNumBlock(4)=',i8,/,
     *'    OverallNumBlock(5)=',i8,//,
     *'                                               ')
   11 format(i5,')',3x,a8,2x,a5)
   12 format(9x,15i5)
   13 format('kFixGTK  ',15i5)
 1100 format('Block #',i2,' is empty or wrongly defined!!!')
 9002  format(' R(F)% ( wR(F**2)% ) =',f6.2,' (',f6.2,')',
     *        ' Goodness of Fit (S) =',f6.2)
      end
!
code for FixedByUser
      subroutine FixedByUser(iAction, It1,ier)
!--NOT MORE USED      
!-- iAction = 1    crea the FIXED directive by user from the code vector
!-- iAction = 2    crea the code vector from FIXED directive by user
!
      USE General
      USE Atomi
      USE Molcom
      USE LsqModule
      USE LsqStuff
      USE LsqStuff12
      USE LsqStuff12_byUser
!
      character*16 vetch
!
      character *(*) It1(*)
!      
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
!      
      character line*80,dire*80,diret*80
      character*7 fixch, plusch
      data fixch/'fixed  '/, plusch/'plus  '/
!--
      ier=0
      if(iAction.eq.1) then
!--crea le FIXED direttive from the code vector ckFix(i)
         call x62start(ncard,ier)
         do i=1,nats
            if(ckFix(i).gt.0) then
               nParx=4
               if (IsoAniso(i).eq.1) nParx=10
!--setto binary code         
               IDMC = 2**nParx - 1  
               if (IsoAniso(i).eq.1) IDMC = IDMC - 2**3 ! ecludo l'indicazione del b[iso]
!--binary code IDM : 1111 (se iso) 1111110111 (se aniso)
               line=fixch//aLab(i)
               if(ckFix(i).ne.IDMC) then
                  do k=1,nParx
                     k1=k-1
                     ID=2**k1
                     ir=iand(ckFix(i),ID)
                     if(ir.ne.0) then
                        call shift(line,kk)
                        line=line(1:kk)//It1(k)
                     endif
                  enddo
               endif
               ncard=ncard+1
               write(ncpu,'(a80)')line
            endif
            if(kFix(11,i).eq.0) then
               line=plusch//aLab(i)
               call shift(line,kk)
               line=line(1:kk)//It1(11)
               ncard=ncard+1
               write(ncpu,'(a80)')line
            endif
         enddo
         if(ncard.gt.0) then
            call x62end_byUser(ncard)
         else   
            NumCond12_byUser = 0
            close (ncpu)
         endif
      else
!  kFix(:,:)  = 0 nessuna definizione by user
!             = 1 param. fisso by user
!
         do in=1,NumOggettiMax
            ckFix(in)=0
            do i=1,nPar15
               kFix(i,in)=0        ! default parametri  non fissati 
            enddo
            kFix(11,in)=1          ! default parametro Occ fissato 
         enddo
!         
!--crea the code vector ckFix(i) from FIXED direttive
!
         do m=1,NumCond12_byUser
            if(idir12_byUser(m).eq.9) exit
            line = stringa12_byUser(m)
            call lcase(line)
!--le direttive possibili sono FIXED e PLUS           
            call cutst(line,lenp,dire,lend)   ! elimino direttiva 'fixed'
            call cutst(line,lenp,dire,lend)   ! estraggo nome dell'atomo
            vetch=dire(1:lend)
            call LookforAtom(vetch,nord)
            if(nord.le.0) then
               write(ncwu,'(2a)')'Error! Atom not found: ',vetch
               ier=-1
               return
            endif
            nParx=4
            if (IsoAniso(nord).eq.1)  nParx=10
            if(lenp.gt.0) then
               call cutst(line,lenp,dire,lend)
               vetch=dire(1:lend)
               n=KompareString(vetch,Param12,NumParam12,0)  ! check parameter  
               if(n.eq.0) then
                  write(ncwu,'(2a)')'Error! Param not found: ',vetch
                  ier=-1
                  return
               endif
               codeparam(1:nParx)=0
               if(idir12_byUser(m).eq.4) then
                  if(n.ne.11) then
                     write(ncwu,'(2a)')'Error! Wrong Param found: ',vetch
                     ier=-1
                     return
                  endif
                  kFix(11,nord)=0        ! parametro Occ da affinare 
               else   
                  if(lenp.le.0) then
                     call par22MNQD(0,n)
                  else                                      
                     call jpargMNQD(0,n,line,ier) 
                  endif
                  kFix(1:nParx,nord)=codeparam(1:nParx)
                  IDP = 0
                  do k=1,nParx
                     if(codeparam(k).eq.1)then
                        k1=k-1
                        IDP = IDP + 2**k1
                     endif
                  enddo
                  ckFix(nord)= IDP
               endif
            else
               IDMC = 2**nParx - 1  
               if (IsoAniso(nord).eq.1) IDMC = IDMC - 2**3 ! ecludo l'indicazione del b[iso]
               ckFix(nord) = IDMC
               kFix(1:nParx,nord)=1
               if (IsoAniso(nord).eq.1)kFix(4,nord)=0
            endif 
         enddo  
      endif
      return
      end
!-----------------------------------------------------------------------
      integer*4 Function NGruppiDefMNQD(jump)
      USE General
      USE LsqGroupsStuff
      USE LsqStuff
      USE Molcom
      USE Atomi
!
c      implicit none
      integer jump
!
      integer lsn,lixx,ljxx,lkxx,llxx, nIt, kk, m, l, mx, ncard
      integer ier, nchv, Len1, i, ll, iser, lz1, lz2, lz3
      integer n, Lung, NrotaC, NatomC, iflagAmb
      character*80 line, dire
!
      call InitResidues()
!
      if (jump == 0) then
          ifLabelsVis(:) = 0
          ifRigidBody = 1
      endif
      
      if (InfoOK(13) <= 0) then
          call UpdateCommonAndList5(ier)
          if (ier == 0) then
              NGruppiDefMNQD = -1
          else
              NGruppiDefMNQD = -2
          endif
          return
      else
          NGruppiDefMNQD = NumGroup 
          nIt = jump
!
!-- Groups
         do jy=1, NumGroup
            Msg=' '
            line=NameLongGroup(jy)
            call shift(line,len)
            call lcase(line)
            call ucase(line(1:1))
            write(dire,'(i4)') NserialGroup(jy)
            call shift(dire,lend)
            Msg=line(1:len)//' '//dire(1:lend)
            m=len+lend+3
            n_atoms=NumAtomsGroup(jy)
            do ja=1,n_atoms
               nord=NordAtomsGroup(ja,jy)
               Inte=aLab(nord)
               call shift(Inte, nchv)
               call lcase(Inte)
               call ucase(Inte(1:1))
               Msg(m:m+nchv) = Inte(1:nchv)
               m = m + nchv + 1
            enddo
            call OneBlankOnly(Msg)
            L = Lung(Msg)
            if (L <= 56) then
               Len1 = L
            else
               Len1 = 56
            endif
            nIt = nIt + 1
            It(nIt) = Msg(1:Len1) // char(0)
            do while (L > 56)
               Msg(1:56) = ' '
               call shift(Msg, L)
               nIt = nIt + 1
               It(nIt) = Msg(1:56) // ' &' // char(0)
            enddo
         enddo     
         nIt = nIt + 1
         It(nIt) = 'end' // char(0)
!      
!         write(lo,10) NGruppiDefMNQD
!         do i=1, nIt
!            write(lo,'(a)') It(i)(1:Lung(It(i)))
!   10       format('Contenuto di It per ',i3,' gruppi:',/,
!     *              '===============================')
!         enddo
          
!
         if (ifDrawGroups == 1) then
             ifDrawGroups = 0
             ier = 0
             iflagAmb = 0
             call DrawGroups(ier, iflagAmb)
         endif
      endif
!   
      return
      end
! ----------------------------------------------------------------------
!
!code for RestraintToDiret
      subroutine RestraintToDiret(ier)
!--crea direttive restraints
!
!             nres         = number of restraints
!             vres         = array containing restraints
!
!   restraint code         = 1 DISTANCE
!                            2 ANGLE
!                            3 TORSION
!                            4 PLANE
!                            5 SUM
!                            6 LIMIT
!                            7 SITE
!                            8 DISORDER
!
!   vres(jp)               = restraint code
!   vres(jp+1)             = number of atoms involved
!                          0 = tutti gli atomi    if SUM & LIMIT
!   vres(jp+2)             = sigma
!                            sigma(x)             if LIMIT
!   vres(jp+3)             = distance             if DISTANCE
!                            angle                if ANGLE
!                            angle                if TORSION
!                            zero                 if PLANE
!                            number of parameters if SUM
!                            sigma(B)             if LIMIT
!
!   vres(jp+4)             = sigma(bij)           if LIMIT
!   vres(jp+4....)       = parameters codes only  if SUM
!   vres(jp+4....)         = atoms codes          if DIST, ANGLE, TORSION, PLANE
!   vres(jp+4.....)        = atoms codes          if SITE
!   vres(jp+4[+params]....)= atoms codes          if SUM
!   vres(jp+5....)       = atoms codes            if LIMIT
!
      USE General
      USE Atomi
      USE Molcom
      USE LsqModule
      USE LsqRestraint
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
!
      character*80 text
      character*5  dircur
!
      character*4 nax(20),naxc(20)
      dimension nox(20),noxc(20),noxca(20)
      dimension vresc(500)
      character  It1(15)*6
      data It1 /'    x ','    y ','    z ','b[iso]',
     2          '    11','    12','    13','    22',
     3		'    23','    33','   occ','  occ1',
     4		'  occ2','  occ3','  occ4'/
!
      if (nres.le.0) return
!      write(lo,*) '(from31to12) Nres=',nres
!      jp=11
!      write(lo,*)'&&&',(vres(jj),jj=1,jp)
!---------------------------------
      nox(:)=0
      nax(:)=' '
      do i=1, NatMol
         iz=nzTot(i)
         if(iz.gt.0) then
            nax(iz)=species(iz)
            nox(iz)=nox(iz)+1
         endif
      enddo
!      do l=1,20
!      if(nox(l).eq.0) cycle
!      write(lo,1097) l,nax(l),nox(l)
!1097  format(1x,i3,') species ',a4,' - no. of atom(s) ',i5)
!      enddo
!--
      ier=0
      call x62start(ncard12,ier)  ! inizializzo la lista 62 
!--fine loop sulle direttive presenti e inizio loop sui restraints
      do kk =1,7
         jp = 0
         do i = 1 , nres
            jp = jp + 1
            icode = nint(vres(jp))
            natom = nint(vres(jp+1))
            sigma = vres(jp+2)
            jpara = 0
            npara = 0
            incr  = 3
            if(icode.eq.5) then
              jpara = nint( vres(jp+3) )
              npara = 1
              incr  = 2
            endif
            if(icode.eq.6) then
              incr  = 4
            endif
            if (icode.eq.kk) then
                dista = vres(jp+3)
                select case (icode)
                    case (1)                 ! distances
                       write(text,100) 'dist ',dista, sigma,
     *			            (Lab(nint(vres(jj))),jj=jp+4,jp+4+natom-1)
                       ncard12=ncard12+1
                       write(ncpu,'(a80)') text
                    case (2)                 ! angle
                       write(text,100) 'angle',dista,sigma,
     *                       (Lab(nint(vres(jj))),jj=jp+4,jp+4+natom-1)
                       ncard12=ncard12+1
                       write(ncpu,'(a80)') text
                    case (3)                 ! torsion angle
                       write(text,100) 'torsion',dista,sigma,
     *                       (Lab(nint(vres(jj))),jj=jp+4,jp+4+natom-1)
                       ncard12=ncard12+1
                       write(ncpu,'(a80)') text
                    case (4)		           ! plane
!--controllo numero di atomi e numero di parametri
                       if(natom.eq.NatMol) then
!--tutti gli atomi----------
                          write(text,200) 'plane',sigma
                          ncard12=ncard12+1
                          write(ncpu,'(a80)') text
                       else
!--solo alcuni atomi---------
                          icodplane=0
                          noxc(:)=0
                          jp1=jp+4
                          jp2=jp1+natom-1
                          do jj=jp1,jp2
                             k=nint(vres(jj))
                             iz=nzTot(k)
                             if(iz.gt.0) then
                                noxc(iz)=noxc(iz)+1
                             endif
                          enddo
!--ho calcolato il numero di atomi di una specie chimica
!			              write(lo,*) nox,noxc
                          ll2=0
                          do l=1,20
                             if(noxc(l).gt.0) then
                                if(nox(l).eq.noxc(l)) then
!--tutti gli atomi di quella specie chimica sono presenti
                                   ll2=ll2+1
                                   naxc(ll2)=nax(l)
                                   noxca(ll2)=noxc(l)
                                endif
                             endif
                          enddo
                          ll3=0
                          if(ll2.gt.0) then
!--sono presenti tutti gli atomi di una specie chimica
                             natox=0
                             do l=1,ll2
                                natox=natox+noxca(l)
                             enddo
!--tutti gli atomi sono definiti dalle loro specie chimiche (ll3=1)
                             if(natox.eq.natom) ll3=1
!--definisco gli atomi con la sola specie chimica
                             icodplane=1
                             write(text,200) 'plane ',sigma,
     *                            (naxc(jj),jj=1,ll2)
                             ncard12=ncard12+1
                             write(ncpu,'(a80)') text
                          endif
!--fine definizione di atomi dalla loro specie chimica
                          if(ll3.eq.0) then
!--caso in cui ci sono altri atomi da inserire
                             jj2=0
                             do jj=jp1,jp2
                                k=nint(vres(jj))
                                iz=nzTot(k)
                                if(iz.gt.0) then
                                   if(nox(iz).ne.noxc(iz)) then
                                      jj2=jj2+1
                                      vresc(jj2)=vres(jj)
                                   endif
                                endif
                             enddo
                             vres(jp+1)=jj2
                             jp2=jp1+jj2-1
                             jk=1
                             do jj=jp1,jp2
                                vres(jj)=vresc(jk)
                                jk=jk+1
                             enddo
                             dircur='plane '
                             if(icodplane.eq.1) dircur='cont '
                             if(jj2.gt.5) then
                                ncard=jj2/5
                                nrest=jj2-ncard*5
                                kj1=jp+4+jpara
                                do l=1,ncard
                                   kj2=kj1+4
                                   if(icodplane.eq.0.and.l.eq.1) then
                                      write(text,200) dircur ,sigma,
     *			                           (Lab(nint(vres(jj))),
     *			                      jj=kj1,kj2)
                                   else
                                      write(text,201) dircur ,
     *			                           (Lab(nint(vres(jj))),
     *			                      jj=kj1,kj2)
                                   endif
                                   ncard12=ncard12+1
                                   write(ncpu,'(a80)') text
                                   dircur='cont '
                                   kj1=kj1+5
                                enddo
                                if(nrest.gt.0) then
                                   kj2=kj1+nrest-1
                                   write(text,201) dircur ,
     *			                        (Lab(nint(vres(jj))),
     *			                   jj=kj1,kj2)
                                   ncard12=ncard12+1
                                   write(ncpu,'(a80)') text
                                endif
                             else
                                if(icodplane.eq.0) then
                                   write(text,200) dircur,sigma,
     *			                       (Lab(nint(vres(jj))),
     *			                   jj=jp+4,jp+4+jj2-1)
                                else
                                   write(text,201) dircur,
     *			                       (Lab(nint(vres(jj))),
     *			                   jj=jp+4,jp+4+jj2-1)
                                endif
                                ncard12=ncard12+1
                                write(ncpu,'(a80)') text
                             endif
                          endif
                       endif
                    case (5)		       ! sum
                       jpara = nint( vres(jp+3) )
                       npara=1
!--controllo numero di atomi e numero di parametri
                       if(natom.eq.NatMol.or.natom.eq.0) then
!--tutti gli atomi----------
                          write(text,300) 'sum  ',sigma,
     *			             (It1(nint(vres(jj))),jj=jp+4,jp+4+jpara-1)
                          ncard12=ncard12+1
                          write(ncpu,'(a80)') text
                       else
!--solo alcuni atomi---------
                          noxc(:)=0
                          jp1=jp+4+jpara
                          jp2=jp1+natom-1
                          do jj=jp1,jp2
                             k=nint(vres(jj))
                             iz=nzTot(k)
                             if(iz.gt.0) then
                                noxc(iz)=noxc(iz)+1
                             endif
                          enddo
!--ho calcolato il numero di atomi di una specie chimica
                          ll2=0
                          do l=1,20
                             if(noxc(l).gt.0) then
                                if(nox(l).eq.noxc(l)) then
!--tutti gli atomi di quella specie chimica sono presenti
                                   ll2=ll2+1
                                   naxc(ll2)=nax(l)
                                   noxca(ll2)=noxc(l)
                                endif
                             endif
                          enddo
                          ll3=0
                          if(ll2.gt.0) then
!--sono presenti tutti gli atomi di una specie chimica
                             natox=0
                             do l=1,ll2
                                natox=natox+noxca(l)
                             enddo
!--tutti gli atomi sono definiti dalle loro specie chimiche (ll3=1)
                             if(natox.eq.natom) ll3=1
!--definisco gli atomi con la sola specie chimica
                             write(text,300) 'sum  ',sigma,
     *			              (naxc(jj),jj=1,ll2),
     *			              (It1(nint(vres(jj))),jj=jp+4,jp+4+jpara-1)
                             ncard12=ncard12+1
                             write(ncpu,'(a80)') text
                          endif
!--fine definizione di atomi dalla loro specie chimica
                          if(ll3.eq.0) then
!--caso in cui ci sono altri atomi da inserire
                             jj2=0
                             do jj=jp1,jp2
                                k=nint(vres(jj))
                                iz=nzTot(k)
                                if(iz.gt.0) then
                                   if(nox(iz).eq.noxc(iz)) then
                                      if(jj.lt.jp2) then
                                         do jjj=jj+1,jp2
                                            vres(jjj-1)=vres(jjj)
                                         enddo
                                         jp2=jp2-1
                                      endif
                                   else
                                      jj2=jj2+1
                                   endif
                                endif
                             enddo
                             if(jj2.gt.5) then
                                ncard=jj2/5
                                nrest=jj2-ncard*5
                                kj1=jp+4+jpara
                                dircur='sum'
                                do l=1,ncard
                                   kj2=kj1+4
                                   if(l.eq.ncard.and.nrest.eq.0) then
                                     write(text,301) dircur ,
     *			                     (Lab(nint(vres(jj))),jj=kj1,kj2),
     *			                     (It1(nint(vres(jj))),jj=jp+4,jp+4+jpara-1)
                                   else
                                      write(text,300) dircur ,sigma,
     *			                      (Lab(nint(vres(jj))),jj=kj1,kj2)
                                   endif
                                   ncard12=ncard12+1
                                   write(ncpu,'(a80)') text
                                   dircur='cont '
                                   kj1=kj1+5
                                enddo
                                if(nrest.gt.0) then
                                   kj2=kj1+nrest-1
                                   write(text,301) dircur ,
     *			                   (Lab(nint(vres(jj))), jj=kj1,kj2),
     *			                   (It1(nint(vres(jj))),jj=jp+4,jp+4+jpara-1)
                                   ncard12=ncard12+1
                                   write(ncpu,'(a80)') text
                                endif
                             else
                                write(text,300) 'sum  ',sigma,
     *			                (Lab(nint(vres(jj))),
     *			                jj=jp+4+jpara,jp+4+jpara+jj2-1),
     *			                (It1(nint(vres(jj))),jj=jp+4,jp+4+jpara-1)
                                 ncard12=ncard12+1
                                 write(ncpu,'(a80)') text
                             endif
                          endif
                       endif
                    case (6)		          ! limit
!--controllo numero di atomi e numero di parametri
                       if(natom.eq.NatMol.or.natom.eq.0) then
!--tutti gli atomi----------
                          write(text,400) 'limit',(vres(jp+1+j),j=1,3)
                          ncard12=ncard12+1
                          write(ncpu,'(a80)') text
                       else
!--solo alcuni atomi---------
                          noxc(:)=0
                          jp1=jp+5
                          jp2=jp1+natom-1
                          do jj=jp1,jp2
                             k=nint(vres(jj))
                             iz=nzTot(k)
                             if(iz.gt.0) then
                                noxc(iz)=noxc(iz)+1
                             endif
                          enddo
!--ho calcolato il numero di atomi di una specie chimica
                          ll2=0
                          do l=1,20
                             if(noxc(l).gt.0) then
                                if(nox(l).eq.noxc(l)) then
!--tutti gli atomi di quella specie chimica sono presenti
                                   ll2=ll2+1
                                   naxc(ll2)=nax(l)
                                   noxca(ll2)=noxc(l)
                                endif
                             endif
                          enddo
                          ll3=0
                          if(ll2.gt.0) then
!--sono presenti tutti gli atomi di una specie chimica
                             natox=0
                             do l=1,ll2
                                natox=natox+noxca(l)
                             enddo
!--tutti gli atomi sono definiti dalle loro specie chimiche (ll3=1)
                             if(natox.eq.natom) ll3=1
!--definisco gli atomi con la sola specie chimica
                             write(text,400) 'limit',(vres(jp+1+j),
     *			                   j=1,3),(naxc(jj),jj=1,ll2)
                             ncard12=ncard12+1
                             write(ncpu,'(a80)') text
                          endif
!--fine definizione di atomi dalla loro specie chimica
                          if(ll3.eq.0) then
!--caso in cui ci sono altri atomi da inserire
                             jj2=0
                             do jj=jp1,jp2
                                k=nint(vres(jj))
                                iz=nzTot(k)
                                if(iz.gt.0) then
                                   if(nox(iz).eq.noxc(iz)) then
                                      if(jj.lt.jp2) then
                                         do jjj=jj+1,jp2
                                            vres(jjj-1)=vres(jjj)
                                         enddo
                                         jp2=jp2-1
                                      endif
                                   else
                                      jj2=jj2+1
                                   endif
                                endif
                             enddo
                             if(jj2.gt.5) then
                                ncard=jj2/5
                                nrest=jj2-ncard*5
                                kj1=jp+5
                                dircur='limit'
                                do l=1,ncard
                                   kj2=kj1+4
                                   if(l.gt.1) then
                                      write(text,301) dircur ,
     *			                      (Lab(nint(vres(jj))),jj=kj1,kj2)
                                   else
                                      write(text,400) dircur ,
     *		                          (vres(jp+1+j),j=1,3),
     *			                      (Lab(nint(vres(jj))), jj=kj1,kj2)
                                   endif
                                   ncard12=ncard12+1
                                   write(ncpu,'(a80)') text
                                   dircur='cont '
                                   kj1=kj1+5
                                enddo
                                if(nrest.gt.0) then
                                   kj2=kj1+nrest-1
                                   write(text,301) 'cont',
     *			                   (Lab(nint(vres(jj))),jj=kj1,kj2)
                                   ncard12=ncard12+1
                                   write(ncpu,'(a80)') text
                                endif
                             else
                                write(text,400) 'limit',(vres(jp+1+j),
     *			                j=1,3),(Lab(nint(vres(jj))),jj=jp+5,jp+5+jj2-1)
                                ncard12=ncard12+1
                                write(ncpu,'(a80)') text
                             endif
                          endif
                       endif
                    case (7)		          ! Site
!--controllo numero di atomi e numero di parametri
                       write(text,301) 'site ',
     *			            (Lab(nint(vres(jj))),jj=jp+4,jp+4+natom-1)
                       ncard12=ncard12+1
                       write(ncpu,'(a80)') text
                end select
            endif
            jp = jp + natom + incr + npara + jpara
         enddo
      enddo
      call x62end_Restraint(ncard12)
!      
  100 format(a,1x,f8.3,f9.5,1x ,5a8)
  200 format(a,1x,f9.5,1x ,5a8)
  201 format(a,1x,5a8)
  300 format(a,1x,f9.5,1x ,6a8)
  301 format(a,1x,6a8)
  400 format(a,1x,3f7.4,1x,5a8)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine MNQDStampaRefCond(erres)
      USE General
      USE Atomi
      USE LsqGroupsStuff
      USE LsqStuff
      USE LsqStuff12
      USE LsqStuff12_byUser
      USE LsqRestraint
      USE LsqStuff22Abs
!
!-- apre iscra scratch-unformatted-direct access
!
!--n12 n. di istruzioni fornite
!  istore(l12)=codice della prima istruzione
!              1  diag
!              2  full
!              3  block
!
!          nbl12   =  number of blocks
!                  =  1 if full matrix
!                  =  n5+1 if diagonal
!                  =  n. block if block
!
!
      common /ifLiXX/ ifLi04,ifLi05,ifLi06,ifLi12
      character*80 line
      character groupch*7
!
      data groupch/'group  '/   
!
      line = 'Refinement conditions '
      write(iscra,'(a)') line(1:Lung(line))
      write(iscra,'(a)') ' '
!
!-- checks if LIST 6 exists
!
      if (InfoOK(6).gt.0) then
!          call LoadReflInfo
          CutOffB=cutoff
          write(iscra, 90) nrefltot
          write(iscra, 95) nreflObs 
          write(iscra,100) CutOffB
          write(iscra, 96) nonoss,nescl
          if (NParTot.gt.0) then
              write(iscra,110) NParTot
              RatioOP = nreflObs / float(NParTot)
              write(iscra,120) RatioOP
          endif
      else
          write(iscra,200)
      endif
      if (rflsq.gt.0.0) then
!      if (erres.gt.0.0) then
*         write(iscra,210) erres*100.0
          write(iscra,210) rflsq, rwflsq 
          write(iscra,220) slsq
          write(iscra,230) shiftesd(1:2)
      endif
      
   90 format(
     * 'Total number of observations = ',i6)
   95 format(
     * 'Number of observations       = ',i6,' greater than Cutoff')
   96 format(
     * 'Number of unobserved         = ',i6,/,
     * 'Number of omitted            = ',i6)
  100 format(
     * 'Reflections Cutoff           = ',f6.1)
  110 format(
     * 'Number of parameters         = ',i6)
  120 format(
     * 'Observ. per parameters       = ',f6.1)
  200 format('No reflections stored')
  210 format(
     * 'Last R% value (wR%)          = ',f6.2,' (',f6.2,')')
  220 format(
     * 'Goodness of Fit (S)          = ',f6.2)
  230 format(
     * 'Shift/su max and min         = ',2f6.2)

!      write(iscra,'(a)') ' '
!
!-- checks if LIST 4 exists
!
      if (InfoOK(4).gt.0) then
          call PrintWeight(iscra)
      else
          write(iscra,600)
  600     format(/,'No weighting scheme stored',/)
!	  write(iscra,'(a)') ' '
      endif
!
!-- checks if LIST 12 exists
!
      if (InfoOK(62).gt.0) then
          call PrintRefi(iscra)
!--scrive le direttive FIXED by User 
          if(NumCond12_byUser.gt.0) then      
             write(iscra,1010) NumCond12_byUser
1010         format(' Conditions for the refinement by User',i5)
             do m=1,NumCond12_byUser
                call shift(stringa12_byUser(m),l1)
                write(iscra,'(i4,2a)')m,') ',stringa12_byUser(m)(1:l1)
             enddo
             write(iscra,"(' ')")
          endif
!--scrive le direttive restraint 
          if(NumRestraint.gt.0) then
             write(iscra,1014) NumRestraint
1014         format(' No. of directives for restraint(s)',i5)
             do i=1,NumRestraint
                call shift(stringaRestraint(i),l1)
                write(iscra,'(i4,2a)') i,') ',stringaRestraint(i)(1:l1)
             enddo
             write(iscra,"(' ')")
          endif
          if(NumGroup.gt.0) then
!--scrive le direttive Group 
             in=sum(ifGroupRefined(1:NumGroup))
             if(in.gt.0) then
                write(iscra,1015)in 
1015            format(' No. of Constraint(s)',i5)
                do i=1,NumGroup
                   if(ifGroupRefined(i).ne.0) then
                      call shift(aLabGroup(i),len)
                      line=groupch//aLabGroup(i)(1:len)
                      call shift(line,len)
                      write(iscra,'(i4,2a)')  i,') ',line(1:len)
                   endif
                enddo
                write(iscra,"(' ')")
             endif
          endif
      else
          write(iscra,1200)
 1200     format(/,'No refinement conditions stored',/)
      endif
!
      return
      end
!      
!-----------------------------------------------------------------------
      subroutine MNQDStampaAtCond
      USE General
      USE Atomi
      USE LsqStuff
      USE LsqModule
      USE LsqGroupsStuff
      USE LsqStuff12
!
      common /ifLiXX/ ifLi04,ifLi05,ifLi06,ifLi12
      dimension xyzob(15),foocc(4)
      character*16 NomeGroup
      character*16 LabbT
      character*8 Lab8
      character*4 Lspecie(5)
      character*3 Comment(15),CommB
      character*80 line,str
      character*30 Parametri
      character*6 Parcur1,Parcur2,ParBiso
      dimension nna(20),nno(20),iadr(18)
      dimension naX(18),noX(18)
      character*2 iasch
      character*25 Aline(3)
      character*1 kcod1,kcod2
      data iasch/'*!'/ 
!
      imixed=0
      nPar15=11
!--check if groups are present
      if(NGroup12.eq.1) then
        nPar15=14      ! do not consider  rotation angle per group
      else
!--check if there are mixed atom sites
        do i=1,nats
          if(iSite(i).gt.0) then
            nPar15=15
            imixed=1
            exit
          endif
        enddo
      endif
      ParBiso='B[iso]'
      Parametri = 'X Y Z B(111213222333Octhphpsal'
      line = ' Atoms conditions '
      write(iscra,'(a)') line(1:Lung(line))
         noX(:)=0
         naX(:)=0
!
!-- checks if LIST 5 exists
!
      if (InfoOK(5).gt.0) then
          write(iscra,1500) nats
          write(iscra,1510) FcScale
          write(iscra,1520) FcBiso
          write(iscra,1530) FcExtin
          write(iscra,1540) FcPola
          write(iscra,1541) FcTwin
          line = ' '
          write(iscra,'(a)') ' '
          line =
     *    'Atom        X           Y           Z          Occ        B['
     *     //                                                 'Iso]    '
          write(iscra,'(a)') line(1:Lung(line))
          line =
     *    '            11          12          13          22          '
     *     //                                 '23          33'
          write(iscra,'(a)') line(1:Lung(line))
          if(imixed.gt.0) then
          line =
     *    'Specie1    Occ1    Specie2    Occ2    Specie3    Occ3   '  
     *    //' Specie4    Occ4'
          write(iscra,'(a)') line(1:Lung(line))
          endif
          write(iscra,'(a)') ' '
          do i=1,nats
             imixed=iSite(i)
             lnz = nzTot(i)
             do l=1,nk
                if(naX(l).eq.0) then    
                   naX(l)=lnz
                   noX(l)=noX(l)+1
                   exit
                endif
                if(lnz.eq.naX(l)) then    
                   noX(l)=noX(l)+1
                   exit
                endif
             enddo
             do j=1,nPar15      
c                if (kFix(j,i).eq.1) then
                if (nParBl(j,i).eq.0) then
                    Comment(j) = '(F)'
                else
                    Comment(j) = '   '
                endif
             enddo
             CommB = Comment(11)            ! occupanza
             do j=10,4,-1
                Comment(j+1) = Comment(j)
             enddo
             Comment(4) = CommB
!--             if (kFix(11,i).eq.1) Comment(4) = '(F)'
             xyzob( 1) = xyzs(1,i)
             xyzob( 2) = xyzs(2,i)
             xyzob( 3) = xyzs(3,i)
             xyzob( 5) = bfac(i)
             xyzob( 4) = xyzs(5,i)
!             xyzob( 4) = bfac(i)
!             xyzob( 5) = xyzs(5,i)
             if (IsoAniso(i).eq.1) then
                 ifAnis = 10
                 xyzob( 6) = bij(1,i)
                 xyzob( 7) = bij(2,i)
                 xyzob( 8) = bij(3,i)
                 xyzob( 9) = bij(4,i)
                 xyzob(10) = bij(5,i)
                 xyzob(11) = bij(6,i)
             else
                 ifAnis = 5
             endif
!            call StringiStringa(Labb, 8)
             if (ifAnis.eq.5) then
                 write(iscra,1580) aLab(i)(1:8),
     *                   (xyzob(kk),Comment(kk),kk=1,5)
             else
                 write(iscra,1580) aLab(i)(1:8),
     *                   (xyzob(kk),Comment(kk),kk=1,5)
                 write(iscra,1590) (xyzob(kk),Comment(kk),kk=6,11)
             endif
!--print mixed atomic species
          if(iSite(i).gt.0)then
             imix = iSite(i)
             do j=1,imix
                ksp1 = int(SiteInfo(j,i)) / 10    ! specie   
                occ  = amod(SiteInfo(j,i),10.0)   ! occupazione  
                Lspecie(j)=species(ksp1)
                call ucase(Lspecie(j)(1:1))
                foocc(j)=occ
             enddo  
             write(iscra,1585)(Lspecie(kk),foocc(kk),kk=1,imix)
 1585        format(4(a,5x,f8.5,2x))
          endif
!
!-- equivalence conditions
!
!-----	     if (iEquiv(11,1,i).ne.0) then
             if (ckEquiv(i).ne.0) then
                 do 1560 j=1,nPar15
                    iparam = iEquiv(j,3,i)
                    if (iparam.ne.0) then
                        ifatt = iEquiv(j,1,i)
                        fattore = float(ifatt) / 1000.0
                        k = iEquiv(j,2,i)
                        j1=(j-1)*2+1
                        j2=j1+1
                        j3=(iparam-1)*2+1
                        j4=j3+1
                        Parcur1=Parametri(j3:j4)
                        if (j.eq.4) Parcur1=ParBiso
                        Parcur2=Parametri(j1:j2)
                        if(iparam.eq.4) Parcur2=ParBiso
                        L = Lung(aLab(i))
                        Labb = aLab(i)
                        if(k.gt.nats) then
                           LabbT = aLabGroup(k-nats)
                        else
                           LabbT = aLab(k)
                        endif  
                        L = Lung(aLab(k))
                        if (ifatt.ne.1000) then
                            call StringiStringa(LabbT, 8)
                            call StringiStringa(Labb, 8)
                            write(str,1610) LabbT ,Parcur1,
     *                                      Labb   ,Parcur2,
     *                                      fattore
                        else
                            write(str,1620) LabbT ,Parcur1,
     *                                      Labb   ,Parcur2
                        endif
                        k = 0
                        call onebl(str,k,ier)
                        write(iscra,1630) str(1:k)
                    endif
 1560            continue
             endif
             ifG = nGrCode(i)
             if (ifG .gt. 0) then
                 l = Lung(aLabGroup(ifG))
                 write(iscra,1565) aLab(i)(1:8),aLabGroup(ifG)(1:l)
 1565            format(10x,a,' belongs to the group: ',a)    
             endif              
!
          enddo
          write(iscra,1092)
1092      format(/,' Statistics:')
          do l=1,20
             if(naX(l).eq.0) exit
             lnz = naX(l)
             write(iscra,1097) l,nalf(lnz),noX(l)
1097         format(1x,i3,') species ',a4,' - no. of atom(s) ',i5)
          enddo
!1097  format(1x,i3,') species ',a4,' - no. of atom(s) ',i5)
!--connectivity
          if (iconn(1).le.0) goto 2000
          nco=iconn(1)
          if (nco.gt.0) then
              write(iscra,1240)nco
              nlin=nco/3 
              nrest=nco - nlin*3
              if(nrest.gt.0) nlin = nlin + 1
              j = 2
              nbo=1
              do l=1,nlin
                 Aline(1:3)=' '
                 do kl=1,3
                    if(nbo.gt.nco) exit
                    lj=iabs(iconn(j))
                    kj=iabs(iconn(j+1))
                    nj=iconn(j+2)
                    if(nj.lt.0) then 
                       Aline(kl)=blank//'  !      -   !      '
                    else
                       kcod1=' '
                       if(iconn(j).lt.0)kcod1=iasch(1:1) 
                       kcod2=' '
                       if(iconn(j+1).lt.0)kcod2=iasch(1:1) 
                       Aline(kl)=blank//kcod1//aLab(lj)(1:8)// '- '
                       Aline(kl)=Aline(kl)(1:12)//kcod2//aLab(kj)(1:8)
                    endif
                    nbo=nbo+1
                    j=j+3
                 enddo
                 write(iscra,'(3a)') Aline(1:3)   
              enddo   
          endif
2000      continue
          write(iscra,"(' ')")
      else
          write(iscra,1600)
      endif
!
 1240 format(/, ' Connectivity table - bond list ',/
     1,' Number of bonds:',i4,/)
 1250 format(1x,3(a1,2a4,'- ',a1,2a4,4x))
 1260 format(1x,2(a1,2a4,'- ',a1,2a4,4x))
 1270 format(1x,1(a1,2a4,'- ',a1,2a4,4x))
 1500 format('     No. atoms stored        =',i5)
 1510 format('     Overall Fc Scale Factor =',f10.4)
 1520 format('     Overall Thermal Factor  =',f10.4)
 1530 format('     Extinction Factor       =',f10.4)
 1540 format('     Polarity (Flack) Factor =',f10.4)
 1541 format('     Twinning Fract Component=',f10.4)
 1580 format(a8,5(f9.5,a3))
 1590 format(8x,6(f9.5,a3))
 1600 format('No coordinates stored')
 1610 format('Equivalence: ',a8,1x,a6,' = ',a8,1x,a6,' * ',f8.3)
 1620 format('Equivalence: ',a8,1x,a6,' = ',a8,1x,a6)
 1630 format(10x,a)
!
      return
      end
!-----------------------------------------------------------------------
!--routine relative all'agreement      
! ---------------------------------------------------------------------
code from spec2006.f (SIR)
      subroutine finish_agreement(agrvet, agrstr)
      USE General
      USE Molcom
!
      real*8 agrvet(*)
      character*(*) agrstr
!      
          call finish_agreement_exeMNQD(agrvet, agrstr)
      return
      end
!      
! ---------------------------------------------------------------------
      subroutine init_agreement(intervals, ier)
      USE General
      USE Limits      
      USE Molcom
      USE Riflessi
      USE RiflessiNew
!
      integer :: ier
      real intervals(2,10)
      dimension caoscond(10)
      data caoscond/8,9,10,4,1,5,6,7,2,3/
!
!-- chiamata per riempire intervals con i valori min e max di:
!   1   [Sin(Theta)/Lambda]^2
!   2   2 Theta
!   3   Resol.
!   4   Fo
!   5   Fc
!   6   Fo/Fc
!   7   (Fo-Fc)/Fo
!   8   h
!   9   k
!  10   l
!
      ier = 0
      if (nrefl == 0) then
          write(Msg,140)
  140     format('Agreement info not available,',
     *           ' no reflections supplied.')
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          ier = -1
          return
      endif
!-------------------------------------------------------------
!--check if list 68 (limiti) non esiste
!-------------------------------------------------------------
         if(InfoOK(68).eq.0) then      
            CodeLimit(:) = -1
            VetClassiParita(:)=-1 
            NumOmit=0 
            call CalcolaLimitData(1)
            DataMinLim =  TempMinLim 
            DataMaxLim =  TempMaxLim
            call CalcolaLimitData(3)
            AgreMinLim =  TempMinLim 
            AgreMaxLim =  TempMaxLim
            infoOK(68)=1
         endif
!-------------------------------------------------------------
!--chiama la routine di lettura dei riflessi
c--ksubr= 12 carico gli osservati ed gli esclusi da agreement  (escludo non osservati)
         ksubr=12
         ier=0
         call LeggiRiflessi(ier,ksubr)
         nreflX=NreflKsubr
!-------------------------------------------------------------
!--inserisci i limiti cei vettori per la grafica         
         lk=1
         intervals(1,lk)=AgreMinLim%Rho
         intervals(2,lk)=AgreMaxLim%Rho
         lk=lk+1
         intervals(1,lk)=AgreMinLim%Th2
         intervals(2,lk)=AgreMaxLim%Th2
         lk=lk+1
         intervals(1,lk)=AgreMinLim%Resol
         intervals(2,lk)=AgreMaxLim%Resol
         lk=lk+1
         intervals(1,lk)=AgreMinLim%Fo
         intervals(2,lk)=AgreMaxLim%Fo
         lk=lk+1
         intervals(1,lk)=AgreMinLim%Fc
         intervals(2,lk)=AgreMaxLim%Fc
         lk=lk+1
         intervals(1,lk)=AgreMinLim%FoFc
         intervals(2,lk)=AgreMaxLim%FoFc
         lk=lk+1
         intervals(1,lk)=AgreMinLim%R
         intervals(2,lk)=AgreMaxLim%R
         lk=lk+1
         do j=1,3
            intervals(1,lk)=AgreMinLim%HKL(j) 
            intervals(2,lk)=AgreMaxLim%HKL(j) 
            lk=lk+1
         enddo  
!-------------------------------------------------------------
      return
      end
!            
! ---------------------------------------------------------------------
      subroutine finish_agreement_exeMNQD(agrvet, agrstr)
c--agreement routine      
!
!             agrvet(1) = action   ---> 1 = show reflections
!                                       2 = omit reflections
!                                       3 = reset conditions
!             agrvet(2) =          ---> 1 = show/omit using condition
!                                  ---> 2 = show/omit class of reflections
!                                  ---> 3 = show/omit single reflections
!                                  ---> 4 = show/omit/reset all
!             agrvet(3) = minimo        se agrvet(2) = 1
!                         indice classe se agrvet(2) = 2
!                         valore di h   se agrvet(2) = 3
!             agrvet(4) = massimo       se agrvet(2) = 1
!                         valore di k   se agrvet(2) = 3
!             agrvet(5) =  indice cond. se agrvet(2) = 1  (valori interni)
!                         -indice cond. se agrvet(2) = 1  (valori esterni)
!                         valore di l   se agrvet(2) = 3
!
      USE General
      USE Molcom
      USE Riflessi
      USE RiflessiNew
      USE Limits
!
      real*8 agrvet(*)
      character*(*) agrstr
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
!      
      ier = 0
      iagr = nint(agrvet(1)) * 10 + nint(agrvet(2))
      ncwuB = ncwu
      if(QualePgm .ne. CAOSPGM) then
         itype=1
         iform=1
         jop=jopen(jrel,' ',itype,iform,ier)
         ncwu = jrel
      endif
!
!-- chiamate alle routine che producono l'output su NCWU
!
      if (iagr.eq.14) then
c--agreement completo
          call newagrMNQD(ier)
      else
         Inte = 'Agreement'
c--agreement parziali
         call newsup6MNQD(iagr,agrvet,agrstr,nOmitted,ier)
      endif
c--aggiorno code riflessi
      ij = 1
      do i=1, nreflTot
          obsCode = refl%observed(i)
          if (obsCode == 1) cycle       ! riflesso non osservato
          refl%observed(i) = CodeRefl(ij)
          ij = ij + 1
      enddo
!--messaggi
      if (iagr.eq.34) then
          Msg = 'All omit conditions have been removed!!!'
          call MsgWinErr(Inte, Msg, INFO_WINDOW, nExitCode)
      else
          if (ier.lt.0) then
              select case (iagr)
                     case (11,21,31)
                       Msg = 'No reflections selected !!' //
     *                       ' Wrong condition ' // char(10) // agrstr
                       call MsgWinErr(Inte, Msg, WARN_WINDOW, nExitCode)
                     case (12,22,32)
                       Msg = 'No reflections selected !!' //
     *                       ' Wrong class ' // char(10) // agrstr
                       call MsgWinErr(Inte, Msg, WARN_WINDOW, nExitCode)
                     case (13,23,33)
                       Msg ='Reflection 123412341234  does not exist!!'
                       ih = nint(agrvet(3))
                       ik = nint(agrvet(4))
                       il = nint(agrvet(5))
                       write(Msg(12:23),'(3i4)') ih,ik,il
                       call MsgWinErr(Inte, Msg, WARN_WINDOW, nExitCode)
                     case (14)
                       Msg ='ERROR' // char(10) //
     *                      'Cannot show all reflections !!!'
                       call MsgWinErr(Inte, Msg, ERR_WINDOW, nExitCode)
              end select
          else
              select case (iagr)
                     case (21)
                       Msg ='       reflections have been omitted using'
     *                 // ' the condition ' // char(10) // agrstr
                       write(Msg(1:6),'(i6)') nOmitted
                       call MsgWinErr(Inte, Msg, INFO_WINDOW, nExitCode)

                     case (31)
                     Msg ='       reflections have been reset using'
     *                 // ' the condition ' // char(10) // agrstr
                     write(Msg(1:6),'(i6)') nOmitted
                       call MsgWinErr(Inte, Msg, INFO_WINDOW, nExitCode)

                     case (22)
                     Msg ='       reflections have been omitted using'
     *                 // ' the class ' // char(10) // agrstr
                     write(Msg(1:6),'(i6)') nOmitted
                       call MsgWinErr(Inte, Msg, INFO_WINDOW, nExitCode)

                     case (32)
                     Msg ='       reflections have been reset using'
     *                 // ' the class ' // char(10) // agrstr
                     write(Msg(1:6),'(i6)') nOmitted
                       call MsgWinErr(Inte, Msg, INFO_WINDOW, nExitCode)


                     case (23)
                     Msg ='The reflection 123412341234  have been '
     *                 // ' omitted.'
                     ih = nint(agrvet(3))
                     ik = nint(agrvet(4))
                     il = nint(agrvet(5))
                     write(Msg(16:27),'(3i4)') ih,ik,il
                       call MsgWinErr(Inte, Msg, INFO_WINDOW, nExitCode)

                     case (33)
                     Msg ='The reflection 123412341234  have been '
     *                       // ' reset.'
                     ih = nint(agrvet(3))
                     ik = nint(agrvet(4))
                     il = nint(agrvet(5))
                     write(Msg(16:27),'(3i4)') ih,ik,il
                     call MsgWinErr(Inte, Msg, INFO_WINDOW, nExitCode)

              end select
          endif
          if (iagr.lt.20.and.ier.ge.0) then
              kBro = 7
             if(QualePgm .ne. CAOSPGM) call BrowserV2(kBro)
          endif
      endif
      if(QualePgm .ne. CAOSPGM) close(jrel)
      ncwu = ncwuB
c      rewind jhost
!
      return
      end
c
code for newsup6
      subroutine newsup6MNQD(iagr,agrvet,agrstr,nxxa,ier)
c--update list 6
!
!             agrvet(1) = action   ---> 1 = show reflections
!                                       2 = omit reflections
!                                       3 = reset conditions
!             agrvet(2) =          ---> 1 = show/omit using condition
!                                  ---> 2 = show/omit class of reflections
!                                  ---> 3 = show/omit single reflections
!                                  ---> 4 = show/omit/reset all
!             agrvet(3) = minimo        se agrvet(2) = 1
!                         indice classe se agrvet(2) = 2
!                         valore di h   se agrvet(2) = 3
!             agrvet(4) = massimo       se agrvet(2) = 1
!                         valore di k   se agrvet(2) = 3
!             agrvet(5) =  indice cond. se agrvet(2) = 1  (valori interni)
!                         -indice cond. se agrvet(2) = 1  (valori esterni)
!                         valore di l   se agrvet(2) = 3
!
!  code condizione limiti = -1 / 0 / 1
!  se -1 condizione da non applicare
!      0 condizione internal
!      1 condizione external
!
!  Significato del code del riflesso:
!  0	riflesso O.K. osservato
!  1	non osservato
! -1    riflesso 'omit'
! -2    escluso da condizioni sui limiti
!
      USE General
      USE Limits
      USE Atomi
      USE Riflessi
      USE LsqModule
!
      real*8 agrvet(*)
      character*(*) agrstr
c--
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      real, allocatable :: xbuffer(:,:)
c
      character*5 shrese(3)
      data shrese/'Show ','Omit ','Reset'/
c--                                                                     
c--scale of /fo/
      scalc=abs(FcScale)
      scalo=1.0
c--
c      write(ncwu,5001)
c5001  format(1h ,78(1h-))
      icodeFo=IcodeFo4
      if(icodeFo.eq.2) then
            scalc=scalc**2
            scalo=scalo**2
      endif
c
c--check reset all coditions
      if(iagr.eq.34) then
         iaction=3
         nxxa=0
         do i=1,nreflX
            if(CodeRefl(i).lt.0) then
               nxxa=nxxa+1 
               CodeRefl(i)=0
            endif
         enddo
!--reset codici         
         VetClassiParita(:)=-1	
         CodeLimit(:)=-1
         NumOmit=0
c--devo ripristinare i valori iniziali (devo chiamare la routine)         
         call CalcolaLimitData(3)
         AgreMinLim =  TempMinLim 
         AgreMaxLim =  TempMaxLim
c--reset preambe lista 6
         nescl=0
         goto 9999
      endif
      mdxxa=7
      IF (.NOT. ALLOCATED(xbuffer))
     *	  ALLOCATE (xbuffer(1:mdxxa,1:nreflX), stat = ierr)
      if (ierr.ne.0) then
          write(ncwu,*) 'Rflct xbuffer Allocation error'
          call cstop(' ')
      endif
c--vettori per il sorting di stampa      
      work1(1:nreflX)=0.0
      iwork1(1:nreflX)=0
c
c--define show/omit/reset flag
      iaction=nint(agrvet(1))
c
c--check condition/class/single reflect request
      icondclass=nint(agrvet(2))
c
c--condition request
!-- nella finestra di Sir
!   1   [Sin(Theta)/Lambda]^2
!   2   2 Theta
!   3   Resol.
!   4   Fo
!   5   Fc
!   6   Fo/Fc
!   7   (Fo-Fc)/Fo
!   8   h
!   9   k
!  10   l
!
c  code = -1 / 0 / 1
c  se -1 condizione da non applicare
c      0 condizione internal
c      1 condizione external
!
      select case (icondclass)
         case(1)
            ier=0
            icond=nint(agrvet(5))
            icond=iabs(icond)
            internal=0
            if(agrvet(5).lt.0.0) internal=1
            a=agrvet(3)
            b=agrvet(4)
            if(a.gt.b) then
               ier=-1
               goto 9999
            endif
            select case (icond)
               case (1)
                  if(a.lt.0.0.or.b.gt.1.) then
                     ier=-1
                     goto 9999
                  endif   
                  AgreMinLim%Rho = a
                  AgreMaxLim%Rho = b
               case (2)
                  if(a.lt.0.0.or.b.gt.180.) then
                     ier=-1
                     goto 9999
                  endif
                  AgreMinLim%Th2 = a
                  AgreMaxLim%Th2 = b
               case (3)
                  AgreMinLim%Resol = a
                  AgreMaxLim%Resol = b
               case (4)
                  AgreMinLim%Fo = a
                  AgreMaxLim%Fo = b
               case (5)
                  AgreMinLim%Fc = a
                  AgreMaxLim%Fc = b
               case (6)
                  AgreMinLim%FoFc = a
                  AgreMaxLim%FoFc = b
               case (7)
                  AgreMinLim%R = a
                  AgreMaxLim%R = b
               case (8)
                  AgreMinLim%HKL(1) = a
                  AgreMaxLim%HKL(1) = b
               case (9)
                  AgreMinLim%HKL(2) = a
                  AgreMaxLim%HKL(2) = b
               case (10)
                  AgreMinLim%HKL(3) = a
                  AgreMaxLim%HKL(3) = b
            end select      
            CodeLimit(icond)=internal      
            if(iaction.eq.3)CodeLimit(icond)=-1.                 
c--inizio loop sui riflessi
            k1=0
            nchg=0
            n4z=0
            nxxa=0
            do k=1,nreflX
               nn=CodeRefl(k)
               if(nn.ne.-1) then   ! riflesso omit singolarmente
                  if(iaction.eq.3.or.nn.eq.0) then
                     iprint=0
                     ss=sqrt(rhov(k))
                     select case (icond)
                        case (1)
                           c=rhov(k)
                           if(internal.eq.0) then
                              if(rhov(k).ge.AgreMinLim%Rho.and.
     *                           rhov(k).le.AgreMaxLim%Rho) iprint=1
                           else
                              if(rhov(k).lt.AgreMinLim%Rho.or.
     *                           rhov(k).gt.AgreMaxLim%Rho) iprint=1
                           endif                              
                        case (2)
!-----------------------------2theta
                           if(wavel.gt.0.2.and.wavel.lt.2.5) then
                              a=ss*wavel
                              c=2.0*asin(a)*rtd
                              if(internal.eq.0) then
                                 if(c.ge.AgreMinLim%Th2.and.
     *                              c.le.AgreMaxLim%Th2) iprint=1
                              else
                                 if(c.lt.AgreMinLim%Th2.or.
     *                              c.gt.AgreMaxLim%Th2) iprint=1
                              endif                              
                           else
!-----------------------------messaggio di errore (Wave not defined)!                           
                           endif
                        case (3)
!----------------------------calculate resolution 
                           c=0.5/ss
                           if(internal.eq.0) then
                              if(c.ge.AgreMinLim%Resol.and.
     *                           c.le.AgreMaxLim%Resol) iprint=1
                           else
                              if(c.lt.AgreMinLim%Resol.or.
     *                           c.gt.AgreMaxLim%Resol) iprint=1
                           endif                              
                        case (4)
                           c=fovet(k)
                           if(internal.eq.0) then
                              if(fovet(k).ge.AgreMinLim%Fo.and.
     *                           fovet(k).le.AgreMaxLim%Fo) iprint=1
                           else
                              if(fovet(k).lt.AgreMinLim%Fo.or.
     *                           fovet(k).gt.AgreMaxLim%Fo) iprint=1
                           endif                              
                        case (5)
                           c = fcvet(k)*abs(FcScale)  
                           if(internal.eq.0) then
                              if(c.ge.AgreMinLim%Fc.and.
     *                           c.le.AgreMaxLim%Fc) iprint=1
                           else
                              if(c.lt.AgreMinLim%Fc.or.
     *                           c.gt.AgreMaxLim%Fc) iprint=1
                           endif                              
                        case (6)
                           fc = fcvet(k)*abs(FcScale)  
                           if(fc.gt.0.001) then
                              c=fovet(k)/fc
                              if(internal.eq.0) then
                                 if(c.ge.AgreMinLim%FoFc.and.
     *                              c.le.AgreMaxLim%FoFc) iprint=1
                              else
                                 if(c.lt.AgreMinLim%FoFc.or.
     *                              c.gt.AgreMaxLim%FoFc) iprint=1
                              endif
                           else
!-----------------------------message warning! (Fc too small!)                           
                           endif                                 
                        case (7)
                           if(fovet(k).gt.0.001) then
                              fc = fcvet(k)*abs(FcScale)  
                              c=abs(fovet(k)-fc)/fovet(k)        
                              if(internal.eq.0) then
                                 if(c.ge.AgreMinLim%R.and.
     *                              c.le.AgreMaxLim%R) iprint=1
                              else
                                 if(c.lt.AgreMinLim%R.or.
     *                              c.gt.AgreMaxLim%R) iprint=1
                              endif
                           else
!-----------------------------message warning! (Fo too small!)                           
                           endif                                 
                        case (8,9,10)
                           n=icond-7
                           c=khl(n,k)
                           if(internal.eq.0) then
                              if(khl(n,k).ge.AgreMinLim%HKL(n).and.
     *                           khl(n,k).le.AgreMaxLim%HKL(n)) iprint=1
                           else
                              if(khl(n,k).lt.AgreMinLim%HKL(n).or.
     *                           khl(n,k).gt.AgreMaxLim%HKL(n)) iprint=1
                           endif                              
                     end select      
                     if(iprint.eq.1) then
                        nn=0
                        if(iaction.eq.2) then
                           nn=-2
                        endif
                        CodeRefl(k)=nn
                        nxxa=nxxa+1
                        xbuffer(1:3,nxxa)=khl(1:3,k)
                        xbuffer(4,nxxa)=fovet(k)
                        xbuffer(5,nxxa)=fcvet(k)*abs(FcScale)
                        xbuffer(6,nxxa)=rhov(k)
                        xbuffer(7,nxxa)=sigmav(k)
                        work1(nxxa)=c
                        iwork1(nxxa)=nxxa
                     endif    
                 endif
               endif
            enddo
c
c--class request
c--table of parity groups and hkl classes
c
c--code for parity
c--1   ggg
c--2   ggu
c--3   gug
c--4   guu
c--5   ugg
c--6   ugu
c--7   uug
c--8   uuu
c----------------
c--code for class
c--7   hkl + 8 = 15
c--6   0kl + 8 = 14
c--5   h0l + 8 = 13
c--4   00l + 8 = 12
c--3   hk0 + 8 = 11
c--2   0k0 + 8 = 10
c--1   h00 + 8 =  9
c----------------
c--code for class+parity
c--16  g00
c--17  u00
c--18  0g0
c--19  0u0
c--20  gk0
c--21  uk0
c--22  hg0
c--23  hu0
c--24  00g
c--25  00u
c--26  g0l
c--27  u0l
c--28  h0g
c--29  h0u
c--30  0gl
c--31  0ul
c--32  0kg
c--33  0ku
c-------------------
c  VetClassiParita(33)
c
         case(2)
            iclasse=nint(agrvet(3))
            if(iaction.eq.3) then
               VetClassiParita(iclasse)=-1
            else if(iaction.eq.2) then
               VetClassiParita(iclasse)=1
            endif
            k1=0
            nchg=0
            n4z=0
            nxxa=0
            do k=1,nreflX
               nn=CodeRefl(k)
               if(nn.ne.-1) then
                  if(iaction.eq.3.or.nn.eq.0) then
                     ihh=khl(1,k)
                     ikk=khl(2,k)
                     ill=khl(3,k)
                     ihh1=iabs(ihh)
                     ikk1=iabs(ikk)
                     ill1=iabs(ill)
                     if(iclasse.le.8) then
                        ipar=mod(ihh1,2)*4 + mod(ikk1,2)*2 + 
     *                       mod(ill1,2) + 1
                     else
                        ihkl=7
                        if(ihh.eq.0)ihkl=ihkl-1
                        if(ikk.eq.0)ihkl=ihkl-2
                        if(ill.eq.0)ihkl=ihkl-4
                        ipar=ihkl + 8
                        if(iclasse.gt.15) then
                           select case (ihkl)
                              case (1) 	   ! h00
                                 ipar=16+mod(ihh1,2)
                              case (2) 	   ! 0k0
                                 ipar=18+mod(ikk1,2)
                              case (3) 	   ! hk0
                                 ipar=20+mod(ihh1,2)
                                 if(iclasse.gt.21) ipar=22+mod(ikk1,2)
                              case (4) 	   ! 00l
                                 ipar=24+mod(ill1,2)
                              case (5) 	   ! h0l
                                 ipar=26+mod(ihh1,2)
                                 if(iclasse.gt.27) ipar=28+mod(ill1,2)
                              case (6) 	   ! 0kl
                                 ipar=30+mod(ikk1,2)
                                 if(iclasse.gt.31) ipar=32+mod(ill1,2)
                           end select
                        endif
                     endif
                     if(ipar.eq.iclasse) then
                        nn=0
                        if(iaction.eq.2) nn=-2
                        CodeRefl(k)=nn
                        nxxa=nxxa+1
                        xbuffer(1:3,nxxa)=khl(1:3,k)
                        xbuffer(4,nxxa)=fovet(k)
                        xbuffer(5,nxxa)=fcvet(k)*abs(FcScale)
                        xbuffer(6,nxxa)=rhov(k)
                        xbuffer(7,nxxa)=sigmav(k)
                        c=0.0
                        if(fovet(k).gt.0.001) then
                           fc = fcvet(k)*abs(FcScale)  
                           c=abs(fovet(k)-fc)/fovet(k)
                        endif        
                        work1(nxxa)=c*100.0
                        iwork1(nxxa)=nxxa
                     endif
                  endif
               endif
            enddo
c
c--single reflection request
         case(3)
            if(iaction.eq.3.and.NumOmit.eq.0)goto 9999
            ihx=nint(agrvet(3))
            ikx=nint(agrvet(4))
            ilx=nint(agrvet(5))
            k1=0
            nchg=0
            n4z=0
            nxxa=0
            do k=1,nreflX
               nn=CodeRefl(k)
               if(nn.ne.-2) then
                  if(iaction.eq.3.or.nn.eq.0) then
                     ihh=khl(1,k)
                     ikk=khl(2,k)
                     ill=khl(3,k)
                     if(ihx.eq.ihh.and.ikx.eq.ikk.and.ilx.eq.ill) then
                        iconta=0
                        if(iaction.eq.2) then
                           iconta=1
                           nn=-1
                           NumOmit=NumOmit+1
                           VetOmit(1:3,NumOmit)=khl(1:3,k)
                        else
                           if(nn.eq.-1) then
                              iconta=1
                              nn=0
                              do i=1,NumOmit
                                 if(VetOmit(1,i).eq.khl(1,k).and.
     2	                            VetOmit(2,i).eq.khl(2,k).and.
     3	                            VetOmit(3,i).eq.khl(3,k)) then
                                       if(i.lt.NumOmit) then
                                          i1=i
                                          do j=i+1,NumOmit
                                             VetOmit(1:3,i1)=
     *                                        VetOmit(1:3,j)
                                             i1=i1+1
                                          enddo   
                                       endif
                                       NumOmit=NumOmit-1
                                       exit
                                 endif
                              enddo
                           endif   
                        endif
                        CodeRefl(k)=nn
                        nxxa=nxxa+1
                        xbuffer(1:3,nxxa)=khl(1:3,k)
                        xbuffer(4,nxxa)=fovet(k)
                        xbuffer(5,nxxa)=fcvet(k)*abs(FcScale)
                        xbuffer(6,nxxa)=rhov(k)
                        xbuffer(7,nxxa)=sigmav(k)
                        c=0.0
                        work1(nxxa)=c
                        iwork1(nxxa)=nxxa
                        exit
                     endif
                  endif
               endif
            enddo
      end select
c
c--check numero riflessi selezionati
      if(nxxa.eq.0) then
         ier=-1
         goto 9999
      endif
c
c--sortizza risultato
      if(nxxa.gt.1) call SortInd(nxxa,iwork1,work1)
!
      write(ncwu,5000) shrese(iaction)
5000  format(/,1x,a,' analysis')
      if(icondclass.eq.1) write(ncwu,4010) agrstr,nxxa
4010  format(' Condition : ',a,/,' Reflection(s) selected :',i6,/,
     *       ' N.refl',3x,'h',3x,'k',3x,'l',5x,'Fo',6x,'Fc',
     2       6x,'d',7x,'w',6x,'wd2',4x,'R(F)%',3x,'Condition',/)
      if(icondclass.eq.2) write(ncwu,4011) agrstr,nxxa
4011  format(' Class : ',a,/,' Reflection(s) selected :',i6,/,
     *       ' N.refl',3x,'h',3x,'k',3x,'l',5x,'Fo',6x,'Fc',
     2       6x,'d',7x,'w',6x,'wd2',4x,'R(F)%',3x,/)
c--print the result
      fotot=0.0
      dftot=0.0
      do i=1,nxxa
         k=iwork1(i)
         ihh=xbuffer(1,k)
         ikk=xbuffer(2,k)
         ill=xbuffer(3,k)
         fobs=xbuffer(4,k)
         fcal=xbuffer(5,k)
         dif=fobs-fcal
         diff=abs(dif)
         dftot=dftot+diff
         fotot=fotot+fobs
         diff2=diff*diff
         fobs2=fobs*fobs
         st=sqrt(xbuffer(6,k))
         resol=0.5/st
         sigmaf=xbuffer(7,k)
         call CalcWeight(fobs,fcal,sigmaf,st,w1,n4z)
         d2w=diff2*w1*w1
         rr= 100.0*diff/fobs
         wrr=100.0*sqrt(d2w/(fobs2*w1*w1))
         w2=w1*w1
         if(icondclass.eq.1) then
            write(ncwu,4012)i,ihh,ikk,ill,fobs,fcal,diff,w2,d2w
     1	                    ,rr,work1(i)
4012        format(1x,i6,3i4,2f8.2,4f8.3,f12.5)
         else
            write(ncwu,4013)i,ihh,ikk,ill,fobs,fcal,diff,w2,d2w
     1	                    ,rr
4013        format(1x,i6,3i4,2f8.2,4f8.3)
         endif
      enddo
      rtot=100.0*dftot/fotot
      write(ncwu,'(/,59x,f8.3)')rtot
c
c--check if omit/reset conditions
      if(iaction.ne.1) then
c--rewrite the preamble block
         if(iaction.eq.2) then
            nescl=nescl+nxxa
            nreflObs=nreflObs-nxxa
            if(nreflObs.lt.0) nreflObs=0
         else if(iaction.eq.3) then
            if(icondclass.ne.3.and.iconta.gt.0) then
               nescl=nescl-nxxa
               if(nescl.lt.0) nescl=0
               nreflObs=nreflObs+nxxa
            endif
         endif
      endif
!
9999  continue
      write(ncwu,'(1h )')
      DEALLOCATE(xbuffer, stat =ierr)
      return
      end
c---------------------------------------------------------------------
c
code for newagrMNQD
      subroutine newagrMNQD(ier)
c
      USE General
      USE Atomi
      USE Riflessi
      USE LsqModule
      USE Limits
!
!--vettori dinamici per Agreement------------------------------
      real,     allocatable   :: xbuffer(:)
!-----------------------------------------------------------
!
      character*4 iclass(8),lkh(7),lkhgu(18)
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/workd/icod(30),ise(24),fud(4),nty,ityp(8),dummwd(3)
      dimension cod(30)
      equivalence(icod,cod)
!
      dimension norrif(1001),fo(2,1001)
      dimension der(120,3),contris(120)
      dimension fo1f(120),fo2f(120),dif1f(120),dif2f(120),sd2wf(120)
      dimension fc1f(120),npiu(120),nmeno(120),fscal(120)
      dimension	dif1fx(120),fo1fx(120),rfx(120)
      dimension fo1s(120),fo2s(120),dif1s(120),dif2s(120),sd2ws(120)
      dimension rf(120),rwf(120),rs(120),rws(120),sd2wfn(120)
      dimension aap(3),dep(3),det(3,3),aa(3),vvet(3)
      dimension indr(5),jhkl(7),nhkl(7),sd2wsn(120)
!--
      dimension ihkl(3)
!
      data iclass/'ggg ','ggu ','gug ','guu ','ugg ','ugu ',
     1	          'uug ','uuu '/
      data lkh/'h00 ','0k0 ','hk0 ','00l ','h0l ','0kl ',
     1	       'hkl '/
      data lkhgu/'g00 ','u00 ','0g0 ','0u0 ','gk0 ','uk0 ',
     1             'hg0 ','hu0 ','00g ','00u ','g0l ','u0l ',
     2             'h0g ','h0u ','0gl ','0ul ','0kg ','0ku '/
      data nhkl/3,3,5,3,5,5,1/
c
c-- set default values
      icod(:)=0
      icod(3)=8
      cod(4)=-1.0
      cod(6)=0.0
      cod(7)=-1.0
      icod(8)=0
      ier=0
      icod(5)=1
!                                                                           
      icodd=icod(5)
      icod3=icod(3)
!      
!  jump  < 0    sort in decreasing order
!  jump  > 0    sort in increasing order
c
c--ninter: n.di rifl. per intervallo
c--interv: n. di intervalli
c--scale of /fo/
      scalc=abs(FcScale)
      scalo=1.0
c--test      
c      rt=0.
c      fo1ft=0.
c      do  ky=1,nreflX
c            fobs=fovet(ky)
c            fcal=fcvet(ky)*scalc
c            dif=fobs-fcal
c            diff=abs(dif)
c            fo1ft=fo1ft+fobs
c            rt=rt+diff
c            write(lo,1)ky, fobs,fcal,diff,fo1ft,rt
c  1         format(1x,i5,')',3f10.4,2e20.6)         
c      enddo
c      rt=100.*rt/fo1ft
c      write(lo,9051)rt 
c9051  format(/,'  ******* R(F)%.....',f7.2,/)
c      write(lo,*) scalc,nreflX
c--fine test          
      write(ncwu,5001)
5001  format(1h ,78(1h-))
      write(ncwu,5000)
5000  format(/,' Agreement analysis')
      icodeFo=IcodeFo4
      if(icodeFo.eq.2) then
            scalc=scalc**2
            scalo=scalo**2
      endif
      if(nreflX.le.0)nreflX=nreflObs 
!      
c--sort peaks in order of plotting
!--sort in ordine crescente
!      call SortInd(nats25,jFlagAtom1,work25)
!             integer, allocatable :: iwork2(:)
!             integer, allocatable :: iwork1(:)
!             real, allocatable    :: work1(:)
!             real, allocatable    :: work2(:)
!      
      work1(1:nreflX)=fovet(1:nreflX)
      tmpwt(1:nreflX)=rhov(1:nreflX)
      do  k=1,nreflX
          iwork1(k)=k
          iwork2(k)=k
      enddo    
c--sort on Fo 
      call SortInd(nreflX,iwork1,work1)
      work1(1:nreflX) = fovet (1:nreflX)
c--sort on (sin(theta)/lambda)2
      call SortInd(nreflX,iwork2,tmpwt)
c
c--calculate the intervals
      intervx=120
      ninterx=120
      interv=0
      if(icod3.ne.8) interv=icod3
!--intervalli  Fo      
      jfirst=0
      kk=1
      call folimiMNQD(jfirst,interv,intervx,ninterx,norrif,fo,kk)
c
c--intervalli (sin(theta)/lambda)2
      jfirst=1
      kk=2
      call folimiMNQD(jfirst,interv,intervx,ninterx,norrif,fo,kk)
c--
c--sort on Fo and calculate the R(F) and wR%
c
c--calculate for each interval
300   d2wmin=1000
      d2wmax=0.
      d2wt1=0.
      do i=1,interv
         sd2wf(i)=0.
         fo1f(i)=0.
!         fo1fx(i)=0.
         fc1f(i)=0.
         fo2f(i)=0.
         dif1f(i)=0.
!         dif1fx(i)=0.
         dif2f(i)=0.
         npiu(i)=0
         nmeno(i)=0
         fscal(i)=0.0
      enddo
      rwt=0.
      rt=0.
      dif2ft=0.
      fo2ft=0.
      fo1ft=0.
!      fo1ftx=0.0
!      rtx=0.0
      nchg=0
      n4z=0
      do i=1,interv
         iniz=norrif(i)
         ifin=norrif(i+1)-1
         do k=iniz,ifin
            ky=iwork1(k)
            fobs=fovet(ky)
            fcal=fcvet(ky)*scalc
            dif=fobs-fcal
            diff=abs(dif)
            if(dif.lt.0.0) then
               nmeno(i)=nmeno(i)+1
            else
               npiu(i)=npiu(i)+1
            endif
            diff2=diff*diff
            fobs2=fobs*fobs
c	      fodif2=diff2*fobs2
            st=sqrt(rhov(ky))
            sigmaf=sigmav(ky)
            call CalcWeight(fobs,fcal,sigmaf,st,w1,n4z)
            d2w=diff2*w1*w1
            dif1f(i)=dif1f(i)+diff
            dif2f(i)=dif2f(i)+diff2
            fo1f(i)=fo1f(i)+fobs
            fc1f(i)=fc1f(i)+fcal
            fo2f(i)=fo2f(i)+fobs2*w1*w1
            sd2wf(i)=sd2wf(i)+d2w
            fo1ft=fo1ft+fobs
            rt=rt+diff
c            write(lo,*) k,fobs,fcal,diff,fo1f(i),dif1f(i)
c	write(ncwu,*)'k,dif1f(i),dif2f(i),fo1f(i),fo2f(i)',
c     1  k,dif1f(i),dif2f(i),fo1f(i),fo2f(i)
         enddo
         contrib=float(ifin-iniz+1)
c	write(ncwu,*)'i,dif1f(i),dif2f(i),fo1f(i),fo2f(i),contrib',
c     1 i,dif1f(i),dif2f(i),fo1f(i),fo2f(i),contrib
         rwf(i)=100.*sqrt(sd2wf(i)/fo2f(i))
         rf(i)=100.*dif1f(i)/fo1f(i)
c         fo1ft=fo1f(i)+fo1ft
         rwt=rwt+sd2wf(i)
c         rt=rt+dif1f(i)
         fo2ft=fo2ft+fo2f(i)
         dif2ft=dif2ft+dif2f(i)
         sd2wf(i)=sd2wf(i)/contrib
         dif2f(i)=dif2f(i)/contrib
         d2wt1=d2wt1+sd2wf(i)
         icont=int(contrib)
c         write(lo,*)i,rt,fo1ft
c	   write(ncwu,*) 'fo1f(i),fc1f(i)',fo1f(i),fc1f(i)
c         fscal(i)=fo1f(i)/fc1f(i)
c--modifica fo con la nuova scala e ricalcola r
c         do k=iniz,ifin
c            ky=iwork1(k)
c            fobs=fovet(ky)*scalo/fscal(i)
c            if(icod(8).eq.1) then
c               if(cod(9).lt.0.0) then
c                  fovet(ky)=fobs
c                  sigmav(ky)=sigmav(ky)*scalo/fscal(i)
c               else
c                  if(fovet(ky).le.cod(9)) then
c                     fovet(ky)=fobs
c                     sigmav(ky)=sigmav(ky)*scalo/fscal(i)
c                  endif
c               endif
c            endif
c            fcal=fcvet(ky)*scalc
c            diff=fobs-fcal
c            dif1fx(i)=dif1fx(i)+abs(diff)
c            fo1fx(i)=fo1fx(i)+abs(fobs)
c         enddo
c         rfx(i)=100.0*dif1fx(i)/fo1fx(i)
c         fo1ftx=fo1fx(i)+fo1ftx
c         rtx=rtx+dif1fx(i)
      enddo
c--end of calculation
      rtt=rt
      rwtt=rwt
      rt=100.*rt/fo1ft
!      rtx=100.*rtx/fo1ftx
      rwt=100.*sqrt(rwt/fo2ft)
      d2wt1=d2wt1/float(interv)
      write(ncwu,9050)rt,rwt 
9050  format(/,'  R(F)%.....',f7.2,
     1       /,' wR(F^2)%...',f7.2)
      write(ncwu,4003)
c
c--check if directive 'select' was given
      if(icod(10).eq.0) goto 1000
      goto(1000,1100,1200,1200,1200),icod(10)
c
c--table on Fo
1000  continue
            if(icod(10).eq.1) then
               write(ncwu,4010)
4010           format(' N.refl',2x,'h',3x,'k',3x,'l',5x,'Fo',6x,'Fc',
     2         6x,'d',7x,'w',6x,'wd2',4x,'R(F)%',3x,'Resol',/)
               ky=iwork1(1)
               if(cod(11).le.0.0)  cod(11)=fovet(ky)*scalo  ! limite inferiore
               ky=iwork1(nreflX)
               if(icod(12).le.0.0) cod(12)=fovet(ky)*scalo  ! limite superiore
               do i=1,nreflX
                  ky=iwork1(k)
                  fobs=fovet(ky)*scalo
                  if(fobs.lt.cod(11).or.fobs.gt.cod(12)) cycle
                  ihkl(1:3)=khl(1:3,ky)
                  fobs=fovet(ky)
                  fcal=fcvet(ky)*scalc
                  dif=fobs-fcal
                  diff=abs(dif)
                  diff2=diff*diff
                  fobs2=fobs*fobs
                  st=sqrt(rhov(ky))
                  worko(ky)=0.5/st
                  sigmaf=sigmav(ky)
                  call CalcWeight(fobs,fcal,sigmaf,st,w1,n4z)
                  d2w=diff2*w1*w1
                  rr= 100.0*diff/fobs
                  wrr=100.0*sqrt(d2w/(fobs2*w1*w1))
                  w2=w1*w1
                  write(ncwu,4011)i,ihkl,fobs,fcal,diff,w2,d2w
     1	          ,rr,worko(ky)
4011              format(1x,i5,3i4,2f8.2,5f8.3)
               enddo
               write(ncwu,4003)
            else
               write(ncwu,4000)
4000           format(2x,'N.refl',3x,'Total',7x,'Fo range',8x,'<d2>',6x,
     1         '<wd2>',5x,'R(F)%',3x,'wR(F^2)%',/)
c--write file autow.tst
c      write(ncpu,4500)interv,rt,rwt
c4500           format(i10,2f10.4)
c--write the results  1a tabella
               nn=0
               do i=1,interv
                  iniz=norrif(i)
                  ifin=norrif(i+1)-1
                  contrib=float(ifin-iniz+1)
                  ico=int(contrib)
                  nn=nn+ico
                  write(ncwu,4100)ico,nn,fo(1,i),fo(1,i+1),
     1	          dif2f(i),sd2wf(i),rf(i),rwf(i)
c--write file autow.tst
c	fom=0.5*(fo(1,i+1)+fo(1,i))
c	write(ncpu,4600)ico,fom,sd2wf(i)
4600              format(1x,i5,2f10.4)
c--end of writing
               enddo
               dif2ft=dif2ft/nreflX
               rwtt=rwtt/nreflX
               write(ncwu,4003)
               write(ncwu,4100) nreflX,nreflX,fo(1,1),fo(1,interv+1),
     2	       dif2ft,rwtt,rt,rwt
4003           format(1h )
4004           format(//)
4100           format(1x,i5,i10,2x,f6.1,' - ',f6.1,1x,4f10.3)
4005           format(18x,'Average error = ',f10.3)
               sd2wft=0.
               do i=1,interv
                  sd=(sd2wf(i)/rwtt-1)
                  sd2wfn(i)=abs(sd)
                  sd2wft=sd2wft+sd2wfn(i)
               enddo
               sd2wft=sd2wft/interv
               write(ncwu,4003)
               write(ncwu,4005)sd2wft
c--fine stampa prima tabella
               if(icod(8).eq.1) then
c--write the results  2a tabella
                  write(ncwu,4111)
4111              format(/,2x,'N.refl',5x,'Fo range',7x,' fo<fc',6x,
     1            'fo>fc',3x,'new-R%',5x,'Scale',/)
                  do i=1,interv
                     iniz=norrif(i)
                     ifin=norrif(i+1)-1
                     contrib=float(ifin-iniz+1)
                     ico=int(contrib)
                     write(ncwu,4110)ico,fo(1,i),fo(1,i+1),nmeno(i),
     1	             npiu(i),rfx(i),fscal(i)
4110                 format(1x,i5,2x,f6.1,' - ',f6.1,1x,2i10,2f10.3)
c--end of writing
                  enddo
c--check to save reflections
                  write(ncwu,4120)rtx
4120              format(/,' R(%) (new).....',f7.2)
                  if(icod(20).eq.1) then
                     do k=1,nreflX
                        ky=iwork1(k)
                        write(ncpu,4150)khl(1:3,ky),fovet(ky),sigmav(ky)
     *                   ,fcvet(ky),iphaz(ky)
4150	                  format(3i4,3f10.3,i10)
                     enddo
                  endif
               endif
c--end of table on Fo
            endif
            if(icod(10).eq.1) go to 9999
c      if(cod(4).gt.0.01)go to 9999
c
c--sort on resolution (sin(th)/l)
1100  continue
            d2wt1=0.
            do i=1,interv
               sd2ws(i)=0.
               fo1s(i)=0.
               fo2s(i)=0.
               dif1s(i)=0.
               dif2s(i)=0.
            enddo
            rwt=0.
            rt=0.
            dif2st=0.
            fo2st=0.
            fo1st=0.
            nchg=0
            n4z=0
            do i=1,interv
               iniz=norrif(i)
               ifin=norrif(i+1)-1
               do k=iniz,ifin
                  ky=iwork2(k)
                  fobs=fovet(ky)*scalo
                  fcal=fcvet(ky)*scalc
                  diff=abs(fobs-fcal)
                  diff2=diff*diff
                  fobs2=fobs*fobs
                  sigmaf=sigmav(ky)*scalo
                  st=sqrt(rhov(ky))
                  worko(ky)=0.5/st
                  call CalcWeight(fobs,fcal,sigmaf,st,w1,n4z)
                  d2w=diff2*w1*w1
                  dif1s(i)=dif1s(i)+diff
                  dif2s(i)=dif2s(i)+diff2
                  fo1s(i)=fo1s(i)+fobs
                  fo2s(i)=fo2s(i)+fobs2*w1*w1
                  sd2ws(i)=sd2ws(i)+d2w
               enddo
               contrib=float(ifin-iniz+1)
               rws(i)=100*sqrt(sd2ws(i)/fo2s(i))
               rs(i)=100*dif1s(i)/fo1s(i)
               rwt=rwt+sd2ws(i)
               dif2st=dif2st+dif2s(i)
               sd2ws(i)=sd2ws(i)/contrib
               dif2s(i)=dif2s(i)/contrib
               fo1st=fo1s(i)+fo1st
               rt=rt+dif1s(i)
               fo2st=fo2st+fo2s(i)
               icont=int(contrib)
            enddo
c$$--
c      if(icod(20).eq.1) goto 9999
c
c--write the table on resolution
            rtt=rt
            rwtt=rwt
            rt=100.*rt/fo1st
            rwt=100.*sqrt(rwt/fo2st)
            if(icod(10).eq.2) then
               write(ncwu,4015)
4015           format(' N.refl',2x,'h',3x,'k',3x,'l',5x,'Fo',6x,'Fc',
     2         6x,'d',7x,'w',6x,'wd2',4x,'R(F)%',3x,'Resol',/)
               ky=iwork2(1)
               if(cod(11).le.0.0)  cod(11)=rhov(ky)  ! limite inferiore
               ky=iwork2(nreflX)
               if(icod(12).le.0.0) cod(12)=rhov(ky)  ! limite superiore
               do i=1,nreflX
                  ky=iwork2(k)
                  if(rhov(ky).lt.cod(11).or.rhov(ky).gt.cod(12)) cycle
                  ihkl(1:3)=khl(1:3,ky)
                  fobs=fovet(ky)*scalo
                  fcal=fcvet(ky)*scalc
                  dif=fobs-fcal
                  diff=abs(dif)
                  diff2=diff*diff
                  fobs2=fobs*fobs
                  st=sqrt(rhov(ky))
                  worko(ky)=0.5/st
                  sigmaf=sigmav(ky)*scalo
                  call CalcWeight(fobs,fcal,sigmaf,st,w1,n4z)
                  d2w=diff2*w1*w1
                  rr= 100.0*diff/fobs
                  wrr=100.0*sqrt(d2w/(fobs2*w1*w1))
                  w2=w1*w1
                  write(ncwu,4016)i,ihh,ikk,ill,fobs,fcal,diff,w2,d2w
     1	          ,rr,worko(ky)
4016              format(1x,i5,3i4,2f8.2,5f8.3)
               enddo
               write(ncwu,4003)
            else
               write(ncwu,4001)
4001           format(/,2x,'N.refl',3x,'Total',6x,'Resol range',6x,
     1         '<d2>',6x,'<wd2>',5x,'R(F)%',3x,'wR(F^2)%',/)
               nn=0
               do i=1,interv
                  iniz=norrif(i)
                  ifin=norrif(i+1)-1
                  contrib=float(ifin-iniz+1)
                  ico=int(contrib)
                  nn=nn+ico
                  sntla=0.5/sqrt(fo(2,i))
                  sntlb=0.5/sqrt(fo(2,i+1))
                  write(ncwu,4101)ico,nn,sntla,sntlb,dif2s(i),sd2ws(i)
     1            ,rs(i),rws(i)
               enddo
               rwtt=rwtt/nreflX
               dif2st=dif2st/nreflX
               sntla=0.5/sqrt(fo(2,1))
               sntlb=0.5/sqrt(fo(2,interv+1))
               write(ncwu,4003)
               write(ncwu,4101)nreflX,nreflX,sntla,sntlb,dif2st,
     *                          rwtt,rt,rwt
4101           format(1x,i5,i10,3x,f6.3,' - ',f6.3,4f10.3)
               write(ncwu,4003)
               sd2wst=0
               do i=1,interv
                  sd=(sd2ws(i)/rwtt-1)
                  sd2wsn(i)=abs(sd)
                  sd2wst=sd2wst+sd2wsn(i)
               enddo
               sd2wst=sd2wst/interv
               write(ncwu,4005)sd2wst
               write(ncwu,4003)
            endif
            if(icod(10).eq.2) goto 9999
            if(icod(5).eq.0)go to 9999
c
c--agreement of  parity groups and hkl classes
1200  continue
c
c-- md=8    1=no. of contributors
c--         2= fo-fc
c--	      3=(fo-fc)^2
c--         4= fo
c--	      5= fo^2
c--	      6= d2w=w*(fo-fc)^2
c--         7= r
c--         8= rw
c--ladgu first address for parity groups
c--ladgu        ggg      
c--ladgu+1*md   ggu      
c--ladgu+2*md   gug      
c--ladgu+3*md   guu      
c--ladgu+4*md   ugg      
c--ladgu+5*md   ugu      
c--ladgu+6*md   uug      
c--ladgu+7*md   uuu      
c--ladhkl=ladgu+8*md               jhkl(7)=ladhkl
c--lad0kl=ladhkl+(dh+dk+dl)*md     jhkl(6)=lad0kl
c--ladh0l=lad0kl+(dk+dl)*md        jhkl(5)=ladh0l
c--lad00l=ladh0l+(dh+dl)*md        jhkl(4)=lad00l
c--ladhk0=lad00l+(dl)*md           jhkl(3)=ladhk0
c--lad0k0=ladhk0+(dh+dk)*md        jhkl(2)=lad0k0
c--ladh00=lad0k0+(dk)*md           jhkl(1)=ladh00
c--nfl   =ladh00+(dh)*md
c--nhkl/3,3,5,3,5,5,1/
            ladgu=1
            md=8
            ladhkl=ladgu+8*md
            jhkl(7)=ladhkl
            lad0kl=ladhkl+nhkl(7)*md
            jhkl(6)=lad0kl
            ladh0l=lad0kl+nhkl(6)*md
            jhkl(5)=ladh0l
            lad00l=ladh0l+nhkl(5)*md
            jhkl(4)=lad00l
            ladhk0=lad00l+nhkl(4)*md 
            jhkl(3)=ladhk0
            lad0k0=ladhk0+nhkl(3)*md
            jhkl(2)=lad0k0
            ladh00=lad0k0+nhkl(2)*md 
            jhkl(1)=ladh00
            lenght   =ladh00+nhkl(1)*md
            if (.not. allocated(xbuffer)) 
     *                allocate (xbuffer(1:lenght) ,stat = ierr)
            if (ierr.ne.0) then 
                write(ncwu,*)
     *             'Agreement vector xbuffer:  Allocation error'
                call cstop(' ')
            endif
            do i=1,lenght
               xbuffer(i)=0.
            enddo
c
            if(icod(10).gt.2) then
               write(ncwu,4015)
            endif
            k1=0
            nchg=0
            n4z=0
            do i=1,nreflX
               ky=iwork2(i)
               ihh=khl(1,ky)
               ikk=khl(2,ky)
               ill=khl(3,ky)
               ipar=iabs(mod(ihh,2)*4)+iabs(mod(ikk,2)*2)+
     *              iabs(mod(ill,2))
               indr(1)=ladgu+ipar*md
               ixxx=7
               if(ihh.eq.0)ixxx=ixxx-1
               if(ikk.eq.0)ixxx=ixxx-2
               if(ill.eq.0)ixxx=ixxx-4
               laddr=jhkl(ixxx)
               indr(2)=laddr
               ich=0
               indr(3)=-1
               if(ihh.ne.0.and.ixxx.ne.7)then
                  indr(3)=laddr+(1+iabs(mod(ihh,2)))*md
                  ich=1
               endif
               ick=0
               indr(4)=-1
               if(ikk.ne.0.and.ixxx.ne.7)then
                  indr(4)=laddr+(1+2*ich+iabs(mod(ikk,2)))*md
                  ick=1
               endif
               indr(5)=-1
               if(ill.ne.0.and.ixxx.ne.7)then
                  indr(5)=laddr+(1+2*ich+2*ick+iabs(mod(ill,2)))*md
               endif
c      write(ncwu,1) ihh,ikk,ill,ipar,ixxx,(indr(iii),iii=1,5)
c   1  format(5i4,5i10)
               fobs=fovet(ky)*scalo
               fcal=fcvet(ky)*scalc
               dif=fobs-fcal
               diff=abs(dif)
               diff2=diff*diff
               fobs2=fobs*fobs
               st=sqrt(rhov(ky))
               worko(ky)=0.5/st
               sigmaf=sigmav(ky)*scalo
               call CalcWeight(fobs,fcal,sigmaf,st,w1,n4z)
               d2w=diff2*w1*w1
               if(icod(10).gt.2) then
                  rr= 100.0*diff/fobs
                  wrr=100.0*sqrt(d2w/(fobs2*w1*w1))
                  w2=w1*w1
                  if(icod(10).eq.3.and.(ipar+1).eq.icod(11)) then
                     k1=k1+1
                     write(ncwu,4011)k1,ihh,ikk,ill,fobs,fcal,diff,w2,d2w
     1	             ,rr,worko(ky)
                  else if(icod(10).eq.4.and.ixxx.eq.icod(11)) then
                     k1=k1+1
                     write(ncwu,4011)k1,ihh,ikk,ill,fobs,fcal,diff,w2,d2w
     1	             ,rr,worko(ky)
                  endif
               endif
               do kk=1,5
                  mm=indr(kk)
                  if(mm.ne.-1) then
                     xbuffer(mm)=xbuffer(mm)+1
                     xbuffer(mm+1)=xbuffer(mm+1)+fobs
                     xbuffer(mm+2)=xbuffer(mm+2)+fobs2*w1*w1
                     xbuffer(mm+3)=xbuffer(mm+3)+abs(diff)
                     xbuffer(mm+4)=xbuffer(mm+4)+diff2
                     xbuffer(mm+5)=xbuffer(mm+5)+d2w
                  endif
               enddo
            enddo
            if(icod(10).gt.2) goto 9999
c
c--print gu statistic
            iloop=1
            write(ncwu,6102)
            mm=ladgu
            do k=1,8
               contrib=xbuffer(mm)
               if(contrib.gt.0)then 
                  xbuffer(mm+7)=100*sqrt(xbuffer(mm+5)/xbuffer(mm+2))
                  xbuffer(mm+6)=100*xbuffer(mm+3)/xbuffer(mm+1)
                  xbuffer(mm+5)=xbuffer(mm+5)/contrib
                  xbuffer(mm+4)=xbuffer(mm+4)/contrib
                  d2wt1=d2wt1+xbuffer(mm+5)
                  ico=int(contrib)
                  write(ncwu,6101)iclass(k),ico,xbuffer(mm+4),
     1                 xbuffer(mm+5),xbuffer(mm+6),xbuffer(mm+7)
               endif
               mm=mm+md
            enddo
6102        format(3x,'Class',2x,'N.refl.',6x,'<d2>',10x,
     1          '<wd2>',9x,'R(F)%',7x,'wR(F^2)%',/)
6101        format(3x,a4,i8,2x,f10.3,5x,f10.3,2(5x,f9.3))
            write(ncwu,4003)
c--print the hkl statistic
            write(ncwu,6102)
            do k=1,7
               mm=jhkl(k)
               contrib=xbuffer(mm)
               if(contrib.gt.0)then 
                  xbuffer(mm+7)=100*sqrt(xbuffer(mm+5)/xbuffer(mm+2))
                  xbuffer(mm+6)=100*xbuffer(mm+3)/xbuffer(mm+1)
                  xbuffer(mm+5)=xbuffer(mm+5)/contrib
                  xbuffer(mm+4)=xbuffer(mm+4)/contrib
                  d2wt1=d2wt1+xbuffer(mm+5)
                  ico=int(contrib)
                  write(ncwu,6101)lkh(k),ico,xbuffer(mm+4),
     2                  xbuffer(mm+5),xbuffer(mm+6),xbuffer(mm+7)
               endif
               mm=mm+md
            enddo
            write(ncwu,4003)
c--print partial hkl  statistic
            write(ncwu,6102)
            kkk=0
            do k=1,6
               mm=jhkl(k)+md
               do kk=1,nhkl(k)-1
                  contrib=xbuffer(mm)
                  ico=int(contrib)
                  kkk=kkk+1
                  if(ico.gt.0)then 
                     xbuffer(mm+7)=100*sqrt(xbuffer(mm+5)/xbuffer(mm+2))
                     xbuffer(mm+6)=100*xbuffer(mm+3)/xbuffer(mm+1)
                     xbuffer(mm+5)=xbuffer(mm+5)/contrib
                     xbuffer(mm+4)=xbuffer(mm+4)/contrib
                     d2wt1=d2wt1+xbuffer(mm+5)
                     write(ncwu,6101)lkhgu(kkk),ico,xbuffer(mm+4),
     1                     xbuffer(mm+5),xbuffer(mm+6),xbuffer(mm+7)
                  endif
                  mm=mm+md
               enddo
            enddo
9999        continue
            write(ncwu,5002)
5002        format(/,' d2  =   (Fo-Fc)^2 ',/,' wd2 = w*(Fo-Fc)^2 ',/)
c-- print  reflections with /fo - fc/.gt.z (default z=0.5)
            if(cod(6).gt.0.0)  then
               z=cod(6)
               write(ncwu,11)z
11              format(3x,'List reflections with (Fo - Fc)/Fo > ',
     1                f4.1//,6x,'Reflection',8x,'Fo',8x,'Fc',
     2                7x,'Fo-Fc',3x,'Sig(Fo)',5x,'Resol',/)
               n=0
               do i=1,nreflX
                  ky=iwork1(k)
                  ihkl(1:3)=khl(1:3,ky)
                  fobs=fovet(ky)*scalo
                  fcal=fcvet(ky)*scalc
                  diff=fobs-fcal
                  diff2=abs(diff)
                  st=sqrt(rhov(ky))
                  resol=0.5/st
                  sigmaf=sigmav(ky)*scalo
                  e=  z*fobs
                  if(diff2.gt.e) then
                     n=n+1
                    write(ncwu,2)(xbuffer(m),m=m6,m6+2),fobs,fcal,diff,
     1	                  sigmaf,resol
2	              format(3x,3f5.0,4f10.3,f10.4)
                  endif
               enddo
               write(ncwu,3)n
3              format(/,3x,i6,' reflections found',/)
            endif
      DEALLOCATE(xbuffer, stat =ierr)
      return
      end
c
code for folimiMNQD
      subroutine folimiMNQD(jfirst,interv,intervx,
     1 ninterx,norrif,fo,kk)
c--calculate the range limits
c
      USE General
      USE Riflessi
      USE Limits
      USE LsqModule
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      dimension norrif(1001),fo(2,1001)
c
      if(jfirst.eq.0)then
         if(interv.ne.0)then
            ninter=nreflX/interv
         else
            interv=8
150	      continue
            if(interv.lt.intervx) then
               ninter=nreflX/interv
               if(ninter.gt.ninterx)then
                  interv=interv+1
                  goto 150
               endif
            endif
         endif
         ninter=nreflX/interv
         nrest=nreflX-(ninter*interv)
c--calculate the limits of the intervals
         norrif(1)=1
         norrif(interv+1)=nreflX+1
      endif
c--fo o sin(theta)/labmda
      if(kk.eq.1)then
         ky=iwork1(1)
         fo(kk,1)=work1(ky)
         ky=iwork1(nreflX)
         fo(kk,interv+1)=work1(ky)
      else
c         ky=iwork2(1)
c         fo(kk,1)=rhov(ky)
c         ky=iwork2(nreflX)
c         fo(kk,interv+1)=rhov(ky)
         fo(kk,1)=tmpwt(1)
         fo(kk,interv+1)=tmpwt(nreflX)
      endif
      j=2
      do i=2,interv
         if(jfirst.eq.0) then
            ninte=ninter
            if(i.le.nrest)ninte=ninter+1
            norrif(i)=norrif(i-1)+ninte
         else
            ninter=norrif(i)-norrif(i-1)
         endif
         j=j+ninter
         if(kk.eq.1)then
            ky=iwork1(j)
            a=work1(ky)
         else if(kk.eq.2)then
c            ky=iwork2(j)
c            a=rhov(ky)
c         else if(kk.eq.3)then
            a=tmpwt(j)        
         endif
         fo(kk,i)=a
      enddo
c      write(ncwu,*)' interv ',ninter,(norrif(i),i=1,interv+1)
c      write(ncwu,*)' interv ',ninter,(fo(kk,i),i=1,interv+1)
      return
      end
!      
!--------------------------------------------------------
!  routine for Weight	
!--------------------------------------------------------
c
code for PutGetWeight
      subroutine PutGetWeight(iAction)
!--scrive e legge su jdir parametri pesaggio
!  (nuovo meccanismo)
!
      USE General
      USE LsqModule
!      
      if (iAction == 1) then
!      
         write(jdir)IcodeFo4,nWeight,nPar,WPar(:)
!         
      else
!      
         read(jdir) IcodeFo4,nWeight,nPar,WPar(:)
         if(nWeight.gt.0.and.nWeight.le.18) infoOK(4)=1
      endif        
!
      return
      end
c
code for sc04MNQD
      subroutine sc04MNQD
c--create i default per i 18 criteri di pesaggio
c  nParDef(18)
c  WParDef(18,n)
c
c  1  : p(1) = 4*f(min)
c  2  : p(1) = 2*f(min)  
c       p(2) = 1.0
c       p(3) = 2.0/f(max)
c  3  : p(1) = 1.0
c  4  : p(1) = 1.0
c  5  : p(1) = 1.0	   (viene calcolato da weight)
c  6  : p(1) = 1.0	   (viene calcolato da weight)
c  7  : p(1) = f(max)
c       p(2) = f(min)
c  8  : p(1) = 4*f(min)
c  9  : p(1) = 1.0	   (viene calcolato da weight)
c 10  : p(1) = 1.0	   (viene calcolato da weight)
c 11  : p(1) = 2*f(min)
c	p(2) = 1.0
c	p(3) = 2.0/f(max)
c	p(4) = 1.0
c 12  : p(1) = 1.0
c	p(2) = 2*x(min)
c	p(3) = 2.0/x(max)
c       where x=(fo+2Fc)/3 
c 13  : p(1) = 2*f(min)
c       p(2) = 1.0
c       p(3) = 2.0/f(max)
c	p(4) = 1.0
c 14  : p(1) = 2*f(min)
c       p(2) = 1.0
c       p(3) = 2.0/f(max)
c 15  : p(1) = (sin(Th)/L)(min)
c       p(2) = 1.0
c	p(3) = (sin(Th)/L)(max)
c 16  : p(1) = a(1)   no default
c	p(2) = a(2)
c	p(3) = a(3)
c	p(4) = a(4)
c	p(5) = a(5)
c 17  : p(1) = 1.0
c	p(2) = 2.0/f(max)
c	p(3) = 1.0
c 18  : p(1) = 2*f(min)
c       p(2) = 1.0
c       p(3) = 2.0/f(max)
c	p(4) = 1.0
c	p(5) = 1.0
c
      USE LsqModule
      USE Limits      
!
!--check if the refinement is using Fo or I
      if(IcodeFo4.eq.1) then
         a=UserMinLim%Fo
         b=UserMaxLim%Fo
         a1=UserMinLim%P
         b1=UserMaxLim%P
      else
         a=UserMinLim%Fo2
         b=UserMaxLim%Fo2
         a1=UserMinLim%P2
         b1=UserMaxLim%P2
      endif
      s=UserMinLim%Rhoroot
      s1=UserMaxLim%Rhoroot
!
      do iw=1,18
         select case (iw)
c--modified hughs scheme
c--numero di parametri = 1
            case (1)
               nParDef(iw)=1
               WParDef(iw,1)=4.0*a
c--cruishank scheme
c--numero di parametri = 3
            case (2)
               nParDef(iw)=3
               WParDef(iw,1)=2.0*a
               WParDef(iw,2)=1.0
               WParDef(iw,3)=2.0/b
c--w=sin(theta)/lambda
c--numero di parametri = 1
            case (3)
               nParDef(iw)=1
               WParDef(iw,1)=1.0
c--w=lambda/sin(theta)
c--numero di parametri = 1
            case (4)
               nParDef(iw)=1
               WParDef(iw,1)=1.0
c--w=1.0/sigma(Fo)**2
c--numero di parametri = 0
            case (5)
               nParDef(iw)=0
c--unitary weight
c--numero di parametri = 0
            case (6)
               nParDef(iw)=0
c--w=1.0/(1.0+(Fo-Fmin)/Fmax**2))
c--numero di parametri = 2
            case (7)
               nParDef(iw)=2
               WParDef(iw,1)=b
               WParDef(iw,2)=a
c--hughs scheme
c--numero di parametri = 1
            case (8)
               nParDef(iw)=1
               WParDef(iw,1)=4.0*a
c--w=sigma(Fo)
c--numero di parametri = 0
            case (9)
               nParDef(iw)=0
c--w=1.0/sigma(Fo)
c--numero di parametri = 0
            case (10)
               nParDef(iw)=0
c--w=sin(theta/lambda)*cruishank scheme
c--numero di parametri = 4
            case (11)
               nParDef(iw)=4
               WParDef(iw,1)=2.0*a
               WParDef(iw,2)=1.0
               WParDef(iw,3)=2.0/b
               WParDef(iw,4)=1.0
c--w=1.0/(sigma(Fo)^2+a*P+b*P^2)  where P=(Fo+2Fc)/3  (shelx scheme)
c--numero di parametri = 3
            case (12)
               nParDef(iw)=3
               WParDef(iw,1)=1.0
               WParDef(iw,2)=2.0*a1
               WParDef(iw,3)=2.0/b1
c--cruishank scheme + sin(theta)/lambda
c--numero di parametri = 4
            case (13)
               nParDef(iw)=4
               WParDef(iw,1)=2.0*a
               WParDef(iw,2)=1.0
               WParDef(iw,3)=2.0/b
               WParDef(iw,4)=1.0
c--cruishank scheme
c--numero di parametri = 3
            case (14)
               nParDef(iw)=3
               WParDef(iw,1)=2.0*a
               WParDef(iw,2)=1.0
               WParDef(iw,3)=2.0/b
c-- W=1/(P(1)+P(2)*(Sin(Th)/L)+P(3)*(Sin(Th)/L)^2)'
c--numero di parametri = 3
            case (15)
               nParDef(iw)=3
               WParDef(iw,1)=s
               WParDef(iw,2)=1.0
               WParDef(iw,3)=1.0/s1
c--Chebyshev series (max 5 terms)
c--numero di parametri = 5
            case (16)
c--	if(np.le.0) np=5      !!!! da' un WARNING !!!!!
c--	if(np.gt.5) np=5
               np=5
               nParDef(iw)=np
               do i=1,np
                  WParDef(iw,i)=1.0
               enddo
               WParDef(iw,np+1)=1.0/b
               WParDef(iw,np+2)=1.0
c--w=sin(theta/lambda)/(sigma(Fo)^2+b*fo^2)
c--numero di parametri = 3
            case (17)
               nParDef(iw)=3
               WParDef(iw,1)=1.0
               WParDef(iw,2)=2.0/b
               WParDef(iw,3)=1.0
c--w=1./(cruishank scheme + sin(theta)/lambda)*sigma(Fo)^2
c--numero di parametri = 5
            case (18)
               nParDef(iw)=5
               WParDef(iw,1)=2.0*a
               WParDef(iw,2)=1.0
               WParDef(iw,3)=2.0/b
               WParDef(iw,4)=1.0
               WParDef(iw,5)=1.0
c--common section
         end select
         if(iw.ne.16)then 
            np = nParDef(iw)
            WParDef(iw,np+1)=1.0
         endif
      enddo
      return
      end      
c
code for PrintWeight
      subroutine PrintWeight(ncwu)
c--print weighting scheme vettoro sir (list 4)
c
      USE General
      USE LsqModule
!
      character *77 Pesi(18)
c
      character*6 icodeFOch(2)
      data icodeFOch/' Fo   ',' Fo**2'/
c--
      Pesi(1) = 'W=Sc*Fo/P(1) if Fo >= P(1); W=Sc*P(1)/Fo'//
     1          ' otherwise'
      Pesi(2) = 'W=Sc/(P(1)+P(2)*Fo+P(3)*Fo^2)'
      Pesi(3) = 'W=Sc*(Sin(Theta)/Lambda)^P(1)'
      Pesi(4) = 'W=Sc*(Lambda/Sin(Theta))^P(1)'
      Pesi(5) = 'W=Sc/(Sigma(Fo))^2'
      Pesi(6) = 'W=Sc'
      Pesi(7) = 'W=Sc/(1.+((Fo-P(2))/P(1))^2'
      Pesi(8) = 'W=Sc if Fo<=P(1); W=Sc*P(1)/Fo if Fo>P(1)'
      Pesi(9) = 'W=Sc*Sigma(Fo)'
      Pesi(10)= 'W=Sc/Sigma(Fo)'
      Pesi(11)= 'W=Sc*(Sin(theta)/Lambda)^P(4)/(P(1)+P(2)*Fo+'//
     1          'P(3)*Fo^2)'
      Pesi(12)= 'W=Sc/(P(1)*Sigma(Fo))^2+P(2)*Fo+P(3)*Fo^2)'
      Pesi(13)= 'W=Sc/(P(1)+P(2)*Fo+P(3)*Fo^2+P(4)*(Sin(Th)/L))'
      Pesi(14)= 'W=Sc/(P(1)+P(2)*Fo+P(3)*Fo^2)'
      Pesi(15)= 'W=Sc/(P(1)+P(2)*(Sin(Th)/L)+P(3)*'//
     1          '(Sin(Th)/L)^2)'
      Pesi(16)= 'W=Sc/(SUM(aj*Tj(F))j=1,n'
      Pesi(17)= 'W=Sc*(Sin(Th)/L)^P(3)/(P(1)*Sigma(Fo))^2+'//
     1          'P(2)*Fo^2)'
      Pesi(18)= 'W=Sc/((P(1)+P(2)*Fo+P(3)*Fo^2+P(4)*(Sin(Th)/L)'//
     1          '^P(5))*(Sigma(Fo))^2)'
!--		12345678901234567890123456789012345678901234567890
!
      if(nWeight.lt.1.or.nWeight.gt.18) then
         write(ncwu,1000)
1000     format(/,' Warning!: No Weighting scheme provided!')
         return
      endif
      if(ifo2.lt.1.or.ifo2.gt.2) ifo2=1      
      if(IcodeFo4.gt.2.or.IcodeFo4.lt.1)IcodeFo4=ifo2
      write(ncwu,1020) nWeight,icodeFOch(IcodeFo4)
1020  format(/,' Weighting scheme no. ', i3,' on',a)
      write(ncwu,'(1x,a)') Pesi(nWeight)
      write(ncwu,1030)nPar
1030  format(' Parameter(s) provided', i3)
      if (nPar.gt.0) then
         if (nWeight.eq.16) then
            j=nPar+2
         else
            j=nPar+1
         endif
      else
         j=1
      endif      
      write(ncwu,1035) WPar(j)
1035  format(' Sc factor:',f10.4)
      if (nPar.gt.0) then
         write(ncwu,1050) (j,j=1,6)
1050     format( 6x,6('p(',i1,')',8x))
         if (nWeight.eq.16) then
             write(ncwu,1060) (WPar(l),l=1,nPar+1)
1060         format(1x,10f12.5)
         else
             write(ncwu,1060) (WPar(l),l=1,nPar)
         endif
      endif
      write(ncwu,"(' ')")
      return
      end
c
code for CalcWeight
      subroutine CalcWeight(fo,fc,sigmaf,st,w,n4z)
c--calculate the wheight
c
c  fc	      on scale of fo
c  st	      the value of sin(theta)/lambda for the calculation
c
c  on return, 'w' is the calculated weight
c--
      USE General
      USE LsqModule
!
      nWscale=nPar+1
      if (nWeight.eq.16) nWscale=nWscale+1
      select case (nWeight)
        case default
           write(lo,9010) nWeight
9010       format(/,i5,' Weighting scheme not allowed')
           call cstop(' Weighting scheme not allowed')
        case (1)
c--weighting scheme type 1 
           if(fo.le.WPar(1))  then  
             a=WPar(1)/fo
           else
             a=fo/WPar(1)
           endif
        case (2,14)      
c--weighting scheme type 2 & 14
           a=WPar(1)
           do j=1,2
              a=a+WPar(j+1)*fo**j
           enddo
        case (3)      
c--weighting scheme type 3
           a=1./(st**WPar(1))
        case (4)      
c--weighting scheme type 4
           a=st**WPar(1)
        case (5)      
c--weighting scheme type 5
           a=sigmaf*sigmaf
        case (6)      
c--weighting scheme type 6
           a=1.0
        case (7)      
c--weighting scheme type 7
           a=1.0+((fo-WPar(2))/WPar(1))**2
        case (8)      
c--weighting scheme type 8  
           a=1.0
           if(fo.gt.WPar(1)) a=fo/WPar(1)
        case (9)      
c--weighting scheme type 9
           a=1.0/sigmaf
        case (10)      
c--weighting scheme type 10
           a=sigmaf
        case (11)      
c--weighting scheme type 11
           a=WPar(1)
           do j=1,2
              a=a+WPar(j+1)*fo**j
           enddo
           a=a/(st**WPar(4))
        case (12)      
c--weighting scheme type 12
           a=WPar(1)*sigmaf*sigmaf
           p=(fo+2.0*fc)/3.0
           do j=1,2
               a=a+WPar(j+1)*p**j
           enddo
        case (13)      
c--weighting scheme type 13
           a=WPar(1)
           do j=1,2
              a=a+WPar(j+1)*fo**j
           enddo
           a=a+st*WPar(4)
        case (15)      
c--weighting scheme type 15
           st1=1.0/st
           a=WPar(1)
           do j=1,2
              a=a+WPar(j+1)*st1**j
           enddo
        case (16)      
c--weighting scheme type 16
           a=WPar(1)
           g=2.0*fo*WPar(nPar+1) - 1
           b=1.
           c=g
           do j=3,nPar
              d=2.0*g*c-b
              a=a+d*WPar(j)
              b=c
              c=d
           enddo
           a=a+g*WPar(2)
        case (17)      
c--weighting scheme type 17
           a=WPar(1)*sigmaf*sigmaf+WPar(2)*fo*fo
           a=a/(st**WPar(3))
        case (18)      
c--weighting scheme type 18
           a=WPar(1)
           do j=1,2
              a=a+WPar(j+1)*fo**j
           enddo
           a=a+WPar(4)*st**WPar(5)
           a=a*sigmaf*sigmaf
      end select
c--common section
      a=a/WPar(nWscale)
      if(a.le.0.0)then
         if(a.lt.-0.01)then
           a=-a     
         else
           a=0.01
         endif
         n4z=n4z+1
      endif
      w=1.0/a
      w=sqrt(w)
      return
      end
c
code for chweig
      subroutine chweigNEW(jproc,cod,rob,df,w,nchg,ies)
c--check the wheight
c
c  jproc  0   not modify the weight calculated
c	 -1   procedure 1 (like Prince & Nicholson)
c	  1   my procedure
c  cod	      n times limit to modify
c  rob	      average(sqrt(w)*df)
c  df	      the value of fo-fc
c
c  on return, 'w' is the calculated weight
c  ies	  0 no change
c	  1 w was changed
c
c--list 4 and 6 are assumed to have been loaded
c
c--
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      ies=0
      psi=1.0
c--modify the weight
      if (jproc.eq.1) then
c--my procedure
          a=1.0/w
          diff2=abs(df)
          if (diff2.lt.0.00001) diff2=0.00001
          diff3=diff2-a
          rr=abs(diff3/diff2)
          if (diff3.ge.0.) then
              if (rr.gt.cod) then
c	          write(ncwu,'(5f10.4)')rr,diff2,a,w,diff3
                  a=a+0.5*diff2
                  ies=1
                  nchg=nchg+1
              endif
          else
              if (rr.gt.cod) then
c	          write(ncwu,'(5f10.4)')rr,diff2,a,w,diff3
                  a=a-0.5*a
                  nchg=nchg+1
                  ies=1
              endif
          endif
          w=1.0/a
      else
c--Prince procedure
          aw=abs(df)*w
          if (aw.gt.cod*rob) then
              psi=0.
              nchg=nchg+1
              ies=1
          else
              psi=(1-(aw*aw/(cod*cod*rob*rob)))
          endif
          w=w*psi
      endif
c--end of modifying
      return
      end
!      
!---------------------------------------------------------------------------
!--chiamata da finestra LSQ: affina weight      
!---------------------------------------------------------------------------
code for RefineWParMNQD
      subroutine RefineWParMNQD(icriterio)
!--routine di affinamento dei parametri di pesaggio dalla grafica
!      
      USE General
      USE Dialogo
      USE LsqModule
!
      integer icriterio
!
!--trasferisco valori dalla grafica ai vettori del weight corrente
      nWeight=icriterio
      nPar=nParDefGTK(nWeight)
      l=nPar+1
      if (nWeight.eq.16) l=l+1
      do j=1,l
         WPar(j)=WParDefGTK(nWeight,j) 
      enddo
!--chiamo routine di affinamento dei parametri del criterio di pesaggio
      call wautoNEW(ier)
!--trasferisco valori affinati del pesaggio corrente alla grafica      
      icriterio = nWeight
      nParDefGTK(icriterio) = nPar
      l=nPar+1
      if (icriterio.eq.16) l=l+1
      do j=1,l
         WParDefGTK(icriterio,j)=WPar(j) 
         WParGTK(j)=WPar(j) 
      enddo
!
      return
      end
c---------------------------------------------------------------------
c
code for wautoNEW
      subroutine wautoNEW(ier)
c--main routine for cruickshank's coeficents automatic determination
c--read list for weighting scheme optimization
c  call xweight
c  print results
c
      USE General
      USE Riflessi
      USE Atomi
      USE LsqModule
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/workd/icod(30),ise(24),fud(4),nty,ityp(8),dummwd(3)
      dimension cod(30)
      equivalence(icod,cod)
c
      dimension norrif(1001),fo(2,1001),sd2w(1001)
      dimension buff(200)   ! buffer di stampa delle curve
c
      dimension icar(3),itit(15),iti1(15)
      character*3 icarchar
      character*30 ititchar,iti1char
      character*6 icodeFOch(2)
      data icodeFOch/' Fo   ','Fo**2 '/
      data icarchar/'wd*'/
      data ititchar/'s(T)/ld**2  1./w  d**2        '/
      data iti1char/'Fo    d**2  1./w  d**2        '/
c	               123456789012345678901234567890
c
      read(icarchar,'(3a1)')icar
	read(ititchar,'(15a2)')itit
	read(iti1char,'(15a2)')iti1
!
      ier=0
      if (sum(WPar(:)) < 0.001 .or. nWeight == -100) then
          write(ncwu,9314)
          write(ncwu,9310)
          write(ncwu,9314)
          return
      endif
 9310 format('    No info on weights available.',/,
     *       '    You should run Least Squares before.')
      jCode_Peso = 0   ! pezza gianluca 15/04/2009
c--set = 0 vector icod
      icod(:)=0
c-- set default values
      icod(1)=0 		! print
      icod(2)=10
      icod(3)=8
      cod(4)=0.02
      cod(5)=1.0
      icod(7)=1 		 ! verbose 0/1/2
      icod(15)=1		 ! refine coeff
      icod(18)=1		 ! code: (0/1) divide/non divide 
      icod(20)=0		 ! n. intermediate cycles
      icod(21)=1		 ! refinement type
      cod(22)=0.0		 ! average value
      icod(23)=2		 ! fo and sin(theta)/lambda
      icod(24)=0		 ! 0/1 old/new method
      icod(25)=1000
      icod(26)=0		 ! code se w deve essere modificato
      cod(27)=6 		 ! n times per la modifica
      icod(28)=0		 ! code se scrivere file .num (not used)
c--
      icod(29)=IcodeFo4         ! 1/2 = icodeFo (Fo or Fo**2)
!      
c--ksubr= 10 carico solo gli osservati
      ksubr=10
      ier=0
      call LeggiRiflessi(ier,ksubr)
      nreflX=NreflKsubr
!
      scalc=abs(FcScale)

      if(icod(7).ge.1)then
	   write(ncwu,9314)
9314	   format(1h ,78(1h-))
	   write(ncwu,'(a,i3,2a)')
     *	    ' Weighting scheme analysis (scheme No.',nWeight,') on ',
     2      icodeFOch(IcodeFo4)
         if(IcodeFo4.eq.1) then
	      write(ncwu,'(a,/)') ' wd2 = SQRT( w*(Fo-Fc)^2 / Nref )'
	   else
	      write(ncwu,'(a,/)') ' wd2 = SQRT( w*(Io-Ic)^2 / Nref )'
	   endif
         write(ncwu,9139) scalc
9139     format(' Scale (Fc).......',f10.5)	 
         write(ncwu,9320) nreflX
9320     format(' No. reflections..', i7)
	   
	   call PrintWeight(ncwu)
      endif
!
c--------------------------------------
      do k=1,nreflX
         iwork1(k)=k
         iwork2(k)=k
      enddo    
c--sort on Fo 
      tmpwt(1:nreflX)=fovet(1:nreflX)
      call SortInd(nreflX,iwork1,tmpwt)
c--sort on (sin(theta)/lambda)2
      tmpwt(1:nreflX)=rhov(1:nreflX)
      call SortInd(nreflX,iwork2,tmpwt)
c--------------------------------------
c--salvo vettori se fo o fo**2
      if(IcodeFo4.eq.1) then
         worko(1:nreflX) = sigmav(1:nreflX) 
         work1(1:nreflX) = fovet (1:nreflX)
         work2(1:nreflX) = fcvet (1:nreflX)*scalc 
      else
         worko(1:nreflX) = sigmav2(1:nreflX) 
         work1(1:nreflX) = fovet2 (1:nreflX)
         work2(1:nreflX) = (fcvet (1:nreflX)*scalc)**2 
      endif            
c----------------------------------------------------------
c--calculate the optimized weighting scheme----------------
c----------------------------------------------------------
      call xweightNEW(wrob)
c----------------------------------------------------------
c--print final tables
      if(icod(7).eq.0)go to 5500
c
c--calculate the intervals
      intervx=26
      ninterx=20
      interv=0
!      if(icod3.ne.8) interv=icod3
!--intervalli  Fo      
      jfirst=0
      kk=1
      call folimiMNQD(jfirst,interv,intervx,ninterx,norrif,fo,kk)
c
c--intervalli (sin(theta)/lambda)2
      jfirst=1
      kk=2
      call folimiMNQD(jfirst,interv,intervx,ninterx,norrif,fo,kk)
c--indirizzi del buffer per stampa delle curve
      lxxc=1
      mdxxc=2
      nxxc=interv
      nxxb=2
c--funzioni di w
      do kk=1,2
         mxxc=lxxc
         nchg=0
         n4z=0
         do i=1,interv
            iniz=norrif(i)
            ifin=norrif(i+1)-1
            nrrr=0
c--buffer per stampa curve            
            mxxb=mxxc
            do j=1,nxxb
               buff(mxxb+1)=0.0
               mxxb=mxxb+nxxc*mdxxc
            enddo
c	xmind=100000.0
c	xminw=100000.0
c	xmaxd=-10000.0
c	xmaxw=-10000.0
            do k=iniz,ifin
               if(kk.eq.1) then
                  ky=iwork1(k)
               else
                  ky=iwork2(k)
               endif
               nrrr=nrrr+1
               fobs=work1(ky)
               fcal=work2(ky)
               diff=abs(fobs-fcal)
               sigmaf=worko(ky)
               st=sqrt(rhov(ky))
               call CalcWeight(fobs,fcal,sigmaf,st,w1,n4z)
               if(icod(26).ne.0) then
                  w1c=w1
                  call chweigNEW(icod(26),cod(27),wrob,diff,w1,nchg,ies)
c	if(ies.ne.0) then
c	 diff2=diff*diff
c	 w2=w1*w1
c	 w3=0.0
c	 if(w2.gt.0) w3=1.0/w2
c	 write(ncwu,'(5f10.4)') fobs,diff2,w3,w1c,w1
c	endif            
               endif
               diff2=diff*diff
               w2=w1*w1
               w3=0.0
               if(w2.gt.0) w3=1.0/w2
c	xmind=min(xmind,diff2)
c	xmaxd=max(xmaxd,diff2)
c	xminw=min(xminw,w3)
c	xmaxw=max(xmaxw,w3)
               r=0.0
               if(diff2.gt.0.0) r=abs(w3-diff2)/diff2
c      write(ncwu,1045) k,w3,w2,diff2,r,st
c1045  format(1x,i5,4f10.4,2f15.5)
c      store(mxxc+1)=store(mxxc+1)+w2
               buff(mxxc+1)=buff(mxxc+1)+w3
               buff(mxxc+nxxc*mdxxc+1)=buff(mxxc+nxxc*mdxxc+1)+diff2
c      store(mxxc+2*nxxc*mdxxc+1)=store(mxxc+2*nxxc*mdxxc+1)+w2*diff2
c      store(mxxc+3*nxxc*mdxxc+1)=store(mxxc+3*nxxc*mdxxc+1)+r
c      fff=fobs
c      fff1=st
c      if(kk.eq.2) then
c      fff=st
c      fff1=fobs
c      endif
c      write(ncwu,900)' #,fo ,1/w,d2',nrrr, fff,w3,diff2,fff1
c900   format(a,i5,4f10.3)
            enddo
            fom=0.5*(fo(kk,i)+fo(kk,i+1))
            buff(mxxc  )=fom
            buff(mxxc+nxxc*mdxxc)=fom
            contrib=float(ifin-iniz+1)
            mxxb=mxxc
            do j=1,nxxb
               buff(mxxb+1)=buff(mxxb+1)/contrib
               mxxb=mxxb+nxxc*mdxxc
            enddo
c--
c      xwd2=store(mxxc+nxxc*mdxxc+1)/store(mxxc+1)
c      write(ncwu,'(a,i5,f8.0)') 'intervallo #',i,contrib
c      write(ncwu,'(a,4f10.4)')'min,max(1/w),min,max(d2)', 
c     2 xminw,xmaxw,xmind,xmaxd
c      write(ncwu,'(a,4f10.5)') 'fom,1/w,d2,wd2', store(mxxc),
c     1	 store(mxxc+1),store(mxxc+nxxc*mdxxc+1),xwd2
c--
            mxxc=mxxc+mdxxc
         enddo
         iverb = 0
         if (iverb > 0) then !  PEZZA ginluca 19/08/2013
             if(kk.eq.1) then
                write(ncwu,1010)
1010        format(/,' Plot of 1/w and d**2=(Fo-Fc)**2 versus /Fo/',/)
             else
                write(ncwu,1020)
1020        format(/,' Plot of 1/w and d**2=(Fo-Fc)**2 versus  ',
     2               'Sin(theta)/Lambda ',/)
             endif
             ifit=0
            if(kk.eq.1) then
            call yplotNEW(buff,ncwu,lxxc,nxxc,nxxb,mdxxc,icar,iti1,ifit)
c      nlxx=nxxc*nxxb*mdxxc
c      call xplot(store(lxxc),nlxx,ncwu,nxxc,nxxb,mdxxc,icar,iti1,ifit)
            else
            call yplotNEW(buff,ncwu,lxxc,nxxc,nxxb,mdxxc,icar,itit,ifit)
c      nlxx=nxxc*nxxb*mdxxc
c      call xplot(ncwu,lxxc,nxxc,nxxb,mdxxc,icar,itit,ifit)
            endif
         endif
         write(ncwu,1011)nchg
1011     format(' Modified weight(s) =',i5)
         write(ncwu,9314)
      enddo
c
5500  continue
c      icod(1)=1
      if(icod(1).gt.0) then
         write(ncwu,7510)
7510     format(1x,'   h   k   l',6x,'fo',2x,'   sig(fo)',
     1   5x,'fc',5x,'weight',1x,'1/weight',1x,'/fo-fc/',1x,'w*/fo-fc/2')
         nchg=0
         n4z=0
         do k=1,nreflX
            ky=iwork1(k)
            fobs=work1(ky)
            fcal=work2(ky)
            diff=abs(fobs-fcal)
            sigmaf=worko(ky)
            st=sqrt(rhov(ky))
            call CalcWeight(fobs,fcal,sigmaf,st,w1,n4z)
            w2=w1*w1
            w3=0.0
            if(w2.gt.0.0) w3=1/w2
            dw=diff*diff*w2
            write(ncwu,7520)khl(1:3,ky),fobs,sigmaf,fcal
     1	                    ,w2,w3,diff,dw
7520        format(1x,3i4,f10.3,f9.3,f10.3,f9.3,f8.3,f8.3,f10.3)
         enddo
         write(ncwu,9314)
      endif
5510  continue
      return
      end
c
code for yplot
      subroutine yplotNEW(buff,ncwu,l1,n2,n3,nd,n4,n5,ifit)
c--plot routine
c  ifit=0 non interpolo
c	1 interpolo
c  ncwu  printer logical unit
c  l1    address in buff of the first set of coordinates
c  n2    number of points
c  n3    number of sets of points
c  nd    number of words per each point
c  n4    vector contains the characters
c  n5    vector contains the name(s)
c
c--
      dimension buff(200)
      dimension istrip(101),asc(11),n4(*),n5(*)
      dimension r(4),t(4),a(4),ixy(2),its(6)
	character*14 ibchar
      data ibchar/'  x y x  =)=( '/
c                  12345678901234 
c--
c      data ib/2h  /,ic/1hx/,ixy/2hy ,2hx /,iug/2h =/,iugs/2h)=/
c      data ipa/2h( /
c--
      read(ibchar,'(7a2)')ib,ic,ixy,iug,iugs,ipa
c
      write(ncwu,991)
 991  format(1h )
      l1b=l1
      n2b=n2*n3
      fx1=buff(l1b)
      fx2=buff(l1b)
      fy1=buff(l1b+1)
      fy2=buff(l1b+1)
      do n=1,n2b
         e=buff(l1b)
         f=buff(l1b+1)
         fx1=amin1(fx1,e)
         fx2=amax1(fx2,e)
         fy1=amin1(fy1,f)
         fy2=amax1(fy2,f)
         l1b=l1b+nd
      enddo
      xoriz=50.
      yvert=25.
      noriz=50
      nvert=25
      dif=fy2-fy1
      sc1=xoriz/dif
      dif=fx2-fx1
      sc2=yvert/dif
      rsc1=1./sc1
      rsc2=1./sc2
      asc(1)=fy1
      npoint=noriz/10+1
      do i=1,npoint
         asc(i)=asc(1)+10.*(i-1)*rsc1
      enddo
      write(ncwu,1101)(asc(i),i=1,npoint)
 1101 format(4x,11f10.3)
      write(ncwu,1102)
 1102 format(2x,6(9x,1h*))
      write(ncwu,1103)
 1103 format(8x,57(1h*))
      write(ncwu,1104)
 1104 format(8x,1h*,55x,1h*)
      write(ncwu,1104)
c--controllo titolo
      jj=1
      jjj=1
      jj1=1
      j1=4
c--loop analogo normal
      if(ifit.eq.0) then
	   n2b=n2
      else
	   n2b=n2-2
      endif
      j=1
      q=fx1
      do m=1,nvert+1
	   do i=1,noriz+1
	      istrip(i)=ib
	   enddo
	   if(ifit.eq.0)then
	      l1bx=l1+(j-1)*nd
	      l1bxa=l1bx
	      j=j+1
	   else
	      if(j.eq.1) go to 1500
	      if(j.eq.n2b) go to 1515
	      l1b=l1+j*nd
	      if(q.lt.buff(l1b)) go to 1515
1500	      continue
	      j=j+1
	      l1ba=l1+(j-2)*nd
	      l1bx=l1ba
	      do k=1,4
	         r(k)=buff(l1bx)
	         l1bx=l1bx+nd
	      enddo
1515	      continue
	      l1bx=l1ba
    	   endif
	   do n=1,n3
	      if(ifit.eq.0) then
	         al=(buff(l1bx+1)-fy1)*sc1
	      else
	         l1bb=l1bx
	         do k=1,4
	            t(k)=buff(l1bb+1)
	            l1bb=l1bb+nd
	         enddo
	         call xfit (r,t,a)
	         al=(a(4)+q*(a(3)+q*(a(2)+q*a(1)))-fy1)*sc1
	      endif
	      if(al.gt.noriz+2) al=noriz+2
	      il=al+1
	      if(il.gt.noriz+1) il=noriz+1
	      if(il.lt.1) il=1
	      if(istrip(il).eq.ib) go to 1540
	      ia=ic
	      go to 1560
1540	      continue
	      ia=n4(n)
1560	      continue
	      istrip(il)=ia
	      l1bx=l1bx+n2*nd
	   enddo
c--controllo titolo
	   if(jj1.gt.2) go to 1430
	   its(1)=ib
	   its(2)=ixy(jj1)
	   its(3)=iug
	   jj1=jj1+1
         go to 1440
1430	   continue
	   if(jj.gt.n3) go to 1400
	   its(1)=ipa
	   its(2)=n4(jj)
	   its(3)=iugs
	   jj=jj+1
1440	   continue
	   its(4)=n5(jjj  )
	   its(5)=n5(jjj+1)
	   its(6)=n5(jjj+2)
	   jjj=jjj+3
	   go to 1420
1400	   continue
	   do i=1,6
	      its(i)=ib
	   enddo
1420	   continue
	   j1=j1+1
	   if(j1-5) 1300,1250,1300
 1250	   continue
	   q1=q
	   if(ifit.eq.0) q1=buff(l1bxa)
	   write(ncwu,1251) q1 ,(istrip(i),i=1,noriz+1)
     1	                 ,(its(i),i=1,6)
 1251	   format(1x,f6.2,2h**,2x,51a1,2x,2h**,1x,6a2)
	   j1=0
	   go to 1350
 1300	   continue
	   write(ncwu,1301)(istrip(i),i=1,noriz+1)
     1	                  ,(its(i),i=1,6)
 1301	   format(8x,1h*,2x,51a1,2x,1h*,2x,6a2)
 1350	   continue
	   q  =q  +rsc2
      enddo
      write(ncwu,1104)
      write(ncwu,1104)
      write(ncwu,1103)
      write(ncwu,1102)
      write(ncwu,991)
      return
      end
c
code for newpar
      subroutine newparNEW(kk,r1)
c--calculate the cruickshank's coeficents by l.s. analysis of /Fo-Fc/^2
c  nWeight=14 : KK=1
c  nWeight=15 : KK=2
c
      USE General
      USE Riflessi
      USE LsqModule
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/workd/icod(30),ise(24),fud(4),nty,ityp(8),sumn,sumq,sigmaq
      dimension cod(30)
      equivalence(icod,cod)
c
      dimension det(3,3),vet(3),nre(20),rre(20),dumvet(3,3)
      dimension norrif(1001),fo(2,1001),sd2w(1000),ffo(1000)
c--
      jfirst=0
      intervx=1000
      ninterx=20
      interv=0
      if(icod(3).ne.8) interv=icod(3)
!--intervalli  Fo  (kk=1)    
!--intervalli (sin(theta)/lambda)2  (kk=2)
      jfirst=0
      call folimiMNQD(jfirst,interv,intervx,ninterx,norrif,fo,kk)
      vet(:)=0.0
      det(:,:)=0.0
      dumvet(:,:)=0.0
      st=0.0
      do i=1,interv
         iniz=norrif(i)
         ifin=norrif(i+1)-1
         sd2w(i)=0.
         ffo(i)=0.
         do k=iniz,ifin
            ky=iwork1(k)
            fobs=work1(ky)
            fcal=work2(ky)
            sigmaf=worko(ky)
            st=1.0/sqrt(rhov(ky))
            diff=fobs-fcal
            diff2=diff*diff
            sd2w(i)=sd2w(i)+diff2
c--definisco la variabile
            if(kk.eq.1) then
               variab=fobs
            else
               variab=st
            endif
            ffo(i)=ffo(i)+variab
c--calculate the coefficients of the function:
c  utilizzando i valori di ogni riflesso 
c  d2 = a + b*F + c*F2	  case kk=1
c  d2 = a + b*st+ c*st2   case kk=2
c  by the ls methods
c      det(1,1)=det(1,1)+1
c      det(1,2)=det(1,2)+variab
c      det(1,3)=det(1,3)+variab*variab
c      vet(1)=vet(1)+diff2
c      det(2,2)=det(2,2)+variab*variab
c      det(2,3)=det(2,3)+variab*variab*variab
c      vet(2)=vet(2)+diff2*variab
c      det(3,3)=det(3,3)+variab*variab*variab*variab
c      vet(3)=vet(3)+diff2*variab*variab
         enddo
         contrib=float(ifin-iniz+1)
         sd2w(i)=sd2w(i)/contrib
         ffo(i)=ffo(i)/contrib
      enddo
c--calculate the coefficients of the function:
c  utilizzando i valori medi
c  d2 = a + b*F + c*F2	  case kk=1
c  d2 = a + b*st+ c*st2   case kk=2
c  by the ls methods
      do i=1,interv
         det(1,1)=det(1,1)+1
         det(1,2)=det(1,2)+ffo(i)
         det(1,3)=det(1,3)+ffo(i)*ffo(i)
         vet(1)=vet(1)+sd2w(i)
         det(2,2)=det(2,2)+ffo(i)*ffo(i)
         det(2,3)=det(2,3)+ffo(i)*ffo(i)*ffo(i)
         vet(2)=vet(2)+sd2w(i)*ffo(i)
         det(3,3)=det(3,3)+ffo(i)*ffo(i)*ffo(i)*ffo(i)
         vet(3)=vet(3)+sd2w(i)*ffo(i)*ffo(i)
      enddo
      det(2,1)=det(1,2)
      det(3,1)=det(1,3)
      det(3,2)=det(2,3)
c--risoluzione del sistema delle eq. normali
	dumvet(1:3,1)=vet(1:3)
	ider=3
	nvet=1
	call matin(det,ider,dumvet,nvet,deter)
	vet(1:3)=dumvet(1:3,1)
c--controllo la equazione della parabola
c        write(ncwu,*)' vet...',vet(1),vet(2),vet(3)
c        xxx=-vet(2)/(2.0*vet(3))
c        yyy=vet(1)+vet(2)*xxx+vet(3)*xxx*xxx
c        write(ncwu,*)' xxx,yyy',xxx,yyy
c        if(yyy.lt.0) then
c        vet(1)=vet(1)-yyy+0.1
c        endif
c--save new coefficients in list 4
      WPar(1)=vet(1)
      WPar(2)=vet(2)
      WPar(3)=vet(3)
      WPar(4)=1.0
c      idef=0
c      call frm04(iw4,n4,idef)
c     
c      call xfl04
c      write(ncwu,*)' new:', store(l4),store(l4+1),store(l4+2)
c--calculate r(w) indices
      if(icod(7).ge.1) then
         eps=0.
         den=0
         nchg=0
         n4z=0
         do i=1,interv
            fobs=ffo(i)
            if(nWeight.eq.15) st=1.0/ffo(i)
            diff=sqrt(sd2w(i))
            sigmaf=0.0
            call CalcWeight(fobs,fcal,sigmaf,st,w,n4z)
            w3=w*w
            w2=0.0
            if(w3.gt.0.0) w2=1.0/w3
            eps=eps+abs(sd2w(i)-w2)
            den=den+sd2w(i)
            ww=w3*sd2w(i)
         enddo
         r1=100.*eps/den
         write(ncwu,1000) r1
1000     format(/,' R(Inter) =',f10.2)
      endif
      return
      end
c
code for Chepar
      subroutine CheparNEW(kk,r1)
c--calculate the Chebyshev's coeficents by analysis of /Fo-Fc/^2
c  nWeight = 16
c  nPar max = 9 (+1 per scale)
      USE General
      USE Riflessi
      USE LsqModule
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/workd/icod(30),ise(24),fud(4),nty,ityp(8),sumn,sumq,sigmaq
      dimension cod(30)
      equivalence(icod,cod)
c
      real*8  str11(150),buf11(10),vet11(10)
c
      dimension norrif(1001),fo(2,1001),sd2w(1000),ffo(1000)
c--
      jfirst=0
      intervx=1000
      ninterx=20
      interv=0
      if(icod(3).ne.8) interv=icod(3)
!--intervalli  Fo  (kk=1)    
      jfirst=0
      call folimiMNQD(jfirst,interv,intervx,ninterx,norrif,fo,kk)


c--set some address
c      md4=nPar
c      nu=1
c      nr=nu+md4
c      nv=nr-1
c      ns=nr+md4*md4
c      nz=ns+md4
c      nfld=nz+md4
c--dimensione del vettore real*8 per l.s.
c      md11r=nfld-nu+1+md4
c
c-- allocate work area for l.s. matrix (str11)
c
c      IF (.NOT. ALLOCATED(str11))
c     *	  ALLOCATE (str11(1:md11r), stat = ierr)
c      if (ierr.ne.0) then
c	  write(ncwu,*) 'L.S. matrix str11 Allocation error'
c          call cstop(' ')
c      endif
c      do i=nu,nfld
c	str11(i)=0.0
c      enddo
c--start the reflections loop
      str11(:)=0.0
      vet11(:)=0.0
      e=WPar(nPar+1)    
c      write(ncwu,*)'e:',e
      cs=2.
      ew=1.0/(e**cs)
      do k=1,nreflX
         ky=iwork1(k)
         fobs=work1(ky)
         fcal=work2(ky)
	   diff=fobs-fcal
	   diff2=diff*diff
c         sigmaf=worko(ky)
c         st=sqrt(rhov(ky))
c         call CalcWeight(fobs,fcal,sigmaf,st,w1,n4z)
	   g=2.0*fobs*e-1
	   buf11(1 )=1.0
	   buf11(2)=dble(g)
	   do l=3,nPar
	      buf11(l)=2*g*buf11(l-1)-buf11(l-2)
	   enddo
	   w=ew/(1.+fobs**cs)
	   nq=1
	   do l=1,nPar
	      do m=l,nPar
	         str11(nq)=str11(nq)+buf11(l)*buf11(m)*dble(w)
	         nq=nq+1
	      enddo
	      vet11(l)=vet11(l)+buf11(l)*dble(diff2*w)
	   enddo
      enddo
c
c--invert the current block
      if(istat2.ge.2)then  !   2012,2012,2013
         write(ncwu,2021) nPar
2021     format(//,'  matrix order =',i4,/)
         iii=nPar-1
         iv=1
         do ivi=1,nPar
            write(ncwu,2023)(str11(ivv),ivv=iv,iv+iii)
2023        format(1x,10e12.4)
            iv=iv+iii+1
            iii=iii-1
         enddo
         write(ncwu,2023)(vet11(ivv),ivv=1,nPar)
      endif
c
c--calculate the coefficients of the function:
      buf11(:)=0.0
      call CholMnqd(kd,nPar,str11,buf11,ier)
      if(ier.ne.0) goto 3010
      call xsolvMnqd(nPar,str11,vet11,buf11)
c--save new coefficients in list 4
	do n=1,nPar
	   WPar(n)=buf11(n)
	enddo
      WPar(nPar+1)=e
      WPar(nPar+2)=1.0
c--calculate r(w) indices
      if(icod(7).ge.1) then
         eps=0.
         den=0
         nchg=0
         n4z=0
         do i=1,interv
            iniz=norrif(i)
            ifin=norrif(i+1)-1
            sd2w(i)=0.
            ffo(i)=0.
            do k=iniz,ifin
               ky=iwork1(k)
               fobs=work1(ky)
               fcal=work2(ky)
	         diff=fobs-fcal
	         diff2=diff*diff
               sigmaf=worko(ky)
               st=sqrt(rhov(ky))
               sd2w(i)=sd2w(i)+diff2
               ffo(i)=ffo(i)+fobs
            enddo
            contrib=float(ifin-iniz+1)
            sd2w(i)=sd2w(i)/contrib
            ffo(i)=ffo(i)/contrib
            fobs=ffo(i)
            diff=sqrt(sd2w(i))
            call CalcWeight(fobs,fcal,sigmaf,st,w,n4z)
            w3=w*w
            w2=0.0
            if(w3.gt.0.0) w2=1.0/w3
            eps=eps+abs(sd2w(i)-w2)
            den=den+sd2w(i)
            ww=w3*sd2w(i)
         enddo
         r1=100.*eps/den
         write(ncwu,1000) r1
1000     format(/,' R(Inter) =',f10.2)
      endif
      return
3010  continue
      write(ncwu,*)' Warning!'
      return
      end
c
code for xweightNEW
      subroutine xweightNEW(wrob)
c--cruickshank's coeficents automatic determination 
c
      USE General
      USE Riflessi
      USE Atomi
      USE LsqModule
      USE LsqStuff22Abs
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/workd/icod(30),ise(24),fud(4),nty,ityp(8),dummwd(3)
      dimension cod(30)
      equivalence(icod,cod)
c
      dimension aa(3)
c--
c
c--set some code
c     icod(15)=1		 ! refine coeff was set = 1 default
      if(nWeight.eq. 1) icod(15)=0
      if(nWeight.eq. 2) then
         if(icod(21).eq.0) icod(21)=1
      endif
      if(nWeight.eq. 3) icod(15)=0
      if(nWeight.eq. 4) icod(15)=0
      if(nWeight.eq. 5) icod(15)=0
      if(nWeight.eq. 6) icod(15)=0
      if(nWeight.eq. 7) icod(15)=0
      if(nWeight.eq. 8) icod(15)=0
      if(nWeight.eq. 9) icod(15)=0
      if(nWeight.eq.10) icod(15)=0
      if(nWeight.eq.11) then
         if(icod(21).eq.0) icod(21)=1
      endif
      if(nWeight.eq.12) then
         if(icod(21).eq.0) icod(21)=1
         if(icod(24).eq.1) icod(15)=0
      endif
      if(nWeight.eq.13) then
         if(icod(21).eq.0) icod(21)=1
      endif
      if(nWeight.eq.14) icod(15)=0
      if(nWeight.eq.15) icod(15)=0
      if(nWeight.eq.16) icod(15)=0
      if(nWeight.eq.17) icod(15)=0
      if(nWeight.eq.18) icod(15)=0
c--
c     if(nWeight.eq.12) then
c      if(icod(24).eq.1) call wshelx(r1)
c     endif
      if(nWeight.eq.14) then
         kk=1
         call newparNEW(kk,r1)
      endif
      if(nWeight.eq.15) then
c--------------------------------------
         do k=1,nreflX
            iwork2(k)=k
         enddo    
c--sort on 1/st 
         tmpwt(1:nreflX)=1.0/sqrt(rhov(1:nreflX))
         call SortInd(nreflX,iwork2,tmpwt)
         kk=2
         call newparNEW(kk,r1)
         do k=1,nreflX
            iwork2(k)=k
         enddo    
         tmpwt(1:nreflX)=rhov(1:nreflX)
         call SortInd(nreflX,iwork2,tmpwt)
      endif
      if(nWeight.eq.16) then
         kk=1
         call CheparNEW(kk,r1)
      endif
c--
      d2wt1=0.
      nchg=0
      n4z=0
      sumdif=0.0
      sumw=0.0
      do k=1,nreflX
         ky=iwork1(k)
         fobs=work1(ky)
         fcal=work2(ky)
         diff=abs(fobs-fcal)
         diff2=diff*diff
         st=sqrt(rhov(ky))
         sigmaf=worko(ky)
         call CalcWeight(fobs,fcal,sigmaf,st,w1,n4z)
         w2=w1*w1
         d2w=diff2*w2
         d2wt1=d2wt1+d2w
      enddo
      d2wt1=d2wt1/(nreflX-NParTot)
      s=sqrt(d2wt1)
c--determinazione dei nuovi coeff. della funzione di peso
c      write(ncwu,*)' nWeight,d2wt1,nxxe,n22a',nWeight,d2wt1,nxxe,n22a
c-----------1 2 3 4 5 6 7 8 9101112131415161718------------
      nWscale=nPar+1
      if (nWeight.eq.16) nWscale=nWscale+1
      select case (nWeight)
	   case (2,11,12,13,14,15,17,18)
	      n=nPar
	      if(nWeight.eq.11.or.nWeight.ge.17) n=n-1
	      do i=1,n
	         WPar(i)=WPar(i)*d2wt1
	      enddo
	   case (1,3,4,5,6,7,8,9,10)
	      WPar(nWscale)=WPar(nWscale)/d2wt1
      end select
      wfo2t=0.
      rwt=0.
      rt=0.
      fo1t=0.
      d2wt1=0.
      nchg=0
      n4z=0
      do k=1,nreflX
         ky=iwork1(k)
         fobs=work1(ky)
         fcal=work2(ky)
         diff=abs(fobs-fcal)
         diff2=diff*diff
         st=sqrt(rhov(ky))
         sigmaf=worko(ky)
         fobs2=fobs*fobs
         fo1t=fo1t+abs(fobs)
         call CalcWeight(fobs,fcal,sigmaf,st,w1,n4z)
         w2=w1*w1
         d2w=diff2*w2
         d2wt1=d2wt1+d2w
         wfo2t=wfo2t+fobs2*w2
         rwt=rwt+d2w
         rt=rt+abs(diff)
      enddo
      d2wt1=d2wt1/(nreflX-NParTot)
      s=sqrt(d2wt1)
      rt=100.*rt/fo1t
      rwt=100.*sqrt(rwt/wfo2t)
      if(icod(7).ge.1) then
         write(ncwu,9315) rt
9315     format(' R(F)%........',f7.3)
         write(ncwu,9316) rwt
9316     format(' wR(F^2)%.....',f7.3)
c        write(ncwu,8000)s
c8000    format(' S (G.o.F.)...',f7.3)
      end if
c--calculate weight
c   affina i coefficienti solo se   icod(15)=1		
      call calcoeNEW
c
c--calculate r(w) indices
      if(icod(7).ge.1) then
         eps=0.
         den=0.
         if(istat2.ge.1) then
            write(ncwu,1030)
1030        format(/,' List of reflections with (d2-w)/d2',
     1               ' greather than 80%',/)
            write(ncwu,1035)
1035        format(4x,'reflection',6x,'fo',6x,'fc',
     2             5x,'diff2',3x,'weight',3x,'W(new)',2x,'snt/l',/)
         endif
         nchg=0
         wrob=0.0
         n4z=0
         do k=1,nreflX
            ky=iwork1(k)
            fobs=work1(ky)
            fcal=work2(ky)
            diff=abs(fobs-fcal)
            diff2=diff*diff
            st=sqrt(rhov(ky))
            sigmaf=worko(ky)
            fobs2=fobs*fobs
            fo1t=fo1t+abs(fobs)
            call CalcWeight(fobs,fcal,sigmaf,st,w1,n4z)
            wrob=wrob+w1*abs(diff)
            w3=w1*w1
            d2w=diff2*w3
            w2=0.0
            if(w3.gt.0.0) w2=1.0/w3
            diff3=diff2-w2
            eps=eps+abs(diff3)
            diff4=diff2
            if(diff3.lt.0.0) diff4=w2
            den=den+diff4
            if(istat2.ge.1) then
               write(ncwu,1040)(khl(m,ky),m=1,3),fobs,fcal ,
     1                          diff2,w2,w3,st
1040           format(3i5,2f8.2,3f8.3,f8.4)
            endif
         enddo
         wrob=wrob/nreflX
         r2=100.*eps/den
         write(ncwu,1010) nchg,n4z,r2,wrob
1010     format(/,  ' Weight(s) modified      ',i7,/,
     1       ' Weight(s) set to random ',i7,/,
     1       ' %SUM[d2-(1/w)]/SUM[d2] =',f10.2,/,
     1       ' <|sqrt(w).D|>          =',f10.3,/)
!
         write(ncwu,9314)
9314     format(1h ,78(1h-))
      endif
      return
      end
c
code for calcoe
      subroutine calcoeNEW
c--cruickshank's coeficents automatic determination 
c
      USE General
      USE Riflessi
      USE LsqModule
      USE LsqStuff22Abs
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/workd/icod(30),ise(24),fud(4),nty,ityp(8),sumn,sumq,sigmaq
      dimension cod(30)
      equivalence(icod,cod)
c
      dimension sd2w(1000),der(1000,3),aa(3),norrif(1001),
     1 vet(3),fo(2,1001),dumvet(3,3)
      dimension dprint(1000,11)
      dimension aap(50,3),adum(4),sdum(4)
      dimension det(3,3)
c
c      write(ncwu,*) ' entro in calcoe'
c--ninter n.di rifl. per intervallo
c--interv n. di intervalli
c--
      ncicli =icod(2)
      ncicli1=icod(20)
      itype  =icod(21)
      idivide=icod(18)
      errpsi =cod(4)
      ntent  =icod(8)
      fudge  =cod(5)
      ifud   =int(fudge*10000.0)
c      psi=cod(6)
      icod3=icod(3)
      aap(:,:)=0.
      aa(:)=0.
      vet(:)=0.
      dumvet(:,:)=0.0
      adum(:)=0.
      sdum(:)=0.
c
c--range on Fo
      intervx=120
      ninterx=120
      interv=0
      if(icod3.ne.8) interv=icod3
      kk=1
      jfirst=0
      call folimiMNQD(jfirst,interv,intervx,ninterx,norrif,fo,kk)
      jfirst=1
c
c--range on (sin(theta)/lambda)2
      kk=2
      call folimiMNQD(jfirst,interv,intervx,ninterx,norrif,fo,kk)
c--      
      if(icod(7).ge.1)then
	   write(ncwu,4201)
4201	   format(1h )
	   if(icod(15).eq.1) then
	      write(ncwu,'(a)')    ' Starting parameters'
	   else
	      write(ncwu,'(a)')    ' Weighting parameters'
	   endif
	  do i=1,nPar
	     write(ncwu,4202) i,WPar(i)
4202	     format(3h P(,i1,3h) =,f10.5)
	  enddo
      endif
c-------------------------------------
      nci1=1
1000  continue
      call wchoNEW(ider,itype,idivide,aa,bbb)
      psi0=99999.
      iexit=0
      nci=1
c--start the loop
999   continue
      istampa=0
c--
c--write file autow.tst
c      write(ncpu,4601)nci,rrt,rrwt
c--
      if(icod(7).gt.1)then
	   if(icod(15).eq.1) then
	      write(ncwu,'(/,a,i3)') ' Cycle',nci
	   endif
      endif
      d2wmin=1000
      d2wmax=0.
      d2wt1=0.
c--considera distribuzione fo (kk=1) e sin(teta) (kk=2)
      interv2=interv*2
      do kk=1,icod(23)
         if(kk.eq.1) then
            interv2=interv
            incr=0
c            njump=4            ! sort sulla posizione njump-1
         else
            interv2=interv*2
c            njump=8            ! sort sulla posizione njump-1
           incr=interv
         endif
c      call sortz_dyn(xstore,lfl6,lxxe,nxxe,mdxxe,njump)
         if (icod(7).gt.1) then
             if(nci.eq.1.or.nci.eq.ncicli) then
c             istampa=1
                if(kk.eq.1) then
                   write(ncwu,4200)
4200               format(/,' Range #',8x,'Nref',10x,' Fo Range',
     1                    15x,'  < wd2 > ')
                else
                   write(ncwu,4207)
4207               format(/,' Range #',8x,'Nref',5x,
     1                    ' Sin(theta)/l Range',9x,'  < wd2 > ')
                endif
             endif
         endif
         nchg=0
         n4z=0
         do i=1,interv
            ii=i+incr
            iniz=norrif(i)
            ifin=norrif(i+1)-1
            sd2w(ii)=0.
            if(icod(15).eq.1) then
               do j=1,ider
                  der(ii,j)=0.
               enddo
            endif
c     xmind=100000.0
c     xminw=100000.0
c     xmaxd=-10000.0
c     xmaxw=-10000.0
            do k=iniz,ifin
               if(kk.eq.1) then
                  ky=iwork1(k)
               else
                  ky=iwork2(k)
               endif
               fobs=work1(ky)
               fcal=work2(ky)
               diff=abs(fobs-fcal)
               sigmaf=worko(ky)
               st=sqrt(rhov(ky))
               diff2=diff*diff
               if (icod(15).eq.1) then
                   icalc=1
                   call wderivNEW(ky,icalc,itype,aa,bbb,ii,der,d2w)
               else
                   call CalcWeight(fobs,fcal,sigmaf,st,w1,n4z)
                   w2=w1*w1
                   d2w=diff2*w2
               endif
!                  
c        w3=0.0
c        if(w2.gt.0) w3=1.0/w2
c        xmind=min(xmind,diff2)
c        xmaxd=max(xmaxd,diff2)
c        xminw=min(xminw,w3)
c        xmaxw=max(xmaxw,w3)
!              
               sd2w(ii)=sd2w(ii)+d2w
            enddo
            contrib=float(ifin-iniz+1)
            icont=int(contrib)
            sd2w(ii)=sd2w(ii)/contrib
            d2wt1=d2wt1+sd2w(ii)
            ww=sd2w(ii)
            if(icod(15).eq.1) then
	         do l=1,ider
	            der(ii,l)=der(ii,l)/contrib
	         enddo
c--divido per P(2) per essere in scala con S calcolato precedentemente
	         if(idivide.eq.0) then
	            select case (itype)
	               case (1)
	                  ww=sd2w(ii)/WPar(2)
	               case (2)
	                  ww=sd2w(ii)/WPar(3)
	               case (3)
	                  ww=sd2w(ii)/WPar(1)
	               case (4)
	                  ww=sd2w(ii)/WPar(4)
	            end select      
	         endif      
            endif
            if(ww.lt.d2wmin)d2wmin=ww
            if(ww.gt.d2wmax)d2wmax=ww
            if(icod(7).gt.1)then
	         if(nci.eq.1.or.nci.eq.ncicli) then
	            if(kk.eq.1) then
	               write(ncwu,3001)i,icont,(fo(kk,jj),jj=i,i+1),ww
3001	               format(i5,i15,6x,f7.1,' - ',f7.1,f20.5)
	            else
	               write(ncwu,3002)ii,icont,(fo(kk,jj),jj=i,i+1),ww
3002	               format(i5,i15,5x,f7.4,' - ',f7.4,f20.5)
	            endif
               endif
            endif
c--write file 'structure'.num
            fom=0.5*(fo(kk,i+1)+fo(kk,i))
c      write(ncpu,4600)fom,ww
            dprint(ii,1)=fom
            dprint(ii,nci+1)=ww
c--
c--fine loop intervalli
         enddo
c--fine analisi distribuzioni
      enddo
c--
4600  format(1x,11f10.4)
4601  format(1x,i10,2f10.4)
      d2wt1=d2wt1/float(interv2)
c      write(ncwu,*)'d2wt1',d2wt1
c--determinazione della media (sm)
      if(cod(22).gt.0.1) then
	   d2wm=cod(22)
      else
         if(nci.eq.1)then
	      d2wm=0.
	      do j=1,interv2
c	write(ncwu,*) d2wm,sd2w(j)
	         d2wm=d2wm+sd2w(j)
	      enddo
c	write(ncwu,*) interv2
	      d2wm=d2wm/float(interv2)
c	write(ncwu,*)'d2wm',d2wm
	      d2wm5=d2wm*0.5
	      d2wm1=d2wm-d2wm5
	      d2wm2=d2wm+d2wm5
	      d2wmi=0.0
	      nmed=0
	      do j=1,interv2
c	write(ncwu,*) j,d2wm2,d2wm1,d2wmi,sd2w(j)
	         if((sd2w(j).le.d2wm2).and.(sd2w(j).ge.d2wm1)) then
	             d2wmi=d2wmi+sd2w(j)
	             nmed=nmed+1
	         endif
	      enddo
	      if(nmed.eq.0) then
	         write(ncwu,3101)
3101	         format(/,' Warning: bad fo-distribution!')
c     1 ' weighting scheme analisys terminated.')
c         return
c         endif
            else
	         d2wm=d2wmi/float(nmed)
c	 write(ncwu,*)'d2wm, d2wmi,nmed',d2wm, d2wmi,nmed
            endif
         endif
      endif
      if(icod(15).eq.1) then
	   do i=1,ider
	      vet(i)=0.
	   enddo
      endif
c      write(ncwu,*)' icod(15),nci',icod(15),nci
      if(nci.eq.1.and.icod(15).eq.0) goto 3500
      if(iexit.eq.1)goto 3500
      if(icod(15).eq.1) then
c-- calcolo dei coeff.del sistema lineare
	   do i=1,ider
	      vet(i)=0.
	      do  k=1,ider
	          det(i,k)=0.
	      enddo
	   enddo
	   do j=1,interv2
	      do i=1,ider
	         vet(i)=vet(i)+der(j,i)*(d2wm-sd2w(j))
	         do k=1,ider
	            det(i,k)=det(i,k)+der(j,i)*der(j,k)
	         enddo
	      enddo
	   enddo
c--risoluzione del sistema delle eq. normali
	   do i=1,3
	      dumvet(i,1)=vet(i)
	   enddo
	   nvet=1
	   call matin(det,ider,dumvet,nvet,deter)
	   do i=1,3
	      vet(i)=dumvet(i,1)
	   enddo
      end if
c--calcolo della funzione da minimizzare
3500  continue
      psi=0.0
      do j=1,interv2
         e=d2wm-sd2w(j)
         psi=psi+e*e
      enddo
      scarto2=sqrt(psi/interv2)
      d2ww=d2wm
c	write(ncwu,*)' idivide,itype',idivide,itype
	if(idivide.eq.0) then
         select case (itype)
            case (1)
               d2ww=d2wm/WPar(2)
            case (2)
               d2ww=d2wm/WPar(3)
            case (3)
               d2ww=d2wm/WPar(1)
            case (4)
               d2ww=d2wm/WPar(4)
         end select      
	endif
      diffx=100.0*scarto2/d2ww
      diff=100.0*(d2wmax-d2wmin)/d2ww
      if(icod(15).eq.1) then
         if(iexit.eq.0) then
c--determinazione degli shift da applicare
            do k=1,ider
5110           continue
               if(vet(k).lt.-aa(k)) then
	            vet(k)=vet(k)/2
	            goto 5110
               end if
            enddo
         endif
      endif
      if(icod(7).gt.1)then
	   write(ncwu,4201)
         select case (itype)
            case (1)
               adum(1)=aa(1)
	         adum(2)=bbb
	         adum(3)=aa(2)
	         adum(4)=aa(3)
	         sdum(1)=vet(1)
	         sdum(2)=0.0
	         sdum(3)=vet(2)
	         sdum(4)=vet(3)
            case (2)
	         adum(1)=aa(1)
	         adum(2)=aa(2)
	         adum(3)=bbb
	         adum(4)=aa(3)
	         sdum(1)=vet(1)
	         sdum(2)=vet(2)
	         sdum(3)=0.0
	         sdum(4)=vet(3)
            case (3)
	         adum(1)=bbb
	         adum(2)=aa(1)
	         adum(3)=aa(2)
	         adum(4)=aa(3)
	         sdum(1)=0.0
	         sdum(2)=vet(1)
	         sdum(3)=vet(2)
	         sdum(4)=vet(3)
            case (4)
	         adum(1)=aa(1)
	         adum(2)=aa(2)
	         adum(3)=aa(3)
	         adum(4)=bbb
	         sdum(1)=vet(1)
	         sdum(2)=vet(2)
	         sdum(3)=vet(3)
	         sdum(4)=0.0
         end select      
	   j3=3
	   if(nWeight.eq.13) j3=4
	   do j=1,j3
	      write(ncwu,4205) j,adum(j),j,sdum(j)
4205        format(' p(',i1,') =',f10.5,'  shift(',i1,') =',f10.5)
         enddo
         write(ncwu,4203)d2wmin,d2wmax,d2ww,diff,scarto2,diffx
4203     format(' Min. < wd2 >      = ',f10.5,
     1          /,' Max. < wd2 >      = ',f10.5,
     1          /,' Average <wd2>     = ',f10.5,
     1          /,' Difference in %   = ',f10.5,
     1          /,' Scarto quad.medio = ',f10.5,
     1          /,' Scarto relativo % = ',f10.5)
	   if(icod(15).eq.1) then
	      write(ncwu,3506)psi
3506	      format(' Minim. Function   = ',e15.5)
         endif
      endif
      if(iexit.eq.1) goto 5200
      if(icod(15).eq.0) goto 5500
c--determinazione dei nuovi coeff. della funzione di peso
      do i=1,ider
         aap(nci,i)=aa(i)
      enddo 
      do k=1,ider
         aa(k)=aa(k)+vet(k)*fudge
      enddo
c--analisi dell'affinamento
      difpsi=psi0-psi
      if(difpsi.lt.0) goto 5101
      if(difpsi/psi.lt.errpsi) goto 5102 
      if(icod(15).eq.0) go to 5200
      if(nci.eq.ncicli)go to 5200
5105  continue
      nci=nci+1
      psi0=psi
      go to 999
5101  continue
      ncip=nci-1
      if(ncip.le.0)ncip=1
      do i=1,ider
         aa(i)=aap(ncip,i)
      enddo
5102  continue
      iexit=1
      ncicli=nci+1
      goto 5105
c--end of calculation
5200  continue
      if(icod(15).eq.1) then
c        if(icod(28).eq.1) then
c--write file 'structure'.num
c        do ii=1,interv2
c           write(ncpu,4600)dprint(ii,1),(dprint(ii,j),j=2,ncicli+1)
c        enddo
c        endif
      endif
c--
c--determinazione dei nuovi coeff. della funzione di peso
      bb=bbb
c      do 6100 k=1,ider
c6100  aa(k)=aa(k)*d2wt1
c      bb=d2wt1*bbb
c      njump=4          ! sort sulla posizione njump-1
c      call sortz_dyn(xstore,lfl6,lxxe,nxxe,mdxxe,njump)
      d2wt1=0.
      do k=1,nreflX
         ky=iwork1(k)
	   icalc=0
         call wderivNEW(ky,icalc,itype,aa,bb,ii,der,d2w)
         d2wt1=d2wt1+d2w
      enddo
c      write(ncwu,'(f10.3,2i10,2f10.5)') d2wt1,nxxe,n22a,scalo,scalc
      d2wt1=d2wt1/(nreflX-NParTot)
      s=sqrt(d2wt1)
c--save new coefficients in list 4
      select case (itype)
            case (1)
               WPar(1)=aa(1)
               WPar(2)=bb
               WPar(3)=aa(2)
               if(nWeight.eq.13) WPar(4)=aa(3)
            case (2)
               WPar(1)=aa(1)
               WPar(2)=aa(2)
               WPar(3)=bb
               if(nWeight.eq.13) WPar(4)=aa(3)
            case (3)
               WPar(1)=bb
               WPar(2)=aa(1)
               WPar(3)=aa(2)
               if(nWeight.eq.13) WPar(4)=aa(3)
            case (4)
               WPar(1)=aa(1)
               WPar(2)=aa(2)
               WPar(3)=aa(3)
               WPar(4)=bb
      end select      
c      nWscale=nPar+1
c      if (nWeight.eq.16) nWscale=nWscale+1
      if(icod(15).eq.0) goto 5500
      nci1=nci1+1
      if(nci1.le.ncicli1) goto 1000
      if(icod(7).ge.1) then
	   write(ncwu,'(/,a)') ' Final parameters'
	   write(ncwu,1046) ncicli
1046	   format(' after',i3,' cycle(s)')
	   do i=1,nWeight
	      write(ncwu,4202) i, WPar(i)
	   enddo
	   write(ncwu,8000)s
8000	   format(' S (G.o.F.) ',f7.3)
      endif
5500  continue
c--final tables
      if(icod(7).lt.1) return
      d2wmin=1000
      d2wmax=0.
      kk=1
c      njump=4            ! sort sulla posizione njump-1
5540  continue
      if(kk.eq.1) then
	   write(ncwu,5510)
5510	   format(//,' Analysis of <wd2> as a function of Fo')
	   write(ncwu,4200)
	   incr=0
      else
	   write(ncwu,5520)
5520	   format(//,' Analysis of <wd2> as a function of sin(T)/l)')
	   write(ncwu,4207)
	   interv2=2*interv
	   incr=interv
      endif
      nchg=0
      n4z=0
      do i=1,interv
	   ii=i+incr
	   iniz=norrif(i)
	   ifin=norrif(i+1)-1
	   sd2w(ii)=0.
	   do k=iniz,ifin
            if(kk.eq.1) then
               ky=iwork1(k)
            else
               ky=iwork2(k)
            endif
            fobs=work1(ky)
            fcal=work2(ky)
            diff=abs(fobs-fcal)
            sigmaf=worko(ky)
            st=sqrt(rhov(ky))
	      diff2=diff*diff
            call CalcWeight(fobs,fcal,sigmaf,st,w1,n4z)
	      w2=w1*w1
	      d2w=diff2*w2
	      sd2w(ii)=sd2w(ii)+d2w
	   enddo
	   contrib=float(ifin-iniz+1)
	   icont=int(contrib)
	   sd2w(ii)=sd2w(ii)/contrib
	   if(kk.eq.1) then
	      write(ncwu,3001)ii,icont,(fo(kk,jj),jj=i,i+1),sd2w(ii)
	   else
	      write(ncwu,3002)ii,icont,(fo(kk,jj),jj=i,i+1),sd2w(ii)
	   endif
	   ww=sd2w(ii)
	   if(ww.lt.d2wmin)d2wmin=ww
	   if(ww.gt.d2wmax)d2wmax=ww
      enddo
      if(kk.eq.2) then
	   d2wm=0.
	   do j=1,interv2
	      d2wm=d2wm+sd2w(j)
	   enddo
	   d2wm=d2wm/float(interv2)
	   psi=0.0
	   do j=1,interv2
	      e=d2wm-sd2w(j)
	      psi=psi+e*e
	   enddo
	   scarto2=sqrt(psi/interv2)
	   d2ww=d2wm
	   diffx=100.0*scarto2/d2ww
	   diff=100.0*(d2wmax-d2wmin)/d2ww
	   write(ncwu,4201)
	   write(ncwu,4203)d2wmin,d2wmax,d2ww,diff,scarto2,diffx
	   write(ncwu,3506)psi
	   return
      else
	   kk=2
	   goto 5540
      endif
      end
c
code for wcho
      subroutine wchoNEW(ider,itype,idivide,aa,bbb)
c--definisco i coefficienti da affinare
c
      USE General
      USE Riflessi
      USE LsqModule
!
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      dimension aa(3)
c
      ider=nPar-1
      select case (nWeight)
c---------------------------------------
c--criterio di pesaggio 2,11,12
         case(2,11,12)
            select case (itype)
               case(1)
                  aa(1)=  WPar(1)
                  aa(2)=  WPar(3)
                  bbb  =  WPar(2)
	            if(idivide.eq.0) then
	               aa(1)= WPar(1)/WPar(2)
	               aa(2)= WPar(3)/WPar(2)
	               bbb  = 1.0
	            endif
               case(2)
                  aa(1)= WPar(1)
                  aa(2)= WPar(2)
                  bbb  = WPar(3)
	            if(idivide.eq.0) then
                     aa(1)= WPar(1)/WPar(3)
                     aa(2)= WPar(2)/WPar(3)
                     bbb  = 1.0
                  endif
               case(3)
                  aa(1)= WPar(2)
                  aa(2)= WPar(3)
                  bbb  = WPar(1)
	            if(idivide.eq.0) then
                     aa(1)= WPar(2)/WPar(1)
                     aa(2)= WPar(3)/WPar(1)
                     bbb  = 1.0
                  endif
            end select
c---------------------------------------
c--criterio di pesaggio 13
         case(13)
            select case (itype)
               case(1)
                  aa(1)=  WPar(1)
                  aa(2)=  WPar(3)
                  bbb  =  WPar(2)
                  aa(3)=  WPar(4)
	            if(idivide.eq.0) then
	               aa(1)= WPar(1)/WPar(2)
	               aa(2)= WPar(3)/WPar(2)
	               aa(3)= WPar(4)/WPar(2)
	               bbb  = 1.0
	            endif
               case(2)
                  aa(1)= WPar(1)
                  aa(2)= WPar(2)
                  bbb  = WPar(3)
                  aa(3)= WPar(4)
	            if(idivide.eq.0) then
                     aa(1)= WPar(1)/WPar(3)
                     aa(2)= WPar(2)/WPar(3)
                     aa(3)= WPar(4)/WPar(3)
                     bbb  = 1.0
                  endif
               case(3)
                  aa(1)= WPar(2)
                  aa(2)= WPar(3)
                  bbb  = WPar(1)
                  aa(3)= WPar(4)
	            if(idivide.eq.0) then
                     aa(1)= WPar(2)/WPar(1)
                     aa(2)= WPar(3)/WPar(1)
                     aa(3)= WPar(4)/WPar(1)
                     bbb  = 1.0
                  endif
               case(4)
                  aa(1)= WPar(1)
                  aa(2)= WPar(2)
                  aa(3)= WPar(3)
                  bbb  = WPar(4)
	            if(idivide.eq.0) then
                     aa(1)= WPar(1)/WPar(4)
                     aa(2)= WPar(2)/WPar(4)
                     aa(3)= WPar(3)/WPar(4)
                     bbb  = 1.0
                  endif
            end select
c---------------------------------------
      end select
      return
      end
c
code for wderiv
      subroutine wderivNEW(ky,icalc,itype,aa,bbb,
     1 ii,der,d2w)
c--calcola derivate
c
      USE General
      USE Riflessi
      USE LsqModule
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      dimension der(1000,3),aa(3)
c
      fobs=work1(ky)
      fcal=work2(ky)
      sigmaf=worko(ky)
      st=sqrt(rhov(ky))
      diff=fobs-fcal
      diff2=diff*diff
      fobs2=fobs*fobs
      fodif2=diff2*fobs2
      fodif =diff2*fobs
      stdif =diff2*st
      select case (nWeight)
c--criterio di pesaggio 2
         case (2,11)
            select case (itype)
               case(1)
                  w1=aa(1)+bbb*fobs+aa(2)*fobs2           
               case(2)
                  w1=aa(1)+aa(2)*fobs+bbb*fobs2           
               case(3)
                  w1=bbb+aa(1)*fobs+aa(2)*fobs2           
            end select
	      if(nWeight.eq.11) then
	         x=st**WPar(4)
	         w11=w1
	         w1=w1/x
	      endif
	      d2w=diff2/w1
	      if(icalc.gt.0) then
	         if(nWeight.eq.11) then
	            w2=x/(w11*w11)
	         else
	            w2=1./(w1*w1)
	         endif
               select case (itype)
                  case(1)
                     der(ii,1)=der(ii,1)-diff2 *w2
	               der(ii,2)=der(ii,2)-fodif2*w2
                  case(2)
	               der(ii,1)=der(ii,1)-diff2 *w2
	               der(ii,2)=der(ii,2)-fodif *w2
                  case(3)
	               der(ii,1)=der(ii,1)-fodif *w2
	               der(ii,2)=der(ii,2)-fodif2*w2
               end select
            endif   
c--criterio di pesaggio 12
         case (12)
	      sigma2=sigmaf*sigmaf
            select case (itype)
               case(1)
	            w1=aa(1)*sigma2+bbb*fobs+aa(2)*fobs2
              case(2)
	            w1=aa(1)*sigma2+aa(2)*fobs+bbb*fobs2
               case(3)
	            w1=bbb*sigma2+aa(1)*fobs+aa(2)*fobs2
            end select
	      d2w=diff2/w1
	      if(icalc.gt.0) then
	         w2=1./(w1*w1)
               select case (itype)
                  case(1)
	               der(ii,1)=der(ii,1)-diff2 *w2*sigma2
	               der(ii,2)=der(ii,2)-fodif2*w2
                  case(2)
	               der(ii,1)=der(ii,1)-diff2 *w2*sigma2
	               der(ii,2)=der(ii,2)-fodif *w2
                  case(3)
	               der(ii,1)=der(ii,1)-fodif *w2
	               der(ii,2)=der(ii,2)-fodif2*w2
               end select
            endif
c--criterio di pesaggio 13
         case (13)
            select case (itype)
               case(1)
	            w1=aa(1)+bbb*fobs+aa(2)*fobs2+aa(3)*st
               case(2)
	            w1=aa(1)+aa(2)*fobs+bbb*fobs2+aa(3)*st
               case(3)
	            w1=bbb+aa(1)*fobs+aa(2)*fobs2+aa(3)*st
               case(4)
	            w1=aa(1)+aa(2)*fobs+aa(3)*fobs2+bbb*st
            end select
	      d2w=diff2/w1
	      if(icalc.gt.0) then
	         w2=1./(w1*w1)
               select case (itype)
                  case(1)
	               der(ii,1)=der(ii,1)-diff2 *w2
	               der(ii,2)=der(ii,2)-fodif2*w2
	               der(ii,3)=der(ii,3)-stdif *w2
                  case(2)
	               der(ii,1)=der(ii,1)-diff2 *w2
	               der(ii,2)=der(ii,2)-fodif *w2
	               der(ii,3)=der(ii,3)-stdif *w2
                  case(3)
	               der(ii,1)=der(ii,1)-fodif *w2
	               der(ii,2)=der(ii,2)-fodif2*w2
	               der(ii,3)=der(ii,3)-stdif *w2
                  case(4)
	               der(ii,1)=der(ii,1)-diff2 *w2
	               der(ii,2)=der(ii,2)-fodif *w2
	               der(ii,3)=der(ii,3)-fodif2*w2
               end select
            endif
c--
      end select
      return
      end
!---------------------------------------------------------------------
!--Routine della fourier classica
!---------------------------------------------------------------------
      subroutine startfourier(ier,kFinalState)
      USE General
      USE Symmetry, only : nSpaceG
      USE Atomi
      USE Molcom
      USE PhaseModule
      USE LsqModule
      USE xfourx
      USE ilmviewmod, only: jav_set_modify
!
      integer :: kFinalState(10), iAction, ifIdro, ridisegna
      real BTotInv(3,3), xyInv1(3), xyInv2(3), trasla(3), xyz1Cryst(3)
!
!--   kFinalState(4) ==  1  draw the map using Jav
!
!--   kFinalState(5) == -1  Compute Fourier in the unit cell
!--   kFinalState(5) ==  1  Compute Fourier in a cube : xyzCubo
!--   kFinalState(5) ==  2  Compute Fourier in a cube : xyzCubo (Hydrogens)
!
      iCoef        = kFinalState(1)      ! modulo LsqModule
      nPeaksF      = kFinalState(2)
      levelFourier = kFinalState(3)
      javFourier   = kFinalState(4)
      KindFourier  = kFinalState(5)
      javGrid      = float(kFinalState(6)) / 100.0
      ifIdro       = kFinalState(7)
!
      InfoOK(5) = 1
!
      iAction = 1
      call ClessidraOnOff(iAction)
      call jav_set_modify(3)           !!mr 13/01/2016
!
      ifCubo = -1
      k = ridisegna()
      call zflush
!
      if (KindFourier == 1) then 
          call inv3r(BTot, determinante, BTotInv)
!
          do i=1, 3
             xyInv1(i) = 0
             xyInv2(i) = 0
             do j=1, 3
                xyInv1(i) = xyInv1(i) + BTotInv(i, j) * xyzCubo(j)   ! baricentro del cubo
                xyInv2(i) = xyInv2(i) + BTotInv(i, j) * xyz(j,1)     ! atomo #1
             enddo
          enddo
!
          call MoltMatVec(rmi, xyInv1, xyzCuboCryst)
          call MoltMatVec(rmi, xyInv2, xyz1Cryst)
          trasla(:) = xyzs(:,1) - xyz1Cryst(:)
          xyzCuboCryst(:) = xyzCuboCryst(:) + trasla(:)
!-- TEST
*         xyzCuboCryst(:) = 0.5
!-- TEST
      elseif (KindFourier == 2) then 
          NordCubo = kptr(1)   
          xyzCuboCryst(1:3) = xyzs(1:3,NordCubo)
      endif
!
      ier = 0
      call AllocaRiflessi(1)
      ifFromGraphic = 1
      call InitFour(ifFromGraphic,ier)    ! routine in four2006.f
      call AllocaMappa(1)
!
      jComplete = 1
      call ReGroup(jComplete)
!      
!--dalla grafica il codice 'Quale Fourier':
!  KindFourier = -1  Calcolo della Fourier nell'u.a. della cella
!              = 1 e 2  Calcolo della Fourier in una porzione dello spazio 
!
      call FOURlink(ier, ifIdro)
!
!      call AllocaRiflessi(2)
      call AllocaMappa(2)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine FOURlink(ier, ifIdro)
!--caolcolo mappa di d.e. da grafica
!-- iCoef  = 1  Observed
!--        = 2  2*Fo - Fc
!--        = 3  Difference
!-- nPeaksF= Number of peaks to search
!-- iWeiF  = 1  Weighted
!--        = 0  UnWeighted
!
      USE General
      USE Atomi
      USE Molcom
      USE Riflessi
      USE PhaseModule
      USE LsqModule
      USE xfourx
!corr
      USE sinterface
      USE variables
      USE atom_type_util
      USE fouriermap
      USE connect_mod
      USE unit_cell
      type(atom_type), allocatable, dimension(:) :: atmold
      type(cell_type) :: cellt
!corr
!      
      iWeiF = 1
      errem = errem / 10000.0
!
      if (no(1).eq.1) then
          jlig = 1
      else
          jlig = -99
      endif
!corr
!
!     Save current model for compare in labelx
      call xyzs_to_atom(atm)
      call copy_atoms(atmold,atm)
      cellt = set_cell_type(cell)
      call iconn_to_legm(iconn,lconn,atm,cellt%get_g())
!corr
!      
!--salvo in "old" la lista degli atomi      
      NatsOld = nats
      do i=1,NatsOld
         do j=1,5
            xyzo(j,i) = xyzs(j,i)
         enddo
         nzo(i) = nz(i)
         nz(i) = iabs(nz(i)) / nzConst
!--al numero indicato dell'utente si sommano gli atomi presenti       
         nPeaksF = nPeaksF + 1           
         aLabOld(i) = aLab(i)
         qvar(i)   = bfac(i)
         kblock(i) = serial(i)
      enddo
!--fine salvataggio atomi esistenti
!
      if (nPeaksF > MaxAtoms) then
          nPeaksF = MaxAtoms
      endif
!--se difference o se definito un cubo per la Fourier  
!--al programma si dice di cercare solo quelli indicati dall'utente     
      if (iCoef.eq.3.or.KindFourier.eq.1) then
          nPeaksToFind = nPeaksF - nats   !--
      else      
          nPeaksToFind = nPeaksF 
      endif
!
      if(KindFourier == -1) then
         call RoutineHeader('Fourier')
      else
         call RoutineHeader('User Defined Fourier')
      endif
!
      ifFour = nats
      npc = nPeaksF
      call LSQfour(ier)
!
      if(ier /= 0) return
!modhh
!     stop
!modhh
!     if(jscreen==0) call InitMolPlo
!corr
          !call labelxNew(ier, ifIdro)
      nz(:) = 0 ! force new peaks to nz = 0
      call labelx(atmold,cellt,spacegr,nPeaksToFind,ier)
!corr
!
      return
      end
! ----------------------------------------------------------------------
      subroutine LSQfour(ier)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Molcom
      USE PhaseModule
      USE LsqModule
      USE Mappa
      USE MapTest
      USE Limits
      USE xfourx
!modh
      integer, allocatable ::  iphazsav(:)
!
      ier = 0
!-------------------------------------------------------------
!--check if list 68 (limiti) non esiste
!-------------------------------------------------------------
      if(InfoOK(68).eq.0) then      
         CodeLimit(:) = -1
         VetClassiParita(:)=-1 
         NumOmit=0 
         call CalcolaLimitData(1)
         DataMinLim =  TempMinLim 
         DataMaxLim =  TempMaxLim
         call CalcolaLimitData(3)
         AgreMinLim =  TempMinLim 
         AgreMaxLim =  TempMaxLim
         infoOK(68)=1
       endif
!----------------------------------------------------
c--riempie vettori dinamici khl per MNQD
!----------------------------------------------------
c--ksubr= 11 carico tutti i  riflessi
      ksubr=11
      ier=0
      call LeggiRiflessi(ier,ksubr)
      iCutoff=int(cutoff)
      call ChopRiflessiNew(iCutoff)
c--ksubr= 10 carico solo gli osservati (escludo non osservati ed esclusi da agreement)
      ksubr=10
      ier=0
      call LeggiRiflessi(ier,ksubr)
      numbLSQ   = NreflKsubr
      fcoef(:)=fovet(:)
c--fine allocate vector per riflessi
      call CalcolaLimitData(2)
      UserMinLim =  TempMinLim 
      UserMaxLim =  TempMaxLim
!---------------------------------------------------------
!
      erreo=999999.9
      erre =1.0
      krecy=0
      if (iCoef.ne.3) then
         write(Msg,100)
      else
         write(Msg,108)
      end if
  100 format('Computing Fourier. Please wait...')
  108 format('Computing Fo-Fc Fourier. Peak heights will be on relative'
     *       ,' scale. Please wait...')
! --
!     call scrper('Compute structure factors',0,-1)
!
      oscale = 1.0
      factr= 1.0/3.0
      nsec  = 1
      lproj = 0
      mode  = 0
      krecy = 0
      iref  = 0
!      numb = nreflDim
      numb = nrefl
      ifBreak = 0
      aperc(1) = nPeaksToFind 
      do i=1,numb
         wt(i) = 1.0
      enddo
      BTotSav = BTot(1,1)
!modh - vecchia versione
*     go to 53
      isir=0
      if(isir==1) then    ! nuovi sviluppi dedm etc.
!--metto in scala le osservazioni
         scf=sqrt(sc)
         do i=1,numb
           fovet(i)=fovet(i)*scf
           sigmav(i)=sigmav(i)*scf
         enddo
         call sftryyyc(iref,mode,numb,scalan,ifBreak,iCoef)
         rflsq = erre * 100.0
         call UpdateReflInfo
         do i=1,numb
           if(fovet(i)>0.0) wt(i)=1.0
         enddo
         call scrper(' ',0,-1)
         call scrper('Compute structure factors',0,-1)
         level=0
         ifExamin=1
         call to_coord_sir(1,nrefl)
c
c--metto le fasi osservate nella stessa origine di quelle pubblicate
c  (altrimenti il riferimento della Fqvera  non lo posso calcolare)
         call Trasla_Origine(nrefl)
         allocate (iphazsav(nrefl), stat=ierr)
         iphazsav(1:nrefl)=iphaz(1:nrefl)
c--richiamo qui le routines che migliorano la Fourier differenza
         ifDEDM=2
         if (knw > 0) then
             call AllocaMapTest(1)
             fcoef(:)=fovet(:)*wt(:)
             call MakeMap(fcoef,iphaz,nrefl,0,xmap,FORTH,BACK)
             fcoef(:)=fovet(:)
             FORTH=0
             call MakeMap(fcoef,ipub,nrefl,0,xmapT,FORTH,BACK)
             call mapcorr(xmap,xmapT,corr)
             write(6,*) 'CC =', corr
             xmodel = xmap
         endif
         call TestFq(ifDEDM)
         call Search99(mode,ier,numb)
c--metto le fasi di partenza, non quelle della Fourier Differenza
c  per poter fare la to_coord
         iphaz(1:nrefl)=iphazsav(1:nrefl)
         deallocate (iphazsav, stat=ierr)
         if (knw > 0)  call AllocaMapTest(2)
!
!--fine nuovi sviluppi dedm etc.
      else     ! isir=0   = caos
!
         if(KindFourier == -1) then
!---------------------------------------------------------
!--utilizzo della fourier classica (tipo caos)
!---------------------------------------------------------
            jcod  = -1
            ixx   = 1
            iautoF = 0
            iprix = -2
            ifCheck = 1
            scalan=-99
            call CaosFourNew(jhost,ier,jcod,ixx,iautoF,
     *         iprix,numbLSQ,ifCheck,iCoef,scalan)
         else
!---------------------------------------------------------
!--calcolo della fourier in porzioni di spazio definite dall'utente 
!  KindFourier = 1  CUBO
!  KindFourier = 2  SINGLE (per cercare H)        
!---------------------------------------------------------
            call Init_Rho
            if (nats == 0) then
                natsOld = nats    ! 15/02/2011 siamo sicuri che serva ? nats=0
                do i=1, natsOld
                   xyzo(1:5,i) = xyzs(1:5,i)
                   nzo(i) = nz(i)
                enddo
                return
            endif
!
*gl*        ier = 1
         endif
      endif
!
!modh
       if (iprin > 2) then
          write(lo,*) '----lista mia',nPeaksToFind,nats,levelFourier
          do j=1,nats
             write(lo,'(i5,3f10.4,f10.0,f10.3)') j, (xyzs(n,j),n=1,5)
          enddo
!modh
          ifExaminSav = ifExamin
          ifExamin = 1
          call to_coord_sir(1,nrefl)
          ifExamin = ifExaminSav
          write(lo,*) '---------------------'
       endif
!53   continue
!modh - vecchia versione
!
!modh - versione ricerca idrogeni inizio 2009 (Dedi)
      go to 54   ! per ripristinare vecchia versione  (commentare goto 53)
c     isir=0  !caos
      isir=1  !sir (goto 53 in dedm.f solo sir ma pesi dedm) + dedm
      if(isir==1) then 
!--metto in scala le osservazioni
*        scf=sqrt(sc)
*        do i=1,numb
*          fovet(i)=fovet(i)*scf    ! scf per leggi riflessi con ksubr = 10
*          sigmav(i)=sigmav(i)*scf
*        enddo
*        call sftryyyc(iref,mode,numb,scalan,ifBreak,iCoef)   ! sostituire con runlsq solo SFC per bfac aniso
*        rflsq = erre * 100.0

!
!-- calcolo fattori di struttura con bfac aniso (Caos) IsoAniso = 1
!
      dm_fou  = dm !salvo il valore di dm per il pksrch della Fourier 
      istampa = -1
!     write(6,*) 'SFC calculation (runlsq)'
      if (numbGen == 0) then
          Num_Riflessi = 0
      else
          Num_Riflessi = nreflDim - numbGen
      endif
      newpWei = 2
      LsqAct  = 1    ! calcolo fattori e calcola nuova scala
      jcyc = 0
      fdum = 1.0
          call RunMndq(ier,LsqAct,jcyc,fdum,istampa,
     *                     Num_Riflessi, xyzs4,newpWei) ! nuovo MNQD
      if (knw == 1) then
          write(6,*) 'DOPO RunMnqd - solo sfc', rflsq
      endif
      dm = dm_fou   !ripristino il valore di dm dopo LSQ per il pksrch della Fourier
!--metto in scala le osservazioni
*        scf=sqrt(sc)
*        do i=1,numb
*          fovet(i)=fovet(i)*scf    ! scf per leggi riflessi con ksubr = 10
*          sigmav(i)=sigmav(i)*scf
*        enddo
         ksubr = 4
         call LeggiRiflessi(ier,ksubr)
!
!        call UpdateReflInfo
         do i=1,numb
           if(fovet(i)>0.0) wt(i)=1.0
         enddo
        call scrper(' ',0,-1)
        call scrper('Compute structure factors',0,-1)
        level=0
        ifExamin=1
          call to_coord_sir(1,nrefl)
c
c--metto le fasi osservate nella stessa origine di quelle pubblicate
c  (altrimenti il riferimento della Fqvera  non lo posso calcolare)
        call Trasla_Origine(nrefl)
        allocate (iphazsav(nrefl), stat=ierr)
        iphazsav(1:nrefl)=iphaz(1:nrefl)
c--richiamo qui le routines che migliorano la Fourier differenza
        ifDEDM=2
        if (knw > 0) then
          call AllocaMapTest(1)
          fcoef(:)=fovet(:)*wt(:)
          call MakeMap(fcoef,iphaz,nrefl,0,xmap,FORTH,BACK)
          fcoef(:)=fovet(:)
          FORTH=0
          call MakeMap(fcoef,ipub,nrefl,0,xmapT,FORTH,BACK)
          call mapcorr(xmap,xmapT,corr)
          write(6,*) 'CC =', corr
          xmodel = xmap
        endif
        call TestFq(ifDEDM)  !DEDM
        call Search99(mode,ier,numb)
c--metto le fasi di partenza, non quelle della Fourier Differenza
c  per poter fare la to_coord
        iphaz(1:nrefl)=iphazsav(1:nrefl)
        deallocate (iphazsav, stat=ierr)
        if (knw > 0)  call AllocaMapTest(2)
!
      else   ! tipo caos
!modh
        jcod  = -1
        ixx   = 1
        iautoF = 0
        iprix = -2
        ifCheck = 1
        scalan=-99
            call CaosFourNew(jhost,ier,jcod,ixx,iautoF,
     *      iprix,numbLSQ,ifCheck,iCoef,scalan)
      endif
!
!modh
!     if (iprin.gt.2) then
          write(6,*) '--------lista mia',nPeaksToFind,nats,levelFourier
          do j=1,nats
            write(lo,'(i5,3f10.4,f10.0,f10.3)') j, (xyzs(n,j),n=1,5)
            alab(j) = 'Q'
c ???          write(alab(j)(1:8),''('Q',i7)'') j
c ???          call NoBlanks(alab(j),k1)
          enddo
!modh
          call to_coord_sir(1,nrefl)
          write(6,*) '---------------------'
!     endif
!modh - versione ricerca idrogeni inizio 2009
!
 54   continue
!
      BTot(1,1) = BTotSav
!--
      return
      end
!-------------------------------------------------------------------
      MODULE Restw
!
            real, allocatable    :: dfr(:,:),qvr(:,:)
            integer, allocatable :: kbblock(:)
!
      END MODULE Restw
*     common /restw/ dfr(3,500),qvr(3,500),kbblock(500)
!-------------------------------------------------------------------
      subroutine AllocaRestw(iAction)
      USE Restw
      Use Atomi, only : MaxAtoms
      USE General
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
      dimension ierv(3)
!
      if (iAction == 1) then
          if (.not.Allocated(dfr))
     *        Allocate(dfr(1:3,1:MaxAtoms), stat = ierv(1))
          if (.not.Allocated(qvr))
     *        Allocate(qvr(1:3,1:MaxAtoms), stat = ierv(2))
          if (.not.Allocated(kbblock))
     *        Allocate(kbblock(1:MaxAtoms), stat = ierv(3))
          ierr = sum(ierv(:))
          if (ierr.ne.0) then
              write(*,*) 'Restw Allocation Error'
              call cstop(' ')
          endif
          dfr(1:3,1:MaxAtoms) = 0.0
          qvr(1:3,1:MaxAtoms) = 0.0
          kbblock(1:MaxAtoms) = 0
      else
          if (Allocated(dfr)) then
              Deallocate (dfr, qvr, kbblock, stat=ierr)
          endif
          if (ierr.ne.0) then
              write(*,*) 'Restw DeAllocation Error'
              call cstop(' ')
          endif
      endif
!
      return
      end
!----------------------------------------------------------------------------
      subroutine CaosFourNew(jhost1,ier,jcod,izz,iauto,iprix,
     *                NRFour,ifCheck,iCoef,scalaSir)
c--main routine for four
!-- ifCheck = 0   no check: all NRFour reflections will be used
!-- ifCheck = 1   check   : check reflections against cutoff
c
c  jcod -1  prepara_calcoli (non legge direttive)
c	   0  read directives  SIR
c	   1  read directives CAOS
c  izz = 0 Patterson
c	   1 Fourier
c--iCoef = 1 Fo
c	   2 2Fo-Fc
c	   3 Fo-Fc
c
      USE General
      USE Riflessi
      USE xfourx
c--
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2		   jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
!
      call AllocaRestw(1)
!
      isogl = levelFourier
      iprint=iprix
      nPToFind=nPeaksToFind
      call jfodrNew(jhost1,ier,jcod,izz,iauto,ifCheck,iCoef,scalaSir)
      if(ier.ne.0) return
      iunchg=ju
      ier = kfourNew(izz,NRFour,ifCheck)
!
      call AllocaRestw(2)
!
      return
      end
!----------------------------------------------------------------------------
code for jfodrNew
      subroutine jfodrNew
     * (jhost1,ier,jcod,ixx,iauto,ifCheck,iCoef,scalaSir)
c--read directives for fourier map
c  ixx = 0 Patterson
c	   1 Fourier
c
c--itipo = 1 Patterson observed
c	   2 Patterson calculated
c	   3 Fourier observed
c	   4 Fourier calculated
c	   5 Fourier difference
c	   7 Fourier difference 2fo-fc
c
c--read fourier directives
c  jcod -1  prepara_calcoli (non legge direttive)
c	   0  read directives  SIR
c	   1  read directives CAOS
c
      USE General
      USE Symmetry
      USE Riflessi
      USE Restw
      USE Atomi
      USE xfourx
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
!
*gl*  common/inpcl/ntype,ttype(20,5),nproj,nbond,dmaxi,radnew(8)
*gl*  dimension ltype(20,5)
*gl*  equivalence(ttype,ltype)
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
c--
      dimension cfom(300),fom(9),iphi(800)
      character*4 itarg(24),itarg2(3),itarg3,nnameh
c--
      ier=0
      iprint=0               
!      iprint=2                ! print mappa e localizzazione picchi
!--set default 
      iauto=0     !--set flag no auto
      ja=15
      ju=0
*gl*  ntype=0
      nbond=1
      nproj=2
      npeakd=0
      iw=0
      iref=0
      interpo=1
      jq=-1              !  codice localizzazione (-1 = localizza)
      if (ixx.eq.0)then
	   itipo=1
	   isearc=0
      else
	   itipo=3
	   isearc=1
	   if(ifCheck.eq.1) then
	      if(iCoef.eq.2) itipo=7
	      if(iCoef.eq.3) itipo=5
	   endif
      endif
!--define some variables      
      rvol=1.0/volume
      scr=10.0                      ! RS la densita' viene moltiplicata per 10.0
!      fn = nsymTot
!--calculate the F(000)
      f000=0.0                           
      do j = 1,nk
          f000 = f000 + no(j)*nw(j)  !no. atomi in cella*numero atomico
      enddo
      scale=1.0
      if (ixx.eq.0) then
!--patterson  
          icMappa=1    ! settato centro
          if(isogl.eq.0) isogl=50    ! level per la localizzazione
c--calculate the number of atoms in the asymmetric unit
          fato=1.0
          fatom=0.0
          do j = 1,nk
             if (no(j).gt.20) then
                 fato=0.
                 fatom=fatom+nw(j)
             endif
          enddo
c          fatom=fatom/fn
c          nPToFind=fatom*(n2*(ic+1)+fatom+1.)+1
          if(fatom.lt.1.) fatom=20
      else
!--fourier      
          icMappa=icent    
          f000=0.5*f000                !la mappa iniziale viene posta = f000 
          if (scalaSir > 0.0) then
              scale = scalaSir
          else
              if(FcScale.gt.0.0) then
                 scale=1.0/FcScale
              else
	           scale = sqrt(sc)
	        endif
          endif
!--calcola il numero di atomi H          
          inh=0    
          do i=1,nats
             kbblock(i)=1
	       if (nzTot(i).eq.1)inh=inh+1
          enddo
          if( nPToFind.eq.0) nPToFind=nats         !-- ??    
      end if
c-----------------------------------------------------------------------------      
      if(itipo.eq.5) f000=0.0
      if(iprint.ge.-2) then
         write(ncwu,1000)
1000     format(/,' Fourier synthesis map (vers. 0710)')
         select case (itipo)
           case (1)
              write(ncwu,1011)
1011          format(' Observed patterson')
           case (2)
              write(ncwu,1012)
1012          format(' Calculated patterson')
           case (3)
              write(ncwu,1013)
1013          format(' Observed fourier')
              write(ncwu,9026) rflsq
9026          format(' R(F)% of the s.f.c........ ',f7.2)
           case (4)
              write(ncwu,1014)
1014          format(' Calculated fourier')
              write(ncwu,9026) rflsq
           case (5)
              write(ncwu,1015)
1015          format(' Difference fourier')
              write(ncwu,9026) rflsq
           case (7)
              write(ncwu,1017)
1017          format(' 2*F(obs)-F(calc) Observed fourier')
              write(ncwu,9026) rflsq
         end select   
         if(ixx.eq.1) write(ncwu,1335) nats
1335     format(' No. of atoms in model..... ',i7)
         write(ncwu,1330) scr
1330     format(' Rho scale factor.......... ',f7.1)
         if(jq.eq.-1) then
            write(ncwu,1320)
1320        format(' Peak searching requested  ')
            write(ncwu,1321)interpo
1321        format(' Method of peak interpolation (',i1,')')
            write(ncwu,1350) nPToFind
1350        format(' No of peaks to be searched ',i7)
         end if
      endif
      return                                                            
      end
c
code for kfourNew
      function kfourNew(izz,NRFour,ifCheck)
c--new routine for fourier map
c  izz = 0 Patterson
c	   1 Fourier
c
      USE General
      USE Deprecato
      USE Riflessi
      USE Limits
      USE Symmetry
      USE xfourx
!
      common/xdisu/ncdfu ,ndfle,irecx,ldaf,nbytes
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      character*60  jscr,iscr,kscr,lscr,iasun1,iform,imsg,jasun,
     2 kkscr,llscr,psfle1
      common/xscru/ jscr,iscr,kscr,lscr,iasun1,iform,imsg,jasun,
     2 kkscr,llscr,psfle1
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
c--
      real, allocatable :: Map_Area(:,:,:)
      real, allocatable :: Map_Area_New(:,:,:)
      real, allocatable :: Map_Part1(:)
      real, allocatable :: Map_Part2(:)
      real, allocatable :: Map_Part3(:,:)
      real, allocatable :: Map_PartN(:)
      real, allocatable :: Map_Testo_jm(:)
      real, allocatable :: Map_Testo_jn(:)
      real, allocatable :: Map_Testo_jp(:)
c--
      dimension cj(4),bj(4),ihkl(3,4),ee(4),jfase(4),i1(3)
      dimension  idj(26)
      character*1 ixy(3),ista
      data ixy /'x','y','z'/, ista/'*'/  
c--
      kfourNew=0
      rhodiff(1)=-9999.0
      rhodiff(2)=9999.
      rhodiff(3)=0.0
      xpoint=0
      pi2=pi/2.0 
!      
!--definisco indici oriz, vert, sez      
      if(itipo.le.2) then
         ilento=iorizpat
         imedium=ivertpat
      else
         ilento=iorizfou
         imedium=ivertfou
      endif
      ivelo=6-ilento-imedium
!      
!--definisco indici massimi      
      do i=1,3
         j=UserMinLim%HKL(i)
         k=UserMaxLim%HKL(i)
         j=iabs(j)
         k=iabs(k)               
         itemp(i)=max0(j,k)                          
      enddo  
      if(jsys.gt.3) then
         itemp(1)=itemp(1)+itemp(2)
         itemp(2)=itemp(1)
      endif
c
c--ilento   =ioriz
c  imedium =ivert
c  ivelo  =isez
c                                                                       
      ihsmx=itemp(ivelo)+1      
      ihvmx=itemp(imedium)+1
      ihomx=itemp(ilento)+1
!      
      ihvmx2=2*ihvmx
      ihomx4=4*ihomx
!      
c--set some values
      il1=ilento-1
      iv1=ivelo-1
      im1=imedium-1
c---- jq= 2               !  codice localizzazione ( 2 = localizza)
c---- jq=-1               !  codice localizzazione (-1 = localizza)
      nq=jq               ! pongo nq uguale al codice se localizzare
c
c--calculate the number of points of the grid
      if(itipo.le.2) then
         xyzMappa(:,:)=xyzpat(:,:)
         ncondMappa(:,:)=ncondpat(:,:)
         xcondMappa(:,:,:,:)=xcondpat(:,:,:,:)
      else
         xyzMappa(:,:)=xyzfou(:,:)
         ncondMappa(:,:)=ncondfou(:,:)
         xcondMappa(:,:,:,:)=xcondfou(:,:,:,:)
      endif
      jp= int((xyzMappa(ivelo,2)-xyzMappa(ivelo,1))/
     *                                 xyzMappa(ivelo,3)+0.05) + 1
      jp1=jp
      jm= int((xyzMappa(ilento,2)-xyzMappa(ilento,1))/
     *                                 xyzMappa(ilento,3)+0.05) + 1
      jm1=jm
      jn= int((xyzMappa(imedium,2)-xyzMappa(imedium,1))/
     *                                 xyzMappa(imedium,3)+0.05) + 1
      jn1=jn
c---- jq=-1               !  codice localizzazione (-1 = localizza)
      if(jq.le.0) then
         jm=jm+2
         jn=jn+2
         jp=jp+2
         do i=1,3
            xyzMappa(i,1)=xyzMappa(i,1)-xyzMappa(i,3)
            xyzMappa(i,2)=xyzMappa(i,2)+xyzMappa(i,3)
         enddo
      endif
      Map_Grid(ivelo)  =jp
      Map_Grid(imedium)=jn
      Map_Grid(ilento) =jm
!
      do i=1, 3
         limitiJav(1,i) = xyzMappa(i,1)
         limitiJav(2,i) = xyzMappa(i,2)
      enddo
!
c--print limiti e passi della mappa
c      if(iprint.ge.2) then
         write(ncwu,1100)
1100     format( /,' Map limits   :     ',7h  min  ,8x,5h  max,11x,
     1              4hstep,9x,'division')
         do i=1,3
            write(ncwu,1310) ixy(i),(xyzMappa(i,j),j=1,4)
1310        format(9x,a1,4f15.0)
         enddo
         write(ncwu,1110)
1110     format(/,'Number of grid points:')
         do i=1,3
           write(ncwu,'(9x,a1,1h),i5)')ixy(i),Map_Grid(i)
         enddo
         write(ncwu,'(1h )')
c      endif
!
!-- allocate work area for reflections (xstore)
!
      ilen=jm*jn
      lPart1=ihomx*ihvmx
      lPart2=ihvmx2*jm
      md107=ihomx4*ihvmx+4
!      
      IF (.NOT. ALLOCATED(Map_Area))
     *	ALLOCATE (Map_Area(1:jm,1:jn,1:jp), stat = ierr)
       if (ierr.ne.0) then
       write(ncwu,*) 'Map_Area Allocation error'
       call cstop(' ')
      endif
      IF (.NOT. ALLOCATED(Map_Part1))
     *	ALLOCATE (Map_Part1(1:lPart1), stat = ierr)
       if (ierr.ne.0) then
       write(ncwu,*) 'Map_Part1 Allocation error'
       call cstop(' ')
      endif
      IF (.NOT. ALLOCATED(Map_Part2))
     *	ALLOCATE (Map_Part2(1:lPart2), stat = ierr)
       if (ierr.ne.0) then
       write(ncwu,*) 'Map_Part2 Allocation error'
       call cstop(' ')
      endif
      IF (.NOT. ALLOCATED(Map_Part3))
     *	ALLOCATE (Map_Part3(1: md107,1:jp), stat = ierr)
       if (ierr.ne.0) then
       write(ncwu,*) 'Map_Part3 Allocation error'
       call cstop(' ')
      endif
      IF (.NOT. ALLOCATED(Map_PartN))
     *	ALLOCATE (Map_PartN(1:ilen), stat = ierr)
       if (ierr.ne.0) then
       write(ncwu,*) 'Map_Part3 Allocation error'
       call cstop(' ')
      endif
      IF (.NOT. ALLOCATED(Map_Testo_jm))
     *	ALLOCATE (Map_Testo_jm(1:jm), stat = ierr)
       if (ierr.ne.0) then
       write(ncwu,*) 'Map_Testo Allocation error'
       call cstop(' ')
      endif
      IF (.NOT. ALLOCATED(Map_Testo_jn))
     *	ALLOCATE (Map_Testo_jn(1:jn), stat = ierr)
       if (ierr.ne.0) then
       write(ncwu,*) 'Map_Testo Allocation error'
       call cstop(' ')
      endif
      IF (.NOT. ALLOCATED(Map_Testo_jp))
     *	ALLOCATE (Map_Testo_jp(1:jp), stat = ierr)
       if (ierr.ne.0) then
       write(ncwu,*) 'Map_Testo Allocation error'
       call cstop(' ')
      endif
!
!--define some variable
      jd=0       ! controllo prima lettura dei riflessi       
      irig=26
      r=0.0
      d=1.0/360.0
      nrif=0
      nrif1=0
      bj(i:)=0.0
      iminr=9999
      imaxr=-9999
      npag=jm1/irig
      if(npag*irig.ne.jm1) npag=npag+1
!--testi      
      Map_Testo_jm(1)=xyzMappa(ilento,1)
!---- jq=-1               !  codice localizzazione (-1 = localizza)
      if(jq.eq.-1) Map_Testo_jm(1)= Map_Testo_jm(1)+xyzMappa(ilento,3)
      do i=2,jm
          Map_Testo_jm(i)= Map_Testo_jm(i-1)+xyzMappa(ilento,3)
      enddo
      Map_Testo_jn(1)=xyzMappa(imedium,1)
!---- jq=-1               !  codice localizzazione (-1 = localizza)
      if(jq.eq.-1) Map_Testo_jn(1)= Map_Testo_jn(1)+xyzMappa(imedium,3)
      do i=2,jn
          Map_Testo_jn(i)= Map_Testo_jn(i-1)+xyzMappa(imedium,3)
      enddo
      Map_Testo_jp(1)=xyzMappa(ivelo,1)
!---- jq=-1               !  codice localizzazione (-1 = localizza)
!      if(jq.eq.-1) Map_Testo_jp(1)= Map_Testo_jp(1)+xyzMappa(ivelo,3)
      do i=2,jp
          Map_Testo_jp(i)= Map_Testo_jp(i-1)+xyzMappa(ivelo,3)
      enddo
c--end testi
      do i=1,3
         div=xyzMappa(i,4)
c         if(div.le.0.0) goto 9100
         do j=1,3
            xyzMappa(i,j)=xyzMappa(i,j)/div
         enddo
      enddo
c
c--set the address for the areas to be used
c--indicies area
      Map_Part1(:)=0.0     ! lji <---> ljz=lji+ihomx*ihvmx
c--second sum area
      Map_Part2(:)=0.0    ! ljz <---> lje=ljz+ihvmx2*jm
c--third sum area (map)
c---- jq=-1               !  codice localizzazione (-1 = localizza)
      ljg=1
      ljg1=1
      if(jq.eq.-1) ljg1=ljg1+jm+1
      Map_PartN(:)=0.0    ! lje( or ljg) <---> ljf=lje+ilen
!      
c-----------------------------------------------------      
c--start for the group of sections
      nrec=1
!--azzera sezioni      
      Map_Part3(:,:)=0.0   ! l107 <---> l107+ihomx4*ihvmx+4 , 1 <---> jp
c
c---------------------------------------------------------------------
c--loop on the sets of reflections
c---------------------------------------------------------------------
      do kj=1,NRFour
c      write(ncwu,'(a,i10,3f10.2)')'kj,fovet(kj),sigmav(kj),cutoff',
c     1 kj,fovet(kj),sigmav(kj),cutoff
c--check if the reflections has to be used
!-- ifCheck = 0   no check: all NRFour reflections will be used
!-- ifCheck = 1   check   : check reflections against cutoff
c        if(ifCheck.eq.0.or.fovet(kj).ge.sigmav(kj)*cutoff)then
         if(ifCheck.eq.1.and.fovet(kj).lt.sigmav(kj)*cutoff) cycle
         if(ifCheck.eq.0) f=fcoef(kj)
         if(ifCheck.eq.1) f=fovet(kj)*scale
c--jump on fourier type
c      go to (1210,1220,1230,1240,1230,1300,1230),itipo
         select case (itipo)
           case (1)
c--observed patterson
             a=f*f
             t=a
           case (2)
c--calculated patterson
             a=fcvet(kj)*fcvet(kj)
             t=a
           case (3,5,7)
c--observed fourier
             c=f
             if(itipo.eq.5) c=(f-fcvet(kj))
             if(itipo.eq.7) c=2.0*f-fcvet(kj)
             t=f-fcvet(kj)
             t=t*t
             e=d*iphaz(kj)
           case (4)
c--calculated fourier
             c=fcvet(kj)
             e=d*iphaz(kj)
         end select
c--stampa dei riflessi usati
         if(istat2.gt.0) then
            if(jp3.eq.1)then
               write(ncwu,'(3i5,4f10.2,i10)') (khl(n,kj),n=1,3),
     1           fovet(kj),sigmav(kj),fcvet(kj),c,iphaz(kj)
            endif
         endif
c--fine stampa
         nrif1=nrif1+1
c
c--calculate the equivalent reflections
         i1(:) = khl(:,kj)
         do j=1,nsym
            tt=0.0
            do l=1,3
               tt=tt+float(i1(l))*tmat(j,l)
               hkle(l,j)=0
               do k=1,3
                  hkle(l,j)=hkle(l,j)+i1(k)*kmat(j,k,l)
               enddo
            enddo
            hkle(4,j)=tt
            if(j.gt.1) then
               iug=0
               do j1=1,j-1
                 if(abs(hkle(1,j1)-hkle(1,j))+abs(hkle(2,j1)-hkle(2,j))+
     *               abs(hkle(3,j1)-hkle(3,j))-0.001 .le. 0.0)then 
                     iug=1   
                     cycle
                 endif       
                 if(abs(hkle(1,j1)+hkle(1,j))+abs(hkle(2,j1)+hkle(2,j))+
     *               abs(hkle(3,j1)+hkle(3,j))-0.001 .le. 0.0)then
                     iug=1 
                     cycle
                 endif   
               enddo
              if(iug.eq.1) then
                 hkle(:,j)=0.0  
                 cycle
              endif
            endif   
c--this reflection is unique                                            
            ihv= hkle(imedium,j)
            iho= hkle(ilento,j)
            ihv=iabs(ihv)                                                     
            iho=iabs(iho)                                                     
            if(jd.eq.0) then                                               
c--dichiaro la presenza degli indici verticali e orizzontali            
c--Map_Part1(:)=0.0     ! lji <---> ljz=lji+ihomx*ihvmx
               lj=1+ihomx*ihv+iho                                     
               Map_Part1(lj)=1.0                        ! ????????      
               nrif=nrif+1                                           
               r=r+t  
            endif                                                           
            select case (itipo)
               case (3,4,5,6,7)
                  s=e-hkle(4,j)
                  si=sin(s*twopi)
	            co=cos(s*twopi)
                  a=c*co                   
                  if (icMappa.eq.0)  b=c*si             
                  sv=1.0                                   
                  so=1.0 
                  if(hkle(imedium,j).lt.0.0) sv=-sv                        
                  if(hkle(ilento,j).lt.0.0) so=-so                           
               case (1,2)
                  sv=1.0                                    
                  so=1.0 
                  if(hkle(imedium,j).lt.0.0) sv=-sv          
                  if(hkle(ilento,j).lt.0.0) so=-so   
            end select                                                   
c              
c--start of loop over the sections      
            xs=xyzMappa(ivelo,1)                          
            do jse=1,jp
               h=hkle(ivelo,j)*xs
               si=sin(h*twopi)
	         co=cos(h*twopi)
               u=a*co
               v=a*si
c
c--first sums    (4,iho,ihv)
               cj(1)=u
               cj(2)=-v*so
               cj(3)=-v*sv
               cj(4)=-u*so*sv
               if(icMappa.eq.0) then  
                  u=b*si
                  v=b*co
                  bj(1)=u
                  bj(2)=v*so
                  bj(3)=v*sv
                  bj(4)=-u*so*sv
               endif
               lj=1+ihomx4*ihv+4*iho
               do i=1,4
c                  store(lj)=store(lj)+cj(i)+bj(i)
                  Map_Part3(lj,jse)= Map_Part3(lj,jse)+cj(i)+bj(i)
                  lj=lj+1
               enddo
c              m107=m107+md107            !  md107=ihomx4*ihvmx+4           
               xs=xs+xyzMappa(ivelo,3)
            enddo
c--end symmetry loop      
         enddo
      enddo
c---------------------------------------------------------------------
c--end of reflections loop
c---------------------------------------------------------------------
      if(jd.eq.0) then 
         w=scr
         if(itipo.le.2) w=999.0/r
         if(itipo.gt.2) w=2.0*scr*rvol
         if(itipo.eq.3.or.itipo.eq.7) then
            sig=sqrt(r *2.0)*rvol
            if(iprint.ge.-2) write(ncwu,3011) sig
3011        format(' E.s.d. of rho.......... ',f7.2)
         endif
         if(iprint.ge.-2) write(ncwu,3012) nrif,nrif1
3012     format(' Number of reflections used ',i6,
     2          ' (independent =',i6,')')
         jd=1
      endif
c
c--start of loop over the sections                                      
      xs=xyzMappa(ivelo,1)                          
      do jse=1,jp
         Map_Part2(:)=0.0    ! ljz <---> lje=ljz+ihvmx2*jm
c--second sums   (2,ihv,nxo)
         do ihv=1,ihvmx
            ih=ihv-1
c--indirizzo :  i = m107+(4*ik)+(4*ihomx*ih)
            l=1+ihomx4*ih
            do iho=1,ihomx
               ik=iho-1
               lj=1+ihomx*ih+ik
               if(Map_Part1(lj).gt.0) then
                  fko=float(ik)
                  lj=1+2*ih
                  xo=xyzMappa(ilento,1)
                  do j=1,jm
                     g=fko*xo
                     si=sin(g*twopi)
	               co=cos(g*twopi)
                   Map_Part2(lj  )=Map_Part2(lj  )+Map_Part3(l  ,jse)*co
     2                                            +Map_Part3(l+1,jse)*si
                   Map_Part2(lj+1)=Map_Part2(lj+1)+Map_Part3(l+2,jse)*co
     2                                            +Map_Part3(l+3,jse)*si
	               xo=xo+xyzMappa(ilento,3)
                     lj=lj+ihvmx2
                  enddo
               endif
               l=l+4
            enddo
         enddo
c             
c--clear the area for the third sum
         Map_PartN(:)=f000    ! lje <---> ljf=lje+ilen      
c
c--third sum      (nxo,nxv)
         do ihv=1,ihvmx
            ih=ihv-1
            fhv=float(ih)
            xv=xyzMappa(imedium,1)
            l=1
            do i=1,jn
               g=fhv*xv
               si=sin(g*twopi)
               co=cos(g*twopi)
               lj=1+2*ih
c              lj=ljz+2*ih
               do j=1,jm
                  Map_PartN(l)=Map_PartN(l)+Map_Part2(lj  )*co +
     *                                      Map_Part2(lj+1)*si
                  l=l+1
                  lj=lj+ihvmx2
               enddo
               xv=xv+xyzMappa(imedium,3)
            enddo
         enddo
c                  
c--rescale the map
         do m=1,ilen 
            if(itipo.eq.5) then
	         ro=Map_PartN(m)*2.0*rvol
c	         ro=store(m)*2.0*rvol
	         rhodiff(1)=amax1(rhodiff(1),ro)
	         rhodiff(2)=amin1(rhodiff(2),ro)
	         rhodiff(3)=rhodiff(3)+ro*ro
	         xpoint=xpoint+1
            end if
            i=Map_PartN(m)*w             !       w=2.0*scr*rvol
            Map_PartN(m)=i       
            iminr=min0(iminr,i)
            imaxr=max0(imaxr,i)
         enddo
c             
c--check if the priting of the map is required
         if(iprint.ge.2) then
c---- jq=-1               !  codice localizzazione (-1 = localizza)
            if(jq.eq.-1) then 
               if(nq.lt.0) goto 3100  !,3021,3021    ! non devo stampare la prima sezione
! (jp1=numero di sezini effetivamente richieste)
               if(nq.eq.jp1) goto 3100  ! 3022,3100,3022  ! non devo stampare l'ultima sezione 
            endif
c--per stampare una sezione    
c            i=int(xs*xyzMappa(ivelo,4))
c            jpr=i
c           if(iprint.eq.-3) jpr=i
c
c--start printing a layer----------------
c            if(i.eq.jpr) then
               ljg2=ljg1
               m106=1
               jm2=jm1
               do m=1,npag
                  nn=min0(jm2,irig)
                  do i=1,nn
                     idj(i)=Map_Testo_jm(m106)
                     m106=m106+1
                  enddo
                  jm2=jm2-nn
                  write(ncwu,'(1h )')
                  i=int(Map_Testo_jp(jse))
                  write(ncwu,3030) ixy(ivelo),i,ixy(ilento),ixy(imedium)
3030              format(1x,a,' =',i3,2x,' layer,',3x,
     2                      a,' across',3x,a,' down',/)
                  write(ncwu,3050) (idj(i),i=1,nn)
3050              format(/,8x,26i4)
                  write(ncwu,3049) (ista,i=1,nn)
3049              format(8x,26(3x,a))
c                  a= xyzMappa(imedium,1)
c---- jq=-1               !  codice localizzazione (-1 = localizza)
c                  if(jq.eq.-1) a= xyzMappa(imedium,1)+ 
c     *                            xyzMappa(imedium,3)
                  l=ljg2
                  do i=1,jn1
c	               lj=l+nn-1
                     li=l
                     do ig=1,nn
                        idj(ig)=int(Map_PartN(li))
                        li=li+1
                     enddo
                     k=int(Map_Testo_jn(i))
                     write(ncwu,3060)k,(idj(li),li=1,nn)
3060                 format(/,1x,i4,1h*,2x,26i4)
                     l=l+jm
c                     a=a+xyzMappa(imedium,3)
                  enddo
                  ljg2=ljg2+nn
               enddo
c           endif
         endif
3100     continue
c--end printing a layer----------------
c            
         nq=nq+1
c--test if scan is requested or not
c----    jq=-1               !  codice localizzazione (-1 = localizza)
         if(jq.eq.-1) then  
c            m=ljg+ilen-1       ! ?????
c--memorizzo su ALLOCATABLE AREA  Map_Area(1:jm,1:jn,1:jp)
            m=ljg
c           do i=1,ilen
            do i=1,jn
               do j=1,jm
                  Map_Area(j,i,nrec)=Map_PartN(m)
                  m=m+1
               enddo
            enddo
            nrec=nrec+1
         endif
c--increment the layer coordinate  (sezione)                                     
         xs=xs+xyzMappa(ivelo,3)                                       
      enddo
c                                                                       
c--end of loop                                                          
      if(iprint.ge.2) write(ncwu,'(1h )')
      if(iprint.ge.-2) then  !goto 3116
c     if(iprint.lt.-2) goto 3116
         if(itipo.ne.5) then
            write(ncwu,3115) float(iminr)/10.0, float(imaxr)/10.0   ! GL 23/03/09
3115        format(' Minimum =',f7.2,' and maximum =',f7.2,
     2             ' values of rho')
         endif
         if(itipo.eq.5) then
            write(ncwu,3114) rhodiff(2),rhodiff(1)                  ! GL 23/03/09
3114        format(' Minimum =',f7.2,' and maximum =',f7.2,         ! GL 23/03/09
     2             ' values of difference_rho')
            rhodiff(3)=sqrt(rhodiff(3)/xpoint)
            write(ncwu,3113) rhodiff(3)                             ! GL 23/03/09
3113        format(' Having root_mean_square =',f6.2)
         end if
c--test for peak scan
      endif
c3116  continue
c---- jq=-1               !  codice localizzazione (-1 = localizza)
c      if(jq) 3120,3130,3130
      if(jq.gt.0) kfourNew=-1     ! then  !3120,3130,3130
c3120  continue
c
      DEALLOCATE(Map_Part1, stat =ierr)
      DEALLOCATE(Map_Part2, stat =ierr)
      DEALLOCATE(Map_Part3, stat =ierr)
      DEALLOCATE(Map_PartN, stat =ierr)
      DEALLOCATE(Map_Testo_jm, stat =ierr)
      DEALLOCATE(Map_Testo_jn, stat =ierr)
      DEALLOCATE(Map_Testo_jp, stat =ierr)
c
c--end of four routine e controllo se devo localizzare i picchi
      if(kfourNew == 0) then
         itemp(ivelo)=jp      
         itemp(imedium)=jn
         itemp(ilento)=jm
         l_x=itemp(1)      
         l_y=itemp(2)
         l_z=itemp(3)
         IF (.NOT. ALLOCATED(Map_Area_New))
     *	      ALLOCATE (Map_Area_New(1:l_x,1:l_y,1:l_z), stat = ierr)
         if (ierr.ne.0) then
             write(ncwu,*) 'Map_Area_New Allocation error'
             call cstop(' ')
         endif
c--riarrangio mappa secondo x,y,z
c--ilento   = ioriz   (1:jm)
c  imedium  = ivert   (1:jn)
c  ivelo    = isez    (1:jp)
         do ip = 1,jp                   ! loop sulla sezioni
c--start loop verticale      
            do in=1,jn                  ! loop sulle lineee verticali
c--start loop orizzontale         
               do im=1,jm               ! loop sulla riga orizzontale
                  a=Map_Area(im,in,ip)
!               
                  itemp(ivelo)  =ip      
                  itemp(imedium)=in
                  itemp(ilento) =im
!      
                  ile=itemp(1)      
                  ime=itemp(2) 
                  ive=itemp(3)
!              
                  if (javFourier == 1) then
                      write(jrel,*) ile-1, ime-1, ive-1, a
                  endif
!
                  Map_Area_New(ile,ime,ive)=a
               enddo
            enddo      
         enddo
!
         if (javFourier == 1) then
             call javFourierMap(l_x, l_y, l_z, Map_Area_New)
         endif
!
!  stampa di prova
!         write(ncwu,'(1h )')
!         do ip = 2,l_z-1                   ! loop sulla sezioni
!            write(ncwu,'(/,10x,80i5,/)')(i,i=0,l_x-3)
!            do in=2,l_y-1                  ! loop sulle lineee verticali
!               write(ncwu,'(2i5,1h),80f5.0)') in-2,ip-2,
!     *               (Map_Area_New(im,in,ip),im=2,l_x-1)
!            enddo
!         enddo      
!--dealloca la prima mappa      
         DEALLOCATE(Map_Area, stat =ierr)
!--controllo se dati in proiezione (lascio 3 sezioni /= 0)      
         if (lproj == 1) then
             Map_Area_New(4:l_x,1:l_y,1:l_z) = 0.0
         elseif (lproj == 2) then
             Map_Area_New(1:l_x,4:l_y,1:l_z) = 0.0
         elseif (lproj == 3) then
             Map_Area_New(1:l_x,1:l_y,4:l_z) = 0.0
         endif
!          
         call scanNew(izz,Map_Area_New,l_x,l_y,l_z,ier)
c--controllo se bisogna trovare dei picchi negativi
         if(ifNegativePeaks == 1) then
c          call PicchiNeutroni(nPToFind, isogl,izz,i15, Map_Area_New)
         endif
      endif
!      
      if(iprint.ge.-2)  write(ncwu,3200)
3200  format(/,131('+'),/)       
!
      DEALLOCATE(Map_Area_New, stat =ierr)
      return
      end
c                                                                       
!-----------------------------------------------------------------------
      subroutine PicchiNeutroni
     *       (nPToFind,isogl,izz,Map_Area,l_x,l_y,l_z,ier)
      USE General
      Use Atomi
!
      real Map_Area(1:l_x,1:l_y,1:l_z)
!
      natsPos = nats
      do i=1, natsPos
         xyzNeutrons(1:5,i) = xyzs(1:5,i)
      enddo
      a = float(nats) * percNegativePeaks + 0.5
      nNegativePeaks = nint( a )
      Map_Area(:,:,:) = -Map_Area(:,:,:)
c--devo calcolare il numero di picchi da trovare la soglia
      nPToFind=10           ! numero ipotetico
      isogl=5          ! numero ipotetico
      call scanNew(izz,Map_Area,l_x,l_y,l_z,ier)
      natsNeg = min0(nats, nNegativePeaks)
      do i=1, natsNeg
         xyzs(1:5,i+natsPos) = xyzs(1:5,i)
      enddo
      do i=1, natsPos
         xyzs(1:5,i) = xyzNeutrons(1:5,i)
      enddo
      nats = natsPos + natsNeg
      if (no(1).eq.1.and.neutro.eq.0) then
          jlig = 2
      else
          jlig = 1
      endif
      jlig = jlig * nzConst
      do i=1, nats
         nz(i) = jlig
         xyzNeutrons(1:5,i) = xyzs(1:5,i)
         if (i > natsPos) xyzNeutrons(4,i) = -xyzNeutrons(4,i)
         write(6,'(i5,1h),5f12.5)')i,xyzNeutrons(1:5,i)
      enddo
!
      return
      end
!-----------------------------------------------------------------------
code for scanNew 
      subroutine scanNew(ixx,Map_Area,l_x,l_y,l_z,ier)
c--peak searching routine
c  ixx = 0 Patterson
c	   1 Fourier
c
      USE General
      USE Atomi
      USE PhaseModule
      USE Restw
      USE Limits
      USE Symmetry
      USE xfourx
!
      real Map_Area(1:l_x,1:l_y,1:l_z)
      common /misc/ ttt(3,3), dxmax(3),ishift(3,19)
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      dimension xxs(3),xxs1(3)
      dimension xpk(3),xpk1(3),kx(3),vett(3,4),icub(27),cub(27)
      dimension iccp4(3,2)
      dimension d(3)
      character*2 namecc
c
      data namecc/'pk'/
c
      read(namecc,'(a2)')namec
c--
      ier=0
      if(nPToFind.le.0) then
         write(ncwu,901)
901      format(' Warning! no new peaks are requested')
         ier=-1
         return
      endif
!      nats=aperc(1)
!      nats = min0(MaxAtoms-20, nats)
!     if (ksize > 2) then
!         if (nats < 20) nats = 20
!     else
!         if (nats < 5) nats = 5
!     endif
      npic = nint(nats * 1.3)
      npic = min0(MaxAtoms-20, npic)
!
!-- micro structures
!
!     if (ksize == 1) then
!         if (npic < 10) then
!             npic = 10
!         endif
!         if (nats < 10) then
!             nats = 10
!         endif
!     endif
!--initialise constants
      limit = min0(MaxAtoms, npic)
      if(isogl.lt.0) then
	   isogl=20
	   if(nPToFind.gt.100) isogl=10
      endif
c 
      do i=1,3     
         xyzMappa(i,1)=xyzMappa(i,1)+xyzMappa(i,3)
      enddo
c--
      if(iprint.ge.-2) then
         write(ncwu,1000) float(isogl) / 10.0 ! GL 23/03/09
 1000    format(/,' Peak searching with height greater than',f5.1,/)
      endif
      if(iprint.ge.1) then
         write(ncwu,1010)
 1010    format(18x,' ***** map *****',14x,'***** cell *****',/,
     2           8x,' n',8x,' x',5x,' y',5x,' z',10x,' x',8x,' y',8x,
     3           ' z',8x,'rho',/)
      endif
c
c--set to zero numero di picchi trovati
      NumPeaks=0
      npk=0
c--
c--start lof loop over the layers
      xz=xyzMappa(3,1)
      do ip = 2,l_z-1                   ! loop sulla sezioni
c--start loop verticale      
         xy=xyzMappa(2,1)                                               
         do in=2,l_y-1                  ! loop sulle lineee verticali
c--start loop orizzontale         
            xx=xyzMappa(1,1)
            do_ix: do im=2,l_x-1        ! loop sulla riga orizzontale
               a=Map_Area(im,in,ip)
               if(nint(a).ge.isogl) then    
!--analizzo se e' un massimo  
c--punti sul piano centrale
                  icub(14)=Map_Area(im  ,in  ,ip  )
                  icub(13)=Map_Area(im-1,in  ,ip  )
                  icub(15)=Map_Area(im+1,in  ,ip  )
                  icub(11)=Map_Area(im  ,in-1,ip  )  
                  icub(10)=Map_Area(im-1,in-1,ip  )
                  icub(12)=Map_Area(im+1,in-1,ip  )
                  icub(17)=Map_Area(im  ,in+1,ip  )
                  icub(16)=Map_Area(im-1,in+1,ip  )
                  icub(18)=Map_Area(im+1,in+1,ip  )         
c--punti piano inferiore
                  icub( 5)=Map_Area(im  ,in  ,ip-1)
                  icub( 4)=Map_Area(im-1,in  ,ip-1)
                  icub( 6)=Map_Area(im+1,in  ,ip-1)
                  icub( 2)=Map_Area(im  ,in-1,ip-1)
                  icub( 1)=Map_Area(im-1,in-1,ip-1)
                  icub( 3)=Map_Area(im+1,in-1,ip-1)
                  icub( 8)=Map_Area(im  ,in+1,ip-1)
                  icub( 7)=Map_Area(im-1,in+1,ip-1)
                  icub( 9)=Map_Area(im+1,in+1,ip-1)
c--punti piano superiore
                  icub(23)=Map_Area(im  ,in  ,ip+1)
                  icub(22)=Map_Area(im-1,in  ,ip+1)
                  icub(24)=Map_Area(im+1,in  ,ip+1)
                  icub(20)=Map_Area(im  ,in-1,ip+1)
                  icub(19)=Map_Area(im-1,in-1,ip+1)
                  icub(21)=Map_Area(im+1,in-1,ip+1)
                  icub(26)=Map_Area(im  ,in+1,ip+1)
                  icub(25)=Map_Area(im-1,in+1,ip+1)
                  icub(27)=Map_Area(im+1,in+1,ip+1)
                  cub(:)=float(icub(:))
                  iy=-9999
                  do ii=1,27
                     iy=max0(iy,icub(ii))
                  enddo
                  if(nint(a).ge.iy) then
!                    write(ncwu,'(13x,3i7,f10.0)')im-2,in-2,ip-2,a
!--e' un massimo                
!--select the interpolation method
                    select case (interpo)
!
                       case (1)                     
!--from original one ...
                          xz1=xz-xyzMappa(3,3)
                          xz2=xz+xyzMappa(3,3)                 
                          xy1=xy-xyzMappa(2,3)                
                          xy2=xy+xyzMappa(2,3)          
                          xx1=xx-xyzMappa(1,3)          
                          xx2=xx+xyzMappa(1,3)
c      write(ncwu,'(3i7,3f10.4)')icub(5),icub(14),icub(23),xz1,xz,xz2
                          call subxNew(xz1,xz,xz2,cub( 5),cub(14),    
     2                             cub(23) ,xpk(3),rpks)
c      write(ncwu,'(3i7,3f10.4)')icub(11),icub(14),icub(17),xy1,xy,xy2
                          call subxNew(xy1,xy,xy2,cub(11),cub(14),    
     2                             cub(17),xpk(2),rpkv)
c      write(ncwu,'(3i7,3f10.4)')icub(13),icub(14),icub(15),xx1,xx,xx2
                          call subxNew(xx1,xx,xx2,cub(13),cub(14),  
     2                             cub(15),xpk(1),rpko)
                          frpk=  amax1(rpks,rpkv,rpko)  
!                          frpk=     (rpks+rpkv+rpko)/3.0  
!                             
                       case (2)                     
!--from f. pavelcik [acta cryst.(1986)a42,286-287]
                          call xpave(cub,xpk1,frpk)
                          xpk(1)=xx+xpk1(1)*xyzMappa(1,3)
                          xpk(2)=xy+xpk1(2)*xyzMappa(2,3)
                          xpk(3)=xz+xpk1(3)*xyzMappa(3,3)
!                          
                       case (3)                     
c-- from j.s. rollett [computing methods in crystallography]
                         call xrolleNew(icub,xpk1,frpk,lk,l,lnx,la2,lc2)
                          xpk(1)=xx+xpk1(1)*xyzMappa(1,3)
                          xpk(2)=xy+xpk1(2)*xyzMappa(2,3)
                          xpk(3)=xz+xpk1(3)*xyzMappa(3,3)
!                          
                       case (4)                     
c--interpolation by booth's parabola procedure (from CCP4)
	                    iccp4(1,1) = icub(13)
	                    iccp4(1,2) = icub(15)
	                    iccp4(2,1) = icub(11)
	                    iccp4(2,2) = icub(17)
	                    iccp4(3,1) = icub(5)
	                    iccp4(3,2) = icub(23)
	                    iRPK =    icub(14)
                          call xparab(iccp4,irpk,xpk1)
                          frpk=irpk
                          xpk(1)=xx+xpk1(1)*xyzMappa(1,3)
                          xpk(2)=xy+xpk1(2)*xyzMappa(2,3)
                          xpk(3)=xz+xpk1(3)*xyzMappa(3,3)
                    end select
                    irpk=nint(frpk)
                    kx(1)=nint(xx*xyzMappa(1,4)+0.5)
                    kx(2)=nint(xy*xyzMappa(2,4)+0.5)
                    kx(3)=nint(xz*xyzMappa(3,4)+0.5)
                    if(iprint.ge.1) then
                       npk=npk+1
                       write(ncwu,2300) npk,(kx(ii),ii=1,3),
     *                                      (xpk(ii),ii=1,3),irpk
 2300                  format(7x,i3,3x,3i7,4x,3f10.4,i9)
                    endif
!                    
c-- check the peak ------------------------------------------------ 
                    nop1 = NumPeaks+1
                    xx=side(xpk(1))
                    yy=side(xpk(2))
                    zz=side(xpk(3))
                    xyzs(1,nop1) = xx
                    xyzs(2,nop1) = yy
                    xyzs(3,nop1) = zz
                    xyzs(4,nop1) = frpk
c--if two peaks are closer than dm angstroms eliminate the smaller
                    if(NumPeaks > 0) then
                       ir=0
                       do k=1,nsymTot
                          call oper(k,xxs,xx,yy,zz)
                          if (lproj > 0) xxs(lproj) = 0.0
                          do_pk: do jj=1,NumPeaks
                               do l=1,3
                                  xxs1(l)=xxs(l)-xyzs(l,jj)
                                  do while(abs(xxs1(l))>0.5)
                                     xxs1(l)=xxs1(l)-sign(1.0,xxs1(l))
                                  enddo
                                  if(abs(xxs1(l))>dxmax(l)) cycle do_pk
                               enddo
                               if(quadr(xxs1,xxs1,ttt)<=dm) then 
                                  if(ir>0) xyzs(4,ir)=0.0
                                  ir=0
                                  if(ixx /= 0) then
                                     if(frpk <= xyzs(4,jj) ) goto 2000
                                  else
                                     if(frpk <  xyzs(4,jj) ) goto 2000
                                  endif
                                  xyzs(1,jj)= xx
                                  xyzs(2,jj)= yy
                                  xyzs(3,jj)= zz
                                  xyzs(4,jj)= frpk
                                  ir=jj
                               endif
                          enddo do_pk
                       enddo
                       if(ir>0) goto 2000
                    endif
                    NumPeaks=nop1
                    if (NumPeaks .ge. limit) then
                        call sortf(xyzs, 5, NumPeaks, 4)
                        NumPeaks = npic
                        alevel = xyzs(4,npic) + 0.5
                        limit = min0(MaxAtoms, 2*nats)
                    endif
                  endif
               endif
 2000          continue                 
               xx=xx+xyzMappa(1,3)
            enddo do_ix
            xy=+xy+xyzMappa(2,3)                                      
         enddo      
         xz=xz+xyzMappa(3,3)
      enddo 
c!
      call CalcolaOccupanze()
c      
      if (iprint >= 1) then
          write(ncwu,*) '-----Picchi unici ',NumPeaks,nats,isogl
          do j=1,NumPeaks
            write(lo,'(i5,3f10.4,f10.0,f10.3)') j, (xyzs(n,j),n=1,5)
          enddo
          write(ncwu,'(1h )')
      endif
c!
      return
      end
! ----------------------------------------------------------------------
      subroutine CalcolaOccupanze()
      USE General
      USE Atomi
      USE PhaseModule
!
      dimension xo(11),xn(11),key(10)
!
      if (no(1).eq.1.and.neutro.eq.0) then
          jlig = 2
      else
          jlig = 1
      endif
      jlig = jlig * nzConst
      iactn = 1
      itype = 0
      khead = 0
      xo(:) = 0.0
      xn(:) = 0.0
      do i=1,nats
         nz(i) = jlig
         xo(1:3) = xyzs(1:3,i)
         iser  = i
         ksp = kspecb(newvet,xo,xn,key,itype,iser,khead,iactn)
         xyzs(5,i) = 1.0 / float( key(10) )
      enddo
      call sortf(xyzs, 5, nats, 4)
!
      return
      end
! ----------------------------------------------------------------------
code for xpave
      subroutine xpave(f,xpk,frpk)
c--peak interpolation formula by f.pavelcik
c  (acta cryst.(1986) a42,286-287)
      dimension xpk(3),a(3),aa(3)
      real f(27)
c--
      a0=(-f(2)-f(4)-f(6)-f(8)-f(10)-f(12)-f(16)-f(18)-f(20)
     2    -f(22)-f(24)-f(26)+4*f(5)+4*f(11)+4*f(13)+4*f(15)
     3    +4*f(17)+4*f(23)+12*f(14))/24.0
      a(1)=(f(6)-f(4)+f(12)-f(10)+4*(f(15)-f(12))
     2    +f(18)-f(16)+f(24)-f(22))/16.0
      a(2)=(f(8)-f(2)+f(16)-f(10)+4*(f(17)-f(11))
     2    +f(18)-f(12)+f(26)-f(20))/16.0
      a(3)=(f(22)-f(4)+f(20)-f(2)+4*(f(23)-f(5))
     2    +f(26)-f(8)+f(24)-f(6))/16.0
      aa(1)=(f(4)+f(6)+f(10)+f(12)+f(16)+f(18)+f(22)+f(24)
     2     -2*f(5)-2*f(11)-2*f(17)-2*f(23)+2*f(15)+2*f(13)
     3     -4*f(14))/12.0
      aa(2)=(f(2)+f(8)+f(10)+f(16)+f(12)+f(18)+f(20)+f(26)
     2     -2*f(5)-2*f(13)-2*f(15)-2*f(23)+2*f(11)+2*f(17)
     3     -4*f(14))/12.0
      aa(3)=(f(2)+f(4)+f(6)+f(8)+f(20)+f(22)+f(24)+f(26)
     2     -2*f(11)-2*f(13)-2*f(15)-2*f(17)+2*f(5)+2*f(23)
     3     -4*f(14))/12.0
      frpk=a0
      do i=1,3
       xpk(i)=0.0
       if(aa(i).gt.0.0) then 
        xpk(i)=-a(i)/(2.0*aa(i))
        frpk=frpk-(a(i)*a(i))/(4.0*aa(i))
       endif
      enddo
      return
      end
c
code for xparab
      subroutine xparab(iccp4,irpk,xpk)
c--peak interpolation by parabola procedura (from CCP4)
c
c  d = passo lungo l'asse
c  Picco(1) = valore alla posizione (x - d)
c  Picco(2) = valore alla posizione (x)
c  Picco(3) = valore alla posizione (x + d)
c  1) sottraggo x dalle posizioni
c  2) pongo [controllando se Picco(1)>Picco(3)]:
c     A = Picco(1) - Picco(3)
c     B = Picco(2) - Picco(3)
c  3) ho il sistema:
c
c  a.d^2 - b.d + c = A
c		 c = B
c  a.d^2 + b.d + c = 0
c
c  determinante= -2.d^3
c  a = (2.B.d - A.d) / deter
c  b = A.d^2 / deter
c  il massimo e' alla posizione:
c  x = -b / 2.a = [-A / (4.B - 2.A) ] . d
c
c  xpk(N) =  [-A / (4.B - 2.A) ]
c
      dimension xpk(3)
      dimension iccp4(3,2)
c--
	      DO N = 1,3
	       IF (iccp4(N,2).le.iccp4(N,1)) then 
	       R2 = iccp4(N,1) - iccp4(N,2)
	       R1 = iRPK - iccp4(N,2)
	       iQ = -1
               else
  	       R2 = iccp4(N,2) - iccp4(N,1)
	       R1 = iRPK - iccp4(N,1)
	       iQ = 1
               endif
  	       IF (R1.GE.0.001 .OR. R2.GE.0.001) then 
  	       CM = (R2-4.0*R1)/ (2.0*R2-4.0*R1) - 1.0
               else
	       CM = 0.0
               endif
	       xpk(N) = iQ*CM
	      enddo
	    return
	    end
c                                                                       
code for subxNew                                                           
      subroutine subxNew(x1,x2,x3,f1,f2,f3,a,b)                            
c--
      USE General
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty                      
c
      dimension x(3),v(9),c(3,3)                                        
c
      v(:) = 0.0
      x(1)=x1                                                           
      x(2)=x2                                                           
      x(3)=x3                                                           
c     write(ncwu,2000) x,i1,i2,i3
c2000 format(1x,3f10.4,'##',3i5)
      if(f1-f2) 1100,1010,1100
 1010 continue                                                          
      if(f3-f2) 1100,1020,1100                                          
 1020 continue                                                          
      f2=f2+1                                                           
 1100 continue                                                          
      v(1)=f1                                                   
      v(2)=f2                                                 
      v(3)=f3                                                  
      do 1000 i=1,3                                                     
      c(i,1)=x(i)*x(i)                                                  
      c(i,2)=x(i)                                                       
      c(i,3)=1.0
 1000 continue
      call matin(c,3,v,1,d)
      a=-0.5*v(2)/v(1)
      b=a*a*v(1)+a*v(2)+v(3)
      return
      end
c
code for xrolleNew
      subroutine  xrolleNew(icub,xx,frpk,lk,l,lnx,la2,lc2)
c-- from j.s. rollett [computing methods in crystallography,
c   pp.35-37.oxford: pergamon press.
c--
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      dimension icub(27)
      dimension amult(3),sol1(4,4),sol2(3,3),sol3(3,3),p(7),qq(4),xx(3)
     2 ,rho(3,3,3)
      equivalence (p(1),aa),(p(2),ae),(p(3),af),(p(4),ag)
      equivalence (p(5),ab),(p(6),ac),(p(7),ad)
      data amult(1)/1.0/,amult(2)/0.0/,amult(3)/1.0/
      data sol1(1,1)/18./,sol1(1,2)/-10./,sol1(1,3)/-10./,sol1(1,4)/
     2 -10./
      data sol1(2,1)/-10./,sol1(2,2)/11./,sol1(2,3)/4./,sol1(2,4)/4./
      data sol1(3,1)/-10./,sol1(3,2)/4./,sol1(3,3)/11./,sol1(3,4)/4./
      data sol1(4,1)/-10./,sol1(4,2)/4./,sol1(4,3)/4./,sol1(4,4)/11./
c--
      m=1
      do 1150 i=1,3
      do 1100 j=1,3
      do 1050 k=1,3
c--check if the rho value is less than 1.
      if(icub(m)-1)1800,1000,1000
1000  continue
      rho(k,j,i)=float(icub(m))
      m=m+1
1050  continue
1100  continue
1150  continue
      rho(1,1,1)=1.001
      rho(3,1,1)=1.001
      rho(1,3,1)=1.001
      rho(3,3,1)=1.001
      rho(1,1,3)=1.001
      rho(3,1,3)=1.001
      rho(1,3,3)=1.001
      rho(3,3,3)=1.001
c--convert to logs
      do 1450 i=1,3
      do 1400 j=1,3
      do 1350 k=1,3
      rho(k,j,i)=alog(rho(k,j,i))
1350  continue
1400  continue
1450  continue
c--compute the 'b', 'c', and 'd' terms
      ab=0.
      ac=0.
      ad=0.
      do 1550 i=1,3
      do 1500 j=1,3
      ab=ab+rho(3,j,i)-rho(1,j,i)
      ac=ac+rho(j,3,i)-rho(j,1,i)
      ad=ad+rho(j,i,3)-rho(j,i,1)
1500  continue
1550  continue
      ab=0.1*ab
      ac=0.1*ac
      ad=0.1*ad
c--compute the 'h', 'k' and 'l' terms
      ah=0.25*(rho(2,1,1)-rho(2,1,3)-rho(2,3,1)+rho(2,3,3))
      ak=0.25*(rho(1,2,1)-rho(1,2,3)-rho(3,2,1)+rho(3,2,3))
      aj=0.25*(rho(1,1,2)-rho(1,3,2)-rho(3,1,2)+rho(3,3,2))
c--compute the 'q' terms
      do 1551 i=1,4
1551  qq(i)=0.0
      do 1700 i=1,3
      do 1650 j=1,3
      do 1600 k=1,3
      qq(1)=qq(1)+rho(k,j,i)
      qq(2)=qq(2)+rho(k,j,i)*amult(k)
      qq(3)=qq(3)+rho(k,j,i)*amult(j)
      qq(4)=qq(4)+rho(k,j,i)*amult(i)
1600  continue
1650  continue
1700  continue
c--solve the equations
c      write(ncwu,*) '(qq(i),i=1,4):',(qq(i),i=1,4)
c      write(ncwu,*) '(p(i),i=1,7):',(p(i),i=1,7)
      ival4=4
      ival1=1
      call xmtmm(sol1,qq,p,ival4,ival4,ival1)
      do  1710 i=1,4
1710  p(i)=p(i)/42.0
c--solve for the atomic coordinates
      sol2(1,1)=-(ae+ae)
      sol2(1,2)=-aj
      sol2(2,1)=-aj
      sol2(1,3)=-ak
      sol2(3,1)=-ak
      sol2(2,2)=-(af+af)
      sol2(2,3)=-ah
      sol2(3,2)=-ah
      sol2(3,3)=-(ag+ag)
      if(kinv2(3,sol2,sol3,9,1,p(5),xx,3))1800,1750,1800
1750  continue
c -- l.s. fit made to peak.
      frpk=exp(aa+xx(1)*(ab+xx(1)*ae)+xx(2)*(ac+xx(2)*af)+xx(3)
     2 *(ad+xx(3)*ag)+ah*xx(2)*xx(3)+ak*xx(1)*xx(3)+aj*xx(1)*xx(2))
      goto 1850
c--compute the terms of the parabolic interpolation
1800  continue

c      q=store(lk)+store(lk)
c      u=store(la2)-store(lc2)
c      v=store(lk-1)-store(lk+1)
c      w=store(l)-store(lnx)
c      r=(store(lc2)+store(la2)-q)
c      s=(store(lk-1)+store(lk+1)-q)
c      t=(store(l)+store(lnx)-q)
c      if(r.ne.0.0) r=u/r
c      if(s.ne.0.0) s=v/s
c      if(t.ne.0.0) t=w/t
c--compute the average interpolated peak height
c      frpk=store(lk)-(u*r+v*s+w*t)*.041667
      xx(1)=0.5*t
      xx(2)=0.5*s
      xx(3)=0.5*r
1850  continue
      return
      end
c
code for vec                                                            
      function vec(x)                                                   
      vec    = amin1(((0.0106 * x - 0.1304) * x + 0.5658) * x, 1.0)     
      return                                                            
      end                                                               
c
code for kinv2
      function kinv2(n,a,b,na,nm,c,d,nc)
c--matrix inversion and solution of simultaneous linear equations
c
c  n       order of the matices to be inverted.
c  a       matrix to be inverted  i.e. a(n,n)
c  b       inverse matrix  -  calculated by this subroutine  -  b(n,n)
c  na      the order of 'a' and 'b'  -  greater than or equal
c          to 'n*n'.
c  nm      number of column vectors to be multiplied onto the inverse
c          matrix
c  c       column vectors to be multiplied onto the inverse matrix c(n,m
c  d       results of multiplication on to the inverse matrix  -  d(n,m)
c  nc      the order of 'c' and 'd'  -  greater than or equal
c          to the maximum of 'n' and 'n*nm'. this means that a column
c          vector at least must be provided for both.
c
c--in matrix notation
c
c  d=b.c
c  c=a.d
c
c--return values of 'kinv2' are :
c
c   0  inversion etc. went okay.
c  >0  singular  -  return value indicates first signular element found.
c
c--
      double precision  x02abf,dummy
c
      dimension a(na),b(na),c(nc),d(nc)
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      data asing/0.0/,bsing/0.0/,csing/0.0/,e/0.0/,f/0.0/
      data m1/0/,m2/0/,m3/0/,m4/0/,m5/0/,m6/0/,m7/0/,m8/0/
      data i/0/,j/0/,k/0/,l/0/,m/0/
      data dummy/0.2d1/
c
      kinv2=0
c--set 'eps', such that 'eps' is the smallest number for 1.0+eps>1.0
      bsing=16.0**(-5)
c--set the smallest number that can be exactly represented on the machin
      x02abf=dummy**(-34)
      csing=sngl(x02abf)
c--set the singularity check limits
      csing=csing/bsing
      bsing=bsing*16.
c--set row interchange flags
      do 1000 i=1,n
      d(i)=float(i)
1000  continue
c--commence decomposition a=l.u  -  by rows with interchanges
      m5=1
      m6=1
      m1=m5
      m2=m6
      do 1100 i=1,n
      do 1050 j=1,n
      b(m2)=a(m1)
      m1=m1+1
      m2=m2+1
1050  continue
1100  continue
      m8=1
      do 1900 joj=1,n
      j=joj
      m2=m6
      m7=m8
      f=-1.
      l=j-1
c--calculate the l part , except for the division by u(i,i)
      do 1450 i=j,n
      e=b(m2)
      asing=bsing*abs(e)
      if(l)1250,1250,1150
1150  continue
      m3=i
      m4=m7
      do 1200 k=1,l
      e=e-b(m3)*b(m4)
      m3=m3+n
      m4=m4+1
1200  continue
c--transfer to the b array and check for the maximum value
1250  continue
      b(m2)=e
      m2=m2+1
      if(f-abs(e))1300,1450,1450
c--this is the current maximum
1300  continue
      f=abs(e)
      m=i
      d(m)=abs(d(m))
c--check singularity for this element
      if(asing-f)1350,1400,1400
1350  continue
      if(csing-f)1450,1400,1400
1400  continue
      d(m)=-d(m)
1450  continue
c--check if the maximum value is indicated as singular
      if(d(m))1500,1500,1550
1500  continue
      kinv2=j
      goto 3100
c--interchange rows
1550  continue
      call xint2(n,b,na,d,nc,j,m,n)
      e=1./b(m6)
      b(m6)=e
      if(j-n)1600,1900,1600
1600  continue
      m=j+1
      m3=m6+1
      do 1650 i=m,n
      b(m3)=b(m3)*e
      m3=m3+1
1650  continue
      if(l)1850,1850,1700
c--complete calculation of u
1700  continue
      m2=m6+n
      m7=m7+n
      do 1800 i=m,n
      m3=j
      m4=m7
      do 1750 k=1,l
      b(m2)=b(m2)-b(m3)*b(m4)
      m3=m3+n
      m4=m4+1
1750  continue
      m2=m2+n
      m7=m7+n
1800  continue
c--update various flags
1850  continue
      m6=m6+n+1
      m8=m8+n
1900  continue
c--decomposition ends.
c
c--invert the lower triangular matrix l
      m5=2
c--process by rows
      do 2150 i=2,n
      m4=m5
c--process by columns
      do 2100 j=i,n
      b(m5)=-b(m5)
      k=j-i
      if(k)2050,2050,1950
1950  continue
      m1=m5+n
      m2=m4
      do 2000 l=1,k
      b(m5)=b(m5)-b(m1)*b(m2)
      m1=m1+n
      m2=m2+1
2000  continue
2050  continue
      m5=m5+1
2100  continue
      m5=m5+i
2150  continue
c
c--invert the upper triangular matrix u
      m5=n*n-1
      do 2300 i=2,n
      m4=m5+1
      do 2250 j=i,n
      k=j-i+1
      m1=m5
      m2=m4
      e=0.
      do 2200 l=1,k
      e=e-b(m1)*b(m2)
      m1=m1-n
      m2=m2-1
2200  continue
      b(m5)=e*b(m1)
      m5=m5-1
2250  continue
      m5=m5-i
2300  continue
c
c--assembly of the final matrix  -  still with rows interchanged
      m5=1
      do 2700 j=1,n
      m3=m5+n
      m4=m5+j
      do 2650 i=1,n
      m1=m3
      m2=m4
      if(i-j)2350,2350,2400
2350  continue
      e=b(m5)
      m3=m3+1
      k=n-j
      goto 2450
2400  continue
      e=0.
      m3=m3+n+1
      m4=m4+1
      k=n-i+1
2450  continue
      if(k)2600,2600,2500
2500  continue
      do 2550 l=1,k
      e=e+b(m1)*b(m2)
      m1=m1+n
      m2=m2+1
2550  continue
2600  continue
      b(m5)=e
      m5=m5+1
2650  continue
2700  continue
c--assembly ends.
c
c--sort out the interchanges and store final inverse matrix
      do 2850 ioi=1,n
      do 2800 joj=1,n
      i=ioi
      j=joj
      k=nint(d(j))
      if(k-i)2800,2750,2800
2750  continue
      call xint2(n,b,na,d,nc,i,j,1)
      goto 2850
2800  continue
      write(ncwu,2830)
2830  format(15h inverter fails  )
c     call xerhnd ( iersev )
      kinv2=1
      goto 3100
2850  continue
c--final assembly ends.
c
c--solve the given equations if any
      if(nm)3100,3100,2900
2900  m3=1
      m4=1
      do 3050 i=1,nm
      do 3000 j=1,n
      m1=j
      m2=m3
      d(m4)=0.
      do 2950 k=1,n
      d(m4)=d(m4)+b(m1)*c(m2)
      m1=m1+n
2950  m2=m2+1
3000  m4=m4+1
3050  m3=m3+n
c
3100  return
      end
c
code for xint2
      subroutine xint2(n,b,nb,d,nd,j,k,itipo)
c--interchanges either rows or columns j and k
c--the type of interchange is determinated by 'itipo' :
c  1  columns.
c  2  rows.
c--
      dimension b(nb),d(nd)
      data i/0/,l/0/,m/0/
      data f/0.0/
      if(j-k)1000,1100,1000
1000  continue
      l=(j-1)*(n/itipo)+1
      m=(k-1)*(n/itipo)+1
      f=d(j)
      d(j)=d(k)
      d(k)=f
      do 1050 i=1,n
      f=b(l)
      b(l)=b(m)
      b(m)=f
      l=l+itipo
      m=m+itipo
1050  continue
1100  continue
      return
      end
! ----------------------------------------------------------------------
      subroutine labelxNew(ier, ifIdro)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE PhaseModule
      USE LsqModule
      USE xfourx
!
      common/xlimi/nflx,lflx,nlxx,idummx(3),nflsx
      common /RotMou/ iAnchorX, iAnchorY, IfDrag, IcanDrag, iDragEnabled
     *               ,mEv_fsBtn
      common /Distanze/ ndist, dis(300), nop(300), ifDist
!
      dimension xn(3),xo(3),xeq(3),vet(2),s(3) ! , xyzMin(3)
      integer Richiesti, Trovati
!
      vetSpec(19) = 0
      ier = 0
      do i=1,nats
         nz(i) = 20000
      enddo
!
!-- save old connectivity
!
      nco = iconn(1)
      if (nco.gt.0) then
          nitem = 3 * nco + 1
          do i=1,nitem
             iconnSav(i) = iconn(i)
          enddo
      else
          iconnSav(1) = nco
      endif
!
!mer cerca il max serial number sulla vecchia lista per passarlo alla 
!-- nuova e valore minimo dell'altezza di picco per assegnarlo ai nuovi 
!-- atomi
      isnmx=-1
      heimin = 999999
      do k=1,natsOld
         if (nzo(k).ne.0) then
             if (heimin.gt.xyzo(4,k)) then
                 heimin = xyzo(4,k)
             endif
             Labb=aLabOld(k)
             isn = serial(k)
             if (isn.ge.isnmx) isnmx = isn
         endif
      enddo
!      
      if (iprin > 2) then
          write(lo,*) ' vecchia lista '
          do i=1,NatsOld
             nzzo=iabs(nzo(i))/nzConst
             if (nzzo.eq.0) then
                 write(lo,'(2x,2x,i5,f8.1,4f10.3)')
     *                 i,xyzo(4,i),(xyzo(j,i),j=1,3),
     *                 xyzo(5,i)
             else
                 write(lo,'(2x,a2,i5,f8.1,4f10.3)')
     *                 nalf(nzzo),i,xyzo(4,i),(xyzo(j,i),j=1,3),
     *                 xyzo(5,i)
             endif
          enddo
          write(lo,*) ' nuova lista '
      endif
      do j=1,nats
         if (iprin > 2) then
             nzzo=iabs(nz(j)/nzConst)
             if (nzzo.gt.0) then
                 write(lo,'(2x,a2,i5,f8.1,4f10.3)')
     *            nalf(nzzo),j,xyzs(4,j),(xyzs(k,j),k=1,3),
     *            xyzs(5,j)
             else
                 write(lo,'(2x,2x,i5,f8.1,4f10.3)')
     *                       j,xyzs(4,j),(xyzs(k,j),k=1,3),
     *            xyzs(5,j)
             endif
         endif
         qq(j)=0.0
         fvar(j)=biso
      enddo
      vet(1)= 1.0
      vet(2)=-1.0
      ifin=icent+1
      do i=1,NatsOld
         if (nzo(i).ne.0) then
             nnzo=iabs(nzo(i))/nzConst
             do j=1,3
                xo(j)=xyzo(j,i)
             enddo
             distm=9999
             jpunt=0
             do j=1,nats
                if (nz(j).ne.0) then
                    if (qq(j).lt.0.5) then
                        do k=1,3
                           xn(k)=xyzs(k,j)
                        enddo
                        do kt=1,ncentr
                           do ifi=1,ifin
                              coef=vet(ifi)
                              do k=1,nsym
                                 call xequi(xo,k,coef,xeq,kt)
                                 call xdist(xn,xeq,d,s)
                                 if (d.lt.ddmin) then
                                     distm=d
                                     jpunt=j
                                     qq(jpunt) = i
                                     fvar(jpunt) = d
*                                    xyzMin(:) = xeq(:)
                                 endif
                              enddo
                           enddo
                        enddo
                    endif
                endif
             enddo
*            if (jpunt /= 0) then
*                call PosizioneAssoluta(xyzMin, xo)
*                xyzs(1:3,jpunt) = xyzMin(1:3)
*            endif
         endif
      enddo
!
      if (iprin > 2) then
          write(lo,*) ' confronto '
          do j=1,nats
             if (nz(j).ne.0) then
                 nzn=iabs(nz(j)/nzConst)
                 i=nint(qq(j))
                 if (iprin > 2) then
                     if (i.gt.0) then
                         write(lo,210) nalf(nzn),j,(xyzs(k,j),k=1,3)
     *                                ,fvar(j),aLabOld(i),i,
     *                                 (xyzo(k,i),k=1,3),bfac(i)
                         write(lo,*) nint(xyzs(4,j)),fvar(j)
                     else
                         write(lo,210) nalf(nzn),j,(xyzs(k,j),k=1,3)
     *                                ,fvar(j)
                     endif
                 endif
             endif
          enddo
      endif
      k = 0
!
*     call EllRest
      natstmp = nats
      nats = natstmp
!
      do j=1,nats
!
!-- accept the new peak only if has no counterpart
!-- in the atom list
!
         i=qq(j)
         if (i.le.0) then
             k = k + 1
             do jj=1,5
                xyzs(jj,k)=xyzs(jj,j)
             enddo
             bfac(k)=biso
         else
             if (iCoef /=3) then
!
!-- assign to old atom the new peak height (only if Fo or 2Fo-Fc Fourier)
!
!new?            do jj=1,3
!new?               xyzs(jj,i) = xyzo(jj,i)
!new?            enddo
!new?            xyzs(4,i) = xyzs(4,j)  
!new?            xyzs(5,i) = xyzo(5,i)
!new?            bfac(i) = qvar(i)  
!new?            aLab(i) = aLabOld(i)
!new?            nz(i) = nzo(i)
c--------------------------------------------------------------------
c--original...
c
                  do jj=1,3
                     VetChanges(jj) = xyzo(jj,i)
                  enddo
                  VetChanges(4) = xyzs(4,j)
                  VetChanges(5) = xyzo(5,i)
                  VetChanges(6) = qvar(i)  ! bfac(i)  Gianluca 27/06/07
                  Labb = aLabOld(i)
                  lnz = iabs(nzo(i)/nzConst)
                  iAction = 0
                  call ModModel(i,iAction,Labb,lnz,VetChanges)
                  da_verificare = 1
                  if (da_verificare < 0.5) then
                      if (bSav(i).gt.0.0) then
                          VetChanges(1) = Ell(1,1,i)
                          VetChanges(2) = Ell(1,2,i)
                          VetChanges(3) = Ell(1,3,i)
                          VetChanges(4) = Ell(2,2,i)
                          VetChanges(5) = Ell(2,3,i)
                          VetChanges(6) = Ell(3,3,i)
                          iAction = 7
                          call ModModel(i,iAction,Labb,lnz,VetChanges)
                      endif
                  endif
             endif
         endif
      enddo
  210 format(2x,a2,i4,4f10.3,10x,a8,i4,4f10.3,10x)
      nats = k
      if (nats.gt.nPeaksToFind) nats = nPeaksToFind
!
!
      if (nats.gt.0) then
!
!-- assign species to new peaks
!-- update list 5 ( add new atoms )
!
          do i=1,nats
             j = -1
             lnz = PiccoFour
             nz(i) = PiccoFour * nzConst
             call CreaLab(i,j,lnz,Labb)
             aLab(i) = Labb
             serial(i) = i
          enddo
!
!-- move atoms at the end of arrays
!-- to make room for old atoms
!
          do i=nats,1,-1
             do j=1,5
                xyzs(j,NatsOld+i) = xyzs(j,i)
             enddo
             nz(NatsOld+i) = nz(i)
             bfac(NatsOld+i) = bfac(i)
             aLab(NatsOld+i) = aLab(i)
             serial(NatsOld+i) = serial(i)
          enddo
      endif
!
!-- copy old atoms at the beginning of arrays
!
      do i=1,NatsOld
         do j=1,5
            xyzs(j,i) = xyzo(j,i)
         enddo
         nz(i) = nzo(i)
         bfac(i) = qvar(i)
         aLab(i) = aLabOld(i)
         serial(i) = kblock(i)
      enddo
!
      iAction = 2
      call ClessidraOnOff(iAction)
!
      if (nats > 0) then
          if (iprin > 2) then
              write(6,*) 'Lista totale'
              do i = 1, natsOld+nats
                 write(6,123) i, aLab(i),xyzs(1:3,i)
  123            format(i5,2x,a,3f10.3)
              enddo
          endif
          NumLeg = iconn(1)
          natsSav = nats
          nats = NatsOld + nats
          call RaggruppaNew()
          Richiesti = npc - NatsOld
          Trovati = natsSav
!          
          call ClearMessage()
! --
          Msg = '1234 new peak(s) found .' // char(10)
     *     //  'Check Intensities &amp; distances and select peaks'
     *     //  ' to retain.' // char(10)
     *     //  'New peaks will be represented by stars.'
          if (iCoef.eq.3) then
              k = Lung(Msg)
*             write(Msg(k+1:),5) char(10), rhodiff(1:3)
              write(Msg(k+1:),6) char(10), 
     *              rhodiff(1), char(10),
     *              rhodiff(2), char(10),
     *              rhodiff(3)
          endif
          write(Msg(1:4),'(i4)') natsSav
!
          if (Trovati < Richiesti/2 .and. levelFourier > 1) then
              k = Lung(Msg)
              Msg(k+1:) = char(10) // 
     *                    ' Warning: number of peaks found too low.' // 
     *                    char(10) //
     *                    ' Try to decrease the level value.'
          endif
!
          call scrper(' ',0,-1)
!
          iActLis = 7
          k = Lung(Msg)
          Msg(k+1:k+1) = char(0)
          Inte = 'Select peaks to accept'
          NumCan = natsSav
          MultiSel = 1
          selezione(:) = 0
          call manPeekList(Inte, NumCan, MultiSel, selezione, iExitC, 7)
          if (iExitC == 3) then
              natsSav = 0
              selezione(:) = 0
          elseif (iExitC == 2) then
              selezione(:) = 1
          endif
        
          if (iExitC /= 3) then
*             call PutModel
*gl*          NumUnDel = 0
              NumAdd = 0
              do i=1, NumCan
                 if (selezione(i).eq.0) then
*gl*                 NumUnDel = NumUnDel + 1
*                    NumAdd = NumAdd + 1
*                    j = NatsOld + i
*                    iAction = 2
*                    Labb = aLab(j)
*                    lnz = 1
*                    call ModModel(j,iAction,Labb,lnz,VetChanges)
                 else
                     NumAdd = NumAdd + 1
                     j = NatsOld + i
                     iAction = 0
                     iAction = 1
                     Labb = aLab(j)
                     VetChanges(1:5) = xyzs(1:5,j)
                     VetChanges(  6) = dis(i)
                     lnz = PiccoFour
                     call ModModel(j,iAction,Labb,lnz,VetChanges)
                 endif
              enddo
              iAction = 100
              call ModModel(i,iAction,Labb,lnz,VetChanges)
*gl*          natsSav = natsSav - NumUnDel
              natsSav = NumAdd
!
              if (iprin.gt.2) then
                  write(lo,1000)
1000              format(4x,'N',2x,'Label',3x,'Spec',6x,'x',9x,'y',
     2                   9x,'z',9x,'Int',7x,'Occ',5x,'B(iso)',/)
                  do i=1,nats
                     if (nz(i).ne.0) then
                         nzn=iabs(nz(i)/nzConst)
                         write(lo,100) i,alab(i),nalf(nzn),
     *                                 (xyzs(k,i),k=1,5),bfac(i)
  100                    format(i5,') ',a8,2x,a2,3f10.3,f10.0,2f10.3)
                     endif
                  enddo
              endif
          endif
!
          iAngolo = 0
          leggi = 1
*         leggi = 0    ! gianluca 8/10/10
          call toMolPlo3(leggi)
          call RotazTot
          call GetBonds(1)
          if (natsSav.gt.0) then
              write(lo,280) natsSav
  280         format(2x,i5,' new peak(s) accepted')
!--
              radmax = 0
              do i=1, nk
                 if (radii(i,1).gt.radmax) then
                     radmax = radii(i,1)
                 end if
              enddo
              do i=1,natsSav
                 k = NatsOld + i
                 iCol(k) = color_GHOST
                 RS(k) = radmax / 3.0 !        era 0.11
                 rMLu(k) = 2 * radmax
                 SinglePlotType(k) = SinglePlotType(NatsOld)
              enddo
          endif
          call Disegna(1)
          if (natsSav.gt.0) then            !mrmr
              if (ifIdro == 1) then
                  call apri_toolbar ('idro')
              else
                  call apri_toolbar ('four')
              endif
          endif
      else
          call scrper(' ',0,-1)
          ier = -1
          ifFour = 0
          Msg = 'No new peaks found !!! '
          if (iCoef.eq.3) then
              k = Lung(Msg)
              Threshold = float(levelFourier) / 10.0
              write(Msg(k+1:),5) char(10), 
     *              Threshold, char(10),
     *              rhodiff(1), char(10),
     *              rhodiff(2), char(10),
     *              rhodiff(3)
          endif
          call MsgWinErr('Warning', Msg, WARN_WINDOW, nExitCode)
*gl*      call GetModel
          natsSav = 0
*gl*      nats = natsOld
!--new
          leggi = 1
          call toMolPlo3(leggi)
          call RotazTot
          call GetBonds(1)
!--new
      endif
!
      if (iprin > 2) then
          call PrintAtoms
      endif
!
      if (javFourier == 1) then
          call LanciaJavFour
      endif
! mr
      if(natsSav == 0) then
         ier = 100
      endif
!
      return
    5 format(a,
     *         'Threshold = ',f6.1,a,
     *         'Rho max = ',f6.2,a,
     *         'Rho min =', f6.2,a,
     *         'Rms =',f6.2)
    6 format(a,
     *         'Rho max = ',f6.2,a,
     *         'Rho min =', f6.2,a,
     *         'Rms =',f6.2)
      end
! ----------------------------------------------------------------------
      subroutine RaggruppaNew()
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE PhaseModule
      USE LsqModule
!
      common /minma/ amin(3), amax(3)
      common /Distanze/ ndist, dis(300), nop(300), ifDist
!
      dimension cb(3), x1(3), r1(3), x2(3)
      dimension xn(11),xo(11),key(10)
      dimension nMat(200), nCen(200), ash(3)
      dimension iabc(3)
!
      nptr = 1
      NATTrue = NatMol
!
      Tra(1, 1) = 1
      Tra(2, 1) = 0
      Tra(3, 1) = 0
      Tra(1, 2) = 0
      Tra(2, 2) = 1
      Tra(3, 2) = 0
      Tra(1, 3) = 0
      Tra(2, 3) = 0
      Tra(3, 3) = 1
!
      iCentrato = 0
      nce = 0
      nit = 3
      do na = 1, natsOld+natsSav
         xyz(1, na) = xyzs(1, na)
         xyz(2, na) = xyzs(2, na)
         xyz(3, na) = xyzs(3, na)
         iEqui(na) = na
         nOpEq(na) = 1555
      enddo

      if (latt > 1) THEN
         call Centra(nce, Shf)
         iCentrato = -1
      end if
      It = ' '
      do 1100 nPicco=1, natsSav
         kptr(2) = nPicco + natsOld
         j = kptr(2)
         nptr = 2

         natot = natsOld + natsSav
         nagr = nptr - 1    ! n. di atomi per gruppo
         do n = 1, nSymMol
            selezione(n) = natot + 1
            nMat(n) = n
            nCen(n) = 0
            do i = 2, nptr
               na = kptr(i)
               call Ruota(n, na, cb, iabc, 1)
               idop = 0
               natot = natot + 1
               xyz(1, natot) = cb(1)
               xyz(2, natot) = cb(2)
               xyz(3, natot) = cb(3)
               iEqui(natot) = na
               nOpEq(natot) = n * 1000 + 555
               if (natot .eq. MaxAtomsInGr - NatSpi) goto 480
            enddo
         enddo
         selezione(nSymMol+1) = natot + 1
         IndIniz = nSymMol
         NatMol = natot
         if (iCentrato .ne. 0) THEN
            do n=1, nce
               do j=1, nSymMol
                  iSta = selezione(j)
                  iEnd = selezione(j + 1) - 1
                  IndIniz = IndIniz + 1
                  selezione(IndIniz) = natot + 1
                  nMat(IndIniz) = j
                  nCen(IndIniz) = n
                  do na=iSta, iEnd
                     call Trasl(Shf, n, na, cb, iabc, 1)
                     natot = natot + 1
                     xyz(1, natot) = cb(1)
                     xyz(2, natot) = cb(2)
                     xyz(3, natot) = cb(3)
                     iEqui(natot) = iEqui(na)
                     nnn=(n-1)*nSymMol+j       !RS--controllare!!!!!!!!!!!!!!!!!!!!!!
                     nOpEq(natot) = nnn * 1000  + 555
                     if (natot .eq. MaxAtomsInGr - NatSpi) go to 480
                  enddo
               enddo
            enddo
            selezione(IndIniz + 1) = natot + 1
         end if

         ngt = IndIniz
         natg = natot
         DistMin = 9999.
         n1 = kptr(1)
         do NumAtomo=1,natsOld
            n = NumAtomo
            x1(1) = xyz(1, n)
            x1(2) = xyz(2, n)
            x1(3) = xyz(3, n)
            call MoltMatVec(rm,x1,x2)
            do ic = -1, 1
               do ib = -1, 1
                  do ia = -1, 1
                     do ng=1, ngt
                        iSta = selezione(ng)
                        iEnd = selezione(ng + 1) - 1
                        Tra(1, 1) = ia
                        Tra(2, 1) = ib
                        Tra(3, 1) = ic
                        natot = natg
                        do na = iSta, iEnd
                           call Trasl(Tra, 1, na, cb, iabc, 0)
                           call MoltMatVec(rm,cb,r1)
                           dist = 0.
                           do ii=1, 3
                              Dist = Dist + (r1(ii) - x2(ii)) ** 2
                           enddo
                           if (Dist .lt. DistMin) then
                              DistMin = Dist
                              ngdm = ng
                              ash(1) = cb(1)   !ia
                              ash(2) = cb(2)   !ib
                              ash(3) = cb(3)   !ic
                              nvicino = n
                              dvicino = Dist
                           end if
                        enddo
                     enddo
                  enddo
               enddo
            enddo
         enddo
         xyz(1,natsOld+nPicco) = ash(1)
         xyz(2,natsOld+nPicco) = ash(2)
         xyz(3,natsOld+nPicco) = ash(3)
         It(nPicco) = ' '
         write(It(nPicco),'(i5)') nPicco  !   +natsOld
         It(nPicco)( 8:10) = '[I='
*gl*     write(It(nPicco)(11:15),'(i5)') nint(xyzs(4,natsOld+nPicco))
         write(It(nPicco)(11:15),'(f5.1)') xyzs(4,natsOld+nPicco)
         It(nPicco)(16:17) = ']-'
         It(nPicco)(18:25) = Lab(nvicino)
         It(nPicco)(26:31) = ' dmin='
         write(It(nPicco)(32:37),'(f6.3)') sqrt(dvicino)
         It(nPicco)(37:37) = char(0)
         nop(nPicco) = nvicino
         dis(nPicco) = bfac(nvicino)
 1100 continue
      iSta = selezione(ngdm)
      iEnd = selezione(ngdm + 1) - 1
*gl*  do na = 1, natsOld + natsSav
      do na = natsOld + 1, natsOld + natsSav
         cb(1) = xyz(1, na)
         cb(2) = xyz(2, na)
         cb(3) = xyz(3, na)
         xyzs(1, na) = xyz(1, na)
         xyzs(2, na) = xyz(2, na)
         xyzs(3, na) = xyz(3, na)
!
!-- check on special positions
!
         if (xyzs(5,na).lt.0.95) then
             xo(1) = xyzs(1,na)
             xo(2) = xyzs(2,na)
             xo(3) = xyzs(3,na)
             iser=na
             iactn=2
             khead=0
             ksp=kspecb(newvet,xo,xn,key,itype,iser,khead,iactn)
             xyzs(1,na) = xn(1)
             xyzs(2,na) = xn(2)
             xyzs(3,na) = xn(3)
         endif
         call MoltMatVec(rm,cb,r1)
         xyz(1, na) = r1(1)
         xyz(2, na) = r1(2)
         xyz(3, na) = r1(3)
      enddo
      do i=1,NatMol
         iOrd(i) = i
      enddo
!
  480 NatMol = natsOld + NatsSav
      nats = NatMol
!
      leggi = 1
      leggi = 0    ! gianluca 8/10/10
      call toMolPlo3(leggi)
      call RotazTot
      call GetBonds(1)
!
      Rmin1 = 99999.
      Rmin2 = 99999.
      RMAX1 = -99999.
      RMAX2 = -99999.
!
      return
      end
! ----------------------------------------------------------------------
      subroutine create_tables(Active)
      USE General
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension Active(9)
!
      call UpdateCommonAndList5(ier)
!
      nOpt = 4
      DistMin = Active(8)
      DistMax = Active(9)
      ncwuB = ncwu
      itype=1
      iform=1
      jop=jopen(jrel,' ',itype,iform,ier)
      if (jop.lt.0) go to 8000
      ncwu = jrel
      rewind jhost
      iCall = 0
      ifCallBr  = 0
      do 100 i=1,nOpt
         iActi = nint( Active(i) )
         if (iActi.ne.0) then
             if (i.eq.1) then   ! WEIGHTS
                 ifCallBr  = 1
                 jcod = -1
                 ncwu = jrel
                 write(Msg,31)
                 call PrintMess(Msg)
                 call wautoNEW(ier)
             else if (i.eq.2) then   ! ATOMS
                 ifCallBr  = 1
                 jcod = -1
                 ncwu = jrel
                 write(Msg,32)
                 call PrintMess(Msg)
                 call CaosPubl5NEW(jcod,ier)
             else if (i.eq.3) then
                 iCall = 1
                 write(jhost,"('save   ')")
                 write(jhost,"('atom   ')")
                 write(jhost,"('dist   ',2f8.3)") DistMin,DistMax
             else if (i.eq.4) then
                 iCall = 1
                 write(jhost,"('save   ')")
                 write(jhost,"('atom   ')")
                 write(jhost,"('angle  ',2f8.3)") DistMin,DistMax
             endif
         endif
  100 continue
   31 format ('Print tables of the weight ditribution')
   32 format ('Print table of the atomic parameters')
      if (iCall.eq.1) then
          write(jhost,"('end    ')")
          rewind jhost
          write(Msg,33)
          call PrintMess(Msg)
          jcod=0
          ncwu = jrel
          loSav = lo    ! PEZZA gianluca 05/05/2008
          lo = jrel
          jscre=0
          call CaosGeomNEW(jscre,jhost,ier,jcod)
          lo = loSav
      endif
   33 format ('Print table of distances/angles')
      if (ier.lt.0) then
          ier = 0
      else
          if ( (ifCallBr+iCall) .gt. 0 ) then
              kBro = 6
              call BrowserV2(kBro)
          endif
      endif
      close(jrel)
      ncwu = ncwuB
      rewind jhost
!
      return
!
 8000 write(Msg,8100) ier
      call MsgWinErr('ERROR', Msg, SEVERE_ERR_WINDOW, nExitCode)
 8100 format(' *** open error CreateTables ***  code =',i5)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine UpdateCommonAndList5(ier)
      USE General
      USE Atomi
      USE Molcom
      USE PhaseModule
      USE LsqModule
!
!-- applies modifications to model
!-- deletes ghosts
!
      ier = 0           !!mr
      if (nats.le.0 .or. NatInd < = 0) then
          return
      endif


      call CheckGhosts(ier)  ! gianluca 14/01/2016

      return   ! gianluca 25/03/2015

      if (ifSkeletonOn == 1) then
          call LeggiSkeleton(1)
      endif
!
!-- check on ghosts
!
      call CheckGhosts(ier)
      if (ier < 0) return
!
!      
*     do i=1,nats
*        if (nz(i).eq.0) then
*            RS(i) = -100.0
*        endif
*     enddo
      jrests = 0
      call ModCom(jrests)
      do i=nats+1,MaxAtoms
         aLab(i) = ' '
      enddo

      call PutModel
!
      natsGTK = nats
!
      do i=1,nats
         k = iabs(nz(i)) / nzConst
         if (k > 0 .and. k <= 18) then
             nzHydro(i) = no(k)
         endif
      enddo
!
      if (jscreen > 0) then
          call ChiudiCompare()    ! gl   20/06/09
          ifViewModel = 0
*gl*      BTot(:,:) = 0 ; BTot(1,1) = 1 ; BTot(2,2) = 1 ; BTot(3,3) = 1
          call Disegna(ifScale)   ! dedi 12/03/09
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine CheckGhosts(ier)
      USE General
      USE Atomi
      USE Molcom
!
      implicit none
!
      integer im, lm, ier, ndel, i, Lung, nExitCode
!
!-- check on ghosts
!
      ier = 0
!     return   ! commentato gianluca 14/01/2016
!
      Inte = ' '
      im = 1
      ier = 0
      ndel = 0
      do i=1, nats
         if (nz(i) == 0 .and. RS(i) > -10.0) then
             ndel = ndel + 1
             if (ndel < 4) then
                 Inte(im:im+8) = Lab(i)(1:8) // ','
                 im = im + 9
             elseif (ndel == 4) then
                 Inte(im:im+2) = '...'
                 im = im + 2
             endif
         endif
      enddo
      if (ndel > 0) then
          if (ifMadEnv == 0) then
              Msg = ' '
              call NoBlanks(Inte, im)
              if (ndel <= 3) then
                  Inte(im:im) = '.'
                  im = im + 1
              endif
              write(Msg,"('There are ',i6)") ndel
              call Shift(Msg(11:16), lm)
              lm = Lung(Msg)
              Msg(lm+1:) = ' ghosts in the model:'
              lm = Lung(Msg)
              Msg(lm+1:) = Inte(1:im)
              lm = Lung(Msg)
              Msg(lm+1:) = char(10) // 
     *                 'To retain them an atomic species must be ' //
     *                 'assigned.' // char(10) // char(10) //
     *                 'Do you want to delete them ?'
              call MsgWinErr('WARNING', Msg, QUEST_WINDOW_YES_NO, 
     *                       nExitCode)
              Msg = ' '
              if (nExitCode == 2) then
                  ier = -1
                  return
              else
                  call EliminaGhost(1)
                  call AggiornaJav()  ! gianluca 14/01/2016
              endif
          else
              call EliminaGhost(1)
          endif
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine EliminaGhost(ifPlot)
      USE General
      USE Atomi
      USE Molcom
!
      implicit none
      integer :: i, j, k, i1, i2, nBonds, nB, kplot, ifSingle, interp
      integer :: ifPlot
!
      nzTot(1:nats) = 0
      j = 0
      do i=1, nats
         if (iabs(nz(i)) > 0 .and. RS(i) > -10.0) then
             j = j + 1
             xyzs(:,j) = xyzs(:,i)
             nz(j)     = nz(i)
*            nzTot(j)  = nzTot(i)
             nzTot(i)  = j
             bfac(j)   = bfac(i)
             aLab(j)   = aLab(i)
             serial(j) = serial(i)
         endif
      enddo
      nats = j
!
      nBonds = iconn(1)
      if (nBonds > 0) then
          nB = 0
          k = 1
          j = 1
          do i=1, nBonds
             i1 = iconn(j+1)
             i2 = iconn(j+2)
             if (nzTot(i1) > 0 .and. nzTot(i2) > 0) then
                 nB = nB + 1
                 iconn(k+1) = nzTot(i1)
                 iconn(k+2) = nzTot(i2)
                 iconn(k+3) = iconn(j+3)
                 k = k + 3
             endif
             j = j + 3
          enddo
          iconn(1) = nB
      endif
!
      do i=1, nats
         nzTot(i) = iabs(nz(i)) / nzConst
      enddo
!
      interp = 1
      call PutGetXyzs(1, interp)
      call PutModel
!
*gl*  BTot(1,1) = 101     22/12/2010 gianluca
!
      if (ifPlot == 1) then
          kplot = SIMPLE
          kplot = iPlotType
          ifSingle = 0
          call MolPlo(kplot, ifSingle)
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine init_restraints(ier)
      USE General
      USE Molcom
      USE PhaseModule
      USE LsqModule
!
      character*8 LabN
      integer :: ier
!
      ier = 0
      if (nrefl == 0) then
          write(Msg,140)
  140     format('No restraints can be set, no reflections supplied.')
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          ier = -1
          return
      endif
      call UpdateCommonAndList5(ier)
!
      nresSav = nres
      vresSav = vres
!
      ifDrResSav = ifDrRes
      ifDrRes = 1
      call Disegna(0)
      nresGTK = nres
      natsGTK = NatMol
      vresGTK = vres
!
      do i=1, NatMol
         L = Lung(Lab(i))
         LabN = Lab(i)
         AtomsGTK(i) = LabN(1:Lung(LabN))
      enddo
      AtomsGTK(501) = char(0)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine drwrstr()
      USE LsqModule
!
!-- draw restraints during their definitions trough GUI
!
      nres = nresGTK
      vres = vresGTK
      call Disegna(0)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine BackFromGTK(kstampa)
      USE General
      USE Molcom
      USE PhaseModule
      USE LsqModule
!
!-- kstampa = 0  Transfer data from GTK area to standard area
!--         = 1  Transfer data from GTK area to standard area
!--              and produce a print of relationhips
!--         = 2  Transfer data from standard area to GTK area
!--              and (??) no produce a print of relationhips
!
      dimension vet(500)
      character *100 line
      character  It1(15)*6
      data It1 /'    X ','    Y ','    Z ','B[iso]',
     2          '    11','    12','    13','    22',
     3          '    23','    33','   Occ','  Occ1',
     4          '  Occ2','  Occ3','  Occ4'/
!
      if (kstampa.eq.2) then
          nresGTK = nres
          vresGTK = vres
      endif
!
c      write(lo,*) 'nresGTK',nresGTK
c      write(lo,*) 'vresGTK',(vresGTK(i),i=1,20)
      nres=nresGTK           ! ??????????????????????????????
      if (nresGTK.le.0) return
!
      if (kstampa.eq.1) then
          write(lo,5)
      endif
      jpn = 0
      do kk =1,7
         jp = 0
         iflag = 0
         do i = 1 , nresGTK
            jp = jp + 1
            icode = nint(vresGTK(jp))
            natom = nint(vresGTK(jp+1))
            incr=3
            if (icode.eq.5) then
                nparams = nint( vresGTK(jp+3) )
            else
                nparams = 0
            endif
            if (icode.eq.6) incr=4
            if (icode.eq.kk) then
                sigma = vresGTK(jp+2)
                dista = vresGTK(jp+3)
c--		write(lo,*) kk,jp,icode,natom,incr,nparams,sigma,dista
                select case (icode)
                    case (1)                 ! distances
                        jjfin = jp + 4 + natom - 1
                        if (iflag.eq.0.and.kstampa.eq.1) then
                            write(lo,10)
                            iflag =1
                        endif
                        do jj=jp,jjfin
                           jpn = jpn + 1
                           vres(jpn) = vresGTK(jj)
                        enddo
                        if (kstampa.eq.1) then
                            write(lo,100) sigma,dista,
     *                           (Lab(nint(vresGTK(jj))),jj=jp+4,jjfin)
                        endif
                    case (2)                 ! angle
                        jjfin = jp + 4 + natom - 1
                        if (iflag.eq.0.and.kstampa.eq.1) then
                            write(lo,20)
                            iflag =1
                        endif
                        do jj=jp,jjfin
                           jpn = jpn + 1
                           vres(jpn) = vresGTK(jj)
                        enddo
                        if (kstampa.eq.1) then
                            write(lo,100) sigma,dista,
     *                           (Lab(nint(vresGTK(jj))),jj=jp+4,jjfin)
                        endif
                    case (3)                 ! torsion angle
                        jjfin = jp + 4 + natom - 1
                        if (iflag.eq.0.and.kstampa.eq.1) then
                            write(lo,25)
                            iflag =1
                        endif
                        do jj=jp,jjfin
                           jpn = jpn + 1
                           vres(jpn) = vresGTK(jj)
                        enddo
                        if (kstampa.eq.1) then
                            write(lo,100) sigma,dista,
     *                           (Lab(nint(vresGTK(jj))),jj=jp+4,jjfin)
                        endif
                    case (4)                 ! plane
                        jjfin = jp + 4 + natom - 1
                        if (iflag.eq.0.and.kstampa.eq.1) then
                            write(lo,30)
                            iflag =1
                        endif
                        k = 0
                        do jj =jp+4,jjfin
                           k = k + 1
                           vet(k) = vresGTK(jj)
                        enddo
                        call sortall(1,vet,k)
                        do jj=jp,jp+3   
                           jpn = jpn + 1
                           vres(jpn) = vresGTK(jj)
                        enddo
                        do jj=1,k
                           jpn = jpn + 1
                           vres(jpn) = vet(jj)
                        enddo
                        if (kstampa.eq.1) then
!			     if (natom.ne.nats) then
!  da mettere in funzione quando Riccardo si adegua
                            if (natom.gt.0) then
                                jpp = jpn - natom + 1
                                jjfin = jpp + natom -1
                                write(lo,200) sigma,
     *                               (Lab(nint(vres(jj))),jj=jpp,jjfin)
                            else
                                write(lo,400) sigma
                            endif
                        endif
                    case (5)                 ! sum
                        line = ' '
                        nparams =  nint( vresGTK(jp+3) )
                        jjfin = jp + 4 + nparams + natom - 1
                        if (iflag.eq.0.and.kstampa.eq.1) then
                            write(lo,40)
                            iflag =1
                        endif
                        k = 0
                        do jj =jp+4+nparams,jjfin
                           k = k + 1
                           vet(k) = vresGTK(jj)
                        enddo
                        call sortall(1,vet,k)
                        do jj=jp,jp+3+nparams   
                           jpn = jpn + 1
                           vres(jpn) = vresGTK(jj)
                        enddo
                        jpp = jpn - nparams + 1
                        do jj=1,k
                           jpn = jpn + 1
                           vres(jpn) = vet(jj)
                        enddo
                        if (kstampa.eq.1) then
                            write(line,600) (It1(nint(vres(jj))),
     *                                       jj=jpp,jpp+nparams-1)
                            lline = 0
                            call onebl(line,lline,ier)
                            jpp = jpp + nparams
                            if (natom.eq.0) then
                                write(lo,360) sigma,line(1:12)
                            else
                                jjfin = jpp + natom -1
                                if (lline.le.12) then
                                    write(lo,300) sigma,line(1:12),
     *                               (Lab(nint(vres(jj))),jj=jpp,jjfin)
                                else
                                    write(lo,350) sigma,line(1:lline),
     *                               (Lab(nint(vres(jj))),jj=jpp,jjfin)
                                endif
                            endif
                        endif
                    case (6)         ! limit
                        sigma1 = vresGTK(jp+4)
                        jjfin = jp + 5 + natom - 1
                        if (iflag.eq.0.and.kstampa.eq.1) then
                            write(lo,50)
                            iflag =1
                        endif
                        k = 0
                        do jj =jp+5,jjfin
                           k = k + 1
                           vet(k) = vresGTK(jj)
                        enddo
                        call sortall(1,vet,k)
                        do jj=jp,jp+4
                           jpn = jpn + 1
                           vres(jpn) = vresGTK(jj)
                        enddo
                        do jj=1,k
                           jpn = jpn + 1
                           vres(jpn) = vet(jj)
                        enddo
                        if (kstampa.eq.1) then
                            if (natom.gt.0) then
                                jpp = jpn - natom + 1
                                jjfin = jpp + natom -1
                                write(lo,550) sigma,dista,sigma1,
     *                               (Lab(nint(vres(jj))),jj=jpp,jjfin)
                            else
                                write(lo,500) sigma,dista,sigma
                            endif
                         endif
                    case (7)                 ! site
                        jjfin = jp + 4 + natom - 1
                        if (iflag.eq.0.and.kstampa.eq.1) then
                            write(lo,23)
                            iflag =1
                        endif
                        do jj=jp,jjfin
                           jpn = jpn + 1
                           vres(jpn) = vresGTK(jj)
                        enddo
                        if (kstampa.eq.1) then
                            write(lo,100) sigma,dista,
     *                           (Lab(nint(vresGTK(jj))),jj=jp+4,jjfin)
                        endif
                end select
            endif
            jp = jp + nparams + natom + incr
         enddo
      enddo
      if (kstampa.eq.1) then
          write(lo,*)
      endif
!
    5 format(//,' List of restraints ')
   10 format(/,' on Distance  ESD    Distance   Atoms')
   20 format(/,' on Angle     ESD    Angle      Atoms')
   23 format(/,' on Site      ESD    Angle      Atoms')
   25 format(/,' on Tors.Ang. ESD    Angle      Atoms')
   30 format(/,' on Plane     ESD               Atoms')
   40 format(/,' on Sum       ESD    Parameters Atoms')
   50 format(/,' on Limit  ESD(x) ESD(B) ESD(bij) Atoms')
  100 format(10x,f9.5,f8.3,5x ,5a8,100(/,32x,5a8))
  200 format(10x,f9.5, 8x ,5x ,5a8,100(/,32x,5a8))
  300 format(10x,f9.5,1x,a12, 5a8,100(/,32x,5a8))
  350 format(10x,f9.5,1x,a,       100(/,32x,5a8))
  360 format(10x,f9.5,1x,a,    'All Atoms')
  400 format(10x,f9.5, 8x ,5x ,'All Atoms')
  500 format(10x,3f7.4        ,'All Atoms')
  550 format(10x,3f7.4,     100(/,32x,5a8))
  600 format(15(2x,a6))
!
      return
      end
!-----------------------------------------------------------------------
      subroutine DrawRestraints
      USE General
      USE Atomi
      USE Molcom
      USE LsqModule
!
!-- draws the graphic representation of restraints coded as:
!
c
c             nres         = number of restraints
c             vres         = array containing restraints
c
c   restraint code         = 1 DISTANCE
c                            2 ANGLE
c                            3 TORSION
c                            4 PLANE
c                            5 SUM
c                            6 LIMIT
c                            7 SITE
c                            8 DISORDER
c
c   vres(jp)               = restraint code
c   vres(jp+1)             = number of atoms involved 
c   vres(jp+2)             = sigma
c   vres(jp+3)             = distance              if DISTANCE
c                            angle                 if ANGLE
c                            angle di torsione     if TORSION
c                            zero                  if PLANE
c                            number of parameters  if SUM
c
c   vres(jp+4....)         = parameters codes only if SUM
c   vres(jp+4[+params]...) = atoms codes
c
      integer O1,O2, XX1, YY1, XX2, YY2, XX3, YY3
!
      if (nres.eq.0) return
!
      do i = 1 , (NatMol + NatSpi) - 1
         do k = i + 1 , NatMol + NatSpi
            O1 = iOrd(i)
            O2 = iOrd(k)
            O3 = xyz(3,O1)
            O4 = xyz(3,O2)
            IF (O3.GT.O4) THEN
               iOrd(i) = O2
               iOrd(k) = O1
            endif
         enddo
      enddo
!
      iColRestr = color_RESTR
      jp = 0
      do i = 1 , nres
         jp = jp + 1
         icode = nint(vres(jp))
!
         select case (icode)
!
            case (1)                 ! distances

                 N1    = nint(vres(jp+4))
                 N2    = nint(vres(jp+5))
                 jp = jp + 5
                 if (RS(N1).GT.0.and.RS(N2).GT.0) then
                     XX1 = ipix(1,N1)
                     XX2 = ipix(1,N2)
                     YY1 = ipix(2,N1)
                     YY2 = ipix(2,N2)
                     call Linea(XX1, YY1, XX2, YY2 , iColRestr)
                 endif

            case (2)                 ! angles 

                 N1    = nint(vres(jp+4))
                 N2    = nint(vres(jp+5))
                 N3    = nint(vres(jp+6))
                 jp = jp + 6
                 if (RS(N1).GT.0.and.RS(N2).GT.0.and.RS(N3).GT.0) then
                     XX1 = ipix(1,N1)
                     XX2 = ipix(1,N2)
                     XX3 = ipix(1,N3)
                     YY1 = ipix(2,N1)
                     YY2 = ipix(2,N2)
                     YY3 = ipix(2,N3)
                     ix12 = ( XX1 - XX2 ) / 3  + XX2
                     iy12 = ( YY1 - YY2 ) / 3  + YY2
                     ix23 = ( XX3 - XX2 ) / 3  + XX2
                     iy23 = ( YY3 - YY2 ) / 3  + YY2
                     call Linea( XX2,  YY2, ix12, iy12 , iColRestr)
                     call Linea( XX2,  YY2, ix23, iy23 , iColRestr)
                     call Linea(ix12, iy12, ix23, iy23 , iColRestr)
                 endif

            case (3)                 ! torsion angles 
                 N1    = nint(vres(jp+4))
                 N2    = nint(vres(jp+5))
                 N3    = nint(vres(jp+6))
                 N4    = nint(vres(jp+7))
                 jp = jp + 8

            case (4)                 ! plane 
            
                     n =nint(vres(jp+1))
                     do j=1,n
                        N1 = nint(vres(jp+4+j-1))
                        XX1 = ipix(1,N1)
                        YY1 = ipix(2,N1)
                        if (iPlotType.eq.STICKS) then
                            ira=3
                        else 
                            ira=5
                        endif
                        IfF = 0
                        Call Cerchio(XX1, YY1, ira, iColRestr, IfF,
     *                                iColRestr)
                        ix1 = XX1 - ira
                        iy2 = YY1 + 2 * ira
                        call Linea(ix1, YY1, ix1, iy2 , iColRestr)
                     enddo
                     jp = jp + n + 3

            case (5)                 ! sum 
            
                     n    = nint(vres(jp+1))
!mr                  nparx = nint(vres(jp+4))
                     nparx = nint(vres(jp+3))

                     if (n < nats) then
                         do j=1,n
                            N1 = nint(vres(jp+4+nparx+j-1))
                            XX1 = ipix(1,N1)
                            YY1 = ipix(2,N1)
                            if (iPlotType.eq.STICKS) then
                                ira=3
                            else
                                ira=5
                            endif
                            IfF = 0
                            Call Cerchio(XX1, YY1, ira, iColRestr, IfF, 
     *                                   iColRestr)
                            ix1 = XX1 - ira
                            ix2 = XX1 + ira
                            call Linea(ix1, YY1, ix2, YY1 , iColRestr)
                            iy1 = YY1 - ira
                            iy2 = YY1 + ira
                            call Linea(XX1, iy1, XX1, iy2 , iColRestr)
                         enddo
                     endif

                     jp = jp + nparx + n + 3

            case (7)                 ! site
            
                 N1    = nint(vres(jp+4))
                 jp = jp + 4
                 XX1 = ipix(1,N1)
                 YY1 = ipix(2,N1)
                 if (iPlotType.eq.STICKS) then
                     ira=3
                 else
                     ira=5
                 endif
                 IfF = 0
                 Call Cerchio(XX1, YY1, ira, iColRestr, IfF, 
     *                        iColRestr)
                 ix1 = XX1 - ira
                 ix2 = XX1 + ira
                 call Linea(ix1, YY1, ix2, YY1 , iColRestr)
                 iy1 = YY1 - ira
                 iy2 = YY1 + ira
                 call Linea(XX1, iy1, XX1, iy2 , iColRestr)

            case (8)                 ! disorder

                 n    = nint(vres(jp+1))
                 jp = jp + 1
                 do j=1, n
                    N1 = nint(vres(jp+1))
                    N2 = nint(vres(jp+2))
                    XX1 = ipix(1,N1)
                    YY1 = ipix(2,N1)
                    XX2 = ipix(1,N2)
                    YY2 = ipix(2,N2)
                    call Linea_dash(XX1, YY1, XX2, YY2, iColRestr)
                    jp = jp + 2
                 enddo
         end select
      enddo
!
      return
      end
!----------------------------------------------------------------------
      subroutine MarkAtomsV2 (iAction, nBlock, cVector)
      USE Molcom
      USE LsqModule
!
!-- iAction = 1     Fix
!           = 2     Iso
!           = 3     Isoniso
!           = 4     Block definition
      integer Angolo
      integer cVector(500)
!---
      Angolo = 0
      IfScale= 0
      call Disegna(ifScale)
!
      do 20 i=1, NatMol
         iOK = 0
         if (iAction .eq. 1) then                       ! Fix
            if (cVector(i) .eq. 0) then
               iOK = 1
            end if
         else if (iAction.eq.2 .or.iAction.eq.3) then    ! Iso / Aniso
            if (iand(cVector(i), nBlock).ne.0) then
               iOK = 1
            end if
         else if (iAction.eq.4) then                    ! Block definition
            if (iand(cVector(i), nBlock).ne.0) then
               iOK = 1
            else
               do ig=1,10
                  iw = 2**(ig+3)
                  if (iand(cVector(i), iw).ne.0) then
                     IDum = color_RESTR
                     ifF = 0
                     ixx = ipix(1,i)
                     iyy = ipix(2,i)
                     call Cerchio(ixx,iyy,4,iDum,IfF,iDum)
                  end if
               enddo
            end if
         end if
         if (IOK .eq. 1) then
            ixx = ipix(1,i)
            iyy = ipix(2,i)
            call Linea(ixx-6, iyy-6, ixx+6, iyy+6, color_RESTR)
            call Linea(ixx-6, iyy+6, ixx+6, iyy-6, color_RESTR)
         end if
   20 continue
!---
      return
      end
! ----------------------------------------------------------------------
      subroutine GetSiteConditions(jy, nSpecInSite, occs, Lspecie)
!--routine chiamata da spec2006.f e xfin2006.f      
      USE General
      USE Atomi
      USE LsqStuff
      USE LsqModule
!
      common /ifLiXX/ ifLi04,ifLi05,ifLi06,ifLi12
      character*(*) Lspecie(5)
      real occs(5)
!
c--check if mixed atoms
            if (iSite(jy) > 0) then
               imix=iSite(jy)
               do jj=1, imix
c--pick up the form factors for mixed atoms
                  nSpecInSite = nSpecInSite + 1
                  ksp1 = int(SiteInfo(jj,jy)) / 10    ! specie
                  Lspecie(nSpecInSite)=species(ksp1)
                  call ucase(Lspecie(nSpecInSite)(1:1))
                  occs(nSpecInSite) = amod(SiteInfo(jj,jy),10.0)   ! occupazione
               enddo
            endif
!
      return
      end      
!-----------------------------------------------------------------------
!--routine Map Fourier
!-----------------------------------------------------------------------
      subroutine DifferenceFourier(ier)
      USE General
      USE Atomi
      USE LsqModule
      USE xfourx
!
      write(*,*) 'DifferenceFourier'
      iCoef   = 3
      javFourier = -1    ! RS
      KindFourier = -1   ! RS
!modhh
*     nPeaksF = 10
*     levelFourier = 10
!      nPeaksF = 50          
!      levelFourier = 1      
      nPeaksF = 30  ! dedi prova
      levelFourier = 1
!modhh
      call FOURlink(ier, 0)
!
      return
      end
!----------------------------------------------------------------------
      subroutine finishfourier(notSav)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE PhaseModule
      USE LsqModule
      USE xfourx
!
      integer notSav
!
      common /Distanze/ ndist, dis(300), nop(300), ifDist
!
      if (notSav.eq.0) then
          notSav = 0
          do i=1,natsSav
             k = NatsOld + i
             if (nzTot(k) == PiccoFour) then
                 notSav = notSav + 1
             end if
          enddo
      else
          notSav = 0
      endif
      if (notSav .eq. 0) then
*gl*          kact=4
*gl*          jComplete = 2
*gl*          iconn(1) = -1
*gl*          call build(kact, jComplete)
*gl*      call PutModel
          ifFour = 0
          ndel = 0
          do i=1,natsSav + NatsOld
             rMLU(i) = i
          enddo
          do i=1,natsSav
             k = NatsOld + i
             if (nzTot(k) == PiccoFour) then
                 rMLU(k) = -99.9
                 ndel = ndel + 1
                 iAction = 2
             else
                 rMLU(k) = k - ndel
                 iAction = 0
                 do j=1,5
                    VetChanges(j) = xyzs(j,k)
                 enddo
                 VetChanges(6) = bfac(k) ! biso
                 if (iCoef.eq.3) then
                     VetChanges(4) = xyzs(4,k)/xyzs(4,NatsOld+1)
                     VetChanges(4) = VetChanges(4) * heimin
                 end if
             end if
             Labb = aLab(k)
             lnz = iabs(nz(k)/nzConst)
             if (lnz ==1 .and. no(1) == 1) then
                 VetChanges(6) = VetChanges(6) * 1.3
             endif
             kk = k - ndel + 1
             call ModModel(kk,iAction,Labb,lnz,VetChanges)
          enddo
!
!-- update connectivity (if necessary)
!
          iAction = 100
          i       =   0
          Labb    = ' '
          call ModModel(i,iAction,Labb,lnz,VetChanges)
!
!-- update SinglePlotType ALWAYS !!!!
!
          iAction = 200
          j       =   0
          Labb    = ' '
          call ModModel(j,iAction,Labb,lnz,VetChanges)
!
          if (nats > NatsOld) then    ! gianluca 28/02/07  - 09/12/2008
*gl*          call leggiatomi(SumColor)
              call ManageFourierAtoms(NatsOld)
              call GetModel
              if (KindFourier /= -1) then
                  kblock(1:nats) = 1
              endif
              kact=5
              jComplete = 2
              call build(kact, jComplete)
!
              iAction = 100
              i       =   0
              Labb    = ' '
              call ModModel(i,iAction,Labb,lnz,VetChanges)
              iAction = 200
              j       =   0
              Labb    = ' '
              call ModModel(j,iAction,Labb,lnz,VetChanges)
              do i=2,iconn(1),3
                 j = iconn(i)
                 nz(j) = iabs(nz(j))
                 j = j + 1
                 nz(j) = iabs(nz(j))
              enddo
              call PutModel
          endif
!
          leggi = 1
          call toMolPlo3(leggi)
          call GetBonds(1)
          call RotazTot
          ifScale = 1
          call Disegna(ifScale)
      endif
!
      return
      end
!----------------------------------------------------------------------
      subroutine ManageFourierAtoms(NatsOld)
      USE General
      USE RemoModule
      USE Atomi
!
      implicit none
      integer :: NatsOld, natom, i, k, lnz, isn, seriale(18), Lung
      character (len=17) :: Buffer
!
      seriale(:) = 0
      natom = natsInModel(WhichModel)
      do i=1, NatsOld
         lnz = model(WhichModel)%specie(i,1) /nzConst
         isn = model(WhichModel)%serial(i)
         if (isn > seriale(lnz)) then
             seriale(lnz) = isn
         endif
      enddo
      do i=NatsOld+1, natom
         lnz = model(WhichModel)%specie(i,1) /nzConst
         seriale(lnz) = seriale(lnz) + 1
         isn = seriale(lnz)
         model(WhichModel)%serial(i) = isn
         Buffer = Species(lnz)
         call ucase(Buffer(1:1))
         k = Lung(Buffer) + 1
         write(Buffer(k:k+4),'(i5)') isn
         call NoBlanks(Buffer, k)
         model(WhichModel)%Label(i) = Buffer(1:k)
         model(WhichModel)%th_fact(i,1) = bt
      enddo
!
      return
      end
c---------------------------------------------------------
c  routine per gestire i gruppi in memoria
c---------------------------------------------------------
c
code for input_res
      subroutine input_res(typo,ResMatIn,ResMatOut,ResAngle,ngru,ier)
c--genera coordinate nella cella del gruppo input
c  typo = lettera identificativa del residuo
c  ResMatIn = matrice contenente coordinate (parziali) attuali
c  ResMatOut = matrice contenete le coordiante di tutto il residuo
c  ResAngle = vettore con tre angoli di rotazione
c          (1:3) iniziali; (4:6) correnti
c  ier error code
c--creazione delle tabelle dei residui nel file "xfin2006.f"
c      subroutine FillResiduesTables()
c
c--in common 'zetacom.fi' 
c  t_ortho(3,3) matrice di trasformazione da spazio cristalino a 
c               spazio di riferimento ortonormale monometrico del modello 
c  x_orig(3)  origine nello spazio cristallino
c  t_cryst(3,3) matrice di trasformazione da spazio di riferimento
c              ortonormale monometrico del modello a spazio cristallino
c--in common pltcom.fi
c  tm(3,3)    
c  per portare un atomo x(3) esterno al modello nello stesso riferimento
c  monometrico del modello X(3):
c  x0(3) = x(3) - x_orig(3)
c  X(3)= x0(3) . t_ortho(3,3)
c
c  per portare un atomo X(3) del modello nello spazio cristallino x(3):
c  x0(3)= X(3) . t_cryst(3,3)
c  x(3) = x0(3) + x_orig(3)
c
      USE General
      USE Molcom
      USE Groups
      USE Plotter
      USE ZMatrix
!
      character*1 typo,Am1
      dimension ResMatIn(6,15),ResMatOut(6,15),ResAngle(6)
      dimension ResMatInC(3,15),ResMatOutC(3,15)
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xchar/id,ie,ib,icc,ia,ih,numb(10),iplus, inus,ipoint
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20)
      character chresx*1,chname*4
      common/workgroupX/ngruTot,jnumx(40),jaddrx(40),chresx(40),
     *  chname(40),jTabGru(80,300)
c     
      dimension xmatr(3,3),xx1(3),xx2(3),ori(3,3),oria(3,3)
      dimension x1(3),xr(3),x0(3)
c
c--azzera alcune variabili      
      itest=0
      ier=0
c--passo metriche nelle matrici in PLOTTER da GENERAL
      gdd=xgg
      grr=xgr     
      vd=volume
      vr=1.0/volume
c
c--find the residuo richiesto
      do ja=1,nResid
         Am1 = char(ResidTable1(ja,2))
         if(typo.eq.Am1) then
         ngru=ja
         goto 1000
         endif
      enddo   
      write(ncwu,9010) typo
9010  format( /,' Required group not found for ',a1,/)
      ier=1
      return
c
c--residuo trovato
1000  continue
      ncard=ResidTable1(ngru,1)
c      write(lo,*) 'ncard,iadr',ncard,iadr
c--recupero coordinate z-matrix      
      do jj=1,ncard
        iloc(jj)=jj
        xloc(1:3,jj)=ResidTable2(ngru,1:3,jj) 
        nloc(1:3,jj)=ResidTable2(ngru,4:6,jj) 
      enddo
        if(itest.ge.1) then
          write(ncwu,*)' coordinate da Z-matrix',ncard
          do ja=1,ncard
           write(lo,61) iloc(ja),(nloc(n,ja),xloc(n,ja),n=1,3)
   61      format(2x,i5,3(i5,f10.3))
          enddo
        endif
c--recupero e ortogonalizzo coordinate input
c--1 e' l'origine
c  2 e' l'asse x
c  3 fornisce il piano dove calcolare l'asse y
        loo=1
        lx =2
        ly =3
c--salvo coordinate dell'origine
        x_orig(1:3)=ResMatIn(1:3,loo)
        do ja=1,ncard
        ResMatInC(1:3,ja)=ResMatIn(1:3,ja)
        enddo
        call OrtoGru(ncard,ResMatInC,ResMatOutC,loo,lx,ly,15)
        do ja=1,ncard
        ResMatOut(1:3,ja)=ResMatOutC(1:3,ja)
        enddo        
c--inizio test delle trasformazioni di base
        do ja=1,ncard
         ResMatIn(4:6,ja)= ResMatOut(1:3,ja)
        enddo
        if(itest.ge.1) then
        write(ncwu,*)' coordinate ortogonali nel nuovo riferimento'
        do ja=1,ncard
         write(ncwu,'(10f10.5)') ResMatOut(1:3,ja)
        enddo
        endif
c  la matrice e' la trasposta della matrice che definisce la nuova base: tm
!        call trasp(tm,t_cryst)
        if(itest.eq.2) then
c--passando di qui il test finisce qui
c  inizio trasformazione delle coordinate atomiche
          write(ncwu,*)' matrice 3)'
          do i=1,3
            write(ncwu,'(3f10.4)')(t_cryst(i,j),j=1,3)
          enddo
          do ja=1,ncard
            x1(1:3)=ResMatOut(1:3,ja)
            call orcor(x1(1),x1(2),x1(3),t_cryst,xr(1),xr(2),xr(3))
            ResMatOut(1:3,ja)=xr(1:3)+x_orig(1:3)
         enddo
          write(ncwu,*)' coordinate ripristinate originali'
          do ja=1,ncard
            write(ncwu,'(10f10.5)') ResMatOut(1:3,ja)
          enddo
          return
        endif
c--fine test delle trasformazioni di base
c--definisco le informazioni per la z-matrix routine
        nzm=ncard
        call zmatr_new(ier)
        if(itest.ge.1) then
          write(ncwu,*)' coordinate locali da Z-matrix ordinate'
          do ja=1,ncard
            write(ncwu,'(10f10.5)') (xortolocal(n,ja),n=1,3)
          enddo
        endif  
c--riporto le coordinate in cella
        do ja=1,ncard
          ResMatOut(4:6,ja)=xortolocal(1:3,ja)
          xx1(1:3)=xortolocal(1:3,ja)
          call moltv(t_cryst,xx1,xx2)
          ResMatOut(1:3,ja)=xx2(1:3)+x_orig(1:3)
        enddo
        if(itest.ge.1) then
          write(ncwu,*)' coordinate finali'
          do ja=1,ncard
            write(ncwu,'(10f10.5)') ResMatOut(1:3,ja)
          enddo
        endif
c--
c	    write(lo,*) ' rm(i,j)'
c	    write(lo,'(1x,3f10.4,/)') ((rm(i,j),j=1,3),i=1,3)
c	    write(lo,*) ' rmi(i,j)'
c	    write(lo,'(1x,3f10.4,/)') ((rmi(i,j),j=1,3),i=1,3)
c--
c--orient [B] = Trasf x (orthogonal)-1 = [UB]*[U]-1
        call prodm(rm,t_cryst,ori)
c       write(lo,*) ' ori(i,j)'
c       write(lo,'(1x,3f10.4)') ((ori(i,j),j=1,3),i=1,3)
c       call deter3(ori,det)
c       write(ncwu,*)' deter:',det

c--calcolo angoli euleriani
        isex=1.0
        if(ori(3,3).lt.0.0) isex=-1.0
        xa=abs(ori(3,3))
        iarc=0
        if(xa.lt.0.0) xa=0.0
        if(xa.ge.1.0) then
          xa=1.0
          iarc=1
        endif
        ori(3,3)=isex*xa
        theta=acos(ori(3,3))
        sintheta=sqrt(1-ori(3,3)*ori(3,3))
        if(iarc.eq.0) then
          sinphi=ori(3,1)/sintheta
          cosphi=-ori(3,2)/sintheta
          phi=asin(sinphi)
          ichange=0
          if(sinphi.gt.0.0.and.cosphi.lt.0.0) ichange=1
          if(sinphi.lt.0.0.and.cosphi.lt.0.0) ichange=1
          if(ichange.eq.1) then
             phi=pi-phi
          else if(sinphi.lt.0.0.and.cosphi.gt.0.0) then
             phi=twopi+phi
          endif
          sinpsi=ori(1,3)/sintheta
          cospsi=ori(2,3)/sintheta
          psi=asin(sinpsi)
          ichange=0
          if(sinpsi.gt.0.0.and.cospsi.lt.0.0) ichange=1
          if(sinpsi.lt.0.0.and.cospsi.lt.0.0) ichange=1
          if(ichange.eq.1) then
             psi=pi-psi
          else if(sinpsi.lt.0.0.and.cospsi.gt.0.0) then
             psi=twopi+psi
          endif
        else
c--vanno controllati i valori in casi particolari
        endif
        ResAngle(1)=theta*rtd
        ResAngle(2)=phi*rtd
        ResAngle(3)=psi*rtd
c--
      return
      end
c
code for update_res
      subroutine update_res(typo,ResMatIn,ResMatOut,ResAngle,ier)
c--aggiorna coordinate nella cella del gruppo input
c  dopo applicazione delle tre rotazioni theta,phi,psi
c
      USE General
      USE Molcom
      USE Groups
      USE Plotter
      USE ZMatrix
!
      character*1 typo,Am1
      dimension ResMatIn(6,15),ResMatOut(6,15),ResAngle(6)
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xchar/id,ie,ib,icc,ia,ih,numb(10),iplus, inus,ipoint
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20)
      character chresx*1,chname*4
      common/workgroupX/ngruTot,jnumx(40),jaddrx(40),chresx(40),
     *  chname(40),jTabGru(80,300)
c     
      dimension xmatr(3,3),xx1(3),xx2(3),ori(3,3),oria(3,3)
      dimension x1(3),xr(3),x0(3)
c
c--azzera alcune variabili      
      itest=0
      ier=0
      gdd=xgg
      grr=xgr     
      vd=volume
      vr=1.0/volume
c
c--find the residuo richiesto
      do ja=1,nResid
         Am1 = char(ResidTable1(ja,2))
         if(typo.eq.Am1) then
         ngru=ja
         goto 1000
         endif
      enddo   
      write(ncwu,9010) typo
9010  format( /,' Required group not found for ',a1,/)
      ier=1
      return
c
c--residuo trovato
1000  continue
      ncard=ResidTable1(ngru,1)
      theta=ResAngle(4)*dtr
      phi=  ResAngle(5)*dtr
      psi=  ResAngle(6)*dtr
      call calcorien(theta,phi,psi,ori)
c      write(lo,*) ' **ori(i,j)'
c      write(lo,'(1x,3f10.4)') ((ori(i,j),j=1,3),i=1,3)
c      call deter3(ori,det)
c      write(ncwu,*)' deter:',det
      call prodm(rmi,ori,t_cryst)
c  matrice [UB]-1
c      write(ncwu,*)' matrice 2(t_cryst)'
c      do i=1,3
c      write(ncwu,'(3f10.4)')(t_cryst(i,j),j=1,3)
c      enddo
c      
        do ja=1,ncard
          xx1(1:3)=ResMatOut(4:6,ja)
          call moltv(t_cryst,xx1,xx2)
          ResMatOut(1:3,ja)=xx2(1:3)+x_orig(1:3)
        enddo
        if(itest.ge.1) then
          write(ncwu,*)' coordinate finali'
          do ja=1,ncard
            write(ncwu,'(10f10.5)') ResMatOut(1:3,ja)
          enddo
        endif
c--
      return
      end
c
code for ruota_res
      subroutine ruota_res(typo,ResMatIn,ResMatOut,ResAlpha,ier)
c--aggiorna coordinate nella cella del gruppo input
c  dopo applicazione di una rotazione intorno a un legame
c  ResAlpha = angolo di rotazione
c
      USE General
      USE Molcom
      USE Groups
      USE Plotter
      USE ZMatrix
!
      character*1 typo,Am1
      dimension ResMatIn(6,15),ResMatOut(6,15),ResAngle(6)
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xchar/id,ie,ib,icc,ia,ih,numb(10),iplus, inus,ipoint
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20)
      character chresx*1,chname*4
      common/workgroupX/ngruTot,jnumx(40),jaddrx(40),chresx(40),
     *  chname(40),jTabGru(80,300)
c     
      dimension ResTemp(3,15)
      dimension xmatr(3,3),xx1(3),xx2(3),ori(3,3),oria(3,3)
      dimension x1(3),xr(3),x0(3)
c
c--azzera alcune variabili      
      itest=0
      ier=0
      gdd=xgg
      grr=xgr     
      vd=volume
      vr=1.0/volume
c
c--find the residuo richiesto
      do ja=1,nResid
         Am1 = char(ResidTable1(ja,2))
         if(typo.eq.Am1) then
         ngru=ja
         goto 1000
         endif
      enddo   
      write(ncwu,9010) typo
9010  format( /,' Required group not found for ',a1,/)
      ier=1
      return
c
c--residuo trovato
1000  continue
      ncard=ResidTable1(ngru,1)
c--recupero coordinate z-matrix      
c      do jj=1,ncard
c        iloc(jj)=jj
c        xloc(1:3,jj)=ResidTable2(ngru,1:3,jj) 
c        nloc(1:3,jj)=ResidTable2(ngru,4:6,jj) 
c      enddo
      kat2=5
      kat1=2
      dist=ResidTable2(ngru,1,kat2)
      alfa=ResAlpha*dtr
        if(itest.ge.1) then
          write(ncwu,*)' coordinate cartesiane del modello'
          do ja=1,ncard
            write(ncwu,'(10f10.5)') ResMatOut(4:6,ja)
          enddo
        endif
c--definisco il legame di rotazione CA--CB (no. d'ordine 2--5)
c  e calcolo coseni direttori (5-2)
      do n=1,3
        xx1(n)=(ResMatOut(3+n,kat2) - ResMatOut(3+n,kat1))/dist
      enddo     
        if(itest.ge.1) then
          write(ncwu,*)' distanza, angolo, coseni direttori'
          write(ncwu,'(10f10.5)')dist,alfa*rtd
          write(ncwu,'(10f10.5)') xx1
        endif
c--calcolo la matrice di rotazione
      cosalfa=cos(alfa)
      sinalfa=sin(alfa)
      unomenocos=1-0-cosalfa
      oria(1,1)=cosalfa+xx1(1)*xx1(1)*unomenocos
      oria(1,2)=xx1(1)*xx1(2)*unomenocos+xx1(3)*sinalfa
      oria(1,3)=xx1(1)*xx1(3)*unomenocos-xx1(2)*sinalfa
      oria(2,1)=xx1(1)*xx1(2)*unomenocos-xx1(3)*sinalfa
      oria(2,2)=cosalfa+xx1(2)*xx1(2)*unomenocos
      oria(2,3)=xx1(2)*xx1(3)*unomenocos+xx1(1)*sinalfa
      oria(3,1)=xx1(1)*xx1(3)*unomenocos+xx1(2)*sinalfa
      oria(3,2)=xx1(2)*xx1(3)*unomenocos-xx1(1)*sinalfa
      oria(3,3)=cosalfa+xx1(3)*xx1(3)*unomenocos
      if(itest.ge.1) then
c--matrice ORIA di rotazione
        write(ncwu,*)' matrice oria(3,3) di rotazione'
        do i=1,3
           write(ncwu,'(3f10.4)')(oria(i,j),j=1,3)
        enddo
      endif
c--sposto gli atomi da ruotare
      do ja=kat2+1,ncard
        ResTemp(1:3,ja)= ResMatOut(4:6,ja)- ResMatOut(4:6,kat2)
      enddo      
c--applico la rotazione
      if(itest.ge.1) write(ncwu,*)'coord. iniz, coord. finali'
        do ja=kat2+1,ncard
          xx1(1:3)=ResTemp(1:3,ja)
          if(itest.ge.1)write(ncwu,'(i5,3f10.4)')ja,xx1
          call moltv(oria,xx1,xx2)
          if(itest.ge.1)write(ncwu,'(i5,3f10.4)')ja,xx2
          ResMatOut(4:6,ja)=xx2(1:3)+ ResMatOut(4:6,kat2)
        enddo
c--riporto nella cella cristallina      
      if(itest.ge.1) then
c--matrice [UB]-1
        write(ncwu,*)' matrice 2(t_cryst)'
        do i=1,3
           write(ncwu,'(3f10.4)')(t_cryst(i,j),j=1,3)
        enddo
      endif
        do ja=1,ncard
          xx1(1:3)=ResMatOut(4:6,ja)
          call moltv(t_cryst,xx1,xx2)
          ResMatOut(1:3,ja)=xx2(1:3)+x_orig(1:3)
        enddo
        if(itest.ge.1) then
          write(ncwu,*)' coordinate finali'
          do ja=1,ncard
            write(ncwu,'(10f10.5)') ResMatOut(1:3,ja)
          enddo
        endif
c--
      return
      end
!-----------------------------------------------------------------------
code for scattMnqd
      subroutine scattMnqd(rho)
c--calculate and store the scattering factors for the atoms
c  rho  the value of (sin(theta)/lambda)**2 for the calculation
c
      USE General
!--
      do ij=1,nk
         ff(ij) = ScattFact(ij, rho)
         if (ifMottFormula(ij) == 0) then
            ff(ij) = fprimo(ij)+ff(ij)    ! aggiunge f' parte reale
            fsecondoMnqd(ij)=fsecondo(ij)
         else
            fsecondoMnqd(ij)=0.0
         endif
      enddo
      return
      end
!-----------------------------------------------------------------------
      subroutine xfrm36
!
      integer :: iAction
!
      iAction = 1
      call PutGetRefi(iAction)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine xrst12
!
      integer :: iAction
!
      iAction = 2
      call PutGetRefi(iAction)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine xshift(iname,lnam)
      character*(*) iname
      character*1 blank
      data blank/' '/
      call shift(iname,lnam)
      if(lnam.le.0) return
      lnam1=lnam
      do i=1,lnam1
      if(iname(i:i).eq.blank) then
      lnam=i-1
      return
      endif
      enddo
      return
      end
!-----------------------------------------------------------------------
      subroutine matin(a,n,b,m,determ)
c--subroutine matin
c--matrix inversion with accompanying solution of linear equations
c
      dimension ipivot(160),a(3,3),b(3,3),index(160,2),pivot(160)
      equivalence (irow,jrow), (icolum,jcolum), (amax, t, swap)
c
c     initialization
c
      determ=1.0
      do j=1,n
        ipivot(j)=0
      enddo
      do i=1,n
c
c     search for pivot element
c
        amax=0.0
   45   do 105 j=1,n
   50     if (ipivot(j).eq.1) goto 105 !60, 105, 60
   60     do 100 k=1,n
   70       if (ipivot(k).eq.1) goto 100 ! 80, 100, 740
            if (ipivot(k).gt.1) return 
   80       if (abs(amax).ge.abs(a(j,k))) goto 100 !85, 100, 100
   85       irow=j
   90       icolum=k
   95       amax=a(j,k)
  100     continue
  105   continue
  110   ipivot(icolum)=ipivot(icolum)+1
c
c     interchange rows to put pivot element on diagonal
c
  130   if (irow.eq.icolum)goto 260 ! 140, 260, 140
  140   determ=-determ
  150   do l=1,n
          swap=a(irow,l)
          a(irow,l)=a(icolum,l)
          a(icolum,l)=swap
        enddo
  205   if(m.le.0) goto 260 ! 260, 260, 210
  210   do l=1, m
          swap=b(irow,l)
          b(irow,l)=b(icolum,l)
          b(icolum,l)=swap
        enddo
  260   index(i,1)=irow
  270   index(i,2)=icolum
  310   pivot(i)=a(icolum,icolum)
  320   determ=determ*pivot(i)
c
c     divide pivot row by pivot element
c
  330   a(icolum,icolum)=1.0
  340   do l=1,n
          a(icolum,l)=a(icolum,l)/pivot(i)
        enddo
  355   if(m.gt.0) then  ! 380, 380, 360
  360     do l=1,m
            b(icolum,l)=b(icolum,l)/pivot(i)
          enddo
        endif
c        
c     reduce non-pivot rows
c        
  380   do l1=1,n
          if(l1.ne.icolum) then 
            t=a(l1,icolum)
            a(l1,icolum)=0.0
            do l=1,n
               a(l1,l)=a(l1,l)-a(icolum,l)*t
            enddo
            if(m.gt.0)then 
              do l=1,m
                b(l1,l)=b(l1,l)-b(icolum,l)*t
              enddo
            endif
          endif
        enddo
      enddo
c
c     interchange columns
c
  600 do i=1,n
        l=n+1-i
        if (index(l,1).ne.index(l,2))then 
           jrow=index(l,1)
           jcolum=index(l,2)
           do k=1,n
             swap=a(k,jrow)
             a(k,jrow)=a(k,jcolum)
             a(k,jcolum)=swap
           enddo
        endif
      enddo
      return
      end
!      
!-----------------------------------------------------------------------
      subroutine PassaControllo
!-----------------------------------------------------------------------
!--passa il controllo a Caos
!-----------------------------------------------------------------------      
c**itty meaning:
c  itty  =  -1   interactive device
c  itty  =   0   batch device
cpc**	   itty=-1
!--per attivare il bottone del 'terminal' dal menu della grafica (se e' inibito):
!  1) aprire il file toolbar.h
!  2) andare alla riga 104 (o cercare la riga conn "terminal.png"
!  3) modificare il codice -1 (inibizione) in 1 (attivazione)
!  4) ricompilare
!
      USE General
      USE xfourx
*gl*  USE Atomi !, only: xyzs, nz, nats
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      integer ridisegna
      character*80 abc
! 
      call manage_console(1)
      Save_lo=lo     
      lo=0
      Save_ncwu=ncwu      
      ncwu=0
      Save_ln=ln     
      ln=5
      Save_ncru=ncru      
      ncru=5
c**intty = u.l. interactive device
      Save_itty=itty
      itty=-1
      Save_intty=intty
      intty=0
!-------------------------------------      
!     call Main_Loop_Caos
!-------------------------------------      
c      iAction = 2 + KindFourier
c      call Init_Rho(iAction)
!-------------------------------------      
      lo=Save_lo     
      ncwu=Save_ncwu      
      ln=Save_ln     
      ncru=Save_ncru      
      itty=Save_itty
      intty=Save_intty
      call manage_console(2)
!
*gl*  k = ridisegna()
*gl*  call DoSingleIteration()
!
      return            
      end
!-----------------------------------------------------------------------
!
!--subroutine four_point in commonfiles.f
!      call four_point(dummy, nats, ifSort)
!--calcola valore di rho per punti definiti in dummy(i,j), j=1, nats
!--in input: 
!       nreflDim      num riflessi da usare via USE General
!       khl(3,kj), fcoef(kj), iphaz(kj)  (indici, coef, fase) via USE Riflessi
!       dummy(1,j) = x
!       dummy(2,j) = y
!       dummy(3,j) = z
!       dummy(5,j) = occ
!       ifSort = 1/0  sort/no sort of dummy with respect to rho
!--in output:
!       dummy(4,j) = rho
!       rho(xyz) = 1/Vc [ F(000) 
!                + 2 SUM(h+)SUM(k)SUM(l) |F|cos[2pi(hx+ky+lz)-alpha] ]
!-----------------------------------------------------------------------
!
!--1a ipotesi:
!  calcolo della rho intorno ad un punto (X,Y,Z) 
!                    entro un raggio 'raggio' (o un parallelepipedo di lato 2*'raggio')
!                    con passo in Ang 'passo'
!--svolgimento:
!  per l'asse x: calcolo dx='raggio'/ asse(a)
!                limiti sull'asse x: min(x)= X-dx ; max(x)=X+dx
!                calcolo passo sull'asse x: px='passo'/asse(a)
!                calcolo numero di punti lungo l'asse x: nx=dx/px
!  (analogamnete del asse y e z)   
!--esempio numerico:
!  dato 'raggio'=0.6
!       'passo' =0.2
!  no punti lungo l'asse: nx=1.2 / 0.2 = 6
!  punti totale: NTOT=6*6*6 = 216
!-----------------------------------------------------------------------
!
!code for Init_Rho
      subroutine Init_Rho
!--inizializza calcolo dela densita' elettronica 
!
      USE General
      USE Atomi
      USE Riflessi
      USE ZMatrix
      USE LsqModule
      USE xfourx
      USE Molcom
      USE HydroStuff
      USE BuildModule
!
      dimension nordleg(4),legequi(4),dstleg(4),angleg(4,4)
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension vet(40),ivet(40)
      character*16 vetch
      dimension X1(3),X2(3),X3(3),ar(4),br(4)
      dimension x4(3),x5(3),x6(3),x7(3),x8(3)
      dimension X2r(3),X3r(3)
      dimension tm(3,3),tinv(3,3),d(3,3)
      character*80  line, dire
!      
      ier=0
      nreflDimSav=nreflDim
      nreflDim=NreflKsubr
!      
      if(FcScale.gt.0.0) then
         scale=1.0/FcScale
      else
         scale = sqrt(sc)
      endif
      vr=1.0/volume
      rhodiff(1)=-9999.0
      rhodiff(2)=9999.
      rhodiff(3)=0.0
!   
!-------------------------------------------------------
!--controllo il tipo di fourier richiesta
!-------------------------------------------------------
!--iCoef = 1 Fo
!	     2 2Fo-Fc
!	     3 Fo-Fc
!
      select case (iCoef) 
!      
         case (1)
            fcoef(1:NreflKsubr) = fovet(1:NreflKsubr)*scale
!            
         case (2)
            fcoef(1:NreflKsubr) = 2.0*fovet(1:NreflKsubr)*scale - 
     *                            fcvet(1:nrefl)
!             
         case (3) 
            fcoef(1:NreflKsubr) = fovet(1:NreflKsubr)*scale - 
     *                            fcvet(1:NreflKsubr)
!             
      end select   
!-------------------------------------------------------
      select case (KindFourier)      
!
!-------------------------------------------------------
         case (1)    ! CUBO
!            write(lo,*) 'xyzCubo:',xyzCubo  
!            write(lo,'(a,3f10.4)')'xyzCuboCryst:',xyzCuboCryst  
!            write(lo,'(a,f10.4)')'latoCubo:',latoCubo  
            raggio=0.5*latoCubo
            call Space_Rho(raggio)
! 
!-------------------------------------------------------
         case (2)    ! Ricerca H
            call geometriac(NordCubo,nHybcal,nHydcal,nHybut,nHydut,
     1           nlegati,legequi,nordleg,dstleg,angleg,disthydro)
!-- Passa  i valori calcolati per atomo no. d'ordine NordCubo:
!-- nHybcal : ibridizzazione calcolata 
!-- nHydcal : n. di H calcolato 
!-- nHybut = ibridiz. dall'utente  (ibridz(natom))
!-- nHydut = num. di H dall'utente (ibridz(natom))
!-- valori di nHybcal:  per C e B :1=sp1    (ibtab(i,1)=-11,-10)
!                                  2=sp2    (ibtab(i,1)=-21,-22,-20)
!                                  3=sp3    (ibtab(i,1)=-31,-32,-33,-30)
!                       per N     :2=sp2    (ibtab(i,1)=-20,-21)
!                                  3=sp3    (ibtab(i,1)=-30,-31,-32)
!                       per O     :4=chet.g.(ibtab(i,1)=-40)
!                                  5=alc.g. (ibtab(i,1)=-51)
!                                  6=w.m.   (ibtab(i,1)=-62)
!                       per tutti :9=ngH    (ibtab(i,1)=-99)
!-- nlegati: n. atomi legati
!-- nordleg(1:4) :n.d'ordine degli atomi legati a nord
!-- se nordleg(i)<0 : iequi=1 , atomo equivalente al nordleg(i)
!-- dstleg(1:4)  :dist. di legame dei nordleg
!-- angleg(i,1:3): angoli <i - nord - i+1>.....<i - nord -nlegati>
!-- disthydro  : distanza alla quale generare gli H
!
!           write(lo,*) 'NordCubo:',NordCubo
!           write(lo,*) 'xyzCuboCryst:',xyzCuboCryst(1:3) 
!--now used like CUBO
            raggio=2.0
            call Space_Rho(raggio)
!            
!-------------------------------------------------------------------------
            if(nats.gt.0) then
               rmx=1.2
               rmn=0.5
               X1(1:3)=xyzCuboCryst(1:3) 
!--1) eliminare quelli che distano piu' di 1.2A da xyzCuboCryst(1:3) 
               do j=1,nats
                  if(xyzs(5,j).gt.0.1) then
                     X3(1:3)=xyzs(1:3,j)
                     call vlen (xgg9,x1,x3,r)
!               write(lo,'(i5,3f10.4,f10.0,2f10.3)')j,(xyzs(n,j),n=1,5),r
                     if(r.lt.rmn.or.r.gt.rmx) xyzs(5,j)=-1.0
                  endif
               enddo
!-------------------------------------------------------------------------
!              write(lo,*) ' Picchi dopo analisi dist',nats
!              do j=1,nats
!                 write(lo,'(i5,3f10.4,f10.0,f10.3)') j, 
!     *                 (xyzs(n,j),n=1,5)
!              enddo
!-------------------------------------------------------------------------
!--compatto lista atomi
               i=0
               do j=1,nats
                  if(xyzs(5,j).gt.0.1) then
                     i=i+1
                     xyzs(1:5,i)=xyzs(1:5,j)
                  endif
               enddo
               nats=i 
               if(nats.gt.0) then
!-------------------------------------------------------------------------
!                  write(lo,*) ' Picchi dopo 1a eliminazione',nats
!                  do j=1,nats
!                     write(lo,'(i5,3f10.4,f10.0,f10.3)') j, 
!     *                     (xyzs(n,j),n=1,5)
!                  enddo
!-------------------------------------------------------------------------
!--2) eliminare quelli che formano un angolo minore di 90^ (?)
!     nordleg(i)--xyzCuboCryst(1:3)--newAtom(i)
                  if(nlegati.gt.0) then
                     do i=1, nlegati
                        nord1 = nordleg(i)
                        X2(1:3)=xyzo(1:3,nord1) 
                        do j=1,nats
                           if(xyzs(5,j).gt.0.1) then
                              X3(1:3)=xyzs(1:3,j)
                              call anamp (xgg9,x1,x2,x3,teta)
                              an = teta*rtd
!                              write(lo,'(2i5,3(/,3f10.4))')
!     *                               nord1,j,x1,x2,x3
!                              write(lo,'(i5,3f10.4,f10.0,2f10.3)')
!     *                               j,(xyzs(n,j),n=1,5),an
                              if(an.lt.90.0) xyzs(5,j)=-1.0
                           endif
                        enddo
                     enddo    
!-------------------------------------------------------------------------
!                     write(lo,*) ' Picchi dopo analisi ang ',nats
!                     do j=1,nats
!                        write(lo,'(i5,3f10.4,f10.0,f10.3)')
!     *                        j, (xyzs(n,j),n=1,5)
!                     enddo
!-------------------------------------------------------------------------
!--compatto lista atomi
                     i=0
                     do j=1,nats
                        if(xyzs(5,j).gt.0.1) then
                           i=i+1
                           xyzs(1:5,i)=xyzs(1:5,j)
                        endif
                     enddo
                     nats=i 
!-------------------------------------------------------------------------
!                     if(nats.gt.0) then
!                        write(lo,*) ' Picchi dopo 2a eliminazione',nats
!                        do j=1,nats
!                           write(lo,'(i5,3f10.4,f10.0,f10.3)') 
!     *                           j, (xyzs(n,j),n=1,5)
!                        enddo
!                     endif
!-------------------------------------------------------------------------
                  endif
               endif
            endif
c-------------------------------------------------------------------------
!--per saltare routine non piu' usate            
            ijump=1
            if(ijump.eq.1) goto 2000
!            
!--old source code            
            raggioMin=0.4
            raggioMax=1.4
!            
            select case (nlegati)      
!-------------------------------------------------------
               case (0)    ! atomo isolato
                  x_orig(1:3)=xyzCuboCryst(1:3)
                  t_cryst = rmi
                  icod=1
                  call  Orto_Space_Rho(icod,raggioMin,raggioMax)
!                  
!
!-------------------------------------------------------
               case (1)    ! un legame
                  nord1 = nordleg(1)
                  X1(1:3)=xyzCuboCryst(1:3) 
                  X2(1:3)=xyzs(1:3,nord1) 
!--calcoliamo lo spazio per il calcolo della rho
                  call pnr(X1,X2,X1,xgg9,xgr9,br)
                  if(br(4).eq.0.0) goto 9008
                  do j=1,3
                     j1=j
                     if(br(j).ne.0.0) exit
                  enddo
                  X3(:)=0.0
                  X3(j1)=br(4)/br(j1)
!--shift coordinate atomiche
                  x_orig(1:3)=X1(1:3)
                  X1(1:3)=X1(1:3)-x_orig(1:3)
                  X2(1:3)=X2(1:3)-x_orig(1:3)
                  X3(1:3)=X3(1:3)-x_orig(1:3)
!--calcolo sistema di riferimento ortogonale sull'atomo 1
!--asse XO = legame 1--2             
                  call newfr(vr,xgg,xgr,X2,X3,tm)
                  do i=1,3
                     do j=1,3
                        tinv(i,j)=tm(i,j)
                        d(i,j)=0.0
                     enddo
                  enddo
                  call trasp(tm,t_cryst)
                  ndim=3
                  m=0
                  call matin(tinv,ndim,d,m,det)
                  call trasp(tinv,t_ortho)
!--test--------------------------------------------------------------
! trasformazione delle coordinate atomiche 
!           call orcor(x2(1),x2(2),x2(3),t_ortho,x2r(1),x2r(2),x2r(3))
!           call orcor(x3(1),x3(2),x3(3),t_ortho,x3r(1),x3r(2),x3r(3))
!           write(lo,'(a,3f10.4)')'x2:',x2             
!           write(lo,'(a,3f10.4)')'x3:',x3             
!           write(lo,'(a,3f10.4)')'x2r:',x2r             
!           write(lo,'(a,3f10.4)')'x3r:',x3r             
! trasformazione delle coordinate atomiche 
!           call orcor(x2r(1),x2r(2),x2r(3),t_cryst,x2(1),x2(2),x2(3))
!           call orcor(x3r(1),x3r(2),x3r(3),t_cryst,x3(1),x3(2),x3(3))
!           write(lo,'(a,3f10.4)')'x2:',x2             
!           write(lo,'(a,3f10.4)')'x3:',x3             
!           X2(1:3)=X2(1:3)+x_orig(1:3)
!           X3(1:3)=X3(1:3)+x_orig(1:3)
!           write(lo,'(a,3f10.4)')'x2:',x2             
!           write(lo,'(a,3f10.4)')'x3:',x3             
!           call cpause(' ')
! --ent test-----------------------------------------------------------
                  icod=2
                  call  Orto_Space_Rho(icod,raggioMin,raggioMax)
!-------------------------------------------------------
               case (2,3)    ! due/tre legami
!--calcolo del baricentro tra i due/tre legami               
                  X1(1:3)=xyzCuboCryst(1:3) 
                  nord1 = nordleg(1)
                  nord2 = nordleg(2)
                  X2(1:3)=xyzs(1:3,nord1) 
                  X3(1:3)=xyzs(1:3,nord2) 
!                  
                  call vlen(xgg9,X1,X2,ddd)
                  xxx = 1.0/ddd
                  call pur(X1,X2,xxx,x5)
                  call vlen (xgg9,X1,X3,ddd)
                  xxx = 1.0/ddd
                  call pur(X1,X3,xxx,x6)
                  if(nlegati.eq.3) then
                     nord3 = nordleg(3)
                     x4(1:3)=xyzs(1:3,nord3) 
                     call vlen(xgg9,X1,x4,ddd)
                     xxx = 1.0/ddd
                     call pur(X1,x4,xxx,x7)
                     x8(1) = (x5(1)+x6(1)+x7(1))/3.
                     x8(2) = (x5(2)+x6(2)+x7(2))/3.
                     x8(3) = (x5(3)+x6(3)+x7(3))/3.
                  else
                     x8(1) = (x5(1)+x6(1))/2.
                     x8(2) = (x5(2)+x6(2))/2.
                     x8(3) = (x5(3)+x6(3))/2.
                  endif
!-----------------------------------------------------------                  
                  X2(1:3)=x8(1:3)   ! per omogeneita'....
!--calcoliamo lo spazio per il calcolo della rho
                  call pnr(X1,X2,X1,xgg9,xgr9,br)
                  if(br(4).eq.0.0) goto 9008
                  do j=1,3
                     j1=j
                     if(br(j).ne.0.0) exit
                  enddo
                  X3(:)=0.0
                  X3(j1)=br(4)/br(j1)
!--shift coordinate atomiche
                  x_orig(1:3)=X1(1:3)
                  X1(1:3)=X1(1:3)-x_orig(1:3)
                  X2(1:3)=X2(1:3)-x_orig(1:3)
                  X3(1:3)=X3(1:3)-x_orig(1:3)
!--calcolo sistema di riferimento ortogonale sull'atomo 1
!--asse XO = legame 1--2             
                  call newfr(vr,xgg,xgr,X2,X3,tm)
                  do i=1,3
                     do j=1,3
                        tinv(i,j)=tm(i,j)
                        d(i,j)=0.0
                     enddo
                  enddo
                  call trasp(tm,t_cryst)
                  ndim=3
                  m=0
                  call matin(tinv,ndim,d,m,det)
                  call trasp(tinv,t_ortho)
                  icod=2
                  call  Orto_Space_Rho(icod,raggioMin,raggioMax)
!-------------------------------------------------------
            end select   
!-------------------------------------------------------
2000        continue

      end select   
!-------------------------------------------------------
!      
      nreflDim=nreflDimSav
      return                               
9008  continue
      write(lo,'(a,4f10.4)')'Wrong plane:',pr
      call cpause('Wrong plane ')
      return      
      end
!
!code for Orto_Space_Rho
      subroutine Orto_Space_Rho(icod,raggioMin,raggioMax)
!--calcola la densita' elettronica 
!  icod = 1 sfera intorno all'atomo
!         2 semisfera opposta al legame
!  raggioMin   =  distanza(A^) minima dal punto
!  raggioMax   =  distanza(A^) massima dal punto
!  javGrid     =  passo(A^) per il calcolo della griglia
!                 dove calcolare la rho
!  levelFourier=nint(soglia*10.0)
!
!  esempi:  raggioMax = 1.2
!           passo  = 0.2
!           if(icod.eq.1) Npoint1 = 12
!           if(icod.eq.2) Npoint1 = 6
!           Npoint2 = 12
!           Npoint3 = 12
!           if(icod.eq.1) volume = 12 * 12 * 12 = 1728
!           if(icod.eq.2) volume =  6 * 12 * 12 =  864
      USE General
      USE LsqModule
      USE ZMatrix
      USE xfourx
!
      real, allocatable :: Map_Area(:,:)
!
      dimension xr(3),x(3),xvert(3,8)
      real    :: div_asse(3)
      character frmt*80, frmt1*80, frmtN*5, frmtI*3
      integer :: nGrid(3), npJav(3)
      real    :: Ratio, volumeCubo
!       
      volumeCubo = 1
      Ratio = volume / volumeCubo
!
      itest=1
      Npoint1=raggioMax/javGrid
      Npoint2=2.0*Npoint1+1
      if(icod.eq.1) Npoint1=Npoint2
      Npoint3=Npoint2
      if(icod.eq.2) Npoint1=Npoint1+1
      NTot=Npoint1*Npoint2*Npoint3
      iprint=0
      if(iprint.eq.1) then
         write(lo,'(a,i10,/)')'No di punti:',NTot
!--calcola le coordinate degli 8 vertici del parallelepipedo
!  dove viene calcolata la fourier
         if(icod.eq.1) xvert(1,1)=raggioMax
         if(icod.eq.2) xvert(1,1)=0.0
         xvert(2,1)=-raggioMax
         xvert(3,1)=-raggioMax

         if(icod.eq.1) xvert(1,2)=raggioMax
         if(icod.eq.2) xvert(1,2)=0.0
         xvert(2,2)=raggioMax
         xvert(3,2)=-raggioMax
      
         if(icod.eq.1) xvert(1,3)=raggioMax
         if(icod.eq.2) xvert(1,3)=0.0
         xvert(2,3)=-raggioMax
         xvert(3,3)=raggioMax

         if(icod.eq.1) xvert(1,4)=raggioMax
         if(icod.eq.2) xvert(1,4)=0.0
         xvert(2,4)=raggioMax
         xvert(3,4)=raggioMax

         xvert(1,5)=-raggioMax
         xvert(2,5)=-raggioMax
         xvert(3,5)=-raggioMax

         xvert(1,6)=-raggioMax
         xvert(2,6)=raggioMax
         xvert(3,6)=-raggioMax
      
         xvert(1,7)=-raggioMax
         xvert(2,7)=-raggioMax
         xvert(3,7)=raggioMax

         xvert(1,8)=-raggioMax
         xvert(2,8)=raggioMax
         xvert(3,8)=raggioMax
!--trasforma coord. ortogonali in cristallografiche
         do m=1,8
            xr(1:3)= xvert(1:3,m)
            call orcor(xr(1),xr(2),xr(3),t_cryst,x(1),x(2),x(3))
            x(1:3)=x(1:3)+x_orig(1:3)
            xvert(1:3,m) = x(1:3)
         enddo   
         write(lo,'(a)') 'Coordinate degli 8 vertici'
         do m=1,8
            write(lo,'(1x,2hh ,i1,3f10.4,a,1hh,i1)')
     *          m,xvert(1:3,m),' 3.0 1.0 0 0 ',m
         enddo
         write(lo,'(1h )')
      endif    
!      
      if (allocated(Map_Area))
     *            deallocate (Map_Area, stat = ierr)
!      
      IF (.NOT. ALLOCATED(Map_Area))
     *	ALLOCATE (Map_Area(1:8,1:NTot), stat = ierr)
       if (ierr.ne.0) then
       write(lo,*) 'Map_Area Allocation error'
       call cstop(' ')
      endif
!      
!--cosi' non puo' essere!!!!!!!!!!!!!!!!!     
      do i=1,3
         div_asse(i) = cell(i)/javGrid
      enddo   
!------------------------------------
      NTot=0
      NTot_OK=0
      if(icod.eq.1) xx=raggioMax
      if(icod.eq.2) xx=0.0
      do i=1,Npoint1
          yy=-raggioMax
          do j=1,Npoint2
             zz=-raggioMax
             do k=1,Npoint3
                NTot=NTot+1
                Map_Area(1,NTot)=xx   
                Map_Area(2,NTot)=yy
                Map_Area(3,NTot)=zz
                Map_Area(4,NTot)=0.0
                Map_Area(5,NTot)=1.0
!                a=sqrt(xx*xx+yy*yy+zz*zz)
!--trasforma coord. ortogonali in cristalline-----------------------
                xr(1:3)= Map_Area(1:3,NTot)
                call orcor(xr(1),xr(2),xr(3),t_cryst,x(1),x(2),x(3))
                x(1:3)=x(1:3)+x_orig(1:3)
                Map_Area(1:3,NTot) = x(1:3)
!                   
                ii=Map_Area(1,NTot) * div_asse(1)
                jj=Map_Area(2,NTot) * div_asse(2)
                kk=Map_Area(3,NTot) * div_asse(3)
!                
                Map_Area(6,NTot)=ii
                Map_Area(7,NTot)=jj
                Map_Area(8,NTot)=kk
!------------------------------------------------------------------                   
!                if(a.gt.raggioMax.or.a.lt.raggioMin)then
!                   Map_Area(5,NTot)=-1.
!                else
                   NTot_OK = NTot_OK + 1 
!                endif
!                write(lo,'(3f10.2,f10.3)') xx,yy,zz,a
                zz=zz+javGrid
             enddo      
!             write(lo,'(1h )')
             yy=yy+javGrid
          enddo
          xx=xx-javGrid
      enddo
      if(iprint.eq.1) then 
         write(lo,'(a,i10,/)')'No di punti da calcolare:',NTot_OK
      endif   
      ifSort=0
      call four_point(Map_Area, 8, NTot, ifSort)
c--find minimum and ... 
      do m=1,NTot        
         a=Map_Area(4,m)
         rhodiff(1)=amax1(rhodiff(1),a)
         rhodiff(2)=amin1(rhodiff(2),a)
         rhodiff(3)=rhodiff(3)+a*a
      enddo
      rhodiff(3)=sqrt(rhodiff(3)/float(NTot))
      write(lo,3114) rhodiff(2),rhodiff(1)                  
3114  format(/,'Minimum =',f7.2,' and maximum =',f7.2,       
     2       ' values of rho')
      if(iCoef.eq.3) then
         write(lo,3113) rhodiff(3)                        
3113     format('Having root_mean_square =',f6.2)
      endif
      write(lo,'(1h )')
!
!--print the result
      if(itest.eq.1) then
!--print the coordinates
c         m=1
c         do i=1,Npoint1
c            write(lo,'(a,3f7.2)') 'Starting section:',Map_Area(1:3,m)
c            do j=1,Npoint2
c               m1=m+Npoint3-1
c               write(lo,'(12(1h(,3f6.2,1h)))') (Map_Area(1:3,l),l=m,m1)
c               m=m1+1
c            enddo
c            write(lo,'(a,3f7.2)') 'Ending section:',Map_Area(1:3,m-1)
c            write(lo,'(1h )')
c         enddo
!--print the rho
!                 1234567890123456789012345678901234567890
         frmt  = '(8x, 13f    7.2,/)'  
!                 1234567890123456789012345678901234567890
         frmt1 = '(1h(,f6.2,1h), 11f    7.2,1h(,f6.2,1h))' 
         a=rhodiff(1)
         l=1
         if(a.gt.10.0) then
            ia=int(a)
            write(frmtN,'(i5)')ia
            call shift(frmtN,l)
         endif
         l=l+2   ! sommo uno spazio e il segno -
         l=l+3   ! sommo il punto e due decimali
         write(frmtN,'(i5)')l
         frmt(9:13)    = frmtN
         frmt1(19:23)  = frmtN
         write(frmtI,'(i3)')Npoint3
         frmt(5:7)    = frmtI
         frmt1(15:17) = frmtI
         m=1
         do i=1,Npoint1
            write(lo,'(a,3f8.4)') 'Starting section:',Map_Area(1:3,m)
            m1=m+Npoint3-1
            write(lo,frmt) Map_Area(3,m:m1)
            do j=1,Npoint2
               m1=m+Npoint3-1
               write(lo,frmt1) 
     *           Map_Area(2,m),Map_Area(4,m:m1),Map_Area(2,m1)
               m=m1+1
            enddo
            write(lo,'(/,a,3f8.4)') 'Ending section:',Map_Area(1:3,m-1)
            write(lo,'(1h )')
         enddo
      endif
!
      if (javFourier == 1) then
          nGrid(1:3) = nint(div_asse(1:3))
          call javFourierHeader(nGrid)
          do i=1, NTot
             if (Map_Area(5,i) > 0.0) then
                 npJav(1:3) = nint(Map_Area(6:8,i))
                 do j=1, 3
                    if (npJav(j) < 0) then
                        npJav(j) = npJav(j) + nGrid(j)
                    elseif (npJav(j) > nGrid(j)) then
                        npJav(j) = npJav(j) - nGrid(j)
                    endif
                 enddo
                 write(jrel,*) npJav(1:3), Ratio * Map_Area(4,i)
             endif
          enddo
          close(jrel)
      endif
!
!------------------------------------------------       
!--localize the peaks
!------------------------------------------------ 
      soglia = float(levelFourier)/10.0    
      call scanRho(Map_Area,NTot,Npoint1,Npoint2,Npoint3,soglia,ier)
!
      DEALLOCATE(Map_Area, stat =ierr)
!
*gl*  if (javFourier == 1) then
*gl*      call LanciaJavFour
*gl*  endif
!
      return
      end      
!
!code for Space_Rho
      subroutine Space_Rho(raggio)
!--calcola la densita' elettronica intorno a un punto
!  raggio   =  distanza(A^) dal punto origine xyzCuboCryst(i)
! 
      USE General
      USE LsqModule
      USE Symmetry
      USE xfourx
      USE Molcom, only: latoCubo
!
      real, allocatable :: Map_Area(:,:)
!
      real    :: xvert(3,8)
      real    :: fraz_raggio(3), fraz_passo(3), fraz_min(3), fraz_max(3)
      real    :: div_asse(3)
      character frmt*80, frmt1*80, frmtN*5, frmtI*3
      integer :: nGrid(3), npJav(3)
      real    :: a1, a2, a3, arg, volumeCubo, Ratio
!
!-- calcolo volume cubo
!
      a1  = cos(cell(4) * pi / 180.0)
      a2  = cos(cell(5) * pi / 180.0)
      a3  = cos(cell(6) * pi / 180.0)
      arg = 1.0 - a1*a1 - a2*a2 - a3*a3 + a1*a2*a3 * 2.0
      volumeCubo = latoCubo * latoCubo * latoCubo * sqrt(arg)
      volumeCubo = 1
      Ratio = volume / volumeCubo
!  
      itest=1
      Npoint=raggio/javGrid
      Npoint1=2.0*Npoint+1
      Npoint2=Npoint1
      Npoint3=Npoint1
      NTot=Npoint1*Npoint2*Npoint3
!
      do i=1,3
          fraz_raggio(i)=raggio/cell(i)
          fraz_passo(i)=javGrid/cell(i)
          fraz_min(i)=xyzCuboCryst(i)-fraz_raggio(i)
          fraz_max(i)=xyzCuboCryst(i)+fraz_raggio(i)
      enddo
!      
!      do i=1,3
!         write(lo,'(a,i2,1h),2f10.4)')'lato,passo:',i, fraz_raggio(i),
!     *         fraz_passo(i)
!      enddo
!      write(lo,'(/,a,i10,/)')'No di punti da calcolare:',NTot
!      
      iprint=0
      if(iprint.eq.1) then
!--calcola le coordinate degli 8 vertici del parallelepipedo
!  dove viene calcolata la fourier
         xvert(1,1)= fraz_min(1)
         xvert(2,1)= fraz_min(2)
         xvert(3,1)= fraz_min(3)
      
         xvert(1,2)= fraz_min(1)
         xvert(2,2)= fraz_max(2)
         xvert(3,2)= fraz_min(3)
      
         xvert(1,3)= fraz_min(1)
         xvert(2,3)= fraz_min(2)
         xvert(3,3)= fraz_max(3)

         xvert(1,4)= fraz_min(1)
         xvert(2,4)= fraz_max(2)
         xvert(3,4)= fraz_max(3)

         xvert(1,5)= fraz_max(1)
         xvert(2,5)= fraz_min(2)
         xvert(3,5)= fraz_min(3)

         xvert(1,6)= fraz_max(1)
         xvert(2,6)= fraz_max(2)
         xvert(3,6)= fraz_min(3)
      
         xvert(1,7)= fraz_max(1)
         xvert(2,7)= fraz_min(2)
         xvert(3,7)= fraz_max(3)

         xvert(1,8)= fraz_max(1)
         xvert(2,8)= fraz_max(2)
         xvert(3,8)= fraz_max(3)
!      
         write(lo,'(a)') 'Coordinate degli 8 vertici'
         do m=1,8
            write(lo,'(1x,2hh ,i1,3f10.4,a,1hh,i1)')
     *          m,xvert(1:3,m),' 3.0 1.0 0 0 ',m
         enddo
         write(lo,'(1h )')
      endif    
!      
      if (allocated(Map_Area))
     *            deallocate (Map_Area, stat = ierr)
!      
      IF (.NOT. ALLOCATED(Map_Area))
     *	ALLOCATE (Map_Area(1:8,1:NTot), stat = ierr)
       if (ierr.ne.0) then
       write(lo,*) 'Map_Area Allocation error'
       call cstop(' ')
      endif
!      
      do i=1,3
         div_asse(i) = cell(i)/javGrid
      enddo   
!
      NTot=0
      xx=fraz_min(1)
      do i=1,Npoint1
          yy=fraz_min(2)
          do j=1,Npoint2
             zz=fraz_min(3)
             do k=1,Npoint3
                NTot=NTot+1
                Map_Area(1,NTot)=xx   
                Map_Area(2,NTot)=yy
                Map_Area(3,NTot)=zz
                Map_Area(4,NTot)=0.0
                Map_Area(5,NTot)=1.0
*               Map_Area(6,NTot)=i
*               Map_Area(7,NTot)=j
*               Map_Area(8,NTot)=k
                
                ii=xx * div_asse(1)
                jj=yy * div_asse(2)
                kk=zz * div_asse(3)
                
                Map_Area(6,NTot)=ii
                Map_Area(7,NTot)=jj
                Map_Area(8,NTot)=kk
                zz=zz+fraz_passo(3)
!                write(lo,'(3f10.2)') xx,yy,zz
             enddo      
!             write(lo,'(1h )')
             yy=yy+fraz_passo(2)
          enddo
          xx=xx+fraz_passo(1)
      enddo   
      ifSort=0
      call four_point(Map_Area, 8, NTot, ifSort)
c--find minimum and ... 
      do m=1,NTot        
         a=Map_Area(4,m)
         rhodiff(1)=amax1(rhodiff(1),a)
         rhodiff(2)=amin1(rhodiff(2),a)
         rhodiff(3)=rhodiff(3)+a*a
      enddo
      rhodiff(3)=sqrt(rhodiff(3)/float(NTot))
      write(lo,3114) rhodiff(2),rhodiff(1)                  
3114  format(/,'Minimum =',f7.2,' and maximum =',f7.2,       
     2       ' values of rho')
      if(iCoef.eq.3) then
         write(lo,3113) rhodiff(3)                        
3113     format('Having root_mean_square =',f6.2)
      endif
      write(lo,'(1h )')
!
!--print the result
      if(itest.eq.1) then
!--print the coordinates
c         m=1
c         do i=1,Npoint1
c            write(lo,'(a,3f7.2)') 'Starting section:',Map_Area(1:3,m)
c            do j=1,Npoint2
c               m1=m+Npoint3-1
c               write(lo,'(12(1h(,3f6.2,1h)))') (Map_Area(1:3,l),l=m,m1)
c               m=m1+1
c            enddo
c            write(lo,'(a,3f7.2)') 'Ending section:',Map_Area(1:3,m-1)
c            write(lo,'(1h )')
c         enddo
!--print the rho   
!                 1234567890123456789012345678901234567890
         frmt  = '(8x, 13f    7.2,/)'  
!                 1234567890123456789012345678901234567890
         frmt1 = '(1h(,f6.2,1h), 11f    7.2,1h(,f6.2,1h))' 
         a=rhodiff(1)
         l=1
         if(a.gt.10.0) then
            ia=int(a)
            write(frmtN,'(i5)')ia
            call shift(frmtN,l)
         endif
         l=l+2   ! sommo uno spazio e il segno -
         l=l+3   ! sommo il punto e due decimali
         write(frmtN,'(i5)')l
         frmt(9:13)    = frmtN
         frmt1(19:23)  = frmtN
         write(frmtI,'(i3)')Npoint3
         frmt(5:7)    = frmtI
         frmt1(15:17) = frmtI
         m=1
         do i=1,Npoint1
            write(lo,'(a,3f8.4)') 'Starting section:',Map_Area(1:3,m)
            m1=m+Npoint3-1
            write(lo,frmt) Map_Area(3,m:m1)
            do j=1,Npoint2
               m1=m+Npoint3-1
               write(lo,frmt1) 
     *           Map_Area(2,m),Map_Area(4,m:m1),Map_Area(2,m1)
               m=m1+1
            enddo
            write(lo,'(/,a,3f8.4)') 'Ending section:',Map_Area(1:3,m-1)
            write(lo,'(1h )')
         enddo
      endif
!
      if (javFourier == 1) then
          nGrid(1:3) = nint(div_asse(1:3))
          call javFourierHeader(nGrid)
          do i=1, NTot
             if (Map_Area(5,i) > 0.0) then
                 npJav(1:3) = nint(Map_Area(6:8,i))
                 do j=1, 3
                    if (npJav(j) < 0) then
                        npJav(j) = npJav(j) + nGrid(j)
                    elseif (npJav(j) > nGrid(j)) then
                        npJav(j) = npJav(j) - nGrid(j)
                    endif
                 enddo
                 write(jrel,*) npJav(1:3), Ratio * Map_Area(4,i)
             endif
          enddo
          close(jrel)
      endif
!------------------------------------------------       
!--localize the peaks
!------------------------------------------------       
      soglia = float(levelFourier)/10.0    
      call scanRho(Map_Area,NTot,Npoint1,Npoint2,Npoint3,soglia,ier)
!
*gl*  if (javFourier == 1) then
*gl*      call LanciaJavFour
*gl*  endif
!
      DEALLOCATE(Map_Area, stat =ierr)
!
      return
      end      
!-----------------------------------------------------------------------
!code for scanRho 
      subroutine scanRho(Map_Area,NTot,Npt1,Npt2,Npt3,soglia,ier)
!--peak searching routine
!
      USE General
      USE Atomi
      USE PhaseModule
      USE Restw
      USE Limits
      USE Symmetry
!
      real Map_Area(8,NTot)
!--
      dimension xxs(3),xxs1(3)
      dimension xpk(3),xpk1(3),kx(3),vett(3,4),cub(27)
      dimension iccp4(3,2)
      dimension d(3)
!--
      ier=0
      interpo=1
      iprint=0
!      write(lo,'(/a,4i10,/)')'Valori NTot,Npt1,Npt2,Npt3:',
!     *                            NTot,Npt1,Npt2,Npt3
!      
!--calcolo alcune grandezze
      np23=Npt2*Npt3            
!
!--set to zero numero di picchi trovati5
      nats=0
!
      m = np23 + Npt3 +2
!--start lo loop over the layers
      do ip = 2,Npt1-1                   ! loop sulla sezioni
         m2=m      
c--start 2o loop verticale
         do in=2,Npt2-1                  ! loop sulle lineee verticali
            m3=m   
!            m1=m+Npt3-1
!            write(lo,'(30f7.2)') Map_Area(4,m:m1)
c--start 3o loop orizzontale 
            do_ix: do im=2,Npt3-1        ! loop sulla riga orizzontale
               a=Map_Area(4,m)
               if(a.ge.soglia .and. nats < MaxAtoms) then ! gianluca 9/5/2011  
!--analizzo se e' un massimo  
c--punti sul piano centrale
!                 if(Map_Area(5,m).lt.0.0) goto 2000
                  cub(14)=Map_Area(4,m       )         !(im  ,in  ,ip  )
                  cub(13)=Map_Area(4,m-1     )         !(im-1,in  ,ip  )
                  cub(15)=Map_Area(4,m+1     )         !(im+1,in  ,ip  )
                  cub(11)=Map_Area(4,m-Npt3  )         !(im  ,in-1,ip  )
                  cub(10)=Map_Area(4,m-Npt3-1)         !(im-1,in-1,ip  )
                  cub(12)=Map_Area(4,m-Npt3+1)         !(im+1,in-1,ip  )
                  cub(17)=Map_Area(4,m+Npt3  )         !(im  ,in+1,ip  )
                  cub(16)=Map_Area(4,m+Npt3-1)         !(im-1,in+1,ip  )
                  cub(18)=Map_Area(4,m+Npt3+1)         !(im+1,in+1,ip  )
c--punti piano inferiore
                  cub( 5)=Map_Area(4,m-np23       )    !(im  ,in  ,ip-1)
                  cub( 4)=Map_Area(4,m-np23-1     )    !(im-1,in  ,ip-1)
                  cub( 6)=Map_Area(4,m-np23+1     )    !(im+1,in  ,ip-1)
                  cub( 2)=Map_Area(4,m-np23-Npt3  )    !(im  ,in-1,ip-1)
                  cub( 1)=Map_Area(4,m-np23-Npt3-1)    !(im-1,in-1,ip-1)
                  cub( 3)=Map_Area(4,m-np23-Npt3+1)    !(im+1,in-1,ip-1)
                  cub( 8)=Map_Area(4,m-np23+Npt3  )    !(im  ,in+1,ip-1)
                  cub( 7)=Map_Area(4,m-np23+Npt3-1)    !(im-1,in+1,ip-1)
                  cub( 9)=Map_Area(4,m-np23+Npt3+1)    !(im+1,in+1,ip-1)
c--punti piano superiore
                  cub(23)=Map_Area(4,m+np23       )    !(im  ,in  ,ip+1)
                  cub(22)=Map_Area(4,m+np23-1     )    !(im-1,in  ,ip+1)
                  cub(24)=Map_Area(4,m+np23+1     )    !(im+1,in  ,ip+1)
                  cub(20)=Map_Area(4,m+np23-Npt3  )    !(im  ,in-1,ip+1)
                  cub(19)=Map_Area(4,m+np23-Npt3-1)    !(im-1,in-1,ip+1)
                  cub(21)=Map_Area(4,m+np23-Npt3+1)    !(im+1,in-1,ip+1)
                  cub(26)=Map_Area(4,m+np23+Npt3  )    !(im  ,in+1,ip+1)
                  cub(25)=Map_Area(4,m+np23+Npt3-1)    !(im-1,in+1,ip+1)
                  cub(27)=Map_Area(4,m+np23+Npt3+1)    !(im+1,in+1,ip+1)
                  y=-9999.0
                  do ii=1,27
                     y=amax1(y,cub(ii))
                  enddo
!                  write(lo,'(i5,1h),3i7,2f10.2)')m,in,im,ip,a,y
!---------PIANI DEL CUBO:--------------------------------------------------                  
! INFERIORE  CENTRALE    SUPERIORE                
!   1 2 3    10 11 12    19 20 21             
!   4 5 6    13 14 15    22 23 24
!   7 8 9    16 17 18    25 26 27  
!---------------------------------------------------------------------------       
!                  write(lo,1000)cub(1:3),cub(10:12),cub(19:21)
!                  write(lo,1000)cub(4:6),cub(13:15),cub(22:24)
!                  write(lo,1000)cub(7:9),cub(16:18),cub(25:27)
!1000              format( 3(3f7.2,5x)) 
                  if(a.ge.y) then
!--e' un massimo                
!--check tutti i punti sono entro i limiti
                     if(Map_Area(5,m-1     ).lt.0.0) goto 2000
                     if(Map_Area(5,m+1     ).lt.0.0) goto 2000
                     if(Map_Area(5,m-Npt3  ).lt.0.0) goto 2000     
                     if(Map_Area(5,m-Npt3-1).lt.0.0) goto 2000
                     if(Map_Area(5,m-Npt3+1).lt.0.0) goto 2000
                     if(Map_Area(5,m+Npt3  ).lt.0.0) goto 2000
                     if(Map_Area(5,m+Npt3-1).lt.0.0) goto 2000
                     if(Map_Area(5,m+Npt3+1).lt.0.0) goto 2000
!
                     if(Map_Area(5,m-np23       ).lt.0.0) goto 2000
                     if(Map_Area(5,m-np23-1     ).lt.0.0) goto 2000
                     if(Map_Area(5,m-np23+1     ).lt.0.0) goto 2000
                     if(Map_Area(5,m-np23-Npt3  ).lt.0.0) goto 2000
                     if(Map_Area(5,m-np23-Npt3-1).lt.0.0) goto 2000
                     if(Map_Area(5,m-np23-Npt3+1).lt.0.0) goto 2000
                     if(Map_Area(5,m-np23+Npt3  ).lt.0.0) goto 2000
                     if(Map_Area(5,m-np23+Npt3-1).lt.0.0) goto 2000
                     if(Map_Area(5,m-np23+Npt3+1).lt.0.0) goto 2000
!
                     if(Map_Area(5,m+np23       ).lt.0.0) goto 2000
                     if(Map_Area(5,m+np23-1     ).lt.0.0) goto 2000
                     if(Map_Area(5,m+np23+1     ).lt.0.0) goto 2000
                     if(Map_Area(5,m+np23-Npt3  ).lt.0.0) goto 2000
                     if(Map_Area(5,m+np23-Npt3-1).lt.0.0) goto 2000
                     if(Map_Area(5,m+np23-Npt3+1).lt.0.0) goto 2000
                     if(Map_Area(5,m+np23+Npt3  ).lt.0.0) goto 2000
                     if(Map_Area(5,m+np23+Npt3-1).lt.0.0) goto 2000
                     if(Map_Area(5,m+np23+Npt3+1).lt.0.0) goto 2000
!                  
!--select the interpolation method
                     select case (interpo)
!
                       case (1)                     
!--from original one ...
                          xx=Map_Area(1,m)
                          xy=Map_Area(2,m)
                          xz=Map_Area(3,m)
                          
                          xx1=Map_Area(1,m-np23)
                          xy1=Map_Area(2,m-Npt3)
                          xz1=Map_Area(3,m-1)
                                                    
                          xx2=Map_Area(1,m+np23)
                          xy2=Map_Area(2,m+Npt3)
                          xz2=Map_Area(3,m+1)
                          
!      write(lo,'(3f7.2,3f10.4)')cub(5),cub(14),cub(23),xx1,xx,xx2
                          call subxNew(xx1,xx,xx2,cub( 5),cub(14),    
     2                             cub(23) ,xpk(1),rpks)
!      write(lo,'(3f7.2,3f10.4)')cub(11),cub(14),cub(17),xy1,xy,xy2
                          call subxNew(xy1,xy,xy2,cub(11),cub(14),    
     2                             cub(17),xpk(2),rpkv)
!      write(lo,'(3f7.2,3f10.4)')cub(13),cub(14),cub(15),xz1,xz,xz2
                          call subxNew(xz1,xz,xz2,cub(13),cub(14),  
     2                             cub(15),xpk(3),rpko)
                          frpk=  amax1(rpks,rpkv,rpko)  
!                          frpk=     (rpks+rpkv+rpko)/3.0  
!                             
                       case (2)                     
!--from f. pavelcik [acta cryst.(1986)a42,286-287]
                          call xpave(cub,xpk1,frpk)
                          xpk(1)=xx+xpk1(1)*xyzMappa(1,3)
                          xpk(2)=xy+xpk1(2)*xyzMappa(2,3)
                          xpk(3)=xz+xpk1(3)*xyzMappa(3,3)
!                          
                       case (3)                     
c-- from j.s. rollett [computing methods in crystallography]
c                         call xrolleNew(icub,xpk1,frpk,lk,l,lnx,la2,lc2)
c                          xpk(1)=xx+xpk1(1)*xyzMappa(1,3)
c                          xpk(2)=xy+xpk1(2)*xyzMappa(2,3)
c                          xpk(3)=xz+xpk1(3)*xyzMappa(3,3)
!                          
                       case (4)                     
c--interpolation by booth's parabola procedure (from CCP4)
c	                    iccp4(1,1) = icub(13)
c	                    iccp4(1,2) = icub(15)
c	                    iccp4(2,1) = icub(11)
c	                    iccp4(2,2) = icub(17)
c	                    iccp4(3,1) = icub(5)
c	                    iccp4(3,2) = icub(23)
c	                    iRPK =    icub(14)
c                         call xparab(iccp4,irpk,xpk1)
c                          frpk=irpk
c                          xpk(1)=xx+xpk1(1)*xyzMappa(1,3)
c                          xpk(2)=xy+xpk1(2)*xyzMappa(2,3)
c                          xpk(3)=xz+xpk1(3)*xyzMappa(3,3)
                    end select
                    nats=nats+1
!
                    xyzs(1:3,nats) = xpk(1:3)
                    xyzs(4,nats)   = frpk
                    xyzs(5,nats)   = 1.0
!                   
                    if(iprint.ge.1) then
                       write(lo,2300) nats,(xpk(ii),ii=1,3),frpk
 2300                  format(7x,i3,4x,3f10.4,f9.2)
                    endif
!                    
c-- check the peak ------------------------------------------------ 
c                    nop1 = NumPeaks+1
c                    xx=side(xpk(1))
c                    yy=side(xpk(2))
c                    zz=side(xpk(3))
c                    xyzs(1,nop1) = xx
c                    xyzs(2,nop1) = yy
c                    xyzs(3,nop1) = zz
c                    xyzs(4,nop1) = frpk
c--if two peaks are closer than dm angstroms eliminate the smaller
c                    if(NumPeaks > 0) then
c                       ir=0
c                       do k=1,nsymTot
c                          call oper(k,xxs,xx,yy,zz)
c                          if (lproj > 0) xxs(lproj) = 0.0
c                          do_pk: do jj=1,NumPeaks
c                               do l=1,3
c                                  xxs1(l)=xxs(l)-xyzs(l,jj)
c                                  do while(abs(xxs1(l))>0.5)
c                                     xxs1(l)=xxs1(l)-sign(1.0,xxs1(l))
c                                  enddo
c                                  if(abs(xxs1(l))>dxmax(l)) cycle do_pk
c                               enddo
c                               if(quadr(xxs1,xxs1,ttt)<=dm) then 
c                                  if(ir>0) xyzs(4,ir)=0.0
c                                  ir=0
c                                  if(ixx /= 0) then
c                                     if(frpk <= xyzs(4,jj) ) goto 2000
c                                  else
c                                     if(frpk <  xyzs(4,jj) ) goto 2000
c                                  endif
c                                  xyzs(1,jj)= xx
c                                  xyzs(2,jj)= yy
c                                  xyzs(3,jj)= zz
c                                  xyzs(4,jj)= frpk
c                                  ir=jj
c                               endif
c                          enddo do_pk
c                       enddo
c                       if(ir>0) goto 2000
c                    endif
c                    NumPeaks=nop1
c                    if (NumPeaks .ge. limit) then
c                        call sortf(xyzs, 5, NumPeaks, 4)
c                        NumPeaks = npic
c                        alevel = xyzs(4,npic) + 0.5
c                        limit = min0(MaxAtoms, 2*nats)
c                    endif
                  endif
               endif
 2000          continue
               m=m+1                 
!               write(lo,'(/,a,3i5,/)')'Fine oriz,vert,sez',in,im,ip
            enddo do_ix
            m=m3+Npt3
         enddo 
!         write(lo,'(1h )')
         m=m2+np23     
      enddo 
!
      call CalcolaOccupanze()
c      
      write(lo,*) ' Picchi scanRho ',nats
      if(nats.gt.0) then
         do j=1,nats
            write(lo,'(i5,3f10.4,f10.0,f10.3)') j, (xyzs(n,j),n=1,5)
         enddo
      endif
c!
      if(iprint.ge.1) write(lo,'(1h )')
      return
      end
!-------------------------------------------------------------------
      subroutine javFourierHeader(nGridi)
      USE General
      USE Symmetry
      USE xfourx
!
      implicit none
      integer :: itype, iformato, jop, jopen, ier2
      integer :: i, kk, Lung, nGridi(3), nGrid(3)
!
      kk = Lung(StructureName)
      cardDiret = StructureName(1:kk) // '_tmp.xyz'
      itype = 0
      iformato = 1
      jop = jopen(jrel,cardDiret,itype,iformato,ier2)
      nGrid(1:) = nGridi(1:3) + 1
      write(jrel,'(6f9.3,3i4)') cell(1:6), nGrid(1:3)
      write(Inte,'(16a1)') (nSpaceG(i),i=1,16)
      call ucase(Inte)
      write(jrel,'(a)') Inte(1:16)
!
      return
      end
!-------------------------------------------------------------------
      subroutine javFourierMap(l_x, l_y, l_z, Map)
      USE General
      USE Symmetry
      USE xfourx
      USE MappaAutre
!
      implicit none
      integer :: nGrid(3)
      integer :: i, j, k, iAction, ivvet(2), ifin, kt, ky, kl, ifi
      integer :: i1, j1, k1, l_x, l_y, l_z
      real    :: x, Map(1:l_x,1:l_y,1:l_z), x1(3), x2(3), coef
!
      do i=1, 3 
!RS         npAutre(i) = xyzfou(i, 4) + 2
         npAutre(i) = xyzfou(i, 4) + 1     !  penso che debba essere + 1
      enddo
      write(0,*) npAutre
      call javFourierHeader(npAutre)
      iAction = 1
      call AllocaMappaAutre(iAction)
!
      ivvet(1) =  1
      ivvet(2) = -1
      ifin = icent + 1
!
      do i=1, l_x
         i1 = limitiJav(1,1) + i - 1
         x1(1) = float(i1) / xyzfou(1, 4)
         do j=1, l_y
            j1 = limitiJav(1,2) + j - 1
            x1(2) = float(j1) / xyzfou(2, 4)
            do k=1, l_z
               k1 = limitiJav(1,3) + k - 1
               x1(3) = float(k1) / xyzfou(3, 4)
               x = Map(i, j, k)
               if (abs(x) < 0.0001) cycle
               do kt=1, ncentr
                  do ifi=1,ifin
                     coef = ivvet(ifi)
                     do ky=1, nsym
                        call xequi(x1, ky, coef, x2, kt)
                        do kl=1, 3
                           if (x2(kl) < 0.0) then
                               x2(kl) = x2(kl) + 1.0
                           elseif (x2(kl) > 1.0) then
                               x2(kl) = x2(kl) - 1.0
                           endif
                        enddo
                        i1 = x2(1) * xyzfou(1, 4)
                        j1 = x2(2) * xyzfou(2, 4)
                        k1 = x2(3) * xyzfou(3, 4)
                        xmapAutre(i1, j1, k1) = x
                     enddo
                  enddo
               enddo
            enddo
         enddo
      enddo
!--cosi la mappa va da 0 -- 1
      do i=0, npAutre(1)-1
         do j=0, npAutre(2)-1
            do k=0, npAutre(3)-1
               write(jrel,*) i, j, k, xmapAutre(i, j, k)
            enddo
         enddo
      enddo
!
      iAction = 2
      call AllocaMappaAutre(iAction)
      close(jrel)
!
      return
      end
!-------------------------------------------------------------------
      subroutine LanciaJavFour
      USE General
      USE Molcom, only: latoCubo
      USE Atomi
      USE xfourx
!
      implicit none
      integer :: L, Lung, kk, cubo
      real    :: raggio, bari(3)
!
      kk = Lung(StructureName)
!
      card(2) = cardDiret(1:Lung(cardDiret)) // char(0)
      cardDiret = StructureName(1:kk) // '_tmp.cif'
      call WriteSimpleCif(cardDiret, nats, nz, nzConst, 5, xyzs, bfac,
     *                    aLab, 1.0, bari)
      card(3) = cardDiret(1:Lung(cardDiret)) // char(0)
!
!-- Start Jav
!
      if (KindFourier == -1) then      ! standard fourier
          write(card(1),10) char(34),Titolo(1:Lung(Titolo)),char(34)
      else                            ! fourier in a cube
          raggio = latoCubo / 2
          write(card(1),20) Titolo(1:Lung(Titolo)), raggio, xyzCuboCryst
      endif
      direttiva = card(1)(1:Lung(card(1))) // ' ' //
     *            card(2)(1:Lung(card(2))) // ' ' //
     *            card(3)(1:Lung(card(3)))
      L = Lung(direttiva)
      write(*,*) 'Jav ',direttiva(1:L)
      L = Lung(card(1))
      card(1)(L+1:L+1) = char(0)
      call startJav(card, 3)
!
      return
   10 format('-a -w -t=',a,'Jav: ',a,a)
   19 format('-a -w -t=',a,'Jav: ',a,a,' -R=',a,f6.2,a,' -C=',a,
     *       3(f7.4,','),a)
!!mr     *       3(f7.4,';'),a)
   20 format('-a -w -t="Jav: ',a,'" -R="',f6.2,'" -C="', 
     *       3(f7.4,','),'"')
!mr     *       3(f7.4,';'),'"')
      end
!-------------------------------------------------------------------
