!#define JAV_VIEWER
! ----------------------------------------------------------------------
      subroutine MolPlo(iPlT, ifSingle)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE PhaseModule
#ifdef JAV_VIEWER
      USE ilmviewmod
      USE drawatoms
#endif
!
!      --------     MolPlo    ----------
!
      common /setequ/ kpatt,dummy(504)
!
      dimension B(3, 3)
!
#ifdef JAV_VIEWER
      if (.not.jav_opened()) then
          call ilmview_open(Structurename)
      endif
      call AggiornaJav()
#endif

      if (kmad == 0) then
          ifNoDraw = 0
          if (nolsq == 0 .and. ifSkeleton /= 0) then
              call Skto15
          endif
      else
          ifNoDraw = 1
      endif
!g    if (kscreen.eq.0) return
      call xspinb
      ifCentro = icent
      if (nsym == 1 .and. icent == 0) then
          ifGS_P1 = 1
      else
          ifGS_P1 = 0
      endif
!
      kcont=0
      CheScale = 1
!
      NF=0
*V2*  ifFirstTime = 1

!mr      if (iPlT.le.2) then
      if (iPlT.eq.STICKS.or.iPlT.eq.SIMPLE) then
          iPlotType = iPlT
      else
          if (iPlotType.eq.0) then
              iPlotType=SIMPLE
          endif
          ifFirstTime = 0
      endif
      if (nolsq == 0 .and. ifSkeleton /= 0) then
          call Skto15
          iPlotType = STICKS
      endif
      kplty=iPlotType
      ViewDist = 9.e33
!
      Lim1 = iVP(1)
      Lim2 = iVP(2)
      Lim3 = iVP(3)
      Lim4 = iVP(4)
      NPX = Lim3 - Lim1
      NPY = Lim4 - Lim2
      Ratio = float(NPX) / float(NPY)
!
      if (ifSkeleton == 0) then
          leggi = 1
      else
          leggi = 0
      endif
      call toMolPlo3(leggi)
      BTot11 = BTot(1,1)
!
      if (ifWasMad > 0) then
          iPlotType = STICKS_N_BALLS
      endif
!
      call LsPlane(NATV, 1)
!pgMAD10
      if (NATV == 0) then
         return
      endif
!pgMAD10
      IfLeg = iconn(1)
!
      if (IfLeg .eq.-1) then
          call BuildBonds(1)
          call LEtoIconn
      else
          call GetBonds(1)
      end if
!
      Rmin1 = 99999.
      Rmin2 = 99999.
      RMAX1 = -99999.
      RMAX2 = -99999.
!
      if (kpatt.gt.0) then
          iPlotType = STICKS
      endif
!
      if (BTot11.lt.100.0) then
          call RotazTot
      else
          do i = 1 , 3
             do j = 1 , 3
                BTot(i, j) = 0
             enddo
             BTot(i, i) = 1
          enddo
          call FindOr(B, 1)
      end if
      ifScale = 1
!
      if (kscreen.eq.0) return
!
      call EnableSingleIteration(0)
      if (ifSingle == 0) then
          SinglePlotType(1:NatMol) = iPlotType
      endif
      call Disegna(ifScale)
      call EnableSingleIteration(1)
!
      return
      end
! ---------------------------------------------------------------------
      subroutine DisegnaAtomi(ifNewPage, ifSingle)
      USE General
      USE Atomi
      USE Molcom
      USE Plotter
      USE PhaseModule
!
      common /movediamo3/ nplt, iplt(30000), nlegami(30000)
      real S(3)
!
      integer CC,X11,Y11
!
      natsOnly = NatInd - nSkel
      nCoppieHBond = 0
      do i = 1, NatMol + NatSpi
         RSCOPY(i) = 0
      enddo
      zmin = 9.e33
      zMax = -9.e33
      do 5 i=1, NatMol
         if (RS(i) .gt. 0) then
            if (zmin.gt.xyz(3,i)) zmin = xyz(3,i)
            if (zMax.lt.xyz(3,i)) zMax = xyz(3,i)
         end if
    5 continue
c      write(lo,*)'numleg,natmol,natspi',numleg,natmol,natspi
      iplt(1:NatMol) = 0
      do NLL = 1 , NumLeg
         N1 = LE(1, NLL)
         N2 = LE(2, NLL)
         N3 = LE(3, NLL)
         if (N3 < 0) cycle
         if (N1 > NatMol .or. N2 > NatMol) cycle
         if (N1 <= 0 .or. N2 <= 0) cycle
         iplt(N1) = 1
         iplt(N2) = 1
      enddo
      do NLL = 1 , NumLeg
         N1 = LE(1, NLL)
         N2 = LE(2, NLL)
         if (N1 <= 0 .or. N2 <= 0) cycle




c      write(lo,*)'nll,n1,n2',nll,n1,n2
         if (nzTot(N1).eq.1.and.ifHydro.eq.1.and.ifDrHydr.eq.0) then
             LE(1, NLL) = -iabs(LE(1, NLL))
         endif
         if (nzTot(N2).eq.1.and.ifHydro.eq.1.and.ifDrHydr.eq.0) then
             LE(1, NLL) = -iabs(LE(1, NLL))
         endif
      end do
!
      zmin = zmin -0.01
      zMax = zMax + 0.01
!mono
      do i = 1 , (NatMol + NatSpi) - 1
         do j = i + 1 , NatMol + NatSpi
            iO1 = iOrd(i)
            iO2 = iOrd(j)
            O3 = xyz(3,iO1)
            O4 = xyz(3,iO2)
            if (O3.GT.O4) then
               iOrd(i) = iO2
               iOrd(j) = iO1
            end if
         enddo
      enddo
      opi2 = 8. * PI * PI
      if (nRadType.gt.1 .or. iPlotType.eq.ELLIPSOIDS) then
         ragmed2 = 0.
         nr = 0
         do k=1, NatMol
            i=iEqui(k)
            if (RS(i) .gt. 0.0 .and. nzTot(i) .ne. 0) then
               if (nRadType .eq. 2) then
                  raa = xyzs(4, i)
               else
                  bfaci = abs(bfac(iEqui(i)))
                  if (bfaci.lt.0.01) then
                      bfaci = 0.01
                  endif
                  raa = sqrt(bfaci / opi2)
               end if
               ragmed2 = ragmed2 + raa
               nr = nr + 1
            end if
         enddo
         RagMed2 = (RagMed2 / nr)
         if (nRadType .eq. 2) then
            RagMedAng = RS(1) * (xyzs(4,1) / RagMed2)
         else
            RagMedAng = RagMed2
         end if
         ragmed = RagMedAng * x11scale(1)
      else
         RagMedAng = ragmed / x11scale(1)
      end if
      AAMM = (0.08 - 0.035) / (0.4 - 0.05)
      PPPP = -AAMM * 0.05 + 0.035
      if (RagMedAng .le. 0.05) then
         DLeg = 0.035
      elseif (RagMedAng .ge. 0.4) then
         DLeg = 0.08
      else
         DLeg = AAMM * RagMedAng + PPPP
      end if
!     DLeg = DLeg * 3.4

      DLeg = DLeg * 1.5
!
      if (ifNewPage.eq.1) call NewPage
!
      if (lspec.gt.0) then
          call DisegnaAddAtom
      endif
!
      icolBaseMono = 3
      DDX = (XMax - Xmin) / NPX
      DDY = (YMax - Ymin) / NPY
      do 50 III = 1 , NatMol + NatSpi
         IJ = iOrd(III)
!	write(lo,*)'iii,ij=iord(iii)',iii,iord(iii)
         if (RS(IJ).le.0.0) go to 50
         if (nzTot(IJ).eq.0 .and. ifGhost.eq.0) goto 50
         if (nzTot(IJ).eq.1.and.ifHydro.eq.1.and.ifDrHydr.eq.0) goto 50
!
         X11 = ipix(1,IJ)
         Y11 = ipix(2,IJ)
         CC = iCol(IJ)
         if (ifSingle == 1) then
             jPlotType = SinglePlotType(IJ)
         else
             jPlotType = iPlotType
         endif
!
         FatK = -xyz(3, IJ) / ViewDist + 1
         if (nRadType .eq. 1) then
            RSCOPY(IJ) = RS(IJ) / FatK
            ir = ipix(3,IJ)
         elseif (nRadType .eq. 2) then
            if (IJ.le.NatMol) then
                IJJ = iEqui(IJ)
                RSCOPY(IJ) =  abs(RS(1)) * (xyzs(4, IJJ) / ragmed2)
                ir = nint( RSCOPY(IJ) * x11scale(1) )
            else
                RSCOPY(IJ) = RS(IJ) / FatK
                ir = ipix(3,IJ)
            endif
         elseif (nRadType .eq. 3) then
            if (IJ.le.NatMol) then
                IJJ = iEqui(IJ)
                bfacij = abs(bfac(IJJ))
                if (bfacij.lt.0.01) bfacij = 0.01
                RSCOPY(IJ) =  sqrt(bfacIJ / opi2)
                ir = nint( RSCOPY(IJ) * x11scale(1) )
            else
                RSCOPY(IJ) = RS(IJ) / FatK
                ir = ipix(3,IJ)
            endif
         end if
         if (lspec.gt.0) then
             ir = min0(ir,15)
         endif
         do 40 NLL = 1 , NumLeg
            if (LE(3, NLL).lt.0) then
               goto 40
            end if
            N1 = LE(1, NLL)
            if (ifCell.eq.0 .AND. N1.gt.NatMol) goto 40
            N2 = LE(2, NLL)
            if (N1.NE.IJ.AND.N2.NE.IJ) goto 40
            if (N1 .LT. 0)  goto 40
            if (RSCOPY(N1) .le. 0 .OR. RSCOPY(N2) .le. 0)  goto 40
!
            if (ifSingle == 1) then
                iN1 = SinglePlotType(N1)
                iN2 = SinglePlotType(N2)
            else
                iN1 = iPlotType
                iN2 = iPlotType
            endif
            if (LE(3,NLL) == 10) then
                ifSolidLeg = -10
            elseif (LE(3,NLL) == 6) then
                ifSolidLeg = -6
            elseif (LE(3,NLL) == 5) then
                ifSolidLeg = -5
            elseif (LE(3,NLL) == 4) then
                ifSolidLeg = -4
            elseif (LE(3,NLL) == 3) then
                ifSolidLeg = -1
            elseif ((iN1 <= SIMPLE) .or. (iN2 <= SIMPLE)) then
                ifSolidLeg = 0
            else
                ifSolidLeg = 1
            endif
!
            RAN1 = xyz(3,N1)
            RAN2 = xyz(3,N2)
            if (RAN1.GT.RAN2) then
               NDUM = N1
               N1 = N2
               N2 = NDUM
            end if
            FatK1 = -xyz(3, N1) / ViewDist + 1
            FatK2 = -xyz(3, N2) / ViewDist + 1
            do 30 i = 1 , 3
               DU1 = xyz(i,N1) / FatK1
               DU2 = xyz(i,N2) / FatK2
               S(i) = DU1 - DU2
   30       continue
            SS = S(1) ** 2 + S(2) ** 2
            if (SS .LT. 0.001) then
               goto 34
            end if
            SSS = SS + S(3) ** 2
            RL = SQRT(SSS)
            RL2 = SQRT(SS)
            RN21 = xyz(1,N2) / FatK2
            RN22 = xyz(2,N2) / FatK2
            RN11 = xyz(1,N1) / FatK1
            RN12 = xyz(2,N1) / FatK1
            S1 = S(1)
            S2 = S(2)
            RR1 = RSCOPY(N1)
            if ( N2 .gt. NatMol ) then
               RR2 = RSCOPY(N2)
            else
               RR2 = (RSCOPY(N2) - 4 * DDX)
            endif
            p1 = S1 / RL2 * RR2 + RN21
            p2 = S2 / RL2 * RR2 + RN22
            p3 = -S1 / RL * RR1 + RN11
            p4 = -S2 / RL * RR1 + RN12
            P3RN = (p3 - RN21) ** 2
            P4RN = (p4 - RN22) ** 2
            P3P4 = P3RN + P4RN
            P3P4 = SQRT(P3P4)
            if (P3P4 .LT. RR2) then
               goto 40
            end if
            RN13 = xyz(3,N1)
            RN23 = xyz(3,N2)
            DEL = ABS(RN13 - RN23)
            DIS = RL
            RAP = (DIS - DEL) / DIS
!            RAP = 1.
*           RAP = (2.+RAP)/3.
            if (IJ.gt.NatMol) then
               call Linea0(p1, p2, p3, p4, iCol(IJ))
            else
               if (ifSolidLeg == 1) then
                   IJJ1=iEqui(N1)
                   lnz1 = iabs(nz(IJJ1)) / nzConst
                   IJJ2=iEqui(N2)
                   lnz2 = iabs(nz(IJJ2)) / nzConst
                   if (no(lnz1).eq.1.or.no(lnz2).eq.1) then
                      DLegN = DLeg / 1.5
                   else
                      DLegN = DLeg
                   end if 
               end if
               if (jPlotType .eq. ELLIPSOIDS) then
                  call CalInt (N1, N2, FatK1, FatK2)
               end if
               if (lspec.lt.0) then
                   call DisLeg()
               endif
               if (ifSolidLeg > -2) then
                  Ize = 0
                  if ((jPlotType < ELLIPSOIDS) .and.
     *                (jPlotType > STICKS)) then
                      if (jPlotType == SIMPLE) then
                          ir1 = 1
                      else
                          ir1 = ir
                      endif
                      call Cerchio ( X11, Y11, ir1, CC, Ize, Ize)
                  endif
               endif
            end if
!
   34       continue
            LE(1, NLL) = -LE(1, NLL)
   40    continue
         IJJ=iEqui(IJ)
         if (IJJ == 0) then
             cycle
         endif
c	write(lo,*)'ij,iequi(ij),nzTot(ij),jplottype,x11,y11,ir,cc',
c	1ij,iequi(ij),nzTot(ij),jplottype,x11,y11,ir,cc
         if (IJ.le.NatMol .and. iEqui(IJ) <= natsOnly) then
            if (jPlotType .LT. ELLIPSOIDS) then
               if (nzTot(IJ) /= PiccoFour) then
                   call DisePalle(jPlotType, IJ, X11, Y11, ir, CC)
               else
                   call Star(X11,Y11)
               endif
            else
               lnz = iabs(nz(IJJ)) / nzConst
               if (lnz /= PiccoFour) then
                   if (lnz == 0 .or. lnz == PiccoFour) then
                      call DisePalle(jPlotType, IJ, X11, Y11, ir, CC)
                   else if (no(lnz).eq.1) then
                      call DisePalle(jPlotType, IJ, X11, Y11, ir, CC)
                   else
                      call DisEll(ij,CC)
                   end if
               else
                   call Star(X11,Y11)
               end if
            end if
!cccccccccccccccccccccccccccccccccccccccccccccccccccc
*           if (nzTot(IJJ).eq.0 
*    *         .and. jPlotType.ne.STICKS_N_BALLS) then
            if (nzTot(IJJ).eq.0) then 
! 20 06 2004 gianluca
                 if (jPlotType == SIMPLE) then
                     IRT = 1
                 else
*                    IRT = 0.6 * ir - 2
                     IRT = 0.7 * ir - 2
                     if (IRT .gt. ir-2) IRT = ir-2
                     if (IRT .lt. 1) IRT = 1
                 endif
! 20 06 2004 gianluca
               IfF = -1
               iCC=0
               call Cerchio( X11, Y11, IRT, iCC, IfF, iCC)
               if (jPlotType.eq.SHADING) then
                  IfF = 0
                  iCC = CC
                  call Cerchio( X11, Y11, IRT, iCC, IfF, iCC)
               end if
            end if
         end if
   50 continue
!
      do i = 1, NumLeg
         LE(1, i) = iabs(LE(1, i))
      enddo
      do i = 1, NatMol + NatSpi
         RSCOPY(i) = 0
      enddo
      if (ifFour.ne.0) then
          call AllStars
      endif
      do i=1, NatMol
         if (iplt(i) == 0) then
             jPlotType = SinglePlotType(i)
             if (jPlotType == STICKS) then
                 call Punto(ipix(1,i),ipix(2,i),iCol(i))
             endif
         endif
      enddo
!
      return
      end
! --------------------------------------------------------------------
      subroutine CerchioPiccolo(N1, X11, Y11)
      USE General
      USE Atomi, only : nzTot
      USE Molcom
!
      integer CC1, X11, Y11, PiccoloRaggio
!
      PiccoloRaggio = 1
      CC1 = iCol(N1)
      icolBaseMono = 3
      iCC = color_GRAY
      IfF = -1
      call Cerchio(X11, Y11, 3 * PiccoloRaggio, iCC, IfF, iCC)
      iCC = jBackGround
      call Cerchio(X11, Y11, 4 * PiccoloRaggio, iCC, IfF, iCC)
      if (nzTot(N1).eq.1.and.ifHydro.eq.1) then
          call Cerchio(X11, Y11, 2 * PiccoloRaggio, CC1, IfF, CC1)
      else if (nzTot(N1).eq.0) then
          IfF = -1
          iFC = jBackGround
          call Cerchio(X11, Y11, 2 * PiccoloRaggio, CC1, IfF, iFC)
      else if(nzTot(N1) /= PiccoFour) then
           call Cerchio(X11, Y11, 3 * PiccoloRaggio, CC1, IfF, CC1)
           IDum = color_RESTR
           kk1 = X11 + PiccoloRaggio
           kk2 = nint(Y11 - 2 * DDY)
           call Punto(kk1, kk2, IDum)
      endif
!
      return
      end
! --------------------------------------------------------------------
      subroutine VanderWaals(ifNewPage)
      USE General
      USE Atomi
      USE Molcom
      USE PhaseModule
!
      integer X11, Y11, atomo
      integer RaggioRod, RaggioRodCell

!
      call AllocaGBuffer(1)
!
*         do i = 1 , nk
*            write(6,*) i, radii(i,1:2)
*         enddo
      distmed = 0.0
      amed = 0.0
      do i=1,NumLeg
         if (LE(3, i).gt.0) then
               N1 = LE(1,i)
               N2 = LE(2,i)
               disx = xyz(1,N1) - xyz(1,N2)
               disy = xyz(2,N1) - xyz(2,N1)
               disz = xyz(3,N1) - xyz(3,N1)
               arg = disx ** 2 + disy ** 2 + disz ** 2
               distmed = distmed + sqrt(arg)
               amed = amed + 1.0
           endif
      enddo
      if (amed.gt.0.0) then
          distmed = distmed / amed
          raggio = 0.25 * distmed
      else
          a = 0.2433333 ! raggio del carbonio
          raggio = a / 3.0
      endif
      RaggioRod = nint( raggio*x11scale(1) )
      RaggioRod = ( RaggioRod / 2 ) * 2
      RaggioRodCell = RaggioRod / 2
!
      if (IfScale.ne.0) then
          Rmin1 = 99999
          Rmin2 = 99999
          RMAX1 = -99999
          RMAX2 = -99999
          call FindMinMax
          raggiomassimo = 0
          do i = 1 , nk
             if (radii(i,2).gt.raggiomassimo) then
                 raggiomassimo = radii(i,2)
             endif
          enddo
          Rmin1 = Rmin1 - raggiomassimo
          Rmin2 = Rmin2 - raggiomassimo
          RMAX1 = RMAX1 + raggiomassimo
          RMAX2 = RMAX2 + raggiomassimo
          call SetScale(1)
          call AngToPix
      end if
!
      zmin = 999999
      zmax = -999999
      if (ifCell .eq. 0 ) then
          ifin = NatMol
      else
          ifin = NatMol + NatSpi
      endif
      do i = 1 , ifin
         iOrd(i) = i
         if (xyz(3,i).lt.zmin) then
             zmin = xyz(3,i)
         endif
         if (xyz(3,i).gt.zmax) then
             zmax = xyz(3,i)
         endif
      enddo
!
      if (ifNewPage.eq.1) call NewPage
!
      if (zmin.lt.0) then
          zmin = zmin * 1.1
      else
          zmin = zmin * 0.9
      endif
!
      ixv(5) = nint((zmax - zmin)* x11scale(1))
      if (ifCell.eq.1) then
          call DisegnaCellaRods(RaggioRodCell)
      endif
!
      do i = 1 , NatMol  - 1
         do K = i + 1 , NatMol
            iO1 = iOrd(i)
            iO2 = iOrd(K)
            O3 = xyz(3,iO1)
            O4 = xyz(3,iO2)
            if (O3.LT.O4) then
                iOrd(i) = iO2
                iOrd(K) = iO1
            end if
         enddo
      enddo
!
      mrsqrt = sqrt(2.0) + 0.5
      do ii=1,NatMol
         atomo = iOrd(ii)
         izz = nzTot(atomo)
         iOK = 1
         if (nzTot(atomo) == PiccoFour) then
             iOK = 0
         endif
         if (RS(atomo).lt.0) then
             iOK = 0
         endif
         if (izz.gt.0.and.izz.le.nk) then
             ragg = radii(izz,2)
         else
             if (ifGhost.gt.0) then
                 ragg = radii(1,2) / 2.0
             else
                 iOK = 0
             endif
         endif
         if (nzTot(atomo) == PiccoFour .or.
     *       nzTot(atomo).eq.1.and.ifHydro.eq.1.and.ifDrHydr.eq.0) then
             iOK = 0
         endif
         if (iOK.eq.1) then
             X11 = ipix(1,atomo)
             Y11 = ipix(2,atomo)
             quotaAt   = (xyz(3,atomo) - zmin) * x11scale(1)
             iq = nint(quotaAt)
             raggioAng = ragg
             raggio    = raggioAng * x11scale(1)
             iraggio    = nint(raggio)
             ic1 = iCol(atomo)
             ixlux =  -40      !mr
             iylux =  70      !mr
             ixv(5) = nint((zmax - zmin)* x11scale(1))   ! mr
             call Palla(X11, Y11, iq, iraggio, ic1, ixlux, iylux)
         endif
      enddo
!
      call AllocaGBuffer(0)
!
      return
      end
! --------------------------------------------------------------------
      subroutine RodsType(ifNewPage)
      USE General
      USE Atomi, only : nzTot
      USE Molcom
!
! ---
      common /movediamo3/ nplt, iplt(30000), nlegami(30000)
      integer O1, O2, RaggioRod, RaggioRodCell
! ---
      call AllocaGBuffer(1)
!
      kxyz = 1
      call AveBondDist(distmed, amed, kxyz)
      if (amed.gt.0.0) then
          distmed = distmed / amed
          raggio  = distmed / 8.0
          raggio  = distmed / 6.0                 !mrmrmrmr
      else
          a = 0.2433333 ! raggio del carbonio
          raggio = a / 3.0
      endif
      RaggioRod = nint( raggio*x11scale(1) )
      RaggioRod = ( RaggioRod / 2 ) * 2

      RaggioRod = min(RaggioRod, 32)             !mrmrmr

      RaggioRodCell = RaggioRod / 2
      RaggioRodCell = 1
! ---
      zmin = 9.e33
      zMax = -9.e33
      if (ifCell .eq. 0 ) then
          ifin = NatMol
      else
          ifin = NatMol + NatSpi
      endif
      do i=1, ifin
         if (RS(i) .gt. 0) then
            if (zmin.gt.xyz(3,i)) zmin = xyz(3,i)
            if (zMax.lt.xyz(3,i)) zMax = xyz(3,i)
         end if
      enddo
      zmin = zmin -0.01
      zMax = zMax + 0.01
      if (zmin.lt.0) then
          zmin = zmin * 1.1
      else
          zmin = zmin * 0.9
      endif
      ixv(5) = nint((zmax - zmin)*x11scale(1)/6.) ! mr
!
      do i = 1, NatMol + NatSpi
         iOrd(i) = i
      enddo
      do i = 1, NatMol
         iplt(i)    = 0
         nlegami(i) = 0
      enddo
      do NLL = 1 , NumLeg
!         if ((LE(3, NLL) >= 0) .and. (LE(3, NLL) /= 3)) then
          if (LE(3, NLL) >= 0) then
             N1 = LE(1, NLL)
             N2 = LE(2, NLL)
             if (N1.le.NatMol) then
                 nlegami(N1) = nlegami(N1) + 1
             endif
             if (N2.le.NatMol) then
                 nlegami(N2) = nlegami(N2) + 1
             endif
         endif
      enddo
!
      do i = 1, NatMol - 1
         do K = i + 1, NatMol
            O1 = iOrd(i)
            O2 = iOrd(K)
            O3 = xyz(3,O1)
            O4 = xyz(3,O2)
            if (O3 .GT. O4) then
               iOrd(i) = O2
               iOrd(K) = O1
            end if
         enddo
      enddo
! ---
      if (ifNewPage.eq.1) call NewPage
! ---
!mrmrmr
      if (ifCell.eq.1) then
          call DisegnaCellaRods(RaggioRodCell)
      endif
!mrmrmr
      do JJ = 1 , NatMol
         IJ = iOrd(JJ)
         iOK = 1
         if (RS(IJ) .LE. 0) then
             iOK = 0
         endif
         if (nzTot(IJ).eq.0 .and. ifGhost.eq.0) then
             iOK = 0
         endif
         if (nzTot(IJ).eq.1.and.ifHydro.eq.1 .and. ifDrHydr.eq.0) then
             iOK = 0
         endif
         if (iOK.eq.1) then
             ZETA = xyz(3,IJ)
             Legato = 0
             do NLL = 1 , NumLeg
                if (LE(3, NLL).ge.0) then
                    iOK = 1
                    ifHB = 0
                    N1 = LE(1, NLL)
                    N2 = LE(2, NLL)
                    if (LE(3, NLL).eq.3) then
                         ifHB = 1
                    endif
                    if (N1.NE.IJ.AND.N2.NE.IJ) then
                        iOK = 0
                    endif
                    if (N1 .EQ. IJ .AND. xyz(3,N2) .GT. ZETA)  then
                        iOK = 0
                    endif
                    if (N2 .EQ. IJ .AND. xyz(3,N1) .GT. ZETA)  then
                        iOK = 0
                    endif
                    if (RS(N1) .LE. 0 .OR. RS(N2) .LE. 0)  then
                        iOK = 0
                    endif
                    if (iOK.eq.1) then
                        if (nzTot(N1).eq.1.and.ifHydro.eq.1.
     *                                     and.ifDrHydr.eq.0) then
                            iOK = 0
                        endif
                        if (nzTot(N2).eq.1.and.ifHydro.eq.1.
     *                                     and.ifDrHydr.eq.0) then
                            iOK = 0
                        endif
                        if (iOK.eq.1) then
                            jRaggioRod = RaggioRod
                            ixv(5) = nint((zmax - zmin)*x11scale(1)/6.) ! mr
                            ixv(6) = nlegami(N1)                        ! mr
                            ixv(7) = nlegami(N2)                        ! mr
                            call BiLegame(ifHB, N1, N2, jRaggioRod, NLL)
                            iplt(N1) = 1
                            iplt(N2) = 1
                         endif
                    endif
                endif
             enddo
         endif
      enddo
      do JJ = 1 , NatMol
         IJ = iOrd(JJ)
         if (RS(IJ) .gt. 0.and.iplt(IJ).eq.0) then
            if (nzTot(IJ) /= PiccoFour .and.
     *          nzTot(IJ).eq.1.and.ifHydro.eq.0.or.
     *          nzTot(IJ).eq.1.and.ifHydro.eq.1.and.ifDrHydr.eq.1) then
                ix = ipix(1, IJ)
                iy = ipix(2, IJ)
                ic1 = iCol(IJ)
                iq  = nint( (xyz(3,IJ) - zmin) * x11scale(1) / 6. )
                ixlux = 0
                iylux = 0
                call Palla(ix, iy, iq, RaggioRod, ic1, ixlux, iylux)
            end if
         end if
      enddo
!
      call AllocaGBuffer(0)
!
      return
      end
! -----------------------------------------------------------------
      subroutine BiLegame(ifHB, N1, N2, iRaggio, legame)
      USE Molcom
!
      integer tipo
!
      ixv(1) = ipix(1,N1)
      ixv(2) = ipix(1,N2)
      iyv(1) = ipix(2,N1)
      iyv(2) = ipix(2,N2)
      if (iPlotType.eq.RODS) then
          ixv(3) = nint( ( xyz(3,N1) - zmin) * x11scale(1) / 6.)
          ixv(4) = nint( ( xyz(3,N2) - zmin) * x11scale(1) / 6.)
      else
          ixv(3) = nint( ( xyz(3,N1) - zmin) * x11scale(1))
          ixv(4) = nint( ( xyz(3,N2) - zmin) * x11scale(1))
      endif
      if (legame > 0) then
          tipo = LE(3, legame)
          if (tipo == 4) then
              ir = 3 ! RaggioRodCell
              iC1 = color_YELLOW
              iC2 = color_YELLOW
          else
              ir = iRaggio
              iC1 = iCol(N1)
              iC2 = iCol(N2)
          endif
      else
          ir = iRaggio
          iC1 = iCol(N1)
          iC2 = iCol(N2)
      endif
!
      call Togo(ifHB, ir, iC1, iC2)
!
      return
      end
! --------------------------------------------------------------------
      subroutine AveBondDist(distmed, amed, kxyz)
      USE Molcom
!
!-- Average Bond Distance calculation
!
      distmed = 0.0
      amed = 0.0
      if (kxyz.eq.1) then
          do i=1,NumLeg
             if (LE(3, i).gt.0) then
                 N1 = LE(1,i)
                 N2 = LE(2,i)
                 if (N1.le.NatMol.and.N2.le.NatMol) then
                     if (RS(N1).gt.0.and.RS(N2).gt.0) then
                         disx = xyz(1,N1) - xyz(1,N2)
                         disy = xyz(2,N1) - xyz(2,N2)
                         disz = xyz(3,N1) - xyz(3,N2)
                         arg = disx ** 2 + disy ** 2 + disz ** 2
                         distmed = distmed + sqrt(arg)
                         amed = amed + 1.0
                     endif
                 endif
             endif
          enddo
      else
          do i=1,NumLeg
             if (LE(3, i).gt.0) then
                 N1 = LE(1,i)
                 N2 = LE(2,i)
                 if (N1.le.NatMol.and.N2.le.NatMol) then
                     if (RS(N1).gt.0.and.RS(N2).gt.0) then
                         disx = xyzPov(1,N1) - xyzPov(1,N2)
                         disy = xyzPov(2,N1) - xyzPov(2,N2)
                         disz = xyzPov(3,N1) - xyzPov(3,N2)
                         arg = disx ** 2 + disy ** 2 + disz ** 2
                         distmed = distmed + sqrt(arg)
                         amed = amed + 1.0
                     endif
                 endif
             endif
          enddo
      endif
!
      return
      end
! --------------------------------------------------------------------
      subroutine CombRot(B)
      USE General
      USE Molcom
!

      dimension du(3, 3), vu(10), W(3, 3), B(3,3)
!
      if (nint(RK(2)) .EQ. 0) then
          return
      end if
      do 20 ISS = 1 , 3
         do 10 kSSI = 1 , 3
            du(ISS, kSSI) = 0
   10    continue
   20 continue
      aT = dtor * RK(1)
      dSinT = SIN(aT)
      dCosT = COS(aT)
      if (nint(RK(2)) .EQ. 1) then
         du(1, 1) = 1
         du(2, 2) = dCosT
         du(3, 3) = dCosT
         du(2, 3) = -dSinT
         du(3, 2) = dSinT
      end if
      if (nint(RK(2)) .EQ. 2) then
         du(1, 1) = dCosT
         du(1, 3) = dSinT
         du(2, 2) = 1
         du(3, 1) = -dSinT
         du(3, 3) = dCosT
      end if
      if (nint(RK(2)) .EQ. 3) then
         du(1, 1) = dCosT
         du(1, 2) = -dSinT
         du(2, 1) = dSinT
         du(2, 2) = dCosT
         du(3, 3) = 1
      end if
      if (nint(RK(2)) .EQ. 4) then
         NRTO = RK(3)
         PAR = VV(NRTO, 1) ** 2 + VV(NRTO, 2) ** 2
         PAR = PAR + VV(NRTO, 3) ** 2
         DDN = SQRT(PAR)
!
         if (abs(DDN) < 0.001) DDN = 0.001  ! gianluca 06/10/2010
!
         do 30 i = 1 , 3
            vu(i) = VV(NRTO, i) / DDN
   30    continue
         vu(4) = -vu(2)
         vu(5) = vu(1)
         ANG = RK(1)
         RO = dtor * ANG
         CoRo = COS(RO)
         SiRo = SIN(RO)
         UCoRo = 1 - CoRo
         do 50 i = 1 , 3
            do 40 j = i , 3
               du(i, j) = vu(i) * vu(j) * UCoRo
               if (i.EQ.j) then
                  du(i, j) = du(i, j) + CoRo
               else
                  du(j, i) = du(i, j) + vu(i + j) * SiRo
                  du(i, j) = du(i, j) - vu(i + j) * SiRo
               end if
   40       continue
   50    continue
      end if

      call MoltMatMat(du, B, W)

      do 70 i = 1 , 3
         do 60 j = 1 , 3
            B(i, j) = W(i, j)
   60    continue
   70 continue
!
      end
! ----------------------------------------------------------------------
      subroutine RotTot(B)
      USE Molcom
!
      dimension B(3,3), W(3,3)
!
      call MoltMatMat(B, BTot, W)
      do 170 i = 1 , 3
         do 160 j = 1 , 3
            BTot(i, j) = W(i, j)
  160    continue
  170 continue
!
      return
      end
! ----------------------------------------------------------------------
      subroutine Rotaz(Angolo, Asse, B)
!
      USE Molcom
!
      real B(3,3)
      integer Angolo, Asse
!
      RK(1) = Angolo
      RK(2) = iabs(Asse)
      if (Asse .gt. 0) then
         do i = 1 , 3
            do j = 1 , 3
               B(i, j) = 0
            enddo
            B(i, i) = 1
         enddo
      end if
      call CombRot(B)
      call RotTot(B)
      Rmin1 = 99999
      Rmin2 = 99999
      RMAX1 = -99999
      RMAX2 = -99999
      call RotAtoms(B, 1)
      if (IfScale.ne.0) then
         call FindMinMax
      end if
!
      return
      end
! -----------------------------------------------------------------
      subroutine RotazTot
!
      USE Molcom
!
      if (AtomiBloccati == 0) then
          Rmin1 = 99999
          Rmin2 = 99999
          RMAX1 = -99999
          RMAX2 = -99999
          call RotAtoms(BTot, 1)
          call FindMinMax
      else
!
!-- annulla la rotazione totale
!-- non shifta gli atomi con FindMinMax
!
          BTot(:,:) = 0.0
          BTot(1,1) = 1.0
          BTot(2,2) = 1.0
          BTot(3,3) = 1.0
          call RotAtoms(BTot, 1)
      endif
!
      return
      end
! -----------------------------------------------------------------
      subroutine Disegna(ifScal)
      USE General
      USE Molcom
      USE Plotter
      USE Poliedri
      USE RemoModule
      USE PhaseModule
      USE LsqModule
!
      common /SaveRbyM/ ifDragged, B(3,3), iDxV, iDyV,
     *                  ifLabelsDrag, iPlotTypeDrag
      common /InitialPlotCommon/ ifInitial
!
!     if (kmad /= 0) then
      if (jscreen == 0)  then
        return
      endif
!!mr
      if (ifDrawContour == 1) then
          call PlotContour()
          call Sistemino
          call zflush
          return
      endif
!!end mr
      if (ifMadEnv == 2 .and. ifRemo == 0) then
          if (WhichFom > 1) then
              call DisegnaMad(0)
          endif
          return
      endif
      if (ifRemo == 1) then !  07/05/09 da verificare
          if (ifSkeletonOn == 0) then
              call DataForGraph(6, 0)
              return
**        else
**            NatMol = nSkel
          endif
      endif
      if (nolsq == 0 .and. ifSkeleton == 0) then
          ifNoDraw = 1
      else
          ifNoDraw = 0
      endif
!!mr  if (ifDrawContour == 1) then
!!mr      call PlotContour()
!!mr      call Sistemino
!!mr      call zflush
!!mr      return
!!mr  else
          if (ifNoDraw == 1) then
              return
          endif
!!mr  endif
      if (NatMol == 0) then
          return
      endif
      call SetScale(IfScal)
      call AngToPix
!
      if (ifDragged == 1) then
         ifNewPage = 1
         call PlotStyleDrag(ifNewPage)
         if (ifFour /= 0) then
             call AllStars
         endif
      elseif (iPlotType == RODS) then
         ifNewPage = 1
         call RodsType(ifNewPage)
         if (ifFour /= 0) then
             call AllStars
         endif
      else if (iPlotType == VAN_DER_WAALS) then
         ifNewPage = 1
         call VanderWaals(ifNewPage)
         if (ifFour /= 0) then
             call AllStars
         endif
      else
         ifNewPage = 1
         ifSingle = 1
         call DisegnaAtomi(ifNewPage, ifSingle)
      end if
!
      if (ifTraccia == 1) then
          call DrawTraccia()
      endif
      if (ifLabels /= 0 .or. ifRigidBody == 1) call DrawLabels()
!
      if (ifDrRes /= 0) then
          call DrawRestraints()
      end if
      if (SelectingSites /= 0) then
          call  ClickForSite(1)
      end if
      if (nptrc > 0) then
          call DrawCrosses()
      endif
      if ((nLabelHyd > 0) .and. (ifLabels == 0)) then
          call LabelHydro()
      endif
!
      if ((ViewDist /= 60.06) .and. (lspec < 0)) then
         call Sistemino
      end if
!
      if (ifCubo >= 0) then
          call Cubo
      endif
!
      if (ifViewModel == 1) then
          call DisegnaModello(ifDragged)
      endif
!
      if (ifRemoLegend > 0) then
          ixv(1) = kscrx - 4 * FntPixHeight - ifRemoLegend
          iyv(1) = kscry - 2 * FntPixHeight
          iColor = color_LIGHTBLUE
          call DrawLabel(ixv(1), iyv(1), RemoLegend, iColor, 3)
      endif
!
      call zflush
!
      return
      end
! -----------------------------------------------------------------
      subroutine DrawCrosses()
      USE Molcom
!
      do i=1,nptrc
         j = kptrcopy(i)
         if (RS(j).gt.0) then
             ixx = ipix(1,j)
             iyy = ipix(2,j)
             call Linea(ixx-6, iyy, ixx+6, iyy, icoWire)
             call Linea(ixx, iyy-6, ixx, iyy+6, icoWire)
         endif
      enddo
!
      return
      end
! -----------------------------------------------------------------
      subroutine LabelHydro()
      USE General, only: Labb
      USE Molcom
!
      iColor = color_LABS
      fy = FntPixHeight
      do L1=1, nLabelHyd
         N1 = LabelHyd(L1)
         L = Lung(Lab(N1))
         if (L .GT. 0) then
            Labb = Lab(N1)
            fx = LenInPix(Labb,2)
            iix = ipix(1,N1)
            iiy = ipix(2,N1)
            ir  = fx / 2
            iCC = jBackGround
            IfF = 1
            call Cerchio( iix, iiy, ir, iCC, IfF, iCC)
            ixv(1) = iix - fx / 2.0
            iyv(1) = iiy + fy  / 4.0
            call DrawLabel(ixv(1), iyv(1), Labb, iColor, 2)
         end if
      enddo
!
      return
      end
! -----------------------------------------------------------------
      subroutine DrawFewLabels(jAtom,iAction)
      USE Molcom
!
      common /Distanze/ ndist, dis(300), nop(300), ifDist
!
      if (ifLabels.eq.0) then
          if (iAction.eq.1) then
              nLabelHyd = ndist + 1
              j = 1
              LabelHyd(j) = jAtom
              do i=1, nDist
                 j = j + 1
                 k = kptr(i)
                 LabelHyd(j) = iEqui(k)
              enddo
              nptrc = 0
              call Disegna(0)
          else
              nLabelHyd = 0
          endif
      else
          call Disegna(0)
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine Sistemino
      USE Molcom
      USE PhaseModule
!
      dimension xs(3,4),ipx(2,4)
!
      character *1 Lb(3)
!
      Lb(1)='a'
      Lb(2)='b'
      Lb(3)='c'
      do i=1,4
         do j=1,3
            xs(j,i) = xyz(j,NatMol + i)
         enddo
      enddo
      raa = 1./x11scale(1)
      do i=1,4
         am = 0.
         if (i.lt.4) then
            do j=1,3
               am = am + (xs(j,i)-xs(j,4))**2
            enddo
            am = sqrt(am)
            do j=1,3
             if ( abs(am).gt.0.0001) then
               xs(j,i) = 30. * raa * (xs(j,i)-xs(j,4)) / am + xs(j,4)
             end if
            enddo
         end if
         f = xs(3,i)
         FatK = -f / ViewDist + 1
         a = ( xs(1,i)/FatK + x11disp(1) ) * x11scale(1)
         b = ( xs(2,i)/FatK + x11disp(2) ) * x11scale(2)
         ipx(1,i)=nint(a)
         ipx(2,i)=iVP(4) - nint(b)
      enddo

      dxp = ipx(1,4)
      dyp = ipx(2,4)
      do 65 i=1,4
         ipx(1,i) = ipx(1,i) - dxp + 40
         ipx(2,i) = ipx(2,i) - dyp + iVP(4) - 40
 65   enddo

      do i=1,3
         ix = ipx(1,i)
         iy = ipx(2,i)
         call Linea(ix,iy,ipx(1,4),ipx(2,4),icoWire)
         call DrawLabel(ix + 3, iy - 3, Lb(i), icoWire, 2)
      enddo
!
      return
      end
! ----------------------------------------------------------------------
      subroutine DisePalle(jPlotType, IJ, X11, Y11, ir, CC)
      USE General
      USE Atomi, only : nzTot
      USE Molcom
!
      integer CC
      integer X11, Y11
!
      if (jPlotType == STICKS) then
          return
      elseif (jPlotType == SIMPLE) then
          call CerchioPiccolo(IJ, X11, Y11)
      else
          IfF = 1
          iCC = color_GRAY
          call Cerchio( X11, Y11, ir + 1, iCC, IfF, iCC)
          iCC = jBackGround
          call Cerchio( X11, Y11, ir + 1, iCC, IfF, iCC)
          if (jPlotType.eq.BUBBLES .or. jPlotType.eq.ELLIPSOIDS) then
             IfF = 0
          end if
          iCC = CC
          iFC = iCC
          if (nzTot(IJ) /= PiccoFour) then
              if ((jPlotType == SHADING) .and. (ir.gt.0.1)) then
                   call SfumaPalleBelle(X11, Y11, ir, iFC)
              else
                   call Cerchio( X11, Y11, ir, iCC, IfF, iFC)
                   if (ifLabels.ne.1) then
                       iPP = nint(0.2 * ir)
                       if (iPP .LT. 1) iPP = 1
                       iX11=nint(X11+0.35*ir)
                       iY11=nint(Y11-0.35*ir)
                       iPieno = 1
                       iFC = color_BRIGHTWHITE
                       call Cerchio( iX11, iY11, iPP, iCC, iPieno, iFC)
                   endif
              endif
          else
              call Star(X11,Y11)
          end if
      end if
!
      return
      end
! -----------------------------------------------------------------
      subroutine RotVect(G,Ro,du)
      dimension G(3),du(3,3),vu(5)
!
      Par = G(1) ** 2 + G(2) ** 2 + G(3) ** 2
      ddn = SQRT(Par)
      do 30 i = 1 , 3
         vu(i) = G(i) / ddn
   30 continue
      vu(4) = -vu(2)
      vu(5) = vu(1)
      CoRo = COS(Ro)
      SiRo = SIN(Ro)
      UCoRo = 1 - CoRo
      do 50 i = 1 , 3
         do 40 j = i , 3
            du(i, j) = vu(i) * vu(j) * UCoRo
            if (i.EQ.j) then
               du(i, j) = du(i, j) + CoRo
            else
               du(j, i) = du(i, j) + vu(i + j) * SiRo
               du(i, j) = du(i, j) - vu(i + j) * SiRo
            end if
   40    continue
   50 continue

      return
      end
! -----------------------------------------------------------------
      subroutine DisLeg()
      USE Molcom
      USE Plotter
!
      real xy(8)
!
      integer CC1, CC2, XX1, YY1, XX2, YY2
      integer XX3, YY3, XX1B, XX2B, YY1B, YY2B
!
      DOUBLE PRECISION dM8, dM9
!
      if (ifSolidLeg == -10) then      ! legame dashed
          iColor = color_LIGHTMAGENTA
          N1 = LE(1,NLL)
          N2 = LE(2,NLL)
          ix1 = ipix(1,N1)
          iy1 = ipix(2,N1)
          ix2 = ipix(1,N2)
          iy2 = ipix(2,N2)
          call Linea_dash (ix1, iy1, ix2, iy2, iColor)   
      elseif (ifSolidLeg <= -4) then      ! legame spesso
              if (ifSolidLeg == -4) then      ! skeleton
                  iColor = color_LIGHTBLUE
                  iColor = iCol(LE(1,NLL))
              elseif (ifSolidLeg == -5) then  ! Rigid Group
                  iColor = color_LIGHTGREEN
              elseif (ifSolidLeg == -6) then  ! Rotamer
                  iColor = color_LIGHTMAGENTA
              endif
              N1 = LE(1,NLL)
              N2 = LE(2,NLL)
              ix1 = ipix(1,N1)
              iy1 = ipix(2,N1)
              ix2 = ipix(1,N2)
              iy2 = ipix(2,N2)
              iRaggio = 2
              call LineaSpessa(ix1, iy1, ix2, iy2, iColor, iRaggio)
      elseif (ifSolidLeg == -1) then  ! legame idrogeno
          if (ifDrHBond == 1) then  
              iColor = color_CELL
              N1 = LE(1,NLL)
              N2 = LE(2,NLL)
              ix1 = ipix(1,N1)
              iy1 = ipix(2,N1)
              ix2 = ipix(1,N2)
              iy2 = ipix(2,N2)
              call Linea_dash (ix1, iy1, ix2, iy2, iColor)
              nCoppieHBond = nCoppieHBond + 1
!
          endif
      elseif (ifSolidLeg == 0) then  ! legame STICKS / SIMPLE
!
          N1 = LE(1,NLL)
          N2 = LE(2,NLL)
          XX1 = ipix(1,N1)
          XX2 = ipix(1,N2)
          YY1 = ipix(2,N1)
          YY2 = ipix(2,N2)
          XX1B = XX1
          XX2B = XX2
          YY1B = YY1
          YY2B = YY2
          xd1 = 0
          yd1 = 0
          ixv(1) = nint(XX1B + yd1)
          ixv(2) = nint(XX2B + yd1)
          iyv(1) = nint(YY1B - xd1)
          iyv(2) = nint(YY2B - xd1)
          ixv(4) = nint(XX1B - yd1)
          ixv(3) = nint(XX2B - yd1)
          iyv(4) = nint(YY1B + xd1)
          iyv(3) = nint(YY2B + xd1)
          iz=4
          iColor = jBackGround
          jFill = 1
          call Poligono(iz,iColor,jFill)
          XX3 = (XX1 + XX2) / 2
          YY3 = (YY1 + YY2) / 2
          CC1 = iCol(N1)                ! + 8
          CC2 = iCol(N2)                ! + 8
          call Linea (XX1B, YY1B, XX3,  YY3,  CC1)
          call Linea (XX3,  YY3,  XX2B, YY2B, CC2)
!
      else                                       ! legame "solido"
!
          icolBaseMono = 3
          RAP = .2 + .8 * RAP
          DLegU = DLegN
          DLegR = DLegN * RAP 
          nShades = 7
          do ikl = 1, nShades
             if (ABS(p1 - p3) .LT. .00001) then
                DLegU = DLegU - (ikl-1)*DLegU/nShades
                x11 = p1 - DLegU
                y11 = p2
                x12 = p1 + DLegU
                y12 = p2
                x21 = p3 - DLegU
                y21 = p4
                x22 = p3 + DLegU
                y22 = p4
                goto 100
             else
                dM8 = (p4 - p2) / (p3 - p1)
             end if
             if (ABS(dM8) .GT. .00001) then
                 dM9 = -1. / dM8
             else
                DLegR = DLegR - (ikl-1)*DLegR/nShades
                x11 = p1
                y11 = p2 - DLegR
                x12 = p1
                y12 = p2 + DLegR
                x21 = p3
                y21 = p4 - DLegR
                x22 = p3
                y22 = p4 + DLegR
                goto 100
             end if

             dfkk1 = (DLegN  * dM8) / SQRT(dM8 * dM8 + 1.)
             dfkk2 = (DLegN * RAP * dM8) / SQRT(dM8 * dM8 + 1)
  
             dfk1 = dfkk1 - (ikl-1)*dfkk1/nShades
             dfk2 = dfkk2 - (ikl-1)*dfkk2/nShades
             x11 = p1 + dfk1
             y11 = dM9 * x11 + p1 / dM8 + p2
             x12 = p1 - dfk1
             y12 = dM9 * x12 + p1 / dM8 + p2
             x21 = p3 + dfk2
             y21 = dM9 * x21 + p3 / dM8 + p4
             x22 = p3 - dfk2
             y22 = dM9 * x22 + p3 / dM8 + p4

  100        xy(1) = x11
             xy(2) = y11
             xy(3) = x12
             xy(4) = y12
             xy(5) = x22
             xy(6) = y22
             xy(7) = x21
             xy(8) = y21
             do i=1,4
                a = ( xy(i*2-1) + x11disp(1) ) * x11scale(1)
                b = ( xy(i*2  ) + x11disp(2) ) * x11scale(2)
                ixv(i)=nint(a)
                iyv(i)=iVP(4) - nint(b)
             enddo
             ixv(5)=ixv(1)
             iyv(5)=iyv(1)
             iz=5
             LegCol = color_BONDS
             LegCol1 = LegCol
             call PoligonoSh(iz,LegCol1,ikl,7)
          end do
      endif
!
      return
      end
! -----------------------------------------------------------------
      subroutine EllPrinc(RJ, G, EL, N1, H, C)
      USE Molcom
!
      dimension S(3), G(3), E(3), H(128, 3), RJ(3), EL(3,3), C(3)
!
      call NormVett(RJ, EL, C)
!
      S(1) = G(2) * RJ(3) - G(3) * RJ(2)
      S(2) = G(3) * RJ(1) - G(1) * RJ(3)
      S(3) = G(1) * RJ(2) - G(2) * RJ(1)
      call NormVett(S, EL, G)
      S(1) = RJ(2) * G(3) - RJ(3) * G(2)
      S(2) = RJ(3) * G(1) - RJ(1) * G(3)
      S(3) = RJ(1) * G(2) - RJ(2) * G(1)
      call NormVett(S, EL, E)
      if (E(3) .LE. 0) then
         E(1) = -E(1)
         E(2) = -E(2)
         E(3) = -E(3)
      end if
!
      N = int(N1 / 2)
      do 50 j = 1 , 3
         H(1, j) = 1. * G(j)
         H(N+1, j) = E(j)
         H(N1, j) = -1. * G(j)
   50 continue
   55 if (N.gt.1) then
         N1N = N1 - N
         do 80 JU = 1 , N1N , N
            K = JU + N
            do 60 L = 1 , 3
               S(L) = H(JU, L) + H(K, L)
   60       continue
            call NormVett(S, EL, E)
            JJ = JU + N / 2
            H(JJ, 1) = E(1)
            H(JJ, 2) = E(2)
            H(JJ, 3) = E(3)
   80    continue
         N = N / 2
         goto 55
      end if
!
      return
      end
! -----------------------------------------------------------------
      subroutine RotAtoms(B, iAction)
      USE Molcom
      USE Contorno
      USE TestModel
      USE Dialogo, only : ModelToCompare
!
      dimension q(3), P(3), B(3, 3)
!
      integer O1,O2
!
      do 30 JAT = 1 , NatMol + NatSpi + 9
         q(1) = xyz(1,JAT)
         q(2) = xyz(2,JAT)
         q(3) = xyz(3,JAT)
         do 20 i = 1 , 3
            P(i) = 0
            do 10 j = 1 , 3
               P(i) = P(i) + B(i, j) * q(j)
   10       continue
   20    continue
         if (iAction.eq.1) then       ! normal rotation
            xyz(1,JAT) = P(1)
            xyz(2,JAT) = P(2)
            xyz(3,JAT) = P(3)
         end if
         if (RS(JAT) .LT. 0.0) go to 30
         if (iAction.eq.2) then       ! rotation from Find_Best_Orient.
            if (JAT.le.NatMol .OR. ifCell.gt.0) then
               if (P(1)-RS(JAT) .LT. Rmin1)  Rmin1 = P(1)-RS(JAT)
               if (P(1)+RS(JAT) .GT. RMAX1)  RMAX1 = P(1)+RS(JAT)
               if (P(2)-RS(JAT) .LT. Rmin2)  Rmin2 = P(2)-RS(JAT)
               if (P(2)+RS(JAT) .GT. RMAX2)  RMAX2 = P(2)+RS(JAT)
            end if
         end if
   30 continue
*     if (ifViewModel == 1) then
      if (ModelToCompare == 2) then
          do JAT = 1 , nCoordPub
             q(1) = xyzPub(1,JAT)
             q(2) = xyzPub(2,JAT)
             q(3) = xyzPub(3,JAT)
             do i = 1 , 3
                P(i) = 0
                do j = 1 , 3
                   P(i) = P(i) + B(i, j) * q(j)
                enddo
             enddo
             if (iAction.eq.1) then       ! normal rotation
                xyzPub(1,JAT) = P(1)
                xyzPub(2,JAT) = P(2)
                xyzPub(3,JAT) = P(3)
             end if
          enddo
      endif

      if (iAction .eq. 1) then
         do 50 i = 1 , (NatMol + NatSpi) - 1
            if (RS(i) .LT. 0.0) go to 50
            do 40 K = i + 1 , NatMol + NatSpi
               if (RS(K) .LT. 0.0) go to 40
               O1 = iOrd(i)
               O2 = iOrd(K)
               O3 = xyz(3,O1)
               O4 = xyz(3,O2)
               if (O3.GT.O4) then
                  iOrd(i) = O2
                  iOrd(K) = O1
               end if
   40       continue
   50    continue
      end if
!
      if (ifDrawContour == 1) then
          do JAT = 1 , nPuntiCont + morePoints
             q(1) = xyz_tria(1,JAT)
             q(2) = xyz_tria(2,JAT)
             q(3) = xyz_tria(3,JAT)
             do i = 1 , 3
                P(i) = 0
                do j = 1 , 3
                   P(i) = P(i) + B(i, j) * q(j)
                enddo
             enddo
             xyz_tria(1,JAT) = P(1)
             xyz_tria(2,JAT) = P(2)
             xyz_tria(3,JAT) = P(3)
          enddo
      endif
!
      if (ifCubo == 9) then
          do JAT = 1 , 9
             q(:) = coordCubo(:,JAT)
             do i = 1 , 3
                P(i) = 0
                do j = 1 , 3
                   P(i) = P(i) + B(i, j) * q(j)
                enddo
             enddo
             if (iAction.eq.1) then       ! normal rotation
                coordCubo(:,JAT) = P(:)
             end if
          enddo
          xyzCubo(:) = coordCubo(:,9)
      endif
!
      return
      end
! -----------------------------------------------------------------
      subroutine FindMinMax
      USE Molcom
      USE Atomi, only : nzTot
      USE TestModel
      USE Dialogo, only : ModelToCompare
!
      if (ifDrawContour == 1) then
          call FindMinMaxCont()
          if (NatMol > 0) then
              call SovrapponiAtomi()
          endif
          return
      endif
      Rmin1 = 99999.
      Rmin2 = 99999.
      RMAX1 = -99999.
      RMAX2 = -99999.
      iEnd = NatMol
      if (NatMol == 0) iEnd = NatSpi
      do 10 JAT = 1 , iEnd
         if (RS(JAT) .ge. 0.0) then
            if (nzTot(JAT).ne.0 .or. ifGhost.eq.1) then
            if (xyz(1,JAT) .LT. Rmin1) Rmin1 = xyz(1,JAT)
            if (xyz(1,JAT) .GT. RMAX1) RMAX1 = xyz(1,JAT)
            if (xyz(2,JAT) .LT. Rmin2) Rmin2 = xyz(2,JAT)
            if (xyz(2,JAT) .GT. RMAX2) RMAX2 = xyz(2,JAT)
         end if
         end if
   10 continue
      DrawDeltX = (Rmin1 + RMAX1) / 2
      DrawDeltY = (Rmin2 + RMAX2) / 2
      do JAT = 1 , NatMol + NatSpi + 9
         xyz(1,JAT) = xyz(1,JAT) - DrawDeltX
         xyz(2,JAT) = xyz(2,JAT) - DrawDeltY
      enddo
*     if (ifViewModel == 1) then
      if (ModelToCompare == 2) then
          do JAT = 1 , nCoordPub
             xyzPub(1,JAT) = xyzPub(1,JAT) - DrawDeltX
             xyzPub(2,JAT) = xyzPub(2,JAT) - DrawDeltY
          enddo
      endif
      Rmin1 = 99999.
      Rmin2 = 99999.
      RMAX1 = -99999.
      RMAX2 = -99999.
      iEnd = NatMol
      if (ifCell.eq.1) iEnd = NatMol + NatSpi
      if (NatMol == 0) iEnd = NatSpi
      do 30 JAT = 1 , iEnd
         FatK = -xyz(3,JAT)/ViewDist + 1
         if (RS(JAT) .ge. 0.0) then
            if (nzTot(JAT).ne.0 .or. ifGhost.eq.1) then
               if ((xyz(1,JAT)-RS(JAT))/FatK .LT. Rmin1) then
                  Rmin1 = (xyz(1,JAT)-RS(JAT)) / FatK
               end if
               if ((xyz(1,JAT)+RS(JAT))/FatK .GT. RMAX1) then
                  RMAX1 = (xyz(1,JAT)+RS(JAT)) / FatK
               end if
               if ((xyz(2,JAT)-RS(JAT))/FatK .LT. Rmin2) then
                  Rmin2 = (xyz(2,JAT)-RS(JAT)) / FatK
               end if
               if ((xyz(2,JAT)+RS(JAT))/FatK .GT. RMAX2) then
                  RMAX2 = (xyz(2,JAT)+RS(JAT)) / FatK
               end if
            end if
         end if
   30 continue
!
      return
      end
! -----------------------------------------------------------------
      subroutine SetScale(Azione)
      USE Molcom
!
      integer Azione
!
      Lim1 = iVP(1)
      Lim2 = iVP(2)
      Lim3 = iVP(3)
      Lim4 = iVP(4)
      NPX = Lim3 - Lim1
      NPY = Lim4 - Lim2
      Ratio = float(NPX) / float(NPY)
!
      if (Azione .eq. 0)  goto 2690
      if (Azione .eq. 5) then   !perugia1312
         quanto = 4
      else
         quanto = 20
      end if
      if (Azione .ne. 2)  then
         D1 = (RMAX1 - Rmin1) / quanto
         Rmin1 = Rmin1 - D1
         RMAX1 = RMAX1 + D1
         D2 = (RMAX2 - Rmin2) / quanto
         Rmin2 = Rmin2 - D2
         RMAX2 = RMAX2 + D2
      end if
      Dx = RMAX1 - Rmin1
      Dy = RMAX2 - Rmin2
!
      if (Dx.LE.Dy * Ratio) then
         DX1 = Dy * Ratio
         DEL = (DX1 - Dx) / 2
         Rmin1 = Rmin1 - DEL
         RMAX1 = RMAX1 + DEL
         Dx = DX1
      else
         DY1 = Dx / Ratio
         DEL = (DY1 - Dy) / 2
         Rmin2 = Rmin2 - DEL
         RMAX2 = RMAX2 + DEL
         Dy = DY1
      end if
      if (Azione .EQ. 4) return
      Xmin = Rmin1
      Ymin = Rmin2
      YMax = Rmin2 + Dy
      XMax = Rmin1 + Dx
      RMAX1 = XMax
      RMAX2 = YMax
2690  call Window (Xmin, Ymin, XMax, YMax, Ratio)
      DDX = (XMax - Xmin) / (Lim3 - Lim1)
      DDY = (YMax - Ymin) / (Lim4 - Lim2)
!
      return
      end
! -----------------------------------------------------------------
      subroutine Window(Amin1, Amin2, AMax1, AMax2, Ratio)
      USE Molcom
!
      if (ABS(Amin1 - AMax1) .lt. 1.) then
         Half = (AMax1 + Amin1)/2
         Amin1 = Half - 0.5
         AMax1 = Half + 0.5
         De1 = 0.5*(AMax1 - Amin1)/Ratio
         Half2 = (Amin2+AMax2)/2.
         Amin2 = Half2 - De1
         AMax2 = Half2 + De1
      end if
      if (ABS(Amin2 - AMax2) .lt. 1.) then
         Half = (AMax2 + Amin2)/2
         Amin2 = Half - 0.5
         AMax2 = Half + 0.5
         De2 = Ratio * (Amax2 - Amin2)/2.
         Half1 = (Amin1 + AMax1)/2
         Amin1 = Half1 - De2
         AMax1 = Half1 + De2
      end if
      XXmin = Amin1
      XXMax = AMax1
      YYmin = Amin2
      YYMax = AMax2
      dx=XXMax-XXMin
      dy=YYMax-YYMin
!
          x11scale(1)=(iVP(3) - iVP(1))/dx
          x11scale(2)=(iVP(4) - iVP(2))/dy
          x11disp(1)=-XXMin 
          x11disp(2)=-YYMin 
!
      return
      end
! -----------------------------------------------------------------
      subroutine AngToPix
      USE Molcom
      USE TestModel
      USE Dialogo, only : ModelToCompare
!
      RagMed = 0.0
      NatVis = 0
      do j = 1, NatMol + NatSpi + 9
         f = xyz(3,j)
         FatK = -f / ViewDist + 1
         a = ( xyz(1,j)/FatK + x11disp(1) ) * x11scale(1)
         b = ( xyz(2,j)/FatK + x11disp(2) ) * x11scale(2)
         c =                     RS(j)/FatK * x11scale(1)
         if (j.le.NatMol .and. c.gt.0.0) then
             NatVis = NatVis + 1
             RagMed = RagMed + c
         end if
         ipix(1,j)=nint(a)
         ipix(2,j)=iVP(4) - nint(b)
         ipix(3,j)=nint(c)
      enddo
*     if (ifViewModel == 1) then
      if (ModelToCompare == 2) then
          do j = 1, nCoordPub
             f = xyzPub(3,j)
             FatK = -f / ViewDist + 1
             a = ( xyzPub(1,j)/FatK + x11disp(1) ) * x11scale(1)
             b = ( xyzPub(2,j)/FatK + x11disp(2) ) * x11scale(2)
             ixyPub(1,j) = nint(a)
             ixyPub(2,j) = iVP(4) - nint(b)
          enddo
      endif
      if (NatVis.gt.0) then
         RagMed = RagMed / float(NatVis)
      end if
*     j = NatMol + NatSpi + 9
*     write(0,'(2i5,3f8.3)')   ipix(1:2,j),xyz(:,j)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine ModificaCoordinate()
      USE General
      USE Riflessi
      USE Molcom
      USE Atomi
      USE TestModel
!
      implicit none
      integer lsn, ifLi5, ljxx, lkxx, llxx, ier, ifsca, iContSav
      integer i, j, interp, lnz, k, iAction, leggi, NATV
      integer ifDentro, iZero, kbuild, nadd
      integer iref, mode, numb, ifBreak, iCoeff, ksubr
      real BTot11, B(3, 3), x1(3), x2(3), scalan, a
!
!-- ATTENZIONE se sono stati generati gli equivalenti di simmetria
!
      iContSav = ifCont
      if (iContSav == 1) then
         call SoloInd(NatInd)
      endif
      ifLi5 = 0
!
      do i=1, nats
         a = abs(xyzs(1,i) - coordSir(1,i))
     *     + abs(xyzs(2,i) - coordSir(2,i))
     *     + abs(xyzs(3,i) - coordSir(3,i))
         if (a > 0.1) then
*            kblock(i) = 0
         endif
         xyzs(1:3,i) = coordSir(1:3,i)
      enddo
!
      iAction = 5
*     call build(iAction, 1)   !!! anche con kblock=1 modifica le coord !!!
      call build(iAction, 0)   !!! anche con kblock=1 modifica le coord !!!
      do i=1, nats
         a = abs(xyzs(1,i) - coordSir(1,i))
     *     + abs(xyzs(2,i) - coordSir(2,i))
     *     + abs(xyzs(3,i) - coordSir(3,i))
*        if (a > 0.1) then
*            write(6,*) 'cambiato',i,xyzs(1:3,i),coordSir(1:3,i)
*        endif
      enddo
      interp=1
      call PutGetXyzs(1, interp)
!
      if (iContSav == 1) then
         NATind = nats
         ifDentro = 1
         iZero = 0
         kbuild = 0
         call GeneraAppSym(ifDentro, iZero, kbuild, nadd)
         call FindMinMax
      else
         do i=1, NatMol
             x1(1:3)=xyzs(1:3,i)
             call MoltMatVec(rm, x1, x2)
             xyz(1:3,i) = x2(1:3)
             SinglePlotType(i) = iPlotType
         enddo
         call AggiuSpig
         call LsPlane(NATV, 1)
         call GetBonds(1)
!
         Rmin1 = 99999.
         Rmin2 = 99999.
         RMAX1 = -99999.
         RMAX2 = -99999.
!
         do i = 1 , 3
            do j = 1 , 3
               BTot(i, j) = 0
            enddo
            BTot(i, i) = 1
         enddo
         call FindOr(B, 1)
!
      end if
!
      ifsca = 1
      call Disegna(ifsca)
      call DoSingleIteration()
!
!-- avendo cambiato le coordinate, cambiano tutte le fasi
!

      go to 1

      nzSav(1:nats) = nz(1:nats)
      do i=1, nats
         nz(i) = iabs(nz(i)) / nzConst
      enddo
      iref = 0
      mode = 0
      numb = nrefl
      scalan = 1.0
      ifBreak = 0
      iCoeff = 2
      call sftryyyc(iref,mode,numb,scalan,ifBreak,iCoeff)
      ksubr = 1
      call AggiornaFasiPesiNew(ksubr,wt,iphaz,fcvet)
      nz(1:nats) = nzSav(1:nats)

    1 continue

!
      return
      end
! -----------------------------------------------------------------
      subroutine DisegnaModello(ifDragged)
      USE General, only : no
      USE Molcom
      USE TestModel
      USE PhaseModule
      implicit none
!
      integer i, j, kcolore, i1, i2, x1, x2, y1, y2 , ifDragged
      integer iRaggio, IfF, lnz
!
      selezione(1:nCoordPub) = 0
!
      kcolore = color_LIGHTRED
      do i=1, nLegPub
         i1 = LEPub(1, i)
         i2 = LEPub(2, i)
         x1 = ixyPub(1, i1)
         y1 = ixyPub(2, i1)
         x2 = ixyPub(1, i2)
         y2 = ixyPub(2, i2)
         call Linea_dash (x1, y1, x2, y2, kcolore)
      enddo
      iRaggio = 3
      do i=1, NatInd
         j = npunt(i)
         if (j > 0 .and. j <= nCoordPub) then
             x1 = ixyPub(1, j)
             y1 = ixyPub(2, j)
             IfF = -1
             lnz = nzPub(j)
             kcolore = no(lnz) + N_OBJS
             call Cerchio(x1, y1, iRaggio, kcolore, IfF, kcolore)
             IfF = 0
             call Cerchio(x1, y1, iRaggio, kcolore, IfF, kcolore)
             selezione(j) = 1
         endif
      enddo
      do i=1, nCoordPub
         if (selezione(i) == 0) then
             x1 = ixyPub(1, i)
             y1 = ixyPub(2, i)
             IfF = -1
             kcolore = jBackGround
             call Cerchio(x1, y1, iRaggio, kcolore, IfF, kcolore)
             IfF = 0
             lnz = nzPub(i)
             kcolore = no(lnz) + N_OBJS
             call Cerchio(x1, y1, iRaggio, kcolore, IfF, kcolore)
         endif
      enddo
!
      if (ifLabelsPub == 1 .and. ifDragged == 0) then
          call DrawLabelsPub()
      endif
!
      return
      end
! -----------------------------------------------------------------
      subroutine DrawLabelsPub()
      USE General, only: Labb
      USE Molcom
      USE TestModel
!
      implicit none
      integer iColor, i, L, fx, fy, x1, y1, Lung, LenInPix
!
      iColor = color_LABS
      fy = FntPixHeight
      do i=1, nCoordPub
         Labb = aLabPub(i)
         L = Lung(Labb)
         if (L > 0) then
             fx = LenInPix(Lab(i),2)
             x1 = ixyPub(1, i) - fx / 2.0
             y1 = ixyPub(2, i) + fy ! / 4.0
             call DrawLabel(x1, y1, Labb, iColor, 2)
         endif
      enddo
!
      return
      end
! -----------------------------------------------------------------
      subroutine PlotStyleOne(ifNewPage)
      USE General
      USE Atomi, only : nzTot
      USE Molcom
      USE Plotter
      USE FastPlot
! ---
      common /movediamo3/ nplt, iplt(30000), nlegami(30000)
! ---
      integer CC, CC1, XX1, YY1, XX2, YY2
      integer XX3, YY3
!
      nCoppieHBond = 0
      zmin = 9.e33
      zMax = -9.e33
      do 5 i=1, NatMol
         if (RS(i) .gt. 0) then
            if (zmin.gt.xyz(3,i)) zmin = xyz(3,i)
            if (zMax.lt.xyz(3,i)) zMax = xyz(3,i)
         end if
    5 continue
      zmin = zmin -0.01
      zMax = zMax + 0.01
!
      do 21 i = 1, NatMol
         iplt(i) = 0
   21 continue
! ---
      nSegm = 0
      Legato = 0
      icolBaseMono = 3
      do 30 NLL = 1 , NumLeg
         if (LE(3, NLL).lt.0.or.LE(3,NLL).eq.3) then
            goto 30
         end if
         N1 = LE(1, NLL)
         if (N1.gt.NatMol .and. ifCell.eq.0) goto 30
         if (ifDrHydr.eq.0 .and. nzTot(N1).eq.1
     *                     .and. ifHydro.eq.1) goto 30
         N2 = LE(2, NLL)
         if (ifDrHydr.eq.0) then
            if (nzTot(N1).eq.1.and.ifHydro.eq.1) goto 30
            if (nzTot(N1).eq.1.and.ifHydro.eq.1) goto 30
         end if
         if (RS(N1) .LE. 0 .OR. RS(N2) .LE. 0)  goto 30
         if (ifDrHydr.eq.0 .and. nzTot(N2).eq.1
     *                     .and. ifHydro.eq.1) goto 30
         Legato = -1
         XX1 = ipix(1,N1)
         XX2 = ipix(1,N2)
         YY1 = ipix(2,N1)
         YY2 = ipix(2,N2)
         XX3 = (XX1 + XX2) / 2
         YY3 = (YY1 + YY2) / 2
         CC  = iCol(N2)
         CC1 = iCol(N1)
         iplt(N1) = 1
         iplt(N2) = 1
!
         nSegm = nSegm + 1
         ix1(nSegm) = XX1
         iy1(nSegm) = YY1
         ix2(nSegm) = XX3
         iy2(nSegm) = YY3
         nCol1(nSegm) = CC1
         ix3(nSegm) = XX2
         iy3(nSegm) = YY2
         nCol2(nSegm) = CC
   30 continue
!
!!mr      call xwinnew(ix1,iy1,ix2,iy2,ix3,iy3,nCol1,nCol2,nSegm,
      call DrawSticks(ix1,iy1,ix2,iy2,ix3,iy3,nCol1,nCol2,nSegm,
     .             ifNewPage)
!
      if (ifDrHBond == 1) then
         iColor = color_CELL
         do NLL = 1 , NumLeg
            if (LE(3, NLL).eq.3) then
                N1 = LE(1,NLL)
                N2 = LE(2,NLL)
                ix1b = ipix(1,N1)
                iy1b = ipix(2,N1)
                ix2b = ipix(1,N2)
                iy2b = ipix(2,N2)
                call Linea_dash (ix1b, iy1b, ix2b, iy2b, iColor)
                nCoppieHBond = nCoppieHBond + 1
            end if
         enddo
      endif
!
      do i=1, NatMol
         if (iplt(i).eq.0.and.RS(i).gt.0.0) then
             call Punto(ipix(1,i),ipix(2,i),iCol(i))
         end if
      enddo
!
      return
      end
! -----------------------------------------------------------------
      subroutine PlotStyleDrag(ifNewPage)
      USE General
      USE Atomi, only : nzTot
      USE Molcom
      USE Plotter
      USE FastPlot
!
      implicit none
      common /movediamo3/ nplt, iplt(30000), nlegami(30000)
      integer :: nplt, iplt, nlegami, i, j, nSegm
      integer :: ifNewPage, N1, N2, colore, LineStyle
      integer :: ix1b, iy1b, ix2b, iy2b
!
      colore = icoWire
      nCoppieHBond = 0
!
      iplt(1:NatMol) = 0
!
      nSegm = 0
      j = 1
      do i = 1 , NumLeg
         if (LE(3, i) < 0 .or. LE(3,i) == 3) cycle
         N1 = LE(1, i)
         if (N1 > NatMol .and. ifCell == 0) cycle
         if (ifDrHydr == 0 .and. nzTot(N1) == 1
     *                     .and. ifHydro == 1) cycle
         N2 = LE(2, i)
         if (ifDrHydr == 0) then
            if (nzTot(N1) == 1 .and. ifHydro == 1) cycle
            if (nzTot(N1) == 1 .and. ifHydro == 1) cycle
         end if
         if (RS(N1)  <=  0 .or. RS(N2)  <=  0)  cycle
         if (ifDrHydr == 0 .and. nzTot(N2) == 1
     *                     .and. ifHydro == 1) cycle
         iplt(N1) = 1
         iplt(N2) = 1
!
         nSegm = nSegm + 1
         ix1(j)   = ipix(1,N1)
         iy1(j)   = ipix(2,N1)
         ix1(j+1) = ipix(1,N2)
         iy1(j+1) = ipix(2,N2)
         j = j + 2
         if (j > nFastPlot-2) exit

      enddo
!
      LineStyle = 0
      call DrawSegments(nSegm, colore, ix1, iy1, LineStyle, ifNewPage)
!
      if (ifDrHBond == 1) then
         colore = color_CELL
         do i = 1 , NumLeg
            if (LE(3, i) == 3) then
                N1 = LE(1,i)
                N2 = LE(2,i)
                ix1b = ipix(1,N1)
                iy1b = ipix(2,N1)
                ix2b = ipix(1,N2)
                iy2b = ipix(2,N2)
                call Linea_dash (ix1b, iy1b, ix2b, iy2b, colore)
                nCoppieHBond = nCoppieHBond + 1
            end if
         enddo
      endif
!
      do i=1, NatMol
         if (iplt(i) == 0 .and. RS(i) > 0.0) then
             call Punto(ipix(1,i),ipix(2,i),iCol(i))
         end if
      enddo
!
      return
      end
! -----------------------------------------------------------------
      subroutine DrawTraccia()
      USE Atomi
      USE Molcom
!
      nlegSk = iconnSk(1)
      k = 1
      do i=1, nlegSk
         n1 = iconnSk(k+1)
         n2 = iconnSk(k+2)
         n3 = iconnSk(k+3)
         if (n3 >= 4 .and. n3 <= 7) then
             ix1 = ipix(1,n1)
             iy1 = ipix(2,n1)
             ix2 = ipix(1,n2)
             iy2 = ipix(2,n2)
             if (n3 == 4) then
                 iColor = color_YELLOW
             elseif (n3 == 5) then
                 iColor = color_GREEN
             elseif (n3 == 6) then
                 iColor = color_CYAN             
             else
                 iColor = color_MAGENTA             
             endif
             iRaggio = 2
             if (n3 == 4) then
                 call LineaSpessa(ix1, iy1, ix2, iy2, iColor, iRaggio)
             else
                 call LineaSpessa2(ix1, iy1, ix2, iy2, iColor, iRaggio)
             endif
         endif
         k = k + 3
      enddo
!
      call zflush
!
      return
      end
! -----------------------------------------------------------------
      subroutine DrawLabels()
      USE General, only: Labb
      USE Atomi, only : nzTot
      USE Molcom
!
      iColor = color_LABS
      if (ifMovedLab.eq.0) then
          fy = FntPixHeight
          do i=1, NatMol
             L = Lung(Lab(i))
             if (L .GT. 0) then
                 fx = LenInPix(Lab(i),2)
                 ipixLab(1,i) = ipix(1,i) - fx / 2.0
                 ipixLab(2,i) = ipix(2,i) + fy  / 4.0
             else
                 ipixLab(1,i) = ipix(1,i)
                 ipixLab(2,i) = ipix(2,i)
             endif
          enddo
      endif
      do i=1, NatMol
         if (ifDrHydr.ne.0 .or. (nzTot(i).ne.1.and.ifHydro.eq.1)) then
            if (ifGhost.ne.0 .or. nzTot(i).ne.0) then
               if ((RS(i) > 0) .and. (ifLabelsVis(i) == 1)) then
                  L = Lung(Lab(i))
                  if (L .GT. 0) then
                     Labb = Lab(i)
                     call DrawLabel(ipixLab(1,i), ipixLab(2,i), 
     *                              Labb, iColor, 2)
                  end if
               end if
            end if
         end if
      enddo
!
*     call DisegnaProva
!
      return
      end
! -----------------------------------------------------------------
      subroutine DisegnaProva
      USE Molcom
!
      real punto1(3), punto2(3), mnp(3), x(3)
!
      IDum = color_RESTR
      do i=1, NatMol-1
         punto1(1:3) = xyz(1:3,i)
         do j=i+1, NatMol
            punto2(1:3) = xyz(1:3,j)
            mnp(1) = punto2(1) - punto1(1)
            mnp(2) = punto2(2) - punto1(2)
            mnp(3) = punto2(3) - punto1(3)
            t = 0.0
            do k=1,10
               t = t + 0.1
               x(1) = punto1(1) + mnp(1) * t
               x(2) = punto1(2) + mnp(2) * t
               x(3) = punto1(3) + mnp(3) * t
*              f = x(3)
*              FatK = -f / ViewDist + 1
*              a = ( x(1)/FatK + x11disp(1) ) * x11scale(1)
*              b = ( x(2)/FatK + x11disp(2) ) * x11scale(2)
               a = ( x(1) + x11disp(1) ) * x11scale(1)
               b = ( x(2) + x11disp(2) ) * x11scale(2)
               ix=nint(a)
               iy=iVP(4) - nint(b)
               call Punto(ix, iy, IDum)
            enddo
         exit
         enddo
         exit
      enddo
!
      return
      end
! -----------------------------------------------------------------
      subroutine ResetLabelPos()
      USE Molcom
!
      ifMovedLab = 0
      if (NatMol > 0) then
          xyLab(:,:) = 0.0
          do i=1,NatMol
             ipixLab(1,i) = ipix(1,i)
             ipixLab(2,i) = ipix(2,i)
          enddo
      endif
!
!      ifsca = 0
!      call Disegna(ifsca)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine ResetModelPos()
      USE Molcom, only: rm
      USE TestModel
!
      implicit none
      real x1(3), x2(3)
      integer i
!
      do i=1, nCoordPub
         x1(1:3) = coordPub(1:3, i)
         call MoltMatVec(rm, x1, x2)
         xyzPub(1:3, i) = x2(1:3)
      enddo
!
      return
      end
! -----------------------------------------------------------------
      subroutine SticksOrd(ifNewPage)
      USE General
      USE Atomi, only : nzTot
      USE Molcom
!
! ---
      common /movediamo3/ nplt, iplt(30000), nlegami(30000)
      integer O1, O2
      integer CC, CC1, XX1, YY1, XX2, YY2, DDXS, DDYS
      integer  XX3, YY3, XX1B, XX2B, YY1B, YY2B
! ---
      zmin = 9.e33
      zMax = -9.e33
      do 5 i=1, NatMol
         if (RS(i) .gt. 0) then
            if (zmin.gt.xyz(3,i)) zmin = xyz(3,i)
            if (zMax.lt.xyz(3,i)) zMax = xyz(3,i)
         end if
    5 continue
      zmin = zmin -0.01
      zMax = zMax + 0.01
!
      do 20 i = 1, (NatMol + NatSpi) - 1
         do 10 K = i + 1, NatMol + NatSpi
            O1 = iOrd(i)
            O2 = iOrd(K)
            O3 = xyz(3,O1)
            O4 = xyz(3,O2)
            if (O3 .GT. O4) then
               iOrd(i) = O2
               iOrd(K) = O1
            end if
   10    continue
   20 continue
      do 21 i = 1, NatMol
         iplt(i) = 0
   21 continue
      DDYS = 1
      DDXS = 1
! ---
      if (ifNewPage.eq.1) call NewPage
!
      icolBaseMono = 3
      do 40 JJ = 1 , NatMol + NatSpi
         IJ = iOrd(JJ)
         if (RS(IJ) .LE. 0) go to 40
         if (ifCell .eq. 0 .AND. IJ .gt. NatMol) goto 40
         if (nzTot(IJ).eq.0 .and. ifGhost.eq.0) goto 40
         if (nzTot(IJ).eq.1.and.ifHydro.eq.1.and.ifDrHydr.eq.0) goto 40
         ZETA = xyz(3,IJ)
         Legato = 0
         do 30 NLL = 1 , NumLeg
            if (LE(3, NLL).lt.0) then
               goto 30
            end if
            N1 = LE(1, NLL)
            N2 = LE(2, NLL)
            if (N1.NE.IJ.AND.N2.NE.IJ) goto 30
            if (N1 .EQ. IJ .AND. xyz(3,N2) .GT. ZETA)  goto 30
            if (N2 .EQ. IJ .AND. xyz(3,N1) .GT. ZETA)  goto 30
            if (RS(N1) .LE. 0 .OR. RS(N2) .LE. 0)  goto 30
            Legato = -1
            XX1 = ipix(1,N1)
            XX2 = ipix(1,N2)
            YY1 = ipix(2,N1)
            YY2 = ipix(2,N2)
            if (iPlotType .eq. STICKS .or. N1 .gt. NatMol) then
               XX1B = XX1
               XX2B = XX2
               YY1B = YY1
               YY2B = YY2
               xd1 = 0
               yd1 = 0
            else
               D1 = XX2 - XX1
               D2 = YY2 - YY1
               D = sqrt ( D1 * D1 + D2 * D2)
               if (D .gt. 0) then
                  XX1B = XX1 + 4 * (XX2 - XX1) / D
                  XX2B = XX2 + 4 * (XX1 - XX2) / D
                  YY1B = YY1 + 4 * (YY2 - YY1) / D
                  YY2B = YY2 + 4 * (YY1 - YY2) / D
                  xd1 = (XX2 - XX1) / D
                  yd1 = (YY2 - YY1) / D
               else
                  XX1B = XX1
                  XX2B = XX2
                  YY1B = YY1
                  YY2B = YY2
                  xd1 = 0
                  yd1 = 0
               end if
            end if
            ixv(1) = nint(XX1B + yd1)
            ixv(2) = nint(XX2B + yd1)
            iyv(1) = nint(YY1B - xd1)
            iyv(2) = nint(YY2B - xd1)
            ixv(4) = nint(XX1B - yd1)
            ixv(3) = nint(XX2B - yd1)
            iyv(4) = nint(YY1B + xd1)
            iyv(3) = nint(YY2B + xd1)
            iz=4
            iColor = jBackGround
            jFill = 1
            call Poligono(iz,iColor,jFill)
            XX3 = (XX1 + XX2) / 2
            YY3 = (YY1 + YY2) / 2
            CC  = iCol(N2)                ! + 8
            CC1 = iCol(N1)                ! + 8
!
            if (nzTot(N1).eq.1 .and. ifHydro.eq.1
     *                         .and. ifDrHydr.eq.0) goto 23
            if (nzTot(N2).eq.1 .and. ifHydro.eq.1
     *                         .and. ifDrHydr.eq.0) goto 23

!
            call Linea (XX1B, YY1B, XX3, YY3, CC1)
            call Linea (XX3, YY3, XX2B, YY2B, CC)
   23       if (iPlotType .EQ. SIMPLE .AND. N1 .LE. NatMol) then
               if (iplt(N1) .eq. 0) then
                  if (nzTot(N1).eq.1 .and. ifHydro.eq.1 
     *                               .and. ifDrHydr.eq.0) then
                     iplt(N1) = 1
                     goto 69
                  end if
                  iCC = color_GRAY
                  IfF = -1
                  call Cerchio(XX1, YY1, 3 * DDXS, iCC, IfF, iCC)
                  iCC = jBackGround
                  call Cerchio(XX1, YY1, 4 * DDXS, iCC, IfF, iCC)
                  if (nzTot(N1).eq.1.and.ifHydro.eq.1) then
                      call Cerchio(XX1, YY1, 2 * DDXS, CC1, IfF, CC1)
                  else if (nzTot(N1).eq.0) then
                      IfF = -1
                      iFC = jBackGround
                      call Cerchio(XX2, YY2, 2 * DDXS, CC1, IfF, iFC)
                  else if(nzTot(N1) /= PiccoFour) then
                       call Cerchio(XX1, YY1, 3 * DDXS, CC1, IfF, CC1)
                       IDum = color_RESTR
                       call Punto(XX1 + DDXS, YY1 - 2 * DDYS, IDum)
                  endif
                  iplt(N1) = 1
               end if
   69          if (N2 .le. NatMol .and. iplt(N2). eq. 0) then
                  if (nzTot(N2).eq.1 .and. ifHydro.eq.1
     *                               .and. ifDrHydr.eq.0) then
                     iplt(N2) = 1
                     goto 30
                  end if
                  iCC = color_GRAY
                  IfF = -1
                  call Cerchio(XX2, YY2, 3 * DDXS, iCC, IfF, iCC)
                  iCC = jBackGround
                  call Cerchio(XX2, YY2, 4 * DDXS, iCC, IfF, iCC)
                  if (nzTot(N2).eq.1.and.ifHydro.eq.1) then
                      call Cerchio(XX2, YY2, 2 * DDXS, CC, IfF, CC)
                  else if (nzTot(N2).eq.0) then
                      IfF = -1
                      iFC = jBackGround
                      call Cerchio(XX2, YY2, 2 * DDXS, CC, IfF, iFC)
                  else if(nzTot(N1) /= PiccoFour) then
                       call Cerchio(XX2, YY2, 3 * DDXS, CC, IfF, CC)
                       IDum = color_RESTR
                       call Punto(XX2 + DDXS, YY2 - 2 * DDYS, IDum)
                  endif
                  iplt(N2) = 1
               end if
            end if
   30    continue
         if (Legato .eq. 0) then
            ix = ipix(1, IJ)
            iy = ipix(2, IJ)
            ic1 = iCol(IJ)
            if (iPlotType .eq. STICKS) then
               if (IJ .LE. NatMol) then
                  if (nzTot(IJ) /= PiccoFour) then
                      IDum = color_RESTR
                      call Punto(ix, iy, IDum)
                  end if
               end if
            else if (IJ .LE. NatMol) then
               iCC = color_GRAY
               IfF = -1
               call Cerchio(ix, iy, 3, iCC, IfF, iCC)
               iCC = jBackGround
               call Cerchio(ix, iy, 4, iCC, IfF, iCC)
               if (nzTot(IJ).eq.1.and.ifHydro.eq.1) then
                   call Cerchio(ix, iy, 2, ic1, IfF, ic1)
               else if (nzTot(IJ).eq.0) then
                   IfF = -1
                   iFC = jBackGround
                   call Cerchio(ix, iy, 2, ic1, IfF, iFC)
               else if (nzTot(IJ) /= PiccoFour) then
                   call Cerchio(ix, iy, 3, ic1, IfF, ic1)
                   IDum = color_RESTR
                   call Punto(ix + 1, iy - 2, IDum)
               endif
            end if
         end if
   40 continue
!
      return
      end
! -----------------------------------------------------------------
      subroutine Genera(ifDentro, iiaa)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Poliedri
!
      common/symcon/natsym,idoppiodi,iopsym(1000),ipolim
     1,asmin(3),asmax(3),incella(10000),idoppiodit
     
      dimension cb(3), x1(3), r1(3), isf(3), iabc(3)
!
c----------
      k=1
      do i=1,3
         do j=1,3
         gdist(k)=xgg(i,j)
         k=k+1
         enddo
      enddo
c----------
      call ResetLabelPos()
      iabc(:) = 0
      ipix(:,:) = 0
!
      Tra(1, 1) = 1
      Tra(2, 1) = 0
      Tra(3, 1) = 0
      Tra(1, 2) = 0
      Tra(2, 2) = 1
      Tra(3, 2) = 0
      Tra(1, 3) = 0
      Tra(2, 3) = 0
      Tra(3, 3) = 1
! ===
      if (ifDentro.eq.1) then
          iDentro = 1
      else
          iDentro = 0
      endif
! ===
      iCentrato = 0
      nce = 0
      do 50 i = 1, NatMol
         call DoSingleIteration()
         xyz(1, i) = xyzs(1,i)
         xyz(2, i) = xyzs(2,i)
         xyz(3, i) = xyzs(3,i)
         iEqui(i) = i
!old         nOpEq(i) = 10000
         nOpEq(i) = 1000
!        write(54,'(i5,2x,a8,i8)') i,aLab(i),nOpEq(i)
         if (iDentro.eq.1) then
             n = 1
             x1(1:3)=xyz(1:3, i) 
             na = i
             if (nptr == 1) then
                 ird = 0
             else
                 ird = -1
             endif
!             call Ruota(n, na, cb, iabc, ird)
             iabc(:) = 0
             call xequiTot(n, x1, cb,iexit)             
!             write(6,49) i,xyz(1:3,i),n,i,cb(:)
   49        format(i5,3f8.5,2i5,3f8.5)   
             
             xyz(1, i) = cb(1)
             xyz(2, i) = cb(2)
             xyz(3, i) = cb(3)
!            write(6,'(i5,3f9.5)') i, cb
             ipix(1:3,i) = ipix(1:3,i) + iabc(1:3)
         endif
   50 continue
!
      natot = NatMol
!     write(6,'(/,a,/)')' Ruota e rimetti in cella tutti gli atomi' 
      do 200 na = 1, NatMol
        if(RS(iabs(iEqui(na))) .gt. -10.) then
!          
        do n=1,nsymTot
            x1(1:3)=xyz(1:3, na) 
            call xequiTot(n, x1, cb,iexit)
            iabc(:) = 0
            ird=-1    
            if (ird .lt. 0) then
                call RimettiInCella(cb, iabc)
            elseif (ird .gt. 0) then
                call RimettiDentro(cb, iabc)
            end if
            idop = iDoppio(natot, cb)
            if (idop .EQ. 0) then
               natot = natot + 1
!               write(6,49) na,xyz(1:3,na),n,natot,cb(:)
               xyz(1, natot) = cb(1)
               xyz(2, natot) = cb(2)
               xyz(3, natot) = cb(3)
!            write(6,'(i5,3f9.5)') natot, cb
               ipix(1:3,natot) = ipix(1:3,na) + iabc(1:3)
               iEqui(natot) = na
               nOpEq(natot) = n * 1000 
!        write(54,'(i5,2x,a8,i8)') na,aLab(na),nOpEq(natot)
               if (natot.eq.MaxAtomsInGr - NatSpi) then
                  write(Msg,'(a)')
     * ' The number of atoms exceeds the allowed maximum.'
                  call MsgWinErr('Warning', Msg, WARN_WINDOW, nExitCode)
                  go to 480
               end if
            else
!                write(6,499) na,xyz(1:3,na),n,idoppiodi,cb(:)                
  499           format(i5,3f8.5,2i5,3f8.5,' XXXXXXX')             
            end if
           enddo
        end if
  200 continue

!
      NatMol = natot
      do 680 nax=1, 3
         isf(1) = 0
         isf(2) = 0
         isf(3) = 0
         if (nCell(nax).ne.1) then           ! Cells along a/b/c
!
            jfi = 1
            if (nCell(nax).eq.3) jfi = -1
            do 370 jf=jfi, 1, 2
               isf(nax) = jf
               do 360 jg = 1, NatMol
                  cb(1) = xyz(1, jg) + isf(1)
                  cb(2) = xyz(2, jg) + isf(2)
                  cb(3) = xyz(3, jg) + isf(3)
                  idop = iDoppio(natot, cb)
                  if (idop .EQ. 0) then
                     natot = natot + 1
!                    write(6,49) jg,xyz(1:3,jg),nax,natot,cb(:)
                     xyz(1, natot) = cb(1)
                     xyz(2, natot) = cb(2)
                     xyz(3, natot) = cb(3)
                     ipix(1:3,natot) = ipix(1:3,jg) + isf(1:3)
                     iEqui(natot) = iEqui(jg)
                     nOpEq(natot) = nOpEq(jg)
!     write(54,'(i5,2x,a8,i8,3i4)') jg,aLab(iEqui(jg)),nOpEq(natot),isf
                  else
!                    write(6,499) jg,xyz(1:3,jg),nax,idoppiodi,cb(:)
                  end if
  360          continue
  370       continue
         end if
         AIncP = 1
         AIncN = 1
         if (nCell(nax).eq.2) then
            AIncP = 2
         end if
         if (nCell(nax).eq.3) then
            AIncP = 2
            AIncN = 2
         end if
!
         isf(nax) = AIncP
!     write(6,375)AIncP,nax,DeA(nax)
  375 format(/,' Shift di ',f7.3,' lungo l'' asse ',i2,' DeA=',f8.5,/)
         do 380 jg = 1, NatMol
            if (xyz(nax, jg).ge.0. .and. xyz(nax, jg).lt.DeA(nax)) then
               cb(1) = xyz(1, jg) + isf(1)
               cb(2) = xyz(2, jg) + isf(2)
               cb(3) = xyz(3, jg) + isf(3)
               idop = iDoppio(natot, cb)
               if (idop .EQ. 0) then
                  natot = natot + 1
!                  write(6,49) jg,xyz(1:3,jg),nax,natot,cb(:)
!                    write(6,'(i5,3f9.5)') natot, cb
                  xyz(1, natot) = cb(1)
                  xyz(2, natot) = cb(2)
                  xyz(3, natot) = cb(3)
                  ipix(1:3,natot) = ipix(1:3,jg) + isf(1:3)
                  iEqui(natot) = iEqui(jg)
                  nOpEq(natot) = nOpEq(jg)
!     write(54,'(i5,2x,a8,i8,3i4)') jg,aLab(iEqui(jg)),nOpEq(natot),isf
                  if (natot.eq.MaxAtomsInGr - NatSpi) then
                      write(lo,*) ' The number of atoms exceeds',
     *                         ' the allowed maximum.'
                      go to 480
                  end if
               else
!                  write(6,499) jg,xyz(1:3,jg),nax,idoppiodi,cb(:)
               end if
            end if
  380    continue
         isf(nax) = AIncN
!     write(6,375)AIncN,nax,-DeA(nax)
         do 381 jg = 1, NatMol
            if (xyz(nax, jg).le.1. .and.xyz(nax,jg).gt.1.-DeA(nax)) then
               cb(1) = xyz(1, jg) - isf(1)
               cb(2) = xyz(2, jg) - isf(2)
               cb(3) = xyz(3, jg) - isf(3)
               idop = iDoppio(natot, cb)
               if (idop .EQ. 0) then
                  natot = natot + 1
!                  write(6,49) jg,xyz(1:3,jg),nax,natot,cb(:)
!                    write(6,'(i5,3f9.5)') natot, cb
                  xyz(1, natot) = cb(1)
                  xyz(2, natot) = cb(2)
                  xyz(3, natot) = cb(3)
                  ipix(1:3,natot) = ipix(1:3,jg) + isf(1:3)
                  iEqui(natot) = iEqui(jg)
                  nOpEq(natot) = nOpEq(jg)
!     write(54,'(i5,2x,a8,i8,3i4)') jg,aLab(iEqui(jg)),nOpEq(natot),isf
                  if (natot.eq.MaxAtomsInGr - NatSpi) then
                      write(lo,*) ' The number of atoms exceeds',
     *                            ' the allowed maximum.'
                      go to 480
                  end if
               else
!                  write(6,499) jg,xyz(1:3,jg),nax,idoppiodi,cb(:)
               end if
            end if
  381    continue
         NatMol = natot
  680 continue
  480 NatMol = natot
!
      NATV = 0
      do na = 1, NatMol
         ieq = iabs(iEqui(na))
         Lab(na) = Lab(ieq)
!
         iOrd(na)= i
         nzTot(na) = nzTot(ieq)
         SinglePlotType(na) = SinglePlotType(ieq)
!
         rMLU(na) = rMLU(ieq)
         RS(na) = RS(ieq)
         if (RS(na) .gt. 0) then 
             NATV = NATV + 1
         endif
         iCol(na) = iCol(ieq)
         xyztot(1,na) = xyz(1, na)
         xyztot(2,na) = xyz(2, na)
         xyztot(3,na) = xyz(3, na)
         x1(1) = xyz(1, na)
         x1(2) = xyz(2, na)
         x1(3) = xyz(3, na)
         call MoltMatVec(rm,x1,r1)
         xyz(1, na) = r1(1)
         xyz(2, na) = r1(2)
         xyz(3, na) = r1(3)
         iTraslaTot = (ipix(1,na)+5) * 100 
     *              + (ipix(2,na)+5) * 10 
     *              +  ipix(3,na)+5
*gl*     if (iTraslaTot == 555) then
*gl*         iTraslaTot = 0
*gl*     endif
         nOpEq(na) = nOpEq(na) + iTraslaTot
      enddo
!
      call AggiuSpig
!
      call RotazTot   
!
      if (iiaa.eq.0) then
         call BuildBonds(2)
      else
         call BuildBonds(3)
      end if
!
      Rmin1 = 99999.
      Rmin2 = 99999.
      RMAX1 = -99999.
      RMAX2 = -99999.
!
      return
      end
!------------------------------------------------------------------------
!------------------------------------------------------------------------
      subroutine GeneraAppSym(ifDentro, iiaa,kbuild,nAdd)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Poliedri
      USE Dialogo, only : ModelToCompare
!
      real BondTableSav(2,18,18)
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/symcon/natsym,idoppiodi,iopsym(1000),ipolim
     1,asmin(3),asmax(3),incella(10000),idoppiodit
     
      dimension x1(3), r1(3)
      character*30 labito
!
*     xyz30(1,1:Nats)=RS(1:Nats)    ! gianluca 16/9/2009
!
      ier = 0
      nAdd = -1
      if (ifSkeleton == 0) then           ! 11/03/2009
          call UpdateCommonAndList5(ier)
          if (ier < 0) then
              return
          endif
*         RS(1:Nats)=xyz30(1,1:Nats)    ! gianluca 16/9/2009
          BondTableSav(:,:,:) = BondTable(:,:,:)
          call UpdateBondTable()
      endif
!
      k=1
      do i=1,3
         do j=1,3
         gdist(k)=xgg(i,j)
         k=k+1
         enddo
      enddo
!
      nAdd=0
!      Natmol0=NatMol
      NumLeg0=NumLeg
 !-- 
      call ResetLabelPos()
      if (ModelToCompare == 2) then
          call ResetModelPos()
      endif
      
c----------
      ifmenubuild=0
      if (kbuild.eq.0) then
          call NewAppSym(ifmenubuild)
      endif
! 
      call AggiuSpig
!
      call RotazTot
!
!
      Rmin1 = 99999.
      Rmin2 = 99999.
      RMAX1 = -99999.
      RMAX2 = -99999.
!
  481    continue
      BondTable(:,:,:) = BondTableSav(:,:,:)
!
      return
      end
!-----------------------------------------------------------------------
!------------------------------------------------------------------------
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!nuova procedura app. sym e menubuild  (settembre 2008)
!-costruisce i frammenti completi attraverso build_frammenti  (comune a entrambe)
!- app sym.:
!- calcola il baricentro di ogni frammento
!- trova i baricentri interni alla cella
!- ricrea il frammento attorno ad ogni baricentro
!- crea i frammenti traslati di quelli che sporgono dalla cella
!- trasla la cella  
!
!
!code for NewAppSym
      subroutine NewAppSym (ifmenubuild)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Poliedri
      USE Dialogo, only : ModelToCompare
!
      real BondTableSav(2,18,18)
!
      common/symcon/natsym,idoppiodi,iopsym(1000),ipolim
     1,asmin(3),asmax(3),incella(10000),idoppiodit
      common/buildmolec/natfrag(5000),nfraleg(20000),baric(3,5000)
     1,lunghezzafra(5000),minerale
      dimension b(3),r1(3),x1(3)
      character*16 ilab,vetch,ilabn
!
      BondTableSav(:,:,:) = BondTable(:,:,:)
!
      ier = 0
      natsym=0
      idoppiodi=0
      idoppiodit=0
      iopsym=0
      ipolim=0
      incella=0
      natfrag=0
      nfraleg=0
      nfrag=0
      baric=0.
      lunghezza=0
      ipix(:,:)=0
!      
      k=1
      do i=1,3
         do j=1,3
            gdist(k)=xgg(i,j)
            k=k+1
            asmin(j)=-0.300
            asmax(j)=1.300
         enddo
      enddo
!--se la strutt. non ha c viene definita  minerale=1
      if (ifSkeleton == 0) then   ! gianluca 11/03/2009
          minerale = 1
          do i=1,nk
             if (no(i) == 6) then
                 minerale = 0
                 exit
             endif
          enddo
      else
          minerale = 0
      endif
!     
      NumLeg=iconn(1)
      if (NumLeg.lt.0) Numleg=0
      NatMol_ori=NatMol
      do i = 1, NatMol
         call DoSingleIteration()
         xyz(1:3,i) = xyzs(1:3,i)
!------------------------------------------------------------
         ivia=1
         if (ModelToCompare == 2 .and. ivia == 0) then
             do jjg=1,3
                if (xyz(jjg, jg).gt.1.00001) then
                    do while (xyz(jjg, i).gt.0)
                       xyz(jjg, i)=xyz(jjg, i)-1.
                    enddo
                endif
                if (xyz(jjg, i).lt.-0.00001) then
                    do while (xyz(jjg, i).lt.0)
                       xyz(jjg, i) = xyz(jjg, i) + 1.0
                    enddo
                endif
             enddo
         endif
!------------------------------------------------------------
!
         nzTot(i)=iabs(nz(i))/nzConst
!old         nOpEq(i) = 11000
         nOpEq(i) = 1000
         iEqui(i)=i
         ipix(1:3,i)=0
      enddo      
!-----------------------------------------------------------------------
             kkpri=1
             if(kkpri.eq.0)then
               write(lo,*)'prima di individua_frammenti_ini  ' 
               write(lo,*)'i,xyzs(1:3,i),nOpEq(i),ipix'
               do i = 1, NatMol
                 write(lo,'(i3,3f7.3,i7,3i5,i3,i7,3x,a)')
     *             i,xyz(1:3,i),nOpEq(i),ipix(1:3,i)
               enddo
               do j=1,NumLeg
                 write(lo,*)'j,LE(1:3,j)',j,LE(1:3,j)
               enddo
             endif
!-----------------------------------------------------------------------
      nn=NumLeg        
      call individua_frammenti_ini
      if(nn.ne.NumLeg)call individua_frammenti_ini
!-----------------------------------------------------------------------
             kkpri=1
             if (kkpri.eq.0)then
                 write(lo,*)'prima di build_frammenti  nfrag= ',nfrag 
                 write(lo,*)'i,xyzs(1:3,i),nOpEq(i),ipix,nfragm(i)'
               do i = 1, NatMol
                 nf=nfragm(i)
           write(lo,'(i3,3f7.3,i7,3i5,i3,i7)')i,xyz(1:3,i),nOpEq(i)
     1           ,ipix(1:3,i),nf
               enddo
               do j=1,NumLeg
                 write(lo,*)'j,LE(1:3,j)',j,LE(1:3,j)
               enddo
             endif
!-----------------------------------------------------------------------
!-- compatta ipix e nOpEq
      do i = 1, NatMol
          ipp=-1
          iTraslaTot = (ipp*(ipix(1,i))+5) * 100 
     *               + (ipp*(ipix(2,i))+5) * 10 
     *               +  ipp*(ipix(3,i))+5
          nOpEq(i) =nOpEq(i) + iTraslaTot
      enddo
!-----------------------------------------------------------------------
             kkpri=1
             if(kkpri.eq.0)then
                write(lo,*)'dopo compatta nopeq  ' 
                write(lo,*)'i,xyzs(1:3,i),nOpEq(i),Lab(i)'
                do i = 1, NatMol
                  nf=nfragm(i)
                  write(lo,'(i3,3f7.3,i7,3x,a)')
     *             i,xyz(1:3,i),nOpEq(i),Lab(i)     
                enddo
!               do j=1,NumLeg
!                  write(lo,*)'j,LE(1:3,j)',j,LE(1:3,j)
!               enddo
             endif
!-----------------------------------------------------------------------
      nolegame=0
      if(NumLeg.gt.0)nolegame=1   
      if(nolegame.eq.1)call build_frammenti(nAdd)   
!
      do na = 1, NatMol
         ieq = iabs(iEqui(na))
         iOrd(na)= na
         nzTot(na) = nzTot(ieq)
         SinglePlotType(na) = SinglePlotType(ieq)
         RS(na)=RS(ieq)
         rMLU(na) = rMLU(ieq)
         iCol(na) = iCol(ieq)
         xyztot(1:3,na) = xyz(1:3, na)
      enddo
!-- compatta ipix e nOpEq
      do i = 1, NatMol
         ipp=-1
         iTraslaTot = (ipp*(ipix(1,i))+5) * 100 
     *              + (ipp*(ipix(2,i))+5) * 10 
     *              +  ipp*(ipix(3,i))+5
         nOpEq(i) =1000*(nOpEq(i)/1000) + iTraslaTot
      enddo
!-----------------------------------------------------------------------
             kkpri=1
             if (kkpri == 0) then
                 write(lo,*) 
     *                 'dopo build_frammenti NatMol,nolegame,numleg  '
     1                 ,NatMol,nolegame,numleg 
                 write(lo,*)'i,xyz(1:3,i),iEqui(i),nOpEq(i),ipix,lab(i)'
                 do i = 1, NatMol
                    nf=nfragm(i)
                    write(lo,'(i3,3f7.3,2i7,3i5,3x,a)')i,xyz(1:3,i),
     *                    iEqui(i),nOpEq(i),ipix(1:3,i),lab(i)
                 enddo
                 do j=1,NumLeg
                   write(lo,*)'j,LE(1:3,j)',j,LE(1:3,j)
                 enddo
             endif
!-----------------------------------------------------------------------
!
      if(ifmenubuild.eq.2)then     !viene da PianAnelliNew
         ifmenubuild=NatMol    
         return
      endif   
!
!!!
!!!
!!!
      if(ifmenubuild.eq.0.or.ipolim.eq.1)then     !solo apply symmetry
          call individua_frammenti(nfrag,nolegame)
!-- compatta ipix e nOpEq
!
          do i = 1, NatMol
                ipp=-1
                iTraslaTot = (ipp*(ipix(1,i))+5) * 100 
     *                     + (ipp*(ipix(2,i))+5) * 10 
     *                     +  ipp*(ipix(3,i))+5
                nOpEq(i) =1000*(nOpEq(i)/1000) + iTraslaTot
          enddo
!-----------------------------------------------------------------------
             kkpri=1
             if(kkpri.eq.0)then
               write(lo,*)'dopo individua_frammenti nolegame=',nolegame
               write(lo,*)
     *             'i,xyz(1:3,i),iEqui(i),nOpEq(i),ipix,incella,nfragm'
     1             ,' nOpEqBaric(nf),RS(i),Lab(i)'
               do i = 1, NatMol
                 nf=nfragm(i)
                 write(lo,'(i3,3f7.3,2i7,3i5,i3,i7,f5.0,3x,a)')
     *             i,xyz(1:3,i),iEqui(i),nOpEq(i),ipix(1:3,i)
     1            ,nfragm(i),nOpEqBaric(nf),RS(i),lab(i)
               enddo
               if(nolegame.eq.1)then   
                 do j=1,NumLeg
                   write(lo,*)'j,LE(1:3,j)',j,LE(1:3,j)
                 enddo
               endif
             endif
!-----------------------------------------------------------------------
          nfrag_ini=nfrag
          nfrag0=nfrag
          nfrag=nfrag+1
          NatMol0=NatMol
          NumLeg0=NumLeg
!
          do i1=1,nfrag0
             NatMol=NatMol+1
             NumLeg=NumLeg+1
             call applsym_frammento(i1,nfrag,NatMol0,NumLeg0,nolegame)
          enddo
!-----------------------------------------------------------------------
             kkpri=1
             if(kkpri.eq.0)then
               write(lo,*)'dopo appsym_frammento i1,natmol,numleg'
     1         ,i1,natmol,numleg
               write(lo,*)
     *         'i,baric(:,i),nOpEqBaric(i),lunghezzafra(i)'
               do i = 1, nfrag-1
                 write(lo,'(2i5,3f7.3,2i9)')
     *           nfrag-1,i,baric(1:3,i),nOpEqBaric(i),lunghezzafra(i)
               enddo
               write(lo,*)'i,xyz(1:3,i),iEqui(i),nOpEq(i),ipix,nfragm'
     1         ,' nOpEqBaric(nf),RS(i),Lab(i)'
               do i = 1, NatMol
                 nf=nfragm(i)
                 write(lo,'(i3,3f7.3,2i7,3i5,i3,i7,f5.0,3x,a)')
     1           i,xyz(1:3,i),iEqui(i),nOpEq(i)
     1           ,ipix(1:3,i),nfragm(i),nOpEqBaric(nf),RS(i),lab(i)
               enddo
               if(nolegame.eq.1)then   
               do j=1,NumLeg
                 write(lo,*)'j,LE(1:3,j)',j,LE(1:3,j)
               enddo
               endif
             endif
!-----------------------------------------------------------------------
          call trasla_frammenti(nfrag,nolegame)
!-----------------------------------------------------------------------
      kkpri=1
      if (kkpri.eq.0) then
          write(lo,*)'dopo trasla_frammenti '
          write(lo,*)
     *          'nfrag,i,baric(:,i),nOpEqBaric(i),nfragm(i)'
          do i = 1, nfrag
             write(lo,'(2i5,3f7.3,2i9)')
     *       nfrag,i,baric(1:3,i),nOpEqBaric(i),nfragm(i)     
          enddo
          write(lo,*)'i,xyz(1:3,i),iEqui(i),nOpEq(i),ipix,nfragm',
     1          ' nOpEqBaric(nf),RS(i),Lab(i)'
          do i = 1, NatMol-1
             nf=nfragm(i)
             write(lo,'(i3,3f7.3,2i7,3i5,i3,i7,f5.0,3x,a)')
     1             i,xyz(1:3,i),iEqui(i),nOpEq(i)
     1            ,ipix(1:3,i),nfragm(i),nOpEqBaric(nf),RS(i),lab(i)
          enddo
          if (nolegame.eq.1) then   
             do j=1,NumLeg
                write(lo,*)'j,LE(1:3,j)',j,LE(1:3,j)
             enddo
          endif
      endif
!-----------------------------------------------------------------------
          ii=0
          do nax=1, 3
             if(nCell(nax).ne.1) ii=ii+1           ! Cells along a/b/c
          enddo 
          if(ii.gt.0)then
            call trasla_cella(nfrag,nolegame,ier)
          else if(ii.eq.0)then
            if(minerale.eq.1)call crea_intorno_cella(nfrag,nolegame,ier)
          endif
          if(ier.eq.-1)return  
          nfrag=nfrag-1
          NatMol=NatMol-1
          if(nolegame.eq.1)NumLeg=NumLeg-1
!
          do na = 1, NatMol
            if (na.le.NatMol0.and.nfrag.gt.nfrag_ini) then
!--aggiunge il no.di frag. al nome
              i1=nfragm(na)
              ilab=Lab(na)
              vetch=' '
              call shift(ilab,lengb)
              write(vetch,'(i3)')i1
              call shift(vetch,lengv)
              ilabn=ilab(1:lengb)//'['//vetch(1:lengv)//']'
              Lab(na)=ilabn
            endif
          enddo
!-----------------------------------------------------------------------
      kkpri=1
      if (kkpri.eq.0) then
          write(lo,*)'alla fine nfrag= ',nfrag
          write(lo,*)'i,baric(1:3,i),nOpEqBaric(i),lunghezzafra(i)'
          do i = 1, nfrag
             write(lo,'(i5,3f7.3,2i9)')i,baric(1:3,i),nOpEqBaric(i),
     *          lunghezzafra(i)
          enddo
          write(lo,*)'i,xyztot(1:3,i),iEqui(i),nOpEq(i),ipix,nfragm'
     1,' nOpEqBaric(nf),Lab(i)'
         do i = 1, NatMol
            nf=nfragm(i)
            write(lo,'(i3,3f7.3,2i7,3i5,i3,i7,2x,a)')
     1      i,xyztot(1:3,i),iEqui(i),nOpEq(i)
     1      ,ipix(1:3,i),nfragm(i),nOpEqBaric(nf),Lab(i)
         enddo
         if (nolegame.eq.1) then   
            do j=1,NumLeg
               write(lo,*)'j,LE(1:3,j)',j,LE(1:3,j)
            enddo
         endif
      endif
!-----------------------------------------------------------------------
          endif
!!!
!!!
!!!
      if(numleg.gt.3250)numleg=3250
      NATV = 0
      do na = 1, NatMol
         if (RS(na) .gt. 0) then 
             NATV = NATV + 1
         endif
         x1(1:3) = xyz(1:3, na)
         call MoltMatVec(rm,x1,r1)
         xyz(1:3, na) = r1(1:3)
      enddo
!
      call AggiuSpig
      call BuildBonds(2)
      nAdd=NatMol-NatMol_ori
      if (nAdd.gt.0) then
          ifCont = 1
          write(Msg,10) nAdd
   10     format(i5,' equivalent atoms added ')
!gl       call MsgWinErr('Automatic Build', Msg, INFO_WINDOW, nExitCode)  06/05/09
          call PrintMess(Msg)
      endif
!      
      Rmin1 = 99999.
      Rmin2 = 99999.
      RMAX1 = -99999.
      RMAX2 = -99999.
      BondTable(:,:,:) = BondTableSav(:,:,:)
!
      return
      end
!
!code for build_frammenti
      subroutine build_frammenti(nadd)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Poliedri
!
      real BondTableSav(2,18,18)
!
      common/symcon/natsym,idoppiodi,iopsym(1000),ipolim
     1,asmin(3),asmax(3),incella(10000),idoppiodit
      common/buildmolec/natfrag(5000),nfraleg(20000),baric(3,5000)
     1,lunghezzafra(5000),minerale
      dimension ShfMerc(3,4),jcond(10000),mfrag(10000),cxc(3),iabcxc(3)
     1,a(3),x1(3),r1(3),jsf(3,2),cb(3),numeq(10000)
      dimension b(3)
      character*16 ilab,vetch,ilabn
!
      Natmol0=NatMol
      NumLeg0=NumLeg
      ipolim=0
      iprintmsg=0
!
      nolegame=1
      if(NumLeg.le.0) then
         nAdd=0
         nolegame=0
         return
      endif
!----------
!old      nce=0
!old      ShfMerc(:,:)=0.
!old      if (latt > 1) then
!old         call Centra (nce, Shf)
!old         do i=2,nce+1
!old            do j=1,3
!old              ShfMerc(j,i)=Shf(j,i-1)
!old            enddo
!old         enddo
!old      endif
!------------------------------------------------------------------------
             kkpri=1
             if(kkpri.eq.0)then
               write(lo,*)'build_frammenti:prima connectequiv  ' 
               write(lo,*)'i,xyzs(1:3,i),nOpEq(i),ipix'
               do i = 1, NatMol
                 nf=nfragm(i)
                 write(lo,'(i3,3f7.3,i7,3i5,i3,i7,3x,a)')
     *             i,xyz(1:3,i),nOpEq(i),ipix(1:3,i)
               enddo
!              do j=1,NumLeg
!                write(lo,*)'j,LE(1:3,j)',j,LE(1:3,j)
!              enddo
             endif
!------------------------------------------------------------------------
!-- genera gli equiv legati agli indep.
      call  connectequiv(nce,ShfMerc,NatMol0,NumLeg0)
!------------------------------------------------------------------------
      kkpri=1
      if (kkpri == 0) then
          write(lo,*)
     1          'build_frammenti:dopo connectequiv,numleg,numleg0',
     *          numleg,numleg0
          write(lo,*) 'i,xyz(1:3,i),RS(i),iEqui(i),nOpEq(i),ipix,
     *          incella,lab(i)'
          do i = 1, NatMol
             write(lo,'(i3,4f7.3,2i7,3i5,i3,a)') i,xyz(1:3,i),RS(i),
     *             iEqui(i),nOpEq(i),ipix(1:3,i),incella(i),lab(i)
          enddo
!         do j=1,NumLeg
!            write(lo,*)'j,LE(1:3,j)',j,LE(1:3,j)
!         enddo
      endif
!------------------------------------------------------------------------
!-- trova i legami tra gli equiv generati
      if(NatMol-NatMol0.gt.1)call legaequiv(NatMol0)
!------------------------------------------------------------------------

      kkpri=1
      if (kkpri == 0) then
          write(lo,*)'build_frammenti:dopo legaequiv'
          write(lo,*) 'i,xyz(1:3,i),RS(i),iEqui(i),nOpEq(i),ipix,
     *                incella,lab(i)'
          do i = 1, NatMol
             write(lo,'(i3,4f7.3,2i7,3i5,i3,a)') i,xyz(1:3,i),RS(i),
     *             iEqui(i),nOpEq(i),ipix(1:3,i),incella(i),lab(i)
          enddo
!         do j=1,NumLeg
!            write(lo,*)'j,LE(1:3,j)',j,LE(1:3,j)
!         enddo
      endif
!------------------------------------------------------------------------
      if(NatMol.gt.NatMol0)then
         jcond(1:10000)=0
         mfrag(1:10000)=0
         jcond(1)=1
         nfra=1
         mfrag(1)=nfra
         Natmol1=NatMol
         NumLeg1=NumLeg
!         write(lo,*)'natmol1,numleg1 ',natmol1,numleg1
         NatMOL1fin=0
!-- inizio loop
1        continue  
!      write(lo,'(a,i5)')' dopo 1 NatMol,jcond ',NatMol
!      write(lo,'(3(10i2,x))')jcond(1:NatMol)
         if(NatMOL1fin.eq.0)then
            jj0=0
            jj1=0
            jj2=0
            do i=1,NatMol1
              if(jcond(i).eq.0)jj0=jj0+1
              if(jcond(i).eq.1)jj1=jj1+1
              if(jcond(i).eq.2)jj2=jj2+1
            enddo
            if(jj1.eq.0.and.jj0.gt.0)then
               nfr=nfr+1
               do i=1,NatMol1
                 if(jcond(i).eq.0)then
                   jcond(i)=1
                   mfrag(i)=nfr
                 endif
               enddo
            else if(jj2.eq.NatMol1)then
               NatMOL1fin=1  
            endif
         endif
!      
         ifAdd = 0
         do i=1,NatMol           
           if(jcond(i).eq.1.and.incella(i).ne.1)then
              nfr=mfrag(i) 
              if(i.le.NatMol0)then
                 do j=1,NumLeg
                    if(i.eq.LE(1, j).or.i.eq.LE(2, j))then
                       kkk=LE(1,j)+LE(2,j)-i
                       if(jcond(kkk).eq.0)then
                          jcond(kkk)=1
                          mfrag(kkk)=nfr
                          ifAdd = ifAdd+1
                       endif
                    endif      
                 enddo
                 jcond(i)=2
                 go to 1
              else if(i.gt.NatMol0)then
                 ieq=iEqui(i)
                 do jj=1,NumLeg
                   if(ieq.eq.LE(1,jj).or.ieq.eq.LE(2,jj))then
                      kkk=LE(1,jj)+LE(2,jj)-ieq
!                      write(lo,*)'do jj,i,ieq,kkk,nOpEq(i) '
!     1                 ,jj,i,ieq,kkk,nOpEq(i)
                      call portavicino(ShfMerc,i,kkk,jcond,nfr,mfrag,
     *                NatMol1,NatMol1fin,NatMol0,NumLeg0,iprintmsg)
!
                      if(ipolim.gt.0.and.iprintmsg.eq.0)then
                        iprintmsg=1
                        Msg = 'Polymeric Structure '
*         call MsgWinErr('Automatic Build', Msg, WARN_WINDOW, nExitCode)
                    write(lo,"(/,' Automatic Build Warning: ',a,/)") Msg
!
                        if (minerale.eq.1)then
                          ipix(1:3,NatMol0+1:NatMol) = 0
                          iEqui(NatMol0+1:NatMol) = 0
                          nOpEq(NatMol0+1:NatMol) = 0
                          iOrd(NatMol0+1:NatMol)= 0
                          nzTot(NatMol0+1:NatMol) = 0
                          SinglePlotType(NatMol0+1:NatMol) = 0.
                          rMLU(NatMol0+1:NatMol) = 0.
                          RS(NatMol0+1:NatMol)= 0.
                          iCol(NatMol0+1:NatMol) = 0
                          xyztot(NatMol0+1:1:3,NatMol) = 0.
                          LE(1:3,Numleg0+1:Numleg) =0
                          NatMol=NatMol0
                          Numleg=Numleg0
                          Numleg0=0
                          nolegame=0
                        endif
                        return
                      endif
                      ifAdd = ifAdd+1
                   endif
                 enddo
                 jcond(i)=2
!      write(lo,'(a,2i5)')' do jj i,natmol',i,natmol
!      write(lo,'(3(10i2,x))')jcond(1:NatMol)
                 go to 1
              endif
           endif
         enddo
      endif
1000  continue
!------------------------------------------------------------------------

      kkpri=1
      if(kkpri.eq.0)then
      write(lo,*)'dopo 1000 ',
     *'i,xyz(1:3,i),RS(i),iEqui(i),nOpEq(i),ipix(1:3,i),incella(i)'
      do i = 1, NatMol
         write(lo,'(i5,4f7.3,6i7)')i,xyz(1:3,i),RS(i),iEqui(i),nOpEq(i)
     1     ,ipix(1:3,i),incella(i)
      enddo
!     do j=1,NumLeg
!     write(lo,*)'j,LE(1:3,j)',j,LE(1:3,j)
!     enddo
      endif
!------------------------------------------------------------------------
!-- redefinisce iequi(i), conta gli atomi eliminati
      natfindis=0
      do i = 1, NatMol
         i1=i
         do while (i1.gt.Natmol0)
            i2=iEqui(i1)
            i1=i2
         enddo
         iEqui(i)=i1 
         if (RS(i).le.0.) natfindis = natfindis + 1
      enddo
      nAdd=natmol-natfindis-natmol0
!      write(lo,*)'nAdd,natmol,natfindis,natmol0 ',
!     1nAdd,natmol,natfindis,natmol0
      numeq(1:NatMol0)=1
      do i=NatMol0+1,NatMol
          ieq=iEqui(i)
          neq=numeq(ieq)
          ilab=Lab(ieq)
          vetch=' '
          call shift(ilab,lengb)
          write(vetch,'(i2)')neq
          call shift(vetch,lengv)
          ilabn=ilab(1:lengb)//'_'//vetch(1:lengv)
          Lab(i)=ilabn
          numeq(ieq)=neq+1
      enddo
!------------------------------------------------------------------------

      kkpri=1
      if(kkpri.eq.0)then
      write(lo,*)
     *'i,xyz(1:3,i),RS(i),iEqui(i),nOpEq(i),NzTot(i) fine build_fram'
      do i = 1, NatMol
         write(lo,'(i5,4f7.3,5i7)')i,xyz(1:3,i),RS(i),iEqui(i),nOpEq(i)
     1     ,NzTot(i)
      enddo
!     do j=1,NumLeg
!     write(lo,*)'j,LE(1:3,j)',j,LE(1:3,j)
!     enddo
      endif
!------------------------------------------------------------------------
      return
      end
!
!code for connectequiv
      subroutine connectequiv(nce,ShfMerc,NatMol0,NumLeg0)
!-- aggiunge nella connettivita' i legami tra gli atomi originali (nb)e
!-- gli at. equiv. (di na)
!-- conserva : in  nOpEq(natmol=naequiv)  gli op di simm e di latt,
!--            in iabc(natmol=naequiv) la trasl.
!--            necessari per portar na a dist. di legame da nb
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Poliedri   
!
      real BondTableSav(2,18,18)
!
      common/symcon/natsym,idoppiodi,iopsym(1000),ipolim
     1,asmin(3),asmax(3),incella(10000),idoppiodit

      dimension x1(3), r1(3),cb(3),ShfMerc(3,4),b(3),a(3,3),d(3)
     1,iabc(3),sss(3),ipwr(3)
      real distBackBone(2)
      integer tipoLegame
!
      distBackBone(1) = 4.0
      distBackBone(2) = 7.5
      if (ifSkeleton == 0) then   ! gianluca 11/03/2009
          tipoLegame = 1
      else
          tipoLegame = 4
      endif
!
c----------
      do nb = 1, NatMol0
        iz2 = nzTot(nb)
        if(RS(iabs(iEqui(nb))) .gt. -10..and.iz2.gt.0) then
           do na = 1,NatMol0
             iz1 = nzTot(na)
             if(RS(iabs(iEqui(na))) .gt. -10..and.iz1.gt.0) then
               ieq=iEqui(na)
               b(1:3) = xyz(1:3, na)
!nd             
!old               do n = 1, nSymMol
!old                 do j = 1, 3
!old                   do k = 1, 3
!old                      a(k, j) = kmat(n, k, j)
!old                   enddo
!old                 enddo
!old                 do i = 1, 3
!old                    cb(i) = 0.
!old                    do j = 1, 3
!old                       cb(i) = cb(i) + a(i, j) * b(j)
!old                    enddo
!old                    cb(i) = cb(i) + tmat(n, i)
!old                 enddo
!old                 do nn =1, nce+1
!old                   do  i = 1, 3
!old                     cb(i) = cb(i) + ShfMerc(i, nn)
!old                   enddo
               do n=1,nsymTot
                   call xequiTot(n, b, cb,iexit)
!--calcola la dist. a nb
                   d(1:3) = cb(1:3) -xyz(1:3, nb)
                   call reddst(d,sss)
                   iabc(1:3)=nint(sss(1:3))
                   dis=cdist(gdist,d,ddummy)
!
!      write(lo,'(a,2i3,3f8.3)')
!     1'iz1,iz2,dis,BondTable(1,iz1,iz2),BondTable(2,iz1,iz2)'
!     1,iz1,iz2,dis,BondTable(1,iz1,iz2),BondTable(2,iz1,iz2)
                   iOk = 0
                   if (ifSkeleton == 0) then   ! gianluca 11/03/2009
                     if (dis.ge.(BondTable(1,iz1,iz2)-0.01).and.
     *                   dis.le.(BondTable(2,iz1,iz2)+0.01)) then
                         iOk = 1
                     endif
                   else
                     if (dis < distBackBone(iz1) .and. dis > 3.0) then
                         iOk = 1
                     endif
                   endif
                   if (iOk == 1) then
*                    if (dis.ge.(BondTable(1,iz1,iz2)-0.01).and.
*    *                   dis.le.(BondTable(2,iz1,iz2)+0.01)) then
                     cb(1:3)=cb(1:3)-sss(1:3)
                     idop = iDoppio(NatMol, cb)
!          write(lo,*)'na,nb,natmol,dis,cb,sss,idop,idoppiodi',
!     1                na,nb,natmol,dis,cb,sss,idop,idoppiodi 
                     if (idop .eq. 0) then
                       NatMol = NatMol + 1
!          write(lo,*)'connectequiv salvato natmol,dis,cb,sss',
!     1                natmol,dis,cb,sss 
c-----------------------------------------------------------------
                       if (NatMol.eq.MaxAtomsInGr - NatSpi) then
                         write(lo,*) ' The number of atoms exceeds',
     *                         ' the allowed maximum.',NatMol
                         NatMol=NatMol0
                         NumLeg=NumLeg0
                         do  i = 1, NatMol
                           xyz(1:3, i) = xyzs(1:3,i)
                         enddo
                         return
                       endif
c-----------------------------------------------------------------
                       xyz(1:3, NatMol) = cb(1:3)
                       incella(NatMol)=ifincella(cb)
                       call codifica_at_leg(nb,NatMol)
                       ipwr(1:3)= ipix(1:3,ieq)
                       ipix(1:3,NatMol) = ipix(1:3,ieq)+iabc(1:3)
                       iEqui(NatMol) = ieq
!old                       nOpEq(NatMol) = n * 10000 + nn * 1000
                       nOpEq(NatMol) = n * 1000
                       iOrd(NatMol)= NatMol
                       nzTot(NatMol) = nzTot(ieq)
                       SinglePlotType(NatMol) = SinglePlotType(ieq)
                       rMLU(NatMol) = rMLU(ieq)
                       RS(NatMol)=RS(ieq)
                       iCol(NatMol) = iCol(ieq)
                       xyztot(1:3,NatMol) = xyz(1:3, NatMol)
                       if(RS(nb).gt.0.and.RS(NatMol).gt.0)then
                         NumLeg = NumLeg + 1
                         LE(1, NumLeg) = nb
                         LE(2, NumLeg) = NatMol
                         LE(3, NumLeg) = tipoLegame
                       endif
                     else if (idop .eq.-1) then
                       itrovato=0
                       do k2=1,Numleg
                  if(idoppiodi.eq.LE(1,k2).or.idoppiodi.eq.LE(2,k2))then
                         k3=LE(1,k2)+LE(2,k2)-idoppiodi
                         if(k3.eq.nb)then
                           itrovato=1
                           exit
                         endif
                  endif
                       enddo
                       if(itrovato.eq.0.and.idoppiodi.gt.0)then
                         if(RS(nb).gt.0.and.RS(idoppiodi).gt.0)then
                           NumLeg = NumLeg + 1
                           LE(1, NumLeg) = nb
                           LE(2, NumLeg) = idoppiodi
                           LE(3, NumLeg) = tipoLegame
                         endif
                       endif
                     endif
                   endif
               enddo
             endif
           enddo
        endif
      enddo
      return
      end
!
!code for codifica_at_leg
      subroutine codifica_at_leg(iat1,iat2)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Poliedri
!
      common/symcon/natsym,idoppiodi,iopsym(1000),ipolim
     1,asmin(3),asmax(3),incella(10000),idoppiodit
 
!-- setta incella(iat2)=2 se iat2 Ã¨ fuori ed Ã¨ iat1 dentro
!-- setta incella(iat2)=3 se iat2 Ã¨ fuori ed Ã¨ iat1 Ã¨ 2
!-- lascia incella(iat2)=1 se iat2 Ã¨ fuori ed Ã¨ iat1 fuori
!-- lascia incella(iat2)=0 se iat2 Ã¨ dentro ed Ã¨ iat1 fuori
!
      if(incella(iat2).eq.1.and.incella(iat1).eq.0)incella(iat2)=2
      if(incella(iat2).eq.1.and.incella(iat1).eq.2)incella(iat2)=3
!      
      return
      end
!
!code for legaequiv
      subroutine legaequiv(NatMol0)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Poliedri
!
      real BondTableSav(2,18,18)
!
      common/symcon/natsym,idoppiodi,iopsym(1000),ipolim
     1,asmin(3),asmax(3),incella(10000),idoppiodit
     
      dimension b(3),sss(3),d(3)
!
      nnpp = 0
      do  i = NatMol0+1 , NatMol - 1
         iz1 = nzTot(i)
         if(iz1.le.0)cycle
         iP1 = i + 1
         do j = iP1 , NatMol
            iz2 = nzTot(j)
            if(iz2.le.0)cycle
            nnpp = nnpp + 1
            dis = 0
            do k = 1 , 3
                d(k)= xyz(k,i) - xyz(k,j)
            enddo
                  dis=cdist(gdist,d,ddummy)
c      write(lo,*)'legaequiv i,j,iz1,iz2,dis,BondTable(1:2,iz1,iz2)',
c     1i,j,iz1,iz2,dis,BondTable(1:2,iz1,iz2)
            if (dis.ge.(BondTable(1,iz1,iz2)-0.01).and.
     *          dis.le.(BondTable(2,iz1,iz2)+0.01)) then
            if (RS(i).ge.0.and.RS(i).ge.0)then
                NumLeg = NumLeg + 1
                LE(1, NumLeg) = i
                LE(2, NumLeg) = j
                LE(3, NumLeg) = 1
!            call codifica_at_leg(i,j)
!      write(lo,'(a,i7,3i5,2x,2i8,6f8.3)')
!     1'legaequiv numleg,le(1:3,numleg)incella ',numleg,le(1:3,numleg)
!     1,incella(i),incella(j)
            endif
            endif
c            if (NumLeg .EQ. nMaxLeg - nlp) return
         enddo
      enddo
      return
      end
!
!code for portavicino 
      subroutine portavicino(ShfMerc,i1,i2,jcond,nfr,mfrag
     1,NatMol1,NatMOL1fin,NatMol0,NumLeg0,iprintmsg)
!-- porta i2 vicino a i1 applicando gli op.applicati prima a i1(nOpEq(i1),ipix(1:3,i1))      
!-- aggiunge in xyz le coord. di i2 e nella connettivita' il legame 

      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Poliedri
!
      real BondTableSav(2,18,18)
!
      common/symcon/natsym,idoppiodi,iopsym(1000),ipolim
     1,asmin(3),asmax(3),incella(10000),idoppiodit
     
      dimension cb(3),ShfMerc(3,4),b(3),a(3,3),d(3),cdum(3),jcond(10000)
     1,iabc(3),sss(3),mfrag(10000)
!
!old      nop=nOpEq(i1)/10000
!old      ntras=(nOpEq(i1)-nop*10000)/1000
      iabc(1)=ipix(1,i1)
      iabc(2)=ipix(2,i1)
      iabc(3)=ipix(3,i1)
      n=nOpEq(i1)/1000 
      b(1:3) = xyz(1:3, i2)
      call xequiTot(n, b, cb,iexit)
      cb(1:3) = cb(1:3) - iabc(1:3)
!via
!old                 do j = 1, 3
!old                   do k = 1, 3
!old                   A(k, j) = kmat(nop, k, j)
!old                   enddo
!old                 enddo
!old                        do i = 1, 3
!old                        cb(i) = 0
!old                          do j = 1, 3
!old                          cb(i) = cb(i) + A(i, j) * B(j)
!old                          enddo
!old                        cb(i) = cb(i) + tmat(nop, i)
!old                        enddo
!old                        cdum(1:3)=cb(1:3)
!old                 do  i = 1, 3
!oldc                 cb(i) = cb(i) + ShfMerc(i, ntras) 
!old                 cb(i) = cb(i) + ShfMerc(i, ntras) - iabc(i)
!old                 enddo
!fine via
               ia=ifincella(cb)
               if(iprintmsg.eq.0)ia=0
               idop  = iDoppio(NatMol, cb)
               idopt = iDoppiotras(NatMol, cb)
!      write(lo,'(a,a,2i5,3f8.3,5i4)')
!     1'portavicino i1,i2,cb,idop,idoppiodi,idoppiodit'
!     1,',idopt,ifincella(cb)'
!     1,i1,i2,cb,idop,idoppiodi,idoppiodit,idopt,ifincella(cb)
                  if (idop .eq. 0) then
                     NatMol = NatMol + 1
!      write(lo,*)'portavicino i1,i2,dis,iz1,iz2,natmol',
!     1i1,i2,dis,iz1,iz2,natmol
c-----------------------------------------------------------------
                  if (NatMol.eq.MaxAtomsInGr - NatSpi) then
                      write(lo,*) ' The number of atoms exceeds',
     *                         ' the allowed maximum.',NatMol
c          write(Msg,10) 
c          call MsgWinErr('Apply Symmetry', Msg, INFO_WINDOW, nExitCode)
                   NatMol=NatMol0
                   NumLeg=NumLeg0
                     do  i = 1, NatMol
                     xyz(1:3, i) = xyzs(1:3,i)
                     enddo
                      return
                  end if
c-----------------------------------------------------------------
!       write(lo,'(a,3i5,i7,2i4,6f5.3)')
!     1'portavicino i1,i2,ieq,nOpEq(i1),nop,ntras,cb,ShfMerc(1:3, ntras)'
!     1,i1,i2,ieq,nOpEq(i1),nop,ntras,cb,ShfMerc(1:3, ntras)
                     xyz(1:3, NatMol) = cb(1:3)
                     ipix(1:3,NatMol) = ipix(1:3,i1)
                     iEqui(NatMol) = iEqui(i2)
                     ieq=iEqui(i2)
!old                     nOpEq(NatMol) = nop * 10000 + ntras * 1000
                     nOpEq(NatMol) = n * 1000
                     iOrd(NatMol)= NatMol
                     nzTot(NatMol) = nzTot(ieq)
                     SinglePlotType(NatMol) = SinglePlotType(ieq)
                     rMLU(NatMol) = rMLU(ieq)
                     RRSS=abs(RS(ieq))
                     RS(NatMol)=RRSS
                     if(ia.ne.0)then
                     RS(NatMol)=-(RRSS)
                     endif
                     incella(NatMol)=ia
            call codifica_at_leg(i1,NatMol)
                     iCol(NatMol) = iCol(ieq)
                     xyztot(1:3,NatMol) = xyz(1:3, NatMol)


                     jcond(NatMol)=1
                     if(incella(NatMol).eq.1)jcond(NatMol)=2
                     mfrag(NatMol)=nfr
                if(RS(i1).gt.0.and.RS(NatMol).gt.0)Then
                     NumLeg = NumLeg + 1
                     LE(1, NumLeg) = i1
                     LE(2, NumLeg) = NatMol
                     LE(3, NumLeg) = 1
                endif
!      write(lo,'(a,i7,3i5,2x,2i8,6f8.3)')
!     1'portavicino numleg,le(1:3,numleg)incella(i1),Natmol '
!     1,numleg,le(1:3,numleg)
!     1,incella(i1),incella(NatMol)
!                     end if
!       write(lo,*)'portavicino i1,i2, storizzato natmol,ieq,cb'
!     1,i1,i2,natmol,ieq,cb
                  else if(idop.lt.0)then
                  itrovato=0
                  do k2=1,Numleg
                  if(idoppiodi.eq.LE(1,k2).or.idoppiodi.eq.LE(2,k2))then
                  k3=LE(1,k2)+LE(2,k2)-idoppiodi
!      write(lo,'(a,10i5)')'itrovato,idoppiodi,k2,k3,i1',
!     1itrovato,idoppiodi,k2,k3,i1
                    if(k3.eq.i1)then
                    itrovato=1
                    exit
                    endif
                  endif
                  enddo
                     if(itrovato.eq.0.and.idoppiodi.gt.0)then
                     if(RS(i1).gt.0.and.RS(idoppiodi).gt.0)Then
                     NumLeg = NumLeg + 1
                     LE(1, NumLeg) = i1
                     LE(2, NumLeg) = idoppiodi
                     LE(3, NumLeg) = 1
!      write(lo,'(a,i5,2x,3i4,3f8.3)')'itrovato=0',numleg,le(1:3,numleg)
                     endif
                     endif
                  endif
      return
      end
!
!
!code for individua_frammenti_ini
      subroutine individua_frammenti_ini
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Poliedri
!      
      common/symcon/natsym,idoppiodi,iopsym(1000),ipolim
     1,asmin(3),asmax(3),incella(10000),idoppiodit
      common/buildmolec/natfrag(5000),nfraleg(20000),baric(3,5000)
     1,lunghezzafra(5000),minerale
       dimension x(3),x1(3),cb(3),iabc(3),sss(3),d(3),ivvet(2)
      character*16 ilab,vetch,ilabn
      real distBackBone(2)
      integer tipoLegame
!
!      nfragm(i) = no. del frammento a cui appartiene l'i-esimo atomo
!      natfrag(i)= no. di atomi nel i-esimo frammento
!
      if (ifSkeleton == 0) then   ! gianluca 11/03/2009
          tipoLegame = 1
      else
          tipoLegame = 4
      endif
      distBackBone(1) = 4.0
      distBackBone(2) = 7.5
!
      NumLeg=iconn(1)
      if(NumLeg.lt.0)NumLeg=0
      nfragmm=1
      nfragm(:)=0
      natfrag(:)=0
!      
      nfrag=0
!
      if(NumLeg.gt.0)then
         nfragmm=1
         ich1=1
         do while (ich1==1)
            ich1=0
            do j=1,NumLeg
               i1 = LE(1,j)
               i2 = LE(2,j)
               if(nfragm(i1).ne.0.or.nfragm(i2).ne.0)cycle
               nfragm(i1) = nfragmm
               nfragm(i2) = nfragmm
               nfragmm=nfragmm+1
               ich1=1
               exit
            enddo
            ich2= 1
            do while (ich2== 1)
               ich2=0
               do j=1,NumLeg
                  i1 = LE(1,j)
                  i2 = LE(2,j)
                  if(nfragm(i1).eq.nfragm(i2))cycle
                  ich2=1
                  nf=max0(nfragm(i1),nfragm(i2))
                  nfragm(i1) = nf
                  nfragm(i2) = nf
                  exit
               enddo
            enddo
         enddo
         do j=1,NumLeg
            i1 = LE(1,j)
            i2 = LE(2,j)
            i3=nfragm(i1) 
            i4=nfragm(i2) 
            nfraleg(j)=i3
         enddo
         nfrag=nfragmm-1
      endif
!-- controlla gli isolati
      do i=1,NatMol
         i1=nfragm(i)
         if(i1.eq.0)then
            nfrag=nfrag+1
            nfragm(i)=nfrag
         endif
      enddo     
!      write(lo,'(a,i3,10i5)')'nfrag,nfragm(1:Natmol) ',nfrag
!      write(lo,'(10i5)')nfragm(1:Natmol) 
!-- i frammenti sono uniti per un op. di sym.? ,se sono disordinati (at.troppo vicini)
!-- non crea i legami tra frammenti
      nfraleg(:)=0
!-- fissa il primo frammento
      nfraleg(1)=1
!      
!old      ivvet(1)= 1
!old      ivvet(2)=-1
!old      ifin=icent+1
1     continue
      do j1=1,nfrag
         if(nfraleg(j1).eq.0)cycle
         do i=1,NatMol
            i1=nfragm(i)
            if(i1.ne.j1)cycle
            if(RS(i).le.0)cycle
            iz1 = nzTot(i)
            x1(1:3)=xyz(1:3,i)
            NumLeg_sav=NumLeg
            idisorder=0
            do j=1,NatMol
               if(RS(j).le.0)cycle
               i2=nfragm(j)
               if(i1.eq.i2)cycle
               iz2 = nzTot(j)
               x(1:3)=xyz(1:3,j)

!! newdo
!old               do kt=1,ncentr
!old                  do ifi=1,ifin
!old                  coef=ivvet(ifi)
!old                     do k=1,nsym
               do k=1,nsymTot     
!old                        call xequi(x,k,coef,cb,kt)
                   call xequiTot(k, x, cb,iexit)
                   d(1:3)= cb(1:3)-x1(1:3) 
                   call reddst(d,sss)
                   iabc(1:3)=nint(sss(1:3))
                   dis=cdist(gdist,d,ddummy)
                   iOk = 0
                   if (ifSkeleton == 0) then   ! gianluca 11/03/2009
                      if (dis.le.(1-0.3)*BondTable(1,iz1,iz2))then
                         idisorder=i2
                         iOk = 1
                      endif
                      if (dis.ge.(BondTable(1,iz1,iz2)-0.01).and.
     *                     dis.le.(BondTable(2,iz1,iz2)+0.01)) then
                              iOk = 1
                      endif
                   else
                      if (dis < distBackBone(iz1) .and. dis > 3.0) then
                          iOk = 1
                      endif
                   endif
                      if (iOk == 1) then
!                        cb(1:3)=cb(1:3)-sss(1:3)
                         cb(1:3)=cb(1:3)-iabc(1:3)
                         xyz(1:3,j) = cb(1:3)
                         incella(j)=ifincella(cb)
                         ipix(1:3,j) = ipix(1:3,j)+iabc(1:3)
                         nfragm(j)=j1
*mercedes 14/03/2011     kop=(ifi-1)*nsym+k            
!old                         nOpEq(j) = kop * 10000 + kt * 1000
                         nOpEq(j) = k * 1000
                         if(idisorder.eq.0)then
                              NumLeg = NumLeg + 1
                              LE(1, NumLeg) = i
                              LE(2, NumLeg) = j
                              LE(3, NumLeg) = tipoLegame
!         write(lo,*)' NumLeg,LE(1:3, NumLeg) ',NumLeg,LE(1:3, NumLeg)
                         endif
!-- applica l'operatore agli atomi del frammento
                         do in=1,NatMol
                            if(nfragm(in).ne.i2)cycle
                            if(RS(in).lt.0)cycle
                            x(1:3) = xyz(1:3, in)
!old                          call xequi(x,k,coef,cb,kt)
                            call xequiTot(k, x, cb,iexit)
                            xyz(1:3,in)=cb(1:3)-iabc(1:3)
                            incella(in)=ifincella(cb)
                            ipix(1:3,in) = ipix(1:3,in)+iabc(1:3)
                            nfragm(in)=j1
*mercedes 14/03/2011        kop=(ifi-1)*nsym+k            
!old                          nOpEq(in) = kop * 10000 + kt * 1000
                            nOpEq(in) = k * 1000
 !--controlla il disordine
                            do in2=1,NatMol
                               if(nfragm(in2).ne.i1)cycle
                               iz3 = nzTot(in2)
                               d(1:3)=xyz(1:3,in2)-xyz(1:3,in)
                               dis=cdist(gdist,d,ddummy)
                            if (dis.le.(1-0.3)*BondTable(1,iz3,iz2))then
                                    idisorder=i2
*                   write(lo,*)'frag:i1,i2,in2,in,dis ',i1,i2,in2,in,dis
                            endif
                            enddo
                         enddo
                         nfraleg(i2)=1
                         if(idisorder.eq.i2)then
                            do in2=NumLeg_sav+1,NumLeg
                                LE(1:3,in2)=0
                            enddo
                         endif
                         go to 1
                      endif
!old                     enddo
!old                  enddo
!old               enddo
               enddo
! fine newdo               
            enddo
         enddo
      enddo
      return
      end  
!
!code for individua_frammenti
      subroutine individua_frammenti(nfrag,nolegame)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Poliedri
      common/symcon/natsym,idoppiodi,iopsym(1000),ipolim
     1,asmin(3),asmax(3),incella(10000),idoppiodit
      common/buildmolec/natfrag(5000),nfraleg(20000),baric(3,5000)
     1,lunghezzafra(5000),minerale
       dimension maxlimi(3),minlimi(3),medlimi(3),iabc(3),bar(3),bar1(3)
      character*16 ilab,vetch,ilabn
     
!      nfragm(i) = no. del frammento a cui appartiene l'i-esimo atomo
!      natfrag(i)= no. di atomi nel i-esimo frammento
!      nfraleg(i)= no. del frammento  a cui appartiene l'i-esima terna  in LE(1:3,i)
      nfragmm=1
      nfragm(:)=0
      natfrag(:)=0
!      
      nfrag=0
      if(nolegame.eq.1)then   
         nfragmm=1
         ich1=1
         do while (ich1==1)
            ich1=0
            do j=1,NumLeg
               i1 = LE(1,j)
               i2 = LE(2,j)
               if (i1 <= 0 .or. i2 <= 0) cycle
               if(nfragm(i1).ne.0.or.nfragm(i2).ne.0)cycle
               nfragm(i1) = nfragmm
               nfragm(i2) = nfragmm
               nfragmm=nfragmm+1
               ich1=1
               exit
            enddo
            ich2= 1
            do while (ich2== 1)
              ich2=0
              do j=1,NumLeg
                 i1 = LE(1,j)
                 i2 = LE(2,j)
                 if (i1 <= 0 .or. i2 <= 0) cycle
                 if(nfragm(i1).eq.nfragm(i2))cycle
                 ich2=1
                 nf=max0(nfragm(i1),nfragm(i2))
                 nfragm(i1) = nf
                 nfragm(i2) = nf
                 exit
              enddo
            enddo
         enddo
         do j=1,NumLeg
            i1 = LE(1,j)
            i2 = LE(2,j)
            if (i1 <= 0 .or. i2 <= 0) cycle
            i3=nfragm(i1) 
            i4=nfragm(i2) 
            nfraleg(j)=i3
         enddo
         nfrag=nfragmm-1
      endif
!-- controlla gli isolati
      do i=1,NatMol
         i1=nfragm(i)
         if(i1.eq.0)then
            nfrag=nfrag+1
            nfragm(i)=nfrag
         endif
      enddo     
!      write(lo,'(a,i3,10i5)')'individua_fr nfrag,nfragm(1:Natmol) ',nfrag
!      write(lo,'(10i5)')nfragm(1:Natmol) 
!--calcola i baricentro
      do i1=1,nfrag
         minlimi=0
         maxlimi=0
         medlimi=0
         bar=0.
         do i=1,NatMol
            if(i1.ne.nfragm(i))cycle
            bar(1:3)=bar(1:3)+xyz(1:3,i)
            natfrag(i1)=natfrag(i1)+1
         enddo
!      write(lo,'(a,2(3x,3i5))')'maxlimi,minlimi,medlimi',maxlimi,minlimi
!     1 ,medlimi
      bar(1:3)=bar(1:3)/natfrag(i1)
      bar1(1:3)=bar(1:3)
!         nOpEqbaric(i1) = 11555
!-- controlla se e' fuori la cella
      iabc=0
      call RimettiInCella2(bar, iabc)
      baric(1:3,i1)=bar(1:3)
!-- crea il label del baricentro, utile a ricordare l'op de sym e la trasl. applicata
!old         nOpEqBaric(i1) = 11555
      nOpEqBaric(i1) = 1555
      ipp=-1
      iTraslaTot = (ipp*(iabc(1))+5) * 100 
     *           + (ipp*(iabc(2))+5) * 10 
     *           +  ipp*(iabc(3))+5
      if(iTraslaTot.ne.555)then
!-- applica la traslazione agli atomi del frammento setta ipix
         do in=1,NatMol
            if(nfragm(in).ne.i1)cycle
            do l=1,3
               xyz(l,in)=xyz(l,in)-iabc(l)
               ipix(l,in)=ipix(l,in)+iabc(l)
               if(xyz(l,i).gt.1.001)maxlimi(l)=3
               if(xyz(l,i).lt.0.00)minlimi(l)=1
            enddo
         enddo
      endif
      enddo     
!-- controlla se il fragm. si estende oltre la cella 
!-- (se si verra' ripetuto traslato) 
      do i1=1,nfrag
         minlimi=0
         maxlimi=0
         medlimi=0
         xlimx=0.999
         xlimn=0.0001
         bar=0.
         do i=1,NatMol   
            if(i1.ne.nfragm(i))cycle
            do l=1,3
                if(xyz(l,i).ge.xlimx)maxlimi(l)=3
                if(xyz(l,i).le.xlimn)minlimi(l)=1
                if(xyz(l,i).lt.xlimx.and.xyz(l,i).gt.xlimn)medlimi(l)=2
            enddo
         enddo
!      write(lo,'(a,i5,3f8.3,i8,2i5)')   
!     1'1 nfrag,baric(,n.frag),nOpEqbaric(nfrag),lunghezzafra(i1),ifuori'
!     1,i1,baric(1:3,i1),nOpEqbaric(i1),lunghezzafra(i1),ifuori
         lunghezzafra(i1)=mod(maxlimi(1)+minlimi(1),4)*100
     1                   +mod(maxlimi(2)+minlimi(2),4)*10
     1                   +mod(maxlimi(3)+minlimi(3),4)
!      write(lo,'(a,i5,3f8.3,i8,i5)')
!     1' n.frag,baric(1:3,n.frag),nOpEqbaric(nfrag),lunghezzafra(i1)'
!     1,i1,baric(1:3,i1),nOpEqbaric(i1),lunghezzafra(i1)
      enddo     
      return
      end  
!
!code for applsym_frammento
      subroutine applsym_frammento(nfra,nfrag,NatMol0,NumLeg0,nolegame)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Poliedri
!
      common/symcon/natsym,idoppiodi,iopsym(1000),ipolim
     1,asmin(3),asmax(3),incella(10000),idoppiodit
      common/buildmolec/natfrag(5000),nfraleg(20000),baric(3,5000)
     1,lunghezzafra(5000),minerale
      dimension  b(3),x(3),c(3), cb(3), iabc(3),itras(3),ivvet(2),r1(3)
     1,ioriat(20000),minlimi(3),maxlimi(3),ipixini(3)
      character*16 ilab,vetch,ilabn
!
      xlim1=0.000
      xlim2=1.000
      if(ipolim.eq.1)then
         xlim1=0.001
         xlim2=0.999
!        if(minerale.eq.1)then
!          xlim1=-0.3
!          xlim2=1.3
!        endif
      endif
!old      ivvet(1)= 1
!old      ivvet(2)=-1
!old      ifin=icent+1
      nopbaricori=nOpEqBaric(nfra)
!old      ii=nopbaricori-11000
      ii=mod(nopbaricori,1000)
      ipixini(1)=ii/100
      iii=ii-ipixini(1)*100
      ipixini(2)=iii/10
      ipixini(3)=iii-10*(iii/10)
      ipixini(1:3)=5-ipixini(1:3)   
      x(1:3) = baric(1:3, nfra)
!     write(lo,'(a,i5,3f8.3,i8,3i4)')
!    1' applsym_f,nfra,baric(1:3,nfra),nOpEqbaric(nfra),ipixini'
!    1,nfra,baric(1:3,nfra),nOpEqbaric(nfra),ipixini
      nfrageq=0
! newdo      
!old      do kt=1,ncentr
!old        do ifi=1,ifin
!old        coef=ivvet(ifi)
!old            do k=1,nsym
!      write(lo,'(a,2i5,f5.0,i5,t10f6.3)')
!     1'nsym,k,coef,kt,centrt(latt,1:kt+2)'
!     1,nsym,k,coef,kt,centrt(latt,1:kt+2)
      do k=1,nsymTot
         maxlimi=0
         minlimi=0
!old         call xequi(x,k,coef,cb,kt)
         iexit=-1
         call xequiTot(k, x, cb,iexit)
!           write(lo,'(a,i5,2(3f8.3,2x))')'k ,cb equiv di x',k,cb,x
         iabc=0
         call RimettiInCella2(cb, iabc)
!          write(lo,'(a,2(3f8.3,3i5))')'cb,iabc',cb,iabc
!--controlla se gia' esiste
         do kn=1,nfrag
            k3=0
            do kk=1,3
               if(abs(cb(kk)-baric(kk,kn)).le.0.001)k3=k3+1
            enddo
            if(k3.eq.3)exit   !elimina i doppioni
         enddo
!-- non esiste ancora             
         if(k3.ne.3)then
            baric(1:3,nfrag)=cb(1:3)
            ioriat(:)=0
!-- crea il label del baricentro, utile a ricordare l'op de sym e la trasl. applicata
!old            kop=(ifi-1)*nsym+k            
!old            nOpEqBaric(nfrag) = kop * 10000 + kt * 1000
            nOpEqBaric(nfrag) = k * 1000
            ipp=-1
            iTraslaTot = (ipp*(iabc(1)+ipixini(1))+5) * 100 
     *                 + (ipp*(iabc(2)+ipixini(2))+5) * 10 
     *                 +  ipp*(iabc(3)+ipixini(3))+5
            nOpEqBaric(nfrag) = nOpEqBaric(nfrag) + iTraslaTot
!
!      write(lo,'(a,i5,3f8.3,i8,3i3,3i5)')
!     1'n.frag,baric(1:3,n.frag),nOpEqbaric(nfrag),iabc,ipixini'
!     1,nfrag,cb(1:3),nOpEqbaric(nfrag),iabc,ipixini 
!
!-- applica l'operatore agli atomi del frammento
            nini=NatMol
            do in=1,NatMol0
               if(nfragm(in).ne.nfra)cycle
               if(RS(in).lt.0)cycle
               b(1:3) = xyz(1:3, in)
!old                call xequi(b,k,coef,cb,kt)
               call xequiTot(k, b, cb,iexit)
               c(1:3)=cb(1:3)-iabc(1:3)
!      write(lo,'(a,i5,3f8.3,i8,3i3,36f8.3)')
!     1 ' in, xyz(1:3,in),nOpEq(in),iabc,cb,c ',
!     1   in, xyz(1:3,in),nOpEq(in),iabc,cb,c 
!--controlla se gia' esiste
               do kn=1,NatMol-1
                   k3=0
                   do kk=1,3
                     if(abs(c(kk)-xyz(kk,kn)).le.0.001)k3=k3+1
                   enddo
                   if(k3.eq.3)then
!          write(lo,*)'eliminato natmol,=kn equiv di in',natmol,kn,in
                      ioriat(NatMol)=0
                      exit   !elimina i doppioni
                   endif
               enddo             
               if(k3.eq.3)cycle
               xyz(1:3,NatMol)=cb(1:3)-iabc(1:3)
!-- controlla se il fragm. si estende oltre la cella 
!-- (se si verra' ripetuto traslato) 
               do l=1,3
!                   if(xyz(l,NatMol).gt.1.001)maxlimi(l)=3
                   if(xyz(l,NatMol).gt.xlim2)maxlimi(l)=3
                   if(xyz(l,NatMol).lt.xlim1)minlimi(l)=1
               enddo
!--   
               do l=1,3
 !                   kt1=(kt-1)*3+l
!--05nov08                    ipix(l,NatMol)=-(-iabc(l)+centrt(latt,kt1))
!old               ipix(l,NatMol)=ipix(l,NatMol)-(-iabc(l)+centrt(latt,kt1))
               ipix(l,NatMol)=ipix(l,NatMol)-(-iabc(l))
               enddo
               iequi(NatMol)=iequi(in) 
               ieq = in
               ioriat(in)=NatMol
               nfragm(NatMol) = nfrag
               nOpEq(NatMol) = nOpEq(in)
               iOrd(NatMol)= NatMol
               nzTot(NatMol) = nzTot(ieq)
               SinglePlotType(NatMol) = SinglePlotType(ieq)
               rMLU(NatMol) = rMLU(ieq)
               RS(NatMol)=RS(ieq)
               iCol(NatMol) = iCol(ieq)
               xyztot(1:3,NatMol) = xyz(1:3, NatMol)
!                
               ilab=Lab(ieq)
               vetch=' '
               call shift(ilab,lengb)
               write(vetch,'(i3)')nfrag
               call shift(vetch,lengv)
               ilabn=ilab(1:lengb)//'['//vetch(1:lengv)//']'
               Lab(NatMol)=ilabn
               NatMol=NatMol+1
            enddo
            lunghezzafra(nfrag)=mod(maxlimi(1)+minlimi(1),4)*100
     1                         +mod(maxlimi(2)+minlimi(2),4)*10
     1                         +mod(maxlimi(3)+minlimi(3),4)
            nfin=NatMol-1
!-- copia la connett.            
            if(nolegame.eq.1)then   
               do kj=1,numleg0
!      write(lo,'(a,9i5)')'kj,nfra,nfraleg(kj)',kj,nfra,nfraleg(kj)
                  if(nfraleg(kj).eq.nfra)then    
                     i1=Le(1,kj)
                     i2=Le(2,kj)
                     if(i1.ne.0.and.i2.ne.0)then
!      write(lo,'(a,2i4,2x,2i4)')
!     1'i1,i2,ioriat(i1),ioriat(i2)'
!     1,i1,i2,ioriat(i1),ioriat(i2)
                       if(ioriat(i1).ne.0.and.ioriat(i2).ne.0)then
                    if(RS(ioriat(i1)).gt.0.and.RS(ioriat(i2)).gt.0)then
                        Le(1,NumLeg)=ioriat(i1)
                        Le(2,NumLeg)=ioriat(i2)
                        Le(3,NumLeg)=Le(3,kj)
                        nfraleg(NumLeg)=nfrag
!     write(lo,'(a,i5,2i4,2x,2i4)')
!    1'Numleg,i1,i2,Le(1,NumLeg),Le(2,NumLeg)'
!    1,Numleg,i1,i2,Le(1,NumLeg),Le(2,NumLeg)
                        NumLeg=NumLeg+1
                    endif
                       endif
                     endif
                  endif
               enddo
            endif
            nfrag=nfrag+1
            nfrageq=nfrageq+1
         endif
!old          enddo
!old        enddo
      enddo
!  fine newdo      
      NatMol=NatMol-1
      NumLeg=NumLeg-1
!------------------------------------------------------------------------

      kpri=1
      if (kpri.eq.0)then
         write(lo,*)' '
         write(lo,*)' '
         write(lo,*)'nfrag,i,baric(1:3,i),nOpEqBaric(i),lunghezzafra(i)'
        do i = 1, nfrag-1
          write(lo,'(2i5,3f7.3,i9)')nfrag-1,i,baric(1:3,i),nOpEqBaric(i)
     1    ,lunghezzafra(i)
        enddo
        write(lo,*)'i,xyz(1:3,i),RS(i),iEqui(i),nOpEq(i),ipix,Lab(i)'
        do i = 1, NatMol
          write(lo,'(i3,4f7.3,2i7,3i5,1x,a)')i,xyz(1:3,i),RS(i),iEqui(i)
     1    ,nOpEq(i),ipix(1:3,i),Lab(i)
        enddo
        if(nolegame.eq.1)then   
          do j=1,NumLeg
            write(lo,*)'j,LE(1:3,j)',j,LE(1:3,j)
          enddo
        endif
      endif
!------------------------------------------------------------------------
!
      return
      end
!
!code for trasla_frammenti
      subroutine trasla_frammenti(nfrag,nolegame)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Poliedri
!
      common/symcon/natsym,idoppiodi,iopsym(1000),ipolim
     1,asmin(3),asmax(3),incella(10000),idoppiodit
      common/buildmolec/natfrag(5000),nfraleg(20000),baric(3,5000)
     1,lunghezzafra(5000),minerale
      dimension icomp(3),icompp(3),ioriat(20000),cb(3),ippx(3),jtr(3,7)
      character*16 ilab,vetch,ilabn
!
!      write(lo,'(a,3i5)')'nfrag,natmol,numleg ',nfrag,natmol,numleg
      nfrag=nfrag-1  !e' il vero n.di framm.
      nfrag1=nfrag
      NatMol1=NatMol
      NatMol=NatMol+1
      NumLeg0=NumLeg
      NumLeg=NumLeg+1
      do i=1,nfrag1
        nfra=i
!      write(lo,'(a,i3,i5,3f8.3)')'i,lunghezzafra(i),baric(1:3,i)'
!     1,i,lunghezzafra(i),baric(1:3,i)
        if(lunghezzafra(i).gt.0)then
           icomp(1)=lunghezzafra(i)/100
           ico=lunghezzafra(i)-icomp(1)*100
           icomp(2)=ico/10
           icomp(3)=ico-icomp(2)*10
           icompp=icomp
               do k=1,3
                 if(icomp(k).ne.0)icompp(k)=icomp(k)-2
               enddo
!      write(lo,'(a,i3,i5,6i4)')
!     1 'lunghezzafra(i),icomp,icompp ',lunghezzafra(i),icomp,icompp
!-- crea le traslazioni possibili
           jtr=0
           jtr(1,1)=icompp(1)        
           jtr(2,2)=icompp(2)       
           jtr(3,3)=icompp(3)
           jtr(1:3,4)=jtr(1:3,1)+jtr(1:3,2)        
           jtr(1:3,5)=jtr(1:3,1)+jtr(1:3,3)        
           jtr(1:3,6)=jtr(1:3,2)+jtr(1:3,3)        
           jtr(1:3,7)=jtr(1:3,1)+jtr(1:3,2)+jtr(1:3,3)        
!     write(lo,'(a,i5,3f7.3,i8)')'tras i,baric(1:3,i),nOpEqBaric(i) ',
!    1 i,baric(1:3,i),nOpEqBaric(i)
!-- 
           do j=1,7
             cb(1:3)=baric(1:3,i)-jtr(1:3,j)    !-- crea il baric
!      write(lo,'(a,i3,3i5,3f7.3)')'tras j,jtr(1:3,j),cb',j,jtr(1:3,j),cb
!--controlla se gia' esiste
             do kn=1,nfrag
               k3=0
               do kk=1,3
                 if(abs(cb(kk)-baric(kk,kn)).le.0.001)k3=k3+1   
               enddo
               if(k3.eq.3)then
!      write(lo,'(a,i5,3f7.3,i5,3i4)')'=a kn,baric(,kn)',kn,baric(1:3,kn)
               exit   !elimina i doppioni
               endif
             enddo
!-- non esiste ancora             
             if(k3.ne.3)then
!      write(lo,'(a,3i5)')'nfrag,natmol,numleg ',nfrag,natmol,numleg
               ioriat=0
               nfragini=nfrag
               NatMolini=NatMol
               incell=0
               nfrag=nfrag+1
               baric(1:3,nfrag)=cb(1:3)
!     write(lo,'(a,i5,3f7.3)')'nfrag baric ',nfrag,cb
!-- crea il label del baricentro, utile a ricordare l'op de sym e la trasl. applicata
               nOpEqBaric(nfrag) = (nOpEqBaric(i)/1000) 
               iTraslaToti =  nOpEqBaric(i)-nOpEqBaric(nfrag)*1000
               ipix1=iTraslaToti/100
               ipi=iTraslaToti-ipix1*100
               ipix2=ipi/10
               ipix3=ipi-ipix2*10
               ippx(1)=ipix1-jtr(1,j)
               ippx(2)=ipix2-jtr(2,j)
               ippx(3)=ipix3-jtr(3,j)
               iTraslaTot = ippx(1)*100 
     *                    + ippx(2)*10 
     *                    + ippx(3)
               nOpEqBaric(nfrag) = nOpEqBaric(nfrag)*1000 + iTraslaTot
!       write(lo,'(a,4i10,6i4)')
!     1'nOpEqBaric(nfrag),nOpEqBaric(i),lunghezzafra,iTraslaTot,ippx',
!     1 nOpEqBaric(nfrag),nOpEqBaric(i),lunghezzafra(i),iTraslaTot,ippx
!     1,ipix1,ipix2,ipix3
               ioriat(:)=0
                 do k=1,NatMol1
                   if(nfragm(k).eq.nfra.and.RS(k).gt.0)then
                      jkj=0
                      do kk=1,3
                      xyz(kk,NatMol)=xyz(kk,k)-jtr(kk,j)
          if(xyz(kk,NatMol).ge.0.00.and.xyz(kk,NatMol).le.1.00)jkj=jkj+1
                      enddo
                      if(jkj.eq.3)incell=1  !al meno 1 at. e' dentro 
                      iequi(NatMol)=iequi(k) 
                      ieq = k
                      nfragm(NatMol) = nfrag
                      nOpEq(NatMol) = nOpEq(k)
                      iOrd(NatMol)= NatMol
                      nzTot(NatMol) = nzTot(ieq)
                      SinglePlotType(NatMol) = SinglePlotType(ieq)
                      rMLU(NatMol) = rMLU(ieq)
                      RS(NatMol)=RS(ieq)
                      iCol(NatMol) = iCol(ieq)
                      xyztot(1:3,NatMol) = xyz(1:3, NatMol)
                      ieqq=iequi(ieq)
                      ioriat(k)=NatMol
                      ilab=Lab(ieqq)
                      vetch=' '
                      call shift(ilab,lengb)
                      write(vetch,'(i5)')nfrag
!     write(lo,'(a,a,i10,a)')'ilab,ieq,vetch ',ilab,ieq,vetch
                      call shift(vetch,lengv)
!     write(lo,'(a,a,i10,a,i10,a)')
!    1'ilab,lengb,vetch,lengv ',ilab,lengb,vetch,lengv
                      ilabn=ilab(1:lengb)//'['//vetch(1:lengv)//']'
                      Lab(NatMol)=ilabn
!                    write(lo,'(i5,1x,a)')NatMol,Lab(NatMol)
!                     write(lo,'(a,2i5,3f8.3,3i5)')
!    1                'k,Natmol,xyz(1:3,NatMol),incell,ieqq,ioriat(k) ',
!    1                k,Natmol,xyz(1:3,NatMol),incell,ieqq,ioriat(k)
                      NatMol=NatMol+1
                   endif
                 enddo
                 if(incell.eq.0)then
                   nfrag=nfragini
                   NatMol=NatMolini
!                 write(lo,*)'frag. fouricella ripristina natmol,nfrag'
!    1            ,natmol,nfrag
                   cycle
                 endif
!-- copia la connett.            
               if(nolegame.eq.1)then   
               do kj=1,numleg0
!      write(lo,'(a,9i5)')'kj,nfra,nfraleg(kj)',kj,nfra,nfraleg(kj)
                 if(nfraleg(kj).eq.nfra)then    
                    i1=Le(1,kj)
                    i2=Le(2,kj)
!      write(lo,'(a,i5,4i4,2f9.0,i10)')
!     1'kj,i1,i2,ioriat(i1),ioriat(i2),RS12,NumLeg',
!     1 kj,i1,i2,ioriat(i1),ioriat(i2),RS(i1),RS(i2),NumLeg
                    if(i1.ne.0.and.i2.ne.0)then
                      if(RS(i1).gt.0.and.RS(i2).gt.0)then
                        Le(1,NumLeg)=ioriat(i1)
                        Le(2,NumLeg)=ioriat(i2)
                        Le(3,NumLeg)=Le(3,kj)
!                        write(lo,'(a,i5,2i4)')
!     1                  'Numleg,Le(1,NumLeg),Le(2,NumLeg)'
!     1                  ,Numleg,Le(1,NumLeg),Le(2,NumLeg)
                      endif
                    endif
                    NumLeg=NumLeg+1
                 endif
               enddo
               endif
             endif
          enddo
        endif
      enddo     
      return
      end
! 
!code for trasla_cella
      subroutine trasla_cella(nfrag,nolegame,ier)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Poliedri
!
      common/symcon/natsym,idoppiodi,iopsym(1000),ipolim
     1,asmin(3),asmax(3),incella(10000),idoppiodit
      common/buildmolec/natfrag(5000),nfraleg(20000),baric(3,5000)
     1,lunghezzafra(5000),minerale
      dimension icomp(3),icompp(3),ioriat(2000),ippx(3)
      dimension cb(3),isf(3)
      character*16 ilab,vetch,ilabn
!
      ier=0
      nfrag1=nfrag
!!      nfrag=nfrag-1
      NatMol1=NatMol
!      NatMol=NatMol+1
      NumLeg0=NumLeg
      NumLeg=NumLeg+1
!      write(lo,'(a,2i5,3i5)')'trasla_cella nfrag,NatMol, ncell'
!     1,nfrag,NatMol,ncell
      Nfrag_Attesso=Nfrag1*ncell(1)*ncell(2)*ncell(3)
      NatMol_Attesso=NatMol1*ncell(1)*ncell(2)*ncell(3)
!     write(lo,'(a,2i5,3i5)')'trasla_cel nfrag_Attesso,NatMol_Attesso '
!    1,nfrag_Attesso,NatMol_Attesso
         if(NatMol_Attesso.gt.MaxAtomsInGr) then
         Msg = 'Too much cell requested '
          call MsgWinErr('Apply Symmetry', Msg, WARN_WINDOW, nExitCode)
          ier=-1
          return
      endif
      do nax=1, 3
      isf(1:3) = 0
        if (nCell(nax).ne.1) then           ! Cells along a/b/c
        jfi = 1
        if(nCell(nax).eq.3) jfi = -1
          do jf=jfi, 1, 2
          isf(nax) = jf
!-- crea il baric 
          do i=1,nfrag1
          cb(1:3)=baric(1:3,i)-isf(1:3)
!      write(lo,'(a,i3,3i5,3f7.3)')'i,isf(1:3),cb',i,isf(1:3),cb
!--controlla se gia' esiste
               do kn=1,nfrag
               k3=0
                 do kk=1,3
                 if(abs(cb(kk)-baric(kk,kn)).le.0.001)k3=k3+1
                 enddo
               if(k3.eq.3)then
!      write(lo,'(a,i5,3f7.3,i5,3i4)')'=a kn,baric(,kn)',kn,baric(1:3,kn)
               exit   !elimina i doppioni
               endif
               enddo
!-- non esiste ancora             
            if(k3.ne.3)then
            nfrag=nfrag+1
            baric(1:3,nfrag)=cb(1:3)
!-- crea il label del baricentro, utile a ricordare l'op de sym e la trasl. applicata
            nOpEqBaric(nfrag) = (nOpEqBaric(i)/1000) 
            iTraslaToti =  nOpEqBaric(i)-nOpEqBaric(nfrag)*1000
            ipix1=iTraslaToti/100
            ipi=iTraslaToti-ipix1*100
            ipix2=ipi/10
            ipix3=ipi-ipix2*10
            ippx(1)=ipix1-isf(1)
            ippx(2)=ipix2-isf(2)
            ippx(3)=ipix3-isf(3)
            iTraslaTot = ippx(1)*100 
     *                 + ippx(2)*10 
     *                 + ippx(3)
!       write(lo,'(a,i5,4i10,6i4)')
!     1'nfrag,nOpEqBaric(nfrag),nOpEqBaric(i),iTraslaTot,ippx',
!     1 nfrag,nOpEqBaric(nfrag),nOpEqBaric(i),iTraslaTot,ippx
!     1,ipix1,ipix2,ipix3
            nOpEqBaric(nfrag) = nOpEqBaric(nfrag)*1000 + iTraslaTot
!-- trasla gli atomi            
            ioriat(:)=0
                 do k=1,NatMol1
                   if(nfragm(k).eq.i.and.RS(k).gt.0)then
                   xyz (1:3,NatMol)=xyz (1:3,k)-isf(1:3)
                   iequi(NatMol)=iequi(k) 
                   ieq = k
                   ioriat(k)=NatMol
                   nfragm(NatMol) = nfrag
                   nOpEq(NatMol) = nOpEq(k)
                   iOrd(NatMol)= NatMol
                   nzTot(NatMol) = nzTot(ieq)
                   SinglePlotType(NatMol) = SinglePlotType(ieq)
                   rMLU(NatMol) = rMLU(ieq)
                   RS(NatMol)=RS(ieq)
                   iCol(NatMol) = iCol(ieq)
                   xyztot(1:3,NatMol) = xyz(1:3, NatMol)
                   ieqq=iequi(ieq)
                   ilab=Lab(ieqq)
                   vetch=' '
                   call shift(ilab,lengb)
                   write(vetch,'(i5)')nfrag
!     write(lo,'(a,a,i10,a)')'ilab,ieq,vetch ',ilab,ieq,vetch
                   call shift(vetch,lengv)
!     write(lo,'(a,a,i10,a,i10,a)')
!    1'ilab,lengb,vetch,lengv ',ilab,lengb,vetch,lengv
                   ilabn=ilab(1:lengb)//'['//vetch(1:lengv)//']'
                   Lab(NatMol)=ilabn
!     write(lo,'(i5,1x,a,3f6.3)')NatMol,Lab(NatMol),xyz (1:3,NatMol)
                   NatMol=NatMol+1
                   endif
                 enddo
!-- copia la connett.            
             if(nolegame.eq.1)then   
             do kj=1,numleg0
!      write(lo,'(a,9i5)')'kj,nfra,nfraleg(kj)',kj,nfra,nfraleg(kj)
               if(nfraleg(kj).eq.i)then    
               i1=Le(1,kj)
               i2=Le(2,kj)
                  if(i1.ne.0.and.i2.ne.0)then
                  if(RS(i1).gt.0.and.RS(i2).gt.0)then
                  Le(1,NumLeg)=ioriat(i1)
                  Le(2,NumLeg)=ioriat(i2)
                  Le(3,NumLeg)=Le(3,kj)
                  endif
                  endif
!      write(lo,'(a,i5,2i4)')
!     1'Numleg,Le(1,NumLeg),Le(2,NumLeg)'
!     1,Numleg,Le(1,NumLeg),Le(2,NumLeg)
               NumLeg=NumLeg+1
               endif
             enddo
             endif
            endif
          enddo
          enddo
        endif
      enddo     
!
      return
   10 format(' The number of atoms exceeds the allowed maximum.  ')
      end
!
!code for crea_intorno_cella
      subroutine crea_intorno_cella(nfrag,nolegame,ier)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Poliedri
!
      common/symcon/natsym,idoppiodi,iopsym(1000),ipolim
     1,asmin(3),asmax(3),incella(10000),idoppiodit
      common/buildmolec/natfrag(5000),nfraleg(20000),baric(3,5000)
     1,lunghezzafra(5000),minerale
      dimension icomp(3),icompp(3),ioriat(2000),ippx(3)
      dimension cb(3),isf(3),xlim1(2,2),xlim2(2,2,3)
      character*16 ilab,vetch,ilabn
!
!      xlim1(1,1)=-0.001   
!      xlim1(1,2)= 0.334   
!      xlim1(2,1)= 0.665   
!      xlim1(2,2)= 1.001
      do nax=1, 3
      x1=0.334
      x2=0.665
      if(DeA(nax).gt.0.)then
      x1=DeA(nax)+0.001
      x2=0.999-x1
      endif
      xlim2(1,1,nax)=-0.001
      xlim2(1,2,nax)=x1
      xlim2(2,1,nax)=x2
      xlim2(2,2,nax)=1.001
      enddo
      
      ier=0
      nfrag1=nfrag

      NatMol1=NatMol
      NumLeg0=NumLeg
      NumLeg=NumLeg+1
!      write(lo,'(a,2i5,3i5)')'trasla_cella nfrag,NatMol, ncell'
!     1,nfrag,NatMol,ncell
      Nfrag_Attesso=Nfrag1*ncell(1)*ncell(2)*ncell(3)
      NatMol_Attesso=NatMol1*ncell(1)*ncell(2)*ncell(3)
!     write(lo,'(a,2i5,3i5)')'trasla_cel nfrag_Attesso,NatMol_Attesso '
!    1,nfrag_Attesso,NatMol_Attesso
         if(NatMol_Attesso.gt.MaxAtomsInGr) then
         Msg = 'Too much cell requested '
          call MsgWinErr('Apply Symmetry', Msg, WARN_WINDOW, nExitCode)
          ier=-1
          return
      endif
      
      
      do nax=1, 3
      xlim1(1,1)=xlim2(1,1,nax)   
      xlim1(1,2)=xlim2(1,2,nax)
      xlim1(2,1)=xlim2(2,1,nax)
      xlim1(2,2)=xlim2(2,2,nax)
      NatMol1=NatMol
      isf(1:3) = 0
          do jf=-1, 1, 2
          isf(nax) = jf
!-- crea il baric 
          nfrag1=nfrag
          do i=1,nfrag1
          cb(1:3)=baric(1:3,i)-isf(1:3)
!      write(lo,'(a,i3,3i5,3f7.3)')'i,isf(1:3),cb',i,isf(1:3),cb
!--controlla se gia' esiste
               do kn=1,nfrag
               k3=0
                 do kk=1,3
                 if(abs(cb(kk)-baric(kk,kn)).le.0.001)k3=k3+1
                 enddo
               if(k3.eq.3)then
!      write(lo,'(a,i5,3f7.3,i5,3i4)')'=a kn,baric(,kn)',kn,baric(1:3,kn)
               exit   !elimina i doppioni
               endif
               enddo
!-- non esiste ancora             
            if(k3.ne.3)then
            nfrag=nfrag+1
            nonvuoto=0
            baric(1:3,nfrag)=cb(1:3)
!-- crea il label del baricentro, utile a ricordare l'op de sym e la trasl. applicata
            nOpEqBaric(nfrag) = (nOpEqBaric(i)/1000) 
            iTraslaToti =  nOpEqBaric(i)-nOpEqBaric(nfrag)*1000
            ipix1=iTraslaToti/100
            ipi=iTraslaToti-ipix1*100
            ipix2=ipi/10
            ipix3=ipi-ipix2*10
            ippx(1)=ipix1-isf(1)
            ippx(2)=ipix2-isf(2)
            ippx(3)=ipix3-isf(3)
            iTraslaTot = ippx(1)*100 
     *                 + ippx(2)*10 
     *                 + ippx(3)
!       write(lo,'(a,i5,4i10,6i4)')
!     1'nfrag,nOpEqBaric(nfrag),nOpEqBaric(i),iTraslaTot,ippx',
!     1 nfrag,nOpEqBaric(nfrag),nOpEqBaric(i),iTraslaTot,ippx
!     1,ipix1,ipix2,ipix3
            nOpEqBaric(nfrag) = nOpEqBaric(nfrag)*1000 + iTraslaTot
!-- trasla gli atomi            
            ioriat(:)=0
                 do k=1,NatMol1
                   if(nfragm(k).eq.i.and.RS(k).gt.0)then
!controlla se l'atomo e' entro l'intorno
!                   do i2=1,2
                   i2=1
                   if(jf.eq.1)i2=2 
                   if (xyz(nax,k).ge.xlim1(i2,1).and.
     1                 xyz(nax,k).le.xlim1(i2,2))then
!       write(lo,'(a,3i5,3f7.3,5x,2f7.4,i4)')
!     1 'nax,i2,k,xyz(1:3,k),xlim1(i2,1),xlim1(i2,2)'
!     1 ,nax,i2,k,xyz(1:3,k),xlim1(i2,1),xlim1(i2,2)
                   nonvuoto=1
                   xyz (1:3,NatMol)=xyz (1:3,k)
                   xyz (1:3,NatMol)=xyz (1:3,k)-isf(1:3)
                   iequi(NatMol)=iequi(k) 
                   ieq = k
                   ioriat(k)=NatMol   
                   nfragm(NatMol) = nfrag
                   nOpEq(NatMol) = nOpEq(k)
                   iOrd(NatMol)= NatMol
                   nzTot(NatMol) = nzTot(ieq)
                   SinglePlotType(NatMol) = SinglePlotType(ieq)
                   rMLU(NatMol) = rMLU(ieq)
                   RS(NatMol)=RS(ieq)
                   iCol(NatMol) = iCol(ieq)
                   xyztot(1:3,NatMol) = xyz(1:3, NatMol)
                   ieqq=iequi(ieq)
                   ilab=Lab(ieqq)
                   vetch=' '
                   call shift(ilab,lengb)
                   write(vetch,'(i5)')nfrag
!     write(lo,'(a,a,i10,a)')'ilab,ieq,vetch ',ilab,ieq,vetch
                   call shift(vetch,lengv)
!     write(lo,'(a,a,i10,a,i10,a)')
!    1'ilab,lengb,vetch,lengv ',ilab,lengb,vetch,lengv
                   ilabn=ilab(1:lengb)//'['//vetch(1:lengv)//']'
                   Lab(NatMol)=ilabn
!     write(lo,'(a,2i5,1x,a,3f6.3)')'nfragi,NatMol,xyz',
!    1 i,NatMol,Lab(NatMol),xyz (1:3,NatMol)
                   NatMol=NatMol+1
                   endif
!                   enddo
                   endif
                 enddo
!-- copia la connett.            
                   if(nolegame.eq.1)then   
                     do kj=1,numleg0
!      write(lo,'(a,9i5)')'kj,i,nfraleg(kj)',kj,i,nfraleg(kj)
                       if(nfraleg(kj).eq.i)then    
                       i1=Le(1,kj)
                       i2=Le(2,kj)
                         if(i1.ne.0.and.i2.ne.0)then
                            if(RS(i1).gt.0.and.RS(i2).gt.0)then
                            Le(1,NumLeg)=ioriat(i1)
                            Le(2,NumLeg)=ioriat(i2)
                            Le(3,NumLeg)=Le(3,kj)
                            endif
                         endif
!                       write(lo,'(a,i5,2i6,2i8)')
!     1'Numleg,i1,i2,Le(1,NumLeg),Le(2,NumLeg)'
!     1,Numleg,i1,i2,Le(1,NumLeg),Le(2,NumLeg)
                       NumLeg=NumLeg+1
                       endif
                     enddo
                   endif
                if(nonvuoto.eq.0)nfrag=nfrag-1
            endif
          enddo
          enddo
      enddo     
!
      return
   10 format(' The number of atoms exceeds the allowed maximum.  ')
      end
! 
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!-----------------------------------------------------------------------
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!-----------------------------------------------------------------------
!
!code for ifincella
      function ifincella(as)
      common/symcon/natsym,idoppiodi,iopsym(1000),ipolim
     1,asmin(3),asmax(3),incella(10000),idoppiodit
     
      dimension as(3)
      ifincella=1    ! e'fuori cella
      if(as(1).ge.asmin(1).and.as(1).le.asmax(1).and.
     1   as(2).ge.asmin(2).and.as(2).le.asmax(2).and.
     1   as(3).ge.asmin(3).and.as(3).le.asmax(3))ifincella=0 !e'in cella
      return
      end
!
c
cxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
c
c------------------------------------------------------------------------
      subroutine Centra (nce, Shf)
      USE Symmetry
!
      character *1 nt1
      dimension Shf(3,3)
      character *7 reticoli

      reticoli = 'pabcifr'
      nt1 = reticoli(latt:latt)
!      centrt(7,12) 
      nce = ncentr - 1
      do kt = 2, ncentr
         do l=1,3
            ktl=(kt-1)*3+l
            Shf(l,kt-1) = centrt(latt,ktl)
         enddo
      enddo
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!      
!!!mercedes 25.07.08  correzione per rendere il vettore Shf compatibile con centrt      
      ia=1
      if(ia.eq.0)then
      if (nt1 .EQ. 'f') then
         nce = 3
         Shf(1, 1) = 0.
         Shf(2, 1) = .5
         Shf(3, 1) = .5
         Shf(1, 2) = .5
         Shf(2, 2) = 0.
         Shf(3, 2) = .5
         Shf(1, 3) = .5
         Shf(2, 3) = .5
         Shf(3, 3) = 0.
      end if
      if (nt1 .EQ. 'r') then
         nce = 2
         Shf(1, 1) = .333
         Shf(2, 1) = .666
         Shf(3, 1) = .666
         Shf(1, 2) = .666
         Shf(2, 2) = .333
         Shf(3, 2) = .333
      end if
      if (nt1 .EQ. 'i') then
         nce = 1
         Shf(1, 1) = .5
         Shf(2, 1) = .5
         Shf(3, 1) = .5
      end if
      if (nt1 .EQ. 'a') then
         nce = 1
         Shf(1, 1) = 0.
         Shf(2, 1) = .5
         Shf(3, 1) = .5
      end if
      if (nt1 .EQ. 'b') then
         nce = 1
         Shf(1, 1) = .5
         Shf(2, 1) = 0.
         Shf(3, 1) = .5
      end if
      if (nt1 .EQ. 'c') then
         nce = 1
         Shf(1, 1) = .5
         Shf(2, 1) = .5
         Shf(3, 1) = 0.
      end if
      endif
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!      
      return
      end
! --------------------------------------------------------------------
      function iDoppio (natot, c)
!      function iDoppioPoly (natot, c)
      USE General, only : gdist
      USE Molcom
!
      dimension c(3),d(3)
      common/symcon/natsym,idoppiodi,iopsym(1000),ipolim
     1,asmin(3),asmax(3),incella(10000),idoppiodit
     
!
      iDoppio = 0
      iDoppioPoly = 0
      idoppiodi = 0
      do nn = 1, natot
         do i = 1, 3
         d(i)=xyz(i, nn) - c(i)
         enddo
         dis=cdist(gdist,d,ddummy)
         if(dis.gt.0.1)cycle
         idoppiodi=nn
         iDoppio = -1
         iDoppioPoly = -1
         return
      enddo
      return
      end
! --------------------------------------------------------------------
      function iDoppiotras (natot,c)
      USE General
      USE Molcom
!
      dimension c(3),d(3),sss(3)
      common/symcon/natsym,idoppiodi,iopsym(1000),ipolim
     1,asmin(3),asmax(3),incella(10000),idoppiodit
     
      iDoppiotras = 0
      idoppiodit= 0
      do nn = 1, natot
         do i = 1, 3
         d(i)=xyz(i, nn) - c(i)
         enddo
      call reddst(d,sss)
c      if(abs(sss(1))+abs(sss(2))+abs(sss(3)).gt.0)ipolim=ipolim+1
      dis=cdist(gdist,d,ddummy)
      if(dis.gt.0.1)cycle
      idoppiodit=nn
      iDoppiotras = -1
      if(abs(sss(1))+abs(sss(2))+abs(sss(3)).gt.0)ipolim=ipolim+1
      return
      enddo
      return
      end
! --------------------------------------------------------------------
      function iDoppioxyzs (c)
      USE Atomi
      USE Molcom
!
      dimension c(3)
      common/symcon/natsym,idoppiodi,iopsym(1000),ipolim
     1,asmin(3),asmax(3),incella(10000),idoppiodit
     
!
      iDoppioxyzs = 0
      idoppiodi = 0
      do 20 nn = 1, natsym
         do 10 i = 1, 3
            if (ABS(xyzs(i, nn) - c(i)) .GT. .001) goto 20
   10    continue
         idoppiodi=nn
         iDoppioxyzs = -1
         return
   20 continue
      return
      end
! --------------------------------------------------------------------
      subroutine RimettiDentro (c, iabc)
      USE Molcom
!
      dimension c(3), iabc(3)

   10 if (c(1) .gt. 1+DeA(1)) then
         c(1) = c(1) - 1
         iabc(1)=iabc(1)-1
         goto 10
      end if
   20 if (c(1) .lt. -DeA(1)) then
         c(1) = c(1) + 1
         iabc(1)=iabc(1)+1
         goto 20
      end if
   30 if (c(2) .gt. 1+DeA(2)) then
         c(2) = c(2) - 1
         iabc(2)=iabc(2)-1
         goto 30
      end if
   40 if (c(2) .lt. -DeA(2)) then
         c(2) = c(2) + 1
         iabc(2)=iabc(2)+1
         goto 40
      end if
   50 if (c(3) .gt. 1+DeA(3)) then
         c(3) = c(3) - 1
         iabc(3)=iabc(3)-1
         goto 50
      end if
   60 if (c(3) .lt. -DeA(3)) then
         c(3) = c(3) + 1
         iabc(3)=iabc(3)+1
         goto 60
      end if

      return
      end
! --------------------------------------------------------------------
      subroutine RimettiInCella (c, iabc)

      dimension c(3), iabc(3)

   10 if (c(1) .gt. 1.0000) then
         c(1) = c(1) - 1
         iabc(1)=iabc(1)-1
         goto 10
      end if
   20 if (c(1) .lt. 0.0000) then
         c(1) = c(1) + 1
         iabc(1)=iabc(1)+1
         goto 20
      end if
   30 if (c(2) .gt. 1.0000) then
         c(2) = c(2) - 1
         iabc(2)=iabc(2)-1
         goto 30
      end if
   40 if (c(2) .lt. 0.0000) then
         c(2) = c(2) + 1
         iabc(2)=iabc(2)+1
         goto 40
      end if
   50 if (c(3) .gt. 1.0000) then
         c(3) = c(3) - 1
         iabc(3)=iabc(3)-1
         goto 50
      end if
   60 if (c(3) .lt. 0.0000) then
         c(3) = c(3) + 1
         iabc(3)=iabc(3)+1
         goto 60
      end if
      return
      end
! --------------------------------------------------------------------
      subroutine RimettiInCella2 (c, iabc)  

      common/buildmolec/natfrag(5000),nfraleg(20000),baric(3,5000)
     1,lunghezzafra(5000),minerale
      common/symcon/natsym,idoppiodi,iopsym(1000),ipolim
     1,asmin(3),asmax(3),incella(10000),idoppiodit
      dimension c(3), iabc(3)
!!      llim=1.0001
      xlim1=0.001
      xlim2=1.001
      if(ipolim.eq.1.and.minerale.eq.1)then
      xlim1=-0.0001
      xlim2=.999
!      xlim1=-0.3
!      xlim2=1.3
      endif
      do i=1,3
!!!21ott08      if (c(i) .gt. 1.0001) then
      if (c(i) .gt. xlim2) then
      iabc(i)=int(c(i))
      else if (c(i) .lt.xlim1)then
      iabc(i)=int(c(i))-1
      endif
      c(i)=c(i)-iabc(i)
      enddo
      return
      end
! --------------------------------------------------------------------
      subroutine RimettiInCella2_old (c, iabc)

      dimension c(3), iabc(3)
      do i=1,3
!!      llim=1.0001
      llim=.999
!!!21ott08      if (c(i) .gt. 1.0001) then
      if (c(i) .gt. llim) then
      iabc(i)=int(c(i))
      else if (c(i) .lt. -0.0001)then
      iabc(i)=int(c(i))-1
      endif
      c(i)=c(i)-iabc(i)
      enddo
      return
      end
! --------------------------------------------------------------------
      subroutine Ruota (n, na, cb, iabc, ird)
      USE General
      USE Symmetry
      USE Molcom
!
      dimension A(3, 3), B(3), cb(3), iabc(3)
!
      iabc(1:3) = 0
      do j = 1, 3
         do k = 1, 3
            A(k, j) = kmat(n, k, j)
         enddo
         B(j) = xyz(j, na)
      enddo
      do i = 1, 3
         cb(i) = 0
         do j = 1, 3
            cb(i) = cb(i) + A(i, j) * B(j)
         enddo
         cb(i) = cb(i) + tmat(n, i)
      enddo
!
      if (ird .lt. 0) then
          call RimettiInCella(cb, iabc)
      elseif (ird .gt. 0) then
          call RimettiDentro(cb, iabc)
      end if
!
!      write(lo,*)' ruota n,na,A,tmat(n,1:3),xyz(1:3,na),cb,iabc'
!      write(lo,'(2i4,3(3f4.0),3f4.1,3f5.2,2x,3f5.2,3i4)')
!     1 n,na,A(1,1:3),A(2,1:3),A(3,1:3),tmat(n,1:3),xyz(1:3,na),cb,iabc
      return
      end
! --------------------------------------------------------------------
      subroutine Trasl (Trv, n, na, cb, iabc, ird)
      USE Molcom
!
      dimension Trv(3,3), cb(3), iabc(3)
!
      iabc(:) = 0
      do 10 i = 1, 3
       cb(i) = xyz(i, na) + Trv(i, n)
   10 continue
      if (ird .lt. 0) then
         call RimettiInCella(cb, iabc)
      elseif (ird .gt. 0) then
         call RimettiDentro(cb, iabc)
      end if
      return
      end
! --------------------------------------------------------------------
      subroutine SoloInd(NatIn)
      USE General
      USE Atomi
      USE Molcom
      USE TestModel
      USE Dialogo, only : ModelToCompare
!
      dimension  x1(3), r1(3)
!
      ifCont = 0
      do i=NatIn+1, NatMol
         if (RS(i) .gt. 0.0) then
            RS(iEqui(i)) = abs(RS(i))
         end if
      enddo
      NatMol = NatIn
      do i = 1, NatMol
         x1(1:3) = xyzs(1:3, i)
         call MoltMatVec(rm,x1,r1)
         xyz(1:3, i) = r1(1:3)
         iEqui(i) = i
         nOpEq(i) = 1555
         Lab(i) = aLab(i)
      enddo
*     if (ifViewModel == 1) then
      if (ModelToCompare == 2) then
          do i = 1, nCoordPub
             x1(1:3) = coordPub(1:3, i)
             call MoltMatVec(rm,x1,r1)
             xyzPub(1:3, i) = r1(1:3)
          enddo
      endif
      call AggiuSpig
      call RotazTot
!
      NumLeg = nLegInd
      call GetBonds(2)
!
      do 70 i = 1, NumLeg
         LE(1, i) = LE1(1, i)
         LE(2, i) = LE1(2, i)
         LE(3, i) = LE1(3, i)
   70 continue
!
      return
      end
! -----------------------------------------------------------------
      function Individua(jx, jy)
      USE General
      USE Atomi
      USE Molcom
!
      common /scrsv/ isx1,isy1,isx2,isy2
!g    common /AtomType/ nTp, kCentral, xyzTmp(3,5)
      common /k1920/ ibu19,ibu20,k19,k20,ibu26,ibu27,k26,k27
!
      integer X11, Y11
!
      Individua = 0
      if (nptr.eq.0) then
         do 10 i=1, 80
            Message(i:i) = ' '
   10    continue
      end if
!
      ix = jx
      iy = jy
!
      jfound = 0
      idmin = 9999
      do 50 III = NatMol + NatSpi, 1 , -1
         IJ = iOrd(III)
         if (IJ.gt.NatMol .OR. RS(IJ).lt.0 ) go to 50
         X11 = ipix(1, IJ)
         Y11 = ipix(2, IJ)
         dx= ix - X11
         dy= iy - Y11
         dist = sqrt( dx*dx + dy*dy )
         idist=nint(dist)
         if (idist.le.ipix(3, IJ) .and. RS(IJ).gt.0) then
            if (idist.le.idmin) then
               idmin = idist
               jfound= IJ
            endif
          endif
   50 continue
      if (jfound.gt.0) then
         if (nTp .gt. 0) then
             knz = nz(jfound) / nzConst
             lnz = iabs(knz)
!            if (no(lnz) .ne. nTp) then
             if (no(lnz) .lt. 6 .or. no(lnz) .gt. 8) then
                Individua = -1
                return
            end if
         end if
         if (NonDoppio .eq. 1) then
            do 70 k=1, nptr
               if (jfound .eq. kptr(k)) then
                  Individua = -1
                  return
              end if
   70       continue
         else if (NonDoppio .eq. 2) then
            jfounde = iEqui(jfound)
            do 75 k=1, nptr
               kpt = iEqui(kptr(k))
               if (jfounde .eq. kpt) then
                       Individua = -1
                  return
              end if
   75       continue
         end if
         nptr  = nptr + 1
         nptrc = nptrc + 1
         kptr(nptr)      = jfound
         kptrcopy(nptrc) = jfound
!         write(0,*) 'INDIVIDUA',nptr, nptrc,jfound
         ixx = ipix(1,jfound)
         iyy = ipix(2,jfound)
         jx = ixx                                   !mr
         jy = iyy                                   !mr
!mr      call Linea(ixx-6, iyy, ixx+6, iyy, color_RESTR)
!mr      call Linea(ixx, iyy-6, ixx, iyy+6, color_RESTR)
         do 80 i=1, 80
            Message(i:i) = ' '
   80    continue
!
!
!
!
!
! ----  controllare il numero di caratteri immessi
! ----  nella stringa "message"
! ----  Eventualmente si puo' shiftare il message a sinistra
!
!
!
!
         iniz = 1
         if (nptr-iniz .gt. 12) then
            iniz = nptr - 12
         end if
         ip = 1
         do i=iniz, nptr
            Labb = Lab(kptr(i))
            L = Lung(Labb)
            message(ip:ip+L-1) = Labb
            message(ip+L:ip+L) = ','
            ip = ip + L + 2
         enddo
      else
         Individua = -1
      end if
!
      return
      end
! -----------------------------------------------------------------
      function IndividuaLab(jx, jy)
      USE General
      USE Atomi
      USE Molcom
!
      common /scrsv/ isx1,isy1,isx2,isy2
!g    common /AtomType/ nTp, kCentral, xyzTmp(3,5)
      common /k1920/ ibu19,ibu20,k19,k20,ibu26,ibu27,k26,k27
!
      integer X11, Y11
!
      IndividuaLab = 0
      if (nptr.eq.0) then
         do 10 i=1, 80
            Message(i:i) = ' '
   10    continue
      end if
!
      ix = jx
      iy = jy
!
      jfound = 0
      idmin = 9999
      do 50 III = NatMol + NatSpi, 1 , -1
         IJ = iOrd(III)
         if (IJ.gt.NatMol .OR. RS(IJ).lt.0 ) go to 50
         X11 = ipixLab(1, IJ)
         Y11 = ipixLab(2, IJ)
         dx= ix - X11
         dy= iy - Y11
         dist = sqrt( dx*dx + dy*dy )
         idist=nint(dist)
         if (idist.le.ipix(3, IJ) .and. RS(IJ).gt.0) then
            if (idist.le.idmin) then
               idmin = idist
               jfound= IJ
            endif
          endif
   50 continue
      if (jfound.gt.0) then
         if (nTp .gt. 0) then
             knz = nz(jfound) / nzConst
             lnz = iabs(knz)
!            if (no(lnz) .ne. nTp) then
             if (no(lnz) .lt. 6 .or. no(lnz) .gt. 8) then
                IndividuaLab = -1
                return
            end if
         end if
         if (NonDoppio .eq. 1) then
            do 70 k=1, nptr
               if (jfound .eq. kptr(k)) then
                       IndividuaLab = -1
                  return
              end if
   70       continue
         else if (NonDoppio .eq. 2) then
            jfounde = iEqui(jfound)
            do 75 k=1, nptr
               kpt = iEqui(kptr(k))
               if (jfounde .eq. kpt) then
                       IndividuaLab = -1
                  return
              end if
   75       continue
         end if
         nptr  = nptr + 1
         nptrc = nptrc + 1
         kptr(nptr)      = jfound
         kptrcopy(nptrc) = jfound
!         write(0,*) 'INDIVIDUALAB',nptr, nptrc,jfound
         ixx = ipixLab(1,jfound)
         iyy = ipixLab(2,jfound)
         jx = ixx                                   !mr
         jy = iyy                                   !mr
         do 80 i=1, 80
            Message(i:i) = ' '
   80    continue
!
!
!
!
!
! ----  controllare il numero di caratteri immessi
! ----  nella stringa "message"
! ----  Eventualmente si puo' shiftare il message a sinistra
!
!
!
!
         iniz = 1
         if (nptr-iniz .gt. 12) then
            iniz = nptr - 12
         end if
         ip = 1
         do i=iniz, nptr
            Labb = Lab(kptr(i))
            L = Lung(Labb)
            message(ip:ip+L-1) = Labb
            message(ip+L:ip+L) = ','
            ip = ip + L + 2
         enddo
      else
         IndividuaLab = -1
      end if
!
      return
      end
! -----------------------------------------------------------------
      subroutine DelAt
      USE General
      USE Atomi
      USE Molcom
!
      character *80 Deltd
!
      Message = ' '
      Deltd = ' '
!
      NumCanc = 0
      NumCTot = 0
      iscr=0
      do 60 n = 1, nptr
         jfound = kptr(n)
         if (jfound.gt.0) then
            RS(jfound) = -(10. + RS(jfound))
            NumCanc = NumCanc + 1
            NumCTot = NumCTot + 1
            ipunta = (NumCanc - 1) * 6 + 1
            if (ipunta.eq. 79) then
                if (iscr.eq.0) write(lo,120)
                write(lo,"(' ',a)") Deltd
                Deltd = ' '
                iscr = 1
                NumCanc = 1
                ipunta = 1
            end if
            Deltd(ipunta:ipunta+4) = Lab(jfound)
            do 55 i=1, NatMol
               if (iEqui(i).eq.iEqui(jfound)) then
                   RS(i) =  RS(jfound)
               end if
   55       continue

            do i=1, NumLeg - nlp
               if (LE(1, i).eq.jfound.or.LE(2, i).eq.jfound) then
                  if (LE(3,i).gt.0) then
                      LE(3, i) = -(10 + LE(3,i))
                  end if
               end if
            end do

         endif
   60 continue
   70 if (NumCTot.gt.0) then
         write(Message,100) NumCTot
      else
         write(Message,110)
      endif
      call PrintMess(Message)
      if (NumCanc.gt.0) then
         if (iscr.eq.0) write(lo,120)
         if (Deltd(1:1).ne.' ') write(lo,"(' ',a)") Deltd
      end if
!
  100 format(i3,' Atom(s) has been deleted !')
  110 format(' No Atom deleted !')
  120 format(/,' The following Atom(s) has been deleted :')
!
      return
      end
! -----------------------------------------------------------------
      subroutine DelHide(iz)
      USE General
      USE Atomi
      USE Molcom
!
      character *80 Deltd
!
      Message = ' '
      Deltd = ' '
!
!   rendi visibili tutti gli atomi hidden (show all)
!
      if (iz.eq.4) then
         do 500 i=1, NatMol
            IJ = i
            if (RS(IJ) .gt. -10.) then
               RS(IJ) = abs(RS(IJ))
            end if
  500    continue
         call ClearMessage
         call AggiornaJav
         return
      end if
!
      do i = 1, 99
         if (ixp(i).lt.0) then
             exit
         endif
      enddo
      nvpol = i - 1
      n = 1
   21 n = n + 1
      if (ixp(n).eq.ixp(n - 1) .AND. iyp(n).eq.iyp(n - 1)) then
         do 22 i = n, nvpol - 1
            ixp(i) = ixp(i + 1)
            iyp(i) = iyp(i + 1)
   22    continue
         nvpol = nvpol - 1
         n = n - 1
      end if
      if (n.lt.nvpol) goto 21
   23 icont = 0
      if (nvPol.lt.4) then
         Message = 'No polygon !!!!'
         call MsgWinErr('Warning', Message, WARN_WINDOW, nExitC)
         iz = 0
         return
      end if
      do 26 i = 1, nvpol - 2
         do 24 j = i + 1, nvpol - 1
            if (IABS(iyp(i) - iyp(j)) .le. 2) then
               iyp(j) = iyp(j) - 1
               icont = -1
            end if
   24    continue
   26 continue
      if (icont .ne. 0) goto 23
      NumCanc = 0
      NumCancTot = 0
      NumHidd = 0
      NumCh = 0
      iscr = 0
      nbu = 0
      do 50 III = NatMol + NatSpi, 1 , -1
         IJ = iOrd(III)
         if (IJ .GT. NatMol. OR. RS(IJ). LT. 0) go to 50
         ix = ipix(1,IJ)
         iy = ipix(2,IJ)
         in = Interno(ix, iy, nvpol)
         inn = Interno(ix, iy - 1, nvpol)
         if (iz .eq. 3) then
! --        voglio nascondere gli esterni
            if (in .eq. -2 .or. inn .eq. -2) then
! --           e' interno
               nbu = nbu+1
            end if
         else
! --        gli interni sono selezionati ...
            if (in.eq.-2 .or. inn.eq.-2) then
               if (iz.eq.1) then
! --              ... per cancellarli
                  RS(IJ) = -(10. + ABS(RS(IJ)))
                  NumCanc = NumCanc + 1
                  NumCancTot = NumCancTot + 1
                  nbu = nbu+1
                  ipunt = (NumCanc - 1) * 6 + 1
                  if (ipunt.eq. 79) then
                     if (iscr.eq.0) write(lo,120)
                      write(lo,'(a)') Deltd
                      Deltd = ' '
                      iscr = 1
                      NumCanc = 1
                      ipunt = 1
                  end if
                  Deltd(ipunt:ipunt+4) = Lab(IJ)
                  do 55 i=1, NatMol
                     if (iEqui(i) .eq. iEqui(IJ)) then
                         RS(i) =  RS(IJ)
                     end if
   55             continue
               else if (iz.eq.2) then
! --              ... per nasconderli
                  RS(IJ) = -ABS(RS(IJ))
                  NumHidd = NumHidd + 1
                  nbu = nbu+1
               else if (iz.eq.5) then
! --              ... per cambiargli di colore
                  if (NumCh.eq.0) then
                     call PrintMess('Select the new color ...')
                     call PeekColV2 (nColSel, jReset)  
                  end if
                  if (jReset.eq.1) then
!!mr240711                      kj = iEqui(IJ)
!!mr240711                      iCol(IJ) = color_GHOST
                      igi = nzTot(IJ)                         !mr 191206
                      if (igi == 0) then
                          iCol(IJ) = color_GHOST
                      else
                          iCol(IJ) = no(igi) + N_OBJS             !mr 191206
                      endif
                  else
                     if (nColSel.gt.0) then
                         iCol(IJ) = nColSel
                     endif
                  endif
                  NumCh = NumCh + 1
                  nbu = nbu+1
               end if
            end if
         end if
   50 continue
      if (nbu.eq.0) then
         Inte = 'WARNING !'
         Msg = 'No atom selected !'
         call MsgWinErr(Inte, Msg, WARN_WINDOW, nExitC)
         iz = -iz
         return
      end if
      if (iz .eq. 3) then
         do 60 III = NatMol + NatSpi, 1 , -1
            IJ = iOrd(III)
            if (IJ .GT. NatMol. OR. RS(IJ). LT. 0) go to 60
            ix = ipix(1,IJ)
            iy = ipix(2,IJ)
            in = Interno(ix, iy, nvpol)
            inn = Interno(ix, iy - 1, nvpol)
! --        voglio nascondere gli esterni
            if (in .ne. -2 .and. inn .ne. -2) then
! --           e' esterno
               RS(IJ) = -ABS(RS(IJ))
               NumHidd = NumHidd + 1
            end if
   60    continue
      end if
!
   70 if(iz.eq.1) then
         if (NumCancTot.gt.0) then
            write(Message,100) NumCancTot
            if (NumCanc.gt.0) then
               if (iscr.eq.0) write(lo,120)
               if (Deltd(1:1).ne.' ') write(lo,'(a)') Deltd
            end if
         else
            write(Message,110)
         endif
      else if(iz.eq.2 .or. iz.eq.3) then
         if (NumHidd.gt.0) then
            write(Message,200) NumHidd
         else
            write(Message,210)
         endif
      else if(iz.eq.5) then
         if (NumCh.gt.0) then
            write(Message,300) NumCh
         else
            write(Message,310)
         endif
      end if
!
      call PrintMess(Message)
      call AggiornaJav
!
      return
  100 format(i4,' Atom(s) has been deleted !')
  110 format(' No Atom deleted !')
  120 format(/,' The following Atom(s) has been deleted :')
  200 format(i4,' Atom(s) has been hidden  !')
  210 format(' No Atom hidden  !')
  300 format(i4,' Atom(s) has been changed !')
  310 format(' No Atom changed !')
      end
! -----------------------------------------------------------------
      subroutine ReLabel(iz)
      USE General
      USE Atomi
      USE Molcom
      USE PhaseModule
      USE LsqModule
!
      character *16 LabN(20)
!
      call FillVetSpec()
!
      Message = ' '
      if (nptr .gt. 1) then
         write(lo,300)
         npp = 0
         do j=1, nptr
            npp = npp + 1
            L = Lung(Lab(kptr(j)))
            LabN(npp) = Lab(kptr(j))
            if (npp.eq.20 .or. j.eq.nptr) then
               write(lo,310) (LabN(kj),kj=1, npp)
               npp = 0
            end if
         enddo
      endif
!
      ifOK = 1
      do j=1, nptr
         jfound = kptr(j)
         jfeq = iEqui(jfound)
         lnz=mod(nz(jfeq),nzConst)
         nz(jfeq)=iz*nzConst+lnz
         nzTot(jfeq) = iz
         if (nptr .eq. 1) then
            Labb = Lab(jfound)
            L = Lung(Labb)
            write(Message(1:33),100) Labb
         end if
         call ModLab(iEqui(jfound),iz,' ')
!
         Labb = Lab(iEqui(jfound))
         aLab(jfeq) = Labb
         Lab(jfeq) =  Labb
!
         if (nptr .eq. 1) then
             Labb = Lab(jfound)
             L = Lung(Labb)
             write(Message(34:46),110) Labb
             write(lo,'(a)') Message(1:Lung(Message))
         else
             write(Message(1:30),400) nptr
         end if
         if (no(1).eq.1) then
             jlig=0
         else
             jlig=0
         endif
         if (neutro.eq.1) jlig=0
         iCol(jfound) = no(iz) + N_OBJS
         Rs  (jfound) = radii(iz,1) / 3.0
         rMLu (jfound) = 2*radii(iz,1) + 0.3
         do i=1, NatMol
            if (iEqui(i).eq.iEqui(jfound)) then
                if (RS(i) .gt.-10.) then
                    if (RS(i) .gt. 0.) then
                        RS(i) =  RS(jfound)
                    else
                        RS(i) = -RS(jfound)
                    end if
                end if
                iCol(i) = iCol(jfound)
                rMLu(i) = rMLu(jfound)
                Lab(i) = Lab(iEqui(jfound))
!
                k = iEqui(i)
                aLab(k) = aLab(iEqui(jfound))
!
            endif
         enddo
      enddo
!
      if (nptr .gt. 1) then
         write(lo,320)
         npp = 0
         do 70 j=1, nptr
            npp = npp + 1
            LabN(npp) = Lab(kptr(j))
            L = Lung(Lab(kptr(j)))
            if (npp.eq.20 .or. j.eq.nptr) then
               write(lo,310) (LabN(kj),kj=1, npp)
               npp = 0
            end if
   70    continue
      end if
!
!-- update model
      iAction = 0
      do j=1, nptr
         jfound = kptr(j)
         i = iEqui(jfound)
         Labb = Lab(i)
         lnz = iabs(nz(i)) / nzConst
         VetChanges(1:3) = xyzs(1:3,i)
         VetChanges(4:6) = 0.0
         call ModModel(i,iAction,Labb,lnz,VetChanges)
      enddo
!
      call AggiornaJav
      call PrintMess(Message)
!
  100 format(' Atom ',a5,' has been reLabelled  ')
  110 format(' as   ',a5,' !')
  115 format(' No selected atom to relabel !')
  120 format(' No Atom reLabelled !')
  300 format(' The following atoms :')
  310 format((' ',20a6))
  320 format(' have been relabelled as :')
  400 format(i3,' atoms have been relabelled')
!
      if (ifFour.ne.0) then
!!!       call NewBonds       !!!! se cancello un secondo atomo,
!!!                           relabel solo una parte dei picchi fourier
!!!                           crea dei legami con picchi non ancora relabellati
      endif
!
      ifMess = 0
!
      return
      end
! -----------------------------------------------------------------
      subroutine FillVetSpec()
      USE General
      USE Atomi
      USE Molcom
      USE PhaseModule
!
!     do i=1,nats
!        write(6,*) 'i,nz(i),serial(i)',i,nz(i),serial(i)
!     enddo
      vetSpec(:) = 0
      do i=1,nats
         lnz = iabs(nz(i)) / nzConst
         if (lnz.gt.0) then
             iser = serial(i)
             if (iser.gt.vetSpec(lnz)) then
                 vetSpec(lnz) = iser ! vetSpec(lnz) + 1
             endif
         endif
      enddo
!
      return
      end
! -----------------------------------------------------------------
      subroutine ReNumber(numbAtom,Prefisso)
      USE General
      USE Atomi
      USE Molcom
      USE LsqModule
!
      character*(*) Prefisso
!
! ---
      call UpdateCommonAndList5(ier)
! ---
      ifOK = 1
      call ModLab(numbAtom, -1, Prefisso)
      if (ifOK == 1) then
          if (nptr.eq.1) then
              write(Message(1:30),300) 
          else
              write(Message(1:30),400) nptr
          endif
          call PrintMess(Message)
*gl*      call xupd05a(ier)
          iAction = 0
          do i=1, NatMol
             Labb = Lab(i)
             lnz = iabs(nz(i)) / nzConst
             do k=1,3
                VetChanges(k) = xyzs(k,i)
             enddo
             do k=4,6
                VetChanges(k) = 0.0
             enddo
             call ModModel(i,iAction,Labb,lnz,VetChanges)
          enddo
*gl*      call xupd05z(0)
      endif
! ---
  300 format('One atom has been relabelled  ')
  400 format(i3,' atoms have been relabelled')
! ---
!
!-- checks for label duplications     !!!  spostata in ModLab
!
*     ifSame = 0
*     Message = ' '
*     do i = 1 , NatMol - 1
*        do j = i + 1 , NatMol
*           if (Lab(i).eq.Lab(j).and.ifSame.eq.0) then
*               ifSame = 1
*               Inte = 'W A R N I N G ...'
*               Message = 'There is at least one couple of atoms '//
*    *                     'with the same name (i.e. '//Lab(i)//')'
*               iExCode = 0
*               call MsgWinErr(Inte,Message,WARN_WINDOW,iExCode)
*           endif
*        enddo
*     enddo
! ---
      leggi = 1
      call toMolPlo3(leggi)
      call RotazTot
      call GetBonds(1)
      call AggiornaJav()
cccccccccccccccc      call sfl12
! ---
      return
      end
! -----------------------------------------------------------------
      subroutine Distance(iAction)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
!
      common /Distanze/ ndist, dis(300), nop(300), ifDist
!g    common /AtomType/ nTp, kCentral, xyzTmp(3,5)
!

      common/symcon/natsym,idoppiodi,iopsym(1000),ipolim
     1,asmin(3),asmax(3),incella(10000),idoppiodit
     
      dimension d(3)

      Message = ' '
      ifDist = 1
      coef = 1.5
      iscr=0
      if (nptr .eq. 0) then
         write(Message,300)
         goto 100
      elseif (nptr .eq.1) then
         distmin = 99999.9
         j1 = kptr(1)
         ndist = 0
         if (ifCont.eq.0) then
            ifDentro = 1
            iUno = 1
            call Genera(ifDentro, iUno)
         end if
         do 56 nf=1,NatMol  !  Gen
            RSnf = abs(RS(nf))
            if (nf.ne.j1.and.RSnf.lt.5.0) then
                dist = 0.
                do 52 i=1,3
                   dist = dist + (xyz(i,j1)-xyz(i,nf))**2
   52           continue
                dist = sqrt(dist)
                iOK = 1
                DistMax = RaggioSfera
                if (dist .gt. DistMax) then
                   iOK = 0
                end if
                if (iOK .eq. 1) then
                   ndist = ndist + 1
                   dis(ndist) = dist
                   kptr(ndist) = nf
                else
                   if (dist.lt.distmin) then
                      distmin = dist
                      jf = nf
                   endif
                endif
            endif
   56    continue
         if (ndist .eq. 0) then
            ndist = 1     !  commentate - gianluca - 28/06/2003
            dis(1) = distmin
            kptr(1) = jf
            ifDist = 0
            ifFound = 0
         else
            ifFound = 1
         end if
         do 70 i=1,ndist-1
            do 60 j=i+1,ndist
               if (dis(j).lt.dis(i)) then
                  idu = kptr(i)
                  kptr(i) = kptr(j)
                  kptr(j) = idu
                  dum = dis(i)
                  dis(i) = dis(j)
                  dis(j) = dum
                end if
   60       continue
   70    continue
         if (iaction.eq.3) then
            if (dis(1).lt.0.6) then
               kptr(3) = nint(dis(1)*10000.)     !pg210807
               kptr(2) = iEqui(kptr(1))
               kptr(1) = -iabs(kptr(1))
            end if
            goto 100
         end if
         call DispDist(dis, j1, ndist, iAction, ifFound)
         goto 100
      elseif (nptr.eq.2) then
         dist = 0.
         j1 = kptr(1)
         j2 = kptr(2)
         do 80 i=1,3
            dist = dist + (xyz(i,j1)-xyz(i,j2))**2
   80    continue
         dist = sqrt(dist)
         l1 = Lung(Lab(j1))
         l2 = Lung(Lab(j2))
         write (Message,200) Lab(j1)(1:l1),Lab(j2)(1:l2),dist
         call PrintMess(Message)
         goto 100
      end if
!
  200 format(' Distance ',a,'- ',a,' = ',f7.4)
!
  100 khead = 0
      if (ifCont.eq.0) then
         call SoloInd(NatInd)
      end if
      return
  300 format(' Sorry ....   no selection !')
      end
! -----------------------------------------------------------------
      subroutine DispDist(dis, j1, ndist, iAction, ifFound)
      USE General
      USE Atomi
      USE Molcom
!
      real dis(100)
      character(len=80)  :: string
!
      do i=1,100
         It(i) = ' ' // char(0)
      enddo

      if (iAction.eq.1) then
          ifFound = 1
          if (ndist == 1 .and. dis(1) > DistMax) then
              ifFound = 0
          endif
      endif
      nn1 = 0
      if (ifFound == 0) then
!         It(1) = 'No atoms below the specified distance.' // char(0)
          write(It(1),455) DistMax, char(0)
          It(2) = 'Closest atom:' // char(0)
          nn1 = 2
      endif
      if (iAction.eq.2) then
          nn1 = nn1 + 1
          Lab1 = Lab(j1)
          l1 = Lung(Lab1)
          l1 = iEqui(j1)
          if (nzTot(l1) /= PiccoFour) then
              write(It(nn1),100) Lab1, char(0)
          else
              write(It(nn1),200) Lab1, char(0)
          endif
          nn1 = nn1 + 1
          write(It(nn1),300) char(0)
          nn1 = nn1 + 1
          write(It(nn1),400) (xyzs(kk,l1), kk=1,3),
     *              xyzs(5,l1),nint(xyzs(4,l1)),bfac(l1), char(0)
          nn1 = nn1 + 1
          It(nn1) = ' ' // char(0)
      endif
!
      Lab1 = Lab(j1)
      if (nOpEq(j1) == 1555) then
          string = '(asymmetric)'
          l1 = Lung(string)
      else
         call MakeString(j1,string)
         call NoBlanks(string,l1)
      endif
      if (ifFound == 1) then
          write(It(1),450) Lab1(1:Lung(Lab1)), string(1:l1), char(0)
          write(It(2),460) DistMax, char(0)
      endif
      nn1 = 2 
      do nn =1,ndist
         nn1 = nn1 + 1
         j2 = kptr(nn)
         Lab2 = Lab(j2)
         l2 = Lung(Lab2)
         call MakeString(j2,string)
         call NoBlanks(string,l1)
!         write (It(nn1),500) Lab1(1:l1),Lab2(1:l2),dis(nn), char(0)
         write (It(nn1),550) dis(nn), Lab2(1:l2),string(1:l1), char(0)
      enddo
      It(nn1+1) = char(0)
!
      if (ifCont.eq.0) then         ! modifica del 12/10/2002 - gianluca
         call SoloInd(NatInd)       ! modifica del 12/10/2002 - gianluca
      end if                        ! modifica del 12/10/2002 - gianluca
      call PrintDist(j1, nn1)                         !mrmrmr
!
      nel = 0
!
  100 format('Atom ', a8,a)
  200 format('Fourier peak #',a8,a)
  300 format('   x      y      z     Occ  Height   B  ',a)
  400 format(3f7.3,f6.3,i6,f7.2,a)
  450 format('Distance(s) from ',a,a,a)
  455 format('No atoms below ',f6.3,a)
  460 format('below ',f6.3,a)
  500 format ('Distance ',a,' - ',a,' =',f7.4,a)
  550 format (f7.4,2x,a,2x,a,a)

      end
! -----------------------------------------------------------------
      subroutine MakeString(j1,string)
      USE Molcom
      USE Symmetry
!
      character*(*) string
      integer abc(3)
!
      string = ' '
      if (nOpEq(j1) /= 1555) then
          ii = nOpEq(j1) / 1000
          string = '('//SymmStrings(ii)(1:Lung(SymmStrings(ii)))//')'
          jj = nOpEq(j1) - ii * 1000
          if (jj > 0) then
              string(67:68) = '+('
              kk = 100
              do i=1,3
                 ii = jj / kk
                 abc(i) = ii - 5
                 jj = jj - ii * kk
                 kk = kk / 10
              enddo
              write(string(69:78),"(2(i2,','),i2)") abc
              string(79:79) = ')'
          endif
      endif
!
      return
      end
! -----------------------------------------------------------------
      subroutine PrintDist(jAtom, nIt)
      USE Molcom
! ---
      call DrawFewLabels(jAtom,1)
!
      ir = RaggioSfera * x11scale(1)
      ix = ipix(1,jAtom)
      iy = ipix(2,jAtom)
      call Cerchio_dash(ix, iy, ir, icoWire)
!
      call PrintIt('Distances', nIt)
      call DrawFewLabels(jAtom,2)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine CalcAngle(ifInGraphic,Ang)
      USE General
      USE Atomi
      USE Molcom
!
      if (nptr.eq.3) then
         dist = 0.
         j1 = kptr(1)
         j2 = kptr(2)
         j3 = kptr(3)
*        call ProvaAngolo(j1,j2,j3)
!
         nvc = 0
         do 85 j=1, 3, 2
            nvc = nvc + 1
            jj = kptr(j)
            do 80 i=1, 3
               VV(nvc,i) = xyz(i,jj) - xyz(i,j2)
   80       continue
   85    continue
         rMod1 = sqrt(VV(1,1)**2+VV(1,2)**2+VV(1,3)**2)
         rMod2 = sqrt(VV(2,1)**2+VV(2,2)**2+VV(2,3)**2)
         rModuS = VV(1,1)*VV(2,1)+VV(1,2)*VV(2,2)+VV(1,3)*VV(2,3)
         CosAng = rModuS/(rMod1*rMod2)
         if (CosAng .gt. 0.999999) CosAng = 0.999999
         if (CosAng .lt.-0.999999) CosAng =-0.999999
         Ang = acos(CosAng) * RtoD
         if (ifInGraphic == 1) then
             nf = 0
             Lab1 = Lab(j1)
             Lab2 = Lab(j2)
             Lab3 = Lab(j3)
             l1 = Lung(Lab1)
             l2 = Lung(Lab2)
             l3 = Lung(Lab3)
             write (Message,200) Lab1(1:l1),Lab2(1:l2),Lab3(1:l3),
     *                           Ang
             call PrintMess(Message)
         endif
      end if
!
  200 format(' Angle ',a,'- ',a,'- ',a,' = ',f6.1)

      return
      end
!-----------------------------------------------------------------------
      subroutine ProvaAngolo(j1, j2, j3)
      USE Atomi
!
      implicit none
      integer :: j1, j2, j3
      real    :: Angolo, x1(3), x2(3), x3(3)
!
      x1(1:3) = xyzs(1:3, j1)
      x2(1:3) = xyzs(1:3, j2)
      x3(1:3) = xyzs(1:3, j3)
      call CalcolaAngoloFract(x1, x2, x3, Angolo)
      write(*,*) Angolo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine AddDelBonds(iAction, NatIn, ifHBond)
      USE General
      USE Atomi
      USE Molcom
!
      Message = ' '
      NumAD = 0
      if (iAction == 3) then
          do i = 1, NumLeg
             if (LE(3, i) == 3) then
                 LE(3, i) = -1
             endif
          enddo
      else
          do npt=1, nptr, 2
             if (npt.eq.nptr) then
                 exit
             endif
             j1 = kptr(npt)
             j2 = kptr(npt+1)
             if (j1 .ne. j2) then
                 call CheckBond(j1, j2, iBondStat, iPunt)
                 iOK = 0
                 if (iAction == 1) then
                     if (iPunt < 0) then
                         iOK = 1
                     else
                         if (iBondStat == -1) then
                             LE(3, iPunt) = 2
                         endif
                     endif
                 elseif (iAction == 2) then
                     if (iPunt > 0) iOK = 1
                 endif
                 if (iOK > 0) then
                     NumAD = NumAD + 1
                     if (iabs(iAction).eq.1) then
*?                       if (iBondStat.ge.1) then
*?                           return
*?                       end if
                         if (iBondStat.eq.-999) then
                             if (NumLeg .EQ. nMaxLeg) then
                                 exit
                             end if
                             do i = NumLeg, NumLeg - nlp + 1, -1
                                LE(1, i + 1) = LE(1, i)
                                LE(2, i + 1) = LE(2, i)
                                LE(3, i + 1) = LE(3, i)
                             end do   
                             NumLeg = NumLeg + 1
                             LE(1, NumLeg - nlp) = j1
                             LE(2, NumLeg - nlp) = j2
                             LE(3, NumLeg - nlp) = 2 + ifHBond
                         else
                             LE(3, iPunt) = 2
                         end if
                     else
                        LE(3, iPunt) = -1
                     end if
                 end if
             end if
          enddo
      endif
!
  200 format(i4,'  bond(s) have been added  ')
  300 format(i4,'  bond(s) have been deleted')
  400 format(i4,'  hydrogen bond(s) have been deleted')
!
      if (iAction.eq.1) then
          write(Message,200) NumAD
      elseif (iAction.eq.2) then
          write(Message,300) NumAD
      else
          write(Message,300) NumAD
      end if
!
      if (NatMol .eq. NatIn) then
          do i = 1, NumLeg
             LE1(1, i) = LE(1, i)
             LE1(2, i) = LE(2, i)
             LE1(3, i) = LE(3, i)
          enddo
          nLegInd = NumLeg
      end if
!
      kSca = 0
      call Disegna(kSca)
!
      if (QualePgm == SIRPGM) then
          call LEtoIconn
*gl*      call xupd05a(ier)
          j = 1
          iAction = 100
          Labb = Lab(j)
          lnz = 1
          call ModModel(j,iAction,Labb,lnz,VetChanges)
*gl*      call xupd05z(0)
      endif
c      ii=iconn(1)*3+1
c      write(lo,*)'adddelbond iconn ',iconn(1:ii)
!
      call PrintMess(Message)
      call AggiornaJav
!
      return
      end
! -----------------------------------------------------------------
      subroutine reset_hbonds()
      USE Molcom
!
      iAction = 3
      idumm = 0
      call AddDelBonds(iAction, NatInd, idumm)
!
      return
      end
! -----------------------------------------------------------------
      Subroutine CheckBond(n1, n2, iBondStat, iPunt)
      USE General
      USE Atomi
      USE Molcom
!
      iPunt = -1
      iBondStat = -999
      do i=1, NumLeg - nlp
         if (LE(1, i).eq.n1) then
            if (LE(2, i).eq.n2) then
               iBondStat = LE(3, i)
               iPunt = i
               return
            end if
         elseif (LE(1, i).eq.n2) then
            if (LE(2, i).eq.n1) then
               iBondStat = LE(3, i)
               iPunt = i
               return
            end if
         end if
      end do

      return
      end
! -----------------------------------------------------------------
      subroutine TorsAngle
      USE General
      USE Atomi
      USE Molcom
!
      j1 = kptr(1)
      j2 = kptr(2)
      j3 = kptr(3)
      j4 = kptr(4)
!
!--- Calcola i vettori V1, V2 e V3
!
      do 80 i = 1, 3
         do 70 j = 1, 3
            VV(i, j) = xyz(j, kptr(i+1)) - xyz(j, kptr(i))
   70    continue
   80 continue
!
!--- Calcola gli angoli V1^V2 e V2^V3
!
      rModuA = sqrt(VV(1,1)**2+VV(1,2)**2+VV(1,3)**2)
      rModuB = sqrt(VV(2,1)**2+VV(2,2)**2+VV(2,3)**2)
      rModuS = VV(1,1)*VV(2,1)+VV(1,2)*VV(2,2)+VV(1,3)*VV(2,3)
      CosAng = rModuS/(rModuA*rModuB)
      if (CosAng .gt. 0.999999) CosAng = 0.999999
      if (CosAng .lt.-0.999999) CosAng =-0.999999
      AngG = acos(CosAng)
      SinG = sin(AngG)
!
      rModuC = sqrt(VV(3,1)**2+VV(3,2)**2+VV(3,3)**2)
      rModuS = VV(2,1)*VV(3,1)+VV(2,2)*VV(3,2)+VV(2,3)*VV(3,3)
      CosAng = rModuS/(rModuB*rModuC)
      if (CosAng .gt. 0.999999) CosAng = 0.999999
      if (CosAng .lt.-0.999999) CosAng =-0.999999
      AngA = acos(CosAng)
      SinA = sin(AngA)
!
!--- Calcola le componenti dei prodotti vettoriali V1 x V2, V2 x V3
!   ( V4 e V5 ) e  V4 x V5  ( V6 )
!
      do 180 i = 2, 3
         VV(2+i,1) = VV(i-1,2)*VV(i,3) - VV(i-1,3)*VV(i,2)
         VV(2+i,2) =-VV(i-1,1)*VV(i,3) + VV(i-1,3)*VV(i,1)
         VV(2+i,3) = VV(i-1,1)*VV(i,2) - VV(i-1,2)*VV(i,1)
  180 continue
      VV(6,1) = VV(4,2)*VV(5,3) - VV(4,3)*VV(5,2)
      VV(6,2) =-VV(4,1)*VV(5,3) + VV(4,3)*VV(5,1)
      VV(6,3) = VV(4,1)*VV(5,2) - VV(4,2)*VV(5,1)
!
      V = VV(1,1)*VV(5,1)+VV(1,2)*VV(5,2)+VV(1,3)*VV(5,3)
      SinAng =  V / (rModuA*rModuB*rModuC*SinA*SinG)
      pm =sign(1.,SinAng)
!
!--- Calcola il prodotto scalare V4 . V5
!
      rModuS = VV(4,1)*VV(5,1)+VV(4,2)*VV(5,2)+VV(4,3)*VV(5,3)
!
      CosAng = rModuS / (rModuA*rModuB*rModuB*rModuC*SinA*SinG)
      if (CosAng .gt. 0.999999) CosAng = 0.999999
      if (CosAng .lt.-0.999999) CosAng =-0.999999
      Ang = pm * acos(CosAng) * RtoD
!
!
!
      Lab1= Lab(j1)
      Lab2= Lab(j2)
      Lab3= Lab(j3)
      Lab4= Lab(j4)
      l1 = Lung(Lab1)
      l2 = Lung(Lab2)
      l3 = Lung(Lab3)
      l4 = Lung(Lab4)
      write(Message,200) Lab1(1:l1),Lab2(1:l2),Lab3(1:l3),
     *                   Lab4(1:l4),Ang
  200 format(' Torsion angle ',a,'- ',a,'- ',a,'- ',a,' =',f6.1)
      call PrintMess(Message)
!
      return
      end
! -----------------------------------------------------------------
      subroutine ModCom(jrest0)
      USE General
      USE Atomi
      USE Molcom
      USE PhaseModule
      USE LsqModule
!
      integer :: ifModModel
      real :: B(3,3)
!
      ifModModel = 0
      call SoloInd(NatInd)
      do i=1,NatInd
         nz(i) = -iabs(nz(i))
      enddo
!
      NLeg = NumLeg - nlp

      NumLeg = NLeg     ! gianluca 28/04/2011

      do j=1,NLeg
         do i=1,2
            leg=LE(i,j)
            if (leg <= NatInd) then
                nz(leg)=iabs(nz(leg))
            endif
         enddo
      enddo

!
!-- update atoms
!-- block the atoms connected
!-- leave free the unlinked & ghosts
!
      VetChanges(:) = 0.0

!
!-- check on List 5
!
      lis5 = 1
      if (InfoOK(15) == 0) then
          call PutModel
      endif

c
c--correzione del 2/12/99------------
      call EllRest
c

      lnz = 0
      j=0
      ndel = 0
      do i=1,NatInd
         if (nz(i) == 0) then
             ndel = ndel +1
             rMLU(i) = 0
         else
             j = i - ndel
             Labb = Lab(i)
             if (RS(i).lt.-10.0) then
                 iAction = 2
                 call ModModel(j,iAction,Labb,lnz,VetChanges)
                 ndel = ndel +1
                 rMLU(i) = 0
                 ifModModel = 1
             else
                 if (ifChangedB(i).ne.0) then
                     iAction = 3
                     call ModModel(j,iAction,Labb,lnz,VetChanges)
                     ifModModel = 1
                 endif
                 ifC = ifChanged(i)
                 if (ifC.ne.0) then
                     lnz = iabs(nz(i)) / nzConst
                     do k=1,5
                        VetChanges(k) = xyzs(k,i)
                     enddo
                     VetChanges(6) = bfac(i)
                     iAction = 0
                     call ModModel(j,iAction,Labb,lnz,VetChanges)
                     if (bSav(j) > 0.0) then
                         VetChanges(1) = Ell(1,1,j)
                         VetChanges(2) = Ell(1,2,j)
                         VetChanges(3) = Ell(1,3,j)
                         VetChanges(4) = Ell(2,2,j)
                         VetChanges(5) = Ell(2,3,j)
                         VetChanges(6) = Ell(3,3,j)
                         iAction = 7
                         call ModModel(j,iAction,Labb,lnz,VetChanges)
                     endif
                     ifModModel = 1
                 endif
                 rMLU(i) = i - ndel
                 nz(j) = nz(i)
                 bfac(j) = bfac(i)
                 aLab(j) = Lab(i)
                 do k = 1 , 5
                    xyzs(k,j) = xyzs(k,i)
                 enddo
             endif
         endif
      enddo
      nats = j
*     ndel = 0
*     do i=1,NatInd
*        if (RS(i).lt.-10.0) then
*            ndel = ndel + 1
*            nz(i) = 0
*        endif
*     enddo
!gl!  if (ndel > 0) then
*gl**     jdoppio(1:NatInd) = rMLU(1:NatInd)
!gl!      call EliminaGhost(1)
*gl**     rMLU(1:NatInd)   = jdoppio(1:NatInd)
*gl** endif
!gl!  else
      call GetModel      ! gianluca 20 ottobre 2014
!
!-- update connectivity
!
      NLeg = NumLeg
      k=0
      do j=1,NLeg
         leg1=LE(1,j)
         leg2=LE(2,j)
         leg3=LE(3,j)
         if (rMLU(leg1).gt.0 .and. rMLU(leg2).gt.0) then
             k=k+1
             leg1 = rMLU(leg1)
             leg2 = rMLU(leg2)
             LE(1,k) = leg1
             LE(2,k) = leg2
             LE(3,k) = leg3
         endif
      enddo
!
      NLeg = k
!
      j=1
      iconn(1)=NLeg
      do i=1,NLeg
         do k=1,2
            j=j+1
            iconn(j)=LE(k,i)
         enddo
         j=j+1
         iconn(j)=LE(3,i)
      enddo
!
      NLeg = iconn(1)
      iAction = 100
      i       =   0
      Labb    = ' '
      call ModModel(i,iAction,Labb,lnz,VetChanges)
!
!-- update SinglePlotType ALWAYS !!!!
!
      iAction = 200
      j       =   0
      Labb    = ' '
      call ModModel(j,iAction,Labb,lnz,VetChanges)
!gl!  endif
!
!-- update restraints
!
      if (nres.gt.0) then
!         call from12to31(ier)
c          call PrintRestraint(-1)
          kDelete = 0
          jp = 0
          do k=1,nres
             jp = jp + 1
             icode = nint(vres(jp))
             natom = nint(vres(jp+1))
             if (icode.eq.5) then
                 npar31 = nint(vres(jp+3))
             else
                 npar31 = 0
             endif
!mrmrmr 010704
             mrinc = 4
             if (icode == 6) then
                 mrinc = 5
             endif
             if (icode == 8) then   ! disorder
                 mrinc = 2
                 natom = 2 * natom
             endif
!mr
             natnew = 0
c             write(lo,*)'k,nres,icode,natom,npar31,mrinc',
c     *          k,nres,icode,natom,npar31,mrinc 
!mr             do jj=jp+4+npar31,jp+4+npar31+natom-1
             do jj=jp+mrinc+npar31,jp+mrinc+npar31+natom-1
                nc = nint ( vres(jj) )
                nnc = rMLU(nc)
                vres(jj) = nnc
c                write(lo,*)jj,nc,nnc
                if (nnc.ne.0) then
                    natnew = natnew + 1
                endif
             enddo
             if (icode.eq.1.and.natnew.ne.2) then
                 vres(jp) = 0
                 kDelete = kDelete + 1
             else if (icode.eq.2.and.natnew.ne.3) then
                 vres(jp) = 0
                 kDelete = kDelete + 1
             else if (icode.eq.3.and.natnew.lt.3) then
                 vres(jp) = 0
                 kDelete = kDelete + 1
             else if (icode.eq.4.and.natnew.lt.2) then
                 if (natom.gt.0) then
                     vres(jp) = 0
                     kDelete = kDelete + 1
                 endif
             endif
!mr             jp = jp + 3 + natom + npar31
             jp = jp + mrinc - 1 + natom + npar31
          enddo
          if (kDelete.gt.0) then
              jp = 0
              jn = 0
              do k=1,nres
                 jp = jp + 1
                 icode = nint(vres(jp))
                 natom = nint(vres(jp+1))
                 if (icode.eq.5) then
                     npar31 = nint(vres(jp+3))
                 else
                     npar31 = 0
                 endif
                 mrinc = 4
                 if (icode == 6) then
                    mrinc = 5
                 endif
                 if (icode.gt.0) then
                     kk = 0
                     do jj=jp,jp+mrinc+npar31+natom-1
                        jn = jn + 1
                        vres(jn) = vres(jp+kk)
                        kk = kk + 1
                     enddo
                 endif
                 jp = jp + mrinc - 1 + npar31 + natom
              enddo
              nres = nres - kDelete
!
!-- update array LAB
              j = 0
              do i=1, NatMol
                 if (rMLU(i) == 0) cycle
                 j = j + 1
                 Lab(j) = Lab(i)
              enddo
          endif
!
c          call PrintRestraint(-1)
      endif
!
          interp=1
          call PutGetXyzs(1, interp)
      if (lis5.le.0) then
          jrest=jrest0
          interp=1
          call PutGetXyzs(1, interp)
          call SaveRestoreXyzs(1)
      else
          call PutModel   !! problema btot 20/12/2010 gianluca
          leggi = 1
          call toMolPlo3(leggi)
          call RotazTot
*gl*      call FindOr(B, 1)
          call GetBonds(1)
      endif
c      write(lo,*)'Stampo list 12 fine modcom'      
c      call sw12(lo,1)    
!
      return
      end
! -----------------------------------------------------------------
      subroutine Upd15()
      USE General
      USE Atomi
      USE Molcom
      USE PhaseModule
      USE LsqModule
!
!-- update (delete) atoms in List 15 only
!
      lnz = 0
      j=0
      ndel = 0
      do i=1,nats
         if (RS(i).lt.-10.0) then
             ndel = ndel +1
             rMLU(i) = 0
         else
             j = j + 1
             rMLU(i) = i - ndel
             serial(j) = serial(i)
             Lab(j) = Lab(i)
             aLab(j) = aLab(i)
             nz(j) = nz(i)
             bfac(j) = bfac(i)
             aLab(j) = Lab(i)
             xyzs(1:5,j) = xyzs(1:5,i)
         endif
      enddo
      nats = j
!
!-- update connectivity
!
      NLeg = iconn(1)
      k = 0
      i1 = 1
      i2 = 1
      do j=1,NLeg
         leg1 = iconn(i1 + 1)
         leg2 = iconn(i1 + 2)
         leg3 = iconn(i1 + 3)
         if (rMLU(leg1) > 0 .and. rMLU(leg2) > 0) then
             k = k + 1
             leg1 = rMLU(leg1)
             leg2 = rMLU(leg2)
             iconn(i2 + 1) = leg1
             iconn(i2 + 2) = leg2
             iconn(i2 + 3) = leg3
             i2 = i2 + 3
         endif
         i1 = i1 + 3
      enddo
!
      iconn(1) = k
!
      return
      end
! ----------------------------------------------------------------------
      subroutine ReGroup(jComplete)
      USE General
      USE Atomi
      USE Molcom
      USE PhaseModule
!
!-- jComplete = 1    complete a partial connectivity
!-- jComplete = 2    recompute connectivity
!
      if (jComplete == 1) iconn(1) = -iabs(iconn(1))
      if (jComplete == 2) then
          nz(1:nats) = iabs(nz(1:nats))
          iconn(1) = -9999
      endif
      ier = 0
!
      do i=1,nats
         kblock(i) = 0
         nzo(i)=nz(i)
      enddo
!
!-- check on List 5
!
      kact=5
c--mercedes 2mag2006
      call build(kact, jComplete)
      do i=1,nats
         if (nz(i).ne.0) then
             nz(i)=nzo(i)
           else
             nz(i)=0
         endif
      enddo
!
      if (QualePgm == SIRPGM) then
          do i=1,nats
             lnz = iabs(nz(i)) / nzConst
             kblock(i) = 0
             do k=1,5
                VetChanges(k) = xyzs(k,i)
             enddo
             VetChanges(6) = bfac(i)
             Labb = Lab(i)
             iAction = 0
             call ModModel(i,iAction,Labb,lnz,VetChanges)
             if (bSav(i).gt.0.0) then
                 VetChanges(1) = bij(1,i)
                 VetChanges(2) = bij(2,i)
                 VetChanges(3) = bij(3,i)
                 VetChanges(4) = bij(4,i)
                 VetChanges(5) = bij(5,i)
                 VetChanges(6) = bij(6,i)
                 iAction = 7
                 call ModModel(i,iAction,Labb,lnz,VetChanges)
             endif
          enddo
          iAction = 100
          call ModModel(i,iAction,Labb,lnz,VetChanges)
          do i=2,iconn(1),3
             j = iconn(i)
             nz(j) = iabs(nz(j))
             j = j + 1
             nz(j) = iabs(nz(j))
          enddo
          call PutModel
!
      else
!
!-- save atom list for future use
!
          interp=1
          call PutGetXyzs(1, interp)
      endif
!
      leggi = 1
      call toMolPlo3(leggi)
*gl*  if (BTot(1,1) < 100) then
          call LsPlane(NATV, 1)
*gl*  else
*gl*      do i = 1 , 3
*gl*         do j = 1 , 3
*gl*            BTot(i, j) = 0
*gl*         enddo
*gl*         BTot(i, i) = 1
*gl*      enddo
*gl*      call FindOr(B, 1)
*         ifScale = 1
*gl*      call RotazTot
*         call GetBonds(1)
*gl*  endif
!
      call RotazTot    ! *gl*
!
!-- NEW    8 febbraio 2013
!
      IfLeg = iconn(1)
!
      if (IfLeg .eq.-1) then
          call BuildBonds(1)
          call LEtoIconn
      else
          call GetBonds(1)
      end if
      if (kscreen.eq.0) return
!
      call EnableSingleIteration(0)
      call Disegna(ifScale)
      call EnableSingleIteration(1)
!
!-- NEW    8 febbraio 2013
!
      call AggiornaJav()
!
      return
      end
! -----------------------------------------------------------------
      subroutine Translate (iAction, Perc)
      USE Molcom
!
      Rmin1 = Xmin
      Rmin2 = Ymin
      RMax1 = XMax
      RMax2 = YMax
      D1 = (RMAX1 - Rmin1) * Perc / 100.
      D2 = (RMAX2 - Rmin2) * Perc / 100.
      if (iAction.EQ.1) then
         Rmin1 = Rmin1 + D1
         RMax1 = RMax1 + D1
      else if (iAction.EQ.2) then
         Rmin1 = Rmin1 - D1
         RMax1 = RMax1 - D1
      else if (iAction.EQ.3) then
         Rmin2 = Rmin2 + D2
         RMax2 = RMax2 + D2
      else if (iAction.EQ.4) then
         Rmin2 = Rmin2 - D2
         RMax2 = RMax2 - D2
      else if (iAction.EQ.5) then
         Rmin1 = Rmin1 - D1
         RMax1 = RMax1 + D1
         Rmin2 = Rmin2 - D2
         RMax2 = RMax2 + D2
      else if (iAction.EQ.6) then
         Rmin1 = Rmin1 + D1
         RMax1 = RMax1 - D1
         Rmin2 = Rmin2 + D2
         RMax2 = RMax2 - D2
      end if
      Xmin = Rmin1
      Ymin = Rmin2
      XMax = RMax1
      YMax = RMax2
      call SetScale(0)
      return
      end
! -----------------------------------------------------------------
      function Interno (ix, iy, nvpolx)
      USE Molcom
!
      real  sm
!
      NumIntD = 0
      NumIntS = 0
      Inter = 0
      do k = 1, nvpolx - 1
          ia = iy - iyp(k + 1)
          if (ia .ne. 0) then
              a1 = iy - iyp(k + 1)
              b1 = iyp(k) - iy
              if (b1 / a1 .ge. 0.0) then
                  if (iyp(k + 1) .ne. iyp(k)) then
                      a = ixp(k + 1) - ixp(k)
                      b = iyp(k + 1) - iyp(k)
                      if (ABS(b) .gt. .00001) then
                          sm = a / b
                      else
                          sm = 0
                      end if
                      rix1 = ixp(k) + (iy - iyp(k)) * sm
                  else
                      rix1 = ixp(k)
                  end if
                  if (rix1 .lt. ix) then
                      NumIntS = NumIntS + 1
                  end if
                  if (rix1 .gt. ix) then
                      NumIntD = NumIntD + 1
                  end if
              end if
          end if
      enddo
      if (NumIntD .gt. 0) then
         if (INT(NumIntD / 2) * 2 .ne. NumIntD) then
            Inter = -1
         end if
      end if
      if (NumIntS .gt. 0) then
         if (INT(NumIntS / 2) * 2 .ne. NumIntS) then
            Inter = Inter - 1
         end if
      end if
      Interno = Inter
!
      return
      end
! --------------------------------------------------------------------
      subroutine ChePiano(iSce)
      USE Molcom
!
      dimension B(3, 3)
!
      iExitCode = 1
      iScelta = iSce
      if (iSce.eq.7) then
         iScelta = 1
         do i=1, NatMol
            iok = 1
            do j=1, nptr
               if (i.eq.kptr(j)) iok =0
            enddo
            if (iok.eq.1) RS(i) = RS(i) - 100.
         enddo
      end if
!
      if (iScelta.ge.1 .and. iScelta .le.3) then
          call LsPlane(NATV, 1)
          if (NATV.eq.0) then
              return
          end if
          VecX = evec(1, iScelta)
          VecY = evec(2, iScelta)
          VecZ = evec(3, iScelta)
      elseif (iScelta.ge.4 .and. iScelta .le.6) then
!pg2          if (ifDrawContour == 0) then

              k = NatMol + iScelta - 3
              j = NatMol + 4
              VecX = xyz(1, k) - xyz(1, j)
              VecY = xyz(2, k) - xyz(2, j)
              VecZ = xyz(3, k) - xyz(3, j)

!pg2          else
!pg2              k = nPuntiCont + iScelta - 3
!pg2              j = nPuntiCont + 4
!pg2              VecX = xyz_tria(1, k) - xyz_tria(1, j)
!pg2              VecY = xyz_tria(2, k) - xyz_tria(2, j)
!pg2              VecZ = xyz_tria(3, k) - xyz_tria(3, j)
!pg2          end if
          end if
!
      if (iSce.eq.7) then
         do i=1, NatMol
            iok = 1
            do j=1, nptr
               if (i.eq.kptr(j)) iok =0
            enddo
            if (iok.eq.1) RS(i) = RS(i) + 100.
         enddo
      end if
!
      if (iScelta .lt. 8) then
*         write(*, *) VecX, VecY, VecZ
          call PlaneFound(VecX, VecY, VecZ)
!pg2          if (ifDrawContour == 0) then         !pg
          if (ifDrawContour .ne. 1) then         !pg2
             call FindOr(B, iSce)
          end if                               !pg
      end if
!
      return
      end
! -----------------------------------------------------------------
      subroutine PlaneFound (VecX, VecY, VecZ)
      USE General
      USE Molcom
!
      nRot = 1
      nRTot = 1
      VMod = VecX ** 2 + VecY ** 2
      V1Mod = SQRT(VMod + VecZ ** 2)
      VMod = SQRT(VMod)
      s = VMod / V1Mod
      if (s .lt. .999) then
          Ang = ATAN(s / SQRT(1 - s * s))
          Ang = Ang * rtod
      else
          Ang = 90
      end if
      if (VecZ .lt. 0) then
         Ang = 180 - Ang
      end if
      RK(1) = Ang
      RK(2) = 4
      RK(3) = 1
      VV(1, 1) = VecY
      VV(1, 2) = -VecX
      VV(1, 3) = 0
      if (abs(VecX).lt.0.00001 .AND. abs(VecY).lt.0.00001) then
          VV(1, 3) = 1
      end if
!
      return
      end
! -----------------------------------------------------------------
      subroutine FindOr(B, iSce)
      USE General
      USE Molcom
      USE Atomi
!
      dimension B(3, 3), BOpt(3, 3)
!
      do j = 1 , 3
         do i = 1 , 3
            B(i, j) = 0
            BOpt(i, j) = 0
         enddo
         B(j, j) = 1
         BOpt(j, j) = 1
      enddo
!
      call CombRot(B)
      call RotTot(B)
!
      call RotAtoms(B, 1)
      
      call FindMinMax
      call SetScale(4)
!
      if (iSce > 3 .and. iSce < 7) then
         if (iSce.eq.4) then
            ns = 2
         elseif (iSce.eq.5) then
            ns = 3
         elseif (iSce.eq. 6) then
            ns = 1
         end if
         p1 = xyz(1, NatMol + ns) 
     *      - xyz(1, NatMol + 4)
         p2 = xyz(2, NatMol + ns) 
     *      - xyz(2, NatMol + 4)
         xl = sqrt( p1 * p1 + p2 * p2 )
!         if (xl > 0.000001)  then
         if (xl > 1.e-20)  then
            Angolo = (xyz(1, NatMol + ns) 
     *             - xyz(1, NatMol + 4)) / xl
         else
!            Angolo = 0.999999
            Angolo = 1.e-20
         end if
!         if (Angolo .gt. 0.999999) Angolo = 0.999999
!         if (Angolo .lt.-0.999999) Angolo =-0.999999
         if (Angolo .gt. 1.-1.e-20) Angolo = 1.-1.e-20
         if (Angolo .lt.-1.+1.e-20) Angolo =-1.+1.e-20
         RK(1) = acos(Angolo) * rtod
         if (xyz(2, NatMol + ns) -
     *       xyz(2, NatMol + 4).gt.0) then
             RK(1) = -abs(RK(1))
         end if
         RK(2) = 3
         call CombRot(BOpt)
         call RotTot(BOpt)
         call RotAtoms(BOpt, 1)
         call FindMinMax()
! 
         call SetScale(1)
         return
      else
         pippo = 0
      end if

      SupMin = abs((RMAX1-Rmin1)/RS(1))
      do i = 1 , 3
         do j = 1 , 3
            BOpt(i, j) = 0
            B   (i, j) = 0
         enddo
         BOpt(i, i) = 1
         B   (i, i) = 1
      enddo
      RK(1) = 0
      do NuR = 1 , 18
         RK(1) = RK(1) + 10
         RK(2) = 3
         do j = 1 , 3
            do i = 1 , 3
               B(i, j) = 0
            enddo
            B(j, j) = 1
         enddo
         call CombRot(B)
         Rmin1 = 99999.
         Rmin2 = 99999.
         RMAX1 = -99999.
         RMAX2 = -99999.
         call RotAtoms(B, 2)
         call SetScale(4)
         sca=abs((RMAX1-Rmin1)/RS(1))
         if (sca .lt. SupMin) then
            SupMin = sca
            do i = 1 , 3
               do j = 1 , 3
                  BOpt(i, j) = B(i, j)
               enddo
            enddo
         end if
      enddo
      Rmin1 = 99999.
      Rmin2 = 99999.
      RMAX1 = -99999.
      RMAX2 = -99999.
      
      call RotAtoms(BOpt, 1)
      
      call RotTot(BOpt)
      
      call FindMinMax
      call SetScale(1)
!
      return
      end
! -----------------------------------------------------------------
      subroutine Regular6(dEExp)
      USE General
      USE Atomi
      USE Molcom
      USE ilmviewmod
      USE RemoModule
! ---
      real barb(3)
!
      integer jfou(100)
! ---
      iscr=0
      nf = 0
      do n = 1, nptr
         nf = nf + 1
         jfou(nf) = kptr(n)
      enddo
!
      do k = 1, NatMol + NatSpi
         iok = 0
         do i = 1, 6
            IJ = jfou(i)
            if(k .eq. IJ)  iok = 1
         enddo
         if(iok .eq. 0) RS(k) =  RS(k) - 1000.
      enddo
!
      call DoItReg1(jfou, dEExp)
      call DoItReg1(jfou, dEExp)
!
      barb(:) = DrawBard(:)
!
      call DoItReg2(jfou, dEExp)
      call DoItReg2(jfou, dEExp)
!
      DrawBard(:) = barb(:)
!
      do IJ = 1, NatMol + NatSpi
         if(RS(IJ) .lt. -100.) then
            RS(IJ) =  RS(IJ) + 1000.
         end if
      enddo
!
      if (jav_opened()) then
          do i=1, NatInd
             model(WhichModel)%atoms(:,i,1) = xyzs(:,i)
          enddo
          call AggiornaJav
      endif
!
      return
      end
! -----------------------------------------------------------------
      subroutine DoItReg1(jfou, dEExp)
      USE General
      USE Atomi
      USE Molcom
! ---
      dimension B(3, 3), q(3), P(3)
!
      integer jfou(100)
! ---
      call LsPlane(NATV, 1)
*     bard(:) = DrawBard(:)
      do i = 1, NatMol + NatSpi
         xyz(1, i) = xyz(1, i) + DrawBard(1)
         xyz(2, i) = xyz(2, i) + DrawBard(2)
         xyz(3, i) = xyz(3, i) + DrawBard(3)
      enddo
! ---
! ---  muovi il baricentro a distanza dEExp dal primo atomo selezionato
! ---
      d1 = 0.
      do i=1, 3
         d1 = d1 + (DrawBard(i) - xyz(i, jfou(1))) ** 2
      enddo
      d1 = sqrt(d1)
      do i=1, 3
         DrawBard(i) = xyz(i, jfou(1)) 
     *               + (DrawBard(i) - xyz(i, jfou(1))) * dEExp/d1
      enddo
      do i = 1, NatMol + NatSpi
         xyz(1, i) = xyz(1, i) - DrawBard(1)
         xyz(2, i) = xyz(2, i) - DrawBard(2)
         xyz(3, i) = xyz(3, i) - DrawBard(3)
      enddo
! ---
      VecX = evec(1, 1)
      VecY = evec(2, 1)
      VecZ = evec(3, 1)
      Ang = 60
      RK(1) = Ang
      RK(2) = 4
      RK(3) = 1
      VV(1, 1) = VecX
      VV(1, 2) = VecY
      VV(1, 3) = VecZ
      do i = 1 , 3
         do j = 1 , 3
            B(i, j) = 0
         enddo
         B(i, i) = 1
      enddo
      call CombRot(B)

      JAT = jfou(1)
      P(1) = xyz(1, JAT)
      P(2) = xyz(2, JAT)
      P(3) = xyz(3, JAT)
      do J = 2, 6
         q(1) = P(1)
         q(2) = P(2)
         q(3) = P(3)
         do i = 1 , 3
            P(i) = 0
            do k = 1 , 3
               P(i) = P(i) + B(i, k) * q(k)
            enddo
         enddo
         DisMin = 9999.
         do k=1, 6
            JA = jfou(k)
            Dis = 0.
            do kk=1, 3
               Dis = Dis + (P(kk) - xyz(kk, JA))**2
            enddo
            if (Dis .lt. DisMin) then
               DisMin = Dis
               JAT = JA
            end if
         enddo
         xyz(1, JAT) = P(1)
         xyz(2, JAT) = P(2)
         xyz(3, JAT) = P(3)
      enddo
      do i = 1, NatMol + NatSpi
         xyz(1, i) = xyz(1, i) + DrawBard(1)
         xyz(2, i) = xyz(2, i) + DrawBard(2)
         xyz(3, i) = xyz(3, i) + DrawBard(3)
      enddo
!
      return
      end
! -----------------------------------------------------------------
      subroutine DoItReg2(jfou, dEExp)
      USE General
      USE Atomi
      USE Molcom
      USE LsqModule
!
      dimension B(3, 3), q(3), P(3), x1(3), r1(3)
!
      integer jfou(100)
! ---

      do 30 i=1, 6
         do 10 k=1, 3
            x1(k) = xyzs(k,jfou(i))
   10    continue
         call MoltMatVec(rm,x1,r1)
         do 20 k=1, 3
            xyzs(k, jfou(i)) = r1(k)
   20    continue
   30 continue
! ---
      call LsPlane(NATV, 2)
*     bard(:) = DrawBard(:)
      do 77 i = 1, NatMol
         xyzs(1, i) = xyzs(1, i) + DrawBard(1)
         xyzs(2, i) = xyzs(2, i) + DrawBard(2)
         xyzs(3, i) = xyzs(3, i) + DrawBard(3)
   77 continue
! ---
! ---  muovi il baricentro a distanza dEExp dal primo atomo selezionato
! ---
      d1 = 0.
      do 80 i=1, 3
         d1 = d1 + (DrawBard(i) - xyzs(i, jfou(1))) ** 2
   80 continue
      d1 = sqrt(d1)
      do 82 i=1, 3
         DrawBard(i) = xyzs(i, jfou(1)) 
     *               + (DrawBard(i) - xyzs(i, jfou(1))) * dEExp/d1
   82 continue
      do 84 i = 1, NatMol
         xyzs(1, i) = xyzs(1, i) - DrawBard(1)
         xyzs(2, i) = xyzs(2, i) - DrawBard(2)
         xyzs(3, i) = xyzs(3, i) - DrawBard(3)
   84 continue
! ---
      VecX = evec(1, 1)
      VecY = evec(2, 1)
      VecZ = evec(3, 1)
      Ang = 60
      RK(1) = Ang
      RK(2) = 4
      RK(3) = 1
      VV(1, 1) = VecX
      VV(1, 2) = VecY
      VV(1, 3) = VecZ
      do i = 1 , 3
         do j = 1 , 3
            B(i, j) = 0
         enddo
         B(i, i) = 1
      enddo
      call CombRot(B)

      JAT = jfou(1)
      P(1) = xyzs(1, JAT)
      P(2) = xyzs(2, JAT)
      P(3) = xyzs(3, JAT)
      do 130 J = 2, 6
         q(1) = P(1)
         q(2) = P(2)
         q(3) = P(3)
         do 120 i = 1 , 3
            P(i) = 0
            do 110 k = 1 , 3
               P(i) = P(i) + B(i, k) * q(k)
  110       continue
  120    continue
         DisMin = 9999.
         do 125 k=1, 6
            JA = jfou(k)
            Dis = 0.
            do 123 kk=1, 3
               Dis = Dis + (P(kk) - xyzs(kk, JA))**2
  123       continue
            if (Dis .lt. DisMin) then
               DisMin = Dis
               JAT = JA
            end if
  125    continue
         xyzs(1, JAT) = P(1)
         xyzs(2, JAT) = P(2)
         xyzs(3, JAT) = P(3)
  130 continue
      do 140 i = 1, NatMol
         xyzs(1, i) = xyzs(1, i) + DrawBard(1)
         xyzs(2, i) = xyzs(2, i) + DrawBard(2)
         xyzs(3, i) = xyzs(3, i) + DrawBard(3)
  140 continue
!
      do i=1, 6
         ifChanged(jfou(i)) = 6
         do k=1, 3
            x1(k) = xyzs(k, jfou(i))
         end do
         call MoltMatVec(rmi, x1, r1)
         do k=1, 3
            xyzs(k, jfou(i)) = r1(k)
         end do
      end do
!
      return
      end
!-----------------------------------------------------------------------
      subroutine DisEll(ii,CC)
      USE General, only: lo
      USE Atomi
      USE Molcom
!
      real el(3, 3), s(3), e(3), g(3)
      real rj(3), c(3), f(3),  h(128,3)
      integer CC

! ---
      i = iEqui(ii)
      do 10 j=1, 3
         do 5 k=1, 3
            el(j,k) = Ell(j,k,i)
    5    continue
   10 continue
      if (nOpEq(ii)/1000 .ne. 1) then
         call EllEqui(el, nOpEq(ii))
      end if
c      write(lo,'(i5)') i
c      write(lo,'(a,3f10.5,/,2(8x,3f10.5,/))') 'el(j,k)a:',
c     *   ((el(j,k),j=1,3),k=1,3)
      call RotEll(el)
c      write(lo,'(a,3f10.5,/,2(8x,3f10.5,/))') 'el(j,k)b:',
c     *   ((el(j,k),j=1,3),k=1,3)
!--- ellisse contorno
      rj(1) = 0.
      rj(2) = 0.
      rj(3) = 1.
      call MoltMatVec(el, rj, c)
      s(1) = 1.
      s(2) = 1.
      s(3) = -(c(1) + c(2)) / c(3)
      call NormVett(s, el, g)
c      write(lo,'(a,3f10.5)') 'g(j):',g
      call MoltMatVec(el, g, f)
      call ProVet(c, f, s)
      call NormVett(s, el, e)
c      write(lo,'(a,3f10.5)') 'e(j):',e
      n1 = 32
      n2 = (n1+5) / 10
      n = n1 / 4
      do 20 j=1, 3
         h(1,j) = g(j)
         h(1+n,j) = e(j)
         h(1+2*n,j) = -g(j)
         h(1+3*n,j) = -e(j)
   20 continue
      n11 = n1 - 1
      do 50 m=1, n2
         do 40 j=1, n11, n
            k = j + n
            if (k .ge. n1+1) k = 1
            do 30 l=1, 3
               s(l) = h(j,l) + h(k,l)
   30       continue
            call NormVett(s, el, e)
            jj = j + n / 2
            h(jj,1) = e(1)
            h(jj,2) = e(2)
            h(jj,3) = e(3)
   40    continue
         n = n / 2
   50 continue
      ff = xyz(3,i)
      FatK = -ff / ViewDist + 1
      call hToPix(n1, h, FatK, ii, CC, 1)
!--- disegna i semiassi
      do 90 k1=1, 3
         do 70 j=1, 3
            rj(j) = cd(j,k1,i)
  70     continue
         if (nOpEq(ii)/1000 .ne. 1) then
            call CDEqui(rj, nOpEq(ii))
         end if
         call MoltMatVec(BTot, rj, f)
         call NormVett(f, el, e)
         call EllPrincE(f, c, el, FatK, ii, CC)
         if (e(3) .le. 0.) then
            e(1) = -e(1)
            e(2) = -e(2)
         end if
         ix = ipix(1,ii)
         iy = ipix(2,ii)
         xx1 = xyz(1,ii) + e(1)
         yy1 = xyz(2,ii) + e(2)
         ix1 = nint(( xx1/FatK + x11disp(1) ) * x11scale(1))
         y = ( yy1/FatK + x11disp(2) ) * x11scale(2)
         iy1 = iVP(4) - nint(y)
!         call Linea(ix, iy, ix1, iy1, iCol(ii))
         call Linea(ix, iy, ix1, iy1, CC)
   90 continue
! ---
      return
      end
! -----------------------------------------------------------------
      subroutine EllPrincE(rj, c, el, FatK, i, CC)
      real rj(3),c(3),g(3),e(3)
      real s(3),h(128,3),el(3,3)
      integer CC
! ---
      call ProVet(c, rj, s)
      call NormVett(s, el, g)
      call MoltMatVec(el, g, e)
      call ProVet(rj, e, s)
      call NormVett(s, el, e)
      if (e(3) .le. 0.) then
         e(1) = -e(1)
         e(2) = -e(2)
         e(3) = -e(3)
      end if
      n1 = 17
      n2 = (2*n1 + 5) / 10
      n = n1/2
      do 80 j=1, 3
         h(1,j) = g(j)
         h(1+n,j) = e(j)
         jj = 2*n+1
         h(jj,j) = -g(j)
   80 continue
      do 110 m=1, n2
         n1n = n1-n
         do 100 j=1,n1n,n
            k = j+n
            do 90 l=1, 3
               s(l) = h(j,l) + h(k,l)
   90       continue
            call NormVett(s, el, e)
            jj = j + n/2
            h(jj,1) = e(1)
            h(jj,2) = e(2)
            h(jj,3) = e(3)
  100    continue
         n = n/2
  110 continue

      call hToPix(n1, h, FatK, i, CC, 2)
! ---
      return
      end
! -----------------------------------------------------------------
      subroutine ProVet(a, b, c)
      dimension a(3), b(3), c(3)
! ---
      c(1) = a(2)*b(3) - a(3)*b(2)
      c(2) = a(3)*b(1) - a(1)*b(3)
      c(3) = a(1)*b(2) - a(2)*b(1)
! ---
      return
      end
! -----------------------------------------------------------------
      subroutine hToPix(n1, h, FatK, i, CC, iAction)
      USE Molcom
! ---
      real h(128,3)
      integer CC
!
      iColor = CC
      do 55 j=1, n1
         a = ( (xyz(1,i)+h(j,1))/FatK + x11disp(1) ) * x11scale(1)
         b = ( (xyz(2,i)+h(j,2))/FatK + x11disp(2) ) * x11scale(2)
         ixv(j)=nint(a)
         iyv(j)=iVP(4) - nint(b)
   55 continue
!
      if (iAction .eq. 1) then
         iz = n1
         jFill = 1
         iClr = jBackGround
         call Poligono(iz,iClr,jFill)
         jFill = 0
         call Poligono(iz,iColor,jFill)
      else
         iz = n1
         jFill = -1
         call Poligono(iz,iColor,jFill)
      end if
!
      return
      end
!------------------------------------------------------------------
      subroutine AllStars
      USE General
      USE Atomi, only : nzTot
      USE Molcom
!
!-- Draw all stars
!
      do JJ = 1 , NatMol + NatSpi
         IJ = iOrd(JJ)
         IJ = JJ
         if (IJ .le. NatMol) then
             if (RS(IJ) .GT. 0) then
                 if (nzTot(IJ) == PiccoFour) then
                     ix = ipix(1, IJ)
                     iy = ipix(2, IJ)
                     call Star(ix,iy)
                 end if
             endif
         endif
      enddo
!
      return
      end
!------------------------------------------------------------------
      subroutine enantiomorph()
      USE General
      USE Riflessi
      USE Symmetry
      USE Atomi
      USE Molcom
      USE PhaseModule
!
      implicit none
      integer :: i, j, k, interp, iAction, lnz, fase, nExitCode
      integer :: iz, ksubr, iPlt, ifSingle, ier, nsetFinalPhases, nset
      real    :: fig(11)
!
      if (icent.eq.1) then
          Msg = 'No enantiomorph in centrosymmetric structures !!!'
          call MsgWinErr('Warning', Msg, WARN_WINDOW, nExitCode)
      else
!
!-- Invert coordinates
!
          do i=1,nats
             do j=1,3
                xyzs(j,i) = 1.0 - xyzs(j,i)
             enddo
          enddo
          interp = 1
          call PutGetXyzs(1, interp)
          if (InfoOK(5).ne.0) then
              iAction = 0
              do i=1, nats
                 Labb = aLab(i)
                 lnz = iabs(nz(i)) / nzConst
                 do k=1,5
                    VetChanges(k) = xyzs(k,i)
                 enddo
                 VetChanges(6) = bfac(i)
                 call ModModel(i,iAction,Labb,lnz,VetChanges)
              enddo
          endif
!
!-- Invert values for phases in memory
!
          if (InfoOK(6) > 0) then
              do i=1, nreflDim
                 fase = iphaz(i)
                 fase = mod(-fase + 3600, 360)
                 iphaz(i) = fase
              enddo
              ksubr = 4
              call AggiornaFasiPesiNew(ksubr, wt, iphaz, fcvet)
!
!-- Invert values for phases stored
!
          if (InfoOK(17) > 0) then
              call LoadFinalPhases(FomsFineDSR, iposFineDSR,
     *                                nsetFinalPhases)
              do j=1, nsetFinalPhases
                 nset = iposFineDSR(j)
                 call PutGetFinalPhases(2, nset, fig)
                 if (nint(fig(1)) == numbrun) then
                     do i=1, nreflDim
                        fase = iphaz(i)
                        fase = mod(-fase + 3600, 360)
                        iphaz(i) = fase
                     enddo
                     call PutGetFinalPhases(1, nset, fig)
                 endif
              enddo
          endif
!
!-- Reload phases
!
              ksubr = 4
              call LeggiRiflessi(ier, ksubr)
          endif
!
          iPlt = iPlotType
          ifSingle = 1
          call MolPlo(iPlt, ifSingle)
          iz = 0
          call EnableSingleIteration(iz)
      endif
!
      return
      end
! -------------------------------------------------------------------
      subroutine Trasforma_Modello(rotMat, traMat)
      USE General
      USE Riflessi
      USE Symmetry
      USE Atomi
      USE Molcom
      USE PhaseModule
!
      real rotMat(3,3), traMat(3), xeq(3)
!
      do i=1,nats
         do l=1,3
            xeq(l)=traMat(l)
            do j=1,3
               xeq(l)=xeq(l)+xyzs(j,i)*rotMat(l,j)
            enddo
         enddo
         xyzs(1:3,i) = xeq(1:3)
      enddo
      interp = 1
      call PutGetXyzs(1, interp)
      if (InfoOK(5) /= 0) then
          iAction = 0
          do i=1, nats
             Labb = aLab(i)
             lnz = iabs(nz(i)) / nzConst
             do k=1,5
                VetChanges(k) = xyzs(k,i)
             enddo
             VetChanges(6) = bfac(i)
             call ModModel(i,iAction,Labb,lnz,VetChanges)
          enddo
      else
          call UpdateCommonAndList5(ier)
      endif
!
!-- Re-compute phase values (if we have reflections)
!
      if (InfoOK(6) /= 0) then
          nzsav(1:nats) = nz(1:nats)
          nz(1:nats) = nz(1:nats) / nzConst

          iref  = 0
          mode  = 1
          numb = nreflDim
          ifBreak = 0
          iCoeff = 2
          call sftryyyc(iref,mode,numb,scalan,ifBreak,iCoeff)
          RSir = erre * 100.0
          ksubr = 4
          call AggiornaFasiPesiNew(ksubr, wt, iphaz, fcvet)
      endif
!
      iPlt = iPlotType
      ifSingle = 1
      call MolPlo(iPlt, ifSingle)
      iz = 0
      call EnableSingleIteration(iz)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine DisegnaCellaRods(RaggioRodCell)
      USE Atomi
      USE Molcom
!
      dimension  kSpi(12,2)
      integer RaggioRodCell
!
!      if (RaggioRodCell.lt.2) then
!          RaggioRodCell = 2
!      endif
      kSpi( 1,1) = NatMol + 1
      kSpi( 1,2) = NatMol + 4
      kSpi( 2,1) = NatMol + 1
      kSpi( 2,2) = NatMol + 5
      kSpi( 3,1) = NatMol + 1
      kSpi( 3,2) = NatMol + 6
      kSpi( 4,1) = NatMol + 2
      kSpi( 4,2) = NatMol + 4
      kSpi( 5,1) = NatMol + 2
      kSpi( 5,2) = NatMol + 5
      kSpi( 6,1) = NatMol + 2
      kSpi( 6,2) = NatMol + 7
      kSpi( 7,1) = NatMol + 3
      kSpi( 7,2) = NatMol + 4
      kSpi( 8,1) = NatMol + 3
      kSpi( 8,2) = NatMol + 6
      kSpi( 9,1) = NatMol + 3
      kSpi( 9,2) = NatMol + 7
      kSpi(10,1) = NatMol + 8
      kSpi(10,2) = NatMol + 5
      kSpi(11,1) = NatMol + 8
      kSpi(11,2) = NatMol + 6
      kSpi(12,1) = NatMol + 8
      kSpi(12,2) = NatMol + 7
!
      ifHB = 0
      do j=1,12
         N1 = kSpi(j,1)
         N2 = kSpi(j,2)
         call BiLegame(ifHB, N1, N2, RaggioRodCell, 0)
      enddo
!
      return
      end
! -----------------------------------------------------------------
      subroutine Genera_aided(kplt)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Poliedri
!
      common/symcon/natsym,idoppiodi,iopsym(1000),ipolim
     1,asmin(3),asmax(3),incella(10000),idoppiodit
     
      dimension xo(3), xeq(3), ncellc(3)
!
      call ResetLabelPos()
      k=1
      do i=1,3
         do j=1,3
         gdist(k)=xgg(i,j)
         k=k+1
         enddo
      enddo

      if (kplt.lt.0) then
          kplt = -kplt
          j = 0
          do i=1,nAided
            if (i.ne.kplt) then
                j = j + 1
                jAided(j) = jAided(i) 
            endif
          enddo
          nAided = nAided - 1
      else
          nAided = nAided + 1
          jAided(nAided) = kplt
      endif
!
      do i = 1, NatInd
         xyz(1, i) = xyzs(1,i)
         xyz(2, i) = xyzs(2,i)
         xyz(3, i) = xyzs(3,i)
         iEqui(i) = i
         nOpEq(i) = 1555
      enddo
!
      natot = NatInd
      do i=1,nAided
         jplt      = jAided(i)
         ksym      = jplt / 1000
         jplt      = jplt - ksym * 1000
         ncellc(1) = jplt / 100
         jplt      = jplt - ncellc(1) * 100
         ncellc(2) = jplt / 10
         jplt      = jplt - ncellc(2) * 10
         ncellc(3) = jplt
         ncellc(1) = ncellc(1) - 5
         ncellc(2) = ncellc(2) - 5
         ncellc(3) = ncellc(3) - 5
         do j=1,NatInd
            if (nz(j) > 0) then
                if (RS(iEqui(j)) > -10.) then
                    xo(1:3) = xyzs(1:3,j)
                    k = -1
                    call xequiTot(ksym, xo, xeq, k)
                    do l=1,3
                       xeq(l) = xeq(l) + ncellc(l)
                    enddo
                    idop = iDoppio (natot, xeq)
                    if (idop == 0) then
                       natot = natot + 1
                       xyz(1:3, natot) = xeq(1:3)
                       iEqui(natot) = j
                       nOpEq(natot) = jAided(i)
                    endif
                endif
            endif
         enddo
      enddo
!
      NATV = 0
      do na = 1, natot
         ieq = iEqui(na)
         Lab(na) = Lab(ieq)
!
         iOrd(na)= i
         nzTot(na) = nzTot(ieq)
         SinglePlotType(na) = SinglePlotType(ieq)
!
         rMLU(na) = rMLU(ieq)
         RS(na) = RS(ieq)
         if (RS(na) .gt. 0) NATV = NATV + 1
         iCol(na) = iCol(ieq)
         xo(1:3) = xyz(1:3, na)
         xyztot(1:3,na) = xyz(1:3, na)
         call MoltMatVec(rm,xo,xeq)
         xyz(1:3, na) = xeq(1:3)
      enddo
!
      NatMol = natot
      if (NatMol.gt.NatInd) then
          ifCont = 1
      else
          ifCont = 0
      endif
!
      call AggiuSpig
!
      call RotazTot
!
      call BuildBonds(3)
!
      Rmin1 = 99999.
      Rmin2 = 99999.
      RMAX1 = -99999.
      RMAX2 = -99999.
!
      call SetScale(0)
      call FindMinMax
      call Disegna(ifScale)
!
      return
      end
! -----------------------------------------------------------------
      subroutine UpdateBondTable()
      USE General
      USE Atomi, only : nzTot
      USE Molcom
!
      real cBondTable(2,18,18), cRadii(18,2)
!
!-- Take into account the already defined bonds to update the table
!
      ifModified = 0
      do i=1,NumLeg
         N1 = LE(1,i)
         N2 = LE(2,i)
         N3 = LE(3,i)
         if (N1.le.NatMol.and.N2.le.NatMol) then
             iz1 = nzTot(N1)
             iz2 = nzTot(N2)
             DIS = 0
             do K = 1 , 3
                DR = xyz(K,N1) - xyz(K,N2)
                DIS = DIS + DR * DR
             enddo
             DIS = SQRT(DIS)
             if (DIS.lt.BondTable(1,iz1,iz2)) then
                 BondTable(1,iz1,iz2) = DIS
                 BondTable(1,iz2,iz1) = DIS
                 ifModified = 1
             endif
             if (DIS.gt.BondTable(2,iz1,iz2)) then
                 BondTable(2,iz1,iz2) = DIS
                 BondTable(2,iz2,iz1) = DIS
                 ifModified = 1
             endif
         endif
      enddo
!
      if (ifModified == 1 ) then
!         update BondTable in binary file       !  RICCARDO
          cBondTable(:,:,:) = BondTable(:,:,:)
          cRadii(:,:)       = Radii(:,:)
          call updBondTable(cBondTable, cRadii)
!
      endif
!
      return
      end
! -----------------------------------------------------------------
      subroutine DisegnaAddAtom
      USE General
      USE Molcom
!      
!-- distance
      ix1 = ipix(1,NatMol)
      iy1 = ipix(2,NatMol)
      ix2 = ipix(1,iCl1)
      iy2 = ipix(2,iCl1)
      call Linea_dash (ix1, iy1, ix2, iy2, icoWire)
      ixv(1) = ix1 + (ix2 - ix1) / 2 + 10
      iyv(1) = iy1 + (iy2 - iy1) / 2 + FntPixHeight / 2
      call DrawLabel(ixv(1), iyv(1), 'D', icoWire, 2)
!-- bond angle
      ix1 = ipix(1,iCl1)
      iy1 = ipix(2,iCl1)
      ir = 30
      iniz = nint(gamma*RtoD)
      ifin = nint(ang_b)
      call Arco_dash (ix1, iy1, ir, iniz, ifin, icoWire)
      ixv(1) = nint(ix1 + ir * 1.25 * cos(gamma+ ang_b/2*DtoR))
      iyv(1) = nint(iy1 - ir * 1.25 * sin(gamma+ ang_b/2*DtoR))
      call DrawLabel(ixv(1), iyv(1), 'B', icoWire, 2)
!-- torsion angle
      tanT = abs( tan(gamma) )
      iEnd = 180
      iRaggio = 4
      ix1 = ipix(1,iCl1)
      iy1 = ipix(2,iCl1)
      ix2 = ipix(1,iCl2)
      iy2 = ipix(2,iCl2)
      ixT = ix1 + 2 * (ix2 - ix1) / 3
      iyT = iy1 + 2 * (iy2 - iy1) / 3
      if (tanT.lt.1.0) then
          iAsseY = iRaggio * 4
          idx = 0
          idy = -iAsseY * 2
      else
          iAsseX = iRaggio * 4
          idx = iAsseX * 2
          idy = 0
      endif
      ixv(1) = ixT + idx
      iyv(1) = iyT + FntPixHeight / 2 + idy
      call DrawLabel(ixv(1), iyv(1), 'T', icoWire, 2)

!-- bonds
      do i=1, NumLeg - nlp
         if (LE(3, i).ge.0) then
             N1 = LE(1, i)
             N2 = LE(2, i)
             if (RS(N1).gt.0.and.RS(N2).gt.0) then
                 iN1 = SinglePlotType(N1)
                 iN2 = SinglePlotType(N2)
                 Nll = i
                 if (iN1 <= SIMPLE .or. iN2 <= SIMPLE) then
                     ifSolidLeg = 0
                     call DisLeg()
                 else
                     ifSolidLeg = 1
                     ix1 = ipix(1,N1)
                     iy1 = ipix(2,N1)
                     ix2 = ipix(1,N2)
                     iy2 = ipix(2,N2)
                     iColor = color_BONDS
                     call LineaSfumata(ix1, iy1, ix2, iy2, 
     *                                 iColor, iRaggio)
                 endif
             endif
         endif
      enddo
      if (tanT.lt.1.0) then
          iAsseX = iRaggio * 2
          iAsseY = iRaggio * 4
          iSt = 270
      else
          iAsseX = iRaggio * 4
          iAsseY = iRaggio * 2
          iSt = 180
      endif
      call Ellisse_dash (ixT, iyT, iAsseX, iAsseY, iSt, iEnd, icoWire)
      if (tanT.lt.1.0) then
          ixv(1) = ixT - iRaggio*2
          iyv(1) = iyT + iAsseY
          ixv(2) = ixv(1) + iRaggio*2
          iyv(2) = iyv(1) - iRaggio
          ixv(3) = ixv(1) + iRaggio*2
          iyv(3) = iyv(1) + iRaggio
      else
          ixv(1) = ixT + iAsseX
          iyv(1) = iyT - iRaggio*2
          ixv(2) = ixv(1) - iRaggio
          iyv(2) = iyv(1) + iRaggio*2
          ixv(3) = ixv(1) + iRaggio
          iyv(3) = iyv(1) + iRaggio*2
      endif
      iz = 3
      jFill = 0
      call Poligono(iz,icoWire,jFill)
      call zflush
!
      return
      end
!-----------------------------------------------------------------------
      subroutine WriteAtomsInfo(ifSFC)
      USE General
      USE Atomi
      USE PhaseModule
      USE TestModel
!
      character (len=2)  :: specie
      character (len=2) :: PubSpec
      character (len=5)  :: dividedc
!
      divided  = 1.0
      dividedc = '*10  '
!
      if (knw == 1) then
          call to_coord_sir(-1,nrefl)
          write(lo,10) dividedc
      else
          write(lo,20) dividedc
      endif
      nzSav(1:nats) = nz(1:nats)
      do i=1, nats
         k = nint( xyzs(4,i) / divided )
         lnz = iabs(nz(i))
         kfrag = mod(lnz, nzConst)
         lnz = lnz / nzConst
         nz(i) = lnz
         if (lnz == 0) then
             specie(1:2) = 'Q '
         else
             write(specie(1:2),'(a2)') nalf(lnz)
         endif
         call ucase(specie(1:1))
         if (knw == 1) then
             n3 = npunt(i)
             if (n3 > 0) then
                 n3 = nzPub(n3)
                 PubSpec = Species(n3)
                 call ucase(PubSpec(1:1))
             else
                 PubSpec = '--'
             endif
             L = Lung(aLab(i))
             Labb = aLab(i)(1:L) // ' (' // PubSpec // ')'
             write(lo,30) i,specie,Labb,k,(xyzs(j,i),j=1,3),
     *                         xyzs(5,i),bfac(i),kfrag
         else
             write(lo,40) i,specie,aLab(i),k,(xyzs(j,i),j=1,3),
     *                         xyzs(5,i),bfac(i),kfrag
         endif
      enddo
!
      if (ifSFC == 1) then
          iref  = 0
          mode  = 1
          numb = nrefl
          ifBreak = 0
          iCoeff = 2
          call sftryyyc(iref,mode,numb,scalan,ifBreak,iCoeff)
          write(lo,45) erre*100.0
      endif
      if (knw == 1) then
          write(Msg,50)  nint(vett_test(1)), nats, nint(vett_test(3))
          call OneBlankOnly(Msg)
          write(lo,'(/,2x,a)') Msg(1:Lung(Msg))
          write(Msg,55) vett_test(4), erore, erorepes, isumal
          call OneBlankOnly(Msg)
          write(lo,'(2x,a)') Msg(1:Lung(Msg))
      endif
      nz(1:nats) = nzSav(1:nats)
!
      return
   10 format(/,' Serial Atom  Label       Height',a5,
     *         ' ','x',7x,'y',7x,'z',
     *         2x,'     Occ.   B[iso] Frag',/)
   20 format(/,' Serial Atom  Label   Height',a5,
     *         ' ','x',7x,'y',7x,'z',
     *         2x,'     Occ.   B[iso] Frag',/)
   30 format(' ',i4,')',3x,a2,3x,a12,i6,2x,3f8.3,f8.3,f8.2,i4)
   40 format(' ',i4,')',3x,a2,3x,a8,i6,2x,3f8.3,f8.3,f8.2,i4)
   45 format(/,' Final R value = ',f6.2,'%')
   50 format(i5,' atoms published,',i5,' used, ',i5,' found.')
   55 format(' <dist> =', f9.4,', MPE = ',f6.2,' (',f6.2,') using ',
     *    i8,' reflections.')
!
      return
      end
! -----------------------------------------------------------------
      subroutine Distance_pg(xcr, RScr, iAction)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
!
      common /Distanze/ ndist, dis(300), nop(300), ifDist
!g    common /AtomType/ nTp, kCentral, xyzTmp(3,5)
!
      common/symcon/natsym,idoppiodi,iopsym(1000),ipolim
     1,asmin(3),asmax(3),incella(10000),idoppiodit
     

      dimension xcr(3), d(3)
      
      Message = ' '
      ifDist = 1
      coef = 1.5
      iscr=0
      
         distmin = 99999.9
         ndist = 0
         if (ifCont.eq.0) then
            ifDentro = 1
            iUno = 1
            call Genera(ifDentro, iUno)
         end if
         do 56 nf=1,NatMol  !  Gen
            RSnf = abs(RS(nf))
            if (RSnf.lt.5.0) then
!                dist = 0.
!                do 52 i=1,3
!                   dist = dist + (xcr(i)-xyz(i,nf))**2
!   52           continue
!                dist = sqrt(dist)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
                do i = 1, 3
                   d(i)=xcr(i) - xyztot(i,nf)
                enddo
                dist = cdist(gdist,d,ddummy)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
                iOK = 1
                DistMax = RaggioSfera
                if (dist .gt. DistMax) then
                   iOK = 0
                end if
               write(6,14) xcr(1:3),
     *                     lab(nf),nf,xyz(1:3,nf),dist,distmax,iOK
  14  format(3f10.3,4x,a,2x,i5,3f10.3,2x,2f10.3,i4)
                if (iOK .eq. 1) then
                   ndist = ndist + 1
                   dis(ndist) = dist
                   kptr(ndist) = nf
                else
                   if (dist.lt.distmin) then
                      distmin = dist
                      jf = nf
                   endif
                endif
            endif
   56    continue
         if (ndist .eq. 0) then
            ndist = 1     !  commentate - gianluca - 28/06/2003
            dis(1) = distmin
            kptr(1) = jf
            ifDist = 0
            ifFound = 0
         else
            ifFound = 1
         end if
         do 70 i=1,ndist-1
            do 60 j=i+1,ndist
               if (dis(j).lt.dis(i)) then
                  idu = kptr(i)
                  kptr(i) = kptr(j)
                  kptr(j) = idu
                  dum = dis(i)
                  dis(i) = dis(j)
                  dis(j) = dum
                end if
   60       continue
   70    continue
         if (iaction.eq.3) then
            if (dis(1).lt.0.6) then
               kptr(3) = nint(dis(1)*10000.)     !pg210807
               kptr(2) = iEqui(kptr(1))
               kptr(1) = -iabs(kptr(1))
            end if
            goto 100
         end if
!
  200 format(' Distance ',a,'- ',a,' = ',f7.4)
!
  100 khead = 0
      if (ifCont.eq.0) then
         call SoloInd(NatInd)
      end if
      return
  300 format(' Sorry ....   no selection !')
      end
!-----------------------------------------------------------------------
      subroutine AggiungeConnettivita(iAction, ier)
      USE General
      Use Atomi
      USE Molcom
!
      implicit none
      integer ier, iAction, interp, lsn, ifLi5, ljxx, lkxx, llxx, i, lnz
      real SumColor, aaaa
!
      if (iabs(nz(1)) < (nzConst -1)) then
          nz(1:nats) = nz(1:nats) * nzConst
      endif
      iconn(1) = -9999
      kblock(:) = 1
      call build(iAction, 2)
      call PutModel
      interp = 1
      call PutGetXyzs(1, interp)
      kblock(:) = 0
!
      return
      end
! ----------------------------------------------------------------------------------------------
! ----------------------------------------------------------------------------------------------
! ----------------------------------------------------------------------------------------------
! ----------------------------------------------------------------------------------------------
! ----------------------------------------------------------------------------------------------
! ----------------------------------------------------------------------------------------------
!                   ZONA "MEGLIO_NON_BUTTARE_NIENTE_SI_SA_MAI"
! ----------------------------------------------------------------------------------------------
! ----------------------------------------------------------------------------------------------
! ----------------------------------------------------------------------------------------------
! ----------------------------------------------------------------------------------------------
! ----------------------------------------------------------------------------------------------
! ----------------------------------------------------------------------------------------------
!
!routine anteriori al 1set.2008 (_ex)
c------------------------------------------------------------------------
!-----------------------------------------------------------------------
!
!code for menubuild
      subroutine menubuild(ifDentro,iUno,kbuild,nadd)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Poliedri
!
      real BondTableSav(2,18,18)
!
      common/symcon/natsym,idoppiodi,iopsym(1000),ipolim
     1,asmin(3),asmax(3),incella(10000),idoppiodit
!gianluca     1,natfrag(2000)
      common/buildmolec/natfrag(5000),nfraleg(20000),baric(3,5000)
     1,lunghezzafra(5000),minerale
     
      dimension ShfMerc(3,4),jcond(10000),mfrag(10000),cxc(3),iabcxc(3)
     1,a(3),x1(3),r1(3),jsf(3,2),cb(3)
!
      call ResetLabelPos()
      
      BondTableSav(:,:,:) = BondTable(:,:,:)
      call UpdateBondTable()
      ia=0
      if(ia.ne.0)then
         natsym=0
         idoppiodi=0
         idoppiodit=0
         iopsym=0
         ipolim=0
         incella=0
         natfrag=0
         nfraleg=0
         baric=0.
         lunghezza=0
         ipix(:,:)=0
         do i = 1, NatMol
           call DoSingleIteration()
           xyz(1:3, i) = xyzs(1:3,i)
           incella(i)=0
           nOpEq(i) = 11000
           iEqui(i)=i
         enddo
         call build_frammenti(nadd)
!
         NATV = 0
         do na = 1, NatMol
            ieq = iabs(iEqui(na))
            iOrd(na)= na
            nzTot(na) = nzTot(ieq)
            SinglePlotType(na) = SinglePlotType(ieq)
            rMLU(na) = rMLU(ieq)
            RS(na)=RS(ieq)
            if (RS(na) .gt. 0) then 
                NATV = NATV + 1
            endif
            iCol(na) = iCol(ieq)
            xyztot(1:3,na) = xyz(1:3, na)
            x1(1:3) = xyz(1:3, na)
            call MoltMatVec(rm,x1,r1)
            if(kbuild.ne.2)xyz(1:3, na) = r1(1:3)
         enddo
         nadd=NATV
!
      else
         ifmenubuild=1
         call NewAppSym(ifmenubuild)
      endif
!------------------------------------------------------------------------

      kkpri=1
      if(kkpri.eq.0)then
      write(lo,*)
     *   'i,xyztot(1:3,i),RS(i),iEqui(i),nOpEq(i),ipix(1:3,i)'
      do i = 1, NatMol
       write(lo,'(i5,4f7.3,5i7)')i,xyztot(1:3,i),RS(i),iEqui(i),nOpEq(i)
     1     ,ipix(1:3,i)
      enddo
!     do j=1,NumLeg
!     write(lo,*)'j,LE(1:3,j)',j,LE(1:3,j)
!     enddo
      endif
!------------------------------------------------------------------------
!      call AggiuSpig
!      if(iuno.eq.1)then
!      call RotazTot
!      call BuildBonds(2)
!      endif
!
      Rmin1 = 99999.
      Rmin2 = 99999.
      RMAX1 = -99999.
      RMAX2 = -99999.
      return
      end
!
      subroutine AutoBuild()
      USE General
      USE Molcom
      use Atomi 
      USE BuildStuff
      USE BuildModule
!    
      call UpdateCommonAndList5(ier)
!
      ia=0
      if(ia.ne.0)then
      ifDentro = 0
      iUno = 1
      kbuild=1
      nAdd=0
!      call Genera(ifDentro,iUno)
!      call GeneraAppSym(ifDentro,iUno,kbuild,nadd)
      call menubuild(ifDentro,iUno,kbuild,nAdd)
      do i=1,3
         DeA(i) = DeaDef(i)
      enddo
!
      call SetScale(0)
      call FindMinMax
      call Disegna(ifScale)
!
        if (nAdd.gt.0) then
          ifCont = 1
          write(Msg,10) nAdd
   10     format(i5,' equivalent atoms added to the asymmetric unit')
          call MsgWinErr('Automatic Build', Msg, INFO_WINDOW, nExitCode)
        else
          Msg = ' No equivalent atoms added to the asymmetric unit'
          call MsgWinErr('Automatic Build', Msg, WARN_WINDOW, nExitCode)
          call SoloInd(NatInd)
          ifCont = 0
        endif
      else
      ifmenubuild=1
      call NewAppSym(ifmenubuild)
!
      call SetScale(0)
      call FindMinMax
      call Disegna(ifScale)
!
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Cubo
      USE General , only : cell
      USE Molcom
      USE PhaseModule
      USE FastPlot
!
      implicit none
      integer :: i, j, k, jx1, jy1, LineStyle
      integer :: raggio, filled, width, hwidth, hwwidth, numVert, colore
      real    :: a, b, c, f, FatK,xyzCuboCryst(3)
      real    :: x1(3), x2(3), shift(3), latoXyz(3)
      integer :: ifNewPage
!
!                  2----------------5
!                 /|               /|
!                / |              / |
!               /  |             /  |
!              /   |            /   |
!             /    |           /    |
!            7----------------8     |
!            |     |          |     |
!            |     4----------|-----1
!            |    /           |    /
!            |   /            |   /
!            |  /             |  /
!            | /              | /
!            |/               |/
!            3----------------6
!
      if (ifCubo == 0 .or. ifCubo == 1) then
          if (xyzCubo(1) > 9999) then
              shift(:) = 0.0
              do i=1, NatMol
                 shift(1) = shift(1) + xyz(1,i)
                 shift(2) = shift(2) + xyz(2,i)
                 shift(3) = shift(3) + xyz(3,i)
              enddo
              xyzCubo(:) = shift(:) / float(NatMol)
*             xyzCubo(:) = xyz(:,6)
              call MoltMatVec(rmi, xyzCubo, xyzCuboCryst)
*             write(0,*) 'xyzCuboCryst(:)',xyzCuboCryst(:)
              ifCubo = 0
          endif
!
          if (ifCubo == 0) then
              ifCubo = 1
              latoXyz(1:3) = latoCubo / cell(1:3)
!
!-- build the cube
!
              coordCubo(:,:) = 0.0
              coordCubo(1,1) = latoXyz(1)
              coordCubo(2,2) = latoXyz(2)
              coordCubo(3,3) = latoXyz(3)
              coordCubo(1,5) = latoXyz(1)
              coordCubo(2,5) = latoXyz(2)
              coordCubo(1,6) = latoXyz(1)
              coordCubo(3,6) = latoXyz(3)
              coordCubo(2,7) = latoXyz(2)
              coordCubo(3,7) = latoXyz(3)
              coordCubo(1,8) = latoXyz(1)
              coordCubo(2,8) = latoXyz(2)
              coordCubo(3,8) = latoXyz(3)
              coordCubo(1,9) = latoXyz(1) / 2.0
              coordCubo(2,9) = latoXyz(2) / 2.0
              coordCubo(3,9) = latoXyz(3) / 2.0
!
              do i=1,9
                 x1(:) = coordCubo(:,i)
                 call MoltMatVec(rm, x1, x2)
                 coordCubo(:,i) = x2(:)
              enddo
!
!-- Rotate/translate the cube according to the model
!
              do k=1, 9
                 x1(:) = coordCubo(:,k)
                 do i=1, 3
                    x2(i) = 0
                    do j=1, 3
                       x2(i) = x2(i) + BTot(i, j) * x1(j)
                    enddo
                 enddo
                 coordCubo(:,k) = x2(:)
              enddo
!
!-- move the cube in the desired position
!
              shift(:) = xyzCubo(:) - coordCubo(:,9)
              do i=1,9
                 coordCubo(:,i) = coordCubo(:,i) + shift(:)
                 xyz(:, NatMol + NatSpi + i) = coordCubo(:,i)
              enddo
              f = coordCubo(3,9)
              FatK = -f / ViewDist + 1
              a = ( coordCubo(1,9)/FatK + x11disp(1) ) * x11scale(1)
              b = ( coordCubo(2,9)/FatK + x11disp(2) ) * x11scale(2)
!!mr              ixCubo = nint(a)
!!mr              iyCubo = iVP(4) - nint(b)
          endif
!
      endif
      do i=1,9
         coordCubo(:,i) = xyz(:, NatMol + NatSpi + i)
      enddo
      xyzCubo(:) = coordCubo(:,9)
!
!-- Transform the coordinates of the cube in pixels
!
      do i=1,9
         j = NatMol + NatSpi + i
         f = coordCubo(3,i)
         FatK = -f / ViewDist + 1
         a = ( coordCubo(1,i)/FatK + x11disp(1) ) * x11scale(1)
         b = ( coordCubo(2,i)/FatK + x11disp(2) ) * x11scale(2)
         c =                     RS(1)/FatK * x11scale(1)
         ipxCubo(1,i) = nint(a)
         ipxCubo(2,i) = iVP(4) - nint(b)
         ipxCubo(3,i) = nint(c)
         ipix(:,j) = ipxCubo(:,i)
      enddo
*     else
*         do i=1,9
*            j = NatMol + NatSpi + i
*            ipxCubo(:, i) = ipix(:,j)
*         enddo
*     endif
!
      do i=1,9
         j = NatMol + NatSpi + i
         ipxCubo(:, i) = ipix(:,j)
      enddo
!!mr
              ixCubo = ipxCubo(1,9);
              iyCubo = ipxCubo(2,9);
!!mr

!
!-- draw cube
!
      colore = color_LIGHTBLUE
      j = 1
      do i=1, 12
         ix1(j)   = ipxCubo(1, legaCubo(i,1))
         iy1(j)   = ipxCubo(2, legaCubo(i,1))
         ix1(j+1) = ipxCubo(1, legaCubo(i,2))
         iy1(j+1) = ipxCubo(2, legaCubo(i,2))
         j = j + 2
      enddo
      i = 12
      LineStyle = 1                   !! dashed
      ifNewPage = 0
      call DrawSegments(i, colore, ix1, iy1, LineStyle, ifNewPage);
*        write(0,*) 'ipxCubo',ipxCubo(:,9)
!
*     if (ifCubo /= 2) then
          raggio = nint( RS(1) * x11scale(1) )
          filled = 0
          jx1 = ipxCubo(1,9)
          jy1 = ipxCubo(2,9)
!
!-- draw arrows
!
          width   = max0(raggio/6, 4)
          hwidth  = width / 2
          hwwidth = width + hwidth
          ixv( 1) = jx1            ; iyv( 1) = jy1 + raggio
          ixv( 2) = jx1 + width    ; iyv( 2) = jy1 + hwwidth
          ixv( 3) = jx1 + hwidth   ; iyv( 3) = iyv( 2)
          ixv( 4) = ixv( 3)        ; iyv( 4) = jy1 + hwidth
          ixv( 5) = jx1 + hwwidth  ; iyv( 5) = iyv( 4)
          ixv( 6) = ixv( 5)        ; iyv( 6) = jy1 + width
          ixv( 7) = jx1 + raggio   ; iyv( 7) = jy1
          ixv( 8) = ixv( 6)        ; iyv( 8) = jy1 - width
          ixv( 9) = ixv( 6)        ; iyv( 9) = jy1 - hwidth
          ixv(10) = ixv( 4)        ; iyv(10) = iyv( 9)
          ixv(11) = ixv( 4)        ; iyv(11) = jy1 - hwwidth
          ixv(12) = ixv( 2)        ; iyv(12) = iyv(11)
          ixv(13) = jx1            ; iyv(13) = jy1 - raggio
          ixv(14) = jx1 - width    ; iyv(14) = iyv(12)
          ixv(15) = jx1 - hwidth   ; iyv(15) = iyv(12)
          ixv(16) = ixv(15)        ; iyv(16) = iyv(10)
          ixv(17) = jx1 - hwwidth  ; iyv(17) = iyv(10)
          ixv(18) = ixv(17)        ; iyv(18) = iyv( 8)
          ixv(19) = jx1 - raggio   ; iyv(19) = iyv( 7)
          ixv(20) = ixv(18)        ; iyv(20) = iyv( 6)
          ixv(21) = ixv(18)        ; iyv(21) = iyv( 5)
          ixv(22) = ixv(16)        ; iyv(22) = iyv( 5)
          ixv(23) = ixv(16)        ; iyv(23) = iyv( 3)
          ixv(24) = ixv(14)        ; iyv(24) = iyv( 3)
!
          numVert = 24
          filled = 0
          call Poligono (numVert, colore, filled)
*     endif
!
      return
      end subroutine Cubo
! ----------------------------------------------------------------------
      subroutine PoligonoSh (numVert, iColore, nsh, nshmax)
      USE Molcom
! ---
      call PoligonoSfumato(numVert, iColore, nsh, nshmax, ixv, iyv)
      return
      end
! ----------------------------------------------------------------------
      subroutine CalcolaAngoloFract(x1, x2, x3, Ang)
      USE General
      USE Atomi
      USE Molcom
!
!--                      ^
!-- Compute angle    x1  x2  x3
!
      implicit none
      integer :: kk(3), j2, nvc, i, j, jj
      real    :: x1(3), x2(3), x3(3), xm(3), amat(3,3)
      real    :: Ang, rMod1, rMod2, rModuS, CosAng
!
      call MoltMatVec(rm, x1, xm)
      amat(1:3,1) = xm(1:3)
      call MoltMatVec(rm, x2, xm)
      amat(1:3,2) = xm(1:3)
      call MoltMatVec(rm, x3, xm)
      amat(1:3,3) = xm(1:3)
      kk(1:3) = (/ 1,   2,  3 /)
!
      j2 = 2
      nvc = 0
      do j=1, 3, 2
         nvc = nvc + 1
         jj = kk(j)
         do i=1, 3
            VV(nvc,i) = amat(i,jj) - amat(i,j2)
         enddo
      enddo
      rMod1 = sqrt(VV(1,1)**2+VV(1,2)**2+VV(1,3)**2)
      rMod2 = sqrt(VV(2,1)**2+VV(2,2)**2+VV(2,3)**2)
      rModuS = VV(1,1)*VV(2,1)+VV(1,2)*VV(2,2)+VV(1,3)*VV(2,3)
      CosAng = rModuS/(rMod1*rMod2)
      if (CosAng >  0.999999) CosAng = 0.999999
      if (CosAng < -0.999999) CosAng =-0.999999
      Ang = acos(CosAng) * RtoD
!
      return
      end
!------------------------------------------------------------------------------
