#include "mrconfig.h"
#include "aliasx.h"
#include "callbacks.h"
#include <gtkmrcomune.h>
#include <cmtzlib.h>
#include <csymlib.h>
#include <functional>
typedef char stringa5[9];
typedef std::vector<const CMtz::MTZCOL* > VMTZCOL;
typedef VMTZCOL::iterator VMTZCOL_it;
static VMTZCOL MtzValues, MtzEsds, MtzAllCols, MtzAllTypes;
static VMTZCOL MtzSelected;
static float EPS = 0.00001f;
#define MAX_MODELS 20
#define MAX_FRAGS  20
#define SIR_MAX_ELEMENTS 4
#define SIR_MAX_WAVES 4
static _StyleType FrameStyle = {true, 1, NULL, GTK_SHADOW_ETCHED_IN, 3, 3, 10, 3};
static _StyleType FrameStyle1 = {true, 1, NULL, GTK_SHADOW_NONE, 3, 3, 10, 3};

static int ktest;
//               0 --> new project
//               1 --> existing data
//               2 --> import

enum pagine {page_SPGR, page_GENERAL, page_CELL, page_MTZ, page_CONTENT,
             page_REFL, page_SOLVE, page_RUN};

//enum strategies {S_AUTO, S_MDM, S_DM, S_PATT, S_VLD, S_SA};
enum strategies {S_VOID, S_AUTO, S_MDM, S_DM, S_PATT, S_VLD, S_SA};
namespace main_app {
       extern Application TheApp;
                   }

extern "C" {
void  init_setbd_      (float bondtable[NUMSPECIES][NUMSPECIES][2],
                                       float radii[2][NUMSPECIES]);
void  finish_setbd_    (float bondtable[NUMSPECIES][NUMSPECIES][2],
                        float radii[2][NUMSPECIES], int *Action);
void  getformat_(char *fnam, char *formato, int *ifsigma, size_t l1, size_t l2);
}
void FillMtzVectors(gpointer mtzi);
void clear_mtz(int flag, GtkWidget *dlg);
void force_close_viewers();
void add_mtz_val(const char *val, int quale);
void update_mtzpage(GtkWidget *dlg);
void clear_windinfo(void);
void BuildSymmOps(CSym::CCP4SPG *spg, std::ostream &strm);
GtkWidget *i_Spg_Cell (GtkWidget *notebook, GtkWidget *new_project_dlg,
                       GCallback cb_func, const char *filspg);
int CheckSpace(GtkWidget *dialog, int spgnum, float symop_r[3], int ktest1);

static int    Res[6]    =  { 1,6,7,8,16,15};
static int    dime = 4;
static int    ifLaue = 1;
static int    MaxBlocks = 10;
static int    Neutro = 0;
//static int    blocchi_def[20];  
//static int    nblocchi_def;
static const char *cell_data[] = {"a:", "b:", "c:", "alpha:", "beta:", "gamma:",
                         "err_a:", "err_b:", "err_c:", "err_alpha:", 
                         "err_beta:", "err_gamma:", "Volume:"};
 static const char *CrystSystem[] = {"Automatic", "Triclinic", "Monoclinic a", "Monoclinic b", "Monoclinic c", "Orthorombic", "Tetragonal", "Hexagonal", "Cubic ", "Rhombohedric"};

enum PROCS {ZERO, REMO, SADMAD, AB_INITIO, REFINE};
enum MOLSZ {SERO, SMALL, MACRO};
//const char *procedures[]  = {"Dummy", "Ab initio / Simulated Annealing",
//                             "Molecular Replacement"};
const char *procedures[]  = {"Dummy", "Molecular Replacement", "SAD/MAD",
                             "Ab initio / Simulated Annealing", "Phase Refinement"};
const char *refls[]  = {"DummyR", "HKL file", "MTZ file"};
const char *molsizes[]  = {"DummyM", "Small Molecule", "Macro Molecule"};
const char *sources[]  = {"X Ray Data", "Neutron Data", "Electron Data"};
//const char *waves[]  = {"Cu", "Mo", "Other"};
const char *sfacs[]  = {"F(obs)", "F(obs)**2"};
const char *relstr[] = {"Automatic", "Always", "Never"};
const char *radio_mu[] = {"Molecular Weight:", "Number of residues:",
                          "Sequence\n(FASTA format):"};
const char *spin_mu[] = {"MolSpin", "ResiduesSpin"};
const char *combo_amb[] = {"Buccaneer", "Nautilus", "ARP/wARP", "Phenix"};
const char *combo_amb_prg[] = {"buccaneer_pipeline", "cnautilus", 
                               "auto_tracing.sh", "phenix.autobuild"};
static const gchar *Sizes[] = {"XS", "S", "M" , "L", "XL", "XXL", "HUGE", " "};
int nAmb = (int) (sizeof(combo_amb)/sizeof(combo_amb[0]));
const char *lb_phFrom[] = {"Molecular Replacement", "SAD/MAD", "Ab initio",
                    "Let the program to decide"};
const char *str_lb[] = {"MR", "MAD", "ABI", "PRG"};


static GdkColor colorYellow = Yellow;

extern    "C" _SWareRC  *SWareRC;
extern    _Dialogo  *dialogo;
extern    "C" _Project  *prj;

extern "C" int   get_content_from_formula_(char *param, int Amount[], int Z[],
                    size_t idum);
#include <fstream>
#include <sstream>
#include <iomanip>

typedef struct {
                GtkWidget *entry;
                GtkWidget *browse;
                GtkWidget *view;
                GtkWidget *title;
                GtkWidget *spg;
                GtkWidget *find;
                GtkWidget *cell;
                GtkWidget *hint;
                GtkWidget *columns;
                GtkWidget *del;
                GtkWidget *vcombo;
                GtkWidget *esdcombo;
                GtkWidget *add;
                GtkWidget *allcols;
                GtkWidget *addcol;
                char *mtzfile;
                int quale;
              } _MyMTZ;

typedef struct {
                 GtkWidget *frame;
                 GtkWidget *PDBentry;
                 GtkWidget *nMonomers;
                 GtkWidget *hetero;
                 GtkWidget *PDBradio;
                 GtkWidget *Wilsonradio;
                 GtkWidget *p20radio;
//                 GtkWidget *seqradio;
//                 GtkWidget *rmsradio;
                 GtkWidget *seqid_check;
                 GtkWidget *entry;
                 GtkWidget *polycheck;
                 GtkWidget *cutmodel;
                 GtkWidget *fromres;
                 GtkWidget *tores;
                 GtkWidget *rotfix;
                 GtkWidget *rot1;
                 GtkWidget *rot2;
                 GtkWidget *rot3;
                 GtkWidget *transfix;
                 GtkWidget *trans1;
                 GtkWidget *trans2;
                 GtkWidget *trans3;
                 GtkWidget *edm;
                 GtkWidget *edmspin;
               } MRmodel;

typedef struct {
                 GtkWidget *manres;
                 GtkWidget *autores;
                 GtkWidget *minres;
                 GtkWidget *maxres;
                 GtkWidget *mantres;
                 GtkWidget *autotres;
                 GtkWidget *rot;
                 GtkWidget *rotlocal;
                 GtkWidget *trans;
                 GtkWidget *translocal;
//                 GtkWidget *vldcheck;
//                 GtkWidget *flcheck;
//                 GtkWidget *ambcheck;
//                 GtkWidget *ambcombo;
               } MRtask;

static const gchar *sizes[] = {"XS: Very Small", "S: Small", "M: Medium" ,
                         "L: Large", "XL: Very Large", "XXL: Very Very Large",
                         "HUGE: Big Protein", "Let the program to decide"};
static int nsizes = G_N_ELEMENTS(sizes);
static int    real_dime = nsizes;

static const gchar *labsizes[] =
  {"< 6 non-H atoms in asymmetric unit             ",
   "6-80 non-H atoms in asymmetric unit          ",
   "81-300 non-H atoms in asymmetric unit        " ,
   "301-600 non-H atoms in asymmetric unit      ",
   "601-1000 non-H atoms in asymmetric unit     ",
   "1001-1750 non-H atoms in asymmetric unit  ",
   "> 1750 non-H atoms in asymmetric unit         ",
   " "};


class eq : public std::unary_function< const CMtz::MTZCOL * , bool >
{
  private:
    const char *label;
  public:
    eq(const char *nm) {label=nm;}
    result_type operator( ) ( argument_type col )
    {
        return ( result_type ) ( std::strcmp(col->label, label)==0 );
    }
};

VMTZCOL_it get_mtz_col(VMTZCOL &v, const char *nm)
{
    return
    std::find_if(v.begin(), v.end(), eq(nm) );
}

int IsValidElement(const char *el)
{
    return (is_valid_symbol(el, 98));
}

void file_preview(GtkButton *button, GtkWidget *textwindow)
{
   GtkWidget *entry;
   char *fnam;

   entry = get_widget(GTK_WIDGET(button), "entry");
   fnam = g_strdup_printf("%s", gtk_editable_get_chars(GTK_EDITABLE(entry),
             0, -1));
   (void) load_file_into_window(fnam, textwindow,NULL,NULL, 4);

   GtkTextIter iter1, iter2;
   GtkTextBuffer *tb = gtk_text_view_get_buffer(GTK_TEXT_VIEW(textwindow));
   gtk_text_buffer_get_bounds(tb, &iter1, &iter2);
   gtk_text_buffer_apply_tag_by_name(tb, MONOSPACE_FONT, &iter1, &iter2);
}

int find_space(GtkWidget *dlg)
{
    GtkWidget *entry = get_widget(dlg, "radio_search");
    if(entry == NULL)
         return 0;
    if(!gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry)))
         return 0;
    entry = get_widget(dlg, "radio_find");
    GtkWidget *entry2 = get_widget(dlg, "radio_scan");
    if((entry == NULL) && (entry2 == NULL))
         return 0;
    else
    { 
         if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry)))
            return 1;
         else if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry2)))
            return 2;
         else
            return 0;
    } 
}

namespace Sir
{
  class SirProject {
  public:
        SirProject(gchar *dir);
        int SirOpen(const std::string &fn, GtkWidget *dlg);
        bool SirSave(const std::string &strfn, GtkWidget *dlg);
        float Volume();
        void FillForm(GtkWidget *dialog);
        void ReadForm(GtkWidget *dialog, int page=page_RUN+1);
        int  nTrialsDefault();
        int HeteroAndAnom(std::ostream &os, std::ostream &os1, int *n_anom) const;
        bool SaveSir();
        int  CalcolaSize();
        void FillFromMTZ(GtkWidget *dlg, std::string fn);
        int  MtzGetInfo(gpointer mtzi);
        std::string GetFilename(const gchar *suffix) const;
        void WriteSequence() const;
        void ReadSequence() const;
        void ClearSequence();
        int  ContentFromSequenceStr(const std::string &sequence);
        void SetContent(const char *cont) {strContent = cont;}
        const std::string &GetContent() const {return strContent;}
        double MolecularWeight() const;
        void Content(std::ostream &os) const;
        int  HeteroAtoms(std::ostream &os) const;
        int  NResidues() const;
        int  NNonHtot() const;
        int  NNonHtot(int nEl, const stringa5 El[], const int Am[]) const;
        void ChangeVolPerAt();
        void ChangeVolPerAt(int nEl, const stringa5 El[], const int Am[]);
        int NCellResidues() const {return NResidues()*nMolecules*SpgrOrder;}
        void update_windinfo (int npag);
        void CheckPDBFile(const std::string &fn, int which);
        void FillFromPDB(int which);
        void DoubleToUI(const char *name, double d) const;
        void BoolToUI(const char *name, bool b) const;
        void ComboValToUI(const char *name, int b) const;
        void IntToUI(const char *name, int i) const;
        void TextToUI(const char *name, const char *text) const;
        int  IntFromUI(const char *name) const;
        double DoubleFromUI(const char *name) const;
        bool  BoolFromUI(const char *name) const;
        int   ComboValFromUI(const char *name) const;
        size_t truesize();

        GtkWidget *window;
        char WorkDir[MaxLenFilename];
        char StructNam[80];
        int  nProc;
        int  ReflFileType;
        int  MolType;
        int  iCont;
        int  SpaceGroup;
        int  SpgrOrder;
        char szSpaceGroup[20];
        nomefile szMtzFile;
        nomefile szSelectedColumns;
        nomefile szSeqFile;
        int  FindSpace;
        float Cell[13];
        int nElements;
        char Elem[NUMSPECIES][SYMLEN+1];
        int Amount[NUMSPECIES];
        int nMolecules;
        double dCont;
        float dresMax, dresMin;
        int nPerResidue[6];
        float Deltaf1[NUMSPECIES];
        float Deltaf2[NUMSPECIES];
        int Source;
//        int Wavetype;
//        float Wavelen;
        char ReflFile[MaxLenFilename];
        char ReflForm[40];
        int ReflFileFormat;
        int ifSigma;
        int ReflPerRec;
        float ThFactor;
        float MinRes;
        int TMat[3][3];
        int Sfac;
        int Strategy;
        int useDefaults;
        int StructSize;
        int ifRelax;
        int Nblocks;
        int ToGen[NUMSPECIES];
        int ToStore[NUMSPECIES];
        float RSoglia;
        char JobTitle[80];
        char InputF[MaxLenFilename];
        char OutputF[MaxLenFilename];
        int  nFrags;
        nomefile szFragment[MAX_FRAGS];
   //Molecular Replacement
    int nMRModels;
    nomefile szMRFile[MAX_MODELS];
    bool bMRUsePseudo;
    bool bMRUseHetero[MAX_MODELS], bMRRot[MAX_MODELS],
         bMRTrans[MAX_MODELS], bMREdm[MAX_MODELS], bMRSeq[MAX_MODELS];
    char cMRAdp[MAX_MODELS]; // 'P' - PDB, 'W' - Wilson, '2' - 20
    int nMRNmol[MAX_MODELS], iMRalfa[MAX_MODELS], iMRbeta[MAX_MODELS], iMRgamma[MAX_MODELS];
    double dMREdmres[MAX_MODELS], dMRxx[MAX_MODELS], dMRyy[MAX_MODELS], dMRzz[MAX_MODELS], dMRvalue[MAX_MODELS];
    bool bMRPolyalanine[MAX_MODELS], bMRCutModel[MAX_MODELS];
    int n1MR[MAX_MODELS], n2MR[MAX_MODELS];
    int min_resid[MAX_MODELS], max_resid[MAX_MODELS];
    int n_residui[MAX_MODELS];

    bool bMRRes, bMRTSAuto;
    double dMRMinres, dMRMaxres, dMRTSRot, dMRTSRotLoc, dMRTSTra, dMRTSTraLoc;
    bool bVLD, bFL, bAMB, bCAB;

  //MAD/SAD
    bool bNative;
    int dumWaves, maxWaves;
    double dElementF1F2[SIR_MAX_ELEMENTS][SIR_MAX_WAVES][2]; 
    int whichAMB;
    bool waveSel[SIR_MAX_WAVES];
    int nTrials;
    bool useTrialsDefault;
    bool useMadFile;
    nomefile szMadFile;
    bool allT;
    int  setN1, setN2;
    bool lsq_a[3], lsq_w[2];

  //Phase refinement
    nomefile szPhRFile;
    int phFrom;

    bool bWindow;
private:
        std::string strContent;
    };
  static SirProject *project;

size_t SirProject::truesize()
{
  return (sizeof(*this) - sizeof(strContent));
}
void SirProject::DoubleToUI(const char *name, double d) const
{
    GtkWidget *w = get_widget(window, name);
    if(GTK_IS_SPIN_BUTTON(w))
       spin_button_set_value(w, d);
    else
    {
       int prec = get_int(w, "prec");
       gtk_entry_set_text(GTK_ENTRY(w), fToStr2((float) d, prec, false).c_str());
    }
}

void SirProject::IntToUI(const char *name, int i) const
{
    GtkWidget *w = get_widget(window, name);
    if(GTK_IS_SPIN_BUTTON(w))
       spin_button_set_value(w, static_cast<double>(i));
    else
       gtk_entry_set_text(GTK_ENTRY(w), fToStr2((float)i, 0, false).c_str());
}

void SirProject::BoolToUI(const char *name, bool b) const
{
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(get_widget(window, name)), b?TRUE:FALSE);
}

void SirProject::ComboValToUI(const char *name, int b) const
{
    combo_set_val(get_widget(window, name), b);
}

void SirProject::TextToUI(const char *name, const char *text) const
{
    gtk_entry_set_text(GTK_ENTRY(get_widget(window, name)), toUTF8(text));
}

int SirProject::IntFromUI(const char *name) const
{
    GtkWidget *w = get_widget(window, name);
    if(GTK_IS_SPIN_BUTTON(w))
       return spin_button_get_value_as_int(w);
    else
       return atoi(gtk_entry_get_text(GTK_ENTRY(w)));
}
double SirProject::DoubleFromUI(const char *name) const
{
    GtkWidget *w = get_widget(window, name);
    if(GTK_IS_SPIN_BUTTON(w))
       return spin_button_get_value(w);
    else
       return atof(gtk_entry_get_text(GTK_ENTRY(w)));
}
bool SirProject::BoolFromUI(const char *name) const
{
    return gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(
           get_widget(window, name)))!=0;
}

int SirProject::ComboValFromUI(const char *name) const
{
    return combo_get_val( get_widget(window, name));
}
  SirProject::SirProject( gchar *dir)
  {
    memset(this, 0, truesize());
    g_strlcpy(WorkDir, dir, sizeof(WorkDir));
    CopiaStringa(ReflForm,sizeof(ReflForm), "(3I4, 2F8.2)");
    Sfac = 1;
    ReflPerRec = 1;
    ReflFileFormat = 3;
    SpaceGroup = -1;
    FindSpace = 0;
    nFrags = 1;
//    Wavetype = 1;
    RSoglia = 25;
    Strategy = 0;
    Neutro = 0;
    useDefaults = 1;
    nMolecules = 1;
    nMRModels = 1;
    bVLD = true;
    dCont = 0;
    bMRTSAuto = true;
    for(int i=0; i<3;i++)
    {
        for(int j=0;j<3;j++)
        {
            if(i == j)
               TMat[i][j] = 1;
            else
               TMat[i][j] = 0;
        }
    }
    strContent.clear();
    maxWaves = 0;
    for(int i=0; i<SIR_MAX_WAVES;i++)
        waveSel[i] = true;
    nTrials = -1;
    allT = true;
    useTrialsDefault = false;
    useMadFile = false;
    for(int i=0;i<3;i++)
       lsq_a[i] = true;
    for(int i=0;i<2;i++)
       lsq_w[i] = true;
    for(int i=0;i<MAX_MODELS;i++)
       bMRSeq[i] = true;
    phFrom = 3;
  }

  int SirProject::SirOpen(const std::string &strfn, GtkWidget *dlg )
  {
    std::ifstream f;
    char lung[6];
    int errore = 0;
    if(open_project(strfn.c_str(), f))
    {
      g_print ("Could not open file: %s\n",strfn.c_str());
      return -1;
    }

    memset(this, 0, truesize());

    size_t nsz = read_project(f, static_cast<char*>(static_cast<void*>(this)), truesize());

    if( (int)nsz == -1 )
    {
      MessageDialog(dlg, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, "Error in open file: %s", strfn.c_str());
       errore = -1;
    }
    if( nsz!=truesize() )
    {
      MessageDialog(dlg, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, "This is not a Sir project file");
      errore = -1;
    }
    read_project(f, lung, sizeof(lung));
    int l = atoi(lung);
    if((l < 0) || (l>=(int)MaxLenFilename))
        errore = -1;
    char *nome = g_new0(char, l+1);
    read_project(f, nome, l+1);
    SetContent(nome);
    g_free(nome);
    f.close();

    if(dir_set_current(WorkDir))
    {
      MessageDialog(dlg, GTK_MESSAGE_WARNING, GTK_BUTTONS_CLOSE, "Error in dir_set_current: %s ", WorkDir);
      CopiaStringa(WorkDir, sizeof(WorkDir), SWareRC->WorkingDirectory);
    }
    if(!mr_access(WorkDir, 'm'))
    {
      MessageDialog(dlg, GTK_MESSAGE_WARNING, GTK_BUTTONS_CLOSE, 
            "Working directory '%s' is read-only", WorkDir);
      CopiaStringa(WorkDir, sizeof(WorkDir), SWareRC->WorkingDirectory);
    }
    if(dir_set_current(WorkDir))
    {
      MessageDialog(dlg, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, "Error in dir_set_current: %s ", WorkDir);
      errore = -1;
    }
    window = dlg;
    return errore;
  }
  bool SirProject::SirSave(const std::string &strfn, GtkWidget *dlg )
  {
    std::ofstream fil;
    size_t towrite = truesize();

    fil.open(strfn.c_str(), std::ios::binary|std::ios::out);
    if( !fil || !fil.is_open() )
    {
      MessageDialog(dlg, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, "Error in open file: %s", strfn.c_str());
      return false;
    }
    fil.write(static_cast<const char*>(static_cast<const void*>(this)), towrite);
    char lung[6];
    ScriviStringa(lung, 6, "%5.5d", (int) strlen(GetContent().c_str()));
    fil.write(lung,6);
    fil.write(static_cast<const char*>(GetContent().c_str()), strlen(GetContent().c_str())+1);
    fil.close();
    return true;
  }
  float SirProject::Volume()
  {
    return (float) CellVolume(Cell);
  }

int SirProject::NResidues() const
{
    int nres;
    if( iCont > 0 )
      nres = iround( dCont );
    else
      nres = iround( dCont/DResidueWeight );
    return nres;
}

double SirProject::MolecularWeight() const
{
    double molves;
    if( iCont > 0 )
      molves = iround( dCont) * DResidueWeight;
    else
      molves = dCont;
    return molves;
}

int SirProject::HeteroAtoms(std::ostream &os) const
{
    for(int i=0; i<nElements; i++ )
      os << Elem[i] << " " << Amount[i] << " ";
    return nElements;
}

void SirProject::Content(std::ostream &os) const
{
    if(MolType == MACRO)
    {
       const int nres = NCellResidues();
       int nPerRes[6];
       if(iCont == 2)
       {
          for(int i=0; i<6; i++)
              nPerRes[i] = nPerResidue[i];
       }
       else
       {
          nPerRes[0] = iround(nres*DHPerResidue);
          nPerRes[1] = iround(nres*DCPerResidue);
          nPerRes[2] = iround(nres*DNPerResidue);
          nPerRes[3] = iround(nres*DOPerResidue);
          nPerRes[5] = 0;
          if (nProc != AB_INITIO)
              nPerRes[4] = iround(nres*DSPerResidue);
          else
              nPerRes[4] = 0;
       }
       for(int j=0; j<nElements; j++ )
       {
           int z = IsValidElement(Elem[j]);
           for(int i=0; i<6; i++)
           {
               if(z == Res[i]) 
                  nPerRes[i] += Amount[j]*SpgrOrder;
           }
       }
       for(int i=0; i<6;i++)
       {
           if(nPerRes[i])
              os << "  " << get_nth_element_name(Res[i]-1) << " " << nPerRes[i]
                 << "\n";
       }
       for(int j=0; j<nElements; j++ )
       {
           int z = IsValidElement(Elem[j]);
           if(((z == Res[0]) && nPerRes[0]) ||
              ((z == Res[1]) && nPerRes[1]) ||
              ((z == Res[2]) && nPerRes[2]) ||
              ((z == Res[3]) && nPerRes[3]) ||
              ((z == Res[4]) && nPerRes[4]) ||
              ((z == Res[5]) && nPerRes[5]) )
                 continue;
           os << "  "  << get_nth_element_name(z-1) << " " << Amount[j]*SpgrOrder
           << "\n";
       }
    }
    else if(MolType == SMALL)
    {
       for(int j=0; j<nElements; j++ )
       {
           int z = IsValidElement(Elem[j]);
           if(z > 0)
              os << "  "  << get_nth_element_name(z-1) << " " << Amount[j]
                 << "\n";
       }
    }
}

int SirProject::NNonHtot(int nEl, const stringa5 El[], const int Am[]) const
{
    int ntot=0;
    if(MolType == MACRO)
    {
       if(iCont == 2)                // Sequence
          for(int i=1; i<6; i++)
              ntot += nPerResidue[i];
       else
       {
          const int nres = NCellResidues();
          ntot = ( iround(nres*DCPerResidue) + iround(nres*DNPerResidue) + iround(nres*DOPerResidue) );
          if (nProc != 0)
              ntot += iround(nres*DSPerResidue);
       }
       for(int i=0; i<nEl; i++ )
       {
           char *at = g_strdup(El[i]);
           if(IsValidElement(g_strstrip(at)) != 1)
             ntot += Am[i]*SpgrOrder;
       }
    }
    else if(MolType == SMALL)
    {
       for(int i=0; i<nEl; i++ )
       {
           char *at = g_strdup(El[i]);
           if(IsValidElement(g_strstrip(at)) != 1)
             ntot += Am[i];
       }
    }
    return ntot;
}

int SirProject::NNonHtot() const
{
    return NNonHtot(nElements, Elem, Amount);
}

void SirProject::ChangeVolPerAt(int nEl, const stringa5 El[], const int Am[])
{
  int nNonH = NNonHtot(nEl, El, Am);
  GtkWidget *entry = get_widget(window, "vol_per_at");
  if(nNonH)
     gtk_label_set_text(GTK_LABEL(entry), g_strdup_printf("%.4f",
                Volume()/(float)nNonH));
  else
     gtk_label_set_text(GTK_LABEL(entry), " ");
}

void SirProject::ChangeVolPerAt()
{
  ChangeVolPerAt(nElements, Elem, Amount);
}

void SirProject::FillForm(GtkWidget *dialog)
{

      GtkWidget *entry, *frame, *frame2;
      int i, imax;

// General
      entry = get_widget(dialog, "workdir");
      gtk_entry_set_text(GTK_ENTRY(entry), toUTF8(WorkDir));
      entry = get_widget(dialog, "structnam");
      gtk_entry_set_text(GTK_ENTRY(entry), toUTF8(StructNam));
      entry = get_widget(dialog, "structfile");
      gtk_entry_set_text (GTK_ENTRY(entry), "");
      entry = get_widget(dialog, "job");
      gtk_entry_set_text(GTK_ENTRY(entry), toUTF8(JobTitle));
      entry = get_widget(dialog, molsizes[MolType]);
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry), TRUE);
      entry = get_widget(dialog, procedures[nProc]);
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry), TRUE);
      entry = get_widget(dialog, refls[ReflFileType]);
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry), TRUE);

//      entry = get_widget(dialog, "dirsel");
//      gtkext::riempi_listNew(entry);
      BoolToUI("AMBCheck", bAMB);
      ComboValToUI("AMBCombo", whichAMB+1);
      BoolToUI("CABCheck", bCAB);

// Symmetry & Cell Parameters

//PROVA      if((ReflFileType == 1) || (ReflFileType == 0))
      {
      entry = get_widget(dialog, "entry_spg");
      int hnd = get_int(entry, "hnd");
      g_signal_handler_block(G_OBJECT(entry), hnd);
      if((SpaceGroup != -1) && !FindSpace)
         gtk_entry_set_text(GTK_ENTRY(entry), szSpaceGroup);
      else
         gtk_entry_set_text(GTK_ENTRY(entry), "");
      g_signal_handler_unblock(G_OBJECT(entry), hnd);

      entry = get_widget(dialog, "CellPar");
      set_label_text(entry, " ", "red",  1.05f);
//      entry = get_widget(dialog, "radio_find");
//      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry), FALSE);

      entry = get_widget(dialog, "cell_param");
      gtk_widget_set_sensitive (entry, FALSE);

      for(i = 0; i<=12; i++)
      {
          entry = get_widget(dialog, cell_data[i]);
          gtk_entry_set_text(GTK_ENTRY(entry), fToStr(Cell[i], 4).c_str());
     }
     entry = get_widget(dialog, "radio_space");
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry), !FindSpace);
     entry = get_widget(dialog, "radio_search");
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry), FindSpace);
     entry = get_widget(dialog, "radio_find");
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry), (FindSpace == 1));
     entry = get_widget(dialog, "radio_scan");
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry), (FindSpace == 2));
//     entry = get_widget(dialog, "crysf");
//     gtk_widget_set_sensitive (entry, FindSpace);
     }
//MTZ
//PROVA     if((ReflFileType == 2) || (ReflFileType == 0))
     {
     std::string fn = szMtzFile;
     FillFromMTZ(dialog, fn);
     update_mtzpage(dialog);
     entry = get_widget(dialog, "MtzFileEntry");
     gtk_entry_set_text(GTK_ENTRY(entry), szMtzFile);
     entry = get_widget(dialog, "MtzColumnsEntry");
     gtk_text_buffer_set_text(gtk_text_view_get_buffer(GTK_TEXT_VIEW(entry)),
              toUTF8(szSelectedColumns), -1);
     entry = get_widget(dialog, "MtzSpgFind");
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry), FindSpace);
     }

//Cell Content

     frame = get_widget(dialog, "frame_elements");
     frame2 = get_widget(dialog, "molecular_unit");
     if(MolType == SMALL)
     {
        gtk_widget_show(frame);
        gtk_widget_hide(frame2);
     }
     else if(MolType == MACRO)
     {
        gtk_widget_hide(frame);
        gtk_widget_show(frame2);
     }
     entry = get_widget(dialog, "vol_cell");
     gtk_label_set_text(GTK_LABEL(entry), fToStr(Volume(), 4).c_str());
     //entry = get_widget(dialog, molsizes[MolType]);
     //gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry), TRUE);
//PROVA     if(MolType == 0)
     {   
        entry = get_widget(dialog,"formula");
        gtk_entry_set_text(GTK_ENTRY(entry), "");
        if(!GetContent().empty())
           gtk_entry_set_text(GTK_ENTRY(entry),  GetContent().c_str());
     } 
//PROVA     else
     {   
        frame = dialog;
//PROVA        if(nProc != SADMAD)
        {
           imax = 4;
           for (i=1; i<=nElements; i++)
           {   
             entry = get_widget(frame, g_strdup_printf("cont%d_0", i));
             gtk_entry_set_text(GTK_ENTRY(entry), Elem[i-1]);
             entry = get_widget(frame, g_strdup_printf("cont%d_1", i));
             gtk_entry_set_text(GTK_ENTRY(entry), 
               fToStr2((float) Amount[i-1], 0, false).c_str());
           }
           for (i=nElements+1; i<=imax; i++)
           {   
             entry = get_widget(frame, g_strdup_printf("cont%d_0", i));
             gtk_entry_set_text(GTK_ENTRY(entry), " ");
             entry = get_widget(frame, g_strdup_printf("cont%d_1", i));
             gtk_entry_set_text(GTK_ENTRY(entry), "0");
           }
        }
//PROVA        else
        {
           for (i=1; i<=nElements; i++)
           {
             std::stringstream name;
             name.str("");
             name << "ContSymbol" << i << "Entry";
             entry = get_widget(dialog, name.str().c_str());
             gtk_entry_set_text(GTK_ENTRY(entry), Elem[i-1]);
             name.str("");
             name  << "ContAmount" << i << "Spin";
             entry = get_widget(dialog, name.str().c_str());
             gtk_entry_set_text(GTK_ENTRY(entry), 
               fToStr2((float) Amount[i-1], 0, false).c_str());
             for(int j=1; j<=SIR_MAX_WAVES; j++ )
             {
                for(int k=1; k<=2; k++ )
                {
                  std::stringstream name;
                  name << "ContE" << i << "W" << j << "F" << k << "Spin";
                  entry = get_widget(dialog, name.str().c_str());
                  gtk_entry_set_text(GTK_ENTRY(entry), 
                   fToStr2((float)dElementF1F2[i-1][j-1][k-1],3,false).c_str());
                }
             }

           }
           for (i=nElements+1; i<=SIR_MAX_ELEMENTS; i++)
           {   
             std::stringstream name;
             name.str("");
             name << "ContSymbol" << i << "Entry";
             entry = get_widget(dialog, name.str().c_str());
             gtk_entry_set_text(GTK_ENTRY(entry), " ");
             name.str("");
             name  << "ContAmount" << i << "Spin";
             entry = get_widget(dialog, name.str().c_str());
             gtk_entry_set_text(GTK_ENTRY(entry), " ");
             for(int j=1; j<=SIR_MAX_WAVES; j++ )
             {
                for(int k=1; k<=2; k++ )
                {
                  std::stringstream name;
                  name << "ContE" << i << "W" << j << "F" << k << "Spin";
                  entry = get_widget(dialog, name.str().c_str());
                  gtk_entry_set_text(GTK_ENTRY(entry), " ");
                }
             }
           }
        }
        entry = get_widget(dialog, radio_mu[iCont]);
        gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry), TRUE);
//PROVA        if(iCont != 2)
           ClearText(get_widget(dialog, "Seq"));
//PROVA        else if(!str_white (szSeqFile))
           ReadSequence();
        
        entry = get_widget(dialog, "ResiduesSpin");
        spin_button_set_value(entry, NResidues() );
        entry = get_widget(dialog, "MolSpin");
        spin_button_set_value(entry, MolecularWeight());
        entry = get_widget(dialog, "NMolsSpin");
        spin_button_set_value(entry, nMolecules);
     }
     entry = get_widget(dialog, sources[Source]);
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry), TRUE);
     Neutro = Source;

// Reflections
//PROVA     if((ReflFileType == 1) || (ReflFileType == 0))
     {
     entry = get_widget(dialog, "rpc_file");
     gtk_entry_set_text(GTK_ENTRY(entry), toUTF8(ReflFile));
     entry = get_widget(dialog, "preview_w");
     ClearText(entry);
     entry = get_widget(dialog, "format");
     if(!str_white(ReflFile))
     {
        gtk_button_clicked(GTK_BUTTON(get_widget(dialog, "preview_b")));
        gtk_entry_set_text(GTK_ENTRY(entry), ReflForm);
        gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(get_widget(dialog, 
          "ifsigma")), !ifSigma);
     }
     else
     {
        gtk_entry_set_text(GTK_ENTRY(entry), "(3I4, 2F8.2)");
        gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(get_widget(dialog, 
          "ifsigma")), FALSE);
     }
     entry = get_widget(dialog, "refl_per_rec");
     gtk_entry_set_text(GTK_ENTRY(entry), fToStr((float) ReflPerRec, 0).c_str());
     entry = get_widget(dialog, g_strdup_printf("Format%d", ReflFileFormat));
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry), TRUE);
     entry = get_widget(dialog, "Tfac");
     gtk_entry_set_text(GTK_ENTRY(entry), fToStr(ThFactor, 4).c_str());
     entry = get_widget(dialog, "minres");
     gtk_entry_set_text(GTK_ENTRY(entry), fToStr(MinRes, 4).c_str());
     entry = get_widget(dialog, sfacs[Sfac]);
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry), TRUE);
     for(i=0; i<3; i++)
     {
         for(int j=0; j<3; j++)
         {
             entry = get_widget(dialog, g_strdup_printf("%d", 3*i+j));
             gtk_entry_set_text(GTK_ENTRY(entry), fToStr((float) TMat[i][j], 0).c_str());
         }
     }
     }

// Solve
//PROVA     if(nProc == AB_INITIO)
     {
     entry = get_widget(dialog, "combosize");
//     combo_set_val(entry, StructSize);
//     dime = StructSize;
     combo_set_val(entry, nsizes);
     dime = nsizes;

     switch(Strategy)
     {
     case S_AUTO:
       gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(get_widget(dialog, "AutoCheck")), TRUE);
       break;
     case S_DM:
       gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(get_widget(dialog, "TangentCheck")), TRUE);
       break;
     case S_PATT:
       gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(get_widget(dialog, "PattersonCheck")), TRUE);
       break;
     case S_VLD:
       gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(get_widget(dialog, "VLDCheck")), TRUE);
       break;
     case S_MDM:
       gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(get_widget(dialog, "MDMCheck")), TRUE);
       break;
     case S_SA:
       gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(get_widget(dialog, "SACheck")), TRUE);
       break;
     }
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(get_widget(dialog, relstr[ifRelax])), TRUE);
     frame = get_widget(dialog, "lista_blocchi");
     entry = get_widget(frame, "nblocchi");
     spin_button_set_value(entry, Nblocks);
     for(i=1; i<=Nblocks; i++)
     {
       char nome[20];
       ScriviStringa(nome, sizeof(nome), "G%d", i);
       spin_button_set_value(get_widget(frame, nome), ToGen[i-1]);
       ScriviStringa(nome, sizeof(nome), "S%d", i);
       spin_button_set_value(get_widget(frame, nome), ToStore[i-1]);
       ScriviStringa(nome, sizeof(nome), "block%dlabel", i);
       set_label_text(get_widget(frame, nome), g_strdup_printf("%d", i) , MyBLUE, 0.99f);
     }
     for(i=Nblocks+1; i<=MaxBlocks; i++)
     {
       char nome[20];
       ScriviStringa(nome, sizeof(nome), "G%d", i);
       spin_button_set_value(get_widget(frame, nome), 1);
       ScriviStringa(nome, sizeof(nome), "S%d", i);
       spin_button_set_value(get_widget(frame, nome), 1);
       ScriviStringa(nome, sizeof(nome), "block%dlabel", i);
       set_label_text(get_widget(frame, nome), g_strdup_printf("%d", i) , MyBLUE, 0.99f);
     }

     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(get_widget(dialog, "defaults")), useDefaults);
     entry = get_widget(dialog, "Rsoglia");
     spin_button_set_value(entry, RSoglia);
     IntToUI("nFrags", nFrags);
     for(int i=0; i<MAX_FRAGS; i++)
     {
         char *nome = g_strdup_printf("frag_file%d", i);
         entry = get_widget(dialog, nome);
         gtk_entry_set_text(GTK_ENTRY(entry), szFragment[i]);
         g_free(nome);
     }
     entry = get_widget(dialog, "frame_blocks");
     gtk_widget_set_sensitive(entry, (Strategy != S_SA));
     entry = get_widget(dialog, "frame_sa");
     gtk_widget_set_sensitive(entry, (Strategy == S_SA));
     }
//PROVA     else if(nProc == REMO)
     {
      IntToUI("MRnModels", nMRModels);
      BoolToUI("MRPseudoCheck", bMRUsePseudo );
      for(int i=0; i<MAX_MODELS; i++)
      {
          TextToUI(g_strdup_printf("MRFileEntry%d",i), szMRFile[i]);
          BoolToUI(g_strdup_printf("MRHeteroCheck%d", i), bMRUseHetero[i] );
          BoolToUI(g_strdup_printf("MRPdbRadio%d", i), cMRAdp[i] == 'P'); 
          BoolToUI(g_strdup_printf("MRWilsonRadio%d", i), cMRAdp[i] == 'W'); 
          BoolToUI(g_strdup_printf("MR20Radio%d", i), cMRAdp[i] == '2');
          BoolToUI(g_strdup_printf("MRPolyalaCheck%d", i), bMRPolyalanine[i]);
          BoolToUI(g_strdup_printf("MRRotCheck%d", i), bMRRot[i]);
          IntToUI(g_strdup_printf("MRRot1Spin%d", i), iMRalfa[i]);
          IntToUI(g_strdup_printf("MRRot2Spin%d", i), iMRbeta[i]);
          IntToUI(g_strdup_printf("MRRot3Spin%d", i), iMRgamma[i]);
          BoolToUI(g_strdup_printf("MRTransCheck%d", i), bMRTrans[i]);
          DoubleToUI(g_strdup_printf("MRTrans1Spin%d", i), dMRxx[i]);
          DoubleToUI(g_strdup_printf("MRTrans2Spin%d", i), dMRyy[i]);
          DoubleToUI(g_strdup_printf("MRTrans3Spin%d", i), dMRzz[i]);
          IntToUI(g_strdup_printf("MRNmolSpin%d", i), nMRNmol[i]);
          BoolToUI(g_strdup_printf("MREdmCheck%d", i), bMREdm[i]);
          DoubleToUI(g_strdup_printf("MREdmSpin%d", i), dMREdmres[i]);
          gtk_widget_set_sensitive(get_widget(dialog,g_strdup_printf("MREdmSpin%d", i)), bMREdm[i]);
          BoolToUI(g_strdup_printf("MRSeqIdeCheck%d", i), bMRSeq[i]);
          DoubleToUI(g_strdup_printf("MRvalue%d", i), dMRvalue[i]);
          FillFromPDB(i);
          if(i < nMRModels)
             gtk_widget_show(get_widget(dialog,g_strdup_printf("MRModel%d",i)));
          else
             gtk_widget_hide(get_widget(dialog,g_strdup_printf("MRModel%d",i)));
      }
      BoolToUI("MRmRes", bMRRes);
      BoolToUI("MRaRes", !bMRRes);
      if(!bMRRes)
      {
         dMRMinres = dresMax;
         dMRMaxres = dresMin;
      }

      //spin_button_set_range(get_widget(dialog,"MRResMinSpin"),dresMax,dresMin);
      //spin_button_set_range(get_widget(dialog,"MRResMaxSpin"),dresMax,dresMin);
      DoubleToUI("MRResMinSpin", dMRMinres);
      DoubleToUI("MRResMaxSpin", dMRMaxres);

      set_tip ( get_widget(dialog,"MRResMinSpin"),
         g_strdup_printf("max res. = %.2f, min res. = %.2f", dresMax, dresMin));
      set_tip ( get_widget(dialog,"MRResMaxSpin"),
         g_strdup_printf("max res. = %.2f, min res. = %.2f", dresMax, dresMin));

      BoolToUI("MRTSAuto", bMRTSAuto);
      BoolToUI("MRTSMan", !bMRTSAuto);
      DoubleToUI("MRTSRotSpin", dMRTSRot);
      DoubleToUI("MRTSRotLocSpin", dMRTSRotLoc);
      DoubleToUI("MRTSTraSpin", dMRTSTra);
      DoubleToUI("MRTSTraLocSpin", dMRTSTraLoc);
      BoolToUI("MRVLDCheck", bVLD);
//      BoolToUI("MRFLCheck", bFL);
//      BoolToUI("MRAMBCheck", bAMB);
//      ComboValToUI("MRAMBCombo", whichAMB+1);
     }
//PROVA     else if(nProc == SADMAD)
     {
        for(int j=1; j<=SIR_MAX_WAVES; j++ )
        {
            std::stringstream name;
            name.str("");
            name << "Wave " << j;
            BoolToUI(name.str().c_str(), waveSel[j-1]);
        }
        BoolToUI("ntrials_default", useTrialsDefault);
        if(useTrialsDefault)
           nTrials = nTrialsDefault();
        IntToUI("ntrials_spin", nTrials);
        BoolToUI("use_madfile", useMadFile);
        BoolToUI("use_ntrials", !useMadFile);
        if(useMadFile)
          TextToUI("MadFileEntry", szMadFile);
        else
        {
          BoolToUI("use_all", allT);
          if(!allT)
          {
             IntToUI("bt_n1", setN1);
             IntToUI("bt_n2", setN2);
          }
        }
        for(int i=0; i<3; i++)
        {
            std::stringstream name;
            name.str("");
            name << "lsq_a" << i;
            BoolToUI(name.str().c_str(), lsq_a[i]);
        }
        for(int i=0; i<2; i++)
        {
            std::stringstream name;
            name.str("");
            name << "lsq_w" << i;
            BoolToUI(name.str().c_str(), lsq_w[i]);
        }
     }
     {
        gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(get_widget(dialog, str_lb[phFrom])), TRUE);
        TextToUI("PhRFileEntry", szPhRFile);
     }

// Run

     BoolToUI("bWindow", bWindow);
     entry = get_widget(dialog, "inpfile");
     gtk_entry_set_text(GTK_ENTRY(entry), InputF);
     entry = get_widget(dialog, "outfile");
     gtk_entry_set_text(GTK_ENTRY(entry), OutputF);
}

int SirProject::ContentFromSequenceStr(const std::string &sequence)
{
      FILE *fp = fOpen(szSeqFile, "r");
      bool Empty = true;
      std::string buffer = "";
      int NumSpec[6] = {0, 0, 0, 0, 0, 0};

      if(fp)
      {
          gchar *buf = g_new0(gchar, MaxLen);
          while(fgets(buf, MaxLen, fp))
          {
              buffer += buf;
              Empty = false;
          }
          g_free(buf);
          (void) fclose(fp);
      }

      gboolean result = Empty;      // il file e' pieno?
      if(!Empty)
      {
         // controlla che la sequenza non sia stata modificata
         if(buffer.compare(sequence) != 0)
         {
           std::string fn = szSeqFile;
           std::string mesg = "File " + fn + " already exists.\n"
            "Do you want to replace it?";
           result = gtkext::dlg_yesno(GTK_WINDOW(window), mesg.c_str());
         }
      }
      if(result)     // la sequenza e' stata introdotta o modificata via gui
      {
         if(!str_white(sequence.c_str()))
         {
            fp = fOpen(szSeqFile, "w");
            if(fp)
            {
               (void) fputs(sequence.c_str(), fp);
               (void) fclose(fp);
            }
         }
      }
     else
         ReadSequence(); //allinea file e gui

     int iresult = ContentFromSequenceFile(szSeqFile, NumSpec);// legge da file
     if(iresult != -1)
     {
         for(int n=0; n<6; n++)
             nPerResidue[n] = NumSpec[n]*nMolecules*SpgrOrder;
     }
     return iresult;
}

int SirProject::nTrialsDefault()
{
    int somma = 0;
    for(int i=0; i<nElements; i++ )
        somma += Amount[i];
    if((somma > 45) && (Volume() >  900000))
        return 60;
    else
        return 30;
}
void SirProject::ReadForm(GtkWidget *dialog, int page)
{
   int i;
   GtkWidget *entry, *frame;
   float symop_r[3];

// General
   if((page == page_GENERAL) || (page > page_RUN))
   {
      entry = get_widget(dialog, "workdir");
      CopiaStringa(WorkDir, sizeof(WorkDir), fromUTF8(gtk_entry_get_text(GTK_ENTRY(entry))).c_str());
      entry = get_widget(dialog, "structnam");
      CopiaStringa(StructNam, sizeof(StructNam), fromUTF8(gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1)).c_str());
      entry = get_widget(dialog, "job");
      CopiaStringa(JobTitle, sizeof(JobTitle), fromUTF8(gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1)).c_str());
      if(str_white(JobTitle))
      {
         struct tm TMbuf;
         OraCorrente(&TMbuf);
         std::string myname(g_strdup_printf( "%s_%s %2.2d/%2.2d/%4.4d",
                MR_PACKAGE, StructNam,
               TMbuf.tm_mday, TMbuf.tm_mon+1, TMbuf.tm_year+1900));
         ScriviStringa(JobTitle, sizeof(JobTitle), "%s", myname.c_str());
         gtk_entry_set_text(GTK_ENTRY(entry), toUTF8(JobTitle));
      }
      for(i=0; i< (int)(sizeof(molsizes)/sizeof(molsizes[0])); i++)
      {
          GtkWidget *button = get_widget(dialog, molsizes[i]);
          if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(button)))
          {
             MolType = i;
             break;
          }
      }

      for(i=0; i< (int)(sizeof(procedures)/sizeof(procedures[0])); i++)
      {
          GtkWidget *button = get_widget(dialog, procedures[i]);
          if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(button)))
          {
             nProc = i;
             break;
          }
      }
      for(i=0; i< (int)(sizeof(refls)/sizeof(refls[0])); i++)
      {
          GtkWidget *button = get_widget(dialog, refls[i]);
          if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(button)))
          {
             ReflFileType = i;
             break;
          }
      }
      bAMB = BoolFromUI("AMBCheck");
      whichAMB = ComboValFromUI("AMBCombo")-1;
      bCAB = BoolFromUI("CABCheck");
   }

// Symmetry & Cell Parameters
   if(ReflFileType == 1)
   {
   if((page == page_SPGR) || (page > page_RUN))
   {
      entry = get_widget(dialog, "entry_spg");
      CopiaStringa(szSpaceGroup,  sizeof(szSpaceGroup), g_strstrip(combo_get_text(entry)));
      SpaceGroup = GetSpgNum(szSpaceGroup, symop_r, &SpgrOrder);
      ifLaue = 1;
      FindSpace = find_space(dialog);
      if( FindSpace == 1)
      {
          entry = get_widget(dialog, "crystfam");
          if(entry != NULL)
             ifLaue = combo_get_val(entry);
      }
   }

   if((page == page_CELL) || (page > page_RUN))
   {
      FindSpace = find_space(dialog);
      entry = get_widget(dialog, cell_data[0]);
      Cell[0] = (float) atof(gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
      for(i = 1; i<3; i++)
      {
          entry = get_widget(dialog, cell_data[i]);
          std::string cellval = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
          if(cellval.find("=") != std::string::npos)
             Cell[i] = Cell[0];
          else
             Cell[i] = (float) atof(cellval.c_str());
      }
      for(i = 3; i<=12; i++)
      {
          entry = get_widget(dialog, cell_data[i]);
          Cell[i] = (float) atof(gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
      }
   }
   }

// MTZ
   else if(ReflFileType == 2)
   {
   if((page == page_MTZ) || (page > page_RUN))
   {
      entry = get_widget(dialog, "MtzFileEntry");
      CopiaStringa(szMtzFile, MaxLenFilename, gtk_entry_get_text(GTK_ENTRY(entry)));
      entry = get_widget(dialog, "MtzColumnsEntry");
      CopiaStringa(szSelectedColumns, MaxLenFilename, get_text(GTK_TEXT_VIEW(entry)));
      entry = get_widget(dialog, "MtzSpgEntry");
      CopiaStringa(szSpaceGroup,sizeof(szSpaceGroup),gtk_entry_get_text(GTK_ENTRY(entry)));
      entry = get_widget(dialog, "MtzSpgFind");
      FindSpace = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry));
   }
   }

//Cell Content

   if((page == page_CONTENT) || (page > page_RUN))
   {
      //entry = get_widget(dialog, molsizes[1]);
      //MolType = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry));
      if(MolType == SMALL)         // Small molecule
      {
         frame = get_widget(dialog,"formula");
         char *line = g_strdup(gtk_entry_get_text(GTK_ENTRY(frame)));
         int *Z = g_new0(int, NUMSPECIES);
         nElements = get_content_from_formula_(line, Amount, Z, strlen(line));
         for(i=0; i<nElements; i++)
             CopiaStringa(Elem[i], SYMLEN+1, get_nth_element(Z[i]-1));
         SetContent(gtk_entry_get_text(GTK_ENTRY(frame)));
/*
         frame = get_widget(dialog, "lista_elements");
         nElements = 0;
         for(i=1; i<=NUMSPECIES; i++)
         {   
              entry = get_widget(frame, g_strdup_printf("cont%d_0", i));
              CopiaStringa(Elem[nElements], SYMLEN, gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
              entry = get_widget(frame, g_strdup_printf("cont%d_1", i));
              Amount[nElements] = spin_button_get_value_as_int(entry);
              if(!str_white(Elem[nElements]) && Amount[nElements])
              {
                  entry = get_widget(frame, g_strdup_printf("cont%d_2", i));
                  Deltaf1[nElements] = (float) atof(gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
                  entry = get_widget(frame, g_strdup_printf("cont%d_3", i));
                  Deltaf2[nElements] = (float) atof(gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
                  nElements++;
              }
         }
*/
      }
      else if(MolType == MACRO)   // Macro molecule 
      {
          for(i=0; i<(int)(sizeof(radio_mu)/sizeof(radio_mu[0])); i++)
          {
               entry = get_widget(dialog,  radio_mu[i]);
               if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry)))
                  iCont = i;
          }
          entry = get_widget(dialog, "NMolsSpin");
          nMolecules = spin_button_get_value_as_int(entry);
          switch(iCont)
          {
          case 0:
                entry = get_widget(dialog, "MolSpin");
                dCont = spin_button_get_value(entry);
          break;
          case 1:
                entry = get_widget(dialog, "ResiduesSpin");
                dCont = spin_button_get_value(entry);
          break;
          case 2:
                entry = get_widget(dialog, "SeqFile");
                CopiaStringa(szSeqFile, MaxLenFilename, 
                   gtk_entry_get_text(GTK_ENTRY(entry)));
                if(str_white(szSeqFile))
                {
                   CopiaStringa(szSeqFile, MaxLenFilename, 
                     GetFilename(".seq").c_str()); 
                   WriteSequence();
                }
                {
                   std::string sequence_txt =
                      GetTextW(get_widget(dialog, "Seq"));
                   dCont = ContentFromSequenceStr(sequence_txt);
                }
          break;
          }
          nElements = 0;
          if(nProc != SADMAD)
          {
            for(i=1; i<=4; i++ )
            {
               entry = get_widget(dialog, g_strdup_printf("cont%d_0", i));
               CopiaStringa(Elem[nElements], SYMLEN,
                   gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
               entry = get_widget(dialog, g_strdup_printf("cont%d_1", i));
               Amount[nElements] = atoi(gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
               if(!str_white(Elem[nElements]) || Amount[nElements])
                  nElements++;
            }
          }
          else
          {
            for(i=1; i<=SIR_MAX_ELEMENTS; i++ )
            {
              std::stringstream name;
              name.str("");
              name << "ContSymbol" << i << "Entry";
              entry = get_widget(dialog, name.str().c_str());
              CopiaStringa(Elem[nElements], SYMLEN,
                  gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
              name.str("");
              name  << "ContAmount" << i << "Spin";
              entry = get_widget(dialog, name.str().c_str());
              Amount[nElements] = atoi(gtk_entry_get_text(GTK_ENTRY(entry)));
              if(str_white(Elem[nElements]) && !Amount[nElements])
                 continue;
              for(int j=1; j<=SIR_MAX_WAVES; j++ )
              {
                 for(int k=1; k<=2; k++ )
                 {
                    std::stringstream name;
                    name << "ContE" << i << "W" << j << "F" << k << "Spin";
                    entry = get_widget(dialog, name.str().c_str());
                    dElementF1F2[nElements][j-1][k-1] =(j <= maxWaves)?
                     atof(gtk_entry_get_text(GTK_ENTRY(entry))):0;
                 }
              }
              nElements++;
            }
            entry = get_widget(dialog, "ntrials_spin");
            if(nTrials == -1)
              spin_button_set_value(entry, nTrialsDefault());
          }
      }
      for(i=0; i< (int) (sizeof(sources)/sizeof(sources[0])); i++)
      {
          entry = get_widget(dialog, sources[i]);
          if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry)))
             Source = i;
      }
      Neutro = Source;
   }

// Reflections
   if(ReflFileType == 1)
   {
   if((page == page_REFL) || (page > page_RUN))
   {
      entry = get_widget(dialog, "rpc_file");
      CopiaStringa(ReflFile, sizeof(ReflFile), gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
      for(int j=1; j<=3; j++)
      {
          entry = get_widget(dialog, g_strdup_printf("Format%d", j));
          if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry)))
          {
             ReflFileFormat = j;
             break;
          }
      }
      if(ReflFileFormat == 1)
         CopiaStringa(ReflForm, sizeof(ReflForm), "(3I4, 2F8.2)");
      else if(ReflFileFormat == 2)
         CopiaStringa(ReflForm, sizeof(ReflForm), "free");
      else
      {
        entry = get_widget(dialog, "format");
        CopiaStringa(ReflForm, sizeof(ReflForm), gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
      }
      entry = get_widget(dialog, "ifsigma");
      ifSigma = (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry)))?0:1;
         
      entry = get_widget(dialog, "refl_per_rec");
      ReflPerRec = atoi (gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
      entry = get_widget(dialog, "Tfac");
      ThFactor = (float) atof(gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
      entry = get_widget(dialog, "minres");
      MinRes = (float) atof(gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
      entry = get_widget(dialog, sfacs[0]);
      if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry)))
         Sfac = 0;
      else
         Sfac = 1;
      for(i=0; i<3; i++)
      {
          for(int j=0; j<3; j++)
          {
              entry = get_widget(dialog, g_strdup_printf("%d", 3*i+j));
               TMat[i][j] = atoi(gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
          }
      }
   }
   }

// Solve
   if((page == page_SOLVE) || (page > page_RUN))
   {
   if(nProc == AB_INITIO)
   {
      entry = get_widget(dialog, "combosize");
      StructSize = combo_get_val(entry);

      entry = get_widget(dialog, "TangentCheck");
      if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry)))
         Strategy = S_DM;
      entry = get_widget(dialog, "PattersonCheck");
      if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry)))
         Strategy = S_PATT;
      entry = get_widget(dialog, "VLDCheck");
      if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry)))
         Strategy = S_VLD;
      entry = get_widget(dialog, "MDMCheck");
      if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry)))
         Strategy = S_MDM;
      entry = get_widget(dialog, "AutoCheck");
      if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry)))
         Strategy = S_AUTO;
      entry = get_widget(dialog, "SACheck");
      if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry)))
         Strategy = S_SA;
      if(Strategy == S_SA)
      {
         nFrags = IntFromUI("nFrags");
         for(int i=0; i<nFrags; i++)
         {
             char *nome = g_strdup_printf("frag_file%d", i);
             entry = get_widget(dialog, nome);
             CopiaStringa(szFragment[i], MaxLenFilename,
                   gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
             g_free(nome);
         }
      }
      else
      {
         nFrags = 0;
         for(int i=0; i<MAX_FRAGS; i++)
             memset(szFragment[i], 0, sizeof(szFragment[i]));
      }

      for(i=0; i<(int)(sizeof(relstr)/sizeof(relstr[0])); i++)
         if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(get_widget(dialog, relstr[i]))))
             ifRelax = i;
      frame = get_widget(dialog, "lista_blocchi");
      entry = get_widget(frame, "nblocchi");
      Nblocks = spin_button_get_value_as_int(entry);
      for(i=1; i<=Nblocks; i++)
      {
         char nome[10];
         ScriviStringa(nome, sizeof(nome), "G%d", i);
         ToGen[i-1] = spin_button_get_value_as_int(get_widget(frame, nome));
         ScriviStringa(nome, sizeof(nome), "S%d", i);
         ToStore[i-1] = spin_button_get_value_as_int(get_widget(frame, nome));
      }
      entry = get_widget(dialog, "defaults");
      useDefaults = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry));
      entry = get_widget(dialog, "Rsoglia");
      RSoglia = (float) spin_button_get_value(entry);
   }
   else if(nProc == REMO)
   {
      nMRModels = IntFromUI("MRnModels");
      bMRUsePseudo = BoolFromUI("MRPseudoCheck");
      for(i=0; i<nMRModels; i++)
      {
          entry = get_widget(dialog, g_strdup_printf("MRFileEntry%d",i));
          CopiaStringa(project->szMRFile[i], MaxLenFilename, gtk_entry_get_text(
              GTK_ENTRY(entry)));
          bMRUseHetero[i] = BoolFromUI(g_strdup_printf("MRHeteroCheck%d", i));
          if( BoolFromUI(g_strdup_printf("MRPdbRadio%d", i)) )
            cMRAdp[i] = 'P';
          else if( BoolFromUI(g_strdup_printf("MRWilsonRadio%d", i)) )
            cMRAdp[i] = 'W';
          else
            cMRAdp[i] = '2';
          bMRPolyalanine[i] = BoolFromUI(g_strdup_printf("MRPolyalaCheck%d", i));
          bMRCutModel[i] = BoolFromUI(g_strdup_printf("MRCutCheck%d", i));
          if(bMRCutModel[i])
          {
             n1MR[i] = IntFromUI(g_strdup_printf("MRn1Spin%d", i));
             n2MR[i] = IntFromUI(g_strdup_printf("MRn2Spin%d", i));
             if(n1MR[i] < min_resid[i])
                n1MR[i] = min_resid[i];
             if(n2MR[i] > max_resid[i])
                n2MR[i] = max_resid[i];
             if(n2MR[i] < n1MR[i])
                n1MR[i] = n2MR[i];
          }
          bMRRot[i] = BoolFromUI(g_strdup_printf("MRRotCheck%d", i));
          if(bMRRot[i])
          {
             iMRalfa[i]  = IntFromUI(g_strdup_printf("MRRot1Spin%d", i));
             iMRbeta[i]  = IntFromUI(g_strdup_printf("MRRot2Spin%d", i));
             iMRgamma[i] = IntFromUI(g_strdup_printf("MRRot3Spin%d", i));
          }
          bMRTrans[i] = BoolFromUI(g_strdup_printf("MRTransCheck%d", i));
          if(bMRTrans[i])
          {
             dMRxx[i] = DoubleFromUI(g_strdup_printf("MRTrans1Spin%d", i));
             dMRyy[i] = DoubleFromUI(g_strdup_printf("MRTrans2Spin%d", i));
             dMRzz[i] = DoubleFromUI(g_strdup_printf("MRTrans3Spin%d", i));
          }
          nMRNmol[i] = IntFromUI(g_strdup_printf("MRNmolSpin%d", i));
          bMREdm[i] = BoolFromUI(g_strdup_printf("MREdmCheck%d", i));
          dMREdmres[i] = DoubleFromUI(g_strdup_printf("MREdmSpin%d", i));
          bMRSeq[i] = BoolFromUI(g_strdup_printf("MRSeqIdeCheck%d", i));
          if(!bMRSeq[i])
             dMRvalue[i] = DoubleFromUI(g_strdup_printf("MRvalue%d", i));
      }

      bMRTSAuto = BoolFromUI("MRTSAuto");
      if(bMRTSAuto)
      {
         dMRTSRot = 0;
         dMRTSRotLoc = 0;
         dMRTSTra = 0;
         dMRTSTraLoc = 0;
      }
      else
      {
         dMRTSRot = DoubleFromUI("MRTSRotSpin");
         dMRTSRotLoc = DoubleFromUI("MRTSRotLocSpin");
         dMRTSTra = DoubleFromUI("MRTSTraSpin");
         dMRTSTraLoc = DoubleFromUI("MRTSTraLocSpin");
         if((dMRTSRot < 0) || (dMRTSRot > 1))
         {
            dMRTSRot = 0;
            DoubleToUI("MRTSRotSpin", dMRTSRot);
         }
         if((dMRTSRotLoc < 0) || (dMRTSRotLoc > 1))
         {
            dMRTSRotLoc = 0;
            DoubleToUI("MRTSRotLocSpin", dMRTSRotLoc);
         }
         if((dMRTSTra < 0) || (dMRTSTra > 1))
         {
            dMRTSTra = 0;
            DoubleToUI("MRTSTraSpin", dMRTSTra);
         }
         if((dMRTSTraLoc < 0) || (dMRTSTraLoc > 1))
         {
            dMRTSTraLoc = 0;
            DoubleToUI("MRTSTraLocSpin", dMRTSTraLoc);
         }
      }
      bMRRes = BoolFromUI("MRmRes");
      if(bMRRes)
      {
         dMRMinres = DoubleFromUI("MRResMinSpin");
         dMRMaxres = DoubleFromUI("MRResMaxSpin");

         if(dMRMinres < dresMax)
            dMRMinres = dresMax;
         if(dMRMaxres > dresMin)
            dMRMaxres = dresMin;
         if(dMRMaxres < dMRMinres)
            dMRMaxres = dMRMinres;
         DoubleToUI("MRResMinSpin", dMRMinres);
         DoubleToUI("MRResMaxSpin", dMRMaxres);

      }
      else
      {
         dMRMinres = dresMax;
         dMRMaxres = dresMin;
      }
      bVLD = BoolFromUI("MRVLDCheck");
//      bFL  = BoolFromUI("MRFLCheck");
//      bAMB = BoolFromUI("MRAMBCheck");
//      whichAMB = ComboValFromUI("MRAMBCombo")-1;
   }
   else if(nProc == SADMAD)
   {
      for(int j=1; j<=maxWaves; j++ )
      {
          std::stringstream name;
          name.str("");
          name << "Wave " << j;
          waveSel[j-1] = BoolFromUI(name.str().c_str());
      }
      useTrialsDefault = BoolFromUI("ntrials_default");
      if(!useTrialsDefault)
         nTrials = IntFromUI("ntrials_spin");
      else
         nTrials = nTrialsDefault();
      useMadFile = BoolFromUI("use_madfile");
      if(!useMadFile)
      {
         allT = BoolFromUI("use_all");
         setN1 = 1;
         setN2 = -1;
         if(!allT)
         {
            setN1 = IntFromUI("bt_n1");
            setN2 = IntFromUI("bt_n2");
         }
      }
      for(int i=0; i<3; i++)
      {
          std::stringstream name;
          name.str("");
          name << "lsq_a" << i;
          lsq_a[i] = BoolFromUI(name.str().c_str());
      }
      for(int i=0; i<2; i++)
      {
          std::stringstream name;
          name.str("");
          name << "lsq_w" << i;
          lsq_w[i] = BoolFromUI(name.str().c_str());
      }
   }
   else if(nProc == REFINE)
   {
      for(int i=0; i<4; i++)
      {
          entry = get_widget(dialog, str_lb[i]);
          if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry)))
             project->phFrom = i;
      }
      entry = get_widget(dialog, "PhRFileEntry");
      CopiaStringa(project->szPhRFile, MaxLenFilename, gtk_entry_get_text(
              GTK_ENTRY(entry)));
   }
   }

// Run

   if(page >= page_RUN)
   {
      bWindow = BoolFromUI("bWindow");
      entry = get_widget(dialog, "inpfile");
      CopiaStringa(InputF, sizeof(InputF), gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
      entry = get_widget(dialog, "outfile");
      CopiaStringa(OutputF, sizeof(OutputF), gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
   }
}

void SirProject::ClearSequence()
{
    memset(szSeqFile, 0, sizeof(szSeqFile));
    szSeqFile[0] = ' ';
    ClearText(get_widget(window, "Seq"));
    gtk_entry_set_text(GTK_ENTRY(get_widget(window, "SeqFile")), szSeqFile);
}

void SirProject::WriteSequence() const
{
      std::string fn = szSeqFile;
      if(!fn.empty())
      {
         std::string sequence = GetTextW(get_widget(window, "Seq"));
         FILE *fp = fOpen(szSeqFile, "w");
         if(fp)
         {
            (void) fputs(sequence.c_str(), fp);
            (void) fclose(fp);
         }
      }
}

void SirProject::ReadSequence() const
{
      std::string fn = szSeqFile;

      gtk_entry_set_text(GTK_ENTRY(get_widget(window, "SeqFile")), szSeqFile);

      if(!fn.empty())
      {
         FILE *fp = fOpen(szSeqFile, "r");
         if( fp)
         {
            gchar *buf = g_new0(gchar, 80);
            std::string buffer = "";
            while(fgets(buf, 80, fp))
               buffer.append (buf);
            fclose(fp);
            put_text(get_widget(window, "Seq"), buffer.c_str ());
            g_free(buf);
         }
      }
}

int SirProject::HeteroAndAnom(std::ostream &os, std::ostream &os1, int *n_anom) const
{
   int nh = 0, na = 0;
   for(int i=0; i<nElements; i++ )
   {
      bool is_anom = false;
      for(int j=0; j<maxWaves; j++ )
      {
         if(std::fabs( dElementF1F2[i][j][0] ) > 0.0001 || std::fabs( dElementF1F2[i][j][1] ) > 0.0001 )
         {
            is_anom = true;
            break;
         }
      }
      if(is_anom )
      {
         os1 << "    Anomalous ";
         os1 << Elem[i] << " " << Amount[i] << " ";
         for(int j=0; j<maxWaves; j++ )
           os1 << dElementF1F2[i][j][0] << " " << dElementF1F2[i][j][1] << " ";
         os1 << std::endl;
         na++;
      }
      else
      {
         os << Elem[i] << " " << Amount[i] << " ";
         nh++;
      }
   }
   *n_anom = na;
   return nh;
}

bool SirProject::SaveSir()
{
    float EPS = 0.00001f;
    Cancella(main_app::TheApp.filesir);
    FILE *fp = fOpen(main_app::TheApp.filesir, "w");
    if(fp == NULL)
       return false;
//279214    fprintf(fp, "%%Window\n");
    if(bWindow)
       fprintf(fp, "%%Window\n");
    else
       fprintf(fp, "%%Nowindow\n");
    fprintf(fp, "%%Structure %s\n", fromUTF8(StructNam).c_str());
    fprintf(fp, "%%Job %s\n", fromUTF8(JobTitle).c_str());
    if( bAMB )
    {
        if(bCAB)
           fprintf(fp, "%%Cab ");
        else
           fprintf(fp, "%%Amb ");
        if((whichAMB < 0) ||  (whichAMB > nAmb))
            whichAMB = 0;
//        std::string amb_str(lower_case(combo_amb[whichAMB]), 0, 3);
        std::string amb_str(combo_amb[whichAMB]);
        fprintf(fp,"%s\n", amb_str.c_str());
    }
    fprintf(fp, "%%Data\n");
    if(ReflFileType == 1)                       // HKL
    {
       fprintf(fp, "    Cell");
       for(int i=0; i<6; i++)
           fprintf(fp, " %.4f", Cell[i]);
       fprintf(fp, "\n");
       if(Cell[6] > EPS)
       {
          fprintf(fp, "    Errors");
          for(int i=0; i<6; i++)
              fprintf(fp, " %.4f", Cell[i+6]);
          if(Cell[12] > EPS)
              fprintf(fp, " %.4f", Cell[12]);
          fprintf(fp, "\n");
       }
       if(FindSpace == 0)
          fprintf(fp, "    Space %s\n", szSpaceGroup);
       else if((FindSpace == 1) && (ifLaue > 1))
          fprintf(fp, "    Space %s\n", CrystSystem[ifLaue-1]);
       else if(FindSpace == 2)
          fprintf(fp, "    Spacegroup Scan \n");
    }
    else                                        // Mtz
    {
       fprintf(fp, "    Mtz %s\n", fromUTF8(szMtzFile).c_str());
       fprintf(fp, "    Label %s\n", szSelectedColumns);
    }

    if(MolType == SMALL)
    {
//       fprintf(fp, "    Cont");
//       for(int i=0; i<nElements; i++)
//           fprintf(fp, " %s %d", Elem[i], Amount[i]);
       fprintf(fp, "    Formula %s\n", GetContent().c_str());
    }
    else if(MolType == MACRO)
    {
       switch(iCont)
       {
       case 0:               // Molecular Weight
           fprintf(fp, "    Weight %lf\n", dCont);
         break;
       case 1:               // Number of residues
           fprintf(fp, "    nResidues %d\n", iround(dCont));
         break;
       case 2:               // Sequence
           fprintf(fp, "    Sequence %s\n", fromUTF8(szSeqFile).c_str());
         break;
       }
     if(nMolecules != 1)
        fprintf(fp, "    nMolecules %d\n", nMolecules);
     std::stringstream strm1;
     if(HeteroAtoms(strm1) && (nProc != SADMAD))
        fprintf(fp, "    Hetatm %s\n", strm1.str().c_str());
    }

    if(Source == 1)
       fprintf(fp, "    Neutrons\n");
    else if(Source == 2)
       fprintf(fp, "    Electrons\n");
#if 0
    if(MolType == 0)
    {
       if(Wavetype == 0)
          fprintf(fp, "    Wavelength Cu\n");
       else if(Wavetype == 1)
          fprintf(fp, "    Wavelength Mo\n");
       else
          fprintf(fp, "    Wavelength %.6f\n", Wavelen);
    }
#endif
    if(ReflFileType == 1)                       // HKL
    {
       fprintf(fp, "    Reflections %s\n", fromUTF8(ReflFile).c_str());
       bool ifmat = false;
       for(int i=0; i<3;i++)
       {
           for(int j=0; j<3; j++)
           {
               if((i == j) && (TMat[i][j] != 1))
                  ifmat = true;
               if((i != j) && (TMat[i][j] != 0))
                  ifmat = true;
           }
       }
       if(ifmat)
       {
          fprintf(fp, "    Orient");
          for(int i=0; i<3;i++)
              for(int j=0; j<3; j++)
                  fprintf(fp," %d", TMat[j][i]);
          fprintf(fp, "\n");
       }
       fprintf(fp, "    Format %s\n", ReflForm);
       if(!ifSigma)
          fprintf(fp, "    nosigma\n");
       if(MinRes > EPS)
          fprintf(fp, "    ResM %.2f\n", MinRes);
       if(Sfac == 0)
          fprintf(fp, "    Fobs\n");
       else
          fprintf(fp, "    Fosq\n");
       if(ThFactor > EPS)
          fprintf(fp, "    BFactor %.3f\n", ThFactor);
    }
    if(nProc == AB_INITIO)
    {
       if(Strategy != S_SA)
          fprintf(fp, "%%Phase\n");
//160614       if(!FindSpace)
       {
          switch(Strategy)
          {
          case S_AUTO:
          default:
               break;
          case S_DM:
               fprintf(fp, "    sdm");
               if(!useDefaults)
               {
                  for(int i=0; i< Nblocks; i++ )
                      fprintf(fp, " %d %d",ToGen[i],ToStore[i]);
               }
               fprintf(fp, "\n");
               break;
          case S_PATT:
               fprintf(fp, "    Patterson");
               if(!useDefaults)
                  fprintf(fp, " %d",ToGen[0]);
               fprintf(fp, "\n");
               break;
          case S_VLD:
               fprintf(fp, "    vld ");
               if(!useDefaults)
                  fprintf(fp, " %d %d",ToGen[0],ToStore[0]);
               fprintf(fp, "\n");
               break;
          case S_MDM:
               fprintf(fp, "    mdm ");
               if(!useDefaults)
                  fprintf(fp, " %d",ToGen[0]);
               fprintf(fp, "\n");
               break;
          case S_SA:
               for(int i=0; i<nFrags; i++)
               {
                   if(!str_white(szFragment[i]))
                      fprintf(fp, "%%Import %s\n", szFragment[i]);
               }
               fprintf(fp, "%%Sannel\n");
               break;
          }
          if((Strategy != S_SA) && (Strategy != S_AUTO))
          {
//             if(StructSize <= 3)
             if((real_dime <= 3) && (Source != 2))
                fprintf(fp, "    Resid %.2f\n", RSoglia);
//210114     if((Strategy == S_DM) || (Strategy == S_PATT))
//210114     {
//210114        if(ifRelax == 1)
//210114           fprintf(fp, "    Relax\n");
//210114        else if(ifRelax == 2)
//210114           fprintf(fp, "    UnRelax\n");
//210114     }
             if(!str_white(Sizes[StructSize-1]))
                fprintf(fp, "    Size %s\n", Sizes[StructSize-1]);
          }
       }
    }
    else if(nProc == REMO)
    {
       fprintf(fp, "%%Remo\n");
       if( bVLD ) fprintf(fp, "    Improve\n");
//       if( bFL ) fprintf(fp, "    FreeLunch\n");
//       if( bAMB ) fprintf(fp, "    Amb\n");
       if( bMRUsePseudo ) fprintf(fp, "    Pseudo\n");
       if (bMRRes)
           fprintf(fp, "    Range   %.2f  %.2f\n", dMRMinres, dMRMaxres);
//       else
//           fprintf(fp, "    Range   0  0\n");
       if(!bMRTSAuto)
           fprintf(fp, "    Threshold   %.2f  %.2f  %.2f %.2f\n",
                    dMRTSRot, dMRTSRotLoc, dMRTSTra, dMRTSTraLoc);
       for(int i=0; i<nMRModels; i++)
       {
           fprintf(fp, "    Model\n");
           if( bMRPolyalanine[i])
               fprintf(fp, "       Polyalanine\n");
           if( bMRCutModel[i])
               fprintf(fp, "       Cut %d %d\n", n1MR[i], n2MR[i]);
           const char *het = bMRUseHetero[i] ? "hetam" : " ";
           fprintf(fp, "       Fragment  %s %s\n", het, fromUTF8(szMRFile[i]).c_str());
           if( bMREdm[i] ) fprintf(fp, "refin\n");
           if(bMRRot[i])
              fprintf(fp, "       RotSelected %d %d %d\n", iMRalfa[i],
                        iMRbeta[i], iMRgamma[i]);
           if(bMRTrans[i])
              fprintf(fp, "       TranSelected %f %f %f\n", dMRxx[i],
                        dMRyy[i], dMRzz[i]);
           fprintf(fp, "       Monomers   %d\n", nMRNmol[i]);
           if(cMRAdp[i] == 'P')
              fprintf(fp, "       BFactor PDB\n");
           else if(cMRAdp[i] == 'W')
              fprintf(fp, "       BFactor Wilson\n");
           else
              fprintf(fp, "       BFactor 20\n");
           if(!bMRSeq[i])
              fprintf(fp, "       IdSeq %lf\n", dMRvalue[i]);
//           else
//              fprintf(fp, "       Rms %lf\n", dMRvalue[i]);
           fprintf(fp, "    EndModel\n");
       }
    }
    else if(nProc == SADMAD)
    {
       std::stringstream strm1, strm2;
       int na;
       if(this->HeteroAndAnom(strm1, strm2, &na))
          fprintf(fp, "    Hetatm %s\n", strm1.str().c_str());
       if(na)
          fprintf(fp, "%s", strm2.str().c_str());
       if(maxWaves)
          fprintf(fp, "    Native\n");
       fprintf(fp, "%%Mad\n");
// Trials
       if(!useTrialsDefault)
          fprintf(fp, "    Patterson %d\n", nTrials);
// Waves
       strm1.str("");
       strm1 << "    Wave";
       int count = 0;
       for(int i=0; i<maxWaves; i++)
       {
           if(waveSel[i])
           {
              count++;
              strm1 << " " << i+1;
           }
       }
       if((count != 0) && (count != maxWaves))
          fprintf(fp, "%s\n", strm1.str().c_str());
// Set
       strm1.str("");
       if(useMadFile)
          strm1 << "    Position " << szMadFile;
       else
       {
          strm1 << "    Set";
          if(allT)
             strm1 << " 1 -1";
          else
             strm1 << " " << setN1 << " " << setN2;
       }
       if(!allT)
          fprintf(fp, "%s\n", strm1.str().c_str());
// LSQ
       int lsqcode = 0, tmpcode = 0;
       for(int i=0; i<3; i++)
       {
           if(lsq_a[i])
              tmpcode = b_set(tmpcode, i);
       }
// e se io volessi affinare solo occ. e B-factor o solo occ. e posizione?
// pezza a colore
       if(tmpcode > 5)
          tmpcode = 5;
       lsqcode = tmpcode*10;
       tmpcode = 0;      
       for(int i=0; i<2; i++)
       {
           if(lsq_w[i])
              tmpcode = b_set(tmpcode, i);
       }
       lsqcode += tmpcode;
       if(lsqcode && (lsqcode != 53))
          fprintf(fp, "    Lsq %d\n", lsqcode);
    }
    else if(nProc == REFINE)
    {
       fprintf(fp, "%%Refine\n");
       if((phFrom >=0 ) && (phFrom < 3))
          fprintf(fp, "   %s \n", str_lb[phFrom]);
       if(!str_white (szPhRFile))
          fprintf(fp, "   Model  %s \n", fromUTF8(szPhRFile).c_str());
    }

    fprintf(fp, "%%End\n");
    fclose(fp);
    return true;
}

int SirProject::CalcolaSize()
{
    if(FindSpace == 0)
    {
       int nonH_au = NNonHtot();
       nonH_au /= SpgrOrder;
       if(nonH_au <= 5)
          StructSize = 1;
       else if((nonH_au > 5) && (nonH_au <= 80))
          StructSize = 2;
       else if((nonH_au > 80) && (nonH_au <= 300))
          StructSize = 3;
       else if((nonH_au > 300) && (nonH_au <= 600))
          StructSize = 4;
       else if((nonH_au > 600) && (nonH_au <= 1000))
          StructSize = 5;
       else if((nonH_au > 1000) && (nonH_au <= 1750))
          StructSize = 6;
       else
          StructSize = 7;
    }
    else
       StructSize = 8;
    return StructSize;
}

int SirProject::MtzGetInfo(gpointer mtzi)
{
    float cell[6];
    float resMin, resMax;
    int nsympx, nspgrx;
    char ltypex[256], spgrnx[256], pgnamx[256];
    CMtz::MTZ *mtzin;
    const std::string fn = fromUTF8(szMtzFile);

    if(mtzi == NULL)
       mtzin = CMtz::MtzGet(fn.c_str(), 0);
    else
       mtzin = (CMtz::MTZ* )mtzi;

    if(mtzin == NULL)
       return 0;

    CMtz::MtzResLimits(mtzin, &resMin, &resMax);
    if(MRabs(resMin) > EPS)
       dresMin = (float) (1.0 / sqrt((double)resMin));
    if(MRabs(resMax) > EPS)
       dresMax = (float) (1.0 / sqrt((double)resMax));

    CMtz::ccp4_lrsymi(mtzin, &nsympx, ltypex, &nspgrx,
       spgrnx, pgnamx);
    if(str_white(szSpaceGroup))   
       CopiaStringa(szSpaceGroup, sizeof(szSpaceGroup), spgrnx);
    CSym::CCP4SPG *spg = CSym::ccp4spg_load_by_spgname(szSpaceGroup);
    if(!spg)
       return -1;
    SpgrOrder = spg->nsymop;
    CSym::ccp4spg_free(&spg);

    CMtz::ccp4_lrcell(MtzIxtal(mtzin, 0), cell);
    for(int i=0; i<6; i++)
        Cell[i] = cell[i];
    return 1;
 }

void SirProject::FillFromMTZ(GtkWidget *dlg, std::string fn)
{
    if(str_white(fn.c_str()))
    {
       GtkWidget *w = get_widget(dlg,"MtzTitleEntry");
       gtk_entry_set_text(GTK_ENTRY(w), " ");
       w = get_widget(dlg, "MtzSpgEntry");
       gtk_entry_set_text(GTK_ENTRY(w), " ");
       w = get_widget(dlg, "MtzCellEntry");
       gtk_entry_set_text(GTK_ENTRY(w), " ");
       w = get_widget(dlg, "MtzFileEntry");
       gtk_entry_set_text(GTK_ENTRY(w), " ");
       w = get_widget(dlg, "MtzSpgFind");
       gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(w), FALSE);
       return;
    }
    if( !g_file_test(fn.c_str(), G_FILE_TEST_EXISTS) )
       return;
    MtzSelected.clear();
    CMtz::MTZ *mtzin;
    mtzin = CMtz::MtzGet(fn.c_str(), 0);
    if( mtzin==0 )
        return;

    MtzGetInfo(mtzin);
    char titl[1024];
    CMtz::ccp4_lrtitl(mtzin, titl);
    GtkWidget *w = get_widget(dlg,"MtzTitleEntry");
    gtk_entry_set_text(GTK_ENTRY(w), titl);
    w = get_widget(dlg, "MtzFileEntry");
    gtk_entry_set_text(GTK_ENTRY(w), fn.c_str());
    w = get_widget(dlg, "MtzColumnsEntry");
    gtk_text_buffer_set_text(gtk_text_view_get_buffer(GTK_TEXT_VIEW(w)),
              toUTF8(szSelectedColumns), -1);

    std::stringstream tcell;
    tcell  << Cell[0] << " " << Cell[1] << " "
             << Cell[2] << " " << Cell[3] << " " << Cell[4] << " " << Cell[5];
    w = get_widget(dlg, "MtzSpgEntry");
    gtk_entry_set_text(GTK_ENTRY(w), szSpaceGroup);
    w = get_widget(dlg, "MtzCellEntry");
    gtk_entry_set_text(GTK_ENTRY(w), tcell.str().c_str());
    FillMtzVectors(mtzin);
    clear_mtz(0, dlg);
    if(strlen(szSelectedColumns) > 0)
    {
       GList *SelectedColumns = fill_list(szSelectedColumns, " ");
       if(SelectedColumns)
       {
          int nsc = (int) g_list_length(SelectedColumns);
          int i;
          for(i=0; i<nsc; i++)
          {
              char *pstr = (char *)g_list_nth_data(SelectedColumns, i);
              add_mtz_val(pstr, 0);
              g_free(pstr);
          }
          g_list_free(SelectedColumns);
       }
    }
}

std::string SirProject::GetFilename(const gchar *suffix) const
{
    std::string r(StructNam);
    gchar *fn = NULL;

    r += suffix;
    fn = g_build_filename(WorkDir, r.c_str(), NULL);
    r = fn;
    g_free(fn);
    return r;
}

void SirProject::update_windinfo (int npag)
{
   GtkWidget *text;
   std::stringstream strm;

   text = get_widget(window, "testo");
   clear_windinfo();
   if((npag == page_SPGR) && (ReflFileType == 2))
       return;
   if((npag == page_CELL) && (ReflFileType == 2))
       return;
   if((npag == page_MTZ) && (ReflFileType == 1))
       return;
   switch(npag)
   {
   case page_GENERAL:
        strm << "Structure name:        " << StructNam << "\n";
        strm << "Working directory:     " << WorkDir << "\n";
        strm << "Job title:             " << JobTitle << "\n";
        strm << "Procedure type:        " << procedures[nProc] << "\n";
        strm << "Reflections file type: " << refls[ReflFileType] << "\n";
        break;
   case page_MTZ:
   case page_SPGR:
   case page_CELL:
        if(!str_white(szSpaceGroup))
        {
            CSym::CCP4SPG *spg = CSym::ccp4spg_load_by_spgname(szSpaceGroup);
            if( spg!=0 )
            {
                strm << "Space group name:  " << spg->symbol_xHM << "\n";
                strm << "            Hall:  " << spg->symbol_Hall << "\n";
                strm << "            No:    " << spg->spg_num << "\n";
                strm << "            Order: " << spg->nsymop << "\n";
                strm << "Point group:       " << spg->point_group << "\n";
                strm << "Laue class:        " << spg->laue_name << "\n";
                BuildSymmOps(spg, strm);
                CSym::ccp4spg_free(&spg);
            }
        }
        if(npag > page_SPGR)
                strm << "Cell volume:       " << project->Volume() << "\n";
        if(npag == page_MTZ)
        {
            CMtz::MTZ *mtzin;
            const std::string fn = fromUTF8(szMtzFile);
            mtzin = CMtz::MtzGet(fn.c_str(), 0);
            if(mtzin != NULL)
            {
               float resMin, resMax;
               float dresMin=0, dresMax=0;
               int nNrRefl = CMtz::MtzNref(mtzin);
               strm << "\nNumber of Reflections: " << nNrRefl << "\n";
               CMtz::MtzResLimits(mtzin, &resMin, &resMax);
               try
               {
                   dresMin = (float) (1.0 / sqrt((double)resMin));
                   dresMax = (float) (1.0 / sqrt((double)resMax));
               }
               catch(...)
               {
               }
               if((MRabs(dresMin) > EPS) && (MRabs(dresMax) > EPS))
                   strm << "Resolution Range:       (" << dresMax <<" - "
                        << dresMin << " A)" << "\n";
            }
        }
        break;
        case page_CONTENT:
        if(MolType == MACRO)
           strm << "Estimated cell composition:\n";
        else if(MolType == SMALL)
           strm << "Unit cell contents:\n";
        Content(strm);
        strm << std::endl;

        break;
   }
   put_text(text, strm.str().c_str(), "big");
}

void SirProject::FillFromPDB(int wM)
{
   if((min_resid[wM] != 0) && (max_resid[wM] != 0))
   {
      gtk_widget_set_sensitive(get_widget(window,g_strdup_printf(
         "MRCutCheck%d", wM)), TRUE);
      BoolToUI(g_strdup_printf("MRCutCheck%d", wM), bMRCutModel[wM]);
      if(bMRCutModel[wM])
      {
         IntToUI(g_strdup_printf("MRn1Spin%d", wM), n1MR[wM]);
         IntToUI(g_strdup_printf("MRn2Spin%d", wM), n2MR[wM]);
         if(n1MR[wM] < min_resid[wM])
            IntToUI(g_strdup_printf("MRn1Spin%d", wM), min_resid[wM]);
         if(n2MR[wM] > max_resid[wM])
            IntToUI(g_strdup_printf("MRn2Spin%d", wM), max_resid[wM]);
         if(n1MR[wM] > n2MR[wM])
            IntToUI(g_strdup_printf("MRn1Spin%d", wM), n2MR[wM]);
      }
      else
      {
          IntToUI(g_strdup_printf("MRn1Spin%d", wM), min_resid[wM]);
          IntToUI(g_strdup_printf("MRn2Spin%d", wM), max_resid[wM]);
      }
   }
   else
      gtk_widget_set_sensitive(get_widget(window,g_strdup_printf(
              "MRCutCheck%d", wM)), FALSE);
   entry_set_range ( get_widget(window,g_strdup_printf("MRn1Spin%d", wM)),
          min_resid[wM], max_resid[wM]);
   entry_set_range ( get_widget(window,g_strdup_printf("MRn2Spin%d", wM)),
          min_resid[wM], max_resid[wM]);

   set_tip ( get_widget(window,g_strdup_printf("MRn1Spin%d", wM)),
              g_strdup_printf("min = %d, max = %d", min_resid[wM],
              max_resid[wM]));
   set_tip ( get_widget(window,g_strdup_printf("MRn2Spin%d", wM)),
              g_strdup_printf("min = %d, max = %d", min_resid[wM],
              max_resid[wM]));
}
void SirProject::CheckPDBFile(const std::string &fn, int which)
{
    int nresid0, nresid1, nresidui;
    Read_PDB(fn, nresid0, nresid1, nresidui);
    min_resid[which] = nresid0;
    max_resid[which] = nresid1;
    n_residui[which] = nresidui;
}

}   // end namespace Sir

        
static gchar *backwd;
static gchar *binfile;
static gboolean old = FALSE;
extern    GtkWidget *finestre[6];
extern    gboolean can_drag, auto_newproj;
extern    int larSaveN, altSaveN;
extern    stringa     *It;
extern gchar *Sigle[NUMSPECIES];
extern gchar *Specie[NUMSPECIES];
extern int nSpec;
GdkColor colorWhite = {0, 65535, 65535, 65535};

static int oldPos = -1;
static int nCards = page_RUN; //6;
static int curPag = 1;
int ipages[] = {1, 0, 2, 3, 4, 5, 6};
static GtkWidget *np_dialog = NULL;
static GtkWidget *notebook = NULL;
//static const gchar *col_titles[4] = { "Element", "N. in cell", "Delta f'","f''"};

static int intervalli[] = {1, 3, 16, 75, 143, 195};
static const char *famiglia[] = {"Triclinic", "Monoclinic", "Orthorombic",
                           "Tetragonal", "Hexagonal", "Cubic"};
static const char *condizioni[] = {" ", "alpha = gamma = 90", 
                             "alpha = beta = gamma = 90",
                             "a = b; alpha = beta = gamma = 90",
                             "a = b; alpha = beta = 90; gamma = 120",
                             "a = b = c; alpha = beta = gamma = 90"};

float  fvalues[13];
float  emin, emax;
static float elist[4000];  
static int blocchi[20];  
int    nstr;
int vspace = 4;
int cellconditions[14];
nomefile vcurdir;

void call_fortran(char *inpFile, char *outFile, const char *tipo);
GtkWidget *i_refle(GtkWidget *parent, GtkWidget *wheresetdata);

void HidePage(GtkWidget *dlg, int pag)
{
    char key[8];

    ScriviStringa(key, sizeof(key), "vbox%d", pag);
    GtkWidget *vbox = get_widget(dlg, key);
    gtk_widget_set_sensitive(vbox, FALSE);
    gtk_widget_hide(vbox);
}

void ShowPage(GtkWidget *dlg, int pag)
{
    char key[8];

    ScriviStringa(key, sizeof(key), "vbox%d", pag);
    GtkWidget *vbox = get_widget(dlg, key);
    gtk_widget_set_sensitive(vbox, TRUE);
    gtk_widget_show(vbox);
}

GtkWidget *createSelectionM(GtkWidget *parent, GtkWidget *parentbox,
          const char *title[], const char *id, int ncol, const char *col)
{  
  GtkWidget *scrollwin, *dirsel, *label, *frame;
  GtkListStore *store;
  GtkCellRenderer *renderer;
  GtkTreeViewColumn *column;
  GType *types = g_new0(GType, ncol);
  int i;

 for(i=0; i<ncol; i++)
     types[i] = G_TYPE_STRING;

  frame = gtk_frame_new(NULL);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 6);
  if(parentbox)
  {
     if (GTK_IS_BOX(G_OBJECT(parentbox)))
         gtk_box_pack_start (GTK_BOX (parentbox), frame, TRUE, TRUE, 0);
     else if (GTK_IS_CONTAINER(G_OBJECT(parentbox)))
         gtk_container_add(GTK_CONTAINER(parentbox), frame);
  }
  gtk_widget_show (frame);

  scrollwin = gtk_scrolled_window_new (NULL, NULL);
  gtk_container_add(GTK_CONTAINER(frame), scrollwin);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrollwin),
                                   GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
  gtk_widget_show (scrollwin);
  dirsel = gtk_tree_view_new();
  g_object_set_data(G_OBJECT(dirsel), "formato", GINT_TO_POINTER(ncol));
  g_object_set_data(G_OBJECT(dirsel), "frame", frame);

  store = gtk_list_store_newv(ncol, types);
  renderer = gtk_cell_renderer_text_new ();
  for(i=0; i<ncol; i++)
  {
        column = gtk_tree_view_column_new_with_attributes (title[i],
//            renderer, "markup", i, NULL);
            renderer, "text", i, NULL);
        gtk_tree_view_column_set_clickable(column, FALSE);
        gtk_tree_view_append_column (GTK_TREE_VIEW(dirsel), column); 
        if(title && title[i])
        {
           label = LABEL_NEW(title[i], col);
           gtk_widget_show (label);
           gtk_tree_view_column_set_widget(column, label);
        }
  }
  gtk_tree_view_set_model(GTK_TREE_VIEW(dirsel), GTK_TREE_MODEL (store));
  g_object_set_data(G_OBJECT (parent), id, dirsel);
  gtk_widget_show (dirsel);
  gtk_container_add (GTK_CONTAINER (scrollwin), dirsel);
  if(!title)
      gtk_tree_view_set_headers_visible(GTK_TREE_VIEW(dirsel), FALSE);
  return dirsel;
}

void add_line_to_listM(GtkWidget *list, char *line[])
{
    GtkListStore *list_store;
    GtkTreeIter iter;
    int i, ncol = get_int(list, "formato");

    list_store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(list)));
    gtk_list_store_append (list_store, &iter);
    for(i=0; i<ncol; i++)
       gtk_list_store_set (list_store, &iter, i, line[i],-1);
}

int avvisa_fortran(int code)
{

/*     code = 1:    close & delete     */
/*     code = 2:    close  */

  int ier = 0;
  chiudi_bin_(&code, &ier);
  return ier;
}

void clear_txt_files()
{
   int i;
   nomefile filnam;

   for (i=1; i<nCards; i++)
   {
       ScriviStringa(filnam, MaxLenFilename, "newproj%d.txt", i);
       Cancella(filnam);
   }
}

char *struct_to_prj(char *nomestru)
{
   char *string, *suffix;
   unsigned int i;
   size_t sz = strlen(nomestru) + strlen(PK) + 6;
                                                                                                                       
   string = g_new0(char, sz);
   suffix = g_strdup_printf("%s", PK);
   for(i=0; i<strlen(suffix); i++)
           suffix[i] = tolower(suffix[i]);
   ScriviStringa(string, sz, "%s_%s.prj", fromUTF8(nomestru).c_str(), suffix);
   return string;
}

bool write_file(GtkWidget *dialog)
{
using namespace Sir;
   project->ReadForm(dialog);
   const std::string fn = struct_to_prj(project->StructNam);
   if(!project->SirSave(fn, dialog))
      return false;
   return (project->SaveSir());
}

void close_newproj_dlg(GtkButton *button, gpointer data)
{
    void draw_initial_pixmap();

    clear_txt_files();
    close_dlg(button, GINT_TO_POINTER(1));
    if(auto_newproj)
    {
       auto_newproj = FALSE;
       draw_initial_pixmap();
       //gtk_main_quit();
    }
}

void riapribin(GtkButton *button, gpointer data)
{
   prj->ifProject = 0;       // !!!!!!!!!!!!!!!!!!!!!!!!!
   if(old)
   {
      ScriviStringa(vcurdir, MaxLenFilename, "%s%c%s",backwd, G_DIR_SEPARATOR, binfile);
      load_recent_project(NULL, vcurdir);
   }
}

void clear_windinfo(void)
{
   GtkWidget *text;

   text = get_widget(np_dialog, "testo");
   if(GTK_IS_TEXT_VIEW(text))
   {
      GtkTextIter start, end;
      GtkTextBuffer *text_buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(text));
      gtk_text_buffer_get_bounds (text_buffer, &start, &end);
      gtk_text_buffer_delete(text_buffer, &start, &end);
   }
   else 
      gtk_label_set_text(GTK_LABEL(text), " ");
}

int c_newproject_symm(char *spg, int cellconditions[])
{
   int l1, ier;

   l1 = 17;

   newproject_symm_(&ier, spg, cellconditions, l1);
   return ier;
}

void swp (GtkNotebook *nb, gint page_num,
                                             gpointer user_data)
{
       return;
/*
    int npag;
    GtkWidget *widget;
    gint ipage = gtk_notebook_get_current_page(nb);
//  ipage    ==> da dove vengo
//  page_num ==> dove devo andare

    if(ipage == page_num)
       return;
    widget = gtk_notebook_get_tab_label(GTK_NOTEBOOK(notebook), 
            gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook), page_num));
    if(!gtk_widget_get_sensitive(widget))
    {
       g_signal_stop_emission_by_name(G_OBJECT (notebook), "change-current-page");
       return;
    }
*/

/* // ???????????????
    if(page_num > curPag)
        npag = curPag;
    else
        npag = page_num;
// ??????????????? */

/*
    npag = page_num;

//070309    if(npag < nCards)
    if(npag < ipage)
       update_windinfo(npag+1);
    else
    {
       char filnam[20];
       ScriviStringa(filnam, sizeof(filnam), "newproj%d.txt", npag+1);
       if(g_file_test(filnam, G_FILE_TEST_EXISTS))
          update_windinfo(npag+1);
       else
         clear_windinfo();
    }
    if(npag == 1)
    {
       widget = get_widget(np_dialog, "space_group");
       gtk_widget_grab_focus(widget);
    }
*/
}

int check_conditions(GtkWidget *dlg)
{
    int i, ier;
    
    ier = 0;
    for(i = 0; i<6; i++)
    {
        if(cellconditions[i] != -100)
        {
           if(i < 3)
           {
              if(MRabs(fvalues[i]-fvalues[0])  > 0.001 )
                 ier = -1;
           }
           else
           {
              if(MRabs(fvalues[i]-(float)cellconditions[i])  > 0.001 )
                 ier = -1;
           }
        }
    }
    if(ier)
    {
       MessageDialog(dlg, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, 
           "Cell parameters not compatible with conditions for a %s cell:\n     %s",
           famiglia[cellconditions[13]-1], condizioni[cellconditions[13]-1]);

    }
    return ier;
}

void aggiungi_blocchi(GtkWidget *dlg, int nelem)
{
    GtkWidget *frame;
    int i, j;

    frame = get_widget(dlg, "defaults");
    int sensitive = !gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(frame));
    frame = get_widget(dlg, "lista_blocchi");
    spin_button_set_value(get_widget(frame, "nblocchi"), nelem);
    j = 0;
    for(i=1; i<=nelem; i++)
    {
       char nome[20];
       ScriviStringa(nome, sizeof(nome), "G%d", i);
       spin_button_set_value(get_widget(frame, nome), blocchi[j]);
       gtk_widget_set_sensitive(get_widget(frame, nome), sensitive);
       ScriviStringa(nome, sizeof(nome), "S%d", i);
       spin_button_set_value(get_widget(frame, nome), blocchi[j+1]);
       gtk_widget_set_sensitive(get_widget(frame, nome), sensitive);
       ScriviStringa(nome, sizeof(nome), "block%dlabel", i);
       set_label_text(get_widget(frame, nome), g_strdup_printf("%d", i) , MyBLUE, 0.99f);
       gtk_widget_set_sensitive(get_widget(frame, nome), sensitive);
       j += 2;
    }
    if(!sensitive)
       spin_button_set_value(get_widget(frame, "nblocchi"), 1);
}

int leggi_blocchi(GtkWidget *dialog)
{
    GtkWidget *frame;
    int i, j, rows;

    frame = get_widget(dialog, "lista_blocchi");
    rows = spin_button_get_value_as_int(get_widget(frame, "nblocchi"));
    j = 0;
    for(i=1; i<=rows; i++)
    {
       char nome[20];
       ScriviStringa(nome, sizeof(nome), "G%d", i);
       blocchi[j] = spin_button_get_value_as_int(get_widget(frame, nome));
       ScriviStringa(nome, sizeof(nome), "S%d", i);
       blocchi[j+1] = spin_button_get_value_as_int(get_widget(frame, nome));
       j += 2;
    }
    for(i=rows+1; i<=MaxBlocks; i++)
    {
       blocchi[j] = 0;
       blocchi[j+1] = 0;
       j += 2;
    }
    return rows;
}

void riempi_blocchi_e_relax(GtkWidget *dialog, float valori[])
{
    GtkWidget *entry;

    entry = get_widget(dialog, "Relax");
    gtk_widget_set_sensitive(entry, TRUE);
    switch((int)valori[7])
    {
        case -2:
               gtk_widget_set_sensitive(entry, FALSE);
               break;
        case -1:
               entry = get_widget(dialog, "Never");
               gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry), TRUE);
               break;
        case 0:
               entry = get_widget(dialog, "Automatic");
               gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry), TRUE);
               break;
        case 1:
               entry = get_widget(dialog, "Always");
               gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry), TRUE);
               break;
     }
/* riboh 011210
//     if(valori[0])                     //boh 130308
     if(valori[4] > 3)
        gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(get_widget(dialog, "PattersonCheck")), TRUE);
     else
        gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(get_widget(dialog, "TangentCheck")), TRUE);
*/
     switch((int)valori[0]+1)
     {
     case S_AUTO:
       gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(get_widget(dialog, "AutoCheck")), TRUE);
       break;
     case S_DM:
       gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(get_widget(dialog, "TangentCheck")), TRUE);
       break;
     case S_PATT:
       gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(get_widget(dialog, "PattersonCheck")), TRUE);
       break;
     case S_VLD:
       gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(get_widget(dialog, "VLDCheck")), TRUE);
       break;
     case S_MDM:
       gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(get_widget(dialog, "MDMCheck")), TRUE);
       break;
     case S_SA:
       gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(get_widget(dialog, "SACheck")), TRUE);
       break;
     }

     MaxBlocks = (int)valori[6];
     if(ktest == 0)
        aggiungi_blocchi(dialog, (int) valori[5]);
}

int riempi_newproj(char *string1, GtkWidget *dialog)
{
using namespace Sir;
   std::string fn = fromUTF8(string1);
   int errore = project->SirOpen(fn, dialog);
   project->FillForm(dialog);
   return errore;
}

int check_spacegroup(GtkWidget *Entry, GtkWidget *dialog, float symop_r[])
{
using namespace Sir;
     char *string0 = g_new0(char, 80);
     GtkWidget *entry;
     int i, spgnum, ifSilent = 1;

     ScriviStringa(string0, 80, "%s", gtk_editable_get_chars(GTK_EDITABLE(Entry), 0, -1));
     if(str_white(string0))
     {
        MessageDialog(dialog, GTK_MESSAGE_WARNING, GTK_BUTTONS_CANCEL, "You must select a space group! ");
        return -1;
     }
     entry = get_widget(get_widget(dialog, "space_group"), "entry");
     gtk_entry_set_text(GTK_ENTRY(entry), get_spg(g_strstrip(string0), ifSilent));
     ifSilent = 1 - ifSilent;
     spgnum = GetSpgNum(get_spg(g_strstrip(string0), ifSilent), symop_r);

     if(spgnum == -1)
        return -1;
     for (i=5; i>=0; i--)
     {
        if(spgnum >= intervalli[i])
           break;
     }
     if(i < 0)
     {
        MessageDialog(dialog, GTK_MESSAGE_ERROR, GTK_BUTTONS_CANCEL, 
              g_strdup_printf("Error in SpaceGroup Number '%d'!", spgnum));
        return -1;
     }
     return spgnum;
}

#if 0
void on_cb_attiva_single(GtkToggleButton *button, GtkWidget *dlg)
{
     if(gtk_toggle_button_get_active(button))
     {
        gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(get_widget(dlg, waves[2])), TRUE);
        gtk_widget_set_sensitive(get_widget(dlg, waves[0]), FALSE);
        gtk_widget_set_sensitive(get_widget(dlg, waves[1]), FALSE);
     }
     else
     {
        gtk_widget_set_sensitive(get_widget(dlg, waves[0]), TRUE);
        gtk_widget_set_sensitive(get_widget(dlg, waves[1]), TRUE);
        gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(get_widget(dlg, waves[1])), TRUE);
     }
}
#endif

void show_models(GtkWidget *dlg, int nModels)
{
  for(int i=0; i<MAX_MODELS; i++)
  {
      if(i < nModels)
         gtk_widget_show(get_widget(dlg,g_strdup_printf("MRModel%d",i)));
      else
         gtk_widget_hide(get_widget(dlg,g_strdup_printf("MRModel%d",i)));
  }
}

void PreparaSolve(GtkWidget *dialog)
{
using namespace Sir;
     project->FindSpace = find_space(dialog);
     GtkWidget *frame = get_widget(dialog, "Frame_solve");
//240214     gtk_widget_set_sensitive(frame, !project->FindSpace);
     gtk_widget_set_sensitive(frame, true);
//NEW 160414
     dime = nsizes;
     GtkWidget *entry = get_widget(dialog, "combosize");
     combo_set_val(entry, dime);
     if(project->FindSpace)
     {
//        dime = nsizes;
//170614        entry = get_widget(dialog, "AutoCheck");
//170614        gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry), TRUE);
//        entry = get_widget(dialog, "combosize");
//        combo_set_val(entry, dime);
        entry = get_widget(dialog, "labelsize");
        gtk_label_set_text (GTK_LABEL (entry), labsizes[dime-1]);
        if(ktest != 1)
        {
           entry = get_widget(dialog, "AutoCheck");
           gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry), TRUE);
        }
        return;
     }
     else
     {
        entry = get_widget(dialog, "labelsize");
        gtk_label_set_text (GTK_LABEL (entry), labsizes[real_dime-1]);
     }
// END NEW

     if(project->nProc == AB_INITIO)
     {
        GtkWidget *soglia = get_widget(dialog, "Rsoglia_l");
        if((real_dime <= 3) && (project->Source != 2))
           gtk_widget_show(soglia);
        else
           gtk_widget_hide(soglia);
        if(ktest != 1)
        {
           entry = get_widget(dialog, "AutoCheck");
#if 0
           if(dime <= 3)
           {
//030214      if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry)))
//030214         entry = get_widget(dialog, "TangentCheck");
//030214      else
                 entry = get_widget(dialog, "MDMCheck");
//                 entry = get_widget(dialog, "VLDCheck");
           }
           else
              entry = get_widget(dialog, "PattersonCheck");
#endif
           gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry), TRUE);
//160414           entry = get_widget(dialog, "combosize");
//160414           combo_set_val(entry, dime);
//160414           entry = get_widget(dialog, "labelsize");
//160414           gtk_label_set_text (GTK_LABEL (entry), labsizes[dime-1]);
//        riempi_blocchi_e_relax(dialog, valori);
//                  nblocchi_def = (int) valori[5];
//        for(i=0; i<nblocchi_def*2; i++)
//            blocchi_def[i] = blocchi[i];
        }
     }
     else if(project->nProc == REMO)
     {
//        entry = get_widget(dialog, "MRFLCheck");
//        gtk_widget_set_sensitive(entry, (project->dresMax > 1.2));
        show_models(dialog, project->nMRModels);
     }
}

void c_finish_tune(float valori[])
{
   can_drag = FALSE;
   fortran_al_lavoro();
   finish_tune_(valori, blocchi);
   fine_lavoro();
}

int check_data(int pag, GtkWidget *dialog)
{
using namespace Sir;
using namespace gtkext;
    GtkWidget *entry, *box, *pix1, *pix2, *widget, *frame1, *frame2,
              *frame3, *frame4;
    char  *string1, *string2, stringf[17];
    char filnam[MaxLenFilename];
    int i, ier;
    struct stat s;
    gint status;
    FILE *fp; //, *fp1;
//    int c_finish_tune(float valori[]);

    memset(filnam, 0, sizeof(filnam));
    string1 = g_new0(char, MaxLenFilename);
    string2 = g_new0(char, MaxLenFilename);
    ier = 0;

    switch(pag)
    {
    case page_GENERAL:                               /* General */
    case -page_GENERAL:
         project->ReadForm(dialog, page_GENERAL);
         ier = dir_set_current(project->WorkDir);
         if(ier != 0)
         {
            MessageDialog(dialog, GTK_MESSAGE_WARNING, GTK_BUTTONS_CLOSE, "Error in dir_set_current %s", project->WorkDir);
            return ier;
         }
         CopiaStringa(SWareRC->WorkingDirectory, MaxLenFilename, project->WorkDir);
         if(strlen(project->StructNam) <= 0)
         {
            MessageDialog(dialog, GTK_MESSAGE_WARNING, GTK_BUTTONS_CLOSE, "You must specify a structure name!");
            return -2;
         }

/* setta il nome del file dei riflessi    */
         entry = get_widget(dialog, "rpc_file");
         ScriviStringa(string1, MaxLenFilename, "%s", 
           gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));

         if(str_white(string1))
         {
            ScriviStringa(string2, MaxLenFilename, "%s%s.hkl", 
                SWareRC->WorkingDirectory, project->StructNam);
//new 180308
            if(g_file_test(string2, G_FILE_TEST_EXISTS))
            {
               gtk_entry_set_text(GTK_ENTRY(entry), string2);
               entry = get_widget(dialog, "preview_b");
               gtk_button_clicked(GTK_BUTTON(entry));
            }
            else
               gtk_entry_set_text(GTK_ENTRY(entry), " ");
         }

         entry = get_widget(dialog, "structfile");
         ScriviStringa(string1, MaxLenFilename, "%s", 
           gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
         if(!string1 || (strlen(string1) <= 0))
            ScriviStringa(string1, MaxLenFilename, "%s_sir.prj", project->StructNam);
         status = stat ( fromUTF8(string1).c_str(), &s);
         if((status == 0) && (pag < 0))
         {
            int error = riempi_newproj(string1, np_dialog);
//            if(!error) 
               ktest = 1;
            return error;
         }

         if(project->MolType == 0)
         {
            MessageDialog(dialog, GTK_MESSAGE_WARNING, GTK_BUTTONS_CLOSE, "You must specify a molecule size!");
            return -2;
         }
         if(project->nProc == 0)
         {
            MessageDialog(dialog, GTK_MESSAGE_WARNING, GTK_BUTTONS_CLOSE, "You must specify a procedure!");
            return -2;
         }
         frame1 = get_widget(dialog, "frame_elements");
         frame2 = get_widget(dialog, "molecular_unit");
         if(project->MolType == SMALL)
         {
            gtk_widget_show(frame1);
            gtk_widget_hide(frame2);
         }
         else if(project->MolType == MACRO)
         {
            gtk_widget_hide(frame1);
            gtk_widget_show(frame2);
         }

         entry = get_widget(dialog, "Frame_solve");  
         widget = get_widget(dialog, "Frame_remo");  
         frame4 = get_widget(dialog, "Frame_refine");
         frame3 = get_widget(dialog, "Frame_mad");
         frame1 = get_widget(dialog, "frameLig");
         frame2 = get_widget(dialog, "frameMad");
         if(project->nProc == AB_INITIO)
         {
            gtk_widget_show(entry);
            gtk_widget_hide(widget);
            gtk_widget_hide(frame1);
            gtk_widget_hide(frame2);
            gtk_widget_hide(frame3);
            gtk_widget_hide(frame4);
         }
         else if(project->nProc == REMO)
         {
            gtk_widget_hide(entry);
            gtk_widget_hide(frame3);
            gtk_widget_hide(frame4);
            gtk_widget_show(widget);
            //130219entry = get_widget(dialog, molsizes[1]);
            //130219gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry), TRUE);
            gtk_widget_show(frame1);
            gtk_widget_hide(frame2);
         }
         else if(project->nProc == SADMAD)
         {
            gtk_widget_hide(entry);
            gtk_widget_hide(widget);
            //130219entry = get_widget(dialog, molsizes[1]);
            //130219gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry), TRUE);
            //gtk_widget_hide(frame);
            gtk_widget_hide(frame1);
            gtk_widget_hide(frame4);
            gtk_widget_show(frame2);
            gtk_widget_show(frame3);
         }
         else if(project->nProc == REFINE)
         {
            gtk_widget_hide(entry);
            gtk_widget_hide(widget);
            gtk_widget_show(frame1);
            gtk_widget_hide(frame2);
            gtk_widget_hide(frame3);
            gtk_widget_show(frame4);
         }
         if(project->ReflFileType == 0)
         {
            MessageDialog(dialog, GTK_MESSAGE_WARNING, GTK_BUTTONS_CLOSE, "You must specify a reflections file type!");
            return -2;
         }
         if(project->ReflFileType == 1)
         {
            HidePage(dialog, page_MTZ);
            ShowPage(dialog, page_CELL);
         }
         else
         {
            HidePage(dialog, page_CELL);
            entry = get_widget(dialog, "MtzHint");
            if(project->nProc == SADMAD)
               set_label_text(entry, "Select F, sigF for protein if available"
               " and F+,sigF+, F-,sigF- for every wavelength", MyBLUE, 1.1f);
            else if(project->nProc == REFINE)
               set_label_text(entry, "Select F, sigF, PhiCalc and Fom",
                 MyBLUE, 1.1f);
            else
               set_label_text(entry,"Select F, sigF for protein", MyBLUE, 1.1f);
            ShowPage(dialog, page_MTZ);
         }
            ScriviStringa(main_app::TheApp.filesir, MaxLenFilename, "%s.sir", project->StructNam);
            ScriviStringa(main_app::TheApp.fileout, MaxLenFilename, "%s.out", project->StructNam);
            entry = get_widget(dialog, "inpfile");
            gtk_entry_set_text(GTK_ENTRY(entry), toUTF8(main_app::TheApp.filesir));
            entry = get_widget(dialog, "outfile");
            gtk_entry_set_text(GTK_ENTRY(entry), toUTF8(main_app::TheApp.fileout));
            box = get_widget(dialog, "inpfileex");
            pix1 = get_widget(box, "pix1");
            pix2 = get_widget(box, "pix2");
            status = stat (fromUTF8(main_app::TheApp.filesir).c_str(), &s);
            if(status == 0)
            {
               gtk_widget_hide(pix1);
               gtk_widget_show(pix2);
            }
            else
            {
               gtk_widget_hide(pix2);
               gtk_widget_show(pix1);
            }
            box = get_widget(dialog, "outfileex");
            pix1 = get_widget(box, "pix1");
            pix2 = get_widget(box, "pix2");
            status = stat (fromUTF8(main_app::TheApp.fileout).c_str(), &s);
            if(status == 0)
            {
               gtk_widget_hide(pix1);
               gtk_widget_show(pix2);
            }
            else
            {
               gtk_widget_hide(pix2);
               gtk_widget_show(pix1);
            }
 
         break;

    case page_SPGR:                              /* Symmetry */
         break;

    case page_CELL:                                  /* Cell conditions */ 
         if(project->ReflFileType != 1)
            return 0;
         project->ReadForm(dialog, page_CELL);

         if(project->FindSpace == 0)
         {
            if(str_white(project->szSpaceGroup))
              return -2;
            ScriviStringa(stringf, sizeof(stringf), "%16.16s", project->szSpaceGroup);
            ier = c_newproject_symm(stringf, cellconditions);
         }

         for(i=0; i<13; i++)
         {
            if(i < 6)
            {
                if(project->Cell[i] < EPS)
                {
                    MessageDialog(dialog, GTK_MESSAGE_WARNING, GTK_BUTTONS_CLOSE, 
                          "You must specify a value for %s", cell_data[i]);
                    return -5;
                }
            }
         }

         if((ktest == 2) && !project->FindSpace)
         {
           ier = check_conditions(dialog);
           return ier;
         }
         widget = get_widget(dialog, "vol_cell");
         if(widget)
         {
            entry = get_widget(dialog, "vol_cell");
            gtk_label_set_text(GTK_LABEL(entry),fToStr(project->Volume(), 4).c_str());
            box = get_widget(dialog, "lista_elements");
            project->ChangeVolPerAt();
         }
         ShowPage(dialog, page_CONTENT);
         break;

    case page_MTZ:                                  /* Mtz File */
         if(project->ReflFileType != 2)
            return 0;
         project->ReadForm(dialog, page_MTZ);
         widget = get_widget(dialog, "MtzFileEntry");
         {
         const char *fil = gtk_entry_get_text(GTK_ENTRY(widget));
         if(str_white(fil))
         {
            MessageDialog(dialog, GTK_MESSAGE_WARNING, GTK_BUTTONS_CLOSE, 
                          "You must specify a MTZ file");
            return -1;
         }
         if( !g_file_test(fil, G_FILE_TEST_EXISTS) )
         {
            MessageDialog(dialog, GTK_MESSAGE_WARNING, GTK_BUTTONS_CLOSE, 
                          "File %s does not exist", fil);
            return -1;
         }
         if(MtzSelected.size() < 2 )
         {
            MessageDialog(dialog, GTK_MESSAGE_WARNING, GTK_BUTTONS_CLOSE, 
                          "You should select columns");
            return -1;
         }
         int countE = 0, countF = 0, countP = 0, countW = 0;
         for(unsigned int i=0; i< MtzSelected.size(); i++)
         {
             char typ = MtzSelected[i]->type[0];
             if( typ=='P' )
                 countP++;
             if( typ=='W' )
                 countW++;
             if( typ=='Q' || typ=='L' )
                 countE++;
             if( typ=='F' || typ=='G' || typ=='J')
                 countF++;
         }
         if((project->nProc == AB_INITIO) || (project->nProc == REMO) ||
             (project->nProc == REFINE))
         {
             if(project->nProc == REFINE)
             {
                if(countP != 1)
                {
                   MessageDialog(dialog, GTK_MESSAGE_WARNING, GTK_BUTTONS_CLOSE, 
                    "You have to select one calculated phase!");
                   return -1;
                }
                if(countW != 1)
                {
                   MessageDialog(dialog, GTK_MESSAGE_WARNING, GTK_BUTTONS_CLOSE, 
                    "You have to select FOM!");
                   return -1;
                }
             }
             if((countF != 1) || (countE != 1))
             {
                MessageDialog(dialog, GTK_MESSAGE_WARNING, GTK_BUTTONS_CLOSE, 
                 "You have to select one F-sigF pair!");
                return -1;
             }
         }
         else          // SADMAD
         {
             if( countF != countE )
             {
                 MessageDialog(dialog, GTK_MESSAGE_WARNING, GTK_BUTTONS_CLOSE,
                 "You have to select F-sigF pairs!");
                return -1;
              }
              project->maxWaves = countE / 2;
              int ctot = (int)MtzSelected.size() - 3;
              project->bNative = ((ctot % 4) != 0);
              //spin_button_set_range(get_widget(dialog, "nWaves"), 0, maxw);
              for(int j=1; j<=SIR_MAX_WAVES; j++ )
              {
                  std::stringstream name;
                  name.str("");
                  name << "LabWave" << j;
                  widget = get_widget(dialog, name.str().c_str());
                  gtk_widget_set_sensitive(widget, (j<=project->maxWaves));
                  name.str("");
                  name << "Wave " << j;
                  widget = get_widget(dialog, name.str().c_str());
                  gtk_widget_set_sensitive(widget, (j<=project->maxWaves));
                  project->BoolToUI(name.str().c_str(), project->waveSel[j-1]);
                  for(int i=1; i<=SIR_MAX_ELEMENTS; i++ )
                  {
                     for(int k=1; k<=2; k++ )
                     {
                        name.str("");
                        name << "ContE" << i << "W" << j << "F" << k << "Spin";
                        widget = get_widget(dialog, name.str().c_str());
                        gtk_widget_set_sensitive(widget,(j<=project->maxWaves));
                     }
                  }
              }

         }
         }
         widget = get_widget(dialog, "vol_cell");
         if(widget)
         {
            entry = get_widget(dialog, "vol_cell");
            gtk_label_set_text(GTK_LABEL(entry),fToStr(project->Volume(), 4).c_str());
            box = get_widget(dialog, "lista_elements");
            project->ChangeVolPerAt();
         }
         ShowPage(dialog, page_CONTENT);
         break;

    case page_CONTENT:                                  /* Cell content */
         project->ReadForm(dialog, page_CONTENT);
         if((project->MolType == SMALL) &&(project->nElements == 0))
         {
             MessageDialog(dialog, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, 
                              "Incorrect unit cell content ");
             return -1;
         }
         if((project->MolType == MACRO) &&(project->dCont <= 0))
         {
             MessageDialog(dialog, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, 
                              "Incorrect unit cell content ");
             return -1;
         }
         for(i=0; i<project->nElements; i++)
         {
             if(IsValidElement(g_strstrip(project->Elem[i])))
             {
                if(project->Amount[i] == 0)
                {
                   MessageDialog(dialog, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, 
                              "Incorrect unit cell content ");
                   return -1;
                }
             }
             else
             {
                MessageDialog(dialog, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, 
                              "Incorrect unit cell content ");
                return -1;
             }
         }
         project->ChangeVolPerAt();
         if(project->nProc == SADMAD)
         {
              for(int j=0; j<project->maxWaves; j++ )
              {
                  for(int i=0; i<project->nElements; i++ )
                  {
                      if((MRabs(project->dElementF1F2[i][j][0])<0.0001 )||
                         (MRabs(project->dElementF1F2[i][j][1])<0.0001))
                      {
                         MessageDialog(dialog, GTK_MESSAGE_ERROR,
                           GTK_BUTTONS_CLOSE, "f' and/or f'' are not present");
                         return -1;
                      }
                  }
              }
         }
         entry = gtk_notebook_get_tab_label (GTK_NOTEBOOK (notebook),
          gtk_notebook_get_nth_page (GTK_NOTEBOOK(notebook), page_SOLVE-1));

         if(project->nProc == REFINE)
            gtk_label_set_text (GTK_LABEL (entry), "Refine"); 
         else
            gtk_label_set_text (GTK_LABEL (entry), "Solve"); 

         entry = get_widget(dialog, "minreslabel");
         gtk_label_set_text(GTK_LABEL(entry), "Min. resolution value (Angstrom):");
         entry = get_widget(dialog, "thfaclabel");
         gtk_label_set_text(GTK_LABEL(entry), "User supplied thermal factor:");
         if(project->ReflFileType == 1)
            ShowPage(dialog, page_REFL);
         else
            ShowPage(dialog, page_SOLVE);
         real_dime = project->CalcolaSize();
         if(project->ReflFileType != 1)
            PreparaSolve(dialog);
         break;

    case page_REFL:                                  /* Reflections */
         if(project->ReflFileType != 1)
            return 0;
         project->ReadForm(dialog, page_REFL);
         ier = dir_set_current(SWareRC->WorkingDirectory);
         if(str_white(project->ReflFile))
         {
            MessageDialog(dialog, GTK_MESSAGE_WARNING, GTK_BUTTONS_CLOSE, 
                              "You must specify a reflections file!");
            return -4;
         }
         fp = fOpen(project->ReflFile, "r");
         if(fp == NULL)
         {
            MessageDialog(dialog, GTK_MESSAGE_WARNING, GTK_BUTTONS_CLOSE, 
                "Error in open file: %s", project->ReflFile);
            return -4;
         }
         (void) fclose (fp);
         ShowPage(dialog, page_SOLVE);
         PreparaSolve(dialog);
         break;

    case page_SOLVE:                                  /* Solve */
         project->ReadForm(dialog, page_SOLVE);
         if(project->nProc == REMO)
         {
            if(project->dMRMinres < project->dresMax)
            project->dMRMinres = project->dresMax;
            if(project->dMRMaxres > project->dresMin)
               project->dMRMaxres = project->dresMin;
            if(project->dMRMaxres <= project->dMRMinres)
            {
               MessageDialog(dialog, GTK_MESSAGE_WARNING,
                        GTK_BUTTONS_CLOSE, "Incorrect resolution range");
               return -5;
            }
            for(int i=0; i<project->nMRModels; i++)
            {
                if( str_white(project->szMRFile[i]) ) 
                {
                    MessageDialog(dialog, GTK_MESSAGE_WARNING,
                        GTK_BUTTONS_CLOSE, "Empty PDB filename entry");
                    return -5;
                }
                if( !g_file_test(project->szMRFile[i], G_FILE_TEST_EXISTS) )
                {
                    MessageDialog(dialog, GTK_MESSAGE_WARNING,
                        GTK_BUTTONS_CLOSE, "Model file does not exist");
                    return -5;
                }
            }
         }
         else if(project->nProc == SADMAD)
         {
            if(project->useMadFile)
            {
                if( str_white(project->szMadFile) )
                {
                    MessageDialog(dialog, GTK_MESSAGE_WARNING,
                        GTK_BUTTONS_CLOSE, "Empty PDB filename entry");
                    return -5;
                }
                if( !g_file_test(project->szMadFile, G_FILE_TEST_EXISTS) )
                {
                    MessageDialog(dialog, GTK_MESSAGE_WARNING,
                        GTK_BUTTONS_CLOSE, "Anomalous scattered positions file does not exist");
                    return -5;
                }
            }
            else if(!project->allT)
            {
                if(project->setN1 > project->setN2)
                {
                   MessageDialog(dialog, GTK_MESSAGE_WARNING,
                        GTK_BUTTONS_CLOSE, "Incorrect best trials range");
                   return -5;
                }
            }
         }
         else if(project->nProc == REFINE)
         {
              if( !str_white(project->szPhRFile) )
              {
                if( !g_file_test(project->szPhRFile, G_FILE_TEST_EXISTS) )
                {
                    MessageDialog(dialog, GTK_MESSAGE_WARNING,
                        GTK_BUTTONS_CLOSE, "Model file does not exist");
                    return -5;
                }
              }
         }

         ShowPage(dialog, page_RUN);
         break;

    case page_RUN:
         ier = GTK_RESPONSE_YES;
         entry = get_widget(dialog, "inpfile");
         ScriviStringa(main_app::TheApp.filesir, MaxLenFilename, gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
         entry = get_widget(dialog, "outfile");
         ScriviStringa(main_app::TheApp.fileout, MaxLenFilename, gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));

         status = stat (main_app::TheApp.filesir, &s);
         if (status == 0)
            ier = MessageDialog(dialog, GTK_MESSAGE_QUESTION, GTK_BUTTONS_YES_NO,
                 "File already exists. OK to overwrite %s?", main_app::TheApp.filesir); 
         if(ier != GTK_RESPONSE_YES)
            return -1;
         status = stat (main_app::TheApp.fileout, &s);
         if (status == 0)
             ier = MessageDialog(dialog, GTK_MESSAGE_QUESTION, GTK_BUTTONS_YES_NO,
                 "File already exists. OK to overwrite %s?", main_app::TheApp.fileout); 
         if(ier != GTK_RESPONSE_YES)
            return -1;
         entry = get_widget(dialog, "cancel_button");
         bool result = write_file(np_dialog);
         if(!result)
         {
              MessageDialog(dialog, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, 
             "Error in save project file");
           return -1;
         }
         close_newproj_dlg(GTK_BUTTON(entry), GINT_TO_POINTER(0));

         ier = 0;
         if(ier == 0)
         {
           GtkWidget *dlg = gtk_message_dialog_new(
               GTK_WINDOW(finestre[0]),GTK_DIALOG_MODAL,
               GTK_MESSAGE_QUESTION, GTK_BUTTONS_NONE, 
               "File: %s has been created.\n"
               "Do you want edit it, run or quit?", main_app::TheApp.filesir);
           GtkWidget *button1 =  myimage_button("  _Edit", "edit.png");
           gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button1, 1);
           button1 =  myimage_button("    _Go", "go.png");
           gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button1, 2);
           button1 = QUIT_button();
           gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button1, 3);
           int response = gtk_dialog_run(GTK_DIALOG(dlg));
           gtk_widget_destroy(dlg);
           switch(response)
           {
           case 3:
           default:
                riapribin(NULL, NULL);
                return 0;
                break;
           case 1:
                text_window(GTK_WINDOW(finestre[0]), main_app::TheApp.filesir, "*.sir",
                   IFPROP + IFSAVE, main_app::TheApp.filesir);
                break;
           case 2:
                break;
           }
           call_fortran(main_app::TheApp.filesir, main_app::TheApp.fileout, "sir");
         }
         break;
    }
    return ier;
}
void change_pag(int pag, gboolean flag)
{
using namespace Sir;
    if(pag <= nCards)
    {
        if(pag > curPag)
           curPag = pag;
        if(flag)
           gtk_notebook_set_current_page(GTK_NOTEBOOK(notebook), pag);
        project->update_windinfo(pag);
    }
}

int check_space(GtkWidget *dialog)
{
using namespace Sir;
     char *string0 = g_new0(char, 80);
     GtkWidget *entry;
     int i, spgnum;
     float symop_r[3];

     if(ktest == 0)                   // New Project
     {
         entry = get_widget(dialog, "CellPar");
         set_label_text(entry, " ", "red", 1.05f);
         for(i = 0; i<13; i++)
         {
            entry = get_widget(dialog, cell_data[i]);
            gtk_entry_set_text(GTK_ENTRY(entry), "  ");
         }
     }

     entry = get_widget(dialog, "entry_spg");
     string0 = combo_get_text(entry);
     if(str_white(string0))
        return -1;
     spgnum = GetSpgNum(get_spg(g_strstrip(string0), 0), symop_r);
     if(spgnum == -1)
        return -1;
     if(CheckSpace(dialog, spgnum, symop_r, ktest) < 0)
        return -1;
     return 0;
}

int on_accept_clicked (GtkWidget *button, gpointer pag)
{
using namespace Sir;
    int npag, ier, i;
    GtkWidget *vbox;

    npag = GPOINTER_TO_INT(pag);
    if(npag == page_SPGR)
    {
       if(project->ReflFileType == 2)
         return 0;
       if(find_space(np_dialog) || ((ier = check_space(np_dialog)) == 0))
       {
          vbox = get_widget(np_dialog, "cell_param");
          gtk_widget_set_sensitive (vbox, TRUE);
          vbox = get_widget(np_dialog, "accept2");
          gtk_widget_set_sensitive (vbox, TRUE);
          project->ReadForm(np_dialog, page_SPGR);
          change_pag(npag, FALSE);
       }
       else
       {
          vbox = get_widget(np_dialog, "cell_param");
          gtk_widget_set_sensitive (vbox, FALSE);
          vbox = get_widget(np_dialog, "accept2");
          gtk_widget_set_sensitive (vbox, FALSE);
          for(i=3; i<=nCards; i++)  /* disabilita pagine seguenti */
              HidePage(np_dialog, i);
       }
       return ier;
    }
    if((ier = check_data (npag, np_dialog)) == 0)
    {
       if(npag < nCards)
       {
          change_pag(npag, FALSE);
//110208          change_pag(npag, TRUE);
       }
    }
    else
    {
       for(i=npag+1; i<=nCards; i++)  /* disabilita pagine seguenti */
            HidePage(np_dialog, i);
    }
    return ier;
}

void bottoni_e_titolo(GtkWidget *vbox, int npag, const char *title)
{
  GtkWidget *button, *label;
  gchar key[8];

  ScriviStringa(key, sizeof(key), "vbox%d", npag);
  g_object_set_data(G_OBJECT(gtk_widget_get_toplevel(vbox)), 
           key, vbox);
  GtkWidget *dlg = gtk_widget_get_toplevel(vbox);
  GtkWidget *hbuttonbox = hbutton_box_new();
  gtk_widget_show(hbuttonbox);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(hbuttonbox), GTK_BUTTONBOX_SPREAD);
  gtk_box_pack_end (GTK_BOX (vbox), hbuttonbox, FALSE, FALSE, 4);

  if(npag < nCards)
  {
     button = myimage_button ("_Accept", "apply.png");
     gtk_widget_set_name(button, "accept");
     ScriviStringa(key, sizeof(key), "accept%d", npag);
     g_object_set_data(G_OBJECT(gtk_widget_get_toplevel(vbox)), 
           key, button);
     gtk_container_add (GTK_CONTAINER (hbuttonbox), button);
     set_tip (button, "Click to confirm supplied data");
     (void) g_signal_connect (G_OBJECT(button), "clicked", 
             G_CALLBACK(on_accept_clicked), GINT_TO_POINTER(npag));
  }
  else
     button = get_widget(gtk_widget_get_toplevel(vbox), "accept6");

  GtkWidget *cancel_button = myimage_button("  _Cancel", "cancel.png");
  if(npag == nCards)
     g_object_set_data (G_OBJECT (dlg), "cancel_button",
                            cancel_button);
  gtk_container_add (GTK_CONTAINER (hbuttonbox), cancel_button);
  set_tip (cancel_button, "Abandon the New Project procedure");
  gtk_widget_show (cancel_button);
  (void) g_signal_connect (G_OBJECT(cancel_button), "clicked",
              G_CALLBACK(close_newproj_dlg), GINT_TO_POINTER(0));
  (void) g_signal_connect_after (G_OBJECT(cancel_button), "clicked",
              G_CALLBACK(riapribin), NULL);

  if(npag <= nCards)
  {
     std::string new_string = "  (<span foreground=\"red\"> * </span>)";
     new_string.append(" Required field");
     //if(npag < nCards)
     //   new_string.append("\n  Check results below");
     label = LABEL_BOLD("", MSGCOLOR, 1.1f);
     gtk_label_set_markup(GTK_LABEL(label), new_string.c_str());
     gtk_widget_show(label);
     set_alignment(label, 0., 1.);
     gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, FALSE, vspace);
  }

  if(npag == 2)
     gtk_widget_set_sensitive(button, FALSE);
  gtk_widget_grab_focus(button);
  gtk_widget_show (button);

  set_tab_label (GTK_NOTEBOOK (notebook),  npag-1, title); 
}

void on_title_changed(GtkEditable *entry, gpointer data)
{
   char *str;

   str =  g_strdup_printf("New Project for: %s", 
               gtk_editable_get_chars(entry, 0, -1));
   gtk_window_set_title(GTK_WINDOW(gtk_widget_get_toplevel(GTK_WIDGET(entry))), 
                         str);
}

void on_filename_changed(GtkEditable *entry, GtkWidget *box)
{
   GtkWidget *pix1, *pix2;
   nomefile filnam;
   gint status;
   struct stat s;

   ScriviStringa(filnam, MaxLenFilename, "%s", gtk_editable_get_chars(entry, 0, -1));
   pix1 = get_widget(box, "pix1");
   pix2 = get_widget(box, "pix2");
   status = stat (filnam, &s);
   if(status == 0)
   {
      gtk_widget_hide(pix1);
      gtk_widget_show(pix2);
   }
   else
   {
      gtk_widget_hide(pix2);
      gtk_widget_show(pix1);
   }
}

void change_molimage(GtkToggleButton *but, GtkWidget *box)
{
   GtkWidget *pix1, *pix2;

   pix1 = get_widget(box, "pix_small");
   pix2 = get_widget(box, "pix_macro");
   if(gtk_toggle_button_get_active(but))
   {
      gtk_widget_hide(pix1);
      gtk_widget_show(pix2);
   }
   else
   {
      gtk_widget_hide(pix2);
      gtk_widget_show(pix1);
   }
}

void to_open_file(GtkButton *button, gpointer data)
{
  GtkWidget *accept;
  int exitCode;
  int tipofile = GPOINTER_TO_INT(data);

  if(np_dialog)
     gtk_widget_set_sensitive(np_dialog, FALSE);
  exitCode = open_file(NULL, data);
  if(np_dialog)
     gtk_widget_set_sensitive(np_dialog, TRUE);
  if(tipofile == 9)
  {
     if(exitCode > 0)
     {
        if(check_data(-1, np_dialog) == -1)
           return;
        gtk_widget_set_sensitive(get_widget(np_dialog, "vbox2"), TRUE);
        gtk_widget_show(get_widget(np_dialog, "vbox2"));
        change_pag(1, 1);
        for(int i=0; i<nCards; i++)
        {
            ktest = 1;
            accept = get_widget(np_dialog, g_strdup_printf("accept%d", ipages[i]));
            if(on_accept_clicked(accept, GINT_TO_POINTER(ipages[i])))
               break;
//            gtk_button_clicked(GTK_BUTTON(accept));
        }
        gtk_notebook_set_current_page(GTK_NOTEBOOK(get_widget(np_dialog, "notebook")), 0);
     }
  }
  else if(tipofile == 8)
  {
       GtkWidget *dlg = gtk_widget_get_toplevel(GTK_WIDGET(button));
       GtkWidget *entry = get_widget(dlg, "Format3");
       gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry), TRUE);
       gtk_button_clicked(GTK_BUTTON(get_widget(dlg, "preview_b")));
       entry = get_widget(GTK_WIDGET(button), "entry");
       char *formato = g_new0(char, 40);
       int ifsigma;
       char *fnam = g_strdup(fromUTF8(gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1)).c_str());
       getformat_(fnam, formato, &ifsigma, strlen(fnam), (size_t) 39);
       formato[39] = 0;
       entry = get_widget(dlg, "format");
       gtk_entry_set_text(GTK_ENTRY(entry), g_strstrip(formato));
       entry = get_widget(dlg, "ifsigma");
       gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry), !ifsigma);
//       g_print("formato %s\n", formato);
  }
}

void to_select_dir(GtkWidget *button, gpointer data)
{
using namespace gtkext;

  GtkWidget *dlg = gtk_widget_get_toplevel(button);
  gtk_widget_set_sensitive(dlg, FALSE);
  GtkWidget *entry = get_widget(button, "entry");
  std::string wd = gtk_entry_get_text(GTK_ENTRY(entry));
  wd = dlg_select_file(dlg, wd, eSELECT_DIR, "*");
  gtk_widget_set_sensitive(dlg, TRUE);
  if(!str_white(wd.c_str()))
  {
     GtkWidget *entry = get_widget(button, "entry");
     gtk_entry_set_text(GTK_ENTRY(entry), wd.c_str());
     dir_set_current(wd.c_str());
  }
}

static void fill_combo_amb(GtkCellLayout *w,
                      GtkCellRenderer   *renderer,
                      GtkTreeModel      *model,
                      GtkTreeIter       *iter,
                      gpointer           data)
{
    char *line;
    gtk_tree_model_get (GTK_TREE_MODEL(data), iter, 1, &line, -1);
    if(line != NULL)
    {
       if(find_program_in_path(line))
          g_object_set(G_OBJECT(renderer), "sensitive", TRUE, NULL);
       else
          g_object_set(G_OBJECT(renderer), "sensitive", FALSE, NULL);
    }
}

GtkWidget *FrameSize(GtkWidget *vbox2, GtkWidget *father)
{
  GSList *grp3_group = NULL;
  GtkWidget *frame1 = NEW_FRAME ("Molecule size", &FrameStyle);
  gtk_widget_show (frame1);
  gtk_box_pack_start (GTK_BOX (vbox2), frame1, FALSE, FALSE, 0);
  g_object_set_data (G_OBJECT (father), "frame_molsize", frame1);

//  vbox1 = vbox_new (FALSE, 4);
  GtkSizeGroup *sz = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
  GtkWidget *vbox1 = hbox_new (FALSE, 4);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (get_widget(frame1, "align")), vbox1);
  gtk_container_set_border_width (GTK_CONTAINER (vbox1), 4);

  for(int i=0; i< (int)(sizeof(molsizes)/sizeof(molsizes[0])); i++)
  {
      GtkWidget *radiobutton = RADIO_BUTTON_WITH_LABEL (grp3_group, molsizes[i], LABELCOLOR);
      gtk_size_group_add_widget(sz, radiobutton);
      grp3_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton));
      g_object_set_data (G_OBJECT (father), molsizes[i], radiobutton);
      if(i)
         gtk_widget_show (radiobutton);
      gtk_box_pack_start (GTK_BOX (vbox1), radiobutton, FALSE, FALSE, 0);
#if 0
      if(i == 0)
      {
         g_signal_connect (G_OBJECT(radiobutton), "toggled",
                      G_CALLBACK(on_cb_show), frameEl);
         g_signal_connect (G_OBJECT(radiobutton), "toggled",
                      G_CALLBACK(on_cb_hide), frameMu);
      }
      else
      {
         g_signal_connect (G_OBJECT(radiobutton), "toggled",
                      G_CALLBACK(on_cb_hide), frameEl);
         g_signal_connect (G_OBJECT(radiobutton), "toggled",
                      G_CALLBACK(on_cb_show), frameMu);
      }
#endif
  }
  return frame1;
}

void selected_molsize(GtkToggleButton *button, gpointer)
{
  gboolean active = gtk_toggle_button_get_active(button);
  GtkWidget *dlg = gtk_widget_get_toplevel(GTK_WIDGET(button));
  GtkWidget *frame_pro = get_widget(dlg, "procedure");
  int to_activate = 0;
  if(active)
     to_activate = AB_INITIO;
  GtkWidget *check_pro = get_widget(dlg, procedures[to_activate]);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check_pro),  TRUE);
  gtk_widget_set_sensitive(frame_pro, !active);
  GtkWidget *frame_amb = get_widget(dlg, "AMBframe");
  gboolean sensitive = get_int(frame_amb, "sensitive");
  sensitive &= (!active);
  gtk_widget_set_sensitive(frame_amb, sensitive);
  check_pro = get_widget(dlg, "bWindow");
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check_pro),  active);
}

void page1(GtkWidget *notebook, GtkWidget *new_project_dlg)
{
  GtkWidget *vbox;
  GtkWidget *label;
  GtkWidget *frame;
  GtkWidget *table;
  GtkWidget *entry;
//  GtkWidget *dirsel;

  vbox = vbox_new (FALSE, vspace);
  gtk_widget_show (vbox);
  gtk_container_add (GTK_CONTAINER (notebook), vbox);

  //GtkWidget *align = gtk_alignment_new(0, 0, 0.6f, 1);
  //gtk_widget_show(align);
  //gtk_box_pack_start (GTK_BOX(vbox), align, TRUE, TRUE, 0);
  GtkWidget *vbox1 = vbox_new (FALSE, vspace);
  gtk_widget_show (vbox1);
  //gtk_container_add (GTK_CONTAINER (align), vbox1);
#ifdef IN_GTK3
  gtk_widget_set_vexpand(vbox1, TRUE);
#endif
  gtk_box_pack_start (GTK_BOX(vbox), vbox1, TRUE, TRUE, 0);

  table = table_new (5, 2, FALSE);
  table_set_col_spacings(table, 2);
  table_set_row_spacings(table, 6);
  gtk_widget_show(table);
  gtk_box_pack_start (GTK_BOX(vbox1), table, TRUE, TRUE, 0);

  label = entry_for_fileselection("User Working Directory", NULL,
             G_CALLBACK(to_select_dir), NULL, 0, 1, MyBLUE);
  gtk_container_set_border_width(GTK_CONTAINER(label), 6);
  gtk_widget_show (label);
  table_attach(table, label, 0, 2, 0, 1, TRUE);
  g_object_set_data(G_OBJECT(new_project_dlg), "workdir", get_widget(label, "entry"));

  label = entry_for_fileselection("Structure name or previous project", NULL,
             G_CALLBACK(to_open_file), GINT_TO_POINTER(9), 0, 1, MyRED);
  table_attach(table, label, 0, 2, 1, 2, TRUE);
  set_mandatory(get_widget(label, "label"));

  gtk_container_set_border_width(GTK_CONTAINER(label), 6);
  entry = get_widget(label, "entry");
  g_object_set_data(G_OBJECT(new_project_dlg), "structnam", entry);
  gtk_editable_set_editable(GTK_EDITABLE(entry), TRUE);
  set_tip (entry, "Enter the name of the structure or recover an old one by clicking on Browse button");
  g_signal_connect (G_OBJECT(entry), "changed",
                   G_CALLBACK (on_title_changed), NULL);

  entry = gtk_entry_new ();
  g_object_set_data(G_OBJECT(new_project_dlg), "structfile", entry);

  frame = vbox_new(FALSE, 0);
  gtk_widget_show(frame);
  gtk_container_set_border_width(GTK_CONTAINER(frame), 6);
  table_attach(table, frame, 0, 2, 2, 3, TRUE);
  label = LABEL_BOLD("Job title", MyBLUE, 1.05f);
  gtk_widget_show(label);
  gtk_box_pack_start(GTK_BOX(frame), label, FALSE, FALSE, 0);
  set_alignment(label, 0., 0.5);

  label = gtk_entry_new();
  gtk_widget_show(label);
  gtk_box_pack_start(GTK_BOX(frame), label, FALSE, FALSE, 2);
  g_object_set_data(G_OBJECT(new_project_dlg), "job", label);

  GtkWidget *frame1 = FrameSize(frame, new_project_dlg);
  g_object_set_data(G_OBJECT(new_project_dlg), "molsize", frame1);
  set_mandatory(gtk_frame_get_label_widget(GTK_FRAME(frame1)));

  frame = NEW_FRAME("Procedure", &FrameStyle);
  gtk_widget_show(frame);
  gtk_container_set_border_width(GTK_CONTAINER(frame), 6);
  table_attach_exp(table, frame, 0, 1, 3, 4);
  set_mandatory(gtk_frame_get_label_widget(GTK_FRAME(frame)));
  vbox1 = vbox_new(FALSE, 0);
  gtk_widget_show(vbox1);
  gtk_container_add(GTK_CONTAINER(get_widget(frame, "align")), vbox1);
  g_object_set_data(G_OBJECT(new_project_dlg), "procedure", frame);

  GSList *group = NULL;
  for(int i=0; i< (int)(sizeof(procedures)/sizeof(procedures[0])); i++)
  {
      GtkWidget *radiobutton = RADIO_BUTTON_WITH_LABEL (group, procedures[i], NULL);
      group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton));
      g_object_set_data (G_OBJECT (new_project_dlg), procedures[i], radiobutton);
      if(i)
         gtk_widget_show (radiobutton);
      gtk_box_pack_start (GTK_BOX (vbox1), radiobutton, FALSE, FALSE, 0);
  }
  GtkWidget *w = get_widget(new_project_dlg, molsizes[SMALL]);
  g_signal_connect(G_OBJECT(w), "toggled", G_CALLBACK(selected_molsize),
      NULL);

  frame = NEW_FRAME("Reflections", &FrameStyle);
  gtk_widget_show(frame);
  gtk_container_set_border_width(GTK_CONTAINER(frame), 6);
  table_attach_exp(table, frame, 1, 2, 3, 4);
  set_mandatory(gtk_frame_get_label_widget(GTK_FRAME(frame)));
  vbox1 = vbox_new(FALSE, 0);
  gtk_widget_show(vbox1);
  gtk_container_add(GTK_CONTAINER(get_widget(frame, "align")), vbox1);

  group = NULL;
  for(int i=0; i< (int)(sizeof(refls)/sizeof(refls[0])); i++)
  {
      GtkWidget *radiobutton = RADIO_BUTTON_WITH_LABEL (group, refls[i], NULL);
      group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton));
      g_object_set_data (G_OBJECT (new_project_dlg), refls[i], radiobutton);
      if(i)
         gtk_widget_show (radiobutton);
      gtk_box_pack_start (GTK_BOX (vbox1), radiobutton, FALSE, FALSE, 0);
  }

  frame = NEW_FRAME(NULL, &FrameStyle);
  gtk_widget_show(frame);
  table_attach_exp(table, frame, 0, 2, 4, 5);
  gtk_container_set_border_width(GTK_CONTAINER(frame), 6);
  GtkWidget *AMBCheck = CHECK_BUTTON_WITH_LABEL
        ("Automated Model Building (Macromolecules only)",  MyBLUE);
  gtk_widget_show(AMBCheck);
  gtk_frame_set_label_widget(GTK_FRAME(frame), AMBCheck);
  GtkWidget *vb = vbox_new(FALSE, 0);
  gtk_widget_show(vb);
  add_to_frame(frame, vb);
//  gtk_box_pack_start(GTK_BOX(vb), AMBCheck, FALSE, FALSE, 2);
  HOOKUP_OBJECT (new_project_dlg, AMBCheck, "AMBCheck");
  HOOKUP_OBJECT (new_project_dlg, frame, "AMBframe");
  gboolean sensitive = FALSE;
  for(int k=0; k<(int) G_N_ELEMENTS(combo_amb); k++)
      sensitive |= (find_program_in_path(combo_amb_prg[k]) != NULL);
  gtk_widget_set_sensitive(AMBCheck, sensitive);
  g_object_set_data (G_OBJECT (frame), "sensitive", GINT_TO_POINTER(sensitive));
  GtkTreeStore *store = gtk_tree_store_new(2, G_TYPE_STRING, G_TYPE_STRING);
  GtkWidget *AMBCombo = gtk_combo_box_new_with_model(GTK_TREE_MODEL(store));
  GtkCellRenderer *renderer = gtk_cell_renderer_text_new();
  gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(AMBCombo), renderer, TRUE);
  gtk_cell_layout_add_attribute(GTK_CELL_LAYOUT(AMBCombo), renderer, "text", 0);
  gtk_cell_layout_set_cell_data_func (GTK_CELL_LAYOUT(AMBCombo), renderer,
            fill_combo_amb, (gpointer)store, NULL);
  GtkTreeIter iter;
  for(int k=0; k<(int) G_N_ELEMENTS(combo_amb); k++)
  {
       gtk_tree_store_append(store, &iter, NULL);
       gtk_tree_store_set(store, &iter, 0, combo_amb[k],
                                        1, combo_amb_prg[k], -1);
  }

  gtk_box_pack_start(GTK_BOX(vb), AMBCombo, FALSE, FALSE, 2);
  gtk_widget_show(AMBCombo);
  HOOKUP_OBJECT (new_project_dlg, AMBCombo, "AMBCombo");
  gtk_widget_set_sensitive(AMBCombo, FALSE);

  GtkWidget *CABCheck = CHECK_BUTTON_WITH_LABEL
        ("Use CAB procedure",  MyBLUE);
  gtk_box_pack_start(GTK_BOX(vb), CABCheck, FALSE, FALSE, 2);
  gtk_widget_show(CABCheck);
  HOOKUP_OBJECT (new_project_dlg, CABCheck, "CABCheck");
  gtk_widget_set_sensitive(CABCheck, FALSE);
  g_signal_connect(G_OBJECT(AMBCheck), "toggled", G_CALLBACK(on_cb_attiva),
        AMBCombo);
  g_signal_connect(G_OBJECT(AMBCheck), "toggled", G_CALLBACK(on_cb_attiva),
        CABCheck);


  bottoni_e_titolo(vbox, page_GENERAL, "General");
  label = get_widget(new_project_dlg, "accept1");
  entry = get_widget(new_project_dlg, "structnam");
  g_signal_connect_swapped(G_OBJECT(entry), "activate",
             G_CALLBACK(gtk_button_clicked), G_OBJECT(label));
}

void on_find_space(GtkToggleButton *button, gpointer data)
{
   GtkWidget *wid;
   GtkWidget *dlg = gtk_widget_get_toplevel(GTK_WIDGET(button));
   if(ktest == 2)
   {
        wid = get_widget(dlg, "okbutton");
        gtk_widget_set_sensitive(wid, gtk_toggle_button_get_active(button));
        return;
   }
   wid = lookup_widget(GTK_WIDGET(button), "cell_param");
   gtk_widget_set_sensitive(wid, gtk_toggle_button_get_active(button));
   if(dlg == np_dialog)
   {
      wid = lookup_widget(GTK_WIDGET(button), "accept2");
      gtk_widget_set_sensitive(wid, gtk_toggle_button_get_active(button));
   }
   wid = lookup_widget(GTK_WIDGET(button), "CellPar");
/* tmp 070207
   if(gtk_toggle_button_get_active(button))
   {
      gtk_label_set_text(GTK_LABEL(wid), " ");
      for(int i = 0; i<13; i++)
      {
         wid = lookup_widget(GTK_WIDGET(button), cell_data[i]);
         gtk_entry_set_text(GTK_ENTRY(wid), "  ");
         gtk_editable_set_editable(GTK_EDITABLE(wid), TRUE);
      }
   }
*/
}

void disattiva(GtkEditable *widget, GtkWidget *frame)
{
   gtk_widget_set_sensitive(frame, FALSE);
}

void set_cur_pag(GtkWidget *entry, gpointer data)
{
   curPag = GPOINTER_TO_INT(data);
   return;
   for(int i=curPag+1; i<nCards; i++)
       HidePage(np_dialog, i+1);
}

void page2(GtkWidget *notebook, GtkWidget *new_project_dlg)
{
  GtkWidget *vbox;

  vbox = vbox_new (FALSE, vspace);
  gtk_widget_show (vbox);
  gtk_container_add (GTK_CONTAINER (notebook), vbox);

  //GtkWidget *align = gtk_alignment_new(0, 0, 0.6f, 1);
  //gtk_widget_show(align);
  //gtk_box_pack_start (GTK_BOX(vbox), align, TRUE, TRUE, 0);
#ifdef IN_GTK3
  gtk_widget_set_vexpand(vbox, TRUE);
#endif
  std::string filspg = g_strdup_printf( "%s%cfiles%c%s.spg", 
       g_path_get_dirname(main_app::TheApp.PkgDataDir().c_str()), 
       G_DIR_SEPARATOR, G_DIR_SEPARATOR, PK);

  GtkWidget *vbox2 = i_Spg_Cell(vbox, new_project_dlg,
         G_CALLBACK(on_accept_clicked), filspg.c_str());

  GtkWidget *label = get_widget(new_project_dlg, "radio_search");
  g_signal_connect(G_OBJECT(label), "toggled", G_CALLBACK(on_find_space), NULL);
#if 0
  GtkWidget *button = get_widget(new_project_dlg, "accept0");
  GtkWidget *vbox1 = get_widget(new_project_dlg, "spaceg_box");
  GtkWidget *hbox = get_widget(new_project_dlg, "spaceg_hbox");
  GtkWidget *label = CHECK_BUTTON_WITH_LABEL("Find Space Group", MyRED);
  gtk_widget_show (label);
  gtk_box_pack_start( GTK_BOX(vbox1), label, FALSE, FALSE, 0);
  g_object_set_data (G_OBJECT (new_project_dlg), "radio_find", label);
  set_tip (label, "Click to Find Space Group ");
  g_signal_connect(G_OBJECT(label), "toggled", G_CALLBACK(on_find_space), NULL);
  g_signal_connect(G_OBJECT(label), "toggled", G_CALLBACK(on_cb_disattiva), button);
  g_signal_connect(G_OBJECT(label), "toggled", G_CALLBACK(on_cb_disattiva), hbox);
  GtkWidget *hbox2 = hbox_new(FALSE, 0);
  gtk_widget_show (hbox2);
  g_object_set_data (G_OBJECT (new_project_dlg), "crysf", hbox2);
  gtk_box_pack_start( GTK_BOX(vbox1), hbox2, FALSE, FALSE, 10);
  GtkWidget *lab1 = LABEL_NEW("Crystal Family: ", MyBLUE);
  gtk_widget_show (lab1);
  gtk_box_pack_start( GTK_BOX(hbox2), lab1, FALSE, FALSE, 0);
  int n = (int) (sizeof(CrystSystem)/ sizeof(CrystSystem[0]));
  GtkWidget *combo = create_combo(hbox2, CrystSystem, n, 1, &ifLaue, NULL);
  gtk_widget_show (combo);
  gtk_widget_set_sensitive(hbox2, FALSE);
  g_signal_connect(G_OBJECT(label), "toggled", G_CALLBACK(on_cb_attiva), hbox2);
  set_width_chars (GTK_ENTRY(get_widget(combo,"entry")), 16);
#endif
  gtk_widget_show (vbox2);

  bottoni_e_titolo(vbox, page_CELL,"Symmetry &amp; Cell parameters"); 
  g_signal_connect(G_OBJECT(get_widget(new_project_dlg, "entry_spg")), "changed", 
        G_CALLBACK (disattiva), get_widget(new_project_dlg, "accept2"));
  g_signal_connect(G_OBJECT(get_widget(new_project_dlg, "entry_spg")), "changed", 
        G_CALLBACK (disattiva), get_widget(new_project_dlg, "cell_param"));
  g_signal_connect(G_OBJECT(get_widget(new_project_dlg, "entry_spg")), "changed", 
        G_CALLBACK (set_cur_pag), GINT_TO_POINTER(1));
}

void to_open_file_mtz(GtkWidget *button, gpointer data)
{
using namespace gtkext;
using namespace Sir;

  GtkWidget *dlg = gtk_widget_get_toplevel(button);
  gtk_widget_set_sensitive(dlg, FALSE);
  std::string fn;
  fn = dlg_select_file(dlg, fn, eSELECT_TO_READ, "*.mtz");
  gtk_widget_set_sensitive(dlg, TRUE);
  if(!str_white(fn.c_str()))
  {
     GtkWidget *entry = get_widget(button, "entry");
     gtk_entry_set_text(GTK_ENTRY(entry), fn.c_str());
     CopiaStringa(project->szMtzFile, MaxLenFilename, fn.c_str());
     entry = get_widget(dlg, "MtzColumnsEntry");
     gtk_text_buffer_set_text(gtk_text_view_get_buffer(GTK_TEXT_VIEW(entry)),
              toUTF8(project->szSelectedColumns), -1);
     project->FillFromMTZ(dlg, fn);
     entry = get_widget(dlg, "MtzDeleteBtn");
     gtk_button_clicked(GTK_BUTTON(entry));
  }
}

void on_view_clicked (GtkWidget *button, gpointer data)
{
    GtkWidget *entry = (GtkWidget *) data;
    const char *fil = gtk_entry_get_text(GTK_ENTRY(entry));
    std::string fn = fil;
    if( !fn.empty() )
      myshow_mtz(fn, GTK_WINDOW(gtk_widget_get_toplevel(button)));
}

void FillMtzVectors(gpointer mtzi)
{
using namespace Sir;
    char labels[100][31], types[100][3];
    int sets[100];
    int ncols;
    int i;
    CMtz::MTZ *mtzin;
    const std::string fn = fromUTF8(project->szMtzFile);

    MtzValues.clear();
    MtzEsds.clear();
    MtzAllCols.clear();

    if(mtzi == NULL)
    {
       if(str_white(fn.c_str()))
          return;
       mtzin = CMtz::MtzGet(fn.c_str(), 0);
    }
    else
       mtzin = (CMtz::MTZ* )mtzi;
    ncols = CMtz::MtzNcol(mtzin);
    CMtz::MtzListColumn(mtzin, labels, types, sets);

    for( i=0; i<ncols; i++ )
    {
      char typ = types[i][0];

      MtzAllCols.push_back( CMtz::MtzColLookup(mtzin, labels[i]) );
      if( typ=='Q' || typ=='L' || typ=='M')
        MtzEsds.push_back( CMtz::MtzColLookup(mtzin, labels[i]) );
      if( typ=='F' || typ=='G' || typ=='J' || typ=='K')
        MtzValues.push_back( CMtz::MtzColLookup(mtzin, labels[i]) );
    }
}

void add_mtz_val(const char *val, int quale)
{
    VMTZCOL_it it, vit, eit;
    it = get_mtz_col(MtzAllCols, val);
    if( it==MtzAllCols.end() )
        return;
    MtzSelected.push_back(*it);
    MtzAllCols.erase(it);
    vit = get_mtz_col(MtzValues, val);
    if( vit!=MtzValues.end())
        MtzValues.erase(vit);
    eit = get_mtz_col(MtzEsds, val);
    if( eit!=MtzEsds.end())
        MtzEsds.erase(eit);
}

void add_mtz_col(const char *val, int quale)
{
using namespace Sir;
    VMTZCOL_it it, vit, eit;
    it = get_mtz_col(MtzAllCols, val);
    if( it==MtzAllCols.end() )
        return;
    if(strstr(project->szSelectedColumns, val) == NULL)
       MtzSelected.push_back(*it);
    MtzAllCols.erase(it);
    vit = get_mtz_col(MtzValues, val);
    if( vit!=MtzValues.end())
        MtzValues.erase(vit);
    eit = get_mtz_col(MtzEsds, val);
    if( eit!=MtzEsds.end())
        MtzEsds.erase(eit);
}

bool add_mtz_pair(const char *val, const char *esd, int quale, GtkWidget *dlg)
{
    VMTZCOL_it vit, eit;
    GtkWidget *entry = get_widget(dlg, "MtzColumnsEntry");
    const char *SelC = get_text(GTK_TEXT_VIEW(entry));
    vit = get_mtz_col(MtzValues, val);
    eit = get_mtz_col(MtzEsds, esd);
    if( vit==MtzValues.end() || eit==MtzEsds.end() )
        return false;
    if(strstr(SelC, val) == NULL)
       MtzSelected.push_back(*vit);
    if(strstr(SelC, esd) == NULL)
       MtzSelected.push_back(*eit);
    MtzValues.erase(vit);
    MtzEsds.erase(eit);
    vit = get_mtz_col(MtzAllCols, val);
    MtzAllCols.erase(vit);
    eit = get_mtz_col(MtzAllCols, esd);
    MtzAllCols.erase(eit);
    return true;
}

void clear_mtz(int flag, GtkWidget *dlg)
{
    MtzSelected.clear();
    if(flag)
    {
       memset(Sir::project->szSelectedColumns, 0, MaxLenFilename);
       FillMtzVectors(NULL);
       add_mtz_val("H", 0);
       add_mtz_val("K", 0);
       add_mtz_val("L", 0);
       if(MtzEsds.size() == 1)
          gtk_button_clicked(GTK_BUTTON(get_widget(dlg, "MtzAddBtn")));
    }
}

void update_mtzpage(GtkWidget *dlg)
{
    GList *vitems=NULL, *sitems=NULL, *aitems=NULL, *bitems=NULL;
    unsigned i;
    GtkWidget *w;

    for( i=0; i<MtzEsds.size(); i++ )
      sitems = g_list_append(sitems, (gpointer) MtzEsds[i]->label);
    for( i=0; i<MtzValues.size(); i++ )
      vitems = g_list_append(vitems, (gpointer) MtzValues[i]->label );

    for( i=0; i<MtzAllCols.size(); i++ )
    {
      aitems = g_list_append(aitems, (gpointer) MtzAllCols[i]->label );
      bitems = g_list_append(bitems, (gpointer) MtzAllCols[i]->type );
    }

    w = get_widget(dlg, "MtzValueCombo");
//    gtk_entry_set_text( GTK_ENTRY(get_widget(w,"entry")), "" );
//    if(g_list_length(vitems))
       set_popdown_strings(w, vitems);
    w = get_widget(dlg, "MtzEsdCombo");
//    gtk_entry_set_text( GTK_ENTRY(get_widget(w,"entry")), "" );
//    if(g_list_length(sitems))
       set_popdown_strings(w, sitems);
    w = get_widget(dlg, "MtzAllCols");
    populate_selection(GTK_TREE_VIEW(w), aitems, bitems);

    std::string str;
    for( i=0; i<MtzSelected.size(); i++ ) {
      str += MtzSelected[i]->label;
      str += ' ';
    }

    w = get_widget(dlg, "MtzColumnsEntry");
    gtk_text_buffer_set_text(gtk_text_view_get_buffer (GTK_TEXT_VIEW (w)), str.c_str(),-1);
}

void on_AddPairBtn_clicked (GtkButton *button, gpointer user_data )
{
  GtkWidget *dlg = gtk_widget_get_toplevel(GTK_WIDGET(button));
  const gchar *vlb, *elb;
  _MyMTZ *mtz = (_MyMTZ *) user_data;

  vlb = combo_get_text( get_widget(mtz->vcombo,"entry") );
  elb = combo_get_text( get_widget(mtz->esdcombo,"entry") );
  if(!vlb || !elb)
     return;
  if( add_mtz_pair(vlb, elb, mtz->quale, dlg) )
         update_mtzpage(dlg);
}

void on_ClearBtn_clicked (GtkButton *button, gpointer user_data)
{
    GtkWidget *dlg = gtk_widget_get_toplevel(GTK_WIDGET(button));

    clear_mtz(1, dlg);
    update_mtzpage(dlg);
}

void  on_AddC_clicked(GtkButton *button, gpointer user_data)
{
  GtkWidget *dlg = gtk_widget_get_toplevel(GTK_WIDGET(button));
  _MyMTZ *mtz = (_MyMTZ *) user_data;
  const gchar *lb = get_selected_row((GtkWidget *) mtz->allcols);

  if(lb)
  {
      add_mtz_col(lb,mtz->quale);
      update_mtzpage(dlg);
  }
}

_MyMTZ *page_mtz(GtkWidget *fbox1, bool ifPhases, char *filename)
{
  _MyMTZ *mymtz = g_new0(_MyMTZ, 1);
  GtkSizeGroup *szgroup1 = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
  GtkWidget *hbox2, *align, *vbox4, *vbox3, *frame;
  GtkWidget *hboxmtz2;
  GtkWidget *hboxmtz2b;
  GtkWidget *hboxmtz3;
  GtkWidget *hboxmtz4;
  GtkWidget *vboxmtz4;
  GtkWidget *labelmtz;
  GtkWidget *labelmtz2;
  GtkWidget *labelmtz2b;
  GtkWidget *labelmtz3;
  GtkWidget *labelmtz4;
  GtkWidget *labelmtz6;
  GtkWidget *framemtz1;
  GtkWidget *framemtz2;
  static const char *titles[] = {"Label", "Type"};
  int sizes[] = {130, 70};

  GtkWidget *fbox = vbox_new(FALSE, 0);
#ifdef IN_GTK3
  gtk_box_pack_start (GTK_BOX (fbox1), fbox, FALSE, FALSE, 0);
#else
  align = gtk_alignment_new(0,0,0,0);
  gtk_box_pack_start (GTK_BOX (fbox1), align, FALSE, FALSE, 0);
  gtk_widget_show(align);
  gtk_container_add(GTK_CONTAINER(align), fbox);
#endif
  gtk_widget_show(fbox);
  std::string filespg = main_app::TheApp.PkgDataDir() + "files"  + G_DIR_SEPARATOR_S + "Sir.spg";

  mymtz->mtzfile = filename;
  hbox2 = entry_for_fileselection("MTZ filename: ", NULL,
             G_CALLBACK(to_open_file_mtz), NULL, 1, 1, MyRED);
  gtk_container_set_border_width (GTK_CONTAINER (hbox2), 4);
  gtk_box_pack_start (GTK_BOX (fbox), hbox2, FALSE, FALSE, 0);

  mymtz->entry = get_widget(hbox2, "entry");
  set_tip (mymtz->entry, "MTZ file");
  mymtz->browse = get_widget (hbox2, "browse");
  set_tip (mymtz->browse, "Select MTZ file");
  mymtz->view = get_widget (hbox2, "preview");
  gtk_size_group_add_widget(szgroup1, get_widget(hbox2, "label"));
  gtk_editable_set_editable (GTK_EDITABLE (mymtz->entry), FALSE);
  set_mandatory(get_widget(hbox2, "label"));

  mymtz->title = entry_for_filesel(NULL, "Title:", "MtzTitleEntry", 0, 0);
  hbox2 = get_widget(mymtz->title, "box");
  gtk_container_set_border_width (GTK_CONTAINER (hbox2), 4);
  gtk_box_pack_start (GTK_BOX (fbox), hbox2, FALSE, FALSE, 0);
  gtk_widget_show (mymtz->title);
  gtk_editable_set_editable (GTK_EDITABLE (mymtz->title), FALSE);
  gtk_size_group_add_widget(szgroup1, get_widget(mymtz->title, "label"));

  hboxmtz2 = hbox_new (FALSE, 0);
  gtk_widget_show (hboxmtz2);
  gtk_box_pack_start (GTK_BOX (fbox), hboxmtz2, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hboxmtz2), 4);

  labelmtz2 = LABEL_NEW ("Change Space Group:", MyBLUE);
  gtk_widget_show (labelmtz2);
  gtk_box_pack_start (GTK_BOX (hboxmtz2), labelmtz2, FALSE, FALSE, 0);

  int ifSilent = 0;
  mymtz->spg = spgr_widget((char *)filespg.c_str(), ifSilent);
  gtk_widget_show (mymtz->spg);
  gtk_box_pack_start (GTK_BOX (hboxmtz2), mymtz->spg, FALSE, FALSE, 4);
//  gtk_widget_set_size_request(mymtz->spg, 120, -1);

  mymtz->find = CHECK_BUTTON_WITH_LABEL("Check Space Group", MyBLUE);
  gtk_widget_show (mymtz->find);
  gtk_box_pack_start (GTK_BOX (hboxmtz2), mymtz->find, FALSE, FALSE, 25);
  g_signal_connect(G_OBJECT(mymtz->find), "toggled", G_CALLBACK(on_cb_disattiva), mymtz->spg);
  
  hboxmtz2b = hbox_new (FALSE, 0);
  gtk_widget_show (hboxmtz2b);
  gtk_box_pack_start (GTK_BOX (fbox), hboxmtz2b, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hboxmtz2b), 4);

  mymtz->cell = gtk_entry_new ();
  gtk_widget_show (mymtz->cell);
  //gtk_box_pack_end (GTK_BOX (hboxmtz2), mymtz->cell, FALSE, FALSE, 0);
  gtk_editable_set_editable (GTK_EDITABLE (mymtz->cell), FALSE);
  gtk_widget_set_size_request(mymtz->cell, 250, -1);

  labelmtz2b = LABEL_NEW ("Cell Parameters:", MyBLUE);
  gtk_widget_show (labelmtz2b);
  //gtk_box_pack_end (GTK_BOX (hboxmtz2), labelmtz2b, FALSE, FALSE, 4);
  gtk_box_pack_start (GTK_BOX (hboxmtz2b), labelmtz2b, FALSE, FALSE, 4);
  gtk_box_pack_start (GTK_BOX (hboxmtz2b), mymtz->cell, FALSE, FALSE, 4);

  framemtz1 = gtk_frame_new (NULL);
  gtk_widget_show (framemtz1);
  gtk_box_pack_end (GTK_BOX (fbox), framemtz1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (framemtz1), 4);

  mymtz->hint = gtk_label_new ("");
  gtk_widget_show (mymtz->hint);
  set_alignment (mymtz->hint, 0., 0.5);
  set_margins (mymtz->hint, 5, 5, 2, 2);
  gtk_frame_set_label_widget (GTK_FRAME (framemtz1), mymtz->hint);

  hbox2 = hbox_new (FALSE, 0);
  gtk_widget_show (hbox2);
  gtk_container_add (GTK_CONTAINER (framemtz1), hbox2);
  gtk_container_set_border_width (GTK_CONTAINER (hbox2), 4);

#ifdef IN_GTK3
  align = new_alignment(GTK_ALIGN_START, GTK_ALIGN_FILL, FALSE, TRUE);
#else
  align = gtk_alignment_new(0, 0, 0, 1);
#endif
  gtk_widget_show (align);
  gtk_box_pack_start (GTK_BOX (hbox2), align, FALSE, FALSE, 0);

  vbox4 = vbox_new (FALSE, 4);
  gtk_widget_show (vbox4);
  gtk_container_add (GTK_CONTAINER (align), vbox4);
  gtk_container_set_border_width (GTK_CONTAINER (vbox4), 4);

  hboxmtz4 = hbox_new (FALSE, 4);
  gtk_widget_show (hboxmtz4);
  gtk_box_pack_start (GTK_BOX (vbox4), hboxmtz4, TRUE, TRUE, 0);

  vboxmtz4 = vbox_new (FALSE, 4);
  gtk_widget_show (vboxmtz4);
  gtk_box_pack_start (GTK_BOX (hboxmtz4), vboxmtz4, TRUE, TRUE, 0);

  labelmtz6 = LABEL_NEW ("Selected columns:", MyBLUE);
  gtk_widget_show (labelmtz6);
  set_alignment (labelmtz6, 0., 0.5);
  set_margins (labelmtz6, 5, 5, 2, 2);

  align = gtk_frame_new(NULL);
  gtk_box_pack_start (GTK_BOX (vboxmtz4), align, TRUE, TRUE, 0);
  gtk_widget_show (align);
  gtk_frame_set_label_widget (GTK_FRAME (align), labelmtz6);
  gtk_container_set_border_width (GTK_CONTAINER (align), 10);

  framemtz2 = gtk_scrolled_window_new( NULL, NULL);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (framemtz2),
                                  GTK_POLICY_NEVER, 
                                  GTK_POLICY_AUTOMATIC);
  gtk_widget_show (framemtz2);
  gtk_container_add (GTK_CONTAINER (align), framemtz2);
  gtk_widget_set_size_request(framemtz2, -1, 60);

  mymtz->columns = gtk_text_view_new ();
  gtk_widget_show (mymtz->columns);
  gtk_container_add(GTK_CONTAINER(framemtz2), mymtz->columns);
  gtk_text_view_set_editable (GTK_TEXT_VIEW (mymtz->columns), FALSE);
  gtk_text_view_set_wrap_mode(GTK_TEXT_VIEW (mymtz->columns), GTK_WRAP_WORD);
  gtk_text_view_set_right_margin (GTK_TEXT_VIEW (mymtz->columns), 4);
  gtk_text_view_set_left_margin (GTK_TEXT_VIEW (mymtz->columns), 4);
//  gtk_widget_set_size_request(mymtz->columns, 120, 60);

#ifdef IN_GTK3
  align = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_CENTER, FALSE, FALSE);
#else
  align = gtk_alignment_new(0.5, 0.5, 0, 0);
#endif
  gtk_widget_show (align);
  gtk_box_pack_end (GTK_BOX (vboxmtz4), align, FALSE, FALSE, 0);

  mymtz->del = gtk_button_new_with_mnemonic ("Clear columns");
  gtk_widget_show (mymtz->del);
  gtk_container_add (GTK_CONTAINER (align), mymtz->del);

  labelmtz = LABEL_NEW ("Columns", MyBLUE);
  gtk_widget_show (labelmtz);
  set_alignment (labelmtz, 0., 0.5);
  set_margins (labelmtz, 5, 5, 2, 2);

  align = gtk_frame_new(NULL);
  gtk_widget_show (align);
  gtk_box_pack_end (GTK_BOX (vbox4), align, TRUE, TRUE, 0);
  gtk_frame_set_label_widget (GTK_FRAME (align), labelmtz);

  hboxmtz3 = table_new(2, 3, FALSE);
  table_set_col_spacings(hboxmtz3, 4);

  gtk_widget_show (hboxmtz3);
  gtk_container_add (GTK_CONTAINER (align), hboxmtz3);
  gtk_container_set_border_width (GTK_CONTAINER (hboxmtz3), 4);

  if(ifPhases)
     labelmtz4 = gtk_label_new ("value/phase:");
  else
     labelmtz4 = gtk_label_new ("value:");
  gtk_widget_show (labelmtz4);
  table_attach(hboxmtz3, labelmtz4, 0, 1, 0, 1);

  mymtz->vcombo = new_combo ();
  gtk_widget_set_size_request(mymtz->vcombo, 150, -1);
  gtk_widget_show (mymtz->vcombo);
  table_attach(hboxmtz3, mymtz->vcombo, 0, 1, 1, 2);
//  gtk_editable_set_editable (GTK_EDITABLE (get_widget (mymtz->vcombo,"entry")), FALSE);

  if(ifPhases)
     labelmtz3 = gtk_label_new ("    esd/weight:");
  else
     labelmtz3 = gtk_label_new ("    esd:");
  gtk_widget_show (labelmtz3);
  table_attach(hboxmtz3, labelmtz3, 1, 2, 0, 1);

  mymtz->esdcombo = new_combo ();
  gtk_widget_set_size_request(mymtz->esdcombo, 150, -1);
  gtk_widget_show (mymtz->esdcombo);
  table_attach(hboxmtz3, mymtz->esdcombo, 1, 2, 1, 2);
//  gtk_editable_set_editable (GTK_EDITABLE (get_widget (mymtz->esdcombo,"entry")), FALSE);

  mymtz->add = gtk_button_new_with_mnemonic ("Add pair");
  gtk_widget_show (mymtz->add);
  table_attach(hboxmtz3, mymtz->add, 2, 3, 1, 2);

  frame = FRAME_NEW("Available columns", MyBLUE);
  gtk_widget_show (frame);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 10);
#ifdef IN_GTK3
  gtk_widget_set_vexpand(frame, TRUE);
  gtk_widget_set_hexpand(frame, TRUE);
  gtk_box_pack_start (GTK_BOX (hbox2), frame, TRUE, TRUE, 0);
#else
  align = gtk_alignment_new(0, 0, 1, 1);
  gtk_widget_show (align);
  gtk_box_pack_start (GTK_BOX (hbox2), align, TRUE, TRUE, 0);
  gtk_container_add (GTK_CONTAINER(align), frame);
#endif

  vbox3 = table_new(2, 1, FALSE);
  gtk_widget_show (vbox3);
  gtk_container_set_border_width (GTK_CONTAINER (vbox3), 6);
#ifdef IN_GTK3
  gtk_widget_set_vexpand(vbox3, TRUE);
  g_object_set(G_OBJECT(vbox3), "halign", GTK_ALIGN_CENTER, NULL);
  gtk_container_add (GTK_CONTAINER(frame), vbox3);
#else
  align = gtk_alignment_new(0.5, 0, 0, 1);
  gtk_widget_show (align);
  gtk_container_add (GTK_CONTAINER(align), vbox3);
  gtk_container_add (GTK_CONTAINER(frame), align);
#endif


  mymtz->allcols = new_selection(frame, NULL, "vbox3", 
                               2, titles, sizes);
  gtk_container_set_border_width (GTK_CONTAINER (get_widget(mymtz->allcols, "frame")), 0);
//  table_attach_exp(vbox3, get_widget(mymtz->allcols, "frame"), 0, 1, 0, 1);
  table_attach(vbox3, get_widget(mymtz->allcols, "frame"), 0, 1, 0, 1, TRUE);
#ifdef IN_GTK3
  gtk_widget_set_vexpand(mymtz->allcols, TRUE);
#endif
  gtk_widget_show (mymtz->allcols);

  mymtz->addcol = gtk_button_new_with_mnemonic ("Add");
  gtk_widget_show (mymtz->addcol);
  table_attach(vbox3, mymtz->addcol, 0, 1, 1, 2);

  g_signal_connect ((gpointer) mymtz->view, "clicked",
                    G_CALLBACK (on_view_clicked),
                    mymtz->entry);
  g_signal_connect ((gpointer) mymtz->add, "clicked",
                    G_CALLBACK (on_AddPairBtn_clicked),
                    mymtz);
  g_signal_connect ((gpointer) mymtz->del, "clicked",
                    G_CALLBACK (on_ClearBtn_clicked),
                    mymtz);
  g_signal_connect ((gpointer) mymtz->addcol, "clicked",
                    G_CALLBACK (on_AddC_clicked),
                    mymtz);
  return mymtz;
}

void page2mtz(GtkWidget *notebook, GtkWidget *dlg)
{
using namespace Sir;
  GtkWidget *vbox = vbox_new (FALSE, vspace);
  gtk_widget_show (vbox);
  gtk_container_add (GTK_CONTAINER (notebook), vbox);
  //GtkWidget *align = gtk_alignment_new(0, 0, 0.6f, 1);
  //gtk_widget_show(align);
  //gtk_box_pack_start (GTK_BOX(vbox), align, TRUE, TRUE, 0);
  GtkWidget *vbox1 = vbox_new (FALSE, vspace);
  gtk_widget_show (vbox1);
#ifdef IN_GTK3
  gtk_widget_set_vexpand(vbox1, TRUE);
#endif
  gtk_box_pack_start (GTK_BOX(vbox), vbox1, TRUE, TRUE, 0);
  //gtk_container_add (GTK_CONTAINER (align), vbox1);
  _MyMTZ *mymtz = page_mtz(vbox1, false, project->szMtzFile);
  mymtz->quale = 0;
  g_object_set_data (G_OBJECT(dlg), "MtzFileEntry", mymtz->entry);
  g_object_set_data (G_OBJECT(dlg), "MtzBrowseBtn", mymtz->browse);
  g_object_set_data (G_OBJECT(dlg), "MtzViewBtn", mymtz->view);
  g_object_set_data (G_OBJECT(dlg), "MtzTitleEntry", mymtz->title);
  g_object_set_data (G_OBJECT(dlg), "MtzSpgEntry", get_widget(mymtz->spg, "entry"));
  g_object_set_data (G_OBJECT(dlg), "MtzSpgFind", mymtz->find);
  g_object_set_data (G_OBJECT(dlg), "MtzCellEntry", mymtz->cell);
  g_object_set_data (G_OBJECT(dlg), "MtzHint", mymtz->hint);
  g_object_set_data (G_OBJECT(dlg), "MtzValueCombo", mymtz->vcombo);
  g_object_set_data (G_OBJECT(dlg), "MtzValueEntry", get_widget(mymtz->vcombo,"entry"));
  g_object_set_data (G_OBJECT(dlg), "MtzEsdCombo", mymtz->esdcombo);
  g_object_set_data (G_OBJECT(dlg), "MtzEsdEntry", get_widget(mymtz->esdcombo, "entry"));
  g_object_set_data (G_OBJECT(dlg), "MtzColumnsEntry", mymtz->columns);
  g_object_set_data (G_OBJECT(dlg), "MtzAddBtn", mymtz->add);
  g_object_set_data (G_OBJECT(dlg), "MtzDeleteBtn", mymtz->del);
  g_object_set_data (G_OBJECT(dlg), "MtzAllCols", mymtz->allcols);
  g_object_set_data (G_OBJECT(dlg), "MtzAddColBtn", mymtz->addcol);
  set_label_text(mymtz->hint, "Select F, sigF for protein", MyBLUE, 1.1f);

  bottoni_e_titolo(vbox, page_MTZ,"MTZ"); 
}

int check_is_numeric(char *string)
{
  int ier, nch;

  nch = (int) strlen(string);
  if(nch == 0)
     return 0;
  ier = f_checkisnumeric_(string, nch);
  return ier;
}

int get_cell_content(GtkWidget *dlg, stringa5 El[], int Am[])
{
    GtkWidget *widget = get_widget(dlg,"formula");
    char *param = g_strdup(gtk_entry_get_text(GTK_ENTRY(widget)));
    if(str_white(param))
       return -1;
    int *Z = g_new0(int, NUMSPECIES);
    int nEl = get_content_from_formula_(param, Am, Z, strlen(param));
    if(nEl == 0)
       return -1;
    int hnd = get_int(widget, "hnd");
    g_signal_handler_block(G_OBJECT(widget), hnd);
    set_error_color(widget, (nEl < 0));
    g_signal_handler_unblock(G_OBJECT(widget), hnd);
    if(nEl < 0)
       return -1;
    else
    {
        for(int i=0; i<nEl; i++)
            CopiaStringa(El[i], SYMLEN+1, get_nth_element(Z[i]-1));
    }
    g_free(Z);
    return nEl;
}

void cell_content_changed(GtkWidget *, GtkWidget *dlg)
{
using namespace Sir;
   stringa5 El[NUMSPECIES];
   int Am[NUMSPECIES];

   int nEl = get_cell_content(dlg, El, Am);
   GtkWidget *label = get_widget(dlg, "vol_cell");
   float V = project->Volume();
   set_label_text(label, g_strdup_printf("%.3f", V), MyBLUE, 0.99f);
   label = get_widget(dlg, "formula");
   project->ChangeVolPerAt(nEl, El, Am);
}

GtkWidget *frame_elements(GtkWidget *dialog)
{
//  GtkWidget *table, *scrolled_window, *entry;
//  int i;

  GtkWidget *Frame = NEW_FRAME ("Cell content:", &FrameStyle1);
  gtk_widget_show (get_widget(Frame, "align"));

  GtkWidget *vb = vbox_new(FALSE, 0);
  add_to_frame(Frame, vb);
  gtk_widget_show (vb);
  GtkWidget *label = LABEL_NEW("Warning:\nTo avoid ambiguities, "
          "you should write the "
          "two-letter elements with the second letter in lower-case or "
          "insert a space between elements.", "red");
  set_alignment(label, 0., 0.);
  gtk_label_set_line_wrap(GTK_LABEL(label), TRUE);
  gtk_box_pack_start(GTK_BOX(vb), label, FALSE, FALSE, 0);
  gtk_widget_show (label);
  GtkWidget *content = gtk_entry_new();
  gtk_box_pack_start(GTK_BOX(vb), content, FALSE, FALSE, 4);
  gtk_widget_show (content);
  g_object_set_data(G_OBJECT (dialog), "formula", content);
  int hnd = g_signal_connect(G_OBJECT(content),  "changed",
     G_CALLBACK(cell_content_changed), dialog);
  g_object_set_data(G_OBJECT (content), "hnd", GINT_TO_POINTER(hnd));

/*
  scrolled_window = gtk_scrolled_window_new (NULL, NULL);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_window),
                                    GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);
  gtk_container_add(GTK_CONTAINER(get_widget(Frame, "align")), scrolled_window);
  gtk_widget_show (scrolled_window);

  GtkWidget *view = gtk_viewport_new(NULL, NULL);
  gtk_widget_show (view);
  gtk_container_add(GTK_CONTAINER(scrolled_window), view);
  widget_modify_bg(view, GTK_STATE_NORMAL, &colorWhite);
  gtk_viewport_set_shadow_type(GTK_VIEWPORT(view), GTK_SHADOW_ETCHED_IN);    

  table = table_new (NUMSPECIES+1, 4, FALSE);
  gtk_widget_show (table);
  table_set_row_spacings (table, 4);
  table_set_col_spacings (table, 12);
  gtk_container_set_border_width (GTK_CONTAINER (table), 6);
  gtk_container_add(GTK_CONTAINER(view), table);

  g_object_set_data(G_OBJECT (Frame), "lista_elements", table);

  for(int j=0; j<NUMSPECIES+1; j++)
  {
    for(i = 0; i < 4; i++)
    {
      if(j == 0)
      {
         if(i < 2)
         {
            entry = LABEL_NEW(col_titles[i], MyRED);
            set_mandatory(entry);
         }
         else
            entry = LABEL_NEW(col_titles[i], MyBLUE);
      }
      else
      {
          if(i == 1)
          {
             entry = spin_button_new_with_range(0, 10000, 1);
             set_width_chars (GTK_ENTRY (entry), 5);
          }
          else
          {
             entry = gtk_entry_new();
             if(i == 0)
                set_width_chars (GTK_ENTRY (entry), 3);
             else
                set_width_chars (GTK_ENTRY (entry), 8);
          }
          g_object_set_data(G_OBJECT(table), g_strdup_printf("cont%d_%d", j, i), entry);
      }
      gtk_widget_show(entry);
      table_attach (table, entry, i, i+1, j, j+1);
    }
  }
*/
  return Frame;
}

void on_cont_radio_toggled (GtkToggleButton *togglebutton, gpointer data)
{
  int which = GPOINTER_TO_INT(data);
  GtkWidget *dlg = gtk_widget_get_toplevel(GTK_WIDGET(togglebutton));
  gboolean act = gtk_toggle_button_get_active(togglebutton);
  
  switch(which)
  {
  case 0:
       gtk_widget_set_sensitive(get_widget(dlg, "MolSpin"), act);
       gtk_widget_set_sensitive(get_widget(dlg, "ResiduesSpin"), 1-act);
       gtk_widget_set_sensitive(get_widget(dlg, "SeqBox"), 1-act);
       gtk_widget_set_sensitive(get_widget(dlg, "SeqFrame"), 1-act);
       if(act)
          Sir::project->ClearSequence();
       break;
  case 1:
       gtk_widget_set_sensitive(get_widget(dlg, "MolSpin"), 1-act);
       gtk_widget_set_sensitive(get_widget(dlg, "ResiduesSpin"), act);
       gtk_widget_set_sensitive(get_widget(dlg, "SeqBox"), 1-act);
       gtk_widget_set_sensitive(get_widget(dlg, "SeqFrame"), 1-act);
       if(act)
          Sir::project->ClearSequence();
       break;
   case 2:
       gtk_widget_set_sensitive(get_widget(dlg, "MolSpin"), 1-act);
       gtk_widget_set_sensitive(get_widget(dlg, "ResiduesSpin"), 1-act);
       gtk_widget_set_sensitive(get_widget(dlg, "SeqBox"), act);
       gtk_widget_set_sensitive(get_widget(dlg, "SeqFrame"), act);
       break;
   }
}

void on_SeqBrowse_clicked (GtkButton *button, gpointer data)
{
using namespace gtkext;
    GtkWidget *dlg = gtk_widget_get_toplevel(GTK_WIDGET(button));
    std::string fn;
    GtkWidget *entry = get_widget(dlg, "SeqFile");
    const char *seqfile = gtk_entry_get_text(GTK_ENTRY(entry));
    fn = dlg_select_file(dlg, seqfile, eSELECT_TO_READ, "*.seq");
    if( !fn.empty() ) {
      g_strlcpy(Sir::project->szSeqFile, fn.c_str(), MaxLenFilename);
        Sir::project->ReadSequence();
    }
}

static gboolean PasteOk = FALSE;

void on_SeqPaste(GtkTextView *widget, gpointer data)
{
      GtkWidget *dlg = gtk_widget_get_toplevel(GTK_WIDGET(widget));
      PasteOk = false;
      if(str_white(Sir::project->szSeqFile))
      {
         CopiaStringa(Sir::project->szSeqFile, MaxLenFilename, 
                      Sir::project->GetFilename(".seq").c_str());
         GtkWidget *w = get_widget(dlg, "SeqFile");
         gtk_entry_set_text(GTK_ENTRY(w), Sir::project->szSeqFile);
         PasteOk = true;
      }
      else
      {
         if( gtkext::dlg_yesno(GTK_WINDOW(dlg),
                "File already exists. Are you sure you want to overwrite?") ) 
            PasteOk = true;
         else
            g_signal_stop_emission_by_name ((gpointer) widget, "paste-clipboard");
       
      }
}

void on_SeqPasteAfter (GtkTextView *widget, gpointer data)
{
      if(PasteOk)
      {
         while(gtk_events_pending())
               gtk_main_iteration();
         Sir::project->WriteSequence();
      }
}

GtkWidget *frameLig(GtkWidget *father, GtkWidget *parentBox)
{
  GtkWidget *LigFrm = NEW_FRAME("Ligands - Additional elements and corresponding number in asymmetric unit", &FrameStyle);
  //gtk_widget_show (LigFrm);
  gtk_box_pack_start (GTK_BOX (parentBox), LigFrm, FALSE, FALSE, 0);
  g_object_set_data (G_OBJECT(father), "frameLig", LigFrm);

  GtkWidget *hbox1 = hbox_new (FALSE, 12);
  gtk_widget_show (hbox1);
  gtk_container_add (GTK_CONTAINER (get_widget(LigFrm, "align")), hbox1);
  gtk_container_set_border_width (GTK_CONTAINER (hbox1), 8);

  for(int i=1; i<=4;i++)
  {
      GtkWidget *hbox2 = hbox_new (FALSE, 4);
      gtk_widget_show (hbox2);
      gtk_box_pack_start (GTK_BOX (hbox1), hbox2, FALSE, TRUE, 0);

      GtkWidget *entry = gtk_entry_new ();
      g_object_set_data (G_OBJECT(father), g_strdup_printf("cont%d_0", i),
            entry);
      gtk_widget_show (entry);
      gtk_box_pack_start (GTK_BOX (hbox2), entry, FALSE, TRUE, 0);
      gtk_entry_set_max_length (GTK_ENTRY (entry), 3);
      set_width_chars (GTK_ENTRY (entry), 5);

      GtkWidget *spin = gtk_entry_new ();
      //GObject *adj = adj_new (0, 0, 10000, 1, 10);
      //GtkWidget *spin = spin_button_new (GTK_ADJUSTMENT (adj), 1, 0);
      g_object_set_data (G_OBJECT(father), g_strdup_printf("cont%d_1", i),
             spin);
      gtk_widget_show (spin);
      set_width_chars (GTK_ENTRY (spin), 5);
      gtk_box_pack_start (GTK_BOX (hbox2), spin, FALSE, TRUE, 0);
  }
  return LigFrm;
}

GtkWidget *frameMad(GtkWidget *father, GtkWidget *parentBox)
{
#if 0
  GtkWidget *MadFrm = vbox_new (FALSE, 0);
  //gtk_widget_show (MadFrm);
  gtk_box_pack_start (GTK_BOX (parentBox), MadFrm, FALSE, FALSE, 0);
  GtkWidget *hboxNative = hbox_new (FALSE, 16);
  gtk_widget_show (hboxNative);
  gtk_box_pack_start (GTK_BOX (MadFrm), hboxNative, FALSE, TRUE, 0);
  g_object_set_data (G_OBJECT(father), "frameMad", MadFrm);

  GtkWidget *NativeCheck = CHECK_BUTTON_WITH_LABEL ("Native data present", MyBLUE);
  gtk_widget_show (NativeCheck);
  gtk_box_pack_start (GTK_BOX (hboxNative), NativeCheck, FALSE, FALSE, 0);
  set_tip (NativeCheck, "Check this if the native protein diffraction data are present in the reflection file in addition to anomalous diffraction data");
  GtkWidget *WavesSpin = SPIN_WITH_LABEL("Number of Waves: ",
                     MyBLUE, 0, SIR_MAX_WAVES, 1, 1, 0);
  gtk_widget_show_all (WavesSpin);
  gtk_box_pack_start (GTK_BOX (hboxNative), WavesSpin, FALSE, FALSE, 10);
  set_tip (WavesSpin, "Number of wavelengths used to collect MAD/SAD data");
  HOOKUP_OBJECT (father, get_widget(WavesSpin, "spin"), "nWaves");
#endif

  GtkWidget *frame = NEW_FRAME("Additional elements in asymmetric unit "
         "with anomalous dispersion coeficients", &FrameStyle);
  gtk_widget_show (frame);
  //gtk_box_pack_start (GTK_BOX (MadFrm), frame, FALSE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (parentBox), frame, FALSE, FALSE, 0);
  g_object_set_data (G_OBJECT(father), "frameMad", frame);

  GtkWidget *table = table_new (SIR_MAX_ELEMENTS+1, SIR_MAX_WAVES+2, FALSE);
  gtk_widget_show (table);
  gtk_container_add (GTK_CONTAINER (get_widget(frame, "align")), table);
  gtk_container_set_border_width (GTK_CONTAINER (table), 4);
  table_set_row_spacings (table, 2);
  table_set_col_spacings (table, 4);

  GtkWidget *label = LABEL_NEW ("Amount", MyBLUE);
  gtk_widget_show (label);
  table_attach (table, label, 2, 3, 0, 1, TRUE);
  set_alignment(label, 0., 0.5);

  label = LABEL_NEW ("Element", MyBLUE);
  gtk_widget_show (label);
  table_attach (table, label, 1, 2, 0, 1, TRUE);
  set_alignment(label, 0., 0.5);

  for(int j=1; j<=SIR_MAX_WAVES; j++ )
  {
      std::stringstream name;
      name.str("");
      name << "LabWave" << j;
      label = LABEL_NEW (g_strdup_printf("Wave %d:  f' and f''", j), MyBLUE);
      gtk_widget_show (label);
      table_attach (table, label, 2+j, 3+j, 0, 1, TRUE);
      set_alignment(label, 0., 0.5);
      HOOKUP_OBJECT (father, label, name.str().c_str());
  }
  for(int i=1; i<=SIR_MAX_ELEMENTS; i++ )
  {
    std::stringstream name;
    name.str("");
    name << "ContSymbol" << i << "Entry";
    GtkWidget *Entry = gtk_entry_new ();
    gtk_widget_show (Entry);
    table_attach (table, Entry, 1, 2, i, i+1);//, TRUE);
    gtk_entry_set_max_length (GTK_ENTRY (Entry), SYMLEN);
    set_width_chars (GTK_ENTRY (Entry), 5);
    HOOKUP_OBJECT (father, Entry, name.str().c_str());

    GtkWidget *Spin = ENTRY_WITH_LIM (NULL,MyBLUE, 0, 1e4, 0, 0);
    GtkWidget *AmountSpin = get_widget(Spin, "spin");
    name.str("");
    name  << "ContAmount" << i << "Spin";
    set_width_chars(GTK_ENTRY(AmountSpin), 4);
    gtk_widget_show_all (Spin);
    table_attach (table, Spin, 2, 3, i, i+1);//, TRUE);
    HOOKUP_OBJECT (father, AmountSpin, name.str().c_str());

    for(int j=1; j<=SIR_MAX_WAVES; j++ )
    {
        GtkWidget *hbox = hbox_new (FALSE, 0);
        gtk_widget_show (hbox);
        table_attach (table, hbox, 2+j, 3+j, i, i+1, TRUE);
        for(int k=1; k<=2; k++ )
        {
            std::stringstream name;
            name << "ContE" << i << "W" << j << "F" << k << "Spin";
            Spin = ENTRY_WITH_LIM (NULL,MyBLUE, -100, 100, 0, 3);
            GtkWidget *entry = get_widget(Spin, "spin");
            set_width_chars(GTK_ENTRY(entry), 6);
            gtk_widget_show_all (Spin);
            gtk_box_pack_start (GTK_BOX (hbox), Spin, TRUE, TRUE, 0);
            HOOKUP_OBJECT (father, entry, name.str().c_str());
         }
    }
  }

//  return MadFrm;
  return frame;
}

GtkWidget *frame_mu(GtkWidget *father)
{
  GtkWidget *spin2[2];
  GtkWidget *radio[3];
  //GtkSizeGroup *sz = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
  GtkWidget *Frame = NEW_FRAME (" Molecular unit:", &FrameStyle);
  gtk_container_set_border_width (GTK_CONTAINER (Frame), 8);

  GtkWidget *vbox = vbox_new(FALSE, 0);
  gtk_widget_show (vbox);
  gtk_container_add (GTK_CONTAINER (get_widget(Frame, "align")), vbox);

  GtkWidget *hboxmu = table_new (4,5, FALSE);
  g_object_set_data (G_OBJECT(father), "hboxbu", hboxmu);
  gtk_widget_show (hboxmu);
  gtk_box_pack_start (GTK_BOX (vbox), hboxmu, FALSE, FALSE, 0);
  table_set_row_spacings (hboxmu, 8);
  table_set_col_spacings (hboxmu, 2);

  GtkWidget *spin = SPIN_WITH_LABEL("Number of molecules in\n the asymmetric unit: ",
                     MyBLUE, 1, 100, 1, 1, 0);
  g_object_set_data (G_OBJECT(father),  "NMolsSpin", get_widget(spin, "spin"));
  gtk_widget_show_all (spin);
  //gtk_size_group_add_widget(sz, get_widget(spin, "spin"));

  GSList *group = NULL;
  for(int i=0; i<(int)(sizeof(radio_mu)/sizeof(radio_mu[0])); i++)
  {
      radio[i] = RADIO_BUTTON_WITH_LABEL (group, radio_mu[i], MyBLUE);
      g_object_set_data (G_OBJECT(father),  radio_mu[i], radio[i]);
      gtk_widget_show (radio[i]);
      group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio[i]));
      g_signal_connect(G_OBJECT(radio[i]), "toggled",
         G_CALLBACK(on_cont_radio_toggled), GINT_TO_POINTER(i));
      if(i < 2)
      {
         spin2[i] = SPIN_NEW(0, 1e+07, 0, 1000, 0);
         g_object_set_data (G_OBJECT(father),  spin_mu[i], spin2[i]);
         gtk_widget_show_all (spin2[i]);
#ifdef IN_GTK3
         gtk_widget_set_hexpand(spin2[i], FALSE);
         gtk_widget_set_halign(spin2[i], GTK_ALIGN_START);
#endif
         //gtk_size_group_add_widget(sz, spin2[i]);
      }
  }
  gtk_widget_set_sensitive(get_widget(father, spin_mu[1]), FALSE);
  GtkWidget *entry = entry_for_filesel(NULL, "", "SeqFile", 0, 1);
  gtk_widget_show (entry);
  g_object_set_data (G_OBJECT(father),  "SeqFile", entry);
  gtk_editable_set_editable(GTK_EDITABLE(entry), FALSE);
  GtkWidget *button = get_widget(entry, "browse");
#ifdef IN_GTK3
  gtk_widget_set_vexpand(entry, FALSE);
  gtk_widget_set_vexpand(button, FALSE);
  gtk_widget_set_valign(button, GTK_ALIGN_CENTER);
#endif
  g_signal_connect(G_OBJECT(button), "clicked",
       G_CALLBACK (on_SeqBrowse_clicked), NULL);

  GtkWidget *frameseq = gtk_frame_new(NULL);
  gtk_widget_show (frameseq);
  g_object_set_data (G_OBJECT(father),  "SeqFrame", frameseq);
  gtk_widget_set_sensitive(frameseq, FALSE);

  
  GtkWidget *Seq = ScrolledText (frameseq);
  gtk_widget_show (Seq);
//  gtk_container_add(GTK_CONTAINER(frameseq), get_widget(Seq, "box"));
  g_object_set_data (G_OBJECT(father),  "Seq", Seq);
  g_signal_connect (G_OBJECT(Seq), "paste-clipboard",
                    G_CALLBACK (on_SeqPaste), NULL);
  g_signal_connect_after (G_OBJECT(Seq), "paste-clipboard",
                    G_CALLBACK (on_SeqPasteAfter), NULL);

  GtkWidget *labelseq = LABEL_NEW("or paste data in the box above", MyBLUE);
  gtk_widget_show (labelseq);

  table_attach (hboxmu, spin, 0, 2, 0, 1);
  table_attach (hboxmu, radio[0], 0, 1, 1, 2);
  table_attach (hboxmu, spin2[0], 1, 2, 1, 2);
  table_attach (hboxmu, radio[1], 0, 1, 2, 3);
  table_attach (hboxmu, spin2[1], 1, 2, 2, 3);
  table_attach (hboxmu, frameseq, 2, 5, 0, 3, TRUE);
  table_attach (hboxmu, radio[2], 0, 1, 3, 4);
  //table_attach (hboxmu, radio[2], 0, 2, 3, 4);

  GtkWidget *hbox = hbox_new(FALSE, 0);
  gtk_widget_show(hbox);
  //table_attach (hboxmu, hbox, 2, 5, 3, 4);
  table_attach (hboxmu, hbox, 1, 5, 3, 4);
  gtk_box_pack_start(GTK_BOX(hbox), get_widget(entry, "box"), TRUE, TRUE, 0);
  gtk_box_pack_end(GTK_BOX(hbox), labelseq, FALSE, TRUE, 6);
  g_object_set_data (G_OBJECT(father),  "SeqBox", hbox);
  gtk_widget_set_sensitive(hbox, FALSE);

  hbox = frameLig(father, vbox);
  hbox = frameMad(father, vbox);
  return Frame;
}

void page3(GtkWidget *notebook, GtkWidget *new_project_dlg)
{
  GtkWidget *hbox;
  GtkWidget *vbox;
  GtkWidget *vbox1;
  GtkWidget *vbox2;
  GtkWidget *table1;
  GtkWidget *frame1;
  GtkWidget *label;
  GtkWidget *radiobutton;
  GSList *grp2_group = NULL;
  int i;

  vbox = vbox_new (FALSE, 4);
  gtk_widget_show (vbox);
  gtk_container_add (GTK_CONTAINER (notebook), vbox);

//  hbox = hbox_new(FALSE, 0);
  hbox = vbox_new(FALSE, 0);
  gtk_widget_show(hbox);
  gtk_box_pack_start (GTK_BOX (vbox), hbox, TRUE, TRUE, 0);

//  frame1 = gtk_frame_new(NULL);
//  gtk_widget_show(frame1);
//  gtk_box_pack_end (GTK_BOX (hbox), frame1, TRUE, TRUE, 0);
  
  vbox2 = vbox_new (FALSE, 4);
  gtk_widget_show (vbox2);
  gtk_box_pack_end (GTK_BOX (hbox), vbox2, TRUE, TRUE, 0);
//  gtk_container_add (GTK_CONTAINER (frame1), vbox2);

  GtkWidget *frameEl = frame_elements(new_project_dlg);
  g_object_set_data(G_OBJECT (new_project_dlg), "frame_elements", frameEl);
  g_object_set_data(G_OBJECT (new_project_dlg), "lista_elements", 
         get_widget(frameEl, "lista_elements"));
  gtk_box_pack_start (GTK_BOX (vbox2), frameEl, FALSE, FALSE, 8);
  gtk_widget_show(frameEl);

  GtkWidget *frameMu = frame_mu(new_project_dlg);
  g_object_set_data(G_OBJECT (new_project_dlg), "molecular_unit", 
         frameMu);
  gtk_box_pack_start (GTK_BOX (vbox2), frameMu, TRUE, TRUE, 0);

  table1 = table_new(1, 4, FALSE);
  gtk_widget_show(table1);
  gtk_box_pack_start (GTK_BOX (vbox2), table1, FALSE, FALSE, 0);
  table_set_row_spacings(table1, 4);
  table_set_col_spacings(table1, 10);
  gtk_container_set_border_width (GTK_CONTAINER (table1), 6);
  
  label = LABEL_NEW("Cell Volume:", MyBLUE);
  gtk_widget_show(label);
  set_alignment(label, 0., 0.5);
  table_attach_exp(table1, label, 0, 1, 0, 1);
 
  label = LABEL_NEW("Volume per Atom:", MyBLUE);
  gtk_widget_show(label);
  set_alignment(label, 0., 0.5);
  table_attach_exp(table1, label, 2, 3, 0, 1);
 
  label = label_boxed("vol cell");
  gtk_widget_show(label);
  table_attach_exp(table1, label, 1, 2, 0, 1);
  g_object_set_data(G_OBJECT(new_project_dlg), "vol_cell", gtk_bin_get_child(GTK_BIN(label)));
  gtk_widget_set_size_request(label, 80, -1);
 
  label = label_boxed("        ");
  gtk_widget_show(label);
  table_attach_exp(table1, label, 3, 4, 0, 1);
  g_object_set_data(G_OBJECT(new_project_dlg), "vol_per_at", gtk_bin_get_child(GTK_BIN(label)));
  gtk_widget_set_size_request(label, 80, -1);
 
//  frame1 = gtk_frame_new(NULL);
//  gtk_widget_show(frame1);
//  gtk_box_pack_start (GTK_BOX (hbox), frame1, FALSE, FALSE, 0);
//  gtk_frame_set_shadow_type(GTK_FRAME(frame1), GTK_SHADOW_NONE);
  
  vbox2 = vbox_new (FALSE, 4);
  gtk_widget_show (vbox2);
//  gtk_container_add (GTK_CONTAINER (frame1), vbox2);
  gtk_box_pack_start (GTK_BOX (hbox), vbox2, FALSE, FALSE, 0);

  //frame1 = FrameSize(vbox2, new_project_dlg);

  frame1 = NEW_FRAME ("Source", &FrameStyle1);//, &FrameStyle);
  gtk_widget_show (frame1);
  gtk_box_pack_start (GTK_BOX (vbox2), frame1, FALSE, FALSE, 0);

//  vbox1 = vbox_new (FALSE, 4);
  vbox1 = hbox_new (FALSE, 4);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (get_widget(frame1, "align")), vbox1);
  gtk_container_set_border_width (GTK_CONTAINER (vbox1), 4);

  for(i=0; i< (int)(sizeof(sources)/sizeof(sources[0])); i++)
  {
      radiobutton = RADIO_BUTTON_WITH_LABEL (grp2_group, sources[i], LABELCOLOR);
      //gtk_size_group_add_widget(sz, radiobutton);
      grp2_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton));
      g_object_set_data (G_OBJECT (new_project_dlg), sources[i], radiobutton);
      gtk_widget_show (radiobutton);
      gtk_box_pack_start (GTK_BOX (vbox1), radiobutton, FALSE, FALSE, 0);
#if 0
      if(i)
         g_signal_connect (G_OBJECT(radiobutton), "toggled",
                      G_CALLBACK(on_cb_attiva_single), new_project_dlg);
#endif
  }

#if 0
  GSList *grp1_group = NULL;
  frame1 = NEW_FRAME ("Wave Length", &FrameStyle1);//, &FrameStyle);
  gtk_widget_show (frame1);
  gtk_box_pack_start (GTK_BOX (vbox2), frame1, FALSE, FALSE, 0);

//  vbox1 = vbox_new (FALSE, 4);
  vbox1 = hbox_new (FALSE, 4);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (get_widget(frame1, "align")), vbox1);
  gtk_container_set_border_width (GTK_CONTAINER (vbox1), 4);

  radiobutton = RADIO_BUTTON_WITH_LABEL (grp1_group, "Cu", LABELCOLOR);
  gtk_size_group_add_widget(sz, radiobutton);
  grp1_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton));
  g_object_set_data (G_OBJECT (new_project_dlg), "Cu", radiobutton);
  gtk_widget_show (radiobutton);
  gtk_box_pack_start (GTK_BOX (vbox1), radiobutton, FALSE, FALSE, 0);

  radiobutton = RADIO_BUTTON_WITH_LABEL (grp1_group, "Mo", LABELCOLOR);
  gtk_size_group_add_widget(sz, radiobutton);
  grp1_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton));
  g_object_set_data (G_OBJECT (new_project_dlg), "Mo", radiobutton);
  gtk_widget_show (radiobutton);
  gtk_box_pack_start (GTK_BOX (vbox1), radiobutton, FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radiobutton), TRUE);

  radiobutton = RADIO_BUTTON_WITH_LABEL (grp1_group, "Other", LABELCOLOR);
  gtk_size_group_add_widget(sz, radiobutton);
  grp1_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton));
  g_object_set_data (G_OBJECT (new_project_dlg), "Other", radiobutton);
  gtk_widget_show (radiobutton);
  gtk_box_pack_start (GTK_BOX (vbox1), radiobutton, FALSE, FALSE, 0);

//  hbox = gtk_alignment_new(0.,0.5,0.,0.);
//  gtk_widget_show(hbox);
//  gtk_box_pack_start (GTK_BOX (vbox1), hbox, FALSE, FALSE, 0);

  GtkWidget *entry = gtk_entry_new ();
  gtk_size_group_add_widget(sz, entry);
  (void) g_signal_connect (G_OBJECT(radiobutton), "toggled", 
                      G_CALLBACK(on_cb_attiva), entry);
  g_object_set_data (G_OBJECT (new_project_dlg), "WaveLength", entry);
  gtk_widget_set_size_request(entry, 70, -1);
  gtk_widget_set_sensitive(entry, FALSE);
  gtk_widget_show (entry);
  gtk_box_pack_start (GTK_BOX (vbox1), entry, FALSE, FALSE, 0);
//  gtk_container_add (GTK_CONTAINER (hbox), entry);
  g_signal_connect (G_OBJECT(entry), "focus_in_event",
                   G_CALLBACK (on_entry_focus_in_event), NULL);
#endif
  bottoni_e_titolo(vbox, page_CONTENT,"Cell Content"); 
}

GtkWidget *i_refle(GtkWidget *notebook, GtkWidget *dlg)
{
  GtkWidget *hbox;
  GtkWidget *vbox;
  GtkWidget *vbox1;
  GtkWidget *vbox2;
  GtkWidget *button;
  GtkWidget *label;
  GtkWidget *frame;
  GtkWidget *table1;
  GtkWidget *table2;
  GtkWidget *entry;
  GtkWidget *frame1;
  GtkWidget *radiobutton;
  GtkWidget *alignment;
  GSList    *vbox2_group = NULL;
  int       i,j;
  char      key[5];

  if(GTK_IS_DIALOG(notebook))
     vbox = gtk_dialog_get_content_area(GTK_DIALOG(notebook));
  else
  {
     vbox = vbox_new (FALSE, 4);
     gtk_widget_show (vbox);
     gtk_container_add (GTK_CONTAINER (notebook), vbox);
  }

  table1 = table_new (12, 3, FALSE);
  gtk_widget_show (table1);
  table_set_row_spacings (table1, 4);
  table_set_col_spacings (table1, 4);
  gtk_box_pack_start (GTK_BOX (vbox), table1, TRUE, TRUE, 0);

  vbox1 = entry_for_fileselection("Reflections filename: ", NULL,
             G_CALLBACK(to_open_file), GINT_TO_POINTER(8), -1, 1, MyRED);
  gtk_widget_show(vbox1);
  table_attach(table1, vbox1, 0, 3, 0, 2, TRUE);
  entry = get_widget(vbox1, "entry");
  g_object_set_data(G_OBJECT (dlg), "rpc_file", entry);
  entry = get_widget(vbox1, "label");
  set_mandatory(entry);
  button = get_widget(vbox1, "preview");
  g_object_set_data(G_OBJECT (dlg), "preview_b", button);

  frame = NEW_FRAME("Preview Window", &FrameStyle);
  gtk_widget_show (frame);
  table_attach (table1, frame, 0, 2, 2, 7, TRUE);

  entry = scrolled_text(get_widget(frame, "align"));
  gtk_widget_show (entry);
//  set_widget_font(entry, main_app::TheApp.FontN().c_str());
  g_object_set_data (G_OBJECT (dlg), "preview_w", entry);
  (void) g_signal_connect(G_OBJECT(button), "clicked", 
         G_CALLBACK(file_preview), entry);

  frame = NEW_FRAME("Format", &FrameStyle);
  gtk_widget_show (frame);
  table_attach (table1, frame, 2, 3, 2, 7, TRUE);

  vbox2 = vbox_new (FALSE, 4);
  gtk_widget_show (vbox2);
  gtk_container_add (GTK_CONTAINER (get_widget(frame, "align")), vbox2);
  gtk_container_set_border_width (GTK_CONTAINER (vbox), 6);

  hbox = hbox_new(FALSE, 0);
  gtk_widget_show(hbox);
  gtk_box_pack_end (GTK_BOX (vbox2), hbox, FALSE, FALSE, 4);

  label = LABEL_NEW("Reflections per record", LABELCOLOR);
  gtk_widget_show (label);
  set_alignment(label, 0., 0.5);
  gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, TRUE, 0);

  entry = gtk_entry_new ();
  gtk_widget_set_size_request(entry, 40, -1);
  g_object_set_data (G_OBJECT (dlg), "refl_per_rec", entry);
  gtk_widget_show (entry);
  gtk_entry_set_text(GTK_ENTRY(entry), "1");
  gtk_box_pack_end(GTK_BOX(hbox), entry, FALSE, FALSE, 0);
  g_signal_connect (G_OBJECT(entry), "focus_in_event",
                   G_CALLBACK (on_entry_focus_in_event), NULL);

  hbox = hbox_new(FALSE, 0);
  gtk_widget_show(hbox);
  gtk_box_pack_start (GTK_BOX (vbox2), hbox, FALSE, FALSE, 4);

  entry = gtk_entry_new ();
  g_object_set_data (G_OBJECT (dlg), "format", entry);
  gtk_entry_set_text(GTK_ENTRY(entry), "(3I4, 2F8.2)");
  gtk_widget_show (entry);
  gtk_box_pack_end (GTK_BOX (hbox), entry, FALSE, FALSE, 4);
//  gtk_widget_set_sensitive(entry, FALSE);
  g_signal_connect (G_OBJECT(entry), "focus_in_event",
                   G_CALLBACK (on_entry_focus_in_event), NULL);

  radiobutton = RADIO_BUTTON_WITH_LABEL (vbox2_group, "Assumed format", LABELCOLOR);
  vbox2_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton));
  g_object_set_data(G_OBJECT (dlg), "Format3", radiobutton);
  gtk_widget_show (radiobutton);
//  gtk_box_pack_start (GTK_BOX (vbox2), radiobutton, FALSE, FALSE, 4);
  gtk_box_pack_start (GTK_BOX (hbox), radiobutton, FALSE, FALSE, 0);
  g_signal_connect (G_OBJECT(radiobutton), "toggled",
                   G_CALLBACK (on_cb_attiva), entry);

  radiobutton = RADIO_BUTTON_WITH_LABEL (vbox2_group, "Blanks delimited values", LABELCOLOR);
  vbox2_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton));
  g_object_set_data(G_OBJECT (dlg), "Format2", radiobutton);
  gtk_widget_show (radiobutton);
  gtk_box_pack_start (GTK_BOX (vbox2), radiobutton, FALSE, FALSE, 4);
  g_signal_connect (G_OBJECT(radiobutton), "toggled",
                   G_CALLBACK (on_cb_disattiva), entry);

  radiobutton = RADIO_BUTTON_WITH_LABEL (vbox2_group,
           "Shelx format (3I4, 2F8.2)", LABELCOLOR);
  vbox2_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton));
  g_object_set_data(G_OBJECT (dlg), "Format1", radiobutton);
  gtk_widget_show (radiobutton);
  gtk_box_pack_start (GTK_BOX (vbox2), radiobutton, FALSE, FALSE, 4);
  g_signal_connect (G_OBJECT(radiobutton), "toggled",
                   G_CALLBACK (on_cb_disattiva), entry);

  radiobutton = CHECK_BUTTON_WITH_LABEL("sigma(F) not supplied", LABELCOLOR);
  g_object_set_data(G_OBJECT (dlg), "ifsigma", radiobutton);
  gtk_widget_show (radiobutton);
  gtk_box_pack_start (GTK_BOX (vbox2), radiobutton, FALSE, FALSE, 4);

#if 0
  radiobutton = RADIO_BUTTON_WITH_LABEL (vbox2_group, "Blanks delimited values", LABELCOLOR);
  vbox2_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton));
  g_object_set_data(G_OBJECT (dlg), "Format2", radiobutton);
  gtk_widget_show (radiobutton);
  gtk_box_pack_start (GTK_BOX (vbox2), radiobutton, FALSE, FALSE, 4);
  g_signal_connect (G_OBJECT(radiobutton), "toggled",
                   G_CALLBACK (on_cb_disattiva), entry);

  radiobutton = RADIO_BUTTON_WITH_LABEL (vbox2_group, "User supplied format", LABELCOLOR);
  vbox2_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton));
  g_object_set_data(G_OBJECT (dlg), "Format3", radiobutton);
  gtk_widget_show (radiobutton);
//  gtk_box_pack_start (GTK_BOX (vbox2), radiobutton, FALSE, FALSE, 4);
  gtk_box_pack_start (GTK_BOX (hbox), radiobutton, FALSE, FALSE, 0);
  g_signal_connect (G_OBJECT(radiobutton), "toggled",
                   G_CALLBACK (on_cb_attiva), entry);
#endif

  label = LABEL_NEW ("User supplied thermal factor:", LABELCOLOR);
  gtk_widget_show (label);
  g_object_set_data (G_OBJECT (dlg), "thfaclabel", label);
  table_attach(table1, label, 2, 3, 8, 9, TRUE);
  set_alignment(label, 0., 0.5);

  entry = gtk_entry_new ();
  g_object_set_data (G_OBJECT (dlg), "Tfac", entry);
  gtk_widget_show (entry);
  table_attach (table1, entry, 2, 3, 9, 10, TRUE);
  g_signal_connect (G_OBJECT(entry), "focus_in_event",
                   G_CALLBACK (on_entry_focus_in_event), NULL);

  label = LABEL_NEW("Min. resolution value (Angstrom):", LABELCOLOR);
  gtk_widget_show (label);
  g_object_set_data (G_OBJECT (dlg), "minreslabel", label);
  table_attach(table1, label, 2, 3, 10, 11, TRUE);
  set_alignment(label, 0., 0.5);

  entry = gtk_entry_new ();
  g_object_set_data (G_OBJECT (dlg), "minres", entry);
  gtk_widget_show (entry);
  table_attach(table1, entry, 2, 3, 11, 12, TRUE);
  g_signal_connect (G_OBJECT(entry), "focus_in_event",
                   G_CALLBACK (on_entry_focus_in_event), NULL);

  frame1 = NEW_FRAME ("Transformation Matrix", &FrameStyle);
  gtk_widget_show (frame1);
  table_attach (table1, frame1, 0, 1, 8,12, TRUE);

  table2 = table_new (3, 3, FALSE);
  gtk_widget_show (table2);
  gtk_container_set_border_width (GTK_CONTAINER (table2), 0);
  alignment = get_widget(frame1, "align");
#ifdef IN_GTK3
  gtk_widget_set_hexpand(table2, FALSE);
  gtk_widget_set_vexpand(table2, FALSE);
  g_object_set(G_OBJECT(table2), "halign", GTK_ALIGN_CENTER, NULL);
  g_object_set(G_OBJECT(table2), "valign", GTK_ALIGN_CENTER, NULL);
#else
  gtk_alignment_set (GTK_ALIGNMENT(alignment),0.5, 0.5, 0, 0);
#endif
  gtk_container_add (GTK_CONTAINER (alignment), table2);
  table_set_row_spacings (table2, 1);
  table_set_col_spacings (table2, 4);

  for(i=0; i<3;i++)
  {
     for(j=0;j<3;j++)
     {
         entry = gtk_entry_new ();
         set_width_chars (GTK_ENTRY (entry), 3);
//         gtk_widget_set_size_request(entry, 20, 20);
         ScriviStringa(key, sizeof(key), "%d", 3*i+j);
         g_object_set_data(G_OBJECT(dlg), key, entry);
         gtk_widget_show (entry);
         table_attach (table2, entry, j, j+1, i, i+1, TRUE);
         if(i == j)
            gtk_entry_set_text (GTK_ENTRY(entry), "1");
         else
            gtk_entry_set_text (GTK_ENTRY(entry), "0");
         g_signal_connect (G_OBJECT(entry), "focus_in_event",
                   G_CALLBACK (on_entry_focus_in_event), NULL);
     }
  }

  frame1 = NEW_FRAME ("Structure factors", &FrameStyle);
  gtk_widget_show (frame1);
  table_attach (table1, frame1, 1, 2, 8, 12, TRUE);

  table2 = vbox_new (FALSE, 0);
  gtk_widget_show (table2);
  gtk_container_set_border_width (GTK_CONTAINER (table2), 4);
  gtk_container_add (GTK_CONTAINER (get_widget(frame1, "align")), table2);

  vbox2_group = NULL;
  radiobutton = RADIO_BUTTON_WITH_LABEL (vbox2_group, sfacs[0], LABELCOLOR);
  vbox2_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton));
  g_object_set_data(G_OBJECT (dlg), sfacs[0], radiobutton);
  gtk_widget_show (radiobutton);
  gtk_box_pack_start (GTK_BOX (table2), radiobutton, TRUE, TRUE, 0);

  radiobutton = RADIO_BUTTON_WITH_LABEL (vbox2_group, sfacs[1], LABELCOLOR);
  vbox2_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton));
  g_object_set_data(G_OBJECT (dlg), sfacs[1], radiobutton);
  gtk_widget_show (radiobutton);
  gtk_box_pack_start (GTK_BOX (table2), radiobutton, TRUE, TRUE, 0);

  return vbox;

}

void page4(GtkWidget *notebook, GtkWidget *new_project_dlg)
{
  GtkWidget *vbox;

  vbox = i_refle(notebook, new_project_dlg);
  bottoni_e_titolo(vbox, page_REFL,"Reflections");
}

void nblocks_changed(GtkWidget *button, GtkWidget *father)
{
  int i, num; 
  char nome[30];

  num = spin_button_get_value_as_int(button);
  for(i=1; i<=num; i++)
  {
     ScriviStringa(nome, sizeof(nome), "block%dlabel", i);
     gtk_widget_show(get_widget(father, nome));
     ScriviStringa(nome, sizeof(nome), "G%d", i);
     gtk_widget_show(get_widget(father, nome));
     ScriviStringa(nome, sizeof(nome), "S%d", i);
     gtk_widget_show(get_widget(father, nome));
  }
  for(i=num+1; i<=MaxBlocks; i++)
  {
     ScriviStringa(nome, sizeof(nome), "block%dlabel", i);
     gtk_widget_hide(get_widget(father, nome));
     ScriviStringa(nome, sizeof(nome), "G%d", i);
     gtk_widget_hide(get_widget(father, nome));
     ScriviStringa(nome, sizeof(nome), "S%d", i);
     gtk_widget_hide(get_widget(father, nome));
  }
}

void use_defaults(GtkToggleButton *button, GtkWidget *frame)
{
   int active = gtk_toggle_button_get_active(button);
   if(active)
      spin_button_set_value(get_widget(frame, "nblocchi"), 1);
   gtk_widget_set_sensitive(get_widget(frame, "G1"), !active);
   gtk_widget_set_sensitive(get_widget(frame, "S1"), !active);
   gtk_widget_set_sensitive(get_widget(frame, "nblocchi"),  !active);
}

void trials_g_changed(GtkWidget *spin, GtkWidget *spinS)
{
   GtkWidget *dlg = gtk_widget_get_toplevel(spinS);
   if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(get_widget(dlg, "VLDCheck"))))
       return;
   int trgen = spin_button_get_value_as_int(spin);
   int trsto = spin_button_get_value_as_int(spinS);
   spin_button_set_range(spinS, 1, trgen);
   spin_button_set_value(spinS, MRmin(trgen, trsto));
}

GtkWidget *frame_blocks(GtkWidget *father)
{
  GtkWidget *table, *table1, *frame, *label, *spin, *check, *spinG;
  int i; 
  char nome[30];

  frame = NEW_FRAME("Parameters", &FrameStyle);
  gtk_widget_show (frame);
  g_object_set_data(G_OBJECT(father), "frame_blocks", frame);
   
  table1 = table_new (12, 5, FALSE);
  gtk_widget_show (table1);
  gtk_container_add (GTK_CONTAINER (get_widget(frame, "align")), table1);
  table_set_col_spacings (table1, 20);
//  table_set_col_spacing (table1, 3, 50);
  table_set_row_spacings (table1, 4);
//  gtk_container_set_border_width (GTK_CONTAINER (table1), 6);

  table = table_new (11, 2, FALSE);
  gtk_widget_show (table);
  table_attach(table1, table, 0, 1, 0, 11, TRUE);
  g_object_set_data(G_OBJECT(father), "table_blocks", table);

  label = LABEL_NEW ("Nr. of Blocks    ", MyBLUE);
  gtk_widget_show (label);
  table_attach_exp (table, label, 0, 1, 0, 1);
  set_alignment(label, 0., 0.5);

  spin = spin_button_new_with_range (1, MaxBlocks, 1);
  gtk_widget_show (spin);
  table_attach_exp (table, spin, 0, 1, 1, 2);
  g_object_set_data(G_OBJECT(frame), "nblocchi", spin);
  g_signal_connect(G_OBJECT(spin), "value_changed",
          G_CALLBACK(nblocks_changed), frame);

  label = LABEL_NEW ("Block #", MyBLUE);
  gtk_widget_show (label);
  table_attach_exp (table, label, 1, 2, 0, 1);
  set_alignment(label, 0., 0.5);

  check = CHECK_BUTTON_WITH_LABEL("Use default values", LABELCOLOR);
  gtk_widget_show (check);
  g_object_set_data(G_OBJECT(father), "defaults", check);
  table_attach_exp (table1, check, 4, 5, 1, 2);
  g_signal_connect(G_OBJECT(check), "toggled",
          G_CALLBACK(use_defaults), frame);

  check = CHECK_BUTTON_WITH_LABEL("Use direct space", LABELCOLOR);
  g_object_set_data(G_OBJECT(father), "directspace", check);
  table_attach_exp (table1, check, 3, 4, 1, 2);

  label = SPIN_WITH_LABEL2("Stop when R% is less than", LABELCOLOR, 1, 50, 25, 1, 0, 0);
  g_object_set_data (G_OBJECT (father), "Rsoglia_l", label);
//  gtk_container_set_border_width (GTK_CONTAINER (label), 4);
  spin = get_widget (label, "spin");
  g_object_set_data (G_OBJECT (father), "Rsoglia", spin);
  gtk_widget_show_all (label);
  spin_button_set_numeric (spin, TRUE);
  spin_button_set_update_policy( spin,
                     GTK_UPDATE_IF_VALID);
//  gtk_widget_set_size_request(spin, 40, 20);
  set_width_chars(GTK_ENTRY(spin), 3);
  table_attach_exp (table1, label, 0, 3, 11, 12);


  for(i=1; i<=MaxBlocks; i++)
  {
     label = LABEL_NEW (g_strdup_printf("%d", i), MyBLUE);
     ScriviStringa(nome, sizeof(nome), "block%dlabel", i);
     g_object_set_data(G_OBJECT(frame), nome, label);
     if(i == 1)
        gtk_widget_show (label);
     table_attach_exp (table, label, 1, 2, i, i+1);
     set_alignment(label, 0.5, 0.5);
  }

  int kcol = 1;
  for(i=1; i<=MaxBlocks; i++)
  {
     spinG = spin_button_new_with_range (1, 300, 1);
     spin_button_set_value(spinG, 30);
     ScriviStringa(nome, sizeof(nome), "G%d", i);
     g_object_set_data(G_OBJECT(frame), nome, spinG);
     if(i == 1)
        gtk_widget_show (spinG);
     table_attach_exp (table1, spinG, kcol, kcol+1, i, i+1);

     spin = spin_button_new_with_range (1, 300, 1);
     spin_button_set_value(spin, 30);
     ScriviStringa(nome, sizeof(nome), "S%d", i);
     g_object_set_data(G_OBJECT(frame), nome, spin);
     if(i == 1)
        gtk_widget_show (spin);
     table_attach_exp (table1, spin, kcol+1, kcol+2, i, i+1);
     int hnd = g_signal_connect (G_OBJECT(spinG), "value-changed", G_CALLBACK(trials_g_changed), spin);
     g_object_set_data(G_OBJECT(spinG), "hnd", GINT_TO_POINTER(hnd));
  }

//  kcol = 0;
  label = LABEL_NEW ("Trials to generate", MyBLUE);
  gtk_widget_show (label);
  table_attach_exp (table1, label, kcol, kcol+1, 0, 1);
  set_alignment(label, 0., 0.5);

  label = LABEL_NEW ("Trials to store       ", MyBLUE);
  gtk_widget_show (label);
  table_attach_exp (table1, label, kcol+1, kcol+2, 0, 1);
  g_object_set_data(G_OBJECT(father), "label_trials", label);
  set_alignment(label, 0., 0.5);
  return frame;
}

void update_labelsize (GtkWidget *wid, GtkWidget *label)
{
   if((dime == nsizes) || (dime <= 0))
     gtk_label_set_text (GTK_LABEL (label), labsizes[real_dime-1]);
   else
     gtk_label_set_text (GTK_LABEL (label), labsizes[dime-1]);
       
}

void change_labelsize (GtkWidget *wid, GtkWidget *label)
{
   int pos;

   pos = dime;
   if(pos == oldPos)
      return;
   oldPos = pos;
   if(pos > 0)
      gtk_label_set_text (GTK_LABEL (label), 
                                   labsizes[pos-1]);
       
}

void show_frags(GtkWidget *dlg, int nFrags)
{
  for(int i=0; i<MAX_FRAGS; i++)
  {
      if(i < nFrags)
         gtk_widget_show(get_widget(dlg,g_strdup_printf("frag_entry%d",i)));
      else
         gtk_widget_hide(get_widget(dlg,g_strdup_printf("frag_entry%d",i)));
  }
}

void num_frags_changed(GtkWidget *spin, GtkWidget *dlg)
{
  int nFrags = spin_button_get_value_as_int(spin);
  show_frags(dlg, nFrags);
}

void to_open_file_frag(GtkWidget *button, gpointer data)
{
using namespace gtkext;
using namespace Sir;

  int nfrag = GPOINTER_TO_INT(data);
  GtkWidget *dlg = gtk_widget_get_toplevel(button);
  gtk_widget_set_sensitive(dlg, FALSE);
  std::string fn;
  fn = dlg_select_file(dlg, fn, eSELECT_TO_READ, 
    "*.mol,*.mop,*.mol2,*.ml2,*.cif,*.pdb,*.fhz,*.fra,*.xyz,*.ins,*.res");
  gtk_widget_set_sensitive(dlg, TRUE);
  if(!str_white(fn.c_str()))
  {
     GtkWidget *entry = get_widget(button, "entry");
     gtk_entry_set_text(GTK_ENTRY(entry), fn.c_str());
     CopiaStringa(project->szFragment[nfrag], MaxLenFilename,  fn.c_str()); 
  }
}

void relax_and_blocks(GtkWidget *dialog, GtkWidget *hbox, 
                        GtkWidget *vbox2)
{
  GtkWidget *vbox3, *button, *frame; 
  GSList *grp2_group = NULL;
 
  frame = NEW_FRAME("Relax", &FrameStyle);
  g_object_set_data(G_OBJECT (dialog), "Relax", frame);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 4);
//210114  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (hbox), frame, TRUE, TRUE, 10);

  vbox3 = vbox_new (FALSE, 0);
  gtk_widget_show (vbox3);
  gtk_container_add (GTK_CONTAINER (get_widget(frame, "align")), vbox3);
  gtk_container_set_border_width (GTK_CONTAINER (vbox3), 4);

  button = RADIO_BUTTON_WITH_LABEL (grp2_group, "Automatic", LABELCOLOR);
  grp2_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (button));
  gtk_widget_show (button);
  gtk_box_pack_start (GTK_BOX (vbox3), button, FALSE, FALSE, 0);
  g_object_set_data (G_OBJECT (dialog), "Automatic", button);

  button = RADIO_BUTTON_WITH_LABEL (grp2_group, "Never", LABELCOLOR);
  grp2_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (button));
  gtk_widget_show (button);
  gtk_box_pack_start (GTK_BOX (vbox3), button, FALSE, FALSE, 0);
  g_object_set_data (G_OBJECT (dialog), "Never", button);

  button = RADIO_BUTTON_WITH_LABEL (grp2_group, "Always", LABELCOLOR);
  grp2_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (button));
  gtk_widget_show (button);
  gtk_box_pack_start (GTK_BOX (vbox3), button, FALSE, FALSE, 0);
  g_object_set_data (G_OBJECT (dialog), "Always", button);

  button = CHECK_BUTTON_WITH_LABEL("Reset Starting Trial", LABELCOLOR);
  gtk_widget_show(button);
  g_object_set_data(G_OBJECT (dialog), "Resetst", button);
  gtk_box_pack_start(GTK_BOX(vbox2), button, FALSE, FALSE, 20);
  gtk_container_set_border_width (GTK_CONTAINER (button), 4);

// gianluca

  frame = frame_blocks(dialog);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 4);
  gtk_box_pack_start (GTK_BOX (vbox2), frame, FALSE, FALSE, 10);
  g_object_set_data(G_OBJECT (dialog), "lista_blocchi", frame);

  frame = FRAME_BOLD("Fragment for simulated annealing", MyBLUE, 1.1f);
  gtk_widget_show (frame);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 4);
  g_object_set_data(G_OBJECT(dialog), "frame_sa", frame);
  gtk_box_pack_start (GTK_BOX (vbox2), frame, TRUE, TRUE, 10);
  GtkWidget *vbox_sa = vbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER(frame), vbox_sa);
  gtk_widget_show(vbox_sa);
  GtkWidget *nfr = SPIN_WITH_LABEL("Number of fragments: ", MyBLUE, 1, 20, 1, 1, 0);
  gtk_box_pack_start (GTK_BOX (vbox_sa), nfr, FALSE, FALSE, 0);
  gtk_widget_show_all (nfr);
  g_object_set_data (G_OBJECT (dialog), "nFrags", get_widget(nfr, "spin"));
  g_signal_connect(G_OBJECT(get_widget(nfr, "spin")), "value-changed",
     G_CALLBACK(num_frags_changed), dialog);

  GtkWidget *scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow1);
  gtk_box_pack_start (GTK_BOX (vbox_sa), scrolledwindow1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (scrolledwindow1), 4);
//  gtk_widget_set_size_request(scrolledwindow1, 20,  80);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1),
        GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  GtkWidget *viewport = gtk_viewport_new(NULL, NULL);
  widget_modify_bg(viewport, GTK_STATE_NORMAL, &colorWhite);
  gtk_widget_show (viewport); 
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), viewport);

  GtkWidget *Vbox2 = vbox_new (FALSE, 4);
  gtk_widget_show (Vbox2);
  gtk_container_add (GTK_CONTAINER (viewport), Vbox2);

  for(int i=0; i<MAX_FRAGS; i++)
  {
      gchar *nome = g_strdup_printf("Fragment %d", i+1);
      GtkWidget *label = entry_for_fileselection("Filename", NULL,
          G_CALLBACK(to_open_file_frag), GINT_TO_POINTER(i), 0, 1, MyRED, 'h');
      g_free(nome);
      nome = g_strdup_printf("frag_file%d", i);
      g_object_set_data (G_OBJECT (dialog), nome, get_widget(label, "entry"));
      set_mandatory(get_widget(label, "label"));
  //gtk_container_add(GTK_CONTAINER(frame), label);
      gtk_box_pack_start(GTK_BOX(Vbox2), label, FALSE, FALSE, 0);
//      gtk_widget_show_all(label);
      g_free(nome);
      nome = g_strdup_printf("frag_entry%d", i);
      g_object_set_data (G_OBJECT (dialog), nome, label);
      g_free(nome);
  }

}

void select_strategy(GtkToggleButton *button, gpointer data)
{
   if(!gtk_toggle_button_get_active(button))
      return;
   int quale = GPOINTER_TO_INT(data);
   GtkWidget *father = gtk_widget_get_toplevel(GTK_WIDGET(button));
   GtkWidget *frame1 = get_widget(father, "frame_blocks");
   GtkWidget *frame2 = get_widget(father, "frame_sa");
   GtkWidget *frame, *label;
   gtk_widget_set_sensitive(frame1, (quale != S_SA) && (quale != S_AUTO));
   gtk_widget_set_sensitive(frame2, (quale == S_SA));
   obj_set_visible(frame1, (quale != S_SA) && (quale != S_AUTO));
   obj_set_visible(frame2, (quale == S_SA));
   frame1 = get_widget(father, "Relax");
//   if(father != np_dialog)
      gtk_widget_set_sensitive(frame1, (quale == S_PATT)||(quale == S_DM));
//  else
//     gtk_widget_set_sensitive(frame1, (quale != 3));
   frame1 = get_widget(father, "frame_size");
   gtk_widget_set_sensitive(frame1, (quale != S_SA));

   frame = get_widget(father, "table_blocks");
   gtk_widget_show(frame);
   label = get_widget(father, "label_trials");
   gtk_label_set_text(GTK_LABEL(label), "Trials to store       ");
   label = get_widget(father, "directspace");
   gtk_widget_hide(label);
   frame = get_widget(father, "lista_blocchi");
   label = get_widget(frame, "G1");
   spin_button_set_value(label, 100);
   label = get_widget(frame, "S1");
   spin_button_set_range(label, 1, 20);
   spin_button_set_value(label, 10);
//   frame = get_widget(father, "frame_blocks");
//   obj_set_visible((gpointer)frame, (quale != S_SA));
   label = get_widget(father, "label_trials");
   obj_set_visible((gpointer) label, (quale == S_VLD));
   frame = get_widget(father, "lista_blocchi");
   label = get_widget(frame, "S1");
   obj_set_visible((gpointer) label, (quale == S_VLD));
   if (quale != S_SA)
   {
       spin_button_set_value(get_widget(father, "nFrags"), 0);
       for(int j=0; j<MAX_FRAGS; j++)
       {
         char *nome = g_strdup_printf("frag_file%d", j);
         label = get_widget(father, nome);
         gtk_entry_set_text(GTK_ENTRY(label), " ");
       }
   }
   switch (quale)
   {
   case S_DM:
        frame = get_widget(father, "table_blocks");
        gtk_widget_hide(frame);
        gtk_widget_set_sensitive(get_widget(father, "defaults"), TRUE);
        gtk_widget_set_sensitive(get_widget(father, "Resetst"), FALSE);
        break;
//   case S_PATT:
//        frame = get_widget(father, "defaults");
//        gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(frame), TRUE);
//        gtk_widget_set_sensitive(get_widget(father, "defaults"), FALSE);
//        gtk_widget_set_sensitive(get_widget(father, "Resetst"), FALSE);
//        break;
   case S_PATT:
   case S_MDM:
        {
        label = get_widget(father, "combosize");
        int s = combo_get_val(label);
        label = get_widget(father, "label_trials");
        gtk_widget_hide(label);
        frame = get_widget(father, "lista_blocchi");
        label = get_widget(frame, "S1");
        gtk_widget_hide(label);
        label = get_widget(frame, "G1");
        spin_button_set_range(label, 1, 10000);
        if(s == 3)
           spin_button_set_value(label, 600);
        else
           spin_button_set_value(label, 100);
        }
   case S_VLD:
        frame = get_widget(father, "defaults");
        gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(frame), TRUE);
        gtk_widget_set_sensitive(frame, TRUE);
        frame = get_widget(father, "table_blocks");
        gtk_widget_hide(frame);
        label = get_widget(father, "label_trials");
        gtk_label_set_text(GTK_LABEL(label), "EDM-DEDM iterations    ");
        frame = get_widget(father, "lista_blocchi");
        label = get_widget(frame, "G1");
        if(quale == S_VLD)
           spin_button_set_value(label, 20);
        if(quale == S_PATT)
        {
           spin_button_set_range(label, 1, 1000);
           spin_button_set_value(label, 100);
        }
        label = get_widget(frame, "S1");
        spin_button_set_range(label, 10, 1000);
        spin_button_set_value(label, 300);
        break;
   case S_SA:
        {
           int nf= spin_button_get_value_as_int(get_widget(father, "nFrags"));
           show_frags(father, nf);
        }
   case S_AUTO:
        break;
   }
        GtkWidget *soglia = get_widget(father, "Rsoglia_l");
        if((real_dime <= 3) && (Neutro != 2))
//        if(real_dime <= 3)
           gtk_widget_show(soglia);
        else
           gtk_widget_hide(soglia);
}

void on_pdbview_clicked (GtkWidget *button, gpointer data)
{
    GtkWidget *entry = (GtkWidget *) data;
    const char *fil = gtk_entry_get_text(GTK_ENTRY(entry));
    std::string fn = fil;
    if( !fn.empty() )
    gtkext::text_window(GTK_WINDOW(gtk_widget_get_toplevel(entry)),
      fn.c_str(), "*.pdb", gtkext::IFREADONLY, fn.c_str(), 850, 500);
}

void to_open_file_pdb(GtkWidget *button, gpointer data)
{
using namespace gtkext;
using namespace Sir;

  int nmodel = GPOINTER_TO_INT(data);
  GtkWidget *dlg = gtk_widget_get_toplevel(button);
  gtk_widget_set_sensitive(dlg, FALSE);
  std::string fn;
  fn = dlg_select_file(dlg, fn, eSELECT_TO_READ, "*.pdb,*.ent");
  gtk_widget_set_sensitive(dlg, TRUE);
  if(!str_white(fn.c_str()))
  {
     GtkWidget *entry = get_widget(button, "entry");
     gtk_entry_set_text(GTK_ENTRY(entry), fn.c_str());
     CopiaStringa(project->szMRFile[nmodel], MaxLenFilename, fn.c_str());
     project->CheckPDBFile(fn, nmodel);
     project->FillFromPDB(nmodel);
  }
}

MRmodel *model_info(GtkWidget *father, int n)
{
  GtkWidget *frame;
  GtkWidget *vbox;
  GtkWidget *hbox;
  GtkWidget *entry;
  GtkWidget *ViewBtn;
  GtkWidget *table_remo;
  GtkWidget *label;
  GtkWidget *spin;
  GtkWidget *check;
  GtkWidget *radio;
  GtkWidget *hbox1;
  GtkWidget *hbox2;
  GSList *group = NULL;
  GObject *adj;
  GtkSizeGroup *szgroup;

  MRmodel *model = g_new0(MRmodel, 1);

  frame = NEW_FRAME(g_strdup_printf("Model n. %d", n+1), &FrameStyle);
  gtk_widget_set_name (frame, g_strdup_printf("MRModel%d",n));
  HOOKUP_OBJECT (father, frame, g_strdup_printf("MRModel%d",n));
  model->frame = frame;

  vbox = vbox_new (FALSE, 8);
  gtk_widget_show (vbox);
  gtk_container_add (GTK_CONTAINER (get_widget(frame, "align")), vbox);
  gtk_container_set_border_width (GTK_CONTAINER (vbox), 8);

  hbox2 = entry_for_fileselection("Model PDB file", NULL,
             G_CALLBACK(to_open_file_pdb), GINT_TO_POINTER(n), 1, 1, MyBLUE);
  entry = get_widget(hbox2, "entry");
  gtk_box_pack_start(GTK_BOX(vbox), hbox2, FALSE, FALSE, 0);
  gtk_widget_set_name (entry, g_strdup_printf("MRFileEntry%d", n));
  ViewBtn = get_widget(hbox2, "preview");
  model->PDBentry = entry;
  HOOKUP_OBJECT (father, entry, g_strdup_printf("MRFileEntry%d", n));
  g_signal_connect ((gpointer) ViewBtn, "clicked",
                    G_CALLBACK (on_pdbview_clicked),
                    entry);

  table_remo = table_new(2, 2, FALSE);      //TRUE);
  gtk_widget_show (table_remo);
  gtk_box_pack_start (GTK_BOX (vbox), table_remo, FALSE, FALSE, 20);
//  table_set_col_spacing(table_remo, 0, 50);

  hbox = hbox_new (FALSE, 0);
  gtk_widget_show (hbox);
  table_attach_exp(table_remo, hbox, 0, 1, 0, 1);

  label = LABEL_NEW ("Number of monomers to search", MyBLUE);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);

  adj = adj_new (1, 1, 100000, 1, 2);
  spin = spin_button_new (GTK_ADJUSTMENT (adj), 1, 0);
  gtk_widget_show (spin);
  gtk_box_pack_start (GTK_BOX (hbox), spin, FALSE, TRUE, 10);
  model->nMonomers = spin;
  HOOKUP_OBJECT (father, spin, g_strdup_printf("MRNmolSpin%d", n));

  check = CHECK_BUTTON_WITH_LABEL ("Use heteroatoms",MyBLUE);
  gtk_widget_show (check);
  table_attach_exp(table_remo, check, 0, 1, 1, 2);
  model->hetero = check;
  gtk_widget_set_name (check, g_strdup_printf("MRHeteroCheck%d", n));
  HOOKUP_OBJECT (father, check, g_strdup_printf("MRHeteroCheck%d", n));

  label = NEW_FRAME ("Thermal Factor: ", &FrameStyle);
  gtk_widget_show (label);
  table_attach_exp(table_remo, label, 1, 2, 0, 2);

  hbox = vbox_new (FALSE, 2);
  gtk_widget_show (hbox);
  gtk_container_add(GTK_CONTAINER(get_widget(label, "align")), hbox);

  radio = RADIO_BUTTON_WITH_LABEL (NULL, "PDB", MyBLUE);
  gtk_widget_show (radio);
  gtk_box_pack_start (GTK_BOX (hbox), radio, FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radio), group);
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
  model->PDBradio = radio;
  gtk_widget_set_name (radio, g_strdup_printf("MRPdbRadio%d", n));
  HOOKUP_OBJECT (father, radio, g_strdup_printf("MRPdbRadio%d", n));

  radio = RADIO_BUTTON_WITH_LABEL (NULL, "Proportional to Wilson", MyBLUE);
  gtk_widget_show (radio);
  gtk_box_pack_start (GTK_BOX (hbox), radio, FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radio), group);
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
  model->Wilsonradio = radio;
  gtk_widget_set_name (radio, g_strdup_printf("MRWilsonRadio%d", n));
  HOOKUP_OBJECT (father, radio, g_strdup_printf("MRWilsonRadio%d", n));

  radio = RADIO_BUTTON_WITH_LABEL (NULL, "20", MyBLUE);
  gtk_widget_show (radio);
  gtk_box_pack_start (GTK_BOX (hbox), radio, FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radio), group);
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
  model->p20radio = radio;
  gtk_widget_set_name (radio, g_strdup_printf("MR20Radio%d", n));
  HOOKUP_OBJECT (father, radio, g_strdup_printf("MR20Radio%d", n));

  label = NEW_FRAME ("Similarity of the PDB model to the target structure", &FrameStyle1);
  gtk_widget_show (label);

#ifdef IN_GTK3
  gtk_widget_set_hexpand(label, TRUE);
  gtk_widget_set_vexpand(label, TRUE);
  gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, FALSE, 0);
#else
  GtkWidget *align = gtk_alignment_new(0,0,1,1);
  gtk_widget_show (align);
  gtk_box_pack_start (GTK_BOX (vbox), align, FALSE, FALSE, 0);
#ifndef CANNOT_PAD_ALIGN
  gtk_alignment_set_padding(GTK_ALIGNMENT(align), 0, 0, 0, 20);
#endif
  gtk_container_add (GTK_CONTAINER (align), label);
#endif

  hbox = hbox_new (FALSE, 6);
  gtk_widget_show (hbox);
  gtk_container_add (GTK_CONTAINER(get_widget(label, "align")) , hbox);
  gtk_container_set_border_width (GTK_CONTAINER(hbox) , 6);

  radio = LABEL_NEW ("Sequence identity:", MyBLUE);
  gtk_widget_show (radio);
  gtk_box_pack_start (GTK_BOX (hbox), radio, FALSE, FALSE, 0);

  check = CHECK_BUTTON_WITH_LABEL ("Computed by the program", MyBLUE);
  gtk_widget_show (check);
  gtk_box_pack_start (GTK_BOX (hbox), check, FALSE, FALSE, 20);
  model->seqid_check = check;
  gtk_widget_set_name (check, g_strdup_printf("MRSeqIdeCheck%d", n));
  HOOKUP_OBJECT (father, check, g_strdup_printf("MRSeqIdeCheck%d", n));

  spin = SPIN_WITH_LABEL (" ",MyBLUE, 0, 1, 1, .1, 4);
  gtk_widget_show_all (spin);
  gtk_box_pack_start (GTK_BOX (hbox), spin, FALSE, FALSE, 6);
  gtk_widget_set_sensitive(spin, FALSE);
  set_width_chars(GTK_ENTRY(get_widget(spin, "spin")), 8);
  g_signal_connect(G_OBJECT(check), "toggled", G_CALLBACK(on_cb_disattiva),
         spin);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check), TRUE);

  model->entry = spin;
  gtk_widget_set_name (get_widget(spin,"spin" ), g_strdup_printf("MRvalue%d", n));
  HOOKUP_OBJECT (father, get_widget( spin,"spin" ), g_strdup_printf("MRvalue%d", n));

  label = NEW_FRAME ("Modify model", &FrameStyle1);
  gtk_widget_show (label);

#ifdef IN_GTK3
  gtk_widget_set_hexpand(label, TRUE);
  gtk_widget_set_vexpand(label, TRUE);
  gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, FALSE, 0);
#else
  align = gtk_alignment_new(0,0,1,1);
  gtk_widget_show (align);
  gtk_box_pack_start (GTK_BOX (vbox), align, FALSE, FALSE, 0);
#ifndef CANNOT_PAD_ALIGN
  gtk_alignment_set_padding(GTK_ALIGNMENT(align), 0, 0, 0, 20);
#endif
  gtk_container_add (GTK_CONTAINER (align), label);
#endif

  hbox = hbox_new (FALSE, 6);
  gtk_widget_show (hbox);
  gtk_container_add (GTK_CONTAINER(get_widget(label, "align")) , hbox);
  gtk_container_set_border_width (GTK_CONTAINER(hbox) , 6);

  check = CHECK_BUTTON_WITH_LABEL ("Polyalanine model", MyBLUE);
  gtk_widget_show (check);
  gtk_box_pack_start (GTK_BOX (hbox), check, FALSE, FALSE, 10);
  model->polycheck = check;
  gtk_widget_set_name (check, g_strdup_printf("MRPolyalaCheck%d", n));
  HOOKUP_OBJECT (father, check, g_strdup_printf("MRPolyalaCheck%d", n));

//  hbox1 = hbox_new (FALSE, 6);
//  gtk_widget_show (hbox1);
//  gtk_box_pack_end (GTK_BOX (hbox), hbox1, FALSE, FALSE, 10);

  check = CHECK_BUTTON_WITH_LABEL ("Cut model:", MyBLUE);
  gtk_widget_show (check);
//  gtk_box_pack_start (GTK_BOX (hbox1), check, FALSE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (hbox), check, FALSE, FALSE, 0);
  model->cutmodel = check;
  gtk_widget_set_name (check, g_strdup_printf("MRCutCheck%d", n));
  HOOKUP_OBJECT (father, check, g_strdup_printf("MRCutCheck%d", n));

  spin = ENTRY_WITH_LIM ("use residues from ",MyBLUE, 1, 3000, 1, 0);
  gtk_widget_show_all (spin);
//  gtk_box_pack_start (GTK_BOX (hbox1), spin, FALSE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX (hbox), spin, FALSE, TRUE, 0);
  gtk_widget_set_sensitive(spin, FALSE);
  g_signal_connect ((gpointer) check, "toggled",
                    G_CALLBACK (on_cb_attiva), spin);
  model->fromres = spin;
  HOOKUP_OBJECT (father, get_widget( spin,"spin" ), g_strdup_printf("MRn1Spin%d", n));

  spin = ENTRY_WITH_LIM ("to ",MyBLUE, 1, 3000, 1, 0);
  gtk_widget_show_all (spin);
//  gtk_box_pack_start (GTK_BOX (hbox1), spin, FALSE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX (hbox), spin, FALSE, TRUE, 0);
  gtk_widget_set_sensitive(spin, FALSE);
  g_signal_connect ((gpointer) check, "toggled",
                    G_CALLBACK (on_cb_attiva), spin);
  model->tores = spin;
  HOOKUP_OBJECT (father, get_widget( spin,"spin" ), g_strdup_printf("MRn2Spin%d", n));

  label = NEW_FRAME ("Rotation: ", &FrameStyle1);
  gtk_widget_show (label);

#ifdef IN_GTK3
  gtk_widget_set_hexpand(label, TRUE);
  gtk_widget_set_vexpand(label, TRUE);
  gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, FALSE, 0);
#else
  align = gtk_alignment_new(0,0,1,1);
  gtk_widget_show (align);
  gtk_box_pack_start (GTK_BOX (vbox), align, FALSE, FALSE, 0);
#ifndef CANNOT_PAD_ALIGN
  gtk_alignment_set_padding(GTK_ALIGNMENT(align), 0, 0, 0, 20);
#endif
  gtk_container_add (GTK_CONTAINER (align), label);
#endif

  hbox = hbox_new (FALSE, 6);
  gtk_widget_show (hbox);
  gtk_container_add (GTK_CONTAINER(get_widget(label, "align")) , hbox);
  gtk_container_set_border_width (GTK_CONTAINER(hbox) , 6);

  check = CHECK_BUTTON_WITH_LABEL ("Fixed", MyBLUE);
  gtk_widget_show (check);
  gtk_box_pack_start (GTK_BOX (hbox), check, FALSE, FALSE, 0);
  model->rotfix = check;
  gtk_widget_set_name (check, g_strdup_printf("MRRotCheck%d", n));
  HOOKUP_OBJECT (father, check, g_strdup_printf("MRRotCheck%d", n));

  hbox1 = hbox_new (FALSE, 8);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (hbox), hbox1, FALSE, TRUE, 30);
  gtk_widget_set_sensitive (hbox1, FALSE);
  g_signal_connect ((gpointer) check, "toggled",
                    G_CALLBACK (on_cb_attiva), hbox1);

  label = LABEL_NEW("Eulerian angles (degrees)", MyBLUE);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox1), label, TRUE, TRUE, 0);

  szgroup = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);

  spin = ENTRY_WITH_LIM (NULL,MyBLUE, 0, 360, 0, 0);
  //adj = adj_new (0, 0, 360, 1, 10);
  //spin = spin_button_new (GTK_ADJUSTMENT (adj), 1, 0);
  gtk_widget_show_all(spin);
  gtk_box_pack_start (GTK_BOX (hbox1), spin, TRUE, TRUE, 10);
//  gtk_size_group_add_widget(szgroup, spin);
  model->rot1 = spin;
  HOOKUP_OBJECT (father, get_widget(spin, "spin"), g_strdup_printf("MRRot1Spin%d", n));

  spin = ENTRY_WITH_LIM (NULL,MyBLUE, 0, 360, 0, 0);
  //adj = adj_new (0, 0, 360, 1, 10);
  //spin = spin_button_new (GTK_ADJUSTMENT (adj), 1, 0);
  gtk_widget_show_all(spin);
  gtk_box_pack_start (GTK_BOX (hbox1), spin, TRUE, TRUE, 10);
//  gtk_size_group_add_widget(szgroup, spin);
  model->rot2 = spin;
  HOOKUP_OBJECT (father, get_widget(spin, "spin"), g_strdup_printf("MRRot2Spin%d", n));
 
  spin = ENTRY_WITH_LIM (NULL,MyBLUE, 0, 360, 0, 0);
  //adj = adj_new (0, 0, 360, 1, 10);
  //spin = spin_button_new (GTK_ADJUSTMENT (adj), 1, 0);
  gtk_widget_show_all(spin);
  gtk_box_pack_start (GTK_BOX (hbox1), spin, TRUE, TRUE, 10);
//  gtk_size_group_add_widget(szgroup, spin);
  model->rot3 = spin;
  HOOKUP_OBJECT (father, get_widget(spin, "spin"), g_strdup_printf("MRRot3Spin%d", n));

  label = NEW_FRAME ("Translation: ", &FrameStyle);
  //gtk_widget_show (label);

#ifdef IN_GTK3
  gtk_widget_set_hexpand(label, TRUE);
  gtk_widget_set_vexpand(label, TRUE);
  gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, FALSE, 0);
#else
  align = gtk_alignment_new(0,0,1,1);
//  gtk_widget_show (align);             //da commentare
  gtk_box_pack_start (GTK_BOX (vbox), align, FALSE, FALSE, 0);
#ifndef CANNOT_PAD_ALIGN
  gtk_alignment_set_padding(GTK_ALIGNMENT(align), 0, 0, 0, 20);
#endif
  gtk_container_add (GTK_CONTAINER (align), label);
#endif

  hbox = hbox_new (FALSE, 6);
  gtk_widget_show (hbox);
  gtk_container_add (GTK_CONTAINER(get_widget(label, "align")), hbox);
  gtk_container_set_border_width (GTK_CONTAINER(hbox), 6);

  check = CHECK_BUTTON_WITH_LABEL ("Fixed", MyBLUE);
  gtk_widget_show (check);
  gtk_box_pack_start (GTK_BOX (hbox), check, FALSE, FALSE, 0);
  model->transfix = check;
  gtk_widget_set_name (check, g_strdup_printf("MRTransCheck%d", n));
  HOOKUP_OBJECT (father, check, g_strdup_printf("MRTransCheck%d", n));

  hbox1 = hbox_new (FALSE, 8);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (hbox), hbox1, TRUE, TRUE, 30);
  gtk_widget_set_sensitive (hbox1, FALSE);
  g_signal_connect ((gpointer) check, "toggled",
                    G_CALLBACK (on_cb_attiva), hbox1);

  label = LABEL_NEW("Fractional coordinates   ", MyBLUE);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox1), label, TRUE, TRUE, 0);

  adj = adj_new (0, 0, 1, 0.1, 0.1);
  spin = spin_button_new (GTK_ADJUSTMENT (adj), 1, 3);
  gtk_widget_show (spin);
  gtk_box_pack_start (GTK_BOX (hbox1), spin, FALSE, TRUE, 10);
  gtk_size_group_add_widget(szgroup, spin);
  model->trans1 = spin;
  HOOKUP_OBJECT (father, spin, g_strdup_printf("MRTrans1Spin%d", n));

  adj = adj_new (0, 0, 1, 0.1, 0.1);
  spin = spin_button_new (GTK_ADJUSTMENT (adj), 1, 3);
  gtk_widget_show (spin);
  gtk_box_pack_start (GTK_BOX (hbox1), spin, FALSE, TRUE, 10);
  gtk_size_group_add_widget(szgroup, spin);
  model->trans2 = spin;
  HOOKUP_OBJECT (father, spin, g_strdup_printf("MRTrans2Spin%d", n));

  adj = adj_new (0, 0, 1, 0.1, 0.1);
  spin = spin_button_new (GTK_ADJUSTMENT (adj), 1, 3);
  gtk_widget_show (spin);
  gtk_box_pack_start (GTK_BOX (hbox1), spin, FALSE, TRUE, 10);
  gtk_size_group_add_widget(szgroup, spin);
  model->trans3 = spin;
  HOOKUP_OBJECT (father, spin, g_strdup_printf("MRTrans3Spin%d", n));

  hbox = hbox_new (FALSE, 8);
//  gtk_widget_show (hbox);              // da commentare
  gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, TRUE, 0);

  check =  CHECK_BUTTON_WITH_LABEL ("EDM", MyBLUE);
  gtk_widget_show (check);
  gtk_box_pack_start (GTK_BOX (hbox), check, FALSE, FALSE, 0);
  model->edm = check;
  gtk_widget_set_name (check, g_strdup_printf("MREdmCheck%d", n));
  HOOKUP_OBJECT (father, check, g_strdup_printf("MREdmCheck%d", n));

  hbox1 = hbox_new (FALSE, 8);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (hbox), hbox1, TRUE, TRUE, 30);
  gtk_widget_set_sensitive (hbox1, FALSE);
  g_signal_connect ((gpointer) check, "toggled",
                    G_CALLBACK (on_cb_attiva), hbox1);

  label = LABEL_NEW ("Extend resolution up to", MyBLUE);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox1), label, FALSE, FALSE, 0);

  adj = adj_new (1, 0, 10, 1, 10);
  spin = spin_button_new (GTK_ADJUSTMENT (adj), 1, 0);
  gtk_widget_show (spin);
  gtk_box_pack_start (GTK_BOX (hbox1), spin, FALSE, TRUE, 0);
  model->edmspin = spin;
  HOOKUP_OBJECT (father, spin, g_strdup_printf("MREdmSpin%d", n));

  return model;
}

void create_task_info(GtkWidget *father, GtkWidget *parent_box)
{
  GtkWidget *hb;
  GtkWidget *vb;
  GtkWidget *hbox;
  GtkWidget *label;
  GtkWidget *spin;
  GtkWidget *radio;
  GtkWidget *hbox1;
  GSList *group = NULL;

  MRtask *model = g_new0(MRtask, 1);

  hb = table_new(1, 2, FALSE);
  gtk_widget_show (hb);
  gtk_box_pack_start (GTK_BOX (parent_box), hb, FALSE, FALSE, 0);
  table_set_col_spacings(hb, 12);

  vb = vbox_new (FALSE, 8);
  gtk_widget_show (vb);
  table_attach_exp(hb, vb, 0, 1, 0, 1);

  label = NEW_FRAME ("Resolution range", &FrameStyle);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (vb), label, FALSE, FALSE, 0);

  hbox = hbox_new (FALSE, 8);
  gtk_widget_show (hbox);
  gtk_container_add (GTK_CONTAINER (get_widget(label, "align")), hbox);
  gtk_container_set_border_width (GTK_CONTAINER (hbox), 6);

  group = NULL;
  radio = RADIO_BUTTON_WITH_LABEL (NULL, "Automatic", MyBLUE);
  gtk_widget_show (radio);
  gtk_box_pack_start (GTK_BOX (hbox), radio, FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radio), group);
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
  model->autores = radio;
  HOOKUP_OBJECT (father, radio, "MRaRes");

  radio = RADIO_BUTTON_WITH_LABEL (NULL, "Manual", MyBLUE);
  gtk_widget_show (radio);
  gtk_box_pack_start (GTK_BOX (hbox), radio, FALSE, FALSE, 10);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radio), group);
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
  model->manres = radio;
  HOOKUP_OBJECT (father, radio, "MRmRes");

  spin = ENTRY_WITH_LABEL("Max Res.: ", MyBLUE, 1., 2);
  gtk_widget_show_all (spin);
  gtk_box_pack_start (GTK_BOX (hbox), spin, FALSE, TRUE, 20);
  gtk_widget_set_sensitive(spin, FALSE);
  model->minres = spin;
  //spin_button_set_update_policy(get_widget(spin, "spin"), GTK_UPDATE_IF_VALID);
  g_signal_connect(G_OBJECT(model->manres), "toggled", G_CALLBACK(on_cb_attiva), spin);
  HOOKUP_OBJECT (father, get_widget(spin, "spin"), "MRResMinSpin");

  spin = ENTRY_WITH_LABEL("Min Res.: ", MyBLUE, 1., 2);
  gtk_widget_show_all (spin);
  gtk_box_pack_start (GTK_BOX (hbox), spin, FALSE, TRUE, 10);
  gtk_widget_set_sensitive(spin, FALSE);
  model->maxres = spin;
  //spin_button_set_update_policy(get_widget(spin, "spin"), GTK_UPDATE_IF_VALID);
  g_signal_connect(G_OBJECT(model->manres), "toggled", G_CALLBACK(on_cb_attiva), spin);
  HOOKUP_OBJECT (father, get_widget(spin, "spin"), "MRResMaxSpin");

  label = NEW_FRAME ("Thresholds selection  ", &FrameStyle);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (vb), label, FALSE, FALSE, 0);

  hbox = table_new (2, 2, FALSE);
  gtk_widget_show (hbox);
  gtk_container_add (GTK_CONTAINER (get_widget(label, "align")), hbox);
  gtk_container_set_border_width (GTK_CONTAINER (hbox), 6);
  table_set_col_spacings (hbox, 30);

  group = NULL;
  radio = RADIO_BUTTON_WITH_LABEL (NULL, "Automatic", MyBLUE);
  gtk_widget_show (radio);
  table_attach_exp (hbox, radio, 0, 1, 0, 1);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radio), group);
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
  model->autotres = radio;
  gtk_widget_set_name (radio, "MRTSAuto");
  HOOKUP_OBJECT (father, radio, "MRTSAuto");

  radio = RADIO_BUTTON_WITH_LABEL (NULL, "Manual", MyBLUE);
  gtk_widget_show (radio);
  table_attach_exp (hbox, radio, 0, 1, 1, 2);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radio), group);
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
  model->mantres = radio;
  gtk_widget_set_name (radio, "MRTSMan");
  HOOKUP_OBJECT (father, radio, "MRTSMan");

  hbox1 = table_new (1, 4, FALSE);
  gtk_widget_show (hbox1);
  table_attach (hbox, hbox1, 1, 2, 0, 2, TRUE);
  table_set_col_spacings (hbox1, 10);
  gtk_widget_set_sensitive(hbox1, FALSE);
  g_signal_connect(G_OBJECT(model->mantres), "toggled", G_CALLBACK(on_cb_attiva), hbox1);

  spin = ENTRY_WITH_LABEL("Rotation ", MyBLUE, 0., 2, 1);
  gtk_widget_show_all (spin);
  table_attach_exp (hbox1, spin, 0, 1, 0, 1);
  model->rot = spin;
  HOOKUP_OBJECT (father, get_widget(spin, "spin"), "MRTSRotSpin");

  spin = ENTRY_WITH_LABEL("Optimization ", MyBLUE, 0., 2, 1);
  gtk_widget_show_all (spin);
  table_attach_exp (hbox1, spin, 1, 2, 0, 1);
  model->rotlocal = spin;
  HOOKUP_OBJECT (father, get_widget(spin, "spin"), "MRTSRotLocSpin");

  spin = ENTRY_WITH_LABEL("Translation ", MyBLUE, 0., 2, 1);
  gtk_widget_show_all (spin);
  table_attach_exp (hbox1, spin, 2, 3, 0, 1);
  model->trans = spin;
  HOOKUP_OBJECT (father, get_widget(spin, "spin"), "MRTSTraSpin");

  spin = ENTRY_WITH_LABEL("Optimization ", MyBLUE, 0., 2, 1);
  gtk_widget_show_all (spin);
  table_attach_exp (hbox1, spin, 3, 4, 0, 1);
  model->translocal = spin;
  HOOKUP_OBJECT (father, get_widget(spin, "spin"), "MRTSTraLocSpin");

  vb = vbox_new (FALSE, 8);
  gtk_widget_show (vb);
  table_attach_exp(hb, vb, 1, 2, 0, 1);

  label = NEW_FRAME ("Solving Strategy", &FrameStyle);
  gtk_widget_show (label);
  //gtk_box_pack_start (GTK_BOX (vb), label, FALSE, FALSE, 0);

  vb = vbox_new (FALSE, 8);
  gtk_widget_show (vb);
  gtk_container_add(GTK_CONTAINER(get_widget(label, "align")), vb);

  GtkWidget *MRVLDCheck = CHECK_BUTTON_WITH_LABEL ("Improve",  MyBLUE);
  gtk_widget_show(MRVLDCheck);
  gtk_box_pack_start(GTK_BOX(vb), MRVLDCheck, FALSE, FALSE, 2);
//  model->vldcheck = MRVLDCheck;
//  HOOKUP_OBJECT (father, MRVLDCheck, "MRVLDCheck");
  
#if 0
  GtkWidget *MRFLCheck = CHECK_BUTTON_WITH_LABEL ("Free Lunch",  MyBLUE);
  gtk_widget_show(MRFLCheck);
  gtk_box_pack_start(GTK_BOX(vb), MRFLCheck, FALSE, FALSE, 2);
  model->flcheck = MRFLCheck;
  HOOKUP_OBJECT (father, MRFLCheck, "MRFLCheck");
  
  GtkWidget *MRAMBCheck = CHECK_BUTTON_WITH_LABEL ("Automated Model Building",  MyBLUE);
  gtk_widget_show(MRAMBCheck);
  gtk_box_pack_start(GTK_BOX(vb), MRAMBCheck, FALSE, FALSE, 2);
  model->ambcheck = MRAMBCheck;
  HOOKUP_OBJECT (father, MRAMBCheck, "MRAMBCheck");
  gboolean sensitive = FALSE;
  for(int k=0; k<(int) G_N_ELEMENTS(combo_amb); k++)
      sensitive |= (find_program_in_path(combo_amb_prg[k]) != NULL);
  gtk_widget_set_sensitive(MRAMBCheck, sensitive);
  GtkTreeStore *store = gtk_tree_store_new(2, G_TYPE_STRING, G_TYPE_STRING);
  GtkWidget *MRAMBCombo = gtk_combo_box_new_with_model(GTK_TREE_MODEL(store));
  GtkCellRenderer *renderer = gtk_cell_renderer_text_new();
  gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(MRAMBCombo), renderer, TRUE);
  gtk_cell_layout_add_attribute(GTK_CELL_LAYOUT(MRAMBCombo), renderer, "text", 0);
  gtk_cell_layout_set_cell_data_func (GTK_CELL_LAYOUT(MRAMBCombo), renderer,
            fill_combo_amb, (gpointer)store, NULL);
  GtkTreeIter iter;
  for(int k=0; k<(int) G_N_ELEMENTS(combo_amb); k++)
  {
       gtk_tree_store_append(store, &iter, NULL);
       gtk_tree_store_set(store, &iter, 0, combo_amb[k],
                                        1, combo_amb_prg[k], -1);
  }

//  GtkWidget *MRAMBCombo = create_combo_str(false);
//  fill_combo(MRAMBCombo, combo_amb, G_N_ELEMENTS(combo_amb), 1);
  gtk_box_pack_start(GTK_BOX(vb), MRAMBCombo, FALSE, FALSE, 2);
  gtk_widget_show(MRAMBCombo);
  model->ambcombo = MRAMBCombo;
  HOOKUP_OBJECT (father, MRAMBCombo, "MRAMBCombo");
  gtk_widget_set_sensitive(MRAMBCombo, FALSE);
  g_signal_connect(G_OBJECT(MRAMBCheck), "toggled", G_CALLBACK(on_cb_attiva),
        MRAMBCombo);
#endif
}

void num_models_changed(GtkWidget *spin, GtkWidget *dlg)
{
  int nModels = spin_button_get_value_as_int(spin);
  show_models(dlg, nModels);
}

GtkWidget *frameMolrep(GtkWidget *parentBox, GtkWidget *father)
{
  GtkWidget *MRnModels;
  GtkWidget *MRPseudoCheck;

  GtkWidget *frameREMO = gtk_frame_new(NULL);
  gtk_frame_set_shadow_type(GTK_FRAME(frameREMO), GTK_SHADOW_NONE);
//  gtk_widget_show(frameREMO);
  gtk_container_add (GTK_CONTAINER (parentBox), frameREMO);
  g_object_set_data (G_OBJECT(father), "Frame_remo", frameREMO);

  GtkWidget *Vbox1 = vbox_new (FALSE, 8);
  gtk_widget_show (Vbox1);
  gtk_container_add (GTK_CONTAINER (frameREMO), Vbox1);
  gtk_container_set_border_width (GTK_CONTAINER (Vbox1), 4);

  GtkWidget *frame = NEW_FRAME ("Molecular replacement phasing", &FrameStyle);
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (Vbox1), frame, FALSE, FALSE, 0);

  GtkWidget *vbox1 = vbox_new (FALSE, 8);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (get_widget(frame, "align")), vbox1);
  gtk_container_set_border_width (GTK_CONTAINER (vbox1), 8);

  GtkWidget *hbox1 = hbox_new (FALSE, 8);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, FALSE, FALSE, 0);

  MRnModels = SPIN_WITH_LABEL("Number of models: ", MyBLUE, 1, 20, 1, 1, 0);
  gtk_widget_set_name (get_widget(MRnModels, "spin"), "MRnModels");
  gtk_box_pack_start (GTK_BOX (hbox1), MRnModels, FALSE, FALSE, 0);
  gtk_widget_show_all (MRnModels);
  HOOKUP_OBJECT (father, get_widget(MRnModels, "spin"), "MRnModels");
  g_signal_connect(G_OBJECT(get_widget(MRnModels, "spin")), "value-changed",
     G_CALLBACK(num_models_changed), father);

  GtkWidget *vb = vbox_new (FALSE, 8);
  gtk_widget_show (vb);
  gtk_box_pack_start (GTK_BOX (hbox1), vb, TRUE, TRUE, 40);

  MRPseudoCheck = CHECK_BUTTON_WITH_LABEL ("Use pseudotranslation information (if present)",  MyBLUE);
  gtk_widget_show (MRPseudoCheck);
  //gtk_box_pack_start (GTK_BOX (vb), MRPseudoCheck, FALSE, FALSE, 0);
  gtk_widget_set_name (MRPseudoCheck, "MRPseudoCheck");
  HOOKUP_OBJECT (father, MRPseudoCheck, "MRPseudoCheck");

  GtkWidget *MRVLDCheck = CHECK_BUTTON_WITH_LABEL ("Improve MR results",  MyBLUE);
  gtk_widget_show(MRVLDCheck);
  gtk_box_pack_start(GTK_BOX(vb), MRVLDCheck, FALSE, FALSE, 2);
  HOOKUP_OBJECT (father, MRVLDCheck, "MRVLDCheck");


  GtkWidget *scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow1);
  gtk_box_pack_start (GTK_BOX (vbox1), scrolledwindow1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (scrolledwindow1), 4);
  gtk_widget_set_size_request(scrolledwindow1, 20, 280);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), 
        GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  GtkWidget *viewport = gtk_viewport_new(NULL, NULL);
  widget_modify_bg(viewport, GTK_STATE_NORMAL, &colorWhite);
  gtk_widget_show (viewport);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), viewport);
//  gtk_viewport_set_shadow_type(GTK_VIEWPORT(viewport), GTK_SHADOW_NONE);

  GtkWidget *Vbox2 = vbox_new (FALSE, 8);
  gtk_widget_show (Vbox2);
  gtk_container_add (GTK_CONTAINER (viewport), Vbox2);

  for(int i=0; i<MAX_MODELS; i++)
  {
      MRmodel *model = model_info(father, i);
      gtk_box_pack_start (GTK_BOX (Vbox2), model->frame, FALSE, FALSE, 0);
  }

  create_task_info(father, vbox1);

  return frameREMO;
}

static void on_browse(GtkWidget *button, gpointer data)
{
using namespace gtkext;
using namespace Sir;

  GtkWidget *dlg = gtk_widget_get_toplevel(button);
  gtk_widget_set_sensitive(dlg, FALSE);
  std::string fn;
  fn = dlg_select_file(dlg, fn, eSELECT_TO_READ, "*.pdb,*.ent");
  gtk_widget_set_sensitive(dlg, TRUE);
  if(!str_white(fn.c_str()))
  {
     GtkWidget *entry = get_widget(button, "entry");
     gtk_entry_set_text(GTK_ENTRY(entry), fn.c_str());
     CopiaStringa(project->szMadFile, MaxLenFilename, fn.c_str());
  }
}

GtkWidget *frameSadMad(GtkWidget *parentBox, GtkWidget *father)
{

  GtkWidget *frameMAD = gtk_frame_new(NULL);
  gtk_frame_set_shadow_type(GTK_FRAME(frameMAD), GTK_SHADOW_NONE);
  gtk_container_add (GTK_CONTAINER (parentBox), frameMAD);
  g_object_set_data (G_OBJECT(father), "Frame_mad", frameMAD);

  GtkWidget *Vbox1 = vbox_new (FALSE, 8);
  gtk_widget_show (Vbox1);
  gtk_container_add (GTK_CONTAINER (frameMAD), Vbox1);
  gtk_container_set_border_width (GTK_CONTAINER (Vbox1), 4);

  GtkWidget *frame = NEW_FRAME ("SAD/MAD phasing", &FrameStyle);
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (Vbox1), frame, FALSE, FALSE, 0);

  GtkWidget *vbox1 = vbox_new (FALSE, 8);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (get_widget(frame, "align")), vbox1);
  gtk_container_set_border_width (GTK_CONTAINER (vbox1), 8);

  GtkWidget *hbox1 = hbox_new (FALSE, 8);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, FALSE, FALSE, 0);

  GtkWidget *label = LABEL_NEW("Select waves:", NULL);
  gtk_widget_show (label);
  set_alignment(label, 0., 0.5);
  gtk_label_set_justify (GTK_LABEL (label), GTK_JUSTIFY_FILL);
  gtk_box_pack_start (GTK_BOX (hbox1), label, FALSE, FALSE, 0);

  for(int i=1; i<=SIR_MAX_WAVES; i++)
  {
      std::stringstream nome;
      nome << "Wave " << i;
      GtkWidget *button = CHECK_BUTTON_WITH_LABEL(nome.str().c_str(), NULL);
      g_object_set_data (G_OBJECT (father), nome.str().c_str(), button);
      gtk_widget_show (button);
      gtk_box_pack_start (GTK_BOX (hbox1), button, FALSE, FALSE, 6);
  }
  GtkWidget *hbox2 = hbox_new (FALSE, 8);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox2, FALSE, FALSE, 4);

  GtkWidget *spin = SPIN_WITH_LABEL("N. trials  to generate : ", NULL, 1, 1000, 60, 1, 0);
  g_object_set_data(G_OBJECT(father), "ntrials_spin", get_widget(spin, "spin"));
  gtk_widget_show_all (spin);
  gtk_box_pack_start (GTK_BOX (hbox2), spin, FALSE, FALSE, 0);

  GtkWidget *button = CHECK_BUTTON_WITH_LABEL("Use default values", NULL);
  g_object_set_data (G_OBJECT (father), "ntrials_default", button);
  gtk_widget_show(button);
  gtk_box_pack_start (GTK_BOX (hbox2), button, FALSE, FALSE, 6);
  g_signal_connect(G_OBJECT(button), "toggled", G_CALLBACK(on_cb_disattiva), spin);

  GSList    *group = NULL;

  button = RADIO_BUTTON_WITH_LABEL
           (group, "Anomalous scatterers positions file: (PDB)", NULL);
  gtk_widget_show(button);
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (button));
  gtk_box_pack_start (GTK_BOX (vbox1), button, FALSE, FALSE, 6);
  g_object_set_data (G_OBJECT (father), "use_madfile", button);
  GtkWidget *box = 
  //entry_for_fileselection( "Anomalous scatterers positions file: (PDB)", NULL,
  entry_for_fileselection( "", NULL,
             G_CALLBACK(on_browse), GINT_TO_POINTER(0), -1, 1, MyRED);
  gtk_box_pack_start (GTK_BOX (vbox1), box, FALSE, FALSE, 0);
  GtkWidget *browse = get_widget (box, "browse");
  GtkWidget *entry = get_widget (box, "entry");
  set_width_chars (GTK_ENTRY (entry), 60);
  set_tip (entry, "The file with the coordinates of anomalous scatterers.");
  g_object_set_data (G_OBJECT (father), "MadFileEntry", entry);
  g_object_set_data (G_OBJECT (father), "MadFileBox", box);
  g_signal_connect ((gpointer) browse, "clicked",
                    G_CALLBACK (on_browse), NULL);
  g_signal_connect(G_OBJECT(button), "toggled", G_CALLBACK(on_cb_attiva), box);

  hbox2 = hbox_new (FALSE, 8);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox2, FALSE, FALSE, 4);

  GtkWidget *button2 = RADIO_BUTTON_WITH_LABEL(group, "Best trials ", NULL);
  gtk_widget_show(button2);
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (button2));
  gtk_box_pack_start (GTK_BOX (hbox2), button2, FALSE, FALSE, 0);
  g_object_set_data (G_OBJECT (father), "use_ntrials", button2);

  button = CHECK_BUTTON_WITH_LABEL("All", NULL);
  gtk_widget_show(button);
  gtk_box_pack_start (GTK_BOX (hbox2), button, FALSE, FALSE, 2);
  g_object_set_data(G_OBJECT(father), "use_all", button);

  GtkWidget *hbox22 = hbox_new (FALSE, 0);
  gtk_widget_show (hbox22);
  gtk_box_pack_start (GTK_BOX (hbox2), hbox22, FALSE, FALSE, 0);

  spin = SPIN_WITH_LABEL("from : ", NULL, 1, 10, 1, 1, 0);
  g_object_set_data(G_OBJECT(father), "bt_n1", get_widget(spin, "spin"));
  gtk_widget_show_all (spin);
  gtk_box_pack_start (GTK_BOX (hbox22), spin, FALSE, FALSE, 4);

  spin = SPIN_WITH_LABEL("to : ", NULL, 1, 10, 1, 1, 0);
  g_object_set_data(G_OBJECT(father), "bt_n2", get_widget(spin, "spin"));
  gtk_widget_show_all (spin);
  gtk_box_pack_start (GTK_BOX (hbox22), spin, FALSE, FALSE, 4);

  gtk_widget_set_sensitive(hbox22, FALSE);
  gtk_widget_set_sensitive(button, FALSE);
  g_signal_connect(G_OBJECT(button), "toggled", G_CALLBACK(on_cb_disattiva), hbox22);
  g_signal_connect(G_OBJECT(button2), "toggled", G_CALLBACK(on_cb_attiva), hbox22);
  g_signal_connect(G_OBJECT(button2), "toggled", G_CALLBACK(on_cb_attiva), button);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button2), TRUE);

  frame = NEW_FRAME("LSQ: parameters to refine", &FrameStyle1);
  gtk_widget_show(frame);
  gtk_container_set_border_width(GTK_CONTAINER(frame), 6);
  gtk_box_pack_start (GTK_BOX (vbox1), frame, FALSE, FALSE, 4);
  GtkWidget *table = table_new(2, 4, FALSE);
  table_set_col_spacings(table, 4);
  table_set_row_spacings(table, 4);
  gtk_widget_show(table);
  gtk_container_set_border_width (GTK_CONTAINER (table), 10);
  add_to_frame (frame, table);
#ifdef IN_GTK3
  gtk_widget_set_hexpand(table, FALSE);
  gtk_widget_set_halign(table, GTK_ALIGN_START);
#endif
  label = LABEL_NEW("Atomic parameters:", NULL);
  gtk_widget_show (label);
  set_alignment(label, 0., 0.5);
  //gtk_label_set_justify (GTK_LABEL (label), GTK_JUSTIFY_FILL);
  table_attach( table, label, 0, 1, 0, 1);//, TRUE);
  label = LABEL_NEW("Wave parameters:", NULL);
  gtk_widget_show (label);
  set_alignment(label, 0., 0.5);
  gtk_label_set_justify (GTK_LABEL (label), GTK_JUSTIFY_FILL);
  table_attach( table, label, 0, 1, 1, 2, TRUE);

  button = CHECK_BUTTON_WITH_LABEL ("position", MyBLUE);
  gtk_widget_show (button);
  table_attach( table, button, 1, 2, 0, 1);
  set_tip(button, "x,y,z coordinates");
  g_object_set_data(G_OBJECT(father), "lsq_a1", button);
  button = CHECK_BUTTON_WITH_LABEL ("B-factor", MyBLUE);
  gtk_widget_show (button);
  table_attach( table, button, 2, 3, 0, 1);
  set_tip(button, "Atomic displacement parameter");
  g_object_set_data(G_OBJECT(father), "lsq_a0", button);
  button = CHECK_BUTTON_WITH_LABEL ("sof", MyBLUE);
  gtk_widget_show (button);
  table_attach( table, button, 3, 4, 0, 1);
  set_tip(button, "Site occupation factor");
  g_object_set_data(G_OBJECT(father), "lsq_a2", button);
  std::string delta(special_car_greek('D'));
  delta.append("f'");
  button = CHECK_BUTTON_WITH_LABEL (delta.c_str(), MyBLUE);
  gtk_widget_show (button);
  table_attach( table, button, 1, 2, 1, 2);
  g_object_set_data(G_OBJECT(father), "lsq_w1", button);
  button = CHECK_BUTTON_WITH_LABEL ("f''", MyBLUE);
  gtk_widget_show (button);
  table_attach( table, button, 2, 3, 1, 2);
  g_object_set_data(G_OBJECT(father), "lsq_w0", button);

  return frameMAD;
}

void solve(GtkWidget *vbox, GtkWidget *dialog)
{
  GtkWidget *hbox;
  GtkWidget *vbox1;
  GtkWidget *vbox2;
  GtkWidget *label;
  GtkWidget *frame;
  GtkWidget *check;
  GtkWidget *combo;
  GSList    *group = NULL;

  frame = NEW_FRAME ("Solving strategy", &FrameStyle);
//  gtk_widget_show (frame);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 4);
  gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 0);
  g_object_set_data (G_OBJECT(dialog), "Frame_solve", frame);

  vbox2 = vbox_new(FALSE, 0);
  gtk_widget_show(vbox2);
  gtk_container_add (GTK_CONTAINER (get_widget(frame, "align")), vbox2);

  hbox = hbox_new(FALSE, 0);
  gtk_widget_show(hbox);
  gtk_box_pack_start (GTK_BOX (vbox2), hbox, FALSE, FALSE, 0);

  vbox1 = vbox_new(FALSE, 0);
  gtk_widget_show(vbox1);
  gtk_box_pack_start(GTK_BOX(hbox), vbox1, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (vbox1), 4);

  check = RADIO_BUTTON_WITH_LABEL(group, "void", MyBLUE);
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (check));
  g_object_set_data (G_OBJECT(dialog), "void", check);

  check = RADIO_BUTTON_WITH_LABEL(group, "Let the program to decide", MyBLUE);
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (check));
  g_object_set_data (G_OBJECT(dialog), "AutoCheck", check);
  gtk_widget_show (check);
  gtk_box_pack_start (GTK_BOX (vbox1), check, FALSE, FALSE, 0);
  g_signal_connect(G_OBJECT(check), "toggled", G_CALLBACK(select_strategy),
          GINT_TO_POINTER(S_AUTO));

  check = RADIO_BUTTON_WITH_LABEL(group, "Modern Direct Methods (MDM)", MyBLUE);
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (check));
  g_object_set_data (G_OBJECT(dialog), "MDMCheck", check);
  gtk_widget_show (check);
  gtk_box_pack_start (GTK_BOX (vbox1), check, FALSE, FALSE, 2);
  g_signal_connect(G_OBJECT(check), "toggled", G_CALLBACK(select_strategy),
          GINT_TO_POINTER(S_MDM));

  check = RADIO_BUTTON_WITH_LABEL (group, "Standard Direct Methods (SDM)", MyBLUE);
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (check));
  g_object_set_data (G_OBJECT(dialog), "TangentCheck", check);
  gtk_widget_show (check);
  gtk_box_pack_start (GTK_BOX (vbox1), check, FALSE, FALSE, 2);
  g_signal_connect(G_OBJECT(check), "toggled", G_CALLBACK(select_strategy),
          GINT_TO_POINTER(S_DM));

  check = RADIO_BUTTON_WITH_LABEL (group, "Patterson", MyBLUE);
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (check));
  g_object_set_data (G_OBJECT(dialog), "PattersonCheck", check);
  gtk_widget_show (check);
  gtk_box_pack_start (GTK_BOX (vbox1), check, FALSE, FALSE, 2);
  g_signal_connect(G_OBJECT(check), "toggled", G_CALLBACK(select_strategy),
          GINT_TO_POINTER(S_PATT));

  check = RADIO_BUTTON_WITH_LABEL (group, "VLD", MyBLUE);
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (check));
  g_object_set_data (G_OBJECT(dialog), "VLDCheck", check);
  gtk_widget_show (check);
  gtk_box_pack_start (GTK_BOX (vbox1), check, FALSE, FALSE, 2);
  g_signal_connect(G_OBJECT(check), "toggled", G_CALLBACK(select_strategy),
          GINT_TO_POINTER(S_VLD));

  check = RADIO_BUTTON_WITH_LABEL (group, "Simulated Annealing", MyBLUE);
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (check));
  g_object_set_data (G_OBJECT(dialog), "SACheck", check);
  gtk_widget_show (check);
  gtk_box_pack_start (GTK_BOX (vbox1), check, FALSE, FALSE, 2);
  g_signal_connect(G_OBJECT(check), "toggled", G_CALLBACK(select_strategy),
          GINT_TO_POINTER(S_SA));

  label = FRAME_NEW("Size:", LABELCOLOR);
  gtk_widget_show (label);
  gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, TRUE, 0);
  g_object_set_data (G_OBJECT(dialog), "frame_size", label);

  vbox1 = vbox_new(FALSE, 0);
  gtk_widget_show(vbox1);
  gtk_container_add(GTK_CONTAINER(label), vbox1);
  gtk_container_set_border_width (GTK_CONTAINER (vbox1), 4);

  combo = create_combo(NULL, sizes, nsizes, 3, &dime, NULL, false);
  gtk_widget_show (combo);
  g_object_set_data (G_OBJECT (dialog), "combosize", combo);
  gtk_box_pack_start(GTK_BOX(vbox1), get_widget(combo, "parent"), FALSE, FALSE, 2);
//  gtk_widget_set_size_request(combo, 140, 24);
//  gtk_editable_set_editable(GTK_EDITABLE(get_widget(combo, "entry")), FALSE);

  label = label_boxed (" ");
  gtk_box_pack_start(GTK_BOX(vbox1), label, FALSE, FALSE, 2);
  g_object_set_data (G_OBJECT (dialog), "labelsize", 
                  gtk_bin_get_child(GTK_BIN(label)));
  gtk_widget_show (label);
  label = get_widget(dialog, "labelsize");
  set_alignment(label, 0., 0.5);
  gtk_label_set_line_wrap(GTK_LABEL(label), TRUE);
#ifndef GTK_COMBO_BOX
  g_signal_connect(G_OBJECT(GTK_COMBO(combo)->entry), "changed", 
          G_CALLBACK(update_labelsize), label);
#else
  g_signal_connect(G_OBJECT(combo), "changed", 
          G_CALLBACK(update_labelsize), label);
#endif  

// gianluca

  relax_and_blocks(dialog, hbox, vbox2);
}
  
static void on_browse_refine(GtkWidget *button, gpointer data)
{
using namespace gtkext;
using namespace Sir;

  GtkWidget *dlg = gtk_widget_get_toplevel(button);
  gtk_widget_set_sensitive(dlg, FALSE);
  std::string fn;
  fn = dlg_select_file(dlg, fn, eSELECT_TO_READ, "*.pdb,*.ent");
  gtk_widget_set_sensitive(dlg, TRUE);
  if(!str_white(fn.c_str()))
  {
     GtkWidget *entry = get_widget(button, "entry");
     gtk_entry_set_text(GTK_ENTRY(entry), fn.c_str());
     CopiaStringa(project->szPhRFile, MaxLenFilename, fn.c_str());
  }
}

GtkWidget *frameRefine(GtkWidget *parentBox, GtkWidget *father)
{

  GtkWidget *frameRefine = gtk_frame_new(NULL);
  gtk_frame_set_shadow_type(GTK_FRAME(frameRefine), GTK_SHADOW_NONE);
  gtk_container_add (GTK_CONTAINER (parentBox), frameRefine);
  g_object_set_data (G_OBJECT(father), "Frame_refine", frameRefine);

  GtkWidget *Vbox1 = vbox_new (FALSE, 8);
  gtk_widget_show (Vbox1);
  gtk_container_add (GTK_CONTAINER (frameRefine), Vbox1);
  gtk_container_set_border_width (GTK_CONTAINER (Vbox1), 4);

  GtkWidget *frame = NEW_FRAME ("Phase Refinement", &FrameStyle);
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (Vbox1), frame, FALSE, FALSE, 0);


  GtkWidget *vbox1 = vbox_new (FALSE, 8);
  gtk_widget_show (vbox1);
  add_to_frame(frame, vbox1);
  gtk_container_set_border_width (GTK_CONTAINER (vbox1), 8);

  frame = NEW_FRAME ("Phases from:", &FrameStyle1);
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (vbox1), frame, FALSE, FALSE, 0);

  GtkWidget *vbox = vbox_new (FALSE, 8);
  gtk_widget_show (vbox);
  add_to_frame(frame, vbox);
  gtk_container_set_border_width (GTK_CONTAINER (vbox), 4);

  GSList *group=NULL;
  for(int i=0; i<4; i++)
  {
      GtkWidget *radio = RADIO_BUTTON_WITH_LABEL (group, lb_phFrom[i], NULL);
      group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
      gtk_widget_show (radio);
      g_object_set_data(G_OBJECT (father), str_lb[i], radio);
      gtk_box_pack_start (GTK_BOX (vbox), radio, FALSE, FALSE, 0);
      if(i == 3)
         gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radio), TRUE);
  }

  GtkWidget *box =
  entry_for_fileselection( "Model PDB File (when available)", NULL,
             G_CALLBACK(on_browse_refine), GINT_TO_POINTER(0), -1, 1, MyRED);
  gtk_box_pack_start(GTK_BOX(vbox1), box, FALSE, FALSE, 4);
  GtkWidget *entry = get_widget (box, "entry");
  set_width_chars (GTK_ENTRY (entry), 60);
  set_tip (entry, "The Model PDB file (when available)");
  g_object_set_data (G_OBJECT (father), "PhRFileEntry", entry);
  g_object_set_data (G_OBJECT (father), "PhRFileBox", box);

  return frameRefine;
}

void page5(GtkWidget *notebook, GtkWidget *new_project_dlg)
{
  GtkWidget *vbox;

  vbox = vbox_new (FALSE, vspace);
  gtk_widget_show (vbox);
  gtk_container_add (GTK_CONTAINER (notebook), vbox);

  solve(vbox, new_project_dlg);
  frameMolrep(vbox, new_project_dlg);
  frameSadMad(vbox, new_project_dlg);
  frameRefine(vbox, new_project_dlg);

  bottoni_e_titolo(vbox, page_SOLVE,"Solve");
}

void page6old(GtkWidget *notebook, GtkWidget *new_project_dlg)
{
  GtkWidget *vbox;
  GtkWidget *frame;
  GtkWidget *table;
  GtkWidget *hbox;
  GtkWidget *pixmap;
  GtkWidget *label;
  GtkWidget *button;
  GtkWidget *align;
  GtkWidget *pix1, *pix2;

  vbox = vbox_new (FALSE, 4);
  gtk_widget_show (vbox);
  gtk_container_add (GTK_CONTAINER (notebook), vbox);

  frame = NEW_FRAME ("Run", &FrameStyle);
  gtk_widget_show (frame);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 10);
  gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 0);

  //GtkWidget *vbox1 = vbox_new (FALSE, 4);
  //gtk_widget_show (vbox1);
  //gtk_container_set_border_width (GTK_CONTAINER (vbox1), 10);
  //gtk_container_add (GTK_CONTAINER (get_widget(frame, "align")), vbox1);

  button = CHECK_BUTTON_WITH_LABEL("Graphic window required", LABELCOLOR);
  g_object_set_data (G_OBJECT (new_project_dlg), "bWindow", button);
  gtk_widget_show (button);
  //gtk_box_pack_start (GTK_BOX (vbox1), button, FALSE, FALSE, 4);

  hbox = hbox_new (FALSE, 4);
  gtk_widget_show (hbox);
  gtk_container_set_border_width (GTK_CONTAINER (hbox), 10);
  //gtk_box_pack_start (GTK_BOX (vbox1), hbox, FALSE, FALSE, 4);
  add_to_frame(frame, hbox);

  pixmap = create_image("faccia1.png");
  gtk_widget_show (pixmap);
  gtk_box_pack_start (GTK_BOX (hbox), pixmap, FALSE, TRUE, 0);
  
  frame = gtk_frame_new (NULL);
  gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_NONE);
  gtk_widget_show (frame);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 10);
  gtk_box_pack_start (GTK_BOX (hbox), frame, TRUE, TRUE, 0);

#ifdef IN_GTK3
  align = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_CENTER, FALSE, FALSE);
#else
  align = gtk_alignment_new(0.5f, 0.5f, 0.,0.);
#endif
  gtk_widget_show(align);
  gtk_container_add (GTK_CONTAINER (frame), align);

  table = table_new(8, 3, FALSE);
  table_set_col_spacings(table, 4);
  table_set_row_spacings(table, 6);
//  table_set_row_spacing(table, 5, 40);
  gtk_widget_show(table);
  gtk_container_set_border_width (GTK_CONTAINER (table), 10);
  gtk_container_add (GTK_CONTAINER (align), table);

  int row = 0;
  table_attach_exp(table, button, 0, 2, row, row+1);
  row++;
  label = LABEL_BOLD("Input filename", MyRED, 1.1f);
  gtk_widget_show(label);
  table_attach_exp(table, label, 0, 2, row, row+1);
  set_alignment(label, 0., 0.5);
  set_mandatory(label);

  label = LABEL_BOLD("Already exists", LABELCOLOR, 1.1f);
  gtk_widget_show(label);
  table_attach_exp(table, label, 2, 3, row, row+1);
  set_alignment(label, 0.5, 0.5);

  label = LABEL_BOLD("Output filename", MyRED, 1.1f);
  gtk_widget_show(label);
  table_attach_exp(table, label, 0, 2, row+2, row+3);
  set_alignment(label, 0., 0.5);
  set_mandatory(label);

  label = gtk_entry_new();
  gtk_widget_show(label);
  table_attach_exp(table, label, 0, 2, row+1, row+2);
  g_object_set_data(G_OBJECT(new_project_dlg), "inpfile", label);

  pix1 = create_image("no_lab.png");
  pix2 = create_image("yes_lab.png");

  button = hbox_new(TRUE, 0);
  gtk_widget_show(button);
  table_attach_exp(table, button, 2, 3, row+1, row+2);
  g_object_set_data(G_OBJECT(new_project_dlg), "inpfileex", button);
  gtk_widget_show(pix1);
  gtk_container_add(GTK_CONTAINER(button), pix1);
  g_object_set_data(G_OBJECT(button), "pix1", pix1);
  gtk_container_add(GTK_CONTAINER(button), pix2);
  g_object_set_data(G_OBJECT(button), "pix2", pix2);
  g_signal_connect (G_OBJECT(label), "changed",
                   G_CALLBACK (on_filename_changed), button);

  label = gtk_entry_new();
  gtk_widget_show(label);
  table_attach_exp(table, label, 0, 2, row+3, row+4);
  g_object_set_data(G_OBJECT(new_project_dlg), "outfile", label);

  pix1 = create_image("no_lab.png");
  pix2 = create_image("yes_lab.png");
  button = hbox_new(TRUE, 0);
  gtk_widget_show(button);
  table_attach(table, button, 2, 3, row+3, row+4);
  g_object_set_data(G_OBJECT(new_project_dlg), "outfileex", button);
  gtk_widget_show(pix1);
  gtk_container_add(GTK_CONTAINER(button), pix1);
  g_object_set_data(G_OBJECT(button), "pix1", pix1);
  gtk_container_add(GTK_CONTAINER(button), pix2);
  g_object_set_data(G_OBJECT(button), "pix2", pix2);
  g_signal_connect (G_OBJECT(label), "changed",
                   G_CALLBACK (on_filename_changed), button);

#ifdef IN_GTK3
  align = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_CENTER, FALSE, FALSE);
#else
  align = gtk_alignment_new(0.5f, 0.5f, 0.,0.);
#endif
  gtk_widget_show(align);
  table_attach (table, align, 0, 3, row+4, row+5, TRUE);

  hbox = hbox_new(FALSE,0);
  gtk_widget_show(hbox);
  gtk_container_add (GTK_CONTAINER (align), hbox);

  label = LABEL_BOLD("Click on ", MSGCOLOR, 1.2f);
  set_alignment(label, 1.0, 0.5);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, TRUE, 0);
  
  button = myimage_button("", "save.png");
  set_tip (button, "Saves supplied data, creates input file for the program and starts the run");
  g_object_set_data(G_OBJECT(new_project_dlg), "accept7", button);
  (void) g_signal_connect (G_OBJECT(button), "clicked", 
             G_CALLBACK(on_accept_clicked), GINT_TO_POINTER(page_RUN));
  gtk_widget_set_name(button, "accept");
  label = LABEL_BOLD(" to save the project", MSGCOLOR, 1.2f);
  gtk_box_pack_start (GTK_BOX (hbox), button, TRUE, TRUE, 0);

  set_alignment(label, 0.0, 0.5);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, TRUE, 0);
  bottoni_e_titolo(vbox, page_RUN,"Run");
}

void on_cb_setsens(GtkToggleButton *toggle, GtkWidget *w)
{
   gtk_widget_set_sensitive(w, gtk_toggle_button_get_active(toggle));
}

void page6(GtkWidget *notebook, GtkWidget *new_project_dlg)
{
  GtkWidget *vbox;
  GtkWidget *frame;
  GtkWidget *table;
  GtkWidget *hbox;
  GtkWidget *pix_small;
  GtkWidget *pix_macro;
  GtkWidget *label;
  GtkWidget *button;
  GtkWidget *align;
  GtkWidget *pix1, *pix2;

  vbox = vbox_new (FALSE, 4);
  gtk_widget_show (vbox);
  gtk_container_add (GTK_CONTAINER (notebook), vbox);

  frame = NEW_FRAME ("Run", &FrameStyle);
  gtk_widget_show (frame);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 10);
  gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 0);

  GtkWidget *vbox1 = vbox_new (FALSE, 4);
  gtk_widget_show (vbox1);
  gtk_container_set_border_width (GTK_CONTAINER (vbox1), 10);
  add_to_frame(frame, vbox1);

  button = CHECK_BUTTON_WITH_LABEL("Graphic window required", LABELCOLOR);
  g_object_set_data (G_OBJECT (new_project_dlg), "bWindow", button);
  gtk_widget_show (button);
  gtk_box_pack_start (GTK_BOX (vbox1), button, FALSE, FALSE, 4);

  hbox = hbox_new (FALSE, 4);
  gtk_widget_show (hbox);
  gtk_container_set_border_width (GTK_CONTAINER (hbox), 10);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox, FALSE, FALSE, 8);

  pix_small = create_image("carbamide.png");
  gtk_widget_show (pix_small);
  gtk_widget_set_sensitive(pix_small, FALSE);
  g_signal_connect(G_OBJECT(button), "toggled", G_CALLBACK(on_cb_setsens),
       pix_small);
  g_object_set_data(G_OBJECT(new_project_dlg), "pix_small", pix_small);
  gtk_box_pack_start (GTK_BOX (vbox1), pix_small, FALSE, FALSE, 4);
  
  pix_macro = create_image("1kqw.png");
  gtk_widget_set_sensitive(pix_macro, FALSE);
  g_signal_connect(G_OBJECT(button), "toggled", G_CALLBACK(on_cb_setsens),
       pix_macro);
  g_object_set_data(G_OBJECT(new_project_dlg), "pix_macro", pix_macro);
  gtk_box_pack_start (GTK_BOX (vbox1), pix_macro, FALSE, FALSE, 4);
  
  button = get_widget(new_project_dlg, molsizes[MACRO]);
  g_signal_connect(G_OBJECT(button), "toggled", G_CALLBACK(change_molimage),
       new_project_dlg);

  table = table_new(7, 3, FALSE);
  table_set_col_spacings(table, 4);
  table_set_row_spacings(table, 6);
  gtk_widget_show(table);
  gtk_container_set_border_width (GTK_CONTAINER (table), 10);
  gtk_box_pack_start (GTK_BOX (vbox1), table, FALSE, FALSE, 10);

  int row = 0;
  label = LABEL_BOLD("Input filename", MyRED, 1.1f);
  gtk_widget_show(label);
  table_attach_exp(table, label, 0, 2, row, row+1);
  set_alignment(label, 0., 0.5);
  set_mandatory(label);

  label = LABEL_BOLD("Already exists", LABELCOLOR, 1.1f);
  gtk_widget_show(label);
  table_attach_exp(table, label, 2, 3, row, row+1);
  set_alignment(label, 0.5, 0.5);

  label = LABEL_BOLD("Output filename", MyRED, 1.1f);
  gtk_widget_show(label);
  table_attach_exp(table, label, 0, 2, row+2, row+3);
  set_alignment(label, 0., 0.5);
  set_mandatory(label);

  label = gtk_entry_new();
  gtk_widget_show(label);
  table_attach_exp(table, label, 0, 2, row+1, row+2);
  g_object_set_data(G_OBJECT(new_project_dlg), "inpfile", label);

  pix1 = create_image("no_lab.png");
  pix2 = create_image("yes_lab.png");

  button = hbox_new(TRUE, 0);
  gtk_widget_show(button);
  table_attach_exp(table, button, 2, 3, row+1, row+2);
  g_object_set_data(G_OBJECT(new_project_dlg), "inpfileex", button);
  gtk_widget_show(pix1);
  gtk_container_add(GTK_CONTAINER(button), pix1);
  g_object_set_data(G_OBJECT(button), "pix1", pix1);
  gtk_container_add(GTK_CONTAINER(button), pix2);
  g_object_set_data(G_OBJECT(button), "pix2", pix2);
  g_signal_connect (G_OBJECT(label), "changed",
                   G_CALLBACK (on_filename_changed), button);

  label = gtk_entry_new();
  gtk_widget_show(label);
  table_attach_exp(table, label, 0, 2, row+3, row+4);
  g_object_set_data(G_OBJECT(new_project_dlg), "outfile", label);

  pix1 = create_image("no_lab.png");
  pix2 = create_image("yes_lab.png");
  button = hbox_new(TRUE, 0);
  gtk_widget_show(button);
  table_attach(table, button, 2, 3, row+3, row+4);
  g_object_set_data(G_OBJECT(new_project_dlg), "outfileex", button);
  gtk_widget_show(pix1);
  gtk_container_add(GTK_CONTAINER(button), pix1);
  g_object_set_data(G_OBJECT(button), "pix1", pix1);
  gtk_container_add(GTK_CONTAINER(button), pix2);
  g_object_set_data(G_OBJECT(button), "pix2", pix2);
  g_signal_connect (G_OBJECT(label), "changed",
                   G_CALLBACK (on_filename_changed), button);

#ifdef IN_GTK3
  align = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_CENTER, FALSE, FALSE);
#else
  align = gtk_alignment_new(0.5f, 0.5f, 0.,0.);
#endif
  gtk_widget_show(align);
  table_attach (table, align, 0, 3, row+4, row+5, TRUE);

  hbox = hbox_new(FALSE,0);
  gtk_widget_show(hbox);
  gtk_container_add (GTK_CONTAINER (align), hbox);

  label = LABEL_BOLD("Click on ", MSGCOLOR, 1.2f);
  set_alignment(label, 1.0, 0.5);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, TRUE, 0);
  
  button = myimage_button("", "save.png");
  set_tip (button, "Saves supplied data, creates input file for the program and starts the run");
  g_object_set_data(G_OBJECT(new_project_dlg), "accept7", button);
  (void) g_signal_connect (G_OBJECT(button), "clicked", 
             G_CALLBACK(on_accept_clicked), GINT_TO_POINTER(page_RUN));
  gtk_widget_set_name(button, "accept");
  label = LABEL_BOLD(" to save the project", MSGCOLOR, 1.2f);
  gtk_box_pack_start (GTK_BOX (hbox), button, TRUE, TRUE, 0);

  set_alignment(label, 0.0, 0.5);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, TRUE, 0);
  bottoni_e_titolo(vbox, page_RUN,"Run");
}
GtkWidget* create_new_project (void)
{
  GtkWidget *new_project_dlg;
  GtkWidget *vbox;
  GtkWidget *text;
  GtkWidget *frame;
  GtkWidget *cancel_button;
  int larg, alt;

  new_project_dlg = gtk_dialog_new ();
  g_object_set_data (G_OBJECT (new_project_dlg), 
                       "new_project_dlg", new_project_dlg);
  gtk_window_set_title (GTK_WINDOW (new_project_dlg), "New Project");
  gtk_window_set_transient_for(GTK_WINDOW(new_project_dlg), GTK_WINDOW(finestre[0]));

  vbox = gtk_dialog_get_content_area(GTK_DIALOG(new_project_dlg));
  gtk_container_set_border_width (GTK_CONTAINER (vbox), 4);
  GdkRectangle rect;
#if (GTK_MAJOR_VERSION > 2) && (GTK_MINOR_VERSION >= 22)
         GdkMonitor *mon = gdk_display_get_primary_monitor(gdk_display_get_default());
         if(mon == NULL)
            mon = gdk_display_get_monitor_at_point(gdk_display_get_default(), 0, 0);
         if(mon != NULL)
            gdk_monitor_get_geometry(mon, &rect);
         else
         {
            rect.width = 800;
            rect.height = 600;
         }
#else
         GdkScreen *sc = gdk_screen_get_default();
         gdk_screen_get_monitor_geometry(sc, 0, &rect);
#endif

  int ww = rect.width;
  int hh = rect.height;

  larg = MRmin(110 * larSaveN, ww -50);
  alt  = 120;
//  if(gdk_screen_height() < 610)
//     alt = 150;

  if(hh < 1000)               // 200910
  {
     gtk_window_set_default_size (GTK_WINDOW (new_project_dlg), larg, hh-100);
     GtkWidget *scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
     gtk_widget_show (scrolledwindow1);
     gtk_box_pack_start (GTK_BOX (vbox), scrolledwindow1, TRUE, TRUE, 0);
     gtk_container_set_border_width (GTK_CONTAINER (scrolledwindow1), 4);
     gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
     GtkWidget *viewport = gtk_viewport_new(NULL, NULL);
     widget_modify_bg(viewport, GTK_STATE_NORMAL, &colorWhite);
     gtk_widget_show (viewport);
     gtk_container_add (GTK_CONTAINER (scrolledwindow1), viewport);
     vbox = vbox_new(FALSE, 0);
     gtk_widget_show(vbox);
     gtk_container_add (GTK_CONTAINER (viewport), vbox);
  }

  notebook = gtk_notebook_new ();
  g_object_set_data (G_OBJECT (new_project_dlg), "notebook", notebook);
  gtk_box_pack_start (GTK_BOX (vbox), notebook, TRUE, TRUE, 0);
  widget_modify_bg(notebook, GTK_STATE_NORMAL, &colorWhite);   //NEW
  gtk_widget_show (notebook);

  larg = 60 * larSaveN;

  frame = NEW_FRAME("Output", &FrameStyle);
  gtk_widget_show(frame);
  //gtk_box_pack_start(GTK_BOX(vbox), frame, 0, TRUE, FALSE);
  gtk_container_set_border_width(GTK_CONTAINER(frame), 4);
#if defined (IN_GTK3) && (GTK_MINOR_VERSION > 14)
  text = scrolled_labeltext(get_widget(frame, "align"));
#else
  text = scrolled_text(get_widget(frame, "align"));
#endif
  gtk_widget_show(text);
  set_bg_color(text, colorYellow);
  set_text_color(text, "blue");

  g_object_set_data(G_OBJECT(new_project_dlg), "testo", text);
  gtk_widget_set_size_request(get_widget(text, "scrollwin"), larg, alt);

  page1(notebook, new_project_dlg);
  page2(notebook, new_project_dlg);
  page2mtz(notebook, new_project_dlg);
  page3(notebook, new_project_dlg);
  page4(notebook, new_project_dlg);
  page5(notebook, new_project_dlg);
  page6(notebook, new_project_dlg);

  cancel_button = get_widget(new_project_dlg, "cancel_button");
  (void) g_signal_connect (G_OBJECT(notebook), "change-current-page",
              G_CALLBACK(swp), NULL);
  (void) g_signal_connect_swapped(G_OBJECT(new_project_dlg), "delete_event", 
              G_CALLBACK(gtk_button_clicked), G_OBJECT(cancel_button));
  (void) g_signal_connect (G_OBJECT (new_project_dlg), "delete_event",
                      G_CALLBACK(true_cb), NULL);

  return new_project_dlg;
}

void open_newproj_dlg(GtkWidget *item, const char *string)
{
using namespace Sir;
     GtkWidget *entry;
     int        i;

     if(prj->ifProject)
     {
        old = TRUE;
        if(avvisa_fortran(2) < 0)
           return;
        backwd = DuplicaStringa(getpwd());
        binfile =  DuplicaStringa(main_app::TheApp.filebin);
     }
                                                                          
     dir_set_current(SWareRC->WorkingDirectory);
     if(project != NULL)
        delete project;
     project = NULL;
     project = new SirProject(SWareRC->WorkingDirectory);
                                                                                
     ktest = 0;
     clear_txt_files();

     if(np_dialog == NULL)
        np_dialog = create_new_project();

     project->window = np_dialog;

     g_object_set_data (G_OBJECT (finestre[0]), 
                       "new_project_dlg", np_dialog);
/* inizializzazioni */

     curPag = 1;

     clear_windinfo();
     gtk_notebook_set_current_page (GTK_NOTEBOOK(notebook), 0);

     project->FillForm(np_dialog);
     for(i = 1; i<nCards; i++)
         HidePage(np_dialog, i+1);

     entry = get_widget(np_dialog, "CellPar");
     set_label_text(entry, " ", "red", 1.05f);
     for(i = 0; i<13; i++)
     {
         entry = get_widget(np_dialog, cell_data[i]);
         gtk_entry_set_text(GTK_ENTRY(entry), "  ");
         gtk_editable_set_editable(GTK_EDITABLE(entry), TRUE);
     }

     gtk_widget_show(np_dialog);
     finestra_modale_aperta2(np_dialog);
     entry = get_widget(np_dialog, "structnam");
     gtk_widget_grab_focus (entry);
     entry = get_widget(np_dialog, "Resetst");
     gtk_widget_hide(entry);
     //if(auto_newproj)
     //   gtk_main();
}

/********************************************************/
/*                         T U N E                      */
/********************************************************/

static GtkWidget *tune_dlg = NULL;

int c_init_tune(float valori[])
{
   int ier=0;

   ier = init_tune_(elist, valori, blocchi);
   return ier;
}

void check_solve(GtkWidget *dialog)
{
   float valori[10];
   int usedef, i;

   GtkWidget *entry = get_widget(dialog, "TangentCheck");
   if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry)))
      valori[0] = S_DM;
   entry = get_widget(dialog, "PattersonCheck");
   if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry)))
      valori[0] = S_PATT;
   entry = get_widget(dialog, "VLDCheck");
   if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry)))
      valori[0] = S_VLD;
   entry = get_widget(dialog, "MDMCheck");
   if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry)))
      valori[0] = S_MDM;
   entry = get_widget(dialog, "AutoCheck");
   if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry)))
      valori[0] = S_AUTO;
   entry = get_widget(dialog, "SACheck");
   if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry)))
      valori[0] = S_SA;

   usedef = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(get_widget(dialog, "defaults")));
   if(usedef)
      valori[1] = 0;
   else
      valori[1] = (float) leggi_blocchi(dialog);

   entry = get_widget(dialog, "Relax");
   if(!gtk_widget_get_sensitive(entry))
      i = -2;
   else
   {
      entry = get_widget(dialog, "Never");
      if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry)))
         i = -1;
      entry = get_widget(dialog, "Automatic");
      if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry)))
         i = 0;
      entry = get_widget(dialog, "Always");
      if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry)))
         i = 1;
   }
   valori[2] = (float) (i + 3);

   entry = get_widget(dialog, "Rsoglia");
   valori[3] = (float)spin_button_get_value(entry);

   if(dime < nsizes)
      valori[4] = (float) dime;
   else
      valori[4] = (float) real_dime;

   entry = get_widget(dialog, "Resetst");
   if(gtk_widget_get_visible(entry))
      valori[8] = (float) gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry));
   c_finish_tune(valori);
}

void end_tune(GtkButton *button, gpointer data)
{
   close_dlg(button, data);
   check_solve(gtk_widget_get_toplevel(GTK_WIDGET(button)));
   GtkWidget *tb = lookup_widget(finestre[0], "toolbar_main");
   abilitamb(finestre[0], dialogo->QualeAbilita);
   abilitatb(tb, dialogo->QualeAbilita);
}

GtkWidget* create_tune (void)
{
  GtkWidget *tune_window;
  GtkWidget *vbox;
  GtkWidget *ok_button;
  GtkWidget *cancel_button;

  tune_window = gtk_dialog_new ();
  g_object_set_data (G_OBJECT (tune_window), "tune_window", tune_window);
//  gtk_window_set_title (GTK_WINDOW (tune_window), "Tune program parameters");
  gtk_window_set_title (GTK_WINDOW (tune_window), "Define the Restart Strategy");
//  gtk_window_set_default_size(GTK_WINDOW(tune_window), 620, 380);

  vbox = gtk_dialog_get_content_area(GTK_DIALOG(tune_window));

  solve(vbox, tune_window);
  GtkWidget *frame = get_widget(tune_window, "Frame_solve");
  gtk_widget_show(frame);

  ok_button = myimage_button("", "go.png");
  g_object_set_data (G_OBJECT (tune_window), "ok_button",
                            ok_button);
  (void) g_signal_connect(G_OBJECT(ok_button), "clicked", 
         G_CALLBACK(end_tune), GINT_TO_POINTER(1));
  gtk_dialog_add_action_widget (GTK_DIALOG (tune_window), ok_button, 1);
  gtk_widget_show (ok_button);

  cancel_button = CANCEL_button();
  g_object_set_data (G_OBJECT (tune_window), "cancel_button",
                            cancel_button);
  gtk_dialog_add_action_widget (GTK_DIALOG (tune_window), cancel_button, 2);
  (void) g_signal_connect(G_OBJECT(cancel_button), "clicked", 
         G_CALLBACK(close_dlg), GINT_TO_POINTER(1));
  gtk_widget_show (cancel_button);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(ok_button)),
       GTK_BUTTONBOX_SPREAD);

  (void) g_signal_connect_swapped (G_OBJECT(tune_window), "delete_event", 
        G_CALLBACK(gtk_button_clicked), G_OBJECT(cancel_button)); 
  (void) g_signal_connect (G_OBJECT (tune_window), "delete_event",
                      G_CALLBACK(true_cb), NULL);

  return tune_window;
}

void tune (GtkWidget *widget, gpointer data)
{

   GtkWidget *entry;
   float valori[10];

/* inizializzazioni */

   int ier = c_init_tune(valori);

   if(ier)
      return;
   {

      if(tune_dlg == NULL)
         tune_dlg = create_tune();

      ktest = 2;

      entry = get_widget(tune_dlg, "frame_sa");
      gtk_widget_hide(entry);

      entry = get_widget(tune_dlg, "SACheck");
      gtk_widget_hide(entry);

      entry = get_widget(tune_dlg, "combosize");
      combo_set_val(entry, nsizes);
      real_dime = (int) valori[4];

      entry = get_widget(tune_dlg, "labelsize");
      gtk_label_set_text (GTK_LABEL (entry),
                       labsizes[real_dime-1]);
      entry = get_widget (tune_dlg, "AutoCheck");
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry), TRUE);

      riempi_blocchi_e_relax(tune_dlg, valori);
      entry = get_widget(tune_dlg, "Resetst");
      gtk_widget_show(entry);
#if 0
      switch((int)valori[8])
      {
      case S_DM:
          gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(get_widget(tune_dlg, "TangentCheck")), TRUE);
          break;
      case S_PATT:
          gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(get_widget(tune_dlg, "PattersonCheck")), TRUE);
          break;
      case S_VLD:
          gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(get_widget(tune_dlg, "VLDCheck")), TRUE);
          break;
      case S_MDM:
          gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(get_widget(tune_dlg, "MDMCheck")), TRUE);
          break;
      case S_SA:
          gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(get_widget(tune_dlg, "SACheck")), TRUE);
          break;
      }
#endif
      Neutro = 0;
      entry = get_widget(tune_dlg, "Rsoglia");
      if(valori[9] < 0)
      {
         gtk_widget_hide(entry);
         Neutro = 2;
      }
      else
      {
         gtk_widget_show(entry);
         spin_button_set_value(entry, valori[9]);
      }
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(get_widget(tune_dlg, "defaults")), TRUE);

      gtk_window_set_transient_for(GTK_WINDOW(tune_dlg), GTK_WINDOW(finestre[0]));
      gtk_widget_show (tune_dlg);
      finestra_modale_aperta2(tune_dlg);
   }
}

/********************************************************/
/*             B O N D    D I S T A N C E               */
/********************************************************/

int iStart = 0;


void c_init_setbd (float BondTable[NUMSPECIES][NUMSPECIES][2], float radii[2][NUMSPECIES])
{
     init_setbd_(BondTable, radii);
}

void c_finish_setbd (float BondTable[NUMSPECIES][NUMSPECIES][2], float radii[2][NUMSPECIES]
       , int *Action)
{
     finish_setbd_(BondTable, radii, Action);
}

void end_bd (GtkWidget *dlg, int *Action)
{
     float BondTable[NUMSPECIES][NUMSPECIES][2], radii[2][NUMSPECIES];
     int i, j, iStart;
     char num[20];
     GtkWidget *wid;

     for(i=0; i<NUMSPECIES; i++)
     {
         radii[0][i] = 0.;
         radii[1][i] = 0.;
         for(j=0; j<NUMSPECIES; j++)
         {
             BondTable[i][j][0] = 0.;
             BondTable[i][j][1] = 0.;
         }
     }

     if((*Action) == 1)
     {
         iStart = 0;
         for(i=iStart; i<nSpec; i++)    
         {
             ScriviStringa(num, sizeof(num), "radc%d", i);
             wid = get_widget(dlg, num);
             CopiaStringa(num, sizeof(num), gtk_editable_get_chars(GTK_EDITABLE(wid), 0, -1));
             radii[0][i] = (float) atof(num);
             ScriviStringa(num, sizeof(num), "radv%d", i);
             wid = get_widget(dlg, num);
             CopiaStringa(num, sizeof(num), gtk_editable_get_chars(GTK_EDITABLE(wid), 0, -1));
             radii[1][i] = (float) atof(num);
             for(j=iStart; j<nSpec; j++)    
             {
                 ScriviStringa(num, sizeof(num), "%d-%dm", i, j);
                 wid = get_widget(dlg, num);
                 CopiaStringa(num,sizeof(num),  
                             gtk_editable_get_chars(GTK_EDITABLE(wid), 0, -1));
                 BondTable[i][j][0] = (float) atof(num);
                 ScriviStringa(num, sizeof(num), "%d-%dM", i, j);
                 wid = get_widget(dlg, num);
                 CopiaStringa(num,sizeof(num),  
                               gtk_editable_get_chars(GTK_EDITABLE(wid), 0, -1));
                 BondTable[i][j][1] = (float) atof(num);
             }
         }
     }

     c_finish_setbd(BondTable, radii, Action);
}

//void change_title (GtkNotebook *nb, gint page_num, GtkWidget *dialog)
//{
//    gtk_window_set_title(GTK_WINDOW(dialog), g_strdup_printf(
//             "Modify %s properties", Specie[page_num]));
//}

GtkWidget *create_bd(void)
{
   GtkWidget *dialog, *vbox, *bd_notebook, *label, *frame, *hbox, *table, *button;
   int i, j, c, r;
   char *labels_bd, num[8];

   dialog = gtk_dialog_new();
   gtk_window_set_title(GTK_WINDOW(dialog), "Modify atomic properties");
   gtk_window_set_default_size(GTK_WINDOW(dialog), 400, 400);

   vbox = gtk_dialog_get_content_area(GTK_DIALOG(dialog));
   gtk_container_set_border_width (GTK_CONTAINER (vbox), 8);

   bd_notebook = gtk_notebook_new();
   gtk_box_pack_start (GTK_BOX(vbox), bd_notebook, TRUE, TRUE, 0);

   for(i=iStart; i<nSpec; i++)
   {
       vbox = vbox_new (FALSE, 8);
       gtk_container_add (GTK_CONTAINER (bd_notebook), vbox);
       gtk_container_set_border_width (GTK_CONTAINER (vbox), 8);

       frame = gtk_frame_new(NULL);
       gtk_box_pack_start (GTK_BOX(vbox), frame, FALSE, FALSE, 0);
       hbox = hbox_new(FALSE, 4);
       gtk_container_add(GTK_CONTAINER(frame), hbox);
       gtk_container_set_border_width (GTK_CONTAINER (hbox), 8);

       label = gtk_label_new("Covalent Radius");
       set_alignment(label, 0., 0.5);
       gtk_box_pack_start (GTK_BOX(hbox), label, FALSE, FALSE, 0);

       label = gtk_entry_new();
//       gtk_widget_set_size_request(label, 60, 24);
       set_width_chars(GTK_ENTRY(label), 8);
       gtk_box_pack_start (GTK_BOX(hbox), label, FALSE, FALSE, 0);
       ScriviStringa(num, sizeof(num), "radc%d", i);
       g_object_set_data(G_OBJECT (dialog), num, label);
       g_signal_connect (G_OBJECT(label), "focus_in_event",
                   G_CALLBACK (on_entry_focus_in_event), NULL);

       label = gtk_entry_new();
       set_width_chars(GTK_ENTRY(label), 8);
       gtk_box_pack_end (GTK_BOX(hbox), label, FALSE, FALSE, 0);
       ScriviStringa(num, sizeof(num), "radv%d", i);
       g_object_set_data(G_OBJECT (dialog), num, label);
       g_signal_connect (G_OBJECT(label), "focus_in_event",
                   G_CALLBACK (on_entry_focus_in_event), NULL);

       label = gtk_label_new("Van der Waals Radius");
       gtk_box_pack_end (GTK_BOX(hbox), label, FALSE, FALSE, 0);
       set_alignment(label, 0., 0.5);

       frame = FRAME_NEW("Min and Max Bond Distance", FRAMECOLOR);
       gtk_box_pack_start (GTK_BOX(vbox), frame, FALSE, FALSE, 8);

       table = table_new((nSpec+1-iStart)/2, 6, TRUE);
       gtk_container_set_border_width (GTK_CONTAINER (table), 8);
       gtk_container_add(GTK_CONTAINER(frame), table);
       table_set_row_spacings(table, 4);
       table_set_col_spacings(table, 8);
       
       c = 0;
       r = 0;
       for(j=iStart; j<nSpec; j++)
       {
          labels_bd = g_strdup_printf("%s-%s", Sigle[i], Sigle[j]);
          label = gtk_label_new(labels_bd);
          table_attach(table, label, c, c+1, r, r+1);
          c++;
          label = gtk_entry_new();
          set_width_chars(GTK_ENTRY(label), 8);
          table_attach(table, label, c, c+1, r, r+1);
          ScriviStringa(num, sizeof(num), "%d-%dm", i, j);
          g_object_set_data(G_OBJECT (dialog), num, label);
          g_signal_connect (G_OBJECT(label), "focus_in_event",
                   G_CALLBACK (on_entry_focus_in_event), NULL);
          c++;
          label = gtk_entry_new();
          set_width_chars(GTK_ENTRY(label), 8);
          table_attach(table, label, c, c+1, r, r+1);
          ScriviStringa(num, sizeof(num), "%d-%dM", i, j);
          g_object_set_data(G_OBJECT (dialog), num, label);
          g_signal_connect (G_OBJECT(label), "focus_in_event",
                   G_CALLBACK (on_entry_focus_in_event), NULL);
          c ++;
          if(c == 6)
          {
             r++;
             c = 0;
          }
       }
       set_tab_label (GTK_NOTEBOOK (bd_notebook), i-iStart, Sigle[i]);
   }

   button = OK_button();
   gtk_dialog_add_action_widget(GTK_DIALOG(dialog), button, 1);

   button = DEFAULTS_button();
   gtk_dialog_add_action_widget(GTK_DIALOG(dialog), button, 2);

   button = CANCEL_button();
   gtk_dialog_add_action_widget(GTK_DIALOG(dialog), button, 0);
   gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
        GTK_BUTTONBOX_SPREAD);

//   (void) g_signal_connect_after (G_OBJECT(bd_notebook), "change-current-page", 
//          G_CALLBACK(change_title), dialog);
   return dialog;
}

void set_bd (GtkWidget *widget, gpointer data)
{
     int i,j;
     char num[8];
     GtkWidget *wid, *setbd_dlg;
     float BondTable[NUMSPECIES][NUMSPECIES][2], radii[2][NUMSPECIES];

     c_init_setbd(BondTable, radii);
     iStart = 0;

     setbd_dlg = create_bd();

     for(i=iStart; i<nSpec; i++)    
     {
         ScriviStringa(num, sizeof(num), "radc%d", i);
         wid = lookup_widget(setbd_dlg, num);
         gtk_entry_set_text(GTK_ENTRY(wid), 
                 g_strdup_printf("%6.4f", radii[0][i]));
         ScriviStringa(num, sizeof(num), "radv%d", i);
         wid = lookup_widget(setbd_dlg, num);
         gtk_entry_set_text(GTK_ENTRY(wid), 
                 g_strdup_printf("%6.4f", radii[1][i]));
         for(j=iStart; j<nSpec; j++)    
         {
             ScriviStringa(num, sizeof(num), "%d-%dm", i, j);
             wid = lookup_widget(setbd_dlg, num);
             gtk_entry_set_text(GTK_ENTRY(wid), 
                 g_strdup_printf("%6.4f", BondTable[i][j][0]));
             ScriviStringa(num, sizeof(num), "%d-%dM", i, j);
             wid = lookup_widget(setbd_dlg, num);
             gtk_entry_set_text(GTK_ENTRY(wid), 
                 g_strdup_printf("%6.4f", BondTable[i][j][1]));
         }
     }
     gtk_window_set_transient_for(GTK_WINDOW(setbd_dlg), GTK_WINDOW(finestre[0]));
     gtk_widget_show_all(setbd_dlg);
     finestra_modale_aperta2(setbd_dlg);
     int result = gtk_dialog_run(GTK_DIALOG(setbd_dlg));
     if(result)
        end_bd(setbd_dlg, &result);
     finestra_modale_chiusa2();
     gtk_widget_destroy(setbd_dlg);
}


/********************************************************/
/*           M I S S I N G   D A T A                    */
/********************************************************/

void GetSpgAndCell(float abcvet[], int *ier, int *ktest, const char *filspg);

extern "C" int c_putrefl_(char *szmegastr, int *i, size_t idum);

extern "C" void c_get12_(float abcvet[], int *ier)
{
    std::string filspg = g_strdup_printf( "%s%cfiles%cSir.spg",
       g_path_get_dirname(main_app::TheApp.PkgDataDir().c_str()),
       G_DIR_SEPARATOR, G_DIR_SEPARATOR);
    GetSpgAndCell(abcvet, ier, &ktest, filspg.c_str());
}

int check_reflections(GtkWidget *dlg)
{
    std::string megastr;
    int i;
    char *szmegastr;
    char buffer[10];
    GtkWidget *entry = get_widget(dlg, "rpc_file");
    char *string2 = gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1);
    if(str_white(string2))
    {
       MessageDialog(dlg, GTK_MESSAGE_WARNING, GTK_BUTTONS_CLOSE,
                              "You must specify a reflections file!");
       return -1;
    }
    FILE *fp = fOpen(string2, "r");
    if(fp == NULL)
    {
       MessageDialog(dlg, GTK_MESSAGE_WARNING, GTK_BUTTONS_CLOSE,
                "Error in open file: %s", string2);
       return -1;
    }
    (void) fclose (fp);
    megastr.clear();
    megastr.append(fromUTF8(string2).c_str());
    megastr.append("@");
    entry = get_widget(dlg, "format");
    if(gtk_widget_get_sensitive(entry))
       megastr.append(gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
    else
    {
       entry = get_widget(dlg, "Format2");
       if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry)))
          megastr.append("free");
       else
          megastr.append("(3I4, 2F8.2)");
    }
    megastr.append("@");
    entry = get_widget(dlg, "ifsigma");
    if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry)))
       megastr.append("0");
    else
       megastr.append("1");
    megastr.append("@");
// decidere se serve il campo ifsigma
    entry = get_widget(dlg, "Tfac");
    megastr.append( gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
    megastr.append("@");
    entry = get_widget(dlg, "minres");
    megastr.append(gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
    megastr.append("@");

    for(i=0; i<9; i++)
    {
        ScriviStringa(buffer, sizeof(buffer), "%d", i);
        entry = get_widget(dlg, buffer);
        megastr.append(gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
        megastr.append("@");
    }

    entry = get_widget(dlg, "refl_per_rec");
    megastr.append(gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
    megastr.append("@");

    entry = get_widget(dlg, sfacs[0]);
    if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry)))
       i = 1;
    else
       i = 2;

    szmegastr = DuplicaStringa(megastr.c_str());
    gtk_widget_set_sensitive(dlg, FALSE);
    fortran_al_lavoro();
    int ier = c_putrefl_(szmegastr, &i, strlen(szmegastr));
    fine_lavoro();
    gtk_widget_set_sensitive(dlg, TRUE);
    if(ier)
       return -1;
    return 0;
}

extern "C" void c_getrefl_(char *string, char *formato, int *fsq, int *ier)
{
    GtkWidget *dialog, *button, *entry, *button2;
    char *string1, *string2;
    int lung_str;

    ktest = 0;
    *ier = 0;
    string2 = g_new0(char, MaxLenFilename);
    dialog = gtk_dialog_new();
    g_object_set_data(G_OBJECT(finestre[0]), "new_project_dlg", dialog);
    gtk_window_set_title(GTK_WINDOW(dialog), "Missing data");
    i_refle(dialog, dialog);
    button = OK_button();
    g_object_set_data(G_OBJECT(dialog), "okbutton", button);
    gtk_dialog_add_action_widget(GTK_DIALOG(dialog), button, GTK_RESPONSE_OK);

    button2 = CANCEL_button();
    gtk_dialog_add_action_widget(GTK_DIALOG(dialog), button2, GTK_RESPONSE_CANCEL);
    g_object_set_data(G_OBJECT(dialog), "cancelbutton", button2);
    gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
        GTK_BUTTONBOX_SPREAD);

    entry = get_widget(dialog, "rpc_file");
    string1 = g_new0(char, MaxLenFilename);
    ScriviStringa(string1, MaxLenFilename, "%s", 
             gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
    if(strlen(string1))
    {
       CopiaStringa(string2, MaxLenFilename, g_path_get_dirname(string1));
//    else
//       CopiaStringa(string2, MaxLenFilename, SWareRC->WorkingDirectory);
    lung_str = (int) strlen(string2);
    *(string2+lung_str) = G_DIR_SEPARATOR;
    *(string2+lung_str+1) = '\0';
    AppendiStringa(string2, MaxLenFilename, string);
    AppendiStringa(string2, MaxLenFilename, ".hkl");
    gtk_entry_set_text(GTK_ENTRY(entry), string2);
    }
    else
       gtk_entry_set_text(GTK_ENTRY(entry), "");
    if(*fsq == 1)
       entry = get_widget(dialog, sfacs[0]);
    else
       entry = get_widget(dialog, sfacs[1]);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry), TRUE);

    if(strlen(formato) > 1)
    {
       entry = get_widget(dialog, "format");
       gtk_entry_set_text(GTK_ENTRY(entry), formato);
    }
//    entry = get_widget(dialog, "ifsigma");
//    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry), !ifSigma);

    finestra_modale_aperta2(dialog);
    bool loop=true;
    while(loop)
    {
         gtk_widget_show_all(dialog);
         gboolean result = gtk_dialog_run(GTK_DIALOG(dialog));
         gtk_widget_hide(dialog);
         loop = false;
         if(result == GTK_RESPONSE_OK)
         { 
             *ier = check_reflections(dialog);
             if(*ier)
                loop = true;
         }
         else
             *ier = -1;
    }
    gtk_widget_destroy(dialog);
    finestra_modale_chiusa2();
}

/*****************************************************************/
/*              R E S T A R T                                    */
/*****************************************************************/

static GtkWidget *restart_dialog = NULL;
static GtkWidget *amb_dialog = NULL;
static GtkWidget *contour_dialog = NULL;
static GtkWidget *rct_dialog = NULL;
static GtkWidget *export_dialog = NULL;

static int SelectedTrial;

void ok_restart (GtkButton *button, gpointer user_data)
{
    GtkWidget *dialog, *entry;
    float valori[10]; 
    int i;

    dialog = gtk_widget_get_toplevel(GTK_WIDGET(button));

    valori[4] = (float) leggi_blocchi(dialog);
    if(valori[4] == 0)
    {
       MessageDialog(dialog, GTK_MESSAGE_WARNING, GTK_BUTTONS_CLOSE, 
                 "You must specify trials for block!");
       return;
    }

    entry = get_widget(dialog, "Never");
    if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry)))
       i = -1;
    entry = get_widget(dialog, "Automatic");
    if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry)))
       i = 0;
    entry = get_widget(dialog, "Always");
    if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry)))
       i = 1;
    valori[4] = valori[4]*100 + i + 3;
    entry = get_widget(dialog, "Rsoglia");
    valori[5] = (float)spin_button_get_value(entry);

    gtk_widget_hide (gtk_widget_get_toplevel(GTK_WIDGET(button)));
    finestra_modale_chiusa2();
    fortran_al_lavoro();
    can_drag = FALSE;
    i = 2;
    finishrestart_ (&i, valori, blocchi);
    fine_lavoro();
    GtkWidget *tb = lookup_widget(finestre[0], "toolbar_main");
    abilitamb(finestre[0], dialogo->QualeAbilita);
    abilitatb(tb, dialogo->QualeAbilita);
}

static void   on_select_restart (GtkTreeSelection *selec, gpointer data)
{
   int sel, pos;
   GtkTreeModel *model;
   GtkTreeIter iter;

   sel = gtk_tree_selection_get_selected (selec, &model, &iter);
   pos = -1;
   if(sel)
      pos = row_selected(selec);

/* pos indica il numero d'ordine nella lista                 */


   if(pos != -1)
      SelectedTrial = pos + 1 ;
   else
      SelectedTrial = -1;
}


GtkWidget* create_restart ()
{
  GtkWidget *window1;
  GtkWidget *vbox1;
  GtkWidget *hbox;
  GtkWidget *frame;
  GtkWidget *vbox2;
  GtkWidget *button1;
  GtkWidget *button2;

  window1 = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (window1), "Define the Restart Strategy");
  gtk_container_set_border_width (GTK_CONTAINER (window1), 10);

  vbox1 = gtk_dialog_get_content_area(GTK_DIALOG(window1));

  frame = FRAME_BOLD ("Restart conditions", FRAMECOLOR, 1.2f);
  gtk_widget_show (frame);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 4);
  gtk_box_pack_start (GTK_BOX (vbox1), frame, FALSE, FALSE, 0);
/*
  hbox = hbox_new(FALSE, 0);
  gtk_widget_show(hbox);
  gtk_container_add (GTK_CONTAINER (frame), hbox);

  vbox2 = vbox_new(FALSE, 0);
  gtk_widget_show(vbox2);
  gtk_box_pack_start (GTK_BOX (hbox), vbox2, FALSE, FALSE, 0);
*/
  vbox2 = vbox_new(FALSE, 0);
  gtk_widget_show(vbox2);
  gtk_container_add (GTK_CONTAINER (frame), vbox2);

  hbox = hbox_new(FALSE, 0);
  gtk_widget_show(hbox);
  gtk_box_pack_start (GTK_BOX (vbox2), hbox, FALSE, FALSE, 0);

  relax_and_blocks(window1, hbox, vbox2);


  button1 = myimage_button("", "go.png");
  gtk_dialog_add_action_widget (GTK_DIALOG (window1), button1, 1);

  button2 = CANCEL_button();
  gtk_dialog_add_action_widget (GTK_DIALOG (window1), button2, 2);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button1)),
          GTK_BUTTONBOX_SPREAD);

  (void) g_signal_connect (G_OBJECT(button1), "clicked", 
                      G_CALLBACK(ok_restart), NULL);
  (void) g_signal_connect (G_OBJECT(button2), "clicked", 
                      G_CALLBACK(close_dlg), GINT_TO_POINTER(1));

  (void) g_signal_connect_swapped(G_OBJECT(window1), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button2)); 
  (void) g_signal_connect (G_OBJECT (window1), "delete_event",
                      G_CALLBACK(true_cb), NULL);

  return window1;
}


void open_restart (float valori[])
{
     GtkWidget *label;

     ktest = 0;
     if(restart_dialog == NULL)
           restart_dialog = create_restart();
     gtk_window_set_transient_for(GTK_WINDOW(restart_dialog), GTK_WINDOW(finestre[0]));
     gtk_widget_show(restart_dialog);
     finestra_modale_aperta2(restart_dialog);

     label = lookup_widget(restart_dialog,"Rsoglia");
     spin_button_set_value(label, valori[9]);
     label = get_widget(restart_dialog, "Resetst");
     gtk_widget_hide(label);
     riempi_blocchi_e_relax(restart_dialog, valori);
}

void riempi_listaT(GtkWidget *lista)
{
  int i;
  char *rigacom[4];

  clear_list(lista);
  i = 0;
  while(strlen(dialogo->SmallIt[i]))
  {
     get_str_tokens(dialogo->SmallIt[i], " ", 4, rigacom);
     add_line_to_listM(lista, rigacom);
     i++;
   }
}

void ok_amb (GtkButton *button, gpointer user_data)
{
    GtkWidget *dialog, *entry;
    float valori[10];
    int i;

    dialog = gtk_widget_get_toplevel(GTK_WIDGET(button));
    valori[4] = (float)SelectedTrial * 100 + 1;

    entry = get_widget(dialog, "Rsoglia");
    valori[5] = (float)spin_button_get_value(entry);

    for(i=0; i<3; i++)
    {
        entry = get_widget(dialog, g_strdup_printf("%d", i));
        if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry)))
        {
           valori[6] = (float) i + 1;
           break;
        }
    }
    
    if(SelectedTrial > 0)
    {
       gtk_widget_hide (gtk_widget_get_toplevel(GTK_WIDGET(button)));
       finestra_modale_chiusa2();
       fortran_al_lavoro();
       can_drag = FALSE;
       i = 1;
       finishrestart_ (&i, valori, blocchi);
       fine_lavoro();
       can_drag = TRUE;
       GtkWidget *tb = lookup_widget(finestre[0], "toolbar_main");
       abilitamb(finestre[0], dialogo->QualeAbilita);
       abilitatb(tb, dialogo->QualeAbilita);
    }
    else
       MessageDialog(gtk_widget_get_toplevel(GTK_WIDGET(button)), GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, 
             "You should select a trial!");
}


GtkWidget* create_amb ()
{
  GtkWidget *window1;
  GtkWidget *vbox1, *vbox;
  GtkWidget *frame, *table;
  GtkWidget *frame3;
  GtkWidget *list1, *radio;
  GtkWidget *label, *spin;
  GtkWidget *button1;
  GtkWidget *button2;
  GSList *group=NULL;
  int i;
  static const char *colonne[] = {"  Trial ", "  Procedure  ", "  Early FOM  ", "  Final FOM  "};
  static const char *l[] = {"Peak search only", 
                      "Fourier refinement only", 
                      "Complete Diagonal LSQ refinement"};


  window1 = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (window1), "Automatic Model Builder");
  gtk_container_set_border_width (GTK_CONTAINER (window1), 10);
  gtk_widget_set_size_request (window1, 450, 350);

  vbox1 = gtk_dialog_get_content_area(GTK_DIALOG(window1));

  frame = gtk_frame_new(NULL);
  gtk_widget_show (frame);
  gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_ETCHED_OUT);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 4);
  gtk_box_pack_start (GTK_BOX (vbox1), frame, FALSE, FALSE, 4);

  label = LABEL_BOLD("Starting model building", LABELCOLOR, 1.3f);
  gtk_widget_show (label);
  gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_CENTER);
  gtk_container_add(GTK_CONTAINER(frame), label);

  frame = gtk_frame_new(NULL);
  gtk_widget_show (frame);
  gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_ETCHED_OUT);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 4);
  gtk_box_pack_start (GTK_BOX (vbox1), frame, FALSE, FALSE, 4);

  label = LABEL_BOLD("Observations/Parameters ", LABELCOLOR, 1.1f);
  gtk_widget_show (label);
  gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_CENTER);
  gtk_box_pack_start (GTK_BOX (vbox1), label, FALSE, FALSE, 4);
  g_object_set_data (G_OBJECT (window1), "osup", label);

  table = table_new(2, 2, FALSE);
  gtk_widget_show (table);
  gtk_container_add(GTK_CONTAINER(frame), table);

  label = LABEL_BOLD("Atoms", LABELCOLOR, 1.1f);
  gtk_widget_show (label);
  gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_CENTER);
  table_attach (table, label, 0, 1, 0, 1, TRUE);

  label = LABEL_BOLD("Strategy", LABELCOLOR, 1.1f);
  gtk_widget_show (label);
  gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_CENTER);
  table_attach (table, label, 1, 2, 0, 1, TRUE);

#ifdef IN_GTK3
  frame = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_FILL, FALSE, TRUE);
#else
  frame = gtk_alignment_new(0.5, 0., 0.,1.);
#endif
  gtk_widget_show (frame);
  table_attach (table, frame, 0, 1, 1, 2, TRUE);
  spin = SPIN_WITH_LABEL("Atoms to find  ", LABELCOLOR, 1, 10000, 10, 1., 0);
  gtk_widget_show (spin);
  gtk_container_add(GTK_CONTAINER(frame), spin);
  g_object_set_data (G_OBJECT (window1), "Rsoglia", get_widget(spin, "spin"));
  
#ifdef IN_GTK3
  frame = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_FILL, FALSE, TRUE);
#else
  frame = gtk_alignment_new(0.5, 0., 0.,1.);
#endif
  gtk_widget_show (frame);
  table_attach (table, frame, 1, 2, 1, 2, TRUE);

  vbox = vbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER(frame), vbox);
  gtk_widget_show(vbox);

  for(i=0; i<3; i++)
  {
      radio = RADIO_BUTTON_WITH_LABEL (group, l[i], LABELCOLOR);
      group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
      gtk_widget_show (radio);
      g_object_set_data(G_OBJECT (window1), g_strdup_printf("%d", i),
          radio);
      gtk_box_pack_start (GTK_BOX (vbox), radio, FALSE, FALSE, 0);
  }


  frame3 = FRAME_BOLD("Stored Trials", FRAMECOLOR, 1.2f);
  g_object_set_data(G_OBJECT (window1), "frameOldTrials", frame3);
  gtk_box_pack_start (GTK_BOX (vbox1), frame3, TRUE, TRUE, 10);

#ifdef IN_GTK3
  frame = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_FILL, FALSE, TRUE);
#else
  frame = gtk_alignment_new(0.5, 0., 0.,1.);
#endif
  gtk_container_add(GTK_CONTAINER(frame3), frame);
  gtk_widget_show (frame);
  list1 = createSelectionM(window1, frame, colonne, "listaTrials", 
          sizeof(colonne)/sizeof(colonne[0]), MyBLUE);
  set_selection_mode(list1, GTK_SELECTION_SINGLE);

  button1 = myimage_button("", "go.png");
  gtk_dialog_add_action_widget (GTK_DIALOG (window1), button1, 1);

  button2 = CANCEL_button();
  gtk_dialog_add_action_widget (GTK_DIALOG (window1), button2, 2);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button1)),
          GTK_BUTTONBOX_SPREAD);

  /*  segnali  */
  (void) g_signal_connect (G_OBJECT(button1), "clicked", 
                      G_CALLBACK(ok_amb), NULL);
  (void) g_signal_connect (G_OBJECT(button2), "clicked", 
                      G_CALLBACK(close_dlg), GINT_TO_POINTER(1));

  (void) g_signal_connect_swapped(G_OBJECT(window1), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button2)); 
  (void) g_signal_connect (G_OBJECT (window1), "delete_event",
                      G_CALLBACK(true_cb), NULL);

  g_signal_connect(G_OBJECT(gtk_tree_view_get_selection (GTK_TREE_VIEW (list1))),
        "changed", G_CALLBACK(on_select_restart), NULL);

  return window1;
}

void open_amb (float valori[])
{
     GtkWidget *label;
     char *string;

     string = g_new0(char, 60);
     ktest = 0;
     SelectedTrial = -1;
     if(amb_dialog == NULL)
           amb_dialog = create_amb();
     gtk_widget_show_all(amb_dialog);
     finestra_modale_aperta2(amb_dialog);

     label = lookup_widget(amb_dialog,"listaTrials");
     set_widget_fontN(label);
     riempi_listaT(label);
     label = lookup_widget(amb_dialog,"Rsoglia");
     spin_button_set_value(label, valori[9]);
     label = get_widget(amb_dialog,"osup");
     ScriviStringa(string, 60, "Observations/Parameters = %.2f", valori[0]);
     set_label_text(label, string, MSGCOLOR, 1.1f);
}

void ok_rct (GtkButton *button, gpointer user_data)
{
    GtkWidget *dialog, *entry;
    float valori[10];
    int i;

    dialog = gtk_widget_get_toplevel(GTK_WIDGET(button));

    entry = get_widget(dialog, "Rsoglia");
    valori[4] = (float)spin_button_get_value(entry)*100;

    for(i=0; i<3; i++)
    {
        entry = get_widget(dialog, g_strdup_printf("%d", i+4));
        if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry)))
        {
           valori[6] = (float) i + 1;
           break;
        }
    }
    
    for(i=0; i<4; i++)
    {
        entry = get_widget(dialog, g_strdup_printf("%d", i));
        if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry)))
        {
           valori[7] = (float) i + 1;
           break;
        }
    }
    
    gtk_widget_hide (gtk_widget_get_toplevel(GTK_WIDGET(button)));
    finestra_modale_chiusa2();
    fortran_al_lavoro();
    can_drag = FALSE;
    i = 5;
    finishrestart_ (&i, valori, blocchi);
    fine_lavoro();
    can_drag = TRUE;
    GtkWidget *tb = lookup_widget(finestre[0], "toolbar_main");
    abilitamb(finestre[0], dialogo->QualeAbilita);
    abilitatb(tb, dialogo->QualeAbilita);
}


GtkWidget* create_rct ()
{
  GtkWidget *window1;
  GtkWidget *vbox1;
  GtkWidget *frame, *table;
  GtkWidget *radio;
  GtkWidget *label;
  GtkWidget *button1;
  GtkWidget *button2;
  GSList *group=NULL;
  int i;
  static const char *l[] = {"Peak search only", 
                      "Fourier refinement only", 
                      "Complete Diagonal LSQ refinement"};
  static const char *l2[] = {"MDM Procedure", 
                       "SDM Procedure", 
                       "VLD Procedure", 
                       "Patterson Procedure"};

  window1 = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (window1), "Re-compute trial");
  gtk_container_set_border_width (GTK_CONTAINER (window1), 10);
  gtk_widget_set_size_request (window1, 450, 200);

  vbox1 = gtk_dialog_get_content_area(GTK_DIALOG(window1));

  frame = gtk_frame_new(NULL);
  gtk_widget_show (frame);
  gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_ETCHED_OUT);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 4);
  gtk_box_pack_start (GTK_BOX (vbox1), frame, FALSE, FALSE, 4);

  table = table_new(5, 2, FALSE);
  gtk_widget_show (table);
  gtk_container_add(GTK_CONTAINER(frame), table);
  gtk_container_set_border_width (GTK_CONTAINER (table), 10);
  table_set_row_spacings(table, 4);

  label = SPIN_WITH_LABEL("Re-compute trial number", LABELCOLOR, 1, 100 ,1, 1, 0);
  gtk_widget_show (label);
  g_object_set_data(G_OBJECT (window1), "Rsoglia", get_widget(label, "spin"));
  table_attach (table, label, 0, 2, 0, 1, TRUE);

  for(i=0; i<3; i++)
  {
      radio = RADIO_BUTTON_WITH_LABEL (group, l[i], LABELCOLOR);
      group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
      gtk_widget_show (radio);
      g_object_set_data(G_OBJECT (window1), g_strdup_printf("%d", i+4),
          radio);
      table_attach (table, radio, 1, 2, i+1, i+2, TRUE);
  }

  group = NULL;
  for(i=0; i<4; i++)
  {
      radio = RADIO_BUTTON_WITH_LABEL (group, l2[i], LABELCOLOR);
      group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
      gtk_widget_show (radio);
      g_object_set_data(G_OBJECT (window1), g_strdup_printf("%d", i),
          radio);
      table_attach (table, radio, 0, 1, i+1, i+2, TRUE);
  }

  button1 = myimage_button("", "go.png");
  gtk_dialog_add_action_widget (GTK_DIALOG (window1), button1, 1);

  button2 = CANCEL_button();
  gtk_dialog_add_action_widget (GTK_DIALOG (window1), button2, 2);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button1)),
          GTK_BUTTONBOX_SPREAD);

  /*  segnali  */
  (void) g_signal_connect (G_OBJECT(button1), "clicked", 
                      G_CALLBACK(ok_rct), NULL);
  (void) g_signal_connect (G_OBJECT(button2), "clicked", 
                      G_CALLBACK(close_dlg), GINT_TO_POINTER(1));

  (void) g_signal_connect_swapped(G_OBJECT(window1), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button2)); 
  (void) g_signal_connect (G_OBJECT (window1), "delete_event",
                      G_CALLBACK(true_cb), NULL);

  return window1;
}

void open_rct (float valori[])
{
     GtkWidget *label;
     int i;

     ktest = 0;
     SelectedTrial = -1;
     force_close_viewers();
     if(rct_dialog == NULL)
           rct_dialog = create_rct();
     gtk_window_set_transient_for(GTK_WINDOW(rct_dialog), GTK_WINDOW(finestre[0]));
     gtk_widget_show_all(rct_dialog);
     finestra_modale_aperta2(rct_dialog);

     label = lookup_widget(rct_dialog,"Rsoglia");
     spin_button_set_range(label, 1, valori[9]);
     spin_button_set_value(label, valori[8]);
     for(i=0; i<4; i++)
     {
         label = get_widget(rct_dialog,  g_strdup_printf("%d", i));
         gtk_widget_set_sensitive(label, (int)valori[5]);
         gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(label),
             (i == ((int)valori[5]-1)));
     }
     for(i=4; i<7; i++)
     {
         label = get_widget(rct_dialog,  g_strdup_printf("%d", i));
         if(valori[6])
            gtk_widget_show(label);
         else
            gtk_widget_hide(label);
     }
     if(valori[6])
     {
         label = get_widget(rct_dialog,  "6");
         gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(label), TRUE);
     }
}

void ok_contour (GtkButton *button, gpointer user_data)
{
    GtkWidget *dialog;
    float valori[10]; 

    dialog = gtk_widget_get_toplevel(GTK_WIDGET(button));
    valori[4] = (float)SelectedTrial * 100 + 1;

//050711    GtkWidget *entry = get_widget(dialog, "Rsoglia");
//050711    valori[5] = (float)spin_button_get_value(entry);

    if(SelectedTrial > 0)
    {
       gtk_widget_hide (gtk_widget_get_toplevel(GTK_WIDGET(button)));
       finestra_modale_chiusa2();
       fortran_al_lavoro();
       can_drag = FALSE;

       int i = get_int(dialog, "codice");
       finishrestart_ (&i, valori, blocchi);
       if(i == 4)
          mostra_tb(finestre[0], (gpointer) "contour");
       fine_lavoro();
       can_drag = TRUE;
       GtkWidget *tb = lookup_widget(finestre[0], "toolbar_main");
       abilitamb(finestre[0], dialogo->QualeAbilita);
       abilitatb(tb, dialogo->QualeAbilita);
    }
    else
       MessageDialog(gtk_widget_get_toplevel(GTK_WIDGET(button)), GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, 
             "You should select a trial!");
}


GtkWidget* create_contour ()
{
  GtkWidget *window1;
  GtkWidget *vbox1;
  GtkWidget *frame;
  GtkWidget *frame3;
  GtkWidget *list1;
  GtkWidget *label;
  GtkWidget *button1;
  GtkWidget *button2;
  //static const char *colonne[] = {"  Trial ", "  Procedure  ", "  Early FOM  ", "  Final FOM  "};
  static const char *colonne[] = {"Trial", "Procedure", "Final FOM", "R%"};

  window1 = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (window1), "Contour");
  gtk_container_set_border_width (GTK_CONTAINER (window1), 10);
  gtk_widget_set_size_request (window1, 450, 350);

  vbox1 = gtk_dialog_get_content_area(GTK_DIALOG(window1));

  frame = gtk_frame_new(NULL);
  gtk_widget_show (frame);
  gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_ETCHED_OUT);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 4);
  gtk_box_pack_start (GTK_BOX (vbox1), frame, FALSE, FALSE, 4);

  label = LABEL_BOLD("Starting 3D contour using Jav", LABELCOLOR, 1.3f);
  gtk_widget_show (label);
  gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_CENTER);
  gtk_container_add(GTK_CONTAINER(frame), label);
  g_object_set_data (G_OBJECT (window1), "label", label);

/*  050711
  label = LABEL_BOLD("Set the cutoff for the map ", LABELCOLOR, 1.1f);
  gtk_widget_show (label);
  gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_CENTER);
  gtk_box_pack_start (GTK_BOX (vbox1), label, FALSE, FALSE, 4);

  frame = gtk_alignment_new(0.5, 0., 0.,1.);
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (vbox1), frame, FALSE, FALSE, 4);
  GtkWidget *spin = SPIN_WITH_LABEL("Sigma value  ", LABELCOLOR, 0, 10, 3, 0.05, 2);
  gtk_widget_show (spin);
  gtk_container_add(GTK_CONTAINER(frame), spin);
  g_object_set_data (G_OBJECT (window1), "Rsoglia", get_widget(spin, "spin"));
*/
  
  frame3 = FRAME_BOLD("Stored Trials", FRAMECOLOR, 1.2f);
  g_object_set_data(G_OBJECT (window1), "frameOldTrials", frame3);
  gtk_box_pack_start (GTK_BOX (vbox1), frame3, TRUE, TRUE, 10);

#ifdef IN_GTK3
  frame = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_FILL, FALSE, TRUE);
#else
  frame = gtk_alignment_new(0.5, 0., 0.,1.);
#endif
  gtk_container_add(GTK_CONTAINER(frame3), frame);
  gtk_widget_show (frame);
  list1 = createSelectionM(window1, frame, colonne, "listaTrials",
          sizeof(colonne)/sizeof(colonne[0]), MyBLUE);

  set_selection_mode(list1, GTK_SELECTION_SINGLE);

  button1 = myimage_button("", "go.png");
  gtk_dialog_add_action_widget (GTK_DIALOG (window1), button1, 1);

  button2 = CANCEL_button();
  gtk_dialog_add_action_widget (GTK_DIALOG (window1), button2, 2);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button1)),
          GTK_BUTTONBOX_SPREAD);

  /*  segnali  */
  (void) g_signal_connect (G_OBJECT(button1), "clicked", 
                      G_CALLBACK(ok_contour), NULL);
  (void) g_signal_connect (G_OBJECT(button2), "clicked", 
                      G_CALLBACK(close_dlg), GINT_TO_POINTER(1));

  (void) g_signal_connect_swapped(G_OBJECT(window1), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button2)); 
  (void) g_signal_connect (G_OBJECT (window1), "delete_event",
                      G_CALLBACK(true_cb), NULL);

  g_signal_connect(G_OBJECT(gtk_tree_view_get_selection (GTK_TREE_VIEW (list1))),
        "changed", G_CALLBACK(on_select_restart), NULL);

  return window1;
}

void open_contour (float valori[], int codice)
{
     GtkWidget *label;

     ktest = 0;
     SelectedTrial = -1;
     if(contour_dialog == NULL)
           contour_dialog = create_contour();
     g_object_set_data(G_OBJECT(contour_dialog), "codice", GINT_TO_POINTER(codice));
     label = get_widget(contour_dialog,"label");
     if(codice == 3)
     {
        gtk_label_set_text(GTK_LABEL(label), "Starting 3D contour using Jav");
        gtk_window_set_title (GTK_WINDOW (contour_dialog), "Map Viewer");
     }
     else
     {
        gtk_label_set_text(GTK_LABEL(label), "Starting 2D contour");
        gtk_window_set_title (GTK_WINDOW (contour_dialog), "2D Contour");
     }

     gtk_window_set_transient_for(GTK_WINDOW(contour_dialog), GTK_WINDOW(finestre[0]));
     gtk_widget_show_all(contour_dialog);
     finestra_modale_aperta2(contour_dialog);

     label = lookup_widget(contour_dialog,"listaTrials");
     set_widget_fontN(label);
     riempi_listaT(label);
}

static int scelta = -1;

void ok_export (GtkButton *button, gpointer user_data)
{
    float valori[10];

    scelta = GPOINTER_TO_INT(user_data);
    if(scelta < 0)
    {
       gtk_widget_hide (gtk_widget_get_toplevel(GTK_WIDGET(button)));
       finestra_modale_chiusa2();
       gtk_main_quit();
       return;
    }
    valori[4] = (float)SelectedTrial * 100 + 1;

    if(SelectedTrial > 0)
    {
       gtk_widget_hide (gtk_widget_get_toplevel(GTK_WIDGET(button)));
       finestra_modale_chiusa2();
       fortran_al_lavoro();
       can_drag = FALSE;
       int i = 6;
       finishrestart_ (&i, valori, blocchi);
       fine_lavoro();
       can_drag = TRUE;
       gtk_main_quit();
    }
    else
    {
       MessageDialog(gtk_widget_get_toplevel(GTK_WIDGET(button)), GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, 
             "You should select a trial!");
        scelta = -1;
    }
}


GtkWidget* create_export ()
{
  GtkWidget *window1;
  GtkWidget *vbox1;
  GtkWidget *frame;
  GtkWidget *frame3;
  GtkWidget *list1;
  GtkWidget *label;
  GtkWidget *button1;
  GtkWidget *button2;
  static const char *colonne[] = {"  Trial ", "  Procedure  ", "  Early FOM  ", "  Final FOM  "};

  window1 = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (window1), "Export");
  gtk_container_set_border_width (GTK_CONTAINER (window1), 10);
  gtk_widget_set_size_request (window1, 450, 350);

  vbox1 = gtk_dialog_get_content_area(GTK_DIALOG(window1));

  frame = gtk_frame_new(NULL);
  gtk_widget_show (frame);
  gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_ETCHED_OUT);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 4);
  gtk_box_pack_start (GTK_BOX (vbox1), frame, FALSE, FALSE, 4);

  label = LABEL_BOLD("Export Phases", LABELCOLOR, 1.3f);
  gtk_widget_show (label);
  gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_CENTER);
  gtk_container_add(GTK_CONTAINER(frame), label);
  g_object_set_data(G_OBJECT (window1), "inte", label);

  frame3 = NEW_FRAME("Stored Trials", &FrameStyle);
  g_object_set_data(G_OBJECT (window1), "frameOldTrials", frame3);
  gtk_box_pack_start (GTK_BOX (vbox1), frame3, TRUE, TRUE, 10);

#ifdef IN_GTK3
  frame = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_FILL, FALSE, TRUE);
#else
  frame = gtk_alignment_new(0.5, 0., 0.,1.);
#endif
  gtk_container_add(GTK_CONTAINER(get_widget(frame3, "align")), frame);
  gtk_widget_show (frame);
  list1 = createSelectionM(window1, frame, colonne, "listaTrials", 
          sizeof(colonne)/sizeof(colonne[0]), MyBLUE);
  set_selection_mode(list1, GTK_SELECTION_SINGLE);

  button1 = myimage_button("", "go.png");
  gtk_dialog_add_action_widget (GTK_DIALOG (window1), button1, 1);

  button2 = CANCEL_button();
  gtk_dialog_add_action_widget (GTK_DIALOG (window1), button2, 2);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button1)),
          GTK_BUTTONBOX_SPREAD);

  /*  segnali  */
  (void) g_signal_connect (G_OBJECT(button1), "clicked", 
                      G_CALLBACK(ok_export), GINT_TO_POINTER(1));
  (void) g_signal_connect (G_OBJECT(button2), "clicked", 
                      G_CALLBACK(ok_export), GINT_TO_POINTER(-1));

  (void) g_signal_connect_swapped(G_OBJECT(window1), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button2)); 
  (void) g_signal_connect (G_OBJECT (window1), "delete_event",
                      G_CALLBACK(true_cb), NULL);

  g_signal_connect(G_OBJECT(gtk_tree_view_get_selection (GTK_TREE_VIEW (list1))),
        "changed", G_CALLBACK(on_select_restart), NULL);

  return window1;
}

void open_export (float valori[], int code)
{
     GtkWidget *label;

     ktest = 0;
     SelectedTrial = -1;
     if(export_dialog == NULL)
           export_dialog = create_export();
     gtk_widget_show_all(export_dialog);
     finestra_modale_aperta2(export_dialog);

     label = lookup_widget(export_dialog,"listaTrials");
     set_widget_fontN(label);
     riempi_listaT(label);
     label = get_widget(export_dialog,"inte");
     if(code == 6)                // Xtal
     {
        set_label_text(label, "Export Map &amp; Phases\nin Xtal format", LABELCOLOR, 1.3f);
     }
     else if(code == 7)           // CCP4
     {
        set_label_text(label, "Export Map \nin CCP4 format", LABELCOLOR, 1.3f);
     }
     gtk_main();
}



int c_restart (GtkWidget *item,  gpointer data)
{
   float valori[10];
   int ier, code = GPOINTER_TO_INT(data);

   ier = restart_(valori, blocchi, &code);
   if(!ier)
   {
       if(code == 1)                                 // Automatic Model Building
          open_amb(valori);
       else if(code == 3)                            // map via Jav
          open_contour(valori, code);
       else if(code == 4)                            // 2D contour
          open_contour(valori, code);
       else if(code == 5)                            // ReCompute Trial
          open_rct(valori);
       else if((code == 6) || (code == 7))           // export map in CCP4/Xtal
       {
           if(valori[4] > 1)
              open_export(valori, code);
           else
           {
              scelta = 1;
              valori[4] = 101;
              fortran_al_lavoro();
              can_drag = FALSE;
              int i = 6;
              finishrestart_ (&i, valori, blocchi);
              fine_lavoro();
              can_drag = TRUE;
           }
           return scelta;
       }
   }
   return 0;
}

/**************************************************************************************/
/*                  F i n d   S p a c e   G r o u p                                   */
/**************************************************************************************/

static GtkWidget *spacegroup_dialog = NULL;
typedef struct {
                 int start;
                 int quante;
               } _lines;
_lines *lines;

static int rowspace;

void sel_to_extinction (GtkTreeSelection *selec, GtkWidget *listagruppi)
{
   GtkWidget *framel, *listaspace, *altralista;
   int isel;
   int i, row;

   row = row_selected(selec);
   isel = (row != -1);
   if(listagruppi == get_widget(spacegroup_dialog, "extinctionlista2"))
      row += get_int(spacegroup_dialog, "nExt1");
   framel = get_widget(spacegroup_dialog, "frame_space");
   listaspace = get_widget(spacegroup_dialog, "spacelista");
   altralista = get_widget(listagruppi, "altra");
   rowspace = -1;
   if (isel)       /* selezione attiva sulla lista dei gruppi di estinzione */
   {
       GList *g_space = NULL;
       gtk_widget_set_sensitive(framel, TRUE);
       if(altralista != NULL)
       {
          int hnd = get_int(altralista, "hnd");
          g_signal_handler_block(G_OBJECT(
             gtk_tree_view_get_selection(GTK_TREE_VIEW(altralista))), hnd);
          unselect_all(GTK_TREE_VIEW(altralista));
          g_signal_handler_unblock(G_OBJECT(
             gtk_tree_view_get_selection(GTK_TREE_VIEW(altralista))), hnd);
       }
       std::string p = get_selected_row(listagruppi);
       if(lines[row].start < 0)
       {
           g_print ("Error in extinction groups\n\n\n\n");
       }
       else
       {
       for (i=0;i<lines[row].quante;i++)
       {
            std::string riga = It[lines[row].start+i];
            int loc = (int) riga.find( "Laue Class", 0 );
            if( loc == -1 )
                g_space = g_list_append(g_space, It[lines[row].start+i]);
       }       
       populate_listg(GTK_TREE_VIEW(listaspace), g_space);
       }
   }
   else            /* selezione disattivata */
   {
       gtk_widget_set_sensitive(framel, FALSE);
       clear_list(listaspace);
   }
}

void sel_to_spacegroup (GtkTreeSelection *selec, gpointer data)
{
       rowspace = row_selected(selec);
}

void selection_user(GtkWidget *widget, gpointer data)
{
   GtkWidget *combo, *framext, *framext2;
   GtkWidget *listaext;

   combo = get_widget(spacegroup_dialog, "spacebox");
   framext = get_widget(spacegroup_dialog, "frame_extinction1");
   framext2 = get_widget(spacegroup_dialog, "frame_extinction2");
   if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)))
   {
       gtk_widget_set_sensitive(combo, TRUE);
       gtk_widget_set_sensitive(framext, FALSE);
       if(framext2)
          gtk_widget_set_sensitive(framext2, FALSE);
       listaext = get_widget(spacegroup_dialog, "extinctionlista1");
       unselect_all(GTK_TREE_VIEW(listaext));
       listaext = get_widget(spacegroup_dialog, "extinctionlista2");
       if(listaext)
          unselect_all(GTK_TREE_VIEW(listaext));
   }
   else
   {
       gtk_widget_set_sensitive(combo, FALSE);
       gtk_widget_set_sensitive(framext, TRUE);
       if(framext2)
          gtk_widget_set_sensitive(framext2, TRUE);
   }
}

void help_spg(GtkButton *button, gpointer data)
{
    open_htm("data-module/#select"); //Whatsnew.html#SpaceGroup");
}

void c_statistics(GtkWidget *button, char *filnam)
{
using namespace gtkext;

  char *fil = g_strstrip(DuplicaStringa(filnam));
  text_window (GTK_WINDOW(gtk_widget_get_toplevel(button)), fil, "*.txt",
             IFREADONLY+IFMARKUP, "Statistics");
}

GtkWidget* create_spacedialog (int nSyst, bool kpseudo, char *filnam)
{
  GtkWidget *spacewin;
  GtkWidget *vbox1;
  GtkWidget *vbox2;
  GtkWidget *hbox1;
  GtkWidget *hbox2;
  GtkWidget *hbox3;
  GtkWidget *frame1;
  GtkWidget *frame2;
  GtkWidget *frame3;
  GtkWidget *button;
  GtkWidget *listext1;
  GtkWidget *listext2;
  GtkWidget *listspace;
  GtkWidget *combo;
  GtkWidget *entry;
  GtkWidget *ok_space;
  GtkWidget *cancel_space;
  int i;
  int vspace = 4;
  static const char *titles[] = {"Laue Class            ", "Extinction Group      ", "Fig. of Merit"};
  static const char *spacetitles[] = {"Space Groups   "};
  std::string titwin;

//TMP
      kpseudo = false;

  spacewin = gtk_dialog_new ();
/* gianluca 20 giugno 2011
  titwin.assign("Check space group in ");
  titwin.append(CrystSystem[nSyst]);
  titwin.append(" crystal system");
*/
  titwin.assign("Check space group");
  gtk_window_set_title (GTK_WINDOW (spacewin), titwin.c_str());

  vbox1 = gtk_dialog_get_content_area(GTK_DIALOG(spacewin));
  gtk_container_set_border_width (GTK_CONTAINER (vbox1), 4);

  hbox1 = hbox_new (FALSE, 0);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, TRUE, TRUE, 0);

//
// Prima lista
//

  frame1 = gtk_frame_new ("Select extinction group");
  g_object_set_data (G_OBJECT (spacewin), "frame_extinction1", frame1);
  gtk_widget_show (frame1);
  gtk_box_pack_start (GTK_BOX (hbox1), frame1, TRUE, TRUE, 0);
  gtk_container_set_border_width(GTK_CONTAINER(frame1), 6);

  vbox2 = vbox_new (FALSE, 0);
  gtk_widget_show (vbox2);
  gtk_container_add (GTK_CONTAINER (frame1), vbox2);

  listext1 = createSelectionM (spacewin, vbox2,titles, "lista_gruppi_estinzione", 3, "red");
  g_object_set_data (G_OBJECT (spacewin), "extinctionlista1", listext1);
  gtk_widget_set_size_request(get_widget(listext1, "frame"),-1,200);
  set_widget_fontN(listext1);
  gtk_widget_show (listext1);
  GList *columns = gtk_tree_view_get_columns(GTK_TREE_VIEW(listext1));
  for(i=0; i<(int)g_list_length(columns); i++)
  {
      GtkTreeViewColumn *tree_column = (GtkTreeViewColumn *) g_list_nth_data(columns, i);
      gtk_tree_view_column_set_sizing (tree_column, GTK_TREE_VIEW_COLUMN_AUTOSIZE);
  }
  g_list_free(columns);

//
// Seconda lista con pseudotraslazione
//
  if (kpseudo)
  {
    frame1 = gtk_frame_new ("Select extinction group (pseudo applied)");
    g_object_set_data (G_OBJECT (spacewin), "frame_extinction2", frame1);
    gtk_widget_show (frame1);
    gtk_box_pack_start (GTK_BOX (hbox1), frame1, TRUE, TRUE, 0);
    gtk_container_set_border_width(GTK_CONTAINER(frame1), 6);

    vbox2 = vbox_new (FALSE, 0);
    gtk_widget_show (vbox2);
    gtk_container_add (GTK_CONTAINER (frame1), vbox2);

    listext2 = createSelectionM (spacewin, vbox2, titles, "lista_gruppi_estinzione_pseudo", 3, "red");
    g_object_set_data (G_OBJECT (spacewin), "extinctionlista2", listext2);
    set_widget_fontN(listext2);
    gtk_widget_show (listext2);
    gtk_widget_set_size_request(get_widget(listext2, "frame"),-1,200);
    columns = gtk_tree_view_get_columns(GTK_TREE_VIEW(listext2));
    for(i=0; i<(int)g_list_length(columns); i++)
    {
        GtkTreeViewColumn *tree_column = (GtkTreeViewColumn *) g_list_nth_data(columns, i);
        gtk_tree_view_column_set_sizing (tree_column, GTK_TREE_VIEW_COLUMN_AUTOSIZE);
    }
    g_object_set_data(G_OBJECT(listext2), "altra", listext1);
    g_object_set_data(G_OBJECT(listext1), "altra", listext2);
  }
  else
     g_object_set_data(G_OBJECT(listext1), "altra", NULL);

//
// Lista gruppi spaziali
//
  frame2 = gtk_frame_new ("Select space group");
  g_object_set_data (G_OBJECT (spacewin), "frame_space", frame2);
  gtk_widget_show (frame2);
  gtk_box_pack_start (GTK_BOX (hbox1), frame2, TRUE, TRUE, 0);
  gtk_container_set_border_width(GTK_CONTAINER(frame2), 6);

  listspace = createSelectionM (spacewin, frame2, spacetitles, "lista_gruppi_spaziali", 1, "red");
  g_object_set_data (G_OBJECT (spacewin), "spacelista", listspace);
  set_widget_fontN(listspace);
  gtk_widget_show (listspace);

  hbox3 = hbox_new (FALSE, 0);
  gtk_widget_show (hbox3);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox3, FALSE, FALSE, 0);
  gtk_widget_set_sensitive(frame2, FALSE);

//
// Inserimento gruppo spaziale da parte dell'utente
//
  frame3 = gtk_frame_new (NULL);
  gtk_widget_show (frame3);
  gtk_box_pack_start (GTK_BOX (hbox3), frame3, TRUE, TRUE, 0);
  gtk_container_set_border_width(GTK_CONTAINER(frame3), 6);

  GtkWidget *hbox22 = hbox_new (FALSE, 0);
  gtk_widget_show (hbox22);
  gtk_container_set_border_width (GTK_CONTAINER (hbox22), vspace);
  gtk_container_add (GTK_CONTAINER (frame3), hbox22);

  button = CHECK_BUTTON_WITH_LABEL("User's space group", LABELCOLOR);
  g_object_set_data (G_OBJECT (spacewin), "spacebutton", button);
  gtk_widget_show (button);
  gtk_box_pack_start (GTK_BOX (hbox22), button, FALSE, FALSE, 0);
  gtk_container_set_border_width(GTK_CONTAINER(button), 6);
  g_signal_connect(G_OBJECT(button),"toggled",G_CALLBACK(selection_user),NULL);

  hbox2 = hbox_new (FALSE, 0);
  gtk_widget_show (hbox2);
  gtk_container_set_border_width (GTK_CONTAINER (hbox2), vspace);
  gtk_box_pack_start (GTK_BOX (hbox22), hbox2, FALSE, FALSE, 0);
  g_object_set_data (G_OBJECT (spacewin), "spacebox", hbox2);
  gtk_widget_set_sensitive(hbox2, FALSE);

  std::string filspg = g_strdup_printf( "%s%cfiles%c%s.spg",
       g_path_get_dirname(main_app::TheApp.PkgDataDir().c_str()), G_DIR_SEPARATOR, G_DIR_SEPARATOR, PK);
  int Silent = 1;
  combo = spgr_widget(filspg.c_str(), Silent);
  entry = get_widget(combo, "entry");
  g_object_set_data (G_OBJECT (spacewin), "space_group", combo);
  g_object_set_data (G_OBJECT (spacewin), "entry_spg", entry);
//  gtk_widget_set_size_request(combo, 110, -1);
  gtk_box_pack_start( GTK_BOX(hbox2), combo, FALSE, FALSE, vspace);

  frame3 = gtk_frame_new (NULL);
  gtk_widget_show (frame3);
  gtk_box_pack_end (GTK_BOX (hbox3), frame3, FALSE, FALSE, 0);
  gtk_container_set_border_width(GTK_CONTAINER(frame3), 6);

  GtkWidget *hbox23 = hbox_new (FALSE, 0);
  gtk_widget_show (hbox23);
  gtk_container_set_border_width (GTK_CONTAINER (hbox23), vspace);
  gtk_container_add (GTK_CONTAINER (frame3), hbox23);

  button = myimage_button ("_Statistics", "details.png");
  gtk_box_pack_start( GTK_BOX(hbox23), button, FALSE, FALSE, vspace);
  g_signal_connect(G_OBJECT(button),"clicked",
         G_CALLBACK(c_statistics),filnam);
//
// Bottoni OK e CANCEL
//

  button = HELP_button();
  gtk_dialog_add_action_widget(GTK_DIALOG(spacewin), button, GTK_RESPONSE_HELP);

  ok_space = myimage_button ("   _OK", "ok.png");
  gtk_dialog_add_action_widget(GTK_DIALOG(spacewin), ok_space, GTK_RESPONSE_OK);

  cancel_space = myimage_button("  _Cancel", "cancel.png");
  gtk_dialog_add_action_widget(GTK_DIALOG(spacewin), cancel_space, GTK_RESPONSE_CANCEL);
  (void) g_signal_connect (G_OBJECT (button), "clicked",
         G_CALLBACK(help_spg), NULL);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(ok_space)),
          GTK_BUTTONBOX_SPREAD);

  int hnd = g_signal_connect(G_OBJECT(gtk_tree_view_get_selection(GTK_TREE_VIEW(listext1))),
               "changed", G_CALLBACK(sel_to_extinction),listext1);
  g_object_set_data (G_OBJECT (listext1), "hnd", GINT_TO_POINTER(hnd));

  if (kpseudo)
  {
      hnd = g_signal_connect(G_OBJECT(gtk_tree_view_get_selection(GTK_TREE_VIEW(listext2))),
            "changed", G_CALLBACK(sel_to_extinction),listext2);
      g_object_set_data (G_OBJECT (listext2), "hnd", GINT_TO_POINTER(hnd));
  }
  g_signal_connect(G_OBJECT(gtk_tree_view_get_selection(GTK_TREE_VIEW(listspace))),"changed",
           G_CALLBACK(sel_to_spacegroup), NULL);

  return spacewin;
}

void populate_listgv(GtkTreeView *list, GList *values[], int numlists,
                     int ista, int iend)
{
    GtkListStore *list_store;
    GtkTreeIter iter;
    char *entry;
    int i, j, numval;

    list_store = GTK_LIST_STORE(gtk_tree_view_get_model(list));
    gtk_list_store_clear(GTK_LIST_STORE(list_store));
    if(iend == -1)
       numval = g_list_length(values[0]);
    else
       numval = iend;
    for(i=ista; i<numval; i++)
    {
        entry = (char *)g_list_nth_data (values[0], i);
        if(entry && strlen(entry))
        {
           gtk_list_store_append (list_store, &iter);
           for(j=0; j<numlists; j++)
           {
               entry = (char *)g_list_nth_data (values[j], i);
               gtk_list_store_set (list_store, &iter, j, entry,-1);
           }
        }
    }
}

extern "C" int selectgroup_(int numbExt[], int *numbSpg, int gs1[], int gs2[],
                            int *sys, char *filnam)
{
  int i, nExt = numbExt[0] + numbExt[1], nspg = *numbSpg;
  int nSyst = *sys;
  GList *g_extinction[3];
  float symop_r[3];
  
  for(i=0; i<3; i++)
      g_extinction[i] = NULL;

  lines = g_new0(_lines, nExt);

  for (i=0;i<nExt;i++)
  {
       g_extinction[0] = g_list_append(g_extinction[0], g_strstrip((char *) get_nth_field(It[i+nspg], ";",1,'s')));
       g_extinction[1] = g_list_append(g_extinction[1], g_strstrip((char *) get_nth_field(It[i+nspg], ";",2,'s')));
       g_extinction[2] = g_list_append(g_extinction[2], g_strstrip((char *) get_nth_field(It[i+nspg], ";",3,'s')));
       lines[i].start  = gs1[i]-1;
       lines[i].quante = gs2[i]-gs1[i]+1;
  }
  rowspace = -1;

  spacegroup_dialog = create_spacedialog(nSyst+1, (numbExt[1] > 0), filnam);
  g_object_set_data(G_OBJECT(spacegroup_dialog), "nExt1", GINT_TO_POINTER(numbExt[0]));

  populate_listgv(GTK_TREE_VIEW(get_widget(spacegroup_dialog, "extinctionlista1")),
                  g_extinction, 3, 0, numbExt[0]);
  if(numbExt[1])
      populate_listgv(GTK_TREE_VIEW(get_widget(spacegroup_dialog, "extinctionlista2")),
                  g_extinction, 3, numbExt[0], nExt);
  gtk_window_set_transient_for(GTK_WINDOW(spacegroup_dialog), GTK_WINDOW(finestre[0]));
  int ret_val = -2;
  setSmiley(finestre[0], "smil5.gif");
  while(ret_val == -2)
  {
       GtkWidget *but;
       int irisp = gtk_dialog_run(GTK_DIALOG(spacegroup_dialog));
       switch(irisp)
       {
       case GTK_RESPONSE_OK:
            but = get_widget(spacegroup_dialog, "spacebutton");
            if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(but)))
            {
                GtkWidget *entry = get_widget(spacegroup_dialog, "entry_spg");
                if(check_spacegroup(entry, spacegroup_dialog, symop_r) >= 0)
                {
                   ScriviStringa(It[nspg+nExt], sizeof(stringa), "%-16.16s", 
                         g_strstrip(combo_get_text(entry)));
                    ret_val = 0;
                }
            }
            else 
            {
                char *riga = get_selected_row(get_widget(spacegroup_dialog, "lista_gruppi_spaziali"));
                if(riga == NULL)                                   /* nessuna selezione sulla lista */
                   MessageDialog(spacegroup_dialog, GTK_MESSAGE_WARNING, GTK_BUTTONS_CANCEL, 
                        "You must select a space group! ");
                else
                {
                   ScriviStringa(It[nspg+nExt], sizeof(stringa), "%-16.16s", g_strstrip(riga));
                   if(get_selections(get_widget(spacegroup_dialog, "extinctionlista1")))
                      ret_val = get_selected_row_num(get_widget(spacegroup_dialog, "extinctionlista1")) + 1;
                   else 
                      ret_val = get_selected_row_num(get_widget(spacegroup_dialog, "extinctionlista2")) + 1;
                }
            }
            break;
       case GTK_RESPONSE_CANCEL:
       case GTK_RESPONSE_DELETE_EVENT:
            int ier = MessageDialog(spacegroup_dialog, GTK_MESSAGE_QUESTION, GTK_BUTTONS_YES_NO, 
                                    "Do you want stop the run?");
            if (ier == GTK_RESPONSE_YES)
            {
                CopiaStringa(It[nspg+nExt], 60, "                ");
                ret_val = -1;
            }
            break;
       }
  }
  gtk_widget_destroy(spacegroup_dialog);
  resetSmiley(finestre[0]);

  if((np_dialog != NULL) && gtk_widget_get_visible(np_dialog))               // arriva qui dal new project
  {
      GtkWidget *entry;

      if(ret_val != -1)               // mr100609
      {
//          entry = get_widget(np_dialog, "radio_find");
//          gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry), FALSE);
          entry = get_widget(np_dialog, "entry_spg");
          gtk_entry_set_text(GTK_ENTRY(entry), It[nspg+nExt]);
          entry = get_widget(np_dialog, "accept0");
          gtk_button_clicked(GTK_BUTTON(entry));
          for(int i=2; i<4; i++)
          {
              ShowPage(np_dialog, i);
              change_pag(i, FALSE);
          }
      }

  }
  return ret_val;
}

void riempi_listaC(GtkWidget *lista, int nlines)
{
  char *rigacom[3];

  clear_list(lista);
  const char *riga = "Automatic";
  add_line_to_list(lista, (gpointer) riga);
  for(int i=0; i<nlines; i++)
  {
     get_str_tokens(It[i], "@", 3, rigacom);
     for(int j=0; j<3; j++)
         g_strstrip(rigacom[j]);
     add_line_to_listM(lista, rigacom);
   }
}


extern "C" void getcrystfamilyfromgraphic_(float cella[], int *indice, 
                                           int *nrighe, int *out)
{
   int nlines = *nrighe;
//
// TEST ONLY
//   *out = 1;  // Automatic
//   *out = 3;  // Monoclinic a
//   *out = 10;  // Rhomboedric
//      
// Titolo:     Crystal System selection
//      
//       No space group symbol supplied;
//       it will be determined on statistical basis.
//      
//       The Crystal System deduced from the cell constants
//               a = ...  b = ...    c = .. 
//           alpha = ...  beta = ... gamma = ... 
//       is
//              CrystSystem[*indice]     
//
//       It is possible to select a different Crystal System:
//              LISTA
//      
//          +----------+             +----------+
//          |   OK     |             |  CANCEL  |
//          +----------+             +----------+
//      
//      
//       Se OK, in *out deve essere messa la posizione della riga selezionata
//       Se CANCEL, in *out deve essere messo 1

  GtkWidget *dlg = gtk_dialog_new();
  gtk_window_set_title (GTK_WINDOW (dlg), "Crystal System selection");

  GtkWidget *vbox = gtk_dialog_get_content_area(GTK_DIALOG(dlg));
  gtk_container_set_border_width (GTK_CONTAINER (vbox), 8);

  GtkWidget *table1 = table_new (6, 6, FALSE);
  gtk_widget_show (table1);
  table_set_row_spacings (table1, 10);
  table_set_col_spacings (table1, 4);
  gtk_box_pack_start(GTK_BOX(vbox), table1, FALSE, FALSE, 10);
  gtk_container_set_border_width (GTK_CONTAINER (table1), 10);

  GtkWidget *label = LABEL_NEW("No space group symbol supplied;"
             " it will be determined on statistical basis.\n"
             "The Crystal System deduced from the cell constants\n", NULL);
  gtk_widget_show (label);
  set_alignment(label, 0., 0.5);
  gtk_label_set_justify (GTK_LABEL (label), GTK_JUSTIFY_FILL);
  table_attach( table1, label, 0, 6, 0, 1, TRUE);

  for(int k = 0; k<2; k++)
  {
      for(int j = 0; j<6; j++)
      {
           int kl = k * 3 + j/2;
           if((j % 2) == 0)                     /* label */
           {
               label = LABEL_NEW (cell_data[kl], LABELCOLOR);
               gtk_widget_show (label);
               table_attach_exp(table1, label, j, j+1, k+1, k+2);
               set_alignment(label, 1.0, 0.5);
           }
           else                                 /* value */
           {
               label = LABEL_NEW (g_strdup_printf("%7.4f",cella[kl]), LABELCOLOR);
               gtk_widget_show (label);
               table_attach_exp(table1, label, j, j+1, k+1, k+2);
               set_alignment(label, 1.0, 0.5);
           }
      }
  }

  GtkWidget *hbox = hbox_new(FALSE, 0);
  label = LABEL_NEW("is: ", NULL);
  set_alignment(label, 0., 0.5);
  gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
  label = LABEL_NEW(CrystSystem[*indice], LABELCOLOR);
  set_alignment(label, 0., 0.5);
  gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
  table_attach( table1, hbox, 0, 5, 4, 5, TRUE);

  label = LABEL_NEW("It is possible to select a different Crystal System:", NULL);
  gtk_widget_show (label);
  set_alignment(label, 0., 0.5);
  table_attach( table1, label, 0, 5, 5, 6, TRUE);

#ifdef IN_GTK3
  GtkWidget *align = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_FILL, FALSE, TRUE);
#else
  GtkWidget *align = gtk_alignment_new(0.5, 0.5, 0.,1.);
#endif
  gtk_widget_show (align);
  gtk_box_pack_start(GTK_BOX(vbox), align, TRUE, TRUE, 0);
  const char *colonne[] = {"Crystal System", "Laue Class", "Probability"};
  GtkWidget *list1 = createSelectionM(dlg, align, colonne, "listaCS",
          sizeof(colonne)/sizeof(colonne[0]), MyBLUE);
  set_selection_mode(list1, GTK_SELECTION_SINGLE);
  PangoFontDescription *fontd = get_fontN(MONOSPACE_FONT);
  widget_modify_font(list1, fontd);
   
  for(int j=0; j<(int)(sizeof(colonne)/sizeof(colonne[0])); j++)
  {
      GtkTreeViewColumn *col = gtk_tree_view_get_column(GTK_TREE_VIEW(list1), j);
      widget_modify_font(gtk_tree_view_column_get_widget(col), fontd);
  }
  int alt, lar;
  get_metrics(fontd, &lar, &alt);
  gtk_widget_set_size_request(get_widget(list1, "frame"), -1, (int)MRmin(1.7f*(nlines+1)*alt, 15*alt));
  riempi_listaC(list1, nlines);

  GtkWidget *ok = OK_button();
  gtk_dialog_add_action_widget(GTK_DIALOG(dlg), ok, GTK_RESPONSE_OK);

  GtkWidget *cancel = CANCEL_button();
  gtk_dialog_add_action_widget(GTK_DIALOG(dlg), cancel, GTK_RESPONSE_CANCEL);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(ok)),
          GTK_BUTTONBOX_SPREAD);

  gtk_widget_show_all(dlg);
  int result = gtk_dialog_run(GTK_DIALOG(dlg));
  if(result == GTK_RESPONSE_OK)
  {
     *out = row_selected(gtk_tree_view_get_selection(GTK_TREE_VIEW(list1)));
     if(*out < 0)
        *out = 0;
  }
  else
     *out = 0;
  gtk_widget_destroy(dlg);
}

