!-----------------------------------------------------------------------
      MODULE Psi0Stuff
           integer, allocatable :: ktheta(:)
           real,    allocatable :: alphap(:)
cdedi
           real,    allocatable :: alphapsi0(:)
           real,    allocatable :: alphapsi0_rif(:)
           real,    allocatable :: alphapsi0_sav(:)
cdedi
           real,    allocatable :: a0est(:)
           real,    allocatable :: a0var(:)
           integer, allocatable :: jph0(:)
           integer, allocatable :: limref0(:)
           integer, allocatable :: klim0(:)
           integer, allocatable :: nbinv0(:)
           real,    allocatable :: ee0(:)
           real,    allocatable :: alpha0(:)
           integer, allocatable :: ntr0(:)
      END MODULE Psi0Stuff
!-----------------------------------------------------------------------
      MODULE Riflessi_Pub
             real, allocatable    :: Epub(:)
             real, allocatable    :: Fpub(:)
      END MODULE Riflessi_Pub
!-----------------------------------------------------------------------
      subroutine AllocaRiflessi_Pub(iAction)
      USE General
      USE Riflessi_Pub
!
!-- Allocate Reflections arrays  -- Versione DEDI
!
      implicit none
      integer  :: iAction, ier, ierv(2)
!
      ierv(:) = 0
      if (iAction == 1) then
         if (.not. allocated(Epub))
     *     allocate (Epub(1:nreflDim) ,stat = ierv( 1))
         if (.not. allocated(Fpub))
     *     allocate (Fpub(1:nreflDim) ,stat = ierv( 2))
!
         ier = sum(iabs(ierv(:)))
         if (ier /= 0) then
             write(*,*) 'Riflessi_Pub Allocation error'
             call cstop(' ')
         endif
!
         Epub(:) = 0.0
         Fpub(:) = 0.0
!
      else
         if (allocated(Epub)) then
               deallocate(Epub , stat=ierv( 1))
               deallocate(Fpub , stat=ierv( 2))
         endif
         ier = sum(iabs(ierv(:)))
         if (ier /= 0) then
             write(*,*) 'Riflessi_Pub DeAllocation Error'
             call cstop(' ')
         endif

      endif
!
      return
      end
!------------------------------------------------------------------------------
      subroutine Contan(ier, ksubr, ifFromGraphic)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Molcom          
      USE PhaseStuff
      USE Mappa
      USE Grafici
      USE HistoStuff
      USE Html
      USE Param
      USE MadModule
      USE PhaseModule
      USE RfacMatrixModule
      USE TestModel
      USE Migliore
      USE RemoModule
      USE Direttive
      USE grexpomod, only : fortran_work
      USE VLDmod
      USE VLDmod_3       ! x VLD
      USE RelaxMod
!
! -----                              
!
      common /modifica_effe/ modf
      common /LoopC/ Loop
      common /tagliafo/ sogliafofc
      common/dir10/numk,ntrs,ntr10,sogpo,sogne,nupos,nuneg,
     1 indpo,indne,nmxtn
      common /GedmCommon/ ifGedm, cicliFour, nBatch, nGedm,
     *                    ifCMap, CMapVet(3)
c
      integer HoScritto
      character*256 filet
      real nwTmp(18),x_cp(3)
!
      logical Esiste
!mr
      interface
         subroutine MiglioriErre(iAction, trial, trialv, erreV, str)
         USE General, only: MyStringa
           integer   :: iAction
           type(MyStringa), optional  :: str(*)
           integer, optional :: trial
           integer, optional :: trialv(*)
           real, optional    :: erreV(*)
        end subroutine MiglioriErre
       end interface
!end mr
!formula20
c     ifForm20 = 0
*     nRfacMatrix   = 600
*     nRfacMatrixBl = 30
*     call AllocaRfacMatrix(1)
!
      if (sum(nw(:)) == 0) then
          Msg = 'No cell content supplied. Program aborted.'
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          ier = -1
          return
      endif

      if(kverbo>0) call CPUTime0('inizio Contan ')
!
!--creo default condizioni affinamento 
!
      call DefaultRefi(2,ier)
!
      hsol = 0.0
      hFom = 0.0
      ipreb = 0
      nrefB = 0
      krecy = 0
      HistoOK(:) = 0
!
      call scrper(' ', 0, -1)
!
!-- per tenere in memoria le origini del gruppo spaziale originario
!-- utilizzate in relax
!
      nOrigRoxiRoc=nOrigRoxi
      taboRoc(:,:)=tabo(:,:)

      if (knw == 1 .and. kverbo == 1) then
          write(lo,'(//,a,i5)') ' Tabo =',nOrigRoxiRoc
      endif
      do i1=1,nOrigRoxiRoc
         do j1=1,3
            x_cp(j1)=taboRoc(i1,j1)
         end do
         if (knw == 1 .and. kverbo == 1)  write(lo,*) x_cp
      end do

! modifiche per taboroc
! modifiche necessarie
      
      call EstendiOriginiPermesse
      
      if (knw == 1 .and. kverbo == 1) then
          write(lo,'(//,a,i5)') ' TaboRoc =',nOrigRoxiRoc
      endif
      do i1=1,nOrigRoxiRoc
         do j1=1,3
            x_cp(j1)=taboRoc(i1,j1)
         end do
         if (knw == 1 .and. kverbo == 1)  write(lo,*) x_cp
      end do

      nOrigRoxi=nOrigRoxiRoc
      tabo(:,:)=taboRoc(:,:)

!
      costanteMatthews = 1.23  ! valore utilizzato da liberato (ab-initio)
      Iterazione = -999
!
      numbModels = 1
      WhichModel = 1
      MonomerInModel(WhichModel) = 1
      ifNegativePeaks = 0
      percNegativePeaks  = 0
      natsNeg = 0
      if (neutro == 1) then
          asum = sum(nw(1:nk))
          bsum = 0.0
          do i=1, nk
             if (cl(i) < 0) then         
                 ifNegativePeaks = 1
                 bsum = bsum + nw(i)
             endif
          enddo
          if (ifNegativePeaks == 1) then
              percNegativePeaks = bsum / asum
          endif
      endif
!     CoefFom = 0.0
      TrerreBest = -99
      Imported = 0
      ifBreak = 0
      waveare = 0.0
      exposigma = 2.0
      cicloEDM = 0
      f000 = 0.0
      QualeAbilita = 0
      corre = 0.5
      istat=0
      iform=1
      iPlotTypeSWRC = iPlotType
!
!      if (ksubr.eq.3.and.ifFromGraphic.eq.0) then    !pgVLD
!          call RoutineHeader('Phase')                !pgVLD
!      endif                                          !pgVLD
!
! -- Inizializzazioni
!
      call AllocaGrafici(2, 0, ifTang)
!
      if (kmad == 2) then   !! verificare per il caso MAD
          RSoglia = 0.0
      endif
      natm = nint( anat )
      natm = max0(natm, nk)
      nats = natm
      numbModels = 2
      call AllocaAtomi(1)
      BondsInModel(:) = MaxBonds
      call AllocaBonds(1)
      if (numbGen  == 0) then
          ihmxSav=ihmx
          ifat1=(2*ihmx(3)+1)*(2*ihmx(2)+1)
          ifat2=(2*ihmx(3)+1)
          ifatx=ihmx(1)*ifat1+ihmx(2)*ifat2+ihmx(3)
      else
          ihmxSav=ihmx
          ifat1=(2*ihmxExt(3)+1)*(2*ihmxExt(2)+1)
          ifat2=(2*ihmxExt(3)+1)
          ifatx=ihmxExt(1)*ifat1+ihmxExt(2)*ifat2+ihmxExt(3)
      endif
      numbGenSav=numbGen
**    call AllocaInvarStuff(1)
      call AllocaIsr(1)
      averlar = -9999
      errem = 9999
      BestRatVet(1:8) = -9999.9
      ntrSv = 0
      nFour = 0
      nBias = 0
      if (nsym.eq.1.and.icent.eq.0) then
          ifP1 = 1
      else
          ifP1 = 0
      endif
      WhichFom = 2
      HoScritto = 0
      ier = 0
      nEmod = 0
c--
      nstrP1 = nstr
      nrun = 0
      if (jrest /= 0 .and. allocated(RfacMatrix)) then
          do i=1,nRfacMatrix
             if (RfacMatrix(1, i,jBlock).gt.0) then
                 nRfac = i
             endif
          enddo
          if (nRfac > 0) then
              FomsMin = RfacMatrix(2, nRfac,jBlock)
          endif
          if (jrest == 2) then
              jRfac = 0
              do i=1,nRfac
                 if (nint(RfacMatrix(1,i,jBlock)).eq.itria) then
                     jRfac = i
                 endif
              enddo
              if (jRfac ==0) then
                  nRfac = 1
                  RfacMatrix(1,1,1) = itria
              endif
          endif
          if (jrest.eq.1) then
              jRfac = nRfac
              nrun  = nRfac
              MaxRun = MaxRun + nrun
              numbTrials = 0
          else
              do i=1,nRfac
                 if (nint(RfacMatrix(1,i,jBlock)).eq.itria) then
                     jRfac = i
                 endif
              enddo
          endif
      else
          FomsMin = 999999
          nRfac = 0
      endif
      write(SpaceGroup,'(16a1)') nSpaceG

      call ControllaAtomiPesanti(NumPeso)
      call AllocaPherrMod(1)
      call dirpha(ifFromGraphic, ifTest, filet, ier)
!
!-- Gestione dei file da exportare automaticamente (shelx o pdb)
!
      natsExportLimit = 300
      if (ifExportShelx < 0) then
          if (nint(anat) > natsExportLimit .or. ksize_vero >= 4) then
              ifExportShelx = 0
          else
              ifExportShelx = 1
          endif
      endif
      if (ifExportShelx == 0) then
          ExportExtension = 'pdb'
      else
          ExportExtension = 'res'
      endif
!
      nstr = nstr_data
      if (ifMDM == 1) then
!pg0602014          
          nstr = nstr * 0.8               ! prova per SelAlfa
          if (ksize_vero >=  4) then
              nstr = nstr_MDM                 ! prova per SelAlfa
          end if
          call UpdateReflInfo
          if (InfoOK(8) /= 0) then
              nstrSav = nstr
          endif
      endif
!
**    if (nScan <= 1) then
      if (MAD_posi == 0) then
          call MiglioriErre(0)
      endif
**    endif
c     if (ifVLD == 1) then
c         ifPatt = 0
c         ifTang = 0
c     endif
!pgVLD
      if (ksubr.eq.3.and.ifFromGraphic.eq.0) then
          if (FichierIn(1:1) == ' ') then 
              call RoutineHeader('Phase')
          endif
      endif
!pgVLD
      call VolumeProteina()
      call WhiteBoard
      if (ier.lt.0) return
!
!-- remove old .LOG file
!
      k = index(fname(1),'.bin')
      Inte = fname(1)(1:k-1) // '.log'
      inquire (file=Inte,  exist = Esiste)
      if (Esiste) then
          istat = 2
          iform = 1
          jop = jopen(ktml,Inte,istat,iform,ierr)
          close(ktml, status='delete',err=9000)
      endif
!
!--gestione dei blocchi nel riciclo dei trials
!
      npunti = sum(jBlocksPh(1,:))
      if (kmad == 2) then
          npunti = npunti * nDataSets
      endif          
      if (jscreen > 0) then
          kLarg = kscrx
          kAlt  = kscry
          stepGR = 1.5 * FntPixHeight / float(kAlt)
          stepGR0 = 1.0
      endif
      call AllocaGrafici(1, npunti, ifTang)
!
**    call AllocaInvarStuff(1)
      call AllocaIsr(1)
!
      if (ifFromGraphic == 1) then
          erreBest = 9999.9
!GL!      if (ifPatt == 1 .and. ntria /= 1) then
          if (ifPatt == 1                 ) then
              call DefinePattTrials()
          endif
      endif
!
      if (MAD_posi == 0) then
          call Init_RfacMatrix
      endif
!
*     call AllocaRiflessiSIGMAA(1)
*     if (kmad == 0) then                !!   DA ELIMINARE   !!
*         do i=1, nreflDim
*            fovet_mod(i) = fovet(i) * exp( bt * rhov(i) )
*         enddo
*     endif
!
      if (jscreen.gt.0) then
          if (nBlocksPh.le.0) then
              call AbilitaSkipeStop()
          endif
          if (jrest.eq.0) then
              ifLabels  = 0
              call reset_plot_style
          endif
      endif
!
!-- check if a model has to be loaded
!
*     call CheckModelToLoad(ier)
*     if (ier < 0) return
!
      call NewCheshire(1)
      call CheshireTra()
      if (kmad == 2) then
          nCicliPhase = nDataSets
      else
          nCicliPhase = 1
      endif
!pgMAD
         if (kmad.ne.0) then
             if (kmad.eq.1) then
                 s3s2 = s3s2mad
             end if
             call outFrag(0, numset, ifBreak)
         end if
!pgMAD
!
      ifPattSav = ifPatt
      numbtrialsSav = numbtrials
      do WhichDeriv =1, nCicliPhase
         fomBest  = -9999.9
         fomBestE = -9999.9
         lPlots(:) = 0
         if (kmad == 2) then
             s3s2 = s3s2d(WhichDeriv)
             is3s2=1./(s3s2*s3s2)+0.5
             numR = 0
             ilist = 8
             call Cancella(ilist)
             natsSav = nats
             call AllocaAtomi(2)
             nats = 3500
             call AllocaAtomi(-1)
             natsSav = nats
             numFragsMad = 0 
             ifPatt = ifPattSav
             numbtrials = numbtrialsSav
             call GetFromAtmStruct
             do i=1, nk
                if (kAnom(WhichDeriv) == nalf(i)) then
                    no(1) = no(i)
                    nw(1) = nw(i)
                    cl(1) = cl(i)
                    al(1:4,1) = al(1:4,i)
                    bs(1:4,1) = bs(1:4,i)
                    nalf(1) = nalf(i)
                    if (knw == 1) then
                        write(6,'(a,a2)') 'CICLO SUI DERIVATI ',nalf(1)
                    endif
                    exit
                endif
             enddo
             nk = 1
             anat = float(nw(1)) / (pts*float((icent+1)*nsym))
             ksize = 2
             call outFrag(-1, numset, ifBreak)
         endif
!- prova Falini
c                 nrefl = nrefl + Added
c                 Added = 0
c                 call UpdateReflInfo
!- prova Falini
         if (numbGen == 0) then
             call LeggiRiflessi(ier,ksubr)  ! lettura normale
*           do i=1, nrefl
*              write(6,*) i,khl(:,i),evet(i)
*           enddo
*           stop 1313
c              do i = 1, nreflDim     ! per Dritan
c                write(999,'(3i4,2f15.3)')
c    *                 khl(:,i),evet(i),rhov(i)
c             enddo
c             stop 9999
         else
c           call LeggiRiflessi(ier,6)  ! ordina i riflessi interni secondo E
            call LeggiRiflessi(ier,33)  ! lascia invariati i riflessi interni
            if (knw == 1) then
c               call F2E_Pub()
                sss = sum(fcvet(1:nreflDim)) 
                if (sss > 0.00001) then
                    call RinormalizzaPubblicati()
                    call StatRfac_PubAdd(ier)
                endif
            endif
!           ifRelax = -2
!           relaxReq = ifRelax
!
            call Init_Canalizzazione()
!
         endif
c
         if (kmad == 2) then
             call SortMir
             if (knw.gt.0) then
                call SFCalc_mir()
            endif
         endif
         call InitGiw()
         call CheckGrid()

         nstartTang = nstr / 4
         if (kmad == 1) then  
             nstartTang = nstr / 2
c        else                          ! dedi
         elseif (ifTang == 1) then
            if (ifOldFoms == 0 ) then
                if (icent == 1) then
                    if (LowRes == 0) then
                         nstartTang = nstr / 3
                    else
                         nstartTang = nint(float(nstr) / 2.5)
                    endif
                else
                    nstartTang = nstr / 4
                endif
            else
                if (icent == 1) then
                    nstartTang = nstr / 3
                else
                    nstartTang = nstr / 2
                endif
            endif
            if (nint(anat) < 10) then
                nstartTang = nstr / 2
            endif
            if (neutro == 2) then
                nstartTang = nstr / 2
            endif
         endif

         call InitSigmaA(1)
         call AllocaMappa(1)
         if (knw == 1) then
             call AllocaTestStuff(1)
         endif
         if (ifVLD == 0) then                                           !pgVLD
             if (jpfile == 0) then
                 if (kmad /= 1 .or. ifTang == 1) then
                     ifInvar = 1
                     call InitPhase(ifTest, ier)
                 end if
             end if
!modifiche controllate
            ksize_vero = ksize
            if(ifMDM == 1) then
              esaltaPatt = 0
              ifVLD = 1
              ksize_vero = ksize
              if (ksize == 3) then
                ksize = 4
                nolsq = 0
                call UpdateReflInfo
              endif
            end if


         end if                                                         !pgVLD
!
         if (ier.lt.0) return
!
         if (ifVLD == 0) call Define_Iteration()
!
         call CreavettoreSigma()
!
         if (WhichDeriv == 1 .and. MAD_posi == 0) then
             call WritePhaseInfo(ntot)
             if (kmad == 0) then
                 call AbInfo(0)
             endif
         endif
         call WriteBlocksInfo(ifFromGraphic)
         numbPse = 0
         InfoOK(19) = 0
!
!-- initialize final phases structures and file 
!
         if (kmad == 0) then
             k = index(fname(1),'.bin')
             kk = kStripTask1(k)
             Buffer1 = fname(1)(1:kk-1) // '_SIR200x.pha'
             itype = 2
             iform = 1
             jop =jopen(jgrap,Buffer1,itype,iform,ios)
             if (jop >= 0) then
                 close(jgrap, status = 'delete')
             endif
!gl!         call nfrm17()
             call ManageFinalPhases(1, nReflDim, nSetsMaxFineDSR)
!gl!         call sfl17()
             call LoadFinalPhases(FomsFineDSR, iposFineDSR,
     *                            nsetFinalPhases)
         endif
         nSetsFineDSR = 0
c

         if (jscreen.ne.0) then
             call InitMolplo
         endif
         if (jpfile /= 0 .and. MAD_posi == 0) then
             numbrun = 1
             erreBest = 9999.9
             import = kQualeFormato(filet)
             istat2=0
             istat=2
             iform=1
             k = jopen(jhost,filet,istat,iform,ier)
             if (import.eq.1) then
                 call ManageShelxSir(ifRefl, 0, nwTmp, ier)
                 call GetModel
                 BTot(:,:) = 0; BTot(1,1) = 1
                 BTot(2,2) = 1; BTot(3,3) = 1
             elseif (import.eq.2) then
                 call ManagePDBSir(0, 1, 1, 0, 0, ier)
                 call GetModel
                 BTot(:,:) = 0; BTot(1,1) = 1
                 BTot(2,2) = 1; BTot(3,3) = 1
*             elseif (import.eq.3) then
*                 call LeggiCaos(ier)
             elseif (import.eq.4) then
*?*              call LeggiCIF(ifRefl, 0, ier)
                 call LeggiCIF(ifRefl, 1, ier)
                 BondsInModel(WhichModel) = 0
                 call GetModel
             else
                 call getplt(0, 0, ier)
                 call PutModel
             endif
             close(jhost)
!
             bSav(:) = bfac(:)
!
             call GetFromAtmStruct
!
*gl*  call ScriviFrammento
!
             if (ier.lt.0) return
             if (neutro == 1) then
                 xyzNeutrons(1:5,1:nats) = xyzs(1:5,1:nats)
             endif
             if (import.ne.0) then
                 call AggiungeConnettivita(5, ier)
                 if (ier < 0) return
             endif
             MaxRun = 1
             if (neutro == 2 .and. modf == 1) then
                 call ModificaFobs
             endif
         endif
c
         percMap   = -9999.9
         percMap_n = -9999.9
         erreOpt = 999.9
         kWstop = 0
         nuset = 0
c
         if (ksubr.eq.3) then
             if (jpfile <= 0) then
                 call Cancella(5)
                 call Cancella(12)
                 call Cancella(15)
                 bij = 0.0
             endif
             if (jrest.ne.2) then
                 ilist= 34
                 call Cancella(ilist)
             endif
         endif
         if (jpfile == 0) then
             ilist=15
             call Cancella(ilist)
         endif

!
         if (nrefltot > 0 .and. kmad == 0) then
             call LoadReflInfo         !!!!!!!!! ATTENZIONE  a iyrand 
             if (jproc == 0 .or. ifVLD == 1) then
                 iyrand = 67543
             endif
         endif
!
*        call AllocaTestStuff(1)
         call InitFour(ifFromGraphic,ier)
         if (ier.lt.0) return
c
*        if (kWriMap.ge.0.and.knw.gt.0) then
*            MapNumber = 0
*            iGiaFatta = 0
*            if (iWrimap == 0) then
*                numbM = nstr
*            else
*                numbM = numbLSQ
*            endif
*            do i=1,numbM
*               fcoef(i) = evet(i)
*               wt(i) = 1.0
*               iphaz(i) = ipub(i)
*            enddo
*            write(0,*) 'Mappa vera per Xtal'
*            call Scrivi_Mappa_Xtal(numbM,MapNumber,xmap_div,iGiaFatta)
*            kWriMap = 0
*        endif
!
!
!--  calcolo la Fourier Vera e controllo la presenza degli atomi pesanti sulla mappa
!
!        iff = 1  ! Fobs
!        call Calcola_Fourier_Vera(iff)
!        write(6,*) 'StatErre_perShell in PHASE'
!        call StatErre_perShell(numbLSQ)
!
c
         wt = 0.0
c
!
         if (WhichDeriv == 1) then
             if (ifMadEnv /= 0) then
                 if (ifVLD == 0 .or. ifMDM == 1) then
                     ifResetLab = 0
                     k = kridisegna(kscrx, kscry, ifResetLab)
                 endif
                 if (ifVLD == 0  .and. MAD_posi == 0) then
                     Msg = "<big><b>Initial phasing:</b></big>"
                     call TestoGR(Msg, color_RED, 2, 2)

                     if (ifPatt == 0) then
                         write(Msg,9056) nstr
                         call TestoGR(Msg, -1, 2, 2)
                     else
                         if (kmad == 0) then
                             write(Msg,9057) 
                             call TestoGR(Msg, -1, 2, 2)
                             write(Msg,9067) 
                             call TestoGR(Msg, -1, 2, 2)
                         else
                             write(Msg,8057) 
                             call TestoGR(Msg, -1, 2, 2)
                             write(Msg,8058) 
                             call TestoGR(Msg, -1, 2, 2)
                             write(Msg,8059) 
                             call TestoGR(Msg, -1, 2, 2)
                         endif
                     endif
                 else
                     if (ifMDM == 0) then
                         Msg = "<big><b>VLD procedure:</b></big>"
                     else
                         Msg = "<big><b>MDM procedure:</b></big>"
                     endif
                     call TestoGR(Msg, color_RED, 2, 2)
                     if (ifMDM == 0) then
                         write(Msg,9058) n_Maxrun
                     else
                         write(Msg,9068) n_Maxrun
                     endif
                     call OneBlankOnly(Msg)
                     call TestoGR(Msg, -1, 2, 2)
                     if (ifMDM == 0) then
                         write(Msg,9059) n_cicli
                         call OneBlankOnly(Msg)
                         call TestoGR(Msg, -1, 2, 2)
                     endif
                     write(Msg,9060)
                     call TestoGR(Msg, -1, 2, 2)
                     stampa_stopFinalFom2 = stopFinalFom2 ! 2.5 secondo carmelo
                     write(Msg,9061) stampa_stopFinalFom2
                     call OneBlankOnly(Msg)
                     call TestoGR(Msg, -1, 2, 2)
*                    write(Msg,9062) stopFinalFom
*                    call OneBlankOnly(Msg)
*                    call TestoGR(Msg, -1, 2, 2)
                 endif
             end if
         endif
!
!pgMAD1011
!pgMAD0112
 9056 format('The tangent formula is used to phase the best',i5,
     *       ' reflections.')
 8057 format('|E<sub>0a</sub>| amplitudes are used to calculate',
     *       ' a Patterson map.')
 8058 format('The Patterson superposition techniques are used to locate
     *')
 8059 format('the anomalous scatterer substructure.')
 9057 format('Patterson superposition methods are used')
 9067 format('to phase the observed reflections.')
 9058 format('The VLD procedure is applied to ',i5,' trials')
 9068 format('The MDM procedure is applied to ',i5,' trials')
 9059 format('performing ',i5,' cycles of EDM in each trial.')
 9060 format('The solution is expected if the final FOM (fFOM) is')
 9061 format('around or greater than ',f5.1,': the program will stop.')
         npold=0
!
!-- Calcolo mappa vera per coeff. correlazione
!
         if (knw.eq.1.and.ifTime.eq.0) then
             iphaz(1:numbLSQ)  = ipub(1:numbLSQ)
!
!-- istruzioni da eliminare: test superflip
!
*             call CPUTime0('  ')
*             numb = nrefl
*             iphazo(:) = 0
*                wt(1:numb)     = 1.0
*                fcoef(1:numb)  = fovet(1:numb) * wt(1:numb)
*                jpatt = 0
*                call MakeMap(fcoef, iphaz, numb, jpatt, xmap,
*     *                   FORTH, BACK)
*             do i=1, 20000
*                wt(1:numb)     = 1.0
*                fcoef(1:numb)  = fovet(1:numb) * wt(1:numb)
*                jpatt = 0
*                call MakeMap(fcoef, iphaz, numb, jpatt, xmap,
*     *                   FORTH, BACK)
*                call NewInv(iphazo,fcvet,numb,np(1),np(2),np(3), BACK)
*                iphaz(:) = iphazo(:)
*                if (i < 100) then
*                    if (mod(i,10) == 0) write(0,'(a,i6)') 'Ciclo ',i
*                elseif (i < 1000) then
*                    if (mod(i,100) == 0) write(0,'(a,i6)') 'Ciclo ',i
*                elseif (i < 100000) then
*                    if (mod(i,1000) == 0) write(0,'(a,i6)') 'Ciclo ',i
*                endif
*             enddo
*             call CPUTime('Test FFTW', 0)
*             write(0,*) Inte
*             stop
!
!------------------------------------------
!
             wt(1:numbLSQ)     = 1.0
             fcoef(1:numbLSQ)  = fovet(1:numbLSQ) * wt(1:numbLSQ)
             jpatt = 0
             call MakeMap(fcoef, iphaz, numbLSQ, jpatt, xmap,
     *                FORTH, BACK)
             call Scrivi_Mappa_Vera(2)
             ifMappaTest = 0
             if (ifMappaTest == 1) then
                 itype = 0
                 iform = 1
                 jop =jopen(kform,'testsir.map',itype,iform,ios) 
                 do i=1,6
                    write(kform,*) cell(i)
                 enddo
                 do i=1,3
                    write(kform,*) np(i)
                 enddo
                 do iz=0,np(3)-1
                    do iy=0,np(2)-1
                       do ix=0,np(1)-1
                          write(kform,*) xmap(ix,iy,iz)
                       enddo
                    enddo
                 enddo
                 close(kform)
                 jpatt = 0
                 call CCP4MAPOUT(jpatt,xmap,np,'testccp4.map')
             endif
             iphaz = 0.0
             wt = 0.0
         endif
c
c     inserire calcolo mappa vera per coeff. correlazione
c     nel caso Patterson riscrivo la mappa vera solo se il Grid e' cambiato
c
         if(npold/=np(1)+np(2)+np(3)) then
           if (knw.eq.1.or.ifTime.eq.0) then
            if((ResEff-resm)/resm>0.1.or.(LowRes==1.and.no(nk)<20)) then
                   iterasog = 2
            else
                   iterasog = 0
            endif
            if(LowRes==0.and.iwei==0.and.v_p>0.55.and.ksize<6) then
                   iterasog = -1
            endif
            if(LowRes==1.and.ksize==7) iterasog = -1
!           if(ResEff>1.91) iterasog = -1
            if(ResEff>sogResEff) iterasog = -1!liberato2009
            if((ResEff-resm)/resm>0.1) then!liberato2009
               iterasog = 0
            endif
             if (numbGen > 0 .and. Iterazione > iterasog) then
               numberToUse=nreflTot
             else
               numberToUse=numbLSQ
             endif
             tmpwt(1:numberToUse)  = wt(1:numberToUse)
             iwork1(1:numberToUse) = iphaz(1:numberToUse)
             iphaz(1:numberToUse)  = ipub(1:numberToUse)
             wt(1:numberToUse)     = 1.0
             fcoef(1:numberToUse)  = fovet(1:numberToUse) * 
     *                               wt(1:numberToUse)
*            write(6,*) 'contan'
*            do i=1, numbLSQ
*               write(6,*) i,fovet(i),wt(i), fcoef(i)
*            enddo
             jpatt = 0
             call MakeMap(fcoef, iphaz, numbLSQ, jpatt, xmap,
     *                FORTH, BACK)
c    memorizzare mappa vera su disco
             call Scrivi_Mappa_Vera(2)
!--  mappa vera (con tutti i riflessi) su disco (*.pat)
             if (numbGen > 0) then
                 fcoef(1:nreflTot)  = fcvet(1:nreflTot) * wt(1:nreflTot)
                 call MakeMap(fcoef, iphaz, nreflTot, jpatt, xmap,
     *                FORTH, BACK)
                 call Scrivi_Mappa_Vera(1)
             endif
             iphaz = 0.0
             wt = 0.0
             if (ifPatt == 1) then
                 do i = 1,numberToUse
                     wt(i) = tmpwt(i)
                     iphaz(i) = iwork1(i)
                 enddo
             endif
           endif
         endif
c--
c
         nperc=MaxRun
         iperc0=1
         iperc=iperc0
         jperc=0
         if (nrefltot.gt.0.and.iprin.eq.2) then
            call ScritControl()
         endif
c ---
!
!
!--generazione di fasi con i codici
!
*        call codici()
!
         if (TotalScan == 0) then
             Inte = ' '
         else
             write(Inte,'(16a1)') nSpaceG(1:16)
             call ucase(Inte(1:1))
             nSgScan(nScan) = nSpaceGroup
             SgScan(nScan) = Inte(1:16)
             Inte = ' in ' // Inte
         endif
         if (ifVLD == 0) then
             if (ifPatt <= 0 .and. jpfile == 0) then
                 Msg = 'Starting SDM procedure'
                 call PrintMess(Msg)
                 Msg = 'Compute phases by means of SDM procedure' //Inte
                 call RunToolBar(1,Msg)
             endif
         elseif (ifMDM == 1) then
             Msg = 'Starting MDM procedure'
             call PrintMess(Msg)
             Msg = 'Compute phases by means of MDM procedure' // Inte
             call RunToolBar(1,Msg)
         endif
!

**       if (WhichDeriv == 1 .and. kmad /= 0) then
         if (MAD_posi == 0) then
             if (WhichDeriv == 1 .and. ifMadEnv /= 0) then
                 ifClick = 1
                 if (ifPatt /= 2) then
                     write(Msg,'(i8)') ntot
                     n1 = sum(jBlocksPh(2,1:nBlocksPh))
                     write(Inte,'(i8)') n1
                 else
                     n1 = sum(jBlocksPh(1,1:nBlocksPh))
                     n2 = sum(jBlocksPh(2,1:nBlocksPh))
                     write(Msg,'(i8)') n1
                     write(Inte,'(i8)') n2
                 end if
                 call shift(Msg, k1)
                 call shift(Inte, k2)
                 if (kmad == 1) then
                     write(Msg(k1+2:),6023) Inte(1:k2)
                     call TestoGR(Msg, -1, 2, 2)
                     write(Msg,6024)
                     call TestoGR(Msg, -1, 2, 2)
*                    write(Msg,6026)
*                    call TestoGR(Msg, color_GREEN, 2, 2)            !pgMAD0512
                 elseif (kmad == 2) then
                     write(Msg(k1+2:),6025) Inte(1:k2)
                     call TestoGR(Msg, -1, 2, 2)
                     write(Msg,6027)
                     call TestoGR(Msg, -1, 2, 2)
                     write(Msg,6028)
                     call TestoGR(Msg, -1, 2, 2)
*                    write(Msg,6026)
*                    call TestoGR(Msg, color_GREEN, 2, 2)            !pgMAD0512
                 else
*                    if (ifVLD == 0) then
*                        write(Msg,6035)
*                        call TestoGR(Msg, color_GREEN, 2, 2)
*                        write(Msg,6036)
*                        call TestoGR(Msg, color_GREEN, 2, 2)
*                    endif
                 endif
*gl*             write(Msg,6026)
*gl*             call TestoGR(Msg, color_GREEN, 2, 2)            !pgMAD0512
             endif
         endif
 6023 format('trials requested and ',a,' trials stored.')
 6024 format('They will be used to locate the anomalous substructure.')
 6025 format('trials requested and ',a,
     *       ' trials stored for each derivative. ')
 6026 format('The best trials are expected to have the ',
     *        'highest eFOM values.')
 6027 format('They will be used to locate the heavy atom substructure')
 6028 format('on the basis of the early Figure Of Merit (eFOM).')
 6035 format('The best trials with respect to the eFOM')
 6036 format('undergo phase refinement and extension.')

!
         if (kverbo.gt.0) then
             write(lo,*) 'Specie, IWEI, NumPeso, pip, NumPes'
             write(lo,101) nk, IWEI, NumPeso, pip, NumPes
         endif
 101  format (i3,5x,i5,3x,i7,f5.1,3x,i7)
c--
         if (knw.gt.0) then
             itype = 0
             iform = 1
             jop =jopen(jerr,fname(5),itype,iform,ios)
         endif
c_LIB
         FOMsog   = -9999.9
         FOMrif   =  9999.9

         if (jpfile.ne.0 .and. MAD_posi == 0) then
             ksubr = 4
             numbInvSav = numbInv
             call LeggiRiflessi(ier,ksubr)
             numbInv = numbInvSav
             call PutGetXyzs(2,interp)
             iCoeff = 0
             mode = 1
             iref=0
             nzsav(1:nats) = nz(1:nats)
             nz(1:nats) = nz(1:nats) / nzConst
             call sftryyyc(iref,mode,nrefl,scalan,ifBreak,iCoeff)
             nz(1:nats) = nzsav(1:nats)
             FinalFom = 1
             call ManagePhasesDSR(1,corre, 0)
             call ManagePhasesDSR(2,corre, 0)
             errem = erre
             RSir = erre*100
             call ScriviFrammento
             numbrun = 1
             call MiglioriErre(1)
!
             if (neutro == 2) then
                 if (nBest > 0) then
                     kdoBest = doBest
                     doBest = 1
                     call PreparaRmiglioreFequ(0)
                     scalan = 1.0
                     call sftryyycele(iref,mode,nrefl,scalan,ifBreak,
     *                                iCoeff)
                     RBea = erre*100
                     beaPerc= 100.0 * float(nBest) / float(nrefl)
                     write(6,'(a,2f8.2,f8.0,a)')
     *                 ' R classico, BEA ',RSir, RBea, beaPerc,'%'
                     doBest = kdoBest
                     deallocate (matFoSig, indBest, numBest, stat=ier)
                     erre = errem
                     if (ier /= 0) stop 1234
                 else
                     erreno = 0.0
                     write(6,'(a,f8.2,a)')
     *                 ' R classico, BEA ',RSir, ' No Equiv. Refl.'
                 endif
             endif
             numbLSQFinal = nrefl
c            if (knw == 1) then
c               if (ifExamin.ne.0) then
c                   izero = 0
c                   ifmin = 1
c                   nbru = -2
c                   call examin(nbru,mkang,khl,ipub,iphaz,nrefl,izero,
c    *                   wt,ifmin)
c                   write(lo,100) filet(1:lung(filet)), erre*100,
c    *                            erore, erorepes, isumal
c               endif
c            endif
             nz(1:nats) = nzsav(1:nats)
             ksubr = 4
             call AggiornaFasiPesiNew(ksubr, wt, iphaz, fcvet)
             if (ksize > 3) then
                 nsetP = 1
                 nSetsFineDSR = nsetP
                 iposFineDSR(1) = nsetP
                 figMer(:) = 0.0
!gl!             call snw17(nsetP, figMer)
                 call PutGetFinalPhases(1, nsetP, figMer)
!gl!             call sup17(nsetP)
                 call UpdateFinalPhases(FomsFineDSR, iposFineDSR, nsetP)
!gl!             call sfl17()
                 call LoadFinalPhases(FomsFineDSR, iposFineDSR,
     *                                nsetFinalPhases)
                 number = 0
                 nSetsP = 1
                 call WriteMTZ(1, number, nSetsP, 1, ier)
                 if (ier < 0) return
             endif
             if (jpfile.gt.0) then
                 QualeAbilita = 2
                 kWstop = 1
                 nBlocksPh = 0
             endif
             nundet = 0
             if (ifExamin.ne.0) then
                 izero = 0
                 ifmin = 0
                 nbru = -2
                 call examin(nbru,mkang,khl,ipub,iphaz,nrefl,izero,
     *                   wt,ifmin)
                 write(lo,100) filet(1:lung(filet)), erre*100,
     *                            erore, erorepes, isumal
             endif
             write(Msg,200) filet(1:lung(filet)), erre*100
             call PrintMess(Msg)
         endif
c--

! - confronto frammento / picchi su mappa con fasi vere

!     fcoef (:) = evet(:)
!     wt(:) = 1.0
!     iphaz(:) = ipub(:)
!     jpatt = 0
!     call MakeMap(fcoef, iphaz, nrefl, jpatt, xmap,
!    *                FORTH, BACK)
!     nats = nint(anat)
!     aperc(1) = nats
!     call Search99(1,ier,nrefl)
!     nats = nint(anat)
!     do j = 1,10
!         write(lo,310) j,(xyzs(k,j),k=1,5)
!     enddo
!     call to_coord_sir(1,nrefl)

! 310 format(i6,2x,3f6.3,f10.1,f6.2)

!          STOP 12345
!

         if (nBlocksPh > 0) then
c           if (ifGEDM == 1) then
            if (ifGedm /= 0) then
                call AllocaC_EDM(1)   ! da deallocare prima di chiudere SIR
                call InitGEDM()
            endif 
            if (neutro == 2 .and. doBest == 1) then
                call PreparaRmiglioreFequ(1)
            endif 
!pgVLD
            call SolutionFound(0, 0)
            if (ifVLD == 0) then
               call BlockPh(ier, iPlotTypeSWRC, ifFromGraphic, ifBreak)
            else
               fortran_work = .false.
               call Block_VLD(ier, iPlotTypeSWRC, ifFromGraphic,
     *                          ifBreak)
               nPreviousTrials = nPreviousTrials + numbrunTot
               ksize = ksize_vero
            end if
!pgVLD
            if (ifBreak == 1) then
                call ResetStop()
                return
            endif
         else
            if (jpfile.le.0) then
                ier = -1
                return
            endif
         endif
!

         if (WhichDeriv < nCicliPhase) then
             ifInvar = 0
             call AllocaMappa(2)
         endif

         call InitSigmaA(2)

      enddo   !    fine do su nCicliPhase

      if (ksize > 3) then
          iOk = 0
          j1 = icomat + 1
          j2 = icomat + 2
          if (icomq(j1,1) == 49) then
              iOk = 1
              icomat = j1
          endif
          if (icomq(j2,1) == 49) then
              iOk = 1
              icomat = j2
          endif
          if (iOk == 1) then
              call FinalEDM(ier)
              Msg = 'Ab Initio structure ' //
     *              'determination is over.'
              call scrper(Msg,0,-1)
          endif
      endif

!
c     if (ifGEDM == 1) then
      if (ifGedm /= 0) then
          call AllocaC_EDM(2)
      endif
!
      call AllocaHistoStuff(2)
      call AllocaPsi0Stuff(2)
*     call AllocaRiflessiSIGMAA(2)
*     call AllocaRiflessiSIGMAA(2)
**    call AllocaInvarStuff(2)
      call AllocaIsr(2)
      call DeAllocaVLD
      if (allocated(FasiRelax)) then
          deallocate(FasiRelax, PesiRelax, stat = ier)
      endif
!
!-- delete .pat, .mpt
!
      if (ilMilione == 0 .and. knw > 0) then
          itype = 2
          iform = 1
          do i=6,7
             jop =jopen(jgrap,fname(i),itype,iform,ios)
             if (jop >= 0) then
*                close(jgrap, status = 'delete')
             endif
          enddo 
      endif
      if (jpfile /= 0) then
          nolsq = -1
      endif
!
!-- serve per scrivere i files *.phasitest per le fasi da affinare
!
!      do  i=1,nrefl
!          p = ipub(i)
!          c = iphaz(i)
!          w = wt(i)
!        write(79,'(3i5,5f12.3)') khl(1:3,i),fovet(i),sigmav(i),p,c,w
!      enddo
c--occhio
!
      if (ifBreak == 1) then
          call PrintMess('Program stopped by the user')
          ifBreak = 0
          nats = 0
      endif
      if (ier == -1) then
          call PrintMess('Program stopped because of errors')
      endif

      if (ifMadEnv > 0 .and. jscreen > 0) then

          if (ifPhD == 0) then

              if (ilMilione == 0) then  !  .and. ifAutomatic == 0) then
                  if (ier >= 0) then
                      kk = ifWasMad     ! gianluca 11/09/2009
                      call ProcOver(kk, irisp)
*gl*                  if (irisp == 2) then
*gl*                      ifAutomatic = 1
*gl*                  endif
                  endif
              endif
!
              if (ier == 0) then
                  if (kmad == 1) then
                      Msg = 'Anomalous scatterers substructure ' //
     *                      'determination finished.'
                  elseif (kmad == 2) then
                      Msg = 'Derivative substructure ' //
     *                      'determination finished.'
                  else
                      Msg = 'Ab Initio structure ' //
     *                      'determination finished.'
                  endif
              else
                  if (kmad == 1) then
                      Msg = 'Anomalous scatterers substructure ' //
     *                      'determination finished in error.'
                  elseif (kmad == 2) then
                      Msg = 'Derivative substructure ' //
     *                      'determination finished in error.'
                  else
                      Msg = 'Ab Initio structure ' //
     *                      'determination finished in error.'
                  endif
              endif
              if (kmad == 0) then
                  call CPUTime(' ', 0)   !????!
              endif
              if(kverbo>0) call CPUTime('fine Contan ', 1)
              HTMLcpu = Inte(1:Lung(Inte))
              headersGR(2) = Inte
              call ManageGraph(0, 0)
              call zflush
              call DoSingleIteration()
              call zflush
              call DoSingleIteration()
              if (ifMadEnv == 0) then
                  call CreaPng(fname(9))
              else
                  k1 = index(fname(1), '.bin') - 1
                  Inte = fname(1)(1:k1) // '_fPlot.png' // char(0)
                  call CreaPng(Inte)
              endif
!
          endif

          iAc = 9
          call FilesInfo(iAc, 0)
       
      elseif (ifMadEnv == 0 .and. jscreen > 0) then
!g        call CPUTime(' ', 0)
!g        HTMLcpu = Inte(1:Lung(Inte))
!g        call CPUTime0(' ')
!
          if (MaxRun > 1 .and. ifVLD == 0) then
              if (jpfile <= 0) then
                  call ManageGraph(0, 0)
              endif
              call zflush
              call DoSingleIteration()
              k1 = index(fname(1), '.bin') - 1
              Inte = fname(1)(1:k1) // '_Foms.png'              !mr   // char(0)
              ind = -100
              call Visualizzatore(ind, 0, 0, Inte)
          endif
!
      endif
!
      if (ifPhD == 1) then
          call StartPhD(ier)
      endif
      if (jscreen == 0) then
          if (ifPhantom == 0) then
              kk = ifWasMad     ! gianluca 11/09/2009
              call ProcOver(kk, irisp)
          endif
      endif
!
      call AllocaRiflessi_Canal(2)
      call AllocaCanalMod(2)
      call AllocaPherrMod(2)
!
      call AllocaRiflessi_Pub(2)
      call AllocaRiflessi_c(2)
      call AllocaHistoMatch(2, 0)
      call AllocaMappaAutre(2)
      call AllocaBuildStuff(2)
      call DeallocaBuildModuleSmall
*     call AllocaRfacMatrix(2)
!
      return
 9000 ier = -1
      write(Msg,'("Cannot delete log file :",a)') Inte(1:Lung(Inte))
      Inte = 'Protected file'
      call MsgWinErr(Inte, Msg, INFO_WINDOW, nExitCode)
      return
  100 format(' Fragment ',a,':',/,' R% = ',f6.2,' Mean Phase Error ',
     *          f5.2,'  (',f5.2,')  over',i8,' reflections')
  200 format(' Fragment ',a,':   R% = ',f6.2)
      end
!-----------------------------------------------------------------------
      subroutine Init_RfacMatrix
      USE PhaseModule
      USE RfacMatrixModule
      USE VLDmod, only : n_Maxrun, n_abi_model
!
      implicit none
!
      if (ifMDM == 1) then
          nRfacMatrix   = n_Maxrun + n_abi_model - 1
          nRfacMatrixBl = 1
      elseif (ifVLD == 1) then
          nRfacMatrix   = n_Maxrun + n_abi_model - 1
          nRfacMatrixBl = 1
      elseif (ifTang == 1) then
          nRfacMatrix   = maxval(jBlocksPh(1,1:nBlocksPh))
          nRfacMatrixBl = nBlocksPh
      elseif (ifPatt == 1) then
          nRfacMatrix   = maxval(jBlocksPh(1,1:nBlocksPh))
          nRfacMatrixBl = nBlocksPh
      else
          call cstop('error in Init_RfacMatrix')
      endif
      call AllocaRfacMatrix(1)
      NumbMaxRfac = nRfacMatrix
!
      RfacMatrix(:,:,:) = 0.0
      RfacMatrix(3,:,:) = -9999
      if (jrest.eq.0 .and. ifVLD == 0) then
          RfacMatrix(2,:,:) = -9999.9
      endif
      if (jrest == 2) then
          jRfac = size(RfacMatrix(1,:,1))
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine WhiteBoard
      USE General
      USE Riflessi
      USE Molcom
      USE Grafici
      USE Param
      USE PhaseModule
      USE GREXPOMOD
!
      implicit none
      integer :: iAction, npunti, k1, k2
!
      character *10 WilsonString
!
      if (ksize <= 3 .or. kmad /= 0) then
          return
      endif
!
      ifMadEnv = 2
      jBackGround = 1
      call CambiaBg(jBackGround)
      call c_scr2(-1, 0, 0, 0, 0, ' ')
      call RunToolBar(-1,' ')
!!mr  call NascondiToolbar(0)
      call zflush
      call DoSingleIteration()
      ifViewer = .false.
      iAction = -1
      npunti = sum(jBlocksPh(1,:))
      call DataForGraph(iAction, npunti)
      ifDrawGR = .true.
      Msg = "<big><b>Data Section:</b></big>"
      call TestoGR(Msg, color_RED, 2, 1)
      write(Msg,40) nrefl
      call shift(Msg, k1)
      call TestoGR(Msg(1:k1), -1, 2, 1)
      write(Msg,10) resol_obs_min, resol_obs_max
      call TestoGR(Msg, -1, 2, 1)
      if (numbGen > 0) then
          write(Msg,15) numbGen, resolMiss
          call shift(Msg,k2)
          call TestoGR(Msg, -1, 2, 1)
      endif
      if (knw > 0) then
          write(Inte,'(i10)') nrefl
          call shift(Inte,k1)
          write(WilsonString,'(f10.2)') bt
          call shift(WilsonString,k2)
          write(Msg,20) Inte(1:k1), WilsonString(1:k2)
          k1 = index(Msg, 'lised.') + 5
          call TestoGR(Msg(1:k1), -1, 2, 1)
          call TestoGR(Msg(k1+2:), -1, 2, 1)
          if (ksize_vero > 3) then
              write(Msg,30) v_m, v_s
              call TestoGR(Msg, -1, 2, 1)
          endif
      endif
      call zflush
      call DoSingleIteration()

!
      return
   10 format('Observed resolution range: ',f5.2,' -',f5.2,
     *       ' &#xC5; .')
   15 format(i6,' reflections extrapolated up to ',f5.2,' &#xC5; .')
   20 format(' ',a,' structure factors have been normalised.',
     *       ' The average thermal factor (through ',
     *       'Wilson plot) is ',a)
   30 format(' Matthews coefficient =',f5.2,
     *       ', Solvent fraction =',f5.2)
   40 format(i8,' observed reflections')
      end
!-----------------------------------------------------------------------
      subroutine SortMir
      USE General
      USE Riflessi
      USE PhaseModule
!
      real, allocatable   :: vettore(:)
!
!-- sort reflections with respect to E's of current derivative
!-- numbLSQ and resm must be defined here
!
      iblk = 10
      idim = nrefl * iblk 
      allocate ( vettore(1:idim) )
!
      j = 0
      do i=1, nrefl
         vettore(j + 1:j+3) = khl(1:3,i)
         vettore(j + 4) = fovet(i)
         vettore(j + 5) = sigmav(i)
         vettore(j + 6) = evet(i)
         vettore(j + 7) = mkang(i)
         vettore(j + 8) = mult(i)
         vettore(j + 9) = epsv(i)
         vettore(j +10) = rhov(i)
         j = j + iblk
      enddo 
      lind = 1
      numb = nrefl
      jump =  -6
      call sortz_dyn(vettore,idim,lind,numb,iblk,jump)
!
      rhomax = 0.0
      j = 0
      k = 0
      do i=1, nrefl
         if (vettore(j+6) > 0.0) then
             k = k + 1
             khl(1:3,k) = nint(vettore(j + 1:j+3))
             fovet(k)   = vettore(j + 4)
             sigmav(k)  = vettore(j + 5)
             evet(k)    = vettore(j + 6)
             mkang(k)   = nint(vettore(j + 7))
             mult(k)    = nint(vettore(j + 8))
             epsv(k)    = vettore(j + 9)
             rhov(k)    = vettore(j +10)
             if (k < 11 .and. knw == 1) then
                 write(6,10) k, khl(:,k), evet(k)
             endif
             j = j + iblk
             if (rhov(k) > rhomax) then
                 rhomax = rhov(k)
             endif
         endif
      enddo 
      nrefl = k
      numbLSQ = 0.7 * float(nrefl)
      resm = 0.5 / sqrt(rhomax)
      if (knw == 1) then
          write(6,*) 'SortMir', nrefl, numblsq,resm,bt,sc
      endif
c     do i=1,nrefl
c        write(6,1) khl(1:3,i),evet(i),fovet(i),sigmav(i)
c     enddo
c   1 format(3i4,3f12.5)
!
      deallocate ( vettore )
!
      return
  10  format (i3,')',3i4,f8.3)
      end
!-----------------------------------------------------------------------
      subroutine VolumeProteina()
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Molcom          
      USE PhaseStuff
      USE Mappa
      USE Param
      USE PhaseModule
!
      common/dir10/numk,ntrs,ntr10,sogpo,sogne,nupos,nuneg,
     1 indpo,indne,nmxtn
      common /ConvComm/ NSigPos, SogPos, NSigNeg, NQuaNeg, inizNeg,
     *                  NPsiZero, numbReflTrip, SogNeg, SogQuaNeg
!psie      
!psie      common /ConvComm/ NSigPos, SogPos, NSigNeg, NQuaNeg, inizNeg,
!psie     *                   NPsie,NPsiZero, numbReflTrip, SogNeg, SogQuaNeg
!
!--- Calcolo il volume della Proteina
!
      v_p = 1.
      v_s = 0.
      if (ksize.gt.3) then
          v_m  = 0.0
!
          do i = 1,nk
!old         if (no(i).gt.1) then
             if (no(i) > 1.and. no(i) <= 16) then
                 v_m = v_m + 14.0 * float(nw(i)) ! 14=2*nz(azoto)
             endif
          enddo
*         write(lo,20) costanteMatthews, volume, v_m
!--- Matthews' number
          v_m = volume / v_m
!--- Percent of Protein
          v_p = costanteMatthews / v_m
          v_s = 1.0 - v_p
*         write(lo,30) v_m, v_p, v_s
          if (v_s < 0.0) then
              v_p = 1.
              v_s = 0.
          endif
      endif
c--dedi
      if (v_s <= 0.1 ) then
         ifEnve = 0
      endif
c--dedi
!
      return
      end
c-------------------------------------------------------
      subroutine F2E_Pub()
c
      USE General
      USE Symmetry
      USE Riflessi
c
c--trasformo gli F calcolati in E osservati per i riflessi generati
c  (per gli altri il valore di E osservato l'ho gia')
!          utilizza fcvet --> fcvetv
c
c--parte da utilizzare per mettere in scala gli fcvet dei riflessi esterni
c  con gli fovet iniziali
c
      sumfo=0.0
      sumfc=0.0
      do i=1,nrefl
c         write(688,*) i,fovet(i),fovet(i)/sqrt(sc),
c    &                  evet(i),0.5/sqrt(rhov(i))
        sumfo=sumfo+fovet(i)/sqrt(sc)
        sumfc=sumfc+fcvet(i)
      enddo

! dedi 13/5/10  -  se non uso known + modello non posso calcolare  fcvet e fcvetv (Fpub e Epub)
      if (sumfc < 0.0000001) return   

      scala = sumfo/sumfc
c----
      tot=0.0
      nww=0.0
      do i=1,nreflTot
         fcvetp(i) = fcvet(i)  ! memorizzo F calcolati da modello 
c        fo = fcvet(i)
         fo = fcvet(i)*scala
         rho = rhov(i)
         eps=epsv(i)
         multi=mult(i)
         ff0   = fo * fo / pts
         sinth=100.0*sqrt(rho)
         ind=max0(2,int(sinth+1.5))
         frac=sinth-float(ind-1)
         bf=0.5*(giw(ind+1)-giw(ind-1))
         af=bf+giw(ind-1)-giw(ind)
         form=af*frac*frac+bf*frac+giw(ind)
         denor=form*eps
         ed = ff0/denor
         esq=sc*ed*exp(2.*bt*rho)
c           write(687,'(i10,3f15.8)') i,fcvet(i),sqrt(esq),
c    &                  0.5/sqrt(rho)
         fcvetv(i)=sqrt(esq)
         multt = mult(i)
         tmul=float(multt)
         tot=tot+esq*tmul
         nww=nww+multt
      enddo
      tot=tot/float(nww)
      scala=1.0/tot
      fcvetv(nrefl+1:nreflTot)=fcvetv(nrefl+1:nreflTot)*sqrt(scala)
c
      return
      end
!-----------------------------------------------------------------------
      subroutine RinormalizzaPubblicati()
      USE General
      USE Riflessi
      USE Riflessi_Pub
!
      if ( knw == 0) return
!
      call AllocaRiflessi_Pub(1)

      interni = 0
      do i = nrefl+1,nreflTot
         if (rhov(i) < rhomax) then
             interni = interni + 1
          else
             numbB = i - 1
             write(6,*) 'Interni',i,rhov(i),rhomax,interni
             exit
         endif
      enddo

           Fpub(1:nreflTot) = fcvet(1:nreflTot)
           sumFo = 0.0
           sumFc = 0.0
           do i = 1,nrefl
              sumFo = sumFo + fovet(i)
              sumFc = sumFc + Fpub(i)
           enddo
           sca = sumFo / sumFc
           sumFo = 0.0
           delFoFc = 0.0
           do i = 1,nrefl
              sumFo = sumFo + fovet(i)
              delFoFc = delFoFc + abs(fovet(i) - sca*Fpub(i))
           enddo
           eerr = delFoFc / sumFo
           write(6,*) 'R(Fobs-Fpub) = ', eerr * 100.,sca
           call toflush()

           call F2E_Pub()
           Epub(1:nreflTot) = fcvetv(1:nreflTot)
c
c-- Rinormalizzo Epub per riflessi osservati (+Added)
c
!          nreflSHL = nrefl+Added
           nreflSHL = nreflDim
           do i = 1,nreflSHL
              work1(i) = Epub(i)
              work2(i) = rhov(i)
           enddo
!          call Renor2004(2)
           call Renor2004(1)
           do i = 1,nreflSHL
              Epub(i) = work1(i)
           enddo
c
c-- Rinormalizzo Epub per riflessi generati
c
!          nreflSHL = nreflDim - (nrefl+Added)  ! = numbGen
!          do i = 1,nreflSHL
!             ii = nrefl+Added + i
!             work1(i) = Epub(ii)
!             work2(i) = rhov(ii)
!          enddo
!          call Renor2004(3)
!          do i = 1,nreflSHL
!             ii = nrefl+Added + i
!             Epub(ii) = work1(i)
!          enddo
!
           fcvetv(1:nreflTot) = Epub(1:nreflTot)
!
           sumEo = 0.0
           sumEc = 0.0
           do i = 1,nrefl
              sumEo = sumEo + evet(i)
              sumEc = sumEc + Epub(i)
           enddo
           sca = sumEo / sumEc
           delEoEc = 0.0
           do i = 1,nrefl
              delEoEc = delEoEc + abs(evet(i) - sca*Epub(i))
           enddo
           eerr = delEoEc / sumEo
           write(6,*) 'R(Eobs-Epub)  = ', eerr * 100.,sca
c          sumE = 0.0
c          delEoEc1 = 0.0
c          delEoEc2 = 0.0
c          do i = nrefl+1,nreflTot
c             sumE = sumE + Epub(i)
c             delEoEc1 = delEoEc1 + abs(1.0 - Epub(i))
c             delEoEc2 = delEoEc2 + abs(0.886 - Epub(i))
c          enddo
c          eerr1 = delEoEc1 / sumE
c          eerr2 = delEoEc2 / sumE
c          write(6,*) 'R(Epub - 1.0)ext = ', eerr1 * 100.
c          write(6,*) 'R(Epub-0.886)ext = ', eerr2 * 100.
c
!
      return
      end
!------------------------------------------------------------------------------
      subroutine RinormalizzaPubblicati_Orig()
      USE General
      USE Riflessi
c
      real,    allocatable :: Fpub(:)   ! F calcolati da PDB
      real,    allocatable :: Epub(:)   ! E calcolati da PDB
!      
      interni = 0
      do i = nrefl+1,nreflTot
         if (rhov(i) < rhomax) then
             interni = interni + 1
          else
             numbB = i - 1
             write(6,*) 'Interni',i,rhov(i),rhomax,interni
             exit
         endif
      enddo
      if ( knw > 0) then
           IF (.NOT. ALLOCATED(Fpub))
     *         ALLOCATE (Fpub(1:nreflDim)     ,stat = ier1)
           IF (.NOT. ALLOCATED(Epub))
     *         ALLOCATE (Epub(1:nreflDim)     ,stat = ier2)
           Epub=0.0
           Fpub=0.0
           Fpub(1:nreflTot) = fcvet(1:nreflTot)
c
           sumFo = 0.0
           sumFc = 0.0
           do i = 1,nrefl
              sumFo = sumFo + fovet(i)
              sumFc = sumFc + Fpub(i)
           enddo
           sca = sumFo / sumFc
           sumFo = 0.0
           delFoFc = 0.0
           do i = 1,nrefl
              sumFo = sumFo + fovet(i)
              delFoFc = delFoFc + abs(fovet(i) - sca*Fpub(i))
           enddo
           eerr = delFoFc / sumFo
           write(6,*) 'R(Fobs-Fpub) = ', eerr * 100.,sca
           call toflush()

           call F2E_Pub()
           Epub(1:nreflTot) = fcvetv(1:nreflTot)
c
c-- Rinormalizzo Epub per riflessi osservati (+Added)
c
           nreflSHL = nrefl+Added
           do i = 1,nreflSHL
              work1(i) = Epub(i)
              work2(i) = rhov(i)
           enddo
           call Renor2004(2)
           do i = 1,nreflSHL
              Epub(i) = work1(i)
           enddo
c
c-- Rinormalizzo Epub per riflessi generati
c
           nreflSHL = nreflDim - (nrefl+Added)  ! = numbGen
           do i = 1,nreflSHL
              ii = nrefl+Added + i
              work1(i) = Epub(ii)
              work2(i) = rhov(ii)
           enddo
           call Renor2004(3)
           do i = 1,nreflSHL
              ii = nrefl+Added + i
              Epub(ii) = work1(i)
           enddo
!
           fcvetv(1:nreflTot) = Epub(1:nreflTot)
!
           sumEo = 0.0
           sumEc = 0.0
           do i = 1,nrefl
              sumEo = sumEo + evet(i)
              sumEc = sumEc + Epub(i)
           enddo
           sca = sumEo / sumEc
           delEoEc = 0.0
           do i = 1,nrefl
              delEoEc = delEoEc + abs(evet(i) - sca*Epub(i))
           enddo
           eerr = delEoEc / sumEo
           write(6,*) 'R(Eobs-Epub)  = ', eerr * 100.,sca
c          sumE = 0.0
c          delEoEc1 = 0.0
c          delEoEc2 = 0.0
c          do i = nrefl+1,nreflTot
c             sumE = sumE + Epub(i)
c             delEoEc1 = delEoEc1 + abs(1.0 - Epub(i))
c             delEoEc2 = delEoEc2 + abs(0.886 - Epub(i))
c          enddo
c          eerr1 = delEoEc1 / sumE
c          eerr2 = delEoEc2 / sumE
c          write(6,*) 'R(Epub - 1.0)ext = ', eerr1 * 100.
c          write(6,*) 'R(Epub-0.886)ext = ', eerr2 * 100.
c
           DEALLOCATE (epub, fpub,  stat = ierr)
           if (ierr.ne.0) then
              write(*,*) 'epub,fpub DeAllocation Error'
              call cstop(' ')
           endif
      endif
!
      return
      end
!------------------------------------------------------------------------------
      subroutine StatRfac_PubAdd(ier)

      USE General
      USE Riflessi

      character ttirang*80

! -- per statistiche di confronto 
         work1(:) =  0.0
         work2(:) =  0.0
         worko(:) =  0.0
         tmpwt(:) =  1.0
         do i=1,nrefl
            worko(i) = 0.5 / sqrt(rhov(i))
            if (worko(i) > 6.0) then
                work1(i) = 1.0
            else
                work2(i) = 1.0
            endif
         enddo
!
        write(lo,*) ' ***  Obs-pub vs Resol  ***'
        ttirang = 'RE Obs-pub'
        nRefBin = 10
        iniz = 1
        ifin = nrefl
        call GetStatRfac(ttirang,worko,evet,fcvetv,ifin,iniz,
     *     tmpwt,nRefBin,0.0)
        ttirang = 'RE Obs-pub'
        nRefBin = 5
        iniz = 1
        ifin = nrefl
        call GetStatRfac(ttirang,worko,evet,fcvetv,ifin,iniz,
     *     work1,nRefBin,0.0)
        ttirang = 'RE Obs-pub'
        nRefBin = 10
        iniz = 1
        ifin = nrefl
        call GetStatRfac(ttirang,worko,evet,fcvetv,ifin,iniz,
     *     work2,nRefBin,0.0)

c       ttirang = 'RF Obs-pub'
c       nRefBin = 10
c       iniz = 1
c       ifin = nrefl
c       call GetStatRfac(ttirang,worko,fovet,fcvetp,ifin,iniz,
c    *     tmpwt,nRefBin,0.0)
c       ttirang = 'RF Obs-pub'
c       nRefBin = 5
c       iniz = 1
c       ifin = nrefl
c       call GetStatRfac(ttirang,worko,fovet,fcvetp,ifin,iniz,
c    *     work1,nRefBin,0.0)
c       ttirang = 'RF Obs-pub'
c       nRefBin = 10
c       iniz = 1
c       ifin = nrefl
c       call GetStatRfac(ttirang,worko,fovet,fcvetp,ifin,iniz,
c    *     work2,nRefBin,0.0)

        write(lo,*)  ' ***  Obs-pub vs E/Fobs  ***'
        ttirang = 'RE Obs-pub'
        nRefBin = 10
        iniz = 1
        ifin = nrefl
        call GetStatRfac(ttirang,evet,evet,fcvetv,ifin,iniz,
     *     tmpwt,nRefBin,0.0)

c       ttirang = 'RF Obs-pub'
c       nRefBin = 10
c       iniz = 1
c       ifin = nrefl
c       call GetStatRfac(ttirang,fovet,fovet,fcvetp,ifin,iniz,
c    *     tmpwt,nRefBin,0.0)
!
! ---    ADDED
!
         if (Added > 0) then

         do i=nrefl+1,nrefl+Added
            worko(i) = 0.5 / sqrt(rhov(i))
            if (worko(i) < 1.80) then
                work2(i) = 1.0
            else
                work2(i) = 0.0
            endif
         enddo

        write(lo,*) ' ***  Add-pub vs Resol  ***'
        ttirang = 'RE Add-pub'
        nRefBin = 10
        iniz = nrefl+1
        ifin = nrefl+Added
        call GetStatRfac(ttirang,worko,evet,fcvetv,ifin,iniz,
     *     work2,nRefBin,0.0)

c       ttirang = 'RF Add-pub'
c       nRefBin = 10
c       iniz = nrefl+1
c       ifin = nrefl+Added
c       call GetStatRfac(ttirang,work1,fovet,fcvetp,ifin,iniz,
c    *     work2,nRefBin,0.0)

        write(lo,*)  ' ***  Add-pub vs E/Fobs  ***'
        ttirang = 'RE Add-pub'
        nRefBin = 10
        iniz = nrefl+1
        ifin = nrefl+Added
        call GetStatRfac(ttirang,evet,evet,fcvetv,ifin,iniz,
     *     work2,nRefBin,0.0)

c       ttirang = 'RF Add-pub'
c       nRefBin = 10
c       iniz = nrefl+1
c       ifin = nrefl+Added
c       call GetStatRfac(ttirang,fovet,fovet,fcvetp,ifin,iniz,
c    *     work2,nRefBin,0.0)

      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine WritePhaseInfo(ntot)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Molcom          
      USE PhaseStuff
      USE Mappa
      USE Param
      USE MadModule
      USE PhaseModule
      USE VLDmod_3
!
      common/dir10/numk,ntrs,ntr10,sogpo,sogne,nupos,nuneg,
     1 indpo,indne,nmxtn
      common /ConvComm/ NSigPos, SogPos, NSigNeg, NQuaNeg, inizNeg,
     *                  NPsiZero, numbReflTrip, SogNeg, SogQuaNeg
!psie
!psie      common /ConvComm/ NSigPos, SogPos, NSigNeg, NQuaNeg, inizNeg,
!psie     *                   NPsie,NPsiZero, numbReflTrip, SogNeg, SogQuaNeg
      
      real QuantiDeriv(5)
      real anatcoef
!
      if (ifVLD == 0 .or. ifMDM == 1) then
          if (NSigPos > 0) write(lo, 100) NSigPos,SogPos
          if (NSigNeg > 0) write(lo, 101) NSigNeg,SogNeg
          if (NQuaNeg > 0) write(lo, 102) NQuaNeg,SogQuaNeg
          if (ifNewPsi0 == 1 .and. npsi > 0) then
              write(lo, 103)
              write(lo, 104) npsi
          endif
          if (ifSelAlfa == 1 .and. nstrelimi > 0) then
              write(lo, 105) 
              write(lo, 106) nstrelimi,nstr
          endif
      endif

!
      if (ksize < 4 .or. kmad==1 ) then     ! patterson MAD pg230407
          anatcoef = 1.2
      elseif (ksize < 6) then
          anatcoef = 1.1
      else
          anatcoef = 1.05
      endif
      if (anat.lt.5) then
          anatLSQ = 7
      else
          anatLSQ = float(nint(anat * anatcoef))
      endif
      if (numbSigma == 0) then
          ObsPar = float(numbLSQ) / ( 4.0 * anatLSQ )
          jjPerc = nint( 100 * float(numbLSQ) / float(nrefl) )
      else
          ObsPar = float(numbSigma) / ( 4.0 * anatLSQ )
          jjPerc = nint( 100 * float(numbSigma) / float(nrefl) )
      endif
      if (ifVLD == 0) then
          if (jpfile == 0 .and. ifPatt == 0) then
              write(lo, 110) nstr,nstartTang
c             write(lo, 110) nstr-nstrelimi, nstartTang
*         elseif (jpfile.lt.0) then
*             write(lo, 120) nstr
          endif
      endif
 
      nTotBlocksPh = 0
      do i=1,nBlocksPh
         nTotBlocksPh = nTotBlocksPh + jBlocksPh(1,i)
      enddo
      ntot = nTotBlocksPh
      if (kmad == 2) then
          ntotwr = ntot * nDataSets
      else
          ntotwr = ntot
      endif
      if (kmad /= 2) then
          numbLSQFinal = numbLSQ
          if (ksize_vero <= 3 .or. knw == 1) then
              if (numbSigma == 0) then
                  write(Inte,129) jjPerc,fosog
              else
                  write(Inte,139) jjPerc, float(ksigma)/10.0
              endif
              call OneBlankOnly(Inte)
              if (numbSigma == 0) then
                  write(lo,130) numbLSQ, Inte(1:Lung(Inte))
              else
                  write(lo,130) numbSigma, Inte(1:Lung(Inte))
              endif
              write(lo,131) anat,anatLSQ,ObsPar
          endif
      else
          Inte = ' '
          l = 1
          do j=1, nDataSets
             write(Inte(l:l+3),'(a4)') kAnom(j)
             call ucase(Inte(l:l))
             l = l + 6
             do i=1, MaxNk
                if (kAnom(j) == nalf(i)) then
                    QuantiDeriv(j) = float(nw(i)) / totop
                    exit
                endif
             enddo
          enddo
          write(lo,132) Inte(1:Lung(Inte)), QuantiDeriv(1:nDataSets)
      endif
      write(lo,141) Complet*100.0, ResEff
      if (kmad == 1) then   !pgMAD191006
          if (SogFiltro(2) /= 0.0) then
              write(lo,133) SogFiltro(2),factr,np
          else
              write(lo,133) resm,factr,np
          end if
      else
          write(lo,133) resm,factr,np
      end if
      if (ksize_vero <= 3) then
          if (ifVLD == 1 .and. knw > 0) then
              pippo = stopFinalFom2
              write(lo,137) pippo
          end if
          if (kmad == 0) then
              write(lo,134) RSoglia,ntotwr
          else
              write(lo,138) ntotwr
          endif
      else
          if (ifVLD == 0) then
              pippo0 = sogFFomRif
              pippo = FFomStopPGM
          else
              pippo0 = sogFinalFom
              pippo = stopFinalFom2
          end if
          if (knw == 0) then
              write(lo,135) pippo, ntotwr
          else
              write(lo,136) pippo0, pippo, ntotwr
          endif
      endif
!pgMAD0301
      call WriteStrategy(lo)
!pgMAD0301
      if (jpfile == 0) then
          if (ifPatt /= 0) then
              if (nIterazioni <= 1) then
                  write(lo, 200) 
              else
                  write(lo, 202) nIteraTot
              endif
              if (kmad == 1) then
                  write(lo, 208)
              endif
          else
              if (ifVLD == 0) then
                  if (nIterazioni == 1) then
                      write(lo, 203) 
                  else
                      write(lo, 206) nIteraTot
                  endif
              elseif (ifMDM == 0) then
                  write(lo, 205)
              elseif (ifMDM == 1) then
                  write(lo, 207)
              endif
          endif
      endif
      if (ksize_vero > 3) then
          write(lo, 210) v_m, v_p, v_s
      endif
*     if (ksize <= 3 .and. LowRes == 1) then
!
      if (knw == 1) then
          if (SogliaCorre < 2.0) then
              write(lo, 220) SogliaCorre
          endif
      endif
      write(lo, 230)
      if (ifRemo /= 0 .or. knw == 1) then
          if (nsym.gt.1.or.icent.eq.1) then
              call WriteCheshire()
          endif
      endif
!     
      if (knw == 1) then
          call toflush()
      endif
!
  100 format(' Number of Pos. Est. Triplets =',i9,' with  G  > ',f5.2)
  101 format(' Number of Neg. Est. Triplets =',i9,' with |G| > ',f5.2)  ! dedi (0.60)
  102 format(' Number of Neg. Est. Quartets =',i9,' with |G| > ',f5.2)  ! dedi (0.10)
  103 format(/,' Psi0 Relationships Actively Used ')
  104 format(' Number of Psi0 Relationships  =',i9)
  105 format(/,' Selection of Reflections to be used Tangent Formula ')
  106 format(' Number of Rejected Reflections  =',i6,' over',i6)
  110 format(/,' Number of refl. to phase     =',i9,/,
     *       ' Number of random phases      =',i9,/)
  120 format(' Number of refl. to phase     =',i9,/)
  129 format('( ',i3,'% of total,','  F',"'",'s >  ',f12.3,' )')
  139 format('( ',i3,'% of total,','  F',"'",'s > ',f4.1,'*sigma  )')
  130 format(' Number of reflections in LSQ =',i9,' ',a)
!    *         '( ',i3,'% of total,','  F',"'",'s >  ',f12.3,' )')
  131 format(' Number of atoms to locate    =',f12.2,/,
     *       ' Number of atoms used in LSQ  =',f12.2,/,
     *       ' Observations / Parameters    =',f12.2)
  141 format(' Completeness (%)             =',f12.2,/,
     *       ' Effective Resolution (Ang.)  =',f12.2)
  132 format(' Derivatives to be used       =',8x,a,/,
     *       ' Number of heavy atoms        =',6x,5f6.2)
  133 format(' Resolution & grid step (Ang) =',6x,2f6.2,/,
     *       ' Fourier map grid points      =',i9,2i6)
  134 format(' Threshold on R %             =',f12.2,/,
     *       ' Total number of trials       =',i9)
  137 format(' Stop condition:    Final Fom >',f12.2)
  138 format(' Total number of trials       =',i9)
  135 format(' Stop condition:    Final Fom >',f12.2,/,
     *       ' Total number of trials       =',i9)
  136 format(' Threshold on Final Fom       =',f12.2,/,
     *       ' Stop condition:    Final Fom >',f12.2,/,
     *       ' Total number of trials       =',i9)
* 200 format(' Patterson Procedure will be used ',
*    *       '(only one DSR iteration per trial)',/)
* 202 format(' Patterson Procedure will be used (up to',i3,
*    *       ' DSR iterations per trial)',/)
  200 format(' Patterson deconvolution strategy via superposition',
     *       ' methods will be used ',/,
     *       ' (only one DSR iteration per trial)',/)
  202 format(' Patterson deconvolution strategy via superposition',
     *       ' methods will be used ',/,
     *       ' (up to',i3,' DSR iterations per trial)',/)
  203 format(' Direct Methods will be used ',
     *       '(only one DSR iteration per trial)',/)
  205 format(' VLD algorithm will be used',/)
  206 format(' Direct Methods will be used (up to',i3,
     *       ' DSR iterations per trial)',/)
  207 format(' MDM algorithm will be used',/)
  208 format(
     *     ' Only data affected by anomalous dispersion will be used.')
  210 format (' Matthews coefficient         =',f12.2,/,
     *        ' Protein fraction             =',f12.2,/,
     *        ' Solvent fraction             =',f12.2)

  220 format (5x,' Soglia_CC = ',f8.3)
  230 format(' ',78('+'),/)


*1010 format (' Ideal RAT = ',f7.3,3x,'Ideal eFom = ',f7.3,/)
*1011 format (' Ideal RAT = ',f7.3,/)
*1012 format (5x,' EO2s = ',f8.3,5x,' EO2w = ',f8.3,/,
*    *            5x,' EO3w = ',f8.3,5x,' EO4w = ',f8.3)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine WriteBlocksInfo(ifFromGraphic)
      USE General
      USE MadModule
      USE PhaseModule
!
      character*4 stringa
!
*     if (ifFromGraphic == 0) then !  .and. ifPatt == 0) then
          if (kmad /= 2) then
              if (jpfile == 0) then
                  if (ifTang == 1)  write(lo, 240) nBlocksPh
              endif
          else
              id = kfpfs(WhichDeriv)
              write(stringa,'(a4)') nalf(id)
              call lcase(stringa)
              call ucase(stringa(1:1))
              write(lo, 245) nBlocksPh, stringa
          endif
          if (jpfile == 0) then
             if (ifTang == 1) then
                do i=1,nBlocksPh
                       write(lo, 250) i,(jBlocksPh(j,i),j=1,2),
     *                                'Direct Methods'
                enddo
             else
                ntr = 0 
                do i=1,nBlocksPh
                   ntr = ntr + jBlocksPh(1,i)
                enddo
                if (ifVLD == 0) then
                    if (ifPatt == 1) then
                     write(lo, 260) ntr
                    endif
                else
                    if (ifMDM == 0) then
                        write(lo, 270) ntr
                    else
                        write(lo, 280) ntr
                    end if
                endif

             endif
          endif
          if (itria > 0) then
              write(lo, 290) itria
          endif
*     endif
!
      return
!
  240 format(' Number of blocks to be used:',i3,/,
     *       15x,' Block     Trials    to explore    Procedure')
  245 format(' Number of blocks to be used:',i3,' for derivative ',a/,
     *       15x,' Block     Trials    to explore    Procedure')
  250 format(15x,i3,2i12,8x,a)
  260 format(' Number of Trials to explore:',i5,
     *       '  (Patterson  Procedure)')
  270 format(' Number of Trials to explore:',i5,
     *       '  (VLD  Procedure)')
  280 format(' Number of Trials to explore:',i5,
     *       '  (MDM  Procedure)')
  290 format(' Starting Trial:',i5)
!
      end
!-----------------------------------------------------------------------
      subroutine WriteBlocksInfo_OLD(ifFromGraphic)
      USE General
      USE MadModule
      USE PhaseModule
!
      character*4 stringa
!
*     if (ifFromGraphic == 0) then !  .and. ifPatt == 0) then
          if (kmad /= 2) then
              if (jpfile == 0) then
                  write(lo, 240) nBlocksPh
              endif
          else
              id = kfpfs(WhichDeriv)
              write(stringa,'(a4)') nalf(id)
              call lcase(stringa)
              call ucase(stringa(1:1))
              write(lo, 245) nBlocksPh, stringa
          endif
          if (jpfile == 0) then
             do i=1,nBlocksPh
                if (ifVLD == 0) then
                    if (ifPatt == 0) then
                       write(lo, 250) i,(jBlocksPh(j,i),j=1,2),
     *                                'Direct Methods'
                    else
                     write(lo, 250) i,(jBlocksPh(j,i),j=1,2),'Patterson'
                    endif
                else
                    if (ifMDM == 0) then
                        write(lo, 250) i,(jBlocksPh(j,i),j=1,2),'   VLD'
                    else
                        write(lo, 250) i,(jBlocksPh(j,i),j=1,2),'   MDM'
                    end if
                endif
             enddo
          endif
          write(lo,*) ' '
*     endif
!
      return
!
  240 format(' Number of blocks to be used:',i3,/,
     *       15x,' Block     Trials    to explore    Procedure')
  245 format(' Number of blocks to be used:',i3,' for derivative ',a/,
     *       15x,' Block     Trials    to explore    Procedure')
  250 format(15x,i3,2i12,8x,a)
!
      end
!-----------------------------------------------------------------------
      subroutine BlockPh(ier, iPlotTypeSWRC, ifFromGraphic, ifBreak)
      USE General
      USE Symmetry
      USE Riflessi
      USE HistoStuff
      USE Atomi
      USE Molcom
      USE Html
      USE PhaseModule
      USE RfacMatrixModule
      USE Mappa
      USE RemoModule
      USE VLDmod, only : nTrialsVLD
      USE Riflessi_App
!
      integer :: doRicicla, stampaInfo
      real    :: VettRisultati(10)
      common /modifica_DSR/ kdsr, kdsrReq, ifPeak, nolsqReq
!
      call AllocaRiflessi_App(1)
!
cdedi
      if (nsym.eq.1.and.icent.eq.0.and.kverbo.eq.0) then
*         ifExamin = 0
      endif
!
      if (jscreen > 0 .and. ifMadEnv == 0) then
          call AbilitaSkipeStop()
      endif
!
      facMato2  = 0.
      facMave  = 0.
      itots = 0
!XtalView
!      if (kmad /= 0) then
!          if (knw.gt.0) then
!             do i=1,nrefl
!                tmpwt(i) = wt(i)
!                wt(i) = 1.
!                fcoef(i) = evet(i)
!                iphaz(i) = ipub(i)
!             end do
!             jpatt = 0
!             call MakeMap(fcoef, iphaz, nrefl, jpatt, xmap,
!    *                FORTH, BACK)
!             kWriO_Map = 0
!             MapNumber = kWriO_Map
!             iWriMap   = -1
!             iGiaFatta =  1
!             call Scrivi_Mappa_Xtal(nrefl,MapNumber,xmap_div,iGiaFatta)
!             do i=1,nrefl
!                wt(i) = tmpwt(i)
!                iphaz(i) = 0
!             end do
!          endif
!      endif
!XtalView


!
      call fomspinit
      call AllocaMappaSnip(1)
!
      WhichBlock = 0
      nuset = 0
      numbrun = 0
      MaxRunTot = 0
      ifPattSav = ifPatt
      jCountRun = 0
!
      numbSet = 0
      sumFFom = 0.0
!
      do jBlock = 1, nBlocksPh
!
         if (ifMadEnv == 0) then
!!           inumC = MaxToStore*1000 + jBlock*1000000       !mr
             inumC = 0
!!           call c_scr2(-2, inumC, ' ')                    !mr
             call c_scr2(-2, inumC, MaxToStore, jBlock, nBlocksPH, ' ')    !mr
         endif
!
         if (ifCycTang > 0) then 
             numbrun = jCountRun
         endif
         erm1min = erm1sav
         ifPatt = ifPattSav
c        write(6,*) 'BLOCK jBlock, ifPatt',jBlock, ifPatt
         if (kverbo>0) call CPUTime0('inizio blocco')    !pgMAD2507
         MaxRun = jBlocksPh(1,jBlock)
         MaxRunTot = MaxRunTot + MaxRun

         if (jrest.ne.2) then
             jRfac = 0
             if (ifPatt == 0) then
                 RfacMatrix(:,:,jBlock) = 0.0
                 RfacMatrix(2,:,jBlock) = -9999.9      !!!<<<
             endif
             RfacMatrix(3,:,jBlock) = -9999.9      !!!<<<
         endif
         MaxToStore = min0(jBlocksPh(2,jBlock),500)
!! PUNTO CRITICO
         if (jBlock == 1) then
             if (MaxToStore > 1 .or. nBlocksPh > 1) then
                 if (ifMadEnv == 0) then
                     iAction = -1
                     npunti = sum(jBlocksPh(1,:))
                     call DataForGraph(iAction, npunti)
                 endif
             endif
         endif
         nRfac    = 0
         WhichFom = 2
         SetsStored=0
         nsxx = MaxRun
         nfom0  = 0
         nfoml  = 0
         nSetStored = 0
         if (ifPatt == 0) then
             lungs = MaxToStore
!gl!         call nfrm16(nstr,lungs)          ! inizializzarla solo 1 volta
             call ManageInitialPhases(1, nstr, lungs)
         else
             lungs = MaxRun
!gl!         call nfrm16(numbLSQ,lungs)          ! inizializzarla solo 1 volta
Corig        call ManageInitialPhases(1, numbLSQ, lungs)
             call ManageInitialPhases(1, nrefl, lungs)     ! per lavorare con nrefl
         endif
!gl!     call ysfl16(cfom,ipos,idum)     ! eliminazione liste 31/03/2010
         ierrP  = 0
         if (ifPatt == 1) then
             FFfom0 = 0.001
             if (kverbo>0) call CPUTime0('inizio patterson')   !pgMAD2507
             call Patterson(inizTrial, ifinTrial, ierrP)
             erre = 9999
! ho commentato la seguente, serve questa stringa per Buccaneer
*            FraFilePath = ' '
             if (kverbo>0) call CPUTime('fine patterson', 1)    !pgMAD2507
             if (ierrP == -2) then
                 if (kfast /= -1 .and. nolsq /= 0) then
                     call Ricovera()
                     jscreenSav = jscreen
                     jscreen    = 1
                     kaction = 4
                     call build(kaction, 2)
                     jscreen = jscreenSav
                     iprinSav = iprin
                     iprin    = 2
                     krecy = 3000
                     kact  = 4
                     call outpea(kact)
                     iprin    = iprinSav
                 endif
                 WhichBlock = jBlock - 1
                 kWstop = 1
                 exit
             elseif (ierrP == -1) then
                 ifBreak = 1
                 return
             elseif (ierrP == -3) then
                 ier = -1
                 return
             endif
         else
             if (kverbo>0) call CPUTime0('inizio tangente')    !pgMAD2507
             if (jpfile < 0) then
                 tmpwt(:) = wt(:)
                 iphazo(:) = iphaz(:)
             endif
             call Tangent(inizTrial, ifinTrial)
             if (kverbo>0) call CPUTime('fine tangente', 1)
         end if

         if (SetsStored.lt.MaxToStore) then
             MaxToStore = SetsStored
         endif

         if (kmad /= 0) then
             do i=1, MaxToStore
                RfacMatrix(2,i,jBlock) = fomrt(i,5)
                RfacMatrix(1,i,jBlock) = fomrt(i,10)  !pgMAD 2223
             end do
             do i=MaxToStore+1, MaxRun
                RfacMatrix(2,i,jBlock) = -9999.9    !!!<<<
             end do
         end if
         call OrdinaStampaTrial(0,1)

         ier = 0
         if (jpfile == 0) then
             if (ifTang == 1) then
                write(lo,111) jBlock, nBlocksPh, inizTrial, ifinTrial
             else
                if (jBlock == 1 .and. MaxRun == 1) then
                    write(lo,112) inizTrial
                else
                    write(lo,113) inizTrial, ifinTrial
                endif
             endif
             call prtfom(ier)
         endif
         erm1sav = erm1min

         if (MaxToStore > 1) then
             kRfac = 1
             a = RfacMatrix(2,1,jBlock)
             if (kmad > 0) then
                iAction = 2
                npunti = MaxToStore
                call DataForGraph(iAction, npunti)
             endif
         endif



         if (ifCycTang > 0  .and. lasts < 3) then
             call SviluppaTangent(inizTrial,ifinTrial, 
     *                           ier,ifFromGraphic,ifBreak)

c           stop 12345
         endif

         if (jpfile == 0) then
             if (kmad == 0) then
                call AbInfo(1)
             else
                call MADInfo(jBlock-1)   !220305
             end if
         end if

         WhichFom = 3
         if (ifPatt == 1) ifPatt = 2

         RfacMatrix(4,:,jBlock) = -9999

         if (kfast.ne.-1) then
c-dedi
             if (lasts == 3 .and. ksize > 3) then
                 FinalFom = 99
                 kWstop = 1
                 ifRelaxTrial = 0
                 call EndDSR(corre, ifRelaxTrial)
                 WhichBlock = jBlock
                 exit
             endif
c-dedi
             if (jscreen > 0) then
                 if (MaxToStore > 1) then
                 endif
             endif
             btOld = bt    ! salvo il B di Wilson
             if (kverbo>0) call CPUTime0('inizio affinamento')
!
             if (jBlock == 1) then
!
! per definire la strategia DSR (indipendentemente da SIZE)  -- dedi 01/07/2011
!
                if (ifVLD == 0 .and. kdsrReq == 1) then   
                    kdsrReq = 2
                    ksize = kdsr       
                    call DefineEtc(ifPeak, kdsrReq)
                    call Define_Iteration()
                    if (nolsqReq /= 0) then
                        if (ksize <= 3 .or. kmad /= 0) then       !120105 !!!!PGBA120609
                            nolsq = -1
                        else
                            nolsq = 0
                        endif
                    else
                        nolsq = 0
                    endif
              
                    write(lo,199) 
                    call WriteStrategy_DSR(lo)
                    call WriteStrategy_DSR(ktml)
          
                    if (ifPatt /= 0) then
                        if (nIterazioni == 1) then
                            write(lo, 200) 
                        else
                            write(lo, 202) nIteraTot
                        endif
                    else
                        if (ifVLD == 0) then
                            if (nIterazioni == 1) then
                                write(lo, 203) 
                            else
                                write(lo, 206) nIterazTot
                            endif
                        else
                            write(lo, 205) 
                        endif
                    endif
                    write(lo,199) 
                endif
!
             endif
!
             call SviluppaTrials(ier, ifFromGraphic, ifBreak) 
!
             if (kWstop == 0) then
                 if (kmad == 0) then
                     if (Lung(HTMLstr) > 0) then
                         call AbInfo(3)
                         HTMLstr = ' '
                         call AbInfo(3)
                     endif
                 else
                     call WriteFinalMad(lo, 0)
                     call MADInfo(3)
                 endif
             else
                 nTrialsVLD = numbSet
                 call SolutionFound(1, 0)
             endif
!

             if CombinedFom = 0
!
             if (kverbo>0) call CPUTime('fine affinamento', 1)
             bt = btOld

             if (kverbo>0) call CPUTime('fine blocco', 1)    !pgMAD2507

             if (ifBreak == 1) then
                 return
             endif
             if (ier < 0) then
                 return
             endif
             if (kWstop.eq.1) then
                 WhichBlock = jBlock
                 exit
             endif
         else
             if (kverbo>0) call CPUTime('fine blocco', 1)    !pgMAD2507
             call scrper(' ', 0, -1)
             call PrintMess(' ')
         endif
!
      enddo
      if (kWstop.eq.1) then
          if (kmad == 1) then
              call MADInfo(2)
          endif
      endif
      if (WhichBlock == 0) then
          jBlock = nBlocksPh
      else
          jBlock = WhichBlock
      endif
!
      call ManagePhasesDSR(2,corre,0)
!
      if (kmad /= 0) then
          InfoOK(15) = 0
      endif
      iPlotType = iPlotTypeSWRC
      if (InfoOK(15).eq.1) then
!
          if (kmad == 0 .and. ifAutomatic == 0) then
              call ThFacTooBig(2)
          end if
!
          interp = 1
          call lastplot(rfac)
          if (nolsq /= 0) then
              call LastSFC(1, ier)
          endif
      endif
!pgMAD0512      call OrdinaStampaTrial(1,1)
!
**    call CloseViewer
      call DoAllGraphs()
      if (kmad > 0) then
          call OrdinaStampaTrial(1,1)       !pgMAD0512
      endif
!
      call AllocaPhaseStuff(2)
      call AllocaMappaSnip(2)
!

      if (kmad /= 0) then
          call Cancella( 5)
          call Cancella(12)
          call Cancella(15)
          call Cancella(22)
          QualeAbilita = 0
      endif
      if (nolsq == 0) then
          if (nSetsFineDSR > 0) then
              call Cancella( 5)
              call Cancella(12)
!              call Cancella(15)
              call Cancella(22)
              call scrper(' ', 0, -1)
!
cdedi - Fare la POSTDSR sul trial migliore (se non fatta per kWstop = 1)
c           numb = nstr
c           if (kmad == 0 .and. ksize > 3) then
c               if (ifExpanded > 0) then 
c                   ifExpanded = 0 
c                   ihmx = ihmxSav
c                   rhomax = maxval(rhov(1:nrefl))
c               endif
c               call PostDSR(numb,corre,ier)
c           endif
!
              numbGen = numbGenSav
              if (ifFreeLunch > 0) then
                  if (LowRes==1.and.numbGen > 0) then
                     ihmx(:) = ihmxExt(:)
                     rhomax = maxval(rhov(1:nreflTot))
                     call FreeLunch()
                  endif
              endif
*             iwork1(:) = iphaz(:)
*             work1(:) = wt(:)
*             if (knw == 1) then
*                 kverbo = 1
*                 call Trasla_Origine(nreflDim)
*                 kverbo = 0
*             endif
              if (ifAmb == 0) then
                  MSetsFineDSR = nSetsFineDSR
              else
                  MSetsFineDSR = 1
              endif
              if (kmad == 0) then
                  call MTZfiles(MSetsFineDSR, 0, 0)
              endif
              if (ifSkeleton == 0) then
*                 write(Msg,60) nSetsFineDSR
*                 HTMLstr = Msg
*                 call AbInfo(11)
*                 call PrintMess(Msg)
                  write(Msg,70) nSetsFineDSR ! , char(10)
              endif
              if (ifMadEnv == 0) then
                  Inte = 'Final Stage'
                  call MsgWinErr(Inte, Msg, INFO_WINDOW, nExitCode)
              else
                  k = index(Msg, 'MTZ')
                  Msg(1:k-1) = ' '
                  call shift(Msg, k)
                  call TestoGR(Msg, -1, 2, 3)
                  write(Msg,75) fomBest
                  HTMLstr = ' ' // Msg
                  call AbInfo(11)
                  call TestoGR(Msg, -1, 2, 3)
              endif
          endif
      endif
!
      if (kmad == 0) then
          call WriteFinalAll(lo)
      endif
!
      if (kfast /= -1) then
          call StoreCorrectPhases
      endif
!
      if (ifAmb > 0 .and. ksize > 3 .and. ifPhD == 0) then
!!!       doRicicla = 1
          doRicicla = 0
          stampaInfo = 1
          call Ricicla(VettRisultati, doRicicla, stampaInfo, ier)
      endif
!
      if (InfoOK(15) == 1) then
          QualeAbilita = 2
      elseif (InfoOK(17) == 1) then
          if (ifSkeleton == 0) then
              QualeAbilita = 1
          else
              QualeAbilita = 2
          endif
      endif
!
      call AllocaRiflessi_App(2)
!

!
      call ManageInitialPhases(2, 0, 0)
!gl!  if (size(model) > 1) then   ! in questo modo distrugge le info sul
!gl!      do i=2, size(model)     ! Best Trial (lista 32) in model(2)
      if (size(model) > 2) then
          do i=3, size(model)
             if (allocated(model(i)%atoms)) then
                 call DeallocaModello(i, ierr)
             endif
          enddo
      endif
!
      return
   60 format(i3,' set of phases available.')
   70 format(i3,' set of phases available.') ! ,a,'Click on Solve menu ',
!    *          'to manage them.')
   75 format('Best Final FOM value: ',f8.3)
  111    format(//,3x,
     *   'Summary for Block # ',i4,'/',i4,
     *   ' from trial ',i5,' to trial ',i5,/)
* 112    format(//,3x,
*    *   'Summary for Trials from ',i5,' to ',i5)
  112    format(/,' Results for Trial ',i5)
  113    format(/,' Results for Trials from ',i5,' to ',i5)
  190 format(/,' *** Warning *** ',/,
     *      ' *** RBC procedure allows only DSR strategy 
     *                          for small/medium sized molecules***',/)
  199 format(/,' ',78('+'),/)
  200 format(' Patterson Procedure will be used (',
     *       ' only one DSR iteration per trial)',/)
  202 format(' Patterson Procedure will be used (up to',i3,
     *       ' DSR iterations per trial)',/)
  203 format(' Direct Methods will be used (',
     *       ' only one DSR iteration per trial)',/)
  205 format(' VLD algorithm will be used',/)
  206 format(' Direct Methods will be used (up to',i3,
     *       ' DSR iterations per trial)',/)
      end
!-----------------------------------------------------------------------
      subroutine StoreCorrectPhases
      USE General
      USE PhaseModule
      USE Groups, only : nChainsInput
!
      implicit none
      integer :: MSetsFineDSR, ifAmbEnanSav
!
      if (ksize > 3 .and. ifPhD == 0) then
          if ((ifBUCCANEER == 1 .or. ifNAUTILUS == 1) 
     *         .and. nChainsInput > 0) then
              if (jEnan == 0) then
                  call LookForEnantiomorph
              endif
          endif
      endif
!
      if (knw == 1) then
          call Trasla_Origine(nreflDim)
      endif
!
      if (ksize > 3) then
          if (ifAmb == 0) then
              MSetsFineDSR = nSetsFineDSR
          else
              MSetsFineDSR = 1
          endif
          ifAmbEnanSav = ifAmbEnan
          ifAmbEnan = 0
          if (kmad == 0) then
              call MTZfiles(MSetsFineDSR, 0, 1)
          endif
          ifAmbEnan = ifAmbEnanSav
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Tangent(inizTrial, ifinTrial)
      USE General
      USE Symmetry
      USE Riflessi
      USE HistoStuff
      USE Atomi
      USE Molcom
      USE PhaseModule
      USE VLDmod
!
      character*11 tirang
      character*10 reje
      character*20 cara
      character*80 line
      dimension errori_tang(6), figure_tang(3,6)
!
      if (ifMDM == 1) then
         errori_tang(:) = 0.0
         figure_tang(:,:) = 0.0
      end if
!

      ifPert_tg = 0
      corre = 0.0
      nRfac    = 0
      WhichFom = 2

*     npercTr = 100
*     if (npercTr > MaxRun) then
*         npercTr = MaxRun
*     endif
      npercTr = MaxRun
      iperc0 = MaxRun / npercTr
      iperc = iperc0
      jperc=0
      call scrper(' ',0,0)             
!
      do ntrbl = 1, MaxRun

      if (jpfile == 0) then

!piero
         if (ifMDM == 0) then
             numbrun = numbrun + 1
         end if
!
         ifinTrial = numbrun

         jCountRun = jCountRun + 1
!dedi -- quando si usa starting trial (ifTrial = 2) 28/6/2011
!        il contatore nella barra deve ripartire da 1
         if (ifTrial == 2 .and. jCountRun > 1) then
             numbrunBar = numbrun - itria + 1
         else
             numbrunBar = numbrun
         endif
!dedi -- quando si usa starting trial
!
         if (MaxRun.gt.1) then
             if (numbTrials > 0) then
                 write(cara,2720) trialVett(jCountRun),MaxRunTot
             else
corig            write(cara,2720) numbrun,MaxRunTot
                 write(cara,2720) numbrunBar,MaxRunTot
             endif
         else
             if (numbTrials > 0) then
                 write(cara,2715) trialVett(jCountRun)
             else
corig            write(cara,2722) numbrun
                 write(cara,2722) numbrunBar
             endif
         endif
         call NoBlanks(cara,icara)
         if (ifMDM == 0) then
             write(line,2730) nstr,cara(1:icara)
         else
             write(line,2731) nstr,cara(1:icara)
         endif

         if (ntrbl.eq.iperc) then
             jperc=jperc+1
             iperc=iperc+iperc0
         endif
         call scrper(line,jperc,npercTr)
!

         if (ntrbl == 1) then
             inizTrial = numbrun
         endif
*gl*     if (ntrbl == MaxRun) then
*gl*         ifinTrial = numbrun
*gl*     endif
!--
         if (numbTrials.lt.0) then
             numbrun = itria
             numbTrials = 0
         elseif (numbTrials.gt.0) then  ! attenzione al valore di numbTrials per i blocchi in continuo = 0 ????
             numbrun = trialVett(jCountRun)
         elseif (numbTrials == 0 
     *    .and. ifCycTang > 0 .and. jBlock > 1) then  ! da usare con le pertubazioni in continuo
             numbrun = jCountRun
         endif
         call FindSeed(numbrun)
         nrun = numbrun   ! per restart
!piero
         if (ifMDM == 1) then
            call FindSeed_VLD(numbrun)
         end if
!--
         iyseed = iyrand
         sigm = s3s2
!piero
         if (ifMDM == 0) then
            inffom = 0
            call RandomPhases(inffom)
         else
            call RandomPhases_VLD
         end if
         if (lasts /= 3) then
             wt(nstr+1:) = 0.0
         endif
!
         izero = 0
         ifmin = 1
         call examin(numbrun,mkang,khl,ipub,iphaz,nrefl,izero,wt,ifmin)
!
         if (lasts <= 1) then
             irefin(:) = 0.
             do i=1,nstr
                BackPh(i) = iphaz(i)*10000 + wt(i) * 1000
             end do
             if (ifMDM == 0) then
                call weitan(numbrun, nstr)
             else
                call weitan_MDM(numbrun, nstr)
             end if
*            ifProva = 0
*            call weitan2(ifProva)
             nwtgt0 = 0
             do i=1,nstr
                if (wt(i).gt.0.00001) nwtgt0 = nwtgt0 + 1
             enddo
*            if (ifProva == 1) then
*                do i = 1,nstr
*                   if (ianto(i) == 0) then
*                       wt1000 = mod(BackPh(i),10000.)
*                       BPh = BackPh(i) - wt1000
*                       iphaz(i) = nint(BPh / 10000)
*                       wt(i) = wt1000 / 1000
*                   endif
*                enddo
*            endif
c       ifmin = 1
c       call examin(numbrun,mkang,khl,ipub,iphaz,nrefl,izero,wt,ifmin)
c       tirang = 'TANG.'
c       ipher = 1
c       call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
c    *                  ipub,iphaz,wt,10,0.0,ipher)
             if (nwtgt0.lt.5) then
                 do i = 1,nstr
                    wt1000 = mod(BackPh(i),10000.)
                    BackPh(i) = BackPh(i) - wt1000
                    iphaz(i) = nint(BackPh(i) / 10000)
                    wt(i) = wt1000 / 1000
                 enddo
             else
                 if (ifRescale.eq.1) then
                     do i = 1,nstr
                        if (wt(i).lt.0.000001) then
                            alphaVet(i) = 0.0
                        endif
                     enddo
                     nperc = nstr*0.1
                     WtRef = 0.3
                     call RiscalAlfa(nstr,nperc,WtRef)
                 endif
             endif
         endif   ! if lasts

         else

             if (jpfile < 0) then
                 inizTrial = 1
                 ifinTrial = 1
                 wt(:) = tmpwt(:)
                 iphaz(:) = iphazo(:)
             endif
         endif
         if (ifExamin.ne.0) then
             izero = 0
             ifmin = 0
c            ifmin = 1
             nnrefl = nrefl
!p&c             
             ifTimeSav = ifTime
             if(ifTime == 1 .and. ifMDM == 1) then
                 ifTime = 0
             end if
             call examin(numbrun,mkang,khl,ipub,iphaz,nnrefl,izero,
     *                            wt,ifmin)
             ifTime = ifTimeSav
!p&c
c-- info distribuzione errore
c       ifmin = 1
c       call examin(numbrun,mkang,khl,ipub,iphaz,nrefl,izero,wt,ifmin)
c       tirang = 'RISCA'
c       ipher = 1
c       call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
c    *                  ipub,iphaz,wt,10,0.0,ipher)
c-- info distribuzione errore

!            write (lo,30)  numbrun,erore, erorepes, isumal
             if (knw == 1) then
                 if (jpfile < 0) then
                     write (lo,33) numbrun,erore,erorepes,isumal
                 else
                     write (lo,31) numbrun,erore,erorepes,isumal,iyseed
                 endif
             endif
             er_tang   = erore
             erp_tang  = erorepes
             isum_tang = isumal
             erp_tang  = erorepes
             if(ifMDM == 1) then
                errori_tang(ntrbl)=  erore
             end if
         endif
!
         call absnew()
c
         if (ifOldFoms == 0) then
             if (ksize <= 3 .or. icent == 1 .or. lproj /= 0 .or.
     *           ifMDM == 1) then
                 call Calcola_FOM_Early(corre)
             else
                 call Mappa_Su(sufom)
                 if (no(nk) >= 20) then
                     FOMs(1,4)=sufom/10.
                 else
                     FOMs(1,4)=1000./sufom
                 endif
             endif
         endif

! le seguenti servono a forzare l'ordine se si richiedono piu' trials
! nella versione distribuita solo un trial e' permesso 
         if (ntria == 1 .or. lasts > 0) then 
             FOMs(1,4) = 11 - jCountRun
             ifCombinedFom = 0
         endif
         if (knw == 1) then
             call toflush()
         else
             corre = 0.0
             er_tang = 0.0
         endif

C-- Mappa Xtal dopo tangente

*        if (iWriMap == 0 ) then
*            kWriMap = 100 
*            fcoef(1:nstr) = evet(1:nstr)
*            tmpwt(1:nstr) = wt(1:nstr)
*            invflag   =  0     !  Non modifica la densita'
*            call Mappe(nstr)
*            wt(1:nstr) = tmpwt(1:nstr)
*        endif
C--
         nuset = numbrun
         call fomsp(nuset, reje)
         stampa( 7) = FOMs(1,1)
         stampa(11) = FOMs(1,2)
         stampa(12) = FOMs(1,3)
         stampa(13) = FOMs(1,4)
         stampa(14) = corre
         if (ifOldFoms == 1) then
             FOMs(1,4)=coms
             write(lo,"(' Trial #',i6,'   cFom =',f6.3)") numbrun, coms
         endif
c--
         if (knw.gt.0.and.lasts.le.1) then
             if (kverbo /= 0) then
                 write(lo,50) 
     *                (stampa(i),i=3,5),(stampa(i),i=8,10),
     *                (stampa(i),i=11,14),reje(1:Lung(reje))
             endif
             if (isumal.gt.nstr/2.and.erore.le.80.0) then
                  if (kmad == 0) then
                      if (erore > 0) then
                          best_trial =float(isumal)*(corre/erore)
                      else
                          best_trial =float(isumal)*corre
                      endif
                  else
                      best_trial = 0.0
                  endif
                  write(jerr,55) numbrun,er_tang,erp_tang,
     *                  isum_tang,FOMs(1,4),corre,best_trial
***               call flush(jerr)
             endif
             call toflush()
         endif
c--
         if (knw.ne.0.and.erm1min.lt.999.0) then
             write(lo,'(a,f6.2,a,f9.0,i12)') 
     *             '    Errore minimo=',erm1min,
     *             '    nel trial ',setmin
         endif
!--
         if (knw == 1) then
             call toflush()
         endif
!-- eFOM's
         eFom = FOMs(1,4)
         call ManageEarlyFom(eFom, corre, er_tang)

         if (ifMDM == 1) then
            call salvafasi(1,eFom,corre,0)
         end if
!
         iBF = ifBreakFun()
         if (iBF /= 0) then
             write(lo,60) numbrun
             exit
         endif

         if (ifMDM == 1) then
            figure_tang(1,ntrbl) = eFom
            figure_tang(2,ntrbl) = FOMs(2,2)
            figure_tang(3,ntrbl) = FOMs(2,3)
         end if
!--
      enddo
!--
      if (ifMDM == 1) then
       call salvafasi(2,0.0,0.0,0)
       if (knw == 1) then
           write(lo,'(a,f10.6)')'recuperato il modello con FOM =',
     *                           fomBestVLD
c          write(lo,'(a,i5,6f10.6,/,a,i5,6f10.6)')
c    *      ' MPE ==',numbrun,(errori_tang(i),i=1,6),
c    *      ' FOM ==',numbrun,(figure_tang(1,i),i=1,6)
           i = 1
           write(lo,'(a,i5,4f10.6)') 
     *          'tang ==',numbrun,errori_tang(i),figure_tang(1,i),
     *           figure_tang(2,i),figure_tang(3,i)
       endif
       fomBestVLD = -9999
       fomBest = -9999.9

      end if
!
      return
!
   31 format(/,' Trial #',i6,' - Mean Phase Error ',f6.2,
     *'  (',f6.2,')  over',i8,' reflections  SEED =',i12)
   33 format(/,' Trial #',i6,' - Mean Phase Error ',f6.2,
     *'  (',f6.2,')  over',i8,' reflections')
   50 format(' FOMs',4f7.3,1x,2f6.2,4f7.3,2x,a)
   55 format (i6,')',2f8.2,i8,3f8.3,4f8.2)
   60 format(/,
     *       '    **** SDM procedure stopped at trial #',
     *        i6,' ****',/)
 2715 format(2x,i5)
 2720 format(2x,i5,'/',i5)
 2722 format(2x,i5) 
 2730 format('SDM - Assign phases to',i5,' reflections for trial ',a)
 2731 format('MDM - Assign phases to',i5,' reflections for trial ',a)
      end
!-----------------------------------------------------------------------
      subroutine Cicli_Perturbation_tg(er_tang,isum_tang,corre,ier)
      USE General
      USE Symmetry
      USE Riflessi
      USE Psi0Stuff
      USE PhaseModule
!
      character*11 tirang
      real Fom_best(2,5)
      real wt_sav(4000)
      integer iphaz_sav(4000)
!psie      
!psie      real wt_sav(12000)
!psie      integer iphaz_sav(12000)
!
      ier = 0
      if (jpfile /= 0 .or. lasts > 1) return
!
      ifErrMin = 0   ! non memorizza MPE minima entro i cicli

      call FindSeed(numbrun)
      iyseed = iyrand
c--  Prova cicli di tangente con perturbazione delle fasi
      iphaz_sav(:) =  0
      wt_sav(:) = 0.0
      iphazo(1:nstr) = iphaz(1:nstr)
      worko(1:nstr) = wt(1:nstr)
C     Fom_best(:,:) = FOMs(:,:)

      nPert = 0
      call Calcola_FOM_Early(corre)
      if (knw /= 0 ) write(lo,10) nPert,numbrun,FOMs(2,4),corre

      Fom_best(:,:) = -999.9     ! prova per saltare la 1a tg

      nPert_best = 0
      if (knw == 1) then
          corre_best = corre
          err_tg = er_tang
          isumal_tg = isum_tang
      endif

      kTang = 1
      nPert = 0
      nPertMax = 3 !10  
      CicliTang: do while (kTang.eq.1)

           iphaz(1:nstr) = iphazo(1:nstr)
           wt(1:nstr) = worko(1:nstr)
           nPert = nPert + 1
           irefin(:) = 0.

           izero = 0
           ifmin = 1
           call examin(numbrun,mkang,khl,ipub,iphaz,nstr,izero,wt,ifmin)
c          tirang = 'TANG.'
c          ipher = 1
c          call pherrdisNew(tirang,wt,khl,mkang,nstr,izero,
c    *                  ipub,iphaz,wt,10,0.0,ipher)
           ifl_prt = 1    ! 0 - 180 
           call RandomPerturbation(ifl_prt,nPert,ier)
c          call RandomPerturbation_New(nPert,ier)
!
            nTangMax =  5  
c           nTangMax =  3   !5  
            call Cicli_Tangent_Fall(nTangMax, ier)
!

             if (knw == 1) then
                 izero = 0
                 ifmin = 0
                 ifmin = 1
                 call examin(numbrun,mkang,khl,ipub,iphaz,nrefl,izero,
     *                            wt,ifmin)
                write (lo,30)  numbrun,erore, erorepes, isumal,iyrand
            endif

!           call absnew()
c
            call Calcola_FOM_Early(corre)
            if (knw /= 0 ) write(lo,10) nPert,numbrun,FOMs(2,4),corre

            if (FOMs(2,4) >= Fom_best(2,4)) then
                Fom_best(:,:) = FOMs(:,:)
                if (knw == 1) corre_best = corre
                nPert_best = nPert
                iphaz_sav(1:nstr) = iphaz(1:nstr)
                wt_sav(1:nstr) = wt(1:nstr)
            endif
            if (nPert >= nPertMax) then
                kTang = 0
            endif

      end do CicliTang

      iyrand = iyseed
      ifErrMin = 1

      if (nPert_best > 0) then
          iphaz(1:nstr) = iphaz_sav(1:nstr)
          wt(1:nstr) = wt_sav(1:nstr)
      else
          iphaz(1:nstr) = iphazo(1:nstr)
          wt(1:nstr) = worko(1:nstr)
      endif
      iphaz(nstr+1:) = 0
      wt(nstr+1:) = 0.0
      call Calcola_FOM_Early(corre)
      if (knw == 1) then
          izero = 0
          ifmin = 1
          call examin(-numbrun,mkang,khl,ipub,iphaz,nstr,izero,wt,ifmin)
          err_pt = erore
          isumal_pt = isumal
          kstp = 1
          call Calcola_CC_Mappa(nstr,corre,kstp,2)
      
*         write(lo,40) numbrun,Fom_best(2,4),corre_best,
          write(lo,40) numbrun,FOMs(2,4),corre,
     *             nPert_best,err_tg,isumal_tg,err_pt,isumal_pt
             
      else
c         write(lo,50) numbrun,Fom_best(2,4),nPert_best
          write(lo,50) numbrun,FOMs(2,4),nPert_best
      endif
!
c     call Doppia_Perturbation_tg(er_tang,isum_tang,corre,ier)
!
      ifPert_tg = 0 
!
      return
!
   10 format(' Pert #',i6,' Trial #',i6,' Pert-FOMs',f12.3,
     *       '  Initial CC_Map = ',f6.3)
   30 format(/,' Trial #',i6,' - Mean Phase Error ',f6.2,
     *'  (',f6.2,')  over',i8,' reflections  RAND =',i12)
   40 format(/,' Trial #',i6,' BFOM  = ',f12.3,
     *         ' BCORR = ',f6.3,' nPert =',i3,
     *         ' Err-ini =',f6.2,' nr_ini =',i6,
     *         ' Err-fin =',f6.2,' nr_fin =',i6)
   50 format(/,' Trial #',i6,' BFOM  = ',f12.3,' nPert =',i3)
      end
!-----------------------------------------------------------------------
      subroutine Cicli_Tangent_Fall(nTangMax, ier)
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
      USE Psi0Stuff
!
      integer iphaz_rif(4000)
      real    wt_rif(4000)
!psie      
!psie      integer iphaz_rif(12000)
!psie      real    wt_rif(12000)
      
      character*11 tirang
!
      FomAlfa = 0.1e-10
      iphaz_rif(:) =  0
      wt_rif(:) = 0.0

      ier = 0
      if (jpfile /= 0 .or. lasts > 1) return
!
c--  Prova riciclo tangente su fasi perturbate

      do nTang = 1, nTangMax
             irefin(:) = 0.
             work1(1:nstr) = wt(1:nstr)
             work2(1:nstr) = wt(1:nstr)
             nnn = nstr * 0.25
c            nnn = nstr * 0.333
             call sortall (-1,work1,nstr)
             sogalf = work1(nnn)
c            nnn = nstr * 0.50
c            nnn = nstr * 0.75 
c            sogalf2 = work1(nnn)
             do i = 1,nstr
                k = iordeTang(i)
                if (work2(k) > sogalf) then
                    irefin(k) = 1
!               elseif (work2(k) > sogalf2) then
!                   irefin(k) = 2
!               else
!                   irefin(k) = 3
!               else  !if (work2(k) < sogalf2) then
!                   wt(i) = 0.0
                endif
             enddo
!
         write(6,*) ' New Tangent #',nTang 

        izero = 0
        ifmin = 1
        call examin(numbrun,mkang,khl,ipub,iphaz,nstr,izero,wt,ifmin)
c       tirang = 'TANG.'
c       ipher = 1
c       call pherrdisNew(tirang,wt,khl,mkang,nstr,izero,
c    *                  ipub,iphaz,wt,10,0.0,ipher)


             call weitan(numbrun, nstr)

c       izero = 0
c       ifmin = 1
c       call examin(numbrun,mkang,khl,ipub,iphaz,nstr,izero,wt,ifmin)
c       tirang = 'NEW TANG.'
c       ipher = 1
c       call pherrdisNew(tirang,wt,khl,mkang,nstr,izero,
c    *                  ipub,iphaz,wt,10,0.0,ipher)


             nwtgt0 = 0
             do i=1,nstr
                if (wt(i).gt.0.00001) nwtgt0 = nwtgt0 + 1
             enddo
             if (nwtgt0.lt.5) then
             else
                 if (ifRescale.eq.1) then
                     do i = 1,nstr
                        if (wt(i).lt.0.000001) then
                            alphaVet(i) = 0.0
                        endif
                     enddo
                     nperc = nstr*0.1
                     WtRef = 0.3
                     call RiscalAlfa(nstr,nperc,WtRef)
                  endif
              endif

!            if (knw == 1) then
                 izero = 0
                 ifmin = 1
                 call examin(numbrun,mkang,khl,ipub,iphaz,nrefl,izero,
     *                            wt,ifmin)

! --  Nuova perturbazione soft
C               if (nTang < nTangMax) then
C                   ifl_prt = 2 
C                   call RandomPerturbation(ifl_prt,nPrt,ier)
C               endif
! --  Nuova perturbazione soft

c-- info distribuzione errore
c               tirang = 'NEW RISCA'
c               ipher = 1
c               call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
c    *                  ipub,iphaz,wt,10,0.0,ipher)
c-- info distribuzione errore

!               write (lo,30)  numbrun,erore, erorepes, isumal,iyrand
!           endif
!
! -- per ridurre i cicli di TNG interna
!
c        if (mod(nTang,2) == 1) then
c            call Calcola_FOM_Early(corre)
c            if (FOMs(2,4) < FomAlfa) then
c               kTang = 0
c            else 
c               FomAlfa = FOMs(2,4)
c               iphaz_rif(1:nstr) = iphaz(1:nstr)  
c               wt_rif(1:nstr) = wt(1:nstr)
c            endif
c        endif

      end do !nTang
!
! -- per ridurre i cicli di TNG interna
!
c     iphaz(1:nstr) = iphaz_rif(1:nstr)  
c     wt(1:nstr) = wt_rif(1:nstr)

 
      return
!
   30 format(/,' Trial #',i6,' - Mean Phase Error ',f6.2,
     *'  (',f6.2,')  over',i8,' reflections  RAND =',i12)
      end
!-----------------------------------------------------------------------
      subroutine Doppia_Perturbation_tg(err_tg,isumal_tg,corre,ier)
      USE General
      USE Symmetry
      USE Riflessi
      USE Psi0Stuff
      USE PhaseModule
!
      character*11 tirang
      real Fom_int(2,5)
      real wt_int(4000)
      integer iphaz_int(4000)
!psie
!psie      real wt_int(4000)
!psie      integer iphaz_int(4000)
!
      write(6,*) ' +++ DOPPIA PERTURBAZIONE +++'
      ier = 0
      if (jpfile /= 0 .or. lasts > 1) return
!
      call FindSeed(numbrun)
c--  Prova cicli di tangente con perturbazione delle fasi
      iphaz_int(:) =  0
      wt_int(:) = 0.0
      iphazo(1:nstr) = iphaz(1:nstr)
      worko(1:nstr) = wt(1:nstr)

      Fom_int(:,:) = FOMs(:,:)
      nPert_int = 10

      kTang = 1
      nPert = 0
      nPertMax = 2 
      CicliTang: do while (kTang.eq.1)

           iphaz(1:nstr) = iphazo(1:nstr)
           wt(1:nstr) = worko(1:nstr)
           nPert = nPert + 1
           irefin(:) = 0.

           izero = 0
           ifmin = 1
           call examin(numbrun,mkang,khl,ipub,iphaz,nstr,izero,wt,ifmin)
c          tirang = 'TANG.'
c          ipher = 1
c          call pherrdisNew(tirang,wt,khl,mkang,nstr,izero,
c    *                  ipub,iphaz,wt,10,0.0,ipher)
           ifl_prt = 1 
           call RandomPerturbation(ifl_prt,nPert,ier)
c          call RandomPerturbation_New(nPert,ier)
!
            nTangMax =  3  
            call Cicli_Tangent_Fall(nTangMax, ier)
!

             if (knw == 1) then
                 izero = 0
                 ifmin = 0
                 ifmin = 1
                 call examin(numbrun,mkang,khl,ipub,iphaz,nrefl,izero,
     *                            wt,ifmin)
                write (lo,30)  numbrun,erore, erorepes, isumal,iyrand
            endif

            call Calcola_FOM_Early(corre)
            if (knw /= 0 ) write(lo,10) nPert,numbrun,FOMs(2,4),corre

            if (FOMs(2,4) >= Fom_int(2,4)) then
                Fom_int(:,:) = FOMs(:,:)
                if (knw == 1) corre_best = corre
                nPert_int = 10 + nPert
                iphaz_int(1:nstr) = iphaz(1:nstr)
                wt_int(1:nstr) = wt(1:nstr)
            endif
            if (nPert >= nPertMax) then
                kTang = 0
            endif

      end do CicliTang


      if (nPert_int > 10) then
          iphaz(1:nstr) = iphaz_int(1:nstr)
          wt(1:nstr) = wt_int(1:nstr)
      else
          iphaz(1:nstr) = iphazo(1:nstr)
          wt(1:nstr) = worko(1:nstr)
      endif
      iphaz(nstr+1:) = 0
      wt(nstr+1:) = 0.0
      call Calcola_FOM_Early(corre)
      if (knw == 1) then
          izero = 0
          ifmin = 1
          call examin(-numbrun,mkang,khl,ipub,iphaz,nstr,izero,wt,ifmin)
          err_pt = erore
          isumal_pt = isumal
          kstp = 1
          call Calcola_CC_Mappa(nstr,corre,kstp,2)
      
*         write(lo,40) numbrun,Fom_best(2,4),corre_best,
          write(lo,40) numbrun,FOMs(2,4),corre,
     *             nPert_int,err_tg,isumal_tg,err_pt,isumal_pt
             
      else
c         write(lo,50) numbrun,Fom_best(2,4),nPert_best
          write(lo,50) numbrun,FOMs(2,4),nPert_int
      endif
!
      return
!
   10 format(' Pert #',i6,' Trial #',i6,' Pert-FOMs',f12.3,
     *       '  Initial CC_Map = ',f6.3)
   30 format(/,' Trial #',i6,' - Mean Phase Error ',f6.2,
     *'  (',f6.2,')  over',i8,' reflections  RAND =',i12)
   40 format(/,' Trial #',i6,' BFOM  = ',f12.3,
     *         ' BCORR = ',f6.3,' nPert =',i3,
     *         ' Err-ini =',f6.2,' nr_ini =',i6,
     *         ' Err-fin =',f6.2,' nr_fin =',i6)
   50 format(/,' Trial #',i6,' BFOM  = ',f12.3,' nPert =',i3)
      end
!------------------------------------------------------------------------------
      subroutine SviluppaTangent(inizTrial,ifinTrial, 
     *                           ier,ifFromGraphic,ifBreak)
!   --  da chiamare se ifCycTang > 0  e lasts < 3

      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Molcom
      USE Grafici
      USE Html
      USE Param
      USE RemoModule
      USE MadModule
      USE PhaseModule
      USE RfacMatrixModule
!
*gl*  common /cBarra/ nbarra, npercB, perc0B, percB, iipercB, jpercB
      integer WhichSet
      character TFom *9, stringa*2, SetStored*5     !140105
      character*10 reje
!pg080906
      common /FragContr/ ContrFra(300,300), Contrdmean(300,300),
     *                   ContrNum(300)
      common /MicroStructures/ BackMicro(4000)
      integer ContrFra, ContrNum

      dimension dmea(300),nPeaEq(300),numPeaEq(300)

      character*6 a6
!
      ifCycTang = ifCycTang + 1

         if (kmad == 0) then
            call AbInfo(1)
         else
            call MADInfo(jBlock-1)   !220305
         end if



      InfoOK(15) = 0
!
      if (TrerreBest > 0) then
          write(Msg,200) erreBest, nint(TrerreBest)
          call RunToolBar(1,Msg)
      endif
  200 format('Best R% = ',f6.2,'  in trial',i5)

      corre = 0.0
      call LoadInitialPhases(cfom, ipos, nset)
      nSetStored = nset
 
      nRfac = min0(500, jBlocksPh(1,jBlock) )
 
 
      numbrunSav = numbrun
      ifBreak = 0
!pgMAD1011
      if (WhichDeriv == 1 .and. kmad /= 0) then
          if (ifRidotta == 0) then
             write(Msg,31)
             call TestoGR(Msg, -1, 2, 2)
          end if
   31 format('The Tangent Modification procedure will be',
     *        ' performed.')
      endif
    1 format('For each selected trial, ',a,' reflections are used to',
     *       ' locate and refine the anomalous substructure.')
    2 format('For each selected trial, ',a,' reflections are used to',
     *       ' locate and refine the heavy atom substructure.')
    3 format('The best trials are expected to have ',
     *       'the lowest values of the ratio R% / f FOM.')
    4 format('The best trials are expected to have ',
     *       'the highest values of Final FOM.')
    5 format('Final FOM greater than ',f7.3,
     *       ' - Candidate solution found.')
!pgMAD1011
      write(lo,8) jBlock
    8 format(/,' ',78('+'),//,
     *     ' Phases Perturbation for Block #',i2,/)
      NWF = WhichFom
      WhichFom = 2
      if (kmad /= 0) then
          call DisegnaMad(1)
      endif

      WhichSet = 0
      WhichFom = NWF

      SetsStored = 0
      jCountRunST = 0
      jRfac = 0

      do ntrSv = 1, nSetStored
         jCountRunST = jCountRunST + 1
         call CalcolaBarra()
         nbarra = iabs(nbarra)
         if (nBlocksPh > 1) then
!!           inumC = ntrSv + MaxToStore*1000 + jBlock*1000000       !mr
             inumC = jBlock
         else
!!           inumC = ntrSv + MaxToStore*1000                    !mr
             inumC = 0
         endif
         if (ifMadEnv == 0) then
!!           call c_scr2(-2, inumC, ' ')                       !mr
             call c_scr2(-2, ntrSv, MaxToStore, inumC, nBlocksPH, ' ')   !mr
         endif
           numbrun = -ntrSv
           numset  = 0
           numb = nstr
           iphaz(:) = 0
           wt(:) = 0.0
           call GetWP(numb)   ! att. in GetWP carico nrefl
           numbrun = nint(fom(10))
!

!-- dedi per saltare trial con MPE > 70°/80°
c        if (knw.eq.1) then
c            nuset = 9876
c            izero = 0
c            ifmin = 0
c            call examin(nuset,mkang,khl,ipub,iphaz,numb,izero,
c    *                   wt,ifmin)
c            if (ksize < 3) then
c                ermpe = 70.0
c            else
c                ermpe = 80.0
c            endif
c            if (erore >= ermpe) cycle
c        endif
!-- dedi per saltare trial con MPE > 70°/80°

         do i=1,numb
            BackMicro(i) = float(iphaz(i)) + wt(i) + 1.0
         enddo

         nondet = nint( fom(6)/ float(nstr) * 100. )
         EarlyFom = fom(5)
!140105
         if (kmad == 1) then
            TFom = '   eFom ='
         else
            TFom = '   eFom ='
         end if
         if (knw.eq.0) then
             if (nondet.gt.0) then
                 write(lo,10) ntrSv,numbrun,TFom,EarlyFom,nondet
             else
                 write(lo,11) ntrSv,numbrun,TFom,EarlyFom
             endif
         else
             if (nondet.gt.0) then
                 write(lo,15) ntrSv,numbrun,TFom,EarlyFom,nondet,
     *                fom(7),fom(8)
             else
                 write(lo,16) ntrSv,numbrun,TFom,EarlyFom,
     *                        fom(7),fom(8)
             endif
         endif
   10    format(' Set',i6,'  Trial  ',i6,' ',a,5x,f7.3,
     *   ' Undetermined reflections ',i3,'%')
   11    format(' Set',i6,'  Trial  ',i6,' ',a,5x,f7.3)
   15    format(' Set',i6,'  Trial  ',i6,' ',a,5x,f7.3,
     *   ' Undetermined reflections ',i3,'%  MPE ',2f8.2)
   16    format(' Set',i6,'  Trial  ',i6,' ',a,5x,f7.3,
     *   '   MPE ',2f8.2)
!
         if (ifPatt == 0 .and. jpfile == 0) then
             wt(nstr+1:) = 0.0
             iphaz(nstr+1:) = 0
         endif

         ifExpanded = 0  ! altrimenti fa l'espansione per i trial successivi al primo
         ihmx=ihmxSav
         rhomax = maxval(rhov(1:nrefl))
!
         if (knw.eq.1) then
             nuset = 7771
             izero = 0
             ifmin = 1
             call examin(nuset,mkang,khl,ipub,iphaz,nrefl,izero,
     *                   wt,ifmin)
             er_tang  = erore
             erp_tang = erorepes
             isum_tang = isumal
c            call Calcola_FOM_Early(corre)
         endif

         call zflush

         if (ksize <= 3) then
             call Barra()
         endif
!
!pgMAD2907

              call Cicli_Perturbation_tg(er_tang,isum_tang,corre,ier)

               if (ifBreak == 1 .or. ier == -1) then   
                  return
               endif

               call absnew()


! le seguenti servono a forzare l'ordine se si richiedono piu' trials
! nella versione distribuita solo un trial e' permesso 
         if (ntria == 1 .or. lasts > 0) then 
             FOMs(1,4) = 11 - jCountRunST
             ifCombinedFom = 0
         endif
         if (knw == 1) then
             call toflush()
         else
             corre = 0.0
             er_tang = 0.0
         endif
C--
         nuset = ntrSv
         call fomsp(nuset, reje)
         stampa( 7) = FOMs(1,1)
         stampa(11) = FOMs(1,2)
         stampa(12) = FOMs(1,3)
         stampa(13) = FOMs(1,4)
         stampa(14) = corre
         if (ifOldFoms == 1) then
             FOMs(1,4)=coms
             write(lo,"(' Trial #',i6,'   cFom =',f6.3)") numbrun, coms
         endif
c--
         if (knw.gt.0.and.lasts.le.1) then
             if (kverbo /= 0) then
                 write(lo,50) 
     *                (stampa(i),i=3,5),(stampa(i),i=8,10),
     *                (stampa(i),i=11,14),reje(1:Lung(reje))
             endif
             if (isumal.gt.nstr/2.and.erore.le.80.0) then
                  if (kmad == 0) then
                      if (erore > 0) then
                          best_trial =float(isumal)*(corre/erore)
                      else
                          best_trial =float(isumal)*corre
                      endif
                  else
                      best_trial = 0.0
                  endif
                  write(jerr,55) numbrun,er_tang,erp_tang,
     *                  isum_tang,FOMs(1,4),corre,best_trial
             endif
             call toflush()
         endif
c--
         if (knw.ne.0.and.erm1min.lt.999.0) then
             write(lo,'(a,f6.2,a,f9.0,i12)') 
     *             '    Errore minimo=',erm1min,
     *             '    nel trial ',setmin
         endif
!--
         if (knw == 1) then
             call toflush()
         endif
!-- eFOM's
         eFom = FOMs(1,4)
         call ManageEarlyFom(eFom, corre, er_tang)
!
         iBF = ifBreakFun()
         if (iBF /= 0) then
             write(lo,60) numbrun
             exit
         endif
!--
      enddo  ! su nSetStored

         if (SetsStored.lt.MaxToStore) then
             MaxToStore = SetsStored
         endif

         if (kmad /= 0) then
             do i=1, MaxToStore
                RfacMatrix(2,i,jBlock) = fomrt(i,5)
                RfacMatrix(1,i,jBlock) = fomrt(i,10)  !pgMAD 2223
             end do
             do i=MaxToStore+1, MaxRun
                RfacMatrix(2,i,jBlock) = -9999.9    !!!<<<
             end do
         end if
         call OrdinaStampaTrial(0,1)

         ier = 0
         write(lo,111) jBlock, nBlocksPh, inizTrial, ifinTrial
         call prtfom(ier)
         erm1sav = erm1min

         if (MaxToStore > 1) then
             kRfac = 1
             a = RfacMatrix(2,1,jBlock)
             if (kmad > 0) then
                iAction = 2
                npunti = MaxToStore
                call DataForGraph(iAction, npunti)
             endif
         endif
!
      ifCycTang = ifCycTang - 1
!
      return
!
   50 format(' FOMs',4f7.3,1x,2f6.2,4f7.3,2x,a)
   55 format (i6,')',2f8.2,i8,3f8.3,4f8.2)
   60 format(/,
     *       '    **** SDM procedure stopped at trial #',
     *        i6,' ****',/)
  111    format(//,3x,
     *   'Summary for Block # ',i4,'/',i2,
     *   ' from trial ',i5,' to trial ',i5,/)
      end
!-----------------------------------------------------------------------
      subroutine MTZfiles(nSetsFineDSR, number, stampaInfo)
      USE General
      USE Riflessi
      USE Dialogo, only : ifMadEnv
      integer :: stampaInfo
      character stringa*20
!
      write(Msg,10) nSetsFineDSR, char(10), ' ', char(10)
      if (nSetsFineDSR == 1) then
          stringa = '1'
          k1 = 1
      else
          write(stringa,20) nSetsFineDSR
          call NoBlanks(stringa,k1)
      endif

      numbGen = 0
      k  = index(fname(1),'.bin')
      cardDiret = fname(1)(1:k-1)// '.mtz'
      MTZfile = cardDiret
      k1 = Lung(Msg)
      k2 = Lung(cardDiret)
      Msg(k1+1:) = 'MTZ file produced:' //  char(10) // cardDiret(1:k2)
      iAction = 0
      ier = 0
*     if (ifAmbEnan == 0) then   ! commentata da Gianluca 9/7/2015
          call WriteMTZ(1, number, nSetsFineDSR, stampaInfo, ier)
*     endif
      if (ier < 0) return
      call FilesInfo(iAction, nSetsFineDSR)
      numbGen = numbGenSav
      if (numbGen > 0) then
!
!-- trasformo gli E calcolati in F osservati per i riflessi generati
!          utilizza fcvet --> fovet
*         fcvet(nrefl+1:nreflTot) = evet(nrefl+1:nreflTot)   ????
          call E2F()
          call WriteMTZ(1, number, nSetsFineDSR, stampaInfo, ier)
          if (ier < 0) return
      endif
!
      return
   10 format(i3,' set of phases available. Click on Final Stage ',
     *          'Procedures (F.S.P.) to manage them.',a,a,a)
   20 format('[1-',i5,']')
      end
!-----------------------------------------------------------------------
      subroutine StampaMtzPdb
      USE General
      USE PhaseModule, only : nSetsFineDSR, erre, erore, ifExportShelx
      USE Molcom, only : color_GREEN, color_RED, jscreen, ModelToCompare
      USE Html
      USE TestModel
!
      implicit none
      integer :: L, Lung, ind
      logical :: Esiste
!
      if (ifWasRemo == 1) then
          return
      endif
!
      if (nSetsFineDSR > 0) then
          inquire (file=MTZfile,  exist = Esiste)
!
          if (Esiste) then
              if (nSetsFineDSR == 1) then
                  Msg = '1 set of phases stored in MTZ file:'
              else
                  write(Msg,'(i5,a)') nSetsFineDSR,
     *                             ' sets of phases stored in MTZ file:'
                  call OneBlankOnly(Inte)     
              endif
              L = Lung(Msg)
              ind = index(MTZfile, slash, .TRUE.)
              Msg(L+2:) = MTZfile(ind+1:Lung(MTZfile))
*             HTMLstr = Msg
              call AbInfo(5)
              if (jscreen ==0) then
                  write(lo,'(2x,a)') Msg(1:Lung(Msg))
              else
                  call TestoGR(Msg, color_GREEN, 2, 3)
              endif
          endif
!
          if (ifAmb == 0) then
              Msg = ' '
              if (ifExportShelx <= 0) then
                  Msg = '    Best model coordinates stored in PDB file:'
              else
                  Msg = '    Best model coordinates stored in INS file:'
              endif
              L = Lung(Msg)
              Msg(L+2:) = FichierOut(1:Lung(FichierOut))
              L = Lung(Msg)
              write(Msg(L+2:),10) erre*100
              HTMLstr = ' '
              call AbInfo(3)
              HTMLstr = Msg
              call AbInfo(3)
              call shift(Msg, L)
              write(lo,'(" ",a)') Msg(1:L)
              if (jscreen > 0) then
                  call TestoGR(Msg, color_GREEN, 2, 3)
              endif
              if (ModelToCompare == 1) then
                  call to_coord_sir(-1, nrefl)
                  write(lo,80) nint(vett_test(1:3)),erore,vett_test(4)
              endif
          endif
      else
          Msg = 'No sets of phases produced !!!'
          write(lo,'(2x,a)') Msg(1:Lung(Msg))
          if (jscreen > 0) then
              call TestoGR(Msg, color_RED, 2, 3)
          endif
      endif
!
      return
   10 format('(R =',f6.2,'%)')
   80 format(i5,' atoms published,',i5,' used, ',i5,' found. MPE =',
     *      f8.3,' <dist> = ',f8.3)
      end
!-----------------------------------------------------------------------
      subroutine SviluppaTrials(ier, ifFromGraphic, ifBreak) 
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Molcom
      USE Grafici
      USE Html
      USE Param
      USE RemoModule
      USE MadModule
      USE PhaseModule
      USE RfacMatrixModule
      USE VLDmod, only : nTrialsVLD
!
*gl*  common /cBarra/ nbarra, npercB, perc0B, percB, iipercB, jpercB
      integer WhichSet
      character TFom *9, stringa*2, SetStored*5     !140105
!pg080906
      common /FragContr/ ContrFra(300,300), Contrdmean(300,300),
     *                   ContrNum(300)
      common /MicroStructures/ BackMicro(4000)
      integer ContrFra, ContrNum

      dimension dmea(300),nPeaEq(300),numPeaEq(300)

      character*6 a6
!
      InfoOK(15) = 0
!
!g!   if (lproj /= 0) then
!g!       call Simmetria2D(lo)
!g!       ifFromGraphic = 0
!g!       call InitFour(ifFromGraphic,ier)
!g!   endif
!
      if (TrerreBest > 0) then
          write(Msg,200) erreBest, nint(TrerreBest)
          call RunToolBar(1,Msg)
      endif
  200 format('Best R% = ',f6.2,'  in trial',i5)
      if (kmad == 1) then
          nActSetStored = 0     !pgMAD110106
          ContrFra(:,:) = 0
          Contrdmean(:,:) = 0
          ContrNum(:) = 0       !pg080906
      endif

      corre = 0.0
      call LoadInitialPhases(cfom, ipos, nset)
      nSetStored = nset
 
      nRfac = min0(500, jBlocksPh(1,jBlock) )
 
 
      ifEnve_sav = ifEnve
      kfastSav = kfast
      numbrunSav = numbrun
      kfast = 0
      ifBreak = 0
      ifP1 = 0
      if (nsym == 1 .and. icent == 0) then
          ifP1 = 1
      endif
!pgMAD1011
      if (WhichDeriv == 1 .and. kmad /= 0) then
          if (ifRidotta == 0) then
             write(Msg,31)
             call TestoGR(Msg, -1, 2, 2)
          end if
   31 format('The Electron Density Modification procedure will be',
     *        ' performed.')
          call numbMAD(numbLSQ,ifRidotta,nn2,numb7)
          write(Inte,'(i10)') numb7
          call shift(Inte, k)
          if (kmad == 1) then
              write(Msg,1) Inte(1:k)
          else
              write(Msg,2) Inte(1:k)
          endif
          k1 = index(Msg,'refine the') + 6
          call TestoGR(Msg(1:k1), -1, 2, 2)
          call TestoGR(Msg(k1+1:), -1, 2, 2)
          call zflush
          call DoSingleIteration()
      endif
    1 format('For each trial, ',a,' reflections are used to',
     *       ' locate and refine the anomalous substructure.')
    2 format('For each trial, ',a,' reflections are used to',
     *       ' locate and refine the heavy atom substructure.')
   55 format('Final FOM greater than ',f7.3,
     *       ' - Candidate solution found.')
!pgMAD1011
      if (jpfile == 0) then
          if (ifTang == 1) then
               write(lo,8) jBlock
          endif
      endif
    8 format(/,' ',78('+'),//,
     *     ' Extending phases for Block #',i2)
      NWF = WhichFom
      WhichFom = 2
      if (kmad /= 0) then
          call DisegnaMad(1)
      endif
      if (kmad == 1) then
         evet_med = 0.0
         sigmav_med = 0.0
         do i=1,nreflTot
            evet_med = evet_med + evet(i)
            sigmav_med = sigmav_med + sigmav(i)
         end do
         evet_med = evet_med / nreflTot
         sigmav_med = sigmav_med / nreflTot
!         if (knw>0) write(lo,'(/,a,2f15.8,/)')    !pgMAD290409
!     *     ' Medie in SviluppaTria:R0a,sigma(R0a)=',evet_med, sigmav_med
      end if

      if (jBlock == 1 .and. ifPatt > 0) then
          if (kmad /= 2) then
              if (inBoxGr(3) >0) then
                nLinesGR=nLinesGRsaveBox(3)
              else
                nLinesGRsaveBox(3)=nLinesGR
              endif
          endif
          if (ifPatt == 0) then
              Msg = "<big><b>Phase refinement and extension:</b></big>"
          else
              Msg = "<big><b>Phase refinement:</b></big>"
          endif
          call TestoGR(Msg, color_RED, 2, 3)
          if (kmad == 0) then
              write(Msg,4)
              call TestoGR(Msg, -1, 2, 3)
              write(Msg,6)
              call TestoGR(Msg, color_GREEN, 2, 3)
          else
              write(Msg,3)
              call TestoGR(Msg, color_GREEN, 2, 3)
          endif
      endif
    3 format('The best trials are expected to have ',
     *       'the lowest value of R%/fFOM.')
    4 format('For each pivot Patterson peak phases are refined via Edm,'
     *       ' Vld and Free Lunch')
    6 format('The best trials are expected to have ',
     *       'the highest value of Final FOM.')

      WhichSet = 0
      WhichFom = NWF
      do ntrSv = 1, nSetStored

         NewPoint = .true.

         numbSet = numbSet + 1
         Iterazione = -999
         call CalcolaBarra()
         nbarra = iabs(nbarra)
         if (nBlocksPh > 1) then
!!           inumC = ntrSv + MaxToStore*1000 + jBlock*1000000       !mr
             inumC = jBlock
         else
!!           inumC = ntrSv + MaxToStore*1000                    !mr
             inumC = 0
         endif
         if (ifMadEnv == 0) then
!!           call c_scr2(-2, inumC, ' ')        !mr
             call c_scr2(-2, ntrSv, MaxToStore, inumC, nBlocksPH, ' ')  !mr
         endif
!d!      if (ksize > 3) then
!d!          numbrun = ntrSv
!d!          call CalcolaFasiPatt(ntrSv, ier)
!d!      else
           numbrun = -ntrSv
           numset  = 0
           numb = nstr
           iphaz(:) = 0
           wt(:) = 0.0
!
           evet(nrefl+1:) = 0.0    ! dedi 21/06/13 per azzerare estrapolati
!
           call GetWP(numb)
           numbrun = nint(fom(10))
*   9 format(a,'_',i5,'_PattVLD.txt')

      if (knw > 0) then
             nuset = 9876
             izero = 0
             ifmin = 1
             call examin(nuset,mkang,khl,ipub,iphaz,nrefl,izero,
     *                   wt,ifmin)
      endif

*          call WriteMTZ(1, 1, 0, 1, ier)   ! per Giuliana
*          if (ier < 0) return
!
!-- dedi per saltare trial con MPE > 70°/80°
c        if (knw.eq.1) then
c            nuset = 9876
c            izero = 0
c            ifmin = 0
c            call examin(nuset,mkang,khl,ipub,iphaz,numb,izero,
c    *                   wt,ifmin)
c            if (ksize < 3) then
c                ermpe = 70.0
c            else
c                ermpe = 80.0
c            endif
c            if (erore >= ermpe) cycle
c        endif
!-- dedi per saltare trial con MPE > 70°/80°

!d!      endif
         do i=1,numb
            BackMicro(i) = float(iphaz(i)) + wt(i) + 1.0
         enddo
C-ULTIM
c        if (knw.eq.1.and.ifPatt.ne.0) then
c            kstp = 0
c            call Calcola_CC_Mappa(nstr,corre,kstp,2)
c            fom(1) = corre
c            call Calcola_CC_Mappa(numbLSQ,corre,kstp,2)  ! croc
c            fom(2) = corre
croc
c            if(numbGen>0.and.iprin==3) then
c               call Calcola_CC_Mappa(nreflTot,corre,kstp,1)
c            endif
croc
c        endif
         nondet = nint( fom(6)/ float(nstr) * 100. )
         EarlyFom = fom(5)
!140105
         if (kmad == 1) then
            TFom = '   eFom ='
         else
            TFom = '   eFom ='
         end if
         if (jpfile == 0) then
             if (knw == 0) then
                 if (ifTang == 1) then
                    if (nondet.gt.0) then
c                      write(lo,10) ntrSv,numbrun,TFom,EarlyFom,nondet
                       write(lo,10) numbSet,numbrun,TFom,EarlyFom,nondet
                    else
c                      write(lo,11) ntrSv,numbrun,TFom,EarlyFom
                       write(lo,11) numbSet,numbrun,TFom,EarlyFom
                    endif
                 else
c                    write(lo,11) ntrSv,numbrun,TFom,EarlyFom
!                    write(lo,11) numbSet,numbrun,TFom,EarlyFom
                     write(lo,12) numbrun
                 endif
             else
                 if (nondet.gt.0) then
c                    write(lo,15) ntrSv,numbrun,TFom,EarlyFom,nondet,
                     write(lo,15) numbSet,numbrun,TFom,EarlyFom,nondet,
     *                    fom(7),fom(8)
                 else
c                    write(lo,16) ntrSv,numbrun,TFom,EarlyFom,
                     write(lo,16) numbSet,numbrun,TFom,EarlyFom,
     *                            fom(7),fom(8)
                 endif
             endif
         endif
*  10    format(/,'  Trial  ',i6,' ',a,5x,f7.3,
*    *   ' Undetermined reflections ',i3,'%',/)
   10    format(/,'Set',i6, '  Trial  ',i6,' ',a,5x,f7.3,
     *   ' Undetermined reflections ',i3,'%',/)
*  11    format(/,'  Trial  ',i6,' ',a,5x,f7.3,/)
   11    format(/,'Set',i6, '  Trial  ',i6,' ',a,5x,f7.3,/)
   12    format(/,' Trial',i5)
   15    format(/,' Set',i6,'  Trial  ',i6,' ',a,5x,f7.3,
     *   ' Undetermined reflections ',i3,'%  MPE ',2f8.2)
   16    format(/,' Set',i6,'  Trial  ',i6,' ',a,5x,f8.3,
     *   '   MPE ',2f8.2)
!
         if (lasts < 3) then
croc
c            if (numbGen == 0 .and. ifPatt == 0) then
             if (ifPatt == 0 .and. jpfile == 0) then
                 wt(nstr+1:) = 0.0
                 iphaz(nstr+1:) = 0
             endif
croc
         endif

         ifExpanded = 0  ! altrimenti fa l'espansione per i trial successivi al primo
         ihmx=ihmxSav
         rhomax = maxval(rhov(1:nrefl))
!
         if (kverbo.eq.1.and.knw.eq.1) then
             nuset = 7771
             izero = 0
             ifmin = 1
             call examin(nuset,mkang,khl,ipub,iphaz,numbLSQ,izero,
     *                   wt,ifmin)
             er_sav  = erore
             erp_sav = erorepes
         endif

         call zflush

         if (ksize <= 3) then
             call Barra()
         endif
         ifEnve = ifEnve_sav
!
         if (kmad == 0) then
             work1(:) = work2(:) ! x seleziona riflessi ad ogni superciclo
         endif
!
!pgMAD2907
         if (ifRidotta == 1) then
!            write(lo,'(/,a,/)') ' NIENTE EDM.........'
            do i=1,nRfac      !pgMAD0408
               if (nint(RfacMatrix(1,i,jBlock)) == numbrun) then
                  kRfac = i
                  exit
               endif
            enddo
         else
            if (lasts < 3) then
*              noDSR = 1    ! SOLO IMMAGINI X DAVIDE
               if (noDSR == 0 .and. jpfile == 0) then
                   call Cicli_DSR(ifBreak,corre,ier)
               endif
               if (ifBreak == 1 .or. ier == -1) then   ! dedi 29/04/09
                  return
               endif
               if (ier == -2) then   ! dedi 29/04/09
                   ier = 0
                   cycle
               endif
            endif
            call ClearMessage()
cdedi
!
             if (ifFromGraphic == 0) then
                 if (ksize <= 3) then  
                     ntrRelax = jBlocksPh(2,jBlock) / (jBlock + 1)
                     ntrRelax = max0(1, ntrRelax)
                     ntrRelax = min0(5, ntrRelax)
                 else 
                     ntrRelax = jBlocksPh(2,jBlock)
                 endif

                 if (ifRelax == 0 .and. ntrSv <= ntrRelax) then
                     ifRelax  = 1
                 endif

                 if (ksize > 3) then
!c!                  if (ResEff >= 1.50) then   !no Relax per bassa risoluzione
!c!                      ifRelax = -1
!c!                  else

!-- da controllare !!!
c                    if (ResEff >= 1.50) then   !no Relax per bassa risoluzione
c                       if (FinalFom < stopFinalFom * 0.95) ifRelax = -1
c                    endif
!-- da controllare !!!

!!!                      if (LowRes == 0) then
!!!                          coefR = 1.5
!!!                      else
!!!                          coefR = 1.25
!!!                      endif
!!!                      fff = stopFinalFom * coefR

c                        if (no(nk) >= NumeroAtomico) then  !in Relax se no(nk) < Ca 
!!!                          if (kWstop == 1 .and. 
!!!  *                           FinalFom_DSR >= fff) then
!!!                              ifRelax = -1
!!!                              if(knw == 1) then
!!!                                 write(6,*)
!!!  *                              ' *** NO RELAX ***',FinalFom_DSR,fff
!!!                              endif
!!!                          endif
!                        else 
!                            ifRelax  = 1
c                        endif

!c!                  endif
                 else
                     if (kWstop == 1.or.lasts/=0) then
                         ifRelax = -1
                     endif
                 endif
! uso delle diretive Relax o UnRelax
                 if (relaxReq == 1) then ! se ho richiesto Relax 
                      ifRelax = 1
                      ntrRelax = jBlocksPh(2,jBlock)
                 else if (relaxReq == -1) then
                      ifRelax = -1 ! direttiva UnRelax
                 endif
! no Relax se P1
                 if (nsym == 1.and.icent == 0) then  
                     ifRelax = -1
                 endif

             endif
cdedi
            numb = nstr
            if (kWstop == 1 .and. ifDsrVLD == 0) then ! vecchia procedura (DirectSpaceRefinement_NEW)
              if (kmad == 0 .and. ksize > 3) then
                  call PostDSR(numb,corre,ier)
              endif
            endif
!d!
            Final_info(1) = FinalFom
            Final_info(5) = 0.0
            if (knw == 1) then
                Final_info(1) = FinalFom
                Final_info(2) = erore
                Final_info(3) = erorepes
                Final_info(4) = corre
                Final_info(5) = 0.0
            endif
!d!
            ifRelaxTrial = 0
            call EndDSR(corre, ifRelaxTrial)
!
         end if  
!pgMAD2907
         if (ifBreak == 1) then
             ifBreak = 0
             kWstop = 0
             if (jscreen.eq.0) then
                 call PrintNoWindow(errem, FinalFom)
             endif
         else
!dedi
             ifRelaxSav = ifRelax
             if (nolsq /= 0) then
                 Fadlsq = 1
                 if (Fadlsq /= 0) then
                     kWstop = 0
                     if (ifRelax.eq.1) then
                         kcicla = 2
                     else
                         kcicla = 1
                     endif
                     fomNoWind = FinalFom
                     if (numbrun == 2) then
                         igian = 1
                     endif
                     call dlsq(ier,kcicla,erreNoWind, fomNoWind, 0,
     *                          ifBreak)
                     QualeAbilita = 2
                     if (kmad /= 0 .and. ier == -1234) then
                        ier = 0
                     endif
                     if (ier < 0 . or. ifBreak == 1) then
                         return
                     endif
                 else
                     if (jscreen.eq.0) then
                         call PrintNoWindow(errem, FinalFom)
                     endif
                 endif
             else
                 if (ifRelax == 1) then
                     numbR = min0(nreflDim,8000)
                     BackPh(1:numbR) = iphaz(1:numbR)
                     BackWt(1:numbR) = wt(1:numbR)
                     iphazo(1:numbR) = iphaz(1:numbR)
                     izero = 0
                     ifmin = 1
                     call examin(-111,mkang,khl,ipub,iphazo,numbR,izero,
     *                           BackWt,ifmin)
                     call Relax(ier, fomNoWind, ifGoOn, ifBreak)
                     if (jscreen > 0) then
                         Lab(1:nats) = aLab(1:nats)
                     endif
                     if (ifBreak == 1) then
                         return
                     endif
                 endif
             endif
             ifRelax = ifRelaxSav
         endif
!d!
         if (erre > 9000) then
             a6 = ' n.a. '
         else
             write(a6,'(f6.2)') erre*100.
         endif
c        if (knw == 1) then
c            if (Final_info(5) < 0.9) then
!                write(lo,100) ntrSv,numbrun,Final_info(1:4), a6
!                write(lo,100) numbSet,numbrun,Final_info(1:4), a6
c                write(lo,100) numbSet,numbrun,Final_info(1:4), ResEff
c            else
!                write(lo,101) ntrSv,numbrun,Final_info(1:4), a6
!                write(lo,101) numbSet,numbrun,Final_info(1:4), a6
c                write(lo,101) numbSet,numbrun,Final_info(1:4), ResEff
c            endif
*        else 
*            if (Final_info(5) < 0.9) then
*                write(lo,102) numbSet,numbrun,Final_info(1)
*            else
*                write(lo,103) numbSet,numbrun,Final_info(1)
*            endif
c        endif
  100    format(/,' SET ',i6,' TRIAL ',i6,' FFom =',f7.3,
!    *          ' MPE (MPEw)',2f7.2,' CC =',f7.3,' R% =',a6)
     *          ' MPE (MPEw)',2f7.2,' CC =',f7.3,' RES =',f6.2)
  101    format(/,' SET ',i6,' TRIAL ',i6,' FFom =',f7.3,
!    *          ' MPE (MPEw)',2f7.2,' CC =',f7.3, ' R% =',a6,
     *          ' MPE (MPEw)',2f7.2,' CC =',f7.3, ' RES =',f6.2,
     *                                                ' (Relax)')
  102    format(' Set ',i5,'  Trial  ',i6,'    FFom =',f7.3)
  103    format(' Set ',i5,'  Trial  ',i6,'    FFom =',f7.3,
     *                                                ' (Relax)')

! -- per non fermare il pgm in funzione della FFom
         if (ksize > 3) then
             if (FinalFom < FFomStopPGM) then
                 kWstop = 0
             else
                 kWstop = 1
             endif
         endif

         if (ntrSv == nSetStored .and. jBlock == nBlocksPh) then
             kWstop = 1
         endif
         if (corre > SogliaCorre .and. knw == 1) then
             kWstop = 1
         endif
!
         if (kWstop == 1) then
             if (nolsq /= 0) then
                 if (kmad == 1) then
                     call WriteFinalMad(lo, 0)
                 endif
!
!-- Final Interpretation
!
                 if (kmad == 0) then
                     call FinalInterpretation
                 endif
!
                 WhichSet = ntrSv
             endif
             exit
         endif
!
   20 format(/,1x, 78('+'),//,19x,
     1       '***   Final interpretation  ***',/,a,/)

      enddo  !  ntrSv

      if (kmad == 0 .and. ifRecovered == 0) then
      endif
      if (kmad /= 0) then
          call MADInfo(3)
      endif
!pgMAD110106
      if (kmad == 1 .and. kverbo>0) then
          write(lo,'(/,a,/)') 
     *          ' Tabella delle coincidenze dei picchi nei modelli'
          do i=1, nSetStored
             write(lo,30) i,(ContrFra(i,j),j=1,nSetStored)
          end do
          do i=1, nSetStored
            write(lo,40) i,(Contrdmean(i,j),j=1,nSetStored)
          end do
  30  format (i3,' - ',31i7)
  40  format (i3,' - ',31f7.3)
          do j=1, nSetStored
!             npt = 0
             dmea(:) = 0.0
             nPeaEq(:) = 0
             numPeaEq(:) = 0
             nEq = 0
             do i=1, nSetStored
                if (mod(ContrFra(j, i),1000)  > 0.75 * anat) then
                   nEq = nEq + 1
                   dmea(nEq) =  Contrdmean(j,i)
                   nPeaEq(nEq) = ContrFra(j ,i)/1000
                   numPeaEq(nEq) = ContrFra(j, i)
!                   ContrFra(j, i) = -ContrFra(i, j)
                end if
             end do
             if (nEq > 0) then
                 write(lo,6001) j,(nPeaEq(i),i=1,nEq)
                 write(lo,6002) (numPeaEq(i),i=1,nEq)
                 write(lo,6003) (dmea(i),i=1,nEq)
             end if
          end do
      endif
!pgMAD110106
 6001 format(' Il modello n.',i4,'  e'' equivalente ai modelli:',
     *       /,30i6)
 6002 format(30i6)
 6003 format(30f6.3)
!pgMAD1011
!      if (ilMilione == 0) then
**        if (kmad /= 0) then
          if (ifMadEnv /= 0) then
!pgMAD0112

              if (ifPatt == 0) then
                  if (kmad /= 2) then
                      if (inBoxGr(3) >0) then
                        nLinesGR=nLinesGRsaveBox(3)
                      else
                        nLinesGRsaveBox(3)=nLinesGR
                      endif
                  endif
              endif
!
              if (WhichDeriv == 1) then
                  if (ifPatt == 0) then
                      Msg = 
     *               "<big><b>Phase refinement and extension:</b></big>"
                      call TestoGR(Msg, color_RED, 2, 3)
                  endif
                  if (nolsq /= 0) then
                      write(Msg,3)
!?!                   call TestoGR(Msg, color_GREEN, 2, 3)
                  else
                      if (ifPatt == 0) then
                          write(Msg,4)
!?!                       call TestoGR(Msg, color_GREEN, 2, 3)
                      endif
!
! -- attenzione introdotta modifica se non si vuole fermare il PGM 
!
                      if (fomBest > FFomStopPGM) then
!                         write(Msg,55) sogFinalFom
!D                        write(Msg,55) stopFinalFom
                          write(Msg,55) FFomStopPGM
                          HTMLstr = ' ' // Msg
                          call AbInfo(11)
                          write(lo,"(/,' ',a)") Msg(1:Lung(Msg))
                          call TestoGR(Msg, color_LIGHTRED, 2, 3)
                          Msg = '-- Phase refinement procedure stops --'
*                         write(lo,"(/,' ',a)") Msg(1:Lung(Msg))
*                         call TestoGR(Msg, color_LIGHTRED, 2, 3)
*                         HTMLstr = Msg
*                         call AbInfo(9)
                      endif
                  endif
                  
              endif
              if (kmad > 0) then
                  write(SetStored,'(i5)') nActSetStored
                  call shift(SetStored, k0)
                  if (kmad == 1) then
                      write(Msg,32) SetStored(1:k0)
                  else
                      id = kfpfs(WhichDeriv)
                      write(stringa,'(a2)') nalf(id)
                      call lcase(stringa)
                      call ucase(stringa(1:1))
                      k1 = 2
                      if (stringa(2:2) == ' ') k1 = 1
                      write(Msg,33) SetStored(1:k0), stringa(1:k1)
                  endif
                  call TestoGR(Msg, -1, 2, 3)
              endif
          end if
!      endif
   32 format('At the end of the procedure ',a,' substructure models ',
     *        'have been stored.')
   33 format('At the end of the procedure ',a,' ',a,
     *       '-substructure models have been stored.')
!pgMAD1011
      if (WhichSet == 0) then
          ntrSv = nSetStored
      else
          ntrSv = WhichSet
      endif
    5 format('At this stage we have ',a,
     *       ' substructure models stored; ',
     *       'they will be submitted to phase extension and ',
     *       'refinement in order of R% / f FOM')
!
      nTrialsVLD = numbrun  ! per stampa su SolutionFound

      kfast = kfastSav
      numbrun = numbrunSav
      write(lo,1920)
 1920 format(/,1x, 78('+'),/)
!
      call DistruggiPianiAll
!
      return
      end
!-------------------------------------------------------------------------------
      subroutine Ricovera()
      USE General
      USE Symmetry
      USE Atomi
      USE Html
      USE Param
      USE RemoModule
      USE MadModule
      USE PhaseModule
!
      character*6 a6
!
!mr
      interface
         subroutine MiglioriErre(iAction, trial, trialv, erreV, str)
         USE General, only: MyStringa
           integer   :: iAction
           type(MyStringa), optional  :: str(*)
           integer, optional :: trial
           integer, optional :: trialv(*)
           real, optional    :: erreV(*)
        end subroutine MiglioriErre
       end interface
!end mr
!
      if (.not. allocated(natsInModel)) then
          WhichModel = 1
          call AllocaModelRemo(0)
          natsInModel(WhichModel) = MaxAtoms
          call AllocaModelRemo(1)
      endif
      call MiglioriErre(10)

      WhichModel = 0   ! gianluca strutture mad 31 marzo 2017

      call MiglioriErre(2)
      call PutGetBackUpXyzs(2)

      WhichModel = 1   ! gianluca strutture mad 31 marzo 2017
!
!
!--
!
      erreo = errem
      erre  = errem
      ifRecovered = 1
!     erreBest = errem                   ! gianluca 16/03/2009
      erreBest = errem * 100.0           ! gianluca 16/03/2009
!     if (kmad /= 0) then                ! gianluca 16/03/2009
!         erreBest = erreBest * 100.0    ! gianluca 16/03/2009
!     endif                              ! gianluca 16/03/2009
      TrerreBest = numbrun
      if (kmad == 0) then
          write(a6,'(i6)') numbrun
          call shift(a6, k1)
!         write(HTMLstr,25) a6(1:k1), erreBest*100.0              ! gianluca 16/03/2009
          write(HTMLstr,25) a6(1:k1), erreBest                    ! gianluca 16/03/2009
      endif
!
      interp = 1
      return
!
   25 format(' Best trial #',a,' recovered, R% = ',f12.2)
      end
!-------------------------------------------------------------------------------
      subroutine EndDSR(corre, ifRelaxTrial)
      USE General
      USE Riflessi
      USE Atomi
      USE Molcom     
      USE PhaseModule
      USE RfacMatrixModule
      USE VLDmod
!
      ifTime_sav = ifTime
      ifTime = 0
      nset = 0
      if (ifVLD == 0) then

c         call Prepara_EndDsr()
 
          do i=1,nRfac
             if (nint(RfacMatrix(1,i,jBlock)) == numbrun) then
                 kRfac = i
                 exit
             endif
          enddo
          RfacMatrix(3,kRfac,jBlock) = FinalFom
          RfacMatrix(6,kRfac,jBlock) = erore
          RfacMatrix(7,kRfac,jBlock) = erorepes
      else
          kRfac = numbrun
          RfacMatrix(1,kRfac,jBlock) = kRfac
          RfacMatrix(4,kRfac,jBlock) = erreBestVLD * 100.
      endif
      if (knw > 0) then
          write(6,*) 'EndDSR',krfac,RfacMatrix(1:4,kRfac,1)
      endif
      RfacMatrix(8,kRfac,jBlock) = corre
      if (MaxToStore > 1 .or. ifPatt == 1 .or. ifMadEnv > 0) then
          if (nolsq == 0 .and. kmad == 0) then
              iAction = 3
              npunti = 1
*             if (ksize > 3) then
*                 ifReduced = 1
*             endif
              call DataForGraph(iAction, npunti)
*             if (ksize > 3) then
*                 ifReduced = 0
*             endif
          endif
      endif
!
      if (numbrun == 6) then
          aaaaaa = 1111.111
      endif
      if (ifVLD == 0) then
          call ManagePhasesDSR(1, corre, ifRelaxTrial)
      endif
!
      if (FinalFom > fomBest) then
!         write(6,*) 'FINALFOM, FOMBEST',FinalFom,fomBest
          fomBest = FinalFom
          TrBestFom = numbrun
      endif
!
!     if (ksize <= 3 .and. LowRes == 1) nolsq = -1   ! dedi per non cancellare lista 15 e fare DLSQ (piccole con resol tagliata e senza estrapolazione)

      if (nolsq == 0) then
          call Cancella(15)
          nats = 0
          NatMol = 0
          NatInd = 0
      endif
!
      ifTime = ifTime_sav 
!
      return
      end
!-------------------------------------------------------------------------------
      subroutine conver()
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseStuff
      USE InvarStuff
      USE PhaseModule
!
      common /sigma/ NSPmed
      dimension lim1(4001),enil(4),bility(4),iphh(4),line(4,4),nnn1(4)
!psie
!psie      dimension lim1(12001),enil(4),bility(4),iphh(4),line(4,4),nnn1(4)

      common/dir10/numk,ntrs,ntr10,sogpo,sogne,nupos,nuneg,
     1 indpo,indne,nmxtn
      common /ConvComm/ NSigPos, SogPos, NSigNeg, NQuaNeg, inizNeg,
     *                  NPsiZero, numbReflTrip, SogNeg, SogQuaNeg
!psie
!psie      common /ConvComm/ NSigPos, SogPos, NSigNeg, NQuaNeg, inizNeg,
!psie     *                   NPsie,NPsiZero, numbReflTrip, SogNeg, SogQuaNeg
!
*     integer, allocatable :: iet(:,:)
*     integer, allocatable :: imat(:,:)
*     integer, allocatable :: ieq(:,:)
      integer, allocatable :: imat1(:,:)
!
!     call AllocaInvarStuff(1)
!
      if (ncountConver == 1) then
         alfaprimo(:) = 0.0
         icodeli(:) = 0.0
      endif
      ifinConver = nstr
      do i=1,ifinConver
         iordeTang(i)=0
         alfest(i)=0.
      end do
!
      call PreparaIph(4, ifinConver)
!
      n=0
      if (jtabl.ne.0) then 
         if (knw.eq.0) then
            write(lo,905)
         else
            write(lo,907)
         end if
      end if
  905 format(////47x,'table of estimated alpha',"'",'s',//
     * 4('  code  h   k   l    E  alpha')//)
  907 format(////47x,'table of estimated alpha',"'",'s',//
     * 3('  code    h   k   l   E    phi     alpha'),/)
      do 1150 ii=1, nstr
         i = ii
         alf1=0.
         call inter(i,alf1)
         alf1=abs(alf1)
         alfest(i)=alf1

         if (ncountConver == 1) then
             alfaprimo(i) = alfest(i) / evet(i)
         endif

         if (jtabl.ne.0) then
            n=n+1
            line(n,1)=i
            enil(n)= evet(i)
            line(n,2) = khl(1,i)
            line(n,3) = khl(2,i)
            line(n,4) = khl(3,i)
            bility(n)=alfest(i)
            if (knw.ne.0) then 
               iphh(n)=ipub(i)
               if(n.eq.3) then
                  write(lo,908) ((line(n,l),l=1,4),enil(n),
     *                            iphh(n),bility(n),n=1,3)
  908             format(3(i6,')',3i4,f6.2,i5,1x,f9.3))
                  n=0
               end if      
            else 
               if(n.eq.4) then
                  write(lo,906) ((line(n,l),l=1,4),enil(n),
     *                                    bility(n),n=1,4)
                  n=0
  906             format(4(i4,')',3i4,f6.2,f8.3))
               end if
            end if
         end if
 1150 continue
      if(n.ne.0 .and. jtabl.ne.0) then
         if(knw.eq.0) then
            write(lo,906)((line(m,l),l=1,4),enil(m),bility(m),m=1,n)
         else
             write(lo,908) ((line(m,l),l=1,4),enil(m),iphh(m),
     *                      bility(m),m=1,n)
         end if
      end if
c 
      do 1152 i=1, ifinConver
         iordeTang(i) = i
 1152 continue
c
      call sort3 (alfest,iordeTang, ifinConver)
c -----
c     call sub. lettura lista 9 : relazioni psi-zero
c     calcola alfest ed alfvar
c -----
c
!gl!  if (npsi.gt.0) then                      ! rimozione liste relazioni 31/03/2010
!gl!      iAll = 1                             ! rimozione liste relazioni 31/03/2010
!gl!      iDim = 3 * npsi                      ! rimozione liste relazioni 31/03/2010
!gl!      call sflxx(iprea,9,npsi,npsi,num0,   ! rimozione liste relazioni 31/03/2010
!gl! *               nxxe,iccd,iAll,imat,iDim) ! rimozione liste relazioni 31/03/2010
!gl!      do i=1,npsi                          ! rimozione liste relazioni 31/03/2010
!gl!         iph0n(i)=imat(1,i)                ! rimozione liste relazioni 31/03/2010
!gl!      enddo                                ! rimozione liste relazioni 31/03/2010
!gl!  endif                                    ! rimozione liste relazioni 31/03/2010
      npsi = NPsiZero
      num0 = nzro
      sigm = s3s2
      call rialfnew(sigm)
c
!     call AllocaInvarStuff(2)
!NEWPSI0
      if (ifNewPsi0 == 1) then
          if (npsi > 0) then
!gl!          call newpsi1(imat, ndim)
              call newpsi1
          else
              ifNewPsi0 = 0
          endif
      endif
!NEWPSI0
!
! -- DEDI -- Selezione dei riflessi sulla base di alfaprimo
!    si eliminano le relazioni per i riflessi con scarsa attendibilta'
!
      if (ifSelAlfa == 1 .and. ncountConver == 1) then
          call SelAlfa()
      endif
!
      if (ncountConver == ifSelAlfa + 1) then
          DEALLOCATE (imat, stat = ierr)
      endif
!
      return
      end
!------------------------------------------------------------------------------
      subroutine SelAlfa()

      USE General
      USE Riflessi
      USE PhaseModule


      zero = 0.00001
      ppp = 999
      n0 = nstr
      n00 = 0
! 
      icodeli(:)=0
      worko(:)=0.
!
      do i = 1, nstr
         worko(i) = alfaprimo(i)
      enddo
! 
corig elimalfa = 0.10
      if (elimalfa > 0.99999) elimalfa = elimalfa / 100.
      if (elimalfa > 0.30) then
          elimalfa = 0.30
      endif
      percalfa = 1.0 - elimalfa 
      call sortall(-1,worko,nstr)
      do j = nstr,1,-1
         if (worko(j) > zero) then
           n0 = j
           exit
         endif
      enddo
      n00 = nstr - n0
      ncond1 = nint(float(nstr) * percalfa)
      ncond1 = ncond1 - n00
      sog = worko(ncond1)
      sw1 = sum(worko(1:nstr)) / nstr

! -- istruzioni da commentare se si vuole eliminare una % specifica
c         ww1 = sw1 * 0.20  !0.333  !0.20   ! 0.25
c         sog = min(sog, ww1)
c         ww2 = 1.5 * worko(n0)
c         sog = max(sog, ww2)
! -- istruzioni da commentare se si vuole eliminare una % specifica

      nstrelimi = 0
      do i=1,nstr
         if (alfaprimo(i).lt.sog) then
             icodeli(i) = 1
             nstrelimi = nstrelimi + 1
         else
             icodeli(i) = 0
         endif
      enddo
      ppp = float(nstrelimi) / float(nstr)

      if (knw /= 0) then
          write(6,*) 
          write(6,*) ' Alfapr. Max',worko(1),' Alfapr. Min ',worko(nstr)
          write(6,*) ' Alfapr. Min > 0',worko(n0), 'Alfapr. Med ',sw1
          write(6,*) ' Soglia Alfaprimo ', sog,' % elim ',ppp*100
          write(6,*) ' Num. rifl. eliminati',nstrelimi,' su ',nstr
      endif
     
c     percTang = float(nstartTang) / float(nstr) 
c     nstrSel = nstr - nstrelimi 
c     nstartTang = nstrSel * percTang
c     nstr = nstrSel

      return
      end
!----------------------------------------------------------------------
!
!          Active use of psi-zero relationships
!
!----------------------------------------------------------------------
      subroutine AllocaPsi0Stuff(iAction)
      USE General
      USE PhaseModule
      USE Psi0Stuff
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
      dimension ierv(20)
!
      ierv(:) = 0
      ierr = 0
!
      if (iAction == 1) then
          IF (.NOT. ALLOCATED(ktheta))
     *     ALLOCATE (ktheta(1:nzro)    ,stat = ierv(1))
          IF (.NOT. ALLOCATED(alphap))
     *     ALLOCATE (alphap(1:nzro)    ,stat = ierv(2))
          IF (.NOT. ALLOCATED(a0est))
     *     ALLOCATE (a0est(1:nzro)   ,stat = ierv(3))
          IF (.NOT. ALLOCATED(a0var))
     *     ALLOCATE (a0var(1:nzro) ,stat = ierv(4))
          IF (.NOT. ALLOCATED(jph0))
     *     ALLOCATE (jph0(1:2*npsi) ,stat = ierv(5))
          IF (.NOT. ALLOCATED(limref0))
     *     ALLOCATE (limref0(1:nstr+num0+1) ,stat = ierv(6))
          IF (.NOT. ALLOCATED(klim0))
     *     ALLOCATE (klim0(1:nstr+num0+1) ,stat = ierv(7))
          IF (.NOT. ALLOCATED(nbinv0))
     *     ALLOCATE (nbinv0(1:3*npsi) ,stat = ierv(8))
          IF (.NOT. ALLOCATED(ee0))
     *     ALLOCATE (ee0(1:num0) ,stat = ierv(9))
          IF (.NOT. ALLOCATED(alpha0))
     *     ALLOCATE (alpha0(1:num0) ,stat = ierv(10))
          IF (.NOT. ALLOCATED(ntr0))
     *     ALLOCATE (ntr0(1:num0) ,stat = ierv(11))
cdedi
          IF (.NOT. ALLOCATED(alphapsi0))
     *     ALLOCATE (alphapsi0(1:nzro)    ,stat = ierv(12))
          IF (.NOT. ALLOCATED(alphapsi0_rif))
     *     ALLOCATE (alphapsi0_rif(1:nzro),stat = ierv(13))
          IF (.NOT. ALLOCATED(alphapsi0_sav))
     *     ALLOCATE (alphapsi0_sav(1:nzro),stat = ierv(14))
cdedi
          ierr = 0
          do i=1,20
             ierr = ierr + iabs( ierv(i) )
          enddo
          if (ierr.ne.0) then
              write(lo,*) 'Psi0Stuff Allocation error'
              call cstop(' ')
          endif
          ktheta(:)        = 0
          alphap(:)        = 0
          a0est(:)         = 0
          a0var(:)         = 0
          jph0(:)          = 0
          limref0(:)       = 0
          klim0(:)         = 0
          nbinv0(:)        = 0
          ee0(:)           = 0
          alpha0(:)        = 0
          ntr0(:)          = 0
          alphapsi0(:)     = 0
          alphapsi0_rif(:) = 0
          alphapsi0_sav(:) = 0
      else
          IF (ALLOCATED(ktheta))
     *        DEALLOCATE (ktheta, alphap, a0est, a0var, jph0,
     *                    limref0, klim0, nbinv0, 
     *                    ee0, alpha0, ntr0, alphapsi0, alphapsi0_rif, 
     *                    alphapsi0_sav, stat = ierr)
          if (ierr.ne.0) then
              write(*,*) 'Psi0Stuff DeAllocation Error'
              call cstop(' ')
          endif
      endif
!
      return
      end
!----------------------------------------------------------------------
      subroutine newpsi(k,sang,cang,nn0,tnd,alpham)
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
      USE Psi0Stuff
!
      nn0=0
      if (icent.le.0) then
          sigmaOld=2.0*s3s2
          q0=0.886
        else
          sigmaOld=s3s2
          q0=0.798
      endif
      li=limref0(k) + 1
      ls=limref0(k+1)
      if (ls >=  li) then
          ta=0.0
          tn=0.0
          td=0.0
          do j=li,ls
             ind=nbinv0(j)
             call depac0(k, ind, ifaz, iw, nn)
             k2=nn(1)
             k3=nn(2)
             nn3=nn(3)
             ka2=iabs(k2) - nstr
             ka3=iabs(k3)
! dedi
*            if (ktheta(ka2).ne.0.and.iphaz(ka3).ne.0) then
*                if (alphap(ka2).ge.a0var(ka2)) then   ! old
!new             if (alphap(ka2).ge.a0est(ka2)) then   ! new
*                    w= alphap(ka2)             / a0var(ka2)
*                    w=(alphap(ka2)-a0est(ka2)) / a0var(ka2)
*                    w=bes(w)
*                    aprimo=evet(k)*evet(ka3)*sigmaOld
*                    iarg = isign(ktheta(ka2),k2)
*    *                    + isign(iphaz(ka3),k3)
*    *                    + ifaz*15
*                    arg=float(iarg) * dtor
*                    tn=tn + w * aprimo * sin(arg)
*                    td=td + w * aprimo * cos(arg)
*                    nn0 = nn0 + 1
*                endif
*            endif

             if (ka2.le.0.or.ka3.le.0) then
                
                  ka2 = 9999

             endif
             if (ktheta(ka2).ne.0.and.iphaz(ka3).ne.0) then
c                w= alphap(ka2)             / a0var(ka2)
c                w=(alphap(ka2)-a0est(ka2)) / a0var(ka2)
                 if (alphap(ka2).ge.a0var(ka2)) then   ! old
!new             if (alphap(ka2).ge.a0est(ka2)) then   ! new
                     w=(alphap(ka2)-a0est(ka2)) / a0var(ka2)
                     w=bes(w)
                 else
                     w=(alphap(ka2) / a0var(ka2))
                     w=bes(w)
*                    w = 0.5 * w
                 endif
                 aprimo=evet(k)*evet(ka3)*sigmaOld
                 iarg = isign(ktheta(ka2),k2)
     *                + isign(iphaz(ka3),k3)
     *                + ifaz*15
                 arg=float(iarg) * dtor
                 tn=tn + w * aprimo * sin(arg)
                 td=td + w * aprimo * cos(arg)
                 nn0 = nn0 + 1
             endif
! dedi
          enddo
          tnd = sqrt(tn*tn+td*td)

          if (pts == 1) then ! dedi
              psog = 0.25
          else
!             psog = 0.20
              psog = 0.10
          endif
          soglia = sqrt(alpham) * psog
!         soglia = sqrt(alpham) * 0.30

*         write(6,*) 'newpsi',k,sang,cang,nn0,tnd,alpham
          if (tnd.lt.soglia) return
          sang  = sang - tn
          cang  = cang - td
      endif
!
      return
      end
!----------------------------------------------------------------------
!gl!  subroutine newpsi1(imat, ndim)
      subroutine newpsi1
      USE General
      USE PhaseModule
      USE PhaseStuff
      USE Psi0Stuff
!
!gl!  integer imat(3,ndim)
!
      call AllocaPsi0Stuff(1)
!
!gl!  iAll = 1                             ! rimozione liste relazioni 31/03/2010
!gl!  iDim = 3 * npsi                      ! rimozione liste relazioni 31/03/2010
!gl!  call sflxx(iprea,9,npsi,npsi,num0,   ! rimozione liste relazioni 31/03/2010
!gl! *           nxxe,iccd,iAll,imat,iDim) ! rimozione liste relazioni 31/03/2010
      jg=0
      ifaz=-1
      j=0
      do i=1,npsi
         imat1 = iabs(imat(1,i))
         call unpak3Sir(imat1,    kod2,kod3,ishif)
         call unpak3Sir(imat(2,i),kod1,kod2,ishif)
         kod1 = nstr + kod1
         jph0(j+1)=((kod1+4096)*8192+kod2+4096)*32+ifaz+1
         jph0(j+2)=((kod3+4096)*8192+jg+4096)*32+ishif+1
         j=j+2
      enddo
c
c   preparation of pointers table for psi-zero
c
      n1 = 0
      n2 = 0
      nb1 = nstr + num0 + 1
      limref0(1:nb1) = 0
      npsi0elimi = 0
      j = 1
      do i = 1,npsi
         call depac0(0, j, ifaz, iw, nn)
         j = j + iw
         nn2 = iabs(nn(2))
         nn3 = iabs(nn(3))
!!!!!!!!!!!!!!!!KRIS  ----  ciclo se uno dei riflessi e' quello che voglio scartare
             if (icodeli(nn2).eq.1.or.icodeli(nn3).eq.1) then
                 npsi0elimi = npsi0elimi + 1
                 cycle
            endif
!!!!!!!!!!!!!!!!KRIS 
         do kk = 1,3
            if (nn(kk).ne.0) then
                n1=iabs(nn(kk))+1
                limref0(n1) = limref0(n1) + 1
            endif
         enddo
      enddo
      do i = 1, nstr + num0
         limref0(i+1) = limref0(i+1) + limref0(i)
         klim0(i+1) = limref0(i+1)
      enddo
      klim0(1) = 0
      if (ncountConver == 2) then
         if (knw /= 0) then
            write(6,*) 
     *            ' Num. psi0        eliminate',npsi0elimi,' su ',npsi
            write(6,*) 
         endif
      endif
c
c  storage of the no. of relations for a given reflexion
      j = 1
      do i = 1,npsi
         call depac0(0, j, ifaz, iw, nn)
         jj = j
         j = j + iw
         nn2 = iabs(nn(2))
         nn3 = iabs(nn(3))
!!!!!!!!!!!!!!!!KRIS  ----  ciclo se uno dei riflessi e' quello che voglio scartare
             if (icodeli(nn2).eq.1.or.icodeli(nn3).eq.1) then
                 cycle
            endif
!!!!!!!!!!!!!!!!KRIS 
         do kk = 1,3
            if (nn(kk).ne.0) then
                ind=iabs(nn(kk))
                klim0(ind) = klim0(ind) + 1
                ind1= klim0(ind)
                nbinv0(ind1) = jj
            endif
         enddo
      enddo
      do i=1,nstr + num0
         n1=0
         n2=0
         lm=limref0(i)+1
         ls=limref0(i+1)
         if (lm.le.ls) then
             do ii=lm,ls
                ind=nbinv0(ii)
                call depac0(0, ind, ifaz, iw, nn)
                if (iw.eq.2) then
                    n1=n1+1
                else
                    n2=n2+1
                endif
             enddo
         endif
      enddo
      do i=1,num0
         alphap(i)=0.0
         ktheta(i)=0
         a0est(i)=0.0
         a0var(i)=0.0
      enddo
!
      npsi = npsi - npsi0elimi
!
      return
      end
!----------------------------------------------------------------------
      subroutine newpsi3(kweak)
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
      USE Psi0Stuff
!
*     integer i1(3),i2(3),i3(3)
!
      zer      = 0.1e-10
      if (icent.le.0) then
          sigmaOld = 2.0 * s3s2
          q0 = 0.886
      else
          sigmaOld = s3s2
          q0 = 0.798
      endif
c
      iarg = -99
      i=kweak
*     i1(1:3) = khl(1:3,i)
      ii=i+nstr
      alphap(i) = 0.0
      ktheta(i) = 0
      a0est(i)  = 0.0
      a0var(i)  = 0.0
      li = limref0(ii) + 1
      ls = limref0(ii+1)
      if (ls >= li) then
          ta = 0.0
          tn = 0.0
          td = 0.0
          jcont = 0
          do j=li,ls
             jcont = jcont+1
             ind = nbinv0(j)
             call depac0(0, ind, ifaz, iw, nn)
             k2   = -nn(2)
             k3   = -nn(3)
             ifaz = -ifaz
             ka2  = iabs(k2)
             ka3  = iabs(k3)
*            i2(1:3) = khl(1:3,ka2)
*            i3(1:3) = khl(1:3,ka3)
             if (iphaz(ka2).ne.0.and.iphaz(ka3).ne.0) then
                 iarg = isign(iphaz(ka2),k2)
     *                + isign(iphaz(ka3),k3)
     *                + ifaz*15
                 arg= float(iarg) * dtor
                 ee = evet(ka2) * evet(ka3) * sigmaOld
                 ta = ta + ee * ee
                 tn = tn + ee * sin(arg)
                 td = td + ee * cos(arg)
             endif
          enddo
          if (ta.gt.0.001) then
              ta = sqrt(ta)
              alphap(i) = sqrt(tn*tn + td*td)
              ip = 3600 + atan2(tn, td) * rtod
              ip = mod(ip, 360)
              if (ip.eq.0) ip = 360
              ktheta(i) = ip
              a0est(i)  = ta * q0
              a0var(i)  = ta
          endif
cdedi
         if (wt(ka2) > zer .and. wt(ka3) > zer) alphapsi0(i) = alphap(i)
cdedi
      endif
*     write(6,'(3i6,3f15.3)') i,ka2,ka3,evet(ka2),evet(ka3),ta
!
      return
      end
!----------------------------------------------------------------------
      subroutine newpsi4
      USE General
      USE PhaseModule
      USE Psi0Stuff
!
!-- compute alpha' and theta' respect to all refl.
!
      alphapsi0(:) = 0.0
      do ka2=1,num0
         call newpsi3(ka2)
      enddo
!
      return
      end
!----------------------------------------------------------------------
      subroutine depac0(i, ind, ifaz, iw, nn)
      USE General
      USE Psi0Stuff
!
      dimension nn(8)
!
      icod=0
      nn(:) = 0
      call unpak3Sir(jph0(ind), nn(1), nn(2), ifaz)
      call unpak3Sir(jph0(ind+1), nn(3), jg, ifaz)
      iw = 2
      if (i.ne.0) then
          jj = 0
          do j = 1,3
             if (iabs(nn(j)).eq.i) then
                 jj = j
             endif
          enddo
          if (jj.eq.0) then
              call cstop('rogramming error in subroutine depac0')
          endif
          isi = - isign(1,nn(jj))
          j1 = 1
          do jcris = 1,3
             if (jcris.ne.jj) then
                 nn(j1) = nn(jcris) * isi
                 j1 = j1+1
             endif
          enddo
          ifaz = ifaz * isi
          if (ifaz.lt.0) ifaz=ifaz+24
      endif
!
      return
      end
!----------------------------------------------------------------------
      subroutine inter(i,alf1)
      USE General
      USE Symmetry
      USE PhaseStuff
      USE PhaseModule
!
      ist = 3
      jpqq = 0
      do kcr=1,2
         ist = ist+1
         lm = limref(kcr,i)*ist + 1 + jpqq
         ls = limref(kcr,i+1)*ist   + jpqq
         if (lm <= ls) then
             nv=0
             do j=lm,ls,ist
                ind = j
                nn(1) = iph(ind)
                nn(2) = iph(ind+1)
                if (kcr.eq.1) then
                   nn(3) = 0
                   a1 = 0.01 * iph(ind+2)
                   ifaz = iph(ind+3)
                else
                   nn(3) = iph(ind+2)
                   a1 = 0.01 * iph(ind+3)
                   ifaz = iph(ind+4)
                end if
                ila = iabs(nn(1))
                ira = iabs(nn(2))
                ita = iabs(nn(3))
!psie
!psie                if(ila > nstr .or. ira > nstr .or. ita > nstr) then
!psie                  cycle
!psie                end if
                
                w=1.
c
                gbes = abs(a1)
                eee = gbes * w
                vec1 = bes(a1*w)
c
                vec2 = vec1 * eee
c--- alfa / varianza
                d1=bes(gbes)
                ee=gbes
                d2=1-(2./ee)*d1
                costa=1+d2-2.*(d1*d1)
                varia=gbes*gbes*costa
                if(varia.lt.0.0) varia = abs(varia)
                vec2=vec2/sqrt(varia)
c--- alfa / varianza
c
                alf1=alf1+vec2
             enddo
         endif
         jpqq = jpq
      enddo
c ---
      return
      end
c ------------------------------------------------------------------
      subroutine RandomPhases(inffom)
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
c
      iphaz(:) = 0
      wt(:)    = 0.0
      if (lasts.eq.0) then
c routine definizione set di fasi mediante SirRandom
          IYsolve = iyrand
!         write(lo,*) 'iyrand=',IYsolve
          if (kverbo.ne.0) then 
              write(lo,*) 'TRIAL =',numbrun
          endif
          ix=iyrand
          iniz = 1
          if (ifInvar == 1) then
              ifin = nstartTang
          else
              ifin = nstr
          endif
          if (inffom == 1) then
              ifin = nstr
          endif

*         ifin = nstr

          do i=iniz,ifin
             k = iordeTang(i)
             call SirRandom(ix,iyrand,yfl)
             ix=iyrand
             iphi=nint(yfl*360.0)
             if(iabs(mkang(k)).ne.1) then
                idv = 15*mod(iabs(mkang(k))-1,12)
                id1 = iabs(idv-iphi)
                id2 = iabs(idv+180-iphi)
                id1=min0(id1,360-id1)
                id2=min0(id2,360-id2)
                if (id1.lt.id2) then
                    iphi=idv
                else
                    iphi=idv+180
                endif
             endif
             iphi=mod(iphi,360)
             iphaz(k)=iphi
             wt(k) = 1.0
          enddo
          call UpdateReflInfo
      else
!
!-- assegnazione fasi vere e pesi unitari per il set tangentato
!
          if (lasts.eq.1) then
              do i=1,nstartTang
                 k = iordeTang(i)
!!!!!         do i=1,nstr   ! per riprodurre run di Rocco
!!!!!            k = i
                 wt(k)=1.0
                 if (ipub(k).eq.0) then
                     ipub(k)=360
                 endif
                 kcr = 1
                 li=limref(kcr,i)*4+1
                 ls=limref(kcr,i+1)*4
                 if (li.gt.ls) then
                     wt(k)=0.0
                 endif
                 iphaz(k) = ipub(k)
              enddo
          else
c-- assegnazione fasi vere e pesi unitari per il set vero
              if (lasts.eq.2) then
                  nnn = nstr
              elseif (lasts.eq.3) then
                  nnn = numbLSQ
              endif
              do i=1,nnn
                 wt(i)=1.0
                 if (ipub(i).eq.0) then
                     ipub(i)=360
                 endif
                 iphaz(i) = ipub(i)
              enddo
          endif
      endif
c
      return
      end
!-----------------------------------------------------------------------
      subroutine RandomPerturbation(ifl_prt,nPert,ier)
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
!
! routine  di perturbazione delle fasi di tangente
!
      ier = 0
      if (ifl_prt == 1) write(6,*) ' Perturbazione Random #',nPert 

      ix=iyrand
      do i= 1,nstr
         k = iordeTang(i)
         if (wt(k) > 0.00001) then
                 call SirRandom(ix,iyrand,yfl)
                 ix=iyrand

                 if (ifl_prt == 1) then
                     if (yfl < 0.7) then
                        iphi = 0
                     else
                        iphi = 180
                     endif
                 elseif(ifl_prt == 2) then        ! perturbazioni interne
                     iphi = 0
                     if (wt(k) < 0.5) then
c                        iphi=nint((yfl*60.0) - 30.0)
                         iphi=nint((yfl*20.0) - 10.0)
                         if(iabs(mkang(k)).ne.1) then
                            if (yfl < 0.85) then
                                iphi = 0
                            else
                                iphi = 180
                            endif
                         endif
                     endif
                 endif

                 iphaz(k)=iphaz(k) + iphi + 3600
                 iphaz(k)=mod(iphaz(k),360)



         else
             iphaz(k)=0
             wt(k)=0.0
         endif
      enddo

      ifPert_tg = 1
!
      return
      end
!-----------------------------------------------------------------------
      subroutine RandomPerturbation_New(nPert,ier)
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
!
! routine  di perturbazione delle fasi di tangente
!
      
      nristr = 0
      nristr0 = 0
      ier = 0
      write(6,*) ' Perturbazione Random #',nPert 
      work1(:) = 0.0
      work1(1:nstr) = wt(1:nstr)
      ncont = nstr * 0.2
      call sortall(-1,work1,nstr)
      sog=work1(ncont)


      ix=iyrand
      ifin = nstr
      ifin = nstartTang
      do i= 1,nstr
         k = iordeTang(i)
c        if (i > ifin) then   ! non perturbo i riflessi con peso maggiore
c            iphaz(k)=0
c            wt(k)=0.0
c        else             

         if (wt(k) > sog) then   ! non perturbo i riflessi con peso maggiore
             cycle
         endif
         if (wt(k) > 0.00001) then
                 call SirRandom(ix,iyrand,yfl)
                 ix=iyrand
                 iphi=nint((yfl*60.0) - 30.0)
                 iphaz(k)=iphaz(k) + iphi + 3600

                 if(iabs(mkang(k)).ne.1) then
                    nristr = nristr + 1
                    if (yfl < 0.5) then
                        iphi = 0
                        nristr0 = nristr0 + 1
                    else
                        iphi = 180
                    endif
                    iphaz(k)=iphaz(k) + iphi + 3600
                 endif

                 iphaz(k)=mod(iphaz(k),360)
         else
             iphaz(k)=0
             wt(k)=0.0

c            k = iordeTang(i)
c            call SirRandom(ix,iyrand,yfl)
c            ix=iyrand
c            iphi=nint(yfl*360.0)
c            if(iabs(mkang(k)).ne.1) then
c               idv = 15*mod(iabs(mkang(k))-1,12)
c               id1 = iabs(idv-iphi)
c               id2 = iabs(idv+180-iphi)
c               id1=min0(id1,360-id1)
c               id2=min0(id2,360-id2)
c               if (id1.lt.id2) then
c                   iphi=idv
c               else
c                   iphi=idv+180
c               endif
c            endif
c            iphi=mod(iphi,360)
c            iphaz(k)=iphi
c            wt(k) = 0.5
         endif

c        endif   ! ifin
      enddo
      write(6,*) ' Fasi ristrette  da perturbare =',nristr
      write(6,*) ' Fasi ristrette non perturbate =',nristr0
      write(6,*) ' Riflessi Forti =',nstr, ncont

      ifPert_tg = 1
!
      return
      end
!-----------------------------------------------------------------------
      subroutine RandomWeights()
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
!
! routine definizione set di pesi mediante SirRandom
!
      if (knw == 1) then
          write(6,*) ' Pesi Random' 
      endif
      wt(:) = 0.0
      IYsolve = iyrand
      ix=iyrand
      do i=1,nstr
         call SirRandom(ix,iyrand,yfl)
         ix=iyrand
         wt(i)=yfl
      enddo
      iyrand = IYsolve
!
      return
      end
!----------------------------------------------------------------------- 
      subroutine SirRandom(ix,iyrand,yfl)
!
!-- computes uniformly distributed random real numbers between 0 and 1.
!
      iyrand = ix * 65539
      if (iyrand < 0) then
          iyrand = (iyrand + 2147483647) + 1
      endif
      yfl = iyrand
      yfl = yfl * .4656613e-9
c
      return
      end
!-----------------------------------------------------------------------
      subroutine dirpha(ifFromGraphic, ifTest, filet, ier)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom     
      USE Seminvariants
      USE Param
      USE MadModule
      USE PhaseModule
      USE TestModel, only: ifNoMatch
      USE Migliore
      USE Direttive
      USE RfacMatrixModule
      USE VLDmod
      USE VLDmod_3       ! x VLD
      USE MappaPatterson, only: iesCmap, iesSnip, ifModPat, ifNewPat
      USE PhMod

!
      common /modifica_DSR/ kdsr, kdsrReq, ifPeak, nolsqReq
      common /modifica_effe/ modf
*gl*  common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common /GedmCommon/ ifGedm, cicliFour, nBatch, nGedm,
     *                    ifCMap, CMapVet(3)
!
      common /dirtr/emin,ntra,sgg,MaxPsi0
      common/dir10/numk,ntrs,ntr10,sogpo,sogne,nupos,nuneg,
     1 indpo,indne,nmxtn
!
      character direp*256
      character*(*) filet
      integer nolsqReq, enveReq
      real stopF2Req
!
!-- set default values
!
!
!-- MAD-Sirprot
!
      MAD_WL_vet(:) = 0; MAD_WL_number = 0; MAD_set(:) = 0; MAD_lsq = 0
      MAD_posi = 0; FichierIn = ' '
!
!formula20
      if (ksize > 3 .or. kmad == 1) then
          ifPhD = 1
      else
          ifPhD = 0
      endif
      ifForm20 = 0
!
      stopF2Req = -9999
      nIterazioni = 0
      Iterazione = 0
      ricicloVLD = 0
      iesCmap = 0
      iesCmapReq = -99
      iesSnip = 0
      iesSnipReq = -99
      if (ifFromGraphic == 0) then  ! ifFromGraphic = 1  riparte da restart
          ifMDM = 0
          ifVLD = 0
          ifTang  = 0
          ifPatt  = 0
      endif
      ifDsrVLD  = 0   
      ifDsrVLD = 0
      kverbo_pg = 0
      ksize_vero = 0
      kSavMDM = 0
      kdsr = 0                   !! 050611
      if (neutro == 2) then
          sogFinalFom = 2.0
      endif
      if (neutro == 2) then ! .or. ksize <= 3) then
          nBestModelsMax = 5   ! memorizza i modelli dei migliori 5 trials
      else
          nBestModelsMax = 1
      endif
      firstTime = 1
      nCycleVLD = 0
      erreBestVLD = 9999
      abs_erreBestVLD = 9999
      useSigma = 1
      modf = 0
      ifSelAlfa = 0
      if (ifFromGraphic == 0) then
          relaxReq = -99
          ifVLD = 0 
          if (NewPsi0Req == 0) then
              if (kmad == 0 .and. ksize <= 3) then
                  ifNewPsi0 = 1 !dedi 04/12/08 USO ATTIVO PSI0 migliora weitan
              else
                  ifNewPsi0 = 0
              endif
          endif
      else
          relaxReq = 1
          ifNewPsi0 = 1
      endif
      ifNoMatch = 0
      ifCMap = 0
      ifCycTang = 0
      ifGedm = 0
      ifModPat = 0
      ifNewPat = 0
      ifOldFoms = 0
      ifTest = -1
      nstrMod = nstr
      nstrSav = nstr
      nsymTot=nsym*(icent+1)*pts
!--valore di stop per la FinalFom (normalizzata a sogFinalFom)
      stopFinalFom = 1.0
      if (ifWillVLD == 1) then
         stopFinalFom2 = 0.8       ! x VLD
         sogFinalFom = 2.0         ! x VLD
         if (neutro == 2) then
             n_Maxrun = 5
         else
             n_Maxrun = 20
         endif
      elseif (ifWillMDM == 1) then
         stopFinalFom2 = 3.0       ! x MDM
         stopFinalFom = 0.3
         if (ksize <= 2) then
             n_Maxrun = 100
         else
             n_Maxrun = 600
         endif
      end if
      FFomStopPGM = 99.9

      n = nrefl
      call CalcolaResEff(n)
!--numero di riflessi atteso
*     NRefAtt=volume*(4.0*Pi)/(3.0*resm**3)
!--numero di riflessi effettivamente presenti
*     NRefPre=nrefl*nsymTot*2.0
!--percentuale di riflessi mancanti (completezza)
*     Complet=float(NRefPre)/float(NRefAtt)
*     Complet=min(Complet,1.0)
!--risoluzione effettiva dei dati
!     if(Complet>0.7) then
*       ResEff=resm/(Complet)**0.3333
!     else
!       ResEff=0.9*resm/(Complet)**0.3333
!     endif
      sogResEff=1.59
      sogResStrategy=1.50
!     if(no(nk)<=26) sogResEff=1.54
c     write(6,*) 'scritte',NrefAtt,NrefPre,Complet,resm,ResEff
!     if(kverbo>0) then
*        write(lo,'(a,f8.2)')'Completeness (%)',Complet*100.
*        write(lo,'(a,f8.2)')'Effective Resolution',ResEff
!     endif
!
      write(SpaceGroup,'(16a1)') nSpaceG
!	
      doBest = 0
      ifPivot = 0
      ifFreeLunch = 0
      ifInvar = 0
      ifPert = 0  !per sigmaA 
      ifPert_tg = 0
      if (knw.eq.1) then
          ifExamin = 1
      else
          ifExamin = 0
      endif
      if (ifFromGraphic == 0) then
          if (nsym == 1 .and. icent == 1 .and. ksize < 2) then
              ifRelax = 1
          else
              ifRelax = 0
          endif
      endif
      nowei = 0
      noweiReq = -99
      ksizeReq = -99
      PattTangReq = -99
      nPattpksReq = -99
      nBlocksPhReq = -99
      kdsrReq = -99
      ifGminReq = -99
      ifCochReq = -99
      ifNoQuaReq = -99
      nolsqReq = -99
      enveReq = -99
*     ResBiasReq = -99 ! dedi
      ffomReq  = -99 
      ffom  = 0.0
      coef_hFom = 1.0
      noDSR = 0
      ifTime = 0
      ksizeBin = ksize
      MaxToStore = 500
      jrecyc = 0
      jfragment = 0
      jpfile = 0
      jtabl=0
      nfisso = 10
      lasts = 0
      kfast = 0
      kWriMap = -1
      iWriMap = -1
      noSkeleton = 1
!
      ifPDBfiles = 1
      ifRidotta = 0
      itera = -1
      if97 = 0
      ifnoesa = 0
      ifOUT = 0
!     ifOUT = 1
      ifnoEE = 0
      ifnoEEReq = -99
      ifNstr = 0
      ifHafr  = 1
      ifLsqh  = 1
      kedm = 0
      ifCombinedFom = 1
      SogliaCorre = 2.0
      nVolteFour = 1
      ifCorr = -1
      ifRescale = 1
      ResSog_Ph = 5.0
      ifCompareFragments = 0          !pgMAD290409
!pgVLD
!set initial values for VLD procedure
      ifTuttiCarboni = 0
      if (ifMDM == 0) then
          n_EDM = 10
      endif
      n_cicli = 300
      n_cb = 20
      n_abi_model = nPreviousTrials + 1
      sog_sigmaA = 0.97
      ifContrLab = 1
      nPrCy = 0    !non stampa nessun ciclo
      Sog_PrCy = 99999.0
      sog_ref = 100.
!pgVLD
      if (RSoglia.lt.0) then
!leuven
          if (kmad == 0) then         
             RSoglia = 25.0
             if (neutro == 2) then
                 RSoglia = 1.0
             endif
          else
             RSoglia = 1.0
          end if
!leuven
      endif
      nneg=1
      nngq=1
      if (icent == 1) then
          ipesi = 6
      else
          ipesi = 5
      endif
      iprin = 0
      kverbo = 0
      ifEnve = 0
      RenveStart = 8.0
      RenveStep  = 2.0
      if (ResEff < ResSogLow) then  !LowRes su risoluzione effettiva dei dati
          LowRes = 0
          ifPost = 0
      else
          LowRes = 1
          ifPost = 0
          if (kmad == 0) then
              nolsq  = 0
          endif
      endif
!
      if (ifFromGraphic == 0) then  ! ifFromGraphic = 1  riparte da restart
          jproc=1
          nBlocksPh = 0
          jBlocksPh = 0
          numbTrials = 0
          ntria = 0
          itria = 0
          itriaPatt = 0
          trialVett(:)=0
!
!-- scelta automatica della Procedura Ab-initio
!
          call DefaultAbInitio
!
          if (ifVLD == 1 .or. ifWillVLD == 1) then
              if (ifMDM == 0 .and. ifWillMDM == 0) then
                  if (neutro == 2) then
                      n_Maxrun = 5
                  else
                      n_Maxrun = 20
                  endif
              endif
          endif
          ifPeak  = 0
          ifTrial = 0
!
!--Patterson values
!  the number of peaks (if present) must be equal to numbTrials
!  numbTrials must be not greater than 500
!
          
          if (ifPatt == 1) then
              call DefinePattTrials()
          elseif (ifPatt == 0) then
              call DefineBlocksEtc()
          endif
!
      else
!
          if (ifPatt == 1) then
              if (MaxRun == -1) then
                  call DefinePattTrials()
              else
                  ntria = 1
                  numbrun = itria
                  trialVett(1) = itria
                  nBlocksPh = 1
              endif
          endif
      endif     !  (ifFromGraphic == 0)
!
!pgMAD
      if (kmad.eq.0) then
         anat=float(nat)/(pts*float((icent+1)*nsym))
      else
         anat = 0.
         do ii=1,nAnom
            anat=anat+float(nw(nkAnom(ii)))/(pts*float((icent+1)*nsym))
         end do
         call DefineSizeMAD()     !pgMAD0301
      end if
!pgMAD
      ic=0
      icmax=icomq(icomat,2)
!
  100 continue
!
      ic=ic+1
      if (ic.gt.icmax) go to 9000
c     ipdir=ipdir+1
c     line=card(ipdir)
c     write(lo,'(a)') line
c     diret=line
c     ldiret = Lung(diret)
c     call cutst(line,lenp,dire,lend)
c     call lcase(dire)
!
!-- directives without numeric parameters
!


*     do while (ic.lt.icmax.and.ier.eq.0)
*        ic = ic + 1
         ipdir=ipdir+1
         cardDiret=card(ipdir)
         cardImage=cardDiret
         ldiret = Lung(cardImage)
         call cutst(cardDiret,lenp,direttiva,lend)
         call lcase(direttiva)

c-- directives with alphanumeric parameters
      if (direttiva(1:4).eq.'rido') then
          ifRidotta = 1
          go to 100
      elseif (direttiva(1:3).eq.'noh') then
          HeavyAtoms = .false.
          go to 100
      elseif (direttiva(1:3).eq.'phd') then
          ifPhD = 1
          go to 100
      elseif (direttiva(1:4).eq.'noph') then
          ifPhD = -1
          go to 100
*     elseif (direttiva(1:3).eq.'amb') then
*         ifAmb = 1
*         go to 100
      elseif (direttiva(1:3).eq.'jen') then
          jEnan = 1
          go to 100
      elseif (direttiva(1:4).eq.'vpat')  then  ! da eliminare nel pgm definitivo
          ifTang  = 0
          ifPatt  = 1
          ifDsrVLD = 1
          ifVLD   = 0
          call DefinePattTrials()
          go to 100
      elseif (direttiva(1:3).eq.'bea') then
          if (nBest > 0) then
              doBest = 1
          endif
          go to 100
      elseif (direttiva(1:4).eq.'noma') then   ! dedi non c'e' il *.fra
          ifNoMatch = 1
          go to 100
c     elseif (direttiva(1:4).eq.'sela') then
c         ifSelAlfa = 1
c         go to 100
      elseif (direttiva(1:4).eq.'nose') then
          ifSelAlfa = 0
          go to 100
      elseif (direttiva(1:4).eq.'nqua') then
          ifNoQuaReq = 1
          go to 100
      elseif (direttiva(1:4).eq.'coch') then      ! per invar  (Cochran)
          ifCochReq = 1
          go to 100
      elseif (direttiva(1:4).eq.'psi0') then
          ifNewPsi0 = 1
          go to 100
      elseif (direttiva(1:4).eq.'nops') then
          ifNewPsi0 = -1
          MaxPsi0 = 8000
          go to 100
      elseif (direttiva(1:4).eq.'oldf') then
          ifOldFoms = 1
          go to 100
      elseif (direttiva(1:4).eq.'free') then
          ifFreeLunch = 1
          go to 100
      elseif (direttiva(1:4).eq.'nosk') then
          noSkeleton = 1
          go to 100
      elseif (direttiva(1:4).eq.'nosi') then
          useSigma = 0
          go to 100
      elseif (direttiva(1:4).eq.'post')  then
          ifPost = 0
          go to 100
      elseif (direttiva(1:4).eq.'nopo')  then
          ifPost = 0
          go to 100
!-- dedi --  mantengo la direttiva SIZE in phase  per compatibilità con SIR2008 (settaggi in invar e dsr)
      elseif (direttiva(1:4).eq.'size') then
c         ksizeReq = -9999
          call lcase(cardDiret)
          if (lenp.gt.0) then
              ksizeReq = 1
              if (cardDiret(1:3).eq.'xs ') then
                  ksize = 1
              elseif (cardDiret(1:3).eq.'s  ') then
                  ksize = 2
              elseif (cardDiret(1:3).eq.'m  ') then
                  ksize = 3
              elseif (cardDiret(1:3).eq.'l  ') then
                  ksize = 4
              elseif (cardDiret(1:3).eq.'xl ') then
                  ksize = 5
              elseif (cardDiret(1:3).eq.'xxl') then
                  ksize = 6
              elseif (cardDiret(1:3).eq.'hug') then
                  ksize = 7
              else
                  go to 8000
              endif
          else
                  go to 8000
          endif
          if (ksize.le.3) then
              nolsqReq = -1
          endif
          go to 100
!-- dedi --   SIZE (DSR) in phase dovrebbe modificare solo i parametri del DSR (e non invar)
      elseif (direttiva(1:3).eq.'dsr') then
          call lcase(cardDiret)
          if (lenp.gt.0) then
              kdsrReq = 1
              if (cardDiret(1:3).eq.'xs ') then
                  kdsr = 1
              elseif (cardDiret(1:3).eq.'s  ') then
                  kdsr = 2
              elseif (cardDiret(1:3).eq.'m  ') then
                  kdsr = 3
              elseif (cardDiret(1:3).eq.'l  ') then
                  kdsr = 4
              elseif (cardDiret(1:3).eq.'xl ') then
                  kdsr = 5
              elseif (cardDiret(1:3).eq.'xxl') then
                  kdsr = 6
              elseif (cardDiret(1:3).eq.'hug') then
                  kdsr = 7
              else
                  go to 8000
              endif
          else
                  go to 8000
          endif
          if (kdsr.le.3) then
              nolsqReq = -1
          endif
          go to 100
!-- dedi --   
      elseif (direttiva(1:4).eq.'unkn')  then    ! per test con VLD (in alternativa a time)
          knw  = 0
          go to 100
!-- dedi --   
      elseif (direttiva(1:4).eq.'modf')  then
          modf  = 1
          go to 100
      elseif (direttiva(1:4).eq.'fast')  then
          kfast  = -1
          go to 100
      elseif (direttiva(1:3).eq.'low')  then
          LowRes = 1
          go to 100
      elseif (direttiva(1:3).eq.'hig')  then
          LowRes = 0
          go to 100
      elseif (direttiva(1:4).eq.'time')  then
          ifTime = 1
          go to 100
      elseif (direttiva(1:4).eq.'noex')  then
          ifExamin = 0
          go to 100
      elseif (direttiva(1:4).eq.'noco')  then
          ifCorr = -1
          go to 100
      elseif (direttiva(1:4).eq.'corr')  then
          ifCorr = 2
          go to 100
      elseif (direttiva(1:3).eq.'nor')  then
          ifRescale = 0
          go to 100
      elseif (direttiva(1:4).eq.'noen')  then
          enveReq = -1
          go to 100
      elseif (direttiva(1:4).eq.'nowe')  then ! Patterson non pesata
          noweiReq = 1
          go to 100
      elseif (direttiva(1:4).eq.'noes')  then  ! x non esaltare la mappa
          ifnoesa = 1
          go to 100
      elseif (direttiva(1:4).eq.'noee')  then  ! x non usare sigmaEobs in sigmaA  Liberato
          ifnoEE = 1
          ifnoEEReq = 1
          go to 100
      elseif (direttiva(1:4).eq.'noou')  then  ! limita output per risparmiare tempo  Liberato
          ifOUT = 0
          go to 100
      elseif (direttiva(1:4).eq.'novp')  then  !  No VLD in DSR (vecchia procedura)
          ifDsrVLD = 0
          go to 100
      elseif (direttiva(1:4).eq.'nocm' .or.
     *        direttiva(1:4).eq.'nocp')  then  !  No Cmap in Patterson
          iesCmapReq = 0
          go to 100
      elseif (direttiva(1:4).eq.'snip')  then  !  Snip in Patterson 
          iesSnipReq = 1
          go to 100
      elseif (direttiva(1:4).eq.'nosn')  then  !  No Snip in Patterson 
          iesSnipReq = 0
          go to 100
      elseif (direttiva(1:4).eq.'nols' .or. 
     *                       direttiva(1:4).eq.'nocy') then
          nolsqReq = 0
          nBestModelsMax = 0
          go to 100
      elseif (direttiva(1:4).eq.'verb' .or. 
     *                       direttiva(1:4).eq.'deta') then
          kverbo=1
          go to 100
      elseif (direttiva(1:4).eq.'pg  ') then
          kverbo_pg=1
          go to 100
!     elseif (direttiva(1:4).eq.'gedm') then  ! versione 1° lavoro Cmap
!         ifGedm = 1
!         go to 100
!     elseif (direttiva(1:4).eq.'cmap') then
!         ifGedm = 2
!         go to 100
!!!   elseif (direttiva(1:4).eq.'mpat') then
!!!       ifModPat = 1
!!!       go to 100
      elseif (direttiva(1:4).eq.'npat') then
          ifNewPat = 1
          go to 100
      elseif (direttiva(1:4).eq.'cyct') then
          ifCycTang = 1
          go to 100
      elseif (direttiva(1:4).eq.'tabl') then
          jtabl=1
          go to 100
      elseif (direttiva(1:4).eq.'nneg')  then
          nneg=0
          go to 100
      elseif (direttiva(1:4).eq.'nngq')  then
          nngq=0
          go to 100
      elseif (direttiva(1:4).eq.'rela')  then
          relaxReq = 1
          go to 100
      elseif (direttiva(1:4).eq.'unre')  then
          relaxReq = -1
          go to 100
      elseif (direttiva(1:4).eq.'nnods')  then
          noDSR = 1
          go to 100
      elseif (direttiva(1:4).eq.'test')  then
          jproc=0
          go to 100
      elseif (direttiva(1:4).eq.'shel') then
          jout = 0
          ifExportShelx = 1
          if (lenp > 0) fname(3)=cardDiret
          go to 100
      elseif (direttiva(1:4).eq.'crys') then
          jout = 1
          if (lenp > 0) fname(3)=cardDiret
          go to 100
      elseif (direttiva(1:4).eq.'recy' ) then
          jfragment = 0
          jpfile=kform
          read(cardDiret,'(a)') filet
          istat=2
          iform=1
          if (jopen(jpfile,filet,istat,iform,ier).ne.0) go to 9100
          jrecyc = 100
          close(jpfile)
          jpfile = -jpfile
          ifMDM = 0
          ifVLD = 0
          ifTang  = 1
          ifPatt  = 0
          go to 100
      elseif (direttiva(1:4).eq.'frag') then
          jfragment = 1
        if (jrecyc == 0) then
          jpfile=kform
          read(cardDiret,'(a)') filet
          istat=2
          iform=1
          if (jopen(jpfile,filet,istat,iform,ier).ne.0) go to 9100
          jrecyc = 0
          close(jpfile)
          ifMDM = 0
          ifVLD = 0
          ifTang  = 1
          ifPatt  = 0
        endif
          go to 100
      elseif (direttiva(1:4).eq.'nopd') then
          ifPDBfiles = 0
          go to 100
      elseif (direttiva(1:4).eq.'cmpf') then    !pgMAD290409
          ifCompareFragments = 1
          go to 100
!pgVLD
! directives for VLD procedure without numeric parameters
      elseif (direttiva(1:4).eq.'carb')  then
          ifTuttiCarboni = 1
          go to 100
      elseif (direttiva(1:4).eq.'ncon')  then
          ifContrLab = 0
          go to 100
      elseif (direttiva(1:3).eq.'nrst')  then   !rst
          ripetibilita = 0
          go to 100
      elseif (direttiva(1:4).eq.'form')  then
          ifForm20 = 1
          go to 100
!
!-- MAD
!
      elseif (direttiva(1:4).eq.'posi')  then
          read(cardDiret,'(a)') FichierIn
          jpfile = 1
          MAD_posi = 1
          go to 100
!pgVLD
      endif
!
!-- directives with numeric parameters
!
      iopt=0
      call getnum(cardDiret,vet,ivet,iv,iopt)
      if (iopt.eq.-1) go to 8000
   

      if (direttiva(1:4).eq.'fom2')  then
          if (iopt > 0) then
              stopF2Req = vet(1)
          endif
          go to 100
      elseif (direttiva(1:4).eq.'patt')  then
          ifTang  = 0
          ifPatt  = 1
          ifVLD   = 0
          ifMDM   = 0
          if (ksize <= 3) then
              ifDsrVLD = 0
          else
              ifDsrVLD = 1
          endif
          PattTangReq = 1
          if (iv == 1) then
              nPattpksReq = ivet(1)
          elseif (iv == 2) then
              nPattpksReq = ivet(1)
              numbTrials = 1
              itria = ivet(2)
              itria = -itria
              ifTrial = 2
          elseif (iv > 2) then
              go to 8000
          endif
          call DefinePattTrials()
          go to 100
      elseif (direttiva(1:4).eq.'dm  ' .or. 
     *        direttiva(1:4).eq.'sdm ')  then
              ifTang  = 1
              ifPatt  = 0
              ifVLD   = 0
              ifMDM   = 0
              if (ksize <= 3) then
                  ifDsrVLD = 0
              else
                  ifDsrVLD = 1
              endif
              PattTangReq = 1
              if (iv == 1) then
                  nBlocksPh = 1
                  ifPeak = 2
                  jBlocksPh(1,1) = ivet(1)
                  jBlocksPh(2,1) = ivet(1)
              elseif (mod(iv,2) == 0) then
                  if (iv > 0) then
                      ifPeak = 2
                      nBlocksPh = iv / 2
                      j = 0
                      do i=1, nBlocksPh
                         jBlocksPh(1,i) = ivet(j+1)
                         jBlocksPh(2,i) = ivet(j+2)
                         j = j + 2
                      enddo
              endif
          else
              go to 8000
          endif
          if (ifPeak == 0) then
                 call DefineBlocksEtc()
          else
              nBlocksPh = min0(nBlocksPh,10)
              do i=1, nBlocksPh
                 if (jBlocksPh(2,i) > 500) jBlocksPh(2,i) = 500
              enddo
          endif
          go to 100
      elseif (direttiva(1:4).eq.'gedm') then  ! versione 1° lavoro Cmap
           if (iv == 1) then
               ifGedm  = ivet(1)  ! 1 = versione 1° lavoro Cmap; 2 = versione Cmap Dedi
               if (ifGedm < 1 .or. ifGedm > 2) goto 8000
           else
               goto 8000
           endif
       elseif (direttiva(1:4).eq.'cmap' .or.
     *          direttiva(1:4).eq.'cpat') then   ! cpat obsoleto
           if (iv == 0) then
               if (ksize > 3 ) then
                   iesCmapReq  = 1
               else
                   iesCmapReq  = 3  ! da controllare (ROCCO)       
               endif
           elseif (iv == 1) then
               iesCmapReq  = ivet(1)  ! indica il numero di cicli di Cmap
           else
               goto 8000
           endif
           go to 100
      elseif (direttiva(1:4).eq.'best') then  ! per invar
          if (iv.eq.1) then
              nBestModelsMax = min0(ivet(1), 20)
          else
              go to 8000
          endif
          go to 100
      elseif (direttiva(1:3).eq.'ric') then
          if (iv.eq.0) then
              ricicloVLD = 100
              ricicloVLD =  90
          else
              ricicloVLD = ivet(1)
          endif
          go to 100
      elseif (direttiva(1:4).eq.'gmin') then  ! per invar
          ifGmin = 1
          ifGminReq = 1
          if (iv.eq.1) then
              sogpo = vet(1)
          elseif(iv.eq.0) then
              sogpo = 0.15
          else
              go to 8000
          endif
          if (sogpo.lt.0.15) sogpo = 0.15
          go to 100
      elseif (direttiva(1:4).eq.'ffom')  then
          if (iv.eq.1) then
              ffomReq = 1
              ffom = vet(1)
          else
              go to 8000
          endif
          go to 100
      elseif (direttiva(1:4).eq.'sela')  then
          ifSelAlfa = 1
          elimalfa = 10.0
          if (iv.eq.1) then
              elimalfa = vet(1)
          elseif (iv > 1) then
              go to 8000
          endif
          go to 100
      elseif (direttiva(1:4).eq.'ccma')  then
          if (iv.eq.1) then
              SogliaCorre = vet(1)
          else
              go to 8000
          endif
          go to 100
      elseif (direttiva(1:4).eq.'iter')  then
          if (iv.eq.1) then
              itera = max0(0,ivet(1))
          else
              go to 8000
          end if
          go to 100
      elseif (direttiva(1:4).eq.'dlsq' .or. 
     *                       direttiva(1:4).eq.'cycl')  then
          if (iv.eq.0) then
              nolsqReq = -1
          else
              nVolteFour = 1
              if (ivet(1).lt.0) then
                  go to 8000
              else
                  nolsqReq = ivet(1)
              endif
              if (ivet(2).le.0) then
                  go to 8000
              else
                  if (ivet(2).gt.2) ivet(2) = 2
                  nVolteFour = ivet(2)
              endif
          endif
          go to 100
      elseif (direttiva(1:4).eq.'stri')  then     ! starting trial
          if (iv.gt.1) go to 8000
          numbTrials = iv
          itria = ivet(1)
          itria = -itria
          ifTrial = 2
          go to 100
      elseif (direttiva(1:4).eq.'tria')  then
          if (iv.eq.0) go to 8000
          if (iv.gt.10) iv = 10
          numbTrials = iv
          nBlocksPh = 1
          jBlocksPh(1,1) = iv
          jBlocksPh(2,1) = iv
          do i=1, jBlocksPh(1,1)
            trialVett(i) = ivet(i)
          enddo
          ntria = 1
          itria = ivet(1)
          ifTrial = 1
          ifPeak = 1
          go to 100
      elseif (direttiva(1:4).eq.'forc')  then
          if (iv /= 3) go to 8000
          numbTrials = 1
          nBlocksPh = 1
          jBlocksPh(1,1) = 1
          jBlocksPh(2,1) = 1
          trialVett(1) = 1
          ntria = 1
          itria = 1
          ifPivot = 1
          ifPeak = 1
          coord_temp(1:3) = vet(1:3)
          ldirep = Lung(direttiva)
          direp = direttiva(1:ldirep)
          go to 100
      elseif (direttiva(1:4).eq.'reso')  then
          if (iv.ne.1) go to 8000
          ResSog_Ph = vet(1)
          go to 100
      elseif (direttiva(1:4).eq.'resi')  then
          if (iv.ne.1) go to 8000
          RSoglia = vet(1)
          go to 100
!     elseif (direttiva(1:4).eq.'pesi')  then ! x scelta pesi in weitan
!         if (iv.ne.1) go to 8000
!         ipesi = ivet(1)
!         go to 100
      elseif (direttiva(1:4).eq.'prin') then
          if (iv.ne.1) go to 8000
          iprin=ivet(1)
          go to 100
      elseif (direttiva(1:4).eq.'last') then
          if (iv.ne.1) go to 8000
          lasts=ivet(1)
          MaxRun = 1
          ifPatt = 0
          go to 100
      elseif (direttiva(1:4).eq.'nedm')  then
          if (iv.ne.2) go to 8000
          if (ivet(1) > 50 .or. ivet(2) > 10) go to 8000
          if (ivet(1) <= 0 .or. ivet(2) <= 0) go to 8000
          kedm = 1
          nedm1 =ivet(1)
          nedm2 =ivet(2)
          go to 100
      elseif (direttiva(1:4).eq.'mdm')  then
          if (iv.gt.3) go to 8000
          ifMDM = 1
          ifVLD = 0
          ifTang = 0
          ifRelax = 1
          ifPatt = 0
          n_EDM = 18
          ifDsrVLD = 0
          if (iv >= 1) then
              n_Maxrun = ivet(1)
          end if
          if (iv == 2) then
              n_abi_model = ivet(2)
          end if
          nBlocksPh = 1
          jBlocksPh(1,1) = n_Maxrun
          jBlocksPh(2,1) = n_Maxrun
          go to 100
!pgVLD
! directives for VLD procedure [in direct space] with numeric parameters        
      elseif (direttiva(1:3).eq.'vld')  then
          if (neutro == 2) then
              n_Maxrun = 5
          else
              n_Maxrun = 20
          endif
          stopFinalFom2 = 0.8       ! x VLD
          sogFinalFom = 2.0         ! x VLD
          n_EDM = 10
          if (iv.gt.3) go to 8000
          if (nrefl < minNrefl) then
              write(Msg,9800) nrefl
              call OneBlankOnly(Msg)     
              call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
              ier = -1
              return
          endif
          ifVLD = 1
          ifMDM = 0
          ifRelax = 1 
          ifTang = 0
          ifPatt = 0
          ifDsrVLD = 0
          if (direttiva(4:4).eq.'d')  then
              ifVLDdir = 1
          else
              ifVLDdir = 0
          endif
          if (iv >= 1) then
             n_cicli = ivet(1)
          end if
          if (iv >= 2) then
             n_Maxrun = ivet(2)
          end if 
          if (iv == 3) then
             n_abi_model = ivet(3)
          end if 
          nBlocksPh = 1
          jBlocksPh(1,1) = n_Maxrun
          jBlocksPh(2,1) = n_Maxrun
          go to 100
! directives for VLD procedure in direct space with numeric parameters        
!      elseif (direttiva(1:4).eq.'n_mo')  then
!          if (iv.ne.1) go to 8000
!          n_abi_model = ivet(1)
!          go to 100
      elseif (direttiva(1:4).eq.'n_ed')  then
          if (iv.ne.1) go to 8000
          n_EDM = ivet(1)
          go to 100
!      elseif (direttiva(1:4).eq.'n_ci')  then
!          if (iv.gt.2) go to 8000
!          n_cicli = ivet(1)
!          if (iv == 2) then
!             n_Maxrun = ivet(2)
!          end if 
!          go to 100
      elseif (direttiva(1:4).eq.'n_cb')  then
          if (iv.ne.1) go to 8000
          n_cb = ivet(1)
          go to 100
      elseif (direttiva(1:4).eq.'sogs')  then
          if (iv.ne.1) go to 8000
          sog_sigmaA = vet(1)
          go to 100
      elseif (direttiva(1:4).eq.'pr_c')  then
          if (iv > 2) go to 8000
          nPrCy = ivet(1)
          if (iv == 2) then
             Sog_PrCy = vet(2)
          end if
          go to 100
      elseif (direttiva(1:4).eq.'pref')  then
          if (iv.ne.1) go to 8000
          sog_ref = vet(1)
          go to 100
!
!-- MAD
!
      elseif (direttiva(1:4).eq.'wave')  then
          if (iv == 0) go to 8000
          MAD_WL_number = iv
          MAD_WL_vet(1:iv) = ivet(1:iv)
          go to 100
      elseif (direttiva(1:3).eq.'set')  then
          if (iv == 0) go to 8000
          MAD_set(1:2) = ivet(1:2)
          go to 100
      elseif (direttiva(1:3).eq.'lsq')  then
          if (iv == 0) go to 8000
          MAD_lsq = ivet(1)
          go to 100
!pgVLD
      endif
      write(Msg,6000) char(10),cardImage(1:ldiret)
 6000 format(' Wrong directive on following line:',a,3x,a)
      call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
      ier=-1
      return
 8000 continue
      ier=-1
      write(Msg,6100) cardImage(1:ldiret)
 6100 format(' Error in  directive : ',a)
      call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
      return
 9000 continue
!--
      if (stopF2Req > 0.0) then
          stopFinalFom2 = stopF2Req
      endif
!
      if ((ifMDM == 1 .or. ifVLD == 1) .and. nrefl < minNrefl) then
          Msg =  'Not enough reflections to use MDM or VLD.'
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          ier = -1
          return
      endif
      if (jrecyc == 100 .and. jfragment == 1) then
          Msg =  'Fragment and Recycle directives are incompatible.' //
     *           '  Fragment directive will be ignored!' 
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
      endif
!---
      if (jpfile /= 0 .and. MAD_posi == 0) then
          ifTang = 1
          ifPatt = 0
          ifVLD  = 0
      endif
      if (ifVLD == 1 .and. ifTrial > 0) then
          if (ifTrial == 1) then       ! trial n
              n_Maxrun = itria
              n_abi_model = 1
          elseif (ifTrial == 2) then   ! strial n
              n_abi_model = iabs(itria)
          endif
      endif
!-- 
      if (ksizeReq == 1) then
          ksize_vero = ksize
      else
          ksize_vero = ksize_orig
      endif
      if (ifVLD == 1) then
          if (ksize == 3) then
              ksize = 4
*             ifPDBfiles = 0
          endif
      endif
!
*     write(6,*) 'ifPeak, ifTrial, ifPivot',ifPeak,ifTrial,ifPivot

      if (ifPivot > 0 .and. ifPatt == 0) then
          ier=-1
          Msg = direp(1:ldirep)  !cardImage(1:ldiret)
     *          // ' directive must be associated with '
     *          // 'Patterson procedure !!!'
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          return
      endif
      if (ifPivot > 0 .and. ifTrial > 0) then
          ier=-1
          Msg = direp(1:ldirep)  !cardImage(1:ldiret)
     *          //' directive is inconsistent with '
     *          //'TRIAL (or STRIAL) directive !!!'

          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          return
      endif

!!!!  if (doBest > 0 .and. neutro /= 2) then
!!!!      ier=-1
!!!!      Msg = 'BEA directive must be associated with '
!!!! *          // 'ELECTRONS directive in DATA module!!!'      !!!  DA CONTROLLARE  !!!
!!!!      call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
!!!!      return
!!!!  endif

      if (ifCycTang > 0 .and. ifPatt == 1) then
          ier=-1
          Msg = 'CycTang directive must be associated with '
     *          // 'SDM procedure !!!'
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          return
      endif

      if (ifVLD > 0 .and. kdsrReq > 0) then
          ier=-1
          Msg = 'VLD and DSR directives' //
     *          ' are incompatible'
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          return
      endif

      if (PattTangReq > 0 .and. ifVLD > 0) then
          ier=-1
          Msg = 'Patterson or DM directive and VLD procedure' //
     *          ' are incompatible'
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          return
      endif
      if (numbGen > 0 .and. ifVLD > 0) then
          ier=-1
          Msg = 'VLD directive and Extrapolation procedure' //
     *          ' are incompatible'
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          return
      endif
      if (kmad > 0 .and. ifPatt == 0) then
          ier=-1
          Msg = 'DM or VLD directive is inconsistent with '
     *          //'SAD/MAD procedure'
c         Msg = 'DM or VLD directive and SAD/MAD procedure' //
c    *          ' are incompatible'
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          return
      endif

!
      call DefineEtc(ifPeak, kdsrReq)
!
      if (ilMilione == 2) then
          kfast  = -1
      endif
!
      if (nolsqReq /= -99) then
          nolsq = nolsqReq
      else
          if (ifFromGraphic == 0) then
              if (ksize.le.3 .or. kmad /= 0) then       !120105 !!!!PGBA120609
                  nolsq = -1 
              else
                  nolsq = 0
              endif
          endif
      endif
!
!     if (ksize > 3) then
!         if (kmad == 0) then
!             ifEnve = 1
!         endif
!     endif
!
      if (enveReq /= -99) then
          ifEnve = enveReq
      endif

      if (relaxReq /= -99) then
          ifRelax = relaxReq
      endif

      if (noweiReq /= -99 .and. ifPatt == 1) then
          nowei = noweiReq
      endif
!
      if (iesSnipReq /= -99 .and. ifPatt == 1) then
         iesSnip = iesSnipReq
      endif
      if (iesCmapReq /= -99 .and. ifPatt == 1) then
         iesCmap = iesCmapReq
      endif
!
*??*  if (ifPatt  == 1 .and.  ifTang  == 0 ) then
*??*      nBlocksPh = 0
*??*      ifBlocks = 1
*??*  endif
      if (ifPatt.ne.0) then
          MaxRun = 1
      endif
      if (jpfile.ne.0) then
          if (jpfile.lt.0) then
              nBlocksPh = 1
              jBlocksPh(1,1) = 1
              jBlocksPh(2,1) = 1
          else
              nBlocksPh = 0
          endif
      endif
!pgMAD0301
      if (kmad /= 0) then
!         if (ksize < 4 .and. numbWL > 1) then    !cricri2
!            ifRidotta = 1
!         end if
!cricri2
         if (ifPatt == 0) then        ! Tangente
             if (numbWL > 1) then      !MAD
                 if (ksize == 1) then
                     ifRidotta = 1
                 else
                     ifRidotta = 0
                 end if
             else                      !SAD
                 ifRidotta = 0
             end if
         else                         !Patterson
             if (ksize < 4) then
                 ifRidotta = 1
             else
                 ifRidotta = 0
             end if
         end if
!cricri2
      end if
!pgMAD0301
      if (kedm.eq.1) then
          nMacroTot = nedm1
          if (mod(nMacroTot,nBlockEDM) /= 0) then
              nrap = nMacroTot / nBlockEDM
              nMacroTot = (nrap + 1) * nBlockEDM
          endif
          nMicro = nedm2
      endif
!
*     if (NumbMaxRfac.gt.500) then
*         NumbMaxRfac = 500
*     endif
*     if (jrest.eq.0 .and. ifVLD == 0) then
*         RfacMatrix(:,:,:) = 0.0
*         RfacMatrix(2,:,:) = -9999.9      !!!<<<
*         RfacMatrix(3,:,:) = -9999.9      !!!<<<
*     endif
      if (nrefltot > 0 .or. ksize /= ksizeBin) then
          call UpdateReflInfo
      endif
      if (knw == 0 .and. lasts > 0) then
          write(0,33)
          write(6,33)
      endif
 33   format( '*** WARNING: non è possibile calcolare le fasi ',
     *    'per il set tangentato ***',//)
      if (lasts.gt.0) then
          MaxRun = 1
      endif
      if (itria.gt.0) then
          MaxRun = numbTrials
      else if (itria.lt.0) then
          itria = - itria
          numbTrials = -1
          if (ifPatt == 1) then
          itriaPatt = itria
          endif
      endif
      if (kfast.lt.0.and.ifPatt==0) then
          if (nBlocksPh == 0) then
              nBlocksPh = 1
              jBlocksPh(1,1) = MaxRun
              jBlocksPh(2,1) = min0(MaxRun,500)
          endif
      endif
      if (lasts > 0) then
          nBlocksPh = 1
          jBlocksPh(1,1) = 1
          jBlocksPh(2,1) = 1
      endif
      MaxToStore = min0(MaxToStore,MaxRun)
!
      if (kmad > 0) then
          if (ifPhD < 0) then
              ifPhD = 0
          else
              ifPhD = 1
          endif
      else
*         if (ifPatt == 1 .and. ksize > 3) then
          if (ksize_vero > 3) then
              if (ifPhD < 0) then
                  ifPhD = 0
              else
                  ifPhD = 1
              endif
          else
              ifPhD = 0
          endif
      endif
      if (ilMilione == 1) then
          ifPhD = 0
      endif
!
      return
!
 9100 continue
      ier=-1
      if (jfragment == 1) then
          write(Msg,9110) ier,filet(1:Lung(filet))
      else
          write(Msg,9120) ier,filet(1:Lung(filet))
      endif
 9110 format(' Open error, code =',i5,' Fragment file name is ',a)
 9120 format(' Open error, code =',i5,' Recycle file name is ',a)
      call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
 9800 format('Number of independent reflections (',i5,') is too low.',
     *       ' VLD cannot be used !')
!
      return
      end
!-----------------------------------------------------------------------
      subroutine DefaultAbInitio()
      USE General
      USE PhaseModule
      USE RfacMatrixModule
      USE VLDmod
      USE VLDmod_3
!
      implicit none
!
!-- scelta automatica della Procedura Ab-initio
!

      if (kmad == 1) then
          ifMDM  = 0
          ifVLD  = 0
          ifTang = 0
          ifPatt = 1
      elseif (neutro == 0 .and. nrefl > minNrefl) then  ! DRX
          if (ksize <= 3) then
              ifMDM = 1
              ifVLD = 0
              ifTang  = 0
              ifPatt  = 0
              ifDsrVLD  = 0   
              n_EDM = 18
              ifDsrVLD = 0
              stopFinalFom  = 0.3
              stopFinalFom2 = 3.0       ! x MDM
              if (ksize <= 2) then
                  n_Maxrun = 100
              else
                  n_Maxrun = 600
              endif
              nBlocksPh = 1
              jBlocksPh(1,1) = n_Maxrun
              jBlocksPh(2,1) = n_Maxrun
              if (numbGen > 0) then
                  ifVLD = 0
                  ifTang  = 1
                  ifPatt  = 0
                  ifDsrVLD  = 0   
              endif
          else
              if (iwei > 0 .or. no(nk) >= 15) then  
                  ifVLD = 0
                  ifTang  = 0
                  ifPatt  = 1   ! dedi 08/03/13 modifica per PattVLD per Proteine
                  ifDsrVLD  = 1   
              else
                  ifMDM = 1  ! gianluca 03/02/2014
                  ifVLD = 0  ! se proteina e no HA, allora MDM gianluca
                  ifTang  = 0
                  ifPatt  = 0
                  ifDsrVLD  = 0
                  stopFinalFom  = 0.3
                  stopFinalFom2 = 3.0
                  n_Maxrun = 600
             endif
          endif
      else !  neutro /= 0  Elettroni oppure pochi riflessi Gianluca 07/05/2015
          ifVLD = 0
          ifTang  = 1
          ifPatt  = 0
          ifDsrVLD  = 0
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine weitan_MDM(nuset, nnn)
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseStuff
      USE PhaseModule
      USE VLDmod
      USE VLDmod_3, only:ifForm20
c
      dimension ifa(3)
      dimension alp(4000),iphazz(4000),wttLocal(4000)
      dimension ianto(4000)
!psie      
!psie      dimension alp(12000),iphazz(12000),wttLocal(12000)
!psie      dimension ianto(12000)
      dimension SC_alfa(300)
      
c
c
c--aggiustamento per il calcolo della FinalFom quando
c  si usa la Patterson: evita che si esca dal do while
c  con tutti i pesi nulli
c
!piero
      if (ifMDM == 1) then
         iprin = 1
!cris
         if (nuset /= 0) then      
             irefin(:) = 1
             numero_random = 0
             do i=1,nstr
                if (wt(i) /= 0.0) then
                    numero_random = numero_random + 1
                    irefin(i) = 0
                end if
             end do
             if (knw == 1) then
                 write(lo,'(/,a,2i5,/)') ' FASI RANDOM INIZIALI',nstr,
     *                                   numero_random
             endif
         end if
      end if
!cris      
      if (ifPatt == 0) then
          sogalpham=1.5
      else
          sogalpham=0.01
      endif
c
      soglow   = 0.5
      zer      = 0.1e-10
      alphaVet(:) = 0.
      alpha_str(:) = 0.0
      ianto(:) = 0
      num_det = 0
      swh_det = 0.0
      swh_med = 1.
c===============================================================
      salf=0.
      alpham=10000000.
      kVai = 1
      ncycl = 0
      ifRiscala = 0
      Perc_det = 0.0
      Cicli: do while (kVai.eq.1)
         ncycl = ncycl + 1
         alphmax=0.0
         sumalf= salf
         salf  = 0.0
         dalfa = 0.0
         numb1 = 0
         
         n_random = 0
         swh = 0.0
                     
         do ll= 1,nnn
            k=iordeTang(ll)
            
            if (ifPert_tg == 1) then
                if (irefin(k) == 1 .and. ncycl > 1) then
                    irefin(k)=0 
                endif
            endif
            alfmed=0.0
            cang=0.
            sang=0.
                        
            jcris=0
            ist = 3
            jpqq = 0
            do kcr=1,2
               ist = ist + 1
               li=limref(kcr,k)*ist+1 + jpqq
               ls=limref(kcr,k+1)*ist + jpqq
               if (li.le.ls) then
                   do jj= li,ls,ist
                      numi=0
                      w=1
                      ip=0
                      nn(2)=0
                      ifa(2)=0
                      nn(3)=0
                      ifa(3)=0
                      iw=4
                      ir = iph(jj)
                      ira = iabs(ir)
                      il = iph(jj+1)
                      ila = iabs(il)
                      if ( kcr.eq.1) then
!psie
!psie                     if (ira>nnn .or. ila>nnn) then
!psie                        cycle
!psie                     end if
                         
                         if(abs(wt(ira)).lt.0.1 .or.
     *                      abs(wt(ila)).lt.0.1) cycle
                      else
                         it = iph(jj+2)
                         ita = iabs(it)
!psie
!psie                     if (ira>nnn .or. ila>nnn .or. ita>nnn) then
!psie                        cycle
!psie                     end if
                         
                         if(abs(wt(ira)).lt.0.1 .or.
     *                      abs(wt(ila)).lt.0.1 .or.
     *                      abs(wt(ita)).lt.0.1) cycle
                      end if
                      numi = numi+1
                      nn(numi) = ir
                      w = w*wt(ira)
                      ifa(numi) = iphaz(ira)
                      numi = numi+1
                      nn(numi) = il
                      w = w*wt(ila)
                      ifa(numi) = iphaz(ila)
                      ip=isign(ifa(1),nn(1))
                      ip=ip+isign(ifa(2),nn(2))                    
                      if ( kcr.eq.1) then
                         a1 = iph(jj+2)*0.01
                         ifaz = iph(jj+3)
                      else
                         numi = numi+1
                         nn(numi) = it
                         w = w*wt(ita)
                         ifa(numi) = iphaz(ita)
                         a1 = iph(jj+3)*0.01
                         ifaz = iph(jj+4)
                         ip=ip+isign(ifa(3),nn(3))
                      end if
                      aa1=abs(w)
                      if(a1.gt.6.) a1=6.0
                      jcris=jcris+1
                      ip=ip+15*ifaz+36000
                      ip= mod(ip,360)+1
                      gbes=abs(a1)
                      a1=bes(a1)
                      aa1=aa1*gbes
                      ee=aa1
                      sang=sang+ee*sint(ip)
                      cang=cang+ee*cost(ip)
                      alfmed=alfmed+gbes*a1
                   enddo
               endif
               jpqq = jpq
            enddo

            if (jcris == 0) cycle
!
!-- introduce psi-zero in tangent formula
!
            if (nnn == nstr .and. ifNewPsi0 == 1) then
                call newpsi(k,sang,cang,nn0,tnd,alpham)
            endif
!
            if (mkang(k) /= 1) then
                idv = 15*mod(iabs(mkang(k))-1,12) + 1
                t2 = sang*sint(idv) + cang*cost(idv)
                sang = t2*sint(idv)
                cang = t2*cost(idv)
            endif
            
            if (abs(sang) < zer .and. abs(cang) < zer) cycle
            alfa = sang*sang + cang*cang
            if (alfa < zer) cycle
            alphaVet(k)=alfa
            phaz=rtod*atan2(sang,cang)
            ip=nint(phaz)
            ip=mod(ip+3600,360)
            if(ip.eq.0) ip=360
            iphaze=ip
            wh=1.
            
            
            if (alphaVet(k).gt.alphmax) alphmax=alphaVet(k)
            irandom = 0
            if (alphavet(k).lt.alpham) then
              if (nuset == 0 . or. ncycl == 1) cycle
               if (irefin(k) /= 0) then 
                  cycle
               else
                 irandom = 1
               end if
            end if
          

!
!-- Applico pesi
!
            
            alfa = sqrt(alphaVet(k))
            
!riscala alfa e alfmed
            if (ifRiscala == 1) then
               alfa = alfa * SC_alfa_np1           
               alfmed = alfmed * SC_alfa_np1           
            end if
            
            if (alfmed > 0.00001) then
                if (alfa.le.alfmed) then
                    if (ipesi.eq.1) then
                        wh = 1.0
                    else
                        wh = bes(alfa)
                    endif
                else
                    if (ipesi.eq.1) then
                        wh = 1.0
                    elseif (ipesi.eq.2) then
                        wh = exp (-(alfa-alfmed)/alfmed)
                    elseif (ipesi.eq.3) then
                        wh = sqrt(exp (-(alfa-alfmed)/alfmed))
                    elseif (ipesi.eq.4) then
                        wh = bes(alfa)
                    elseif (ipesi.eq.5) then
                        wh = (exp (-(alfa-alfmed)/alfmed))**0.333
                    elseif (ipesi.eq.6) then
                        wh = (exp (-(alfa-alfmed)/alfmed))**0.25
                    elseif (ipesi.eq.7) then
                        wh = (exp (-(alfa-alfmed)/alfmed))**0.10
                    endif
                endif
                if (wh < 0.2) wh = 0.2
            endif
!
            if (ksize_vero >= 4) then
               if (nuset /= 0 .and. ncycl > 1)  then
                  if (irandom == 0) then
                     swh_det = swh_det  + wh
                     num_det = num_det + 1
                     swh_med =  swh_det / num_det
                  elseif (irandom == 1) then
                     n_random = n_random + 1
                     wh = 0.6 * swh_med
                     swh = swh + wh
                  end if
               end if
            else
               if (irandom == 1) then
                  n_random = n_random + 1
                  wh = wh / 2.
                  swh = swh + wh
               end if
            end if           
            
            wt(k)=wh
            
            iphaz(k)=iphaze
            if (irandom == 0) then
              ianto(k)=1
              numb1=numb1+1
              salf=salf+alphaVet(k)
!cris            
! se è una fase random irefin = 1
              if (nuset /= 0 ) then
                if (irefin(k) ==0) then
                  irefin(k) = 1
                end if
              end if
            end if
!cris            
cdedi
            if (wt(k) > zer) alpha_str(k) = alphaVet(k)
cdedi
         enddo
         
         if (n_random > 0) then
          swh = swh/n_random
!          write (lo,'(a,i5,f10.6)')'media dei pesi delle fasi random',
!     *                              n_random,swh
         end if 
!
         if (nnn == nstr .and. ifNewPsi0 == 1) then
             ipr=0
             call newpsi4
         endif
!
         numb1prec = numb1
         numb1sog = numb1prec + 0.5 * numb1prec
         if (ncycl == 1) nDetRef = 0  !piero
!--------------------------------------------------------------------
!calcolo della scala per gli alfaVet per ottenere <wt> = 0.6
       if (ncycl > 1 .and. nuset > 0) then
         nDetRef = 0
         Sum_alfa = 0.0
         alfa_rif = besinv(0.6)
         do i=1, nnn
            if (irefin(i) == 1) then
               nDetRef = nDetRef + 1
               Sum_alfa = sum_alfa + sqrt(alphaVet(i))
            end if
         end do
         Rmedia_alfa = Sum_alfa / nDetRef
         SC_alfa(ncycl) = alfa_rif / Rmedia_alfa
         Perc_Det = float(nDetRef) / nnn
         if (Perc_Det < 0.2) then
            ifRiscala = 0
            SC_alfa_np1 = 0.0
         else
            if (Perc_Det <0.65) then
               SC_alfa_np1 = 1.25 * SC_alfa(ncycl)
            elseif (Perc_Det <0.8) then
               SC_alfa_np1 = 1.15 * SC_alfa(ncycl)
            else
               SC_alfa_np1 = 1.10 * SC_alfa(ncycl)
            end if
         end if
         
         WtWt = 0.0
         do i=1, nnn
            if (irefin(i) == 1) then
              WtWt = WtWt + bes(sqrt(alphaVet(i)) * SC_alfa(ncycl))
!                WtWt = WtWt + wt(i)
            end if
         end do
         WtWt = WtWt / nDetRef
      
!      write(lo,'(a,i5,4f10.5)')' ciclo,%,Sc_alfa, <Wt>, Sc_alfanp1',
!     *         ncycl,Perc_Det,SC_alfa(ncycl),WtWt,SC_alfa_np1
      end if 
!--------------------------------------------------------------------
!
!-- calcolo della soglia sull'alpha per innescare la tangente
!
         if (ncycl == 1) then
!
             do ib=1,nstr
                alp(ib) = alphaVet(ib)
             end do
             call sortall (-1,alp,nstr)
!
             nult = 30
             if (nult.gt.nnn) then
                 nult = nnn / 2
             endif
             alpham = alp(nult)
!
             if (alpham.lt.0.01) then
                 kult = 0
                 do i=nult,1,-1
                    if (alp(i).gt.0.01.and.kult.eq.0) then
                        kult = i
                        alpham = alp(kult)
                    endif
                 enddo
             endif
!
             if (alpham < soglow) then
                soglow = alphmax * 0.3
!                write(lo,*) 'alphmax, soglow =',alphmax,soglow
            endif
         endif
c--
         if (knw == 1 .and. ifExamin /=0 .and. iprin > 0) then
             if (ncycl.ne.1) then
                 do i=1,nstr
                    wttLocal(i)=wt(i)*ianto(i)
                    iphazz(i)=iphaz(i)*ianto(i)
                 enddo
                 erore = 0
                 erorepes = 0
                 izero = 0
                 ifmin = 0 !1
                 call examin(nuset,mkang,khl,ipub,iphazz,nstr,izero,
     *                       wttLocal,ifmin)
             else
                 erore = 0
                 erorepes = 0
             endif
             soglia=sqrt(alpham) 
             soglix=sqrt(alphmax)
c            write(lo,9000) ncycl,nnn,soglia,erore,
c    *                     erorepes,numb1,soglix
         endif
         
         if (Perc_Det >= 0.2) then
            ifRiscala = 1
         end if
!        iprin = 0
c
         kVai = 0
!pgMAD
         if (kmad.eq.0) then
             percent1 = 0.50
         else
             percent1 = 0.80
         end if
!pgMAD
         if (ifPert_tg == 1 ) then
             percent1 = 0.75
         endif
         percent2 = 0.90
         
!formula20
         if (ifForm20 == 1) then
             numb11 = nDetRef
         else 
             numb11 = numb1
         end if
!cris2         if (numb1.lt.(percent1*nnn)) then
!cris2        if (nDetRef.lt.(percent1*nnn)) then
         if (numb11.lt.(percent1*nnn)) then
             cut= percent2 * alpham
             alpham=amax1(cut,0.05)
             if (alpham.gt.soglow) kVai = 1
!            if (alpham.gt.1.5) kVai = 1 ! originale
             if (alpham.gt.sogalpham) kVai = 1
             if (ncycl.gt.300) kVai = 0    !!!!  Evita il loop se non fasa niente
!      write (lo,'(a,i6,3f12.6)')' CICLO =',ncycl,alpham,soglow,sogalpham
         else
           if (ifForm20 == 1) then
             exit
           end if
         end if
         
c-- se non sono stati fasati riflessi durante l'autoconsistenza
         if (kVai.eq.0) then 
             if (salf.le.0.0001) then
                 exit
             endif
             if ((salf-sumalf)/salf.gt.0.02) kVai = 1
         endif
      end do Cicli
c   fine loop per raffinamento tangente
      numb_det = 0
      do i=1,nstr
         if(ianto(i) == 1) numb_det = numb_det + 1
         wt(i)=wt(i)*ianto(i)
         iphaz(i)=iphaz(i)*ianto(i)
      enddo
      bMedia = 0.
      nMedia = 0
      do jjff=1,nstr
            if (wt(jjff) /= 0.0) then
!            write(lo,'(i5,f6.3,i5)') jjff,wt(jjff),iphaz(jjff)
               nMedia = nMedia + 1
               bMedia = bMedia + wt(jjff)
            end if
       end do
       bMedia = bMedia / nMedia
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
!piero
!      if (nuset == 1) stop
      if (ifMDM == 1 .and. kverbo_pg > 0) then
      write(lo,'(a,i7,f12.5)')' Fasi determinate con <wt> = ',
     *         numb_det,bMedia
      end if
      iprin = 0
      
!
      return
 9000 format(' ncy=',i3,' nnn=',i4,' alpham=',f8.3,' er=',f8.3,
     1       ' w-er=',f8.3,' det.ph=',i4,' max alfa=',f10.3,/)
      end
!-----------------------------------------------------------------------
      subroutine weitan_psie(nuset, nnn, nrefl_psie)
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseStuff
      USE PhaseModule
      USE VLDmod
c
      dimension ifa(3)
      dimension iphazz(12000),wttLocal(12000)
      dimension ianto(12000)
      character tirang*80
      
c

      iprin = 1
c
      write (lo,'(/,a,/)') ' Tangente Psi-E ='
      zer      = 0.1e-10
      alphaVet(:) = 0.
      ianto(:) = 0
      do i = 1, nstr
          if (wt(i) > 0.0) then
              ianto(i) = 1
          end if
      end do
c===============================================================
         numb1 = 0
         nnn_iniz = nnn + 1
         nnn_ifin = nrefl_psie
                     
         do ll= nnn_iniz,nnn_ifin
            k=ll
            
            alfmed=0.0
            cang=0.
            sang=0.
                        
            jcris=0
            kcr=1
            ist = 4
            li=limref(kcr,k)*ist+1
            ls=limref(kcr,k+1)*ist
            if (li.le.ls) then
                do jj= li,ls,ist
                   numi=0
                   w=1
                   ip=0
                   nn(2)=0
                   ifa(2)=0
                   nn(3)=0
                   ifa(3)=0
                   iw=4
                   ir = iph(jj)
                   ira = iabs(ir)
                   il = iph(jj+1)
                   ila = iabs(il)
                   if(abs(wt(ira)).lt.0.1 .or. abs(wt(ila)).lt.0.1) then
                     cycle
                   end if
                   numi = numi+1
                   nn(numi) = ir
                   w = w*wt(ira)
                   ifa(numi) = iphaz(ira)
                   numi = numi+1
                   nn(numi) = il
                   w = w*wt(ila)
                   ifa(numi) = iphaz(ila)
                   ip=isign(ifa(1),nn(1))
                   ip=ip+isign(ifa(2),nn(2))                    
                   a1 = iph(jj+2)*0.01
                   ifaz = iph(jj+3)
                   aa1=abs(w)
                   if(a1.gt.6.) a1=6.0
                   jcris=jcris+1
                   ip=ip+15*ifaz+36000
                   ip= mod(ip,360)+1
                   gbes=abs(a1)
                   a1=bes(a1)
                   aa1=aa1*gbes
                   ee=aa1
                   sang=sang+ee*sint(ip)
                   cang=cang+ee*cost(ip)
                   alfmed=alfmed+gbes*a1
                enddo
            endif

            if (jcris == 0) cycle
            
            if (mkang(k) /= 1) then
                idv = 15*mod(iabs(mkang(k))-1,12) + 1
                t2 = sang*sint(idv) + cang*cost(idv)
                sang = t2*sint(idv)
                cang = t2*cost(idv)
            endif
            
            if (abs(sang) < zer .and. abs(cang) < zer) cycle
            alfa = sang*sang + cang*cang
            if (alfa < zer) cycle
            alphaVet(k)=alfa
            phaz=rtod*atan2(sang,cang)
            ip=nint(phaz)
            ip=mod(ip+3600,360)
            if(ip.eq.0) ip=360
            iphaze=ip
            wh=1.
!
!-- Applico pesi
!
            
            alfa = sqrt(alphaVet(k))
            if (alfmed > 0.00001) then
                if (alfa.le.alfmed) then
                    if (ipesi.eq.1) then
                        wh = 1.0
                    else
                        wh = bes(alfa)
                    endif
                else
                    if (ipesi.eq.1) then
                        wh = 1.0
                    elseif (ipesi.eq.2) then
                        wh = exp (-(alfa-alfmed)/alfmed)
                    elseif (ipesi.eq.3) then
                        wh = sqrt(exp (-(alfa-alfmed)/alfmed))
                    elseif (ipesi.eq.4) then
                        wh = bes(alfa)
                    elseif (ipesi.eq.5) then
                        wh = (exp (-(alfa-alfmed)/alfmed))**0.333
                    elseif (ipesi.eq.6) then
                        wh = (exp (-(alfa-alfmed)/alfmed))**0.25
                    elseif (ipesi.eq.7) then
                        wh = (exp (-(alfa-alfmed)/alfmed))**0.10
                    endif
                endif
                if (wh < 0.2) wh = 0.2
            endif
!
            wt(k)=wh
            iphaz(k)=iphaze
            ianto(k)=1
            numb1=numb1+1
         enddo
c--
         if (knw == 1 .and. ifExamin /=0 .and. iprin > 0) then
             do i=1,nnn_ifin
                 wttLocal(i)=wt(i)*ianto(i)
                 iphazz(i)=iphaz(i)*ianto(i)
             enddo
             
             write(lo,'(/,a,/)') ' MPE su Nlarge + Psi-E='
             
             erore = 0
             erorepes = 0
             izero = 0
             ifmin = 1
             call examin(nuset,mkang,khl,ipub,iphazz,nnn_ifin,izero,
     *                       wttLocal,ifmin)
!             write(lo,8000) nstr,erore,erorepes
             
!-distribuzione errore
             do i = 1,nnn_ifin
                if (i <= nstr) then
                   tmpwt(i) = 0.0
                else
                   tmpwt(i) = wttLocal(i)
                endif
             enddo
             
             write(lo,'(/,a,/)') ' MPE su Psi-E ='
            
             erore = 0
             erorepes = 0
             izero = nnn_iniz-1
             ifmin = 1
             call examin(nuset,mkang,khl,ipub,iphazz,nnn_ifin,izero,
     *                       tmpwt,ifmin)
             
             
 !            write(lo,9000) nnn_ifin,erore,erorepes,numb1
             
             tirang = ' stat WT    '
             izero = nnn_iniz-1
             ipher = 1
             call weightsdis(tirang,tmpwt,khl,nnn_ifin,izero,
     *                     ipub,iphazz,tmpwt,10,0.0,ipher)

            
             
         endif
         
c   fine loop 
      numb_det = 0
      do i=1,nnn_ifin
         if(ianto(i) == 1) numb_det = numb_det + 1
         wt(i)=wt(i)*ianto(i)
         iphaz(i)=iphaz(i)*ianto(i)
      enddo
      jt = 0
      do i=nnn_iniz,nnn_ifin
         jt = jt + 1
         tmpwt(jt) = wt(i)
      end do
      call sortall(-1, tmpwt, jt)
      sog = tmpwt(nint(jt*0.5))
      numb_det = 0
      do i=nnn_iniz,nnn_ifin
         if(ianto(i) == 1 .and. wt(i) > sog) then
            numb_det = numb_det + 1
            wt(i)=wt(i)*ianto(i)
            iphaz(i)=iphaz(i)*ianto(i)
         else
            wt(i) = 0.0
         end if
      enddo
      write(lo,'(/a,i6,/)') ' Psi-E prese 50% con wt maggiore =',
     *                        numb_det
      iprin = 0
      
!
      return
 8000 format(' nstr=',i4,' er=',f8.3,' w-er=',f8.3,/)
 9000 format(' nnn_ifin=',i4,' er=',f8.3,' w-er=',f8.3,' det.ph=',i4/)
      end
!-----------------------------------------------------------------------
      subroutine weitan_estendi(nuset, nnn)
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseStuff
      USE PhaseModule
      USE VLDmod
c
      dimension ifa(3)
      dimension iphazz(12000),wttLocal(12000)
      dimension ianto(12000)
      character tirang*80
      
c

      iprin = 1
c
      write (lo,'(/,a,/)') ' Tangente Estensione ='
      zer      = 0.1e-10
      alphaVet(:) = 0.
      ianto(:) = 0
      do i = 1, nstr
          if (wt(i) > 0.0) then
              ianto(i) = 1
          end if
      end do
c===============================================================
         numb1 = 0
         nnn_iniz =  1
         nnn_ifin = nnn
                     
         do ll= nnn_iniz,nnn_ifin
            k=ll
            if (ianto(k) == 1) cycle
            alfmed=0.0
            cang=0.
            sang=0.
                        
            jcris=0
            kcr=1
            ist = 4
            li=limref(kcr,k)*ist+1
            ls=limref(kcr,k+1)*ist
            if (li.le.ls) then
                do jj= li,ls,ist
                   numi=0
                   w=1
                   ip=0
                   nn(2)=0
                   ifa(2)=0
                   nn(3)=0
                   ifa(3)=0
                   iw=4
                   ir = iph(jj)
                   ira = iabs(ir)
                   il = iph(jj+1)
                   ila = iabs(il)
                   if(abs(wt(ira)).lt.0.1 .or. abs(wt(ila)).lt.0.1) then
                     cycle
                   end if
                   numi = numi+1
                   nn(numi) = ir
                   w = w*wt(ira)
                   ifa(numi) = iphaz(ira)
                   numi = numi+1
                   nn(numi) = il
                   w = w*wt(ila)
                   ifa(numi) = iphaz(ila)
                   ip=isign(ifa(1),nn(1))
                   ip=ip+isign(ifa(2),nn(2))                    
                   a1 = iph(jj+2)*0.01
                   ifaz = iph(jj+3)
                   aa1=abs(w)
                   if(a1.gt.6.) a1=6.0
                   jcris=jcris+1
                   ip=ip+15*ifaz+36000
                   ip= mod(ip,360)+1
                   gbes=abs(a1)
                   a1=bes(a1)
                   aa1=aa1*gbes
                   ee=aa1
                   sang=sang+ee*sint(ip)
                   cang=cang+ee*cost(ip)
                   alfmed=alfmed+gbes*a1
                enddo
            endif

            if (jcris == 0) cycle
            
            if (mkang(k) /= 1) then
                idv = 15*mod(iabs(mkang(k))-1,12) + 1
                t2 = sang*sint(idv) + cang*cost(idv)
                sang = t2*sint(idv)
                cang = t2*cost(idv)
            endif
            
            if (abs(sang) < zer .and. abs(cang) < zer) cycle
            alfa = sang*sang + cang*cang
            if (alfa < zer) cycle
            alphaVet(k)=alfa
            phaz=rtod*atan2(sang,cang)
            ip=nint(phaz)
            ip=mod(ip+3600,360)
            if(ip.eq.0) ip=360
            iphaze=ip
            wh=1.
!
!-- Applico pesi
!
            
            alfa = sqrt(alphaVet(k))
            if (alfmed > 0.00001) then
                if (alfa.le.alfmed) then
                    if (ipesi.eq.1) then
                        wh = 1.0
                    else
                        wh = bes(alfa)
                    endif
                else
                    if (ipesi.eq.1) then
                        wh = 1.0
                    elseif (ipesi.eq.2) then
                        wh = exp (-(alfa-alfmed)/alfmed)
                    elseif (ipesi.eq.3) then
                        wh = sqrt(exp (-(alfa-alfmed)/alfmed))
                    elseif (ipesi.eq.4) then
                        wh = bes(alfa)
                    elseif (ipesi.eq.5) then
                        wh = (exp (-(alfa-alfmed)/alfmed))**0.333
                    elseif (ipesi.eq.6) then
                        wh = (exp (-(alfa-alfmed)/alfmed))**0.25
                    elseif (ipesi.eq.7) then
                        wh = (exp (-(alfa-alfmed)/alfmed))**0.10
                    endif
                endif
                if (wh < 0.2) wh = 0.2
            endif
!
            wt(k)=wh
            iphaz(k)=iphaze
            ianto(k)=1
            numb1=numb1+1
         enddo
c--
         if (knw == 1 .and. ifExamin /=0 .and. iprin > 0) then
             do i=1,nnn_ifin
                 wttLocal(i)=wt(i)*ianto(i)
                 iphazz(i)=iphaz(i)*ianto(i)
             enddo
             
             erore = 0
             erorepes = 0
             izero = 0
             ifmin = 1
             call examin(nuset,mkang,khl,ipub,iphazz,nstr,izero,
     *                       wttLocal,ifmin)
             write(lo,8000) nstr,erore,erorepes
            
         endif
         
c   fine loop 
      numb_det = 0
      do i=1,nnn_ifin
         if(ianto(i) == 1) numb_det = numb_det + 1
         wt(i)=wt(i)*ianto(i)
         iphaz(i)=iphaz(i)*ianto(i)
      enddo

      iprin = 0
      
!
      return
 8000 format(' nstr=',i4,' er=',f8.3,' w-er=',f8.3,/)

      end
!-----------------------------------------------------------------------
      subroutine weitan(nuset, nnn)
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseStuff
      USE PhaseModule
c
      dimension ifa(3)
      dimension alp(4000),iphazz(4000),wttLocal(4000)
      dimension ianto(4000)
!psie      
!psie      dimension alp(12000),iphazz(12000),wttLocal(12000)
!psie      dimension ianto(12000)
c
c
c--aggiustamento per il calcolo della FinalFom quando
c  si usa la Patterson: evita che si esca dal do while
c  con tutti i pesi nulli
c
      if (ifPatt == 0) then
          sogalpham=1.5
      else
          sogalpham=0.01
      endif
c
      soglow   = 0.5
      zer      = 0.1e-10
      alphaVet(:) = 0.
      ianto(:) = 0
c===============================================================
      salf=0.
      alpham=10000000.
      kVai = 1
      ncycl = 0
      Cicli: do while (kVai.eq.1)
         ncycl = ncycl + 1
         alphmax=0.0
         sumalf= salf
         salf  = 0.0
         dalfa = 0.0
         numb1 = 0
         do ll= 1,nnn
            k=iordeTang(ll)
            if (ifPert_tg == 1) then
                if (irefin(k) == 1 .and. ncycl > 1) then
                    irefin(k)=0 
                endif
            endif
            if (irefin(k) == 1) cycle
            if (irefin(k) == 2) then
                if (ncycl > 1) then
                    irefin(k)=0 
                else
                    cycle
               endif
            endif
            alfmed=0.0
            cang=0.
            sang=0.
            jcris=0
            ist = 3
            jpqq = 0
            do kcr=1,2
               ist = ist + 1
               li=limref(kcr,k)*ist+1 + jpqq
               ls=limref(kcr,k+1)*ist + jpqq
               if (li.le.ls) then
                   do jj= li,ls,ist
                      numi=0
                      w=1
                      ip=0
                      nn(2)=0
                      ifa(2)=0
                      nn(3)=0
                      ifa(3)=0
                      iw=4
                      ir = iph(jj)
                      ira = iabs(ir)
                      il = iph(jj+1)
                      ila = iabs(il)
                      if ( kcr.eq.1) then
                         if(abs(wt(ira)).lt.0.1 .or.
     *                      abs(wt(ila)).lt.0.1) cycle
                      else
                         it = iph(jj+2)
                         ita = iabs(it)
                         if(abs(wt(ira)).lt.0.1 .or.
     *                      abs(wt(ila)).lt.0.1 .or.
     *                      abs(wt(ita)).lt.0.1) cycle
                      end if
                      numi = numi+1
                      nn(numi) = ir
                      w = w*wt(ira)
                      ifa(numi) = iphaz(ira)
                      numi = numi+1
                      nn(numi) = il
                      w = w*wt(ila)
                      ifa(numi) = iphaz(ila)
                      ip=isign(ifa(1),nn(1))
                      ip=ip+isign(ifa(2),nn(2))
                      if ( kcr.eq.1) then
                         a1 = iph(jj+2)*0.01
                         ifaz = iph(jj+3)
                      else
                         numi = numi+1
                         nn(numi) = it
                         w = w*wt(ita)
                         ifa(numi) = iphaz(ita)
                         a1 = iph(jj+3)*0.01
                         ifaz = iph(jj+4)
                         ip=ip+isign(ifa(3),nn(3))
                      end if
                      aa1=abs(w)
                      if(a1.gt.6.) a1=6.0
                      jcris=jcris+1
                      ip=ip+15*ifaz+36000
                      ip= mod(ip,360)+1
                      gbes=abs(a1)
                      a1=bes(a1)
                      aa1=aa1*gbes
                      ee=aa1
                      sang=sang+ee*sint(ip)
                      cang=cang+ee*cost(ip)
*          write(6,'(a,2i5,3f15.6)') 'W',k,ip,ee,sint(ip),a1
                      alfmed=alfmed+gbes*a1
                   enddo
               endif
               jpqq = jpq
            enddo

            if (jcris == 0) cycle
!
!-- introduce psi-zero in tangent formula
!
            if (nnn == nstr .and. ifNewPsi0 == 1) then
                call newpsi(k,sang,cang,nn0,tnd,alpham)
            endif
!
            if (mkang(k) /= 1) then
                idv = 15*mod(iabs(mkang(k))-1,12) + 1
                t2 = sang*sint(idv) + cang*cost(idv)
                sang = t2*sint(idv)
                cang = t2*cost(idv)
            endif
            if (abs(sang) < zer .and. abs(cang) < zer) cycle
            alfa = sang*sang + cang*cang
            if (alfa < zer) cycle
            alphaVet(k)=alfa
            phaz=rtod*atan2(sang,cang)
            ip=nint(phaz)
            ip=mod(ip+3600,360)
            if(ip.eq.0) ip=360
            iphaze=ip
            wh=1.
            if (alphaVet(k).gt.alphmax) alphmax=alphaVet(k)
            if (alphaVet(k).lt.alpham) cycle
!
!-- Applico pesi
!
            alfa = sqrt(alphaVet(k))
            if (alfmed > 0.00001) then
                if (alfa.le.alfmed) then
                    if (ipesi.eq.1) then
                        wh = 1.0
                    else
                        wh = bes(alfa)
                    endif
                else
                    if (ipesi.eq.1) then
                        wh = 1.0
                    elseif (ipesi.eq.2) then
                        wh = exp (-(alfa-alfmed)/alfmed)
                    elseif (ipesi.eq.3) then
                        wh = sqrt(exp (-(alfa-alfmed)/alfmed))
                    elseif (ipesi.eq.4) then
                        wh = bes(alfa)
                    elseif (ipesi.eq.5) then
                        wh = (exp (-(alfa-alfmed)/alfmed))**0.333
                    elseif (ipesi.eq.6) then
                        wh = (exp (-(alfa-alfmed)/alfmed))**0.25
                    elseif (ipesi.eq.7) then
                        wh = (exp (-(alfa-alfmed)/alfmed))**0.10
                    endif
                endif
                if (wh < 0.2) wh = 0.2
            endif
!
            wt(k)=wh
            ianto(k)=1
            iphaz(k)=iphaze
            numb1=numb1+1
            salf=salf+alphaVet(k)
         enddo
!
         if (nnn == nstr .and. ifNewPsi0 == 1) then
             ipr=0
             call newpsi4
         endif
!
         numb1prec = numb1
         numb1sog = numb1prec + 0.5 * numb1prec
!
!-- calcolo della soglia sull'alpha per innescare la tangente
!
         if (ncycl == 1) then
!
             do ib=1,nstr
                alp(ib) = alphaVet(ib)
             end do
             call sortall (-1,alp,nstr)
!
             nult = 30
             if (nult.gt.nnn) then
                 nult = nnn / 2
             endif
             alpham = alp(nult)
!
             if (alpham.lt.0.01) then
                 kult = 0
                 do i=nult,1,-1
                    if (alp(i).gt.0.01.and.kult.eq.0) then
                        kult = i
                        alpham = alp(kult)
                    endif
                 enddo
             endif
!
             if (alpham < soglow) then
!               write(lo,*) 'alphmax, soglow =',alphmax,soglow
                soglow = alphmax * 0.3
             endif
         endif
c--
         if (knw == 1 .and. ifExamin /=0 .and. iprin > 0) then
             if (ncycl == 2) then
                 gianluca = 1
             endif
             if (ncycl.ne.1) then
                 do i=1,nstr
                    wttLocal(i)=wt(i)*ianto(i)
                    iphazz(i)=iphaz(i)*ianto(i)
                 enddo
                 erore = 0
                 erorepes = 0
                 izero = 0
                 ifmin = 1
                 call examin(nuset,mkang,khl,ipub,iphazz,nstr,izero,
     *                       wttLocal,ifmin)
             else
                 erore = 0
                 erorepes = 0
             endif
             soglia=sqrt(alpham)
             soglix=sqrt(alphmax)
             write(lo,9000) ncycl,nnn,soglia,erore,
     *                     erorepes,numb1,soglix
         endif
!        iprin = 0
c
         kVai = 0
!pgMAD
         if (kmad.eq.0) then
             percent1 = 0.50
         else
             percent1 = 0.80
         end if
!pgMAD
         if (ifPert_tg == 1 ) then
             percent1 = 0.75
         endif
         percent2 = 0.90
         if (numb1.lt.(percent1*nnn)) then
             cut= percent2 * alpham
             alpham=amax1(cut,0.05)
             if (alpham.gt.soglow) kVai = 1
!            if (alpham.gt.1.5) kVai = 1 ! originale
             if (alpham.gt.sogalpham) kVai = 1
             if (ncycl.gt.300) kVai = 0    !!!!  Evita il loop se non fasa niente
         end if
c-- se non sono stati fasati riflessi durante l'autoconsistenza
         if (kVai.eq.0) then
             if (salf.le.0.0001) then
                 exit
             endif
             if ((salf-sumalf)/salf.gt.0.02) kVai = 1
         endif
      end do Cicli
c   fine loop per raffinamento tangente
      do i=1,nstr
         wt(i)=wt(i)*ianto(i)
         iphaz(i)=iphaz(i)*ianto(i)
      enddo
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc       
!
      return
 9000 format(' ncy=',i3,' nnn=',i4,' alpham=',f8.3,' er=',f8.3,
     1       ' w-er=',f8.3,' det.ph=',i4,' max alfa=',f10.3)
      end
!-----------------------------------------------------------------------
      subroutine weitan_MDM_SB(nuset, nnn, jjcris)
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseStuff
      USE PhaseModule
      USE VLDmod
c
      dimension ifa(3)
      dimension alp(4000),iphazz(4000),wttLocal(4000)
      dimension ianto(4000)
!psie      
!psie      dimension alp(12000),iphazz(12000),wttLocal(12000)
!psie      dimension ianto(12000)
      dimension SC_alfa(300)
      
c
c
c--aggiustamento per il calcolo della FinalFom quando
c  si usa la Patterson: evita che si esca dal do while
c  con tutti i pesi nulli
c
!piero
      if (ifMDM == 1) then
         iprin = 1
!cris
!         if (nuset /= 0) then      
!           irefin(:) = 1
!           numero_random = 0
!           do i=1,nstr
!            if (wt(i) /= 0.0) then
!              numero_random = numero_random + 1
!              irefin(i) = 0
!            end if
!           end do
!        write(lo,'(/,a,2i5,/)') ' FASI RANDOM INIZIALI',nstr,
!     *                                         numero_random
!         end if
      end if
      
      irefin(:) = 0
      
!cris      
      if (ifPatt == 0) then
          sogalpham=1.5
      else
          sogalpham=0.01
      endif
c
      soglow   = 0.5
      zer      = 0.1e-10
      alphaVet(:) = 0.
      alpha_str(:) = 0.0
      ianto(:) = 0
      num_det = 0
      swh_det = 0.0
      swh_med = 1.
c===============================================================
      salf=0.
      alpham=10000000.
      kVai = 1
      ncycl = 0
      ifRiscala = 0
      Perc_det = 0.0
      Cicli: do while (kVai.eq.1)
         ncycl = ncycl + 1
         
!         if (ncycl == 3) then
!           exit
!         end if
         alphmax=0.0
         sumalf= salf
         salf  = 0.0
         dalfa = 0.0
         numb1 = 0
         
         n_random = 0
         swh = 0.0
                     
         do ll= 1,nnn
            k=iordeTang(ll)
            
            alfmed=0.0
            cang=0.
            sang=0.
                        
            jcris=0
            ist = 3
            jpqq = 0
            do kcr=1,2
               ist = ist + 1
               li=limref(kcr,k)*ist+1 + jpqq
               ls=limref(kcr,k+1)*ist + jpqq
               if (li.le.ls) then
                   do jj= li,ls,ist
                      numi=0
                      w=1
                      ip=0
                      nn(2)=0
                      ifa(2)=0
                      nn(3)=0
                      ifa(3)=0
                      nn(4) = 0
                      iw=4
                      ir = iph(jj)
                      ira = iabs(ir)
                      il = iph(jj+1)
                      ila = iabs(il)
                      if ( kcr.eq.1) then
                         if(abs(wt(ira)).lt.0.1 .or.
     *                      abs(wt(ila)).lt.0.1) cycle
                      else
                         it = iph(jj+2)
                         ita = iabs(it)
                         if(abs(wt(ira)).lt.0.1 .or.
     *                      abs(wt(ila)).lt.0.1 .or.
     *                      abs(wt(ita)).lt.0.1) cycle
                      end if
                      numi = numi+1
                      nn(numi) = ir
                      w = w*wt(ira)
                      ifa(numi) = iphaz(ira)
                      numi = numi+1
                      nn(numi) = il
                      w = w*wt(ila)
                      ifa(numi) = iphaz(ila)
                      ip=isign(ifa(1),nn(1))
                      ip=ip+isign(ifa(2),nn(2))                    
                      if ( kcr.eq.1) then
                         a1 = iph(jj+2)*0.01
                         ifaz = iph(jj+3)
                      else
                         numi = numi+1
                         nn(numi) = it
                         w = w*wt(ita)
                         ifa(numi) = iphaz(ita)
                         a1 = iph(jj+3)*0.01
                         ifaz = iph(jj+4)
                         ip=ip+isign(ifa(3),nn(3))
                      end if
                      aa1=abs(w)
                      if(a1.gt.6.) a1=6.0
                      jcris=jcris+1
                      ip=ip+15*ifaz+36000
                      ip= mod(ip,360)+1
                      gbes=abs(a1)
                      a1=bes(a1)
                      aa1=aa1*gbes
                      ee=aa1
                      sang=sang+ee*sint(ip)
                      cang=cang+ee*cost(ip)
                      alfmed=alfmed+gbes*a1
                
            if (jjcris == 2) then
            if (nuset /= 0) then
            if (ncycl == 15 .or. ncycl == 16  .or. ncycl == 17) then
            if (k == 2) then
 !           write(lo,'(2i5,3i5,3f7.2)')
 !    *      k,irefin(k),nn(1),nn(2),nn(3),wt(ira),wt(ila),wt(ita)
            end if
            end if
            end if
            end if  
               
                  enddo
               endif
               jpqq = jpq
            enddo

            if (jcris == 0) cycle
!
!-- introduce psi-zero in tangent formula
!
            if (nnn == nstr .and. ifNewPsi0 == 1) then
                call newpsi(k,sang,cang,nn0,tnd,alpham)
            endif
!
            if (mkang(k) /= 1) then
                idv = 15*mod(iabs(mkang(k))-1,12) + 1
                t2 = sang*sint(idv) + cang*cost(idv)
                sang = t2*sint(idv)
                cang = t2*cost(idv)
            endif
            
            if (abs(sang) < zer .and. abs(cang) < zer) cycle
            alfa = sang*sang + cang*cang
            if (alfa < zer) cycle
            alphaVet(k)=alfa
            phaz=rtod*atan2(sang,cang)
            ip=nint(phaz)
            ip=mod(ip+3600,360)
            if(ip.eq.0) ip=360
            iphaze=ip
            wh=1.
            
            
            if (alphaVet(k).gt.alphmax) alphmax=alphaVet(k)
            irandom = 0
            if (alphavet(k).lt.alpham) then
              if (nuset == 0 . or. ncycl == 1) cycle
               if (irefin(k) /= 0) then 
                  cycle
               else
                 irandom = 1
               end if
            end if
          

!
!-- Applico pesi
!
            
            alfa = sqrt(alphaVet(k))
            
!riscala alfa e alfmed
            if (ifRiscala == 1) then
               alfa = alfa * SC_alfa_np1           
               alfmed = alfmed * SC_alfa_np1           
            end if
            
            if (alfmed > 0.00001) then
                if (alfa.le.alfmed) then
                    if (ipesi.eq.1) then
                        wh = 1.0
                    else
                        wh = bes(alfa)
                    endif
                else
                    if (ipesi.eq.1) then
                        wh = 1.0
                    elseif (ipesi.eq.2) then
                        wh = exp (-(alfa-alfmed)/alfmed)
                    elseif (ipesi.eq.3) then
                        wh = sqrt(exp (-(alfa-alfmed)/alfmed))
                    elseif (ipesi.eq.4) then
                        wh = bes(alfa)
                    elseif (ipesi.eq.5) then
                        wh = (exp (-(alfa-alfmed)/alfmed))**0.333
                    elseif (ipesi.eq.6) then
                        wh = (exp (-(alfa-alfmed)/alfmed))**0.25
                    elseif (ipesi.eq.7) then
                        wh = (exp (-(alfa-alfmed)/alfmed))**0.10
                    endif
                endif
                if (wh < 0.2) wh = 0.2
            endif
!
            if (ksize_vero >= 4) then
               if (nuset /= 0 .and. ncycl > 1)  then
                  if (irandom == 0) then
                     swh_det = swh_det  + wh
                     num_det = num_det + 1
                     swh_med =  swh_det / num_det
                  elseif (irandom == 1) then
                     n_random = n_random + 1
                     wh = 0.6 * swh_med
                     swh = swh + wh
                  end if
               end if
            else
               if (irandom == 1) then
                  n_random = n_random + 1
                  wh = wh / 2.
                  swh = swh + wh
               end if
            end if           
            
            wt(k)=wh
            
            iphaz(k)=iphaze
            
            if (jjcris == 2) then
            if (nuset /= 0) then
            if (ncycl == 15 .or. ncycl == 16  .or. ncycl == 17) then
            if(irandom == 0) then
 !           write(lo,'(2i5,3f10.3,i5,f8.3)')
 !    *      k,irefin(k),alphaVet(k),alfa,wt(k),iphaz(k),alpham
            end if
            end if
            end if
            end if
            
            if (irandom == 0) then
              ianto(k)=1
              numb1=numb1+1
              salf=salf+alphaVet(k)
!cris            
! se ÃƒÂ¨ una fase random irefin = 1
              if (nuset /= 0 ) then
                if (irefin(k) ==0) then
                  irefin(k) = 1
                end if
              end if
            end if
!cris            
cdedi
            if (wt(k) > zer) alpha_str(k) = alphaVet(k)
cdedi
         enddo
         
         if (n_random > 0) then
          swh = swh/n_random
!          write (lo,'(a,i5,f10.6)')'media dei pesi delle fasi random',
!     *                              n_random,swh
         end if 
!
         if (nnn == nstr .and. ifNewPsi0 == 1) then
             ipr=0
             call newpsi4
         endif
!
         numb1prec = numb1
         numb1sog = numb1prec + 0.5 * numb1prec
         
!--------------------------------------------------------------------
!calcolo della scala per gli alfaVet per ottenere <wt> = 0.6
       if (ncycl > 1 .and. nuset > 0) then
         nDetRef = 0
         Sum_alfa = 0.0
         alfa_rif = besinv(0.6)
         do i=1, nnn
            if (irefin(i) == 1) then
               nDetRef = nDetRef + 1
               Sum_alfa = sum_alfa + sqrt(alphaVet(i))
            end if
         end do
         Rmedia_alfa = Sum_alfa / nDetRef
         SC_alfa(ncycl) = alfa_rif / Rmedia_alfa
         Perc_Det = float(nDetRef) / nnn
         if (Perc_Det < 0.2) then
            ifRiscala = 0
            SC_alfa_np1 = 0.0
         else
            if (Perc_Det <0.65) then
               SC_alfa_np1 = 1.25 * SC_alfa(ncycl)
            elseif (Perc_Det <0.8) then
               SC_alfa_np1 = 1.15 * SC_alfa(ncycl)
            else
               SC_alfa_np1 = 1.10 * SC_alfa(ncycl)
            end if
         end if
         
         WtWt = 0.0
         do i=1, nnn
            if (irefin(i) == 1) then
              WtWt = WtWt + bes(sqrt(alphaVet(i)) * SC_alfa(ncycl))
!                WtWt = WtWt + wt(i)
            end if
         end do
         WtWt = WtWt / nDetRef
      
      write(lo,'(a,i5,4f10.5)')' ciclo,%,Sc_alfa, <Wt>, Sc_alfanp1',
     *         ncycl,Perc_Det,SC_alfa(ncycl),WtWt,SC_alfa_np1
      end if 
!--------------------------------------------------------------------
!
!-- calcolo della soglia sull'alpha per innescare la tangente
!
         if (ncycl == 1) then
!
             do ib=1,nstr
                alp(ib) = alphaVet(ib)
             end do
             call sortall (-1,alp,nstr)
!
             nult = 30
             nult = 0.75 * nnn
             if (nult.gt.nnn) then
                 nult = nnn / 2
             endif
             alpham = alp(nult)
!
             if (alpham.lt.0.01) then
                 kult = 0
                 do i=nult,1,-1
                    if (alp(i).gt.0.01.and.kult.eq.0) then
                        kult = i
                        alpham = alp(kult)
                    endif
                 enddo
             endif
!
             if (alpham < soglow) then
                soglow = alphmax * 0.3
!                write(lo,*) 'alphmax, soglow =',alphmax,soglow
            endif
         endif
c--
         if (knw == 1 .and. ifExamin /=0 .and. iprin > 0) then
             if (ncycl.ne.1) then
                 do i=1,nstr
                    wttLocal(i)=wt(i)*ianto(i)
                    iphazz(i)=iphaz(i)*ianto(i)
                 enddo
                 erore = 0
                 erorepes = 0
                 izero = 0
                 ifmin = 1
                 call examin(nuset,mkang,khl,ipub,iphazz,nstr,izero,
     *                       wttLocal,ifmin)
             else
                 erore = 0
                 erorepes = 0
             endif
             soglia=sqrt(alpham) 
             soglix=sqrt(alphmax)
             write(lo,9000) ncycl,nnn,soglia,erore,
     *                     erorepes,numb1,soglix
         endif
         
         if (Perc_Det >= 0.2) then
            ifRiscala = 1
         end if
        iprin = 0
c
         kVai = 0
!pgMAD
         if (kmad.eq.0) then
             percent1 = 0.50
         else
             percent1 = 0.80
         end if
!pgMAD
         percent2 = 0.90
         if (numb1.lt.(percent1*nnn)) then
         
!             if (ncycl == 1) then
 !               alpham = 100.0
 !            end if
             
             cut= percent2 * alpham
             alpham=amax1(cut,0.05)
             if (alpham.gt.soglow) kVai = 1
!            if (alpham.gt.1.5) kVai = 1 ! originale
             if (alpham.gt.sogalpham) kVai = 1
             if (ncycl.gt.300) kVai = 0    !!!!  Evita il loop se non fasa niente
!      write (lo,'(a,i6,3f12.6)')' CICLO =',ncycl,alpham,soglow,sogalpham
             
         end if
         
c-- se non sono stati fasati riflessi durante l'autoconsistenza
         if (kVai.eq.0) then 
             if (salf.le.0.0001) then
                 exit
             endif
             if ((salf-sumalf)/salf.gt.0.02) kVai = 1
         endif
      end do Cicli
c   fine loop per raffinamento tangente
      numb_det = 0
      do i=1,nstr
         if(ianto(i) == 1) numb_det = numb_det + 1
         wt(i)=wt(i)*ianto(i)
         iphaz(i)=iphaz(i)*ianto(i)
      enddo
      bMedia = 0.
      nMedia = 0
      do jjff=1,nstr
            if (wt(jjff) /= 0.0) then
!            write(lo,'(i5,f6.3,i5)') jjff,wt(jjff),iphaz(jjff)
               nMedia = nMedia + 1
               bMedia = bMedia + wt(jjff)
            end if
      end do
      bMedia = bMedia / nMedia
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
!piero
!      if (nuset == 1) stop
      if (ifMDM == 1 .and. kverbo_pg > 0) then
      write(lo,'(a,i7,f12.5)')' Fasi determinate con <wt> = ',
     *       numb_det,bMedia
      end if
      iprin = 0
      
!
      return
 9000 format(' ncy=',i3,' nnn=',i4,' alpham=',f8.3,' er=',f8.3,
     1       ' w-er=',f8.3,' det.ph=',i4,' max alfa=',f10.3,/)
      end
!-----------------------------------------------------------------------
      subroutine weitan_trip_SB(nuset, nnn, jjcris)
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseStuff
      USE PhaseModule
      USE VLDmod
      USE VLDmod_2
      USE Mappa
c
      dimension ifa(3)
      dimension alp(4000),iphazz(4000),wttLocal(4000)
      dimension ianto(4000)
!psie      
!psie      dimension alp(12000),iphazz(12000),wttLocal(12000)
!psie      dimension ianto(12000)
     
      dimension SC_alfa(300)
      
      dimension isegno(3)
      dimension iphaz_o(1:nstr), iphaz_Sim(1:nstr), iphaz_Tripl(1:nstr)
      dimension contr_Sim(1:nstr), contr_Tripl(1:nstr)

c
      enne_eq = s3s2
      
      WT_save_m(1:nrefl) = wt(1:nrefl)
      
      
      npunti=np(1)*np(2)*np(3)

      percn=0.00
      percp = 0.025

      npts1=npunti*percp ! punti positivi
      npts2 = 0
          
      call denhist(0,xmap,xenve,npts1,npts2)
c
c--inverto la mappa
c
      knw_save = knw
      knw = 0
      if (npts2 == 0) then
         call ChangeAndInvMap_VLD(xmap,xenve,1,0.0,1,1,ier)
      end if 
      knw = knw_save 
      
      work1(1:nrefl) = fcvet(1:nrefl)
      nwizm1=25
      nsip1=150 
      if (ksize_vero < 3) then
         call HistogramMatch(work1,work1,nrefl,nsip1,nwizm1,4) 
      else
          call HistogramMatch(work1,evet,nrefl,nsip1,nwizm1,1) 
      endif
      fcvet(1:nrefl) = work1(1:nrefl)
      Ep(1:nrefl) = work1(1:nrefl)
      PHIp(1:nrefl) = iphaz(1:nrefl)
      
      wt(1:nrefl) =  WT_save_m(1:nrefl)


      iprin = 1
      
      irefin(:) = 0
      
      sogalpham=1.5
c
      soglow   = 0.5
      zer      = 0.1e-10
      alphaVet(:) = 0.
      ianto(:) = 0
      num_det = 0
      swh_det = 0.0
      swh_med = 1.
c===============================================================
      salf=0.
      alpham=10000000.
      kVai = 1
      ncycl = 0
      ifRiscala = 0
      Perc_det = 0.0
!large      
!P      if (ksize_vero >= 4) then
         Rapp_Sim_Trip = 1.0
!P      end if
      Cicli: do while (kVai.eq.1)
         ncycl = ncycl + 1
         alphmax=0.0
         sumalf= salf
         salf  = 0.0
         dalfa = 0.0
         numb1 = 0
         
         Sim_med = 0.0
         Trip_med = 0.0
         wt_med = 0.0
!large      
!P         if (ksize_vero >= 4) then
            n_ncycl1 =  0
!P         end if
         
         n_random = 0
         swh = 0.0
                     
         do ll= 1,nnn
            k=iordeTang(ll)
            
            a01 = 2 * evet(k) * (Dluz(k)/(1. - Dluz(k)**2)) * Ep(k) *
     *                        cos(PHIp(k)* dtor)
            a02 = 2 * evet(k) * (Dluz(k)/(1. - Dluz(k)**2)) * Ep(k) *
     *                        sin(PHIp(k)* dtor)
         
!  calcolo fase e G da contributo SIM         

            if(mkang(k).ne.1) then
              idv = 15*mod(iabs(mkang(k))-1,12)
              t2 = a02*sin(idv*dtor) + a01*cos(idv*dtor)
              a02 = t2*sin(idv*dtor)
              a01 = t2*cos(idv*dtor)
            end if
         
            contr_Sim(k) = sqrt(a01**2 + a02**2)
         
            phaz=rtod*atan2(a02,a01)
            ip=nint(phaz)
            ip=mod(ip+3600,360)
            if(ip.eq.0) ip=360
            iphaz_Sim(k)=ip
                     
            alfmed=0.0
            cang=0.
            sang=0.
                        
            jcris=0
            ist = 4
            kcr = 1
            li=limref(kcr,k)*ist+1 
            ls=limref(kcr,k+1)*ist 
            if (li.le.ls) then
               do jj= li,ls,ist
                   gj = iph(jj+2)*0.01
                   gjabs=abs(gj)
                   gjbes=bes(gj)
                   
                   jcris = jcris + 1
                   isegno(2) = isign(1,iph(jj))
                   ira = iabs(iph(jj))
                   isegno(3) = isign(1,iph(jj+1))
                   ila = iabs(iph(jj+1))
 !psie 
 !psie                   if (ira>nnn .or. ila>nnn) then
 !psie                            cycle
 !psie                   end if
                   
 !psie                   jcris = jcris + 1
                   
                   ifaz = iph(jj+3) * 15

!piero  formula del lavoro                
!                beta1 = 1. /((es(k)-Dluz(k)**2) * (es(ira)-Dluz(ira)**2)
!     *                            * (es(ila)-Dluz(ila)**2))
!                beta2 = enne_eq - enne_peq * Dluz(k) * Dluz(ira) * 
!     *                  Dluz(ila)
!                beta = beta1 * beta2
               
!piero   formula (4) per beta del mail del 3/9/2012
                
!                beta = enne_eq *( 1. - Dluz(k) * Dluz(ira) * Dluz(ila))
                
!piero   formula (3) per beta del mail del 3/9/2012
                
!                beta = enne_eq *( 1. - Dluz(k) * Dluz(ira) * Dluz(ila))
!                beta1 = 8. * (1-Dluz(k))*(1-Dluz(ira))*(1-Dluz(ila))
!                beta = beta / beta1
                
!piero   formula (5) per beta del mail del 1/10/2012
                
                   beta = enne_eq *(1.- Dluz(k) * Dluz(ira) * Dluz(ila))
                beta1 = (1-Dluz(k)**2)*(1-Dluz(ira)**2)*(1-Dluz(ila)**2)
!             beta1 =8.*(1-Dluz(k)**2)*(1-Dluz(ira)**2)*(1-Dluz(ila)**2)
                   beta = beta / beta1
                
!                fact_beta = abs(iph(jj+2) / 100.)
!                beta = beta * fact_beta !* 1.5
                
                   iphi23 = iphaz(ira)*isegno(2) + iphaz(ila)*isegno(3)
                   
                   iphi23 = iphi23 + ifaz
                   
                   cos23 = cos(iphi23 * dtor)
                   sin23 = sin(iphi23 * dtor)
                   
                   iphi23p = iphaz(ira)*isegno(2) + PHIp(ila)*isegno(3)
                   
                   iphi23p = iphi23p + ifaz
                   
                   cos23p = cos(iphi23p * dtor)
                   sin23p = sin(iphi23p * dtor)
                   
                   iphi2p3 = PHIp(ira)*isegno(2) + iphaz(ila)*isegno(3)
                   
                   iphi2p3 = iphi2p3 + ifaz
                   
                   cos2p3 = cos(iphi2p3 * dtor)
                   sin2p3 = sin(iphi2p3 * dtor)
                   
                   iphi2p3p = PHIp(ira)*isegno(2) + PHIp(ila)*isegno(3)
                   
                   iphi2p3p = iphi2p3p  + ifaz
                   
                   cos2p3p = cos(iphi2p3p * dtor)
                   sin2p3p = sin(iphi2p3p * dtor)
                   
                   
!piero  formula  pesata con m fuori
                contcos = evet(ira)*evet(ila)*cos23
     *                   - Dluz(ila)*evet(ira)*Ep(ila)*cos23p
     *                   - Dluz(ira)*Ep(ira)*evet(ila)*cos2p3
     *                   + Dluz(ira)*Dluz(ila)*Ep(ira)*Ep(ila)*cos2p3p
   
                contsin = evet(ira)*evet(ila)*sin23
     *                   - Dluz(ila)*evet(ira)*Ep(ila)*sin23p
     *                   - Dluz(ira)*Ep(ira)*evet(ila)*sin2p3
     *                   + Dluz(ira)*Dluz(ila)*Ep(ira)*Ep(ila)*sin2p3p
                a1q =  beta * wt(ira) * wt(ila) * contcos 
                a2q =  beta * wt(ira) * wt(ila) * contsin

!piero  formula  pesata  con m dentro
!                contcos = wt(ira) * wt(ila) * evet(ira)*evet(ila)*cos23
!     *                   - wt(ira) * Dluz(ila)*evet(ira)*Ep(ila)*cos23p
!     *                   - wt(ila) * Dluz(ira)*Ep(ira)*evet(ila)*cos2p3
!     *                   + Dluz(ira)*Dluz(ila)*Ep(ira)*Ep(ila)*cos2p3p
!                contsin = wt(ira) * wt(ila) * evet(ira)*evet(ila)*sin23
!     *                   - wt(ira) * Dluz(ila)*evet(ira)*Ep(ila)*sin23p
!     *                   - wt(ila) * Dluz(ira)*Ep(ira)*evet(ila)*sin2p3
!     *                   + Dluz(ira)*Dluz(ila)*Ep(ira)*Ep(ila)*sin2p3p
!                   a1q =  beta * contcos 
!                   a2q =  beta * contsin
!piero  formula  non pesata
!                contcos =  evet(ira)*evet(ila)*cos23
!     *                   - Dluz(ila)*evet(ira)*Ep(ila)*cos23p
!     *                   - Dluz(ira)*Ep(ira)*evet(ila)*cos2p3
!     *                   + Dluz(ira)*Dluz(ila)*Ep(ira)*Ep(ila)*cos2p3p
!                contsin =  evet(ira)*evet(ila)*sin23
!     *                   - Dluz(ila)*evet(ira)*Ep(ila)*sin23p
!     *                   - Dluz(ira)*Ep(ira)*evet(ila)*sin2p3
!     *                   + Dluz(ira)*Dluz(ila)*Ep(ira)*Ep(ila)*sin2p3p
!                   a1q =  beta * contcos 
!                   a2q =  beta * contsin
                
!                contcos = evet(ira)*evet(ila)*cos23
!                contsin = evet(ira)*evet(ila)*sin23
!                a1q =  beta * contcos 
!                a2q =  beta * contsin
                 
                   sang = sang + a2q
                   cang = cang + a1q                   
                   alfmed = alfmed  + gjbes * gjabs                   
               enddo   !loop sui tripletti
 !large      
 !P              if (ksize_vero >= 4) then
                  a2 = a02 + 2 * evet(k) * sang  * Rapp_Sim_Trip
                  a1 = a01 + 2 * evet(k) * cang  * Rapp_Sim_Trip
 !P              else
 !P                 a2 = a02 + 2 * evet(k) * sang
!P                  a1 = a01 + 2 * evet(k) * cang
!P              end if
                   
             
               san =  2 * evet(k) * sang ! * Rapp_Sim_Trip
               can =  2 * evet(k) * cang ! * Rapp_Sim_Trip
             
               if(mkang(k).ne.1) then
                 idv = 15*mod(iabs(mkang(k))-1,12)
                 t2 = a2*sin(idv*dtor) + a1*cos(idv*dtor)
                 a2 = t2*sin(idv*dtor)
                 a1 = t2*cos(idv*dtor)
               
                 t2 = san*sin(idv*dtor) + can*cos(idv*dtor)
                 san = t2*sin(idv*dtor)
                 can = t2*cos(idv*dtor)
              
               end if
             
! calcolo fase e G da contributo tripletti

               phaz=rtod*atan2(san,can)
               ip=nint(phaz)
               ip=mod(ip+3600,360)
               if(ip.eq.0) ip=360
               iphaz_Tripl(k)=ip
            
               contr_Tripl(k) = sqrt(san ** 2 + can ** 2)               
            endif
               
            if (jcris == 0) cycle
            
 !large      
 !P           if (ksize_vero >= 4) then
              if(ncycl == 1) then
                 Sim_med = Sim_med + contr_Sim(k)
                 Trip_med = Trip_med + contr_Tripl(k)
                 n_ncycl1 = n_ncycl1  + 1
              end if
!P            end if
            
!
            if (mkang(k) /= 1) then
                idv = 15*mod(iabs(mkang(k))-1,12) + 1
                t2 = a2*sint(idv) + a1*cost(idv)
                a2 = t2*sint(idv)
                a1 = t2*cost(idv)
            endif
            
            if (abs(a1) < zer .and. abs(a2) < zer) cycle
            alfa = a1*a1 + a2*a2
            if (alfa < zer) cycle
            alphaVet(k)=alfa
            phaz=rtod*atan2(a2,a1)
            ip=nint(phaz)
            ip=mod(ip+3600,360)
            if(ip.eq.0) ip=360
            iphaze=ip
            wh=1.
            
            
            if (alphaVet(k).gt.alphmax) alphmax=alphaVet(k)
            irandom = 0
            if (alphavet(k).lt.alpham) then
              if (nuset == 0 . or. ncycl == 1) cycle
               if (irefin(k) /= 0) then 
                  cycle
               else
                 irandom = 1
               end if
            end if
          

!
!-- Applico pesi
!
            
            alfa = sqrt(alphaVet(k))
            
!riscala alfa e alfmed
            if (ifRiscala == 1) then
               alfa = alfa * SC_alfa_np1           
               alfmed = alfmed * SC_alfa_np1           
            end if
            
            if (alfmed > 0.00001) then
                if (alfa.le.alfmed) then
                    if (ipesi.eq.1) then
                        wh = 1.0
                    else
                        wh = bes(alfa)
                    endif
                else
                    if (ipesi.eq.1) then
                        wh = 1.0
                    elseif (ipesi.eq.2) then
                        wh = exp (-(alfa-alfmed)/alfmed)
                    elseif (ipesi.eq.3) then
                        wh = sqrt(exp (-(alfa-alfmed)/alfmed))
                    elseif (ipesi.eq.4) then
                        wh = bes(alfa)
                    elseif (ipesi.eq.5) then
                        wh = (exp (-(alfa-alfmed)/alfmed))**0.333
                    elseif (ipesi.eq.6) then
                        wh = (exp (-(alfa-alfmed)/alfmed))**0.25
                    elseif (ipesi.eq.7) then
                        wh = (exp (-(alfa-alfmed)/alfmed))**0.10
                    endif
                endif
                if (wh < 0.2) wh = 0.2
            endif
!
            if (ksize_vero >= 4) then
               if (nuset /= 0 .and. ncycl > 1)  then
                  if (irandom == 0) then
                     swh_det = swh_det  + wh
                     num_det = num_det + 1
                     swh_med =  swh_det / num_det
                  elseif (irandom == 1) then
                     n_random = n_random + 1
                     wh = 0.6 * swh_med
                     swh = swh + wh
                  end if
               end if
            else
               if (irandom == 1) then
                  n_random = n_random + 1
                  wh = wh / 2.
                  swh = swh + wh
               end if
            end if           
            
            wt(k)=wh
            
            iphaz(k)=iphaze
            
            
            
            if (irandom == 0) then
              Sim_med = Sim_med + contr_Sim(k)
              Trip_med = Trip_med + contr_Tripl(k)
              wt_med = wt_med + wt(k)             
              ianto(k)=1
              numb1=numb1+1
 !             if (ncycl == 4 .or. ncycl==5) then
 !                write(lo,'(i5,3f10.4)')k,wt(k),alfa,alfmed
 !             end if
              salf=salf+alphaVet(k)
          
! se ÃƒÂ¨ una fase random irefin = 1
              if (nuset /= 0 ) then
                if (irefin(k) ==0) then
                  irefin(k) = 1
                end if
              end if
            end if
         
      enddo  ! loop sui riflessi
      
 !large      
 !P     if (ksize_vero >= 4) then
         if (ncycl == 1) then
            Sim_med = Sim_med / n_ncycl1
            Trip_med = Trip_med / n_ncycl1
 !P           Rapp_Sim_Trip_1 = Sim_med / Trip_med 
            Rapp_Sim_Trip = 2 * Sim_med / Trip_med 
            if (Rapp_Sim_Trip > 1.0 )then
                Rapp_Sim_Trip = 1.0
            end if
            
            write(lo,'(/,a,i3,2x,a,f7.3,a,f9.3,a,f9.3)')
     *                  'ciclo =',ncycl,
     *                  ' <Sim> =', Sim_med,
     *                  ' <Tripletti> =',Trip_med,
!P     *                  ' Rapp_Sim_Trip =', Rapp_Sim_Trip_1
     *                  ' Rapp_Sim_Trip =', Rapp_Sim_Trip
         end if
!P      else
         if (ncycl > 1) then
            if (numb1 > 0) then
               Sim_med = Sim_med / numb1
               Trip_med = Trip_med / numb1
               wt_med =wt_med / numb1
               Rapp_Sim_Trip = 2 * Sim_med / Trip_med
               if (Rapp_Sim_Trip > 1.0 )then
                   Rapp_Sim_Trip = 1.0
               end if
            else
               Sim_med = 0.0
               Trip_med = 0.0
               wt_med = 0.0
               Rapp_Sim_Trip = 1.0
            end if
           
            write(lo,'(/,a,i3,2x,a,f7.3,a,f9.3,a,f9.3,a,f9.3)')
     *                  'ciclo =',ncycl,
     *                  ' <Sim> =', Sim_med,
     *                  ' <Tripletti> =',Trip_med,
     *                  ' <WT> =', wt_med,
     *                  ' Rapp_Sim_Trip =', Rapp_Sim_Trip
         end if
!P      end if
               
         if (n_random > 0) then
          swh = swh/n_random
!          write (lo,'(a,i5,f10.6)')'media dei pesi delle fasi random',
!     *                              n_random,swh
         end if 
!
!
         if (ncycl == 1) ndetref = 0 
!--------------------------------------------------------------------
!calcolo della scala per gli alfaVet per ottenere <wt> = 0.6
       if (ncycl > 1 .and. nuset > 0) then
         nDetRef = 0
         Sum_alfa = 0.0
         alfa_rif = besinv(0.6)
         do i=1, nnn
            if (irefin(i) == 1) then
               nDetRef = nDetRef + 1
               Sum_alfa = sum_alfa + sqrt(alphaVet(i))
            end if
         end do
         Rmedia_alfa = Sum_alfa / nDetRef
         SC_alfa(ncycl) = alfa_rif / Rmedia_alfa
         Perc_Det = float(nDetRef) / nnn
         if (Perc_Det < 0.2) then
            ifRiscala = 0
            SC_alfa_np1 = 0.0
         else
            if (Perc_Det <0.65) then
               SC_alfa_np1 = 1.25 * SC_alfa(ncycl)
            elseif (Perc_Det <0.8) then
               SC_alfa_np1 = 1.15 * SC_alfa(ncycl)
            else
               SC_alfa_np1 = 1.10 * SC_alfa(ncycl)
            end if
         end if
         
         WtWt = 0.0
         do i=1, nnn
            if (irefin(i) == 1) then
              WtWt = WtWt + bes(sqrt(alphaVet(i)) * SC_alfa(ncycl))
!                WtWt = WtWt + wt(i)
            end if
         end do
         WtWt = WtWt / nDetRef
      
      write(lo,'(a,i5,4f10.5)')' ciclo,%,Sc_alfa, <Wt>, Sc_alfanp1',
     *         ncycl,Perc_Det,SC_alfa(ncycl),WtWt,SC_alfa_np1
      end if
      
 !large      
      if (ksize_vero >= 4) then
         if (ncycl > 1 .and. Perc_Det > 0.2 ) then
            Sim_med = Sim_med / numb1
            Trip_med = Trip_med / numb1
            wt_med =wt_med / numb1
            Rapp_Sim_Trip = 2. * Sim_med / Trip_med 
            if (Rapp_Sim_Trip > 1.0 )then
                Rapp_Sim_Trip = 1.0
            end if
            write(lo,'(a,i3,2x,a,f7.3,a,f9.3,a,f9.3,a,f9.3)')
     *                  'ciclo =',ncycl,
     *                  ' <Sim> =', Sim_med,
     *                  ' <Tripletti> =',Trip_med,
     *                  ' <WT> =', wt_med,
     *                  ' Rapp_Sim_Trip =', Rapp_Sim_Trip
         end if
      end if
       
!--------------------------------------------------------------------
!
!-- calcolo della soglia sull'alpha per innescare la tangente
!
         if (ncycl == 1) then
!
             do ib=1,nstr
                alp(ib) = alphaVet(ib)
             end do
             call sortall (-1,alp,nstr)
!
!large        
             nult = 30
             
!pg20032014             
             if (ksize_vero < 4) then
               nult = 0.50 * nnn
             end if
             
             if (nult.gt.nnn) then
                 nult = nnn / 2
             endif
             alpham = alp(nult)
!
             if (alpham.lt.0.01) then
                 kult = 0
                 do i=nult,1,-1
                    if (alp(i).gt.0.01.and.kult.eq.0) then
                        kult = i
                        alpham = alp(kult)
                    endif
                 enddo
             endif
!
             if (alpham < soglow) then
                soglow = alphmax * 0.3
!                write(lo,*) 'alphmax, soglow =',alphmax,soglow
            endif
         endif
c--
         if (knw == 1 .and. ifExamin /=0 .and. iprin > 0) then
             if (ncycl.ne.1) then
                 do i=1,nstr
                    wttLocal(i)=wt(i)*ianto(i)
                    iphazz(i)=iphaz(i)*ianto(i)
                 enddo
                 erore = 0
                 erorepes = 0
                 izero = 0
                 ifmin = 1
                 call examin(nuset,mkang,khl,ipub,iphazz,nstr,izero,
     *                       wttLocal,ifmin)
             else
                 erore = 0
                 erorepes = 0
             endif
             soglia=sqrt(alpham) 
             soglix=sqrt(alphmax)
             write(lo,9000) ncycl,nnn,soglia,erore,
     *                     erorepes,numb1,soglix
         endif
         
         if (Perc_Det >= 0.2) then
            ifRiscala = 1
         end if
c
         kVai = 0
         
!         if (ncycl == 1) then         
            percent1 = 0.50
!         end if
         
!         if (ncycl >= 2) then
!            percent1 = 0.50 + (jjcris-1)*0.1
!            percent1 = min(percent1,1.0)
!         end if
         percent2 = 0.90
!cris2         if (numb1.lt.(percent1*nnn)) then
         if (nDetRef.lt.(percent1*nnn)) then
 !large      
 !P            if (ksize_vero >= 4) then
                cut= percent2 * alpham * Rapp_Sim_Trip
 !P            else
 !P                cut= percent2 * alpham
 !P           end if
             alpham=amax1(cut,0.05)
             if (alpham.gt.soglow) kVai = 1
             if (alpham.gt.sogalpham) kVai = 1
             if (ncycl.gt.300) kVai = 0    !!!!  Evita il loop se non fasa niente
!      write (lo,'(a,i6,3f12.6)')' CICLO =',ncycl,alpham,soglow,sogalpham
         else
            exit
         end if
         
c-- se non sono stati fasati riflessi durante l'autoconsistenza
         if (kVai.eq.0) then 
             if (salf.le.0.0001) then
                 exit
             endif
             if ((salf-sumalf)/salf.gt.0.02) kVai = 1
         endif
      end do Cicli
c   fine loop per raffinamento tangente
      numb_det = 0
      do i=1,nstr
         if(ianto(i) == 1) numb_det = numb_det + 1
         wt(i)=wt(i)*ianto(i)
         iphaz(i)=iphaz(i)*ianto(i)
      enddo
      bMedia = 0.
      nMedia = 0
      do jjff=1,nstr
            if (wt(jjff) /= 0.0) then
!            write(lo,'(i5,f6.3,i5)') jjff,wt(jjff),iphaz(jjff)
               nMedia = nMedia + 1
               bMedia = bMedia + wt(jjff)
            end if
      end do
      bMedia = bMedia / nMedia
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      if (ifMDM == 1 .and. kverbo_pg > 0) then
      write(lo,'(a,i7,f12.5)')' Fasi determinate con <wt> = ',
     *       numb_det,bMedia
      end if
      iprin = 0
      
!
      return
 9000 format(' ncy=',i3,' nnn=',i4,' alpham=',f8.3,' er=',f8.3,
     1       ' w-er=',f8.3,' det.ph=',i4,' max alfa=',f10.3,/)
      end

!-------------------------------------------------------------------------
      subroutine InitPhase(ifTest, ier)
      USE General
      USE Symmetry
      USE Riflessi
      USE Molcom
      USE PhaseStuff
      USE HistoStuff
      USE Param
      USE PhaseModule
      USE VLDmod, only: kverbo_pg
      USE Direttive
!
      common /ConvComm/ NSigPos, SogPos, NSigNeg, NQuaNeg, inizNeg,
     *                  NPsiZero, numbReflTrip, SogNeg, SogQuaNeg
!psie
!psie      common /ConvComm/ NSigPos, SogPos, NSigNeg, NQuaNeg, inizNeg,
!psie     *                   NPsie,NPsiZero, numbReflTrip, SogNeg, SogQuaNeg
!
      if (ifVLD == 0) then
          call AllocaTestStuff(1)
      endif
!
!-- compute triplets if necessary
!

      if (knw == 1) then
         call AllocaTestStuff(1)
      endif
      if (ifTang == 1 .or. ifMDM == 1) then
      
         if (InfoOK(8) == 0) then
             ipunt = 0
             call AllocaInvarStuff(2)
             ksubr = 2
             ifFromGraphic = 0
             icomq(icomat,2) = 0
c         if (ksize <= 3 .and. ifPatt == 0 .and. knw == 1) then
             if (ifPatt == 0) then
                 ifFromPhase = 1
             else
                 ifFromPhase = 1
             endif
             kverboSav = kverbo
             iprinSav = iprin
             ifNewPsi0Sav = ifNewPsi0
             call invar(ier, ksubr, ifFromGraphic, ifFromPhase)
             ifNewPsi0 = ifNewPsi0Sav
             iprin = iprinSav
             kverbo = kverboSav
             if (ier < 0) return
             if (kmad /= 2) then
              if (numbGen == 0) then
                     ksubr = 3
                 else
c                 ksubr = 6
                     ksubr = 33
                 endif
                 call LeggiRiflessi(ier,ksubr)

!pgMAD150206
                 if (kmad == 1) then
                    s3s2 = s3s2mad
                 end if
!pgMAD150206
                 call AllocaInvarStuff(1)
             endif
         endif
!
         ksubr = 3
!  ripeto conver se devo eliminare le relazioni per riflessi poco attendibili
         ncountConver = 0
         iniz = 1
         if (ifSelAlfa == 0) then
             ifin = 1    
         else
             ifin = 2
         endif
         do ncv = iniz, ifin
            ncountConver = ncv
            call conver()
            if (ier < 0) return
         enddo

      endif ! ifTang
!
      if (jproc.eq.0) then
          iyrand = 67543
      endif
!
*     if (kmad == 0) then ! dedi
      if (kmad == 0 .and. neutro == 0) then ! gianluca 5/10/2009
          call AllocaHistoStuff(1)
          vetmatchin(1:nrefl) = evet(1:nrefl)
          kk = 0
          call InitHistMatchObs(kk)
          if (numbGen > 0) then
              kk = -1
              call InitHistMatchTheo(kk)
          endif

c- Inserisco calcolo mappa vera in memoria per sub. Calcola_CC_Mappa_completa
         if (knw == 1) then
             call MakeMapsForCorr(ifBreak, ier)
         endif
c- Inserisco calcolo mappa vera in memoria per sub. Calcola_CC_Mappa_completa

corig     if (ifTang == 1) then
!!!       if (ifMDM == 1 .or. (ifTang == 1 .and. ksize < 4)) then
          if (ifMDM == 1) then
              if (ifOldFoms == 0) call InitFinalFom()
          else
              kve = kverbo_pg
              kverbo_pg = 1
              call InitFinalFom_New()
              kverbo_pg = kve
          endif

          if (numbGen>0) then
             rmax = maxval(rhov(1:nrefl+Added))
          else
             rmax = rhomax
          endif
          if (ksize > 3) then
              rmax = 0.5 / sqrt(rmax)
              numresVal = numres(rmax)
          endif
      endif
!
      return
      end
!----------------------------------------------------------------------
      subroutine InitSigmaA(iAction)
      USE General
      USE Riflessi
      USE ShellSIGMAA
      USE RemoModule 
      USE riflessi_c
      USE PhaseModule
      USE RuotaRiflessi

      real,     allocatable   :: RES(:), shellTAB(:,:)
!
      if (numbGen == 0) then
          numbRefl = nreflDim
          if (kmad == 2) numbRefl=nrefl
      else
          numbRefl = nrefl
      endif
canna
c     if(use_E) numbRefl=nreflSelTra
      if(use_E) numbRefl=nreflSelRemo
canna       
      if (iAction == 1) then
          Nbin  = 30
          Nstat = floor( numbRefl / float(Nbin) )
          Nbin  = 8.0*alog10( 0.05*float( max0(numbRefl, 100) ) + 0.5 )
          allocate (RES(numbRefl), RES_TAG(numbRefl), stat=ierr)
          allocate (shellTAB(Nbin,2), midpts(Nbin), stat=ierr)
          if (.not.allocated(Eo2Ec2Mean)) then
              allocate (Eo2Ec2Mean(Nbin), stat=ierr)
          endif
canna          
          if (.not.use_E)then
              RES(1:numbRefl) = sqrt(rhov(1:numbRefl))
          else  
             do i=1,numbRefl
                k=k_mem1(i)
                RES(i)=sqrt(rhov(k))
             enddo
          endif
canna
          shellTAB(:,:) = 0.0
          midpts(:)     = 0.0
          RES_TAG(:)    = 0
          shellTAB(:,:) = 0.0
          midpts(:)     = 0.0
          RES_TAG(:)    = 0
!
          call shells(shellTAB, midpts, RES_TAG, RES, numbRefl, Nbin, 1)
!
          deallocate (RES, shellTAB, stat=ierr)
!
      else
!
          if (allocated(RES_TAG)) then
              deallocate (RES_TAG, midpts, stat=ierr)
          endif
!
      endif
!
      return
      end
!----------------------------------------------------------------------
      subroutine ScritControl()
      USE General
      USE PhaseStuff
      USE PhaseModule
c
      ist = 3
      jpqq = 0
      do kcr=1,2
         ist = ist + 1
         do 300 i=1,nstr
            lm=limref(kcr,i)*ist+1 + jpqq
            ls=limref(kcr,i+1)*ist + jpqq
            if(lm.gt.ls) goto 300
            do 220 ii=lm,ls,ist
               if (i.le.2) then
                  nn(1) = iph(ii)
                  nn(2) = iph(ii+1)
                  if (ist .eq. 4) then
                     nn(3) = 0
                     a1 = 0.01 * iph(ii+2)
                     ifaz = iph(ii+3)
                  write(lo,215) i,(nn(kj),kj=1,2),a1,ifaz
  215             format(3x,' code =',i5,3x,2i5,e15.8,i5)
                  else
                     nn(3) = iph(ii+2)
                     a1 = 0.01 * iph(ii+3)
                     ifaz = iph(ii+4)
                 write(lo,213) i,(nn(kj),kj=1,3),a1,ifaz
  213            format(3x,' code =',i5,3x,3i5,e15.8,i5)
                  end if
               endif
  220       continue
  300    continue
         jpqq = jpq
      end do
      return
      end
c----------------------------------------------------------------------
      subroutine CorrectBassoTeta_Ph()
      USE General
      USE Riflessi
      USE PhaseModule
c
      dimension tetp(30,3)
c
      write(lo,*) ' CorrectBassoTeta_Ph'
      if (kverbo.gt.0)  write(lo,*) ' ' 
      call StatLow_Ph(tetp,iren,ier)
      if (ier.lt.0) then
          return
      endif
c

c
      resol = ResSog_Ph
      rhosog = (0.5 / resol) **2
      nfin = numbLSQ
      nnref = 0
      mmref = 0
      deltamin = 99999.9
c
      do 100 ii = 1,4
         gco = 0.5 + ii*0.1
         do 200 j = 1,4
            BB = 50. + j*100.           
            sume2 = 0.0
            ave2 = 0.0
            do 300 i=1,nfin
               rho = rhov(i)
               if(rho.le.rhosog) then
                  if(ii.eq.1.and.j.eq.1) then
                     nnref = nnref +1
                     mmref = mmref + mult(i)
                  endif
                  tmult = float(mult(i)) 
                  e = evet(i)
                  e2Val = e * e
                  denom =  1-(gco*exp(-BB*rhov(i)))
                  e2Val = (e / denom)**2
                  sume2 = sume2 + e2Val * tmult
               endif
 300        continue
            ave2 = sume2/mmref 
            delta = (ave2 - 1)**2
            if(delta.lt.deltamin) then
               deltamin = delta
               gcomin = gco
               BBmin  = BB
            endif
 200     continue
 100  continue
 120  format ('gco =',f5.1,' BB =',f7.1,' delta =',f12.4)
 150  format ('scala =',f5.1,' Bsolv =',f7.1,' delta =',f12.4)
      do 400 i=1,nfin
         rho = rhov(i)
         if(rho.le.rhosog) then
            e = evet(i)
            denom =  1-(gcomin*exp(-BBmin*rhov(i)))
            evet(i) = e / denom
         endif
 400  continue

      if (kverbo.gt.0)  write(lo,*) ' ' 
      call StatLow_Ph(tetp,iren,ier)
      if (iren.eq.1) then
          call RenLow_Ph(tetp)
          if (kverbo.gt.0)  write(lo,*) ' ' 
          call StatLow_Ph(tetp,iren,ier)
      endif
c
c
      return
      end
c-------------------------------------------------------------------
      subroutine FindSeed(itr)
      USE General
      USE PhaseModule

      iyrand=67543
      ix=iyrand
      do 10 ntri=1,itr-1
         do 20 i=1,nstartTang
            call SirRandom(ix,iyrand,yfl)
            ix=iyrand
 20      continue
 10   continue
      call UpdateReflInfo
c
      return
      end
c-----------------------------------------------------------------
      subroutine StatLow_Ph(tetp,iren,ier)
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
!
c
      dimension sw2(30),sr(30),nsum(30),avrr(30),avw2(30)
      dimension tetp(30,3)
c
      ier = 0
      iren = 0
      rhosog = (0.5 / ResSog_Ph) **2
      rhoshmin =  0.0000001
      nfin = numbLSQ
      nnref = 0
      mmref = 0
      do i=1,nfin
         if (rhov(i).ge.rhoshmin.and.rhov(i).le.rhosog) then
             nnref = nnref + 1
             mmref = mmref + mult(i)
         endif
      enddo
c
      if (nnref.eq.0) then
          ier = -1
          return
      endif
      nbWils = 9
      add=rhosog/float(nbWils)
      rr=float(nbWils)/rhosog
c
      start=-add
      end=add
      number=0
      do 50 i=1,30
         sw2(i)=0.0
         sr(i)=0.0
         nsum(i)=0
         avrr(i)=0.0
         avw2(i)=0.0
   50 continue
c
      do 200 i=1,nfin
         rho=rhov(i)
         if(rho.gt.rhosog) go to  200
         ew=evet(i)
c-- n stores range of rho
         n=min0(int(1.0+rr*rho),nbWils)
         mmult=mult(i)
         tmul=float(mmult)
!        write(lo,22) i,(khl(ii,i),ii=1,3),mmult,ew,rho
c-- weighted sums
c-- number of reflexions
         nsum(n)=nsum(n)+mmult
c-- E**2
         ew2 = ew**2
         sw2(n)=sw2(n)+ew2*tmul
c-- rho
         sr(n)=sr(n)+rho*tmul
  200 continue
      do 300 i=1,nbWils
c-- smooth curve by adding adjacent ranges
         number=number+nsum(i)
         nsum(i)=nsum(i)+nsum(i+1)
         sw2(i)=sw2(i)+sw2(i+1)
         sr(i)=sr(i)+sr(i+1)
c-- calculate weighted averages and total summations
         peso=float(nsum(i))
         if(nsum(i).gt.0)  then
            div=1.0/amax1(1.0,peso)
            avrr(i)=sr(i)*div
            avw2(i)=(sw2(i)*div)
            avri  = 1.0 / ( 2.0*sqrt(avrr(i))) 
          else
            avrr(i)= 0.0
            avw2(i)= 0.0
            avri  = 0.0
         endif
         start=start+add
         end=end+add
         end=amin1(end,rhosog)
         if (start.gt.0.0001) then
             startp = 1.0 / ( 2.0*sqrt(start)) 
         else
             startp = 999
         endif
         endp  = 1.0 / ( 2.0*sqrt(end)  ) 
         tetp(i,1) = startp
         tetp(i,2) = endp
         tetp(i,3) = avw2(i)
         if (kverbo.gt.0) then
             write(lo,280) i,startp,endp,nsum(i),avri,avw2(i)
         endif
         if (tetp(i,3).gt.1.5) iren = 1
  300 continue
  280 format(1x,i3,f15.4,'  -',f8.4,i11,2f14.4)
 
      return
      end
c---------------------------------------------------------------
      subroutine RenLow_Ph(tetp)
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
c
      dimension tetp(30,3)
c
!?!   nEmod = 0
      nfin = numbLSQ
      rhosog = (0.5 / ResSog_Ph) **2
      do i=1,nfin
         rho = rhov(i)
         rhop = 1.0 / ( 2.0*sqrt(rho))
         if (rho.lt.rhosog) then
             e = evet(i)
             e2Val = e * e
             do j=nbWils,1,-1
                if (tetp(j,1).gt.rhop.and.rhop.ge.tetp(j,2)) then
                    ii = j
                endif
             enddo
             ren = 1.0
             if(tetp(ii,3).gt.1.5) ren = 1.5 / tetp(ii,3)
             e2Val = e2Val * ren
             evet(i) = sqrt(e2Val)
!?!          if (nEmod.lt.4000) then
!?!              nEmod = nEmod + 1
!?!              BackEmod(nEmod,1) = i
!?!              BackEmod(nEmod,2) = evet(i)
!?!          endif
!        write(lo,55) i,rhop,tetp(ii,1),tetp(ii,2),tetp(ii,3),ren,
!    *               e*e, e2Val, e, evet(i)
         endif
      enddo
 55   format(1x,i9,')',f10.4,f12.4,'  -',f8.4,6f10.4)
c
      return
      end
c------------------------------------------------------------------
      subroutine Barra()
      USE General
      USE Dialogo, only: ifMadEnv
      USE PhaseModule
      USE VLDmod, only : n_Maxrun
!
      character line*80, cara*20, cara2*20, Patt_or_Tang*12
      character cIterazione*5
      common /BarraLocale/ line, cara, cara2, Patt_or_Tang, cIterazione 
!
      if (nTotTrials.gt.1) then
          write(cara,10) numbrun,MaxRun 
      else
          write(cara,12) numbrun
      endif
 10   format (i6,'/',i6)
 12   format (i6)
      if (ifRemo == 0) then
          if (ifPatt /= 0) then
              Patt_or_Tang = 'Patterson -'
          else
              if (ifMDM == 0) then
                  Patt_or_Tang = 'SDM -      '
              else
                  Patt_or_Tang = 'MDM -      '
              endif
          endif
      else
          Patt_or_Tang = 'Remo -  '
      endif
      k = Lung(Patt_or_Tang)
      call NoBlanks(cara,icara)
      if (ifMadEnv == 0) then
          cara2 = ' '
          ncara2 = 1
      else
          if (ifMDM == 0) then
              write(cara2,50) ntrSv, nSetStored
              call NoBlanks(cara2,ncara2)
          else
              cara2 = ' '
              ncara2 = 1
          endif
      endif


      goto 1122

      if (ifReduced == 0) then
          if (Iterazione < 1) then
              if (ifVLD == 0) then
                  write(line,20) Patt_or_Tang(1:k), cara(1:icara),
     *                           cara2(1:ncara2)
              else
                  write(cara,'(i4,"/",i4)') numbrun, n_Maxrun
                  call NoBlanks(cara, icara)
                  if (ifMDM == 0) then
                      write(line,25) cara(1:icara)
                  else
                      write(line,26) cara(1:icara)
                  endif
              endif
          else
              write(cIterazione,"(i2,'/',i2)") Iterazione, nIteraTot
              call NoBlanks(cIterazione,ncara3)
              if (ksize > 3) then
                  write(line,30) Patt_or_Tang(1:k), cara(1:icara), 
     *                           cara2(1:ncara2), cIterazione(1:ncara3)
              else
                  write(line,32) Patt_or_Tang(1:k), cara(1:icara), 
     *                           cara2(1:ncara2)
              endif
          endif
      else
          if (ifVLD == 0 .or. ifMDM == 1) then
              write(line,40) Patt_or_Tang(1:k), cara(1:icara),
     *                       cara2(1:ncara2)
          else
              write(cara,'(i4,"/",i4)') numbrun, n_Maxrun
              call NoBlanks(cara, icara)
              write(line,45) cara(1:icara)
          endif
      endif
   20 format (a,' trial ',a,' ',a,': Direct Space Refinement')
!  25 format (' VLD trial ',a,': Direct Space Refinement')
!  26 format (' MDM trial ',a,': Direct Space Refinement')
!  30 format (a,' trial ',a,' ',a,
!    *          ': Direct Space Refinement  -  Iteration # ',a)
!  32 format (a,' trial ',a,' ',a,
!    *          ': Direct Space Refinement')
!  40 format (a,' trial ',a,' ',a,
!    *          ' RELAX : Direct Space Refinement in P 1')
!  45 format ('VLD trial ',a,' ',
!    *          ' RELAX : Direct Space Refinement in P 1')
!  50 format('(',i5,'/',i5,')')


 1122  continue


      if (ifReduced == 0) then
          if (Iterazione < 1) then
              write(cara,'(i4,"/",i4)') numbrun, n_Maxrun
              call NoBlanks(cara, icara)
              if (ifMDM == 0) then
                  if (ifPhantom == 0) then
                      if (ifPatt == 0) then
                          write(line,25) cara(1:icara)
                      else
                          write(cara,'(i4,"/",i4)') numbrun, Maxrun
                          call NoBlanks(cara, icara)
                          write(line,27) cara(1:icara)
                      endif
                  else
                      write(line,28)
                  endif
              else
                  write(line,26) cara(1:icara)
              endif
          else
              write(cIterazione,"(i2,'/',i2)") Iterazione, nIteraTot
              call NoBlanks(cIterazione,ncara3)
              if (nIterazioni > 1) then
                  if (ifTang == 1) then
                      write(line,30) Patt_or_Tang(1:k), cara(1:icara), 
     *                 cara2(1:ncara2), cIterazione(1:ncara3)
                  else
                      write(line,31) Patt_or_Tang(1:k), cara(1:icara), 
     *                                       cIterazione(1:ncara3)
                  endif
              else
                  if (ifTang == 1) then
                      write(line,32) Patt_or_Tang(1:k), cara(1:icara), 
     *                           cara2(1:ncara2)
                  else
                      write(line,33) Patt_or_Tang(1:k), cara(1:icara) 
                  endif
              endif
          endif
      else
          if (ifVLD == 0 .or. ifMDM == 1) then
!             write(line,40) Patt_or_Tang(1:k), cara(1:icara),
!    *                       cara2(1:ncara2)
              write(line,41) Patt_or_Tang(1:k), cara(1:icara)
          else
              write(cara,'(i4,"/",i4)') numbrun, n_Maxrun
              call NoBlanks(cara, icara)
              write(line,45) cara(1:icara)
          endif
      endif
   25 format (' VLD trial ',a,': Direct Space Refinement')
   26 format (' MDM trial ',a,': Direct Space Refinement')
   27 format (' Patterson trial ',a,': Direct Space Refinement')
   28 format (' Phantom Derivative : Direct Space Refinement')
   30 format (a,' trial ',a,' ',a,
     *          ': Direct Space Refinement  -  Iteration # ',a)
   31 format (a,' trial ',a,
     *          ': Direct Space Refinement  -  Iteration # ',a)
   32 format (a,' trial ',a,' ',a,
     *          ': Direct Space Refinement')
   33 format (a,' trial ',a,
     *          ': Direct Space Refinement')
   40 format (a,' trial ',a,' ',a,
     *          ' RELAX : Direct Space Refinement in P 1')
   41 format (a,' trial ',a,
     *          ' RELAX : Direct Space Refinement in P 1')
   45 format ('VLD trial ',a,' ',
     *          ' RELAX : Direct Space Refinement in P 1')
   50 format('(',i5,'/',i5,')')





      if (nbarra.gt.0) then
          call scrper(line,0,0)
          npercB = nbarra
          perc0B = float(nbarra)/float(npercB)
          percB = perc0B
          jpercB = 0
          iipercB = 0
          nbarra = -nbarra
      endif
      iipercB = iipercB + 1
      if (iipercB.eq.nint(percB)) then
          jpercB = jpercB + 1
          percB = percB + perc0B
          call scrper(' ',jpercB,npercB)
!         write(6,*)'BARRA ',iipercB,jpercB,percB,nbarra,npercB
!         write(0,*)'BARRA ',iipercB,jpercB,percB,nbarra,npercB
      endif
c
      return
      end 
c--------------------------------------------------------------------------
      subroutine RiscalAlfa(numb,nperc,WtRef)
      USE General
      USE Riflessi
      USE PhaseModule
c
      character tirang * 11
      dimension workalfa(4000)
!psie      dimension workalfa(12000)
c
!     izero = 0
!     ifmin = 1
!     nuset = 6555
!     call examin(nuset,mkang,khl,ipub,iphaz,numb,izero,wt,ifmin)
!     tirang = 'TANG.'
!     ipher = 1
!     call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
!    *                  ipub,iphaz,wt,10,0.0,ipher)
!
      nalphaGT0 = 0
      WtMin = 999999
      do i = 1,numb
         if (alphaVet(i).gt.0.00001) then
             workalfa(i) = sqrt(alphaVet(i)) 
             if (wt(i).lt.WtMin) then
                 WtMin = wt(i)
             endif
             nalphaGT0 = nalphaGT0 + 1
         else
             workalfa(i) = 0.0
         endif
      enddo
      if (nalphaGT0.le.nstr/20) then
          return
      endif
      if (Wtmin.gt.WtRef) then
*         WtRef = WtMin
      endif
      alpfa = besinv(WtRef)
c
!     write(lo,*) testo
!     write(lo,*) 'NPERC , NUMB = ',nperc,numb
c
      amedalp = 0.0
      kalp = 0
      call sortall (1,workalfa,numb)
      do i = 1,numb 
         if (workalfa(i).gt.0.00001) then
             kalp = kalp + 1
             if (kalp.le.nperc) then
                 amedalp = amedalp + workalfa(i)
             else
                 exit
             endif
         endif
      enddo
      amedalp = amedalp / float(nperc)
c
      scalalp = alpfa / amedalp
!     write(lo,100) nperc, alpfa, amedalp, scalalp
!100  format(' n.rif. ',i5,' soglia ',f7.4,' <alfa> ultimo intervallo ',
!    * f7.4,' scala ',f7.4)
c
      do i = 1,numb
         if (alphaVet(i).gt.0.00001) then
             workalfa(i) = sqrt(alphaVet(i)) 
             workalfa(i) = workalfa(i) * scalalp
             ttww = wt(i)
             wt(i) = bes(workalfa(i))
         else
             workalfa(i) = 0.0
             ttww = wt(i)
             wt(i) = 0.0
         endif
!            write(lo,'(i6,1h),4f10.4)') i,sqrt(alphaVet(i)),
!    *                              workalfa(i),ttww,wt(i)
      enddo
!     izero = 0
!     ifmin = 1
!     nuset = 7555
!     call examin(nuset,mkang,khl,ipub,iphaz,numb,izero,wt,ifmin)
!     tirang = 'RISCAL.'
!     ipher = 1
!     call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
!    *                  ipub,iphaz,wt,10,0.0,ipher)
c
      return
      end      
c----------------------------------------------------------------------
      subroutine OrdinaStampaTrial(iAction,ifSort)
      USE General
      USE PhaseModule
      USE RfacMatrixModule
!
!-- iAction = 0 sort and print foms information
!-- iAction = 1 sort, print and store foms information
!-- ifSort  = 1/0 sort/no_sort
!
      character*9 StringaErre, StringaFom
      real, allocatable :: store(:)
!
      nToSort = 0
      j = 0
      if (iAction == 0) then
         kini = jBlock
         kfin = jBlock
      else
         kini = 1
         kfin = nBlocksPh
      end if



         kini = jBlock
         kfin = jBlock

      n = nRfacMatrix * 9
      allocate(store(n), stat=ier)

      do k=kini, kfin
         do i=1, nRfacMatrix
            if (RfacMatrix(1,i,k) > 0.0) then
                store(j+1) = RfacMatrix(1,i,k)
                store(j+2) = RfacMatrix(2,i,k)
                store(j+3) = RfacMatrix(3,i,k)
                store(j+4) = RfacMatrix(4,i,k)
                store(j+5) = RfacMatrix(5,i,k)
                store(j+6) = RfacMatrix(6,i,k)
                store(j+7) = RfacMatrix(7,i,k)
                store(j+8) = RfacMatrix(8,i,k)
                if (kmad > 0 .and. WhichFom == 3) then
                    rfa = RfacMatrix(4,i,jBlock)
                    store(j+9) = rfa / RfacMatrix(3,i,jBlock)
                else
                    store(j+9) = RfacMatrix(WhichFom,i,jBlock)
                endif
*        write(6,'(8f8.3)') (rfacmatrix(jj,i,jBlock),jj=1,8)
                j = j + 9
                nToSort = nToSort + 1
            endif
         enddo
      enddo
      if (nToSort == 0) then
          return
      endif

      nToSave = min0(jBlocksPh(2,jBlock), nToSort)    ! patterson MAD pg230407
      if (kmad == 1 .and. iAction == 1) goto 200      ! patterson MAD pg230407

      lind = 1
      nr2  = nToSort
      iblk = 9
      if (kmad == 0) then
          jump = -9
      else
          jump = -9        !cricri
      endif
      if (ifSort == 1) then
*         call sortz(lind,nr2,iblk,jump)
          call sortz_dyn(store, n, lind, nr2, iblk, jump)
      endif
c
      if (kmad == 0 .or. ifPatt == 1) then   !090205
          if (ifExamin.ne.0) then
              write(lo,10) 
          else
              if (knw == 1) write(lo,20)
          endif
          else
             if (ifExamin.ne.0) then
                 if (kmad == 0) then
                     write(lo,110)
                 else
                     write(lo,111)
                 endif
             else
                 if (knw == 1) then
                     if (kmad == 0) then
                         write(lo,120)
                     else
                         write(lo,121)
                     endif
                 endif
             endif
      end if
   10 format(/,7x,'Trial   eFom      Fom    R%       Correl.',
     *            '      Mean Phase Errors',/)
   20 format(/,7x,'Trial   eFom      Fom    R%   ',/)
  110 format(/,7x,'Trial   cFom      Fom    R%       Correl.',
     *            '      Mean Phase Errors',/)
  111 format(/,7x,'Trial   cFom     Fom    R%/Fom    Correl.',
     *            '      Mean Phase Errors',/)
  120 format(/,7x,'Trial   cFom      Fom    R%   ',/)
  121 format(/,7x,'Trial   cFom      Fom   R%/Fom',/)
c
      nToSave = min0(jBlocksPh(2,jBlock), nToSort)
      j = 0
      if (iAction == 0) then
         k = jBlock
      else
         k = 1
      end if
      RfacMatrix(:,:,k) = 0.0
      RfacMatrix(2,:,k) = -9999.9      !!!<<<
      RfacMatrix(3,:,k) = -9999.9      !!!<<<
      do i=1,nToSave
         RfacMatrix(1,i,k) = store(j+1)
         RfacMatrix(2,i,k) = store(j+2)
         RfacMatrix(3,i,k) = store(j+3)
         RfacMatrix(4,i,k) = store(j+4)
         RfacMatrix(5,i,k) = store(j+5)
         RfacMatrix(6,i,k) = store(j+6)
         RfacMatrix(7,i,k) = store(j+7)
         RfacMatrix(8,i,k) = store(j+8)
*        write(6,'(8f8.3)') (rfacmatrix(jj,i,jBlock),jj=1,8)
         j = j + 9
      enddo
      TrBestFom = RfacMatrix(1,1,jBlock)
      if (knw == 1) then
      do i=1,nToSave
         rfa = RfacMatrix(4,i,jBlock)
         if (rfa < 99.9 .and. rfa > 0.0) then
             if (kmad == 0) then
                 write(StringaErre,'(f8.3,1x)') rfa
             else
                 rfa = rfa / RfacMatrix(3,i,jBlock)
                 write(StringaErre,'(f8.3,1x)') rfa
             endif
         else
             StringaErre = '   n.a.   '
         endif
         rat = RfacMatrix(3,i,jBlock)
         if (rat > -9000.0) then ! .or. ifSort == 0) then
             write(StringaFom,'(f9.3)') rat
         else
             StringaFom = '     n.a. '
         endif
         if (ifExamin.ne.0) then
             write(lo,30) i,nint(RfacMatrix(1,i,jBlock)),
     *                    RfacMatrix(2,i,jBlock),
     *                    StringaFom,StringaErre,
     *                    RfacMatrix(8,i,jBlock),
     *                    (RfacMatrix(k,i,jBlock),k=5,7)
         else
             write(lo,30) i,nint(RfacMatrix(1,i,jBlock)),
     *                    RfacMatrix(2,i,jBlock),
     *                    StringaFom,StringaErre
         endif
      enddo
   30 format(i5,')',i6,f8.3,2a9,5f9.3)
      endif
c
!

  200 continue                    ! patterson MAD pg230407

      if (iAction == 1) then
          nRfac = nToSave
          call PutGetRfacMatrix(1)
      endif
!
      deallocate(store, stat=ier)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine ManagePhasesDSR(iAction,correl, ifRelaxTrial)
      USE General
      USE Riflessi
      USE RemoModule
      USE PhaseModule
      USE RfacMatrixModule
      USE Mappa
      USE Param
!
      real, allocatable :: store(:)
      character tirang * 11
!-- 
      nset = 0
      if (iAction == 1) then
          if (nSetsFineDSR < nSetsMaxFineDSR .or.
     *       (nSetsFineDSR == nSetsMaxFineDSR .and. 
     *       ifRelaxTrial == 1)) then
              if (ifRelaxTrial == 0) then
                  nSetsFineDSR = nSetsFineDSR + 1
              elseif (ifVLD == 1) then
                  if (FinalFom < FomsFineDSR(nSetsFineDSR)) then
                      return
                  endif
              endif
              ifStoredPhases = 1
              FomsFineDSR(nSetsFineDSR) = FinalFom
              nset = nSetsFineDSR
          else
              nFomMin = 0
              fomMin = 99999999
              do i=1, nSetsMaxFineDSR
                 if (FomsFineDSR(i) < fomMin) then
                     fomMin = FomsFineDSR(i)
                     nFomMin = i
                 endif
              enddo
              if (FinalFom > fomMin) then
                  nset = nFomMin
                  FomsFineDSR(nset) = FinalFom
              else
                if (ifRemo == 0) then
                  if (knw > 0) then
                     call examin(5252,mkang,khl,ipub,iphaz,nrefl,0,wt,0)
                     if (ifRelaxTrial == 0) then
                         correl = -99.99
                         write(lo,100) numbSet,numbrun,
     *                             FinalFom, erore, erorepes, correl
                  else
                         write(lo,101) numbSet,numbrun,
     *                          FinalFom, erore, erorepes, correl
                     endif
                  endif
                endif
                return
              endif
          endif
!
          iphazo(:) = iphaz(:)
          worko(:) = wt(:)
!
          if (knw > 0) then
              izero = 0
              if (kverbo > 0) then
                  ifm = 1
              else
                  ifm = 0
              endif
              call examin(5353,mkang,khl,ipub,iphaz,numbLSQ,izero,
     *                   wt,ifm)
              call examin(5454,mkang,khl,ipub,iphaz,nreflDim,izero,
     *                   wt,ifm)
!- Trasla_origine da non commentare per avere l'enantiomorfo giusto
!- dedi 16/10/13 -- Problemi per ARP/wARP
              if (knw > 0 .and. ifVLD == 0) then
!                 kverboS = kverbo
!                 kverbo = 1
*                 call Trasla_Origine(nreflDim)
!                 kverbo = kverboS
              endif
          endif
          if (nset /= 0 .and. kmad == 0) then
              figMer(:)   = 0.0
*             figMer(1:3) = RfacMatrix(1:3,kRfac,jBlock)
*             figMer(4:6) = RfacMatrix(6:8,kRfac,jBlock)
              figMer(1) = numbrun
              if (ifMDM == 0) then
                  figMer(2) = EarlyFom
                  figMer(3) = FinalFom
              else
                  figMer(2) = FinalFom
                  figMer(3) = erre
              endif
              figMer(4) = erore
              figMer(5) = erorepes
              figMer(6) = corre
              if (ifRemo == 0) then
                  if (ifVLD == 1) then
                      if (ifMDM == 1) then
                          figMer(7) = 4
                      else
                          figMer(7) = 0
                      endif
                  elseif (ifPatt == 0) then
                      figMer(7) = 2
                  else
                      figMer(7) = 1
                  endif
              else
                  figMer(7) = 3
              endif
!
cdedi - Calcolo fasi e pesi per tutti nrefl  prima di memorizzarli su lista 17
!
              if (ifRemo == 0 .and. ifVLD == 0) then
               if (ksize > 3 .and. kmad == 0) then
                  numberToUse = numbLSQ
                  numberToInv = nrefl
                  fcoef(1:numberToUse) = fovet(1:numberToUse) * 
     *                                   wt(1:numberToUse)
                  jpatt = 0
                  call MakeMap(fcoef, iphaz, numberToUse, jpatt, xmap,
     *                FORTH, BACK)
                  percMap = 0.05
                  percMap_n = 0.0
                  invflag = 1
                  call InvMap(khl,mkang,iphaz,fcvet,numberToInv)

                  ifEndDSR = 1
                  iesfast = 0
                  jflag =  2
                  call PresigmaA(jflag, 0)
                  if (knw == 1) then
                      izero = 0
                      ifmin = 1
                      call examin(numbrun,mkang,khl,ipub,iphaz,nrefl,
     *                       izero,wt,ifmin)
                      if (knw == 1) then
                          ifE = 0
                          call Calcola_CC_Mappa_Finale(ifE)
                          correl = corre
                          if (ifRelaxTrial == 0) then
                               write(lo,100) numbSet,numbrun,
     *                             Final_info(1), erore, erorepes, corre
                          else
                               write(lo,101) numbSet,numbrun,
     *                             Final_info(1), erore, erorepes, corre
                          endif
                      endif
                  endif
!d!
                  ifEndDSR = 0
                  RfacMatrix(6,kRfac,jBlock) = erore
                  RfacMatrix(7,kRfac,jBlock) = erorepes
               endif
              endif
  100    format(/,' SET ',i6,' TRIAL ',i6,' FFom =',f7.3,
     *          ' MPE (MPEw)',2f7.2,' CC =',f7.3,' (All)')
  101    format(/,' SET ',i6,' TRIAL ',i6,' FFom =',f7.3,
     *          ' MPE (MPEw)',2f7.2,' CC =',f7.3,' (All - Relax)')
!
*             if (knw > 0 .and. ifVLD == 0) then
*                 call Trasla_Origine(nreflDim)
*             endif
              nsetVLD = nset
              call PutGetFinalPhases(1, nset, figMer)   ! snw17
          endif
          iphaz(:) = iphazo(:)
          wt(:) = worko(:)
      else
          if (nSetsFineDSR > 0 .and. kmad == 0) then
              n = nSetsFineDSR * 2
              allocate(store(n), stat=ier)
              k=0
              do i=1,nSetsFineDSR
                 nset = i
!                 write(6,199) i,nset, FomsFineDSR(i)
                 k=k+1
                 store(k)=FomsFineDSR(i)
                 k=k+1
                 store(k)=i
              enddo
              LenStore = k
              jump  = -1
              iniz  = 1
              lungs = nSetsFineDSR
              istep = 2
              iniz = 1
              call sortz_dyn(store, n, 1, lungs, istep, jump)
              k = 0
              do i=1,nSetsFineDSR
                 k = k + 1
                 FomsFineDSR(i) = store(k)
                 k = k + 1
                 iposFineDSR(i) = nint(store(k))
              enddo
              deallocate(store, stat=ier)
              if (ifRemo == 1) then
                  nSetsFineDSR = min0(nSetsFineDSR, nSolToExplore)
              endif
              call UpdateFinalPhases(FomsFineDSR, iposFineDSR, ! sup17
     *                               nSetsFineDSR)
              call LoadFinalPhases(FomsFineDSR, iposFineDSR,   ! sfl17
     *                             nsetFinalPhases)
!- solo per controllo  (in memeoria restano le fasi dell'ultimo set
!memorizzato  (quello con la FinalFom più bassa tra i 5 set selezionati)
!             do i=1, nSetsFineDSR
!                nset = iposFineDSR(i)
!                call snr17(nset,figMer)
!                call PutGetFinalPhases(2, nset, figMer)
*                write(6,200) i,nset, FomsFineDSR(i), figMer(1:7)
!             enddo
          endif
      endif
  199 format('ord 0  ',i5,')',i5,9f9.3)
  201 format('ord 1  ',6x,i5,9f9.3)
  200 format('ordina ',i5,1h),i5,9f9.3)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine NewCheshire(mode)
!
!-- Hirshfeld (1968) Acta Cryst A24 301-311
!
!-- mode = 1 Relax approach
!        = 2 Molecular Replacement approach
!        = 3 Molecular Replacement approach (MoreMolecules)
!
      USE General
      USE Symmetry
      USE RemoModule
      USE PhaseModule
      USE Groups, only : nResidStored, nAcid
!
      character*16 spaceg
      character*1 reticolo
      dimension ipolv(3),div(3,3)
      
c     kverbo = 1
!
      if (mode == 1) then
          resn = 1.0
      else
          resn = resol1
      endif
!

!      resn = 1.0
!      a = sqrt(40.5)
!	cell(1:2) = a



      write(spaceg,'(16a1)') nSpaceG
      call lcase(spaceg(1:1))
      kdummy=kpol
      do i = 1, 3
         j = 4 - i
         if (mod( kdummy, 10 ).eq.1) then
             ipolv(j) = 0
         else
             ipolv(j) = 1
         endif
         kdummy = kdummy / 10
         if (nAcid > 0 .and. nResidStored == 0) then
             Gridv(i) = resn / 4.0
         else
             Gridv(i) = resn / 3.0
         endif
      enddo

      Grido(:) = Gridv(:)

      if (kverbo > 0 .and. knw > 0) then
          write(6,*) 'CONTROLLO Gridv =',Gridv(1)
      endif
      reticolo = spaceg(1:1)

      do i=1,3
         do j=1,3
            CheMat(i,j) = 0.0
            div(i,j)  = 1.0
         enddo
         CheMat(i,i) = 1.0
         div (i,i) = 2.0
         if (mode == 3 .and. ipolv(i) == 0) then
             div (i,i) = 1.0
             ipolv(i) = 1
         endif
         CheCell(i)  = cell(i)
      enddo
      select case (jsys)

             case (1,2,3)               ! Triclinic, Monoclinic, Orthorombic
                   do i = 1, 3
                      CheCell(i) = ipolv(i) * CheCell(i) / div(i,i)
                      if (ipolv(i).gt.0) then
                          nGridv(i) = int( CheCell(i) / Gridv(i) ) + 1
                          Gridv(i) = Gridv(i) / CheCell(i)
                      else
                          Gridv(i) = 0.0
                          nGridv(i) = 1
                      endif
                   enddo

             case (4)                   ! Tetragonal
                   CheMat(1,2) =  1.0
                   CheMat(2,1) = -1.0
                   div (1,2) =  2.0
                   div (2,1) =  2.0
                   CheCell(1) = sqrt( 2.0 * CheCell(1) * CheCell(1) )
                   CheCell(2) = CheCell(1)
                   do i = 1, 3
                      CheCell(i) = ipolv(i) * CheCell(i) / div(i,i)
                      if (ipolv(i).gt.0) then
                          nGridv(i) = int( CheCell(i) / Gridv(i) ) + 1
                          Gridv(i) = Gridv(i) / CheCell(i)
                      else
                          Gridv(i) = 0.0
                          nGridv(i) = 1
                      endif
                   enddo

             case (44)                   ! old Tetragonal
                   CheMat(1,2) =  1.0
                   CheMat(2,1) = -1.0
                   div (1,2) =  2.0
                   div (2,1) =  2.0
                   CheCell(1) = sqrt( 2.0 * CheCell(1) * CheCell(1) )
                   CheCell(2) = CheCell(1)
                   do i = 1, 3
                      CheCell(i) = ipolv(i) * CheCell(i) / div(i,i)
                      if (ipolv(i).gt.0) then
                          if (i.ne.3) then
                              Gridv(i) = sqrt( 
     *                                   2.0 * Gridv(i) * Gridv(i) )
                          endif
                          nGridv(i) = int( CheCell(i)/Gridv(i) ) + 1
                      else
                          Gridv(i) = 0.0
                          nGridv(i) = 1
                      endif
                   enddo
                   xl = resn / 3.0 !    1.0 / 3.0
!-- prova
                   CheCell(1:3) = ipolv(1:3) * cell(1:3)
                   CheCell(1:3) = CheCell(1:3) / 2.0
!-- prova
                   do i = 1, 3
                      if (CheCell(i).gt.0.001) then
                          Gridv(i)  = xl / CheCell(i)
!-- prova
                          nGridv(i) = int( CheCell(i)/Gridv(i) ) + 1
!-- prova
                      else
                          Gridv(i) = 0.0
                      endif
                   enddo

             case (5)                   ! Hexagonal
                 cos120 = cos(dtor*cell(6))
                 if (reticolo.eq.'r') then
                     if (ipolv(3).eq.0) then   ! floating origin along Z
                         CheMat(1,2) =  1.0
                         CheMat(2,1) = -1.0
                         CheMat(2,2) =  2.0
                         div(1,1)  =  3.0
                         div(1,2)  =  3.0
                         div(2,1)  =  3.0
                         div(2,2)  =  3.0
                         cos120 = cos(dtor*cell(6))
                         arg = CheCell(1) * CheCell(1) *
     *                         2.0 * (1.0 + cos120)
                         CheCell(1) = sqrt( arg )
                         arg = CheCell(1) * CheCell(1) *
     *                         (5.0 -4.0 * cos120)
                         CheCell(2) = sqrt( arg )
                     else
                         CheMat(1,1) =  0.0
                         CheMat(1,2) =  1.0
                         CheMat(2,1) = -1.0
                         CheMat(2,2) =  1.0
                         div(1,1)  =  1.0
                         div(1,2)  =  1.0
                         div(2,1)  =  1.0
                         div(2,2)  =  1.0
                         div(3,3)  =  2.0
                         CheCell(1) = CheCell(2)
                         arg = CheCell(1) * CheCell(1) +
     *                         CheCell(2) * CheCell(2) +
     *                         CheCell(1) * CheCell(2) *
     *                         2.0 * cos120
                         CheCell(2) = sqrt( arg )
                     endif
                 else
                     if (jsvet(1).eq.128) then
                         CheMat(1,2) =  1.0
                         CheMat(2,1) = -1.0
                         CheMat(2,2) =  2.0
                         div(1,1)  =  3.0
                         div(1,2)  =  3.0
                         div(2,1)  =  3.0
                         div(2,2)  =  3.0
                         arg = CheCell(1) * CheCell(1) *
     *                         2.0 * (1.0 + cos120)
                         CheCell(1) = sqrt( arg )
                         arg = CheCell(1) * CheCell(1) *
     *                         (5.0 -4.0 * cos120)
                         CheCell(2) = sqrt( arg )
                     else
                         div(1,1)  =  1.0
                         div(2,2)  =  1.0
                         div(2,3)  =  2.0
                     endif
                 endif
                 do i = 1, 3
                    CheCell(i) = ipolv(i) * CheCell(i) / div(i,i)
                    if (ipolv(i).gt.0) then
                        nGridv(i) = int( CheCell(i) / Gridv(i) ) + 1
                        Gridv(i) = Gridv(i) / CheCell(i)
                    else
                        Gridv(i) = 0.0
                        nGridv(i) = 1
                    endif
                 enddo

             case (6)                   ! Cubic
c                if (reticolo.ne.'f') then
c                    do i = 1, 3
c                       div(i,i) = 1.0
c                    enddo
c                endif
c                do i = 1, 3
c                   CheCell(i)  = CheCell(i) / div(i,i)
c                   nGridv(i) = int( CheCell(i) / Gridv(i) ) + 1
c                   Gridv(i)  = Gridv(i) / CheCell(i)
c                enddo
croc
                 select case (nSpaceGroupPatt)
                      case (21,22,23)           !  cubico  m -3 lo considero come 222
                         if (nSpaceGroupPatt /= 22) then
                             div(:,:) = 1
                         endif
                         do i = 1, 3
                           CheCell(i) = ipolv(i) * CheCell(i) / div(i,i)
                           if (ipolv(i).gt.0) then
                               nGridv(i) = int(CheCell(i) / Gridv(i))+1
                               Gridv(i) = Gridv(i) / CheCell(i)
                           else
                               Gridv(i) = 0.0
                               nGridv(i) = 1
                           endif
                         enddo

                      case (24)           !  cubico  m -3 mlo considero come 422

                         div(:,:) = 1
                         do i = 1, 3
                            CheCell(i) = ipolv(i) * CheCell(i)/div(i,i)
                            if (ipolv(i).gt.0) then
                                nGridv(i) = int(CheCell(i) / Gridv(i))+1
                                Gridv(i)  = Gridv(i) / CheCell(i)
                            else
                                Gridv(i) = 0.0
                                nGridv(i) = 1
                            endif
                         enddo

                      case (25,26)           !  cubico  m -3 mlo considero come 422
                         CheMat(1,2) =  1.0
                         CheMat(2,1) = -1.0
                         div (1,2) =  2.0
                         div (2,1) =  2.0
                         CheCell(1) = sqrt(2.0*CheCell(1) * CheCell(1))
                         CheCell(2) = CheCell(1)
                         do i = 1, 3
                            CheCell(i) = ipolv(i) * CheCell(i)/div(i,i)
                            if (ipolv(i).gt.0) then
                                nGridv(i) = int(CheCell(i) / Gridv(i))+1
                                Gridv(i)  = Gridv(i) / CheCell(i)
                            else
                                Gridv(i) = 0.0
                                nGridv(i) = 1
                            endif
                         enddo
                 end select
croc
      end select

      do i = 1, 3
         do j = 1, 3
            CheMat(i,j) = CheMat(i,j) / div(i,j)
         enddo
         CheMat(i,i) = CheMat(i,i) * ipolv(i)
      enddo
!
!-- trova i limiti sugli angoli di Eulero
!
      call CheshireAngle()
c     kverbo = 0
!
      return
      end
! ----------------------------------------------------------------------
      subroutine WriteCheshire()
      USE General
      USE Symmetry
!
      character spaceg*16, cond(3,2)*6
      integer kd(3), ku(3)
!
      write(spaceg,'(16a1)') nSpaceG
      call ucase(spaceg(1:1))
!
!     write(lo,10)
!  10 format(' RELAX procedure required:',/)
**    write(lo,40)
      write(lo,20) spaceg,
     *             (cell(i)   ,i=1,3), (CheMat(1,j),j=1,3),
     *             (CheCell(i),i=1,3), (CheMat(2,j),j=1,3),
*    *             (Gridv(i)  ,i=1,3), (CheMat(3,j),j=1,3),
     *             (Grido(i)  ,i=1,3), (CheMat(3,j),j=1,3),
     *             (nGridv(i) ,i=1,3)
*  20 format('   Space Group:  ',a,/,
*    *       '          Cell: ',3f6.2,24x,                3f7.2,/,
*    *       ' Cheshire cell: ',3f6.2,5x,'Transf. Matrix from',3f7.2,/,
*    *       '          Grid: ',3f6.2,3x,'Cell to Cheshire cell',3f7.2,/,
*    *       '   Grid points: ',3(i3,3x),/)
   20 format('   Space Group:  ',a,/,
     *       '          Cell: ',3f7.2,2x,'Transformation Matrix ',3f6.2,
     *     /,' Cheshire cell: ',3f7.2,2x,'      from Cell       ',3f6.2,
     *     /,'          Grid: ',3f7.2,2x,'  to Cheshire cell    ',3f6.2,
     *     /,'   Grid points: ',3(i7),/)
      do i=1,3
         cond(i,1) = '(0,'
         kd(i) = 3
      enddo
      do i=1,3
         k = nint( alimUp(i) * 10 )
         if (k == 0) then
             cond(i,2) = '0)'
             ku(i) = 2
         elseif(k == 5) then
             cond(i,2) = 'Pi/6)'
             ku(i) = 5
         elseif(k == 10) then
             cond(i,2) = 'Pi/3)'
             ku(i) = 5
         elseif(k == 16) then
             cond(i,2) = 'Pi/2)'
             ku(i) = 5
         elseif(k == 21) then
             cond(i,2) = '2Pi/3)'
             ku(i) = 6
         elseif(k == 31) then
             cond(i,2) = 'Pi)'
             ku(i) = 3
         elseif(k == 63) then
             cond(i,2) = '2Pi)'
             ku(i) = 4
         endif
      enddo
      write(lo,30)
     *  (     cond(i,1)(1:kd(i)), cond(i,2)(1:ku(i)) ,i=1,3)
   30 format(' Conditions on Eulerian Angles :',
     *   10x,3(a,a,5x))
!
      call CheshireConditions()
!
      write(lo,40)
   40 format(' ',78('+'),/)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine EspandiInP1(kh,kk,kl,phi,jhklm,ifin,ksubr)
c
      USE General
      USE Symmetry
      USE PhaseModule
!
      integer jhklm(6,24),i1(3),i2(3),i3(3),indrvet(24)
c
      i1(1) = kh
      i1(2) = kk
      i1(3) = kl
     
c
c-- compute H*R and phi(H*R)
c
      j=1
      do jj=1,nsymTrue
         isegno = 1
         ht = 0.0
         do l=1,3
            i2(l)=0
            do k=1,3
               i2(l)=i2(l)+i1(k)*kmat(jj,k,l)
            enddo
            ht = ht + float(i1(l)) * tmat(jj,l)
            i3(l) = i2(l)
         enddo
c
         iflag = 0
         i = 0
         do while ( iflag .eq. 0 )
            i = i + 1
            if (i3(i).ne.0) then
                if (i3(i).lt.0) then
                    isegno = -1
                    do k=1,3
                       i3(k) = -i3(k)
                    enddo
                endif
                iflag = 1
            endif
         enddo
         indr=i3(1)*ifat1+i3(2)*ifat2+i3(3)
         iflag = 1
         if (jj.eq.1) then
             j = 0
         else
             do k=1,j
                if (indr.eq.indrvet(k)) then
                    iflag = 0
                endif
             enddo
         endif
         if (iflag.eq.1) then
             j = j + 1
             indrvet(j) = indr
             if (ksubr.eq.2) then
                 jhklm(1,j) = i3(1)
                 jhklm(2,j) = i3(2)
                 jhklm(3,j) = i3(3)
                 jsegno = isegno
             else
                 jhklm(1,j) = i2(1)
                 jhklm(2,j) = i2(2)
                 jhklm(3,j) = i2(3)
                 jsegno = 1
             endif
             iphi       = jsegno * nint(phi - 360.0 * ht) + 36000
             jhklm(4,j) = mod(iphi,360)
             jhklm(5,j) = jj
             jhklm(6,j) = isegno
         endif
      enddo
      ifin = j
c
      return
      end
c----------------------------------------------------------------------
      subroutine ProvaInP1(numbRileggi, ier, ifAborted, ifBreak)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Molcom
      USE BuildStuff
      USE PhaseModule
      USE RemoModule
!
!--
!
      common /cent/ tl(3,4),fs(3,3,24),mlat
      dimension tlsav(12),fsSav(216)
!
      call CPUTime0('RELAX starts')
      ifAborted = 0
      if (ifRemo == 1 .and. knw == 1) then
          ifExamin = 1
      endif

      if (knw == 1) then
          write(lo,10) numbrun
      endif
   10 format(8x,' Start of RELAX procedure for trial ',i5)


      call FromGStoP1toGS(1)

*     stop

      kstr = 0 
      do i=1, nreflDim
         if (evet(i) < en) then
             kstr = i - 1
             exit
         endif
      enddo
      
      if (kstr > 0 ) then
          nstr = kstr         ! PROVA gianluca 6/10/06
      endif
!     write(6,*) 'nreflDim in P1',nreflDim,nrefltot,numbGen,numbLSQ,nstr

      if (ier.lt.0) go to 1000
      call InitSigmaA(1)
      nBack = 0
      nOld  = 0
      ncont  = 0
      do i=1, numbInv
         if (iwork1(i).gt.0) then
             iworki = iwork1(i)
         else
             iworki = -iwork1(i)
         endif
         ii = jwork1(i)                      ! numero d'ordine asimm.
         jj = iworki
         jj = jj / 100                       ! operatore di simm.
         if (ii.ne.nOld) then
             nBack = nBack + 1
             if (nBack.gt.numbRileggi) then
                 exit
             endif
             nOld  = ii
         endif
         ht = 0.0
         do l=1,3
            ht = ht + float( khl(l,ii) ) * tmat(jj,l)
         enddo
         iphaz(i) = BackPh(nBack) - (twopi * ht) * rtod
         iphaz(i) = mod(iphaz(i)+36000,360)
         wt(i) = BackWt(nBack)
         ncont = ncont + 1
         if (ii <= numbPse) wtPseudo(i) = alphaVet(ii)
      enddo
      ifmin = 11
      izero = 0
      call examin(-2,mkang,khl,ipub,iphaz,ncont,izero,wt,ifmin)
      call CalcolaBarra()
      if (numbGen == 0) then
          ncont = nreflDim
      endif
      call Contan2(ifAborted, ncont, ifBreak, ier)
!
 1000 continue


      if (ifTre == 1) then
          go to 2
      endif


      call CreavettoreSigma()
      call InitSigmaA(1)


    2 continue
c
!
!     if (ksize.ge.2 .and. kmad == 0) then
!         call AllocaHistoStuff(1)
!         vetmatchin(1:nrefl) = evet(1:nrefl)
!         izzero = 0
!         call InitHistMatchObs(izzero)
!     endif
!
!pg201213
!      if (ifTre == 0) then
          call CPUTime('RELAX ends', 1)
*     end if
!
      return
      end
!-----------------------------------------------------------------------
      subroutine FromGStoP1toGS(iAction)
!
!-- iAction = 1 move in P 1
!-- iAction = 2 back in space group
!
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE PhaseModule
      USE RelaxMod
      USE RemoModule
      USE BuildStuff, only : MaxAtomsBuild
!
      implicit none
      integer :: iAction, i, j, k, l, lixx, mn, ier, ksubr
      integer :: mlat, ifmin, izero
      real    :: tl, fs
      common /cent/ tl(3,4),fs(3,3,24),mlat
!
      if (iAction == 1) then
!
!--  Dedi per calcolo errore di fase corretto in P1
!
          if (knw == 1) then
              call AllocaTestStuff(2)
              call AllocaTestStuff(3) ! chiamata per il P1
          endif
!
          ifExpandedSav = ifExpanded
          if (ifExpanded>0) then ! occhio
             ifExpanded = 0
             ihmx=ihmxSav
             rhomax = maxval(rhov(1:nrefl))
          endif
!
          ifmin = 1
          izero = 0
          call examin(-1,mkang,khl,ipub,iphaz,nrefl,izero,wt,ifmin)
!
          jsysSav = jsys
          lattSav = latt
          anatSav  = anat
          natmSav  = natm
          icentSav = icent
          totopSav = totop
          alphaVet(:) = wtPseudo(:)
          icent = 0
          ifReduced = 1
          jsys    = 1
          nsym = 1
          totop = pts * float( ( icent + 1 ) * nsym )
          anat=float(nat)/(pts*float((icent+1)*nsym))
          natm=int(anat+0.5)
          natm = max0(natm, nk)
          nsymTot=nsym*(icent+1)*mlat
          numbLSQSav  = numbLSQ
          numbInvSav  = numbInv
          numbGenSav  = numbGen
          nreflDimSav = nreflDim
          nrefltotSav = nrefltot
          nreflSav    = nrefl
          nstrSav     = nstr
          en = evet(nstr)
          do i=1,45
             aperc(i+45) = aperc(i)
             rperc(i+45) = rperc(i)
          enddo
          mn = int(4.5*anat+100.5) + 50
          nstr = min0(mn,maxstr)
          nstr = mn + min0(maxstr-mn,100) / 2
          nstrP1 = nstr
    
          k = 0
          do i=1,3
             do j=1,4
                k = k + 1
                tlSav(k) = tl(i,j)
                tl(i,j) = 0
             enddo
          enddo
          k = 0
          do i=1,3
             do j=1,3
                do l=1,24
                   k = k + 1
                   fsSav(k) = fs(i,j,l)
                   fs(i,j,l) = 0
                enddo
             enddo
          enddo
          do i=1,3
             fs(i,i,1) = 1
          enddo
!
          jspini = -1
          call xspinb
!
          if (ifVLD == 1) then
              ksizeSav = ksize
          endif
          call scrper(' ',0,-1)
          lixx = InfoOK(6)
          if (lixx.gt.0) then
              call LoadReflInfo
          else
              nrefltot = 0
          endif
          numbGen  = 0
          nrefltot = nrefl
          nreflDim = sum(mult(1:nrefltot))  ! gianluca 16/04/2007
*         nreflDim = sum(mult(1:nreflDim-numbGen))  ! gianluca 23/01/2014
          call InitSigmaA(2)
          call AllocaRiflessi(1)
          if (.not.allocated(xyzs)) then
               call AllocaAtomi(1)
          endif
          MaxAtomsBuild = MaxAtoms
!
          if (ifVLD == 1) then
              wt(:)    = 0.0      !POSIZIONE FORSE SBAGLIATA DA PARTE DI PG
              iphaz(:) = 0
          endif
!
          ier = 0
          if (nrefltot.gt.0) then
              ksubr = 3
              call LeggiRiflessi(ier,ksubr)
          endif
!
!-- azzero fasi e pesi che poi recupero da BackPh e BackWT !!!
!
          if (ifVLD == 0) then
              wt(:)    = 0.0      !  FORSE CORRETTO !!!
              iphaz(:) = 0
          endif
!      
          if (ifVLD == 1) then
              ksize = ksizeSav
          endif
      else
          call InitSigmaA(2)
          if (knw == 1) then
              call AllocaTestStuff(2)
          endif
!
          ifReduced = 0
          call CalcolaBarra()
          jsys    = jsysSav
          latt    = lattSav
          icent   = icentSav
          nsym    = nsymTrue
          anat    = anatSav
          natm    = natmSav
          nsymTot = nsym*(icent+1)*mlat
          totop   = totopSav
          wtPseudo(:) = alphaVet(:)
!
          k = 0
          do i=1,3
             do j=1,4
                k = k + 1
                tl(i,j) = tlSav(k)
             enddo
          enddo
          k = 0
          do i=1,3
             do j=1,3
                do l=1,24
                   k = k + 1
                   fs(i,j,l) = fsSav(k)
                enddo
             enddo
          enddo
!
          jspini = -1
          call xspinb
          numbLSQ = numbLSQSav
          numbInv = numbInvSav
          numbGen = numbGenSav
          nreflDim = nreflDimSav
          nrefltot = nrefltotSav
          nrefl = nreflSav
          nstr = nstrSav
          nstrP1 = nstr
          do i=1,45
             aperc(i) = aperc(i+45)
             rperc(i) = rperc(i+45)
          enddo
!
          call AllocaRiflessi(1)
*****     call AllocaAtomi(1)
          MaxAtomsBuild = MaxAtoms
          if (knw == 1) then
              call AllocaTestStuff(1)
          endif
!
          ifExpanded = ifExpandedSav
          if (ifExpanded>0) then ! occhio
             ifExpanded = 0
             ihmx=ihmxExt
             rhomax = maxval(rhov(1:nrefltot))
          endif
      
          if (ifVLD == 1) then
              ksizeSav = ksize
          endif
      
          if (ifRemo == 1) then
              ksubr = 4
          else
              if (numbGen == 0) then
                  ksubr = 3
              else
              ksubr = 33
              endif
          endif
          call LeggiRiflessi(ier,ksubr)
      
          if (ifVLD == 1) then
              ksize = ksizeSav
          endif      
      
          call CreavettoreSigma()
          call InitSigmaA(1)
!
      endif
!
      return
      end
!----------------------------------------------------------------------
      subroutine Contan2(ifAborted, ncont, ifBreak, ier)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Molcom          
      USE PhaseModule
      USE LsqModule
      USE VLDmod, only:varg3
      USE RelaxMod
!
      implicit none
      integer :: ifAborted, ifBreak, ier, ifExaminSav, ifTimeSav, ncont
      integer :: ifEnve_sav, nIterazioni_sav, izero, ifmin, ifFromRelax
      real    :: varg3_sav, corre
!
      epsv = 1
      ifBreak = 0
      nbarra = iabs(nbarra)
      call Barra()
!
      ifExaminSav = ifExamin
      ifEnve_sav = ifEnve
      nIterazioni_sav = nIterazioni
      varg3_sav = varg3
      varg3 = 0
!!!!  ifEnve = 0
      nIterazioni = 0
      Iterazione = 0
!     ifExamin = 0
      if (ifRemo == 0) then
          ifExamin = 0 !1  !??
      endif
      if (noDSR == 0) then
          call Cicli_DSR(ifBreak, corre, ier)    !  ERRORE 04/02/2010
      endif
      if (ifBreak == 1) then
          return
      endif
      ifEnve = ifEnve_sav
      nIterazioni = nIterazioni_sav
      varg3 = varg3_sav
      if (knw == 1) then
          ifExamin = 1
          ifmin = 11
          izero = 0
          ifTimeSav = iftime
          iftime = 0
          call examin(-3,mkang,khl,ipub,iphaz,numbLSQ,izero,wt,ifmin)
          iftime = ifTimeSav
      endif
      if (.not.allocated(FasiRelax)) then
*         allocate(FasiRelax(1:nreflDim), stat = ier)
*         allocate(PesiRelax(1:nreflDim), stat = ier)
          allocate(FasiRelax(1:ncont), stat = ier)
          allocate(PesiRelax(1:ncont), stat = ier)
      endif
*     FasiRelax(1:nreflDim) = iphaz(1:nreflDim)
*     PesiRelax(1:nreflDim) = wt(1:nreflDim)
      FasiRelax(1:ncont) = iphaz(1:ncont)
      PesiRelax(1:ncont) = wt(1:ncont)
      if (noDSR==0) then
         ifFromRelax = 1
*        call TraslasOLd(ifFromRelax, jsysSav)
         call Traslas(ifAborted, ifFromRelax)
c        call Traslas_Relax(ifFromRelax, jsysSav) ! leggermente modificata;  da testare
      endif
      ifExamin = ifExaminSav
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Relax(ier, fomNoWind, ifGoOn, ifBreak)
!!!!! attenzione gestire il BREAK ????

      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE PhaseStuff
      USE Mappa
      USE PhaseModule
      USE VLDmod
      USE VLDmod_1
      USE VLDmod_2, only:work22
      USE VLDmod_3   !pg201213
      USE RelaxMod
      USE RfacMatrixModule

      USE Riflessi_App
!

*pg*  real :: fcvet_trasl2(nrefl)     !residuo_piccolo
*pg*  real :: fcvet_trasl1(nrefl)     !residuo_piccolo 
*pg*  character ttirang*80            !residuo_piccolo

      if (ifVLD == 1) then
         OldFinalFom = FinalFom
      else
         OldFinalFom = FinalFom_DSR

         FinalFomApp = FinalFom
         iphapp(1:nreflDim) = iphaz(1:nreflDim)
         pesapp(1:nreflDim) = wt(1:nreflDim)
         eveapp(1:nreflDim) = evet(1:nreflDim)

      endif

      ntraslas = 0

      if (ifVLD /= 0 .and. ksize < 3) then    !????????????
!     if (ifVLD /= 0 .and. ksize <= 3) then   !???
          OldFinalFom = 0.0
      endif

      numbRileggi = min0(numbInv,8000)
      call ProvaInP1(numbRileggi, ier, ifAborted, ifBreak)
!
      if (ifBreak == 1) then
          return
      endif

      if (ifTre == 1) then
          go to 1003
      endif

! - modifiche dedi
      if (ifAborted == 0) then
      
          do i = ntraslas,1,-1  ! 2 traslazioni
    
             if (ntraslas == 1) then
!!gpu           call NewInv(iphaz,fcvet,nrefl,np(1),np(2),np(3), 
!!gpu*                      BACKenv)
                call NewInvCuda(iphaz,fcvet,nrefl,np(1),np(2),np(3),
     *                      BACKenv, xenve)
     
*pg*               fcvet_trasl1(1:nrefl) = fcvet(1:nrefl)     !residuo_piccolo  

             elseif (ntraslas > 1) then
                if (i == 1) then
                   iphazo(:) = iphaz(:)
                   worko(:)  = wt(:)
                   ffmm = FinalFom
!gpu              call NewInv(iphaz,fcvet,nrefl,np(1),np(2),np(3), 
!!gpu*                         BACKenv)
                   call NewInvCuda(iphaz,fcvet,nrefl,np(1),np(2),np(3),
     *                         BACKenv, xenve)
     
*pg*               fcvet_trasl1(1:nrefl) = fcvet(1:nrefl)     !residuo_piccolo  

                else
!!gpu              call NewInv(iphaz,fcvet,nrefl,np(1),np(2),np(3), 
!!gpu*                         BACK)
                   call NewInvCuda(iphaz,fcvet,nrefl,np(1),np(2),np(3),
     *                         BACK, xmap)
     
*pg*               fcvet_trasl2(1:nrefl) = fcvet(1:nrefl)     !residuo_piccolo  

                endif
             endif
!
             ifSigmaA = 0   ! da testare ifSigmaA=1 (per usare la nuova SigmaA)
             iAll = 1
             chope = 0.5
             call CalcolaPesi(numbLSQ,numbLSQ,chope,iAll)
             if(noDSR==0) then
                izero = 0
                ifmin = 1
                call examin(-555,mkang,khl,ipub,iphaz,numbLSQ,izero,
     *                       wt,ifmin)
             endif
   
             if (ifVLD == 0) then
                 if (knw == 1 .and. ifTime == 0) then
                     kstp = 1
                     call Calcola_CC_Mappa(numbLSQ,corre,kstp,2)
CDEDI                write(lo,10) CCEoEc,FOMs(2,4),corre
                 endif
    
                 if (ksize <= 3) then
                   call Calcola_FOM_Lib(1)
!D                 FinalFom = FOMs(2,4)
!D                 fomNoWind = FOMs(2,4)
                   FinalFom0 = FOMs(2,4)
                   FinalFom  = FinalFom0 / sogFinalFom
                 else
                   ifReduced = 1
                   call Calcola_FinalFom(0)
                   call Calcola_FinalFom2(0)
                   ifReduced = 0
                 endif
             else
                 call CalcFFomVLD(0,0.0)
                 if (knw > 0) then
                    write(6,*) 'RELAX CalcFFomVLD',FinalFom, OldFinalFom
                 endif
             endif
             if (knw > 0) then
                     write(lo,15) i, FinalFom,delta_tra(i,:)
                     write(lo,10) FinalFom
             endif

          enddo
!
          if (ntraslas > 1) then
             if (FinalFom < ffmm) then
                 iphaz(:) = iphazo(:)
                    wt(:) = worko(:)
                 delta_sol(:) = delta_tra(2,:)
                 FinalFom = ffmm
*pg*             if (ifVLD /= 0) then
*pg*                work22(1:nrefl) = fcvet_trasl2(1:nrefl)    !residuo_piccolo 
*pg*                ttirang = ' Ntrasl = 2 '                   !residuo_piccolo 
*pg*             end if
             else
                 delta_sol(:) = delta_tra(1,:)
*pg*             if (ifVLD /= 0) then
*pg*                work22(1:nrefl) = fcvet_trasl1(1:nrefl)    !residuo_piccolo
*pg*                ttirang = ' Ntrasl = 1 '                   !residuo_piccolo
*pg*             end if
             endif
          else
             delta_sol(:) = delta_tra(1,:)
*pg*         if (ifVLD /= 0) then
*pg*            ttirang = ' Ntrasl = 1 '                   !residuo_piccolo
*pg*            work22(1:nrefl) = fcvet_trasl1(1:nrefl)    !residuo_piccolo
*pg*         end if
          endif

          fomNoWind = FinalFom

          if (knw /= 0) then
              write(Inte,'(16a1)') nSpaceG(1:16)
              call lcase(Inte)
              call ucase(Inte(1:1))
              write(lo,98) Inte(1:Lung(Inte)), delta_sol(1:3)
          else
              write(lo,99) delta_sol(1:3)
          endif

          if (noDSR ==0 ) then
!p&c             
             ifTimeSav = ifTime
             if(ifTime == 1 .and. ifMDM == 1) then
                 ifTime = 0
             end if
!p&c
              izero = 0
              ifmin = 1
              call examin(-666, mkang, khl, ipub, iphaz, numbLSQ, izero,
     *                    wt, ifmin)
              ifTime = ifTimeSav     !p&c
              kstp = 1
              call Calcola_CC_Mappa(numbLSQ,corre,kstp,2)
          endif
   
      else
          FinalFom = OldFinalFom - 0.1 ! ifAborted == 1
      endif  

 1003 continue

      if (numero_cicli==64) then
          pippo=0
      end if

!pg201213
      FinalFom = BestFomChe
      if (knw /= 0) then
          write(Inte,'(16a1)') nSpaceG(1:16)
          call lcase(Inte)
          call ucase(Inte(1:1))
          write(lo,98) Inte(1:Lung(Inte)), Best_Tra(1:3)
      else
          write(lo,99) Best_Tra(1:3)
      endif

! - modifiche dedi
      if (nolsq == 0) then
          call Cancella(15)
          nats = 0
      endif
!
      if (ifVLD == 0 .and. ifDsrVLD == 1) then
          if (LowRes == 0) then
              coefF = 1.2
          else
              coefF = 1.5
          endif
          OldFFom = coefF * OldFinalFom
      else
          OldFFom = OldFinalFom
      endif
          
      if (FinalFom > OldFinalFom) then
*     if (FinalFom > OldFFom) then
          if (ifVLD == 1) then
              if (ifMDM == 0) then
                  FinalFom2 = FinalFom
                  call PlotFinalFomVLD(2)
              else
                  call PlotFinalFomMDM(2)
              endif
          endif
          if (abs(OldFinalFom) < 0.001) then
              if (ifVLD == 0) then
                  write(lo,20) FinalFom
              else
                  if (knw == 0) then
!pg27012014                      
!                      write(lo,21) FinalFom
                  else
                      write(lo,26) FinalFom, OldFinalFom
                  endif
                  if (ksize < 3) then
                      RfacMatrix(3,numbrun,jBlock) = BestFomChe
                      if (BestFomChe > fomBestVLD) then
                          fomBestVLD = BestFomChe
                      endif
                  endif
              endif
          else
              if (ifVLD == 0) then
                  write(lo,25) FinalFom, OldFinalFom
!                 write(lo,25) FinalFom, OldFFom, OldFinalFom
              else
                  if (knw == 0) then
!pg27012014                      
!                      write(lo,21) FinalFom
                  else
                      write(lo,26) FinalFom, OldFinalFom
                  endif
                  if (ksize < 3) then
                      RfacMatrix(3,numbrun,jBlock) = BestFomChe
                      if (BestFomChe > fomBestVLD) then
                          fomBestVLD = BestFomChe
                      endif
                  endif
              endif
          endif
!
      kkk = 0

      if (kkk > 0) then
         iphazo(:) = iphaz(:)
         call Trasla_Origine(nrefl)
         izero = 0
         ifmin = 1
         nse = 12345
         call examin(nse,mkang,khl,ipub,iphaz,nrefl,
     *                                       izero,wt,ifmin)
         fcoef(1:nrefl) = evet(1:nrefl)
     *                        * wt(1:nrefl)

         jpatt = 0
         call MakeMap(fcoef, iphaz, nrefl, jpatt, xmap,
     *                FORTH, BACK)
         call maxmin3d(denmin,denmax,avden,stden,npunt,0)
         write(6,*) 'dopo RELAX ',denmin,denmax,avden,stden
!
         nnuu = 70
         call Write_CCP4_Map(xmap, nnuu)
!
*          FileMapName = 'mappa1.map'
*          call CCP4MAPOUT(jpatt,xmap,np,FileMapName)
         iphaz(:) = iphazo(:)
!
      endif
!
          if (ifVLD == 0 .and. ksize <= 3) then
              kWstop = 0     !piccole e medie non VLD si fermano in f.ne Rf
          else
              if (FinalFom > stopFinalFom) then
                  kWstop = 1
                  if (knw > 0) then
                      write(6,*) 'RELAX kWstop=1',FinalFom, stopFinalFom
                  endif
              endif
          endif
!
          numb = nstr
          correl = 0.0
          iesRelax = 1
          if (ifVLD == 1) then
              RfacMatrix(3,numbrun,jBlock) = FinalFom
          endif
          if (kmad == 0 .and. ksize > 3 .and. kWstop == 1) then  
             if (ifVLD == 1) then
                 call PostDSR_VLD(correl ,ifBreak, ier)
             elseif (ifDsrVLD == 1) then
                 FinalFom_DSR = FinalFom
                 call PostDSR_PROT(correl ,ifBreak, ier)
                 if (knw == 1) then
                     write (lo,'(12x,a,f7.3,a,f7.3,a)')
     *          'Improved Phases: Final Fom ',FinalFom_DSR,' (before);',
     *                                        FinalFom,' (after)'
                 else
                     write (lo,'(12x,a,f7.3)')
     *               'Improved Phases: Final Fom ',FinalFom_DSR
                 endif
                FinalFom = FinalFom_DSR     ! non mostrare FFOM dopo PostDSR

             endif
             corre = correl
             jpercBarra = 0
             npercBarra = 0
             call scrper(' ',jpercBarra, npercBarra)
          else
             corre = 0.0
          endif
!d!
          if (iesRelax == 1) then
              Final_info(1) = FinalFom
              Final_info(5) = 1.0
              if (knw == 1) then
                  Final_info(2) = erore
                  Final_info(3) = erorepes
                  Final_info(4) = corre
              endif
              ifRelaxTrial = 1
corig         if (ifVLD == 0) then     
              if (ifPatt /= 1 .and. ifVLD == 0) then
                  call EndDSR(corre, ifRelaxTrial)
              end if
          endif
!d!
!gianluca ifReduced = 1
!!!       ifRelaxTrial = 1
*         if (ifVLD /= 0) then               !pgVLD2912   ! gl 12/01/11
*             ifRelaxTrial = 0
*         end if
*         if (ifVLD == 0 .or. ksize > 3) then               ! gl 12/01/11
!!!       if (ifVLD == 0) then                              ! gl 26/10/11
!!!           call EndDSR(corre, ifRelaxTrial)
!!!       end if
!gianluca ifReduced = 0
*         ratio = FinalFom / OldFinalFom
*         if (FinalFom > 0.2 .and. ratio > 1.3) then
*             ifGoOn = 1
*         endif
*         write(6,*) 'RATIO', ratio, ifGoOn
          ifGoOn = 1
!
      else
          if (ifAborted == 0) then
              if (abs(OldFinalFom) < 0.001) then
                  if (ifVLD == 0) then
                      write(lo,30) FinalFom
                  else
                      if (knw == 0) then
!pg27012014                      
!                          write(lo,31) FinalFom
                      else
                          write(lo,36) FinalFom, OldFinalFom
                      endif
                  endif
              else
                  if (ifVLD == 0) then
                      write(lo,35) FinalFom, OldFinalFom
!                     write(lo,35) FinalFom, OldFFom, OldFinalFom
                  else
                      if (knw == 0) then
!pg27012014                      
!                          write(lo,31) FinalFom
                      else
                          write(lo,36) FinalFom, OldFinalFom
                      endif
                  endif
              endif
          else
              write(lo,37)
          endif
! 
          FinalFom = OldFinalFom
          ifGoOn = 0
          call ClearMessage()
      endif
c     else
!
c         if (hsol < hFom) then
c             write(lo,*)' *****  RELAX Procedure ABORTED! *****'
c         endif
c         FinalFom = OldFinalFom
c         ifGoOn = 0
c         call ClearMessage()
!
c     endif
!
      ntraslas = 0
!
CDE10 format(11x,' End of RELAX FOMs =',3f9.3,' CC_MAP =',f6.3,/)
   10 format(11x,' End of RELAX FOMs =',2f9.3,/)
   15 format(11x,' NTRASLAS = ',i4,' Final FOM =',f7.3,' DELTA: ',3f7.4)
   20 format(11x,' Final Fom ',f7.3,' improved by RELAX.')
   21 format(11x,' Relax Fom ',f7.3,' improved by RELAX.')
   25 format(11x,' Final Fom ',f7.3,' improved by RELAX ',
     *     '(previous value',f7.3,').')
!  25 format(2x,' Final Fom',f7.3,' improved by RELAX ',
!    *     '(threshold value',f7.3,' - previous value',f7.3,').')
   26 format(11x,' Relax Fom ',f7.3,' improved by RELAX ',
     *     '(comparison value',f7.3,').')
   30 format(11x,' Final Fom ',f7.3,' RELAX fault.')
   31 format(11x,' Relax Fom ',f7.3,' RELAX fault.')
   35 format(11x,' Final Fom ',f7.3,' RELAX fault ',
     *     '(previous value ',f7.3,').')
!  35 format(2x,' Final Fom ',f7.3,' RELAX fault ',
!    *     '(threshold value',f7.3,' - previous value',f7.3,').')
   36 format(11x,' Relax Fom ',f7.3,' RELAX fault ',
     *     '(comparison value',f7.3,').')
   37 format(11x,' No peaks found, Relax aborted')

   98 format(//,11x,' Back in ',a,'. Translation applied:',3f8.4)
   99 format(11x,' RELAX procedure: translation applied:',3f8.4)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine DefineBlocksEtc()
      USE General
      USE Symmetry
      USE PhaseModule
      USE RfacMatrixModule
      USE VLDmod
!
      if (kmad == 0 ) then
          if (ifTang == 0) then
              nBlocksPh = 1
              jBlocksPh(1,1) = n_Maxrun
              jBlocksPh(2,1) = n_Maxrun
              ifRelax = 1
          else
              if (ksize == 1 ) then
                  nBlocksPh = 3
                  jBlocksPh(1,1:nBlocksPh) = 100
                  jBlocksPh(2,1) = 50
                  jBlocksPh(2,2) = 65
                  jBlocksPh(2,3) = 80
              elseif ( ksize == 2) then
                  nBlocksPh = 3
                  jBlocksPh(1,1:nBlocksPh) = 100
                  if (neutro == 2) then
                      nBlocksPh = 1
                      jBlocksPh(2,1) = 100
                  else
                      jBlocksPh(2,1) = 10
                      jBlocksPh(2,2) = 20
                      jBlocksPh(2,3) = 30
                  endif
                  ifEnve = 0
                  ifPost = 0
              elseif ( ksize == 3 ) then
                  if (neutro == 2) then
                      nBlocksPh = 1
                      jBlocksPh(1,1) = 250
                      jBlocksPh(2,1) = 250
                  else
                      nBlocksPh = 5
                      jBlocksPh(2,1) = 25
                      jBlocksPh(2,2) = 50
                      jBlocksPh(2,3) = 75
                      jBlocksPh(2,4) = 100
                      jBlocksPh(2,5) = 150
                      jBlocksPh(1,1:nBlocksPh) = 
     *                          jBlocksPh(2,1:nBlocksPh)*10
                  endif
                  if (ifCycTang == 1) then
                      jBlocksPh(2,1:nBlocksPh) = 50
                  endif
              else
                  nBlocksPh = 3
                  jBlocksPh(1,1:nBlocksPh) = 500
                  if (LowRes == 0) then
                      jBlocksPh(2,1:nBlocksPh) =  50
!                     if (no(nk) < 16) then
                      if (no(nk) < 20) then
                          jBlocksPh(2,1:nBlocksPh) = 100
                      endif
                  else
                      jBlocksPh(2,1:nBlocksPh) = 100
                  endif
                  if (ifCycTang == 1) then
                      jBlocksPh(2,1:nBlocksPh) = 50
                  endif
              endif
          endif
      elseif (kmad == 1) then
          nBlocksPh = 1
          if (ksize <= 3) then
              jBlocksPh(1,1) = 60
              jBlocksPh(2,1) = 30
          else
              jBlocksPh(1,1) = 200
              jBlocksPh(2,1) = 60
          end if
      elseif (kmad == 2) then
          nBlocksPh = 1
          jBlocksPh(1,1) = 100
          jBlocksPh(2,1) = 10
      endif
!
      if (nsym == 1 .and. icent == 0) then
          ifRelax = 0
      endif
!
      return 
      end
!-----------------------------------------------------------------------
      subroutine DefineEtc(ifPeak, kdsrReq)
      USE General
      USE Symmetry
      USE PhaseModule
      USE VLDmod_1 , only : ksigma_pg
      USE VLDmod_3 
!
      if (ksize <= 2) then   ! small
          nBlockEDM = 1
          isma = 1
          ismah = 0
          nMacroTot = 3
          nMicro = 3
          ifRescale = 0   
          if (LowRes == 1) ifRescale = 1 ! dedi
          if97 = 1
          ntrRelax=1
*         if (ifVLD == 0) then
*             ifRelax = -1
*         endif
          ifHafr = 1
          ifPDBfiles = 0

          if (ifVLD == 0) then  ! nuovo DSR per micro e piccole
              nBlockEDM = 2
              nMacroTot = 4
              nMicro = 3
          endif

      elseif (ksize == 3) then   ! medie
          nBlockEDM = 3
          isma = 2
          ismah = 0
          nMacroTot = 9
          nMicro = 5
          if(ifPatt==0) then
            ntrRelax = 5  
          else
            ntrRelax = 1
          endif
          ifRescale = 1
          if97 = 2
          ifHafr = 1
*         if (ifVLD == 0) then
*             ifRelax = -1
*         endif
          ifPDBfiles = 0
      elseif (ksize.ge.4) then   ! proteins
          nBlockEDM = 5
          isma = 4
          ismah = 2
          nMacroTot = 15
          nMicro = 7
          ntrRelax = 10  !KUKU
c         ntrRelax=9999
          ifHafr = 0
*         if (ifVLD == 0) then
*             ifRelax = -1
*         endif
      endif
!

corig if (ifVLD == 0) then
      if (ifVLD == 0 .and. kdsrReq /= 2) then
          if (ksizeReq == 1 .and. ifPeak == 0) then
              if (ifPatt == 1) then
                  call DefinePattTrials()
              elseif (ifPatt == 0) then
                  call DefineBlocksEtc()
              endif
          endif
      endif

!
      if (if97 == 1) then
          nBlockEDM_UnRel = nBlockEDM
          nMacroTot_UnRel = nMacroTot
          nBlockEDM_Relax = nBlockEDM * 2
          nMacroTot_Relax = nMacroTot * 2
      endif
!
      if (ksize <= 3 ) then
          ifMadEnv = 0
          ifEnve = 0
          ifPost = 0
      else
          ifMadEnv = 2
*         if (kmad == 0  .and. ifEnve >= 0) then      !120105   enveReq = -1: noenve
          if (kmad == 0) then      !160609   enveReq = -99
             ifEnve = 1
          end if
      endif
!
      if (kmad == 0 .and. ksize <= 3) then   ! Resol. Bias  ??
          if (anat > 10 .and. LowRes == 1 .and. numbGen > 0) then
              ifNewPsi0 = 1  ! impongo l'uso delle psi0
          endif
      endif

      if (kmad /= 0 .or. ksize <= 3) then
          ifCombinedFom = 0
      endif
!
      if (ifEnve < 0) then
          ifEnve = 0
      endif

      if (kmad.ne.0) then
          ifMadEnv = 2
          ifRelax = -2
          relaxReq = ifRelax
          ifEnve = 0
          ifPost = 0
      endif
!
      if (nsym == 1) then
          if (icent == 0) then
              if (ifRelax >= 0) write(lo,9001)
              ifRelax = -2
              relaxReq = ifRelax
          endif
      endif
!
      if (ifVLD == 1) then ! per definire il valore di ksigma_pg
          ksigma_pg = 0
      else
!----------------------------------
!Inizializzazione variabili per VLD
!----------------------------------
          rfac_init = 0.
          rfac_10EDM = 0.
          Rat_VLD = 0. 
          sigmaA_init = 0.
          numero_cicli = 0
c         ksigma_pg = ksigma
          ksigma_pg =  0  ! come VLD perugini
!----------------------------------
      endif
 9001 format(/,' *** WARNING *** ',
     *         ' Automatic Relax Procedure not applied in P 1',/)
!
      return 
      end
!-----------------------------------------------------------------------
      subroutine DefinePattTrials()
      USE General
      USE Symmetry, only: jsys, nsym, icent
      USE PhaseModule
      USE MappaPatterson, only: iesCmap, iesSnip
!
      integer :: step
!
      step = 5
      ifCombinedFom = 0
      if (kmad == 0) then

! - dedi

         if (ksize <= 2) then
             nPattpks = 25
             step = 12
         elseif (ksize == 3) then
             nPattpks = 50
             step = 10
         else
             nPattpks = 100
             step = 5
         endif
    
         if (nPattpksReq > 0) then
             nPattpks = nPattpksReq
         endif

!!!      if (ksize > 3 ) then
             nBlocksPh = 0
             npks = nPattpks - 1   ! tolgo il primo picco
!
             if (npks > 145) then
                 step = npks / 29 + 1
             endif
!
             if (npks > 0) then
                 nBlocksPh = npks / step
                 if (mod(npks,step) /= 0) then
                 nBlocksPh = nBlocksPh + 1
                 endif
             endif

             nBlocksPh = nBlocksPh + 1 ! aggiungo il primo blocco sul trial 1
             jBlocksPh(1,1) = 1
             jBlocksPh(2,1) = 1

             if (nBlocksPh > 1) then
                 npks = 1
                 do i = 2,nBlocksPh - 1     ! blocchi di 5 trials
                    jBlocksPh(1,i) = step
                    jBlocksPh(2,i) = step
                    npks = npks + step
                 enddo
        
                 jBlocksPh(1,nBlocksPh) = nPattpks - npks
                 jBlocksPh(2,nBlocksPh) = nPattpks - npks
             endif

!!!      else
!!!          nBlocksPh = 1 ! un solo blocco per small/med
!!!          jBlocksPh(1,1) = nPattpks
!!!          jBlocksPh(2,1) = nPattpks
!!!      endif
! - dedi

      elseif (kmad == 1) then
          nBlocksPh = 1
          if (nPattpksReq > 0) then
              nPattpks = nPattpksReq
              jBlocksPh(1,1) = nPattpksReq
              jBlocksPh(2,1) = nPattpksReq
          else
              if (ksize <= 3) then
                  jBlocksPh(1,1) = 30
                  jBlocksPh(2,1) = 30
              else
                  jBlocksPh(1,1) = 60
                  jBlocksPh(2,1) = 60
              end if
         endif
      elseif (kmad == 2) then
          nBlocksPh = 1
          jBlocksPh(1,1) = 30
          jBlocksPh(2,1) = 30
      endif
!
!- istruzioni per uso Snip e Cmap
!
      noModSnip = 0
      if (kmad == 0) then
        if (ksize > 3) then

          if (LowRes == 0) then
              iesCmap = 0
              iesSnip = 0 
!-- inserisco chiamata a SNIP
!!!           if (iheavy == 0) then  ! HA < Ca
!!!               iesSnip = 1
!!!               noModSnip = 1
!!!           endif
!-- 
              if (nsym == 1 .and. icent == 0) then
                  iesSnip = 1
              endif
          else
c             if (no(nk) < NumeroAtomico) then
              if (iheavy == 0) then
                  iesCmap = 0
                  iesSnip = 0
                  if (nsym == 1 .and. icent == 0) then
                      iesSnip = 1
                  endif
              else
                  iesCmap = 1
                  iesSnip = 1
              endif
          endif
        else
            iesSnip = 0
            iesCmap = 3  !0
        endif
!- non applico SNIP per alte simmetrie
        if (noModSnip == 0) then
            if (jsys > 3) iesSnip = 0 
        endif
!- non applico SNIP e CMAP per gli elettroni
        if (neutro /= 0) then
            iesSnip = 0 
            iesCmap = 0
        endif
!
      endif

      return 
      end
!-----------------------------------------------------------------------
      subroutine DefinePattTrials_pFom()
      USE General
      USE Symmetry, only: jsys, nsym, icent
      USE PhaseModule
      USE MappaPatterson, only: iesCmap, iesSnip
!
      ifCombinedFom = 0
      if (kmad == 0) then
          if (ksize <= 2) then
              nBlocksPh = 2
              jBlocksPh(1,1) = 1
              jBlocksPh(2,1) = 1
              if(jsys==1) then
                jBlocksPh(1,2) = 15
                jBlocksPh(2,2) = 15
              else
                if(no(nk)>20) then
                  jBlocksPh(1,2) = 10
                  jBlocksPh(2,2) = 10
                else
                  jBlocksPh(1,2) = 40
                  jBlocksPh(2,2) = 10
                endif
              endif
          elseif (ksize == 3) then
              nBlocksPh = 2
              jBlocksPh(1,1) = 1
              jBlocksPh(2,1) = 1
              if(jsys==1) then
                jBlocksPh(1,2) = 35
                jBlocksPh(2,2) = 15
              else
                if(no(nk)>20) then
                  jBlocksPh(1,2) = 30
                  jBlocksPh(2,2) = 20
                else
                  jBlocksPh(1,2) = 80
                  jBlocksPh(2,2) = 60
                endif
              endif
c         elseif(LowRes==0.and.ksize<6) then!KUKU
c             nBlocksPh = 5
c             jBlocksPh(1,1) = 1
c             jBlocksPh(2,1) = 1
c             jBlocksPh(1,2) = 4 !2
c             jBlocksPh(2,2) = 4 !2
c             jBlocksPh(1,3) = 10!9
c             jBlocksPh(2,3) = 10!9
c             jBlocksPh(1,4) = 30
c             jBlocksPh(2,4) = 30
c             jBlocksPh(1,5) = 240
c             jBlocksPh(2,5) = 80
c             if (nsym == 1 .and. icent == 0) jBlocksPh(2,5) = 240 !P1

c         else
c             nBlocksPh = 7
c             jBlocksPh(1,1) = 1
c             jBlocksPh(2,1) = 1
c             jBlocksPh(1,2) = 4 !2
c             jBlocksPh(2,2) = 4 !2
c             jBlocksPh(1,3) = 10!9
c             jBlocksPh(2,3) = 10!9
c             jBlocksPh(1,4) = 60
c             jBlocksPh(2,4) = 25!24
c             if (nsym == 1 .and. icent == 0) jBlocksPh(2,4) = 60 !P1
c             jBlocksPh(1,5) = 180
c             jBlocksPh(2,5) = 75!72
c             if (nsym == 1 .and. icent == 0) jBlocksPh(2,5) = 180 !P1
c             jBlocksPh(1,6) = 360
c             jBlocksPh(2,6) = 75!72
c             if (nsym == 1 .and. icent == 0) jBlocksPh(2,6) = 360 !P1
c             jBlocksPh(1,7) = 360
c             jBlocksPh(2,7) = 75!72
c             if (nsym == 1 .and. icent == 0) jBlocksPh(2,7) = 360 !P1

! -- per le proteine esploro max 100 picchi  (Carmelo 14/01/14)

          else 
              nBlocksPh = 10
              jBlocksPh(1,1) = 1
              jBlocksPh(2,1) = 1
              jBlocksPh(1,2) = 5 !2-6 !!!4  !2-5
              jBlocksPh(2,2) = 5 !4
              jBlocksPh(1,3) = 9 !7-15  !!!10 !6-15
              jBlocksPh(2,3) = 9 !10
              jBlocksPh(1,4) = 15 !16-30
              jBlocksPh(2,4) = 15
              jBlocksPh(1,5) = 20 !31-50
              jBlocksPh(2,5) = 20
              jBlocksPh(1,6) = 25 !51-75
              jBlocksPh(2,6) = 25
              jBlocksPh(1,7) = 25 !76-100
              jBlocksPh(2,7) = 25
!             jBlocksPh(1,8)  = 50 !101-150
!             jBlocksPh(2,8)  = 25
!             jBlocksPh(1,9)  = 50 !151-200
!             jBlocksPh(2,9)  = 25
!             jBlocksPh(1,10) = 100!201-300
!             jBlocksPh(2,10) = 25
          endif

!- dedi prova per esplorare ogni singolo trial (Patterson + DSR)

*             nBlocksPh = 100
*             do i = 1,nBlocksPh
*                jBlocksPh(1,i) = 1
*                jBlocksPh(2,i) = 1
*             enddo

! - dedi

      elseif (kmad == 1) then
          nBlocksPh = 1
          if (ksize <= 3) then
              jBlocksPh(1,1) = 30
              jBlocksPh(2,1) = 30
          else
              jBlocksPh(1,1) = 60
              jBlocksPh(2,1) = 60
          end if
      elseif (kmad == 2) then
          nBlocksPh = 1
          jBlocksPh(1,1) = 30
          jBlocksPh(2,1) = 30
      endif
!
!- istruzioni per uso Snip e Cmap
!
      noModSnip = 0
      if (kmad == 0) then
        if (ksize > 3) then

          if (LowRes == 0) then
              iesCmap = 0
              iesSnip = 0 
              if (iheavy == 0) then  ! HA < Ca
                  iesSnip = 1
                  noModSnip = 1
              endif
              if (nsym == 1 .and. icent == 0) then
                  iesSnip = 1
              endif
          else
c             if (no(nk) < NumeroAtomico) then
              if (iheavy == 0) then
                  iesCmap = 0
                  iesSnip = 0
                  if (nsym == 1 .and. icent == 0) then
                      iesSnip = 1
                  endif
              else
                  iesCmap = 1
                  iesSnip = 1
              endif
          endif
        else
            iesSnip = 0
            iesCmap = 3  !0
        endif
!- non applico SNIP per alte simmetrie
        if (noModSnip == 0) then
            if (jsys > 3) iesSnip = 0 
        endif
!- non applico SNIP e CMAP per gli elettroni
        if (neutro /= 0) then
            iesSnip = 0 
            iesCmap = 0
        endif
!
      endif

      return 
      end
!-----------------------------------------------------------------------
      subroutine ControllaAtomiPesanti(NumPeso)
      USE General
      USE Symmetry
      USE PhaseModule
!
!-- Controllo su esistenza atomo pesanti per proteine
!-- Per i neutroni assumiamo che non ci sono atomi pesanti
!
      is3s2=1./(s3s2*s3s2)+0.5
      iwei = 0
      iheavy=0
      NumPes  = 0
      NumPeso = 0
      NumeroAtomico = 20  !(calcio)
      NumeroZolfo = 15    !(fosforo) 
      NumPes1 = 0
      NumPes2 = 0
!
!
      if (nk > 0 .and. no(nk) >= NumeroAtomico) iheavy=1
!
      if (neutro /= 1 .and. ksize > 3) then

          if (nk > 2 .and. no(nk) >= NumeroAtomico) then
              NumPes1 = nint(nw(nk) / totop)
              iwei = 1
              idelwei1 = no(nk) - no(nk-1)

!             if (no(nk-1) >= NumeroAtomico) then    ! dedi 11/03/13
              if (no(nk-1) > NumeroZolfo) then    
!                 idelwei2 = no(nk-1) - no(nk-2)
!                 if (idelwei2.gt.3) then
                      iwei = 2
                      NumPes2 = nint(nw(nk-1) / totop)
!                 endif
              endif

!     write(6,*) 'Controlla HA =', iwei,idelwei1,idelwei2,no(nk-2:nk)
              NumPeso= NumPes1 + NumPes2
              pip = 1.0
              if (NumPeso.le.6) then
                  pip = 1.5
              else
                  pip = 1.3
              endif
!     write(6,*) 'Controlla HA =', NumPes1, NumPes2, pip
              NumPes1 = nint(float(NumPes1) * pip)
              NumPes2 = nint(float(NumPes2) * pip)
              NumPes = NumPes1 + NumPes2
c     write(6,*) 'Controlla HA =',iwei,NumPeso,NumPes,NumPes1,NumPes2
          endif
!
!-- dedi -- stima atomi P,S,Cl
!
          if (nk > 2 .and. no(nk) >= NumeroZolfo .and.
     *                             no(nk) < NumeroAtomico) then
             iwei = 0
             NumPeso = nint(float(nw(nk)) / totop)
             NumPes  =  NumPeso * 2
c     write(6,*) 'Controlla HA =',iwei,NumPeso,NumPes,nw(nk),totop
          endif

      endif
!
      is3s2=1./(s3s2*s3s2)+0.5
c
      return
      end
!-------------------------------------------------------------------------------
      subroutine CalcolaBarra()
      USE General
      USE PhaseModule
!
*gl*  common /cBarra/ nbarra, npercB, perc0B, percB, iipercB, jpercB
!
      ismaSav  = isma
      ismaSavh = ismah
      if (ifReduced == 1 .and. ksize > 3) then
          nbarra =  nMacroTot * nMicro
          return
      endif
   

      go to 1


      if (Iterazione == 0) then
          nmacroBarra = nMacroTot
      else
          if (ntrSv <= ntrRelax) then
              nmacroBarra = nMacroTot
          endif
      endif

    1 continue


      nmacroBarra = nMacroTot


      ninver = nmacroBarra * nMicro
      if (ksize == 1) then
          ninver = 0
          ndefstra =  6 + 1 
          nprebm = 0
      elseif (ksize.le.3) then
          ndefstra =  6 + 1 
          nprebm = 0
      else
          ndefstra =  5 + 1
          if (iwei > 0) then
              if (ksize == 4) then
                  kfin = 2
              else
                  kfin = 3
              endif
          else
              kfin = 0
          endif
          nprebm = ismah * kfin
      endif
      nbarra = ninver + isma * ndefstra + nprebm
      if (ifPost == 1 .and. Iterazione == 0) then
          nbarra = nbarra + ninver / nBlockEDM
      endif
      if (ifRemo == 1) then
          nbarra = nBlockEDM
      endif
!     write(6,*) 'CalcolaBarra: ',ninver, isma*ndefstra, nprebm, nbarra
!     write(0,*) 'CalcolaBarra: ',ninver, isma*ndefstra, nprebm, nbarra
      isma  = ismaSav
      ismah = ismaSavh
!
      return
      end
!-----------------------------------------------------------------------
      subroutine ManageEarlyFom(eFom, corre, er_tang)
      USE General
      USE Symmetry
      USE Molcom
      USE PhaseModule
      USE RfacMatrixModule
!
!-- Early Foms Management
!
      if (eFom.ge.fomBestE) then
          fomBestE = eFom
      endif
      eFOM_MDM = eFom
!

      if (jrest /= 2) then
          jRfac = jRfac + 1
          if (jRfac > NumbMaxRfac) then
              if (eFom > FomsMin) then
                  kRfac = kFomsMin
                  RfacMatrix(2,kRfac,jBlock) = eFom
                  FomsMin = 999999
                  do i=1, NumbMaxRfac
                     if (FomsMin > RfacMatrix(2,i,jBlock)) then
                         FomsMin = RfacMatrix(2,i,jBlock)
                         kFomsMin = i
                     endif
                  enddo
              else
                  kRfac = 0
              endif
          else
              kRfac = jRfac
              if (eFom < FomsMin) then
                  FomsMin = eFom
                  kFomsMin = kRfac
              endif
          endif
      else
          kRfac = jRfac
      endif
      if (kRfac > 0) then
          RfacMatrix(1,kRfac,jBlock) = numbrun
          RfacMatrix(2,kRfac,jBlock) = eFom
!         RfacMatrix(3,kRfac,jBlock) = -1.0
          RfacMatrix(3,kRfac,jBlock) = -9999.9    !!!<<<
*         RfacMatrix(4,kRfac,jBlock) = 100
          RfacMatrix(4,kRfac,jBlock) = -99
          RfacMatrix(5,kRfac,jBlock) = er_tang
          RfacMatrix(6,kRfac,jBlock) = erore
          RfacMatrix(7,kRfac,jBlock) = erorepes
          RfacMatrix(8,kRfac,jBlock) = corre

!!060711          if (MaxToStore > 1 .or. ifPatt == 1 .or. ifMadEnv > 0) then
          if ((MaxToStore > 1 .or. nBlocksPh > 1) .or. 
     *        (ifPatt == 1 .and. ifMadEnv > 0)) then
              if (ifTang > 0 .or. ifMadEnv > 0) then
                  iAction = 1
                  npunti = 1
                  if (ifPatt /= 1. and. ifMDM == 0) then
                      call DataForGraph(iAction, npunti)
                  endif
              endif
          endif
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine PresigmaA(jflag, ifLinear)
      USE General
      USE Symmetry
      USE Riflessi
*     USE RiflessiSIGMAA
      USE PhaseModule
      USE RuotaRiflessi
      USE RemoModule
!
      kverboOld = kverbo
c      kverbo = 1 
      iworkt(:) = iphaz(:)
      if (knw > 0) then
          call Trasla_Origine(nrefl)
      endif
canna
      if(use_E)then
         nreflsav = nrefl
c        nrefl=nreflSelTra
         nrefl=nreflSelRemo
      endif
canna  
!
!--non considero i valori di sigma nel calcolo della
!  sigmaA se questi non hanno significato fisico
!
      if (ifVLD == 0) then
          if (ksigma <= 0) then
             ifnoEE = 1  ! originale
          else
             ifnoEE = 0  ! originale
          endif
      endif
      if(ksigma<=0) ifnoEE=1
      if (ifnoEEReq == 1)  ifnoEE=1  ! richiesto da direttiva
!     if (knw == 1) then
!         write(6,*) ' SigmaA , ifnoEE =',ifnoEE
!     endif
!
!-- pesMod contiene il nuovo peso Sim
!
      if (kmad /= 0) then
          iphaz_in(1:nreflDim) = iphaz(1:nreflDim)
          wt_in(1:nreflDim) = wt(1:nreflDim)
      endif
      call sigmaA(jflag,fovet,sigmav,evet,mkang,rhov,epsv,fcvet,
     *         ipub,iphaz,wt, iphaz_in, wt_in, wvar, pesMod, Dluz,
     *         varia, varia, nreflDim, nrefl, ifPert, kverbo, ifLinear)
canna
      if(use_E) nrefl=nreflsav
canna
      if (ifPert == 0) then
          iphaz(:) = iworkt(:)
      endif
      kverbo = kverboOld
!
      return
      end
!-----------------------------------------------------------------------
      subroutine F2ENew(iniz,ifin)
c
      USE General
      USE Symmetry
      USE Riflessi
c
!-- trasformo gli F in E 
!          utilizza fcvet --> fcvetv
      zero = 0.0000000001
c
!     iniz = nrefl+1
!     ifin = nreflTot
      do i=iniz,ifin
         fo = fcvet(i)
!
!!!!     if (fo < zero) fo = 0.0     ! per non considerare valori di fcvet p.es. = -999.0
!
         rho = rhov(i)
         eps=epsv(i)
         multi=mult(i)
         ff0   = fo * fo / pts
         sinth=100.0*sqrt(rho)
         ind=max0(2,int(sinth+1.5))
         frac=sinth-float(ind-1)
         bf=0.5*(giw(ind+1)-giw(ind-1))
         af=bf+giw(ind-1)-giw(ind)
         form=af*frac*frac+bf*frac+giw(ind)
         denor=form*eps
         ed = ff0/denor
         esq=sc*ed*exp(2.*bt*rho)
c           write(687,'(i10,4f15.8)') i,fovet(i),evet(i),sqrt(esq),
c    &                  0.5/sqrt(rho)
         fcvetv(i)=sqrt(esq)   ! E calcolati
      enddo
c
      return
      end
!-----------------------------------------------------------------------
      subroutine E2FNew(iniz,ifin)
c
      USE General
      USE Symmetry
      USE Riflessi
!
!-- trasformo gli E (work1) in F (work2)
!
      do i=iniz,ifin
         ec    = work1(i)
         ec2   = ec * ec
         rho   = rhov(i)
         eps   = epsv(i)
         multi = mult(i)
         sinth = 100.0 * sqrt(rho)
         ind   = max0( 2, int(sinth + 1.5) )
         frac  = sinth - float( ind - 1 )
         bf    = 0.5 * ( giw(ind+1) - giw(ind-1) )
         af    = bf + giw(ind-1) - giw(ind)
         sigma = af * frac * frac + bf * frac + giw(ind)
         denor = sc * exp( 2.0 * bt * rho )
         fo    = sqrt( ec2 * pts * eps * sigma / denor )
         work2(i) = fo   ! F calcolati
      enddo
!
      return
      end
!-----------------------------------------------------------------------
!      HISTOGRAM MATCHING PROCEDURE
! -----------------------------------------------------------------
      subroutine InitHistMatchObs(ntot)
      USE General
      USE Riflessi
      USE HistoStuff
      USE PhaseModule

c -- controllare l'uso per piccole e medie -  ksize <= 3

      if (ksize == 1) then ! dedi
          nwizm=10  ! micro
      elseif (ksize < 4) then
          nwizm=15  ! small/medium
      else
          if (nstr < 1000) then
              nwizmT=15  ! proteins very low resolution
          else
              nwizmT=25  ! proteins
          endif

          nwizm=25  ! proteins
      endif

      nden =  nstr / 10
      if (nden == 0) nden = 1
      nsip = nrefl / nden
      if (nsip > 498) nsip = 498   ! numero di intervalli  - max. 500
      nwiz = 0
      do while (nwiz < nwizm)
         nwiz=nint(float(nrefl)/float(nsip))
*        nsip=nint(float(nrefl)/float(nwiz))
         if (nwiz.lt.nwizm) then
             nsip=nint(float(nsip)/2.0)
         endif
      enddo
      nwizl=nrefl-nwiz*(nsip-1)
!
      iprint = 0
      if (iprint == 1) then
        write(lo,*)'*********************************************'
        write(lo,*)'*      HISTOGRAM MATCHING PROCESS           *'
        write(lo,*)'*********************************************'
        write(lo,1000)nsip,nwiz,nwizl,nrefl
      endif
 1000 format (10x,'Nr. areas ....................',i6,/,
     +        10x,'Nr. ref. in one area .........',i6,/,
!orig+        10x,'Nr. ref. in the last area ....',i6,/,
     +        10x,'Nr. ref. in the first area ...',i6,/,
     +        10x,'Nr. reflections ..............',i6,/)
      if (knw == 1) then
         call toflush()
      endif
      ntot = nrefl
      isort = -1
      do i=1,ntot 
         hisobco4(1,i)=vetmatchin(i)**2   ! vetmatchin = evet
      enddo

!------------ Vettore di riferimento (Eobs)----------------------

      do i=1,nsip+2
         xoss_Obs(i)=0.0
      enddo
      call sortall2(hisobco4,4,1,ntot,ntot,isort)
      rmin= hisobco4(1,1)
      rmax= hisobco4(1,ntot)
      xoss_Obs(1)=rmin
      xoss_Obs(nsip+1)=rmax
      ic=0
      ii=1
      do i=1,ntot
         if (ii.eq.1) then
             nwizj=nwizl
         else
             nwizj=nwiz
         endif
         ic=ic+1
         if (ic.eq.nwizj) then
            ii=ii+1
            xoss_Obs(ii)=hisobco4(1,i)
            ic=0
         endif
      enddo
!
      return
      end
! ----------------------------------------------------------------------
      subroutine HistMatchObs()

      USE General
      USE PhaseModule
      USE Riflessi
      USE HistoStuff


! -- attenzione: riempire sempre il vettore di appoggio
! -- evet       = vettore di riferimento (Eobs)
! -- fcvet      = vettore da modificare  (Ecal)
! -- vetmatchin = vettore    modificato  (Ecal**2)

!
      ntot  = nrefl
      isort = -1 
      do i=1,ntot
        hisobco4(2,i)=vetmatchin(i)**2   ! vetmatchin = fcvet
        hisobco4(3,i)=float(i)
        hisobco4(4,i)=0.0
      enddo

!------------ Vettore da riscalare (Ecal)----------------------
      do i=1,nsip+2
         xcalc(i)=0.0
      enddo
      call sortall2(hisobco4,4,2,ntot,ntot,isort)
      rmin= hisobco4(2,1)
      rmax= hisobco4(2,ntot)
      xcalc(1)=rmin
      xcalc(nsip+1)=rmax
      ic=0
      ii=1
      do i=1,ntot
         if (ii.eq.1) then
             nwizj=nwizl
         else
             nwizj=nwiz
         endif
         ic=ic+1
         if (ic.eq.nwizj) then
            ii=ii+1
            xcalc(ii)=hisobco4(2,i)
            ic=0
         endif
      enddo
!
!---  shift della curva exp. --------------------
      call match12_Obs()

!---  calc. nuovi valori osservati
      call newvalue_Obs(ntot,isort)

      call sortall2(hisobco4,4,3,ntot,ntot,isort)
!     write(6,*) 'Dopo newvalue_Obs'
      do i=1,ntot
!       write(6,'(i6,3f15.4)')i,fcvet(i)**2,evet(i)**2,hisobco4(4,i)
        vetmatchin(i)=hisobco4(4,i)    ! fcvet riscalato
      enddo

      return
      end
! ----------------------------------------------------------------------
      subroutine HistMatchObsDedi()

      USE General
      USE Riflessi
      USE HistoStuff
      USE PhaseModule
!
! -- attenzione: riempire sempre il vettore di appoggio
! -- evet       = vettore di riferimento (Eobs)
! -- fcvet      = vettore da modificare  (Ecal)
! -- vetmatchin = vettore    modificato  (Ecal**2)

!
      ntot  = nrefl
      isort = -1 
      do i=1,ntot
        hisobco4(2,i)=vetmatchin(i)**2   ! vetmatchin = fcvet
        hisobco4(3,i)=float(i)
        hisobco4(4,i)=0.0
      enddo

!------------ Vettore da riscalare (Ecal)----------------------
      do i=1,nsip+2
         xcalc(i)=0.0
      enddo
      call sortall2(hisobco4,4,2,ntot,ntot,isort)
      rmin= hisobco4(2,1)
      rmax= hisobco4(2,ntot)
      xcalc(1)=rmin
      xcalc(nsip+1)=rmax
      ic=0
      ii=1
      do i=1,ntot
         if (ii.eq.1) then
             nwizj=nwizl
         else
             nwizj=nwiz
         endif
         ic=ic+1
         if (ic.eq.nwizj) then
            ii=ii+1
            xcalc(ii)=hisobco4(2,i)
            ic=0
         endif
      enddo

!merge!! riordiniamo per i dati osservati
!merge!call sortall2(hisobco4,4,1,ntot,ntot,-1)
       call sortall2(hisobco4,4,3,ntot,ntot,isort)

!
!---  shift della curva exp. --------------------
      call match12_Obs()

!---  calc. nuovi valori osservati
      call newvalue_Obs(ntot,isort)

!     write(6,*) 'Dopo newvalue_Obs'
      do i=1,ntot
!       write(6,'(i8,3f15.4)')i,fcvet(i)**2,evet(i)**2,hisobco4(4,i)
        vetmatchin(i)=hisobco4(4,i)    ! fcvet riscalato
      enddo

      return
      end
!-----------------------------------------------------
      subroutine match12_Obs()
      USE PhaseModule
!      
      do 10 i=1,nsip
         domin = xcalc(i+1)-xcalc(i)
         if (domin > 0.00000001) then
             ai(i) = (xoss_Obs(i+1)-xoss_Obs(i))/domin
             bi(i) = ((xoss_Obs(i)*xcalc(i+1))-
     *                (xoss_Obs(i+1)*xcalc(i)))/domin
         else
             ai(i) = 0.0
             bi(i) = 0.0
         endif
!        xhist(i)=ai(i)*xcalc(i)+bi(i)
!        xhist(i+1)=ai(i)*xcalc(i+1)+bi(i)
!     write(6,'(i8,5f10.5)')i,xcalc(i),xoss_Obs(i),ai(i),bi(i),xhist(i)
 10   continue
      return
      end
!-----------------------------------------------------------------------
!     Calcolo dei nuovi valori per HISOB (usare la scala-ai e lo shift-bi)
!-----------------------------------------------------------------------
      subroutine newvalue_Obs(ntot,isort)
      USE HistoStuff
      USE PhaseModule
!
      call sortall2(hisobco4,4,2,ntot,ntot,isort)
      isip=2
!     write(6,*) 'Newvalue_Obs'
      do i=1,ntot
         if (hisobco4(2,i).le.xcalc(isip)) then
             hisobco4(4,i)=ai(isip-1)*hisobco4(2,i)+bi(isip-1)
         else
             isip=isip+1
             hisobco4(4,i)=ai(isip-1)*hisobco4(2,i)+bi(isip-1)
         endif
!        write(6,'(i6,4f10.4)')isip,hisobco4(2,i),ai(isip-1),
!    *                              bi(isip-1),hisobco4(4,i)
      enddo 

      return
      end
c-----------------------------------------------------------------------
      subroutine SviluppaUnTrial(AllInMemory, ier)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Molcom
      USE Grafici
      USE Html
      USE Param
      USE RemoModule
      USE PhaseModule
      USE RfacMatrixModule
!
*gl*  common /cBarra/ nbarra, npercB, perc0B, percB, iipercB, jpercB
      integer WhichSet
      integer AllInMemory
      character TFom *9     !140105
!pg080906
!
      call RoutineHeader('Develop')
!
      call AllocaRiflessi(2)
      call LoadReflInfo
      reflDim = nrefltot
      call AllocaRiflessi(1)
      ksubr = 3
      call LeggiRiflessi(ier,ksubr)
!
      kSave1 = nrefltot
      call GetMad
      nrefltot = kSave1
!
      kBox = 2
      if (AllInMemory == 0) then
          kBox = 1
          call PutAllInMemory
          Msg = "<big><b>Initial phasing:</b></big>"
          call TestoGR(Msg, color_RED, 2, kBox)
      endif
      call DoAllGraphs()
      call DistruggiPianiAll
      corre = 0.0
      nSetStored = nset
      call LoadInitialPhases(cfom, ipos, nset)
      nSetStored = nset
      if (InfoOK(16).gt.0) then
          nSetStored = nset
          iOK = 0
          do j=1,nSetStored
             if (cfom(j) > 0.0) then
                 iOK = 1
                 exit
             endif
          enddo

****             iOK = 1

          if (iOK == 0) then
              Msg = 'All sets have been already examined. Program stops'
              call TestoGR(Msg, color_LIGHTRED, 2, kBox)
              call MsgWinErr('Info', Msg, INFO_WINDOW, nExitCode)
              ier = -1
              return
          endif
      else
          call MsgWinErr('ERROR', 'No sets of phases available', 
     *                   ERR_WINDOW, nExitCode)
          ier = -1
          return
      endif
   
      if (ilMilione == 2) then
          write(TFom,'(i5)') nSetStored 
          call shift(TFom, lstr)
          write(Msg,34) TFom(1:lstr)
          call TestoGR(Msg, -1, 2, kBox)
      endif
   34 format('Only one of the ',a,' requested trials will be processed')
 
 
      kfast = 0
      ifBreak = 0
      ifP1 = nsym*(icent+1)
!pgMAD1011
      if (ifRidotta == 0) then
          write(Msg,31)
          call TestoGR(Msg, -1, 2, kBox)
      end if
   31 format('The Electron Density Modification procedure will be',
     *        ' performed.')
      call numbMAD(numbLSQ,ifRidotta,nn2,numb7)
      write(Inte,'(i10)') numb7
      call shift(Inte, k)
      write(Msg,1) Inte(1:k)
      k1 = index(Msg,'refine the') + 10
      call TestoGR(Msg(1:k1), -1, 2, kBox)
      call TestoGR(Msg(k1+1:), -1, 2, kBox)
*     write(Msg,3)
    1 format('For each selected trial, ',a,' reflections are used to',
     *       ' locate and refine the anomalous substructure.')
    3 format('The best trials will have ',
     *       'the smallest value of the ratio R% / f FOM.')
!pgMAD1011
!
      kBox = kBox + 1
      Msg = "<big><b>Phase refinement and extension:</b></big>"
      call TestoGR(Msg, color_RED, 2, kBox)
!
      WhichFom = 3
      NWF = WhichFom
      WhichFom = 2
      call DisegnaMad(1)
      nMessages = nMessages + 3
      evet_med = 0.0
      sigmav_med = 0.0
      do i=1,nreflTot
         evet_med = evet_med + evet(i)
         sigmav_med = sigmav_med + sigmav(i)
      end do
      evet_med = evet_med / nreflTot
      sigmav_med = sigmav_med / nreflTot
!      if (knw>0) write(lo,'(/,a,2f15.8,/)')         !pgMAD290409
!     *  ' Medie in SviluppaTria:R0a,sigma(R0a)=',evet_med, sigmav_med


      WhichSet = 0
      WhichFom = NWF
      ntrSv = 1
         Iterazione = 0
         call CalcolaBarra()
         nbarra = iabs(nbarra)
         numbrun = -ntrSv
         numset  = 0
         numb = nstr
         iphaz(:) = 0
         wt(:) = 0.0
         call GetWP(numb)
         numbrun = nint(fom(10))
         if (knw == 1 .and. ifPatt /= 0) then
             kstp = 0
             call Calcola_CC_Mappa(nstr,corre,kstp,2)
             fom(1) = corre
             call Calcola_CC_Mappa(numbLSQ,corre,kstp,2)  ! croc
             fom(2) = corre                            ! croc
         endif

         nondet = nint( fom(6)/ float(nstr) * 100. )
         EarlyFom = fom(5)
!140105
         TFom = '   cFom ='
         if (knw.eq.0) then
             if (nondet.gt.0) then
                 write(lo,10) ntrSv,numbrun,TFom,EarlyFom,nondet
             else
                 write(lo,11) ntrSv,numbrun,TFom,EarlyFom,
     *                        nint(fom(6))
             endif
         else
             if (nondet.gt.0) then
                 write(lo,15) ntrSv,numbrun,TFom,EarlyFom,nondet,
     *                fom(7),fom(8)
             else
                 write(lo,16) ntrSv,numbrun,TFom,EarlyFom,
     *                        nint(fom(6)),fom(7),fom(8)
             endif
         endif
   10    format(' Set',i6,'  Trial',i6,a,f7.3,
     *   '   UnDet ',i4,'%')
   11    format(' Set',i6,'  Trial',i6,a,f7.3,
     *   '   UnDet ',i4)
   15    format(' Set',i6,'  Trial',i6,a,f7.3,
     *   '  UnDet ',i4,'%  MPE ',2f6.2)
   16    format(' Set',i6,'  Trial',i6,a,f7.3,
     *   '  UnDet ',i4,'   MPE ',2f6.2)
!

             if (ifPatt == 0) then
                 wt(nstr+1:) = 0.0
                 iphaz(nstr+1:) = 0
             endif
croc

         ifExpanded = 0  ! altrimenti fa l'espansione in POSTWEITAN
                         !  per i trial successivi al primo
!
         if (kverbo.eq.1.and.knw.eq.1) then
             nuset = 7771
             izero = 0
             ifmin = 1
             call examin(nuset,mkang,khl,ipub,iphaz,numbLSQ,izero,
     *                   wt,ifmin)
             er_sav  = erore
             erp_sav = erorepes
         endif

         call zflush

         call Barra()
!
!
!pgMAD2907

         if (ifRidotta == 1) then
!            write(lo,'(/,a,/)') ' NIENTE EDM.........'
            do i=1,nRfac      !pgMAD0408
               if (nint(RfacMatrix(1,i,jBlock)) == numbrun) then
                  kRfac = i
               endif
            enddo
         else
               if(noDSR==0) call Cicli_DSR(ifBreak,corre,ier)!KUKU
               if (ifBreak == 1) then
                  return
               endif
            call ClearMessage()
cdedi
!
            ifRelaxTrial = 0
            call EndDSR(corre, ifRelaxTrial)
!
         end if  
!pgMAD2907
         if (ifBreak == 1) then
             ifBreak = 0
             kWstop = 0
             if (jscreen.eq.0) then
                 call PrintNoWindow(errem, FinalFom)
             endif
         else
!dedi

             if (nolsq /= 0) then
                 if (kWstop == 0) then
                     Fadlsq = 1
                 else
                     Fadlsq = 0
                 endif        
!dedi
                 if (Fadlsq /= 0) then
                     kWstop = 0
                     if (ifRelax.eq.1) then
                         kcicla = 2
                     else
                         kcicla = 1
                     endif
                     fomNoWind = FinalFom
                     call dlsq(ier,kcicla,erreNoWind, fomNoWind, 0,
     *                          ifBreak)
                     QualeAbilita = 2
                     if (ier == -1234) then
                        ier = 0
                     endif
                     if (ier < 0 . or. ifBreak == 1) then
                         return
                     endif
                 else
                     if (jscreen.eq.0) then
                         call PrintNoWindow(errem, FinalFom)
                     endif
                 endif
             endif
         endif

         kWstop = 1

         if (nolsq /= 0) then
!gl!         write(lo,20) itle
             write(lo,20) Titolo
             ifRecovered = 0
             interp = 1
             errem = erre
             if (nTotBlocksPh > 1) then
                 if ( erre*100. > rfacSog )  then
                      call PutGetBackUpXyzs(2)
                      erreo = errem
                      erre  = errem
                      ifRecovered = 1
                 endif
             endif
             jscreenSav = jscreen
             jscreen    = 1
             kaction = 4
             call build(kaction, 2)
             jscreen = jscreenSav
             iprinSav = iprin
             iprin    = 2
             krecy = 3000
             kact  = 4
             call outpea(kact)
             iprin    = iprinSav
!
             WhichSet = ntrSv
             write(Inte,'(i10)') ntrSv
         endif
!
   20 format(/,1x, 78('+'),//,19x,
     1       '***   Final interpretation  ***',/,a,/)
 999   continue
!pgMAD1011

         if (AllInMemory == 1) then
             write(Msg,32)
         else
             write(Msg,33)
         endif
         call TestoGR(Msg, -1, 2, kBox)
         write(Msg,3)
         call TestoGR(Msg, color_RED, 2, kBox)
   32 format('At the end of the procedure 1 substructure model ',
     *        'have been stored.')
   33 format('At the end of the procedure 1 more substructure model ',
     *        'have been stored.')
!pgMAD1011
    2 format('At this stage we have 1 more substructure model stored; ',
     *       'it will be submitted to phase extension.')
!
      write(lo,1920)
 1920 format(/,1x, 78('+'),/)
!
      call DistruggiPianiAll
!
!?!   call CPUTime(' ', 0)
      HTMLcpu = Inte(1:Lung(Inte))
      headersGR(2) = Inte
      call ManageGraph(0, 0)
      call zflush
      call DoSingleIteration()
!
      call OrdinaStampaTrial(1,1)
!
      call CreaPng(fname(9))
!
      return
      end
!-------------------------------------------------------------------------------
      subroutine PutAllInMemory
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Molcom
      USE Mappa, only : factr
      USE Param
      USE RemoModule
      USE MadModule
      USE PhaseModule
!
      factr = 0
      call inptf
      ifReduced = 0
      ifGener = 0
      natm = nint( anat )
      natm = max0(natm, nk)
      nats = natm
      call AllocaAtomi(1)
      ifat1=(2*ihmx(3)+1)*(2*ihmx(2)+1)
      ifat2=(2*ihmx(3)+1)
      ifatx=ihmx(1)*ifat1+ihmx(2)*ifat2+ihmx(3)
**    call AllocaInvarStuff(1)
      call AllocaIsr(1)
      call CheckGrid()
      call AllocaMappa(1)
      call AllocaHistoStuff(1)
      call AllocaTestStuff(1)
      numbB = numbLSQ
      kverbo = 1
!
      return
      end
!-----------------------------------------------------------------------
      subroutine FilesInfo(iAction, nSetsMTZ)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Riflessi
      USE Html
      USE MadModule
      USE PhaseModule
!
!-- iAction = 0  create the log file
!-- iAction > 0  Append to the log file
!
      k = index(fname(1),'.bin')
      cardImage = fname(1)(1:k-1) // '_files.log'
!
      if (iAction == 0) then
          istat = 0
          iform = 1
      else
          istat = 3
          iform = 1
      endif
!
      jop=jopen(ktml,cardImage,istat,iform,ierr)
      if (jop < 0) then
          write(Msg,8100) ierr
          call MsgWinErr('ERROR', Msg, SEVERE_ERR_WINDOW, nExitCode)
          return
      endif
!
      if (iAction == 0) then
          if (kmad == 0) then
              if (ifRemo == 0) then
                  Inte = 'Ab Initio structure determination.'
              else
                  Inte = 'Molecular Replacement procedure.'
              endif
          else if (kmad == 1) then
              Inte = 'Mad/Sad: Finding the anomalous scatterers'
          else if (kmad == 2) then
              Inte = 'Mir/Sir: Finding the Heavy Atom substructure.'
          endif
          call HTML_header(ktml,' ',Inte)
          call FilesInfoMTZ(ktml)
          write(ktml,20)
          write(ktml,*) '<u><b>Files produced</b></u> '
          write(ktml,40)
          if (kmad == 0) then
              if (ifRemo == 0) then
                  Inte = 'Ab Initio structure determination.'
              else
                  Inte = 'Molecular Replacement procedure.'
              endif
          else if (kmad == 1) then
              Inte = 'Mad/Sad: Finding the anomalous scatterers'
          else if (kmad == 2) then
              Inte = 'Mir/Sir: Finding the Heavy Atom substructure.'
          endif
          call HTML_header(ktml,' ',Inte)
      elseif (iAction == 1) then
          write(ktml,40)
          if (kmad == 0) then
              write(ktml,500)
              k2 = Lung(cardDiret)
              write(ktml,'(6x,a)') cardDiret(1:k2)
          elseif (ifRemo == 1) then
              write(ktml,600)
              k  = index(fname(1),'.bin')
              kk = kStripTask1(k)
              cardDiret = fname(1)(1:kk-1)// '_NN.pdb'
              k2 = Lung(cardDiret)
              write(ktml,'(6x,a)') cardDiret(1:k2)
          endif
      elseif (iAction == 2) then
              write(ktml,40)
              write(ktml,220)
              k2 = Lung(cardDiret)
              write(ktml,'(6x,a)') cardDiret(1:k2)
              write(ktml,230)
      elseif (iAction == 3) then
              write(ktml,40)
              write(ktml,510) nSetsMTZ
              k2 = Lung(cardDiret)
              write(ktml,'(6x,a)') cardDiret(1:k2)
      elseif (iAction == 9) then
          call HTML_end(ktml)
      endif
      close(ktml)
!
      return
   20 format('<font size="2" ',
     *       'style="font-family: courier new,courier,monospace;">')
*  30 format(2x,'<u><b>Files produced</b></u> ')
   40 format(' ')
* 100 format(4x,'MTZ file containing ',i2,' set(s) of phases,',
*    *          ' ordered by figure of merit ',/)
* 110 format(/,4x,' Each set includes the group of columns: ',/,
*    &            '        FCAB  (calculated moduli)',/,
*    &            '        PHIAB (phases)',/,
*    &            '        WTAB  (weights)',/,
*    &            '        HLA   (Hendrickson-Lattman coefficient)',/,
*    &            '        HLB   (Hendrickson-Lattman coefficient)'/,
*    &            '        HLC   (Hendrickson-Lattman coefficient)',/,
*    &            '        HLD   (Hendrickson-Lattman coefficient)')
* 200 format(4x,'MTZ file containing ',i2,' solution(s),',
*    *          ' ordered by figure of merit ',/)
* 210 format(/,4x,'Each solution corresponds to a group of columns: ',/,
*    &            '        FMR   (calculated moduli)',/,
*    &            '        PHIMR (phases)',/,
*    &            '        WTMR  (weights)',/,
*    &            '        HLA   (Hendrickson-Lattman coefficient)',/,
*    &            '        HLB   (Hendrickson-Lattman coefficient)'/,
*    &            '        HLC   (Hendrickson-Lattman coefficient)',/,
*    &            '        HLD   (Hendrickson-Lattman coefficient)')
  220 format(4x,'MTZ file containing phases refined by EDM',/)
  230 format(/,4x,'Columns: ',/,
     &            '        PHI_EDM (phases)',/,
     &            '        WT_EDM  (weights)',/,
     &            '        HLA   (Hendrickson-Lattman coefficient)',/,
     &            '        HLB   (Hendrickson-Lattman coefficient)'/,
     &            '        HLC   (Hendrickson-Lattman coefficient)',/,
     &            '        HLD   (Hendrickson-Lattman coefficient)')
  300 format(4x,'File used to pass substructure information to Task2')
  500 format(4x,'Best Model produced by the program in PDB format')
  510 format(4x,'Information about ',i3,' heavy atom(s) in PDB format')
  600 format(4x,'Substructure model in PDB format, for every trial')
 8100 format(' *** log file open error  ***  code =',i5)
      end
!-----------------------------------------------------------------------
      subroutine FilesInfoMTZ(jtml)
      USE General
      USE PhaseModule, only : nSetsFineDSR
!
      implicit none
      integer :: jtml, nSetsMTZ, k, k2, Lung
!
*     write(jtml,20)
*     write(jtml,*) '<u><b>Files produced</b></u> '
*     write(jtml,40)
*     if (kmad == 0) then
*         if (ifRemo == 0) then
*             Inte = 'Ab Initio structure determination.'
*         else
*             Inte = 'Molecular Replacement procedure.'
*         endif
*     else if (kmad == 1) then
*         Inte = 'Mad/Sad: Finding the anomalous scatterers'
*     else if (kmad == 2) then
*         Inte = 'Mir/Sir: Finding the Heavy Atom substructure.'
*     endif
*     call HTML_header(jtml,' ',Inte)
      write(jtml,20)
      write(jtml,*) '<u><b>Files produced</b></u> '
      write(jtml,40)
      if (kmad == 0) then
          if (ifRemo == 0)  then
              write(jtml,100)  nSetsFineDSR
              k  = index(fname(1),'.bin')
*gl*          cardDiret = fname(1)(1:k-1)// '_sir.mtz'
*gl*          cardDiret = fname(1)(1:k-1)// '.mtz'
              cardDiret = MTZfile
              k2 = Lung(cardDiret)
              write(jtml,'(6x,a)') cardDiret(1:k2)
              write(jtml,110) 
          else
              write(jtml,200)  nSetsFineDSR
*gl*          cardDiret = fname(1)(1:k-1)// '.mtz'
              cardDiret = MTZfile
*gl*          k  = index(fname(1),'.bin')
              k2 = Lung(cardDiret)
              write(jtml,'(6x,a)') cardDiret(1:k2)
              write(jtml,210) 
          endif
      else
          write(jtml,300) 
          k2 = Lung(cardDiret)
          write(jtml,'(6x,a)') cardDiret(1:k2)
      endif
!
      return
   20 format('<font size="2" ',
     *       'style="font-family: courier new,courier,monospace;">')
   30 format(2x,'<u><b>Files produced</b></u> ')
   40 format(' ')
  100 format(4x,'MTZ file containing ',i2,' set(s) of phases,',
     *          ' ordered by figure of merit ',/)
  110 format(/,4x,' Each set includes the group of columns: ',/,
     &            '        FCAB  (calculated moduli)',/,
     &            '        PHIAB (phases)',/,
     &            '        WTAB  (weights)',/,
     &            '        HLA   (Hendrickson-Lattman coefficient)',/,
     &            '        HLB   (Hendrickson-Lattman coefficient)'/,
     &            '        HLC   (Hendrickson-Lattman coefficient)',/,
     &            '        HLD   (Hendrickson-Lattman coefficient)')
  200 format(4x,'MTZ file containing ',i2,' solution(s),',
     *          ' ordered by figure of merit ',/)
  210 format(/,4x,'Each solution corresponds to a group of columns: ',/,
     &            '        FMR   (calculated moduli)',/,
     &            '        PHIC  (phases)',/,
     &            '        FOM   (weights)',/,
     &            '        HLA   (Hendrickson-Lattman coefficient)',/,
     &            '        HLB   (Hendrickson-Lattman coefficient)'/,
     &            '        HLC   (Hendrickson-Lattman coefficient)',/,
     &            '        HLD   (Hendrickson-Lattman coefficient)')
  220 format(4x,'MTZ file containing phases refined by EDM',/)
  230 format(/,4x,'Columns: ',/,
     &            '        PHI_EDM (phases)',/,
     &            '        WT_EDM  (weights)',/,
     &            '        HLA   (Hendrickson-Lattman coefficient)',/,
     &            '        HLB   (Hendrickson-Lattman coefficient)'/,
     &            '        HLC   (Hendrickson-Lattman coefficient)',/,
     &            '        HLD   (Hendrickson-Lattman coefficient)')
  300 format(4x,'File used to pass substructure information to Task2')
      end
!-----------------------------------------------------------------------
      subroutine AbInfo(iAction)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Riflessi
      USE Html
      USE MadModule
      USE PhMod
      USE PhaseModule
      USE VLDmod_3
!
!-- iAction = 0  create the log file
!-- iAction > 0  Append to the log file
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
!     common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,del,ks
      common /ConvComm/ NSigPos, SogPos, NSigNeg, NQuaNeg, inizNeg,
     *                  NPsiZero, numbReflTrip, SogNeg, SogQuaNeg
!psie
!psie      common /ConvComm/ NSigPos, SogPos, NSigNeg, NQuaNeg, inizNeg,
!psie     *                   NPsie,NPsiZero, numbReflTrip, SogNeg, SogQuaNeg
!
      character *255  filename
      logical Esiste
!
      ier = 0
      ncwuSav = ncwu
      ncwu = ktml
!
      k = index(fname(1),'.bin')
      filename = fname(1)(1:k-1) // '.log'
!
      if (iAction == 0) then
          istat = 0
          iform = 1
      else
          istat = 3
          iform = 1
      endif
!
      jop=jopen(ktml,filename,istat,iform,ierr)
      if (jop < 0) then
          write(Msg,9900) ierr
          call MsgWinErr('ERROR', Msg, SEVERE_ERR_WINDOW, nExitCode)
          return
      endif
!
      if (iAction == 0) then
          if (Imported == 0) then
              Msg = 'Ab Initio structure determination.'
          else
              if (Imported ==1) then
                  Msg = 'Imported data'
              else
                  Msg = 'Previous run'
              endif
          endif
          call HTML_header(ktml,' ',Msg)
          write(ktml,29)
!
          kk = ktml
          call PreProcessed(kk, ier)
!
          write(ktml,*) '<u><b>Crystallographic Data</b></u> '
          write(ktml,31)
          Inte = Titolo
          write(ktml,200)
          write(ktml,210) (cell(i),i=1,3)
          write(ktml,220) (cell(i),i=4,6)
          write(ktml,230) 

          call WriteSymmInfo(ktml)
!--scrivo le informazione del contenuto della cella dalla routine apposita
!
          loSav=lo
          lo = ktml
          call WriteContInfo(npq,ier)
          iact = 0
          if (numbGen == 0) then
              iact = 0
              call WriteReflInfo(iact)
          else
              do iact =1,2
                 call WriteReflInfo(iact)
              enddo
          endif
          lo=loSav
          
          ifLi6 = InfoOK(6)

c--b from wilson plot
          if (ifLi6 > 0) then
              k1 = index(fname(1), '.bin') - 1
              Inte = fname(1)(1:k1) // '_Wilson.png'
              inquire (file=Inte,  exist = Esiste)
              if (Esiste) then
                  write(ktml,675) Inte(1:Lung(Inte))
              endif
              if (sc > 0.0) then
                  write(ktml,680) bt, sqrt(sc)
                  write(ktml,230)
              endif

              if (Imported == 0) then
                  write(ktml,30)
                  write(ktml,*) '<u><b>Solve section</b></u> '
                  write(ktml,31)
    
                  if (ifVLD == 0) then
                     if (NSigPos > 0) write(ktml, 100) NSigPos,SogPos
                     if (NSigNeg > 0) write(ktml, 101) NSigNeg,SogNeg
                     if (NQuaNeg > 0) write(ktml, 102) NQuaNeg,SogQuaNeg
                     if (ifNewPsi0 == 1 .and. npsi > 0) then
                         write(lo, 103) 
                         write(lo, 104) npsi
                     endif
                     if (ifSelAlfa == 1 .and. nstrelimi > 0) then
                         write(lo, 105)
                         write(lo, 106) nstrelimi,nstr
                     endif
                  endif
         
                  call WriteStrategy(ktml) 
                  if (ifMDM == 1) then
                      write(ktml,9060)
                  elseif (ifVLD == 0) then
                      if (ifPatt == 0) then
                          write(ktml,9056) nstr
                          write(ktml,9059) jBlocksPh(1,1),jBlocksPh(2,1)
                      elseif (ifPatt == 1) then
                          write(ktml,9058)
                      endif
                  else
                      write(ktml,9057)
                  endif
                  if (ksize > 3)  then
                      if (ifVLD == 0) then
                          pippo = FFomStopPGM
                          write(ktml,107) pippo
                      else
                          write(ktml,107) stopFinalFom2
                      endif
                      write(ktml,9065) sum(jBlocksPh(1,1:nBlocksPh))
                  endif
              endif
          else
              NSigPos = 0
              ntrSv   = 0
          endif
      else
          if (iAction == 1) then
*             if (knw /= 0) then
*                 call LoadInitialPhases(cfom, ipos, nset)
*                 nSetStored = nset
*                 if (InfoOK(16).gt.0) then
*                     iAlloca = 0
*                     if (.not.allocated(work1)) then
*                         iAlloca = 1
*                         allocate(work1(nrefl),iwork1(nrefl),stat=ierr)
*                     endif
*                     write(ktml,700)
*                     write(ktml,720)
*                     iOK = 0
*                     do j=1,nset
*                        i = ipos(j)
*                        call PutGetInitialPhases(2, i,fom,work1,iwork1)
*                        iitrial = nint(fom(10))
*                        if (mod(j,3) == 1) then
*                            Inte = ' '
*                            iOK = 1
*                            write(Inte(1:27),650)  j, iitrial, fom(5)
*                        elseif (mod(j,3) == 2) then
*                            write(Inte(28:47),650) j, iitrial, fom(5)
*                        else
*                            write(Inte(55:74),650) j, iitrial, fom(5)
*                            write(ktml,'(a)') Inte
*                            iOK = 0
*                        endif
*                     enddo
*                     if (iOK == 1) then
*                         write(ktml,'(a)') Inte
*                         iOK = 0
*                     endif
*                     if (iAlloca == 1) then
*                         deallocate(work1,iwork1, stat=ierr)
*                     endif
*                     write(ktml,230)
*                 endif
*             endif
          elseif (iAction == 2) then
          elseif (iAction == 3) then
              k1 = Lung(HTMLstr)
              if (k1 <= 0) then
                  write(ktml,'(a)') ' '
              else
                  write(ktml,'(a)') HTMLstr(1:Lung(HTMLstr))
              endif
          elseif (iAction == 4) then
              write(ktml,'(a)') HTMLstr(1:Lung(HTMLstr))
              if (ifMadEnv == 0) then
                  k1 = index(fname(1), '.bin') - 1
                  Inte = fname(1)(1:k1) // '_Foms.png'
                  inquire (file=Inte,  exist = Esiste)
                  if (Esiste) then
                      write(ktml,800) Inte(1:Lung(Inte))
                      ind = index(Inte,slash,.TRUE.) 
                      write(ktml,675) Inte(ind+1:Lung(Inte))
                  endif
              endif
              call HTML_end(ktml)
          elseif (iAction == 5) then
              call FilesInfoMTZ(ktml)
          elseif (iAction == 9) then
              write(ktml,900) HTMLstr(1:Lung(HTMLstr))
          elseif (iAction == 10) then
              write(ktml,8000)
              write(ktml,8100) nBigCycles, ancellaMax
          elseif (iAction == 11) then
              write(ktml,'(a)') HTMLstr(1:Lung(HTMLstr))
          endif
      endif

!
!-- da completare le seguenti stampe
!
!     if (ntrSv == 1) then 
!     write(ktml,9060)
!9060    format(/,' Direct Space Refinement Section',//,
!    *             ' The best trials have the lowest R%/RAT values',//, 'pgMAD1011
!    *           8x,' Trial     R%        RAT     R%/RAT')
!     end if

!     if (nnumset > 0.) then
!        RF = rfacR(numR)           !    /FOM_MAD(6)    ! ATTENZIONE !
!        write(ktml,'(8x,i5,3f10.3)')nnumset,rfacR(numR),FOM_MAD(6),RF
!     end if

      close(ktml)
      ncwu = ncwuSav
      ier = 0
      return
!
   29 format('<font size="2" ',
     *       'style="font-family: courier new,courier,monospace;">')
   30 format(' <hr color="#000080" size="1">')
   31 format(' ')
  100 format(' Number of Pos. Est. Triplets =',i9,' with  G  > ',f5.2)
  101 format(' Number of Neg. Est. Triplets =',i9,' with |G| > ',f5.2) ! dedi  (0.60)
  102 format(' Number of Neg. Est. Quartets =',i9,' with |G| > ',f5.2) ! dedi  (0.10)
  103 format(/,' Psi0 Relationships Actively Used ') 
  104 format(' Number of Psi0 Relationships  =',i9) 
  105 format(/,' Selection of Reflections to be used Tangent Formula ') 
  106 format(' Number of Rejected Reflections  =',i6,' over',i6) 
  107 format(/,' Stop condition:    Final Fom >',f8.2)
  200 format(' Cell Parameters:',/)
  210 format('     a = ',f9.3,'     b = ',f9.3,'     c = ',f9.3)
  220 format(' alpha = ',f9.3,'  beta = ',f9.3,' gamma = ',f9.3)
  230 format(' ')
  500 format(' Cell Content:')
  650 format(i4,'  (',i5,')',f7.3)
  675 format('<img border="0" src="',a,'">')
  680 format(' Thermal factor B(iso) and scale from Wilson Plot = ',
     *       2f8.3)
  682 format(' Scale  Thermal Factor B(iso) = ',f7.3)
  700 format(/,10x,'+++++++++++++  Figures  of  merit  ++++++++++++')
  720 format(/,' <b>',3('Set  (Trial)   eFom',8x),'</b>',/)
  800 format('<p align="left"><b><u>Image File: ',a,'</u></b></p>')
  900 format('<font size="4" style="font-family: ',
     *       'times new roman,times,serif;" color="#FF0000"><b>',
     *       a,'</b></font>')
 9028 format(' Structure name:',a,/,' ',a,/)
 9056 format(' The tangent formula is used to phase the best',i5,
     *       ' reflections',/)
 9057 format(' The VLD procedure is used to solve the structure',/)
 9060 format(' The MDM procedure is used to solve the structure',/)
 9058 format(' The Patterson procedure is used to phase the observed',
     *       ' reflections',/)
 9059 format(i6,' trials requested and',i6,' trials stored.',/,
     *    ' They will be used to locate the model on the basis',/,
     *    ' of the early Figure Of Merit (eFOM).',/)  
 9065 format(' Trials to explore: ',i6)
 8000 format(' Edm, Vld, Free Lunch and Phantom Derivative techniques',
     *         ' will be used',
     *        ' to extend and to refine phases.')
 8100 format(
     *     ' In PhD ',i1,' cycles and ',i2,' derivatives will be used.')
 9900 format(' *** log file open error  ***  code =',i5)
!
      end
!-----------------------------------------------------------------------
      subroutine CopyLog(LUnit)
      USE General
!
      istat = 2
      iform = 1
      jop = jopen(jgrap,Msg,istat,iform,ierr)
      do 
        read(jgrap,'(a)',end=100) cardImage
        write(LUnit,'(a)') cardImage(1:Lung(cardImage))
      enddo
  100 close(jgrap)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine WriteStrategy(unit)
      USE General
      USE PhaseModule, only : ksize_vero
!
      implicit none
      integer :: unit, kdsr, kdsrReq, ifPeak, nolsqReq
      common /modifica_DSR/ kdsr, kdsrReq, ifPeak, nolsqReq
!      
      if (kmad == 1) then
          if (ksize_vero == 1 ) then
              write(unit, 145) ' Solving strategy: '
          elseif (ksize_vero == 2 ) then                      !cricri2
              write(unit, 148) ' Solving strategy: '
          else
              write(unit, 155) ' Solving strategy: '
          end if
      else
          if (ksize_vero == 1) then
              write(unit, 140) ' Solving strategy: '
          elseif (ksize_vero == 2) then
              write(unit, 150) ' Solving strategy: '
          elseif (ksize_vero == 3) then
              write(unit, 160) ' Solving strategy: '
          elseif (ksize_vero == 4) then
              write(unit, 170) ' Solving strategy: '
          elseif (ksize_vero == 5) then
              write(unit, 180) ' Solving strategy: '
          elseif (ksize_vero == 6) then
              write(unit, 190) ' Solving strategy: '
          elseif (ksize_vero == 7) then
              write(unit, 200) ' Solving strategy: '
          endif
      end if
      write(unit,*)
!
      if (kdsrReq == 1) then
          if (kdsr == 1) then
              write(unit, 140) ' DSR strategy changed: '
          elseif (kdsr == 2) then
              write(unit, 150) ' DSR strategy changed: '
          elseif (kdsr == 3) then
              write(unit, 160) ' DSR strategy changed: '
          elseif (kdsr == 4) then
              write(unit, 170) ' DSR strategy changed: '
          elseif (kdsr == 5) then
              write(unit, 180) ' DSR strategy changed: '
          elseif (kdsr == 6) then
              write(unit, 190) ' DSR strategy changed: '
          elseif (kdsr == 7) then
              write(unit, 200) ' DSR strategy changed: '
          endif
      end if
!
      return
!
  140 format(/,a,
     *'very small-size structure ( up to 5 atoms in a.u. )')
  150 format(/,a,
     *'small-size structure ( 6-80 atoms in a.u. )')
!pgMAD0301
  145 format(/,a,
     *'small-size structure ( up to 10 atoms in a.u. )')    !cricri2
  148 format(/,a,
     *'medium-size structure ( 11-50 atoms in a.u. )')      !cricri2
  155 format(/,a,
     *'large-size structure ( >50 atoms in a.u. )')
!pgMAD0301
  160 format(/,a,
     *'medium-size structure ( 80-300 atoms in a.u. )')
  170 format(/,a,
     *'large-size structure ( 300-600 atoms in a.u. )')
  180 format(/,a,
     *'very large-size structure ( 600-1000 atoms in a.u. )')
  190 format(/,a,
     *'very large-size structure ( >1000 atoms in a.u. )')
  200 format(/,a,
     *'huge-size / difficult structure ( >1750 atoms in a.u. )')
!
      end
!-----------------------------------------------------------------------
      subroutine WriteFinalAll(unit)
      USE General
      USE Riflessi
      USE PhaseModule
      USE RfacMatrixModule
      USE VLDmod, only: nTrialsVLD
      USE Html
!
      implicit none
      integer :: unit, ifHTML, i, j, jj, iOK, iitrial, Lung, nToSort, ht
      integer :: MaxT, ier
      real    :: r, fm
      real, allocatable :: prtvet(:)
      character (len=6) :: ffomval, erreval, mpe
!      
      if (jBlocksPh(1,jBlock) <= 0) then
          return
      endif
!
      if (jpfile /= 0) then
          return
      endif
!
      MaxT = size(RfacMatrix(1,:,1))
      nToSort = MaxT * jBlock * 10
      allocate (prtvet(nToSort), stat=ier)
      prtvet(:) = 0
      call OrdinaTrials(nToSort, prtvet)
!
      do ht=1, 2
         ifHTML = ht - 1
         mpe = ' '
         if (ifHTML == 0) then
             write(unit,510) 
             if (knw == 0) then
                 write(unit,602)
             else
                 write(unit,702)
             endif
         else
             HTMLstr = ' '
             call AbInfo(11)
             write(HTMLstr,511)
             call AbInfo(11)
             if (knw == 0) then
                 write(HTMLstr,612)
             else
                 write(HTMLstr,712)
             endif
             call AbInfo(11)
         endif
!
         j = 0
         iOK = 0
         jj  = 0
         do i=1, nToSort
!
            iitrial = nint(work1(j+1))
            r       = work1(j+4)
            fm      = work1(j+9)
               jj = jj + 1
            if (r > 0.0 .and. r < 199.0) then
                write(erreval,'(f6.2)') r
            else
                erreval = '  n.a.'
            endif
            if (fm > -9999) then
                write(ffomval,'(f6.3)') fm
            else
                ffomval = '  n.a.'
            endif
            if (knw > 0) then
                write(mpe,'(f6.2)') work1(j+6)
            endif
            if (mod(jj,2) == 1) then
                Buffer1 = ' '
                iOK = 1
                write(Buffer1(1:36),652) iitrial,
     *                                   ffomval, erreval, mpe
            else
                write(Buffer1(32:80),652) iitrial,
     *                                    ffomval, erreval, mpe
                if (ifHTML == 0) then
                    write(unit,'(a)') Buffer1(1:Lung(Buffer1))
                else
                    HTMLstr = Buffer1(1:Lung(Buffer1))
                    call AbInfo(11)
                endif
                iOK = 0
            endif
            j = j + 9
         enddo
         if (iOK == 1) then
             if (ifHTML == 0) then
                 write(unit,'(a)') Buffer1(1:Lung(Buffer1))
             else
                 HTMLstr = Buffer1(1:Lung(Buffer1))
                 call AbInfo(11)
             endif
         endif
         if (ifHTML == 0) then
             write(unit,'(a)') ' '
         else
             HTMLstr = ' '
             call AbInfo(11)
         endif
      enddo
      deallocate (prtvet, stat=ier)
!
      return
!
  510 format(/,' ',18('+'),'  Final results  ',18('+'))
  511 format(  ' ',18('+'),'  Final results  ',18('+'))
  652 format(i4,'   ',a,' ',a,' ',a)
  602 format(/,    2(' Trial   fFom    R%',10x),/)
  612 format('<b>',2(' Trial   fFom    R%',10x),'</b>')
  702 format(/,    2(' Trial   fFom    R%    MPE',5x),/)
  712 format('<b>',2(' Trial   fFom    R%    MPE',5x),'</b>')
!
      end
!-----------------------------------------------------------------------
      subroutine OrdinaTrials(nToSort, work1)
      USE General
      USE PhaseModule
      USE RfacMatrixModule
      USE VLDmod, only: nTrialsVLD
!
      implicit none
      integer :: k, j, nToSort, lind, nr2, iblk, iitrial
      integer :: i, n, jump, MaxT, ifErreStored, ErreStored
      real    :: work1(nToSort)
!
      MaxT = size(RfacMatrix(1,:,1))
      ifErreStored = 0
      j = 0
      nToSort = 0
      do k=1, jBlock
         do i=1, MaxT
            iitrial = nint(RfacMatrix(1,i,k))
            if (iitrial > nTrialsVLD) then
                cycle
            endif
            if (iitrial == 0) then
                cycle
            endif
            ErreStored = nint(RfacMatrix(4,i,k))
            if (ErreStored /= -9999) ifErreStored = 1
            work1(j+1) = RfacMatrix(1,i,k)
            work1(j+2) = RfacMatrix(2,i,k)
            work1(j+3) = RfacMatrix(3,i,k)
            work1(j+4) = RfacMatrix(4,i,k)
            work1(j+5) = RfacMatrix(5,i,k)
            work1(j+6) = RfacMatrix(6,i,k)
            work1(j+7) = RfacMatrix(7,i,k)
            work1(j+8) = RfacMatrix(8,i,k)
            work1(j+9) = RfacMatrix(3,i,k)
            j = j + 9
            nToSort = nToSort + 1
         enddo
      enddo
      lind = 1
      nr2  = nToSort
      n = nToSort * 9
      iblk = 9
      if (ifErreStored == 0) then
          jump = -9
      else
          jump = 4
      endif
      call sortz_dyn(work1, n, lind, nr2, iblk, jump)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine WriteFinalMad(unit, ifHTML)
      USE General
      USE PhaseModule
      USE RfacMatrixModule
!
      integer unit
      real, allocatable::prtvet(:)
!      
      if (ifHTML == 0) then
          write(unit,600)
      else
          write(unit,610)
      endif
!
      istep = 4
      idim = MaxToStore * istep
      allocate (prtvet(idim), stat=ier)
      k = 0
      do j=1, MaxToStore
         atrial = RfacMatrix(1,j,jBlock)
         r1 = RfacMatrix(4,j,jBlock) * 100.0
         r2 = RfacMatrix(3,j,jBlock)
         rr = r1 / r2
         prtvet(k+1) = atrial
         prtvet(k+2) = r1
         prtvet(k+3) = r2
         prtvet(k+4) = rr
         k = k + istep
      enddo
      jump = 4
      iniz = 1
      call sortz_dyn(prtvet,idim,iniz,MaxToStore,istep,jump)
      iOK = 0
      k = 0
      do j=1, MaxToStore
         iitrial = nint(prtvet(k+1))
         r1 = prtvet(k+2)
         r2 = prtvet(k+3)
         rr = prtvet(k+4)
         if (mod(j,2) == 1) then
             Buffer1 = ' '
             iOK = 1
             write(Buffer1(1:35),650)  iitrial, r1, r2, rr
         else
             write(Buffer1(46:81),650) iitrial, r1, r2, rr
             write(unit,'(a)') Buffer1(1:Lung(Buffer1))
             iOK = 0
         endif
         k = k + istep
      enddo
      if (iOK == 1) then
          write(unit,'(a)') Buffer1(1:Lung(Buffer1))
          iOK = 0
      endif
      deallocate (prtvet, stat=ier)
!
      return
!
 
  650 format(i5,3f10.3)
  600 format(/,' Direct Space Refinement Section',/,
     *             ' The best trials are expected to have the lowest '
     *             'R%/fFOM values',//,
     *         ' ',31('+'),'  Final results  ',31('+'),//,
     *             2(' Trial    R%        fFOM     R%/fFOM',9x)/)
  610    format(/,' <u>Direct Space Refinement Section</u>',//,
     *            ' The best trials have the lowest R%/fFOM values',//,
     *         ' ',31('+'),'  Final results  ',31('+'),//,
     *    '<b>',2(' Trial    R%       fFOM      R%/fFOM',10x),'</b>',/)
!
      end
!-----------------------------------------------------------------------
      subroutine Traslas(ifAborted, ifFromRelax)
!
!--faccio la traslazione con la FFT
!
      USE General
      USE Symmetry
      USE Riflessi
      USE Riflessi_c
      USE Atomi
      USE Mappa
      USE MappaAutre
      USE RemoModule
      USE PhaseModule
      USE VLDmod_3, only : numero_cicli
      USE RelaxMod
!
      logical :: noWrite
      common/util2/noWrite
      dimension vet2(3),vet(3)
      integer iHcan(3),hklmin(3),hklmax(3),hkl(3),hmax1,hmax2,hmax3
      integer inCheshire, inChe, iesOrigine
      character spaceg*16
*     integer, allocatable :: iworki(:,:)
      dimension x1(3),s(3)
      dimension sol_list(4,50)
      dimension xo(11),xn(11),keyx(10)
!

      if(kverbo>0) call CPUTime0('inizio traslas')
!
      write(spaceg,'(16a1)') (nSpaceG(i),i=1,16)
!
      call ucase(spaceg(1:1))
      if (ifFromRelax == 1) then
          l = Lung(spaceg)
          write(Inte,10) numbrun,spaceg(1:l)
      else
          write(Inte,20) numbrun
          call OneBlankOnly(Inte)     
      endif
      call scrper(Inte,0,-1)
   10 format('End of RELAX procedure for trial ',i5,
     *       '. Now back in ',a,' ...')
   20 format('Trial ',i5,': moving in P -1')
!
*     call CheshireTra()
      alim=nGridv(1)*nGridv(2)*nGridv(3)  
!
      if (.not. allocated(iworki)) then
          allocate(iworki(2,numbLSQ), stat=ierr)
      endif
      iworki(:,:)=0.0
      avterm = 0.0
      acont  = 0.0
      do i=1, numbLSQ
         iphazo(i)=iphaz(i)
         if (wt(i) > 0.01) then
             work2(i) = fovet(i)
             avterm = avterm + work2(i)
             acont  = acont + 1
         else
             work2(i) = 0.0
         endif
         if (iwork1(i) > 0) then
              iwk = iwork1(i)
          else
              iwk = -iwork1(i)
          endif
          ii = jwork1(i)
          jj = iwk / 100
          iworki(1,i) = jj      ! operatore di simm.
          if (jj == 1) then
              iworki(2,i) = 1   ! numero di equiv. per il riflesso
              iia = i
          else
              iworki(2,iia) = iworki(2,iia) + 1
          endif
      enddo
      avterm = avterm / acont
!
!-- salvo le variabili
!
      natsOld = nats
      nzsav(1:nats) = nz(1:nats)
      xyz30(:,:) = xyzs(:,:)
      ihmxSav(:)=ihmx(:)

      new = 1
      new = 0
      ksol = 1
c
c--definisco la nuova griglia dello spazio reciproco sulla quale 
c  fare la FFT per trovare la traslazione
c
      if (new == 0) then

      frac=1.0
c     frac=2.0 ! per aumentare il numero di riflessi per la FFT
      asym=2.0*nsym*(icent+1)*pts
      term=resm**3*(nrefl*3.0*asym)/(4.0*Pi*volume)
      res=resm/(1+frac*term)**0.333
      rhomax1 = 0.25/(res*res)
      resolMax = res
      eps1=rhomax1/25.  ! allargo leggermente la corona circolare
c
c----------4/3*pi*Hmax
      previsti=0.5*(4.0/3.0)*Pi*(volume/resolMax**3)
      nRifDimC=ceiling(1.2*previsti)
      hmax1=ceiling(cell(1)/resolMax)+1
      hmax2=ceiling(cell(2)/resolMax)+1
      hmax3=ceiling(cell(3)/resolMax)+1
      if(ihmx(1)>hmax1) hmax1=ihmx(1)
      if(ihmx(2)>hmax2) hmax2=ihmx(2)
      if(ihmx(3)>hmax3) hmax3=ihmx(3)
      ihmx(1)=hmax1
      ihmx(2)=hmax2
      ihmx(3)=hmax3
      
      endif

      if (new == 1) then
          if (.not.allocated(fcvetc)) then
              call space_hRsRq()
          else
              ihmx(1:3) = ihmx_c(1:3)
          endif
      else
!
!-- conta i riflessi per un corretto uso di AllocaRiflessi_c
!
          nrr = 0
          do indh=0,hmax1
             indkmin=-hmax2
             if(indh==0) indkmin=0
             do indk=indkmin,hmax2
                indlmin=-hmax3
                if(indh==0.and.indk==0) indlmin=1
                do indl=indlmin,hmax3
                   rho1 = rhof(pp,indh,indk,indl)
                   rho  = rho1 * rho1
                   if (rho > rhomax1+eps1) cycle   ! PEZZA
                   nrr = nrr + 1
                enddo
             enddo
          enddo
          nRifDimC = nrr
          if (knw ==1 .and. kverbo == 1) 
     *                write(6,*) 'riflessi effettivi: ',nrr
          call AllocaRiflessi_c(1)
!
          nrr = 0
          hklmin(:) =  9999
          hklmax(:) = -9999
          do indh=0,hmax1
             indkmin=-hmax2
             if(indh==0) indkmin=0
             do indk=indkmin,hmax2
                indlmin=-hmax3
                if(indh==0.and.indk==0) indlmin=1
                do indl=indlmin,hmax3
                   rho1 = rhof(pp,indh,indk,indl)
                   rho  = rho1 * rho1
                   if (rho > rhomax1+eps1) cycle   ! PEZZA
                   vet(1)=indh
                   vet(2)=indk
                   vet(3)=indl
                   call controllo_indici_interi(vet,hkl)
                   nrr = nrr + 1
                   khlc(1:3,nrr) = hkl(1:3)
                   indr = hkl(1) * ifat1C + hkl(2) * ifat2C + hkl(3)
                   superind(indr) = nrr
                   do j1=1,3
                      if (hkl(j1) < hklmin(j1)) hklmin(j1)=hkl(j1)
                      if (hkl(j1) > hklmax(j1)) hklmax(j1)=hkl(j1)
                   end do 
                enddo
             enddo
          enddo
          nRifDimC = nrr
 
      endif
!
!-- create the TF Map
!
      fcvetc = 0.0
      fcvets = 0.0
      numbPhased = 0
      i = 0
      do
         i = i + 1
         if (i > numbLSQ) exit
         jj = iworki(1,i)   ! operatore di simm.
         if(jj == 1) then
           numbEq = iworki(2,i)
           if(icentTrue==0) then
             numbEqTrue=numbEq
           else
             numbEqTrue=numbEq*2
           endif
           do m2=1, numbEqTrue-1
             m2True=mod(m2,numbEq)
             if(m2True==0) m2True=numbEq
             if(m2<=numbEq) then
               iicc2=1
             else
               cycle ! elimino i riflessi -H
               iicc2=-1
             endif
             n2 = i + m2True - 1
             k2 = iworki(1,n2)
             do m1=m2+1, numbEqTrue
               m1True=mod(m1,numbEq)
               if(m1True==0) m1True=numbEq
               if(m1<=numbEq) then
                 iicc1=1
               else
                 if(m1True<m2True) cycle ! elimino i riflessi con fase opposta
                 iicc1=-1
               endif
               n1  = i + m1True - 1
               k1 = iworki(1,n1)
               tt = 0
               do k=1,3
                  vet2(k) = khl(1,i)*(iicc2*kmat(k2,1,k)
     &                               -iicc1*kmat(k1,1,k))
     &                    + khl(2,i)*(iicc2*kmat(k2,2,k)
     &                               -iicc1*kmat(k1,2,k))
     &                    + khl(3,i)*(iicc2*kmat(k2,3,k)
     &                               -iicc1*kmat(k1,3,k))
                  tt = tt + khl(k,i)*(tmat(k1,k)-tmat(k2,k))
               enddo
!
               call controllo_indici_interi(vet2,iHcan)
!
!-- seleziono i riflessi H
!
!--controllo importante, altrimenti il superindice non funziona!!
               if (new == 0) then
                   if(abs(iHcan(1))>hmax1.or.
     &                abs(iHcan(2))>hmax2.or.
     &                abs(iHcan(3))>hmax3) then
!                     write(6,*) 'CONTR',iHcan,hmax1,hmax2,hmax3
                      cycle     ! PEZZA
                   endif
               endif
               indr = iHcan(1)*ifat1C + iHcan(2)*ifat2C + iHcan(3)
               if(indr>0.and.indr <= ifatxC) then
                 kk = superind(indr)
                 if(kk > 0) then
!
!--calcolo i coefficienti
!
                   arg = - (iicc1*iphazo(n1)
     &                        - iicc2*iphazo(n2) + 360*tt)
                   term = work2(n1) * work2(n2)
                   term=term/(avterm*avterm)
                   fcvetc(kk)=fcvetc(kk)+term*cos(dtor*arg)
                   fcvets(kk)=fcvets(kk)+term*sin(dtor*arg)
                   numbPhased = numbPhased + 1
*                  write(6,'(i5,1h),3i4,2f12.4,i6,2f10.4)')
*    *                   i,iHcan,arg,term,kk,fcvetc(kk),fcvets(kk)
c                  write(6,'(a,3i5,3i4,4x,3i4,2f13.3)') 
c    &                 'indici ',i,k1,k2,khl(1:3,i),iHcan,term,arg
                 endif
               endif
             enddo
           enddo
           i = i + numbEq - 1
         else
           call cstop(' error in Traslas ')
         endif
      enddo
c
*     deallocate (iworki, stat=ierr)
      if (knw ==1 .and. kverbo == 1) 
     *                write(6,*) 'riflessi fasati: ',numbPhased
c
*     call AllocaMappa(2)
      if (new == 0) then
          ihmx(1:3)=hklmax(1:3)
      endif
      call CheckGrid()
      if (new == 0) then
          do i=1,3
            if(ihmx(i)==0) np(i)=3
          enddo
      endif
*     call AllocaMappa(1)
      
      npAutre(:) = np(:)

!     STOP

      call AllocaMappaAutre(1)
!
c
c--cambio gruppo spaziale ( no perche' sono gia' in P1 )
c
      latt=1 ! evita di considerare la centratura
      call MakeMapMR(xmapAutre, xmapCa, FORTHa, BACKa, npAutre,
     *               FFTW_ESTIMATE)
!
!-- ricerca i picchi sulla mappa bidimensionale (non lo posso fare sulla mappa
!   per colonne)
!
      if (nGridv(1) == 1) then
          xmapAutre(1:np(1)-1,0:np(2)-1,0:np(3)-1) = 0.0
      elseif (nGridv(2) == 1) then
          xmapAutre(0:np(1)-1,1:np(2)-1,0:np(3)-1) = 0.0
      elseif (nGridv(3) == 1) then
          xmapAutre(0:np(1)-1,0:np(2)-1,1:np(3)-1) = 0.0
      endif
c
c--cerco i picchi in P1 
c
      nats=0
      xyzs(:,:)=0.0
      krecy=0
      ihalf=0  ! per fare il peak search su tutta la cella 
      term = alim / 50.0
      term = max(10.0, term)
      term = min(term, float(MaxAtoms-1))
!
      ifPattSav = ifPatt
      ifPatt = 0
      iflagPKS = 1
      npic = term
      call pksrch_core(xmapAutre, np, ifPatt, iflagPKS, npic, dm,
     *                 NumPeaks, ier)
      ifPatt = ifPattSav
      nats = NumPeaks

!     if (knw == 1)  then
!         write(6,*) ' Altezza Picchi '
!         do nR = 1,nats
!            write(6,'(i5,3f10.4,f15.2)') nR, xyzs(1:4,nR)
!         enddo
!     endif
!

!
!-- TEST
!
      nnew = 1
      nnew = 0

      if (nnew == 1) then

          ihmx(:)=ihmxSav(:)
          call CheckGrid()
          call DefinisciTraslazione(vet2, nRis)

      else

      nRisCheck=0
      ifOrigineNonPerm=0
      delta_sol(:) = 0.0

      ifTre = 1
      if (ifTre == 1) then
          call AnalizzaPicchi(nPeaksCh)
          nRis = 1
          go to 1001
      endif

      nRis = 0
      do_1: do i = 1 , nats
c        if (knw == 1) 
*        write(6,*) 'picco trovato ',i,xyzs(1:3,i),xyzs(4,i)
         delta_sol(1) = side( xyzs(1,i) )
         delta_sol(2) = side( xyzs(2,i) )
         delta_sol(3) = side( xyzs(3,i) )
         inChe = inCheshire(delta_sol)
         if (knw == 1) 
     *   write(6,100) i, delta_sol(1:3), xyzs(4,i), inChe
         if (inChe == 1) then
c
c--scarto soluzioni nel caso di gruppo di Cheshire con I e con
c  cella di cheshire che non esclude posizioni collegate da I
c  (avviene solo nel cubico)
c
             if (jsysSav == 6 .and. i > 1) then
                 diff = abs( delta_sol(1) - side( xyzs(1,i-1) ))
                if (abs( diff - 0.5 ) < 0.01) then
                    diff = abs( delta_sol(2) - side( xyzs(2,i-1) ))
                    if (abs( diff - 0.5 ) < 0.01) then
                        diff = abs( delta_sol(3) - side( xyzs(3,i-1) ))
                        if (abs( diff - 0.5 ) < 0.01) then
                            cycle
                        endif
                    endif
                endif
             endif
c
             nRis = nRis + 1
c
c--controllo se la soluzione e' troppo vicina ad una origine permessa
c
             if(ifRhombAx==1) then
c--la variabile nOrigRoxi non e' corretta in questo caso
               vet2(:)=delta_sol(:)
               exit do_1
             else
!--per le soluzioni piu' alte, controllo se ci sono origini permesse
c              if(nRis==1) hmax=xyzs(4,i)
               if(nRis==1) then
                  hmax=xyzs(4,i)
                  kRis = i
               endif
c
               if(xyzs(4,i)>0.90*hmax) then
*gl*           if(xyzs(4,i)>0.00) then
*******          if (nRisCheck == 50) exit
                 iperm=0
                 nRisCheck=nRisCheck+1
!--controllo se l'origine e' permessa
                 distmin=9999.
                 do i1=1,nOrigRoxiRoc
                   do j1=1,3
                     x1(j1)=taboRoc(i1,j1)
!gl!                 if(x1(j1)>1.0) x1(j1)=0.0
                     if (x1(j1) > 1.0) then
                         x1(j1) = delta_sol(j1)
                     endif
                   enddo
                   call xdist(x1,delta_sol,dist,s)
                   if(dist<distmin) distmin=dist
                 enddo
                 if (knw == 1) then
                   write(6,'(a,i5,3f10.4,f15.1,f8.3)') ! dedi
     *         'dist. orig. perm.', nRis, delta_sol, xyzs(4,i),distmin
                 endif
                 if(ksize<=3) then
                    if(distmin>0.15) then
                      sol_list(1:3,1)=delta_sol(:)
                      hsol = xyzs(4,i)
                      ksol = i
                      exit do_1
                    endif
                 else
                   if(distmin<0.15) iperm=1
                   if(iperm==0) ifOrigineNonPerm=1
                   sol_list(1:3,nRisCheck)=delta_sol(1:3)
                   sol_list(4,nRisCheck)=iperm
                   hsol = xyzs(4,i)
                   ksol = i
                 endif
               else 
c                if(ksize<=3) sol_list(1:3,1)=delta_sol(:)
                 if(ksize<=3) then
                    sol_list(1:3,1)=delta_sol(:)
                    hsol = xyzs(4,i)
                    ksol = i
                 endif
                 exit do_1
               endif
             endif
         endif
      enddo do_1
!
!--scelgo la soluzione da prendere
!
      if (kverbo.gt.0) then
          write(6,*) 'ifOrigineNonPerm=',ifOrigineNonPerm
      endif
      if (ifOrigineNonPerm == 1 .and. ksize > 3) then
!--prendo la soluzione con origine non permessa presente tra le soluzioni piu' probabili
        do iroc=1,nRisCheck
!         if(sol_list(4,iroc)==1) cycle
          if(nint(sol_list(4,iroc)) > 0) cycle
          ksol = iroc
          vet2(1:3)=sol_list(1:3,iroc)
          exit
        enddo
      else
!--prendo la prima soluzione ( anche con origine permessa )
        vet2(1:3)=sol_list(1:3,1)
      endif
*     if (numero_cicli == 53) then
*         write(6,*) 'MODIFICO PICCO'
*         vet2(1:3) = xyzs(1:3,8) 
*     endif

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! merge con sir PG

      if (ksol > 1) then
         rapp_hei =  xyzs(4,1)/hsol 
         if (rapp_hei > 2.0) then
            vet2(1) = side(xyzs(1,1))
            vet2(2) = side(xyzs(2,1))
            vet2(3) = side(xyzs(3,1))
            ksol = 1
            hsol = xyzs(4,1)
          write (lo,'(a,2f12.3)') ' IMPOSTO PICCO 1',hsol, rapp_hei
        end if
      end if

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
      if (nRis == 0) then
!        write(6,*) 'nessun picco trovato in TRASLAS' ! dedi
*         write(6,*) 'No peaks found (a)'
      else
         delta_sol(:) = vet2(:)
      endif

      endif

 1001 continue
!
!--rimetto a posto i valori
!
      nats=natsOld
      nz(1:nats)=nzsav(1:nats)
      xyzs=xyz30
      ihmx(:)=ihmxSav(:)
      if (ifRemo == 0) then
          call CheckGrid()
      else
          call CalcGrid
      endif

      if (ifTre == 1) then
          go to 1002
      endif


      if (nRis == 0) then
!        write(6,*) 'nessun picco trovato in TRASLAS' ! dedi
*         write(6,*) 'No peaks found, Relax aborted'
         if (ifVLD == 0) then
             ifAborted = 1
             ik = knw
             if(kverbo>0) call CPUTime('fine traslas',ik)
             return
         endif
      else
         delta_sol(:) = vet2(:)
      endif
!
! - modifiche dedi

*     if (nnew == 0) then

          if (ifVLD == 1 .and. nRis == 0) then
                 ntraslas = 1
                 delta_sol(1:3) = 0
          else
              if (icentSav == 0) then
                  ntraslas = 2
              else
                  ntraslas = 1
              endif
          endif

*     endif

      delta_tra(1,1:3) = delta_sol(1:3)

      if (ntraslas == 2) then
          delta_tra(2,1:3) = -delta_sol(1:3)
      endif

      if (knw /= 0) then 
          write(6,'(a,3f10.4,f12.2,i5)')
     *  ' Most probable Translations: ', delta_sol(:)
      endif

      do j = 1,ntraslas   ! 2 traslazioni

         delta_sol(:) = delta_tra(j,:)

         if (knw > 0) write(lo,109) j,delta_sol(1:3)
  109 format(11x,' NTRASLAS = ',i4,'  Translation applied:',3f7.4)
         do i=1,numbLSQ
            faze = dtor*iphazo(i) - twopi *
     *       (khl(1,i)*delta_sol(1) + khl(2,i)*delta_sol(2) + 
     *        khl(3,i)*delta_sol(3))
            work2(i) = faze
            iphz = nint(faze*rtod)+360000
            iphaz(i) = mod(iphz, 360)
            fcoef(i) = evet(i)
         enddo
         if (knw == 1) then
             ifExamin = 1
             izero = 0
             ifmin = 11
             call examin(-333,mkang,khl,ipub,iphaz,numbLSQ,izero,wt,
     *                   ifmin)
         endif
         fcoef(:) = fcoef(:) * wt(:)
         jpatt = 0
         if (j == 1) then
             call MakeMap(fcoef, iphaz, numbLSQ, jpatt, xenve,
     *                    FORTHenv,BACKenv)
         else
             call MakeMap(fcoef, iphaz, numbLSQ, jpatt, xmap,
     *                    FORTH, BACK)
         endif

      enddo
! - modifiche dedi
!

 1002 continue


      ik = knw
      if(kverbo>0) call CPUTime('fine traslas',ik)
!
      return
  100 format('Picco # ',i3,3f8.4,f15.3,i5)
      end
!-----------------------------------------------------------------------
      subroutine AnalizzaPicchi(n)
      USE General
      USE Riflessi
      USE PhaseModule
      Use Atomi
      USE RelaxMod
      USE VLDMod
!
      implicit none
      integer :: n, i, j, k, inChe, inCheshire, prevH, alMassimo, ier
      integer :: i1, j1, k1, ndistamin, ncont, jj, j2, numero_taboroc
      real    :: delta(3), deltaN(3), side, diff, del_sol(3)
      real    :: FomChe
      real    :: pippo
      real    :: distmin, dist, s(3), x1(3),x2(3),dista,distamin
      real    :: xyz_app (5,100)
      integer, allocatable :: BestFasi(:)
!
      allocate(BestFasi(1:nrefl), stat = ier)
!
! modifica Dedi: uso xyz_app al posto di xyzo per non sporcare questo vettore.
! modifica Dedi: per usare RELAX anche in Patterson
!
      xyz_app(:,:) = 0.0
      n = 0
      do i =1 , min0(nats,100)
         delta(1) = side( xyzs(1,i) )
         delta(2) = side( xyzs(2,i) )
         delta(3) = side( xyzs(3,i) )
         deltaN(1:3) = delta(1:3)
         do k=1, 3
            do j=1,5
               if (abs(deltaN(k) - ValCritici(j,1)) < EpsCritici) then
                   deltaN(k) = ValCritici(j,2)
               endif
            enddo
         enddo
         inChe = inCheshire(delta)
         if (knw /= 0 .and. kverbo_pg /= 0) then
             write(6,100) i, delta, deltaN, nint(xyzs(4,i)), inChe
         endif
         if (inChe == 1) then
             n = n + 1
             xyz_app(1:3, n) = delta(1:3)
             xyz_app(4  , n) = xyzs(4,i)
             xyz_app(5  , n) = i
         endif
      enddo
!
      if (knw == 1) write(lo,*)
      if (jsysSav == 6) then
          do j=1, n
             delta(1:3) = xyz_app(1:3, j)
             i = (nint(xyz_app(5,j)))
             if (i > 1) then
                 diff = abs( delta(1) - side( xyzs(1,i-1) ))
                 if (abs( diff - 0.5 ) < 0.01) then
                    diff = abs( delta(2) - side( xyzs(2,i-1) ))
                    if (abs( diff - 0.5 ) < 0.01) then
                        diff = abs( delta(3) - side( xyzs(3,i-1) ))
                        if (abs( diff - 0.5 ) < 0.01) then
                            xyz_app(5, j) = 0
                            if (knw == 1) then
                                write(6,*) 'Eliminato picco # ',i
                            endif
                        endif
                    endif
                endif
             endif
          enddo
      endif
!
!________________________________________________________________ 
      
      prevH = -9999
      do i =1, n
!--controllo se l'origine e' permessa
         distmin=9999.
         distamin=9999.
         do i1=1,nOrigRoxiRoc
           do j1=1,3
             x1(j1)=taboRoc(i1,j1)
             delta_sol(j1) = xyz_app(j1,i)
             
             if (x1(j1) > 10.0) then    !floating origin
                 x1(j1) = xyz_app(j1,i)
             end if
             if (x1(j1) > 1.0) then
!!!!!!!!!!!!!!!!!!!!!!!!!!!                 x1(j1) = xyz_app(j1,i)
                 x1(j1) = x1(j1) - 1.0 
             endif
           enddo
           call xdist(x1,delta_sol,dist,s)
           if(dist<distmin) then 
               distmin=dist
               numero_taboroc = i1
           end if
         enddo
!pg20012014         
         if (distmin < 0.2) then
!!!!!!!!!           if (ifMDM == 0) then
               if (ksize >= 3) then
                  xyz_app(5,i) = -xyz_app(5,i)
               else
!pg27012014
                  if (knw /= 0 .and .kverbo_pg /= 0) then
                     write(6,'(a,i3,a,3f10.4,f15.1,f8.3,i6)')'peak ',
     *                  nint(xyz_app(5,i)),'  eliminata orig perm.',
     *                  delta_sol, xyzs(4,i),distmin,numero_taboroc
                  end if
                  xyz_app(5,i) = 0
               end if
!!!!!!!!!!!           end if
         end if
!________________________________________________________________ 
         
!pg19022014
!         if (nint(xyz_app(5,i)) == 0) cycle
!         if (nint(xyz_app(4,i)) == prevH) then
!             xyz_app(5, i) = 0
!         else
!             
!              prevH = nint(xyz_app(4,i))
!         end if 
      end do

!elimina i picchi relazionati ad altri gia' presi per traslazioni permesse
      do i=1, n
         if (nint(xyz_app(5,i)) /= 0) then
             do jj=-1, 1, 2
                 delta_sol(1:3) = xyz_app(1:3,i) * jj
                 do i1=1,nOrigRoxiRoc
                    do j1=1,3
                       x1(j1)=taboRoc(i1,j1)
                       if (x1(j1) > 10.0) then    !floating origin
                           x1(j1) = xyz_app(j1,i)
                       end if
                       if (x1(j1) > 1.0) then
                           x1(j1) = x1(j1) - 1.0 
                       endif
                    end do
             
                    del_sol(1:3) = delta_sol(1:3) + x1(1:3)
                    do j2=1, i-1
                       if (nint(xyz_app(5,j2)) /= 0) then
                          x2(1:3) = xyz_app(1:3,j2) 
 !            if (jj==1) then 
 !            if (nint(xyz_app(5,j2)) == 11 .and.nint(xyz_app(5,i)) == 12) then
 !                pippo=0
 !            end if    
 !            end if
                          call xdist(x2,del_sol,dist,s)
 !            if (nint(xyz_app(5,j2)) == 11 .and.nint(xyz_app(5,i)) == 12) then
 !            write(lo,'(2(a,i3,3f8.4),f8.3)') 'picco ',
 !    *       nint(xyz_app(5,i)), del_sol(1:3) ,' con',
 !    *       nint(xyz_app(5,j2)), x2(1:3), dist
 !             end if
                          
                          if (dist < 0.2) then
                if (knw /= 0 .and. kverbo_pg /= 0) then
             write(lo,'(2(a,i3,3f8.4),f8.3,i6)') 'picco eliminato',
     *       nint(xyz_app(5,i)), xyz_app(1:3,i) ,' equivalente a',
     *       nint(xyz_app(5,j2)), x2(1:3), dist, i1
                end if
                             xyz_app(5, i) = 0
                             exit
                          end if
                       end if
                    end do
                    if (nint(xyz_app(5,i)) == 0) then
                       exit
                    end if
                 end do
                 if (nint(xyz_app(5,i)) == 0) then
                     exit
                 end if
             end do
         end if
      end do
!pg19022014

!pg201213
      do i=1, n
         if (nint(xyz_app(5,i)) /= 0) then
            if (knw /= 0 .and. kverbo_pg /= 0) then
              write(6,200) nint(xyz_app(5,i)), xyz_app(1:3,i), 
     *                                      nint(xyz_app(4,i))
            end if
         endif
      enddo
!
!-- elimina i picchi da xyz_app considerandone alMassimo
!
      alMassimo = 3
      j = 0
      do i =1, n
         if (nint(xyz_app(5,i)) /= 0) then
             j = j + 1
             xyz_app(1:5,j) = xyz_app(1:5,i)
             if (j == alMassimo) then
                 exit
             endif
         endif
      enddo
      n = j
      alMassimo = min0(alMassimo,j)
      
      j = 1
      do i =1, alMassimo-1
         if (xyz_app(5,i) < 0) then
             j = j + 1
         elseif (xyz_app(4,i)/xyz_app(4,i+1) > 1.5) then
             j = i
             exit
         else 
             j = j + 1
         end if
      enddo
      n = j
      if (knw /= 0 .or.kverbo_pg /= 0) then
          if (n == 1) then
             write(lo,'(/,a,i2,a)') 'Going to analyze the first peak.'
          else
             write(lo,'(/,a,i2,a)') 'Going to analyze ',n,' peaks.'
          end if
      endif
      Rap_Picchi(1) = 1.0
      k = 1
      if (xyz_app(5,1) < 0) then
          k = 2
      end if
      do i = 2, n
          Rap_Picchi(i) = xyz_app(4,k) / xyz_app(4,i)
      end do
!
      ihmx(:) = ihmxSav(:)
      if (ifRemo == 0) then
          call CheckGrid()
      else
          call CalcGrid
      end if
!      
      BestFomChe = -9999
      ncont = size(FasiRelax)
      do i =1 , n
*        iphazo(1:nreflDim) = FasiRelax(1:nreflDim)
*        wt(1:nreflDim)     = PesiRelax(1:nreflDim)
         iphazo(1:ncont) = FasiRelax(1:ncont)
         wt(1:ncont)     = PesiRelax(1:ncont)
         delta(1:3) = xyz_app(1:3,i)
         call CalcolaFomCheshire(delta,FomChe,i,n,BestFasi)
         if (knw /= 0 .and. kverbo_pg /= 0) then
             write(6,300) nint(xyz_app(5,i)), xyz_app(1:3,i),
     *                               FomChe, erore
         endif
      enddo
!
*     iphazo(1:nreflDim) = FasiRelax(1:nreflDim)
*     wt(1:nreflDim)     = PesiRelax(1:nreflDim)
      iphazo(1:ncont) = FasiRelax(1:ncont)
      wt(1:ncont)     = PesiRelax(1:ncont)
      iphaz(1:nrefl) = BestFasi(1:nrefl)
      call examin(-222,mkang,khl,ipub,iphaz,numbLSQ,0,wt,1)
      deallocate(BestFasi, stat = ier)
!
      return
  100 format('Picco # ',i4,3f8.4,2x,3f8.4,i10,i3)
  200 format('Picco # ',i4,3f8.4,i10)
  220 format('Picco ##',i4,3f8.4,i10,f8.4,i4)
  300 format('Picco # ',i4,3f8.4,' Fom = ',f8.4,'  MPE = ',f6.2)
      end
!-----------------------------------------------------------------------
      subroutine CalcolaFomCheshire(delta, FomChe, picco, npicchi,
     *                               BestFasi)
      USE General
      USE Riflessi
      USE PhaseModule
      USE Mappa
      USE RemoModule
      USE RelaxMod
      USE VLDmod_3, only : FinalFom2
!
      implicit none
      integer :: i, j, kstp, iphz, jpatt, iAll, ifmin, izero, ici, ier
      integer :: AggiornaFasi, kverbo_pg_sav, ifExaminSav, ifTime_sav
      integer :: picco, npicchi, BestFasi(1:nrefl)
      real    :: delta(3), faze, FomChe, chope, ffmm, corre
!
      if (knw /= 0) then
          write(6,'(/,a,/,a,3f10.4,f12.2,i5)')
     *  '-------------------------------------------------',
     *  ' Examining Translation: ', delta(:)
      endif
      if (icentSav == 0) then
          ntraslas = 2
          delta_tra(1,1:3) =  delta(1:3)
          delta_tra(2,1:3) = -delta(1:3)
      else
          ntraslas = 1
          delta_tra(1,1:3) = delta(1:3)
      endif

      ifExamin = 1
      ifmin = 11
      jpatt = 0
      invflag = 1
      percmap = 0.20
!
      do j = 1,ntraslas   ! 2 traslazioni
         delta_sol(:) = delta_tra(j,:)
         if (knw > 0) write(lo,109) j,delta_sol(1:3)
         do i=1,numbLSQ
            faze = dtor*iphazo(i) - twopi *
     *       (khl(1,i)*delta_sol(1) + khl(2,i)*delta_sol(2) +
     *        khl(3,i)*delta_sol(3))
            work2(i) = faze
            iphz = nint(faze*rtod)+360000
            iphaz(i) = mod(iphz, 360)
            fcoef(i) = evet(i)
         enddo
         if (knw == 1) then
             ifExamin = 1
             izero = 0
             ifmin = 11
             call examin(-333,mkang,khl,ipub,iphaz,numbLSQ,izero,wt,
     *                   ifmin)
         endif
         fcoef(:) = fcoef(:) * wt(:)
         jpatt = 0
         if (j == 1) then
             call MakeMap(fcoef, iphaz, numbLSQ, jpatt, xenve,
     *                    FORTHenv,BACKenv)
         else
             call MakeMap(fcoef, iphaz, numbLSQ, jpatt, xmap,
     *                    FORTH, BACK)
         endif
      enddo

      call FromGStoP1toGS(2)

      do i=ntraslas, 1, -1
         if (ntraslas == 1) then
             call NewInvCuda(iphaz,fcvet,nrefl,np(1),np(2),np(3),
     *                       BACKenv, xenve)
         elseif (ntraslas > 1) then
            if (i == 1) then
                iphazo(:) = iphaz(:)
                worko(:)  = wt(:)
                ffmm = FinalFom
                call NewInvCuda(iphaz,fcvet,nrefl,np(1),np(2),np(3),
     *                          BACKenv, xenve)
            else
                call NewInvCuda(iphaz,fcvet,nrefl,np(1),np(2),np(3),
     *                          BACK, xmap)
            endif
         endif
!
         ifSigmaA = 0   ! da testare ifSigmaA=1 (per usare la nuova SigmaA)
         iAll = 1
         chope = 0.5
         call CalcolaPesi(numbLSQ,numbLSQ,chope,iAll)
         if (noDSR == 0) then
             izero = 0
             ifmin = 1
             call examin(-555,mkang,khl,ipub,iphaz,numbLSQ,izero,
     *                   wt,ifmin)
         endif
         if (ifVLD == 0) then
             if (knw == 1 .and. ifTime == 0) then
                 kstp = 1
                 call Calcola_CC_Mappa(numbLSQ,corre,kstp,2)
             endif
             if (ksize <= 3) then
                 call Calcola_FOM_Lib(1)
                 FinalFom0 = FOMs(2,4)
                 FinalFom  = FinalFom0 / sogFinalFom
             else
                 ifReduced = 1
                 call Calcola_FinalFom(0)
                 call Calcola_FinalFom2(0)
                 ifReduced = 0
             endif
         else
             call CalcFFomVLD(0,0.0)
             if (knw > 0) then
                 write(6,*) 'RELAX CalcFFomVLD',FinalFom
             endif
         endif
         if (knw > 0) then
             write(lo,15) i, FinalFom,delta_tra(i,:)
             write(lo,10) FinalFom
         endif
      enddo
!
      if (ntraslas > 1) then
          if (FinalFom < ffmm) then
              iphaz(:) = iphazo(:)
              wt(:) = worko(:)
              delta_sol(:) = delta_tra(2,:)
              FinalFom = ffmm
          else
              delta_sol(:) = delta_tra(1,:)
          endif
      else
         delta_sol(:) = delta_tra(1,:)
      endif
      
      FomChe = FinalFom
      
!pg201213
      if (ksize > 3333) then
cdedi
         if (ifVLD == 1) then  !dedi 08/01/14 solo se VLD o MDM
cdedi
          if (knw == 1) then
              ifExamin = 1
              izero = 0
              ifmin = 11
              call examin(-123,mkang,khl,ipub,iphaz,numbLSQ,izero,wt,
     *                   ifmin)
          endif
          ici = 1
!         if (ksize > 3) then
              call PostDSR_VLD(corre, ici, ier)
!         end if
          if (knw == 1) then
              ifExamin = 1
              izero = 0
              ifmin = 11
              call examin(-124,mkang,khl,ipub,iphaz,numbLSQ,izero,wt,
     *                    ifmin)
          endif
          call CalcFFomVLD(0,0.0)  !da non applicare se DM o PATT perchè FFomVLD non è confrontabile con FFom
          if (knw == 1) then
              ifExamin = 1
              izero = 0
              ifmin = 11
              call examin(-125,mkang,khl,ipub,iphaz,numbLSQ,izero,wt,
     *                    ifmin)
          endif

cdedi
        endif
cdedi
*         FomChe=CCEoEc(1)*FOMs(2,4)*diffCC/(fomold(1)*fomold(3))
          fcoef (1:nrefl) = evet(1:nrefl) * wt(1:nrefl)
          jpatt = 0
          call MakeMap(fcoef, iphaz, nrefl, jpatt, xmap,
     *                 FORTH, BACK)
          AggiornaFasi  = 0
          kverbo_pg_sav = 0
          ifExaminSav   = 1
          ifTime_sav    = 0
          ifTraslas     = 1
!         if (ksize > 3) then
          call MiglioraFasi_2(AggiornaFasi, kverbo_pg_sav, ifExaminSav,
     *                        ifTime_sav, corre)
          if (knw == 1) then
              write(6,*) 'MiglioraFasi_2 fFom, fFom2',FinalFom,FinalFom2
          endif
          ifTraslas     = 0
          if (knw == 1) then
              ifExamin = 1
              izero = 0
              ifmin = 11
              call examin(-125,mkang,khl,ipub,iphaz,numbLSQ,izero,wt,
     *                    ifmin)
          endif
      end if

      FomChe = FinalFom / Rap_Picchi(picco)
      if (FomChe > BestFomChe) then
          BestFomChe = FomChe
          Best_Tra(:) = delta_sol(:)
          BestFasi(1:nrefl) = iphaz(1:nrefl)
      endif
      if (picco < npicchi) then
          call FromGStoP1toGS(1)
      endif

!
      return
   10 format(11x,' End of RELAX FOMs =',2f9.3,/)
   15 format(11x,' NTRASLAS = ',i4,' Final FOM =',f7.3,' DELTA: ',3f7.4)
  109 format(11x,' NTRASLAS = ',i4,'  Translation applied:',3f7.4)
      end
!-----------------------------------------------------------------------
      subroutine TraslasOLd(ifFromRelax, jsysSav)
!
!--faccio la traslazione con la FFT
!
      USE General
      USE Symmetry
      USE Riflessi
      USE Riflessi_c
      USE Atomi
      USE Mappa
      USE MappaAutre
      USE RemoModule
      USE PhaseModule
!
      logical :: noWrite
      common/util2/noWrite
      dimension vet2(3),vet(3)
      integer iHcan(3),hklmin(3),hklmax(3),hkl(3),hmax1,hmax2,hmax3
      integer inCheshire
      character spaceg*16
*     integer, allocatable :: iworki(:,:)
      dimension x1(3),s(3)
      dimension sol_list(4,50)
!
      if(kverbo>0) call CPUTime0('inizio traslas')
!
      write(spaceg,'(16a1)') (nSpaceG(i),i=1,16)
!
      call ucase(spaceg(1:1))
      if (ifFromRelax == 1) then
          l = Lung(spaceg)
          write(Inte,10) numbrun,spaceg(1:l)
      else
          write(Inte,20) numbrun
          call OneBlankOnly(Inte)     
      endif
      call scrper(Inte,0,-1)
   10 format('End of RELAX procedure for trial ',i5,
     *       '. Now back in ',a,' ...')
   20 format('Trial ',i5,': moving in P -1')
!
      call CheshireTra()
      alim=nGridv(1)*nGridv(2)*nGridv(3)  
!
      if (.not. allocated(iworki)) then
          allocate(iworki(2,numbLSQ), stat=ierr)
      endif
      iworki(:,:)=0.0
      avterm = 0.0
      acont  = 0.0
      do i=1, numbLSQ
         iphazo(i)=iphaz(i)
         if (wt(i) > 0.01) then
             work2(i) = fovet(i)
             avterm = avterm + work2(i)
             acont  = acont + 1
         else
             work2(i) = 0.0
         endif
         if (iwork1(i) > 0) then
              iwk = iwork1(i)
          else
              iwk = -iwork1(i)
          endif
          ii = jwork1(i)
          jj = iwk / 100
          iworki(1,i) = jj      ! operatore di simm.
          if (jj == 1) then
              iworki(2,i) = 1   ! numero di equiv. per il riflesso
              iia = i
          else
              iworki(2,iia) = iworki(2,iia) + 1
          endif
      enddo
      avterm = avterm / acont
c
c--definisco la nuova griglia dello spazio reciproco sulla quale 
c  fare la FFT per trovare la traslazione
c
      ihmxSav(:)=ihmx(:)
      frac=1.0
c     frac=2.0 ! per aumentare il numero di riflessi per la FFT
      asym=2.0*nsym*(icent+1)*pts
      term=resm**3*(nrefl*3.0*asym)/(4.0*Pi*volume)
      res=resm/(1+frac*term)**0.333
      rhomax1 = 0.25/(res*res)
      resolMax = res
      eps1=rhomax1/25.  ! allargo leggermente la corona circolare
c
c----------4/3*pi*Hmax
      previsti=0.5*(4.0/3.0)*Pi*(volume/resolMax**3)
      nRifDimC=ceiling(1.2*previsti)
      hmax1=ceiling(cell(1)/resolMax)+1
      hmax2=ceiling(cell(2)/resolMax)+1
      hmax3=ceiling(cell(3)/resolMax)+1
      if(ihmx(1)>hmax1) hmax1=ihmx(1)
      if(ihmx(2)>hmax2) hmax2=ihmx(2)
      if(ihmx(3)>hmax3) hmax3=ihmx(3)
      ihmx(1)=hmax1
      ihmx(2)=hmax2
      ihmx(3)=hmax3
!
!-- conta i riflessi per un corretto uso di AllocaRiflessi_c
!
      nrr = 0
      do indh=0,hmax1
         indkmin=-hmax2
         if(indh==0) indkmin=0
         do indk=indkmin,hmax2
            indlmin=-hmax3
            if(indh==0.and.indk==0) indlmin=1
            do indl=indlmin,hmax3
               rho1 = rhof(pp,indh,indk,indl)
               rho  = rho1 * rho1
               if (rho > rhomax1+eps1) cycle
               nrr = nrr + 1
            enddo
         enddo
      enddo
      nRifDimC = nrr
      if (knw ==1) write(6,*) 'riflessi effettivi: ',nrr
      call AllocaRiflessi_c(1)
!
      nrr = 0
      hklmin(:) =  9999
      hklmax(:) = -9999
      do indh=0,hmax1
         indkmin=-hmax2
         if(indh==0) indkmin=0
         do indk=indkmin,hmax2
            indlmin=-hmax3
            if(indh==0.and.indk==0) indlmin=1
            do indl=indlmin,hmax3
               rho1 = rhof(pp,indh,indk,indl)
               rho  = rho1 * rho1
               if (rho > rhomax1+eps1) cycle
               vet(1)=indh
               vet(2)=indk
               vet(3)=indl
               call controllo_indici_interi(vet,hkl)
               nrr = nrr + 1
               khlc(1:3,nrr) = hkl(1:3)
               indr = hkl(1) * ifat1C + hkl(2) * ifat2C + hkl(3)
               superind(indr) = nrr
               do j1=1,3
                  if (hkl(j1) < hklmin(j1)) hklmin(j1)=hkl(j1)
                  if (hkl(j1) > hklmax(j1)) hklmax(j1)=hkl(j1)
               end do 
            enddo
         enddo
      enddo
      nRifDimC = nrr
!
!-- salvo le variabili
!
      ifPattSav = ifPatt
      natsOld = nats
      nzsav(1:nats) = nz(1:nats)
      xyz30(:,:) = xyzs(:,:)
!
!-- create the TF Map
!
      fcvetc=0.0
      fcvets=0.0
      numbPhased = 0
      i = 0
      do
         i = i + 1
         if (i > numbLSQ) exit
         jj = iworki(1,i)   ! operatore di simm.
         if(jj == 1) then
           numbEq = iworki(2,i)
           if(icentTrue==0) then
             numbEqTrue=numbEq
           else
             numbEqTrue=numbEq*2
           endif
           do m2=1, numbEqTrue-1
             m2True=mod(m2,numbEq)
             if(m2True==0) m2True=numbEq
             if(m2<=numbEq) then
               iicc2=1
             else
               cycle ! elimino i riflessi -H
               iicc2=-1
             endif
             n2 = i + m2True - 1
             k2 = iworki(1,n2)
             do m1=m2+1, numbEqTrue
               m1True=mod(m1,numbEq)
               if(m1True==0) m1True=numbEq
               if(m1<=numbEq) then
                 iicc1=1
               else
                 if(m1True<m2True) cycle ! elimino i riflessi con fase opposta
                 iicc1=-1
               endif
               n1  = i + m1True - 1
               k1 = iworki(1,n1)
               tt = 0
               do k=1,3
                  vet2(k) = khl(1,i)*(iicc2*kmat(k2,1,k)
     &                               -iicc1*kmat(k1,1,k))
     &                    + khl(2,i)*(iicc2*kmat(k2,2,k)
     &                               -iicc1*kmat(k1,2,k))
     &                    + khl(3,i)*(iicc2*kmat(k2,3,k)
     &                               -iicc1*kmat(k1,3,k))
                  tt = tt + khl(k,i)*(tmat(k1,k)-tmat(k2,k))
               enddo
               call controllo_indici_interi(vet2,iHcan)
!-- seleziono i riflessi H
!
!--controllo importante, altrimenti il superindice non funziona!!
               if(abs(iHcan(1))>hmax1.or.
     &            abs(iHcan(2))>hmax2.or.
     &            abs(iHcan(3))>hmax3) cycle
               indr = iHcan(1)*ifat1C + iHcan(2)*ifat2C + iHcan(3)
               if(indr>0.and.indr <= ifatxC) then
                 kk = superind(indr)
                 if(kk > 0) then
!
!--calcolo i coefficienti
!
                   arg = - (iicc1*iphazo(n1)
     &                        - iicc2*iphazo(n2) + 360*tt)
                   term = work2(n1) * work2(n2)
                   term=term/(avterm*avterm)
                   fcvetc(kk)=fcvetc(kk)+term*cos(dtor*arg)
                   fcvets(kk)=fcvets(kk)+term*sin(dtor*arg)
                   numbPhased = numbPhased + 1
c                  write(6,'(a,3i5,3i4,4x,3i4,2f13.3)') 
c    &                 'indici ',i,k1,k2,khl(1:3,i),iHcan,term,arg
                 endif
               endif
             enddo
           enddo
           i = i + numbEq - 1
         else
           call cstop(' error in Traslas ')
         endif
      enddo
c
*     deallocate (iworki, stat=ierr)
      if (knw == 1)  write(6,*) numbPhased, ' riflessi fasati'
c
*     call AllocaMappa(2)
      ihmx(1:3)=hklmax(1:3)
      call CheckGrid()
      do i=1,3
        if(ihmx(i)==0) np(i)=3
      enddo
*     call AllocaMappa(1)
      
      npAutre(:) = np(:)
      call AllocaMappaAutre(1)
!
c
c--cambio gruppo spaziale ( no perche' sono gia' in P1 )
c
      latt=1 ! evita di considerare la centratura
      call MakeMapMR(xmapAutre, xmapCa, FORTHa, BACKa, npAutre,
     *               FFTW_ESTIMATE)
c
c     do ix=0,np(1)-1
c     do iy=0,np(2)-1
c     do iz=0,np(3)-1
c       xx=xmap(ix,iy,iz)
c       write(87,*) ix,iy,iz,xx
c     enddo
c     enddo
c     enddo
!
!-- ricerca i picchi sulla mappa bidimensionale (non lo posso fare sulla mappa
!   per colonne)
!
      if (nGridv(1) == 1) then
          xmapAutre(1:np(1)-1,0:np(2)-1,0:np(3)-1) = 0.0
      elseif (nGridv(2) == 1) then
          xmapAutre(0:np(1)-1,1:np(2)-1,0:np(3)-1) = 0.0
      elseif (nGridv(3) == 1) then
          xmapAutre(0:np(1)-1,0:np(2)-1,1:np(3)-1) = 0.0
      endif
c
c--cerco i picchi in P1 
c
      nats=0
      xyzs(:,:)=0.0
      krecy=0
      ihalf=0  ! per fare il peak search su tutta la cella 
      term = alim / 50.0
      term = max(10.0, term)
      term = min(term, float(MaxAtoms-1))
*     call pksrch_New(-1,1,nreflDim,ier)
!
      ifPatt = 0
      iflagPKS = 1
      npic = term
      call pksrch_core(xmapAutre, np, ifPatt, iflagPKS, npic, dm,
     *                 NumPeaks, ier)
      nats = NumPeaks
      if (knw == 1)  then
          write(6,*) ' Altezza Picchi '
          do nR = 1,nats
             write(6,'(i5,3f10.4,f15.2)') nR, xyzs(1:4,nR)
          enddo
      endif
!
c     if (knw == 1)  write(6,*) ' Most probable Translations: '
c
      nRisCheck=0
      ifOrigineNonPerm=0
      delta_sol(:) = 0.0
      nRis = 0
*     do i = 1 , nats
*        write(6,*) 'picco trovato ',i,xyzs(1:3,i),xyzs(4,i)
*     enddo
      do_1: do i = 1 , nats
c        if (knw == 1) 
c         write(6,12) 'picco trovato ',i,xyzs(1:3,i),xyzs(4,i)
  12   format(a,i5,3f8.4,f10.2)
         delta_sol(1) = side( xyzs(1,i) )
         delta_sol(2) = side( xyzs(2,i) )
         delta_sol(3) = side( xyzs(3,i) )
         if (inCheshire(delta_sol) == 1) then
c           write(6,12) 'picco esaminato',i,delta_sol(1:3),xyzs(4,i)
c
c--scarto soluzioni nel caso di gruppo di Cheshire con I e con
c  cella di cheshire che non esclude posizioni collegate da I
c  (avviene solo nel cubico)
c
             if (jsys == 6 .and. i > 1) then
                 diff = abs( delta_sol(1) - side( xyzs(1,i-1) ))
                if (abs( diff - 0.5 ) < 0.01) then
                    diff = abs( delta_sol(2) - side( xyzs(2,i-1) ))
                    if (abs( diff - 0.5 ) < 0.01) then
                        diff = abs( delta_sol(3) - side( xyzs(3,i-1) ))
                        if (abs( diff - 0.5 ) < 0.01) then
                            cycle
                        endif
                    endif
                endif
             endif
c
             nRis = nRis + 1
c
c--controllo se la soluzione e' troppo vicina ad una origine permessa
c
             if(ifRhombAx==1) then
c--la variabile nOrigRoxi non e' corretta in questo caso
               vet2(:)=delta_sol(:)
               exit do_1
             else
!--per le soluzioni piu' alte, controllo se ci sono origini permesse
c              if(nRis==1) hmax=xyzs(4,i)
               if(nRis==1) then
                  hmax=xyzs(4,i)
                  kRis = i
               endif
c
               if(xyzs(4,i)>0.90*hmax) then
*gl*           if(xyzs(4,i)>0.00) then
*******          if (nRisCheck == 50) exit
                 iperm=0
                 nRisCheck=nRisCheck+1
!--controllo se l'origine e' permessa
                 distmin=9999.
                 do i1=1,nOrigRoxiRoc
                   do j1=1,3
                     x1(j1)=taboRoc(i1,j1)
!gl!                 if(x1(j1)>1.0) x1(j1)=0.0
                     if (x1(j1) > 1.0) then
                         x1(j1) = delta_sol(j1)
                     endif
                   enddo
                   call xdist(x1,delta_sol,dist,s)
                   if(dist<distmin) distmin=dist
                 enddo
                 if (knw == 1) then
                   write(6,'(a,i5,3f10.4,f15.1,f8.3)') ! dedi
     *         'dist. orig. perm.', nRis, delta_sol, xyzs(4,i),distmin
                 endif
                 if(ksize<=3) then
                    if(distmin>0.15) then
                      sol_list(1:3,1)=delta_sol(:)
                      hsol = xyzs(4,i)
                      ksol = i
                      exit do_1
                    endif
                 else
                   if(distmin<0.15) iperm=1
                   if(iperm==0) ifOrigineNonPerm=1
                   sol_list(1:3,nRisCheck)=delta_sol(1:3)
                   sol_list(4,nRisCheck)=iperm
                   hsol = xyzs(4,i)
                   ksol = i
                 endif
               else 
c                if(ksize<=3) sol_list(1:3,1)=delta_sol(:)
                 if(ksize<=3) then
                    sol_list(1:3,1)=delta_sol(:)
                    hsol = xyzs(4,i)
                    ksol = i
                 endif
                 exit do_1
               endif
             endif
         endif
      enddo do_1
!
!--scelgo la soluzione da prendere
!
      if(ifOrigineNonPerm==1.and.ksize>3) then
!--prendo la soluzione con origine non permessa presente tra le soluzioni piu' probabili
        do iroc=1,nRisCheck
          if(sol_list(4,iroc)==1) cycle
          vet2(1:3)=sol_list(1:3,iroc)
          exit
        enddo
      else
!--prendo la prima soluzione ( anche con origine permessa )
        vet2(1:3)=sol_list(1:3,1)
      endif
!
      if (nRis == 0) then
!        write(6,*) 'nessun picco trovato in TRASLAS' ! dedi
         write(6,*) 'No peaks found (b)'
      else
         delta_sol(:) = vet2(:)
      endif
!
!--rimetto a posto i valori
!
      ifPatt = ifPattSav
      nats=natsOld
      nz(1:nats)=nzsav(1:nats)
      xyzs=xyz30
*     call AllocaRiflessi_c(2)
*     call AllocaMappa(2)
      ihmx(:)=ihmxSav(:)
      call CheckGrid()
*     call AllocaMappa(1)
!
!g    write(lo,99) delta_sol(1:3)
!g 99 format(11x,' RELAX procedure ends. Translation applied:',3f7.4)
!
! - modifiche dedi
      if (icentSav == 0) then
          ntraslas = 2
      else
          ntraslas = 1
      endif

      delta_tra(1,1:3) = delta_sol(1:3)
      if (ntraslas == 2) then
          delta_tra(2,1:3) = -delta_sol(1:3)
      endif

      if (knw == 1) then 
          write(6,'(a,i5,3f10.4,f12.2,2i5,f12.2)')
     *  ' Most probable Translations: ',
     *                           ksol,delta_sol(:),hsol,nRis,kRis,hmax
      endif

c-- dedi  13/01/2011 
c     write(6,*) ' HSOL, HFOM: ',hsol,hFom
c-- dedi  13/01/2011 

      do j = 1,ntraslas   ! 2 traslazioni

*        if (j == 2) then
*            xenve(:,:,:) = xmap(:,:,:)
*        endif

         delta_sol(:) = delta_tra(j,:)

         if (knw > 0) write(lo,109) j,delta_sol(1:3)
  109 format(11x,' NTRASLAS = ',i4,'  Translation applied:',3f7.4)
         do i=1,numbLSQ
            faze = dtor*iphazo(i) - twopi *
     *       (khl(1,i)*delta_sol(1) + khl(2,i)*delta_sol(2) + 
     *        khl(3,i)*delta_sol(3))
            work2(i) = faze
            iphz = nint(faze*rtod)+360000
            iphaz(i) = mod(iphz, 360)
            fcoef(i) = evet(i)
         enddo
         if (knw == 1) then
             ifExamin = 1
             izero = 0
             ifmin = 11
             call examin(-333,mkang,khl,ipub,iphaz,numbLSQ,izero,wt,
     *                   ifmin)
         endif
         fcoef(:) = fcoef(:) * wt(:)
         jpatt = 0
         if (j == 1) then
             call MakeMap(fcoef, iphaz, numbLSQ, jpatt, xenve,
     *                    FORTHenv,BACKenv)
         else
             call MakeMap(fcoef, iphaz, numbLSQ, jpatt, xmap,
     *                    FORTH, BACK)
         endif

      enddo
! - modifiche dedi
!
      ik = knw
      if(kverbo>0) call CPUTime('fine traslas',ik)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Traslas_Relax(ifFromRelax, jsysSav)
!
!--faccio la traslazione con la FFT
!
      USE General
      USE Symmetry
      USE Riflessi
      USE Riflessi_c
      USE Atomi
      USE Mappa
      USE MappaAutre
      USE RemoModule
      USE PhaseModule
      USE VLDmod, only : ifOrigPerm
!
      logical :: noWrite
      common/util2/noWrite
      dimension vet2(3),vet(3)
      integer iHcan(3),hklmin(3),hklmax(3),hkl(3),hmax1,hmax2,hmax3
      integer inCheshire,iesOrigine
      character spaceg*16
*     integer, allocatable :: iworki(:,:)
      dimension x1(3),s(3)
      dimension sol_list(4,50)
      dimension xo(11),xn(11),keyx(10)
!
      if(kverbo>0) call CPUTime0('inizio traslas_relax')
!
      write(spaceg,'(16a1)') (nSpaceG(i),i=1,16)
!
      call ucase(spaceg(1:1))
      if (ifFromRelax == 1) then
          l = Lung(spaceg)
          write(Inte,10) numbrun,spaceg(1:l)
      else
          write(Inte,20) numbrun
          call OneBlankOnly(Inte)     
      endif
      call scrper(Inte,0,-1)
   10 format('End of RELAX procedure for trial ',i5,
     *       '. Now back in ',a,' ...')
   20 format('Trial ',i5,': moving in P -1')
!
      call CheshireTra()
      alim=nGridv(1)*nGridv(2)*nGridv(3)  
!
      if (.not. allocated(iworki)) then
          allocate(iworki(2,numbLSQ), stat=ierr)
      endif
      iworki(:,:)=0.0
      avterm = 0.0
      acont  = 0.0
      do i=1, numbLSQ
         iphazo(i)=iphaz(i)
         if (wt(i) > 0.01) then
             work2(i) = fovet(i)
             avterm = avterm + work2(i)
             acont  = acont + 1
         else
             work2(i) = 0.0
         endif
         if (iwork1(i) > 0) then
              iwk = iwork1(i)
          else
              iwk = -iwork1(i)
          endif
          ii = jwork1(i)
          jj = iwk / 100
          iworki(1,i) = jj      ! operatore di simm.
          if (jj == 1) then
              iworki(2,i) = 1   ! numero di equiv. per il riflesso
              iia = i
          else
              iworki(2,iia) = iworki(2,iia) + 1
          endif
      enddo
      avterm = avterm / acont
c
c--definisco la nuova griglia dello spazio reciproco sulla quale 
c  fare la FFT per trovare la traslazione
c
      ihmxSav(:)=ihmx(:)
      frac=1.0
c     frac=2.0 ! per aumentare il numero di riflessi per la FFT
      asym=2.0*nsym*(icent+1)*pts
      term=resm**3*(nrefl*3.0*asym)/(4.0*Pi*volume)
      res=resm/(1+frac*term)**0.333
      rhomax1 = 0.25/(res*res)
      resolMax = res
      eps1=rhomax1/25.  ! allargo leggermente la corona circolare
c
c----------4/3*pi*Hmax
      previsti=0.5*(4.0/3.0)*Pi*(volume/resolMax**3)
      nRifDimC=ceiling(1.2*previsti)
      hmax1=ceiling(cell(1)/resolMax)+1
      hmax2=ceiling(cell(2)/resolMax)+1
      hmax3=ceiling(cell(3)/resolMax)+1
      if(ihmx(1)>hmax1) hmax1=ihmx(1)
      if(ihmx(2)>hmax2) hmax2=ihmx(2)
      if(ihmx(3)>hmax3) hmax3=ihmx(3)
      ihmx(1)=hmax1
      ihmx(2)=hmax2
      ihmx(3)=hmax3
!
!-- conta i riflessi per un corretto uso di AllocaRiflessi_c
!
*     go to 1111

      nrr = 0
      do indh=0,hmax1
         indkmin=-hmax2
         if(indh==0) indkmin=0
         do indk=indkmin,hmax2
            indlmin=-hmax3
            if(indh==0.and.indk==0) indlmin=1
            do indl=indlmin,hmax3
               rho1 = rhof(pp,indh,indk,indl)
               rho  = rho1 * rho1
               if (rho > rhomax1+eps1) cycle
               nrr = nrr + 1
            enddo
         enddo
      enddo
      nRifDimC = nrr
      if (knw ==1) write(6,*) 'riflessi effettivi: ',nrr
      call AllocaRiflessi_c(1)
!
      nrr = 0
      hklmin(:) =  9999
      hklmax(:) = -9999
      do indh=0,hmax1
         indkmin=-hmax2
         if(indh==0) indkmin=0
         do indk=indkmin,hmax2
            indlmin=-hmax3
            if(indh==0.and.indk==0) indlmin=1
            do indl=indlmin,hmax3
               rho1 = rhof(pp,indh,indk,indl)
               rho  = rho1 * rho1
               if (rho > rhomax1+eps1) cycle
               vet(1)=indh
               vet(2)=indk
               vet(3)=indl
               call controllo_indici_interi(vet,hkl)
               nrr = nrr + 1
               khlc(1:3,nrr) = hkl(1:3)
               indr = hkl(1) * ifat1C + hkl(2) * ifat2C + hkl(3)
               superind(indr) = nrr
               do j1=1,3
                  if (hkl(j1) < hklmin(j1)) hklmin(j1)=hkl(j1)
                  if (hkl(j1) > hklmax(j1)) hklmax(j1)=hkl(j1)
               end do 
            enddo
         enddo
      enddo
      nRifDimC = nrr

 1111 continue
      
*     call space_hRsRq
!
!-- salvo le variabili
!
      natsOld = nats
      nzsav(1:nats) = nz(1:nats)
      xyz30(:,:) = xyzs(:,:)
!
!-- create the TF Map
!
      fcvetc=0.0
      fcvets=0.0
      numbPhased = 0
      i = 0
      do
         i = i + 1
         if (i > numbLSQ) exit
         jj = iworki(1,i)   ! operatore di simm.
         if(jj == 1) then
           numbEq = iworki(2,i)
           if(icentTrue==0) then
             numbEqTrue=numbEq
           else
             numbEqTrue=numbEq*2
           endif
           do m2=1, numbEqTrue-1
             m2True=mod(m2,numbEq)
             if(m2True==0) m2True=numbEq
             if(m2<=numbEq) then
               iicc2=1
             else
               cycle ! elimino i riflessi -H
               iicc2=-1
             endif
             n2 = i + m2True - 1
             k2 = iworki(1,n2)
             do m1=m2+1, numbEqTrue
               m1True=mod(m1,numbEq)
               if(m1True==0) m1True=numbEq
               if(m1<=numbEq) then
                 iicc1=1
               else
                 if(m1True<m2True) cycle ! elimino i riflessi con fase opposta
                 iicc1=-1
               endif
               n1  = i + m1True - 1
               k1 = iworki(1,n1)
               tt = 0
               do k=1,3
                  vet2(k) = khl(1,i)*(iicc2*kmat(k2,1,k)
     &                               -iicc1*kmat(k1,1,k))
     &                    + khl(2,i)*(iicc2*kmat(k2,2,k)
     &                               -iicc1*kmat(k1,2,k))
     &                    + khl(3,i)*(iicc2*kmat(k2,3,k)
     &                               -iicc1*kmat(k1,3,k))
                  tt = tt + khl(k,i)*(tmat(k1,k)-tmat(k2,k))
               enddo
               call controllo_indici_interi(vet2,iHcan)
!
!-- seleziono i riflessi H
!
!--controllo importante, altrimenti il superindice non funziona!!
               if(abs(iHcan(1))>hmax1.or.
     &            abs(iHcan(2))>hmax2.or.
     &            abs(iHcan(3))>hmax3) cycle
               indr = iHcan(1)*ifat1C + iHcan(2)*ifat2C + iHcan(3)
               if(indr>0.and.indr <= ifatxC) then
                 kk = superind(indr)
                 if(kk > 0) then
!
!--calcolo i coefficienti
!
                   arg = - (iicc1*iphazo(n1)
     &                        - iicc2*iphazo(n2) + 360*tt)
                   term = work2(n1) * work2(n2)
                   term=term/(avterm*avterm)
                   fcvetc(kk)=fcvetc(kk)+term*cos(dtor*arg)
                   fcvets(kk)=fcvets(kk)+term*sin(dtor*arg)
                   numbPhased = numbPhased + 1
c                  write(6,'(a,3i5,3i4,4x,3i4,2f13.3)') 
c    &                 'indici ',i,k1,k2,khl(1:3,i),iHcan,term,arg
                 endif
               endif
             enddo
           enddo
           i = i + numbEq - 1
         else
           call cstop(' error in Traslas ')
         endif
      enddo
c
*     deallocate (iworki, stat=ierr)
      if (knw == 1)  write(6,*) numbPhased, ' riflessi fasati'
c
*     call AllocaMappa(2)
      ihmx(1:3)=hklmax(1:3)
      call CheckGrid()
      do i=1,3
        if(ihmx(i)==0) np(i)=3
      enddo
*     call AllocaMappa(1)
      
      npAutre(:) = np(:)
      call AllocaMappaAutre(1)
!
c
c--cambio gruppo spaziale ( no perche' sono gia' in P1 )
c
      latt=1 ! evita di considerare la centratura
      call MakeMapMR(xmapAutre, xmapCa, FORTHa, BACKa, npAutre,
     *               FFTW_ESTIMATE)
c
c     do ix=0,np(1)-1
c     do iy=0,np(2)-1
c     do iz=0,np(3)-1
c       xx=xmap(ix,iy,iz)
c       write(87,*) ix,iy,iz,xx
c     enddo
c     enddo
c     enddo
!
!-- ricerca i picchi sulla mappa bidimensionale (non lo posso fare sulla mappa
!   per colonne)
!
      if (nGridv(1) == 1) then
          xmapAutre(1:np(1)-1,0:np(2)-1,0:np(3)-1) = 0.0
      elseif (nGridv(2) == 1) then
          xmapAutre(0:np(1)-1,1:np(2)-1,0:np(3)-1) = 0.0
      elseif (nGridv(3) == 1) then
          xmapAutre(0:np(1)-1,0:np(2)-1,1:np(3)-1) = 0.0
      endif
c
c--cerco i picchi in P1 
c
      nats=0
      xyzs(:,:)=0.0
      krecy=0
      ihalf=0  ! per fare il peak search su tutta la cella 
      term = alim / 50.0
      term = max(10.0, term)
      term = min(term, float(MaxAtoms-1))
*     call pksrch_New(-1,1,nreflDim,ier)
!
      ifPatt = 0
      iflagPKS = 1
      npic = term
      call pksrch_core(xmapAutre, np, ifPatt, iflagPKS, npic, dm,
     *                 NumPeaks, ier)
      nats = NumPeaks

c     if (knw == 1)  then
c         write(6,*) ' Altezza Picchi '
c         do nR = 1,nats
c            write(6,'(i5,3f10.4,f15.2)') nR, xyzs(1:4,nR)
c         enddo
c     endif
!
c     if (knw == 1)  write(6,*) ' Most probable Translations: '
c
      nRisCheck=0
      ifOrigineNonPerm=0
      delta_sol(:) = 0.0
      nRis = 0
      do_1: do i = 1 , nats
c        if (knw == 1) 
c    *   write(6,12) 'picco trovato ',i,xyzs(1:3,i),xyzs(4,i)
 12   format(a,i5,3f8.4,f10.2)
         delta_sol(1) = side( xyzs(1,i) )
         delta_sol(2) = side( xyzs(2,i) )
         delta_sol(3) = side( xyzs(3,i) )
c        if (inCheshire_Relax(delta_sol) == 1) then
         if (inCheshire(delta_sol) == 1) then
c        write(6,12) 'picco esaminato',i,delta_sol(1:3),xyzs(4,i)
c
c--scarto soluzioni nel caso di gruppo di Cheshire con I e con
c  cella di cheshire che non esclude posizioni collegate da I
c  (avviene solo nel cubico)
c
             if (jsys == 6 .and. i > 1) then
                 diff = abs( delta_sol(1) - side( xyzs(1,i-1) ))
                if (abs( diff - 0.5 ) < 0.01) then
                    diff = abs( delta_sol(2) - side( xyzs(2,i-1) ))
                    if (abs( diff - 0.5 ) < 0.01) then
                        diff = abs( delta_sol(3) - side( xyzs(3,i-1) ))
                        if (abs( diff - 0.5 ) < 0.01) then
                            cycle
                        endif
                    endif
                endif
             endif
c
             nRis = nRis + 1
c
c--controllo se la soluzione e' troppo vicina ad una origine permessa
c
             if(ifRhombAx==1) then
c--la variabile nOrigRoxi non e' corretta in questo caso
               vet2(:)=delta_sol(:)
               exit do_1
             else
!--per le soluzioni piu' alte, controllo se ci sono origini permesse
               if(nRis==1) then
                  hmax=xyzs(4,i)
                  kRis = i
               endif
c
*              if(xyzs(4,i)>0.90*hmax) then
                 iperm=0
                 nRisCheck=nRisCheck+1
!--controllo se l'origine e' permessa
                 distmin=9999.
                 do i1=1,nOrigRoxiRoc
                   do j1=1,3
                     x1(j1)=taboRoc(i1,j1)
c                    if(x1(j1)>1.0) x1(j1)=0.0
                     if(x1(j1)>1.0) then
                        x1(j1)=delta_sol(j1)
                     endif
                   enddo
                   call xdist(x1,delta_sol,dist,s)
                   if(dist<distmin) distmin=dist
                 enddo
                 if (knw == 1) then
                   write(6,'(a,i5,3f10.4,f15.1,f8.3)') ! dedi
     *         'dist. orig. perm.', nRis, delta_sol, xyzs(4,i),distmin
                 endif
                 ippo = 0
                   if(distmin < 0.3) iperm=1
                   if(iperm==0) ifOrigineNonPerm=1
                       ippo = 2
                   sol_list(1:3,nRisCheck)=delta_sol(1:3)
                   sol_list(4,nRisCheck)=iperm
                   hsol = xyzs(4,i)
                   ksol = i
             endif
         endif
         if (nRis == 50) exit do_1   !  per non sfondare sol_list(4,50)
      enddo do_1
!
!--scelgo la soluzione da prendere
!
      write(6,*) 'ifOrigineNonPerm=',ifOrigineNonPerm,ippo
      if(ifOrigineNonPerm==1) then
CCC   if(ifOrigineNonPerm==1.and.ifOrigPerm==0) then
!--prendo la soluzione con origine non permessa presente tra le soluzioni piu' probabili
        do iroc=1,nRisCheck
!         if(sol_list(4,iroc)==1) cycle
          if(nint(sol_list(4,iroc)) > 0) cycle
          ksol = iroc
          vet2(1:3)=sol_list(1:3,iroc)
          exit
        enddo
      else
!--prendo la prima soluzione ( anche con origine permessa )
        ksol = 1
        vet2(1:3)=sol_list(1:3,1)
      endif
!
      if (nRis == 0) then
!        write(6,*) 'nessun picco trovato in TRASLAS' ! dedi
         write(6,*) 'No peaks found (c)'
      else
         delta_sol(:) = vet2(:)
      endif
!
!--rimetto a posto i valori
!
      nats=natsOld
      nz(1:nats)=nzsav(1:nats)
      xyzs=xyz30
*     call AllocaRiflessi_c(2)
*     call AllocaMappa(2)
      ihmx(:)=ihmxSav(:)
      call CheckGrid()
*     call AllocaMappa(1)
!
!g    write(lo,99) delta_sol(1:3)
!g 99 format(11x,' RELAX procedure ends. Translation applied:',3f7.4)
!
! - modifiche dedi
      if (icentSav == 0) then
          ntraslas = 2
      else
          ntraslas = 1
      endif

      delta_tra(1,1:3) = delta_sol(1:3)
      if (ntraslas == 2) then
          delta_tra(2,1:3) = -delta_sol(1:3)
      endif

c     if (knw == 1) then 
          write(6,'(a,3f10.4,f12.2,i5)')
     *  ' Most probable Translations: ',
     *                           delta_sol(:),hsol,ksol
c     endif

c-- dedi  13/01/2011 
      write(6,*) ' HSOL, HFOM: ',hsol,hFom
c-- dedi  13/01/2011 

      do j = 1,ntraslas   ! 2 traslazioni

*        if (j == 2) then
*            xenve(:,:,:) = xmap(:,:,:)
*        endif

         delta_sol(:) = delta_tra(j,:)

         if (knw > 0) write(lo,109) j,delta_sol(1:3)
  109 format(11x,' NTRASLAS = ',i4,'  Translation applied:',3f7.4)
         do i=1,numbLSQ
            faze = dtor*iphazo(i) - twopi *
     *       (khl(1,i)*delta_sol(1) + khl(2,i)*delta_sol(2) + 
     *        khl(3,i)*delta_sol(3))
            work2(i) = faze
            iphz = nint(faze*rtod)+360000
            iphaz(i) = mod(iphz, 360)
            fcoef(i) = evet(i)
         enddo
         if (knw == 1) then
             ifExamin = 1
             izero = 0
             ifmin = 11
             call examin(-333,mkang,khl,ipub,iphaz,numbLSQ,izero,wt,
     *                   ifmin)
         endif
         fcoef(:) = fcoef(:) * wt(:)
         jpatt = 0
         if (j == 1) then
             call MakeMap(fcoef, iphaz, numbLSQ, jpatt, xenve,
     *                    FORTHenv,BACKenv)
         else
             call MakeMap(fcoef, iphaz, numbLSQ, jpatt, xmap,
     *                    FORTH, BACK)
         endif

      enddo
! - modifiche dedi
!
      ik = knw
      if(kverbo>0) call CPUTime('fine traslas_relax', ik)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine space_hRsRq()
      USE General
      USE Symmetry
      USE PhaseModule, only : numbLSQ
      USE Riflessi
      USE riflessi_c 

      implicit none
      integer :: i, jj, numbEq, numbEqTrue, k, kk, iHcan(3), hklmax(3)
      integer :: m1, m1True, iicc1, n1, k1, m2, m2True, iicc2, n2, k2
      integer :: iAction, nrr, indr
      real    :: tt, vet2(3)

      hklmax(1:3)=-99999.0
      do iAction =1, 2
         nrr = 0
         i = 0
         do
            i = i + 1
            if (i > numbLSQ) exit
            jj = iworki(1,i)   ! operatore di simm.
            if (jj == 1) then
                numbEq = iworki(2,i)
                if (icentTrue == 0) then
                    numbEqTrue = numbEq
                else
                    numbEqTrue = numbEq*2
                endif
                do m2=1, numbEqTrue-1
                   m2True = mod(m2,numbEq)
                   if (m2True == 0) m2True = numbEq
                   if (m2 <= numbEq) then
                       iicc2 = 1
                   else
!                      elimino i riflessi -H
                       cycle
                       iicc2 = -1
                   endif
                   n2 = i + m2True - 1
                   k2 = iworki(1,n2)
                   do m1=m2+1, numbEqTrue
                      m1True = mod(m1,numbEq)
                      if (m1True == 0) m1True = numbEq
                      if (m1 <= numbEq) then
                          iicc1 = 1
                      else
!                         elimino i riflessi con fase opposta
                          if (m1True < m2True) cycle
                          iicc1=-1
                      endif
                      n1  = i + m1True - 1
                      k1 = iworki(1,n1)
                      tt = 0
                      do k=1,3
                         vet2(k) = khl(1,i) * (iicc2 * kmat(k2,1,k)
     &                                      -iicc1 * kmat(k1,1,k))
     &                           + khl(2,i) * (iicc2 * kmat(k2,2,k)
     &                                      -iicc1 * kmat(k1,2,k))
     &                           + khl(3,i) * (iicc2 * kmat(k2,3,k)
     &                                      -iicc1 * kmat(k1,3,k))
                         tt = tt + khl(k,i) * (tmat(k1,k) - tmat(k2,k))
                      enddo
!
                      call controllo_indici_interi(vet2,iHcan)
                      nrr = nrr + 1
                      if (iAction == 1) then
                          do k=1, 3
                             kk = iabs(iHcan(k))
                             if (kk > hklmax(k)) then
                                 hklmax(k) = kk
                             endif
                          enddo
                      else
                          khlc(1:3,nrr) = iHcan(1:3)
                          indr = iHcan(1) * ifat1C 
     *                         + iHcan(2) * ifat2C 
     *                         + iHcan(3)
                          superind(indr) = nrr
                      endif
                   enddo
                enddo
                i = i + numbEq - 1
            else
                call cstop(' error in space_hRsRq ')
            endif
         enddo
         if (iAction == 1) then
             ihmx(:) = hklmax(:)
             nRifDimC = nrr
             call AllocaRiflessi_c(1)
         endif
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine EstendiOriginiPermesse
      USE General
      USE Symmetry
      USE PhaseModule
!
      implicit none
      integer :: i, ii, j, k, ktl, n, add
      real    :: x1, new(3), diff
!      
      if (ncentr > 1) then
          n = nOrigRoxiRoc
          do k=2, ncentr
             do_add: do i=1, nOrigRoxiRoc
                do j=1,3
                   ktl = (k - 1) * 3 + j
                   x1 = taboRoc(i,j)
                   if (x1 < 127) then
                       x1 = x1 + centrt(latt,ktl)
*                      taboRoc(n,j) = x1
                       if (x1 > 1.001) x1 = x1 - 1.0
                   endif
                   new(j) = x1
                enddo
                do ii=1, n
                   add = 0
                   do j=1,3
                      diff = abs(new(j)-taboRoc(ii,j))
                      if (diff < 0.01 .or. diff > 0.99) then
                          add = add + 1
                      endif
                   enddo
                   if (add == 3) cycle do_add
                enddo
                n = n + 1
                taboRoc(n,1:3) = new(1:3)
             enddo do_add
          enddo
          nOrigRoxiRoc = n
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine codici()
      USE General
      USE Riflessi
      USE PhaseModule
      USE Mappa
      USE Param
!
      common/golay/matcomb(4096,24)
!
      nstrSav = nstr
      ndop=24
      kdop=12
!
      call comb_samp(icontn1,ndop,kdop)
!
      do i=1,icontn1
        do j=1,ndop
          matcomb(i,j)=matcomb(i,j)*180
        enddo
      enddo
!
      ermin = 9999
      fomm = -9999
      comm = -9999
      nstr = ndop
      do numbrun=1, icontn1
         nstr = ndop
         fcoef(:) = evet(:)
         iphaz(1:nstr)  = matcomb(numbrun,1:nstr)
         kk = sum(iphaz(1:nstr)) / 180
         if (kk == 0) cycle
         iphaz(nstr+1:) = 0
         wt(1:nstr)     = 1.0
         wt(nstr+1:)    = 0.0
         iz = 0
         im = 0
         nu = numbrun
         call examin(nu, mkang,khl, ipub, iphaz, nrefl, iz, wt,im)
         a1 = erore
         a2 = erorepes
         k1 = isumal
*        call Calcola_FOM_Early(corre)
*        fig = FOMs(1,4)
         jpatt = 0
         fcoef(:) = fcoef(:) * wt(:)
         call MakeMap(fcoef, iphaz, nstr, jpatt, xmap,
     *                FORTH, BACK)
      do iz = 0, np(3)-1
         do iy = 0, np(2)-1
            do ix = 0, np(1)-1
               xx = xmap(ix, iy, iz)
               if (xx < 0.0) xmap(ix, iy, iz) = 0.0
            enddo
         enddo
      enddo
         call maxminSir(np(1),np(2),np(3),xmap)
         rapden = denmax/stden
         fig = rapden
         kstp = 1
         call Calcola_CC_Mappa(nstr,corre,kstp,2)
         if (a1 < ermin) then
             k2 = numbrun
             ermin = a2
         endif
         if (fig > fomm) then
             k3 = numbrun
             fomm = fig
         endif
         if (corre > comm) then
             k4 = numbrun
             comm = corre
         endif
         write (lo,30) numbrun, a1, a2, k1, erore, erorepes, isumal, 
     *                 fig, corre,stden, kk,a1
      enddo
      write(6,*) ' ERRORE MINIMO',ermin,' in ',k2
      write(6,*) ' FOM MASSIMA',fomm,' in ',k3
      write(6,*) ' CORRE MASSIMA',comm,' in ',k4
!
      nstr = nstrSav
!
      return
   30 format(' Trial #',i6,2(' - MPE ',f6.2,
     *'  (',f6.2,')  over',i8),' FOM =',3f9.3,i3,f6.2)
      end
c---------------------------------------------------------------------
      subroutine comb_samp(icontn1,ndop,kdop)
c
      common/golay/matcomb(4096,24)
c
c--riempimento campionato con codici lineari e preferibilmente perfetti
c
      integer, allocatable :: vet1(:)
      integer, allocatable :: gmat(:,:)
c
      ALLOCATE (vet1(1:kdop), stat = ierr)
      ALLOCATE (gmat(1:kdop,1:ndop), stat = ierr)
c
      matcomb(:,:)=0
      if(ndop<=0) then
        write(6,*) 'no reflections found'
        return
      endif
c
c--determino kdop (2**kdop) numero di elementi del codice
c  e la matrice generatrice del codice [ndop,kdop,d]
c
      call generatormatrix(gmat,ndop,kdop)
c
c--genero tutte le disposizioni con ripetizione di n oggetti
c  in classe kdop
c
      n=2
      icontn1=n**kdop
      do icont=1,icontn1
        ii=icont-1
        do j=1,kdop-1
          term=kdop-j
          term1=float(n)**term
          nterm2=ii/int(term1)
          vet1(j)=mod(nterm2,n)
        enddo
        vet1(kdop)=mod(ii,n)
c
c--determino il codice di correzione degli errori
c
        do i=1,ndop
          nterm=0.
          do j=1,kdop
            nterm=nterm+vet1(j)*gmat(j,i)
          enddo
          matcomb(icont,i)=mod(nterm,n)
        enddo
      enddo  ! fine loop sul numero di combinazioni
c
      write(6,*) ' dop -->',icontn1        ! deb
      do io=1,icontn1                              ! deb
        write(6,'(a,1000i4)') 'matcomb',matcomb(io,1:ndop) ! deb
      enddo                                      ! deb
c
      IF (ALLOCATED(gmat)) DEALLOCATE (gmat,stat=ierr)
      IF (ALLOCATED(vet1)) DEALLOCATE (vet1,stat=ierr)
c
      return
      end
c--------------------------------------------------------------------
      subroutine generatormatrix(gmat,ndop,kdop)
c
c--determina la matrice di generazione del
c  codice binario lineare [ndop,kdop,d]
c
c    ndop = numero di riflessi = numero di lettere della
c           singola parola del codice
c    kdop: 2**kdop e' il numero di parole del codice
c       d: il numero massimo di lettere di cui una parola del
c          codice puo' differire rispetto ad una qualunque parola
c          di ndop lettere.
c
      common/golay/matcomb(4096,24)
      integer gmat(1:kdop,1:ndop)
c
c-- gmat = (1  ---> ndop)
c--        (2  ---> ndop)
c          .............
c--        (kdop -> ndop)
c
c--funziona solo per ndop<=24. 
c
      gmat(:,:)=0
c
      kdop=12
c--riempio la matrice unitaria
      do i=1,kdop
        gmat(i,kdop+i)=1
      enddo
c
c--inserimento dei codici
c  non li metto in forma standard perche' voglio variare prima i riflessi
c  a teta piu' basso
c
      if(ndop>24) then
        write(6,*) 'codice non inserito'
        stop
      elseif(ndop==24) then
! codice [24,12,8] codice di Golay esteso
         gmat(1,1:ndop)= (/0,1,1,1,1,1,1,1,1,1,1,1/)
         gmat(2,1:ndop)= (/1,1,1,0,1,1,1,0,0,0,1,0/)
         gmat(3,1:ndop)= (/1,1,0,1,1,1,0,0,0,1,0,1/)
         gmat(4,1:ndop)= (/1,0,1,1,1,0,0,0,1,0,1,1/)
         gmat(5,1:ndop)= (/1,1,1,1,0,0,0,1,0,1,1,0/)
         gmat(6,1:ndop)= (/1,1,1,0,0,0,1,0,1,1,0,1/)
         gmat(7,1:ndop)= (/1,1,0,0,0,1,0,1,1,0,1,1/)
         gmat(8,1:ndop)= (/1,0,0,0,1,0,1,1,0,1,1,1/)
         gmat(9,1:ndop)= (/1,0,0,1,0,1,1,0,1,1,1,0/)
         gmat(10,1:ndop)=(/1,0,1,0,1,1,0,1,1,1,0,0/)
         gmat(11,1:ndop)=(/1,1,0,1,1,0,1,1,1,0,0,0/)
         gmat(12,1:ndop)=(/1,0,1,1,0,1,1,1,0,0,0,1/)
      elseif(ndop==23) then
! codice [23,12,8] codice di Golay 
         gmat(1,1:ndop)= (/0,1,1,1,1,1,1,1,1,1,1/)
         gmat(2,1:ndop)= (/1,1,1,0,1,1,1,0,0,0,1/)
         gmat(3,1:ndop)= (/1,1,0,1,1,1,0,0,0,1,0/)
         gmat(4,1:ndop)= (/1,0,1,1,1,0,0,0,1,0,1/)
         gmat(5,1:ndop)= (/1,1,1,1,0,0,0,1,0,1,1/)
         gmat(6,1:ndop)= (/1,1,1,0,0,0,1,0,1,1,0/)
         gmat(7,1:ndop)= (/1,1,0,0,0,1,0,1,1,0,1/)
         gmat(8,1:ndop)= (/1,0,0,0,1,0,1,1,0,1,1/)
         gmat(9,1:ndop)= (/1,0,0,1,0,1,1,0,1,1,1/)
         gmat(10,1:ndop)=(/1,0,1,0,1,1,0,1,1,1,0/)
         gmat(11,1:ndop)=(/1,1,0,1,1,0,1,1,1,0,0/)
         gmat(12,1:ndop)=(/1,0,1,1,0,1,1,1,0,0,0/)
      elseif(ndop<23) then
        write(6,*) 'codice non inserito'
        stop
      endif
c
      return
      end
c--------------------------------------------------------------------
      subroutine FinalEDM(ier)
      USE General
      USE Riflessi
      USE Symmetry
      USE Atomi
      USE RemoModule
      USE PhaseModule
      USE Mappa
      USE Molcom
!
      integer Trial
!
      k = index(fname(1),'.bin')
      kk = kStripTask1(k)
!
!-- load phases for best trial
!
!gl!  call sfl17()
      call LoadFinalPhases(FomsFineDSR, iposFineDSR,
     *                     nsetFinalPhases)
      nset = iposFineDSR(1)
!gl!  call snr17(nset,figMer)
      call PutGetFinalPhases(2, nset, figMer)
      if (knw == 1) then
          write(6,*) 'FIGMER', figmer
      endif
      Trial = nint(figMer(1))
      if (knw == 1) then
          izero = 0
          ifmin = 0
          nbru = -33
          call examin(nbru,mkang,khl,ipub,iphaz,nstr,izero,wt,ifmin)
      endif
!
!-- creat PDB file for heavy atoms (if any)
!
      Pesanti = 0
      iOk = 0
      do i=1,nk
         if (no(i) > 20) then     ! maggiore del Calcio
             iOk = 1
             Pesanti = Pesanti + nw(i)
         endif
      enddo
      if (iOk == 1) then
          Pesanti = Pesanti / totop
          fcoef(1:numbLSQ) = evet(1:numbLSQ) * wt(1:numbLSQ)
          jpatt = 0
          call MakeMap(fcoef, iphaz, numbLSQ, jpatt, xmap, FORTH, BACK)
          mode = 0
          ifFour = 1
          aperc(1) = Pesanti
          call Search99(mode,ier,numbLSQ)
          if (no(1) == 1) then
              jlig = 2
          else
              jlig = 1
          endif
          nz(:) = jlig * nzConst
          nne = nats
          call label(nne)
          ifin = 0
          do i=1, nats
             knz = iabs(nz(i) / nzConst)
             if (no(knz) > 20) then
                 ifin = ifin + 1
             endif
          enddo
          if (ifin > 0) then
              iniz = 1
              call MakeLab(iniz,ifin)
              numbPDB = ifin
              bfac(1:numbPDB) = bt
              call PutModel
              cardDiret = fname(1)(1:kk-1) // '_heavy' // '.pdb'
              nREMcard = 5
              j = 30 - nREMcard
              do i=1, nREMcard
                 card(j) = card(i)
                 j = j +1
              enddo
              card(1) = 'REM '
              card(2) = 'REM '// PkgName(1:lPkgName) // ': ' // 
     *                  ProgName(1:lProgName) // 
     *                  ' - Ab initio procedure'
              write(card(3),10) numbPDB
              write(card(4),"('REM Trial  ',i5)") Trial
              card(5) = 'REM'
              itype = 0
              iform = 1
              jop = jopen(jhost,cardDiret,itype,iform,ier)
              ifFast = 0
              ifREM = nREMcard
              call outPDB(jhost, numbPDB, ifFast, ifREM, 0)
              close(jhost)
              iAction = 3
              call FilesInfo(iAction, numbPDB)
              j = 30 - nREMcard
              do i=1, nREMcard
                 card(i) = card(j)
                 j = j +1
              enddo
          endif
      endif
!
!-- call to EDM procedure
!
      ihmx(:) = ihmxSav(:)
      call AllocaIsr(2)
      ifFromPhase = 1
      call PreEdmDedm(ifFromPhase, ier)
!
!-- MTZ file after EDM
!
      Msg = 'Final EDM recycling'
      cardDiret = fname(1)(1:kk-1) // '_edm' // '.mtz'
      k1 = Lung(Msg)
      k2 = Lung(cardDiret)
      Msg(k1+1:) = 'MTZ file produced:' //  char(10) // cardDiret(1:k2)
      iAction = 2
      call FilesInfo(iAction, nSetsFineDSR)
      call WriteMTZ(-99, Trial, 0, 1, ier)
!
      return
   10 format('REM Heavy atoms coordinates for ',i3,' atoms')
      end
!-----------------------------------------------------------------------
      subroutine CreavettoreSigma()
      USE General
      USE Riflessi
      USE Phasemodule, only: ifVLD, ksize_vero
!
      implicit none
      integer :: i, j, numb
      real    :: sogliaSigma, fo, sig
!
      numb = nrefl
      if (useSigma == 0) then
          do i=1, numb
             vettoreSigma(i) = i
          enddo
          numbSigma = 0
      else
         if (neutro == 2) then
             do i=1, numb
                vettoreSigma(i) = i
             enddo
             numbSigma = 0
         else
             if (kmad == 0 .and. ksigma > 0) then
                 sogliaSigma = float(ksigma)/10.0
!pgVLD
                 if ( ifVLD == 1 .and. ksize_vero == 3) then
                    if (sogliaSigma > 0.6) then
                        sogliaSigma = sogliaSigma - 0.5
                    endif
                 end if
!pgVLD
                 vettoreSigma(:) = 0
                 j = 0
                 do i=1, numb
                    fo = fovet(i)
                    sig = sigmav(i)
                    if (fo > sogliaSigma*sig) then
                        j = j + 1
                        vettoreSigma(j) = i
                    endif
                 enddo
                 numbSigma = j
             else
                 do i=1, numb
                    vettoreSigma(i) = i
                 enddo
                 numbSigma = 0
             endif
         endif
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine PutGetRfacMatrix(iAction)
      USE PhaseModule
      USE RfacMatrixModule
!
      implicit none
      integer :: iAction
!
      if (iAction == 1) then
          if (nRfac > 0) then
              RfacMatrixSav(1:8,1:nRfac,1) = RfacMatrix(1:8,1:nRfac,1)
              nRfacSav      = nRfac
          endif
          nolsqSav      = nolsq
          fomBestSav    = fomBest
          erreBestSav   = erreBest
          TrBestfomSav  = TrBestfom
          TrerreBestSav = TrerreBest
      else
          nRfac      = nRfacSav
          fomBest    = fomBestSav
          erreBest   = erreBestSav
          TrBestfom  = TrBestfomSav
          TrerreBest = TrerreBestSav
          RfacMatrix(1:8,1:nRfac,1) = RfacMatrixSav(1:8,1:nRfac,1)
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine FinalInterpretation
      USE General
      USE Symmetry, only : TotalScan, nScan
      USE PhaseModule
      USE Molcom, only: jscreen
!
      implicit none
      integer :: interp, jscreenSav, kaction, iprinSav
!
      if (kmad /= 1) then
          write(lo,20) Titolo
      endif
      ifRecovered = 0
      interp = 1
      errem = erre
      if (TotalScan == 0) then
          if (nTotBlocksPh > 1) then
              if (erre * 100.0 > rfacSog)  then
                  call Ricovera()
              endif
          else
              call Ricovera()
          endif
      else
          if (nScan == TotalScan) then
              call Ricovera()
          endif
      endif
      jscreenSav = jscreen
      jscreen    = 1
      kaction = 4
      call build(kaction, 2)
      jscreen = jscreenSav
      iprinSav = iprin
      iprin    = 2
      krecy = 3000
      kaction  = 4
      call outpea(kaction)
      iprin    = iprinSav
!
      return
   20 format(/,1x, 78('+'),//,19x,
     1       '***   Final interpretation  ***',/,a,/)
      end
!-----------------------------------------------------------------------
      subroutine Define_Iteration()
      USE General
      USE Symmetry
      USE Param
      USE PhaseModule

      if (ksize <= 3 .or. kmad /= 0) then
           nIterADD = 0
           if (itera < 0) then
             nIterazioni = 1 !0
             if (ksize == 3) nIterazioni = 3  ! 2
          else
             nIterazioni = itera
          endif
      else
          nIterADD = 10
          if (itera < 0) then
             if (ifDsrVLD > 0) then
                 if (iheavy == 1) then
                     nIterazioni = 4 !!10 
                     if (nsym == 1.and.icent == 0) then
                         nIterazioni = 5
                     endif
                 elseif (iheavy == 0) then
                     nIterazioni = 6  !10 
                     if (nsym == 1.and.icent == 0) then
                         nIterazioni = 10
                     endif
                 endif
             else
               nIterazioni = 3
               if(ksize==4) nIterazioni = 2
               if(LowRes==1) then
                  if(resm<1.35) then
                     nIterazioni = 8
                  elseif(resm>1.35.and.resm<1.46) then
                     nIterazioni = 12
                  else
                     nIterazioni = 16
                  endif
                  if(ksize==7) nIterazioni = 8
               endif
             endif
          else
               nIterazioni = itera
          endif
          if(itera == 999) then
             nIterazioni = 20
             if(ksize==7) nIterazioni = 16
          endif
      endif
!
      if(ifDsrVLD == 1) then
         iterasog = 0 
c        if(LowRes == 1 .and. ResEff > sogResEff) iterasog = -1
         if(LowRes == 1) iterasog = -1
      else
         if (ksize > 3) then
            if(LowRes==1.and.iwei==0) then!liberato2009
               iterasog = 2
            else
               iterasog = 0
            endif
            if(LowRes==0.and.iwei==0.and.v_p>0.55.and.ksize<6) then
               iterasog = -1
            endif
            if(LowRes==1.and.ksize==7) iterasog = -1
            if(ResEff>sogResEff) iterasog = -1!liberato2009
            if((ResEff-resm)/resm>0.1) then!liberato2009
               iterasog = 0
            endif
         else
            iterasog = -1 
         endif
      endif

      if (kmad > 0) then
          nIterazioni = 0
          iterasog = 99
      endif
!
      nIteraTot = nIterazioni + nIterADD
!
      return
      end
!-----------------------------------------------------------------------
      subroutine WriteStrategy_DSR(unit)
      USE General
      USE PhaseModule, only : ksize_vero
      common /modifica_DSR/ kdsr, kdsrReq, ifPeak, nolsqReq
      integer unit
!      
      if (kmad == 1) then
          if (kdsr == 1 ) then
              write(unit, 145) ' DSR strategy changed: '
          elseif (kdsr == 2 ) then                      !cricri2
              write(unit, 148) ' DSR strategy changed: '
          else
              write(unit, 155) ' DSR strategy changed: '
          end if
      else
          if (kdsrReq == 1) then
              if (kdsr == 1) then
                  write(unit, 140) ' DSR strategy changed: '
              elseif (kdsr == 2) then
                  write(unit, 150) ' DSR strategy changed: '
              elseif (kdsr == 3) then
                  write(unit, 160) ' DSR strategy changed: '
              elseif (kdsr == 4) then
                  write(unit, 170) ' DSR strategy changed: '
              elseif (kdsr == 5) then
                  write(unit, 180) ' DSR strategy changed: '
              elseif (kdsr == 6) then
                  write(unit, 190) ' DSR strategy changed: '
              elseif (kdsr == 7) then
                  write(unit, 200) ' DSR strategy changed: '
              endif
          end if
      end if
!
!
      return
!
  140 format(/,a,
     *'very small-size structure ( up to 5 atoms in a.u. )')
  150 format(/,a,
     *'small-size structure ( 6-80 atoms in a.u. )')
!pgMAD0301
  145 format(/,a,
     *'small-size structure ( up to 10 atoms in a.u. )')    !cricri2
  148 format(/,a,
     *'medium-size structure ( 11-50 atoms in a.u. )')      !cricri2
  155 format(/,a,
     *'large-size structure ( >50 atoms in a.u. )')
!pgMAD0301
  160 format(/,a,
c    *'medium-size structure ( 80-200 atoms in a.u. )')
     *'medium-size structure ( 80-300 atoms in a.u. )')
  170 format(/,a,
c    *'large-size structure ( 200-600 atoms in a.u. )')
     *'large-size structure ( 300-600 atoms in a.u. )')
  180 format(/,a,
     *'very large-size structure ( 600-1000 atoms in a.u. )')
  190 format(/,a,
     *'very large-size structure ( >1000 atoms in a.u. )')
  200 format(/,a,
     *'huge-size / difficult structure ( >1750 atoms in a.u. )')
!
      end
!-----------------------------------------------------------------------
      subroutine DefinisciTraslazione(delta, nRis)
      USE General
      USE Symmetry
      USE Riflessi
      USE Riflessi_c
      USE Atomi
      USE Mappa
      USE PhaseModule
      USE VLDmod_3, only : numero_cicli
!
      implicit none
      integer :: i, j, k, nRis, inCheshire, iphz, izero, ifmin, jpatt
      integer :: iAll, jBest, kBest
      real    :: side, faze, delta(3), chope, delta_try(3), FFBest
      real    :: uno, coef
!
      uno = xyzs(4,1)
      FFBest = -9999
      nRis = 0
      do j = 1 , nats
         delta(1) = side( xyzs(1,j) )
         delta(2) = side( xyzs(2,j) )
         delta(3) = side( xyzs(3,j) )
         if (inCheshire(delta) == 1) then
             coef = xyzs(4,j) / uno
             nRis = nRis + 1
             do k=-1, 1, 2
                delta_try(1:3) = k * delta(1:3)
                do i=1, numbLSQ
                   faze = dtor*iphazo(i) - twopi *
     *                    (khl(1,i)*delta_try(1) + 
     *                     khl(2,i)*delta_try(2) + 
     *                     khl(3,i)*delta_try(3))
                   work2(i) = faze
                   iphz = nint(faze*rtod)+360000
                   iphaz(i) = mod(iphz, 360)
                   fcoef(i) = evet(i)
                enddo
*               izero = 0
*               ifmin = 11
*               call examin(-777, mkang, khl, ipub, iphaz, numbLSQ,
*    *                      izero, wt, ifmin)
                fcoef(:) = fcoef(:) * wt(:)
                jpatt = 0
                call MakeMap(fcoef, iphaz, numbLSQ, jpatt, xmap,
     *                       FORTH, BACK)
!!gpu           call NewInv(iphaz,fcvet,nrefl,np(1),np(2),np(3),
!!gpu*                       BACK)
                call NewInvCuda(iphaz,fcvet,nrefl,np(1),np(2),np(3),
     *                       BACK, xmap)
                ifSigmaA = 0
                iAll = 1
                chope = 0.5
                call CalcolaPesi(numbLSQ, numbLSQ, chope, iAll)
                call CalcFFomVLD(0, 0.0)
                FinalFom = FinalFom * coef
                write(6,12) nRis ,j, k, xyzs(1:3,j),xyzs(4,j), FinalFom
                if (FinalFom > FFBest) then
                    FFBest = FinalFom
                    jBest = j
                    kBest = k
                endif
             enddo
             if (nRis > 10) exit
         endif
      enddo

*     ntraslas = 1
      delta(1) = kBest * side( xyzs(1,jBest) )
      delta(2) = kBest * side( xyzs(2,jBest) )
      delta(3) = kBest * side( xyzs(3,jBest) )
      nRis = 1
      write(6,14) jBest, kBest, delta(1:3), FFBest
!
      return
   12 format('picco trovato',i5,')',i5,i3, 3f8.4,f10.2,' FFom=',f10.3)
   14 format('picco selezionato',i5,i3, 3f8.4,' FFom=',f10.3)
      end
!-----------------------------------------------------------------------
      subroutine Prepara_EndDsr()
      USE General
      USE Symmetry
      USE Riflessi
      USE Mappa
      USE Atomi
      USE Param
      USE RemoModule
      USE PhaseModule
!
      common/maphistograms/ vresl(50),vrmin(50),vrmax(50),vrave(50),
     +                   vrstd(50),hdata(200,50),nresl,nhist
!
      character tirang * 11
      character ttirang * 80
      character strMaps * 50
      real shi(4) !! , segni_mio(nreflDim)
!


      tmpwt(1:nrefl) = wt(1:nrefl)
      nuset = 9988
      izero = 0
      ifmin = 1
      call examin(nuset,mkang,khl,ipub,iphaz,nrefl,izero,wt,ifmin)
      if (knw == 1) then
          jwork1(:) = iphaz(:)
          shi(:) = shiftexam(1:4)
          call ShiftPhases(jwork1,shi,izero,nrefl)
!         tirang = 'EDM - OBSER'
!         ipher = 1
!         call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
!    *                    ipub,iphaz,wt,10,0.0,ipher)
      

!!        ttirang = 'WT OBS.'
!!        izero1 = 1
!!        segni_mio = 0.0
!!        call ParamDistribution(ttirang,2,wt,khl,nrefl,izero1,
!!   *         ipub,jwork1,shi,wt,segni_mio,10,1.0)
      endif

! 
!- calcolo envelope
!
      jpatt = 0
      RenveDyn = CalcolaRaggioEnve(jpatt)
      RenveDyn = RenveDyn
      if (knw > 0) then
          write(6,*) 'RAGGIO EndDsr =',RenveDyn
      endif
      call Long_Env_New(numbLSQ,jpatt)

      NumPeso = 0 
      call ControllaAtomiPesanti(NumPeso)
      aperc(1) = NumPeso   ! opp. NumPes (un po' di più)
!
      jpatt = 0
      fcoef(1:nrefl) = evet(1:nrefl) * wt(1:nrefl)
      call MakeMap(fcoef, iphaz, nrefl, jpatt, xmap, FORTH, BACK)

      ier = 0 
      if (NumPeso > 0) then
          iflagPKS = 0
          mode = -1
          nnuu = nrefl
          krecy = 0
          call pksrch_New(mode, iflagPKS, nnuu,ier)
          if (ier /= 0) then
              return
          endif
          nats = aperc(1)
      endif
!
      jpatt = 0
      fcoef(1:nrefl) = fovet(1:nrefl) * wt(1:nrefl)
      call MakeMap(fcoef, iphaz, nrefl, jpatt, xmap, FORTH, BACK)

c     iflat = 1  ! originale
c     iflat = 2  ! solo xmap*0.5
      iflat = 3  ! solo xmap*0.0
      Xflip = 0
      call flatmapOld(xmap,xenve,iflat,Xflip)
!  
      if (NumPeso > 0) then
          radius = 2.5
          call elimHA_Map(radius,xmap)
      endif
!
      call readhist
      call HM_Flex(xmap,xenve)
!
      invflag = 0
      call InvMap(khl,mkang,iphaz,fcvet,nrefl)

      wt(1:nrefl) = tmpwt(1:nrefl)

      nuset = 7766
      izero = 0
      ifmin = 1
      call examin(nuset,mkang,khl,ipub,iphaz,nrefl,izero,wt,ifmin)
      if (knw == 1) then
          jwork1(:) = iphaz(:)
          shi(:) = shiftexam(1:4)
          call ShiftPhases(jwork1,shi,izero,nrefl)
!         tirang = 'EDM - OBSER'
!         ipher = 1
!         call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
!    *                    ipub,iphaz,wt,10,0.0,ipher)
      

!!        ttirang = 'WT OBS.'
!!        izero1 = 1
!!        segni_mio = 0.0
!!        call ParamDistribution(ttirang,2,wt,khl,nrefl,izero1,
!!   *         ipub,jwork1,shi,wt,segni_mio,10,1.0)
      endif


c     jflag = 1    !!!  Fo=1, E=-1  <Eo2Ep2>
      jflag = 2    !!!  Fo=2, E=-2  R(Fo,Fc)
c     jflag = -2    !!!  Fo=3, E=-3  <(Eo2-Ec2)>
      call PresigmaA(jflag, 0)

      nuset = 5544
      izero = 0
      ifmin = 1
      call examin(nuset,mkang,khl,ipub,iphaz,nrefl,izero,wt,ifmin)
      if (knw == 1) then
          jwork1(:) = iphaz(:)
          shi(:) = shiftexam(1:4)
          call ShiftPhases(jwork1,shi,izero,nrefl)
c         tirang = 'EDM - OBSER'
c         ipher = 1
c         call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
c    *                    ipub,iphaz,wt,10,0.0,ipher)


!!        ttirang = 'WT OBS.'
!!        izero1 = 1
!!        segni_mio = 0.0
!!        call ParamDistribution(ttirang,2,wt,khl,nrefl,izero1,
!!   *         ipub,jwork1,shi,wt,segni_mio,10,1.0)
      endif

!
      return
      end
!-----------------------------------------------------------------------
