!------------------------------------------------------------------
!  ROUTINE del Plotter NEW :  28 January 2011
!------------------------------------------------------------------
!
      subroutine NewGraph(iAction, istereo)
!--main routine dalla grafica
!
!-- iAction = 1  Postscript
!-- iAction = 2  HPGL
!-- nRadType = 1  Covalent Radius
!            = 2  Peak Height
!            = 3  Thermal Factor
!
      USE General
      USE Molcom
!
      character line*80,diret*80
*gl*  common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
!
      iAct = iAction
      KK = 0
      select case (iPlotType)
          case(1)     ! STICKS
              KK=1
          case(3)       ! SIMPLE
              KK=2
          case(4,5,6,8) ! ELLIPSOIDS,BUBBLES,SHADING,STICKS_N_BALLS
              KK=3
          case(2)       ! RODS          warning! not used!
              KK=4
          case(7)       ! VANDERVAALS   warning! not used!
              KK=5
      end select
      if (KK.gt.0) then
          call MainPlot(istereo,ier,KK,iAction,ifLabels)
          call zflush
          if (iAct.gt.10) then
              call EndViewer(1)
          endif
      else
          call MsgWinErr('Warning',
     *         'Export not supported for this plot style',
     *         WARN_WINDOW, iExitC)
      endif
      return
      end
!
!------------------------------------------------------------------
!
      subroutine NewLabel
c--calcolo posizioni delle label
c  iAction=-1
c
      USE General
      USE Molcom
!
      character line*80,diret*80
*gl*  common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
c
      KK = 0
      select case (iPlotType)
          case(1)     ! STICKS
               KK=1
          case(3)       ! SIMPLE
               KK=2
          case(4,5,6,8) ! ELLIPSOIDS,BUBBLES,SHADING,STICKS_N_BALLS
               KK=3
          case(2)       ! RODS
               KK=4
          case(7)       ! VANDERVAALS
               KK=5
      end select
      if (KK.gt.0) then
          istereo =  0
          iAction = -1
          call MainPlot(istereo,ier,KK,iAction,ifLabels)
c         do j=1,n5
c             write(lo,'(2f10.3)')(xyLab(n,j),n=1,2)
c         enddo
      endif
      return
      end
!------------------------------------------------------------------
!c
!code for MainPlot
      subroutine MainPlot(istereo,ier,KK,iAction,jlab)
c-- ex subroutine CaosPlot (ex eplot(KK))
c--main switch routine
c     KK=-1  legge direttive (Caos)
c     KK= 0  legge direttive (Sir)
c     KK= 1  da Sir  stick
c     KK= 2  da Sir  simple
c     KK= 3  da Sir  balls, ellipsoids
c     KK= 4  da Sir  rods         !not used
c     KK= 5  da sir  vanderwaals  ! not used
c
c-- iAction =-1   Calcola posizioni delle Label
c-- iAction = 0   Schermo
c-- iAction = 1   Solo file Postscript
c-- iAction = 2   Solo file HPGL   
c-- iAction = 11  Solo preview Postscript
c-- iAction = 12  Solo preview HPGL
c-- iAction = 21  Preview e file Postscript
c-- iAction = 22  Preview e file HPGL
c
c      jlab=0 da Sir  no labels
c      jlab=1 da Sir  labels
c
c      STICKS = 1; RODS = 2; SIMPLE = 3; STICKS_N_BALLS = 4; BUBBLES = 5
c      SHADING = 6; VAN_DER_WAALS = 7; ELLIPSOIDS = 8; 
c      iPlotType = 0; ifTraccia = 0; RaggioSfera = 2.0
!
      USE General
      USE Molcom
      USE Atomi
      USE Plotter
!
      common /rot1/ BarVett(3), v1, v2, IfScaleO
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
!
      dimension el(3,3),x1(3),rrv(3),x2(3),r1(3),BToti(3,3)
      dimension dummy(3,3),fvert(3,8),uori(3,3)
      character *80 ifilin
c--
      ier=0
      istat2=0
      nFloc=1
      if(QualePgm.ne.CAOSPGM) then
         if (KK.gt.0) then
            ncpu=jhost
         endif
      endif
      if (nCoppieHBond > 0) then
          jhydro = 1
      else
          jhydro = 0
      endif
c      jlab=1   ! controllare
c--percentuale di riduzione del bond in funzione del raggio degli atomi
      xrm=0.25
      iline=10
      if(KK.eq.4) then
         xrm=1.0
         iline=10
      endif
      if(KK.eq.1) then
         xrm=1.0
         iline=1
      endif
      jdim=iline+1
!------------------------------------------------------------------
!--alloco vettori dinamici
!------------------------------------------------------------------
      natsPlo = NatMol
      NNLeg = NumLeg - nlp
      call AllocaPlotter(1,KK)
!------------------------------------------------------------------
!------------------------------------------------------------------
c--uori = orientation x orthogonal
!------------------------------------------------------------------
      call prodm(BTot,rm,uori)
!------------------------------------------------------------------
!--inverte la matrice di rotazione      
!------------------------------------------------------------------
c      do i=1,3
c         do j=1,3
c            BToti(i,j)=BTot(i,j)
c         enddo
c      enddo
c      call matin(BToti,3,dummy,1,deter)
!---------------------------------------
!--recupero coordinate vertici
!---------------------------------------
c      if (ifCell.eq.1) then
c          k=1
c          do i=NatMol+1,NatMol+8
c             x1(1) = xyz(1, i)
c             x1(2) = xyz(2, i)
c             x1(3) = xyz(3, i)
c             call MoltMatVec(BToti,x1,r1)
c             r1(1)=r1(1) + bard(1)
c             r1(2)=r1(2) + bard(2)
c             r1(3)=r1(3) + bard(3)
c             call MoltMatVec(rmi,r1,x1)
c             fvert(1,k)= x1(1)
c             fvert(2,k)= x1(2)
c             fvert(3,k)= x1(3)
c             k=k+1
c          enddo
c      else
c          do i=1,8
c             do j=1,3
c                fvert(j,i)=0.0
c             enddo
c          enddo
c      endif
!---------------------------------------
!       write(lo,*)' Matrice BTot'
!       do i=1,3
!       write(lo,'(3f10.4)')(BTot(i,j),j=1,3)
!       enddo
!---------------------------------------
!       write(lo,*)' Matrice BToti'
!       do i=1,3
!       write(lo,'(3f10.4)')(BToti(i,j),j=1,3)
!       enddo
!---------------------------------------
!       write(lo,*)' Matrice rmi'
!       do i=1,3
!       write(lo,'(3f10.4)')(rmi(i,j),j=1,3)
!       enddo
!---------------------------------------
!       write(lo,*)' Matrice rm'
!       do i=1,3
!       write(lo,'(3f10.4)')(rm(i,j),j=1,3)
!       enddo
!------------------------------------------------------------------------------
!--riempio vettori coordinate di lavoro (coordinate atomiche e connettivita')
!------------------------------------------------------------------------------
!--il vettore bij() contiene solo gli asimmetrici.
!  per gli equivalenti va considerata l'operatore di simmetria (????)
!  la matrice Ell(i,j,n=1,nats) contine:
!  bij(1:6) / twopis ; i termini misti sono / 2
!  infine sono divisi / FProb
!  la matrice semax(j,n) contine i semiassi principali
!  la matrice cd(j,k,n) contine semiassi dei tre ellissoidi secondari k
!  la routine per disegnare gli ellissoidi sulla finestra del SIR e' 
!  subroutine DisEll(ii,CC) in molp2006.f
!  viene chiamata dalla subroutine DisegnaAtomi(ifNewPage, ifSingle)
!
      k=0
      do i=1,NatMol 
         j=iEqui(i)
         ifDrawPs = 1
         if (nzTot(i).eq.1.and.ifHydro.eq.1) then
             if (ifDrHydr == 0) then
                 ifDrawPs = 0
             endif
         endif
         if (RS(i) < 0.0 .or. nz(j) == 0) then
             ifDrawPs = 0
         endif
         if (ifDrawPs == 1) then
             k=k+1
             rMLU(i) = 1
             xyzsPlo(1:3,k)=xyz(1:3,i)
             aLabPlo(k)=aLab(j)
             AdrPloto5(k)=j
             bfacPlo(k) = bfac(j)
             bijPlo(1:6,k)=bij(1:6,k)
c             
c             if(IsoAniso(j).eq.1) then
c                fbiso=bfacPlo(k)
c                do ii = 1, 3
c                   do jj = 1, 3
c                      el(ii, jj) = Ell(ii, jj, j)
c                   enddo
c                enddo
c                if (nOpEq(i)/1000 .ne. 1) then
c                    call EllEqui(el, nOpEq(i))
c                end if
c                call storb(fbiso,el,k)
c             else
c                bijPlo(1:6,k)=0.0
c             endif
         else
             rMLU(i) = 0
         endif
      enddo
      natsPlo=k
      ndel = 0
      do i=1,NatMol
         j=iEqui(i)
         if (rMLU(i)< 0.5) then
             ndel = ndel +1
             RSCOPY(i) = 0
         else
             RSCOPY(i) = i - ndel
         endif
      enddo
      selezione(1:natsPlo) = 0
      if(istat2.gt.0) call cwrli('INPUT')
c      stop
!---------------------------------------
!--riempio vettori connettivita'
!---------------------------------------
      do j=1,NNleg
         do i=1,2
            LEdum(i,j) = LE(i,j)
         enddo
      enddo
      k = 0
      do j=1,NNLeg
         if ((LE(3,j) /= 3) .and. (LE(3,j) /= -1)) then
             k = k + 1
             do i=1,2
                LEdum(i,k) = LE(i,j)
             enddo
         endif
      enddo
      NNLeg = k
!---------------------------------------
!-- update connectivity
!---------------------------------------
      k=0
      do j=1,NNLeg
         leg1=LEdum(1,j)
         leg2=LEdum(2,j)
         if (leg1.gt.0.and.leg2.gt.0) then
             if (RSCOPY(leg1).gt.0 .and. RSCOPY(leg2).gt.0) then
                 k=k+1
                 leg1 = RSCOPY(leg1)
                 leg2 = RSCOPY(leg2)
                 LEdum(1,k) = leg1
                 LEdum(2,k) = leg2
             endif
         endif
      enddo
      NNLeg = k
!
!-------------------------------------------------------------
c--set ex occ=1 (usato come flag) not more used
c         jFlagAtom(1:natsPlo)=1       ! (m25+nstep)
c--set flag iplottype ex store(m5+54)
!--update i fattori termici
      do k=1,natsPlo  
         i = AdrPloto5(k)
         if(IsoAniso(i).eq.1) then
            call bstor(fbiso,el,k)
            do j=1,3
               do n=1,3
                  el(j,n)=el(j,n)/twopis
               enddo
            enddo
            call storb(fbiso,el,k)
         endif
      enddo
      if(istat2.gt.0) call cwrli('START')
      do k=1,natsPlo  
         i = AdrPloto5(k)
         if(IsoAniso(i).eq.1) then
            call bstor(fbiso,el,k)
            call mxmxm(uori,el)    
            call storb(fbiso,el,k)
         endif
      enddo
      if(istat2.gt.0) call cwrli('START1')
!------------------------------------------------------------------
      do k=1,natsPlo  
!--salvo coordinate atomiche nella ex lista 26
         xyzsPloCopia(1:3,k)=xyzsPlo(1:3,k)
         bfacPloCopia(k) = bfacPlo(k)
         bijPloCopia(1:6,k)=bijPlo(1:6,k)
!--fine salvataggio---------------------------            
      enddo
!--definisco la variabile iscreen: indica schermo(1) o no(0)
      iscreen=0
!------------------------------------------------------------------
      ndisegni=1
      idise = 1
      if (iAction.gt.20) then          ! Preview e file Postscript
          idise = 1
          ndisegni = 2
          iAction = iAction - 20
      else if (iAction.gt.10) then     ! Solo preview Postscript
          idise = 2
          ndisegni = 2
          iAction = iAction - 10
      elseif (iAction.gt.0) then       ! Solo file Postscript
          idise = 1
          ndisegni = 1
      endif
      if(iAction.ne.-1) then
         write(ncwu,1030)
 1030    format(1h ,78(1h-))
         write(ncwu,1031)
 1031    format(/, ' Structure plotting',/)
      endif
!==================================================================
!--inizio loop sui disegni
!==================================================================
      do jdise = idise, ndisegni
         if (jdise.eq.2) then
             call ApriViewer(iAction)
             iscreen=1
         endif
!--ripristino coordinate atomiche nella ex lista 25
         do k=1,natsPlo  
            xyzsPlo(1:3,k)=xyzsPloCopia(1:3,k)
            bfacPlo(k) = bfacPloCopia(k)
            bijPlo(1:6,k)=bijPloCopia(1:6,k)
         enddo
!--fine ripristino----------------------------------            
c--controllo la variabile iscreen
         if(iAction.eq.0.or.jdise.eq.2) iscreen=1
         if(iAction.eq.-1) iscreen=1    ! per calcolare posizioni label
         jlab1=jlab
         jhydro1=jhydro
!--set code for the directives
         iscena=0
         iorient=0
!--spostamento della seconda molecola
         fff=6.
         ilabel=0
         idump=0
         ipack=0
!         icell=0
!         if(KK.ne.0) then
!           if(ifCell.eq.1) icell=1
!         endif
         idr=0
c--from plscena.f
         iup=0
         nset=0
         isosc=0
         rr(:)=0.
         tr(:)=0.
c--from plorient.f
         iskl=0
         idsk=0
         ro(:)=0.0
         iro(:)=0
         ind=0
c--set some values
c--disegno sullo schermo
         if(iscreen.eq.1) then
            iqplot=0
            icolore=63
            call GetMaxScreen(p2xs,p2ys,xplo2s,yplo2s)
            xplo2=xplo2s
            yplo2=yplo2s
            p2x=p2xs
            p2y=p2ys
            scax=p2xs/xplo2s
            scay=p2ys/yplo2s
c      write(ncwu,*)'p2xs,p2ys,xplo2s,yplo2s,scax,scay,xplo2,yplo2',
c     2  p2xs,p2ys,xplo2s,yplo2s,scax,scay,xplo2,yplo2
         endif
c                  
c--disegno su file (PostScript)
         if(iscreen.eq.0) then
c--file postscripts
            xplo2=xplo2a
            yplo2=yplo2a
            p2x=p2xa
            p2y=p2ya
            scax=p2x/xplo2
            scay=p2y/yplo2
c      write(ncwu,*)'p2xa,p2ya,xplo2a,yplo2a,scax,scay',
c     2 p2xa,p2ya,xplo2a,yplo2a,scax,scay
            iqplot=2
            if(KK.eq.0) then
c--define PostScript file
               k = index(fname(1),'.bin')
               ifilin = fname(1)(1:k) // 'ps'
               write(ncwu,2716) ifilin
 2716          format(/,' PostScript file= ',a,/)
            endif
         endif
c--fine definizione default
         if(iAction.ne.-1) then
            if(KK.eq.0) then
               call inunit(ifilin,ier)
               if(ier.ne.0) return
            endif
            ipen=1
            call init(ipen)
         endif
c -- end select
         jrun=3
         idr =2
         if(KK.gt.0) then
            select case (KK)
               case(1)   ! STICKS
                  jrun=2
                  idr =1   ! iPlotType=STICKS
               case(2)     ! SIMPLE
                  jrun=3
                  idr =2   ! iPlotType=STICKS_N_BALLS
               case(3)     ! BUBBLES,SHADING,ELLIPSOIDS
                  jrun=4   ! 
                  idr =3   ! iPlotType=BUBBLES  ,  iPlotType=ELLIPSOIDS
!               case(4)     ! RODS
!                  jrun=3
!                  idr =4   ! iPlotType=RODS
!               case(5)     ! VANDERWAALS
!                  jrun=3
!                  idr =5
            end select
         endif
         if(iskl.eq.0) sk(1)=0.
         if(idsk.eq.0) dk(1)=0.9
         sktmp=sk(1)
         dktmp=dk(1)
         call skale(iAction)
         skdktmp=skdk
         scadis=skdk
c--calcolo eventuala scala per le label calcolate precedentemente
         if(iscreen.eq.0) then
            call GetMaxScreen(p2xs,p2ys,xplo2s,yplo2s)
            sk(1)=sktmp
            dk(1)=dktmp
            call skaleVideo
            scadis=skdk
            skdk=skdktmp
         endif
c--fine calcolo
         iscena=1
         iorient=1
         if(istat2.gt.0) call cwrli('CREA5')
         if(iAction.eq.-1) jrun=5      ! per testare problema label
c         stop
!         
         select case (jrun)
!
!--SIMPLE
            case(2)       !--'sketch block' 
               ipr=0       !--disegno sketch
               call sketch(ipr)    
!
!--! BUBBLES,SHADING,STICKS_N_BALLS         
            case(3)        !--'stiks and balls block' 
               call sae(idr,ibnd,iexit,xrm)
               if(iexit.eq.-1) return
               call sae1(idr)
c--calcola e memorizza basi dei bond
               call sae2(idr,ibnd)
c--memorizzo tratti oscuri elisse contorno nn5--nn6
               call sae3(idr,ibnd)
c--disegna  ball
               call sae31(idr,jdise)
c--disegna i bond
               if(ibnd.eq.1.and.idr.ne.5) call sae9(idr,jdise)
c               if(icell.ne.0) call xvert(idr,istereo,ipack,icell)
!
!--!  BALL & ELLIPSOIDS         
            case(4)        !--'ball and ellipsoides block' 
               call sae(idr,ibnd,iexit,xrm)
               if(iexit.eq.-1) return
               call sae1(idr)
c--calcola e memorizza basi dei bond
               call sae2(idr,ibnd)
               write(lo,'(a)') ' dopo sae2'
c--memorizzo tratti oscuri elisse contorno nn5--nn6
               call sae3(idr,ibnd)
c--disegna elissoidi (ellisse contorno)
               call sae31(idr,jdise)
               write(lo,'(a)') ' dopo sae31'
c--memorizzo tratti oscuri primo ellisse principale
               call sae4(idr,ibnd)
               write(lo,'(a)') ' dopo sae4'
               call sae41(idr)
c--disegna il primo ellisse principale
               call sae42(idr,jdise)
               write(lo,'(a)') ' dopo sae42'
               call sae5(idr,ibnd)
               call sae51(idr)
c--disegna secondo ellisse principale
               call sae52(idr,jdise)
               write(lo,'(a)') ' dopo sae52'
               call sae6(idr,ibnd)
               call sae61(idr)
c--disegna il terzo ellisse principale
               call sae62(idr,jdise)
               write(lo,'(a)') ' dopo sae62'
c--disegna semiassi principali
               call sae7(idr,ibnd,jdise)
               write(lo,'(a)') ' dopo sae7'
c--disegna i bond
               if(ibnd.eq.1) call sae9(idr,jdise)
               write(lo,'(a)') ' dopo sae9'
c              if(icell.ne.0) call xvert(idr,istereo,ipack,icell)
!
!--! per calcolare posizioni LABEL
            case(5)        !--'label positions' 
               ipr=1       !--calcolo posizioni label (non disegno)
               if(idr.eq.1) then
                  call sketch(ipr)
                  call zlabel(ipr)
               else
                  call sae(idr,ibnd,iexit,xrm)
                  if(iexit.eq.-1) return
                  call sae1(idr)
                  call sae2(idr,ibnd)
                  call labat(idr,ipr)
               endif   
               return
!
!--ERROR               
            case default
               ier=-1
!              
         end select
!--controllo s devo scrivere le label          
         if(jlab.eq.1) then
               ipr=0       !--disegno label 
               if(ifMovedLab.eq.0) ipr=-1
               if(idr.eq.1) then
                  call zlabel(ipr)
               else
                  call labat(idr,ipr)  ! ancora da correggere
               endif
         endif         
         if(ier.eq.0) call clunit
      enddo
!==================================================================
!--fine loop sui disegni
!==================================================================
!--dealloca finale
!      
      call AllocaPlotter(2,KK)
!      
      return    
      end
c
code for skale
      subroutine skale(iAction)
c--
      USE General
      USE Atomi
      USE Plotter
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension xo(3),xn(3)
      character*7 display
c--
      call mimax(xm,ym,zm,delx,dely,delz,zmin)
      if (sk(1).le.0.0) then
          sk1=xplo2/delx
          sk2=yplo2/dely
          if (sk1-sk2.le.0.0) then
             skn=sk1
          else
             skn=sk2
          endif
      else
          skn=sk(1)
      endif
      do  i=1,natsPlo
          xo(1:3)=xyzsPlo(1:3,i)
          xn(1:3)=(xo(1:3)-xm)*skn
          xyzsPlo(1:3,i)=xn(1:3)
          call bstor(fbiso,bij_single,i)
          bij_single(:,:)=bij_single(:,:)*(skn**2)
          call storb(fbiso,bij_single,i)
      enddo
      zmax=delz*skn
      if(istat2.gt.0) call cwrli('SKALEa')
c
code for ex-dskal
c--
      dkn=dk(1)
      do i=1,natsPlo
c      call storo(xo,yo,zo,m25)
          xo(1:3)=xyzsPlo(1:3,i)
          xn(1)=xo(1)*dkn+xplo2/2.
          xn(2)=xo(2)*dkn+yplo2/2.
          xn(3)=xo(3)*dkn
          xyzsPlo(1:3,i)=xn(1:3)
          call bstor(fbiso,bij_single,i)
          bij_single(:,:)=bij_single(:,:)*(dkn**2)
          call storb(fbiso,bij_single,i)
      enddo
      if(istat2.gt.0) call cwrli('SKALEb')
      skdk=skn*dkn
      zmax=zmax*dkn
      if (iqplot.eq.0) then
          display='display'
       elseif (iqplot.eq.1) then
          display='plotter'
       elseif (iqplot.eq.2) then
          display='file.PS'
      endif
      if (iAction.ne.-1) then
          write(ncwu,100)display,skdk
100      format(' Drawing scale on ',a,' (cm/A) :',f10.3)
      endif
!
      return
      end
c
code for skaleVideo
      subroutine skaleVideo
c--
      USE General
      USE Plotter
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
!
      call mimax(xm,ym,zm,delx,dely,delz,zmin)
      if (sk(1).le.0.0) then
          sk1=xplo2s/delx
          sk2=yplo2s/dely
          if (sk1-sk2.le.0.0) then
             skn=sk1
          else
             skn=sk2
          endif
      else
          skn=sk(1)
      endif
      dkn=dk(1)
      if (istat2.gt.0) call cwrli('SKALEb*')
      skdk=skn*dkn
!
      return
      end
c
code for mimax
      subroutine mimax(xm,ym,zm,delx,dely,delz,zmin)
c--
      USE General
      USE Atomi
      USE Plotter
c--
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      xmax=-100000
      ymax=-100000
      zmax=-100000
      xmin= 100000
      ymin= 100000
      zmin= 100000
      do i=1,natsPlo
         call bstor(fbiso,bij_single,i)
         xo=xyzsPlo(1,i)
         yo=xyzsPlo(2,i)
         zo=xyzsPlo(3,i)
         if(xmax.lt.xo) xmax=xo+sqrt(fbiso)
         if(ymax.lt.yo) ymax=yo+sqrt(fbiso)
         if(zmax.lt.zo) zmax=zo+sqrt(fbiso)
         if(xmin.gt.xo) xmin=xo-sqrt(fbiso)
         if(ymin.gt.yo) ymin=yo-sqrt(fbiso)
         if(zmin.gt.zo) zmin=zo-sqrt(fbiso)
      enddo
      xm=(xmax+xmin)/2
      ym=(ymax+ymin)/2
      zm=(zmax+zmin)/2
      delx=xmax-xmin
      dely=ymax-ymin
      delz=zmax-zmin
      if(natsPlo.eq.1) then
         delx=delx*2
         dely=dely*2
         delz=delz*2
      endif
      return
      end
!   
!------------------------------------------------------------------
!--macro routine di  per LABEL
!------------------------------------------------------------------
!
!code for zlabel
      subroutine zlabel(ipr)
!--scrive label per sketch
!  ipr = 0 scrive label sul disegno
!	   1 scrive coordinate label sull'output
!	  -1 scrive label sul disegno calcolate dal programma
!
      USE General
      USE Atomi
      USE Molcom
      USE Plotter
!
      real, allocatable :: xyLab_Temp(:,:)
!
      dimension va(3),vb(3),at(3),ilb(1),
     *pp0(3),pp1(3),pp2(3),pp3(3),vap0(3),vap1(3),vap2(3),vap3(3),
     *vbp0(3),vbp1(3),vbp2(3),vbp3(3),vap(2),vbp(2)
c--
!      
      if (allocated(xyLab_Temp))
     *            deallocate (xyLab_Temp, stat = ierr)
!      
      IF (.NOT. ALLOCATED(xyLab_Temp))
     *	ALLOCATE (xyLab_Temp(1:8,1:natsPlo), stat = ierr)
       if (ierr.ne.0) then
       write(lo,*) 'xyLab_Temp Allocation error'
       call cstop(' ')
      endif
! 
      xyLab_Temp(:,:)=0.0
!           
      dalfa=2.0
      dalfa=dalfa*dtr
      pi2=pi/2
      nlbl=1
!-- assign a default value to a default value to h
      h(1)=0.4
!-- assign a default value to r
      r(1)=0.05
      w=0.66666*h(1)
!--start loop sugli atomi      
      do k=1,natsPlo
         alfa=0.0
         ilab=0
         inter=0
         nbl=1
         call compl(k,j)
         ncar=j-1
!--controllo se la posizione della label e' gia' stata calcolata
         if(ipr.eq.0) then
            call symbl(k,pp0,w,ncar,ipr)
         else
            rl=ncar*h(1)
            zona=bomax+h(1)/2+rl
            i= AdrPloto5(k)
            at(1:3)=xyzsPlo(1:3,k)
c            if(ibnd.eq.-1) go to 921
!-- scorrimento tabella di connettivita'
            do j=1,NNLeg
               ia=LEdum(1,j)
               ib=LEdum(2,j)
               va(1:3)=xyzsPlo(1:3,ia)
               vb(1:3)=xyzsPlo(1:3,ib)
               if(abs(at(1)-va(1)).gt.zona) go to 450
               if(abs(at(2)-va(2)).gt.zona) go to 450
               go to 400
  450          continue
               if(abs(at(1)-vb(1)).gt.zona) cycle
               if(abs(at(2)-vb(2)).gt.zona) cycle
  400          continue
c-- il bond ab deve essere memorizzato
               ilab=ilab+1
               Finter(nbl)=ia
               Finter(nbl+1)=ib
               nbl=nbl+2
            enddo
c  921       continue
            inter=0
            alfa=0.
c-- calcolo dimensioni del rettangolo contenente la label
            pp0(1)=at(1)+h(1)/2
            pp0(2)=at(2)
            pp0(3)=at(3)
            
            pp1(1)=pp0(1)+rl
            pp1(2)=at(2)
            pp1(3)=at(3)
            
            pp2(1)=pp1(1)
            pp2(2)=at(2)+h(1)
            pp2(3)=at(3)
            
            pp3(1)=pp0(1)
            pp3(2)=pp2(2)
            pp3(3)=at(3)
            
            do j1=1,ilab
               inter=0
               do j2=1,ilab
                  if(j1.eq.j2) cycle
                   i3=(j2-1)*2+1
                   j3=Finter(i3)
                   j4=Finter(i3+1)
                   va(1:3)=xyzsPlo(1:3,j3)
                   vb(1:3)=xyzsPlo(1:3,j4)
!                   
                   vap0(1:2)=xyLab_Temp(1:2,j3)
                   vap0(3)=0.0
                   vap1(1:2)=xyLab_Temp(3:4,j3)
                   vap1(3)=0.0
                   vap2(1:2)=xyLab_Temp(5:6,j3)
                   vap2(3)=0.0
                   vap3(1:2)=xyLab_Temp(7:8,j3)
                   vap3(3)=0.0
!
                   vbp0(1:2)=xyLab_Temp(1:2,j4)
                   vbp0(3)=0.0
                   vbp1(1:2)=xyLab_Temp(3:4,j4)
                   vbp1(3)=0.0
                   vbp2(1:2)=xyLab_Temp(5:6,j4)
                   vbp2(3)=0.0
                   vbp3(1:2)=xyLab_Temp(7:8,j4)
                   vbp3(3)=0.0
!                   
                   if((vap0(1).eq.0).and.(vbp0(1).eq.0)) ich=0
                   if((vap0(1).ne.0).and.(vbp0(1).eq.0)) ich=1
                   if((vap0(1).eq.0).and.(vbp0(1).ne.0)) ich=2
                   if((vap0(1).ne.0).and.(vbp0(1).ne.0)) ich=3
!--indirizzo di rientro da posizione successiva                   
   80              continue
                   inter=0
                   call crlb(va,vb,pp0,pp1,inter)
                   if(inter.gt.0) goto 300   
                   call crl(vap0,vap1,vap2,vap3,vbp0,vbp1,vbp2,
     *                      vbp3,pp0,pp1,ich,inter)
                   if(inter.gt.0) goto 300  
                   call crlb(va,vb,pp1,pp2,inter)
                   if(inter.gt.0) goto 300  
                   call crl(vap0,vap1,vap2,vap3,vbp0,vbp1,vbp2,
     *                      vbp3,pp1,pp2,ich,inter)
                   if(inter.gt.0) goto 300  
                   call crlb(va,vb,pp3,pp2,inter)
                   if(inter.gt.0) goto 300  
                   call crl(vap0,vap1,vap2,vap3,vbp0,vbp1,vbp2,
     *                      vbp3,pp3,pp2,ich,inter)
                   if(inter.gt.0) goto 300  
                   call crlb(va,vb,pp0,pp3,inter)
                   if(inter.gt.0) goto 300  
                   call crl(vap0,vap1,vap2,vap3,vbp0,vbp1,vbp2,
     *                      vbp3,pp0,pp3,ich,inter)
                   if(inter.le.0) goto 106  
  300              continue
c                  if(alfa.gt.2*pi) go to 145
                   if(alfa.gt.2*pi) go to 180
                   alfa=alfa+dalfa
                   call chpos(at,pi2,pp0,pp1,pp2,pp3,alfa,rl)
                   go to 80
  106              continue
               enddo
            enddo
            go to 160
  145       continue
            go to 900
  160       continue
            if((alfa.ge.0).and.(alfa.le.pi2)) go to 165
            if((alfa.gt.pi2).and.(alfa.le.pi)) go to 170
            if((alfa.gt.pi).and.(alfa.le.3*pi2)) go to 175
            if((alfa.gt.3*pi2).and.(alfa.le.2*pi)) go to 180
  165       continue
            call symbl(k,pp0,w,ncar,ipr)
            go to 901
  170       continue
            call symbl(k,pp1,w,ncar,ipr)
            go to 901
  175       continue
            call symbl(k,pp2,w,ncar,ipr)
            go to 901
  180       continue
            call symbl(k,pp3,w,ncar,ipr)
  901       continue
            xyLab_Temp(1:2,k)=pp0(1:2)
            xyLab_Temp(3:4,k)=pp1(1:2)
            xyLab_Temp(5:6,k)=pp2(1:2)
            xyLab_Temp(7:8,k)=pp3(1:2)
!--fine se calcolo/stampa posizioni label      
          endif
  900 continue
!--fine loop sugli atomi
      enddo 
!         
      DEALLOCATE(xyLab_Temp, stat =ierr)
!      
      return
      end
!
!code for labat
      subroutine labat(idr,ipr)
!--scrive label per ball e ellissoidi
!  ipr = 0 scrive label sul disegno
!	 1 calcola posizioni  label sull'output
!      0 scrive label sul disegno
!	-1 scrive label sul disegno calcolate dal programma
!
      USE General
      USE Atomi
c      USE Molcom
      USE Plotter
!
      real, allocatable :: xyLab_Temp(:,:)
!
      dimension p0(3),p1(3),p2(3),p3(3),at(3),va(3),vb(3),at1(3),
     *at2(3),vap0(3),vap1(3),vap2(3),vap3(3),am(3,3)
      dimension abond(4,60),bbond(4,60)
!
c      dimension va(3),vb(3),at(3),ilb(1),
c     *pp0(3),pp1(3),pp2(3),pp3(3),vap0(3),vap1(3),vap2(3),vap3(3),
c     *vbp0(3),vbp1(3),vbp2(3),vbp3(3),vap(2),vbp(2)
c--
!      
      npercBarra  = 100
      npercBarra  = natsPlo
      iperc0      = natsPlo / npercBarra
      iperc       = iperc0
      jpercBarra  = 0
      call scrper('Computing labels positions',0,0)
      if (allocated(xyLab_Temp))
     *            deallocate (xyLab_Temp, stat = ierr)
!      
      IF (.NOT. ALLOCATED(xyLab_Temp))
     *	ALLOCATE (xyLab_Temp(1:8,1:natsPlo), stat = ierr)
       if (ierr.ne.0) then
       write(lo,*) 'xyLab_Temp Allocation error'
       call cstop(' ')
      endif
! 
      xyLab_Temp(:,:)=0.0
!      
      dalfa=2.0
      dalfa=dalfa*dtr
      pi2=pi/2
      nlbl=1
!-- assign a default value to a default value to h
      h(1)=0.4
!-- assign a default value to r
      r(1)=0.05
c--w larghezza carattere (=2/3 dell'altezza h(1))
      w=0.66666*h(1)
c--start loop sugli atomi
      do ij=1,natsPlo
         if (ij == iperc) then
             jpercBarra = jpercBarra + 1
             iperc = iperc + iperc0
             call scrper(' ',jpercBarra,npercBarra)
         endif
         call DoSingleIteration()
         alfa=0.0
         ilab=0
         inter=0
         nbl=1
         call compl(ij,j)
         ncar=j-1
!--controllo se la posizione della label e' gia' stata calcolata
         if(ipr.eq.0) then
            call symbl(ij,p0,w,ncar,ipr)
         else
            i= AdrPloto5(ij)
            at(1:3)=xyzsPlo(1:3,ij)
            call bstor(fbiso,bij_single,i)            
            axa=1/sqrt(bij_single(1,1))
            axb=1/sqrt(bij_single(2,2))
            axc=1/sqrt(bij_single(3,3))
            xr=axa
            xr=amax1(xr,axb)
            xr=amax1(xr,axc)
            if(idr.eq.1) xr=0.0
c--base dell'etichetta : ncar * (w + 1/3 h(1))
c  considerando la spaziatura tra i caratteri = 1/3 h(1)
            rl=ncar*h(1)-h(1)/3
            rk=rl+xr
            zona=bomax+h(1)/2+rk
!------------------------------------------------
!-- scorrimento tabella di connettivita'
            do j=1,NNLeg
               ja=LEdum(1,j)
               jb=LEdum(2,j)
               va(1:3)=xyzsPlo(1:3,ja)
               vb(1:3)=xyzsPlo(1:3,jb)
               if(abs(at(1)-va(1)).gt.zona) go to 450
               if(abs(at(2)-va(2)).gt.zona) go to 450
	         go to 400
  450          continue
	         if(abs(at(1)-vb(1)).gt.zona) cycle
	         if(abs(at(2)-vb(2)).gt.zona) cycle
  400	         continue
!-- il bond ab deve essere memorizzato
               ilab=ilab+1
               Finter(nbl)=ja
               Finter(nbl+1)=jb
               nbl=nbl+2
            enddo
!-------------------------------------------------
!-- calcolo dimensioni label
            p0(1)=at(1)+xr+h(1)
            p0(2)=at(2)
            p0(3)=at(3)
             
            p1(1)=p0(1)+rl
            p1(2)=at(2)
            p1(3)=at(3)
             
            p2(1)=p1(1)
            p2(2)=at(2)+h(1)
            p2(3)=at(3)
             
            p3(1)=p0(1)
            p3(2)=p2(2)
            p3(3)=at(3)
c-- definizione della zona entro la quale
c-- la label puo' intersecare un atomo
c-- rappresentato come una sfera (BALLS or ELLIPS)
            if(idr.gt.1) then
!--start loop sugli atomi      
               ns=nbl
               is=0
               iat=0
               do i=1,natsPlo
                  j= AdrPloto5(i)
                  at1(1:3)=xyzsPlo(1:3,i)
                  call bstor(fbiso,bij_single,j)            
                  axa=1/sqrt(bij_single(1,1))
                  axb=1/sqrt(bij_single(2,2))
                  axc=1/sqrt(bij_single(3,3))
                  xr1=axa
                  xr1=amax1(xr1,axb)
                  xr1=amax1(xr1,axc)
                  call lngtp(at,at1,dp)
                  dmax=2*xr+2*xr1+h(1)+rl
                  if(dp.le.dmax) then
                     iat=iat+1
                     Finter(nbl)=i
                     nbl=nbl+1
                     is=1
                  endif
               enddo
               if(is.ne.0) ns1=nbl-1
            endif
!--posizione per chiamata successiva all'indietro            
 3000       continue
            inter=0
!--loop sui bond che intersecano label
c           do 150 j1=nlb,nlb+ilab-1,2
            do j1=1,ilab
               j2=(j1-1)*2+1
               ja=Finter(j2)
               jb=Finter(j2+1)
c--controllo intersezioni generatrici dei bonds
c--sulla tabella contenente le basi dei tronchi di cono
c-- (nn3---nn4)
               do i1=1,nbon
                  call BondStor(i1,ia,ib,abond,bbond) 
                  if(ia.eq.0) cycle
                  if((ia.ne.ja).or.(ib.ne.jb)) cycle
                  do i=1,jdim
                     va(1:3)=abond(1:3,i)
                     vb(1:3)=bbond(1:3,i)
                     call crlb(va,vb,p0,p1,inter)
                     if(inter.gt.0) goto 12
                     call crlb(va,vb,p1,p2,inter)
                     if(inter.gt.0) goto 12
                     call crlb(va,vb,p3,p2,inter)
                     if(inter.gt.0) goto 12
                     call crlb(va,vb,p0,p3,inter)
                     if(inter.gt.0) goto 12
                  enddo
               enddo
            enddo
c-- controllo intersezioni con eventuali atomi
            if(iat.gt.0) then
               do j1=1,iat
                  j2=(j1-1)+ns
                  ja=Finter(j2)
                  j= AdrPloto5(ja)
                  at2(1:3)=xyzsPlo(1:3,ja)
                  call bstor(fbiso,bij_single,j)            
                  axa=1/sqrt(bij_single(1,1))
                  axb=1/sqrt(bij_single(2,2))
                  axc=1/sqrt(bij_single(3,3))
                  r2=axa
                  r2=amax1(r2,axb)
                  r2=amax1(r2,axc)
                  call sbintr(p0,p1,p2,p3,at2,r2,inter)
                  if(inter.gt.0) goto 12
                   call lngtp(at2,p0,d0)
                   if(d0.le.r2) go to 12
                   call lngtp(at2,p1,d1)
                   if(d1.le.r2) go to 12
                   call lngtp(at2,p2,d2)
                   if(d2.le.r2) go to 12
                   call lngtp(at2,p3,d3)
                   if(d3.le.r2) go to 12
               enddo
            endif
            if(ij.eq.1) go to 95  
c-- controllo interezioni label--label
            do j2=1,natsPlo
               if(ij.eq.j2) cycle
!                   
               vap0(1:2)=xyLab_Temp(1:2,j2)
               vap0(3)=0.0
               vap1(1:2)=xyLab_Temp(3:4,j2)
               vap1(3)=0.0
               vap2(1:2)=xyLab_Temp(5:6,j2)
               vap2(3)=0.0
               vap3(1:2)=xyLab_Temp(7:8,j2)
               vap3(3)=0.0
!                
               if((vap0(1).eq.0).and.(vap1(1).eq.0)) cycle
c-- controllo eventuali intersezioni
               call labin(vap0,vap1,vap2,vap3,p0,p1,inter)
               if(inter.gt.0) goto 12
               call labin(vap0,vap1,vap2,vap3,p1,p2,inter)
               if(inter.gt.0) goto 12
               call labin(vap0,vap1,vap2,vap3,p2,p3,inter)
               if(inter.gt.0) goto 12
               call labin(vap0,vap1,vap2,vap3,p0,p3,inter)
               if(inter.gt.0) goto 12
            enddo
   95       continue
c-- la label pu0' essere disegnata
            if((alfa.ge.0).and.(alfa.le.pi2)) go to 265
            if((alfa.gt.pi2).and.(alfa.le.pi)) go to 270
            pi32=pi2*3
            if((alfa.gt.pi).and.(alfa.le.pi32)) go to 275
            if((alfa.gt.pi32).and.(alfa.lt.twopi)) go to 280
  265       call symbl(ij,p0,w,ncar,ipr)
            go to 901
  270       call symbl(ij,p1,w,ncar,ipr)
            go to 901
  275       call symbl(ij,p2,w,ncar,ipr)
            go to 901
  280       call symbl(ij,p3,w,ncar,ipr)
  901       continue
            xyLab_Temp(1:2,ij)=p0(1:2)
            xyLab_Temp(3:4,ij)=p1(1:2)
            xyLab_Temp(5:6,ij)=p2(1:2)
            xyLab_Temp(7:8,ij)=p3(1:2)
            cycle
   12       continue
c-- la posizione della label deve essere cambiata
c   altrimenti stampo comunque
            if(alfa.gt.twopi) go to 95
            alfa=alfa+dalfa
            call chpos1(at,p0,p1,p2,p3,alfa,rl,xr)
            go to 3000
         endif
      enddo
!
      call scrper(' ', 0, -1)
      call PrintMess(' ')
!
      return
      end
c
code for labin
      subroutine labin(v0,v1,v2,v3,vap,vbp,inter)
c--
      dimension v0(3),v1(3),v2(3),v3(3),vap(3),vbp(3)
c
      call crlb(v0,v1,vap,vbp,inter)
      if(inter) 1,1,2
    1 call crlb(v1,v2,vap,vbp,inter)
      if(inter) 3,3,2
    3 call crlb(v2,v3,vap,vbp,inter)
      if(inter) 4,4,2
    4 call crlb(v0,v3,vap,vbp,inter)
      if(inter) 5,5,2
    5 continue
      return
    2 continue
      return
      end
c
code for crl
      subroutine crl(ap0,ap1,ap2,ap3,bp0,bp1,bp2,bp3,v1,v2,ich,inter)
c--
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension ap0(3),ap1(3),ap2(3),ap3(3),bp0(3),bp1(3),bp2(3),
     *bp3(3),v1(3),v2(3)
c--
      if(ich.eq.0) return
      if(ich.eq.1) go to 10
      if(ich.eq.2) go to 11
      if(ich.eq.3) go to 12
   10 continue
      call crlb(ap0,ap1,v1,v2,inter)
      call crlb(ap1,ap2,v1,v2,inter)
      call crlb(ap3,ap2,v1,v2,inter)
      call crlb(ap0,ap3,v1,v2,inter)
      return
   11 continue
      call crlb(bp0,bp1,v1,v2,inter)
      call crlb(bp1,bp2,v1,v2,inter)
      call crlb(bp3,bp2,v1,v2,inter)
      call crlb(bp0,bp3,v1,v2,inter)
      return
   12 continue
      call crlb(ap0,ap1,v1,v2,inter)
      call crlb(ap1,ap2,v1,v2,inter)
      call crlb(ap3,ap2,v1,v2,inter)
      call crlb(ap0,ap3,v1,v2,inter)
      call crlb(bp0,bp1,v1,v2,inter)
      call crlb(bp1,bp2,v1,v2,inter)
      call crlb(bp3,bp2,v1,v2,inter)
      call crlb(bp0,bp3,v1,v2,inter)
      return
      end
c
code for chpos
      subroutine chpos(at,pi2,p0,p1,p2,p3,alfa,rl)
      USE General
      USE Plotter
c--
      dimension at(3),p0(3),p1(3),p2(3),p3(3)
c--
      if((alfa.gt.0).and.(alfa.le.pi2)) go to 10
      if((alfa.gt.pi2).and.(alfa.le.pi)) go to 15
      if((alfa.gt.pi).and.(alfa.le.3*pi2)) go to 20
      if((alfa.gt.3*pi2).and.(alfa.le.2*pi)) go to 25
   10 continue
      p0(1)=at(1)+h(1)/2*cos(alfa)
      p0(2)=at(2)+h(1)/2*sin(alfa)
      p1(1)=p0(1)+rl
      p1(2)=p0(2)
      p2(1)=p0(1)+rl
      p2(2)=p0(2)+h(1)
      p3(1)=p0(1)
      p3(2)=p0(2)+h(1)
      return
   15 continue
      p0(1)=at(1)+h(1)/2*cos(alfa)
      p0(2)=at(2)+h(1)/2*sin(alfa)
      p1(1)=p0(1)-rl
      p1(2)=p0(2)
      p2(1)=p0(1)-rl
      p2(2)=p0(2)+h(1)
      p3(1)=p0(1)
      p3(2)=p0(2)+h(1)
      return
   20 continue
      p0(1)=at(1)+h(1)/2*cos(alfa)
      p0(2)=at(2)+h(1)/2*sin(alfa)
      p1(1)=p0(1)-rl
      p1(2)=p0(2)
      p2(1)=p0(1)-rl
      p2(2)=p0(2)-h(1)
      p3(1)=p0(1)
      p3(2)=p0(2)-h(1)
      return
   25 continue
      p0(1)=at(1)+h(1)/2*cos(alfa)
      p0(2)=at(2)+h(1)/2*sin(alfa)
      p1(1)=p0(1)+rl
      p1(2)=p0(2)
      p2(1)=p0(1)+rl
      p2(2)=p0(2)-h(1)
      p3(1)=p0(1)
      p3(2)=p0(2)-h(1)
      return
      end
c
code for crlb
      subroutine crlb(va,vb,vc,vd,inter)
c--
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension va(3),vb(3),vc(3),vd(3)
c
      zero=0.001
      dx1=vb(1)-va(1)
      dy1=vb(2)-va(2)
      dx2=vd(1)-vc(1)
      dy2=vd(2)-vc(2)
      det=dx2*dy1-dy2*dx1
      if(abs(det).le.zero) go to 100
      t=(dx2*(vc(2)-va(2))-dy2*(vc(1)-va(1)))/det
      q=(dx1*(vc(2)-va(2))-dy1*(vc(1)-va(1)))/det
      if((t.le.0).or.(t.ge.1)) go to 20
      if((q.le.0).or.(q.ge.1)) go to 20
      inter=inter+1
      return
   20 continue
      return
  100 continue
      if((dx1.eq.0).and.(dx2.eq.0)) go to 150
      if((dy1.eq.0).and.(dy2.eq.0)) go to 120
  150 continue
      if(abs(va(1)-vc(1)).gt.zero) return
      if(abs(vb(2)-va(2)).le.zero) return
      tc=(vc(2)-va(2))/(vb(2)-va(2))
      td=(vd(2)-va(2))/(vb(2)-va(2))
      go to 125
  120 continue
      if(abs(vb(1)-va(1)).le.zero) return
      if(abs(va(2)-vc(2)).gt.zero) return
      tc=(vc(1)-va(1))/(vb(1)-va(1))
      td=(vd(1)-va(1))/(vb(1)-va(1))
  125 continue
      if((tc.ge.0).and.(tc.le.1)) go to 130
      if((td.ge.0).and.(td.le.1)) go to 130
      return
  130 continue
      inter=inter+1
      return
      end
!
!code for compl
      subroutine compl(k,j)
!--salvo la label nel vettore ilbl() per il plotter
      USE General
      USE Plotter
!
      call shift(aLabPlo(k),lenp)
      read(aLabPlo(k),'(16a1)')(ilbl(i),i=1,lenp)
      j=lenp+1
      ilbl(j)=itrmn
      return
      end
c
code for sbintr
      subroutine sbintr(p0,p1,p2,p3,at1,r1,inter)
c-- calcolo di intersezioni fra il rettangolo rappresentate
c-- la label e gli atomi della lista
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension p0(3),p1(3),p2(3),p3(3),at1(3)
c
      inter=1
      call sbass(at1,r1,p0,p1,t1,t2)
      if((t1.lt.0).and.(t2.lt.0)) inter=0
      if((t1.gt.1).and.(t2.gt.1)) inter=0
      if(inter) 1,1,2
    2 continue
      return
    1 call sbass(at1,r1,p1,p2,t3,t4)
      if((t3.lt.0).and.(t4.lt.0)) inter=0
      if((t3.gt.1).and.(t4.gt.1)) inter=0
      if(inter) 3,3,2
    3 call sbass(at1,r1,p2,p3,t5,t6)
      if((t5.lt.0).and.(t6.lt.0)) inter=0
      if((t5.gt.1).and.(t6.gt.1)) inter=0
      if(inter) 4,4,2
    4 call sbass(at1,r1,p0,p3,t7,t8)
      if((t7.lt.0).and.(t8.lt.0)) inter=0
      if((t7.gt.1).and.(t8.gt.1)) inter=0
      return
      end
c
code for sbass
      subroutine sbass(c,r,a,b,t1,t2)
c--
      dimension c(3),a(3),b(3)
      bax=b(1)-a(1)
      bay=b(2)-a(2)
      acx=a(1)-c(1)
      acy=a(2)-c(2)
      c1=bax*bax+bay*bay
      c2=(bax*acx+bay*acy)*2
      c3=acx*acx+acy*acy-r*r
      delta=c2*c2-4*c1*c3
      if(delta) 5,10,10
    5 continue
      t1=-10000
      t2=-10000
      return
   10 continue
      delta=sqrt(delta)
      if(c1.ne.0.0) then
      t1=(-c2-delta)/(2*c1)
      t2=(-c2+delta)/(2*c1)
      endif
      return
      end
c
code for chpos1
      subroutine chpos1(at,p0,p1,p2,p3,alfa,rl,xr)
c--
      USE General
      USE Plotter
!
      dimension at(3),p0(3),p1(3),p2(3),p3(3)
!
      rh=xr+h(1)
      pi2=pi/2
      pi32=pi2*3
      if((alfa.gt.0).and.(alfa.le.pi2)) go to 10
      if((alfa.gt.pi2).and.(alfa.le.pi)) go to 15
      if((alfa.gt.pi).and.(alfa.le.pi32)) go to 20
      if((alfa.gt.pi32).and.(alfa.le.twopi)) go to 25
   10 continue
      p0(1)=at(1)+rh*cos(alfa)
      p0(2)=at(2)+rh*sin(alfa)
      p1(1)=p0(1)+rl
      p1(2)=p0(2)
      p2(1)=p0(1)+rl
      p2(2)=p0(2)+h(1)
      p3(1)=p0(1)
      p3(2)=p0(2)+h(1)
      return
   15 continue
      p0(1)=at(1)+rh*cos(alfa)
      p0(2)=at(2)+rh*sin(alfa)
      p1(1)=p0(1)-rl
      p1(2)=p0(2)
      p2(1)=p0(1)-rl
      p2(2)=p0(2)+h(1)
      p3(1)=p0(1)
      p3(2)=p0(2)+h(1)
      return
   20 continue
      p0(1)=at(1)+rh*cos(alfa)
      p0(2)=at(2)+rh*sin(alfa)
      p1(1)=p0(1)-rl
      p1(2)=p0(2)
      p2(1)=p0(1)-rl
      p2(2)=p0(2)-h(1)
      p3(1)=p0(1)
      p3(2)=p0(2)-h(1)
      return
   25 continue
      p0(1)=at(1)+rh*cos(alfa)
      p0(2)=at(2)+rh*sin(alfa)
      p1(1)=p0(1)+rl
      p1(2)=p0(2)
      p2(1)=p0(1)+rl
      p2(2)=p0(2)-h(1)
      p3(1)=p0(1)
      p3(2)=p0(2)-h(1)
      return
      end
!------------------------------------------------------------------
!--macro routine di  per disegnare
!------------------------------------------------------------------
!======================================================================
!--STICKS_N_BALLS & ELLIPSOIDS BLOCK-----------------------------------
!======================================================================
!
!code for sae
      subroutine sae(idr,ibnd,iexit,xrma)
!--routine iniziale di disegno
!	    KK=1 idr=1      ! STICKS
!	    KK=2 idr=2      ! SIMPLE
!	    KK=3 idr=3      ! ELLIPSOIDS,BUBBLES,SHADING
!	    KK=4 idr=4      ! RODS           !  not used
!	    KK=5 idr=5      ! VANDERVAALS    !  not used
!
!-- nRadType = 1  Covalent Radius
!            = 2  Peak Height
!            = 3  Thermal Factor
!
      USE General
      USE Atomi
      USE Molcom
      USE Plotter
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension d(3,3),b(3,3),xo(11),xn(11),key(10),kinst(3)
!--
      iexit=0
!--set code se direttiva BOND viene fornita
      icodeb=0
!--set default
      xrm=xrma      ! % di riduzione dei bond in funzione del raggio degli atomi
      ivett=0
      zero=0.001
      dvd= 1.5*zmax
      ibnd=1
      rapx=10000.0
!--flag atomo isotropo---------------------------------------------------
      if(idr.eq.3) then
!--caso atomo di H
         do k=1,natsPlo 
            i= AdrPloto5(k)
            ksp = nzTot(i)
            if (no(ksp).eq.1) then
                SinglePlotType(i)=6
            endif
         enddo
      endif
!--check GS se atomo in posizione speciale
      call xspinb
      do k=1,natsPlo
         i= AdrPloto5(k)
         if(IsoAniso(i).eq.1) then
            ksp=nzTot(i) 
            itype=nalf(ksp)
            xo(:)=0.0
            xn(:)=0.0
            xo(1:3)=xyzs(1:3,i)
            xo(4)=xyzs(5,i)
            xo(5:10)=bij(1:6,i)
            iser=i
            khead=0
            iactn=3
!           khead=1
!           iactn=2
            ks=kspecb(newvet,xo,xn,key,itype,iser,khead,iactn)
!--data keyc/' x',' y',' z','11','22','33','23','13','12'/
!            write(ncwu,'(i4,1h),10i3)')i,key
            kinst(:)=0
            if (key(10).ge.1) then
!--equiv
                kweigh=0
!                do j=4,9
!--controllo solo 11 , 22, 33
                do j=4,6      
                   if(key(j).ne.0)then
                      keyx=iabs(key(j))
                      if(keyx.ne.j)then
                         jj=keyx
                         if(jj.ge.10.or.key(j).lt.0) kweigh=1
                         if(jj.ge.10) then
                            jjj=jj/10
                            jj=jj-jjj*10
                         end if
                         if(jj.ne.j) then
                            kinst(jj-3)=1
                            kinst(j-3)=1
                         endif
                      endif
                   endif
                enddo
            endif
            kkk=sum(kinst)
!            if(kkk.eq.0) then
            if(kkk.ne.3) then
               selezione(k) = 1         ! flag atomo anisotropo
               if(SinglePlotType(i).ne.ELLIPSOIDS)selezione(k) = 0
            else
               selezione(k) = 0         ! flag atomo  isotropo
            endif
         endif
      enddo
!--
!--fine loop sugli atomi      
!--end of flag isotropo----------------------------------------------------
      do k=1,natsPlo 
          i= AdrPloto5(k)
          ksp = nzTot(i)
!          
!--definisco rb per i casi idr=2,3       (idr=1 non chiama questa routine)  
          select case (nRadType)
!          
!--Covalent Radius          
             case (1)
!             
                xr=RS(i)  * 0.8          ! B(iso)=RS * ...
!--not used-------------------------------------------------------------         
!          if (idr.eq.5) then
!              rb = radii(ksp,2)*0.5                ! prova VAN_DER_WAALS
!              xrr = bfac(i)/rb
!              if (xrr.lt.rapx) rapx=xrr
!          endif
!-------------------------------------------------------------------------
!               
!--Peak Height               
             case (2)
!                           
                rb=no(ksp)/(4.0*twopis) 
                xr=sqrt(rb)
 !               
 !--Thermal Factor               
             case (3)
!                           
!--va controllato se si richiede la palla proporzionale al T.F. 
                if (bfacPlo(k).gt.1.0) then
                    rb=bfacPlo(k)
                else
                    rb=1.0
                endif
                rb=rb/(4.0*twopis) 
                xr=sqrt(rb)
!                
          end select
                
!-- ex : call iso(k,rb)-----------------
!----------------------------------------          
          bfacPlo(k)=xr *skdk       ! salvo il risultato nella posizione del fatt. isotropo
!--end ----------------------------------          
          if (idr.ne.3) then
              selezione(k) = 0
          endif
      enddo
!--------------------------------------------------------------      
      if(istat2.gt.0) call cwrli('SAE')
!--end default
      do k=1,natsPlo 
         if(selezione(k).eq.0) then
!--atomo isotropo
            xr=bfacPlo(k)
            fbiso=xr
            bij_single(1,1)=xr*xr
            bij_single(1,2)=0.
            bij_single(1,3)=0.
            bij_single(2,1)=0.
            bij_single(2,2)=xr*xr
            bij_single(2,3)=0.
            bij_single(3,1)=0.
            bij_single(3,2)=0.
            bij_single(3,3)=xr*xr
            call storb(fbiso,bij_single,k)
         endif
      enddo
      if(istat2.gt.0) call cwrli('SAEa1')
!--------------------
!--probability: 50%   (settato ProbF=0.5)
      P = ProbF
      if (P.le. 0.975) then
         xprob = (((((23.326*P)-55.693)*P+51.552)*P-22.75)*P+
     *                6.447)*P+0.296
      else
         xprob = -136.496 + 141.072 * P
      end if
      b(:,:)=0.0
      prob2=xprob*xprob
      m=0
      ndim=3
      do i=1,natsPlo
          call bstor(fbiso,bij_single,i)
          fbiso=1./(fbiso*xprob)
          call matin(bij_single,ndim,d,m,det)
          bij_single(:,:)=bij_single(:,:)/prob2
          call storb(fbiso, bij_single,i)
      enddo
      if(ibnd.eq.1) call bmax
      if(istat2.gt.0) call cwrli('SAEa2')
      return
      end
c
code for sae1
      subroutine sae1(idr)
!-- ex ellip(idr)
!-- si memorizzano i parametri necessari per l'esecuzione del
!-- disegno in store da nn1 fino ad nn2 con passo ielem
!-- le informazioni sono conservate per ogni atomo:
!   (13 valori + 6) con le informazioni generali dell'ellissoide
!   solo se ellissoide:
!   + 3 blocchi di 8 valori (calcolati in 5 diverse condizioni)
!-- real*8 ec,ex,ey,ez
!               case(2)     ! STICKS
!                  jrun=3
!                  idr =2   ! iPlotType=STICKS_N_BALLS
!               case(3)     ! BUBBLES,SHADING,STICKS_N_BALLS
!                  jrun=4   ! ELLIPSOIDS
!                  idr =3   ! iPlotType=BUBBLES  ,  iPlotType=ELLIPSOIDS
!               case(4)     ! RODS   (not more used)
!                  jrun=3
!                  idr =4   ! iPlotType=RODS
!               case(5)     ! VANDERWAALS  (not more used)
!                  jrun=3
!                  idr =5
!
!  sir routine per disegnare un ellissoide       \
!  subroutine DisEll(ii,CC)  in molp2006.f

!
      USE General
      USE Plotter
      USE Atomi
      USE Molcom
!      
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      dimension va(3),am(3,3),a(3),b(3),c(3),ec(2,2),
     *          ex(2,2),ey(2,2),ez(2,2)
c
      zer1=0.0001
      do k=1,natsPlo 
            iel33= selezione(k)     ! iel33=0 isotropo  =1 anisotropo
            va(1:3)=xyzsPlo(1:3,k)
            call bstor(fbiso,am,k)
            if(istat2.gt.1) then
               write(ncwu,331) aLabPlo(k)
  331          format(/,'atomo: ',a8)
               write(ncwu,332)((am(j,i),j=1,3),i=1,3)
  332          format('ellissoide:',3f12.4,/,2(11x,3f12.4,/))
            endif
            call cntrl(idr,fbiso,am,iel33,ii,axa,axb,axc,a,b,c)
            call storb(fbiso,am,k)
            if(istat2.gt.1) write(ncwu,333)ii
  333          format('ii:',i5)
c-- memorizzazione assi dell ellissoide : axa,axb,axc
c-- ed autovalori:a(a1,a2,a3),b=(b1,b2,b3),c=(c1,c2,c3)
            ParamEll( 1,k)=k        ! ParamEll(1,k)
            ParamEll( 2,k)=axa
            ParamEll( 3,k)=axb
            ParamEll( 4,k)=axc
            ParamEll( 5,k)=a(1)
            ParamEll( 6,k)=a(2)
            ParamEll( 7,k)=a(3)
            ParamEll( 8,k)=b(1)
            ParamEll( 9,k)=b(2)
            ParamEll(10,k)=b(3)
            ParamEll(11,k)=c(1)
            ParamEll(12,k)=c(2)
            ParamEll(13,k)=c(3)  ! ParamEll(13,k)
c-------------------------------------------------------
c-- memorizzazione parametri ellisse contorno:
c-- am:matrice coefficienti
c-- ac1,ac2,fic:assi ed angolo di inclinazione (in rad)
c-- idr =3   ! iPlotType=BUBBLES  ,  iPlotType=ELLIPSOIDS
            if(idr.ne.3) then ! 
               ec(1,1)=am(1,1)
               ec(1,2)=0.
               ec(2,1)=0.
               ec(2,2)=am(2,2)
               ac1=1./sqrt(ec(1,1))
               ac2=ac1
               fic=0.
            else
               call ellc(am,ec,ac1,ac2,fic)
            endif   
            ParamEll(14,k)=ec(1,1)      ! ParamEll(14,k)
            ParamEll(15,k)=2*ec(1,2)
            ParamEll(16,k)=ec(2,2)
            ParamEll(17,k)=ac1
            ParamEll(18,k)=ac2
            ParamEll(19,k)=fic          ! ParamEll(19,k)
!------------------------------------------------------
!--controllo se idr=3  (caso ellissoide)
            if(idr.eq.3) then
c------------------------------------------------------
c--memorizzo 3 blocchi da 8 valori in ciascun dei 5 casi
               select case (ii)
!----------------------------------------------------------------
!
!--caso ii=1-----------------------------------------------------
                  case(1)       
c-- non ci sono casi particolari
                     if(iel33.eq.0) then  
                        call elpiso(am,a,ec,ex,ax1,ax2,fix,fix1,fix2)
                     else
                        if(abs(a(3)).le.zer1) go to 400
                        call elprin(am,ex,a,ax1,ax2,fix)
                        call elltan(ec,ex,a,fix1,fix2)
                     endif
c-- memorizzazione coefficienti ellisse principale   (asse a)
c-- assi,angolo di inclinazione,arco di visione
                     ParamEllabc(1,1,k)=ex(1,1)     ! ParamEllabc(1,1,k)
                     ParamEllabc(2,1,k)=2*ex(1,2)
                     ParamEllabc(3,1,k)=ex(2,2)
                     ParamEllabc(4,1,k)=ax1
                     ParamEllabc(5,1,k)=ax2
                     ParamEllabc(6,1,k)=fix
                     ParamEllabc(7,1,k)=fix1
                     ParamEllabc(8,1,k)=fix2        ! ParamEllabc(8,1,k)
                     go to 401
c----------------------------------------------------            
  400                continue
c-- caso particolare in cui si annulla una o piu'
c-- componenti dell' autovalore a
                     if(abs(a(1)).le.zer1) go to 410
                     if(abs(a(2)).le.zer1) go to 420
c--caso if(abs(a(3)).le.zer1)             
                     fm=-a(2)/a(1)
                     costx=fm*fm*(am(1,1)*am(3,3)-am(1,3)*am(1,3))+
     *                     2*fm*(am(1,2)*am(3,3)-am(1,3)*am(2,3))+
     *                     am(2,2)*am(3,3)-am(2,3)*am(2,3)
                     costx=am(3,3)/costx
                     y1=-sqrt(costx)
                     y2=-y1
                     x1=fm*y1
                     x2=fm*y2
                     go to 430
c--caso if(abs(a(1)).le.zer1)           
  410                continue
                     costx=am(1,1)*am(3,3)-am(1,3)*am(1,3)
                     costx=am(3,3)/costx
                     x1=-sqrt(costx)
                     x2=-x1
                     y1=0.
                     y2=0.
                     go to 430
c--caso if(abs(a(2)).le.zer1)           
  420                continue
                     costx=am(2,2)*am(3,3)-am(2,3)*am(2,3)
                     costx=am(3,3)/costx
                     y1=-sqrt(costx)
                     y2=-y1
                     x1=0.
                     x2=0.
c--memorizza risultati           
  430                continue
                     ParamEllabc(1,1,k)=0.        ! ParamEllabc(1,1,k)
                     ParamEllabc(2,1,k)=x1*2.
                     ParamEllabc(3,1,k)=y1
                     ParamEllabc(4,1,k)=x2
                     ParamEllabc(5,1,k)=y2
                     ParamEllabc(6,1,k)=0.
                     ParamEllabc(7,1,k)=0.
                     ParamEllabc(8,1,k)=0.        ! ParamEllabc(8,1,k)
  401                continue
c--------------------------------------------------
c-- memorizzazione coeficienti ellisse principale  (asse b)
c-- assi,angolo di inclinazione,arco di visione
                     if(iel33.eq.0) then  
                        call elpiso(am,b,ec,ey,ay1,ay2,fiy,fiy1,fiy2)
                     else
                        if(abs(b(3)).le.zer1) go to 500
                        call elprin(am,ey,b,ay1,ay2,fiy)
                        call elltan(ec,ey,b,fiy1,fiy2)
                     endif
                     ParamEllabc(1,2,k)=ey(1,1)     ! ParamEllabc(1,2,k)
                     ParamEllabc(2,2,k)=2*ey(1,2)
                     ParamEllabc(3,2,k)=ey(2,2)
                     ParamEllabc(4,2,k)=ay1
                     ParamEllabc(5,2,k)=ay2
                     ParamEllabc(6,2,k)=fiy
                     ParamEllabc(7,2,k)=fiy1
                     ParamEllabc(8,2,k)=fiy2        ! ParamEllabc(8,2,k)
                     go to 501
c----------------------------------------------------            
  500                continue
c-- caso particolare in cui si annulla una o piu'
c-- componenti dell' autovalore b
                     if(abs(b(1)).le.zer1) go to 510
                     if(abs(b(2)).le.zer1) go to 520
c--caso if(abs(b(3)).le.zer1)             
                     fm=-b(2)/b(1)
                     costx=fm*fm*(am(1,1)*am(3,3)-am(1,3)*am(1,3))+
     *                      2*fm*(am(1,2)*am(3,3)-am(1,3)*am(2,3))+
     *                      am(2,2)*am(3,3)-am(2,3)*am(2,3)
                     costx=am(3,3)/costx
                     y1=-sqrt(costx)
                     y2=-y1
                     x1=fm*y1
                     x2=fm*y2
                     go to 530
c--caso if(abs(b(1)).le.zer1)             
  510                continue
                     costx=am(1,1)*am(3,3)-am(1,3)*am(1,3)
                     costx=am(3,3)/costx
                     x1=-sqrt(costx)
                     x2=-x1
                     y1=0.
                     y2=0.
                     go to 530
c--caso if(abs(b(2)).le.zer1)             
  520                continue
                     costx=am(2,2)*am(3,3)-am(2,3)*am(2,3)
                     costx=am(3,3)/costx
                     y1=-sqrt(costx)
                     y2=-y1
                     x1=0.
                     x2=0.
c--memorizza risultati           
  530                continue
                     ParamEllabc(1,2,k)=0.        ! ParamEllabc(1,2,k)
                     ParamEllabc(2,2,k)=x1*2.
                     ParamEllabc(3,2,k)=y1
                     ParamEllabc(4,2,k)=x2
                     ParamEllabc(5,2,k)=y2
                     ParamEllabc(6,2,k)=0.
                     ParamEllabc(7,2,k)=0.
                     ParamEllabc(8,2,k)=0.         ! ParamEllabc(8,2,k)
  501                continue
c-----------------------------------------------
c-- memorizzazione coefficienti ellissi principali   (asse c)
c-- assi,angolo,arco di visione
                     if(iel33.eq.0) then  
                        call elpiso(am,c,ec,ez,az1,az2,fiz,fiz1,fiz2)
                     else
                        if(abs(c(3)).le.zer1) go to 600
                        call elprin(am,ez,c,az1,az2,fiz)
                        call elltan(ec,ez,c,fiz1,fiz2)
                     endif
                     ParamEllabc(1,3,k)=ez(1,1)    ! ParamEllabc(1,3,k)
                     ParamEllabc(2,3,k)=2*ez(1,2)
                     ParamEllabc(3,3,k)=ez(2,2)
                     ParamEllabc(4,3,k)=az1
                     ParamEllabc(5,3,k)=az2
                     ParamEllabc(6,3,k)=fiz
                     ParamEllabc(7,3,k)=fiz1
                     ParamEllabc(8,3,k)=fiz2        ! ParamEllabc(8,3,k)
                     go to 601
c----------------------------------------------------            
  600                continue
c-- caso particolare in cui si annulla una o piu'
c-- componenti dell' autovalore c
                     if(abs(c(1)).le.zer1) go to 610
                     if(abs(c(2)).le.zer1) go to 620
c--caso if(abs(c(3)).le.zer1)             
                     fm=-c(2)/c(1)
                     costx=fm*fm*(am(1,1)*am(3,3)-am(1,3)*am(1,3))+
     *                      2*fm*(am(1,2)*am(3,3)-am(1,3)*am(2,3))+
     *                      am(2,2)*am(3,3)-am(2,3)*am(2,3)
                     costx=am(3,3)/costx
                     y1=-sqrt(costx)
                     y2=-y1
                     x1=fm*y1
                     x2=fm*y2
                     go to 630
c--caso if(abs(c(1)).le.zer1)             
  610                continue
                     costx=am(1,1)*am(3,3)-am(1,3)*am(1,3)
                     costx=am(3,3)/costx
                     x1=-sqrt(costx)
                     x2=-x1
                     y1=0.
                     y2=0.
                     go to 630
c--caso if(abs(c(2)).le.zer1)             
  620                continue
                     costx=am(2,2)*am(3,3)-am(2,3)*am(2,3)
                     costx=am(3,3)/costx
                     y1=-sqrt(costx)
                     y2=-y1
                     x1=0.
                     x2=0.
c--memorizza risultati           
  630                continue
                     ParamEllabc(1,3,k)=0.        ! ParamEllabc(1,3,k)
                     ParamEllabc(2,3,k)=x1*2.
                     ParamEllabc(3,3,k)=y1
                     ParamEllabc(4,3,k)=x2
                     ParamEllabc(5,3,k)=y2
                     ParamEllabc(6,3,k)=0.
                     ParamEllabc(7,3,k)=0.
                     ParamEllabc(8,3,k)=0.        ! ParamEllabc(8,3,k)
  601                continue
!----------------------------------------------------------------
!                       
!--caso ii=2-----------------------------------------------------
                  case(2)       
c-- v12=v13=0 => a=(1,0,0) b=(0,b2,b3) c=(0,c2,c3)
c--memorizzazioni ellissi principali
c-- assi angolo di inclinazione ed arco di visione
                     ParamEllabc(1,1,k)=0.         ! ParamEllabc(1,1,k)
                     ParamEllabc(2,1,k)=va(1)
                     ParamEllabc(3,1,k)=-1/sqrt(am(2,2))+va(2)
                     ParamEllabc(4,1,k)=va(1)
                     ParamEllabc(5,1,k)=1/sqrt(am(2,2))+va(2)
                     ParamEllabc(6,1,k)=0.
                     ParamEllabc(7,1,k)=0.
                     ParamEllabc(8,1,k)=0.         ! ParamEllabc(8,1,k)
c----------------------------------------------------------------
c-- memorizzazione ellisse principale
c-- assi,angolo ed arco di visione
                     call elprin(am,ey,b,ay1,ay2,fiy)
                     call elltan(ec,ey,b,fiy1,fiy2)
                     ParamEllabc(1,2,k)=ey(1,1)     ! ParamEllabc(1,2,k)
                     ParamEllabc(2,2,k)=2*ey(1,2)
                     ParamEllabc(3,2,k)=ey(2,2)
                     ParamEllabc(4,2,k)=ay1
                     ParamEllabc(5,2,k)=ay2
                     ParamEllabc(6,2,k)=fiy
                     ParamEllabc(7,2,k)=fiy1
                     ParamEllabc(8,2,k)=fiy2        ! ParamEllabc(8,2,k)
c----------------------------------------------------------------
                     call elprin(am,ez,c,az1,az2,fiz)
                     call elltan(ec,ez,c,fiz1,fiz2)
                     ParamEllabc(1,3,k)=ez(1,1)    ! ParamEllabc(1,3,k)
                     ParamEllabc(2,3,k)=2*ez(1,2)
                     ParamEllabc(3,3,k)=ez(2,2)
                     ParamEllabc(4,3,k)=az1
                     ParamEllabc(5,3,k)=az2
                     ParamEllabc(6,3,k)=fiz
                     ParamEllabc(7,3,k)=fiz1
                     ParamEllabc(8,3,k)=fiz2        ! ParamEllabc(8,3,k)
!----------------------------------------------------------------
!
!--caso ii=3-----------------------------------------------------
                  case(3)       
c-- v12=v23=0 => a(a1,0,a3) b=(0,1,0) c=(c1,0,c3)
                     call elprin(am,ex,a,ax1,ax2,fix)
c-- memorizzazione ellissi principali
c-- assi,angolo di inclinazione ed arco di visione
                     ParamEllabc(1,1,k)=ex(1,1)     ! ParamEllabc(1,1,k)
                     ParamEllabc(2,1,k)=2*ex(1,2)
                     ParamEllabc(3,1,k)=ex(2,2)
                     ParamEllabc(4,1,k)=ax1
                     ParamEllabc(5,1,k)=ax2
                     ParamEllabc(6,1,k)=fix
                     x1=0.
                     x2=0.
                     y1=-1/sqrt(am(2,2))
                     y2=1/sqrt(am(2,2))
                     a1=a(1)
                     a2=a(2)
                     call arc1(a1,a2,x2,y2,x1,y1,tetaf,tetal)
                     ParamEllabc(7,1,k)=tetaf
                     ParamEllabc(8,1,k)=tetal       ! ParamEllabc(8,1,k)
c----------------------------------------------------------------
                     ParamEllabc(1,2,k)=0.          ! ParamEllabc(1,2,k)
                     ParamEllabc(2,2,k)=-1/sqrt(am(1,1))+va(1)
                     ParamEllabc(3,2,k)=va(2)
                     ParamEllabc(4,2,k)=1/sqrt(am(1,1))+va(1)
                     ParamEllabc(5,2,k)=va(2)
                     ParamEllabc(6,2,k)=0.
                     ParamEllabc(7,2,k)=0.
                     ParamEllabc(8,2,k)=0.          ! ParamEllabc(8,2,k)
c----------------------------------------------------------------
                     call elprin(am,ez,c,az1,az2,fiz)
                     ParamEllabc(1,3,k)=ez(1,1)     ! ParamEllabc(1,3,k)
                     ParamEllabc(2,3,k)=2*ez(1,2)
                     ParamEllabc(3,3,k)=ez(2,2)
                     ParamEllabc(4,3,k)=az1
                     ParamEllabc(5,3,k)=az2
                     ParamEllabc(6,3,k)=fiz
                     x1=0.
                     x2=0.
                     y1=-1/sqrt(am(2,2))
                     y2=1/sqrt(am(2,2))
                     c1=c(1)
                     c2=c(2)
                     call arc1(c1,c2,x2,y2,x1,y1,tetaf,tetal)
                     ParamEllabc(7,3,k)=tetaf
                     ParamEllabc(8,3,k)=tetal       ! ParamEllabc(8,3,k)
!----------------------------------------------------------------
!
!--caso ii=4-----------------------------------------------------
                  case(4)       
c-- v13=v23=0 => a=(a1,a2,0) b=(b1,b2,0) c=(0,0,1)
                     ParamEllabc(1,1,k)=0.         ! ParamEllabc(1,1,k)
                     costx=am(1,1)*a(2)*a(2)+am(2,2)*a(1)*a(1)-
     *                     2*am(1,2)*a(1)*a(2)
                     costx=sqrt(costx)
                     ParamEllabc(2,1,k)=a(2)/costx+va(1)
                     ParamEllabc(3,1,k)=-a(1)/costx+va(2)
                     ParamEllabc(4,1,k)=-a(2)/costx+va(1)
                     ParamEllabc(5,1,k)=a(1)/costx+va(2)
                     ParamEllabc(6,1,k)=0.
                     ParamEllabc(7,1,k)=0.
                     ParamEllabc(8,1,k)=0.         ! ParamEllabc(8,1,k)
c----------------------------------------------------------------
                     ParamEllabc(1,2,k)=0.         ! ParamEllabc(1,2,k)
                     costx=am(1,1)*b(2)*b(2)+am(2,2)*b(1)*b(1)-
     *                      2*am(1,2)*b(1)*b(2)
                     costx=sqrt(costx)
                     ParamEllabc(2,2,k)=-b(2)/costx+va(1)
                     ParamEllabc(3,2,k)=b(1)/costx+va(2)
                     ParamEllabc(4,2,k)=b(2)/costx+va(1)
                     ParamEllabc(5,2,k)=-b(1)/costx+va(2)
                     ParamEllabc(6,2,k)=0.
                     ParamEllabc(7,2,k)=0.
                     ParamEllabc(8,2,k)=0.          ! ParamEllabc(8,2,k)
c----------------------------------------------------------------
                     ParamEllabc(1,3,k)=0.          ! ParamEllabc(1,3,k)
                     ParamEllabc(2,3,k)=0.
                     ParamEllabc(3,3,k)=0.
                     ParamEllabc(4,3,k)=0.
                     ParamEllabc(5,3,k)=0.
                     ParamEllabc(6,3,k)=0.
                     ParamEllabc(7,3,k)=0.
                     ParamEllabc(8,3,k)=0.          ! ParamEllabc(8,3,k)
!----------------------------------------------------------------
!
!--caso ii=5-----------------------------------------------------
                  case(5)       
c-- vij=0 i#j
                     ParamEllabc(1,1,k)=0.          ! ParamEllabc(1,1,k)
                     ParamEllabc(2,1,k)=va(1)
                     ParamEllabc(3,1,k)=-axb+va(2)
                     ParamEllabc(4,1,k)=va(1)
                     ParamEllabc(5,1,k)=axb+va(2)
                     ParamEllabc(6,1,k)=0.
                     ParamEllabc(7,1,k)=0. 
                     ParamEllabc(8,1,k)=0.          ! ParamEllabc(8,1,k)
c----------------------------------------------------------------
                     ParamEllabc(1,2,k)=0.          ! ParamEllabc(1,2,k)
                     ParamEllabc(2,2,k)=-axa+va(1)
                     ParamEllabc(3,2,k)=va(2)
                     ParamEllabc(4,2,k)=axa+va(1)
                     ParamEllabc(5,2,k)=va(2)
                     ParamEllabc(6,2,k)=0.
                     ParamEllabc(7,2,k)=0.
                     ParamEllabc(8,2,k)=0.          ! ParamEllabc(8,2,k)
c----------------------------------------------------------------
                     ParamEllabc(1,3,k)=0.          ! ParamEllabc(1,3,k)
                     ParamEllabc(2,3,k)=0.
                     ParamEllabc(3,3,k)=0.
                     ParamEllabc(4,3,k)=0.
                     ParamEllabc(5,3,k)=0.
                     ParamEllabc(6,3,k)=0.
                     ParamEllabc(7,3,k)=0.
                     ParamEllabc(8,3,k)=0.          ! ParamEllabc(8,3,k)
               end select 
c----------------------------------------------------------------
            endif
            if(istat2.gt.1) then
c-- stampa assi dell ellissoide : axa,axb,axc
c-- ed autovalori:a=(a1,a2,a3),b=(b1,b2,b3),c=(c1,c2,c3)
               write(ncwu,'(21x,a,25x,a)')'axa,axb,axc','(a1,a2,a3)'
               write(ncwu,'(21x,a,26x,a)') '(b1,b2,b3)','(c1,c2,c3)'    
               write(ncwu,10) (ParamEll(j,k),j=1,13)
   10          format(f6.0,6f12.4,/,6x,6f12.4)
c-- stampa coeficienti ellisse principale
c-- assi,angolo di inclinazione,arco di visione
               write(ncwu,'(16x,a,18x,a,14x,a)')'3 coef ellisse princ',
     *                      '2 assi','arco'        
               write(ncwu,8) (ParamEll(j,k),j=14,18),ParamEll(19,k)*rtd
   8           format(6x,6f12.4)
               write(ncwu,'(a)') 'ParamEllabc(1:8,1:3,k)'
               do j=1,3
                  write(ncwu,11) (ParamEllabc(n,j,k),n=1,8)
   11             format(6x,8e12.4)
               enddo
               write(ncwu,*)'angoli inclinazione assi ellissi '
               angolo1=ParamEllabc(6,1,k)*rtd
               angolo2=ParamEllabc(6,2,k)*rtd
               angolo3=ParamEllabc(6,3,k)*rtd
               write(ncwu,334)angolo1,angolo2,angolo3
  334          format(' a=',f7.2,' b=',f7.2,' c=',f7.2)
            endif
      enddo
      return
      end
c
code for cntrl
      subroutine cntrl(idr,fbiso,v,iel33,ii,axa,axb,axc,a,b,c)
c-- calcolo assi dell'ellissoide : axa,axb,axc
c   autovalori :a=(a1,a2,a3),b=(b1,b2,b3),c=(c1,c2,c3)
c   v(3,3) matrice elissoide termico
c
c-----real*8 vn
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension v(3,3),vn(2,2),evl(3),a(3),b(3),c(3),ax(3),ev(3,4)
     *,uj(3),uk(3)
c
c-- calcola autovalori ,assi,ed autovettori dell'ellissoide
c-- avente matrice dei coefficienti v(3,3),trattando separatamente
c-- eventuali condizioni sulla matrice
      zero=0.000001
      a(:)=0.
      b(:)=0.
      c(:)=0.
      evl(:)=0.
c      if(idr.ne.3) go to 250
c      if(iel33.eq.0) goto 250
c      if(v(3,3).eq.0.) then
c      v(1,1)=fbiso
c      go to 250
c      endif
      ij=0
      do i=1,3
         do j=1,3
            if((i.ne.j).and.(abs(v(i,j)).gt.zero)) ij=ij+1
         enddo
      enddo
c--   if(ij) 1,2,1
c      if(ij) 1,250,1
c    2 continue
c-- i termini fuori diagonale sono identicamente nulli
c      ii=5
c      a(1)=1.
c      a(2)=0.
c      a(3)=0.
c      b(1)=0.
c      b(2)=1.
c      b(3)=0.
c      c(1)=0.
c      c(2)=0.
c      c(3)=1.
c      axa=1/sqrt(v(1,1))
c      axb=1/sqrt(v(2,2))
c      axc=1/sqrt(v(3,3))
c      return
c
      if(ij.eq.0.or.idr.ne.3) then
c--disegno BALL
         ii=1
c-- caso isotropo : valori ottenuti effettuando
c-- una rotazione di 30 gradi intorno ad x
c-- una rotazione di 30 gradi intorno ad y
c-- una rotazione d 15 gradi intorno a z
         a(1)=0.8365
         a(2)=0.2241
         a(3)=0.5
         b(1)=-0.4656
         b(2)=0.7718
         b(3)=0.4331
         c(1)=-0.2889
         c(2)=-0.5951
         c(3)=0.75
         axa=1/sqrt(v(1,1))
         axb=1/sqrt(v(1,1))
         axc=1/sqrt(v(1,1))
         v(2,2)=v(1,1)
         v(3,3)=v(1,1)
         return
      endif
c-- i termini fuori diagonale non sono tutti identicamente nulli
c-- ma possono verificarsi casi particolari
      ii=1
      do i=1,3
         call seq(i,j,k)
         if((v(i,j).eq.0).and.(v(i,k).eq.0)) ii=i+1
      enddo
      if(ii.gt.1) then
!--casi particolari (elementi fuori diagonale = 0)      
         select case (ii)
!            
            case (2)      
               i=ii-1
               j=2
               k=3
               a(i)=1.
               evl(i)=v(i,i)
               axa=1/sqrt(evl(i))
!            
            case (3)      
               i=ii-1
               j=1
               k=3
               b(i)=1.
               evl(i)=v(i,i)
               axb=1/sqrt(evl(i))
!            
            case (4)      
               i=ii-1
               j=1
               k=2
               c(i)=1.
               evl(i)=v(i,i)
               axc=1/sqrt(evl(i))
!               
         end select
!         
         ev(:,:)=0.
         vn(1,1)=v(j,j)
         vn(1,2)=v(j,k)
         vn(2,2)=v(k,k)
         vn(2,1)=v(k,j)
         ev(i,i)=1.
         call axang1(vn,evlj,evlk,uj,uk)
         evl(j)=evlj
         evl(k)=evlk
         ev(j,j)=uj(1)
         ev(j,k)=uj(2)
         ev(k,k)=uk(2)
         ev(k,j)=uk(1)
         amn=amin1(evlj,evlk)
         amx=amax1(evlj,evlk)
         do i1=1,3
            ev(i1,4)=evl(i1)
         enddo
         do i1=1,3
            if(i1-i.ne.0) then   
   71          if(ev(i1,4).eq.amn) then    
                  if(i.eq.1) then   
                     do j1=1,3
                        b(j1)=ev(i1,j1)
                     enddo
                     axb=1/sqrt(ev(i1,4))
                  else if((i.eq.2).or.(i.eq.3)) then 
                     do j1=1,3
                        a(j1)=ev(i1,j1)
                     enddo
                     axa=1/sqrt(ev(i1,4))
                  endif
               endif
            endif
         enddo
         do i1=1,3
            if(i1-i.ne.0) then   
   61          if(ev(i1,4).eq.amx) then 
                  if((i.eq.1).or.(i.eq.2)) then   
                      do j1=1,3
                         c(j1)=ev(i1,j1)
                      enddo
                      axc=1/sqrt(ev(i1,4))
                  else if(i.eq.3) then  
                      do j1=1,3
                         b(j1)=ev(i1,j1)
                      enddo
                      axb=1/sqrt(ev(i1,4))
                  endif
               endif   
            endif      
         enddo
      else
c-- nessun caso particolare
         call egnvl(v,evl)
         axa=1/sqrt(evl(1))
         axb=1/sqrt(evl(2))
         axc=1/sqrt(evl(3))
         call egnvc(v,evl,a,b,c)
      endif
      return
      end
c
code for ellc
      subroutine ellc(v,d,a1,a2,fi)
c-- calcolo dei parametri necessari per disegnare una ellisse
c  v(3,3) parametri dell'ellissoide
c  d(2,2) coeff. dell'elisse sul piano di proiezione
c  a1, a2, fi assi dell'ellisse e angolo di inclinazione
c
      real*8  v1,d1
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension v(3,3),d(2,2),u1(3),u2(3),v1(3,3),d1(2,2)
c
      v1(:,:)=v(:,:)
      d1(1,1)=v1(1,1)-(v1(1,3)*v1(1,3))/v1(3,3)
      d1(1,2)=v1(1,2)-(v1(1,3)*v1(2,3))/v1(3,3)
      d1(2,1)=d1(1,2)
      d1(2,2)=v1(2,2)-(v1(2,3)*v1(2,3))/v1(3,3)
      if(istat2.ge.3) then
         write(ncwu,1000)((d1(i,j),j=1,2),i=1,2)
1000     format('dl(2,2):',3d15.4,/,8x,3d15.4)
      endif
      call axang(d1,u1,u2,evl1,evl2,a1,a2,fi)
      d(:,:)=d1(:,:)
      return
      end
c
code for elprin
      subroutine elprin(v,vn,ev,a1p,a2p,fip)
c--calcola proiezione ellisse principale
c  v(3,3) elissoide
c  vn(2,2) coeff. ellisse
c  ev(3) asse dell'elissoide
c  a1p, a2p , fip assi dell'ellisse proiezione e angolo di inclinazione
c
      real*8 v1,vn1
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension v(3,3),vn(2,2),ev(3),u1(3),u2(3),v1(3,3),vn1(2,2)
c
      iwrt=0
      if(iwrt.eq.1) write(ncwu,*)'entro in elprin'
      v1(:,:)=v(:,:)
      sq=ev(3)*ev(3)
      vn1(1,1)=v1(1,1)*ev(3)*ev(3)+v1(3,3)*ev(1)*ev(1)-
     *         2.*v1(1,3)*ev(1)*ev(3)
      vn1(1,1)=vn1(1,1)/sq
      vn1(2,2)=v1(2,2)*ev(3)*ev(3)+v1(3,3)*ev(2)*ev(2)-
     *         2.*v1(2,3)*ev(2)*ev(3)
      vn1(2,2)=vn1(2,2)/sq
      vn1(1,2)=v1(3,3)*ev(2)*ev(1)+v1(1,2)*ev(3)*ev(3)-
     *         v1(1,3)*ev(2)*ev(3)-v1(2,3)*ev(1)*ev(3)
      vn1(1,2)=vn1(1,2)/sq
      vn1(2,1)=vn1(1,2)
      if(iwrt.eq.1) then
         do i=1,2
            write(ncwu,'(2d15.5)') (vn1(i,j),j=1,2)
         enddo
      endif
      call axang(vn1,u1,u2,evl1,evl2,a1p,a2p,fip)
      vn(:,:)=vn1(:,:)
      return
      end
c
code for elltan
      subroutine elltan(d,e,ev,tetaf,tetal)
      USE Trigonometria
c-- calcolo dei punti di tangenza fra l'ellisse contorno
c-- e una ellisse principale
c  d(2,2) ellisse contorno
c  e(2,2) ellisse principale
c  ev(3) asse principale dell'elissoide
c
!      
      real*8 d1,e1,c1,c2,c3,q1
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension d(2,2),e(2,2),ev(3),vo(3),p(3),d1(2,2),e1(2,2)
c
      iwrt=0
      if(iwrt.eq.1) write(ncwu,*)'entro in elltan'
      zero=0.000001
      tetaf=0.0
      tetal=0.0
      d1(:,:)=d(:,:)
      e1(:,:)=e(:,:)
c--      xo=vo(1)
c--      yo=vo(2)
      c1=e1(2,2)-d1(2,2)
      c2=2*(e1(1,2)-d1(1,2))
      c3=e1(1,1)-d1(1,1)
	if(iwrt.eq.1)write(ncwu,*)'c1,c2,c3',c1,c2,c3
      if(dabs(c1).lt.zero) return
      q1=-c2/(2*c1)
      if(iwrt.eq.1)write(ncwu,*)'q1',q1
      costx=d1(1,1)+2*d1(1,2)*q1+d1(2,2)*q1*q1
      if(iwrt.eq.1)write(ncwu,*)'costx',costx
      x1=-sqrt(1/costx)
      x2=sqrt(1/costx)
      y1=q1*x1
      y2=q1*x2
      z1=(-ev(1)*x1-ev(2)*y1)/ev(3)
      z2=(-ev(1)*x2-ev(2)*y2)/ev(3)
      prodv3=ev(1)*y1-ev(2)*x1
      if(iwrt.eq.1)write(ncwu,*)'prodv3',prodv3
      if(prodv3 ) 1,1,2
    1 tetaf=atan2(y2,x2)
      tetal=atan2(y1,x1)
      go to 3
    2 tetaf=atan2(y1,x1)
      tetal=atan2(y2,x2)
    3 continue
      if(tetaf.lt.0) tetaf=tetaf+twopi
      if(tetal.lt.0) tetal=tetal+twopi
      return
      end
c
code for axang1
      subroutine axang1(a,evlj,evlk,uj,uk)
      USE Trigonometria
c--
!      
      real*8 c1,c2,c3
c-----real*8 a
      dimension a(2,2),uj(3),uk(3)
c--
      iwrt=0
      c1=1.
      c2=-(a(1,1)+a(2,2))
      c3=a(1,1)*a(2,2)-a(1,2)*a(2,1)
      call solv2(c1,c2,c3,evlj,evlk,isolx,iwrt)
      if(a(1,2).eq.0) go to 30
      uj(2)=(a(1,1)-evlj)/a(2,1)
      uj(1)=-1.
      ujmod=sqrt(uj(1)*uj(1)+uj(2)*uj(2))
      uj(1)=uj(1)/ujmod
      uj(2)=uj(2)/ujmod
      uk(1)=(a(2,2)-evlk)/a(2,1)
      uk(2)=-1.
      ukmod=sqrt(uk(1)*uk(1)+uk(2)*uk(2))
      uk(1)=uk(1)/ukmod
      uk(2)=uk(2)/ukmod
      return
   30 continue
      if(a(1,1).gt.a(2,2)) go to 40
      uj(1)=1.
      uj(2)=0.
      uk(1)=0.
      uk(2)=1.
      return
   40 continue
      uj(1)=0.
      uj(2)=1.
      uk(1)=1.
      uk(2)=0.
      return
      end
c
code for elpiso
      subroutine elpiso(am,ev,ec,ep,a1p,a2p,fip,tetaf,tetal)
      USE Trigonometria
!      
      real*8 ep1
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension am(3,3),ev(3),ec(2,2),ep(2,2),u1(3),u2(3),ep1(2,2)
c--
      ev3ev3=ev(3)*ev(3)
      ev1ev1=ev(1)*ev(1)
      ev2ev2=ev(2)*ev(2)
      ev1ev2=ev(1)*ev(2)
      ep(1,1)=am(1,1)+(am(1,1)*ev1ev1)/ev3ev3
      ep(2,2)=am(1,1)+(am(1,1)*ev2ev2)/ev3ev3
      ep(1,2)=(am(3,3)*ev1ev2)/ev3ev3
      if((ev(1).eq.0.).or.(ev(2).eq.0.)) ep(1,2)=0.
      ep(2,1)=ep(1,2)
      do i=1,2
      do j=1,2
      ep1(i,j)=ep(i,j)
      enddo
      enddo
      call axang(ep1,u1,u2,evl1,evl2,a1p,a2p,fip)
      c1=ep(2,2)-ec(2,2)
      c2=2.*ep(1,2)
      c3=ep(1,1)-ec(1,1)
      q1=-c2/(2.*c1)
      costx=ec(1,1)+ec(2,2)*q1*q1
      costx=1./costx
      x1=-sqrt(costx)
      x2=sqrt(costx)
      y1=q1*x1
      y2=q1*x2
      z1=(-ev(1)*x1-ev(2)*y1)/ev(3)
      z2=(-ev(1)*x2-ev(2)*y2)/ev(3)
      prodv3=ev(1)*y1-ev(2)*x1
      if(prodv3.le.0.0) then
      tetaf=atan2(y2,x2)
      tetal=atan2(y1,x1)
      else
      tetaf=atan2(y1,x1)
      tetal=atan2(y2,x2)
      endif
      if(tetaf.lt.0.) tetaf=tetaf+twopi
      if(tetal.lt.0.) tetal=tetal+twopi
      return
      end
c
code for axang
      subroutine axang(a,u1,u2,evl1,evl2,a1p,a2p,fip)
      USE Trigonometria
c--
      real*8 a,c1,c2,c3
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension a(2,2),u1(3),u2(3)
c--
      iwrt=0
      if(iwrt.eq.1) then
         write(ncwu,'(a,2f10.5,/,7x,2f10.5)')'a(2,2):',
     *              ((a(j,i),j=1,2),i=1,2)
      endif
      if(a(1,2).eq.0.) then
         ev1=a(1,1)
         ev2=a(2,2)
         evl1=amin1(ev1,ev2)
         evl2=amax1(ev1,ev2)
         a1p=1./sqrt(evl1)
         a2p=1./sqrt(evl2)
         if(a(1,1).gt.a(2,2)) then
            u1(1)=0.
            u1(2)=1.
            u2(1)=1.
            u2(2)=0.
            fip=pi/2.
            return
         endif
         u1(1)=1.
         u1(2)=0.
         u2(1)=0.
         u2(2)=1.
         fip=0.
         return
      endif
      c1=1.
      c2=-(a(1,1)+a(2,2))
      c3=a(1,1)*a(2,2)-a(1,2)*a(2,1)
      call solv2(c1,c2,c3,ev1,ev2,isolx,iwrt)
      if(iwrt.eq.1)then 
         write(ncwu,*)'isolx=',isolx
         write(ncwu,'(a,2f12.5)')'ev1,ev2=',ev1,ev2
      endif
      evl1=amin1(ev1,ev2)
      evl2=amax1(ev1,ev2)
      evl1=abs(evl1)
      evl2=abs(evl2)
      cost1=sqrt(evl1)
      cost2=sqrt(evl2)
      a1p=1./cost1
      a2p=1./cost2
      u1(2)=(a(1,1)-evl1)/a(2,1)
      u1(1)=-1.
      u1mod=u1(1)*u1(1)+u1(2)*u1(2)
      u1mod=sqrt(u1mod)
      u1(1)=u1(1)/u1mod
      u1(2)=u1(2)/u1mod
      u2(1)=(a(2,2)-evl2)/a(2,1)
      u2(2)=-1.
      u2mod=u2(1)*u2(1)+u2(2)*u2(2)
      u2mod=sqrt(u2mod)
      u2(1)=u2(1)/u2mod
      u2(2)=u2(2)/u2mod
      y=u1(2)
      x=u1(1)
      fip=atan2(y,x)
      if(fip.lt.0) fip=fip+twopi
      return
      end
c
code for arc1
      subroutine arc1(x1,y1,x2,y2,u1,u2,alfa1,alfa2)
      USE Trigonometria
!      
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension v(2),w(2)
c--
      prod1=x1*u2-y1*u1
      prod2=x2*u2-y2*u1
      cost=prod1*prod2
      if(cost.ge.0.) go to 100
      if(prod1) 1,1,2
    2 v(1)=x1
      v(2)=y1
      w(1)=x2
      w(2)=y2
      go to 5
    1 v(1)=x2
      v(2)=y2
      w(1)=x1
      w(2)=y1
    5 continue
      if((abs(w(1)).lt.0.0001).and.(abs(w(2)).lt.0.0001)) go to 209
      if((abs(v(1)).lt.0.0001).and.(abs(v(2)).lt.0.0001)) go to 209
      alfa1=atan2(w(2),w(1))
      alfa2=atan2(v(2),v(1))
      if(alfa1.lt.0) alfa1=alfa1+twopi
      if(alfa2.lt.0) alfa2=alfa2+twopi
      go to 208
  209 continue 
      if(istat2.gt.0) then
         write(ncwu,991)
  991    format(' attenzione forma indeterminata in arc1 ',
     *          'atan2(w(2),w(1)) o atan2(v(2),v(1))',/)
      endif
      alfa1=0.
      alfa2=0.
  208 continue
      return
  100 continue
      vmod1=sqrt(x1*x1+y1*y1)
      vmod2=sqrt(x2*x2+y2*y2)
      x1n=x1/vmod1
      y1n=y1/vmod1
      x2n=x2/vmod2
      y2n=y2/vmod2
      prd1=x1n*u2-y1n*u1
      prd2=x2n*u2-y2n*u1
      if(prd1.lt.-1.) prd1=-1.
      if(prd1.gt.1.) prd1=1.
      if(prd2.lt.-1.) prd2=-1.
      if(prd2.gt.1.) prd2=1.
      ro1=asin(prd1)
      ro2=asin(prd2)
      if(ro1.gt.ro2) go to 2
      go to 1
      end
c
code for sae2
      subroutine sae2(idr,ibnd)
c-- calcolo e storizzazione  delle basi bonds
c-- nelle locazioni di memoria da nn3 ad nn4
c-- va(3): coordinate del centro dell'ellissoide 'a'
c-- am(3,3): matrice contenente i coefficienti dell'elllissoide 'a'
c-- vb(3): coordinate del centro dell'ellissoide 'b'
c-- bm(3,3): matrice contenente i coefficienti dell'ellissoide 'b'
c-- eca(2,2): ellisse contorno relativa all'ellissoide 'a'
c-- ecb(2,2): ellisse contorno relativa all'ellissoide 'b'
c-----real*8 eca,exa,eya,eza,ecb,exb,eyb,ezb,ec,ex,ey,ez
c
      USE General
      USE Atomi
      USE Plotter
      USE Molcom
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension va(3),am(3,3),vb(3),bm(3,3),abond(4,60),bbond(4,60),
     *v(3),v1(3),eca(2,2),exa(2,2),eya(2,2),eza(2,2),aa(3),ab(3),
     *ac(3),ecb(2,2),exb(2,2),eyb(2,2),ezb(2,2),ba(3),bb(3),bc(3),
     *ve(3),ec(2,2),ex(2,2),ey(2,2),ez(2,2),a(3),b(3),c(3)
c--
c      jdim=iline+1
c      nn3=nFloc
c      if(ibnd.eq.-1) then
c	   nn4=nn3
c	   return
c      endif
      istat2=0
      nbon=0
c--loop sui bond
      do ii=1,NNLeg
         ia=LEdum(1,ii)
         ib=LEdum(2,ii)
         va(1:3)=xyzsPlo(1:3,ia)
         vb(1:3)=xyzsPlo(1:3,ib)
         if(istat2.gt.0) then
            write(ncwu,'(/,a,i5,2x,2a8,/,6f10.4)')'No Bond:',ii,
     *           aLabPlo(ia),aLabPlo(ib),va(1:3),vb(1:3)
         endif
         call bstor(fbiso,am,ia)
         call bstor(fbiso1,bm,ib)
         if(idr.eq.2) then
            xrm1=0.1
            xrm2=0.1
         else
            xrm1=1.0/fbiso
            xrm2=1.0/fbiso1
         endif
c--leggo le informazioni per i due elissoidi
         call elstor(ia,a1,a2,a3,aa,ab,ac,eca,ac1a,ac2a,fia,idr,
     *               exa,ax1a,ax2a,fixa,fix1a,fix2a,
     *               eya,ay1a,ay2a,fiya,fiy1a,fiy2a,
     *               eza,az1a,az2a,fiza,fiz1a,fiz2a)
         call elstor(ib,b1,b2,b3,ba,bb,bc,ecb,ac1b,ac2b,fib,idr,
     *               exb,ax1b,ax2b,fixb,fix1b,fix2b,
     *               eyb,ay1b,ay2b,fiyb,fiy1b,fiy2b,
     *               ezb,az1b,az2b,fizb,fiz1b,fiz2b)
         int=0
         ica=0
         icb=0
         call lngtp(va,vb,dist)
         axca=amax1(ac1a,ac2a)
         axcb=amax1(ac1b,ac2b)
         axm=axca+axcb
         if(dist.lt.axm) int=1      ! gli ellissi si intersecano
         call ellco(idr,am,bm,eca,ecb,va,vb,int,abond,bbond,nb,
     *           alfa1,alfa2,alfa3,alfa4,janga,jangb,ica,icb,xrm1,xrm2)
         if(istat2.gt.1) then
            write(ncwu,17) ica,icb,ia,ib
   17       format(/,' ica=',i3,2x,'icb=',i3,2x,'bond-> ',i4,2x,i4)
         endif
c--controllo se questo legame va disegnato: ica e icb numero di
c  direttrici che non si disegnano
         if((ica.eq.jdim).or.(icb.eq.jdim)) go to 101 ! bond non si disegna
         nbon=nbon+1
         BondAB(1,nbon)=ia             ! BondAB(1,nbon)
         BondAB(2,nbon)=ib           !        2
c--memorizzo inizio e fine direttrici bond (jdim=iline+1)
         do j1=1,jdim
	      do i1=1,3
	         ABaseBond(i1,j1,nbon)=abond(i1,j1)+va(i1)   ! ABaseBond(1:3,1:jdim,nbon)
	         BBaseBond(i1,j1,nbon)=bbond(i1,j1)+vb(i1)   ! ABaseBond(1:3,1:jdim,nbon)
	      enddo
	      ABaseBond(4,j1,nbon)=abond(4,j1)  ! codice 0/1 per: non disegnare/disegnare base
	      BBaseBond(4,j1,nbon)=bbond(4,j1)  ! codice 0/1 per: non disegnare/disegnare base
         enddo
c--
  101    continue
c--fine loop sui bond
      enddo
  105 continue
      if(istat2.gt.1)  write(ncwu,'(/,a,i5)') ' nbon=',nbon
      if(nbon.eq.0) then
	   ibnd=-1
	   return
      endif
      if(istat2.gt.1) then
         do k=1,nbon
            ia=BondAB(1,k)
            ib=BondAB(2,k)
            write(ncwu,'(i5,a,2a8)')k,' bond, atomi:',
     *                           aLabPlo(ia),aLabPlo(ib)
            do j=1,jdim
               write(ncwu,79) j,ABaseBond(1:4,j,k)
               write(ncwu,79) j,BBaseBond(1:4,j,k)
   79          format(i5,4f10.5)
            enddo
            write(ncwu,'(a)')' next' 
         enddo 
      endif
      return
      end
c
code for BondStor
      subroutine BondStor(j,ia,ib,abond,bbond) 
c--fornisce tutti gli elementi relativi al bond j-esimo
!
      USE General
      USE Plotter
!      
      dimension abond(4,60),bbond(4,60)
!      
      ia = BondAB(1,j)           ! BondAB(1,nbon)
      ib = BondAB(2,j)           !        2
c--recupero inizio e fine direttrici bond (jdim=iline+1)
      do j1=1,jdim
	   do i1=1,4
	      abond(i1,j1) = ABaseBond(i1,j1,j)   ! ABaseBond(1:4,1:jdim,nbon)
	      bbond(i1,j1) = BBaseBond(i1,j1,j)   ! ABaseBond(1:4,1:jdim,nbon)
	   enddo
      enddo
      return
      end
c
code for elstor
      subroutine elstor(j,a1,a2,a3,a,b,c,ec,a1c,a2c,fic,idr,
     * ex,a1x,a2x,fix,fix1,fix2,
     * ey,a1y,a2y,fiy,fiy1,fiy2,
     * ez,a1z,a2z,fiz,fiz1,fiz2)
c--fornisce tutti gli elementi relativi all'ellissoide j-esimo
c-----real*8 ec,ex,ey,ez
c
      USE Plotter
c
      dimension a(3),b(3),c(3),ec(2,2),ex(2,2),ey(2,2),ez(2,2)
c--
      a1=ParamEll(2,j)                ! ParamEll(2,j)
      a2=ParamEll(3,j)
      a3=ParamEll(4,j)
      do i=1,3
      a(i)=ParamEll(4+i,j)
      b(i)=ParamEll(7+i,j)
      c(i)=ParamEll(10+i,j)
      enddo
      ec(1,1)=ParamEll(14,j)
      ec(1,2)=ParamEll(15,j)/2.
      ec(2,1)=ec(1,2)
      ec(2,2)=ParamEll(16,j)
      a1c=ParamEll(17,j)
      a2c=ParamEll(18,j)
      fic=ParamEll(19,j)
!--solo se idr=3      
c      if(idr.ne.3) go to 117
c      if(idr.eq.2) go to 117
      if(idr.eq.3) then
      ex(1,1)=ParamEllabc(1,1,j)            ! ParamEllabc(1,1,j)
      ex(1,2)=ParamEllabc(2,1,j)/2.
      ex(2,1)=ex(1,2)
      ex(2,2)=ParamEllabc(3,1,j)
      a1x=ParamEllabc(4,1,j)
      a2x=ParamEllabc(5,1,j)
      fix=ParamEllabc(6,1,j)
      fix1=ParamEllabc(7,1,j)
      fix2=ParamEllabc(8,1,j)
!      
      ey(1,1)=ParamEllabc(1,2,j)            ! ParamEllabc(1,2,j)
      ey(1,2)=ParamEllabc(2,2,j)/2.
      ey(2,1)=ey(1,2)
      ey(2,2)=ParamEllabc(3,2,j)
      a1y=ParamEllabc(4,2,j)
      a2y=ParamEllabc(5,2,j)
      fiy=ParamEllabc(6,2,j)
      fiy1=ParamEllabc(7,2,j)
      fiy2=ParamEllabc(8,2,j)
!      
      ez(1,1)=ParamEllabc(1,3,j)             ! ParamEllabc(1,3,j)
      ez(1,2)=ParamEllabc(2,3,j)/2.
      ez(2,1)=ez(1,2)
      ez(2,2)=ParamEllabc(3,3,j)
      a1z=ParamEllabc(4,3,j)
      a2z=ParamEllabc(5,3,j)
      fiz=ParamEllabc(6,3,j)
      fiz1=ParamEllabc(7,3,j)
      fiz2=ParamEllabc(8,3,j)
      endif
c  117 continue
      return
      end
c
code for ellco
      subroutine ellco(idr,am,bm,ac,bc,va,vb,int,a,b,nb,
     *alfa1,alfa2,alfa3,alfa4,janga,jangb,ica,icb,xrm1,xrm2)
      USE Trigonometria
      USE Plotter
c--ellisse contorno
c-- am: matrice dei coefficienti dell'ellissoide a
c-- bm: matrice dei coefficienti dell'ellissoide b
c-- ac: matrice dei coefficienti dell'ellisse contorno
c	relativa all'ellissoide 'a'
c-- bc: matrice dei coefficienti dell'ellisse contorno
c	relativa all'ellissoide 'b'
c-- va: contiene le coordinate del centro dell'ellissoide a
c-- vb: contiene le coordinate del centro dell'ellissoide b
c-- int : 0/1 distanza tra i due atomi maggiore/minore della
c             somma delle dimensioni degli elissoidi
c-- a : coordinate punti base delle iline del bond atomo a
c-- b : coordinate punti base delle iline del bond atomo b
c-- iline: numero di generatrici del bond
c-- skdk: fattore di scala
c-- xrm1: raggio dell'atomo a
c-- xrm2: raggio dell'atomo b
c-- abase= 0/1 la base a non va / va disegnata
c-- bbase= 0/1 la base b non va / va disegnata
c-- janga = 0/1 l'ellissoide a non e' / e' interrotto dal bond
c-- jangb = 0/1 l'ellissoide b non e' / e' interrotto dal bond
c-- teta1: angolo dal quale inizia l'interruzione
c-- teta2: angolo dove finisce l'interruzione
c-----real*8 ac,bc
c
!      
      real*8 suma,sumb,sumc
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension am(3,3),bm(3,3),rot(3,3),a(4,60),b(4,60),
     *ac(2,2),bc(2,2),u(3),xa0(3),xb0(3),xar(3),xbr(3),xa(3),xb(3),
     *va(3),vb(3),ba(3),xab(3),xba(3)
c--
      iwrt=0
      do i=1,3
         ba(i)=vb(i)-va(i)
      enddo
      tetaf=pi
      if(idr.eq.2) tetaf=0.1
c      n=2*iline
      del=tetaf/iline           ! incremento della rotazione dell'arco
      dz=abs(va(3)-vb(3))
      dv=5*skdk
      xxxx=dv-dz
      if(idr.eq.4.or.idr.eq.2) xxxx=0.0    ! per la prospettiva
      janga=0
      jangb=0
      nb=0      ! non viene modificato (e' sempre=0)
      ica=0
      icb=0
      zero=0.001
      if(idr.ne.2) then
c--calcolo raggio medio del bond in funzione dei raggi degli atomi
         xrmm=(xrm1+xrm2)/2.0
         xrmm=amin1(xrmm,xrm1,xrm2)
         xrmm=xrmm*xrm
         if (xxxx.ne.0.0) then
             zzz=va(3)-vb(3)
             if (zzz.lt.0.0) then
                 rac=xrmm*(1-dz/(dv-dz))
                 rbc=xrmm*(1+dz/(dv-dz))
                 if (rbc.gt.xrm2) rbc=xrm2
             elseif (zzz.eq.0.0) then
                 rac=xrmm
                 rbc=xrmm
             elseif (zzz.gt.0.0) then
                 rac=xrmm*(1+dz/(dv-dz))
                 rbc=xrmm*(1-dz/(dv-dz))
                 if (rac.gt.xrm1) rac=xrm1
             endif
         else
             rac=xrmm
             rbc=xrmm
         endif
      else
         rac=0.0
         rbc=0.0
      endif
      call lngto(va,vb,dist)
      if(dist.le.zero) then
      u(1)=0.
      u(2)=0.
      u(3)=0.
      d=0
      radu=0.
      goto 17
      endif
      u(1)=(vb(1)-va(1))/dist
      u(2)=(vb(2)-va(2))/dist
      u(3)=(vb(3)-va(3))/dist
      call lngtp(va,vb,d)
c      if(abs(u(2)).le.zero) go to 17
      if(abs(u(2)).gt.zero) then
         radu=sqrt(u(1)*u(1)+u(2)*u(2))
         xa0(1)=0.
         if(radu.ne.0.) xa0(1)=(rac*u(2))/radu
         xa0(2)=-(u(1)/u(2))*xa0(1)
         xa0(3)=0.
         xb0(1)=0.
         if(radu.ne.0.) xb0(1)=(rbc*u(2))/radu
         xb0(2)=-(u(1)/u(2))*xb0(1)
         xb0(3)=0.
         go to 18
      endif
   17 continue
         radu=u(1)
         xa0(1)=0.0
         if(u(1).ne.0.0) xa0(1)=(rac*u(2))/u(1)
         xa0(2)=-rac
         xa0(3)=0.
         xb0(1)=0.0
         if(u(1).ne.0.0) xb0(1)=(rbc*u(2))/u(1)
         xb0(2)=-rbc
         xb0(3)=0.
   18 continue
      if(istat2.ne.0) then
         write(ncwu,199) xa0,xb0
  199    format(/,' xa0=',3f10.5,/,' xb0=',3f10.5)
      endif
c-- ricerca e memorizzazione degli altri punti
c-- ottenuti per rotazione
      ig1=0
      ig2=0
      numline=iline+1
c      if(idr.eq.2) numline=1
      if(istat2.ne.0) write(ncwu,*) ' iline=',iline
      do 5000 jd1=1,numline
         abase=1.
         bbase=1.
         call mrot(u,tetaf,rot)
         call vrgv(xa0,rot,xar)
         call vrgv(xb0,rot,xbr)
         if(istat2.gt.1) then
            write(ncwu,*) ' u=',u
            write(ncwu,*) ' rot=',rot
            write(ncwu,*) ' xar=',xar    ! base sul 1 atomo
            write(ncwu,*) ' xbr=',xbr    ! base sul 2 atomo
            write(ncwu,*) ' am=',am
         endif
c-- calcolo del parametro 'ta' che descrive i punti di intersezione
c-- fra l'ellissoide 'a' ed il cilindro di raggio rac
         suma=0.
         sumb=0.
         sumc=0.
         do i=1,3
            do j=1,3
               suma=suma+am(i,j)*u(i)*u(j)
               sumb=sumb+xar(i)*am(i,j)*u(j)
               sumc=sumc+am(i,j)*xar(i)*xar(j)
            enddo
         enddo
         sumb=2*sumb
         sumc=sumc-1
         if(istat2.gt.1) write(ncwu,'(a,3f12.5)')' suma,sumb,sumc=',
     *                       suma,sumb,sumc
         call solv2(suma,sumb,sumc,t1,ta,isolx,iwrt)
c-- calcolo del parametro 'tb' che descrive i punti di intersezione
c-- fra l'ellissoide 'b' ed il cilindro di raggio rbc
         suma=0.
         sumb=0.
         sumc=0.
         do i=1,3
            do j=1,3
               suma=suma+bm(i,j)*u(i)*u(j)
               sumb=sumb+xbr(i)*bm(i,j)*u(j)
               sumc=sumc+bm(i,j)*xbr(i)*xbr(j)
            enddo
         enddo
         sumb=2*sumb
         sumc=sumc-1
         call solv2(suma,sumb,sumc,tb,t2,isolx,iwrt)
c--punti intersezione bond-elisse(a) = xa(i)
c--punti intersezione bond-elisse(b) = xb(i)
         do k=1,3
            xa(k)=xar(k)+u(k)*ta
            xb(k)=xbr(k)+u(k)*tb
         enddo
c-- calcolo del parametro 'tai' che descrive nel piano le intersezioni
c-- fra le generatrici del tronco di cono e l'ellisse contorno
c-- ralativa alla proiezione dell'ellissoide 'a'
         suma=0.
         sumb=0.
         sumc=0.
         do i=1,2
            do j=1,2
               suma=suma+ac(i,j)*u(i)*u(j)
               sumb=sumb+ac(i,j)*xar(i)*u(j)
               sumc=sumc+ac(i,j)*xar(i)*xar(j)
            enddo
         enddo
         sumb=2*sumb
         sumc=sumc-1
        if(istat2.gt.1) write(ncwu,'(a,3f12.5)')'25 suma,sumb,sumc=',
     *                  suma,sumb,sumc
         call solv2(suma,sumb,sumc,t1,tai,isolx,iwrt)
c-- calcolo del parametro 'tbi' che descrive nel piano le intersezioni
c-- fra le generatrici del tronco di cono e l'ellisse contorno
c-- ralativa alla proiezione dell'ellissoide 'b'
         suma=0.
         sumb=0.
         sumc=0.
         do i=1,2
            do j=1,2
               suma=suma+bc(i,j)*u(i)*u(j)
               sumb=sumb+bc(i,j)*xbr(i)*u(j)
               sumc=sumc+bc(i,j)*xbr(i)*xbr(j)
            enddo
         enddo
         sumb=2*sumb
         sumc=sumc-1
        if(istat2.gt.1) write(ncwu,'(a,3f12.5)')'35 suma,sumb,sumc=',
     *                  suma,sumb,sumc
         call solv2(suma,sumb,sumc,tbi,t2,isolx,iwrt)
c-- si confronta la quota del punto xar con la quota del punto
c-- sull'ellisse contorno per decidere se l'ellissoide 'a' e'
c-- interrotto oppure se i punti dell'ellisse contorno
c-- vanno sostituiti ai punti della base del bond
         za=-(am(1,3)*xa(1)+am(2,3)*xa(2))/am(3,3)   ! quota elisse contorno
         if(xa(3)-za.le.0.0) then                    ! quota base bond confronto con quota elisse
c--condizione: quota base bond inferiore quota elisse contorno
            abase=0.
            do k=1,3
               xa(k)=xar(k)+u(k)*tai
            enddo
         else
c--condizione: quota base bond superiore quota elisse contorno
            ig1=ig1+1
            janga=1
            if (ig1.eq.1) then
                x1f=xar(1)+u(1)*tai
                y1f=xar(2)+u(2)*tai
            else
                x2f=xar(1)+u(1)*tai
                y2f=xar(2)+u(2)*tai
            endif
         endif
c-- si confronta la quota del punto xbr con la quota del punto
c-- sull'ellisse contorno per decidere se l'ellissoide 'b' e'
c-- interrotto oppure se i punti dell'ellisse contorno
c-- vanno sostituiti ai punti della base del bond
         zb=-(bm(1,3)*xb(1)+bm(2,3)*xb(2))/bm(3,3)
         if(xb(3)-zb.le.0.0) then
            bbase=0.
            do k=1,3
               xb(k)=xbr(k)+u(k)*tbi
            enddo
         else
            ig2=ig2+1
            jangb=1
            if (ig2.eq.1) then
                x1l=xbr(1)+u(1)*tbi
                y1l=xbr(2)+u(2)*tbi
            else
                x2l=xbr(1)+u(1)*tbi
                y2l=xbr(2)+u(2)*tbi
            endif
         endif
c--controllo il flag int (ellissi si inersecano)
c  il vettore ba(i) e  la differenza vb(i)-va(i)
         if (int.eq.1) then
            do i=1,3
               xba(i)=xb(i)+ba(i)
               xab(i)=xa(i)-ba(i)
            enddo
            ella=ac(1,1)*xba(1)*xba(1)+2*ac(1,2)*xba(1)*xba(2)+
     *           ac(2,2)*xba(2)*xba(2)-1.
            ellb=bc(1,1)*xab(1)*xab(1)+2*bc(1,2)*xab(1)*xab(2)+
     *           bc(2,2)*xab(2)*xab(2)-1.
            if(va(3)-vb(3)) 907,902,908
  907       continue
            if(ellb.gt.0.) go to 902
            icb=icb+1
            do ij=1,3
               xb(ij)=xbr(ij)+u(ij)*tbi
               xa(ij)=xb(ij)+vb(ij)-va(ij)
            enddo
            go to 902
  908       continue
            if(ella.gt.0.) go to 902
            ica=ica+1
            do ij=1,3
               xa(ij)=xar(ij)+u(ij)*tai
               xb(ij)=xa(ij)+va(ij)-vb(ij)
            enddo
  902       continue
         endif
         do k=1,3
            call xappro(xa)    ! approssimo il vettore alla stessa cifra decimale
            a(k,jd1)=xa(k)
            call xappro(xb)
            b(k,jd1)=xb(k)
         enddo
         a(4,jd1)=abase
         b(4,jd1)=bbase
         tetaf=tetaf+del
 5000 continue
      if(janga.eq.1) then
c----- call arc(x1f,y1f,x2f,y2f,alfa1,alfa2)
      else
       alfa1=0.
       alfa2=twopi
      endif
      if(jangb.eq.1) then
c----- call arc(x1l,y1l,x2l,y2l,alfa3,alfa4)
      else
       alfa3=0.
       alfa4=twopi
      endif
      return
      end
c
code for sae3
      subroutine sae3(idr,ibnd)
c--memorizzo tratti oscuri elisse contorno nn5--nn6
c-----real*8 ec,ex,ey,ez,ecb,exb,eyb,ezb
c
      USE General
      USE Atomi
      USE Plotter
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      dimension abond(4,60),bbond(4,60),v(100),egv(3),
     *ec(2,2),ex(2,2),ey(2,2),ez(2,2),bm(3,3),va(3),vb(3),
     *vc(5000),a(3),b(3),c(3),ve(100),
     *ab(3),bb(3),cb(3),ecb(2,2),exb(2,2),eyb(2,2),ezb(2,2),
     *bm1(3,3),tetc(10)
c--
      istat2=0
      zero=0.00001
      iwrt=0
      iwrtx=0
      nn5=nFloc
      nind=nFloc
      jind=nn5
c--primo ellisse    (il loop puo essere sugli atomi...)
      do kj=1,natsPlo
         nell=0
         call elstor(kj,axa,axb,axc,a,b,c,ec,a1c,a2c,fic,idr,
     *               ex,a1x,a2x,fix,fix1,fix2,
     *               ey,a1y,a2y,fiy,fiy1,fiy2,
     *               ez,a1z,a2z,fiz,fiz1,fiz2)
         idim=1
         icc=0
         vc(:)=0.
c--pick up the current atoms
         va(1:3)=xyzsPlo(1:3,kj)
         call bstor(fbiso,bm,kj)
          if(istat2.gt.1.or.iwrt.eq.1) then
            write(ncwu,'(a)')'========================================='
            write(ncwu,'(a,a8,3f10.4)') ' atomo 1: ',aLabPlo(kj),va
         endif
         egv(1)=bm(1,3)
         egv(2)=bm(2,3)
         egv(3)=bm(3,3)
c--intersezione elisse--bond
         if(ibnd.eq.1) then
c--loop sui bond
c            iwrt=0
            if(istat2.gt.1.or.iwrt.eq.1) 
     *             write(ncwu,*)'Controllo intersezione ellisse-bond'
            do j=1,nbon
               call BondStor(j,ia,ib,abond,bbond) 
               int=0
               if(istat2.gt.1.or.iwrt.eq.1) then
                  write(ncwu,'(a,2a8)')' bond: ',aLabPlo(ia),aLabPlo(ib)
               endif
               if(istat2.gt.1.or.iwrt.eq.1) then
                  do j1=1,jdim
                    write(ncwu,'(a,i2,4f10.5)')' linea',j1,abond(1:4,j1)
                    write(ncwu,'(a,   4f10.5)')'        ' ,bbond(1:4,j1)
                  enddo
               endif
c--fine memorizzazioni direttrici
c--calcolo interruzione elissoide contorno a causa bond
               call eprbn(idr,ec,egv,va,abond,bbond,jdim,int,
     *                    x1,y1,x2,y2,iwrtx)
               if(iwrt.eq.1) then
                  write(ncwu,'(a,i4,a,i5,4f10.2)')'atom=',kj,' int',int,
     *                                            x1,y1,x2,y2
               endif
               if(int.eq.-1) then
                  Finter(j)=0
                  Finter(j+1)=0
               else
                  if(int.gt.0) then
c--calcola tratto dei ellisse oscurato come angolo iniziale e finale
c  alfa1 = inizio  ;  alfa2 = fine tratto oscurato
                     call arc(x1,y1,x2,y2,alfa1,alfa2)
                     icc=icc+1
                     if(iwrt.eq.1) then
                        write(ncwu,'(a,2f10.2)') 'alfa=',
     *                           alfa2*rtd,alfa1*rtd
                     endif
                     vc(idim)=alfa2
                     vc(idim+1)=alfa1
                     idim=idim+2
                  endif
c------------------------------------------------
                  call eprbn2(ec,egv,va,abond,bbond,jdim,ve,ndim,
     *                          nell,iwrtx)
                  if(iwrt.eq.1) then
                     write(ncwu,*)'ndim,idim ',ndim,idim
                  endif
                  if(nell.gt.0) go to 93
                  if(ndim.gt.0) then
                     do i1=1,ndim
                        vc(idim+i1-1)=ve(i1)
                     enddo
                     idim=idim+ndim
                     if(iwrt.eq.1) then
                        write(ncwu,'(8f10.4)')(vc(i1)*rtd,i1=1,idim-1)
                     endif
                     icc=icc+1
                  endif
               endif
            enddo
         endif
c---- intersezioni ellisse--ellisse
c--loop sugli elisse
c         iwrt=0
         if(istat2.gt.1.or.iwrt.eq.1) 
     *             write(ncwu,*)'Controllo intersezione ellisse-ellisse'
         do ij=1,natsPlo
            if(ij.ne.kj) then
c--pick up second the atoms
               vb(1:3)=xyzsPlo(1:3,ij)
c--distanza tra i due centri degli ellissi 
!--(controllo che i centri non siano esattamente coincidenti)
               hhh=vb(1)-va(1)
               sss=vb(2)-va(2)
               if((abs(hhh).lt.zero).and.(abs(sss).lt.zero)) cycle
               call bstor(fbiso,bm1,ij)
               if(istat2.gt.1.or.iwrt.eq.1)then
                  write(ncwu,'(a,a8,3f10.4)') 'atomo 2: ',aLabPlo(ij),vb
                  write(ncwu,'(a,2i5)')'ij,kj=',ij,kj
               endif
              call elstor(ij,axab,axbb,axcb,ab,bb,cb,ecb,a1cb,a2cb,ficb,
     *                    idr,exb,a1xb,a2xb,fixb,fix1b,fix2b,
     *                    eyb,a1yb,a2yb,fiyb,fiy1b,fiy2b,
     *                    ezb,a1zb,a2zb,fizb,fiz1b,fiz2b)
               call lngtp(va,vb,dist)
               ax1=amax1(a1c,a2c)
               ax2=amax1(a1cb,a2cb)
               axm=ax1+ax2
               if(dist.le.axm) then
c--controllo se il secondo atomo (vb) ha la z maggiore
                  if(va(3).lt.vb(3)) then
                     im=0
                     call ellint(va,vb,ec,ecb,ndimc,tetc,im,
     *                           an,bn,cn,dn,en,fn,iwrtx)
                     iwrtx=0
                     if(istat2.gt.1.or.iwrt.eq.1) then
                        write(ncwu,'(a,4f10.3)')'dist,axm,ax1,ax2=',
     *                              dist,axm,ax1,ax2
                        write(ncwu,'(a,2i5)')'ndimc,im=',ndimc,im
                     endif
                     if(im.eq.4) then
                        ndimc=0
                        ellb=fn
                        if((ellb.lt.0.).and.(va(3).lt.vb(3)))then
                           if(ax1.lt.ax2) go to 93
                        endif
                     endif
                     if(ndimc.gt.0) then
                        do j1=1,ndimc
                           vc(idim-1+j1)=tetc(j1)
                           if(iwrt.eq.1) then
                         write(ncwu,'(a,f10.3)')'tetc(j1)=',tetc(j1)*rtd
                           endif
                        enddo
                        idim=idim+ndimc
                        icc=icc+1
                     endif
                  endif
               endif
            endif
         enddo
         go to 602
   93    continue
         idim=1
         vc(idim)=0.
         vc(idim+1)=0.
         idim=3
         go to 94
  602    continue
         if(icc.eq.0) then
            vc(idim)=twopi
            vc(idim+1)=0.
            idim=idim+2
         endif
   94    continue
         Finter(jind)=kj
         Finter(jind+1)=idim-1
         nFloc=nFloc+2
         do ij=1,idim-1
            Finter(jind+1+ij)=vc(ij)
            nFloc=nFloc+1
         enddo
         if (istat2.gt.1.or.iwrt.eq.1) then
             write(ncwu,331) aLabPlo(kj)
  331       format('atom : ', a8)
            m=Finter(jind+1)
            write(ncwu,520) Finter(jind),Finter(jind+1)
            write(ncwu,520) (Finter(jind+1+j)*rtd,j=1,m)
  520       format(10f8.2)
         endif
         jind=jind+2+idim-1
      enddo
      nn6=nFloc-1
      iwrt=0
      istat2=0
      return
      end
c
code for sae31
      subroutine sae31(idr,jdise)
c--disegno ball o elissoide (ellisse contorno)
c-----real*8 ec,ex,ey,ez
c
      USE General
      USE Atomi
      USE Plotter
!
      character*80 ifilin
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      dimension abond(4,60),bbond(4,60),
     *ec(2,2),ex(2,2),ey(2,2),ez(2,2),va(3),vb(3),
     *vc(5000),a(3),b(3),c(3),p1(3),p2(3),s1(3),s2(3)
c--
      if (jdise.eq.1) then
          call scrper('Drawing balls/ellipsoids on file',0,0)
      else
          call scrper('Drawing balls/ellipsoids on screen',0,0)
      endif
      if(istat2.gt.1) then
         write(ncwu,*)'============================================'
         write(ncwu,'(a)')'disegno ball o elissoide (ellisse contorno)' 
      endif
!      
      do 100 kj=1,natsPlo
         iwrt=0
         call elstor(kj,axa,axb,axc,a,b,c,ec,a1c,a2c,fic,idr,
     *              ex,a1x,a2x,fix,fix1,fix2,
     *              ey,a1y,a2y,fiy,fiy1,fiy2,
     *              ez,a1z,a2z,fiz,fiz1,fiz2)
         do j=1,5000
            vc(j)=0.
         enddo
         va(1:3)=xyzsPlo(1:3,kj)
         j=AdrPloto5(kj)
         kkk=jSingleColor(j)
         write(ifilin,331)aLabPlo(kj),kkk
  331    format('atom : ',a8,i5)
         call plwrit(ifilin)
         call cpen(kkk)
         j= nn5
  200    continue
         k=Finter(j)
         idim=Finter(j+1)
         if(k.eq.kj) go to 210
         j=j+2+idim
         if(j.le.nn6) go to 200
  210    continue
         do ij=1,idim
            vc(ij)=Finter(j+1+ij)
         enddo
         if (istat2.gt.1.or.iwrt.eq.1) then
             write(ncwu,*)'++++++++++++++++++++++++++++++++++++++++++++'
             write(ncwu,331) aLabPlo(kj)
             write(ncwu,'(a,i5)') ' idim',idim
             write(ncwu,78) (vc(i3)*rtd ,i3=1,idim)
   78       format(10f8.3)
         endif
         if((vc(1).eq.0.).and.(vc(2).eq.0.)) go to 256  !<<<<<=======
         idim=idim+1
         call ordarc(vc,idim,ifus)
         if (istat2.gt.1.or.iwrt.eq.1) then
             write(ncwu,'(a,2i5)') ' idim,ifus',idim,ifus
             write(ncwu,78) (vc(i3)*rtd ,i3=1,idim)
         endif
         xo=va(1)
         yo=va(2)
         call plpoa(xo,yo)
         do ij=2,idim-1,2
            teta1=vc(ij)
            teta2=vc(ij+1)
            if (istat2.gt.1.or.iwrt.eq.1) then
                write(ncwu,'(a,2i5,2f10.2)')
     *             ' idim,ij,t1,t2:',idim,ij, teta1*rtd ,teta2*rtd
            endif
            call elpr(xo,yo,a1c,a2c,fic,teta1,teta2)
         enddo
         call plpup
  256    continue
  100 continue
      do i=1,nn6-nn5+1
         Finter(nn5+i)=0.
      enddo
      nFloc=nind
!
      call scrper(' ',0,-1)
!
      return
      end
c
code for eprbn
      subroutine eprbn(idr,e,egv,v,abond,bbond,jdim,int,
     2   x1,y1,x2,y2,iwrt)
c--calcolo interruzione elissoide contorno a causa bond
c  e   elisse contorno
c  egv autovettore
c  v   coordinate dell'atomo (centro dell'elissoide)
c  abond bbond coordinate inizieli e finali direttrici bond
c  jdim numero di direttrici
c  int 0/1 se elissoide non e' / e' interrotto
c  x1,y1 x2,y2 coordinate dell'interruzione
c	       (relative all'origine centro atomo)
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension abond(4,60),bbond(4,60),e(2,2),egv(3),
     *xa(3),xb(3),xc(3),xd(3),v(3),vint(3)
c--
      zero=1.e-06
      a1=e(1,1)
      b1=2.*e(1,2)
      c1=e(2,2)
      int=0
      x1=0.
      y1=0.
      z1=0.
      x2=0.
      y2=0.
      z2=0.
c--loop sulle direttrici
      do j=1,jdim-1
	   do i=1,3
	      xa(i)=abond(i,j)-v(i)
	      xb(i)=bbond(i,j)-v(i)
	      xc(i)=abond(i,j+1)-v(i)
	      xd(i)=bbond(i,j+1)-v(i)
	   enddo
	   k=0
	   ell1=a1*xa(1)*xa(1)+b1*xa(1)*xa(2)+c1*xa(2)*xa(2)-1.
 	   ell2=a1*xb(1)*xb(1)+b1*xb(1)*xb(2)+c1*xb(2)*xb(2)-1.
	   ell3=a1*xc(1)*xc(1)+b1*xc(1)*xc(2)+c1*xc(2)*xc(2)-1.
	   ell4=a1*xd(1)*xd(1)+b1*xd(1)*xd(2)+c1*xd(2)*xd(2)-1.
	   if(abs(ell1).le.zero) ell1=0.
	   if(abs(ell2).le.zero) ell2=0.
	   if(abs(ell3).le.zero) ell3=0.
	   if(abs(ell4).le.zero) ell4=0.
	   if(ell1.le.0.) k=k+1
	   if(ell2.le.0.) k=k+1
	   if(ell3.le.0.) k=k+1
	   if(ell4.le.0.) k=k+1
	   if(iwrt.eq.1) then
	       write(ncwu,'(a,i5,4e15.5)')' k,ell:',k,ell1,ell2,ell3,ell4
	   endif
	   if(k.gt.0) then
	      call intpr(e,egv,xa,xb,intp,vint,intex,iwrt)
	      if(iwrt.eq.1)write(ncwu,*)'linea AB:j,intp,int:',j,intp,int
	      if(intp.gt.0) then
	         int=int+1
	         if(int.eq.1) then
	            x1=vint(1)
	            y1=vint(2)
	            z1=vint(3)
	         else
	            x2=vint(1)
	            y2=vint(2)
	            z2=vint(3)
	         endif
	         if(iwrt.eq.1) then
	             write(ncwu,'(a,4f10.2)')' x1,y1,x2,y2:',x1,y1,x2,y2
	         endif
	      endif
	      if(idr.ne.4)then
	         call intpr(e,egv,xa,xc,intp,vint,intex,iwrt)
	         if(iwrt.eq.1) write(ncwu,*)' linea AC:j,intp,int:',j,intp,int
	         if(intp.gt.0) then
	            int=int+1
	            if(int.eq.1) then
	               x1=vint(1)
	               y1=vint(2)
	               z1=vint(3)
	            else
	               x2=vint(1)
	               y2=vint(2)
	               z2=vint(3)
	            endif
	            if(iwrt.eq.1) then
	               write(ncwu,'(a,4f10.2)')' x1,y1,x2,y2:',x1,y1,x2,y2
	            endif
	         endif
	      endif
	      call intpr(e,egv,xc,xd,intp,vint,intex,iwrt)
	      if(iwrt.eq.1) write(ncwu,*)' linea CD:j,intp,int:',j,intp,int
	      if(intp.gt.0) then
	         int=int+1
	         if(int.eq.1) then
	            x1=vint(1)
	            y1=vint(2)
	            z1=vint(3)
	         else
	            x2=vint(1)
	            y2=vint(2)
	            z2=vint(3)
	         endif
	         if(iwrt.eq.1) then
	            write(ncwu,'(a,4f10.2)')' x1,y1,x2,y2:',x1,y1,x2,y2
	         endif
	      endif
	      if(idr.ne.4) then
	         call intpr(e,egv,xb,xd,intp,vint,intex,iwrt)
	         if(iwrt.eq.1) write(ncwu,*)' linea BD:j,intp,int:',j,intp,int
	         if(intp.gt.0) then
	            int=int+1
	            if(int.eq.1) then
	               x1=vint(1)
	               y1=vint(2)
	               z1=vint(3)
	            else
	               x2=vint(1)
	               y2=vint(2)
	               z2=vint(3)
	            endif
	            if(iwrt.eq.1) then
	               write(ncwu,'(a,4f10.2)')' x1,y1,x2,y2:',x1,y1,x2,y2
	            endif
	         endif
	      endif
	   endif
      enddo
      if(int.gt.0) then
         dx=x2-x1
         dy=y2-y1
         if(abs(dx).lt.0.001.and.abs(dy).lt.0.001)int=0
      endif
      return
      end
c
code for eprbn2
      subroutine eprbn2(e,egv,v,abond,bbond,jdim,ve,ndim,nell,iwrt)
c-----real*8 e
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension abond(4,60),bbond(4,60),v(3),e(2,2),
     *ve(50),egv(3),xa(3),xb(3),x1(100),x2(100)
c--
      zero=0.001
      ndim=0
      nell=0
      do i=1,50
      ve(i)=0.
      enddo
      a1=e(1,1)
      b1=2*e(1,2)
      c1=e(2,2)
      int=0
      kx1=1
      kx2=1
      imem=0
      do j=1,jdim
       ibn=0.
       do i=1,3
	xa(i)=abond(i,j)-v(i)
	xb(i)=bbond(i,j)-v(i)
	if(i.le.2) then
	if(abs(xa(i)-xb(i)).lt.zero) ibn=ibn+1
	endif
       enddo
       if(ibn.lt.2) then
	call ebint(a1,b1,c1,xa,xb,t1,t2,isolx,iwrt)
	if(iwrt.eq.1) then
	  write(ncwu,'(a,3i5)') 'j,ibn,isolx:',j,ibn,isolx
	endif
	if(isolx.eq.0) goto 25
	if(iwrt.eq.1) then
	  write(ncwu,'(a,i5,2f10.3)') 'eprbn2',j,t1,t2
	endif
	if((t1.ge.0).and.(t1.le.1)) go to 15
	go to 25
   15	if((t2.ge.0).and.(t2.le.1)) go to 30
	go to 25
c-- 0<t1<1 0<t2<1
   30	x1(kx1	)=xa(1)+t1*(xb(1)-xa(1))
	x1(kx1+1)=xa(2)+t1*(xb(2)-xa(2))
	x1(kx1+2)=xa(3)+t1*(xb(3)-xa(3))
	x1(kx1+3)=j
	x2(kx2	)=xa(1)+t2*(xb(1)-xa(1))
	x2(kx2+1)=xa(2)+t2*(xb(2)-xa(2))
	x2(kx2+2)=xa(3)+t2*(xb(3)-xa(3))
	x2(kx2+3)=j
	xint=x1(kx1  )
	yint=x1(kx1+1)
	zint=x1(kx1+2)
	z=(-egv(1)*xint-egv(2)*yint)/egv(3)
	if(z-zint) 21,21,25
   21	xint=x2(kx2  )
	yint=x2(kx2+1)
	zint=x2(kx2+2)
	z=(-egv(1)*xint-egv(2)*yint)/egv(3)
	if(z-zint) 31,31,25
   31	kx1=kx1+4
	kx2=kx2+4
	imem=imem+1
       endif
   25  continue
      enddo
c--	write(ncwu,'(a,i5)') ' imem',imem
c-- analisi dei vettori x1 ed x2
      kx1=kx1-1
      kx2=kx2-1
      if(imem.gt.0) then
	if(((x1(4).eq.1.).and.(x1(kx1).eq.jdim)).and.
     *	   ((x2(4).eq.1.).and.(x2(kx2).eq.jdim))) go to 65
	if(((x1(4).ne.1.).and.(x1(kx1).eq.jdim)).and.
     *	   ((x2(4).ne.1.).and.(x2(kx2).eq.jdim))) go to 70
	if(((x1(4).eq.1.).and.(x1(kx1).ne.jdim)).and.
     *	   ((x2(4).eq.1.).and.(x2(kx2).ne.jdim))) go to 64
	go to 71
   65	continue
c-- 0<t1<1 0<t2<1
	xx1=x1(1)
	xy1=x1(2)
	xx2=x1(kx1-3)
	xy2=x1(kx1-2)
	xx3=x2(1)
	xy3=x2(2)
	xx4=x2(kx2-3)
	xy4=x2(kx2-2)
	call arc(xx1,xy1,xx2,xy2,alfa1,alfa2)
	call arc(xx3,xy3,xx4,xy4,alfa3,alfa4)
	ndim=4
	ve(ndim-3)=alfa2
	ve(ndim-2)=alfa1
	ve(ndim-1)=alfa4
	ve(ndim  )=alfa3
	go to 1000
   70	xx1=x1(kx1-3)
	xy1=x1(kx1-2)
	xx2=x2(kx2-3)
	xy2=x2(kx2-2)
	call arc(xx1,xy1,xx2,xy2,alfa1,alfa2)
	ndim=2
	ve(ndim-1)=alfa2
	ve(ndim  )=alfa1
	go to 1000
   64	xx1=x1(1)
	xy1=x1(2)
	xx2=x2(1)
	xy2=x2(2)
	call arc(xx1,xy1,xx2,xy2,alfa1,alfa2)
	ndim=2
	ve(ndim-1)=alfa2
	ve(ndim  )=alfa1
	go to 1000
   71	continue
c	nell=nell+1
      endif
 1000 continue
      return
      end
c
code for ordarc
      subroutine ordarc(v,idim,ifus)
      USE Trigonometria
c--v: vettore contenente gli archi
c--idim: dimensione effettiva del vattore
c--ifus: numero di fusioni effettuate
!      
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension v(*)
c--
      ifus=0
      iprt=0
      idim=idim-1
      if(idim.eq.2) then
       v(idim+1)=v(1)
       idim=idim+1
       go to 25
      endif
c-- sdoppiamento di intervalli contenenti lo 0
      i=1
  200 continue
      i2=idim-1
      if(i-i2) 31,31,32
   31 continue
      if(v(i).le.(v(i+1)+0.000001)) go to 130
      j=i+1
      j1=idim+2
      j2=j1-2
  120 continue
      if(j-j2) 21,21,22
   21 v(j1)=v(j2)
      j1=j1-1
      j2=j2-1
      go to 120
   22 continue
      v(j)=twopi
      v(j+1)=0.
      idim=idim+2
  130 continue
      i=i+2
      go to 200
   32 continue
      if(iprt.eq.1) then
	write(ncwu,'(a,i5)') ' $idim',idim
	write(ncwu,78) (v(i),i=1,idim)
   78	format(10f8.3)
       endif
c------------------------------------------------
c-- ordinamento delle coppie di archi secondo il
c-- primo elemento della coppia
      do 10 i=1,idim-3,2
      do 15 j=i+2,idim-1,2
      if(v(i)-v(j)) 1,3,2
    2 continue
      com1=v(i)
      v(i)=v(j)
      v(j)=com1
      com2=v(i+1)
      v(i+1)=v(j+1)
      v(j+1)=com2
      go to 1
    3 if(v(i+1)-v(j+1)) 1,1,2
    1 continue
   15 continue
   10 continue
      if(iprt.eq.1) then
	write(ncwu,'(a,i5)') ' $$idim',idim
	write(ncwu,78) (v(i),i=1,idim)
       endif
c-----------------------------------------------------------
c-- inizio fusione
      j=2
   40 continue
      jf=idim-1
   45 continue
      if(j-jf) 50,50,65
   50 continue
      if(v(j).lt.v(j+1)) go to 60
      if(v(j).gt.v(j+2)) go to 61
      do 55 j1=j,idim
      v(j1)=v(j1+2)
   55 continue
      ifus=ifus+1
      idim=idim-2
      go to 40
   61 continue
      do 70 j1=j+1,idim
      v(j1)=v(j1+2)
   70 continue
      ifus=ifus+1
      idim=idim-2
      go to 40
   60 continue
      j=j+2
      go to 45
   65 continue
c-- fine fusione
      if((v(1).ne.0.).or.(v(idim).ne.twopi)) then
	v(idim+1)=v(1)
	idim=idim+1
      endif
   25 continue
      if(iprt.eq.1) then
	write(ncwu,'(a,i5)') ' $$$idim',idim
	write(ncwu,78) (v(i),i=1,idim)
       endif
      return
      end
c
code for arc
      subroutine arc(x1,y1,x2,y2,alfa1,alfa2)
      USE Trigonometria
c--inizio e fine del tratto oscurato in valore angolare
c  alfa1 = angolo iniziale
c  alfa2 = angolo finale
c
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension v(2),w(2)
c--
      zero=1.e-06
      prod3=x1*y2-x2*y1
      if(abs(prod3).le.zero.or.prod3.lt.0.0) then
      v(1)=x2
      v(2)=y2
      w(1)=x1
      w(2)=y1
      else
      v(1)=x1
      v(2)=y1
      w(1)=x2
      w(2)=y2
      endif
      if((abs(v(1)).lt.0.0001).and.(abs(v(2)).lt.0.0001)) go to 208
      if((abs(w(1)).lt.0.0001).and.(abs(w(2)).lt.0.0001)) go to 208
      alfa1=atan2(w(2),w(1))
      alfa2=atan2(v(2),v(1))
      if(alfa1.lt.0) alfa1=alfa1+twopi
      if(alfa2.lt.0) alfa2=alfa2+twopi
      go to 209
  208 if(istat2.gt.0) write(ncwu,211)
  211 format(' attenzione forma indeterminata in arc1 ',
     * 'atan2(w(2),w(1)) o atan2(v(2),v(1))!!'/)
      alfa1=0.
      alfa2=0.
  209 continue
      return
      end
c
code for ellint
      subroutine ellint(va,vb,ea,eb,ndim,tet,im,
     *an,bn,cn,dn,en,fn,iwrt)
      USE Trigonometria
!     
      real*8 c1,c2,c3
c-----real*8 ea,eb
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension va(3),vb(3),teta(10),xv(10),yv(10),
     *ea(2,2),eb(2,2),tet(10)
c--
      zero=0.00001
      ndim=0
      do i=1,10
      teta(i)=0.
      enddo
c--1 ellisse
      a=ea(1,1)
      b=2.*ea(1,2)
      c=ea(2,2)
c--2 ellisse
      d=eb(1,1)
      e=2.*eb(1,2)
      f=eb(2,2)
c--distanza tra i due centri degli ellissi
      h=vb(1)-va(1)
      s=vb(2)-va(2)
      call dtrasf(d,e,f,h,s,an,bn,cn,dn,en,fn)
      g=d*h*h+e*h*s+f*s*s-1   ! spostamento dell'ellisse 2
      if(iwrt.eq.1) then
      write(ncwu,*)'h,s,fn,g',h,s,fn,g
      endif
      if((abs(h).lt.zero).and.(abs(s).lt.zero)) go to 400
c--soluzione del sistema (calcolo dei coeff. dell'eq. di 4 grado)
      a1=4*h*h*d*d+e*e*s*s+4*h*s*e*d
      b1=e*e*h*h+4*s*s*f*f+4*h*s*e*f
      c1=2*(2*h*h*e*d+4*h*s*d*f+e*e*h*s+2*e*s*s*f)
      a5=b1*c
      b5=b*b1+c*c1
      c5=a1*c+a*b1+b*c1
      d5=a*c1+a1*b
      e5=a*a1
      a2=2*c*f*g
      b2=2*c*e*g+2*b*f*g
      c2=2*c*g*d+2*b*e*g+2*a*f*g
      d2=2*b*g*d+2*a*e*g
      e2=2*a*g*d
      a3=f*f
      b3=2*e*f
      c3=e*e+2*d*f
      d3=2*e*d
      e3=d*d
      a4=c*c*g*g
      b4=2*b*c*g*g
      c4=b*b*g*g+2*a*c*g*g
      d4=2*a*b*g*g
      e4=a*a*g*g
      a5=b1*c
      b5=b*b1+c*c1
      c5=a1*c+a*b1+b*c1
      d5=a*c1+a1*b
      e5=a*a1
      a6=a5-a4-a3-a2
      b6=b5-b4-b3-b2
      c6=c5-c4-c3-c2
      d6=d5-d4-d3-d2
      e6=e5-e4-e3-e2
      if(iwrt.eq.1) then
      write(ncwu,*)'1) a6,b6,c6,d6,e6,im',
     1 a6,b6,c6,d6,e6,im
      endif
c--soluzione dell'eq. di 4 grado
      call solv4(a6,b6,c6,d6,e6,q1,q2,q3,q4,im)
      if(iwrt.eq.1) then
      write(ncwu,*)'2) a6,b6,c6,d6,e6,q1,q2,q3,q4,im',
     1 a6,b6,c6,d6,e6,q1,q2,q3,q4,im
      endif
      if(im.eq.4) return
      if(im.le.0) ndim=4
      if(im.gt.0) ndim=2
      cost1=sqrt(a+b*q1+c*q1*q1)
      cost2=sqrt(a+b*q2+c*q2*q2)
      x11=1/cost1
      x12=-1/cost1
      y11=q1*x11
      y12=q1*x12
      if(iwrt.eq.1) then
      write(ncwu,*)'3) cost1,x11,x12,y11,y12',
     1 cost1,x11,x12,y11,y12
      endif
      call sost(x11,x12,y11,y12,a,b,c,
     *an,bn,cn,dn,en,fn,x1,y1)
      x21=1/cost2
      x22=-1/cost2
      y21=q2*x21
      y22=q2*x22
      if(iwrt.eq.1) then
      write(ncwu,*)'4) cost2,x21,x22,y21,y22',
     1 cost2,x21,x22,y21,y22
      endif
      call sost(x21,x22,y21,y22,a,b,c,
     *an,bn,cn,dn,en,fn,x2,y2)
      xv(1)=x1
      xv(2)=x2
      yv(1)=y1
      yv(2)=y2
      if(im.eq.1) go to 300
      cost3=sqrt(a+b*q3+c*q3*q3)
      cost4=sqrt(a+b*q4+c*q4*q4)
      x31=1/cost3
      x32=-1/cost3
      y31=q3*x31
      y32=q3*x32
      call sost(x31,x32,y31,y32,a,b,c,
     *an,bn,cn,dn,en,fn,x3,y3)
      x41=1/cost4
      x42=-1/cost4
      y41=q4*x41
      y42=q4*x42
      call sost(x41,x42,y41,y42,a,b,c,
     *an,bn,cn,dn,en,fn,x4,y4)
      xv(3)=x3
      xv(4)=x4
      yv(3)=y3
      yv(4)=y4
      if(im.eq.1) go to 300
      go to 410
  400 continue
      c1=c*g+f
      c2=e+b*g
      c3=d+a*g
      call solv2(c1,c2,c3,q1,q2,isolx,iwrt)
      acost1=a+b*q1+c*q1*q1
      if(acost1.gt.0.0) then
      cost1=sqrt(acost1)
      xv(1)=1/cost1
      xv(2)=-1/cost1
      else
      xv(1)=0.0
      xv(2)=0.0
      endif
      acost2=a+b*q2+c*q2*q2
      if(acost2.gt.0.0) then
      cost2=sqrt(acost2)
      xv(3)=1/cost2
      xv(4)=-1/cost2
      else
      xv(3)=0.0
      xv(4)=0.0
      endif
      yv(1)=q1*xv(1)
      yv(2)=q1*xv(2)
      yv(3)=q2*xv(3)
      yv(4)=q2*xv(4)
  410 continue
      ndim=4
      do 207 i=1,ndim
      if((abs(yv(i)).lt.0.0001).and.(abs(xv(i)).lt.0.0001))go to 209
      teta(i)=atan2(yv(i),xv(i))
      if(teta(i).lt.0) teta(i)=teta(i)+twopi
      go to 208
  209 continue
      if(istat2.gt.0) write(ncwu,211)
  211 format(' attenzione forma indeterminata in ellint ',
     * 'atan2(yv(i),xv(i))!!',/)
      teta(i)=0.
  208 continue
  207 continue
      call ordn(teta,xv,yv,ndim)
      call osc(teta,xv,yv,ndim,a,b,c,d,e,f,jf,jl)
      if(jf.eq.1) go to 95
      if(jf.eq.2) go to 96
      go to 710
   95 tet(1)=teta(2)
      tet(2)=teta(3)
      tet(3)=teta(4)
      tet(4)=teta(1)
      go to 700
   96 tet(1)=teta(1)
      tet(2)=teta(2)
      tet(3)=teta(3)
      tet(4)=teta(4)
      go to 700
  300 continue
      u1=h
      u2=s
      if(iwrt.eq.1) then
      write(ncwu,*)'5) x1,y1,x2,y2,u1,u2',
     1 x1,y1,x2,y2,u1,u2
      endif
      call arc1(x1,y1,x2,y2,u1,u2,teta1,teta2)
      tet(1)=teta2
      tet(2)=teta1
      ndim=2
      go to 710
  700 continue
  710 continue
      return
      end
c
code for ordn
      subroutine ordn(teta,xv,yv,ndim)
c--ordina i vettori teta xv yv
c--teta: vettore contenente gli angoli calcolati
c--xv:vettore contente le ascisse dei punti
c--yv:vettore contenente le oridnate dei punti
c--ndim: dimensione del vettore teta ordinato
      dimension teta(10),xv(10),yv(10)
c--
      do 10 i=1,ndim-1
      do 15 j=i+1,ndim
      if(teta(i)-teta(j)) 1,1,2
    2 continue
      com1=teta(i)
      teta(i)=teta(j)
      teta(j)=com1
      com2=xv(i)
      xv(i)=xv(j)
      xv(j)=com2
      com3=yv(i)
      yv(i)=yv(j)
      yv(j)=com3
    1 continue
   15 continue
   10 continue
c     teta(ndim+1)=teta(1)
c     ndim=ndim+1
      return
      end
c
code for intpr
      subroutine intpr(ell,egv,xa,xb,intp,vint,intex,iwrt)
c--controlla intersezione ellisse-retta
c  intp = 1 interruzione del legame
c	  0 interruzione dell'ellisse
c  intex = 1 nessuna intersezione
c	   0 abbiamo intersezione
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension ell(2,2),xa(3),xb(3),vint(3),egv(3)
c--
      zero=1.e-07
      intex=0
      intp=0
      a1=ell(1,1)
      a2=2.*ell(1,2)
      a3=ell(2,2)
c--calcola intersezione ellisse-retta
      call ebint(a1,a2,a3,xa,xb,t1,t2,isolx,iwrt)
      if(iwrt.eq.1)  write(ncwu,*) '1) t1,t2,isolx:',t1,t2,isolx
      if(isolx.eq.0) goto 100
      if(abs(t1).lt.zero) t1=0.0
      if(abs(t2).lt.zero) t2=0.0
      if(isolx.eq.2) then
      if(abs(t1-t2).le.0.001) then
      t3=(t1+t2)/2.0
      t1=t3
      t2=t3
      isolx=1
      endif
      endif
      if(iwrt.eq.1)  write(ncwu,*) '2) t1,t2,isolx:',t1,t2,isolx
c
c      if((t1.le.0.).and.(t2.le.0.)) goto 100
c      if((t1.ge.1.).and.(t2.ge.1.)) goto 100
c      if((t1.le.0.).and.(t2.ge.1.)) goto 100
c      if((t1.ge.1.).and.(t2.le.0.)) goto 100
c
      if((t1.ge.0).and.(t1.le.1))  then	     ! go to 10
c      if((t2.gt.0).and.(t2.lt.1)) go to 20
c   10 continue
      intp=1
      vint(1)=xa(1)+t1*(xb(1)-xa(1))
      vint(2)=xa(2)+t1*(xb(2)-xa(2))
      vint(3)=xa(3)+t1*(xb(3)-xa(3))
      if(iwrt.eq.1) then
	write(ncwu,*) 'egv ',egv
	write(ncwu,*) 'vint',vint
      endif
c--calcola il valore di z dell'ellisse in quel punto
      z=-(egv(1)*vint(1)+egv(2)*vint(2))/egv(3)
      if(iwrt.eq.1) write(ncwu,'(a,4f10.3)')' 1)vint,z:',vint,z
c--controllo quota ellisse con quota della retta
      if(z-vint(3).ge.0.0) intp=0
      return
      endif
c      go to 30
      if((t2.ge.0).and.(t2.le.1)) then	      ! go to 20
c   20 continue
      intp=1
      vint(1)=xa(1)+t2*(xb(1)-xa(1))
      vint(2)=xa(2)+t2*(xb(2)-xa(2))
      vint(3)=xa(3)+t2*(xb(3)-xa(3))
c   30 continue
c	write(ncwu,*) 'egv ',egv
c	write(ncwu,*) 'vint',vint
c--calcola il valore di z dell'ellisse in quel punto
      z=-(egv(1)*vint(1)+egv(2)*vint(2))/egv(3)
      if(iwrt.eq.1) write(ncwu,'(a,4f10.3)')' 2)vint,z:',vint,z
c--controllo quota ellisse con quota della retta
      if(z-vint(3).ge.0.0) intp=0
      return
      endif
  100 continue
      intex=1
      return
      end
c
code for ebint
      subroutine ebint(a,b,c,va,vb,t1,t2,isolx,iwrt)
c--intersezioni ellisse retta
c  abbiamo intersezione del segmento della retta (bond) delimitato
c  da va()--vb() se i parametri t1 e t2 sono compresi tra 0 e 1
c
      real*8 cc1,cc2,cc3
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension va(3),vb(3)
c--
      t1=-10000
      t2=-10000
      dx=vb(1)-va(1)
      dy=vb(2)-va(2)
      cc1=a*dx*dx+b*dx*dy+c*dy*dy
      cc2=2*a*va(1)*dx+b*va(2)*dx+b*va(1)*dy+2*c*va(2)*dy
      cc3=a*va(1)*va(1)+b*va(1)*va(2)+c*va(2)*va(2)-1.
      if(iwrt.eq.1) write(ncwu,'(a,3d20.8)')' cc:',cc1,cc2,cc3
      if((cc1.eq.0.).or.(cc3.eq.0.)) go to 79
      call solv2(cc1,cc2,cc3,t1,t2,isolx,iwrt)
      if(isolx.eq.2) then
      endif
c--	write(ncwu,'(a,2e15.5)')' tt:',t1,t2
   79 continue
      return
      end
c
code for dtrasf
      subroutine dtrasf(d,e,f,h,s,an,bn,cn,dn,en,fn)
c--
      an=d
      bn=e
      cn=f
      dn=-2.*h*d-e*s
      en=-2.*s*f-e*h
      fn=d*h*h+e*h*s+f*s*s-1.
      return
      end
c
code for sost
      subroutine sost(x11,x12,y11,y12,a,b,c,
     *an,bn,cn,dn,en,fn,x1,y1)
c--
      el1=a*x11*x11+b*x11*y11+c*y11*y11-1.
      el2=an*x11*x11+cn*y11*y11+bn*x11*y11
     *+dn*x11+en*y11+fn
      el3=a*x12*x12+b*x12*y12+c*y12*y12-1.
      el4=an*x12*x12+cn*y12*y12+bn*x12*y12
     *+dn*x12+en*y12+fn
      if(abs(el2)-abs(el4)) 1,1,2
    1 x1=x11
      y1=y11
      return
    2 x1=x12
      y1=y12
      return
      end
c
code for osc
      subroutine osc(teta,xv,yv,ndim,a,b,c,d,e,f,jf,jl)
c- decide gli archi di ellisse da disegnare
c--jf=1=> si disegna a partire da teta(1)
c--jf=2=> si disegna a partire da teta(2)
      dimension teta(10),xv(10),yv(10),u(3),v(3),w(3)
c--
      x1=xv(1)
      y1=yv(1)
      x2=xv(2)
      y2=yv(2)
      xm=(x1+x2)/2
      ym=(y1+y2)/2
      if(xm) 1,2,1
    2 xf=0.
      xl=0.
      go to 10
    1 if(ym) 3,4,3
    4 yl=0.
      yf=0.
      go to 11
    3 q=ym/xm
      xf=-sqrt(1/(d+e*q+f*q*q))
      xl=sqrt(1/(d+e*q+f*q*q))
      yf=q*xf
      yl=q*xl
      go to 20
   10 yf=-1/sqrt(f)
      yl=1/sqrt(f)
      go to 20
   11 xl=-1/sqrt(d)
      yl=1/sqrt(d)
   20 continue
      prodvw=x1*y2-y1*x2
      if(prodvw) 31,31,32
   31 v(1)=x2
      v(2)=y2
      w(1)=x1
      w(2)=y1
      go to 33
   32 v(1)=x1
      v(2)=y1
      w(1)=x2
      w(2)=y2
   33 continue
      prodvu=v(1)*yf-v(2)*xf
      if(prodvu) 21,21,12
   21 x=xl
      y=yl
      go to 30
   12 x=xf
      y=yf
   30 continue
      eqell=a*x*x+b*x*y+c*y*y-1
      if(eqell) 40,40,50
   40 jf=1
      jl=ndim-2
      return
   50 jf=2
      jl=ndim-1
      return
      end
c
code for sae4
      subroutine sae4(idr,ibnd)
c--primo ellisse principale
c-----real*8 ec,ex,ecb
c
      USE General
      USE Atomi
      USE Plotter
      USE Molcom
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      dimension abond(4,60),bbond(4,60),ec(2,2),ex(2,2),
     *va(3),vb(3),vx(5000),a(3),ve(100),ecb(2,2),bm1(3,3),
     *tetx(10),tet(10),p0(3),pa(3),v(100),ta(3),tb(3),
     *a1(3),a2(3),a3(3),a4(3)
c--
      nn5=nFloc
      nind=nFloc
      jind=nn5
      do kj=1,natsPlo
         j= AdrPloto5(kj)
!--controllo se ANISO e' richiesto
         if(SinglePlotType(j).eq.ELLIPSOIDS)then
            nell=0
            jrt=0
            inter=0
!--estraggo i valori relativi all'ellissoide            
            ex(1,1)=ParamEllabc(1,1,kj)        ! ParamEllabc(1,1,kj)
            ex(1,2)=ParamEllabc(2,1,kj)/2.
            ex(2,1)=ex(1,2)
            ex(2,2)=ParamEllabc(3,1,kj)
            a1x=ParamEllabc(4,1,kj)
            a2x=ParamEllabc(5,1,kj)
            fix=ParamEllabc(6,1,kj)
            fix1=ParamEllabc(7,1,kj)
            fix2=ParamEllabc(8,1,kj)
!            
            a(1)=ParamEll(5,kj)                  ! ParamEll(5,kj)
            a(2)=ParamEll(6,kj)
            a(3)=ParamEll(7,kj)
!            
            a1c=ParamEll(17,kj)                  ! ParamEll(17,kj)   
            a2c=ParamEll(18,kj)
c--fine estrazione            
            vx(:)=0.
            if(ex(1,1).eq.0.0) then
               jrt=1
            endif
            ix=1
            va(1:3)=xyzsPlo(1:3,kj)
            if(jrt.ne.1) then
               vx(ix  )=fix2
               vx(ix+1)=fix1
               ix=ix+2
            endif
            if(ibnd.eq.-1) go to 921
            do j=1,nbon
               call BondStor(j,ia,ib,abond,bbond) 
               int=0
               if(ia.eq.0) cycle
               if(jrt.eq.1) go to 400
               iwrt=0
               call eprbn(idr,ex,a,va,abond,bbond,jdim,int,x1,y1,
     *                    x2,y2,iwrt)
               if(int.ne.0) then
                  call arc(x1,y1,x2,y2,alfa1,alfa2)
                  vx(ix)=alfa2
                  vx(ix+1)=alfa1
                  ix=ix+2
               endif
               iwrt=0
               call eprbn2(ex,a,va,abond,bbond,jdim,ve,ndim,nell,iwrt)
               if(nell.gt.0) jrt=-10
               if(ndim.eq.0) cycle
               do i1=1,ndim
	            vx(ix+i1-1)=ve(i1)
               enddo
               ix=ix+ndim
               cycle
  400          continue
               p0(1)=ex(1,1)-va(1)
               p0(2)=ex(2,2)-va(2)
               p0(3)=0.
               pa(1)=a1x-va(1)
               pa(2)=a2x-va(2)
               pa(3)=0.
c-------------------------
               do j1=1,jdim
                  do i1=1,3
                     abond(i1,j1)=ABaseBond(i1,j1,j)-va(i1)
                     bbond(i1,j1)=BBaseBond(i1,j1,j)-va(i1)
                     if(j1.eq.1) then  
                        a1(i1)=abond(i1,j1)
                        a2(i1)=bbond(i1,j1)
                     endif
                     if(j1.eq.jdim) then  
                        a3(i1)=abond(i1,j1)
                        a4(i1)=bbond(i1,j1)
                     endif
                  enddo
               enddo
               do i1=1,3
                  ta(i1)=(a2(i1)-a1(i1))*0.15
                  tb(i1)=(a4(i1)-a3(i1))*0.15
               enddo
               do i1=1,3
                  a1(i1)=a1(i1)-ta(i1)
                  a2(i1)=a2(i1)+ta(i1)
                  a3(i1)=a3(i1)-tb(i1)
                  a4(i1)=a4(i1)+tb(i1)
               enddo
               call qdrl(a1,a2,a3,a4,p0,pa,t1,t2,nn)
               if(nn.gt.0) then
                  call axbond(abond,bbond,p0,pa,jdim,ndim,v)
                  if(ndim.gt.0) then
	               inter=inter+1
	               do i1=1,ndim
	                  vx(ix+i1-1)=v(i1)
                     enddo
	               ix=ix+ndim
                  endif
               endif
            enddo
c------------------------------------
  921       continue
            Finter(jind  )=kj
            Finter(jind+1)=jrt
            nFloc=nFloc+3
            if((jrt.eq.1).and.(inter.le.0)) then
                Finter(jind+2)=0.
            else
                do ij=1,ix
	             Finter(jind+2+ij)=vx(ij)
	             nFloc=nFloc+1
                enddo
                Finter(jind+2)=ix-1
            endif
            jindc=jind+3+ix-1
            if(istat2.gt.1) then
               l=jindc-jind
	         write(ncwu,331) aLabPlo(kj),l
  331          format('atom : ', a8,i5)
               write(ncwu,600) (Finter(j),j=jind,jindc-1)
  600          format(8f10.5)
            endif
            jind=jindc
         endif
      enddo
      nn6=nFloc-1
      return
      end
c
code for sae41
      subroutine sae41(idr)
c-----real*8 ec,ex,ecb
c
      USE General
      USE Atomi
      USE Plotter
      USE Molcom, only : SinglePlotType
      USE Dialogo
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c	
      dimension abond(4,60),bbond(4,60),ec(2,2),ex(2,2),
     *va(3),vb(3),vx(5000),a(3),ve(100),ecb(2,2),bm1(3,3),
     *tetx(10),tet(10),p0(3),pa(3),v(100)
c--
      zero=0.00001
      nn7=nFloc
      mind=nFloc
      iind=nn7
      do kj=1,natsPlo
         j= AdrPloto5(kj)
c--controllo se ANISO e' richiesto
         if(SinglePlotType(j).eq.ELLIPSOIDS)then
            jrt=0
            ix=1
            nax=0
c--estraggo valori dell'ellissoide            
            ex(1,1)=ParamEllabc(1,1,kj)        ! ParamEllabc(1,1,kj)
            ex(1,2)=ParamEllabc(2,1,kj)/2.
            ex(2,1)=ex(1,2)
            ex(2,2)=ParamEllabc(3,1,kj)
            a1x=ParamEllabc(4,1,kj)
            a2x=ParamEllabc(5,1,kj)
            fix=ParamEllabc(6,1,kj)
            fix1=ParamEllabc(7,1,kj)
            fix2=ParamEllabc(8,1,kj)
!            
            a(1)=ParamEll(5,kj)               ! ParamEll(5,kj)
            a(2)=ParamEll(6,kj)
            a(3)=ParamEll(7,kj)
!            
            a1c=ParamEll(17,kj)
            a2c=ParamEll(18,kj)
c--fine estrazione            
            vx(:)=0.
            if(ex(1,1).eq.0) jrt=1
            va(1:3)=xyzsPlo(1:3,kj)
c---- intersezioni ellisse--ellisse
            do ij=1,natsPlo
               if(ij.ne.kj) then
c--controllo se ANISO e' richiesto   (?? not used)
c--	if(kshuttle(m25s+54).eq.8) then
                  vb(1:3)=xyzsPlo(1:3,ij)
!--(controllo che i centri non siano esattamente coincidenti)
                  hhh=vb(1)-va(1)
                  sss=vb(2)-va(2)
                  if((abs(hhh).lt.zero).and.(abs(sss).lt.zero)) cycle
                  call bstor(fbiso,bm1,ij)
c--estraggo valori dell'ellissoide                  
                  a1cb=ParamEll(17,ij)     ! ParamEll(17,kj)
                  a2cb=ParamEll(18,ij)
                  ecb(1,1)=ParamEll(14,ij)
                  ecb(1,2)=ParamEll(15,ij)/2.
                  ecb(2,1)=ecb(1,2)
                  ecb(2,2)=ParamEll(16,ij)
c--fine estrazione                  
                  call lngtp(va,vb,dist)
                  ax1=amax1(a1c,a2c)
                  ax2=amax1(a1cb,a2cb)
                  axm=ax1+ax2
                  if(dist.gt.axm) go to 700
                  if(va(3).lt.vb(3)) then ! 701,700,700
c-- se l'ellisse contorno e' oscurata potrebbero
c-- essere oscurate anche le ellissi principali
                     if(jrt.eq.1) go to 800
                     iwrt=0
                     call ellint(va,vb,ex,ecb,ndimx,tetx,im,
     *                          an,bn,cn,dn,en,fn,iwrt)
                     if(im.eq.4) ndimx=0
                     if(im.eq.4) go to 91
                     go to 92
   91                ellb=fn
                     if((ellb.lt.0.).and.(va(3).lt.vb(3))) jrt=-10
   92                continue
                     if(ndimx.eq.0) go to 700
                     do j1=1,ndimx
                        vx(ix-1+j1)=tetx(j1)
                     enddo
                     ix=ix+ndimx
                     go to 700
  800                continue
                     p0(1)=ex(1,2)+va(1)
                     p0(2)=ex(2,2)+va(2)
                     p0(3)=va(3)
                     pa(1)=a1x+va(1)
                     pa(2)=a2x+va(2)
                     pa(3)=va(3)
c------------------------------------------
                     nax=0
                     call axl(vb,p0,pa,ecb,nax,ndim1,tet)
                     if(ndim1.eq.0) go to 700
                     do i1=1,ndim1
                        vx(ix+i1)=tet(i1)
                     enddo
                     ix=ix+ndim1
                  endif
!-------------------------------------------------      
  700             continue
                  if(nax.gt.0) jrt=-10
               endif
            enddo
            Finter(iind)=kj
            Finter(iind+1)=jrt
            Finter(iind+2)=ix-1
            nFloc=nFloc+3
            if(ix.gt.1) then
               do ij=1,ix
                  Finter(iind+2+ij)=vx(ij)
                  nFloc=nFloc+1
               enddo
            endif
            iindc=iind+2+ix
            if(istat2.gt.1) then
               l=iindc-iind
               write(ncwu,331) aLabPlo(kj),l
  331          format('atom : ', a8,i5)
               write(ncwu,332) (Finter(j),j=iind,iindc-1)
  332          format(8f10.5)
            endif
            iind=iindc
         endif
      enddo
      nn8=nFloc-1
      return
      end
c
code for sae42
      subroutine sae42(idr,jdise)
c--disegna il primo ellisse principale
c-----real*8 ec,ex,ey,ez
c
      USE General
      USE Atomi
      USE Plotter
      USE Molcom, only : SinglePlotType
      USE Dialogo
!
      character*80 ifilin
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c	
      dimension abond(4,60),bbond(4,60),
     *ec(2,2),ex(2,2),ey(2,2),ez(2,2),va(3),vb(3),
     *vx(5000),v(5000),a(3),b(3),c(3),p1(3),p2(3),s1(3),s2(3)
c--
      if (jdise.eq.1) then
          call scrper('Filling ellipsoids on file',0,0)
      else
          call scrper('Filling ellipsoids on screen',0,0)
      endif
      if(istat2.gt.1) then
         write(ncwu,*)'============================================'
         write(ncwu,'(a)')'disegna il primo ellisse principale'   
      endif
!
      do kj=1,natsPlo
         j= AdrPloto5(kj)
c--controllo se ANISO e' richiesto
         if(SinglePlotType(j).eq.ELLIPSOIDS)then
            if(istat2.gt.1) then
               write(ncwu,332) aLabPlo(kj)
  332          format('atom : ', a8)
            endif
            call elstor(kj,axa,axb,axc,a,b,c,ec,a1c,a2c,fic,idr,
     *                 ex,a1x,a2x,fix,fix1,fix2,
     *                 ey,a1y,a2y,fiy,fiy1,fiy2,
     *                 ez,a1z,a2z,fiz,fiz1,fiz2)
            vx(:)=0.
            ksp = nzTot(j)
            if(no(ksp).eq.1) cycle
            va(1:3)=xyzsPlo(1:3,kj)
            kkk=jSingleColor(j)
            write(ifilin,331)aLabPlo(kj),kkk
  331       format('atom : ', a8,i5)
            call plwrit(ifilin)
            call cpen(kkk)
            j=nn5
  200       continue
            if(j.ge.nn6) cycle
            k=Finter(j)
            ix=Finter(j+2)
            jrt1=Finter(j+1)
            if(jrt1.eq.-10) cycle
            if(k.eq.kj) go to 210
            j=j+3+ix
            go to 200
  210       continue
            if((jrt1.eq.1).and.(ix.eq.0)) go to 921
            do ij=1,ix
               vx(ij)=Finter(j+2+ij)
            enddo
  921       continue
            j1=nn7
  201       continue
            if(j1.ge.nn8) go to 222
            k1=Finter(j1)
            jrt=Finter(j1+1)
            ix1=Finter(j1+2)
            if(k1.eq.kj) go to 211
            j1=j1+3+ix1
            go to 201
  211       continue
            if(ix1.eq.0) go to 222
            do ij=1,ix1
               vx(ix+ij)=Finter(j1+2+ij)
            enddo
  222       continue
            if(jrt.eq.-10) cycle
            idim=ix+ix1+1
            if(jrt) 230,230,240
  230       continue
            if(istat2.gt.1) then
               write(ncwu,31) (vx(i2),i2=1,idim)
   31          format(1x,'vx=',10f10.5)
            endif
            call ordarc(vx,idim,ifus)
            if(istat2.gt.1) then
               write(ncwu,31) (vx(i2),i2=1,idim)
            endif
            xo=va(1)
            yo=va(2)
            call plpoa(xo,yo)
            do ij=2,idim-1,2
               teta1=vx(ij)
               teta2=vx(ij+1)
               call elpr(xo,yo,a1x,a2x,fix,teta1,teta2)
            enddo
            go to 830
  240       continue
            p1(1)=ex(1,2)+va(1)
            p1(2)=ex(2,2)+va(2)
            p1(3)=va(3)
            p2(1)=a1x+va(1)
            p2(2)=a2x+va(2)
            p2(3)=va(3)
            idim=idim-1
            if(idim) 321,321,322
  321       continue
            call plosg(p1,p2,0)
            go to 830
  322       continue
            v(1)=0.
            v(2)=0.
           do ij=3,idim+2
              v(ij)=vx(ij-2)
           enddo
           v(idim+3)=1.
           v(idim+4)=1.
           idimx=idim+4
           call ordvet(idim,idimx,v,jfus)
           ndim=idimx-2*jfus
           do j3=2,ndim,2
              s1(1)=p1(1)+(p2(1)-p1(1))*v(j3)
              s1(2)=p1(2)+(p2(2)-p1(2))*v(j3)
              s1(3)=p1(3)+(p2(3)-p1(3))*v(j3)
              s2(1)=p1(1)+(p2(1)-p1(1))*v(j3+1)
              s2(2)=p1(2)+(p2(2)-p1(2))*v(j3+1)
              s2(3)=p1(3)+(p2(3)-p1(3))*v(j3+1)
              call plosg(s1,s2,0)
           enddo
  830      continue
           call plpup
         endif
      enddo
      nFloc=nind
!
      call scrper(' ',0,-1)
!
      return
      end
c
code for sae5
      subroutine sae5(idr,ibnd)
c-----real*8 ec,ey,ecb
c
      USE General
      USE Atomi
      USE Plotter
      USE Molcom, only : SinglePlotType
      USE Dialogo
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension abond(4,60),bbond(4,60),ec(2,2),ey(2,2),
     *va(3),vb(3),vy(5000),b(3),ve(100),ecb(2,2),bm1(3,3),
     *tety(10),tet(10),p0(3),pb(3),v(100),ta(3),tb(3),
     *a1(3),a2(3),a3(3),a4(3)
c--
      nn5=nFloc
      nind=nFloc
      jind=nn5
      do kj=1,natsPlo
         j= AdrPloto5(kj)
c--controllo se ANISO e' richiesto
         if(SinglePlotType(j).eq.ELLIPSOIDS)then
            nell=0
            jrt=0
            inter=0
c--estraggo valori dell'ellissoide            
            ey(1,1)=ParamEllabc(1,2,kj)      ! ParamEllabc(1,2,kj)
            ey(1,2)=ParamEllabc(2,2,kj)/2.
            ey(2,1)=ey(1,2)
            ey(2,2)=ParamEllabc(3,2,kj)
            a1y=ParamEllabc(4,2,kj)
            a2y=ParamEllabc(5,2,kj)
            fiy=ParamEllabc(6,2,kj)
            fiy1=ParamEllabc(7,2,kj)
            fiy2=ParamEllabc(8,2,kj)
!            
            b(1)=ParamEll(8,kj)              ! ParamEll(8,kj)
            b(2)=ParamEll(9,kj)
            b(3)=ParamEll(10,kj)
!            
            a1c=ParamEll(17,kj)
            a2c=ParamEll(18,kj)
c--fine estrazione            
            vy(:)=0.
            if(ey(1,1).eq.0) jrt=1
            iy=1
            va(1:3)=xyzsPlo(1:3,kj)
            if(jrt.eq.0) then !go to 40
                vy(iy)=fiy2
                vy(iy+1)=fiy1
                iy=iy+2
            endif
c   40 continue
            if(ibnd.eq.-1) go to 921
            do j=1,nbon
               call BondStor(j,ia,ib,abond,bbond) 
               int=0
               if(ia.eq.0) goto 258
               if(jrt.eq.1) go to 400
               iwrt=0
               call eprbn(idr,ey,b,va,abond,bbond,jdim,int,x1,y1,
     *                     x2,y2,iwrt)
               if(int.ne.0) then 
                  call arc(x1,y1,x2,y2,alfa1,alfa2)
                  vy(iy)=alfa2
                  vy(iy+1)=alfa1
                  iy=iy+2
               endif
               iwrt=0
               call eprbn2(ey,b,va,abond,bbond,jdim,ve,ndim,nell,iwrt)
               if(nell.gt.0) jrt=-10
               if(ndim.eq.0) go to 258
               do i1=1,ndim
                  vy(iy+i1-1)=ve(i1)
               enddo
               iy=iy+ndim
               go to 258
  400          continue
               p0(1)=ey(1,2)-va(1)
               p0(2)=ey(2,2)-va(2)
               p0(3)=0.
               pb(1)=a1y-va(1)
               pb(2)=a2y-va(2)
               pb(3)=0.
c-------------------
               do j1=1,jdim
                  do i1=1,3
                     abond(i1,j1)=ABaseBond(i1,j1,j)-va(i1)
                     bbond(i1,j1)=BBaseBond(i1,j1,j)-va(i1)
                     if(j1.eq.1) then  
                        a1(i1)=abond(i1,j1)
                        a2(i1)=bbond(i1,j1)
                     endif
                     if(j1.eq.jdim) then  
                        a3(i1)=abond(i1,j1)
                        a4(i1)=bbond(i1,j1)
                     endif
                  enddo
               enddo
               do i1=1,3
                  ta(i1)=(a2(i1)-a1(i1))*0.15
                  tb(i1)=(a4(i1)-a3(i1))*0.15
               enddo
               do i1=1,3
                  a1(i1)=a1(i1)-ta(i1)
                  a2(i1)=a2(i1)+ta(i1)
                  a3(i1)=a3(i1)-tb(i1)
                  a4(i1)=a4(i1)+tb(i1)
               enddo
               call qdrl(a1,a2,a3,a4,p0,pb,t1,t2,nn)
               if(nn) 258,258,259
  259          call axbond(abond,bbond,p0,pb,jdim,ndim,v)
               if(ndim) 258,258,260
  260          continue
               inter=inter+1
c-----------------------------------
               do i1=1,ndim
                  vy(iy+i1-1)=v(i1)
               enddo
               iy=iy+ndim
  258          continue
            enddo
  921       continue
            Finter(jind)=kj
            Finter(jind+1)=jrt
            nFloc=nFloc+3
            if((jrt.eq.1).and.(inter.le.0)) go to 20
            do ij=1,iy
               Finter(jind+2+ij)=vy(ij)
               nFloc=nFloc+1
            enddo
            go to 820
   20       continue
            Finter(jind+2)=0.
            go to 810
  820       continue
            Finter(jind+2)=iy-1
  810       continue
            jind=jind+3+iy-1
         endif
      enddo
      nn6=nFloc-1
      if(istat2.gt.1) then
       write(ncwu,600) (Finter(nn5+i-1),i=1,nn6-nn5+1)
  600  format(12f10.5)
      endif
      return
      end
c
code for sae51
      subroutine sae51(idr)
c-----real*8 ec,ey,ecb
c
      USE General
      USE Atomi
      USE Plotter
      USE Molcom, only : SinglePlotType
      USE Dialogo
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension abond(4,60),bbond(4,60),ec(2,2),ey(2,2),
     *va(3),vb(3),vy(5000),b(3),ve(100),ecb(2,2),bm1(3,3),
     *tety(10),tet(10),p0(3),pb(3),v(100)
c--
      zero=0.00001
      nn7=nFloc
      mind=nFloc
      iind=nn7
      do kj=1,natsPlo
         j= AdrPloto5(kj)
c--controllo se ANISO e' richiesto
         if(SinglePlotType(j).eq.ELLIPSOIDS)then
            jrt=0
            nax=0
            iy=1
c--estrazione valori dell'ellissoide            
            ey(1,1)=ParamEllabc(1,2,kj)      ! ParamEllabc(1,2,kj)
            ey(1,2)=ParamEllabc(2,2,kj)/2.
            ey(2,1)=ey(1,2)
            ey(2,2)=ParamEllabc(3,2,kj)
            a1y=ParamEllabc(4,2,kj)
            a2y=ParamEllabc(5,2,kj)
            fiy=ParamEllabc(6,2,kj)
            fiy1=ParamEllabc(7,2,kj)
            fiy2=ParamEllabc(8,2,kj)
!            
            b(1)=ParamEll(8,kj)              ! ParamEll(8,kj)
            b(2)=ParamEll(9,kj)
            b(3)=ParamEll(10,kj)
!            
            a1c=ParamEll(17,kj)
            a2c=ParamEll(18,kj)
c--fine estrazione            
            vy(:)=0.
            if(ey(1,1).eq.0.0) jrt=1
            va(1:3)=xyzsPlo(1:3,kj)
c---- intersezioni ellisse--ellisse
            do ij=1,natsPlo
               if(ij.ne.kj) then
c--controllo se ANISO e' richiesto
c---	if(kshuttle(m25s+54).eq.8) then      (?? not used)
                  vb(1:3)=xyzsPlo(1:3,ij)
!--(controllo che i centri non siano esattamente coincidenti)
                  hhh=vb(1)-va(1)
                  sss=vb(2)-va(2)
                  if((abs(hhh).lt.zero).and.(abs(sss).lt.zero)) cycle
                  call bstor(fbiso,bm1,ij)
c--estrazione valori dell'ellissoide
                  a1cb=ParamEll(17,ij)
                  a2cb=ParamEll(18,ij)
!
                  ecb(1,1)=ParamEll(14,ij)
                  ecb(1,2)=ParamEll(15,ij)/2.
                  ecb(2,1)=ecb(1,2)
                  ecb(2,2)=ParamEll(16,ij)
c--fine estrazione                  
                  call lngtp(va,vb,dist)
                  axm1=amax1(a1c,a2c)
                  axm2=amax1(a1cb,a2cb)
                  axm=axm1+axm2
                  if(dist.gt.axm) go to 700
                  if(va(3).ge.vb(3)) goto 700  
c-- se l'ellisse contorno e' oscurata potrebbero
c-- essere oscurate anche le ellissi principali
                  if(jrt.eq.1) go to 800
                  iwrt=0
                  call ellint(va,vb,ey,ecb,ndimy,tety,im,
     *                        an,bn,cn,dn,en,fn,iwrt)
                  if(im.eq.4) ndimy=0
                  if(im.eq.4) go to 91
                  go to 92
   91             ellb=fn
                  if((ellb.lt.0.).and.(va(3).lt.vb(3))) jrt=-10
   92             continue
                  if(ndimy.eq.0) go to 700
                  do j1=1,ndimy
                     vy(iy-1+j1)=tety(j1)
                  enddo
                  iy=iy+ndimy
                  go to 700
  800             continue
                  p0(1)=ey(1,2)+va(1)
                  p0(2)=ey(2,2)+va(2)
                  p0(3)=va(3)
c--               pb(1)=a1x+va(1)
c--               pb(2)=a2x+va(2)
                  pb(1)=axm1+va(1)
                  pb(2)=axm2+va(2)
                  pb(3)=va(3)
c----------------------------
                  nax=0
                  call axl(vb,p0,pb,ecb,nax,ndim2,tet)
                  if(ndim2.eq.0) go to 700
                  do i1=1,ndim2
                     vy(iy+i1-1)=tet(i1)
                  enddo
                  iy=iy+ndim2
  700             continue
                  if(nax.gt.0) jtr=-10
                endif
c--	          endif
            enddo
            Finter(iind)=kj
            Finter(iind+1)=jrt
            Finter(iind+2)=iy-1
            nFloc=nFloc+3
            if((iy-1).eq.0) go to 36
            do ij=1,iy
               Finter(iind+2+ij)=vy(ij)
               nFloc=nFloc+1
           enddo
   36      continue
           iind=iind+2+iy
         endif
      enddo
      nn8=nFloc-1
      if(istat2.gt.1) then
         write(ncwu,200) (Finter(nn7+i-1),i=1,nn8-nn7+1)
  200    format(12f10.5)
      endif
      return
      end
c
code for sae52
      subroutine sae52(idr,jdise)
c--disegna secondo ellisse principale
c-----real*8 ec,ex,ey,ez
c
      USE General
      USE Atomi
      USE Plotter
      USE Molcom, only : SinglePlotType
      USE Dialogo
!
      character*80 ifilin
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      dimension abond(4,60),bbond(4,60),
     *ec(2,2),ex(2,2),ey(2,2),ez(2,2),va(3),vb(3),
     *vy(5000),v(5000),a(3),b(3),c(3),p1(3),p2(3),s1(3),s2(3)
c--
      if (jdise.eq.1) then
          call scrper('Filling ellipsoids on file',0,0)
      else
          call scrper('Filling ellipsoids on screen',0,0)
      endif
      if(istat2.gt.1) then
         write(ncwu,*)'============================================'
         write(ncwu,'(a)')'disegna il secondo ellisse principale'   
      endif
!
      do kj=1,natsPlo
         j= AdrPloto5(kj)
c--controllo se ANISO e' richiesto
         if(SinglePlotType(j).eq.ELLIPSOIDS)then
            call elstor(kj,axa,axb,axc,a,b,c,ec,a1c,a2c,fic,idr,
     *                  ex,a1x,a2x,fix,fix1,fix2,
     *                  ey,a1y,a2y,fiy,fiy1,fiy2,
     *                  ez,a1z,a2z,fiz,fiz1,fiz2)
            vy(:)=0.
            ksp = nzTot(j)
            if(no(ksp).eq.1) cycle
            va(1:3)=xyzsPlo(1:3,kj)
            kkk=jSingleColor(j)
            write(ifilin,331)aLabPlo(kj),kkk
  331       format('atom : ', a8,i5)
            call plwrit(ifilin)
            call cpen(kkk)
            j=nn5
  200       continue
            if(j.ge.nn6) go to 840
            k=Finter(j)
            iy=Finter(j+2)
            jrt1=Finter(j+1)
            if(jrt1.eq.-10) go to 840
            if(k.eq.kj) go to 210
            j=j+3+iy
            go to 200
  210       continue
            if((jrt1.eq.1).and.(iy.eq.0)) go to 921
            do ij=1,iy
               vy(ij)=Finter(j+2+ij)
            enddo
  921       continue
            j1=nn7
  201       continue
            if(j1.ge.nn8) go to 222
            k1=Finter(j1)
            jrt=Finter(j1+1)
            iy1=Finter(j1+2)
            if(k1.eq.kj) go to 211
            j1=j1+3+iy1
            go to 201
  211       continue
            if(iy1.eq.0) go to 222
            do ij=1,iy1
               vy(iy+ij)=Finter(j1+2+ij)
            enddo
  222       continue
            if(jrt.eq.-10) go to 840
            idim=iy+iy1+1
            if(jrt) 230,230,240
  230       continue
            if(istat2.gt.1) then
               write(ncwu,31) (vy(i2),i2=1,idim)
   31          format(1x,'vy=',10f10.5)
            endif
            call ordarc(vy,idim,ifus)
            if(istat2.gt.1) then
               write(ncwu,31) (vy(i2),i2=1,idim)
            endif
            xo=va(1)
            yo=va(2)
            call plpoa(xo,yo)
            do ij=2,idim-1,2
               teta1=vy(ij)
               teta2=vy(ij+1)
               call elpr(xo,yo,a1y,a2y,fiy,teta1,teta2)
            enddo
            go to 830
  240       continue
            p1(1)=ey(1,2)+va(1)
            p1(2)=ey(2,2)+va(2)
            p1(3)=va(3)
            p2(1)=a1y+va(1)
            p2(2)=a2y+va(2)
            p2(3)=va(3)
            idim=idim-1
            if(idim) 321,321,322
  321       continue
            call plosg(p1,p2,0)
            go to 830
  322       continue
            v(1)=0.
            v(2)=0.
            do ij=3,idim+2
               v(ij)=vy(ij-2)
            enddo
            v(idim+3)=1.
            v(idim+4)=1.
            idimy=idim+4
            call ordvet(idim,idimy,v,jfus)
            ndim=idimy-2*jfus
            do j3=2,ndim,2
               s1(1)=p1(1)+(p2(1)-p1(1))*v(j3)
               s1(2)=p1(2)+(p2(2)-p1(2))*v(j3)
               s1(3)=p1(3)+(p2(3)-p1(3))*v(j3)
               s2(1)=p1(1)+(p2(1)-p1(1))*v(j3+1)
               s2(2)=p1(2)+(p2(2)-p1(2))*v(j3+1)
               s2(3)=p1(3)+(p2(3)-p1(3))*v(j3+1)
               call plosg(s1,s2,0)
            enddo
  830       continue
            call plpup
  840       continue
         endif
      enddo
      nFloc=nind
!
      call scrper(' ',0,-1)
!
      return
      end
c
code for sae6
      subroutine sae6(idr,ibnd)
c-----real*8 ec,ez,ecb
c
      USE General
      USE Atomi
      USE Plotter
      USE Molcom, only : SinglePlotType
      USE Dialogo
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension abond(4,60),bbond(4,60),ec(2,2),ez(2,2),
     *va(3),vb(3),vz(5000),c(3),ve(100),ecb(2,2),bm1(3,3),
     *tetz(10),tet(10),p0(3),pc(3),v(100),ta(3),tb(3),
     *a1(3),a2(3),a3(3),a4(3)
c--
      nn5=nFloc
      nind=nFloc
      jind=nn5
      do kj=1,natsPlo
         j= AdrPloto5(kj)
c--controllo se ANISO e' richiesto
         if(SinglePlotType(j).eq.ELLIPSOIDS)then
            nell=0
            jrt=0
            inter=0
c--estrazione valori dell'ellissoide            
            ez(1,1)=ParamEllabc(1,3,kj)       ! ParamEllabc(1,3,kj)     
            ez(1,2)=ParamEllabc(2,3,kj)/2.
            ez(2,1)=ez(1,2)
            ez(2,2)=ParamEllabc(3,3,kj)
            a1z=ParamEllabc(4,3,kj)
            a2z=ParamEllabc(5,3,kj)
            fiz=ParamEllabc(6,3,kj)
            fiz1=ParamEllabc(7,3,kj)
            fiz2=ParamEllabc(8,3,kj)
!            
            c(1)=ParamEll(11,kj)              ! ParamEll(11,kj)
            c(2)=ParamEll(12,kj)
            c(3)=ParamEll(13,kj)
            
            a1c=ParamEll(17,kj)               ! ParamEll(17,kj)
            a2c=ParamEll(18,kj)
c--fine estrazione            
            vz(:)=0.
            if(ez(1,1).eq.0.0) jrt=1
            iz=1
            va(1:3)=xyzsPlo(1:3,kj)
            if(jrt.eq.0) then  
               vz(iz)=fiz2
               vz(iz+1)=fiz1
               iz=iz+2
            endif
            if(ibnd.eq.-1) go to 921
            do j=1,nbon
               call BondStor(j,ia,ib,abond,bbond) 
               int=0
               if(ia.eq.0) cycle
               if(jrt.eq.1) go to 400
               iwrt=0
               call eprbn(idr,ez,c,va,abond,bbond,jdim,int,x1,
     *                    y1,x2,y2,iwrt)
               if(int.eq.0) go to 410
               call arc(x1,y1,x2,y2,alfa1,alfa2)
               vz(iz)=alfa2
               vz(iz+1)=alfa1
               iz=iz+2
  410          continue
               iwrt=0
               call eprbn2(ez,c,va,abond,bbond,jdim,ve,ndim,nell,iwrt)
               if(nell.gt.0) jrt=-10
               if(ndim.eq.0) cycle
               do i1=1,ndim
                  vz(iz+i1-1)=ve(i1)
               enddo
               iz=iz+ndim
               cycle
  400          continue
               p0(1)=ez(1,2)-va(1)
               p0(2)=ez(2,2)-va(2)
               p0(3)=0.
               pc(1)=a1z-va(1)
               pc(2)=a2z-va(2)
               pc(3)=0.
c------------------------------------
               do j1=1,jdim
                  do i1=1,3
                     abond(i1,j1)=ABaseBond(i1,j1,j)-va(i1)
                     bbond(i1,j1)=BBaseBond(i1,j1,j)-va(i1)
                     if(j1.eq.1) then  
                        a1(i1)=abond(i1,j1)
                        a2(i1)=bbond(i1,j1)
                     endif
                     if(j1.eq.jdim) then  
                        a3(i1)=abond(i1,j1)
                        a4(i1)=bbond(i1,j1)
                     endif
                  enddo
               enddo
               do i1=1,3
                  ta(i1)=(a2(i1)-a1(i1))*0.15
                  tb(i1)=(a4(i1)-a3(i1))*0.15
               enddo
               do i1=1,3
                  a1(i1)=a1(i1)-ta(i1)
                  a2(i1)=a2(i1)+ta(i1)
                  a3(i1)=a3(i1)-tb(i1)
                  a4(i1)=a4(i1)+tb(i1)
               enddo
               call qdrl(a1,a2,a3,a4,p0,pc,t1,t2,nn)
               if(nn.le.0) cycle
  259          call axbond(abond,bbond,p0,pc,jdim,ndim,v)
               if(ndim.le.0) cycle
  260          continue
c------------------------------
               inter=inter+1
               do i1=1,ndim
                  vz(iz+i1-1)=v(i1)
               enddo
               iz=iz+ndim
            enddo
  921       continue
            Finter(jind)=kj
            Finter(jind+1)=jrt
            nFloc=nFloc+3
            if((jrt.eq.1).and.(inter.le.0)) go to 20
            do ij=1,iz
               Finter(jind+2+ij)=vz(ij)
               nFloc=nFloc+1
            enddo
            go to 820
   20       continue
            Finter(jind+2)=0.
            go to 810
  820       continue
            Finter(jind+2)=iz-1
  810       continue
            jind=jind+3+iz-1
         endif
      enddo
      nn6=nFloc-1
      if(istat2.gt.1) then
         write(ncwu,600) (Finter(nn5+i-1),i=1,nn6-nn5)
  600    format(12f10.5)
      endif
      return
      end
c
code for sae61
      subroutine sae61(idr)
c-----real*8 ec,ez,ecb
c
      USE General
      USE Atomi
      USE Plotter
      USE Molcom, only : SinglePlotType
      USE Dialogo
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension abond(4,60),bbond(4,60),ec(2,2),ez(2,2),
     *va(3),vb(3),vz(5000),c(3),ve(100),ecb(2,2),bm1(3,3),
     *tetz(10),tet(10),p0(3),pc(3),v(100)
c--
      zero=0.00001
      nn7=nFloc
      mind=nFloc
      iind=nn7
      do kj=1,natsPlo
         j= AdrPloto5(kj)
c--controllo se ANISO e' richiesto
         if(SinglePlotType(j).eq.ELLIPSOIDS)then
            jrt=0
            nax=0
            iz=1
c--estrazione valori dell'ellissoide   
            ez(1,1)=ParamEllabc(1,3,kj)       ! ParamEllabc(1,3,kj)     
            ez(1,2)=ParamEllabc(2,3,kj)/2.
            ez(2,1)=ez(1,2)
            ez(2,2)=ParamEllabc(3,3,kj)
            a1z=ParamEllabc(4,3,kj)
            a2z=ParamEllabc(5,3,kj)
            fiz=ParamEllabc(6,3,kj)
            fiz1=ParamEllabc(7,3,kj)
            fiz2=ParamEllabc(8,3,kj)
!            
            c(1)=ParamEll(11,kj)              ! ParamEll(11,kj)
            c(2)=ParamEll(12,kj)
            c(3)=ParamEll(13,kj)
            
            a1c=ParamEll(17,kj)               ! ParamEll(17,kj)
            a2c=ParamEll(18,kj)
c--fine dell'estrazione            
            vz(:)=0.
            if(ez(1,1).eq.0) jrt=1
            va(1:3)=xyzsPlo(1:3,kj)
c---- intersezioni ellisse--ellisse
            do ij=1,natsPlo
               if(ij.ne.kj) then
c--controllo se ANISO e' richiesto        
c--	if(kshuttle(m25s+54).eq.8) then     (?? non used)
                  vb(1:3)=xyzsPlo(1:3,ij)
!--(controllo che i centri non siano esattamente coincidenti)
                  hhh=vb(1)-va(1)
                  sss=vb(2)-va(2)
                  if((abs(hhh).lt.zero).and.(abs(sss).lt.zero)) cycle
                  call bstor(fbiso,bm1,ij)
c--estrazione dei valori dell'ellissoide                  
                  a1cb=ParamEll(17,ij)            ! ParamEll(17,ij)
                  a2cb=ParamEll(18,ij)
                  ecb(1,1)=ParamEll(14,ij)
                  ecb(1,2)=ParamEll(15,ij)/2.
                  ecb(2,1)=ecb(1,2)
                  ecb(2,2)=ParamEll(16,ij)
c--fine dell'estrazione                  
                  call lngtp(va,vb,dist)
                  axm1=amax1(a1c,a2c)
                  axm2=amax1(a1cb,a2cb)
                  axm=axm1+axm2
                  if(dist.gt.axm) go to 700
                  if(va(3).ge.vb(3)) goto 700  ! 701,700,700
c-- se l'ellisse contorno e' oscurata potrebbero
c-- essere oscurate anche le ellissi principali
                  if(jrt.eq.1) go to 800
                  iwrt=0
                  call ellint(va,vb,ez,ecb,ndimz,tetz,im,
     *                        an,bn,cn,dn,en,fn,iwrt)
                  if(im.eq.4) ndimz=0
                  if(im.eq.4) go to 91
                  go to 92
   91             ellb=fn
                  if((ellb.lt.0.).and.(va(3).lt.vb(3))) jrt=-10
   92             continue
                  if(ndimz.eq.0) go to 700
                  do j1=1,ndimz
                     vz(iz-1+j1)=tetz(j1)
                  enddo
                  iz=iz+ndimz
                  go to 700
  800             continue
                  p0(1)=ez(1,2)+va(1)
                  p0(2)=ez(2,2)+va(2)
                  p0(3)=va(3)
                  pc(1)=a1z+va(1)
                  pc(2)=a2z+va(2)
                  pc(3)=va(3)
c-----------------------
                  nax=0
                  call axl(vb,p0,pc,ecb,nax,ndim3,tet)
                  if(ndim3.eq.0) go to 700
                  do i1=1,ndim3
                     vz(iz+i1)=tet(i1)
                  enddo
                  iz=iz+ndim3
  700             continue
                  if(nax.gt.0)jrt=-10
               endif
c--	   endif
            enddo
            Finter(iind)=kj
            Finter(iind+1)=jrt
            Finter(iind+2)=iz-1
            nFloc=nFloc+3
            if((iz-1).eq.0) go to 36
            do ij=1,iz
               Finter(iind+2+ij)=vz(ij)
               nFloc=nFloc+1
            enddo
   36       continue
            iind=iind+2+iz
         endif
      enddo
      nn8=nFloc-1
      write(ncwu,201) nn8
  201 format(' Buffer used :',i6,' (max length: 10000)'/)     
      if(istat2.gt.1) then
         write(ncwu,200) (Finter(nn7+i-1),i=1,nn8-nn7+1)
  200    format(12f10.5)
      endif
      return
      end
c
code for sae62
      subroutine sae62(idr,jdise)
c--disegna il terzo ellisse principale
c-----real*8 ec,ex,ey,ez
c
      USE General
      USE Atomi
      USE Plotter
      USE Molcom, only : SinglePlotType
      USE Dialogo
!
      character*80 ifilin
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      dimension abond(4,60),bbond(4,60),
     *ec(2,2),ex(2,2),ey(2,2),ez(2,2),va(3),vb(3),
     *vz(5000),v(5000),a(3),b(3),c(3),p1(3),p2(3),s1(3),s2(3)
c--
      if (jdise.eq.1) then
          call scrper('Filling ellipsoids on file',0,0)
      else
          call scrper('Filling ellipsoids on screen',0,0)
      endif
      if(istat2.gt.1) then
         write(ncwu,*)'============================================'
         write(ncwu,'(a)')'disegna il terzo ellisse principale'   
      endif
!
      do kj=1,natsPlo
         j= AdrPloto5(kj)
c--controllo se ANISO e' richiesto
         if(SinglePlotType(j).eq.ELLIPSOIDS)then
            call elstor(kj,axa,axb,axc,a,b,c,ec,a1c,a2c,fic,idr,
     *                  ex,a1x,a2x,fix,fix1,fix2,
     *                  ey,a1y,a2y,fiy,fiy1,fiy2,
     *                  ez,a1z,a2z,fiz,fiz1,fiz2)
            vz(:)=0.
            ksp = nzTot(j)
            if(no(ksp).eq.1) cycle
            va(1:3)=xyzsPlo(1:3,kj)
            kkk=jSingleColor(j)
            write(ifilin,331)aLabPlo(kj),kkk
  331       format('atom : ', a8,i5)
            call plwrit(ifilin)
            call cpen(kkk)
            j=nn5
  200       continue
            if(j.ge.nn6) cycle
            k=Finter(j)
            iz=Finter(j+2)
            jrt1=Finter(j+1)
            if(jrt1.eq.-10) cycle
            if(k.eq.kj) go to 210
            j=j+3+iz
            go to 200
  210       continue
            if((jrt1.eq.1).and.(iz.eq.0)) go to 921
            do ij=1,iz
               vz(ij)=Finter(j+2+ij)
            enddo
  921       continue
            j1=nn7
  201       continue
            if(j1.ge.nn8) go to 222
            k1=Finter(j1)
            jrt=Finter(j1+1)
            iz1=Finter(j1+2)
            if(k1.eq.kj) go to 211
            j1=j1+3+iz1
            go to 201
  211       continue
            if(iz1.eq.0) go to 222
            do ij=1,iz1
               vz(iz+ij)=Finter(j1+2+ij)
            enddo
  222       continue
            if(jrt.eq.-10)cycle
            idim=iz+iz1+1
            if(jrt.gt.0) goto 240  
            if(istat2.gt.1) then
	         write(ncwu,31) (vz(i2),i2=1,idim)
   31	         format(1x,'vz=',10f10.5)
            endif
            call ordarc(vz,idim,ifus)
            xo=va(1)
            yo=va(2)
            call plpoa(xo,yo)
            do ij=2,idim-1,2
               teta1=vz(ij)
               teta2=vz(ij+1)
               call elpr(xo,yo,a1z,a2z,fiz,teta1,teta2)
            enddo
            go to 830
  240       continue
            p1(1)=ez(1,2)+va(1)
            p1(2)=ez(2,2)+va(2)
            p1(3)=va(3)
            p2(1)=a1z+va(1)
            p2(2)=a2z+va(2)
            p2(3)=va(3)
            idim=idim-1
            if(idim.gt.0) goto 322  
            call plosg(p1,p2,0)
            go to 830
  322       continue
            v(1)=0.
            v(2)=0.
            do ij=3,idim+2
               v(ij)=vz(ij-2)
            enddo
            v(idim+3)=1.
            v(idim+4)=1.
            idimz=idim+4
            call ordvet(idim,idimz,v,jfus)
            ndim=idimz-2*jfus
            do j3=2,ndim,2
               s1(1)=p1(1)+(p2(1)-p1(1))*v(j3)
               s1(2)=p1(2)+(p2(2)-p1(2))*v(j3)
               s1(3)=p1(3)+(p2(3)-p1(3))*v(j3)
               s2(1)=p1(1)+(p2(1)-p1(1))*v(j3+1)
               s2(2)=p1(2)+(p2(2)-p1(2))*v(j3+1)
               s2(3)=p1(3)+(p2(3)-p1(3))*v(j3+1)
               call plosg(s1,s2,0)
            enddo
  830       continue
            call plpup
         endif
      enddo
      nFloc=nind
!
      call scrper(' ',0,-1)
!
      return
      end
c
code for sae7
      subroutine sae7(idr,ibnd,jdise)
c--disegna semiassi principali
c-----real*8 ec,ex,ey,ez,ecb,exb,eyb,ezb
c
      USE General
      USE Atomi
      USE Plotter
      USE Molcom, only : SinglePlotType
      USE Dialogo
!
      character*80 ifilin
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      dimension abond(4,60),bbond(4,60),v(10),
     *ec(2,2),ex(2,2),ey(2,2),ez(2,2),va(3),vb(3),a(3),b(3),c(3),
     *ab(3),bb(3),cb(3),ecb(2,2),exb(2,2),eyb(2,2),ezb(2,2),
     *ta(3),tb(3),p0(3),pa(3),
     *s1(3),s2(3),bm(3,3),egv(3),
     *a1(3),a2(3),a3(3),a4(3),vbn(50), aa1(3),aa2(3)
      dimension pabc(3,3),axi(3),v123(100,3),k123(3),naxi(3),abc(3,3)
      dimension vint(3),inum123(3),v1(100),exyz(2,2,3),naxib(3)
c
      if (jdise.eq.1) then
          call scrper('Colouring ellipsoids on file',0,0)
      else
          call scrper('Colouring ellipsoids on screen',0,0)
      endif
      iwrt=0
c      istat2=11  ! no. ordine atomo da analizzare C7
c      istat2=2  ! no. ordine atomo da analizzare S2
      if(istat2.gt.0) then 
         write(ncwu,*)'============================================'
         write(ncwu,*)'disegna semiassi principali'
      endif
c--loop sugli elissoidi
      setli=0.1
      call setline(setli)
      iiii=1
      do kj=1,natsPlo
         j= AdrPloto5(kj)
c--controllo se ANISO e' richiesto
         if(SinglePlotType(j).eq.ELLIPSOIDS)then
           call elstor(kj,axi(1),axi(2),axi(3),a,b,c,ec,a1c,a2c,fic,idr,
     *                  ex,a1x,a2x,fix,fix1,fix2,
     *                  ey,a1y,a2y,fiy,fiy1,fiy2,
     *                  ez,a1z,a2z,fiz,fiz1,fiz2)
            do j=1,3
	         abc(j,1)=a(j)
	         abc(j,2)=b(j)
	         abc(j,3)=c(j)
            enddo
            do j1=1,2
	         do j2=1,2
	            exyz(j1,j2,1)=ex(j1,j2)
	            exyz(j1,j2,2)=ey(j1,j2)
	            exyz(j1,j2,3)=ez(j1,j2)
	         enddo
            enddo
            do j=1,3
	         k123(j)=1
            enddo
            do j=1,3
	         do i1=1,50
	            v123(i1,j)=0.
	         enddo
            enddo
            ksp = nzTot(j)
            if(no(ksp).eq.1) cycle
            va(1:3)=xyzsPlo(1:3,kj)
            if(istat2.eq.kj) then 
c            if(istat2.gt.0) then 
               write(ncwu,'(a,/,a,3f10.4)')
     *     '======================================', aLabPlo(kj),va(1:3)
            endif
            kkk=jSingleColor(j)
            write(ifilin,331)aLabPlo(kj),kkk
  331       format('atom : ', a8,i5)
            call plwrit(ifilin)
            call cpen(kkk)
            call bstor(fbiso,bm,kj)
            egv(1)=bm(1,3)
            egv(2)=bm(2,3)
            egv(3)=bm(3,3)
            k1=1
            do j=1,3
	         v123(k1	,j)=0.
	         v123(k1+1,j)=0.
	         k123(j)=k123(j)+2
            enddo
               if(istat2.eq.kj) then 
c               if(istat2.gt.0) then 
               write(ncwu,'(11x,a,12x,a,13x,a)')
     *                    'pabc(1:3,j)','axi(j)','abc(1:3,j)'
            endif
            do j=1,3
	         p0(j)=0.
	         do i1=1,3
	            pabc(i1,j)=axi(j)*abc(i1,j)
	         enddo
               if(istat2.eq.kj) then 
c               if(istat2.gt.0) then 
                  write(ncwu,'(7f10.4)')pabc(1:3,j),axi(j),abc(1:3,j)
               endif
            enddo
            naxib(:)=0
            if(ibnd.ne.-1) then
c--loop sui bond
               if(istat2.eq.kj) then 
c               if(istat2.gt.0) then 
                  write(ncwu,*)'Loop sui bond'
               endif
               do j=1,nbon
                  call BondStor(j,ia,ib,abond,bbond)
                  if(ia.eq.0) cycle
c                  if(istat2.gt.0) write(ncwu,'(a,i5,2x,2a8)') 
                  if(istat2.eq.kj) write(ncwu,'(a,i5,2x,2a8)') 
     *                 'No Bond:',j,aLabPlo(ia),aLabPlo(ib)
                  do j1=1,jdim
	               do i1=1,3
	                  abond(i1,j1)=ABaseBond(i1,j1,j)-va(i1)
	                  bbond(i1,j1)=BBaseBond(i1,j1,j)-va(i1)
	                  if(j1.eq.1) then
	                     a1(i1)=abond(i1,j1)
	                     a2(i1)=bbond(i1,j1)
	                  endif
	                  if(j1.eq.jdim) then
	                     a3(i1)=abond(i1,j1)
	                     a4(i1)=bbond(i1,j1)
	                  endif
	               enddo
                  enddo
                  do i1=1,3
	               ta(i1)=(a2(i1)-a1(i1))*0.15
	               tb(i1)=(a4(i1)-a3(i1))*0.15
                  enddo
                  do i1=1,3
	               a1(i1)=a1(i1)-ta(i1)
	               a2(i1)=a2(i1)+ta(i1)
	               a3(i1)=a3(i1)-tb(i1)
	               a4(i1)=a4(i1)+tb(i1)
                  enddo
c-- si opera una prima selezione dei bonds
c-- che potrebbero intersecare
                  do jj1=1,3
                     if(naxib(jj1).eq.0) then
                        do i1=1,3
                           pa(i1)=pabc(i1,jj1)
                        enddo
                        call qdrl(a1,a2,a3,a4,p0,pa,t1,t2,nn)
c-----------------------call qdrl(a1,a2,a4,a3,p0,pa,t1,t2,nn)
                        if(istat2.eq.kj)write(ncwu,*)'nn     =',nn
c                        if(istat2.gt.0)write(ncwu,*)'nn=',nn
	                  if(nn.eq.0) then
	                     call intest(a1,a2,a3,a4,p0,pa,n0x,n1x)
c-------------------------call intest(a1,a2,a4,a3,p0,pa,n0x,n1x)
                         if(istat2.eq.kj)write(ncwu,*)'n0x,n1x=',n0x,n1x
c                        if(istat2.gt.0)write(ncwu,*)'n0x,n1x=',n0x,n1x
	                     if(n0x.eq.1.and.n1x.eq.1) then
	                        if(p0(3).lt.a1(3)) then
	                           naxib(jj1)=1
	                           cycle
	                        endif
	                     endif
	                  else
	                     call axbond(abond,bbond,p0,pa,jdim,ndim,vbn)
                           if(istat2.eq.kj)write(ncwu,*)'ndim=',ndim
c                          if(istat2.gt.0)write(ncwu,*)'ndim=',ndim
	                     if(ndim.gt.0) then
	                        k1=k123(jj1)
	                        do j1=1,ndim
	                           v123(k1-1+j1,jj1)=vbn(j1)
	                        enddo
	                        k1=k1+ndim
	                        k123(jj1)=k1
	                     endif
                        endif
                     endif
                  enddo
               enddo
c--fine loop sui bond
            endif
c--calcolo coordinate dell'origine e dell'estremita' dei tre vettori
            do j=1,3
               p0(j)=p0(j)+va(j)
               do ij=1,3
	            pabc(ij,j)=pabc(ij,j)+va(ij)
               enddo
            enddo
            if(istat2.eq.kj) then
c           if(istat2.gt.1) then
               write(ncwu,331) aLabPlo(kj)
               write(ncwu,74) p0,((pabc(ij,j),ij=1,3),j=1,3)
   74          format(' p0 =',3f10.4,' pa =',3f10.4,/,
     1                ' pb =',3f10.4,' pc =',3f10.4)
               write(ncwu,'(a,3i5)')'naxib:',naxib(1:3)
               do j=1,3
                  k1=k123(j)
                  write(ncwu,'(a,i2)')' v =',j
                  write(ncwu,71) (v123(i3,j),i3=1,k1-1)
   71             format(8f10.5)
               enddo
            endif
c-------------------------------------
            naxi(:)=0
c--loop interno sugli elissoidi
            if(istat2.eq.kj) then
c           if(istat2.gt.0) then
               write(ncwu,*)'Loop sugli ellissoidi'
            endif
            do ij=1,natsPlo
	         if(kj.ne.ij) then
c--controllo se ANISO e' richiesto    
c--	   if(kshuttle(m25s+54).eq.8) then     ( ?? not used)
                  vb(1:3)=xyzsPlo(1:3,ij)
                  call elstor(ij,axab,axbb,axcb,ab,bb,cb,ecb,
     *                        a1cb,a2cb,ficb,idr,
     *                        exb,a1xb,a2xb,fixb,fix1b,fix2b,
     *                        eyb,a1yb,a2yb,fiyb,fiy1b,fiy2b,
     *                        ezb,a1zb,a2zb,fizb,fiz1b,fiz2b)
	            ax1=amax1(a1c,a2c)
	            ax2=amax1(a1cb,a2cb)
	            amx=ax1+ax2
	            call lngtp(va,vb,dist)
	            if(dist.le.amx) then
c-- gli assi dell'ellissoide potrebbero essere oscurati
	               do jj1=1,3
		                if(naxib(jj1).eq.0) then
		                   do i1=1,3
		                      pa(i1)=pabc(i1,jj1)
		                   enddo
		                   call axl(vb,p0,pa,ecb,naxi(jj1),ndim1,v)
		                   if(ndim1.gt.0) then
		                      k1=k123(jj1)
		                      do j1=1,ndim1
			                     v123(k1-1+j1,jj1)=v(j1)
		                      enddo
		                      k1=k1+ndim1
		                      k123(jj1)=k1
		                   endif
		                endif
	               enddo
	            endif
c------------  endif
	         endif
            enddo
c--fine loop interno sugli elissoidi
            do j=1,3
               k1=k123(j)
               v123(k1,j)=1.
               v123(k1+1,j)=1.
               k1=k1+1
               k123(j)=k1
               inum123(j)=k1-4
            enddo
               if(istat2.eq.kj) then
c              if(istat2.gt.1) then
               write(ncwu,'(a,3i5)')'naxi:',naxi(1:3)
               do j=1,3
                  k1=k123(j)
                  write(ncwu,'(a,i2)')' v =',j
                  write(ncwu,71) (v123(i3,j),i3=1,k1-1)
               enddo
            endif
            do j=1,3
               k1=k123(j)
               inum1=inum123(j)
               do i1=1,k1
	            v1(i1)=v123(i1,j)
               enddo
               call ordvet(inum1,k1,v1,jfus1)
               do i1=1,k1
	            v123(i1,j)=v1(i1)
               enddo
               k123(j)=k1
            enddo
!---------------------------------------------------------            
!-- disegno i semiassi
!---------------------------------------------------------            
            xo=va(1)
            yo=va(2)
            call plpoa(xo,yo)
!--loop sui semiassi            
            do jj1=1,3
               k1=k123(jj1)
               if(istat2.eq.kj) then
c              if(istat2.ge.3) then
                  write(ncwu,*)'loop sui semiassi ================='
                  write(ncwu,8099) 'jj1,naxi,naxib,k1=',jj1,naxi(jj1),
     *                        naxib(jj1),k1
 8099             format(a,4i5)
                  write(ncwu,101) (v123(i3,jj1),i3=1,k1)
  101             format(10f7.3)
               endif
               if(naxi(jj1).le.0.and.naxib(jj1).eq.0) then
!--scrivo semi assi principali
	            do j1=2,k1-1,2
	               do j2=1,3
	                  s1(j2)=p0(j2)+(pabc(j2,jj1)-p0(j2))*
     *                           v123(j1,jj1)                    ! inizio tratto
	                  s2(j2)=p0(j2)+(pabc(j2,jj1)-p0(j2))
     *                           *v123(j1+1,jj1)                  ! fine tratto
	               enddo
                     if(istat2.eq.kj) then
c                    if(istat2.gt.1) then
	                  call lngtp(s1,s2,xd)
	                  write(ncwu,110) jj1,s1(1:2),s2(1:2),xd
  110	                  format(i4,')',' s1=',2f8.3,' s2=',2f8.3,
     *                                 ' d=',f8.3)
	               endif
	               call plosg(s1,s2,1)
	            enddo
               endif
            enddo
!--fine loop sui semiassi            
!---------------------------------------------------------            
!--calcolo linee parallele semi assi principali
!---------------------------------------------------------   
               if(istat2.eq.kj) then
c               if(istat2.ge.3) then
               write(ncwu,*)'linee parallele semiassi ================='
            endif
            do jj1=1,3
               passomin=0.3
               jj2=jj1+1
               if(jj2.gt.3)jj2=1
               jj3=jj2+1
               if(jj3.gt.3)jj3=1
               do j1=1,2
                  do j2=1,2
                     ez(j1,j2)=exyz(j1,j2,jj3)
                  enddo
               enddo
               do j1=1,3
                  c(j1)=abc(j1,jj3)
               enddo
!--intervallo del semiasse origine delle linee parallele al semiasse corrente               
               deltax1=pabc(1,jj2)-p0(1)   
               deltay1=pabc(2,jj2)-p0(2)
               deltaz1=pabc(3,jj2)-p0(3)
               ass=sqrt(deltax1*deltax1+deltay1*deltay1)   ! lunghezza del semiasse origine
               passo=ass/5
               if(passo.gt.passomin) passo=passomin
               nli=int(ass/passo)
               deltax=deltax1/ass
               deltay=deltay1/ass
               if(istat2.eq.kj) then
c               if(istat2.gt.1) then
                  write(ncwu,*)'---------------------------------------'
                  write(ncwu,8000) jj1,p0(1:3),pabc(1:3,jj2),
     *                deltax1,deltay1,deltaz1   
 8000             format('Asse =',i3,')',3f10.3,/,10x,3f10.3,/,
     *                   10x,3f10.3)
                  write(ncwu,8001)ass,passo,nli,deltax,deltay
 8001             format('lung.asse=',f10.3,' passo=',f10.3,' nli='i5,
     *                  ' delta/asse=', 2f10.3)                
               endif   
               fical=atan2(deltay,deltax)
               if(fical.lt.0.0) fical=fical+twopi
               fincx=passo*cos(fical)
               fincy=passo*sin(fical)
               fincz=deltaz1/nli
               if(istat2.eq.kj) then
c               if(istat2.gt.1) then
                  write(ncwu,8002) fical*rtd, passo,fincx,fincy
 8002             format('fical=',f10.2,' passo=',f10.3,' finc=',2f10.4)
               endif
!--loop sul numero di parallele da disegnare               
               do j0=1,nli
!--aa1(1:3) origine sul semiasse 
!--aa2(1:3) fine della linea parallella al semiasse corrente               
                  aa1(1)=p0(1)      +j0*fincx-va(1)
                  aa1(2)=p0(2)      +j0*fincy-va(2)
                  aa1(3)=p0(3)      +j0*fincz-va(3)
                  aa2(1)=pabc(1,jj1)+j0*fincx-va(1)
                  aa2(2)=pabc(2,jj1)+j0*fincy-va(2)
                  aa2(3)=pabc(3,jj1)+j0*fincz-va(3)
                  if(istat2.eq.kj) then
c                  if(istat2.ge.3) then
                      write(ncwu,8010)aa1(1:3),aa2(1:3)
 8010                 format('vettore = ',3f10.3,/,10x,3f10.3)          
                  endif
c--calcola l'intersezione della linea con la superfice dell'ellissoide                  
                  call intpr(ez,c,aa1,aa2,intp,vint,intex,iwrt)
c--aa1(3) e aa2(3) coordinate inziali e finali del vettore corrente
                  if(istat2.eq.kj) write(ncwu,*) 'intex=',intex
c                  if(istat2.ge.3) write(ncwu,*) 'intex=',intex
                  if(intex.eq.0) then
                     aa2(1)=vint(1)     !  coordinata x dell'intersezione
                     aa2(2)=vint(2)     !  coordianta y dell'intersezione
c--controllo oscuramenti
                     k1=3
                     do j1=1,50
                        v1(j1)=0.
                     enddo
c--loop sui bond---------------------------------------------------------------
                     if(ibnd.ne.-1) then
                        do j=1,nbon
                           call BondStor(j,ia,ib,abond,bbond) 
                           if(ia.eq.0) cycle
                           do j1=1,jdim
                              do i1=1,3
                                 abond(i1,j1)=ABaseBond(i1,j1,j)-va(i1)
                                 bbond(i1,j1)=BBaseBond(i1,j1,j)-va(i1)
                                 if(j1.eq.1) then
                                    a1(i1)=abond(i1,j1)
                                    a2(i1)=bbond(i1,j1)
                                 endif
                                 if(j1.eq.jdim) then
                                    a3(i1)=abond(i1,j1)
                                    a4(i1)=bbond(i1,j1)
                                 endif
                              enddo
c                             jstep=jstep+8
                           enddo
                           do i1=1,3
                              ta(i1)=(a2(i1)-a1(i1))*0.15
                              tb(i1)=(a4(i1)-a3(i1))*0.15
                           enddo
                           do i1=1,3
                              a1(i1)=a1(i1)-ta(i1)
                              a2(i1)=a2(i1)+ta(i1)
                              a3(i1)=a3(i1)-tb(i1)
                              a4(i1)=a4(i1)+tb(i1)
                           enddo
!-- si opera una prima selezione dei bonds
!-- che potrebbero intersecare
                           call qdrl(a1,a2,a3,a4,aa1,aa2,t1,t2,nn)
!--------------------------call qdrl(a1,a2,a4,a3,aa1,aa2,t1,t2,nn)
                           if(nn.eq.0) then
                              call intest(a1,a2,a3,a4,aa1,aa2,n0x,n1x)
!-----------------------------call intest(a1,a2,a4,a3,aa1,aa2,n0x,n1x)
                              if(n0x.eq.1.and.n1x.eq.1) then
                                 if(aa1(3).lt.a1(3)) then
                                    goto 200
                                 endif
                              endif
                           else
                              call axbond(abond,bbond,aa1,aa2,jdim,
     *                                    ndim,vbn)
                              if(ndim.gt.0) then
                                 do j1=1,ndim
                                    v1(k1-1+j1)=vbn(j1)
                                 enddo
                                 k1=k1+ndim
                              endif
                           endif
                        enddo
c--fine loop sui bond-----------------------------------------------
                     endif
c--calcolo coordinate dell'origine e dei tre vettori
	               if(istat2.eq.kj) then
c	               if(istat2.gt.1) then
                        write(ncwu,8011)aa1(1:3),aa2(1:3),va(1:3)
 8011                   format('vett.asse=',3f10.3,/,10x,3f10.3,/,
     *                         'va(1:3)  =',3f10.3)
                     endif
                     do j=1,3
	                  aa1(j)=aa1(j)+va(j)
	                  aa2(j)=aa2(j)+va(j)
                     enddo
	               if(istat2.eq.kj) then
c	               if(istat2.gt.1) then
                        write(ncwu,8012)aa1(1:3),aa2(1:3)
 8012                   format('vett.asse=',3f10.3,/,10x,3f10.3)   
                     endif
c-------------------------------------------------------------------
                     nax1=0
c--loop interno sugli elissoidi-------------------------------------
                     do ij=1,natsPlo
c	                  ij=Finter(j)
	                  if(kj.ne.ij) then
c--controllo se ANISO e' richiesto
c---------------------- if(kshuttle(m25+54).eq.8) then   (?? not used)
                           vb(1:3)=xyzsPlo(1:3,ij)
	                     call elstor(ij,axab,axbb,axcb,ab,bb,cb,ecb,
     *                                 a1cb,a2cb,ficb,idr,
     *	                               exb,a1xb,a2xb,fixb,fix1b,fix2b,
     *	                               eyb,a1yb,a2yb,fiyb,fiy1b,fiy2b,
     *	                               ezb,a1zb,a2zb,fizb,fiz1b,fiz2b)
	                     ax1=amax1(a1c,a2c)
	                     ax2=amax1(a1cb,a2cb)
	                     amx=ax1+ax2
	                     call lngtp(va,vb,dist)
	                     if(dist.le.amx) then
c-- gli assi dell'ellissoide potrebbero essere oscurati
	                        call axl(vb,aa1,aa2,ecb,nax1,ndim1,v)
	                        if(ndim1.gt.0) then
	                           do j1=1,ndim1
	                              v1(k1-1+j1)=v(j1)
	                           enddo
	                           k1=k1+ndim1
	                        endif
	                     endif
	                  endif
                     enddo
c--fine loop interno sugli elissoidi------------------------------------
                     v1(k1)=1.
                     v1(k1+1)=1.
                     k1=k1+1
                     inum1=k1-4
                     call ordvet(inum1,k1,v1,jfus1)
                     if(nax1.le.0) then
	                  do j1=2,k1-1,2
	                     do j2=1,3
	                        s1(j2)=aa1(j2)+(aa2(j2)-aa1(j2))*v1(j1)
	                        s2(j2)=aa1(j2)+(aa2(j2)-aa1(j2))*v1(j1+1)
	                     enddo
	                     if(istat2.eq.kj) then
c	                     if(istat2.gt.1) then
	                        call lngtp(s1,s2,xd)
	                        write(ncwu,111) '%asse:',jj1,s1(1:2),
     *              	                        s2(1:2),xd
  111	                        format(a,i3,')',' s1=',2f8.3,'  s2=',
     *                                      2f8.3, '  d=',f8.3)
	                     endif
	                     call plosg(s1,s2,1)
	                  enddo
                     endif
                  endif
200               continue
               enddo
            enddo
            call plpup
            iiii=iiii+1
         endif
      enddo
!
      istat2=0
      call scrper(' ',0,-1)
!
      return
      end
c
code for qdrl
      subroutine qdrl(a1,a2,a3,a4,p0,p1,ta,tb,nn)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension a1(3),a2(3),a3(3),a4(3),tt(4),p0(3),p1(3)
c--
      nn=0
      call fint(p0,p1,a1,a2,t1,q1)
      call fint(p0,p1,a2,a3,t2,q2)
      call fint(p0,p1,a3,a4,t3,q3)
      call fint(p0,p1,a4,a1,t4,q4)
      z1=a1(3)+q1*(a2(3)-a1(3))
      z2=a2(3)+q2*(a3(3)-a2(3))
      z3=a3(3)+q3*(a4(3)-a3(3))
      z4=a4(3)+q4*(a1(3)-a4(3))
      zt1=p0(3)+t1*(p1(3)-p0(3))
      zt2=p0(3)+t2*(p1(3)-p0(3))
      zt3=p0(3)+t3*(p1(3)-p0(3))
      zt3=p0(3)+t3*(p1(3)-p0(3))
      zt4=p0(3)+t4*(p1(3)-p0(3))
      if(((t1.ge.0.).and.(t1.le.1.)).and.
     *((q1.ge.0.).and.(q1.le.1.))) go to 101
      go to 110
  101 if(zt1-z1) 11,11,110
   11 nn=nn+1
c      write(ncwu,*)' 11) nn,t1,q1',nn,t1,q1
      tt(nn)=t1
  110 if(((t2.ge.0.).and.(t2.le.1.)).and.
     *((q2.ge.0.).and.(q2.le.1.))) go to 102
      go to 120
  102 if(zt2-z2) 12,12,120
   12 nn=nn+1
c      write(ncwu,*)' 12) nn,t2,q2',nn,t2,q2
      tt(nn)=t2
  120 if(((t3.ge.0.).and.(t3.le.1.)).and.
     *((q3.ge.0.).and.(q3.le.1.))) go to 103
      go to 130
  103 if(zt3-z3) 13,13,130
   13 nn=nn+1
c      write(ncwu,*)' 13) nn,t3,q3',nn,t3,q3
      tt(nn)=t3
  130 if(((t4.ge.0.).and.(t4.le.1.)).and.
     *((q4.ge.0.).and.(q4.le.1.))) go to 105
      go to 150
  105 if(zt4-z4) 14,14,150
   14 nn=nn+1
c      write(ncwu,*)' 14) nn,t4,q4',nn,t4,q4
      tt(nn)=t4
  150 continue
      if(nn-1) 200,210,220
  220 continue
      ta=9999.
      tb=-9999.
      do jj=1,nn
      ta=amin1(tt(jj),ta)
      tb=amax1(tt(jj),tb)
      enddo
      go to 200
  210 continue
      call intest(a1,a2,a3,a4,p0,p1,n0,n1)
      if(n0) 300,310,310
  300 continue
      ta=tt(1)
      tb=1.
      go to 200
  310 ta=0.
      tb=tt(1)
  200 continue
      return
      end
c
code for axl
      subroutine axl(va,pa,pb,ell,nax,ndim,v)
c--calcolo intersezioni assi--ellissi
      dimension va(3),pa(3),pb(3),v(10),ell(2,2),p0(3),p1(3),
     *egv(3),v1(3),v2(3)
c--
      iwrt=0
      ndim=0
      do 11 i=1,10
      v(i)=0.
   11 continue
      do 10 i=1,3
      p0(i)=pa(i)-va(i)
      p1(i)=pb(i)-va(i)
   10 continue
      if(p0(3)) 50,50,500
   50 continue
      a=ell(1,1)
      b=2*ell(1,2)
      c=ell(2,2)
      ell0=a*p0(1)*p0(1)+b*p0(1)*p0(2)+c*p0(2)*p0(2)-1.
      ell1=a*p1(1)*p1(1)+b*p1(1)*p1(2)+c*p1(2)*p1(2)-1.
      call ebint(a,b,c,p0,p1,t1,t2,isolx,iwrt)
      if(isolx.eq.0) return
      if((ell0.lt.0.).and.(ell1.lt.0.)) go to 100
      if((t1.lt.0.).and.(t2.lt.0.)) return
      if((t1.gt.1.).and.(t2.gt.1.)) return
      if((t1.lt.0.).and.(t2.gt.1.)) return
      if((t2.lt.0.).and.(t1.gt.1.)) return
      if(((t1.ge.0.).and.(t1.le.1.)).and.
     *((t2.ge.0.).and.(t2.le.1.))) go to 200
      if((t1.ge.0.).and.(t1.le.1.)) t=t1
      if((t2.ge.0.).and.(t2.le.1.)) t=t2
      if(ell0.lt.0.) go to 300
      if(ell1.lt.0.) go to 400
  300 ndim=ndim+1
      v(ndim)=0.
      v(ndim+1)=t
      ndim=ndim+1
      go to 500
  400 ndim=ndim+1
      v(ndim)=t
      v(ndim+1)=1.
      ndim=ndim+1
      go to 500
  200 continue
      ndim=ndim+1
      v(ndim)=t1
      v(ndim+1)=t2
      ndim=ndim+1
      go to 500
  100 nax=nax+1
  500 continue
      return
      end
c
code for axbond
      subroutine axbond(abond,bbond,p0,p1,jdim,ndim,v)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension abond(4,60),bbond(4,60),v(50),
     *xa(3),xb(3),xc(3),xd(3),p0(3),p1(3)
c--
      tmax=-1000
      tmin=1000
      ndim=0
      int=0
      do j=1,jdim-1
       do i=1,3
	xa(i)=abond(i,j)
	xb(i)=bbond(i,j)
	xc(i)=abond(i,j+1)
	xd(i)=bbond(i,j+1)
       enddo
       call qdrl(xa,xc,xd,xb,p0,p1,ta,tb,nn)
       if(nn.gt.0) then
	if(ta.lt.tmin) tmin=ta
	if(tb.gt.tmax) tmax=tb
	int=int+1
       endif
      enddo
      if(int.gt.0) then
	ndim=ndim+1
	v(ndim)=tmin
	v(ndim+1)=tmax
	ndim=ndim+1
      endif
      return
      end
c
code for ordvet
      subroutine ordvet(inum,icoun,v,jfus)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension v(100)
c--
      do i=1,icoun
      if(v(i).lt.0) v(i)=0.
      if(v(i).gt.1) v(i)=1.
      enddo
c	write(ncwu,101) (v(i),i=1,icoun)
c  101	format(1x,'v=',10f10.5)
c-- ordinamento posti pari
      do 10 i=2,icoun-2,2
      do 15 i1=i+2,icoun,2
      if(v(i).le.v(i1)) go to 5
      com1=v(i)
      v(i)=v(i1)
      v(i1)=com1
    5 continue
   15 continue
   10 continue
      if(istat2.gt.3) then
       write(ncwu,1) (v(i),i=1,icoun)
    1  format(1x,'v-',10f10.5)
      endif
c-- ordinamento posti dispari
      do 20 i=1,icoun-3,2
      do 25 i1=i+2,icoun-1,2
      if(v(i).le.v(i1)) go to 70
      com1=v(i)
      v(i)=v(i1)
      v(i1)=com1
   70 continue
   25 continue
   20 continue
c-------------
      if(istat2.gt.3) then
	write(ncwu,1) (v(i),i=1,icoun)
      endif
c-- fusione di intervalli
      jfus=0.
      j=2
   40 continue
      jf=inum+2
   45 continue
      if(j-jf) 50,50,65
   50 continue
      if(v(j).lt.v(j+1)) go to 60
      do 55 j1=j,inum+4
      v(j1)=v(j1+2)
   55 continue
      jfus=jfus+1
      inum=inum-2
      icoun=icoun-2
      go to 40
   60 continue
      j=j+2
      go to 45
   65 continue
      return
      end
c
code for intest
      subroutine intest(a1,a2,a3,a4,a5,a6,n0,n1)
c--n0=-1 :il punto p0 e' esterno
c--n0=0  :il punto p0 e' sulla frontiera
c--n0=1  :il punto p0 e' interno
c--n1=-1 :il punto p1 e' esterno
c--n1=0	 :il punto p1 e' sulla frontiera
c--n1=1	 :il punto p1 e' interno
c
      dimension a1(3),a2(3),a3(3),a4(3),a5(3),a6(3),
     *fl(4,3),sfla0(4),sfla1(4),a(4,3)
c--
      n0=-1
      n1=-1
      do i=1,3
       a(1,i)=a5(i)-a1(i)
       a(2,i)=a5(i)-a2(i)
       a(3,i)=a5(i)-a3(i)
       a(4,i)=a5(i)-a4(i)
       fl(1,i)=a2(i)-a1(i)
       fl(2,i)=a3(i)-a2(i)
       fl(3,i)=a4(i)-a3(i)
       fl(4,i)=a1(i)-a4(i)
      enddo
      do i=1,4
       sfla0(i)=fl(i,1)*a(i,2)-fl(i,2)*a(i,1)
      enddo
      do i=1,3
       a(1,i)=a6(i)-a1(i)
       a(2,i)=a6(i)-a2(i)
       a(3,i)=a6(i)-a3(i)
       a(4,i)=a6(i)-a4(i)
      enddo
      do i=1,4
       sfla1(i)=fl(i,1)*a(i,2)-fl(i,2)*a(i,1)
      enddo
      prod0=sfla0(1)*sfla0(2)*sfla0(3)*sfla0(4)
      if(prod0.eq.0.) then
       n0=0
      else
       iplus=0
       imin=0
       do i=1,4
	if(sfla0(i).gt.0.) iplus=iplus+1
	if(sfla0(i).lt.0.) imin=imin+1
       enddo
       if((iplus.eq.4).or.(imin.eq.4)) n0=1
      endif
c--
      prod0=sfla1(1)*sfla1(2)*sfla1(3)*sfla1(4)
      if(prod0.eq.0.) then
       n1=0
      else
       iplus=0
       imin=0
       do i=1,4
	if(sfla1(i).gt.0.) iplus=iplus+1
	if(sfla1(i).lt.0.) imin=imin+1
       enddo
       if((iplus.eq.4).or.(imin.eq.4)) n1=1
      endif
      return
      end
c
code for sae9
      subroutine sae9(idr,jdise)
      USE Plotter
c--disegno bond
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
c      istat2=0
      if (jdise.eq.1) then
          call scrper('Preparing bonds to draw on file',0,0)
      else
          call scrper('Preparing bonds to draw on screen',0,0)
      endif
      setli=0.3
      call setline(setli)
      mind=lcom1
      if(istat2.gt.1) then
	   write(ncwu,29) epst,epsa
   29	   format(1x,'epst=',f10.5,2x,'epepsa=',f10.5)
      endif
      call intrs
      if(istat2.gt.1) write(ncwu,*)' dopo intrs'
      call bell(idr)
      if(istat2.gt.1) write(ncwu,*)' dopo bell'
      call genint
      if(istat2.gt.1) write(ncwu,*)' dopo genint'
      call boplo(idr)
!
      call scrper(' ',0,-1)
!
      return
      end
c
code for intrs
      subroutine intrs
c-- calcolo e memorizzazione intersezioni bond--bond
c
      USE General
      USE Atomi
      USE Plotter
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension va(3),vb(3),vc(3),vdd(3),ve(3),vf(3)
      dimension abondj(4,60),bbondj(4,60)
      dimension abond(4,60),bbond(4,60)
c
      if(istat2.gt.0) then
         write(ncwu,*) 'Prima di intrs'
         write(ncwu,'( a,i5)')' Numero di bond:',nbon
         do i1=1,nbon
            write(ncwu,'(2i8)')BondAB(1:2,i1)
            do j1=1,jdim 
               write(ncwu,99) ABaseBond(1:4,j1,i1),BBaseBond(1:4,j1,i1)
            enddo
   99       format(8f10.5)
         enddo
      endif
c--primo loop sui bond
      nn5=nFloc
      do i1=1,nbon
         call BondStor(i1,ia,ib,abond,bbond) 
         int=0
         iel=0	! non si capisce l'uso di questa variabile
c--primo bond
         if(istat2.gt.0) write(ncwu,*)'legame(1):',i1,ia,ib
         if(ia.eq.0) cycle
         va(1:3)=xyzsPlo(1:3,ia)
         vb(1:3)=xyzsPlo(1:3,ib)
c--secondo loop sui bond
         do j1=1,nbon
            call BondStor(j1,ja,jb,abondj,bbondj) 
c--secondo bond
            if(istat2.gt.0) write(ncwu,*)'legame(2):',j1,ja,jb
            if(ja.eq.0) cycle
            if((ia.eq.ja).and.(ib.eq.jb)) cycle
            vc(1:3)=xyzsPlo(1:3,ja)
            vdd(1:3)=xyzsPlo(1:3,jb)
c--controlla se coordinate x,y sono identiche (sovrapposizione bond)
c--controllo  va-->vc
            call xchk(va,vc,ier)
            if(ier.eq.0) then
c--controllo  va-->vd
               call xchk(va,vdd,ier)
               if(ier.eq.0) goto 150
c--controllo  vb-->vc
               call xchk(vb,vc,ier)
               if(ier.eq.0) goto 150
               dz1=vdd(3)-va(3)
               if(dz1.gt.0.0) then
                  BondAB(1,i1)=0
                  cycle
               else
                  BondAB(1,j1)=0
                   cycle
               endif
            else
c--controllo  vb-->vd
               call xchk(vb,vdd,ier)
               if(ier.eq.0) goto 150
               dz1=vc(3)-va(3)
               if(dz1.gt.0.0) then
                  BondAB(1,i1)=0
                  cycle
               else
                  BondAB(1,j1)=0
                   cycle
               endif
            endif
150         continue
c--analisi dei tratti del primo bond per ciascuna direttrice
            ici=0
c            do 300 i=i2,i2+kstep-10,8
            do i=1,jdim
               ici=ici+1
               Finter(nFloc)=BondAB(1,i1)
               Finter(nFloc+1)=BondAB(2,i1)
               Finter(nFloc+2)=0.0
               Finter(nFloc+3)=0.0
               Finter(nFloc+4)=0.0
               va(1:3)=abond(1:3,i)
               vb(1:3)=bbond(1:3,i)
               tmin=1000
               tmax=-1000
c--analisi delle quattro rette che delimitano il secondo bond
               icj=0
               imem=0
               do j=1,jdim-1
                  icj=icj+1
                  vc(1:3)=abondj(1:3,j)
                  vdd(1:3)=bbondj(1:3,j)
                  ve(1:3)=abondj(1:3,j+1)
                  vf(1:3)=bbondj(1:3,j+1)
c--controllo con il lato  vc--vd  ---------- legame  atomi 1-2
                  call fint(va,vb,vc,vdd,t1,q1)
                  if(istat2.gt.0) then
	               write(ncwu,'(a,2f10.2)')'va,vb,vc,vd',t1,q1
                  endif
                  if((q1.gt.0).and.(q1.lt.1)) then
                      zt=va(3)+t1*(vb(3)-va(3))
                      zq=vc(3)+q1*(vdd(3)-vc(3))
                      if(istat2.gt.0) 
     *                     write(ncwu,'(a,2f10.4)')'1) zt,zq',zt,zq
                      if(zt.lt.zq)then
c-- ci sono intersezioni
                         if(t1.gt.tmax) tmax=t1
                         if(t1.lt.tmin) tmin=t1
                      endif
                  endif
c--controllo con il lato  ve--vf  ---------- legame  atomi 1-2
                  call fint(va,vb,ve,vf,t2,q2)
                  if(istat2.gt.0) then
	               write(ncwu,'(a,2f10.2)')'va,vb,ve,vf',t2,q2
                  endif
                  if((q2.gt.0).and.(q2.lt.1)) then
                      zt=va(3)+t2*(vb(3)-va(3))
                      zq=ve(3)+q2*(vf(3)-ve(3))
                      if(istat2.gt.0) 
     *                    write(ncwu,'(a,2f10.4)')'2) zt,zq',zt,zq
                      if(zt.lt.zq)then
c-- ci sono intersezioni
                         if(t2.gt.tmax) tmax=t2
                         if(t2.lt.tmin) tmin=t2
                      endif
                  endif
c--controllo con il lato  vd--vf  ---------- base: atomo 2
                  call fint(va,vb,vdd,vf,t3,q3)
                  if(istat2.gt.0) then
	               write(ncwu,'(a,2f10.2)')'va,vb,vd,vf',t3,q3
                  endif
                  if((q3.gt.0).and.(q3.lt.1)) then
                      zt=va(3)+t3*(vb(3)-va(3))
                      zq=vdd(3)+q3*(vf(3)-vdd(3))
                      if(istat2.gt.0) 
     *                    write(ncwu,'(a,2f10.4)')'3) zt,zq',zt,zq
                      if(zt.lt.zq) then
c-- ci sono intersezioni
                         if(t3.gt.tmax) tmax=t3
                         if(t3.lt.tmin) tmin=t3
                         if(va(3).lt.vdd(3)) then
                            BBaseBond(4,i,i1)=0
                         endif
                      endif
                  endif
c--controllo con il lato  vc--ve  ----------  base: atomo 1
                  call fint(va,vb,vc,ve,t4,q4)
                  if(istat2.gt.0) then
	               write(ncwu,'(a,2f10.2)')'va,vb,vc,ve',t4,q4
                  endif
                  if((q4.gt.0).and.(q4.lt.1)) then
                      zt=va(3)+t4*(vb(3)-va(3))
                      zq=vc(3)+q4*(ve(3)-vc(3))
                      if(istat2.gt.0) 
     *                     write(ncwu,'(a,2f10.4)')'4) zt,zq',zt,zq
                      if(zt.lt.zq) then
c-- ci sono intersezioni
                         if(t4.gt.tmax) tmax=t4
                         if(t4.lt.tmin) tmin=t4
                         if(va(3).lt.vc(3)) then
                            ABaseBond(4,i,i1)=0
                         endif
                      endif
                  endif
                  if((tmin.eq.1000).and.(tmax.eq.-1000)) go to 2000
                  Finter(nFloc+2)=tmin
                  Finter(nFloc+3)=tmax
                  imem=1
 2000             continue
c--fine loop di analisi delle rette che delimitano secondo bond
               enddo
               if((Finter(nFloc+2).lt.0).and.
     *                          (Finter(nFloc+3).lt.0)) imem=0
               if((Finter(nFloc+2).gt.1).and.
     *                          (Finter(nFloc+3).gt.1)) imem=0
c--	if(istat2.gt.1) write(ncwu,*)'nbon,imem=',nbon,imem
               if(imem.eq.0) cycle
               Finter(nFloc+4)=ici      ! numero direttrice del bond
               if(istat2.gt.1) then
                  write(ncwu,3) (Finter(nFloc+k-1),k=1,5)
    3             format(5f10.5)
               endif
               nFloc=nFloc+5
               iel=iel+3
c--fine loop di analisi delle rette che delimitano primo bond
            enddo
c--fine secondo loop
         enddo
c--fine primo loop
      enddo
c--puntatori nn5 --> nn6  delimitano i bond
      nn6=nFloc-1
c--situazione dopo il controllo bond--bond
      if(istat2.gt.0) then
         npunt=(nn6-nn5)/5+1
         write(ncwu,'(a,i5)') ' Numero delimitatori bond',npunt
         mm5=nn5
         do i1=1,npunt
            write(ncwu,99) (Finter(j),j=mm5,mm5+4)
            mm5=mm5+5
         enddo
      endif
      if(istat2.gt.0) then
         write(ncwu,*) 'Dopo di intrs'
         write(ncwu,'(2(a,i5))')' Numero di bond:',nbon 
         do i1=1,nbon
            write(ncwu,'(2i8)')BondAB(1:2,i1)
            do j1=1,jdim 
               write(ncwu,99) ABaseBond(1:4,j1,i1),BBaseBond(1:4,j1,i1)
            enddo
         enddo
      endif
      return
      end
c
code for bell
      subroutine bell(idr)
c-- calcolo e memorizzazione intersezioni bond--ellissoide
c-----real*8 ec,ex,ey,ez
c
      USE General
      USE Atomi
      USE Plotter
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension a(3),b(3),c(3),ec(2,2),ex(2,2),ey(2,2),ez(2,2),
     *v(3),bm(3,3),egv(3),va(3),vb(3),xa(3),xb(3),v1(3),v2(3)
      dimension abond(4,60),bbond(4,60)
c--
      iwrt=0
      zero=0.0001
c--loop sugli ellissi
      do kj=1,natsPlo
         call elstor(kj,axa,axb,axc,a,b,c,ec,a1c,a2c,fic,idr,
     *            ex,a1x,a2x,fix,fix1,fix2,
     *            ey,a1y,a2y,fiy,fiy1,fiy2,
     *            ez,a1z,a2z,fiz,fiz1,fiz2)
         v(1:3)=xyzsPlo(1:3,kj)
         if(istat2.gt.0) then
            write(ncwu,*)' Coordinate centro ellisse atomo n.',kj
            write(ncwu,'(3f10.3)')v
         endif
         call bstor(fbiso,bm,kj)
         egv(1)=bm(1,3)
         egv(2)=bm(2,3)
         egv(3)=bm(3,3)
c--loop sui bond
         do i1=1,nbon
            call BondStor(i1,ia,ib,abond,bbond) 
            if(ia.eq.0) cycle
            if(istat2.gt.0) write(ncwu,*)' Bond tra atomi:',ia,ib
            if((kj.eq.ia).or.(kj.eq.ib)) cycle
            ngenn=0
            int=0
c--loop sui tratti del legame
            do j=1,jdim
               int=int+1
               ngenn=ngenn+1
               ngenn1=0
               Finter(nFloc)=ia
               Finter(nFloc+1)=ib
               Finter(nFloc+2)=0.0
               Finter(nFloc+3)=0.0
               Finter(nFloc+4)=0.0
               va(1:3)=ABaseBond(1:3,j,i1)
               vb(1:3)=BBaseBond(1:3,j,i1)
               if(istat2.gt.0) then
                  write(ncwu,*)' Coordinate estremi del tratto'
                  write(ncwu,'(3f10.3)') va,vb
               endif
c--sottraggo le coordinate delle basi dei bond con le coordinate del
c  centro dell'elissoide
               do j1=1,3
                  xa(j1)=va(j1)-v(j1)
                  xb(j1)=vb(j1)-v(j1)
               enddo
               a1=ec(1,1)
               a2=ec(1,2)*2.
               a3=ec(2,2)
c
c--calcola valore t1 e t2 per ottenere i punti di intersezione
c  tratto--ellisse
c  t1 < 0.0 xa interno ellisse
c  0.0 > t1 < 1.0  xa esterno ellisse e t1 fornisce il punto di inters
c--  t1 > 1.0 xa esterno ellisse (???) diciamo che non ha senso
c  t2 > 1.0 xb interno ellisse
c  0.0 > t2 < 1.0  xb esterno ellisse e t2 fornisce il punto di inters
c--  t2 < 1.0 xb esterno ellisse (???) diciamo che non ha senso
c----------------------------------------------
               call ebint(a1,a2,a3,xa,xb,t1,t2,isolx,iwrt)
c
c--calcolo valore dell'ellisse (ellxa,ellxb) nei punti xa e xb
c  valore = 0.0   punto dell'ellisse
c	  > 0.0   punto esterno all'ellisse
c	  < 0.0   punto interno all'ellisse
c-----------------------------------------------
               ellxa=a1*xa(1)*xa(1)+a2*xa(1)*xa(2)+a3*xa(2)*xa(2)-1.
               ellxb=a1*xb(1)*xb(1)+a2*xb(1)*xb(2)+a3*xb(2)*xb(2)-1.
               if(istat2.gt.0) then
c--stampo valori da controllare
                  write(ncwu,*) 'kj,i1,j',kj,i1,j
                  write(ncwu,*)' Coordinate basi meno centro ellisse'
                  write(ncwu,'(3f10.3)') xa,xb
                  write(ncwu,*) ' Dati relativi a ellisse'
                  write(ncwu,'(a,e20.4)') 't1   ',t1
                  write(ncwu,'(a,e20.4)') 't2   ',t2
                  write(ncwu,'(a,f10.4)') 'ellxa',ellxa
                  write(ncwu,'(a,f10.4)') 'ellxb',ellxb
c--fine stampa
               endif
               if(abs(ellxa).lt.zero.and.abs(ellxb).lt.zero) then
                  ngenn1=-ngenn
               endif
               if(abs(ellxa).lt.zero) Finter(nn3+j+5)=0.
               if(abs(ellxb).lt.zero) Finter(nn3+j+9)=0.
               if(ellxa.lt.0.0.and.xa(3).lt.0.0) Finter(nn3+j+5)=0.
               if(ellxb.lt.0.0.and.xb(3).lt.0.0) Finter(nn3+j+9)=0.
               if(abs(ellxa).le.zero.and.abs(ellxb).le.zero) go to 1000
c--casi in cui il tratto e' esterno all'ellisse
               if((t1.le.0.).and.(t2.le.0.)) cycle
               if((t1.ge.1.).and.(t2.ge.1.)) cycle
c--caso in cui il tratto e' tutto interno all'ellisse
               if((t1.le.0.).and.(t2.ge.1.)) then
                   if(xa(3).lt.0.0) then
                      ngenn1=-ngenn
                      goto 2
                   endif
               endif
               if((t2.le.0.).and.(t1.ge.1.)) then
                   if(xb(3).lt.0.0) then
                      ngenn1=-ngenn
                      go to 2
                   endif
               endif
 1000          continue
               v1(1)=xa(1)+t1*(xb(1)-xa(1))
               v1(2)=xa(2)+t1*(xb(2)-xa(2))
               v1(3)=xa(3)+t1*(xb(3)-xa(3))
               v2(1)=xa(1)+t2*(xb(1)-xa(1))
               v2(2)=xa(2)+t2*(xb(2)-xa(2))
               v2(3)=xa(3)+t2*(xb(3)-xa(3))
               z1=(-egv(1)*v1(1)-egv(2)*v1(2))/egv(3)
               z2=(-egv(1)*v2(1)-egv(2)*v2(2))/egv(3)
               if(istat2.gt.0) then
                  write(ncwu,*)' Soluzioni...'
                  write(ncwu,'(a,3f10.4)')' v1',v1
                  write(ncwu,'(a,3f10.4)')' v2',v2
                  write(ncwu,'(a,2f10.4)')' z1,z2',z1,z2
               endif
               if((v1(3).lt.z1).or.(v2(3).lt.z2)) go to 2
               cycle
    2          continue
               imem=1
               if(t1.lt.0.) t1=0.
               if(t1.gt.1.) t1=1.
               if(t2.lt.0.) t2=0.
               if(t2.gt.1.) t2=1.
               Finter(nFloc+2)=t1
               Finter(nFloc+3)=t2
               Finter(nFloc+4)=ngenn
               if(ngenn1.lt.0) Finter(nFloc+4)=ngenn1
               if(istat2.gt.1) then
                  write(ncwu,*)'delimitano bond (nFloc,nFloc+4)'
                  write(ncwu,3) (Finter(nFloc+ki-1),ki=1,5)
    3             format(5f10.5)
               endif
               nFloc=nFloc+5
c--fine loop sui tratti del legame
            enddo
c--fine loop sui bond
         enddo
c--fine loop sugli ellissi
      enddo
      nn6=nFloc-1
c--puntatori nn5 --> nn6  delimitano i bond
c--situazione dopo il controllo bond--bond e bond--ellissi
      if(istat2.gt.1) then
         npunt=(nn6-nn5)/5+1
         write(ncwu,'(a,i5)') ' Numero delimitatori bond',npunt
         mm5=nn5
         do i1=1,npunt
            write(ncwu,99) (Finter(j),j=mm5,mm5+4)
            mm5=mm5+5
         enddo
         write(ncwu,*) 'Dopo di bell'
         write(ncwu,'(2(a,i5))')' Numero di bond:',nbon
         do i1=1,nbon
            write(ncwu,'(2i8)')BondAB(1:2,i1)
            do j=1,jdim
               write(ncwu,99) ABaseBond(1:4,j,i1),BBaseBond(1:4,j,i1)
   99          format(8f10.5)
            enddo
         enddo
      endif
      return
      end
c
code for genint
      subroutine genint
c--lavora sulla lista nn5-->nn6 (tratti oscuri dei bond)
c--e produce la lista nn7-->nn8
      USE Plotter
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension v(5000)
c--
      nn7=nFloc
c--primo loop
      do 10 i=nn5,nn6-4,5
      iobsc=0
      k5=nFloc
      int=1
      i1=i-1
      ia=Finter(i1+1)
      ib=Finter(i1+2)
      if((ia.eq.0).and.(ib.eq.0)) go to 200
      igen=abs(Finter(i1+5))
      if(Finter(i1+5).lt.0.) iobsc=iobsc+1
      Finter(nFloc)=ia
      Finter(nFloc+1)=ib
      Finter(nFloc+2)=igen
      Finter(nFloc+3)=2.
      Finter(nFloc+4)=Finter(i1+3)
      Finter(nFloc+5)=Finter(i1+4)
c--secondo loop
      do 20 j=i+5,nn6-4,5
      j1=j-1
      ja=Finter(j1+1)
      jb=Finter(j1+2)
      jgen=abs(Finter(j1+5))
      if((ia.ne.ja).or.(ib.ne.jb)) go to 1
      if(igen.ne.jgen) goto 1
      if((Finter(i1+5).lt.0.).or.(Finter(j1+5).lt.0.)) iobsc=iobsc+1
      v(int)=Finter(j1+3)
      v(int+1)=Finter(j1+4)
      int=int+2
      Finter(j1+1)=0.
      Finter(j1+2)=0.
      if(int.ge.1000)go to 21
    1 continue
   20 continue
   21 continue
      Finter(nFloc+3)=Finter(nFloc+3)+int-1
      if(iobsc.gt.0) Finter(nFloc+3)=Finter(nFloc+3)*(-1.)
      if(int.eq.1) go to 1000
      if(i.eq.(nn6-4)) intl=Finter(nFloc+3)
      nFloc=nFloc+6
      do k=1,int-1
       Finter(nFloc+k-1)=v(k)
      enddo
      nFloc=nFloc+int-1
 1000 continue
      if(istat2.gt.1) then
       write(ncwu,110) (Finter(k5+k-1),k=1,int+5)
  110  format(8f10.5)
      endif
      if(int.eq.1) nFloc=nFloc+6
  200 continue
   10 continue
c--stampa di controllo intersezioni memorizzate
      if(istat2.gt.0) then
      npunt=(nn6-nn5)/5+1
      write(ncwu,*)' Intersezioni memorizzate',npunt
      mm7=nn7
      do i1=1,npunt
      write(ncwu,'(2f8.0)')Finter(mm7),Finter(mm7+1)
      ll=abs(Finter(mm7+3))+3
      write(ncwu,'(8f10.5)')(Finter(l),l=mm7+2,mm7+ll)
      mm7=mm7+ll+1
      enddo
      endif
      return
      end
c
code for boplo
      subroutine boplo(idr)
c--
      USE General
      USE Atomi
      USE Plotter
!
      character*80 ifilin
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      dimension iname(4)
      dimension va(3),vb(3),v1(3),v2(3),v(5000),com(3),vc(3),vdd(3)
      dimension abond(4,60),bbond(4,60)
c--
      nn8=nFloc-1
      if(istat2.gt.1) then
         write(ncwu,21) nn4,nn5,nn6,nn7,nn8
   21    format(' nn4=',i10,/,
     2       ' nn5=',i10,' nn6=',i10,' nn7=',i10,' nn8=',i10/)
      endif
c--reset color black
      ipen=0
      call cpen(ipen)
      ia1=1
      ia2=1
      ib1=1
      ib2=1
c--inizio loop sui bond
      do i1=1,nbon
         call BondStor(i1,ia,ib,abond,bbond) 
         va(:)=0.
         vb(:)=0.
         v(:)=0.
         v1(:)=0.
         v2(:)=0.
         if(ia.eq.0) cycle
         write(ifilin,331) aLabPlo(ia),aLabPlo(ib)
331      format('bond: ', a8,'<---> ', a8)
         call plwrit(ifilin)
         if(istat2.gt.0) then
            write(ncwu,'(a)')'========================================='
            write(ncwu,*)' bond:',ia,ib
            write(ncwu,331)  aLabPlo(ia),aLabPlo(ib)
         endif
         va(1:3)=xyzsPlo(1:3,ia)
         xo=va(1)
         yo=va(2)
         if(istat2.gt.0) then
            write(ncwu,'(a, a8)')'Coord. atomo: ',aLabPlo(ia)
	      write(ncwu,'(a,3f10.5)')'va=',va
	      write(ncwu,*) 'mi posiziono su xo,yo=va(1),va(2)'
         endif
         call plpoa(xo,yo)
c--controllo se 'empty bond (definiti da direttiva)
         jsp=0
         if(ivett.ge.1) then
            do i=1,ivett,2
               if((ia.eq.sbn(i)).and.(ib.eq.sbn(i+1))) jsp=1
            enddo
         endif
c--inizio loop sui tratti dei bond
         igen=0
         do i=1,jdim-1
c--jdis codice che indica se primo o ultimo tratto del legame
            jdis=0
            if((i.eq.1).or.(i.eq.jdim)) jdis=1
            va(1:3)=abond(1:3,i)
            vb(1:3)=bbond(1:3,i)
c---------------------
            vc(1:3)=abond(1:3,i+1)
            vdd(1:3)=bbond(1:3,i+1)
            if(istat2.gt.0) then
               write(ncwu,'(a,i5,a,i5)')'Bond No=',i1,' Direttrice=',i
	         write(ncwu,'(a,3f10.5)')' va=',va
	         write(ncwu,'(a,3f10.5)')' vb=',vb
	         write(ncwu,'(a,3f10.5)')' vc=',vc
	         write(ncwu,'(a,3f10.5)')' vd=',vdd
	         write(ncwu,*)' i,jdim-1',i,jdim-1
            endif
            abase=abond(4,i)       ! store(ll2+1)
	      bbase=bbond(4,i)       ! store(ll3+1)
	      cbase=abond(4,i+1)     ! store(ll4+1)
	      dbase=bbond(4,i+1)     ! store(ll5+1)
	      if(istat2.gt.1) then
	         write(ncwu,99) abase,bbase,cbase,dbase
   99	         format(1x,'abase bbase cbase dbase=',4f10.5)
	      endif
c---------------------
            igen=igen+1
            nb=0
            ngenn=0
            kgen=0
            jgen=0   ! aggiunto gianluca 19/03/2009
            icoun=0
            inum=0
            j=nn7
            iosc=0
c--inizio loop 420 -------------------------------------
! loop sui tratti oscurati presenti nella lista  nn7-->nn8
  420       continue
            if(istat2.gt.3)  then
               write(ncwu,*)' j,nn8,intl',j,nn8,intl
            endif
            if(j-nn8+intl+3.gt.0) goto 400	  !  fine loop 420
            k=0
            ja   = Finter(j)
            jb   = Finter(j+1)
            jgen = Finter(j+2)
            jst  = abs(Finter(j+3))
            ist  = Finter(j+3)
c--controllo che sulla lista da nn7 corrisponde l'informazione
c  per questo bond
            if((ia.ne.ja).or.(ib.ne.jb)) go to 1  ! non e' lo stesso bond
            nb=1
            if(igen.ne.jgen) goto 1               ! non e' la stessa generatrice
            if(ist.lt.0) then
               iosc=iosc+1
               goto 1
            endif
            kgen=0
            k=1
            ngenn=ngenn+1
c--------------------------------------
c--il passo lungo la lista da nn7 = j=j+4+jst
c--------------------------------------
            if(istat2.gt.1) write(ncwu,*)'Finter(j+4)',Finter(j+4)
            istoj4=int(Finter(j+4))
            if((istoj4.gt.0).and.(istoj4.lt.1)) ia1=0
            j4=j+4+jst
            if(istat2.gt.1) write(ncwu,*)'j4-1,jst',j4-1,jst
            if(istat2.gt.1) write(ncwu,*)'Finter(j4-1)',Finter(j4-1)
            istoj4=int(Finter(j4-1))
            if((istoj4.gt.0).and.(istoj4.lt.1)) ib1=0
            j8=j+4+jst+4
            if(istat2.gt.1) write(ncwu,*)'j8',j8
            if(istat2.gt.1) write(ncwu,*)'Finter(j8)',Finter(j8)
            istoj4=int(Finter(j8))
            if((istoj4.gt.0).and.(istoj4.lt.1)) ia2=0
            jjjj=j+4+jst+3
            jst1=abs(Finter(jjjj))
            j88=j+4+jst+4+jst1
            if(istat2.gt.1) write(ncwu,*)'j88,jjjj,jst1',j88,jjjj,jst1
            if(istat2.gt.1) write(ncwu,*)'Finter(j88-1)',Finter(j88-1)
            istoj4=int(Finter(j88))
            if((istoj4.gt.0).and.(istoj4.lt.1)) ib2=0
c---------------------------------------
            if(istat2.gt.1) then
               write(ncwu,*) 'ia1,ia2,ib1,ib2',ia1,ia2,ib1,ib2
               write(ncwu,*)'igen,ngenn',igen,ngenn
            endif
            if(va(1)-vb(1).gt.0.0) then
               icom=ia1
               ia1=ib1
               ib1=icom
            endif
            if(vc(1)-vdd(1).gt.0.0) then
               icom=ia2
               ia2=ib2
               ib2=icom
            endif
            if(istat2.gt.1) then
               write(ncwu,*) 'ia1,ia2,ib1,ib2',ia1,ia2,ib1,ib2
            endif
c--------------------------------------
            v(k)=0.
            v(k+1)=0.
            k=k+2
            icoun=icoun+2
            do j1=1,jst
               v(k)=Finter(j+3+j1)
               k=k+1
               icoun=icoun+1
               inum=inum+1
            enddo
            v(k)=1.
            v(k+1)=1.
            k=k+1
            icoun=icoun+2
            if(istat2.gt.1) then
               write(ncwu,78) (v(ik),ik=1,k)
   78          format(1x,'v=',10f10.5)
               write(ncwu,*)'inum,icoun',inum,icoun
            endif
            if(istat2.gt.1) then
               write(ncwu,78) (v(ik),ik=1,k)
            endif
            call ordv(inum,icoun,v,jfus)
            if(istat2.gt.1) then
               write(ncwu,78) (v(ik),ik=1,k)
            endif
            k=icoun-2*jfus
            do ij=2,k-2,2
               do jjj=1,3
                  v1(jjj)=va(jjj)+(vb(jjj)-va(jjj))*v(ij)
                  v2(jjj)=va(jjj)+(vb(jjj)-va(jjj))*v(ij+1)
               enddo
               if(istat2.gt.1) then
                  write(ncwu,17) (v1(i5),i5=1,3),(v2(i5),i5=1,3),
     *                        ia,ib,jgen
   17             format(1x,'v1=',3f10.5,/,1x,'v2=',3f10.5,
     *               /,5x,'ia=',i4,5x,'ib=',i5,5x,'jgen=',i3)
                  write(ncwu,*)'iosc,iline,jdis,jsp',iosc,iline,jdis,jsp
               endif
               if(idr.eq.4.and.jdis.eq.0) goto 91
               if((iline.eq.2).and.(jdis.eq.0)) go to 91
               if((jsp.eq.1).and.(jdis.eq.0)) go to 91
               if (istat2.gt.0) write(ncwu,*)' traccio la linea:v1-->v2'
               call plosg(v1,v2,0)
   91          continue
            enddo
c---------------------------------------
            if((abase.eq.1).and.(cbase.eq.1)) then
	         if((ia1.eq.1).and.(ia2.eq.1)) then
	         if(istat2.gt.0) write(ncwu,*)
     *                           ' traccio la linea(1):va-->vc'
	            if(idr.ne.4) call plosg(va,vc,0)
	         endif
            endif
            if((bbase.eq.1).and.(dbase.eq.1)) then
	         if((ib1.eq.1).and.(ib2.eq.1)) then
	         if(istat2.gt.0) write(ncwu,*)
     *                           ' traccio la linea(1):vb-->vd'
	            if(idr.ne.4) call plosg(vb,vdd,0)
	         endif
            endif
            cycle
    1       continue
c--incremento j (scorro sulla lista a partire da nn7)
            j=j+4+jst
            go to 420
c--fine loop 420 -- disegnate linee del bond
  400       continue
            if(kgen.ne.0) cycle
c            if(kgen.ne.0) go to 402
c--------------------------------------------------
            if(istat2.gt.1) then
               write(ncwu,81) (va(i5),i5=1,3),(vb(i5),i5=1,3),ia,ib,
     *                   igen,jgen
   81          format(1x,'va=',3f10.5,/,1x,'vb=',3f10.5,/,1x,'ia=',
     *                  i4,5x,'ib=',i4,5x,'igen=',i4,5x,'jgen=',i4)
               write(ncwu,98) (vc(i6),i6=1,3),(vdd(i6),i6=1,3)
   98          format(1x,'vc=',3f10.5,/,1x,'vdd=',3f10.5)
               write(ncwu,*)' iosc,iline,jdis,jsp',iosc,iline,jdis,jsp
            endif
            if(iosc.gt.0) cycle
            if(idr.eq.4.and.jdis.eq.0) goto 2022
            if((iline.eq.2).and.(jdis.eq.0)) go to 2022
            if((jsp.eq.1).and.(jdis.eq.0)) go to 2022
            if(istat2.gt.0) write(ncwu,*)' traccio la linea:va-->vb'
            call plosg(va,vb,0)
 2022       continue
c------------------
               if((abase.eq.1).and.(cbase.eq.1)) then
                   if(istat2.gt.0) 
     *                write(ncwu,*)' traccio la linea(2):va-->vc'
               if(idr.ne.4) call plosg(va,vc,0)
            endif
            if((bbase.eq.1).and.(dbase.eq.1)) then
               if(istat2.gt.0) 
     *                write(ncwu,*) ' traccio la linea(2):vb-->vd'
               if(idr.ne.4) call plosg(vb,vdd,0)
            endif
c--fine loop sui tratti del legame
         enddo
c--fine disegno bond
         call plpup
c--fine loop sui bond
      enddo
      return
      end
c
code for fint
      subroutine fint(va,vb,vc,vd,ti,qj)
c--controllo di intersezioni fra le generatrici dei coni
c  linea 1 : (vb - va)
c  linea 2 : (vd - vc)
c
      dimension va(3),vb(3),vc(3),vd(3)
c--
      zero=0.001
      dx1=vb(1)-va(1)
      dy1=vb(2)-va(2)
      dx2=vd(1)-vc(1)
      dy2=vd(2)-vc(2)
      det=dx2*dy1-dx1*dy2
      if(abs(det).lt.zero) go to 10
      ti=(dx2*(vc(2)-va(2))-dy2*(vc(1)-va(1)))/det
      qj=(dx1*(vc(2)-va(2))-dy1*(vc(1)-va(1)))/det
      return
   10 continue
      ti=-10
      qj=-10
      return
      end
c
code for ordv
      subroutine ordv(inum,icoun,v,jfus)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension v(100)
c--
      do 100 i=1,icoun
      if(v(i).lt.0) v(i)=0.
      if(v(i).gt.1) v(i)=1.
  100 continue
      if(istat2.gt.1) then
         write(ncwu,101) (v(i),i=1,icoun)
  101    format(1x,'v=',10f10.5)
      endif
      if(inum.eq.2) go to 1000
c-- ordinamento posti pari
      do 10 i=2,icoun-2,2
      do 15 i1=i+2,icoun,2
      if(v(i).le.v(i1)) go to 5
      com1=v(i)
      v(i)=v(i1)
      v(i1)=com1
    5 continue
   15 continue
   10 continue
      if(istat2.gt.1) then
       write(ncwu,1) (v(i),i=1,icoun)
    1  format(1x,'v-',10f10.5)
      endif
c-- ordinamento posti dispari
      do 20 i=1,icoun-3,2
      do 25 i1=i+2,icoun-1,2
      if(v(i).le.v(i1)) go to 70
      com1=v(i)
      v(i)=v(i1)
      v(i1)=com1
   70 continue
   25 continue
   20 continue
c-------------
      if(istat2.gt.1) then
       write(ncwu,1) (v(i),i=1,icoun)
      endif
c-- fusione di intervalli
 1000 continue
      jfus=0.
      j=2
   40 continue
      jf=inum+2
   45 continue
      if(j-jf) 50,50,65
   50 continue
      if(v(j).lt.v(j+1)) go to 60
      do 55 j1=j,inum+4
      v(j1)=v(j1+2)
   55 continue
      jfus=jfus+1
      inum=inum-2
c     icoun=icoun-2
      go to 40
   60 continue
      j=j+2
      go to 45
   65 continue
      return
      end
!      
!======================================================================
!--SKETCH BLOCK--------------------------------------------------------
!======================================================================
!code for sketch
      subroutine sketch(ipr)
!--disegno sketch
!  ipr = 0  disegno effettivamente
!        1  non disegno (serve per il calcolo delle label)
!
      USE General
      USE Plotter
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      eps0=0.1
c--set default
      ivett=0
      zero=0.001
      dvd= 1.5*zmax
      if(istat2.gt.0) call cwrli('SKETCH')
!--disegna le linee
      call intrer(ipr)
      return
      end
c
code for intrer
      subroutine intrer(ipr)
!--disegno linee
!  ipr = 0  disegno effettivamente
!        1  non disegno (serve per il calcolo delle label)
!
      USE General
      USE Molcom
      USE Atomi
      USE Plotter
!
      character*80 AtName
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      dimension iname(4)
      dimension va(3),vb(3),vc(3),vdd(3),vq(3),vt(3),ob1(3),ob2(3)
     *,v1(3),v2(3)
c--
c--reset color black
      ipen=0
      if(ipr.eq.0) call cpen(ipen)
      do i=1,NNLeg
         i1=LEdum(1,i)
         i2=LEdum(2,i)
!             
         va(:)=0.
         vb(:)=0.
         vc(:)=0.
         v1(:)=0.
         v2(:)=0.
!         
         ifus=0
         nfli=0   
         nFloc=1
         int=0
         va(1:3)=xyzsPlo(1:3,i1)
         vb(1:3)=xyzsPlo(1:3,i2)
!--inizializzo interruzioni
         Finter(nFloc)=0.
         Finter(nFloc+1)=0.
         nFloc=nFloc+2
!--lop sui legami 
         do ii=1,NNLeg
            i3=LEdum(1,ii)
            i4=LEdum(2,ii)
            if((i1.eq.i3).and.(i2.eq.i4)) cycle
            vc(1:3)=xyzsPlo(1:3,i3)
            vdd(1:3)=xyzsPlo(1:3,i4)
c            call cross(ia,ib,icc,id,va,vb,vc,vdd,tpiu,tmeno,t,q,
            call cross(i1,i2,i3,i4,va,vb,vc,vdd,tpiu,tmeno,xt,q,
     *                 icros,teta)
            if(icros.ne.1) cycle
c-- ab interrotto: memorizzazione punti di intersezione
            int=int+2
            if((tmeno.lt.0).and.(tpiu.lt.0)) go to 20
            if((tmeno.gt.1).and.(tpiu.gt.1)) go to 25
            go to 30
   20       continue
            tmeno=0.
            tpiu=0.
            go to 30
   25       continue
            tmeno=1.
            tpiu=1.
   30       continue
            Finter(nFloc)=tmeno
            Finter(nFloc+1)=tpiu
            nFloc=nFloc+2
         enddo
         if(ipr.eq.0)  then 
            write(AtName,331) aLabPlo(i1),aLabPlo(i2)
331         format('bond: ',a8,'<---> ',a8)
            call plwrit(AtName)
            xo=va(1)
            yo=va(2)
            call plpoa(xo,yo)
            if(int.le.0) then    
               call plosg(va,vb,0)
            else
               Finter(nFloc)=1.
               Finter(nFloc+1)=1.
               nFloc=nFloc+2
c--
               call ord(Finter,int,nfli,ifus)
               nflj=int+4-2*ifus
c--
               do j=2,nflj-2,2
                  v1(1)=va(1)+(vb(1)-va(1))*Finter(nfli+j)
                  v1(2)=va(2)+(vb(2)-va(2))*Finter(nfli+j)
                  v1(3)=va(3)
                  v2(1)=va(1)+(vb(1)-va(1))*Finter(nfli+j+1)
                  v2(2)=va(2)+(vb(2)-va(2))*Finter(nfli+j+1)
                  v2(3)=vb(3)
                  call plosg(v1,v2,0)
               enddo
            endif
c--fine disegno bond
            call plpup
         endif
      enddo
      return
      end
c
code for cross
      subroutine cross(ia,ib,ic,id,va,vb,vc,vd,tpiu,tmeno,t,q,icros,
     *teta)
c--     
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension va(3),vb(3),vc(3),vd(3),vt(3),vq(3)
c
      zero=0.001
      do i=1,3
      vt(i)=0.
      vq(i)=0.
      enddo
      detxy=0.
      ich1=0
      ich2=0
      dx1=0.
      dx2=0.
      dy1=0.
      dy2=0.
      if(abs(va(1)-vb(1)).lt.zero) va(1)=vb(1)
      if(va(1)-vb(1)) 40,15,10
   10 continue
      ich1=1
      call change(va,vb)
      go to 40
   15 continue
      if(va(2)-vb(2)) 20,20,25
   20 continue
      ich1=1
      call change(va,vb)
   25 continue
      if(vc(2)-vd(2)) 30,30,35
   30 continue
      call change(vc,vd)
   35 continue
      go to 65
   40 continue
      if(abs(vc(1)-vd(1)).lt.zero) vc(1)=vd(1)
      if(vc(1)-vd(1))60,50,45
   45 continue
      ich2=1
      call change(vc,vd)
      go to 60
   50 continue
      if(vc(2)-vd(2)) 55,55,60
   55 continue
      ich2=1
      call change(vc,vd)
   60 continue
   65 continue
      dx1=vb(1)-va(1)
      dx2=vd(1)-vc(1)
      dy1=vb(2)-va(2)
      dy2=vd(2)-vc(2)
      detxy=dx2*dy1-dy2*dx1
      if(abs(detxy).le.zero) go to 85
      if((ia.eq.ic).or.(ia.eq.id)) go to 80
      if((ib.eq.ic).or.(ib.eq.id)) go to 80
      t=(dx2*(vc(2)-va(2))-dy2*(vc(1)-va(1)))/detxy
      q=(dx1*(vc(2)-va(2))-dy1*(vc(1)-va(1)))/detxy
      if((t.ge.0.).and.(t.le.1.)) go to 70
      go to 80
   70 continue
      vt(1)=va(1)+t*(vb(1)-va(1))
      vt(2)=va(2)+t*(vb(2)-va(2))
      vt(3)=va(3)+t*(vb(3)-va(3))
      vq(1)=vt(1)
      vq(2)=vt(2)
      vq(3)=vc(3)+q*(vd(3)-vc(3))
      if(vt(3)-vq(3)) 75,80, 80
   75 continue
      call obsg(va,vb,vc,vd,t,q,teta,tpiu,tmeno,ich1,ich2)
c     if(ich1.eq.1) call change(va,vb)
c     if(ich2.eq.1) call change(vc,vd)
      if(abs(tpiu-tmeno).le.zero) go to 80
      icros=1
      return
   80 continue
      icros=0
c     if(ich1.eq.1) call change(va,vb)
c     if(ich2.eq.1) call change(vc,vd)
      return
   85 continue
      if((abs(dx1).gt.zero).and.(abs(dx2).gt.zero)) go to 90
      go to 115
   90 continue
c-- verifica parallelismo
      r1=(vb(2)-va(2))/(vb(1)-va(1))
      r2=(vd(2)-vc(2))/(vd(1)-vc(1))
      p1=va(2)-va(1)*r1
      p2=vc(2)-vc(1)*r2
      if(abs(p1-p2)-zero) 95,95,  110
   95 continue
c-- verifica appartenenza di c/d al segmento ab/ba
      tc=(vc(1)-va(1))/(vb(1)-va(1))
      td=(vd(1)-va(1))/(vb(1)-va(1))
      if((tc.lt.0).or.(tc.gt.1)) go to 100
      go to 105
  100 if((td.lt.0).or.(td.gt.1)) go to 110
  105 continue
      icros=1
      call paral(va,vb,vc,vd,p1,r1,tmeno,tpiu)
      return
  110 continue
c-- le rette sono parallele ma i segnenti non si oscurano
      icros=0
      go to 150
  115 continue
c-- rette // asse y : x=fk1, x=fk2
      fk1=va(1)
      fk2=vc(1)
      if(abs(fk1-fk2).le.zero) go to 120
      go to 110
  120 continue
c-- verifica di appertenenza di c/d al segmento ab/ba
      if(abs(vb(2)-va(2)).gt.zero) go to 175
      go to 185
 175  continue
      tc=(vc(2)-va(2))/(vb(2)-va(2))
      td=(vd(2)-va(2))/(vb(2)-va(2))
      if((tc.lt.0).or.(tc.gt.1)) go to 125
      go to 130
  125 if((td.lt.0).or.(td.gt.1)) go to 110
  130 continue
c-- rette // asse y con sovrapposizione
      if(abs(vb(2)-va(2)).gt.zero) goto 140
  135 continue
      r1=-6000.
      p1=va(1)
      go to 145
  140 continue
      r1=6000.
      p1=va(1)
  145 continue
      icros=1
      call paral(va,vb,vc,vd,p1,r1,tmeno,tpiu)
      go to 150
  185 continue
c     tc=(vc(3)-va(3))/(vb(3)-va(3))
c     td=(vd(3)-va(3))/(vb(3)-va(3))
  150 continue
      return
      end
c
code for paral
      subroutine paral(va,vb,vc,vd,p1,r1,tpiu,tmeno)
      USE Trigonometria
c--
      double precision dx1,dx2,dy1,dy2,detxy
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension va(3),vb(3),vc(3),vd(3),vz(3),v(3),
     *va1(3),vb1(3),vc1(3),vd1(3),vcp(3),vdp(3),vm1(3),vm(3),
     *vci(3),vdi(3),rot(3,3),rotin(3,3),obs1(3),obs2(3),
     *ob1(3),ob2(3),vas(3),vbs(3),vcs(3),vds(3)
      dimension dummy(3,3)
c
      zero=0.001
      do i=1,3
      do j=1,3
      dummy(i,j)=0.0
      enddo
      enddo
      teta=atan(r1)
      nm=0
      nc=0
      nd=0
      ndzc=0
      ndzd=0
      vz(1)=0.
      vz(2)=0.
      vz(3)=1.
      v(1)=0.
      v(2)=p1
      v(3)=0.
      do 5 i=1,3
      vas(i)=va(i)-v(i)
      vbs(i)=vb(i)-v(i)
      vcs(i)=vc(i)-v(i)
      vds(i)=vd(i)-v(i)
    5 continue
      fi=-teta
      call mrot(vz,fi,rot)
      call vrgv(vas,rot,va1)
      call vrgv(vbs,rot,vb1)
      call vrgv(vcs,rot,vc1)
      call vrgv(vds,rot,vd1)
      dx1n=vb1(1)-va1(1)
      dx2n=vd1(1)-vc1(1)
      dz1n=vb1(3)-va1(3)
      dz2n=vd1(3)-vc1(3)
      detn=dx2n*dz1n-dz2n*dx1n
      if(abs(detn)-zero) 25,25,10
   10 continue
      t1=(dx2n*(vc1(3)-va1(3))-dz2n*(vc1(1)-va1(1)))/detn
      q1=(dx1n*(vc1(3)-va1(3))-dz1n*(vc1(1)-va1(1)))/detn
      if((t1.gt.0).and.(t1.lt.1)) go to 15
      go to 25
   15 if((q1.gt.0).and.(q1.lt.1)) go to 20
      go to 25
   20 continue
      nm=1
      go to 30
   25 continue
      nm=0
   30 continue
      tc1=(vc1(1)-va1(1))/(vb1(1)-va1(1))
      if((tc1.gt.0).and.(tc1.lt.1)) nc=1
      td1=(vd1(1)-va1(1))/(vb1(1)-va1(1))
      if((td1.gt.0).and.(td1.lt.1)) nd=1
      r=(vb1(3)-va1(3))/(vb1(1)-va1(1))
      p=va1(3)-va1(1)*r
      vcp(3)=vc1(1)*r+p
      vdp(3)=vd1(1)*r+p
      if(abs(vc1(3)-vcp(3))-zero) 40,40,35
   35 continue
      if(vc1(3)-vcp(3)) 40,40,45
   40 ndzc=0
      go to 50
   45 ndzc=1
   50 continue
      if(abs(vd1(3)-vdp(3))-zero) 60,60,55
   55 continue
      if(vd1(3)-vdp(3)) 60,60,65
   60 ndzd=0
      go to 70
   65 ndzd=1
   70 continue
      do 75 i=1,2
      vcp(i)=vc1(i)
      vdp(i)=vd1(i)
   75 continue
      vm1(1)=va1(1)+t1*(vb1(1)-va1(1))
      vm1(2)=va1(2)+t1*(vb1(2)-va1(2))
      vm1(3)=va1(3)+t1*(vb1(3)-va1(3))
      if((va1(1).ge.vb1(1)).and.(vc1(1).ge.vd1(1))) iset=1
      if((va1(1).ge.vb1(1)).and.(vc1(1).le.vd1(1))) iset=2
      if((va1(1).le.vb1(1)).and.(vc1(1).ge.vd1(1))) iset=3
      if((va1(1).le.vb1(1)).and.(vc1(1).le.vd1(1))) iset=4
      call abcd(va1,vb1,vc1,vd1,vm1,vcp,vdp,
     *nm,nc,nd,ndzc,ndzd,iset,nobs,obs1,obs2)
      ndim=3
      nn1=0
      call matin(rot,ndim,dummy,nn1,det)
      call vrgv(obs1,rot,ob1)
      call vrgv(obs2,rot,ob2)
      call vrgv(vm1,rot,vm)
      call vrgv(vcp,rot,vci)
      call vrgv(vdp,rot,vdi)
      do 80 i=1,3
      ob1(i)=ob1(i)+v(i)
      ob2(i)=ob2(i)+v(i)
      vm(i)=vm(i)+v(i)
      vci(i)=vci(i)+v(i)
      vdi(i)=vdi(i)+v(i)
   80 continue
c-- calcolo intervalli tmeno---tpiu nel caso di sovrapposizioni
      if(ob1(1)-ob2(1)) 95,85,95
   85 continue
      if(ob2(2)-ob1(2)) 100,90,100
   90 continue
      if(ob2(3)-ob1(3)) 105,110,105
   95 continue
      tmeno=(ob1(1)-va(1))/(vb(1)-va(1))
      tpiu=(ob2(1)-va(1))/(vb(1)-va(1))
      go to 115
  100 continue
      tmeno=(ob1(2)-va(2))/(vb(2)-va(2))
      tpiu=(ob2(2)-va(2))/(vb(2)-va(2))
      go to 115
  105 continue
      tmeno=(ob1(3)-va(3))/(vb(3)-va(3))
      tpiu=(ob2(3)-va(3))/(vb(3)-va(3))
      go to 115
  110 continue
      return
  115 continue
      return
      end
c
code for abcd
      subroutine abcd(va1,vb1,vc1,vd1,vm1,vcp,vdp,
     *nm,nc,nd,ndzc,ndzd,iset,nobs,obs1,obs2)
c--
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension va1(3),vb1(3),vm1(3),vcp(3),vdp(3),obs1(3),obs2(3),
     *vc1(3),vd1(3)
c
      do i=1,3
      obs1(i)=0.
      obs2(i)=0.
      enddo
      xa=va1(1)
      xb=vb1(1)
      xc=vc1(1)
      xd=vd1(1)
      xm=vm1(1)
      nobs=0
      if((iset.eq.2).or.(iset.eq.3)) call change(va1,vb1)
      if(nm) 170,10,170
   10 if(nc) 140,15,140
   15 if(nd) 120,20,120
   20 if(ndzc) 65,25,65
   25 if(ndzd) 35,30,35
   30 go to 280
   35 continue
      if(iset.eq.1) go to 40
      if(iset.eq.2) go to 45
      if(iset.eq.3) go to 50
      if(iset.eq.4) go to 55
   40 continue
      if((xm.ge.xa).and.(xb.ge.xd)) go to 60
      go to 280
   45 continue
      if((xm.le.xb).and.(xd.ge.xa)) go to 60
      go to 280
   50 continue
      if((xm.ge.xb).and.(xd.le.xa)) go to 60
      go to 280
   55 continue
      if((xm.le.xa).and.(xb.le.xd)) go to 60
      go to 280
   60 continue
c-- 00001/00010/00011
      nobs=1
      obs1(1)=vb1(1)
      obs1(2)=vb1(2)
      obs1(3)=vb1(3)
      obs2(1)=va1(1)
      obs2(2)=va1(2)
      obs2(3)=va1(3)
      if((iset.eq.1).or.(iset.eq.3)) go to 285
      call change(obs1,obs2)
      go to 285
   65 continue
      if(ndzd) 95,70,95
   70 continue
      if(iset.eq.1) go to 75
      if(iset.eq.2) go to 80
      if(iset.eq.3) go to 85
      if(iset.eq.4) go to 90
   75 continue
      if((xm.le.xb).and.(xc.ge.xa)) go to 60
      go to 280
   80 continue
      if((xm.ge.xa).and.(xc.le.xb)) go to 60
      go to 280
   85 continue
      if((xm.le.xa).and.(xc.ge.xb)) go to 60
      go to 280
   90 continue
      if((xm.ge.xb).and.(xc.le.xa)) go to 60
      go to 280
   95 continue
      if(iset.eq.1) go to 100
      if(iset.eq.2) go to 105
      if(iset.eq.3) go to 110
      if(iset.eq.4) go to 115
  100 continue
      if((xd.le.xb).and.(xc.ge.xa)) go to 60
      go to 280
  105 continue
      if((xc.le.xb).and.(xd.ge.xa)) go to 60
      go to 280
  110 continue
      if((xd.le.xa).and.(xc.ge.xb)) go to 60
      go to 280
  115 continue
      if((xc.le.xa).and.(xd.ge.xb)) go to 60
      go to 280
  120 continue
      if(ndzc) 135,125,135
  125 if(ndzd) 130,30,130
  130 continue
c-- 00101/00111
      nobs=1
      obs1(1)=vdp(1)
      obs1(2)=vdp(2)
      obs1(3)=vdp(3)
      obs2(1)=va1(1)
      obs2(2)=va1(2)
      obs2(3)=va1(3)
      if((iset.eq.1).or.(iset.eq.3)) go to 285
      call change(obs1,obs2)
      go to 285
  135 continue
      if(ndzd) 130,30,130
  140 continue
      if(nd) 155,145,155
  145 if(ndzc) 150,30,150
  150 continue
c-- 01010/01011
      nobs=1
      obs1(1)=vb1(1)
      obs1(2)=vb1(2)
      obs1(3)=vb1(3)
      obs2(1)=vcp(1)
      obs2(2)=vcp(2)
      obs2(3)=vcp(3)
      if((iset.eq.1).or.(iset.eq.3)) go to 285
      call change(obs1,obs2)
      go to 285
  155 continue
      if(ndzc) 160,30,160
  160 if(ndzd) 165,30,165
  165 continue
c-- 01111
      nobs=1
      obs1(1)=vdp(1)
      obs1(2)=vdp(2)
      obs1(3)=vdp(3)
      obs2(1)=vcp(1)
      obs2(2)=vcp(2)
      obs2(3)=vcp(3)
      if((iset.eq.1).or.(iset.eq.3)) go to 285
      call change(obs1,obs2)
      go to 285
  170 continue
      if(nc) 225,175,225
  175 if(nd) 205,180,205
  180 if(ndzc) 195,185,195
  185 if(ndzd) 190,30,190
  190 continue
c-- 10001/11001
      nobs=1
      obs1(1)=vb1(1)
      obs1(2)=vb1(2)
      obs1(3)=vb1(3)
      obs2(1)=vm1(1)
      obs2(2)=vm1(2)
      obs2(3)=vm1(3)
      if((iset.eq.1).or.(iset.eq.3)) go to 285
      call change(obs1,obs2)
      go to 285
  195 continue
      if(ndzd) 30,200,30
  200 continue
c-- 10010/10110
      nobs=1
      obs1(1)=vm1(1)
      obs1(2)=vm1(2)
      obs1(3)=vm1(3)
      obs2(1)=va1(1)
      obs2(2)=va1(2)
      obs2(3)=va1(3)
      if((iset.eq.1).or.(iset.eq.3)) go to 285
      call change(obs1,obs2)
      go to 285
  205 continue
      if(ndzc) 220,210,220
  210 if(ndzd) 215,30,215
  215 continue
c-- 10101/11101
      nobs=1
      obs1(1)=vdp(1)
      obs1(2)=vdp(2)
      obs1(3)=vdp(3)
      obs2(1)=vm1(1)
      obs2(2)=vm1(2)
      obs2(3)=vm1(3)
      if((iset.eq.1).or.(iset.eq.3)) go to 285
      call change(obs1,obs2)
      go to 285
  220 continue
      if(ndzd) 30,200,30
  225 continue
      if(nd) 255,230,255
  230 if(ndzc) 235,245,235
  235 if(ndzd) 30,240,30
  240 continue
c-- 11010/11110
      nobs=1
      obs1(1)=vm1(1)
      obs1(2)=vm1(2)
      obs1(3)=vm1(3)
      obs2(1)=vcp(1)
      obs2(2)=vcp(2)
      obs2(3)=vcp(3)
      if((iset.eq.1).or.(iset.eq.3)) go to 285
      call change(obs1,obs2)
      go to 285
  245 continue
      if(ndzd) 250,30,250
  250 continue
      go to 190
  255 continue
      if(ndzc) 270,260,270
  260 if(ndzd) 265,30,265
  265 continue
      go to 215
  270 continue
      if(ndzd) 30,275,30
  275 continue
      go to 240
  280 continue
      if((iset.eq.2).or.(iset.eq.3)) call change(va1,vb1)
      return
  285 continue
      if((iset.eq.2).or.(iset.eq.3)) call change(va1,vb1)
      return
      end
c
code for obsg
      subroutine obsg(va,vb,vc,vdd,tt,q,teta,tpiu,tmeno,ich1,ich2)
      USE Trigonometria
      USE Plotter
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension va(3),vb(3),vc(3),vdd(3)
c
      umq=1-q
      upq=1+q
      qb=0.
      qb1=0.
      tpiu=0.
      tmeno=0.
      qpiu=0.
      qmeno=0.
      call lngtp(va,vb,d1)
      call lngtp(vc,vdd,d2)
      call anco(va,vb,ac1)
      call anco(vc,vdd,ac2)
      call ang2(ac1,ac2,teta)
      if((q.gt.0).and.(q.lt.1)) go to 5
      go to 155
    5 continue
      if(q.gt.0.5) go to 10
      go to 60
   10 continue
c-- 0.5<q<1
      teta0=atan2(eps0,umq)
      teta1=atan2(eps0,q)
      teta2=pi-teta0
      teta3=pi-teta1
      if((teta.gt.0).and.(teta.le.teta1)) go to 15
      go to 20
   15 continue
      qb=umq/cos(teta)
      qb1=q/cos(teta)
      go to 145
   20 continue
      if((teta.gt.teta1).and.(teta.lt.teta0)) go to 25
      go to 30
   25 continue
      qb=umq/cos(teta)
      qb1=eps0/sin(teta)
      go to 145
   30 continue
      if((teta.ge.teta0).and.(teta.le.teta2)) go to 35
      go to 40
   35 continue
      qb=eps0/sin(teta)
      qb1=eps0/sin(teta)
      go to 145
   40 continue
      if((teta.gt.teta2).and.(teta.le.teta3)) go to 45
      go to 50
   45 continue
      qb=-umq/cos(teta)
      qb1=eps0/sin(teta)
      go to 145
   50 continue
      if((teta.gt.teta3).and.(teta.lt.pi)) go to 55
      return
   55 continue
      qb=-umq/cos(teta)
      qb1=-q/cos(teta)
      go to 145
   60 continue
      if(q.lt.0.5) go to 65
      if(q.eq.0.5) go to 115
   65 continue
c-- 0<q<0.5
      teta0=atan2(eps0,umq)
      teta1=atan2(eps0,q)
      teta2=pi-teta1
      teta3=pi-teta0
      if((teta.gt.0).and.(teta.le.teta0)) go to 70
      go to 75
   70 continue
      qb=umq/cos(teta)
      qb1=q/cos(teta)
      go to 145
   75 continue
      if((teta.gt.teta0).and.(teta.lt.teta1)) go to 80
      go to 85
   80 continue
      qb=eps0/sin(teta)
      qb1=q/cos(teta)
      go to 145
   85 continue
      if((teta.ge.teta1).and.(teta.le.teta2)) go to 90
      go to 95
   90 continue
      qb=eps0/sin(teta)
      qb1=eps0/sin(teta)
      go to 145
   95 continue
      if((teta.gt.teta2).and.(teta.le.teta3)) go to 100
      go to 105
  100 continue
      qb=eps0/sin(teta)
      qb1=-q/cos(teta)
      go to 145
  105 continue
      if((teta.gt.teta3).and.(teta.lt.pi)) go to 110
      return
  110 continue
      qb=-umq/cos(teta)
      qb1=-q/cos(teta)
      go to 145
  115 continue
c-- q=0.5
      teta0=atan2(eps0,umq)
      teta1=pi-teta0
      if((teta.gt.0).and.(teta.le.teta0)) go to 120
      go to 125
  120 continue
      qb=q/cos(teta)
      qb1=qb
      go to 150
  125 continue
      if((teta.gt.teta0).and.(teta.le.teta1)) go to 130
      go to 135
  130 continue
      qb=eps0/sin(teta)
      qb1=qb
      go to 150
  135 continue
      if((teta.gt.teta1).and.(teta.lt.pi)) go to 140
      return
  140 continue
      qb=-umq/cos(teta)
      qb1=qb
      go to 150
  145 continue
      qpiu=q+qb
      qmeno=q-qb1
      tpiu=(qpiu-q)*d2/d1+tt
      tmeno=(qmeno-q)*d2/d1+tt
      return
  150 continue
      qpiu=q+qb
      qmeno=q-qb1
      tpiu=(qpiu-q)*d2/d1+tt
      tmeno=(qmeno-q)*d2/d1+tt
      return
  155 continue
      if((q.eq.0).or.(q.eq.1)) go to 235
      if(q.lt.0) go to 195
c-- q>1
      teta0=atan2(eps0,-umq)
      teta1=atan2(eps0,q)
      teta2=pi-teta0
      teta3=pi-teta1
      if((teta.gt.0).and.(teta.le.teta1)) go to 160
      go to 165
  160 continue
      qb1=q/cos(teta)
      qb=-umq/cos(teta)
      go to 365
  165 continue
      if((teta.gt.teta1).and.(teta.lt.teta0)) go to 170
      go to 175
  170 continue
      qb1=eps0/sin(teta)
      qb=-umq/cos(teta)
      go to 365
  175 continue
      if((teta.gt.teta2).and.(teta.le.teta3)) go to 180
      go to 185
  180 continue
      qb1=eps0/sin(teta)
      qb=umq/cos(teta)
      go to 365
  185 continue
      if((teta.gt.teta3).and.(teta.lt.pi)) go to 190
      qb1=0.
      qb=0.
      go to 365
  190 continue
      qb1=-q/cos(teta)
      qb=umq/cos(teta)
      go to 365
  195 continue
c--q<0
      teta0=atan2(eps0,umq)
      teta1=atan2(eps0,-q)
      teta2=pi-teta1
      teta3=pi-teta0
      if((teta.gt.0).and.(teta.le.teta0)) go to 200
      go to 205
  200 continue
      qb1=-q/cos(teta)
      qb=umq/cos(teta)
      go to 350
  205 continue
      if((teta.gt.teta0).and.(teta.lt.teta1)) go to 210
      go to 215
  210 continue
      qb1=-q/cos(teta)
      qb=eps0/sin(teta)
      go to 350
  215 continue
      if((teta.gt.teta2).and.(teta.le.teta3)) go to 220
      go to 225
  220 continue
      qb1=q/cos(teta)
      qb=eps0/sin(teta)
      go to 350
  225 continue
      if((teta.gt.teta3).and.(teta.lt.pi)) go to 230
      qb1=0.
      qb=0.
      go to 350
  230 continue
      qb1=q/cos(teta)
      qb=-umq/cos(teta)
      go to 350
  235 continue
c-q=0
      if(q.eq.0) go to 240
      go to 280
  240 continue
      teta0=atan2(eps0,1.)
      teta3=pi-teta0
      if((teta.gt.0).and.(teta.le.teta0)) go to 245
      go to 250
  245 continue
      qb=1/cos(teta)
      qb1=0.
      go to 320
  250 continue
      if(abs(teta-pi/2).le.zero) go to 255
      go to 260
  255 continue
      qb1=eps0
      qb=eps0
      go to 320
  260 continue
      if((teta.gt.teta0).and.(teta.le.teta3)) go to 265
      go to 270
  265 continue
      qb1=0.
      qb=eps0/sin(teta)
      go to 320
  270 continue
      if((teta.gt.teta3).and.(teta.lt.pi)) go to 275
      return
  275 continue
      qb1=0.
      qb=-1/cos(teta)
      go to 320
  280 continue
c-- q=1
      teta1=atan2(eps0,1.)
      teta3=pi-teta1
      if((teta.gt.0).and.(teta.le.teta1)) go to 285
      go to 290
  285 continue
      qb1=eps0/sin(teta)
      qb=0.
      go to 335
  290 continue
      if(abs(teta-pi/2).le.zero) go to 295
      go to 300
  295 continue
      qb=eps0
      qb1=eps0
      go to 335
  300 continue
      if((teta.gt.teta1).and.(teta.le.teta3)) go to 305
      go to 310
  305 continue
      qb1=eps0/sin(teta)
      qb=0.
      go to 335
  310 continue
      if((teta.gt.teta3).and.(teta.lt.pi)) go to 315
      return
  315 continue
      qb1=-1/cos(teta)
      qb=0.
      go to 335
  320 continue
      if((teta.ge.0).and.(teta.le.pi/2)) go to 325
      qpiu=q-qb
      qmeno=q-qb1
      go to 330
  325 continue
      qpiu=q+qb
      qmeno=q+qb1
  330 continue
      tpiu=(qpiu-q)*d2/d1+tt
      tmeno=(qmeno-q)*d2/d1+tt
      return
  335 continue
      if((teta.ge.0).and.(teta.le.pi/2)) go to 340
      qpiu=q+qb
      qmeno=q+qb1
      go to 345
  340 continue
      qpiu=q-qb
      qmeno=q-qb1
  345 continue
      tpiu=(qpiu-q)*d2/d1+tt
      tmeno=(qmeno-q)*d2/d1+tt
      return
  350 continue
      if((teta.ge.0).and.(teta.le.pi/2)) go to 355
      qpiu=q+qb
      qmeno=q+qb1
      go to 360
  355 continue
      qpiu=q+qb
      qmeno=q+qb1
  360 continue
      tpiu=(qpiu-q)*d2/d1+tt
      tmeno=(qmeno-q)*d2/d1+tt
      return
  365 continue
      if((teta.ge.0).and.(teta.le.pi/2)) go to 370
      qpiu=q-qb
      qmeno=q-qb1
      go to 375
  370 continue
      qpiu=q-qb
      qmeno=q-qb1
  375 continue
      tpiu=(qpiu-q)*d2/d1+tt
      tmeno=(qmeno-q)*d2/d1+tt
      return
      end
!
!------------------------------------------------------------------
!--routine speciali
! ----------------------------------------------------------------------
      subroutine ApriViewer(iAction)
c            integer         :: kscrx = 1020
c            integer         :: kscry = 713
c            real            :: p2xs = 640.0
c            real            :: p2ys = 480.0
      USE General
      USE Molcom
!
      if (iAction.eq.1.or.iAction.eq.2) then
          ix1 = 1
          iy1 = 1
          ix2 = kscrx
          iy2 = kscry
          if (iAction.eq.1) then
              Inte = 'Postscript Pre-View'
          else
              Inte = 'HPGL Pre-View'
          endif
          call OpenViewer(ix1,iy1,ix2,iy2,Inte)
      endif
!
      return
      end
!
!------------------------------------------------------------------
!--routine di azione diretta per disegnare
!------------------------------------------------------------------
c
code for inunit
      subroutine inunit(ifilin,ier)
c--inizializzo file di output plotter
c
c
      USE General
      USE Plotter
c!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      character*80 ifilin
      dimension va(3),vb(3)
c--
      ier=0
      call dgintf(iqplot,va,vb,ifilin,0)
      return
      end
c
code for init
      subroutine init(ipen)
c--inizializzazione del plotter
      character*80 ifilin
      dimension va(3),vb(3)
      call dgintf(ipen,va,vb,ifilin,1)
      return
      end
c
code for cpen
      subroutine cpen(ipen)
c--cambia colore di penna
      character*80 ifilin
      dimension va(3),vb(3)
      call dgintf(ipen,va,vb,ifilin,2)
      return
      end
c
code for setline
      subroutine setline(setli)
c--cambia colore di penna
      character*80 ifilin
      dimension va(3),vb(3)
      va(1)=setli
      call dgintf(ipen,va,vb,ifilin,12)
      return
      end
c
code for ctrat
      subroutine ctrat(ilt)
c--cambia tratto della scrittura
      character*80 ifilin
      dimension va(3),vb(3)
      call dgintf(ilt,va,vb,ifilin,3)
      return
      end
c
code for plosg
      subroutine plosg(va,vb,icod)
c-- traccia il segmento che unisce due punti in modo assoluto
      character*80 ifilin
      dimension va(3),vb(3)
      call dgintf(icod,va,vb,ifilin,7)
      return
      end
c
code for symbl
      subroutine symbl(j,pp,w,ncar,ipr)
c-- scrive un numero ncar di caratteri di altezza h ed ampiezza w
c   j     numero d'ordine dell'atomo
c   ipr = 0 scrive label sul disegno
c         1 scrive coordinate label calcolate nel vettore xyLab
c        -1 scrive label sul disegno calcolate dal programma
c
      USE Molcom
      USE Plotter
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      character*80 ifilin
      dimension va(3),vb(3)
      dimension pp(3),px(2)
c
c      write(ncwu,*) ' symbl ipr',ipr
c      m25a=l25+(j-1)*md25
      va(1)=pp(1)
      va(2)=pp(2)
      va(3)=w
      do n=1,3
      vb(n)=va(n)
      enddo
      if(ipr.eq.1) then
c      jj=kshuttle(m25a+50)
c      if(jj.le.0) jj=j
c      write(ncwu,*)'jj=',jj
      xyLab(1,j)=pp(1)/xplo2
      xyLab(2,j)=pp(2)/yplo2
c	xyLab(1,jj)=pp(1)/xplo2
c	xyLab(2,jj)=pp(2)/yplo2
c	write(ncwu,1)'%',(ilbl(i),i=1,10)
c    1 format(1x,a1,'ilbl=',10a1)
c	write(ncwu,3)'%',va,(xyLab(n,jj),n=1,2)
c    3 format(1x,a1,3f10.5,5x,2f6.3)
c	write(ncwu,2) ncar,w,h(1)
c    2	 format(1x,'ncar=',i4,5x,'w=',f10.5,5x,'h=',f10.5)
      else if(ipr.eq.0) then
c	 write(ncwu,*)'ifLabelsVis(j),ipr',ifLabelsVis(j),ipr
!mrmr  22/12/2003
      if (ifLabelsVis(j).ne.0) then
c	    va1=xyLab(1,j)*xplo2s-(xplo2s/2.0)
c	    va2=xyLab(2,j)*yplo2s-(yplo2s/2.0)
c          write(ncwu,'(i5,2f10.3)')j,Finter(m25a+52),Finter(m25a+53)
c          write(ncwu,*)'xplo2s,yplo2s,xplo2,yplo2,scadis,skdk',
c     2    xplo2s,yplo2s,xplo2,yplo2,scadis,skdk
         va1=xyLab(1,j)*xplo2s-(xplo2s/2.0)
         va2=xyLab(2,j)*yplo2s-(yplo2s/2.0)
         va(1)=(va1/scadis)*skdk+(xplo2/2.0)
         va(2)=(va2/scadis)*skdk+(yplo2/2.0)
c	    write(ncwu,1)'$',(ilbl(i),i=1,10)
c	    write(ncwu,3)'$',va,(xyLab(n,j),n=1,2)
         call dgintf(ncar,va,vb,ifilin,8)
      endif
!mrmr  22/12/2003
       else if(ipr.eq.-1) then
c	    write(ncwu,3)'',vb,(xyLab(n,j),n=1,2)
        call dgintf(ncar,vb,va,ifilin,8)
      endif
      return
      end
c
code for poly
      subroutine poly(nlt,at)
      USE Trigonometria
      USE Plotter
c--disegna un poligono di n lati in modo assoluto
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension at(3),va(3),vb(3)
c
      dteta=2*pi/nlt
      teta1=0.
      teta2=teta1+dteta
      do 10 k=1,nlt
      va(1)=at(1)+r(1)*cos(teta1)
      va(2)=at(2)+r(1)*sin(teta1)
      vb(1)=at(1)+r(1)*cos(teta2)
      vb(2)=at(2)+r(1)*sin(teta2)
      call plsa(va,vb)
      teta1=teta2
      teta2=teta2+dteta
   10 continue
      call plpup
      return
      end
c
code for plrst
      subroutine plrst
c-- risetta il plotter nel punto di coordinate 0,0
      character*80 ifilin
      dimension va(3),vb(3)
c
      call dgintf(ilt,va,vb,ifilin,4)
      return
      end
c
code for plsa
      subroutine plsa(va,vb)
c--traccia il segmento che unisce 2 punti in modo assoluto
c  senza sollevare la penna
      character*80 ifilin
      dimension va(3),vb(3)
c
      call dgintf(ilt,va,vb,ifilin,9)
      return
      end
c
code for xstar
      subroutine xstar(at)
      USE Trigonometria
      USE Plotter
c-- traccia un asterisco in modo relativo
c
      dimension at(3),vb(3)
c--
      nlt=8
      teta=0.
      dteta=2*pi/nlt
      do 5 i=1,nlt
      vb(1)=at(1)+r(1)*cos(teta)
      vb(2)=at(2)+r(1)*sin(teta)
      call plosg(at,vb,0)
      teta=teta+dteta
    5 continue
      return
      end
c
code for plpup
      subroutine plpup
c-- alza la penna
c
      character*80 ifilin
      dimension va(3),vb(3)
c
      call dgintf(ilt,va,vb,ifilin,5)
      return
      end
c
code for cirr
      subroutine cirr(xo,yo,r,alfa1,alfa2)
      USE Trigonometria
c-- traccia un arco di circonferenza in modo relativo
c
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension va(3),vb(3)
c
      pi2=pi*2
      zero=0.05
      nlt=100*r
      t=(alfa2-alfa1)*nlt/(pi2)
      n=abs(t)
      del=pi2/nlt
      call plpoa(xo,yo)
      teta1=alfa1
      teta2=teta1+del
      dx=r*cos(teta1)
      dy=r*sin(teta1)
c-----call plpor(dx,dy)
      va(1)=xo+dx
      va(2)=yo+dy
      call plpoa(va(1),va(2))
      do 10 i=1,n
      if(teta2.gt.pi2) teta2=amod(teta2,pi2)
      if(teta1.gt.pi2) teta1=amod(teta1,pi2)
c     if(abs(teta2-alfa2).le.zero) go to 100
      dx=r*(cos(teta2)-cos(teta1))
      dy=r*(sin(teta2)-sin(teta1))
c-----call plosr(dx,dy)
      vb(1)=va(1)+dx
      vb(2)=va(2)+dy
      call plsa(va,vb)
      va(1)=vb(1)
      va(2)=vb(2)
      teta1=teta2
      teta2=teta2+del
   10 continue
c 100 continue
      call plpup
      return
      end
c
code for plpoa
      subroutine plpoa(x,y)
c--posiziona la penna in coordinate assolute
c
      character*80 ifilin
      dimension va(3),vb(3)
c
      va(1)=x
      va(2)=y
      call dgintf(ilt,va,vb,ifilin,10)
      return
      end
c
code for pltbs
      subroutine pltbs(p,pa,pb,pbs,ikost,n)
c-- disegna le basi del tronco di cono
c
      dimension p(3),pbs(3,60),va(3),vb(3),pa(3),pb(3)
c
      if(pa(3)-pb(3)) 1,1,2
    1 continue
      k1=ikost
      k2=n
      go to 10
    2 continue
      k1=ikost
      k2=n
   10 continue
      do 100 j=k1,k2
      do 200 i=1,3
      va(i)=pbs(i,j)+p(i)
      vb(i)=pbs(i,j+1)+p(i)
  200 continue
      call plosg(va,vb,0)
  100 continue
      return
      end
c
code for elpr
      subroutine elpr(xo,yo,a,b,teta0,f1,f2)
      USE Trigonometria
c-- traccia un arco di ellissi
c
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension va(3),vb(3)
c
c      call plpoa(xo,yo)
      fnlt=50*a
      df=twopi/fnlt
      if(f2-f1) 21,21,22
   21 continue
      f2=f2+twopi
   22 continue
      fi=f1
      csfi=cos(fi)
      snfi=sin(fi)
      snt2=sin(fi-teta0)**2
      cst2=cos(fi-teta0)**2
      r=a*b/(sqrt(a*a*snt2+b*b*cst2))
      va(1)=r*csfi+xo
      va(2)=r*snfi+yo
  100 continue
      if(fi-f2) 9,8,8
    9 continue
      fi=fi+df
      if(fi.gt.f2) fi=f2
      csfi=cos(fi)
      snfi=sin(fi)
      snt2=sin(fi-teta0)**2
      cst2=cos(fi-teta0)**2
      r=a*b/(sqrt(a*a*snt2+b*b*cst2))
      vb(1)=r*csfi+xo
      vb(2)=r*snfi+yo
      if(istat2.gt.1) then
      write(ncwu,200) va,vb
  200 format(' va=',3f10.3,' vb=',3f10.3)
      endif
      call plsa(va,vb)
      va(1)=vb(1)
      va(2)=vb(2)
      go to 100
    8 continue
c      call plpup
      return
      end
c
code for pldif
      subroutine pldif(ilt,va,vb)
c-- traccia il segmento che unisce due punti in modo assoluto
      character*80 ifilin
      dimension va(3),vb(3)
c
      call dgintf(ilt,va,vb,ifilin,3)
      call dgintf(ilt,va,vb,ifilin,7)
      return
      end
c
code for plwrit
      subroutine plwrit(ifilin)
      character*(*) ifilin
      dimension va(3),vb(3)
c
      call dgintf(ilt,va,vb,ifilin,11)
      return
      end
c
code for clunit
      subroutine clunit
      character*80 ifilin
      dimension va(3),vb(3)
c
      call dgintf(ilt,va,vb,ifilin,6)
      return
      end
c      
code for dgintf
      subroutine dgintf(mypar,va,vb,ifilin,opcode)
code for graphic interface subroutine for plotting
c grafica schermo pc e file output per Plotter o PostScript
c
c  mypar  : parametro usato in alcuni casi (colore, pennino, no. caratteri...)
c  va(3)  : coordinate iniziali ; (opcode=12 : va(1) = ampiezza linea)
c  vb(3)  : coordinate finali
c  ifilin : nome file output del disegno, stringa commento
c  opcode : codice richiesta operazione
c	    = 0 apertura file di output
c	    = 1 inizializzazione del plot
c	    = 2 cambia pennino (colore)
c	    = 3 cambia tratto della scrittura
c	    = 4 riposiziona il 'pennino' al punto iniziale '0,0'
c	    = 5 alza il pennino
c	    = 6 fine plot (chiude file) (attende un carattere se schermo)
c	    = 7 traccia il segmento che unisce 2 punti in modo assoluto
c	    = 8 se HPGL :
c		scrive un numero ncar di caratteri di altezza h ed ampiezza w
c		se schermo o PS :
c		scrive una stringa di caratteri
c	    = 9 traccia il segmento che unisce 2 punti in modo assoluto
c		(se HPGL senza sollevare la penna)
c	    = 10 posiziona la penna in coordinate assolute
c	    = 11 scrive un commento sul file plotter
c	    = 12 set ampiezza linea (in mm)
c
c  iqplot = 0 schermo
c	    1 file HPGL
c	    2 file PS
c--
      USE General
      USE Plotter
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      integer opcode
      character*16 istr
      dimension va(3),vb(3),rgbpl(3)
      character*1 chtmp
      character*80 linea
      character*80 ifilin
c
Colors:
      dimension colorps(3,7)
      data colorps /
     1 1.0,0.0,0.0, !  current color = red
     2 1.0,0.5,0.0, !  current color = orange
     3 1.0,1.0,0.0, !  current color = yellow
     4 0.0,1.0,0.0, !  current color = green
     5 0.0,0.0,1.0, !  current color = blue
     6 0.5,0.0,1.0, !  current color = indigo
     7 0.5,0.0,0.5 /!  current color = violet
c
c--ms power station fortran (to be checked)
      data iesc/33/
c----end plot block data
c
      call GetMaxScreen(p2xs,p2ys,xplo2s,yplo2s)
c
      if (opcode.eq.0) then
c--apertura file
    5     if (iqplot.gt.0) then
             itype=0
             jform=1
             jop = jopen(ncpu, ifilin,itype,jform,ier)
             if (jop.lt.0) then
              write(ncwu,7110) ier,ifilin
 7110 format(' Error (',i4,')!',' plot file: ',a)
             endif
             return
          endif
          return
      endif
c--
      if(opcode.le.0.or.opcode.gt.12) return
c
      select case (opcode)
c
         case (1)
c  inizializzazione del plotter
            if (iqplot.eq.0) then
c--screen
                ix1 = 0
                iy1 = 0
                ix2 = p2x
                iy2 = iy1 + p2y
                iBianco = 1
                call Rettangolo(ix1,iy1,ix2,iy2,iBianco,iBianco)
            else if (iqplot.eq.1) then
c--plotter
                write(ncpu,12)iesc,iesc
                write(ncpu,13) mypar
                write(ncpu,11)
                write(ncpu,15) itrmn
            else if(iqplot.eq.2) then
c--post_script
c--open init file post_script from Sir2001.ps
                nccf=51
                itype=0
                jform=1
                if (jopen(nccf, psfle,itype,jform,ierr).lt.0) then
                    write(Msg,270) ierr,psfle(1:Lung(psfle))
                    call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
                    ier=-2
                endif
   16           continue
                read(nccf,'(a80)',err=18,end=18)linea
                write(ncpu,'(a80)')linea
                go to 16
   18           continue
                close(nccf)
                setli=0.3
                call setline(setli)
                istroke=0
            endif
            return
c
         case (2)
c--cambia penna (colore)
            jcolore=mypar
            if (iqplot.eq.0) then
c--screen
c---		jcolore=mypar
            else if(iqplot.eq.1) then
c--plotter
                write(ncpu,25) mypar
            else if(iqplot.eq.2) then
c--post_script
                call getRGB(jcolore,rgbpl)    !!!!!!!!!!!!
                write(ncpu,26) (rgbpl(j),j=1,3)
c		if(mypar.eq.0) then
c		write(ncpu,27)
c		else
c		my=mypar-8
c--		write(ncwu,*)'my=',my
c		if(my.le.0) my=1
c		if(my.gt.7) my=7
c		write(ncpu,26) (colorps(j,my),j=1,3)
c		endif
            endif
            return
c
         case (3)
c--cambia tratto della scrittura
            if (iqplot.eq.0) then
c--screen
		if (mypar.eq.0) then
		   ifDashed = 0
		else
		   ifDashed = 1
		endif
            else if(iqplot.eq.1) then
c--plotter
                write(ncpu,35) mypar
            else if(iqplot.eq.2) then
c--post_script
                if (mypar.eq.0) then
                    write(ncpu,36)
                else
                    write(ncpu,37)
                endif
            endif
            return
c
         case (4)
c--resetta il plotter nel punto di coordinate 0,0
            if (iqplot.eq.0) then
c--screen
            else if(iqplot.eq.1) then
c--plotter
                ix1=xplo1
                iy1=yplo1
                write(ncpu,45) ix1,iy1
            else if(iqplot.eq.2) then
c--post_script
                x1=0.
                y1=0.
                write(ncpu,46) x1,y1
            endif
            return
c
         case (5)
c--alza la penna
            if (iqplot.eq.0) then
c--screen
            else if(iqplot.eq.1) then
c--plotter
                write(ncpu,55)
            else if(iqplot.eq.2) then
c--post_script
                write(ncpu,56)
            endif
            return
c
         case (6)
c--fine plot (chiude file se necessario)
            if (iqplot.eq.0) then
c--screen
                continue
            else if(iqplot.eq.1) then
c--plotter
                close(ncpu)
            else if(iqplot.eq.2) then
c--post_script
                write(ncpu,61)
                close(ncpu)
            endif
            return
c
         case (7)
c--traccia il segmento che unisce 2 punti in modo assoluto
            if (iqplot.eq.0) then
c--screen
		jcolor=jcolore
                ix1=va(1)*scax
                iy1c=va(2)*scay
                iy1=p2ys - iy1c
                ix2=vb(1)*scax
                iy2c=vb(2)*scay
                iy2=p2ys - iy2c
c                if(mypar.eq.1) then
c                   write(ncwu,1000) ix1,iy1,ix2,iy2
c 1000              format(75x,2i5,5x,2i5)
c                endif
                call xdrwli(ix1,iy1,ix2,iy2,jcolor)
            else if(iqplot.eq.1) then
c--plotter
                ix1=va(1)*scax
                iy1=va(2)*scay
                ix2=vb(1)*scax
                iy2=vb(2)*scay
                write(ncpu,75) ix1,iy1,ix1,iy1,ix2,iy2
                write(ncpu,'(a)')' pu;'
            else if(iqplot.eq.2) then
c--post_script
                x1=va(1)*scax
                y1=va(2)*scay
                x2=vb(1)*scax
                y2=vb(2)*scay
                write(ncpu,76)x1,y1,x1,y1,x2,y2
            endif
            return
c
         case (8)
c--scrive un numero ncar di caratteri di altezza h ed ampiezza w (PLOTTER)
            ncar=mypar-1
            write(istr,86)(ilbl(i),i=1,ncar+1)
            call shift(istr,len)
            chtmp=istr(1:1)
            call ucase(chtmp)
            istr(1:1)=chtmp
            call xparen(istr)
            call shift(istr,len)
            read (istr,86)(ilbl(i),i=1,ncar+1)
            if (iqplot.eq.0) then
c--screen
		        jcolor=jcolore
                ix1=va(1)*scax
                iy1c=va(2)*scay
                iy1=p2ys - iy1c
                call xdrwts(istr,ix1,iy1,jcolor)
            else if(iqplot.eq.1) then
c--plotter
		        w=va(3)
                ix1=va(1)*scax
                iy1=va(2)*scay
		        write(ncpu,85) ix1,iy1,w,h(1),
     2			       (ilbl(i),i=1,ncar+1),itrmn
            else if(iqplot.eq.2) then
c--post-script
                x1=va(1)*scax
                y1=va(2)*scay
                write(ncpu,87) x1,y1,istr(1:len)
            endif
            return
c
         case (9)
c--traccia il segmento che unisce 2 punti in modo assoluto
c--senza sollevare la penna
            if (iqplot.eq.0) then
c--screen
		        jcolor=jcolore
                ix1=va(1)*scax
                iy1c=va(2)*scay
                iy1=p2ys - iy1c
                ix2=vb(1)*scax
                iy2c=vb(2)*scay
                iy2=p2ys - iy2c
                call xdrwli(ix1,iy1,ix2,iy2,jcolor)
            else if(iqplot.eq.1) then
c--plotter
                ix1=va(1)*scax
                iy1=va(2)*scay
                ix2=vb(1)*scax
                iy2=vb(2)*scay
                write(ncpu,75) ix1,iy1,ix1,iy1,ix2,iy2
            else if(iqplot.eq.2) then
c--post_script
                x1=va(1)*scax
                y1=va(2)*scay
                x2=vb(1)*scax
                y2=vb(2)*scay
                write(ncpu,76)x1,y1,x1,y1,x2,y2
            endif
            return
c
         case (10)
c--posiziona la penna in coordinate assolute
            if (iqplot.eq.0) then
c--screen
                return
            else if(iqplot.eq.1) then
c--plotter
                ix1=va(1)*scax
                iy1=va(2)*scay
                write(ncpu,105) ix1,iy1
            else if(iqplot.eq.2) then
c--post_script
                x1=va(1)*scax
                y1=va(2)*scay
                write(ncpu,106) x1,y1
	    endif
	    return
c
	 case (11)
c--scrive un commento sul file plotter
            if (iqplot.eq.0) then
c--screen
                return
            else if(iqplot.eq.1) then
c--plotter
		return
	    else if(iqplot.eq.2) then
c--post_script
		write(ncpu,'(2h% ,a)') ifilin(1:Lung(ifilin))
	    endif
	    return
c
	 case (12)
c--definisco ampiezza della linea
	    if (iqplot.eq.0) then
c--screen
                return
            else if(iqplot.eq.1) then
c--plotter
		return
	    else if(iqplot.eq.2) then
c--post_script
		if(va(1).gt.5.or.va(1).lt.0.01) va(1)=0.1
		write(ncpu,121) va(1)
	    endif
	    return
      end select
c
   12 format(' in;',a1,'.i;0;17:',a1,'.n;19:',/,
     1       ' vs39.000;',/,' ip;iw;')
   13 format(' sp',i2,';')
   11 format(' sc;')
   15 format(' dt',a1,';')
   25 format(' sp',i2,';')
   26 format(1x,3f6.2,'  setrgbcolor')
   27 format(' 0  setgray')
   35 format(' lt',i3,';')
   36 format('[ ] 0 setdash')
   37 format('[3 5] 6 setdash')
   45 format(' pu',';','pa',2i10,';')
   46 format('newpath',/,2f10.4,' M',/,'stroke')
   55 format(' pu',';')
   56 format('closepath',/,'stroke')
   61 format('showpage')
   75 format(' pa',2i10,';','pd',4i10,';')
   76 format(
     1   2f10.4,' M',/,
     2   2f10.4,' D',/,
     3 2  f10.4,' D')
   85 format(' pa',2i10,';','si',2f10.5,';','lb',11a1)
   86 format(10a1)
   87 format(1x,2f10.4,' M (',a,')  show')
  105 format(' pu',';','pa',2i10,';')
  106 format('newpath',/,
     1       2f10.4,' M')
  121 format(f5.1,' mm setlinewidth')
  270 format(' Open error, code =',i5,' file is ',a)
c
      return
      end
! ----------------------------------------------------------------------
c
code for GetMaxScreen
      subroutine GetMaxScreen(p2xs,p2ys,xplo2s,yplo2s)
      USE Molcom
!
      p2xs = kscrx
      p2ys = kscry
      ratio = p2xs / p2ys
      xplo2s = yplo2s * ratio
      return
      end
c
code for xclear
      subroutine xclear
c-- clear lo schermo
c
      return
      end
c
code for xdrwli
      subroutine xdrwli(ix1,iy1,ix2,iy2,jcolor)
      USE Molcom
      USE Plotter
!
c-- traccia linea
! NO !integer*2 ix1,ix2,iy1,iy2,jcolor
      kcolor = jcolor
      kx1 = ix1
      kx2 = ix2
      ky1 = iy1
      ky2 = iy2
      if(ifDashed.eq.0) then
       call Linea(kx1,ky1,kx2,ky2,kcolor)
      else
       call Linea_dash(kx1,ky1,kx2,ky2,kcolor)
      endif
      return
      end
c
code for xdrwts
      subroutine xdrwts(istr,ix1,iy1,jcolor)
      USE Molcom
!
c-- disegna un testo
! NO !integer*2 ix1,ix2,iy1,iy2,jcolor
      character*16 istr
      ifCanc = 0
      nChars = 0
      kx1 = ix1
      ky1 = iy1
      call Scrivi_plot(istr, nChars, kx1, ky1, ifCanc)
      return
      end
c-----------------------------------------------------------------------
      subroutine Scrivi_plot(Text, nChars, ix1, iy1, ifCanc)
      USE Molcom
!
      character *(*) Text

      if (nChars.gt.0) then
         iz = nChars
      else
         iz = Lung(Text)
      end if
      Lun = LenInPix2(Text,iz, 2)
      if (ifCanc.ne.0) then
         ix2 = ix1 + Lun
         jy1 = iy1 - 1
         jy2 = jy1+fntPixHeight+1
         call Rettangolo (ix1,jy1,ix2,jy2,jBackGround,jBackGround)
      end if
      icl = color_LABS
      call DrawLabel(ix1, iy1, Text, icl, 2)
      return
      end
!------------------------------------------------------------------
!--fine routine di azione diretta per disegnare
!------------------------------------------------------------------
!------------------------------------------------------------------
!-- routine varie
!------------------------------------------------------------------
c
code for bstor
      subroutine bstor(fbiso,el,k)
c  fornisce in b la matrice dell'ellissoide m5-esimo
c
      USE General
      USE Plotter
!
      dimension el(3,3)
c--
      fbiso=bfacPlo(k)
c      el(1:3,1:3) = Ell25(1:3, 1:3, k)
      el(1,1) =  bijPlo(1,k) 
      el(1,2) =  bijPlo(2,k)*0.5 
      el(2,1) =  bijPlo(2,k)*0.5  
      el(1,3) =  bijPlo(3,k)*0.5  
      el(3,1) =  bijPlo(3,k)*0.5  
      el(2,2) =  bijPlo(4,k) 
      el(2,3) =  bijPlo(5,k)*0.5  
      el(3,2) =  bijPlo(5,k)*0.5  
      el(3,3) =  bijPlo(6,k) 
      return
      end
c
code for storb
      subroutine storb(fbiso,el,k)
c--ripristina in store la matrice b(3,3) che rappresenta
c  l'ellissoide
c
      USE General
      USE PLotter
!
      dimension el(3,3)
c--
      bfacPlo(k)=fbiso
c      Ell25(1:3, 1:3, k)=el(1:3,1:3) 
      bijPlo(1,k)  = el(1,1) 
      bijPlo(2,k)  = el(1,2)*2.0 
      bijPlo(2,k)  = el(2,1)*2.0 
      bijPlo(3,k)  = el(1,3)*2.0   
      bijPlo(3,k)  = el(3,1)*2.0  
      bijPlo(4,k)  = el(2,2) 
      bijPlo(5,k)  = el(2,3)*2.0
      bijPlo(5,k)  = el(3,2)*2.0
      bijPlo(6,k)  = el(3,3) 
      return
      end
c
code for bmax
      subroutine bmax
c---
c
      USE General
      USE Atomi
      USE Molcom
      USE Plotter
!
c
      dimension va(3),vb(3)
c--
      bomax=-100
      do i=1,NNLeg
         i1=LEdum(1,i)
         i2=LEdum(2,i)
         va(1:3)=xyzsPlo(1:3,i1)
         vb(1:3)=xyzsPlo(1:3,i2)
         call lngto(va,vb,dist)
         if(dist.gt.bomax) bomax=dist
      enddo
      return
      end
c
code for mrot
      subroutine mrot(ve,fi,xrm)
c**costruisce la matrice di rotazione intorno al vettore ur
      dimension ve(3),xrm(3,3),ven(3),um(3,3)
c
      ncs=0
      call mtrc(ncs,um)
      call normer(ve,um,ven)
      do i=1,3
         call seq(i,j,k)
         xrm(i,i)=ven(i)*ven(i)*(1-cos(fi))+cos(fi)
         xrm(i,j)=ven(i)*ven(j)*(1-cos(fi))-ven(k)*sin(fi)
         xrm(i,k)=ven(i)*ven(k)*(1-cos(fi))+ven(j)*sin(fi)
      enddo
      return
      end
c
code for mtrc
      subroutine mtrc(ncs,u)
c-- ncs=0:   u is the matrix having u(i,i)=1 and u(i,j)=0
c-- ncs=1:   u is the matrix having u(i,i)=-1 and u(i,j)=0
      dimension u(3,3)
c
      do 25 i=1,3
      do 25 j=1,3
      if(i.eq.j) go to 5
      u(i,j)=0.
      go to 20
    5 if(ncs.eq.0) go to 10
      if(ncs.eq.1) go to 15
   10 u(i,j)=1.
      go to 20
   15 u(i,j)=-1.
   20 continue
   25 continue
      return
      end
c
code for lngtp
      subroutine lngtp(x1,x2,d)
      dimension x1(3),x2(3)
c
      d=(x2(1)-x1(1))**2+(x2(2)-x1(2))**2
      d=sqrt(d)
      return
      end
c
code for anco
      subroutine anco(va,vb,ac)
      dimension va(3),vb(3)
c--
      zero=0.001
      dy=vb(2)-va(2)
      dx=vb(1)-va(1)
      if(abs(dx).le.zero) go to 5
      ac=dy/dx
      return
    5 continue
      ac=3000.
      return
      end
c
code for ang2
      subroutine ang2(ac1,ac2,teta)
      USE Trigonometria
c--
      acac=1+ac2*ac1
      tg=ac1-ac2
      if((abs(acac).lt.0.0001).and.(abs(tg).lt.0.0001))return
      teta=atan2(tg,acac)
      if(teta.gt.0) return
      teta=pi-abs(teta)
      return
      end
c
code for change
      subroutine change(v1,v2)
c-- copia il vettore v1 nel vettore v2 e viceversa
      dimension v1(3),v2(3),com(3)
c
      do i=1,3
      com(i)=v1(i)
      v1(i)=v2(i)
      v2(i)=com(i)
      enddo
      return
      end
c
code for ord
      subroutine ord(Finter,inte,nfli,ifus)
c--ordinamento tratti oscuri
c
      dimension Finter(*)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      int=inte
c-- ordinamento posti pari
      do j=1,int+1,2
         do j1=j+2,int+3,2
            if(Finter(nfli+j).le.Finter(nfli+j1)) cycle
            com1=Finter(nfli+j)
            Finter(nfli+j)=Finter(nfli+j1)
            Finter(nfli+j1)=com1
         enddo
      enddo
c-- ordinamento posti dispari
      do j=2,int+2,2
         do j1=j+2,int+4,2
            if(Finter(nfli+j).le.Finter(nfli+j1)) cycle
            com1=Finter(nfli+j)
            Finter(nfli+j)=Finter(nfli+j1)
            Finter(nfli+j1)=com1
         enddo
      enddo
c-- fusione intervalli
      ifus=0
      j=2
   40 continue
      jf=int+2
   45 continue
      if(j-jf) 50,65,65
   50 continue
      if(Finter(nfli+j).lt.Finter(nfli+j+1)) go to 60
      do 55 j1=j,int+4
      Finter(nfli+j1)=Finter(nfli+j1+2)
   55 continue
      ifus=ifus+1
      int=int-2
      go to 40
   60 continue
      j=j+2
      go to 45
   65 continue
      return
      end
c
code for cwrli
      subroutine cwrli(tyt)
c**write list
c tyt vettore titolo
c
      USE General
      USE Atomi
      USE Plotter
      USE Molcom
!
      character*(*) tyt
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension xo(3)
c--
      write(lo,'(a,a,a,i10)') ' start atom list (',tyt,')',natsPlo
      do k=1,natsPlo 
c         if(jFlagAtom(k).gt.0.) then
            icd=selezione(k) 
            i= AdrPloto5(k)
            xo(1:3)=xyzsPlo(1:3,k)
            write(lo,5)k,aLabPlo(k),icd,xo(1:3),bfacPlo(k),
     *           (bijPlo(j,k),j=1,6)
    5       format(1x,i4,')',a8,i5,3f8.4,f8.3,6e10.3)
c         endif
      enddo
      write(lo,*)' end atom list'
      return
      end
c
code for solv2
      subroutine solv2(a,b,c,x1,x2,icod,iwrt)
c--solution of a second degree equation :a*x**2+b*x+c=0
c--x1,x2:solutions
c  icod = 0 non ci sono soluzioni
c         1 unica soluzione
c         2 due soluzioni indipendenti
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      real*8 a,b,c,delta
c--
      icod=0
      if(iwrt.eq.1) then
         write(ncwu,'(a,3d12.4)')'a,b,c',a,b,c
      endif
      if(a.eq.0.0) then
         if(b.eq.0) then
            x1=0.0
            x2=0.0
            return
         else
            icod=1
            x1=-c/b
            x2=x1
            return
         endif
      else
         delta=b**2-4*a*c
         if(iwrt.eq.1) write(ncwu,'(a,d15.4)')'delta:',delta
         if(delta) 1,2,3
    1       continue
            x1=0.0
            x2=0.0
            return
    2       continue
            icod=1
            x1=-b/(2*a)
            x2=x1
            return
    3       continue
            icod=2
            x1=(-b-sqrt(delta))/(2*a)
            x2=(-b+sqrt(delta))/(2*a)
      endif
      return
      end
c
code for solv4
      subroutine solv4(aa,bb,cc,dd,ee,x1,x2,x3,x4,im)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      real*8 a,b,c,d,e,b0,b1,b2,b3,b4,p,q,r,c1,c2,c3
      real*8 z1,z2,z3,z4,z5,z6,z7,z8,f1,f2,q1,q2,q3,q4
      real*8 rmod
      real*8 evlr(3),evli(3)
c--
      zero=0.00001
      x1=0.0
      x2=0.0
      x3=0.0
      x4=0.0
      if(abs(aa).lt.zero) then
      im=4
      return
      endif
      a=aa
      b=bb
      c=cc
      d=dd
      e=ee
      b0=a/a
      b1=b/a
      b2=c/a
      b3=d/a
      b4=e/a
      p=b2-(3.*b1*b1)/8.
      q=(b1*b1*b1)/8.-(b1*b2)/2.+b3
      r=-(3.*b1*b1*b1*b1)/256.+(b1*b1*b2)/16.-(b1*b3)/4.+b4
      c1=p/2.
      c2=(p*p-4.*r)/16.
      c3=-(q*q)/64.
c--  write(ncwu,*)'solv3) c1,c2,c3,im',c1,c2,c3,im
      call solv3(c1,c2,c3,evlr,evli,im)
      if(im.eq.4) return
      if(im.ne.0) go to 100
      if(dabs(evlr(1)).le.zero) evlr(1)=0.
      if(dabs(evlr(2)).le.zero) evlr(2)=0.
      if(dabs(evlr(3)).le.zero) evlr(3)=0.
      evlr(1)=dsqrt(evlr(1))
      evlr(2)=dsqrt(evlr(2))
      evlr(3)=dsqrt(evlr(3))
      z1=evlr(1)+evlr(2)+evlr(3)
      z2=evlr(1)-evlr(2)-evlr(3)
      z3=-evlr(1)+evlr(2)-evlr(3)
      z4=-evlr(1)-evlr(2)+evlr(3)
      z5=-evlr(1)-evlr(2)-evlr(3)
      z6=-evlr(1)+evlr(2)+evlr(3)
      z7=evlr(1)-evlr(2)+evlr(3)
      z8=evlr(1)+evlr(2)-evlr(3)
      f1=z1*z1*z1*z1+p*z1*z1+q*z1+r
      f2=z5*z5*z5*z5+p*z5*z5+q*z5+r
      if(dabs(f1)-dabs(f2)) 1,1,2
    1 q1=z1
      go to 3
    2 q1=z5
    3 f1=z2*z2*z2*z2+p*z2*z2+q*z2+r
      f2=z6*z6*z6*z6+p*z6*z6+q*z6+r
      if(dabs(f1)-dabs(f2)) 4,4,5
    4 q2=z2
      go to 6
    5 q2=z6
    6 f1=z3*z3*z3*z3+p*z3*z3+q*z3+r
      f2=z7*z7*z7*z7+p*z7*z7+q*z7+r
      if(dabs(f1)-dabs(f2)) 7,7,8
    7 q3=z3
      go to 9
    8 q3=z7
    9 f1=z4*z4*z4*z4+p*z4*z4+q*z4+r
      f2=z8*z8*z8*z8+p*z8*z8+q*z8+r
      if(dabs(f1)-dabs(f2)) 10,10,11
   10 q4=z4
      go to 12
   11 q4=z8
   12 continue
      x1=sngl(q1-b1/4.)
      x2=sngl(q2-b1/4.)
      x3=sngl(q3-b1/4.)
      x4=sngl(q4-b1/4.)
      return
  100 continue
      rmod=dsqrt(evlr(2)*evlr(2)+evli(2)*evli(2))
      rmod=dsqrt(rmod)
      if((dabs(evli(2)).lt.0.0001).and.(dabs(evlr(2)).lt.0.0001))
     1  go to 209
      evli2=sngl(evli(2))
      evlr2=sngl(evlr(2))
      teta=atan2(evli2,evlr2)
      teta=teta/2.
      go to 208
  209 if(istat2.gt.0) write(ncwu,211)
  211 format(' attenzione forma indeterminata in  solv4 ',
     * 'atan2(evli(2),evlr(2))',/)
      teta=0.
  208 continue
      evlr(1)=dsqrt(evlr(1))
      z1=evlr(1)+2.*rmod*cos(teta)
      z2=evlr(1)-2.*rmod*cos(teta)
      z3=-evlr(1)-2.*rmod*cos(teta)
      z4=-evlr(1)+2.*rmod*cos(teta)
      f1=z1*z1*z1*z1+p*z1*z1+q*z1+r
      f2=z3*z3*z3*z3+p*z3*z3+q*z3+r
      if(dabs(f1)-dabs(f2)) 13,13,14
   13 q1=z1
      go to 15
   14 q1=z3
   15 f1=z2*z2*z2*z2+p*z2*z2+q*z2+r
      f2=z4*z4*z4*z4+p*z4*z4+q*z4+r
      if(dabs(f1)-dabs(f2)) 16,16,17
   16 q2=z2
      go to 18
   17 q2=z4
   18 continue
      x1=sngl(q1-b1/4.)
      x2=sngl(q2-b1/4.)
      return
      end
c
code for xappro
      subroutine xappro(temp1)
c--approssimo vettore alla stessa cifra decimale
c
      dimension temp1(3)
      character*30 buffer
c
      do i=1,3
         write(buffer,'(f20.5)') temp1(i)
         read(buffer,'(f20.5)') temp1(i)
      enddo
      return
      end
c
code for xchk
      subroutine xchk(va,vb,ier)
c--controllo esatta sovrapposizione
      dimension va(3),vb(3)
c
      ier=0
      zero=0.0001
      dx1=abs(vb(1)-va(1))
      dy1=abs(vb(2)-va(2))
      if(dx1.lt.zero.and.dy1.lt.zero) ier=1
      return
      end
!-----------------------------------------------------------------------
      subroutine xparen(ivet)
c--strip away ( ) characters
c  ivet character  string
c
      character*(*) ivet
      character*1 para,parc,blank
      data para  /'('/
      data parc  /')'/
      data blank /' '/
c
      k1=len(ivet)
      k=k1
      do i=1,k
        if(ivet(i:i).eq.para.or.ivet(i:i).eq.parc) then
          if(i.lt.k) then
            do j=i,k-1
             ivet(j:j)=ivet(j+1:j+1)
            enddo
          endif
          k=k-1
        endif
      enddo
      if(k.lt.k1) then
        do i=k+1,k1
         ivet(i:i)=blank
        enddo
      endif
      return
      end
!-----------------------------------------------------------------------
