      MODULE cc_vet_comm
         real    :: vmedc, vmed2c, wsum, wsum1
         real, allocatable:: work1_cc(:), work2_cc(:)
      END MODULE cc_vet_comm

!=========================================================================
!--14/2/2008   manage MR search in P1 
!              manage MR with centrosymmetric targets
!===========================================================================
!-- sir code for molecular replacement                      Release 2001.01
      subroutine InitMolecular(ier, rMTZ)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Molcom
      USE Grafici
      USE Param
      USE RemoModule
      USE PhaseModule
      USE Align, only : ifAli
      USE Groups, only : nResidStored, nAcid
      USE cc_vet_comm, only: work1_cc, work2_cc
!
      common /cent/ tl(3,4),fs(3,3,24),mlat
      integer :: rMTZ, totModel, Action ! , numeroCatene, Catene(20,5)
      real    :: Rval
      character*256 fileh
      dimension BTotSav(3,3)
      dimension rmtt(3,3)
      
      maybeVet(:) = 0 ; maybeMPE(:) = 0 ; maybeCLA(:) = 0
      SaltaUNK = .true.
      ifExportShelx = 0
      use_pseudo =.false. 
      mlat = 0
      ifViewer = .false.
      jBackGround = 1
      call CambiaBg(jBackGround)
      kLarg = kscrx
      kAlt  = kscry
      stepGR = 1.5 * FntPixHeight / float(kAlt)
      stepGR0 = 1.0
      ier=0
      ifRemoG = 3
      FichierOut = ' '
      idSeqThre = 0.40
!--
      call RoutineHeader('Molecular Replacement')
      call RunToolBar(-1, ' ')
!
!-- gestione del file di log stile "MAD"
!
      call MRInfo(0)
!
!-- set up initial values
!
! -- dedi -- per inizializzare il valore di exposigma
      exposigma = 1
!
      nrefl=0
      rhomax=0.0
      itype=1
      iform=2
      icomple=0
      if (nsym == 1 .and. icent == 0) then
          ifP1 = 1
      else
          ifP1 = 0
      endif
          ifP1 = 0
!
      call scrper(' Reading data ',0,-1)
!
      rmtt=rmi ! serve solo per ifModify==1, solo che non ce l'ho ancora,
               ! per cui non lo posso condizionare
      call SaveLists123
      call dirmol(fileh,ier,volumeProt,rMTZ,totModel)
      if (ier.lt.0) return
!
      if (totModel > numbModels) then
          Action = 2
          call Monomer2Model(Action, totModel)
      endif
****  call AggiungiMonomeri
!
      ifLabels = 0      
      ifMadEnv = 2
      call LeggiSkeletonRemo()
      !!call DoSingleIteration()
      kk = 1
      call SetScale(kk)
      call RotazTot
!
!--- Calcolo il volume della Proteina modello nella cella della proteina target
!
      if (ksize > 3) then
          v_m  = 0.0
          do i = 1,nk
             if (no(i) > 1) then
                 v_m = v_m + 14.0 * float(nw(i)) ! 14=2*nz(azoto)
             endif
          enddo
          nsymTot=nsymSav*(icentSav+1)* ncentrSav
          v_m=v_m*nsymTot
!--- Matthews' number
          v_m = volumeProt / v_m
!--- Percent of Protein
          v_p = costanteMatthews / v_m
          v_s = 1.0 - v_p
          if (v_s < 0.0) then
              v_p = 1.
              v_s = 0.
          endif
          if (nAcid > 0 .and. nResidStored == 0) then
              write(lo,119) v_m, v_p, v_s
          else
              write(lo,19) v_m, v_p, v_s
          endif
          write(Msg,20) v_s*100,v_m
          
          if (nMolMR > 1) then
              write(Msg,12) nMolMR
          endif
          call TestoGR(Msg, -1, 2, 1)


!--warning sul numero di monomeri
          if (v_s > 0.75) then
              write(Msg,31) v_s*100
              write(lo,21)  v_s*100
              call TestoGR(Msg, color_LIGHTRED, 2, 1)
!             nMolMRsugg=nint(0.5*nMolMR/v_p)
              nMolMRsugg=nint(nMolMR*(1.0-0.75)/v_p)
              if (nMolMRsugg > nMolMR) then
                  write(Msg,33) nMolMRsugg
                  write(lo,23) nMolMRsugg
                  call TestoGR(Msg, color_LIGHTRED, 2, 1)
              endif
          elseif (v_s < 0.3) then
              write(Msg,32) v_s*100
              write(lo,22)  v_s*100
              call TestoGR(Msg, color_LIGHTRED, 2, 1)
!             nMolMRsugg=nint(0.5*nMolMR/v_p)
              nMolMRsugg=nint(nMolMR*(1.0-0.30)/v_p)
              if (nMolMRsugg < nMolMR) then
                  write(Msg,33) nMolMRsugg
                  write(lo,23) nMolMRsugg
                  call TestoGR(Msg, color_LIGHTRED, 2, 1)
              endif
          endif
          write(lo,*)  ' '


      endif
      call MRInfo(11)
      call MRInfo(12)
c
c--scrive un pdb col modello ruotato
c     call EsportaMR(1,0,0)  
!                                                RIVEDERE QUESTA PARTE !!!
!-- rhoSog1  seleziona le rotazioni
!-- rhoSog1a seleziona dopo il clustering 
!-- rhoSog2  seleziona le traslazioni 
!-- rhoSog3  seleziona le traslazioni per l'ottimizzazione locale
!-- rhoSog3a seleziona dopo l'ottimizzazione locale
!
      nMolMRTot = sum(MonomerInModel(1:numbModels))

!
      if (ifDNA == 1) then
         call GetModelSequenceDNA ! (1, numeroCatene, Catene)
      endif

!
!--- TEST TEST TEST
!
      if (ifPostCAB > 0) then
*         FichierOut = nome(1:lnome) // '_nautilus_lab.pdb'
          FichierOut = nome(1:lnome) // '_CAB.pdb'
          MTZFILE = nome(1:lnome) // '_CAB.mtz'
          direttiva = nome(1:lnome) //'_nautilus_lab.mtz'
          call cCopyFile(MTZFILE, direttiva)
          call LeggiMtzDna
          call PostCAB(Rval)
          ier = -1
          return
      endif
!
!--- TEST TEST TEST
!
!         
      write(lo,34) natsModel, int(anatSav)
      rapp=natsModel/anatSav
      if (rapp <= 0.7) then
          rapp_sp=anatSav/natsModel
      else
          rapp_sp = 1.0
      endif
c     if(rapp <= 1.0) then     ! da testare !!!!!
         rapp1=(natsModel/anatSav)/(float(nsym)*float(nMolMRTot))
c     else
c        rapp1=(anatSav/natsModel)/(float(nsym)*float(nMolMRTot))
c     endif
      write(lo,36) rapp
      write(lo,40) rapp1
!
      if (ifAli == 0) then
          call Allinea
      else
          call GetAli
      endif
!
      if (idSeq==-9999) idSeq=1
!
      indexDiff = rapp1 * idSeq
      write(lo,41) indexDiff
!
!!!   if (idSeq==-9999) idSeq=1

      if (ies_thre(1) == 0) then   !!! non richiesta soglia da direttiva
          rhoSog1=-0.40*indexDiff+0.50
          rhoSog1=min(rhoSog1,0.5)  !!! MAX 0.5  
          rhoSog1=max(rhoSog1,0.1)  !!! MIN 0.1

              rhoSog1=1.0

      endif

      if (ies_thre(2) == 0) then   !!! non richiesta soglia da direttiva
          rhoSog1a  = -0.55*indexDiff + 0.70

              rhoSog1a=1.0

      endif

      if (ies_thre(3) == 0) then   !!! non richiesta soglia da direttiva
          rhoSog2 = 0.1
          if (ifDNA > 0) then
              rhoSog2 = 0.15
          endif
          if (indexDiff < 0.3 .or. rmsStr > 0.9) rhoSog2 = 0.2
      endif

      if (ies_thre(4) == 0) then   !!! non richiesta soglia da direttiva
          rhoSog3 = 0.15 
          if (ifDNA > 0) then
              rhoSog3 = 0.20
          endif
          if (indexDiff < 0.3 .or. rmsStr > 0.9) rhoSog3 = 0.35
      endif
!
c     write(lo,'(a,/,4(10x,a,f8.2,/))') ' Threshold values for:',
c    &             'Rotation selection     =',rhoSog1,
c    &             'Clustering selection   =',rhoSog1a,
c    &             'Translation selection  =',rhoSog2,
c    &             'Optimization selection =',rhoSog3
!
      allocate(work1_cc(nrefl), stat=ier)
      allocate(work2_cc(nrefl), stat=ier)
!
      return
   12 format(i2,' molecules will be searched ')
   19 format (' Model: Matthews coefficient =',f5.2,/,
     *        '        Protein volume       =',f5.2,/,
     *        '        Solvent volume       =',f5.2)
  119 format (' Model: Matthews coefficient =',f5.2,/,
     *        '        Nucleic Acid volume  =',f5.2,/,
     *        '        Solvent volume       =',f5.2)
   20 format('Model: solvent ',f4.1,'%   Matthews coeff. =',f4.1)
   21 format('Warning: solvent content too high: ',f4.1,'% ')
   22 format('Warning: solvent content too low: ',f4.1,'% ')
   23 format('Suggested number of model molecules: ',i2)
   31 format('Warning: solvent content too high: ',f4.1,'% ')
   32 format('Warning: solvent content too low: ',f4.1,'% ')
   33 format('Suggested number of model molecules: ',i2)
   34 format(' Number of atoms of the model structure  ',i8,/,
     *       ' Number of atoms of the target structure ',i8)
   36 format(' Ratio (atoms of model) / (atoms of target)  ',f5.2)
   40 format(' Coefficient of difficulty ',2f5.2)
   41 format(' Index of difficulty       ',2f5.2)
      end
!-----------------------------------------------------------------------
      subroutine GetModelSequenceDNA
      USE General
      USE Atomi
      USE Align
      USE Groups
      USE RemoModule
      USE ArpWarp
!
      implicit none
      integer :: i, j, k, l, oldRes, QualeCatena, WM, mon, at, newRes
      integer :: ii, ier, n, nR, iniz, ifin, oldNucl
      character (len=1) :: cat
      character (len=4) :: tipoA, tipoR
!
      SequenceModel(:,:) = 0
!
      oldNucl = -9999
      nR = 0
      n = 0
      iniz = 1
      do i=1, numbModels
         write(lo,10) i
         cat = model(i)%catena(1,1)
         nseq2 = 0
         do k=1, natsInModel(i)
            if (model(i)%catena(k,1) /= cat) then
                if (nseq2 > 0) then
*                   write(lo,10) i, nseq2
                    ifin = iniz + nseq2 - 1
                    write(lo,20) cat, char(SequenceModel(iniz:ifin,1))
                    iniz = ifin + 1
                    n = n + 1
                    ResInModel(n) = nseq2
                    nseq2 = 0
                endif
                cat = model(1)%catena(k,1)
            endif
            tipoA = model(i)%tipoAtomo(k, 1)(1:4)
            call ucase(tipoA)
            if (model(i)%numResiduo(k,1) /= oldNucl) then
                oldNucl = model(i)%numResiduo(k,1)
                nseq2 = nseq2 + 1
                nR = nR + 1
                tipoR = model(i)%tipoResiduo(k, 1)(1:3)
                call ucase(tipoR)
                call shift(tipoR,j)
                if (tipoR(1:1) == 'D') then
                    tipoR(1:1) = ' '
                    call shift(tipoR,j)
                endif
*               write(6,*) i, k, nseq2, tipoR
                SequenceModel(nR,1) = ichar(tipoR(1:1))
            endif
         enddo
         if (nseq2 > 0) then
*            write(lo,10) i, nseq2
             ifin = iniz + nseq2 - 1
             write(lo,20) cat, char(SequenceModel(iniz:ifin,1))
             iniz = ifin + 1
             n = n + 1
             ResInModel(n) = nseq2
             nseq2 = 0
          endif
      enddo
      write(lo,*) ' '
!
*     call AnalisiTerminali

      nR = sum(ResInChains(:))
      if (knw > 0) then
          write(lo,30) char(Sequence(1:nR))
          write(lo,40) char(SequenceModel(1:ifin,1))
          write(lo,*) ' '
      endif
!
      call CheckSequence(ifin, nR, n)
      if (knw > 0) then
          if (UseSynergy) then
              write(6,*) 'USA SYNERGY YES'
          else
              write(6,*) 'USA SYNERGY NO'
          endif
      endif
!
      return
*  10 format(/,' Sequence for model #',i2,',',i4,' Nucleotides')
   10 format(/,' Sequence for model #',i2)
   20 format(' Chain ',a1,2x,80a1)
   25 format(' Chain ',a1,2x,i5,2x,80a1)
   30 format(' Target: ',50a1,10(/,9x,50a1))
   40 format(' Model:  ',50a1,10(/,9x,50a1))
      end
!-----------------------------------------------------------------------
      subroutine CheckSequence(numbModel, numbTarget, n)
      USE General
      USE Atomi
      USE Align
      USE Groups
      USE ArpWarp
      USE RemoModule
!
      implicit none
      integer :: numbModel, numbTarget, tot, i, n
      integer :: nDiff, nDiff1, nDiff2, j, k, i1, i2
      integer :: inizModel, inizTarget
      logical :: identical
!
!-- numbModel = numero nucleotidi nel modello
!-- numbTarget= numero nucleotidi nel target
!-- n numero di catene nel modello
!
      if (knw > 0) then
          write(6,*) 'CHECKSEQUENCE'
          write(6,*) 'numbModel ', numbModel
          write(6,*) 'numbTarget ', numbTarget
          write(6,*) 'CATENE NEL MODELLO ', n
      endif
      UseSynergy = .false.
      tot = max(numbModel, numbTarget)
!
!-- Caso sequenze identiche o con una sola differenza
!
      if (numbModel == numbTarget) then
          nDiff = 0
          identical = .true.
          do i=1, tot
             if (Sequence(i) /= SequenceModel(i,1)) then
                 nDiff = nDiff + 1
                 identical = .false.
             endif
          enddo
          if (identical) then
              write(6,*) 'SEQUENZE IDENTICHE'
              UseSynergy = .true.
              return
          elseif (nDiff == n) then
              write(6,*) 'DIFFERISCONO DI 1 in ogni catena'
              UseSynergy = .true.
              return
          endif
      endif
!
!-- Differiscono di un solo nucleotide: target > model
!
      k = sum(ResInChains(:)) - sum(ResInModel(:))
      if (k == n) then
          nDiff = 0
          inizModel = 0
          inizTarget = 0
          do i=1, n
             nDiff1 = 0
             do j=1, ResInModel(i)
                if (Sequence(inizTarget+j) /= 
     *              SequenceModel(inizModel+j,1)) then
                    nDiff1 = nDiff1 + 1
                endif
             enddo
             nDiff2 = 0
             do j=1, ResInModel(i)
                if (Sequence(inizTarget+j+1) /= 
     *              SequenceModel(inizModel+j,1)) then
                    nDiff2 = nDiff2 + 1
                endif
             enddo
             k = min0(nDiff1, nDiff2)
*            if (k <= 1) then
                 nDiff = nDiff + k
*            endif
             inizModel = inizModel + ResInModel(i)
             inizTarget = inizTarget + ResInChains(i)
          enddo
          if (nDiff == 0 .or. nDiff == n) then
              if (knw > 0) write(6,*) ' TARGET > MODEL '
              UseSynergy = .true.
              return
          else
              if (knw > 0) then
                  write(6,*) 'SEQUENZE DIVERSE PER  PIU DI 1 NUCL'
                  write(6,*) 'sequenza = modello+1'
              endif
              return
          endif
      endif
!
!-- Differiscono di un solo nucleotide: target < model
!
      k = sum(ResInModel(:)) - sum(ResInChains(:))
      if (k == n) then
          nDiff = 0
          inizModel = 0
          inizTarget = 0
          do i=1, n
             nDiff1 = 0
             do j=1, ResInChains(i)
                if (Sequence(inizTarget+j) /= 
     *              SequenceModel(inizModel+j,1)) then
                    nDiff1 = nDiff1 + 1
                endif
             enddo
             nDiff2 = 0
             do j=1, ResInChains(i)
                if (Sequence(inizTarget+j) /= 
     *              SequenceModel(inizModel+j+1,1)) then
                    nDiff2 = nDiff2 + 1
                endif
             enddo
             k = min0(nDiff1, nDiff2)
**           if (k == 1) then
                 nDiff = nDiff + k
**           endif
             inizModel = inizModel + ResInModel(i)
             inizTarget = inizTarget + ResInChains(i)
          enddo
**        if (nDiff == n) then
          if (nDiff == 0 .or. nDiff == n) then
              write(6,*) ' TARGET < MODEL '
              UseSynergy = .true.
              return
          endif
          nDiff = 0
          inizModel = 0
          inizTarget = 0
          do i=1, n
             i1 = 0
             do j=1, ResInChains(i)
                if (Sequence(inizTarget+j) == 
     *              SequenceModel(inizModel+j,1)) then
                    i1 = i1 + 1
                else
                    exit
                endif
             enddo
             i2 = 0
             do j=ResInChains(i), 1, -1
                if (Sequence(inizTarget+j) == 
     *              SequenceModel(inizModel+j+1,1)) then
                    i2 = i2 + 1
                else
                    exit
                endif
             enddo
             k = i1 + i2
             if (k == ResInModel(i)) then
                 nDiff = nDiff + 1
             endif
             inizModel = inizModel + ResInModel(i)
             inizTarget = inizTarget + ResInChains(i)
          enddo
          if (nDiff == n) then
              write(6,*) ' TARGET < MODEL '
              UseSynergy = .true.
              return
          endif
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine LeggiSkeletonRemo()
      USE General
      USE Atomi
      USE Molcom
      USE RemoModule
!
      integer :: WM, nIm(10)
      real x1(3), x2(3), B(3,3)
      character (len=4) :: tipoA, tipoR
!
      call AllocaMolcom(1)
      if (.not.allocated(nzTot)) then
          allocate(nzTot(1:MaxAtomsInGr), stat = ier1)
      endif
      do i=1, MaxAtomsInGr
         iOrd(i) = i
      enddo
!
!-- check for no protein structure
!
      ifProtein = 0
      ciclo_1: do ii=1, numbModels
         nMolMR = MonomerInModel(ii)
         do i=1, nMolMR
            do j=1, natsInModel(ii)
               tipoR = model(ii)%tipoResiduo(j,1)(1:4)
               call lcase(tipoR)
               if (tipoR /= 'het ') then
                   ifProtein = 1
                   exit ciclo_1
               endif
            enddo
         enddo
      enddo ciclo_1
!
      if (ifProtein == 1) then
          NatMol = 0
          NumLeg = 0
          do ii=1, numbModels
             nMolMR = MonomerInModel(ii)
             do i=1, nMolMR
                do j=1, natsInModel(ii)
                   tipoA = model(ii)%tipoAtomo(j,1)
                   call lcase(tipoA)
                   if (tipoA == 'ca  ') then
                       NatMol = NatMol + 1
                       xyz(1:3,NatMol) = model(ii)%ortho(1:3,j,i)
                   endif
                enddo
             enddo
          enddo
      endif

!
! TEST
!
*     NatMol = 20
!
      if (NatMol > 0) then
          do i=1, NatMol-1
             dist = 0.0
             do j=1,3
                dist = dist + (xyz(j,i)-xyz(j,i+1))**2
             end do
             dist = sqrt(dist)
             if (dist < 4.0) then
                 NumLeg = NumLeg + 1
                 LE(1, NumLeg) = i
                 LE(2, NumLeg) = i + 1
                 LE(3, NumLeg) = 4
             endif
          enddo
!
          do i=1, NatMol
             RS(i) = 0.25
             nzTot(i) = 1
             iEqui(i) = i
          enddo
          call AggiuSpig
          iPlotType = STICKS
          nSkel = NatMol
          iActionBond = 2
      else
          nIM(1:numbModels) = natsInModel(1:numbModels)
          call AllocaAtomi(1)
          WM = WhichModel
          WhichModel = 1
**??**    natsInModel(WhichModel) = nats
          natsInModel(1:numbModels) = nIM(1:numbModels)
          call GetModel()
          do i=1, nats
              x1(1:3) = xyzs(1:3,i)
              call MoltMatVec(rmi, x1, x2)
              xyzs(1:3,i) = x2(1:3)
          enddo
          leggi = 1
          leggi = 0
          kact = 5
          call build(kact, 2)
          call toMolPlo3(leggi)
          iPlotType = SHADING
          nSkel = 0
          iActionBond = 1
          WhichModel = WM
      endif
      kplty=iPlotType
      ViewDist = 9.e33
!
      Lim1 = iVP(1)
      Lim2 = iVP(2)
      Lim3 = iVP(3)
      Lim4 = iVP(4)
      NPX = Lim3 - Lim1
      NPY = Lim4 - Lim2
      Ratio = float(NPX) / float(NPY)
!
      BTot11 = BTot(1,1)
      call LsPlane(NATV, 1)
      call GetBonds(iActionBond)
      Rmin1 = 99999.
      Rmin2 = 99999.
      RMAX1 = -99999.
      RMAX2 = -99999.
!
      do i = 1 , 3
         do j = 1 , 3
            BTot(i, j) = 0
         enddo
         BTot(i, i) = 1
      enddo
      call FindOr(B, 1)
      ifScale = 1
!
      if (kscreen.eq.0) return
!
      NatInd = NatMol
      ifSkeleton   = NatMol
      ifSkeletonOn = 1
      call EnableSingleIteration(0)
      SinglePlotType(1:NatMol) = iPlotType
      !!call Disegna(ifScale)
      call EnableSingleIteration(1)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine AggiungiMonomeri
      USE General
      USE Atomi
      USE Molcom
      USE RemoModule
!
      real x1(3), x2(3)
!
      do ii = 1, numbModels
         nats = natsInModel(ii)
         do i=1, nats
            x1(1:3) = model(ii)%atoms(1:3,i,1)
            model(ii)%saved(1:3,i,1)= x1(1:3)
            call MoltMatVec(rm, x1, x2)
            model(ii)%atoms(1:3,i,1)= x2(1:3)
            model(ii)%ortho(1:3,i,1)= x2(1:3)
         enddo
         nMolMR  = MonomerInModel(ii)
         if (nMolMR > 1) then
             do i=2, nMolMR
                nats = nats + natsInModel(ii)
                do j=1, natsInModel(ii)
                   model(ii)%atoms(1:5,j,i)  = model(ii)%atoms(1:5,j,1)
                   model(ii)%saved(1:3,j,i)  = model(ii)%saved(1:3,j,1)
                   model(ii)%ortho(1:3,j,i)  = model(ii)%ortho(1:3,j,1)
                   model(ii)%specie(j,i)     = model(ii)%specie(j,1)
                   model(ii)%th_fact(j,i)    = model(ii)%th_fact(j,1)
                   model(ii)%tipoAtomo(j,i)  = model(ii)%tipoAtomo(j,1)
                   model(ii)%tipoResiduo(j,i)=model(ii)%tipoResiduo(j,1)
                   model(ii)%Alternate(j,i)  =model(ii)%Alternate(j,1)
                   model(ii)%catena(j,i)     =model(ii)%catena(j,1)
                   model(ii)%numResiduo(j,i) =model(ii)%numResiduo(j,1)
                   model(ii)%Insertion(j,i)  =model(ii)%Insertion(j,1)
                   model(ii)%HETA(j,i)       =model(ii)%HETA(j,1)
                enddo
             enddo
         endif
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine dirmol(fileh,ier,volumeProt,rMTZ,totModel)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Molcom
      USE Grafici
      USE Param
      USE MadModule
      USE PhaseModule
      USE RemoModule
      USE TraslaSolution
      USE Direttive
      USE Groups
      USE ArpWarp
      USE Align
!
!-- read directives for this modul
!
      common /misurato/ misu  !pgMAD
      common /user1/ ran_low, ran_high, userdef, numeroLim
!
      common /sfact/ nSfCard, sfacm(18,9), kSfac(18)
      integer :: rMTZ, Action, totModel
      dimension celltemp(13)
      character fileh*256 ! , dum1, dum2
      dimension x1(3), x2(3), b(3,3)
      dimension RotAppl1(3),TraAppl1(3)
      character*11 stringa
      integer nwTot(18), nalfTot(19), nkTot, sav
      logical :: Ok
      character*80 itleSav
!
      zero = 0.000001
      itleSav = Titolo
!
!-- set default values
!
      userdef = 0
      numeroLim = -9999
      ran_low  = -99.99
      ran_high = -99.99
      ifClust = 0
      ifPhD = 0
      ifSkip = 0
      ifSoloMR = 0
      ifnoImp = 0
      rMTZ = 0
      ifMtzMap = 2
      ifMutate = 0
      MutateReq = 0
      NoMutateReq = 0
      preMutazioniReq = 0
      idSeq = -9999
      ifAdjust = 0
      ifOverlap = 0
      ifImproveMR = 1
      iesImpr = 0
      ifVLD = 0
      ifReduced = 0
!
      if (numbGen > 0) then
          ifFreeLunchMR = 1
      else
          ifFreeLunchMR = 0
      endif

      ifFreeLunchMR = 0
!
      nAMBReq = -99
      nAMB = 10
      numbModelsMax = 20
      numbModels = 1
*     MonomerInModel(:) = 1
      ModelOn = 0
      CutResiduiVet(:,:) = 0
      bfacMRVet(:) = -1
      AlaVet(:) = 0
      LeggiHetamVet(:) = 0
      ifTraOnlyVet(:) = 0
      ifRotSelVet(:) = 0
      RotAppl1Vet(:,:) = 0.0
      ifPositionedVet(:) = 0
      RotApplVet(:,:) = 0
      TranslApplVet(:,:) = 0
      
!
      nwTot(:) = 0
      nalfTot(:) = 0
      nkTot = 0
      
      ifCutResidui = 0
      bfacMR = -1
      ifAla = 0
      use_E=.true. !lavora con e
c      use_E=.false.  ! lavora con la correlazione
      JellyReq = -99
      isJelly = .false.
      nRefmacCycles = 15
      kverbo = 0
      kcpu = 0
      ifSolvent = 0
      ifShelx = 0
      jMolMR = 0
      kCosto = 5
c
      resol1=-1.0
      resol2=0.0
      rmsStr = 0.0
      nMolMR = 1
      nMolMR = NumeroMonomeri
      MonomerInModel(numbModels) = nMolMR
      rhoSog1  = 0.0
      rhoSog1a = 0.0
      rhoSog2 = 0.0
      rhoSog3 = 0.0
      RfreeThreReq  = -99
      sogSolToExplore = 100
      sogSolToExplore_Req = -99
      sogSolToOptimize = -99
      sogSolutions = -99
      nRot_Req = -99
      nTra_Req = -99
      nSol_Req = -99
      ifModify = 0
!
      if (RSoglia.lt.0) then
          RSoglia = 25.0
      endif
      if (resm < ResSogLow) then
          nolsq = -1
      else
          nolsq = 0
      endif
      jrecyc = 100
      ifPositioned = 0
      ifRotOnly = 0
      ifTraOnly = 0
      globval(1:2) = (/ -9999, 0 /)
      ifTranslAppl = 0
      ifRotAppl    = 0
      TranslAppl(:) = 0.0
      RotAppl(:)    = 0.0
      RotAppl1(:)    = 0.0
      TraAppl1(:)    = 0.0
      ifRotSel=0
      ifTraSel=0
!
!-- check for 'model' directive
!
      ipdS = ipdir
      ic    = 0
      icmax = icomq(icomat,2)
      do while (ic.lt.icmax.and.ier.eq.0)
         ic = ic + 1
         ipdir=ipdir+1
         cardDiret=card(ipdir)
         call lcase(cardDiret)
         if (cardDiret(1:4) == 'mode') then
             numbModels = 0
             exit
         endif
      enddo
      ipdir = ipdS
      
!
      call AllocaModelRemo(2)
!
      resol2 =10.0
      ic    = 0
      icmax = icomq(icomat,2)

c
      do while (ic.lt.icmax.and.ier.eq.0)
         ic = ic + 1
         ipdir=ipdir+1
         cardDiret=card(ipdir)
         cardImage=cardDiret
         ldiret = Lung(cardImage)
         call cutst(cardDiret,lenp,direttiva,lend)
         call lcase(direttiva)
c-- directives with alphanumeric parameters
         if (direttiva(1:4).eq.'post') then
             ifPostCAB = 1
             if (index(cardDiret,'list') > 0) then
                 ifPostCAB = 2
             endif
         else if (direttiva(1:4).eq.'test') then
             testProc = 1
         elseif (direttiva(1:4).eq.'fast') then
             fastMR = 1
*            ifSoloMR = 1
         elseif (direttiva(1:4).eq.'clus') then
             ifClust = 1
         elseif (direttiva(1:4).eq.'nocl') then
             ifClust = 0
         elseif (direttiva(1:3).eq.'phd') then
             ifPhD = 1
         elseif (direttiva(1:4).eq.'noph') then
             ifPhD = 0
         elseif (direttiva(1:4).eq.'rmtz') then
             rMTZ = 1
         elseif (direttiva(1:4).eq.'map ') then
             ifMtzMap = 2
         elseif (direttiva(1:4).eq.'over') then
             ifOverlap = 1
         elseif (direttiva(1:4).eq.'adju') then
             ifAdjust = 1
         elseif (direttiva(1:4).eq.'jell') then
             JellyReq = 1
             isJelly = .true.
         elseif (direttiva(1:4).eq.'impr') then
             ifImproveMR = 1
!            if (ifAmb == 0) then
!                ifAmb = 1
!            endif
!!!!!        ifVLD = 1
         elseif (direttiva(1:4).eq.'skip') then
             ifSkip = 1
         elseif (direttiva(1:4).eq.'solo') then
             ifSoloMR = 1
         elseif (direttiva(1:4).eq.'noim') then
             ifImproveMR = 0
!?!          ifnoImp = 1                          !????
         elseif (direttiva(1:4).eq.'free') then
             ifFreeLunchMR = 1
         elseif (direttiva(1:4).eq.'nofr') then
             ifFreeLunchMR = 0
*        elseif (direttiva(1:3).eq.'amb') then
*            ifAmb = 1
         elseif (direttiva(1:3).eq.'mut') then
             ifMutate = 1
             MutateReq = 1
         elseif (direttiva(1:4).eq.'nomu') then
             ifMutate = 0
             NoMutateReq = 1
         elseif (direttiva(1:4).eq.'mode') then
             if (ModelOn == 0) then
                 ModelOn = 1
                 numbModels = numbModels + 1
                 if (numbModels > numbModelsMax) then
                     ier = -10
                 endif
             else
                 ier = -10              ! errore nella direttiva
             endif
         elseif (direttiva(1:4).eq.'endm') then
             if (ModelOn == 1) then
                 ModelOn = 0
             else
                 ier = -10              ! errore nella direttiva
             endif
         elseif (direttiva(1:3).eq."e's") then
             use_E = .true.  ! lavora con E**2-1
         elseif (direttiva(1:3).eq."f's") then
             use_E = .false.  ! lavora con F
         elseif (direttiva(1:3).eq.'fom') then
             call lcase(cardDiret)
             if (lenp.gt.0) then
                 if (cardDiret(1:4).eq.'rfac') then
                     kCosto = 1
                 elseif (cardDiret(1:4).eq.'sum4') then
                     kCosto = 4
                 elseif (cardDiret(1:4).eq.'corr') then
                     kCosto = 5
                 endif
             else
                 ier = -10              ! errore nella direttiva
             endif
         elseif (direttiva(1:4).eq.'modi')  then
c           ifModify = 1
            ifModify = 2
         elseif (direttiva(1:4).eq.'poly') then
             ifAla = 1
             AlaVet(numbModels) = 1
         elseif (direttiva(1:4).eq.'pseu') then
             use_pseudo = .true.
         elseif (direttiva(1:4).eq.'dlsq') then
             nolsq = -1
         elseif (direttiva(1:4).eq.'appr') then
             ifRotOnly = 1
         elseif (direttiva(1:4).eq.'deta')  then
             kverbo = 1
         elseif (direttiva(1:4).eq.'verb')  then
             kverbo = 1
         elseif (direttiva(1:3).eq.'cpu')  then
             kcpu = 1
         elseif (direttiva(1:4).eq.'shel')  then
             ifShelx = 1
         elseif (direttiva(1:3).eq.'ali') then
             call CheckBlanks(fileh, lend)
             if (lend > 0) then
                 AliFile = fileh(1:lend)
                 ifAli = 1
             else
                 ier = -10
             endif
         elseif (direttiva(1:4).eq.'frag') then         
!
!-- check for HETAM in the fragment string
!
             k = index(cardDiret, 'heta')
             if (k > 0) then
                 LeggiHetam = 1
                 k1 = index(cardDiret(k+1:), ' ')
                 if (k1 == 0) then
                     cardDiret(k:) = ' '
                 else
                     k1 = k1 -1 + k
                     cardDiret(k:k1) = ' '
                 endif
                 call shift(cardDiret, k1)
             else
                 LeggiHetam = 0
             endif
             LeggiHetamVet(numbModels) = LeggiHetam
!
!-- check for blanks in the fragment file name
!
             call CheckBlanks(fileh, lend)
!
             if (lend > 0) then
                 ReflFileName = fileh(1:lend)
                 jjfile = jfile
                 fileh  = ReflFileName
                 card(ncardMax - numbModels + 1) = ReflFileName
             else
                 ier = -10
             endif
         elseif (direttiva(1:4).eq.'bfac') then
             call lcase(cardDiret)
             iopt = 0
             call getnum(cardDiret, vet, ivet, iv, iopt)
             if (iopt /= -1 .and. iv == 1) then
                 bfacMR = vet(1)
                 bfacMRVet(numbModels) = bfacMR
              elseif(cardDiret(1:3) == 'pdb') then
                 bfacMR = 0
                 bfacMRVet(numbModels) = bfacMR
              elseif(cardDiret(1:3) == 'wil') then
                 bfacMR = -1
                 bfacMRVet(numbModels) = bfacMR
              else
                  ier = -10         ! errore nella direttiva
              endif
         else
!-- directives with numeric parameters
              iopt=0
              call getnum(cardDiret,vet,ivet,iv,iopt)          
              if (iopt.ne.-1) then
                 if (direttiva(1:3).eq.'cut') then
                      if (iv == 2) then
                          MinResiduo = ivet(1)
                          MaxResiduo = ivet(2)
                          if (MinResiduo <= MaxResiduo .and. 
     *                        MinResiduo > 0) then
                              ifCutResidui = 1
                              CutResiduiVet(numbModels, 1) = 1
                              CutResiduiVet(numbModels, 2) = MinResiduo
                              CutResiduiVet(numbModels, 3) = MaxResiduo
                          else
                              ier = -10
                          endif
                      else
                          ier = -10
                      endif
                 elseif (direttiva(1:4).eq.'nrot') then
                      if (iv == 1) then
                          sogSolToExplore = ivet(1)
                          sogSolToExplore_Req = 1
                      else
                          ier = -10
                      endif
                 elseif (direttiva(1:4).eq.'nopt') then
                      if (iv == 1) then
                          sogSolToOptimize = ivet(1)
                      else
                          ier = -10
                      endif
                 elseif (direttiva(1:4).eq.'nsol') then
                      if (iv == 1) then
                          sogSolutions = ivet(1)
                      else
                          ier = -10
                      endif
                 elseif (direttiva(1:3).eq.'set') then
                      if (iv == 1) then
                          setMR = ivet(1)
                      else
                          ier = -10
                      endif
                 elseif (direttiva(1:4).eq.'refi') then
                      if (iv == 0) then
                          nRefmacCycles = 15  !10
                      elseif (iv == 1) then
                          nRefmacCycles = ivet(1)
                      else
                          ier = -10
                      endif
                 elseif (direttiva(1:4).eq.'nore') then
                          nRefmacCycles = -1
                 elseif (direttiva(1:4).eq.'solv') then
                      if (iv.eq.1) then
                          ifSolvent = 1
                          Solvent = vet(1)
                      else
                          ier = -10
                      endif
                 elseif (direttiva(1:4).eq.'namb') then  ! numero max di run di AMB (def. = 10)
                      if (iv.eq.1) then
                          nAMBReq = 1
                          nAMB = vet(1)
                      else
                          ier = -10
                      endif
                 elseif (direttiva(1:4).eq.'npre') then  ! numero max di preMutazioni (def. = 1 o 30)
                      if (iv.eq.1) then
                          preMutazioniReq = 1
                          preMutazioni = vet(1)
                          nuovoBl = 5
                      else
                          ier = -10
                      endif
                 elseif (direttiva(1:4).eq.'nblo') then  ! numero max di blocchi REFMAC_VLD aggiunti (def. = 5)
                      if (iv.eq.1) then
                          preMutazioniReq = 1
                          preMutazioni = vet(1)
                          nuovoBl = 5
                      elseif (iv.eq.2) then
                          preMutazioniReq = 1
                          preMutazioni = vet(1)
                          nuovoBl = vet(2)
                      else
                          ier = -10
                      endif
                 elseif (direttiva(1:4).eq.'lran') then
                      if (iv.eq.1) then
                          ran_low=vet(1)  ! p.es. 6.00
                          if (ran_low.lt.0.001) then
                              ier = -10
                          endif
                      else
                          ier = -10
                      endif
                 elseif (direttiva(1:4).eq.'hran') then
                      if (iv.eq.1) then
                          ran_high=vet(1)  ! p.es. 3.20
                          if (ran_high.lt.0.001) then
                              ier = -10
                          else
                              th = ( 0.5 / resol1 ) ** 2
                          endif
                      else
                          ier = -10
                      endif
                 elseif (direttiva(1:4).eq.'rang') then
c                     if (iv.eq.1) then
c                         resol1=vet(1)
c                         if (resol1.lt.0.001) then
c                             ier = -10
c                         else
c                             th = ( 0.5 / resol1 ) ** 2
c                         endif
c                     elseif (iv.eq.2) then
                      if (iv.eq.2) then
                          resol2=vet(1)  ! p.es. 6.00
                          resol1=vet(2)  ! p.es. 3.20
                          userdef = 1
                          if (resol1.lt.0.001) then
                              ier = -10
                          else
                              th = ( 0.5 / resol1 ) ** 2
                          endif
                      else
                          ier = -10
                      endif
                      if (resol1 >= resol2) then
                          write(Inte,200) resol2, resol1
                          call NoBlanks(Inte, lstringa)
                          Msg = 'Illegal resolution range: ' //
     *                          Inte(1:lstringa)
                          call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitC)
                          ier = -10
                      endif
                elseif (direttiva(1:4).eq.'numl') then
                    if (iv == 1) then
                          numeroLim = ivet(1)
                      else
                          ier = -10
                      endif
                elseif (direttiva(1:4).eq.'rfre') then
                        if (iv == 1) then
                            RfreeThreReq = 1
                            RfreeThre  = vet(1)
                        else
                           ier = -10
                        endif
                 elseif (direttiva(1:4).eq.'thre') then
                        if (iv == 1) then
                            ies_thre(1) = 1
                            rhoSog1  = vet(1)
                        elseif (iv == 2) then
                            ies_thre(1:2) = 1
                            rhoSog1  = vet(1)
                            rhoSog1a = vet(2)
                        elseif (iv == 3) then
                            ies_thre(1:3) = 1
                            rhoSog1  = vet(1)
                            rhoSog1a = vet(2)
                            rhoSog2  = vet(3)
                        elseif (iv == 4) then
                            ies_thre(:) = 1
                            rhoSog1  = vet(1)
                            rhoSog1a = vet(2)
                            rhoSog2  = vet(3)
                            rhoSog3  = vet(4)
                        else
                           ier = -10
                        endif
                 elseif (direttiva(1:4).eq.'mole' .or. 
     *                   direttiva(1:4).eq.'mono') then
                      if (iv == 1) then
                          tab21(3) = ivet(1)
                          if (iv /= 999) then
                              nMolMR = ivet(1)
                              NumeroMonomeri = nMolMR
                              NumeroMonomeriExp = nMolMR
                              NumeroMonomeriInp = nMolMR
                              MonomerInModel(numbModels) = nMolMR
                          endif
                      else
                          ier = -10
                      endif
                 elseif (direttiva(1:5).eq.'tmono') then
                      if (iv == 1) then
                          nMonomer = ivet(1)
                      else
                          ier = -10
                      endif
                 elseif (direttiva(1:5).eq.'idseq') then
!
                      if (iv == 1) then
                          idSeq = vet(1)
                          if (idSeq < 0.001) idSeq = -9999
                      else
                          ier = -10
                      endif
                 elseif (direttiva(1:3).eq.'rms') then
!
                      if (iv == 1) then
                          rmsStr = vet(1)
                      else
                          ier = -10
                      endif
                 elseif (direttiva(1:4).eq.'posi') then
!
!-- applica la rotazione e traslazione fornite e basta
!
                      if (iv == 6) then
                          ifPositionedVet(numbModels) = 1
                          do i =1,3
                             if (vet(i) < zero) vet(i) = 360.0 + vet(i)
                          enddo
                          RotApplVet(numbModels, 1:3)    = vet(1:3)
                          TranslApplVet(numbModels, 1:3) = vet(4:6)
                      else
                          ier = -10
                      endif
                 elseif (direttiva(1:4).eq.'tran') then
!
!-- applica inizialmente la traslazione fornita e prosegue regolarmente
!
                      if (iv == 3) then
                          ifTranslApplVet(numbModels) = 1
                          TranslApplVet(numbModels, 1:3) = vet(1:3)
                      else
                          ier = -10
                      endif
                 elseif (direttiva(1:4).eq.'rota') then
!
!-- applica inizialmente la rotazione fornita e prosegue regolarmente
!
                      if (iv == 3) then
                          ifRotApplVet(numbModels) = 1
                          do i =1,3
                             if (vet(i) < zero) vet(i) = 360.0 + vet(i)
                          enddo
                          RotApplVet(numbModels, 1:3) = vet(1:3)
                      else
                          ier = -10
                      endif
                 elseif (direttiva(1:4).eq.'rots') then
!
!-- applica la rotazione fornita e fa solo la traslazione
!
                      ifTraOnlyVet(numbModels) = 1
                      ifRotSelVet(numbModels) = 1
                      if (iv == 3) then
                          do i =1,3
                             if (vet(i) < zero) vet(i) = 360.0 + vet(i)
                          enddo
                          RotAppl1Vet(numbModels,1:3) = vet(1:3)
                      endif
                 elseif (direttiva(1:4).eq.'tras') then
!
!-- applica la rotazione e la traslazione e fa solo la rotazione
!
                      ifTraSel=1
                      if (iv == 6) then
                          do i =1,3
                             if (vet(i) < zero) vet(i) = 360.0 + vet(i)
                          enddo
                          RotAppl1Vet(numbModels,1:3) = vet(1:3)
                          TraAppl1Vet(numbModels,1:3) = vet(4:6)
                      else
                          ier = -10
                      endif
                 else
                   ier = -20
                 endif
              else
                ier = -20
              endif
         endif
!pgMAD
      enddo
      
      if (ifAdjust == 1) then
          if (ifREFMAC == 0) then
              ifAdjust = 0
          endif
      endif
      if (ier == -10) then
          write(Msg,6100) cardImage(1:ldiret)
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          ier = -1
          return
      endif
      
      if (ier == -20) then
          write(Msg,6200) cardImage(1:ldiret)
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          ier = -1
          return
      endif

      if (ModelOn == 1) then
          Msg = 'Model directive used but no endmodel supplied '
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          ier = -1
          return
      endif
!
!--- Calcolo il volume della Proteina
!
      if (ksize.gt.3) then
          v_m  = 0.0
          if (ifSolvent == 1) then
              v_s = Solvent
              v_p = 1.0 - Solvent
          else
!
              do i = 1,nk
                 if (no(i).gt.1) then
                     v_m = v_m + 14.0 * float(nw(i)) ! 14=2*nz(azoto)
                 endif
              enddo
!--- Matthews' number
              v_m = volume / v_m
!--- Percent of Protein
              v_p = costanteMatthews / v_m
              v_s = 1.0 - v_p
          endif
          if (v_s < 0.0) then
              v_p = 1.
              v_s = 0.
          endif
          write(lo,*) ' '
          if (nAcid > 0 .and. nResidStored == 0) then
              write(lo,22) v_m, v_p, v_s
          else
              write(lo,21) v_m, v_p, v_s
          endif
          write(lo,*) ' '
      endif
*  20 format('Target: solvent ',f4.1,'%',' Matthews coeff. =',f4.1)
   21 format(' Target: Matthews coefficient = ',f5.2,/,
     *       '         Protein volume       = ',f5.2,/,
     *       '         Solvent volume       = ',f5.2)
   22 format(' Target: Matthews coefficient = ',f5.2,/,
     *       '         Nucleic Acid volume  = ',f5.2,/,
     *       '         Solvent volume       = ',f5.2)
      volumeProt=volume
      call MRInfo(10)
!
!-- trasforma i monomeri in modelli
!
      Action = 1
      call Monomer2Model(Action, totModel)
!
****  call AllocaModelRemo(0)
!
      if(ifModify==1) then
c       bfacMR=bt
        bfacMR=-1
        use_E=.true.
      endif
!
      Msg = '<big><b>Input conditions</b></big>'
      call TestoGR(Msg, color_RED, 2, 1)
      if (numbModels /= 9) then
          j = index(card(ncardMax), slash, .TRUE.) + 1
          ReflFileName = card(ncardMax)(j:)
          write(Msg,6400) ReflFileName(1:Lung(ReflFileName))
          RemoLegend = 'Model plotted: ' //
     *                 ReflFileName(1:Lung(ReflFileName))
      else
*         Msg = 'Models from'
*         iniz = 13
*         do i=1, numbModels
*            j = index(card(ncardMax -i + 1), slash, .TRUE.) + i
*            ReflFileName = card(ncardMax - i + 1)(j:)
*            L = Lung(ReflFileName)
*            write(Msg(iniz:),"(a,',')") ReflFileName(1:L)
*            L = Lung(Msg)
*            iniz = L + 2
*         enddo
*         Msg(L:L) = ' '
          write(Msg,'(i5,a)') numbModels, ' models in input'
          call shift(Msg,L)
          write(RemoLegend,'(i5,a)') numbModels, ' models plotted'
          call shift(RemoLegend,L)
      endif
      ifRemoLegend = LenInPix(RemoLegend,3)
      call TestoGR(Msg, -1, 2, 1)
      
      sav = numbModels
      numbModels = totModel
      call AllocaBonds(0)
      numbModels = sav

      natsModel = 0
      do WhichModel=1, numbModels
         itype = 2
         iform = 1
         ReflFileName = card(ncardMax - WhichModel + 1)
         nMolMR = MonomerInModel(WhichModel)
         ifCutResidui = CutResiduiVet(WhichModel, 1)
         bfacMR = bfacMRVet(WhichModel)
         ifAla = AlaVet(WhichModel)
         LeggiHetam = LeggiHetamVet(WhichModel)
         ifTraOnly = ifTraOnlyVet(WhichModel)
         ifRotSel =  ifRotSelVet(WhichModel)
         ifPositioned = ifPositionedVet(WhichModel)
         ifRotAppl = ifRotApplVet(WhichModel)
         RotAppl(1:3) = RotApplVet(WhichModel, 1:3)
         RotAppl1(1:3) = RotAppl1Vet(WhichModel,1:3)
         TranslAppl(1:3) = TranslApplVet(WhichModel, 1:3)
         TraAppl1(1:3) = TraAppl1Vet(WhichModel,1:3)

         if (jopen(jhost,ReflFileName,itype,iform,ios).ge.0) then
             WRITE(lo,"(' Model structure file:',/,2x,a)") 
     *             ReflFileName(1:lung(ReflFileName))
*            Msg = '<big><b>Input conditions</b></big>'
*            call TestoGR(Msg, color_RED, 2, 1)
*            write(Msg,6400) ReflFileName(1:Lung(ReflFileName))
*            call TestoGR(Msg, -1, 2, 1)
             Msg = ' '
             k = 0
             if (ifAla == 1) then
                 Msg = '  Transformed in polyalanine'
                 k = Lung(Msg)
             endif
             if (ifCutResidui == 1) then
                 MinResiduo = CutResiduiVet(WhichModel, 2)
                 MaxResiduo = CutResiduiVet(WhichModel, 3)
                 write(stringa,"(i5,'-',i5)") MinResiduo, MaxResiduo
                 call NoBlanks(stringa, lstringa)
                 if (k == 0) then
                     Msg = '  Used residues ' // stringa(1:lstringa)
                 else
                     Msg(k+1:) = ';  used only residues ' // 
     *                           stringa(1:lstringa)
                 endif
                 k = Lung(Msg)
             endif
             if (k > 0) then
                 write(lo,'(a)') Msg(1:k)
                 call TestoGR(Msg, -1, 2, 1)
             endif
             call Cancella(3)
             import = kQualeFormato(ReflFileName)
  
             zero = 0.001
             if (import.eq.2) then
                 ifHOH = 0
                 kAla = ifAla
!--cosi' usa la cella del modello, imponendo la matrice di ortogonalizzazione
!  calcolata nel sir (a volte puo' anche non coincidere con quella del PDB, ma
!  almeno la rigidita' del modello e' conservata
!da verificare   call ManagePDBSir(1, ifHOH, LeggiHetam, kAla,0, ier)
                 if (ifDNA > 9999) then   ! Gianluca 23/07=2020
                     if (ifPostCAB == 0) then   ! Gianluca 23/07=2020
                         Ok = .true.
                         call ManageHetInModel(ReflFileName, Ok)
                         if (Ok) then
                             LeggiHetam = 1
                         else
                             LeggiHetam = 0
                         endif
                     else
                         LeggiHetam = 0
                     endif
                 endif
 
                 LeggiHetam = 0
!
                 SkipAnis = .true.
                 call ManagePDBSir(0, ifHOH, LeggiHetam, kAla,0, ier)
                 SkipAnis = .false.
!--cosi' non usa la cella del modello, ma quella del target
cc                call AccumulaSpecie(nwTot, nalfTot, nkTot)
                 coef = 1.0
                 if (bfacMR < 0.0) then
                     bmedio = 
     *                   sum(model(WhichModel)%th_fact(1:natsMR,1))
                     bmedio = bmedio / float(natsMR)
                     if (bmedio > zero) then
                         coef = 1.1 * bt / bmedio
                         if (kverbo >0) then
                           write(6,*) 
     *                           'Thermal factors:',bt,bmedio,coef
                         endif
                     endif
                 endif
             elseif (import.eq.4) then
                 coef = 1
                 call LeggiCIF(ifRefl, 0, ier)
             else
                 Msg = 'Unrecognized file format: '//
     *           reflfilename (1:lung(reflfilename))
                 call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
                 return
             endif
             close(jhost)
             natsModel = natsModel + nats * nMolMR
!
!--gestisco il caso  in cui il modello ha B nullo
!
             bmin = minval(model(WhichModel)%th_fact(1:natsMR,1))
             if (bmin < zero) then
                 do i=1, natsInModel(WhichModel)
                    if (model(WhichModel)%th_fact(i,1) < zero) then
                        model(WhichModel)%th_fact(i,1) = bt
                    endif
                 enddo
                 write(Msg,10) char(10), bt
                 call OpenWarning(Msg)
                 write(lo,'(/,a)') Msg(1:Lung(Msg))
             endif
          
             n = natsInModel(WhichModel)
             model(WhichModel)%th_fact(1:n,1) = 
     *                   model(WhichModel)%th_fact(1:n,1) * coef
!
            bmedio = sum(model(WhichModel)%th_fact(1:natsMR,1))
            bmedio = bmedio / float(natsMR)
!
             if (ier.lt.0) then
                 Msg = 'Error importing the file '//
     *           reflfilename (1:lung(reflfilename))
                 call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
                 return
             else
                 if (InfoOK(3) == 0) then
                     call Get_3(20)
                 endif
!
*                NatMol = nats
*                call InitMolplo()
!
                 if (ifTranslAppl == 1) then
                     nMolMR = MonomerInModel(WhichModel)
                     do i=1, nMolMR
                        do j=1, natsInModel(WhichModel)
                           model(WhichModel)%atoms(1:3,j,i) = 
     *                           model(WhichModel)%atoms(1:3,j,i) 
     *                         + TranslAppl(1:3)
                        enddo
                     enddo
                 endif
!
                 if (ifRotAppl == 1) then
                     tet1 = RotAppl(1) * dtor
                     tet2 = RotAppl(2) * dtor
                     tet3 = RotAppl(3) * dtor
                     call RotationOper1(b,tet1,tet2,tet3)
!
                     call DrawMatrixTra(b)
!
                     nMolMR = MonomerInModel(WhichModel)
                     do i=1, nMolMR
                        do j=1, natsInModel(WhichModel)
                          x1(1:3) = model(WhichModel)%atoms(1:3,j,i)
                          call MoltMatVec(rm, x1, x2)
                          call MoltMatVec(b, x2, x1)
                          call MoltMatVec(rmi, x1, x2)
                          model(WhichModel)%atoms(1:3,j,i) = x2(1:3)
                        enddo
                     enddo
                 endif
                 if (ifRotSel == 1) then
                   RotAppl(1:3)=RotAppl1(1:3)
                 endif
                 if (ifTraSel==1) then
                   RotAppl(1:3)=RotAppl1(1:3)
                   TranslAppl(1:3)=TraAppl1(1:3)
                 endif
!
c                 nnn = nats
c                 nats = natsInModel(1)
c!                call ScriviFrammento()
c                 nats = nnn
             endif
         else
             write(Msg,9510) ios,ReflFileName (1:lung(ReflFileName))
             call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
             ier = -1
             return
         endif
      enddo  ! fine ciclo sui modelli
c      if (numbModels > 1) then
c          nw(:) = nwTot(:)
c          nalf(:) = nalfTot(:)
c          nk = nkTot
c          wave = wavel
c          call yfrm03(wave,ier)
c          call yfl03
c      endif
      call InitMolplo()
!
      kmSav = whichModel
      whichModel = 1
      call LanciaJavPreviewNew()
      whichModel = kmSav
      preRemo = .true.
!gl!  FichierOut = ReflFileName
!
      write(lo,30) '  MODEL STRUCTURE DESCRIPTION  '
!
      call WriteCellInfo
      if (knw == 1) then
          call AllocaTestStuff(1)
      endif
!
      ksubr = 2  
      call leggiriflessi(ier,ksubr)  
!
      if (ier /= 0) then
          call cstop('dirmol')
      endif  
      iyrand = 67543
      if (resm < ResSogLow) then
          nolsq = -1
      else
          nolsq = 0
      endif
      if (resm < ResSogLow) then
          LowRes = 0
      else
          LowRes = 1
      endif
!
!gl!  itle(:) = itleSav(:)
      Titolo = itleSav
!
      return
! 
   10 format(' Some thermal factor in the model are equal to zero !!',a,
     *       ' Set to Wilson value = ',f8.2)
   30 format(80('-'),/,a,/,80('-'))
  100 format('Molecular Replacement procedure:',i5,' atoms from model')
  200 format(f9.2,'-',f9.2)
 6100 format(' Error in directive : ',a)
 6200 format(' Wrong directive in Molecular Replacement modulus:   ',a)
 6300 format(' ',a2, 'has not been declared in derivative directive')
 6400 format('Model from ',a)
 9510 format(' Open error, code =',i5,' file is ',a,
     *      '. PDB coordinates expected')
      end
!---------------------------------------------------------------------
      subroutine Monomer2Model(Action, totModel)
      USE General
      USE RemoModule
!
!-- Action 1: compute total number of models ad allocates ModelRemo
!-- Action 2: transform monomers in models
!
      implicit none
      integer :: Action, i, j, k, totModel, sav, ier, numMono
!
      if (Action == 1) then
          totModel = 0
          do i=1, numbModels
             totModel = totModel + MonomerInModel(i)
          enddo
          if (knw > 0 .and. numbModels == totModel) then
              write(6,*) 'MONOMER2MODEL RETURN'
          endif
          sav = numbModels
          numbModels = totModel
          call AllocaModelRemo(0)
          numbModels = sav
      else
          j = totModel
          do i= numbModels, 1, -1
             numMono = MonomerInModel(i)
             sav = MonomerInModel(i)
             do k=1, numMono
                if (i /= j) then
                    if (.not. allocated(model(j)%atoms)) then
                        natsInModel(j) = natsInModel(i)
                        call AllocaModello(j, ier)
                    endif
                    MonomerInModel(j) = 1
                    MonomerInModel(i) = 1
                    if (natsInModel(i) > natsInModel(j)) then
                        call DeallocaModello(j, ier)
                        natsInModel(j) = natsInModel(i)
                        call AllocaModello(j, ier)
                    endif
                    call CopyModel(i, j)
                endif
                j = j -1
             enddo
             MonomerInModel(i) = sav
          enddo
          numbModels = totModel
          MonomerInModel(:) = 1
      endif
!
!
      return
      end
!---------------------------------------------------------------------
      subroutine GetAli
      USE General
      USE Align
!
      implicit none
      integer :: ier, i, j, k
      integer :: itype, iform, jop, jopen, Lung, nseqTarget, nseqModel
      integer :: Ltarget, Lmodel, ifTarget, stampa, CodiceResiduo1
      integer :: nsT, nsM
      character (len= 1) :: cat, catOld
      character (len=80) :: target, model
!
      call AllocaAllinea(1)
      call InitAllinea
!
      k = Lung(AliFile)
      Buffer1 = '  Alignment information from file ' // AliFile(1:k)
      k = Lung(Buffer1)
      write(lo,10) '        SEQUENCE ALIGNMENT SECTION ', Buffer1(1:k)
!
      nsT = 0
      nsM = 0
      ifTarget = 0
      nseq2 = 0
      nseqTarget = 0
      nseqModel = 0
      nseqTotTarget = 0
      nseqTotModel = 0
      nCateneTarget = 0
      nCateneModel = 0
*     CateneTarget(1) = nseq1
      itype = 2
      iform = 1
      jop =jopen(jrel, AliFile, itype, iform, ier)
!
      do
         read(jrel,'(a)') Buffer1
         if (Buffer1(1:1) == '>') then
             Buffer1(1:1) = ' '
             call shift(Buffer1, k)
             k = index(Buffer1,':')
             target = Buffer1(1:k-1)
             Ltarget = k - 1
             Buffer1(1:k) = ' '
             call shift(Buffer1, k)
             catOld = Buffer1(1:1)
             exit
         endif
      enddo
      rewind jrel
!
      do
         read(jrel,'(a)', end=100) Buffer1
         if (Buffer1(1:1) == ' ') cycle
         if (Buffer1(1:1) == '>') then
             Buffer1(1:1) = ' '
             call shift(Buffer1, k)
             k = index(Buffer1,':')
             if (target == Buffer1(1:k-1)) then
                 ifTarget = 1
                 if (nseqTarget > 0) then
                     nCateneTarget = nCateneTarget + 1
                     CateneTarget(nCateneTarget) = nseqTarget
                     nseqTotTarget = nseqTotTarget + nseqTarget
                     nseqTarget = 0
                 endif
             else
                 ifTarget = 2
                 if (nseqModel > 0) then
                     nCateneModel = nCateneModel + 1
                     CateneModel(nCateneModel) = nseqModel
                     nseqTotModel = nseqTotModel + nseqModel
                     nseqModel = 0
                 endif
             endif
         else
             if (ifTarget == 1) then
                 do i=1, Lung(Buffer1)
                    nseqTarget = nseqTarget + 1
                    nsT = nsT + 1
                    sequenceA(nsT) = Buffer1(i:i)
                 enddo
             else
                 do i=1, Lung(Buffer1)
                    nseqModel = nseqModel + 1
                    nsM = nsM + 1
                    sequenceB(nsM) = Buffer1(i:i)
                    if (Buffer1(i:i) /= '-') then
                        nseq2 = nseq2 + 1
                    endif
                 enddo
             endif
         endif
      enddo
!
  100 close(jrel)
!
      if (nseqTarget > 0) then
          nCateneTarget = nCateneTarget + 1
          CateneTarget(nCateneTarget) = nseqTarget
          nseqTotTarget = nseqTotTarget + nseqTarget
          nseqTarget = 0
      endif
!
      if (nseqModel > 0) then
          nCateneModel = nCateneModel + 1
          CateneModel(nCateneModel) = nseqModel
          nseqTotModel = nseqTotModel + nseqModel
          nseqModel = 0
      endif
!
      nseq1 = nseqTotTarget
      nAllinea = nseq1

      do i=1, nAllinea
         seq1(i) = CodiceResiduo1(sequenceA(i))
         seq2(i) = CodiceResiduo1(sequenceB(i))
      enddo
!
      L_ali = 0
      L_id  = 0
      do k=1, nAllinea
         sequenceM(k) = ' '
         if (sequenceA(k) /= '-' .and. sequenceB(k) /= '-') then
             if (seq1(k) == seq2(k)) then !identical
                 sequenceM(k) = '|'
             else
                if ((seq1(k) == seqR(seq2(k),1)) .or.
     *              (seq1(k) == seqR(seq2(k),2)) .or.
     *              (seq1(k) == seqR(seq2(k),3))) then
                   sequenceM(k) = ':'
                else
                   sequenceM(k) = '.'
                endif
             endif
         endif
         if (sequenceM(k) /= ' ') then
             L_ali = L_ali + 1
         endif
         if (sequenceM(k) == '|') then
             L_id  = L_id  + 1
         endif
      enddo
!
    
      nseq2True = nseq2
      stampa = 1
      call FinalAlign(stampa)
      write(lo,20)
      call AllocaAllinea(3)
      call AllocaAllinea(2)
!
      allocate (TableM(nAllinea,8), stat = ier)
      allocate (vettCA(nAllinea), stat = ier)
      vettCA(:) = 0
      TableM(:,1:6) = 0
      TableM(:,7)   = 1
      TableM(:,8)   = ichar(blank)
!
      return
   10 format(/,80('-'),/,a,/,a,/,80('-'))
   20 format(80('-'))
      end
!---------------------------------------------------------------------
      subroutine Allinea
*************************************************************************
*     This is a program for protein sequence alignment using the standard
*     Needleman-Wunsch dynamic programming. The mutation matrix is from 
*     BLOSUM62 with gap openning penaly=-11 and gap extension panalty=-1. 
*     The program can be freely copied and modified provided the notices 
*     on the head are retained. Comments and bug report should be addressed 
*     to Yang Zhang (Email: zhng@umich.edu). Last update is in 2010/08/03.
*
*     Instructions:
*     1, the program can be compiled by 
*        >gfortran -static -O3 -ffast-math -lm -o align align.f
*     2, simply running the program will give a brief note on how to use it
*     3, You can run the program in following convenient ways:
*        >align F1.fasta F2.fasta (align two sequences in fasta file)
*        >align F1.pdb F2.pdb 1   (align two sequences in PDB file)
*        >align F1.fasta F2.pdb 2 (align Sequence 1 in fasta and 2 in pdb)
*        >align GKDGL EVADELVSE 3 (align sequences typed by keyboard)
*        >align GKDGL F.fasta 4   (align Seq-1 by keyboard and 2 in fasta)
*        >align GKDGL F.pdb 5     (align Seq-1 by keyboard and 2 in pdb)
*************************************************************************
*     This program has been modified in order to be used as subroutine
*************************************************************************
      USE General
      USE Align
      USE Groups
      USE RemoModule
!
      implicit none
      integer :: ier, i, j, k
      integer :: n, ntot, kk, i1, i2, i3, Lid, Lali, stampa
      integer :: WM, mon, at
      real    :: idSeqSav
      character (len=1) :: cat
!
      idSeqSav = idSeq
      j = 0
      do i=1, nChainsInput
         if (tChains(i) == 1) then
             j = j + 1
         endif
      enddo
      if (j == 0) then
          return
      endif
!
      write(lo,10) '        SEQUENCE ALIGNMENT SECTION ',
     *             '  Code by Yang Zhang (Email: zhng@umich.edu)'
      call AllocaAllinea(1)
      call InitAllinea
!
      call SyncChains
!
      cat = model(1)%catena(1,1)
      ntot = 0
      Lid  = 0
      Lali = 0
      nseqTotTarget = 0
      nseqTotModel  = 0
      WM  = 1
      mon = 1
      at  = 1
      j = 0
      do i=1, nChainsInput
         if (tChains(i) == 1) then
             call GetTargetSequence(i)
             nseqTotTarget = nseqTotTarget + nseq1
             j = j + 1
             call GetModelSequence(cat, WM, mon, at)
             cat = model(WM)%catena(at,mon)
             nseqTotModel = nseqTotModel + nseq2
             call CompareSequences
             call ReloadCompare
             n = max0(nseq1, nseq2)
             n = nAllinea
             do k=1, n
                kk = ntot + k
                i1 = ichar(sequenceA(k))
                i2 = ichar(sequenceB(k)) * 128
                i3 = ichar(sequenceM(k)) * 16384
                BufferAll(kk) = i1 + i2 + i3
             enddo
             CateneTarget(j) = n
             ntot = ntot + n
             Lid  = Lid + L_id
             Lali = Lali + L_ali
         endif
      enddo
      nCateneTarget = j
      do kk=1, ntot
         i = BufferAll(kk)
         i3 = i / 16384
         i  = i - i3 * 16384
         i2 = i / 128
         i1 = i - i2 * 128
         sequenceA(kk) = char(i1)
         sequenceB(kk) = char(i2)
         sequenceM(kk) = char(i3)
      enddo
      nAllinea = ntot   ! ATTENZIONE
!
      nseq1 = nseqTotTarget
      nseq2 = nseqTotModel
      L_ali = Lali
      L_id  = Lid
      stampa = 1
      idSeq = idSeqSav
      call FinalAlign(stampa)
      write(lo,20)
      call AllocaAllinea(3)
      call AllocaAllinea(2)
!
      allocate (TableM(nAllinea,8), stat = ier)
      allocate (vettCA(nAllinea), stat = ier)
      vettCA(:) = 0
      TableM(:,1:6) = 0
      TableM(:,7)   = 1
      TableM(:,8)   = ichar(blank)
!
      return
   10 format(80('-'),/,a,/,a,/,80('-'))
   20 format(80('-'),/)
      end
!---------------------------------------------------------------------
      subroutine AllocaAllinea(iAction)
      USE General
      USE Align
!
      implicit none
      integer :: iAction, ier
!
      if (iAction == 1) then
          allocate (seq1(ndimAlign), stat = ier)
          allocate (seq2(ndimAlign), stat = ier)
          allocate (seqR(ndimAlign,3), stat = ier)
          allocate (score(ndimAlign,ndimAlign), stat = ier)
          allocate (sequenceA(ndimAlign), stat = ier)
          allocate (sequenceB(ndimAlign), stat = ier)
          allocate (sequenceM(ndimAlign), stat = ier)
          allocate (val(0:ndimAlign,0:ndimAlign), stat = ier)
          allocate (idir(0:ndimAlign,0:ndimAlign), stat = ier)
          allocate (jpV(0:ndimAlign,0:ndimAlign), stat = ier)
          allocate (jpH(0:ndimAlign,0:ndimAlign), stat = ier)
          allocate (preV(0:ndimAlign,0:ndimAlign), stat = ier)
          allocate (preH(0:ndimAlign,0:ndimAlign), stat = ier)
          allocate (preD(0:ndimAlign,0:ndimAlign), stat = ier)
          allocate (idirH(0:ndimAlign,0:ndimAlign), stat = ier)
          allocate (idirV(0:ndimAlign,0:ndimAlign), stat = ier)
          allocate (BufferAll(ndimAlign), stat = ier)
          sequenceA(:) = ' '
          sequenceB(:) = ' '
          sequenceM(:) = ' '
          BufferAll(:) = 0
      elseif (iAction == 2) then
          allocate(toMutate(nAllinea), stat=ier)
          allocate(CAtoMutate(nAllinea), stat=ier)
          allocate(newResid(nAllinea), stat=ier)
          allocate(from(nAllinea), stat=ier)
          allocate(vettCatena(nAllinea), stat=ier)
          allocate(countCoot(nAllinea), stat=ier)
          toMutate(:)   = 0
          CAtoMutate(:) = 0
          newResid(:)   = 0
          from(:)       = 0
          vettCatena(:) = ' '
          countCoot(:)  = 0
      elseif (iAction == 3) then
          deallocate (seq1, seq2, seqR, score, stat = ier)
          deallocate (val, idir, jpV, jpH, preV, preH, stat = ier)
          deallocate (preD, idirH, idirV, BufferAll, stat = ier)
      elseif (iAction == 4) then
          deallocate (sequenceA, sequenceB, sequenceM,
     *                TableM, vettCA, stat = ier)
          deallocate (toMutate, CAtoMutate, newResid, from,
     *                vettCatena, countCoot, stat = ier)
      endif
!
      return
      end
!---------------------------------------------------------------------
      subroutine FinalAlign(stampa)
      USE General
      USE Align
      USE RemoModule, only : idSeq
!
      implicit none
      integer :: i, j, k, i1, i2, i1p, i2p, kk, nAll, previous, stampa
!
      if (stampa == 1) then
          write(lo,*)
c         write(lo,101) nseq1
*Ori*     write(lo,102) nseq2
c         write(lo,102) nseq2True

          write(lo,101) nseqTotTarget   !nseq1
          write(lo,102) nseqTotModel    !nseq2

          write(lo,103) L_ali
          write(lo,104) L_id
          SeqId = float(L_id)/(nseq2+0.00000001)
          if (idSeq < 0.0) then
              write(lo,105) SeqId, L_id, nseq2
              write(Msg,107) SeqId
              idSeq =  SeqId
          else
              write(lo,106) SeqId, L_id, nseq2, idSeq
              write(Msg,108) idSeq
          endif
          write(lo,*)
          call MRInfo(13)
          call TestoGR(Msg, -1, 2, 1)
      endif
!
      previous = 0
      do k=1, nCateneTarget
         if (nCateneTarget > 1) then
             write(lo,10) k
         endif
         nAll = CateneTarget(k)
         if (mod(nAll,80) == 0) then
             kk = nAll/80
         else
             kk = nAll/80 + 1
         endif
         i1 = 0
         i2 = 0
         do i=1, kk
            i1 = (i-1)*80 + 1
            i2 = i1 + 79
            if (i2 > nAll) then
                i2 = nAll
            endif
            i1p = i1 + previous
            i2p = i2 + previous
            write(lo,20) (sequenceA(j),j=i1p,i2p)
            write(lo,20) (sequenceM(j),j=i1p,i2p)
            write(lo,20) (sequenceB(j),j=i1p,i2p)
            write(lo,30) (mod(j,10),j=i1,i2)
            write(lo,*)
         enddo
         write(lo,*)
         previous = previous + nAll
      enddo
!
*     jumpRes = 0
*     do i=1, nAllinea
*        if (sequenceB(i) == '-') then
*            jumpRes = jumpRes + 1
*        else
*            exit
*        endif
*     enddo
!
      return
  101 format('Length of sequence (target): ',I4)
  102 format('Length of sequence (model) : ',I4)
  103 format('Aligned length: ',I4)
  104 format('Identical length: ',I4)
  105 format('Sequence identity: ',F8.3,' (=',I4,'/',I4,')')
  106 format('Sequence identity: ',F8.3,' (=',I4,'/',I4,')',
     * ' (computed by the program)',/,'Sequence identity: ',F8.3,
     * ' (supplied by the user) will be used')
  107 format('Sequence identity: ',F8.3)
  108 format('Sequence identity: ',F8.3,' (supplied by the user)')
   10 format(' ',34('*'),' Chain #',i2,' ',34('*'),/)
   20 format(2000A1)
   30 format(2000I1)
      end
!---------------------------------------------------------------------
      subroutine InitAllinea
      USE General
      USE Align
!
      implicit none
!
!-- following from BLOSUM62 used in BLAST:
!
      imut( 1,1:23) = (/ 4,-1,-2,-2, 0,-1,-1, 0,-2,-1,-1,-1,-1,-2,-1,
     *                                        1, 0,-3,-2, 0,-2,-1, 0/)
      imut( 2,1:23) = (/-1, 5, 0,-2,-3, 1, 0,-2, 0,-3,-2, 2,-1,-3,-2,
     *                                       -1,-1,-3,-2,-3,-1, 0,-1/)
      imut( 3,1:23) = (/-2, 0, 6, 1,-3, 0, 0, 0, 1,-3,-3, 0,-2,-3,-2,
     *                                        1, 0,-4,-2,-3, 3, 0,-1/)
      imut( 4,1:23) = (/-2,-2, 1, 6,-3, 0, 2,-1,-1,-3,-4,-1,-3,-3,-1,
     *                                        0,-1,-4,-3,-3, 4, 1,-1/)
      imut( 5,1:23) = (/ 0,-3,-3,-3, 9,-3,-4,-3,-3,-1,-1,-3,-1,-2,-3,
     *                                       -1,-1,-2,-2,-1,-3,-3,-2/)
      imut( 6,1:23) = (/-1, 1, 0, 0,-3, 5, 2,-2, 0,-3,-2, 1, 0,-3,-1,
     *                                        0,-1,-2,-1,-2, 0, 3,-1/)
      imut( 7,1:23) = (/-1, 0, 0, 2,-4, 2, 5,-2, 0,-3,-3, 1,-2,-3,-1,
     *                                        0,-1,-3,-2,-2, 1, 4,-1/)
      imut( 8,1:23) = (/ 0,-2, 0,-1,-3,-2,-2, 6,-2,-4,-4,-2,-3,-3,-2,
     *                                        0,-2,-2,-3,-3,-1,-2,-1/)
      imut( 9,1:23) = (/-2, 0, 1,-1,-3, 0, 0,-2, 8,-3,-3,-1,-2,-1,-2,
     *                                       -1,-2,-2, 2,-3, 0, 0,-1/)
      imut(10,1:23) = (/-1,-3,-3,-3,-1,-3,-3,-4,-3, 4, 2,-3, 1, 0,-3,
     *                                       -2,-1,-3,-1, 3,-3,-3,-1/)
      imut(11,1:23) = (/-1,-2,-3,-4,-1,-2,-3,-4,-3, 2, 4,-2, 2, 0,-3,
     *                                       -2,-1,-2,-1, 1,-4,-3,-1/)
      imut(12,1:23) = (/-1, 2, 0,-1,-3, 1, 1,-2,-1,-3,-2, 5,-1,-3,-1,
     *                                        0,-1,-3,-2,-2, 0, 1,-1/)
      imut(13,1:23) = (/-1,-1,-2,-3,-1, 0,-2,-3,-2, 1, 2,-1, 5, 0,-2,
     *                                       -1,-1,-1,-1, 1,-3,-1,-1/)
      imut(14,1:23) = (/-2,-3,-3,-3,-2,-3,-3,-3,-1, 0, 0,-3, 0, 6,-4,
     *                                       -2,-2, 1, 3,-1,-3,-3,-1/)
      imut(15,1:23) = (/-1,-2,-2,-1,-3,-1,-1,-2,-2,-3,-3,-1,-2,-4, 7,
     *                                       -1,-1,-4,-3,-2,-2,-1,-2/)
      imut(16,1:23) = (/ 1,-1, 1, 0,-1, 0, 0, 0,-1,-2,-2, 0,-1,-2,-1,
     *                                        4, 1,-3,-2,-2, 0, 0, 0/)
      imut(17,1:23) = (/ 0,-1, 0,-1,-1,-1,-1,-2,-2,-1,-1,-1,-1,-2,-1,
     *                                        1, 5,-2,-2, 0,-1,-1, 0/)
      imut(18,1:23) = (/-3,-3,-4,-4,-2,-2,-3,-2,-2,-3,-2,-3,-1, 1,-4,
     *                                       -3,-2,11, 2,-3,-4,-3,-2/)
      imut(19,1:23) = (/-2,-2,-2,-3,-2,-1,-2,-3, 2,-1,-1,-2,-1, 3,-3,
     *                                       -2,-2, 2, 7,-1,-3,-2,-1/)
      imut(20,1:23) = (/ 0,-3,-3,-3,-1,-2,-2,-3,-3, 3, 1,-2, 1,-1,-2,
     *                                       -2, 0,-3,-1, 4,-3,-2,-1/)
      imut(21,1:23) = (/-2,-1, 3, 4,-3, 0, 1,-1, 0,-3,-4, 0,-3,-3,-2,
     *                                        0,-1,-4,-3,-3, 4, 1,-1/)
      imut(22,1:23) = (/-1, 0, 0, 1,-3, 3, 4,-2, 0,-3,-3, 1,-1,-3,-1,
     *                                        0,-1,-3,-2,-2, 1, 4,-1/)
      imut(23,1:23) = (/ 0,-1,-1,-1,-2,-1,-1,-1,-1,-1,-1,-1,-1,-1,-2,
     *                                        0, 0,-2,-1,-1,-1,-1,-1/)
!
      AminoCode3(1:23) = (/
     *     'ALA','ARG','ASN','ASP','CYS','GLN','GLU','GLY','HIS','ILE',
     *     'LEU','LYS','MET','PHE','PRO','SER','THR','TRP','TYR','VAL',
     *     'ASX','GLX','UNK'/)
      numbInRes(1:23) = (/
     *         5,   11,    8,    8,    6,    9,    9,    4,   10,    8,
     *         8,   9,     8,   11,    7,    6,    7,   15,   12,    7,
     *         0,   0,     0/)
      AminoCode1(1:23) = (/
     *     'A',  'R',  'N',  'D',  'C',  'Q',  'E',  'G',  'H',  'I',
     *     'L',  'K',  'M',  'F',  'P',  'S',  'T',  'W',  'Y',  'V',
     *     'B',  'Z',  '-'/)

      seqR(1,1:3)=(/1,1,0/)
      seqR(2,1:3)=(/6,12,0/)
      seqR(3,1:3)=(/4,9,16/)
      seqR(4,1:3)=(/3,7,0/)
      seqR(5,1:3)=(/0,0,0/)
      seqR(6,1:3)=(/2,7,12/)
      seqR(7,1:3)=(/4,6,12/)
      seqR(8,1:3)=(/0,0,0/)
      seqR(9,1:3)=(/3,19,0/)
      seqR(10,1:3)=(/11,13,20/)
      seqR(11,1:3)=(/10,13,20/)
      seqR(12,1:3)=(/2,6,7/)
      seqR(13,1:3)=(/10,11,20/)
      seqR(14,1:3)=(/18,19,0/)
      seqR(15,1:3)=(/0,0,0/)
      seqR(16,1:3)=(/1,3,17/)
      seqR(17,1:3)=(/16,0,0/)
      seqR(18,1:3)=(/14,19,0/)
      seqR(19,1:3)=(/9,14,18/)
      seqR(20,1:3)=(/10,11,13/)
      seqR(21,1:3)=(/0,0,0/)
      seqR(22,1:3)=(/0,0,0/)
      seqR(23,1:3)=(/0,0,0/) 
!
      return
      end
!---------------------------------------------------------------------
      subroutine GetTargetSequence(QualeCatena)
      USE General
      USE Align
      USE Groups
!
      implicit none
      integer :: i, j, k, l, ich, QualeCatena
      character (len=1) :: a1
!
      nseq1 = 0
      k = 0
      do i=1, nChainsInput
         do j=1, ResInChains(i)
            k = k + 1
            if (i == QualeCatena) then
                ich = Sequence(k)
                a1 = char(ich)
                do l=1, NumberAminoAcids
                   if (a1 == AminoCode1(l)) then
                       nseq1 = nseq1 + 1
                       seq1(nseq1) = l
                       exit
                   endif
                enddo
            endif
         enddo
      enddo
!
      return
      end
!---------------------------------------------------------------------
      subroutine GetModelSequence(cat, WM, mon, at)
      USE General
      USE Align
      USE RemoModule
!
      implicit none
      integer :: i, j, k, l, oldRes, QualeCatena, WM, mon, at, newRes
      integer :: ii
      character (len=1) :: cat
      character (len=4) :: tipoA, tipoR
!
      if (kverbo > 0) then
          write(6,*) 
          write(6,*) 'subroutine GetModelSequence'
      endif
      oldRes = model(WM)%numResiduo(at,mon) - 1
      nseq2 = 0
      nseq2True = 0
      tutto: do i=WM, numbModels
         do j=mon, MonomerInModel(i)
            do k=at, natsInModel(i)
               if (model(i)%catena(k,j) /= cat) then
                   WM  = i
                   mon = j
                   at  = k
                   exit tutto
               endif
               tipoA = model(i)%tipoAtomo(k, j)(1:4)
               call ucase(tipoA)
               if (tipoA(1:3) == 'CA ') then
                   newRes = model(i)%numResiduo(k,j)
                   if (newRes /= oldRes) then
                       if (newRes > (oldRes + 1)) then
                           do ii=oldRes+1, newRes-1
                              nseq2 = nseq2 + 1
                              seq2(nseq2) = NumberAminoAcids
                              tipoR = AminoCode3(NumberAminoAcids)
                              if (kverbo > 0) then
                                  write(6,20) nseq2, ii,
     *                                  AminoCode3(NumberAminoAcids),
     *                                  AminoCode1(NumberAminoAcids)
                              endif
                           enddo
                       endif
                       tipoR = model(i)%tipoResiduo(k, j)(1:3)
                       call ucase(tipoR)
                       if (tipoR(1:3) == 'MSE') then
                           tipoR(1:3) = 'MET'
                       endif
                       do l=1, NumberAminoAcids
                          if (tipoR(1:3) == AminoCode3(l)) then
                              nseq2 = nseq2 + 1
                              nseq2True = nseq2True + 1
                              seq2(nseq2) = l
                              if (kverbo > 0) then
                                  write(6,20) nseq2, newRes,
     *                                        tipoR(1:3), AminoCode1(l)
                              endif
                              exit
                          endif
                       enddo
                       oldRes = newRes
                   endif
               endif
            enddo
            at = 1
            if (MonomerInModel(i) == 1) then
                mon = 1
                WM = i + 1
            else
                mon = j + 1
                WM = i
            endif
            exit tutto
         enddo
      enddo tutto
!
      if (WM  > numbModels)         WM  = numbModels
      if (mon > MonomerInModel(WM)) mon = MonomerInModel(WM)
      if (at  > natsInModel(WM))    at  = natsInModel(WM)
!
      if (kverbo > 0) then
          write(6,10) (AminoCode1(seq2(l)), l=1, nseq2)
          write(6,*) 'fine subroutine GetModelSequence'
      endif
      return
   10 format(80a1)
   20 format(2i5,2x,a,2x,a)
      end
!---------------------------------------------------------------------
      subroutine SyncChains
      USE General
      USE Align
      USE RemoModule
      USE Groups
!
      implicit none
      integer :: ier, i, j, k, l, n, n3, oldRes, nResModel, previous
      real    :: SIDbest
      character (len=1) :: cat, a1
      character (len=4) :: tipoA, tipoR
      integer, allocatable :: SequenceSav(:), SequenceTM(:,:)
      integer, allocatable :: ResInChainsSav(:), tChainsSav(:)
!
      allocate(SequenceSav(5000), stat = ier)
      allocate(SequenceTM(2,5000), stat = ier)
      allocate(ResInChainsSav(100), stat = ier)
      allocate(tChainsSav(100), stat = ier)
!
      write(6,*) 
      if (kverbo > 0) then
         write(6,*) 'subroutine GetModelSequenceTot'
      endif
      n = 0
      nResModel = 0
      nCateneModel = 0
      CateneModel(:) = 0
      oldRes = -9999
      cat = model(1)%catena(1,1)
      do i=1, numbModels
         do j=1, MonomerInModel(i)
            do k=1, natsInModel(i)
               if (model(i)%catena(k,j) /= cat) then
                   nCateneModel = nCateneModel + 1
                   CateneModel(nCateneModel)  = nResModel
                   cat = model(i)%catena(k,1)
                   nResModel = 0
               endif
               tipoA = model(i)%tipoAtomo(k, j)(1:4)
               call ucase(tipoA)
               if (model(i)%numResiduo(k,j) /= oldRes) then
                   if (tipoA(1:3) == 'CA ') then
                       nResModel = nResModel + 1
                       oldRes = model(i)%numResiduo(k,j)
                       tipoR = model(i)%tipoResiduo(k,j)
                       call ucase(tipoR)
                       if (tipoR(1:3) == 'MSE') then
                           tipoR(1:3) = 'MET'
                       endif
                       do l=1, NumberAminoAcids
                          if (tipoR(1:3) == AminoCode3(l)) then
                              n3 = l
                              exit
                          endif
                       enddo
                       n = n + 1
                       SequenceTM(2,n) = n3
                   endif
               endif
            enddo
         enddo
                   nCateneModel = nCateneModel + 1
                   CateneModel(nCateneModel)  = nResModel
                   nResModel = 0
      enddo
!
      if (nResModel > 0) then
          CateneModel(nCateneModel)  = nResModel
      endif
      if (kverbo > 0) then
          do i=1, nCateneModel
             write(6,*) 'Catena Modello',i,CateneModel(i)
          enddo
!
          write(6,*) 
          write(6,*) 'subroutine SyncChains'
      endif
      n = 0
      do i=1, nChainsInput
         do j=1, ResInChains(i)
            n = n + 1
            a1 = char(Sequence(n))
            call ucase(a1)
            do l=1, NumberAminoAcids
               if (a1 == AminoCode1(l)) then
                   n3 = l
                   exit
               endif
            enddo
            SequenceTM(1,n) = n3
         enddo
      enddo
      if (kverbo > 0) then
          n = 1
          do i=1, nChainsInput
             write(6,*) 'Residui in catena',i,ResInChains(i),
     *                  ' tipo', tChains(i)
             write(6,10) Sequence(n:n+ResInChains(i)-1)
             n = n + ResInChains(i)
          enddo
      endif
!
      ResInChainsSav(:) = ResInChains(:)
      SequenceSav(:) = Sequence(:)
      ResInChains(:) = 0
      Sequence(:) = 0
      tChainsSav(:) = tChains(:)
!
      n = 0
      do i=1, nCateneModel
         nseq2 = CateneModel(i)
         if (i == 1) then
             previous = 0
         else
             previous = sum(CateneModel(1:i-1))
         endif
         seq2(1:nseq2) = SequenceTM(2, previous+1:previous+nseq2)
         SIDbest = -9999
         do j=1, nChainsInput
            if (ResInChainsSav(j) > 0) then
                if (tChainsSav(j) /= 1) then
                    cycle
                endif
                nseq1 = ResInChainsSav(j)
                if (j == 1) then
                    previous = 0
                else
                    previous = sum(iabs(ResInChainsSav(1:j-1)))
                endif
                seq1(1:nseq1) = SequenceTM(1, previous+1:previous+nseq1)
   
                call CompareSequences
                if (SeqId > SIDbest) then
                    SIDbest = SeqId
                    l = j
                endif
            endif
         enddo
         ResInChains(i) = ResInChainsSav(l)
         tChains(i) = tChainsSav(l)
         if (l == 1) then
             previous = 0
         else
             previous = sum(iabs(ResInChainsSav(1:l-1)))
         endif
         do j=1, ResInChains(i)
            Sequence(n+j) = SequenceSav(previous+j)
         enddo
         n = n + ResInChains(i)
         ResInChains(i) = ResInChainsSav(l)
         ResInChainsSav(l) = -ResInChainsSav(l)
      enddo
!
      do i=1, nChainsInput
         if (tChainsSav(i) /= 1) then
             cycle
         endif
         if (ResInChainsSav(i) < 0) then
             cycle
         endif
         if (i == 1) then
             previous = 0
         else
             previous = sum(iabs(ResInChainsSav(1:i-1)))
         endif
         do j=1, ResInChainsSav(i)
            Sequence(n+j) = SequenceSav(previous+j)
         enddo
         n = n + ResInChains(i)
      enddo
!
      j = 0
      n = 1
      do i=1, nChainsInput
         if (ResInChains(i) > 0) then
             j = i
             if (kverbo > 0) then
                 write(6,*) 'Residui in catena',i,ResInChains(i),
     *                      ' tipo', tChains(i)
                 write(6,10) Sequence(n:n+ResInChains(i)-1)
             endif
             n = n + ResInChains(i)
         else
             exit
         endif
      enddo
      nChainsInput = j
!
      deallocate(SequenceSav, SequenceTM, ResInChainsSav,
     *           tChainsSav, stat = ier)
!
      return
   10 format(20i4)
      end
!---------------------------------------------------------------------
      subroutine CompareSequences
      USE General
      USE Align
      USE RemoModule, only : idSeq
!
      implicit none
      integer :: i, j, k
      real    :: score0
!
      do i=1,nseq1
         do j=1,nseq2
            score(i,j)=imut(seq1(i),seq2(j))
         enddo
      enddo

*4*****************************************************************
*     dynamatic program:
******************************************************************
      gap_open=-11
      gap_extn=-1
      call DP(score0)           !W(k)=Go+Ge*k1+Go+Ge*k2, standard NW
c      call DPalt(score0)        !W(k)=Go+Ge*k1+Ge*k2, alternative NW

*5**   calculate sequence identity---------------------------->
      L_id=0
      L_ali=0
      do j=1,nseq2
         if(j2i(j).gt.0)then
            i=j2i(j)
            L_ali=L_ali+1
            if(seq1(i).eq.seq2(j))L_id=L_id+1
         endif
      enddo
!
      if (kverbo > 0) then
          write(lo,*)
          write(lo,101) nseq1
          write(lo,102) nseq2
          write(lo,102) nseq2True
          write(lo,103) L_ali
          write(lo,104) L_id
      endif
      SeqId = float(L_id)/(nseq2+0.00000001)
      if (idSeq < 0.0) then
          if (kverbo > 0) then
              write(lo,105) SeqId, L_id, nseq2
          endif
          idSeq =  SeqId
      else
          if (kverbo > 0) then
              write(lo,106) SeqId, L_id, nseq2, idSeq
          endif
      endif
 101  format('Length of sequence (target): ',I4)
 102  format('Length of sequence (model) : ',I4)
 103  format('Aligned length: ',I4)
 104  format('Identical length: ',I4)
 105  format('Sequence identity: ',F8.3,' (=',I4,'/',I4,')')
 106  format('Sequence identity: ',F8.3,' (=',I4,'/',I4,')',
     * ' (computed by the program)',/,'Sequence identity: ',F8.3,
     * ' (supplied by the user) will be used')
!
*6******************************************************************
***   output aligned sequences
      k=0                       !final aligned order
      i=1                       !on sequence 1
      j=1                       !on sequence 2
 800  continue
      if(i.gt.nseq1.and.j.gt.nseq2)goto 802
      if(i.gt.nseq1.and.j.le.nseq2)then !unaligned C on 1
         k=k+1
         sequenceA(k)='-'
         sequenceB(k)=AminoCode1(seq2(j))
         sequenceM(k)=' '
         j=j+1
         goto 800
      endif
      if(i.le.nseq1.and.j.gt.nseq2)then !unaligned C on 2
         k=k+1
         sequenceA(k)=AminoCode1(seq1(i))
         sequenceB(k)='-'
         sequenceM(k)=' '
         i=i+1
         goto 800
      endif
      if(i.eq.j2i(j))then    !if aligned
         k=k+1
         sequenceA(k)=AminoCode1(seq1(i))
         sequenceB(k)=AminoCode1(seq2(j))
         if(seq1(i).eq.seq2(j))then !identical
            sequenceM(k)=':'
         else
            sequenceM(k)=' '
         endif
         i=i+1
         j=j+1
         goto 800
      elseif(j2i(j).lt.0)then !if gap on 1
         k=k+1
         sequenceA(k)='-'
         sequenceB(k)=AminoCode1(seq2(j))
         sequenceM(k)=' '
         j=j+1
         goto 800
      elseif(j2i(j).gt.0)then !if gap on 2
         k=k+1
         sequenceA(k)=AminoCode1(seq1(i))
         sequenceB(k)='-'
         sequenceM(k)=' '
         i=i+1
         goto 800
      endif
 802  continue

      nAllinea = k
!
      return
      end
!---------------------------------------------------------------------
      subroutine ReloadCompare
      USE General
      USE Align

      implicit none
  
      integer i , k, j, ncons, n_ali_loc,n,j2_ref, limite
      integer L_ali_loc(20), L_id_loc(20),j_iniz,j_fin, Lid, Lali

*5**   calculate sequence identity---------------------------->
      Lid  = L_id
      Lali = L_ali
      L_id=0
      L_ali=0
      ncons=0
      n_ali_loc=0
      j2i_loc=9999
      if (nseq2 > 15) then
          do j=1,nseq2
             if(j2i(j).gt.0)then
                i=j2i(j)
                L_ali=L_ali+1
                j_fin=j-1
                if(L_ali>1)then
                   limite = abs(j2i(j)-j2_ref)!int(j2i(j)/5)
!                   if(((j2i(j)==j2_ref+1).or.(j2i(j)==j2_ref+2)
!     *                .or.(j2i(j)==j2_ref+3).or.(j2i(j)==j2_ref+4)).and.
!     *                (j.ne.nseq2))then
                   if((limite < 5 ).and.(j.ne.nseq2))then
                      ncons = ncons +1
                      if(seq1(i).eq.seq2(j))L_id=L_id+1
                      j2_ref=j2i(j)
                   else 
                      if(j.eq.nseq2)then
!                        if(((j2i(j)==j2_ref+1).or.(j2i(j)==j2_ref+2)
!     *                    .or.(j2i(j)==j2_ref+3).or.(j2i(j)==j2_ref+4)))then
                         if(limite < 5 )then
                             ncons = ncons +1
                             if(seq1(i).eq.seq2(j))L_id=L_id+1
                             j_fin=j
                         endif
                      endif
                      if(ncons>15)then
                        j2i_loc(j_iniz:j_fin)=j2i(j_iniz:j_fin)
                        n_ali_loc=n_ali_loc+1
                        L_ali_loc(n_ali_loc)=ncons 
                        L_id_loc(n_ali_loc)=L_id
                      else
                        do i = 1, ncons
                           j2i_loc(j-i)=j2i(j)-i  
                        enddo
                      endif  
                      ncons=1
                      L_ali=1
                      L_id=0
                      if(seq1(i).eq.seq2(j))L_id=L_id+1
                      j_iniz=j
                      j2_ref=j2i(j)
                   endif
                else
                   ncons=1
                   if(seq1(i).eq.seq2(j))L_id=L_id+1
                   j_iniz=j
                   j2_ref=j2i(j)
                endif
             else
c                if(ncons>15)then
c                  j2i_loc(j_iniz:j_fin)=j2i(j_iniz:j_fin)
c                  n_ali_loc=n_ali_loc+1
c                  L_ali_loc(n_ali_loc)=ncons 
c                  L_id_loc(n_ali_loc)=L_id
c                endif  
c                ncons=1
c                L_ali=1
c                L_id=0
c                j_iniz=j+1
c                j2_ref=j2i(j)
                j2i_loc(j)=j2i(j)
             endif
          enddo
      else
          n_ali_loc=0
      endif
!
!      n_ali_loc=0
      if (n_ali_loc == 0) then
          if (kverbo > 0) then
              write(6,*)
     *        "attenzione! numero di residui allineati troppo basso"
          endif
          j2i_loc= j2i
      else
         Lid  = 0
         Lali = 0
         do j=1,n_ali_loc 
!scrivi le nuove info solo se hanno senso   
            SeqId = float(L_id_loc(j))/(L_ali_loc(j)+0.00000001)
            if (kverbo > 0) then
                write(lo,*)
                write(lo,103)L_ali_loc(j)
                write(lo,104)L_id_loc(j)
                write(lo,105) SeqId, L_id_loc(j), nseq2
                write(lo,*)
            endif
            Lid  = Lid  + L_id_loc(j) 
            Lali = Lali + L_ali_loc(j)
          enddo 
!
      endif
*6******************************************************************

      k=0                       !final aligned order
      i=1                       !on sequence 1
      j=1                       !on sequence 2
      n=0                       !conta i residui delle catene corte
 800  continue
      if(i.gt.nseq1.and.j.gt.nseq2)goto 802
      if(i.gt.nseq1.and.j.le.nseq2)then !unaligned C on 1
         k=k+1
         sequenceA(k)='-'
         sequenceB(k)=AminoCode1(seq2(j))
         sequenceM(k)=' '
         j=j+1
         goto 800
      endif
      if(i.le.nseq1.and.j.gt.nseq2)then !unaligned C on 2
         k=k+1
         sequenceA(k)=AminoCode1(seq1(i))
         sequenceB(k)='-'
         sequenceM(k)=' '
         i=i+1
         goto 800
      endif
      if(i.eq.j2i_loc(j))then    !if aligned
         k=k+1
         sequenceA(k)=AminoCode1(seq1(i))
         sequenceB(k)=AminoCode1(seq2(j))
         if(seq1(i).eq.seq2(j))then !identical
            sequenceM(k)='|'
         else
            if((seq1(i).eq.seqR(seq2(j),1)).or.
     *         (seq1(i).eq.seqR(seq2(j),2)).or.
     *         (seq1(i).eq.seqR(seq2(j),3)))then
              sequenceM(k)=':'
            else
              sequenceM(k)='.'    
            endif
         endif
         !------------per inserire res non allineati---------------------------
!         if(n>0)then
!            sequenceB(k-n:k-1)=AminoCode1(seq2((j-n):j))
!            sequenceM(k-n:k-1)='X'
!            n=0 
!         endif
         !---------------------------------------------------------------------
         i=i+1
         j=j+1
         goto 800
      elseif(j2i_loc(j).lt.0)then !if gap on 1
         k=k+1
         if(AminoCode1(seq2(j)).ne.'-') n=n+1
         sequenceA(k)='-'
         sequenceB(k)=AminoCode1(seq2(j))
         sequenceM(k)=' '
         j=j+1
         goto 800
      elseif(j2i_loc(j).eq.9999)then !if gap on 2
         k=k+1
         n=n+1 
!         sequenceA(k)=AminoCode1(seq1(i))
!         sequenceB(k)=AminoCode1(seq2(j))
!         sequenceM(k)='X'
         i=i+1
         j=j+1 
         goto 800
      elseif(j2i_loc(j).gt.0)then
         k=k+1
         sequenceA(k)=AminoCode1(seq1(i))
         sequenceB(k)='-'
         sequenceM(k)=' '
         i=i+1
         goto 800
      endif
 802  continue

      nAllinea = k
      L_id  = Lid
      L_ali = Lali
!
      return
 103  format('Aligned local length: ',I4)
 104  format('Identical local length: ',I4)
 105  format('Sequence local identity: ',F8.3,' (=',I4,'/',I4,')')
      end
!---------------------------------------------------------------------

********************************************************************
*     This is a standard Needleman-Wunsch dynamic program (by Y. Zhang 2005)
*     1. Count multiple-gap.
*     2. The gap penality W(k)=Go+Ge*k1+Go+Ge*k2 if gap open on both sequences
*     
*     Input: score(i,j), gap_open, gap_extn
*     Output: j2i(j)
*     idir(i,j)=1,2,3, from diagonal, horizontal, vertical
*     val(i,j) is the cumulative score of (i,j)
********************************************************************
      subroutine DP(score0)
      USE Align
!      
      real D,V,H
      
ccc   initializations --------------->
      val(0,0)=0.0 
      do i=1,nseq1
         val(i,0)=gap_extn*i
         preV(i,0)=val(i,0) !not use preV at the beginning
         idir(i,0)=0            !useless
         jpV(i,0)=1             !useless
         jpH(i,0)=i             !useless
      enddo
      do j=1,nseq2
         val(0,j)=gap_extn*j
         preH(0,j)=val(0,j)
         idir(0,j)=0
         jpV(0,j)=j
         jpH(0,j)=1
      enddo
      
ccc   DP ------------------------------>
      do 111 j=1,nseq2
         do 222 i=1,nseq1
ccc   D=VAL(i-1,j-1)+SCORE(i,j)--------------->
            D=val(i-1,j-1)+score(i,j) !from diagonal, val(i,j) is val(i-1,j-1)
ccc   H=H+gap_open ------->
            jpH(i,j)=1
            val1=val(i-1,j)+gap_open !gap_open from both D and V
            val2=preH(i-1,j)+gap_extn !gap_extn from horizontal
            if(val1.gt.val2) then !last step from D or V
               H=val1
            else                !last step from H
               H=val2
               if(i.gt.1)jpH(i,j)=jpH(i-1,j)+1 !record long-gap
            endif
ccc   V=V+gap_open --------->
            jpV(i,j)=1
            val1=val(i,j-1)+gap_open
            val2=preV(i,j-1)+gap_extn
            if(val1.gt.val2) then
               V=val1
            else
               V=val2
               if(j.gt.1)jpV(i,j)=jpV(i,j-1)+1
            endif
            preH(i,j)=H         !unaccepted H
            preV(i,j)=V         !unaccepted V
            
            if(D.gt.H.and.D.gt.V)then
               idir(i,j)=1
               val(i,j)=D
            elseif(H.gt.V)then
               idir(i,j)=2
               val(i,j)=H
            else
               idir(i,j)=3
               val(i,j)=V
            endif
 222     continue
 111  continue
      score0=val(nseq1,nseq2)   !alignment score
      
c     tracing back the pathway:
      do j=1,nseq2
         j2i(j)=-1              !all are not aligned
      enddo
      i=nseq1
      j=nseq2
      do while(i.gt.0.and.j.gt.0)
         if(idir(i,j).eq.1)then !from diagonal
            j2i(j)=i
            i=i-1
            j=j-1
         elseif(idir(i,j).eq.2)then !from horizonal
            it=jpH(i,j)
            do me=1,it
               if(i.gt.0) then
                  i=i-1                       
               endif
            enddo
         else
            it=jpV(i,j)
            do me=1,it
               if(j.gt.0) then
                  j=j-1                       
               endif
            enddo
         endif
      enddo
      
*^^^^^^^^^^^DP finished ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^      
      return
      end
      
********************************************************************
*     This is an alternative implementation of Needleman-Wunsch dynamic program 
*     (by Y. Zhang 2005)
*     1. Count two-layer iteration and multiple-gaps
*     2. The gap penality W(k)=Go+Ge*k1+Ge*k2 if gap open on both sequences
*     
*     Input: score(i,j), gap_open, gap_extn
*     Output: j2i(j)
*     idir(i,j)=1,2,3, from diagonal, horizontal, vertical
*     val(i,j) is the cumulative score of (i,j)
********************************************************************
      subroutine DPalt(score0)
      USE Align
!
ccc   initializations --------------->
      val(0,0)=0.0
      do i=1,nseq1
        val(i,0)=0
        idir(i,0)=0
        preD(i,0)=0.0
        preH(i,0)=-1000.0
        preV(i,0)=-1000.0
      enddo
      do j=1,nseq2
        val(0,j)=0
        idir(0,j)=0
        preD(0,j)=0.0
        preH(0,j)=-1000.0
        preV(0,j)=-1000.0
      enddo
      
ccc   DP ------------------------------>
      do 111 j=1,nseq2
         do 222 i=1,nseq1
ccc   preD=VAL(i-1,j-1)+SCORE(i,j)--------------->
            preD(i,j)=val(i-1,j-1)+score(i,j)
ccc   preH: pre-accepted H----------------------->
            D=preD(i-1,j)+gap_open
            H=preH(i-1,j)+gap_extn
            V=preV(i-1,j)+gap_extn
            if(D.gt.H.and.D.gt.V)then
               preH(i,j)=D
               idirH(i-1,j)=1
            elseif(H.gt.V)then
               preH(i,j)=H
               idirH(i-1,j)=2
            else
               preH(i,j)=V
               idirH(i-1,j)=3
            endif
ccc   preV: pre-accepted V----------------------->
            D=preD(i,j-1)+gap_open
            H=preH(i,j-1)+gap_extn
            V=preV(i,j-1)+gap_extn
            if(D.gt.H.and.D.gt.V)then
               preV(i,j)=D
               idirV(i,j-1)=1
            elseif(H.gt.V)then
               preV(i,j)=H
               idirV(i,j-1)=2
            else
               preV(i,j)=V
               idirV(i,j-1)=3
            endif
            
ccc   decide idir(i,j)----------->
            if(preD(i,j).gt.preH(i,j).and.preD(i,j).gt.preV(i,j))then
               idir(i,j)=1
               val(i,j)=preD(i,j)
            elseif(preH(i,j).gt.preV(i,j))then
               idir(i,j)=2
               val(i,j)=preH(i,j)
            else
               idir(i,j)=3
               val(i,j)=preV(i,j)
            endif
 222     continue
 111  continue
      score0=val(nseq1,nseq2)   !alignment score
      
ccc   tracing back the pathway:
      do j=1,nseq2
        j2i(j)=-1              !all are not aligned
      enddo
      i=nseq1
      j=nseq2
      do while(i.gt.0.and.j.gt.0)
         if(idir(i,j).eq.1)then !from diagonal
            j2i(j)=i
            i=i-1
            j=j-1
         elseif(idir(i,j).eq.2)then
            i=i-1
            idir(i,j)=idirH(i,j)
         else
            j=j-1
            idir(i,j)=idirV(i,j)
         endif
      enddo
      
*^^^^^^^^^^^DP finished ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^      
      return
      end
!-----------------------------------------------------------------------
      subroutine AccumulaSpecie(nwTot, nalfTot, nkTot)
      USE General
      integer nwTot(18), nalfTot(19), nkTot
!
      if (nkTot == 0) then
          nwTot(:) = nw(:)
          nalfTot(:) = nalf(:)
          nkTot = nk
      else
          do i=1, nk
             iAdded = 0
             do j=1, nkTot
                if (nalf(i) == nalfTot(j)) then
                    nwTot(i) = nwTot(i) + nw(i)
                    iAdded = 1
                    exit
                endif
             enddo
             if (iAdded == 0) then
                 nkTot = nkTot + 1
                 nwTot(nkTot) = nw(i)
                 nalfTot(nkTot) = nalf(i)
             endif
          enddo
      endif
!
      return
      end
!---------------------------------------------------------------------
      subroutine calc_dist_max (n)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE riflessi_c
      USE RemoModule
      USE PhaseModule
!
      integer :: n
      common /util/radius,radius1
      dimension x1(3),rrv(3)
c     dimension baricenter(3)
c           
*     do i = 1, nats
*        x1(1:3)=xyzs(1:3,i)
*        call MoltMatVec(rm, x1, rrv)
*        xyzSk(1:3,i) = rrv(1:3)
*     end do
c

      distmaxPdb=-9999                
c     kk = model(WhichModel)%specie(natsMR,1)/nzConst
c     kk = no(kk)
c     baricenter(1:3)=model(WhichModel)%ortho(1:3,natsMR,1) * kk
c     somma1 = kk

      if (natsMR == 1) then
          distmaxPdb = 38
      else

!
      do j1=1, natsMR-1
c        kk = model(WhichModel)%specie(j1,1)/nzConst
c        kk = no(kk)
c        somma1 = somma1 + kk
c        do i=1,3
c           baricenter(i) = baricenter(i)
c    *                    + model(WhichModel)%ortho(i,j1,1) * kk
c        enddo
!
         do j2=j1+1,natsMR
            dist = 0
            do i=1,3
               dist = dist
     *              + (model(WhichModel)%ortho(i,j1,1) 
     *              -  model(WhichModel)%ortho(i,j2,1)) ** 2
            end do
            dist = sqrt(dist)
            if (dist > distmaxPdb) distmaxPdb = dist
         enddo
      enddo

      endif

!
      if (ifRemo == 1 .and. n == 1) then
          write(lo,'(a,f8.2)')' Maximum distance among atoms of the' //
     *                        ' model molecule', distmaxPDB
      endif
!
c     if (use_E) return ! occhio
!
c     do i=1,3
c        baricenter(i) = baricenter(i) / somma1
c     enddo
c     if (kverbo > 0) then
c         write(6,*) 'coordinates of baricenter ',baricenter(1:3)
c     endif
!
!--calcolo il raggio di girazione
!
c     somma1 = 0.0
c     do j1=1, natsMR
c        dist=0.0
c        do i=1,3
c           dist = dist + (model(WhichModel)%ortho(i,j1,1)
c    *                  - baricenter(i))**2
c        end do
c        somma1 = somma1 + dist
c     enddo

      radius1 = sqrt(3.0/5.0) * distmaxPDB
      if (kverbo > 0) write(lo,*) 'radius of gyration',radius1
!
      return 
      end
!---------------------------------------------------------------------
      subroutine cella_cubica(n)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE riflessi_c
      USE PhaseModule
      USE RemoModule
!
      integer :: n
      dimension celltemp(13)
      dimension kshif(3)
      character*16 spg1

      call Cancella(1)
      call Cancella(2)
      call Cancella(4)
!
      fact=4.0
      if(ifModify==1) fact=1.0
c
      celltemp(4:6)  = 90
      celltemp(1:3)  = distmaxPdb*fact
      celltemp(7:13) = 0
c     write(6,*) 'Dimcell ',celltemp(1)
c
c--ritorno al sistema cristallografico di partenza
c

      dimcell = celltemp(1)
!
      call CreaCellInfo(celltemp) ! (1:6))
!     call WriteCellInfo
      if (n == 1) then
          write(lo,12) celltemp(1)
      endif
   12 format(' Cubic cell length  ',f8.1,a)
!
      kshif(:) = 0
      ishif    = 0
      ier      = 0
      spg1     = 'p 1             ' 
!
      nSpaceGSav(:) = nSpaceG(:)
      read(spg1,'(16a1)') nSpaceG
!
      call CreaSymmetryInfo(ier)
      if (ier < 0) then
          return
      endif
!
      nsymTrue = nsym
!
      jspini = -1 ! croc
      call xspinb
!
      kpolTrue = kpol

      return 
      end
!---------------------------------------------------------------------
      subroutine CalcolaRange()
      USE General
      USE Symmetry
      USE Riflessi
      USE RemoModule
      USE PhaseModule
      common /user1/ ran_low, ran_high, userdef, numeroLim
    
!
      rho_max_oss=0.0
      rho_min_oss=9999.0
      do k=1,nrefl
        if(rhov(k)<rho_min_oss) rho_min_oss=rhov(k)
        if(rhov(k)>rho_max_oss) rho_max_oss=rhov(k)
      enddo
      if(ifModify==1) then
        resol1=0.5/sqrt(rho_max_oss)
        resol2=0.5/sqrt(rho_min_oss)
      endif
c
c--range fornito dall'user
c
      if (userdef == 1) then
          resol1=max(resol1,0.5/sqrt(rho_max_oss))
          resol2=min(resol2,0.5/sqrt(rho_min_oss))
      else
c
c--calcolo automatico del range 
canna
c  il numero min di riflessi da utilizzare �1000
c
          div=10.0
          numeroBest=nrefl/div

c--numeroLim fornito dall'user
          if (numeroLim < 0) then

            if (ksize > 3) then
              numeroLim = 3500
              if(rmsStr > 1.0 ) numeroLim = 5000
c              if(idSeq > 0.85) numeroLim = 6000 !se è buona la resol deve essere più alta
              if(idSeq < 0.5) numeroLim = 2700 !se fa schifo si deve lavorare a resol più bassa
            else
              numeroLim = nrefl / 2.0
            endif

          endif
          do while(numeroBest<numeroLim)
             div = div - 0.1
             numeroBest = nrefl / div
          enddo
          do while(numeroBest>7000)
             div = div + 1
             numeroBest = nrefl / div
          enddo

          if(kverbo>0) then
            write(6,*) 'numeroBest',numeroBest,'dividendo',div
            write(6,*)'ksize',ksize
          endif
c
          resol1    =  9999
          resol2    = -9999
          nstep=50
          step=(rho_max_oss-rho_min_oss)/float(nstep)
c
**        ciclo_1: do rho_curr=rho_min_oss,rho_max_oss,step
          rho_curr=rho_min_oss
          ciclo_1: do while (rho_curr <= rho_max_oss)
             nrr = 0
             do k=1,nrefl
c--taglio a risoluzione alta 
                if (rhov(k) > rho_curr) cycle  
                res = 0.5 / sqrt(rhov(k))
! condizione per non contare troppo i riflessi a bassa risoluzione
                if (res < 10.0)  nrr = nrr + 1  
c               nrr = nrr + 1
                if (res < resol1) resol1=res
                if (res > resol2) resol2=res
             enddo
c--condizione di uscita
             if (nrr > numeroBest) then
c                write(6,*) 'limite raggiunto',nrr
                 exit ciclo_1
             endif
             rho_curr = rho_curr + step
          enddo  ciclo_1
      endif

      if (ran_high > -99.00) then
          userdef = 2
          resol1 = ran_high
      elseif (ran_low > -99.00) then
          userdef = 2
          resol2 = ran_low
      endif

! di default idSeq=1 e rmsStr=0 cioè la struttura è facile;
! se uno dei due parametri indica che la struttura non lo è,
! o la struttura è grande o l'utente ha scelto il range di risol
! il taglio a bassa risoluzione non va applicato 
!c!   if((idSeq >= 0.8 .and. rmsStr < 1.0).and. ksize<8 .and. 
!!!   if((idSeq >= idSeqThre .and. rmsStr < 1.0).and. ksize<8 .and. 

*     go to 1 ! attivare x versione 26 giugno
      if(idSeq >= 0.5 .and. userdef == 0 .and. resol1 >=5.0) then
         resol1 = min(resol1*0.9,4.9)
      endif

      if((idSeq >= 0.5 .and. rmsStr < 1.0).and. ksize<8 .and. 
     *    userdef==0 .and. resol1 < 5.0) resol2 = 7.0 !!!6.0

*   1 continue ! attivare x versione 26 giugno

c     write(6,*) 'CalcolaRange', idSeq,rmsStr,ksize,
c    *                            userdef,resol1,resol2

c
      return 
      end
!---------------------------------------------------------------------
      subroutine riflessi_cubici(n)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE riflessi_c
      USE Mappa
*     USE ParametriMappa
      USE riflessi_c
      USE Grafici
      USE RemoModule
      USE PhaseModule
!
      integer hmax,npSav(3), n
      integer hklmin(3),hklmax(3),hkl(3),ihmxo(3)
      dimension vet(3)
      character*80 Buffer
      common /user/ resol1o
      common /user1/ ran_low, ran_high, userdef, numeroLim

c
c--calcolo il range ottimale
c
      call CalcolaRange()
      write(Buffer,10) resol2,resol1
      call NoBlanks(Buffer, lBuffer)
      write(Msg,12) Buffer(1:lBuffer), '<span lang="A">A</span>'
      if (n == 1) then
          call TestoGR(Msg, -1, 2, 1)
      endif
   10 format('[',f5.2,' , ',f5.2,' ]')
   12 format('Used resolution range ',a,' ',a)
      
      if (WasNegative < 0) then
          write(Msg,14) WasNegative
          call OneBlankOnly(Msg)
          call TestoGR(Msg, color_LIGHTRED, 2, 1)
   14     format('Negative Thermal Factor ',f8.2,' set to 0.001')
      endif
 
      if(use_E) then
         if(userdef == 0) resol1 = max(2.5,resol1)
!use_resplus ha senso che sia true solo se resol1 è più grande di 2.5 
         if (resol1 <= 2.5) use_resplus = .false.
!         if(idSeq < 0.45 .or. rmsStr > 0.9) use_resplus = .false.
         if(idSeq < 0.45 .or. rmsStr > 0.9) use_resplus = .false. 
         resol1o = resol1
!conservo resol1 originale e calcolo il nuovo resol1 a risoluzione più alta
         if(userdef == 0) then
            if(use_resplus) resol1 = max(2.5,resol1 * 0.8)
         endif
!controllo che non si superi la risoluzione sperimentale resm  -  dedi 23/10/18
         if (resol1o > ResEff) then
             resol1 = max(ResEff,resol1)   ! risoluzione efficace  ???
         else
             resol1 = max(resm,resol1)     ! risoluzione sperimentale  ???
         endif
!
      endif
      if (n == 1) then 
          if (use_resplus)then 
              write(lo,'(a,2f10.2)') 
     *             ' Calculated Resolution range',resol2,resol1o
              write(lo,'(a,2f10.2)')
     *             ' Optimized  Resolution range',resol2,resol1
          else
              write(lo,'(a,2f10.2)') 
     *             ' Calculated Resolution range',resol2,resol1
          endif         
      endif         
c
      !
!--porto le coordinate nella cella ingrandita
!
      do j=1, MonomerInModel(WhichModel)
         do i=1, natsInModel(WhichModel)
            model(WhichModel)%atoms(1:3,i,j) = 
     *            model(WhichModel)%ortho(1:3,i,j) / dimcell
         enddo
      enddo
c
c--genero anche a bassissima risoluzione per fare la traslation function
c
      resolsav=resol2
      if(ifModify==0) resol2=9999.
      inizMR = 1
      ifinMR = natsMR
c--ivecchio=1 vecchio calcolo
c--ivecchio=0 nuovo calcolo
c--ivecchio=2 nuovo calcolo con statistiche
      ivecchio=0
c     ivecchio=2
c
      rhomax1 = (0.5/resol1)**2
      rhomax2 = (0.5/resol2)**2   
      eps1=rhomax1/25.  ! allargo leggermente la corona circolare
      if(ifModify==1) eps1=0.0

      previsti=0.5*(4.0/3.0)*Pi*(dimcell/resol1)**3
      nRifDimC=ceiling(1.2*previsti)  
      if(use_resplus) then
         hmaxo = ceiling(dimcell/resol1o)+1
         ihmxSav(1:3)=hmaxo
      endif
      hmax = ceiling(dimcell/resol1)+1
      ihmx(1:3)=hmax
 
      lty = 0
      nrr = 0
      hklmin(:) =  9999
      hklmax(:) = -9999
      resmin    =  9999
      resmax    = -9999
      fcmax     = -9999
!
!-- conta i riflessi per un corretto uso di AllocaRiflessi_c
!
      do indh=0,hmax
         indkmin=-hmax
         if(indh==0) indkmin=0
         do indk=indkmin,hmax
            indlmin=-hmax
            if(indh==0.and.indk==0) indlmin=1
            do indl=indlmin,hmax
c
               rho1 = rhof(pp,indh,indk,indl)
               rho  = rho1 * rho1
               if (rho > rhomax1+eps1. or. rho < rhomax2-eps1) cycle
               nrr = nrr + 1
            enddo
         enddo
      enddo
c     write(6,*) 'riflessi effettiv',nrr
c
      Buffer = 'Structure Factor Calculation'
      call scrper(Buffer,0,0)
!
      nRifDimC=nrr 
      call AllocaRiflessi_c(1)
!
      if(use_E) then
        nperc  = 20
        iperc0 = nRifDimC / nperc
        iperc  = iperc0
        jperc  = 0
      endif
!
      rhomaxPseudo = -9999
      nrr = 0
      do indh=0,hmax
         indkmin=-hmax
         if(indh==0) indkmin=0
         do indk=indkmin,hmax
            indlmin=-hmax
            if(indh==0.and.indk==0) indlmin=1
            do indl=indlmin,hmax
c
               rho1 = rhof(pp,indh,indk,indl)
               rho  = rho1 * rho1
               if (rho > rhomax1+eps1. or. rho < rhomax2-eps1) cycle

               vet(1)=indh
               vet(2)=indk
               vet(3)=indl
               call controllo_indici_interi(vet,hkl)
c
c
               nrr = nrr + 1
               if ( rho > rhomaxPseudo) then
                    rhomaxPseudo = rho
               endif
               khlc(1:3,nrr) = hkl(1:3)
               rhovc(nrr) = rho
               indr = hkl(1) * ifat1C + hkl(2) * ifat2C + hkl(3)
               superind(indr) = nrr
               if(ivecchio==1.or.ivecchio==2) then
                  call sftrNewRotNew(hkl, rho, fc)
                  fcvetc(nrr) = fc     ! fc**2
                  if (sqrt(fc) > fcmax) fcmax = sqrt(fc)
! -- calcolo Ecalc
                  if(ivecchio==2) then
                    fcvetc(nrr)=sqrt(fcvetc(nrr))  !solo per fare le statistiche
                  else
                    ecvetc(nrr) = c_normalizza(rho,fc)
                  endif
! -- calcolo Ecalc
               endif
cdedi
               do j1=1,3
                  if (hkl(j1) < hklmin(j1)) hklmin(j1)=hkl(j1)
                  if (hkl(j1) > hklmax(j1)) hklmax(j1)=hkl(j1)
               end do 
               res = 0.5 / sqrt(rho)
               if (res < resmin) resmin=res
               if (res > resmax) resmax=res
            enddo
         enddo
      enddo
c
      nRifDimC = nrr
cdedi --  nuovo calcolo Fcal
!
      if(ivecchio==0.or.ivecchio==2) then
      ihmx(:) = hklmax(:) 
      if(kverbo>0) write(6,*) 'NP prima',np
      npSav(:)=np(:)
      ifRemo = 2
      call CheckGrid()
      ifRemo = 1
      badd=0.0
      if(np(3)>400) then
        badd=bt*np(3)/400.
        if(kverbo>0) write(lo,'(a,f8.2)') ' smeared by Badd ',badd
        np(3)=400
c
c--per non far andare in errore la FFT
c
        do i=1,3
          np(i)=np(3)
          if (np(i).le.2*ihmx(i)) np(i)=2*ihmx(i)+1    ! Dritan
          if (i.eq.3) np(i)=np(i)+mod(np(i),2)
        enddo
      endif
      if(kverbo>0) write(6,*) 'NP dopo',np
      call AllocaMappa(2)
      call AllocaMappa(1)
      call ChemInfo_MR(badd)
      if(ivecchio==2)  call StatR_MR()
      call AllocaMappa(2)
      np(:)=npSav(:)
      n100=nrifDimC/100
      if(use_E) then
         Msg = 'Structure factors normalization'
         call PrintMess(Msg)
      endif
      do i=1,nrifDimC
         fc=fcvets(i)
         if(badd>0.0) then
           arg=badd*rhovc(i)
           fc=fc*exp(arg)
         endif
c        if (fc > fcmax) fcmax = fc
c        write(88,'(3i5,4f12.3)') khlc(1:3,i),fcvetc(i),0.001,fc,0.001
         fcvetc(i)=fc*fc
*        write(6,*) i,fcvets(i),badd,rhovc(i),fcvetc(i)
         if (mod(i,n100) == 0) call DoSingleIteration()
c
c
         if(use_E) then
           if (i == iperc) then
             jperc=jperc+1
             iperc=iperc+iperc0
             call scrper(' ',jperc,nperc) 
           endif
           ecvetc(i) = c_normalizza(rhovc(i),fcvetc(i))
         endif
      enddo
cdedi --  nuovo calcolo Fcal
      endif
      call toflush()

cdedi
! -- normalizza Ecalc
*     stop
      if(use_E) then
        call Renor_MR(nRifDimC,2)
      endif
! -- normalizza Ecalc
cdedi
c
*     nz(1:nats)=nzsav(1:nats)
*     xyzo(1:3,1:nats) = xyzSk(1:3,1:nats)
      resol2=resolsav
c
      if (n == 1) then
          write(lo,101) nRifDimC
          write(lo,102) hklmin(1),hklmax(1)
          write(lo,103) hklmin(2),hklmax(2)
          write(lo,104) hklmin(3),hklmax(3)
      endif
c     if(kverbo>0) write(lo,105) resmin, resmax
c
 
 101  format(" Number of generated reflections:",i10)
 102  format(" Range of H: Min=",I5,'  Max=',i4)
 103  format(" Range of K: Min=",I5,'  Max=',i4)
 104  format(" Range of L: Min=",I5,'  Max=',i4)
 105  format(" Risoluzione minima e': ",1F10.4,"    la massima e':"
     *        ,1F10.4,'   Ang')
c106  format("Il fattore di struttura massimo e':",f10.3)
c
      return 
      end
!---------------------------------------------------------------------
      subroutine Remo(ier)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Molcom
      USE TraslaSolution
      USE Mappa
      USE Grafici
      USE Html
      USE Param
      USE RemoModule
      USE PhaseModule
*     USE RiflessiSIGMAA
      USE Solutions
      USE Groups, only : nResidStored, nAcid
      USE RuotaRiflessi, only : nreflSelRot, nreflSelTra, nreflSelRemo
      USE cc_vet_comm
!
      logical :: noWrite,plusModel
      real    ::  rmtt(3,3)
      integer :: ncount, maxcount, WM, rMTZ, numbSav
      integer :: trial, dove, npSav(3), box, tipo, ies_opti
      common /util/radius,radius1
      common /util2/ noWrite, ncount, maxcount,plusModel
      dimension ivet(3), x1(3), x2(3),b(3,3),btra(3,3)
      dimension fragShift(3)
      dimension xopti(6)
      character string1*11, string2*80
      logical single
      character Inteps*128
      logical :: riduci
 
      real, allocatable :: work_fom(:)
!
      ifCristina = 1
      ifCristina = 0
      riduci=.false.
      noWrite=.true.
      single =.true.
!
      if (ifAmb == 0) then
         if (nResidStored > 0) then
             ifAmb = 1
         elseif (nAcid > 0 .and. nResidStored == 0) then
             ifAmb = 4
         endif
      endif
!
      ier = 0
      if (knw == 1) then
          ifExamin = 1
      else
          ifExamin = 0
      endif
      call AllocaTestStuff(1)
      call AllocaPherrMod(3)
      call InitMolecular(ier, rMTZ)
      if (ier < 0) return
!
      if (ifPositionedVet(1) == 0 .and. ifAdjust == 1) then
          call AffinaConRefmac(1)
      endif
!
      iPlt = SIMPLE
      ifSingle = 1
      QualeAbilita = 2
      if (knw == 1) then
          ifExamin = 1
      else
          ifExamin = 0
      endif
      ifTraslaFrammento = 1
      resol1Sav = resol1
      write(lo,40)
****  call WriteCheshire()

!---inizio loop sul gruppo spaziale !!!!!!!!!
!---cambia il gruppo spaziale!!!!!

!
! inizio ciclo sui modelli
      Modelli: do WM = 1, numbModels
         WhichModel = WM
         use_resplus=.true.
         resol1 = resol1Sav
         natsMR = natsInModel(WhichModel)
         nMolMR = MonomerInModel(WhichModel)
         ifTraOnly = ifTraOnlyVet(WhichModel)
         ifRotSel =  ifRotSelVet(WhichModel)
         ifPositioned = ifPositionedVet(WhichModel)
         RotAppl(1:3) = RotApplVet(WhichModel, 1:3)
         TranslAppl(1:3) = TranslApplVet(WhichModel, 1:3)
         ifRotAppl = ifRotApplVet(WhichModel)
         if (ifRotSel == 1) then
             RotAppl(1:3) = RotAppl1Vet(WhichModel,1:3)
         endif
c considero solo il primo monomero del modello in oggetto
         model(WhichModel)%considerato(:) = 0
         model(WhichModel)%considerato(1) = 1
!
         if (kcpu > 0) call CPUTime0('CPU Sfc')
         call calc_dist_max(WM)
         call cella_cubica(WM)
         call riflessi_cubici(WM)
         if (kcpu > 0) call CPUTime('CPU Sfc', 1)
!
         call MRInfo(1)
!
         if(ifModify==1) then
!  devo fare il calcolo della Patterson in P1 per il modello
           call PreModifyModel(rmtt)
         endif
!
!
**       call cancella(15)
         call RestoreLists123(1)
         call RestoreLists123(2)
         call InitMolplo()
!
         do j=1, MonomerInModel(WhichModel)
            do i=1, natsInModel(WhichModel)
               x1(1:3)=model(WhichModel)%ortho(1:3,i,j)
               call MoltMatVec(rmi, x1, x2)
               model(WhichModel)%atoms(1:3,i,j) = x2(1:3)
               model(WhichModel)%saved(1:3,i,j) = x2(1:3)
               nkz = 0
               kz = 0
***            kz = serial(i) ! queste parti sono temporaneamente commentate
               do k=1,model(WhichModel)%nk
                  if (model(WhichModel)%nalf(k) == kz) then
                      nkz = k * nzConst
                  endif
               enddo
               if (nkz == 0) then
***                call cstop('nessuna corrispondenza')
               endif
***            nz(i) = nkz
***            serial(i) = kblock(i)
            enddo
         enddo
!        call scriviframmento
         BTot(:,:) = 0
         BTot(1,1) = 1
         BTot(2,2) = 1
         BTot(3,3) = 1
!
!--recupero la informazione sui riflessi osservati
!
*        call AllocaRiflessi1(1)
         ier = 0
         ksubr = 2
         call LeggiRiflessi(ier,ksubr)
         do i=1,nrefl
             ivet(1:3) = khl(1:3,i)
             call cmult2002(ivet,eps,multVal)
             epsv(i) = eps
             mult(i) = multVal
         enddo
!
cdedi   
! -- normalizza Eobs
         if (use_E) then
             call Renor_MR(nrefl,1)
         endif
! -- normalizza Eobs
cdedi
         if(ifModify==1) then
            call ModifyModel()
            write(6,*) ' '
            write(6,*) ' End of the Model Modification procedure '
            write(6,*) ' '
            stop
         endif
!
!-- Initialize Cheshire environment
!-- compute limits on translation and Eulerian angles
!
         nGridMR(:) = - 9999
         if (nMolMR > 1 .and. kpol /= 0) then
             kpolSav = kpol
             kpol = 0
             call NewCheshire(2)
             nGridMR(:) = nGridv(:)
             kpol = kpolSav
         endif
         call NewCheshire(2)
c         resol1=resol1Sav
         do i=1,3
            if (nGridv(i) > nGridMR(i)) then
                nGridMR(i) = nGridv(i)
            endif
         enddo
         if (WhichModel == 1) then
             write(lo,*)
             write(lo,40)
             call WriteCheshire()
         endif
!
!-- Modify F(obs)
!
!---da fare solo per il primo gruppo spaziale!!!!!
!
         if (WM == 1) then
             numeroSoluzioni = 1
         else
             numeroSoluzioni = nSolStored
   
             do nums=1, numeroSoluzioni
                work5(nums)  = finsolcan(nums)%Fom
                iwork5(nums) = nums
             enddo
             iuno = -1
             call sortall3(iuno,work5,iuno,numeroSoluzioni,iwork5)

         endif

         do nums=1, numeroSoluzioni
            if (numeroSoluzioni == 1) then
                if (knw > 0) write(lo,16) '  ROTATION STAGE'
            else
                if (knw > 0) then
                    write(lo,17) '  ROTATION STAGE Solution #', nums 
                    write(lo,18) 
     *                   '   ROTATION STAGE for the monomer/model ', WM,
     *                   ' given the position',
     *                   '   of the previuosly located ',WM-1, 
     *                   ' monomer(s)/model(s). (Solution ',nums,')'


                    write(lo,301)
                    write(lo,310) nums, numeroSoluzioni
                    write(lo,301)
                else
                    if (nums == 1) write(lo,320) WhichModel,WhichModel-1
                endif

            j1 = nums
            i1 = iwork5(j1)
            do k1=1, WhichModel-1
               do k2=1, MonomerInModel(k1)
                  if (knw == 1) then
                     if (k1 == 1) write(lo,198) j1,numeroSoluzioni 
                     write(lo,'(16x,i8,2f8.3,f8.2)') 
     &                    finsolcan(i1)%flag(k1,k2), 
     *                    finsolcan(i1)%RFom,  !RotFom
     &                    finsolcan(i1)%Fom,   !TraFom 
     *                    finsolcan(i1)%MPE
                     write(lo,'(a,i9,3f8.1,3f8.3)') 'RotVal e TraVal',
     &                    finsolcan(i1)%flag(k1,k2), 
     *                    finsolcan(i1)%RotVal(1:3,k1,k2)*rtod,
     *                    finsolcan(i1)%TraVal(1:3,k1,k2)
*                 else
*                    if (k1 == 1) write(lo,199) j1,numeroSoluzioni
*                    write(lo,'(16x,i8,2f8.3)') 
*    &                    finsolcan(i1)%flag(k1,k2), 
*    *                    finsolcan(i1)%RFom,  !RotFom
*    &                    finsolcan(i1)%Fom    !TraFom
                  endif
               enddo
            enddo
            endif
         
  301 format(80('-'))
  198 format(' Solution ',i2,' /',i2,':  Trial    RFom    TFom    MPE')
  199 format(' Solution ',i2,' /',i2,':  Trial    RFom    TFom')
  310 format(/,' Combinations for solution ',i2,' of ',i2,/)
  320 format(/,' Search of the model ',i2,' given the position',/,
     *         ' of the previously located ',i2,' model(s)',//,
     *         ' Solution   TFom    R(F)    R(free)    FFom   cc_FoFc')
!---------------------------------------------------------------
c
            if (kcpu > 0) call CPUTime0('CPU ReCompute')
c
            if (.not.use_E) then
                foper(:) = fovet(:)
                call ReComputeFobsNew()
            endif
            if(ifModify==2) call CalcolaPatterson()
c
            if (kcpu > 0) call CPUTime('CPU ReCompute', 1)
c
            call toflush()

            iOK = 0
         
            if (nMolMR > 1 .and. use_pseudo ) then
                call InitMolplo()
                call CheckPseudo(iOK)
            else
                use_pseudo=.false.
            endif
!
!--trova la migliore orientazione
!
             if (kcpu > 0) call CPUTime0('CPU Rotate')
c
             call RotMolecular(WM)
c
             if (kcpu > 0) call CPUTime('CPU Rotate', 1)
c
             call toflush()
!
!--analizzare i risultati e seleziona le migliori soluzioni
!
             if (kcpu > 0) call CPUTime0('CPU Analisi')
c
             call AnalisiRotSolution(WM)
c
             if (kcpu > 0) call CPUTime('CPU Analisi', 1)
             call toflush()
             call InitSigmaA(2)
c
             if(ifModify==2) call ApplicaPatterson()
             if (ifProtein == 0) then
                 call AllocaAtomi(2)
             endif
!
!-- Recover correct F(obs)(solo se non c'è pseudo)
!
             if (.not.use_pseudo .and. .not.use_E ) fovet(:) = foper(:)
!
!---fine parte da fare solo per il primo gruppo spaziale!!!!!
canna
             nreflSelRemo = nreflSelTra
             call InitSigmaA(1)
canna
! --  Selezione rotazioni da passare alla traslazione: prova senza clustering
!
c        if (nAcid > 0 .and. nResidStored == 0) then
c            nSolToExplore = min0(nSolToExplore,200)   ! massimo 200 rotazioni dopo clustering
c        elseif (nMolMRTot > 1 .or.idSeq < 0.5) then
c            nSolToExplore = min0(nSolToExplore,nSolToExplore0/10)   ! massimo 10% rotazioni selezionate
c        endif

             if(ifPositioned > 0) then
                 nSolToExplore = ifPositioned
             endif
!
             ies_opti = 0 !1
             if(ies_opti == 1) then
                if (kcpu > 0) call CPUTime0('CPU OptiRot')
                call OptiRotSolution()   !Simplesso anche in Rotazione
                if (kcpu > 0) call CPUTime('CPU OptiRot', 1)
             endif
!
             call toflush()
!
!
             preRemo = .false.
!
             if (ifTraslaFrammento == 1) then

                 model(WhichModel)%considerato(:) = 0
                 model(WhichModel)%considerato(1) = 1
!
!-- applica le traslazioni ( tranne che in P 1 )
!
c                nSolToExplore = min0(nSolToExplore,200)   ! massimo 200 rotazioni dopo clustering
                 if (kverbo > 0 .or. knw > 0) then
                     write(lo,30) nSolToExplore
                 else
*                    write(lo,31) nSolToExplore
                 endif

                 nSolToExplore0=nSolToExplore 

                 if (kcpu > 0) call CPUTime0('CPU Trasla')
                 ifTraslaFrammento = 0
                 if (ifTraSel == 1) then
                     call TraMolecularSingle()
                 else
                     call TraMolecular()
                 endif
                 if (kcpu > 0) call CPUTime('CPU Trasla', 1)
!
c
                 call PrintMolRes_New(1)
                 call MRInfo(3)
c
                 call toflush()
c             stop
                if (knw > 0) then
                    write(lo,*) ' TRANSLATION STAGE: Before SIMPLEX'
                endif
                call ConfrontaSoluzioni(1)
                if (ifPositioned == 0) nSolToExplore = nSolToExplore/2
c
c--minimizzazione locale
c
                 if (kverbo > 0) call CPUTime0('Local')
                 if (knw > 0) write(lo,35)   !OPTIMIZATION STAGE
!
                 call preLocal()
                 fomBestE = -9999.9
c
c--alloca mappa per minimizzazione locale
c
                 call AllocaMappa(2)
                 npSav(:)=np(:)
                 ifRemo=3
                 call CheckGrid()
                 ifRemo=1
                 call AllocaMappa(1)
c
                 call scrper(' ',0,0)
!
                 ier1 = 0
                 ier2 = 0
                 if (allocated(work_fom)) then
                     deallocate(work_fom, stat = ier1)
                  endif
                 allocate(work_fom(1:nSolToExplore), stat = ier2)
                 work_fom(:) = 0.0   
!
c     write(6,554)
c 554 format('XXX - INFO - XXX    Sol. Trial      #   TFom_old  ',
c    *'sqrt(RFom) OptiFom    TFomN')
!
                 if (WM == 1) then
                    allocate(RpMat(1:nSolToExplore,1:nreflSelTra),
     *                             stat=ier)
                    nSolStored = nSolToExplore
*                   nSolStored = max0(2,nSolStored/WM)
                    RpMat(:,:) = 0
                 endif
!
                do i=1,nSolToExplore
!
                   write(string1,10) i, nSolToExplore
                   call NoBlanks(string1,k1)
c                   if (fomBestE > -100) then
c                       write(string2,20) fomBestE
c                   else
                       string2 = ' '
c                   endif
                Msg = 'Optimizing solution  '// string1(1:k1) // string2
                   call scrper(Msg,i,nSolToExplore)
!
                   WhichSolution = TraAll(i)%ipunt
                   xopti(1:3) = TraAll(WhichSolution)%RotVal(1:3)
                   xopti(4:6) = TraAll(WhichSolution)%TraVal(1:3)
                   single = .true.
                   fopti0 = TraAll(WhichSolution)%TraCorr
                   fopti1 = TraAll(WhichSolution)%TraCorr
                   TraAll(WhichSolution)%TFom(1) = fopti0

                   if (ifPositioned == 0.and.ifTraSel==0) then
!Raddoppio il Simplesso
                     do ijk = 1,2
!                     write(6,444) ijk,i,WhichSolution, xopti(1:3)*rtod,
!    *                               xopti(4:6),fopti1
                        call LocalMin(xopti,fopti1,single)!rocco
!                     write(6,445) ijk,i,WhichSolution, xopti(1:3)*rtod,
!    *                               xopti(4:6),fopti1
                     enddo
                   endif

 444  format('XOPTI6 in ingresso',i4,2i7,3f10.3,3f10.5,f9.5)
 445  format('XOPTI6 in uscita  ',i4,2i7,3f10.3,3f10.5,f9.5)
 
                   tet1 = xopti(1)
                   tet2 = xopti(2)
                   tet3 = xopti(3)
                   call RotationOper1(b,tet1,tet2,tet3)
c
                   do ii=1,3
                      do j=1,3
                         btra(ii,j) = b(j,ii)
                      enddo
                   enddo
!
                   do ii = 1,  natsInModel(WhichModel)
                      x1(1:3) = model(WhichModel)%saved(1:3,ii,1)
                      call MoltMatVec(rm, x1, x2)
                      call MoltMatVec(btra, x2, x1)
                      call MoltMatVec(rmi, x1, x2)
                      model(WhichModel)%atoms(1:3,ii,1) = x2(1:3) 
                  enddo
               
                  fragShift(:) = 0.0
                  call sftrNew(1, fragShift, dump,1)

                  use_sigmaA = .true. 
                  iact = 2
                  call sftrNew(iact, xopti(4:6), corre, 1)

                  if (corre <= 1.04*fopti0) then
                      xopti(1:3) = TraAll(WhichSolution)%RotVal(1:3)
                      xopti(4:6) = TraAll(WhichSolution)%TraVal(1:3)
                      fopti = TraAll(WhichSolution)%TraCorr
                  else
                      fopti = corre  ! Sir2014 distribuito
c              write(6,555) i, 
c    *                     TraAll(WhichSolution)%trial, WhichSolution,
c    *                     TraAll(WhichSolution)%TraFom, corre,
c    *                     sqrt(TraAll(WhichSolution)%RotFom), fopti
 555  format('XXX - INFO - XXX',3i7,4f10.5)

                  endif
                  call DoSingleIteration()
                  call UpdateSol(xopti,fopti,fopti1,i)
!
                  work_fom(i) = fopti   ! appoggio la nuova TFom vettore per ricerca di rmax e rmin                 
                  TraAll(WhichSolution)%TFom(1) = fopti
!
!
!--memorizzo la nuova funzione costo e i nuovi parametri
!
                enddo

!?!             rmax=maxval(TraAll(1:nSolToExplore)%TraFom)
!?!             rmin=minval(TraAll(1:nSolToExplore)%TraFom)
!?!             if (rmax>rmin) then 
!?!                nSolToExplore1 = 0
!?!                do i=1,nSolToExplore
!?!                   rho=(TraAll(i)%TraFom-rmax)/(rmin-rmax)
!?!                   rhoSog3a = rhoSog3 * 1.5
!?!c                  if (indexDiff < 0.3 .or. rmsStr > 0.9) rhoSog3a = 1.0 ! dfficile
!?!corig              if (rho <= rhoSog3 .or. TraAll(i)%accepted==2)then
!?!                   if (rho <= rhoSog3a .or. TraAll(i)%accepted==2)then
!?!                      nSolToExplore1 = nSolToExplore1 + 1
!?!                      WhichSolution = TraAll(i)%ipunt
!?!                      WhichSolution2 = TraAll(nSolToExplore1)%ipunt
!?!                      TraAll(nSolToExplore1)%ipunt = TraAll(i)%ipunt
!?!                      if(ifpseud==1 .and. nMolMRTot>1)then
!?!                         if(TraAll(i)%accepted.eq.4)
!?!     *                      TraAll(i+1)%accepted = 2
!?!                      endif
!?!                   endif
!?!                enddo
!?!                nSolToExplore=nSolToExplore1
!?!            endif

!-- osservazione Dedi dic.2015 --
!   dopo la selezione delle combinazioni effettuata in TraMolecular
!   (TraNum e rhoSog3) ho ricalcolato nSolToExplore e aggiornato il
!   puntatore TraAll%ipunt

                rmax=maxval(work_fom(1:nSolToExplore))
                rmin=minval(work_fom(1:nSolToExplore))
!               rhoSog3a = rhoSog3 * 1.5
                rhoSog3a = rhoSog3 ! * 1.5
c               if (indexDiff < 0.3 .or. rmsStr > 0.9) rhoSog3a = 1.0 ! dfficile
                if (indexDiff < 0.3 .or. rmsStr > 0.9) 
     *                                rhoSog3a = rhoSog3 * 1.35  !1.5
c               if (nSolToExplore < 5) rhoSog3a = 1.0 ! poche soluzioni
!DEDI
                if (nSolToExplore < 10) rhoSog3a = 1.0 ! poche soluzioni
                rhoSog3a = 1.0  ! per ottimizzare tutte le combinazioni
!DEDI
                if (kverbo > 0)  then
                    write(lo,*)
     *       ' OPTIMIZATION STAGE: rhoSog3, rhoSog3a',rhoSog3,rhoSog3a
                endif
*     TFom_thr = rhoSog3a*(rmin-rmax)+rmax
*     if (kverbo > 0 .and. knw > 0) then
*         write(lo,*) 'TFom_max =',rmax,'  TFom_min =',rmin
*         write(lo,*) 'TFom_thr =',TFom_thr,'  Threshold =',rhoSog3a
*     endif
                if (rmax>rmin) then
                   nSolToExplore1 = 0
                   do i=1,nSolToExplore
                      WhichSolution = TraAll(i)%ipunt
                     rho=(TraAll(WhichSolution)%TraFom-rmax)/(rmin-rmax)
corig              if (rho <= rhoSog3 .or. TraAll(i)%accepted==2)then
!                  if (rho <= rhoSog3a .or.  
!??  *                          TraAll(WhichSolution)%accepted==2)then  !!controllare accepted uso i o WhichSolution?
                      if (rho <= rhoSog3a.or.TraAll(i)%accepted==2) then
                         nSolToExplore1 = nSolToExplore1 + 1
                         WhichSolution2 = TraAll(nSolToExplore1)%ipunt
                         TraAll(nSolToExplore1)%ipunt = TraAll(i)%ipunt
                         if(ifpseud==1 .and. nMolMRTot>1)then
                            if(TraAll(i)%accepted.eq.4)  !!controllare accepted uso i o WhichSolution?
     *                      TraAll(i+1)%accepted = 2  !!controllare accepted uso i o WhichSolution?
                         endif
                      endif
                   enddo
                   nSolToExplore=nSolToExplore1
                endif

                do j=1,nSolToExplore
                   i = TraAll(j)%ipunt
                   work4(j)  = TraAll(i)%TraFom
                   iwork4(j) = i
*                  if (knw > = 0) write(6,*) j, TraAll(j)%ipunt, work4(j)
                enddo
                iuno = -1
                call sortall3(iuno,work4,iuno,nSolToExplore,iwork4)
                do j=1,nSolToExplore
                   i = iwork4(j)
                   TraAll(j)%ipunt = i
                enddo

                call AllocaMappa(2)
                np(:)=npSav(:)
                call AllocaMappa(1)
c--prova
c
                if (numbModels == 1) then
                    call DataForGraph(4,nSolToExplore)
                endif
!
                if (knw > 0) then
                    write(lo,*) ' OPTIMIZATION STAGE: After SIMPLEX'
                endif
!               if (kverbo > 0 ) call PrintMolRes_New(2)
                call PrintMolRes_New(2)
                call ConfrontaSoluzioni(2)

*               write(lo,*) ' OPTIMIZATION STAGE: After Clustering'
                call PrintMolRes_New(2)
                call MRInfo(4)
!
                nFinalSolution = nSolToExplore
                call AllocaFinalSolution(1)
*               call NewFFom
                call FomRefmac
!
*               write(lo,*) ' OPTIMIZATION STAGE: After New FFom'
                call PrintMolRes_New(3)
                call MRInfo(4)
c
                if (kcpu > 0) call CPUTime('CPU Local', 1)
                call toflush()
!
                call FillFinalSolution(1)

c               if (WhichModel < numbModels) then
c                   ipr = 1
c                   dove = lo
c                   call StampaFinalSolution(dove, ipr, riduci)
c               endif
c               if (numbModels > 1) then
c                   nPointsGR = nFinalSolution
c                   call DataForGraph(7,nFinalSolution)
c               endif

!TEST - Seleziona solo 5 soluzioni (dopo Simplex e FFom) per gli altri monomeri 

                if (WM == 1) then
!!!!               nSolStored = min0(nSolToExplore,  5)
                   nSolStored = min0(nFinalSolution,  5)
!
!numero di soluzioni finali da direttiva nsol 
!
                   if (sogSolutions > 0) then
                       nSolStored = min0(nSolStored, sogSolutions)  
                   endif

                   if (fastMR == 1) nSolStored = min0(nSolToExplore, 2)
                   nFinalSolution = nSolStored
                endif
    
                if (WhichModel < numbModels) then
                    ipr = 1
                    dove = lo
                    call StampaFinalSolution(dove, ipr, riduci)
                    if (knw > 0) then
                        write(6,*) 'call StampaFinalSolution 1', riduci
                    endif
                    if (riduci) then
                        exit Modelli
                    endif
                endif
                if (numbModels > 1) then
                    nPointsGR = nFinalSolution
                    call DataForGraph(7,nFinalSolution)
                endif
!
            else     ! if su ifTraslaFrammento = 0
!
c            write(6,*) 'nFinalSolution, nSolToExploreRot',
c    *                   nFinalSolution, nSolToExploreRot
!
                nSolToExploreRot = nSolToExplore
c            write(6,*) 'nFinalSolution, nSolToExploreRot',
c    *                   nFinalSolution, nSolToExploreRot
                call AllocaTraslaSolution(1)
                call AllocaFinale(1)
!
             nSolToExploreRot = nSolToExplore
             do WhichMonomer=1, nMolMR
                if (WhichMonomer == 1) then
                    write(Msg,100) WhichModel
                else
                    write(Msg,110) WhichMonomer, WhichMonomer
                endif
c                Msg = 'Clustering trials'
                call PrintMess(Msg)
                call DoSingleIteration()

                if (knw > 0) then
                    write(lo,*) ' MoreMolecules '
                endif
                if (kcpu > 0) call CPUTime0('CPU MoreMolecules')

                call MoreMolecules(nums)

                if (kcpu > 0) call CPUTime('CPU MoreMolecules', 1)

             enddo
             if (nums == numeroSoluzioni) then
                 nMolMR = 0
             endif
         endif     ! if su ifTraslaFrammento
c         stop
!
            if (jscreen  > 0) then
                if (WhichModel < numbModels) then
                    call ManageGraph(0, 0)
                    call DoSingleIteration()
                    k = index(fname(9),'.png')
                    write(Msg,50) fname(9)(1:k-1),WhichModel
                    call NoBlanks(Msg, k1)
                    call CreaPng(Msg)
c                 call MRInfo(7)
                endif
            endif
         enddo   ! fine ciclo sulle soluzioni

         nFinalSolution = nSolStored
         if (WhichModel > 1 .and. WhichModel /= numbModels) then
             ipr = 1
             dove = lo
             call StampaFinalSolution(dove, ipr, riduci)
             if (knw > 0) then
                 write(6,*) 'call StampaFinalSolution 2', riduci
             endif
             nPointsGR = nFinalSolution
             call DataForGraph(7,nFinalSolution)
         endif
canna
         call InitSigmaA(2)
canna
         call AllocaRuotaRiflessi(2)
         call AllocaSolutions(2)
         call AllocaTraslaSolution(2)
         call AllocaRiflessi_c(2)
         if (WhichModel < numbModels) then
             call AllocaGrafici(2,0,0)
         endif
         call AllocaFinale(2)
!
         if (riduci) then
             exit Modelli
         endif
      enddo Modelli  ! fine ciclo sui modelli
      WhichModel = numbModels

!
!---fine loop sul gruppo spaziale !!!!!!!!!
!-------confronta soluzioni e scegli la soluzione migliore!!!!!!!!!!!
!
***   call AllocaTraslaSolution(2)
!
!-- Recover correct F(obs)( se  c'è pseudo)
!
      if (use_pseudo .and. .not.use_E) fovet(:) = foper(:)

      if (WhichModel == numbModels) then
          ipr = 2
          dove = lo
          call StampaFinalSolution(dove, ipr, riduci)
          if (knw > 0) then
              write(6,*) 'call StampaFinalSolution 3', riduci
          endif
      endif


      call FinalMR(rMTZ)
!
!-- cancello la mappa su disco usata per la correlazione
!
       itype = 2
       iform = 1
       jop =jopen(jgrap,fname(6),itype,iform,ios)
       if (jop >= 0) then
           close(jgrap, status = 'delete')
       endif

!
      ifSkeleton = 0
      call AllocaModelRemo(2)
      infoOK(15) = 0
      call AllocaFinalSolution(2)
      call AllocaAllinea(4)
      call AllocaRiflessiCow(2)
!
      if (jscreen  > 0) then
          call CPUTime(' ', 0)
          HTMLcpu = Inte(1:Lung(Inte))
          headersGR(2) = Inte
          call ManageGraph(0, 0)
          nats = 0
          call scrper(' ',0,-1)
!*!           box = lastBox
!*!           Msg = 
!*!  *       '<big><b>Molecular Replacement procedure is over</b></big>'
!*!          call TestoGR(Msg, color_RED, 2, box)
!*!          Msg = 
!*!  *       '<big> </big>'
!*!          call TestoGR(Msg, color_RED, 2, box)
!*!       Msg = 'Molecular Replacement procedure is over. ' // string2
!*!       write(lo,'(/,a,a)')  ' ', Msg(1:Lung(Msg))
!*!       call PrintMess(Msg)
!*!       call shift(string2,k)
!
          if (ifAutomatic == 0) then
              if (ifPhD == 0) then
                  tipo = 4
              else
                  tipo = 5
              endif
              call ProcOver(tipo, irisp)
          endif
!
!
!*!       if (ifAutomatic == 0) then
!*!           call ProcOver(4, irisp)
!*!       endif
!
      else
          call ProcOver(4, irisp)
      endif
!
!-- Salva i grafici su file .png
!
      if (jscreen  > 0) then
          call zflush
          call DoSingleIteration()
          call CreaPng(fname(9))
      endif
!
      jBlock = 1
      errem = 9999
!
      if (nolsq == 0 .and. ksize > 2) then
          lfw = InfoOK(17)
          if (lfw > 0) then
              call LoadFinalPhases(FomsFineDSR, iposFineDSR,
     *                             nsetFinalPhases)
              if (nSetsFineDSR > 0 .and. ier == 0) then
                  nset = iposFineDSR(1)
                  call PutGetFinalPhases(2, nset, figMer)
                  trial = nint( figMer(1) )
                  fFom = figMer(3)
*                 write(Msg,25) trial, fFom
*                 call PrintMess(Msg)
              endif
          endif
      endif
!
      call AllocaPhaseStuff(2)
!
      if (InfoOK(15) == 1) then
          QualeAbilita = 2
      elseif (InfoOK(17) == 1) then
          if (ifSkeleton == 0) then
              QualeAbilita = 1
          else
              QualeAbilita = 2
          endif
      elseif (InfoOK(17) == 0) then
          ifSkeleton = 0
          if (ifSkeleton == 0) then
              QualeAbilita = 0
          else
              QualeAbilita = 2
          endif
      endif

!!mr  QualeAbilita = 2   ! gianluca 30/06/2015
!
*     call RestoreLists123(3)   ! commentato gianluca 15/04/2009
!
!
      call AllocaRiflessi_Canal(2)
      call AllocaCanalMod(2)
      call AllocaPherrMod(2)
!
      call AllocaSolutions(2)
*      call AllocaRiflessiSIGMAA(2)   
      if (allocated(work_fom)) then
          deallocate(work_fom, stat = ier1)
      endif
!
      deallocate(RpMat, stat=ier1)
*     call CleanMR
!
      return
   10 format(i5,'/',i5 )
   12 format(i2,' molecules will be searched ')
   13 format('One molecule will be searched ')
   16 format(80('-'),//,a,//,80('-'))
   17 format(80('-'),//,a,i4,//,80('-'))
!!!17 format(80('-'),//,a,i4,' Trial ',i9,//,80('-'))
   18 format(80('-'),//,a,i2,a,/,a,i2,a,i2,a,//,80('-'))
   19 format(/,a,/)
   20 format('   Best correlation: ',f8.3)
   21 format(80('-'))
   25 format('Set up skeleton for best trial #',i5,' Final FOM = ',f9.3)
!
   30 format(80('-'),//,' TRANSLATION STAGE:',
     * ' rotation-translation combinations corresponding',/,
     * ' to',i5,' selected rotations.',
     * '  dx, dy, dz translations correspond to',/,
     * ' the largest peaks found on the FT map.',
     * ' Tfom is the figure of merit.',/,80('-'))

   31 format(80('-'),//,' TRANSLATION STAGE:',
     * ' rotation-translation combinations corresponding',/,
     * ' to',i5,' selected rotations.',/,80('-'))

   35 format(80('-'),//,' OPTIMIZATION STAGE: monomer/model # 1',
     *       ' position refinement via SIMPLEX method.',/,
     *       ' TFom is the figure of merit.',/,80('-'))
!
!-- spostata in FinalMR
!
   40 format(' ',80('+'),/)
   50 format(a,'_',i3,'.png')
   70 format(i3,' set of phases available. ')
   80 format(i3,' set of phases available. Click on Final stage ',
     *          'Procedures (F.S.P.) to manage them')
  100 format('Positioning model #',i3)
  110 format('Positioning monomer #',i3,' in model #',i3)
  500 format('Best  FOM  = ',f6.2,'          Best  R%  = ',f6.2)
c
      return
      end
!-----------------------------------------------------------------------     
      subroutine FomRefmac
      USE General
      USE Molcom
      USE Riflessi
      USE PhaseModule
      USE RemoModule
      USE Solutions
      USE TraslaSolution
      USE ArpWarp
      USE Param , only :f000
!
      implicit none
      integer :: filtra, i1, i2, i3, ifFast, ifREM, numbPDB, kk, k1, ii
      integer :: i, j, j1, j2, j1ord, itype, iform,jop, jopen, jj, iexc
      integer :: nRefi, NREFMAC, ier, Lung, knwSav, iuno, sav, iAction
      integer :: npunti
      real    :: tet1, tet2, tet3, x1(3), x2(3), b(3,3), btra(3,3)
      real    :: fomOldOpt, vvmm, vvpp, den, zero, cc_FoFc
      character (len=5) :: a5
*     character (len=256) :: MTZfileSav
      real, allocatable    :: work11(:)
      real, allocatable    :: work22(:)
!
      if (.not. allocated(work11)) then
          allocate (work11(1:nrefl) ,stat = ier)
          allocate (work22(1:nrefl) ,stat = ier)
      endif
!
*     return
!
*     write(6,*) 'INIZIO FomRefm ', f000
*     sav = FasiPerRefmac
*     FasiPerRefmac = -1
*     MTZfileSav = MTZfile
*     cardImage = nome(1:lnome) //'_start.mtz'
*     direttiva = nome(1:lnome) //'_start.mtzSav'
*     call cCopyFile(cardImage, direttiva)
!
!-- MTZ file with F>3sig
!
*     iAction = 0
*     ier = 0
*     sig = 3
*     res = 7
**     call WriteMTZ_Refmac(iAction, sig, ier)
*     call  WriteMTZ_Refmac_res(iAction, sig, res, ier)
!
      call FillFinalSolution(1)
      if (knw > 0) then
          write(6,*)
          write(6,*) 'FOMREFMAC'
          write(6,*)
          write(6,10)
      endif
!
      do j=1,nFinalSolution
         work4(j)  = finsolcan(j)%Fom
         iwork4(j) = j
      enddo
      iuno = -1
      call sortall3(iuno,work4,iuno,nFinalSolution,iwork4)
!
      do jj=1, nFinalSolution


         j = iwork4(jj) ! puntatore con l'ordine delle soluzioni
         if (WhichModel == 1) then
             if (finsolcan(j)%Fom < -99.00) cycle 
         endif


         do j1=1, numbModels
            j2 = MonomerInModel(j1)
            model(j1)%considerato(1:j2) = 0
         enddo
         do j1=1, numbModels
            do j2=1, MonomerInModel(j1)
c
c--non considero la parte mancante
c  (coincide sempre con quella finale del multipletto)
c
               if (finsolcan(j)%flag(j1,j2) == -1) exit
               model(j1)%considerato(j2) = 1
c
               tet1 = finsolcan(j)%RotVal(1,j1,j2)
               tet2 = finsolcan(j)%RotVal(2,j1,j2)
               tet3 = finsolcan(j)%RotVal(3,j1,j2)
               call RotationOper1(b,tet1,tet2,tet3)
!
               do i1=1,3
                  do i2=1,3
                     btra(i1,i2) = b(i2,i1)
                  enddo
               enddo
               do i=1, natsInModel(j1)
                  x1(1:3) = model(j1)%saved(1:3,i,j2)
                  call MoltMatVec(rm, x1, x2)
                  call MoltMatVec(btra, x2, x1)
                  call MoltMatVec(rmi, x1, x2)
                  model(j1)%atoms(1:3,i,j2) =
     *                      x2(1:3) + finsolcan(j)%TraVal(1:3,j1,j2)
               enddo
            enddo
         enddo
         j1 = j
         j1ord = jj

         write(a5,30) j1ord
         call NoBlanks(a5,k1)
         WhichSolution = j1
         numbPDB = 0
         kk = 0
         do i1=1, numbModels
            do i2=1, MonomerInModel(i1)
               if (finsolcan(j1)%flag(i1,i2) == -1) then
                   kk = kk + 1
               else
                   numbPDB = numbPDB + natsInModel(i1)
               endif
            enddo
         enddo
         if (kk == 0) then
             numbPDB = -1
         endif

         FichierOut = nome(1:lnome)//'_remoFOM'//a5(1:k1)//'.pdb'
         itype = 0
         iform = 1
         jop = jopen(jhost,FichierOut,itype,iform,ier)
!
!-- filtra il pdb per gli atomi di tipo OT
!
         filtra = 0
         do i1=1, size(model)
            if (.not.allocated(model(i1)%atoms)) cycle
            do i2=1, MonomerInModel(i1)
               do i3=1, natsInModel(i1)
                  if (model(i1)%tipoAtomo(i3,i2)(1:4)
     *                == 'ot  ') then
                      model(i1)%HETA(i3,i2) = -1
                      filtra = 1
                  endif
               enddo
            enddo
         enddo
!
         fomOldOpt = finsolcan(j1)%Fom
         card(1)='REMARK    '//
     &              ' Model obtained by REMO,'//
     &           ' the Molecular Replacement routine of Sir2019'
         write(card(2),'("REMARK     Solution number: ",i5)') j1ord
         write(card(3),
     &          '("REMARK     Figure of merit (correlation): ",f8.3)')
     &          fomOldOpt
         ifFast = 2
         ifREM = 3 
         call outPDB(jhost, numbPDB, ifFast, ifREM, filtra)
         close(jhost)
         call ManageSe

         nRefi = 5
         NREFMAC = nRefi
         cardImage = cardDiret
         call UseRefmac(FichierOut, nRefi, 0, NREFMAC, 0, ier)
! prova Dedi
         FFom = 1.0 - RfacAW
! prova Dedi

         zero = 0.0000000001
         npunti = 0
         do i = 1, nrefl
            if (fcvet(i) > zero) then
                work11(i) = fovet(i)
                work22(i) = fcvet(i)
                npunti = npunti + 1
            endif
         enddo

         call cc_vet(work11,work22,npunti,cc_FoFc)


!!!!!          FFom = FFom * cc_FoFc    !!!! da provare (vedi DiMaio : 3rn6)

!c!      if (WhichModel == 1) then
             i = TraAll(j)%ipunt
             ii = TraAll(i)%trial
             TraAll(i)%TraFom = FFom
             TraAll(i)%MolMPE = erore
!c!      else
!c!          finsolcan(j)%Fom = FFom
!c!          finsolcan(j)%MPE = erore
!c!      endif

         if (knw > 0) then
             write(6,20) j, ii, fomOldOpt,
     *                   RfacAW, RfreAW,erore, FFom, cc_FoFc
         else
*            write(6,25) j, ii, fomOldOpt,
*    *                   RfacAW, RfreAW,       FFom, cc_FoFc
         endif

!?!      cardImage = nome(1:lnome)//'_refmac.pdb'
!?!      call cCopyFile(cardImage, FichierOut)
!?!      cardImage = nome(1:lnome)//'_refmac0.mtz'
!?!      FichierOut = nome(1:lnome)//'_remoFOM'//a5(1:k1)//'.mtz'
!?!      call cCopyFile(cardImage, FichierOut)

      enddo   ! jj=1, nFinalSolution!
!
!c!   if (WhichModel == 1) then
          do j=1,nFinalSolution
             i = TraAll(j)%ipunt
             work4(j)  = TraAll(i)%TraFom
             iwork4(j) = i
*                 if (knw > = 0) write(6,*) j, TraAll(j)%ipunt, work4(j)
          enddo
          iuno = -1
          call sortall3(iuno,work4,iuno,nFinalSolution,iwork4)
          do j=1,nFinalSolution
             i = iwork4(j)
             TraAll(j)%ipunt = i
          enddo
!c!   endif
!
      if (allocated(work11)) 
     *    deallocate (work11, work22 ,stat = ier)
!

      if (knw > 0) then
          write(6,*)
          write(6,*) 'FINE FOMREFMAC'
          write(6,*)
      endif
!
      return
   10 format(/,' Sol.  Trial   TFom    R(F)',
     *         '    R(free)     MPE     newFom  cc_FoFc',/)
   20 format(i4,i8,f7.3,2f9.4,f10.2,2x,2f8.3)
   25 format(i4,i8,f7.3,2f9.4         ,2f8.3)
   30 format ('_',i4)
      end
!-----------------------------------------------------------------------     
      subroutine FomRefmac_MoreMolecules(nFinSol)
      USE General
      USE Molcom
      USE Riflessi
      USE PhaseModule
      USE RemoModule
      USE Solutions
      USE TraslaSolution
      USE ArpWarp
      USE Param , only :f000
!
      implicit none
      integer :: filtra, i1, i2, i3, ifFast, ifREM, numbPDB, kk, k1
      integer :: i, j, j1, j2, j1ord, itype, iform,jop, jopen, jj
      integer :: nRefi, NREFMAC, ier, Lung, knwSav, iuno
      integer :: npunti,nFinSol
      real    :: tet1, tet2, tet3, x1(3), x2(3), b(3,3), btra(3,3)
      real    :: fomOldOpt, vvmm, vvpp, den, zero, cc_FoFc
      character (len=5) :: a5
      real, allocatable    :: work11(:)
      real, allocatable    :: work22(:)
!
      if (.not. allocated(work11)) then
          allocate (work11(1:nrefl) ,stat = ier)
          allocate (work22(1:nrefl) ,stat = ier)
      endif
!
*     return
      go to 1
      vvmm  = 0.0
      f000 = 0.0
      den = 0.0                     !mr 040606
      do i=1, nk
         if (no(i) > 16) cycle
         f000 = f000 + float( nw(i) * no(i) )
         if (no(i) > 1) then
             den = den + float( nw(i) * nw(i) * no(i) )
             vvmm = vvmm + 14.0 * float( nw(i) )
         endif
      enddo
*---- Matthews' number
      vvmm = volume / vvmm
*---- Percent of Protein
*-----  protein density=1.23 (from CCP4 1.34)
      vvpp = 1.34 / vvmm
      f000 = volume*(0.32*(1.0-vvpp)+0.43*vvpp)
    1 continue
!
      if (knw > 0) then
          write(6,*)
          write(6,*) 'FOMREFMACMOREMOLECULES'
          write(6,*)
          write(6,10)
      else
*         write(6,15)
      endif
!
      do jj=nFinSol, nFinSol

         do j1=1, numbModels
            j2 = MonomerInModel(j1)
            model(j1)%considerato(1:j2) = 0
         enddo
         j = jj  ! puntatore con l'ordine delle soluzioni
         do j1=1, numbModels
            do j2=1, MonomerInModel(j1)
c
c--non considero la parte mancante
c  (coincide sempre con quella finale del multipletto)
c
               if (finsolcan(j)%flag(j1,j2) == -1) exit
               model(j1)%considerato(j2) = 1
c
               tet1 = finsolcan(j)%RotVal(1,j1,j2)
               tet2 = finsolcan(j)%RotVal(2,j1,j2)
               tet3 = finsolcan(j)%RotVal(3,j1,j2)
               call RotationOper1(b,tet1,tet2,tet3)
!
               do i1=1,3
                  do i2=1,3
                     btra(i1,i2) = b(i2,i1)
                  enddo
               enddo
               do i=1, natsInModel(j1)
                  x1(1:3) = model(j1)%saved(1:3,i,j2)
                  call MoltMatVec(rm, x1, x2)
                  call MoltMatVec(btra, x2, x1)
                  call MoltMatVec(rmi, x1, x2)
                  model(j1)%atoms(1:3,i,j2) =
     *                      x2(1:3) + finsolcan(j)%TraVal(1:3,j1,j2)
               enddo
            enddo
         enddo
!
         j1 = j
         j1ord = jj

         write(a5,30) j1ord
         call NoBlanks(a5,k1)
         WhichSolution = j1
         numbPDB = 0
         kk = 0
         do i1=1, numbModels
            do i2=1, MonomerInModel(i1)
               if (finsolcan(j1)%flag(i1,i2) == -1) then
                   kk = kk + 1
               else
                   numbPDB = numbPDB + natsInModel(i1)
               endif
            enddo
         enddo
         if (kk == 0) then
             numbPDB = -1
         endif

         FichierOut = nome(1:lnome)//'_remoFOM'//a5(1:k1)//'.pdb'
         itype = 0
         iform = 1
         jop = jopen(jhost,FichierOut,itype,iform,ier)
!
!-- filtra il pdb per gli atomi di tipo OT
!
         filtra = 0
         do i1=1, size(model)
            if (.not.allocated(model(i1)%atoms)) cycle
            do i2=1, MonomerInModel(i1)
               do i3=1, natsInModel(i1)
                  if (model(i1)%tipoAtomo(i3,i2)(1:4)
     *                == 'ot  ') then
                      model(i1)%HETA(i3,i2) = -1
                      filtra = 1
                  endif
               enddo
            enddo
         enddo
!
         fomOldOpt = finsolcan(j1)%Fom
         card(1)='REMARK    '//
     &              ' Model obtained by REMO,'//
     &           ' the Molecular Replacement routine of Sir2019'
         write(card(2),'("REMARK     Solution number: ",i5)') j1ord
         write(card(3),
     &          '("REMARK     Figure of merit (correlation): ",f8.3)')
     &          fomOldOpt
         ifFast = 2
         ifREM = 3 
         call outPDB(jhost, numbPDB, ifFast, ifREM, filtra)
         close(jhost)
         call ManageSe

         nRefi = 5
         NREFMAC = nRefi
         cardImage = cardDiret
         call UseRefmac(FichierOut, nRefi, 0, NREFMAC, 0, ier)
! prova Dedi
         FFom = 1.0 - RfacAW
! prova Dedi
         zero = 0.0000000001
         npunti = 0
         do i = 1, nrefl
            if (fcvet(i) > zero) then
                work11(i) = fovet(i)
                work22(i) = fcvet(i)
                npunti = npunti + 1
            endif
         enddo

         call cc_vet(work11,work22,npunti,cc_FoFc)


         if (knw > 0) then
             write(6,20) j, fomOldOpt,
     *                RfacAW, RfreAW,erore, FFom, cc_FoFc
         else
             write(a5,"(i2,'/',i2)") j, nFinalSolution
             call NoBlanks(a5, i)
             write(6,21) a5, fomOldOpt, RfacAW, RfreAW, FFom, cc_FoFc
         endif

         finsolcan(j)%Fom = FFom
         finsolcan(j)%MPE = erore

      enddo   ! jj=1, nFinSol!
!
      if (allocated(work11))
     *    deallocate (work11, work22 ,stat = ier)
!

      if (knw > 0) then
          write(6,*)
          write(6,*) 'FINE FOMREFMACMOREMOLECULES'
          write(6,*)
      endif
!
      return
   10 format(/,' Solution   TFom    R(F)',
     *         '    R(free)     MPE     newFom  cc_FoFc',/)
   15 format(/,' Solution   TFom    R(F)',
     *         '    R(free)  newFom  cc_FoFc',/)
   20 format(i5,5x,f6.3,2f9.4,f10.2,2x,2f8.3)
   21 format(3x,a5,2x,f6.3,2f9.4,2x,2f8.3)
   30 format ('_',i4)
      end
!-----------------------------------------------------------------------     

      subroutine DrawMatrixTra(rmat)
c     stampa la trasposta della matrice rmat
c             
      dimension rmat(3,3)
c
      do i=1,3
        write(6,'(3f15.4)') rmat(1:3,i)
      enddo
c
      return
      end
!-----------------------------------------------------------------------     
      subroutine DrawMatrix(rmat)
c      stampa la matrice rmat
c
      dimension rmat(3,3)
c
      do i=1,3
        write(6,'(3f15.4)') rmat(i,1:3)
      enddo
c
      return
      end

!-----------------------------------------------------------------------     
      subroutine RotationOper1(b,teta1,teta2,teta3)
c    
c --- Rotazione e3(teta1) + e1(teta2) + e3(teta3)
c    
      dimension  b(3,3)
c
      st1=sin(teta1)
      st2=sin(teta2)
      st3=sin(teta3)
      ct1=cos(teta1)
      ct2=cos(teta2)
      ct3=cos(teta3)
cc
      ct2st3=ct2*st3
      ct2ct3=ct2*ct3
cc
      b(1,1)=-st1*ct2st3 + ct1*ct3
      b(1,2)=ct1*ct2st3 + st1*ct3
      b(1,3)=st2*st3
      b(2,1)=-st1*ct2ct3 - ct1*st3
      b(2,2)=ct1*ct2ct3 - st1*st3
      b(2,3)=st2*ct3
      b(3,1)=st1*st2
      b(3,2)=-ct1*st2
      b(3,3)=ct2
c
      return
      end
c -----------------------------------------------------------------
      subroutine controllo_indici_interi(vet2, ivet2)
      real::vet2(3)
      integer::ivet2(3)
c
      ivet2(:) = nint(vet2(:))
      if( (ivet2(1)<0).or.(ivet2(1)==0 .and.ivet2(2)<0).or.
     *   (ivet2(1)==0 .and.ivet2(2)==0 .and.ivet2(3)<0)) then
          ivet2(1:3)=-ivet2(1:3)
      endif
c
      end subroutine controllo_indici_interi  
c-----------------------------------------------------------------------
      subroutine RotMolecular(WM)
c
c--routine che fa il campionamento con una griglia
c
      USE General
      USE Symmetry
      USE Molcom
      USE Riflessi
      USE riflessi_c
      USE RuotaRiflessi
      USE Solutions
      USE RemoModule
      USE PhaseModule
      USE Grafici
      USE RenorArrays_MR

!
      dimension vet1(3),vet2(3)
      dimension rmtt(3,3)
      dimension b(3,3)
      integer:: s, f, ivet2(3), kdone, WM
      real::sum_costo,sum_costo2
      real::tre(3),modEc
      real::prt_fom(5)
      common/user/ resol1o
c
c-----------------------------------------menu
      if(ksize>3) then
         stepLimDown=3.0
      elseif(ksize==2) then
         stepLimDown=2.0
      else
         stepLimDown=1.0
      endif
      stepLimUp=10.0
c-----------------------------------------
      tre(1:3) = 0.0
      dieci = -10000
      rho_min = (0.5/resol2)**2   
      rho_max= (0.5/resol1)**2 !è definita per use_resplus = true 
      adist=(cell(1)+cell(2)+cell(3) ) / 3.0 ! new
      if(ksize>3) then
        step=2.0*asin(resol1o/adist) ! new
        if(use_resplus)step1=2.0*asin(resol1/adist)
      else
! rendo lo step piu' piccolo per le piccole molecole
        step=2.0*asin(resol1o/(2.0*adist)) ! originale
        if(use_resplus)step1 = 2.0*asin(resol1/(2.0*adist))
      endif
c
c--controlli sullo step
c
      if(step < stepLimDown*dtor) then
        step=stepLimDown*dtor
      else if(step > stepLimUp*dtor) then
        step=stepLimUp*dtor
      end if
      if(use_resplus)then
         if(step1 < stepLimDown*dtor) then
           step1=stepLimDown*dtor
         else if(step1 > stepLimUp*dtor) then
           step1=stepLimUp*dtor
         end if
      endif
!REMO09step=max(step,3.5*dtor) 
       step=min(step,5.0*dtor) 
!
!*!   if (numbModels == 1) then
          Msg = '<big><b>Rotation stage</b></big>'
          nLinesGRSav = nLinesGR
!*!   else
!*!       j = index(card(ncardMax - WhichModel + 1), slash, .TRUE.) + 1
!*!       ReflFileName = card(ncardMax - WhichModel + 1)(j:)
!*!       L = Lung(ReflFileName)
!*!       write(Msg,5) WhichModel, ReflFileName(1:L)
!*!       if (WhichModel == 1) then
!*!           nLinesGRSav = nLinesGR
!*!       else
!*!           nLinesGR = nLinesGRSav
!*!       endif
!*!   endif
    5 format('<big><b>Rotation stage, model #',i3,' (',a,')</b></big>')
*     call TestoGR(Msg, color_RED, 2, 2)
      write(Inte,11) step*rtod
      if (WhichModel == 1) then
          write(lo,20) step*rtod
      endif
      if (WM == 1) then
          call TestoGR(Msg(1:Lung(Msg))//Inte(1:Lung(Inte)), 
     *                 color_RED, 2,2)
      endif
!
      eps=0.001
      f=1
      costomax=-99999.0
      costomin= 99999.0
      kdone=0
      solnum=0
      sum_costo=0.0
      sum_costo2=0.0
c
c--calcolo il numero approssimativo dei punti griglia da esplorare
c
      GridExp = (2.0/Pi)* (alimUp(1)/step)*
     &                    (alimUp(2)/step)*(alimUp(3)/step)
c
c--alloco lo spazio per le soluzioni
c
      if (ifTraOnly > 0) then
        ifPositioned=1
      endif
c
      if (ifPositioned == 1) then
          nMaxSolutions = 1
      else
          nMaxSolutions = 1.2*GridExp
          if (nMaxSolutions < 10) nMaxSolutions = 10
      endif
      if(kverbo>0) write(6,*) 'number solutions',GridExp,nMaxSolutions
      call AllocaSolutions(1)
c
c___________controllo se i valori sono nel range 
c
      nreflMR = 0
      do k=1,nrefl
        if  (rho_min <= rhov(k) .and. rho_max >= rhov(k)) then
              nreflMR = nreflMR + 1
        endif
      enddo

      call AllocaRuotaRiflessi(1)
      nreflSelTra=riflessiScelti(rho_min,(0.5/resol1o)**2) 
      k_mem1(:)=k_mem(:)
      khlv(1:3,1,:)=khlv(1:3,2,:)
      solv_corr(1,:)=solv_corr(2,:)
      khlv_eq(1:3,:,1,:)= khlv_eq(1:3,:,2,:)
      if(use_E) then
         n=1
         do i=1,nreflSelTra
            k  = k_mem(i)
! compatto i vettori seguenti:
            fccomp(i) = fcvet(k)
            focomp(i) = fovet(k)
            epsvcomp(i) = epsv(k)
            rhovcomp(i) = rhov(k)
            sigmavcomp(i) = sigmav(k)
            ModuliSel(2,i) = evet(k)
            modEc=evet(k)**2

            if(modEc > 1.35.or. modEc < 0.7) then  ! intervallo per !fne_costo

               khlv(1:3,2,n)=khlv(1:3,2,i)
               solv_corr(2,n)=solv_corr(2,i)
               icont=0
               do s = 1, nsym
                  do l = 1, 3
                        ivet2(l)=0
                        do m = 1, 3
                           ivet2(l) = ivet2(l)+khlv(m,2,n)*kmat(s,m,l)
                        enddo
                  enddo
                  vet2=ivet2
                  call controllo_indici_interi(vet2,ivet2)
                  icont  =  icont  +  1
                  khlv_eq(1:3,icont,2,n) = ivet2(1:3)
               enddo
               k_mem(n)=k
               n=n+1

            endif
         enddo
         nreflSelRot=n-1
      else 
!!!!!!!!!!!!!!attenzione!!!!!!!!!!!!!!!!!!!!!!!
         nreflSelRot=nreflSelTra
         traLim = 0.2
         rotLim = 0.000001
      endif
canna
      khlv_eq(1:3,:,3,:)= khlv_eq(1:3,:,2,:)! nel 3 ci sono hrs non orto
      call Orto(cell) !ortogonalizza il sistema
      do j=1,3
        do i=1,3
           rmtt(i,j)=rmi(j,i)*dimcell !matrice riscalata
        enddo
      enddo
c--ricavo i nuovi indici di Miller nel sistema del modello
      do i=1,nreflSelRot
        k  = k_mem(i)
        if(use_E) then
          ModuliSel(2,i) = evet(k)
        else
          ModuliSel(2,i) = solv_corr(2,i)*fovet(k)/sqrt(epsv(k))
        endif
        do jj=1,nsym
         vet1(1:3)=khlv_eq(1:3,jj,2,i)
         call MoltMatVec(rmtt,vet1,vet2) !eseguo la moltiplicaz matrice vettore
         khlv_eq(1:3,jj,2,i)=vet2(1:3)
        enddo
        if(.not.use_E) then
           if(ModuliSel(2,i)<rotLim) then
              nreflSelRot=i
              exit
           endif
           if(ModuliSel(2,i)<traLim) then
              nreflSelTra=i
              traLim=rotLim-0.1
           endif
        endif
      enddo
c
*     worko(:) = 0.0
*     work2(:) = 0.0
*     if(use_E) then
*        do i=1,nreflSelRot
*           k  = k_mem(i)
*           worko(i) = fovet(k)/sigmav(k)
*        enddo

*        ncond1 =  nreflSelRot * 0.9
*        call sortall(-1,worko,nreflSelRot)
*        sog = worko(ncond1)

*        do i=1,nreflSelRot
*           k  = k_mem(i)
*           rap = fovet(k)/sigmav(k)    
*           if (rap > sog) then 
*               work2(i) = ModuliSel(2,i)
*           endif
*        enddo

*        ifl = 1
*        call InitFomModel(ifl,nreflSelRot)
*     endif

      ifl = 1
      call InitFomModel(ifl,nreflSelRot)
c

         nreflSelRemo = nreflSelRot
         call InitSigmaA(1)

      if (whichModel == 1) then
          write(lo,30)  nreflSelRot, nreflSelTra
      endif
      if (.not.use_E) then
          call CalcolaCostoProva0()
      endif

c
c--comandi per la grafica
c
      Inte = 'Applies rotations'
      call scrper(Inte,0,0)
      nperc  = 20
      iperc0 = GridExp / float(nperc)
      iperc  = iperc0
      jperc  = 0
      n100 = GridExp / 100
!
!-- ruoto i riflessi nel sistema ortogonale
!
c      ihmaxlim=0.5*(ifat2C-1)
c
c
c     write(6,'(a)')'RFOM:    #    Old      New'
      ttet2=eps -step
      do while (ttet2 <= pi)
        ttet2 = ttet2 + step
        if (ttet2 > pi) exit
        tet2=ttet2
        step_m=step/sin(0.5*tet2)
        step_p=step/cos(0.5*tet2)
        tetm=0.0 - step_m
        do while (tetm <= twopi)
           tetm = tetm + step_m
           if (tetm > twopi) exit
           tetp=-twopi - step_p
           do while (tetp <= twopi)
              tetp = tetp + step_p
              if (tetp > twopi) exit
              tet1 = 0.5*(tetp+tetm)
              if(tet1.lt.0.0) tet1 = tet1+TwoPi
              tet1 = amod(tet1, TwoPi)
              tet3 = 0.5*(tetp-tetm)
              if(tet3.lt.0.0) tet3 = tet3+TwoPi
              tet3 = amod(tet3, TwoPi)
              if (tet1 >= alimUp(1) + eps) cycle
              if (tet2 >= alimUp(2) + eps) cycle
              if (tet3 >= alimUp(3) + eps) cycle
              if (ifPositioned == 1) then
                  tet1 = RotAppl(1) * dtor 
                  tet2 = RotAppl(2) * dtor
                  tet3 = RotAppl(3) * dtor
              endif
!
!-- applico la matrice di rotazione
!
              call RotationOper1(b,tet1,tet2,tet3)
c
c--ricavo i nuovi indici di Miller nel sistema del modello
c
              Ecal2_med = 0.0
              do i=1,nreflSelRot
c                k = k_mem(i)
                tcalc=0.0
                do jj=1,nsym
                  do io=1, 3
                    vet2(io) = 0
                    do jo=1, 3
                      vet2(io) = vet2(io)+ b(io,jo)* khlv_eq(jo,jj,2,i)
                    enddo
                  enddo
                  call controllo_indici_interi(vet2,ivet2)
c
c---costruisco il vettore superindice per gli osservati ruotati
c
                  indr = ivet2(1)*ifat1C + ivet2(2)*ifat2C + ivet2(3)
                  if (indr <= 0) then
                      j = 0
                  endif
                  if (indr <= ifatxC .and. indr > 0) then
                     j = superind(indr)
                     if (j > 0) then
                      if(use_E) then
                        tcalc=tcalc+ecvetc(j)    !  Ecalc**2 da modello
                      else
                        tcalc=tcalc+fcvetc(j)
                      endif
                     endif
                  endif
                enddo
                ModuliSel(1,i) = sqrt(tcalc)

               Ecal2_med = Ecal2_med + tcalc

              enddo

              Ecal2_med = Ecal2_med / nreflSelRot
c             write(6,*) '<Rp**2> = ', Ecal2_med
              sca = 1.0 / Ecal2_med
              do i=1,nreflSelRot
                 tcalc = sca*(ModuliSel(1,i)**2)
                 ModuliSel(1,i) = sqrt(tcalc)
              enddo
c 
      

c--calcolo della funzione costo
c
              solnum=solnum+1
              if(use_E) then

                prt_fom(:) = 0.0
c
                worko(:) = 0.0
                work1(:) = 0.0
                do i=1,nreflSelRot
                   k  = k_mem(i)
                   worko(i) = fovet(k)/sigmav(k)
                enddo
          
                ncond1 =  nreflSelRot * 0.9
                call sortall(-1,worko,nreflSelRot)
                sog = worko(ncond1)
       
                do i=1,nreflSelRot
                   k  = k_mem(i)
                   rap = fovet(k)/sigmav(k)
                   if (rap > sog) then
                       work1(i) = ModuliSel(1,i)
                   endif
                enddo
       
                ifl = 1
                if (WhichModel == 1) then
                    call FomFirstModel(ifl,nreflSelRot,costo)
                else
                    call FomMoreModels(ifl,nreflSelRot,costo)
                endif

              else
               call CalcolaCostoProva(costo) 
              endif

c             write(6,'(5x,i8,3f8.3)') solnum,costo_old,costo_rot,costo

              if (costo > costomax) costomax=costo
              if (costo < costomin) costomin=costo
              sum_costo=sum_costo+costo
              sum_costo2=sum_costo2+costo*costo
c
c--memorizzo le soluzioni
c
!             solnum=solnum+1
              vet2(1)=tet1
              vet2(2)=tet2
              vet2(3)=tet3
corig         solcan(solnum)=solution(vet2(1:3),tre(1:3),  
corig*                    costo,dieci,erore,solnum,solnum,1)
              solcan(solnum)=solution(vet2(1:3),tre(1:3),  
     *                    costo,dieci,erore,solnum,solnum,1,
     *                    prt_fom(1:5))

       if (kverbo == 1) then
          write(6,'(a,i8,3f15.5)') 
     *            ' Costo =', solnum, costo, sum_costo, sum_costo2
       endif
c
c--faccio avanzare la grafica
c
              if (solnum.eq.iperc) then
                jperc=jperc+1
                iperc=iperc+iperc0
                call scrper(' ',jperc,nperc)
              else
                if (mod(solnum,n100) == 0) then
                    call DoSingleIteration()
                endif
              endif
c
              if (ifPositioned == 1) goto 999
c
!TEST         if (solnum == 1000) exit
              if (fastMR == 1 .and. solnum == 1000) exit  ! riduce il numero di rotazioni
          enddo
!TEST         if (solnum == 1000) exit
              if (fastMR == 1 .and. solnum == 1000) exit  ! riduce il numero di rotazioni
        enddo
!TEST         if (solnum == 1000) exit
              if (fastMR == 1 .and. solnum == 1000) exit  ! riduce il numero di rotazioni
      enddo
c
  999 continue 
      call scrper(' ', 0, -1)
      if(kverbo>0) write(lo,1800) solnum
      avrgRot=sum_costo/float(solnum)
      avrgRot2=sum_costo2/float(solnum)
      sigmaRot=sqrt(abs(avrgRot2- avrgRot*avrgRot))
c
      if(kverbo>0) then
          write(6,'(a,i8,4f15.5)') 
     *      'costomax',solnum,costomax,costomin,avrgRot,sigmaRot
      endif
      if (ifTraOnly > 0) then
        ifPositioned=0
      endif
c
      return
   10 format('Rotation step using ',f5.2,' degrees increments')
   11 format(' using ',f5.2,' degrees increments')
   20 format(' Angular increments: ',f5.2,' Degrees')
   30 format(' Number of reflections selected for rotation step:    ',
     *       i6,/,
     *       ' Number of reflections selected for translation step: ',
     *       i6)
 1800 format('n. of explored rotations: ',i12)
      end
!------------------------------------------------------------------
      function riflessiScelti(rho_min,rho_max)
      USE General
      USE Symmetry
      USE Molcom
      USE Riflessi
      USE riflessi_c
      USE RuotaRiflessi
      USE PhaseModule
      
      dimension vet1(3),vet2(3)
      integer:: s, f, ivet2(3)
      
      f=1
      do k=1,nrefl
        if  (( rho_min<=rhov(k) ).and.( rho_max>=rhov(k))) then
             khlv(1:3,2,f)=khl(1:3,k)
             solv_corr(2,f)=1.0-exp(-rhov(k)/rho_min)
             icont=0
             do s = 1, nsym
                do l = 1, 3
                   ivet2(l)=0
                   do m = 1, 3
                     ivet2(l) = ivet2(l) +  khlv(m,2,f) * kmat(s,m,l)
                   enddo
                enddo
                vet2=ivet2
                call controllo_indici_interi(vet2,ivet2)
                icont  =  icont  +  1
                khlv_eq(1:3,icont,2,f) = ivet2(1:3)
             enddo
             k_mem(f)=k
             f=f+1
         end if   
      enddo 
      riflessiScelti = f-1
      if(kverbo>0) then
        write(lo,*) 'Selected ',riflessiScelti,' reflections from ',
     *              nrefl
      endif

      return
      end
!------------------------------------------------------------------
      subroutine AnalisiRotSolution(WM)
      USE General
      Use Atomi
      USE Riflessi
      USE Solutions
      USE Grafici
      USE RemoModule
      USE PhaseModule
      USE Molcom
      USE RuotaRiflessi
      USE riflessi_c
      USE Symmetry
      USE Html
      USE Groups, only : nResidStored, nAcid

!
      integer :: WM
      character stringa*20
      dimension b(3,3),vet2(3)
      integer ivet2(3),s
      dimension vet1(3)
      dimension rmtt(3,3),ihmx_sav(3),group_sol_sav(5000,5000)   !,group_sol_sav(100,100)
      logical difficile
      common/user/ resol1o
      
      kkvv = kverbo
c     if (knw > 0 ) kverbo = 1
!
!--calcolo di rho
!
      norig=0
      group_sol=0
      difficile=.false.
      call calcolasumff 
      rmax=maxval(solcan(1:solnum)%RotFom)
      rmin=minval(solcan(1:solnum)%RotFom)
      if (rmax>rmin) then
c--faccio affinamento anche quando ho una sola soluzione candidata
        do i=1,solnum
           work3(i) = solcan(i)%RotFom
           iwork3(i) = i
        enddo
        iuno = -1
        call sortall3(iuno,work3,iuno,solnum,iwork3)
c

        if (nMolMRTot > 1 .or.idSeq < 0.5) difficile=.true.
        ncontr=1
        if(difficile)ncontr=20 
        if(difficile)ies_thre(1)=1
        nSolToExplore = 0

!-- con direttiva posi non uso mai il clustering
        if (ifPositioned /= 0) then
            ifClust = 0
        endif
 
        if (idSeq <= idSeqThre) then
            ifClust = 0
        endif

        if (ifClust == 1) then
            if (WhichModel > 1) then
                ifClust = 0
            endif
        endif

        if (ifClust == 0) then
            if (WhichModel == 1) then
                call DefineSolutions_OLD
                if (fastMR == 1) sogSolToExplore = 25
            endif
        else
            call DefineSolutionsRot  ! CLUST
            if (fastMR == 1) sogSolToExplore = 100   ! riduce le rotazioni del clustering
        endif


        if(solnum < sogSolToExplore) then
           sogSolToExplore = solnum
        endif

        do
           do ii=1,solnum
              i = iwork3(ii)
              rho=(solcan(i)%RotFom-rmax)/(rmin-rmax)
              if (rho <= rhoSog1) then  
                 nSolToExplore = nSolToExplore + 1
                 solcan(nSolToExplore)%ipunt = i
              endif
corig             if( nSolToExplore==100)exit
!-- TEST NUOVA FOM ROTAZIONE
             if( nSolToExplore == sogSolToExplore ) exit  ! prova Dedi
!-- TEST NUOVA FOM ROTAZIONE
           enddo
           if(nSolToExplore<ncontr)then
             nSolToExplore = 0
             rhoSog1=rhoSog1+0.01
           else 
             exit
           endif  
        enddo 
      else
c       write(6,*) 'Attenzione',rmax,rmin,solnum
        nSolToExplore=solnum
        do ii=1,solnum
           solcan(ii)%ipunt = ii
           iwork3(ii) = ii
        enddo
      endif
!
      if (ifPositioned == 0) then
        if (ifClust == 0) then
          if (WhichModel > 1) then
              call DefineSolutions_OLD
          endif
        endif
      endif

      if (WM == 1) then
          if (knw > 0) then
              if (numeroSoluzioni == 1) then
                  write(lo,11) solnum, nSolToExplore
              else
                  write(lo,12) solnum, nSolToExplore
              endif
          else
              write(lo,13) solnum, nSolToExplore
          endif
      endif

!!!!  nSolToExplore = min0(solnum/10,10000)  ! prova valore dinamico

      nSolToExplore0=nSolToExplore 
c
      ifDrawGR = .true.
      if (WM == 1) then
          write(Inte,'(i10)') solnum
          call NoBlanks(Inte, k1)
          write(Msg,20) Inte(1:k1)
          call TestoGR(Msg, -1, 2, 2)
          write(Inte,'(i10)') nSolToExplore
          call NoBlanks(Inte, k1)
          write(Msg,30) Inte(1:k1) ! , rhoSog1
          call TestoGR(Msg, color_GREEN, 2, 2)
      endif
c
c--stampa delle soluzioni migliori
c
      if(kverbo > 0 .or. knw > 0) call ScriviRotSolution()
      call MRInfo(2)
      call toflush()
c
      call AllocaGrafici(1, nSolToExplore,0)
      call DataForGraph(-1,nSolToExplore)
      call DataForGraph(1,nSolToExplore)

! -  per saltare il clustering
!CLUST       return ! CLUST
      if (ifClust == 0) then
          return ! CLUST
      endif

      Msg = 'Clustering trials'
      call PrintMess(Msg)
      call DoSingleIteration()
!
      jblock = 1
      call Prima()
!
      if (ifPositioned == 1) return
      if (ifTraOnly == 1) return
      call scrper(' ',0,0)

*     if (kverbo == 0 .and. knw == 0) then
*        write(lo,35)
*     else
*        write(lo,40)
*     endif
      if(use_resplus) then
c--sdoppio le informazioni alla risoluzione di MR e le salvo in vettori gemelli  

        nreflSelTra_sav = nreflSelTra
        nreflSelRot_sav = nreflSelRot 
        call AllocaRiflessi_mio(1)
        rho_max = (0.5/resol1)**2
        rho_min = (0.5/resol2)**2
        nreflSel=riflessiScelti(rho_min,rho_max)
        n=1
        do i=1,nreflSel
           k  = k_mem(i)
           modEc=evet(k)**2
           if(modEc > 1.35.or. modEc < 0.7) then
              khlv(1:3,2,n)=khlv(1:3,2,i)
              solv_corr(2,n)=solv_corr(2,i)
              icont=0
              do s = 1, nsym
               do l = 1, 3
                  ivet2(l)=0
                  do m = 1, 3
                     ivet2(l) = ivet2(l)+khlv(m,2,n)*kmat(s,m,l)
                  enddo
               enddo
               vet2=ivet2
               call controllo_indici_interi(vet2,ivet2)
               icont  =  icont  +  1
               khlv_eq(1:3,icont,2,n) = ivet2(1:3)
              enddo
              k_mem(n)=k
              n=n+1
            endif
         enddo
         nreflSelRot=n-1
         call Orto(cell) !ortogonalizza il sistema
         do j=1,3
           do i=1,3
            rmtt(i,j)=rmi(j,i)*dimcell !matrice riscalata
           enddo
         enddo
         do i=1,nreflSelRot
            k  = k_mem(i)
            ModuliSel(2,i) = evet(k)
            do jj=1,nsym
               vet1(1:3)=khlv_eq(1:3,jj,2,i)
               call MoltMatVec(rmtt,vet1,vet2) !eseguo la moltiplicaz matrice vettore
               khlv_eq(1:3,jj,2,i)=vet2(1:3)
            enddo
         enddo
      endif

c     endif
      call scrper(' ', 0, -1)
!
c      write(lo,80) nSolToExplore
!
c
      if (kverbo > 0) write(lo,110)
      if(nSolToExplore>nMolMR*2)then 
       ipadri=0
       do ii = 1,nSolToExplore
c         ii = iwork3(j)
         WhichSolution = solcan(ii)%ipunt
         if(solcan(WhichSolution)%accepted==0) cycle 
         ipadri = ipadri + 1

         call ImproveRotNewNew(1,ii,ipadri)
         if (kverbo > 0) then
             write(lo,60) ipadri,WhichSolution,
     *                    solcan(WhichSolution)%RotFom,
c    *                    solcan(WhichSolution)%RFom(1:5),  ! dettagli RFom
     &                    solcan(WhichSolution)%RotVal(1:3)*rtod
         endif
      enddo
!
       if (kverbo > 0) write(lo,110)
       write(Inte,'(i10)') ipadri
       call NoBlanks(Inte, k1)
       write(Msg,90) Inte(1:k1)
       HTMLstr = Msg
       call MRInfo(99)  
       call TestoGR(Msg, -1, 2, 2)
       if(ipadri>nMolMR*2)then
         group_sol_sav(:,:)=0.0
         rmax=-1.0
         rmin=+1.0
         do j=1,ipadri
           nsol = group_sol(j,1)
           WhichSolution = solcan(nsol)%ipunt
           RotFomNew=solcan(WhichSolution)%RotFom
           if(RotFomNew>rmax) rmax=RotFomNew
           if(RotFomNew<rmin) rmin=RotFomNew
         enddo
         coeffCompl=idSeq/nMolMR
corig    rhoSog1a  = -0.57*coeffCompl + 0.68!-0.08*idSeq + 0.1!0.1
c        rhoSog1a  = -0.57*indexDiff + 0.68
!!!      rhoSog1a  = -0.55*indexDiff + 0.70
c         write(6,*)"rhoSog1a=",rhoSog1a
*     RFom_thr = rhoSog1a*(rmin-rmax)+rmax
*     if (knw > 0) then
*         write(lo,*) 'RFom_max =',rmax,'  RFom_min =',rmin
*         write(lo,*) 'RFom_thr =',RFom_thr,'  Threshold =',rhoSog1a
*     endif
         ipadri1=0 
         do 
           do j=1,ipadri
              nsol = group_sol(j,1)
              i = solcan(nsol)%ipunt
              rho=(solcan(i)%RotFom-rmax)/(rmin-rmax)
              if(rho <= rhoSog1a) then   
                ipadri1 = ipadri1 + 1
                group_sol_sav(ipadri1,:)=group_sol(j,:)
c              else
c                exit!lo posso fare se il vettore è ordinato per fom
              endif
           enddo
           if(ipadri1>=nMolMR*2) then 
              ipadri=ipadri1
              group_sol(:,:) = group_sol_sav(:,:) 
              exit
           else
              rhoSog1a = 1.1*rhoSog1a!l'aumento del 10% 
              ipadri1 = 0
           endif 
         enddo

!DEDI
         sog_ipadri = sogSolToExplore/10.
         if (ipadri > sog_ipadri) ipadri = sog_ipadri
!DEDI

c       rhoSog1a  = -0.08*idSeq + 0.1!0.1
         nSolToExplore1 = 0 !conterà le figlie prese
c        write(6,*)"--------------------------------------------------" 
         if (kverbo > 0) write(lo,110)
         do i=1,ipadri
           rmax=-1.0
           rmin=+1.0
           nsolfiglie=0
!calcolo massimo e minimo della fom per ogni cluster di soluzioni
           iwork1(i+nSolToExplore1)=solcan(group_sol(i,1))%ipunt
!ordino il cluster
           if(ifpseud==1)then 
             do j=1,nSolToExplore
                jj=group_sol(i,j)
                if(jj==0)exit
                nsolfiglie=nsolfiglie+1 
                WhichSolution = solcan(jj)%ipunt
                RotFomNew=solcan(WhichSolution)%RotFom
                if(RotFomNew>rmax) rmax=RotFomNew
                if(RotFomNew<rmin) rmin=RotFomNew
             enddo

             if(nsolfiglie>1)then 
c               do j=2,nsolfiglie
c                  jj=group_sol(i,j)
c                  ii = solcan(jj)%ipunt
c                  work3(j) = solcan(ii)%RotFom
c                  iwork3(j) = jj
c               enddo
c               call sortall3(-1,work3,iuno,j-1,iwork3)!per evitare che vada inloop se non ha trovato figli della soluzione considerata
               do j=2,nsolfiglie
                  jj=group_sol(i,j)
!prendo le migliori per ogni gruppo 
!!!la soglia potrebbe dipendere dalla idseq!!!!!
                  if(abs(rhoSog1a)< 0.0001)rhoSog1a  = 0.1!(rmax * 0.25)*(rmax-rmin)
c                  ii=iwork3(j)
                  iii = solcan(jj)%ipunt
                  rho=(solcan(iii)%RotFom-rmax)/(rmin-rmax)
                  if (rho <= rhoSog1a) then
                      nSolToExplore1 = nSolToExplore1 + 1
                   iwork1(i+nSolToExplore1)=iii
                  else
                      exit
                  endif
               enddo
             endif
           endif  
         enddo
      
         nSolToExplore=ipadri+nSolToExplore1 

*        write(lo,80) nSolToExplore
!DEDI    write(lo,40) nSolToExplore


!
!-- definizione del numero di soluzioni da selezionare per il primo modello
!
c       if (WhichModel == 1) then
c           call DefineSolutions_OLD
c       endif


        if (ifClust == 0) then
            if (WhichModel == 1) then
                call DefineSolutions_OLD
            endif
        else
            call DefineSolutions_CLUST  ! CLUST
        endif
        if (fastMR == 1) nSolToExplore = 20


         if (knw == 0) then
             write(lo,44) nSolToExplore0, nSolToExplore
         else
             write(lo,45) nSolToExplore0, nSolToExplore
         endif
         write(lo,46) 
         HTMLstr =' Clustering and optimization of selected rotations'
         call MRInfo(99)
         write(HTMLstr,42) nSolToExplore
         call MRInfo(99)
         HTMLstr =' '
         call MRInfo(99)
         HTMLstr ='     Solution   Trial     RFom    Rotation values'
         call MRInfo(99)

         solcan(1:nSolToExplore)%ipunt=iwork1(1:nSolToExplore)
         do j=1,nSolToExplore
           i = solcan(j)%ipunt
           work3(j) = solcan(i)%RotFom
           iwork3(j) = j
         enddo
         call sortall3(-1,work3,iuno,nSolToExplore,iwork3)
!        
! -- per escludere le rotazione che dopo clustering hanno RFom < 0.0
!CLUST   
         if (ifClust == 1) then
             zero = 0.0000000001
             nsolAcc = 0
             do j=1,nSolToExplore
                  if (work3(j) > zero) then
                      nsolAcc = nsolAcc + 1
                  endif
             enddo
             nSolToExplore = max0(nsolAcc,nSolToExplore/10)
         endif
!CLUST   


         iwork1(1:nSolToExplore) = 0
         do j=1,nSolToExplore
           ii = iwork3(j)
           i = solcan(ii)%ipunt
           iwork1(j) = i
           write(HTMLstr,60) j,i,solcan(i)%RotVal(1:3)*rtod,
     *                       solcan(i)%RotFom
!          write(HTMLstr,65) j,i,solcan(i)%RotVal(1:3)*rtod,
!    *                       solcan(i)%RotFom, solcan(i)%RFom(1:5)
           call MRInfo(99)
           write(lo,'(a)') HTMLstr(1:Lung(HTMLstr))
!          write(lo,60) j,i,solcan(i)%RotFom,solcan(i)%RFom(1:5),  ! dettagli RFom
!    *                  solcan(i)%RotVal(1:3)*rtod
         enddo
         do j=1,nSolToExplore
           solcan(j)%ipunt = iwork1(j) 
         enddo
       endif
      else
       write(Inte,'(i10)') nSolToExplore
       call NoBlanks(Inte, k1)
       write(Msg,90) Inte(1:k1)
       call TestoGR(Msg, -1, 2, 2)
      endif
      if(use_resplus) then

        nreflSelTra = nreflSelTra_sav
        nreflSelRot = nreflSelRot_sav 
        call AllocaRiflessi_mio(2)

      endif

*     write(lo,80) nSolToExplore
*     call MRInfo(23)
      write(Inte,'(i10)') nSolToExplore
      call NoBlanks(Inte, k1)
      write(Msg,100) Inte(1:k1), rhoSog1a
      call TestoGR(Msg, color_GREEN, 2, 2)
c
      if (knw > 0 ) kverbo = kkvv

      return
   10 format(' Total rotation performed: ',i10,', ',i8,' selected')
   11 format(80('-'),//,
     *      ' Out of',i8,' performed rotations, the following',
     *                i6,' were selected',/, 
     *      ' as the most probable. RFom is the figure of merit.')
   12 format(80('-'),//,
     *      ' Out of',i8,' performed rotations, the following',
     *                i6,' were selected',/, 
     *      ' as the most probable. NRFom is the figure of merit.')
   13 format(80('-'),//,
     *      ' ROTATION STAGE: out of',i8,' performed rotations',/,
     *                i6,' were selected as the most probable.')

   20 format('Explored trials: ',a)
!  30 format('    Selected ',a,' trials for clustering (threshold: ',
!    *                                                      f5.2,')')
   30 format('    Selected ',a,' trials')
   35 format(' Clustering and optimization of selected rotations')
   40 format(' Clustering and optimization of selected rotations',/,
     *       '      Number of selected solutions after clustering',i6,
     * //,4x,' Solution   Trial     RFom    Rotation values')
   42 format('      Number of selected solutions after clustering',i5)

   44 format(' Out of',i6,' probable rotations, the following',
     *               i6,' were selected by clustering.',/,
c    *       ' and local optimization. Among them the correct',
c    *       ' rotations will be searched.',/)
     *       ' Among them the correct rotations will be searched.',/)
c    *       ' RFom is the figure of merit after clustering.',/,80('-'),
c    * /,4x,' Solution   Trial     Rotation values      RFom')
   45 format(/,' Out of',i6,' probable rotations, the following',
     *               i6,' were selected by clustering',/,
c    *       ' and local optimization. Among them the correct',
c    *       ' rotations will be searched.',/)
     *       ' Among them the correct rotations will be searched.',/)
   46 format(' RFom is the figure of merit after clustering.',/,80('-'),
     * /,4x,' Solution   Trial     Rotation values      RFom')

! -- format per stampa dettaglio RFom 
! -- format per stampa dettaglio RFom 
!  40 format(' Clustering and optimization of selected rotations',/,
!            4x,' Solution   Trial     RFom     nRAT     dRAT     RAT',
!    *          '     costo   RAT*cos   Rotation values')

   50 format(i5,'/',i5)
   60 format(8x,i5,i8,2x,3f6.1,f10.3)
   65 format(8x,i5,i8,2x,3f6.1,f10.3,f7.3,3f10.2,f7.3)
*  60 format(8x,i5,i8,f10.3," ",3f6.1)
c  60 format(8x,i5,i8,6f9.3," ",3f6.1)
   70 format(21x,f10.3," ",3f6.1,'   Improved')
   80 format(' Number of selected solutions after clustering',i5)
!  90 format('Trials after clustering: ',a)
! 100 format('    Selected for translation ',a,' with threshold ',f5.2)
   90 format('Marked trials after clustering: ',a)
  100 format('    Selected ',a,' trials for translation (threshold ',
     *                                                        f5.2,')')
  110 format(80('-'))
      end
!-----------------------------------------------------------------------
      subroutine DefineSolutionsRot
      USE General
      USE RemoModule
!
      implicit none
!
!
!-- definizione del numero di soluzioni da selezionare per il primo modello
!
      if (sogSolToExplore_Req < 0) then
          if (ifDNA > 0) then
             if (numbModels == 1) then
                   sogSolToExplore = 2000   
               else
                   sogSolToExplore = 3000   
               endif
          else
               if (idSeq <= idSeqThre) then
                   sogSolToExplore = 3000
               else
                   if (numbModels == 1) then
                       sogSolToExplore = 2000 !1000  
                   else
                       sogSolToExplore = 3000 !2000  
                   endif
               endif
          endif
      endif

c     sogSolToExplore = sogSolToExplore * 2

      if (WhichModel > 1) then
          sogSolToExplore = sogSolToExplore / 2
          sogSolToExplore = max0(sogSolToExplore, 1000)
      endif
 
      if (fastMR == 1) sogSolToExplore = 100   ! riduce le rotazioni del clustering
!
      return
      end
!-----------------------------------------------------------------------
      subroutine DefineSolutions_CLUST
      USE General
      USE RemoModule
!
      implicit none
!
      if (sogSolToExplore_Req < 0) then
          if (ifDNA > 0) then
               if (numbModels == 1) then
                   sogSolToExplore = 200   
               else
                   sogSolToExplore = 300   !200 !300   
               endif
          else
               if (idSeq <= idSeqThre) then
                   sogSolToExplore = 300   !200 !300 !!!500
               else
                   if (numbModels == 1) then
                       sogSolToExplore = 200  
                   else
                       sogSolToExplore = 300   !200 !300   
                   endif
               endif
          endif
      endif
      nSolToExplore = sogSolToExplore   ! CLUST

      if (WhichModel == 2) then
          if (idSeq <= idSeqThre) then
              nSolToExplore = 150
          else
              nSolToExplore = sogSolToExplore / WhichModel
          endif
      elseif (WhichModel == 3) then
          if (idSeq <= idSeqThre) then
              nSolToExplore = 75
          else
              nSolToExplore = sogSolToExplore / WhichModel
          endif
      elseif (WhichModel >= 4) then
          if (idSeq <= idSeqThre) then
              nSolToExplore = 75
          else
              nSolToExplore = sogSolToExplore / WhichModel
          endif
      endif

      if (fastMR == 1) nSolToExplore = 20
!
      return
      end
!-----------------------------------------------------------------------
      subroutine DefineSolutions_OLD
      USE General
      USE RemoModule
!
      implicit none
!
      if (WhichModel == 1) then
!
!-- definizione del numero di soluzioni da selezionare per il primo modello
!
          if (sogSolToExplore_Req < 0) then
              if (ifDNA > 0) then
                   if (numbModels == 1) then
                       sogSolToExplore = 200   
                   else
                       sogSolToExplore = 300   
                       sogSolToExplore = 200    ! 8 novembre 2019
                   endif
              else
                   if (idSeq <= idSeqThre) then
                       sogSolToExplore = 400 ! 500
                       sogSolToExplore = 250 ! 8 novembre 2019
                   else
                       if (numbModels == 1) then
                           sogSolToExplore = 200  
                       else
                           sogSolToExplore = 300 !200
                           sogSolToExplore = 200    ! 8 novembre 2019
                       endif

*                          sogSolToExplore = 400    ! TEST
*                          sogSolToExplore = 200    ! suggerimento Carmelo
                           
                   endif
              endif
          endif
      elseif (WhichModel == 2) then
          if (idSeq <= idSeqThre) then
              nSolToExplore = 150
          else
              nSolToExplore = sogSolToExplore / WhichModel
          endif
      elseif (WhichModel == 3) then
          if (idSeq <= idSeqThre) then
              nSolToExplore = 75
          else
              nSolToExplore = sogSolToExplore / WhichModel
          endif
      elseif (WhichModel >= 4) then
          if (idSeq <= idSeqThre) then
              nSolToExplore = 75
          else
              nSolToExplore = sogSolToExplore / WhichModel
          endif
      endif

      if (WhichModel > 1) then
          nSolToExplore = max0(nSolToExplore, 20)
          if (fastMR == 1) nSolToExplore = 20
      endif

!
      return
      end
!-----------------------------------------------------------------------
      subroutine ApplicaPatterson()
      USE General
      USE Solutions
      USE RemoModule
      USE MappaPatterson
      USE Molcom
      USE Mappa
c
      dimension btra(3,3),b(3,3),x1(3),x2(3)
c
      call AllocaMappa(1)
c
      do nsol=1, nSolToExplore
         WhichSolution = solcan(nsol)%ipunt
c
c--recupero la matrice di rotazione
c
         tet1=solcan(WhichSolution)%RotVal(1)
         tet2=solcan(WhichSolution)%RotVal(2)
         tet3=solcan(WhichSolution)%RotVal(3)
         call RotationOper1(b,tet1,tet2,tet3)

         do ii=1, numbModels
           do j=1, MonomerInModel(ii)
             do i=1, natsInModel(ii)
               model(ii)%atoms(1:3,i,j) = model(ii)%saved(1:3,i,j)
             enddo
           enddo
         enddo
c
         do i=1,3
           do j=1,3
              btra(i,j) = b(j,i)
           enddo
         enddo
c
         do ii=1, numbModels
           do j=1, MonomerInModel(ii)
              do i=1, natsInModel(ii)
                 x1(1:3)=model(ii)%atoms(1:3,i,j)
                 call MoltMatVec(rm, x1, x2)
                 call MoltMatVec(btra, x2, x1)
                 call MoltMatVec(rmi, x1, x2)
                 model(ii)%atoms(1:3,i,j) = x2(1:3)
              enddo
           enddo
        enddo
!--a questo punto ho le coordinate del modello ruotato
!  ora inizio il check con la Patterson
c
c--genero la mappa del modello
c
         badd = 0.0
         call ChemInfo_MR_Local(badd)
c
c        call CCP4MAPOUT(0,xmap,np,'xmap.map')
c        call CCP4MAPOUT(1,Patt,np,'Patt_now.map')
c
c        call maxmin3d(denmin,denmax,avden,stden,npunt,0)
c        write(6,'(a,4f10.1)') 'Mappa modello ',
c    &                    denmin,denmax,avden,stden
c
c--faccio un taglio sul modello
c
c     sog=2.0*stden
c     do iz=0,np(3)-1
c     do iy=0,np(2)-1
c     do ix=0,np(1)-1
c       write(91,*) ix,iy,iz,xmap(ix,iy,iz)
c       if(xmap(ix,iy,iz)<sog) xmap(ix,iy,iz)=0.0
c     enddo
c     enddo
c     enddo
c
!
!--confronto la mappa del modello con la Patterson,
!  residuo per residuo
!
         
         aconttot=0.
         acontnum=0.
         iconttot=0.
         icontnum=0.
         numOld=0.
         numr=0.
         do ii=1, numbModels
           do j=1, MonomerInModel(ii)
              do i=1, natsInModel(ii)
                 if (model(ii)%tipoAtomo(i,j) == 'ca ') then
                   x2(1:3)=model(ii)%atoms(1:3,i,j) 
                   acont=PattCheck(x2(1),x2(2),x2(3)) 
                   num=model(ii)%numResiduo(i,j)
c                  if(num.ne.numOld) then
c                    numr=numr+1
c                    write(6,*) 'Residuo ',num,' fom=',
c    &                           acontnum/float(icontnum)
c                    write(98,*) numr,acontnum/float(icontnum)
c                    icontnum=0
c                    acontnum=0
c                  endif
                   write(6,*) 'Atomo ',num,' fom=',acont
                   write(97,*) num,acont
                   aconttot=aconttot+acont
                   acontnum=acontnum+acont
                   iconttot=iconttot+1
                   icontnum=icontnum+1
                   numOld=num
                 endif
              enddo
           enddo
        enddo
        write(6,*) 'Solution ',nsol,' fom=',aconttot/float(iconttot)
c
      enddo
      call AllocaMappa(2)
c
      return
      end
c-------------------------------------------------------
      real function PattCheck(x1,y1,z1)
      USE General
      USE Symmetry
      USE Riflessi
      USE Mappa
      USE MappaPatterson
      integer sidepp
!
      dimension xs(3),xeq(3)
      logical :: noWrite
!
      io1=sidepp(nint(x1*np(1)),np(1))
      io2=sidepp(nint(y1*np(2)),np(2))
      io3=sidepp(nint(z1*np(3)),np(3))
!
      dx = 1.0/float(np(1))
      dy = 1.0/float(np(2))
      dz = 1.0/float(np(3))
!
!--sposto la Patterson sulla posizione x1,y1,z1 
!
      xmapShi(:,:,:)=0.0
      do iz = 0,np(3)-1
      do iy = 0,np(2)-1
      do ix = 0,np(1)-1
         xx1=Patt(ix,iy,iz)
         if(xx1<0.01) cycle
         ix1=sidepp(ix+io1,np(1))
         iy1=sidepp(iy+io2,np(2))
         iz1=sidepp(iz+io3,np(3))
         xmapShi(ix1,iy1,iz1)=xx1
      enddo
      enddo
      enddo
!
!-- switch to the Patterson Space Group
!
      icent=1
      tmat(:,:)=0.
      call musym()
      nsymTot=nsym*(icent+1)*pts
!
!--calcolo la sovrapposizione con la mappa del modello
!
      xmapSav(:,:,:)=0.0
      asum=0.0
      asumTot=0.0
      icont=0
      do iz = 0,np(3)-1
      do iy = 0,np(2)-1
      do ix = 0,np(1)-1
         xx1=xmapShi(ix,iy,iz)
!--ora sono nella corona circolare della Patterson
         if(xx1>-0.01.and.xx1<0.01) cycle
         asumTot=asumTot+xmap(ix,iy,iz)
         if(xx1<0.01) cycle
!--ora sono sotto la maschera della Patterson
         xx3=xmapSav(ix,iy,iz)
         if(xx3>0.5) cycle
!--ora sono sotto la maschera della Patterson ripulita della simmetria
         xs(1)=ix*dx
         xs(2)=iy*dy
         xs(3)=iz*dz
!--genero le regioni equivalenti per simmetria Patterson
         xxmax=0.0
         do kk1=1,ncentr
         do kk2=1,icent+1
         coef=1.0
         if(kk2==2) coef=-1.0
         do kk3=1,nsym
           call xequi(xs,kk3,coef,xeq,kk1)
           ixs=sidepp(nint(xeq(1)*np(1)),np(1))
           iys=sidepp(nint(xeq(2)*np(2)),np(2))
           izs=sidepp(nint(xeq(3)*np(3)),np(3))
           xx2=xmap(ixs,iys,izs)
           if(xx2>xxmax) xxmax=xx2
           xmapSav(ixs,iys,izs)=1.0
         enddo
         enddo
         enddo
         icont=icont+1
         asum=asum+xxmax
      enddo
      enddo
      enddo
!
!-- restore the original Space Group
!
      call RestoreSpaceGroup
      noWrite=.false.
!
c     call Correla_Mappe(np(1),np(2),np(3),xmapShi,xmap,corre)
c     npunti=min(nrefl,icont1)
c     call cc_vet(work1,work2,npunti,corre)
c     PattCheck=2*float(icont1)/float(icont)
      PattCheck=asum/asumTot
      if (knw > 0) write(6,*) 'sono    ',icont
!
      return
      end
c---------------------------------------------------------------
      subroutine ScriviRotSolution()
      USE General
      USE Solutions
      USE RemoModule
c
*     kverbo = 1
      write(lo,30)
      if (numeroSoluzioni == 1) then
          write(lo,10) 
      else
          write(lo,15) 
      endif
      do i=1, nSolToExplore
         WhichSolution = solcan(i)%ipunt
         if(sigmaRot<=0.0001) then
           Chi2=0.0
         else
           Chi2=(solcan(WhichSolution)%RotFom-avrgRot)/sigmaRot
         endif
c        write(lo,20) i,WhichSolution,Chi2,
c    &                solcan(WhichSolution)%RotVal(1:3)*rtod,
c    &                solcan(WhichSolution)%RotFom 
         if (kverbo == 0) then
             write(lo,20) i,WhichSolution,
     &                solcan(WhichSolution)%RotVal(1:3)*rtod,
     &      solcan(WhichSolution)%RotFom
         else
             write(lo,25) i,WhichSolution,
     &                solcan(WhichSolution)%RotVal(1:3)*rtod,
c    &      solcan(WhichSolution)%RotFom,solcan(WhichSolution)%RFom(1:5)
     &      solcan(WhichSolution)%RotFom,solcan(WhichSolution)%RFom(1:2)
         endif
      enddo
      write(lo,30)
*     kverbo = 0
c
      return

c  10 format(4x,' Solution   Trial      Chi    ',
c    *           'Rotation values      RFom')
   10 format(4x,' Solution   Trial   Rotation values      RFom') 
   15 format(4x,' Solution   Trial   Rotation values     NRFom') 
c  15 format(4x,' Solution   Trial  Rotation values      
c    *RFom   <SigA>   sumR2    sum<R2>   sumDiff  Resid') 
! -- format per stampa dettaglio RFom 
c  20 format(5x,2i8,f10.2,' ',3f6.1,f9.3)
   20 format(5x,2i8,3f6.1,f10.3)
c  25 format(5x,2i8,3f6.1,f10.3,f7.3,3f10.3,f7.3)
   25 format(5x,2i8,3f6.1,f10.3,5f12.3)
c  25 format(5x,2i8,3f6.1,3f10.3)
   30 format(80('-'))

      end
!------------------------------------------------------------------
      subroutine TraMolecularSingle()
c
c--considera come unica soluzione di traslazione quella data
c  tramite direttiva tras
c
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Mappa
      USE Solutions
      USE riflessi_c
      USE Riflessi
      USE RuotaRiflessi
      USE TraslaSolution
      USE RemoModule
      USE PhaseModule
!
      integer  npSav(3)

c
      npSav(:) = np(:)
c
      ier=0
      TraNum=0
      call AllocaTraslaSolution(1)
      TraSol(:)%accepted=0 
c
      nSolToExploreRot = nSolToExplore
      call CheshireTra()
!!!   call CheshireConditions()
c
c     call cc_vet_mol0()
      ifl = 2
      call InitFomModel(ifl,nreflSelTra)


c
      TraNum=1
      TraAll(TraNum)%TraVal(1:3)=TranslAppl(1:3)
      TraAll(TraNum)%TraFom = 1.0
      TraAll(TraNum)%MolMPE = 0.0
      TraAll(TraNum)%RotVal(1:3) = RotAppl(1:3)*dtor
      TraAll(TraNum)%RotFom = 1.0
      TraAll(TraNum)%trial = 1
      TraAll(TraNum)%accepted = 2
c
      nSolToExplore = TraNum
      do ii=1,TraNum
         TraAll(ii)%ipunt = ii
c        work3(ii) = ii
      enddo
c
      call InitFour(0,ier)  
!
!-- rimetto a posto le posizioni atomiche
!
*     xyzs(1:3,1:nats)=xyzSk(1:3,1:nats)
c
      return
      end
!------------------------------------------------------------------
      subroutine TraMolecular()
c
c--applica le traslazioni
c
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Mappa
      USE Solutions
      USE riflessi_c
      USE Riflessi
      USE RuotaRiflessi
      USE TraslaSolution
      USE RemoModule
      USE PhaseModule
      USE Html
!
      implicit none
      integer :: npSav(3), ier, i, j, k, ii, k1, ifExaminSav, Lung
      integer :: ierr, iuno, istat, iform, jop, jopen, ifl
      real    :: rmax, rmin, rho, TFom_thr
      character (len=20) :: stringa
!
      use_sigmaA = .true.

!
!--eventualmente applico la selezione in risoluzione per l'affinamento
!
!-------------------------------------------------------------
! -- write DETAILED TRANSLATIONS on *_trasla.txt (unit=123)
      if (knw > 0) then
          k1 = index(fname(1),'.bin') - 1
c         write(Inte,197)  fname(1)(1:k1)
c         istat = 0
c         iform = 1
c         jop=jopen(123,Inte,istat,iform,ierr)
c         write(123,*)' +++ DETAILED TRANSLATIONS +++'
          if (knw == 1) then
              write(Inte,198)  fname(1)(1:k1)
              istat = 0
              iform = 1
              jop=jopen(124,Inte,istat,iform,ierr)
              write(124,*)' +++ DETAILED TRANSLATIONS +++'
          endif
      endif
 197  format(a,'_transla.txt')
 198  format(a,'_NTFom.txt')
!
!-------------------------------------------------------------


      nSolToExploreRot = nSolToExplore
c
      if (knw > 0) then
c         write(lo,9)
          write(lo,29)
c         write(123,29)
          if (knw == 1) write(124,229)
      elseif (kverbo > 0) then
c         write(lo,19)
          write(lo,39)
      endif
      npSav(:) = np(:)
      ihmxSav(:) = ihmx(:)   ! serve per strutture in P1
c
      ier = 0
      TraNum = 0
      call AllocaTraslaSolution(1)
c
      ifExaminSav = ifExamin
      if (ifP1 == 1) then
          ifExamin    = 0
      endif
      call CheshireTra()
!!!   call CheshireConditions()
c
*     call cc_vet_mol0()
      ifl = 2
      call InitFomModel(ifl,nreflSelTra)

      Msg = '<big><b>Translation stage</b></big>'
      if (numbModels == 1) then
          Msg = '<big><b>Translation stage</b></big>'
      else
          write(Msg,5) WhichModel
      endif
*     write(Inte,12) rhoSog2
*     call TestoGR(Msg(1:Lung(Msg))//Inte(1:Lung(Inte)), color_RED, 2,2)
      call TestoGR(Msg(1:Lung(Msg)), color_RED, 2,2)
c
      call scrper(' ',0,0)             
c
      do j=1,nSolToExplore
!
         write(stringa,10) j, nSolToExplore
         call NoBlanks(stringa,k)
         write(Inte,15) stringa(1:k)
         call scrper(Inte,j,nSolToExplore)
!
         WhichSolution = solcan(j)%ipunt
         if (kverbo > 0 .or. knw > 0) then 
             write(lo,'(i4,i8,f8.3,3f7.1)') j,WhichSolution,
     &                solcan(WhichSolution)%RotFom
c    &                ,solcan(WhichSolution)%RotVal(1:3)*rtod

! -- write DETAILED TRANSLATIONS on *_trasla.txt (unit=123)
c            write(123,'(i4,i8,f8.3)') j,WhichSolution,
c    &                solcan(WhichSolution)%RotFom
             if (knw == 1) then
                 write(124,'(i4,i8,f9.3,f9.3)') j,WhichSolution,
     &                     solcan(WhichSolution)%RotFom,
     *                     solcan(WhichSolution)%RFom(1)
             endif
         endif

         call ApplicaTra(j,ier)

         if (ier > 0) then
             rap = float(j) / float(nSolToExplore)
             if (kverbo > 0 .or. knw > 0) then 
                 write(lo,*) 'Sog3 reduced',rhoSog3,rap,rhoSog3*rap
             endif
             rhoSog3 = rhoSog3 * rap
             exit
         endif
      enddo
!
c     call AllocaMappa(2)
      np(:) = npSav(:)
      ihmx(:)=ihmxSav(:)
c     call AllocaMappa(1)
!
      ifExamin = ifExaminSav
c     call storeGraphInfo(nSolToExplore)
cc    call AllocaGrafici(1, nSolToExplore,0)
c     if (numbModels == 1) then
c        call DataForGraph(3,TraNum)!nSolToExplore)
c    endif

c
c--ordino le migliori traslazioni e le inserisco in solcan 
c
      rmax=maxval(TraAll(1:TraNum)%TraFom)
      rmin=minval(TraAll(1:TraNum)%TraFom)
c     if (nSolToExplore < 5) rhoSog3 = 1.0 ! poche soluzioni
!DEDI - più soluzioni finali
      if (nSolToExplore < 10) rhoSog3 = 1.0 ! poche soluzioni
!DEDI - più soluzioni finali

*     TFom_thr = rhoSog3*(rmin-rmax)+rmax
*     if (kverbo > 0 .and. knw > 0) then
*         write(lo,*) 'TFom_max =',rmax,'  TFom_min =',rmin
*         write(lo,*) 'TFom_thr =',TFom_thr,'  Threshold =',rhoSog3
*     endif


!PROVAAAA
!!!!!!!      rmax = rmin
       rhoSog3 = 1.0 ! poche soluzioni
!PROVAAAA
 

      if (rmax>rmin) then
          do i=1,TraNum
             work4(i)  = TraAll(i)%TraFom
             iwork4(i) = i
          enddo
          iuno = -1
          call sortall3(iuno,work4,iuno,TraNum,iwork4)
c         call AllocaGrafici(2,nSolToExplore,0)
          nSolToExplore = 0
          do ii=1,TraNum
             i = iwork4(ii)
             rho=(TraAll(i)%TraFom-rmax)/(rmin-rmax)
             if (rho <= rhoSog3 .or. TraAll(i)%accepted==2) then
                 nSolToExplore = nSolToExplore + 1
                 TraAll(nSolToExplore)%ipunt = i
                 if(ifpseud==1 .and. nMolMRTot>1)then
                    if(TraAll(i)%accepted.eq.4)
     *                 TraAll(i+1)%accepted = 2
                 endif
             endif
          enddo
!DEDI - più soluzioni finali
!         nSolToExplore = min0(nSolToExplore, 10) 
*prova?*  nSolToExplore = min0(nSolToExplore, 15) 
ccc       nSolToExplore = min0(nSolToExplore, 25) 

          if (idSeq > idSeqThre) then
              if (ifDNA == 1) then
                  nSolToExplore = min0(nSolToExplore, 10)
c                 nSolToExplore = min0(nSolToExplore, 20)
              else
                  if (numbModels == 1) then
                      nSolToExplore = min0(nSolToExplore,  5)
                  else
                      nSolToExplore = min0(nSolToExplore, 10)
                  endif
              endif
          else
              nSolToExplore = min0(nSolToExplore, 10)
          endif
!
!numero di soluzioni da ottimizzare da direttiva nopti 
!
          if (sogSolToOptimize > 0) then
              nSolToExplore = min0(nSolToExplore, sogSolToOptimize)  
          endif

!TEST     nSolToExplore = min0(nSolToExplore,  5)
          if (fastMR == 1) nSolToExplore = min0(nSolToExplore,  3)  ! riduce le final sol.
          
!!!!!            nSolToExplore = nSolToExplore * 2  !  TEST ROCCO
                 nSolToExplore = nSolToExplore * 2
!DEDI - più soluzioni finali
      else
          nSolToExplore = TraNum
          do ii=1,TraNum
             TraAll(ii)%ipunt = ii
          enddo
      endif
c     call storeGraphInfo(nSolToExplore)
cc    call AllocaGrafici(1, nSolToExplore,0)
c     if (numbModels == 1) then
c         call DataForGraph(3,nSolToExplore)
c     endif
c
      if (nsym == 1 .and. icent == 0) then
          ifP1 = 1
      else
          ifP1 = 0
      endif
          ifP1 = 0
      if (nMolMRTot == 1) then
          IF (ALLOCATED(TraSol)) DEALLOCATE (TraSol, stat = ierr)
      endif
c
      if (knw == 1) then
c         close(123)
          close(124)
      endif
c
      write(Inte,'(i10)') nSolToExplore
      call NoBlanks(Inte, k1)
      write(HTMLstr,20) Inte(1:k1) ! , rhoSog3
      call MRInfo(99)
      call TestoGR(HTMLstr, color_GREEN, 2, 2)
c
    5 format('<big><b>Translation stage, model #',i3,' </b></big>')
    9 format( ' nSol  Trial    RFom        Rot    TFom  ',
     *          '  dx     dy     dz    MPE  BestTFom  in')
! -- format per stampa dettaglio TFom (vedi TraslaFrammento)
!   9 format( ' nSol  Trial    RFom        Rot    TFom',
!    *        '  nRAT   dRAT    RAT   corre RAT*cor',
!    *        '  dx     dy     dz    MPE  BestTFom  in')

   19 format( ' nSol  Trial    RFom        Rot    TFom  ',
     *          '  dx     dy     dz  BestTFom  in')
   10 format('(',i5,'/',i5,')')
   11 format('Translation step using threshold ',f5.2)
   12 format(' using threshold ',f5.2)
   15 format('Translating trial ',a)
!  20 format('    Final solutions selected: ',a,' with threshold',f5.2)
   20 format('    Final selected solutions: ',a) ! ,' (threshold',f5.2,')')
   29 format( ' nSol  Trial    RFom    # ',
     *        '    dx     dy     dz     TFom   MPE')
*    *        '    dx     dy     dz     TFom   TFold   MPE')
   39 format( ' nSol  Trial    RFom    # ',
     *        '    dx     dy     dz     TFom')
  229 format( ' nSol  Trial    RFom5   <sigmaA>  #     g',
     *        '     sumR1    sum<R1>   sumDiff   Resid   TFom   MPE')
c
      return
      end
c------------------------------------------------------------------
      subroutine ApplicaTra(nsol,ier)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Solutions
      USE Riflessi
      USE riflessi_c
      USE RuotaRiflessi
      USE RemoModule
      USE TraslaSolution
      USE PhaseModule
!
      common /appo_fom/ prt_fom(5), Rota_Fom
!
      dimension btra(3,3),b(3,3),x1(3),x2(3), fragShift(3)
      
c--recupero la matrice di rotazione
c
      tet1=solcan(WhichSolution)%RotVal(1)
      tet2=solcan(WhichSolution)%RotVal(2)
      tet3=solcan(WhichSolution)%RotVal(3)
      call RotationOper1(b,tet1,tet2,tet3)

      do ii=1, numbModels
         do j=1, MonomerInModel(ii)
            do i=1, natsInModel(ii)
               model(ii)%atoms(1:3,i,j) = model(ii)%saved(1:3,i,j)
            enddo
         enddo
      enddo
      
*     nIm = natsInModel(1)
*     model(1)%th_fact_dev(1:nIm,1) = model(1)%th_fact(1:nIm,1)
c
      do i=1,3
        do j=1,3
            btra(i,j) = b(j,i)
         enddo
      enddo
      do ii=1, numbModels
         do j=1, MonomerInModel(ii)
            do i=1, natsInModel(ii)
               x1(1:3)=model(ii)%atoms(1:3,i,j)
               call MoltMatVec(rm, x1, x2)
               call MoltMatVec(btra, x2, x1)
               call MoltMatVec(rmi, x1, x2)
               model(ii)%atoms(1:3,i,j) = x2(1:3)
            enddo
         enddo
      enddo
!
!-- potremmo applicare Refmac
!
      if (ifPositionedVet(1) == 0 .and. ifAdjust == 1) then
          call AffinaConRefmac(2)
      endif
!
      fragShift(:) = 0.0
      call sftrNew(1, fragShift, dump, 1)
      if (ifRotOnly == 0) then
          Rota_Fom = solcan(WhichSolution)%RotFom
          call TraslaFrammento(nsol,ier)
      else
          call RotationOnly()
      endif

*     model(1)%th_fact(1:nIm,1) = model(1)%th_fact_dev(1:nIm,1)

      do ii=1, numbModels
         do j=1, MonomerInModel(ii)
            do i=1, natsInModel(ii)
               model(ii)%atoms(1:3,i,j) = model(ii)%saved(1:3,i,j)
            enddo
         enddo
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine AffinaConRefmac(iAction)
      USE General
      USE Symmetry
      USE ArpWarp
      USE RemoModule
!
!-- iAction = 1 write MTZ file 
!-- iAction = 2 start Refmac
!
      implicit none
      integer :: nrefi, ier, k, kk, kStripTask1, iAction
      integer :: nSpaceGroupSav, jsysSav, nRefSav, lstringa, lcard
      integer :: itype, iform, jop, jopen, Lung, MonInMod(20)
      logical :: Esiste
      character (len=3) :: extens
      character (len=16) :: p1
      character (len=20) :: stringa
!
*     return
!
      if (ifW95 /= 0) then
          extens = 'bat'
      else
          extens = 'sh'
      endif
      k = index(fname(1),'.bin')
      kk = kStripTask1(k) - 1
      nome = fname(1)(1:kk)
      lnome = Lung(nome)
      FichierOut = fname(1)(1:kk) // '_tmp.pdb'
      stringa = 'run_refmac.' // extens(1:Lung(extens))
      lstringa = Lung(stringa)
!
      nSpaceGSav(:) = nSpaceG(:)
      nSpaceGroupSav = nSpaceGroup
      jsysSav = jsys
      p1 = 'p 1             '
      read(p1,'(16a1)') nSpaceG(1:16)
      nSpaceGroup = 1
      jsys = 1
      numbGenSav = numbGen
      numbGen = 0
      nRefSav = nreflDim
      nreflDim = nrefl
!
      if (iAction == 1) then
          call WriteMTZ_Refmac(1, -1.0, ier)
!
!-- create shell script
!
          nrefi = 5
          cardImage = nome(1:lnome) // '_' // stringa(1:lstringa)
          direttiva = nome(1:lnome) // '_refmac.log'
!!mr
      call WriteRefmacShell(stringa, direttiva, nrefi,
     *                      MTZfile, FichierOut,
     *                      nome(1:lnome) // '_refmac0.mtz', ' ')
      goto 1954
!!end mr
          itype = 0
          iform = 1
          jop = jopen(jhost, cardImage, itype, iform, ier)
          write(jhost,'(a)') '#!/bin/sh'
          write(jhost,'(a)') 'refmac5 \'
          Msg = 'hklin     ' // MTZfile(1:Lung(MTZfile)) // ' \'
          write(jhost,'(a)') Msg(1:Lung(Msg))
          write(jhost,'(a)') 'xyzin     '
     *                        // FichierOut(1:Lung(FichierOut)) // ' \'
          Msg = 'hklout    ' // nome(1:lnome) // '_refmac0.mtz > '
     *                       // direttiva(1:Lung(direttiva)) // ' <<END'
          write(jhost,'(a)') Msg(1:Lung(Msg))
          write(jhost,'(a)') 'labin     FP=F SIGFP=SIGF ' //
     *                       'FREE=FreeR_flag'
          write(jhost,'(a)') 'refi -'
          write(jhost,'(a)') '    type REST -'
          write(jhost,'(a)') '    resi MLKF -'
          write(jhost,'(a)') '    meth CGMAT'
          write(jhost,'(a,i2)') 'ncyc ', nRefi
          write(jhost,'(a)') 'END'
          close(jhost)
!!mr
 1954     continue
          lstringa = Lung(stringa)
!!end mr
          cardImage = nome(1:lnome) // '_' // stringa(1:lstringa)
          lcard = Lung(cardImage)
          cardImage(lcard+1:lcard+1) = char(0)
          call MakeExec(cardImage)
      else
          if (knw == 1) Then
              write(6,*) ' AffinaConRefmac'
          endif
          FichierOut = 'XYZOUT'
          inquire (file=FichierOut,  exist = Esiste)
          if (Esiste) then
              itype = 2
              iform = 1
              jop = jopen(jhost, FichierOut, itype, iform, ier)
              close(jhost, status='delete')
          endif
          FichierOut = fname(1)(1:kk) // '_tmp.pdb'
          itype = 0
          iform = 1
          jop = jopen(jhost, FichierOut, itype, iform, ier)
          FichierOut = fname(1)(1:kk) // '_tmp.pdb'
          itype = 0
          iform = 1
          jop = jopen(jhost, FichierOut, itype, iform, ier)
          ifRemo = 0
          MonInMod(1:20) = MonomerInModel(1:20)
          MonomerInModel(1) = 1
          MonomerInModel(2:20) = 0
          totopSav = totop
          totop = 1
          call outPDB(jhost, 0, 0, 0, 0)
          ifRemo = 1
          MonomerInModel(1:20) = MonInMod(1:20)
          totop = totopSav
          close(jhost)
*         call UseRefmac(FichierOut, nRefi, 0, ier)
*         call LanciaRefmac(FichierOut, nRefi)
          Buffer1 = WorkingDirectory(1:Lung(WorkingDirectory)) // slash
     *          // nome(1:lnome) // '_' // stringa(1:lstringa)
          call Lanciash(Buffer1(1:Lung(Buffer1)) // char(0))
          call GetPdbRefmac
      endif
      nSpaceG(:) = nSpaceGSav(:)
      nSpaceGroup = nSpaceGroupSav
      jsys = jsysSav
      numbGen = numbGenSav
      nreflDim = nRefSav
!
      return
      end
!-----------------------------------------------------------------------
      subroutine GetPdbRefmac
      USE General
      USE RemoModule
      USE Molcom , only : rmi
!
      implicit none
      integer :: nats, nSpec, nSecondary, ier, i, WM
      integer :: itype, iform, jop, jopen
      real    :: aniso(6), celltemp(13)
      integer :: spec, nRes, HET, n
      real    :: orto(3),cryst(3), atomi(2), b
      character (len= 1) :: Alt, cat, Ins
      character (len= 4) :: tA, tR
      character (len=16) :: Labe
!
      FichierOut = 'XYZOUT'
      itype = 2
      iform = 1
      jop = jopen(jhost, FichierOut, itype, iform, ier)
      if (jop == 0) then
          n = 0
          call LeggiPDBinMem(1, 1, 1, 0, 0,
     *                       celltemp, n, nSpec, nSecondary, ier)
!
          rewind jgrap
!
          do i=1, n
             read(jgrap)
     *            orto,
     *            atomi(1:2),
     *            spec,
     *            b,
     *            tA,
     *            Alt,
     *            tR,
     *            cat,
     *            nRes,
     *            Ins,
     *            Labe,
     *            aniso(1:6),
     *            HET
             call MoltMatVec(rmi, orto, cryst)
*            write(6,'(i5,3f9.4)') i, model(WhichModel)%atoms(1:3,i,1)
             model(WhichModel)%atoms(1:3,i,1) = cryst(1:3)
*            write(6,'(i5,3f9.4)') i, model(WhichModel)%atoms(1:3,i,1)
*            model(WhichModel)%th_fact(i,1) = b
          enddo
          close(jhost)
      endif
      FichierOut = ' '
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Prima()
      USE General
      USE Symmetry
      USE RemoModule
      USE PhaseModule
*     USE RfacMatrixModule
!
*     nRfacMatrix   = 500
*     nRfacMatrixBl = 1
*     call AllocaRfacMatrix(1)
!
      fomBestE = -9999
      nBlocksPh = 1
      WhichFom = 2
      jBlock = 1
      jBlocksPh(1,1) = nSolToExplore
      jBlocksPh(2,1) = nSolToExplore
      jRfac = 0
*     RfacMatrix(:,:,jBlock) = 0.0
*     RfacMatrix(2,:,jBlock) = -9999.9      !!<<<
*     RfacMatrix(3,:,jBlock) = -9999.9      !!!<<<
!
      return
      end
!-----------------------------------------------------------------------
      subroutine RotationOnly()
!
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Molcom     
      USE riflessi_c
      USE Solutions
      USE RuotaRiflessi
      USE RemoModule
      USE PhaseModule
!
      dimension fragShift(3)
 
!
      call sftrNew(2, fragShift, corre,1)
!
      if(knw>0) then
        tmpwt(:) = 0.0
        do i=1, nreflSelRot
           j = k_mem(i)
           tmpwt(j) = 1.0
        enddo
        nbru = 20
        izero = 0
        ifmin = 0
        call examin(nbru, mkang, khl, ipub, iphaz, nrefl,
     *              izero,tmpwt,ifmin)
      endif
!
      solcan(WhichSolution)%TraVal(1:3) = 0.0
      solcan(WhichSolution)%TraFom = corre
      solcan(WhichSolution)%MolMPE = erore
!
      return
      end
!-----------------------------------------------------------------------
      subroutine TraslaFrammento(nsol,ier)
!
!--faccio la traslazione con la FFT
!
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Molcom     
      USE Mappa
      USE Solutions
      USE RuotaRiflessi
      USE riflessi_c
      USE TraslaSolution
      USE RemoModule
      USE PhaseModule
!
      common /appo_fom/ prt_fom(5), Rota_Fom
!
      logical :: noWrite,plusModel
      integer :: ncount, maxcount
      common/util2/noWrite,ncount,maxcount,plusModel
      dimension delta(3),vet2(3)
      integer iHcan(3)
      integer inCheshire_remo
      integer hklmax(3)
      integer WhichTraSol
      real :: delta_TFom, MPE, MPE_sog
      character (len=11) :: tirang
       
!
      alim=nGridv(1)*nGridv(2)*nGridv(3)  
      if (ifPositioned == 0.and.(nsym>1.or.icent==1) ) then
        aver=0.0
        aversh=0.0
        do j=1,nreflSelTra
          term=solv_corr(1,j)*focomp(j)
          aver=aver+term*term
          aversh=aversh+Fsh(1,1,j)*Fsh(1,1,j)
        enddo
        aver=aver/float(nreflSelTra)
        aversh=aversh/float(nreflSelTra)
c
c--salvo le variabili
c
        natsOld=nats
***     nzsav(1:nats)=nz(1:nats)
***     xyz30=xyzs
!
!-- create the TF Map
!
        hklmax(1:3)=-99999.0
        fcvetc=0.0
        fcvets=0.0
        ihmaxlim=0.5*(ifat2C-1)
        nsymicent=nsym*(icent+1)
c       do k2=1,nsym-1
c         do k1=k2+1,nsym 
        do k2=1,nsymicent-1
          do k1=k2+1,nsymicent 
            do j=1,nreflSelTra
              do ii=1,3
                vet2(ii)= khlv(1,1,j)*( kmat(k1,1,ii)-kmat(k2,1,ii) )+
     &                    khlv(2,1,j)*( kmat(k1,2,ii)-kmat(k2,2,ii) )+
     &                    khlv(3,1,j)*( kmat(k1,3,ii)-kmat(k2,3,ii) )
              enddo
              call controllo_indici_interi(vet2,iHcan)
c
c--seleziono i riflessi H
c
!             if(iHcan(1)>ihmaxlim.or.
!    &           abs(iHcan(2))>ihmaxlim.or.
!    &           abs(iHcan(3))>ihmaxlim) then
!                write(6,*) 'limite raggiunto',iHcan,ihmaxlim
!                cycle
!             endif
              indr = iHcan(1)*ifat1C + iHcan(2)*ifat2C + iHcan(3)
              if (indr>0.and.indr <= ifatxC) then
                jj = superind(indr)
                if (jj > 0) then
c
c--calcolo i coefficienti
c
                  if(abs(iHcan(1))>hklmax(1)) hklmax(1)=abs(iHcan(1))
                  if(abs(iHcan(2))>hklmax(2)) hklmax(2)=abs(iHcan(2))
                  if(abs(iHcan(3))>hklmax(3)) hklmax(3)=abs(iHcan(3))
                  arg=Fsh(k1,2,j)-Fsh(k2,2,j)
                  term1=solv_corr(1,j)*focomp(j)
                  term=(term1*term1-aver)*Fsh(k1,1,j)*Fsh(k2,1,j)
                  term=term/(aver*aversh)
                  fcvetc(jj)=fcvetc(jj)+term*cos(arg)
                  fcvets(jj)=fcvets(jj)+term*sin(arg)
c                 write(6,'(a,3e20.3)') 'term ',
c    &                                  term1*term1,aver,work1(j)
c                 write(6,'(a,2e20.3)') 'term1 '
c    &                                    ,Fsh(k1,1,j)*Fsh(k2,1,j),term
c                  write(80,'(3i4,3e20.3)')khlv(1:3,1,j),term,
c     &            Fsh(k1,1,j),(term1*term1-aver)*Fsh(k1,1,j)*Fsh(k2,1,j)
                endif
              endif
            enddo
          enddo
        enddo
c
c       do jj=1,nRifDimC
c         if(fcvetc(jj)==0.0) cycle
c         act=fcvetc(jj)
c         bct=fcvets(jj)
c         args = act * act + bct * bct
c         if (args > 0.000001) then
c            amodu  = sqrt(args)
c            faze = atan2( bct, act ) 
c            fcvetc(jj)=amodu*cos(faze)
c            fcvets(jj)=amodu*sin(faze)
c            write(6,'(a,4i8,2e15.3,i6)') 'FIN ',jj,khlc(1:3,jj),amodu,
c    &                    faze
c         else
c            fcvetc(jj)=0.0
c            fcvets(jj) =0.0
c         endif
c       enddo
c
        if(nsol==1) then
          ihmxSav(:)=ihmx(:)
          call AllocaMappa(2)
c         write(6,*) 'prima',ihmx,np
          ihmx(1:3)=hklmax(1:3)
          call CheckGrid()
          do i=1,3  
           if(ihmx(i)==0) np(i)=3   
          enddo
          call AllocaMappa(1)
        endif
c
        call MakeMapMR(xmap, xmapC, FORTH, BACK, np, FFTW_ESTIMATE)

c        call CCP4MAPOUT(xmap,np,'mappaDr.map')

c        do ix=0,np(1)-1
c           do iy=0,np(2)-1
c              do iz=0,np(3)-1
c                 write(81,*)ix,iy,iz,xmap(ix,iy,iz)
c              enddo
c           enddo
c        enddo

c
c--ricerca i picchi sulla mappa bidimensionale (non lo posso fare sulla mappa
c   per colonne)
c
        if(nGridv(1)==1) then
          xmap(1:np(1)-1,0:np(2)-1,0:np(3)-1)=0.0
        elseif(nGridv(2)==1) then
          xmap(0:np(1)-1,1:np(2)-1,0:np(3)-1)=0.0
        elseif(nGridv(3)==1) then
          xmap(0:np(1)-1,0:np(2)-1,1:np(3)-1)=0.0
        endif
c
c--faccio il taglio della TF
c
c
c       invflag = 10
c       call maxmin3d(denmin,denmax,avden,stden,npunt,1)
c       sog=avden+1.5*stden
c       sog=avden*0.5  ! occhio
c       call changesection3d(sog,nmod,denmin,denmax)
c       denom=np(1)*np(2)*np(3)
c       write(6,'(a,4f15.2,f8.3,a)') 'change TF ',
c     & denmax,avden,stden,sog,100*((denom-float(nmod))/denom),'%'
c
c--deb
c       iz=nint(0.098*np(3))
c       do ix=0,np(1)-1
c       do iy=0,np(2)-1
c       do iz=0,np(3)-1
c       do iz=iz1-1,iz1+1
c          write(97+nsol,'(3i5,g18.2)') ix,iy,iz,xmap(ix,iy,iz)
c          write(98,*) ix,iy,0,xmap(ix,iy,0)
c          write(97+nsol,*) ix,0,iz,xmap(ix,0,iz)
c       enddo
c       enddo
c       enddo
c--deb
c
c--cambio gruppo spaziale
c
        icent=0
        tmat(:,:)=0.
        kmat(2:,:,:)=0.
        nsym=1
        call musym()
        nsymTot=nsym*(icent+1)*pts
        latt=1 ! evita di considerare la centratura
c
c--cerco i picchi  (attenzione, li cerca nel gruppo spaziale della proteina!)
c
        if(nsol==1) call InitFour(0,ier)  ! prova
        nats=0
****    xyzs(:,:)=0.0
        krecy=0
        ihalf=0  ! per fare il peak search su tutta la cella 
        term=alim/10.0
        aperc(1)=max(50.0,term)
c        aperc(1)= 1000
        if (allocated(xyzs)) then
            deallocate(xyzs, stat = ier1)
        endif
        if (allocated(nz)) then
            deallocate(nz, stat = ier1)
        endif
        MaxAtoms = aperc(1) * 2
        allocate(xyzs(1:5,1:MaxAtoms), stat = ier1)
        allocate(nz(1:MaxAtoms),       stat = ier2)
        call pksrch_New(-1,1,nrefl,ier)
c       call Search99(-1,ier,nrefl) ! occhio
c       write(6,*) 'Rotazione #', nsol
c       write(6,*) 'Picchi trovati', nats,'  su', MaxAtoms
c       do i = 1 , 50  !nats
c          write(6,*) i, xyzs(1:4,i)
c       enddo
c--ristabilisco il gruppo spaziale originario
c
canna        
        noWrite=.false.
        call RestoreLists123(2)
c       call AllocaMappa(2)
c       np(:) = npSav(:)
c       call AllocaMappa(1)
canna
c
        nRis = 0
        do i = 1 , nats
c          write(80,*) xyzs(1:3,i),xyzs(4,i)
          delta(1)=side(xyzs(1,i))
          delta(2)=side(xyzs(2,i))
          delta(3)=side(xyzs(3,i))
          if(inCheshire_remo(delta)==1) then
c
c--scarto soluzioni nel caso di gruppo di Cheshire con I e con
c  cella di cheshire che non esclude posizioni collegate da I
c  (avviene solo nel cubico)
c
            if(jsys==6.and.i>1) then
              diff=abs(delta(1)-side(xyzs(1,i-1)))
              if(abs(diff-0.5)<0.01) then
                diff=abs(delta(2)-side(xyzs(2,i-1)))
                if(abs(diff-0.5)<0.01) then
                  diff=abs(delta(3)-side(xyzs(3,i-1)))
                  if(abs(diff-0.5)<0.01) then
                    cycle
                  endif
                endif
              endif
            endif
c
            nRis = nRis + 1
            iact = 2
            call sftrNew(iact, delta, corre,1)    ! CALCOLO TraFom
            TraSol(nRis)%TraVal(1:3) = delta(1:3)
            TraSol(nRis)%TraFom = corre   ! attiva se uso nuovo calcolo !TFom=RatioT
!!!!!       TraSol(nRis)%TraFom = corre / sqrt(Rota_Fom) !!!  TFom riscalata su sqrt(RFom)

            TraSol(nRis)%TFom(1:5) = prt_fom(1:5)

c            use_sigmaA=.false.
c            use_E = .false.
c            call sftrNew(2, delta, corre1,1)
c            use_E = .true.
c            use_sigmaA=.true.
c            erre = cR_vet_mol()  
c            call cc_vet_mol(corre1)
c            TraSol(nRis)%TraCorr = corre1
c            TraSol(nRis)%TraFom =  corre1 * corre
c             write(6,'(a,i6,3f8.3,g15.2,4f8.3)') 'picco sel '
c     *           ,nRis,xyzs(1:3,i),xyzs(4,i),corre
          endif
        enddo
!
        deallocate(xyzs, nz, stat = ier3)
!
        if(nRis==0) then
         write(lo,*) 'nessun picco trovato'
         return
        endif
c
c--rimetto a posto i valori
c
        nats=natsOld
***     nz(1:nats)=nzsav(1:nats)
***     xyzs=xyz30
c
c--ordino le soluzioni 
c
        
        rmax=maxval(TraSol(1:nRis)%TraFom)
        rmin=minval(TraSol(1:nRis)%TraFom)
        if (rmax > rmin) then
            do i=1,nRis
               work4(i)  = TraSol(i)%TraFom
               iwork4(i) = i
            enddo
            iuno = -1
            call sortall3(iuno,work4,iuno,nRis,iwork4)
c     TFom_thr = rhoSog2*(rmin-rmax)+rmax
c     if (knw > 0) then
c         write(lo,*) 'TFom_max =',rmax,'  TFom_min =',rmin
c         write(lo,*) 'TFom_thr =',TFom_thr,'  Threshold =',rhoSog2
c     endif
c     TFom_thr = work4(1) - work4(2)    ! SKIP: traslazioni troppo simili
c     rrr = 0.02*rmax
c     write(lo,*) 'TFom_thr =',TFom_thr,'  Threshold =',rrr

            nTraSol = 0
c           delta_TFom = work4(1) - work4(2)    ! SKIP: traslazioni troppo simili
            delta_TFom = 999    ! noSKIP

            rhoSog2 = 0.05
                 

            if (delta_TFom > 0.02*rmax) then

               do ii=1,nRis
                  i = iwork4(ii)
!!!!!             rho=(TraSol(i)%TraFom-rmax)/(rmin-rmax)
                  rho=(rmax-TraSol(i)%TraFom)/rmax
               !se c'è pseudo prendo almeno 2 tra x rot
                  if (rho <= rhoSog2 .or. 
c               if (rho <= 0.0001 .or. 
     *                 (ifpseud==1 .and. ii==2 .and. nMolMRTot>1)) then 
                      nTraSol = nTraSol + 1
                      TraSol(nTraSol)%ipunt = i
                      if(ifpseud==1 .and. ii==1 .and. nMolMRTot>1)then
                         TraSol(nTraSol)%accepted=4
                      endif
                  else
                      exit
                  endif
                  if (nTraSol > 4) exit   ! per selezionare al max 5 traslazioni per rotazione 
c                 if (nTraSol > 2) exit   ! per selezionare al max 5 traslazioni per rotazione
               enddo

            endif
        else
c           write(6,*) 'Attenzione',rmax,rmin,nRis
            nTraSol=nRis
            do ii=1,nRis
               TraSol(ii)%ipunt = ii
            enddo
        endif
      else
          delta(1:3) = TranslAppl(1:3)
          call sftrNew(2, delta, corre, 1)    ! CALCOLO TraFom
          nTraSol = 1
          TraSol(1)%ipunt = 1
          TraSol(1)%TraFom = corre   ! attiva se uso nuovo calcolo TFom=RatioT
!!!!!     TraSol(1)%TraFom = corre / sqrt(Rota_Fom) !!!  TFom riscalata su sqrt(RFom)
          TraSol(1)%TraVal(1:3) = delta(1:3)

          TraSol(1)%TFom(1:5) = prt_fom(1:5)

      endif
      

!!!!!!!!!!  PROVA !!!!!!!!!!!!!!!
C        nTraSol = 1  ! prende solo la traslazione con TraFom più alta
!
      if (nTraSol == 0 ) then
          if (knw > 0) write(lo,51)
c         write(lo,52)
          return
      endif

      MPE = 0 
      MPE_sog = 78 
      do i=1, nTraSol
         WhichTraSol = TraSol(i)%ipunt
!
!-- compute M.P.E ( if known structure )
!
         delta(1:3) = TraSol(WhichTraSol)%TraVal(1:3)
         use_E=.false.
         use_sigmaA = .false.
         call sftrNew(2, delta, corre,1)
         use_sigmaA = .true. 
         use_E=.true.
!gianlucaif (knw == 1 .and. kverbo > 0) then
         if (knw == 1) then
c           delta(1:3) = TraSol(WhichTraSol)%TraVal(1:3)
c           call sftrNew(2, delta, corre,1)
            tmpwt(:) = 0.0
            do io=1, nreflSelTra
               j = k_mem1(io)
               tmpwt(j) = 1.0
            enddo
            nbru  = i  !0
            izero = 0
            ifmin = 0
            call examin(nbru,mkang,khl,ipub,iphaz,nrefl,
     *                  izero,tmpwt,ifmin)
c
c            tirang = 'TRANSL. Wt.'
c            izero = 0
c            ipher = 1
c            call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
c    *                ipub,iphaz,tmpwt,10,0.0,ipher)

         else
            erore = 0.0
         endif
         TraSol(WhichTraSol)%MolMPE=erore
         TraSol(WhichTraSol)%TraCorr=corre
 
c
c--aggiorno le variabili globali per la grafica
c
         if (TraSol(WhichTraSol)%TraFom > globval(1)) then
             globval(1) = TraSol(WhichTraSol)%TraFom
             globval(2) = nsol
         endif
c
c--scrivo i risultati
c
         if(knw>0) then
          MPE = TraSol(WhichTraSol)%MolMPE
!          if (MPE < MPE_sog) then 
              write(lo,60) i,
     &          TraSol(WhichTraSol)%TraVal(1:3),
     &          TraSol(WhichTraSol)%TraFom,
*    &          TraSol(WhichTraSol)%TFom(1),
     &          TraSol(WhichTraSol)%MolMPE
c    &          TraSol(WhichTraSol)%TFom(1:5),    ! dettagli TFom
c    &          ,globval(1),nint(globval(2))
!          else
!             write(lo,53)
!          
c          write(123,60) i,
c    &          TraSol(WhichTraSol)%TraVal(1:3),
c    &          TraSol(WhichTraSol)%TraFom,
c    &          TraSol(WhichTraSol)%MolMPE
!          if (knw == 1) then
!              write(124,600) i,
!    &              TraSol(WhichTraSol)%TFom(1:5),
!    &              TraSol(WhichTraSol)%TraFom,
!    &              TraSol(WhichTraSol)%MolMPE
!          endif
         elseif (kverbo > 0) then
           write(lo,61) i,
     &          TraSol(WhichTraSol)%TraVal(1:3),
     &          TraSol(WhichTraSol)%TraFom
c    &          ,globval(1),nint(globval(2))
         endif
c
c--scelgo le migliori traslazioni per ciascuna rotazione
c
         TraNum=TraNum+1
         TraAll(TraNum)%TraVal(1:3)=TraSol(WhichTraSol)%TraVal(1:3)

         TraAll(TraNum)%TraFom = TraSol(WhichTraSol)%TraFom
c        TraAll(TraNum)%TraFom = TraSol(WhichTraSol)%TraFom /
c    &                                 (TraSol(WhichTraSol)%TFom(4)**2.)
         TraAll(TraNum)%TFom(1:5) = TraSol(WhichTraSol)%TFom(1:5)

         TraAll(TraNum)%TraCorr = TraSol(WhichTraSol)%TraCorr

         TraAll(TraNum)%MolMPE = TraSol(WhichTraSol)%MolMPE
         TraAll(TraNum)%RotVal(1:3) = solcan(WhichSolution)%RotVal(1:3)
         TraAll(TraNum)%RotFom = solcan(WhichSolution)%RotFom
         TraAll(TraNum)%trial = solcan(WhichSolution)%trial
         TraAll(TraNum)%accepted = TraSol(i)%accepted
         TraAll(TraNum)%ipunt = TraNum 
                                   !solcan(WhichSolution)%accepted
c
c        if(TraNum>alim-1.and.(nsym>1.or.icent>0)) then
c          write(lo,*) 'Warning: vector TraAll full'
c          ier=1
c          return  ! per non sfondare il vettore TraAll
c        endif
c
      enddo
c
c--scelgo la traslazione migliore (la prima in ordine di TraFom) per ogni rotazione
c
      WhichTraSol = TraSol(1)%ipunt
      solcan(WhichSolution)%TraVal(1:3)=TraSol(WhichTraSol)%TraVal(1:3)
      solcan(WhichSolution)%TraFom = TraSol(WhichTraSol)%TraFom
      solcan(WhichSolution)%MolMPE = TraSol(WhichTraSol)%MolMPE
!?!   solcan(WhichSolution)%TFom(1:5) = TraSol(WhichTraSol)%TFom(1:5)
!
      numbrun = nsol
      if (ifPositioned == 0) then
        if (corre.ge.fomBestE) fomBestE = corre
      endif
c
      call toflush()
c
      return

   50 format(10x,'Map Analysis indicates to skip this combination')
   51 format(23x,'TFom indicates to skip this combination')
   52 format(23x,'No good translation found')
   53 format(23x,'MPE too high')
   60 format(20x,i5,')',3f7.3,f8.3,f7.2)
*  60 format(20x,i5,')',3f7.3,2f8.3,f7.2)
c  60 format(25x,i5,')',f8.3,8f7.3,f7.2,f8.3,i5)
   61 format(20x,i5,')',3f7.3,f8.3)
  600 format(30x,i5,')',f7.3,3f10.3,2f7.3,f7.2)
      end
!-----------------------------------------------------------------------
      subroutine sftryyyRemo(numb,scalan,iCoeff)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Molcom
      USE PhaseModule
      USE RemoModule
!
!-- structure factor calculation
!
      integer i1(3)
      real x1(3)
!
      oscale=1.0
      scale=1.0/oscale
      sumfo=0.0
      sumfor=0.0
      sumfc=0.0
      sumdf=0.0
      sumdf2=0.0
      bison=0.0
      bisod=0.0

c      write(6,*)pts,nsym,twopi
c      do ii=1, numbModels
c            do j=1, MonomerInModel(ii)
c               if (model(ii)%considerato(j) == 0) cycle
c               do jj=1,natsInModel(ii)
c                  kz=model(ii)%specie(jj,j) / nzConst
c                  write(6,*)jj, kz , model(ii)%atoms(1:5,jj,j), 
c     *                     model(ii)%th_fact(jj,j)
c               enddo
c            enddo
c     enddo
      


      do i=1,numb
         i1(1)=khl(1,i)
         i1(2)=khl(2,i)
         i1(3)=khl(3,i)
c
c-- compute H*R and H*T
c
         do j=1,nsym
            tt=1000.0
            do l=1,3
               tt=tt+float(i1(l))*tmat(j,l)
               hkle(l,j)=0
c
               do k=1,3
                  hkle(l,j)=hkle(l,j)+i1(k)*kmat(j,k,l)
               enddo
c
            enddo
            hkle(4,j)=tt
         enddo
         fo=fovet(i)
         rho=rhov(i)
         act=0.0
         bct=0.0
c         do ij=1,nk
c            ff(ij) = ScattFact(ij, rho )
c         enddo
c         write(6,*)i1(:),fo,rho,ff(1:nk)

!
         do ii=1, numbModels
            do ij=1,model(ii)%nk
                   ff(ij) = ScattFact_MR(ij, rho,ii)
                enddo
            do j=1, MonomerInModel(ii)
               if (model(ii)%considerato(j) == 0) cycle
               do jj=1,natsInModel(ii)
                  kz=model(ii)%specie(jj,j) / nzConst
                  if (kz /= 0) then
                      x1(1:3) = model(ii)%atoms(1:3,jj,j)
                      fkz=ff(kz)
                      arg=-model(ii)%th_fact(jj,j)*rho
                      effe=pts*fkz*exp(arg)
                      tfocc=effe*model(ii)%atoms(5,jj,j)
                      tfocp=tfocc*twopi*float(icent+1)
                      call sfacyyyRemo(x1, contc, conts)
                      contc=contc*tfocc
                      conts=conts*tfocc
                      act=act+contc
                      bct=bct+conts
                  endif
               enddo
            enddo
         enddo
!
         args=act*act+bct*bct
         if (args.gt.0.000001) then
             fc=sqrt(args)
             faze=rtod*atan2(bct,act)+360.0
             ac=act/fc
             bc=bct/fc
         else
             fc=0.0
             faze=0.0
             ac=0.0
             bc=0.0
         endif
         work1(i)=fc
         fcvet(i) = fc

         foTest=fo
         sumfor=sumfor+fo
         fo=fo*scale
         df=fo-fc
         sumfo=sumfo+fo
         sumfc=sumfc+fc
         absdf=abs(df)
         sumdf=sumdf+absdf
         sumdf2=sumdf2+absdf*absdf
!
!-- compute stuff for fourier
!
         iphap=mod(int(faze+0.5),360)
         if (iphap.eq.0) iphap=360
         iphaz(i)=iphap
      enddo
!
!--  compute r-factor
!
      scalan=sumfc/sumfor
!
      oscale=1.0/scalan
      sumdf=0.0
      sumdf2=0.0
      sumfo=0.0
      do i=1,numb
         absdf=abs(work1(i)-scalan*fovet(i))
         sumdf=sumdf+absdf
         sumdf2=sumdf2+absdf*absdf
         sumfo=sumfo+scalan*fovet(i)
      enddo
      erre=sumdf/sumfo
      rfac=100.0*erre
!
!
!-- compute fourier coefficients and weights
!--         iCoeff = 1  Observed
!--                = 2  2*Fo - Fc
!--                = 3  Difference
!

      if (iCoeff.gt.0) then
          if (iCoeff.eq.1) then
              c1 = 1.0
              c2 = 0.0
          elseif (iCoeff.eq.2) then
              c1 = 2.0
              c2 = 1.0
          elseif (iCoeff.eq.3) then
              c1 = 1.0
              c2 = 1.0
          endif
          do i=1,numb
             fo       = fovet(i) * scalan
             fc       = work1(i)
             fcoef(i) = c1 * fo  - c2 * fc
          enddo
      elseif (iCoeff.eq.-1) then
          do i=1,numb
             fcoef(i) = evet(i)
          enddo
      endif

      do i=1,numb
         rho = rhov(i)
         eps = epsv(i)
         sumfff = 0.0
!attenzione deve essere adattata alla nuova gestione di nk e ff
         do ii=1, numbModels
            do ij=1,model(ii)%nk
               ff(ij) = ScattFact_MR(ij, rho,ii)
               sumfff=sumfff+model(ii)%nw(ij)*(ff(ij)**2)
            enddo
         enddo
!
!--     Sim = D1 ( gSim )
!--    gSim =  2 * E(obs) * E(Calc)
!-- E(Calc) =  F(calc) / den
!--     den =  eps * pts * coef * sig
!--     sig =  sqrt( sigma ** 2 ) )
!
         coef = 1.0
         sig = sqrt( exp(-2.0*bt*rho) * sumfff )
         den = coef * eps       * sig
         gSimValue = (0.5* evet(i) * work1(i)) / ( 0.33 * den*pts)
         work1(i) = work1(i) / (den*pts)  ! ecal
         work2(i) = gSimValue
         wt(i)=bes(gSimValue)
      enddo
!
      call DoSingleIteration()
!
      return
      end
!-----------------------------------------------------------------------
      function ScattFact_MR(k, rho, nMod)
!
      USE General
      USE RemoModule

!
      sf = model(nMod)%cl(k)
      do i=1,4
         sf = sf + model(nMod)%al(i,k) * exp(-model(nMod)%bs(i,k)*rho)
      enddo
      ScattFact_MR = sf
      if (ifMottFormula(k) > 0) then
          Zeta = model(nMod)%no(k)
          ScattFact_MR = 0.023934 * (Zeta - ScattFact_MR) / rho
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine sfacyyyRemo(x1, contc, conts)
      USE General
      USE Symmetry
!
      real x1(3)
!
!--   structure factor calculation
!
      att=0.0
      btt=0.0
      do j=1,nsym
         arg=amod(hkle(1,j)*x1(1)
     *           +hkle(2,j)*x1(2)
     *           +hkle(3,j)*x1(3)
     *           +hkle(4,j),1.0)
         iarg=int(360.0*arg+0.5)+1
         if (iarg.eq.361) iarg=1
         if (iarg < 0 .or. iarg > 360) then
             iii = 0
         endif
         att=att+cost(iarg)
         btt=btt+sint(iarg)
      enddo
!
      if (icent.eq.0) then
          contc=att
          conts=btt
      else
          contc=2.0*att
          conts=0.0
      endif
!
      return
      end
!-------------------------------------------------------------
      subroutine sftrNew(iAct, fragShift, corre, nM)
      USE General
      USE Symmetry
      USE Atomi
      USE Riflessi
      USE RuotaRiflessi
      USE riflessi_c
      USE RemoModule
      USE PhaseModule
      
      common /appo_fom/ prt_fom(5), Rota_Fom
!
!-- iAction = 1(3)   Calcola i valori di Fs(h) ( di FshFix )
!-- iAction = 2      Calcola i valori di Fp(h)
!
      dimension fragShift(3)
      integer s, nM
      real, allocatable :: fc_sav(:), fo_sav(:) 
      
!
      iAction = abs(iAct)
c
      nsymcent=nsym*(icent+1)
      if (iAction == 1.or.iAction == 3) then

      Fsh(:,:,:) = 0.0
c      FshFix(:,:,:) = 0.0
c
      do i=1,nreflSelTra
         rho   = rhovcomp(i)
         do ii=1, numbModels
            do j=1, MonomerInModel(ii)
               if (model(ii)%considerato(j) == 0) cycle
               do ij = 1, model(ii)%nk
                  ff_m(ij,ii) = ScattFact_MR(ij, rho,ii)
               enddo
            enddo
         enddo

         do s = 1, nsymcent
            tt = 1000.0
            do l = 1, 3
               tt = tt + float( khlv(l,1,i) ) * tmat(s,l)
               hkle(l,s) = 0
               do k = 1, 3
                  hkle(l,s) = hkle(l,s) + khlv(k,1,i) * kmat(s,k,l)
               enddo
               khlv_eq(l,s,1,i)=hkle(l,s)
             enddo
             hkle(4,s) = tt
             call sfacNewNew(s, rho, att, btt)
             if(iAction == 1) then
               Fsh(s,1,i) = sqrt( att * att + btt * btt )
               Fsh(s,2,i) = atan2( btt, att )
             else
               FshFix(s,1,i) = sqrt( att * att + btt * btt )
               FshFix(s,2,i) = atan2( btt, att )
             endif
           enddo
        enddo 
 
      elseif (iAction == 2 .or. iAction == 4) then

        allocate(fc_sav(1:nreflSelTra), stat = ier1)
        allocate(fo_sav(1:nreflSelTra), stat = ier2)

        do i=1,nreflSelTra
             j = k_mem1(i)
             act  = 0.0
             bct  = 0.0
             do s = 1, nsymcent
                arg = twopi * ( khlv_eq(1,s,1,i) * fragShift(1)
     *                      +   khlv_eq(2,s,1,i) * fragShift(2)
     *                      +   khlv_eq(3,s,1,i) * fragShift(3) )
                arg  = arg + Fsh(s,2,i)
                act  = act + Fsh(s,1,i) * cos(arg)
                bct  = bct + Fsh(s,1,i) * sin(arg)
                if (jMolMR > 0 .and. iAction == 2) then
                   act  = act + FshFix(s,1,i) * cos(FshFix(s,2,i))
                   bct  = bct + FshFix(s,1,i) * sin(FshFix(s,2,i))
                endif
             enddo
             args = act * act + bct * bct

             if (args > 0.000001) then
                if (iAct > 0) then
                    fccomp(i)  = sqrt(args)
                else
                    fccomp(i)  = args
                endif
                faze = rtod * atan2( bct, act ) + 3600.0
                iphaz(j) = mod( nint( faze  ), 360 )
                wt(j) = 1.0
             else
                 fccomp(i)=0.0
                 iphaz(j) = 0
                 wt(j) = 0.0
            endif

        enddo
canna
        if(iAct > 0 .and. use_sigmaA)then
           fc_sav(1:nreflSelTra) = fcvet(1:nreflSelTra)
           fo_sav(1:nreflSelTra) = fovet(1:nreflSelTra)
           fcvet(1:nreflSelTra)=fccomp(1:nreflSelTra)
           fovet(1:nreflSelTra)=focomp(1:nreflSelTra)
           jflag  = 1
           nreflSelRemo = nreflSelTra
           wt(:) = 1.0
           knwSav = knw       ! gianluca 6/12/12
           knw = 0
           call PresigmaA(jflag, 0)
           knw = knwSav
           fcvet(1:nreflSelTra) = fc_sav(1:nreflSelTra) 
           fovet(1:nreflSelTra) = fo_sav(1:nreflSelTra) 
        endif
canna
        if(use_E) then
           prt_fom(:) = 0.0
           ifl = 2
           call FomFirstModel(ifl,nreflSelTra,corre)
        else
           call cc_vet_mol(corre)
        endif
      
        deallocate(fc_sav, fo_sav, stat = ier3)
      endif

      return
      end
!-------------------------------------------------------------
      subroutine sfacNewNew(k, rho, att, btt)
      USE General
      USE Symmetry
      USE Atomi
      USE RemoModule
!
!--   structure factor calculation
!
      att=0.0
      btt=0.0
      do ii=1, numbModels
         do j=1, MonomerInModel(ii)
            if (model(ii)%considerato(j) == 0) cycle
            ifinMR = natsInModel(ii)
            do jj=1, ifinMR
               kz=model(ii)%specie(jj,j) / nzConst
               fkz=ff_m(kz,ii)
               arg=-model(ii)%th_fact(jj,j)*rho
               effe=pts*fkz*exp(arg)
               tfocc=effe*model(ii)%atoms(5,jj,j)
               arg=amod(hkle(1,k)*model(ii)%atoms(1,jj,j)
     *                 +hkle(2,k)*model(ii)%atoms(2,jj,j)
     *                 +hkle(3,k)*model(ii)%atoms(3,jj,j)
     *                 +hkle(4,k),1.0)
               iarg=int(360.0*arg+0.5)+1
               if (iarg.eq.361) iarg=1
               att = att + cost(iarg) * tfocc
               btt = btt + sint(iarg) * tfocc
            enddo
         enddo
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine cc_vet0_all(iexc,npunti)
      USE General
      USE Symmetry
      USE Riflessi
      USE cc_vet_comm
c
      vmedc=0.0
      vmed2c=0.0
      wsum = 0.0
      wsum1 = 0.0

      if (iexc == 0) then
         do ix=1,npunti
            w=nsym/epsv(ix)
            wsum = wsum + w
            wsum1 = wsum1 + w*w
            xx1 = fovet(ix)
            vmedc=vmedc + w * xx1
            vmed2c=vmed2c + w * xx1 * w * xx1
         enddo
      else
         do ix=1,npunti
            eo = evet(ix)
            if(eo > 1.35 .or. eo < 0.7) then
               w=nsym/epsv(ix)
               wsum = wsum + w
               wsum1 = wsum1 + w*w
               xx1 = fovet(ix)
               vmedc=vmedc + w * xx1
               vmed2c=vmed2c + w * xx1 * w * xx1
            endif
         enddo
      endif

      vmedc  = vmedc  / wsum
      vmed2c = vmed2c / wsum1
!
      return
      end
!-----------------------------------------------------------------------
      subroutine cc_vet_all(iexc,npunti,costo)
      USE General
      USE Symmetry
      USE Riflessi
      USE cc_vet_comm

C --  Correlazione tra due vettori 
c
      vmedfc = 0.0
      vmed2fc = 0.0
      vmedfcfo = 0.0

      if (iexc == 0) then
         do ix=1,npunti
            w=nsym/epsv(ix)
            xx1 = fcvet(ix)
            xx2 = fovet(ix)
            vmedfc =vmedfc + w * xx1
            vmedfcfo=vmedfcfo + w * xx1 * w * xx2
            vmed2fc =vmed2fc +  w * xx1 * w * xx1
         enddo
      else
         do ix=1,npunti
            eo = evet(ix)
            if(eo > 1.35 .or. eo < 0.7) then
               w=nsym/epsv(ix)
               xx1 = fcvet(ix)
               xx2 = fovet(ix)
               vmedfc =vmedfc + w * xx1
               vmedfcfo=vmedfcfo + w * xx1 * w * xx2
               vmed2fc =vmed2fc +  w * xx1 * w * xx1
            endif
         enddo
      endif

      vmedfc=vmedfc / wsum
      vmed2fc=vmed2fc / wsum1
      vmedfcfo=vmedfcfo/ wsum1

      rnum=vmedfcfo - (vmedfc*vmedc)
      rden=sqrt(vmed2fc-vmedfc**2) * sqrt(vmed2c-vmedc**2)
      costo=rnum/rden
!
      return
      end
!----------------------------------------------------------------------
      subroutine cc_vet_mol0()
      USE General
      USE RuotaRiflessi
      USE Symmetry
      USE Riflessi
      USE riflessi_c
      USE cc_vet_comm

C --  Correlazione tra due vettori x, y

      vmedc=0.0
      vmed2c=0.0
!      vmedce = 0.0
!      vmed2ce = 0.0
      wsum=0.0
      wsum1=0.0
      do ix=1,nreflSelTra
         j=k_mem1(ix)
         w=nsym/epsv(j)
         wsum = wsum + w
         wsum1 = wsum1 + w*w
         xx1 = fovet(j)
!         xx2 = evet(j)
         vmedc=vmedc + w * xx1
         vmed2c=vmed2c + w * xx1 * w * xx1
!         vmedce=vmedce + w * xx2
!         vmed2ce=vmed2ce + w * xx2 * w * xx2
      enddo
      vmedc  = vmedc  / wsum
      vmed2c = vmed2c / wsum1
!      vmedce  = vmedce  / wsum
!      vmed2ce = vmed2ce / wsum1
      return
      end
!------------------------------------------------------------
      subroutine cc_vet_mol(costo)
!
!--calcolo il fattore di accordo -- corre
!
      USE General
      USE Symmetry
      USE Riflessi
      USE riflessi_c
      USE RuotaRiflessi
      USE cc_vet_comm
c
      vmedfc = 0.0
      vmed2fc = 0.0
      vmedfcfo = 0.0
      do ix=1,nreflSelTra
         w=nsym/epsvcomp(ix)
         xx1 = fccomp(ix) 
         xx2 = focomp(ix)
         vmedfc =vmedfc + w * xx1
         vmedfcfo=vmedfcfo + w * xx1 * w * xx2
         vmed2fc =vmed2fc +  w * xx1 * w * xx1
      enddo
      vmedfc=vmedfc / wsum
      vmed2fc=vmed2fc / wsum1
      vmedfcfo=vmedfcfo/ wsum1 
      rnum=vmedfcfo - (vmedfc*vmedc)
      rden=sqrt(vmed2fc-vmedfc**2) * sqrt(vmed2c-vmedc**2)
      costo=rnum/rden
!
      return
      end
!----------------------------------------------------------------------
      function cR_vet_mol()
!
!--calcolo il fattore di accordo -- corre
!
      USE General
      USE Symmetry
      USE Riflessi
      USE riflessi_c
      USE RuotaRiflessi

      sumfc=0.0
      sumfo=0.0
      do i=1,nreflSelTra
         sumfc=sumfc+fccomp(i)
         sumfo=sumfo+focomp(i)
      enddo
      scalan=sumfc/sumfo
      sumdf=0.0
      sumfo=0.0
      do i=1,nreflSelTra
         absdf=abs(fccomp(i)-scalan*focomp(i))
         sumdf=sumdf+absdf
         sumfo=sumfo+scalan*focomp(i)
c         fcvet(i)=fcvet(i)/scalan
      enddo
      cR_vet_mol = sumdf/sumfo

      return
      end
!----------------------------------------------------------------------
      subroutine InitFomModel(ifl,npunti)
      USE General
      USE RuotaRiflessi
      USE Symmetry
      USE Riflessi
      USE riflessi_c
      USE cc_vet_comm
!
      implicit none
      integer :: ifl, npunti, ix, j
      real    :: w, xx2
!
C --  Calcolo parte costante x correlazione tra due vettori x, y
! ifl =  1  --> evet
! ifl = -1  --> evet  tagli rifl. con Fo/sigFo basso
! ifl =  2  --> fovet

      vmedc=0.0
      vmed2c=0.0
      wsum=0.0
      wsum1=0.0
      do ix=1,npunti
         j=k_mem1(ix)
         if (ifl == 1) then
            w = 1.0
            xx2 = ModuliSel(2,ix)**2  !evet(j)**2
         elseif (ifl == -1) then    ! taglio rifl. con Fo/sigFo basso
            w = 1.0
            xx2 = work2(ix)**2  !evet(j)**2
         elseif (ifl == 2) then
            w=nsym/epsv(j)
            xx2 = fovet(j)
         endif
         wsum = wsum + w
         wsum1 = wsum1 + w*w
         vmedc=vmedc + w * xx2
         vmed2c=vmed2c + w * xx2 * w * xx2
      enddo
      vmedc  = vmedc  / wsum
      vmed2c = vmed2c / wsum1
!
      return
      end
!------------------------------------------------------------
      subroutine FomFirstModel(ifl,npunti,costo)
*     subroutine FomFirstModel_CC(ifl,npunti,costo)
      USE General
      USE Symmetry
      USE Riflessi
      USE riflessi_c
      USE RuotaRiflessi
      USE cc_vet_comm
!
      implicit none
      integer :: ifl, npunti, isHM, i, nwizm1, nden, nsip1, ix
      real    :: costo, w, xx1, xx2, vmedfc, vmed2fc, vmedfcfo
      real    :: rnum, rden
!--calcolo il fattore di accordo -- corre
! ifl = 1  --> ecal
! ifl = 2  --> fcal

!
      work1_cc(:) = 0.0
      work2_cc(:) = 0.0
      isHM = 1  !0
      if (ifl == 1 .and. isHM == 1) then
            do i = 1,npunti
                work1_cc(i) = ModuliSel(1,i)**2 ! Ecalc ; Emod in uscita
                work2_cc(i) = ModuliSel(2,i)**2  ! Eobs
            enddo
            nwizm1=25  ! proteins  -  da provare con routine generalizzata
            nden =  nstr / 10
            nsip1 = nrefl / nden
            nsip1 = min(nsip1,498)
            call HistogramMatch(work1_cc,work2_cc,nreflSelRot,nsip1,
     *                          nwizm1,1)
            ModuliSel(1,1:nreflSelRot) = sqrt(work1_cc(1:nreflSelRot))
      endif

      vmedfc = 0.0
      vmed2fc = 0.0
      vmedfcfo = 0.0
      do ix=1,npunti
         
         if (ifl == 1) then
             w = 1.0
             xx1 = ModuliSel(1,ix)**2
             xx2 = ModuliSel(2,ix)**2
         elseif (ifl == 2) then
             w=nsym/epsvcomp(ix)
             xx1 = fccomp(ix) 
             xx2 = focomp(ix)
         endif

         vmedfc =vmedfc + w * xx1
         vmedfcfo=vmedfcfo + w * xx1 * w * xx2
         vmed2fc =vmed2fc +  w * xx1 * w * xx1
      enddo
      vmedfc=vmedfc / wsum
      vmed2fc=vmed2fc / wsum1
      vmedfcfo=vmedfcfo/ wsum1 
      rnum=vmedfcfo - (vmedfc*vmedc)
      rden=sqrt(vmed2fc-vmedfc**2) * sqrt(vmed2c-vmedc**2)
      costo=rnum/rden

      return
      end
!----------------------------------------------------------------------
      subroutine FomMoreModels(ifl,npunti,costo)
*     subroutine FomMoreModels_CC(ifl,npunti,costo)
      USE General
      USE Symmetry
      USE Riflessi
      USE riflessi_c
      USE Solutions
      USE RuotaRiflessi
      USE cc_vet_comm
!
      implicit none
      integer :: ifl, npunti, isHM, i, nwizm1, nden, nsip1, ix
      real    :: costo, w, xx1, xx2, vmedfc, vmed2fc, vmedfcfo
      real    :: rnum, rden
!
      work1_cc(:) = 0.0
      work2_cc(:) = 0.0

      isHM = 1  !0
      if (ifl == 1 .and. isHM == 1) then
          do i = 1,npunti
!                           Rp1                  Eps
             work1_cc(i) = RpMat(nums,i) ** 2 + ModuliSel(1,i)**2 
             work2_cc(i) = ModuliSel(2,i)**2 ! Eobs
          enddo
          nwizm1=25  ! proteins  -  da provare con routine generalizzata
          nden =  nstr / 10
          nsip1 = nrefl / nden
          nsip1 = min(nsip1,498)
          call HistogramMatch(work1_cc,work2_cc,npunti,nsip1,
     *                        nwizm1,1)
          ModuliSel(1,1:nreflSelRot) = sqrt(work1_cc(1:nreflSelRot))
      endif
      vmedfc = 0.0
      vmed2fc = 0.0
      vmedfcfo = 0.0
      do ix=1,npunti
         if (ifl == 1) then
             w = 1.0
             xx1 = work1_cc(ix)
             xx2 = work2_cc(ix)
         elseif (ifl == 2) then
             w=nsym/epsvcomp(ix)
             xx1 = fccomp(ix)
             xx2 = focomp(ix)
         endif

         vmedfc =vmedfc + w * xx1
         vmedfcfo=vmedfcfo + w * xx1 * w * xx2
         vmed2fc =vmed2fc +  w * xx1 * w * xx1
      enddo
      vmedfc=vmedfc / wsum
      vmed2fc=vmed2fc / wsum1
      vmedfcfo=vmedfcfo/ wsum1
      rnum=vmedfcfo - (vmedfc*vmedc)
      rden=sqrt(vmed2fc-vmedfc**2) * sqrt(vmed2c-vmedc**2)
      costo=rnum/rden
!
      return
      end
!----------------------------------------------------------------------
*     subroutine FomFirstModel(ifl,npunti,costo)
      subroutine FomFirstModel_Rf(ifl,npunti,costo)
      USE General
      USE Symmetry
      USE Riflessi
      USE riflessi_c
      USE RuotaRiflessi
      USE cc_vet_comm
!
      implicit none
      integer :: ifl, npunti, isHM, i, nwizm1, nden, nsip1, ix
      real    :: costo, rrtt, fo, fc
      real    :: sumfo, sumfc, sumdf, absdf, scalan
!
!--calcolo la Fom = 1 - Rcryst
!
! ifl = 1  --> ecal**2
! ifl = 2  --> fcal

!
      work1_cc(:) = 0.0
      work2_cc(:) = 0.0

      isHM = 0 !1  !0
      if (ifl == 1 .and. isHM == 1) then
            do i = 1,npunti
                work1_cc(i) = ModuliSel(1,i)**2  ! Ecalc 
                work2_cc(i) = ModuliSel(2,i)**2  ! Eobs
            enddo
            nwizm1=25  ! proteins  -  da provare con routine generalizzata
            nden =  nstr / 10
            nsip1 = nrefl / nden
            nsip1 = min(nsip1,498)
            call HistogramMatch(work1_cc,work2_cc,npunti,nsip1,
     *                          nwizm1,1)
            ModuliSel(1,1:npunti) = sqrt(work1_cc(1:npunti))
      endif

      do ix=1,npunti
         
         if (ifl == 1) then
             work1_cc(ix) = ModuliSel(1,ix)**2  ! Ecalc 
             work2_cc(ix) = ModuliSel(2,ix)**2  ! Eobs
         elseif (ifl == 2) then
             work1_cc(ix) = fccomp(ix)  ! Fcalc
             work2_cc(ix) = focomp(ix)  ! Fobs
         endif

      enddo
!
      rrtt   = 0.99999
!
      sumfo = 0.0
      sumfc = 0.0
      do i=1,npunti
         sumfo = sumfo + work2_cc(i)
         sumfc = sumfc + work1_cc(i)
      enddo
!
      scalan = sumfc / sumfo
!
      sumfo = 0.0
      sumdf = 0.0
      do i=1,npunti
         fc = work1_cc(i)
         fo = work2_cc(i)
         absdf = abs( fc - scalan * fo )
         sumfo = sumfo + scalan * fo
         sumdf = sumdf + absdf
      enddo
      rrtt =  sumdf / sumfo
!

      costo= 1.0 - rrtt

      return
      end
!----------------------------------------------------------------------
*     subroutine FomMoreModels(ifl,npunti,costo)
      subroutine FomMoreModels_Rf(ifl,npunti,costo)
      USE General
      USE Symmetry
      USE Riflessi
      USE riflessi_c
      USE Solutions
      USE RuotaRiflessi
      USE cc_vet_comm
!
      implicit none
      integer :: ifl, npunti, isHM, i, nwizm1, nden, nsip1, ix
      real    :: costo, rrtt, fo, fc
      real    :: sumfo, sumfc, sumdf, absdf, scalan
!
      work1_cc(:) = 0.0
      work2_cc(:) = 0.0

      isHM = 0 !1  !0
      if (ifl == 1 .and. isHM == 1) then
          do i = 1,npunti
!                           Rp1                  Eps
             work1_cc(i) = RpMat(nums,i) ** 2 + ModuliSel(1,i)**2 
             work2_cc(i) = ModuliSel(2,i)**2 ! Eobs
          enddo
          nwizm1=25  ! proteins  -  da provare con routine generalizzata
          nden =  nstr / 10
          nsip1 = nrefl / nden
          nsip1 = min(nsip1,498)
          call HistogramMatch(work1_cc,work2_cc,npunti,nsip1,
     *                        nwizm1,1)
          ModuliSel(1,1:npunti) = sqrt(work1_cc(1:npunti))
      endif

!
      do ix=1,npunti
         
         if (ifl == 1) then
             work1_cc(ix) = ModuliSel(1,ix)**2  ! Ecalc 
             work2_cc(ix) = ModuliSel(2,ix)**2  ! Eobs
         elseif (ifl == 2) then
             work1_cc(ix) = fccomp(ix)  ! Fcalc
             work2_cc(ix) = focomp(ix)  ! Fobs
         endif

      enddo
!
      rrtt   = 0.99999
!
      sumfo = 0.0
      sumfc = 0.0
      do i=1,npunti
         sumfo = sumfo + work2_cc(i)
         sumfc = sumfc + work1_cc(i)
      enddo
!
      scalan = sumfc / sumfo
!
      sumfo = 0.0
      sumdf = 0.0
      do i=1,npunti
         fc = work1_cc(i)
         fo = work2_cc(i)
         absdf = abs( fc - scalan * fo )
         sumfo = sumfo + scalan * fo
         sumdf = sumdf + absdf
      enddo
      rrtt =  sumdf / sumfo
!

      costo= 1.0 - rrtt

      return
      end
      subroutine calcolasumff
!
      USE General
      USE Symmetry
      USE Riflessi
      USE riflessi_c
      USE RuotaRiflessi
      USE Atomi
      USE RemoModule
      USE PhaseModule
      
      do i=1,nreflSelTra
         k=k_mem1(i)
         rho = rhovcomp(i)
         eps = epsvcomp(i)
         sumff(k) = 0.0
         do ij=1,nkSav
            ff(ij)=clSav(ij)
            do ii=1,4
               ff(ij)=ff(ij)+alSav(ii,ij)*exp(-bsSav(ii,ij)*rho)
            enddo
            sumff(k)=sumff(k)+nwSav(ij)*(ff(ij)**2)
         enddo
         sumffMod(k,WhichModel) = 0.0
         do ij=1,model(WhichModel)%nk
            ff(ij) = ScattFact_MR(ij, rho,WhichModel)
            sumffMod(k,WhichModel)=sumffMod(k,WhichModel)+
     *                             model(WhichModel)%nw(ij)*
     *                             totop*(ff(ij)**2)
         enddo
         !calcola la sigma di N/n (per ogni monomero)
         sumffMod(k,WhichModel)=sumffMod(k,WhichModel)/
     *                          MonomerInModel(WhichModel)
      enddo
      
      return
      end
!----------------------------------------------------------------------
      subroutine sfacNew(j, rho, att, btt)
      USE General
      USE Symmetry
      USE Atomi
      USE RemoModule
!
!--   structure factor calculation
!
      att=0.0
      btt=0.0
      do jj=inizMR, ifinMR
         kz=nz(jj)
         fkz=ff(kz)
         arg=-bfac(jj)*rho
         effe=pts*fkz*exp(arg)
         tfocc=effe*xyzs(5,jj)
         arg=amod(hkle(1,j)*xyzs(1,jj)
     *           +hkle(2,j)*xyzs(2,jj)
     *           +hkle(3,j)*xyzs(3,jj)
     *           +hkle(4,j),1.0)
         iarg=int(360.0*arg+0.5)+1
         if (iarg.eq.361) iarg=1
          att = att + cost(iarg) * tfocc
          btt = btt + sint(iarg) * tfocc
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine sftrNewRotNew(hkl, rho, SumGs2)
      USE General
      USE Symmetry
      USE Atomi
      USE RemoModule
      USE PhaseModule
!
      integer hkl(3)
!
      do ij = 1, model(WhichModel)%nk
         ff_m(ij,WhichModel) = ScattFact_MR(ij, rho,WhichModel)
      enddo
!
      hkle(1:3,1)=hkl(1:3)
      hkle(4,1) = 1000.0
      call sfacNewNew(1, rho, att, btt)
      SumGs2 = (att*att + btt*btt)
c
      return
      end
!-----------------------------------------------------------------------
       integer function inCheshire_remo(delta)
       USE General
       USE Symmetry
       USE RelaxMod
 
!
       dimension delta(3)
!
       do i=1,3
         if (ifR3Cheshire == 0 .or. i==3) then
         do j=1,2
           nCond = ncondche(i,j)
           if (nCond > 0) then
               if (j == 1) then
                   m=1
                   a = ( xcondche(i,j,m,1) * delta(1) +
     *                  xcondche(i,j,m,2) * delta(2) +
     *                  xcondche(i,j,m,3) * delta(3) +
     *                  xcondche(i,j,m,4) ) * xcondche(i,j,m,5)
                   if (delta(i) <= a) then
                       if(nCond==1) then
                        inCheshire_remo = 0
                        return
                      else
                        m=2
                        a = ( xcondche(i,j,m,1) * delta(1) +
     *                       xcondche(i,j,m,2) * delta(2) +
     *                       xcondche(i,j,m,3) * delta(3) +
     *                       xcondche(i,j,m,4) ) * xcondche(i,j,m,5)
                        if (delta(i) <= a) then
                          inCheshire_remo = 0
                          return
                        endif
                      endif
                   endif
               else
                    m=1
                    a = ( xcondche(i,j,m,1) * delta(1) +
     *                   xcondche(i,j,m,2) * delta(2) +
     *                   xcondche(i,j,m,3) * delta(3) +
     *                   xcondche(i,j,m,4) ) * xcondche(i,j,m,5)
                    if (delta(i) >= a) then
                      if(nCond==1) then
                         inCheshire_remo = 0
                         return
                      else
                        m=2
                        a = ( xcondche(i,j,m,1) * delta(1) +
     *                       xcondche(i,j,m,2) * delta(2) +
     *                       xcondche(i,j,m,3) * delta(3) +
     *                       xcondche(i,j,m,4) ) * xcondche(i,j,m,5)
                        if (delta(i) >= a) then
                          inCheshire_remo = 0
                          return
                        endif
                      endif
                   endif
               endif
           endif
         enddo
         else    ! caso trigonale-esagonale, solo nel piano xy
         do j=1,2
           nCond = ncondche(i,j)
           do m=1,nCond
             a = ( xcondche(i,j,m,1) * delta(1) +
     *            xcondche(i,j,m,2) * delta(2) +
     *            xcondche(i,j,m,3) * delta(3) +
     *            xcondche(i,j,m,4) ) * xcondche(i,j,m,5)
             if(j==1) then
               if (delta(i) <= a) then
                 inCheshire_remo = 0
                 return
               endif
             else
               if (delta(i) >= a) then
                 inCheshire_remo = 0
                 return
               endif
             endif
           enddo
         enddo
         endif
       enddo

       inCheshire_remo = 1

       return
       end
!-----------------------------------------------------------------------
      integer function inCheshire(deltaO)
      USE General
      USE Symmetry
      USE RelaxMod
!
      implicit none
      integer :: i, j, m, nCond
      real    :: deltaO(3), delta(3), eps, a
!
      eps = 0.01
      delta(1:3) = deltaO(1:3)
      do i=1, 3
         do j=1,5
            if (abs(delta(i) - ValCritici(j,1)) < EpsCritici) then
                delta(i) = ValCritici(j,2)
                exit
            endif
         enddo
      enddo
!
      do i=1,3
        if (ifR3Cheshire == 0 .or. i==3) then
            do j=1,2
              nCond = ncondche(i,j)
              if (nCond > 0) then
                  if (j == 1) then
                      m=1
                      a = ( xcondche(i,j,m,1) * delta(1) +
     *                      xcondche(i,j,m,2) * delta(2) +
     *                      xcondche(i,j,m,3) * delta(3) +
     *                      xcondche(i,j,m,4) ) * xcondche(i,j,m,5)
*                     if (delta(i) <= a) then
                      if (delta(i) < a-eps) then
                          if (nCond==1) then
                              inCheshire = 0
                              return
                          else
                           m=2
                           a = ( xcondche(i,j,m,1) * delta(1) +
     *                           xcondche(i,j,m,2) * delta(2) +
     *                           xcondche(i,j,m,3) * delta(3) +
     *                           xcondche(i,j,m,4) ) * xcondche(i,j,m,5)
*                          if (delta(i) <= a) then
                           if (delta(i) < a-eps) then
                               inCheshire = 0
                             return
                           endif
                         endif
                      endif
                  else
                       m=1
                       a = ( xcondche(i,j,m,1) * delta(1) +
     *                       xcondche(i,j,m,2) * delta(2) +
     *                       xcondche(i,j,m,3) * delta(3) +
     *                       xcondche(i,j,m,4) ) * xcondche(i,j,m,5)
*                      if (delta(i) >= a) then
                       if (delta(i) > a+eps) then
                           if (nCond == 1) then
                              inCheshire = 0
                              return
                           else
                              m=2
                              a = (xcondche(i,j,m,1) * delta(1) +
     *                             xcondche(i,j,m,2) * delta(2) +
     *                             xcondche(i,j,m,3) * delta(3) +
     *                             xcondche(i,j,m,4) )*xcondche(i,j,m,5)
*                             if (delta(i) >= a) then
                              if (delta(i) > a+eps) then
                                inCheshire = 0
                                return
                              endif
                           endif
                       endif
                  endif
              endif
            enddo
        else    ! caso trigonale-esagonale, solo nel piano xy
            do j=1,2
               nCond = ncondche(i,j)
               do m=1,nCond
                  a = ( xcondche(i,j,m,1) * delta(1) +
     *                  xcondche(i,j,m,2) * delta(2) +
     *                  xcondche(i,j,m,3) * delta(3) +
     *                  xcondche(i,j,m,4) ) * xcondche(i,j,m,5)
                  if (j == 1) then
*                     if (delta(i) <= a) then
                      if (delta(i) < a-eps) then
                          inCheshire = 0
                          return
                      endif
                  else
*                     if (delta(i) >= a) then
                      if (delta(i) > a+eps) then
                          inCheshire = 0
                          return
                      endif
                  endif
               enddo
            enddo
        endif
      enddo
!
      inCheshire = 1
!
      return
      end
!-----------------------------------------------------------------------
      function inCheshireLat(delta)
      USE Symmetry
!
      dimension delta(3)
c
c--non considero la cella di Cheshire,
c        ma restringo la ricerca in base alla sola centratura
c
      inCheshireLat = 1
c
      if(latt==1) return
c
      if(latt==2.or.latt==3.or.latt==5) then
c--A, B o F
        if(delta(3)>0.5) inCheshireLat=0
      elseif(latt==4) then
c--C
        if(delta(2)>0.5) inCheshireLat=0
      elseif(latt==6) then
c--F
        if(delta(1)>0.5.or.
     &     delta(2)>0.5.or.
     &     delta(3)>0.5) inCheshireLat=0
      elseif(latt==7) then
c--R
        if(delta(2)>0.333) inCheshireLat=0
      endif
!
c     write(6,*) 'ecco',latt,inCheshireLat
      return
      end
!-----------------------------------------------------------------------
      subroutine CheshireTra()
c
      USE General
      USE Symmetry
c
c--inserisce le condizioni sulla cella di Cheshire nelle variabili
c    ncondche(1:3,1:2)
c    xcondche(1:3,1:2,1:ncondche,1:5)
c
      ifR3Cheshire = 0
      ncondche=0
      xcondche=0.0
c
c--vedo se la matrice di cheshire e' diagonale 
c
      idiag=1
      inull=0
      do i=1,3
        do j=1,3
          if(i==j) cycle
          if(CheMat(i,j)==0) cycle
          idiag=0     
        enddo
      enddo
c
      if(idiag==1) then
c
c--matrice di Cheshire diagonale
c
       do i=1,3
         if(CheMat(i,i)==0) cycle
c--condizione < 
         ncondche(i,2)=ncondche(i,2)+1
         xcondche(i,2,ncondche(i,2),4) = 1.0
c        xcondche(i,2,ncondche(i,2),5) = 1.0/2.0
         xcondche(i,2,ncondche(i,2),5) = CheMat(i,i)
       enddo
c
      else
c
c--matrice di Cheshire non diagonale
c
c--considero l'origine libera lungo z
       icont=0
       do j=1,3
         if(CheMat(3,j)==0) cycle
         icont=icont+1
       enddo
       if(icont==1) then   ! non abbiamo origine libera secondo z
c--condizione < 
         ncondche(3,2)=ncondche(3,2)+1
         xcondche(3,2,ncondche(3,2),4) = 1.0
         xcondche(3,2,ncondche(3,2),5) = 1.0/2.0
       endif
c
c--elemento non diagonale: si possono avere 3 casi:
c
       if(CheMat(1,1)==0.0) then
c--caso del R-3m
c--condizione > 
c        ncondche(2,1)=ncondche(2,1)+1
c        xcondche(2,1,ncondche(2,1),1:5) = (/ 1,0,0,0,1 /)
       elseif(CheMat(1,1)>0.4) then
c--caso del del tetragonale
c--condizione > 
         ncondche(2,1)=ncondche(2,1)+1
         xcondche(2,1,ncondche(2,1),:) = (/ 1.0,0.0,0.0,0.0,1.0 /)
         ncondche(2,1)=ncondche(2,1)+1
         xcondche(2,1,ncondche(2,1),:) = (/-1.0,0.0,0.0,1.0,1.0 /)
c--condizione < 
         ncondche(2,2)=ncondche(2,2)+1
         xcondche(2,2,ncondche(2,2),:) = (/-1.0,0.0,0.0,1.0,1.0 /)
         ncondche(2,2)=ncondche(2,2)+1
         xcondche(2,2,ncondche(2,2),:) = (/ 1.0,0.0,0.0,0.0,1.0 /)
       else
c--caso del trigonale-esagonale
c--condizione > 
         ifR3Cheshire = 1
         ncondche(2,1)=ncondche(2,1)+1
         xcondche(2,1,ncondche(2,1),:) = (/ 0.5,0.0,0.0,0.0,1.0 /)
         ncondche(2,1)=ncondche(2,1)+1
         xcondche(2,1,ncondche(2,1),:) = (/2.0,0.0,0.0,-1.0,1.0 /)
c--condizione < 
         ncondche(2,2)=ncondche(2,2)+1
         xcondche(2,2,ncondche(2,2),:) = (/2.0,0.0,0.0,0.0,1.0 /)
         ncondche(2,2)=ncondche(2,2)+1
         xcondche(2,2,ncondche(2,2),:) = (/ 0.5,0.0,0.0,0.5,1.0 /)
       endif
c
      endif
c
c     do i=1,3
c        m=ncondche(i,1)
c        write(6,*) 'condizione > ',m
c        do im=1,m
c          write(6,*) xcondche(i,1,im,1:5)
c        enddo
c        m=ncondche(i,2)
c        write(6,*) 'condizione < ',m
c        do im=1,m
c          write(6,*) xcondche(i,2,im,1:5)
c        enddo
c     enddo
      return
      end
!-----------------------------------------------------------------------
      subroutine CheshireConditions()
      USE General, only : lo
      USE Symmetry
!
!--print Cheshire Conditions
!
      implicit none
      integer :: i, j, k, l, m, ncond, jc1(3), jc2(2,2), jc3(2)
      character (len=2) :: jc2ch(2,2), jc3ch
      character (len=6) :: jc1ch
!
      if (ifR3Cheshire == 1) then
          return
      endif
      ncond = sum(ncondche(:,:))
      if (ncond == 0) then
          return
      endif
!
      jc1ch      = 'x y z '
      jc3ch      = '><'
      jc2ch(1,1) = 'mi'
      jc2ch(2,1) = 'n)'
      jc2ch(1,2) = 'ma'
      jc2ch(2,2) = 'x)'
!
      read(jc1ch,'(3a2)') jc1
      read(jc3ch,'(2a1)') jc3
      do i=1, 2
         do j=1, 2
            read(jc2ch(j,i),'(a2)') jc2(j,i)
         enddo
      enddo
!
      write(lo,10)
      do i=1, 3
         do j=1, 2
            ncond = ncondche(i,j)
            if (ncond > 0) then
                write(lo,20) ncond ,jc1(i),(jc2(k,j),k=1,2)
                do m=1, ncond 
                   write(lo,30) jc1(i),(jc2(k,j),k=1,2),jc3(j),
     2                              (xcondche(i,j,m,l),l=1,5)
                 enddo
            endif
         enddo
      enddo
!
      return
   10 format(/,' Conditions on Cheshire cell :')
   20 format(i4,' condition(s) on ',a1,'(',2a2)
   30 format(5x,a1,'(',2a2,1x,a1,' [ (',f5.2,' * x )',
     1                           ' + (',f5.2,' * y )',
     2                           ' + (',f5.2,' * z )',
     3                           ' +',f5.2,' ] *',f5.2)
 1305 format(20x,f6.3,' <   ',a1,'   < ',f6.3)
 1306 format(/,' Fourier limits   : ' ,f6.3,' <   ',a1,'   < ',f6.3)
      end
!-----------------------------------------------------------------------
      subroutine CheshireAngle()
!
!--limiti per angoli di Eulero definiti tra 0.0 e TwoPi.
!-- Int. Tables (2001) Vol. B , pagg. 254,256
!
      USE General
      USE Symmetry
!
!-condizioni generali per gli angoli di Eulero
!
      alimUp(1:3)=  (/  TwoPi,   Pi,  TwoPi /)
!
      select case (nSpaceGroupPatt)
         case (1)            !  triclino
              alimUp(1:3) = (/ TwoPi,   Pi,  TwoPi /)
         case (2,3)          !  monoclino ( asse unico b )
              if (abs(cell(5)-90.0) > 0.01) then  ! asse unico b
                  alimUp(1:3) = (/ TwoPi,   Pi/2.0,  TwoPi /)
c                 alimUp(1:3) = (/ Pi/2.0,   Pi,  TwoPi /)  ! con simmetria
              elseif (abs(cell(6)-90.0) > 0.01) then  ! asse unico c
                  alimUp(1:3) = (/ Pi,   Pi,  TwoPi /)
c                 alimUp(1:3) = (/ Pi,   Pi,  Pi /) ! con simmetria  
              endif
         case (4,5,6,7,8,9)  !  ortorombico
              alimUp(1:3) = (/ Pi,   Pi/2.0,  TwoPi /)
c             alimUp(1:3) = (/ Pi/2.0,   Pi/2.0,  Pi /)  ! con simmetria
         case (10,11)        !  tetragonale 4/m
              alimUp(1:3) = (/ Pi/2.0,   Pi,  TwoPi /)
c             alimUp(1:3) = (/ Pi/2.0,   Pi,  Pi/2.0 /)  ! con simmetria
         case (12,13)        !  tetragonale 4/mmm
              alimUp(1:3) = (/ Pi/2.0,   Pi/2.0,  TwoPi /)
c             alimUp(1:3) = (/  Pi/4.0,   Pi/2.0,  Pi/2.0 /) ! con simmetria
         case (14,15)           !  trigonale  3 (non romboedrico)
              if (ifRhombAx == 0) then
                  alimUp(1:3) = (/ TwoPi/3.0,    Pi,  TwoPi /)  
              endif
c             alimUp(1:3) = (/ TwoPi/3.0,    Pi,  TwoPi/3.0 /)  ! con simmetria
c        case (16,17)        !   trigonale  3m (non romboedrico)
         case (16,17,18)        !   trigonale  3m (non romboedrico)
              if(ifRhombAx == 0) then
                 alimUp(1:3) = (/ TwoPi/3.0,  Pi/2.0,  TwoPi /)
              endif
c             alimUp(1:3) = (/ Pi/6.0,  Pi,  TwoPi/3.0 /)  ! con simmetria
         case (19)           !  esagonale  6/m
              alimUp(1:3) = (/ Pi/3.0,  Pi,  TwoPi /)
c             alimUp(1:3) = (/ Pi/3.0,  Pi,  Pi/3.0 /)  ! con simmetria
         case (20)           !  esagonale  6/mmm
              alimUp(1:3) = (/ Pi/3.0,  Pi/2.0,  TwoPi /)
c             alimUp(1:3) = (/ Pi/6.0,  Pi/2.0,  Pi/3.0 /)  ! con simmetria
         case (21,22,23)           !  cubico  m -3
              alimUp(1:3) = (/ Pi,   Pi/2.0,  TwoPi /) ! lo considero come 222
c_giaco               alimUp(1:3) = (/ Pi/2.0,   Pi/2.0,  Pi /)
         case (24,25,26)           !  cubico  m -3 m
              alimUp(1:3) = (/ Pi/2.0,   Pi/2.0,  TwoPi /) ! lo considero come 422
      end select
!
      return
      end
!-----------------------------------------------------------------------
      subroutine sftrNewLocal(corre)
      USE General
      USE Symmetry
      USE Riflessi
      USE RuotaRiflessi
      USE riflessi_c
      USE Atomi
      USE RemoModule
c----
c     structure factor calculation
c----
c
      do i=1,nreflSelTra
         rho=rhovcomp(i)
         do ij = 1, model(WhichModel)%nk
            ff(ij) = ScattFact_MR(ij, rho,WhichModel)
         enddo
c
         act=0.0
         bct=0.0
         do j=1,nsym
            tt=1000.0
            do l=1,3
               tt=tt+float(khlv(l,1,i))*tmat(j,l)
               hkle(l,j)=khlv_eq(l,j,1,i)
            enddo
            hkle(4,j)=tt
            call sfacNewNew(j, rho, att, btt)
            act=act+att
            bct=bct+btt
         enddo
c
         args = act * act + bct * bct
         if (args > 0.000001) then
             fccomp(i) = sqrt(args)
         else
             fccomp(i) = 0.0
         endif
c
      enddo
c
      return
      end
!-----------------------------------------------------------------------
      subroutine ImproveRotNewNew(imode,nsol,iicont)
c
c--routine per migliorare le soluzioni candidate dopo la ricerca
c   delle rotazioni
c
      USE General
      USE Symmetry
      USE Solutions
      USE riflessi_c
      USE RuotaRiflessi
      USE Riflessi
      USE RemoModule
      USE PhaseModule
      USE Molcom

c      implicit none
     
! 
      integer nsol,imode,iicont
      dimension b(3,3),vet2(3)
      dimension dtet1(3),dtet(3)
      integer ivet2(3), i, j, ii ,jj, n
      dimension vet1(3)
      real tet10,tet20,tet30,tet1p,tet2p,tet3p
      real ttet1, ttet2, ttet3
      real Re1(3,3), Re2(3,3)
      real M1Re1(3,3),MRc(3,3),MRcM1Re1(3,3)
      real A(3,3),C(3,3),lim_clust
      real dx1x2 , dx1o, dx2o, s_ang, c_ang
      real prt_fom(5),prt_fom_max(5)
c      real vect_sol(50)

      kkvv = kverbo 
c     if (knw > 0) kverbo = 1
! fissa le iterazioni complessive (pari a 8000) e al tempo stesso l'estensione
! della regione esplorata
! estensione=2*tol*dtet
! passo=dtet
! numero di punti griglia=2*tol
! per lasciare invariata l'estensione devo diminuire tol e aumentare dtet, lasciando
! pero' il prodotto tol*dtet costante
c
c
c--determino il punto centrale
c

      tet10 = solcan(WhichSolution)%RotVal(1)   
      tet20 = solcan(WhichSolution)%RotVal(2)   
      tet30 = solcan(WhichSolution)%RotVal(3) 
      call RotationOper1(Re1,tet10,tet20,tet30)

      costofirst=solcan(WhichSolution)%RotFom

c
c--seleziono i punti della griglia da clusterizzare
c
!la prima volta faccio cluster più grandi
!!!!  lim_clust = 0.14*idSeq + 0.11 

      lim_clust = 0.09*idSeq + 0.11 

      if(imode==1)then
!!!      lim_clust=0.1 !più piccoli
         lim_clust=0.125 !più piccoli
         group_sol(iicont,1)=nsol
         ncont_figli=1 
      endif
c     write(6,*) ' lim_clust =', lim_clust

          
      do j=1+nsol,nSolToExplore
         i = solcan(j)%ipunt
         if(solcan(i)%accepted==0) cycle
         tet1p=solcan(i)%RotVal(1)
         tet2p=solcan(i)%RotVal(2)
         tet3p=solcan(i)%RotVal(3)
         call RotationOper1(Re2,tet1p,tet2p,tet3p)

        ciclo_sym: do jj = 1,nsym
            do ij = 1,nsym 

               A(:,:)=kmat(jj,:,:)
               C(:,:)=kmat(ij,:,:)
              
               call inv3r(A,det,MRc)!inversa dell'operatore di simmetria

               call MoltMatMat(C,Re1,M1Re1 )
               call MoltMatMat(MRc,M1Re1,MRcM1Re1)

               rms = 0.0
               do n = 1,3
                  do ii=1,3
                     rms = rms + (Re2(n,ii)-MRcM1Re1(n,ii))**2 
                  enddo
               enddo 
               rms = sqrt(rms) 
            
c            write(6,*)WhichSolution,i,nsym,rms
c           lim_clust = 0.25*idSeq + 0.05
               if(rms < lim_clust) then
                  if(imode==1)then
                     ncont_figli=ncont_figli+1
                     group_sol(iicont,ncont_figli)=j
                     solcan(i)%accepted=0 
                     if (kverbo >0) then
                         write(6,*)i,'->',WhichSolution
                     endif
                  else
                     if (kverbo >0) then
                         write(6,*)i,'->',WhichSolution
                     endif
                     solcan(i)%accepted=0
                  endif
                  exit ciclo_sym
              endif 
           enddo  
        enddo ciclo_sym
      enddo

      if(imode==0)then
         tol=3.0
         do i=1,3
           dump=0.7*alimUp(i)/TwoPi
           if(i==2) dump=0.5*alimUp(i)/Pi
           dtet(i) = dump*step
           dtet1(i) = tol*dtet(i)
         enddo

c        if(use_resplus)then
c           do i=1,3
c              dump=0.7*alimUp(i)/TwoPi
c              if(i==2) dump=0.5*alimUp(i)/Pi
c              dtet(i) = dump*step1
c              dtet1(i) = tol*dtet(i)
c           enddo
c        endif
c        dtet1(:)=min(dtet1(:),0.23)

c
c--determino un cubo intorno alla soluzione considerata
c
         icont=0
         costomax=-1.0
         ttet1=tet10-dtet1(1)
         do while(ttet1 <= tet10+dtet1(1))
            ttet2=tet20-dtet1(2)
            do while(ttet2<= tet20+dtet1(2))
               ttet3=tet30-dtet1(3)
               do while(ttet3 <= tet30+dtet1(3))
c
                  call RotationOper1(b,ttet1,ttet2,ttet3)
c
c
                  Ecal2_med = 0.0
                  do i=1,nreflSelRot
                     k = k_mem(i) 
                     tcalc=0.0
                     do jj=1,nsym
                        do io=1, 3
                           vet2(io) = 0
                           do jo=1, 3
                              vet2(io) = vet2(io) + b(io,jo)
     *                                   *khlv_eq(jo,jj,2,i)
                           enddo
                        enddo
                        call controllo_indici_interi(vet2,ivet2)
                        indr =ivet2(1)*ifat1C+ivet2(2)*ifat2C + ivet2(3)
                        if (indr <= ifatxC .and. indr > 0) then
                           j = superind(indr)
                           if (j > 0) then
                              if(use_E) then
                                 tcalc=tcalc+ecvetc(j)   
                              else
                                 tcalc=tcalc+fcvetc(j)
                              endif
                           endif
                        endif
                     enddo
                     ModuliSel(1,i) = sqrt(tcalc)

                     Ecal2_med = Ecal2_med + tcalc

                  enddo

              Ecal2_med = Ecal2_med / nreflSelRot
c             write(6,*) '<Rp**2> = ', Ecal2_med
              sca = 1.0 / Ecal2_med
              do i=1,nreflSelRot
                 tcalc = sca*(ModuliSel(1,i)**2)
                 ModuliSel(1,i) = sqrt(tcalc)
              enddo


c
c--calcolo della funzione costo
c
                  if(use_E) then
c                   call CalcolaCosto2(costo)
c                   kverbo = 0  !200
c                   iact = 1
c                   call Calcola_FinalFom_MR(nsol,iact,costo,prt_fom)
c                   costo_old = FinalFom
c                   kverbo = 0
cc                  call CalcolaCosto_Rot(costo,prt_fom)

                    ifl = 1
                    if (WhichModel == 1) then
                        call FomFirstModel(ifl,nreflSelRot,costo)
                    else
                        call FomMoreModels(ifl,nreflSelRot,costo)
                    endif

                  else
                     call CalcolaCostoProva(costo) 
                  endif
                  icont=icont+1

                  if (costo > costomax) then
                      costomax=costo
                      prt_fom_max(:)=prt_fom(:)
                      tet1max=ttet1
                      tet2max=ttet2
                      tet3max=ttet3
                  endif
c
                  ttet3 = ttet3 + dtet(3)
               enddo
               ttet2 = ttet2 + dtet(2)
            enddo
            ttet1 = ttet1 + dtet(1)
         enddo
         if(kverbo>0) then
            write(6,'(a,2f8.3,i8)')'costoBest',costofirst,costomax,icont
         endif
c
c
c--riporto gli angoli nell'intervallo [0,TwoPi]
c
         tet1 = tet1max
         if(tet1.lt.0.0) tet1 = tet1+TwoPi
         tet1 = amod(tet1, TwoPi)
         tet2 = tet2max
         if(tet2.lt.0.0) tet2 = tet2+TwoPi
         tet2 = amod(tet2, TwoPi)
         tet3 = tet3max
         if(tet3.lt.0.0) tet3 = tet3+TwoPi
         tet3 = amod(tet3, TwoPi)

         solcan(WhichSolution)%RotVal(1) = tet1
         solcan(WhichSolution)%RotVal(2) = tet2
         solcan(WhichSolution)%RotVal(3) = tet3
!uso trafom per non visualizzare sulla grafica valori numerici della fom ottimizzata più bassi
         solcan(WhichSolution)%TraFom = solcan(WhichSolution)%RotFom
         solcan(WhichSolution)%RotFom = costomax
         solcan(WhichSolution)%RFom(:) = prt_fom_max(:)

      endif
      if (knw > 0) kverbo = kkvv
!
      return
      end
!-----------------------------------------------------------------------
      subroutine UpdateSol2(xopti,fopti,j1)
!
      USE General
      USE Symmetry
      USE Riflessi
      USE RuotaRiflessi
      USE riflessi_c
      USE Atomi
      USE Molcom
      USE TraslaSolution
      USE RemoModule
      USE PhaseModule
      USE Solutions
      USE Finale
!
!-- memorizza i nuovi parametri e funzione costo nella lista
!
      real, allocatable :: x1(:), x2(:)
      real  b(3,3),btra(3,3),xopti(6*nMolMR)
      real fopti
      integer j1
      dimension fragShift(3)
      allocate(x1(1:3*jMolMR), stat = ier2)
      allocate(x2(1:3*jMolMR), stat = ier3)

!
!-- posiziono il modello in funzione dei nuovi parametri
!
      natsSav = nats
      nats    = natsMR
      if(knw>0) then
      
      do jj=1, jMolMR
          n_index = 6 * (jj-1) 

          tet1 = xopti(n_index+1)
          tet2 = xopti(n_index+2)
          tet3 = xopti(n_index+3)
          call RotationOper1(b,tet1,tet2,tet3)
!
          do i=1,3
             do j=1,3
                btra(i,j) = b(j,i)
             enddo
          enddo
          do i=1, natsInModel(WhichModel)
             x1(1:3) = model(WhichModel)%saved(1:3,i,jj)
             call MoltMatVec(rm, x1, x2)
             call MoltMatVec(btra, x2, x1)
             call MoltMatVec(rmi, x1, x2)
             n_start=6*(jj-1)+4
             n_fin=6*(jj-1)+6
             model(WhichModel)%atoms(1:3,i,jj) = x2(1:3) +
     *                                           xopti(n_start:n_fin)
         enddo
      enddo
c
c--calcolo rigoroso, ma lento   
c       iCoeff = 0
c       mode = 1
c       iref = 0
c       call sftryyyRemo(nrefl,scalan,iCoeff,)
c--calcolo approssimato, ma veloce   
c        badd = 0.0
c        call ChemInfo_MR_Local(badd)
c        call NewInv_MR_Local()

        call ChemInfo_MR_Final()
        call NewInv_MR_Final()
! 
        tmpwt(:) = 0.0
        do io=1, nreflSelTra
          j = k_mem1(io)
          tmpwt(j) = 1.0
        enddo
        nbru = 1
        izero = 0
        ifmin = 0
        call examin(nbru,mkang,khl,ipub,iphaz,nrefl,
     *              izero,tmpwt,ifmin)
      endif

      model(WhichModel)%considerato(:) = 0
      model(WhichModel)%considerato(1:jMolMR-1) = 1

      do jj=1, jMolMR-1
          n_index = 6 * (jj-1) 

          tet1 = xopti(n_index+1)
          tet2 = xopti(n_index+2)
          tet3 = xopti(n_index+3)
          call RotationOper1(b,tet1,tet2,tet3)
!
          do i=1,3
             do j=1,3
                btra(i,j) = b(j,i)
             enddo
          enddo
          do i=1, natsInModel(WhichModel)
             x1(1:3) = model(WhichModel)%saved(1:3,i,jj)
             call MoltMatVec(rm, x1, x2)
             call MoltMatVec(btra, x2, x1)
             call MoltMatVec(rmi, x1, x2)
             n_start=6*(jj-1)+4
             n_fin=6*(jj-1)+6
             model(WhichModel)%atoms(1:3,i,jj) = x2(1:3)
     *                                         +  xopti(n_start:n_fin)
         enddo
      enddo
      fragShift(:) = 0.0
      call sftrNew(3, fragShift, dump,1)

      model(WhichModel)%considerato(:) = 0
      model(WhichModel)%considerato(jMolMR) = 1

      n_index = 6 * (jMolMR-1) 
      tet1 = xopti(n_index+1)
      tet2 = xopti(n_index+2)
      tet3 = xopti(n_index+3)
      call RotationOper1(b,tet1,tet2,tet3)
!
      do i=1,3
         do j=1,3
            btra(i,j) = b(j,i)
         enddo
      enddo
      do i=1, natsInModel(WhichModel)
         x1(1:3) = model(WhichModel)%saved(1:3,i,jj)
         call MoltMatVec(rm, x1, x2)
         call MoltMatVec(btra, x2, x1)
         call MoltMatVec(rmi, x1, x2)
         model(WhichModel)%atoms(1:3,i,jj) = x2(1:3)
      enddo

      n_start=6*(jMolMR-1)+4
      n_fin=6*(jMolMR-1)+6
      fragShift(:) = 0.0
      call sftrNew(1, fragShift, corre,1)
      use_sigmaA = .true. 
      call sftrNew(2, xopti(n_start:n_fin), corre, 1)
      model(WhichModel)%considerato(1:jMolMR) = 1

c
c      corre=fopti
!
!--inserisco i parametri
!
c
c--riporto gli angoli nell'intervallo [0,TwoPi]
c
      do jj=1,jMolMR
         n_index=6*(jj-1)
         do i=n_index+1,n_index+3
            tet=xopti(i)
            if(tet.lt.0.0) tet = tet+TwoPi
            tet = amod(tet, TwoPi)
            xopti(i)=tet
         enddo
c
c--riporto la posizione nella cella
c
         do i=n_index+4,n_index+6
            pos=xopti(i)
            xopti(i)=side(pos)
         enddo
    
c
!
!--memorizzo la nuova funzione costo e i nuovi parametri
!
      ResMol(j1,jj,1:3) = xopti(n_index+1:n_index+3) * rtod
      ResMol(j1,jj,4:6) = xopti(n_index+4:n_index+6)
      finsolcan(j1)%RotVal(1:3,WhichModel,jj)
     *                        = xopti(n_index+1:n_index+3) 
      finsolcan(j1)%TraVal(1:3,WhichModel,jj)
     *                        = xopti(n_index+4:n_index+6)
      enddo
      finsolcan(j1)%Corr = fopti
      finsolcan(j1)%Fom = corre
      finsolcan(j1)%MPE = erore
c
c      call DataForGraph(5,ipoint)
!
      nats = natsSav
c      do ii=1, numbModels
c         jj = MonomerInModel(ii)
c         model(ii)%considerato(1:jj) = 1
c      enddo
      deallocate( x1, x2, stat = ier4)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine UpdateSol3(xopti,fopti,j1,ncontMon)
!
      USE General
      USE Symmetry
      USE Riflessi
      USE RuotaRiflessi
      USE riflessi_c
      USE Atomi
      USE Molcom
      USE TraslaSolution
      USE RemoModule
      USE PhaseModule
      USE Solutions
      USE Finale
!
!-- memorizza i nuovi parametri e funzione costo nella lista
!
c      real, allocatable :: x1(:), x2(:)
      real  b(3,3),btra(3,3),xopti(6*ncontMon)
      real fopti
      integer j1
      dimension fragShift(3)
      real x1(3), x2(3)
c      allocate(x1(1:3), stat = ier2)
c      allocate(x2(1:3), stat = ier3)

!
!-- posiziono il modello in funzione dei nuovi parametri
!
      natsSav = nats
      nats    = natsMR
      if(knw>0) then
        jj = 0
        do ii=1, WhichModel
           do j=1, MonomerInModel(ii)
              if (model(ii)%considerato(j) == 0) cycle
              jj = jj + 1
              n_index = 6 * (jj-1) 
              tet1 = xopti(n_index+1)
              tet2 = xopti(n_index+2)
              tet3 = xopti(n_index+3)
              call RotationOper1(b,tet1,tet2,tet3)
!
              do i=1,3
                 do jjj=1,3
                    btra(i,jjj) = b(jjj,i)
                 enddo
              enddo
              do i=1, natsInModel(ii)
                 x1(1:3) = model(ii)%saved(1:3,i,j)
                 call MoltMatVec(rm, x1, x2)
                 call MoltMatVec(btra, x2, x1)
                 call MoltMatVec(rmi, x1, x2)
                 n_start=6*(jj-1)+4
                 n_fin=6*(jj-1)+6
                 model(ii)%atoms(1:3,i,j) = x2(1:3) +
     *                                  xopti(n_start:n_fin)
             enddo
           enddo
        enddo
c
c--calcolo rigoroso, ma lento   
c        iCoeff = 0
c        mode = 1
c        iref = 0
c        call sftryyyRemo(nrefl,scalan,iCoeff)
c--calcolo approssimato, ma veloce   

c         badd = 0.0
c         call ChemInfo_MR_Local(badd)
c         call NewInv_MR_Local()

         call ChemInfo_MR_Final()
         call NewInv_MR_Final()

         tmpwt(:) = 0.0
         do io=1, nreflSelTra
            j = k_mem1(io)
            tmpwt(j) = 1.0
         enddo
         nbru = 1
         izero = 0
         ifmin = 0
         call examin(nbru,mkang,khl,ipub,iphaz,nrefl,
     *              izero,tmpwt,ifmin)
      endif
      jj = 0
      model(WhichModel)%considerato(WhichMonomer) = 0
c      model(WhichModel)%considerato(1:jMolMR-1) = 1
      do ii=1, WhichModel
         do j=1, MonomerInModel(ii)
            if (model(ii)%considerato(j) == 0) cycle
            jj = jj + 1
            n_index = 6 * (jj-1) 

            tet1 = xopti(n_index+1)
            tet2 = xopti(n_index+2)
            tet3 = xopti(n_index+3)
            call RotationOper1(b,tet1,tet2,tet3)
!
            do i=1,3
               do jjj=1,3
                  btra(i,jjj) = b(jjj,i)
               enddo
            enddo
            do i=1, natsInModel(ii)
               x1(1:3) = model(ii)%saved(1:3,i,j)
               call MoltMatVec(rm, x1, x2)
               call MoltMatVec(btra, x2, x1)
               call MoltMatVec(rmi, x1, x2)
               n_start=6*(jj-1)+4
               n_fin=6*(jj-1)+6
               model(ii)%atoms(1:3,i,j) = x2(1:3)
     *                                 +  xopti(n_start:n_fin)
            enddo
         enddo
      enddo
      fragShift(:) = 0.0
      call sftrNew(3, fragShift, dump,1)

c     model(WhichModel)%considerato(:) = 0
c     model(WhichModel)%considerato(jMolMR) = 1
      do ii=1, WhichModel
         model(ii)%considerato(:) = 0
      enddo
      model(WhichModel)%considerato(WhichMonomer) = 1

      n_index = 6 * (ncontMon-1) 
      tet1 = xopti(n_index+1)
      tet2 = xopti(n_index+2)
      tet3 = xopti(n_index+3)
      call RotationOper1(b,tet1,tet2,tet3)
!
      do i=1,3
         do j=1,3
            btra(i,j) = b(j,i)
         enddo
      enddo
      do i=1, natsInModel(WhichModel)
         x1(1:3) = model(WhichModel)%saved(1:3,i,WhichMonomer)
         call MoltMatVec(rm, x1, x2)
         call MoltMatVec(btra, x2, x1)
         call MoltMatVec(rmi, x1, x2)
         model(WhichModel)%atoms(1:3,i,WhichMonomer) = x2(1:3)
      enddo

      n_start=6*(ncontMon-1)+4
      n_fin=6*(ncontMon-1)+6
      fragShift(:) = 0.0
      call sftrNew(1, fragShift, corre,1)
      use_sigmaA = .true. 
      call sftrNew(2, xopti(n_start:n_fin), corre, 1)
      do ii=1, WhichModel
         model(ii)%considerato(:) = 1
      enddo
      do ii=1, MonomerInModel(WhichModel)
         if(ii>WhichMonomer)
     &       model(WhichModel)%considerato(ii) = 0
      enddo
c
c      corre=fopti
!
!--inserisco i parametri
!
c
c--riporto gli angoli nell'intervallo [0,TwoPi]
c
       jj = 0
       do ii=1, WhichModel
         do j=1, MonomerInModel(ii)
            if (model(ii)%considerato(j) == 0) cycle
            jj = jj + 1
            n_index=6*(jj-1)
            do i=n_index+1,n_index+3
               tet=xopti(i)
               if(tet.lt.0.0) tet = tet+TwoPi
               tet = amod(tet, TwoPi)
               xopti(i)=tet
            enddo
c
c--riporto la posizione nella cella
c
            do i=n_index+4,n_index+6
               pos=xopti(i)
               xopti(i)=side(pos)
            enddo
    
c
!
!--memorizzo la nuova funzione costo e i nuovi parametri
!
c            ResMol(j1,jj,1:3) = xopti(n_index+1:n_index+3) * rtod
c            ResMol(j1,jj,4:6) = xopti(n_index+4:n_index+6)
            finsolcan(j1)%RotVal(1:3,ii,j)
     *                        = xopti(n_index+1:n_index+3) 
            finsolcan(j1)%TraVal(1:3,ii,j)
     *                        = xopti(n_index+4:n_index+6)
         enddo
      enddo
      finsolcan(j1)%Corr = fopti
      finsolcan(j1)%Fom = corre
      finsolcan(j1)%MPE = erore
c
c      call DataForGraph(5,ipoint)
!
      nats = natsSav
c      do ii=1, numbModels
c         jj = MonomerInModel(ii)
c         model(ii)%considerato(1:jj) = 1
c      enddo
c      deallocate( x1, x2, stat = ier4)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine UpdateSol(xopti,fopti,fopti1,iii)
!
      USE General
      USE Symmetry
      USE Riflessi
      USE RuotaRiflessi
      USE riflessi_c
      USE Atomi
      USE Molcom
      USE TraslaSolution
      USE RemoModule
      USE PhaseModule
*     USE RfacMatrixModule
      USE Solutions
!
      common /appo_fom/ prt_fom(5), Rota_Fom
!
!
!-- memorizza i nuovi parametri e funzione costo nella lista
!
      dimension xopti(6)
      dimension b(3,3),x1(3),x2(3),btra(3,3)
!
!-- posiziono il modello in funzione dei nuovi parametri
!
      natsSav = nats
      nats    = natsMR
c      do ii=1, numbModels
c         jj = MonomerInModel(ii)
c         model(ii)%considerato(1:jj) = 0
c     enddo
c      model(WhichModel)%considerato(1) = 1
!
      tet1 = xopti(1)
      tet2 = xopti(2)
      tet3 = xopti(3)
      call RotationOper1(b,tet1,tet2,tet3)
!
      do i=1,3
           do j=1,3
              btra(i,j) = b(j,i)
         enddo
      enddo
      do j=1, MonomerInModel(WhichModel)
         if (model(WhichModel)%considerato(j) == 0) cycle
         do i=1, natsInModel(WhichModel)
            x1(1:3) = model(WhichModel)%saved(1:3,i,j)
            call MoltMatVec(rm, x1, x2)
            call MoltMatVec(btra, x2, x1)
            call MoltMatVec(rmi, x1, x2)
            model(WhichModel)%atoms(1:3,i,j) = x2(1:3) + xopti(4:6)
         enddo
      enddo

c
c--calcolo rigoroso, ma lento   
c     iCoeff = 0
c     mode = 1
c     iref = 0
c     call sftryyyRemo(nrefl,scalan,iCoeff)
c--calcolo approssimato, ma veloce   
      call ChemInfo_MR_Final()
      call NewInv_MR_Final()
*     call F2ENew(1, nrefl)
      call F2E_MR
      do io=1, nreflSelTra
         j = k_mem1(io)
         RpMat(iii,io) = fcvetv(j)
      enddo
      if (knw > 0) then
          nbru = TraAll(WhichSolution)%trial
          izero = 0
          ifmin = 0
          call examin(nbru,mkang,khl,ipub,iphaz,nrefl,
     *                izero,tmpwt,ifmin)
c         write(6,'(a,i8,a,f8.2)') ' MPE su ', isumal, 
c    *          ' riflessi di traslazione ',erore

!         tmpwt(:) = 1.0
!         nbru = TraAll(WhichSolution)%trial
!         izero = 0
!         ifmin = 0
!         call examin(nbru,mkang,khl,ipub,iphaz,nrefl,
!    *                izero,tmpwt,ifmin)
!         write(6,'(a,i8,a,f8.2)') ' MPE su tutti ', isumal, 
!    *          ' riflessi ',erore
      endif
c
      corre=fopti
      corre1=fopti1
!
!--inserisco i parametri
!
c
c--riporto gli angoli nell'intervallo [0,TwoPi]
c
      do i=1,3
        tet=xopti(i)
        if(tet.lt.0.0) tet = tet+TwoPi
        tet = amod(tet, TwoPi)
        xopti(i)=tet
      enddo
c
c--riporto la posizione nella cella
c
      do i=4,6
         pos=xopti(i)
         xopti(i)=side(pos)
      enddo
c
      TraAll(WhichSolution)%RotVal(1:3) = xopti(1:3)
      TraAll(WhichSolution)%TraVal(1:3) = xopti(4:6)
      TraAll(WhichSolution)%LocFom = corre
      TraAll(WhichSolution)%TraFom = corre

      TraAll(WhichSolution)%TFom(1:5) = prt_fom(1:5)

      TraAll(WhichSolution)%TraCorr = corre1
      TraAll(WhichSolution)%MolMPE = erore
!
      if (corre.ge.fomBestE) fomBestE = corre
!
      Buffer16(  1) = TraAll(WhichSolution)%RotFom
      Buffer16(2:4) = TraAll(WhichSolution)%RotVal(1:3)*rtod
      Buffer16(5:7) = TraAll(WhichSolution)%TraVal(1:3)
      Buffer16(  8) = TraAll(WhichSolution)%TraFom
      Buffer16(  9) = TraAll(WhichSolution)%ipunt
      Buffer16(  9) = TraAll(WhichSolution)%trial
      Buffer16( 10) = TraAll(WhichSolution)%MolMPE
      cfom(iii)       = TraAll(WhichSolution)%TraFom  
      ipos(iii)       = iii  
!
      nurec = iii
!
*     RfacMatrix(1,iii,jBlock) = iii
*     RfacMatrix(2,iii,jBlock) = TraAll(WhichSolution)%TraFom
*     RfacMatrix(3,iii,jBlock) = -9999.9    !!!<<<
*     RfacMatrix(4,iii,jBlock) = 100
*     RfacMatrix(5,iii,jBlock) = TraAll(WhichSolution)%MolMPE
*     RfacMatrix(6,iii,jBlock) = TraAll(WhichSolution)%MolMPE
*     RfacMatrix(7,iii,jBlock) = TraAll(WhichSolution)%MolMPE
*     RfacMatrix(8,iii,jBlock) = TraAll(WhichSolution)%TraFom

      nsind = nurec
      fomrt(nsind, 1) = 0
      fomrt(nsind, 2) = 0
      fomrt(nsind, 3) = 0
      fomrt(nsind, 4) = 0
      fomrt(nsind, 5) = Buffer16(  8)
      fomrt(nsind, 6) = 0
      fomrt(nsind, 7) = 0
      fomrt(nsind, 8) = 0
      fomrt(nsind, 9) = 0
      fomrt(nsind,10) = Buffer16(  9)
!
      nats = natsSav
c      do ii=1, numbModels
c         jj = MonomerInModel(ii)
c         model(ii)%considerato(1:jj) = 1
c      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine F2E_MR
      USE General
      USE Symmetry
      USE Atomi, only: nzConst
      USE Riflessi
      USE RemoModule
!
      implicit none
      integer :: i, j, kz, nnww(18)
!
      nnww(:) = nw(:)
      nw(:) = 0
      do i=1, numbModels
         if (model(i)%considerato(1) == 0) cycle
         do j=1, natsInModel(i)
            kz = model(i)%specie(j,1) / nzConst
            nw(kz) = nw(kz) + totop
         enddo
      enddo
      call Normalize(1, fcvet, fcvetv)
      nw(:) = nnww(:)
      return
      end
!-----------------------------------------------------------------------
      subroutine PrintMolRes_New(iact)
!
      USE General
      USE TraslaSolution
      USE Riflessi
      USE RemoModule

      implicit none
      integer :: i, j, iuno, iact, ncont, nstampa

      do j=1,nSolToExplore
         i = TraAll(j)%ipunt
         work4(j)  = TraAll(i)%TraFom
         iwork4(j) = i
*        if (knw > = 0) write(6,*) j, TraAll(j)%ipunt, work4(j)
      enddo
      iuno = -1
      call sortall3(iuno,work4,iuno,nSolToExplore,iwork4)
!-- ripristino TraAll%ipunt (utile dopo ConfrontaSoluzioni)
      ncont = 0 
      do j=1,nSolToExplore
         i = iwork4(j)
         TraAll(j)%ipunt = i
         if (TraAll(i)%TraFom < -99.00) ncont = ncont + 1
      enddo
      nstampa = nSolToExplore - ncont
c
      if (iact == 1) write(lo,30)
      if (iact == 1 ) then
          if (knw > 0) then
              write(lo,5) nSolToExplore0, nSolToExplore
          else
              write(lo,6) nSolToExplore0, nSolToExplore
          endif
          if (knw>0) then
              write(lo,30)
              write(lo,10)
          else
              write(lo,11)
          endif
      elseif (iact ==2) then
          if (knw > 0) then
              write(lo,15) nstampa  !nSolToExplore
              write(lo,30)
              write(lo,20)
          else
*             write(lo,14) nstampa  !nSolToExplore
*             write(lo,21)
          endif
      elseif (iact ==3) then
*         write(lo,16) nstampa  !nSolToExplore
*         write(lo,30)
          if (knw > 0) then
              write(lo,16) nstampa  !nSolToExplore
              write(lo,30)
              write(lo,20)
          else
              write(lo,18)
*             write(lo,21)
          endif
      endif
      do j=1,nSolToExplore
          i = iwork4(j)
c         if(kverbo > 0) then
             if (knw>0) then

                 if (iact == 1) then
                     write(lo,40) 
     &               TraAll(i)%trial,      TraAll(i)%RotVal(1:3)*rtod,
     &               TraAll(i)%TraVal(1:3),TraAll(i)%RotFom,
     &               TraAll(i)%TraFom,     TraAll(i)%MolMPE
                 elseif (iact >= 2 .and. TraAll(i)%TraFom > -99.00) then ! per stampa FOM dopo SIMPLEX
                     write(lo,41) 
     &               TraAll(i)%trial,      TraAll(i)%RotVal(1:3)*rtod,
     &               TraAll(i)%TraVal(1:3),TraAll(i)%RotFom,
     &               TraAll(i)%TFom(1),TraAll(i)%TraFom,TraAll(i)%MolMPE
                 endif

             else

                 if (iact /= 1) go to 99 
                 if (iact == 1) then
                     write(lo,50) 
     &               TraAll(i)%trial,      TraAll(i)%RotVal(1:3)*rtod,
     &               TraAll(i)%TraVal(1:3),TraAll(i)%RotFom,
     &               TraAll(i)%TraFom
                 elseif (iact >= 2 .and. TraAll(i)%TraFom > -99.00) then ! per stampa FOM dopo SIMPLEX
                     write(lo,51) 
     &               TraAll(i)%trial,      TraAll(i)%RotVal(1:3)*rtod,
     &               TraAll(i)%TraVal(1:3),TraAll(i)%RotFom,
     &               TraAll(i)%TFom(1),TraAll(i)%TraFom
                 endif
   99            continue

             endif
c         endif
!
      enddo
      if (iact == 1) write(lo,30)

*     stop 5678
!
      return

    5 format(80('-'),//,
     *    ' Out of',i6,' roto-translation combinations, the following',
     *              i6,' were selected',/,
     *    ' as the most probable. TFom is the figure of merit.')
    6 format(80('-'),//,' TRANSLATION STAGE:',
     *    ' out of',i6,' roto-translation combinations,',/,
     *    ' the following',i6,' were selected',
     *    ' as the most probable.',/,' TFom is the figure of merit.',/)
   10 format('   Trial      RotVal                 TraVal         ',
     *       '  RFom    TFom    MPE')
   11 format('   Trial   Rotation values     Translation values   ',
     *       '  RFom    TFom')
   14 format(80('-'),//, ' OPTIMIZATION STAGE: the following',i5,
     * ' roto-translation combinations ',/,
     * ' were selected after optimization via SIMPLEX method.',/)
   15 format(80('-'),//, ' The following',i5,
     * ' roto-translation combinations were selected',/,
     * ' after optimization stage. TFom is the figure of merit.')
   16 format(80('-'),//, ' The following',i5,
     * ' roto-translation combinations were selected',/,
     * ' after Refmac refinement (FFom).')
   18 format(80('-'),//,
     * ' OPTIMIZATION STAGE: the roto-translation combinations',
     * ' have been selected',/,
     * ' after optimization via SIMPLEX method and Refmac refinement.',/
     *,' FFom is the final figure of merit.')
   20 format('   Trial      RotVal               TraVal        ',
     *       'RFom    TFom    FFom    MPE')
   21 format('   Trial   Rotation values     Translation values   ',
     *       '  RFom    TFom    FFom')
   30 format(80('-'))

   40 format(i8,3f6.1,3f8.3,2f8.3,f8.2)
   41 format(i8,3f6.1,5f7.3,f8.3,f8.2)

   50 format(i8,3f6.1,3f8.3,2f8.3)
   51 format(i8,3f6.1,3f8.3,3f8.3)

      end
!-----------------------------------------------------------------------
      subroutine preLocal()
      USE General
      USE Solutions
      USE Riflessi
      USE riflessi_c
      USE RuotaRiflessi
      USE RemoModule
      USE PhaseModule
!
!-- prepara la minimizzazione locale
!
      call scrper(' ',0,-1)
!
      do ii=1, numbModels
         do j=1, MonomerInModel(ii)
            do i=1, natsInModel(ii)
               model(ii)%atoms(1:3,i,j) = model(ii)%saved(1:3,i,j)
            enddo
         enddo
      enddo
c
c--eventualmente applico la selezione in risoluzione per l'affinamento
c
      return
      end
!-----------------------------------------------------------------------
      subroutine LocalMin(xopti,fopti,single)
c
      USE General
      USE Symmetry
      USE Mappa
      USE RemoModule
c
c--versione per subplex
c

      integer niwmax,nwmax,nxmax
      parameter (niwmax=300,nwmax=300,nxmax=300)
c     parameter (niwmax=6,nwmax=6,nxmax=6)
      dimension xopti(6)
      integer iwork(niwmax),
     *        maxnfe,mdcont,mdsing,mduser,mode,
     *        nf1,nf2,nfe,nfinc,n
      double precision    fx,scale(nxmax),
     *        tol,tol1,tol2,tolfac,work(nwmax),x(nwmax)
c
c subroutines and functions
c
      double precision fun, fun2
      external fun,fun2,subplx
      logical single
!
      logical :: noWrite,plusModel
      integer :: ncount, maxcount
      common /util2/ noWrite, ncount, maxcount,plusModel


      if (WhichModel == 1) then
          if (nsym == 1 .and. icent == 0) then
              ifRotOnly = 1
              xopti(4:6) = 0.0
          endif
      else
          ifRotOnly = 0
      endif


      ncount = 0
      nsubplx = 0
c
c-----------------------------------------------------------
c
c--valori per R
c
c     tol1=0.5
c     tol2=1.e-2
c     tolfac=0.5
c     nf1=100
c     nf2=1000
c     nfinc=100
c     scl=0.1
cc    scale(1) = -abs(scl)
c     scale(1:3) = 0.2
c     scale(4:6) = 0.1
c
c--valori per 1-corre
c
      tol1=0.1!0.25
      tol2=0.001!0.5  ! occhio
cc    tol2=0.10
      tolfac=0.5
      nf1=200!100
      nf2=1000!500
      nfinc=100
c     scl=0.1
c     scale(1:3) = 0.6
c     scale(4:6) = 0.2
c     scale(1:3) = 0.087  ! 5 gradi
c     scale(1:3) = step*1.2 ! quello delle rotazioni
      scale(1:3) = step*5.0 ! quello delle rotazioni
c     scale(4:6) = 0.01
      tol=tol1
      maxnfe=nf1
c     fxold=fopti
c     tolfx=1.e-4
c
c--riprendo i parametri iniziali 
c
c     scale(4:6)=0.0
      x(1:3)= xopti(1:3)
      n=3
      if (ifRotOnly == 0) then
          do j=1,3
c            if(CheCell(j)==0.0) cycle
             n=n+1
             x(n)= xopti(3+j)
             scale(n) = 2.0/float(np(j))
          enddo
      endif
c     write (6,*) 'scale',scale(1:n)
c      write (6,'(a,6f15.6)') 'prim',x(1)*rtod,x(2)*rtod,x(3)*rtod,
c     &           (x(i),i=4,n)
c
c First call to subplx so continuation mode is off.
c
      mdcont = 0
c
c Using default options so user options mode is off.
c
      mduser = 0
c
c Using optimization so single-step mode is off.
c
      mdsing = 0

   20   continue
c
      if(.not.single) then

         call NoBlanks(Inte, k1)
         if(.not.use_pseudo)then
           Msg= 'NCS search for solution ' // Inte(1:k1)//
     *        ': optimizing single monomer position'
         else
           Msg= 'Pseudo-translational search for monomers '
     *         // Inte(1:k1)//
     *        ': optimizing single monomer position'
         endif
         call scrper(Msg,ncount,nf2)
      endif
 
      nsubplx = nsubplx + 1
      call DoSingleIteration()
      mode = 4*mdsing + 2*mduser + mdcont
      if(single) then
         call subplx (fun,n,tol,maxnfe,mode,scale,x,fx,nfe,
     *                     work,iwork,iflag)
      else
         call subplx (fun2,n,tol,maxnfe,mode,scale,x,fx,nfe,
     *                     work,iwork,iflag)
      endif
c
c Print intermediate results.
c
c        write (6,1020) maxnfe,tol,fx,nfe,iflag
1020    format (t5,i6,t15,e10.2,t30,e20.10,t45,
     *          i6,t60,i5)
c
c Check iflag to see if done or which termination
c test needs to be reset before resuming optimization.
        if (iflag .eq. -1) then
          if (maxnfe .ge. nf2) go to 30
          maxnfe = maxnfe+nfinc
        else if (iflag .eq. 0) then
c         if(abs(fx-fxold)<tolfx) then
c              write(6,*) 'tolfx',fx,fxold,fx-fxold
c              go to 30  ! occhio
c         endif
          if (tol .le. tol2) go to 30
          tol = tol*tolfac
c         fxold=fx
        else
          go to 30
        end if
c
c Resume optimization in continuation mode.
c
        mdcont=1
        go to 20
c
c Print optimization results.
c
   30   continue
c       write (6,1025) iflag,flgdsc(iflag)
c1025   format (' iflag =',i3,5x,'(',a26,')')
c       write (6,1030) nfe,fx
c1030   format (/1x,'nfe=',i7,5x,'fx=',e16.8/)
c       write (6,'(a,6f15.6)') 'dopo',x(1)*rtod,x(2)*rtod,x(3)*rtod,
c     &           (x(i),i=4,n)
c
c--prendo i valori ottimizzati
c
      xopti(1:3)=x(1:3)
      n=3
      if (ifRotOnly == 0) then      
         do j=1,3
c           if(CheCell(j)==0.0) cycle
           n=n+1
           xopti(3+j)=x(n)
         enddo
      endif
      fopti=fx
c
      return
      end
c-----------------------------------------------------------------
      subroutine LocalMin_2mon(xopti,fopti)
c
      USE General
      USE Mappa
      USE RemoModule
c
c--versione per subplex
c

      integer niwmax,nwmax,nxmax
      parameter (niwmax=300,nwmax=300,nxmax=300)
      dimension xopti(jMolMR*6)
      integer iwork(niwmax),
     *        maxnfe,mdcont,mdsing,mduser,mode,
     *        nf1,nf2,nfe,nfinc,n
      double precision    fx,scale(nxmax),
     *        tol,tol1,tol2,tolfac,work(nwmax),x(nwmax)
c
c subroutines and functions
c
      double precision fun3, fun4
      external fun3,fun4,subplx
      logical :: noWrite, plusModel
      integer :: ncount, maxcount
      common /util2/ noWrite, ncount, maxcount,plusModel
      character stringa*20

      ncount = 0
      nsubplx = 0

      tol1=0.1!0.25
      tol2=0.001!0.5  ! occhio
      tolfac=0.5
      nf1=200!100
      nf2=1000!500
      nfinc=100
      tol=tol1
      maxnfe=nf1
c
c--riprendo i parametri iniziali 
c
      do i=1,jMolMR
         x(6*i-5:6*i-3) = xopti(6*i-5:6*i-3)
         scale(6*i-5:6*i-3) = step*5.0 
         n=6*i-3
         if (ifRotOnly == 0) then
            do j=1,3
c               if(CheCell(j)==0.0) cycle
               n=n+1
               x(n)= xopti(n)
               scale(n) = 2.0/float(np(j))
            enddo
         endif
      enddo
c     write (6,*) 'scale',scale(1:n)
c      write (6,'(a,6f15.6)') 'prim',x(1)*rtod,x(2)*rtod,x(3)*rtod,
c     &           (x(i),i=4,n)
c
c First call to subplx so continuation mode is off.
c
      mdcont = 0
c
c Using default options so user options mode is off.
c
      mduser = 0
c
c Using optimization so single-step mode is off.
c
      mdsing = 0

   20   continue
c
        call NoBlanks(Inte, k1)
        write(stringa,'(i10)') jMolMR
        call NoBlanks(stringa,k2)

        if(.not.use_pseudo .and. plusModel)then
          Msg = 'Translation search for model ' // Inte(1:k1)//
     *        ': optimizing all monomers position'
        else if(.not.use_pseudo )then
           Msg = 'NCS search of monomer '//stringa(1:k2)//
     *          ' for solution '// Inte(1:k1)//
     *         ': optimizing all monomers position'
        else  
          Msg='Pseudo-translational search for monomers '//Inte(1:k1)//
     *        ': optimizing all monomer position'
        endif
        call scrper(Msg,ncount,nf2)

        nsubplx = nsubplx + 1
        call DoSingleIteration()
        mode = 4*mdsing + 2*mduser + mdcont
        if(plusModel)then 
           call subplx (fun4,n,tol,maxnfe,mode,scale,x,fx,nfe,
     *                     work,iwork,iflag)
        else
           call subplx (fun3,n,tol,maxnfe,mode,scale,x,fx,nfe,
     *                     work,iwork,iflag)
        endif
c 
c Print intermediate results.
c
c        write (6,1020) maxnfe,tol,fx,nfe,iflag
c1020    format (t5,i6,t15,e10.2,t30,e20.10,t45,
c    *          i6,t60,i5)

c       write (6,1030) nfe,fx
c
c Check iflag to see if done or which termination
c test needs to be reset before resuming optimization.
        if (iflag .eq. -1) then
          if (maxnfe .ge. nf2) go to 30
          maxnfe = maxnfe+nfinc
        else if (iflag .eq. 0) then
c         if(abs(fx-fxold)<tolfx) then
c              write(6,*) 'tolfx',fx,fxold,fx-fxold
c              go to 30  ! occhio
c         endif
          if (tol .le. tol2) go to 30
          tol = tol*tolfac
c         fxold=fx
        else
          go to 30
        end if
c
c Resume optimization in continuation mode.
c
        mdcont=1
        go to 20
c
c Print optimization results.
c
   30   continue
c       write (6,1025) iflag,flgdsc(iflag)
c1025   format (' iflag =',i3,5x,'(',a26,')')
c       write (6,1030) nfe,fx
c1030   format (/1x,'nfe=',i7,5x,'fx=',e16.8/)
c       write (6,'(a,6f15.6)') 'dopo',x(1)*rtod,x(2)*rtod,x(3)*rtod,
c     &           (x(i),i=4,n)
c
c--prendo i valori ottimizzati
c
      do i=1,jMolMR
         xopti(6*i-5:6*i-3) = x(6*i-5:6*i-3)
         n=6*i-3
         if (ifRotOnly == 0) then
            do j=1,3
c               if(CheCell(j)==0.0) cycle
               n=n+1
               xopti(n)= x(n)
            enddo
         endif
      enddo

      fopti=fx
c
      return
      end
c-----------------------------------------------------------------
      double precision function fun3(n,x)
c
      USE General
      USE Atomi
      USE Molcom
      USE Mappa
      USE Riflessi
      USE RuotaRiflessi
      USE RemoModule
      USE PhaseModule
      USE riflessi_c 
!
      integer n
      double precision  x(n)
      real, allocatable :: x1(:), x2(:)
      real b(3,3),btra(3,3)
      character stringa*20
      logical :: noWrite,plusModel
      integer :: ncount, maxcount
      common /util2/ noWrite, ncount, maxcount,plusModel
      
      ncount = ncount + 1
c      write(6,*)'ncount',ncount,maxcount
c      call NoBlanks(Inte, k1)
c      write(stringa,'(i10)') jMolMR
c      call NoBlanks(stringa,k2)
c      if(.not.plusModel .and. .not.use_pseudo)then
c         Msg = 'NCS search of monomer '//stringa(1:k2)//' for solution '
c     *          // Inte(1:k1)//
c     *         ': optimizing position all monomers'
c      else if (.not.use_pseudo)then
c         Msg = 'Translation search for model ' // Inte(1:k1)//
c     *        ': optimizing position all monomers'
c      else 
c          Msg='Pseudo-translational search for monomers '// Inte(1:k1)//
c     *        ': optimizing position all monomers'
c      endif

c      call scrper(Msg,ncount,maxcount)


      allocate(x1(1:3*jMolMR), stat = ier2)
      allocate(x2(1:3*jMolMR), stat = ier3)

c
c--posiziono il modello in funzione dei nuovi parametri 
c
      do jj=1, jMolMR

c        if (model(WhichModel)%considerato(jj) == 0) cycle
         n_index = 6 * (jj-1) 
         tet1 = x(n_index+1)
         tet2 = x(n_index+2)
         tet3 = x(n_index+3)
         call RotationOper1(b,tet1,tet2,tet3)
c
         do i=1,3
            do j=1,3
               btra(i,j) = b(j,i)
            enddo
         enddo
         do i = 1, natsMR
            x1(1:3) = model(WhichModel)%saved(1:3,i,jj)
            call MoltMatVec(rm, x1, x2)
            call MoltMatVec(btra, x2, x1)
            call MoltMatVec(rmi, x1, x2)
            model(WhichModel)%atoms(1:3,i,jj) = x2(1:3) 
            if (ifRotOnly == 0) then      
               icont=6*(jj-1) + 3
               do j=1,3
c                  if(CheCell(j)==0.0) cycle
                  icont=icont+1
                  model(WhichModel)%atoms(j,i,jj) = 
     *                 model(WhichModel)%atoms(j,i,jj) + x(icont)
               enddo
            endif
         enddo
      enddo
c--calcolo i nuovi fattori di struttura
c
c
c--calcolo classico 
c
c      call sftrNewLocal(corre) ! occhio
c
c--calcolo con FFT
c
      badd = 0.0
      call ChemInfo_MR_Local(badd)
      call NewInv_MR_Local()
c
      call cc_vet_mol(corre)
c--stat
c     write(6,*) 'uffa',corre
c--stat
c
      fun3 = corre
c      write(97,'(3f12.3,4f12.4)') x(1)*57.3,x(2)*57.3,x(3)*57.3,
c     &                       x(4:6),corre
c
      deallocate( x1, x2, stat = ier4)
      return
      end
c-----------------------------------------------------------------
      double precision function fun4(n,x)
c
      USE General
      USE Atomi
      USE Molcom
      USE Mappa
      USE Riflessi
      USE RuotaRiflessi
      USE RemoModule
      USE PhaseModule
      USE riflessi_c 
!
      integer n
      double precision  x(n)
      real, allocatable :: x1(:), x2(:)
      real b(3,3),btra(3,3)

      logical :: noWrite,plusModel
      integer :: ncount, maxcount
      common /util2/ noWrite, ncount, maxcount,plusModel

      ncount = ncount + 1
c      write(6,*)'ncount',ncount,maxcount
c      call NoBlanks(Inte, k1)
c      if(.not.use_pseudo)then
c         Msg= 'NCS search for solution ' // Inte(1:k1)//
c     *        ': optimizing position all monomers'
c      else
c          Msg='Pseudo-translational search for monomers '// Inte(1:k1)//
c     *        ': optimizing position all monomers'
c      endif
c      call scrper(Msg,ncount,maxcount)


      allocate(x1(1:3*jMolMR), stat = ier2)
      allocate(x2(1:3*jMolMR), stat = ier3)

c
c--posiziono il modello in funzione dei nuovi parametri 
c
      jj = 0
      do ii=1, WhichModel
         do j=1, MonomerInModel(ii)
            if (model(ii)%considerato(j) == 0) cycle
            jj = jj + 1
            n_index = 6 * (jj-1) 
            tet1 = x(n_index+1)
            tet2 = x(n_index+2)
            tet3 = x(n_index+3)
            call RotationOper1(b,tet1,tet2,tet3)
c
            do i=1,3
               do jjj=1,3
                  btra(i,jjj) = b(jjj,i)
               enddo
            enddo
            do i = 1, natsInModel(ii)
               x1(1:3) = model(ii)%saved(1:3,i,j)
               call MoltMatVec(rm, x1, x2)
               call MoltMatVec(btra, x2, x1)
               call MoltMatVec(rmi, x1, x2)
               model(ii)%atoms(1:3,i,j) = x2(1:3) 
               if (ifRotOnly == 0) then      
                  icont=6*(jj-1) + 3
                  do j1=1,3
c                    if(CheCell(j)==0.0) cycle
                     icont=icont+1
                     model(ii)%atoms(j1,i,j) = 
     *               model(ii)%atoms(j1,i,j) + x(icont)
                  enddo
               endif
            enddo
         enddo
      enddo
c--calcolo i nuovi fattori di struttura
c
c
c--calcolo classico 
c
c      call sftrNewLocal(corre) ! occhio
c
c--calcolo con FFT
c
      badd = 0.0
      call ChemInfo_MR_Local(badd)
      call NewInv_MR_Local()
c
      call cc_vet_mol(corre)
c--stat
c     write(6,*) 'uffa',corre
c--stat
c
      fun4 = corre
c      write(97,'(3f12.3,4f12.4)') x(1)*57.3,x(2)*57.3,x(3)*57.3,
c     &                       x(4:6),corre
c
      deallocate( x1, x2, stat = ier4)
      return
      end
c-----------------------------------------------------------------
      double precision function fun(n,x)
c
      USE General
      USE Atomi
      USE Molcom
      USE Mappa
      USE Riflessi
      USE RuotaRiflessi
      USE RemoModule
      USE PhaseModule
      USE riflessi_c 
!
      integer n
      double precision x(n)
      dimension b(3,3),x1(3),x2(3),btra(3,3)
      
c
c--posiziono il modello in funzione dei nuovi parametri 
c
      tet1 = x(1)
      tet2 = x(2)
      tet3 = x(3)
      call RotationOper1(b,tet1,tet2,tet3)
c
      do i=1,3
        do j=1,3
            btra(i,j) = b(j,i)
         enddo
      enddo
!
      do ii=1, numbModels
         do j=1, MonomerInModel(ii)
            if (model(ii)%considerato(j) == 0) cycle
            do i = 1, natsMR
               x1(1:3) = model(WhichModel)%saved(1:3,i,j)
               call MoltMatVec(rm, x1, x2)
               call MoltMatVec(btra, x2, x1)
               call MoltMatVec(rmi, x1, x2)
               model(WhichModel)%atoms(1:3,i,j) = x2(1:3) 
               if (ifRotOnly == 0) then      
                  icont=3
                  do jj=1,3
c                     if(CheCell(jj)==0.0) cycle
                     icont=icont+1
                     model(WhichModel)%atoms(jj,i,j) = 
     *                    model(WhichModel)%atoms(jj,i,j) + x(icont)
                  enddo
               endif
            enddo
         enddo
      enddo
c--calcolo i nuovi fattori di struttura
c
c
c--calcolo classico 
c
c      call sftrNewLocal(corre) ! occhio
c
c--calcolo con FFT
c
      badd = 0.0
      call ChemInfo_MR_Local(badd)
      call NewInv_MR_Local()
c
      call cc_vet_mol(corre)
c--stat
c     write(6,*) 'uffa',corre
c--stat
c
      fun = corre
c      write(97,'(3f12.3,4f12.4)') x(1)*57.3,x(2)*57.3,x(3)*57.3,
c     &                       x(4:6),corre
c
      return
      end
c----------------------------------------------------------------
      double precision function fun2(n,x)
c
      USE General
      USE Atomi
      USE Molcom
      USE Mappa
      USE Riflessi
      USE RuotaRiflessi
      USE RemoModule
      USE PhaseModule
      USE riflessi_c 
!
      integer n
      double precision x(n)
      dimension b(3,3),x1(3),x2(3),btra(3,3)

      logical :: noWrite,plusModel
      integer :: ncount, maxcount
      common /util2/ noWrite, ncount, maxcount,plusModel

      ncount = ncount + 1
c      write(6,*)'ncount',ncount,maxcount
c
c--posiziono il modello in funzione dei nuovi parametri 
c
      tet1 = x(1)
      tet2 = x(2)
      tet3 = x(3)
      call RotationOper1(b,tet1,tet2,tet3)
c
      do i=1,3
        do j=1,3
            btra(i,j) = b(j,i)
         enddo
      enddo
!
      do i = 1,  natsInModel(WhichModel)
         x1(1:3) = model(WhichModel)%saved(1:3,i,jMolMR)
         call MoltMatVec(rm, x1, x2)
         call MoltMatVec(btra, x2, x1)
         call MoltMatVec(rmi, x1, x2)
         model(WhichModel)%atoms(1:3,i,jMolMR) = x2(1:3) 
         if (ifRotOnly == 0) then      
            icont=3
            do jj=1,3
c               if(CheCell(jj)==0.0) cycle
                 icont=icont+1
                 model(WhichModel)%atoms(jj,i,jMolMR) = 
     *                model(WhichModel)%atoms(jj,i,jMolMR) + x(icont)
            enddo
         endif
      enddo


      badd = 0.0
      call ChemInfo_MR_Local(badd)
      call NewInv_MR_Local()
c
      call cc_vet_mol(corre)
c--stat

c
      fun2 = corre
c      write(97,'(3f12.3,4f12.4)') x(1)*57.3,x(2)*57.3,x(3)*57.3,
c     &                       x(4:6),corre
c
      return
      end
c----------------------------------------------------------------
c   subplex optimization program
c----------------------------------------------------------------
c coded by
c
c Tom Rowan
c Oak Ridge National Laboratory
c Mathematical Sciences Section
c P.O. Box 2008, Bldg. 6012
c Oak Ridge, TN 37831-6367
c
c Phone: (615) 574-3131
c Email: na.rowan@na-net.ornl.gov
c This program uses subplx to minimize the function fun.
c
c constants
c     See subplx comments for storage requirements.
c
c
      subroutine calcc (ns,s,ih,inew,updatc,c)
c
      integer ns,ih,inew
      double precision s(ns,ns+3),c(ns)
      logical updatc
c
c                                         Coded by Tom Rowan
c                            Department of Computer Sciences
c                              University of Texas at Austin
c
c calcc calculates the centroid of the simplex without the
c vertex with highest function value.
c
c input
c
c   ns     - subspace dimension
c
c   s      - double precision work space of dimension .ge.
c            ns*(ns+3) used to store simplex
c
c   ih     - index to vertex with highest function value
c
c   inew   - index to new point
c
c   updatc - logical switch
c            = .true.  : update centroid
c            = .false. : calculate centroid from scratch
c
c   c      - centroid of the simplex without vertex with
c            highest function value
c
c output
c
c   c      - new centroid
c
c local variables
c
      integer i,j
      double precision zeroD(1)
c
c subroutines and functions
c
c   blas
      external daxpyRemo,dcopyRemo,dscalRemo
c
c-----------------------------------------------------------
c
      zeroD = 0.0
      if (updatc) then
        if (ih .eq. inew) return
        do 10 i = 1,ns
          c(i) = c(i)+(s(i,inew)-s(i,ih))/ns
   10   continue
      else
        call dcopyRemo (ns,zeroD,0,c,1)
        do 20 j = 1,ns+1
          if (j .ne. ih) call daxpyRemo (ns,1.d0,s(1,j),1,c,1)
   20   continue
        call dscalRemo (ns,1.d0/ns,c,1)
      end if
      return
      end
      double precision function dasumRemo(n,dx,incx)
c
c     takes the sum of the absolute values.
c     uses unrolled loops for increment equal to one.
c     jack dongarra, linpack, 3/11/78.
c     modified to correct problem with negative increment, 8/21/90.
c
      double precision dx(n),dtemp
!!mr      double precision dx(1),dtemp
      integer i,incx,ix,m,mp1,n
c
      dasumRemo = 0.0d0
      dtemp = 0.0d0
      if(n.le.0)return
      if(incx.eq.1)go to 20
c
c        code for increment not equal to 1
c
      ix = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      do 10 i = 1,n
        dtemp = dtemp + dabs(dx(ix))
        ix = ix + incx
   10 continue
      dasumRemo = dtemp
      return
c
c        code for increment equal to 1
c
c
c        clean-up loop
c
   20 m = mod(n,6)
      if( m .eq. 0 ) go to 40
      do 30 i = 1,m
        dtemp = dtemp + dabs(dx(i))
   30 continue
      if( n .lt. 6 ) go to 60
   40 mp1 = m + 1
      do 50 i = mp1,n,6
        dtemp = dtemp + dabs(dx(i)) + dabs(dx(i + 1)) + dabs(dx(i + 2))
     *  + dabs(dx(i + 3)) + dabs(dx(i + 4)) + dabs(dx(i + 5))
   50 continue
   60 dasumRemo = dtemp
      return
      end
      subroutine daxpyRemo(n,da,dx,incx,dy,incy)
c
c     constant times a vector plus a vector.
c     uses unrolled loops for increments equal to one.
c     jack dongarra, linpack, 3/11/78.
c
      double precision dx(n),dy(n),da
!mr      double precision dx(1),dy(1),da
      integer i,incx,incy,ix,iy,m,mp1,n
c
      if(n.le.0)return
      if (da .eq. 0.0d0) return
      if(incx.eq.1.and.incy.eq.1)go to 20
c
c        code for unequal increments or equal increments
c          not equal to 1
c
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1,n
        dy(iy) = dy(iy) + da*dx(ix)
        ix = ix + incx
        iy = iy + incy
   10 continue
      return
c
c        code for both increments equal to 1
c
c
c        clean-up loop
c
   20 m = mod(n,4)
      if( m .eq. 0 ) go to 40
      do 30 i = 1,m
        dy(i) = dy(i) + da*dx(i)
   30 continue
      if( n .lt. 4 ) return
   40 mp1 = m + 1
      do 50 i = mp1,n,4
        dy(i) = dy(i) + da*dx(i)
        dy(i + 1) = dy(i + 1) + da*dx(i + 1)
        dy(i + 2) = dy(i + 2) + da*dx(i + 2)
        dy(i + 3) = dy(i + 3) + da*dx(i + 3)
   50 continue
      return
      end
      subroutine dcopyRemo(n,dx,incx,dy,incy)
c
c     copies a vector, x, to a vector, y.
c     uses unrolled loops for increments equal to one.
c     jack dongarra, linpack, 3/11/78.
c
      double precision dx(n),dy(n)
      integer i,incx,incy,ix,iy,m,mp1,n
c
      if(n.le.0)return
      if(incx.eq.1.and.incy.eq.1)go to 20
c
c        code for unequal increments or equal increments
c          not equal to 1
c
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1,n
        dy(iy) = dx(ix)
        ix = ix + incx
        iy = iy + incy
   10 continue
      return
c
c        code for both increments equal to 1
c
c
c        clean-up loop
c
   20 m = mod(n,7)
      if( m .eq. 0 ) go to 40
      do 30 i = 1,m
        dy(i) = dx(i)
   30 continue
      if( n .lt. 7 ) return
   40 mp1 = m + 1
      do 50 i = mp1,n,7
        dy(i) = dx(i)
        dy(i + 1) = dx(i + 1)
        dy(i + 2) = dx(i + 2)
        dy(i + 3) = dx(i + 3)
        dy(i + 4) = dx(i + 4)
        dy(i + 5) = dx(i + 5)
        dy(i + 6) = dx(i + 6)
   50 continue
      return
      end
      double precision function dist (n,x,y)
c
      integer n
      double precision x(n),y(n)
c
c                                         Coded by Tom Rowan
c                            Department of Computer Sciences
c                              University of Texas at Austin
c
c dist calculates the distance between the points x,y.
c
c input
c
c   n      - number of components
c
c   x      - point in n-space
c
c   y      - point in n-space
c
c local variables
c
      integer i
      double precision absxmy,scale,sum
c
c subroutines and functions
c
c   fortran
      intrinsic abs,sqrt
c
c-----------------------------------------------------------
c
      absxmy = abs(x(1)-y(1))
      if (absxmy .le. 1.d0) then
        sum = absxmy*absxmy
        scale = 1.d0
      else
        sum = 1.d0
        scale = absxmy
      end if
      do 10 i = 2,n
        absxmy = abs(x(i)-y(i))
        if (absxmy .le. scale) then
          sum = sum+(absxmy/scale)**2
        else
          sum = 1.d0+sum*(scale/absxmy)**2
          scale = absxmy
        end if
   10 continue
      dist = scale*sqrt(sum)
      return
      end
      subroutine  dscalRemo(n,da,dx,incx)
c
c     scales a vector by a constant.
c     uses unrolled loops for increment equal to one.
c     jack dongarra, linpack, 3/11/78.
c     modified to correct problem with negative increment, 8/21/90.
c
      double precision da,dx(n)
!!mr      double precision da,dx(1)
      integer i,incx,ix,m,mp1,n
c
      if(n.le.0)return
      if(incx.eq.1)go to 20
c
c        code for increment not equal to 1
c
      ix = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      do 10 i = 1,n
        dx(ix) = da*dx(ix)
        ix = ix + incx
   10 continue
      return
c
c        code for increment equal to 1
c
c
c        clean-up loop
c
   20 m = mod(n,5)
      if( m .eq. 0 ) go to 40
      do 30 i = 1,m
        dx(i) = da*dx(i)
   30 continue
      if( n .lt. 5 ) return
   40 mp1 = m + 1
      do 50 i = mp1,n,5
        dx(i) = da*dx(i)
        dx(i + 1) = da*dx(i + 1)
        dx(i + 2) = da*dx(i + 2)
        dx(i + 3) = da*dx(i + 3)
        dx(i + 4) = da*dx(i + 4)
   50 continue
      return
      end
      subroutine evalf (f,ns,ips,xs,n,x,sfx,nfe)
c
      integer ns,n,nfe
      integer ips(*)
      double precision f,xs(*),x(n),sfx
c
c                                         Coded by Tom Rowan
c                            Department of Computer Sciences
c                              University of Texas at Austin
c
c evalf evaluates the function f at a point defined by x
c with ns of its components replaced by those in xs.
c
c input
c
c   f      - user supplied function f(n,x) to be optimized
c
c   ns     - subspace dimension
c
c   ips    - permutation vector
c
c   xs     - double precision ns-vector to be mapped to x
c
c   n      - problem dimension
c
c   x      - double precision n-vector
c
c   nfe    - number of function evaluations
c
c output
c
c   sfx    - signed value of f evaluated at x
c
c   nfe    - incremented number of function evaluations
c
c common
c
      integer nsmin,nsmax,irepl,ifxsw,nfstop,nfxe
      double precision alpha,beta,gamma,delta,psi,omega,
     *     bonus,fstop,fxstat,ftest
      logical minf,initx,newx
c
      common /usubc/ alpha,beta,gamma,delta,psi,omega,nsmin,
     *               nsmax,irepl,ifxsw,bonus,fstop,nfstop,
     *               nfxe,fxstat(4),ftest,minf,initx,newx
c
      double precision fbonus,sfstop,sfbest
      logical new
c
      common /isubc/ fbonus,sfstop,sfbest,new
c
c local variables
c
      integer i
      double precision fx
      logical newbst
c
      save
c
c subroutines and functions
c
      external f,fstats
c
c-----------------------------------------------------------
c

      do 10 i = 1,ns
        x(ips(i)) = xs(i)
   10 continue
      newx = new .or. irepl .ne. 2
      fx = f(n,x)
      if (irepl .eq. 0) then
        if (minf) then
          sfx = fx
        else
          sfx = -fx
        end if
      else if (new) then
        if (minf) then
          sfx = fx
          newbst = fx .lt. ftest
        else
          sfx = -fx
          newbst = fx .gt. ftest
        end if
        if (initx .or. newbst) then
          if (irepl .eq. 1) call fstats (fx,1,.true.)
          ftest = fx
          sfbest = sfx
        end if
      else
        if (irepl .eq. 1) then
          call fstats (fx,1,.false.)
          fx = fxstat(ifxsw)
        end if
        ftest = fx+fbonus*fxstat(4)
        if (minf) then
          sfx = ftest
          sfbest = fx
        else
          sfx = -ftest
          sfbest = -fx
        end if
      end if
      nfe = nfe+1
      return
      end
      subroutine fstats (fx,ifxwt,reset)
c
      integer ifxwt
      double precision fx
      logical reset
c
c                                         Coded by Tom Rowan
c                            Department of Computer Sciences
c                              University of Texas at Austin
c
c fstats modifies the common /usubc/ variables nfxe,fxstat.
c
c input
c
c   fx     - most recent evaluation of f at best x
c
c   ifxwt  - integer weight for fx
c
c   reset  - logical switch
c            = .true.  : initialize nfxe,fxstat
c            = .false. : update nfxe,fxstat
c
c common
c
      integer nsmin,nsmax,irepl,ifxsw,nfstop,nfxe
      double precision alpha,beta,gamma,delta,psi,omega,
     *     bonus,fstop,fxstat,ftest
      logical minf,initx,newx
c
      common /usubc/ alpha,beta,gamma,delta,psi,omega,nsmin,
     *               nsmax,irepl,ifxsw,bonus,fstop,nfstop,
     *               nfxe,fxstat(4),ftest,minf,initx,newx
c
c local variables
c
      integer nsv
      double precision fscale,f1sv
c
      save
c
c subroutines and functions
c
c   fortran
      intrinsic abs,max,min,sqrt
c
c-----------------------------------------------------------
c
      if (reset) then
        nfxe = ifxwt
        fxstat(1) = fx
        fxstat(2) = fx
        fxstat(3) = fx
        fxstat(4) = 0.d0
      else
        nsv = nfxe
        f1sv = fxstat(1)
        nfxe = nfxe+ifxwt
        fxstat(1) = fxstat(1)+ifxwt*(fx-fxstat(1))/nfxe
        fxstat(2) = max(fxstat(2),fx)
        fxstat(3) = min(fxstat(3),fx)
        fscale = max(abs(fxstat(2)),abs(fxstat(3)),1.d0)
        fxstat(4) = fscale*sqrt((
     *              (nsv-1)*(fxstat(4)/fscale)**2+
     *              nsv*((fxstat(1)-f1sv)/fscale)**2+
     *              ifxwt*((fx-fxstat(1))/fscale)**2)
     *              /(nfxe-1))
      end if
      return
      end
      subroutine newpt (ns,coef,xbase,xold,new,xnew,small)
c
      integer ns
      double precision coef,xbase(ns),xold(ns),xnew(*)
      logical new,small
c
c                                         Coded by Tom Rowan
c                            Department of Computer Sciences
c                              University of Texas at Austin
c
c newpt performs reflections, expansions, contractions, and
c shrinkages (massive contractions) by computing:
c
c xbase + coef * (xbase - xold)
c
c The result is stored in xnew if new .eq. .true.,
c in xold otherwise.
c
c use :  coef .gt. 0 to reflect
c        coef .lt. 0 to expand, contract, or shrink
c
c input
c
c   ns     - number of components (subspace dimension)
c
c   coef   - one of four simplex method coefficients
c
c   xbase  - double precision ns-vector representing base
c            point
c
c   xold   - double precision ns-vector representing old
c            point
c
c   new    - logical switch
c            = .true.  : store result in xnew
c            = .false. : store result in xold, xnew is not
c                        referenced
c
c output
c
c   xold   - unchanged if new .eq. .true., contains new
c            point otherwise
c
c   xnew   - double precision ns-vector representing new
c            point if  new .eq. .true., not referenced
c            otherwise
c
c   small  - logical flag
c            = .true.  : coincident points
c            = .false. : otherwise
c
c local variables
c
      integer i
      double precision xoldi
      logical eqbase,eqold
c
c subroutines and functions
c
c   fortran
      intrinsic dble
c
c-----------------------------------------------------------
c
      eqbase = .true.
      eqold = .true.
      if (new) then
        do 10 i = 1,ns
          xnew(i) = xbase(i)+coef*(xbase(i)-xold(i))
          eqbase = eqbase .and.
     *             (dble(xnew(i)) .eq. dble(xbase(i)))
          eqold = eqold .and.
     *            (dble(xnew(i)) .eq. dble(xold(i)))
   10   continue
      else
        do 20 i = 1,ns
          xoldi = xold(i)
          xold(i) = xbase(i)+coef*(xbase(i)-xold(i))
          eqbase = eqbase .and.
     *             (dble(xold(i)) .eq. dble(xbase(i)))
          eqold = eqold .and.
     *            (dble(xold(i)) .eq. dble(xoldi))
   20   continue
      end if
      small = eqbase .or. eqold
      return
      end
      subroutine order (npts,fs,il,is,ih)
c
      integer npts,il,is,ih
      double precision fs(npts)
c
c                                         Coded by Tom Rowan
c                            Department of Computer Sciences
c                              University of Texas at Austin
c
c order determines the indices of the vertices with the
c lowest, second highest, and highest function values.
c
c input
c
c   npts   - number of points in simplex
c
c   fs     - double precision vector of function values of
c            simplex
c
c   il     - index to vertex with lowest function value
c
c output
c
c   il     - new index to vertex with lowest function value
c
c   is     - new index to vertex with second highest
c            function value
c
c   ih     - new index to vertex with highest function value
c
c local variables
c
      integer i,il0,j
c
c subroutines and functions
c
c   fortran
      intrinsic mod
c
c-----------------------------------------------------------
c
      il0 = il
      j = mod(il0,npts)+1
      if (fs(j) .ge. fs(il)) then
        ih = j
        is = il0
      else
        ih = il0
        is = j
        il = j
      end if
      do 10 i = il0+1,il0+npts-2
        j = mod(i,npts)+1
        if (fs(j) .ge. fs(ih)) then
          is = ih
          ih = j
        else if (fs(j) .gt. fs(is)) then
          is = j
        else if (fs(j) .lt. fs(il)) then
          il = j
        end if
   10 continue
      return
      end
      subroutine partx (n,ip,absdx,nsubs,nsvals)
c
      integer n,nsubs,nsvals(*)
      integer ip(n)
      double precision absdx(n)
c
c                                         Coded by Tom Rowan
c                            Department of Computer Sciences
c                              University of Texas at Austin
c
c partx partitions the vector x by grouping components of
c similar magnitude of change.
c
c input
c
c   n      - number of components (problem dimension)
c
c   ip     - permutation vector
c
c   absdx  - vector of magnitude of change in x
c
c   nsvals - integer array dimensioned .ge. int(n/nsmin)
c
c output
c
c   nsubs  - number of subspaces
c
c   nsvals - integer array of subspace dimensions
c
c common
c
      integer nsmin,nsmax,irepl,ifxsw,nfstop,nfxe
      double precision alpha,beta,gamma,delta,psi,omega,
     *     bonus,fstop,fxstat,ftest
      logical minf,initx,newx
c
      common /usubc/ alpha,beta,gamma,delta,psi,omega,nsmin,
     *               nsmax,irepl,ifxsw,bonus,fstop,nfstop,
     *               nfxe,fxstat(4),ftest,minf,initx,newx
c
c local variables
c
      integer i,nleft,ns1,ns2,nused
      double precision asleft,as1,as1max,as2,gap,gapmax
c
      save
c
c subroutines and functions
c
c   fortran
      intrinsic min
c
c-----------------------------------------------------------
c
      nsubs = 0
      nused = 0
      nleft = n
      asleft = absdx(1)
      do 10 i = 2,n
        asleft = asleft+absdx(i)
   10 continue
   20 continue
      if (nused .lt. n) then
        nsubs = nsubs+1
        as1 = 0.d0
        do 30 i = 1,nsmin-1
          as1 = as1+absdx(ip(nused+i))
   30   continue
        gapmax = -1.d0
        do 40 ns1 = nsmin,min(nsmax,nleft)
          as1 = as1+absdx(ip(nused+ns1))
          ns2 = nleft-ns1
          if (ns2 .gt. 0) then
            if (ns2 .ge. ((ns2-1)/nsmax+1)*nsmin) then
              as2 = asleft-as1
              gap = as1/ns1-as2/ns2
              if (gap .gt. gapmax) then
                gapmax = gap
                nsvals(nsubs) = ns1
                as1max = as1
              end if
            end if
          else
            if (as1/ns1 .gt. gapmax) then
              nsvals(nsubs) = ns1
              return
            end if
          end if
   40   continue
        nused = nused+nsvals(nsubs)
        nleft = n-nused
        asleft = asleft-as1max
        go to 20
      end if
      return
      end
      subroutine setstp (nsubs,n,deltax,step)
c
      integer nsubs,n
      double precision deltax(n),step(n)
c
c                                         Coded by Tom Rowan
c                            Department of Computer Sciences
c                              University of Texas at Austin
c
c setstp sets the stepsizes for the corresponding components
c of the solution vector.
c
c input
c
c   nsubs  - number of subspaces
c
c   n      - number of components (problem dimension)
c
c   deltax - vector of change in solution vector
c
c   step   - stepsizes for corresponding components of
c            solution vector
c
c output
c
c   step   - new stepsizes
c
c common
c
      integer nsmin,nsmax,irepl,ifxsw,nfstop,nfxe
      double precision alpha,beta,gamma,delta,psi,omega,
     *     bonus,fstop,fxstat,ftest
      logical minf,initx,newx
c
      common /usubc/ alpha,beta,gamma,delta,psi,omega,nsmin,
     *               nsmax,irepl,ifxsw,bonus,fstop,nfstop,
     *               nfxe,fxstat(4),ftest,minf,initx,newx
c
c local variables
c
      integer i
      double precision dasumRemo,stpfac
c
      save
c
c subroutines and functions
c
c   blas
      external dasumRemo,dscalRemo
c   fortran
      intrinsic max,min,sign
c
c-----------------------------------------------------------
c
c     set new step
c
      if (nsubs .gt. 1) then
        stpfac = min(max(dasumRemo(n,deltax,1)/dasumRemo(n,step,1),
     *           omega),1.d0/omega)
      else
        stpfac = psi
      end if
      call dscalRemo (n,stpfac,step,1)
c
c     reorient simplex
c
      do 10 i = 1,n
        if (deltax(i) .ne. 0.) then
          step(i) = sign(step(i),deltax(i))
        else
          step(i) = -step(i)
        end if
   10 continue
      return
      end
      subroutine simplx (f,n,step,ns,ips,maxnfe,cmode,x,fx,
     *                   nfe,s,fs,iflag)
c
      integer n,ns,maxnfe,nfe,iflag
      integer ips(ns)
      double precision f,step(n),x(n),fx,s(ns,ns+3),fs(ns+1)
      logical cmode
c
c                                         Coded by Tom Rowan
c                            Department of Computer Sciences
c                              University of Texas at Austin
c
c simplx uses the Nelder-Mead simplex method to minimize the
c function f on a subspace.
c
c input
c
c   f      - function to be minimized, declared external in
c            calling routine
c
c   n      - problem dimension
c
c   step   - stepsizes for corresponding components of x
c
c   ns     - subspace dimension
c
c   ips    - permutation vector
c
c   maxnfe - maximum number of function evaluations
c
c   cmode  - logical switch
c            = .true.  : continuation of previous call
c            = .false. : first call
c
c   x      - starting guess for minimum
c
c   fx     - value of f at x
c
c   nfe    - number of function evaluations
c
c   s      - double precision work array of dimension .ge.
c            ns*(ns+3) used to store simplex
c
c   fs     - double precision work array of dimension .ge.
c            ns+1 used to store function values of simplex
c            vertices
c
c output
c
c   x      - computed minimum
c
c   fx     - value of f at x
c
c   nfe    - incremented number of function evaluations
c
c   iflag  - error flag
c            = -1 : maxnfe exceeded
c            =  0 : simplex reduced by factor of psi
c            =  1 : limit of machine precision
c            =  2 : reached fstop
c
c common
c
      integer nsmin,nsmax,irepl,ifxsw,nfstop,nfxe
      double precision alpha,beta,gamma,delta,psi,omega,
     *     bonus,fstop,fxstat,ftest
      logical minf,initx,newx
c
      common /usubc/ alpha,beta,gamma,delta,psi,omega,nsmin,
     *               nsmax,irepl,ifxsw,bonus,fstop,nfstop,
     *               nfxe,fxstat(4),ftest,minf,initx,newx
c
      double precision fbonus,sfstop,sfbest
      logical new
c
      common /isubc/ fbonus,sfstop,sfbest,new
c
c local variables
c
      integer i,icent,ih,il,inew,is,itemp,j,npts
      double precision dist,dum(1),fc,fe,fr,tol
      logical small,updatc
c
      save
c
c subroutines and functions
c
      external f,calcc,dist,evalf,newpt,order,start
c   blas
      external dcopyRemo
c   fortran
      intrinsic min
c      character*80 Buffer

c
c-----------------------------------------------------------
c
c      Buffer = 'Optimizing solution'
c      call scrper(Buffer,0,0)
c      nperc  = maxnfe
c      iperc0 = nRifDimC / nperc
c      iperc  = iperc0
c      jperc  = 0

      if (cmode) go to 50
      npts = ns+1
      icent = ns+2
      itemp = ns+3
      updatc = .false.
      call start (n,x,step,ns,ips,s,small)
      if (small) then
        iflag = 1
        return
      end if
      if (irepl .gt. 0) then
        new = .false.
        call evalf (f,ns,ips,s(1,1),n,x,fs(1),nfe)
c        jperc = nfe 
c        call scrper(' ',jperc,nperc) 
      else
        fs(1) = fx
      end if
      new = .true.
      do 10 j = 2,npts
        call evalf (f,ns,ips,s(1,j),n,x,fs(j),nfe)
c        jperc = nfe 
c        call scrper(' ',jperc,nperc)
   10 continue
      il = 1
      call order (npts,fs,il,is,ih)
      tol = psi*dist(ns,s(1,ih),s(1,il))
c
c     main loop
c
   20 continue
        call calcc (ns,s,ih,inew,updatc,s(1,icent))
        updatc = .true.
        inew = ih
c
c       reflect
c
        call newpt (ns,alpha,s(1,icent),s(1,ih),.true.,
     *              s(1,itemp),small)
        if (small) go to 40
        call evalf (f,ns,ips,s(1,itemp),n,x,fr,nfe)
c        jperc = nfe 
c        call scrper(' ',jperc,nperc)
        if (fr .lt. fs(il)) then
c
c         expand
c
          call newpt (ns,-gamma,s(1,icent),s(1,itemp),
     *                .true.,s(1,ih),small)
          if (small) go to 40
          call evalf (f,ns,ips,s(1,ih),n,x,fe,nfe)
c          jperc = nfe 
c          call scrper(' ',jperc,nperc)
          if (fe .lt. fr) then
            fs(ih) = fe
          else
            call dcopyRemo (ns,s(1,itemp),1,s(1,ih),1)
            fs(ih) = fr
          end if
        else if (fr .lt. fs(is)) then
c
c         accept reflected point
c
          call dcopyRemo (ns,s(1,itemp),1,s(1,ih),1)
          fs(ih) = fr
        else
c
c         contract
c
          if (fr .gt. fs(ih)) then
            call newpt (ns,-beta,s(1,icent),s(1,ih),.true.,
     *                  s(1,itemp),small)
          else
            call newpt (ns,-beta,s(1,icent),s(1,itemp),
     *                  .false.,dum,small)
          end if
          if (small) go to 40
          call evalf (f,ns,ips,s(1,itemp),n,x,fc,nfe)
c          jperc = nfe 
c          call scrper(' ',jperc,nperc)
          if (fc .lt. min(fr,fs(ih))) then
            call dcopyRemo (ns,s(1,itemp),1,s(1,ih),1)
            fs(ih) = fc
          else
c
c           shrink simplex
c
            do 30 j = 1,npts
              if (j .ne. il) then
                call newpt (ns,-delta,s(1,il),s(1,j),
     *                      .false.,dum,small)
                if (small) go to 40
                call evalf (f,ns,ips,s(1,j),n,x,fs(j),nfe)
c                jperc = nfe 
c                call scrper(' ',jperc,nperc)
              end if
   30       continue
          end if
          updatc = .false.
        end if
        call order (npts,fs,il,is,ih)
c
c       check termination
c
   40   continue
        if (irepl .eq. 0) then
          fx = fs(il)
        else
          fx = sfbest
        end if
   50   continue
        if (nfstop .gt. 0 .and. fx .le. sfstop .and.
     *      nfxe .ge. nfstop) then
          iflag = 2
        else if (nfe .ge. maxnfe) then
          iflag = -1
        else if (dist(ns,s(1,ih),s(1,il)) .le. tol .or.
     *           small) then
          iflag = 0
        else
          go to 20
        end if
c
c     end main loop, return best point
c
      do 60 i = 1,ns
        x(ips(i)) = s(i,il)
   60 continue
      return
      end
      subroutine sortd (n,xkey,ix)
c
      integer n
      integer ix(n)
      double precision xkey(n)
c
c                                         Coded by Tom Rowan
c                            Department of Computer Sciences
c                              University of Texas at Austin
c
c sortd uses the shakersort method to sort an array of keys
c in decreasing order. The sort is performed implicitly by
c modifying a vector of indices.
c
c For nearly sorted arrays, sortd requires O(n) comparisons.
c for completely unsorted arrays, sortd requires O(n**2)
c comparisons and will be inefficient unless n is small.
c
c input
c
c   n      - number of components
c
c   xkey   - double precision vector of keys
c
c   ix     - integer vector of indices
c
c output
c
c   ix     - indices satisfy xkey(ix(i)) .ge. xkey(ix(i+1))
c            for i = 1,...,n-1
c
c local variables
c
      integer i,ifirst,ilast,iswap,ixi,ixip1
c
c-----------------------------------------------------------
c
      ifirst = 1
      iswap = 1
      ilast = n-1
   10 continue
      if (ifirst .le. ilast) then
        do 20 i = ifirst,ilast
          ixi = ix(i)
          ixip1 = ix(i+1)
          if (xkey(ixi) .lt. xkey(ixip1)) then
            ix(i) = ixip1
            ix(i+1) = ixi
            iswap = i
          end if
   20   continue
        ilast = iswap-1
        do 30 i = ilast,ifirst,-1
          ixi = ix(i)
          ixip1 = ix(i+1)
          if (xkey(ixi) .lt. xkey(ixip1)) then
            ix(i) = ixip1
            ix(i+1) = ixi
            iswap = i
          end if
   30   continue
        ifirst = iswap+1
        go to 10
      end if
      return
      end
      subroutine start (n,x,step,ns,ips,s,small)
c
      integer n,ns
      integer ips(n)
      double precision x(n),step(n),s(ns,ns+3)
      logical small
c
c                                         Coded by Tom Rowan
c                            Department of Computer Sciences
c                              University of Texas at Austin
c
c start creates the initial simplex for simplx minimization.
c
c input
c
c   n      - problem dimension
c
c   x      - current best point
c
c   step   - stepsizes for corresponding components of x
c
c   ns     - subspace dimension
c
c   ips    - permutation vector
c
c
c output
c
c   s      - first ns+1 columns contain initial simplex
c
c   small  - logical flag
c            = .true.  : coincident points
c            = .false. : otherwise
c
c local variables
c
      integer i,j
c
c subroutines and functions
c
c   blas
      external dcopyRemo
c   fortran
      intrinsic dble
c
c-----------------------------------------------------------
c
      do 10 i = 1,ns
        s(i,1) = x(ips(i))
   10 continue
      do 20 j = 2,ns+1
        call dcopyRemo (ns,s(1,1),1,s(1,j),1)
        s(j-1,j) = s(j-1,1)+step(ips(j-1))
   20 continue
c
c check for coincident points
c
      do 30 j = 2,ns+1
        if (dble(s(j-1,j)) .eq. dble(s(j-1,1))) go to 40
   30 continue
      small = .false.
      return
c
c coincident points
c
   40 continue
      small = .true.
      return
      end
      subroutine subopt (n)
      USE RemoModule
 
c
      integer n
c
c                                         Coded by Tom Rowan
c                            Department of Computer Sciences
c                              University of Texas at Austin
c
c subopt sets options for subplx.
c
c input
c
c   n      - problem dimension
c
c common
c
      integer nsmin,nsmax,irepl,ifxsw,nfstop,nfxe
      double precision alpha,beta,gamma,delta,psi,omega,
     *     bonus,fstop,fxstat,ftest
      logical minf,initx,newx
c
      common /usubc/ alpha,beta,gamma,delta,psi,omega,nsmin,
     *               nsmax,irepl,ifxsw,bonus,fstop,nfstop,
     *               nfxe,fxstat(4),ftest,minf,initx,newx
c
      save
c
c subroutines and functions
c
c   fortran
      intrinsic min
c
c-----------------------------------------------------------
c
c***********************************************************
c simplex method strategy parameters
c***********************************************************
c
c alpha  - reflection coefficient
c          alpha .gt. 0
c
      alpha = 1.d0
c
c beta   - contraction coefficient
c          0 .lt. beta .lt. 1
c
      beta = .5d0
c
c gamma  - expansion coefficient
c          gamma .gt. 1
c
      gamma = 2.d0
c
c delta  - shrinkage (massive contraction) coefficient
c          0 .lt. delta .lt. 1
c
      delta = .5d0
c
c***********************************************************
c subplex method strategy parameters
c***********************************************************
c
c psi    - simplex reduction coefficient
c          0 .lt. psi .lt. 1
c
      psi = .25d0
c
c omega  - step reduction coefficient
c          0 .lt. omega .lt. 1
c
      omega = 0.25d0!.1d0
c
c nsmin and nsmax specify a range of subspace dimensions.
c In addition to satisfying  1 .le. nsmin .le. nsmax .le. n,
c nsmin and nsmax must be chosen so that n can be expressed
c as a sum of positive integers where each of these integers
c ns(i) satisfies   nsmin .le. ns(i) .ge. nsmax.
c Specifically,
c     nsmin*ceil(n/nsmax) .le. n   must be true.
c
c nsmin  - subspace dimension minimum
c
!!!!!!!!!!!!!attenzione!!!!!!!!!!!!!!!!!!!!!!!!!
      if(jMolMR>1)then
         nsmin = min(5,n)
         nsmax = min(7,n)
      else
      
         nsmin = min(2,n)
c
c nsmax  - subspace dimension maximum
c
         nsmax = min(5,n)
      endif
c
c***********************************************************
c subplex method special cases
c***********************************************************
c nelder-mead simplex method with periodic restarts
c   nsmin = nsmax = n
c***********************************************************
c nelder-mead simplex method
c   nsmin = nsmax = n, psi = small positive
c***********************************************************
c
c irepl, ifxsw, and bonus deal with measurement replication.
c Objective functions subject to large amounts of noise can
c cause an optimization method to halt at a false optimum.
c An expensive solution to this problem is to evaluate f
c several times at each point and return the average (or max
c or min) of these trials as the function value.  subplx
c performs measurement replication only at the current best
c point. The longer a point is retained as best, the more
c accurate its function value becomes.
c
c The common variable nfxe contains the number of function
c evaluations at the current best point. fxstat contains the
c mean, max, min, and standard deviation of these trials.
c
c irepl  - measurement replication switch
c irepl  = 0, 1, or 2
c        = 0 : no measurement replication
c        = 1 : subplx performs measurement replication
c        = 2 : user performs measurement replication
c              (This is useful when optimizing on the mean,
c              max, or min of trials is insufficient. Common
c              variable initx is true for first function
c              evaluation. newx is true for first trial at
c              this point. The user uses subroutine fstats
c              within his objective function to maintain
c              fxstat. By monitoring newx, the user can tell
c              whether to return the function evaluation
c              (newx = .true.) or to use the new function
c              evaluation to refine the function evaluation
c              of the current best point (newx = .false.).
c              The common variable ftest gives the function
c              value that a new point must beat to be
c              considered the new best point.)
c
      irepl = 0
c
c ifxsw  - measurement replication optimization switch
c ifxsw  = 1, 2, or 3
c        = 1 : retain mean of trials as best function value
c        = 2 : retain max
c        = 3 : retain min
c
      ifxsw = 1
c
c Since the current best point will also be the most
c accurately evaluated point whenever irepl .gt. 0, a bonus
c should be added to the function value of the best point
c so that the best point is not replaced by a new point
c that only appears better because of noise.
c subplx uses bonus to determine how many multiples of
c fxstat(4) should be added as a bonus to the function
c evaluation. (The bonus is adjusted automatically by
c subplx when ifxsw or minf is changed.)
c
c bonus  - measurement replication bonus coefficient
c          bonus .ge. 0 (normally, bonus = 0 or 1)
c        = 0 : bonus not used
c        = 1 : bonus used
c
      bonus = 1.d0
c
c nfstop = 0 : f(x) is not tested against fstop
c        = 1 : if f(x) has reached fstop, subplx returns
c              iflag = 2
c        = 2 : (only valid when irepl .gt. 0)
c              if f(x) has reached fstop and
c              nfxe .gt. nfstop, subplx returns iflag = 2
c
      nfstop = 0
c
c fstop  - f target value
c          Its usage is determined by the value of nfstop.
c
c minf   - logical switch
c        = .true.  : subplx performs minimization
c        = .false. : subplx performs maximization
c
c     minf = .true.
      minf = .false.  ! fa la massimizzazione
      return
      end
      subroutine subplx (f,n,tol,maxnfe,mode,scale,x,fx,nfe,
     *                   work,iwork,iflag)
c
      integer n,maxnfe,mode,nfe,iwork(*),iflag
      double precision f,tol,scale(*),x(n),fx,work(*)
c
c                                         Coded by Tom Rowan
c                            Department of Computer Sciences
c                              University of Texas at Austin
c
c subplx uses the subplex method to solve unconstrained
c optimization problems.  The method is well suited for
c optimizing objective functions that are noisy or are
c discontinuous at the solution.
c
c subplx sets default optimization options by calling the
c subroutine subopt.  The user can override these defaults
c by calling subopt prior to calling subplx, changing the
c appropriate common variables, and setting the value of
c mode as indicated below.
c
c By default, subplx performs minimization.
c
c input
c
c   f      - user supplied function f(n,x) to be optimized,
c            declared external in calling routine
c
c   n      - problem dimension
c
c   tol    - relative error tolerance for x (tol .ge. 0.)
c
c   maxnfe - maximum number of function evaluations
c
c   mode   - integer mode switch with binary expansion
c            (bit 1) (bit 0) :
c            bit 0 = 0 : first call to subplx
c                  = 1 : continuation of previous call
c            bit 1 = 0 : use default options
c                  = 1 : user set options
c
c   scale  - scale and initial stepsizes for corresponding
c            components of x
c            (If scale(1) .lt. 0.,
c            abs(scale(1)) is used for all components of x,
c            and scale(2),...,scale(n) are not referenced.)
c
c   x      - starting guess for optimum
c
c   work   - double precision work array of dimension .ge.
c            2*n + nsmax*(nsmax+4) + 1
c            (nsmax is set in subroutine subopt.
c            default: nsmax = min(5,n))
c
c   iwork  - integer work array of dimension .ge.
c            n + int(n/nsmin)
c            (nsmin is set in subroutine subopt.
c            default: nsmin = min(2,n))
c
c output
c
c   x      - computed optimum
c
c   fx     - value of f at x
c
c   nfe    - number of function evaluations
c
c   iflag  - error flag
c            = -2 : invalid input
c            = -1 : maxnfe exceeded
c            =  0 : tol satisfied
c            =  1 : limit of machine precision
c            =  2 : fstop reached (fstop usage is determined
c                   by values of options minf, nfstop, and
c                   irepl. default: f(x) not tested against
c                   fstop)
c            iflag should not be reset between calls to
c            subplx.
c
c common
c
      integer nsmin,nsmax,irepl,ifxsw,nfstop,nfxe
      double precision alpha,beta,gamma,delta,psi,omega,
     *     bonus,fstop,fxstat,ftest
      logical minf,initx,newx
c
      common /usubc/ alpha,beta,gamma,delta,psi,omega,nsmin,
     *               nsmax,irepl,ifxsw,bonus,fstop,nfstop,
     *               nfxe,fxstat(4),ftest,minf,initx,newx
c
      double precision fbonus,sfstop,sfbest
      logical new
c
      common /isubc/ fbonus,sfstop,sfbest,new

canna: per barra temporale
      logical  noWrite,plusModel
      integer  ncount,maxcount
      common /util2/ noWrite,ncount,maxcount,plusModel
canna
c
c local variables
c
      integer i,j,ifsptr,ins,insfnl,insptr,ipptr,isptr,
     *        istep,istptr,ns,nsubs
      double precision bnsfac(3,2),dum(1),scl(1),sfx,xpscl
      logical cmode
c
      save
c
c subroutines and functions
c
      external f,sortd,evalf,partx,setstp,simplx,subopt
c   blas
      external dcopyRemo
c   fortran
      intrinsic abs,mod
c
c data
c
      data ((bnsfac(i,j),i=1,3),j=1,2) /-1.d0,-2.d0,0.d0,
     *      1.d0,0.d0,2.d0/
c-----------------------------------------------------------
c

c      ncount = 0 
      maxcount = maxnfe
      if (mod(mode,2) .eq. 0) then
c
c       first call, check input
c
        if (n .lt. 1) go to 120
        if (tol .lt. 0.d0) go to 120
        if (maxnfe .lt. 1) go to 120
        if (scale(1) .ge. 0.d0) then
          do 10 i = 1,n
            xpscl = x(i)+scale(i)
            if (xpscl .eq. x(i)) go to 120
   10     continue
        else
          scl = abs(scale(1))
          do 20 i = 1,n
            xpscl = x(i)+scl(1)
            if (xpscl .eq. x(i)) go to 120
   20     continue
        end if
        if (mod(mode/2,2) .eq. 0) then
          call subopt (n)
        else
          if (alpha .le. 0.d0) go to 120
          if (beta .le. 0.d0 .or. beta .ge. 1.d0) go to 120
          if (gamma .le. 1.d0) go to 120
          if (delta .le. 0.d0 .or. delta .ge. 1.d0)
     *        go to 120
          if (psi .le. 0.d0 .or. psi .ge. 1.d0) go to 120
          if (omega .le. 0.d0 .or. omega .ge. 1.d0)
     *        go to 120
          if (nsmin .lt. 1 .or. nsmax .lt. nsmin .or.
     *        n .lt. nsmax) go to 120
          if (n .lt. ((n-1)/nsmax+1)*nsmin) go to 120
          if (irepl .lt. 0 .or. irepl .gt. 2) go to 120
          if (ifxsw .lt. 1 .or. ifxsw .gt. 3) go to 120
          if (bonus .lt. 0.d0) go to 120
          if (nfstop .lt. 0) go to 120
        end if
c
c       initialization
c
        istptr = n+1
        isptr = istptr+n
        ifsptr = isptr+nsmax*(nsmax+3)
        insptr = n+1
        if (scale(1) .gt. 0.d0) then
          call dcopyRemo (n,scale,1,work,1)
          call dcopyRemo (n,scale,1,work(istptr),1)
        else
          call dcopyRemo (n,scl,0,work,1)
          call dcopyRemo (n,scl,0,work(istptr),1)
        end if
        do 30 i = 1,n
          iwork(i) = i
   30   continue
        nfe = 0
        nfxe = 1
        if (irepl .eq. 0) then
          fbonus = 0.d0
        else if (minf) then
          fbonus = bnsfac(ifxsw,1)*bonus
        else
          fbonus = bnsfac(ifxsw,2)*bonus
        end if
        if (nfstop .eq. 0) then
          sfstop = 0.d0
        else if (minf) then
          sfstop = fstop
        else
          sfstop = -fstop
        end if
        ftest = 0.d0
        cmode = .false.
        new = .true.
        initx = .true.
        call evalf (f,0,iwork,dum,n,x,sfx,nfe)
        initx = .false.
      else
c
c       continuation of previous call
c
        if (iflag .eq. 2) then
          if (minf) then
            sfstop = fstop
          else
            sfstop = -fstop
          end if
          cmode = .true.
          go to 70
        else if (iflag .eq. -1) then
          cmode = .true.
          go to 70
        else if (iflag .eq. 0) then
          cmode = .false.
          go to 90
        else
          return
        end if
      end if
c
c     subplex loop
c
   40 continue
        do 50 i = 1,n
          work(i) = abs(work(i))
   50   continue
        call sortd (n,work,iwork)
        call partx (n,iwork,work,nsubs,iwork(insptr))
        call dcopyRemo (n,x,1,work,1)
        ins = insptr
        insfnl = insptr+nsubs-1
        ipptr = 1
c
c       simplex loop
c
   60   continue
          call DoSingleIteration()
          ns = iwork(ins)
   70     continue
          call simplx (f,n,work(istptr),ns,iwork(ipptr),
     *                 maxnfe,cmode,x,sfx,nfe,work(isptr),
     *                 work(ifsptr),iflag)
          cmode = .false.
          if (iflag .ne. 0) go to 110
          if (ins .lt. insfnl) then
            ins = ins+1
            ipptr = ipptr+ns
            go to 60
          end if
c
c       end simplex loop
c
        do 80 i = 1,n
          work(i) = x(i)-work(i)
   80   continue
c
c       check termination
c
   90   continue
        istep = istptr
        do 100 i = 1,n
          if (max(abs(work(i)),abs(work(istep))*psi)/
     *        max(abs(x(i)),1.d0) .gt. tol) then
            call setstp (nsubs,n,work,work(istptr))  
            go to 40
          end if
          istep = istep+1
  100   continue
c
c     end subplex loop
c
      iflag = 0
  110 continue
      if (minf) then
        fx = sfx
      else
        fx = -sfx
      end if
      return
c
c     invalid input
c
  120 continue
      iflag = -2
      return
      end
!-----------------------------------------------------------------------
      subroutine ConvertAngle(tet1,tet2,tet3,phi,psi,chi)
c
      USE General
c
      eps=0.001
      tet1p=0.5*(tet1+tet3)
      tet2p=0.5*(tet2)
      tet3p=0.5*(tet1-tet3)
c
c--calcolo chi
c
      term=cos(tet2p)*cos(tet1p)
      chi=2.0*acos(term)
c
c--calcolo phi
c
      term=cos(tet3p)
      if(abs(term)>eps) then
        secTet3p=1.0/cos(tet3p)
      else
        if(term>0.0) then
          phi=-0.5*Pi
        else
          phi=+0.5*Pi
        endif
        goto 10
      endif
c
      term=sin(tet2p)
      if(abs(term)<eps) then
        if(term>0.0) then
          phi=0.0
        else
          phi=-Pi
        endif
        goto 10
      endif
c
      term1=secTet3p / tan(tet2p)
      term=-sin(tet1p)*term1
      phi=atan(term)
  10  continue
c
c--calcolo psi
c
      term=cos(phi)
      if(abs(term)>eps) then
        secphi=1.0/cos(phi)
      else
        if(term>0.0) then
          psi=0.5*Pi
        else
          psi=-0.5*Pi
        endif
        goto 20
      endif
c
      term=sin(Tet3p)
      if(abs(term)<eps) then
        if(term>0.0) then
          psi=0.0
        else
          psi=+Pi
        endif
        goto 20
      endif
c
      term=secphi / tan(tet3p)
      psi=atan(term)
  20  continue
c
      return
      end
!-----------------------------------------------------------------------
      subroutine Renor_MR(numb,mode)

      USE General
      USE Symmetry
      USE Riflessi
      USE RenorArrays_MR
      USE riflessi_c
      USE RuotaRiflessi
      USE RemoModule
      USE PhaseModule
!
!-- mode = 1  Renorm Observed E's
!-- mode = 2  Renorm Calc E's
!
*     iprin = 1
c     iprin = 0
      if (mode == 1 .and. ifRenor == 100) then
          return
      endif
!
      NShell = 20
      Nstat = floor(numb/float(NShell))
      Nstat = min(500,Nstat)    ! max 500 rifl.
      Nstat = max(100,Nstat)    ! min 100 rifl.
      NShell = floor(numb/float(Nstat))
      NShell = max(10,NShell)   ! min  10 shell
      NShell = min(100,NShell)  ! max 100 shell
      Nstat = floor(numb/float(NShell))
!
      if (iprin > 0) then
          write(lo,*)'================================='
          write(lo,*)'=   Renormalize routine (MR)    ='
          write(lo,*)'================================='
          write(lo,*) 'number = ',numb
          write(lo,*) 'NShell = ',NShell
          write(lo,*) 'Nstat  = ',Nstat
      endif
!
      if (mode == 1) then
          iact = -1
      else
          iact =  1
      endif
      call AllocaRenorArrays_MR(iact)
   
      if (mode == 1) then
          do i=1,numb
             RES(i) = 0.5 / sqrt(rhov(i))
          enddo
      else
          do i=1,numb
             RES(i) = 0.5 / sqrt(rhovc(i))
          enddo
      endif
!
      call shells_MR(numb) 
!
! --  calcolo < Eo >
!
      sum1 = 0.0
      sum2 = 0.0
      if (mode == 1) then
          do i = 1,numb
             ii = RES_TAG(i)
             eo  = evet(i)
             eo2 = evet(i)**2
             Eo2Shell(ii) = Eo2Shell(ii) + eo2
             sum1 = sum1 + eo
             sum2 = sum2 + eo2
          enddo
      else
          do i = 1,numb
             ecvetc(i)= sqrt(ecvetc(i))

             ii = RES_TAG(i)
             eo  = ecvetc(i)
             eo2 = ecvetc(i)**2
             Eo2Shell(ii) = Eo2Shell(ii) + eo2
             sum1 = sum1 + eo
             sum2 = sum2 + eo2
          enddo
      endif
      if (iprin > 0) then
          if (mode == 1) then
              write(lo,*)'< Eo >',sum1 / float(numb)
              write(lo,*)'< Eo2 >',sum2 / float(numb)
          else
              write(lo,*)'< Ec >',sum1 / float(numb)
              write(lo,*)'< Ec2 >',sum2 / float(numb)
          endif
      endif
!
! --  calcolo < E**2 >  for any shell
!
      do i = 1, NShell
         numbShell = count(RES_TAG(:) == i)   ! numero di riflessi per shell
         Eo2Shell(i) = Eo2Shell(i) / float(numbShell)
         if (iprin > 1) then
             if (mode == 1) then
                 write(lo,*)'< Eo2 >or per shell ', i, Eo2Shell(i)
             else
                 write(lo,*)'< Ec2 >or per shell ', i, Eo2Shell(i)
             endif
        endif
      enddo
!
      if (iprin > 0) then
          if (mode == 1) then
              write(lo,*)'< Eo2 >or ',sum(Eo2Shell(:))/float(NShell)
          else
              write(lo,*)'< Ec2 >or ',sum(Eo2Shell(:))/float(NShell)
          endif
      endif
!
! -- calcolo la scala  per <E**2> 
!
      if (mode == 1) then
         costNorm = 1.0
      else
         costNorm = 1.0 / float(nsymSav)
      endif
      if(ifModify==1) costNorm=1.0
      do i = 1,NShell
         scEo2Shell(i) = Eo2Shell(i) / costNorm
         Eo2Shell(i) = Eo2Shell(i) / scEo2Shell(i)
         if (iprin > 1) then
             if (mode == 1) then
                 write(lo,*)'< Eo2 >rn per shell ', i, Eo2Shell(i)
             else
                 write(lo,*)'< Ec2 >rn per shell ', i, Eo2Shell(i)
             endif
         endif
      enddo
!
      sum1 = 0.0
      sum2 = 0.0
      if (mode == 1) then
           do i = 1,numb
              ii = RES_TAG(i)
              Eobs(i) = evet(i) / sqrt(scEo2Shell(ii))
              evet(i) = Eobs(i)
              if(evet(i) > 2.) evet(i) = 2.
              sum1 = sum1 + evet(i)
              sum2 = sum2 + evet(i)**2
           enddo
           if (iprin > 0) then
               write(lo,*)'  CostNorm  ', costNorm
               write(lo,*)'< Eo >rn',sum1 / float(numb)
               write(lo,*)'< Eo2 >rn',sum2 / float(numb)
           endif
      else
           do i = 1,numb
              ii = RES_TAG(i)
              Ec = ecvetc(i) / sqrt(scEo2Shell(ii))
              ecvetc(i) = Ec
              if(ecvetc(i)>2.) ecvetc(i)=2. 
              sum1 = sum1 + ecvetc(i)
              sum2 = sum2 + ecvetc(i)**2
              ecvetc(i) = ecvetc(i)**2
           enddo
          if (iprin > 0) then
              write(lo,*)'  CostNorm  ', costNorm
              write(lo,*)'< Ec >rn',sum1 / float(numb)
              write(lo,*)'< Ec2 >rn',sum2 / float(numb)
          endif
       endif
!
       call AllocaRenorArrays_MR(2)
!
      if (iprin > 0) then
          write(lo,*)'================================='
          write(lo,*)'=       end Renor_MR            ='
          write(lo,*)'================================='
      endif
!
      return
      end
!------------------------------------------------------------------------
      subroutine shells_MR(numb)

      USE General
      USE RenorArrays_MR
      USE riflessi_c
      USE RuotaRiflessi

      shellTAB(:,:)  = 0.0
!
      Ndata = floor(numb / float(NShell))
!
      do i = 1,numb
         IX_sort(i) = i
         res_sort(i) = RES(i)
      enddo
      call sortall3(1,res_sort,1,numb,IX_sort)
      do i = 1,NShell-1
          rmin = 10000.0
          rmax = -10000.0
          j = 0
          do ii = 1+(i-1)*Ndata,i*Ndata
             j = j+1
             RES_TAG(IX_sort(ii)) = i
             rmax = max(rmax,RES(IX_sort(ii)))
             rmin = min(rmin,RES(IX_sort(ii)))
         enddo
         shellTAB(i,1) = rmin
         shellTAB(i,2) = rmax
       enddo
!
       rmin = 10000.0
       rmax = -10000.0
       j = 0
       do ii = 1+(NShell-1)*Ndata,numb
          j = j+1
          RES_TAG(IX_sort(ii)) = NShell
          rmax = max(rmax,RES(IX_sort(ii)))
          rmin = min(rmin,RES(IX_sort(ii)))
       enddo
       shellTAB(NShell,1) = rmin
       shellTAB(NShell,2) = rmax
!
       return
       end
!---------------------------------------------------------------------
      function c_normalizza(rho,fcalc)
  
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE riflessi_c
      USE RemoModule
      USE PhaseModule
!
      do ij=1,model(WhichModel)%nk
         ff(ij) = ScattFact_MR(ij, rho,WhichModel)
      enddo
      fkz = 0.0
      do jj=1,natsInModel(WhichModel)
         kz=model(WhichModel)%specie(jj,1) / nzConst
         if (kz /= 0) then
            fkz = fkz + ff(kz) * ff(kz)
         endif
      enddo
      ed = fcalc / fkz  !  fcalc = Fcalc**2
!-- Ecalc ** 2
c     c_normalizza = ed* exp(2.* 1.1 * bt *rho)  ! per uniformarci al BT del modello
      c_normalizza = ed* exp(2.* bmedio *rho)  ! per uniformarci al BT del modello
!        
      return
      end
!----------------------------------------------------------------------
      subroutine CalcolaCosto_Rot(costo,prt_fom)
!
      USE General
      USE RuotaRiflessi
      USE Riflessi
      USE riflessi_c
      USE RemoModule
      USE PhaseModule
      USE WrReIn, only : aveFob
!
!--calcolo della Nuova FOM  su (Eobs, Ecal)
!
!--  iact = 1  : costo = 1-R1; residuo R1 basato su (Ro - Rc)  ! da provare per uniformità con Tfom
!--  iact = 2  : costo = 1-R2; residuo R2 basato su (Ro**2 - Rc**2)
!--  iact = 3  : NRFom5

      real::prt_fom(5)
      prt_fom(:) = 0.0


      work1(:) = 0.0
      work2(:) = 0.0

      isHM = 1  !0
      if (isHM == 1) then
         do i = 1,nreflSelRot
                work1(i) = ModuliSel(1,i)**2 ! Ecalc ; Emod in uscita
                work2(i) = ModuliSel(2,i)**2  ! Eobs
         enddo
         nwizm1=25  ! proteins  -  da provare con routine generalizzata
         nden =  nstr / 10
         nsip1 = nrefl / nden
         nsip1 = min(nsip1,498)
c        write(6,*) 'HHMM',nstr,nrefl,nreflSelRot,nden,nsip1,nwizm1
         call HistogramMatch(work1,work2,nreflSelRot,nsip1,nwizm1,1)
         ModuliSel(1,1:nreflSelRot) = sqrt(work1(1:nreflSelRot))
      endif


      work1(:) = 0.0
      work2(:) = 0.0
      worko(:) = 0.0

      work1(1:nreflSelRot) = fcvet(1:nreflSelRot)
      work2(1:nreflSelRot) = evet(1:nreflSelRot)
      fcvet(1:nreflSelRot)=ModuliSel(1,1:nreflSelRot)
      evet(1:nreflSelRot)=ModuliSel(2,1:nreflSelRot)
      jflag  = -1    ! calcolo sigmaA con E
      wt(:) = 1.0
      knwSav = knw       ! gianluca 6/12/12
      knw = 0
      call PresigmaA(jflag, 0)
      knw = knwSav
      fcvet(1:nreflSelRot) = work1(1:nreflSelRot)
      evet(1:nreflSelRot) = work2(1:nreflSelRot)

      costo = 0.0
      sumR2calc = 0.0
      sigmamed = 0
      ncond1 = 0
      do i=1,nreflSelRot
           ec2 = ModuliSel(1,i)**2
           eo2 = ModuliSel(2,i)**2
c          sigma = Dluz(i)
           sigma = Dluz(i)**2
           sigma = max(0.00001,sigma)
           sigmamed = sigmamed + sigma
           ec2med = 1 + (sigma*(ec2-1))
           worko(i) =  ec2med
           ncond1 = ncond1 + 1
      enddo

      sigmamed = sigmamed / ncond1  !nreflSelRot

      isHM = 1  !0
      if (isHM == 1) then
         do i = 1,nreflSelRot
                work1(i) = worko(i) ! Ecalc 
                work2(i) = ModuliSel(2,i)**2  ! Eobs
         enddo
         nwizm1=25  ! proteins  -  da provare con routine generalizzata
         nden =  nstr / 10
         nsip1 = nrefl / nden
         nsip1 = min(nsip1,498)
         call HistogramMatch(work1,work2,nreflSelRot,nsip1,nwizm1,1)
         do i = 1,nreflSelRot
c           write(6,*) 'XXX',i, work2(i), worko(i), work1(i)
            worko(i) = work1(i)
         enddo
      endif

      work1(:) = 0.0
      work2(:) = 0.0
      work2(1:nreflSelRot) = 1.0

      goto 1122

      do i=1,nreflSelRot
         work1(i) = focomp(i) / sigmavcomp(i)
      enddo
      ncond1 =  nreflSelRot * 0.9
      call sortall(-1,work1,nreflSelRot)
      sog = work1(ncond1)

c         sog = -999

      ncont_fo = 0
      do i=1,nreflSelRot
         fosigfo = focomp(i) / sigmavcomp(i)
         if (fosigfo < sog) then
             work2(i) = 0.0
             ncont_fo = ncont_fo + 1
         endif
      enddo

c         work2(1:nreflSelRot) = 1.0

      do i=1,nreflSelRot
         delta = abs(worko(i) - 1.0)
         work1(i) =  delta
      enddo
      ncond1 =  nreflSelRot * 0.15
      call sortall(1,work1,nreflSelRot)
      sog = work1(ncond1)

      ncont_de = 0
      do i=1,nreflSelRot
         delta = abs(worko(i) - 1.0)
         if (delta < sog) then
             work2(i) = 0.0
             ncont_de = ncont_de + 1
         endif
      enddo

      ncont = 0
      do i=1,nreflSelRot
         if (work2(i) < 0.001) then
             ncont = ncont + 1
         endif
      enddo
   
c         work2(1:nreflSelRot) = 1.0

 1122 continue

      sumR2oss = 0.0
      sumR2calc = 0.0
      sumDiff = 0.0
      do i=1,nreflSelRot
         if (work2(i) .gt. 0.001) then
             eo2 = ModuliSel(2,i)**2
             sumR2oss = sumR2oss + eo2
             ec2med = worko(i) 
             sumR2calc = sumR2calc + ec2med
             Diff = abs(eo2 - ec2med)
             sumDiff = sumDiff + Diff
         endif
      enddo
      arg = sumDiff / sumR2oss

      costo = 1.0 - arg
   
      prt_fom(1) = sigmamed
      prt_fom(2) = sumR2oss
      prt_fom(3) = sumR2calc
      prt_fom(4) = sumDiff
      prt_fom(5) = arg

      return
      end

!------------------------------------------------------------
!------------------------------------------------------------
      subroutine CalcolaCosto_Tra(nM,costo,prt_fom)
!
!--calcolo della Nuova FOM  su (Eobs, Ecal)
!
      USE General
      USE Symmetry
      USE Riflessi
      USE riflessi_c
      USE RuotaRiflessi
      USE Atomi
      USE RemoModule
      USE PhaseModule
      USE TraslaSolution

      real::prt_fom(5)
      integer :: iact, nM

!--  iact = 0  : costo = gmed
!--  iact = 1  : costo = 1-R1; residuo R1 basato su (Ro - Rc)
!--  iact = 2  : costo = 1-R2; residuo R2 basato su (Ro**2 - Rc**2)
!--  iact = 3  : costo = (1-R1)*gmed
!--  iact = 4  : costo = (1-R2)*gmed

      prt_fom(:) = 0.0

      workRenor1(:) = 0.0
      workRenor2(:) = 0.0
      sumffMod_n= 0.0
      do i=1,nreflSelTra
         j = k_mem1(i)
         do ii=1,WhichModel-1
            sumffMod_n = sumffMod_n + sumffMod(j,ii)* 
     *                   MonomerInModel(ii)   
         enddo
         sumffMod_n = sumffMod_n + sumffMod(j,WhichModel)*nM
         den = sqrt(pts * epsvcomp(i) * sumffMod_n)
         workRenor1(i) = (fccomp(i)/den)*exp(bmedio*rhovcomp(i))!tolgo 2 per radice   
         workRenor2(i) = evet(j) 
      enddo

      isHM = 1  
      if (isHM == 1) then 
         do i = 1,nreflSelTra
                work1(i) = workRenor1(i)**2 ! Ecalc ; Emod in uscita
                work2(i) = workRenor2(i)**2  ! Eobs
c               work1(i) = fcvet(i)    ! Ecalc ; Emod in uscita
c               work2(i) = evet(i)     ! Eobs
         enddo
         nwizm1=25  ! proteins  -  da provare con routine generalizzata
         nden =  nstr / 10
         nsip1 = nrefl / nden
         nsip1 = min(nsip1,498)
         call HistogramMatch(work1,work2,nreflSelTra,nsip1,nwizm1,1)
         workRenor1(1:nreflSelTra) = sqrt(work1(1:nreflSelTra))
      endif

      gmed = 0
      do i=1,nreflSelTra
         ec = workRenor1(i)
         eo = workRenor2(i)
         gmed = gmed + (eo*ec)**2
      enddo
      gmed = gmed / nreflSelTra

      iact = 3

      if (iact == 0) then
         costo = gmed
         return
      else if (iact == 1 .or. iact == 3) then
         costo = 0.0
         sumRoss = 0.0
         sumRcalc = 0.0
         sigmamed = 0

         do i=1,nreflSelTra
            ec = workRenor1(i)
            eo = workRenor2(i)
            sumRoss = sumRoss + eo
            sumRcalc = sumRcalc + ec
         enddo

         sca = sumRoss / sumRcalc

         sumRcalc = 0.0
         sumDiff = 0.0
         do i=1,nreflSelTra
            eo = workRenor2(i)
            ec = sca * workRenor1(i)
            sumRcalc = sumRcalc + ec
            Diff = abs(eo - ec)
            sumDiff = sumDiff + Diff
         enddo
         arg = sumDiff / sumRoss
         costo = (1.0 - arg)
         if (iact == 3) costo = costo*gmed

         prt_fom(1) = gmed
         prt_fom(2) = sumRoss
         prt_fom(3) = sumRcalc
         prt_fom(4) = sumDiff
         prt_fom(5) = arg

      else if (iact == 2 .or. iact == 4) then

         costo = 0.0
         sumR2oss = 0.0
         sumR2calc = 0.0
         sigmamed = 0
         do i=1,nreflSelTra
            ec2 = workRenor1(i)**2
            eo2 = workRenor2(i)**2
            sumR2oss = sumR2oss + eo2
            sumR2calc = sumR2calc + ec2
         enddo

         sca = sumR2oss / sumR2calc

         sumR2calc = 0.0
         sumDiff = 0.0
         do i=1,nreflSelTra
            eo2 = workRenor2(i)**2
            ec2 = sca *  workRenor1(i)**2
            sumR2calc = sumR2calc + ec2
            Diff = abs(eo2 - ec2)
            sumDiff = sumDiff + Diff
         enddo
         arg = sumDiff / sumR2oss
         costo = (1.0 - arg)
         if (iact == 4) costo = costo*gmed

         prt_fom(1) = gmed
         prt_fom(2) = sumR2oss
         prt_fom(3) = sumR2calc
         prt_fom(4) = sumDiff
         prt_fom(5) = arg

      endif

      return
      end
!----------------------------------------------------------------------
      subroutine CalcolaCosto_New(ifl,iact,nM,corre)
!
      USE General
      USE Symmetry
      USE RuotaRiflessi
      USE Riflessi
      USE riflessi_c
      USE RuotaRiflessi
      USE RemoModule
      USE PhaseModule
      USE TraslaSolution

      integer :: ifl, iact, nM
!
!--calcolo della Nuova FOM  su (Eobs, Ecal)
!
!--  iflag = 1 : Rotazione
!--  iflag = 2 : Traslazione
!--  iact = 1  : costo = 1-R1; residuo R1 basato su (Ro - Rc)  ! da provare per uniformità con Tfom
!--  iact = 2  : costo = 1-R2; residuo R2 basato su (Ro**2 - Rc**2)

      work1(:) = 0.0
      work2(:) = 0.0
      
      npunti = nreflSelRot
c     work1(1:npunti)=ModuliSel(2,1:npunti)  !evet
c     work2(1:npunti)=ModuliSel(1,1:npunti)  !ecal
      work1(1:npunti)=ModuliSel(1,1:npunti)  !evet
      work2(1:npunti)=ModuliSel(2,1:npunti)  !ecal

      if (iact == 2) then
          work1(1:npunti)=work1(1:npunti)**2
          work2(1:npunti)=work2(1:npunti)**2
      endif
c
      vmedt=0.0
      vmedc=0.0
      vmedtc=0.0
      vmed2t=0.0
      vmed2c=0.0

      do ix=1,npunti
         xx1 = work1(ix)
         xx2 = work2(ix)
         vmedt=vmedt + xx1
         vmedc=vmedc + xx2
         vmedtc=vmedtc + xx1 * xx2
         vmed2t=vmed2t + xx1 * xx1
         vmed2c=vmed2c + xx2 * xx2
      enddo
      vmedt=vmedt/float(npunti)
      vmedc=vmedc/float(npunti)
      vmedtc=vmedtc/float(npunti)
      vmed2t=vmed2t/float(npunti)
      vmed2c=vmed2c/float(npunti)

      rnum=vmedtc - (vmedt*vmedc)
      rden=sqrt(vmed2t-vmedt**2) * sqrt(vmed2c-vmedc**2)
      corre=rnum/rden
!
      return
      end
!----------------------------------------------------------------------
      subroutine CalcolaCosto2(costo)
!
      USE RuotaRiflessi
      USE Symmetry
      USE Riflessi
      USE riflessi_c
      USE RemoModule
!
!--calcolo della FOM (Eo-1) * (Ec - 1)
!
c     write(123,100)
      cost = 0.0
      costo = 0.0
      denom = 0.0
      do i=1,nreflSelRot
         ec2 = ModuliSel(1,i)**2
         eo2 = ModuliSel(2,i)**2
         if (eo2 < 7.0 )then
             if(ec2 > 1.35 .or. ec2 < 0.7) then
                 j = k_mem(i)
                 peso = nsym/epsv(j)

                 cost = ( eo2 - 1.0)*(ec2 - 1.0)*peso
c                write(123,123) i,j,eo2,ec2,epsv(j),peso,cost

                 costo = costo + ( eo2 - 1.0)*(ec2 - 1.0)*peso
c                denom = denom + 1
             endif
         endif
      enddo
      denom =  nreflSelRot
      costo = costo / denom

100   format(/,80('-'))
123   format(2i8,5f10.3)

      return
      end

!------------------------------------------------------------
       real function pesoCC(shellr,NShell)

       real a, b, c
       integer shellr,NShell
       c = 0.8 
       a = 4 *(c-1) / (1-NShell)**2
       b = (1-NShell) * a 
   
       pesoCC = a * (shellr**2) + b * shellr + c

       return
       end
!------------------------------------------------------------

       subroutine CalcolaCostoMoreMol(RotSel,costo, nM)
!
      USE RuotaRiflessi
      USE Symmetry
      USE Riflessi
      USE riflessi_c
      USE RemoModule

      integer nM
      real k201, sigma, K_const, ec_kn, ec_unkn, eo2
      real RotSel(nreflSelRot)
 
      costo  = 0.0
      sumpes = 0.0
      do i=1,nreflSelRot
         sumffMod_n = 0.0
         j = k_mem(i)
         ec2_kn = ModuliSel(1,i)**2 !Ea
         ec2_unkn = RotSel(i)**2 !Eb
         eo2 = evet(j)**2
         do ii=1,WhichModel-1
            sumffMod_n = sumffMod_n + sumffMod(j,ii)*   
     *                   MonomerInModel(ii)
         enddo
         
         sumffMod_n = sumffMod_n + sumffMod(j,WhichModel)*(nM-1)

         K_const = sumff(j)/abs(sumff(j)-sumffMod_n)
         sigma = sqrt(sumffMod_n / sumff(j)) 
         arg = 2.0 * sigma * sqrt(eo2 * ec2_kn )
         if ((arg * K_const) > 1) then
             peso = (nsym/epsv(j))  
             costo = costo + (ec2_unkn - 1.0) * 
     *               (K_const *(eo2 + (sigma**2)*ec2_kn - arg * 
     *                bes(K_const * arg)) - 1.0) * peso!*k201
             sumpes = sumpes + peso !* k201
         endif
      enddo
      denom = nreflSelRot  
      costo = costo / denom
      return
      end
!------------------------------------------------------------
       subroutine CalcolaCosto2NCS(RotSel, costo,nM)
!
      USE RuotaRiflessi
      USE Symmetry
      USE Riflessi
      USE riflessi_c
      USE RemoModule

      real k200, k200m
      real, allocatable :: ec(:)
      real RotSel(nMolMR,nreflSelRot)

      allocate(ec(1:nMolMR), stat = ier)

      costo  = 0.0
      sumpes = 0.0
      eo2m = 0.0
      ealfa= 0.0
      ebeta = 0.0
      k200m = 0.0
      do i=1,nreflSelRot
         j = k_mem(i)
         ec(1) = RotSel(1,i)**2 !Ea
         do nn = 2, nM
            ec(nn) = RotSel(nn,i)**2 !Eb
         enddo
         ecnota = ec(1)!parte nota della struttura
         do nn = 2, nM - 1
            ecnota = ecnota + ec(nn) 
         enddo
         eo2 = evet(j)**2 !R
         eo2m = eo2m + eo2
         ealfa=ealfa + ecnota
         ebeta = ebeta + ec(nM) 
c         sigmaRappo = sumffMod(i) / sumff(i)
c         if (sigmaRappo > 1 ) sigmaRappo = 1./sigmaRappo 
         sigmaRappo = 1.   
         k200 = (ecnota  * sigmaRappo) +
     *          ((nMolMR - (nM - 1.0)) / nMolMR)
         k200m = k200m + k200
         if(eo2 > k200 * 1.35 .or. eo2 < k200 * 0.7) then
            if(ec(nM) > 1.35 .or. ec(nM) < 0.7) then  
               peso = nsym/epsv(j)*(4./k200**2)  
               costo = costo + ( ec(nM) - 1.0) * ( eo2 - k200) * peso
               sumpes = sumpes + peso
            endif
         endif
      enddo
c       write (6,*)'k200m = ',k200m/nreflSelRot,'eo2m=',eo2m/nreflSelRot,
c     *            'ealfa=',ealfa/nreflSelRot,'ebeta=',ebeta/nreflSelRot
      denom =  nreflSelRot 
      costo = costo / denom
      deallocate(ec, stat = ier)
      return
      end
!------------------------------------------------------------

      subroutine CalcolaCostoProva0()
!
!--calcolo il fattore di accordo -- corre
!
      USE General
      USE Symmetry
      USE Riflessi
      USE riflessi_c
      USE RuotaRiflessi
      USE Solutions
      USE RemoModule
      USE PhaseModule
      USE cc_vet_comm
!
        vmedc=0.0
        vmed2c=0.0
        wsum=0.0
        wsum1=0.0
        do ix=1,nreflSelRot
          j = k_mem(ix)
          w=nsym/epsv(j)
          wsum=wsum+w
          wsum1=wsum1+w*w
          xx2 = ModuliSel(2,ix)
          vmedc=vmedc + w * xx2
          vmed2c=vmed2c + w * xx2 * w* xx2
        enddo
        vmedc=vmedc/wsum
        vmed2c=vmed2c/wsum1
!
      return
      end
!------------------------------------------------------------
      subroutine CalcolaCostoProva(costo)
!
!--calcolo il fattore di accordo -- corre
!
      USE General
      USE Symmetry
      USE Riflessi
      USE riflessi_c
      USE RuotaRiflessi
      USE Solutions
      USE RemoModule
      USE PhaseModule
      USE cc_vet_comm
!
      vmedt=0.0
      vmed2t=0.0
      vmedtc=0.0
      do ix=1,nreflSelRot
         xx1 = ModuliSel(1,ix)
         xx2 = ModuliSel(2,ix)
         j = k_mem(ix)
         w=nsym/epsv(j)
         vmedt=vmedt + w*xx1
         vmedtc=vmedtc + w * xx1 * w * xx2
         vmed2t=vmed2t + w * xx1 * w * xx1
      enddo
      vmedt=vmedt/wsum
      vmedtc=vmedtc/wsum1
      vmed2t=vmed2t/wsum1
      rnum=vmedtc - (vmedt*vmedc)
      rden=sqrt(vmed2t-vmedt**2) * sqrt(vmed2c-vmedc**2)
      costo=rnum/rden
!
      return
      end
!------------------------------------------------
      subroutine StatisticaRExp()
c
      USE General
      USE Riflessi
      USE Atomi
      USE RemoModule
      USE PhaseModule
!
      dimension rhr(20),rhrn(20),nhr(20),stl(20),rsv(20),den(20)
!
      natsSav = nats
      nats    = natsMR
!
      zero = 0.001
      rhm = 0.5 / sqrt(rhomax)
      sumfc = 0.0
      sumfo = 0.0
      write(lo,10)
   10 format(70('-'))
      write(lo,*) 'StatisticaR'
      do i=1, nrefl
        if (wt(i) > zero) then
             sumfo = sumfo + fovet(i) 
             sumfc = sumfc + work1(i)
        endif 
      enddo
      scale = sumfo/sumfc
      write(6,*) 'numbGen,scale,sumfo,sumfc',numbGen,scale,sumfo,sumfc
      write(6,*) 'rhomax,rhm',rhomax,rhm
      write(6,10)
      sumfc = 0.0
      sumfo = 0.0
      sumdf = 0.0
!
      nShells = 20
      rhom = sqrt(rhomax)
      rr0 = float(nShells) / rhom
!
      rhr = 0.0
      rhrn = 0.0
      stl = 0.0
      rsv = 0.0
      den = 0.0
      nhr = 0
!
      do i=1, nrefl
         if (wt(i) > zero) then
             rhos=sqrt(rhov(i))
c-- n stores range of rho
             n=min0(int(1.0+rr0*rhos),nShells)
             fo = fovet(i)
             df = fo - work1(i) * scale
             absdf = abs(df)
             sumfo = sumfo + fo
             sumdf = sumdf + absdf
             rhr(n) = rhr(n) + absdf
             rhrn(n) = rhrn(n) + df
             den(n) = den(n) + fo
             nhr(n) = nhr(n) + 1
         endif 
      enddo
      erreT = sumdf / sumfo
      rfac = 100.0 * erreT
      write(lo,100) rfac, erre*100.0
      do i=1,nShells
         if (nhr(i).gt.0.0) then
             rhr(i) = rhr(i) / den(i)
             rhrn(i) = rhrn(i) / den(i)
         else
             rhr(i) = 0.0
             rhrn(i) = 0.0
         endif
      enddo
      rr0 = 1.0 / rr0
      do i=1,nShells
         stl(i) = rr0 * float(i)
         rsv(i) = 0.5 / stl(i)
         rhr(i) = rhr(i) * 100.0
         rhrn(i) = rhrn(i) * 100.0
      enddo
      write(lo,332) rsv( 1: 5), rhr( 1: 5), nhr( 1: 5),
     *              rsv( 6:10), rhr( 6:10), nhr( 6:10),
     *              rsv(11:15), rhr(11:15), nhr(11:15),
     *              rsv(16:20), rhr(16:20), nhr(16:20)

  100 format ('ERRE TOTALE = ',f8.2,'%')
  332 format(/,22x,'***     Statistic on Residual    ***',//,
     2 4(5x,'Resol.  ',3x,5f10.2,/,
     3   5x,' R%     ',3x,5f10.2,/,
     3   5x,'number  ',3x, 5i10,//))
  330 format(/,22x,'***     Statistic on Residual    ***',//,11x,
     1 'Distribution of R% with resolution',/,
     2 2(' sinth/lambda',3x,5f10.4,/,
     3     5x,'Resol.  ',3x,5f10.2,/,
     3     5x,'|R%|    ',3x,5f10.2,/,
     3     5x,' R%     ',3x,5f10.2,/,
     3     5x,'number  ',3x, 5i10,//))
      write(99,331)
     * (stl(j),j=1,10),(rsv(j),j=1,10),(rhr(j),j=1,10),(rhrn(j),j=1,10),
     * (nhr(j),j=1,10)
  331 format(
     2 ' sinth/lambda',3x,10(' , ',f10.4),/,
     3   5x,'Resol.  ',3x,10(' , ',f10.2),/,
     3   5x,'|R%|    ',3x,10(' , ',f10.2),/,
     3   5x,' R%     ',3x,10(' , ',f10.2),/,
     3   5x,'number  ',3x,10(' , ',i10))
!
      nats = natsSav
!
      return
      end
!---------------------------------------------------------------
      subroutine RFactorStat()
      USE General
      USE Riflessi
      USE PhaseModule
!
      dimension resolTab(25),effeTab(25,11),erreTab(25,4)
!
      write(6,10)
      write(6,*) 'StatisticaR'
!
      nrows = 24
      resolTab( 1) =10.0
      resolTab( 2) = 8.0
      resolTab( 3) = 6.0
      resolTab( 4) = 5.0
      resolTab( 5) = 4.0
      resolTab( 6) = 3.0
      resolTab( 7) = 2.5
      resolTab( 8) = 2.0
      resolTab( 9) = 1.8
      resolTab(10) = 1.6
      resolTab(11) = 1.4
      resolTab(12) = 1.3
      resolTab(13) = 1.2
      resolTab(14) = 1.1
      resolTab(15) = 1.0
      resolTab(16) = 0.9
      resolTab(17) = 0.8
      resolTab(18) = 0.7
      resolTab(19) = 0.6
      resolTab(20) = 0.5
      resolTab(21) = 0.4
      resolTab(22) = 0.3
      resolTab(23) = 0.2
      resolTab(24) = 0.1
      resolTab(25) = 0.001
      effeTab(:,:) = 0.0
!
      resolmax = 0.5 / sqrt(rhomax)
      sumfc = 0.0
      sumfo = 0.0
      do i=1, nrefl
         sumfo = sumfo + fovet(i) 
         sumfc = sumfc + work1(i)
      enddo
      scale = sumfc / sumfo

!
      sumfo = 0.0
      sumdf = 0.0
      do i=1, nrefl
         sclf = scale * fovet(i)
         absdf = abs( work1(i) - sclf )
         sumfo = sumfo + sclf
         sumdf = sumdf + absdf

!
!-- fill array for statistics
!
         inserito = 0
         resol = 0.5 / sqrt(rhov(i))
         n = 0
         do while (inserito.eq.0.and.n.le.nrows)
            n = n + 1
            if (resol.gt.resolTab(n)) then
                effeTab(n,1) = effeTab(n,1) + absdf
                effeTab(n,2) = effeTab(n,2) + sclf
                effeTab(n,3) = effeTab(n,3) + 1
                inserito = n
            endif
         enddo
         do n=nrows, inserito, -1
            effeTab(n, 4) = effeTab(n,4) + absdf
            effeTab(n, 5) = effeTab(n, 5) + sclf
            effeTab(n, 6) = effeTab(n, 6) + 1
            effeTab(n, 7) = effeTab(n, 7) + fovet(i)
            effeTab(n, 8) = effeTab(n ,8) + work1(i) 
            effeTab(n, 9) = effeTab(n, 9) + fovet(i) * work1(i)
            effeTab(n,10) = effeTab(n,10) + fovet(i) * fovet(i)
            effeTab(n,11) = effeTab(n,11) + work1(i) * work1(i)
         enddo
      enddo
      erreT = sumdf / sumfo
      rfac = 100.0 * erreT
      write(lo,100) rfac, erre*100.0
!
      nend = 1
      do i = 1,nrows
         if (resolmax.lt.resolTab(i)) then
             nend = nend + 1
         endif
      enddo
      do n=1,nend
         erreTab(n,1) =  100.0 * effeTab(n,1) / effeTab(n,2)
         erreTab(n,2) =  100.0 * effeTab(n,4) / effeTab(n,5)
         if (effeTab(n,6) > 1.1) then
             effeTab(n, 7) = effeTab(n, 7) / effeTab(n,6)
             effeTab(n, 8) = effeTab(n, 8) / effeTab(n,6)
             effeTab(n, 9) = effeTab(n, 9) / effeTab(n,6)
             effeTab(n,10) = effeTab(n,10) / effeTab(n,6)
             effeTab(n,11) = effeTab(n,11) / effeTab(n,6)
             rnum = effeTab(n,9) - ( effeTab(n,7) * effeTab(n,8) )
             rden = sqrt( effeTab(n,10) - effeTab(n,7) **2 ) * 
     *              sqrt( effeTab(n,11) - effeTab(n,8) **2 )
             erreTab(n,3) =  rnum / rden
         elseif (effeTab(n,6) > 0.1) then
             erreTab(n,3) =  1.0
         else
             erreTab(n,3) =  0.0
         endif
      enddo
      write(lo,900) 
      write(lo,910) resolTab(1),erreTab(1,1), nint(effeTab(1,3)),
     *                          erreTab(1,2), nint(effeTab(1,6)),
     *                          erreTab(1,3)
      do i=2, nend
         write(lo,915) resolTab(i-1),resolTab(i),
     *                 erreTab(i,1), nint(effeTab(i,3)),
     *                 erreTab(i,2), nint(effeTab(i,6)),
     *                 erreTab(i,3)
      enddo
!
      return
   10 format(70('-'))
  100 format ('ERRE TOTALE = ',f8.2,'%')
  900 format(/,20x,'Distribution of R Factor',//,
     *'    Angstrom       R       No. of      R cum.    No. of',/,
     *'   resolution    factor     refl       factor     refl')
  910 format(3x,'up to',f5.1,2(3x,f6.2,2x,i7,4x),4x,f6.3)
  915 format(3x,f4.1,' -',f4.1,2(3x,f6.2,2x,i7,4x),4x,f6.3)
      end
!---------------------------------------------------------------
      subroutine ReComputeFobsNew()
      USE General
      USE Symmetry
      USE Riflessi
      USE Mappa
      USE riflessi_c
      USE PhaseModule
!
      logical :: noWrite,plusModel
      integer :: ncount,maxcount
      common/util2/noWrite,ncount,maxcount,plusModel
      common /util/radius,radius1
      dimension xs(3),xs1(3)
      integer sidepp
      character *200 CIROmap
!    
      call AllocaMappa(1)
      xenve(:,:,:) = 0.0 
!
!-- switch to the Patterson Space Group
!
      icent=1
      tmat(:,:)=0.
      call musym()
      nsymTot=nsym*(icent+1)*pts
c
c--faccio la mappa Patterson
c
      wt(:) = 0.0
      do i=1,nrefl
         wt(i) = 1
         fcoef(i) = fovet(i) * fovet(i)
      enddo
      jpatt = 1
      call MakeMap(fcoef, iphaz, nrefl, jpatt, xmap,
     *                FORTH, BACK)
c
c     CIROmap = 'ciro_no.map'
c     call CCP4MAPOUT(0,xmap,np,CIROmap)
!
!--determino il raggio di integrazione
!
      raggio=radius1
      write(lo,'(a,f6.2)') ' Radius of gyration :',raggio
!
!--modifico la mappa Patterson
!
      alim=raggio
      deltx=np(1)/cell(1)
      delty=np(2)/cell(2)
      deltz=np(3)/cell(3)
c
      if(kverbo>0) write(6,*) '  np   ',np,alim
c
      ca=cos(cell(4)*dtor)
      cb=cos(cell(5)*dtor)
      cg=cos(cell(6)*dtor)
c
      xs1(:)=0.0
      do kk1=1,ncentr
         coef=1.0
         kk3=1
         call xequi(xs1,kk3,coef,xs,kk1)
c
         iszu=int(xs(3)*np(3)+alim*deltz+1)
         iszl=int(xs(3)*np(3)-alim*deltz-1)
         isyu=int(xs(2)*np(2)+alim*delty+1)
         isyl=int(xs(2)*np(2)-alim*delty-1)
         isxu=int(xs(1)*np(1)+alim*deltx+1)
         isxl=int(xs(1)*np(1)-alim*deltx-1)
c
         do iz = iszl, iszu
            az = iz / deltz - xs(3) * cell(3)
            az2 = az * az
            il = sidepp(iz, np(3))
            do iy = isyl, isyu
               ay = iy / delty - xs(2) * cell(2)
               ay2 = ay * ay
               ik = sidepp(iy, np(2))
               do ix = isxl, isxu
                  ax = ix / deltx - xs(1) * cell(1)
                  ax2 = ax * ax
                  ih = sidepp(ix, np(1))
c
                  ray = ax2 + ay2 + az2 + 2.0 * ax * ay * cg +
     &               2.0 * ax * az * cb + 2.0 * ay * az * ca
                  ray=sqrt(ray)
c
                  dmin=funmia(ray, alim)
                  xenve(ih, ik, il) = dmin
c
               enddo
            enddo
         enddo
c
      enddo  ! fine loop sulla centratura
c--deb     
c     do ix=0,np(1)-1
c     do iy=0,np(2)-1
c     do iz=0,np(3)-1
c       write(95,'(3i5,f15.1)') ix,iy,iz,xenve(ix,iy,iz)
c     enddo
c     enddo
c     enddo
c     CIROmap = 'ciro_env.map'
c     call CCP4MAPOUT(0,xenve,np,CIROmap)
c
c     do ix=0,np(1)
c     do iy=0,np(2)
c       write(97,'(3i5,f15.1)') ix,iy,0,xmap(ix,iy,0)
c     enddo
c     enddo
c--deb     
      xmap=xmap*xenve
!
!--inverto la mappa Patterson modificata
!
      invflag = 0 
      numberToInv = nrefl
      call InvMap(khl,mkang,iphaz,fcvet,numberToInv)
      do i=1,nrefl
        fovet(i) = sqrt(fcvet(i))
      enddo
!
!-- restore the original Space Group
!
      call RestoreSpaceGroup
      noWrite=.false.
!
      call AllocaMappa(2)
!
      return
      end
!------------------------------------------------------------------
      function funmia(x,r)
      USE General
!
      x=x/r
      funmia=0.5*(1-TANH(2*pi*(x-1))) 
!
      return
      end
!---------------------------------------------------------------
      subroutine CalcolaPatterson()
      USE General
      USE Symmetry
      USE Riflessi
      USE Mappa
      USE riflessi_c
      USE PhaseModule
      USE MappaPatterson
!
      logical :: noWrite,plusModel
      integer :: ncount,maxcount
      common/util2/noWrite,ncount,maxcount,plusModel
      common /util/radius,radius1
      dimension xs(3),xs1(3)
      integer sidepp
!    
      call AllocaMappaPatterson(1)
      call AllocaMappa(1)
!
!-- switch to the Patterson Space Group
!
      icent=1
      tmat(:,:)=0.
      call musym()
      nsymTot=nsym*(icent+1)*pts
c
c--faccio la mappa Patterson
c
      wt(:) = 0.0
      do i=1,nrefl
         wt(i) = 1
         fcoef(i) = evet(i) * evet(i)
      enddo
      jpatt = 1
      call MakeMap(fcoef, iphaz, nrefl, jpatt, xmap,
     *                FORTH, BACK)
c
      call maxmin3d(denmin,denmax,avden,stden,npunt,0)
      write(6,'(a,4f10.1)') 'Mappa Patterson ',
     &                    denmin,denmax,avden,stden
c
!
!--determino il raggio di integrazione
!
      raggio=radius1
      write(lo,'(a,f6.2)') ' Radius of gyration :',raggio
!
!--modifico la mappa Patterson
!
      alim=raggio
      xmin=minval(cell(1:3))
      alimMin=0.5*xmin
      alim=min(alim,alimMin)
      deltx=np(1)/cell(1)
      delty=np(2)/cell(2)
      deltz=np(3)/cell(3)
c
      if(kverbo>0) write(6,*) '  np   ',np,alim
c
      ca=cos(cell(4)*dtor)
      cb=cos(cell(5)*dtor)
      cg=cos(cell(6)*dtor)
c
      xs1(:)=0.0
      do kk1=1,ncentr
         coef=1.0
         kk3=1
         call xequi(xs1,kk3,coef,xs,kk1)
c
         iszu=int(xs(3)*np(3)+alim*deltz+1)
         iszl=int(xs(3)*np(3)-alim*deltz-1)
         isyu=int(xs(2)*np(2)+alim*delty+1)
         isyl=int(xs(2)*np(2)-alim*delty-1)
         isxu=int(xs(1)*np(1)+alim*deltx+1)
         isxl=int(xs(1)*np(1)-alim*deltx-1)
c
         xenve(:,:,:)=0.0
         do iz = iszl, iszu
            az = iz / deltz - xs(3) * cell(3)
            az2 = az * az
            il = sidepp(iz, np(3))
            do iy = isyl, isyu
               ay = iy / delty - xs(2) * cell(2)
               ay2 = ay * ay
               ik = sidepp(iy, np(2))
               do ix = isxl, isxu
                  ax = ix / deltx - xs(1) * cell(1)
                  ax2 = ax * ax
                  ih = sidepp(ix, np(1))
c
                  ray = ax2 + ay2 + az2 + 2.0 * ax * ay * cg +
     &               2.0 * ax * az * cb + 2.0 * ay * az * ca
                  ray=sqrt(ray)
c                 if(ray<3.0) then
c                    xmap(ih,ik,il)=0.0
c                 endif
                  if(ray>5.0.and.ray<alim) then
                      xenve(ih,ik,il)=1.0
                  endif
c                 dmin=funmia(ray, alim)
c                 xenve(ih, ik, il) = dmin

               enddo
            enddo
         enddo
c
      enddo  ! fine loop sulla centratura
c
c     jpatt = 1
c     call CCP4MAPOUT(jpatt,xenve,np,'test.map')
c
      Patt=xmap*xenve
c     Patt=xmap ! occhio
c     call CCP4MAPOUT(1,Patt,np,'Patt_new.map')
c
      xmap=Patt
      call maxmin3d(denmin,denmax,avden,stden,npunt,0)
      write(6,'(a,4f10.1)') 'Mappa Patterson mod',
     &                    denmin,denmax,avden,stden
c
c--faccio un taglio sulla Patterson
c
      sog=3.0*stden
c     sog=5.0*stden
      do iz=0,np(3)-1
      do iy=0,np(2)-1
      do ix=0,np(1)-1
        if(Patt(ix,iy,iz)<sog) Patt(ix,iy,iz)=-1.0
      enddo
      enddo
      enddo
!
!-- restore the original Space Group
!
      call RestoreSpaceGroup
      noWrite=.false.
!
      call AllocaMappa(2)
!
      return
      end
!---------------------------------------------------------------
      subroutine AncoraFasiMR()
      USE General
      USE Riflessi
      USE RemoModule
      USE PhaseModule
!
      real newMR
!
      oldMR = 1.0 
      newMR = 1.0 - oldMR
      rewind 58
!      do i=1, nFasiMR 
!          read(58,*) j, iphaz(j), wt(j)
!	enddo
      return
      do i=1, nFasiMR 
          read(58,*) j,iphj,wtj
          if (wt(j).gt.0.001) then
              tannum = newMR * besinv(wt(j)) * sin( dtor * iphaz(j) ) +
     *                 oldMR * besinv(wtj)   * sin( dtor * iphj )
              tanden = newMR * besinv(wt(j)) * cos( dtor * iphaz(j) ) +
     *                 oldMR * besinv(wtj)   * cos( dtor * iphj )
              iphaz(j) = nint(mod(rtod*atan2(tannum,tanden)+
     *                                3600.,360.))
!              wt(j) = newMR * wt(i) + oldMR * wtj
          else
              iphaz(j) = iphj
              wt(j)    = wtj
          endif
      enddo
!
      return
      end
!---------------------------------------------------------------
      subroutine MoreMolecules(n)
      USE General
      USE Symmetry
      USE Solutions
      USE Riflessi
      USE RuotaRiflessi
      USE riflessi_c
      USE Atomi
      USE Molcom
      USE Mappa
      USE Finale
      USE Solutions
      USE TraslaSolution
      USE RemoModule
      USE PhaseModule

      integer :: n
      common /cent/ tl(3,4),fs(3,3,24),mlat
      dimension b(3,3),x1(3),x2(3),btra(3,3),BestShift(3),BestRotaz(3)
      dimension fragShift(3),delta(3)
      integer  npSav(3), ihmxS(3)
      character stringa*20
      dimension xopti(6), xopti1(6)
c     real xopti_2mon(12)
      logical single
      real, allocatable :: xopti_2mon(:)
      logical :: noWrite,plusModel
      integer :: ncount, maxcount
      common /util2/ noWrite, ncount, maxcount,plusModel
      common /skip/ tet_old(3), delta_old(3), tet123(3), delta123(3)


      if (knw > 0) write(6,*) 'Sono in MoreMolecules, soluzione #', nums

      i = maxval(MonomerInModel(1:numbModels))
      if (.not. Allocated(ang1))  then
           allocate (ang1(3,numbModels,i))
           allocate (shf1(3,numbModels,i))
      endif

      ifl = 2
      call InitFomModel(ifl,nreflSelTra)

      plusModel=.true.
 
      write(Msg,'(a,i2)') 'Adding model #',WhichModel
      call PrintMess(Msg)
      call DoSingleIteration()
!
      if (n == 1) then
          write(Msg,"('<big><b>Translation stage, model #',
     *          i3,'</b></big>')") WhichModel
          call TestoGR(Msg, color_RED, 2, 2)
      endif
!
      ier = 0
      BestShift(1:3) = 0.0
      BestRotaz(1:3) = 0.0
      trBest         = 0.0
      phBest         = 0.0
!!!   do i1=1, nFinalSolution
c-- dedi 2/12/19 - correzione dal terzo monomero
c     do i1=nums, nFinalSolution
c        finsolcan(i1)%flag(WhichModel,WhichMonomer) = -1
c     enddo
c-- dedi 2/12/19
c      ncontMonT = 0
      do ii=1, numbModels
         jj = MonomerInModel(ii)
         model(ii)%considerato(1:jj) = 0
c         ncontMonT = ncontMonT + jj
      enddo

c      allocate(xopti_2mon(1:6*ncontMonT), stat = ier1)
      ncontMon = 0
      do ii=1, WhichModel
         do jj = 1, MonomerInModel(ii)
            ncontMon = ncontMon + 1
            if(ii.eq.WhichModel .and. jj.eq.WhichMonomer ) exit 
         enddo
      enddo
      allocate(xopti_2mon(1:6*ncontMon), stat = ier1)
 

      do ii=1, WhichModel-1
         jj = MonomerInModel(ii)
         model(ii)%considerato(1:jj) = 1
      enddo
      fomBestE = -9999
      iBest=-1
      npSav(:)=np(:)
      ifExaminSav = ifExamin
      if (ifP1 == 1) then
          ifExamin    = 0
      endif
c
      if (nMolMRTot > 1) then
          if (kpol /= 0) then
              kpolSav = kpol
              kpol = 0
              call NewCheshire(2)
*             call WriteCheshire()
              kpol = kpolSav
          endif
      endif
!
      do j1=1, nFinalSolution
         work1(j1)  = finsolcan(j1)%Fom
         iwork1(j1) = j1
      enddo
      iuno = -1   
      call sortall3(iuno,work1,iuno,nFinalSolution,iwork1)
!
      npuntitot = nFinalSolution * nSolToExploreRot
      call storeGraphInfo(npuntitot)
      do j=1,nSolToExploreRot
         i = solcan(j)%ipunt
         work1(j)  = solcan(i)%RotFom
         iwork2(j) = i
         TrialDrop(j)=1.0
      enddo
      iuno = -1   
      call sortall3(iuno,work1,iuno,nSolToExploreRot,iwork2)
      do j=1,nSolToExploreRot
         i = iwork2(j)
*        if (solcan(i)%RotFom < 0) cycle  ! per velocizzare 1e8a
*        if (j > 50) cycle  ! per velocizzare 1e8a
         if (kverbo > 0) then
             write(lo,1) 'trial RFom',
     &                 solcan(i)%trial,solcan(i)%RotFom
         endif
      enddo
      if (WhichMonomer > 1) then
          write(Msg,2) nMolMR
      elseif (numbModels > 1) then
          write(Msg,3) WhichModel
          if (knw > 0) write(lo,4) WhichModel,numbModels
      endif
    2     format(' Search for ',i2,' monomer(s) related by NCS')
    3     format(' Search for ',i2,' model(s) ')
    4     format(' Search for model #',i2,' / ',i2)
    1 format(a,i8,f12.3)
! 
      write(Inte,'(i10)') WhichModel
      call NoBlanks(Inte, k1)
c     write(lo,30)
c     if (knw == 1) then
c         write(lo,20)
c     else
c         write(lo,21)
!
      call zflush()
      call DoSingleIteration()
      
      call scrper(' ',0,0)
!n

      do j1=nums, nums ! nums è definito a monte ed coincide con la soluzione
!-- dedi 2/12/19 - correzione dal terzo monomero
         i1 = iwork5(j1)
         finsolcan(i1)%flag(WhichModel,WhichMonomer) = -1
!??!     i1 = j1
!-- dedi 2/12/19
         do ii=1, numbModels
            jj = MonomerInModel(ii)
            model(ii)%considerato(1:jj) = 0
         enddo
         do ii=1, WhichModel-1
            jj = MonomerInModel(ii)
            model(ii)%considerato(1:jj) = 1
         enddo
         if (WhichMonomer > 1) then
             do j=1, WhichMonomer - 1
                model(WhichModel)%considerato(j) = 1
             enddo
         endif
!
         write(stringa,13) j1, nFinalSolution
         call NoBlanks(stringa,k1)    
!
         do ii=1, numbModels
            do j=1, MonomerInModel(ii)
               if (model(ii)%considerato(j) == 0) cycle
               tet1 = finsolcan(i1)%RotVal(1, ii, j)
               tet2 = finsolcan(i1)%RotVal(2, ii, j)
               tet3 = finsolcan(i1)%RotVal(3, ii, j)
               call RotationOper1(b,tet1,tet2,tet3)
               do m1=1,3
                  do m2=1,3
                     btra(m1,m2) = b(m2,m1)
                  enddo
               enddo
               do i = 1, natsInModel(ii)
                  x1(1:3) = model(ii)%saved(1:3,i,j)
                  call MoltMatVec(rm, x1, x2)
                  call MoltMatVec(btra, x2, x1)
                  call MoltMatVec(rmi, x1, x2)
                  model(ii)%atoms(1:3,i,j) = x2(1:3) 
     *                          + finsolcan(i1)%TraVal(1:3, ii, j)
               enddo
            enddo
         enddo
         fragShift(:) = 0.0
         call sftrNew(3, fragShift, dump,1)
         work1(j1)  = finsolcan(j1)%Fom

         if (knw > 0) then
             write(lo,30)
c            write(lo,310) j1, nFinalSolution
             write(lo,300) WhichModel,WhichModel-1
             write(lo,30)
         endif

         do k1=1, WhichModel-1
            do k2=1, MonomerInModel(k1)
               if (knw == 1) then
!                 write(lo,200)
!                 write(lo,'(i4,i8,2f8.3,f8.2)') j1,
!    &                 finsolcan(i1)%flag(k1,k2),
!    *                 finsolcan(i1)%RFom,  !RotFom
!    &                 finsolcan(i1)%Fom,   !TraFom 
!    *                 finsolcan(i1)%MPE
!              else
!                 write(lo,201)
!                 write(lo,'(i4,i8,2f8.3)') j1,
!    &                 finsolcan(i1)%flag(k1,k2),
!    *                 finsolcan(i1)%RFom,  !RotFom
!    &                 finsolcan(i1)%Fom    !TraFom

*                 if (k1 == 1) write(lo,198) j1, nFinalSolution 
*                 write(lo,'(16x,i8,2f8.3,f8.2)') 
*    &                 finsolcan(i1)%flag(k1,k2), 
*    *                 finsolcan(i1)%RFom,  !RotFom
*    &                 finsolcan(i1)%Fom,   !TraFom 
*    *                 finsolcan(i1)%MPE
*                 write(lo,'(a,i9,3f8.1,3f8.3)') 'RotVal e TraVal',
*    &                 finsolcan(i1)%flag(k1,k2), 
*    *                 finsolcan(i1)%RotVal(1:3,k1,k2)*rtod,
*    *                 finsolcan(i1)%TraVal(1:3,k1,k2)
*              else
*                 if (k1 == 1) write(lo,199) j1, nFinalSolution
*                 write(lo,'(16x,i8,2f8.3)') 
*    &                 finsolcan(i1)%flag(k1,k2), 
*    *                 finsolcan(i1)%RFom,  !RotFom
*    &                 finsolcan(i1)%Fom    !TraFom
               endif

               ang1(1:3,k1,k2) = finsolcan(i1)%RotVal(1:3,k1,k2)*rtod
               shf1(1:3,k1,k2) = finsolcan(i1)%TraVal(1:3,k1,k2)
            enddo

            k2 = 1
            if (k1 ==  WhichModel-1) then
                  tet_old(1:3) = finsolcan(i1)%RotVal(1:3,k1,k2)
                delta_old(1:3) = finsolcan(i1)%TraVal(1:3,k1,k2)
            endif

         enddo
         if (WhichMonomer > 1) then
            k1 = WhichModel
            do k2=1, WhichMonomer-1
               write(lo,'(i8,3f6.1,3f8.3,2f8.3,f8.2)')
     &                 finsolcan(i1)%flag(k1,k2), 
     *                 finsolcan(i1)%RotVal(1:3,k1,k2)*rtod,
     &                 finsolcan(i1)%TraVal(1:3,k1,k2),
     *                 finsolcan(i1)%Fom,
     &                 finsolcan(i1)%Fom,     
     *                 finsolcan(i1)%MPE
            enddo
         endif
c         if (TraAll(i1)%LocFom > fomBestE) then
c             fomBestE = TraAll(i1)%LocFom
c             WhichBestSolution = j1
c         endif
c         TrialCor(j1,1) = TraAll(i1)%LocFom
c         TrialCor(j1,2) = TraAll(i1)%MolMPE
         BestCorrMol = -9999
         BestCorrMol2 = finsolcan(i1)%Fom
crocco         jMolMR = 99
         jMolMR = WhichMonomer

         do ii=1, numbModels
            jj = MonomerInModel(ii)
            model(ii)%considerato(1:jj) = 0
         enddo
         model(WhichModel)%considerato(WhichMonomer) = 1
!
c        write(6,*) 'MoreMolecules: nSolToExploreRot=',nSolToExploreRot
         BestCorrMol1 = -9999
         ipoint=0
 
c           write(lo,30)
c           write(lo,301) WhichModel,WhichModel-1
            if (kverbo > 0 .or. knw > 0) then
                write(lo,320)
                if (knw > 0) then
                    if(nums == 1)  then
                       write(lo,330)
                    else
                       write(lo,340)
                    endif
                else
                    if(nums == 1)  then
                       write(lo,331)
                    else
                       write(lo,341)
                    endif
                endif
            endif


         ihmxS(:) = ihmx(:)
         do j2=1,nSolToExploreRot
            i2 = iwork2(j2)
*********** if (solcan(i2)%trial==finsolcan(i1)%flag(1,1)) cycle
*           if(solcan(i2)%RotFom<0) cycle  ! per velocizzare 1e8a
c           if(j2>50) cycle  ! per velocizzare 1e8a

            write(stringa,10) j2, nSolToExploreRot
            call NoBlanks(stringa,k)

            ang2(1:3) = solcan(i2)%RotVal(1:3)*rtod   ! rotazione nuovo monomero
            solcan(i2)%TraVal(1:3) = 0.0

c           write(lo,'(a,i6,3f6.1,3f8.3,f8.3)') '->',
c    &         solcan(i2)%trial, solcan(i2)%RotVal(1:3)*rtod,
c    &         solcan(i2)%TraVal(1:3),solcan(i2)%RotFom

            if (kverbo > 0 .or. knw > 0) then
            write(lo,'(a,i6,3f6.1,f8.3)') '->',
     &               solcan(i2)%trial, solcan(i2)%RotVal(1:3)*rtod,
     &               solcan(i2)%RotFom
            endif
!
!--elimino tutte le orientazioni uguali
!
            if (WhichMonomer > 1) then
                ies = 0
                do i=1, WhichMonomer - 1
                   ktrial = finsolcan(i1)%flag(WhichModel,i)
                   if (solcan(i2)%trial == ktrial) then
                       ies = 1
                       exit
                   endif
                enddo
                if (ies == 1) cycle
            endif
!
            tet1 = solcan(i2)%RotVal(1)
            tet2 = solcan(i2)%RotVal(2)
            tet3 = solcan(i2)%RotVal(3)

            tet123(1:3) = solcan(i2)%RotVal(1:3)

            call RotationOper1(b,tet1,tet2,tet3)
!  
            do i=1,3
               do j=1,3
                  btra(i,j) = b(j,i)
               enddo
            enddo
            do i = 1, natsInModel(WhichModel)
               x1(1:3) = model(WhichModel)%saved(1:3,i,WhichMonomer)
               call MoltMatVec(rm, x1, x2)
               call MoltMatVec(btra, x2, x1)
               call MoltMatVec(rmi, x1, x2)
               model(WhichModel)%atoms(1:3,i,WhichMonomer) = x2(1:3)
            enddo
            fragShift(:) = 0.0
            call sftrNew(1, fragShift, corre,1)
c
            if (mlat == 0) then
                call InitFour(0,ier)
            endif
            call TraslaFrammento2(j2,iBest,1)
!!!!!!      call OttimizzaRotoTraslazioni(iBest)
c
c--figura di merito per la selezione della coppia migliore
c

            corrT1 = TraSol(iBest)%TraCorr
            corrT = TraSol(iBest)%TraFom

Canna!!!!!!!!!!!!Attenzione!!!!!!!!!!!!!!!!!
c                   corrT = corrT1
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

c
            fragShift(1:3) = TraSol(iBest)%TraVal(1:3)
            erore=TraSol(iBest)%MolMPE
!
!--parte per valutare il miglioramento 
!
            if (corrT > BestCorrMol2) then
                BestCorrMol2=+9999999999999999999.0
            endif
!
!--parte per selezionare la coppia migliore
!
            if (corrT > BestCorrMol) then
!
!--data for graph (plot della sola correlazione)
!
                ipoint=ipoint+1      
                ra(ipoint)=corrT    
c
                BestCorrMol = corrT
                BestCorrMol1 = corrT1
                BestShift(1:3) = fragShift(1:3)
                BestRotaz(1:3) = solcan(i2)%RotVal(1:3)
                i1Best = i1
                i2Best = i2
                phBest = erore
                trBest = solcan(i2)%trial
                TrialCor(j1,1) = BestCorrMol
                TrialCor(j1,2) = phBest
            endif
c
         enddo  ! enddo su j2


         ihmx(:) = ihmxS(:)
         finsolcan(i1)%RotVal(1:3,WhichModel,WhichMonomer)
     *                        = BestRotaz(1:3)
         finsolcan(i1)%TraVal(1:3,WhichModel,WhichMonomer)
     *                        = BestShift(1:3)
         finsolcan(i1)%flag(WhichModel,WhichMonomer) = trBest
         finsolcan(i1)%Fom = BestCorrMol
         finsolcan(i1)%MPE = phBest
         if (kverbo > 0) then
             write(6,70) i1, nint(trBest), BestCorrMol, phBest,
     *               BestRotaz*rtod, BestShift
         endif

!--non ricerco ulteriori monomeri se non ho ho aggiunto alcuna rotazione 
         if (ipoint==0) exit 

!--------------------------------------------------------------------
c--minimizzazione locale 
c
!
c           write(6,*) '  Solution optimization '
            if (knw > 0) then
                write(lo,30)
                write(lo,19) WhichModel
            endif
            call preLocal()
            fomBestE = -9999.9
c
c--alloca mappa per minimizzazione locale
c
            call AllocaMappa(2)
            ifRemo=3
            call CheckGrid()
            ifRemo=1
            call AllocaMappa(1)
            do ii=1, WhichModel
               model(ii)%considerato(:) = 0
            enddo
            do ii=1, WhichModel-1
               jj = MonomerInModel(ii)
               model(ii)%considerato(1:jj) = 1
            enddo
             if (WhichMonomer > 1) then
                 do j=1, WhichMonomer - 1
                    model(WhichModel)%considerato(j) = 1
                 enddo
             endif

            do ii=1, numbModels
               do j=1, MonomerInModel(ii)
                  if (model(ii)%considerato(j) == 0) cycle
                  tet1 = finsolcan(i1)%RotVal(1,ii,j)
                  tet2 = finsolcan(i1)%RotVal(2,ii,j)
                  tet3 = finsolcan(i1)%RotVal(3,ii,j)
                  call RotationOper1(b,tet1,tet2,tet3)
c
                  do i=1,3
                     do jj=1,3
                        btra(i,jj) = b(jj,i)
                     enddo
                  enddo
                  do i = 1, natsInModel(ii)
                     x1(1:3) = model(ii)%saved(1:3,i,j)
                     call MoltMatVec(rm, x1, x2)
                     call MoltMatVec(btra, x2, x1)
                     call MoltMatVec(rmi, x1, x2)
                     model(ii)%atoms(1:3,i,j) = x2(1:3) 
                     if (ifRotOnly == 0) then      
                       icont=0
                       do jj=1,3
c                         if(CheCell(j)==0.0) cycle
                          icont=icont+1
                          model(ii)%atoms(jj,i,j) =
     *                        model(ii)%atoms(jj,i,j) 
     *                      + finsolcan(i1)%TraVal(icont,ii,j)
                       enddo
                     endif
                  enddo
               enddo
            enddo
            model(WhichModel)%considerato(WhichMonomer) = 1

            xopti(1:3) = BestRotaz(1:3) 
            xopti(4:6) = BestShift(1:3)
            fopti = BestCorrMol1
            single = .false.
            call scrper(Inte,0,0)

            if (ifPositionedVet(WhichModel) == 0) then
!               write(6,442) WhichModel, xopti(1:3)*rtod,
!    *                               xopti(4:6),fopti
                call LocalMin(xopti,fopti,single)!rocco
!               write(6,443) WhichModel, xopti(1:3)*rtod,
!    *                               xopti(4:6),fopti
            endif

 442  format('XOPTI in ingresso',i4,3f10.3,3f10.5,f9.5)
 443  format('XOPTI in uscita  ',i4,3f10.3,3f10.5,f9.5)

c
c--posiziono il modello in funzione dei nuovi parametri 
c
            tet1 = xopti(1)
            tet2 = xopti(2)
            tet3 = xopti(3)
            call RotationOper1(b,tet1,tet2,tet3)

            do i=1,3
               do j=1,3
                  btra(i,j) = b(j,i)
               enddo
            enddo
c!
            do i = 1,  natsInModel(WhichModel)
               x1(1:3) = model(WhichModel)%saved(1:3,i,WhichMonomer)
               call MoltMatVec(rm, x1, x2)
               call MoltMatVec(btra, x2, x1)
               call MoltMatVec(rmi, x1, x2)
               model(WhichModel)%atoms(1:3,i,WhichMonomer) = x2(1:3)
               if (ifRotOnly == 0) then      
                  icont=3
                  do jj=1,3
c                     if(CheCell(jj)==0.0) cycle
                     icont=icont+1
                     model(WhichModel)%atoms(jj,i,WhichMonomer) = 
     *                     model(WhichModel)%atoms(jj,i,WhichMonomer)
     *                   + xopti(icont)
                  enddo
               endif
            enddo
            badd = 0.0
            call ChemInfo_MR_Local(badd)
            call NewInv_MR_Local()
!
            jMolMR = ncontMon
            call cc_vet_mol(corre)
!
            n_fin = 6 * ncontMon   
            n_start =  n_fin - 5
            jj = 0
            do ii = 1, WhichModel
               do j=1, MonomerInModel(ii)
                  if(j==WhichMonomer .and. ii==WhichModel)exit 
                  jj = jj + 1
                  n_index = 6 * (jj-1) 
                  xopti_2mon(n_index+1:n_index+3) = 
     *                         finsolcan(i1)%RotVal(1:3,ii,j) 
                  xopti_2mon(n_index+4:n_index+6) = 
     *                         finsolcan(i1)%TraVal(1:3,ii,j)
!               write(6,444) ii, n_index, 
!    *                       xopti_2mon(n_index+1:n_index+3)*rtod,
!    *                       xopti_2mon(n_index+4:n_index+6)
               enddo
            enddo
 444  format('XOPTI_2mon n_index',2i4,3f10.3,3f10.5)
            
            xopti_2mon(n_start:n_fin) = xopti(1:6)
!           write(6,445) jj,n_start,xopti_2mon(n_start:n_start+2)*rtod,
!    *                       xopti_2mon(n_start+3:n_start+5)

 445  format('XOPTI_2mon n_start',2i4,3f10.3,3f10.5)

            call UpdateSol3(xopti_2mon,corre,i1,ncontMon)
c            write(6,70) j1, nint(trBest), finsolcan(j1)%Fom,
c     *      finsolcan(j1)%RotVal(1:3,WhichModel,WhichMonomer)*rtod,
c    *      finsolcan(j1)%TraVal(1:3,WhichModel,WhichMonomer)

            fopti = corre
            if (ifPositionedVet(WhichModel) == 0) then
                jj = 0   
                do ii = 1, WhichModel
                   jj = jj + 1
                   n_index = 6 * (jj-1)
!               write(6,446) ii, n_index, 
!    *                           xopti_2mon(n_index+1:n_index+3)*rtod,
!    *                           xopti_2mon(n_index+4:n_index+6),fopti 
                enddo
c               write(6,*) 'Prima di LocalMin_2mon'
c               write(6,*) xopti_2mon(:)
                call LocalMin_2mon(xopti_2mon,fopti)!rocco
c               write(6,*) 'Dopo    LocalMin_2mon'
c               write(6,*) xopti_2mon(:)
                jj = 0   
                do ii = 1, WhichModel
                   jj = jj + 1
                   n_index = 6 * (jj-1)
!               write(6,447) ii, n_index, 
!    *                           xopti_2mon(n_index+1:n_index+3)*rtod,
!    *                           xopti_2mon(n_index+4:n_index+6),fopti 
                enddo
            endif
 446  format('XOPTI in ingresso',2i4,3f10.3,3f10.5,f9.5)
 447  format('XOPTI in uscita  ',2i4,3f10.3,3f10.5,f9.5)
            call DoSingleIteration()
c            write(6,*)'corre', fopti
            call UpdateSol3(xopti_2mon,fopti,i1,ncontMon)

            if (knw > 0) then 
                write(lo,400)
                do ib=1,WhichModel 
                   do ia=1,WhichMonomer
                      write(lo,'(i8,3f6.1,3f8.3)')
     &                        finsolcan(i1)%flag(ib,ia),
     &                        finsolcan(i1)%RotVal(1:3,ib,ia)*rtod,
     &                        finsolcan(i1)%TraVal(1:3,ib,ia)
                   enddo
                enddo
                write(lo,410) finsolcan(i1)%Fom,finsolcan(i1)%MPE
                write(lo,30)
            else
*               write(lo,411) finsolcan(i1)%Fom
            endif

*           call NewFFom_MoreMolecules(i1)
            call FomRefmac_MoreMolecules(i1)

            if (knw == 1) then
                write(lo,420) finsolcan(i1)%Fom,finsolcan(i1)%MPE
                write(lo,30)
            else
*               write(lo,421) finsolcan(i1)%Fom
            endif
           
c            ra(ipoint+1)=finsolcan(j1)%Fom
c            call DataForGraph(8,ipoint)
c

!----------------------------------------------------------------------

      enddo ! fine loop su j1 ora j1==nums

c
****  IF (ALLOCATED(TraSol)) DEALLOCATE (TraSol, stat = ierr)
      call AllocaMappa(2)
      np(:) = npSav(:)
      ihmx(:)=ihmxSav(:)
      call AllocaMappa(1)
!
      ifExamin = ifExaminSav
!
      call MRInfo(8)
!
      return
   10 format('(',i5,'/',i5,')')
   12 format('[1-',i5,']')
   13 format(i5,'/',i5)
   15 format('Applies translation to Trial #',i6,2x,a)
   16 format('Applies translation to Trial #',i6,2x,a,
     *        '   Best correlation: ',f8.3)
   19 format(/,'  Optimizing solution of ',i2,
     * ' monomer(s)/model(s) via SIMPLEX method ',/,
     * '  NTFom is the overall figure of merit.')
!  20 format('   Trial      RotVal                 TraVal         ',
!    *       '  RFom    TFom    MPE',/,25x,
!    &       ' NFom    dx     dy     dz   MPE  BestNFom    TFom')
   21 format('   Trial   Rotation values     Translation values   ',
     *       '   RFom    TFom',/,25x,
     &       ' NFom    dx     dy     dz  BestNFom    TFom')
  198 format(' Solution ',i2,' /',i2,':  Trial    RFom    TFom    MPE')
  199 format(' Solution ',i2,' /',i2,':  Trial    RFom    TFom')
! 200 format(' Sol.  Trial    RFom    TFom    MPE')  ! per la stampa delle info sulla soluzione selezionata
! 201 format(' Sol.  Trial    RFom    TFom')  ! per la stampa delle info sulla soluzione selezionata
   22 format('   Trial      RotVal                 TraVal         ',
     *       '   RFom    TFom    MPE')
   23 format('   Trial   Rotation values     Translation values   ',
     *       '   RFom    TFom')
   30 format(80('-'))
  300 format(/,' Finding the position of the monomer/model ',i2,/,
     *       ' given the optimized location of the previous ',i2,
     *       ' monomer(s)/model(s)',/,
     *       ' NTFOM is the new figure of merit.')
  301 format(/,' Search for the monomer/model ',i2, /,
     *       ' given the optimized location of the previous ',i2,
     *       ' monomer(s)/model(s)',/)
  310 format(/,' Combinations for solution ',i2,' of ',i2,/)
  320 format(/,' In the table,  dx dy dz  is the translation applied ',
     * 'to the new monomer.',/)
  330 format('   Trial   Rotation values    RFom  # ',
     *        '    dx     dy     dz    TFom    MPE')
  331 format('   Trial   Rotation values    RFom  # ',
     *        '    dx     dy     dz    TFom')
  340 format('   Trial   Rotation values   NRFom  # ',
     *        '    dx     dy     dz    NTFom   MPE')
  341 format('   Trial   Rotation values   NRFom  # ',
     *        '    dx     dy     dz    NTFom')
  400 format(/,'   Trial   Rotation values     Translation values',/)
  410 format(/,'   For this combination:  NTFom =', f8.3,
     *                                  '  MPE =',f7.2,/)
  411 format(/,'   For this combination:  NTFom =', f8.3,/)
  420 format(/,'   For this combination:  NFFom =', f8.3,
     *                                  '  MPE =',f7.2,/)
  421 format(/,'   For this combination:  NFFom =', f8.3,/)
   35 format(30('-'),/,i10,f8.3,5x,f8.2,5x,3f8.3,5x,3f8.3,/,30('-'))
   40 format(i6,
     *      ' molecules specified, only ',i2,
     *      ' molecule(s) searched because of ')
   50 format(i6,' molecules specified, only ',i2,
     *          ' molecule(s) searched because of ')
   60 format('     the pseudo-translation: ',a)
   70 format('Best #',i3,' Trial, Fom, MPE',i8,f9.3,f8.2,3f8.1,3f8.3,/)
      end
!---------------------------------------------------------------
      subroutine OttimizzaRotoTraslazioni(iBest)
      USE General
      USE RemoModule
      USE TraslaSolution
      USE Molcom
!
      implicit none
      integer :: iBest, i, j, jj, icont
      real    :: xopti(6), fopti, tet1, tet2, tet3, b(3,3), btra(3,3)
      real    :: corre, badd, x1(3), x2(3)
      logical :: single
!
      if (ifPositionedVet(WhichModel) /= 0) then
          return
      endif
      write(6,*) 'OttimizzaRotoTraslazioni'
      call preLocal()
!
      xopti(1:3) = TraSol(iBest)%RotVal(1:3)
      xopti(4:6) = TraSol(iBest)%TraVal(1:3)
      fopti      = TraSol(iBest)%TraFom
      single = .true.
c     single = .false.
      call LocalMin(xopti,fopti,single)!rocco
!
!--posiziono il modello in funzione dei nuovi parametri 
!
      tet1 = xopti(1)
      tet2 = xopti(2)
      tet3 = xopti(3)
      call RotationOper1(b,tet1,tet2,tet3)

      do i=1,3
         do j=1,3
            btra(i,j) = b(j,i)
         enddo
      enddo
!
      do i = 1,  natsInModel(WhichModel)
         x1(1:3) = model(WhichModel)%saved(1:3,i,WhichMonomer)
         call MoltMatVec(rm, x1, x2)
         call MoltMatVec(btra, x2, x1)
         call MoltMatVec(rmi, x1, x2)
         model(WhichModel)%atoms(1:3,i,WhichMonomer) = x2(1:3)
         if (ifRotOnly == 0) then
            icont=3
            do jj=1,3
               icont=icont+1
               model(WhichModel)%atoms(jj,i,WhichMonomer) =
     *               model(WhichModel)%atoms(jj,i,WhichMonomer)
     *             + xopti(icont)
            enddo
         endif
      enddo
      badd = 0.0
      call ChemInfo_MR_Local(badd)
      call NewInv_MR_Local()
      call cc_vet_mol(corre)
      fopti = corre
      TraSol(iBest)%TraCorr = fopti
      TraSol(iBest)%TraFom  = fopti
      TraSol(iBest)%RotVal(1:3) = xopti(1:3)
      TraSol(iBest)%TraVal(1:3) = xopti(4:6)
!
      if (knw == 1) then
          write(lo,10) TraSol(iBest)%TraVal(1:3),
     &          TraSol(iBest)%TraFom, TraSol(iBest)%MolMPE
      endif
!
      return
   10 format(36x,"2)",3f7.3,f8.3,f7.2)
      end
!---------------------------------------------------------------
      subroutine OttimizzaRotoTraslazioni_New(i2, iBest)
      USE General
      USE RemoModule
      USE TraslaSolution
      USE Molcom
      USE Solutions
!
      implicit none
      integer :: i2, iBest, i, j, jj, icont
      real    :: xopti(6), fopti, tet1, tet2, tet3, b(3,3), btra(3,3)
      real    :: corre, badd, x1(3), x2(3)
      logical :: single
!
      if (ifPositionedVet(WhichModel) /= 0) then
          return
      endif
*     write(6,*) 'OttimizzaRotoTraslazioni'
      call preLocal()
!
      xopti(1:3) = solcan(i2)%RotVal(1:3)
      xopti(4:6) = TraSol(iBest)%TraVal(1:3)
      fopti      = TraSol(iBest)%TraFom
c     single = .false.
      single = .true.
*     write(6,'(a,3f6.1)') 'OTTI ', xopti(1:3)*rtod
      call LocalMin(xopti,fopti,single)!rocco
!
!--posiziono il modello in funzione dei nuovi parametri 
!
      tet1 = xopti(1)
      tet2 = xopti(2)
      tet3 = xopti(3)
      call RotationOper1(b,tet1,tet2,tet3)

      do i=1,3
         do j=1,3
            btra(i,j) = b(j,i)
         enddo
      enddo
!
      do i = 1,  natsInModel(WhichModel)
         x1(1:3) = model(WhichModel)%saved(1:3,i,WhichMonomer)
         call MoltMatVec(rm, x1, x2)
         call MoltMatVec(btra, x2, x1)
         call MoltMatVec(rmi, x1, x2)
         model(WhichModel)%atoms(1:3,i,WhichMonomer) = x2(1:3)
         if (ifRotOnly == 0) then
            icont=3
            do jj=1,3
               icont=icont+1
               model(WhichModel)%atoms(jj,i,WhichMonomer) =
     *               model(WhichModel)%atoms(jj,i,WhichMonomer)
     *             + xopti(icont)
            enddo
         endif
      enddo
      badd = 0.0
      call ChemInfo_MR_Local(badd)
      call NewInv_MR_Local()
      call cc_vet_mol(corre)
      fopti = corre
!
      if (knw == 1) then
          write(lo,10) solcan(i2)%trial,
     *          xopti(1:3)*rtod, solcan(i2)%RotFom,
     *          xopti(4:6), fopti, TraSol(iBest)%MolMPE
      endif
      solcan(i2)%RotVal(1:3) = xopti(1:3)
      TraSol(iBest)%TraCorr = fopti
      TraSol(iBest)%TraFom  = fopti
      TraSol(iBest)%TraVal(1:3) = xopti(4:6)
!
      return
   10 format('OT',i6,3f6.1,f8.3,'  2)',3f7.3,f8.3,f7.2)
      end
!---------------------------------------------------------------
      subroutine StampaFinalSolution(dove, ipr, riduci)
      USE General
      USE Riflessi
      USE RemoModule
      USE Finale
      USE Solutions
      USE TraslaSolution
      USE Html
      USE Groups, only : NumeroMonomeriInp
!
      integer :: ipr, dove  !   dove=lo oppure dove=iscra
      character*3 MPE
      logical :: riduci
!
      if (knw > 0) then
          write(6,*) 'STAMPAFINALSOLUTION ', ipr, dove
      endif
      if (knw == 1) then
          MPE = 'MPE'
      else
          MPE = '   '
      endif
      do j=1, nFinalSolution
         work1(j)  = finsolcan(j)%Fom
         iwork1(j) = j
      enddo
      iuno = -1   
      call sortall3(iuno,work1,iuno,nFinalSolution,iwork1)
!
      if (dove == lo) then
          j = iwork1(1)
          maybeVet(WhichModel) = finsolcan(j)%Fom
          maybeMPE(WhichModel) = finsolcan(j)%MPE
          if (knw > 0) then
              write(6,'(a,i3,2f8.3)') 'MAYBE ',WhichModel,
     *                                maybeVet(WhichModel),
     *                                maybeMPE(WhichModel)
          endif

      endif
!
      if (dove == lo) then
          if (ipr == 1) then
              write(dove,*)
              write(dove,60)
              write(dove,10) WhichModel
          else
              write(dove,*)
              write(dove,60)
              write(dove,15)
          endif
          write(dove,60)
          write(dove,20) MPE
      else
          if (ipr == 1) then
              write(dove,10) WhichModel
          else
              write(dove,15)
          endif
          write(dove,60)
          call MRInfo(99)  
          write(HTMLstr,30) MPE
          call MRInfo(99)  
      endif
!--dedi
!-------------------------------------------------------------
      if (knw > 0) then
          k1 = index(fname(1),'.bin') - 1
          write(Inte,198)  fname(1)(1:k1)
          istat = 0
          iform = 1
          jop=jopen(99,Inte,istat,iform,ierr)
          write(99,*)' +++ DETAILED MR POSITION +++'
          write(99,25) !!!!!! per stampa con Rot e Tra dettagliati
      endif
!
!-------------------------------------------------------------
!--dedi
      do jj=1, nFinalSolution
         j = iwork1(jj)
         do j1=1, WhichModel
            do j2=1, MonomerInModel(j1)
               if (finsolcan(j)%flag(j1,j2) == 0) cycle
               if (knw == 1) then
!!!!               write(HTMLstr,40) j,finsolcan(j)%flag(j1,j2),
                   write(HTMLstr,40) jj,finsolcan(j)%flag(j1,j2),
     *                            finsolcan(j)%RotVal(1:3,j1,j2)*rtod,
     *                            finsolcan(j)%TraVal(1:3,j1,j2),
     *                            finsolcan(j)%Fom,
     *                            finsolcan(j)%MPE
               else
!!!!               write(HTMLstr,40) j,finsolcan(j)%flag(j1,j2),
                   if (j1 == 1) then
                       write(HTMLstr,40) jj,finsolcan(j)%flag(j1,j2),
     *                              finsolcan(j)%RotVal(1:3,j1,j2)*rtod,
     *                              finsolcan(j)%TraVal(1:3,j1,j2),
     *                              finsolcan(j)%Fom 
                   else
                       write(HTMLstr,40) jj,finsolcan(j)%flag(j1,j2),
     *                              finsolcan(j)%RotVal(1:3,j1,j2)*rtod,
     *                              finsolcan(j)%TraVal(1:3,j1,j2)
                   endif
               endif
               if (dove == lo) then
                   write(lo,'(a)') HTMLstr(1:Lung(HTMLstr))
               else
                   call MRInfo(99)  
               endif

!--dedi - POSIZIONE DETTAGLIATA
               if (knw == 1) then
                   write(99,199) j,finsolcan(j)%flag(j1,j2),
     *                            finsolcan(j)%RotVal(1:3,j1,j2)*rtod,
     *                            finsolcan(j)%TraVal(1:3,j1,j2)
               endif
!--dedi

            enddo
         enddo
      enddo
*     if (ipr == 2 .and. dove == lo) then
      if (dove == lo .and. NumeroMonomeriInp == 0) then
*         if (numbModels > 1) then
          if (WhichModel > 1) then
              call RisistemaSoluzioni(riduci)
              write(dove,60)
              write(dove,20) MPE
              do jj=1, nFinalSolution
                 j = iwork1(jj)
                 do j1=1, WhichModel
                    do j2=1, MonomerInModel(j1)
                       if (finsolcan(j)%flag(j1,j2) == 0) cycle
                       if (knw == 1) then
                           write(HTMLstr,40) 
     *                           jj,finsolcan(j)%flag(j1,j2),
     *                           finsolcan(j)%RotVal(1:3,j1,j2)*rtod,
     *                           finsolcan(j)%TraVal(1:3,j1,j2),
     *                           finsolcan(j)%Fom,
     *                           finsolcan(j)%MPE
                       else
                           write(HTMLstr,40) 
     *                           jj,finsolcan(j)%flag(j1,j2),
     *                           finsolcan(j)%RotVal(1:3,j1,j2)*rtod,
     *                           finsolcan(j)%TraVal(1:3,j1,j2),
     *                           finsolcan(j)%Fom
                       endif
                       if (dove == lo) then
                           write(lo,'(a)') HTMLstr(1:Lung(HTMLstr))
                       else
                           call MRInfo(99)
                       endif
                    enddo
                 enddo
              enddo
          else
              if (WhichModel == numbModels) then
                  write(6,*) 'NUMBER OF MONOMERS FIXED TO ', numbModels
              endif
          endif
      endif

      if (knw == 1) then
          close(99)
      endif
 198  format(a,'_detail.txt')
 199  format(i4,i8,6f15.9)

      if (dove == lo) then
          write(dove,60)
!
          if (ipr == 1) then
              if (WhichModel < numbModels) then
                  call finsolcanSave
              endif
          endif
      endif
!
      return
   10 format(14('-'),' FINAL SOLUTION(S) - ',i2,
     *               ' monomer(s)/model(s) located ',14('-'))
   15 format(30('-'),' FINAL SOLUTION(S)  ',30('-'))
   20 format(' Sol.  Trial      Rotation values       Translation ',
*    *       'values      TFom      ',a3)
     *       'values      FFom      ',a3)
   25 format(' Sol   Trial '20x,'RotVal',40x,'TraVal')
   30 format('<b> Sol.  Trial      Rotation values       Translation ',
*    *       'values      TFom      ',a3,'<b>')
     *       'values      FFom      ',a3,'<b>')
   40 format(i4,i8,3f8.1,4f8.3,2x,f8.2)
   60 format(80('-'))
      end
!---------------------------------------------------------------
      subroutine PrintSolutions
      USE General
      USE Riflessi
      USE RemoModule
      USE Finale
      USE Solutions
      USE TraslaSolution
!
      implicit none
      integer :: j, jj, j1, j2, iuno
      character (len=3) :: MPE
!
*     write(6,*) 'PRINTSOLUTIONS nFinalSolution ', nFinalSolution
      if (knw == 1) then
          MPE = 'MPE'
      else
          MPE = '   '
      endif
      do j=1, nFinalSolution
         work1(j)  = finsolcan(j)%Fom
         iwork1(j) = j
      enddo
      iuno = -1
      call sortall3(iuno,work1,iuno,nFinalSolution,iwork1)
      if (knw == 1) write(lo,20) MPE
      do jj=1, nFinalSolution
         j = iwork1(jj)
         do j1=1, WhichModel
            do j2=1, MonomerInModel(j1)
               if (finsolcan(j)%flag(j1,j2) == 0) cycle
               if (knw == 1) then
                   write(lo,40) jj,finsolcan(j)%flag(j1,j2),
     *                          finsolcan(j)%RotVal(1:3,j1,j2)*rtod,
     *                          finsolcan(j)%TraVal(1:3,j1,j2),
     *                          finsolcan(j)%Fom,
     *                          finsolcan(j)%MPE
               endif
            enddo
         enddo
      enddo
*     write(6,*) 'END PRINTSOLUTIONS'
!
      return
   20 format(' Sol.  Trial      Rotation values       Translation ',
     *       'values      FFom      ',a3)
   40 format(i4,i8,3f8.1,4f8.3,2x,f8.2)
      end
!---------------------------------------------------------------
      subroutine finsolcanSave
      USE General
      USE Solutions
!
      implicit none
      integer :: i
!
*     write(6,*) 'FINSOLCANSAVE nFinalSolution ', nFinalSolution
      call PrintSolutions
      do i=1,nFinalSolution
         finsolcanSav(i)%RotVal(:,:,:) = finsolcan(i)%RotVal(:,:,:)
         finsolcanSav(i)%TraVal(:,:,:) = finsolcan(i)%TraVal(:,:,:)
         finsolcanSav(i)%flag(:,:)     = finsolcan(i)%flag(:,:)
         finsolcanSav(i)%Corr = finsolcan(i)%Corr
         finsolcanSav(i)%Rfom = finsolcan(i)%Rfom
         finsolcanSav(i)%Fom  = finsolcan(i)%Fom 
         finsolcanSav(i)%Fom_o= finsolcan(i)%Fom_o
         finsolcanSav(i)%Pkg  = finsolcan(i)%Pkg 
         finsolcanSav(i)%MPE  = finsolcan(i)%MPE
      enddo
!
      return
      end
!---------------------------------------------------------------
      subroutine finsolcanRestore
      USE General
      USE Solutions
!
      implicit none
      integer :: i
!
      write(6,*) 'FINSOLCANRESTORE nFinalSolution ', nFinalSolution
      do i=1,nFinalSolution
         finsolcan(i)%RotVal(:,:,:) = finsolcanSav(i)%RotVal(:,:,:) 
         finsolcan(i)%TraVal(:,:,:) = finsolcanSav(i)%TraVal(:,:,:) 
         finsolcan(i)%flag(:,:)     = finsolcanSav(i)%flag(:,:)     
         finsolcan(i)%Corr = finsolcanSav(i)%Corr
         finsolcan(i)%Rfom = finsolcanSav(i)%Rfom
         finsolcan(i)%Fom  = finsolcanSav(i)%Fom 
         finsolcan(i)%Fom_o= finsolcanSav(i)%Fom_o
         finsolcan(i)%Pkg  = finsolcanSav(i)%Pkg 
         finsolcan(i)%MPE  = finsolcanSav(i)%MPE
      enddo
      call PrintSolutions
!
      return
      end
!---------------------------------------------------------------
      subroutine RisistemaSoluzioni(riduci)
      USE General
      USE Riflessi, only: iwork1, work1
      USE RemoModule
      USE Finale
      USE Solutions
!
      implicit none
      integer :: j, jj, j1, j2, iuno
      real    :: soglia, pk, er0, er1, dr, ddr
      logical :: riduci
!
      write(6,*) 'RISIS modelli  ', WhichModel
!
      do j=1, nFinalSolution
         work1(j) = finsolcan(j)%Fom
         iwork1(j) = j
      enddo

      iuno = -1   
      call sortall3(iuno,work1,iuno,nFinalSolution,iwork1)
      j = iwork1(1) ! puntatore con l'ordine delle soluzioni
      call  Model4Clash(j)
      maybeCLA(WhichModel) = packRemo
      do j=1, WhichModel
         if (j == 1) then
             write(6,10) j, maybeVet(j), maybeMPE(j)
         else
             write(6,20) j, maybeVet(j), maybeMPE(j), maybeCLA(j)
         endif
      enddo
!
      pk = packRemo / 100.0
      er0 = 1.0 - maybeVet(WhichModel-1)
      er1 = 1.0 - maybeVet(WhichModel)
      if (pk < 0.1) pk = 0.1
      dr = er0 - er1
      write(6,30) er0, er1, dr,  pk, dr/pk
      if (dr < 0 .or. pk > 0.35) then
          write(6,*) 'RISIS RIDUCI TRUE'
          riduci = .true.
      else
          ddr = dr / pk
          if (ddr < 0.05) then
              write(6,*) 'RISIS RIDUCI TRUE'
              riduci = .true.
          else
              write(6,*) 'RISIS RIDUCI FALSE'
              if (numbModels == WhichModel) then
                  write(6,*) 'NUMBER OF MONOMERS FIXED TO ', numbModels
              endif
              riduci = .false.
          endif
      endif

      go to 1

      soglia = maybeVet(WhichModel-1) + 0.02
      if (maybeVet(WhichModel) > soglia) then
          if (packRemo < 10) then
              write(6,*) 'RISIS RIDUCI FALSE'
*             write(6,*) 'RISIS OK '
*             numbModels = WhichModel
              if (numbModels == WhichModel) then
                  write(6,*) 'NUMBER OF MONOMERS FIXED TO ', numbModels
              endif
              riduci = .false.
          else
              write(6,*) 'RISIS RIDUCI TRUE'
              riduci = .true.
          endif
      else
          write(6,*) 'RISIS RIDUCI TRUE'
          riduci = .true.
      endif

    1 continue

      if (riduci) then
          call finsolcanRestore
          do j=1, nFinalSolution
             finsolcan(j)%flag(WhichModel,1) = -1
             work1(j)  = finsolcan(j)%Fom
             iwork1(j) = j
          enddo
          iuno = -1
          call sortall3(iuno,work1,iuno,nFinalSolution,iwork1)
          WhichModel = WhichModel - 1
          numbModels = WhichModel
          write(6,*) 'NUMBER OF MONOMERS FIXED TO ', numbModels
      endif
!
      return
   10 format(' FOM(',i1,') = ', f8.3,' MPE = ',f8.2)
   20 format(' FOM(',i1,') = ', f8.3,' MPE = ',f8.2,' clash = ',f8.3)
   30 format(' R(m+1)   = ', f9.4,/,
     *       ' R(m)     = ', f9.4,/,
     *       ' DR       = ', f9.4,/,
     *       ' clash    = ', f9.4,/,
     *       ' DR/clash = ', f9.4,/)
      end
!---------------------------------------------------------------
      subroutine Model4Clash(j)
      USE General
      USE Riflessi, only: iwork1, work1
      USE RemoModule
      USE Finale
      USE Solutions
      USE Molcom
!
      implicit none
      integer :: j ! puntatore con l'ordine delle soluzioni
      integer :: i, i1, i2, j1, j2
      real    :: x1(3), x2(3), tet1, tet2, tet3, b(3,3), btra(3,3)
!
      do j1=1, WhichModel
         do j2=1, MonomerInModel(j1)
c
c--non considero la parte mancante
c  (coincide sempre con quella finale del multipletto)
c
            if (finsolcan(j)%flag(j1,j2) == -1) exit
            model(j1)%considerato(j2) = 1
c
            write(6,'(a,i8)') 'Trial in Model4Clash ',
     *                           finsolcan(j)%flag(j1,j2)
            tet1 = finsolcan(j)%RotVal(1,j1,j2)
            tet2 = finsolcan(j)%RotVal(2,j1,j2)
            tet3 = finsolcan(j)%RotVal(3,j1,j2)
            call RotationOper1(b,tet1,tet2,tet3)
!
            do i1=1,3
               do i2=1,3
                  btra(i1,i2) = b(i2,i1)
               enddo
            enddo
            do i=1, natsInModel(j1)
               x1(1:3) = model(j1)%saved(1:3,i,j2)
               call MoltMatVec(rm, x1, x2)
               call MoltMatVec(btra, x2, x1)
               call MoltMatVec(rmi, x1, x2)
               model(j1)%atoms(1:3,i,j2) = 
     *                   x2(1:3) + finsolcan(j)%TraVal(1:3,j1,j2)
            enddo
         enddo
      enddo
!
      call CalcoloPacking()
!
      return
      end
!---------------------------------------------------------------
      subroutine FillFinalSolution(MN)
      USE General
      USE RemoModule
      USE Finale
      USE Solutions
      USE TraslaSolution
!
!-- MN Monomer Number
!
      jj = 0
      do j=1, nFinalSolution
         i=TraAll(j)%ipunt

         if (TraAll(i)%TraFom < -99.00) cycle
         jj = jj + 1

         finsolcan(jj)%RotVal(1:3,WhichModel,MN) = TraAll(i)%RotVal(1:3)
         finsolcan(jj)%TraVal(1:3,WhichModel,MN) = TraAll(i)%TraVal(1:3)
         finsolcan(jj)%flag(WhichModel,MN)       = TraAll(i)%trial
         finsolcan(jj)%RFom = TraAll(i)%RotFom
         finsolcan(jj)%Fom = TraAll(i)%TraFom
         finsolcan(jj)%MPE = TraAll(i)%MolMPE
c        finsolcan(jj)%Corr = TraAll(i)%TraCorr  !TFom prima del simplesso
         finsolcan(jj)%Corr = TraAll(i)%TFom(1)  !TFom dopo  il  simplesso
      enddo
!
      nFinalSolution = jj
!
      return
      end
!---------------------------------------------------------------
      subroutine FillFinalSolution_OLD(MN)
      USE General
      USE RemoModule
      USE Finale
      USE Solutions
      USE TraslaSolution
!
!-- MN Monomer Number
!
      do j=1, nFinalSolution
         i=TraAll(j)%ipunt
         finsolcan(j)%RotVal(1:3,WhichModel,MN) = TraAll(i)%RotVal(1:3)
         finsolcan(j)%TraVal(1:3,WhichModel,MN) = TraAll(i)%TraVal(1:3)
         finsolcan(j)%flag(WhichModel,MN)       = TraAll(i)%trial
         finsolcan(j)%RFom = TraAll(i)%RotFom
         finsolcan(j)%Fom = TraAll(i)%TraFom
         finsolcan(j)%MPE = TraAll(i)%MolMPE
         finsolcan(j)%Corr = TraAll(i)%TraCorr

      enddo
!
      return
      end
!---------------------------------------------------------------
      subroutine FinalMR(rMTZ)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Molcom
      USE riflessi_c
      USE Finale
      USE RemoModule
      USE Solutions
      USE PhaseModule
      USE Mappa
      USE Grafici
      USE ArpWarp
      USE Align, only: ifAli, testProc
      USE Html
      USE RuotaRiflessi, only : nreflSelRot, nreflSelTra, nreflSelRemo
      USE PhMod
      USE TestModel, only : vett_test, CaOnly
!
      implicit none
      integer :: ncount, maxcount, box, doRicicla, rMTZ, VLD_OK, soft
      integer :: stampaMTZ, icic, numbGenLoc, nAMB_Sav, sav, filtra
      integer :: stampaInfo, ricAMB, ifSave, ifRestore, zero, uno
      integer :: jpatt, ifTime_sav, k, kk, k1, j, jj, j1, j2, i, i1, i2
      integer :: kFirst, iuno, iexc, iAction, jflag, numbPDB
      integer :: itype, iform, jop, jopen, ier, i3, ifFast, ifREM
      integer :: nRefi, NREFMAC, npunti, izero, ifmin, numb, nMacroBatch
      integer :: kstp, nurec, nMolMax, ki, k2, k3, kStripTask1, Lung 
      integer :: ifRicicla, ifExit, nSetBest, nset, kQuantiSets, stepS
      integer :: icicAMB, kkSav, ifReje, kk1, icont1, icont, ipher
      integer :: maxBatchCAB, nBC, inizBatchCAB, MacroBatch, identical
      logical :: fermati
      real    :: tet1, tet2, tet3, corre, fact_pack, packRemoBest, a
      real    :: CorrErrPack(100,4), sumfc, sumfo, scalan, sumdf
      real    :: absdf, cc_FoFc, FFom0, soglia, corre_o, rfac
      real    :: fomBestC, f000
      real    :: b(3,3), x1(3), x2(3), btra(3,3)
      real    :: fig(11), FFom_S, RfacAW_S, RfreAW_S, deltaRfAW, NTFom
      real    :: Save_FFom(100,10)
      real    :: scaletta, cost0, avefcw, avefcw_sca, rtot
      real    :: rrtt, rrttee, rrtt40, rmeno, rmenoee, rmeno40
      real    :: errePostCAB, errePostCABmin
      character (len= 5) :: a5
      character (len=11) :: tirang, string1
      character (len=20) :: stringa
      character (len=80) :: string2
      character(len=256) :: FileIn_1, FileOut_1, FileIn_2, FileOut_2
      character(len=256) :: FileIn_3, FileOut_3, FileOut_M, FileOut_R
      character(len=256) :: File_Mod, File_Ref, AmbPDBSav
      character(len=256) :: MTZfileSav, MTZRestore, PDBRestore
      logical :: noWrite, plusModel, Esiste
      common /erre_fom/rrtt, rrttee, rrtt40, avefcw, scaletta
      common /perMRinfo/ CorrErrPack
      common/util2/noWrite,ncount,maxcount,plusModel
      common /fasi/ nset
!
      icicAMB = 0
      fermati = .false.
      errePostCABmin = 9999
!-- riscrive il file della sequenza tenendo conto del numero di monomeri
!-- calcolato dal programma.
!
      call WriteExpSequence(Buffer1)
!
*     if (ifPhD == 1) then
          call AllocaRiflessiCow(1)
*     endif
      packRemoBest = 100
! -- dedi -- per inizializzare il valore di exposigma
      exposigma = 1
      kWstop = 0
!
!!!!!!       idSeq = 1.0  !!!per simulare REVA
!
      stampaInfo = 1
      RfacAW_S = 0.999
      RfreAW_S = 0.999
!
      ifFreeLunchMR_Sav = 0
      kWstop = 0
      ifRemoLegend = 0
      use_E = .false.
      call InitSigmaA(1)
c      call RestoreLists123(3)
!
      if(plusModel) nSolToExplore=nFinalSolution
      if (nSolToExplore == 0) then
          nSolToExplore = 1
      endif
      MaxToStore = nSolToExplore
      nSetsMaxFineDSR = min0(nSolToExplore, 5)
!gl!  call nfrm17()
      call ManageFinalPhases(1, nrefl, nSetsMaxFineDSR)
!gl!  call sfl17()
!gl!  call LoadFinalPhases(FomsFineDSR, iposFineDSR,
!gl! *                     nsetFinalPhases)
      nSetsFineDSR = 0
      Save_FFom(:,:) = 0.0

!
!-- calcolo e memorizzazione mappa vera per correlazione
!
      if (knw == 1) then
          fcoef(1:nrefl) = fovet(1:nrefl)
          iphaz(1:nrefl) = ipub(1:nrefl)
          wt(1:nrefl) = 1.0
          jpatt = 0
          call MakeMap(fcoef, iphaz, nrefl, jpatt, xmap,
     *                FORTH, BACK)
          call Scrivi_Mappa_Vera(2)
      endif
!
      
      ifTime_sav = ifTime
      ifTime = 0 !1
c     if (knw == 1) then
c         write(lo,335)
c     endif

      k  = index(fname(1),'.')
      if (nSolToExplore == 1) then
          stringa = '1'
          k1 = 1
      else
          write(stringa,12) nSolToExplore
          call NoBlanks(stringa,k1)
      endif

      call scrper('Final MR calculations...',0,-1)


!---  modifiche dedi per ordinamento nuove Foms (NTFom, FinalFom)

!
!--ordino le soluzioni secondo la figura di merito (TFom)
!
      fomBestE=-99999
      do j=1, nFinalSolution
         if (finsolcan(j)%Fom > fomBestE) then
             fomBestE = finsolcan(j)%Fom
             WhichBestSolution = j
         endif
         work1(j) = finsolcan(j)%Fom
         iwork2(j) = j
      enddo

      iuno = -1   
      call sortall3(iuno,work1,iuno,nFinalSolution,iwork2)
!
!--costruisco le soluzioni gia' ordinate in f.ne di TFom
!
      do jj=1, nFinalSolution
         do j1=1, numbModels
            j2 = MonomerInModel(j1)
            model(j1)%considerato(1:j2) = 0
         enddo
*        write(6,*) 'PRIMA DI PREPACK'
         j = iwork2(jj) ! puntatore con l'ordine delle soluzioni
         do j1=1, numbModels
            do j2=1, MonomerInModel(j1)
c
c--non considero la parte mancante
c  (coincide sempre con quella finale del multipletto)
c
               if (finsolcan(j)%flag(j1,j2) == -1) exit
               model(j1)%considerato(j2) = 1
c
               tet1 = finsolcan(j)%RotVal(1,j1,j2)
               tet2 = finsolcan(j)%RotVal(2,j1,j2)
               tet3 = finsolcan(j)%RotVal(3,j1,j2)
               call RotationOper1(b,tet1,tet2,tet3)
!
               do i1=1,3
                  do i2=1,3
                     btra(i1,i2) = b(i2,i1)
                  enddo
               enddo
               do i=1, natsInModel(j1)
                  x1(1:3) = model(j1)%saved(1:3,i,j2)
                  call MoltMatVec(rm, x1, x2)
                  call MoltMatVec(btra, x2, x1)
                  call MoltMatVec(rmi, x1, x2)
                  model(j1)%atoms(1:3,i,j2) = 
     *                      x2(1:3) + finsolcan(j)%TraVal(1:3,j1,j2)
*        write(6,11) i, model(j1)%atoms(1:3,i,j2), 
*    *               model(j1)%specie(i,j2), model(j1)%th_fact(i,j2)
*  11 format(i6,3f10.6,i7,f8.3)
               enddo
            enddo
         enddo
!
!--calcolo dell'impacchettamento della soluzione jj 
!   (gia' ordinata per figura di merito TFom)
!

!!!      call PrePacking(j)
!
c        if (nsym == 1 .and. icent == 0) then

c            packRemo=0.0
c            packRemoBest=packRemo
c
c            corre = finsolcan(j)%Fom
c            finsolcan(j)%Fom_o = corre

c            fact_pack = 1.0 
c
c        else

             call CalcoloPacking()
             if(jj==1) packRemoBest=packRemo
!
             corre = finsolcan(j)%Fom
             finsolcan(j)%Fom_o = corre


             fact_pack = 1.0 - (0.8 * packRemo/100.)
             fact_pack = max(fact_pack,0.2)

!-  non applico il riscalamento in f.ne del Clash se < 8% o se DNA-RNA

             if (packRemo < 8.0 .or. ifDNA == 1) then
                fact_pack = 1.0
             endif

!- se il clash è > 20%, la FOM viene abbattuta

             if (packRemo > 20.0 .and. ifDNA == 0) then
                fact_pack = 1.0 - packRemo/100.
             endif

c        endif

         NTFom = corre  * fact_pack

         finsolcan(j)%Fom = NTFom    !Xchè fouri dall'if su kFirst = 1 ????
         finsolcan(j)%Pkg = packRemo
!
         kFirst = 1 
         do j1=1, numbModels 
            do j2=1, MonomerInModel(j1)
               if (finsolcan(j)%flag(j1,j2) /= -1) then
                   if (kFirst == 1) then 
                       kFirst = 0 
c?Xchè commentata      NTFom = corre  * fact_pack
c?Xchè commentata      finsolcan(j)%Fom = NTFom
                   endif
               endif
            enddo
         enddo
!
      enddo !1, nFinalSolution
!
!---  modifiche dedi per ordinamento NTFom
!--ordino le soluzioni secondo la figura di merito (NTFom)
!
      fomBestE=-99999
      do j=1, nFinalSolution
         if (finsolcan(j)%Fom > fomBestE) then
             fomBestE = finsolcan(j)%Fom
             WhichBestSolution = j
         endif
         work1(j) = finsolcan(j)%Fom
         iwork2(j) = j
      enddo

      iuno = -1   
      call sortall3(iuno,work1,iuno,nFinalSolution,iwork2)
      if (setMR /=1) then
          k = iwork2(setMR)
          j = iwork2(1)
          iwork2(1) = k
          iwork2(setMR) = j
          a = finsolcan(j)%Fom
          finsolcan(j)%Fom = finsolcan(k)%Fom
          finsolcan(k)%Fom = a
      endif

      jwork1(1:nFinalSolution) = iwork2(1:nFinalSolution)
!
!--costruisco le soluzioni gia' ordinate in f.ne di NTFom
!
c     numbLSQ = 0.7 * nrefl
      iexc = 1
      call cc_vet0_all(iexc,nrefl)

      do jj=1, nFinalSolution

         iwork2(jj) = jwork1(jj)
         do j1=1, numbModels
            j2 = MonomerInModel(j1)
            model(j1)%considerato(1:j2) = 0
         enddo
         j = iwork2(jj) ! puntatore con l'ordine delle soluzioni
         do j1=1, numbModels
            do j2=1, MonomerInModel(j1)
c
c--non considero la parte mancante
c  (coincide sempre con quella finale del multipletto)
c
               if (finsolcan(j)%flag(j1,j2) == -1) exit
               model(j1)%considerato(j2) = 1
c
               tet1 = finsolcan(j)%RotVal(1,j1,j2)
               tet2 = finsolcan(j)%RotVal(2,j1,j2)
               tet3 = finsolcan(j)%RotVal(3,j1,j2)
               call RotationOper1(b,tet1,tet2,tet3)
!
               do i1=1,3
                  do i2=1,3
                     btra(i1,i2) = b(i2,i1)
                  enddo
               enddo
               do i=1, natsInModel(j1)
                  x1(1:3) = model(j1)%saved(1:3,i,j2)
                  call MoltMatVec(rm, x1, x2)
                  call MoltMatVec(btra, x2, x1)
                  call MoltMatVec(rmi, x1, x2)
                  model(j1)%atoms(1:3,i,j2) =
     *                      x2(1:3) + finsolcan(j)%TraVal(1:3,j1,j2)
               enddo
            enddo
         enddo

!
         iAction = 1
         call EsportaMR(iAction, j, jj)

         goto 2233      ! commentare x versione 26 giugno
!
c--calcolo rigoroso, ma lento   
c        iCoeff = 0 ! occhio
c        mode = 1
c        iref = 0
c        call sftryyyRemo(nrefl,scalan,iCoeff)
c--calcolo approssimato, ma veloce   

         call ChemInfo_MR_Final()
         call NewInv_MR_Final()

!       tmpwt(:) = 1.0
!       ifTime = 0
!       izero = 0
!       ifmin = 0 !1
!       call examin(2222,mkang,khl,ipub,iphaz,nrefl,
!    *              izero,tmpwt,ifmin)
!       write(6,'(a,i8,a,f8.2)') ' MPE su tutti ', isumal,
!    *        ' riflessi ',erore
!
!--  compute r-factor and scale fcvet values
!
         sumfc=0.0
         sumfo=0.0
         do i=1,nrefl
            sumfc=sumfc+fcvet(i)
            sumfo=sumfo+fovet(i)
         enddo
         scalan=sumfc/sumfo
         sumdf=0.0
         sumfo=0.0
         do i=1,nrefl
            absdf=abs(fcvet(i)-scalan*fovet(i))
            sumdf=sumdf+absdf
            sumfo=sumfo+scalan*fovet(i)
            fcvet(i)=fcvet(i)/scalan ! occhio
         enddo
         erre=sumdf/sumfo
         if(j==1) erreBest=erre
c
         jflag  = 1
         call PresigmaA(jflag, 1)

 2233 continue
*       goto 3322   ! attivare x versione 26 giugno

         write(a5,13) jj
   13 format ('_',i4)
         call NoBlanks(a5,k1)
         WhichSolution = j
         numbPDB = 0
         kk = 0
         do i1=1, numbModels
            do i2=1, MonomerInModel(i1)
               if (finsolcan(j)%flag(i1,i2) == -1) then
                   kk = kk + 1
               else
                   numbPDB = numbPDB + natsInModel(i1)
               endif
            enddo
         enddo
         if (kk == 0) then
             numbPDB = -1
         endif

         FichierOut = nome(1:lnome)//'_FinalMR'//a5(1:k1)//'.pdb'
         itype = 0
         iform = 1
         jop = jopen(jhost,FichierOut,itype,iform,ier)
!
!-- filtra il pdb per gli atomi di tipo OT
!
         filtra = 0
         do i1=1, size(model)
            if (.not.allocated(model(i1)%atoms)) cycle
            do i2=1, MonomerInModel(i1)
               do i3=1, natsInModel(i1)
                  if (model(i1)%tipoAtomo(i3,i2)(1:4)
     *                == 'ot  ') then
                      model(i1)%HETA(i3,i2) = -1
                      filtra = 1
                  endif
               enddo
            enddo
         enddo
!
         card(1)='REMARK    '//
     &              ' Model obtained by REMO,'//
     &           ' the Molecular Replacement routine of Sir2019'
         write(card(2),'("REMARK     Solution number: ",i5)') jj
         write(card(3),
     &          '("REMARK     Figure of merit (correlation): ",f8.3)')
     &          finsolcan(j)%Fom

         ifFast = 2
         ifREM = 3
         call outPDB(jhost, numbPDB, ifFast, ifREM, filtra)
         close(jhost)
         call ManageSe

         nRefi = 10 !5  !(1)
         nRefi = 2  ! gianluca 30 luglio 2019
!cristina
         if (ifCristina == 1) then
*            nRefi = 0
         endif
         NREFMAC = nRefi
         cardImage = cardDiret
         call UseRefmac(FichierOut, nRefi, 0, NREFMAC, 0, ier)

!
!-- gianluca 31 ottobre 2019
!
             packRemo = finsolcan(j)%Pkg
             fact_pack = 1.0 - (0.8 * packRemo/100.)
             fact_pack = max(fact_pack,0.2)

!-  non applico il riscalamento in f.ne del Clash se < 8% o se DNA-RNA

             if (packRemo < 8.0 .or. ifDNA == 1) then
                fact_pack = 1.0
             endif

!- se il clash è > 20%, la FOM viene abbattuta

             if (packRemo > 20.0 .and. ifDNA == 0) then
                fact_pack = 1.0 - packRemo/100.
             endif


*            fact_pack = 1.0   ! TEST


             FFom0 = finsolcan(j)%Fom
             FFom = 1.0 - RfacAW
             finsolcan(j)%Fom = FFom
             finsolcan(j)%Fom = FFom * fact_pack

         if(j==1) erreBest=RfacAW
! prova Dedi
         zero = 0.0000000001
         npunti = 0
         fcoef(:) = 0.0
         worko(:) = 0.0
         do i = 1, nrefl
            if (fcvet(i) > zero) then
                fcoef(i) = fovet(i)
                worko(i) = fcvet(i)
                npunti = npunti + 1
            endif
         enddo

         call cc_vet(fcoef,worko,npunti,cc_FoFc)
! prova Dedi
 3322 continue    ! versione 26 giugno


!       write(6,'(a,i8,a,f8.2)') ' MPE su ', nreflSelTra,
!    *        ' riflessi ',finsolcan(j)%MPE
        ifTime = 0
        izero = 0
        ifmin = 1
        call examin(2222,mkang,khl,ipub,iphaz,nrefl,
     *              izero,wt,ifmin)
*       enddo
!
!-- GIANLUCA --
!
        go to 2

        do i=1, nrefl
           iworkt(i) = i
           wvar(i) = wt(i)
        enddo
        call sort3_big(wvar, iworkt, worko, nrefl)
        numb = float(nrefl) * 0.66
        numb = float(nrefl) * 0.50
        soglia = worko(numb)
        do i=1, nrefl
           if (wt(i) < soglia) then
               wt(i) = 0.0
           endif
        enddo
        ifTime = 0
        izero = 0
        ifmin = 1
        call examin(2223,mkang,khl,ipub,iphaz,nrefl,
     *              izero,wt,ifmin)

    2 continue

!
!-- GIANLUCA --
!
!       write(6,'(a,i8,a,f8.2)') ' MPE su tutti ', isumal,
!    *        ' riflessi ',erore


!
!--scrivo le linee di REMARK  del file PDB
!
         card(1)='REMARK    '//
     &         ' Model obtained by REMO,'//
     & ' the Molecular Replacement routine of Sir2019'
         write(card(2),'("REMARK     Solution number: ",i5)') jj
         write(card(3),
     &     '("REMARK     Figure of merit (correlation): ",f8.3)')
     &     finsolcan(j)%Fom
!
!--scrivo il file *_remo_#.pdb
!
         iAction = 2
         call EsportaMR(iAction, j, jj)
!
! - vecchio calcolo di FFom con Fc da inversione di mappa di gaussiane
!
!!!      iflg = 3 
!!!      call NewFFom0(iflg,jj,j,rmeno)
!!!      costo = rmeno


!!!      packRemo = finsolcan(j)%Pkg
!!!      fact_pack = 1.0 - (0.8 * packRemo/100.)
!!!      fact_pack = max(fact_pack,0.2)
!!!      FinalFom = costo  * fact_pack
c        if (knw == 1) then
c            write(6,'(a,i3,f8.3,f8.2,7f8.3,f8.2)') 'FOMs = ',
c    *             j, finsolcan(j)%Fom, finsolcan(j)%MPE, cost0, 
c    *             rmeno, rmenoee, rmeno40, avefcw_sca, 
c    *             costo, FinalFom, erore
c            write(6,*) ' '
c        endif
!

         FinalFom = finsolcan(j)%Fom

         if (knw == 1) then
             worko(:) = fcvet(:)
!            nbru = j
             izero = 0
             ifmin = 0 !1
             call examin(1133,mkang,khl,ipub,iphaz,nrefl,izero,
     *                   wt,ifmin)
             if (fact_pack < 1.0) write(lo,112)  erore, nrefl, FinalFom
             write(lo,30)
!
!-- correlazione di mappa
!
!??!         fcoef(:) = fcoef(:) * wt(:)
             fcoef(:) = fovet(:) * wt(:)
             jpatt = 0
             call MakeMap(fcoef, iphaz, nrefl, jpatt, xmap,
     *                FORTH, BACK)
             kstp = 0
             call Calcola_CC_Mappa(nrefl, correMappa, kstp, 2)
             fcvet(:) = worko(:)
         endif

 112  format(' After Clash   MPE', f8.2,' over',i7,
     *' reflections.   FFom =',2f9.3)
!

         Save_FFom(j,1) = finsolcan(j)%Fom_o
         Save_FFom(j,2) = finsolcan(j)%Fom
         Save_FFom(j,3) = FinalFom
         Save_FFom(j,4) = finsolcan(j)%Pkg
         Save_FFom(j,5) = erore
         Save_FFom(j,6) = erre
         Save_FFom(j,7) = correMappa

c        write(6,*) jj,j,Save_FFom(j,1:7)

c        finsolcan(j)%Fom_o = finsolcan(j)%Fom
         finsolcan(j)%Fom = FinalFom

         EarlyFom = finsolcan(j)%Fom_o
         FinalFom = finsolcan(j)%Fom
         numbrun = j
         numbLSQ=nrefl
!!!      call LeggiFasiRefmac(j)
         call ManagePhasesDSR(1,correMappa,0)



c        ifTime = 1
      enddo   ! jj=1, nFinalSolution
 
!---  modifiche dedi per ordinamento FinalFom

!
!--ordino le soluzioni secondo la figura di merito (FinalFom)
!
      fomBestE=-99999
      do j=1, nFinalSolution
         if (finsolcan(j)%Fom > fomBestE) then
             fomBestE = finsolcan(j)%Fom
             WhichBestSolution = j
         endif
         work1(j) = finsolcan(j)%Fom
         iwork2(j) = j
      enddo

      iuno = -1   
      call sortall3(iuno,work1,iuno,nFinalSolution,iwork2)
      if (setMR /=1) then
          k = iwork2(setMR)
          j = iwork2(1)
          iwork2(1) = k
          iwork2(setMR) = j
          a = finsolcan(j)%Fom
          finsolcan(j)%Fom = finsolcan(k)%Fom
          finsolcan(k)%Fom = a
      endif

      jwork1(1:nFinalSolution) = iwork2(1:nFinalSolution)
!
!--costruisco le soluzioni gia' ordinate in f.ne di NTFom
!
      if (knw == 1) then
          write(lo,35)

          if (knw == 1) then
              if (ifTime == 0) then
                  write(lo,40)
              else
                  write(lo,41)
              endif
          else
              write(lo,30)
              write(lo,45)
          endif
      endif

      do jj=1, nFinalSolution

         iwork2(jj) = jwork1(jj)
         do j1=1, numbModels
            j2 = MonomerInModel(j1)
            model(j1)%considerato(1:j2) = 0
         enddo
         j = iwork2(jj) ! puntatore con l'ordine delle soluzioni
         do j1=1, numbModels
            do j2=1, MonomerInModel(j1)
c
c--non considero la parte mancante
c  (coincide sempre con quella finale del multipletto)
c
               if (finsolcan(j)%flag(j1,j2) == -1) exit
               model(j1)%considerato(j2) = 1
c
               tet1 = finsolcan(j)%RotVal(1,j1,j2)
               tet2 = finsolcan(j)%RotVal(2,j1,j2)
               tet3 = finsolcan(j)%RotVal(3,j1,j2)
               call RotationOper1(b,tet1,tet2,tet3)
!
               do i1=1,3
                  do i2=1,3
                     btra(i1,i2) = b(i2,i1)
                  enddo
               enddo
               do i=1, natsInModel(j1)
                  x1(1:3) = model(j1)%saved(1:3,i,j2)
                  call MoltMatVec(rm, x1, x2)
                  call MoltMatVec(btra, x2, x1)
                  call MoltMatVec(rmi, x1, x2)
                  model(j1)%atoms(1:3,i,j2) =
     *                      x2(1:3) + finsolcan(j)%TraVal(1:3,j1,j2)
               enddo
            enddo
         enddo
!
         corre = finsolcan(j)%Fom
         corre_o = finsolcan(j)%Fom_o
         packRemo = finsolcan(j)%Pkg
         error = finsolcan(j)%MPE
         erre =  Save_FFom(j,6)
         rfac  = erre * 100.0
         erore = Save_FFom(j,5)
         correMappa = Save_FFom(j,7)
         work1(jj)=erre
         work1(jj+100)=packRemo
         work2(jj)=correMappa
         work2(jj+100)=erore
         CorrErrPack(jj, 1) = correMappa
         CorrErrPack(jj, 2) = erore
         CorrErrPack(jj, 3) = erre
         CorrErrPack(jj, 4) = packRemo


!
         kFirst = 1 
         do j1=1, numbModels 
            do j2=1, MonomerInModel(j1)
               if (finsolcan(j)%flag(j1,j2) == -1) then
                   write(lo,52) j1, j2
               else
                   if (kFirst == 1) then 
                       kFirst = 0 
                       NTFom = corre     !Xchè nell'if sua kFirst = 1   ????
                       if (knw == 1) then
                           if (ifTime == 0) then
!!!                            write(lo,49) j, corre_o, error,
                               write(lo,49) jj, corre_o, error,
     *                              packRemo, NTFom, correMappa, erore
                           else
!!!                            write(lo,49) j, corre_o, error, 
                               write(lo,49) jj, corre_o, error, 
     *                              packRemo, NTFom
                           endif
                       else
c                          write(lo,50) j, corre_o, packRemo, NTFom
*                          write(lo,50) j, packRemo, NTFom
                       endif
                       corre = NTFom 
                   endif
               endif
            enddo
         enddo
!
         Buffer16(  1) = erre
         Buffer16(2:4) = 0.0
         Buffer16(5:7) = 0.0
         Buffer16(  8) = corre
         Buffer16(  9) = 0
         Buffer16( 10) = erore
         cfom(j1)      = corre
         ipos(j1)      = j
!
         nurec = j1
!         
      enddo   ! jj=1, nFinalSolution

c     fomBestE=-99999
c     do j=1, nSetsFineDsr
c        if (FomsFineDSR(j) > fomBestE) then
c            fomBestE = FomsFineDSR(j)
c            nSetBest = j
c        endif
c     enddo
!

!--memorizzo il valore di packing per la migliore soluzione
!
      packRemo=packRemoBest
!
!--memorizzo il valore di R per la migliore soluzione
!
      erre=erreBest
!
      write(lo,30)
      call ManagePhasesDSR(2,corre,0)
!      
      iAction = 0
      call FilesInfo(iAction, nSetsFineDSR)
!
      nMolMax = maxval(MonomerInModel(1:numbModels))
*     if (nMolMax > 1) then
          nSolToExplore = nFinalSolution
          call MRInfo(5)
*     endif
!
!-- Scrive i risultati sulla White Board
!
      write(Inte,'(i5)') WhichBestSolution
      call NoBlanks(Inte, ki)
      fomBestC = finsolcan(WhichBestSolution)%Corr
      write(string2,32) Inte(1:ki), fomBestC, erre*100, packRemo
      call TestoGR(string2, -1, 2, 3)     
      Msg = 'MTZ and PDB files produced after Molecular Replacement'
      call TestoGR(Msg, -1, 2, 3)
      write(lo,60) Msg(1:Lung(Msg))

      k = index(fname(1),'.bin')
      k2 = kStripTask1(k)

!-- dedi 
      nSetsFineDSR = 1  ! per memorizzare solo la soluzione migliore (vedi anche in PostMR)
      write(stringa,15) nSetsFineDSR
      call NoBlanks(stringa,k1)
!-- dedi 
!
***   cardDiret = fname(1)(1:k2-1) // '_remo' // stringa(1:k1) //'.mtz'
      cardDiret = nome(1:lnome) // '_remo.mtz'
      k3 = Lung(cardDiret)
      Msg = '   ' // cardDiret(1:k3)
      k3 = Lung(Msg) + 1
      cardImage = cardDiret
  
***   cardDiret = fname(1)(1:k2-1) // '_remo' // stringa(1:k1) //'.pdb'
      cardDiret = nome(1:lnome) // '_remo.pdb'
      k2 = Lung(cardDiret)
      Msg(k3+7:) = cardDiret(1:k2)
      call TestoGR(Msg, color_GREEN, 2, 3)
      write(lo,"(2x,a)") Msg(1:Lung(Msg))
      call zflush
      call DoSingleIteration()
!
!-- Improve MR phases
!
c     write(6,*) 'Riflessi 1',nrefl,nreflDim,numbGen

      ifTime = ifTime_sav
      if (ifImproveMR == 0) then
          ifFreeLunchMR = 0
          ifMutate = 0
          iesImpr = 0
      endif
      ifFreeLunchMR_Sav = ifFreeLunchMR
      ifRicicla = 1

c        if (idSeq <= 0.35) then
         if (idSeq <= idSeqThre) then
              if (ifAmb > 0) then
                  ifAmbMR = ifAmb      ! per usare Model Building in REVAN
              else
                  ifAmbMR = 0
              endif
         else
              ifAmbMR = 0
         endif

         if (ifCoot == 0 .or. ifDNA == 0 .or. 
     *       ifSoloMR == 1 .or. ifCAB == 0) then
             nMacroBatch = 1
         else
             nMacroBatch = 2
         endif

         nMacroBatch = 1 ! 21marzo

         do MacroBatch=1, nMacroBatch
         if (ifDNA == 1) then
             maxBatchCAB = 6 ! nuovo algoritmo
             maxBatchCAB = 10
*            maxBatchCAB = 3 ! TEST
         else
             maxBatchCAB = 1
         endif
         if (ifCAB == 0) then
             maxBatchCAB = 1
         endif
         if (ifCoot == 0 .or. ifDNA == 0 .or. 
     *       ifSoloMR == 1 .or. ifCAB == 0) then
             maxBatchCAB = 1
         endif
*        maxBatchCAB = 2
         if (MacroBatch == 1) then
             inizBatchCAB = 1
         else
             inizBatchCAB = 2
             maxBatchCAB = 2
         endif
         nBC = 0
         do BatchCAB =inizBatchCAB, maxBatchCAB
         
!     if (ifImproveMR == 1 .or. ifFreeLunchMR == 1 .or. 
!    *    nRefmacCycles > 0) then
          call PostMR(VettRisultati, rMTZ, ifExit, FFom_S, ifRicicla, 
     *         ricAMB, nSetBest, RfacAW_S, RfreAW_S, maxBatchCAB)
          ifVLD = 0
!     else
!         if (ifFreeLunchMR == 0) then
!             numbGen = 0
!         endif
!         kQuantiSets = nSetsFineDSR
!         call WriteMTZ(1, 0, kQuantiSets, 1, ier)
!     endif
!
!
         isJelly = .false.
         ier = 0
         ncontAMB = 0
!
!
         icic = 0 
         fig(:) = figMer(:)
!
! -- Se non c'è PGM per AMB (ifAmb = 0) ma è richesto improve (FL)
!
      if (ifAmbMR == 0 .and. ifImproveMR > 0) then

          if (ifFreeLunchMR_Sav == 1) then
              ifFreeLunchMR = ifFreeLunchMR_Sav
!
              call Init_Canalizzazione()
!
              if (knw > 0) then
                  write(6,*) 'FREELUNCH APPLIED'
                  write(lo,23) erore, FFom_S, RfacAW_S, RfreAW_S
              endif
              fig(3) = FFom_S
              RfacAW = RfacAW_S
              RfreAW = RfreAW_S
          endif

          sav = ifFreeLunchMR
          if (ifDNA == 1) ifFreeLunchMR = 0 ! come in sir2019 distr.

          if (nats_added_to_pdb == 0) then
              call DoRemoDsr(VettRisultati)
          endif

          ifFreeLunchMR = sav

          if (ifCristina == 1) then
              do i=1, nrefl
*                wt(i) = sqrt(wt(i))
                 wt(i) = wt(i) ** 1.2
              enddo
              izero = 0
              ifmin = 1
              call examin(33, mkang, khl, ipub, iphaz, nrefl,
     *                   izero,wt,ifmin)
              tirang = 'SQRT(WT)   '
              izero = 0
              ipher = 1
              call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
     *                 ipub,iphaz,wt,10,0.0,ipher)
          endif

              fig(3) = FinalFom
!
              if (knw > 0) then
                  MPEvet(2) = erore
                  fasePhantom = erore
                  tabImpr(1) = fasePhantom
                  write(6,*) 'FASEPHANTOM 2', erore
                  write(lo,20) erore, icic-1, FinalFom, RfacAW, RfreAW
             write(6,25) FinalFom,FOMs(2,5),RfacAW,RfreAW,erore,erorepes
              else
                  if (ifFreeLunchMR == 1) then
                      write(lo,200) FinalFom
                  else
                      write(lo,201) FinalFom
                  endif
              endif
!
              call PutGetFinalPhases(1, nset, fig)
              ifVLD = 0
              kQuantiSets = 1
              numbGenLoc = numbGen
              numbGen = 0
 
              stampaMTZ = 0
              call WriteMTZ(1, 0, kQuantiSets, stampaMTZ,ier)
              numbGen = numbGenLoc

      endif

!
!-- Automated Model Building
!
      if (ifAmbMR /= 0) then

          if (jscreen > 0 ) then
              nLinesGR_Amb = nLinesGR
              Box_Amb = lastBox
              inBoxGR_Amb = inBoxGR(Box_Amb)
          endif
          k = index(fname(1),'.bin')
          kk = kStripTask1(k) - 1

          if (ifImproveMR == 1) then
              FileIn_1 = fname(1)(1:kk) // '_refmac.pdb'
              FileOut_M = fname(1)(1:kk) // '_improved.pdb'
c             FileIn_2 = fname(1)(1:kk) // '_remo.mtz'
c             FileOut_R = fname(1)(1:kk) // '_refmac.mtz'
              RfacAW_S = RfacAW
              RfreAW_S = RfreAW
              call cCopyFile(FileIn_1, FileOut_M)
c             call cCopyFile(FileIn_2, FileOut_R)
          endif
!
          if (ifAmbMR == 1) then
             FileIn_1 = fname(1)(1:kk) // '_buccaneer.pdb'
             FileOut_1 = fname(1)(1:kk) // '_buccaneer_Sav.pdb'
             FileIn_2 = fname(1)(1:kk) // '_buccaneer.mtz'
             FileOut_2 = fname(1)(1:kk) // '_buccaneer_Sav.mtz'
             FileIn_3 = fname(1)(1:kk) // '_buccaneer.txt'
             FileOut_3 = fname(1)(1:kk) // '_buccaneer_Sav.txt'
          else if (ifAmbMR == 2) then
             FileIn_1 = fname(1)(1:kk) // '_arp.pdb'
             FileOut_1 = fname(1)(1:kk) // '_arp_Sav.pdb'
             FileIn_2 = fname(1)(1:kk) // '_arp.mtz'
             FileOut_2 = fname(1)(1:kk) // '_arp_Sav.mtz'
             FileIn_3 = fname(1)(1:kk) // '_arp.txt'
             FileOut_3 = fname(1)(1:kk) // '_arp_Sav.txt'
          else if (ifAmbMR == 3) then
             FileIn_1 = fname(1)(1:kk) // '_phenix.pdb'
             FileOut_1 = fname(1)(1:kk) // '_phenix_Sav.pdb'
             FileIn_2 = fname(1)(1:kk) // '_phenix.mtz'
             FileOut_2 = fname(1)(1:kk) // '_phenix_Sav.mtz'
             FileIn_3 = fname(1)(1:kk) // '_phenix.txt'
             FileOut_3 = fname(1)(1:kk) // '_phenix_Sav.txt'
          else if (ifAmbMR == 4) then
             FileIn_1 = fname(1)(1:kk) // '_nautilus.pdb'
             FileOut_1 = fname(1)(1:kk) // '_nautilus_Sav.pdb'
             FileIn_2 = fname(1)(1:kk) // '_nautilus.mtz'
             FileOut_2 = fname(1)(1:kk) // '_nautilus_Sav.mtz'
             FileIn_3 = fname(1)(1:kk) // '_nautilus.txt'
             FileOut_3 = fname(1)(1:kk) // '_nautilus_Sav.txt'
          endif

          doRicicla = 1

c         if (idSeq <= 0.35) then
          if (idSeq <= idSeqThre) then
              ricAMB = 3
          else
              ricAMB = 1
          endif
!
! -- Se non è richiesto il riciclo su AMB (ifImproveMR = 0)
!
          if (ifImproveMR == 0) then
              ifExit = -1
          endif

          call AllocaCanalMod(1)

c         ricAMB = 1

!TEST!    pdbinMR = .true.
          if (ifPhD == 0 .and. ifCAB > 0) then
              call AllocaPhantom(1)
          endif

          do icicAMB=1,ricAMB

             if (ifFreeLunchMR_Sav == 1) then
                 ifFreeLunchMR = ifFreeLunchMR_Sav
!NEW
                 if (ifDNA == 1) ifFreeLunchMR = 0 ! come in sir2019 distr.
!NEW
                 if (knw > 0 .and. ifFreeLunchMR == 1) then
                     write(6,*) 'FREELUNCH APPLIED'
                     write(lo,23) erore, FFom_S, RfacAW_S, RfreAW_S
                 else
                     write(lo,233) FFom_S
                 endif
                 ifExit = 0
                 fig(3) = FFom_S
                 RfacAW = RfacAW_S
                 RfreAW = RfreAW_S
             else
                 if (ifImproveMR > 0) then
                     if (knw > 0) write(lo,234) FFom_S
                 endif
             endif

             nAMB_Sav = 0
             if (ifSkip == 1) then
                 nAMB_Sav = nAMB
                 nAMB = 1
             endif 

c            nAMB = 3
             do icic = 1,nAMB
                ifRestore = 0
!-----------------------------------------------------------------------

                if (ifExit == 0) then
!
                    if (icic > 1) then
                        HTMLstr =  ' '
                        call MRInfo(99)
                        HTMLstr = grufle(1:Lung(grufle))
                        call MRInfo(99)
                        call TestoGR(HTMLstr, -1, 2, 3)
                    endif
                    call zflush
                    call DoSingleIteration()
                    call DoRemoDsr(VettRisultati)

                    fig(3) = FinalFom
!
                    if (knw > 0) then
                        write(lo,20) erore, icic-1, FinalFom, 
     *                                              RfacAW, RfreAW
                        write(6,25) FinalFom,FOMs(2,5),RfacAW,RfreAW,
     *                                                 erore,erorepes
*                       MPEvet(2) = erore
                        tabImpr(1) = erore
                    else
                        if (ifFreeLunchMR == 1) then
                            write(lo,200) FinalFom 
                        else
                            write(lo,201) FinalFom 
                        endif
                    endif
!
                    call PutGetFinalPhases(1, nset, fig)
                    ifVLD = 0
                    kQuantiSets = 1
                    numbGenLoc = numbGen
                    numbGen = 0
 
                    stampaMTZ = 0
                    call WriteMTZ(1, 0, kQuantiSets, stampaMTZ,ier)
                    numbGen = numbGenLoc

                    if (icic == 1) then
c                        MTZfileSav = fname(1)(1:kk) // '_remo.mtz'
                         MTZfileSav = fname(1)(1:kk) // '_improved.mtz'
                         FileOut_R = fname(1)(1:kk) // '_FL.mtz'
                         call cCopyFile(MTZfileSav, FileOut_R)
                    endif

                elseif (ifExit == 1) then    ! da controllare  !!!
                        if (knw > 0) then
                          write(lo,21) erore, FFom_S, RfacAW_S, RfreAW_S
                        endif
                    
                endif
!
!-----------------------------------------------------------------------
                if (ifPhD == 0 .and. ifCAB > 0) then
                    Fasi_Sav(1:nrefl) = iphaz(1:nrefl)
                    Pesi_Sav(1:nrefl) = wt(1:nrefl)
                    Pub_target(1:nrefl) = ipub(1:nrefl)
                endif
!
                ifFailAW = 0 
                numbGenLoc = numbGen
                numbGen = 0
                stampaInfo = 1
                ncontAMB = ncontAMB + 1
                call Ricicla(VettRisultati, doRicicla, stampaInfo, ier)
                        CaOnly = .false.
                        nzSav(1:nats) = nz(1:nats)
                        call to_coord_sir(1, nrefl)
                        tabImpr(15) = nint(vett_test(7))
                        nz(1:nats) = nzSav(1:nats)
                        CaOnly = .true.
                        nzSav(1:nats) = nz(1:nats)
                        call to_coord_sir(1, nrefl)
                        tabImpr(4) = nint(vett_test(7))
                        nz(1:nats) = nzSav(1:nats)
                MPEvet(2) = erore
                if (knw > 0) then
                    write(6,*) 'MPEVET(2) ', MPEvet(2)
                endif
                cardDiret = FileIn_3
                itype = 0
                iform = 1
                jop = jopen(jhost,cardDiret,itype,iform,ier)
                write(jhost,300) coverage, RfacAW, RfreAW, residuesAW
                close(jhost) 

                write(stringa,15) ncontAMB
                call NoBlanks(stringa,k1)
                k = index(MTZfile,'.mtz')
                kk = k - 1
                kkSav = k - 1

                ifSave = 0
                ifReje = 0
                if (icic == 1) then
c                   if (idSeq <= 0.35 .and. RfreAW > 0.35 .and.
                    if (idSeq <= idSeqThre .and. RfreAW > 0.35 .and.
     *                  RfreAW > (1.015 * RfreAW_S)) then
                        FileIn_1 =FileIn_1(1:kk)//stringa(1:k1)//'.pdb'
                        FileIn_2 =FileIn_1(1:kk)//stringa(1:k1)//'.mtz'
                        call cCopyFile(AmbPDB, FileIn_1)
                        call cCopyFile(MTZfile, FileIn_2)
                        k = index(fname(1),'.bin')
                        kk = kStripTask1(k) - 1
                        File_Mod = fname(1)(1:kk) // '_improved.pdb'
                        File_Ref = fname(1)(1:kk) // '_improved.mtz'
                        call cCopyFile(FileOut_M, File_Mod)
                        call cCopyFile(FileOut_R, File_Ref)
                        k1 = index(File_Ref,'.mtz')
                        kkSav = k1 - 1
                        ifReje = 2 !1
                    else
                        RfacAW_S = RfacAW
                        RfreAW_S = RfreAW
                        call cCopyFile(AmbPDB, FileOut_1)
                        call cCopyFile(MTZfile, FileOut_2)
                        call cCopyFile(FileIn_3, FileOut_3)
                        File_Mod =FileIn_1(1:kk)//stringa(1:k1)//'.pdb'
                        File_Ref =FileIn_1(1:kk)//stringa(1:k1)//'.mtz'
                        call cCopyFile(AmbPDB, File_Mod)
                        call cCopyFile(MTZfile, File_Ref)
                        ifSave = 1
                        FileIn_1 = File_Mod
                        FileIn_2 = File_Ref
                    endif
                else
                    deltaRfAW = RfreAW_S - RfreAW
                    if (RfreAW > RfreAW_S) then
                        File_Mod =FileIn_1(1:kk)//stringa(1:k1)//'.pdb'
                        File_Ref =FileIn_1(1:kk)//stringa(1:k1)//'.mtz'
                        call cCopyFile(AmbPDB, File_Mod)
                        call cCopyFile(MTZfile, File_Ref)
                        call cCopyFile(FileOut_1, FileIn_1)
                        call cCopyFile(FileOut_2, FileIn_2)
                        call cCopyFile(FileOut_3, FileIn_3)
                        ifReje = 1
                    else
                        RfacAW_S = RfacAW
                        RfreAW_S = RfreAW
                        call cCopyFile(AmbPDB, FileOut_1)
                        call cCopyFile(MTZfile, FileOut_2)
                        call cCopyFile(FileIn_3, FileOut_3)
                        File_Mod =FileIn_1(1:kk)//stringa(1:k1)//'.pdb'
                        File_Ref =FileIn_1(1:kk)//stringa(1:k1)//'.mtz'
                        call cCopyFile(AmbPDB, File_Mod)
                        call cCopyFile(MTZfile, File_Ref)
                        FileIn_1 = File_Mod
                        FileIn_2 = File_Ref
                        ifSave = 1

                        if (RfreAW < 0.350.and.deltaRfAW <= 0.009) then
                            ifSave = 2
                        endif

                    endif
                endif
!
!--- PROVA DI STAMPA
!
                if (ifReje == 2) then
                    AmbPDB  = FileIn_1
                    MTZfile = FileIn_2
                else
                    AmbPDB  = File_Mod
                    MTZfile = File_Ref
                endif

                stampaInfo = 1
                call WriteAmbResults(stampaInfo)
                call Scrivi_R_Rfree
!
!--- PROVA DI STAMPA
!
!?!             Msg = 'Files produced after Automated Model Building:'
!?!             write(lo,60) Msg(1:Lung(Msg))
!?!             k = index(MTZfile, slash, .TRUE.) + 1
!?!             Msg = '    ' // MTZfile(k:)
!?!             k = Lung(Msg) + 1
!?!             inquire (file=AmbPDB,  exist = Esiste)
!?!             if (Esiste) then
!?!                 Msg(k+2:) = AmbPDB(1:Lung(AmbPDB))
!?!             else
!?!                 Msg(k+2:) = 'no PDB file created'
!?!             endif
!?!             k = Lung(Msg)
!?!             write(lo,"(' ',a)") Msg(1:k)
!
                if (knw > 0) then
                    if (ifReje == 0) then
                        write(lo,22) icic, erore, RfacAW, RfreAW
                    else
                        write(lo,222) icic, erore, RfacAW, RfreAW
                    endif
                endif
!
                exposigma=1
                ifPostDSR = 0
                ifReduced = 0
                f000=0
                call Calcola_FinalFom_PostMR(0)
                if (knw > 0) then
                    if (ifReje == 0) then
                        write(6,26) FinalFom,FOMs(2,5),RfacAW,RfreAW,
     *                            erore,erorepes
                    else
                        write(6,266) FinalFom,FOMs(2,5),RfacAW,RfreAW,
     *                            erore,erorepes
                    endif
                endif
!
                numbGen = numbGenLoc
                if (ifExit == 1) ifExit = 0
!
                if (ifSave == 0) then

                    if (ifReje == 2) then
                       PDBRestore = File_Mod
                       MTZRestore = File_Ref
                    else
                       PDBRestore = FileIn_1 !File_Mod
                       MTZRestore = FileIn_2 !File_Ref
                    endif

                    stampaInfo = 1
                    call RestoreMTZ_PDBFiles(MTZRestore, PDBRestore,
     *                VettRisultati, doRicicla, stampaInfo,
     *                ifRestore, ifReje, ier)
                    k = index(fname(1),'.bin')
                    kk1 = kStripTask1(k) - 1 
                    FichierOut = fname(1)(1:kk1) // '_refmac0.pdb'
                    call cCopyFile(FileIn_1, FichierOut)
                    if (icic > 1) then
                        cardDiret = FileIn_3
                        itype = 0
                        iform = 1
                        jop = jopen(jhost,cardDiret,itype,iform,ier)
                        read(jhost,300)coverage,RfacAW,RfreAW,residuesAW
                        close(jhost)
                    endif
                else
                    FileIn_1 = File_Mod
                    FileIn_2 = File_Ref
                endif

                call PutGetFinalPhases(1, nset, fig)
                ifVLD = 0
                kQuantiSets = 1
                numbGenLoc = numbGen
                numbGen = 0
!
                stampaMTZ = 0
                call WriteMTZ(1, 0, kQuantiSets, stampaMTZ, ier)
                numbGen = numbGenLoc
!
                if (ifReje > 0 .or. ifFailAW == 1) then
                    RfacAW = RfacAW_S
                    RfreAW = RfreAW_S
                    exit  !inutile ciclare se AMB diverge o fallisce
                endif
!
                if (RfreeThreReq < 0) then
c                   if (idSeq <= 0.35) then
                    if (idSeq <= idSeqThre) then
                        RfreeThre = 0.30
                    else
                        RfreeThre = 0.275
                    endif
                endif
!
                if (nAMBReq < 0) then
*                   if (RfreAW < 0.250) exit  !inutile ciclare se Rfree < 0.25
                    if (RfreAW < RfreeThre) then
                        kWstop = 1
                        exit !inutile ciclare se Rfree < soglia 
                    endif
                endif
!
                SogliaRfree = 0.30
                if (RfacAW < SogliaRfree) then
                    kWstop = 1
                    exit !inutile ciclare se Rf < soglia 
                endif
!
                if (ifSave == 2) then

                        kWstop = 1

                    exit  !inutile ciclare se Rfree < 0.35 e delta <= 0.009
                endif

                if (residuesAW == 0) then
                    exit      ! AMB failed, no residues found
                endif

             enddo !icic

!!!!!
c            if (icicAMB > 0) exit   !!! non riciclo per produrre i files di AMB per i test successivi
             if (icicAMB == ricAMB .or. kWstop == 1) then
                 exit   !!! niente Improve sull'ultimo ciclo (finisce con AMB)
             endif
!!!!!

c            if (idSeq > 0.35) then
             if (idSeq <= idSeqThre) then
                 exit     ! non ricicla in caso di strutture con buona ID
             endif

!?!          if (ifnoImp > 0) then
!?!              exit     ! non ricicla in caso di direttiva noImprove
!?!          endif
!
!  -- Riciclo Improve_PKG se RfreAW (<0.50) <0.45 e >0.35   
!
c            if (RfreAW < 0.50 .and. RfreAW > 0.35) then
             if (RfreAW <= 0.45 .and. RfreAW >= 0.35) then
!
                 if (ifAli == 0) then
                     call Allinea
                 else
                     call GetAli
                 endif
!
                 ifFreeLunchMR = 0

                 soft = 0
                 stepS = 1
                 call Improve_PKG(VettRisultati, icicAMB,
     *                ifExit, FFom_S, RfacAW_S, RfreAW_S, soft, stepS)
             else
                 exit
             endif

         enddo !icicAMB
!
         if (ier == -1) then !  scrive sulla finestra che ci sono stati problemi con ARP/wARP
             ier = 0
         endif
      endif !ifAmbMR /= 0

      if (ifAmbMR /= 0) then          !!mr 30/06/2015
          if (nAMB > 1) then
!*!           Msg = 'BEST FINAL MODEL'
!*!           write(lo,80) Msg(1:Lung(Msg))
!*!           box = lastBox
!*!           call TestoGR(Msg, -1, 2, box)
!**!          MTZfileSav = MTZfile
!**!          AmbPDBSav = AmbPDB
              MTZfile = File_Ref
              AmbPDB  = File_Mod

              if (ifRestore == 1) then
                  MTZfile = MTZRestore
                  AmbPDB  = PDBRestore
              endif

              AmbPDBSav  = AmbPDB
              MTZfileSav = MTZfile
c             FichierOut = AmbPDBSav(1:kkSav)//'.pdb'
c             MTZfile    = MTZfileSav(1:kkSav)//'.mtz'

              if (kWstop == 0) then
                  FichierOut = nome(1:lnome) // '_improved.pdb'
              endif
              MTZFile = nome(1:lnome) // '_improved.mtz'
              call cCopyFile(AmbPDBSav, FichierOut)
              call cCopyFile(MTZfileSav, MTZfile)

              stampaInfo = 1

!*!              if (ifReje /= 2) then
!*!                  call WriteAmbResults(stampaInfo)
!*!              else
!*!!*!               if (stampaInfo == 9) then
!*!!*!               Msg = 'Files produced after Automated Model Building:'
!*!!*!                   write(lo,60) Msg(1:Lung(Msg))
!*!!*!                   box = lastBox
!*!!*!                   call TestoGR(Msg, -1, 2, box)
!*!!*!                   k = index(MTZfile, slash, .TRUE.) + 1
!*!!*!                   Msg = '    ' // MTZfile(k:)
!*!!*!                   k = Lung(Msg) + 1
!*!!*!                   inquire (file=AmbPDB,  exist = Esiste)
!*!!*!                   if (Esiste) then
!*!!*!                       Msg(k+2:) = AmbPDB(1:Lung(AmbPDB))
!*!!*!                   else
!*!!*!                       Msg(k+2:) = 'no PDB file created'
!*!!*!                   endif
!*!!*!                   k = Lung(Msg)
!*!!*!                   call TestoGR(Msg, color_GREEN, 2, box)
!*!!*!                   write(lo,"(' ',a)") Msg(1:Lung(Msg))
!*!!*!               endif
!*!              endif
!**!          MTZfile = MTZfileSav
!**!          AmbPDB = AmbPDBSav
          endif
      else
          if (ifImproveMR > 0) then
              k = index(fname(1),'.bin')
              kk1 = kStripTask1(k) - 1
c             File_Ref = fname(1)(1:kk1) // '_FL.mtz'
              File_Ref = fname(1)(1:kk1) // '_improved.mtz'
              call cCopyFile(MTZfile, File_Ref)
c             File_Mod = fname(1)(1:kk1) // '_refmac.pdb'
              File_Mod = fname(1)(1:kk1) // '_improved.pdb'
              call cCopyFile(FichierOut, File_Mod)
              MTZfile = File_Ref
              if (ifREFMAC == 1) FichierOut  = File_Mod

                  if (stampaInfo == 9) then
                  Msg = 'Files produced after improvement:'
                      write(lo,60) Msg(1:Lung(Msg))
                      box = lastBox
                      call TestoGR(Msg, -1, 2, box)
                      k = index(MTZfile, slash, .TRUE.) + 1
                      Msg = '    ' // MTZfile(k:)
                      k = Lung(Msg) + 1
                      inquire (file=FichierOut,  exist = Esiste)
                      if (Esiste) then
                          Msg(k+2:) = FichierOut(1:Lung(FichierOut))
                      else
                          Msg(k+2:) = 'no PDB file created'
                      endif
                      k = Lung(Msg)
                      call TestoGR(Msg, color_GREEN, 2, box)
                      write(lo,"(' ',a)") Msg(1:Lung(Msg))
                  endif
          endif
      endif
!
!
*     kQuantiSets = nSetsFineDSR
*     call WriteMTZ(1, 0, kQuantiSets, 1, ier)
!
c
c--produce un file mtz per ogni soluzione
c
c     if (kQuantiSets > 1) then
c         call sfl17()
c         call LoadFinalPhases(FomsFineDSR, iposFineDSR,
c    *                         nsetFinalPhases)
c         do i=1, kQuantiSets
c            nset = iposFineDSR(i)
c            call snr17(nset,fig)
c            call PutGetFinalPhases(2, nset, fig)
c            ii = nint(fig(1))
c            call WriteMTZ(1, ii, 0, 1, ier)
c         enddo
c     endif
!
!
      call MRInfo(51)
!
      if (BatchCAB == 1) then
          icont1=0
          do j=1,nFinalSolution
             nMolMR = 0
             icont = 0
             do j1=1, numbModels
                do j2=1, MonomerInModel(j1)
                   if (finsolcan(j)%flag(j1,j2) == -1) then
                       icont = icont + 1
                   else
                       nMolMR = nMolMR + 1
                   endif
                enddo
             enddo
             if (icont > 0)  then
                 write(Inte,103) j, nMolMR, nMolMRTot
                 call OneBlankOnly(Inte)
                 write(lo,'(/,2x,a)') Inte(1:Lung(Inte))
                 icont1 = icont1 + 1 
             endif
          enddo
c
          if (icont1 > 0) then
              write(Msg,102) icont1, nMolMRTot
              call  OneBlankOnly(Msg) 
              call TestoGR(Msg, color_LIGHTRED, 2, 3)
          endif
      endif
!
      if (WasAmb > 0) then
          if (RfreAW < 0.30) then
! per articolo ifPhD = 0
          endif
      endif
      
      if (kWstop == 1) then
!TEST!    ifPhD = 0 
!TEST!    ifRicicla = 0
          if (knw > 0) then
              if (PDBcode(1:1) == ' ') then
                   Inte = nome(1:lnome)
               else
                   Inte = PDBcode
               endif
               zero = 0
               uno  = 1
               write(6,1004) Inte(1:Lung(Inte)), nint(MPEvet(1)),
     *           nint(MPEvet(2)), zero, zero, zero, zero, zero, uno,
     *           nint(RfacAW*100.0),nint(RfreAW*100.0),
     *           nint(MPEvet(3)),nint(coverage), perc_CA, vett_test(4)
          endif
      endif

*     if (ifDNA == 1) then
*         write(6,*) 'PESANTIFOSFATI DA FINALMR'
*         call PesantiFosfati(2)
*     endif
      tab2(:) = 0
      iesImpr = 0
      if (ifPhD == 1) then
          if (ifAmb == 0) then
              ifAmb = ifAmbMR
          endif
          call StartPhD(ier)
      else
        if (ifRicicla > 0) then
          if (ifAmb > 0 .and. kWstop == 0) then
              ifRemo = 0
              if (jscreen > 0) then
                  nLinesGR_Amb = nLinesGR
                  Box_Amb = lastBox
                  inBoxGR_Amb = inBoxGR(lastBox)
              endif
              doRicicla = 0
              stampaInfo = 1
              ier = 0
              if (ifAmb > 0) then
                  if (.not.allocated(Fasi_MR)) then
                      call AllocaPhantom(1)
                      Fasi_Sav(1:nrefl) = iphaz(1:nrefl)
                      Pesi_Sav(1:nrefl) = wt(1:nrefl)
                      Pub_target(1:nrefl) = ipub(1:nrefl)
                  endif
      go to 77
                  if (ifAmbMR == 0) then
                      RfreAW = 1
                      RfacAW = 1
*                     coverage = 0
                      perc_CA = 0
                      vett_test(4) = 0
                      tabImpr(5) = 0
                  endif
   77 continue
                  if (ifAmbMR == 0) then
*                     tabImpr(1) = erore
                    if (knw > 0)
     *              write(6,*) 'TABIMPR(1) FINALMR', erore
                    sav = ifPhantom
                    ifPhantom = 1
                    if (ifDNA == 1) then ! spostato sopra
                        if (knw > 0) then
                            write(6,*) 'PESANTIFOSFATI DA FINALMR'
                        endif
                        call PesantiFosfati(2)
                    endif
!-- GAUSSIANE
*                   call BeforeNautilus
*                   cardDiret = nome(1:lnome) // '_phantom.mtz '
*                   call WriteMTZ_Express(0, 0, cardDiret, ier)
!
                    if (nPrevCAB > 0) then
                        call Ricicla(VettRisultati, doRicicla, 
     *                               stampaInfo,ier)
!BACK                   nPrevCAB = 1
                    else
                        RfacAW = 0.9999
                    endif
                    tab2(3) = nint(RfacAW*100)
                    if (ifDNA == 1) then
                    if (knw > 0) then
                        write(6,*)
                      write(6,*) 'Confronto tra atomi Nautilus e target'
                        write(6,*)
                    else
                        if (knw > 0) then
                        write(6,*)
                        write(6,*) 'Confronto tra atomi Bucc. e target'
                        write(6,*)
                        endif
                    endif
                    endif
                        CaOnly = .false.
                        nzSav(1:nats) = nz(1:nats)
                        call to_coord_sir(1, nrefl)
                        nz(1:nats) = nzSav(1:nats)
                        tabImpr(15) = nint(vett_test(7))
                        tab3(5) = vett_test(7)
                        tab2(5) = nint(vett_test(7))
                        CaOnly = .true.
                        nzSav(1:nats) = nz(1:nats)
                        call to_coord_sir(1, nrefl)
                        nz(1:nats) = nzSav(1:nats)
                        tab2(4) = nint(vett_test(7))
                        tab3(4) = vett_test(7)
                        tab3(6) = vett_test(4)
*                   endif
                    ifPhantom = sav
                  endif
                  pdbinMR = .true.
                  PDBfile = nome(1:lnome) // '_improved.pdb'
                  if (ifCAB > 0) then
                      if (nPrevCAB > 0) then
                          call MiglioraDopo(1)
                      else
                          RfacAW = 0.99
                          call UseSynergyResults
                      endif
                      call StampaTabellaArt(tabImpr, 0)
                  endif
              else
                  call Ricicla(VettRisultati, doRicicla, stampaInfo,ier)
              endif
          else
              ifRemo = 0
              call LoadPDBfromAmb(1,0,1)
          endif
        endif


      endif
!


      if (ifDNA == 1 .and. ifSoloMR == 0) then
*         call NewPostCAB(nBC, tabImpr)

          if (maxBatchCAB > 1) then
              call RestartBatchCAB(fermati, maxBatchCAB, nBC)
              if (fermati) exit
          endif
      endif


      if (ifSoloMR == 1) exit

      enddo ! do BatchCAB =1, maxBatchCAB


      if (ifDNA == 1 .and. ifCAB > 0 .and. 
     *    ifCoot == 1 .and. ifSoloMR == 0) then

          if (ifPostCAB < 0) then
              if (MacroBatch == 2) then
                  nBC = 1
                  cardImage = nome(1:lnome) // '_CAB2.pdb'
                  cardDiret = nome(1:lnome) // '_CAB1.pdb'
                  call cCopyFile(cardImage, cardDiret)
                  cardImage = nome(1:lnome) // '_CAB2.mtz'
                  cardDiret = nome(1:lnome) // '_CAB1.mtz'
                  call cCopyFile(cardImage, cardDiret)
              endif
              ifPostCAB = 1
              call PrePostCAB(nBC, tabImpr, errePostCAB, identical)
              if (knw > 0) then
                  write(6,*) 'DOPO PREPOSTCAB ', errePostCAB
                  write(6,*) 'DOPO PREPOSTCAB ', FichierOut
                  write(6,*) 'IDENTICAL ', identical
              endif
              cardImage = nome(1:lnome) //'_mod.pdb'
              cardDiret = nome(1:lnome) //'_nautilus_prev.pdb'
              call cCopyFile(cardImage, cardDiret)
          endif
*         call FinalBatchCAB(nBC)
          if (errePostCAB < errePostCABmin) then
              cardImage = nome(1:lnome) //'_mod.pdb'
              cardDiret = nome(1:lnome) //'_modmin.pdb'
              call cCopyFile(cardImage, cardDiret)
              cardImage = nome(1:lnome) //'_mod.mtz'
              cardDiret = nome(1:lnome) //'_modmin.mtz'
              call cCopyFile(cardImage, cardDiret)
              errePostCABmin = errePostCAB
          endif
          if (fermati .or.
     *        errePostCABmin < 0.33 .or. identical == 1) then
              exit
          endif
      endif
      enddo ! MacroBatch
!
      if (ifCoot == 1 .and. ifSoloMR == 0 .and. ifCAB > 0) then
          if (ifDNA == 1) call FinalMacro(errePostCABmin)
      endif

      call InitSigmaA(2)
      call AllocaMapTest(2)
!
   12 format('[1-',i5,']')
   14 format ('1_',i4)
   15 format ('_',i4)
   16 format('[1-',i5,']')
   20 format('IMPROVE: VLD+FL',f8.2,' ; AMB #',i4,
     *       ' FFom2 =',f8.3,' Rf =',f8.3,' Rfree =',f8.3)
   24 format('IMPROVE: VLD+FL',f8.2,' ; AMB #',i4,
     *    ' FFom2 =',f8.3,' Rf =',f8.3,' Rfree =',f8.3, ' Rejected')
   21 format('IMPROVE: INIZIO AMB',f8.2,' ;  FFom2 =',f8.3,
     *       ' Rf =',f8.3,' Rfree =',f8.3)
   22 format('IMPROVE: DOPO AMB',i4,f8.2,' ;  Rf =',f8.3,' Rfree =',
     *                                                 f8.3)
  222 format('IMPROVE: DOPO AMB',i4,f8.2,' ;  Rf =',f8.3,' Rfree =',
     *                                                 f8.3,' Rejected')
   23 format('IMPROVE: INIZIO VLD+FL',f8.2,' ;  FFom2 =',f8.3,
     *       ' Rf =',f8.3,' Rfree =',f8.3)
   25 format('IMPROVE: VLD+FL FOM:'4x,4f8.3,2f8.2)
   26 format('IMPROVE: AMB    FOM:'4x,4f8.3,2f8.2)
  266 format('IMPROVE: AMB    FOM:'4x,4f8.3,2f8.2,' Rejected')
   27 format('IMPROVE: REFMAC FOM:'4x,4f8.3,2f8.2)
   30 format(80('-'))
   32 format('Best solution: #',a,', Corr = ',f6.3,', R% = ',f5.2,
     &                ', Clashes% = ',f6.2)
   35 format(/,10x,' ACCEPTED SOLUTION(S) ',/)
   40 format('   Sol.   FFom    MPE   Clash %     FFomN    CCMap   ',
     *       ' MPEN')
   41 format(' Sol.     FFom    MPE   Clash %     FFomN')
c  45 format('  Sol.     TFom     Clash%     FFom')
   45 format('  Sol.     Clash%     FFom')
*  49 format(a,i5,f9.3,f8.2,f7.2,3x,f9.3,f9.3,f8.2)
   49 format(i5,f9.3,f8.2,f7.2,3x,f9.3,f9.3,f8.2)
   50 format(i5,1x,f9.2,1x,f9.3)
   51 format(5x,i7,33x,3f6.1,3f7.3)
  511 format(5x,i7,17x,3f6.1,3f7.3)
   52 format(' -----   Model',i4,', monomer',i4,' not found')
   55 format(i6,f9.3,f8.2,2x,f6.2,f8.2,3f6.1,3f7.3,/,
     *             10(i6,32x,3f6.1,3f7.3,/))
   60 format(/,' ',a,/,'     MTZ format',12x,' PDB format')
   80 format(/,' ',a)
  102 format(' Warning: ',i6, ' solution(s) have less than ',i4,
     *       ' monomer(s)')
  103 format(' Warning: solution',i4,' have',i4,' /',i4,' monomers')

  200 format(' After  VLD-Free Lunch: Final FOM =',f8.3)
  201 format('       Final   ',f8.3)
  202 format(' After  AMB: Final FOM =',f8.3)
  244 format(' After  VLD-Free Lunch: Final FOM =',f8.3, ' Rejected')
  245 format(' After  VLD: Final FOM =',f8.3, ' Rejected')
  233 format(/,' Before VLD-Free Lunch: Final FOM =',f8.3)
  234 format(' Before VLD: Final FOM =',f8.3)
  300 format(f8.2,2f10.5,i5)
  335 format(/,'FOMs = Sol    TFom    MPE2    CORR    1-R    1-Ree   
     *1-R40   Denom   Costo    FFOM  MPEall',/)
 1004 format('TABIMP0 ',a,13(' |',i3),' | ',f6.3,' | ',a)
!
      return
      end
!---------------------------------------------------------------
      subroutine FinalMacro(errePostCABmin)
      USE General
      USE Riflessi
      USE TestModel
      USE PhaseModule
      USE ArpWarp

      implicit none
      integer :: Lung
      real    :: errePostCABmin, R, Rf, vet(5)
!
      cardImage = nome(1:lnome) //'_modmin.pdb'
      FichierOut = nome(1:lnome) //'_mod.pdb'
      call cCopyFile(cardImage, FichierOut)
      cardImage = nome(1:lnome) //'_modmin.mtz'
      MTZfile = nome(1:lnome) //'_mod.mtz'
      call cCopyFile(cardImage, MTZfile)
      if (knw > 0) then
          write(6,*) 'FINALMACRO ', errePostCABmin
          write(6,*) 'FINALMACRO ', FichierOut(1:Lung(FichierOut))
          write(6,*) 'FINALMACRO ', MTZfile(1:Lung(MTZfile))
      endif
!
      call FinalSequences
*FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
*     call StartGlob ! NO COOT
*FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
!
      call LeggiMtzDna
      call GetRvalueFromPDB(R, Rf, knw)
      vet(1) = R * 10000
      vet(2) = erore
      call LoadPDBfromAmb(0, -1, 2)
      if (knw > 0) write(6,*) 'FINALMACRO ', R, Rf
      CaOnly = .false.
      confronta = .false.
      call LoadPDBfromAmb(0, 0, 1)
      CaOnly = .true.
      call to_coord_sir(-1, nrefl)
      vet(3) = vett_test(7)
      vet(5) = vett_test(4)
      CaOnly = .false.
      call to_coord_sir(-1, nrefl)
      vet(4) = vett_test(7)
      if (knw > 0) then
          write(6,*) 'FINALMACRO ', vet
          write(6,100) nint(vet(1:4)), vet(5)
      endif
      tab3(2) = R
      tab3(3) = vet(2)
      tab3(4) = vet(3)
      tab3(5) = vet(4)
      tab3(6) = vet(5)
!
      return
  100 format('TABIMPM ',61x,'|',i4,3('|',i3,' '),'| ',f6.3,' | F')
      end
!---------------------------------------------------------------
      subroutine PrePacking(j)

      USE General
      USE Riflessi
      USE RemoModule

      implicit none
      integer :: j, Lung, knwSav, k1, i
      character (len=5) :: a5
!
      write(a5,30) j
      call NoBlanks(a5,k1)
      FichierOut = nome(1:lnome)//'_remoFOM'//a5(1:k1)//'.pdb'
!
c     call examin(3331,mkang,khl,ipub,iphaz,nrefl,0,wt,1)
!
c     write(6,20) j, FichierOut(1:Lung(FichierOut))
!
      knwSav = knw
      knw    = 0
      call LoadPDBfromAmb(0,0,1)
      knw    = knwSav
!
c     call examin(3332,mkang,khl,ipub,iphaz,nrefl,0,wt,1)
*     write(6,*) 'PREPACK'
*     do i=1, natsinmodel(1)
*        write(6,11) i, model(1)%atoms(1:3,i,1), 
*    *               model(1)%specie(i,1), model(1)%th_fact(i,1)
*     enddo
*  11 format(i6,3f10.6,i7,f8.3)
!
      return
   10 format(/,' Solution       File  ',/)
   20 format(i5,5x,a)
   30 format ('_',i4)
      end
!---------------------------------------------------------------
      subroutine LeggiFasiRefmac(j)
      USE General
      USE Riflessi
      USE PhaseModule
      USE RemoModule
      USE Solutions
!
      implicit none
      integer :: j, Lung, knwSav, k1, i, ier
      character (len=5) :: a5
!
      write(a5,30) j
      call NoBlanks(a5,k1)
      cardDiret = MTZfile
      MTZfile = nome(1:lnome)//'_remoFOM'//a5(1:k1)//'.mtz'
      ifMTZlab = 0
      call LeggiFasiMTZ(ier)
      k1 = ifTime
      ifTime = 0
      call examin(3331,mkang,khl,ipub,iphaz,nrefl,0,wt,0)
      ifTime = k1
c     write(6,20) j, MTZfile(1:Lung(MTZfile)), erore
      finsolcan(j)%MPE = erore
!
      return
   10 format(/,' Solution       File        MPE ',/)
   20 format(i5,5x,a,8x,f8.2)
   30 format ('_',i4)
      end
!---------------------------------------------------------------
      subroutine Scrivi_R_Rfree
      USE General
      USE Molcom
      USE ArpWarp
      USE Html
!
      implicit none
!
      write(HTMLstr,10) RfacAW, RfreAW
      call MRInfo(99)
      call TestoGR(HTMLstr, color_GREEN, 2, 3)
      call zflush
      call DoSingleIteration()
!
      return
   10 format('R =',f8.4,'  (Rfree =',f8.4,')')
      end
!---------------------------------------------------------------
      subroutine ManageNCS()
      USE General
      USE Symmetry
      USE Solutions
      USE Atomi
      USE Molcom
      USE Riflessi
      USE riflessi_c
      USE RuotaRiflessi
      USE RemoModule

!
      dimension  b(3,3), btra(3,3), x1(3), x2(3), vCorr(10)
      dimension vRot(10,3)
      dimension vet1(3),vet2(3)
      integer vTri(10), ivet2(3)
      integer hkl(3)
      character*40 fmt,fmt1
      Integer*4   Cnk
      Integer,    allocatable:: CombiS (:,:)
      Real,       allocatable:: workC1 (:)
      Integer,    allocatable:: workC2 (:) 
      Real,       allocatable:: workC3 (:)
      real, allocatable ::workRenor1(:), workRenor2(:)
      real, allocatable ::RotSel(:,:)

c
      allocate(workRenor1(1:nreflSelRot), stat=ier)
      allocate(workRenor2(1:nreflSelRot), stat=ier)
      allocate(RotSel(1:nMolMR,1:nreflSelRot), stat=ier)

      rhoSogNCS=1.0
!
      numbComb = Cnk(nSolToExplore, nMolMR) + nSolToExplore !num combinazioni semplici + combinazione con se stessa
      ALLOCATE (CombiS(1:numbComb, 1:nMolMR), stat = ierr)
      ALLOCATE (workC1(1:numbComb), stat = ierr)
      ALLOCATE (workC2(1:numbComb), stat = ierr)
      ALLOCATE (workC3(1:numbComb), stat = ierr)

      call CombinazioniSempliciRip(CombiS,nSolToExplore,numbComb,nMolMR)
      write(lo,*) '  ManageNCS ---------- ',nSolToExplore, numbComb
      write(fmt, 10) nMolMR
      write(fmt1,20) nMolMR
      write(lo,*) fmt
      write(lo,*) fmt1
   10 format('(',i2,'(i7,f8.3),2x,f8.3)')
   20 format('(',i2,'(i7,3f6.1,2x),f8.3)')
!
      do nComb = 1, numbComb

          j1 = CombiS(nComb, 1)
          i1 = solcan(j1)%ipunt
          vCorr(1) = solcan(i1)%RotFom
          tet1 = solcan(i1)%RotVal(1)
          tet2 = solcan(i1)%RotVal(2)
          tet3 = solcan(i1)%RotVal(3)
          call RotationOper1(b,tet1,tet2,tet3)

          do i=1,nreflSelRot
               tcalc=0.0
               do jj=1,nsym
                  do io=1, 3
                     vet2(io) = 0
                     do jo=1, 3
                        vet2(io)=vet2(io) + b(io,jo)* khlv_eq(jo,jj,2,i)
                     enddo
                  enddo
                  call controllo_indici_interi(vet2,ivet2)
                  indr = ivet2(1)*ifat1C + ivet2(2)*ifat2C + ivet2(3)
                  if (indr <= 0) then
                      j = 0
                  endif
                  if (indr <= ifatxC .and. indr > 0) then
                      j = superind(indr)
                      if (j > 0) then
                          tcalc=tcalc+ecvetc(j)    !  Ecalc**2 da modello
                      endif
                  endif
               enddo
               RotSel(1,i) = sqrt(tcalc) !valore di Ealfa
          enddo
          
          do nM = 2, nMolMR
            j2 = CombiS(nComb, nM)
            i2 = solcan(j2)%ipunt
            vCorr(nM) = solcan(i2)%RotFom
            tet1 = solcan(i2)%RotVal(1)
            tet2 = solcan(i2)%RotVal(2)
            tet3 = solcan(i2)%RotVal(3)
            call RotationOper1(b,tet1,tet2,tet3)
!

            do ii=1,nreflSelRot
               tcalc=0.0
               do jj=1,nsym
                  do io=1, 3
                     vet2(io) = 0
                     do jo=1, 3
                        vet2(io)=vet2(io) + b(io,jo)*khlv_eq(jo,jj,2,ii)
                     enddo
                  enddo
                  call controllo_indici_interi(vet2,ivet2)
                  indr = ivet2(1)*ifat1C + ivet2(2)*ifat2C + ivet2(3)
                  if (indr <= 0)j = 0
                  if (indr <= ifatxC .and. indr > 0) then
                      j = superind(indr)
                      if (j > 0) tcalc=tcalc+ecvetc(j)    !  Ecalc da modello
                  endif
               enddo
               RotSel(nM,ii) = sqrt(tcalc)
            enddo
c          enddo
          call CalcolaCosto2NCS(RotSel(:,:),corre,nM)
          workC1(nComb) = corre
          workC2(nComb) = nComb
          workC3(nComb) = corre
        enddo
      enddo
      write(lo,*) '  ManageNCS ---------- '
      rmax=maxval(workC1(1:numbComb))
      rmin=minval(workC1(1:numbComb))
      iuno = -1   
      call sortall3(iuno,workC3,iuno,numbComb,workC2)
      do i=1,numbComb
            nC = workC2(i)
            if(rmax==rmin)then
               rho=0.
            else 
               rho=(workC1(nC)-rmax)/(rmin-rmax)
            endif
            if(rho <= rhoSogNCS) then
               do nm = 1, nMolMR
                  k1 = CombiS(nC, nm)
                  k1 = solcan(k1)%ipunt
                  vRot(nm,1:3)=solcan(k1)%RotVal(1:3)*rtod
                  vTri(nm)=solcan(solcan(CombiS(nC,nm))%ipunt)%trial 
               enddo
               write(lo,fmt1) (vTri(nm), vRot(nm,:), nM = 1, nMolMR),
     &                                    workC1(nC)
            endif
      enddo
      DEALLOCATE (CombiS, workC1, workC2, workC3, stat = ierr)
      deallocate (workRenor1, workRenor2, RotSel, stat = ier)
!
      return
      end
!---------------------------------------------------------------
      Subroutine CombinazioniSempliciRip(CombiS, N, NR, K)
!
!   Ritorna, nella matrice CombiS(Cnk(N, K), K) con N >= K e K > 0,
!   le combinazioni semplici di N oggetti della classe K:
!
      Integer   N, K, R, NR, C, P, CombiS(NR,K)

      ! Scrivo la prima riga:
      Do C = 1, K
         CombiS(1, C) = C
      end do

      ! Righe rimanenti:
      do R = 2, NR-N

         P = K
         Do While (CombiS(R - 1, P) >= N - K + P)
            P = P - 1
         enddo

         do C = 1, P - 1
            CombiS(R, C) = CombiS(R - 1, C)
         end do

         CombiS(R, P) = CombiS(R - 1, P) + 1

         do C = P + 1, K
            CombiS(R, C) = CombiS(R, C - 1) + 1
         end do

      end do
      M = 1
      do i=NR-N+1,NR
         CombiS(i,:) = M
         M = M + 1
      enddo
      do i=1, NR
         write(6,'(i3,1h),10i5)') i, CombiS(i,1:K)
      end do

      return
      end
!-----------------------------------------------------------------------
      Integer Function Prodotto(N2, N3)

!   Ritorna il prodotto dei numeri, consecutivi, interi e positivi,
!   da N1 a N2 (0 < N1 <= N2). Se N1 > N2 ritorna 1.
!   Se N1 manca, ritorna il Fattoriale di N2; in questo caso puo'
!   anche essere N2 = 0 perche', per definizione, e' 0! = 1:

      Integer   Pr, I

      if (N3 == -1) then
          N1 = 2
      else
          N1 = N3
      endif
      Pr = 1
      do I = N1, N2
         Pr = Pr * I
      end do

      Prodotto = Pr
      return

      End
!-----------------------------------------------------------------------
      Integer Function Dnk(N, K)
!
!   Ritorna il numero delle disposizoni semplici
!   di N oggetti presi a gruppi di K. Se K = 0 e',
!   per definizione, Dnk(N, 0) = 1:
!
      Integer*4 Prodotto

      Dnk = Prodotto(N, N - K + 1) 
!
      return
      end
!---------------------------------------------------------------
      subroutine TraslaFrammento2(nsol,WhichTraSol,nM)
!
!--faccio la traslazione con la FFT, mantenendo un monomero fisso
!
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Molcom     
      USE Mappa
      USE Solutions
      USE RuotaRiflessi
      USE riflessi_c
      USE TraslaSolution
      USE RemoModule
      USE PhaseModule
      USE Param
!
      logical :: noWrite,plusModel
      integer :: ncount,maxcount 
      common/util2/noWrite,ncount,maxcount,plusModel
      dimension delta(3),vet2(3)
      integer :: iHcan(3), inCheshireLat, nM, hklmax(3)
      integer :: WhichTraSol,vet(1)
      character stringa*20
      common /skip/ tet_old(3), delta_old(3), tet123(3), delta123(3)


      use_sigmaA=.true.

c
      if (ifPositioned == 0) then
          aver=0.0
          aversh=0.0
          rho_min = (0.5/resol2)**2 
          do j=1,nreflSelTra
             term=(1.0-exp(-rhovcomp(j)/rho_min))*focomp(j)
c            write(6,*) 'term',term, rhovcomp(j), rho_min, focomp(j)
             aver=aver+term*term
             aversh=aversh+Fsh(1,1,j)*FshFix(1,1,j)
c            write(6,*) 'aver',aver, aversh, Fsh(1,1,j),FshFix(1,1,j)
          enddo
c          write(6,*) 'term1',term

          aver=aver/float(nreflSelTra)
          aversh=aversh/float(nreflSelTra)
c
c--salvo le variabili
c
          natsOld=nats
          ifP1Old = ifP1
!
!-- create the TF Map
!
          hklmax(1:3)=-99999.0
          fcvetc=0.0
          fcvets=0.0
          ihmaxlim=0.5*(ifat2C-1)
c
          nsymicent=nsym*(icent+1)
         
          do j=1,nreflSelTra
!--per il momomero fisso posso considerare anche s1=s2
            do k2=1,nsymicent
              do k1=k2,nsymicent 
                solvcorr = 1.0-exp(-rhovcomp(j)/rho_min)
                term1=solvcorr * focomp(j)
                term2=term1*term1-aver
c
c--termine del monomero fisso
c
                do ii=1,3
                  vet2(ii)= khlv(1,1,j)*( -kmat(k1,1,ii) )+
     &                      khlv(2,1,j)*( -kmat(k1,2,ii) )+
     &                      khlv(3,1,j)*( -kmat(k1,3,ii) )
                enddo
                call controllo_indici_interi(vet2,iHcan)
c
c--seleziono i riflessi H
c1lys_remo_ultimo.out
                indr = iHcan(1)*ifat1C + iHcan(2)*ifat2C + iHcan(3)
                if (indr>0.and.indr <= ifatxC) then
                  jj = superind(indr)
                  if (jj > 0) then
c
c--calcolo i coefficienti
c
                   if(abs(iHcan(1))>hklmax(1)) hklmax(1)=abs(iHcan(1))
                   if(abs(iHcan(2))>hklmax(2)) hklmax(2)=abs(iHcan(2))
                   if(abs(iHcan(3))>hklmax(3)) hklmax(3)=abs(iHcan(3))
                   arg=Fsh(k1,2,j)-FshFix(k2,2,j)
                   term=2.0*term2*Fsh(k1,1,j)*FshFix(k2,1,j)
                   term=term/(aver*aversh)
                   fcvetc(jj)=fcvetc(jj)+term*cos(arg)
                   fcvets(jj)=fcvets(jj)+term*sin(arg)
                  endif
                endif
              enddo
            enddo
c             write(6,*) 'term',term
            do k2=1,nsymicent-1
              do k1=k2+1,nsymicent
c
c--termine del monomero libero
c
                do ii=1,3
                  vet2(ii)=khlv(1,1,j)*(kmat(k2,1,ii)-kmat(k1,1,ii) )+
     &                     khlv(2,1,j)*(kmat(k2,2,ii)-kmat(k1,2,ii) )+
     &                     khlv(3,1,j)*(kmat(k2,3,ii)-kmat(k1,3,ii) )
                enddo
                call controllo_indici_interi(vet2,iHcan)
c
c--seleziono i riflessi H
c
                indr = iHcan(1)*ifat1C + iHcan(2)*ifat2C + iHcan(3)
                if (indr>0.and.indr <= ifatxC) then
                  jj = superind(indr)
                  if (jj > 0) then
c
c--calcolo i coefficienti
c
                   if(abs(iHcan(1))>hklmax(1)) hklmax(1)=abs(iHcan(1))
                   if(abs(iHcan(2))>hklmax(2)) hklmax(2)=abs(iHcan(2))
                   if(abs(iHcan(3))>hklmax(3)) hklmax(3)=abs(iHcan(3))
                   arg=Fsh(k1,2,j)-Fsh(k2,2,j)
                   term=term2*Fsh(k1,1,j)*Fsh(k2,1,j)
                   term=term/(aver*aversh)
                   fcvetc(jj)=fcvetc(jj)+term*cos(arg)
                   fcvets(jj)=fcvets(jj)+term*sin(arg)
c                   write(6,*)jj,fcvetc(jj),aver,aversh,arg,Fsh(k1,1,j),Fsh(k2,1,j)
 
                  endif
                endif
              enddo
            enddo
          enddo
c
          if (WhichTraSol == -1) then
              call AllocaMappa(2)
c             write(6,*) 'prima',ihmx,np
              ihmxSav(:)=ihmx(:)
              ihmx(1:3)=hklmax(1:3)
              call CheckGrid()
c             write(6,*) 'dopo',ihmx,np
              call AllocaMappa(1)
          endif
c
          call MakeMapMR(xmap, xmapC, FORTH, BACK, np, FFTW_ESTIMATE)

          

c
c--cambio gruppo spaziale
c
          icent=0
          tmat(:,:)=0.
          kmat(2:,:,:)=0.
          nsym=1
          call musym()
          nsymTot=nsym*(icent+1)*pts
          latt=1 ! evita di considerare la centratura
c
c--cerco i picchi  (attenzione, li cerca nel gruppo spaziale della proteina!)
c
          nats=0
          krecy=0
          ihalf=0  ! per fare il peak search su tutta la cella 
          alim=nGridv(1)*nGridv(2)*nGridv(3)  
          term=alim/10.0
          aperc(1)=max(50.0,term)
!
          aperc(1) = min(aperc(1), 1000.0) !  Gianluca 26/01/2013
!
!          aperc(1)=50.
           if (allocated(xyzs)) then
               deallocate(xyzs, stat = ier1)
           endif
           if (allocated(nz)) then
               deallocate(nz, stat = ier1)
           endif
          MaxAtoms = aperc(1) * 2
          allocate(xyzs(1:5,1:MaxAtoms), stat = ier1)
          allocate(nz(1:MaxAtoms),       stat = ier2)
          call pksrch_New(-1,1,nrefl,ier)
!TEST!    call pksrch_New(-1,0,nrefl,ier) ! solo nella ASU
c
c--ristabilisco il gruppo spaziale originario
c
canna        
          noWrite=.false.
          call RestoreLists123(2)
canna
          ifP1 = ifP1Old
c
          nRis = 0

          if (nsym==1.and.icent==0) then
              dimmax=nSolToExploreRot
          else
              dimmax = nGridMR(1) * nGridMR(2) * nGridMR(3)
          endif

          do i = 1 , nats
             if(.not.plusModel) then
                write(stringa,'(i10)') jMolMR
                call NoBlanks(stringa,k2)
                Msg = 'NCS stage for solution ' // Inte(1:k1)//
     *         ': searching translation for monomer '//stringa(1:k2)//''
             else
                write(stringa,'(i10)') WhichMonomer
                call NoBlanks(stringa,k2)
                Msg ='Searching translation for model '// Inte(1:k1)//
     *          ': monomer ' //stringa(1:k2) //''
             endif
             call scrper(Msg,i,nats)

             delta(1)=side(xyzs(1,i))
             delta(2)=side(xyzs(2,i))
             delta(3)=side(xyzs(3,i)) 
 
             delta123(1:3) = delta(1:3)
!
! inserire controllo per escludere rototralazioni 
! equivalenti ad un monomero precedente (tet_old e delta_old)
!

!??????????????????????????????????????????????????????????????

!

             if (inCheshireLat(delta) == 1) then   !!! CHESHIRE
                 nRis = nRis + 1
                 if (nRis > nTraSol) then
                    if (knw>0) write(lo,*) 'Warning: vector TraSol full'
                    exit  ! per non sfondare il vettore TraSol
                 endif
                 call sftrNew(2, delta, corre, nM)
                 TraSol(nRis)%TraVal(1:3) = delta(1:3)
                 TraSol(nRis)%TraFom = corre
c                TraSol(nRis)%LocFom = xyzs(4,i)/1000000.
c                TraSol(nRis)%LocFom = xyzs(4,i)/(aver*aversh)
                 TraSol(nRis)%LocFom = xyzs(4,i)
c                 write(6,'(a,i6,3f8.3,g15.2,f8.3)') 'picco sel '
c     &                          ,nRis,xyzs(1:3,i),xyzs(4,i),corre
                 if (nRis == dimmax) exit
             endif
          enddo
!
          deallocate(xyzs, nz, stat = ier3)
!
          if (nRis == 0) then
              write(6,*) 'nessun picco trovato'
              return
          endif
c
c--rimetto a posto i valori
c
          nats=natsOld
c
c--seleziono la migliore soluzione
c
          vet=maxloc(TraSol(1:nRis)%TraFom)
          WhichTraSol=vet(1)
      else
*       if (ifPositioned == 1) then
          delta(1:3) = TranslAppl(1:3)
          call sftrNew(2, delta, corre, nM)
          TraSol(1)%TraVal(1:3) = delta(1:3)
          TraSol(1)%TraFom = corre

          call AllocaMappa(2)
          ihmxSav(:)=ihmx(:)
          ihmx(1:3)=hklmax(1:3)
          call CheckGrid()
          call AllocaMappa(1)
          ihmx(:)=ihmxSav(:)
          WhichTraSol = 1
c          TraSol(WhichTraSol)%TraVal(1:3) = 0
c          TraSol(WhichTraSol)%TraFom = 1.0
      endif
!
!-- compute M.P.E ( if known structure )
!
      delta(1:3) = TraSol(WhichTraSol)%TraVal(1:3)
      use_E =.false.
      use_sigmaA =.false.
      call sftrNew(2, delta, corre, nM) 
      use_E=.true.
      use_sigmaA=.true.
      if (knw == 1) then
          tmpwt(:) = 0.0
          do io=1, nreflSelTra
             j = k_mem1(io)
             tmpwt(j) = 1.0
          enddo
          nbru  = 0
          izero = 0
          ifmin = 0
          call examin(nbru,mkang,khl,ipub,iphaz,nrefl,izero,
     *                   tmpwt,ifmin)
      else
          erore = 0.0
      endif
      TraSol(WhichTraSol)%MolMPE=erore
      TraSol(WhichTraSol)%TraCorr=corre

      shf2(1:3) = TraSol(WhichTraSol)%TraVal(1:3)
      call RigettaSoluzioni(WhichTraSol)

c
c--aggiorno le variabili globali per la grafica
c
      if (TraSol(WhichTraSol)%TraFom > globval(1)) then
          globval(1) = TraSol(WhichTraSol)%TraFom
          globval(2) = nsol
      endif
c
c--scrivo i risultati
c
      if (knw==1) then
          write(lo,60) TraSol(WhichTraSol)%TraVal(1:3),
     &          TraSol(WhichTraSol)%TraFom, TraSol(WhichTraSol)%MolMPE
c    &          ,globval(1),nint(globval(2))
      elseif (kverbo > 0) then
          write(lo,61) TraSol(WhichTraSol)%TraVal(1:3), 
     &                 TraSol(WhichTraSol)%TraFom
c    &          ,globval(1),nint(globval(2))
      endif

c
      numbrun = nsol
      if (corre.ge.fomBestE) fomBestE = corre
c
      call toflush()
c
      return
c  60 format(25x,f8.3,3f7.3,f7.2,f8.3,i5)
c  61 format(25x,f8.3,3f7.3,f8.3,i5)
   60 format(36x,"1)",3f7.3,f8.3,f7.2)
   61 format(36x,"1)",3f7.3,f8.3)
      end
!-----------------------------------------------------------------------
      subroutine EsportaMR(iAction, j1, j1ord)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Finale
      USE RemoModule
      USE Solutions
      USE PhaseModule
      USE Riflessi
!
!-- iAction = 1 move coordinates in binary file
!--         = 2 export coordinates in PDB format
!
      implicit none 
    
      integer :: iAction,j1ord,k1,k,k2,ifLista5,nbru,izero,ifmin
      integer :: kk,numbPDB,i1,i2,j1,kStripTask1,itype,iform,jop
      integer :: ifFast,ifREM,jopen,ier,i3, kt, filtra
      real    :: x1(3), xeq(3)
!      common /minma/ amin(3), amax(3)
!      real dimension xo(3), xn(3), xeq(3), vet(2), s(3), ix(3)
      character a5*5
!
      write(a5,15) j1ord
  15  format ('_',i4)
      call NoBlanks(a5,k1)
      k = index(fname(1),'.bin')
      k2 = kStripTask1(k)
      if (iAction == 1) then
          ifLista5 = InfoOK(5)
          if (ifLista5.gt.0) then
            call Impacchetta()
          endif
      elseif (iAction == 2) then
          if (ifShelx == 0) then
!
!-- overlap model to target
!
              if (knw == 1 .and. ifOverlap == 1) then
                  call Overlap(1)
              endif
!
              numbPDB = 0
              kk = 0
              do i1=1, numbModels
                 do i2=1, MonomerInModel(i1)
                    if (finsolcan(j1)%flag(i1,i2) == -1) then
                        kk = kk + 1
                    else
                        numbPDB = numbPDB + natsInModel(i1)
                    endif
                 enddo
              enddo
!!            cardDiret = fname(1)(1:k2-1) // a5(1:k1) // '.pdb'
              cardDiret = fname(1)(1:k2-1)//'_remo'//a5(1:k1)//'.pdb'
ccc           cardDiret = fname(1)(1:k2-1)//'_remo.pdb'
              itype = 0
              iform = 1
              jop = jopen(jhost,cardDiret,itype,iform,ier)
              if (FichierOut(1:1) == ' ') then
                  FichierOut = cardDiret
              endif
              if (kk == 0) then
                  numbPDB = -1
!--attenzione: gestire correttamente i modelli da scrivere nel pdb
!  nel caso in cui flag=-1
*             else
*                 numbPDB = (nMolMR - kk) * natsMR
              endif
              WhichSolution = j1
              ifFast = 2
              ifREM = 3 ! numero di colonne da scrivere
!
!-- filtra il pdb per gli atomi di tipo OT
!
              filtra = 0
              do i1=1, size(model)
                 if (.not.allocated(model(i1)%atoms)) cycle
                 do i2=1, MonomerInModel(i1)
                    do i3=1, natsInModel(i1)
                       if (model(i1)%tipoAtomo(i3,i2)(1:4) 
     *                     == 'ot  ') then
                           model(i1)%HETA(i3,i2) = -1
                           filtra = 1
                       endif
                    enddo
                 enddo
              enddo
!
!-- avvicina i modelli
!
              call AvvicinaModelli
!
              call outPDB(jhost, numbPDB, ifFast, ifREM, filtra)
              close(jhost)
!
              call ManageSe
!
          else
              cardDiret = fname(1)(1:k2-1) // a5(1:k1) // '.ins'
              itype = 0
              iform = 1
              jop = jopen(jhost,cardDiret,itype,iform,ier)
              nz(1:nats) = nz(1:nats) * nzConst
              call outShelx(0)
              nz(1:nats) = nz(1:nats) / nzConst
              close(jhost)
          endif
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine WriteRemoInfo()
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Molcom          
      USE Mappa
      USE Param
      USE PhaseModule
!
      write(lo,9) 
    9 format(/,' ',80('+'),//,
     *     ' Extending phases from Molecular Replacement Procedure',/)

      write(lo, 130) resm,factr,np
      if (ksize.gt.3) then
          write(lo, 210) v_p, v_s
      endif
!
      if (knw == 1) then
          if (SogliaCorre < 2.0) then
              write(lo, 220) SogliaCorre
          endif
      endif
!     
      if (ksize.eq.1) then
          write(lo, 140) ' Refinement strategy #',ksize
      elseif (ksize.eq.2) then
          write(lo, 150) ' Refinement strategy #',ksize
      elseif (ksize.eq.3) then
          write(lo, 160) ' Refinement strategy #',ksize
      elseif (ksize.eq.4) then
          write(lo, 170) ' Refinement strategy #',ksize
      elseif (ksize.eq.5) then
          write(lo, 180) ' Refinement strategy #',ksize
      elseif (ksize.eq.6) then
          write(lo, 190) ' Refinement strategy #',ksize
      endif
!
      call toflush()
      write(lo,*) ' '
      write(lo, 400)
!
      return
!
  130 format(' Resolution & grid step (Ang)   =',3x,2f8.2,/,
     *       ' Fourier map grid points        =',3i8)
  140 format(/,a,i2,
     *': very small-size structure ( up to 5 atoms in a.u. )')
  150 format(/,a,i2,
     *': small-size structure ( 6-80 atoms in a.u. )')
  160 format(/,a,i2,
     *': medium-size structure ( 80-200 atoms in a.u. )')
  170 format(/,a,i2,
     *': large-size structure ( 200-600 atoms in a.u. )')
  180 format(/,a,i2,
     *': very large-size structure ( 600-1000 atoms in a.u. )')
  190 format(/,a,i2,
     *': very large-size / difficult structure ( >1000 atoms in a.u. )')
  210 format (' Protein volume percentage      =',f12.3,/,
     *        ' Solvent volume percentage      =',f12.3)
  220 format (5x,' Soglia_CC = ',f8.3)
  400 format(' ',80('+'),/)
  300 format (
     +  ' Included reflections for Rfree =',i8,' / ',i8,/
     +  ' Excluded reflections for Rfree =',i8,' / ',i8,/
     +  '    Total reflections for Rfree =',i8,' / ',i8)
!
      end
!-----------------------------------------------------------------------
      subroutine ChemInfo_MR(badd)
!
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Mappa
      USE RemoModule
      USE PhaseModule
      USE Riflessi
!
      integer sidepp
      dimension xs1(3)
      dimension anorm2(4),vet(4)
      dimension gauss(4501)
      dimension all(2,5),bss(2,5)
      integer ipunt(5)

!
!-- make plans
!
      if (FORTH == 0) then
          call sfftw_plan_dft_c2r_3d(FORTH, np(1), np(2), np(3), 
     *                               xmapC,xmap, FFTW_ESTIMATE)
          call sfftw_plan_dft_r2c_3d(BACK,  np(1), np(2), np(3),
     *                               xmap,xmapC, FFTW_ESTIMATE)
      endif
!
! -- creo la mappa inserendo una gaussiana intorno ad ogni
! -- atomo posizionato; le code si possono sovrapporre
!
c
c--per questi atomi uso i fattori di scattering di Argawal
c
      ipunt(1:5)=(/ 1, 6, 7, 8, 16 /)
      all(1:2,1)=(/  0.7932, 0.1949 /)  ! H
      bss(1:2,1)=(/ 24.2157, 2.1089 /)
      all(1:2,2)=(/  2.9972, 2.9791 /)  ! C
      bss(1:2,2)=(/ 30.0167, 2.8886 /)
      all(1:2,3)=(/  2.9924, 3.9986 /)  ! N
      bss(1:2,3)=(/ 25.3766, 3.5004 /)
      all(1:2,4)=(/  2.4485, 5.5589 /)  ! O
      bss(1:2,4)=(/ 24.7562, 4.1372 /)
      all(1:2,5)=(/  5.5480,10.4241 /)  ! S
      bss(1:2,5)=(/ 33.7108, 1.9034 /)
!
!--determino la costante per passare da Angstrom a punti griglia:
!
      deltx=np(1)/cell(1)
      deltChem=deltx
      FourPiSq=TwoPi*TwoPi
      rmax=2.5
      eps= 0.00001
c
c--tabulazione dei valori della funzione esponenziale
c
      gauss(:) = 0.0
      do i = 1,4500
        gauss(i) = exp(-0.002*i+0.002)
      enddo
c
**    write(6,*) 'ChemInfo_MR'
!     do i=inizMR,ifinMR
      do i=1, natsInModel(WhichModel)
        xs1(1)=side(model(WhichModel)%atoms(1,i,1))
        xs1(2)=side(model(WhichModel)%atoms(2,i,1))
        xs1(3)=side(model(WhichModel)%atoms(3,i,1))
        bterm=model(WhichModel)%th_fact(i,1)+badd
!                  centr* occupanza   



        anorm=100.*pts*model(WhichModel)%atoms(5,i,1)+10*badd
        kz=model(WhichModel)%specie(i,1) / nzConst
**    write(6,*) i,kz,xs1,bterm,anorm
        iargawal=0
        do ii=1,5
          if(model(WhichModel)%no(kz)==ipunt(ii)) then
             iargawal=1
             kz1=ii
             exit
          endif
        enddo
*       write(6,*) i,kz,iargawal,xs1,bterm,anorm
        if(iargawal==1) then
           anorm1 = 0.0
           ngaus=2
           do ii=1,ngaus
             vet(ii)=bterm+bss(ii,kz1)
             vet(ii)=max(eps,vet(ii)) 
             anorm2(ii) =  anorm * all(ii,kz1)/ (vet(ii))**1.5
           enddo
        else
           anorm1 =  anorm * model(WhichModel)%cl(kz)/(bterm)**1.5
           ngaus=4
           do ii=1,ngaus
             vet(ii)=bterm+model(WhichModel)%bs(ii,kz)
             vet(ii)=max(eps,vet(ii))
             anorm2(ii) =  anorm * model(WhichModel)%al(ii,kz) / 
     *                     (vet(ii))**1.5
           enddo
        endif
c
c--determino il raggio di integrazione
c
        alim=rmax*(sqrt(bterm+25)/TwoPi)
        DmaxSq=alim*alim
!
        iszu=int(xs1(3)*np(3)+alim*deltChem)
        iszl=int(xs1(3)*np(3)-alim*deltChem)
        isyu=int(xs1(2)*np(2)+alim*deltChem)
        isyl=int(xs1(2)*np(2)-alim*deltChem)
        isxu=int(xs1(1)*np(1)+alim*deltChem)
        isxl=int(xs1(1)*np(1)-alim*deltChem)
!
!--definisco un intorno di ogni atomo e creo la Gaussiana
!
        do iz = iszl, iszu
          do iy = isyl, isyu
            do ix = isxl, isxu
              a1=ix/deltChem-xs1(1)*cell(1)
              a2=iy/deltChem-xs1(2)*cell(2)
              a3=iz/deltChem-xs1(3)*cell(3)
              ray=a1**2 + a2**2 + a3**2 
              if (ray < DmaxSq) then
                 ix1=sidepp(ix,np(1))
                 ix2=sidepp(iy,np(2))
                 ix3=sidepp(iz,np(3))
c                factt=anorm1*exp(-(FourPiSq*ray)/bterm)
                 term = ray*500.0*(FourPiSq/bterm) + 1.0
                 term = MIN1(term,4001.1)
                 iterm = nint(term)
                 factt  = anorm1*GAUSS(iterm) 
                 do ii=1,ngaus
c                  factt=factt+anorm2(ii)*exp(-(FourPiSq*ray)/vet(ii))
                   term = ray*500.0*(FourPiSq/vet(ii)) + 1.0
                   term = MIN1(term,4001.1)
                   iterm = nint(term)
                   factt  = factt + anorm2(ii)*GAUSS(iterm) 
                 enddo
                 xmap(ix1,ix2,ix3) = xmap(ix1,ix2,ix3)+factt
              endif
            enddo
          enddo
        enddo
!
      enddo
!
      call NewInv_MR()
!
      return
      end
c------------------------------------------------------------------
      subroutine ChemInfo_MR_Local(badd)
!
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Mappa
      USE RemoModule
      USE PhaseModule
!
      integer sidepp
      dimension xs1(3)
      dimension xs(3)
      dimension anorm2(4),vet(4)
      dimension gauss(4501)
      dimension all(2,5),bss(2,5)
      integer ipunt(5)
!
!-- make plans
!
      if (FORTH == 0) then
          call sfftw_plan_dft_c2r_3d(FORTH, np(1), np(2), np(3), 
     *                               xmapC,xmap, FFTW_ESTIMATE)
          call sfftw_plan_dft_r2c_3d(BACK,  np(1), np(2), np(3),
     *                               xmap,xmapC, FFTW_ESTIMATE)
      endif
!

! -- creo la mappa inserendo una gaussiana intorno ad ogni
! -- atomo posizionato; le code si possono sovrapporre
!
c
c--per questi atomi uso i fattori di scattering di Argawal
c
      ipunt(1:5)=(/ 1, 6, 7, 8, 16 /)
      all(1:2,1)=(/  0.7932, 0.1949 /)  ! H
      bss(1:2,1)=(/ 24.2157, 2.1089 /)
      all(1:2,2)=(/  2.9972, 2.9791 /)  ! C
      bss(1:2,2)=(/ 30.0167, 2.8886 /)
      all(1:2,3)=(/  2.9924, 3.9986 /)  ! N
      bss(1:2,3)=(/ 25.3766, 3.5004 /)
      all(1:2,4)=(/  2.4485, 5.5589 /)  ! O
      bss(1:2,4)=(/ 24.7562, 4.1372 /)
      all(1:2,5)=(/  5.5480,10.4241 /)  ! S
      bss(1:2,5)=(/ 33.7108, 1.9034 /)
!
!--determino la costante per passare da Angstrom a punti griglia:
!
      deltx=np(1)/cell(1)
      delty=np(2)/cell(2)
      deltz=np(3)/cell(3)
      caChem=cos(cell(4)*dtor)
      cbChem=cos(cell(5)*dtor)
      cgChem=cos(cell(6)*dtor)
      FourPiSq=TwoPi*TwoPi
      rmax=2.5
c
c--tabulazione dei valori della funzione esponenziale
c
      xmap(:,:,:)=0.0
      gauss(:) = 0.0
      do i = 1,4500
         gauss(i) = exp(-0.002*i+0.002)
      enddo
c
      do ij=1, numbModels
         do j=1, MonomerInModel(ij)
            if (model(ij)%considerato(j) == 0) cycle
            do i=1,natsInModel(ij)
               xs1(1)=side(model(ij)%atoms(1,i,j))
               xs1(2)=side(model(ij)%atoms(2,i,j))
               xs1(3)=side(model(ij)%atoms(3,i,j))
               bterm=model(ij)%th_fact(i,1)+badd
!              centr* occupanza   
               anorm=100.*pts*model(ij)%atoms(5,i,j)+10*badd
               kz=model(ij)%specie(i,1) / nzConst
               iargawal=0
               do ii=1, 5
                  if (model(ij)%no(kz) == ipunt(ii)) then
                     iargawal=1
                     kz1 = ii
                     exit
                  endif
               enddo
c        enddo
c      enddo
          
         if (iargawal == 1) then
             anorm1 = 0.0
             ngaus=2
             do ii=1,ngaus
                vet(ii)=bterm+bss(ii,kz1)
                anorm2(ii) =  anorm * all(ii,kz1)/ (vet(ii))**1.5
             enddo
         else
             anorm1 =  anorm * model(ij)%cl(kz)/(bterm)**1.5
             ngaus=4
             do ii=1,ngaus
                vet(ii)=bterm+model(ij)%bs(ii,kz)
                anorm2(ii) =  anorm * model(ij)%al(ii,kz)
     *                        / (vet(ii))**1.5
             enddo
         endif
!
!-- determino il raggio di integrazione
!
         alim=rmax*(sqrt(bterm+25)/TwoPi)
         DmaxSq=alim*alim
!
!-- aggiungo la simmetria
!
         do kk1 = 1, ncentr
            do kk2 = 1, icent+1
               coef = 1.0
               if (kk2 == 2) coef = -1.0
               do kk3 = 1,nsym
                  call xequi(xs1,kk3,coef,xs,kk1)
                  xs(1)=side(xs(1))
                  xs(2)=side(xs(2))
                  xs(3)=side(xs(3))
                  iszu=int(xs(3)*np(3)+alim*deltz)
                  iszl=int(xs(3)*np(3)-alim*deltz)
                  isyu=int(xs(2)*np(2)+alim*delty)
                  isyl=int(xs(2)*np(2)-alim*delty)
                  isxu=int(xs(1)*np(1)+alim*deltx)
                  isxl=int(xs(1)*np(1)-alim*deltx)
c       write(6,*) 'chem2',iszu,iszl,isyu,isyl,isxu,isxl
!
!--definisco un intorno di ogni atomo e creo la Gaussiana
!
                  do iz = iszl, iszu
                     do iy = isyl, isyu
                        do ix = isxl, isxu
                           a1=ix/deltx-xs(1)*cell(1)
                           a2=iy/delty-xs(2)*cell(2)
                           a3=iz/deltz-xs(3)*cell(3)
                           ray=a1**2 + a2**2 + a3**2 + 2.*a1*a2*cgChem +
     &                              2.*a1*a3*cbChem + 2.*a2*a3*caChem
                           if (ray < DmaxSq) then
                               ix1=sidepp(ix,np(1))
                               ix2=sidepp(iy,np(2))
                               ix3=sidepp(iz,np(3))
                               term = ray*500.0*(FourPiSq/bterm) + 1.0
                               term = MIN1(term,4001.1)
                               iterm = nint(term)
                               factt  = anorm1*GAUSS(iterm) 
                               do ii=1,ngaus
                                  term =ray*500.0*(FourPiSq/vet(ii))+1.0
                                  term =MIN1(term,4001.1)
                                  iterm = nint(term)
                                  factt = factt+anorm2(ii)*GAUSS(iterm)
                               enddo
                               xmap(ix1,ix2,ix3)=xmap(ix1,ix2,ix3)+factt
                           endif
                        enddo
                     enddo
                  enddo
               enddo
            enddo
         enddo
      enddo
      enddo
      enddo
!
      return
      end
c------------------------------------------------------------------
      subroutine ChemInfo_MR_Final()
!
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Mappa
      USE RemoModule
      USE PhaseModule
!
      integer sidepp
      dimension xs1(3)
      dimension xs(3)
      dimension anorm2(4),vet(4)
      dimension gauss(4501)
      dimension all(2,5),bss(2,5)
      integer ipunt(5)
!
!-- make plans
!
      if (FORTH == 0) then
          call sfftw_plan_dft_c2r_3d(FORTH, np(1), np(2), np(3), 
     *                               xmapC,xmap, FFTW_ESTIMATE)
          call sfftw_plan_dft_r2c_3d(BACK,  np(1), np(2), np(3),
     *                               xmap,xmapC, FFTW_ESTIMATE)
      endif
!

! -- creo la mappa inserendo una gaussiana intorno ad ogni
! -- atomo posizionato; le code si possono sovrapporre
!
c
c--per questi atomi uso i fattori di scattering di Argawal
c
      ipunt(1:5)=(/ 1, 6, 7, 8, 16 /)
      all(1:2,1)=(/  0.7932, 0.1949 /)  ! H
      bss(1:2,1)=(/ 24.2157, 2.1089 /)
      all(1:2,2)=(/  2.9972, 2.9791 /)  ! C
      bss(1:2,2)=(/ 30.0167, 2.8886 /)
      all(1:2,3)=(/  2.9924, 3.9986 /)  ! N
      bss(1:2,3)=(/ 25.3766, 3.5004 /)
      all(1:2,4)=(/  2.4485, 5.5589 /)  ! O
      bss(1:2,4)=(/ 24.7562, 4.1372 /)
      all(1:2,5)=(/  5.5480,10.4241 /)  ! S
      bss(1:2,5)=(/ 33.7108, 1.9034 /)
!
!--determino la costante per passare da Angstrom a punti griglia:
!
      deltx=np(1)/cell(1)
      delty=np(2)/cell(2)
      deltz=np(3)/cell(3)
      caChem=cos(cell(4)*dtor)
      cbChem=cos(cell(5)*dtor)
      cgChem=cos(cell(6)*dtor)
      FourPiSq=TwoPi*TwoPi
      rmax=2.5
      badd=0.0
*        write(6,*) 'CHEMINFOK'
c
c--tabulazione dei valori della funzione esponenziale
c
      xmap(:,:,:)=0.0
      gauss(:) = 0.0
      do i = 1,4500
         gauss(i) = exp(-0.002*i+0.002)
      enddo
c
      do im=1, numbModels
      do j=1, MonomerInModel(im)
       if (model(im)%considerato(j) == 0) cycle
       do i=1,natsInModel(im)
         xs1(1)=side(model(im)%atoms(1,i,j))
         xs1(2)=side(model(im)%atoms(2,i,j))
         xs1(3)=side(model(im)%atoms(3,i,j))
         bterm=model(im)%th_fact(i,j)+badd
!                  centr* occupanza   
         anorm=100.*pts*model(im)%atoms(5,i,j)+10*badd
*        write(6,11) i, model(im)%atoms(1:3,i,j), 
*    *               model(im)%specie(i,j), model(im)%th_fact(i,j)
*  11 format(i6,3f10.6,i7,f8.3)
         kz=model(im)%specie(i,j) / nzConst
         iargawal=0
         do ii=1, 5
            if (model(im)%no(kz) == ipunt(ii)) then
                iargawal=1
                kz1 = ii
                exit
            endif
         enddo
         if (iargawal == 1) then
             anorm1 = 0.0
             ngaus=2
             do ii=1,ngaus
                vet(ii)=bterm+bss(ii,kz1)
                anorm2(ii) =  anorm * all(ii,kz1)/ (vet(ii))**1.5
             enddo
         else
             anorm1 =  anorm * model(im)%cl(kz)/(bterm)**1.5
             ngaus=4
             do ii=1,ngaus
                vet(ii)=bterm+model(im)%bs(ii,kz)
                anorm2(ii) =  anorm * model(im)%al(ii,kz)
     *                        / (vet(ii))**1.5
             enddo
         endif
!
!-- determino il raggio di integrazione
!
         alim=rmax*(sqrt(bterm+25)/TwoPi)
         DmaxSq=alim*alim
!
!-- aggiungo la simmetria
!
         do kk1 = 1, ncentr
            do kk2 = 1, icent+1
               coef = 1.0
               if (kk2 == 2) coef = -1.0
               do kk3 = 1,nsym
                  call xequi(xs1,kk3,coef,xs,kk1)
                  xs(1)=side(xs(1))
                  xs(2)=side(xs(2))
                  xs(3)=side(xs(3))
                  iszu=int(xs(3)*np(3)+alim*deltz)
                  iszl=int(xs(3)*np(3)-alim*deltz)
                  isyu=int(xs(2)*np(2)+alim*delty)
                  isyl=int(xs(2)*np(2)-alim*delty)
                  isxu=int(xs(1)*np(1)+alim*deltx)
                  isxl=int(xs(1)*np(1)-alim*deltx)
c       write(6,*) 'chem2',iszu,iszl,isyu,isyl,isxu,isxl
!
!--definisco un intorno di ogni atomo e creo la Gaussiana
!
                  do iz = iszl, iszu
                     do iy = isyl, isyu
                        do ix = isxl, isxu
                           a1=ix/deltx-xs(1)*cell(1)
                           a2=iy/delty-xs(2)*cell(2)
                           a3=iz/deltz-xs(3)*cell(3)
                           ray=a1**2 + a2**2 + a3**2 + 2.*a1*a2*cgChem +
     &                              2.*a1*a3*cbChem + 2.*a2*a3*caChem
                           if (ray < DmaxSq) then
                               ix1=sidepp(ix,np(1))
                               ix2=sidepp(iy,np(2))
                               ix3=sidepp(iz,np(3))
                               term = ray*500.0*(FourPiSq/bterm) + 1.0
                               term = MIN1(term,4001.1)
                               iterm = nint(term)
                               factt  = anorm1*GAUSS(iterm) 
                               do ii=1,ngaus
                                  term =ray*500.0*(FourPiSq/vet(ii))+1.0
                                  term =MIN1(term,4001.1)
                                  iterm = nint(term)
                                  factt = factt+anorm2(ii)*GAUSS(iterm)
                               enddo
                               xmap(ix1,ix2,ix3)=xmap(ix1,ix2,ix3)+factt
                           endif
                        enddo
                     enddo
                  enddo
               enddo
            enddo
         enddo
       enddo
      enddo
      enddo
!
      return
      end
!---------------------------------------------------------------------
      subroutine NewInv_MR()
      USE General
      USE Symmetry
      USE Mappa
      USE riflessi_c
! 
      integer ix(3),lmod
      complex sf
      logical hemiFFTW
      
      external hemiFFTW,lmod
!
      n1 = np(1)
      n2 = np(2)
      n3 = np(3)
      n0 = n1 / 2 + 1
!
!---- Scale ----*
      scfft1 = 1.0/ real(n1 * n2 * n3 * nsym)

!!gpu call sfftw_execute(BACK)
      call sfftw_executer2c(n1,n2,n3,BACK,xmap,xmapC)

!---- Fill the reflection list ----*
      do i=1, nRifDimC
         ix(1:3) = khlc(1:3,i)
!---- Average over symmetry equivalents for this reflection ----*
         sf = cmplx(0.0, 0.0)
         if (hemiFFTW(ix(1), ix(2), ix(3))) then
               iu = lmod(ix(1), n0)
               iv = lmod(ix(2), n2)
               iw = lmod(ix(3), n3)
               sf = sf + conjg(xmapC(iu,iv,iw))
         else
               iu = lmod(-ix(1), n0)
               iv = lmod(-ix(2), n2)
               iw = lmod(-ix(3), n3)
               sf = sf + xmapC(iu,iv,iw)
         endif
         sf = sf * scfft1
         fcvets(i) = abs(sf)   ! F.d.S calc.
      enddo
!
      return
      end
c---------------------------------------------------------
      subroutine NewInv_MR_Local()
      USE General
      USE Symmetry
      USE Mappa
      USE Riflessi
      USE riflessi_c
      USE RuotaRiflessi
! 
      integer ix(3),i2(3),lmod
      complex sf,phasec
      logical hemiFFTW
      
      external hemiFFTW,lmod
!
      n1 = np(1)
      n2 = np(2)
      n3 = np(3)
      n0 = n1 / 2 + 1
!
!---- Scale ----*
      scfft1 = 1.0/ real(n1 * n2 * n3 * nsym)

!!gpu call sfftw_execute(BACK)
      call sfftw_executer2c(n1,n2,n3,BACK,xmap,xmapC)

!---- Fill the reflection list ----*
      do i=1, nreflSelTra
canna2c
         ix(1:3) = khlv(1:3,1,i)
!---- Average over symmetry equivalents for this reflection ----*
         sf = cmplx(0.0,0.0)
         do j=1, nsym
            phim = twopi * (ix(1) * tsmat(1,j)
     *                   +  ix(2) * tsmat(2,j)
     *                   +  ix(3) * tsmat(3,j))
canna2c
           i2(1:3) = khlv_eq(1:3, j,1, i)

            if (hemiFFTW(i2(1),i2(2),i2(3))) then
               iu = lmod(i2(1), n0)
               iv = lmod(i2(2), n2)
               iw = lmod(i2(3), n3)
               sf = sf + conjg(xmapC(iu,iv,iw)) * phasec(phim)
            else
               iu = lmod(-i2(1), n0)
               iv = lmod(-i2(2), n2)
               iw = lmod(-i2(3), n3)
               sf = sf + xmapC(iu,iv,iw) * phasec(phim)
            endif
         enddo
         sf = sf * scfft1
canna2c
         fccomp(i) = abs(sf)   ! F.d.S calc.
      enddo
!
      return
      end
!---------------------------------------------------------------
      subroutine NewInv_MR_Final()
      USE General
      USE Symmetry
      USE Mappa
      USE Riflessi
      USE riflessi_c
      USE RuotaRiflessi
! 
      integer ix(3),i2(3),lmod
      complex sf,phasec
      logical hemiFFTW
      
      external hemiFFTW,lmod
!
      n1 = np(1)
      n2 = np(2)
      n3 = np(3)
      n0 = n1 / 2 + 1
!
!---- Scale ----*
      scfft1 = 1.0/ real(n1 * n2 * n3 * nsym)

!!gpu call sfftw_execute(BACK)
      call sfftw_executer2c(n1,n2,n3,BACK,xmap,xmapC)

!---- Fill the reflection list ----*
      do i=1, nrefl
         ix(1:3) = khl(1:3,i)
!---- Average over symmetry equivalents for this reflection ----*
         sf = cmplx(0.0,0.0)
         do j=1, nsym
            phim = twopi * (ix(1) * tsmat(1,j)
     *                   +  ix(2) * tsmat(2,j)
     *                   +  ix(3) * tsmat(3,j))
            do l=1,3
               i2(l)=0
               do k=1,3
                  i2(l)=i2(l)+ix(k)*kmat(j,k,l)
               enddo
            enddo
c
            if (hemiFFTW(i2(1),i2(2),i2(3))) then
               iu = lmod(i2(1), n0)
               iv = lmod(i2(2), n2)
               iw = lmod(i2(3), n3)
               sf = sf + conjg(xmapC(iu,iv,iw)) * phasec(phim)
            else
               iu = lmod(-i2(1), n0)
               iv = lmod(-i2(2), n2)
               iw = lmod(-i2(3), n3)
               sf = sf + xmapC(iu,iv,iw) * phasec(phim)
            endif
         enddo
         sf = sf * scfft1
         fcvet(i) = abs(sf)   ! F.d.S calc.
         faze=phaseof(sf)*rtod
         if (mkang(i).ne.1) then
             faze1= favi(mkang(i),faze)
             faze=faze1
         endif
         faze=mod(faze+3600.,360.)
         iphaz(i)=faze   ! la fase calc.
      enddo
!
      return
      end
!---------------------------------------------------------------------
      subroutine StatR_MR()
c
c--confronta gli F calcolati da SFTR (fcvetc) con gli F calcolati da FFT (fcvets) 
c
      USE riflessi_c

      dimension nrf(30)
c
      numint=10
c
c--calcolo la scala
c
      sumfo=0.0
      sumfo1=0.0
      do j=1,nRifDimC
         sumfo=sumfo+fcvets(j)
         sumfo1=sumfo1+fcvetc(j)
      enddo
      scala=sumfo1/sumfo
      call cc_vet(fcvetc,fcvets,nRifDimC,corre)
      write(6,*) 'Correlazione Fc da SFTR con Fc da FFT = ',corre
      write(6,*) 'SCALA  = ',scala
      fcvets(1:nRifDimC) = fcvets(1:nRifDimC) * scala

c
c--calcola gli RF in intervalli di Fc da SFTR
c
      sumdfcum=0.0
      sumfccum=0.0
      exmax=-999999.0
      exmin=999999.0
      do j=1,nRifDimC
         if(fcvetc(j).gt.exmax) exmax=fcvetc(j)
         if(fcvetc(j).lt.exmin) exmin=fcvetc(j)
         sumdfcum=sumdfcum+abs( fcvets(j)-fcvetc(j) )
         sumfccum=sumfccum+fcvets(j)
      enddo 
      if(sumfccum.gt.0.0) erecum=(sumdfcum/sumfccum)*100.0
      write(6,*) 'ERRE TOT = ',erecum

      eint1=exmax/float(numint * 5)
      eint2=eint1 * 2
      eint3=eint1 * 3
      exmax_sav = exmax
      exmin_sav = exmin


      eint=(exmax-exmin)/float(numint)
      write(6,'(5x,3(a,5x),a,4x,a,4x,a)')
     *'Fmin',' Fmax',' |R_F|',' R_F cum.','NR','NR cum.'
      sumdfcum=0.0
      sumfccum=0.0
      do j=1,numint
        sumdf=0.0
        ere=0.0

        elim1=exmin+(j-1)*eint
        elim2=elim1+eint
        if(elim2.ge.(exmax-0.0001).and.elim2.le.(exmax+0.0001))
     *     elim2=exmax+0.0001

        sumfc=0.0
        sumdf=0.0
        numbStat=0
        do k=1,nRifDimC
          if(fcvets(k).ge.elim1.and.fcvets(k).lt.elim2) then
            numbStat=numbStat+1
            sumdf=sumdf+abs( fcvets(k)-fcvetc(k) )
            sumfc=sumfc+fcvets(k)
            sumdfcum=sumdfcum+abs( fcvets(k)-fcvetc(k) )
            sumfccum=sumfccum+fcvets(k)
          endif
        enddo
        if(j.gt.1)then
          nrf(j)=numbStat+nrf(j-1)
        else
          nrf(j)=numbStat
        endif
        if(numbStat.eq.0) cycle 
        if(sumfc.gt.0.0) ere=(sumdf/sumfc)*100.0
        if(sumfccum.gt.0.0) erecum=(sumdfcum/sumfccum)*100.0
        write(6,'(4f10.3,2i10)') elim1,elim2,ere,erecum,numbStat,nrf(j)
      enddo
c
      return
      end
!---------------------------------------------------------------------
      subroutine CheckPseudo(iOK)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Grafici
      USE Html
      USE RemoModule
      USE PhaseModule
!
!-- Check for Pseudotranslational effects
!
!
      HTMLstr = '#'
! lo metto a false perchè non sempre posso usarla
      use_pseudo =.false.
!
      ifLista19 = InfoOK(19)
      if (ifLista19 <= 0) then
          return
      endif
!
      nTransl = lpseuv(4) !ordine pseudosimmetria
      call PutGetPseudoInfo(2,ipik)
      nps = 0
      do i=1,3
         j = (i - 1) * 4 + 4
         if (lpseuv(j) > 1) then
             nps = nps + 1
         endif
      enddo
      if (nps /= 1) then
          return
      endif
!
      !
!--da rivedere, la pseudo protrebbe anche essere applicata
!  quando nTransl>nMolMR, supponendo che alcune pseudo-traslazioni
!  si hanno utilizzando la simmetria cristallografica
!
      if (mod(nMolMR, nTransl) /= 0) then
          write(lo,'(/,5x,a,/,a,i4,a)') 'Pseudotranslation not applied '
     &              ,'because it involves',nTransl,' monomers'
                     
          return
      endif
c dice che si può usare la pseudo
      use_pseudo = .true.
            
c conserva il numero di monomeri iniziale
c      nMolMR_orig = nMolMR
c nuovo numero di monomeri considerando la pseudo
c      nMolMR = nMolMR / nTransl
      nMon_pseudo =  nTransl
      iOK = 1
      return
      end
!-----------------------------------------------------------------------
      subroutine ApplyPseudo()
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Grafici
      USE Html
      USE RemoModule
      USE PhaseModule
      USE TraslaSolution
      USE Riflessi
      USE Solutions
      USE Finale
!
!-- Apply Pesutrotranslational effects
!-- to model
!
      dimension b(3,3),x1(3),x2(3),btra(3,3),BestShift(3),BestRotaz(3)
      dimension xopti(6)
      logical single
      real, allocatable :: xopti_2mon(:)
      real xeq(3), toAdd(3)
      integer i, ii, i1, j, jj, j1, ier1
      logical :: noWrite,plusModel
      integer :: ncount, maxcount
      common /util2/ noWrite, ncount, maxcount,plusModel
 
      allocate(xopti_2mon(1:6*nMon_pseudo), stat = ier1)

      call scrper(' ',0,0)
!
      write(Inte,'(i10)') nMon_pseudo
      call NoBlanks(Inte, k1)
      Msg='<big><b>Pseudo-translational stage</b></big>'
      call TestoGR(Msg, color_RED, 2, 3)

      if(nMon_pseudo > 1)then
         Msg='Search for '// Inte(1:k1) //
     *      ' monomer(s) related by pseudo-symmetry '
      else
         Msg='Search for '// Inte(1:k1) //
     *      ' monomer related by pseudo-symmetry'
      endif

      call TestoGR(Msg, -1, 2, 3)

      do j1=1,nSolToExplore
!
         i1=j1   
         model(WhichModel)%considerato(:) = 0
         model(WhichModel)%considerato(1) = 1

         ResMol(j1,1,7) = TraAll(i1)%trial
         ResMol(j1,1,1:3) = TraAll(i1)%RotVal(1:3)* rtod
         ResMol(j1,1,4:6) = TraAll(i1)%TraVal(1:3)
         ResMol(j1,2:nMolMR,7)   = -1.0

         tet1 = TraAll(i1)%RotVal(1)
         tet2 = TraAll(i1)%RotVal(2)
         tet3 = TraAll(i1)%RotVal(3)
         call RotationOper1(b,tet1,tet2,tet3)
!
         do i=1,3
            do j=1,3
               btra(i,j) = b(j,i)
            enddo
         enddo

         do j=1, MonomerInModel(WhichModel)
            if (model(WhichModel)%considerato(j) == 0) cycle
            do i = 1, natsMR
               x1(1:3) = model(WhichModel)%saved(1:3,i,j)
               call MoltMatVec(rm, x1, x2)
               call MoltMatVec(btra, x2, x1)
               call MoltMatVec(rmi, x1, x2)
               model(WhichModel)%atoms(1:3,i,j) = x2(1:3) 
     *                                     + TraAll(i1)%TraVal(1:3)
            enddo
         enddo

         xeq(:) = 1.0
         xeq(1:3) = xeq(1:3) * lpseuv(1:3)
         xeq(1:3) = xeq(1:3) / float(lpseuv(4))
         toAdd(:) = 0.0

         do jj = 2,nMon_pseudo
            toAdd(:) = toAdd(:) + xeq(:)
            do i = 1, natsMR
               model(WhichModel)%atoms(1:3,i,jj) = 
     *                     model(WhichModel)%atoms(1:3,i,1) + toAdd(1:3)
               model(WhichModel)%saved(1:3,i,jj) = 
     *                     model(WhichModel)%saved(1:3,i,1)
            enddo
         enddo

         call AllocaMappa(2)
         ifRemo=3
         call CheckGrid()
         ifRemo=1
         call AllocaMappa(1)
         toAdd(:) = 0.0
 
         tet1 = TraAll(i1)%RotVal(1)
         tet2 = TraAll(i1)%RotVal(2)
         tet3 = TraAll(i1)%RotVal(3)
         call RotationOper1(b,tet1,tet2,tet3)
!
         do i=1,3
            do j=1,3
               btra(i,j) = b(j,i)
            enddo
         enddo

         do j=1, MonomerInModel(WhichModel)
            if (model(WhichModel)%considerato(j) == 0) cycle
            do i = 1, natsMR
               x1(1:3) = model(WhichModel)%saved(1:3,i,j)
               call MoltMatVec(rm, x1, x2)
               call MoltMatVec(btra, x2, x1)
               call MoltMatVec(rmi, x1, x2)
               model(WhichModel)%atoms(1:3,i,j) = x2(1:3) 
     *                                     + TraAll(i1)%TraVal(1:3)
            enddo
         enddo

c
         do jj = 2,nMon_pseudo

            toAdd(:) = toAdd(:) + xeq(:)
            jMolMR = jj 
            model(WhichModel)%considerato(1:jj) = 1 
            badd = 0.0
            call ChemInfo_MR_Local(badd)
            call NewInv_MR_Local()
            call cc_vet_mol(corre)
            xopti(1:3) = TraAll(i1)%RotVal(1:3) 
            xopti(4:6) = TraAll(i1)%TraVal(1:3) + toAdd(1:3)
            n_fin = 6 * jj   
            n_start =  n_fin - 5
            do ji = 1,jj-1
               n_index = 6 * (ji-1) 
               xopti_2mon(n_index+1:n_index+3) = 
     *                finsolcan(j1)%RotVal(1:3,WhichModel,ji) 
               xopti_2mon(n_index+4:n_index+6) = 
     *                finsolcan(j1)%TraVal(1:3,WhichModel,ji)
            enddo
            xopti_2mon(n_start:n_fin) = xopti(1:6) 

            call UpdateSol2(xopti_2mon,corre,j1)
c            write(6,*)'xopti',xopti(1:6),corre
            fopti = corre
            single = .false.
            call LocalMin(xopti,fopti,single)

c
c--posiziono il modello in funzione dei nuovi parametri 
c
            tet1 = xopti(1)
            tet2 = xopti(2)
            tet3 = xopti(3)
            call RotationOper1(b,tet1,tet2,tet3)

            do i=1,3
               do j=1,3
                  btra(i,j) = b(j,i)
               enddo
            enddo
c!
            do i = 1, natsMR
               x1(1:3) = model(WhichModel)%saved(1:3,i,jj)
               call MoltMatVec(rm, x1, x2)
               call MoltMatVec(btra, x2, x1)
               call MoltMatVec(rmi, x1, x2)
               model(WhichModel)%atoms(1:3,i,jj) = x2(1:3)
               if (ifRotOnly == 0) then      
                  icont=3
                  do ji=1,3
                     icont=icont+1
                     model(WhichModel)%atoms(ji,i,jj) = 
     *                          model(WhichModel)%atoms(ji,i,jj)
     *                          + xopti(icont)
                  enddo
               endif
            enddo
            badd = 0.0
            call ChemInfo_MR_Local(badd)
            call NewInv_MR_Local()
c
            call cc_vet_mol(corre)
            xopti_2mon(n_start:n_fin) = xopti(1:6)
            call UpdateSol2(xopti_2mon,corre,j1)
c            write(6,*) 'parametri del 2 mon indip', corre, erore!,
c!     *               BestRotaz*rtod, BestShift

            fopti = corre
            plusModel=.false.
            call LocalMin_2mon(xopti_2mon,fopti)!rocco
            call DoSingleIteration()
            call UpdateSol2(xopti_2mon,fopti,j1)
         enddo
      enddo
!
      return
      end
!------------------------------------------------------------------------------
      subroutine MRInfo(iCode)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Finale
      USE Riflessi
      USE Solutions
      USE riflessi_c
      USE RuotaRiflessi
      USE TraslaSolution
      USE Html
      USE Param
      USE RemoModule
      USE PhaseModule
      USE Align
!
      integer dove, WM
      real    :: CorrErrPack(100,4)
      common /perMRinfo/ CorrErrPack
      character *255  filename
      character stringa*20
      logical Esiste,plusModel
      logical :: riduci
      common/util2/noWrite,ncount,maxcount,plusModel
!
      k = index(fname(1),'.bin')
      if (iCode >= 0) then
          filename = fname(1)(1:k-1) // '.log'
      end if
      kk = kStripTask1(k)
      k = kk

      if (iCode <= 0) then

          if (iCode == 0) then
              ierr = 0
              istat = 0
              iform = 1
              jop=jopen(ktml,filename,istat,iform,ierr)
          end if
!
          Msg = 'Molecular Replacement Procedure'
          call HTML_header(ktml,' ',Msg)

          write(ktml,29)
          write(ktml,*) '<u><b>Protein structure description</b></u> '
          write(ktml,31)

          write(ktml,200)
          write(ktml,210) (cell(i),i=1,3)
          write(ktml,220) (cell(i),i=4,6)
          write(ktml,230) 

          call WriteSymmInfo(ktml)
    
          write(ktml,230)

          write(ktml,610)
          if (neutro == 0) then
              write(ktml,619)
          else
              write(ktml,620)
          endif
          do i=1,nk
             if (neutro == 0) then
                 write(ktml,640) nomeat(i), Species(i), nw(i), 
     *                            no(i), radii(i,1)
             else
                 write(ktml,640) nomeat(i), Species(i), nw(i), 
     *                            no(i), radii(i,1), zeff(i)
             endif
          enddo
          if (neutro == 1) then
              write(ktml,621)
          elseif (neutro == 2) then
              write(ktml,622)
          endif

          write(ktml,230)
          write(ktml,9050) nrefl

          k1 = index(fname(1), '.bin') - 1
          Inte = fname(1)(1:k1) // '_Wilson.png'
          inquire (file=Inte,  exist = Esiste)
          if (Esiste) then
              write(ktml,675) Inte(1:Lung(Inte))
          endif

          write(ktml,230)
          write(ktml,680) bt
          write(ktml,230)
!               
      else
!
!-- scrive sul file di log in append mode
!
          open(unit=ktml, file=filename, iostat=ier,  err=8000,
     1         status='old', form='formatted', position='append')

          if (iCode==10) then
!
!--percentuale di solvente della proteina
!
              write(ktml,*) ' '
              v_m=costanteMatthews/v_p
              write(ktml,24) v_s, v_m
              write(ktml,*) ' '
          elseif (iCode == 11) then
!
!--informazioni sul file PDB del modello
!
              write(ktml,30)
              write(ktml,*) '<u><b>MODEL STRUCTURE DESCRIPTION</b></u>'
              write(ktml,31)
              if (numbModels == 1) then
                  write(ktml,"(' Model structure file:',/,2x,a)") 
     *                      ReflFileName(1:lung(ReflFileName))
              else
                  write(ktml,"(' Model structure files:')") 
                  do i=1, numbModels
                     ReflFileName = card(ncardMax - i + 1)
                     write(ktml,"(2x,'#',i2,2x,a)") WhichModel,
     *                      ReflFileName(1:lung(ReflFileName))
                  enddo
              endif
              write(ktml,"(' ')")
              Msg = ' '
              k = 0
              if (ifAla == 1) then
                  Msg = '  Transformed in polyalanine'
                  k = Lung(Msg)
              endif
              if (ifCutResidui == 1) then
                  write(stringa,"(i5,'-',i5)") MinResiduo, MaxResiduo
                  call NoBlanks(stringa, lstringa)
                  if (k == 0) then
                      Msg = '  Used residues ' // stringa(1:lstringa)
                  else
                      Msg(k+1:) = ';  used only residues ' // 
     *                            stringa(1:lstringa)
                  endif
                  k = Lung(Msg)
              endif
              if (k > 0) then
                  write(ktml,'(a,/)') Msg(1:k)
              endif
              write(ktml,200)
              write(ktml,210) (cell(i),i=1,3)
              write(ktml,220) (cell(i),i=4,6)
    
              write(ktml,230)

              write(ktml,610)
              if (neutro == 0) then
                  write(ktml,619)
              else
                  write(ktml,620)
              endif

              do i=1,nk
                 call ucase(Species(i)(1:1))
                 if (neutro == 0) then
                     write(ktml,640) nomeat(i), Species(i), nw(i),
     *                                no(i), radii(i,1)
                 else
                     write(ktml,640) nomeat(i), Species(i), nw(i),
     *                                no(i), radii(i,1), zeff(i)
                 endif
              enddo
!
!--controllo sulla percentuale di solvente del modello
!
              if (ksize > 3) then
                  write(ktml,230) 
                  v_m=costanteMatthews/v_p
                  write(ktml,25)  v_s,v_m
!--warning sul numero di monomeri
                  if (v_s > 0.75) then
                      write(ktml,21)  v_s
!                     nMolMRsugg=nint(0.5*nMolMR/v_p)
                      nMolMRsugg=nint(nMolMR*(1.0-0.75)/v_p)
                      if (nMolMRsugg > nMolMR) write(ktml,23)nMolMRsugg
                  elseif (v_s < 0.3) then
                      write(ktml,22)  v_s
!                     nMolMRsugg=nint(0.5*nMolMR/v_p)
                      nMolMRsugg=nint(nMolMR*(1.0-0.30)/v_p)
                      if (nMolMRsugg < nMolMR)write(ktml,23) nMolMRsugg
                  endif
                  write(ktml,230) 
              endif
!
          elseif (iCode == 12) then
              if (HTMLstr(1:1) /= '#') then
                  k1 = index(HTMLstr, 'because')
                  k2 = Lung(HTMLstr)
                  if (k1*k2 > 0 .and. k1 < k2) then
                      write(ktml,36) HTMLstr(1:k1-1)
                      write(ktml,36) HTMLstr(k1:k2)
                  endif
              endif
          elseif (iCode == 13) then
              write(ktml,*)
              write(ktml,306) nMolMR
              write(ktml,*)
              write(ktml,301) nseqTotTarget   !nseq1
              write(ktml,302) nseqTotModel    !nseq2
              write(ktml,303) L_ali
              write(ktml,304) L_id
              SeqIId = float(L_id)/(nseq2+0.00000001)
              write(ktml,305) SeqIId
              write(ktml,*)
          elseif (iCode == 1) then
!
              write(ktml,30)
              write(ktml,230)
              ReflFileName = card(ncardMax - WhichModel + 1)
              L = Lung(ReflFileName)
              write(ktml,38) WhichModel, ReflFileName(1:L)

              rapp=nats/anatSav
              rapp1=rapp/(float(nsym)*float(nMolMR))
              write(ktml,230)
              write(ktml,40) natsModel, int(anatSav)
              write(ktml,42) rapp, rapp1
              write(ktml,43) distmaxPDB, resol1, resol2

          elseif (iCode == 2) then
!
!--informazioni sul rotation stage 
!
              write(ktml,30)
              if (numbModels == 1) then
                  Msg = '<u><b>Rotation stage</b></u>'
              else
                  write(Msg,5) WhichModel
              endif
              write(ktml,'(a)') Msg(1:Lung(Msg))
              write(ktml,31)
              write(ktml,10) nreflSelRot, nreflSelTra, solnum,
     *                        nSolToExplore

          elseif (iCode == 22) then

              write(ktml,30)
              Msg = '<u><b>Clustering and optimization '
     *           // 'for the rotation stage</b></u>'
              write(ktml,'(a)') Msg(1:Lung(Msg))
              write(ktml,31)

          elseif (iCode == 3) then
!
!--informazioni sul translation stage 
!
              write(ktml,30)
              if (numbModels == 1) then
                  Msg = '<b><u>Translation stage</u>: list of the most 
     * reliable rotation-translation combinations</b>'
              else
                  write(Msg,6) WhichModel, WhichMonomer
              endif
              write(ktml,'(a)') Msg(1:Lung(Msg))
              write(ktml,31)
              if (knw == 0) then
                  write(ktml,12)
              else
                  write(ktml,13)
              endif
              do j=1,nSolToExplore
                 i=TraAll(j)%ipunt
!
!--calcolo gli angoli sferici
!
                 tet1=TraAll(i)%RotVal(1)
                 tet2=TraAll(i)%RotVal(2)
                 tet3=TraAll(i)%RotVal(3)
                 if (knw == 0) then
                     write(ktml,'(i8,3f6.1,3f8.3,2f8.3,f8.3)')
     &               TraAll(i)%trial,      TraAll(i)%RotVal(1:3)*rtod,
     &               TraAll(i)%TraVal(1:3),TraAll(i)%RotFom,
     &               TraAll(i)%TraFom
                 else
                     write(ktml,'(i8,3f6.1,3f8.3,2f8.3,f8.2)')
     &               TraAll(i)%trial,      TraAll(i)%RotVal(1:3)*rtod,
     &               TraAll(i)%TraVal(1:3),TraAll(i)%RotFom,
     &               TraAll(i)%TraFom,     TraAll(i)%MolMPE
                 endif
              enddo
c
          elseif (iCode == 4) then
c
c--informazioni sul optimization stage 
c
              write(ktml,30)
              write(ktml,*) '<b><u>Optimization stage</u>: monomer
     * position refinement</b>'
              write(ktml,31)
              if (knw == 0) then
                  write(ktml,12)
              else
                  write(ktml,13)
              endif
              do j=1,nSolToExplore
                 i = iwork4(j)
!
!--calcolo gli angoli sferici
!
                 tet1=TraAll(i)%RotVal(1)
                 tet2=TraAll(i)%RotVal(2)
                 tet3=TraAll(i)%RotVal(3)
                 if (knw == 0) then
                     write(ktml,'(i8,3f6.1,3f8.3,2f8.3,f8.3)')
     &               TraAll(i)%trial,      TraAll(i)%RotVal(1:3)*rtod,
     &               TraAll(i)%TraVal(1:3),TraAll(i)%RotFom,
     &               TraAll(i)%LocFom
                 else
                     write(ktml,'(i8,3f6.1,3f8.3,2f8.3,f8.2)')
     &               TraAll(i)%trial,      TraAll(i)%RotVal(1:3)*rtod,
     &               TraAll(i)%TraVal(1:3),TraAll(i)%RotFom,
     &               TraAll(i)%LocFom,     TraAll(i)%MolMPE
                 endif
              enddo
c
          elseif (iCode == 5) then
!
!--informazioni sul NCS stage 
!
              write(ktml,30)
              if (.not. use_pseudo) then
                  nMolMax = maxval(MonomerInModel(1:numbModels))
                  if (nMolMax > 1) then
                      write(ktml,*) 
     *                   '<b><u>NCS stage</u>: accepted solution(s)</b>'
                  else
                      write(ktml,*) 
     *                   '<b>Accepted solution(s)</b>'
                  endif
              else
                  write(ktml,*) '<b><u>PseudoTraslational stage </u>:'//
     *                          'solution refined</b>'
              endif
              write(ktml,31)
              if (knw == 1) then
                  if (.not. plusModel) then
                      write(ktml,47)
                  else
                      write(ktml,48)
                  endif
              else
                  if (.not. plusModel) then
                      write(ktml,45)
                  else
                      write(ktml,46)
                  endif
              endif


              do jj=1, nFinalSolution
                 j = iwork2(jj) ! puntatore con l'ordine delle soluzioni
                 correj = finsolcan(j)%Fom
                 errorj = finsolcan(j)%MPE
                 correMappaj = CorrErrPack(jj, 1)
                 erorej      = CorrErrPack(jj, 2)
                 errej       = CorrErrPack(jj, 3)
                 packRemoj   = CorrErrPack(jj, 4)
                 pckRm = packRemoj
                 if (packRemoj < 0.1) pckRm = 0.1
                 correjj = correj / (pckRm**0.333)
                 kFirst = 1
                 do j1=1, numbModels 
                    do j2=1, MonomerInModel(j1)
                       if (finsolcan(j)%flag(j1,j2) == -1) then
                          write(ktml,52) j1, j2
                       else 
                          if (kFirst == 1) then 
                              kFirst = 0 
                              if (knw == 1) then
                                  write(ktml,49) j, 
     *                            finsolcan(j)%flag(j1,j2),
     *                            correjj,errorj,correMappaj,erorej,
     *                            finsolcan(j)%RotVal(1:3,j1,j2)*rtod,
     *                            finsolcan(j)%TraVal(1:3,j1,j2),
     *                            packRemoj,correj
                              else
                                  write(ktml,50) j, 
     *                            finsolcan(j)%flag(j1,j2),
     *                            correjj,errej*100.0,
     *                            finsolcan(j)%RotVal(1:3,j1,j2)*rtod,
     *                            finsolcan(j)%TraVal(1:3,j1,j2),
     *                            packRemoj,correj
                              end if
                          else 
                              if (knw == 1) then
                                  write(ktml,51)
     *                            finsolcan(j)%flag(j1,j2),
     *                            finsolcan(j)%RotVal(1:3,j1,j2)*rtod,
     *                            finsolcan(j)%TraVal(1:3,j1,j2)
                              else
                                  write(ktml,511)
     *                            finsolcan(j)%flag(j1,j2),
     *                            finsolcan(j)%RotVal(1:3,j1,j2)*rtod,
     *                            finsolcan(j)%TraVal(1:3,j1,j2)
                              endif
                          endif
                       endif
                    enddo
                 enddo
              enddo

          elseif (iCode == 6) then

              write(ktml,30)

          elseif (iCode == 51) then

              if (ifImproveMR == 0) then
                  write(ktml,30)
                  write(ktml,60)
                  if (nSolToExplore == 1) then
                      stringa = '1'
                      k1 = 1
                  else
                      write(stringa,16) nSolToExplore
                      call NoBlanks(stringa,k1)
                  endif
                  k = index(fname(1),'.bin')
                  k2 = kStripTask1(k)
    
                  cardDiret = fname(1)(1:k2-1)//'_remo'// '.mtz'
                  k3 = Lung(cardDiret)
                  Msg = cardDiret(1:k3)
                  k3 = Lung(Msg) + 1
!
                  cardDiret = fname(1)(1:k2-1) // '_remo_' //
     *                        stringa(1:k1) //'.pdb'
                  k2 = Lung(cardDiret)
                  Msg(k3:) = '          ' // cardDiret(1:k2)
                  write(ktml,'(a)') Msg(1:Lung(Msg))
              endif
         

              do j1=1,nSolToExplore
                 do WM=1, numbModels
                    icont=0
                    nMolMR = MonomerInModel(WM)
                    do j=1, nMolMR
                       kk = finsolcan(j1)%flag(WM,j)
                       if (kk == -1) icont=icont+1
                    enddo
                    if (icont > 0)  then
                        write(Inte,103) nMolMR-icont,nMolMR
                        call OneBlankOnly(Inte)
                        write(ktml,'(a)') Inte(1:Lung(Inte))
                    endif
                 enddo
              enddo

              write(ktml,230)
              write(Inte,'(i10)') WhichBestSolution
              call NoBlanks(Inte, k1)
              fomBestC = finsolcan(WhichBestSolution)%Corr
!
          elseif (iCode == 8) then
!
              write(Msg,7) WhichModel
              write(ktml,'(/,a,/)') Msg(1:Lung(Msg))
              ipr = 2
              dove = ktml
              call StampaFinalSolution(dove, ipr, riduci)
              write(ktml,'(a)') ' '
!
          elseif (iCode == 98) then

              write(ktml,900) HTMLstr(1:Lung(HTMLstr))

          elseif (iCode == 99) then

              write(ktml,'(a)') HTMLstr

          endif

      endif

      close(ktml)

    5 format('<u><b>Rotation stage, model #',i3,'</b></u>')
    6 format('<u><b>Translation stage, model #',i3, 
     *       ', monomer #',i3,'</b></u>')
    7 format('<u><b>Positioning model #',i3,'</b></u>')
   10 format(' Number of  reflections selected for rotation stage   :',
     *       i6,/,
     *       ' Number of  reflections selected for translation stage:',
     *       i6,/,
     *       ' Total rotation performed: ',i10,', ',i8,' selected',/)
*  11 format(8x,
*    *       '<b>   Trial       RFom           RotVal        Chi</b>')
* 111 format(8x,
*    *       '<b>   Trial       RFom           RotVal </b>       ') 
   12 format('<b>   Trial   Rotation values     Translation values', 
     *       '     RFom    TFom</b>')
   13 format('<b>   Trial   Rotation values     Translation values', 
     *       '     RFom    TFom    MPE</b>')
   16 format('[1-',i5,']')
   20 format(2i8,' ',f10.3,3x,3f6.1,f8.2)
c  20 format(2i8,' ',6f9.3,3x,3f6.1,f8.2)
  201 format(2i8,' ',f10.3,3x,3f6.1)
   21 format(' Warning: solvent content too high: ',f5.2)
   22 format(' Warning: solvent content too low:  ',f5.2)
   23 format(' Suggested number of model molecules ',i4)
   24 format(' Protein: solvent ',f5.2,', Matthews coefficient ',f5.2)
   25 format(' Model: solvent ',f5.2,', Matthews coefficient ',f5.2)
   29 format('<font size="2" ',
     *       'style="font-family: courier new,courier,monospace;">')
   30 format(' <hr color="#000080" size="1">')
   31 format(' ')
   35 format('<font color="#FF0000"><b>',
     *       'Best solution: #',a,', Corr = ',f6.3,' R% = ',f5.2,
     *       ' Clashes% = ',f6.2,'</b></font>')
   36 format('<font color="#FF0000"><b>',' ',a,'</b></font>')
   38 format('<u><b>Model #',i3,' ',a,'</b></u>')
   40 format(' Number of atoms of the model structure      ',i5,/,
     *       ' Number of atoms of the protein structure    ',i5)
   41 format(' Number of selected solutions after clustering',i5)
   42 format(' Ratio (atoms of model) / (atoms of protein) ',f5.2,/,
     *       ' Coefficient of difficulty                   ',f5.2)
   43 format(' Maximum distance among atoms of the model molecule',
     *        f8.2,/,' Resolution range ',2f10.2)

   45 format('<b> Sol.  Trial    TFom      R%',3x,'Rotation values   ',
     *       'Traslation values    Clashes%   NTFom <b>')
   46 format('<b> Sol.  Trial    NFom      R%',3x,'Rotation values   ',
     *       'Traslation values    Clashes% <b>')
   47 format('<b> Sol.  Trial    TFom ',4x,'MPE',3x,'CorrMap',3x,'MPE',
     *       3x,'Rotation values   Traslation values    Clashes%   ',
     *       'NTFom <b>')
   48 format('<b> Sol.  Trial    TFom ',4x,'MPE',3x,'CorrMap',3x,'MPE',
     *       3x,'Rotation values   Traslation values    Clashes% <b>')

   49 format(i5,i7,f9.3,f8.2,f8.3,f8.2,3f6.1,3f7.3,3x,f6.2,f9.3)
   50 format(i5,i7,f9.3,f8.2,3f6.1,3f7.3,3x,f6.2,f9.3)


   51 format(5x,i7,32x,3f6.1,3f7.3)
  511 format(5x,i7,16x,3f6.1,3f7.3) 
   52 format(' -----   Model',i4,', monomer',i4,' not found')
   60 format(/,'<u><b>Files produced at the end of this run:</b></u>',//
     *        ,'MTZ format',15x,'PDB format')
  103 format('         Warning: solution with',i4,'/ ',i4,' monomers')
  200 format(' Cell Parameters:',/)
  210 format('     a = ',f9.3,'     b = ',f9.3,'     c = ',f9.3)
  220 format(' alpha = ',f9.3,'  beta = ',f9.3,' gamma = ',f9.3)
  230 format(' ')
  240 format(a)
  301 format('Length of sequence (target): ',I4)
  302 format('Length of sequence (model) : ',I4)
  303 format('Aligned length: ',I4)
  304 format('Identical length: ',I4)
  305 format('Sequence identity: ',F8.3)
  306 format(i2,' molecules will be searched ')
  610 format(' Unit cell content:',/)
  619 format(4x,'Atom',6x,'Symbol',3x,'Number in cell',3x,
     *             'Atomic number',3x,'Radius')
  620 format(4x,'Atom',6x,'Symbol',3x,'Number in cell',3x,
     *             'Atomic number',3x,'Radius',3x,'  f  ')
  621 format(/,' Neutron diffraction data',/)
  622 format(/,' Electron diffraction data',/)
  640 format(2x,a12,2x,a4,i11,i16,5x,2f9.3)
  675 format('<img border="0" src="',a,'">')
  680 format(' Wilson Thermal Factor B(iso) = ',f7.3)
  900 format('<font size="4" style="font-family: ',
     *       'times new roman,times,serif;" color="#FF0000"><b>',
     *       a,'</b></font>')
 9050 format(' Input reflections:',i8)
 9052 format('          selected:',i8)
!
      return
 8000 write(Msg,8100) ier
      call MsgWinErr('ERROR', Msg, SEVERE_ERR_WINDOW, nExitCode)
 8100 format(' *** open error MRInfo ***  code =',i5)
      return
      end
!----------------------------------------------------------------------
      subroutine storeGraphInfo(npunti)
      USE Grafici
!
      real,       allocatable :: Sxpoints(:,:)
      real,       allocatable :: Sypoints(:,:)
      integer,    allocatable :: ScolorGR(:,:)
      real,       allocatable :: SMinMaxGR(:,:)
      integer,    allocatable :: SlPlots(:)
      integer                 :: SHistoOK(3) 
!
        idimx = size(xpoints,1)
        idimy = size(xpoints,2)
        if (idimx > npunti) return
!
        idimxx = max(idimx,npunti)
        allocate(Sxpoints(1:idimxx,1:idimy), stat = ierv)
        allocate(Sypoints(1:idimxx,1:idimy), stat = ierv)
        allocate(ScolorGR(1:idimxx,1:idimy), stat = ierv)
        allocate(SMinMaxGR(1:4,1:idimy), stat = ierv)
        allocate(SlPlots(1:idimy), stat = ierv)
!     
        Sxpoints(:,:)  = 0.0
        Sypoints(:,:)  = 0.0
        ScolorGR(:,:)  = 0.0
        SMinMaxGR(:,:) = 0.0
        SlPlots(:)     = 0.0
!
        Sxpoints(1:idimx,1:idimy) = xpoints(1:idimx,1:idimy)
        Sypoints(1:idimx,1:idimy) = ypoints(1:idimx,1:idimy)
        ScolorGR(1:idimx,1:idimy) = colorGR(1:idimx,1:idimy)
        SMinMaxGR(1:4,1:idimy) = MinMaxGR(1:4,1:idimy)
        SlPlots(1:idimy) = lPlots(1:idimy)
        SHistoOK(1:3) = HistoOK(1:3)
 
        call AllocaGrafici(2,0,0)
        call AllocaGrafici(1,npunti,0)

        idimx = size(Sxpoints,1)
        idimy = size(Sxpoints,2)
        xpoints(1:idimx,1:idimy) = Sxpoints(1:idimx,1:idimy)
        ypoints(1:idimx,1:idimy) = Sypoints(1:idimx,1:idimy)
        colorGR(1:idimx,1:idimy) = ScolorGR(1:idimx,1:idimy)
        MinMaxGR(1:4,1:idimy) = SMinMaxGR(1:4,1:idimy)
        lPlots(1:idimy) = SlPlots(1:idimy)
        HistoOK(1:3) = SHistoOK(1:3)
!
        deallocate(Sxpoints, Sypoints, SlPlots, ScolorGR, SMinMaxGR,
     *      stat = ierr)
!
      return
      end
!----------------------------------------------------------------------
!============ routines per la modifica del modello prima del MR =======
!----------------------------------------------------------------------
      subroutine ModifyModel()
      USE General
      USE Symmetry
      USE Riflessi
      USE riflessi_c
      USE Mappa
      USE PhaseModule
      USE RemoModule
      USE ModModel
      USE Molcom
!
!--modifico il modello utilizzando la funzione Patterson
!
      common /misc/ ttt(3,3), dxmax(3),ishift(3,19)
      common /util/radius,radius1
      dimension xs(3),xs1(3),b(19)
      dimension vet1(3),vet2(3)
      integer sidepp
!
      real, allocatable : : vetcont(:)
      integer, allocatable : : ivetcont(:)
!
      allocate (vetcont(1:50*nrefl),stat = ierv)
      allocate (ivetcont(1:50*nrefl),stat = ierv)
!
!  e definisco il puntatore dei carboni alpha alla struttura
!
      call AllocaMappa(1)
!
      eps=0.0001
!
!-- switch to the Patterson Space Group
!
      icent=1
      tmat(:,:)=0.
      call musym()
      nsymTot=nsym*(icent+1)*pts
!
!--faccio la mappa Patterson
!
      wt(:) = 0.0
      do i=1,nrefl
         wt(i) = 1
         fcoef(i) = evet(i) * evet(i) - 1.0
      enddo
      fcoef(:) = fcoef(:) * wt(:)
      jpatt = 1
      call MakeMap(fcoef, iphaz, nrefl, jpatt, xmap,
     *                FORTH, BACK)
      xenve=xmap
!
!--deb
!
c     do ix=0,np(1)-1
c     do iy=0,np(2)-1
c     do iz=0,np(3)-1
c       write(65,*) ix,iy,iz,xmap(ix,iy,iz)
c     enddo
c     enddo
c     enddo
!
!--definisco i parametri per la ricerca nella Patterson
!
      deltx=np(1)/cell(1)
      delty=np(2)/cell(2)
      deltz=np(3)/cell(3)
      ca=cos(cell(4)*dtor)
      cb=cos(cell(5)*dtor)
      cg=cos(cell(6)*dtor)
      tol=1.0/min(deltx,delty,deltz)
      tol1=0.01  ! in scala normalizzata
c     alimmin=3.0 
      alimmin=5.0 
!
!--il raggio di integrazione e' radius1
!
      write(6,'(a,3f8.2)') 'MODIFY',alimmin,radius1,tol
!
!--calcolo la matrice delle distanze
!
      distMatrixPatt(:,:)=0.0
      acontTot=0.0
      PatDistTot=0.0
      PatDistModelTot=0.0
      PatDistDiff=0.0
c     do ipunt1=1,nca-1
      do ipunt1=1,1
        do ipunt2=ipunt1+1,nca
!
!--prendo la distanza tra due carboni alpha
!
           PatDistModel=distMatrixModel(ipunt1,ipunt2)
c          if(PatDistModel<=eps) cycle 
           alim = distMatrix(ipunt1,ipunt2)
           if(alim>alimmin.and.alim<radius1) then ! va bene il taglio >10
!
!--cerco cosa c'e' nella mappa Patterson
!
             icont=0
             xmax=0.0
             xmin=9999999.0
c
c--coordinate sferiche
c
             step_rho=0.5*tol
             rho=alim-tol
             do while (rho<=alim+tol)
               rho=rho+step_rho
               if (rho > alim+tol-eps) exit
               phi=0.0
               step_phi=0.8*1./(deltz*rho)
               do while (phi<=Pi)
                 phi=phi+step_phi
                 if (phi > Pi-eps) exit
                 tet=0.0
                 step_tet=0.8*sqrt((1./deltx)**2+(1./delty)**2)
     &                    /(sin(phi)*rho)
                 ciclo: do while (tet<=TwoPi)
                   tet=tet+step_tet
                   if (tet > TwoPi-eps) exit
                   vet1(1)=rho*sin(phi)*cos(tet)
                   vet1(2)=rho*sin(phi)*sin(tet)
                   vet1(3)=rho*cos(phi)
                   call MoltMatVec(rmi,vet1,vet2)
                   ax=side(vet2(1))
                   ay=side(vet2(2))
                   az=side(vet2(3))
!--trasformo da coordinate ortogonali a coordinate cristallografiche
                   ix=nint(ax*np(1))
                   iy=nint(ay*np(2))
                   iz=nint(az*np(3))
                   ih = sidepp(ix, np(1))
                   ik = sidepp(iy, np(2))
                   il = sidepp(iz, np(3))
c
                   xx=xenve(ih,ik,il)
                   if(xx<=0.0) cycle 
!
!--cerco i picchi nella corona circolare
!
c                  do i=1,6
c                     ih1=sidepp(ih+ishift(1,i),np(1))
c                     ik1=sidepp(ik+ishift(2,i),np(2))
c                     il1=sidepp(il+ishift(3,i),np(3))
c                     b(i)=enve(ih1,ik1,il1)
c                     if(xx < b(i) ) then
c                       cycle ciclo
c                     endif
c                  enddo
                   b(10)=xx
                   do i=1,19
                      if(i==10) cycle
                      ih1=sidepp(ih+ishift(1,i),np(1))
                      ik1=sidepp(ik+ishift(2,i),np(2))
                      il1=sidepp(il+ishift(3,i),np(3))
                      b(i)=xenve(ih1,ik1,il1)
                      if(b(10) < b(i) ) then
                        cycle ciclo
                      endif
                   enddo
!
                   icont=icont+1
                   vetcont(icont)=xx
                   if(xx>xmax) xmax=xx
                   if(xx<xmin) xmin=xx
!
!--riempio lo Shell
!
                   Shell(ipunt2-1,icont,1)=xx
                   Shell(ipunt2-1,icont,2)=tet 
                   Shell(ipunt2-1,icont,3)=phi
!--deb
c                  if(acontTot==10) then
c                    h1=MatrixModel(ipunt2-1,1)
c                    Tet1=MatrixModel(ipunt2-1,2)
c                    Phi1=MatrixModel(ipunt2-1,3)
c                    write(6,'(8f10.3)') tet,phi,xx,
c    &                                    Tet1,Phi1,h1,rho,alim
c                  endif
                 enddo ciclo
               enddo
             enddo
!
!--rinormalizzo le intensita' dei picchi nello Shell
!
            ShellCont(ipunt2-1)=icont
            if(icont>0) then
              if(abs(xmin-xmax)>eps) then
                do ip=1,icont
                  xxmax=Shell(ipunt2-1,ip,1)
                  rho=(xxmax-xmin)/(xmax-xmin)
                  Shell(ipunt2-1,ip,1)=rho
               enddo
              else
               do ip=1,icont
                  Shell(ipunt2-1,ip,1)=1.0
               enddo
              endif
            endif
!
               goto 30
!
!--seleziono i picchi in base all'altezza
!
            ies=0
            if(icont>0.and.abs(xmin-xmax)>0.1) then
             if(icont>1) then
c              iuno = +1 ! prendo il minimo delle altezze
               iuno = -1 ! prendo il massimo delle altezze
               call sortall3(iuno,vetcont,iuno,icont,ivetcont) ! ordina anche vetcont
             endif
             k=1
             do while(k<=icont)
               xxmax=vetcont(k)
               lcont=1
               do j=k+1,icont
                 xx=vetcont(j)
                 if(abs(xx-xxmax)<0.5) then
                   lcont=lcont+1
                 endif
               enddo
               write(6,'(a,f8.2,i8,2f8.2)') 'red',alim,lcont,
     &                           xmax,xxmax
!
!--scelgo il massimo valore con giusta molteplicita'
!  no, perche' posso prendere piu' volte lo stesso pixel
!
c              if(lcont==nsymTot) then
                 rho=(xxmax-xmin)/(xmax-xmin)
                 if(abs(rho-PatDistModel)<tol1) then
                   ies=1
                   exit
                 endif
c              endif
               k=k+lcont
             enddo
            endif
            if(ies==0) then
              rho=0.0
            else
              write(6,'(a,2i8,5f8.2)') 'ecco',
     &            icont,lcont,alim,xmin,xmax,rho,PatDistModel
            endif
            PatDist=rho
!
!--riempio la matrice delle "distanze Patterson"
!
             distMatrixPatt(ipunt1,ipunt2)=PatDist
             distMatrixPatt(ipunt2,ipunt1)=PatDist
!
!--riprendo la matrice delle "distanze Patterson" del modello
!
            PatDistModel=distMatrixModel(ipunt1,ipunt2)
!
!--calcolo le variabili globali
!
             PatDistTot=PatDistTot+PatDist
             PatDistModelTot=PatDistModelTot+PatDistModel
             PatDistDiff=PatDistDiff+(PatDist-PatDistModel)
   30        continue
             acontTot=acontTot+1
!
           endif ! endif sulla sfera della Patterson
        enddo ! enddo sulle coppie di atomi del modello
      enddo
!
         goto 31
      if(acontTot>0.0) then
        PatDistDiff=PatDistDiff/PatDistTot
        PatDistTot=PatDistTot/acontTot
        PatDistModelTot=PatDistModelTot/acontTot
        adif=(PatDistTot-PatDistModelTot)/PatDistTot
      else
        PatDistTot=0.0
        PatDistModelTot=0.0
        PatDistDiff=0.0
        adif=0.0
      endif
      write(6,'(a,2f8.2,2f8.3)') 'average difference Pat-Model'
     &              ,PatDistTot,PatDistModelTot,adif,PatDistDiff
!
!--stampo le matrici e calcolo la correlazione tra le due matrici
!
      corrx=0.0
      corrxx=0.0
      corry=0.0
      corryy=0.0
      corrxy=0.0
      acont=0.0
      corrx1=0.0
      corrxx1=0.0
      corry1=0.0
      corryy1=0.0
      corrxy1=0.0
      acont1=0.0
      do j1=1,nca
       do j2=1,nca
          x=distMatrixModel(j1,j2)
          y=distMatrixPatt(j1,j2)
          xy=distMatrix(j1,j2)
          write(81,'(2i5,3f15.1)') j1,j2,x,y,xy
          if(x>0.0) then
            corrx=corrx+x
            corrxx=corrxx+x*x
            corry=corry+y
            corryy=corryy+y*y
            corrxy=corrxy+x*y
            acont=acont+1.0
            if(y>0.0) then
              corrx1=corrx1+x
              corrxx1=corrxx1+x*x
              corry1=corry1+y
              corryy1=corryy1+y*y
              corrxy1=corrxy1+x*y
              acont1=acont1+1.0
            endif
          endif
        enddo
      enddo
      if(acont>2.and.acont1>0) then
        corrx=corrx/acont
        corry=corry/acont
        corrxy=corrxy/acont
        corrxx=corrxx/acont
        corryy=corryy/acont
        corrnum=corrxy - corrx*corry
        corrden=sqrt(corrxx-corrx*corrx)*sqrt(corryy-corry*corry)
        corre=corrnum/corrden
      else
        corre=0.0
      endif
      if(acont1>2) then
        corrx1=corrx1/acont1
        corry1=corry1/acont1
        corrxy1=corrxy1/acont1
        corrxx1=corrxx1/acont1
        corryy1=corryy1/acont1
        corrnum1=corrxy1 - corrx1*corry1
        corrden1=sqrt(corrxx1-corrx1*corrx1)*sqrt(corryy1-corry1*corry1)
        corre1=corrnum1/corrden1
      else
        corre1=0.0
      endif
      frac=acont1/acont
      write(6,'(a,2f10.0,f10.3)') 'non-zero fraction (Mod, Pat)',
     &                      0.5*acont,0.5*acont1,frac
      write(6,'(a,2f10.3)') 'Correlation between matrices',corre,corre1
      call corrMatrix(0.0,10.0,corre,acont,frac)
      write(6,'(a,3f10.3)') 'Correlation A',corre,acont,frac
      call corrMatrix(10.0,20.0,corre,acont,frac)
      write(6,'(a,3f10.3)') 'Correlation B',corre,acont,frac
      call corrMatrix(20.0,30.0,corre,acont,frac)
      write(6,'(a,3f10.3)') 'Correlation C',corre,acont,frac
      call corrMatrix(30.0,9999.0,corre,acont,frac)
      write(6,'(a,3f10.3)') 'Correlation D',corre,acont,frac
  31   continue
!
!--calcola la figura di merito per la struttura
!
      call CalcFigStruct()
!
!-- restore the original Space Group
!
      call RestoreSpaceGroup
!
      call AllocaMappa(2)
      call AllocaModModel(2)
      deallocate(vetcont,ivetcont, stat=ierr)
!
      return
      end
!------------------------------------------------------
      subroutine PreModifyModel(rmtt)
!
!  faccio la Patterson del modello in P-1
!  e constrisco la matrice delle distanze derivata dalla Patterson
!
      USE General
      USE Symmetry
      USE Riflessi
      USE riflessi_c
      USE Mappa
      USE PhaseModule
      USE RemoModule
      USE ModModel
      USE Molcom
!
!--modifico il modello utilizzando la funzione Patterson
!
!
      common /misc/ ttt(3,3), dxmax(3),ishift(3,19)
      common /util/radius,radius1
      integer  npSav(3)
      dimension xs(3),xs1(3),b(19)
      integer sidepp
!
      integer, allocatable : : ipuntCA(:)
      real, allocatable : : vetcont(:)
      integer, allocatable : : ivetcont(:)
      dimension vet1(3),vet2(3),rmtt(3,3)
      integer :: s,ivet2(3)
!
      allocate (vetcont(1:10*nrefl),stat = ierv)
      allocate (ivetcont(1:10*nrefl),stat = ierv)
!
      imodel=1
      imono=1
      eps=0.0001
!
!--shifts per peak search
!
      ishift(1:3,1) =(/ -1,  0, -1/)
      ishift(1:3,2) =(/  0, -1, -1/)
      ishift(1:3,3) =(/  0,  0, -1/)
      ishift(1:3,4) =(/  0,  1, -1/)
      ishift(1:3,5) =(/  1,  0, -1/)
      ishift(1:3,6) =(/ -1, -1,  0/)
      ishift(1:3,7) =(/ -1,  0,  0/)
      ishift(1:3,8) =(/ -1,  1,  0/)
      ishift(1:3,9) =(/  0, -1,  0/)
      ishift(1:3,10)=(/  0,  0,  0/)
      ishift(1:3,11)=(/  0,  1,  0/)
      ishift(1:3,12)=(/  1, -1,  0/)
      ishift(1:3,13)=(/  1,  0,  0/)
      ishift(1:3,14)=(/  1,  1,  0/)
      ishift(1:3,15)=(/ -1,  0, +1/)
      ishift(1:3,16)=(/  0, -1, +1/)
      ishift(1:3,17)=(/  0,  0, +1/)
      ishift(1:3,18)=(/  0,  1, +1/)
      ishift(1:3,19)=(/  1,  0, +1/)

c     ishift(1:3,1)=(/  0,  0, -1/)
c     ishift(1:3,2)=(/ -1,  0,  0/)
c     ishift(1:3,3)=(/  0, -1,  0/)
c     ishift(1:3,4)=(/  0,  1,  0/)
c     ishift(1:3,5)=(/  1,  0,  0/)
c     ishift(1:3,6)=(/  0,  0, +1/)
c     ishift(1:3,7)=(/  0,  0,  0/)
!
!--procedura per scartare i riflessi non misurati
!--annullo il contributo dei riflessi equivalenti a quelli mancanti
!
      fcvetc(:)=0.0
c
c----rmi =  matrice M trasposta (coincide con quella del PDB)
c
      rmi=rmtt
      do j=1,3
        do i=1,3
           rmtt(i,j)=rmi(j,i)*dimcell !matrice riscalata
        enddo
      enddo
c
      icont=0
      do k=1,nrefl
        do s = 1, nsymSav
          ivet2(1:3)=0
          do l = 1, 3
            do m=1,2
              m1=iabs(ismatSav(m,l,s))
              if (m1.gt.0) then
                 ivet2(m1)=ivet2(m1)+khl(l,k)*isign(1,ismatSav(m,l,s))
              endif
            enddo
          enddo
          vet2=ivet2
          call controllo_indici_interi(vet2,ivet2)
          vet1(1:3)=ivet2(1:3)
          call MoltMatVec(rmtt,vet1,vet2) !eseguo la moltiplicaz matrice vettore
          call controllo_indici_interi(vet2,ivet2)
!---costruisco il vettore superindice per gli osservati 
          indr = ivet2(1)*ifat1C + ivet2(2)*ifat2C + ivet2(3)
          if (indr <= ifatxC .and. indr > 0) then
            j = superind(indr)
            if (j > 0) then
              fcvetc(j)=1.0
              icont=icont+1
            endif
          endif
        enddo
      enddo
!
!--calcolo il numero di carboni alpha nel modello
!
      nca=0
      do j=1,natsInModel(imodel)
        if(model(imodel)%tipoatomo(j,imono)=="ca ") then
c       if(model(imodel)%tipoatomo(j,imono)=="ca ".or.
c    &     model(imodel)%tipoatomo(j,imono)=="cb  ") then
          nca=nca+1
        endif
      enddo
      write(6,*) 'NCA',nca
!
      allocate (ipuntCA(1:nca),    stat = ierv)
      call AllocaModModel(1)
!
!  e definisco il puntatore dei carboni alpha alla struttura
!
      nca=0
      do j=1,natsInModel(imodel)
        if(model(imodel)%tipoatomo(j,imono)=="ca ") then
c       if(model(imodel)%tipoatomo(j,imono)=="ca ".or.
c    &     model(imodel)%tipoatomo(j,imono)=="cb  ") then
          nca=nca+1
          ipuntCA(nca)=j
        endif
      enddo
!
      npSav(:)=np(:)
      write(6,*) 'NP prima',np
      call CheckGrid()
      write(6,*) 'NP dopo',np
      call AllocaMappa(2)
      call AllocaMappa(1)
!
!-- switch to the Patterson Space Group
!
      icent=1
      tmat(:,:)=0.
      call musym()
      nsymTot=nsym*(icent+1)*pts
!
!--faccio la mappa Patterson del modello
!
      fcvets(:)=0.0
      icont=0
      do i=1,nRifDimC
        if(fcvetc(i)>0.5) then
           fcvetc(i)=ecvetc(i)-1.0
           icont=icont+1
        endif
      enddo
      write(6,*) 'riduzione riflessi ',nRifDimC,icont,
     &                     icont/float(nRifDimC)
      call MakeMapMR(xmap, xmapC, FORTH, BACK, np, FFTW_ESTIMATE)
!
!--deb
!
c     do ix=0,np(1)-1
c     do iy=0,np(2)-1
c     do iz=0,np(3)-1
c       write(66,*) ix,iy,iz,xmap(ix,iy,iz)
c     enddo
c     enddo
c     enddo
c     stop
c
!--definisco i parametri per la ricerca nella Patterson
!
      deltx=np(1)/cell(1)
      delty=np(2)/cell(2)
      deltz=np(3)/cell(3)
      ca=cos(cell(4)*dtor)
      cb=cos(cell(5)*dtor)
      cg=cos(cell(6)*dtor)
c     tol=1.0/deltx  ! 1 pixel
c     tol1=2*tol
      tol=1.5/deltx  ! 1 pixel
      tol1=tol
c     alimmin=3.0 
      alimmin=5.0 
!
!--il raggio di integrazione e' radius1
!
      write(6,'(a,3f8.2)') 'MODIFY MOD',alimmin,radius1,tol
!
!--calcolo la matrice delle distanze
!
      distMatrix(:,:)=0.0
      distMatrixPatt(:,:)=0.0
      acontTot=0.0
      PatDistModelTot=0.0
c     do ipunt1=1,nca-1
      do ipunt1=1,1 ! occhio
        j1=ipuntCA(ipunt1)
        do ipunt2=ipunt1+1,nca
           j2=ipuntCA(ipunt2)
!
!--calcolo la distanza tra due carboni alpha
!
           dist = 0
           do k=1,3
             dist = dist + 
     *      (model(imodel)%ortho(k,j1,imono) - 
     *       model(imodel)%ortho(k,j2,imono)) ** 2
           end do
           xmodel=model(imodel)%ortho(1,j1,imono) - 
     *            model(imodel)%ortho(1,j2,imono)
           ymodel=model(imodel)%ortho(2,j1,imono) - 
     *            model(imodel)%ortho(2,j2,imono)
           zmodel=model(imodel)%ortho(3,j1,imono) - 
     *            model(imodel)%ortho(3,j2,imono)
           alim = sqrt(dist)
           if(alim>alimmin.and.alim<radius1) then ! va bene il taglio >10
!
!--riempio la matrice delle distanze del modello
!
             distMatrix(ipunt1,ipunt2)=alim
             distMatrix(ipunt2,ipunt1)=alim
!
!--conservo informazioni sugli angoli del vettore 
!
             TetMod=atan2(ymodel,xmodel)
             if(TetMod<0) TetMod=TetMod+TwoPi
             PhiMod=acos(zmodel/alim)
!
!--cerco cosa c'e' nella mappa Patterson
!
             icont=0
             ymax=0.0
             ymin=999999.0
c
c--coordinate sferiche
c
c            step_rho=0.5*tol
c            rho=alim-tol
c            do while (rho<=alim+tol)
c              rho=rho+step_rho
c              if (rho > alim+tol-eps) exit
               rho=alim
               phi=0.0 
               step_phi=0.8*1./(deltz*rho)
               do while (phi<=Pi)
                 phi=phi+step_phi
                 if (phi > Pi-eps) exit
                 tet=0.0 
                 step_tet=0.8*sqrt((1./deltx)**2+(1./delty)**2)
     &                    /(sin(phi)*rho)
                 ciclo: do while (tet<=TwoPi)
                   tet=tet+step_tet
                   if (tet > TwoPi-eps) exit
                   ax=rho*sin(phi)*cos(tet)
                   ay=rho*sin(phi)*sin(tet)
                   az=rho*cos(phi)
                   ix=nint(ax*deltx)
                   iy=nint(ay*delty)
                   iz=nint(az*deltz)
                   ih = sidepp(ix, np(1))
                   ik = sidepp(iy, np(2))
                   il = sidepp(iz, np(3))
c
                   yy=xmap(ih,ik,il)
                   if(yy<=0.0) cycle
!
!--cerco i picchi nella corona circolare
!
c                  do i=1,6
c                    ih1=sidepp(ih+ishift(1,i),np(1))
c                    ik1=sidepp(ik+ishift(2,i),np(2))
c                    il1=sidepp(il+ishift(3,i),np(3))
c                    b(i)=xmap(ih1,ik1,il1)
c                    if(yy < b(i) ) then
c                      cycle ciclo
c                     endif
c                  enddo
                   b(10)=yy
                   do i=1,19
                      if(i==10) cycle
                      ih1=sidepp(ih+ishift(1,i),np(1))
                      ik1=sidepp(ik+ishift(2,i),np(2))
                      il1=sidepp(il+ishift(3,i),np(3))
                      b(i)=xenve(ih1,ik1,il1)
                      if(b(10) < b(i) ) then
                        cycle ciclo
                      endif
                   enddo
! 
!--riempio le quantita' relative al modello
!
                   if(yy>ymax) ymax=yy
                   if(yy<ymin) ymin=yy
                   if(abs(ax-xmodel)<tol1.and.
     &                abs(ay-ymodel)<tol1.and.
     &                abs(az-zmodel)<tol1 ) then
                         icont=icont+1
                         vetcont(icont)=yy
                   endif
!--deb
c                  if(acontTot==10) then
c                    Tet1=rtod*atan2(ay,ax)
c                    Phi1=rtod*atan2(az,sqrt(ax*ax+ay*ay))
c                    write(80,*) Tet1,Phi1,yy
c                  endif
                 enddo  ciclo
               enddo
c            enddo
!
!--scelgo il picco piu' alto tra quelli nelle vicinanze del picco voluto
!  e calcolo l'altezza normalizzata
!
            if(icont>0.and.abs(ymin-ymax)>0.1) then
             if(icont>1) then
c              iuno = +1 ! prendo il minimo delle altezze
               iuno = -1 ! prendo il massimo delle altezze
               call sortall3(iuno,vetcont,iuno,icont,ivetcont) ! ordina anche vetcont
             endif
             yy=vetcont(1)
             rho=(yy-ymin)/(ymax-ymin)
             write(6,'(a,i8,5f8.2)') 'ecco',icont,alim,ymin,ymax,yy,rho
            else
             rho=0.0
            endif
!
!--riempio la matrice delle "distanze Patterson del modello"
!
             acontTot=acontTot+1
             PatDistModel=rho
             distMatrixModel(ipunt1,ipunt2)=PatDistModel
             distMatrixModel(ipunt2,ipunt1)=PatDistModel
!
!--riempio la struttura dei vincoli
!
             MatrixModel(ipunt2-1,1)=rho
             MatrixModel(ipunt2-1,2)=TetMod
             MatrixModel(ipunt2-1,3)=PhiMod
             MatrixModel(ipunt2-1,4)=alim
c            write(84,*) ipunt2,alim,TetMod*rtod,PhiMod*rtod,rho
!
           endif ! endif sulla sfera della Patterson
        enddo ! enddo sulle coppie di atomi del modello
      enddo
!
!-- restore the original Space Group
!
      call RestoreSpaceGroup
!
      call AllocaMappa(2)
      np(:)=npSav(:)
      deallocate(ipuntCA, stat=ierr)
      deallocate(vetcont,ivetcont, stat=ierr)
!
      return
      end
!-------------------------------------------------
      subroutine corrMatrix(tag1,tag2,corre,acont,frac)
      USE ModModel
!
      corrx=0.0
      corrxx=0.0
      corry=0.0
      corryy=0.0
      corrxy=0.0
      acont=0.0
      acont2=0.0
      do j1=1,nca
       do j2=1,nca
          x=distMatrixModel(j1,j2)
          y=distMatrixPatt(j1,j2)
          xy=distMatrix(j1,j2)
          if(x>0.0) then
          if(xy>tag1.and.xy<=tag2) then
            corrx=corrx+x
            corrxx=corrxx+x*x
            corry=corry+y
            corryy=corryy+y*y
            corrxy=corrxy+x*y
            acont=acont+1.0
            if(y>0.0) then
              acont2=acont2+1
            endif
          endif
          endif
        enddo
      enddo
      if(acont>0.0) then
        frac=acont2/acont
        if(acont>2.0.and.acont2>0.0) then
          corrx=corrx/acont
          corry=corry/acont
          corrxy=corrxy/acont
          corrxx=corrxx/acont
          corryy=corryy/acont
          corrnum=corrxy - corrx*corry
          corrden=sqrt(corrxx-corrx*corrx)*sqrt(corryy-corry*corry)
          corre=corrnum/corrden
        else
          corre=0.0
        endif
      else
        corre=0.0
        frac=0.0
      endif
c
      return
      end
!-------------------------------------------------------------
      subroutine CalcFigStruct()
      USE General
      USE ModModel
!
!--calcola la figura di merito per la data struttura
!
      eps=0.00001
      w1=0.8
      w1=0.0 ! occhio
      ipuntAll=0
!
!--cerco il primo shell riempito
!
      Nallineamenti=0
      j=0
      do while(Nallineamenti==0)
        j=j+1
        Nallineamenti=ShellCont(j)
        jfirst=j
      enddo
!
!--stampe di debug
!
      do i=1,nca-1
        write(6,*) 'shell',i,ShellCont(i),Matrixmodel(i,4)
      enddo
      write(6,*) 'Nallineamenti',jfirst,Nallineamenti
!
      distGenTotMin=9999999.
c     do n=1,Nallineamenti ! loop sugli allineamenti= numbero di hits del primo shell
      do n=1,Nallineamenti+1 ! loop sugli allineamenti= numbero di hits del primo shell
        shiftTet=MatrixModel(jfirst,2)-Shell(jfirst,n,2)
        shiftPhi=MatrixModel(jfirst,3)-Shell(jfirst,n,3)
          if(n>Nallineamenti) then
            shiftTet=0.0
            shiftPhi=0.0 ! occhio
          endif 
          write(6,*) 'shift',shiftTet,shiftPhi
        distGenTot=0.0
        nShell=0
        do j=jfirst+1,nca-1 ! loop sugli shells successivi al primo (usato come allineamento)
          if(ShellCont(j)==0) cycle ! non ci sono hits in questo shell
          hPoint=MatrixModel(j,1) 
c         if(hPoint<eps) cycle
          if(hPoint<eps) w1=0.0
          ray=MatrixModel(j,4) 
          nShell=nShell+1
          TetPoint=MatrixModel(j,2)-shiftTet
          PhiPoint=MatrixModel(j,3)-shiftPhi
          if(TetPoint<0.0) TetPoint=TetPoint+TwoPi !riporto gli angoli in [0, 2pi]
          TetPoint=mod(TetPoint,TwoPi)
          if(PhiPoint<0.0) PhiPoint=PhiPoint+TwoPi
          PhiPoint=mod(PhiPoint,TwoPi)
!--determino l'hit piu' vicino al point
          distmin=999999.
          do k=1,ShellCont(j) ! loop sugli hits dello shell j 
            Tet=Shell(j,k,2)
            Phi=Shell(j,k,3)
            term=cos(Phi)*cos(PhiPoint)+sin(Phi)*sin(PhiPoint)
     &                                  *cos(Tet-TetPoint)
            dist=sqrt(2.*(1.-term))
            if(dist<distmin) then
              distmin=dist
              TetHit=Tet
              PhiHit=Phi
              ipuntHit=k
            endif
          enddo
          hHit=Shell(j,ipuntHit,1)
          if(hHit<eps) w1=0.0
!--calcolo la distanza generalizzata dell'hit scelto dal point
          term=cos(PhiHit)*cos(PhiPoint)+sin(PhiHit)*sin(PhiPoint)
     &                                  *cos(TetHit-TetPoint)
          distGen=sqrt(2.*(1.-term))
c         distGen=ray*sqrt(2.*(1.-term)+w1*(hHit-hPoint)**2)
          distGenTot=distGenTot+distGen
          write(6,'(a,i5,4f8.3)') 'shell ',j,distmin,distGen,hHit,hPoint
        enddo
        distGenTot=distGenTot/float(nShell)
        write(6,'(a,i5,f8.3)') 'alignment, fom ',n,distGenTot
!--determino il minimo tra le distanze totali generalizzate per i vari allineamenti
        if(distGenTot<distGenTotMin) then
          distGenTotMin=distGenTot
          ipuntAll=n
        endif
      enddo
!
      write(6,'(a,f8.3)') 'Final FOM for the structure ',distGenTotMin
      write(6,'(a,i5)') 'Obtained for alignment ',ipuntAll
c
      return
      end

!-------------------------------------------------------------
      subroutine CreaShell(i, nSetsMTZ)
      USE General
      USE RemoModule, only: nkSav, nalfSav, nwSav
!
      k1 = index(fname(1),'.bin') - 1
      write(Inte,10)  fname(1)(1:k1), i
      call NoBlanks(Inte, kk)
      istat = 0
      iform = 1
      jop=jopen(78,Inte,istat,iform,ierr)
!gl!  write(Inte,'(20a4)') itle
      Inte = Titolo
      do j=1, nkSav
         write(vSpecie(j),'(a4)') nalfSav(j)
         call lcase(vSpecie(j))
         call ucase(vSpecie(j)(1:1))
      enddo
      write(cardDiret,20) (vSpecie(j),nwSav(j),j=1,nkSav)
      call OneBlankOnly(cardDiret)
      k2 = Lung(Inte)
      k3 = Lung(MTZfile)
      k4 = Lung(Msg)
      k5 = Lung(cardDiret)
      if (numeroResidui /= 0) then
          write(cardDiret,"('nResidues ',i5)") numeroResidui
          k5 = Lung(cardDiret)
      endif
      write(78,30) fname(1)(1:k1),   ! %structure
     *             Inte(1:k2),       ! %job
     *             MTZfile(1:k3),    ! mtz
     *             Msg(1:k4),        ! label
     *             cardDiret(1:k5)   ! content / numeroResidui
      close(78)
!
      if (i == nSetsMTZ) then
          write(Inte,40)  fname(1)(1:k1)
          istat = 0
          iform = 1
          jop=jopen(78,Inte,istat,iform,ierr)
          do j=1, nSetsMTZ
             write(cardDiret,50) fname(1)(1:k1), j, fname(1)(1:k1), j
             call OneBlankOnly(cardDiret)
             write(78,'(a)') cardDiret(1:Lung(cardDiret))
          enddo
          close(78)
      endif
!
      return
   10 format(a,'_edm',i5,'.sir')
   20 format('Content ',18(a4,i6,2x))
   30 format('%NoWindow',/,
     *       '%Structure  ',a,/,
     *       '%Job ',a,/,
     *       '%Data',/,
     *       '   Mtz ',a,/,
     *       '   Label 'a,/,
     *       '   Phase 3',/,
     *       '   'a,/
     *       '%edm',/,
     *       '   dm 1 1 0 0',/,
     *       '   convc -1',/,
     *       '   refextension 0',/,
     *       '!  partial 2 0 0',/,
     *       '%end')
   40 format(a,'_edm.sh')
   50 format('sirprot ',a,'_edm',i1,'.sir ',a,'_edm',i1,'.out')
!
      end
!----------------------------------------------------------------------
      subroutine CalcoloPacking()
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Molcom
      USE Finale
      USE RemoModule
      USE Solutions
      USE PhaseModule
      USE Mappa
      dimension xsa(3),xsb(3),xeq(3),s(3)
      integer, allocatable : : ifAcid(:)
!
      allocate (ifAcid(1:numbModels),stat = ierv)
!
!--controllo che tipo di  modelli ho: proteina o  acido nucleico
!
      ino=0
      ifAcid(1:numbModels)=2
      do i=1, numbModels
!--controllo che sia una proteina
        do k=1, natsInModel(i)
          if (model(i)%tipoAtomo(k,1) == 'ca ') then
            ifAcid(i)=0 
            exit
          endif
        enddo
        if(ifAcid(i)==0) cycle
!--controllo che sia un acido nucleico
        do k=1, natsInModel(i)
          if (model(i)%tipoResiduo(k,1) == '  a'.or.
     &        model(i)%tipoResiduo(k,1) == '  t'.or.
     &        model(i)%tipoResiduo(k,1) == '  g'.or.
     &        model(i)%tipoResiduo(k,1) == '  c') then
            ifAcid(i)=1
            exit
          endif
          if (model(i)%tipoResiduo(k,1) == ' a '.or.
     &        model(i)%tipoResiduo(k,1) == ' t '.or.
     &        model(i)%tipoResiduo(k,1) == ' g '.or.
     &        model(i)%tipoResiduo(k,1) == ' c ') then
            ifAcid(i)=1
            exit
          endif
          if (model(i)%tipoResiduo(k,1) == 'a  '.or.
     &        model(i)%tipoResiduo(k,1) == 't  '.or.
     &        model(i)%tipoResiduo(k,1) == 'g  '.or.
     &        model(i)%tipoResiduo(k,1) == 'c  ') then
            ifAcid(i)=1
            exit
          endif
        enddo
        if(ifAcid(i)==2) ino=ino+1
      enddo
!
      if(ino==numbModels) return
!
!--calcolo il numero di clashes per la soluzione corrente
!
      tol=3.0
      nclash=0
      ntot1=0
      do ia=1, numbModels
        if(ifAcid(ia)==2) cycle
        do ja=1, MonomerInModel(ia)
          do ka=1, natsInModel(ia)
            if(ifAcid(ia)==0) then
              if (model(ia)%tipoAtomo(ka,ja) /= 'ca ') cycle
            else
              if (model(ia)%tipoAtomo(ka,ja) /= 'c4 '.and.
     &            model(ia)%tipoAtomo(ka,ja) /= 'p  '.and.
     &            model(ia)%tipoAtomo(ka,ja) /= 'n3 '.and.
     &            model(ia)%tipoAtomo(ka,ja) /= 'n7 ') cycle
            endif
            ntot1=ntot1+1
            xsa(1:3)=model(ia)%atoms(1:3,ka,ja)
            ciclo_b: do ib=ia, numbModels
              if(ifAcid(ib)==2) cycle
              do jb=ja, MonomerInModel(ib)
                do kb=1, natsInModel(ib)
                   if(ifAcid(ib)==0) then
                     if (model(ib)%tipoAtomo(kb,jb) /= 'ca ') cycle
                   else
                     if (model(ib)%tipoAtomo(kb,jb) /= 'c4 '.and.
     &                   model(ib)%tipoAtomo(kb,jb) /= 'p  '.and.
     &                   model(ib)%tipoAtomo(kb,jb) /= 'n3 '.and.
     &                   model(ib)%tipoAtomo(kb,jb) /= 'n7 ') cycle
                   endif
                   xsb(1:3)=model(ib)%atoms(1:3,kb,jb)
!--calcolo la distanza minima tra l'atomo a e l'atomo b, 
!  considerata la simmetria
                   distmin=9999.
                   do kk1=1,ncentr
                   do kk2=1,icent+1
                   coef=1.0
                   if(kk2==2) coef=-1.0
                   iniz=1
                   if(kk1==1.and.kk2==1.and.ia==ib.and.ja==jb) then
                     iniz=2
                   endif
                   do kk3=iniz,nsym
                     call xequi(xsa,kk3,coef,xeq,kk1)
                     call xdist(xsb,xeq,dist,s)
                     if(dist<distmin) distmin=dist
                   enddo
                   enddo
                   enddo
!--controllo che la distanza minima sia entro tol, altrimenti
!  ho un clash
                   if(distmin<tol) then
                     nclash=nclash+1
                     exit ciclo_b
                   endif
c                  write(6,*) 'ecco',ia,ib,ja,jb,ka,kb
c                  write(6,*) '    ',distmin,nclash,ntot1
                enddo
              enddo
            enddo ciclo_b
          enddo
        enddo
      enddo
      if(ntot1>0) then
         packRemo=100.*nclash/float(ntot1)
c       packRemo=(100.*2*nclash)/float(ntot1)
      else
        packRemo=0.0
      endif
!
      if(kverbo>0) then
        write(6,'(a,i8)') 'n. of trace atoms:',ntot1
        write(6,'(a,i8)') 'n. of clashes:',nclash
        write(6,'(a,f8.2)') 'Fraction of clashes (%):',packRemo
      endif
!
      deallocate(ifAcid, stat=ierr)
!
      return
      end
!----------------------------------------------------------------------
      subroutine Impacchetta()
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Finale
      USE RemoModule
      USE Solutions
      USE PhaseModule
!
!--avvicina le varie copie di un modello e i vari modelli 
!
      dimension xo(3), xn(3), xeq(3), s(3), ix(3),ixsav(1:3)
      dimension x1(3),x2(3)
!
      xn(1:3) = 0.5
      xn(2) = 0.45
!
!--attenzione, non metto tutti a 0.5 perche' da quel punto
!  passano operatori di simmetria (specialmente nel cubico)
!  per cui non riesco a distinguere posizioni diverse di monomeri
!
      do ia=1, numbModels
        if(ifPositionedVet(ia)>0) cycle 
        do ja=1, MonomerInModel(ia)
!
!--calcolo il baricentro del monomero ja 
!
          xo(1:3) = 0.
          do ka=1, natsInModel(ia)
            xo(1:3) = xo(1:3) + model(ia)%atoms(1:3, ka,ja)
          enddo
          xo(1:3) = xo(1:3) / float(natsInModel(ia))
c         write(6,*) 'xo',xo
!
!--determino la operazione di simmetria che fa avvicinare il baricentro
!                      alla posizione 1/2, 1/2, 1/2
!
          distm = 9999
          do kk1=1,ncentr
          do kk2=1,icent+1
             coef=1.0
             if(kk2==2) coef=-1.0
             do kk3=1,nsym
                call xequi(xo,kk3,coef,xeq,kk1)
                call xdist(xn,xeq,d,s)
                ix(:) = 0
                do i=1,3
                  if (xeq(i) < 0.0) then
                      ix(i) = int(abs(xeq(i))) + 1
                  elseif (xeq(i) > 1.0) then
                      ix(i) = -int(xeq(i)) 
                  endif
                enddo
c               write(6,*) 'xo eq',kk1,kk2,kk3,xeq,d
                if (d < distm) then
c                 write(6,*) 'ufi',xeq,ix
                  kk1Sav = kk1
                  coefSav = coef
                  kk3Sav = kk3
                  distm=d
                  ixsav(1:3)=ix(1:3)
                endif
             enddo
          enddo
          enddo
          if(kk1Sav.ne.1.or.coefSav<0.or.kk3Sav.ne.1) then
c             write(6,*) 'ecco',ja,kk1Sav,coefSav,kk3Sav,ixsav
!
!--applico l'operazione di simmetria
!
            do ka=1, natsInModel(ia)
              xo(1:3) = model(ia)%atoms(1:3, ka,ja)
              call xequi(xo,kk3Sav,coefSav,xeq,kk1Sav)
              do ii=1,3
                x1(ii)=xeq(ii)+ixsav(ii)
              enddo
              model(ia)%atoms(1:3, ka,ja)=x1(1:3)
            enddo
          endif
c--prova
!
!--calcolo il nuovo baricentro del monomero ja 
!
c         xo(1:3) = 0.
c         do ka=1, natsInModel(ia)
c           xo(1:3) = xo(1:3) + model(ia)%atoms(1:3, ka,ja)
c         enddo
c         xo(1:3) = xo(1:3) / float(natsInModel(ia))
c         write(6,*) 'xo new',xo
c--prova
        enddo
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine RemoAnalysis(ier)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Molcom
      USE Grafici
      USE Param
      USE MadModule
      USE PhaseModule
      USE RemoModule
      USE Direttive
!
!-- read directives for this modul
!
      common /misurato/ misu  !pgMAD
!
      common /sfact/ nSfCard, sfacm(18,9), kSfac(18)
      dimension celltemp(13)
      character fileh*256
      dimension x1(3), x2(3), b(3,3)
      dimension RotAppl1(3),TraAppl1(3)
      character*11 stringa
      integer nwTot(18), nalfTot(19), nkTot
      integer itleSav(20)
!
      itleSav(:) = itle(:)
!
!-- set default values
!
      ifRemo = 1
!
      numbModelsMax = 200
      numbModels = 1
      MonomerInModel(:) = 1
      ModelOn = 0
      CutResiduiVet(:,:) = 0
      bfacMRVet(:) = -1
      AlaVet(:) = 0
      LeggiHetamVet(:) = 0
      ifTraOnlyVet(:) = 0
      ifRotSelVet(:) = 0
      RotAppl1Vet(:,:) = 0.0
      ifPositionedVet(:) = 0
      RotApplVet(:,:) = 0
      TranslApplVet(:,:) = 0
      
!
      nwTot(:) = 0
      nalfTot(:) = 0
      nkTot = 0
      
      ifCutResidui = 0
      bfacMR = -1
      ifAla = 0
      use_E=.true. !lavora con e
c      use_E=.false.  ! lavora con la correlazione
c     kverbo = 0
      ifSolvent = 0
      ifShelx = 0
      jMolMR = 0
      kCosto = 5
c
      resol1=-1.0
      resol2=0.0
      resol3=0.0
      resol4=0.0
      idSeq = 1.0
      rmsStr = 0.0
      nMolMR = 1
      rhoSog1  = 0.0
      rhoSog1a = 0.0
      rhoSog2 = 0.0
      rhoSog3 = 0.0
      ifModify = 0
!
      if (RSoglia.lt.0) then
          RSoglia = 25.0
      endif
      if (resm < ResSogLow) then
          nolsq = -1
      else
          nolsq = 0
      endif
      jrecyc = 100
      ifPositioned = 0
      ifRotOnly = 0
      ifTraOnly = 0
      globval(1:2) = (/ -9999, 0 /)
      ifTranslAppl = 0
      ifRotAppl    = 0
      TranslAppl(:) = 0.0
      RotAppl(:)    = 0.0
      RotAppl1(:)    = 0.0
      TraAppl1(:)    = 0.0
      ifRotSel=0
      ifTraSel=0
!
!-- check for 'model' directive
!
      ipdS = ipdir
      ic    = 0
      icmax = icomq(icomat,2)
      do while (ic.lt.icmax.and.ier.eq.0)
         ic = ic + 1
         ipdir=ipdir+1
         cardDiret=card(ipdir)
         call lcase(cardDiret)
         if (cardDiret(1:4) == 'mode') then
             numbModels = 0
             exit
         endif
      enddo
      ipdir = ipdS
      
      resol2 =10.0
      ic    = 0
      icmax = icomq(icomat,2)

c
      do while (ic.lt.icmax.and.ier.eq.0)
         ic = ic + 1
         ipdir=ipdir+1
         cardDiret=card(ipdir)
         cardImage=cardDiret
         ldiret = Lung(cardImage)
         call cutst(cardDiret,lenp,direttiva,lend)
         call lcase(direttiva)
c-- directives with alphanumeric parameters
         if (direttiva(1:4).eq.'mode') then
             if (ModelOn == 0) then
                 ModelOn = 1
                 numbModels = numbModels + 1
                 if (numbModels > numbModelsMax) then
                     ier = -10
                 endif
             else
                 ier = -10              ! errore nella direttiva
             endif
         elseif (direttiva(1:4).eq.'endm') then
             if (ModelOn == 1) then
                 ModelOn = 0
             else
                 ier = -10              ! errore nella direttiva
             endif
         elseif (direttiva(1:4).eq.'poly') then
             ifAla = 1
             AlaVet(numbModels) = 1
         elseif (direttiva(1:4).eq.'deta')  then
             kverbo = 1
         elseif (direttiva(1:4).eq.'verb')  then
             kverbo = 1
         elseif (direttiva(1:4).eq.'shel')  then
             ifShelx = 1
         elseif (direttiva(1:4).eq.'frag') then         
!
!-- check for HETAM in the fragment string
!
             k = index(cardDiret, 'heta')
             if (k > 0) then
                 LeggiHetam = 1
                 k1 = index(cardDiret(k+1:), ' ')
                 if (k1 == 0) then
                     cardDiret(k:) = ' '
                 else
                     k1 = k1 -1 + k
                     cardDiret(k:k1) = ' '
                 endif
                 call shift(cardDiret, k1)
             else
                 LeggiHetam = 0
             endif
             LeggiHetamVet(numbModels) = LeggiHetam
!
!-- check for blanks in the fragment file name
!
             call CheckBlanks(fileh, lend)
!
             if (lend > 0) then
                 ReflFileName = fileh(1:lend)
                 jjfile = jfile
                 fileh  = ReflFileName
                 card(ncardMax - numbModels + 1) = ReflFileName
             else
                 ier = -10
             endif
         elseif (direttiva(1:4).eq.'bfac') then
             call lcase(cardDiret)
             iopt = 0
             call getnum(cardDiret, vet, ivet, iv, iopt)
             if (iopt /= -1 .and. iv == 1) then
                 bfacMR = vet(1)
                 bfacMRVet(numbModels) = bfacMR
              elseif(cardDiret(1:3) == 'pdb') then
                 bfacMR = 0
                 bfacMRVet(numbModels) = bfacMR
              elseif(cardDiret(1:3) == 'wil') then
                 bfacMR = -1
                 bfacMRVet(numbModels) = bfacMR
              else
                  ier = -10         ! errore nella direttiva
              endif
         else
!-- directives with numeric parameters
              iopt=0
              call getnum(cardDiret,vet,ivet,iv,iopt)          
              if (iopt.ne.-1) then
                 if (direttiva(1:4).eq.'rang') then
                      if (iv.eq.1) then
                          resol1=vet(1)
                          if (resol1.lt.0.001) then
                              ier = -10
                          else
                              th = ( 0.5 / resol1 ) ** 2
                          endif
                      elseif (iv.eq.2) then
                          resol1=vet(1)
                          resol2=vet(2)
                      elseif (iv.eq.3) then
                          resol1=vet(1)
                          resol2=vet(2)
                          resol3=vet(3)
                          resol4=vet(2)
                      elseif (iv.eq.4) then
                          resol1=vet(1)
                          resol2=vet(2)
                          resol3=vet(3)
                          resol4=vet(4)
                      else
                          ier = -10
                      endif
                 elseif (direttiva(1:4).eq.'posi') then
!
!-- applica la rotazione e traslazione fornite e basta
!
                      if (iv == 6) then
                          ifPositionedVet(numbModels) = 1
                          RotApplVet(numbModels, 1:3)    = vet(1:3)
                          TranslApplVet(numbModels, 1:3) = vet(4:6)
                      else
                          ier = -10
                      endif
                 elseif (direttiva(1:4).eq.'tran') then
!
!-- applica inizialmente la traslazione fornita e prosegue regolarmente
!
                      if (iv == 3) then
                          ifTranslApplVet(numbModels) = 1
                          TranslApplVet(numbModels, 1:3) = vet(1:3)
                      else
                          ier = -10
                      endif
                 elseif (direttiva(1:4).eq.'rota') then
!
!-- applica inizialmente la rotazione fornita e prosegue regolarmente
!
                      if (iv == 3) then
                          ifRotApplVet(numbModels) = 1
                          RotApplVet(numbModels, 1:3) = vet(1:3)
                      else
                          ier = -10
                      endif
                 elseif (direttiva(1:4).eq.'rots') then
!
!-- applica la rotazione fornita e fa solo la traslazione
!
                      ifTraOnlyVet(numbModels) = 1
                      ifRotSelVet(numbModels) = 1
                      if (iv == 3) then
                          RotAppl1Vet(numbModels,1:3) = vet(1:3)
                      endif
                 elseif (direttiva(1:4).eq.'tras') then
!
!-- applica la rotazione e la traslazione e fa solo la rotazione
!
                      ifTraSel=1
                      if (iv == 6) then
                          RotAppl1Vet(numbModels,1:3) = vet(1:3)
                          TraAppl1Vet(numbModels,1:3) = vet(4:6)
                      else
                          ier = -10
                      endif
                 else
                   ier = -20
                 endif
              else
                ier = -20
              endif
         endif
!pgMAD
      enddo

! -- impongo POLY e BWison
!                ifAla = 1
!                bfacMR = -1
!                bfacMRVet(numbModels) = bfacMR
! -- impongo POLY e BWison
      
      if (ier == -10) then
          write(Msg,6100) cardImage(1:ldiret)
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          ier = -1
          return
      endif
      
      if (ier == -20) then
          write(Msg,6200) cardImage(1:ldiret)
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          ier = -1
          return
      endif

      if (ModelOn == 1) then
          Msg = 'Model directive used but no endmodel supplied '
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          ier = -1
          return
      endif
!
      if (allocated(model)) then
          call AllocaModelRemo(2)
      endif
!
      call AllocaModelRemo(0)
!
      if(ifModify==1) then
c       bfacMR=bt
        bfacMR=-1
        use_E=.true.
      endif
!
      preRemo = .false.
      Msg = '<big><b>Input conditions</b></big>'
      call TestoGR(Msg, color_RED, 2, 1)
      if (numbModels == 1) then
          j = index(card(ncardMax), slash, .TRUE.) + 1
          ReflFileName = card(ncardMax)(j:)
          write(Msg,6400) ReflFileName(1:Lung(ReflFileName))
      else
          write(Msg,'(i5,a)') numbModels, ' models in input'
          call shift(Msg,L)
      endif
      call TestoGR(Msg, -1, 2, 1)
      
      natsModel = 0
      do WhichModel=1, numbModels
         itype = 2
         iform = 1
         ReflFileName = card(ncardMax - WhichModel + 1)
         nMolMR = MonomerInModel(WhichModel)
         ifCutResidui = CutResiduiVet(WhichModel, 1)
         bfacMR = bfacMRVet(WhichModel)
         ifAla = AlaVet(WhichModel)
         LeggiHetam = LeggiHetamVet(WhichModel)
         ifTraOnly = ifTraOnlyVet(WhichModel)
         ifRotSel =  ifRotSelVet(WhichModel)
         ifPositioned = ifPositionedVet(WhichModel)
         ifRotAppl = ifRotApplVet(WhichModel)
         RotAppl(1:3) = RotApplVet(WhichModel, 1:3)
         RotAppl1(1:3) = RotAppl1Vet(WhichModel,1:3)
         TranslAppl(1:3) = TranslApplVet(WhichModel, 1:3)
         TraAppl1(1:3) = TraAppl1Vet(WhichModel,1:3)

         if (jopen(jhost,ReflFileName,itype,iform,ios).ge.0) then
             WRITE(lo,"(' Model structure file:',/,2x,a)") 
     *             ReflFileName(1:lung(ReflFileName))
             Msg = ' '
             k = 0
             if (ifAla == 1) then
                 Msg = '  Transformed in polyalanine'
                 k = Lung(Msg)
             endif
             if (ifCutResidui == 1) then
                 MinResiduo = CutResiduiVet(WhichModel, 2)
                 MaxResiduo = CutResiduiVet(WhichModel, 3)
                 write(stringa,"(i5,'-',i5)") MinResiduo, MaxResiduo
                 call NoBlanks(stringa, lstringa)
                 if (k == 0) then
                     Msg = '  Used residues ' // stringa(1:lstringa)
                 else
                     Msg(k+1:) = ';  used only residues ' // 
     *                           stringa(1:lstringa)
                 endif
                 k = Lung(Msg)
             endif
             if (k > 0) then
                 write(lo,'(a)') Msg(1:k)
                 call TestoGR(Msg, -1, 2, 1)
             endif
             call Cancella(3)
             import = kQualeFormato(ReflFileName)
  
             zero = 0.001
             if (import.eq.2) then
                 ifHOH = 0
                 kAla = ifAla
!--cosi' usa la cella del modello, imponendo la matrice di ortogonalizzazione
!  calcolata nel sir (a volte puo' anche non coincidere con quella del PDB, ma
!  almeno la rigidita' del modello e' conservata
!--cosi' non usa la cella del modello, ma quella del target
                 call ManagePDBSir(0, ifHOH, LeggiHetam, kAla,0, ier)
                 coef = 1.0
                 if (bfacMR < 0.0) then
                     bmedio = 
     *                   sum(model(WhichModel)%th_fact(1:natsMR,1))
                     bmedio = bmedio / float(natsMR)
                     if (bmedio > zero) then
                         coef = 1.1 * bt / bmedio
                         if (kverbo >0) then
                           write(6,*) 
     *                           'Thermal factors:',bt,bmedio,coef
                         endif
                     endif
                 endif
             elseif (import.eq.4) then
                 coef = 1
                 call LeggiCIF(ifRefl, 0, ier)
             else
                 Msg = 'Unrecognized file format: '//
     *           reflfilename (1:lung(reflfilename))
                 call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
                 return
             endif
             close(jhost)
             natsModel = natsModel + nats * nMolMR
!
!--gestisco il caso  in cui il modello ha B nullo
!
             bmin = minval(model(WhichModel)%th_fact(1:natsMR,1))
             if (bmin < zero) then
                 do i=1, natsInModel(WhichModel)
                    if (model(WhichModel)%th_fact(i,1) < zero) then
                        model(WhichModel)%th_fact(i,1) = bt
                    endif
                 enddo
                 write(Msg,10) char(10), bt
                 call OpenWarning(Msg)
                 write(lo,'(/,a)') Msg(1:Lung(Msg))
             endif
          
             n = natsInModel(WhichModel)
             model(WhichModel)%th_fact(1:n,1) = 
     *                   model(WhichModel)%th_fact(1:n,1) * coef
!
            bmedio = sum(model(WhichModel)%th_fact(1:natsMR,1))
            bmedio = bmedio / float(natsMR)
!
             if (ier.lt.0) then
                 Msg = 'Error importing the file '//
     *           reflfilename (1:lung(reflfilename))
                 call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
                 return
             else
                 if (InfoOK(3) == 0) then
                     call Get_3(20)
                 endif
!
*                NatMol = nats
*                call InitMolplo()
!
                 if (ifTranslAppl == 1) then
                     nMolMR = MonomerInModel(WhichModel)
                     do i=1, nMolMR
                        do j=1, natsInModel(WhichModel)
                           model(WhichModel)%atoms(1:3,j,i) = 
     *                           model(WhichModel)%atoms(1:3,j,i) 
     *                         + TranslAppl(1:3)
                        enddo
                     enddo
                 endif
!
                 if (ifRotAppl == 1) then
                     tet1 = RotAppl(1) * dtor
                     tet2 = RotAppl(2) * dtor
                     tet3 = RotAppl(3) * dtor
                     call RotationOper1(b,tet1,tet2,tet3)
!
                     call DrawMatrixTra(b)
!
                     nMolMR = MonomerInModel(WhichModel)
                     do i=1, nMolMR
                        do j=1, natsInModel(WhichModel)
                          x1(1:3) = model(WhichModel)%atoms(1:3,j,i)
                          call MoltMatVec(rm, x1, x2)
                          call MoltMatVec(b, x2, x1)
                          call MoltMatVec(rmi, x1, x2)
                          model(WhichModel)%atoms(1:3,j,i) = x2(1:3)
                        enddo
                     enddo
                 endif
                 if (ifRotSel == 1) then
                   RotAppl(1:3)=RotAppl1(1:3)
                 endif
                 if (ifTraSel==1) then
                   RotAppl(1:3)=RotAppl1(1:3)
                   TranslAppl(1:3)=TraAppl1(1:3)
                 endif
!
c                 nnn = nats
c                 nats = natsInModel(1)
c!                call ScriviFrammento()
c                 nats = nnn
             endif
         else
             write(Msg,9510) ios,ReflFileName (1:lung(ReflFileName))
             call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
             ier = -1
             return
         endif
      enddo  ! fine ciclo sui modelli
c      if (numbModels > 1) then
c          nw(:) = nwTot(:)
c          nalf(:) = nalfTot(:)
c          nk = nkTot
c          wave = wavel
c          call yfrm03(wave,ier)
c          call yfl03
c      endif
      call InitMolplo()
!
      write(lo,30) '  MODEL STRUCTURE DESCRIPTION  '
!
      call WriteCellInfo
**    call WriteSymmInfo(lo)
*     call WriteContInfo(dum1,dum2,npq,ier)
      call WriteContInfo(npq,ier)
      if (knw == 1) then
          call AllocaTestStuff(1)
      endif
!
      ksubr = 2  
      call leggiriflessi(ier,ksubr)  
!
      if (ier /= 0) then
          call cstop('dirmol')
      endif  
      iyrand = 67543
      if (resm < ResSogLow) then
          nolsq = -1
      else
          nolsq = 0
      endif
      if (resm < ResSogLow) then
          LowRes = 0
      else
          LowRes = 1
      endif
!
      itle(:) = itleSav(:)
!
      call  ExploreModels(numbModelsMax,ier)
!
      return
! 
   10 format(' Some thermal factor in the model are equal to zero !!',a,
     *       ' Set to Wilson value = ',f8.2)
   30 format(80('-'),/,a,/,80('-'))
  100 format('Molecular Replacement procedure:',i5,' atoms from model')
 6100 format(' Error in directive : ',a)
 6200 format(' Wrong directive in Molecular Replacement modulus:   ',a)
 6300 format(' ',a2, 'has not been declared in derivative directive')
 6400 format('Model from ',a)
 9510 format(' Open error, code =',i5,' file is ',a,
     *      '. PDB coordinates expected')
      end
!---------------------------------------------------------------------
      subroutine ExploreModels(numbModelsMax,ier)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Molcom
      USE Param
      USE PhaseModule
      USE RemoModule
      integer, allocatable : : PhasiModel(:,:)
      real*8 MpeVector(numbModelsMax*(numbModelsMax-1)/2)
c
      allocate(PhasiModel(1:numbModelsMax,1:nrefl), stat = ier1)
c
c--alloca le mappe
c
      ifRemo = 2
      call CheckGrid()
      ifRemo = 1
      call AllocaMappa(2)
      call AllocaMappa(1)
c
c--calcolo fattori di struttura e set di fasi per ogni modello caricato
c
     
      do i=1, numbModels
        do j=1, MonomerInModel(i)
        model(i)%considerato(j) = 0
        enddo
      enddo
c
      do i=1, numbModels
        model(i)%considerato(1) = 1
        call ChemInfo_MR_Final()
        call NewInv_MR_Final()
        PhasiModel(i,1:nrefl)=iphaz(1:nrefl)
        model(i)%considerato(1) = 0
      enddo
c
      call AllocaMappa(2)
c
c--introduzione del taglio sui riflessi
c
      do jj = 1, 5

      if (jj == 1) then
          wt(:) = 1.0
      else
          res2 = 100.
          res1 = float(jj * 2)
          
          write(6,*) 'range ',res1,res2
c         rho_max = (0.5/res1)**2
c         rho_min = (0.5/res2)**2
          wt=0.0
          do i=1,nrefl
            resol = 0.5 / sqrt(rhov(i))
c           if(rhov(i)>rho_min.and.rhov(i)<rho_max) then
            if(resol>res1.and.resol<res2) then
              wt(i)=1.0
            endif
          enddo
      endif
c
c--calcolo degli errori di fase
c
      if (knw == 1) then
          ifExamin = 1
      endif
c
      MpeVector=0.0
      do i=1, numbModels-1
        iwork1(:)=PhasiModel(i,:)
        do j=i+1, numbModels
          iwork2(:)=PhasiModel(j,:)
          call examin(0,mkang,khl,iwork1,iwork2,nrefl,0,wt,0)
          ipunt=(j-1)*(j-2)/2+i
          MpeVector(ipunt)=erore
          write(6,'(2(a,i6),2x,a,2x,f5.2)') 'model ',j,' model ',i,
     &                                   'MPE ',erore
        enddo
      enddo
c
c--algoritmo di clustering
c
      call AllocaClustering(1,numbModelsMax)
      if (numbModels > 2) then
          call MakeCluster(numbModels,MpeVector,numbModelsMax)
      endif
      call AllocaClustering(2,numbModelsMax)
c

      enddo

      deallocate(PhasiModel, stat = ier1)
c
      return
      end
!------------------------------------------------------------------------------
      subroutine MakeCluster(n,d,nmax)
      USE Clustering
c
c--esegue il clustering gerarchico su una matrice delle distanze
c  precalcolata
c
      character *1  orient
      integer nmax,ldc
      parameter(ldc=100)
      character*600 c(ldc)
      real*8 dmin,dstep,ydist
      real*8 d(nmax*(nmax-1)/2)
      integer iwk(2*nmax)
c     real*8 cd(nmax-1),d(nmax*(nmax-1)/2),dord(nmax)
c     integer ilc(nmax-1),iord(nmax),iuc(nmax-1),iwk(2*nmax)
      kverbose=0
c
c-stampa della matrice delle distanze
c
      if(kverbose==1) then
        write(6,*) 'Distance matrix'
        do i=2,n
          write(6,96) i,(d(j),j=(i-1)*(i-2)/2+1,i*(i-1)/2)
        enddo
  96    format(1x,i2,2x,200(1x,f5.2))
      endif
c
c     method=1
      method=3
      ifail=0
      call ClusterFinder(method,N,D,ILCclust,IUCclust,CDclust,
     &              IORDclust,DORDclust,IWK,IFAIL)
      if (ifail /= 0) then
        write(6,*) 'ifail clustering ',ifail
        return
      endif
c
      write(6,56)
  56  format( 2x,'Step',2x,'Dist',2x,'Peak 1',2x,'Peak 2')
      do i = n-1,1,-1
        write(6,'(i5,2x,f5.2,2(2x,i5))') i,cdclust(i),
     &             ilcclust(i),iucclust(i)
      enddo
c
c--produce il dendogramma
c
      if(kverbose==1) then
         orient='S'
         dmin=0.0
         nsym=ldc
         dstep= cdclust(n-1)/float(nsym)
         ifail=0
         call Dendogram(orient,N,DORDclust,DMIN,DSTEP,NSYM,C,LDC,IFAIL)
         if (ifail /= 0) then
           write(6,*) 'ifail dendrogram ',ifail
           return
         endif
c
c--scrivo i risultati
c
         write(6,*) 'Dendrogram'
         ydist=cdclust(n-1)
         do i=1,nsym
           if(mod(i,3)==1) then
             write(6,99) ydist,c(i)
           else
             write(6,98) c(i)
              endif
              ydist=ydist-dstep
         enddo 
         write(6,*)
         write(6,*) (iordclust(i),i=1,N)
 99      format(f10.3,5x,600a)
 98      format(15x,600a)
      endif
c
      return
      end
c----------------------------------------------------
      subroutine Xroutine(N,D,INC,ITH,JTH,DMIN)
c
C     Selects the two clusters to merge
C
C     Only units with IND gt 0 are considered
C
      DOUBLE PRECISION  DMIN
      INTEGER           ITH, JTH, N
      DOUBLE PRECISION  D(N*(N-1)/2)
      INTEGER           INC(N)
      INTEGER           I, J, K, L
C     
C
      DO 20 I = 2, N
         IF (INC(I).GT.0) THEN
            L = I
            GO TO 40
         END IF
   20 CONTINUE
   40 CONTINUE
      K = (L-1)*(L-2)/2 + 1
      DMIN = D(K)
      ITH = L
      JTH = 1
      DO 80 I = L, N
         IF (INC(I).GT.0) THEN
            DO 60 J = 1, I - 1
               IF (INC(J).GT.0) THEN
                  IF (D(K).LE.DMIN) THEN
                     DMIN = D(K)
                     ITH = I
                     JTH = J
                  END IF
               END IF
               K = K + 1
   60       CONTINUE
         ELSE
            K = K + I - 1
         END IF
   80 CONTINUE
      RETURN
      END
c----------------------------------------------------
      subroutine Yroutine(ITYPE,Wfunc,N,D,INC,NC,JOIN1,JOIN2,DMIN)
C
C     Updates distance matrix when clusters JOIN1 and JOIN2 are
C     merged. Function Wfunc computes new distances
C
      DOUBLE PRECISION  DMIN
      INTEGER           ITYPE, JOIN1, JOIN2, N
      DOUBLE PRECISION  D(N*(N-1)/2)
      INTEGER           INC(N), NC(N)
      DOUBLE PRECISION  Wfunc
      EXTERNAL          Wfunc
      DOUBLE PRECISION  DKL, DKU
      INTEGER           I, JL, JU, KL, KU, NL, NU
C
      IF (JOIN1.LT.JOIN2) THEN
         JL = JOIN1
         JU = JOIN2
      ELSE
         JL = JOIN2
         JU = JOIN1
      END IF
      INC(JU) = 0
      NL = NC(JL)
      NU = NC(JU)
      NC(JL) = NL + NU
      NC(JU) = 0
      KL = (JL-1)*(JL-2)/2
      KU = (JU-1)*(JU-2)/2
      DO 20 I = 1, JL - 1
         KL = KL + 1
         KU = KU + 1
         DKL = D(KL)
         DKU = D(KU)
         IF (INC(I).GT.0) D(KL) = Wfunc(ITYPE,DKL,DKU,DMIN,NL,NU,NC(I))
   20 CONTINUE
C
C     Skip JL
C
      KL = KL + 1
      KU = KU + 1
C
      DO 40 I = JL + 1, JU - 1
         KL = KL + I - 2
         KU = KU + 1
         DKL = D(KL)
         DKU = D(KU)
         IF (INC(I).GT.0) D(KL) = Wfunc(ITYPE,DKL,DKU,DMIN,NL,NU,NC(I))
   40 CONTINUE
C
C     Skip JU
C
      KL = KL + JU - 2
      KU = KU + 1
C
      DO 60 I = JU + 1, N
         KL = KL + I - 2
         KU = KU + I - 2
         DKL = D(KL)
         DKU = D(KU)
         IF (INC(I).GT.0) D(KL) = Wfunc(ITYPE,DKL,DKU,DMIN,NL,NU,NC(I))
   60 CONTINUE
      RETURN
      END
c----------------------------------------------------
      subroutine Zroutine(N,ILC,IUC,CD,IORD,DORD,IND,IERROR)
C
C     Computes information for producing dendrogram
C
C     ILC(i) contains the cluster that joins IUC(i) at the
C     ith join. ILC(i) gt IUC(i)
C
C     IORD is the order for the dendrogram and object IORD(i)
C     joins cluster with object IORD(i-1) at distance DORD(i)
C
C     IND contains information on which part of the ILC is to be
C     searched
C
C     IERROR returns 1 if algorithm fails
C
      INTEGER           IERROR, N
      DOUBLE PRECISION  CD(N-1), DORD(N)
      INTEGER           ILC(N-1), IND(N), IORD(N), IUC(N-1)
      INTEGER           I, ILINK, J, L
C
      IERROR = 0
      DO 20 I = 1, N
         IND(I) = 1
   20 CONTINUE
      L = 1
      ILINK = 1
      IORD(1) = 1
      DORD(N) = CD(N-1)
      DO 140 I = 2, N
   40    CONTINUE
         DO 60 J = IND(L), N - 1
            IF (ILC(J).EQ.ILINK) THEN
               GO TO 100
            END IF
   60    CONTINUE
         IF (L.EQ.1) THEN
            IERROR = 1
            GO TO 160
         END IF
         IND(L) = N
   80    L = L - 1
         IF (IND(L).LT.N) THEN
            ILINK = IORD(L)
            GO TO 40
         ELSE IF (L.GT.1) THEN
            GO TO 80
         ELSE
            IERROR = 1
            GO TO 160
         END IF
  100    CONTINUE
         IND(L) = J + 1
         ILINK = IUC(J)
         IORD(I) = ILINK
         DORD(I-1) = CD(J)
  120    L = L + 1
         IF (L.GT.N) THEN
            IERROR = 1
            GO TO 160
         ELSE IF (IND(L).EQ.N) THEN
            GO TO 120
         END IF
  140 CONTINUE
  160 CONTINUE
      RETURN
      END
c----------------------------------------------------
      double precision function Wfunc(ITYPE,DKI,DKJ,DIJ,NI,NJ,NK)
C
C     Computes the distance (DKI) from cluster k to cluster
C     formed by merging clusters i and j.
C     ITYPE indicates method:
C           1 - slingle link
C           2 - complete link
C           3 - group average
C           4 - centroid
C           5 - median
C           6 - minimum variance
C
      DOUBLE PRECISION                 DIJ, DKI, DKJ
      INTEGER                          ITYPE, NI, NJ, NK
      INTRINSIC                        DBLE, MAX, MIN
c 
C
      IF (ITYPE.EQ.1) THEN
         Wfunc = MIN(DKI,DKJ)
      ELSE IF (ITYPE.EQ.2) THEN
         Wfunc = MAX(DKI,DKJ)
      ELSE IF (ITYPE.EQ.3) THEN
         Wfunc = (DBLE(NI)*DKI+DBLE(NJ)*DKJ)/DBLE(NI+NJ)
      ELSE IF (ITYPE.EQ.4) THEN
         Wfunc = (DBLE(NI)*DKI+DBLE(NJ)*DKJ-DBLE(NI)*DBLE(NJ)
     *            *DIJ/DBLE(NI+NJ))/DBLE(NI+NJ)
      ELSE IF (ITYPE.EQ.5) THEN
         Wfunc = 0.5D0*DKI + 0.5D0*DKJ - 0.25D0*DIJ
      ELSE IF (ITYPE.EQ.6) THEN
         Wfunc = (DBLE(NI+NK)*DKI+DBLE(NJ+NK)*DKJ-DBLE(NK)*DIJ)
     *            /DBLE(NI+NJ+NK)
      END IF
      RETURN
      END
c----------------------------------------------------
      subroutine ClusterFinder(METHOD,N,D,ILC,IUC,CD,
     &                              IORD,DORD,IWK,IFAIL)
c
C     Performs Hierarchical Cluster Analysis using distance matrix D.
C
C     METHOD indicates which type is performed
C     METHOD = 1 - single link
C     METHOD = 2 - complete link
C     METHOD = 3 - group average
C     METHOD = 4 - centroid
C     METHOD = 5 - median
C     METHOD = 6 - minimum variance
C
C     ILC, IUC and CD give information about the clustering process
C
C     IORD and DORD give information for printing the dendrogram
C
      INTEGER           IFAIL, METHOD, N
      DOUBLE PRECISION  CD(N-1), D(N*(N-1)/2), DORD(N)
      INTEGER           ILC(N-1), IORD(N), IUC(N-1), IWK(2*N)
      DOUBLE PRECISION  DMIN
      INTEGER           I, IERROR, IFAULT, ITH, JTH, NN
      CHARACTER*80      REC(1)
      DOUBLE PRECISION  Wfunc
      EXTERNAL          Wfunc
      EXTERNAL          Xroutine, Yroutine, Zroutine
c
      IERROR = 0
      IF (METHOD.LT.1 .OR. METHOD.GT.6) THEN
         IERROR = 1
         WRITE (REC,FMT=99999) METHOD
      ELSE IF (N.LT.2) THEN
         IERROR = 1
         WRITE (REC,FMT=99998) N
      ELSE
         NN = N*(N-1)/2
         DO 20 I = 1, NN
            IF (D(I).LT.0.0D0) THEN
               IERROR = 2
            END IF
   20    CONTINUE
         IF (IERROR.EQ.2) THEN
            WRITE (REC,FMT=99997)
         END IF
      END IF
      IF (IERROR.EQ.0) THEN
         DO 40 I = 1, N
            IWK(I) = I
            IWK(N+I) = 1
   40    CONTINUE
         DO 60 I = 1, N - 1
            CALL Xroutine(N,D,IWK,ITH,JTH,DMIN)
            IF (I.NE.N-1) THEN
               CALL Yroutine(METHOD,Wfunc,N,D,IWK,IWK(N+1),ITH,JTH,DMIN)
            END IF
            ILC(I) = JTH
            IUC(I) = ITH
            CD(I) = DMIN
            IF (I.GT.1) THEN
               IF (DMIN.LT.CD(I-1)) THEN
                  IERROR = 3
                  WRITE (REC,FMT=99996)
               END IF
            END IF
   60    CONTINUE
         CALL Zroutine(N,ILC,IUC,CD,IORD,DORD,IWK,IFAULT)
         IF (IFAULT.NE.0) THEN
            IERROR = 4
         END IF
      END IF
      CONTINUE
      IFAIL = IERROR
C
      RETURN
C
99999 FORMAT (1X,'** On entry, METHOD.lt.1 .or. METHOD.gt.6: METHOD = ',
     *       I16)
99998 FORMAT (1X,'** On entry, N.lt.2: N = ',I16)
99997 FORMAT (1X,'** On entry, at least one element of D is negative.')
99996 FORMAT (1X,'** Minimum cluster distance not increasing, dendrogr',
     *       'am invalid.')
      END
c----------------------------------------------------
      subroutine Dendogram(ORIENT,N,DORD,DMIN,DSTEP,NSYM,C,LENC,IFAIL)
c
      DOUBLE PRECISION  DMIN, DSTEP
      INTEGER           IFAIL, LENC, N, NSYM
      CHARACTER         ORIENT
      DOUBLE PRECISION  DORD(N)
      CHARACTER*(*)     C(LENC)
      DOUBLE PRECISION  D, DL, DU
      INTEGER           CLEN, I, IDINC, IDLL, IDUL, IEND, IERROR, IST, J
      LOGICAL           LINE, MAX
      CHARACTER         LINC
      CHARACTER*80      REC(1)
      INTRINSIC         LEN
c
      DL = DMIN
      DU = DL + DSTEP
      IERROR = 0
      IF (N.LT.2) THEN
         IERROR = 1
         WRITE (REC,FMT=99999) N
      ELSE IF (NSYM.LT.1) THEN
         IERROR = 1
         WRITE (REC,FMT=99998) NSYM
      ELSE IF (DMIN.LT.0.0D0) THEN
         IERROR = 1
         WRITE (REC,FMT=99997) DMIN
      ELSE IF (DSTEP.LE.0.0D0) THEN
         IERROR = 1
         WRITE (REC,FMT=99996) DSTEP
      ELSE IF (ORIENT.NE.'W' .AND. ORIENT.NE.'w' .AND. ORIENT.NE.
     *         'N' .AND. ORIENT.NE.'n' .AND. ORIENT.NE.'S' .AND.
     *         ORIENT.NE.'s' .AND. ORIENT.NE.'E' .AND. ORIENT.NE.'e')
     *         THEN
         IERROR = 1
         WRITE (REC,FMT=99995) ORIENT
      ELSE IF ((ORIENT.EQ.'N' .OR. ORIENT.EQ.'n' .OR. ORIENT.EQ.'S' .OR.
     *         ORIENT.EQ.'s') .AND. (LENC.LT.NSYM)) THEN
         IERROR = 1
         WRITE (REC,FMT=99994) LENC
      ELSE IF ((ORIENT.EQ.'E' .OR. ORIENT.EQ.'e' .OR. ORIENT.EQ.'W' .OR.
     *         ORIENT.EQ.'w') .AND. (LENC.LT.N)) THEN
         IERROR = 1
         WRITE (REC,FMT=99994) LENC
      ELSE
         CLEN = LEN(C(1))
         IF ((ORIENT.EQ.'N' .OR. ORIENT.EQ.'n' .OR. ORIENT.EQ.'S' .OR.
     *       ORIENT.EQ.'s') .AND. (CLEN.LT.3*N)) THEN
            IERROR = 1
            WRITE (REC,FMT=99992)
         ELSE IF ((ORIENT.EQ.'E' .OR. ORIENT.EQ.'e' .OR. ORIENT.EQ.
     *            'W' .OR. ORIENT.EQ.'w') .AND. (CLEN.LT.NSYM)) THEN
            IERROR = 1
            WRITE (REC,FMT=99992)
         END IF
         MAX = .TRUE.
         DO 20 I = 1, N - 1
            MAX = MAX .AND. (DORD(N).GE.DORD(I))
   20    CONTINUE
         IF ( .NOT. MAX) THEN
            IERROR = 2
            WRITE (REC,FMT=99993)
         END IF
      END IF
      IF (IERROR.EQ.0) THEN
         DO 40 I = 1, LENC
            C(I) = ' '
   40    CONTINUE
         IF (ORIENT.EQ.'W' .OR. ORIENT.EQ.'w' .OR. ORIENT.EQ.'E' .OR.
     *       ORIENT.EQ.'e') THEN
            IF (ORIENT.EQ.'W' .OR. ORIENT.EQ.'w') THEN
               LINC = ')'
               IDUL = NSYM
               IDLL = 1
               IDINC = 1
            ELSE
               LINC = '('
               IDUL = 1
               IDLL = NSYM
               IDINC = -1
            END IF
            DO 80 J = IDLL, IDUL, IDINC
               LINE = .FALSE.
               IF (DORD(1).GE.DU) THEN
                  C(1) (J:J) = '.'
               ELSE IF (DORD(1).LT.DL) THEN
                  C(1) (J:J) = ' '
               ELSE
                  C(1) (J:J) = ' '
                  LINE = .TRUE.
               END IF
               DO 60 I = 2, N
                  D = DORD(I)
                  IF (LINE) THEN
                     IF (D.LT.DL) THEN
                        C(I) (J:J) = LINC
                     ELSE IF (D.GE.DU) THEN
                        C(I) (J:J) = LINC
                        LINE = .FALSE.
                     ELSE
                        C(I) (J:J) = LINC
                     END IF
                  ELSE
                     IF (D.GE.DU) THEN
                        C(I) (J:J) = '.'
                     ELSE IF (D.LT.DL) THEN
                        C(I) (J:J) = ' '
                     ELSE
                        C(I) (J:J) = ' '
                        LINE = .TRUE.
                     END IF
                  END IF
   60          CONTINUE
               DL = DL + DSTEP
               DU = DU + DSTEP
   80       CONTINUE
         ELSE
            IF (ORIENT.EQ.'S' .OR. ORIENT.EQ.'s') THEN
               IDLL = NSYM
               IDUL = 1
               IDINC = -1
            ELSE
               IDLL = 1
               IDUL = NSYM
               IDINC = 1
            END IF
            DO 120 J = IDLL, IDUL, IDINC
               LINE = .FALSE.
               IF (DORD(1).GE.DU) THEN
                  C(J) (1:3) = 'I  '
               ELSE IF (DORD(1).LT.DL) THEN
                  C(J) (1:3) = '   '
               ELSE
                  C(J) (1:3) = '---'
                  LINE = .TRUE.
               END IF
               DO 100 I = 2, N - 1
                  D = DORD(I)
                  IEND = I*3
                  IST = IEND - 2
                  IF (LINE) THEN
                     IF (D.LT.DL) THEN
                        C(J) (IST:IEND) = '---'
                     ELSE IF (D.GE.DU) THEN
                        C(J) (IST:IEND) = '*  '
                        LINE = .FALSE.
                     ELSE
                        C(J) (IST:IEND) = '---'
                     END IF
                  ELSE
                     IF (D.GE.DU) THEN
                        C(J) (IST:IEND) = 'I  '
                     ELSE IF (D.LT.DL) THEN
                        C(J) (IST:IEND) = '   '
                     ELSE
                        C(J) (IST:IEND) = '---'
                        LINE = .TRUE.
                     END IF
                  END IF
  100          CONTINUE
               D = DORD(N)
               IST = IEND + 1
               IEND = IST + 2
               IF (LINE) THEN
                  IF (D.GE.DU) THEN
                     C(J) (IST:IEND) = '*  '
                  ELSE
                     C(J) (IST:IEND) = '-  '
                  END IF
               ELSE
                  IF (D.GE.DU) THEN
                     C(J) (IST:IEND) = 'I  '
                  ELSE IF (D.LT.DL) THEN
                     C(J) (IST:IEND) = '   '
                  ELSE
                     C(J) (IST:IEND) = '-  '
                  END IF
               END IF
               DL = DL + DSTEP
               DU = DU + DSTEP
  120       CONTINUE
         END IF
      END IF
C
      IFAIL = IERROR
      RETURN
C
99999 FORMAT (1X,'** On entry, N.lt.2: N = ',I16)
99998 FORMAT (1X,'** On entry, NSYM.lt.1: NSYM = ',I16)
99997 FORMAT (1X,'** On entry, DMIN.lt.0.0: DMIN = ',D13.5)
99996 FORMAT (1X,'** On entry, DSTEP.le.0.0: DSTEP = ',D13.5)
99995 FORMAT (1X,'** On entry, ORIENT is not valid: ORIENT = ',A1)
99994 FORMAT (1X,'** On entry, LENC is too small: LENC = ',I16)
99993 FORMAT (1X,'** On entry, DORD(I).gt.DORD(N), I.lt.N')
99992 FORMAT (1X,'** On entry, insufficient characters can be stored i',
     *       'n each element of vector C')
      END
!-----------------------------------------------------------------------
      subroutine RestoreSpaceGroup
      USE Symmetry
!
      nSpaceG(:) = nSpaceGSav(:)
      call CreaSymmetryInfo(ier)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine PostMR(VettRisultati, rMTZ, ifExit, FFom_S, ifRicicla,
     *           ricAMB, nSetBest, RfacAW_S, RfreAW_S, maxBatchCAB)
      USE General
      USE Riflessi
      USE Molcom
      USE PhaseModule
      USE Mappa
      USE HistoStuff
      USE VLDmod, only : sog_sigmaA, n_Maxrun
      USE ArpWarp
      USE Grafici
      USE RemoModule
      USE Align
      USE TestModel, only : CaOnly
      USE Param , only :f000  
      USE Html
!
      implicit none
      integer :: i, j, k, ier, nset, kk, ksubr, ifBreak, nsetFinalPhases
      integer :: istat, iform, jopen, kQuantiSets, jhk(3), ifSem, nsem
      integer :: numestrefCow, ifFromGraphic, ii, nRefi, Lung, jop
      integer :: iPlotTypeSWRC, nbru, izero, ifmin, modulo_sir, numb
      integer :: ifVLDs, cicliMut, nMutated, nAggiunti, nMacroRef
      integer :: kStripTask1, nMutated_prev, deleted, nGenSav, ifEmm
      integer :: maxGap, numbGenLoc, Max_icy, ifExit, iact, k1, k2
      integer :: SaveAmb, doRicicla, stampaMTZ, nMutatedtot, rMTZ
      integer :: icic, idsr, totdsr, ifVLDSav, L, ipher, ijij, jiji
      integer :: ij, ji, iii, jjj, jpatt, jflag, numb_accept, ncond1
      integer :: nSetsFineDSR_Sav,iai,icicAMB,numbAMB,stampaInfo
      integer :: soft, sav1, sav2, sav3, sav4, stepS
      integer :: box, ifRicicla, nSetBest, segno, maxBatchCAB, ricAMB
      logical :: continua, isOk
      real    :: sog, sog_res, sog_wt, zero, f000_back, coefOld
      real    :: smax, erreSav, perc, sMR
      real    :: FFom_S, RfacAW_S, RfreAW_S, deltaRfAW, ssogg
      real    :: correl, fig(11)
      real    :: VettRisultati(10)
      character (len=5) :: a5
      character (len=11) :: tirang
      character (len=20) :: stringa
      character (len=256) :: MTZfileSav, MTZrecycle
      character(len=256) :: FileIn_1, FileOut_1, FileIn_2, FileOut_2
      common /fasi/ nset
!
      zero = 0.000001
      stepS = 1
!
      if (numbGen == 0) then
          ifFreeLunchMR = 0
      endif
      if (ifREFMAC == 0 .and. ifImproveMR /= 0) then
          nRefmacCycles = -1
!         Msg = 'Molecular Replacement results will NOT be improved:' //
!    *              ' REFMAC program is missing !'
!         write(lo,80) Msg(1:Lung(Msg))
*         call TestoGR(Msg, -1, 2, 3)
*         return
      endif

      if (ifImproveMR == 0) then
          ifFreeLunchMR = 0
          nRefmacCycles = -1
          iesImpr = 0
      endif
!
      coverageOld = -9999
      nMacroRef = 2
      doRicicla = 1
!     if (idSeq < 0.4) then  !include 1e8a
      if (idSeq <= 0.35) then
          ifFreeLunchMR = 0
          if (preMutazioniReq == 0) then
              preMutazioni = 30 !7
              nuovoBl = min0(preMutazioni,5)
!             nuovoBl = min0(preMutazioni,10)
          endif
          if (NoMutateReq == 0) then
              ifMutate = 1   ! attivo mutazione  
          else
              ifMutate = 0  
          endif
      else
          ifFreeLunchMR = 0
          if (preMutazioniReq == 0) then
              preMutazioni = 0
              nuovoBl = 0
          endif
          if (MutateReq == 0) then
              ifMutate = 0  
          else
              ifMutate = 1   ! attivo mutazione
          endif
      endif
      if (preMutazioni == 0) then
          nuovoBl = 0
          ifMutate = 0
      endif
!
      if (JellyReq == 1) then
         isJelly = .true.
      endif
!
!!!   kverboCow =1
      kverboCow =0
      continua = .true.
      k = index(fname(1),'.bin')
      kk = kStripTask1(k) - 1
      nome = fname(1)(1:kk)
      lnome = Lung(nome)
!
      MTZrecycle = nome(1:lnome) // 'recycle.mtz'
!
      ifLoadedPDB = .false.
      VettRisultati(:) = 0.0
      cardDiret = nome(1:lnome) // '_refmac0.pdb'
      istat = 2
      iform = 1
      jop = jopen(jhost, cardDiret, istat, iform, ier)
      if (jop >= 0) then
          close(jhost, status = "delete")
      endif
      cardDiret = nome(1:lnome) // '_refmac.pdb'
      istat = 2
      iform = 1
      jop = jopen(jhost, cardDiret, istat, iform, ier)
      if (jop >= 0) then
          close(jhost, status = "delete")
      endif
!
      if (BatchCAB == 1) then
          ksubr = 4
          call LeggiRiflessi(ier,ksubr)
      endif
      call AllocaHistoStuff(1)
      kk = 0
      vetmatchin(1:nrefl) = evet(1:nrefl)
      call InitHistMatchObs(kk)
      call RestoreLists123(3)
      call AllocaTestStuff(2)
      call AllocaTestStuff(1)
!
      numbLSQ = 0.7 * nrefl
      ffomReq = -99
      sogResEff = 1.59
      iphazo(1:nrefl) = iphaz(1:nrefl)
      wto(1:nrefl) = wt(1:nrefl)
      call AllocaMapTest(1)
      call InitFinalFom_PostMR()
      if (knw == 1) then
          write(6,*) 'Initial dopo REMO ',CCEoEc(1:2),FOMs(2,4)
      endif
c     call AllocaMapTest(2)
      iphaz(1:nrefl) = iphazo(1:nrefl)
      wt(1:nrefl) = wto(1:nrefl)
      call examin(9991, mkang, khl, ipub, iphaz, nrefl,0,wt,1)
!!
      if (BatchCAB == 1) then
          call LoadFinalPhases(FomsFineDSR, iposFineDSR,
     *                        nsetFinalPhases)
      else
          nsetFinalPhases = 1
      endif
c
c            tirang = 'REMO  Wt.'
c            izero = 0
c            ipher = 1
c            call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
c    *                ipub,iphaz,wt,10,0.0,ipher)

      nTotTrials = nsetFinalPhases
      n_Maxrun = nsetFinalPhases
!
      call calcolasumffTot
!
      CCP4map = nome(1:lnome) // '_ccp4_map.map'
      if (ifMutate == 1) then
          CaOnly = .true.
      endif
!
*     if (knw > 0) then
*         do i=1, nsetFinalPhases
*            nset = iposFineDSR(i)
*            call PutGetFinalPhases(2, nset, fig)
*            call examin(i, mkang, khl, ipub, iphaz, nrefl,0,wt,1)
*         enddo
*     endif
!
!
!

      nSetsFineDSR_Sav = nSetsFineDSR
*??*  do i=1, nsetFinalPhases
!???! do i=1, 1
         i = setMR
!ORIG!   i = 1

!!!!!      i = nSetBest

         if (BatchCAB == 1) then
             FichierOut = nome(1:lnome) //'_remo.pdb'
!            write(stringa,"('_',i4)") nSetsFineDSR
             write(stringa,"('_',i4)") iposFineDSR(i)
             call NoBlanks(stringa,k1)
             FileIn_1 = nome(1:lnome) //'_remo'// stringa(1:k1) //'.pdb'
             call cCopyFile(FileIn_1, FichierOut)
         else
             FichierOut = nome(1:lnome) //'_nautilus_prev.pdb'
         endif

         if (ifImproveMR /= 0) then
             if (knw > 0) then
                 write(lo,90) 
c                write(lo,80) '  +++  IMPROVE PROCEDURE  +++'
                 write(lo,85)
                 write(lo,80) Msg(1:Lung(Msg))
             endif
             if (ifREFMAC == 1 .and. knw > 0) then
                 write(lo,95) FichierOut(1:Lung(FichierOut))
                 write(lo,90) 
             endif
         else
             cardImage = nome(1:lnome) // '_improved.pdb'
             call cCopyFile(FichierOut, cardImage)
         endif
         if (BatchCAB == 1) then
             nset = iposFineDSR(i)
!!!          nset = nSetBest 
             call PutGetFinalPhases(2, nset, fig)
             numbrun = fig(1)
         endif
!
      nbru = 10
      izero = 0
      ifmin = 1
      call examin(nbru, mkang, khl, ipub, iphaz, nrefl,izero,wt,ifmin)
      ifVLD = 0
      kQuantiSets = 1
      numbGenLoc = numbGen
      numbGen = 0
      stampaMTZ = 0
      if (BatchCAB == 1) then
          call WriteMTZ(1, 0, kQuantiSets, stampaMTZ,ier)
          numbGen = numbGenLoc
      else
         cardDiret = nome(1:lnome) // '_remo.mtz'
         call WriteMTZ_Express(1, 0, cardDiret, ier)
      endif
!
*     FileIn_2 = nome(1:lnome) // '_remo.mtz'
*     FileOut_2 = nome(1:lnome) // '_remo' // stringa(1:k1) //'.mtz'
*     call cCopyFile(FileIn_2, FileOut_2)
!

      if (knw == 1) then
c         nbru = 10
c         izero = 0
c         ifmin = 1
c         call examin(nbru, mkang, khl, ipub, iphaz, nrefl,
c    *               izero,wt,ifmin)
c         call Trasla_Origine(nrefl)
          nbru = 20
          izero = 0
          ifmin = 1
          call examin(nbru, mkang, khl, ipub, iphaz, nrefl,
     *                izero,wt,ifmin)
          write(6,37) erore
          MPEvet(1) = erore
c
          tirang = 'REMO  Wt.'
          izero = 0
          ipher = 1
          call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
     *                ipub,iphaz,wt,10,0.0,ipher)
      else
          erore = 0
      endif
!
!--TEST
!
!
      go to 77

      call CheckMtzMpe(segno)
      if (knw == 1) then
          nbru = 20
          izero = 0
          ifmin = 1
          call examin(nbru, mkang, khl, ipub, iphaz, nrefl,
     *                izero,wt,ifmin)
          write(6,37) erore
          MPEvet(1) = erore
c
          tirang = 'REMO  Wt. 2'
          izero = 0
          ipher = 1
          call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
     *                ipub,iphaz,wt,10,0.0,ipher)
      else
          erore = 0
      endif

   77 continue
!
!
 
c     if (LowRes == 1) then
c         call EstendiMR
c     endif
 
!
!--FINE TEST
!
      VettRisultati(1) = erore
      if (numbGen > 0) then
          iphaz(nrefl+1:) = 0
          wt(nrefl+1:) = 0
      endif
      ier = 0
      ifBreak = 0
!
      if (ifSoloMR == 0) then
          exposigma=1
          ifPostDSR = 0
          ifReduced = 0
          f000=0
          call Calcola_FinalFom_PostMR(0)
          if (knw == 1) then
              write(6,*) 'Current dopo REMO ',CCEoEc(1:2),FOMs(2,4)
              write(6,15) FinalFom,erore,erorepes
          endif
      else
          ifImproveMR = 0
          ifRicicla = 0
          ifPhD = 0
          ifAmbMR = 0
          BatchCAB = 0
          maxBatchCAB = 0
!         kWstop 
          return
      endif

!
      if (ifImproveMR == 0) then
          statoMR = 7 ! per AMB Finale
          return
      else
          iesImpr = 1
      endif

c     if (ifImproveMR > 0) then
!
c     if (idSeq < 0.4) then
      if (idSeq <= idSeqThre) then   ! TEST 12 settembre
          call SistemaPDB   ! taglia i residui degli estremi (utile per REFMAC e COOT)
      else
!           if (CCEoEc(1) > 0.35 .and. CCEoEc(1) < 0.5) then
!               if (preMutazioniReq == 0) preMutazioni = 1
!               nuovoBl = 0 !1
!           else if(CCEoEc(1) < 0.35) then
!               if (preMutazioniReq == 0) preMutazioni = 3
!               nuovoBl = 0 !3
!           endif
      endif
!
      box = lastBox
      if (ifImproveMR /= 0 .and. jscreen > 0) then
          call AppendiPixmap(1)
          call ResettaWhiteBoard
          box = lastBox
          call MRInfo(6)  
          Msg = '<big><b>Improving MR results</b></big>'
          HTMLstr = Msg
          call MRInfo(98)  
          call TestoGR(Msg, color_RED, 2, box)
          call scrper('Improving MR results ...',0,-1)
          if (ifFreeLunchMR_Sav == 0) then
              Msg = 'Molecular Replacement results will be improved'
     *              // ' using ' !VLD'
          else
              Msg = 'Molecular Replacement results will be improved'
     *              // ' using VLD and Free Lunch'
          endif
          Msg = 'Molecular Replacement results will be improved using '
          write(lo,*) ' '
          write(lo,'(7x,a)') Msg(1:Lung(Msg))
          HTMLstr = Msg
          call MRInfo(99)
          call TestoGR(Msg, -1, 2, box)
          Msg = 'VLD'
          L = Lung(Msg)
          if (ifFreeLunchMR_Sav /= 0) then
              Inte = ', Free Lunch'
              Msg(L+1:) = Inte
          endif
          L = Lung(Msg)
          if (ifREFMAC == 1) then
              Inte = ', Refmac'
              Msg(L+1:) = Inte
          endif
          L = Lung(Msg)
          write(lo,'(7x,a)') Msg(1:Lung(Msg))
          grufle = Msg
          if (ifAmbMR > 0) then
              if (ifAmbMR == 1) Inte = ', Buccaneer'
              if (ifAmbMR == 2) Inte = ', ARP/wARP'
              if (ifAmbMR == 3) Inte = ', Phenix'
              if (ifAmbMR == 4) Inte = ', Nautilus'
              Msg(L+1:) = Inte
          endif
          HTMLstr = Msg
          call MRInfo(99)
          call TestoGR(Msg, -1, 2, box)
          if (ifAmbMR > 0) then
              grufle(L+1:) = ' are used to improve ' //
     *                  Inte(3:Lung(Inte)) // ' phases.'
          else
              grufle(L+1:) = ' are used to improve phases.'
          endif

*         if (ifAmbMR > 0) then
*             if (ifAmbMR == 1) HTMLstr = 'Buccaneer'
*             if (ifAmbMR == 2) HTMLstr = 'ARP/wARP'
*             if (ifAmbMR == 3) HTMLstr = 'Phenix'
*             if (ifAmbMR == 4) HTMLstr = 'Nautilus'
*             L = Lung(HTMLstr)
*             HTMLstr(L+1:) = ' will be used in this step'
*             call MRInfo(99)
*             call TestoGR(HTMLstr, -1, 2, box)
*         endif
      endif
!
      call zflush
      call DoSingleIteration()
      call zflush
      call DoSingleIteration()
!
      nRefi = nRefmacCycles
      write(lo,90)
      if (nRefi >= 0 .and. ifREFMAC == 1) then
          if (ricAMB == 1) then
              write(lo,96) FichierOut(1:Lung(FichierOut)), nRefi
          else
              if (ifDNA == 1) then
                  write(lo,96) FichierOut(1:Lung(FichierOut)), nRefi
              else
                  if (idSeq > idSeqThre) then
                      write(lo,96) FichierOut(1:Lung(FichierOut)), nRefi
                  else
                      write(lo,97) FichierOut(1:Lung(FichierOut)), nRefi
                  endif
              endif
          endif
!
!-- re-compute phases, fc, wt using refmac
!
          Msg = 
     *      'Refining the MR model using Refmac, VLD and Free Lunch ...'
*         call TestoGR(Msg, -1, 2, box)
          call scrper(Msg,0,-1)
          numbGenLoc = numbGen
          numbGen = 0
!
          allocate(FC_refmac(1:nrefl), stat=ier)
          allocate(PH_refmac(1:nrefl), stat=ier)
          allocate(WT_refmac(1:nrefl), stat=ier)
!
          call zflush
          call DoSingleIteration()
!
          statoMR = -1
!
!-- NEW

          FasiPerRefmac = -1

!-- PEZZA 
          if (idSeq <= idSeqThre) then
              nRefi = nRefmacCycles * 2
          endif

          ciclaRefmac = 1

          if (idSeq < idSeqThre) then
              icicAMB = 0
              sav1 = icicAMB
              sav2 = preMutazioni
              sav3 = ifMutate
              sav4 = statoMR
              ifMutate = 1
              statoMR = 0
              icicAMB = 1
              soft = 1
              call Improve_PKG(VettRisultati, icicAMB,
     *                  ifExit, FFom_S, RfacAW_S, RfreAW_S, soft, stepS)
              icicAMB = sav1
              preMutazioni = sav2
              ifMutate = sav3
              statoMR = sav4
          endif
          nRefi = 15 ! NEW
!ORI      call UseRefmacN(nRefi, 0, nMacroRef, ier)
*         call DoRemoDsr(VettRisultati)  !PROVA
*         call NewRefmac(nRefi, 0, nMacroRef, ier) ! 17 luglio 2019
*         ifSkip = 1        ! attivare x versione 26 giugno (anche sopra)

!-- PEZZA 
          nRefi = nRefmacCycles

          fcvetp(1:nrefl) = fcvet(1:nrefl)

          exposigma=1
          ifPostDSR = 0
          ifReduced = 0
          f000=0
          call Calcola_FinalFom_PostMR(0)
          FinalFom_1=FinalFom
          if (knw /= 0) then
c             write(6,*) 'FinaFom1 prima MUTATE0',FinalFom,' per ',erore
              write(6,40) 
     *                  FinalFom,FOMs(2,5),RfacAW,RfreAW,erore,erorepes
          endif

          fcvet(1:nrefl) = fcvetp(1:nrefl)
          iact = 0
          call Select_Refl_MR(iact)

          call PutGetFinalPhases(1, nset, fig)
          VettRisultati(2) = erore
          numbGen = numbGenLoc

      endif

!
c     if (ifFreeLunchMR_Sav == 0) then
c         Msg = 'Molecular Replacement results will be improved' //
c    *              ' using VLD'
c     else
c         Msg = 'Molecular Replacement results will be improved' //
c    *              ' using VLD and FreeLunch'
c     endif
c     write(lo,80) Msg(1:Lung(Msg))
c     call TestoGR(Msg, -1, 2, 3)
!
!
      call scrper(
     *  'Improving MR results using Refmac, VLD and Free Lunch...',0,-1)
!
      rhomax = maxval(rhov(1:nreflDim))
!
      if (ifMutate == 1) then
          cicliMut = 1000
          MutateOn = .true.
      else
          cicliMut = preMutazioni
      endif
      nMutated_prev = 1
!
!-- statoMR = 0 mutazione residui simili - ALANIZZAZIONE
!-- statoMR = 6 inizio procedura amb (Nuovo Blocco)
!-- statoMR = 7 procedura amb
!-- statoMR = 9 fine procedura
!
      icicAMB = 0   
      if (ifSkip == 0) then
          soft = 0
          call Improve_PKG(VettRisultati, icicAMB,
     *                  ifExit, FFom_S, RfacAW_S, RfreAW_S, soft, stepS)
      endif
!
!???! enddo
*??*  enddo   ! i=1, nsetFinalPhases

c     endif  ! ifImproveMR

      statoMR = 7 ! per AMB Finale
      MutateOn = .false.
***** HydroRefmac = .true.
      ifVLD = 0
      if (ifAmbMR == 0) then
          kQuantiSets = nSetsFineDSR
      else
          kQuantiSets = 1
      endif
!
      nGenSav = numbGen
      numbGen = 0
!
      stampaMTZ = 0
      call WriteMTZ(1, 0, kQuantiSets, stampaMTZ, ier)

!-- dedi per recuperare il set di fasi con la migliore Fom
      nset = iposFineDSR(1)
c     write(6,*) ' +++ PROVA NSET +++ ',nset
      call PutGetFinalPhases(2, nset, fig)
      if (knw > 0) then
          nbru = 30
          izero = 0
          ifmin = 1
          call examin(nbru, mkang, khl, ipub, iphaz, nrefl,
     *               izero,wt,ifmin)

          tirang = 'REMO  Wt.'
          izero = 0
          ipher = 1
          call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
     *             ipub,iphaz,wt,10,0.0,ipher)
      endif
!
      numbGen =  nGenSav
!
      if (allocated(FC_refmac)) then
          deallocate(FC_refmac, PH_refmac, WT_refmac, stat=ier)
      endif
!
!     call AllocaMapTest(2)

      return
   10 format(a,'_',i5,'_PattVLD.txt')
   15 format(' FinalFom dopo REMO',f8.3,'  MPE ',2f8.2)
   25 format('TESTVETB ',';',f6.2,' ;',6(i3,' ;'))
   26 format('IMPROVE: VLD   ',f8.2,' ; PreMutazioni #',i4,
     *       ' FFom2 =',f8.3,' Rf =',f8.3,' Rfree =',f8.3)
   27 format('IMPROVE: VLD   ',f8.2,' ; Mutazione #',i4,
     *       ' FFom2 = ',f8.3,' Rf =',f8.3,' Rfree =',f8.3)
   28 format('IMPROVE: VLD   ',f8.2,' ; PreMutazioni #',i4,
     *      ' FFom2 = ',f8.3,' Rf =',f8.3,' Rfree =',f8.3,' Rejected !')
   29 format('IMPROVE: VLD   ',f8.2,' ; Mutazione #',i4,
     *      ' FFom2 = ',f8.3,' Rf =',f8.3,' Rfree =',f8.3,' Rejected !')
   36 format('IMPROVE: VLD   ',f8.2,' ; NUOVO Blocco #',i4,
     *       ' FFom2 = ',f8.3,' Rf =',f8.3,' Rfree =',f8.3)
   38 format('IMPROVE: VLD   ',f8.2,' ; NUOVO Blocco #',i4,
     *       ' FFom2 =',f8.3,' Rf =',f8.3,' Rfree =',f8.3,' Rejected !')
   37 format('REMO MPE ',f8.2,' ;')
   30 format('    Final FOM: ',f6.3)
   40 format('IMPROVE: REFMAC FOM: ',4x,4f8.3,2f8.2)
   50 format('IMPROVE: VLD    FOM: ',i4,4f8.3,2f8.2)
   80 format(/,' ',a)
   85 format(/,
     * '  +++  Phase extension to all measured reflections and  +++',/,
     * '  +++     initial phase refinement via edm procedure    +++')
   90 format(/,80('-'))
   95 format(/,'  The model to be improved is in the file ',a)
   96 format(/,'  The model ',a,' will be improved',/,
     *         '  using VLD and Refmac Phases-Driven ',
     *         '(batches of ',i2,' cycles)',/)
   97 format(/,'  The model ',a,' will be improved',/,
     *         '  using VLD and Refmac Phases-Driven ',
     *         '(batches of ',i2,' cycles), first step',/)
  100 format(/,' After VLD: Final FOM =',f8.3)
  110 format(' After VLD: Final FOM =',f8.3,' Rejected !')
!
   21 format('IMPROVE: INIZIO AMB',f8.2,' ;  FFom2 =',f8.3,
     *       ' Rf =',f8.3,' Rfree =',f8.3)
   23 format('IMPROVE: INIZIO VLD+FL',f8.2,' ;  FFom2 =',f8.3,
     *       ' Rf =',f8.3,' Rfree =',f8.3)
  261 format('IMPROVE: AMB    FOM:'4x,4f8.3,2f8.2)

  200 format('After  VLD-Free Lunch: Final FOM =',f8.3)
  201 format('After  VLD: Final FOM =',f8.3)
  202 format('After  AMB: Final FOM =',f8.3)
  244 format('After  VLD-Free Lunch: Final FOM =',f8.3, ' Rejected')
  245 format('After  VLD: Final FOM =',f8.3, ' Rejected')
  233 format('Before VLD-Free Lunch; Final FOM =',f8.3)
!
      end
!-----------------------------------------------------------------------
      subroutine EstendiMR
      USE General
      USE Riflessi
      USE Molcom
      USE PhaseModule
      USE PhMod
      USE RemoModule, only : ifFreeLunchMR
      USE RuotaRiflessi, only: nreflSelTra
!
      implicit none
      integer :: i, ier, izero, ipher, nRefi, NREFMAC, Action, n
      integer :: ifRemoSav
      real    :: vettoreRis(10), soglia
      character (len=11) :: tirang
!
*Test1nRefi = 0
*Test1NREFMAC = nRefi
*Test1cardImage = cardDiret
*Test1FichierOut = nome(1:lnome) // '_remo.pdb'
*Test1call UseRefmac(FichierOut, nRefi, 0, NREFMAC, 0, ier)
*Test1call examin(0, mkang, khl, ipub, iphaz, nrefl, 0,wt,1)
*Test1tirang = 'Refmac Dist'
*Test1izero = 0
*Test1ipher = 1
*Test1call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
*Test*                ipub,iphaz,wt,10,0.0,ipher)
!
      ifRemoSav = ifRemo
      call  AllocaPhantom(1)
!
      do i=1, nrefl
         wt(i) = wt(i) ** 1.2
      enddo
!
      Pub_Target(:) = ipub(:)
      Pesi_MR(1:nrefl) = wt(1:nrefl)
      Fasi_MR(1:nrefl) = iphaz(1:nrefl)
      ModificaNp = .true.
      cicloMut = 1
      call Cicla_LOW(0)
      ifMixEdm = 0

      call UpdateMAD(1)
*Test1if (numbGen > 0) then
*Test1    ifFreeLunchMR = 1
*Test1    call Init_Canalizzazione()
*Test1endif
!
      Fcvet_MR(:) = fcvet(:)
      ifTime = 0
*     if (LowRes == 0) then
*         call Cicla_PHA
*     else
*         call Cicla_LOW(1)
*         ifPhantom = 1
*     endif

      go to 10
      do i=1, 1
         call Cicla_VLD(1, 0, 0, vettoreRis)
      enddo
      call examin(18, mkang, khl, ipub, iphaz, nrefl, 0, wt ,0)
      tirang = 'Dopo 1 VLD '
      izero = 0
      ipher = 1
      call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
     *         ipub,iphaz,wt,10,0.0,ipher)
      go to 10
!
!-- seleziona 1.7 nreflSelTra riflessi e richiama rfmac phase driven
!
     
      n = 1.7 * float(nreflSelTra)
      write(6,*) 'NREFLSELTRA ', nreflSelTra
!
!-- selezione riflessi
!
      do i=1, nrefl
         jwork1(i) = i
         work1(i) = wt(i)
      enddo
      call sort3_big(work1, jwork1, worko, nrefl)
      soglia = worko(n)
      if (knw == 1) then
          write(6,*) 'NUMERO PESI SEL ', n
          write(6,*) 'SOGLIA ', soglia
      endif
      do i=1, nrefl
         if (wt(i) < soglia) then
             wt(i) = 0.0
         endif
      enddo
      tirang = '1.7 reflTra'
      izero = 0
      ipher = 1
      call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
     *         ipub,iphaz,wt,10,0.0,ipher)
!
!-- Refmac phase driven
!
      Action = 1
      nRefi = 2
      call ApplicaRefmac(Action, nRefi)

      call examin(18, mkang, khl, ipub, iphaz, nrefl, 0, wt ,1)
      if (knw == 1) then
          write(6,199) erore, erorepes, isumal
      endif
!
      fcvet(:) = Fcvet_MR(:)
!
   10 ifRemo = ifRemoSav
      call  AllocaPhantom(2)
*Test1ifFreeLunchMR = 0
!
      return
  199 format(/,' Free Lunch ends - Mean Phase Error',f6.2,' (',f6.2,
     *       ')  over ',i7,' reflections',/)
      end
!-----------------------------------------------------------------------
      subroutine Improve_PKG(VettRisultati, icicAMB,
     *                  ifExit, FFom_S, RfacAW_S, RfreAW_S, soft, stepS)
      USE General
      USE Riflessi
      USE Molcom
      USE PhaseModule
      USE Mappa
      USE HistoStuff
      USE VLDmod, only : sog_sigmaA, n_Maxrun
      USE ArpWarp
      USE RemoModule
      USE Align
      USE TestModel, only : CaOnly
      USE Param , only :f000  
*     USE PhMod, only: Fasi_MR
*     USE FasiEDM
!
      implicit none
      integer :: i, j, k, ier, nset, ksubr, ifBreak, nsetFinalPhases
      integer :: istat, iform, jopen, kQuantiSets, jhk(3), ifSem, nsem
      integer :: numestrefCow, ifFromGraphic, ii, nRefi, Lung, jop
      integer :: iPlotTypeSWRC, nbru, izero, ifmin, modulo_sir, numb
      integer :: ifVLDs, cicliMut, nMutated, nAggiunti, nMacroRef
      integer :: kStripTask1, nMutated_prev, deleted, nGenSav, ifEmm
      integer :: maxGap, numbGenLoc, Max_icy, ifExit, iact, soft, stepS
      integer :: SaveAmb, doRicicla, stampaMTZ, nMutatedtot, rMTZ
      integer :: icic, idsr, totdsr, ifVLDSav, L, ipher, ijij, jiji
      integer :: ij, ji, iii, jjj, jpatt, jflag, numb_accept, ncond1
      integer :: nSetsFineDSR_Sav,iai,icicAMB,numbAMB,stampaInfo, sav
!cristina
      integer :: num_35
      logical :: continua, isOk
      real    :: sog, sog_res, sog_wt, zero, f000_back, wtMin
      real    :: smax, erreSav, perc, sMR
      real    :: FFom_S, RfacAW_S, RfreAW_S, deltaRfAW, ssogg
      real    :: correl, fig(11)
      real    :: VettRisultati(10)
      real    :: coefOld, phOld, wtOld, coefNew, phNew, wtNew
      real    :: TangNum, TangDen, ww, bes, MPEvld, MPErefmac
      character (len=11) :: tirang
      character (len=256) :: MTZfileSav, MTZrecycle
      character(len=256) :: FileIn_1, FileOut_1, FileIn_2, FileOut_2
      character(len=256) :: FileIn_3, FileOut_3
      common /fasi/ nset

!cristina
      common/cristina/ RfacPH
      real :: RfacPH

      integer, allocatable :: FasiCombinazione(:)
      real, allocatable    :: PesiCombinazione(:)

*     write(6,*) 'SOFT,ICICAMB,steps ', soft,icicAMB,stepS
*     call cstop('stop in Improve_PKG ')
      if (icicAMB > 0 .and. knw > 0) then
          write(lo,85) '  +++  RECYCLE IMPROVE PROCEDURE  +++'
          write(lo,*)
      endif
!
      zero = 0.000001

!
      nMacroRef = 2
      nRefi = nRefmacCycles
      perc = float(nAllinea) * 0.05
      statoMR = -1

      maxGap = 0
      erreSav = erre
      ifEmm = 0
      isOk=.true.
      ifExit = 0 

      fig(3) = FinalFom
      FFom_S = fig(3) 
      RfacAW_S = RfacAW
      RfreAW_S = RfreAW

      if (icicAMB > 0) then
          allocate (FasiCombinazione(1:nrefl), stat = ier)
          allocate (PesiCombinazione(1:nrefl), stat = ier)
          FasiCombinazione(1:nrefl) = iphaz(1:nrefl)
          PesiCombinazione(1:nrefl) = wt(1:nrefl)

          nbru = 110
          izero = 0
          ifmin = 1
          call examin(nbru, mkang, khl, ipub, FasiCombinazione, nrefl,
     *                  izero,PesiCombinazione,ifmin)

      endif

! -- !!!  INIZIO PACCHETTO PREMUTAZIONI (PKG) !!!

      if (soft == 0) then
          cicliMut = preMutazioni
          cicliMut = 16
          nuovoBl = 0
          ifMutate = 0
*         cicliMut = 1
      else
          cicliMut = 14
          preMutazioni = cicliMut
          nuovoBl = 5
*         cicliMut = 1
*         nuovoBl = 1
      endif

      if (BatchCAB > 1) then
          cicliMut = 4
      endif

! TEST TEST FAST
*     cicliMut = 1
!cristina
      RfacPH = 0.0

*     allocate(Fasi_EDM(1:nrefl), stat=ier)
*     allocate(Pesi_EDM(1:nrefl), stat=ier)
*     BestEdmFom = -9999

      if (stepS == 1) then
          stepS = stepS + 1
      else
          write(lo,7)
      endif
      write(lo,10)
      do cicloMut=1, cicliMut
!
*        if (cicloMut > 1) then
             if (LowRes == 1) then
                 call DoRemoDsr(VettRisultati)
             else
                 call Cicla_HI(0)
             endif
             MPEvld = erore
             if (knw == 1) then
                 write(6,50)
     *                 FinalFom,FOMs(2,5),RfacAW,RfreAW,erore,erorepes
*            else
*                write(lo,100) cicloMut, FinalFom, RfacAW, RfreAW
             endif
*        endif

         iact = 1
         iact = -1

cprova              if (FinalFom < fig(3)) then
cprova                 ifExit = 1
cprova              endif

         if (ifExit == 0 ) then

             fig(1) = numbrun
             fig(3) = FinalFom
             FFom_S = fig(3) 
             RfacAW_S = RfacAW
             RfreAW_S = RfreAW
!
             if (knw > 0) then
                write(lo,25) resol_obs_max , nint(VettRisultati(1:6))
                if (cicloMut <= preMutazioni) then
                    write(lo,26) erore, cicloMut, FinalFom, 
     *                           RfacAW, RfreAW
                else
                    write(lo,27) erore, cicloMut, FinalFom, 
     *                           RfacAW, RfreAW
                endif
             endif
!
             ifVLD = 0
!
             nGenSav = numbGen
             numbGen = 0
             kQuantiSets = nSetsFineDSR
!
             call PutGetFinalPhases(1, nset, fig)
!
         else

             if (knw > 0) then
                write(lo,25) resol_obs_max , nint(VettRisultati(1:6))
                write(lo,28) erore, cicloMut, FinalFom, 
     *                       RfacAW, RfreAW
             endif

!
             ifVLD = 0
!
             nGenSav = numbGen
             numbGen = 0
             kQuantiSets = nSetsFineDSR
!
             call PutGetFinalPhases(2, nset, fig)

         endif   ! ifExit = 0
!
         stampaMTZ = 0
         call WriteMTZ(1, 0, kQuantiSets, stampaMTZ, ier)

         MTZfileSav = MTZfile

 
         FasiPerRefmac = 0
         ciclaRefmac = 0

!!!! PROVA !!!!
c        ciclaRefmac = 1
!!!! PROVA !!!!

         if (cicloMut == 16) then
*            anisoRef = .true.
         endif
         call UseRefmacN(nRefi, 0, nMacroRef, ier)
         if (knw > 0) then
             write(6,'(a,2f8.4)') 'IMPROVE_PKG R ', RfacAW, RfreAW
         else
            write(lo,100) cicloMut, FinalFom, RfacAW, RfreAW
         endif
         RfacSynergy = RfacAW
         RfreSynergy = RfreAW
*        anisoRef = .false.

         exposigma=1
         ifPostDSR = 0
         ifReduced = 0
         f000=0
         call Calcola_FinalFom_PostMR(0)
         FinalFom_1=FinalFom
         if (knw /= 0) then
             write(6,*) 'FinaFom1 prima MUTATE0',FinalFom ,
     *                      ' per ',erore
             if (knw == 1) write(6,40) 
     *           FinalFom,FOMs(2,5),RfacAW,RfreAW,erore,erorepes
         endif
!cristina
             nbru = 30
             izero = 0
             ifmin = 1
             call examin(nbru, mkang, khl, ipub, iphaz, nrefl,
     *                  izero,wt,ifmin)
             MPErefmac = erore
             tirang = 'Post REFMAC'
             izero = 0
             ipher = 1
             call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
     *                ipub,iphaz,wt,10,0.0,ipher)
!cristina
             if (knw > 0) then
                 write(6,*) 'GIANLUCA ', RfacAW, minval(wt(1:nrefl))
             endif
             if (RfacAW < 0.35 .and. ifCristina == 1 .and. knw > 0) then
             write(lo,'(a)') ' Rfac < 0.35 => wt < 0.25 => wt = 0.25 '
             RfacPH = RfacAW
             if (minval(wt(1:nrefl)) < 0.25) then
                 wtMin = 0.15
                 num_35 = 0
                 do ij = 1,nrefl
                     if (wt(ij) < wtMin) then
                         num_35 = num_35 + 1
                        wt(ij) = wtMin
                     end if
                 end do
                 write (lo,'(a,i6)')' num_35 - REFMAC = ',num_35
             endif
             nbru = 30
             izero = 0
             ifmin = 1
             call examin(nbru, mkang, khl, ipub, iphaz, nrefl,
     *                  izero,wt,ifmin)
             tirang = 'Post R<0.35'
             izero = 0
             ipher = 1
             call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
     *                ipub,iphaz,wt,10,0.0,ipher)
         end if
!!!!     call Select_Refl_MR(0)


         numbGen = nGenSav
         MTZfileSav = MTZfile
!
      enddo  ! cicli di mutazione
!
      if (icicAMB > 0) then
         deallocate (FasiCombinazione, PesiCombinazione, stat = ier)
      endif

*     iphaz(1:nrefl) = Fasi_EDM(1:nrefl)
*     wt(1:nrefl) = Pesi_EDM(1:nrefl)
*     deallocate(Fasi_EDM, Pesi_EDM, stat=ier)
*     if (knw /= 0) then
*         call examin(88, mkang, khl, ipub, iphaz, nrefl,0,wt,1)
*     endif
*     write(6,777) 'BEST PHASES', MPEvld, MPErefmac, erore, BestEdmFom
* 777 format(a,2x,3f8.2,f9.4)
      if (knw > 0) then
          write(6,777) 'BEST PHASES', MPEvld, MPErefmac
      endif
!
      ifVLD = 0
!
      nGenSav = numbGen
      numbGen = 0
      kQuantiSets = nSetsFineDSR
!
      call PutGetFinalPhases(1, nset, fig)
      numbGen = nGenSav
!
!- controllo se Rfree < 0.4 dopo PreMutazioni e vado in AMB   !!!  DA GESTIRE
!
      if (RfreAW < 0.4) then
          ifMutate = 0
          statoMR = 7
          ifExit = 1
      else
          statoMR = 0
      endif
!
      if (ifMutate == 1 .and. statoMR == 0) then
          isOk=.true.
          ifVLDs = ifVLD
          ifVLD = 0
!!!!!     FasiPerRefmac = 0   !dedi 27/4/2016
          FasiPerRefmac = 1   !no Phases-Driven
          ciclaRefmac = 1

          call AlanizzaBterm(nMutated)
          if (nMutated < nint(perc)) then
              nMutated = 0
          endif
          if(nMutated==0)isOk=.false. 
          nMutated_prev = nMutated
          ifVLD = ifVLDs
      endif
!
      InfoOK(15) = 0
      erre = erreSav
!
      if (statoMR < 7) then
          statoMR = 6
      endif
!
!-- per saltare Nuovo VLD-EDM + Refmac --> statoMR = 7
!
      if (statoMR == 6 .and. nuovoBl > 0) then

          if (knw > 0) then
              write(lo,*) ''
              write(lo,*) ' +++   Nuovo VLD-EDM + Refmac   +++'
              write(lo,*) ''
          endif

          ifExit = 0

!
c         nuovoBl = 2
          sav = statoMR
          statoMR = -1
          write(lo,8) 
          write(lo,10)
          do icic = 1,nuovoBl
!
             call DoRemoDsr(VettRisultati)

             if (knw == 1) then
                 write(6,50)
     *             FinalFom,FOMs(2,5),RfacAW,RfreAW,erore,erorepes
             else
                 write(lo,100) icic, FinalFom, RfacAW, RfreAW
             endif

             iact = 1
             iact = -1
             if (iact < 0) goto 222

             if (icicAMB == 0) then  !goto 222
!!!      goto 222

                 fcvetp(1:nrefl) = fcvet(1:nrefl) 

                 do jiji = 1,nrefl

                    if (wt(jiji) < 0.05) then
                        wt(jiji) = 0.05
                    else
                         wt(jiji) = wt(jiji)**0.85
                    endif

                    if (fcvet(jiji) < zero) then
                        fcvet(jiji) = 0.0
                    endif
                            
                 enddo !jiji

                 call Select_Refl_MR(iact)

             endif  !goto 222
 222  continue

!
                 fig(3) = FinalFom
                 FFom_S = fig(3) 
                 RfacAW_S = RfacAW
                 RfreAW_S = RfreAW
!
                 call PutGetFinalPhases(1, nset, fig)

                 ifVLD = 0
                 kQuantiSets = 1
                 numbGenLoc = numbGen
                 numbGen = 0
!
                 stampaMTZ = 0
                 call WriteMTZ(1, 0, kQuantiSets, stampaMTZ, ier)
                 numbGen = numbGenLoc

!
                if (knw > 0) then
                    write(lo,25) resol_obs_max, nint(VettRisultati(1:6))
                    write(lo,36) erore, icic, FinalFom,
     *                                        RfacAW, RfreAW
                endif
 
                 FasiPerRefmac = 0

!ORI             ciclaRefmac = 1  !!! <--
                 ciclaRefmac = 0

                 call UseRefmacN(nRefi, 0, nMacroRef, ier)

                 exposigma=1
                 ifPostDSR = 0
                 ifReduced = 0
                 f000=0
                 call Calcola_FinalFom_PostMR(0)
                 if (knw == 1) write(6,40)
     *              FinalFom,FOMs(2,5),RfacAW,RfreAW,erore,erorepes

          enddo  ! nuovoBl
          statoMR = sav
!

      endif  ! statoMR = 6
!
*     if (ifDNA == 1000) then
*         write(6,*) 'prima di AggiungiPesanti FichierOut ',
*    *               FichierOut(1:Lung(FichierOut))
*         call AggiungiPesanti
*         call Phosphate
*     endif
!
*     call cstop('fine aggiungi')

      return

    7 format(/,' Model improvement, third step',/)
    8 format(/,' Model improvement, second step',/)
   10 format('  Synergy cycle  VLD Fom  R factor   R free')
   25 format('TESTVETB ',';',f6.2,' ;',6(i3,' ;'))
   26 format('IMPROVE: VLD   ',f8.2,' ; PreMutazioni #',i4,
     *       ' FFom2 =',f8.3,' Rf =',f8.3,' Rfree =',f8.3)
   27 format('IMPROVE: VLD   ',f8.2,' ; Mutazione #',i4,
     *       ' FFom2 =',f8.3,' Rf =',f8.3,' Rfree =',f8.3)
   28 format('IMPROVE: VLD   ',f8.2,' ; PreMutazioni #',i4,
     *       ' FFom2 =',f8.3,' Rf =',f8.3,' Rfree =',f8.3,' Rejected !')
   29 format('IMPROVE: VLD   ',f8.2,' ; Mutazione #',i4,
     *       ' FFom2 =',f8.3,' Rf =',f8.3,' Rfree =',f8.3,' Rejected !')
   36 format('IMPROVE: VLD   ',f8.2,' ; NUOVO Blocco #',i4,
     *       ' FFom2 =',f8.3,' Rf =',f8.3,' Rfree =',f8.3)
   38 format('IMPROVE: VLD   ',f8.2,' ; NUOVO Blocco #',i4,
     *       ' FFom2 =',f8.3,' Rf =',f8.3,' Rfree =',f8.3,' Rejected !')
   30 format('    Final FOM: ',f6.3)
   40 format('IMPROVE: REFMAC FOM: ',4x,4f8.3,2f8.2)
   50 format('IMPROVE: VLD    FOM: ',4x,4f8.3,2f8.2)
   80 format(/,' ',a)
   85 format(/,10x,a,i4,a)
   90 format(/,80('-'))
  100 format(7x,i3,4x,f9.3,2x,f8.4,2x,f8.4)
  110 format(' After VLD: Final FOM =',f8.3,' Rejected !',/)
  777 format(a,2x,3f8.2,f9.4)
!
      end
!-----------------------------------------------------------------------
      subroutine AggiungiPesanti(erre2, erref2, errore2, pCA, pAT)
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
      USE Atomi
      USE Mappa
      USE Param
      USE RemoModule
      USE ArpWarp
      USE Groups
      USE PhMod
      USE Molcom
      USE TestModel
!
      implicit none
      integer :: i, j, k, ipher, natsPDB, maxNatsPDB, sogHA, nHA, ier
      integer :: HeavyInPDB, HAvet(8), nzvet(8), numb, nset, jj, kkk
      integer :: iflagPKS, mode, kt, ifAmbS, Box_CAB, Lung
      integer :: nMacroRef, nRefi, ifCABsav, pCA, pAT
      integer :: itype, iform, jop, jopen, ios, maxNatsPDBsav
      real    :: x1(3), x2(3), xeq(3),dLimit, distmA, d, s(3)
      real    :: RFreeOld, RfreeMinAbs, fig(11), oldR, oldRf
      real    :: erre1, erre2, errore1, errore2, errore3, rapporto
      real    :: distCoordSav, xeqSav(3), erref2
      character (len=2) :: a1, a2
      character (len=11) :: tirang
      character (len=80) :: linea
      character(len=256) :: FichierOut_SAV
      common /fasi/ nset
!
      sogHA = 20
      if (ifAmb /= 4 .and. ifCAB == 0) then
          sogHA = 999
      endif
      if (ifCAB == 0) then
          sogHA = 999
      endif
      if (knw > 0) write(6,*) 'IFCAB', ifCAB

*     sogHA = 999


      if (knw > 0) write(6,*) 'IFAMB SOGHA', ifAmb, sogHA
*     sogHA = 2000   ! TEST noHA
      call ContaPesantiPDB(sogHA)
!
      cardImage = nome(1:lnome) // '_synergy.mtz'
      call cCopyFile(MTZfile, cardImage)
      if (BatchCAB == 1) then
          cardImage = nome(1:lnome) // '_synergy1.mtz'
          call cCopyFile(MTZfile, cardImage)
          if (knw > 0) then
              write(6,*) 'CREATO ', cardImage(1:Lung(cardImage))
          endif
      endif
      if (knw > 0) then
          write(6,*) 'MTZFILE ',MTZfile(1:Lung(MTZfile))
          write(6,*) 'COPIED MTZFILE ',MTZfile(1:Lung(MTZfile)),
     *               ' IN SYNERGY ',cardImage(1:Lung(cardImage))
      endif
      cardImage = nome(1:lnome) // '_improved_HA.mtz'
      call cCopyFile(MTZfile, cardImage)
      if (knw > 0) then
          write(6,*) 'COPIED MTZFILE ',MTZfile(1:Lung(MTZfile)),
     *               ' IN HA ',cardImage(1:Lung(cardImage))
      endif
!
      cardImage = nome(1:lnome) // '_heavy.pdb'
      if (knw > 0) then
          write(6,*) 'REMOVE ',cardImage(1:Lung(cardImage))
      endif
      itype = 2
      iform = 1
      jop =jopen(jgrap,cardImage,itype,iform,ios)
      if (jop >= 0) then
          if (knw > 0) write(6,*) 'YES'
          close(jgrap, status = 'delete')
      endif
      call InitFour(0, ier)
!
      NfNhNe(:) = 0
      linea = ' '
      FichierOut_SAV = FichierOut
      Inte = nome(1:lnome) // '_sav' // '.pdb'
      if (knw == 1) then
          write(6,1) FichierOut(1:Lung(FichierOut)),
     *               Inte(1:Lung(Inte))
      endif
      call cCopyFile(FichierOut, Inte)
!
      Inte = nome(1:lnome) // '_improved_HA.pdb'
      if (knw == 1) then
          write(6,1) FichierOut(1:Lung(FichierOut)),
     *               Inte(1:Lung(Inte))
      endif
      call cCopyFile(FichierOut, Inte)

      oldR  = RfacAW
      oldRf = RfreAW

      if (ifDNA == 1) then
          maxNatsPDB = 2 * nAcid
          maxNatsPDB = 4 * nAcid
          maxNatsPDB = float(25 * nAcid) * 1.2
      else
          maxNatsPDB = 20
      endif
      maxNatsPDBsav = maxNatsPDB
      allocate(xyzHeavy(5,1:maxNatsPDB), stat=ier)
      allocate(aLabHeavy(1:maxNatsPDB), stat=ier)
      allocate(IntModel(1:maxNatsPDB), stat=ier)
      IntModel(1:maxNatsPDB) = 0
      if (.not.allocated(Pub_target)) then
          call AllocaPhantom(1)
      endif

      do kkk=1, 2

         maxNatsPDB = maxNatsPDBsav

         nats_added_to_pdb = 0

         write(linea,80) Species(nk)(1:2), no(nk)
*        if (RfacAW > 0.35) return
         if (no(nk) >= sogHA) then
             ifHeavyAtom = .true.
         else
             jj = Lung(linea)
             linea(jj+2:) = 'NOT APPLIED'
             if (knw > 0) write(6,'(a)') linea(1:Lung(linea))
*            call cstop('fine aggiungi')
****         call AllocaPhantom(2)
             return
         endif

         if (kkk == 1) then
             write(lo,210)
         else
             write(lo,220)
         endif
   
         HeavyInPDB = 0
         nHA = 0
         HAvet(:) = 0
         if (knw /= 0) then
             call examin(88, mkang, khl, ipub, iphaz, nrefl,0,wt,1)
             tirang = 'Distr. Emap'
             ipher = 1
             call pherrdisNew(tirang,wt,khl,mkang,nrefl,0,
     *                       ipub,iphaz,wt,10,0.0,ipher)
         endif
         if (kkk == 1) then
             erre1   = RfacAW
             errore1 = erore
         endif
!
         do i=nk, 1, -1
            if (no(i) > sogHA) then
                nHA = nHA + 1
                HAvet(nHA) = float(nw(i)) / totop
                NfNhNe(2) = NfNhNe(2) + float(nw(i)) / totop
                if (knw /= 0) then
                    write(6,20) Species(i)(1:2),no(i),nint(nw(i)/totop)
                endif
                nzvet(nHA) = i
                HeavyInPDB = HeavyInPDB + float(nw(i)) / totop
            endif
         enddo


         call AllocaAtomi(2)
         call AllocaAtomi(1)
   
         f000 = 0
         fcoef(1:nrefl) = evet(1:nrefl) * wt(1:nrefl)
         call MakeMap(fcoef, iphaz, nrefl, 0, xmap, FORTH, BACK)
!
         if (kkk == 2) then
             call AltezzaPicchiModello(maxNatsPDB)
         endif
         call Holes(maxNatsPDB)
*        call CCP4MAPOUT(0, xmap, np, 'mappa_ccp4.map')
!
         nats = maxNatsPDB
         aperc(1) = maxNatsPDB
         ifFour = 1
         iflagPKS = 0
         mode = 0
         krecy = 0
         numb = nrefl
         ier = 0
         call pksrch_New(mode, iflagPKS, numb, ier)
         if (knw > 0) then
             write(6,*)
             write(6,*) ' Picchi dopo azzeramento gaussiane'
             write(6,*)
             write(6,48)
         endif
         j = 0
         do i=1, maxNatsPDB
            if (xyzs(4,i) > 10.0) then
                j = j + 1
                if (knw == 1) then
                  write(6,50) i, nint(xyzs(4,i)), xyzs(1:3,i), xyzs(5,i)
                endif
            endif
         enddo
         maxNatsPDB = j
         call AnalizzaHeavy(ifHeavyPDB, maxNatsPDB)
         nats = maxNatsPDB
         CaOnly = .false.
         if (knw > 0) then
             write(6,*)
             write(6,*) 'Confronto tra atomi pesanti e target'
             write(6,*)
*     distCoordSav = distCoord
*     distCoord = 2.0
             nzSav(1:nats) = nz(1:nats)
             call to_coord_sir(1, nrefl)
             nz(1:nats) = nzSav(1:nats)
*     distCoord = distCoordSav
         endif

*        if (kkk == 2) then
*            call AnalisiFosforiNew(maxNatsPDB)
*        endif

*        write(6,*)
*        write(6,*) 'Confronto tra il modello MR e target (solo P)'
*        write(6,*)
         confronta = .true.
         CaOnly = .true.
         call LoadPDBfromAmb(0,1,1)
*        confronta = .true.
         xyzs(4,1:maxNatsPDB) = IntModel(1:maxNatsPDB)
         jj = Lung(linea)
         write(linea(jj+2:),100) nint(vett_test(1:3))

!
!-- flag heavy atoms too close to model atoms
!
         if (knw > 0) then
         write(6,*)
         write(6,*) 'Flag heavy atoms too close to model atoms'
         write(6,*)
         endif
         dLimit = 1.3
         dLimit = radii(nk,1) + 1
         dLimit = maxval(radii(1:nk,1))
         if (knw > 0) then
             write(6,*) 'Distance limit ',dLimit,' Ang.'
             write(6,*)
             write(6,58)
         endif
         do i=1, nats
            distmA = 9999
            x1(1:3) = xyzs(1:3,i)
            do j=1, maxNatsPDB
               if (xyzHeavy(4,j) < 0.0) cycle
               x2(1:3) = xyzHeavy(1:3,j)
               do k=1,nsymTot
                  kt = -1
                  call xequiTot(k, x2, xeq, kt)
                  call xdist(x1, xeq, d, s)
                  if (d < dLimit) then
                      if (knw > 0) 
     *                write(6,60) i, nint(xyzs(4,i)), aLab(i),
     *                         j, nint(xyzHeavy(4,j)), aLabHeavy(j), d
                      xyzHeavy(4,j) = -abs(xyzHeavy(4,j))
                  endif
               enddo
            enddo
         enddo

         j = 0
         do i=1, maxNatsPDB
            if (xyzHeavy(4,i) > 10.0) then
                j = j + 1
                xyzHeavy(:,j) = xyzHeavy(:,i)
                aLabHeavy(j) = aLabHeavy(i)
            endif
         enddo
         maxNatsPDB = j
         rapporto = 15.0 / float(no(nk))
         j = 0
         do i=1, maxNatsPDB
            xyzHeavy(5,i) = xyzHeavy(4,i) / xyzHeavy(4,1)
            if (xyzHeavy(5,i) < rapporto) exit
            j = j + 1
         enddo
*        maxNatsPDB = j
*        maxNatsPDB = min0(maxNatsPDB, 15)
         maxNatsPDB = min0(maxNatsPDB, 10)

         call AvvicinaHA(maxNatsPDB)


         if (knw > 0) then
             write(6,*)
             write(6,*) 'Final list of heavy atoms'
             write(6,*)
         endif

         ifHeavyPDB = 1
         natsPDB = ifHeavyPDB
         if (knw > 0) then
             write(6,46)
             do i=1, maxNatsPDB
                write(6,55) i, aLabHeavy(i), nint(xyzHeavy(4,i)), 
     *                      xyzHeavy(1:3,i), xyzHeavy(5,i)
             enddo
         endif
         if (knw > 0) then
             write(6,*)
           write(6,*) 'Confronto tra atomi pesanti selezionati e target'
             write(6,*)
             CaOnly = .false.
             nats = maxNatsPDB
             xyzs(1:5,1:nats) = xyzHeavy(1:5,1:nats)
             aLab(1:nats) = aLabHeavy(1:nats)
             call to_coord_sir(1, nrefl)
             write(6,*)
         endif
!
         if (maxNatsPDB == 0) then
             ifHeavyAtom = .false.
****         call AllocaPhantom(2)
             return
         endif
         Box_CAB = 3
         ifAmbS = ifAmb
         AmbName = 'nautilus'
         lAmb = Lung(AmbName)
         RFreeOld = RfacAW
         RfreeMinAbs = RfacAW
         erreTest = RfacAW
         absVet(2) = RfacAW
         absVet(3) = RfreAW
         Inte = nome(1:lnome) // '_' // AmbName(1:lAmb) // 
     *          '.pdb_minAbs'
         call cCopyFile(FichierOut, Inte)
         MTZfile = nome(1:lnome) // '_refmac0' // '.mtz'
         Inte = nome(1:lnome) // '_' // AmbName(1:lAmb) // 
     *          '.mtz_minAbs'
         call cCopyFile(MTZfile, Inte)

         erre_added_to_pdb = RfacAW
         erref2            = RfreAW
         if (allocated(Pfinal)) then
             Pfinal(1:nrefl) = iphaz(1:nrefl)
             Wfinal(1:nrefl) = wt(1:nrefl)
             Fcvet_MR(1:nrefl) = fcvet(1:nrefl)
         endif
   
         RFreeOld = oldR
         absVet(2) = oldR
         absVet(3) = oldRf
         call ImproveAmbHeavy(RFreeOld, sogHA, natsPDB,
     *        maxNatsPDB, RfreeMinAbs, ifAmbS, Box_CAB)
*        call AddHeavyAtomsPDB(sogHA, natsPDB, maxNatsPDB, 
*    *              RfreeMinAbs, ifAmbS, FichierOut_SAV)

!
         if (knw /= 0) then
             call examin(88, mkang, khl, ipub, iphaz, nrefl,0,wt,1)
             tirang = 'AFTER HEAVY'
             ipher = 1
             call pherrdisNew(tirang,wt,khl,mkang,nrefl,0,
     *                       ipub,iphaz,wt,10,0.0,ipher)
         endif
!
         cardDiret = MTZfile
         call WriteMTZ_Express(knw, 0, cardDiret, ier)
         if (knw > 0) write(6,*) 'SCRIVO MTZ ', MTZfile(1:Lung(MTZfile))
         Fasi_MR(1:nrefl) = iphaz(1:nrefl)
         Pesi_MR(1:nrefl) = wt(1:nrefl)
         Fasi_Sav(1:nrefl) = iphaz(1:nrefl)
         Pesi_Sav(1:nrefl) = wt(1:nrefl)

!
         erre2   = erre_added_to_pdb
         errore2 = erore
         jj = Lung(linea)
         write(linea(jj+2:),70) erre1, erre2, errore1, errore2, 
     *                          nats_pesanti_in_pdb, nats_added_to_pdb

         errore3 = 0
         if (nats_added_to_pdb > 0) then
*            ifPhD = 0
*            call RemoveHeavyPDB
*            nMacroRef = 2
*            nRefi = 0
*            FasiPerRefmac = -1
*            call UseRefmacN(nRefi, 0, nMacroRef, ier)
*            if (knw /= 0) then
*                call examin(88, mkang, khl, ipub, iphaz, nrefl,0,wt,1)
*                tirang = 'AFTER RM HA'
*                ipher = 1
*                call pherrdisNew(tirang,wt,khl,mkang,nrefl,0,
*    *                           ipub,iphaz,wt,10,0.0,ipher)
*            endif
             errore3 = erore
         endif
*        jj = Lung(linea)
*        write(linea(jj+2:),75) erre1, erre2, errore1, errore2, errore3,
*    *                          nats_pesanti_in_pdb, nats_added_to_pdb

         if (nats_added_to_pdb == 0) then
             FichierOut = FichierOut_SAV
             Inte = nome(1:lnome) // '_sav' // '.pdb'
             if (knw == 1) then
                 write(6,1) FichierOut(1:Lung(FichierOut)),
     *                      Inte(1:Lung(Inte))
             endif
             call cCopyFile(Inte, FichierOut)
         endif

         nset = 1
         call PutGetFinalPhases(1, nset, fig)


*        call HeavyPDB(nats_added_to_pdb, maxNatsPDB)

         if (knw > 0) write(6,'(a)') linea(1:Lung(linea))


         ifHeavyAtom = .false.

         if (nats_added_to_pdb == 0) exit

      enddo

****  call AllocaPhantom(2)

      maxNatsPDB = maxNatsPDBsav
*     call AnalisiFosforiNew(maxNatsPDB)

      deallocate(xyzHeavy, aLabHeavy, IntModel, stat=ier)

      cardDiret  = nome(1:lnome) // '_improved_HA.pdb'
      call cCopyFile(FichierOut, cardDiret)
      cardDiret  = nome(1:lnome) // '_improved_HA.mtz'
      call cCopyFile(MTZfile, cardDiret)
      if (nats_added_to_pdb > 0) then
          call RemoveHeavyPDB  !  commentare per Riga 2

      endif

      call LoadPDBfromAmb(0,0,1)
      if (knw > 0) then
          write(6,*)
          write(6,*) 'Confronto finale tra modello MR e target (solo P)'
          write(6,*)
      endif
      distCoordSav = distCoord
      distCoord = 0.6
      CaOnly = .true.
      nzSav(1:nats) = nz(1:nats)
      call to_coord_sir(1, nrefl)
      distCoord = distCoordSav
      pCA = nint(vett_test(7))
*     distCoord = distCoordSav
      nz(1:nats) = nzSav(1:nats)
      if (knw > 0) then
          write(6,*)
          write(6,*) 'Confronto tra modello MR e target'
          write(6,*)
      endif
*     distCoordSav = distCoord
*     distCoord = 10
      CaOnly = .false.
      nzSav(1:nats) = nz(1:nats)
      call to_coord_sir(1, nrefl)
      pAT = nint(vett_test(7))
*     distCoord = distCoordSav
      nz(1:nats) = nzSav(1:nats)
      CaOnly = .true.
!
      return
    1 format(' COPY ',a,' IN ',a)
   10 format(/,' Heavy atoms:',/,
     *         ' Species  Z  number')
   20 format(3x,a2,2i6)
   30 format('HETATM      ',a2,3x,'HET',10x,3f8.3,2f6.2,10x,a2)
   45 format(/,'           Int   X      Y      Z     Occ')
   46 format(/,
     *     '     Heavy                  Int   X      Y      Z     Occ')
   48 format(/,'   Peak   Height   X      Y      Z    Occ')
   50 format(i5,')',i10,4f7.4)
   55 format(i3,') ',a,i10,4f7.4)
   58 format(' Atom  Int  Name             Heavy Int  Name             '
     *       '    dist')
   60 format(2(2i5,2x,a),2x,f8.3)
   70 format(' ', 2f8.4,2f8.2,2i4)
   75 format(' ', 2f8.4,3f8.2,2i4)
   80 format(' AGGIUNGI ', a2, i3)
   90 format(' AGGIUNGI NOT APPLIED', a, 2i3)
  100 format(3i4)
  210 format(/,' Heavy atom procedure - first step')
  220 format(/,' Heavy atom procedure - second step')
      end
!-----------------------------------------------------------------------
      subroutine Cicla_HI(Action)
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
      USE Mappa
      USE Param
      USE PhMod
      USE MapTest
!
!-- Action = 0  call da Improve_PKG
!-- Action = 1  call da FinalStepT
      implicit none
      integer :: Action, n, ipher, i, ifBreak, nMicro_SOMMA, jpatt
      real    :: w, correl, chope
      character (len=11) :: tirang
!
      invflag = 1
      percMap = 0.05
      nMicro_SOMMA = 10
      do indiceMicro = 1, nMicro_SOMMA
         numbrun = indiceMicro
         if (Action == 0) then
             jpatt = 0
             fcoef(1:nrefl) = evet(1:nrefl) * wt(1:nrefl)
             call MakeMap(fcoef, iphaz, nrefl,jpatt,xmap,FORTH,BACK)
         else
             if (indiceMicro > 1) then
                 fcoef(1:nrefl) = Rtarget(1:nrefl) * wt(1:nrefl)
                 jpatt = 0
                 call MakeMap(fcoef, iphaz, nrefl,jpatt,xmap,FORTH,BACK)
             endif
         endif

         call ModificaMappa()

         call NewInvCuda(iphaz, fcvet, nrefl, np(1), np(2), np(3),
     *                      BACK, xmap)
         wt(1:nrefl) = 1
         call Normalize(2, fcvet, fcvet)
         call Weights_Calculation_NEW(nrefl,nrefl,chope, correl,
     *                                ifBreak)
!
         if (indiceMicro > 1 .and. Action == 1) then
             do i=1, nrefl
                w = wt(i)
                if (w < 0.10) w = 0.10
                wt(i) = 0.7 * w ** 0.5
             enddo
         endif
         if (knw == 1) then
             if (Action == 0) then
                 n = indiceMicro
                 call examin(n,mkang,khl,ipub,iphaz,nrefl,0,wt,1)
             else
                 call examin(7,mkang,khl,Pub_target,iphaz,nrefl,0,wt,0)
             endif
         endif
         if (indiceMicro <= 2 .and. Action == 1) then
             if (indiceMicro == 1) then
                 AddRis = .false.
                 call FillVett_PHA(erore)
             endif
             tirang = 'SOMMA      '
             write(tirang(7:8),'(i2)') indiceMicro
             ipher = 1
             call pherrdisNew(tirang, wt, khl, mkang, nrefl, 0,
     *                        Pub_target, iphaz, wt, 20, 0.0, ipher)
         endif
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine DoRemoDsr(VettRisultati)
      USE General
      USE Riflessi
      USE Mappa
      USE PhaseModule
      USE RemoModule
      USE ArpWarp, only : statoMR
      USE VLDmod, only : sog_sigmaA
      USE Tutto, only : wt11
!
      implicit none
      integer :: i, ii, ifBreak, ier, Max_icy, numb, jj
      real    :: correl, VettRisultati(10)
!
      if (ifFreeLunchMR == 0) then
          if (knw == 1) write(lo,110) 
      else
          if (ifPhantom == 0) then
              if (knw == 1) write(lo,120) 
          endif
      endif
!
      ifOutDsr = 1
!
      i = 1
      if (LowRes == 1) then
          ifDsrVLD = 1
          Max_icy = 4

!         if (statoMR == 0) then ! come in sir2019 distr.
!             ifDsrVLD = 0       ! come in sir2019 distr.
!         endif                  ! come in sir2019 distr.

          call DirectSpaceRefinement_Cow(correl, 
     *         VettRisultati, ifBreak, i, Max_icy, ier)
!
      else
!
!dedi --  ATTENZIONE ALLE ROUTINES PER DATI AD ALTA RISOLUZIONE  (si deve usare DSR_HIGH)
!
          if (knw > 0) then
              call examin(1,mkang,khl,ipub,iphaz,nrefl,0,wt,0)
              VettRisultati(2) = erore
          endif
          call DefineEtc(0, 0)
          numbInv = 0.5 * nrefl
          numbLSQ = nrefl
          ifRelax = 0
          do ii=1, nrefl
             if (evet(ii) < 0.8) then
                 exit
             else
                 numbInv = ii
             endif
          enddo
          ksize_vero = ksize
          ifDsrVLD = 1       !  TEST
          call AllocaMappa(1) !  TEST
          call AllocaMapTest(1)
          numbLSQ = nrefl*0.7 !  TEST
          fcoef(1:nreflTot)  = fcvet(1:nreflTot) 
     *                       * wt(1:nreflTot)
          call MakeMap(fcoef, iphaz, nreflTot, 0, xmap,
     *             FORTH, BACK)
          call Scrivi_Mappa_Vera(1)
          ifRelax = 1
          sog_sigmaA = 0.97
          numb = nrefl
          if (no(nk) > 20) then
              call AllocaAtomi(1)
          endif
!
!-- PEZZA PEZZA
!
          ResEff = 0
          Complet = 0
          call MakeMapsForCorr(ifBreak, ier)
!
          if (ifPhantom == 0) then
              call DirectSpaceRefinement_HIGH(correl, ifBreak, ier)
              kWstop = 0
          else
              call DirectSpaceRefinement_NEW(correl,ifBreak, ier)  !!! dovrebbe essere sostituita da DSR_HIGH
              wt(1:nrefl) = wt11(1:nrefl)
          endif
         
          if (knw > 0) then
             call examin(1,mkang,khl,ipub,iphaz,nrefl,0,wt,1)
             VettRisultati(3) = erore
             VettRisultati(4) = 0.0
             write(lo,20) resol_obs_max, nint(VettRisultati(1:3))
          endif
          if (ifMutate == 0) then
              call AllocaAtomi(2)
          endif
      endif
!
      return
   20 format('TESTVET ',';',f6.2,' ;',5(i3,' ;'))
  110 format(/,' Starting VLD ')
  120 format(/,' Starting VLD-Free Lunch ')
      end
!-----------------------------------------------------------------------
      subroutine PostImprove
      USE General
      USE Riflessi
      USE Mappa
      USE Param
      USE ArpWarp
      USE PhaseModule
      USE ShellSIGMAA
      USE VLDmod, only : sog_sigmaA
      USE VLDmod_1, only : es
      USE RemoModule, only : ifFreeLunchMR
!
      implicit none
      integer :: ncy, ifmin, i, npunti, npts1, npts2, knw_save, ifInv
      integer :: iflat1, ier, id1, min0, iphi, id2, idv, nwizm1, nsip1
      integer :: numres, jenveTipo, ihism_save, iwp, Max_icy, ii,ifBreak
      integer :: ifFreeLunchMRSav, jPrintStat, iAction
      real    :: coefR, coefI, phi, phip, f000Sav, faze, args, fsc
      real    :: aa, bes, fazeP, fazeQ, fscP, fscQ, smax, wangmd, wangrd
      real    :: sw, rmax, rnrflc, sA, wQ, scala, somma, Ratt
      real    :: VettRisultati(10), correl, sigmaAmed, rf1, rf2, X
      logical :: nonAllocata
      real, allocatable  :: xenveDEDM(:,:,:)
!
      write(6,*) 'PostImprove'
      iAction = 1
      call AllocaRiflessiCow(iAction)
      iphad(1:nrefl) = iphaz(1:nrefl)
      wtd(1:nrefl) = wt(1:nrefl)
      iphazo(1:nrefl) = iphaz(1:nrefl)
      tmpwt(1:nrefl) = wt(1:nrefl)
      write(6,*) 'FL <wt> =',sum(wtd(1:nrefl))/float(nrefl)
!
      ncy = 3330
      ifmin = 1
      call examin(ncy, mkang, khl, ipub, iphaz, nrefl,
     *            0, wt, ifmin)
      fcoef(1:nrefl) = evet(1:nrefl) * wt(1:nrefl)
      f000Sav = f000
      f000 = 0
      call MakeMap(fcoef, iphaz, nrefl, 0, xmap, FORTH, BACK)
      f000Sav = f000
      percMap = 0.025
      invflag = 1
      call InvMap(khl,mkang,iwork1,fcvet,nrefl)
      nwizm1=25
      nsip1=150 
      work1(1:nrefl) = fcvet(1:nrefl)
      call HistogramMatch(work1,evet,nrefl,nsip1,nwizm1,1) 
      fcvet(1:nrefl) = work1(1:nrefl)
      somma = 0.0
      do i=1, nrefl
         somma = somma + fcvet(i) ** 2
      enddo
*     scala = float(nrefl) / somma
*     do i=1, nrefl
*        fcvet(i) = sqrt( scala * fcvet(i) ** 2 )
*     enddo
      somma = sum(fcvet(1:nrefl) ** 2)
      write(6,*) '<Ep**2>', somma / float(nrefl)
      ncy = 3333
      ifmin = 1
      call examin(ncy, mkang, khl, ipub, PH_refmac, nrefl,
     *            0, WT_refmac, ifmin)
!
!-- salva fasi e Ec di EDM-VLD-FL
!
      nonAllocata = .false.
      if (.not.allocated(es)) then
          nonAllocata = .true.
          allocate(es(1:nrefl), stat=ier)
      endif
!
!-- calcolo sigmaA
!
      Ratt = 0
      sog_sigmaA    = 0.97
      es(1:nrefl) = 1.0
      call Calcola_SigmaA(Ratt)
      wvar(1:nrefl) = Dluz(1:nrefl)
      do i=1,nrefl
         X = (2. * Dluz(i) * evet(i) * fcvet(i)) / (es(i) - Dluz(i)**2)
****     tmpwt(i) = bes(X)
      enddo
      write(6,*) 'SA <wt> =',sum(tmpwt(1:nrefl))/float(nrefl)
!
!-- salva i valori attuali di Ec e fase
!
      ifasi(1:nrefl) = iphaz(1:nrefl)
      ecoef(1:nrefl) = fcvet(1:nrefl)
!
!-- normalizza gli FC di refmac
!
      fcvet(1:nrefl) = FC_refmac(1:nrefl)
      call F2ENew(1, nrefl)
      somma = 0.0
      do i=1, nrefl
         somma = somma + fcvetv(i) ** 2
      enddo
      scala = float(nrefl) / somma
      do i=1, nrefl
         fcvetv(i) = sqrt( scala * fcvetv(i) ** 2 )
      enddo
      somma = 0.0
      do i=1, nrefl
         somma = somma + fcvetv(i) ** 2
      enddo
      somma = sum(fcvetv(1:nrefl) ** 2)
      write(6,*) '<Ec**2>', somma / float(nrefl)
      somma = sum(wvar(1:nrefl))
      write(6,*) '<sigmaA>', somma / float(nrefl)
!
!-- calcola envelope
!
      allocate(xenveDEDM(0:np(1)-1,0:np(2)-1,0:np(3)-1), stat = ier)
      rhomax_obs=maxval(rhov(1:nrefl))
      rmax=0.5/sqrt(rhomax_obs)
      rnrflc=100 + numres(rmax)
      wangmd=131.0
      wangrd=-2.0
      iwp=int(wangmd/100) + 1
      sw=sum(wt(1:nrefl)**iwp)
      Renve=abs(wangrd)*(rnrflc/sw)**0.33*rmax
      Renve=min(Renve,10.0)
      smax=rhomax_obs*4.0
      ihism_save = ihism
      ihism = 0 ! per fare l'envelope con Fo invece di Fo_0
      f000Sav=f000
      f000=volume*(0.32*(1.0-v_p)+0.43*v_p)
      FORTHenv = 0
      jenveTipo = 0

      call PreMaskSirProt(jenveTipo,v_p,xenveDEDM,FORTHenv,BACKenv)
      call Map2EnveMask(0,smax,v_p,xenveDEDM,FORTHenv,BACKenv)
      f000=f000Sav

      ihism = ihism_save
      call DistruggiPiani(FORTHenv,BACKenv)
!
!-- calcola la mappa differenza delle fourier
!
      do i=1, nrefl
         phi  = float(ifasi(i)) * dtor        ! fase dopo EDM-VLD-FL
         phip = float(PH_refmac(i)) * dtor    ! fase dopo refmac
         sA = wvar(i)                         ! sigmaA
         coefR = evet(i) * cos(phi) - sA * fcvetv(i) * cos(phip)
         coefI = evet(i) * sin(phi) - sA * fcvetv(i) * sin(phip)
         fcoef(i) = sqrt(coefR * coefR + coefI * coefI)
         faze = rtod * atan2(coefI, coefR)
         iwork1(i) = faze
      enddo
      f000Sav = f000
      f000 = 0
      call MakeMap(fcoef, iwork1, nrefl, 0, xmap, FORTH, BACK)
      f000 = f000Sav
!
!-- inverte la mappa fourier differenza
!
      npunti = np(1) * np(2) * np(3)

      iflat1 = 1 ! mask =1/0.5
      xenveDEDM(:,:,:) = 100.0
      call flatmap(xmap, xenveDEDM, iflat1, 0.0)  ! con l'envelope "parziale"
      perc=0.10
      npts1 = npunti * perc ! punti positivi
      npts2 = npunti * perc ! punti negativi
      call denhist(0, xmap, xenveDEDM, npts1, npts2)
      knw_save = knw
      knw = 0
      ifInv = 1
      call ChangeAndInvMap_VLD(xmap, xenve, 7, 0.0, 1, ifInv, ier)
      knw = knw_save

      iwork2(1:nrefl) = iphaz(1:nrefl)
!
!-- histogram matching
!
      nwizm1=25
      nsip1=150 
      work1(1:nrefl) = fcvet(1:nrefl)
      call HistogramMatch(work1,evet,nrefl,nsip1,nwizm1,1) 
      fcvet(1:nrefl) = work1(1:nrefl)
      somma = sum(fcvet(1:nrefl) ** 2)
      write(6,*) '<Eq**2>', somma / float(nrefl)

!
!-- calcolo E totale con la formula della tangente
!
      do i=1, nrefl
         fazeQ = iwork2(i) * dtor
         fazeP = ifasi(i) * dtor
         fscQ  = fcvet(i)
         fscP  = ecoef(i)
         sA = min(1.0, wvar(i))
         wQ = sqrt( 2.0*(1-sA) )
         coefR = wQ * fscQ * cos(fazeQ) + fscP * cos(fazeP)
         coefI = wQ * fscQ * sin(fazeQ) + fscP * sin(fazeP)
         args = coefR * coefR + coefI * coefI
         if (args > 0.0) then
             fsc=sqrt(args)
             fcvet(i)=fsc
             faze=atan2(coefI,coefR)
             faze=faze*rtod
             faze=mod(faze+3600.,360.)
             if (faze.le.0.0) faze=360.-faze
             if (mkang(i).ne.1) then
                iphi=faze
                 idv = 15*mod(mkang(i)-1,12)
                 id1 = iabs(idv-iphi)
                 id2 = iabs(idv+180-iphi)
                 id1=min0(id1,360-id1)
                 id2=min0(id2,360-id2)
                 if (id1.lt.id2) then
                     iphi=idv
                 else
                     iphi=idv+180
                 endif
                 iphi=mod(iphi,360)
                 faze=iphi
             endif
             iphaz(i)= faze
             aa = sqrt(coefR**2 + coefI**2)
             wt(i) = bes(aa)
         else
             fcvet(i)=0.0
             iphaz(i)= 0
             wt(i)= 0
         endif
      enddo
!
      ncy = 3334
      ifmin = 1
      call examin(ncy, mkang, khl, ipub, iphaz, nrefl,
     *            0, wt, ifmin)
      write(lo,10) erore, erorepes
!
      if (nonAllocata) then
          deallocate(xenveDEDM, es, stat=ier)
      endif
      write(6,*) 'Old <wt> =',sum(wt(1:nrefl))/float(nrefl)
!
!-- calcolo Fp per EDM
!
      worko(1:nrefl) = wt(1:nrefl)
      f000 = 0
      fcoef(1:nrefl) = fovet(1:nrefl) * wt(1:nrefl)
      call MakeMap(fcoef, iphaz, nrefl, 0, xmap, FORTH, BACK)
      f000 = f000Sav
      percMap = 0.03
      invflag = 1
      call InvMap(khl,mkang,iphaz,fcvet,nrefl)
      ncy = 3335
      ifmin = 1
      call examin(ncy, mkang, khl, ipub, iphaz, nrefl,
     *            0, wt, ifmin)
!
!-- histogram matching
!
*     go to 1

      work1(1:nrefl)=fcvet(1:nrefl)
      nsip1=150
      nwizm1=25
      call HistogramMatch(work1,fovet,nrefl,nsip1,nwizm1,1)
      fcvet(1:nrefl) = work1(1:nrefl)

!
!-- calcolo dei pesi con sigmaA
!
      jsigmaa = 1
      jPrintStat = 1
                rf1 = 1
                rf2 = 1
                wt(1:nrefl) = 1
                call sigmaAfromSirprot(sigmaAmed,jsigmaa,fovet_mod,
     *               sigmav,fovet_mod,mkang,rhov,epsv,
     *               fcvet,ipub,iphaz,wt,iphad,wtd,
     *               wvar,pesmod,Dluz,e1,e2,
     *               nreflDim,nrefl,nrefl,
     *               icomb,rf1,rf2,jPrintStat)
    1 continue
      write(6,*) 'New <wt> =',sum(wt(1:nrefl))/float(nrefl)
      ncy = 3330
      ifmin = 1
      call examin(ncy, mkang, khl, iphad, iphaz, nrefl,
     *            0, wtd, ifmin)

      wt(1:nrefl) = worko(1:nrefl)
      write(6,*) 'New <wt> =',sum(wt(1:nrefl))/float(nrefl)
      iAction = 2
      call AllocaRiflessiCow(iAction)

      ifBreak = 0
      ier = 0
      ii = 2
*     ifFreeLunchMRSav = ifFreeLunchMR
*     ifFreeLunchMR = 0
      Max_icy = 1
      call DirectSpaceRefinement_Cow(correl, VettRisultati, 
     *                               ifBreak, ii, Max_icy, ier)
*     ifFreeLunchMR = ifFreeLunchMRSav

      write(lo,20) erore, erorepes
!
      return
   10 format('POSTIMPROVE1 ',2f8.2)
   20 format('POSTIMPROVE2 ',2f8.2)
      end
!-----------------------------------------------------------------------
      subroutine CompletaModello(VettRisultati)
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
      USE Molcom
      USE Atomi
      USE RemoModule
      USE ArpWarp
      USE Mappa
      USE Param, only : f000
!
      implicit none
      integer :: ier, itype, iform, jop, jopen, ios, i, jlig, nne
      integer :: n, ix, iy, iz, sidepp, nRefi, iflagPKS, mode, numb
      integer :: ox, nExtC
      real    :: xs1(3), bterm, side, soglia, VettRisultati(10)
!
      write(6,*) 
      write(6,*) '    subroutine CompletaModello'
      write(6,*) 

!
      FichierOut = nome(1:lnome) // '_refmac0.pdb'
      itype = 2
      iform = 1
      jop = jopen(jhost,cardDiret,itype,iform,ios)
      if (jop < 0) then
          return
      endif
      nMolMR = 1
      WhichModel = 1
      call AllocaModelRemo(2)
      numbModels = 1
      call AllocaAtomi(-1)
*     call AllocaModelRemo(0)
      call ManagePDBSir(0, 0, 0, 0, 1, ier)
      if (ier < 0) then
          return
      endif
      close(jhost)
      call RestoreLists123(3)   ! modificato dalla lettura del PDB
!
      call GetModel
      call to_coord_sir(1, nrefl)
!
      call examin(0, mkang, khl, ipub, iphaz, nrefl, 0, wt, 1)
      fcoef(1:nrefl) = wt(1:nrefl) * fovet(1:nrefl)
      f000 = 0
      call MakeMap(fcoef, iphaz, nrefl, 0, xmap, FORTH, BACK)
!
      n = natsInModel(WhichModel)
      do i=1, n
         xs1(1) = side( model(WhichModel)%atoms(1,i,1) )
         xs1(2) = side( model(WhichModel)%atoms(2,i,1) )
         xs1(3) = side( model(WhichModel)%atoms(3,i,1) )
         ix = int( xs1(1) * np(1) )
         iy = int( xs1(2) * np(2) )
         iz = int( xs1(3) * np(3) )
         ix = sidepp( ix, np(1) )
         iy = sidepp( iy, np(2) )
         iz = sidepp( iz, np(3) )
         bterm = model(WhichModel)%th_fact(i,1)
         model(WhichModel)%atoms(4,i,1) = xmap(ix, iy, iz) / bterm
         bSav(i) = model(WhichModel)%atoms(4,i,1)
         write(6,'(i5,2x,a,2f10.2)') 
     *                 i, model(WhichModel)%label(i), bterm, bSav(i)
      enddo
      i = -1
      call sortall(i, bSav, n)
      i = 0.85 * float(n)
      soglia = bSav(i)
      write(6,*) 'n, i, soglia', n, i, soglia
      do i=1, n
         write(6,*) i, bSav(i)
      enddo
      do i=1, n
         bterm = model(WhichModel)%atoms(4,i,1)
         if (bterm < soglia) then
            model(WhichModel)%atoms(4,i,1) = -bterm
         endif
      enddo
!
      FichierOut = nome(1:lnome) // '_refmac0.pdb'
      cardDiret  = nome(1:lnome) // '_refmac.pdb'
      call cCopyFile(FichierOut, cardDiret)
      call CreaPDB(n, 0)
      model(WhichModel)%atoms(4,1:n,1) = 
     *      abs(model(WhichModel)%atoms(4,1:n,1))
      natsInModel(WhichModel) = n
!
      nrefi = 5
      call UseRefmac(FichierOut, nRefi, 0, nRefi, 1, ier)
      VettRisultati(5) = erore
!
      nrefi = 0
      call UseRefmac(FichierOut, nRefi, 1, nRefi, 1, ier)
      fcoef(1:nrefl) = fcvet(1:nrefl)
      call MakeMap(fcoef, iphaz, nrefl, 0, xmap, FORTH, BACK)

      aperc(1) = anat - n
      ifFour = 1
      iflagPKS = 0
      mode = 0
      krecy = 0
      numb = nrefl
      ier = 0
      call pksrch_New(mode, iflagPKS, numb, ier)
      do i=1, nk
         if (no(i) == 8) then
             ox = i
             exit
         endif
      enddo
      nz(1:nats) = ox * nzConst
      write(6,*) 'nk,no(nk),nw(nk),totop',nk,no(nk),nw(nk),totop
      if (no(nk) > 18) then
          i = nint( float(nw(nk) ) / totop )
          nz(1:i) = nk * nzConst
          write(6,*) 'i, nz(1:i)',i, nz(1:i)
      endif
      call MakeLab(1, nats)
      do i=1, nats
         write(6,'(i5,2x,a,f12.2)') i, aLab(i), xyzs(4,i)
      enddo
      call to_coord_sir(1, nrefl)
      
!
      call CreaPDB(n, 1)
      natsInModel(1) = n
!
      nRefi = 5
      nExtC = 1
      FasiPerRefmac = 0
      call UseRefmacN(nRefi, 0, nExtC, ier)
      VettRisultati(6) = erore
      infoOK(15) = 0
!
      return
      end
!-----------------------------------------------------------------------
      subroutine CreaPDB(n, add)
      USE General
      USE Atomi
      USE Molcom
      USE ArpWarp
      USE Groups
      USE RemoModule
!
      implicit none
      integer :: i, j, k, L, Lung, ier, n, nCatena, nResi, oldResi
      integer :: jop, jopen, itype, iform, nRej, add
      real    :: x1(3), x2(3), bterm
      character (len=1) :: Catena, oldCatena
      character (len=2) :: a1, a2
      character (len=3) :: a3
!
      itype = 0
      iform = 1
      jop = jopen(jhost, FichierOut, itype, iform, ier)
! 
      nCatena = ichar('A') - 1
      oldCatena = '*'
      nResi = 0
      oldResi = -1
      n = 0
      j = 0
      itype = 0
      iform = 1
      nRej = 0
      jop = jopen(jrel, cardDiret, itype, iform, ier)
      do
         read(jrel,'(a)',end=10) Inte
         if (Inte(1:6) == 'CRYST1' .or.
     *       Inte(1:5) == 'SCALE') then
             L = Lung(Inte)
             write(jhost,'(a)') Inte(1:L)
         elseif (Inte(1:4) == 'ATOM') then
             if (Inte(18:20) == 'DUM') cycle
             j = j + 1
             bterm = xyzo(4,j)
             if (bterm < 0) then
                 nRej = nRej + 1
*                write(6,'(i5,2x,a,2f10.2)') 
*    *                 nRej, model(WhichModel)%label(j), abs(bterm),
*    *                 model(WhichModel)%th_fact(j,1)
                 cycle
             endif
             n = n + 1
             write(Inte(7:11),'(i5)') n
             catena = Inte(22:22)
             if (catena /= oldCatena) then
              nCatena = nCatena + 1
                 oldCatena = catena
             endif
             Inte(22:22) = char(nCatena)
             read(Inte(23:26),'(i4)') k
             if (k /= oldResi) then
                 nResi = nResi + 1
                 oldResi = k
             endif
             write(Inte(23:26),'(i4)') nResi
             L = Lung(Inte)
             write(jhost,'(a)') Inte(1:L)
         endif
      enddo
   10 continue
      if (add == 1) then
          do j=1, nats
             k = iabs(nz(j)) / nzConst
             a2(1:2) = Species(k)(1:2)
             call ucase(a2)
             a1 = a2
             if (a2(2:2) == ' ') then
                 a2(2:2) = a2(1:1)
                 a2(1:1) = ' '
             endif
             if (a1 == 'O ') then
                 a3 = 'HOH'
             else
                 a3 = ' ' // a1(1:2)
             endif
             x1(1:3) = xyzs(1:3,j)
             call MoltMatVec(rm, x1, x2)
             write(Inte,20) a1(1:2), a3(1:3), x2(1:3), xyzs(5,j), bt,
     *                      a2(1:2)
             n = n + 1
             write(Inte(7:11),'(i5)') n
             nResi = nResi + 1
             write(Inte(23:26),'(i4)') nResi
             nCatena = nCatena + 1
             Inte(22:22) = char(nCatena)
             Inte(22:22) = ' '
             write(jhost,'(a)') Inte(1:80)
          enddo
      endif
!
      close(jrel)
      close(jhost)
!
      return
   20 format('HETATM      ',a2,3x,a3,10x,3f8.3,2f6.2,10x,a2)
      end
!-----------------------------------------------------------------------
      subroutine ManageSe
      USE General
      USE ArpWarp
      USE RemoModule
!
      implicit none
      integer :: i, L, Lung, ier
      integer :: jop, jopen, itype, iform, se, ifHET
!
      se = 0
      do i=1, nk
         if (no(i) == 34) then
             se = i
             exit
         endif
      enddo
      if (se == 0) then
          return
      endif
!
      cardDiret  = nome(1:lnome) // '_refmac.pdb'
      call cCopyFile(FichierOut, cardDiret)
      itype = 0
      iform = 1
      jop = jopen(jrel, cardDiret, itype, iform, ier)  ! pdb da Remo
      jop = jopen(jhost, FichierOut, itype, iform, ier) ! pdb corretto
!
      do
         read(jrel,'(a)',end=10) cardImage
         L = Lung(cardImage)
         call ucase(cardImage(1:L))
         if (cardImage(1:6) /= 'HETATM') then
             write(jhost,'(a)') cardImage(1:L)
         else
             if (cardImage(18:20) == 'MSE') then
                 cardImage(1:6) = 'ATOM  '
             endif
             write(jhost,'(a)') cardImage(1:L)
         endif
      enddo
!
   10 close(jrel)
      close(jhost)
      return
!
      return
      end
!-----------------------------------------------------------------------
      subroutine AddHOH(nAdd, nBatch)
      USE General
      USE Atomi
      USE Molcom
      USE ArpWarp
      USE Groups
      USE RemoModule
!
      implicit none
      integer :: i, j, k, L, Lung, ier, n, nCatena, nResi, oldResi
      integer :: jop, jopen, itype, iform, nRej, nAdd, ox, se, sez
      integer :: oxnz, nkH, noH(18), nwH(18), nBatch
      real    :: x1(3), x2(3)
      character (len=2) :: a1, a2
      character (len=3) :: a3
!
      noH(:) = 0
      nkH = 0
      ox = 0
      se = 0
      do i=1, nk
         if (no(i) == 8) then
             ox = i
         endif
         if (no(i) == 34) then
             se = i
         endif
      enddo
      oxnz = ox * nzConst
      nz(1:nAdd) = oxnz
      if (nBatch == 1) then
          if (no(nk) >= 20) then
              call label(nAdd)
          endif
      endif
      sez = se * nzConst
      do i=1, nAdd
         if (nz(i) == sez) then
*            nz(i) = oxnz
         else
             k = nz(i) / nzConst
             if (no(k) < 20) then
                 nz(i) = oxnz
             endif
         endif
      enddo
      do i=1, nAdd
         if (nz(i) == oxnz) cycle
         if (nkH == 0) then
             nkH = nkH + 1
             nwH(nkH) = nz(i)
             noH(nkH) = noH(nkH) + 1
         else
             k = 0
             do j=1, nkH
                if (nz(i) == nwH(j)) then
                    noH(j) = noH(j) + 1
                    k = j
                endif
             enddo
             if (k == 0) then
                 nkH = nkH + 1
                 nwH(nkH) = nz(i)
                 noH(nkH) = noH(nkH) + 1
             endif
         endif
      enddo
!
      itype = 0
      iform = 1
      jop = jopen(jhost, FichierOut, itype, iform, ier)
! 
      itype = 0
      iform = 1
      jop = jopen(jrel, cardDiret, itype, iform, ier)
      do
         read(jrel,'(a)',end=10) Inte
         if (Inte(1:3) == 'END') then
             exit
         endif
         L = Lung(Inte)
         write(jhost,'(a)') Inte(1:L)
         if (Inte(1:4) == 'ATOM') then
             read(Inte,'(6x,i5,11x,i4)') n, nResi
         endif
      enddo
   10 continue
!ETATM 1393  O   HOH  1002      19.505   7.976  20.657  0.94 10.05           O
!ETATM 1393  O   HOH  1002    xxxx.xxxyyyy.yyyzzzz.zzz  0.94 10.05           O
      do j=1, 30
         write(6,18) j,xyzs(1:5,j)
      enddo
   18 format(i3,1h),5f15.3)
      L = Lung(Inte)
      do j=1, nAdd
         n = n + 1
         nResi = nResi + 1
         x1(1:3) = xyzs(1:3,j)
         call MoltMatVec(rm, x1, x2)
         k = iabs(nz(j)) / nzConst
         if (k == ox .or. no(k) < 20) then
             Inte = 'HETATM 1393  O   HOH  1002' //
     *       '      19.505   7.976  20.657  0.94 10.05           O'
             write(Inte(31:66),'(3f8.3,2f6.2)') x2(1:3), xyzs(5,j), bt
             write(Inte(7:11),'(i5)') n
             write(Inte(23:26),'(i4)') nResi
         else
             a2(1:2) = Species(k)(1:2)
             call ucase(a2)
             a1 = a2
             if (a2(2:2) == ' ') then
                 a2(2:2) = a2(1:1)
                 a2(1:1) = ' '
             endif
             a3 = ' ' // a1(1:2)
             write(Inte,20) a1(1:2), a3(1:3), x2(1:3), xyzs(5,j), bt,
     *                      a2(1:2)
             write(Inte(7:11),'(i5)') n
             write(Inte(23:26),'(i4)') nResi
             Inte(22:22) = ' '
         endif
         write(jhost,'(a)') Inte(1:L)
      enddo
!
      close(jrel)
      close(jhost)
      if (nkH > 0) then
          do i=1, nkH
             k = nwH(i) / nzConst
             a2 = Species(k)(1:2)
             call ucase(a2(1:1))
             write(lo,30) noH(i), a2
          enddo
      endif
!
      return
   20 format('HETATM      ',a2,3x,a3,10x,3f8.3,2f6.2,10x,a2)
   30 format(12x,'Added heavy atom(s) ',i3,2x,a)
      end
!----------------------------------------------------------------------
      subroutine AddCA(nAdd, nBatch, previous)
      USE General
      USE Atomi
      USE Molcom
      USE ArpWarp
      USE Groups
      USE RemoModule
!
      implicit none
      integer :: i, j, k, L, Lung, ier, n, nCatena, nResi, oldResi
      integer :: jop, jopen, itype, iform, nRej, nAdd, ox, se, sez
      integer :: oxnz, nkH, noH(18), nwH(18), nBatch, previous
      real    :: x1(3), x2(3)
      character (len=2) :: a1, a2
      character (len=3) :: a3
!
      noH(:) = 0
      nkH = 0
      ox = 0
      se = 0
      do i=1, nk
         if (no(i) == 6) then
             ox = i
         endif
         if (no(i) == 34) then
             se = i
         endif
      enddo
      oxnz = ox * nzConst
      nz(1:nAdd) = oxnz
      if (nBatch == 1) then
          if (no(nk) >= 20) then
              call label(nAdd)
          endif
      endif
      sez = se * nzConst
      do i=1, nAdd
         if (nz(i) == sez) then
*            nz(i) = oxnz
         else
             k = nz(i) / nzConst
             if (no(k) < 20) then
                 nz(i) = oxnz
             endif
         endif
      enddo
      do i=1, nAdd
         if (nz(i) == oxnz) cycle
         if (nkH == 0) then
             nkH = nkH + 1
             nwH(nkH) = nz(i)
             noH(nkH) = noH(nkH) + 1
         else
             k = 0
             do j=1, nkH
                if (nz(i) == nwH(j)) then
                    noH(j) = noH(j) + 1
                    k = j
                endif
             enddo
             if (k == 0) then
                 nkH = nkH + 1
                 nwH(nkH) = nz(i)
                 noH(nkH) = noH(nkH) + 1
             endif
         endif
      enddo
!
      itype = 0
      iform = 1
      jop = jopen(jhost, FichierOut, itype, iform, ier)
! 
      itype = 0
      iform = 1
      jop = jopen(jrel, cardDiret, itype, iform, ier)
      do
         read(jrel,'(a)',end=10) Inte
         if (Inte(1:3) == 'END') then
             exit
         endif
         L = Lung(Inte)
         write(jhost,'(a)') Inte(1:L)
         if (Inte(1:4) == 'ATOM') then
             read(Inte,'(6x,i5,11x,i4)') n, nResi
         endif
      enddo
   10 continue
!ETATM 1393  O   HOH  1002      19.505   7.976  20.657  0.94 10.05           O
!ETATM 1393  O   HOH  1002    xxxx.xxxyyyy.yyyzzzz.zzz  0.94 10.05           O
      do j=1, 30
         write(6,18) j,xyzs(1:5,j)
      enddo
   18 format(i3,1h),5f15.3)
      previous = n
      L = Lung(Inte)
      do j=1, nAdd
         n = n + 1
         nResi = nResi + 1
         x1(1:3) = xyzs(1:3,j)
         call MoltMatVec(rm, x1, x2)
         k = iabs(nz(j)) / nzConst
         if (k == ox .or. no(k) < 20) then
             Inte = 'ATOM   1393  CA  ALA  1002' //
     *       '      19.505   7.976  20.657  0.94 10.05           C'
             write(Inte(31:66),'(3f8.3,2f6.2)') x2(1:3), xyzs(5,j), bt
             write(Inte(7:11),'(i5)') n
             write(Inte(23:26),'(i4)') nResi
         else
             a2(1:2) = Species(k)(1:2)
             call ucase(a2)
             a1 = a2
             if (a2(2:2) == ' ') then
                 a2(2:2) = a2(1:1)
                 a2(1:1) = ' '
             endif
             a3 = ' ' // a1(1:2)
             write(Inte,20) a1(1:2), a3(1:3), x2(1:3), xyzs(5,j), bt,
     *                      a2(1:2)
             write(Inte(7:11),'(i5)') n
             write(Inte(23:26),'(i4)') nResi
             Inte(22:22) = ' '
         endif
         write(jhost,'(a)') Inte(1:L)
      enddo
!
      close(jrel)
      close(jhost)
      if (nkH > 0) then
          do i=1, nkH
             k = nwH(i) / nzConst
             a2 = Species(k)(1:2)
             call ucase(a2(1:1))
             write(lo,30) noH(i), a2
          enddo
      endif
!
      if (se > 0) then
*         call AddSe(se)
      endif
!
      return
   20 format('HETATM      ',a2,3x,a3,10x,3f8.3,2f6.2,10x,a2)
   30 format(12x,'Added heavy atom(s) ',i3,2x,a)
      end
!-----------------------------------------------------------------------
      subroutine DelHOH(In, Out, nBatch, ifAll)
      USE General
      USE Riflessi, only : iorde
      USE RemoModule
      USE ArpWarp
      USE Align
!
      implicit none
      integer :: i, j, k, kk, nAtoms, n, itype, iform, jop, jopen, ier
      integer :: isort, filtra, nModified, m, nBatch, ifAll
      real    :: B, Valore, soglia, sogliaH, coef, bmed, bnum
      logical :: ifHeavy
      real, allocatable    :: FattoreTermico(:)
      logical :: leggiB
      character (len=*) :: In, Out
      character (len=3) :: Heavy, tipoR
      character (len=4) :: tipoA
      character (len=6) :: bchar
!
      write(lo,100)
      nAtoms = sum(natsInModel(1:numbModels))
      allocate (FattoreTermico(1:nAtoms), stat = ier)
!
      ifHeavy = .false.
      write(Heavy,'(a1,a2)') ' ',Species(nk)(1:2)
      call shift(Heavy, kk)
      call ucase(Heavy)
      write(6,1) Heavy
    1 format(' Heavy >',a3,'<')
      itype = 0
      iform = 1
      jop = jopen(jrel, In, itype, iform, ier)


      itype = 0
      iform = 1
      jop = jopen(jhost, Out, itype, iform, ier)

      leggiB = .false.
      bmed = 0
      bnum = 0
      n = 0
      do
         read(jrel,'(a)',end=10) Inte
         if (Inte(1:6) == 'CRYST1') then
             leggiB = .true.
         endif
         if (leggiB) then
             if (Inte(1:4) == 'ATOM' .or. Inte(1:4) == 'HETA') then
                 bchar = Inte(61:66)
                 B = Valore(bchar)
                 tipoR = Inte(18:20)
                 if (tipoR == 'HOH') then
                     n = n + 1
                     FattoreTermico(n) = B
                 else
                     bmed = bmed + B
                     bnum = bnum + 1
                 endif
             endif
         endif
      enddo
   10 continue
      rewind jrel
!
      bmed = bmed / bnum 
      sogliaH = bmed * 1.5
      if (ifAll == 0) then
          i = -1
          call sortall(i, FattoreTermico, n)
          if (nBatch == 1) then
              n = 3 * n / 4
          else
              n = 2 * n / 3
          endif
          soglia = FattoreTermico(n)
      else
          soglia = -9999
      endif
!
      n = 0
      m = 0
      do
         read(jrel,'(a)',end=20) Inte
         if (Inte(1:4) == 'ATOM' .or. Inte(1:4) == 'HETA') then
             bchar = Inte(61:66)
             B = Valore(bchar)
             tipoR = Inte(18:20)
             call shift(tipoR, kk)
             call ucase(tipoR)
             if (tipoR == 'HOH') then
                 if (B < soglia) then
                     n = n + 1
                     write(jhost,'(a)') Inte(1:80)
                 endif
             elseif (tipoR == Heavy) then
                 ifHeavy = .true.
                 if (B < sogliaH) then
                     m = m + 1
                     write(jhost,'(a)') Inte(1:80)
                 endif
             else
                 write(jhost,'(a)') Inte(1:80)
             endif
         else
             write(jhost,'(a)') Inte(1:80)
         endif
      enddo
   20 continue

!
      close(jrel)
      close(jhost)
      deallocate (FattoreTermico, stat = ier)
      write(lo,110) n, soglia
      if (ifHeavy) then
          write(lo,115) m, sogliaH
      endif
      write(lo,100)
!
      return
  100 format(2x,70('X'))
  110 format(2x,10x,'Accepted ',i4,' waters, threshold = ',f8.2)
  115 format(2x,10x,'Accepted ',i4,' heavy atom(s), threshold = ',f8.2)
      end
!-----------------------------------------------------------------------
      subroutine calcolasumffTot
!
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE RemoModule
!
      implicit none
      integer :: i, j, k, Wmod, Wmon
      real    :: rho, eps, somma, sigmaN, sigmaP, ScattFact_MR
!
!-- sigmaN
!
      sigmaN = 0
      do i=1,nrefl
         rho = rhov(i)
         eps = epsv(i)
         somma = 0.0
         do j=1, nkSav
            ff(j) = clSav(j)
            do k=1, 4
               ff(j) = ff(j) + alSav(k,j) * exp(-bsSav(k,j) * rho)
            enddo
            somma = somma + nwSav(j) * (ff(j)**2)
         enddo
         sigmaN = sigmaN + somma
      enddo
!
!-- sigmaP
!
      sigmaP = 0.0
      do Wmod=1, numbModels
         somma = 0.0
         do i=1,nrefl
            rho = rhov(i)
            eps = epsv(i)
            do j=1, model(Wmod)%nk
               ff(j) = ScattFact_MR(j, rho, Wmod)
               somma = somma + model(Wmod)%nw(j) * totop*(ff(j)**2)
            enddo
         enddo
         sigmaP = sigmaP + somma
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine UseRefmacN(nRefi, ifDiff, nMacroRef, ier)
      USE General
      USE Riflessi
      USE PhaseModule, only : erore, erorepes
      USE RemoModule
      USE ArpWarp
      USE Align, only: testProc
      USE Grafici
      USE Molcom
!
      implicit none
      integer :: nRefi, ifDiff, ier, NREFMAC, k, Lung, nAtoms, ifAll
      integer :: Macro, nMacroRef, nBatch, nVolte, nVolteMax, previous
      integer :: MaxBatch, ndPhi, i, MOD_NREFMAC, FasiPerRefmac_Sav
      integer :: box, ierr
      real    :: R, Rfree, vecchioValore, RFree0, RFreen, DeltaRFree
      real    :: erreUsed, dPhi, dPhiSog, dif, RFreeRef
      character (len= 5)  :: a5
      character (len= 80) :: Stringa
      logical :: UsaRfree
      real, allocatable    :: FasiPrecedenti(:)
      real, allocatable    :: PesiPrecedenti(:)
!
      ifOutDsr = 0
      FasiPerRefmac_Sav = FasiPerRefmac
!
      if (nrefi == 0) then
          write(lo,110)
      else
          if (knw > 0) then
              if (FasiPerRefmac /= 0) then
                  if (ifCAB < 2) write(lo,100) nRefi
              else
                  if (ifCAB < 2) write(lo,120) nRefi
              endif
          endif
      endif
!
      ndPhi = 0
      dPhi = 99
      dPhiSog = 3.0
      allocate (FasiPrecedenti(1:nrefl), stat = ier)
      allocate (PesiPrecedenti(1:nrefl), stat = ier)
      FasiPrecedenti(:) = 0
      PesiPrecedenti(:) = 0
!
      if (ifCAB < 2) then
          if (knw > 0) then
*             write(lo,10)
*         else
              write(lo,15)
          endif
      endif
      UsaRfree = .true.
      UsaRfree = .false.
c      k = index(FichierOut,'_')
c      Stringa = FichierOut(1:k)
c      k = Lung(Stringa)
!
      NREFMAC = 0
      if (nRefi == 0) then
          vecchioValore = -9999
          erreUsed = -9999
          RFree0 = -9999 
      else
          vecchioValore = 9999
          erreUsed = 9999
          RFree0 = 9999 
      endif
      nVolteMax = 2
      tutto: do Macro=1, nMacroRef
         if (Macro == 1) then
             nVolteMax = 2
             MaxBatch = 30
         else
             nVolteMax = 1
             MaxBatch = 15
         endif
*        if (UsaRfree) then
*            nVolteMax = nVolteMax + 1
*        endif
         nVolte = 0
         do nBatch=1, MaxBatch ! 30
            FasiPerRefmac = FasiPerRefmac_Sav
            if (Macro == 3 .and. nBatch == 1) then !(nBatch == 1 .or. nBatch == 3)) then
                write(6,36) erore, erorepes
                call FDiffRemo(nBatch, previous)
            elseif (Macro == 4 .and. nBatch == 1) then !(nBatch == 1 .or. nBatch == 3)) then
                write(6,37) erore, erorepes
                FichierOut = nome(1:lnome) // '_refmac0.pdb'
                cardDiret  = nome(1:lnome) // '_refmac.pdb'
                call cCopyFile(FichierOut, cardDiret)
                ifAll = 1
                call DelHOH(cardDiret, FichierOut, nBatch, ifAll)
                nRefi = 3
                vecchioValore = 0
            endif
            NREFMAC = NREFMAC + nRefi
            TotRefmacCycles = TotRefmacCycles + nRefi
            if (testProc == 0) then
              call UseRefmac(FichierOut, nRefi, ifDiff, NREFMAC, 0, ier)
            else
              call UseRefmac(FichierOut,   1  , ifDiff, NREFMAC, 0, ier)
            endif
            if (ier < 0) then
                exit tutto
            endif
            if (UsaRfree) then
                erreUsed = RfreAW
            else
                erreUsed = RfacAW
            endif
!
            if (ndPhi == 0) then
                a5 = '     '
            else
                dPhi = 0
                ndPhi = 0
                do i=1, nrefl
                   if (wt(i) > 0.0 .and. PesiPrecedenti(i) > 0.0) then
                       dif = iphaz(i) - FasiPrecedenti(i)
                       dif = cos(dif * dtor)
                       dif = acos(dif) * rtod
                       if (dif > 180.0) dif = 360.0 - dif
                       dPhi = dPhi + dif
                       ndPhi = ndPhi + 1
                   endif
                enddo
                if (ndPhi > 0) dPhi = dPhi / float(ndPhi)
                write(a5,'(f5.2)') dPhi
            endif
            FasiPrecedenti(1:nrefl) = iphaz(1:nrefl)
            PesiPrecedenti(1:nrefl) = wt(1:nrefl)
            ndPhi = 1
            if (ifCAB < 2) then
                if (knw > 0 .or. ciclaRefmac == 1) then
                    if (knw == 0) then
                        write(lo,20) NREFMAC, RfacAW, RfreAW, a5
                    else
                        write(lo,20) NREFMAC, RfacAW, RfreAW, a5,
     *                               erore, erorepes, erreUsed
                    endif
                endif
            endif
!
            write(Msg,55) RfacAW , RfreAW, TotRefmacCycles
            call OneBlankOnly(Msg)
            box = lastBox
            call SameLine(Msg, color_GREEN, box)
            call zflush
            call DoSingleIteration()
!
            FichierOut = nome(1:lnome) // '_refmac0.pdb'
            cardDiret  = nome(1:lnome) // '_refmac.pdb'
            if (Macro == 3 .and. nBatch == 1) then !(nBatch == 1 .or. nBatch == 3)) then
                ifAll = 0
                call DelHOH(cardDiret, FichierOut, nBatch, ifAll)
                vecchioValore = 9999
                erreUsed      = 9998
            else
                call cCopyFile(cardDiret, FichierOut)
            endif
            if (erreUsed > vecchioValore) then
                nVolte = nVolte + 1
                if (nVolte == nVolteMax) then
                    if (ifPostCAB == 0 .and. knw > 0) then
                        write(6,65) ' EXIT IF nVolteMax', 
     *                              nVolte, nVolteMax
                    endif
                    exit
                else
                    erreUsed = vecchioValore
                endif
            endif
            vecchioValore = erreUsed
            if (Macro == 1 .and.  nBatch == 1) then
               RFree0 = erreUsed
               RFreeRef =  RfreAW
            endif
!
            if (testProc == 1) then
                exit
            endif
            if (dPhi < dPhiSog) then
                if (knw == 1 .and. kverbo > 0) then
                    if (ifPostCAB == 0 .and. knw > 0) then
                        write(6,70) 'D(phi): EXIT IF ',dPhi, dPhiSog
                    endif
                endif
                exit tutto
            endif
            MOD_NREFMAC = nRefi * 5
  
            if (ciclaRefmac == 1) then

              if (mod(NREFMAC,MOD_NREFMAC) == 0) then
!NEW          if (mod(NREFMAC,MOD_NREFMAC) == 0 .and.
!NEW *            NREFMAC/MOD_NREFMAC > 1) then       ! gianluca 26/09/2019
                if (knw == 1 .and. kverbo > 0) then
                    write(6,*) 'nRefi, MOD_NREFMAC ',nRefi,MOD_NREFMAC
                endif
                if (RfreAW > RFreeRef) then
                    if (knw == 1) then
                        write(6,50) 'Rfree: EXIT IF ',RfreAW, RFreeRef
                    endif
                    exit tutto
                else
                    RFreeRef = RfreAW
                endif
              endif

            else

              if (NREFMAC == nRefi) then
                if (knw == 1 .and. kverbo > 0) then
                    write(6,*) 'nRefi, NREFMAC ',nRefi,NREFMAC
                endif
                exit tutto
              endif

            endif
!
         enddo
!
         vecchioValore = 9999
      enddo tutto
!
      RFreen = erreUsed 
      DeltaRFree = ( RFree0 - RFreen)/ RFreen
      if (ifCompareModel == 0 .and. ifPostCAB == 0) then
          if (knw == 1) then
              if (ifCAB < 2 .and. knw > 0) then
                  write(6,30) 'NREFMAC',NREFMAC, DeltaRFree
                  write(lo,40) NREFMAC, RfacAW, RfreAW, erore, erorepes
                  if (statoMR < 0) then
                      write(6,80) erore, RfacAW, RfreAW
                  elseif (statoMR > 5) then
                      write(6,85) erore, RfacAW, RfreAW
                  else
                      write(6,90) erore, statoMR, RfacAW, RfreAW
                  endif
              endif
          endif
      endif
!
      deallocate (FasiPrecedenti, PesiPrecedenti, stat = ierr)
!
      return
   10 format(' Cycles  R factor',3x,'R free',3x,'D(phi)')
   15 format(/,' Cycles  R factor',3x,'R free',3x,'D(phi)',
     *      3x,'MPE     wMPE       R test')
   20 format(2x,i3,3x,f8.4,2x,f8.4,3x,a5,2f8.2,5x,f8.4)
   30 format(2x,a,i5,'   Delta(Rfree) =',f9.4)
   35 format(2x,'BMOD   ',2f8.2)
   36 format(2x,'ADDW   ',2f8.2)
   37 format(2x,'DELH   ',2f8.2)
   40 format(2x,'After ',i3,' Refmac cycles: ',f8.4,2x,f8.4,2f8.2)
   45 format(2x,'REFMAC ',i3,' ; ',f8.4,' ; ',f8.2,' ; ')
   50 format(a,f8.4,' >',f8.4)
   55 format('R =',f7.4,'  (Rfree =',f7.4,') after ',i5,
     *       ' Refmac cycles')
   60 format('REFMAC MPE',f8.2,' ;',/,'NCICLI ',i3,' ;')
   65 format(a,3x, 2i4)
   70 format(a,f8.2,' <',f8.2)
   80 format(/,'IMPROVE: REFMAC',f8.2,' ; PreMutazioni :',
     *                               ' Rf =',f8.3,' Rfree =',f8.3)
   85 format(/,'IMPROVE: REFMAC',f8.2,' ; NUOVO Blocco :',
     *                               ' Rf =',f8.3,' Rfree =',f8.3)
   90 format(/,'IMPROVE: REFMAC',f8.2,' ; Mutazione #',i4,
     *                               ' Rf =',f8.3,' Rfree =',f8.3)
  100 format(/,' Starting Refmac: batches of ',i2,' cycles',/)
  110 format(/,' Phases are computed using Refmac')
  120 format(' Starting Phases-Driven Refmac: batches of ',i2,
     *         ' cycles')
      end
!-----------------------------------------------------------------------
      subroutine FDiffProva(nRefi, MTZfileSav)
      USE General
      USE PhaseModule
      USE ArpWarp
!
      implicit none
      integer :: i, nBatch, previous, nRefi, ifDiff, NREFMAC, ier
      real    :: erreUsed, vecchioValore
      character (len=256) :: MTZfileSav
!
      nrefi = 5
      vecchioValore = 9999
      write(6,35) erore, erorepes
      ier = 0
      nBatch = 2
      previous = 1
      ifDiff = 0
      NREFMAC = 0
!
      call FDiffRemo(nBatch, previous)

      do i=1, 10

         NREFMAC = NREFMAC + nRefi
         call UseRefmac(FichierOut, nRefi, ifDiff, NREFMAC, 0, ier)
         erreUsed = RfacAW
         if (knw == 0) then
             write(lo,20) NREFMAC, RfacAW, RfreAW
         else
             write(lo,20) NREFMAC, RfacAW, RfreAW, erore, erorepes,
     *                    erreUsed
         endif
         if (erreUsed > vecchioValore) then
             exit
         else
             vecchioValore = erreUsed
         endif
         FichierOut = nome(1:lnome) // '_refmac0.pdb'
         cardDiret  = nome(1:lnome) // '_refmac.pdb'
         call cCopyFile(cardDiret, FichierOut)

      enddo

!
      return
   20 format(2x,i3,3x,f8.4,2x,f8.4,2f8.2,5x,f8.4)
   35 format(2x,'NEWD   ',2f8.2)
      end
!-----------------------------------------------------------------------
      subroutine FDiffRemo(nBatch, previous)
      USE General
      USE Riflessi
      USE Mappa
      USE RemoModule
      USE PhaseModule
      USE Atomi
      USE ArpWarp
!
      implicit none
      integer :: nRefi, ifDiff, NREFMAC, ier, nAdd, ifVLDSav, nset
      integer :: ishift, nBatch, previous
      real    :: fig(11), dmSav, ttt, dxmax
      common /fasi/ nset
      common /misc/ ttt(3,3), dxmax(3),ishift(3,19)
!
!     if (ifMtzMap == 2 .and. ifMutate == 1) then
      if (ifMtzMap == 2                    ) then
          call PutGetFinalPhases(1, nset, fig)
          ifVLDSav = ifVLD
          ifVLD    = 0
          call WriteMapForCoot(0)
          ifVLD = ifVLDSav
      endif
!
!-- Calcola FC
!
      nRefi = 0
      ifDiff = 1
      NREFMAC = 0
      call UseRefmac(FichierOut, nRefi, ifDiff, NREFMAC, 0, ier)
      fcoef(1:nrefl) = fcvet(1:nrefl)
      call MakeMap(fcoef, iphaz, nrefl, 0, xmap, FORTH, BACK)
!
      call Init_pksrch(dm)
*     dmSav = dm
!
*     dm0 = 1
!
*     dxmax(1)=dm0*cell(2)*cell(3)*sin(dtor*cell(4))/volume
*     dxmax(2)=dm0*cell(3)*cell(1)*sin(dtor*cell(5))/volume
*     dxmax(3)=dm0*cell(1)*cell(2)*sin(dtor*cell(6))/volume
*     dm=dm0*dm0
!
      aperc(1) = 0.2 * (anat - natsInModel(WhichModel))
      if (nBatch == 1) then
          aperc(1) = 0.2 * (natsInModel(WhichModel))
      else
          aperc(1) = 0.1 * (natsInModel(WhichModel))
      endif
      krecy = 0
      call pksrch_New(-1, 0, nrefl, ier)
*     dm = dmSav
      nAdd = nats
      write(6,100)
      write(6,110) nAdd
      call AddHOH(nAdd, nBatch)
*     call AddCA(nAdd, nBatch, previous)
      write(6,100)
      FichierOut = nome(1:lnome) // '_refmac0.pdb'
      cardDiret  = nome(1:lnome) // '_refmac.pdb'
      call cCopyFile(FichierOut, cardDiret)
!
      return
  100 format(2x,70('X'))
  110 format(2x,10x,'Added ',i5,' waters')
      end
!-----------------------------------------------------------------------
      subroutine AnalizzaPDB(In, Out)
      USE General
      USE Riflessi, only : iorde
      USE RemoModule
      USE ArpWarp
      USE Align
!
      implicit none
      integer :: i, j, k, kk, nAtoms, n, itype, iform, jop, jopen, ier
      integer :: isort, filtra, nModified, nSmall
      real    :: B, Valore, soglia, coef, bmed, bterm, bmedNew
      real, allocatable    :: FattoreTermico(:)
      logical :: leggiB
      character (len=*) :: In, Out
      character (len=4) :: tipoA
      character (len=6) :: bchar
!
      nAtoms = sum(natsInModel(1:numbModels))
      allocate (FattoreTermico(1:nAtoms), stat = ier)

      itype = 0
      iform = 1
      jop = jopen(jrel, In, itype, iform, ier)


      itype = 0
      iform = 1
      jop = jopen(jhost, Out, itype, iform, ier)

      leggiB = .false.
      n = 0
      do
         read(jrel,'(a)',end=10) Inte
         if (Inte(1:6) == 'CRYST1') then
             leggiB = .true.
         endif
         if (leggiB) then
             if (Inte(1:4) == 'ATOM') then
                 n = n + 1
                 bchar = Inte(61:66)
                 B = Valore(bchar)
                 FattoreTermico(n) = B
             endif
         endif
      enddo
   10 continue
      rewind jrel
!
      nModified = 0
      nSmall = 0
      bmed = sum(FattoreTermico(1:n)) / float(n)
      soglia = 1.5 * bmed
      write(6,*) 'B(Wilson), <B>, soglia', bt, bmed, soglia
      i = -1
      call sortall(i, FattoreTermico, n)
      n = n / 10
      soglia = FattoreTermico(n)
!
      n = 0
      bmedNew = 0
      leggiB = .false.
      do
         read(jrel,'(a)',end=20) Inte
         if (Inte(1:4) == 'ATOM') then

             bchar = Inte(61:66)
             B = Valore(bchar)
             coef = B / bt
             coef = B / bmed
*            B =  amin1( B * coef, 2 * bt )
             if (coef > 1.0) then
*                B = B * sqrt( coef )
                 B = B * coef
                 if (B > 500) then
                     B = 500
                 endif
                 nModified = nModified + 1
                 write(Inte(61:66),'(f6.2)') B
                 n = n + 1
                 bmedNew = bmedNew + B
             elseif (coef < 0.75) then
                 B = B * sqrt( coef )
                 if (B > 500) then
                     B = 500
                 endif
                 nSmall = nSmall + 1
                 nModified = nModified + 1
                 write(Inte(61:66),'(f6.2)') B
                 n = n + 1
                 bmedNew = bmedNew + B
             else
                 n = n + 1
                 bmedNew = bmedNew + B
             endif
             write(jhost,'(a)') Inte(1:80)
         else
             write(jhost,'(a)') Inte(1:80)
         endif
      enddo
   20 continue

!
      close(jrel)
      close(jhost)
      deallocate (FattoreTermico, stat = ier)
!
      if (knw == 1) then
          B = 100 * float(nModified) / float(nAtoms)
          write(6,100)
          write(6,130) nModified, nAtoms, B
          B = 100 * float(nSmall) / float(nAtoms)
          write(6,135) nSmall, nAtoms, B
          write(6,100)
          write(6,*) 'New <B>', bmedNew/float(n)
      endif
!
      return
  100 format(2x,70('X'))
  110 format(2x,10x,'coef = B / bt')
  120 format(2x,10x,'B =  amin1( B * coef, 2 * bt )')
  130 format(2x,'Modificato il B(>>) per ',i5,'/',i5,' atomi ',f6.2,'%')
  135 format(2x,'Modificato il B(<<) per ',i5,'/',i5,' atomi ',f6.2,'%')
      end
!-----------------------------------------------------------------------
      subroutine SucchiaPDB(filename, n)
      USE General
      USE Atomi
!
      implicit none
      integer :: n, i, j, l, jop, jopen, itype, iform, ios
      real    :: xmatr(3,3), x1(3), x2(3)
      character (len=*) :: filename
      character (len=4) :: a4
!
      itype = 2
      iform = 1
      jop = jopen(jhost, filename, itype, iform, ios)
      if (.not.allocated(xyzs)) then
          call AllocaAtomi(1)
      endif
!
      do i=1, nk
         a4 = Species(i)
         call ucase(a4)
         vSpecie(i) = a4
      enddo
      n = 0
      do
         read(jhost,'(a)',end=10) cardImage
         if (cardImage(1:6) == 'SCALE1') then
             read(cardImage,20)(xmatr(1,j),j=1,3)
             read(jhost,20)(xmatr(2,j),j=1,3)
             read(jhost,20)(xmatr(3,j),j=1,3)
         elseif (cardImage(1:4) == 'ATOM' .or.
     *           cardImage(1:4) == 'HETA') then
             n = n + 1
             read(cardImage,30) xyzs(1:3,n), xyzs(5,n), bfac(n),a4
             read(cardImage(23:26),'(i4)') nzSav(n)
             Inte = cardImage(7:22)
*            write(Inte,'(a,i6)') a4,n
             call NoBlanks(Inte, l)
             aLab(n) = Inte(1:l)
             call shift(a4, i)
             call ucase(a4)
             nz(n) = nzConst
             do i=1, nk
                if (a4 == vSpecie(i)) then
                    nz(n) = i * nzConst
                    exit
                endif
             enddo
         endif
      enddo
   10 close(jhost)
      do i=1, n
         x1(1:3) = xyzs(1:3,i)
         call MoltMatVec(xmatr, x1, x2)
         xyzs(1:3,i) = x2(1:3)
      enddo
!
      return
   20 format(10x,3f10.6)
   30 format(30x,3f8.3,2f6.2,10x,a4)
      end
!-----------------------------------------------------------------------
      subroutine LoadPDBtoMutate(stampa)
      USE General
      USE Atomi
      USE RemoModule
      USE ArpWarp
      USE Align
!
      implicit none
      integer :: jop, jopen, istat, iform, ier, inizio, fine, CA, m1
      integer :: i, j, k, l, n1, n3, nCA, oldRes, CodiceResiduo1
      integer :: jumpR, stampa, ifHet, nSecondary
      character (len=1) :: a1
      character (len=4) :: SpeciesTmp(18), a4, tipoA, tipoR
!
      ifHet = 0
      jumpR = jumpRes
      cardDiret = nome(1:lnome) // '_refmac0.pdb'
      istat = 2
      iform = 1
      jop = jopen(jhost, cardDiret, istat, iform, ier)
      if (jop < 0) then
          jop = jopen(jhost, FichierOut, istat, iform, ier)
      else
          FichierOut = cardDiret
      endif
!
      if (ifLoadedPDB) then
          call DeallocaModello(WhichModel, ier)
      else
          nMolMR = 1
          WhichModel = 1
          call AllocaAtomi(2)      ! gianluca 17 ottobre 2014
          call AllocaModelRemo(2)
          nats = anat * 1.1
          numbModels = 1
          call AllocaAtomi(-1)
      endif
      call ManagePDBSir(0, 0, 0, 0, 1, ier)
      if (ier < 0) then
          return
      endif
      close(jhost)
!
      SpeciesTmp(1:18) = Species(1:18)
      call RestoreLists123(3)   ! modificato dalla lettura del PDB
!
      do i=1, natsInModel(WhichModel)
         k = model(WhichModel)%specie(i,1) / nzConst
         a4 = SpeciesTmp(k)
         do j=1, nk
            if (a4 == Species(j)) then
                k = j
                exit
            endif
         enddo
         model(WhichModel)%specie(i,1) = k * nzConst
      enddo
!
      call GetModel
!
!-- crea la tavola dei residui (TableM)
!
!   TableM(i, 1) = serial number of CA in the i-th residue
!   TableM(i, 2) = serial number of the first atom in the i-th residue
!   TableM(i, 3) = serial number of the last atom in the i-th residue
!   TableM(i, 4) = code of the i-th residue
!   TableM(i, 5) = code of the i-th residue in the model sequence
!   TableM(i, 6) = code of the i-th residue in the target sequence
!   TableM(i, 7) = 1 the i-th residue can be changed
!                = 0 the i-th residue has been changed
!                = -1 the i-th cannot be changed
!   TableM(i, 8) = ascii code of the secondary structure element
!
      nCA = 0
      oldRes = -9999
      inizio = 0
      fine   = 0
      CA = 0
      do i=1, natsInModel(WhichModel)
         if (model(WhichModel)%numResiduo(i,1) /= oldRes .or.
     *       i == natsInModel(WhichModel)) then
             if (inizio > 0) then
                 
                 if (i == natsInModel(WhichModel)) then
                     fine = i
                 else
                     fine = i - 1
                 endif
                 nCA = model(WhichModel)%numResiduo(fine,1)
                 tipoR = model(WhichModel)%tipoResiduo(fine,1)
                 call ucase(tipoR)
                 if (tipoR(1:3) == 'MSE') then
                     tipoR(1:3) = 'MET'
                 endif
                 n3 = 0
                 do l=1, NumberAminoAcids
                    if (tipoR(1:3) == AminoCode3(l)) then
                        n3 = l
                        exit
                    endif
                 enddo
!
                 m1 = CodiceResiduo1(sequenceA(nCA))
                 n1 = CodiceResiduo1(sequenceB(nCA))
                 TableM(nCA,1) = CA
                 TableM(nCA,2) = inizio
                 TableM(nCA,3) = fine
                 TableM(nCA,4) = n3
                 TableM(nCA,5) = n1
                 TableM(nCA,6) = m1
!   TableM(i, 4) = code of the i-th residue
!   TableM(i, 5) = code of the i-th residue in the model sequence
!   TableM(i, 6) = code of the i-th residue in the target sequence
                
                 if (vettCA(nCA) == 2) then
                     vettCA(nCA) = 1
                     TableM(nCA,7) = 0
                 endif
                 if (stampa == 1) then
                     if (m1 == 0) then
                         a1 = '-'
                     else
                         a1 = AminoCode1(m1)
                     endif
                     write(lo,10) nCA, TableM(nCA,1:3), 
     *                     AminoCode3(TableM(nCA,4)),
     *                     AminoCode1(TableM(nCA,4)), a1
                 endif
             endif
             nCA = model(WhichModel)%numResiduo(i,1)
             inizio = i
             oldRes = model(WhichModel)%numResiduo(i,1)
             CA = 0
         endif
         tipoA = model(WhichModel)%tipoAtomo(i,1)
         call ucase(tipoA)
         if (tipoA == 'CA  '. and. CA == 0) then
             CA = i
         endif
      enddo
!
      numeroCA = model(WhichModel)%numResiduo(fine,1)
!
      do i=1, nAllinea
         if (vettCA(i) == 2) then
             write(6,*) 'RESIDUE',i,' not generated by Coot'
             vettCA(i) = 0
             countCoot(i) = countCoot(i) + 1
             if (countCoot(i) <= 3) then
                 TableM(i,7) = 1
             else
                 TableM(i,7) = -1
             endif
         endif
      enddo
!
!-- secondary structure analysys
!
      nats = natsInModel(WhichModel)
      allocate(CSecondary(nats))
      nSecondary = 0
      call SecondaryStructureInfo(nats, nSecondary, CSecondary)
      do i=1, nAllinea
         j = TableM(i,1)
         if (j > 0) then
             a1 = CSecondary(j)
             if (a1 == 'H' .or. a1 == 'G' .or. a1 == 'G') then
                 a1 = 'H'
             elseif (a1 == 'E') then
                 a1 = 'B'
             else
                 a1 = 'L'
             endif
             TableM(i, 8) = ichar(a1)
         else
             TableM(i, 8) = ichar(blank)
         endif
      enddo
      deallocate(CSecondary)
!
      return
   10 format(i5,1h),3i5,2x,a3,2x,a1,2x,a1)
      end
!-----------------------------------------------------------------------
      subroutine CutChain()
      USE General
      USE Atomi
      USE RemoModule
      USE ArpWarp
      USE Align
!
      implicit none
      integer :: jop, jopen, istat, iform, ier, filtra, delete, deleted
      integer :: i, j,jj, k,ii,newRes,oldRes, ifHET, seqA, stampa, ndel
      integer :: previous, nModelChain(50,2), nres, nchain, natomxc
      integer :: lim1,lim2,lim11, k1, k2, ivect(6),k1old
      real :: baver, bterm
      logical :: continua
      character (len=1) :: a1, altA, altB, cat, oldCat
      character (len=4) :: SpeciesTmp(18), a4, tipoA, tipoB
!
!-- re-arrange residues sequence number
!-- and delete model residues not in target
!

      stampa = 0
      call LoadPDBtoMutate(stampa)
      deleted=0
      delete=0 
      seqA = 0
      newRes = 0
      nres = 0
      oldRes = -9999
      nchain=0
      oldCat = "x"
      do i=1, natsInModel(WhichModel)
         k = model(WhichModel)%numResiduo(i,1)
         cat = model(WhichModel)%catena(i,1)
         if(cat/=oldCat)then
             oldCat=cat
             if(nchain>0)then
                nModelChain(nchain,1)=nres 
                nModelChain(nchain,2)=natomxc
             endif
             nchain=nchain+1
             nres=1
             natomxc=1
             if (k /= oldRes)oldRes=k
         else
             if (k /= oldRes)then
                nres = nres + 1
                oldRes=k 
             endif
             natomxc=natomxc+1
         endif
      enddo
      numbRes=nres
      nModelChain(nchain,1)=nres 
      nModelChain(nchain,2)=natomxc

      seqA = 0 
      oldRes = -9999
      nchain = 0
      oldCat = "x"
      j=0
      jj=9999
      lim1=0
      lim11=0  
      lim2=0
      do i=1, natsInModel(WhichModel) 
            k = model(WhichModel)%numResiduo(i,1)
            cat = model(WhichModel)%catena(i,1)
            if(cat/=oldCat)then
               oldCat=cat
               nchain=nchain+1
               if (j > 0) then
                   ivect=0
                   ii=0
                   k1old=0 
                   do k2=lim11+1, j
                      model(WhichModel)%HETA(k2,1) = -1
                      k1 = model(WhichModel)%numResiduo(k2,1)
                      TableM(k1,1) = 0
                      if(k1.ne.k1old)then
                         ii=ii+1 
                         k1old=k1
                         ivect(ii)=k1
                      endif
                   enddo
                   do k2=1,6
                    if(ivect(k2).ne.0)then
                      if (knw == 1) 
     *                write(6,*)"terminal residues cut at the top:",
     *                        ivect(k2)
                    endif
                   enddo
               endif
               if (jj < 9999)then
                   ii=0
                   ivect=0 
                   k1old=0
                   do k2=jj, i-1
                      model(WhichModel)%HETA(k2,1) = -1
                      k1 = model(WhichModel)%numResiduo(k2,1)
                      TableM(k1,1) = 0
                      if(k1.ne.k1old)then
                         ii=ii+1 
                         k1old=k1
                         ivect(ii)=k1
                      endif
                   enddo
                   do k2=1,6
                    if(ivect(k2).ne.0)then
                      if (knw == 1) 
     *                write(6,*)"terminal residues cut at the end:",
     *                        ivect(k2)
                    endif
                   enddo
               endif
               j=0
               jj=9999  
            endif
            if (k /= oldRes) then
               deleted=0
c               delete=0 
               seqA = seqA + 1
               ii = TableM(k,8)
               delete = 0  
               if(nchain>1)lim1=sum(nModelChain(1:(nchain-1),1))
               if(nchain>1)lim11=sum(nModelChain(1:(nchain-1),2))
               lim2=sum(nModelChain(1:nchain,1))
               if(ii== 76 .and.
     *           (seqA<(lim1+6).or.seqA>(lim2-6)))then
                  if(seqA<(lim1+6))then
                     deleted=1
                     j=i
                  elseif(seqA>(lim2-6))then
                     if(i<jj)then
c                       delete=1
                       jj=i
                     endif  
                  endif 
                endif 
               oldRes = k
            else
               if(deleted==1)then
                 j=i
c               else if(delete==1)then
c                 jj=i 
               endif 
            endif
      enddo
      if (j > 0) then
          ii=0
          ivect=0 
          k1old=0
          do k2=lim11+1, j
             model(WhichModel)%HETA(k2,1) = -1
             k1 = model(WhichModel)%numResiduo(k2,1)
             TableM(k1,1) = 0
             if(k1.ne.k1old)then
                ii=ii+1 
                k1old=k1
                ivect(ii)=k1
             endif
          enddo
          do k2=1,6
            if(ivect(k2).ne.0)then
              if (knw == 1) 
     *        write(6,*)"terminal residues cut at the end:",
     *                        ivect(k2)
            endif
          enddo
      endif
      if (jj < 9999) then
          ii=0
          ivect=0
          k1old=0
          do k2=jj, natsInModel(WhichModel)
             model(WhichModel)%HETA(k2,1) = -1
             k1 = model(WhichModel)%numResiduo(k2,1)
             TableM(k1,1) = 0
             if(k1.ne.k1old)then
                ii=ii+1 
                k1old=k1
                ivect(ii)=k1
             endif
          enddo
          do k2=1,6
            if(ivect(k2).ne.0)then
              if (knw == 1) 
     *        write(6,*)"terminal residues cut at the end:",
     *                        ivect(k2)
            endif
          enddo  
      endif
      FichierOut = nome(1:lnome) // '_refmac0.pdb'
      istat = 0
      iform = 1
      jop = jopen(jhost, FichierOut, istat, iform, ier)
      filtra = 1
      call outPDB(jhost, 0, 0, 0, filtra)
*     call DeallocaModello(WhichModel, ier)
*     ifHET = 0
*     call ManagePDBSir(0, 0, ifHET, 0, 1, ier)

      close(jhost)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine SistemaPDB
      USE General
      USE Atomi
      USE RemoModule
      USE Groups
      USE ArpWarp
      USE Align
!
      implicit none
      integer :: jop, jopen, istat, iform, ier, filtra, delete, deleted
      integer :: i, j, k, newRes, oldRes, ifHET, seqA, stampa, ndel
      integer :: previous, ntipoA, j1, j2, iniz, CodiceResiduo3
      logical :: continua
      character (len=1) :: sA, sB, altA, altB, cat
      character (len=3) :: tipoR
      character (len=4) :: SpeciesTmp(18), a4, tipoA, tipoB
      character (len=4) , allocatable :: tipoAvet(:)
!
      j = 0
      do i=1, nChainsInput
         if (tChains(i) == 1) then
             j = j + 1
         endif
      enddo
      if (j == 0) then
          return
      endif
!
      cardDiret = nome(1:lnome) // '_refmac0.pdb'
      istat = 2
      iform = 1
      jop = jopen(jhost, FichierOut, istat, iform, ier)
!
      deleted = 0
*     if (ifMutate == 1) then
          write(lo,10)
          write(lo,*)
          write(lo,20)
*     endif
      nMolMR = 1
      WhichModel = 1
      call AllocaModelRemo(2)
      call AllocaAtomi(2)
      i = 0
      do
         read(jhost,'(a)',end=1) Inte
         i = i + 1
      enddo
    1 nats = i
      rewind jhost
      numbModels = 1
      call AllocaAtomi(-1)
      ifHET = 0
      call ManagePDBSir(0, 0, ifHET, 0, 1, ier)
      close(jhost)
!
      SpeciesTmp(1:18) = Species(1:18)
      call RestoreLists123(3)   ! modificato dalla lettura del PDB
!
      do i=1, natsInModel(WhichModel)
         k = model(WhichModel)%specie(i,1) / nzConst
         a4 = SpeciesTmp(k)
         do j=1, nk
            if (a4 == Species(j)) then
                k = j
                exit
            endif
         enddo
         model(WhichModel)%specie(i,1) = k * nzConst
      enddo
!
      allocate(tipoAvet(1:natsInModel(WhichModel)), stat=ier)
!
!-- flag and delete disordered atoms
!
      oldRes = model(WhichModel)%numResiduo(1,1)
      ntipoA = 0
      iniz = 1
      do i=1, natsInModel(WhichModel)
         tipoA = model(WhichModel)%tipoAtomo(i,1)
         call ucase(tipoA)
         k = model(WhichModel)%numResiduo(i,1)
         if (k /= oldRes) then
             do j1=1, ntipoA-1
                do j2=j1+1, ntipoA
                   if (tipoAvet(j2) == tipoAvet(j1)) then
                       j = iniz + j2 - 1
                       model(WhichModel)%HETA(j,1) = -1
                   endif
                enddo
             enddo
             oldRes = k
             ntipoA = 1
             tipoAvet(ntipoA) = tipoA
             iniz = i
         else
             ntipoA = ntipoA + 1
             tipoAvet(ntipoA) = tipoA
         endif
         if (tipoA(1:3) == 'OT ') then
             model(WhichModel)%HETA(i,1) = -1
         endif
      enddo
!
!-- last residue
!
      if (ntipoA > 1) then
          do j1=1, ntipoA-1
             do j2=j1+1, ntipoA
                if (tipoAvet(j2) == tipoAvet(j1)) then
                    j = iniz + j2 - 1
                    model(WhichModel)%HETA(j,1) = -1
                endif
             enddo
          enddo
      endif
!
!-- re-arrange residues sequence number
!-- and delete model residues not in target
!
*     if (ifMutate == 1) then
          seqA = 0
          newRes = 0
          oldRes = -9999
          do i=1, natsInModel(WhichModel)
             k = model(WhichModel)%numResiduo(i,1)
             if (k /= oldRes) then
                 newRes = newRes + 1
                 seqA = seqA + 1
                 continua = .true.
                 do while (continua)
                    sA = sequenceA(seqA)
                    sB = sequenceB(seqA)
                    if (sB == '-') then
                        if (sA == '-') then
*                           continua = .false.
                            seqA = seqA + 1
                        else
                            newRes = newRes + 1
                            seqA = seqA + 1
                        endif
                    else
                        continua = .false.
                    endif
                 enddo
                 delete = 0
                 sA = sequenceA(seqA)
                 if (sA == '-' .or. seqA > nAllinea)then
                     tipoR = model(WhichModel)%tipoResiduo(i,1)
                     call ucase(tipoR)
                     if (CodiceResiduo3(tipoR) > 0) then
                         newRes = newRes - 1
                         delete = 1
                         if (seqA <= nAllinea) then
                             deleted = 1
                         endif
                     endif
                 endif
                 model(WhichModel)%numResiduo(i,1) = newRes
                 if (delete == 1) then
                     model(WhichModel)%HETA(i,1) = -1
                 endif
                 oldRes = k
             else
                 model(WhichModel)%numResiduo(i,1) = newRes
                 if (delete == 1) then
                     model(WhichModel)%HETA(i,1) = -1
                 endif
             endif
          enddo
*     endif
!
!-- clean "Alternate" flag and set occupancy = 1 for all atoms
!
      model(WhichModel)%Alternate(1:natsInModel(WhichModel),1) = ' '
      model(WhichModel)%atoms(5,1:natsInModel(WhichModel),1) = 1.0
!
!-- re-arrange sequences alignment
!
      deleted = 1
      if (deleted == 1) then
          deleted = 0
          j = 0
          nCateneTarget = 1
          ndel = 0
          previous = CateneTarget(nCateneTarget)
          do i=1, nAllinea
             if (i > previous) then
                 CateneTarget(nCateneTarget) = 
     *                         CateneTarget(nCateneTarget) - ndel
                 nCateneTarget = nCateneTarget + 1
                 previous = previous + CateneTarget(nCateneTarget)
                 ndel = 0
             endif
             sA = sequenceA(i)
             if (sA /= '-') then
                 j = j + 1
                 sequenceA(j) = sequenceA(i)
                 sequenceB(j) = sequenceB(i)
                 sequenceM(j) = sequenceM(i)
             else
                 ndel = ndel + 1
                 deleted = deleted + 1
             endif
          enddo
          if (ndel > 0) then
              CateneTarget(nCateneTarget) = 
     *                      CateneTarget(nCateneTarget) - ndel
          endif
          nAllinea = sum(CateneTarget(1:nCateneTarget))
          write(lo,30)
  
          stampa = 0
          call FinalAlign(stampa)
      endif
!
      write(lo,10)
      FichierOut = nome(1:lnome) // '_refmac0.pdb'
      istat = 0
      iform = 1
      jop = jopen(jhost, FichierOut, istat, iform, ier)
      filtra = 1
      call outPDB(jhost, 0, 0, 0, filtra)
      close(jhost)
!
      ifLoadedPDB = .true.
      deallocate(tipoAvet, stat=ier)
! modifica dopo idSeqThre = 0.4
c     if (idSeq < 0.4) then
          call CutChain()
c     endif
!
      return
   10 format(80('-'))
   20 format(' PDB file is cleaned and re-numbered',/)
   30 format('New Alignment:',/)
      end
!-----------------------------------------------------------------------
      subroutine AlanizzaBterm(nMutated)
      USE General
      USE Riflessi
      USE Atomi
      USE RemoModule
      USE Groups
      USE Align, only: CCP4map
!
      implicit none
      integer :: jop, jopen, istat, iform, ier, i, j, n, k, oldRes
      integer :: ifHET, L, Lung, cat, nMutated, stampa, nRefi, nExtC
      integer :: maxToMutate, nCicli, ii, nr, nFatt
      real    :: B, Bres, Btot, nA, perc, soglia
      logical :: MutaRes
      character (len=1) :: catena
      character (len=3) :: tipoR
      character (len=4) :: SpeciesTmp(18)
      real, allocatable :: FattoriTermici(:,:)
!
      stampa = 0
      perc = 0.2
      perc = 0.8
*     perc = 1.0

      nMutated = 0
      cardDiret = nome(1:lnome) // '_refmac0.pdb'
      istat = 2
      iform = 1
      jop = jopen(jhost, FichierOut, istat, iform, ier)
!
      if (knw > 0) write(lo,10)
      nMolMR = 1
      WhichModel = 1
      call AllocaModelRemo(2)
      call AllocaAtomi(2)
      call AllocaAtomi(2)
      i = 0
      do
         read(jhost,'(a)',end=1) Inte
         i = i + 1
      enddo
    1 nats = i
      rewind jhost
      numbModels = 1
      call AllocaAtomi(-1)
      ifHET = 0
      call ManagePDBSir(0, 0, ifHET, 0, 1, ier)
      close(jhost)
      SpeciesTmp(1:18) = Species(1:18)
      call RestoreLists123(3)   ! modificato dalla lettura del PDB
!
!-- conta il numero di residui
!
      oldRes = -9999
      nFatt = 0
      do i=1, natsInModel(WhichModel)
         k = model(WhichModel)%numResiduo(i,1)
         if (k /= oldRes) then
             nFatt = nFatt + 1
             oldRes = k
         endif
      enddo
      allocate(FattoriTermici(nFatt, 4), stat=ier)
!
!-- calcola il <B> dei singoli residui e il <B> del modello
!
      Btot = 0
      oldRes = -9999
      n = 0
      do i=1, natsInModel(WhichModel)
         catena = model(WhichModel)%catena(i,1)
         call ucase(catena)
         cat = ichar(catena)
         k = model(WhichModel)%numResiduo(i,1)
         tipoR = model(WhichModel)%tipoResiduo(i,1)
         call ucase(tipoR)
         B = model(WhichModel)%th_fact(i,1)
         Btot = Btot + B
         if (k /= oldRes) then
             if (n > 0) then
                 FattoriTermici(n,1) = Bres / nA
             endif
             Bres = B
             nA = 1
             n = n + 1
             oldRes = k
             FattoriTermici(n,2) = k
             FattoriTermici(n,4) = cat
             do j=1, 22
                if (tipoR == AminoName3(j)) then
                    FattoriTermici(n,3) = j
                    exit
                endif
             enddo
         else
             Bres = Bres + B
             nA = nA + 1
         endif
      enddo
      if (nA > 0) then
          FattoriTermici(n,1) = Bres / nA
      endif
!
      Btot = Btot / float(natsInModel(WhichModel))
      write(lo,20) nint(perc*100)
      if (knw > 0) then
          write(6,*) n, ' RESIDUI, <Btot> = ', Btot
          write(lo,*)
      endif
!
      do i=1, n
         jwork1(i) = i
         work1(i) = FattoriTermici(i,1)
      enddo
      call sort3_big(work1, jwork1, worko, n)
      i = perc * float(n)
      soglia = worko(i)
*     soglia = -999
      do i=1, n
         if (FattoriTermici(i,3) /= 1) then
             if (FattoriTermici(i,1) > soglia) then
                 FattoriTermici(i,1) = -FattoriTermici(i,1)
                 nMutated = nMutated + 1
             endif
         endif
      enddo

      if (knw > 0) then
          write(6,*) 'MUTA ', nMutated, ' RESIDUI'
      endif
*     if (nMutated > 300) then
          maxToMutate =max(100, int(nMutated/3))
          nCicli = nMutated / maxToMutate
          if (mod(nMutated, maxToMutate) > 0) then
              nCicli = nCicli + 1
          endif
*     else
*         maxToMutate = nMutated
*         nCicli = 1
*     endif
      call MakeALA(nFatt, FattoriTermici, nCicli, n, maxToMutate)

      deallocate(FattoriTermici, stat=ier)

*     stop
!
      return
   10 format(80('-'))
   20 format(/,i3,'% of the residues will be transformed in alanine',/)
   25 format(/,' Resid Name Chain    <B>')
   30 format(i6,2x,a,3x,a,3x,f8.3)
   40 format(2x,i5,' mutated residue(s)')
      end
!-----------------------------------------------------------------------
      subroutine MakeALA(nFatt, FattoriTermici, nCicli, n, maxToMutate)
      USE General
      USE Atomi
      USE RemoModule
      USE Groups
      USE ArpWarp
!
      implicit none
      integer :: nFatt, istat, iform, jop, jopen, ier, nCicli, i, ii, j
      integer :: n, nr, cat, cat1, maxToMutate, filtra, stampa, nRefi
      integer :: nExtC, res, res1, k, Lung, nzz
      real    :: FattoriTermici(nFatt, 4)
      character (len=1) :: catena
      character (len=3) :: tipoR
      character (len=4) :: tipoA, atomo, spec
!
      cardDiret = nome(1:lnome) // '_bef.pdb'
      call cCopyFile(FichierOut, cardDiret)
      if (knw > 0) then
          write(6,*) 'SAVED ', FichierOut(1:Lung(FichierOut))
          write(6,*) 'Species ', Species(1:nk)
      endif
      do i=1, natsInModel(WhichModel)
         atomo = model(WhichModel)%AtSpecies(i,1)
         call ucase(atomo)
         do j=1, nk
            spec = Species(j)
            call ucase(spec)
            if (atomo == spec) then
                model(WhichModel)%specie(i,1) = j * nzConst
                exit
            endif
         enddo
      enddo
!
      tipoR = 'ALA'
      do ii=1, nCicli
          if (knw > 0) write(lo,25)
          nr = 0
          do k=1, n
             if (FattoriTermici(k,1) < 0) then
                 nr = nr + 1
                 FattoriTermici(k,1) = -FattoriTermici(k,1)
                 res = FattoriTermici(k,2)
                 cat = nint(FattoriTermici(k,4))
                 j = FattoriTermici(k,3)
                 if (knw > 0) then
                     write(6,30) iabs(nint(FattoriTermici(k,2))),
     *                           AminoName3(j),
     *                           char(cat), abs(FattoriTermici(k,1))
                 endif
                 do i=1, natsInModel(WhichModel)
                    catena = model(WhichModel)%catena(i,1)
                    call ucase(catena)
                    cat1 = ichar(catena)
                    res1 = model(WhichModel)%numResiduo(i,1)
                    if (cat == cat1 .and. res == res1) then
                        tipoA = model(WhichModel)%tipoAtomo(i,1)
                        call ucase(tipoA)
                        if (tipoA(1:3) == 'N  ' .or.
     *                      tipoA(1:3) == 'CA ' .or.
     *                      tipoA(1:3) == 'CB ' .or.
     *                      tipoA(1:3) == 'C  ' .or.
     *                      tipoA(1:3) == 'O  ') then
                            model(WhichModel)%tipoResiduo(i,1) = tipoR
                        else
                            model(WhichModel)%HETA(i,1) = -1
                        endif
                    endif
                 enddo
                 if (nr == maxToMutate) exit
             endif
          enddo
          write(lo,40) nr
!
!-- write modified PDB file
!
          cardDiret = nome(1:lnome) // '_tmp.pdb'
          istat = 0
          iform = 1
          jop = jopen(jrel, cardDiret, istat, iform, ier)
          filtra = 1
          call outPDB(jrel, -1, 0, 0, filtra)
          close(jrel)
          call cCopyFile(cardDiret, FichierOut)
!
!-- start Refmac
!
*         stampa = 0
*         call LoadPDBtoMutate(stampa)
          FichierOut = nome(1:lnome) // '_refmac0.pdb'
          nRefi = 10
          nExtC = 1
*         j = FasiPerRefmac
*         FasiPerRefmac = 0
          if (knw == 0) write(lo,100) nRefi
          call UseRefmacN(nRefi, 0, nExtC, ier)
*         FasiPerRefmac = j
!
      enddo ! nCicli
!
      return
   25 format(/,' Resid Name Chain    <B>')
   30 format(i6,2x,a,3x,a,3x,f8.3)
   40 format(2x,i5,' residue(s) mutated in alanine')
  100 format(/,' Starting Refmac: batches of ',i2,' cycles',//,
     *         ' Cycles  R factor',3x,'R free',3x,'D(phi)')
      end
!-----------------------------------------------------------------------
      integer function CodiceResiduo1(codice)
      USE Align
!
      implicit none
      integer :: i
      character (len=1) :: codice
!
      CodiceResiduo1 = 0
      do i=1, NumberAminoAcids
         if (codice == AminoCode1(i)) then
             CodiceResiduo1 = i
             exit
         endif
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      integer function CodiceResiduo3(codice)
      USE Align
!
      implicit none
      integer :: i
      character (len=3) :: codice
!
      CodiceResiduo3 = 0
      do i=1, NumberAminoAcids
         if (codice == AminoCode3(i)) then
             CodiceResiduo3 = i
             exit
         endif
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine WriteMapForCoot(onlyMap)
      USE General
      USE Riflessi
      USE Mappa
      USE Align
      USE Param
      USE ArpWarp
      USE PhaseModule
!
      implicit none
      integer :: jpatt, nse, kQuantiSets, ier, SavGen, stampaMTZ
      integer :: onlyMap
      real    :: f000Sav
!
      nse = 9991
      call examin(nse, mkang, khl, ipub, iphaz, nrefl, 0, wt, 1)
!
      jpatt = 0
      fcoef(:) = evet(:) * wt(:)
*     fcoef(:) = fovet(:) * wt(:)
      f000Sav = f000
      f000 = 0.0
      call MakeMap(fcoef, iphaz, nrefl, jpatt, xmap, FORTH, BACK)
      f000 = f000Sav
!
      call CCP4MAPOUT(jpatt, xmap, np, CCP4map)
      if (onlyMap == 0) then
          cardDiret  = nome(1:lnome) // '_ccp4_map1.map'
          call cCopyFile(CCP4map, cardDiret)
!
          kQuantiSets = nSetsFineDSR
!
          SavGen = numbGen
          numbGen = 0
          stampaMTZ = 0
          call WriteMTZ(1, 0, kQuantiSets, stampaMTZ, ier)
          numbGen = SavGen
          cardDiret  = nome(1:lnome) // '_mtzsav.mtz'
          call cCopyFile(MTZfile, cardDiret)
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine CombinaFasiPesi_MR(numb,wt_in,ph_in,wt,iphaz,coefOld)
!
      USE General, only : dtor, rtod, knw
      USE Riflessi, only : mkang, khl, ipub
      implicit none
      integer :: numb, i, ph_in(numb), iphaz(numb), ipri
      real    :: wt_in(numb), wt(numb)
      real    :: coefOld, coefNew, wtOld, phOld, wtNew, phNew
      real    :: TangNum, TangDen, sog
!
c     ipri = kverbo
      ipri = 0

      if (knw==1 .and. ipri > 0) then
          write(6,*) ' CombinaFasiPesi_MR'
          call examin(101, mkang, khl, ipub, ph_in, numb, 0, wt_in, 1)
          call examin(102, mkang, khl, ipub, iphaz, numb, 0, wt, 1)
      endif
!
c     coefOld = 0.2
      coefNew = 1.0 - coefOld
      do i=1, numb
         wtOld = wt_in(i)
         phOld = ph_in(i) * dtor
         wtNew = wt(i)
         phNew = iphaz(i) * dtor
         if (wtOld > 0.001 .and. wtNew > 0.001) then
             TangNum = coefOld * wtOld * sin(phOld) +
     *                 coefNew * wtNew * sin(phNew)
             TangDen = coefOld * wtOld * cos(phOld) +
     *                 coefNew * wtNew * cos(phNew)
             phNew = atan2(TangNum, TangDen) * rtod + 3600
             iphaz(i) = mod(nint(phNew), 360)
             wt(i) = wtOld
         elseif (wtOld > 0.001 .and. wtNew < 0.001) then
             iphaz(i) = ph_in(i)
             wt(i) = wtOld
         endif
      enddo
!
      if (knw==1 .and. ipri > 0) then
          call examin(103, mkang, khl, ipub, iphaz, numb, 0, wt, 1)
      endif
!
      return
      end
!-----------------------------------------------------------------
      subroutine Select_Refl_MR(iact)
      USE General
      USE Riflessi
      USE PhaseModule
      USE Mappa
      USE HistoStuff
      USE RemoModule
      USE Param , only :f000  
!
      implicit none
      integer :: i, j, k, ii, iai, iact, ifin, ipri
      integer :: nbru, izero, ifmin, numb
      integer :: ipher, ijij, jiji
      integer :: ij, ji, iii, jjj, jpatt, jflag, numb_accept, ncond1
      integer :: nSetsFineDSR_Sav
      real    :: sog, sog_res, sog_wt, zero, f000_back, coefOld
      real    :: ssogg
      character (len=11) :: tirang
!
! iact = -1  !RETURN
!
! iact = 0   !REFMAC
! iact = 1   !VLD
!
c     ipri = kverbo
      ipri = 0

      if (iact < 0 ) return    ! esco dalla subroutine

      return    ! NEW ! commentare x versione 26 giugno
!
      zero = 0.000001
!
      fcvetp(1:nrefl) = fcvet(1:nrefl)

      do i = 1,nrefl
          if (fcvet(i) < zero) then
              fcvet(i) = 0.0
          endif
      enddo

      call F2ENew(1,nrefl)
c
c-- Rinormalizzo Ecalc per riflessi osservati
c
      do j = 1,nrefl
         work1(j) = fcvetv(j)
         work2(j) = rhov(j)
      enddo
      call Renor2004(0)
      do j = 1,nrefl
         fcvetv(j) = work1(j)
      enddo

!-- Inserisco criterio di selezione di fasi e pesi prima di VLD-EDM
!
      f000_back=f000
      f000=0.0
      waveare = 0.0
      exposigma = 2.0
!
      if (knw == 1) then
          if (ipri == 0) then
              ipher = -1  !1
              ifmin = 0 !1
          else
              ipher = 1 
              ifmin = 1
          endif
          nbru = 1000
          izero = 0
          call examin(nbru,mkang,khl,ipub,iphaz,nrefl,izero,
     *                wt,ifmin)

          if (iact == 0) then
              tirang = 'REFMAC  Wt.'
          else
              tirang = 'mod. VLD Wt'
          endif
         
          call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
     *          ipub,iphaz,wt,10,0.0,ipher)

          write(6,5)  erore, erorepes, isumal
      endif


      ifin = 1  !5
      do iai = 1,ifin

         tmpwt(:) = 0.0
         worko(:) = 0.0
         ssogg = 1.7 + 0.1*iai

         do j=1,nrefl
            if (evet(j) > ssogg*fcvetv(j)) then 
                tmpwt(j) = wt(j)
                worko(j) = evet(j) - (ssogg*fcvetv(j))
            endif
         enddo

         if (knw == 1 .and. ipri > 0) then
             write(6,*) ' Ro > ',ssogg,' * Rc'
             nbru = j
             izero = 0
             ifmin = 1
             call examin(nbru,mkang,khl,ipub,iphaz,nrefl,izero,
     *                tmpwt,ifmin)
   
             tirang = 'Ro-sog*Rc '
             ipher = 1
             call pherrdisNew(tirang,worko,khl,mkang,nrefl,
     *                izero,ipub,iphaz,tmpwt,10,0.0,ipher)
    
             tirang = 'Wt        '
             call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
     *                ipub,iphaz,tmpwt,10,0.0,ipher)
        endif

        do j=1,nrefl
           if (evet(j) > ssogg*fcvetv(j)) then
               if (wt(j) < 0.5) then
                  wt(j) = wt(j)**1.5
               else
                  wt(j) = wt(j)**1.25
               endif
           else
               if (wt(j) < 0.5) then
                  wt(j) = wt(j)**0.95
               else
                  wt(j) = wt(j)**0.9
               endif
           endif
        enddo

        if (knw == 1 .and. ipri > 0) then
             write(6,*) ' Dopo Modifica Pesi'
             nbru = j
             izero = 0
             ifmin = 1
             call examin(nbru,mkang,khl,ipub,iphaz,nrefl,izero,
     *                wt,ifmin)

            tirang = 'Wt Modif. '
            call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
     *                ipub,iphaz,wt,10,0.0,ipher)

        endif
      enddo  !iai
! 
      do i = 1,2

!        if (i == 1) then
!            sog_wt = 0.2
!        else
!            sog_wt = 0.3  
!        endif

         sog_wt = 0.15  !0.2

         ncond1 = 0
         do j=1,nrefl
            if (wt(j) < sog_wt) then
                wt(j) = 0.0
            else
                ncond1 = ncond1 + 1
            endif
         enddo
!
         if (knw == 1 .and. ipri > 0) then
             write(6,*) 'SOG_WT, NUMB_ACCEPT',sog_wt,ncond1
             nbru = j
             izero = 0
             ifmin = 1
             call examin(nbru,mkang,khl,ipub,iphaz,nrefl,izero,
     *                  wt,ifmin)

             tirang = 'SELEZ.  Wt.'
             izero = 0
             ipher = 1
             call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
     *                ipub,iphaz,wt,10,0.0,ipher)
         endif
! 
         iphazo(:) = 0
         worko(:) = 0.0
         do iii  = 1, nrefl
            iphazo(iii) = iphaz(iii)
            if (wt(iii) > zero) then
                worko(iii) = wt(iii)
            else
                worko(iii) = -99.9
            endif
         enddo
!

         do ij = 1,2

            do ji = 1,1 !2

               fcoef(:) = evet(:) * wt(:)
               jpatt = 0
               call MakeMap(fcoef, iphaz, nrefl, jpatt, xmap,
     *                FORTH, BACK)

               invflag = 1  !3
               percMap  = 0.035

c
c--inverto la mappa
c
               call InvMap(khl,mkang,iphaz,fcvet,nrefl)

               jflag  = -2
               call PresigmaA(jflag, 0)
               waveare = sum(wt(1:nrefl))/float(nrefl)

               if (knw == 1 .and. ipri > 0) then
                   nbru = ji*10
                   izero = 0
                   ifmin = 1
                   call examin(nbru,mkang,khl,ipub,iphaz,nrefl,izero,
     *                   wt,ifmin)

                   tirang = 'NEWINV  Wt.'
                   izero = 0
                   ipher = 1
                   call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
     *                ipub,iphaz,wt,10,0.0,ipher)
               endif

             enddo  !ji


!
            coefOld = 0.8
            call CombinaFasiPesi_MR(nrefl,worko,iphazo,wt,iphaz,coefOld)
!
            if (knw == 1 .and. ipri > 0) then
                write(6,*) ' Dopo CombinaFasiPesi_MR'
                nbru = ij*100
                izero = 0
                ifmin = 1
                call examin(nbru,mkang,khl,ipub,iphaz,nrefl,izero,
     *                   wt,ifmin)
                tirang = 'COMBINA Wt.'
                izero = 0
                ipher = 1
                call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
     *                ipub,iphaz,wt,10,0.0,ipher)
            endif

         enddo !ij 

       enddo !i

c        if (iact == 0) then
c            write(6,10)  erore, erorepes
c        else
c            write(6,20)  erore, erorepes
c        endif

        do iai = 1,ifin

            tmpwt(:) = 0.0
            worko(:) = 0.0
            ssogg = 1.7 + 0.1*iai

            do j=1,nrefl
               if (evet(j) > ssogg*fcvetv(j)) then
                   tmpwt(j) = wt(j)
                   worko(j) = evet(j) - (ssogg*fcvetv(j))
               endif
            enddo

            if (knw == 1 .and. ipri > 0) then
                write(6,*) ' Ro > ',ssogg,' * Rc'

                tirang = 'Ro-sog*Rc '
                call pherrdisNew(tirang,worko,khl,mkang,nrefl,
     *                izero,ipub,iphaz,tmpwt,10,0.0,ipher)

                tirang = 'Wt Final  '
                call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
     *                ipub,iphaz,tmpwt,10,0.0,ipher)

            endif

            do j=1,nrefl
               if (evet(j) > ssogg*fcvetv(j)) then
                   if (wt(j) < 0.5) then
                      wt(j) = wt(j)**1.5
                   else
                      wt(j) = wt(j)**1.25
                   endif
               else
                   if (wt(j) < 0.5) then
                      wt(j) = wt(j)**0.95
                   else
                      wt(j) = wt(j)**0.9
                   endif
               endif
            enddo

            if (knw == 1) then
                if (ipri == 0) then
                    ipher = -1  !1
                    ifmin = 0 !1
                else
                    ipher = 1
                    ifmin = 1
                endif
                nbru = 2000
                izero = 0
                call examin(nbru,mkang,khl,ipub,iphaz,nrefl,izero,
     *                   wt,ifmin)

                tirang = 'Wt Fin Mod'
                call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
     *                ipub,iphaz,wt,10,0.0,ipher)
            endif

        enddo  !iai

  !!!    enddo !ij 

!!!    enddo !i

         if (knw == 1 .and. ipri > 0) then
            if (iact == 0) then
                write(6,10)  erore, erorepes, isumal
            else
                write(6,20)  erore, erorepes, isumal
            endif
         endif

         write(6,30)  erore, erorepes, isumal

!
        f000=f000_back
        iphazo(:) = 0
        worko(:) = 0.0
        fcvet(1:nrefl) = fcvetp(1:nrefl)

  5   format(/,'Entro in  Select_Refl_MR  MPE', 2f8.2,i10)
 10   format('IMPROVE: REFMAC Wtmod MPE', 2f8.2,i10)
 20   format('IMPROVE: VLD    Wtmod MPE', 2f8.2,i10)
 30   format('Esco  da  Select_Refl_MR  MPE', 2f8.2,i10,/)


      return
      end
!-----------------------------------------------------------------------
      subroutine RestoreMTZPhases(MTZRestore)
      USE General
      USE Riflessi
      USE Align
      USE Param
      USE ArpWarp
!
      implicit none
      integer :: lix1, lix2, iAction, ier, knwSav, deleted, nse, stampa
      integer :: i, istat, iform, jop, jopen, nRefi
      real    :: celltemp(13)
      character (len=256) :: MTZRestore
!
      MTZfile  = MTZRestore
!
      lix1 = 1
      lix2 = 1
      Lab_Ch(1) = 'H'
      Lab_Ch(2) = 'K'
      Lab_Ch(3) = 'L'
      Lab_Ch(4) = 'F'
      Lab_Ch(5) = 'SIGF'
      Lab_Ch(7) = 'FOM'
c     Lab_Ch(6) = 'PHIC'    ! fase
c     Lab_Ch(8) = 'FWT'      ! fc


      Lab_Ch(6) = 'PHIC_ALL' ! fase
      Lab_Ch(8) = 'FC_ALL'   ! fc


      ier = 0
      knwSav = knw
      ifMTZlab = 1
      do iAction =1, 2
         call ManageMTZ(iAction, celltemp, lix1, lix2, ier)
         if (ier /= 0) then
             return
         endif
      enddo
      knw = 0
      call LeggiMTZPhase(ier)
!
      iAction = 3
      call ManageMTZ(iAction, celltemp, lix1, lix2, ier)
!
      knw = knwSav
      nse = 9992
      call examin(nse, mkang, khl, ipub, iphaz, nrefl, 0, wt, 1)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine RestoreMTZ_PDBFiles(MTZRestore, PDBRestore, 
     *           VettRisultati, doRicicla, stampaInfo, 
     *           ifRestore, ifReje, ier)
      USE General
      USE Riflessi
      USE PhaseModule
      USE ArpWarp
      USE Groups
!
      implicit none
      integer :: ier, iAction, lix1, lix2, nExitCode, ksubr
      integer :: Lung, cod, ifmin, knwSav, ifBreak, doRicicla
      integer :: k, kk, kStripTask1, stampaInfo, ipher
      integer :: ifRestore, ifReje
      real    :: celltemp(13), correl, VecchioCoverage
      real    :: VettRisultati(10)
      logical :: Esiste
      character tirang * 11
      character(len=256) :: cardDriret, MTZRestore, PDBRestore
!
      ifRestore = 1
      ier = 0
      cardDiret = MTZRestore
      inquire (file=cardDiret,  exist = Esiste)
      if (.not.Esiste) then
          write(lo,*) 
     *   'RESTORE MTZ file not possible - Error reading MTZ file ' 
     *    // MTZRestore(1:Lung(MTZRestore))
          ier = 100
      endif

      cardDiret = PDBRestore
      inquire (file=cardDiret,  exist = Esiste)
      if (.not.Esiste) then
          write(lo,*) 
     *   'RESTORE PDB file not possible - Error reading PDB file ' 
     *    // PDBRestore(1:Lung(PDBRestore))
          ier = 100
      endif
!
      if (ier == 100) return
!
      kWstop = 0
      ier = 0
!
      if (ifAmbMR == 0) then
          return
      endif
!
      MTZfile = MTZRestore
      FichierOut  = PDBRestore
c     AmbPDB  = PDBRestore
!
      if (knw > 0) then
          write(lo,10) MTZRestore(1:Lung(MTZRestore))
      endif
      lix1 = 1
      lix2 = 1
      Lab_Ch(1) = 'H'
      Lab_Ch(2) = 'K'
      Lab_Ch(3) = 'L'
      Lab_Ch(4) = 'F'
      Lab_Ch(5) = 'SIGF'
      Lab_Ch(7) = 'FOM'      ! peso
      if (ifReje == 1) then
          Lab_Ch(6) = 'PHIC_ALL' ! fase
          Lab_Ch(8) = 'FC_ALL'   ! fc
      elseif (ifReje == 2) then
          Lab_Ch(6) = 'PHIC' ! fase
          Lab_Ch(8) = 'FC'   ! fc
      endif

      ifMTZlab = 1

      do iAction =1, 2
         call ManageMTZ(iAction, celltemp, lix1, lix2, ier)
         if (ier /= 0) then
             Msg = 'Error reading MTZ file ' // MTZfile(1:Lung(MTZfile))
             call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
             doRicicla = 0
             return
         endif
      enddo
!
      iAction = 1
      call AllocaRiflessi(iAction)
      ksubr = 4
      call LeggiRiflessi(ier, ksubr)
!
      knwSav = knw
      knw = 0
      call LeggiMTZPhase(ier)
!
      iAction = 3
      call ManageMTZ(iAction, celltemp, lix1, lix2, ier)     !mr
!
      knw = knwSav
      if (knw > 0) then
          ifmin = 1
          cod = 9992
          call examin(cod, mkang, khl, ipub, iphaz, nrefl, 0, wt, ifmin)
          
          tirang = 'Distr. MTZ '
          ipher = 1
          call pherrdisNew(tirang,wt,khl,mkang,nrefl,0,
     *                    ipub,iphaz,wt,10,0.0,ipher)

          VettRisultati(4) = erore
          
          if (ifReje == 1) then
              if (ifAmbMR == 1) then
                  write(lo,20) 'Buccaneer',erore, erorepes, isumal
              elseif (ifAmbMR == 2) then
                  write(lo,20) 'Arp/Warp',erore, erorepes, isumal
              elseif (ifAmbMR == 3) then
                  write(lo,20) 'Phenix',erore, erorepes, isumal
              elseif (ifAmbMR == 4) then
                  write(lo,20) 'Nautilus',erore, erorepes, isumal
              endif
          elseif (ifReje == 2) then
                  write(lo,20) 'Refmac',erore, erorepes, isumal
          endif
      endif
!
      if (knw > 0) then
          write(lo,15) PDBRestore(1:Lung(PDBRestore))
      endif
!
      return
   10 format(//,2x,'Reading phases from ',a)
   15 format(//,2x,'Reading coordinates from ',a)
   20 format(/,2x,'After RESTORE ',a,' - Mean Phase Error ',f6.2,
     *       '  (',f6.2,')  over',i8,' reflections')
      end
!-----------------------------------------------------------------------
      Integer Function Cnk(N, K)
!
!   Ritorna il numero delle combinazioni semplici
!   di N oggetti presi a gruppi di K. Se K = 0 e',
!   per definizione, Cnk(N, 0) = 1:
!
      Integer   Prodotto

      Cnk = Prodotto(N, N - K + 1) / Prodotto(K, -1)
!
      return
      end
!-----------------------------------------------------------------------
!   Ottimizzazione delle Rotazioni
!-----------------------------------------------------------------------
      subroutine OptiRotSolution()  ! Simplesso per le Rotazioni
      USE General
      USE Symmetry
      Use Atomi
      USE Riflessi
      USE Solutions
      USE Grafici
      USE RemoModule
      USE PhaseModule
      USE Molcom
      USE RuotaRiflessi
      USE riflessi_c
      USE Html
      USE Mappa
!
      common / PerFun0 / isol
!
      character stringa*20, string1*11, string2*80
      real :: b(3,3), vet1(3), vet2(3), vet3(3,500)
      real :: xopti(6), prt_fom(5), factrSav
      integer :: ivet2(3), s, npSav(3)


      if (ifPositioned == 1) then
          return
      endif

      write(lo,20)
      write(lo,15) '  OPTIMIZATION STAGE:',
     *       '       clusterized rotation refinement via SIMPLEX method'
      write(lo,20)
!
      call scrper(' ',0,0)
!
      do i=1,nSolToExplore
            isol = solcan(i)%ipunt
!
         write(string1,10) i, nSolToExplore
         call NoBlanks(string1,k1)
         string2 = ' '
         Msg = 'Optimizing solution  '// string1(1:k1) // string2
         call scrper(Msg,i,nSolToExplore)
!
         WhichSolution = solcan(i)%ipunt
         xopti(1:3) = solcan(WhichSolution)%RotVal(1:3)
         xopti(4:6) =  0.0
         vet3(1:3,i) = solcan(WhichSolution)%RotVal(1:3) ! salvo i valori per stampa
         fopti1 = solcan(WhichSolution)%RotFom

         do ijk = 1,2
c           write(6,444) ijk,i,WhichSolution, xopti(1:3)*rtod,fopti1
            call LocalMinRot(xopti,fopti1)!rocco
c           write(6,445) ijk,i,WhichSolution, xopti(1:3)*rtod,fopti1
         enddo

            solcan(WhichSolution)%RotVal(1:3) =  xopti(1:3)  ! aggiorno gli angoli di rotazione
      enddo

 444  format('XOPTI3 in ingresso',i4,2i7,3f10.5,f9.5)
 445  format('XOPTI3 in uscita  ',i4,2i7,3f10.5,f9.5)
 


c     write(lo,20)
c     write(6,554)
c 554 format('XXXINFO Sol.  Trial     tet1   tet2   tet3    RFom',
c    *'     tet1N  tet2N  tet3N  RFomN')


      do ij=1,nSolToExplore

         isol = solcan(ij)%ipunt
         WhichSolution = solcan(ij)%ipunt
         xopti(1:3) = solcan(WhichSolution)%RotVal(1:3)
         tet1 = xopti(1)
         tet2 = xopti(2)
         tet3 = xopti(3)
!
!-- applico la matrice di rotazione
!
         call RotationOper1(b,tet1,tet2,tet3)
c
c--ricavo i nuovi indici di Miller nel sistema del modello
c
         Ecal2_med = 0.0
         do i=1,nreflSelRot
c                k = k_mem(i)
             tcalc=0.0
             do jj=1,nsym
                do io=1, 3
                   vet2(io) = 0
                   do jo=1, 3
                      vet2(io) = vet2(io)+ b(io,jo)* khlv_eq(jo,jj,2,i)
                   enddo
                enddo
                call controllo_indici_interi(vet2,ivet2)
c
c---costruisco il vettore superindice per gli osservati ruotati
c
                indr = ivet2(1)*ifat1C + ivet2(2)*ifat2C + ivet2(3)
                if (indr <= 0) then
                    j = 0
                endif
                if (indr <= ifatxC .and. indr > 0) then
                   j = superind(indr)
                   if (j > 0) then
                      if(use_E) then
                        tcalc=tcalc+ecvetc(j)    !  Ecalc**2 da modello
                      else
                        tcalc=tcalc+fcvetc(j)
                      endif
                     endif
                  endif
                enddo
                ModuliSel(1,i) = sqrt(tcalc)

               Ecal2_med = Ecal2_med + tcalc

             enddo

              Ecal2_med = Ecal2_med / nreflSelRot
c             write(6,*) '<Rp**2> = ', Ecal2_med
              sca = 1.0 / Ecal2_med
              do i=1,nreflSelRot
                 tcalc = sca*(ModuliSel(1,i)**2)
                 ModuliSel(1,i) = sqrt(tcalc)
              enddo

c 
c--calcolo della funzione costo
c
             if(use_E) then
                call CalcolaCosto2(costo)
c                   kverbo = 0  !100
                iact = 1 
                prt_fom(:) = 0.0
                call Calcola_FinalFom_MR(isol,iact,costo,prt_fom)
                costo = FinalFom
c                   kverbo = 0 
c               call CalcolaCosto_Rot(costo,prt_fom)
             else
               call CalcolaCostoProva(costo) 
             endif
!
c            write(6,555) ij, WhichSolution, vet3(1:3,ij)*rtod, 
c    *      solcan(WhichSolution)%RotFom, xopti(1:3)*rtod,costo

c555  format('XXXINFO',i5,i7,2(3x,3f7.1,f9.5))

!
!--memorizzo la nuova funzione costo e i nuovi parametri
!
             solcan(WhichSolution)%RotFom = costo
             solcan(WhichSolution)%RFom(1:5) = prt_fom(1:5)

         enddo

         iwork1(:) = 0
         iwork3(:) = 0
         work3(:) = 0.0

         do j=1,nSolToExplore
            WhichSolution = solcan(j)%ipunt
            work3(j) = solcan(WhichSolution)%RotFom
            iwork3(j) = j
         enddo
         iuno = -1
         call sortall3(iuno,work3,iuno,nSolToExplore,iwork3)

c        write(lo,50)
         do j=1,nSolToExplore
            ii = iwork3(j)
            WhichSolution = solcan(ii)%ipunt
            iwork1(j) = WhichSolution
c           write(lo,60) j,WhichSolution,
c    *             solcan(WhichSolution)%RotVal(1:3)*rtod,
c    *                       solcan(WhichSolution)%RotFom
         enddo

       write(lo,20)
       write(lo,50)
       do j=1,nSolToExplore
         solcan(j)%ipunt = iwork1(j) 
         WhichSolution = solcan(j)%ipunt
         write(lo,60) j,WhichSolution,
     *             solcan(WhichSolution)%RotVal(1:3)*rtod,
     *                       solcan(WhichSolution)%RotFom
       enddo

       return


   10 format(i5,'/',i5 )
   15 format(a)
   20 format(80('-'))
   50 format(4x,' Solution   Trial     Rotation values      RFom')
   60 format(8x,i5,i8,2x,3f6.1,f10.3)


       end
!-----------------------------------------------------------------------
      subroutine LocalMinRot(xopti,fopti)
c
      USE General
      USE Mappa
      USE RemoModule
c
c--versione per subplex
c

      integer niwmax,nwmax,nxmax
      parameter (niwmax=300,nwmax=300,nxmax=300)
c     parameter (niwmax=6,nwmax=6,nxmax=6)
      dimension xopti(6)
      integer iwork(niwmax),
     *        maxnfe,mdcont,mdsing,mduser,mode,
     *        nf1,nf2,nfe,nfinc,n
      double precision    fx,scale(nxmax),
     *        tol,tol1,tol2,tolfac,work(nwmax),x(nwmax)
c
c subroutines and functions
c
      double precision fun0
      external fun0,subplx
!
      logical :: noWrite,plusModel
      integer :: ncount, maxcount
      common /util2/ noWrite, ncount, maxcount,plusModel


      ncount = 0
      nsubplx = 0
c
c-----------------------------------------------------------
c
c--valori per R
c
c     tol1=0.5
c     tol2=1.e-2
c     tolfac=0.5
c     nf1=100
c     nf2=1000
c     nfinc=100
c     scl=0.1
cc    scale(1) = -abs(scl)
c     scale(1:3) = 0.2
c     scale(4:6) = 0.1
c
c--valori per 1-corre
c
      tol1=0.1!0.25
      tol2=0.001!0.5  ! occhio
cc    tol2=0.10
      tolfac=0.5
      nf1=200!100
      nf2=1000!500
      nfinc=100
c     scl=0.1
c     scale(1:3) = 0.6
c     scale(4:6) = 0.2
c     scale(1:3) = 0.087  ! 5 gradi
c     scale(1:3) = step*1.2 ! quello delle rotazioni
      scale(1:3) = step*5.0 ! quello delle rotazioni
c     scale(4:6) = 0.01
      tol=tol1
      maxnfe=nf1
c     fxold=fopti
c     tolfx=1.e-4
c
c--riprendo i parametri iniziali 
c
c     scale(4:6)=0.0
      x(1:3)= xopti(1:3)
      n=3
c     write (6,*) 'scale',scale(1:n)
c      write (6,'(a,6f15.6)') 'prim',x(1)*rtod,x(2)*rtod,x(3)*rtod,
c     &           (x(i),i=4,n)
c
c First call to subplx so continuation mode is off.
c
      mdcont = 0
c
c Using default options so user options mode is off.
c
      mduser = 0
c
c Using optimization so single-step mode is off.
c
      mdsing = 0

   20   continue

      nsubplx = nsubplx + 1
      call DoSingleIteration()
      mode = 4*mdsing + 2*mduser + mdcont
      call subplx (fun0,n,tol,maxnfe,mode,scale,x,fx,nfe,
     *                     work,iwork,iflag)
c
c Print intermediate results.
c
c        write (6,1020) maxnfe,tol,fx,nfe,iflag
1020    format (t5,i6,t15,e10.2,t30,e20.10,t45,
     *          i6,t60,i5)
c
c Check iflag to see if done or which termination
c test needs to be reset before resuming optimization.
        if (iflag .eq. -1) then
          if (maxnfe .ge. nf2) go to 30
          maxnfe = maxnfe+nfinc
        else if (iflag .eq. 0) then
c         if(abs(fx-fxold)<tolfx) then
c              write(6,*) 'tolfx',fx,fxold,fx-fxold
c              go to 30  ! occhio
c         endif
          if (tol .le. tol2) go to 30
          tol = tol*tolfac
c         fxold=fx
        else
          go to 30
        end if
c
c Resume optimization in continuation mode.
c
        mdcont=1
        go to 20
c
c Print optimization results.
c
   30   continue
c       write (6,1025) iflag,flgdsc(iflag)
c1025   format (' iflag =',i3,5x,'(',a26,')')
c       write (6,1030) nfe,fx
c1030   format (/1x,'nfe=',i7,5x,'fx=',e16.8/)
c       write (6,'(a,6f15.6)') 'dopo',x(1)*rtod,x(2)*rtod,x(3)*rtod,
c     &           (x(i),i=4,n)
c
c--prendo i valori ottimizzati
c
      xopti(1:3)=x(1:3)
      n=3

      fopti=fx
c
      return
      end
c-----------------------------------------------------------------
      double precision function fun0(n,x)
c
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Mappa
      USE Riflessi
      USE RuotaRiflessi
      USE RemoModule
      USE PhaseModule
      USE riflessi_c 
!
      common / PerFun0 / isol
!
      integer n
      double precision x(n)
      real :: b(3,3), vet1(3), vet2(3), prt_fom(5)
      integer :: ivet2(3), s
      
c
c--posiziono il modello in funzione dei nuovi parametri 
c
      tet1 = x(1)
      tet2 = x(2)
      tet3 = x(3)
      call RotationOper1(b,tet1,tet2,tet3)
c
c--ricavo i nuovi indici di Miller nel sistema del modello
c
         Ecal2_med = 0.0
         do i=1,nreflSelRot
c                k = k_mem(i)
             tcalc=0.0
             do jj=1,nsym
                do io=1, 3
                   vet2(io) = 0
                   do jo=1, 3
                      vet2(io) = vet2(io)+ b(io,jo)* khlv_eq(jo,jj,2,i)
                   enddo
                enddo
                call controllo_indici_interi(vet2,ivet2)
c
c---costruisco il vettore superindice per gli osservati ruotati
c
                indr = ivet2(1)*ifat1C + ivet2(2)*ifat2C + ivet2(3)
                if (indr <= 0) then
                    j = 0
                endif
                if (indr <= ifatxC .and. indr > 0) then
                   j = superind(indr)
                   if (j > 0) then
                      if(use_E) then
                        tcalc=tcalc+ecvetc(j)    !  Ecalc**2 da modello
                      else
                        tcalc=tcalc+fcvetc(j)
                      endif
                     endif
                  endif
                enddo
                ModuliSel(1,i) = sqrt(tcalc)

                Ecal2_med = Ecal2_med + tcalc

             enddo
              Ecal2_med = Ecal2_med / nreflSelRot
              write(6,*) '<Rp**2> = ', Ecal2_med
              sca = 1.0 / Ecal2_med
              do i=1,nreflSelRot
                 tcalc = sca*(ModuliSel(1,i)**2)
                 ModuliSel(1,i) = sqrt(tcalc)
              enddo

c 
c--calcolo della funzione costo
c
             if(use_E) then
                call CalcolaCosto2(costo)
c                   kverbo = 0  !100
                iact = 1 
                prt_fom(:) = 0.0
                call Calcola_FinalFom_MR(isol,iact,costo,prt_fom)
                costo = FinalFom
c                   kverbo = 0 
c               call CalcolaCosto_Rot(costo,prt_fom)
             else
               call CalcolaCostoProva(costo) 
             endif
!
!
!--memorizzo la nuova funzione costo e i nuovi parametri
!
c--stat
c     write(6,*) 'uffa',costo
c--stat
c
      fun0 = costo
c      write(97,'(3f12.3,4f12.4)') x(1)*57.3,x(2)*57.3,x(3)*57.3,
c     &                       x(4:6),corre
c
      return
      end
!-----------------------------------------------------------------------
      subroutine Cicla_EDM(rrtt,avefcw)
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
      USE Mappa
      USE MapTest
      USE Param
      USE PhMod
!
      implicit none
      integer :: i, ipher, nweek, ifin, npSav(3)
      integer :: nfree, numBox, ifPhantom_sav
      real :: rrtt, sumfcw, avefcw
      character (len=11) :: tirang
!
!

      wt(1:nrefl) = sqrt(wt(1:nrefl))
!
      if (knw == 1) then
          call examin(3,mkang, khl, ipub, iphaz, nrefl, 0, wt, 0)
          write(6,10) erore, erorepes, isumal
          tirang = 'WT IN  EDM '
          ipher = 1
          call pherrdisNew(tirang, wt, khl, mkang, nrefl, 0,
     *                         ipub, iphaz, wt, 10, 0.0, ipher)
      endif
      numbGenSav = numbGen
      npSav(1:3) = np(1:3)

      nfree = 0 ; numBox = 0
      wtd(1:nrefl) = wt(1:nrefl)
      iphad(1:nrefl) = iphaz(1:nrefl)
      call AllocaMapTest(2)
      numbGen = 0

      call PreCicla_LOW(npSav)
      ifPhantom_sav = ifPhantom
      ifPhantom = -9

!cristina
      call EDMdritan(nfree, numBox, 0)

      call PostCicla_LOW(npSav)
      ifRemo = 1
      ifPhantom = ifPhantom_sav 
!
      call Calcola_RF(nrefl,rrtt)

      ifin = nrefl * 0.70
      nweek = 0
      sumfcw = 0.0
      do i=ifin+1,nrefl
         nweek = nweek + 1
         sumfcw = sumfcw + fcvet(i)
      enddo
      avefcw = sumfcw / nweek
!
      if (knw == 1) then
          call examin(3,mkang, khl, ipub, iphaz, nrefl,
     *                    0, wt, 0)
          write(6,20) erore, erorepes, isumal
          tirang = 'WT OUT EDM '
          ipher = 1
          call pherrdisNew(tirang, wt, khl, mkang, nrefl, 0,
     *                         ipub, iphaz, wt, 10, 0.0, ipher)
      endif
!
      numbGen = numbGenSav
!
      return
   10 format(/,'Starting Cicla_LOW - MPE = ',f6.2,' (',f6.2,') using ',
     *       i6,' reflections',/)
   20 format(/,'Ending   Cicla_LOW - MPE = ',f6.2,' (',f6.2,') using ',
     *       i6,' reflections',/)
      end
!-----------------------------------------------------------------------
      subroutine VLD_Fom()
      USE General
      USE Riflessi
      USE Molcom
      USE PhaseModule
      USE PhMod
      USE ArpWarp, only : statoMR
      USE RemoModule, only : ifFreeLunchMR
      USE RuotaRiflessi, only: nreflSelTra
!
      implicit none
      integer :: i, ier, izero, ipher, nweek, ifin
      integer :: ifRemo_Sav, ifFreeLunchMR_Sav, ifVLD_Sav, ifDsrVLD_Sav
      integer :: statoMR_Sav, ifPhantom_Sav, jumpVLD_Sav
      real    :: vettoreRis(10), soglia, rrtt, sumfcw, avefcw
      character (len=11) :: tirang
!
      ifFreeLunchMR_Sav = ifFreeLunchMR
      statoMR_Sav = statoMR
      ifPhantom_Sav = ifPhantom
      ifRemo_Sav = ifRemo
      jumpVLD_Sav = jumpVLD

      call  AllocaPhantom(1)

      statoMR = 0
      ifPhantom = -9
      ifFreeLunchMR = 0
      jumpVLD = 2
!
      Pub_Target(:) = ipub(:)
      Pesi_MR(1:nrefl) = wt(1:nrefl)
      Fasi_MR(1:nrefl) = iphaz(1:nrefl)
      ifTime = 0

      wt(1:nrefl) = sqrt(wt(1:nrefl))

!     if (knw == 1) then
!        call examin(18, mkang, khl, ipub, iphaz, nrefl, 0, wt ,0)
!        write(6,10) erore, erorepes, isumal
!        tirang = 'Prima 1 VLD'
!        izero = 0
!        ipher = 1
!        call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
!    *         ipub,iphaz,wt,10,0.0,ipher)
!     endif

*     go to 10
      do i=1, 1
         call Cicla_VLD_MR(1, vettoreRis)
      enddo

      ifRemo = ifRemo_Sav
      statoMR = statoMR_Sav
      ifPhantom = ifPhantom_Sav
      ifFreeLunchMR = ifFreeLunchMR_Sav
      jumpVLD = jumpVLD_Sav

      call  AllocaPhantom(2)
      call AllocaMapTest(1)
!
   10 format(/,'Starting Cicla_VLD_MR - MPE =',f6.2,' (',f6.2,') using',
     *       i8,' reflections',/)
   20 format(/,'Ending   Cicla_VLD_MR - MPE =',f6.2,' (',f6.2,') using',
     *       i8,' reflections',/)

      return
      end
!-------------------------------------------------------------------------
      subroutine Cicla_VLD_MR(Cicli, vettoreRis)
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
      USE Mappa
      USE MapTest
      USE Param
      USE PhMod
      USE RemoModule, only : ifFreeLunchMR
!
      implicit none
      integer :: numbLSQSav, npSav(3), j, Cicli, LowResSav, knwSav
      real    :: vettoreRis(10)
!
      npSav(1:3) = np(1:3)
!
      do j=1, Cicli

         ifRemo = 1
         if (allocated(xmodel)) then
             call AllocaMapTest(2)
         endif

         work_PHA(1:nrefl) = sigmav(1:nrefl)
         numbLSQSav = numbLSQ

         LowResSav = LowRes
         LowRes = 1
*        ifFreeLunchMR = 1
         knwSav = knw
         knw = 0
         call DoRemoDsr(vettoreRis)
         ifPhantom = 1
         LowRes = LowResSav
         knw = knwSav 

         numbLSQ = numbLSQSav
         sigmav(1:nrefl) = work_PHA(1:nrefl)
         if (allocated(xmodel)) then
             call AllocaMapTest(2)
         endif
         if (.not.allocated(wtd)) then
             call AllocaRiflessiCow(1)
         endif

      enddo
! 

      call AllocaMappa(2)
      np(1:3) = npSav(1:3)
      call AllocaMappa(1)

      return
      end
! ----------------------------------------------------------------------
      subroutine Calcola_RF(numb,errett)
      USE General
      USE Riflessi
!
      integer       :: i, numb
      real          :: errett, sumfo, sumfc, scalan
!
      sumfo = 0.0
      sumfc = 0.0
      do i=1,numb
         sumfo = sumfo + fovet(i)
         sumfc = sumfc + fcvet(i)
      enddo
!
      scalan = sumfc / sumfo
!
      sumfo = 0.0
      sumdf = 0.0
      do i=1,numb
         absdf = abs( fcvet(i) - scalan * fovet(i) )
         sumfo = sumfo + scalan * fovet(i)
         sumdf = sumdf + absdf
      enddo
      errett =  sumdf / sumfo
!
      return
      end
! ----------------------------------------------------------------------
      subroutine Calcola_RF_Fom()
      USE General
      USE Riflessi
!
      common /erre_fom/rrtt, rrttee, rrtt40, avefcw, scaletta
!
      integer       :: i, ncond1, ifin, nweek
      real          :: rrtt, rrttee, rrtt40
      real          :: sumfo, sumfc, scalan, sumfcw, avefcw
!
      rrtt   = 0.99999
      rrttee = 0.99999
      rrtt40 = 0.99999
      avefcw = 0.0
!
      sumfo = 0.0
      sumfc = 0.0
      do i=1,nrefl
         sumfo = sumfo + fovet(i)
         sumfc = sumfc + fcvet(i)
      enddo
!
      scalan = sumfc / sumfo
!
      sumfo = 0.0
      sumdf = 0.0
      do i=1,nrefl
         absdf = abs( fcvet(i) - scalan * fovet(i) )
         sumfo = sumfo + scalan * fovet(i)
         sumdf = sumdf + absdf
      enddo
      rrtt =  sumdf / sumfo
!
      sumfo = 0.0
      sumdf = 0.0
      ncond = 0 
      do i=1,nrefl
         eo = evet(i)
c        if(eo > 1.35 .or. eo < 0.7) then
         if(eo > 0.7) then
            ncond =  ncond + 1
            absdf = abs( fcvet(i) - scalan * fovet(i) )
            sumfo = sumfo + scalan * fovet(i)
            sumdf = sumdf + absdf
         endif
      enddo
      rrttee =  sumdf / sumfo
c     write(6,*) 'RRTTEE =',rrttee, ncond
!
      tmpwt(:) = 0.0
      do i=1,nrefl
         tmpwt(i) = wt(i)
      enddo
      ncond1 =  nrefl * 0.4
      call sortall(-1,tmpwt,nrefl)
      sog = tmpwt(ncond1)

      sumfo = 0.0
      sumdf = 0.0
      do i=1,nrefl
         if (wt(i) > sog) then
            absdf = abs( fcvet(i) - scalan * fovet(i) )
            sumfo = sumfo + scalan * fovet(i)
            sumdf = sumdf + absdf
         endif
      enddo
      rrtt40 =  sumdf / sumfo
!
      ifin = nrefl * 0.70
      nweek = 0
      sumfcw = 0.0
      do i=ifin+1,nrefl
         nweek = nweek + 1
         sumfcw = sumfcw + fcvet(i)
      enddo
      avefcw = sumfcw / nweek
!
      return
      end
! ----------------------------------------------------------------------
!-----------------------------------------------------------------------     
      subroutine NewFFom
      USE General
      USE Molcom
      USE Riflessi
      USE PhaseModule
      USE RemoModule
      USE Solutions
      USE TraslaSolution
      USE ArpWarp
      USE Param , only :f000
      USE RuotaRiflessi, only : nreflSelRot, nreflSelTra, nreflSelRemo
!
      implicit none
      integer :: filtra, i1, i2, i3, ifFast, ifREM, numbPDB, kk, k1
      integer :: i, j, j1, j2, j1ord, itype, iform,jop, jopen, jj
      integer :: iflg, jflag, iexc, izero, ifmin, iuno
      real    :: tet1, tet2, tet3, x1(3), x2(3), b(3,3), btra(3,3)
      real    :: sumfo, sumfc, sumdf, scalan, absdf
      real    :: scaletta, cost0, avefcw, avefcw_sca, rtot
      real    :: rrtt, rrttee, rrtt40, rmeno, rmenoee, rmeno40, f000Sav
      common /erre_fom/rrtt, rrttee, rrtt40, avefcw, scaletta
      character (len=5) :: a5

!
      write(6,*) 'INIZIO NewFFom ', f000
      f000Sav = f000
*     return
!
      if(.not.allocated(iphad)) then
         call AllocaRiflessiCow(1)
      endif

      call FillFinalSolution(1)
      write(6,*)
      write(6,*) 'New FFom'
      write(6,*)
!
      iexc = 1
      call cc_vet0_all(iexc,nrefl)
!
      do j=1,nFinalSolution
         work4(j)  = finsolcan(j)%Fom 
         iwork4(j) = j
      enddo
      iuno = -1
      call sortall3(iuno,work4,iuno,nFinalSolution,iwork4)
!
      do jj=1, nFinalSolution

         do j1=1, numbModels
            j2 = MonomerInModel(j1)
            model(j1)%considerato(1:j2) = 0
         enddo
         j = iwork4(jj) ! puntatore con l'ordine delle soluzioni
c        j =        jj  ! puntatore con l'ordine delle soluzioni
         do j1=1, numbModels
            do j2=1, MonomerInModel(j1)
c
c--non considero la parte mancante
c  (coincide sempre con quella finale del multipletto)
c
               if (finsolcan(j)%flag(j1,j2) == -1) exit
               model(j1)%considerato(j2) = 1
c
               tet1 = finsolcan(j)%RotVal(1,j1,j2)
               tet2 = finsolcan(j)%RotVal(2,j1,j2)
               tet3 = finsolcan(j)%RotVal(3,j1,j2)
               call RotationOper1(b,tet1,tet2,tet3)
!
               do i1=1,3
                  do i2=1,3
                     btra(i1,i2) = b(i2,i1)
                  enddo
               enddo
               do i=1, natsInModel(j1)
                  x1(1:3) = model(j1)%saved(1:3,i,j2)
                  call MoltMatVec(rm, x1, x2)
                  call MoltMatVec(btra, x2, x1)
                  call MoltMatVec(rmi, x1, x2)
                  model(j1)%atoms(1:3,i,j2) =
     *                      x2(1:3) + finsolcan(j)%TraVal(1:3,j1,j2)
               enddo
            enddo
         enddo


         call ChemInfo_MR_Final()
         call NewInv_MR_Final()

!
!--  compute r-factor and scale fcvet values
!
         sumfc=0.0
         sumfo=0.0
         do i=1,nrefl
            sumfc=sumfc+fcvet(i)
            sumfo=sumfo+fovet(i)
         enddo
         scalan=sumfc/sumfo
         sumdf=0.0
         sumfo=0.0
         do i=1,nrefl
            absdf=abs(fcvet(i)-scalan*fovet(i))
            sumdf=sumdf+absdf
            sumfo=sumfo+scalan*fovet(i)
            fcvet(i)=fcvet(i)/scalan ! occhio
         enddo
         erre=sumdf/sumfo
c
         jflag  = 1
         call PresigmaA(jflag, 1)

         iflg = 1
         call NewFFom0(iflg,jj,j,rmeno)
         
         if (WhichModel == 1) then
            i = TraAll(j)%ipunt
            TraAll(i)%TraFom = rmeno
            TraAll(i)%MolMPE = erore
         else
            finsolcan(j)%Fom = rmeno
            finsolcan(j)%MPE = erore
         endif

      enddo   ! jj=1, nFinalSolution!

      if (WhichModel == 1) then
         do j=1,nFinalSolution
            i = TraAll(j)%ipunt
            work4(j)  = TraAll(i)%TraFom
            iwork4(j) = i
*                 if (knw > = 0) write(6,*) j, TraAll(j)%ipunt, work4(j)
         enddo
         iuno = -1
         call sortall3(iuno,work4,iuno,nFinalSolution,iwork4)
         do j=1,nFinalSolution
              i = iwork4(j) 
              TraAll(j)%ipunt = i
         enddo
      endif

      f000 = f000Sav
      write(6,*) 'FINE   NewFFom ', f000
      write(6,*)
      write(6,*) 'FINE New FFom'
      write(6,*)

      return
      end
!-----------------------------------------------------------------------     
!-----------------------------------------------------------------------     
      subroutine NewFFom0(iflg,jj,j,rmeno)
      USE General
      USE Molcom
      USE Riflessi
      USE PhaseModule
      USE RemoModule
      USE Solutions
      USE TraslaSolution
      USE ArpWarp
      USE Param , only :f000
      USE RuotaRiflessi, only : nreflSelRot, nreflSelTra, nreflSelRemo
!
      implicit none
      integer :: i, j, jj
      integer :: iflg, iexc, izero, ifmin, iuno
      real    :: sumfo, sumfc, sumdf, scalan, absdf
      real    :: scaletta, cost0, avefcw, avefcw_sca, rtot
      real    :: rrtt, rrttee, rrtt40, rmeno, rmenoee, rmeno40
      common /erre_fom/rrtt, rrttee, rrtt40, avefcw, scaletta
      character (len=5) :: a5

!
      ifTime = 0
      ifVLD = 0
      ifDsrVLD = 1
      if (ifDNA == 1) ifFreeLunchMR = 0 ! come in sir2019 distr.

      izero = 0
      ifmin = 0
      call examin(2222,mkang,khl,ipub,iphaz,nrefl,
     *              izero,wt,ifmin)

      if (knw == 1) then
          write(lo,30)
          if (iflg < 3) then
              write(lo,111) jj, j, finsolcan(j)%MPE, nreflSelTra,
     *                     erore, nrefl, finsolcan(j)%Fom
          endif
      endif


      call VLD_Fom()

      iexc = 1
      call cc_vet_all(iexc,nrefl,cost0)

      call Calcola_RF_Fom()

      if (jj == 1) then
          scaletta =  0.5 / avefcw
      endif
      avefcw_sca = avefcw * scaletta

      rmeno = 1.0 - rrtt
      rmenoee = 1.0 - rrttee
      rmeno40 = 1.0 - rrtt40

      if (knw == 1) then
          call examin(18, mkang, khl, ipub, iphaz, nrefl, 0, wt ,0)
          if (iflg < 3) then
              write(lo,112)  erore, nrefl, rmeno
          elseif (iflg == 3) then
              write(lo,113) jj, erore, nrefl, rmeno
          endif
          write(lo,30)
      endif


   30 format(80('-'))
 111  format(' Solution #',i3,'(',i3,'). MPE',f8.2,
     *' over',i7,' reflections.',/,20x,
     *' MPE', f8.2,' over',i7,' reflections.   TFom =',f9.3)
 112  format(20x,
     *' MPE', f8.2,' over',i7,' reflections.   FFom =',f9.3)

 113  format(' Solution #',i3,' MPE',f8.2,
     *' over',i7,' reflections.   FFom =',f9.3)
      return
      end
!-----------------------------------------------------------------------     
      subroutine NewFFom_MoreMolecules(nFinSol)
      USE General
      USE Molcom
      USE Riflessi
      USE PhaseModule
      USE RemoModule
      USE Solutions
      USE TraslaSolution
      USE ArpWarp
      USE Param , only :f000
      USE RuotaRiflessi, only : nreflSelRot, nreflSelTra, nreflSelRemo
!
      implicit none
      integer :: filtra, i1, i2, i3, ifFast, ifREM, numbPDB, kk, k1
      integer :: i, j, j1, j2, j1ord, itype, iform,jop, jopen, jj
      integer :: nFinSol, iflg, jflag, iexc, izero, ifmin, iuno
      real    :: tet1, tet2, tet3, x1(3), x2(3), b(3,3), btra(3,3)
      real    :: sumfo, sumfc, sumdf, scalan, absdf
      real    :: scaletta, cost0, avefcw, avefcw_sca, rtot
      real    :: rrtt, rrttee, rrtt40, rmeno, rmenoee, rmeno40, f000Sav
      common /erre_fom/rrtt, rrttee, rrtt40, avefcw, scaletta
      character (len=5) :: a5

!
*     return
!
      if(.not.allocated(iphad)) then
         call AllocaRiflessiCow(1)
      endif

      write(6,*)
      write(6,*) 'New FFom in MoreMolecules'
      write(6,*)
      f000Sav = f000
!
      iexc = 1
      call cc_vet0_all(iexc,nrefl)
!
      do jj=nFinSol, nFinSol

         do j1=1, numbModels
            j2 = MonomerInModel(j1)
            model(j1)%considerato(1:j2) = 0
         enddo
         j = jj  ! puntatore con l'ordine delle soluzioni
         do j1=1, numbModels
            do j2=1, MonomerInModel(j1)
c
c--non considero la parte mancante
c  (coincide sempre con quella finale del multipletto)
c
               if (finsolcan(j)%flag(j1,j2) == -1) exit
               model(j1)%considerato(j2) = 1
c
               tet1 = finsolcan(j)%RotVal(1,j1,j2)
               tet2 = finsolcan(j)%RotVal(2,j1,j2)
               tet3 = finsolcan(j)%RotVal(3,j1,j2)
               call RotationOper1(b,tet1,tet2,tet3)
!
               do i1=1,3
                  do i2=1,3
                     btra(i1,i2) = b(i2,i1)
                  enddo
               enddo
               do i=1, natsInModel(j1)
                  x1(1:3) = model(j1)%saved(1:3,i,j2)
                  call MoltMatVec(rm, x1, x2)
                  call MoltMatVec(btra, x2, x1)
                  call MoltMatVec(rmi, x1, x2)
                  model(j1)%atoms(1:3,i,j2) =
     *                      x2(1:3) + finsolcan(j)%TraVal(1:3,j1,j2)
               enddo
            enddo
         enddo


         call ChemInfo_MR_Final()
         call NewInv_MR_Final()

!
!--  compute r-factor and scale fcvet values
!
         sumfc=0.0
         sumfo=0.0
         do i=1,nrefl
            sumfc=sumfc+fcvet(i)
            sumfo=sumfo+fovet(i)
         enddo
         scalan=sumfc/sumfo
         sumdf=0.0
         sumfo=0.0
         do i=1,nrefl
            absdf=abs(fcvet(i)-scalan*fovet(i))
            sumdf=sumdf+absdf
            sumfo=sumfo+scalan*fovet(i)
            fcvet(i)=fcvet(i)/scalan ! occhio
         enddo
         erre=sumdf/sumfo
c
         jflag  = 1
         call PresigmaA(jflag, 1)

         iflg = 1
         call NewFFom0(iflg,jj,j,rmeno)
         
         finsolcan(j)%Fom = rmeno
         finsolcan(j)%MPE = erore

      enddo   ! jj=1, nFinSol!

      f000 = f000Sav
      write(6,*)
      write(6,*) 'FINE New FFom in MoreMolecules'
      write(6,*)

      return
      end
!-----------------------------------------------------------------------     
      subroutine WriteMTZ_Refmac_res(iAction, sig, res, ier)
      USE General
      USE Symmetry
      USE Riflessi
      USE Molcom
      USE PhaseModule
      USE VLDMod
      USE ArpWarp
!
!-- iAction = 0  standard MTZ file
!-- iAction = 1  MTZ file with reflections expanded in P1
!-- sig     -1   write all reflections
!            n   write only rflections with fo > n*sigma
!
      implicit none
      integer :: step, ColonneStandard, LungMtzName
!-- Max number of labels
      integer :: MaxLab
      parameter (MaxLab = 200)
!-- Max number of symmetry operations
      integer :: MaxSym
      parameter (MaxSym = 192)

      INTEGER :: i, MTZOUT, NSYMTZ, NSYMP, NSPGR
      REAL RSYM(4,4,MaxSym)

      integer :: ier, ierr, ix, iy, k, kk, j, Lung
      real    :: flag, yfl, sig

      integer :: numb, jhklm(6,24)
      integer :: iAction, ii, jj, ksubr, ifin, n, nnr
      real    :: fase, res, r

      CHARACTER CrystalName*20, ProjectName*20, DataSetName*20,
     +   SPGRNAM*10, PGNAM*10,
     *   LabCol1*30, LabCol2*30, LabCol3*30, Col1, Col2, Col3,
     *   LabCol4*30, LabCol5*30, LabCol6*30, Col4, Col5, Col6,
     *   HLA*30, HLB*30, HLC*30, HLD*30
!
!-- ASU
!
      INTEGER NSPGRP_MASTER,   NLAUE_MASTER,
     +        NSYMP_MASTER,    NSYM_MASTER
      CHARACTER NAMSPG_MASTER*10, PGNAME_MASTER*10,LATTYP_MASTER*1
      REAL    RSYMT_MASTER,    RSYM_MASTER
!
      COMMON /ATSYM/  RSYM_MASTER(4,4,MaxSym),
     +                RSYMT_MASTER(4,4,MaxSym),
     +                NSYM_MASTER,
     +                NSYMP_MASTER,
     +                NSPGRP_MASTER,
     +                NLAUE_MASTER
      COMMON /ATSYM_CHAR/ NAMSPG_MASTER, PGNAME_MASTER, LATTYP_MASTER
      integer hkli(3), hklo(3)
!
      real, allocatable :: hkl(:,:)
      character (len=7) :: rVLDc
!
      ier = 0
!
      if (sig > 0.0) then
          n = 0
          do i=1, nrefl
             if (fovet(i) < sig * sigmav(i)) cycle
             r = 0.5 / sqrt(rhov(i))
*            if (r < res) cycle
             if (r > res) cycle
             n = n + 1
          enddo
          write(6,*) '3SIGMA + Res<7 nrefl, n ', nrefl, n
      else
          n = nreflDim
      endif
!
!-- Calcolo Rfree
!
      if (ifRFree == 0) then
          iy = 67543
          ix = iy
*         do i=1, nreflDim
          do i=1, n
             call randu1(ix,iy,yfl)
             flag = real(int(yfl*20.0)+1)
             ix = iy
             rfree1(i) = nint(flag) - 1
          enddo
      endif
!
      kk = Lung(StructureName)
      CrystalName = StructureName(1:kk)
      call ucase(CrystalName)
!
      direttiva = StructureName(1:kk)
      k = Lung(direttiva)
      direttiva = direttiva(1:k) //'_start.mtz'
!
      LungMtzName = Lung(direttiva)
      MTZfile = direttiva
!
      HLA = 'HLA'
      HLB = 'HLB'
      HLC = 'HLC'
      HLD = 'HLD'
      Lab_Col(1) = 'H'
      Lab_Col(2) = 'K'
      Lab_Col(3) = 'L'
      j = 3
      Lab_Col(j+1) = 'F'
      Lab_Col(j+2) = 'SIGF'
      Lab_Col(j+3) = 'FreeR_flag'
      tipo_colonne(1:3) = 'H'
      tipo_colonne(j+1) = 'F'
      tipo_colonne(j+2) = 'Q'
      tipo_colonne(j+3) = 'I'
      j = j + 3
      ColonneStandard = j
      nMTZlab = j
!
      ProjectName = ProgName(1:lProgName)
!
      call WriteMTZHeader(MTZOUT, direttiva, ProjectName, 
     *                    CrystalName, DataSetName, MaxLab, MaxSym,
     *                    SPGRNAM, NSPGR, PGNAM, NSYMTZ, RSYM, ier)
!
      if (ier < 0) then
          if (ifMadEnv /= 0) then
              Msg = 'No MTZ file produced'
              call TestoGR('No MTZ file produced', color_RED, 2, 3)
          endif
          return
      endif
      if (iAction == 0) then
*         numb = nreflDim
          numb = n
      else
          numb = sum(mult(1:nreflDim))
      endif

!-- Loop over reflections

      allocate (hkl(nMTZlab, numb), stat = ierr)
      fase = 0
      ii = 0
      ksubr = 3
      k = 0
      if (sig > 0.0) then 
          nnr = nrefl
      else
          nnr = nreflDim
      endif
*ori  do i=1, nreflDim
      do i=1, nnr
         if (sig > 0.0 .and. fovet(i) < sig * sigmav(i)) cycle
         r = 0.5 / sqrt(rhov(i))
*        if (r < res) cycle
         if (r > res) cycle
         k = k + 1
*        write(6,*) k, numb
         hkli(1:3) = khl(1:3,i)
         if (iAction == 0) then
             hkl(1:3,k) = hkli(1:3)
             j = 3
             hkl(j+1,k) = fovet(i)
             hkl(j+2,k) = sigmav(i)
             hkl(j+3,k) = rfree1(i)
*            write(6,'(3i4,2f15.5)') khl(1:3,i),fovet(i),sigmav(i)
             j = j + 3
         else
             call EspandiInP1(hkli(1), hkli(2), hkli(3),
     *                        fase, jhklm, ifin, ksubr)
             do j=1,ifin
                ii = ii + 1
                hkl(1:3,ii) = jhklm(1:3,j)
                jj = 3
                hkl(jj+1,ii) = fovet(i)
                hkl(jj+2,ii) = sigmav(i)
                hkl(jj+3,ii) = rfree1(i)
             enddo
         endif
      enddo
!
!-- Put reflections (h,k,l and phases) into asymmetric unit defined in ASUSET
!
!
!-- ASU
!
      NAMSPG_MASTER = SPGRNAM
      NSPGRP_MASTER = NSPGR
      PGNAME_MASTER = PGNAM
      NSYM_MASTER   = NSYMTZ
      RSYM_MASTER   = RSYM
      CALL ASUSET(NAMSPG_MASTER,   NSPGRP_MASTER,
     +            PGNAME_MASTER,   NSYM_MASTER,
     +            RSYM_MASTER,     NSYMP_MASTER,
     +            NLAUE_MASTER,    .FALSE.)
!
!-- FINE ASU
!
      nreflMTZ = numb
      call WriteMTZFooter(MTZOUT, hkl)
!
      deallocate (hkl, stat=ierr)
!
      return
      end
!-----------------------------------------------------------------------     
      subroutine ConfrontaSoluzioni(iact)
!
      USE General
      USE TraslaSolution
      USE Riflessi
      USE RemoModule
      USE Solutions

      implicit none
      integer :: i, j, iuno, ii, jj, ij, ncont, iact
      integer :: itri1, itri2, k1, k2
      real  :: dell(3), del_ang, del_shf, side, sog_ang, sog_shf
      real  :: Fom(50), Fom1, Fom2, del_Fom, rap_Fom

      if (nSolToExplore == 1) return

      i = maxval(MonomerInModel(1:numbModels))
      if (.not. Allocated(ang1))  then
           allocate (ang1(3,numbModels,i))
           allocate (shf1(3,numbModels,i))
      endif
  
      k1 = 1
      k2 = 1
      do j=1,nSolToExplore
         i = TraAll(j)%ipunt
         work4(j)  = TraAll(i)%TraFom
         iwork4(j) = i
*        if (knw > = 0) write(6,*) j, TraAll(j)%ipunt, work4(j)
      enddo
      iuno = -1
      call sortall3(iuno,work4,iuno,nSolToExplore,iwork4)

      Fom(:) = 0.0

      do j=1,nSolToExplore
         i = iwork4(j)
         Fom(j) = TraAll(i)%TraFom
      enddo
      
      do j=1,nSolToExplore-1
         i = iwork4(j)
         Fom1 = TraAll(i)%TraFom
         itri1 = TraAll(i)%trial
         if (Fom(j) < -99.00) then
            cycle
         endif

         do jj=j+1,nSolToExplore
            ij = iwork4(jj)
            Fom2 = TraAll(ij)%TraFom
            itri2 = TraAll(ij)%trial
            if (Fom(jj) < -99.00) then
               cycle
            endif

            del_Fom = Fom1 - Fom2
            rap_Fom = del_Fom / Fom1

            if (rap_Fom < 0.05) then

                ang1(1:3,k1,k2) = TraAll(i)%RotVal(1:3)*rtod
                ang2(1:3) = TraAll(ij)%RotVal(1:3)*rtod
                do ii = 1,3
                   ang1(ii,k1,k2) = amod(ang1(ii,k1,k2)+3600.0,360.0)
                   ang2(ii) = amod(ang2(ii)+3600.0,360.0)
                
                   dell(ii) = abs(ang1(ii,k1,k2)-ang2(ii))
                   dell(ii) = min(dell(ii),360-dell(ii))
                enddo
       
                del_ang = sum(dell(1:3))
      
                shf1(1:3,k1,k2) = TraAll(i)%TraVal(1:3)
                shf2(1:3) = TraAll(ij)%TraVal(1:3)
                do ii = 1,3
                   shf1(ii,k1,k2)=side(shf1(ii,k1,k2))
                   shf2(ii)=side(shf2(ii))

                   dell(ii) = abs(shf1(ii,k1,k2)-shf2(ii))
                   dell(ii) = min(dell(ii),1.0-dell(ii))
                enddo
       
                del_shf = sum(dell(1:3))
               
                if (iact == 1) then
                    sog_ang = 9.0
                    sog_shf = 0.1
                else
                    sog_ang = 6.0
                    sog_shf = 0.06
                endif
                if (del_ang < sog_ang .and. del_shf < sog_shf) then
                    if (Fom1 >= Fom2) then
                        Fom(jj) = -99.99
                    else
                        Fom(j) = -99.99
                    endif
                endif
!
            endif
         enddo
      enddo

      do j=1,nSolToExplore
          ij = iwork4(j)
          TraAll(ij)%TraFom = Fom(j) 
      enddo
!
 110  format (a,2i4,i8,2f8.3)
      return

      end
!-----------------------------------------------------------------------
      subroutine RigettaSoluzioni(iBest)
!
      USE General
      USE TraslaSolution
      USE Riflessi
      USE RemoModule
      USE Solutions

      implicit none
      integer :: i, j, iuno, ii, jj, ij, ncont
      integer :: iBest, itri1, itri2, k1, k2
      real  :: dell(3), del_ang, del_shf, side, sog_ang, sog_shf

      sog_ang = 9.0
      sog_ang = 30.0
      sog_shf = 0.1   ! GL
c     sog_shf = 0.15  ! Dedi

*     write(6,*) 'RIGETTASOLUZIONI SOGLIE', sog_ang, sog_shf
  
      do k1 = 1,WhichModel-1
         do k2 = 1,WhichMonomer

                do ii = 1,3
                   ang1(ii,k1,k2) = amod(ang1(ii,k1,k2)+3600.0,360.0)
                   ang2(ii) = amod(ang2(ii)+3600.0,360.0)
                
                   dell(ii) = abs(ang1(ii,k1,k2)-ang2(ii))
                   dell(ii) = min(dell(ii),360-dell(ii))
                enddo
*               write(6,110)  ang1(1:3,k1,k2), ang2(1:3), del_ang
*               write(6,115)  dell(1:3)
!--NEW   gianluca 5/11/19
                if (abs(180-dell(1)) < 20 .and.
     *              abs(    dell(2)) < 20 .and.
     *              abs(180-dell(3)) < 20) then
                    dell(1) = min(dell(1),abs(180-dell(1)))
                    dell(3) = min(dell(3),abs(180-dell(3)))
*                   write(6,115)  dell(1:3)
!--NEW   gianluca 5/11/19
                endif
       
                del_ang = sum(dell(1:3))
      

                
                do ii = 1,3
                   shf1(ii,k1,k2)=side(shf1(ii,k1,k2))
                   shf2(ii)=side(shf2(ii))

                   dell(ii) = abs(shf1(ii,k1,k2)-shf2(ii))
                   dell(ii) = min(dell(ii),1.0-dell(ii))
                enddo
       
                del_shf = sum(dell(1:3))
               
*               write(6,120)  shf1(1:3,k1,k2), shf2(1:3), del_shf

                if (del_ang < sog_ang .and. del_shf < sog_shf) then
                    TraSol(iBest)%TraCorr = -9.999
                    TraSol(iBest)%TraFom  = -9.999
                endif
!
         enddo
      enddo

!
 110  format ('ANG=',2(3f8.3),f8.3)
 115  format ('DEL=',2(3f8.3),f8.3)
 120  format ('SHF=',2(3f8.3),f8.3)
!
      return

      end
!-----------------------------------------------------------------------
      subroutine Holes(maxNatsPDB)
!
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Mappa
      USE RemoModule
      USE PhaseModule
      USE TestModel
      USE PhMod
!
      implicit none
      integer :: ier, sidepp,  ipunt(5), i, ii, j, kz
      integer :: kk1, kk2, kk3, iszu, iszl, isyu, isyl, maxNatsPDB
      integer :: isxu, isxl, iz, iy, ix, ix1, ix2, ix3 
      real    :: xs1(3), xs(3), deltx, delty, deltz, rmax, bterm
      real    :: alim, DmaxSq, coef,  a1, a2, a3, ray, side
!

! -- azzero la mappa considerando una gaussiana intorno ad ogni
! -- atomo posizionato con raggio van der Walls.
!
!
!-- carico il modello
!
      confronta = .false.
      call LoadPDBfromAmb(0,0,1)
      xyzs(4,1:maxNatsPDB) = IntModel(1:maxNatsPDB)

      if (knw > 0) then
          write(6,*)
          write(6,*) 'Confronto tra modello MR e target (solo P)'
          write(6,*)
      endif
      CaOnly = .true.
      nzSav(1:nats) = nz(1:nats)
      call to_coord_sir(1, nrefl)
      nz(1:nats) = nzSav(1:nats)

      if (knw > 0) then
          write(6,*)
          write(6,*) 'Confronto tra modello MR e target'
          write(6,*)
      endif
      CaOnly = .false.
      nzSav(1:nats) = nz(1:nats)
      call to_coord_sir(1, nrefl)
      nz(1:nats) = nzSav(1:nats)
      CaOnly = .true.

!
!--determino la costante per passare da Angstrom a punti griglia:
!
      deltx=np(1)/cell(1)
      delty=np(2)/cell(2)
      deltz=np(3)/cell(3)
      caChem=cos(cell(4)*dtor)
      cbChem=cos(cell(5)*dtor)
      cgChem=cos(cell(6)*dtor)
      rmax=2.5
!
*     write(6,*) 'HOLE natsInModel(1)', natsInModel(1)
      j = 1
      do i=1,natsInModel(1)
         xs1(1)=side(model(1)%atoms(1,i,j))
         xs1(2)=side(model(1)%atoms(2,i,j))
         xs1(3)=side(model(1)%atoms(3,i,j))
         bterm=model(1)%th_fact(i,j)
         kz=model(1)%specie(i,j) / nzConst
!
!-- determino il raggio di integrazione
!
         alim=rmax*(sqrt(bterm+25)/TwoPi)
         DmaxSq=alim*alim
         DmaxSq =radii(kz,1) ** 2
         DmaxSq =1.4 * radii(kz,1) ** 2
         DmaxSq = 1.0
!
!-- aggiungo la simmetria
!
         do kk1 = 1, ncentr
            do kk2 = 1, icent+1
               coef = 1.0
               if (kk2 == 2) coef = -1.0
               do kk3 = 1,nsym
                  call xequi(xs1,kk3,coef,xs,kk1)
                  xs(1)=side(xs(1))
                  xs(2)=side(xs(2))
                  xs(3)=side(xs(3))
                  iszu=int(xs(3)*np(3)+alim*deltz)
                  iszl=int(xs(3)*np(3)-alim*deltz)
                  isyu=int(xs(2)*np(2)+alim*delty)
                  isyl=int(xs(2)*np(2)-alim*delty)
                  isxu=int(xs(1)*np(1)+alim*deltx)
                  isxl=int(xs(1)*np(1)-alim*deltx)
!
!--definisco un intorno di ogni atomo e creo la Gaussiana
!
                  do iz = iszl, iszu
                     do iy = isyl, isyu
                        do ix = isxl, isxu
                           a1=ix/deltx-xs(1)*cell(1)
                           a2=iy/delty-xs(2)*cell(2)
                           a3=iz/deltz-xs(3)*cell(3)
                           ray=a1**2 + a2**2 + a3**2 + 2.*a1*a2*cgChem +
     &                              2.*a1*a3*cbChem + 2.*a2*a3*caChem
                           if (ray < DmaxSq) then
                               ix1=sidepp(ix,np(1))
                               ix2=sidepp(iy,np(2))
                               ix3=sidepp(iz,np(3))
                               xmap(ix1,ix2,ix3) = 0
                           endif
                        enddo
                     enddo
                  enddo
               enddo
            enddo
         enddo
      enddo
!
      confronta = .true.
!
      return
      end
!---------------------------------------------------------------------
      subroutine HolesCompl(Action)
!
      USE General
      USE Riflessi
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Mappa
      USE RemoModule
      USE PhaseModule
      USE TestModel
      USE PhMod
      USE Param
!
      implicit none
      integer :: ier, sidepp,  ipunt(5), i, ii, j, kz, Action
      integer :: kk1, kk2, kk3, iszu, iszl, isyu, isyl
      integer :: isxu, isxl, iz, iy, ix, ix1, ix2, ix3 
      real    :: xs1(3), xs(3), deltx, delty, deltz, rmax, bterm
      real    :: alim, DmaxSq, coef,  a1, a2, a3, ray, side
!

      write(6,*) 'HOLESCOMPL'
      f000 = 0
      fcoef(1:nrefl) = evet(1:nrefl) * wt(1:nrefl)
      call MakeMap(fcoef, iphaz, nrefl, 0, xmap, FORTH, BACK)
      xenve = 0
!
! -- azzero la mappa al di fuori di una gaussiana intorno ad ogni
! -- atomo posizionato con raggio van der Walls.
!
!-- carico il modello
!
      confronta = .false.
      call LoadPDBfromAmb(0,0,1)

      if (Action == 0) then
          write(6,*)
          write(6,*) 'Confronto tra modello e target (solo P)'
          write(6,*)
          CaOnly = .true.
          nzSav(1:nats) = nz(1:nats)
          call to_coord_sir(1, nrefl)
          nz(1:nats) = nzSav(1:nats)
      endif

!
!--determino la costante per passare da Angstrom a punti griglia:
!
      deltx=np(1)/cell(1)
      delty=np(2)/cell(2)
      deltz=np(3)/cell(3)
      caChem=cos(cell(4)*dtor)
      cbChem=cos(cell(5)*dtor)
      cgChem=cos(cell(6)*dtor)
      rmax=2.5
!
      write(6,*) 'HOLESCOMPL natsInModel(1) ', natsInModel(1)
      j = 1
      do i=1,natsInModel(1)
         xs1(1)=side(model(1)%atoms(1,i,j))
         xs1(2)=side(model(1)%atoms(2,i,j))
         xs1(3)=side(model(1)%atoms(3,i,j))
         bterm=model(1)%th_fact(i,j)
         kz=model(1)%specie(i,j) / nzConst
!
!-- determino il raggio di integrazione
!
         alim=rmax*(sqrt(bterm+25)/TwoPi)
         DmaxSq=alim*alim
         DmaxSq =radii(kz,1) ** 2
         DmaxSq =1.4 * radii(kz,1) ** 2
         DmaxSq = 1.0
         DmaxSq = 2.0  ! TEST
         DmaxSq = 3.0  ! TEST
!
!-- aggiungo la simmetria
!
         do kk1 = 1, ncentr
            do kk2 = 1, icent+1
               coef = 1.0
               if (kk2 == 2) coef = -1.0
               do kk3 = 1,nsym
                  call xequi(xs1,kk3,coef,xs,kk1)
                  xs(1)=side(xs(1))
                  xs(2)=side(xs(2))
                  xs(3)=side(xs(3))
                  iszu=int(xs(3)*np(3)+alim*deltz)
                  iszl=int(xs(3)*np(3)-alim*deltz)
                  isyu=int(xs(2)*np(2)+alim*delty)
                  isyl=int(xs(2)*np(2)-alim*delty)
                  isxu=int(xs(1)*np(1)+alim*deltx)
                  isxl=int(xs(1)*np(1)-alim*deltx)
!
!--definisco un intorno di ogni atomo e creo la Gaussiana
!
                  do iz = iszl, iszu
                     do iy = isyl, isyu
                        do ix = isxl, isxu
                           a1=ix/deltx-xs(1)*cell(1)
                           a2=iy/delty-xs(2)*cell(2)
                           a3=iz/deltz-xs(3)*cell(3)
                           ray=a1**2 + a2**2 + a3**2 + 2.*a1*a2*cgChem +
     &                              2.*a1*a3*cbChem + 2.*a2*a3*caChem
                           if (ray < DmaxSq) then
                               ix1=sidepp(ix,np(1))
                               ix2=sidepp(iy,np(2))
                               ix3=sidepp(iz,np(3))
                               xenve(ix1,ix2,ix3) = 1
                           endif
                        enddo
                     enddo
                  enddo
               enddo
            enddo
         enddo
      enddo
!
      confronta = .true.
      xmap = xmap * xenve
!
      return
      end
!---------------------------------------------------------------------
      subroutine ContaPesantiPDB(sogHA)
      USE General
      USE RemoModule
      USE TestModel
      USE ArpWarp
!
!-- counts the number of atoms in published PDB file with Z >= sogHA
!
      implicit none
      integer :: i, kz, z, sogHA
!
      nats_pesanti_in_pdb = 0
!
      do i=1, nCoordPub
         kz = nzPub(i)
         z = no(kz)
         if (z >= sogHA) then
             nats_pesanti_in_pdb = nats_pesanti_in_pdb + 1
         endif
      enddo
!
      return
      end
!---------------------------------------------------------------------
      subroutine RemoveHeavyPDB
      USE General
      USE ArpWarp
!
      implicit none
      integer :: i, n, jop, jopen, itype, iform, ios, Lung
      logical :: scrivi
      logical :: stampaCopy
      character (len=6) :: linea
!
      stampaCopy = .true.
      itype = 2
      iform = 1
      if (stampaCopy .and. knw == 1) then
          write(6,*) 'RM HET FichierOut ',FichierOut(1:Lung(FichierOut))
      endif 
      jop = jopen(jgrap, FichierOut, itype, iform, ios)
      itype = 0
      iform = 1
      i = index(FichierOut,'.pdb') - 1
      Inte = FichierOut(1:i) // '_heavy.pdb'
      if (stampaCopy .and. knw == 1) then
          write(6,*) 'COPY TO INTE ',Inte(1:Lung(Inte))
      endif 
      jop = jopen(jrel, Inte, itype, iform, ios)
      cardImage = nome(1:lnome) // '_heavy.pdb'
      itype = 0
      iform = 1
      jop = jopen(jhost, cardImage, itype, iform, ios)
!
      n = 0
      do
         read(jgrap,'(a)', end = 10) cardImage
         linea(1:3) = cardImage(1:3)
         call ucase(linea)
         if (linea(1:3) == 'HET') then
             n = n + 1
             if (n <= nats_added_to_pdb) then
                 write(jhost,'(a)') cardImage(1:Lung(cardImage))
             endif
         elseif (linea(1:3) == 'ATO') then
             write(jrel,'(a)') cardImage(1:Lung(cardImage))
         else
             write(jrel,'(a)') cardImage(1:Lung(cardImage))
             if (linea(1:3) /= 'TER') then
                 write(jhost,'(a)') cardImage(1:Lung(cardImage))
             endif
         endif
         if (linea(1:3) == 'END') then
             exit
         endif
      enddo
   10 close(jgrap)
      close(jrel)
      close(jhost)
!
      if (stampaCopy .and. knw == 1) then
          write(6,*) 'COPY ',Inte(1:Lung(Inte)),' IN ', 
     *                       FichierOut(1:Lung(FichierOut))
      endif
      call cCopyFile(Inte, FichierOut)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine AnalisiFosforiNew(maxNatsPDB)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Mappa
      USE Param
      USE PhaseModule
      USE PhMod
      USE Groups, only: nAcid, nResidStored, nChainsInput, ResInChains
      USE RemoModule
      USE TestModel
      USE ArpWarp
      USE Molcom
!
      implicit none
      integer :: i, j, k, kt, jpuntA, maxNatsPDB, P, nPtarget, nPmodel
      integer :: Lung, numbPDB, itype, iform, jop, jopen, hei, ier
      integer :: iniz, ifin, numTerminali, nMacroRef, nRefi, i1, j1
      integer :: nCatN, nCatV, ResInChainsN(100), natsPDB
      integer :: ii, picchiP(100)
      integer :: iflagPKS, mode, numb, ifCABsav
      integer, allocatable :: legami(:)
      integer, allocatable :: terminali(:,:)
      real    :: distmA, xn(3), xo(3), xeq(3), s(3), d, dLimit, somma, n
      real    :: erreRif
      character(len=1):: catena
      character(len=4):: a4
!
      if (knw > 0) then
          write(6,*)
          write(6,*) 'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX'
          write(6,*) 'ANALISIFOSFORI maxNatsPDB', maxNatsPDB
          write(6,*) 'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX'
          write(6,*)
      endif
!
      f000 = 0
      fcoef(1:nrefl) = evet(1:nrefl) * wt(1:nrefl)
      call MakeMap(fcoef, iphaz, nrefl, 0, xmap, FORTH, BACK)
!
      nats = maxNatsPDB
      aperc(1) = maxNatsPDB
      ifFour = 1
      iflagPKS = 0
      mode = 0
      krecy = 0
      numb = nrefl
      ier = 0
      call pksrch_New(mode, iflagPKS, numb, ier)
      xyzHeavy(1:5,1:maxNatsPDB) =  xyzs(1:5,1:maxNatsPDB)
      IntModel(1:maxNatsPDB) = xyzs(4,1:maxNatsPDB)
      if (knw > 0) then
          write(6,*)
          write(6,*) 'Lista picchi mappa '
          write(6,*)
          write(6,11)
      endif
      j = 0
      do i=1, maxNatsPDB
         if (xyzs(4,i) > 10) then
             j = j + 1
             if (knw > 0) write(6,18) i, xyzs(4,i), xyzs(1:3,i)
         endif
      enddo
      maxNatsPDB = j
      nats = maxNatsPDB

      allocate (legami(1:nats), stat=ier)
      allocate (terminali(2,1:nats), stat=ier)
      terminali(:,:) = 0
      do i=1, nk
         a4 = Species(i)
         call ucase(a4)
*        write(6,*) i, a4
         if (a4(1:2) == 'P ') then
             P = i
             exit
         endif
      enddo
*     write(6,*) 'P ', P
!
      confronta = .false.
      call LoadPDBfromAmb(0,0,1)
      confronta = .true.
      xyzs(4,1:maxNatsPDB) = IntModel(1:maxNatsPDB)
!
      Buffer1 = ' '
      j = 0
      k = 0
      write(6,*)
      write(6,'(a,2x,a)') 'Fosfori del modello',
     *                    FichierOut(1:Lung(FichierOut))
      write(6,*)
      write(6,70)
      do i=1, nats
         if (nzTot(i) == P) then
             write(6,55) i, nint(xyzs(4,i)), 
     *                   xyzs(1:3,i), xyzs(5,i), bfac(i), aLab(i)
             j = j + 1
             k = k + 1
             Buffer1(j:j) = aLab(i)(3:3)
             if (k == 10) then
                 j = j + 1
                 k = 0
             endif
         endif
      enddo
*     write(6,*) 'Sequenza del modello Nautilus'
*     write(6,'(a)') Buffer1(1:j)
*     write(6,*)
!
!-- first step: check P-P distances
!
*     legami(:) = 0
      dLimit = 8
      write(6,*)
      write(6,*) 'Lista distanze fosforo-fosforo nel modello MR'
      write(6,*) 'Limite ',dLimit,' Ang.'
      write(6,*)
      somma = 0
      n = 0
      do i=1, nats-1
         if (nzTot(i) == P) then
             distmA=9999
             jpuntA = 0
             xo(1:3) = xyzs(1:3,i)
             do j=i+1, nats
                if (i == j) cycle
                if (nzTot(j) == P) then
                    xn(1:3) = xyzs(1:3,j)
                    k=1
                    kt = -1
                    call xequiTot(k, xn, xeq, kt)
                    call xdist(xo, xeq, d, s)
                    if (d < dLimit) then
*                       legami(i) = legami(i) + 1
*                       legami(j) = legami(j) + 1
                        write(6,10) i, aLab(i), j, aLab(j), d
                        somma = somma + d
                        n = n + 1
                    endif
                endif
             enddo
         endif
      enddo
      somma = somma / n
      write(6,*) '<dist(P)> ',nint(n), somma
!
      dLimit = 8
      write(6,*)
      write(6,*) 'Lista distanze picchi-fosfori nel modello MR'
      write(6,*) 'Limite ',somma,' +/- 1.0 Ang.'
      write(6,*)
      write(6,15)
      n = 0
      do i=1, maxNatsPDB
         xo(1:3) = xyzHeavy(1:3,i)
         do j=1, nats
!           if (nzTot(j) == P) then         ! ORIGINALE
            if (j == 20 .or. j == 244) then   ! TEST per 5i4s P_DC_A_3
*           if (j == 244) then  ! TEST per 5i4s P_DC_B_15
                distmA=9999
                xn(1:3) = xyzs(1:3,j)
                do k=1, nsymTot
                   kt = -1
                   call xequiTot(k, xn, xeq, kt)
                   call xdist(xo, xeq, d, s)
                   if (d < distmA .and. d < dLimit) then
                       distmA = d
                   endif
                enddo
*               if (abs(distmA - somma) < 1.0) then
                if (distmA < 999) then
                    write(6,20) i, nint(xyzHeavy(4,i)), 
     *                          j, nint(xyzs(4,j)), aLab(j), distmA
                    n = n + 1
                    picchiP(nint(n)) = i
                endif
            endif
         enddo
      enddo
      write(6,*) 
      write(6,*)  'Distanze picchi modello'
      write(6,*) 
      write(6,15)
      dLimit = 3.0
      do ii=1, maxNatsPDB
         i = ii
         xo(1:3) = xyzHeavy(1:3,i)
         do j=1, nats
            distmA=9999
            xn(1:3) = xyzs(1:3,j)
            do k=1, nsymTot
               kt = -1
               call xequiTot(k, xn, xeq, kt)
               call xdist(xo, xeq, d, s)
               if (d < distmA .and. d < dLimit) then
                   distmA = d
               endif
            enddo
            if (distMA < 9998) then
                write(6,20) i, nint(xyzHeavy(4,i)), 
     *                      j, nint(xyzs(4,j)), aLab(j), distmA
            endif
         enddo
      enddo
!
!-- look for Oxigen O5'
!
      write(6,*) 
      write(6,*)  "Look for Oxigen O5'"
      write(6,*) 
      write(6,15)
      dLimit = 1.8
      do ii=1, nint(n)
         i = picchiP(ii)
         xo(1:3) = xyzHeavy(1:3,i)
         do j=1, nats
!           if (nzTot(j) == P) then         ! ORIGINALE
            if (j == 1 .or. j == 225) then    ! TEST per 5i4s O5'_DG_A_2
*           if (j == 225) then  ! TEST per 5i4s O5'_DG_14_B
                distmA=9999
                xn(1:3) = xyzs(1:3,j)
                do k=1, nsymTot
                   kt = -1
                   call xequiTot(k, xn, xeq, kt)
                   call xdist(xo, xeq, d, s)
                   if (d < distmA .and. d < dLimit) then
                       distmA = d
                   endif
                enddo
                if (distMA < 9998) then
                    write(6,20) i, nint(xyzHeavy(4,i)), 
     *                          j, nint(xyzs(4,j)), aLab(j), distmA
                endif
            endif
         enddo
      enddo
      xo(1:3) = xyzHeavy(1:3,52)
      call MoltMatVec(rm, xo, xn)
      write(6,*) xn(1:3)
      xo(1:3) = xyzHeavy(1:3,54)
      call MoltMatVec(rm, xo, xn)
      write(6,*) xn(1:3)
      go to 3

      write(6,*)
      write(6,*) 'Numero legami per i fosfori del modello'
      write(6,*)

    3 continue

      nPmodel = 0
      do i=1, nats
         if (nzTot(i) == P) then
*            write(6,*) aLab(i), legami(i)
             nPmodel = nPmodel + 1
         endif
      enddo


      go to 4

      nPtarget = nAcid
      write(6,*)
      write(6,25) nPtarget, nPmodel
!
!-- corrispondente intensita
!
      write(6,*)
      write(6,*) 'Intensita per dist < 1.0'
      dLimit = 1.0
      do i=1, maxNatsPDB
         distmA=9999
         jpuntA = 0
         xo(1:3) = xyzHeavy(1:3,i)
         do j=1, nats
            if (nzTot(j) == P) then
                xn(1:3) = xyzs(1:3,j)
                do k=1, nsymTot
                   kt = -1
                   call xequiTot(k, xn, xeq, kt)
                   call xdist(xo, xeq, d, s)
                   if (d < distmA .and. d < dLimit) then
                       distmA = d
                       jpuntA = j
                   endif
                enddo
            endif
         enddo
         if (jpuntA > 0) then
             hei = nint(xyzHeavy(4,i))
             write(6,60) i, distmA, aLab(jpuntA), hei
             model(1)%atoms(4,jpuntA,1) = hei
         endif
      enddo
!
!-- verifica se i P terminali sono nella lista ridotta
!

      write(6,*)
      write(6,*) 'Analisi P terminali'
      write(6,*)
      dLimit = 1.3
      do i=1, nats
         if (legami(i) == 2) then
             write(6,*) 'P terminale ',i, aLab(i)
             xo(1:3) = xyzs(1:3,i)
             distmA=9999
             jpuntA = 0
             do j=1, maxNatsPDB
                xn(1:3) = xyzHeavy(1:3,j)
                do k=1, nsymTot
                    kt = -1
                    call xequiTot(k, xn, xeq, kt)
                    call xdist(xo, xeq, d, s)
                    if (d < distmA .and. d < dLimit) then
                        distmA = d
                        jpuntA = j
                    endif
                enddo
             enddo
             if (jpuntA == 0) then
                 write(6,*) 'Non nella lista ridotta ',i,aLab(i)
                 legami(i) = 100 + model(1)%numresiduo(i,1)
             endif
         endif
      enddo

*   4 continue

!
!-- Nuova procedura terminali: definisce i limiti dei vari residui
!
      write(6,*)
      write(6,*) 'Limiti dei vari residui '
      write(6,*)
      numTerminali = 0
      iniz = 0
      ifin = 0
      do i=1, nats
         k = model(1)%numResiduo(i,1)
*        write(6,*) i, k, ' ', model(1)%label(i)
         if (k /= iniz) then
             numTerminali = numTerminali + 1
             terminali(1, numTerminali) = i
             iniz = k
         else
             terminali(2, numTerminali) = i
         endif
      enddo
!
!-- Nuova procedura terminali: seleziona i residui terminali
!
      do i=1, numTerminali
         write(6,30) i, model(1)%label(terminali(1,i)), 
     *                  model(1)%label(terminali(2,i)),
     *                  terminali(1,i), terminali(2,i)
      enddo
      nCatV = nChainsInput
      nCatN = 1
      ResInChainsN(:) = 0
      ResInChainsN(1) = 1
      catena = model(1)%catena(1,1)
      do i=2, numTerminali
         k = terminali(1,i)
         if (model(1)%catena(k,1) == catena) then
             terminali(1,i) = -terminali(1,i)
             ResInChainsN(nCatN) = ResInChainsN(nCatN) + 1
         else
             terminali(1,i-1) = -terminali(1,i-1)
             catena = model(1)%catena(k,1)
             nCatN = nCatN + 1
             ResInChainsN(nCatN) = ResInChainsN(nCatN) + 1
         endif
      enddo
      terminali(1,numTerminali) = -terminali(1,numTerminali)

      write(6,*)
      write(6,*) 'Catene target ',nCatV, '   Catene MR ', nCatN
      write(6,*) 'Nucleotidi in target    ', ResInChains(1:nCatV)
      write(6,*) 'Nucleotidi in MR ', ResInChainsN(1:nCatN)
      write(6,*)

   4  return

*     terminali(1,numTerminali-1) = -terminali(1,numTerminali-1)
      j = 1
      do i=2, numTerminali
         if (terminali(1,i) > 0) then
             j = j + 1
             terminali(1,j) = terminali(1,i)
             terminali(2,j) = terminali(2,i)
         endif
      enddo
      numTerminali = j
      write(6,*)
      write(6,*) 'Nuova procedura terminali'
      write(6,*)
      do i=1, numTerminali
         k = terminali(1,i)
         write(6,30) i, model(1)%label(terminali(1,i)), 
     *                  model(1)%label(terminali(2,i)),
     *                  terminali(1,i), terminali(2,i),
     *                  nint(model(1)%atoms(4,k,1))
      enddo
!
      write(6,*)
      write(6,*) 'Distanze tra ',numTerminali,' fosfori terminali'
      write(6,*)
      do i=1, numTerminali-1
         i1 = terminali(1,i)
         xo(1:3) = xyzs(1:3,i1)
         do j=i+1, numTerminali
            distmA=9999
            jpuntA = 0
            j1 = terminali(1,j)
            if (model(1)%catena(i1,1) == model(1)%catena(j1,1)) cycle
            xn(1:3) = xyzs(1:3,j1)
            do k=1, nsymTot
               kt = -1
               call xequiTot(k, xn, xeq, kt)
               call xdist(xo, xeq, d, s)
               if (d < distmA) then
                   distmA = d
                   jpuntA = j1
               endif
            enddo
            write(6,*) aLab(i1), aLab(jpuntA), distmA
         enddo
      enddo
!
      write(6,*)
      write(6,*) 'Elimina i nucleotidi dei fosfori terminali'
      write(6,*) 'con 2+ legami '
      write(6,*) 
      do i=1, numTerminali
         k = terminali(1,i)
         if (legami(k) >=2) then
             i1 = terminali(1,i)
             j1 = terminali(2,i)
             do j=i1, j1
                model(1)%HETA(j,1) = - 1
                write(6,*) 'Eliminato atomo ', j, aLab(j)
             enddo
         endif
      enddo
!
!-- elimina i picchi corrispondenti ai P del modello
!
      dLimit = 1.3
      dLimit = 4
      dLimit = 2.4
      write(6,*)
      write(6,*) 'Elimina i picchi synergy corrispondenti'
      write(6,*) 'ai P del modello con distanza ', dLimit
      write(6,*)
      n = 0
      do i=1, maxNatsPDB
         distmA=9999
         jpuntA = 0
         xo(1:3) = xyzHeavy(1:3,i)
         do j=1, nats
             xn(1:3) = xyzs(1:3,j)
             do k=1, nsymTot
                kt = -1
                call xequiTot(k, xn, xeq, kt)
                call xdist(xo, xeq, d, s)
                if (d < distmA .and. d < dLimit) then
                    distmA = d
                    jpuntA = j
                endif
             enddo
         enddo
         if (jpuntA > 0) then
             if (model(1)%HETA(jpuntA,1)  >= 0) then
                 write(6,*) 'Eliminato ',i,' vicino a ',aLab(jpuntA),
     *                       distmA
                 xyzHeavy(4,i) = -9999
                 n = n + 1
             endif
         endif
      enddo
      write(6,*) 'Eliminati ', nint(n), ' picchi (fosfori)'
!
!-- elimina i picchi corrispondenti agli atomi del modello
!
      dLimit = 1
      write(6,*)
      write(6,*)'Elimina i picchi corrispondenti agli atomi del modello'
      write(6,*) 'con distanza ', dLimit
      write(6,*)
      n = 0
      do i=1, maxNatsPDB
         if (xyzHeavy(4,i)  < 0) cycle
         distmA=9999
         jpuntA = 0
         xo(1:3) = xyzHeavy(1:3,i)
         do j=1, nats
            xn(1:3) = xyzs(1:3,j)
            do k=1, nsymTot
               kt = -1
               call xequiTot(k, xn, xeq, kt)
               call xdist(xo, xeq, d, s)
               if (d < distmA .and. d < dLimit) then
                   distmA = d
                   jpuntA = j
               endif
            enddo
         enddo
         if (jpuntA > 0) then
             if (model(1)%HETA(jpuntA,1)  >= 0) then
                 write(6,*) 'Eliminato ',i,' vicino a ',aLab(jpuntA),
     *                      distmA
                 xyzHeavy(4,i) = -9999
                 n = n + 1
             endif
         endif
      enddo
      write(6,*) 'Eliminati ', nint(n), ' picchi (atomi leggeri)'

!
!-- riduci la lista dei picchi
!

      j = 0
      do i=1, maxNatsPDB
         if (xyzHeavy(4,i) > 10.0) then
             j = j + 1
             xyzHeavy(1:5,j) = xyzHeavy(1:5,i)
             aLabHeavy(j) = aLabHeavy(i)
         endif
      enddo
      maxNatsPDB = j

      if (knw > 0) then
          write(6,*)
          write(6,*) 'ANALISIFOSFORI lista ridotta', maxNatsPDB
          write(6,*)
          do i=1, maxNatsPDB
             write(6,50) i, aLabHeavy(i), nint(xyzHeavy(4,i)),
     *                   xyzHeavy(1:3,i), xyzHeavy(5,i)
          enddo
      endif

      k = index(FichierOut, '.pdb')
      AmbPDB = FichierOut
      FichierOut = AmbPDB(1:k-1) // '_Modificato.pdb'
      itype = 0
      iform = 1
      jop = jopen(ifour,FichierOut,itype,iform,ier)
      numbPDB = nats
      call outPDB(ifour, numbPDB, 1, 0, 1)
      close (ifour)
      
      if (maxNatsPDB == 0) then
          ifHeavyAtom = .false.
      endif

      go to 5

         nMacroRef = 2
         nRefi = 5
         FasiPerRefmac = -1
         call UseRefmacN(nRefi, 0, nMacroRef, ier)
         write(6,*) 'DOPO REFMAC R, RFree ', RfacAW, RfreAW
         erreRif = RfacAW
!
      do i=1, numTerminali
         write(6,30) i, model(1)%label(terminali(1,i)), 
     *                  model(1)%label(terminali(2,i)),
     *                  terminali(1,i), terminali(2,i)
         do j=terminali(1,i), terminali(2,i)
            model(1)%HETA(j,1) = model(1)%HETA(j,1) - 1000
         enddo
         FichierOut = AmbPDB(1:k-1) // '_Modificato.pdb'
         itype = 0
         iform = 1
         jop = jopen(ifour,FichierOut,itype,iform,ier)
         numbPDB = nats
         call outPDB(ifour, numbPDB, 1, 0, 1)
         close (ifour)
      
         nMacroRef = 2
         nRefi = 5
         FasiPerRefmac = -1
         call UseRefmacN(nRefi, 0, nMacroRef, ier)
         write(6,*) 'DOPO REFMAC R, RFree ', RfacAW, RfreAW
         do j=terminali(i,1), terminali(i,1)
            model(1)%HETA(j,1) = model(1)%HETA(j,1) + 1000
         enddo
      enddo
!
    5 continue


      go to 6

      natsInModel(1) = nats
      do i=1, natsInModel(1)
         model(1)%numResiduo(i,1) = i + nResidStored
         model(1)%tipoAtomo(i,1)   = SHeavyPDB
         model(1)%tipoResiduo(i,1) = ' ' // SHeavyPDB(1:3)
         model(1)%HETA(i,1)        = 1
      enddo
!
      k = index(FichierOut, '.pdb')
      cardImage = FichierOut(1:k-1) // '_Modificato.pdb'
      itype = 0
      iform = 1
      jop = jopen(ifour,cardImage,itype,iform,ier)
      numbPDB = nats
      call outPDB(ifour, numbPDB, 1, 0, 1)
      close (ifour)
!
    6 continue

      if (ifHeavyAtom) then
          nats = maxNatsPDB
          bfac(1:nats) = bt
          call PutModel
          natsInModel(1) = nats
          do i=1, natsInModel(1)
             model(1)%numResiduo(i,1) = i + nAcid
             model(1)%tipoAtomo(i,1)   = SHeavyPDB
             model(1)%HETA(i,1)        = 1
             model(1)%specie(i,1) = ZHeavyPDB * nzConst
             if (SHeavyPDB(1:2) /= 'AS') then
                 model(1)%tipoResiduo(i,1) = ' ' // SHeavyPDB(1:3)
             else
                 model(1)%tipoResiduo(i,1) = 'CAC'
             endif
          enddo
          if (knw > 0) then
              aLab(1:maxNatsPDB) = aLabHeavy(1:maxNatsPDB)
              CaOnly = .false.
              call to_coord_sir(1, nrefl)
              CaOnly = .true.
          endif

      go to 7 

          PDBfile = nome(1:lnome)  // '_heavy' // '.pdb'
          k = Lung(PDBfile)
          natsPDB = maxNatsPDB
          itype = 0
          iform = 1
          jop = jopen(jhost,PDBfile(1:k),itype,iform,ier)
          call outPDB(jhost, natsPDB, 1, 0, 1)
          close(jhost)
          if (knw == 1) write(lo,40) PDBfile(1:k)

    7 continue

      endif
      write(6,*) 'Copiato ',FichierOut(1:Lung(FichierOut)), '  in ',
     *           AmbPDB(1:Lung(AmbPDB))
*     pause
      call cCopyFile(FichierOut, AmbPDB)
      FichierOut = AmbPDB

      deallocate(legami, terminali, stat = ier)
! YYYYYYYYYYYYY
      ifCABsav = ifCAB
      ifCAB = 99
      nMacroRef = 2
      nRefi = 10
      FasiPerRefmac = -1
      call UseRefmacN(nRefi, 0, nMacroRef, ier)
      write(6,*)
      write(6,*) 'calcolo Refmac dopo aggiunta fosfori ', RfacAW
      write(6,*)
      ifCAB = ifCABsav
! YYYYYYYYYYYYY
!
      return
   10 format(' dist ',i4,2x,a,i4,2x,a,f10.6)
   11 format(/,' Peak    Height      X          Y          Z')
   15 format('  Peak  Int   Atom  Int    Name               dist')
   18 format(i4,f11.2,3f11.4)
   20 format(i5,3i6,4x,a,f10.6)
   25 format('Fosfori nel target = ', i4,' Fosfori nel modello =', i4)
   30 format(' Terminale ',i2,2x,a,a,2i5,i9)
   40 format(/,' Written the file ',a,/)
   50 format(i4,') ',a,i10,4f7.4,2x,a)
   55 format(i4,')',i10,4f7.4,2x,f7.3,2x,a)
   60 format(" Intensità del picco ",i4,' dist ',f8.4,' vicino a ',a
     *       ,2x,i6)
   70 format(
     *  'Serial      Int  X      Y      Z      Occ     Bterm   Fosforo')
      end
! ----------------------------------------------------------------------
      subroutine AltezzaPicchiModello(maxNatsPDB)
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE PhMod
      USE RemoModule
      USE PhaseModule
      USE ArpWarp
      USE Molcom
      USE TestModel
!
      implicit none
      integer :: i, j, k, kt, maxNatsPDB, P, mode, numb, ier, n
      integer :: iflagPKS, jpuntA, ipuntA
      real    :: distmA, xn(3), xo(3), xeq(3), s(3), d, dLimit
      character(len=4):: a4
!
      if (knw > 0) then
          write(6,*) 'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX'
          write(6,*) '  ALTEZZE DEGLI ATOMI DEL MODELLO'
          write(6,*) 'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX'
          write(6,*) ' Peak search nella mappa fourier intonsa'
          write(6,*) 'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX'
      endif
      do i=1, nk
         a4 = Species(i)
         call ucase(a4)
*        write(6,*) i, a4
         if (a4(1:2) == 'P ') then
             P = i
             exit
         endif
      enddo
!
      nats = maxNatsPDB
      aperc(1) = maxNatsPDB
      ifFour = 1
      iflagPKS = 0
      mode = 0
      krecy = 0
      numb = nrefl
      ier = 0
      call pksrch_New(mode, iflagPKS, numb, ier)
      xyzHeavy(1:5,1:maxNatsPDB) =  xyzs(1:5,1:maxNatsPDB)
      IntModel(1:maxNatsPDB) = xyzs(4,1:maxNatsPDB)
      if (knw > 0) write(6,10)
      j = 0
      do i=1, maxNatsPDB
         if (xyzs(4,i) > 10) then
             j = j + 1
             if (knw > 0) write(6,20) i, xyzs(4,i), xyzs(1:3,i)
         endif
      enddo
      maxNatsPDB = j
      nats = maxNatsPDB
      do i=1, nats
         aLab(i) = ' '
         write(aLab(i)(1:4),'(i4)') i
      enddo
      if (knw > 0) then
          write(6,*)
          write(6,*) 'Confronto tra picchi intonsi e target'
          write(6,*)
          nzSav(1:nats) = nz(1:nats)
          CaOnly = .false.
          call to_coord_sir(1, nrefl)
          nz(1:nats) = nzSav(1:nats)
      endif
!
      confronta = .false.
      call LoadPDBfromAmb(0,0,1)
      confronta = .true.
      xyzs(4,1:maxNatsPDB) = IntModel(1:maxNatsPDB)
!
      dLimit = 2.5
      if (knw > 0) then
          write(6,*) 
          write(6,*)'Altezza dei picchi corrispondenti ai P del modello'
          write(6,*)  'Soglia per la distanza ', dLimit
          write(6,*) 
          write(6,30)
      endif

      do i=1, nats
         distmA = 9999
         jpuntA = 0
         ipuntA = 0
         xo(1:3) = xyzs(1:3,i)
         do j=1, maxNatsPDB
            xn(1:3) = xyzHeavy(1:3,j)
            do k=1, nsymTot
               kt = -1
               call xequiTot(k, xn, xeq, kt)
               call xdist(xo, xeq, d, s)
               if (d < distmA .and. d < dLimit) then
                   distmA = d
                   jpuntA = j
                   ipuntA = i
               endif
            enddo
         enddo
         if (ipuntA > 0) then
             if (nzTot(ipuntA) == P .and. knw > 0) then
                 write(6,40) jpuntA, aLab(ipuntA), distmA,
     *                       xyzHeavy(4,jpuntA), bfac(ipuntA)
             endif
             xyzs(4,i) = xyzHeavy(4,jpuntA)
         endif
      enddo
!
      IntModel(1:maxNatsPDB) = xyzs(4,1:maxNatsPDB)
      if (knw > 0) then
          write(6,*) 'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX'
          write(6,*) '  FINE ALTEZZE DEGLI ATOMI DEL MODELLO'
          write(6,*) 'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX'
      endif
!
      return
   10 format(/,' Peak    Height      X          Y          Z')
   20 format(i4,f11.2,3f11.4)
   30 format(/,' Peak  close to            dist      Height      Bfac')
   40 format(i4, 3x,a,2x,f7.4,2(3x,f8.2))
   41 format(i4, 3x,a,3x,f12.4,3x,f8.2,' TEST')
      end
! ----------------------------------------------------------------------
      subroutine AvvicinaModelli
      USE General
      USE Symmetry
      USE RemoModule
      USE Molcom
!
      integer none
      integer :: WM, i, j, k, kt, ifi, minimi(5), kx, ky, kz
      integer :: itype, iform, jop, jopen, ier, vet(5)
!
      real    :: x1(3), x2(3), bari0(3), bari(3), xeq(3), coef, distA
      real    :: dist, s(3)
!
      if (numbModels == 1) return
!
      vet(1) = -2
      vet(2) = -1
      vet(3) =  0
      vet(4) =  1
      vet(5) =  2
      bari0(:) = 0
      WM = 1
      do i=1, natsInModel(WM)
         call MoltMatVec(rm, model(WM)%atoms(1:3,i,1), x1)
         model(WM)%ortho(1:3,i,1) = x1(1:3)
         bari0(1:3) = bari0(1:3) + x1(1:3)
      enddo
      bari0(1:3) = bari0(1:3) / float(natsInModel(WM))
      if (knw > 0) then
          write(6,'(a,3f8.3)') 'BARI 0 ', bari0(1:3)
      endif

      bari(:) = 0
      WM = 2
      do i=1, natsInModel(WM)
         call MoltMatVec(rm, model(WM)%atoms(1:3,i,1), x1)
         model(WM)%ortho(1:3,i,1) = x1(1:3)
         bari(1:3) = bari(1:3) + x1(1:3)
      enddo
      bari(1:3) = bari(1:3) / float(natsInModel(WM))
*     write(6,'(a,3f8.3)') 'BARI 1 ', bari(1:3)
!
      do WM=2, numbModels
         bari(1:3) = 0
         do i=1, natsInModel(WM)
            bari(1:3) = bari(1:3) + model(WM)%atoms(1:3,i,1)
         enddo
         bari(1:3) = bari(1:3) / float(natsInModel(WM))
*        call MoltMatVec(rm, bari, x1)
*        write(6,'(a,3f8.3)') 'BARI ', x1(1:3)
!
         coef = 1
         distA = 9999
         do kt=1, ncentr
            do k=1, nsym
               call xequi(bari, k, coef, xeq, kt)
               call MoltMatVec(rm, xeq, x1)
               do kx=1,5
                  do ky=1,5
                     do kz=1,5
                        x2(1) = x1(1) + vet(kx) * cell(1)
                        x2(2) = x1(2) + vet(ky) * cell(2)
                        x2(3) = x1(3) + vet(kz) * cell(3)
                        dist = 0.
                        do i=1, 3
                           dist = dist + (bari0(i)-x2(i))**2
                        enddo
                        dist = sqrt(dist)
*                       write(6,'(5i4,f12.4)') kt, k, vet(kx),
*    *                                         vet(ky), vet(kz), dist
                        if (dist < distA) then
                            if (knw > 0) then
                               write(6,'(a,i4,3f8.3)')'BARI ',WM,x1(1:3)
                            endif
                            distA = dist
                            minimi(1) = kt
                            minimi(2) = k
                            minimi(3) = vet(kx)
                            minimi(4) = vet(ky)
                            minimi(5) = vet(kz)
                        endif
                     enddo
                  enddo
               enddo
            enddo
         enddo
!
         do i=1, natsInModel(WM)
            bari(1:3) = model(WM)%atoms(1:3,i,1)
            coef = 1
            call xequi(bari, minimi(2), coef, xeq, minimi(1))
            xeq(1) = xeq(1) + minimi(3)
            xeq(2) = xeq(2) + minimi(4)
            xeq(3) = xeq(3) + minimi(5)
            model(WM)%atoms(1:3,i,1) = xeq(1:3)
         enddo
      enddo
!
*     itype = 0
*     iform = 1
*     jop = jopen(jhost, FichierOut, itype, iform, ier)
*     call outPDB(jhost, 0, 0, 0, 0)
*     close(jhost)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine AvvicinaHA(maxNatsPDB)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE PhMod
!
      implicit none
      integer :: i, ii, j, k, kt, kx, ky, kz, vet(3), maxNatsPDB
      integer :: minimi(5)
      real    :: bari(3), x2(3), bario(3), x2o(3), dist, coef, distmA
      real    :: xeq(3), x3(3)
!
!-- avvicina gli heavy atoms al modello
!
      vet(1) = -1
      vet(2) =  0
      vet(3) =  1
      bari(1:3) = 0
      do i=1, nats
         bari(1:3) = bari(1:3) + xyzs(1:3,i)
      enddo
      bari(1:3) = bari(1:3) / float(nats)
      call MoltMatVec(rm, bari, bario)
      if (knw > 0) write(6,'(a,3f8.3)') 'BARI 0 ', bario(1:3)
!
      coef = 1
      do j=1, maxNatsPDB
         x2(1:3) = xyzHeavy(1:3,j)
         distmA = 9999
         do kt=1, ncentr
            do k=1, nsym
               call xequi(x2, k, coef, xeq, kt)
               call MoltMatVec(rm, xeq, x2o)
               do kx=1,3
                  do ky=1,3
                     do kz=1,3
                        x3(1) = x2o(1) + vet(kx) * cell(1)
                        x3(2) = x2o(2) + vet(ky) * cell(2)
                        x3(3) = x2o(3) + vet(kz) * cell(3)
                        dist = 0.
                        do ii=1, 3
                           dist = dist + (bario(ii)-x3(ii))**2
                        enddo
                        dist = sqrt(dist)
                        if (dist < distmA) then
                            distmA = dist
                            minimi(1) = kt
                            minimi(2) = k
                            minimi(3) = vet(kx)
                            minimi(4) = vet(ky)
                            minimi(5) = vet(kz)
                        endif
                     enddo
                  enddo
               enddo
            enddo
         enddo
         coef = 1
         call xequi(x2, minimi(2), coef, xeq, minimi(1))
         x3(1) = xeq(1) + minimi(3)
         x3(2) = xeq(2) + minimi(4)
         x3(3) = xeq(3) + minimi(5)
         xyzHeavy(1:3,j) = x3(1:3)
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Phosphate
      USE General
      USE ArpWarp
!
      implicit none
      integer :: k, jop, jopen, itype, iform, ios, Lung, ier
      logical :: stampaCopy
      character (len=2) :: LineCont
      character (len=3) :: po3o5
      character (len=6) :: linea
      logical :: Esiste
!
      cardDiret = '/home/gianluca/nautilus/cnautilus'
      inquire (file=cardDiret, exist = Esiste)
      if (.not.Esiste) then
          DoPhosphate = .false.
          Msg = nome(1:lnome) // '_po3o5_out.pdb'
          if (knw > 0) write(6,*) 'NON CREATO ', Msg(1:Lung(Msg))
          return
      endif
!
      stampaCopy = .true.
      itype = 2
      iform = 1
      if (stampaCopy .and. knw == 1) then
          write(6,*) 'from PHOSPHATE FichierOut ',
     *               FichierOut(1:Lung(FichierOut))
      endif 
!
      Msg = nome(1:lnome) // '_po3o5_out.pdb'
      call RemoveFile
!
      jop = jopen(jgrap, FichierOut, itype, iform, ios)
      itype = 0
      iform = 1
      Inte = nome(1:lnome) // '_po3o5.pdb'
      if (stampaCopy .and. knw == 1) then
          write(6,*) 'PRODUCE  ',Inte(1:Lung(Inte))
      endif 
      jop = jopen(jrel, Inte, itype, iform, ios)
!
      do
         read(jgrap,'(a)', end = 10) cardImage
         linea(1:3) = cardImage(1:3)
         call ucase(linea)
         if (linea(1:3) == 'CRY' .or.
     *       linea(1:3) == 'SCA' .or.
     *       linea(1:3) == 'TER' .or.
     *       linea(1:3) == 'END') then
             write(jrel,'(a)') cardImage(1:Lung(cardImage))
         elseif (linea(1:3) == 'ATO') then
             po3o5 = cardImage(14:16)
             call ucase(po3o5)
             if (po3o5 == "P  " .or.
     *           po3o5 == "O3'" .or.
     *           po3o5 == "O5'") then
                 write(jrel,'(a)') cardImage(1:Lung(cardImage))
             endif
         endif
         if (linea(1:3) == 'END') then
             exit
         endif
      enddo
   10 close(jgrap)
      close(jrel)
!
!-- Write new Nautilus input file
!
      cardDiret = nome(1:lnome) // '_phosphate.inp '
      itype = 0
      iform = 1
      jop = jopen(jhost, cardDiret, itype, iform, ier)
      Msg = '  mtzin            ' // nome(1:lnome) // '_improved.mtz'
      write(jhost,'(a)') Msg(1:Lung(Msg))
      Msg = '  colin-fo         F,SIGF'
      write(jhost,'(a)') Msg(1:Lung(Msg))
      Msg = '  colin-hl         HLA,HLB,HLC,HLD'
      write(jhost,'(a)') Msg(1:Lung(Msg))
      Msg = '  colin-free       FreeR_flag'
      write(jhost,'(a)') Msg(1:Lung(Msg))
      Msg = '  pdbin-phosphate  ' // nome(1:lnome) // '_po3o5.pdb'
      write(jhost,'(a)') Msg(1:Lung(Msg))
      Msg = '  pdbout           ' // nome(1:lnome) // '_po3o5_out.pdb'
      write(jhost,'(a)') Msg(1:Lung(Msg))
      Msg = '  cycles 0'
      write(jhost,'(a)') Msg(1:Lung(Msg))
      close(jhost)
!
!-- Write structurename_run_phosphate.sh
!
      if (ifW95 == 0) then
          LineCont = ' \'
          Inte = nome(1:lnome) // '_run_phosphate.sh '
      else
          LineCont = ' ^'
          Inte = nome(1:lnome) // '_run_phosphate.bat '
      endif
      itype = 0
      iform = 1
      jop = jopen(jhost, Inte, itype, iform, ier)
*     Msg = 'export LD_LIBRARY_PATH=$CLIB ; ' // 
      Msg = 'export LD_LIBRARY_PATH=' //
     *      "'/home/gianluca/ccp4-7.0-src/ccp4-7.0/lib' ; " // 
     *      '/home/gianluca/nautilus/cnautilus ' //
     *      '-stdin<' // cardDiret(1:Lung(cardDiret)) //
     *      ' >' // nome(1:lnome) // '_phosphate.log '
      write(jhost,'(a)') Msg(1:Lung(Msg))
      close(jhost)
!
      k = Lung(Inte)
      Inte(k+1:k+1) = char(0)
      call MakeExec(Inte)
!
!-- Start new nautilus shell script
!
      Buffer1 = WorkingDirectory(1:Lung(WorkingDirectory))
     *       // slash // Inte
      k = Lung(Buffer1)
      Buffer1(k+1:k+1) = char(0)

*     pause

      call Lanciash(Buffer1)
!
      Msg = nome(1:lnome) // '_po3o5_out.pdb'
      inquire (file=Msg, exist = Esiste)
!
      if (ifCAB == 0) then
          Esiste  = .false.
      endif
!
      if (Esiste) then
          DoPhosphate = .true.
          write(6,*) 'CREATO ', Msg(1:Lung(Msg))
      else
          DoPhosphate = .false.
          write(6,*) 'NON CREATO ', Msg(1:Lung(Msg))
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine CercaLigandi
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
      USE Atomi
      USE Mappa
      USE Param
      USE RemoModule
      USE ArpWarp
      USE Groups
      USE PhMod
      USE Molcom
      USE TestModel
!
      implicit none
      integer :: i, j, k, C, ipher, natsPDB, maxNatsPDB, sogHA, nHA, ier
      integer :: HeavyInPDB, HAvet(8), nzvet(8), numb, nset, jj, kkk
      integer :: iflagPKS, mode, kt, ifAmbS, Box_CAB, Lung
      integer :: nMacroRef, nRefi, ifCABsav, ifDiff, jscreenSav
      integer :: itype, iform, jop, jopen, ios, maxNatsPDBsav, NREFMAC
      real    :: x1(3), x2(3), xeq(3),dLimit, distmA, d, s(3)
      real    :: RFreeOld, RfreeMinAbs, fig(11), oldR, oldRf
      real    :: erre1, erre2, errore1, errore2, errore3, rapporto
      real    :: distCoordSav, xeqSav(3), atm
      character (len=2) :: a1, a2
      character (len=11) :: tirang
      character (len=80) :: linea
      character(len=256) :: FichierOut_SAV
      common /fasi/ nset
!
!-- USA LA FOURIER DIFFERENZA
!
      write(6,*) 'CERCALIGANDI ', FichierOut(1:Lung(FichierOut))
      do i=1, nk
         if (no(i) == 6) then
             C = i
             exit
         endif
      enddo
      iphazo(1:nrefl) = iphaz(1:nrefl)
      wto(1:nrefl) = wt(1:nrefl)
*     nRefi = 0
*     NREFMAC = nRefi
*     ifDiff = 1
*            anisoRef = .true.
*     call UseRefmac(FichierOut, nRefi, ifDiff, NREFMAC, 0, ier)
*            anisoRef = .false.
      confronta = .true.
      call LoadPDBfromAmb(0,1,1)
      call InitFour(0, ier)
!
      FichierOut_SAV = FichierOut

      oldR  = RfacAW
      oldRf = RfreAW

      maxNatsPDB = float(25 * nAcid) * 1.2

      if (.not.allocated(Pub_target)) then
          call AllocaPhantom(1)
      endif

      nats_added_to_pdb = 0

      if (knw /= 0) then
          call examin(88, mkang, khl, ipub, iphaz, nrefl,0,wt,1)
          tirang = 'Distr. Emap'
          ipher = 1
          call pherrdisNew(tirang,wt,khl,mkang,nrefl,0,
     *                    ipub,iphaz,wt,10,0.0,ipher)
      endif

      f000 = 0
*     fcoef(1:nrefl) = fcvet(1:nrefl)
      fcoef(1:nrefl) = fovet(1:nrefl)*wt(1:nrefl)
      fcoef(1:nrefl) = evet(1:nrefl)*wt(1:nrefl)
      call MakeMap(fcoef, iphaz, nrefl, 0, xmap, FORTH, BACK)
      iphaz(1:nrefl) = iphazo(1:nrefl)
      wt(1:nrefl) = wto(1:nrefl)
!
      nats = maxNatsPDB
      aperc(1) = maxNatsPDB
      ifFour = 1
      iflagPKS = 0
      mode = 0
      krecy = 0
      numb = nrefl
      ier = 0
      call pksrch_New(mode, iflagPKS, numb, ier)
      write(6,*)
      write(6,*) ' Picchi Fourier differenza'
      write(6,*)
      write(6,48)
      j = 0
      do i=1, maxNatsPDB
         if (xyzs(4,i) > 10.0) then
             j = j + 1
             if (knw == 1) then
               write(6,50) i, nint(xyzs(4,i)), xyzs(1:3,i), xyzs(5,i)
               nz(i) = C * nzConst
               aLab(i) = Species(C)(1:2)
               write(Inte,'(a2,i5)') Species(C)(1:2), i
               call NoBlanks(Inte,k)
               aLab(i) = Inte(1:k)
             endif
         endif
      enddo
      maxNatsPDB = j
      nats = maxNatsPDB
      CaOnly = .false.
      if (knw > 0) then
          write(6,*)
          write(6,*) 'Confronto tra picchi e target'
          write(6,*)
          nzSav(1:nats) = nz(1:nats)
          call to_coord_sir(1, nrefl)
          nz(1:nats) = nzSav(1:nats)
      endif

!
!-- flag peaks too close to model atoms
!
      write(6,*)
      write(6,*) 'Flag peaks too close to model atoms'
      write(6,*)
      dLimit = 1.3
      dLimit = radii(nk,1) + 1
      dLimit = maxval(radii(1:nk,1))
      write(6,*) 'Distance limit ',dLimit,' Ang.'
      write(6,*)
      write(6,58)
      do i=1, natsInModel(1)
         distmA = 9999
         x1(1:3) = model(1)%atoms(1:3,i,1)
         do j=1, nats
            if (xyzs(4,j) < 0.0) cycle
            x2(1:3) = xyzs(1:3,j)
            do k=1,nsymTot
               kt = -1
               call xequiTot(k, x2, xeq, kt)
               call xdist(x1, xeq, d, s)
               if (d < dLimit) then
                   write(6,60) i, nint(xyzs(4,i)), model(1)%Label(i),
     *                      j, nint(xyzs(4,j)), aLab(j), d
                   xyzs(4,j) = -abs(xyzs(4,j))
               endif
            enddo
         enddo
      enddo

      j = 0
      do i=1, nats
         if (xyzs(4,i) > 10.0) then
             j = j + 1
             xyzs(:,j) = xyzs(:,i)
             aLab(j) = aLab(i)
         endif
      enddo
      nats = j


      call SaveLists123
      Species(1) = 'C ' ; nw(1) = 72 ; no(1) = 6
      Species(2) = 'N ' ; nw(2) = 16 ; no(2) = 7
      Species(3) = 'O ' ; nw(3) = 56 ; no(2) = 8
      Species(4) = 'P ' ; nw(4) =  8 ; no(2) = 15
      Species(5) = 'BR' ; nw(5) =  8 ; no(2) = 35
      nk = 5
      atm = sum(nw(1:nk)) 
      atm = 1.2 * atm / totop
      nats = atm
      maxNatsPDB = nats
!
      nz(i:nats) = nzConst
!
      call label(maxNatsPDB)
      write(6,*)
      write(6,*) 'Final list of peaks', nats
      write(6,*)
      do i=1, nats
         j = nz(i) / nzConst
         write(Inte,'(a2,i5)') Species(j)(1:2), i
         call NoBlanks(Inte,j)
         aLab(i) = Inte(1:j)
         write(6,'(i4,")",2x,a,5f10.3)') i, aLab(i), xyzs(1:5,i)
      enddo
      jscreenSav = jscreen
      jscreen    = 1
      j = 4
      call build(j, 2)
      jscreen = jscreenSav

      if (knw > 0) then
          write(6,46)
          do i=1, nats
             write(6,55) i, aLab(i), nint(xyzs(4,i)), 
     *                   xyzs(1:3,i), xyzs(5,i)
          enddo
      endif
      if (knw > 0) then
          write(6,*)
          write(6,*) 'Confronto tra picchi selezionati e target'
          write(6,*)
          CaOnly = .false.
          call to_coord_sir(1, nrefl)
          write(6,*)
      endif
*     call cstop('fine CercaLigandi')
!
      Box_CAB = 3
      ifAmbS = ifAmb
      AmbName = 'nautilus'
      lAmb = Lung(AmbName)
      RFreeOld = RfacAW
      RfreeMinAbs = RfacAW
      erreTest = RfacAW
      absVet(2) = RfacAW
      absVet(3) = RfreAW
      Inte = nome(1:lnome) // '_' // AmbName(1:lAmb) // 
     *       '.pdb_minAbs'
      call cCopyFile(FichierOut, Inte)
      MTZfile = nome(1:lnome) // '_refmac0' // '.mtz'
      Inte = nome(1:lnome) // '_' // AmbName(1:lAmb) // 
     *       '.mtz_minAbs'
      call cCopyFile(MTZfile, Inte)

      erre_added_to_pdb = RfacAW
      if (allocated(Pfinal)) then
          Pfinal(1:nrefl) = iphaz(1:nrefl)
          Wfinal(1:nrefl) = wt(1:nrefl)
          Fcvet_MR(1:nrefl) = fcvet(1:nrefl)
      endif
  
      RFreeOld = oldR
      absVet(2) = oldR
      absVet(3) = oldRf
      call ImproveAmbHeavy(RFreeOld, sogHA, natsPDB,
     *     maxNatsPDB, RfreeMinAbs, ifAmbS, Box_CAB)

!
      if (knw /= 0) then
          call examin(88, mkang, khl, ipub, iphaz, nrefl,0,wt,1)
          tirang = 'AFTER HEAVY'
          ipher = 1
          call pherrdisNew(tirang,wt,khl,mkang,nrefl,0,
     *                    ipub,iphaz,wt,10,0.0,ipher)
      endif
!
      erre2   = erre_added_to_pdb
      errore2 = erore
      jj = Lung(linea)
      write(linea(jj+2:),70) erre1, erre2, errore1, errore2, 
     *                       nats_pesanti_in_pdb, nats_added_to_pdb

      errore3 = 0
      if (nats_added_to_pdb > 0) then
          ifPhD = 0
          errore3 = erore
      endif

      if (nats_added_to_pdb == 0) then
          FichierOut = FichierOut_SAV
          Inte = nome(1:lnome) // '_sav' // '.pdb'
          if (knw == 1) then
              write(6,1) FichierOut(1:Lung(FichierOut)),
     *                   Inte(1:Lung(Inte))
          endif
          call cCopyFile(Inte, FichierOut)
      endif

      call PutGetFinalPhases(1, nset, fig)



      write(6,'(a)') linea(1:Lung(linea))


      ifHeavyAtom = .false.

      call AllocaPhantom(2)

      maxNatsPDB = maxNatsPDBsav

      deallocate(xyzHeavy, aLabHeavy, IntModel, stat=ier)

      cardDiret  = nome(1:lnome) // '_improved_HA.pdb'
      call cCopyFile(FichierOut, cardDiret)
      if (nats_added_to_pdb > 0) then
          call RemoveHeavyPDB  !  commentare per Riga 2

      endif

      call LoadPDBfromAmb(0,0,1)
      if (knw > 0) then
          write(6,*)
          write(6,*) 'Confronto finale tra modello MR e target (solo P)'
          write(6,*)
      endif
      distCoordSav = distCoord
      distCoord = 2.0
      CaOnly = .true.
      nzSav(1:nats) = nz(1:nats)
      call to_coord_sir(1, nrefl)
      distCoord = distCoordSav
*     distCoord = distCoordSav
      nz(1:nats) = nzSav(1:nats)
      write(6,*)
      write(6,*) 'Confronto tra modello MR e target'
      write(6,*)
*     distCoordSav = distCoord
*     distCoord = 10
      CaOnly = .false.
      nzSav(1:nats) = nz(1:nats)
      call to_coord_sir(1, nrefl)
*     distCoord = distCoordSav
      nz(1:nats) = nzSav(1:nats)
      CaOnly = .true.
!
*     call cstop('fine CercaLigandi')
!
      return
    1 format(' COPY ',a,' IN ',a)
   10 format(/,' Heavy atoms:',/,
     *         ' Species  Z  number')
   20 format(3x,a2,2i6)
   30 format('HETATM      ',a2,3x,'HET',10x,3f8.3,2f6.2,10x,a2)
   45 format(/,'           Int   X      Y      Z     Occ')
   46 format(/,
     *     '     Heavy                  Int   X      Y      Z     Occ')
   48 format(/,' Peak   Height   X      Y      Z    Occ')
   50 format(i3,')',i10,4f7.4)
   55 format(i3,') ',a,i10,4f7.4)
   58 format(' Atom  Int  Name             Heavy Int  Name             '
     *       '    dist')
   60 format(2(2i5,2x,a),2x,f8.3)
   70 format(' ', 2f8.4,2f8.2,2i4)
   75 format(' ', 2f8.4,3f8.2,2i4)
   80 format(' AGGIUNGI ', a2, i3)
   90 format(' AGGIUNGI NOT APPLIED', a, 2i3)
  100 format(3i4)
      end
!-----------------------------------------------------------------------
      subroutine GetLab(i, labstring)
      USE RemoModule
!
      implicit none
      integer            :: i, j, k, Lung
      character  (len=*) :: labstring
!
      j = InfoOnModels(WhichModel)%iEqui(i)
      k = Lung( model(WhichModel)%Label(j) )
      labstring = model(WhichModel)%Label(j)(1:k) // char(0)
!
      return
      end
!-----------------------------------------------------------------------
      integer function GetZ (i)
      USE RemoModule
      USE Atomi, only : nzConst
!
      implicit none
      integer            :: i, j, k
!
      j = InfoOnModels(WhichModel)%iEqui(i)
      k = model(WhichModel)%specie(j, 1) / nzConst
      GetZ = model(WhichModel)%no(k)
!
      return
      end
!-----------------------------------------------------------------------
      real function GetXYZ(i, j)
      USE RemoModule
      USE Atomi
!
      implicit none
      integer       :: i, j
!
      GetXYZ = model(WhichModel)%ortho(j,i,1)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine ManageHetInModel(FileName, Ok)
      USE General
!
      implicit none
      integer :: jop, jopen, itype, iform, ios, Lung, L, i, j, k
      integer :: Res, oldRes
      logical :: Ok
      character (len=1) :: cat, oldcat
      character (len=*) :: FileName
      character (len=256) :: fileProbeRefmac
!
      close(jhost)
      L = Lung(FileName)
      write(lo,20) FileName(1:L)
      itype = 2
      iform = 1
      jop = jopen(jgrap, FileName, itype, iform, ios)
!
      cardDiret = ' '
      oldcat = ' '
      oldRes = -9999
      i = 0
      do
         read(jgrap,'(a)',end=10) cardImage
         i = i + 1
         call ucase(cardImage)
         if (cardImage(1:3) == 'TER' .or. cardImage(1:4) == 'ATOM') then
             k = i
         endif
      enddo
   10 continue
!
      rewind(jgrap)
      cardImage = FileName
      call ucase(cardImage)
      i = index(cardImage,'.PDB')
      fileProbeRefmac = FileName(1:i-1) // '_het' // FileName(i:L)
      itype = 0
      iform = 1
      jop = jopen(jrel, fileProbeRefmac, itype, iform, ios)
      do i=1, k
         read(jgrap,'(a)',end=10) cardImage
         write(jrel,'(a)') cardImage(1:Lung(cardImage))
      enddo
      write(jrel,'(a)') 'END'
      close(jgrap)
      close(jrel)
!
      call ProbeRefmac(fileProbeRefmac, Ok)
!
      if (Ok) then
          FileName = fileProbeRefmac(1:Lung(fileProbeRefmac))
      else
          if (knw > 0) write(6,*) 'PROBEREFMAC FAILED'
      endif
      jop = jopen(jhost, FileName, itype, iform, ios)
!
      return
   20 format(/,'HETATM atoms will be deleted from ',a,/)
      end
!-----------------------------------------------------------------------
      subroutine ProbeRefmac(file, Ok)
      USE General
      USE RemoModule
!
      implicit none
      integer :: nRefi, jop, jopen, itype, iform, ios, ier, sav, k
      integer :: ifHOH, kAla, numbPDB, ifFast, ifREM, filtra
      logical :: Ok
      character (len=*) :: file
!
      k =  index(file,'.pdb')
      cardImage = file(1:k-1) // '_tmp.pdb'
      call cCopyFile(file, cardImage)
      itype = 2
      iform = 1
      jop = jopen(jhost, cardImage, itype, iform, ios)
      ifHOH = 0
      kAla  = 0
      ier   = 0
      LeggiHetam = 1
      SkipAnis = .true.
      call ManagePDBSir(0, ifHOH, LeggiHetam, kAla, 0, ier)
      SkipAnis = .false.
      close(jhost)
      natsInModel(1) = natsMR
      cardImage = file(1:k-1) // '_tmp.pdb'
      itype = 2
      iform = 1
      jop = jopen(jhost, cardImage, itype, iform, ios)
      numbPDB = -1
      ifFast  = 2
      ifREM   = 0 
      filtra  = 0 
      sav     = ifRemo
      ifRemo  = 0
      call outPDB(jhost, numbPDB, ifFast, ifREM, filtra)
      close(jhost)
      ifREmo = sav
!
      FichierOut = file(1:k-1) // '_tmp.pdb'
      nRefi = 1
      call LanciaRefmac(FichierOut, nRefi)
      cardImage = nome(1:lnome) // '_refmac.log'
      itype = 2
      iform = 1
      jop = jopen(jgrap, cardImage, itype, iform, ios)
      Ok = .false.
      do
         read(jgrap,'(a)',end=10) Inte
         if (index(Inte,'$TEXT:Result: $$ Final results $$') > 0) then
             Ok = .true.
             exit
         endif
      enddo
   10 close(jgrap)
      return
!
      return
   20 format(/,'HETATM atoms will be deleted from ',a,/)
      end
!-----------------------------------------------------------------------
      subroutine PrePostCAB(nBC, tabImpr, errePostCAB, identical)
      USE General
      USE Riflessi
      USE PhaseModule
      USE AlignDNA
      USE ArpWarp
      USE PhMod, only: tabPrev
!
      implicit none
      integer :: nBC, i, n, lix1, lix2, nExitCode, iAction
      integer :: ier, Lung, doRicicla, ksubr, knwSav, identical
      real    :: PCAB(5), celltemp(13), errePostCAB, Rval, R, Rf
      real    :: tabImpr(16), Rpost(2)
      character (len=1) :: unodue
!
      identical = 0
      ier = 0
      PCAB(:) = 9999
      Rpost(:) = 9999
      if (nBC == 1) then
          n = 1
      else
          n = 2
      endif
      do i=1, n
         write(unodue,'(i1)') i
*        if (i == 1) then
*            FichierOut = nome(1:lnome) // '_CAB1.pdb'
*            MTZfile = nome(1:lnome) // '_CAB1.mtz'
*        else
*            FichierOut = nome(1:lnome) // '_CAB2.pdb'
*            MTZfile = nome(1:lnome) // '_CAB2.mtz'
*        endif
         FichierOut = nome(1:lnome) // '_CAB' // unodue // '.pdb'
         MTZfile = nome(1:lnome) // '_CAB' // unodue // '.mtz'
         cardImage = nome(1:lnome) // '_nautilus_lab.mtz'
         call cCopyFile(MTZfile, cardImage)
!
         call LeggiMtzDna
         if (knw > 0) then
             write(6,'(a,2x,a)') 'PREPOSTCAB',MTZfile(1:Lung(MTZfile))
         endif
         call examin(1000, mkang, khl, ipub, iphaz, nrefl, 0, wt, 1)
!
         call PostCAB(Rval)
         Rpost(i) = Rval
!

*        go to 1

         if (knw > 0) then
             write(6,*) 'PREPOSTCAB PCAB', i, Rpost(i)
             write(6,*) PCAB(1:5)
             if (nint(CabVet( 8)) /= -1) then
                 write(6,100) nint(CabVet( 9)), nint(CabVet( 8)),
     *                        nint(CabVet(11)), nint(CabVet(12)),
     *                        CabVet(13), i
             else
                 write(6,200) i
             endif
         endif

*   1 continue

         if (i == 1) then
             PCAB(1) = CabVet( 9)
             PCAB(2) = CabVet( 8)
             PCAB(3) = CabVet(11)
             PCAB(4) = CabVet(12)
             PCAB(5) = CabVet(13)
             cardImage = nome(1:lnome) // '_CAB' // unodue // '.pdb'
             cardDiret = nome(1:lnome) // '_CAB.pdb'
             call cCopyFile(cardImage, cardDiret)
             cardImage = nome(1:lnome) // '_CAB' // unodue // '.mtz'
             cardDiret = nome(1:lnome) // '_CAB.mtz'
             call cCopyFile(cardImage, cardDiret)
!!           cardImage = nome(1:lnome) // '_refmac.pdb'    ! 19marzo
             cardImage = nome(1:lnome) // '_CAB.pdb'
             cardDiret = nome(1:lnome) // '_mod.pdb'
             call cCopyFile(cardImage, cardDiret)
             cardImage = nome(1:lnome) // '_refmac0.mtz'
             cardImage = nome(1:lnome) // '_CAB.mtz'       ! 19 marzo
             cardDiret = nome(1:lnome) // '_mod.mtz'
             call cCopyFile(cardImage, cardDiret)
         else
            if (CabVet( 9) < PCAB(1)) then
                PCAB(1) = CabVet( 9)
                PCAB(2) = CabVet( 8)
                PCAB(3) = CabVet(11)
                PCAB(4) = CabVet(12)
                PCAB(5) = CabVet(13)
                cardImage = nome(1:lnome) // '_CAB' // unodue // '.pdb'
                cardDiret = nome(1:lnome) // '_CAB.pdb'
                call cCopyFile(cardImage, cardDiret)
                cardImage = nome(1:lnome) // '_CAB' // unodue // '.mtz'
                cardDiret = nome(1:lnome) // '_CAB.mtz'
                call cCopyFile(cardImage, cardDiret)
                cardImage = nome(1:lnome) // '_refmac.pdb'
                cardDiret = nome(1:lnome) // '_mod.pdb'
                call cCopyFile(cardImage, cardDiret)
                cardImage = nome(1:lnome) // '_refmac0.mtz'
                cardDiret = nome(1:lnome) // '_mod.mtz'
                call cCopyFile(cardImage, cardDiret)
            endif
         endif
      enddo
!
      if (nint(PCAB(2)) /= -1) then
!                      | Re | CAB| Mae| Maa| <dist> |
          if (knw > 0) write(6,100) nint(PCAB(1:4)), PCAB(5)
!                      | Syn|  R | AMB| MAp| MAa| <dist> |
          tab3(2) = PCAB(1) / 10000.
          tab3(3) = PCAB(2)
          tab3(4) = PCAB(3)
          tab3(5) = PCAB(4)
          tab3(6) = PCAB(5)
      else
          if (knw > 0) write(6,200) 

          tab3(2) = tabPrev(11)
          tab3(3) = tabPrev(12)
          tab3(4) = tabPrev(13)
          tab3(5) = tabPrev(14)
          tab3(6) = tabPrev(15)
          identical = 1
      endif
!
      if (identical == 1) then
          if (Rpost(1) < Rpost(2)) then
              i = 1
          else
              i = 2
          endif
          write(unodue,'(i1)') i
          cardImage = nome(1:lnome) // '_CAB' // unodue // '.pdb'
          cardDiret = nome(1:lnome) // '_mod.pdb'
          call cCopyFile(cardImage, cardDiret)
          cardImage = nome(1:lnome) // '_CAB' // unodue // '.mtz'
          cardDiret = nome(1:lnome) // '_mod.mtz'
          call cCopyFile(cardImage, cardDiret)
      endif
!
      errePostCAB = tab3(2)
!
      if (ifAmb == 0) then
          call StampaTab2()
      endif
!
      cardImage = FichierOut
      FichierOut = nome(1:lnome) // '_mod.pdb'
      call cCopyFile(cardImage, FichierOut)
      call GetRvalueFromPDB(R, Rf, 1)
!
      ifPostCAB = -1
!
      return
  100 format('TABIMPM ',61x,'|',i4,3('|',i3,' '),'| ',f6.3,' | ',i1)
  200 format('TABIMPM ',61x,'| IDENTICAL                  | ',i1)
      end
!-----------------------------------------------------------------------
      subroutine NewPostCAB(nBC, tabImpr)
      USE General
      USE Riflessi
      USE PhaseModule
      USE AlignDNA
      USE ArpWarp
      USE PhMod, only: tabPrev
!
      implicit none
      integer :: nBC, i, n, lix1, lix2, nExitCode, iAction
      integer :: ier, Lung, doRicicla, ksubr, knwSav
      real    :: PCAB(5), celltemp(13), Rval
      real    :: tabImpr(16)
      character (len=1) :: unodue
!
      ifPostCAB = 1
      i = 1
      ier = 0
      PCAB(:) = 9999
      write(unodue,'(i1)') i
      cardImage = nome(1:lnome) // '_nautilus_lab.mtz'
      call cCopyFile(MTZfile, cardImage)
!
      call LeggiMtzDna
      write(6,'(a,2x,a)') 'NEWPOSTCAB',MTZfile(1:Lung(MTZfile))
      call examin(1000, mkang, khl, ipub, iphaz, nrefl, 0, wt, 1)
!
      call PostCAB(Rval)
!
      write(6,*) PCAB(1:5)
      if (nint(CabVet( 8)) /= -1) then
          write(6,100) nint(CabVet( 9)), nint(CabVet( 8)),
     *                 nint(CabVet(11)), nint(CabVet(12)),
     *                 CabVet(13), i
      else
          write(6,200) i
      endif
      PCAB(1) = CabVet( 9)
      PCAB(2) = CabVet( 8)
      PCAB(3) = CabVet(11)
      PCAB(4) = CabVet(12)
      PCAB(5) = CabVet(13)
      cardImage = nome(1:lnome) // '_CAB' // unodue // '.pdb'
      cardDiret = nome(1:lnome) // '_CAB.pdb'
      call cCopyFile(cardImage, cardDiret)
      cardImage = nome(1:lnome) // '_CAB' // unodue // '.mtz'
      cardDiret = nome(1:lnome) // '_CAB.mtz'
      call cCopyFile(cardImage, cardDiret)
      cardImage = nome(1:lnome) // '_refmac.pdb'
      cardDiret = nome(1:lnome) // '_mod.pdb'
      call cCopyFile(cardImage, cardDiret)
      cardImage = nome(1:lnome) // '_refmac0.mtz'
      cardDiret = nome(1:lnome) // '_mod.mtz'
      call cCopyFile(cardImage, cardDiret)
!
      if (nint(PCAB(2)) /= -1) then
!                      | Re | CAB| Mae| Maa| <dist> |
          write(6,100) nint(PCAB(1:4)), PCAB(5)
!                      | Syn|  R | AMB| MAp| MAa| <dist> |
          tab3(2) = PCAB(1) / 10000.
          tab3(3) = PCAB(2)
          tab3(4) = PCAB(3)
          tab3(5) = PCAB(4)
          tab3(6) = PCAB(5)
      else
          write(6,200) 
          tab3(2) = tabPrev(11)
          tab3(3) = tabPrev(12)
          tab3(4) = tabPrev(13)
          tab3(5) = tabPrev(14)
          tab3(6) = tabPrev(15)
      endif
!
       tabImpr(14) = RfacAW
!
      if (ifAmb == 0) then
          call StampaTab2()
      endif
!
      return
  100 format('TABIMPM ',61x,'|',i4,3('|',i3,' '),'| ',f6.3,' | ',i1)
  200 format('TABIMPM ',61x,'| IDENTICAL                  | ',i1)
      end
!---------------------------------------------------------------
      subroutine LeggiMtzDna
      USE General
      USE Riflessi
      USE PhaseModule
!
      implicit none
      integer :: lix1, lix2, iAction, ier, ksubr, knwSav
      integer :: Lung, doRicicla, nExitCode
      real    :: celltemp(13)
!
      ier = 0
      lix1 = 1
      lix2 = 1
      Lab_Ch(1) = 'H'
      Lab_Ch(2) = 'K'
      Lab_Ch(3) = 'L'
      Lab_Ch(4) = 'F'
      Lab_Ch(5) = 'SIGF'
      Lab_Ch(6) = 'PHIC'     ! fase
      Lab_Ch(7) = 'FOM'      ! peso
      Lab_Ch(8) = 'FC'       ! fc
!
      ifMTZlab = 1
      do iAction =1, 2
         call ManageMTZ(iAction, celltemp, lix1, lix2, ier)
         if (ier /= 0) then
             Msg = 'Error reading MTZ file ' 
     *           // MTZfile(1:Lung(MTZfile))
             call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
             doRicicla = 0
             return
         endif
      enddo
!
      iAction = 1
      call AllocaRiflessi(iAction)
      ksubr = 4
      call LeggiRiflessi(ier, ksubr)
!
      knwSav = knw
      knw = 0
      call LeggiMTZPhase(ier)
!
      iAction = 3
      call ManageMTZ(iAction, celltemp, lix1, lix2, ier)     !mr
      knw = knwSav
      call examin(1000, mkang, khl, ipub, iphaz, nrefl, 0, wt, 1)
!
      return
      end
!---------------------------------------------------------------
      subroutine FinalBatchCAB(nBC)
      USE General
      USE Riflessi
      USE PhaseModule
      USE ArpWarp
      USE PhMod
!
      implicit none
      integer :: Lung, nBC
!
      write(6,*) 'FINALBATCHCAB'
      if (PDBcode(1:1) == ' ') then
          Inte = nome(1:lnome)
      else
          Inte = PDBcode
      endif
      write(6,1003) Inte(1:Lung(Inte)), 
     *           nint(tabPrev(1)), nint(tabPrev(2)),
     *           nint(tabPrev(3)*10000.0), nint(tabPrev(4)*100.0), 
     *           nint(tabPrev(5)), nint(tabPrev(6)),
     *           nint(tabPrev(7)), nint(tabPrev(8)),
     *           nint(tabPrev(9)*10000.0), nint(tabPrev(10)*10000.0),
     *           nint(tabPrev(11)),nint(tabPrev(12)),
     *           nint(tabPrev(13)), nint(tabPrev(14)), tabPrev(15), nBC
!
      return
 1003 format('TABIMPM ',a,2(' |',i3),' | ',i4,5(' |',i3),' ',3('|',i4)
     *       3('|',i3,' '),'| ',f6.3,' | ',i1)
      end
!---------------------------------------------------------------
      subroutine RestartBatchCAB(fermati, maxBatchCAB, nBC)
      USE General
      USE Riflessi
      USE PhaseModule
      USE ArpWarp
      USE PhMod
!
      implicit none
      integer :: maxBatchCAB, nBC
      real    :: lim1, lim2, erreE, erreToUse, erreToUsePrev
      logical :: fermati
!
      fermati = .false.
      erreE = tabImpr(14)
      lim1 = 0.34
      lim2 = 0.45
*     lim2 = 0.47   ! TEST 3d2v
      erreToUse = erreE
      erreToUsePrev = erreEprev
      if (knw > 0) then
          write(6,*) 'RESTARTBATCHCAB limits', lim1, lim2
          call examin(3331,mkang,khl,ipub,iphaz,nrefl,0,wt,1)
          write(6,*) 'ERREHA = ', erreHA
          write(6,*) 'ERRECAB = ', erreCAB
          write(6,*) 'RE = ', erreE
      endif
!
      if (BatchCAB == 1) then
          cardImage = nome(1:lnome) // '_nautilus_lab.pdb'
          cardDiret = nome(1:lnome) // '_CAB1.pdb'
          call cCopyFile(cardImage, cardDiret)
          cardImage = nome(1:lnome) // '_nautilus_lab.mtz'
          cardDiret = nome(1:lnome) // '_CAB1.mtz'
          call cCopyFile(cardImage, cardDiret)
      endif
      if (erreE < lim1 .or. erreE > lim2) then
          fermati = .true.
          tabPrev( 1) = MPEvet(1)   ; tabPrev( 2) = tabImpr(1)
          tabPrev( 3) = erreHA      ; tabPrev( 4) = tabImpr(13)
          tabPrev( 5) = MPEvet(2)   ; tabPrev( 6) = tabImpr(4)
          tabPrev( 7) = tabImpr(15) ; tabPrev( 8) = tabImpr(5)
          tabPrev( 9) = erreCAB     ; tabPrev(10) = erreCAB1
          tabPrev(11) = tabImpr(14) ; tabPrev(12) = MPEvet(3)
          tabPrev(13) = tabImpr(8)  ; tabPrev(14) = tabImpr(16)
          tabPrev(15) = tabImpr(12)
          nBC = BatchCAB
          cardImage = nome(1:lnome) // '_nautilus_lab.pdb'
          cardDiret = nome(1:lnome) // '_CAB2.pdb'
          call cCopyFile(cardImage, cardDiret)
          cardImage = nome(1:lnome) // '_nautilus_lab.mtz'
          cardDiret = nome(1:lnome) // '_CAB2.mtz'
          call cCopyFile(cardImage, cardDiret)
      else
          if (erreE > erreEprev) then
              nBC = BatchCAB - 1
              fermati = .true.
              cardImage = nome(1:lnome) // '_nautilus_lab.pdb'
              cardDiret = nome(1:lnome) // '_nautilus_prev.pdb'
              call cCopyFile(cardDiret, cardImage)
              cardImage = nome(1:lnome) // '_nautilus_lab.mtz'
              cardDiret = nome(1:lnome) // '_nautilus_prev.mtz'
              call cCopyFile(cardDiret, cardImage)
              cardImage = nome(1:lnome) // '_nautilus_lab.pdb'
              cardDiret = nome(1:lnome) // '_CAB2.pdb'
              call cCopyFile(cardImage, cardDiret)
              cardImage = nome(1:lnome) // '_nautilus_lab.mtz'
              cardDiret = nome(1:lnome) // '_CAB2.mtz'
              call cCopyFile(cardImage, cardDiret)
          else
              if (BatchCAB == maxBatchCAB) then
                  nBC = BatchCAB
                  fermati = .true.
                  if (nPrevCAB > 0) then
                      cardImage = nome(1:lnome) // '_nautilus_lab.pdb'
                      cardDiret = nome(1:lnome) // '_CAB2.pdb'
                      call cCopyFile(cardImage, cardDiret)
                      cardImage = nome(1:lnome) // '_nautilus_lab.mtz'
                      cardDiret = nome(1:lnome) // '_CAB2.mtz'
                      call cCopyFile(cardImage, cardDiret)
                  else
                      cardImage = nome(1:lnome) // '_improved_HA.pdb'
                      cardDiret = nome(1:lnome) // '_CAB2.pdb'
                      call cCopyFile(cardImage, cardDiret)
                      cardImage = nome(1:lnome) // '_improved_HA.mtz'
                      cardDiret = nome(1:lnome) // '_CAB2.mtz'
                      call cCopyFile(cardImage, cardDiret)
                  endif
              else

                  if (nPrevCAB > 0) then
                      cardImage = nome(1:lnome) // '_nautilus_lab.pdb'
                      cardDiret = nome(1:lnome) // '_nautilus_prev.pdb'
                      call cCopyFile(cardImage, cardDiret)
                      cardImage = nome(1:lnome) // '_nautilus_lab.mtz'
                      cardDiret = nome(1:lnome) // '_nautilus_prev.mtz'
                      call cCopyFile(cardImage, cardDiret)
                  else
                      cardImage = nome(1:lnome) // '_improved_HA.pdb'
                      cardDiret = nome(1:lnome) // '_nautilus_prev.pdb'
                      call cCopyFile(cardImage, cardDiret)
                      cardImage = nome(1:lnome) // '_improved_HA.mtz'
                      cardDiret = nome(1:lnome) // '_nautilus_prev.mtz'
                      call cCopyFile(cardImage, cardDiret)
                  endif
              endif
              tabPrev( 1) = MPEvet(1)   ; tabPrev( 2) = tabImpr(1)
              tabPrev( 3) = erreHA      ; tabPrev( 4) = tabImpr(13)
              tabPrev( 5) = MPEvet(2)   ; tabPrev( 6) = tabImpr(4)
              tabPrev( 7) = tabImpr(15) ; tabPrev( 8) = tabImpr(5)
              tabPrev( 9) = erreCAB     ; tabPrev(10) = erreCAB1
              tabPrev(11) = tabImpr(14) ; tabPrev(12) = MPEvet(3)
              tabPrev(13) = tabImpr(8)  ; tabPrev(14) = tabImpr(16)
              tabPrev(15) = tabImpr(12)
          endif
      endif
*     fermati = .false.
!
      if (fermati) then
          if (BatchCAB > 1 .and. BatchCAB /= maxBatchCAB) then
              cardImage = nome(1:lnome) // '_nautilus_lab.pdb'
              cardDiret = nome(1:lnome) // '_nautilus_prev.pdb'
              call cCopyFile(cardDiret, cardImage)
              cardImage = nome(1:lnome) // '_nautilus_lab.mtz'
              cardDiret = nome(1:lnome) // '_nautilus_prev.mtz'
              call cCopyFile(cardDiret, cardImage)
          endif
*         if (BatchCAB > 1) then
*             cardImage = nome(1:lnome) // '_nautilus_prev.pdb'
*             cardDiret = nome(1:lnome) // '_CAB2.pdb'
*             call cCopyFile(cardImage, cardDiret)
*             cardImage = nome(1:lnome) // '_nautilus_prev.mtz'
*             cardDiret = nome(1:lnome) // '_CAB2.mtz'
*             call cCopyFile(cardImage, cardDiret)
*         endif
      endif
      if (.not. fermati. or. BatchCAB == maxBatchCAB) then
          ifRemo = 1
          jumpVLD = 0
          statoMR = -1
          tabPrev( 1) = MPEvet(1)   ; tabPrev( 2) = tabImpr(1)
          tabPrev( 3) = erreHA      ; tabPrev( 4) = tabImpr(13)
          tabPrev( 5) = MPEvet(2)   ; tabPrev( 6) = tabImpr(4)
          tabPrev( 7) = tabImpr(15) ; tabPrev( 8) = tabImpr(5)
          tabPrev( 9) = erreCAB     ; tabPrev(10) = erreCAB1
          tabPrev(11) = tabImpr(14) ; tabPrev(12) = MPEvet(3)
          tabPrev(13) = tabImpr(8)  ; tabPrev(14) = tabImpr(16)
          tabPrev(15) = tabImpr(12)
          erreCABprev = erreCAB
          erreHAprev  = erreHA
          erreEprev   = tabImpr(14)
      endif
!
      return
      end
